;;; disk-resident

;;; Claws-II open class tag lexicon for full N-ANLT grammar
;;; Eirik Hektoen 1998

;;; Includes only open class and number tags, on assumption that closed class
;;; words and punctuation are defined in a regular lexicon.

;;; The predicate -lemma- in semantic forms should be substituted by the
;;; relevant lemma or other suitable lexical predicate.

;;; STILL TO DO ???:
;;;  - For _ND1 etc, any feature for 'noun of direction'? Adv+?
;;;  - For _RA, based on ANLT 'else', check also 'ago' (see sus-tags)
;;;  - For _RGA, based on ANLT 'enough', check also 'indeed'
;;;  - Also include?  &FO &FW NN1$

;;; MO all lexica files have been concatenated together.


WORD _JA : ; predic adj 'afraid', 'tantamount' (selection of subcats)

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SFIN, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SINF, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT VPINF, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE READY, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT PP, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-.

WORD _JB : ; attrib adj 'main', 'chief'

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      DISTR ATT, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-.

WORD _JBR : ; attrib adj compar 'upper'

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, er, DISTR ATT,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-.

WORD _JBT : ; attrib adj super 'utmost'

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, est, DISTR ATT,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-.

WORD _JJ : ; general adj (selection of subcats)

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SFIN, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SINF, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT VPINF, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE READY, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT PP, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      DISTR ATT, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-.

WORD _JJR : ; general adj compar (selection of subcats)

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, er, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SFIN, CONJ NULL, PART -, er, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SINF, CONJ NULL, PART -, er, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT VPINF, CONJ NULL, PART -, er, DISTR PRD,
      SUBTYPE READY, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT PP, CONJ NULL, PART -, er, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, er, DISTR ATT,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-.

WORD _JJT : ; general adj super (selection of subcats)

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, est, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SFIN, CONJ NULL, PART -, est, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SINF, CONJ NULL, PART -, est, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT VPINF, CONJ NULL, PART -, est, DISTR PRD,
      SUBTYPE READY, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT PP, CONJ NULL, PART -, est, DISTR PRD,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-,
   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, est, DISTR ATT,
      SUBTYPE NONE, AGR N2[NFORM NORM], GRADE +] : -lemma-.

WORD _JK : ; adj catenative (?) 'able' (in 'be able to')

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SC_INF, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE RAIS] : -lemma-.

WORD _MC : ; cardinal number 'two', 'three', '123'

   [CN1 @x, CN2 SMALL, CN4 +] : -lemma-.

WORD _MC1 : ; cardinal number sg 'one'

   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, SUBCAT NULL, CONJ NULL, NFORM
         NORM, PER 3, PN -, PROTYPE NONE, PART -, AFORM NONE, WH NO, UB NO,
      EVER NO, REFL -, DEMON -] : (pro (the (x) (and (sg x) (human x)))),
   [CN3 ONE] : |1|.

WORD _MC2 : ; cardinal number pl '1990s'

   [CN1 @x, CN2 BIG, AND -, CN4 -] : -lemma-.

WORD _MD : ; ordinal number 'first', 'last', 'next'

   DetA[ORD, AFORM NONE, WH NO, UB NO, EVER NO] : -lemma-,
   A[-ADV, -NEG, -QUA, ORD, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      DISTR ATT, SUBTYPE NONE, AGR N2[NFORM NORM], GRADE -] : -lemma-,
   DetN[-POSS, +DEF, WH NO, UB NO, EVER NO, AGR N2[-PLU, +COUNT, QFEAT -],
      DEMON -] :
   (lambda (P) (dd (the (x) (and (sg x) (-lemma- x) (P x))))),
   [PLU @x, FRACT @y] : -lemma-.

WORD _MF : ; fraction 'quarter'

   [PLU @x, FRACT @y] : -lemma-.

WORD _NN1 : ; noun sg 'abbot'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NC2 : ; cited word pl (as noun) 'ifs', 'buts'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-.

WORD _ND1 : ; noun of direction sg 'north'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NN : ; noun (sg or pl) 'deer'

   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM, PER 3,
      PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL, NFORM
         NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NN2 : ; noun pl 'abbots'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-.

WORD _NNJ : ; organisational noun (sg or pl) 'council'

   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM, PER 3,
      PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL, NFORM
         NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NNJ1 : ; organisational noun sg 'commonwealth'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NNJ2 : ; organisational noun pl 'committees'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-.

WORD _NNL : ; locative noun (sg or pl) 'st.'

   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM, PER 3,
      PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL, NFORM
         NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NNL1 : ; locative noun sg 'street'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NNL2 : ; locative noun pl 'streets'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-.

WORD _NNO : ; numeric noun (sg or pl) 'thousand', 'dozen'
   [CN1 @x, CN2 BIG, AND -, CN4 -] : -lemma-.

WORD _NNO1 : ; numeric noun sg
   [CN1 @x, CN2 BIG, AND -, CN4 -] : -lemma-.

WORD _NNO2 : ; numeric noun pl 'thousands', 'dozens'
   [CN1 @x, CN2 BIG, AND -, CN4 -] : -lemma-.

WORD _NNS : ; noun of style (sg or pl)

   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM, PER 3,
      PN -, PROTYPE NONE, PART -, DEMON -, ADDRESS +] : -lemma-.

WORD _NNS1 : ; noun of style sg 'Mayor'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -, ADDRESS +] : -lemma-.

WORD _NNS2 : ; noun of style pl 'Chiefs'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, ADDRESS +] : -lemma-.

WORD _NNSA1 : ; following noun of style sg 'Jr.'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -, ADDRESS +] : -lemma-.

WORD _NNSA2 : ; following noun of style pl

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, ADDRESS +] : -lemma-.

WORD _NNSB : ; preceding noun of style (sg or pl) 'Rt.Hon.'

   N[-POSS, -ADV, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM, PER 3,
      PN -, PROTYPE NONE, PART -, DEMON -, ADDRESS +] : -lemma-.

WORD _NNSB1 : ; preceding noun of style sg 'Prof.'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -, ADDRESS +] : -lemma-.

WORD _NNSB2 : ; preceding noun of style pl 'Reps.'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, ADDRESS +] : -lemma-.

WORD _NNT : ; temporal noun (sg or pl)

   N[-POSS, -ADV, -PRO, -NUM, SUBCAT NULL, CONJ NULL, NFORM NORM, PER
         3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, +ADV, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, +ADV, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, +ADV, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL, NFORM
         NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NNT1 : ; temporal noun sg 'day'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, SUBCAT NULL, CONJ NULL, NFORM
      NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, +ADV, -PLU, -PRO, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, +ADV, -PLU, -PRO, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-,
   N[-POSS, +ADV, -PLU, -PRO, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -, DEMON -] : -lemma-.

WORD _NNT2 : ; temporal noun pl 'days'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT NULL, CONJ NULL, NFORM
      NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, +ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, +ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, +ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-.

WORD _NNU : ; unit of measurement (sg or pl) 'kg'

   N[-POSS, -ADV, -PRO, +COUNT, -NUM, SUBCAT NULL, CONJ NULL, NFORM NORM, PER
         3, PN -, PROTYPE NONE, DEMON -, PART NO_OF] : -lemma-,
   N[-POSS, -ADV, -PRO, +COUNT, -NUM, SUBCAT NULL, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, DEMON -, PART OF] : -lemma-,
   N[-POSS, -ADV, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, DEMON -, PART -] : -lemma-,
   N[-POSS, -ADV, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, DEMON -, PART -] : -lemma-,
   N[-POSS, -ADV, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL, NFORM
         NORM, PER 3, PN -, PROTYPE NONE, DEMON -, PART -] : -lemma-.

WORD _NNU1 : ; unit of measurement sg 'gram'

   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, SUBCAT NULL, CONJ NULL, NFORM
      NORM, PER 3, PN -, PROTYPE NONE, DEMON -, PART NO_OF] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, DEMON -, PART OF] :
   -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, DEMON -, PART -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, DEMON -, PART -] : -lemma-,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, DEMON -, PART -] : -lemma-.

WORD _NNU2 : ; unit of measurement pl 'grams'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT NULL, CONJ NULL, NFORM
      NORM, PER 3, PN -, PROTYPE NONE, PART NO_OF] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART OF] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PRT @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-,
   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, SUBCAT @x, PFORM @y, CONJ NULL,
      NFORM NORM, PER 3, PN -, PROTYPE NONE, PART -] : -lemma-.

WORD _NP : ; proper noun (sg or pl)

   N[-POSS, -ADV, -PRO, -NUM, +PN, SUBCAT NULL, CONJ NULL, NFORM NORM,
      PER 3, PROTYPE NONE, PART -, ADDRESS -, DEMON -] :
   (name (the (x) (and (sg x) (named x -lemma-) (animate x)))).

WORD _NP1 : ; proper noun sg 'Kim'

   N[-POSS, -ADV, -PLU, -PRO, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -, DEMON -] :
   (name (the (x) (and (sg x) (named x -lemma-) (animate x)))).

WORD _NP2 : ; proper noun pl 'Americas'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -] :
   (name (the (x) (and (sg x) (named x -lemma-) (animate x)))).

WORD _NPD1 : ; weekday noun sg 'Sunday'

   N[-POSS, +ADV, -PLU, -PRO, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -, DEMON -] :
   -lemma-.

WORD _NPD2 : ; weekday noun pl 'Sundays'

   N[-POSS, +ADV, +PLU, -PRO, +COUNT, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -] : -lemma-.

WORD _NPM1 : ; month noun sg 'October'

   N[-POSS, +ADV, -PLU, -PRO, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -, DEMON -] :
   -lemma-.

WORD _NPM2 : ; month noun pl 'Octobers'

   N[-POSS, +ADV, +PLU, -PRO, +COUNT, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -] : -lemma-.

WORD _RA : ; adv after nominal head 'else' (in 'anyone else'), 'ago'

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE NONE, AGR N2[NFORM NORM], COADV -, GRADE -] :
   -lemma-.

WORD _RGA : ; post-nom/adj/adv degree word 'indeed', 'enough'

   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -,
      AFORM NONE, DISTR ATT, SUBTYPE NONE, AGR N2[+PLU, +COUNT, QFEAT -],
      GRADE -] :
   (lambda (Q) (Q -lemma- (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -,
      AFORM NONE, DISTR ATT, SUBTYPE NONE, AGR N2[-PLU, -COUNT, QFEAT -],
      GRADE -] :
   (lambda (Q) (Q -lemma- (lambda (x) (lambda (P) (and (ms x) (P x)))))).

WORD _RL : ; locative adv 'forward', 'alongside'

   A[+ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      SUBTYPE NONE, AGR N2[NFORM NORM]] : -lemma-.

WORD _RR : ; adv 'eagerly'

   A[+ADV, -NEG, -QUA, -NUM, SUBCAT NULL, CONJ NULL, PART -, AFORM NONE,
      SUBTYPE NONE, AGR N2[NFORM NORM]] : -lemma-.

WORD _RRR : ; compar adv 'longer'

   A[+ADV, -NEG, -QUA, -NUM, er, SUBCAT NULL, CONJ NULL, PART -, SUBTYPE NONE,
      AGR N2[NFORM NORM]] : -lemma-.

WORD _RRT : ; super adv 'longest'

   A[+ADV, -NEG, -QUA, -NUM, est, SUBCAT NULL, CONJ NULL, PART -, SUBTYPE
      NONE, AGR N2[NFORM NORM]] : -lemma-.

WORD _RT : ; time noun 'now', 'tomorrow'

   N[+PRD, -POSS, -ADV, +DEF, +PRO, -NUM, SUBCAT NULL, CONJ NULL, NFORM NORM,
      PER 3, PN -, PROTYPE PMOD, PART -, AFORM NONE, WH NO, UB NO, EVER NO,
      REFL -, DEMON +] :
   (lambda (Q) (Q dd the (lambda (x) (and (sg x) (-lemma- x) (time x)))
            AT)).

WORD _VV0 : ; verb base form (incl imp, non-s pres) 'give', 'work'

   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PSVE -,
      AGR N2[NFORM NORM]] : -lemma-,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[+NOM, NFORM NORM]] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, +PLU, NFORM NORM]] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 1]] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 2]] : -lemma-,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PSVE -,
      AGR N2[NFORM NORM], PRT @x] : -lemma-,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[+NOM, NFORM NORM], PRT @x] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, +PLU, NFORM NORM], PRT @x] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 1], PRT @x] :
   -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 2], PRT @x] :
   -lemma-,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PSVE -,
      AGR N2[NFORM NORM], PFORM @y] : -lemma-,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[+NOM, NFORM NORM], PFORM @y] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, +PLU, NFORM NORM], PFORM @y] :
   -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 1], PFORM @y] :
   -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 2], PFORM @y] :
   -lemma-,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PSVE -,
      AGR N2[NFORM NORM], PRT @x, PFORM @y] : -lemma-,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[+NOM, NFORM NORM], PRT @x, PFORM @y] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, +PLU, NFORM NORM], PRT @x, PFORM @y] :
   -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 1], PRT @x,
      PFORM @y] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 2], PRT @x,
      PFORM @y] : -lemma-.

WORD _VVD : ; verb past tense 'gave', 'worked'

   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST +, PSVE -, AGR N2[NFORM NORM]] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST +, PSVE -, AGR N2[NFORM NORM], PRT @x] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST +, PSVE -, AGR N2[NFORM NORM], PFORM @y] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST +, PSVE -, AGR N2[NFORM NORM], PRT @x, PFORM @y] : -lemma-.

WORD _VVG : ; 'helping'

   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT, PSVE
      -, AGR N2[NFORM NORM]] : -lemma-,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[NFORM NORM], PRT @x] : -lemma-,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[NFORM NORM], PFORM @y] : -lemma-,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[NFORM NORM], PRT @x, PFORM @y] : -lemma-.

WORD _VVN : ; verb past participle 'given', 'worked'

   V[PSP, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT, PSVE
      -, AGR N2[NFORM NORM]] : -lemma-,
   V[PAS, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE +, AGR N2[NFORM NORM]] : -lemma-,
   V[PSP, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[NFORM NORM], PRT @x] : -lemma-,
   V[PAS, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE +, AGR N2[NFORM NORM], PRT @x] : -lemma-,
   V[PSP, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[NFORM NORM], PFORM @y] : -lemma-,
   V[PAS, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE +, AGR N2[NFORM NORM], PFORM @y] : -lemma-,
   V[PSP, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE -, AGR N2[NFORM NORM], PRT @x, PFORM @y] : -lemma-,
   V[PAS, -INV, -NEG, -FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, PAST NOT,
      PSVE +, AGR N2[NFORM NORM], PRT @x, PFORM @y] : -lemma-.

WORD _VVZ : ; verb s-form 'helps'

   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 3]] : -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 3], PRT @x] :
   -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 3], PFORM @y] :
   -lemma-,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, SUBCAT @s, CONJ NULL, VFORM NOT,
      PAST -, PSVE -, AGR N2[+NOM, -PLU, NFORM NORM, PER 3], PRT @x,
      PFORM @y] : -lemma-.

WORD _VVGK : ; adj (ing-form catenative) 'going'

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SC_INF, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE RAIS, GRADE -] : GOING.

WORD _VVNK : ; adj (past participle catenative) 'bound'

   A[-ADV, -NEG, -QUA, -NUM, SUBCAT SC_INF, CONJ NULL, PART -, AFORM NONE,
      DISTR PRD, SUBTYPE RAIS, GRADE -] : BOUND.

WORD _ZZ1 : ; letter sg 'B'

   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -, DEMON -] :
   -lemma-.

WORD _ZZ2 : ; letter pl 'Bs'

   N[-POSS, -ADV, +PLU, -PRO, +COUNT, -NUM, +PN, SUBCAT NULL, CONJ NULL,
      NFORM NORM, PER 3, PROTYPE NONE, PART -, ADDRESS -, DEMON -] :
   -lemma-.
;;; OPEN WORDS LEXICON /homes/eh101/big/lex-open
;;; generated by open-lex.cl from:
;;;   /usr/groups/nltools/dict/adj.le
;;;   /usr/groups/nltools/dict/adv.le
;;;   /usr/groups/nltools/dict/n.le
;;;   /usr/groups/nltools/dict/v.le

WORD abandon : 
   [COORD @D56, AGR [COUNT @D55, PER @D54, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ABANDON, 
   [COORD @D58, AGR [COUNT @D57, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ABANDON, 
   [COORD @D60, AGR [COUNT @D59, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ABANDON, 
   [COORD @D64, AGR [COUNT @D63, PER @D62, PLU @D61, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ABANDON, 
   [COORD @D70, PAST @D69, AGR [CASE @D68, COUNT @D67, PER @D66, 
            PLU @D65, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, LAT -, ARITY 3] : ABANDON, 
   [COORD @D73, AGR [COUNT @D72, PER @D71, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABANDON, 
   [COORD @D75, 
      AGR [COUNT @D74, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, PLU -], 
      VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, SUBTYPE NONE, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABANDON, 
   [COORD @D77, AGR [COUNT @D76, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABANDON, 
   [COORD @D81, 
      AGR [COUNT @D80, PER @D79, PLU @D78, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABANDON, 
   [COORD @D87, PAST @D86, 
      AGR [CASE @D85, COUNT @D84, PER @D83, PLU @D82, BAR 2, V -, N +, 
            NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABANDON.

WORD abandoned : 
   [COADV @D99, COORD @D98, DEF @D97, PRD @D96, AGR [CASE @D95, 
            COUNT @D94, PER @D93, PLU @D92, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, N +, GRADE +, ADV -, 
      AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : ABANDONED, 
   [COORD @D104, AGR [CASE @D103, COUNT @D102, PER @D101, PLU @D100, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ABANDON, 
   [COORD @D109, AGR [CASE @D108, COUNT @D107, PER @D106, PLU @D105, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ABANDON, 
   [COORD @D114, AGR [CASE @D113, COUNT @D112, PER @D111, PLU @D110, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ABANDON, 
   [COORD @D119, AGR [CASE @D118, COUNT @D117, PER @D116, PLU @D115, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ABANDON, 
   
   [COORD @D124, AGR [CASE @D123, COUNT @D122, PER @D121, PLU @D120, BAR 
               2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ABANDON, 
   [COORD @D129, AGR [CASE @D128, COUNT @D127, PER @D126, PLU @D125, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ABANDON.

WORD abandoning : 
   [COORD @D141, PRD @D140, AGR [CASE @D139, COUNT @D138, PER @D137, 
            PLU @D136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ABANDON, 
   [COORD @D147, PRD @D146, AGR [CASE @D145, COUNT @D144, PER @D143, 
            PLU @D142, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ABANDON.

WORD abandons : 
   [COORD @D153, AGR [COUNT @D152, NFORM NORM, PLU -, PER 3, CASE NOM, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ABANDON, 
   [COORD @D155, 
      AGR [COUNT @D154, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ABANDON.

WORD abuse : 
   [COORD @D165, REFL @D164, COUNT @D163, PRD @D162, CASE @D161, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ABUSE, 
   [COORD @D168, 
      AGR [COUNT @D167, PER @D166, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABUSE, 
   [COORD @D170, 
      AGR [COUNT @D169, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABUSE, 
   [COORD @D172, 
      AGR [COUNT @D171, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABUSE, 
   [COORD @D176, 
      AGR [COUNT @D175, PER @D174, PLU @D173, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABUSE, 
   [COORD @D182, PAST @D181, 
      AGR [CASE @D180, COUNT @D179, PER @D178, PLU @D177, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ABUSE.

WORD abused : 
   [COORD @D194, AGR [CASE @D193, COUNT @D192, PER @D191, PLU @D190, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ABUSE, 
   [COORD @D199, 
      AGR [CASE @D198, COUNT @D197, PER @D196, PLU @D195, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ABUSE, 
   [COORD @D204, 
      AGR [CASE @D203, COUNT @D202, PER @D201, PLU @D200, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ABUSE.

WORD abuses : 
   [COORD @D216, DEMON @D215, REFL @D214, PRD @D213, CASE @D212, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ABUSE, 
   [COORD @D218, 
      AGR [COUNT @D217, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ABUSE.

WORD abusing : 
   [COORD @D229, PRD @D228, AGR [CASE @D227, COUNT @D226, PER @D225, 
            PLU @D224, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ABUSE.

WORD accept : 
   [COORD @D235, AGR [COUNT @D234, PER @D233, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D237, 
      AGR [COUNT @D236, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D239, 
      AGR [COUNT @D238, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D243, 
      AGR [COUNT @D242, PER @D241, PLU @D240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D249, PAST @D248, 
      AGR [CASE @D247, COUNT @D246, PER @D245, PLU @D244, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D252, 
      AGR [COUNT @D251, PER @D250, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D254, 
      AGR [COUNT @D253, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D256, 
      AGR [COUNT @D255, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D260, 
      AGR [COUNT @D259, PER @D258, PLU @D257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D266, PAST @D265, 
      AGR [CASE @D264, COUNT @D263, PER @D262, PLU @D261, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCEPT, 
   [COORD @D269, 
      AGR [COUNT @D268, PER @D267, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ACCEPT, 
   [COORD @D271, 
      AGR [COUNT @D270, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ACCEPT, 
   [COORD @D273, 
      AGR [COUNT @D272, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ACCEPT, 
   [COORD @D277, 
      AGR [COUNT @D276, PER @D275, PLU @D274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ACCEPT, 
   [COORD @D283, PAST @D282, 
      AGR [CASE @D281, COUNT @D280, PER @D279, PLU @D278, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ACCEPT.

WORD accepted : 
   [COORD @D292, AGR [CASE @D291, COUNT @D290, PER @D289, PLU @D288, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCEPT, 
   [COORD @D297, AGR [CASE @D296, COUNT @D295, PER @D294, PLU @D293, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ACCEPT, 
   [COORD @D302, AGR [UB @D301, VFORM @D300, SUBJ @D299, FIN @D298, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, SUBCAT SFIN, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCEPT, 
   [COORD @D307, 
      AGR [CASE @D306, COUNT @D305, PER @D304, PLU @D303, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCEPT, 
   [COORD @D312, 
      AGR [CASE @D311, COUNT @D310, PER @D309, PLU @D308, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ACCEPT, 
   [COORD @D317, 
      AGR [CASE @D316, COUNT @D315, PER @D314, PLU @D313, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCEPT, 
   [COORD @D322, 
      AGR [CASE @D321, COUNT @D320, PER @D319, PLU @D318, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCEPT, 
   [COORD @D327, 
      AGR [CASE @D326, COUNT @D325, PER @D324, PLU @D323, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ACCEPT.

WORD accepting : 
   [COORD @D339, PRD @D338, AGR [CASE @D337, COUNT @D336, PER @D335, 
            PLU @D334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACCEPT, 
   [COORD @D345, PRD @D344, AGR [CASE @D343, COUNT @D342, PER @D341, 
            PLU @D340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACCEPT, 
   [COORD @D351, PRD @D350, AGR [CASE @D349, COUNT @D348, PER @D347, 
            PLU @D346, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACCEPT.

WORD accepts : 
   [COORD @D357, AGR [COUNT @D356, NFORM NORM, PLU -, PER 3, CASE NOM, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCEPT, 
   [COORD @D359, 
      AGR [COUNT @D358, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCEPT, 
   [COORD @D361, 
      AGR [COUNT @D360, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCEPT.

WORD access : 
   [COORD @D369, REFL @D368, COUNT @D367, PRD @D366, CASE @D365, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ACCESS.

WORD accesses : 
   [COORD @D378, DEMON @D377, REFL @D376, PRD @D375, CASE @D374, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ACCESS.

WORD account : 
   [COORD @D386, REFL @D385, COUNT @D384, PRD @D383, CASE @D382, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ACCOUNT, 
   [COORD @D389, 
      AGR [COUNT @D388, PER @D387, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, 
      ARITY 3] : ACCOUNT, 
   [COORD @D391, AGR [COUNT @D390, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_TO, ARITY 3] : ACCOUNT, 
   [COORD @D393, AGR [COUNT @D392, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_TO, ARITY 3] : ACCOUNT, 
   [COORD @D397, AGR [COUNT @D396, PER @D395, PLU @D394, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM FOR_TO, ARITY 3] : ACCOUNT, 
   [COORD @D403, PAST @D402, 
      AGR [CASE @D401, COUNT @D400, PER @D399, PLU @D398, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, 
      ARITY 3] : ACCOUNT, 
   [COORD @D406, AGR [COUNT @D405, PER @D404, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      ARITY 2] : ACCOUNT, 
   [COORD @D408, AGR [COUNT @D407, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      ARITY 2] : ACCOUNT, 
   [COORD @D410, AGR [COUNT @D409, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      ARITY 2] : ACCOUNT, 
   [COORD @D414, AGR [COUNT @D413, PER @D412, PLU @D411, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : ACCOUNT, 
   [COORD @D420, PAST @D419, AGR [CASE @D418, COUNT @D417, PER @D416, 
            PLU @D415, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : ACCOUNT, 
   [COORD @D423, AGR [COUNT @D422, PER @D421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      ARITY 2] : ACCOUNT, 
   [COORD @D425, AGR [COUNT @D424, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      ARITY 2] : ACCOUNT, 
   [COORD @D427, AGR [COUNT @D426, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      ARITY 2] : ACCOUNT, 
   [COORD @D431, AGR [COUNT @D430, PER @D429, PLU @D428, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : ACCOUNT, 
   [COORD @D437, PAST @D436, AGR [CASE @D435, COUNT @D434, PER @D433, 
            PLU @D432, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : ACCOUNT, 
   [COORD @D440, AGR [COUNT @D439, PER @D438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, PREP FOR, 
      ARITY 2] : ACCOUNT, 
   [COORD @D442, AGR [COUNT @D441, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, PREP FOR, 
      ARITY 2] : ACCOUNT, 
   [COORD @D444, AGR [COUNT @D443, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, PREP FOR, 
      ARITY 2] : ACCOUNT, 
   [COORD @D448, AGR [COUNT @D447, PER @D446, PLU @D445, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP FOR, ARITY 2] : ACCOUNT, 
   [COORD @D454, PAST @D453, AGR [CASE @D452, COUNT @D451, PER @D450, 
            PLU @D449, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, PREP FOR, ARITY 2] : ACCOUNT, 
   [COORD @D457, AGR [COUNT @D456, PER @D455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ACCOUNT, 
   [COORD @D459, AGR [COUNT @D458, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ACCOUNT, 
   [COORD @D461, AGR [COUNT @D460, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ACCOUNT, 
   [COORD @D465, AGR [COUNT @D464, PER @D463, PLU @D462, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ACCOUNT, 
   [COORD @D471, PAST @D470, AGR [CASE @D469, COUNT @D468, PER @D467, 
            PLU @D466, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : ACCOUNT, 
   [COORD @D474, AGR [COUNT @D473, PER @D472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, ARITY 2] : ACCOUNT, 
   [COORD @D476, 
      AGR [COUNT @D475, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, 
      PFORM FOR, ORDER PRENP, ARITY 2] : ACCOUNT, 
   [COORD @D478, AGR [COUNT @D477, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, ARITY 2] : ACCOUNT, 
   [COORD @D482, 
      AGR [COUNT @D481, PER @D480, PLU @D479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, 
      PFORM FOR, ORDER PRENP, ARITY 2] : ACCOUNT, 
   [COORD @D488, PAST @D487, 
      AGR [CASE @D486, COUNT @D485, PER @D484, PLU @D483, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, 
      ORDER PRENP, ARITY 2] : ACCOUNT.

WORD accounted : 
   [COORD @D498, AGR [CASE @D497, COUNT @D496, PER @D495, PLU @D494, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D503, AGR [CASE @D502, COUNT @D501, PER @D500, PLU @D499, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D508, AGR [CASE @D507, COUNT @D506, PER @D505, PLU @D504, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACCOUNT, 
   [COORD @D513, AGR [CASE @D512, COUNT @D511, PER @D510, PLU @D509, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACCOUNT, 
   [COORD @D518, AGR [CASE @D517, COUNT @D516, PER @D515, PLU @D514, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ACCOUNT, 
   [COORD @D523, AGR [CASE @D522, COUNT @D521, PER @D520, PLU @D519, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACCOUNT, 
   [COORD @D528, AGR [CASE @D527, COUNT @D526, PER @D525, PLU @D524, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ACCOUNT, 
   [COORD @D534, AGR [CASE @D533, NFORM @D532, COUNT @D531, PER @D530, 
            PLU @D529, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACCOUNT, 
   [COORD @D539, AGR [UB @D538, VFORM @D537, SUBJ @D536, FIN @D535, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D544, 
      AGR [CASE @D543, COUNT @D542, PER @D541, PLU @D540, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACCOUNT, 
   [COORD @D549, AGR [CASE @D548, COUNT @D547, PER @D546, PLU @D545, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D554, AGR [CASE @D553, COUNT @D552, PER @D551, PLU @D550, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D559, AGR [CASE @D558, COUNT @D557, PER @D556, PLU @D555, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D564, AGR [CASE @D563, COUNT @D562, PER @D561, PLU @D560, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D569, AGR [CASE @D568, COUNT @D567, PER @D566, PLU @D565, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OR, PFORM FOR, ORDER PRENP, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D574, AGR [CASE @D573, COUNT @D572, PER @D571, PLU @D570, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D579, AGR [CASE @D578, COUNT @D577, PER @D576, PLU @D575, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ACCOUNT.

WORD accounting : 
   [COORD @D594, PRD @D593, AGR [CASE @D592, COUNT @D591, PER @D590, 
            PLU @D589, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D600, PRD @D599, AGR [CASE @D598, COUNT @D597, PER @D596, 
            PLU @D595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACCOUNT, 
   [COORD @D606, PRD @D605, AGR [CASE @D604, COUNT @D603, PER @D602, 
            PLU @D601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACCOUNT, 
   [COORD @D612, PRD @D611, AGR [CASE @D610, COUNT @D609, PER @D608, 
            PLU @D607, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D618, PRD @D617, AGR [CASE @D616, COUNT @D615, PER @D614, 
            PLU @D613, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D624, PRD @D623, AGR [CASE @D622, COUNT @D621, PER @D620, 
            PLU @D619, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCOUNT.

WORD accounts : 
   [COORD @D634, DEMON @D633, REFL @D632, PRD @D631, CASE @D630, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ACCOUNT, 
   [COORD @D636, 
      AGR [COUNT @D635, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM FOR_TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ACCOUNT, 
   [COORD @D638, AGR [COUNT @D637, NFORM NORM, PLU -, PER 3, CASE NOM, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D640, 
      AGR [COUNT @D639, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D642, 
      AGR [COUNT @D641, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D644, 
      AGR [COUNT @D643, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCOUNT, 
   [COORD @D646, 
      AGR [COUNT @D645, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : ACCOUNT.

WORD accuse : 
   [COORD @D653, AGR [COUNT @D652, PER @D651, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, LAT -, 
      ARITY 3] : ACCUSE, 
   [COORD @D655, AGR [COUNT @D654, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, LAT -, 
      ARITY 3] : ACCUSE, 
   [COORD @D657, AGR [COUNT @D656, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, LAT -, 
      ARITY 3] : ACCUSE, 
   [COORD @D661, AGR [COUNT @D660, PER @D659, PLU @D658, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, 
      LAT -, ARITY 3] : ACCUSE, 
   [COORD @D667, PAST @D666, AGR [CASE @D665, COUNT @D664, PER @D663, 
            PLU @D662, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OF, LAT -, ARITY 3] : ACCUSE, 
   [COORD @D670, AGR [COUNT @D669, PER @D668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCUSE, 
   [COORD @D672, 
      AGR [COUNT @D671, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCUSE, 
   [COORD @D674, 
      AGR [COUNT @D673, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCUSE, 
   [COORD @D678, 
      AGR [COUNT @D677, PER @D676, PLU @D675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCUSE, 
   [COORD @D684, PAST @D683, 
      AGR [CASE @D682, COUNT @D681, PER @D680, PLU @D679, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACCUSE.

WORD accused : 
   [COADV @D697, COORD @D696, DEF @D695, PRD @D694, AGR [CASE @D693, 
            COUNT @D692, PER @D691, PLU @D690, BAR 2, V -, N +, 
            NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, N +, 
      COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   ACCUSED, 
   [COORD @D702, AGR [CASE @D701, COUNT @D700, PER @D699, PLU @D698, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OF, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCUSE, 
   [COORD @D707, AGR [CASE @D706, COUNT @D705, PER @D704, PLU @D703, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACCUSE, 
   [COORD @D712, AGR [CASE @D711, COUNT @D710, PER @D709, PLU @D708, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACCUSE, 
   [COORD @D717, AGR [CASE @D716, COUNT @D715, PER @D714, PLU @D713, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCUSE, 
   [COORD @D722, 
      AGR [CASE @D721, COUNT @D720, PER @D719, PLU @D718, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACCUSE, 
   [COORD @D727, 
      AGR [CASE @D726, COUNT @D725, PER @D724, PLU @D723, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ACCUSE.

WORD accuses : 
   [COORD @D734, AGR [COUNT @D733, NFORM NORM, PLU -, PER 3, CASE NOM, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCUSE, 
   [COORD @D736, 
      AGR [COUNT @D735, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACCUSE.

WORD accusing : 
   [COORD @D746, PRD @D745, AGR [CASE @D744, COUNT @D743, PER @D742, 
            PLU @D741, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACCUSE, 
   [COORD @D752, PRD @D751, AGR [CASE @D750, COUNT @D749, PER @D748, 
            PLU @D747, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACCUSE.

WORD achieve : 
   [COORD @D759, AGR [COUNT @D758, PER @D757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACHIEVE, 
   [COORD @D761, 
      AGR [COUNT @D760, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACHIEVE, 
   [COORD @D763, 
      AGR [COUNT @D762, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACHIEVE, 
   [COORD @D767, 
      AGR [COUNT @D766, PER @D765, PLU @D764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACHIEVE, 
   [COORD @D773, PAST @D772, 
      AGR [CASE @D771, COUNT @D770, PER @D769, PLU @D768, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACHIEVE.

WORD achieved : 
   [COORD @D783, AGR [CASE @D782, COUNT @D781, PER @D780, PLU @D779, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACHIEVE, 
   
   [COORD @D788, AGR [CASE @D787, COUNT @D786, PER @D785, PLU @D784, BAR 
               2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACHIEVE, 
   [COORD @D793, AGR [CASE @D792, COUNT @D791, PER @D790, PLU @D789, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ACHIEVE.

WORD achieves : 
   [COORD @D800, AGR [COUNT @D799, NFORM NORM, PLU -, PER 3, CASE NOM, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACHIEVE.

WORD achieving : 
   [COORD @D810, PRD @D809, AGR [CASE @D808, COUNT @D807, PER @D806, 
            PLU @D805, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACHIEVE.

WORD act : 
   [COORD @D817, REFL @D816, PRD @D815, CASE @D814, FIX NOT, BAR 0, 
      SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, COUNT +] : ACT, 
   [COORD @D820, AGR [COUNT @D819, PER @D818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : ACT, 
   [COORD @D822, AGR [COUNT @D821, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : ACT, 
   [COORD @D824, AGR [COUNT @D823, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : ACT, 
   [COORD @D828, AGR [COUNT @D827, PER @D826, PLU @D825, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : ACT, 
   [COORD @D834, PAST @D833, AGR [CASE @D832, COUNT @D831, PER @D830, 
            PLU @D829, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : ACT, 
   [COORD @D837, AGR [COUNT @D836, PER @D835, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AS, 
      ARITY 2] : ACT, 
   [COORD @D839, AGR [COUNT @D838, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AS, 
      ARITY 2] : ACT, 
   [COORD @D841, AGR [COUNT @D840, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AS, 
      ARITY 2] : ACT, 
   [COORD @D845, AGR [COUNT @D844, PER @D843, PLU @D842, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : ACT, 
   [COORD @D851, PAST @D850, AGR [CASE @D849, COUNT @D848, PER @D847, 
            PLU @D846, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AS, ARITY 2] : ACT, 
   [COORD @D854, AGR [COUNT @D853, PER @D852, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : ACT, 
   [COORD @D856, AGR [COUNT @D855, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : ACT, 
   [COORD @D858, AGR [COUNT @D857, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : ACT, 
   [COORD @D862, AGR [COUNT @D861, PER @D860, PLU @D859, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : ACT, 
   [COORD @D868, PAST @D867, AGR [CASE @D866, COUNT @D865, PER @D864, 
            PLU @D863, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : ACT, 
   [COORD @D871, AGR [COUNT @D870, PER @D869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D873, AGR [COUNT @D872, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D875, AGR [COUNT @D874, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D879, AGR [COUNT @D878, PER @D877, PLU @D876, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, 
      ARITY 2] : ACT, 
   [COORD @D885, PAST @D884, AGR [CASE @D883, COUNT @D882, PER @D881, 
            PLU @D880, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, 
      LAT -, ARITY 2] : ACT, 
   [COORD @D888, AGR [COUNT @D887, PER @D886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACT, 
   [COORD @D890, 
      AGR [COUNT @D889, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACT, 
   [COORD @D892, 
      AGR [COUNT @D891, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACT, 
   [COORD @D896, 
      AGR [COUNT @D895, PER @D894, PLU @D893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACT, 
   [COORD @D902, PAST @D901, 
      AGR [CASE @D900, COUNT @D899, PER @D898, PLU @D897, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ACT, 
   [COORD @D905, 
      AGR [COUNT @D904, PER @D903, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADVP, LAT -, ARITY 2] : ACT, 
   [COORD @D907, 
      AGR [COUNT @D906, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADVP, LAT -, ARITY 2] : ACT, 
   [COORD @D909, 
      AGR [COUNT @D908, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADVP, LAT -, ARITY 2] : ACT, 
   [COORD @D913, 
      AGR [COUNT @D912, PER @D911, PLU @D910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADVP, LAT -, ARITY 2] : ACT, 
   [COORD @D919, PAST @D918, 
      AGR [CASE @D917, COUNT @D916, PER @D915, PLU @D914, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT ADVP, LAT -, ARITY 2] : ACT, 
   [COORD @D922, 
      AGR [COUNT @D921, PER @D920, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, LAT -, 
      ARITY 2] : ACT, 
   [COORD @D924, AGR [COUNT @D923, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, LAT -, 
      ARITY 2] : ACT, 
   [COORD @D926, AGR [COUNT @D925, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, LAT -, 
      ARITY 2] : ACT, 
   [COORD @D930, AGR [COUNT @D929, PER @D928, PLU @D927, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, 
      LAT -, ARITY 2] : ACT, 
   [COORD @D936, PAST @D935, AGR [CASE @D934, COUNT @D933, PER @D932, 
            PLU @D931, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, LAT -, ARITY 2] : ACT, 
   [COORD @D939, AGR [COUNT @D938, PER @D937, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D941, AGR [COUNT @D940, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D943, AGR [COUNT @D942, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D947, AGR [COUNT @D946, PER @D945, PLU @D944, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : ACT, 
   [COORD @D953, PAST @D952, AGR [CASE @D951, COUNT @D950, PER @D949, 
            PLU @D948, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, LAT -, ARITY 2] : ACT, 
   [COORD @D956, AGR [COUNT @D955, PER @D954, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D958, AGR [COUNT @D957, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D960, AGR [COUNT @D959, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   ACT, 
   [COORD @D964, AGR [COUNT @D963, PER @D962, PLU @D961, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : ACT, 
   [COORD @D970, PAST @D969, AGR [CASE @D968, COUNT @D967, PER @D966, 
            PLU @D965, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, LAT -, ARITY 2] : ACT, 
   [COORD @D973, AGR [COUNT @D972, PER @D971, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : ACT, 
   [COORD @D975, AGR [COUNT @D974, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : ACT, 
   [COORD @D977, AGR [COUNT @D976, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : ACT, 
   [COORD @D981, AGR [COUNT @D980, PER @D979, PLU @D978, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ACT, 
   [COORD @D987, PAST @D986, AGR [CASE @D985, COUNT @D984, PER @D983, 
            PLU @D982, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ACT, 
   [COORD @D990, AGR [COUNT @D989, PER @D988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : ACT, 
   [COORD @D992, AGR [COUNT @D991, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : ACT, 
   [COORD @D994, AGR [COUNT @D993, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : ACT, 
   [COORD @D998, AGR [COUNT @D997, PER @D996, PLU @D995, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : ACT, 
   [COORD @D1004, PAST @D1003, AGR 
         [CASE @D1002, COUNT @D1001, PER @D1000, PLU @D999, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, ARITY 1] : 
   ACT, 
   [COORD @D1007, AGR [COUNT @D1006, PER @D1005, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ACT, 
   [COORD @D1009, AGR [COUNT @D1008, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ACT, 
   [COORD @D1011, 
      AGR [COUNT @D1010, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ACT, 
   [COORD @D1015, 
      AGR [COUNT @D1014, PER @D1013, PLU @D1012, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ACT, 
   [COORD @D1021, PAST @D1020, AGR [CASE @D1019, COUNT @D1018, 
            PER @D1017, PLU @D1016, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ACT.

WORD acted : 
   [COORD @D1031, AGR [CASE @D1030, COUNT @D1029, PER @D1028, PLU 
               @D1027, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1036, AGR [CASE @D1035, COUNT @D1034, PER @D1033, 
            PLU @D1032, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1041, AGR [CASE @D1040, COUNT @D1039, PER @D1038, 
            PLU @D1037, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1046, AGR [CASE @D1045, COUNT @D1044, PER @D1043, 
            PLU @D1042, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1051, AGR [CASE @D1050, COUNT @D1049, PER @D1048, 
            PLU @D1047, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1056, AGR [CASE @D1055, COUNT @D1054, PER @D1053, 
            PLU @D1052, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1061, AGR [CASE @D1060, COUNT @D1059, PER @D1058, 
            PLU @D1057, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1066, AGR [CASE @D1065, COUNT @D1064, PER @D1063, 
            PLU @D1062, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1071, AGR [CASE @D1070, COUNT @D1069, PER @D1068, 
            PLU @D1067, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1076, AGR [CASE @D1075, COUNT @D1074, PER @D1073, 
            PLU @D1072, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1081, AGR [CASE @D1080, COUNT @D1079, PER @D1078, 
            PLU @D1077, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACT, 
   [COORD @D1086, AGR [CASE @D1085, COUNT @D1084, PER @D1083, 
            PLU @D1082, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ACT, 
   [COORD @D1091, AGR [CASE @D1090, COUNT @D1089, PER @D1088, 
            PLU @D1087, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ACT, 
   [COORD @D1096, AGR [CASE @D1095, COUNT @D1094, PER @D1093, 
            PLU @D1092, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1101, AGR [CASE @D1100, COUNT @D1099, PER @D1098, 
            PLU @D1097, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1106, AGR [CASE @D1105, COUNT @D1104, PER @D1103, 
            PLU @D1102, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1111, AGR [CASE @D1110, COUNT @D1109, PER @D1108, 
            PLU @D1107, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1116, AGR [CASE @D1115, COUNT @D1114, PER @D1113, 
            PLU @D1112, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1121, AGR [CASE @D1120, COUNT @D1119, PER @D1118, 
            PLU @D1117, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1126, AGR [CASE @D1125, COUNT @D1124, PER @D1123, 
            PLU @D1122, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1131, AGR [CASE @D1130, COUNT @D1129, PER @D1128, 
            PLU @D1127, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1136, AGR [CASE @D1135, COUNT @D1134, PER @D1133, 
            PLU @D1132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1141, AGR [CASE @D1140, COUNT @D1139, PER @D1138, 
            PLU @D1137, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1146, AGR [CASE @D1145, COUNT @D1144, PER @D1143, 
            PLU @D1142, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1151, AGR [CASE @D1150, COUNT @D1149, PER @D1148, 
            PLU @D1147, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ACT, 
   [COORD @D1156, AGR [CASE @D1155, COUNT @D1154, PER @D1153, 
            PLU @D1152, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1161, AGR [CASE @D1160, COUNT @D1159, PER @D1158, 
            PLU @D1157, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ACT.

WORD acting : 
   [COADV @D1178, COORD @D1177, DEF @D1176, PRD @D1175, AGR [CASE 
               @D1174, COUNT @D1173, PER @D1172, PLU @D1171, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, SUBCAT NULL, 
      INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR ATT] : 
   ACTING, 
   [COORD @D1182, REFL @D1181, PRD @D1180, CASE @D1179, FIX NOT, BAR 0, 
      SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : ACTING, 
   [COORD @D1188, PRD @D1187, 
      AGR [CASE @D1186, COUNT @D1185, PER @D1184, PLU @D1183, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1194, PRD @D1193, AGR [CASE @D1192, COUNT @D1191, 
            PER @D1190, PLU @D1189, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1200, PRD @D1199, 
      AGR [CASE @D1198, COUNT @D1197, PER @D1196, PLU @D1195, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACT, 
   
   [COORD @D1206, PRD @D1205, AGR [CASE @D1204, COUNT @D1203, PER @D1202, 
            PLU @D1201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACT, 
   [COORD @D1212, PRD @D1211, AGR [CASE @D1210, COUNT @D1209, 
            PER @D1208, PLU @D1207, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1218, PRD @D1217, AGR [CASE @D1216, COUNT @D1215, 
            PER @D1214, PLU @D1213, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1224, PRD @D1223, AGR [CASE @D1222, COUNT @D1221, 
            PER @D1220, PLU @D1219, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1230, PRD @D1229, 
      AGR [CASE @D1228, COUNT @D1227, PER @D1226, PLU @D1225, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACT, 
   
   [COORD @D1236, PRD @D1235, AGR [CASE @D1234, COUNT @D1233, PER @D1232, 
            PLU @D1231, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ACT, 
   [COORD @D1242, PRD @D1241, AGR [CASE @D1240, COUNT @D1239, 
            PER @D1238, PLU @D1237, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ACT, 
   [COORD @D1248, PRD @D1247, 
      AGR [CASE @D1246, COUNT @D1245, PER @D1244, PLU @D1243, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ACT, 
   
   [COORD @D1254, PRD @D1253, AGR [CASE @D1252, COUNT @D1251, PER @D1250, 
            PLU @D1249, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ACT.

WORD acts : 
   [COORD @D1277, DEMON @D1276, REFL @D1275, PRD @D1274, CASE @D1273, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ACT, 
   [COORD @D1279, 
      AGR [COUNT @D1278, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ACT, 
   [COORD @D1281, AGR [COUNT @D1280, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1283, 
      AGR [COUNT @D1282, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1285, 
      AGR [COUNT @D1284, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1287, 
      AGR [COUNT @D1286, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1289, 
      AGR [COUNT @D1288, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1291, 
      AGR [COUNT @D1290, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1293, 
      AGR [COUNT @D1292, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1295, 
      AGR [COUNT @D1294, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1297, 
      AGR [COUNT @D1296, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1299, 
      AGR [COUNT @D1298, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT, 
   [COORD @D1301, 
      AGR [COUNT @D1300, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ACT.

WORD add : 
   [COORD @D1307, AGR [COUNT @D1306, PER @D1305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ADD, 
   [COORD @D1309, AGR [COUNT @D1308, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ADD, 
   [COORD @D1311, AGR [COUNT @D1310, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ADD, 
   [COORD @D1315, AGR [COUNT @D1314, PER @D1313, PLU @D1312, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ADD, 
   [COORD @D1321, PAST @D1320, AGR [CASE @D1319, COUNT @D1318, 
            PER @D1317, PLU @D1316, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, LAT -, ARITY 3] : ADD, 
   [COORD @D1324, AGR [COUNT @D1323, PER @D1322, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ADD, 
   [COORD @D1326, AGR [COUNT @D1325, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ADD, 
   [COORD @D1328, AGR [COUNT @D1327, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ADD, 
   [COORD @D1332, AGR [COUNT @D1331, PER @D1330, PLU @D1329, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ADD, 
   [COORD @D1338, PAST @D1337, AGR [CASE @D1336, COUNT @D1335, 
            PER @D1334, PLU @D1333, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, ARITY 2] : ADD, 
   [COORD @D1341, AGR 
         [COUNT @D1340, PER @D1339, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : ADD, 
   [COORD @D1343, AGR [COUNT @D1342, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : ADD, 
   [COORD @D1345, AGR [COUNT @D1344, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : ADD, 
   [COORD @D1349, AGR [COUNT @D1348, PER @D1347, PLU @D1346, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : ADD, 
   [COORD @D1355, PAST @D1354, AGR [CASE @D1353, COUNT @D1352, 
            PER @D1351, PLU @D1350, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : ADD, 
   [COORD @D1358, 
      AGR [COUNT @D1357, PER @D1356, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   ADD, 
   [COORD @D1360, AGR [COUNT @D1359, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   ADD, 
   [COORD @D1362, AGR [COUNT @D1361, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   ADD, 
   [COORD @D1366, AGR [COUNT @D1365, PER @D1364, PLU @D1363, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : ADD, 
   [COORD @D1372, PAST @D1371, AGR [CASE @D1370, COUNT @D1369, 
            PER @D1368, PLU @D1367, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : ADD, 
   [COORD @D1375, AGR [COUNT @D1374, PER @D1373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ADD, 
   [COORD @D1377, AGR [COUNT @D1376, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ADD, 
   [COORD @D1379, 
      AGR [COUNT @D1378, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ADD, 
   [COORD @D1383, 
      AGR [COUNT @D1382, PER @D1381, PLU @D1380, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ADD, 
   [COORD @D1389, PAST @D1388, AGR [CASE @D1387, COUNT @D1386, 
            PER @D1385, PLU @D1384, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : ADD, 
   [COORD @D1392, AGR [COUNT @D1391, PER @D1390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADD, 
   [COORD @D1394, AGR [COUNT @D1393, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADD, 
   [COORD @D1396, 
      AGR [COUNT @D1395, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADD, 
   [COORD @D1400, 
      AGR [COUNT @D1399, PER @D1398, PLU @D1397, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADD, 
   [COORD @D1406, PAST @D1405, AGR [CASE @D1404, COUNT @D1403, 
            PER @D1402, PLU @D1401, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ADD, 
   [COORD @D1409, AGR [COUNT @D1408, PER @D1407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT UP, LAT -, 
      ARITY 2] : ADD, 
   [COORD @D1411, AGR [COUNT @D1410, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT UP, LAT -, ARITY 2] : ADD, 
   [COORD @D1413, 
      AGR [COUNT @D1412, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT UP, LAT -, ARITY 2] : ADD, 
   [COORD @D1417, 
      AGR [COUNT @D1416, PER @D1415, PLU @D1414, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT UP, LAT -, 
      ARITY 2] : ADD, 
   [COORD @D1423, PAST @D1422, AGR [CASE @D1421, COUNT @D1420, 
            PER @D1419, PLU @D1418, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      PRT UP, LAT -, ARITY 2] : ADD, 
   [COORD @D1426, AGR [COUNT @D1425, PER @D1424, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT TOGETHER, 
      LAT -, ARITY 2] : ADD, 
   [COORD @D1428, AGR [COUNT @D1427, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT TOGETHER, LAT -, ARITY 2] : 
   ADD, 
   [COORD @D1430, AGR [COUNT @D1429, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT TOGETHER, LAT -, ARITY 2] : 
   ADD, 
   [COORD @D1434, AGR [COUNT @D1433, PER @D1432, PLU @D1431, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT TOGETHER, 
      LAT -, ARITY 2] : ADD, 
   [COORD @D1440, PAST @D1439, AGR [CASE @D1438, COUNT @D1437, 
            PER @D1436, PLU @D1435, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      PRT TOGETHER, LAT -, ARITY 2] : ADD, 
   [COORD @D1443, AGR [COUNT @D1442, PER @D1441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ADD, 
   [COORD @D1445, AGR [COUNT @D1444, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : ADD, 
   [COORD @D1447, AGR [COUNT @D1446, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : ADD, 
   [COORD @D1451, AGR [COUNT @D1450, PER @D1449, PLU @D1448, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ADD, 
   [COORD @D1457, PAST @D1456, AGR [CASE @D1455, COUNT @D1454, 
            PER @D1453, PLU @D1452, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, PRT UP, ARITY 1] : ADD, 
   [COORD @D1460, AGR [COUNT @D1459, PER @D1458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      LAT -, ARITY 1] : ADD, 
   [COORD @D1462, AGR [COUNT @D1461, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT UP, LAT -, ARITY 1] : 
   ADD, 
   [COORD @D1464, AGR [COUNT @D1463, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT UP, LAT -, ARITY 1] : 
   ADD, 
   [COORD @D1468, AGR [COUNT @D1467, PER @D1466, PLU @D1465, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      LAT -, ARITY 1] : ADD, 
   [COORD @D1474, PAST @D1473, AGR [CASE @D1472, COUNT @D1471, 
            PER @D1470, PLU @D1469, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, LAT -, ARITY 1] : ADD, 
   [COORD @D1477, AGR [COUNT @D1476, PER @D1475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      PRT TOGETHER, LAT -, ARITY 1] : ADD, 
   [COORD @D1479, AGR [COUNT @D1478, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, LAT -, 
      ARITY 1] : ADD, 
   [COORD @D1481, AGR [COUNT @D1480, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, LAT -, 
      ARITY 1] : ADD, 
   [COORD @D1485, AGR [COUNT @D1484, PER @D1483, PLU @D1482, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      PRT TOGETHER, LAT -, ARITY 1] : ADD, 
   [COORD @D1491, PAST @D1490, AGR [CASE @D1489, COUNT @D1488, 
            PER @D1487, PLU @D1486, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, LAT -, ARITY 1] : ADD.

WORD added : 
   [COORD @D1500, AGR [CASE @D1499, COUNT @D1498, PER @D1497, PLU 
               @D1496, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADD, 
   [COORD @D1505, AGR [CASE @D1504, COUNT @D1503, PER @D1502, 
            PLU @D1501, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1510, AGR [CASE @D1509, COUNT @D1508, PER @D1507, 
            PLU @D1506, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1515, AGR [CASE @D1514, COUNT @D1513, PER @D1512, 
            PLU @D1511, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1520, AGR [CASE @D1519, COUNT @D1518, PER @D1517, 
            PLU @D1516, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1525, AGR [CASE @D1524, COUNT @D1523, PER @D1522, 
            PLU @D1521, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADD, 
   [COORD @D1530, AGR [CASE @D1529, COUNT @D1528, PER @D1527, 
            PLU @D1526, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1535, AGR [CASE @D1534, COUNT @D1533, PER @D1532, 
            PLU @D1531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1540, AGR [CASE @D1539, COUNT @D1538, PER @D1537, 
            PLU @D1536, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADD, 
   [COORD @D1545, AGR [CASE @D1544, COUNT @D1543, PER @D1542, 
            PLU @D1541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1550, AGR [CASE @D1549, COUNT @D1548, PER @D1547, 
            PLU @D1546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1555, AGR [CASE @D1554, COUNT @D1553, PER @D1552, 
            PLU @D1551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADD, 
   [COORD @D1560, AGR [CASE @D1559, COUNT @D1558, PER @D1557, 
            PLU @D1556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ADD, 
   [COORD @D1565, AGR [UB @D1564, VFORM @D1563, SUBJ @D1562, FIN @D1561, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1570, 
      AGR [CASE @D1569, COUNT @D1568, PER @D1567, PLU @D1566, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1575, 
      AGR [CASE @D1574, COUNT @D1573, PER @D1572, PLU @D1571, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1580, 
      AGR [CASE @D1579, COUNT @D1578, PER @D1577, PLU @D1576, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1585, 
      AGR [CASE @D1584, COUNT @D1583, PER @D1582, PLU @D1581, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1590, 
      AGR [CASE @D1589, COUNT @D1588, PER @D1587, PLU @D1586, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1595, 
      AGR [CASE @D1594, COUNT @D1593, PER @D1592, PLU @D1591, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : 
   ADD, 
   [COORD @D1600, AGR [CASE @D1599, COUNT @D1598, PER @D1597, PLU 
               @D1596, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1605, AGR [CASE @D1604, COUNT @D1603, PER @D1602, 
            PLU @D1601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1610, AGR [CASE @D1609, COUNT @D1608, PER @D1607, 
            PLU @D1606, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADD, 
   [COORD @D1615, AGR [CASE @D1614, COUNT @D1613, PER @D1612, 
            PLU @D1611, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1620, AGR [CASE @D1619, COUNT @D1618, PER @D1617, 
            PLU @D1616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1625, AGR [CASE @D1624, COUNT @D1623, PER @D1622, 
            PLU @D1621, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1630, AGR [CASE @D1629, COUNT @D1628, PER @D1627, 
            PLU @D1626, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADD, 
   [COORD @D1635, AGR [CASE @D1634, COUNT @D1633, PER @D1632, 
            PLU @D1631, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1640, AGR [CASE @D1639, COUNT @D1638, PER @D1637, 
            PLU @D1636, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ADD.

WORD adding : 
   [COORD @D1652, PRD @D1651, AGR [CASE @D1650, COUNT @D1649, PER 
               @D1648, PLU @D1647, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1658, PRD @D1657, 
      AGR [CASE @D1656, COUNT @D1655, PER @D1654, PLU @D1653, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ADD, 
   [COORD @D1664, PRD @D1663, AGR [CASE @D1662, COUNT @D1661, 
            PER @D1660, PLU @D1659, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1670, PRD @D1669, 
      AGR [CASE @D1668, COUNT @D1667, PER @D1666, PLU @D1665, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   
   [COORD @D1676, PRD @D1675, AGR [CASE @D1674, COUNT @D1673, PER @D1672, 
            PLU @D1671, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ADD, 
   [COORD @D1682, PRD @D1681, AGR [CASE @D1680, COUNT @D1679, 
            PER @D1678, PLU @D1677, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1688, PRD @D1687, AGR [CASE @D1686, COUNT @D1685, 
            PER @D1684, PLU @D1683, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1694, PRD @D1693, 
      AGR [CASE @D1692, COUNT @D1691, PER @D1690, PLU @D1689, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   
   [COORD @D1700, PRD @D1699, AGR [CASE @D1698, COUNT @D1697, PER @D1696, 
            PLU @D1695, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADD, 
   [COORD @D1706, PRD @D1705, AGR [CASE @D1704, COUNT @D1703, 
            PER @D1702, PLU @D1701, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD, 
   [COORD @D1712, PRD @D1711, 
      AGR [CASE @D1710, COUNT @D1709, PER @D1708, PLU @D1707, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADD.

WORD adds : 
   [COORD @D1718, AGR [COUNT @D1717, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1720, 
      AGR [COUNT @D1719, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1722, 
      AGR [COUNT @D1721, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ADD, 
   [COORD @D1724, AGR [COUNT @D1723, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1726, 
      AGR [COUNT @D1725, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1728, 
      AGR [COUNT @D1727, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1730, 
      AGR [COUNT @D1729, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1732, 
      AGR [COUNT @D1731, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1734, 
      AGR [COUNT @D1733, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1736, 
      AGR [COUNT @D1735, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADD, 
   [COORD @D1738, 
      AGR [COUNT @D1737, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ADD.

WORD admit : 
   [COORD @D1744, AGR [COUNT @D1743, PER @D1742, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ADMIT, 
   [COORD @D1746, AGR [COUNT @D1745, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ADMIT, 
   [COORD @D1748, AGR [COUNT @D1747, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ADMIT, 
   [COORD @D1752, AGR [COUNT @D1751, PER @D1750, PLU @D1749, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ADMIT, 
   [COORD @D1758, PAST @D1757, AGR [CASE @D1756, COUNT @D1755, 
            PER @D1754, PLU @D1753, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, LAT -, ARITY 3] : ADMIT, 
   [COORD @D1761, AGR [COUNT @D1760, PER @D1759, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM INTO, LAT -, ARITY 3] : ADMIT, 
   [COORD @D1763, AGR [COUNT @D1762, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM INTO, LAT -, 
      ARITY 3] : ADMIT, 
   [COORD @D1765, AGR [COUNT @D1764, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM INTO, LAT -, 
      ARITY 3] : ADMIT, 
   [COORD @D1769, AGR [COUNT @D1768, PER @D1767, PLU @D1766, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM INTO, LAT -, ARITY 3] : ADMIT, 
   [COORD @D1775, PAST @D1774, AGR [CASE @D1773, COUNT @D1772, 
            PER @D1771, PLU @D1770, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, LAT -, ARITY 3] : ADMIT, 
   [COORD @D1778, AGR [COUNT @D1777, PER @D1776, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      LAT -, ARITY 3] : ADMIT, 
   [COORD @D1780, AGR [COUNT @D1779, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, LAT -, 
      ARITY 3] : ADMIT, 
   [COORD @D1782, AGR [COUNT @D1781, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, LAT -, 
      ARITY 3] : ADMIT, 
   [COORD @D1786, AGR [COUNT @D1785, PER @D1784, PLU @D1783, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      LAT -, ARITY 3] : ADMIT, 
   [COORD @D1792, PAST @D1791, AGR [CASE @D1790, COUNT @D1789, 
            PER @D1788, PLU @D1787, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, LAT -, ARITY 3] : ADMIT, 
   [COORD @D1795, AGR [COUNT @D1794, PER @D1793, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ADMIT, 
   [COORD @D1797, AGR [COUNT @D1796, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ADMIT, 
   [COORD @D1799, AGR [COUNT @D1798, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ADMIT, 
   [COORD @D1803, AGR [COUNT @D1802, PER @D1801, PLU @D1800, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ADMIT, 
   [COORD @D1809, PAST @D1808, AGR [CASE @D1807, COUNT @D1806, 
            PER @D1805, PLU @D1804, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, ARITY 2] : ADMIT, 
   [COORD @D1812, 
      AGR [COUNT @D1811, PER @D1810, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1814, 
      AGR [COUNT @D1813, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1816, 
      AGR [COUNT @D1815, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1820, 
      AGR [COUNT @D1819, PER @D1818, PLU @D1817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ADMIT, 
   [COORD @D1826, PAST @D1825, AGR [CASE @D1824, COUNT @D1823, 
            PER @D1822, PLU @D1821, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1829, AGR [COUNT @D1828, PER @D1827, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, 
      ARITY 2] : ADMIT, 
   [COORD @D1831, AGR [COUNT @D1830, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, ARITY 2] : 
   ADMIT, 
   [COORD @D1833, AGR [COUNT @D1832, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, ARITY 2] : 
   ADMIT, 
   [COORD @D1837, AGR [COUNT @D1836, PER @D1835, PLU @D1834, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, 
      ARITY 2] : ADMIT, 
   [COORD @D1843, PAST @D1842, AGR [CASE @D1841, COUNT @D1840, 
            PER @D1839, PLU @D1838, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_ING, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1846, AGR [COUNT @D1845, PER @D1844, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : ADMIT, 
   [COORD @D1848, AGR [COUNT @D1847, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, ARITY 2] : 
   ADMIT, 
   [COORD @D1850, AGR [COUNT @D1849, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, ARITY 2] : 
   ADMIT, 
   [COORD @D1854, AGR [COUNT @D1853, PER @D1852, PLU @D1851, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : ADMIT, 
   [COORD @D1860, PAST @D1859, AGR [CASE @D1858, COUNT @D1857, 
            PER @D1856, PLU @D1855, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1863, AGR [COUNT @D1862, PER @D1861, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADMIT, 
   [COORD @D1865, AGR [COUNT @D1864, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1867, 
      AGR [COUNT @D1866, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1871, 
      AGR [COUNT @D1870, PER @D1869, PLU @D1868, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADMIT, 
   [COORD @D1877, PAST @D1876, AGR [CASE @D1875, COUNT @D1874, 
            PER @D1873, PLU @D1872, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1880, AGR [COUNT @D1879, PER @D1878, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : ADMIT, 
   [COORD @D1882, AGR [COUNT @D1881, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   ADMIT, 
   [COORD @D1884, AGR [COUNT @D1883, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   ADMIT, 
   [COORD @D1888, AGR [COUNT @D1887, PER @D1886, PLU @D1885, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : ADMIT, 
   [COORD @D1894, PAST @D1893, AGR [CASE @D1892, COUNT @D1891, 
            PER @D1890, PLU @D1889, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, LAT -, ARITY 2] : ADMIT, 
   [COORD @D1897, AGR [COUNT @D1896, PER @D1895, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ADMIT, 
   [COORD @D1899, AGR [COUNT @D1898, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ADMIT, 
   [COORD @D1901, 
      AGR [COUNT @D1900, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ADMIT, 
   [COORD @D1905, 
      AGR [COUNT @D1904, PER @D1903, PLU @D1902, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ADMIT, 
   [COORD @D1911, PAST @D1910, AGR [CASE @D1909, COUNT @D1908, 
            PER @D1907, PLU @D1906, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ADMIT.

WORD admits : 
   [COORD @D1917, AGR [COUNT @D1916, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1919, 
      AGR [COUNT @D1918, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ADMIT, 
   [COORD @D1921, AGR [COUNT @D1920, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1923, 
      AGR [COUNT @D1922, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1925, 
      AGR [COUNT @D1924, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1927, 
      AGR [COUNT @D1926, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1929, 
      AGR [COUNT @D1928, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1931, 
      AGR [COUNT @D1930, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1933, 
      AGR [COUNT @D1932, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1935, 
      AGR [COUNT @D1934, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADMIT.

WORD admitted : 
   [COADV @D1947, COORD @D1946, DEF @D1945, PRD @D1944, AGR 
            [CASE @D1943, COUNT @D1942, PER @D1941, PLU @D1940, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : ADMITTED, 
   [COORD @D1952, AGR [CASE @D1951, COUNT @D1950, PER @D1949, 
            PLU @D1948, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADMIT, 
   [COORD @D1957, AGR [CASE @D1956, COUNT @D1955, PER @D1954, 
            PLU @D1953, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1962, AGR [CASE @D1961, COUNT @D1960, PER @D1959, 
            PLU @D1958, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1967, AGR [CASE @D1966, COUNT @D1965, PER @D1964, 
            PLU @D1963, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADMIT, 
   [COORD @D1972, AGR [CASE @D1971, COUNT @D1970, PER @D1969, 
            PLU @D1968, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1977, AGR [CASE @D1976, COUNT @D1975, PER @D1974, 
            PLU @D1973, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1982, AGR [CASE @D1981, COUNT @D1980, PER @D1979, 
            PLU @D1978, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADMIT, 
   [COORD @D1987, AGR [CASE @D1986, COUNT @D1985, PER @D1984, 
            PLU @D1983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1992, AGR [CASE @D1991, COUNT @D1990, PER @D1989, 
            PLU @D1988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D1997, AGR [CASE @D1996, COUNT @D1995, PER @D1994, 
            PLU @D1993, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2002, AGR [CASE @D2001, COUNT @D2000, PER @D1999, 
            PLU @D1998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2007, AGR [CASE @D2006, COUNT @D2005, PER @D2004, 
            PLU @D2003, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OF, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADMIT, 
   [COORD @D2012, AGR [UB @D2011, VFORM @D2010, SUBJ @D2009, FIN @D2008, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2017, 
      AGR [CASE @D2016, COUNT @D2015, PER @D2014, PLU @D2013, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2022, 
      AGR [CASE @D2021, COUNT @D2020, PER @D2019, PLU @D2018, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2027, 
      AGR [CASE @D2026, COUNT @D2025, PER @D2024, PLU @D2023, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2032, 
      AGR [CASE @D2031, COUNT @D2030, PER @D2029, PLU @D2028, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2037, 
      AGR [CASE @D2036, COUNT @D2035, PER @D2034, PLU @D2033, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2042, 
      AGR [CASE @D2041, COUNT @D2040, PER @D2039, PLU @D2038, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2048, 
      AGR [CASE @D2047, NFORM @D2046, COUNT @D2045, PER @D2044, 
            PLU @D2043, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ADMIT, 
   [COORD @D2053, AGR [UB @D2052, VFORM @D2051, SUBJ @D2050, FIN @D2049, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2058, 
      AGR [CASE @D2057, COUNT @D2056, PER @D2055, PLU @D2054, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2063, 
      AGR [CASE @D2062, COUNT @D2061, PER @D2060, PLU @D2059, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2068, 
      AGR [CASE @D2067, COUNT @D2066, PER @D2065, PLU @D2064, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2073, 
      AGR [CASE @D2072, COUNT @D2071, PER @D2070, PLU @D2069, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ADMIT, 
   [COORD @D2078, AGR [CASE @D2077, COUNT @D2076, PER @D2075, 
            PLU @D2074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2083, AGR [CASE @D2082, COUNT @D2081, PER @D2080, 
            PLU @D2079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADMIT, 
   [COORD @D2088, AGR [CASE @D2087, COUNT @D2086, PER @D2085, 
            PLU @D2084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ADMIT.

WORD admitting : 
   [COORD @D2100, PRD @D2099, AGR [CASE @D2098, COUNT @D2097, 
            PER @D2096, PLU @D2095, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2106, PRD @D2105, 
      AGR [CASE @D2104, COUNT @D2103, PER @D2102, PLU @D2101, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ADMIT, 
   [COORD @D2112, PRD @D2111, AGR [CASE @D2110, COUNT @D2109, PER 
               @D2108, PLU @D2107, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2118, PRD @D2117, 
      AGR [CASE @D2116, COUNT @D2115, PER @D2114, PLU @D2113, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ADMIT, 
   [COORD @D2124, PRD @D2123, AGR [CASE @D2122, COUNT @D2121, 
            PER @D2120, PLU @D2119, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2130, PRD @D2129, AGR 
         [CASE @D2128, COUNT @D2127, PER @D2126, PLU @D2125, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2136, PRD @D2135, 
      AGR [CASE @D2134, COUNT @D2133, PER @D2132, PLU @D2131, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2142, PRD @D2141, 
      AGR [CASE @D2140, COUNT @D2139, PER @D2138, PLU @D2137, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADMIT, 
   [COORD @D2148, PRD @D2147, 
      AGR [CASE @D2146, COUNT @D2145, PER @D2144, PLU @D2143, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ADMIT, 
   [COORD @D2154, PRD @D2153, AGR [CASE @D2152, COUNT @D2151, PER 
               @D2150, PLU @D2149, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADMIT.

WORD adopt : 
   [COORD @D2160, AGR [COUNT @D2159, PER @D2158, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      LAT -, ARITY 3] : ADOPT, 
   [COORD @D2162, AGR [COUNT @D2161, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, LAT -, 
      ARITY 3] : ADOPT, 
   [COORD @D2164, AGR [COUNT @D2163, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, LAT -, 
      ARITY 3] : ADOPT, 
   [COORD @D2168, AGR [COUNT @D2167, PER @D2166, PLU @D2165, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      LAT -, ARITY 3] : ADOPT, 
   [COORD @D2174, PAST @D2173, AGR [CASE @D2172, COUNT @D2171, 
            PER @D2170, PLU @D2169, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, LAT -, ARITY 3] : ADOPT, 
   [COORD @D2177, AGR [COUNT @D2176, PER @D2175, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADOPT, 
   [COORD @D2179, AGR [COUNT @D2178, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADOPT, 
   [COORD @D2181, 
      AGR [COUNT @D2180, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADOPT, 
   [COORD @D2185, 
      AGR [COUNT @D2184, PER @D2183, PLU @D2182, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADOPT, 
   [COORD @D2191, PAST @D2190, AGR [CASE @D2189, COUNT @D2188, 
            PER @D2187, PLU @D2186, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ADOPT.

WORD adopted : 
   [COORD @D2200, AGR [CASE @D2199, COUNT @D2198, PER @D2197, 
            PLU @D2196, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADOPT, 
   [COORD @D2205, AGR [CASE @D2204, COUNT @D2203, PER @D2202, 
            PLU @D2201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADOPT, 
   [COORD @D2210, AGR [CASE @D2209, COUNT @D2208, PER @D2207, 
            PLU @D2206, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADOPT, 
   [COORD @D2215, AGR [CASE @D2214, COUNT @D2213, PER @D2212, 
            PLU @D2211, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ADOPT, 
   [COORD @D2220, AGR [CASE @D2219, COUNT @D2218, PER @D2217, 
            PLU @D2216, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ADOPT, 
   [COORD @D2225, AGR [CASE @D2224, COUNT @D2223, PER @D2222, 
            PLU @D2221, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ADOPT.

WORD adopting : 
   [COORD @D2237, PRD @D2236, AGR [CASE @D2235, COUNT @D2234, 
            PER @D2233, PLU @D2232, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADOPT, 
   [COORD @D2243, PRD @D2242, 
      AGR [CASE @D2241, COUNT @D2240, PER @D2239, PLU @D2238, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADOPT.

WORD adopts : 
   [COORD @D2249, AGR [COUNT @D2248, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : ADOPT, 
   [COORD @D2251, AGR [COUNT @D2250, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADOPT.

WORD advance : 
   [COORD @D2258, AGR [COUNT @D2257, PER @D2256, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, 
      ARITY 3] : ADVANCE, 
   [COORD @D2260, AGR [COUNT @D2259, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, ARITY 3] : 
   ADVANCE, 
   [COORD @D2262, AGR [COUNT @D2261, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, ARITY 3] : 
   ADVANCE, 
   [COORD @D2266, AGR [COUNT @D2265, PER @D2264, PLU @D2263, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, 
      ARITY 3] : ADVANCE, 
   [COORD @D2272, PAST @D2271, AGR [CASE @D2270, COUNT @D2269, 
            PER @D2268, PLU @D2267, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_NP, LAT -, ARITY 3] : ADVANCE, 
   [COORD @D2275, AGR [COUNT @D2274, PER @D2273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ADVANCE, 
   [COORD @D2277, AGR [COUNT @D2276, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ADVANCE, 
   [COORD @D2279, AGR [COUNT @D2278, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ADVANCE, 
   [COORD @D2283, AGR [COUNT @D2282, PER @D2281, PLU @D2280, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ADVANCE, 
   [COORD @D2289, PAST @D2288, AGR [CASE @D2287, COUNT @D2286, 
            PER @D2285, PLU @D2284, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, LAT -, ARITY 3] : ADVANCE, 
   [COORD @D2292, AGR [COUNT @D2291, PER @D2290, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADVANCE, 
   [COORD @D2294, AGR [COUNT @D2293, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2296, 
      AGR [COUNT @D2295, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2300, 
      AGR [COUNT @D2299, PER @D2298, PLU @D2297, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADVANCE, 
   [COORD @D2306, PAST @D2305, AGR [CASE @D2304, COUNT @D2303, 
            PER @D2302, PLU @D2301, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2309, AGR [COUNT @D2308, PER @D2307, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, 
      LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2311, AGR [COUNT @D2310, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, LAT -, 
      ARITY 2] : ADVANCE, 
   [COORD @D2313, AGR [COUNT @D2312, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, LAT -, 
      ARITY 2] : ADVANCE, 
   [COORD @D2317, AGR [COUNT @D2316, PER @D2315, PLU @D2314, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM UPON, 
      LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2323, PAST @D2322, AGR [CASE @D2321, COUNT @D2320, 
            PER @D2319, PLU @D2318, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM UPON, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2326, AGR [COUNT @D2325, PER @D2324, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2328, AGR [COUNT @D2327, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   ADVANCE, 
   [COORD @D2330, AGR [COUNT @D2329, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   ADVANCE, 
   [COORD @D2334, AGR [COUNT @D2333, PER @D2332, PLU @D2331, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2340, PAST @D2339, AGR [CASE @D2338, COUNT @D2337, 
            PER @D2336, PLU @D2335, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2343, AGR [COUNT @D2342, PER @D2341, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2345, AGR [COUNT @D2344, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, LAT -, ARITY 2] : 
   ADVANCE, 
   [COORD @D2347, AGR [COUNT @D2346, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, LAT -, ARITY 2] : 
   ADVANCE, 
   [COORD @D2351, AGR [COUNT @D2350, PER @D2349, PLU @D2348, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2357, PAST @D2356, AGR [CASE @D2355, COUNT @D2354, 
            PER @D2353, PLU @D2352, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2360, AGR [COUNT @D2359, PER @D2358, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2362, AGR [COUNT @D2361, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, LAT -, 
      ARITY 2] : ADVANCE, 
   [COORD @D2364, AGR [COUNT @D2363, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, LAT -, 
      ARITY 2] : ADVANCE, 
   [COORD @D2368, AGR [COUNT @D2367, PER @D2366, PLU @D2365, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, LAT -, ARITY 2] : ADVANCE, 
   [COORD @D2374, PAST @D2373, 
      AGR [CASE @D2372, COUNT @D2371, PER @D2370, PLU @D2369, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, LAT -, ARITY 2] : 
   ADVANCE, 
   [COORD @D2377, AGR [COUNT @D2376, PER @D2375, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ADVANCE, 
   [COORD @D2379, AGR [COUNT @D2378, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ADVANCE, 
   
   [COORD @D2381, AGR [COUNT @D2380, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ADVANCE, 
   
   [COORD @D2385, AGR [COUNT @D2384, PER @D2383, PLU @D2382, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ADVANCE, 
   [COORD @D2391, PAST @D2390, AGR [CASE @D2389, COUNT @D2388, 
            PER @D2387, PLU @D2386, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ADVANCE.

WORD advanced : 
   [COADV @D2404, COORD @D2403, DEF @D2402, PRD @D2401, AGR 
            [CASE @D2400, COUNT @D2399, PER @D2398, PLU @D2397, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ADVANCED, 
   [COORD @D2409, 
      AGR [CASE @D2408, COUNT @D2407, PER @D2406, PLU @D2405, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADVANCE, 
   
   [COORD @D2414, AGR [CASE @D2413, COUNT @D2412, PER @D2411, PLU @D2410, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2419, AGR [CASE @D2418, COUNT @D2417, PER @D2416, 
            PLU @D2415, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2424, AGR [CASE @D2423, COUNT @D2422, PER @D2421, 
            PLU @D2420, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2429, AGR [CASE @D2428, COUNT @D2427, PER @D2426, 
            PLU @D2425, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2434, AGR [CASE @D2433, COUNT @D2432, PER @D2431, 
            PLU @D2430, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2439, AGR [CASE @D2438, COUNT @D2437, PER @D2436, 
            PLU @D2435, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ADVANCE, 
   [COORD @D2444, AGR [CASE @D2443, COUNT @D2442, PER @D2441, 
            PLU @D2440, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ADVANCE, 
   [COORD @D2449, AGR [CASE @D2448, COUNT @D2447, PER @D2446, 
            PLU @D2445, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ADVANCE, 
   [COORD @D2454, AGR [CASE @D2453, COUNT @D2452, PER @D2451, 
            PLU @D2450, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2459, AGR [CASE @D2458, COUNT @D2457, PER @D2456, 
            PLU @D2455, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2464, AGR [CASE @D2463, COUNT @D2462, PER @D2461, 
            PLU @D2460, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2469, AGR [CASE @D2468, COUNT @D2467, PER @D2466, 
            PLU @D2465, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2474, AGR [CASE @D2473, COUNT @D2472, PER @D2471, 
            PLU @D2470, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2479, AGR [CASE @D2478, COUNT @D2477, PER @D2476, 
            PLU @D2475, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2484, AGR [CASE @D2483, COUNT @D2482, PER @D2481, 
            PLU @D2480, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2489, AGR [CASE @D2488, COUNT @D2487, PER @D2486, 
            PLU @D2485, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2494, AGR [CASE @D2493, COUNT @D2492, PER @D2491, 
            PLU @D2490, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2499, AGR [CASE @D2498, COUNT @D2497, PER @D2496, 
            PLU @D2495, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ADVANCE.

WORD advances : 
   [COORD @D2506, AGR [COUNT @D2505, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2508, 
      AGR [COUNT @D2507, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2510, 
      AGR [COUNT @D2509, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2512, 
      AGR [COUNT @D2511, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2514, 
      AGR [COUNT @D2513, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2516, 
      AGR [COUNT @D2515, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2518, 
      AGR [COUNT @D2517, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ADVANCE, 
   [COORD @D2520, AGR [COUNT @D2519, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVANCE.

WORD advancing : 
   [COORD @D2531, PRD @D2530, AGR [CASE @D2529, COUNT @D2528, 
            PER @D2527, PLU @D2526, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2537, PRD @D2536, 
      AGR [CASE @D2535, COUNT @D2534, PER @D2533, PLU @D2532, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ADVANCE, 
   [COORD @D2543, PRD @D2542, AGR [CASE @D2541, COUNT @D2540, 
            PER @D2539, PLU @D2538, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2549, PRD @D2548, 
      AGR [CASE @D2547, COUNT @D2546, PER @D2545, PLU @D2544, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ADVANCE, 
   [COORD @D2555, PRD @D2554, AGR [CASE @D2553, COUNT @D2552, 
            PER @D2551, PLU @D2550, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2561, PRD @D2560, 
      AGR [CASE @D2559, COUNT @D2558, PER @D2557, PLU @D2556, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ADVANCE, 
   [COORD @D2567, PRD @D2566, AGR [CASE @D2565, COUNT @D2564, 
            PER @D2563, PLU @D2562, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADVANCE, 
   [COORD @D2573, PRD @D2572, 
      AGR [CASE @D2571, COUNT @D2570, PER @D2569, PLU @D2568, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADVANCE.

WORD advertise : 
   [COORD @D2580, AGR [COUNT @D2579, PER @D2578, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ADVERTISE, 
   [COORD @D2582, AGR [COUNT @D2581, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : 
   ADVERTISE, 
   [COORD @D2584, AGR [COUNT @D2583, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : 
   ADVERTISE, 
   [COORD @D2588, AGR [COUNT @D2587, PER @D2586, PLU @D2585, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ADVERTISE, 
   [COORD @D2594, PAST @D2593, AGR [CASE @D2592, COUNT @D2591, 
            PER @D2590, PLU @D2589, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : ADVERTISE, 
   [COORD @D2597, AGR [COUNT @D2596, PER @D2595, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADVERTISE, 
   [COORD @D2599, AGR [COUNT @D2598, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADVERTISE, 
   
   [COORD @D2601, AGR [COUNT @D2600, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ADVERTISE, 
   
   [COORD @D2605, AGR [COUNT @D2604, PER @D2603, PLU @D2602, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ADVERTISE, 
   [COORD @D2611, PAST @D2610, AGR [CASE @D2609, COUNT @D2608, 
            PER @D2607, PLU @D2606, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ADVERTISE, 
   [COORD @D2614, AGR [COUNT @D2613, PER @D2612, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : ADVERTISE, 
   [COORD @D2616, AGR [COUNT @D2615, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   ADVERTISE, 
   [COORD @D2618, AGR [COUNT @D2617, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   ADVERTISE, 
   [COORD @D2622, AGR [COUNT @D2621, PER @D2620, PLU @D2619, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : ADVERTISE, 
   [COORD @D2628, PAST @D2627, AGR [CASE @D2626, COUNT @D2625, 
            PER @D2624, PLU @D2623, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : ADVERTISE, 
   [COORD @D2631, AGR [COUNT @D2630, PER @D2629, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ADVERTISE, 
   [COORD @D2633, AGR [COUNT @D2632, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : 
   ADVERTISE, 
   [COORD @D2635, AGR [COUNT @D2634, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : 
   ADVERTISE, 
   [COORD @D2639, AGR [COUNT @D2638, PER @D2637, PLU @D2636, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ADVERTISE, 
   [COORD @D2645, PAST @D2644, AGR [CASE @D2643, COUNT @D2642, 
            PER @D2641, PLU @D2640, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ADVERTISE.

WORD advertised : 
   [COORD @D2655, AGR [CASE @D2654, COUNT @D2653, PER @D2652, 
            PLU @D2651, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2660, AGR [CASE @D2659, COUNT @D2658, PER @D2657, 
            PLU @D2656, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2665, AGR [UB @D2664, VFORM @D2663, SUBJ @D2662, FIN @D2661, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ADVERTISE, 
   [COORD @D2670, AGR [CASE @D2669, COUNT @D2668, PER @D2667, 
            PLU @D2666, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ADVERTISE, 
   [COORD @D2675, AGR [CASE @D2674, COUNT @D2673, PER @D2672, 
            PLU @D2671, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ADVERTISE, 
   [COORD @D2680, AGR [CASE @D2679, COUNT @D2678, PER @D2677, 
            PLU @D2676, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ADVERTISE, 
   [COORD @D2685, AGR [CASE @D2684, COUNT @D2683, PER @D2682, 
            PLU @D2681, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2690, AGR [CASE @D2689, COUNT @D2688, PER @D2687, 
            PLU @D2686, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2695, AGR [CASE @D2694, COUNT @D2693, PER @D2692, 
            PLU @D2691, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2700, AGR [CASE @D2699, COUNT @D2698, PER @D2697, 
            PLU @D2696, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ADVERTISE.

WORD advertises : 
   [COORD @D2707, AGR [COUNT @D2706, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2709, 
      AGR [COUNT @D2708, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2711, 
      AGR [COUNT @D2710, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ADVERTISE, 
   [COORD @D2713, AGR [COUNT @D2712, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ADVERTISE.

WORD advertising : 
   [COORD @D2721, REFL @D2720, PRD @D2719, CASE @D2718, FIX NOT, BAR 0, 
      SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : ADVERTISING, 
   [COORD @D2727, PRD @D2726, 
      AGR [CASE @D2725, COUNT @D2724, PER @D2723, PLU @D2722, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2733, PRD @D2732, 
      AGR [CASE @D2731, COUNT @D2730, PER @D2729, PLU @D2728, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ADVERTISE, 
   [COORD @D2739, PRD @D2738, 
      AGR [CASE @D2737, COUNT @D2736, PER @D2735, PLU @D2734, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ADVERTISE, 
   [COORD @D2745, PRD @D2744, AGR [CASE @D2743, COUNT @D2742, 
            PER @D2741, PLU @D2740, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ADVERTISE.

WORD agree : 
   [COORD @D2758, AGR [COUNT @D2757, PER @D2756, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, 
      PFORM WITH, LAT -, ARITY 3] : AGREE, 
   [COORD @D2760, AGR [COUNT @D2759, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, PFORM WITH, 
      LAT -, ARITY 3] : AGREE, 
   [COORD @D2762, AGR [COUNT @D2761, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, PFORM WITH, 
      LAT -, ARITY 3] : AGREE, 
   [COORD @D2766, AGR [COUNT @D2765, PER @D2764, PLU @D2763, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, 
      PFORM WITH, LAT -, ARITY 3] : AGREE, 
   [COORD @D2772, PAST @D2771, AGR [CASE @D2770, COUNT @D2769, 
            PER @D2768, PLU @D2767, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_PP_INF, PFORM WITH, LAT -, ARITY 3] : AGREE, 
   [COORD @D2775, 
      AGR [COUNT @D2774, PER @D2773, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM WITH, LAT -, 
      ARITY 3] : AGREE, 
   [COORD @D2777, AGR [COUNT @D2776, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM WITH, LAT -, 
      ARITY 3] : AGREE, 
   [COORD @D2779, AGR [COUNT @D2778, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM WITH, LAT -, 
      ARITY 3] : AGREE, 
   [COORD @D2783, AGR [COUNT @D2782, PER @D2781, PLU @D2780, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, 
      PFORM WITH, LAT -, ARITY 3] : AGREE, 
   [COORD @D2789, PAST @D2788, AGR [CASE @D2787, COUNT @D2786, 
            PER @D2785, PLU @D2784, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM WITH, LAT -, ARITY 3] : AGREE, 
   [COORD @D2792, 
      AGR [COUNT @D2791, PER @D2790, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      ARITY 2] : AGREE, 
   [COORD @D2794, AGR [COUNT @D2793, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : AGREE, 
   [COORD @D2796, AGR [COUNT @D2795, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : AGREE, 
   [COORD @D2800, AGR [COUNT @D2799, PER @D2798, PLU @D2797, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : AGREE, 
   [COORD @D2806, PAST @D2805, AGR [CASE @D2804, COUNT @D2803, 
            PER @D2802, PLU @D2801, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, ARITY 2] : AGREE, 
   [COORD @D2809, 
      AGR [COUNT @D2808, PER @D2807, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : AGREE, 
   [COORD @D2811, 
      AGR [COUNT @D2810, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : AGREE, 
   [COORD @D2813, 
      AGR [COUNT @D2812, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : AGREE, 
   [COORD @D2817, 
      AGR [COUNT @D2816, PER @D2815, PLU @D2814, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2823, PAST @D2822, AGR [CASE @D2821, COUNT @D2820, 
            PER @D2819, PLU @D2818, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : AGREE, 
   [COORD @D2826, AGR [COUNT @D2825, PER @D2824, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2828, AGR [COUNT @D2827, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   AGREE, 
   [COORD @D2830, AGR [COUNT @D2829, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   AGREE, 
   [COORD @D2834, AGR [COUNT @D2833, PER @D2832, PLU @D2831, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2840, PAST @D2839, AGR [CASE @D2838, COUNT @D2837, 
            PER @D2836, PLU @D2835, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_INF, LAT -, ARITY 2] : AGREE, 
   [COORD @D2843, AGR [COUNT @D2842, PER @D2841, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2845, AGR [COUNT @D2844, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : AGREE, 
   [COORD @D2847, 
      AGR [COUNT @D2846, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : AGREE, 
   [COORD @D2851, 
      AGR [COUNT @D2850, PER @D2849, PLU @D2848, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2857, PAST @D2856, AGR [CASE @D2855, COUNT @D2854, 
            PER @D2853, PLU @D2852, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : AGREE, 
   [COORD @D2860, AGR [COUNT @D2859, PER @D2858, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2862, AGR [COUNT @D2861, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2864, AGR [COUNT @D2863, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2868, AGR [COUNT @D2867, PER @D2866, PLU @D2865, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2874, PAST @D2873, AGR [CASE @D2872, COUNT @D2871, 
            PER @D2870, PLU @D2869, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, LAT -, ARITY 2] : AGREE, 
   [COORD @D2877, AGR [COUNT @D2876, PER @D2875, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2879, AGR [COUNT @D2878, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   AGREE, 
   [COORD @D2881, AGR [COUNT @D2880, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   AGREE, 
   [COORD @D2885, AGR [COUNT @D2884, PER @D2883, PLU @D2882, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2891, PAST @D2890, AGR [CASE @D2889, COUNT @D2888, 
            PER @D2887, PLU @D2886, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, LAT -, ARITY 2] : AGREE, 
   [COORD @D2894, AGR [COUNT @D2893, PER @D2892, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2896, AGR [COUNT @D2895, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, LAT -, ARITY 2] : 
   AGREE, 
   [COORD @D2898, AGR [COUNT @D2897, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, LAT -, ARITY 2] : 
   AGREE, 
   [COORD @D2902, AGR [COUNT @D2901, PER @D2900, PLU @D2899, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2908, PAST @D2907, AGR [CASE @D2906, COUNT @D2905, 
            PER @D2904, PLU @D2903, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, LAT -, ARITY 2] : AGREE, 
   [COORD @D2911, AGR [COUNT @D2910, PER @D2909, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2913, AGR [COUNT @D2912, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2915, AGR [COUNT @D2914, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, LAT -, 
      ARITY 2] : AGREE, 
   [COORD @D2919, AGR [COUNT @D2918, PER @D2917, PLU @D2916, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      LAT -, ARITY 2] : AGREE, 
   [COORD @D2925, PAST @D2924, AGR [CASE @D2923, COUNT @D2922, 
            PER @D2921, PLU @D2920, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, LAT -, ARITY 2] : AGREE, 
   [COORD @D2928, AGR [COUNT @D2927, PER @D2926, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : AGREE, 
   [COORD @D2930, AGR [COUNT @D2929, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : AGREE, 
   [COORD @D2932, 
      AGR [COUNT @D2931, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : AGREE, 
   [COORD @D2936, 
      AGR [COUNT @D2935, PER @D2934, PLU @D2933, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : AGREE, 
   [COORD @D2942, PAST @D2941, AGR [CASE @D2940, COUNT @D2939, 
            PER @D2938, PLU @D2937, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : AGREE, 
   [COORD @D2945, AGR [COUNT @D2944, PER @D2943, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      PRT TOGETHER, LAT -, ARITY 1] : AGREE, 
   [COORD @D2947, AGR [COUNT @D2946, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, LAT -, 
      ARITY 1] : AGREE, 
   [COORD @D2949, AGR [COUNT @D2948, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, LAT -, 
      ARITY 1] : AGREE, 
   [COORD @D2953, AGR [COUNT @D2952, PER @D2951, PLU @D2950, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      PRT TOGETHER, LAT -, ARITY 1] : AGREE, 
   [COORD @D2959, PAST @D2958, 
      AGR [CASE @D2957, COUNT @D2956, PER @D2955, PLU @D2954, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, LAT -, ARITY 1] : 
   AGREE.

WORD agreed : 
   [COORD @D2969, AGR [CASE @D2968, COUNT @D2967, PER @D2966, PLU 
               @D2965, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_PP_INF, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D2974, AGR [CASE @D2973, COUNT @D2972, PER @D2971, 
            PLU @D2970, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_PP_INF, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D2979, AGR [CASE @D2978, COUNT @D2977, PER @D2976, 
            PLU @D2975, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D2984, AGR [CASE @D2983, COUNT @D2982, PER @D2981, 
            PLU @D2980, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D2989, AGR [CASE @D2988, COUNT @D2987, PER @D2986, 
            PLU @D2985, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D2994, AGR [CASE @D2993, COUNT @D2992, PER @D2991, 
            PLU @D2990, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D2999, AGR [CASE @D2998, COUNT @D2997, PER @D2996, 
            PLU @D2995, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AGREE, 
   [COORD @D3004, AGR [CASE @D3003, COUNT @D3002, PER @D3001, 
            PLU @D3000, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AGREE, 
   [COORD @D3009, AGR [CASE @D3008, COUNT @D3007, PER @D3006, 
            PLU @D3005, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : AGREE, 
   [COORD @D3014, AGR [UB @D3013, VFORM @D3012, SUBJ @D3011, FIN @D3010, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3019, 
      AGR [CASE @D3018, COUNT @D3017, PER @D3016, PLU @D3015, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3024, 
      AGR [CASE @D3023, COUNT @D3022, PER @D3021, PLU @D3020, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3029, 
      AGR [CASE @D3028, COUNT @D3027, PER @D3026, PLU @D3025, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3034, 
      AGR [CASE @D3033, COUNT @D3032, PER @D3031, PLU @D3030, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3039, 
      AGR [CASE @D3038, COUNT @D3037, PER @D3036, PLU @D3035, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3044, 
      AGR [CASE @D3043, COUNT @D3042, PER @D3041, PLU @D3040, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : AGREE, 
   [COORD @D3049, AGR [CASE @D3048, COUNT @D3047, PER @D3046, 
            PLU @D3045, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3054, AGR [CASE @D3053, COUNT @D3052, PER @D3051, 
            PLU @D3050, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3059, AGR [CASE @D3058, COUNT @D3057, PER @D3056, 
            PLU @D3055, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3064, AGR [CASE @D3063, COUNT @D3062, PER @D3061, 
            PLU @D3060, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3069, AGR [CASE @D3068, COUNT @D3067, PER @D3066, 
            PLU @D3065, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3074, AGR [CASE @D3073, COUNT @D3072, PER @D3071, 
            PLU @D3070, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3079, AGR [CASE @D3078, COUNT @D3077, PER @D3076, 
            PLU @D3075, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3084, AGR [CASE @D3083, COUNT @D3082, PER @D3081, 
            PLU @D3080, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AGREE, 
   [COORD @D3089, AGR [CASE @D3088, COUNT @D3087, PER @D3086, 
            PLU @D3085, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : AGREE, 
   [COORD @D3094, AGR [CASE @D3093, COUNT @D3092, PER @D3091, 
            PLU @D3090, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : AGREE, 
   [COORD @D3099, AGR [CASE @D3098, COUNT @D3097, PER @D3096, 
            PLU @D3095, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : AGREE.

WORD agrees : 
   [COORD @D3106, AGR [COUNT @D3105, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_PP_INF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   AGREE, 
   [COORD @D3108, AGR [COUNT @D3107, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   AGREE, 
   [COORD @D3110, AGR [COUNT @D3109, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : AGREE, 
   [COORD @D3112, AGR [COUNT @D3111, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3114, 
      AGR [COUNT @D3113, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3116, 
      AGR [COUNT @D3115, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3118, 
      AGR [COUNT @D3117, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3120, 
      AGR [COUNT @D3119, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3122, 
      AGR [COUNT @D3121, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3124, 
      AGR [COUNT @D3123, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3126, 
      AGR [COUNT @D3125, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AGREE, 
   [COORD @D3128, 
      AGR [COUNT @D3127, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   AGREE.

WORD aim : 
   [COORD @D3140, REFL @D3139, COUNT @D3138, PRD @D3137, CASE @D3136, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : AIM, 
   [COORD @D3143, AGR 
         [COUNT @D3142, PER @D3141, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, LAT -, 
      ARITY 3] : AIM, 
   [COORD @D3145, AGR [COUNT @D3144, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, LAT -, 
      ARITY 3] : AIM, 
   [COORD @D3147, AGR [COUNT @D3146, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, LAT -, 
      ARITY 3] : AIM, 
   [COORD @D3151, AGR [COUNT @D3150, PER @D3149, PLU @D3148, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, 
      LAT -, ARITY 3] : AIM, 
   [COORD @D3157, PAST @D3156, AGR [CASE @D3155, COUNT @D3154, 
            PER @D3153, PLU @D3152, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, LAT -, ARITY 3] : AIM, 
   [COORD @D3160, AGR [COUNT @D3159, PER @D3158, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : AIM, 
   [COORD @D3162, AGR [COUNT @D3161, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP AT, ARITY 2] : AIM, 
   [COORD @D3164, AGR [COUNT @D3163, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP AT, ARITY 2] : AIM, 
   [COORD @D3168, AGR [COUNT @D3167, PER @D3166, PLU @D3165, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : AIM, 
   [COORD @D3174, PAST @D3173, 
      AGR [CASE @D3172, COUNT @D3171, PER @D3170, PLU @D3169, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, PREP AT, 
      ARITY 2] : AIM, 
   [COORD @D3177, AGR [COUNT @D3176, PER @D3175, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : AIM, 
   [COORD @D3179, AGR [COUNT @D3178, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : AIM, 
   [COORD @D3181, AGR [COUNT @D3180, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : AIM, 
   [COORD @D3185, AGR [COUNT @D3184, PER @D3183, PLU @D3182, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : AIM, 
   [COORD @D3191, PAST @D3190, AGR [CASE @D3189, COUNT @D3188, 
            PER @D3187, PLU @D3186, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, ARITY 2] : AIM, 
   [COORD @D3194, 
      AGR [COUNT @D3193, PER @D3192, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      ARITY 2] : AIM, 
   [COORD @D3196, AGR [COUNT @D3195, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : AIM, 
   [COORD @D3198, AGR [COUNT @D3197, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : AIM, 
   [COORD @D3202, AGR [COUNT @D3201, PER @D3200, PLU @D3199, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : AIM, 
   [COORD @D3208, PAST @D3207, AGR [CASE @D3206, COUNT @D3205, 
            PER @D3204, PLU @D3203, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, ARITY 2] : AIM, 
   [COORD @D3211, AGR 
         [COUNT @D3210, PER @D3209, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : AIM, 
   [COORD @D3213, 
      AGR [COUNT @D3212, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : AIM, 
   [COORD @D3215, 
      AGR [COUNT @D3214, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : AIM, 
   [COORD @D3219, 
      AGR [COUNT @D3218, PER @D3217, PLU @D3216, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : AIM, 
   [COORD @D3225, PAST @D3224, AGR [CASE @D3223, COUNT @D3222, 
            PER @D3221, PLU @D3220, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_INF, LAT -, ARITY 2] : AIM, 
   [COORD @D3228, AGR [COUNT @D3227, PER @D3226, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : AIM, 
   [COORD @D3230, AGR [COUNT @D3229, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : AIM, 
   [COORD @D3232, 
      AGR [COUNT @D3231, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : AIM, 
   [COORD @D3236, 
      AGR [COUNT @D3235, PER @D3234, PLU @D3233, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : AIM, 
   [COORD @D3242, PAST @D3241, AGR [CASE @D3240, COUNT @D3239, 
            PER @D3238, PLU @D3237, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : AIM, 
   [COORD @D3245, AGR [COUNT @D3244, PER @D3243, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : AIM, 
   [COORD @D3247, AGR [COUNT @D3246, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   AIM, 
   [COORD @D3249, AGR [COUNT @D3248, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   AIM, 
   [COORD @D3253, AGR [COUNT @D3252, PER @D3251, PLU @D3250, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : AIM, 
   [COORD @D3259, PAST @D3258, AGR [CASE @D3257, COUNT @D3256, 
            PER @D3255, PLU @D3254, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : AIM, 
   [COORD @D3262, AGR [COUNT @D3261, PER @D3260, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AT, 
      LAT -, ARITY 2] : AIM, 
   [COORD @D3264, AGR [COUNT @D3263, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AT, LAT -, ARITY 2] : 
   AIM, 
   [COORD @D3266, AGR [COUNT @D3265, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AT, LAT -, ARITY 2] : 
   AIM, 
   [COORD @D3270, AGR [COUNT @D3269, PER @D3268, PLU @D3267, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AT, 
      LAT -, ARITY 2] : AIM, 
   [COORD @D3276, PAST @D3275, AGR [CASE @D3274, COUNT @D3273, 
            PER @D3272, PLU @D3271, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, LAT -, ARITY 2] : AIM, 
   [COORD @D3279, AGR [COUNT @D3278, PER @D3277, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : AIM, 
   [COORD @D3281, AGR [COUNT @D3280, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : AIM, 
   [COORD @D3283, 
      AGR [COUNT @D3282, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : AIM, 
   [COORD @D3287, 
      AGR [COUNT @D3286, PER @D3285, PLU @D3284, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : AIM, 
   [COORD @D3293, PAST @D3292, AGR [CASE @D3291, COUNT @D3290, 
            PER @D3289, PLU @D3288, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : AIM.

WORD aimed : 
   [COORD @D3303, AGR [CASE @D3302, COUNT @D3301, PER @D3300, PLU 
               @D3299, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3308, AGR [CASE @D3307, COUNT @D3306, PER @D3305, 
            PLU @D3304, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3313, AGR [CASE @D3312, COUNT @D3311, PER @D3310, 
            PLU @D3309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AIM, 
   [COORD @D3318, AGR [CASE @D3317, COUNT @D3316, PER @D3315, 
            PLU @D3314, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3323, AGR [CASE @D3322, COUNT @D3321, PER @D3320, 
            PLU @D3319, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AIM, 
   [COORD @D3328, AGR [CASE @D3327, COUNT @D3326, PER @D3325, 
            PLU @D3324, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3333, AGR [CASE @D3332, COUNT @D3331, PER @D3330, 
            PLU @D3329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3338, AGR [CASE @D3337, COUNT @D3336, PER @D3335, 
            PLU @D3334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AIM, 
   [COORD @D3343, AGR [CASE @D3342, COUNT @D3341, PER @D3340, 
            PLU @D3339, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3348, AGR [CASE @D3347, COUNT @D3346, PER @D3345, 
            PLU @D3344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AIM, 
   [COORD @D3353, AGR [CASE @D3352, COUNT @D3351, PER @D3350, 
            PLU @D3349, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3358, AGR [CASE @D3357, COUNT @D3356, PER @D3355, 
            PLU @D3354, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3363, AGR [CASE @D3362, COUNT @D3361, PER @D3360, 
            PLU @D3359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3368, AGR [CASE @D3367, COUNT @D3366, PER @D3365, 
            PLU @D3364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : AIM, 
   [COORD @D3373, AGR [CASE @D3372, COUNT @D3371, PER @D3370, 
            PLU @D3369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : AIM, 
   [COORD @D3378, AGR [CASE @D3377, COUNT @D3376, PER @D3375, 
            PLU @D3374, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : AIM, 
   [COORD @D3383, AGR [CASE @D3382, COUNT @D3381, PER @D3380, 
            PLU @D3379, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3388, AGR [CASE @D3387, COUNT @D3386, PER @D3385, 
            PLU @D3384, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AIM, 
   [COORD @D3393, AGR [CASE @D3392, COUNT @D3391, PER @D3390, 
            PLU @D3389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3398, AGR [CASE @D3397, COUNT @D3396, PER @D3395, 
            PLU @D3394, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AIM, 
   [COORD @D3403, AGR [CASE @D3402, COUNT @D3401, PER @D3400, 
            PLU @D3399, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3408, AGR [CASE @D3407, COUNT @D3406, PER @D3405, 
            PLU @D3404, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : AIM.

WORD aiming : 
   [COORD @D3423, PRD @D3422, AGR [CASE @D3421, COUNT @D3420, PER 
               @D3419, PLU @D3418, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3429, PRD @D3428, 
      AGR [CASE @D3427, COUNT @D3426, PER @D3425, PLU @D3424, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : AIM, 
   
   [COORD @D3435, PRD @D3434, AGR [CASE @D3433, COUNT @D3432, PER @D3431, 
            PLU @D3430, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3441, PRD @D3440, AGR [CASE @D3439, COUNT @D3438, 
            PER @D3437, PLU @D3436, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3447, PRD @D3446, 
      AGR [CASE @D3445, COUNT @D3444, PER @D3443, PLU @D3442, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3453, PRD @D3452, 
      AGR [CASE @D3451, COUNT @D3450, PER @D3449, PLU @D3448, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : AIM, 
   [COORD @D3459, PRD @D3458, 
      AGR [CASE @D3457, COUNT @D3456, PER @D3455, PLU @D3454, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : AIM, 
   
   [COORD @D3465, PRD @D3464, AGR [CASE @D3463, COUNT @D3462, PER @D3461, 
            PLU @D3460, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : AIM, 
   [COORD @D3471, PRD @D3470, AGR [CASE @D3469, COUNT @D3468, 
            PER @D3467, PLU @D3466, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : AIM.

WORD aims : 
   [COORD @D3481, DEMON @D3480, REFL @D3479, PRD @D3478, CASE @D3477, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : AIM, 
   [COORD @D3483, 
      AGR [COUNT @D3482, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3485, 
      AGR [COUNT @D3484, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3487, 
      AGR [COUNT @D3486, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3489, 
      AGR [COUNT @D3488, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3491, 
      AGR [COUNT @D3490, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3493, 
      AGR [COUNT @D3492, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3495, 
      AGR [COUNT @D3494, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3497, 
      AGR [COUNT @D3496, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM, 
   [COORD @D3499, 
      AGR [COUNT @D3498, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AIM.

WORD alarm : 
   [COORD @D3507, REFL @D3506, COUNT @D3505, PRD @D3504, CASE @D3503, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ALARM, 
   [COORD @D3510, 
      AGR [COUNT @D3509, PER @D3508, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   ALARM, 
   [COORD @D3512, AGR [COUNT @D3511, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   ALARM, 
   [COORD @D3514, AGR [COUNT @D3513, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   ALARM, 
   [COORD @D3518, AGR [COUNT @D3517, PER @D3516, PLU @D3515, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ALARM, 
   [COORD @D3524, PAST @D3523, AGR [CASE @D3522, COUNT @D3521, 
            PER @D3520, PLU @D3519, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ALARM.

WORD alarmed : 
   [COORD @D3534, AGR [CASE @D3533, COUNT @D3532, PER @D3531, 
            PLU @D3530, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ALARM, 
   [COORD @D3539, AGR [CASE @D3538, COUNT @D3537, PER @D3536, 
            PLU @D3535, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ALARM, 
   [COORD @D3544, AGR [CASE @D3543, COUNT @D3542, PER @D3541, 
            PLU @D3540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ALARM.

WORD alarming : 
   [COORD @D3559, PRD @D3558, AGR [CASE @D3557, COUNT @D3556, 
            PER @D3555, PLU @D3554, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ALARM.

WORD alarms : 
   [COORD @D3569, DEMON @D3568, REFL @D3567, PRD @D3566, CASE @D3565, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ALARM, 
   [COORD @D3571, 
      AGR [COUNT @D3570, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALARM.

WORD allow : 
   [COORD @D3578, AGR [COUNT @D3577, PER @D3576, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, 
      ARITY 3] : ALLOW, 
   [COORD @D3580, AGR [COUNT @D3579, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, ARITY 3] : ALLOW, 
   [COORD @D3582, 
      AGR [COUNT @D3581, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, ARITY 3] : ALLOW, 
   [COORD @D3586, 
      AGR [COUNT @D3585, PER @D3584, PLU @D3583, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, 
      ARITY 3] : ALLOW, 
   [COORD @D3592, PAST @D3591, AGR [CASE @D3590, COUNT @D3589, 
            PER @D3588, PLU @D3587, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_NP, LAT -, ARITY 3] : ALLOW, 
   [COORD @D3595, AGR [COUNT @D3594, PER @D3593, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, LAT -, 
      ARITY 3] : ALLOW, 
   [COORD @D3597, AGR [COUNT @D3596, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, LAT -, ARITY 3] : ALLOW, 
   
   [COORD @D3599, AGR [COUNT @D3598, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, LAT -, ARITY 3] : ALLOW, 
   
   [COORD @D3603, AGR [COUNT @D3602, PER @D3601, PLU @D3600, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, LAT -, 
      ARITY 3] : ALLOW, 
   [COORD @D3609, PAST @D3608, AGR [CASE @D3607, COUNT @D3606, 
            PER @D3605, PLU @D3604, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_LOC, LAT -, ARITY 3] : ALLOW, 
   [COORD @D3612, AGR [COUNT @D3611, PER @D3610, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      LAT -, ARITY 3] : ALLOW, 
   [COORD @D3614, AGR [COUNT @D3613, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, LAT -, 
      ARITY 3] : ALLOW, 
   [COORD @D3616, AGR [COUNT @D3615, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, LAT -, 
      ARITY 3] : ALLOW, 
   [COORD @D3620, AGR [COUNT @D3619, PER @D3618, PLU @D3617, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      LAT -, ARITY 3] : ALLOW, 
   [COORD @D3626, PAST @D3625, AGR [CASE @D3624, COUNT @D3623, 
            PER @D3622, PLU @D3621, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, LAT -, ARITY 3] : ALLOW, 
   [COORD @D3629, AGR [COUNT @D3628, PER @D3627, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP FOR, ARITY 2] : ALLOW, 
   [COORD @D3631, AGR [COUNT @D3630, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, PREP FOR, 
      ARITY 2] : ALLOW, 
   [COORD @D3633, AGR [COUNT @D3632, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, PREP FOR, 
      ARITY 2] : ALLOW, 
   [COORD @D3637, AGR [COUNT @D3636, PER @D3635, PLU @D3634, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP FOR, ARITY 2] : ALLOW, 
   [COORD @D3643, PAST @D3642, AGR [CASE @D3641, COUNT @D3640, 
            PER @D3639, PLU @D3638, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, PREP FOR, ARITY 2] : ALLOW, 
   [COORD @D3646, 
      AGR [COUNT @D3645, PER @D3644, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, PREP FOR, 
      ARITY 2] : ALLOW, 
   [COORD @D3648, AGR [COUNT @D3647, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP FOR, ARITY 2] : ALLOW, 
   [COORD @D3650, AGR [COUNT @D3649, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP FOR, ARITY 2] : ALLOW, 
   [COORD @D3654, AGR [COUNT @D3653, PER @D3652, PLU @D3651, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : ALLOW, 
   [COORD @D3660, PAST @D3659, 
      AGR [CASE @D3658, COUNT @D3657, PER @D3656, PLU @D3655, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, PREP FOR, 
      ARITY 2] : ALLOW, 
   [COORD @D3663, AGR [COUNT @D3662, PER @D3661, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ALLOW, 
   [COORD @D3665, AGR [COUNT @D3664, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ALLOW, 
   [COORD @D3667, AGR [COUNT @D3666, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ALLOW, 
   [COORD @D3671, AGR [COUNT @D3670, PER @D3669, PLU @D3668, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : ALLOW, 
   [COORD @D3677, PAST @D3676, AGR [CASE @D3675, COUNT @D3674, 
            PER @D3673, PLU @D3672, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, ARITY 2] : ALLOW, 
   [COORD @D3680, 
      AGR [COUNT @D3679, PER @D3678, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : ALLOW, 
   [COORD @D3682, AGR [COUNT @D3681, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3684, AGR [COUNT @D3683, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3688, AGR [COUNT @D3687, PER @D3686, PLU @D3685, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3694, PAST @D3693, AGR [CASE @D3692, COUNT @D3691, 
            PER @D3690, PLU @D3689, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3697, 
      AGR [COUNT @D3696, PER @D3695, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_INF, 
      PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3699, AGR [COUNT @D3698, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3701, AGR [COUNT @D3700, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3705, AGR [COUNT @D3704, PER @D3703, PLU @D3702, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 2] : ALLOW, 
   [COORD @D3711, PAST @D3710, 
      AGR [CASE @D3709, COUNT @D3708, PER @D3707, PLU @D3706, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_INF, PFORM FOR, 
      ARITY 2] : ALLOW, 
   [COORD @D3714, AGR [COUNT @D3713, PER @D3712, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, ARITY 2] : ALLOW, 
   [COORD @D3716, 
      AGR [COUNT @D3715, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, 
      PFORM FOR, ORDER PRENP, ARITY 2] : ALLOW, 
   [COORD @D3718, AGR [COUNT @D3717, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, ARITY 2] : ALLOW, 
   [COORD @D3722, 
      AGR [COUNT @D3721, PER @D3720, PLU @D3719, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, ARITY 2] : ALLOW, 
   [COORD @D3728, PAST @D3727, 
      AGR [CASE @D3726, COUNT @D3725, PER @D3724, PLU @D3723, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, 
      ORDER PRENP, ARITY 2] : ALLOW, 
   [COORD @D3731, AGR [COUNT @D3730, PER @D3729, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3733, AGR [COUNT @D3732, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3735, 
      AGR [COUNT @D3734, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3739, 
      AGR [COUNT @D3738, PER @D3737, PLU @D3736, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3745, PAST @D3744, AGR [CASE @D3743, COUNT @D3742, 
            PER @D3741, PLU @D3740, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3748, AGR [COUNT @D3747, PER @D3746, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3750, AGR [COUNT @D3749, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, ARITY 2] : 
   ALLOW, 
   [COORD @D3752, AGR [COUNT @D3751, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, ARITY 2] : 
   ALLOW, 
   [COORD @D3756, AGR [COUNT @D3755, PER @D3754, PLU @D3753, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3762, PAST @D3761, AGR [CASE @D3760, COUNT @D3759, 
            PER @D3758, PLU @D3757, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3765, AGR [COUNT @D3764, PER @D3763, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3767, AGR [COUNT @D3766, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, ARITY 2] : 
   ALLOW, 
   [COORD @D3769, AGR [COUNT @D3768, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, ARITY 2] : 
   ALLOW, 
   [COORD @D3773, AGR [COUNT @D3772, PER @D3771, PLU @D3770, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3779, PAST @D3778, AGR [CASE @D3777, COUNT @D3776, 
            PER @D3775, PLU @D3774, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3782, AGR [COUNT @D3781, PER @D3780, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3784, AGR [COUNT @D3783, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, ARITY 2] : 
   ALLOW, 
   [COORD @D3786, AGR [COUNT @D3785, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, ARITY 2] : 
   ALLOW, 
   [COORD @D3790, AGR [COUNT @D3789, PER @D3788, PLU @D3787, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3796, PAST @D3795, AGR [CASE @D3794, COUNT @D3793, 
            PER @D3792, PLU @D3791, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3799, AGR [COUNT @D3798, PER @D3797, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3801, AGR [COUNT @D3800, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3803, 
      AGR [COUNT @D3802, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ALLOW, 
   [COORD @D3807, 
      AGR [COUNT @D3806, PER @D3805, PLU @D3804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ALLOW, 
   [COORD @D3813, PAST @D3812, AGR [CASE @D3811, COUNT @D3810, 
            PER @D3809, PLU @D3808, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ALLOW.

WORD allowed : 
   [COORD @D3823, AGR [CASE @D3822, COUNT @D3821, PER @D3820, 
            PLU @D3819, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ALLOW, 
   [COORD @D3828, AGR [CASE @D3827, COUNT @D3826, PER @D3825, 
            PLU @D3824, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ALLOW, 
   [COORD @D3833, AGR [CASE @D3832, COUNT @D3831, PER @D3830, 
            PLU @D3829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ALLOW, 
   [COORD @D3838, AGR [CASE @D3837, COUNT @D3836, PER @D3835, 
            PLU @D3834, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ALLOW, 
   [COORD @D3843, AGR [CASE @D3842, COUNT @D3841, PER @D3840, 
            PLU @D3839, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ALLOW, 
   [COORD @D3848, AGR [CASE @D3847, COUNT @D3846, PER @D3845, 
            PLU @D3844, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ALLOW, 
   [COORD @D3853, AGR [CASE @D3852, COUNT @D3851, PER @D3850, 
            PLU @D3849, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ALLOW, 
   [COORD @D3858, AGR [CASE @D3857, COUNT @D3856, PER @D3855, 
            PLU @D3854, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3863, AGR [CASE @D3862, COUNT @D3861, PER @D3860, 
            PLU @D3859, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3868, AGR [CASE @D3867, COUNT @D3866, PER @D3865, 
            PLU @D3864, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3873, AGR [CASE @D3872, COUNT @D3871, PER @D3870, 
            PLU @D3869, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3878, AGR [CASE @D3877, COUNT @D3876, PER @D3875, 
            PLU @D3874, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3883, AGR [CASE @D3882, COUNT @D3881, PER @D3880, 
            PLU @D3879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3888, AGR [CASE @D3887, COUNT @D3886, PER @D3885, 
            PLU @D3884, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OF, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ALLOW, 
   [COORD @D3893, AGR [CASE @D3892, COUNT @D3891, PER @D3890, 
            PLU @D3889, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3898, AGR [CASE @D3897, COUNT @D3896, PER @D3895, 
            PLU @D3894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3903, AGR [CASE @D3902, COUNT @D3901, PER @D3900, 
            PLU @D3899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3908, AGR [CASE @D3907, COUNT @D3906, PER @D3905, 
            PLU @D3904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3913, AGR [CASE @D3912, COUNT @D3911, PER @D3910, 
            PLU @D3909, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ALLOW, 
   [COORD @D3918, AGR [CASE @D3917, COUNT @D3916, PER @D3915, 
            PLU @D3914, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE PVERB_OR, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3923, AGR [CASE @D3922, COUNT @D3921, PER @D3920, 
            PLU @D3919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_INF, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3928, AGR [CASE @D3927, COUNT @D3926, PER @D3925, 
            PLU @D3924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_INF, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3933, AGR [CASE @D3932, COUNT @D3931, PER @D3930, 
            PLU @D3929, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OR, PFORM FOR, ORDER PRENP, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3938, AGR [CASE @D3937, COUNT @D3936, PER @D3935, 
            PLU @D3934, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3943, 
      AGR [CASE @D3942, COUNT @D3941, PER @D3940, PLU @D3939, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3948, AGR [UB @D3947, VFORM @D3946, SUBJ @D3945, FIN @D3944, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3953, 
      AGR [CASE @D3952, COUNT @D3951, PER @D3950, PLU @D3949, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3958, 
      AGR [CASE @D3957, COUNT @D3956, PER @D3955, PLU @D3954, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3963, 
      AGR [CASE @D3962, COUNT @D3961, PER @D3960, PLU @D3959, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT OC_NP, CONJ NULL, 
      SUBTYPE RAIS, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3968, 
      AGR [CASE @D3967, COUNT @D3966, PER @D3965, PLU @D3964, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3973, 
      AGR [CASE @D3972, COUNT @D3971, PER @D3970, PLU @D3969, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3979, 
      AGR [CASE @D3978, NFORM @D3977, COUNT @D3976, PER @D3975, 
            PLU @D3974, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ALLOW, 
   [COORD @D3984, AGR [UB @D3983, VFORM @D3982, SUBJ @D3981, FIN @D3980, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3989, 
      AGR [CASE @D3988, COUNT @D3987, PER @D3986, PLU @D3985, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3994, 
      AGR [CASE @D3993, COUNT @D3992, PER @D3991, PLU @D3990, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D3999, 
      AGR [CASE @D3998, COUNT @D3997, PER @D3996, PLU @D3995, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4004, 
      AGR [CASE @D4003, COUNT @D4002, PER @D4001, PLU @D4000, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4010, 
      AGR [CASE @D4009, NFORM @D4008, COUNT @D4007, PER @D4006, 
            PLU @D4005, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ALLOW, 
   [COORD @D4015, AGR [UB @D4014, VFORM @D4013, SUBJ @D4012, FIN @D4011, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4020, 
      AGR [CASE @D4019, COUNT @D4018, PER @D4017, PLU @D4016, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4025, 
      AGR [CASE @D4024, COUNT @D4023, PER @D4022, PLU @D4021, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4030, 
      AGR [CASE @D4029, COUNT @D4028, PER @D4027, PLU @D4026, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ALLOW.

WORD allowing : 
   [COORD @D4043, PRD @D4042, AGR [CASE @D4041, COUNT @D4040, 
            PER @D4039, PLU @D4038, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4049, PRD @D4048, AGR 
         [CASE @D4047, COUNT @D4046, PER @D4045, PLU @D4044, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4055, PRD @D4054, 
      AGR [CASE @D4053, COUNT @D4052, PER @D4051, PLU @D4050, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ALLOW, 
   [COORD @D4061, PRD @D4060, AGR [CASE @D4059, COUNT @D4058, PER 
               @D4057, PLU @D4056, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4067, PRD @D4066, 
      AGR [CASE @D4065, COUNT @D4064, PER @D4063, PLU @D4062, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ALLOW, 
   [COORD @D4073, PRD @D4072, AGR [CASE @D4071, COUNT @D4070, PER 
               @D4069, PLU @D4068, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4079, PRD @D4078, 
      AGR [CASE @D4077, COUNT @D4076, PER @D4075, PLU @D4074, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ALLOW, 
   [COORD @D4085, PRD @D4084, AGR [CASE @D4083, COUNT @D4082, 
            PER @D4081, PLU @D4080, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_INF, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4091, PRD @D4090, 
      AGR [CASE @D4089, COUNT @D4088, PER @D4087, PLU @D4086, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4097, PRD @D4096, AGR 
         [CASE @D4095, COUNT @D4094, PER @D4093, PLU @D4092, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4103, PRD @D4102, 
      AGR [CASE @D4101, COUNT @D4100, PER @D4099, PLU @D4098, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4109, PRD @D4108, 
      AGR [CASE @D4107, COUNT @D4106, PER @D4105, PLU @D4104, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4115, PRD @D4114, 
      AGR [CASE @D4113, COUNT @D4112, PER @D4111, PLU @D4110, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4121, PRD @D4120, 
      AGR [CASE @D4119, COUNT @D4118, PER @D4117, PLU @D4116, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ALLOW.

WORD allows : 
   [COORD @D4128, AGR [COUNT @D4127, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4130, 
      AGR [COUNT @D4129, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4132, 
      AGR [COUNT @D4131, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4134, 
      AGR [COUNT @D4133, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4136, 
      AGR [COUNT @D4135, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4138, 
      AGR [COUNT @D4137, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4140, 
      AGR [COUNT @D4139, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4142, 
      AGR [COUNT @D4141, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_INF, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ALLOW, 
   [COORD @D4144, AGR [COUNT @D4143, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FOR, ORDER PRENP, AUX -, 
      INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4146, AGR [COUNT @D4145, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4148, 
      AGR [COUNT @D4147, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4150, 
      AGR [COUNT @D4149, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4152, 
      AGR [COUNT @D4151, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW, 
   [COORD @D4154, 
      AGR [COUNT @D4153, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ALLOW.

WORD amnesties : 
   [COORD @D4165, DEMON @D4164, REFL @D4163, PRD @D4162, CASE @D4161, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : AMNESTY.

WORD amnesty : 
   [COORD @D4175, REFL @D4174, COUNT @D4173, PRD @D4172, CASE @D4171, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : AMNESTY.

WORD amount : 
   [COORD @D4183, REFL @D4182, PRD @D4181, CASE @D4180, FIX NOT, BAR 0, 
      SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, COUNT +] : AMOUNT, 
   [COORD @D4186, AGR [COUNT @D4185, PER @D4184, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : AMOUNT, 
   [COORD @D4188, AGR [COUNT @D4187, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : AMOUNT, 
   [COORD @D4190, AGR [COUNT @D4189, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : AMOUNT, 
   [COORD @D4194, AGR [COUNT @D4193, PER @D4192, PLU @D4191, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : AMOUNT, 
   [COORD @D4200, PAST @D4199, AGR [CASE @D4198, COUNT @D4197, 
            PER @D4196, PLU @D4195, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM TO, ARITY 2] : AMOUNT.

WORD amounted : 
   [COORD @D4211, AGR [CASE @D4210, COUNT @D4209, PER @D4208, 
            PLU @D4207, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : AMOUNT, 
   [COORD @D4216, AGR [CASE @D4215, COUNT @D4214, PER @D4213, 
            PLU @D4212, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : AMOUNT.

WORD amounting : 
   [COORD @D4232, PRD @D4231, AGR [CASE @D4230, COUNT @D4229, 
            PER @D4228, PLU @D4227, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : AMOUNT.

WORD amounts : 
   [COORD @D4243, DEMON @D4242, REFL @D4241, PRD @D4240, CASE @D4239, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : AMOUNT, 
   [COORD @D4245, 
      AGR [COUNT @D4244, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : AMOUNT.

WORD anger : 
   [COORD @D4254, REFL @D4253, PRD @D4252, CASE @D4251, FIX NOT, BAR 0, 
      SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : ANGER, 
   [COORD @D4257, AGR [COUNT @D4256, PER @D4255, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ANGER, 
   [COORD @D4259, AGR [COUNT @D4258, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   ANGER, 
   [COORD @D4261, AGR [COUNT @D4260, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   ANGER, 
   [COORD @D4265, AGR [COUNT @D4264, PER @D4263, PLU @D4262, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ANGER, 
   [COORD @D4271, PAST @D4270, AGR [CASE @D4269, COUNT @D4268, 
            PER @D4267, PLU @D4266, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ANGER, 
   [COORD @D4274, AGR [COUNT @D4273, PER @D4272, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ANGER, 
   [COORD @D4276, AGR [COUNT @D4275, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   ANGER, 
   [COORD @D4278, AGR [COUNT @D4277, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   ANGER, 
   [COORD @D4282, AGR [COUNT @D4281, PER @D4280, PLU @D4279, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ANGER, 
   [COORD @D4288, PAST @D4287, AGR [CASE @D4286, COUNT @D4285, 
            PER @D4284, PLU @D4283, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ANGER.

WORD angered : 
   [COORD @D4300, AGR [CASE @D4299, COUNT @D4298, PER @D4297, 
            PLU @D4296, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ANGER, 
   [COORD @D4305, AGR [CASE @D4304, COUNT @D4303, PER @D4302, 
            PLU @D4301, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ANGER, 
   [COORD @D4310, AGR [CASE @D4309, COUNT @D4308, PER @D4307, 
            PLU @D4306, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ANGER, 
   [COORD @D4315, AGR [CASE @D4314, COUNT @D4313, PER @D4312, 
            PLU @D4311, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANGER, 
   [COORD @D4320, AGR [CASE @D4319, COUNT @D4318, PER @D4317, 
            PLU @D4316, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ANGER.

WORD angering : 
   [COORD @D4335, PRD @D4334, AGR [CASE @D4333, COUNT @D4332, 
            PER @D4331, PLU @D4330, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ANGER, 
   [COORD @D4341, PRD @D4340, AGR 
         [CASE @D4339, COUNT @D4338, PER @D4337, PLU @D4336, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANGER.

WORD angers : 
   [COORD @D4350, AGR [COUNT @D4349, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANGER, 
   [COORD @D4352, 
      AGR [COUNT @D4351, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANGER.

WORD announce : 
   [COORD @D4361, AGR [COUNT @D4360, PER @D4359, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, 
      PFORM TO, LAT -, ARITY 3] : ANNOUNCE, 
   [COORD @D4363, AGR [COUNT @D4362, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, LAT -, 
      ARITY 3] : ANNOUNCE, 
   [COORD @D4365, AGR [COUNT @D4364, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, LAT -, 
      ARITY 3] : ANNOUNCE, 
   [COORD @D4369, AGR [COUNT @D4368, PER @D4367, PLU @D4366, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, 
      PFORM TO, LAT -, ARITY 3] : ANNOUNCE, 
   [COORD @D4375, PAST @D4374, AGR 
         [CASE @D4373, COUNT @D4372, PER @D4371, PLU @D4370, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, LAT -, ARITY 3] : 
   ANNOUNCE, 
   [COORD @D4378, AGR [COUNT @D4377, PER @D4376, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ANNOUNCE, 
   [COORD @D4380, AGR [COUNT @D4379, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ANNOUNCE, 
   [COORD @D4382, AGR [COUNT @D4381, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ANNOUNCE, 
   [COORD @D4386, AGR [COUNT @D4385, PER @D4384, PLU @D4383, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ANNOUNCE, 
   [COORD @D4392, PAST @D4391, AGR [CASE @D4390, COUNT @D4389, 
            PER @D4388, PLU @D4387, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, LAT -, ARITY 3] : ANNOUNCE, 
   [COORD @D4395, AGR 
         [COUNT @D4394, PER @D4393, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : 
   ANNOUNCE, 
   [COORD @D4397, AGR [COUNT @D4396, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : 
   ANNOUNCE, 
   [COORD @D4399, AGR [COUNT @D4398, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : 
   ANNOUNCE, 
   [COORD @D4403, AGR [COUNT @D4402, PER @D4401, PLU @D4400, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ANNOUNCE, 
   [COORD @D4409, PAST @D4408, AGR [CASE @D4407, COUNT @D4406, 
            PER @D4405, PLU @D4404, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : ANNOUNCE, 
   [COORD @D4412, AGR [COUNT @D4411, PER @D4410, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ANNOUNCE, 
   [COORD @D4414, AGR [COUNT @D4413, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ANNOUNCE, 
   [COORD @D4416, 
      AGR [COUNT @D4415, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ANNOUNCE, 
   [COORD @D4420, 
      AGR [COUNT @D4419, PER @D4418, PLU @D4417, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ANNOUNCE, 
   [COORD @D4426, PAST @D4425, AGR [CASE @D4424, COUNT @D4423, 
            PER @D4422, PLU @D4421, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ANNOUNCE.

WORD announced : 
   [COORD @D4438, AGR [CASE @D4437, COUNT @D4436, PER @D4435, 
            PLU @D4434, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4443, AGR [CASE @D4442, COUNT @D4441, PER @D4440, 
            PLU @D4439, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4448, AGR [CASE @D4447, COUNT @D4446, PER @D4445, 
            PLU @D4444, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4453, AGR [CASE @D4452, COUNT @D4451, PER @D4450, 
            PLU @D4449, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4458, AGR [CASE @D4457, COUNT @D4456, PER @D4455, 
            PLU @D4454, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4463, AGR [CASE @D4462, COUNT @D4461, PER @D4460, 
            PLU @D4459, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4468, AGR [CASE @D4467, COUNT @D4466, PER @D4465, 
            PLU @D4464, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4473, AGR [UB @D4472, VFORM @D4471, SUBJ @D4470, FIN @D4469, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ANNOUNCE, 
   [COORD @D4478, AGR [CASE @D4477, COUNT @D4476, PER @D4475, 
            PLU @D4474, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ANNOUNCE, 
   [COORD @D4483, AGR [CASE @D4482, COUNT @D4481, PER @D4480, 
            PLU @D4479, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ANNOUNCE, 
   [COORD @D4488, AGR [CASE @D4487, COUNT @D4486, PER @D4485, 
            PLU @D4484, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ANNOUNCE.

WORD announces : 
   [COORD @D4497, AGR [COUNT @D4496, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ANNOUNCE, 
   [COORD @D4499, AGR [COUNT @D4498, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANNOUNCE, 
   
   [COORD @D4501, AGR [COUNT @D4500, NFORM NORM, PLU -, PER 3, CASE NOM, N 
            +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4503, 
      AGR [COUNT @D4502, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANNOUNCE.

WORD announcing : 
   [COORD @D4516, PRD @D4515, AGR [CASE @D4514, COUNT @D4513, 
            PER @D4512, PLU @D4511, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4522, PRD @D4521, 
      AGR [CASE @D4520, COUNT @D4519, PER @D4518, PLU @D4517, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ANNOUNCE, 
   [COORD @D4528, PRD @D4527, AGR [CASE @D4526, COUNT @D4525, 
            PER @D4524, PLU @D4523, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ANNOUNCE, 
   [COORD @D4534, PRD @D4533, 
      AGR [CASE @D4532, COUNT @D4531, PER @D4530, PLU @D4529, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANNOUNCE.

WORD answer : 
   [COORD @D4544, REFL @D4543, COUNT @D4542, PRD @D4541, CASE @D4540, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ANSWER, 
   [COORD @D4549, REFL @D4548, COUNT @D4547, PRD @D4546, CASE @D4545, 
      FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO] : ANSWER, 
   [COORD @D4552, 
      AGR [COUNT @D4551, PER @D4550, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   ANSWER, 
   [COORD @D4554, AGR [COUNT @D4553, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   ANSWER, 
   [COORD @D4556, AGR [COUNT @D4555, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   ANSWER, 
   [COORD @D4560, AGR [COUNT @D4559, PER @D4558, PLU @D4557, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : ANSWER, 
   [COORD @D4566, PAST @D4565, AGR [CASE @D4564, COUNT @D4563, 
            PER @D4562, PLU @D4561, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : ANSWER, 
   [COORD @D4569, AGR [COUNT @D4568, PER @D4567, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : ANSWER, 
   [COORD @D4571, AGR [COUNT @D4570, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : ANSWER, 
   [COORD @D4573, AGR [COUNT @D4572, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : ANSWER, 
   [COORD @D4577, AGR [COUNT @D4576, PER @D4575, PLU @D4574, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : ANSWER, 
   [COORD @D4583, PAST @D4582, 
      AGR [CASE @D4581, COUNT @D4580, PER @D4579, PLU @D4578, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : ANSWER, 
   [COORD @D4586, AGR [COUNT @D4585, PER @D4584, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM FOR_TO, ARITY 3] : ANSWER, 
   [COORD @D4588, AGR [COUNT @D4587, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_TO, ARITY 3] : ANSWER, 
   [COORD @D4590, AGR [COUNT @D4589, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_TO, ARITY 3] : ANSWER, 
   [COORD @D4594, AGR [COUNT @D4593, PER @D4592, PLU @D4591, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM FOR_TO, ARITY 3] : ANSWER, 
   [COORD @D4600, PAST @D4599, 
      AGR [CASE @D4598, COUNT @D4597, PER @D4596, PLU @D4595, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, 
      ARITY 3] : ANSWER, 
   [COORD @D4603, AGR [COUNT @D4602, PER @D4601, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ANSWER, 
   [COORD @D4605, AGR [COUNT @D4604, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : ANSWER, 
   [COORD @D4607, AGR [COUNT @D4606, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : ANSWER, 
   [COORD @D4611, AGR [COUNT @D4610, PER @D4609, PLU @D4608, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ANSWER, 
   [COORD @D4617, PAST @D4616, 
      AGR [CASE @D4615, COUNT @D4614, PER @D4613, PLU @D4612, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, ARITY 3] : 
   ANSWER, 
   [COORD @D4620, AGR [COUNT @D4619, PER @D4618, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ANSWER, 
   [COORD @D4622, AGR [COUNT @D4621, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   ANSWER, 
   [COORD @D4624, AGR [COUNT @D4623, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   ANSWER, 
   [COORD @D4628, AGR [COUNT @D4627, PER @D4626, PLU @D4625, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ANSWER, 
   [COORD @D4634, PAST @D4633, AGR [CASE @D4632, COUNT @D4631, 
            PER @D4630, PLU @D4629, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : ANSWER, 
   [COORD @D4637, AGR [COUNT @D4636, PER @D4635, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ANSWER, 
   [COORD @D4639, AGR [COUNT @D4638, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   ANSWER, 
   [COORD @D4641, AGR [COUNT @D4640, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   ANSWER, 
   [COORD @D4645, AGR [COUNT @D4644, PER @D4643, PLU @D4642, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ANSWER, 
   [COORD @D4651, PAST @D4650, AGR [CASE @D4649, COUNT @D4648, 
            PER @D4647, PLU @D4646, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ANSWER, 
   [COORD @D4654, AGR [COUNT @D4653, PER @D4652, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : ANSWER, 
   [COORD @D4656, AGR [COUNT @D4655, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : ANSWER, 
   [COORD @D4658, AGR [COUNT @D4657, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : ANSWER, 
   [COORD @D4662, AGR [COUNT @D4661, PER @D4660, PLU @D4659, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : ANSWER, 
   [COORD @D4668, PAST @D4667, AGR [CASE @D4666, COUNT @D4665, 
            PER @D4664, PLU @D4663, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM WITH, ARITY 2] : ANSWER, 
   [COORD @D4671, 
      AGR [COUNT @D4670, PER @D4669, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : ANSWER, 
   [COORD @D4673, AGR [COUNT @D4672, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : ANSWER, 
   [COORD @D4675, AGR [COUNT @D4674, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : ANSWER, 
   [COORD @D4679, AGR [COUNT @D4678, PER @D4677, PLU @D4676, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : ANSWER, 
   [COORD @D4685, PAST @D4684, AGR [CASE @D4683, COUNT @D4682, 
            PER @D4681, PLU @D4680, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM TO, ARITY 2] : ANSWER, 
   [COORD @D4688, 
      AGR [COUNT @D4687, PER @D4686, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : ANSWER, 
   [COORD @D4690, AGR [COUNT @D4689, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ANSWER, 
   [COORD @D4692, AGR [COUNT @D4691, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ANSWER, 
   [COORD @D4696, AGR [COUNT @D4695, PER @D4694, PLU @D4693, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ANSWER, 
   [COORD @D4702, PAST @D4701, AGR [CASE @D4700, COUNT @D4699, 
            PER @D4698, PLU @D4697, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, ARITY 2] : ANSWER, 
   [COORD @D4705, 
      AGR [COUNT @D4704, PER @D4703, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT BACK, 
      ARITY 2] : ANSWER, 
   [COORD @D4707, AGR [COUNT @D4706, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT BACK, 
      ARITY 2] : ANSWER, 
   [COORD @D4709, AGR [COUNT @D4708, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT BACK, 
      ARITY 2] : ANSWER, 
   [COORD @D4713, AGR [COUNT @D4712, PER @D4711, PLU @D4710, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : ANSWER, 
   [COORD @D4719, PAST @D4718, AGR [CASE @D4717, COUNT @D4716, 
            PER @D4715, PLU @D4714, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, ARITY 2] : ANSWER, 
   [COORD @D4722, AGR [COUNT @D4721, PER @D4720, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ANSWER, 
   [COORD @D4724, AGR [COUNT @D4723, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   ANSWER, 
   [COORD @D4726, AGR [COUNT @D4725, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   ANSWER, 
   [COORD @D4730, AGR [COUNT @D4729, PER @D4728, PLU @D4727, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ANSWER, 
   [COORD @D4736, PAST @D4735, AGR [CASE @D4734, COUNT @D4733, 
            PER @D4732, PLU @D4731, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ANSWER, 
   [COORD @D4739, AGR [COUNT @D4738, PER @D4737, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : ANSWER, 
   [COORD @D4741, AGR [COUNT @D4740, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, 
      ARITY 1] : ANSWER, 
   [COORD @D4743, AGR [COUNT @D4742, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, 
      ARITY 1] : ANSWER, 
   [COORD @D4747, AGR [COUNT @D4746, PER @D4745, PLU @D4744, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : ANSWER, 
   [COORD @D4753, PAST @D4752, 
      AGR [CASE @D4751, COUNT @D4750, PER @D4749, PLU @D4748, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, ARITY 1] : 
   ANSWER.

WORD answered : 
   [COORD @D4765, AGR [CASE @D4764, COUNT @D4763, PER @D4762, 
            PLU @D4761, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ANSWER, 
   [COORD @D4770, AGR [CASE @D4769, COUNT @D4768, PER @D4767, 
            PLU @D4766, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4775, AGR [CASE @D4774, COUNT @D4773, PER @D4772, 
            PLU @D4771, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4780, AGR [CASE @D4779, COUNT @D4778, PER @D4777, 
            PLU @D4776, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4785, AGR [CASE @D4784, COUNT @D4783, PER @D4782, 
            PLU @D4781, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4790, AGR [CASE @D4789, COUNT @D4788, PER @D4787, 
            PLU @D4786, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4795, AGR [CASE @D4794, COUNT @D4793, PER @D4792, 
            PLU @D4791, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4800, AGR [CASE @D4799, COUNT @D4798, PER @D4797, 
            PLU @D4796, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4805, AGR [CASE @D4804, COUNT @D4803, PER @D4802, 
            PLU @D4801, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4810, AGR [CASE @D4809, COUNT @D4808, PER @D4807, 
            PLU @D4806, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4815, AGR [CASE @D4814, COUNT @D4813, PER @D4812, 
            PLU @D4811, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4820, AGR [CASE @D4819, COUNT @D4818, PER @D4817, 
            PLU @D4816, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4825, AGR [CASE @D4824, COUNT @D4823, PER @D4822, 
            PLU @D4821, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4830, AGR [UB @D4829, VFORM @D4828, SUBJ @D4827, FIN @D4826, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4835, 
      AGR [CASE @D4834, COUNT @D4833, PER @D4832, PLU @D4831, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4840, 
      AGR [CASE @D4839, COUNT @D4838, PER @D4837, PLU @D4836, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4845, 
      AGR [CASE @D4844, COUNT @D4843, PER @D4842, PLU @D4841, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4850, 
      AGR [CASE @D4849, COUNT @D4848, PER @D4847, PLU @D4846, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ANSWER, 
   [COORD @D4855, AGR [CASE @D4854, COUNT @D4853, PER @D4852, 
            PLU @D4851, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4860, AGR [CASE @D4859, COUNT @D4858, PER @D4857, 
            PLU @D4856, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4865, AGR [CASE @D4864, COUNT @D4863, PER @D4862, 
            PLU @D4861, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4870, AGR [CASE @D4869, COUNT @D4868, PER @D4867, 
            PLU @D4866, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4875, AGR [CASE @D4874, COUNT @D4873, PER @D4872, 
            PLU @D4871, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4880, AGR [CASE @D4879, COUNT @D4878, PER @D4877, 
            PLU @D4876, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4885, AGR [CASE @D4884, COUNT @D4883, PER @D4882, 
            PLU @D4881, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4890, AGR [CASE @D4889, COUNT @D4888, PER @D4887, 
            PLU @D4886, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4895, AGR [CASE @D4894, COUNT @D4893, PER @D4892, 
            PLU @D4891, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4900, AGR [CASE @D4899, COUNT @D4898, PER @D4897, 
            PLU @D4896, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4905, AGR [CASE @D4904, COUNT @D4903, PER @D4902, 
            PLU @D4901, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ANSWER, 
   [COORD @D4910, AGR [CASE @D4909, COUNT @D4908, PER @D4907, 
            PLU @D4906, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4915, AGR [CASE @D4914, COUNT @D4913, PER @D4912, 
            PLU @D4911, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ANSWER.

WORD answering : 
   [COORD @D4932, PRD @D4931, AGR [CASE @D4930, COUNT @D4929, 
            PER @D4928, PLU @D4927, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4938, PRD @D4937, 
      AGR [CASE @D4936, COUNT @D4935, PER @D4934, PLU @D4933, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ANSWER, 
   [COORD @D4944, PRD @D4943, AGR [CASE @D4942, COUNT @D4941, PER 
               @D4940, PLU @D4939, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4950, PRD @D4949, 
      AGR [CASE @D4948, COUNT @D4947, PER @D4946, PLU @D4945, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ANSWER, 
   [COORD @D4956, PRD @D4955, AGR [CASE @D4954, COUNT @D4953, 
            PER @D4952, PLU @D4951, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4962, PRD @D4961, 
      AGR [CASE @D4960, COUNT @D4959, PER @D4958, PLU @D4957, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4968, PRD @D4967, 
      AGR [CASE @D4966, COUNT @D4965, PER @D4964, PLU @D4963, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ANSWER, 
   [COORD @D4974, PRD @D4973, AGR [CASE @D4972, COUNT @D4971, PER 
               @D4970, PLU @D4969, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4980, PRD @D4979, 
      AGR [CASE @D4978, COUNT @D4977, PER @D4976, PLU @D4975, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ANSWER, 
   [COORD @D4986, PRD @D4985, AGR [CASE @D4984, COUNT @D4983, 
            PER @D4982, PLU @D4981, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4992, PRD @D4991, 
      AGR [CASE @D4990, COUNT @D4989, PER @D4988, PLU @D4987, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ANSWER, 
   [COORD @D4998, PRD @D4997, 
      AGR [CASE @D4996, COUNT @D4995, PER @D4994, PLU @D4993, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ANSWER.

WORD answers : 
   [COORD @D5010, DEMON @D5009, REFL @D5008, PRD @D5007, CASE @D5006, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ANSWER, 
   [COORD @D5015, DEMON @D5014, REFL @D5013, PRD @D5012, CASE @D5011, 
      COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, SUBCAT PP, 
      PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, 
      NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ANSWER, 
   [COORD @D5017, 
      AGR [COUNT @D5016, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5019, 
      AGR [COUNT @D5018, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ANSWER, 
   [COORD @D5021, AGR [COUNT @D5020, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : ANSWER, 
   [COORD @D5023, AGR [COUNT @D5022, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : ANSWER, 
   [COORD @D5025, AGR [COUNT @D5024, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5027, 
      AGR [COUNT @D5026, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5029, 
      AGR [COUNT @D5028, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5031, 
      AGR [COUNT @D5030, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5033, 
      AGR [COUNT @D5032, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5035, 
      AGR [COUNT @D5034, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5037, 
      AGR [COUNT @D5036, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER, 
   [COORD @D5039, 
      AGR [COUNT @D5038, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ANSWER.

WORD appeal : 
   [COORD @D5049, REFL @D5048, COUNT @D5047, PRD @D5046, CASE @D5045, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : APPEAL, 
   [COORD @D5052, 
      AGR [COUNT @D5051, PER @D5050, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM TO_FOR, ARITY 3] : APPEAL, 
   [COORD @D5054, AGR [COUNT @D5053, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM TO_FOR, ARITY 3] : APPEAL, 
   [COORD @D5056, AGR [COUNT @D5055, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM TO_FOR, ARITY 3] : APPEAL, 
   [COORD @D5060, AGR [COUNT @D5059, PER @D5058, PLU @D5057, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM TO_FOR, ARITY 3] : APPEAL, 
   [COORD @D5066, PAST @D5065, 
      AGR [CASE @D5064, COUNT @D5063, PER @D5062, PLU @D5061, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, PFORM TO_FOR, 
      ARITY 3] : APPEAL, 
   [COORD @D5069, AGR [COUNT @D5068, PER @D5067, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM TO_AGAINST, ARITY 3] : APPEAL, 
   [COORD @D5071, AGR [COUNT @D5070, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM TO_AGAINST, ARITY 3] : APPEAL, 
   [COORD @D5073, AGR [COUNT @D5072, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM TO_AGAINST, ARITY 3] : APPEAL, 
   [COORD @D5077, AGR [COUNT @D5076, PER @D5075, PLU @D5074, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM TO_AGAINST, ARITY 3] : APPEAL, 
   [COORD @D5083, PAST @D5082, 
      AGR [CASE @D5081, COUNT @D5080, PER @D5079, PLU @D5078, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, PFORM TO_AGAINST, 
      ARITY 3] : APPEAL, 
   [COORD @D5086, AGR [COUNT @D5085, PER @D5084, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : APPEAL, 
   [COORD @D5088, AGR [COUNT @D5087, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PP_INF, 
      PFORM TO, ARITY 3] : APPEAL, 
   [COORD @D5090, AGR [COUNT @D5089, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PP_INF, 
      PFORM TO, ARITY 3] : APPEAL, 
   [COORD @D5094, AGR [COUNT @D5093, PER @D5092, PLU @D5091, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : APPEAL, 
   [COORD @D5100, PAST @D5099, 
      AGR [CASE @D5098, COUNT @D5097, PER @D5096, PLU @D5095, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM TO, 
      ARITY 3] : APPEAL, 
   [COORD @D5103, AGR [COUNT @D5102, PER @D5101, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : APPEAL, 
   [COORD @D5105, AGR [COUNT @D5104, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : APPEAL, 
   [COORD @D5107, AGR [COUNT @D5106, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : APPEAL, 
   [COORD @D5111, AGR [COUNT @D5110, PER @D5109, PLU @D5108, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : APPEAL, 
   [COORD @D5117, PAST @D5116, AGR [CASE @D5115, COUNT @D5114, 
            PER @D5113, PLU @D5112, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, ARITY 2] : APPEAL, 
   [COORD @D5120, 
      AGR [COUNT @D5119, PER @D5118, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : APPEAL, 
   [COORD @D5122, AGR [COUNT @D5121, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : APPEAL, 
   [COORD @D5124, AGR [COUNT @D5123, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : APPEAL, 
   [COORD @D5128, AGR [COUNT @D5127, PER @D5126, PLU @D5125, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : APPEAL, 
   [COORD @D5134, PAST @D5133, AGR [CASE @D5132, COUNT @D5131, 
            PER @D5130, PLU @D5129, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM FOR, ARITY 2] : APPEAL, 
   [COORD @D5137, 
      AGR [COUNT @D5136, PER @D5135, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, 
      ARITY 2] : APPEAL, 
   [COORD @D5139, AGR [COUNT @D5138, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, 
      ARITY 2] : APPEAL, 
   [COORD @D5141, AGR [COUNT @D5140, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, 
      ARITY 2] : APPEAL, 
   [COORD @D5145, AGR [COUNT @D5144, PER @D5143, PLU @D5142, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : APPEAL, 
   [COORD @D5151, PAST @D5150, AGR [CASE @D5149, COUNT @D5148, 
            PER @D5147, PLU @D5146, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM AGAINST, ARITY 2] : APPEAL, 
   [COORD @D5154, 
      AGR [COUNT @D5153, PER @D5152, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   APPEAL, 
   [COORD @D5156, AGR [COUNT @D5155, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   APPEAL, 
   [COORD @D5158, AGR [COUNT @D5157, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   APPEAL, 
   [COORD @D5162, AGR [COUNT @D5161, PER @D5160, PLU @D5159, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : APPEAL, 
   [COORD @D5168, PAST @D5167, AGR [CASE @D5166, COUNT @D5165, 
            PER @D5164, PLU @D5163, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : APPEAL.

WORD appealed : 
   [COORD @D5180, AGR [CASE @D5179, COUNT @D5178, PER @D5177, 
            PLU @D5176, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5185, AGR [CASE @D5184, COUNT @D5183, PER @D5182, 
            PLU @D5181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5190, AGR [CASE @D5189, COUNT @D5188, PER @D5187, 
            PLU @D5186, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM TO_AGAINST, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5195, AGR [CASE @D5194, COUNT @D5193, PER @D5192, 
            PLU @D5191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM TO_AGAINST, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5200, AGR [CASE @D5199, COUNT @D5198, PER @D5197, 
            PLU @D5196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5205, AGR [CASE @D5204, COUNT @D5203, PER @D5202, 
            PLU @D5201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5210, AGR [CASE @D5209, COUNT @D5208, PER @D5207, 
            PLU @D5206, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE EQUI, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5215, AGR [CASE @D5214, COUNT @D5213, PER @D5212, 
            PLU @D5211, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5220, AGR [CASE @D5219, COUNT @D5218, PER @D5217, 
            PLU @D5216, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5225, AGR [CASE @D5224, COUNT @D5223, PER @D5222, 
            PLU @D5221, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPEAL, 
   [COORD @D5230, AGR [CASE @D5229, COUNT @D5228, PER @D5227, 
            PLU @D5226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5235, AGR [CASE @D5234, COUNT @D5233, PER @D5232, 
            PLU @D5231, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5240, AGR [CASE @D5239, COUNT @D5238, PER @D5237, 
            PLU @D5236, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5245, AGR [CASE @D5244, COUNT @D5243, PER @D5242, 
            PLU @D5241, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5250, AGR [CASE @D5249, COUNT @D5248, PER @D5247, 
            PLU @D5246, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPEAL, 
   [COORD @D5255, AGR [CASE @D5254, COUNT @D5253, PER @D5252, 
            PLU @D5251, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : APPEAL.

WORD appealing : 
   [COORD @D5272, PRD @D5271, AGR [CASE @D5270, COUNT @D5269, 
            PER @D5268, PLU @D5267, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, 
      PFORM TO_FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5278, PRD @D5277, 
      AGR [CASE @D5276, COUNT @D5275, PER @D5274, PLU @D5273, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_PP, PFORM TO_AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPEAL, 
   [COORD @D5284, PRD @D5283, AGR [CASE @D5282, COUNT @D5281, 
            PER @D5280, PLU @D5279, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5290, PRD @D5289, 
      AGR [CASE @D5288, COUNT @D5287, PER @D5286, PLU @D5285, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPEAL, 
   [COORD @D5296, PRD @D5295, AGR [CASE @D5294, COUNT @D5293, 
            PER @D5292, PLU @D5291, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5302, PRD @D5301, 
      AGR [CASE @D5300, COUNT @D5299, PER @D5298, PLU @D5297, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   APPEAL, 
   [COORD @D5308, PRD @D5307, AGR [CASE @D5306, COUNT @D5305, PER 
               @D5304, PLU @D5303, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPEAL.

WORD appeals : 
   [COORD @D5320, DEMON @D5319, REFL @D5318, PRD @D5317, CASE @D5316, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : APPEAL, 
   [COORD @D5322, 
      AGR [COUNT @D5321, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPEAL, 
   [COORD @D5324, AGR [COUNT @D5323, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_PP, PFORM TO_AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPEAL, 
   [COORD @D5326, AGR [COUNT @D5325, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPEAL, 
   [COORD @D5328, AGR [COUNT @D5327, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : APPEAL, 
   [COORD @D5330, AGR [COUNT @D5329, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAL, 
   [COORD @D5332, 
      AGR [COUNT @D5331, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPEAL, 
   [COORD @D5334, AGR [COUNT @D5333, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAL.

WORD appear : 
   [COORD @D5342, AGR [COUNT @D5341, PER @D5340, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : APPEAR, 
   [COORD @D5344, AGR [COUNT @D5343, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5346, 
      AGR [COUNT @D5345, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5350, 
      AGR [COUNT @D5349, PER @D5348, PLU @D5347, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : APPEAR, 
   [COORD @D5356, PAST @D5355, AGR [CASE @D5354, COUNT @D5353, 
            PER @D5352, PLU @D5351, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT LOC, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5358, AGR [COUNT @D5357, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, PFORM TO, LAT -, 
      ARITY 2] : APPEAR, 
   [COORD @D5360, AGR [COUNT @D5359, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, PFORM TO, LAT -, 
      ARITY 2] : APPEAR, 
   [COORD @D5364, AGR [NFORM @D5363, COUNT @D5362, PER @D5361, N +, V -, 
            BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, 
      PFORM TO, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5368, AGR [COUNT @D5367, PER @D5366, PLU @D5365, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, 
      PFORM TO, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5371, AGR @D5370, PAST @D5369, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_PP_INF, 
      PFORM TO, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5374, AGR [COUNT @D5373, PER @D5372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : APPEAR, 
   [COORD @D5376, AGR [COUNT @D5375, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   APPEAR, 
   [COORD @D5378, AGR [COUNT @D5377, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   APPEAR, 
   [COORD @D5382, AGR [COUNT @D5381, PER @D5380, PLU @D5379, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : APPEAR, 
   [COORD @D5388, PAST @D5387, AGR [CASE @D5386, COUNT @D5385, 
            PER @D5384, PLU @D5383, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5391, AGR [COUNT @D5390, PER @D5389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM BEFORE, 
      LAT -, ARITY 2] : APPEAR, 
   [COORD @D5393, AGR [COUNT @D5392, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM BEFORE, LAT -, 
      ARITY 2] : APPEAR, 
   [COORD @D5395, AGR [COUNT @D5394, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM BEFORE, LAT -, 
      ARITY 2] : APPEAR, 
   [COORD @D5399, AGR [COUNT @D5398, PER @D5397, PLU @D5396, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM BEFORE, 
      LAT -, ARITY 2] : APPEAR, 
   [COORD @D5405, PAST @D5404, AGR [CASE @D5403, COUNT @D5402, 
            PER @D5401, PLU @D5400, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM BEFORE, LAT -, ARITY 2] : APPEAR, 
   [COORD @D5407, AGR [COUNT @D5406, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, ARITY 1] : APPEAR, 
   
   [COORD @D5409, AGR [COUNT @D5408, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, ARITY 1] : APPEAR, 
   
   [COORD @D5413, AGR [NFORM @D5412, COUNT @D5411, PER @D5410, N +, V -, 
            BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5417, AGR [COUNT @D5416, PER @D5415, PLU @D5414, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_NP, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5420, AGR @D5419, PAST @D5418, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5422, AGR [COUNT @D5421, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 1] : 
   APPEAR, 
   [COORD @D5424, AGR [COUNT @D5423, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 1] : 
   APPEAR, 
   [COORD @D5428, AGR [NFORM @D5427, COUNT @D5426, PER @D5425, N +, V -, 
            BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5432, AGR [COUNT @D5431, PER @D5430, PLU @D5429, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5435, AGR @D5434, PAST @D5433, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5437, AGR [COUNT @D5436, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, LAT -, ARITY 1] : APPEAR, 
   
   [COORD @D5439, AGR [COUNT @D5438, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, SUBTYPE RAIS, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, LAT -, ARITY 1] : APPEAR, 
   
   [COORD @D5443, AGR [NFORM @D5442, COUNT @D5441, PER @D5440, N +, V -, 
            BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5447, AGR [COUNT @D5446, PER @D5445, PLU @D5444, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5450, AGR @D5449, PAST @D5448, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_AP, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5453, AGR [COUNT @D5452, PER @D5451, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5455, AGR [COUNT @D5454, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : APPEAR, 
   [COORD @D5457, 
      AGR [COUNT @D5456, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : APPEAR, 
   [COORD @D5461, 
      AGR [COUNT @D5460, PER @D5459, PLU @D5458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : APPEAR, 
   [COORD @D5467, PAST @D5466, AGR [CASE @D5465, COUNT @D5464, 
            PER @D5463, PLU @D5462, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : APPEAR, 
   [COORD @D5472, PAST @D5471, 
      AGR [COUNT @D5470, PER @D5469, PLU @D5468, NFORM IT, CASE NOM, N +, 
            V -, BAR 2], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, LAT -, ARITY 2] : 
   APPEAR, 
   [COORD @D5477, PAST @D5476, AGR [COUNT @D5475, PER @D5474, PLU 
               @D5473, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, V +, 
      N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE ASIF, SUBCAT WHS, 
      LAT -, ARITY 1] : APPEAR, 
   [COORD @D5482, PAST @D5481, AGR [COUNT @D5480, PER @D5479, 
            PLU @D5478, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, 
      LAT -, ARITY 1] : APPEAR.

WORD appeared : 
   [COORD @D5493, AGR [CASE @D5492, COUNT @D5491, PER @D5490, 
            PLU @D5489, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5498, AGR [CASE @D5497, COUNT @D5496, PER @D5495, 
            PLU @D5494, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5500, AGR @D5499, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_PP_INF, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5502, AGR @D5501, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_PP_INF, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5507, AGR [CASE @D5506, COUNT @D5505, PER @D5504, 
            PLU @D5503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5512, AGR [CASE @D5511, COUNT @D5510, PER @D5509, 
            PLU @D5508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5517, AGR [CASE @D5516, COUNT @D5515, PER @D5514, 
            PLU @D5513, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BEFORE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5522, AGR [CASE @D5521, COUNT @D5520, PER @D5519, 
            PLU @D5518, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BEFORE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5524, AGR @D5523, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPEAR, 
   [COORD @D5526, AGR @D5525, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5528, AGR @D5527, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPEAR, 
   [COORD @D5530, AGR @D5529, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5532, AGR @D5531, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPEAR, 
   [COORD @D5534, AGR @D5533, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5539, AGR [CASE @D5538, COUNT @D5537, PER @D5536, 
            PLU @D5535, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5544, AGR [CASE @D5543, COUNT @D5542, PER @D5541, 
            PLU @D5540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5548, AGR [COUNT @D5547, PER @D5546, PLU @D5545, NFORM IT, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5552, AGR [COUNT @D5551, PER @D5550, PLU @D5549, NFORM IT, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : APPEAR, 
   [COORD @D5556, AGR [COUNT @D5555, PER @D5554, PLU @D5553, NFORM IT, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE ASIF, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPEAR, 
   [COORD @D5560, AGR [COUNT @D5559, PER @D5558, PLU @D5557, NFORM IT, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE ASIF, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5564, AGR [COUNT @D5563, PER @D5562, PLU @D5561, NFORM IT, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPEAR, 
   [COORD @D5568, AGR [COUNT @D5567, PER @D5566, PLU @D5565, NFORM IT, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : 
   APPEAR.

WORD appearing : 
   [COORD @D5582, PRD @D5581, AGR [CASE @D5580, COUNT @D5579, 
            PER @D5578, PLU @D5577, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5585, AGR @D5584, PRD @D5583, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_PP_INF, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5591, PRD @D5590, AGR [CASE @D5589, COUNT @D5588, 
            PER @D5587, PLU @D5586, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5597, PRD @D5596, 
      AGR [CASE @D5595, COUNT @D5594, PER @D5593, PLU @D5592, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM BEFORE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   APPEAR, 
   [COORD @D5600, AGR @D5599, PRD @D5598, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5603, AGR @D5602, PRD @D5601, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5606, AGR @D5605, PRD @D5604, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5612, PRD @D5611, AGR [CASE @D5610, COUNT @D5609, 
            PER @D5608, PLU @D5607, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5617, PRD @D5616, 
      AGR [COUNT @D5615, PER @D5614, PLU @D5613, NFORM IT, CASE NOM, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   APPEAR, 
   [COORD @D5622, PRD @D5621, AGR [COUNT @D5620, PER @D5619, PLU @D5618, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE ASIF, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5627, PRD @D5626, AGR [COUNT @D5625, PER @D5624, PLU @D5623, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : APPEAR.

WORD appears : 
   [COORD @D5635, AGR [COUNT @D5634, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5639, 
      AGR [CASE @D5638, NFORM @D5637, COUNT @D5636, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT SC_PP_INF, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5644, AGR [UB @D5643, VFORM @D5642, SUBJ @D5641, FIN @D5640, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT SC_PP_INF, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : APPEAR, 
   [COORD @D5646, AGR [COUNT @D5645, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5648, 
      AGR [COUNT @D5647, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM BEFORE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5652, 
      AGR [CASE @D5651, NFORM @D5650, COUNT @D5649, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_NP, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5657, 
      AGR [UB @D5656, VFORM @D5655, SUBJ @D5654, FIN @D5653, N -, V +, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_NP, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5661, 
      AGR [CASE @D5660, NFORM @D5659, COUNT @D5658, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5666, 
      AGR [UB @D5665, VFORM @D5664, SUBJ @D5663, FIN @D5662, N -, V +, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5670, 
      AGR [CASE @D5669, NFORM @D5668, COUNT @D5667, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_AP, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5675, 
      AGR [UB @D5674, VFORM @D5673, SUBJ @D5672, FIN @D5671, N -, V +, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_AP, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5677, 
      AGR [COUNT @D5676, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR, 
   [COORD @D5680, 
      AGR [CASE @D5679, COUNT @D5678, N +, V -, BAR 2, NFORM IT, PLU -, 
            PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPEAR, 
   [COORD @D5683, AGR [CASE @D5682, COUNT @D5681, N +, V -, BAR 2, 
            NFORM IT, PLU -, PER 3], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE ASIF, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPEAR, 
   [COORD @D5686, AGR [CASE @D5685, COUNT @D5684, N +, V -, BAR 2, 
            NFORM IT, PLU -, PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPEAR.

WORD apple : 
   [COORD @D5696, REFL @D5695, PRD @D5694, CASE @D5693, FIX NOT, BAR 0, 
      SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, COUNT +] : APPLE.

WORD apples : 
   [COORD @D5708, DEMON @D5707, REFL @D5706, PRD @D5705, CASE @D5704, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : APPLE.

WORD applied : 
   [COADV @D5723, COORD @D5722, DEF @D5721, PRD @D5720, AGR 
            [CASE @D5719, COUNT @D5718, PER @D5717, PLU @D5716, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   APPLIED, 
   [COORD @D5728, AGR [CASE @D5727, COUNT @D5726, PER @D5725, 
            PLU @D5724, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5733, AGR [CASE @D5732, COUNT @D5731, PER @D5730, 
            PLU @D5729, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5738, AGR [CASE @D5737, COUNT @D5736, PER @D5735, 
            PLU @D5734, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPLY, 
   [COORD @D5743, AGR [CASE @D5742, COUNT @D5741, PER @D5740, 
            PLU @D5739, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5748, AGR [CASE @D5747, COUNT @D5746, PER @D5745, 
            PLU @D5744, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5753, AGR [CASE @D5752, COUNT @D5751, PER @D5750, 
            PLU @D5749, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPLY, 
   [COORD @D5758, AGR [CASE @D5757, COUNT @D5756, PER @D5755, 
            PLU @D5754, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : APPLY, 
   [COORD @D5763, AGR [CASE @D5762, COUNT @D5761, PER @D5760, 
            PLU @D5759, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : APPLY, 
   [COORD @D5768, AGR [CASE @D5767, COUNT @D5766, PER @D5765, 
            PLU @D5764, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5773, AGR [CASE @D5772, COUNT @D5771, PER @D5770, 
            PLU @D5769, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5778, AGR [CASE @D5777, COUNT @D5776, PER @D5775, 
            PLU @D5774, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5783, AGR [CASE @D5782, COUNT @D5781, PER @D5780, 
            PLU @D5779, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5788, AGR [CASE @D5787, COUNT @D5786, PER @D5785, 
            PLU @D5784, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPLY, 
   [COORD @D5793, AGR [CASE @D5792, COUNT @D5791, PER @D5790, 
            PLU @D5789, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : APPLY.

WORD applies : 
   [COORD @D5802, AGR [COUNT @D5801, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPLY, 
   [COORD @D5804, AGR [COUNT @D5803, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPLY, 
   [COORD @D5806, 
      AGR [COUNT @D5805, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPLY, 
   [COORD @D5808, 
      AGR [COUNT @D5807, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPLY, 
   [COORD @D5810, 
      AGR [COUNT @D5809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPLY, 
   [COORD @D5812, 
      AGR [COUNT @D5811, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPLY.

WORD apply : 
   [COORD @D5821, AGR [COUNT @D5820, PER @D5819, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM TO_FOR, LAT -, ARITY 3] : APPLY, 
   [COORD @D5823, AGR [COUNT @D5822, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_PP, PFORM TO_FOR, LAT -, 
      ARITY 3] : APPLY, 
   [COORD @D5825, AGR [COUNT @D5824, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_PP, PFORM TO_FOR, LAT -, 
      ARITY 3] : APPLY, 
   [COORD @D5829, AGR [COUNT @D5828, PER @D5827, PLU @D5826, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM TO_FOR, LAT -, ARITY 3] : APPLY, 
   [COORD @D5835, PAST @D5834, 
      AGR [CASE @D5833, COUNT @D5832, PER @D5831, PLU @D5830, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_PP, PFORM TO_FOR, LAT -, ARITY 3] : 
   APPLY, 
   [COORD @D5838, AGR [COUNT @D5837, PER @D5836, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : APPLY, 
   [COORD @D5840, AGR [COUNT @D5839, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : APPLY, 
   [COORD @D5842, AGR [COUNT @D5841, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : APPLY, 
   [COORD @D5846, AGR [COUNT @D5845, PER @D5844, PLU @D5843, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : APPLY, 
   [COORD @D5852, PAST @D5851, AGR [CASE @D5850, COUNT @D5849, 
            PER @D5848, PLU @D5847, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, LAT -, ARITY 3] : APPLY, 
   [COORD @D5855, AGR [COUNT @D5854, PER @D5853, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : APPLY, 
   [COORD @D5857, AGR [COUNT @D5856, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : APPLY, 
   [COORD @D5859, 
      AGR [COUNT @D5858, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : APPLY, 
   [COORD @D5863, 
      AGR [COUNT @D5862, PER @D5861, PLU @D5860, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : APPLY, 
   [COORD @D5869, PAST @D5868, AGR [CASE @D5867, COUNT @D5866, 
            PER @D5865, PLU @D5864, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : APPLY, 
   [COORD @D5872, AGR [COUNT @D5871, PER @D5870, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : APPLY, 
   [COORD @D5874, AGR [COUNT @D5873, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   APPLY, 
   [COORD @D5876, AGR [COUNT @D5875, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, LAT -, ARITY 2] : 
   APPLY, 
   [COORD @D5880, AGR [COUNT @D5879, PER @D5878, PLU @D5877, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : APPLY, 
   [COORD @D5886, PAST @D5885, AGR [CASE @D5884, COUNT @D5883, 
            PER @D5882, PLU @D5881, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, LAT -, ARITY 2] : APPLY, 
   [COORD @D5889, AGR [COUNT @D5888, PER @D5887, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : APPLY, 
   [COORD @D5891, AGR [COUNT @D5890, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   APPLY, 
   [COORD @D5893, AGR [COUNT @D5892, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   APPLY, 
   [COORD @D5897, AGR [COUNT @D5896, PER @D5895, PLU @D5894, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : APPLY, 
   [COORD @D5903, PAST @D5902, AGR [CASE @D5901, COUNT @D5900, 
            PER @D5899, PLU @D5898, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : APPLY, 
   [COORD @D5906, AGR [COUNT @D5905, PER @D5904, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : APPLY, 
   [COORD @D5908, AGR [COUNT @D5907, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : APPLY, 
   [COORD @D5910, 
      AGR [COUNT @D5909, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : APPLY, 
   [COORD @D5914, 
      AGR [COUNT @D5913, PER @D5912, PLU @D5911, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : APPLY, 
   [COORD @D5920, PAST @D5919, AGR [CASE @D5918, COUNT @D5917, 
            PER @D5916, PLU @D5915, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : APPLY.

WORD applying : 
   [COORD @D5935, PRD @D5934, AGR [CASE @D5933, COUNT @D5932, 
            PER @D5931, PLU @D5930, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, 
      PFORM TO_FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5941, PRD @D5940, 
      AGR [CASE @D5939, COUNT @D5938, PER @D5937, PLU @D5936, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   APPLY, 
   [COORD @D5947, PRD @D5946, AGR [CASE @D5945, COUNT @D5944, PER 
               @D5943, PLU @D5942, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5953, PRD @D5952, AGR 
         [CASE @D5951, COUNT @D5950, PER @D5949, PLU @D5948, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   APPLY, 
   [COORD @D5959, PRD @D5958, AGR [CASE @D5957, COUNT @D5956, PER 
               @D5955, PLU @D5954, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : APPLY, 
   [COORD @D5965, PRD @D5964, 
      AGR [CASE @D5963, COUNT @D5962, PER @D5961, PLU @D5960, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : APPLY.

WORD approach : 
   [COORD @D5974, REFL @D5973, COUNT @D5972, PRD @D5971, CASE @D5970, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : APPROACH, 
   [COORD @D5977, 
      AGR [COUNT @D5976, PER @D5975, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, LAT -, 
      ARITY 3] : APPROACH, 
   [COORD @D5979, AGR [COUNT @D5978, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, LAT -, 
      ARITY 3] : APPROACH, 
   [COORD @D5981, AGR [COUNT @D5980, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, LAT -, 
      ARITY 3] : APPROACH, 
   [COORD @D5985, AGR [COUNT @D5984, PER @D5983, PLU @D5982, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ABOUT, LAT -, ARITY 3] : APPROACH, 
   [COORD @D5991, PAST @D5990, 
      AGR [CASE @D5989, COUNT @D5988, PER @D5987, PLU @D5986, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, LAT -, ARITY 3] : 
   APPROACH, 
   [COORD @D5994, AGR [COUNT @D5993, PER @D5992, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : APPROACH, 
   [COORD @D5996, AGR [COUNT @D5995, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : APPROACH, 
   [COORD @D5998, 
      AGR [COUNT @D5997, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : APPROACH, 
   [COORD @D6002, 
      AGR [COUNT @D6001, PER @D6000, PLU @D5999, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : APPROACH, 
   [COORD @D6008, PAST @D6007, AGR [CASE @D6006, COUNT @D6005, 
            PER @D6004, PLU @D6003, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : APPROACH, 
   [COORD @D6011, AGR [COUNT @D6010, PER @D6009, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : APPROACH, 
   [COORD @D6013, AGR [COUNT @D6012, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : 
   APPROACH, 
   [COORD @D6015, AGR [COUNT @D6014, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : 
   APPROACH, 
   [COORD @D6019, AGR [COUNT @D6018, PER @D6017, PLU @D6016, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : APPROACH, 
   [COORD @D6025, PAST @D6024, AGR [CASE @D6023, COUNT @D6022, 
            PER @D6021, PLU @D6020, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : APPROACH.

WORD approached : 
   [COORD @D6036, AGR [CASE @D6035, COUNT @D6034, PER @D6033, 
            PLU @D6032, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : APPROACH, 
   [COORD @D6041, AGR [CASE @D6040, COUNT @D6039, PER @D6038, 
            PLU @D6037, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : APPROACH, 
   [COORD @D6046, AGR [CASE @D6045, COUNT @D6044, PER @D6043, 
            PLU @D6042, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : APPROACH, 
   [COORD @D6051, AGR [CASE @D6050, COUNT @D6049, PER @D6048, 
            PLU @D6047, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : APPROACH, 
   [COORD @D6056, AGR [CASE @D6055, COUNT @D6054, PER @D6053, 
            PLU @D6052, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : APPROACH, 
   [COORD @D6061, AGR [CASE @D6060, COUNT @D6059, PER @D6058, 
            PLU @D6057, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : APPROACH, 
   [COORD @D6066, AGR [CASE @D6065, COUNT @D6064, PER @D6063, 
            PLU @D6062, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : APPROACH, 
   [COORD @D6071, AGR [CASE @D6070, COUNT @D6069, PER @D6068, 
            PLU @D6067, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : APPROACH.

WORD approaches : 
   [COORD @D6082, DEMON @D6081, REFL @D6080, PRD @D6079, CASE @D6078, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : APPROACH, 
   [COORD @D6084, 
      AGR [COUNT @D6083, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   APPROACH, 
   [COORD @D6086, AGR [COUNT @D6085, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPROACH, 
   [COORD @D6088, 
      AGR [COUNT @D6087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : APPROACH.

WORD approaching : 
   [COORD @D6104, PRD @D6103, AGR [CASE @D6102, COUNT @D6101, 
            PER @D6100, PLU @D6099, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : APPROACH, 
   [COORD @D6110, PRD @D6109, 
      AGR [CASE @D6108, COUNT @D6107, PER @D6106, PLU @D6105, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : APPROACH, 
   [COORD @D6116, PRD @D6115, 
      AGR [CASE @D6114, COUNT @D6113, PER @D6112, PLU @D6111, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : APPROACH.

WORD arise : 
   [COORD @D6130, AGR [COUNT @D6129, PER @D6128, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, 
      LAT -, ARITY 2] : ARISE, 
   [COORD @D6132, AGR [COUNT @D6131, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, LAT -, 
      ARITY 2] : ARISE, 
   [COORD @D6134, AGR [COUNT @D6133, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, LAT -, 
      ARITY 2] : ARISE, 
   [COORD @D6138, AGR [COUNT @D6137, PER @D6136, PLU @D6135, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, 
      LAT -, ARITY 2] : ARISE, 
   [COORD @D6144, PAST @D6143, AGR [CASE @D6142, COUNT @D6141, 
            PER @D6140, PLU @D6139, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FROM, LAT -, ARITY 2] : ARISE, 
   [COORD @D6147, AGR [COUNT @D6146, PER @D6145, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : ARISE, 
   [COORD @D6149, AGR [COUNT @D6148, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, ARITY 1] : ARISE, 
   [COORD @D6151, 
      AGR [COUNT @D6150, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, ARITY 1] : ARISE, 
   [COORD @D6155, 
      AGR [COUNT @D6154, PER @D6153, PLU @D6152, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : ARISE, 
   [COORD @D6161, PAST @D6160, AGR [CASE @D6159, COUNT @D6158, 
            PER @D6157, PLU @D6156, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      REG -, LAT -, ARITY 1] : ARISE.

WORD arises : 
   [COORD @D6175, AGR [COUNT @D6174, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARISE, 
   [COORD @D6177, 
      AGR [COUNT @D6176, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARISE.

WORD arising : 
   [COORD @D6188, PRD @D6187, AGR [CASE @D6186, COUNT @D6185, 
            PER @D6184, PLU @D6183, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ARISE, 
   [COORD @D6194, PRD @D6193, 
      AGR [CASE @D6192, COUNT @D6191, PER @D6190, PLU @D6189, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARISE.

WORD arrange : 
   [COORD @D6202, AGR [COUNT @D6201, PER @D6200, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM FOR_WITH, ARITY 3] : ARRANGE, 
   [COORD @D6204, AGR [COUNT @D6203, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_WITH, ARITY 3] : ARRANGE, 
   [COORD @D6206, AGR [COUNT @D6205, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_WITH, ARITY 3] : ARRANGE, 
   [COORD @D6210, AGR [COUNT @D6209, PER @D6208, PLU @D6207, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM FOR_WITH, ARITY 3] : ARRANGE, 
   [COORD @D6216, PAST @D6215, 
      AGR [CASE @D6214, COUNT @D6213, PER @D6212, PLU @D6211, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_WITH, 
      ARITY 3] : ARRANGE, 
   [COORD @D6219, AGR [COUNT @D6218, PER @D6217, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6221, AGR [COUNT @D6220, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, PFORM WITH, 
      LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6223, AGR [COUNT @D6222, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, PFORM WITH, 
      LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6227, AGR [COUNT @D6226, PER @D6225, PLU @D6224, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6233, PAST @D6232, 
      AGR [CASE @D6231, COUNT @D6230, PER @D6229, PLU @D6228, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, COMPOUND NOT, SUBCAT SC_PP_INF, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6236, AGR [COUNT @D6235, PER @D6234, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHVP, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6238, AGR [COUNT @D6237, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHVP, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6240, AGR [COUNT @D6239, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHVP, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6244, AGR [COUNT @D6243, PER @D6242, PLU @D6241, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHVP, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6250, PAST @D6249, 
      AGR [CASE @D6248, COUNT @D6247, PER @D6246, PLU @D6245, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_WHVP, PFORM WITH, LAT -, ARITY 3] : 
   ARRANGE, 
   [COORD @D6253, AGR [COUNT @D6252, PER @D6251, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHS, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6255, AGR [COUNT @D6254, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHS, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6257, AGR [COUNT @D6256, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHS, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6261, AGR [COUNT @D6260, PER @D6259, PLU @D6258, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_WHS, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6267, PAST @D6266, 
      AGR [CASE @D6265, COUNT @D6264, PER @D6263, PLU @D6262, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_WHS, PFORM WITH, LAT -, ARITY 3] : 
   ARRANGE, 
   [COORD @D6270, AGR [COUNT @D6269, PER @D6268, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SINF, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6272, AGR [COUNT @D6271, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SINF, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6274, AGR [COUNT @D6273, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SINF, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6278, AGR [COUNT @D6277, PER @D6276, PLU @D6275, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SINF, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6284, PAST @D6283, 
      AGR [CASE @D6282, COUNT @D6281, PER @D6280, PLU @D6279, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_SINF, PFORM WITH, LAT -, ARITY 3] : 
   ARRANGE, 
   [COORD @D6287, AGR [COUNT @D6286, PER @D6285, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6289, AGR [COUNT @D6288, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6291, AGR [COUNT @D6290, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6295, AGR [COUNT @D6294, PER @D6293, PLU @D6292, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6301, PAST @D6300, 
      AGR [CASE @D6299, COUNT @D6298, PER @D6297, PLU @D6296, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_SFIN, PFORM WITH, LAT -, ARITY 3] : 
   ARRANGE, 
   [COORD @D6304, AGR [COUNT @D6303, PER @D6302, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SBSE, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6306, AGR [COUNT @D6305, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SBSE, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6308, AGR [COUNT @D6307, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SBSE, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6312, AGR [COUNT @D6311, PER @D6310, PLU @D6309, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP_SBSE, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6318, PAST @D6317, 
      AGR [CASE @D6316, COUNT @D6315, PER @D6314, PLU @D6313, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP_SBSE, PFORM WITH, LAT -, ARITY 3] : 
   ARRANGE, 
   [COORD @D6321, AGR [COUNT @D6320, PER @D6319, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6323, AGR [COUNT @D6322, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6325, AGR [COUNT @D6324, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6329, AGR [COUNT @D6328, PER @D6327, PLU @D6326, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6335, PAST @D6334, 
      AGR [CASE @D6333, COUNT @D6332, PER @D6331, PLU @D6330, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, LAT -, ARITY 3] : 
   ARRANGE, 
   [COORD @D6338, AGR [COUNT @D6337, PER @D6336, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6340, AGR [COUNT @D6339, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6342, AGR [COUNT @D6341, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, LAT -, 
      ARITY 3] : ARRANGE, 
   [COORD @D6346, AGR [COUNT @D6345, PER @D6344, PLU @D6343, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6352, PAST @D6351, AGR [CASE @D6350, COUNT @D6349, 
            PER @D6348, PLU @D6347, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, LAT -, ARITY 3] : ARRANGE, 
   [COORD @D6355, AGR 
         [COUNT @D6354, PER @D6353, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : ARRANGE, 
   [COORD @D6357, AGR [COUNT @D6356, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ARRANGE, 
   [COORD @D6359, AGR [COUNT @D6358, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ARRANGE, 
   [COORD @D6363, AGR [COUNT @D6362, PER @D6361, PLU @D6360, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ARRANGE, 
   [COORD @D6369, PAST @D6368, AGR [CASE @D6367, COUNT @D6366, 
            PER @D6365, PLU @D6364, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, ARITY 2] : ARRANGE, 
   [COORD @D6372, 
      AGR [COUNT @D6371, PER @D6370, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6374, AGR [COUNT @D6373, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6376, AGR [COUNT @D6375, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6380, AGR [COUNT @D6379, PER @D6378, PLU @D6377, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6386, PAST @D6385, AGR [CASE @D6384, COUNT @D6383, 
            PER @D6382, PLU @D6381, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT WHVP, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6389, AGR [COUNT @D6388, PER @D6387, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6391, AGR [COUNT @D6390, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6393, 
      AGR [COUNT @D6392, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6397, 
      AGR [COUNT @D6396, PER @D6395, PLU @D6394, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6403, PAST @D6402, AGR [CASE @D6401, COUNT @D6400, 
            PER @D6399, PLU @D6398, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT WHS, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6406, AGR [COUNT @D6405, PER @D6404, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6408, AGR [COUNT @D6407, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6410, AGR [COUNT @D6409, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6414, AGR [COUNT @D6413, PER @D6412, PLU @D6411, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6420, PAST @D6419, AGR [CASE @D6418, COUNT @D6417, 
            PER @D6416, PLU @D6415, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SINF, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6423, AGR [COUNT @D6422, PER @D6421, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6425, AGR [COUNT @D6424, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6427, AGR [COUNT @D6426, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6431, AGR [COUNT @D6430, PER @D6429, PLU @D6428, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6437, PAST @D6436, AGR [CASE @D6435, COUNT @D6434, 
            PER @D6433, PLU @D6432, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6440, AGR [COUNT @D6439, PER @D6438, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6442, AGR [COUNT @D6441, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   ARRANGE, 
   [COORD @D6444, AGR [COUNT @D6443, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   ARRANGE, 
   [COORD @D6448, AGR [COUNT @D6447, PER @D6446, PLU @D6445, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6454, PAST @D6453, AGR [CASE @D6452, COUNT @D6451, 
            PER @D6450, PLU @D6449, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_INF, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6457, AGR [COUNT @D6456, PER @D6455, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6459, AGR [COUNT @D6458, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6461, AGR [COUNT @D6460, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, ARITY 2] : ARRANGE, 
   
   [COORD @D6465, AGR [COUNT @D6464, PER @D6463, PLU @D6462, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6471, PAST @D6470, AGR [CASE @D6469, COUNT @D6468, 
            PER @D6467, PLU @D6466, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SBSE, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6474, AGR [COUNT @D6473, PER @D6472, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6476, AGR [COUNT @D6475, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6478, 
      AGR [COUNT @D6477, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ARRANGE, 
   [COORD @D6482, 
      AGR [COUNT @D6481, PER @D6480, PLU @D6479, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ARRANGE, 
   [COORD @D6488, PAST @D6487, AGR [CASE @D6486, COUNT @D6485, 
            PER @D6484, PLU @D6483, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ARRANGE.

WORD arranged : 
   [COORD @D6499, AGR [CASE @D6498, COUNT @D6497, PER @D6496, 
            PLU @D6495, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6504, AGR [CASE @D6503, COUNT @D6502, PER @D6501, 
            PLU @D6500, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6509, AGR [CASE @D6508, COUNT @D6507, PER @D6506, 
            PLU @D6505, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_PP_INF, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6514, AGR [CASE @D6513, COUNT @D6512, PER @D6511, 
            PLU @D6510, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_PP_INF, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6519, AGR [CASE @D6518, COUNT @D6517, PER @D6516, 
            PLU @D6515, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_WHVP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6524, AGR [CASE @D6523, COUNT @D6522, PER @D6521, 
            PLU @D6520, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_WHVP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6529, AGR [CASE @D6528, COUNT @D6527, PER @D6526, 
            PLU @D6525, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_WHS, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6534, AGR [CASE @D6533, COUNT @D6532, PER @D6531, 
            PLU @D6530, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_WHS, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6539, AGR [CASE @D6538, COUNT @D6537, PER @D6536, 
            PLU @D6535, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SINF, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6544, AGR [CASE @D6543, COUNT @D6542, PER @D6541, 
            PLU @D6540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SINF, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6549, AGR [CASE @D6548, COUNT @D6547, PER @D6546, 
            PLU @D6545, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6554, AGR [CASE @D6553, COUNT @D6552, PER @D6551, 
            PLU @D6550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6559, AGR [CASE @D6558, COUNT @D6557, PER @D6556, 
            PLU @D6555, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SBSE, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6564, AGR [CASE @D6563, COUNT @D6562, PER @D6561, 
            PLU @D6560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SBSE, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6569, AGR [CASE @D6568, COUNT @D6567, PER @D6566, 
            PLU @D6565, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6574, AGR [CASE @D6573, COUNT @D6572, PER @D6571, 
            PLU @D6570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6579, AGR [CASE @D6578, COUNT @D6577, PER @D6576, 
            PLU @D6575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6584, AGR [CASE @D6583, COUNT @D6582, PER @D6581, 
            PLU @D6580, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6589, AGR [CASE @D6588, COUNT @D6587, PER @D6586, 
            PLU @D6585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6594, AGR [CASE @D6593, COUNT @D6592, PER @D6591, 
            PLU @D6590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6599, AGR [CASE @D6598, COUNT @D6597, PER @D6596, 
            PLU @D6595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6604, AGR [CASE @D6603, COUNT @D6602, PER @D6601, 
            PLU @D6600, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6609, AGR [CASE @D6608, COUNT @D6607, PER @D6606, 
            PLU @D6605, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6614, AGR [CASE @D6613, COUNT @D6612, PER @D6611, 
            PLU @D6610, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6619, AGR [CASE @D6618, COUNT @D6617, PER @D6616, 
            PLU @D6615, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6624, AGR [CASE @D6623, COUNT @D6622, PER @D6621, 
            PLU @D6620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6629, AGR [CASE @D6628, COUNT @D6627, PER @D6626, 
            PLU @D6625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6634, AGR [CASE @D6633, COUNT @D6632, PER @D6631, 
            PLU @D6630, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6639, AGR [CASE @D6638, COUNT @D6637, PER @D6636, 
            PLU @D6635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6644, AGR [CASE @D6643, COUNT @D6642, PER @D6641, 
            PLU @D6640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6649, AGR [CASE @D6648, COUNT @D6647, PER @D6646, 
            PLU @D6645, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6654, AGR [UB @D6653, VFORM @D6652, SUBJ @D6651, FIN @D6650, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   
   [COORD @D6659, AGR [CASE @D6658, COUNT @D6657, PER @D6656, PLU @D6655, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6664, AGR [CASE @D6663, COUNT @D6662, PER @D6661, 
            PLU @D6660, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6669, AGR [CASE @D6668, COUNT @D6667, PER @D6666, 
            PLU @D6665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6674, AGR [CASE @D6673, COUNT @D6672, PER @D6671, 
            PLU @D6670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6679, AGR [CASE @D6678, COUNT @D6677, PER @D6676, 
            PLU @D6675, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ARRANGE, 
   [COORD @D6684, AGR [CASE @D6683, COUNT @D6682, PER @D6681, 
            PLU @D6680, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ARRANGE, 
   [COORD @D6689, AGR [CASE @D6688, COUNT @D6687, PER @D6686, 
            PLU @D6685, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ARRANGE.

WORD arranges : 
   [COORD @D6697, AGR [COUNT @D6696, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM FOR_WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6699, AGR [COUNT @D6698, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_PP_INF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6701, AGR [COUNT @D6700, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_WHVP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6703, AGR [COUNT @D6702, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_WHS, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6705, AGR [COUNT @D6704, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SINF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6707, AGR [COUNT @D6706, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6709, AGR [COUNT @D6708, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SBSE, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6711, AGR [COUNT @D6710, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6713, AGR [COUNT @D6712, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6715, 
      AGR [COUNT @D6714, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6717, 
      AGR [COUNT @D6716, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6719, 
      AGR [COUNT @D6718, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6721, 
      AGR [COUNT @D6720, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6723, 
      AGR [COUNT @D6722, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6725, 
      AGR [COUNT @D6724, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6727, 
      AGR [COUNT @D6726, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6729, 
      AGR [COUNT @D6728, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRANGE.

WORD arranging : 
   [COORD @D6740, PRD @D6739, AGR [CASE @D6738, COUNT @D6737, 
            PER @D6736, PLU @D6735, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM FOR_WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6746, PRD @D6745, 
      AGR [CASE @D6744, COUNT @D6743, PER @D6742, PLU @D6741, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_PP_INF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ARRANGE, 
   [COORD @D6752, PRD @D6751, AGR [CASE @D6750, COUNT @D6749, 
            PER @D6748, PLU @D6747, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_WHVP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6758, PRD @D6757, 
      AGR [CASE @D6756, COUNT @D6755, PER @D6754, PLU @D6753, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_WHS, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6764, PRD @D6763, AGR [CASE @D6762, COUNT @D6761, 
            PER @D6760, PLU @D6759, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SINF, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6770, PRD @D6769, 
      AGR [CASE @D6768, COUNT @D6767, PER @D6766, PLU @D6765, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6776, PRD @D6775, AGR [CASE @D6774, COUNT @D6773, 
            PER @D6772, PLU @D6771, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SBSE, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6782, PRD @D6781, 
      AGR [CASE @D6780, COUNT @D6779, PER @D6778, PLU @D6777, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ARRANGE, 
   [COORD @D6788, PRD @D6787, AGR [CASE @D6786, COUNT @D6785, 
            PER @D6784, PLU @D6783, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6794, PRD @D6793, 
      AGR [CASE @D6792, COUNT @D6791, PER @D6790, PLU @D6789, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ARRANGE, 
   [COORD @D6800, PRD @D6799, AGR [CASE @D6798, COUNT @D6797, 
            PER @D6796, PLU @D6795, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6806, PRD @D6805, 
      AGR [CASE @D6804, COUNT @D6803, PER @D6802, PLU @D6801, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6812, PRD @D6811, 
      AGR [CASE @D6810, COUNT @D6809, PER @D6808, PLU @D6807, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6818, PRD @D6817, 
      AGR [CASE @D6816, COUNT @D6815, PER @D6814, PLU @D6813, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6824, PRD @D6823, 
      AGR [CASE @D6822, COUNT @D6821, PER @D6820, PLU @D6819, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6830, PRD @D6829, 
      AGR [CASE @D6828, COUNT @D6827, PER @D6826, PLU @D6825, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE, 
   [COORD @D6836, PRD @D6835, 
      AGR [CASE @D6834, COUNT @D6833, PER @D6832, PLU @D6831, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRANGE.

WORD arrest : 
   [COORD @D6843, AGR [COUNT @D6842, PER @D6841, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ARREST, 
   [COORD @D6845, AGR [COUNT @D6844, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ARREST, 
   [COORD @D6847, 
      AGR [COUNT @D6846, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ARREST, 
   [COORD @D6851, 
      AGR [COUNT @D6850, PER @D6849, PLU @D6848, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ARREST, 
   [COORD @D6857, PAST @D6856, AGR [CASE @D6855, COUNT @D6854, 
            PER @D6853, PLU @D6852, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ARREST.

WORD arrested : 
   [COORD @D6867, AGR [CASE @D6866, COUNT @D6865, PER @D6864, 
            PLU @D6863, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ARREST, 
   [COORD @D6872, AGR [CASE @D6871, COUNT @D6870, PER @D6869, 
            PLU @D6868, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ARREST, 
   [COORD @D6877, AGR [CASE @D6876, COUNT @D6875, PER @D6874, 
            PLU @D6873, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ARREST.

WORD arresting : 
   [COORD @D6890, PRD @D6889, AGR [CASE @D6888, COUNT @D6887, 
            PER @D6886, PLU @D6885, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ARREST.

WORD arrests : 
   [COORD @D6897, AGR [COUNT @D6896, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARREST.

WORD arrive : 
   [COORD @D6905, AGR [COUNT @D6904, PER @D6903, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : ARRIVE, 
   [COORD @D6907, AGR [COUNT @D6906, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : ARRIVE, 
   [COORD @D6909, AGR [COUNT @D6908, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : ARRIVE, 
   [COORD @D6913, AGR [COUNT @D6912, PER @D6911, PLU @D6910, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : ARRIVE, 
   [COORD @D6919, PAST @D6918, AGR [CASE @D6917, COUNT @D6916, 
            PER @D6915, PLU @D6914, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, ARITY 2] : ARRIVE, 
   [COORD @D6922, 
      AGR [COUNT @D6921, PER @D6920, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ARRIVE, 
   [COORD @D6924, 
      AGR [COUNT @D6923, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ARRIVE, 
   [COORD @D6926, 
      AGR [COUNT @D6925, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ARRIVE, 
   [COORD @D6930, 
      AGR [COUNT @D6929, PER @D6928, PLU @D6927, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ARRIVE, 
   [COORD @D6936, PAST @D6935, AGR [CASE @D6934, COUNT @D6933, 
            PER @D6932, PLU @D6931, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ARRIVE.

WORD arrived : 
   [COORD @D6947, AGR [CASE @D6946, COUNT @D6945, PER @D6944, 
            PLU @D6943, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ARRIVE, 
   [COORD @D6952, AGR [CASE @D6951, COUNT @D6950, PER @D6949, 
            PLU @D6948, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ARRIVE, 
   [COORD @D6957, AGR [CASE @D6956, COUNT @D6955, PER @D6954, 
            PLU @D6953, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRIVE, 
   [COORD @D6962, AGR [CASE @D6961, COUNT @D6960, PER @D6959, 
            PLU @D6958, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ARRIVE, 
   [COORD @D6967, AGR [CASE @D6966, COUNT @D6965, PER @D6964, 
            PLU @D6963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ARRIVE.

WORD arrives : 
   [COORD @D6975, AGR [COUNT @D6974, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : ARRIVE, 
   [COORD @D6977, AGR [COUNT @D6976, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ARRIVE.

WORD arriving : 
   [COORD @D6988, PRD @D6987, AGR [CASE @D6986, COUNT @D6985, 
            PER @D6984, PLU @D6983, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRIVE, 
   [COORD @D6994, PRD @D6993, 
      AGR [CASE @D6992, COUNT @D6991, PER @D6990, PLU @D6989, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ARRIVE.

WORD ask : 
   [COORD @D7001, AGR [COUNT @D7000, PER @D6999, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7003, AGR [COUNT @D7002, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, LAT -, ARITY 3] : 
   ASK, 
   [COORD @D7005, AGR [COUNT @D7004, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, LAT -, ARITY 3] : 
   ASK, 
   [COORD @D7009, AGR [COUNT @D7008, PER @D7007, PLU @D7006, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7015, PAST @D7014, AGR [CASE @D7013, COUNT @D7012, 
            PER @D7011, PLU @D7010, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, LAT -, ARITY 3] : ASK, 
   [COORD @D7018, AGR [COUNT @D7017, PER @D7016, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHVP, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7020, AGR [COUNT @D7019, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHVP, LAT -, ARITY 3] : ASK, 
   [COORD @D7022, 
      AGR [COUNT @D7021, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHVP, LAT -, ARITY 3] : ASK, 
   [COORD @D7026, 
      AGR [COUNT @D7025, PER @D7024, PLU @D7023, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHVP, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7032, PAST @D7031, AGR [CASE @D7030, COUNT @D7029, 
            PER @D7028, PLU @D7027, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_WHVP, LAT -, ARITY 3] : ASK, 
   [COORD @D7035, AGR [COUNT @D7034, PER @D7033, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHS, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7037, AGR [COUNT @D7036, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHS, LAT -, ARITY 3] : ASK, 
   [COORD @D7039, 
      AGR [COUNT @D7038, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHS, LAT -, ARITY 3] : ASK, 
   [COORD @D7043, 
      AGR [COUNT @D7042, PER @D7041, PLU @D7040, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_WHS, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7049, PAST @D7048, AGR [CASE @D7047, COUNT @D7046, 
            PER @D7045, PLU @D7044, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_WHS, LAT -, ARITY 3] : ASK, 
   [COORD @D7052, AGR [COUNT @D7051, PER @D7050, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7054, AGR [COUNT @D7053, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, ARITY 3] : ASK, 
   [COORD @D7056, 
      AGR [COUNT @D7055, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, ARITY 3] : ASK, 
   [COORD @D7060, 
      AGR [COUNT @D7059, PER @D7058, PLU @D7057, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7066, PAST @D7065, AGR [CASE @D7064, COUNT @D7063, 
            PER @D7062, PLU @D7061, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_NP, LAT -, ARITY 3] : ASK, 
   [COORD @D7069, AGR [COUNT @D7068, PER @D7067, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ASK, 
   [COORD @D7071, AGR [COUNT @D7070, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7073, AGR [COUNT @D7072, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7077, AGR [COUNT @D7076, PER @D7075, PLU @D7074, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ASK, 
   [COORD @D7083, PAST @D7082, AGR [CASE @D7081, COUNT @D7080, 
            PER @D7079, PLU @D7078, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, LAT -, ARITY 3] : ASK, 
   [COORD @D7086, AGR [COUNT @D7085, PER @D7084, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM OF, 
      LAT -, ARITY 3] : ASK, 
   [COORD @D7088, AGR [COUNT @D7087, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM OF, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7090, AGR [COUNT @D7089, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM OF, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7094, AGR [COUNT @D7093, PER @D7092, PLU @D7091, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM OF, 
      LAT -, ARITY 3] : ASK, 
   [COORD @D7100, PAST @D7099, AGR [CASE @D7098, COUNT @D7097, 
            PER @D7096, PLU @D7095, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM OF, LAT -, ARITY 3] : ASK, 
   [COORD @D7103, AGR [COUNT @D7102, PER @D7101, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      LAT -, ARITY 3] : ASK, 
   [COORD @D7105, AGR [COUNT @D7104, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7107, AGR [COUNT @D7106, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, LAT -, 
      ARITY 3] : ASK, 
   [COORD @D7111, AGR [COUNT @D7110, PER @D7109, PLU @D7108, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      LAT -, ARITY 3] : ASK, 
   [COORD @D7117, PAST @D7116, AGR [CASE @D7115, COUNT @D7114, 
            PER @D7113, PLU @D7112, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, LAT -, ARITY 3] : ASK, 
   [COORD @D7120, AGR [COUNT @D7119, PER @D7118, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ASK, 
   [COORD @D7122, AGR [COUNT @D7121, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ASK, 
   [COORD @D7124, AGR [COUNT @D7123, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ASK, 
   [COORD @D7128, AGR [COUNT @D7127, PER @D7126, PLU @D7125, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ASK, 
   [COORD @D7134, PAST @D7133, AGR [CASE @D7132, COUNT @D7131, 
            PER @D7130, PLU @D7129, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, ARITY 2] : ASK, 
   [COORD @D7137, 
      AGR [COUNT @D7136, PER @D7135, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, 
      ARITY 2] : ASK, 
   [COORD @D7139, AGR [COUNT @D7138, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, ARITY 2] : ASK, 
   [COORD @D7141, AGR [COUNT @D7140, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, ARITY 2] : ASK, 
   [COORD @D7145, AGR [COUNT @D7144, PER @D7143, PLU @D7142, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, ARITY 2] : ASK, 
   [COORD @D7151, PAST @D7150, AGR [CASE @D7149, COUNT @D7148, 
            PER @D7147, PLU @D7146, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, ARITY 2] : ASK, 
   [COORD @D7154, 
      AGR [COUNT @D7153, PER @D7152, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, ARITY 2] : ASK, 
   [COORD @D7156, 
      AGR [COUNT @D7155, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, ARITY 2] : ASK, 
   [COORD @D7158, 
      AGR [COUNT @D7157, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, ARITY 2] : ASK, 
   [COORD @D7162, 
      AGR [COUNT @D7161, PER @D7160, PLU @D7159, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHVP, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7168, PAST @D7167, AGR [CASE @D7166, COUNT @D7165, 
            PER @D7164, PLU @D7163, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT WHVP, LAT -, ARITY 2] : ASK, 
   [COORD @D7171, AGR [COUNT @D7170, PER @D7169, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7173, AGR [COUNT @D7172, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, ARITY 2] : ASK, 
   [COORD @D7175, 
      AGR [COUNT @D7174, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, ARITY 2] : ASK, 
   [COORD @D7179, 
      AGR [COUNT @D7178, PER @D7177, PLU @D7176, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT WHS, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7185, PAST @D7184, AGR [CASE @D7183, COUNT @D7182, 
            PER @D7181, PLU @D7180, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT WHS, LAT -, ARITY 2] : ASK, 
   [COORD @D7188, AGR [COUNT @D7187, PER @D7186, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7190, AGR [COUNT @D7189, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, ARITY 2] : ASK, 
   [COORD @D7192, 
      AGR [COUNT @D7191, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, ARITY 2] : ASK, 
   [COORD @D7196, 
      AGR [COUNT @D7195, PER @D7194, PLU @D7193, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SINF, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7202, PAST @D7201, AGR [CASE @D7200, COUNT @D7199, 
            PER @D7198, PLU @D7197, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SINF, LAT -, ARITY 2] : ASK, 
   [COORD @D7205, AGR [COUNT @D7204, PER @D7203, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7207, AGR [COUNT @D7206, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   ASK, 
   [COORD @D7209, AGR [COUNT @D7208, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   ASK, 
   [COORD @D7213, AGR [COUNT @D7212, PER @D7211, PLU @D7210, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7219, PAST @D7218, AGR [CASE @D7217, COUNT @D7216, 
            PER @D7215, PLU @D7214, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_INF, LAT -, ARITY 2] : ASK, 
   [COORD @D7222, AGR [COUNT @D7221, PER @D7220, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7224, AGR [COUNT @D7223, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, ARITY 2] : ASK, 
   [COORD @D7226, 
      AGR [COUNT @D7225, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, ARITY 2] : ASK, 
   [COORD @D7230, 
      AGR [COUNT @D7229, PER @D7228, PLU @D7227, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SBSE, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7236, PAST @D7235, AGR [CASE @D7234, COUNT @D7233, 
            PER @D7232, PLU @D7231, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SBSE, LAT -, ARITY 2] : ASK, 
   [COORD @D7239, AGR [COUNT @D7238, PER @D7237, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7241, AGR [COUNT @D7240, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ASK, 
   [COORD @D7243, 
      AGR [COUNT @D7242, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ASK, 
   [COORD @D7247, 
      AGR [COUNT @D7246, PER @D7245, PLU @D7244, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7253, PAST @D7252, AGR [CASE @D7251, COUNT @D7250, 
            PER @D7249, PLU @D7248, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ASK, 
   [COORD @D7256, AGR [COUNT @D7255, PER @D7254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : ASK, 
   [COORD @D7258, AGR [COUNT @D7257, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   ASK, 
   [COORD @D7260, AGR [COUNT @D7259, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : 
   ASK, 
   [COORD @D7264, AGR [COUNT @D7263, PER @D7262, PLU @D7261, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : ASK, 
   [COORD @D7270, PAST @D7269, AGR [CASE @D7268, COUNT @D7267, 
            PER @D7266, PLU @D7265, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : ASK, 
   [COORD @D7273, AGR [COUNT @D7272, PER @D7271, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OUT, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7275, AGR [COUNT @D7274, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OUT, LAT -, ARITY 2] : ASK, 
   
   [COORD @D7277, AGR [COUNT @D7276, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OUT, LAT -, ARITY 2] : ASK, 
   
   [COORD @D7281, AGR [COUNT @D7280, PER @D7279, PLU @D7278, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OUT, LAT -, 
      ARITY 2] : ASK, 
   [COORD @D7287, PAST @D7286, AGR [CASE @D7285, COUNT @D7284, 
            PER @D7283, PLU @D7282, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      PRT OUT, LAT -, ARITY 2] : ASK, 
   [COORD @D7290, AGR [COUNT @D7289, PER @D7288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ASK, 
   [COORD @D7292, AGR [COUNT @D7291, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ASK, 
   [COORD @D7294, 
      AGR [COUNT @D7293, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ASK, 
   [COORD @D7298, 
      AGR [COUNT @D7297, PER @D7296, PLU @D7295, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ASK, 
   [COORD @D7304, PAST @D7303, AGR [CASE @D7302, COUNT @D7301, 
            PER @D7300, PLU @D7299, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ASK, 
   [COORD @D7307, AGR [COUNT @D7306, PER @D7305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      LAT -, ARITY 1] : ASK, 
   [COORD @D7309, AGR [COUNT @D7308, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OUT, LAT -, ARITY 1] : 
   ASK, 
   [COORD @D7311, AGR [COUNT @D7310, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OUT, LAT -, ARITY 1] : 
   ASK, 
   [COORD @D7315, AGR [COUNT @D7314, PER @D7313, PLU @D7312, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      LAT -, ARITY 1] : ASK, 
   [COORD @D7321, PAST @D7320, AGR [CASE @D7319, COUNT @D7318, 
            PER @D7317, PLU @D7316, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, LAT -, ARITY 1] : ASK.

WORD asked : 
   [COORD @D7331, AGR [CASE @D7330, COUNT @D7329, PER @D7328, PLU 
               @D7327, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7336, AGR [CASE @D7335, COUNT @D7334, PER @D7333, 
            PLU @D7332, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7342, AGR [CASE @D7341, NFORM @D7340, COUNT @D7339, 
            PER @D7338, PLU @D7337, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7347, AGR [CASE @D7346, COUNT @D7345, PER @D7344, 
            PLU @D7343, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_WHVP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASK, 
   [COORD @D7352, AGR [CASE @D7351, COUNT @D7350, PER @D7349, 
            PLU @D7348, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7357, AGR [CASE @D7356, COUNT @D7355, PER @D7354, 
            PLU @D7353, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7362, AGR [CASE @D7361, COUNT @D7360, PER @D7359, 
            PLU @D7358, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_WHS, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASK, 
   [COORD @D7367, AGR [CASE @D7366, COUNT @D7365, PER @D7364, 
            PLU @D7363, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7372, AGR [CASE @D7371, COUNT @D7370, PER @D7369, 
            PLU @D7368, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7377, AGR [CASE @D7376, COUNT @D7375, PER @D7374, 
            PLU @D7373, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASK, 
   [COORD @D7382, AGR [CASE @D7381, COUNT @D7380, PER @D7379, 
            PLU @D7378, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7387, AGR [CASE @D7386, COUNT @D7385, PER @D7384, 
            PLU @D7383, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7392, AGR [CASE @D7391, COUNT @D7390, PER @D7389, 
            PLU @D7388, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7397, AGR [CASE @D7396, COUNT @D7395, PER @D7394, 
            PLU @D7393, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7402, AGR [CASE @D7401, COUNT @D7400, PER @D7399, 
            PLU @D7398, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK, 
   [COORD @D7407, AGR [CASE @D7406, COUNT @D7405, PER @D7404, 
            PLU @D7403, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7412, AGR [CASE @D7411, COUNT @D7410, PER @D7409, 
            PLU @D7408, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7417, AGR [CASE @D7416, COUNT @D7415, PER @D7414, 
            PLU @D7413, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK, 
   [COORD @D7422, AGR [CASE @D7421, COUNT @D7420, PER @D7419, 
            PLU @D7418, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7427, AGR [CASE @D7426, COUNT @D7425, PER @D7424, 
            PLU @D7423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7432, AGR [CASE @D7431, COUNT @D7430, PER @D7429, 
            PLU @D7428, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK, 
   [COORD @D7437, AGR [CASE @D7436, COUNT @D7435, PER @D7434, 
            PLU @D7433, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7442, AGR [CASE @D7441, COUNT @D7440, PER @D7439, 
            PLU @D7438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7447, AGR [CASE @D7446, COUNT @D7445, PER @D7444, 
            PLU @D7443, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK, 
   [COORD @D7452, AGR [CASE @D7451, COUNT @D7450, PER @D7449, 
            PLU @D7448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7457, AGR [CASE @D7456, COUNT @D7455, PER @D7454, 
            PLU @D7453, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK, 
   [COORD @D7462, AGR [CASE @D7461, COUNT @D7460, PER @D7459, 
            PLU @D7458, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AFTER, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7467, AGR [CASE @D7466, COUNT @D7465, PER @D7464, 
            PLU @D7463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7472, AGR [CASE @D7471, COUNT @D7470, PER @D7469, 
            PLU @D7468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7477, AGR [CASE @D7476, COUNT @D7475, PER @D7474, 
            PLU @D7473, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7482, AGR [CASE @D7481, COUNT @D7480, PER @D7479, 
            PLU @D7478, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7487, AGR [CASE @D7486, COUNT @D7485, PER @D7484, 
            PLU @D7483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7492, AGR [CASE @D7491, COUNT @D7490, PER @D7489, 
            PLU @D7488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7497, AGR [CASE @D7496, COUNT @D7495, PER @D7494, 
            PLU @D7493, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7502, AGR [CASE @D7501, COUNT @D7500, PER @D7499, 
            PLU @D7498, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7507, AGR [CASE @D7506, COUNT @D7505, PER @D7504, 
            PLU @D7503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7512, AGR [CASE @D7511, COUNT @D7510, PER @D7509, 
            PLU @D7508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7517, AGR [CASE @D7516, COUNT @D7515, PER @D7514, 
            PLU @D7513, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ASK, 
   [COORD @D7522, AGR [CASE @D7521, COUNT @D7520, PER @D7519, 
            PLU @D7518, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASK, 
   [COORD @D7527, AGR [CASE @D7526, COUNT @D7525, PER @D7524, 
            PLU @D7523, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ASK, 
   [COORD @D7532, AGR [CASE @D7531, COUNT @D7530, PER @D7529, 
            PLU @D7528, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7537, AGR [CASE @D7536, COUNT @D7535, PER @D7534, 
            PLU @D7533, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK, 
   [COORD @D7542, AGR [CASE @D7541, COUNT @D7540, PER @D7539, 
            PLU @D7538, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7547, AGR [CASE @D7546, COUNT @D7545, PER @D7544, 
            PLU @D7543, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK, 
   [COORD @D7552, AGR [CASE @D7551, COUNT @D7550, PER @D7549, 
            PLU @D7548, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7557, AGR [CASE @D7556, COUNT @D7555, PER @D7554, 
            PLU @D7553, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7562, AGR [CASE @D7561, COUNT @D7560, PER @D7559, 
            PLU @D7558, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7567, AGR [CASE @D7566, COUNT @D7565, PER @D7564, 
            PLU @D7563, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7572, AGR [CASE @D7571, COUNT @D7570, PER @D7569, 
            PLU @D7568, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASK.

WORD asking : 
   [COORD @D7585, PRD @D7584, AGR [CASE @D7583, COUNT @D7582, PER 
               @D7581, PLU @D7580, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7591, PRD @D7590, AGR [CASE @D7589, COUNT @D7588, 
            PER @D7587, PLU @D7586, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7597, PRD @D7596, AGR [CASE @D7595, COUNT @D7594, 
            PER @D7593, PLU @D7592, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7603, PRD @D7602, AGR [CASE @D7601, COUNT @D7600, 
            PER @D7599, PLU @D7598, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7609, PRD @D7608, AGR [CASE @D7607, COUNT @D7606, 
            PER @D7605, PLU @D7604, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7615, PRD @D7614, 
      AGR [CASE @D7613, COUNT @D7612, PER @D7611, PLU @D7610, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASK, 
   [COORD @D7621, PRD @D7620, AGR [CASE @D7619, COUNT @D7618, 
            PER @D7617, PLU @D7616, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7627, PRD @D7626, 
      AGR [CASE @D7625, COUNT @D7624, PER @D7623, PLU @D7622, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASK, 
   [COORD @D7633, PRD @D7632, AGR [CASE @D7631, COUNT @D7630, 
            PER @D7629, PLU @D7628, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7639, PRD @D7638, 
      AGR [CASE @D7637, COUNT @D7636, PER @D7635, PLU @D7634, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7645, PRD @D7644, 
      AGR [CASE @D7643, COUNT @D7642, PER @D7641, PLU @D7640, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7651, PRD @D7650, 
      AGR [CASE @D7649, COUNT @D7648, PER @D7647, PLU @D7646, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7657, PRD @D7656, 
      AGR [CASE @D7655, COUNT @D7654, PER @D7653, PLU @D7652, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7663, PRD @D7662, 
      AGR [CASE @D7661, COUNT @D7660, PER @D7659, PLU @D7658, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7669, PRD @D7668, 
      AGR [CASE @D7667, COUNT @D7666, PER @D7665, PLU @D7664, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7675, PRD @D7674, 
      AGR [CASE @D7673, COUNT @D7672, PER @D7671, PLU @D7670, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK, 
   
   [COORD @D7681, PRD @D7680, AGR [CASE @D7679, COUNT @D7678, PER @D7677, 
            PLU @D7676, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASK, 
   [COORD @D7687, PRD @D7686, AGR [CASE @D7685, COUNT @D7684, 
            PER @D7683, PLU @D7682, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ASK, 
   [COORD @D7693, PRD @D7692, AGR [CASE @D7691, COUNT @D7690, 
            PER @D7689, PLU @D7688, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ASK.

WORD asks : 
   [COORD @D7700, AGR [COUNT @D7699, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7702, 
      AGR [COUNT @D7701, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7704, 
      AGR [COUNT @D7703, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7706, 
      AGR [COUNT @D7705, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7708, 
      AGR [COUNT @D7707, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7710, 
      AGR [COUNT @D7709, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7712, 
      AGR [COUNT @D7711, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7714, 
      AGR [COUNT @D7713, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7716, 
      AGR [COUNT @D7715, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7718, 
      AGR [COUNT @D7717, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7720, 
      AGR [COUNT @D7719, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7722, 
      AGR [COUNT @D7721, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7724, 
      AGR [COUNT @D7723, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7726, 
      AGR [COUNT @D7725, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7728, 
      AGR [COUNT @D7727, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7730, 
      AGR [COUNT @D7729, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7732, 
      AGR [COUNT @D7731, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7734, 
      AGR [COUNT @D7733, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK, 
   [COORD @D7736, 
      AGR [COUNT @D7735, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASK.

WORD associate : 
   [COORD @D7746, AGR [COUNT @D7745, PER @D7744, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, LAT -, ARITY 3] : ASSOCIATE, 
   [COORD @D7748, AGR [COUNT @D7747, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, LAT -, 
      ARITY 3] : ASSOCIATE, 
   [COORD @D7750, AGR [COUNT @D7749, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, LAT -, 
      ARITY 3] : ASSOCIATE, 
   [COORD @D7754, AGR [COUNT @D7753, PER @D7752, PLU @D7751, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, LAT -, ARITY 3] : ASSOCIATE, 
   [COORD @D7760, PAST @D7759, 
      AGR [CASE @D7758, COUNT @D7757, PER @D7756, PLU @D7755, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, LAT -, ARITY 3] : 
   ASSOCIATE, 
   [COORD @D7763, AGR [COUNT @D7762, PER @D7761, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ASSOCIATE, 
   [COORD @D7765, AGR [COUNT @D7764, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ASSOCIATE, 
   
   [COORD @D7767, AGR [COUNT @D7766, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ASSOCIATE, 
   
   [COORD @D7771, AGR [COUNT @D7770, PER @D7769, PLU @D7768, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ASSOCIATE, 
   [COORD @D7777, PAST @D7776, AGR [CASE @D7775, COUNT @D7774, 
            PER @D7773, PLU @D7772, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ASSOCIATE, 
   [COORD @D7780, AGR [COUNT @D7779, PER @D7778, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      LAT -, ARITY 2] : ASSOCIATE, 
   [COORD @D7782, AGR [COUNT @D7781, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, LAT -, 
      ARITY 2] : ASSOCIATE, 
   [COORD @D7784, AGR [COUNT @D7783, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, LAT -, 
      ARITY 2] : ASSOCIATE, 
   [COORD @D7788, AGR [COUNT @D7787, PER @D7786, PLU @D7785, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      LAT -, ARITY 2] : ASSOCIATE, 
   [COORD @D7794, PAST @D7793, AGR [CASE @D7792, COUNT @D7791, 
            PER @D7790, PLU @D7789, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, LAT -, ARITY 2] : ASSOCIATE, 
   [COORD @D7797, AGR 
         [COUNT @D7796, PER @D7795, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : 
   ASSOCIATE, 
   [COORD @D7799, AGR [COUNT @D7798, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : 
   ASSOCIATE, 
   [COORD @D7801, AGR [COUNT @D7800, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : 
   ASSOCIATE, 
   [COORD @D7805, AGR [COUNT @D7804, PER @D7803, PLU @D7802, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ASSOCIATE, 
   [COORD @D7811, PAST @D7810, AGR [CASE @D7809, COUNT @D7808, 
            PER @D7807, PLU @D7806, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ASSOCIATE.

WORD associated : 
   [COORD @D7824, AGR [CASE @D7823, COUNT @D7822, PER @D7821, 
            PLU @D7820, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7829, AGR [CASE @D7828, COUNT @D7827, PER @D7826, 
            PLU @D7825, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7834, AGR [CASE @D7833, COUNT @D7832, PER @D7831, 
            PLU @D7830, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7839, AGR [CASE @D7838, COUNT @D7837, PER @D7836, 
            PLU @D7835, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASSOCIATE, 
   [COORD @D7844, AGR [CASE @D7843, COUNT @D7842, PER @D7841, 
            PLU @D7840, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ASSOCIATE, 
   [COORD @D7849, AGR [CASE @D7848, COUNT @D7847, PER @D7846, 
            PLU @D7845, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ASSOCIATE, 
   [COORD @D7854, AGR [CASE @D7853, COUNT @D7852, PER @D7851, 
            PLU @D7850, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7859, AGR [CASE @D7858, COUNT @D7857, PER @D7856, 
            PLU @D7855, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7864, AGR [CASE @D7863, COUNT @D7862, PER @D7861, 
            PLU @D7860, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7869, AGR [CASE @D7868, COUNT @D7867, PER @D7866, 
            PLU @D7865, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ASSOCIATE.

WORD associates : 
   [COORD @D7879, AGR [COUNT @D7878, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ASSOCIATE, 
   [COORD @D7881, AGR [COUNT @D7880, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7883, 
      AGR [COUNT @D7882, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ASSOCIATE, 
   [COORD @D7885, AGR [COUNT @D7884, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASSOCIATE.

WORD associating : 
   [COORD @D7898, PRD @D7897, AGR [CASE @D7896, COUNT @D7895, 
            PER @D7894, PLU @D7893, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7904, PRD @D7903, 
      AGR [CASE @D7902, COUNT @D7901, PER @D7900, PLU @D7899, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSOCIATE, 
   [COORD @D7910, PRD @D7909, 
      AGR [CASE @D7908, COUNT @D7907, PER @D7906, PLU @D7905, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ASSOCIATE, 
   [COORD @D7916, PRD @D7915, AGR [CASE @D7914, COUNT @D7913, 
            PER @D7912, PLU @D7911, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ASSOCIATE.

WORD assume : 
   [COORD @D7924, AGR [COUNT @D7923, PER @D7922, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7926, AGR [COUNT @D7925, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ASSUME, 
   [COORD @D7928, 
      AGR [COUNT @D7927, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, ARITY 2] : ASSUME, 
   [COORD @D7932, 
      AGR [COUNT @D7931, PER @D7930, PLU @D7929, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7938, PAST @D7937, AGR [CASE @D7936, COUNT @D7935, 
            PER @D7934, PLU @D7933, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : ASSUME, 
   [COORD @D7941, AGR [COUNT @D7940, PER @D7939, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7943, AGR [COUNT @D7942, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, ARITY 2] : 
   ASSUME, 
   [COORD @D7945, AGR [COUNT @D7944, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, ARITY 2] : 
   ASSUME, 
   [COORD @D7949, AGR [COUNT @D7948, PER @D7947, PLU @D7946, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7955, PAST @D7954, AGR [CASE @D7953, COUNT @D7952, 
            PER @D7951, PLU @D7950, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, LAT -, ARITY 2] : ASSUME, 
   [COORD @D7958, AGR [COUNT @D7957, PER @D7956, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7960, AGR [COUNT @D7959, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, ARITY 2] : 
   ASSUME, 
   [COORD @D7962, AGR [COUNT @D7961, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, ARITY 2] : 
   ASSUME, 
   [COORD @D7966, AGR [COUNT @D7965, PER @D7964, PLU @D7963, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7972, PAST @D7971, AGR [CASE @D7970, COUNT @D7969, 
            PER @D7968, PLU @D7967, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, LAT -, ARITY 2] : ASSUME, 
   [COORD @D7975, AGR [COUNT @D7974, PER @D7973, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7977, AGR [COUNT @D7976, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, ARITY 2] : 
   ASSUME, 
   [COORD @D7979, AGR [COUNT @D7978, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, ARITY 2] : 
   ASSUME, 
   [COORD @D7983, AGR [COUNT @D7982, PER @D7981, PLU @D7980, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7989, PAST @D7988, AGR [CASE @D7987, COUNT @D7986, 
            PER @D7985, PLU @D7984, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, LAT -, ARITY 2] : ASSUME, 
   [COORD @D7992, AGR [COUNT @D7991, PER @D7990, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D7994, AGR [COUNT @D7993, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ASSUME, 
   [COORD @D7996, 
      AGR [COUNT @D7995, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ASSUME, 
   [COORD @D8000, 
      AGR [COUNT @D7999, PER @D7998, PLU @D7997, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ASSUME, 
   [COORD @D8006, PAST @D8005, AGR [CASE @D8004, COUNT @D8003, 
            PER @D8002, PLU @D8001, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ASSUME.

WORD assumed : 
   [COORD @D8017, AGR [UB @D8016, VFORM @D8015, SUBJ @D8014, FIN @D8013, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8022, 
      AGR [CASE @D8021, COUNT @D8020, PER @D8019, PLU @D8018, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8027, 
      AGR [CASE @D8026, COUNT @D8025, PER @D8024, PLU @D8023, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8032, 
      AGR [CASE @D8031, COUNT @D8030, PER @D8029, PLU @D8028, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT OC_NP, CONJ NULL, 
      SUBTYPE RAIS, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8037, 
      AGR [CASE @D8036, COUNT @D8035, PER @D8034, PLU @D8033, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8042, 
      AGR [CASE @D8041, COUNT @D8040, PER @D8039, PLU @D8038, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8048, 
      AGR [CASE @D8047, NFORM @D8046, COUNT @D8045, PER @D8044, 
            PLU @D8043, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASSUME, 
   [COORD @D8053, AGR [UB @D8052, VFORM @D8051, SUBJ @D8050, FIN @D8049, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8058, 
      AGR [CASE @D8057, COUNT @D8056, PER @D8055, PLU @D8054, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8063, 
      AGR [CASE @D8062, COUNT @D8061, PER @D8060, PLU @D8059, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8068, 
      AGR [CASE @D8067, COUNT @D8066, PER @D8065, PLU @D8064, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8073, 
      AGR [CASE @D8072, COUNT @D8071, PER @D8070, PLU @D8069, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8079, 
      AGR [CASE @D8078, NFORM @D8077, COUNT @D8076, PER @D8075, 
            PLU @D8074, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ASSUME, 
   [COORD @D8084, AGR [UB @D8083, VFORM @D8082, SUBJ @D8081, FIN @D8080, 
            N -, V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8089, 
      AGR [CASE @D8088, COUNT @D8087, PER @D8086, PLU @D8085, NFORM NORM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8094, 
      AGR [CASE @D8093, COUNT @D8092, PER @D8091, PLU @D8090, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8099, 
      AGR [CASE @D8098, COUNT @D8097, PER @D8096, PLU @D8095, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ASSUME.

WORD assumes : 
   [COORD @D8107, AGR [COUNT @D8106, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8109, 
      AGR [COUNT @D8108, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8111, 
      AGR [COUNT @D8110, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8113, 
      AGR [COUNT @D8112, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8115, 
      AGR [COUNT @D8114, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ASSUME.

WORD assuming : 
   [COORD @D8126, PRD @D8125, AGR [CASE @D8124, COUNT @D8123, 
            PER @D8122, PLU @D8121, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8132, PRD @D8131, 
      AGR [CASE @D8130, COUNT @D8129, PER @D8128, PLU @D8127, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8138, PRD @D8137, 
      AGR [CASE @D8136, COUNT @D8135, PER @D8134, PLU @D8133, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8144, PRD @D8143, 
      AGR [CASE @D8142, COUNT @D8141, PER @D8140, PLU @D8139, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME, 
   [COORD @D8150, PRD @D8149, 
      AGR [CASE @D8148, COUNT @D8147, PER @D8146, PLU @D8145, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ASSUME.

WORD attach : 
   [COORD @D8161, AGR [COUNT @D8160, PER @D8159, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ATTACH, 
   [COORD @D8163, AGR [COUNT @D8162, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : ATTACH, 
   [COORD @D8165, AGR [COUNT @D8164, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : ATTACH, 
   [COORD @D8169, AGR [COUNT @D8168, PER @D8167, PLU @D8166, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ATTACH, 
   [COORD @D8175, PAST @D8174, 
      AGR [CASE @D8173, COUNT @D8172, PER @D8171, PLU @D8170, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, ARITY 3] : 
   ATTACH, 
   [COORD @D8178, AGR [COUNT @D8177, PER @D8176, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ATTACH, 
   [COORD @D8180, AGR [COUNT @D8179, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ATTACH, 
   [COORD @D8182, AGR [COUNT @D8181, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, LAT -, 
      ARITY 3] : ATTACH, 
   [COORD @D8186, AGR [COUNT @D8185, PER @D8184, PLU @D8183, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      LAT -, ARITY 3] : ATTACH, 
   [COORD @D8192, PAST @D8191, AGR [CASE @D8190, COUNT @D8189, 
            PER @D8188, PLU @D8187, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, LAT -, ARITY 3] : ATTACH, 
   [COORD @D8195, AGR [COUNT @D8194, PER @D8193, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP TO, ARITY 2] : ATTACH, 
   [COORD @D8197, AGR [COUNT @D8196, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP TO, ARITY 2] : ATTACH, 
   [COORD @D8199, AGR [COUNT @D8198, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP TO, ARITY 2] : ATTACH, 
   [COORD @D8203, AGR [COUNT @D8202, PER @D8201, PLU @D8200, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP TO, ARITY 2] : ATTACH, 
   [COORD @D8209, PAST @D8208, 
      AGR [CASE @D8207, COUNT @D8206, PER @D8205, PLU @D8204, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, PREP TO, 
      ARITY 2] : ATTACH, 
   [COORD @D8212, AGR [COUNT @D8211, PER @D8210, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ATTACH, 
   [COORD @D8214, AGR [COUNT @D8213, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ATTACH, 
   [COORD @D8216, AGR [COUNT @D8215, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ATTACH, 
   [COORD @D8220, AGR [COUNT @D8219, PER @D8218, PLU @D8217, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : ATTACH, 
   [COORD @D8226, PAST @D8225, AGR [CASE @D8224, COUNT @D8223, 
            PER @D8222, PLU @D8221, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, ARITY 2] : ATTACH, 
   [COORD @D8229, 
      AGR [COUNT @D8228, PER @D8227, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTACH, 
   [COORD @D8231, 
      AGR [COUNT @D8230, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTACH, 
   [COORD @D8233, 
      AGR [COUNT @D8232, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTACH, 
   [COORD @D8237, 
      AGR [COUNT @D8236, PER @D8235, PLU @D8234, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ATTACH, 
   [COORD @D8243, PAST @D8242, AGR [CASE @D8241, COUNT @D8240, 
            PER @D8239, PLU @D8238, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ATTACH.

WORD attached : 
   [COORD @D8253, AGR [CASE @D8252, COUNT @D8251, PER @D8250, 
            PLU @D8249, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ATTACH, 
   [COORD @D8258, AGR [CASE @D8257, COUNT @D8256, PER @D8255, 
            PLU @D8254, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8263, AGR [CASE @D8262, COUNT @D8261, PER @D8260, 
            PLU @D8259, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8268, AGR [CASE @D8267, COUNT @D8266, PER @D8265, 
            PLU @D8264, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ATTACH, 
   [COORD @D8273, AGR [CASE @D8272, COUNT @D8271, PER @D8270, 
            PLU @D8269, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8278, AGR [CASE @D8277, COUNT @D8276, PER @D8275, 
            PLU @D8274, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8283, AGR [CASE @D8282, COUNT @D8281, PER @D8280, 
            PLU @D8279, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8288, AGR [CASE @D8287, COUNT @D8286, PER @D8285, 
            PLU @D8284, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8293, AGR [CASE @D8292, COUNT @D8291, PER @D8290, 
            PLU @D8289, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8298, AGR [CASE @D8297, COUNT @D8296, PER @D8295, 
            PLU @D8294, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8303, AGR [CASE @D8302, COUNT @D8301, PER @D8300, 
            PLU @D8299, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ATTACH, 
   [COORD @D8308, AGR [CASE @D8307, COUNT @D8306, PER @D8305, 
            PLU @D8304, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ATTACH, 
   [COORD @D8313, AGR [CASE @D8312, COUNT @D8311, PER @D8310, 
            PLU @D8309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ATTACH, 
   [COORD @D8318, AGR [CASE @D8317, COUNT @D8316, PER @D8315, 
            PLU @D8314, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ATTACH.

WORD attaching : 
   [COORD @D8331, PRD @D8330, AGR [CASE @D8329, COUNT @D8328, 
            PER @D8327, PLU @D8326, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8337, PRD @D8336, 
      AGR [CASE @D8335, COUNT @D8334, PER @D8333, PLU @D8332, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ATTACH, 
   [COORD @D8343, PRD @D8342, AGR [CASE @D8341, COUNT @D8340, PER 
               @D8339, PLU @D8338, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ATTACH, 
   [COORD @D8349, PRD @D8348, 
      AGR [CASE @D8347, COUNT @D8346, PER @D8345, PLU @D8344, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ATTACH, 
   [COORD @D8355, PRD @D8354, AGR [CASE @D8353, COUNT @D8352, 
            PER @D8351, PLU @D8350, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ATTACH.

WORD attack : 
   [COORD @D8369, REFL @D8368, COUNT @D8367, PRD @D8366, CASE @D8365, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ATTACK, 
   [COORD @D8373, REFL @D8372, PRD @D8371, CASE @D8370, FIX NOT, INFL +, 
      BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : ATTACK, 
   [COORD @D8377, REFL @D8376, PRD @D8375, CASE @D8374, FIX NOT, INFL +, 
      BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : ATTACK, 
   [COORD @D8380, 
      AGR [COUNT @D8379, PER @D8378, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTACK, 
   [COORD @D8382, 
      AGR [COUNT @D8381, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTACK, 
   [COORD @D8384, 
      AGR [COUNT @D8383, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTACK, 
   [COORD @D8388, 
      AGR [COUNT @D8387, PER @D8386, PLU @D8385, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ATTACK, 
   [COORD @D8394, PAST @D8393, AGR [CASE @D8392, COUNT @D8391, 
            PER @D8390, PLU @D8389, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ATTACK, 
   [COORD @D8397, AGR [COUNT @D8396, PER @D8395, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ATTACK, 
   [COORD @D8399, AGR [COUNT @D8398, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ATTACK, 
   [COORD @D8401, 
      AGR [COUNT @D8400, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, ARITY 1] : ATTACK, 
   [COORD @D8405, 
      AGR [COUNT @D8404, PER @D8403, PLU @D8402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : ATTACK, 
   [COORD @D8411, PAST @D8410, AGR [CASE @D8409, COUNT @D8408, 
            PER @D8407, PLU @D8406, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : ATTACK.

WORD attacked : 
   [COORD @D8422, AGR [CASE @D8421, COUNT @D8420, PER @D8419, 
            PLU @D8418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ATTACK, 
   [COORD @D8427, AGR [CASE @D8426, COUNT @D8425, PER @D8424, 
            PLU @D8423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ATTACK, 
   [COORD @D8432, AGR [CASE @D8431, COUNT @D8430, PER @D8429, 
            PLU @D8428, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ATTACK, 
   [COORD @D8437, AGR [CASE @D8436, COUNT @D8435, PER @D8434, 
            PLU @D8433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ATTACK, 
   [COORD @D8442, AGR [CASE @D8441, COUNT @D8440, PER @D8439, 
            PLU @D8438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ATTACK.

WORD attacking : 
   [COORD @D8458, PRD @D8457, AGR [CASE @D8456, COUNT @D8455, 
            PER @D8454, PLU @D8453, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ATTACK, 
   [COORD @D8464, PRD @D8463, 
      AGR [CASE @D8462, COUNT @D8461, PER @D8460, PLU @D8459, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ATTACK.

WORD attacks : 
   [COORD @D8475, DEMON @D8474, REFL @D8473, PRD @D8472, CASE @D8471, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ATTACK, 
   [COORD @D8480, DEMON @D8479, REFL @D8478, PRD @D8477, CASE @D8476, 
      COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, SUBCAT PP, 
      PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, 
      NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ATTACK, 
   [COORD @D8485, DEMON @D8484, REFL @D8483, PRD @D8482, CASE @D8481, 
      COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, SUBCAT PP, 
      PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, 
      NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ATTACK, 
   [COORD @D8487, 
      AGR [COUNT @D8486, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ATTACK, 
   [COORD @D8489, 
      AGR [COUNT @D8488, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ATTACK.

WORD attempt : 
   [COORD @D8497, REFL @D8496, PRD @D8495, CASE @D8494, FIX NOT, INFL +, 
      BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM AT, COUNT +] : ATTEMPT, 
   [COORD @D8501, REFL @D8500, PRD @D8499, CASE @D8498, FIX NOT, INFL +, 
      BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT VPINF, COUNT +] : ATTEMPT, 
   [COORD @D8506, REFL @D8505, COUNT @D8504, PRD @D8503, CASE @D8502, 
      FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ATTEMPT, 
   [COORD @D8509, 
      AGR [COUNT @D8508, PER @D8507, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, ARITY 2] : ATTEMPT, 
   [COORD @D8511, 
      AGR [COUNT @D8510, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, ARITY 2] : ATTEMPT, 
   [COORD @D8513, 
      AGR [COUNT @D8512, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, ARITY 2] : ATTEMPT, 
   [COORD @D8517, 
      AGR [COUNT @D8516, PER @D8515, PLU @D8514, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, LAT -, 
      ARITY 2] : ATTEMPT, 
   [COORD @D8523, PAST @D8522, AGR [CASE @D8521, COUNT @D8520, 
            PER @D8519, PLU @D8518, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_ING, LAT -, ARITY 2] : ATTEMPT, 
   [COORD @D8526, AGR [COUNT @D8525, PER @D8524, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : ATTEMPT, 
   [COORD @D8528, AGR [COUNT @D8527, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   ATTEMPT, 
   [COORD @D8530, AGR [COUNT @D8529, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, ARITY 2] : 
   ATTEMPT, 
   [COORD @D8534, AGR [COUNT @D8533, PER @D8532, PLU @D8531, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, LAT -, 
      ARITY 2] : ATTEMPT, 
   [COORD @D8540, PAST @D8539, AGR [CASE @D8538, COUNT @D8537, 
            PER @D8536, PLU @D8535, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_INF, LAT -, ARITY 2] : ATTEMPT, 
   [COORD @D8543, AGR [COUNT @D8542, PER @D8541, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ATTEMPT, 
   [COORD @D8545, AGR [COUNT @D8544, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTEMPT, 
   [COORD @D8547, 
      AGR [COUNT @D8546, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, ARITY 2] : ATTEMPT, 
   [COORD @D8551, 
      AGR [COUNT @D8550, PER @D8549, PLU @D8548, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : ATTEMPT, 
   [COORD @D8557, PAST @D8556, AGR [CASE @D8555, COUNT @D8554, 
            PER @D8553, PLU @D8552, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : ATTEMPT.

WORD attempted : 
   [COORD @D8568, AGR [CASE @D8567, COUNT @D8566, PER @D8565, 
            PLU @D8564, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8573, AGR [CASE @D8572, COUNT @D8571, PER @D8570, 
            PLU @D8569, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8578, AGR [CASE @D8577, COUNT @D8576, PER @D8575, 
            PLU @D8574, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8583, AGR [CASE @D8582, COUNT @D8581, PER @D8580, 
            PLU @D8579, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8588, AGR [CASE @D8587, COUNT @D8586, PER @D8585, 
            PLU @D8584, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ATTEMPT, 
   [COORD @D8593, AGR [CASE @D8592, COUNT @D8591, PER @D8590, 
            PLU @D8589, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ATTEMPT, 
   [COORD @D8598, AGR [CASE @D8597, COUNT @D8596, PER @D8595, 
            PLU @D8594, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : ATTEMPT.

WORD attempting : 
   [COORD @D8614, PRD @D8613, AGR [CASE @D8612, COUNT @D8611, 
            PER @D8610, PLU @D8609, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8620, PRD @D8619, 
      AGR [CASE @D8618, COUNT @D8617, PER @D8616, PLU @D8615, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8626, PRD @D8625, 
      AGR [CASE @D8624, COUNT @D8623, PER @D8622, PLU @D8621, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ATTEMPT.

WORD attempts : 
   [COORD @D8637, DEMON @D8636, REFL @D8635, PRD @D8634, CASE @D8633, 
      COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, SUBCAT PP, 
      PFORM AT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, 
      NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ATTEMPT, 
   [COORD @D8642, DEMON @D8641, REFL @D8640, PRD @D8639, CASE @D8638, 
      COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, SUBCAT VPINF, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ATTEMPT, 
   [COORD @D8647, DEMON @D8646, REFL @D8645, PRD @D8644, CASE @D8643, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ATTEMPT, 
   [COORD @D8649, 
      AGR [COUNT @D8648, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8651, 
      AGR [COUNT @D8650, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ATTEMPT, 
   [COORD @D8653, 
      AGR [COUNT @D8652, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ATTEMPT.

WORD back : [FIX NOT, PRT BACK, INFL -] : BACK, 
   [COORD @D8661, AGR [COUNT @D8660, PER @D8659, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : BACK, 
   [COORD @D8663, AGR [COUNT @D8662, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : BACK, 
   [COORD @D8665, AGR [COUNT @D8664, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : BACK, 
   [COORD @D8669, AGR [COUNT @D8668, PER @D8667, PLU @D8666, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : BACK, 
   [COORD @D8675, PAST @D8674, 
      AGR [CASE @D8673, COUNT @D8672, PER @D8671, PLU @D8670, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : BACK, 
   [COORD @D8678, AGR [COUNT @D8677, PER @D8676, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : BACK, 
   [COORD @D8680, AGR [COUNT @D8679, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : BACK, 
   [COORD @D8682, AGR [COUNT @D8681, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : BACK, 
   [COORD @D8686, AGR [COUNT @D8685, PER @D8684, PLU @D8683, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : BACK, 
   [COORD @D8692, PAST @D8691, 
      AGR [CASE @D8690, COUNT @D8689, PER @D8688, PLU @D8687, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : BACK, 
   [COORD @D8695, AGR [COUNT @D8694, PER @D8693, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BACK, 
   [COORD @D8697, AGR [COUNT @D8696, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   BACK, 
   [COORD @D8699, AGR [COUNT @D8698, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   BACK, 
   [COORD @D8703, AGR [COUNT @D8702, PER @D8701, PLU @D8700, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BACK, 
   [COORD @D8709, PAST @D8708, AGR [CASE @D8707, COUNT @D8706, 
            PER @D8705, PLU @D8704, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : BACK, 
   [COORD @D8712, AGR [COUNT @D8711, PER @D8710, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : BACK, 
   [COORD @D8714, AGR [COUNT @D8713, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : BACK, 
   [COORD @D8716, AGR [COUNT @D8715, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : BACK, 
   [COORD @D8720, AGR [COUNT @D8719, PER @D8718, PLU @D8717, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : BACK, 
   [COORD @D8726, PAST @D8725, AGR [CASE @D8724, COUNT @D8723, 
            PER @D8722, PLU @D8721, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, ARITY 2] : BACK, 
   [COORD @D8729, 
      AGR [COUNT @D8728, PER @D8727, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : BACK, 
   [COORD @D8731, AGR [COUNT @D8730, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : BACK, 
   [COORD @D8733, AGR [COUNT @D8732, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : BACK, 
   [COORD @D8737, AGR [COUNT @D8736, PER @D8735, PLU @D8734, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : BACK, 
   [COORD @D8743, PAST @D8742, AGR [CASE @D8741, COUNT @D8740, 
            PER @D8739, PLU @D8738, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : BACK, 
   [COORD @D8746, 
      AGR [COUNT @D8745, PER @D8744, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8748, AGR [COUNT @D8747, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8750, AGR [COUNT @D8749, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8754, AGR [COUNT @D8753, PER @D8752, PLU @D8751, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8760, PAST @D8759, AGR 
         [CASE @D8758, COUNT @D8757, PER @D8756, PLU @D8755, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, PFORM FROM, 
      ARITY 2] : BACK, 
   [COORD @D8763, AGR [COUNT @D8762, PER @D8761, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8765, AGR [COUNT @D8764, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OFF, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8767, AGR [COUNT @D8766, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OFF, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8771, AGR [COUNT @D8770, PER @D8769, PLU @D8768, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8777, PAST @D8776, AGR 
         [CASE @D8775, COUNT @D8774, PER @D8773, PLU @D8772, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OFF, PFORM FROM, 
      ARITY 2] : BACK, 
   [COORD @D8780, AGR [COUNT @D8779, PER @D8778, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8782, AGR [COUNT @D8781, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT DOWN, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8784, AGR [COUNT @D8783, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT DOWN, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8788, AGR [COUNT @D8787, PER @D8786, PLU @D8785, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8794, PAST @D8793, 
      AGR [CASE @D8792, COUNT @D8791, PER @D8790, PLU @D8789, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT DOWN, PFORM FROM, 
      ARITY 2] : BACK, 
   [COORD @D8797, AGR [COUNT @D8796, PER @D8795, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8799, AGR [COUNT @D8798, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT AWAY, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8801, AGR [COUNT @D8800, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT AWAY, 
      PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8805, AGR [COUNT @D8804, PER @D8803, PLU @D8802, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : BACK, 
   [COORD @D8811, PAST @D8810, 
      AGR [CASE @D8809, COUNT @D8808, PER @D8807, PLU @D8806, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT AWAY, PFORM FROM, 
      ARITY 2] : BACK, 
   [COORD @D8814, AGR [COUNT @D8813, PER @D8812, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BACK, 
   [COORD @D8816, AGR [COUNT @D8815, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   BACK, 
   [COORD @D8818, AGR [COUNT @D8817, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   BACK, 
   [COORD @D8822, AGR [COUNT @D8821, PER @D8820, PLU @D8819, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BACK, 
   [COORD @D8828, PAST @D8827, AGR [CASE @D8826, COUNT @D8825, 
            PER @D8824, PLU @D8823, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : BACK, 
   [COORD @D8831, AGR [COUNT @D8830, PER @D8829, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BACK, 
   [COORD @D8833, AGR [COUNT @D8832, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   BACK, 
   [COORD @D8835, AGR [COUNT @D8834, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   BACK, 
   [COORD @D8839, AGR [COUNT @D8838, PER @D8837, PLU @D8836, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BACK, 
   [COORD @D8845, PAST @D8844, AGR [CASE @D8843, COUNT @D8842, 
            PER @D8841, PLU @D8840, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : BACK, 
   [COORD @D8848, AGR [COUNT @D8847, PER @D8846, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BACK, 
   [COORD @D8850, AGR [COUNT @D8849, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : BACK, 
   [COORD @D8852, AGR [COUNT @D8851, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : BACK, 
   [COORD @D8856, AGR [COUNT @D8855, PER @D8854, PLU @D8853, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BACK, 
   [COORD @D8862, PAST @D8861, AGR 
         [CASE @D8860, COUNT @D8859, PER @D8858, PLU @D8857, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, ARITY 1] : 
   BACK, 
   [COORD @D8865, AGR [COUNT @D8864, PER @D8863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BACK, 
   [COORD @D8867, AGR [COUNT @D8866, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : BACK, 
   [COORD @D8869, AGR [COUNT @D8868, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : BACK, 
   [COORD @D8873, AGR [COUNT @D8872, PER @D8871, PLU @D8870, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BACK, 
   [COORD @D8879, PAST @D8878, 
      AGR [CASE @D8877, COUNT @D8876, PER @D8875, PLU @D8874, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, ARITY 1] : 
   BACK, 
   [COORD @D8882, AGR [COUNT @D8881, PER @D8880, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BACK, 
   [COORD @D8884, AGR [COUNT @D8883, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : BACK, 
   [COORD @D8886, AGR [COUNT @D8885, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : BACK, 
   [COORD @D8890, AGR [COUNT @D8889, PER @D8888, PLU @D8887, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BACK, 
   [COORD @D8896, PAST @D8895, 
      AGR [CASE @D8894, COUNT @D8893, PER @D8892, PLU @D8891, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, ARITY 1] : 
   BACK, 
   [COORD @D8899, AGR [COUNT @D8898, PER @D8897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BACK, 
   [COORD @D8901, AGR [COUNT @D8900, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : BACK, 
   [COORD @D8903, AGR [COUNT @D8902, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : BACK, 
   [COORD @D8907, AGR [COUNT @D8906, PER @D8905, PLU @D8904, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BACK, 
   [COORD @D8913, PAST @D8912, 
      AGR [CASE @D8911, COUNT @D8910, PER @D8909, PLU @D8908, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, ARITY 1] : 
   BACK, 
   [COORD @D8916, AGR [COUNT @D8915, PER @D8914, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BACK, 
   [COORD @D8918, AGR [COUNT @D8917, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : BACK, 
   [COORD @D8920, AGR [COUNT @D8919, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : BACK, 
   [COORD @D8924, AGR [COUNT @D8923, PER @D8922, PLU @D8921, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BACK, 
   [COORD @D8930, PAST @D8929, 
      AGR [CASE @D8928, COUNT @D8927, PER @D8926, PLU @D8925, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, ARITY 1] : 
   BACK.

WORD backed : 
   [COORD @D8942, AGR [CASE @D8941, COUNT @D8940, PER @D8939, PLU 
               @D8938, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BACK, 
   [COORD @D8947, AGR [CASE @D8946, COUNT @D8945, PER @D8944, 
            PLU @D8943, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D8952, AGR [CASE @D8951, COUNT @D8950, PER @D8949, 
            PLU @D8948, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D8957, AGR [CASE @D8956, COUNT @D8955, PER @D8954, 
            PLU @D8953, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BACK, 
   [COORD @D8962, AGR [CASE @D8961, COUNT @D8960, PER @D8959, 
            PLU @D8958, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D8967, AGR [CASE @D8966, COUNT @D8965, PER @D8964, 
            PLU @D8963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D8972, AGR [CASE @D8971, COUNT @D8970, PER @D8969, 
            PLU @D8968, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BACK, 
   [COORD @D8977, AGR [CASE @D8976, COUNT @D8975, PER @D8974, 
            PLU @D8973, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BACK, 
   [COORD @D8982, AGR [CASE @D8981, COUNT @D8980, PER @D8979, 
            PLU @D8978, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : BACK, 
   [COORD @D8987, AGR [CASE @D8986, COUNT @D8985, PER @D8984, 
            PLU @D8983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D8992, AGR [CASE @D8991, COUNT @D8990, PER @D8989, 
            PLU @D8988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D8997, AGR [CASE @D8996, COUNT @D8995, PER @D8994, 
            PLU @D8993, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ONTO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BACK, 
   [COORD @D9002, AGR [CASE @D9001, COUNT @D9000, PER @D8999, 
            PLU @D8998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9007, AGR [CASE @D9006, COUNT @D9005, PER @D9004, 
            PLU @D9003, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9012, AGR [CASE @D9011, COUNT @D9010, PER @D9009, 
            PLU @D9008, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9017, AGR [CASE @D9016, COUNT @D9015, PER @D9014, 
            PLU @D9013, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9022, AGR [CASE @D9021, COUNT @D9020, PER @D9019, 
            PLU @D9018, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9027, AGR [CASE @D9026, COUNT @D9025, PER @D9024, 
            PLU @D9023, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9032, AGR [CASE @D9031, COUNT @D9030, PER @D9029, 
            PLU @D9028, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9037, AGR [CASE @D9036, COUNT @D9035, PER @D9034, 
            PLU @D9033, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9042, AGR [CASE @D9041, COUNT @D9040, PER @D9039, 
            PLU @D9038, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9047, AGR [CASE @D9046, COUNT @D9045, PER @D9044, 
            PLU @D9043, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9052, AGR [CASE @D9051, COUNT @D9050, PER @D9049, 
            PLU @D9048, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9057, AGR [CASE @D9056, COUNT @D9055, PER @D9054, 
            PLU @D9053, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9062, AGR [CASE @D9061, COUNT @D9060, PER @D9059, 
            PLU @D9058, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BACK, 
   [COORD @D9067, AGR [CASE @D9066, COUNT @D9065, PER @D9064, 
            PLU @D9063, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BACK, 
   [COORD @D9072, AGR [CASE @D9071, COUNT @D9070, PER @D9069, 
            PLU @D9068, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : BACK, 
   [COORD @D9077, AGR [CASE @D9076, COUNT @D9075, PER @D9074, 
            PLU @D9073, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9082, AGR [CASE @D9081, COUNT @D9080, PER @D9079, 
            PLU @D9078, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9087, AGR [CASE @D9086, COUNT @D9085, PER @D9084, 
            PLU @D9083, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9092, AGR [CASE @D9091, COUNT @D9090, PER @D9089, 
            PLU @D9088, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9097, AGR [CASE @D9096, COUNT @D9095, PER @D9094, 
            PLU @D9093, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9102, AGR [CASE @D9101, COUNT @D9100, PER @D9099, 
            PLU @D9098, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9107, AGR [CASE @D9106, COUNT @D9105, PER @D9104, 
            PLU @D9103, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9112, AGR [CASE @D9111, COUNT @D9110, PER @D9109, 
            PLU @D9108, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK, 
   [COORD @D9117, AGR [CASE @D9116, COUNT @D9115, PER @D9114, 
            PLU @D9113, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9122, AGR [CASE @D9121, COUNT @D9120, PER @D9119, 
            PLU @D9118, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BACK.

WORD backing : 
   [COORD @D9137, PRD @D9136, AGR [CASE @D9135, COUNT @D9134, 
            PER @D9133, PLU @D9132, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9143, PRD @D9142, 
      AGR [CASE @D9141, COUNT @D9140, PER @D9139, PLU @D9138, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BACK, 
   [COORD @D9149, PRD @D9148, AGR [CASE @D9147, COUNT @D9146, PER 
               @D9145, PLU @D9144, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9155, PRD @D9154, AGR [CASE @D9153, COUNT @D9152, 
            PER @D9151, PLU @D9150, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9161, PRD @D9160, 
      AGR [CASE @D9159, COUNT @D9158, PER @D9157, PLU @D9156, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BACK, 
   [COORD @D9167, PRD @D9166, AGR [CASE @D9165, COUNT @D9164, 
            PER @D9163, PLU @D9162, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9173, PRD @D9172, 
      AGR [CASE @D9171, COUNT @D9170, PER @D9169, PLU @D9168, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OFF, PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BACK, 
   [COORD @D9179, PRD @D9178, AGR [CASE @D9177, COUNT @D9176, 
            PER @D9175, PLU @D9174, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9185, PRD @D9184, 
      AGR [CASE @D9183, COUNT @D9182, PER @D9181, PLU @D9180, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BACK, 
   [COORD @D9191, PRD @D9190, AGR [CASE @D9189, COUNT @D9188, 
            PER @D9187, PLU @D9186, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9197, PRD @D9196, 
      AGR [CASE @D9195, COUNT @D9194, PER @D9193, PLU @D9192, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9203, PRD @D9202, 
      AGR [CASE @D9201, COUNT @D9200, PER @D9199, PLU @D9198, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BACK, 
   [COORD @D9209, PRD @D9208, AGR [CASE @D9207, COUNT @D9206, PER 
               @D9205, PLU @D9204, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9215, PRD @D9214, 
      AGR [CASE @D9213, COUNT @D9212, PER @D9211, PLU @D9210, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BACK, 
   [COORD @D9221, PRD @D9220, AGR [CASE @D9219, COUNT @D9218, PER 
               @D9217, PLU @D9216, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK, 
   [COORD @D9227, PRD @D9226, 
      AGR [CASE @D9225, COUNT @D9224, PER @D9223, PLU @D9222, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BACK.

WORD backs : 
   [COORD @D9236, AGR [COUNT @D9235, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BACK, 
   [COORD @D9238, AGR [COUNT @D9237, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9240, 
      AGR [COUNT @D9239, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9242, 
      AGR [COUNT @D9241, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9244, 
      AGR [COUNT @D9243, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BACK, 
   [COORD @D9246, AGR [COUNT @D9245, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BACK, 
   [COORD @D9248, AGR [COUNT @D9247, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OFF, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BACK, 
   [COORD @D9250, AGR [COUNT @D9249, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BACK, 
   [COORD @D9252, AGR [COUNT @D9251, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BACK, 
   [COORD @D9254, AGR [COUNT @D9253, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9256, 
      AGR [COUNT @D9255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9258, 
      AGR [COUNT @D9257, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9260, 
      AGR [COUNT @D9259, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9262, 
      AGR [COUNT @D9261, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9264, 
      AGR [COUNT @D9263, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK, 
   [COORD @D9266, 
      AGR [COUNT @D9265, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BACK.

WORD bag : 
   [COORD @D9275, REFL @D9274, PRD @D9273, CASE @D9272, FIX NOT, BAR 0, 
      SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, COUNT +] : BAG, 
   [COORD @D9278, AGR [COUNT @D9277, PER @D9276, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BAG, 
   [COORD @D9280, AGR [COUNT @D9279, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : BAG, 
   
   [COORD @D9282, AGR [COUNT @D9281, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : BAG, 
   
   [COORD @D9286, AGR [COUNT @D9285, PER @D9284, PLU @D9283, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BAG, 
   [COORD @D9292, PAST @D9291, AGR [CASE @D9290, COUNT @D9289, 
            PER @D9288, PLU @D9287, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : BAG, 
   [COORD @D9295, AGR [COUNT @D9294, PER @D9293, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BAG, 
   [COORD @D9297, AGR [COUNT @D9296, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   BAG, 
   [COORD @D9299, AGR [COUNT @D9298, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   BAG, 
   [COORD @D9303, AGR [COUNT @D9302, PER @D9301, PLU @D9300, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BAG, 
   [COORD @D9309, PAST @D9308, AGR [CASE @D9307, COUNT @D9306, 
            PER @D9305, PLU @D9304, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : BAG, 
   [COORD @D9312, AGR [COUNT @D9311, PER @D9310, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BAG, 
   [COORD @D9314, AGR [COUNT @D9313, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : BAG, 
   [COORD @D9316, AGR [COUNT @D9315, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : BAG, 
   [COORD @D9320, AGR [COUNT @D9319, PER @D9318, PLU @D9317, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BAG, 
   [COORD @D9326, PAST @D9325, AGR 
         [CASE @D9324, COUNT @D9323, PER @D9322, PLU @D9321, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, ARITY 1] : 
   BAG.

WORD bagged : 
   [COORD @D9338, AGR [CASE @D9337, COUNT @D9336, PER @D9335, PLU 
               @D9334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BAG, 
   [COORD @D9343, AGR [CASE @D9342, COUNT @D9341, PER @D9340, 
            PLU @D9339, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : BAG, 
   [COORD @D9348, AGR [CASE @D9347, COUNT @D9346, PER @D9345, 
            PLU @D9344, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BAG, 
   [COORD @D9353, AGR [CASE @D9352, COUNT @D9351, PER @D9350, 
            PLU @D9349, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BAG, 
   [COORD @D9358, AGR [CASE @D9357, COUNT @D9356, PER @D9355, 
            PLU @D9354, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : BAG, 
   [COORD @D9363, AGR [CASE @D9362, COUNT @D9361, PER @D9360, 
            PLU @D9359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BAG, 
   [COORD @D9368, AGR [CASE @D9367, COUNT @D9366, PER @D9365, 
            PLU @D9364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BAG.

WORD bagging : 
   [COORD @D9381, PRD @D9380, AGR [CASE @D9379, COUNT @D9378, 
            PER @D9377, PLU @D9376, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BAG, 
   [COORD @D9387, PRD @D9386, AGR [CASE @D9385, COUNT @D9384, 
            PER @D9383, PLU @D9382, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BAG, 
   [COORD @D9393, PRD @D9392, AGR [CASE @D9391, COUNT @D9390, 
            PER @D9389, PLU @D9388, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BAG.

WORD bags : 
   [COORD @D9404, REFL @D9403, PRD @D9402, CASE @D9401, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, NFORM NORM, PER 3, 
      ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM OF, COUNT +] : BAGS, 
   [COORD @D9408, REFL @D9407, PRD @D9406, CASE @D9405, FIX NOT, BAR 0, 
      SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, REG -, COUNT +] : BAGS, 
   [COORD @D9413, DEMON @D9412, REFL @D9411, PRD @D9410, CASE @D9409, 
      COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, CONJ NULL, 
      PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, PLU +, NUM -, 
      AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BAG, 
   [COORD @D9415, 
      AGR [COUNT @D9414, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BAG, 
   [COORD @D9417, 
      AGR [COUNT @D9416, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BAG, 
   [COORD @D9419, 
      AGR [COUNT @D9418, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BAG.

WORD bank : 
   [COORD @D9439, AGR [COUNT @D9438, PER @D9437, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : BANK, 
   [COORD @D9441, AGR [COUNT @D9440, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : BANK, 
   [COORD @D9443, AGR [COUNT @D9442, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : BANK, 
   [COORD @D9447, AGR [COUNT @D9446, PER @D9445, PLU @D9444, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : BANK, 
   [COORD @D9453, PAST @D9452, 
      AGR [CASE @D9451, COUNT @D9450, PER @D9449, PLU @D9448, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, 
      ARITY 3] : BANK, 
   [COORD @D9456, AGR [COUNT @D9455, PER @D9454, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BANK, 
   [COORD @D9458, AGR [COUNT @D9457, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   BANK, 
   [COORD @D9460, AGR [COUNT @D9459, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   BANK, 
   [COORD @D9464, AGR [COUNT @D9463, PER @D9462, PLU @D9461, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BANK, 
   [COORD @D9470, PAST @D9469, AGR [CASE @D9468, COUNT @D9467, 
            PER @D9466, PLU @D9465, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : BANK, 
   [COORD @D9473, AGR [COUNT @D9472, PER @D9471, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP ON, ARITY 2] : BANK, 
   [COORD @D9475, AGR [COUNT @D9474, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP ON, ARITY 2] : BANK, 
   [COORD @D9477, AGR [COUNT @D9476, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP ON, ARITY 2] : BANK, 
   [COORD @D9481, AGR [COUNT @D9480, PER @D9479, PLU @D9478, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP ON, ARITY 2] : BANK, 
   [COORD @D9487, PAST @D9486, 
      AGR [CASE @D9485, COUNT @D9484, PER @D9483, PLU @D9482, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, PREP ON, 
      ARITY 2] : BANK, 
   [COORD @D9490, AGR [COUNT @D9489, PER @D9488, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BANK, 
   [COORD @D9492, AGR [COUNT @D9491, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : BANK, 
   [COORD @D9494, AGR [COUNT @D9493, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : BANK, 
   [COORD @D9498, AGR [COUNT @D9497, PER @D9496, PLU @D9495, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BANK, 
   [COORD @D9504, PAST @D9503, AGR [CASE @D9502, COUNT @D9501, 
            PER @D9500, PLU @D9499, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, PFORM WITH, ARITY 2] : BANK, 
   [COORD @D9507, 
      AGR [COUNT @D9506, PER @D9505, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : BANK, 
   [COORD @D9509, AGR [COUNT @D9508, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : BANK, 
   [COORD @D9511, AGR [COUNT @D9510, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : BANK, 
   [COORD @D9515, AGR [COUNT @D9514, PER @D9513, PLU @D9512, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : BANK, 
   [COORD @D9521, PAST @D9520, AGR [CASE @D9519, COUNT @D9518, 
            PER @D9517, PLU @D9516, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, ARITY 2] : BANK, 
   [COORD @D9524, 
      AGR [COUNT @D9523, PER @D9522, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, 
      PFORM ON, ARITY 2] : BANK, 
   [COORD @D9526, AGR [COUNT @D9525, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM ON, ARITY 2] : BANK, 
   [COORD @D9528, AGR [COUNT @D9527, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM ON, ARITY 2] : BANK, 
   [COORD @D9532, AGR [COUNT @D9531, PER @D9530, PLU @D9529, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM ON, ARITY 2] : BANK, 
   [COORD @D9538, PAST @D9537, 
      AGR [CASE @D9536, COUNT @D9535, PER @D9534, PLU @D9533, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM ON, 
      ARITY 2] : BANK, 
   [COORD @D9541, AGR [COUNT @D9540, PER @D9539, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BANK, 
   [COORD @D9543, AGR [COUNT @D9542, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   BANK, 
   [COORD @D9545, AGR [COUNT @D9544, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   BANK, 
   [COORD @D9549, AGR [COUNT @D9548, PER @D9547, PLU @D9546, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BANK, 
   [COORD @D9555, PAST @D9554, AGR [CASE @D9553, COUNT @D9552, 
            PER @D9551, PLU @D9550, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : BANK, 
   [COORD @D9558, AGR [COUNT @D9557, PER @D9556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BANK, 
   [COORD @D9560, AGR [COUNT @D9559, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   BANK, 
   [COORD @D9562, AGR [COUNT @D9561, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   BANK, 
   [COORD @D9566, AGR [COUNT @D9565, PER @D9564, PLU @D9563, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BANK, 
   [COORD @D9572, PAST @D9571, AGR [CASE @D9570, COUNT @D9569, 
            PER @D9568, PLU @D9567, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : BANK, 
   [COORD @D9575, AGR [COUNT @D9574, PER @D9573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BANK, 
   [COORD @D9577, AGR [COUNT @D9576, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : BANK, 
   [COORD @D9579, AGR [COUNT @D9578, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : BANK, 
   [COORD @D9583, AGR [COUNT @D9582, PER @D9581, PLU @D9580, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BANK, 
   [COORD @D9589, PAST @D9588, AGR 
         [CASE @D9587, COUNT @D9586, PER @D9585, PLU @D9584, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, ARITY 1] : 
   BANK.

WORD banked : 
   [COORD @D9600, AGR [CASE @D9599, COUNT @D9598, PER @D9597, PLU 
               @D9596, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE PVERB_OE, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9605, AGR [CASE @D9604, COUNT @D9603, PER @D9602, 
            PLU @D9601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9610, AGR [CASE @D9609, COUNT @D9608, PER @D9607, 
            PLU @D9606, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BANK, 
   [COORD @D9615, AGR [CASE @D9614, COUNT @D9613, PER @D9612, 
            PLU @D9611, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BANK, 
   [COORD @D9620, AGR [CASE @D9619, COUNT @D9618, PER @D9617, 
            PLU @D9616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BANK, 
   [COORD @D9625, AGR [CASE @D9624, COUNT @D9623, PER @D9622, 
            PLU @D9621, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : BANK, 
   [COORD @D9630, AGR [CASE @D9629, COUNT @D9628, PER @D9627, 
            PLU @D9626, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9635, AGR [CASE @D9634, COUNT @D9633, PER @D9632, 
            PLU @D9631, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BANK, 
   [COORD @D9640, AGR [CASE @D9639, COUNT @D9638, PER @D9637, 
            PLU @D9636, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9645, AGR [CASE @D9644, COUNT @D9643, PER @D9642, 
            PLU @D9641, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BANK, 
   [COORD @D9650, AGR [CASE @D9649, COUNT @D9648, PER @D9647, 
            PLU @D9646, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9655, AGR [CASE @D9654, COUNT @D9653, PER @D9652, 
            PLU @D9651, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BANK, 
   [COORD @D9660, AGR [CASE @D9659, COUNT @D9658, PER @D9657, 
            PLU @D9656, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BANK, 
   [COORD @D9665, AGR [CASE @D9664, COUNT @D9663, PER @D9662, 
            PLU @D9661, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OR, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9670, AGR [CASE @D9669, COUNT @D9668, PER @D9667, 
            PLU @D9666, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9675, AGR [CASE @D9674, COUNT @D9673, PER @D9672, 
            PLU @D9671, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BANK, 
   [COORD @D9680, AGR [CASE @D9679, COUNT @D9678, PER @D9677, 
            PLU @D9676, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9685, AGR [CASE @D9684, COUNT @D9683, PER @D9682, 
            PLU @D9681, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BANK, 
   [COORD @D9690, AGR [CASE @D9689, COUNT @D9688, PER @D9687, 
            PLU @D9686, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BANK, 
   [COORD @D9695, AGR [CASE @D9694, COUNT @D9693, PER @D9692, 
            PLU @D9691, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BANK, 
   [COORD @D9700, AGR [CASE @D9699, COUNT @D9698, PER @D9697, 
            PLU @D9696, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : BANK, 
   [COORD @D9705, AGR [CASE @D9704, COUNT @D9703, PER @D9702, 
            PLU @D9701, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9710, AGR [CASE @D9709, COUNT @D9708, PER @D9707, 
            PLU @D9706, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BANK.

WORD banking : 
   [COORD @D9722, REFL @D9721, PRD @D9720, CASE @D9719, FIX NOT, BAR 0, 
      SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : BANKING, 
   [COORD @D9728, PRD @D9727, 
      AGR [CASE @D9726, COUNT @D9725, PER @D9724, PLU @D9723, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BANK, 
   [COORD @D9734, PRD @D9733, AGR [CASE @D9732, COUNT @D9731, 
            PER @D9730, PLU @D9729, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9740, PRD @D9739, AGR [CASE @D9738, COUNT @D9737, 
            PER @D9736, PLU @D9735, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9746, PRD @D9745, 
      AGR [CASE @D9744, COUNT @D9743, PER @D9742, PLU @D9741, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BANK, 
   [COORD @D9752, PRD @D9751, AGR [CASE @D9750, COUNT @D9749, PER 
               @D9748, PLU @D9747, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9758, PRD @D9757, 
      AGR [CASE @D9756, COUNT @D9755, PER @D9754, PLU @D9753, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BANK, 
   [COORD @D9764, PRD @D9763, AGR [CASE @D9762, COUNT @D9761, 
            PER @D9760, PLU @D9759, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9770, PRD @D9769, 
      AGR [CASE @D9768, COUNT @D9767, PER @D9766, PLU @D9765, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BANK, 
   [COORD @D9776, PRD @D9775, 
      AGR [CASE @D9774, COUNT @D9773, PER @D9772, PLU @D9771, BAR 2, V -, 
            N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BANK.

WORD banks : 
   [COORD @D9794, AGR [COUNT @D9793, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : BANK, 
   [COORD @D9796, AGR [COUNT @D9795, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BANK, 
   [COORD @D9798, 
      AGR [COUNT @D9797, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BANK, 
   [COORD @D9800, 
      AGR [COUNT @D9799, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BANK, 
   [COORD @D9802, 
      AGR [COUNT @D9801, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BANK, 
   [COORD @D9804, 
      AGR [COUNT @D9803, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BANK, 
   [COORD @D9806, AGR [COUNT @D9805, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BANK, 
   [COORD @D9808, 
      AGR [COUNT @D9807, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BANK, 
   [COORD @D9810, 
      AGR [COUNT @D9809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BANK.

WORD base : 
   [COORD @D9819, AGR [COUNT @D9818, PER @D9817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : BASE, 
   [COORD @D9821, AGR [COUNT @D9820, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : BASE, 
   [COORD @D9823, AGR [COUNT @D9822, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : BASE, 
   [COORD @D9827, AGR [COUNT @D9826, PER @D9825, PLU @D9824, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : BASE, 
   [COORD @D9833, PAST @D9832, 
      AGR [CASE @D9831, COUNT @D9830, PER @D9829, PLU @D9828, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, ARITY 3] : 
   BASE.

WORD based : 
   [COORD @D9845, AGR [CASE @D9844, COUNT @D9843, PER @D9842, PLU 
               @D9841, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BASE, 
   [COORD @D9850, AGR [CASE @D9849, COUNT @D9848, PER @D9847, 
            PLU @D9846, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BASE, 
   [COORD @D9855, AGR [CASE @D9854, COUNT @D9853, PER @D9852, 
            PLU @D9851, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BASE.

WORD bases : 
   [COORD @D9864, AGR [COUNT @D9863, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BASE.

WORD basing : 
   [COORD @D9876, PRD @D9875, AGR [CASE @D9874, COUNT @D9873, PER 
               @D9872, PLU @D9871, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BASE.

WORD bear : 
   [COORD @D9886, REFL @D9885, PRD @D9884, CASE @D9883, FIX NOT, BAR 0, 
      SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, COUNT +] : BEAR, 
   [COORD @D9890, REFL @D9889, PRD @D9888, CASE @D9887, FIX NOT, BAR 0, 
      SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, REG -, COUNT +] : BEAR, 
   [COORD @D9893, AGR [COUNT @D9892, PER @D9891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BEAR, 
   [COORD @D9895, AGR [COUNT @D9894, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BEAR, 
   [COORD @D9897, AGR [COUNT @D9896, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BEAR, 
   [COORD @D9901, AGR [COUNT @D9900, PER @D9899, PLU @D9898, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BEAR, 
   [COORD @D9907, PAST @D9906, AGR [CASE @D9905, COUNT @D9904, 
            PER @D9903, PLU @D9902, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, ARITY 2] : BEAR, 
   [COORD @D9910, 
      AGR [COUNT @D9909, PER @D9908, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM UNDER, ARITY 2] : BEAR, 
   [COORD @D9912, AGR [COUNT @D9911, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM UNDER, ARITY 2] : BEAR, 
   [COORD @D9914, AGR [COUNT @D9913, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM UNDER, ARITY 2] : BEAR, 
   [COORD @D9918, AGR [COUNT @D9917, PER @D9916, PLU @D9915, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM UNDER, ARITY 2] : BEAR, 
   [COORD @D9924, PAST @D9923, AGR 
         [CASE @D9922, COUNT @D9921, PER @D9920, PLU @D9919, BAR 2, V -, 
            N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, PFORM UNDER, 
      ARITY 2] : BEAR, 
   [COORD @D9927, AGR [COUNT @D9926, PER @D9925, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9929, AGR [COUNT @D9928, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9931, AGR [COUNT @D9930, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9935, AGR [COUNT @D9934, PER @D9933, PLU @D9932, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9941, PAST @D9940, AGR [CASE @D9939, COUNT @D9938, 
            PER @D9937, PLU @D9936, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9944, 
      AGR [COUNT @D9943, PER @D9942, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT DOWN, 
      PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9946, AGR [COUNT @D9945, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9948, AGR [COUNT @D9947, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9952, AGR [COUNT @D9951, PER @D9950, PLU @D9949, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9958, PAST @D9957, AGR [CASE @D9956, COUNT @D9955, 
            PER @D9954, PLU @D9953, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, ARITY 2] : BEAR, 
   [COORD @D9961, 
      AGR [COUNT @D9960, PER @D9959, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   BEAR, 
   [COORD @D9963, AGR [COUNT @D9962, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   BEAR, 
   [COORD @D9965, AGR [COUNT @D9964, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, ARITY 2] : 
   BEAR, 
   [COORD @D9969, AGR [COUNT @D9968, PER @D9967, PLU @D9966, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BEAR, 
   [COORD @D9975, PAST @D9974, AGR [CASE @D9973, COUNT @D9972, 
            PER @D9971, PLU @D9970, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : BEAR, 
   [COORD @D9978, AGR [COUNT @D9977, PER @D9976, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : BEAR, 
   [COORD @D9980, AGR [COUNT @D9979, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : BEAR, 
   [COORD @D9982, AGR [COUNT @D9981, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : BEAR, 
   [COORD @D9986, AGR [COUNT @D9985, PER @D9984, PLU @D9983, N +, V -, 
            BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : BEAR, 
   [COORD @D9992, PAST @D9991, AGR [CASE @D9990, COUNT @D9989, 
            PER @D9988, PLU @D9987, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : BEAR, 
   [COORD @D9995, AGR [COUNT @D9994, PER @D9993, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : BEAR, 
   [COORD @D9997, AGR [COUNT @D9996, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : BEAR, 
   [COORD @D9999, AGR [COUNT @D9998, N +, V -, BAR 2, NFORM NORM, CASE NOM, 
            PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : BEAR, 
   [COORD @D10003, AGR [COUNT @D10002, PER @D10001, PLU @D10000, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : BEAR, 
   [COORD @D10009, PAST @D10008, 
      AGR [CASE @D10007, COUNT @D10006, PER @D10005, PLU @D10004, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : BEAR, 
   [COORD @D10012, AGR [COUNT @D10011, PER @D10010, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BEAR, 
   [COORD @D10014, AGR [COUNT @D10013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BEAR, 
   [COORD @D10016, AGR [COUNT @D10015, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BEAR, 
   [COORD @D10020, AGR [COUNT @D10019, PER @D10018, PLU @D10017, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : BEAR, 
   [COORD @D10026, PAST @D10025, 
      AGR [CASE @D10024, COUNT @D10023, PER @D10022, PLU @D10021, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BEAR, 
   [COORD @D10029, AGR [COUNT @D10028, PER @D10027, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : BEAR, 
   [COORD @D10031, AGR [COUNT @D10030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : BEAR, 
   [COORD @D10033, AGR [COUNT @D10032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : BEAR, 
   [COORD @D10037, AGR [COUNT @D10036, PER @D10035, PLU @D10034, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : BEAR, 
   [COORD @D10043, PAST @D10042, 
      AGR [CASE @D10041, COUNT @D10040, PER @D10039, PLU @D10038, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : BEAR, 
   [COORD @D10046, AGR [COUNT @D10045, PER @D10044, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BEAR, 
   [COORD @D10048, AGR [COUNT @D10047, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BEAR, 
   [COORD @D10050, AGR [COUNT @D10049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BEAR, 
   [COORD @D10054, AGR [COUNT @D10053, PER @D10052, PLU @D10051, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BEAR, 
   [COORD @D10060, PAST @D10059, 
      AGR [CASE @D10058, COUNT @D10057, PER @D10056, PLU @D10055, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : BEAR, 
   [COORD @D10063, AGR [COUNT @D10062, PER @D10061, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BEAR, 
   [COORD @D10065, AGR [COUNT @D10064, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BEAR, 
   [COORD @D10067, AGR [COUNT @D10066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BEAR, 
   [COORD @D10071, AGR [COUNT @D10070, PER @D10069, PLU @D10068, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BEAR, 
   [COORD @D10077, PAST @D10076, 
      AGR [CASE @D10075, COUNT @D10074, PER @D10073, PLU @D10072, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : BEAR, 
   [COORD @D10080, AGR [COUNT @D10079, PER @D10078, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BEAR, 
   [COORD @D10082, AGR [COUNT @D10081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BEAR, 
   [COORD @D10084, AGR [COUNT @D10083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BEAR, 
   [COORD @D10088, AGR [COUNT @D10087, PER @D10086, PLU @D10085, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BEAR, 
   [COORD @D10094, PAST @D10093, 
      AGR [CASE @D10092, COUNT @D10091, PER @D10090, PLU @D10089, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : BEAR, 
   [COORD @D10097, AGR [COUNT @D10096, PER @D10095, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BEAR, 
   [COORD @D10099, AGR [COUNT @D10098, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BEAR, 
   [COORD @D10101, AGR [COUNT @D10100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BEAR, 
   [COORD @D10105, AGR [COUNT @D10104, PER @D10103, PLU @D10102, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BEAR, 
   [COORD @D10111, PAST @D10110, 
      AGR [CASE @D10109, COUNT @D10108, PER @D10107, PLU @D10106, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : BEAR, 
   [COORD @D10114, AGR [COUNT @D10113, PER @D10112, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BEAR, 
   [COORD @D10116, AGR [COUNT @D10115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BEAR, 
   [COORD @D10118, AGR [COUNT @D10117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BEAR, 
   [COORD @D10122, AGR [COUNT @D10121, PER @D10120, PLU @D10119, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BEAR, 
   [COORD @D10128, PAST @D10127, 
      AGR [CASE @D10126, COUNT @D10125, PER @D10124, PLU @D10123, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : BEAR.

WORD bearing : 
   [COORD @D10144, REFL @D10143, PRD @D10142, CASE @D10141, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BEARING, 
   [COORD @D10149, REFL @D10148, COUNT @D10147, PRD @D10146, 
      CASE @D10145, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : BEARING, 
   [COORD @D10155, PRD @D10154, 
      AGR [CASE @D10153, COUNT @D10152, PER @D10151, PLU @D10150, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BEAR, 
   [COORD @D10161, PRD @D10160, AGR [CASE @D10159, COUNT @D10158, 
            PER @D10157, PLU @D10156, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM UNDER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAR, 
   [COORD @D10167, PRD @D10166, 
      AGR [CASE @D10165, COUNT @D10164, PER @D10163, PLU @D10162, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAR, 
   [COORD @D10173, PRD @D10172, AGR [CASE @D10171, COUNT @D10170, 
            PER @D10169, PLU @D10168, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT DOWN, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAR, 
   [COORD @D10179, PRD @D10178, 
      AGR [CASE @D10177, COUNT @D10176, PER @D10175, PLU @D10174, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAR, 
   [COORD @D10185, PRD @D10184, AGR [CASE @D10183, COUNT @D10182, 
            PER @D10181, PLU @D10180, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAR, 
   [COORD @D10191, PRD @D10190, 
      AGR [CASE @D10189, COUNT @D10188, PER @D10187, PLU @D10186, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAR, 
   [COORD @D10197, PRD @D10196, AGR [CASE @D10195, COUNT @D10194, 
            PER @D10193, PLU @D10192, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAR, 
   [COORD @D10203, PRD @D10202, 
      AGR [CASE @D10201, COUNT @D10200, PER @D10199, PLU @D10198, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAR, 
   [COORD @D10209, PRD @D10208, AGR [CASE @D10207, COUNT @D10206, 
            PER @D10205, PLU @D10204, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAR, 
   [COORD @D10215, PRD @D10214, 
      AGR [CASE @D10213, COUNT @D10212, PER @D10211, PLU @D10210, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAR, 
   [COORD @D10221, PRD @D10220, AGR [CASE @D10219, COUNT @D10218, 
            PER @D10217, PLU @D10216, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAR, 
   [COORD @D10227, PRD @D10226, 
      AGR [CASE @D10225, COUNT @D10224, PER @D10223, PLU @D10222, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAR, 
   [COORD @D10233, PRD @D10232, AGR [CASE @D10231, COUNT @D10230, 
            PER @D10229, PLU @D10228, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAR.

WORD bearings : 
   [COORD @D10252, REFL @D10251, PRD @D10250, CASE @D10249, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : BEARINGS, 
   [COORD @D10257, DEMON @D10256, REFL @D10255, PRD @D10254, 
      CASE @D10253, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BEARING.

WORD bears : 
   [COORD @D10288, DEMON @D10287, REFL @D10286, PRD @D10285, CASE 
         @D10284, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BEAR, 
   [COORD @D10290, 
      AGR [COUNT @D10289, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10292, 
      AGR [COUNT @D10291, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BEAR, 
   [COORD @D10294, AGR [COUNT @D10293, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BEAR, 
   [COORD @D10296, AGR [COUNT @D10295, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : BEAR, 
   [COORD @D10298, AGR [COUNT @D10297, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10300, 
      AGR [COUNT @D10299, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10302, 
      AGR [COUNT @D10301, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10304, 
      AGR [COUNT @D10303, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10306, 
      AGR [COUNT @D10305, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10308, 
      AGR [COUNT @D10307, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10310, 
      AGR [COUNT @D10309, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10312, 
      AGR [COUNT @D10311, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10314, 
      AGR [COUNT @D10313, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR, 
   [COORD @D10316, 
      AGR [COUNT @D10315, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAR.

WORD beat : 
   [COORD @D10325, AGR [COUNT @D10324, PER @D10323, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : BEAT, 
   [COORD @D10327, AGR [COUNT @D10326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : BEAT, 
   [COORD @D10329, AGR [COUNT @D10328, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : BEAT, 
   [COORD @D10333, AGR [COUNT @D10332, PER @D10331, PLU @D10330, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM TO, ARITY 3] : BEAT, 
   [COORD @D10339, PAST @D10338, 
      AGR [CASE @D10337, COUNT @D10336, PER @D10335, PLU @D10334, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT DOWN, 
      PFORM TO, ARITY 3] : BEAT, 
   [COORD @D10342, AGR [COUNT @D10341, PER @D10340, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADL, REG -, LAT -, 
      ARITY 3] : BEAT, 
   [COORD @D10344, AGR [COUNT @D10343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADL, REG -, LAT -, 
      ARITY 3] : BEAT, 
   [COORD @D10346, AGR [COUNT @D10345, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADL, REG -, LAT -, 
      ARITY 3] : BEAT, 
   [COORD @D10350, AGR [COUNT @D10349, PER @D10348, PLU @D10347, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADL, REG -, 
      LAT -, ARITY 3] : BEAT, 
   [COORD @D10356, PAST @D10355, AGR [CASE @D10354, COUNT @D10353, 
            PER @D10352, PLU @D10351, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_ADL, REG -, LAT -, ARITY 3] : BEAT, 
   [COORD @D10360, AGR [COUNT @D10359, PER @D10358, PLU @D10357, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PRT DOWN, PFORM TO, PAST +, ARITY 3] : BEAT, 
   [COORD @D10364, AGR [COUNT @D10363, PER @D10362, PLU @D10361, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADL, REG -, PAST +, LAT -, 
      ARITY 3] : BEAT, 
   [COORD @D10367, AGR [COUNT @D10366, PER @D10365, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM FOR, ARITY 2] : BEAT, 
   [COORD @D10369, AGR [COUNT @D10368, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM FOR, ARITY 2] : BEAT, 
   [COORD @D10371, AGR [COUNT @D10370, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM FOR, ARITY 2] : BEAT, 
   [COORD @D10375, AGR [COUNT @D10374, PER @D10373, PLU @D10372, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ABOUT, PFORM FOR, ARITY 2] : BEAT, 
   [COORD @D10381, PAST @D10380, 
      AGR [CASE @D10379, COUNT @D10378, PER @D10377, PLU @D10376, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ABOUT, 
      PFORM FOR, ARITY 2] : BEAT, 
   [COORD @D10384, AGR [COUNT @D10383, PER @D10382, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : BEAT, 
   [COORD @D10386, AGR [COUNT @D10385, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : BEAT, 
   [COORD @D10388, AGR [COUNT @D10387, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : BEAT, 
   [COORD @D10392, AGR [COUNT @D10391, PER @D10390, PLU @D10389, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : BEAT, 
   [COORD @D10398, PAST @D10397, 
      AGR [CASE @D10396, COUNT @D10395, PER @D10394, PLU @D10393, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : BEAT, 
   [COORD @D10401, AGR [COUNT @D10400, PER @D10399, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : BEAT, 
   [COORD @D10403, AGR [COUNT @D10402, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : BEAT, 
   [COORD @D10405, AGR [COUNT @D10404, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : BEAT, 
   [COORD @D10409, AGR [COUNT @D10408, PER @D10407, PLU @D10406, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : BEAT, 
   [COORD @D10415, PAST @D10414, 
      AGR [CASE @D10413, COUNT @D10412, PER @D10411, PLU @D10410, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : BEAT, 
   [COORD @D10418, AGR [COUNT @D10417, PER @D10416, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BEAT, 
   [COORD @D10420, AGR [COUNT @D10419, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BEAT, 
   [COORD @D10422, AGR [COUNT @D10421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BEAT, 
   [COORD @D10426, AGR [COUNT @D10425, PER @D10424, PLU @D10423, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : BEAT, 
   [COORD @D10432, PAST @D10431, 
      AGR [CASE @D10430, COUNT @D10429, PER @D10428, PLU @D10427, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : BEAT, 
   [COORD @D10435, AGR [COUNT @D10434, PER @D10433, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : BEAT, 
   [COORD @D10437, AGR [COUNT @D10436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : BEAT, 
   [COORD @D10439, AGR [COUNT @D10438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : BEAT, 
   [COORD @D10443, AGR [COUNT @D10442, PER @D10441, PLU @D10440, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : BEAT, 
   [COORD @D10449, PAST @D10448, 
      AGR [CASE @D10447, COUNT @D10446, PER @D10445, PLU @D10444, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : BEAT, 
   [COORD @D10452, AGR [COUNT @D10451, PER @D10450, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10454, AGR [COUNT @D10453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10456, AGR [COUNT @D10455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10460, AGR [COUNT @D10459, PER @D10458, PLU @D10457, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10466, PAST @D10465, AGR [CASE @D10464, COUNT @D10463, 
            PER @D10462, PLU @D10461, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, REG -, LAT -, ARITY 2] : BEAT, 
   [COORD @D10469, AGR [COUNT @D10468, PER @D10467, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADL, REG -, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10471, AGR [COUNT @D10470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADL, REG -, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10473, AGR [COUNT @D10472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADL, REG -, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10477, AGR [COUNT @D10476, PER @D10475, PLU @D10474, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADL, REG -, 
      LAT -, ARITY 2] : BEAT, 
   [COORD @D10483, PAST @D10482, AGR [CASE @D10481, COUNT @D10480, 
            PER @D10479, PLU @D10478, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT ADL, REG -, LAT -, ARITY 2] : BEAT, 
   [COORD @D10487, AGR [COUNT @D10486, PER @D10485, PLU @D10484, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM FOR, PAST +, ARITY 2] : BEAT, 
   [COORD @D10491, AGR [COUNT @D10490, PER @D10489, PLU @D10488, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : BEAT, 
   [COORD @D10495, AGR [COUNT @D10494, PER @D10493, PLU @D10492, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : BEAT, 
   [COORD @D10499, AGR [COUNT @D10498, PER @D10497, PLU @D10496, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : BEAT, 
   [COORD @D10503, AGR [COUNT @D10502, PER @D10501, PLU @D10500, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PAST +, ARITY 2] : BEAT, 
   [COORD @D10507, AGR [COUNT @D10506, PER @D10505, PLU @D10504, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, PAST +, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10511, AGR [COUNT @D10510, PER @D10509, PLU @D10508, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT ADL, REG -, PAST +, LAT -, 
      ARITY 2] : BEAT, 
   [COORD @D10514, AGR [COUNT @D10513, PER @D10512, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : BEAT, 
   [COORD @D10516, AGR [COUNT @D10515, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : BEAT, 
   [COORD @D10518, AGR [COUNT @D10517, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : BEAT, 
   [COORD @D10522, AGR [COUNT @D10521, PER @D10520, PLU @D10519, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : BEAT, 
   [COORD @D10528, PAST @D10527, 
      AGR [CASE @D10526, COUNT @D10525, PER @D10524, PLU @D10523, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : BEAT, 
   [COORD @D10531, AGR [COUNT @D10530, PER @D10529, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : BEAT, 
   [COORD @D10533, AGR [COUNT @D10532, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : BEAT, 
   [COORD @D10535, AGR [COUNT @D10534, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : BEAT, 
   [COORD @D10539, AGR [COUNT @D10538, PER @D10537, PLU @D10536, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : BEAT, 
   [COORD @D10545, PAST @D10544, 
      AGR [CASE @D10543, COUNT @D10542, PER @D10541, PLU @D10540, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : BEAT, 
   [COORD @D10548, AGR [COUNT @D10547, PER @D10546, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BEAT, 
   [COORD @D10550, AGR [COUNT @D10549, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BEAT, 
   [COORD @D10552, AGR [COUNT @D10551, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BEAT, 
   [COORD @D10556, AGR [COUNT @D10555, PER @D10554, PLU @D10553, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : BEAT, 
   [COORD @D10562, PAST @D10561, 
      AGR [CASE @D10560, COUNT @D10559, PER @D10558, PLU @D10557, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : BEAT, 
   [COORD @D10565, AGR [COUNT @D10564, PER @D10563, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : BEAT, 
   [COORD @D10567, AGR [COUNT @D10566, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : BEAT, 
   [COORD @D10569, AGR [COUNT @D10568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : BEAT, 
   [COORD @D10573, AGR [COUNT @D10572, PER @D10571, PLU @D10570, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : BEAT, 
   [COORD @D10579, PAST @D10578, 
      AGR [CASE @D10577, COUNT @D10576, PER @D10575, PLU @D10574, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : BEAT, 
   [COORD @D10582, AGR [COUNT @D10581, PER @D10580, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : BEAT, 
   [COORD @D10584, AGR [COUNT @D10583, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : BEAT, 
   [COORD @D10586, AGR [COUNT @D10585, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : BEAT, 
   [COORD @D10590, AGR [COUNT @D10589, PER @D10588, PLU @D10587, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : BEAT, 
   [COORD @D10596, PAST @D10595, 
      AGR [CASE @D10594, COUNT @D10593, PER @D10592, PLU @D10591, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, 
      ARITY 1] : BEAT, 
   [COORD @D10599, AGR [COUNT @D10598, PER @D10597, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BEAT, 
   [COORD @D10601, AGR [COUNT @D10600, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BEAT, 
   [COORD @D10603, AGR [COUNT @D10602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BEAT, 
   [COORD @D10607, AGR [COUNT @D10606, PER @D10605, PLU @D10604, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, 
      LAT -, ARITY 1] : BEAT, 
   [COORD @D10613, PAST @D10612, AGR [CASE @D10611, COUNT @D10610, 
            PER @D10609, PLU @D10608, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, REG -, LAT -, ARITY 1] : BEAT, 
   [COORD @D10617, AGR [COUNT @D10616, PER @D10615, PLU @D10614, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : BEAT, 
   [COORD @D10621, AGR [COUNT @D10620, PER @D10619, PLU @D10618, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : BEAT, 
   [COORD @D10625, AGR [COUNT @D10624, PER @D10623, PLU @D10622, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : BEAT, 
   [COORD @D10629, AGR [COUNT @D10628, PER @D10627, PLU @D10626, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : BEAT, 
   [COORD @D10633, AGR [COUNT @D10632, PER @D10631, PLU @D10630, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, PAST +, ARITY 1] : BEAT, 
   [COORD @D10637, AGR [COUNT @D10636, PER @D10635, PLU @D10634, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, PAST +, LAT -, 
      ARITY 1] : BEAT.

WORD beaten : 
   [COORD @D10650, PAST @D10649, AGR [CASE @D10648, COUNT @D10647, 
            PER @D10646, PLU @D10645, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM TO, FIN -, ARITY 3] : BEAT, 
   [COORD @D10656, PAST @D10655, 
      AGR [CASE @D10654, COUNT @D10653, PER @D10652, PLU @D10651, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT DOWN, PFORM TO, 
      FIN -, ARITY 3] : BEAT, 
   [COORD @D10662, PAST @D10661, AGR [CASE @D10660, COUNT @D10659, 
            PER @D10658, PLU @D10657, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, LAT -, FIN -, ARITY 3] : BEAT, 
   [COORD @D10668, PAST @D10667, 
      AGR [CASE @D10666, COUNT @D10665, PER @D10664, PLU @D10663, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBCAT NP_ADL, REG -, LAT -, FIN -, ARITY 3] : BEAT, 
   [COORD @D10674, PAST @D10673, 
      AGR [CASE @D10672, COUNT @D10671, PER @D10670, PLU @D10669, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ABOUT, PFORM FOR, 
      FIN -, ARITY 2] : BEAT, 
   [COORD @D10680, PAST @D10679, AGR [CASE @D10678, COUNT @D10677, 
            PER @D10676, PLU @D10675, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : BEAT, 
   [COORD @D10686, PAST @D10685, 
      AGR [CASE @D10684, COUNT @D10683, PER @D10682, PLU @D10681, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : BEAT, 
   [COORD @D10692, PAST @D10691, AGR [CASE @D10690, COUNT @D10689, 
            PER @D10688, PLU @D10687, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : BEAT, 
   [COORD @D10698, PAST @D10697, 
      AGR [CASE @D10696, COUNT @D10695, PER @D10694, PLU @D10693, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : BEAT, 
   [COORD @D10704, PAST @D10703, AGR [CASE @D10702, COUNT @D10701, 
            PER @D10700, PLU @D10699, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : BEAT, 
   [COORD @D10710, PAST @D10709, 
      AGR [CASE @D10708, COUNT @D10707, PER @D10706, PLU @D10705, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      FIN -, ARITY 2] : BEAT, 
   [COORD @D10716, PAST @D10715, AGR [CASE @D10714, COUNT @D10713, 
            PER @D10712, PLU @D10711, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : BEAT, 
   [COORD @D10722, PAST @D10721, 
      AGR [CASE @D10720, COUNT @D10719, PER @D10718, PLU @D10717, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      FIN -, ARITY 2] : BEAT, 
   [COORD @D10728, PAST @D10727, AGR [CASE @D10726, COUNT @D10725, 
            PER @D10724, PLU @D10723, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, 
      LAT -, FIN -, ARITY 2] : BEAT, 
   [COORD @D10734, PAST @D10733, AGR [CASE @D10732, COUNT @D10731, 
            PER @D10730, PLU @D10729, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, 
      REG -, LAT -, FIN -, ARITY 2] : BEAT, 
   [COORD @D10740, PAST @D10739, 
      AGR [CASE @D10738, COUNT @D10737, PER @D10736, PLU @D10735, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBCAT ADL, REG -, LAT -, FIN -, ARITY 2] : BEAT, 
   [COORD @D10746, PAST @D10745, 
      AGR [CASE @D10744, COUNT @D10743, PER @D10742, PLU @D10741, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : BEAT, 
   [COORD @D10752, PAST @D10751, AGR [CASE @D10750, COUNT @D10749, 
            PER @D10748, PLU @D10747, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : BEAT, 
   [COORD @D10758, PAST @D10757, 
      AGR [CASE @D10756, COUNT @D10755, PER @D10754, PLU @D10753, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, FIN -, 
      ARITY 1] : BEAT, 
   [COORD @D10764, PAST @D10763, AGR [CASE @D10762, COUNT @D10761, 
            PER @D10760, PLU @D10759, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : BEAT, 
   [COORD @D10770, PAST @D10769, 
      AGR [CASE @D10768, COUNT @D10767, PER @D10766, PLU @D10765, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, FIN -, 
      ARITY 1] : BEAT, 
   [COORD @D10776, PAST @D10775, AGR [CASE @D10774, COUNT @D10773, 
            PER @D10772, PLU @D10771, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      REG -, LAT -, FIN -, ARITY 1] : BEAT.

WORD beating : 
   [COORD @D10814, REFL @D10813, COUNT @D10812, PRD @D10811, 
      CASE @D10810, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : BEATING, 
   [COORD @D10820, PRD @D10819, 
      AGR [CASE @D10818, COUNT @D10817, PER @D10816, PLU @D10815, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BEAT, 
   [COORD @D10826, PRD @D10825, AGR [CASE @D10824, COUNT @D10823, 
            PER @D10822, PLU @D10821, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BEAT, 
   [COORD @D10832, PRD @D10831, 
      AGR [CASE @D10830, COUNT @D10829, PER @D10828, PLU @D10827, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ABOUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BEAT, 
   [COORD @D10838, PRD @D10837, AGR [CASE @D10836, COUNT @D10835, 
            PER @D10834, PLU @D10833, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAT, 
   [COORD @D10844, PRD @D10843, 
      AGR [CASE @D10842, COUNT @D10841, PER @D10840, PLU @D10839, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAT, 
   [COORD @D10850, PRD @D10849, AGR [CASE @D10848, COUNT @D10847, 
            PER @D10846, PLU @D10845, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAT, 
   [COORD @D10856, PRD @D10855, 
      AGR [CASE @D10854, COUNT @D10853, PER @D10852, PLU @D10851, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAT, 
   [COORD @D10862, PRD @D10861, AGR [CASE @D10860, COUNT @D10859, 
            PER @D10858, PLU @D10857, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BEAT, 
   [COORD @D10868, PRD @D10867, 
      AGR [CASE @D10866, COUNT @D10865, PER @D10864, PLU @D10863, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BEAT, 
   [COORD @D10874, PRD @D10873, AGR [CASE @D10872, COUNT @D10871, 
            PER @D10870, PLU @D10869, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAT, 
   [COORD @D10880, PRD @D10879, 
      AGR [CASE @D10878, COUNT @D10877, PER @D10876, PLU @D10875, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAT, 
   [COORD @D10886, PRD @D10885, AGR [CASE @D10884, COUNT @D10883, 
            PER @D10882, PLU @D10881, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAT, 
   [COORD @D10892, PRD @D10891, 
      AGR [CASE @D10890, COUNT @D10889, PER @D10888, PLU @D10887, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BEAT, 
   [COORD @D10898, PRD @D10897, AGR [CASE @D10896, COUNT @D10895, 
            PER @D10894, PLU @D10893, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAT, 
   [COORD @D10904, PRD @D10903, 
      AGR [CASE @D10902, COUNT @D10901, PER @D10900, PLU @D10899, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BEAT.

WORD beatings : 
   [COORD @D10920, DEMON @D10919, REFL @D10918, PRD @D10917, 
      CASE @D10916, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BEATING.

WORD beats : 
   [COORD @D10929, AGR [COUNT @D10928, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BEAT, 
   [COORD @D10931, AGR [COUNT @D10930, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10933, 
      AGR [COUNT @D10932, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ABOUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BEAT, 
   [COORD @D10935, AGR [COUNT @D10934, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10937, 
      AGR [COUNT @D10936, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10939, 
      AGR [COUNT @D10938, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10941, 
      AGR [COUNT @D10940, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10943, 
      AGR [COUNT @D10942, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10945, 
      AGR [COUNT @D10944, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10947, 
      AGR [COUNT @D10946, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10949, 
      AGR [COUNT @D10948, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10951, 
      AGR [COUNT @D10950, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10953, 
      AGR [COUNT @D10952, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10955, 
      AGR [COUNT @D10954, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT, 
   [COORD @D10957, 
      AGR [COUNT @D10956, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEAT.

WORD begin : 
   [COORD @D10966, AGR [COUNT @D10965, PER @D10964, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEGIN, 
   [COORD @D10968, AGR [COUNT @D10967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEGIN, 
   [COORD @D10970, AGR [COUNT @D10969, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEGIN, 
   [COORD @D10974, AGR [COUNT @D10973, PER @D10972, PLU @D10971, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BEGIN, 
   [COORD @D10980, PAST @D10979, AGR [CASE @D10978, COUNT @D10977, 
            PER @D10976, PLU @D10975, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, REG -, LAT -, ARITY 2] : BEGIN, 
   [COORD @D10982, AGR [COUNT @D10981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D10984, AGR [COUNT @D10983, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D10988, AGR [NFORM @D10987, COUNT @D10986, PER @D10985, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D10992, AGR [COUNT @D10991, PER @D10990, PLU @D10989, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_ING, REG -, 
      LAT -, ARITY 1] : BEGIN, 
   [COORD @D10995, AGR @D10994, PAST @D10993, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D10997, AGR [COUNT @D10996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D10999, AGR [COUNT @D10998, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D11003, AGR [NFORM @D11002, COUNT @D11001, PER @D11000, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D11007, AGR [COUNT @D11006, PER @D11005, PLU @D11004, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SC_INF, REG -, 
      LAT -, ARITY 1] : BEGIN, 
   [COORD @D11010, AGR @D11009, PAST @D11008, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D11013, AGR [COUNT @D11012, PER @D11011, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D11015, AGR [COUNT @D11014, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D11017, AGR [COUNT @D11016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BEGIN, 
   [COORD @D11021, AGR [COUNT @D11020, PER @D11019, PLU @D11018, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, 
      LAT -, ARITY 1] : BEGIN, 
   [COORD @D11027, PAST @D11026, AGR [CASE @D11025, COUNT @D11024, 
            PER @D11023, PLU @D11022, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, REG -, LAT -, ARITY 1] : BEGIN.

WORD beginning : 
   [COORD @D11047, REFL @D11046, COUNT @D11045, PRD @D11044, 
      CASE @D11043, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : BEGINNING, 
   [COORD @D11053, PRD @D11052, 
      AGR [CASE @D11051, COUNT @D11050, PER @D11049, PLU @D11048, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BEGIN, 
   [COORD @D11056, AGR @D11055, PRD @D11054, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BEGIN, 
   [COORD @D11059, AGR @D11058, PRD @D11057, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BEGIN, 
   [COORD @D11065, PRD @D11064, AGR [CASE @D11063, COUNT @D11062, 
            PER @D11061, PLU @D11060, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BEGIN.

WORD beginnings : 
   [COORD @D11080, DEMON @D11079, REFL @D11078, PRD @D11077, 
      CASE @D11076, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   BEGINNING.

WORD begins : 
   [COORD @D11089, AGR [COUNT @D11088, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEGIN, 
   [COORD @D11093, 
      AGR [CASE @D11092, NFORM @D11091, COUNT @D11090, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEGIN, 
   [COORD @D11098, 
      AGR [UB @D11097, VFORM @D11096, SUBJ @D11095, FIN @D11094, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEGIN, 
   [COORD @D11102, 
      AGR [CASE @D11101, NFORM @D11100, COUNT @D11099, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEGIN, 
   [COORD @D11107, 
      AGR [UB @D11106, VFORM @D11105, SUBJ @D11104, FIN @D11103, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEGIN, 
   [COORD @D11109, 
      AGR [COUNT @D11108, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BEGIN.

WORD believe : 
   [COORD @D11119, AGR [COUNT @D11118, PER @D11117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP IN, ARITY 2] : BELIEVE, 
   [COORD @D11121, AGR [COUNT @D11120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP IN, ARITY 2] : BELIEVE, 
   [COORD @D11123, AGR [COUNT @D11122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP IN, ARITY 2] : BELIEVE, 
   [COORD @D11127, AGR [COUNT @D11126, PER @D11125, PLU @D11124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP IN, ARITY 2] : BELIEVE, 
   [COORD @D11133, PAST @D11132, 
      AGR [CASE @D11131, COUNT @D11130, PER @D11129, PLU @D11128, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP IN, ARITY 2] : BELIEVE, 
   [COORD @D11136, AGR [COUNT @D11135, PER @D11134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : BELIEVE, 
   [COORD @D11138, AGR [COUNT @D11137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : BELIEVE, 
   [COORD @D11140, AGR [COUNT @D11139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : BELIEVE, 
   [COORD @D11144, AGR [COUNT @D11143, PER @D11142, PLU @D11141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, ARITY 2] : BELIEVE, 
   [COORD @D11150, PAST @D11149, 
      AGR [CASE @D11148, COUNT @D11147, PER @D11146, PLU @D11145, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM IN, 
      ARITY 2] : BELIEVE, 
   [COORD @D11153, AGR [COUNT @D11152, PER @D11151, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11155, AGR [COUNT @D11154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11157, AGR [COUNT @D11156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11161, AGR [COUNT @D11160, PER @D11159, PLU @D11158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT SFIN, 
      LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11167, PAST @D11166, AGR [CASE @D11165, COUNT @D11164, 
            PER @D11163, PLU @D11162, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT SFIN, LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11170, AGR [COUNT @D11169, PER @D11168, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11172, AGR [COUNT @D11171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11174, AGR [COUNT @D11173, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11178, AGR [COUNT @D11177, PER @D11176, PLU @D11175, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11184, PAST @D11183, AGR [CASE @D11182, COUNT @D11181, 
            PER @D11180, PLU @D11179, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11187, AGR [COUNT @D11186, PER @D11185, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11189, AGR [COUNT @D11188, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11191, AGR [COUNT @D11190, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11195, AGR [COUNT @D11194, PER @D11193, PLU @D11192, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11201, PAST @D11200, AGR [CASE @D11199, COUNT @D11198, 
            PER @D11197, PLU @D11196, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11204, AGR [COUNT @D11203, PER @D11202, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11206, AGR [COUNT @D11205, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11208, AGR [COUNT @D11207, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11212, AGR [COUNT @D11211, PER @D11210, PLU @D11209, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11218, PAST @D11217, AGR [CASE @D11216, COUNT @D11215, 
            PER @D11214, PLU @D11213, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11221, AGR [COUNT @D11220, PER @D11219, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11223, AGR [COUNT @D11222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11225, AGR [COUNT @D11224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11229, AGR [COUNT @D11228, PER @D11227, PLU @D11226, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BELIEVE, 
   [COORD @D11235, PAST @D11234, AGR [CASE @D11233, COUNT @D11232, 
            PER @D11231, PLU @D11230, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : BELIEVE, 
   [COORD @D11238, AGR [COUNT @D11237, PER @D11236, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BELIEVE, 
   [COORD @D11240, AGR [COUNT @D11239, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BELIEVE, 
   [COORD @D11242, AGR [COUNT @D11241, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BELIEVE, 
   [COORD @D11246, AGR [COUNT @D11245, PER @D11244, PLU @D11243, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      LAT -, ARITY 1] : BELIEVE, 
   [COORD @D11252, PAST @D11251, AGR [CASE @D11250, COUNT @D11249, 
            PER @D11248, PLU @D11247, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : BELIEVE.

WORD believed : 
   [COORD @D11265, AGR [CASE @D11264, COUNT @D11263, PER @D11262, 
            PLU @D11261, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11270, AGR [CASE @D11269, COUNT @D11268, PER @D11267, 
            PLU @D11266, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11275, AGR [CASE @D11274, COUNT @D11273, PER @D11272, 
            PLU @D11271, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11280, AGR [CASE @D11279, COUNT @D11278, PER @D11277, 
            PLU @D11276, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11285, AGR [CASE @D11284, COUNT @D11283, PER @D11282, 
            PLU @D11281, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11290, AGR [UB @D11289, VFORM @D11288, SUBJ @D11287, 
            FIN @D11286, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BELIEVE, 
   [COORD @D11295, AGR [CASE @D11294, COUNT @D11293, PER @D11292, 
            PLU @D11291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11300, AGR [CASE @D11299, COUNT @D11298, PER @D11297, 
            PLU @D11296, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11305, AGR [CASE @D11304, COUNT @D11303, PER @D11302, 
            PLU @D11301, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11310, AGR [CASE @D11309, COUNT @D11308, PER @D11307, 
            PLU @D11306, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11315, AGR [CASE @D11314, COUNT @D11313, PER @D11312, 
            PLU @D11311, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11321, AGR [CASE @D11320, NFORM @D11319, COUNT @D11318, 
            PER @D11317, PLU @D11316, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11326, AGR [UB @D11325, VFORM @D11324, SUBJ @D11323, 
            FIN @D11322, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BELIEVE, 
   [COORD @D11331, AGR [CASE @D11330, COUNT @D11329, PER @D11328, 
            PLU @D11327, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11336, AGR [CASE @D11335, COUNT @D11334, PER @D11333, 
            PLU @D11332, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11341, AGR [CASE @D11340, COUNT @D11339, PER @D11338, 
            PLU @D11337, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11346, AGR [CASE @D11345, COUNT @D11344, PER @D11343, 
            PLU @D11342, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11352, AGR [CASE @D11351, NFORM @D11350, COUNT @D11349, 
            PER @D11348, PLU @D11347, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11357, AGR [UB @D11356, VFORM @D11355, SUBJ @D11354, 
            FIN @D11353, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BELIEVE, 
   [COORD @D11362, AGR [CASE @D11361, COUNT @D11360, PER @D11359, 
            PLU @D11358, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11367, AGR [CASE @D11366, COUNT @D11365, PER @D11364, 
            PLU @D11363, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11372, AGR [CASE @D11371, COUNT @D11370, PER @D11369, 
            PLU @D11368, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11377, AGR [CASE @D11376, COUNT @D11375, PER @D11374, 
            PLU @D11373, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11382, AGR [CASE @D11381, COUNT @D11380, PER @D11379, 
            PLU @D11378, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELIEVE.

WORD believes : 
   [COORD @D11392, AGR [COUNT @D11391, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11394, 
      AGR [COUNT @D11393, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11396, 
      AGR [COUNT @D11395, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11398, 
      AGR [COUNT @D11397, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11400, 
      AGR [COUNT @D11399, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11402, 
      AGR [COUNT @D11401, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11404, 
      AGR [COUNT @D11403, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11406, 
      AGR [COUNT @D11405, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELIEVE.

WORD believing : 
   [COORD @D11419, PRD @D11418, AGR [CASE @D11417, COUNT @D11416, 
            PER @D11415, PLU @D11414, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11425, PRD @D11424, 
      AGR [CASE @D11423, COUNT @D11422, PER @D11421, PLU @D11420, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BELIEVE, 
   [COORD @D11431, PRD @D11430, AGR [CASE @D11429, COUNT @D11428, 
            PER @D11427, PLU @D11426, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11437, PRD @D11436, 
      AGR [CASE @D11435, COUNT @D11434, PER @D11433, PLU @D11432, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BELIEVE, 
   [COORD @D11443, PRD @D11442, AGR [CASE @D11441, COUNT @D11440, 
            PER @D11439, PLU @D11438, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11449, PRD @D11448, 
      AGR [CASE @D11447, COUNT @D11446, PER @D11445, PLU @D11444, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BELIEVE, 
   [COORD @D11455, PRD @D11454, AGR [CASE @D11453, COUNT @D11452, 
            PER @D11451, PLU @D11450, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BELIEVE, 
   [COORD @D11461, PRD @D11460, 
      AGR [CASE @D11459, COUNT @D11458, PER @D11457, PLU @D11456, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BELIEVE.

WORD belong : 
   [COORD @D11470, AGR [COUNT @D11469, PER @D11468, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : BELONG, 
   [COORD @D11472, AGR [COUNT @D11471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : BELONG, 
   [COORD @D11474, AGR [COUNT @D11473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : BELONG, 
   [COORD @D11478, AGR [COUNT @D11477, PER @D11476, PLU @D11475, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : BELONG, 
   [COORD @D11484, PAST @D11483, 
      AGR [CASE @D11482, COUNT @D11481, PER @D11480, PLU @D11479, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      ARITY 2] : BELONG, 
   [COORD @D11487, AGR [COUNT @D11486, PER @D11485, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : BELONG, 
   [COORD @D11489, AGR [COUNT @D11488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : BELONG, 
   [COORD @D11491, AGR [COUNT @D11490, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : BELONG, 
   [COORD @D11495, AGR [COUNT @D11494, PER @D11493, PLU @D11492, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, 
      LAT -, ARITY 2] : BELONG, 
   [COORD @D11501, PAST @D11500, AGR [CASE @D11499, COUNT @D11498, 
            PER @D11497, PLU @D11496, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT LOC, LAT -, ARITY 2] : BELONG, 
   [COORD @D11504, AGR [COUNT @D11503, PER @D11502, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BELONG, 
   [COORD @D11506, AGR [COUNT @D11505, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BELONG, 
   [COORD @D11508, AGR [COUNT @D11507, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BELONG, 
   [COORD @D11512, AGR [COUNT @D11511, PER @D11510, PLU @D11509, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      LAT -, ARITY 1] : BELONG, 
   [COORD @D11518, PAST @D11517, AGR [CASE @D11516, COUNT @D11515, 
            PER @D11514, PLU @D11513, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : BELONG.

WORD belonged : 
   [COORD @D11530, AGR [CASE @D11529, COUNT @D11528, PER @D11527, 
            PLU @D11526, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BELONG, 
   [COORD @D11535, AGR [CASE @D11534, COUNT @D11533, PER @D11532, 
            PLU @D11531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BELONG, 
   [COORD @D11540, AGR [CASE @D11539, COUNT @D11538, PER @D11537, 
            PLU @D11536, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELONG, 
   [COORD @D11545, AGR [CASE @D11544, COUNT @D11543, PER @D11542, 
            PLU @D11541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELONG, 
   [COORD @D11550, AGR [CASE @D11549, COUNT @D11548, PER @D11547, 
            PLU @D11546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELONG, 
   [COORD @D11555, AGR [CASE @D11554, COUNT @D11553, PER @D11552, 
            PLU @D11551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BELONG, 
   [COORD @D11560, AGR [CASE @D11559, COUNT @D11558, PER @D11557, 
            PLU @D11556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BELONG.

WORD belonging : 
   [COORD @D11575, PRD @D11574, AGR [CASE @D11573, COUNT @D11572, 
            PER @D11571, PLU @D11570, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BELONG, 
   [COORD @D11581, PRD @D11580, 
      AGR [CASE @D11579, COUNT @D11578, PER @D11577, PLU @D11576, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BELONG, 
   [COORD @D11587, PRD @D11586, AGR [CASE @D11585, COUNT @D11584, 
            PER @D11583, PLU @D11582, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BELONG.

WORD belongs : 
   [COORD @D11596, AGR [COUNT @D11595, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BELONG, 
   [COORD @D11598, AGR [COUNT @D11597, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELONG, 
   [COORD @D11600, 
      AGR [COUNT @D11599, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BELONG.

WORD bend : 
   [COORD @D11609, AGR [COUNT @D11608, PER @D11607, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : BEND, 
   [COORD @D11611, AGR [COUNT @D11610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : BEND, 
   [COORD @D11613, AGR [COUNT @D11612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : BEND, 
   [COORD @D11617, AGR [COUNT @D11616, PER @D11615, PLU @D11614, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : BEND, 
   [COORD @D11623, PAST @D11622, AGR [CASE @D11621, COUNT @D11620, 
            PER @D11619, PLU @D11618, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : BEND, 
   [COORD @D11626, 
      AGR [COUNT @D11625, PER @D11624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BEFORE, 
      ARITY 2] : BEND, 
   [COORD @D11628, AGR [COUNT @D11627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEFORE, ARITY 2] : BEND, 
   [COORD @D11630, AGR [COUNT @D11629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEFORE, ARITY 2] : BEND, 
   [COORD @D11634, AGR [COUNT @D11633, PER @D11632, PLU @D11631, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BEFORE, ARITY 2] : BEND, 
   [COORD @D11640, PAST @D11639, 
      AGR [CASE @D11638, COUNT @D11637, PER @D11636, PLU @D11635, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BEFORE, 
      ARITY 2] : BEND.

WORD bending : 
   [COORD @D11655, PRD @D11654, AGR [CASE @D11653, COUNT @D11652, 
            PER @D11651, PLU @D11650, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BEND, 
   [COORD @D11661, PRD @D11660, 
      AGR [CASE @D11659, COUNT @D11658, PER @D11657, PLU @D11656, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BEFORE, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BEND.

WORD bends : 
   [COORD @D11670, AGR [COUNT @D11669, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BEND, 
   [COORD @D11672, AGR [COUNT @D11671, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BEFORE, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BEND.

WORD benefit : 
   [COORD @D11683, REFL @D11682, COUNT @D11681, PRD @D11680, 
      CASE @D11679, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : BENEFIT, 
   [COORD @D11686, 
      AGR [COUNT @D11685, PER @D11684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   BENEFIT, 
   [COORD @D11688, AGR [COUNT @D11687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BENEFIT, 
   [COORD @D11690, AGR [COUNT @D11689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BENEFIT, 
   [COORD @D11694, AGR [COUNT @D11693, PER @D11692, PLU @D11691, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : BENEFIT, 
   [COORD @D11700, PAST @D11699, AGR [CASE @D11698, COUNT @D11697, 
            PER @D11696, PLU @D11695, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : BENEFIT, 
   [COORD @D11703, AGR [COUNT @D11702, PER @D11701, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : BENEFIT, 
   [COORD @D11705, AGR [COUNT @D11704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : BENEFIT, 
   [COORD @D11707, AGR [COUNT @D11706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : BENEFIT, 
   [COORD @D11711, AGR [COUNT @D11710, PER @D11709, PLU @D11708, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : BENEFIT, 
   [COORD @D11717, PAST @D11716, 
      AGR [CASE @D11715, COUNT @D11714, PER @D11713, PLU @D11712, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, 
      ARITY 2] : BENEFIT.

WORD benefits : 
   [COORD @D11730, DEMON @D11729, REFL @D11728, PRD @D11727, 
      CASE @D11726, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BENEFIT, 
   
   [COORD @D11732, AGR [COUNT @D11731, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BENEFIT, 
   [COORD @D11734, 
      AGR [COUNT @D11733, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BENEFIT.

WORD benefitted : 
   [COORD @D11747, AGR [CASE @D11746, COUNT @D11745, PER @D11744, 
            PLU @D11743, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BENEFIT, 
   [COORD @D11752, AGR [CASE @D11751, COUNT @D11750, PER @D11749, 
            PLU @D11748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BENEFIT, 
   [COORD @D11757, AGR [CASE @D11756, COUNT @D11755, PER @D11754, 
            PLU @D11753, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BENEFIT, 
   [COORD @D11762, AGR [CASE @D11761, COUNT @D11760, PER @D11759, 
            PLU @D11758, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BENEFIT, 
   [COORD @D11767, AGR [CASE @D11766, COUNT @D11765, PER @D11764, 
            PLU @D11763, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BENEFIT, 
   [COORD @D11772, AGR [CASE @D11771, COUNT @D11770, PER @D11769, 
            PLU @D11768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BENEFIT.

WORD benefitting : 
   [COORD @D11790, PRD @D11789, AGR [CASE @D11788, COUNT @D11787, 
            PER @D11786, PLU @D11785, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BENEFIT, 
   [COORD @D11796, PRD @D11795, 
      AGR [CASE @D11794, COUNT @D11793, PER @D11792, PLU @D11791, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BENEFIT.

WORD bent : 
   [COADV @D11810, COORD @D11809, DEF @D11808, PRD @D11807, AGR 
            [CASE @D11806, COUNT @D11805, PER @D11804, PLU @D11803, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   BENT_ON, 
   [COADV @D11818, COORD @D11817, DEF @D11816, PRD @D11815, AGR 
            [CASE @D11814, COUNT @D11813, PER @D11812, PLU @D11811, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT PPING, PFORM ON, 
      DISTR PRD, ARITY 2] : BENT_ON, 
   [COADV @D11826, COORD @D11825, DEF @D11824, PRD @D11823, 
      AGR [CASE @D11822, COUNT @D11821, PER @D11820, PLU @D11819, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, DISTR PRD, 
      ARITY 2] : BENT_ON, 
   [COORD @D11830, REFL @D11829, PRD @D11828, CASE @D11827, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BENT, 
   [COORD @D11834, REFL @D11833, PRD @D11832, CASE @D11831, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : BENT, 
   [COORD @D11840, PAST @D11839, 
      AGR [CASE @D11838, COUNT @D11837, PER @D11836, PLU @D11835, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM TO, FIN -, 
      ARITY 2] : BEND, 
   [COORD @D11846, PAST @D11845, AGR [CASE @D11844, COUNT @D11843, 
            PER @D11842, PLU @D11841, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : BEND, 
   [COORD @D11852, PAST @D11851, 
      AGR [CASE @D11850, COUNT @D11849, PER @D11848, PLU @D11847, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM BEFORE, 
      FIN -, ARITY 2] : BEND, 
   [COORD @D11858, PAST @D11857, AGR [CASE @D11856, COUNT @D11855, 
            PER @D11854, PLU @D11853, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM BEFORE, FIN -, ARITY 2] : BEND, 
   [COORD @D11862, 
      AGR [COUNT @D11861, PER @D11860, PLU @D11859, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, 
      PAST +, ARITY 2] : BEND, 
   [COORD @D11866, AGR [COUNT @D11865, PER @D11864, PLU @D11863, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEFORE, PAST +, ARITY 2] : BEND.

WORD bents : 
   [COORD @D11902, DEMON @D11901, REFL @D11900, PRD @D11899, CASE 
         @D11898, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BENT, 
   [COORD @D11907, DEMON @D11906, REFL @D11905, PRD @D11904, 
      CASE @D11903, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   BENT.

WORD bid : 
   [COORD @D11917, REFL @D11916, PRD @D11915, CASE @D11914, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BID, 
   [COORD @D11920, 
      AGR [COUNT @D11919, PER @D11918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   BID, 
   [COORD @D11922, AGR [COUNT @D11921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : BID, 
   [COORD @D11924, AGR [COUNT @D11923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : BID, 
   [COORD @D11928, AGR [COUNT @D11927, PER @D11926, PLU @D11925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : BID, 
   [COORD @D11934, PAST @D11933, 
      AGR [CASE @D11932, COUNT @D11931, PER @D11930, PLU @D11929, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   BID, 
   [COORD @D11937, AGR [COUNT @D11936, PER @D11935, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : BID, 
   [COORD @D11939, AGR [COUNT @D11938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : BID, 
   [COORD @D11941, AGR [COUNT @D11940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : BID, 
   [COORD @D11945, AGR [COUNT @D11944, PER @D11943, PLU @D11942, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, REG -, ARITY 3] : BID, 
   [COORD @D11951, PAST @D11950, 
      AGR [CASE @D11949, COUNT @D11948, PER @D11947, PLU @D11946, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, REG -, ARITY 3] : 
   BID, 
   [COORD @D11954, AGR [COUNT @D11953, PER @D11952, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : BID, 
   [COORD @D11956, AGR [COUNT @D11955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : BID, 
   [COORD @D11958, AGR [COUNT @D11957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : BID, 
   [COORD @D11962, AGR [COUNT @D11961, PER @D11960, PLU @D11959, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : BID, 
   [COORD @D11968, PAST @D11967, 
      AGR [CASE @D11966, COUNT @D11965, PER @D11964, PLU @D11963, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   BID, 
   [COORD @D11971, AGR [COUNT @D11970, PER @D11969, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : BID, 
   [COORD @D11973, AGR [COUNT @D11972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : BID, 
   [COORD @D11975, AGR [COUNT @D11974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : BID, 
   [COORD @D11979, AGR [COUNT @D11978, PER @D11977, PLU @D11976, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : BID, 
   [COORD @D11985, PAST @D11984, 
      AGR [CASE @D11983, COUNT @D11982, PER @D11981, PLU @D11980, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : BID, 
   [COORD @D11988, AGR [COUNT @D11987, PER @D11986, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : BID, 
   [COORD @D11990, AGR [COUNT @D11989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : BID, 
   [COORD @D11992, AGR [COUNT @D11991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : BID, 
   [COORD @D11996, AGR [COUNT @D11995, PER @D11994, PLU @D11993, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : BID, 
   [COORD @D12002, PAST @D12001, 
      AGR [CASE @D12000, COUNT @D11999, PER @D11998, PLU @D11997, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : BID, 
   [COORD @D12008, PAST @D12007, AGR [CASE @D12006, COUNT @D12005, 
            PER @D12004, PLU @D12003, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : BID, 
   [COORD @D12014, PAST @D12013, 
      AGR [CASE @D12012, COUNT @D12011, PER @D12010, PLU @D12009, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, ARITY 3] : 
   BID, 
   [COORD @D12020, PAST @D12019, AGR [CASE @D12018, COUNT @D12017, 
            PER @D12016, PLU @D12015, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, REG -, FIN -, ARITY 3] : BID, 
   [COORD @D12026, PAST @D12025, 
      AGR [CASE @D12024, COUNT @D12023, PER @D12022, PLU @D12021, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, REG -, FIN -, ARITY 3] : 
   BID, 
   [COORD @D12032, PAST @D12031, AGR [CASE @D12030, COUNT @D12029, 
            PER @D12028, PLU @D12027, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : BID, 
   [COORD @D12038, PAST @D12037, 
      AGR [CASE @D12036, COUNT @D12035, PER @D12034, PLU @D12033, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : BID, 
   [COORD @D12044, PAST @D12043, 
      AGR [CASE @D12042, COUNT @D12041, PER @D12040, PLU @D12039, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : BID, 
   [COORD @D12050, PAST @D12049, AGR [CASE @D12048, COUNT @D12047, 
            PER @D12046, PLU @D12045, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : BID, 
   [COORD @D12056, PAST @D12055, 
      AGR [CASE @D12054, COUNT @D12053, PER @D12052, PLU @D12051, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      FIN -, ARITY 3] : BID, 
   [COORD @D12062, PAST @D12061, AGR [CASE @D12060, COUNT @D12059, 
            PER @D12058, PLU @D12057, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : BID, 
   [COORD @D12066, 
      AGR [COUNT @D12065, PER @D12064, PLU @D12063, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PAST +, 
      ARITY 3] : BID, 
   [COORD @D12071, AGR [CASE @D12070, COUNT @D12069, PER @D12068, 
            PLU @D12067, N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, 
      PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PAST +, ARITY 3] : BID, 
   [COORD @D12075, AGR [COUNT @D12074, PER @D12073, PLU @D12072, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PAST +, 
      ARITY 3] : BID, 
   [COORD @D12079, AGR [COUNT @D12078, PER @D12077, PLU @D12076, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, PAST +, ARITY 3] : BID, 
   [COORD @D12084, AGR [CASE @D12083, COUNT @D12082, PER @D12081, 
            PLU @D12080, N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, 
      PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, REG -, PAST +, ARITY 3] : BID, 
   [COORD @D12088, AGR [COUNT @D12087, PER @D12086, PLU @D12085, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, REG -, PAST +, 
      ARITY 3] : BID, 
   [COORD @D12092, AGR [COUNT @D12091, PER @D12090, PLU @D12089, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : BID, 
   [COORD @D12097, AGR [CASE @D12096, COUNT @D12095, PER @D12094, 
            PLU @D12093, N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, 
      PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : BID, 
   [COORD @D12101, AGR [COUNT @D12100, PER @D12099, PLU @D12098, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : BID, 
   [COORD @D12105, AGR [COUNT @D12104, PER @D12103, PLU @D12102, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : BID, 
   [COORD @D12110, AGR [CASE @D12109, COUNT @D12108, PER @D12107, 
            PLU @D12106, N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, 
      PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, PAST +, ARITY 3] : BID, 
   [COORD @D12114, 
      AGR [COUNT @D12113, PER @D12112, PLU @D12111, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      PAST +, ARITY 3] : BID, 
   [COORD @D12118, AGR [COUNT @D12117, PER @D12116, PLU @D12115, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FOR, PAST +, ARITY 3] : BID, 
   [COORD @D12121, AGR [COUNT @D12120, PER @D12119, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : BID, 
   [COORD @D12123, AGR [COUNT @D12122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : BID, 
   [COORD @D12125, AGR [COUNT @D12124, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : BID, 
   [COORD @D12129, AGR [COUNT @D12128, PER @D12127, PLU @D12126, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : BID, 
   [COORD @D12135, PAST @D12134, AGR [CASE @D12133, COUNT @D12132, 
            PER @D12131, PLU @D12130, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : BID, 
   [COORD @D12138, AGR [COUNT @D12137, PER @D12136, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : BID, 
   [COORD @D12140, AGR [COUNT @D12139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : BID, 
   [COORD @D12142, AGR [COUNT @D12141, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : BID, 
   [COORD @D12146, AGR [COUNT @D12145, PER @D12144, PLU @D12143, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : BID, 
   [COORD @D12152, PAST @D12151, AGR [CASE @D12150, COUNT @D12149, 
            PER @D12148, PLU @D12147, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM ON, ARITY 2] : BID, 
   [COORD @D12155, 
      AGR [COUNT @D12154, PER @D12153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      ARITY 2] : BID, 
   [COORD @D12157, AGR [COUNT @D12156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : BID, 
   [COORD @D12159, AGR [COUNT @D12158, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : BID, 
   [COORD @D12163, AGR [COUNT @D12162, PER @D12161, PLU @D12160, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : BID, 
   [COORD @D12169, PAST @D12168, AGR [CASE @D12167, COUNT @D12166, 
            PER @D12165, PLU @D12164, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : BID, 
   [COORD @D12175, PAST @D12174, 
      AGR [CASE @D12173, COUNT @D12172, PER @D12171, PLU @D12170, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : BID, 
   [COORD @D12181, PAST @D12180, AGR [CASE @D12179, COUNT @D12178, 
            PER @D12177, PLU @D12176, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : BID, 
   [COORD @D12187, PAST @D12186, 
      AGR [CASE @D12185, COUNT @D12184, PER @D12183, PLU @D12182, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM ON, FIN -, 
      ARITY 2] : BID, 
   [COORD @D12193, PAST @D12192, AGR [CASE @D12191, COUNT @D12190, 
            PER @D12189, PLU @D12188, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM FOR, FIN -, ARITY 2] : BID, 
   [COORD @D12197, 
      AGR [COUNT @D12196, PER @D12195, PLU @D12194, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : BID, 
   [COORD @D12202, AGR [CASE @D12201, COUNT @D12200, PER @D12199, 
            PLU @D12198, N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, 
      PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PAST +, ARITY 2] : BID, 
   [COORD @D12206, AGR [COUNT @D12205, PER @D12204, PLU @D12203, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : BID, 
   [COORD @D12210, AGR [COUNT @D12209, PER @D12208, PLU @D12207, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, PAST +, ARITY 2] : BID, 
   [COORD @D12214, AGR [COUNT @D12213, PER @D12212, PLU @D12211, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : BID, 
   [COORD @D12217, AGR [COUNT @D12216, PER @D12215, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : BID, 
   [COORD @D12219, AGR [COUNT @D12218, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : BID, 
   [COORD @D12221, AGR [COUNT @D12220, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : BID, 
   [COORD @D12225, AGR [COUNT @D12224, PER @D12223, PLU @D12222, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : BID, 
   [COORD @D12231, PAST @D12230, AGR 
         [CASE @D12229, COUNT @D12228, PER @D12227, PLU @D12226, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   BID, 
   [COORD @D12237, PAST @D12236, AGR [CASE @D12235, COUNT @D12234, 
            PER @D12233, PLU @D12232, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : BID, 
   [COORD @D12241, AGR [COUNT @D12240, PER @D12239, PLU @D12238, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : BID.

WORD bidding : 
   [COORD @D12269, PRD @D12268, AGR [CASE @D12267, COUNT @D12266, 
            PER @D12265, PLU @D12264, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BID, 
   [COORD @D12275, PRD @D12274, AGR 
         [CASE @D12273, COUNT @D12272, PER @D12271, PLU @D12270, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BID, 
   
   [COORD @D12281, PRD @D12280, AGR [CASE @D12279, COUNT @D12278, PER 
               @D12277, PLU @D12276, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BID, 
   [COORD @D12287, PRD @D12286, AGR 
         [CASE @D12285, COUNT @D12284, PER @D12283, PLU @D12282, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BID, 
   [COORD @D12293, PRD @D12292, AGR [CASE @D12291, COUNT @D12290, 
            PER @D12289, PLU @D12288, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BID, 
   [COORD @D12299, PRD @D12298, 
      AGR [CASE @D12297, COUNT @D12296, PER @D12295, PLU @D12294, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BID, 
   
   [COORD @D12305, PRD @D12304, AGR [CASE @D12303, COUNT @D12302, PER 
               @D12301, PLU @D12300, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BID, 
   [COORD @D12311, PRD @D12310, 
      AGR [CASE @D12309, COUNT @D12308, PER @D12307, PLU @D12306, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BID, 
   [COORD @D12317, PRD @D12316, AGR [CASE @D12315, COUNT @D12314, 
            PER @D12313, PLU @D12312, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BID.

WORD bids : 
   [COORD @D12330, DEMON @D12329, REFL @D12328, PRD @D12327, CASE 
         @D12326, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BID, 
   [COORD @D12332, 
      AGR [COUNT @D12331, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12334, 
      AGR [COUNT @D12333, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12336, 
      AGR [COUNT @D12335, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12338, 
      AGR [COUNT @D12337, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12340, 
      AGR [COUNT @D12339, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12342, 
      AGR [COUNT @D12341, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12344, 
      AGR [COUNT @D12343, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12346, 
      AGR [COUNT @D12345, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID, 
   [COORD @D12348, 
      AGR [COUNT @D12347, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BID.

WORD bind : 
   [COORD @D12357, AGR [COUNT @D12356, PER @D12355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : BIND, 
   [COORD @D12359, AGR [COUNT @D12358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : BIND, 
   [COORD @D12361, AGR [COUNT @D12360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : BIND, 
   [COORD @D12365, AGR [COUNT @D12364, PER @D12363, PLU @D12362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : BIND, 
   [COORD @D12371, PAST @D12370, 
      AGR [CASE @D12369, COUNT @D12368, PER @D12367, PLU @D12366, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : BIND, 
   [COORD @D12374, AGR [COUNT @D12373, PER @D12372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : BIND, 
   [COORD @D12376, AGR [COUNT @D12375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : BIND, 
   [COORD @D12378, AGR [COUNT @D12377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : BIND, 
   [COORD @D12382, AGR [COUNT @D12381, PER @D12380, PLU @D12379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : BIND, 
   [COORD @D12388, PAST @D12387, 
      AGR [CASE @D12386, COUNT @D12385, PER @D12384, PLU @D12383, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : BIND, 
   [COORD @D12391, AGR [COUNT @D12390, PER @D12389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : BIND, 
   [COORD @D12393, AGR [COUNT @D12392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : BIND, 
   [COORD @D12395, AGR [COUNT @D12394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : BIND, 
   [COORD @D12399, AGR [COUNT @D12398, PER @D12397, PLU @D12396, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : BIND, 
   [COORD @D12405, PAST @D12404, 
      AGR [CASE @D12403, COUNT @D12402, PER @D12401, PLU @D12400, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : BIND.

WORD binding : 
   [COORD @D12420, PRD @D12419, AGR [CASE @D12418, COUNT @D12417, 
            PER @D12416, PLU @D12415, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BIND, 
   [COORD @D12426, PRD @D12425, 
      AGR [CASE @D12424, COUNT @D12423, PER @D12422, PLU @D12421, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BIND, 
   [COORD @D12432, PRD @D12431, AGR [CASE @D12430, COUNT @D12429, 
            PER @D12428, PLU @D12427, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BIND.

WORD binds : 
   [COORD @D12441, AGR [COUNT @D12440, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BIND, 
   [COORD @D12443, AGR [COUNT @D12442, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BIND, 
   [COORD @D12445, 
      AGR [COUNT @D12444, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BIND.

WORD bore : 
   [COORD @D12454, AGR [COUNT @D12453, PER @D12452, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BORE, 
   [COORD @D12456, AGR [COUNT @D12455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BORE, 
   [COORD @D12458, AGR [COUNT @D12457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BORE, 
   [COORD @D12462, AGR [COUNT @D12461, PER @D12460, PLU @D12459, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : BORE, 
   [COORD @D12468, PAST @D12467, AGR [CASE @D12466, COUNT @D12465, 
            PER @D12464, PLU @D12463, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : BORE, 
   [COORD @D12471, AGR [COUNT @D12470, PER @D12469, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BORE, 
   [COORD @D12473, AGR [COUNT @D12472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BORE, 
   [COORD @D12475, AGR [COUNT @D12474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BORE, 
   [COORD @D12479, AGR [COUNT @D12478, PER @D12477, PLU @D12476, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BORE, 
   [COORD @D12485, PAST @D12484, AGR [CASE @D12483, COUNT @D12482, 
            PER @D12481, PLU @D12480, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : BORE, 
   [COORD @D12488, AGR [COUNT @D12487, PER @D12486, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : BORE, 
   [COORD @D12490, AGR [COUNT @D12489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : BORE, 
   [COORD @D12492, AGR [COUNT @D12491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, LAT -, 
      ARITY 2] : BORE, 
   [COORD @D12496, AGR [COUNT @D12495, PER @D12494, PLU @D12493, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT LOC, 
      LAT -, ARITY 2] : BORE, 
   [COORD @D12502, PAST @D12501, AGR [CASE @D12500, COUNT @D12499, 
            PER @D12498, PLU @D12497, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT LOC, LAT -, ARITY 2] : BORE, 
   [COORD @D12506, AGR [COUNT @D12505, PER @D12504, PLU @D12503, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : BARE, 
   [COORD @D12509, AGR [COUNT @D12508, PER @D12507, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BORE, 
   [COORD @D12511, AGR [COUNT @D12510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BORE, 
   [COORD @D12513, AGR [COUNT @D12512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BORE, 
   [COORD @D12517, AGR [COUNT @D12516, PER @D12515, PLU @D12514, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : BORE, 
   [COORD @D12523, PAST @D12522, AGR [CASE @D12521, COUNT @D12520, 
            PER @D12519, PLU @D12518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : BORE, 
   [COORD @D12526, AGR [COUNT @D12525, PER @D12524, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BORE, 
   [COORD @D12528, AGR [COUNT @D12527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BORE, 
   [COORD @D12530, AGR [COUNT @D12529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BORE, 
   [COORD @D12534, AGR [COUNT @D12533, PER @D12532, PLU @D12531, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      LAT -, ARITY 1] : BORE, 
   [COORD @D12540, PAST @D12539, AGR [CASE @D12538, COUNT @D12537, 
            PER @D12536, PLU @D12535, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : BORE.

WORD bored : 
   [COORD @D12552, AGR [CASE @D12551, COUNT @D12550, PER @D12549, 
            PLU @D12548, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BORE, 
   [COORD @D12557, AGR [CASE @D12556, COUNT @D12555, PER @D12554, 
            PLU @D12553, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BORE, 
   [COORD @D12562, AGR [CASE @D12561, COUNT @D12560, PER @D12559, 
            PLU @D12558, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BORE, 
   [COORD @D12567, AGR [CASE @D12566, COUNT @D12565, PER @D12564, 
            PLU @D12563, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BORE, 
   [COORD @D12572, AGR [CASE @D12571, COUNT @D12570, PER @D12569, 
            PLU @D12568, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BORE, 
   [COORD @D12577, AGR [CASE @D12576, COUNT @D12575, PER @D12574, 
            PLU @D12573, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BORE, 
   [COORD @D12582, AGR [CASE @D12581, COUNT @D12580, PER @D12579, 
            PLU @D12578, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BORE, 
   [COORD @D12587, AGR [CASE @D12586, COUNT @D12585, PER @D12584, 
            PLU @D12583, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BORE, 
   [COORD @D12592, AGR [CASE @D12591, COUNT @D12590, PER @D12589, 
            PLU @D12588, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BORE, 
   [COORD @D12597, AGR [CASE @D12596, COUNT @D12595, PER @D12594, 
            PLU @D12593, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BORE, 
   [COORD @D12602, AGR [CASE @D12601, COUNT @D12600, PER @D12599, 
            PLU @D12598, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BORE, 
   [COORD @D12607, AGR [CASE @D12606, COUNT @D12605, PER @D12604, 
            PLU @D12603, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BORE.

WORD bores : 
   [COORD @D12616, AGR [COUNT @D12615, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BORE, 
   [COORD @D12618, 
      AGR [COUNT @D12617, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BORE, 
   [COORD @D12620, 
      AGR [COUNT @D12619, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BORE, 
   [COORD @D12622, 
      AGR [COUNT @D12621, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BORE, 
   [COORD @D12624, 
      AGR [COUNT @D12623, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BORE.

WORD boring : 
   [COORD @D12636, PRD @D12635, AGR [CASE @D12634, COUNT @D12633, 
            PER @D12632, PLU @D12631, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BORE, 
   [COORD @D12642, PRD @D12641, 
      AGR [CASE @D12640, COUNT @D12639, PER @D12638, PLU @D12637, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BORE, 
   [COORD @D12648, PRD @D12647, AGR [CASE @D12646, COUNT @D12645, 
            PER @D12644, PLU @D12643, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BORE, 
   [COORD @D12654, PRD @D12653, 
      AGR [CASE @D12652, COUNT @D12651, PER @D12650, PLU @D12649, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BORE, 
   [COORD @D12660, PRD @D12659, AGR [CASE @D12658, COUNT @D12657, 
            PER @D12656, PLU @D12655, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BORE.

WORD bought : 
   [COORD @D12677, PAST @D12676, AGR [CASE @D12675, COUNT @D12674, 
            PER @D12673, PLU @D12672, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : BUY, 
   [COORD @D12683, PAST @D12682, 
      AGR [CASE @D12681, COUNT @D12680, PER @D12679, PLU @D12678, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, FIN -, ARITY 3] : BUY, 
   [COORD @D12689, PAST @D12688, AGR [CASE @D12687, COUNT @D12686, 
            PER @D12685, PLU @D12684, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, LAT -, FIN -, ARITY 3] : BUY, 
   [COORD @D12695, PAST @D12694, 
      AGR [CASE @D12693, COUNT @D12692, PER @D12691, PLU @D12690, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, REG -, LAT -, FIN -, ARITY 3] : BUY, 
   [COORD @D12701, PAST @D12700, 
      AGR [CASE @D12699, COUNT @D12698, PER @D12697, PLU @D12696, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, FIN -, ARITY 3] : 
   BUY, 
   [COORD @D12707, PAST @D12706, AGR [CASE @D12705, COUNT @D12704, 
            PER @D12703, PLU @D12702, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, LAT -, FIN -, ARITY 3] : BUY, 
   [COORD @D12713, PAST @D12712, 
      AGR [CASE @D12711, COUNT @D12710, PER @D12709, PLU @D12708, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, LAT -, FIN -, 
      ARITY 3] : BUY, 
   [COORD @D12719, PAST @D12718, AGR [CASE @D12717, COUNT @D12716, 
            PER @D12715, PLU @D12714, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, LAT -, FIN -, ARITY 3] : BUY, 
   [COORD @D12725, PAST @D12724, 
      AGR [CASE @D12723, COUNT @D12722, PER @D12721, PLU @D12720, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FROM, LAT -, FIN -, 
      ARITY 3] : BUY, 
   [COORD @D12731, PAST @D12730, AGR [CASE @D12729, COUNT @D12728, 
            PER @D12727, PLU @D12726, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FROM, LAT -, FIN -, ARITY 3] : BUY, 
   [COORD @D12737, PAST @D12736, 
      AGR [CASE @D12735, COUNT @D12734, PER @D12733, PLU @D12732, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, LAT -, 
      FIN -, ARITY 3] : BUY, 
   [COORD @D12743, PAST @D12742, AGR [CASE @D12741, COUNT @D12740, 
            PER @D12739, PLU @D12738, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, LAT -, FIN -, ARITY 3] : BUY, 
   [COORD @D12747, AGR [COUNT @D12746, PER @D12745, PLU @D12744, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PFORM OF, PAST +, ARITY 3] : BUY, 
   [COORD @D12751, AGR [COUNT @D12750, PER @D12749, PLU @D12748, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, PAST +, 
      LAT -, ARITY 3] : BUY, 
   [COORD @D12755, AGR [COUNT @D12754, PER @D12753, PLU @D12752, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, PAST +, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D12759, AGR [COUNT @D12758, PER @D12757, PLU @D12756, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      PAST +, LAT -, ARITY 3] : BUY, 
   [COORD @D12763, AGR [COUNT @D12762, PER @D12761, PLU @D12760, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FROM, 
      PAST +, LAT -, ARITY 3] : BUY, 
   [COORD @D12767, AGR [COUNT @D12766, PER @D12765, PLU @D12764, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      PAST +, LAT -, ARITY 3] : BUY, 
   [COORD @D12773, PAST @D12772, AGR [CASE @D12771, COUNT @D12770, 
            PER @D12769, PLU @D12768, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : BUY, 
   [COORD @D12779, PAST @D12778, 
      AGR [CASE @D12777, COUNT @D12776, PER @D12775, PLU @D12774, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : BUY, 
   [COORD @D12785, PAST @D12784, AGR [CASE @D12783, COUNT @D12782, 
            PER @D12781, PLU @D12780, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : BUY, 
   [COORD @D12791, PAST @D12790, 
      AGR [CASE @D12789, COUNT @D12788, PER @D12787, PLU @D12786, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : BUY, 
   [COORD @D12797, PAST @D12796, AGR [CASE @D12795, COUNT @D12794, 
            PER @D12793, PLU @D12792, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : BUY, 
   [COORD @D12803, PAST @D12802, 
      AGR [CASE @D12801, COUNT @D12800, PER @D12799, PLU @D12798, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : BUY, 
   [COORD @D12809, PAST @D12808, AGR [CASE @D12807, COUNT @D12806, 
            PER @D12805, PLU @D12804, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : BUY, 
   [COORD @D12815, PAST @D12814, 
      AGR [CASE @D12813, COUNT @D12812, PER @D12811, PLU @D12810, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      FIN -, ARITY 2] : BUY, 
   [COORD @D12821, PAST @D12820, AGR [CASE @D12819, COUNT @D12818, 
            PER @D12817, PLU @D12816, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, 
      LAT -, FIN -, ARITY 2] : BUY, 
   [COORD @D12827, PAST @D12826, AGR [CASE @D12825, COUNT @D12824, 
            PER @D12823, PLU @D12822, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, 
      REG -, LAT -, FIN -, ARITY 2] : BUY, 
   [COORD @D12833, PAST @D12832, 
      AGR [CASE @D12831, COUNT @D12830, PER @D12829, PLU @D12828, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, LAT -, FIN -, ARITY 2] : 
   BUY, 
   [COORD @D12839, PAST @D12838, AGR [CASE @D12837, COUNT @D12836, 
            PER @D12835, PLU @D12834, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, LAT -, FIN -, ARITY 2] : BUY, 
   [COORD @D12843, AGR [COUNT @D12842, PER @D12841, PLU @D12840, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : BUY, 
   [COORD @D12847, AGR [COUNT @D12846, PER @D12845, PLU @D12844, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : BUY, 
   [COORD @D12851, AGR [COUNT @D12850, PER @D12849, PLU @D12848, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : BUY, 
   [COORD @D12855, AGR [COUNT @D12854, PER @D12853, PLU @D12852, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : BUY, 
   [COORD @D12859, AGR [COUNT @D12858, PER @D12857, PLU @D12856, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, PAST +, LAT -, 
      ARITY 2] : BUY, 
   [COORD @D12863, AGR [COUNT @D12862, PER @D12861, PLU @D12860, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, PAST +, 
      LAT -, ARITY 2] : BUY, 
   [COORD @D12867, AGR [COUNT @D12866, PER @D12865, PLU @D12864, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, PAST +, 
      LAT -, ARITY 2] : BUY, 
   [COORD @D12873, PAST @D12872, AGR [CASE @D12871, COUNT @D12870, 
            PER @D12869, PLU @D12868, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : BUY, 
   [COORD @D12879, PAST @D12878, 
      AGR [CASE @D12877, COUNT @D12876, PER @D12875, PLU @D12874, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : BUY, 
   [COORD @D12885, PAST @D12884, AGR [CASE @D12883, COUNT @D12882, 
            PER @D12881, PLU @D12880, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : BUY, 
   [COORD @D12891, PAST @D12890, 
      AGR [CASE @D12889, COUNT @D12888, PER @D12887, PLU @D12886, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, FIN -, 
      ARITY 1] : BUY, 
   [COORD @D12897, PAST @D12896, AGR [CASE @D12895, COUNT @D12894, 
            PER @D12893, PLU @D12892, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      REG -, LAT -, FIN -, ARITY 1] : BUY, 
   [COORD @D12901, AGR [COUNT @D12900, PER @D12899, PLU @D12898, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : BUY, 
   [COORD @D12905, AGR [COUNT @D12904, PER @D12903, PLU @D12902, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : BUY, 
   [COORD @D12909, AGR [COUNT @D12908, PER @D12907, PLU @D12906, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : BUY, 
   [COORD @D12913, AGR [COUNT @D12912, PER @D12911, PLU @D12910, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : BUY, 
   [COORD @D12917, AGR [COUNT @D12916, PER @D12915, PLU @D12914, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, PAST +, LAT -, 
      ARITY 1] : BUY.

WORD bound : 
   [COADV @D12948, COORD @D12947, DEF @D12946, PRD @D12945, AGR 
            [CASE @D12944, COUNT @D12943, PER @D12942, PLU @D12941, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : BOUND, 
   [COADV @D12956, COORD @D12955, DEF @D12954, PRD @D12953, 
      AGR [CASE @D12952, COUNT @D12951, PER @D12950, PLU @D12949, BAR 2, 
            V -, N +, NFORM NORM], N +, V +, SUBCAT SINF, SUBTYPE NONE, 
      FIX NOT, INFL +, BAR 0, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, 
      NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR PRD, 
      ARITY 2] : BOUND, 
   [COADV @D12964, COORD @D12963, DEF @D12962, PRD @D12961, 
      AGR [CASE @D12960, COUNT @D12959, PER @D12958, PLU @D12957, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT SC_INF, 
      DISTR PRD, ARITY 2] : BOUND, 
   [COADV @D12972, COORD @D12971, DEF @D12970, PRD @D12969, 
      AGR [CASE @D12968, COUNT @D12967, PER @D12966, PLU @D12965, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      DISTR PRD, ARITY 2] : BOUND, 
   [COADV @D12980, COORD @D12979, DEF @D12978, PRD @D12977, 
      AGR [CASE @D12976, COUNT @D12975, PER @D12974, PLU @D12973, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      DISTR PRD, ARITY 2] : BOUND, 
   [COORD @D12984, REFL @D12983, PRD @D12982, CASE @D12981, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BOUND, 
   [COORD @D12990, PAST @D12989, 
      AGR [CASE @D12988, COUNT @D12987, PER @D12986, PLU @D12985, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : BIND, 
   [COORD @D12996, PAST @D12995, AGR [CASE @D12994, COUNT @D12993, 
            PER @D12992, PLU @D12991, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : BIND, 
   [COORD @D13000, 
      AGR [COUNT @D12999, PER @D12998, PLU @D12997, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : BIND, 
   [COORD @D13003, AGR [COUNT @D13002, PER @D13001, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BOUND, 
   [COORD @D13005, AGR [COUNT @D13004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BOUND, 
   [COORD @D13007, AGR [COUNT @D13006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BOUND, 
   [COORD @D13011, AGR [COUNT @D13010, PER @D13009, PLU @D13008, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : BOUND, 
   [COORD @D13017, PAST @D13016, AGR [CASE @D13015, COUNT @D13014, 
            PER @D13013, PLU @D13012, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : BOUND, 
   [COORD @D13020, AGR [COUNT @D13019, PER @D13018, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : BOUND, 
   [COORD @D13022, AGR [COUNT @D13021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : BOUND, 
   [COORD @D13024, AGR [COUNT @D13023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : BOUND, 
   [COORD @D13028, AGR [COUNT @D13027, PER @D13026, PLU @D13025, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, ARITY 2] : BOUND, 
   [COORD @D13034, PAST @D13033, AGR [CASE @D13032, COUNT @D13031, 
            PER @D13030, PLU @D13029, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, ARITY 2] : BOUND, 
   [COORD @D13040, PAST @D13039, 
      AGR [CASE @D13038, COUNT @D13037, PER @D13036, PLU @D13035, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : BIND, 
   [COORD @D13046, PAST @D13045, AGR [CASE @D13044, COUNT @D13043, 
            PER @D13042, PLU @D13041, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : BIND, 
   [COORD @D13050, 
      AGR [COUNT @D13049, PER @D13048, PLU @D13047, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PAST +, ARITY 2] : BIND, 
   [COORD @D13056, PAST @D13055, AGR [CASE @D13054, COUNT @D13053, 
            PER @D13052, PLU @D13051, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, FIN -, ARITY 1] : BIND, 
   [COORD @D13060, 
      AGR [COUNT @D13059, PER @D13058, PLU @D13057, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : BIND.

WORD bounded : 
   [COORD @D13073, AGR [CASE @D13072, COUNT @D13071, PER @D13070, 
            PLU @D13069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BOUND, 
   [COORD @D13078, AGR [CASE @D13077, COUNT @D13076, PER @D13075, 
            PLU @D13074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BOUND, 
   [COORD @D13083, AGR [CASE @D13082, COUNT @D13081, PER @D13080, 
            PLU @D13079, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BOUND, 
   [COORD @D13088, AGR [CASE @D13087, COUNT @D13086, PER @D13085, 
            PLU @D13084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BOUND, 
   [COORD @D13093, AGR [CASE @D13092, COUNT @D13091, PER @D13090, 
            PLU @D13089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BOUND.

WORD bounding : 
   [COORD @D13113, PRD @D13112, AGR [CASE @D13111, COUNT @D13110, 
            PER @D13109, PLU @D13108, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BOUND, 
   [COORD @D13119, PRD @D13118, 
      AGR [CASE @D13117, COUNT @D13116, PER @D13115, PLU @D13114, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BOUND.

WORD bounds : 
   [COORD @D13131, REFL @D13130, PRD @D13129, CASE @D13128, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : BOUNDS, 
   [COORD @D13136, DEMON @D13135, REFL @D13134, PRD @D13133, 
      CASE @D13132, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BOUND, 
   [COORD @D13138, 
      AGR [COUNT @D13137, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BOUND, 
   [COORD @D13140, 
      AGR [COUNT @D13139, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BOUND.

WORD brain : 
   [COORD @D13165, REFL @D13164, COUNT @D13163, PRD @D13162, CASE 
         @D13161, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : BRAIN, 
   [COORD @D13168, 
      AGR [COUNT @D13167, PER @D13166, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   BRAIN, 
   [COORD @D13170, AGR [COUNT @D13169, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BRAIN, 
   [COORD @D13172, AGR [COUNT @D13171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : BRAIN, 
   [COORD @D13176, AGR [COUNT @D13175, PER @D13174, PLU @D13173, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : BRAIN, 
   [COORD @D13182, PAST @D13181, AGR [CASE @D13180, COUNT @D13179, 
            PER @D13178, PLU @D13177, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : BRAIN.

WORD brained : 
   [COORD @D13194, AGR [CASE @D13193, COUNT @D13192, PER @D13191, 
            PLU @D13190, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BRAIN, 
   [COORD @D13199, AGR [CASE @D13198, COUNT @D13197, PER @D13196, 
            PLU @D13195, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BRAIN, 
   [COORD @D13204, AGR [CASE @D13203, COUNT @D13202, PER @D13201, 
            PLU @D13200, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BRAIN.

WORD braining : 
   [COORD @D13221, PRD @D13220, AGR [CASE @D13219, COUNT @D13218, 
            PER @D13217, PLU @D13216, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BRAIN.

WORD brains : 
   [COORD @D13232, REFL @D13231, PRD @D13230, CASE @D13229, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : BRAINS, 
   [COORD @D13237, DEMON @D13236, REFL @D13235, PRD @D13234, 
      CASE @D13233, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BRAIN, 
   [COORD @D13239, 
      AGR [COUNT @D13238, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BRAIN.

WORD branch : 
   [COORD @D13260, REFL @D13259, PRD @D13258, CASE @D13257, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BRANCH.

WORD branches : 
   [COORD @D13277, DEMON @D13276, REFL @D13275, PRD @D13274, 
      CASE @D13273, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BRANCH.

WORD break : 
   [COORD @D13300, REFL @D13299, PRD @D13298, CASE @D13297, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BREAK, 
   [COORD @D13303, 
      AGR [COUNT @D13302, PER @D13301, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM OF, ARITY 3] : BREAK, 
   [COORD @D13305, AGR [COUNT @D13304, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : BREAK, 
   [COORD @D13307, AGR [COUNT @D13306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : BREAK, 
   [COORD @D13311, AGR [COUNT @D13310, PER @D13309, PLU @D13308, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : BREAK, 
   [COORD @D13317, PAST @D13316, 
      AGR [CASE @D13315, COUNT @D13314, PER @D13313, PLU @D13312, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM OF, 
      ARITY 3] : BREAK, 
   [COORD @D13320, AGR [COUNT @D13319, PER @D13318, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM WITH, ARITY 3] : BREAK, 
   [COORD @D13322, 
      AGR [COUNT @D13321, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM WITH, ARITY 3] : BREAK, 
   [COORD @D13324, AGR [COUNT @D13323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM WITH, ARITY 3] : BREAK, 
   [COORD @D13328, 
      AGR [COUNT @D13327, PER @D13326, PLU @D13325, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM WITH, ARITY 3] : BREAK, 
   [COORD @D13334, PAST @D13333, 
      AGR [CASE @D13332, COUNT @D13331, PER @D13330, PLU @D13329, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM WITH, ARITY 3] : BREAK, 
   [COORD @D13337, AGR [COUNT @D13336, PER @D13335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, PFORM INTO, ARITY 3] : BREAK, 
   [COORD @D13339, 
      AGR [COUNT @D13338, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT DOWN, 
      PFORM INTO, ARITY 3] : BREAK, 
   [COORD @D13341, AGR [COUNT @D13340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, PFORM INTO, ARITY 3] : BREAK, 
   [COORD @D13345, 
      AGR [COUNT @D13344, PER @D13343, PLU @D13342, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, PFORM INTO, ARITY 3] : BREAK, 
   [COORD @D13351, PAST @D13350, 
      AGR [CASE @D13349, COUNT @D13348, PER @D13347, PLU @D13346, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, PFORM INTO, ARITY 3] : BREAK, 
   [COORD @D13354, AGR [COUNT @D13353, PER @D13352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, LAT -, 
      ARITY 3] : BREAK, 
   [COORD @D13356, AGR [COUNT @D13355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, LAT -, 
      ARITY 3] : BREAK, 
   [COORD @D13358, AGR [COUNT @D13357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, LAT -, 
      ARITY 3] : BREAK, 
   [COORD @D13362, AGR [COUNT @D13361, PER @D13360, PLU @D13359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, 
      LAT -, ARITY 3] : BREAK, 
   [COORD @D13368, PAST @D13367, AGR [CASE @D13366, COUNT @D13365, 
            PER @D13364, PLU @D13363, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, LAT -, ARITY 3] : BREAK, 
   [COORD @D13371, AGR [COUNT @D13370, PER @D13369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OFF, 
      LAT -, ARITY 3] : BREAK, 
   [COORD @D13373, AGR [COUNT @D13372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OFF, 
      LAT -, ARITY 3] : BREAK, 
   [COORD @D13375, AGR [COUNT @D13374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OFF, 
      LAT -, ARITY 3] : BREAK, 
   [COORD @D13379, AGR [COUNT @D13378, PER @D13377, PLU @D13376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OFF, LAT -, ARITY 3] : BREAK, 
   [COORD @D13385, PAST @D13384, AGR 
         [CASE @D13383, COUNT @D13382, PER @D13381, PLU @D13380, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OFF, LAT -, 
      ARITY 3] : BREAK, 
   [COORD @D13388, AGR [COUNT @D13387, PER @D13386, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT OUT, ARITY 2] : BREAK, 
   [COORD @D13390, AGR [COUNT @D13389, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT OUT, ARITY 2] : BREAK, 
   [COORD @D13392, AGR [COUNT @D13391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT OUT, ARITY 2] : BREAK, 
   [COORD @D13396, AGR [COUNT @D13395, PER @D13394, PLU @D13393, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT OUT, ARITY 2] : BREAK, 
   [COORD @D13402, PAST @D13401, 
      AGR [CASE @D13400, COUNT @D13399, PER @D13398, PLU @D13397, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT OUT, 
      ARITY 2] : BREAK, 
   [COORD @D13405, AGR [COUNT @D13404, PER @D13403, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13407, AGR [COUNT @D13406, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13409, AGR [COUNT @D13408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13413, AGR [COUNT @D13412, PER @D13411, PLU @D13410, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13419, PAST @D13418, 
      AGR [CASE @D13417, COUNT @D13416, PER @D13415, PLU @D13414, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13422, AGR [COUNT @D13421, PER @D13420, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13424, AGR [COUNT @D13423, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13426, AGR [COUNT @D13425, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13430, AGR [COUNT @D13429, PER @D13428, PLU @D13427, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13436, PAST @D13435, 
      AGR [CASE @D13434, COUNT @D13433, PER @D13432, PLU @D13431, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      ARITY 2] : BREAK, 
   [COORD @D13439, AGR [COUNT @D13438, PER @D13437, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13441, AGR [COUNT @D13440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13443, AGR [COUNT @D13442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13447, AGR [COUNT @D13446, PER @D13445, PLU @D13444, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13453, PAST @D13452, 
      AGR [CASE @D13451, COUNT @D13450, PER @D13449, PLU @D13448, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13456, AGR [COUNT @D13455, PER @D13454, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13458, AGR [COUNT @D13457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13460, AGR [COUNT @D13459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13464, AGR [COUNT @D13463, PER @D13462, PLU @D13461, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OFF, PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13470, PAST @D13469, 
      AGR [CASE @D13468, COUNT @D13467, PER @D13466, PLU @D13465, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OFF, 
      PFORM WITH, ARITY 2] : BREAK, 
   [COORD @D13473, AGR [COUNT @D13472, PER @D13471, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : BREAK, 
   [COORD @D13475, AGR [COUNT @D13474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : BREAK, 
   [COORD @D13477, AGR [COUNT @D13476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : BREAK, 
   [COORD @D13481, AGR [COUNT @D13480, PER @D13479, PLU @D13478, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, ARITY 2] : BREAK, 
   [COORD @D13487, PAST @D13486, 
      AGR [CASE @D13485, COUNT @D13484, PER @D13483, PLU @D13482, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, 
      ARITY 2] : BREAK, 
   [COORD @D13490, AGR [COUNT @D13489, PER @D13488, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : BREAK, 
   [COORD @D13492, AGR [COUNT @D13491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : BREAK, 
   [COORD @D13494, AGR [COUNT @D13493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : BREAK, 
   [COORD @D13498, AGR [COUNT @D13497, PER @D13496, PLU @D13495, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT IN, PFORM ON, ARITY 2] : BREAK, 
   [COORD @D13504, PAST @D13503, 
      AGR [CASE @D13502, COUNT @D13501, PER @D13500, PLU @D13499, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, 
      ARITY 2] : BREAK, 
   [COORD @D13507, AGR [COUNT @D13506, PER @D13505, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : BREAK, 
   [COORD @D13509, AGR [COUNT @D13508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : BREAK, 
   [COORD @D13511, AGR [COUNT @D13510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : BREAK, 
   [COORD @D13515, AGR [COUNT @D13514, PER @D13513, PLU @D13512, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : BREAK, 
   [COORD @D13521, PAST @D13520, 
      AGR [CASE @D13519, COUNT @D13518, PER @D13517, PLU @D13516, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : BREAK, 
   [COORD @D13524, AGR [COUNT @D13523, PER @D13522, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13526, AGR [COUNT @D13525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13528, AGR [COUNT @D13527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13532, AGR [COUNT @D13531, PER @D13530, PLU @D13529, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13538, PAST @D13537, 
      AGR [CASE @D13536, COUNT @D13535, PER @D13534, PLU @D13533, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      ARITY 2] : BREAK, 
   [COORD @D13541, AGR [COUNT @D13540, PER @D13539, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13543, AGR [COUNT @D13542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13545, AGR [COUNT @D13544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13549, AGR [COUNT @D13548, PER @D13547, PLU @D13546, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT DOWN, PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13555, PAST @D13554, 
      AGR [CASE @D13553, COUNT @D13552, PER @D13551, PLU @D13550, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT DOWN, 
      PFORM INTO, ARITY 2] : BREAK, 
   [COORD @D13558, AGR [COUNT @D13557, PER @D13556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM IN, ARITY 2] : BREAK, 
   [COORD @D13560, AGR [COUNT @D13559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM IN, ARITY 2] : BREAK, 
   [COORD @D13562, AGR [COUNT @D13561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM IN, ARITY 2] : BREAK, 
   [COORD @D13566, AGR [COUNT @D13565, PER @D13564, PLU @D13563, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM IN, ARITY 2] : BREAK, 
   [COORD @D13572, PAST @D13571, 
      AGR [CASE @D13570, COUNT @D13569, PER @D13568, PLU @D13567, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM IN, ARITY 2] : BREAK, 
   [COORD @D13575, AGR [COUNT @D13574, PER @D13573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : BREAK, 
   [COORD @D13577, AGR [COUNT @D13576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : BREAK, 
   [COORD @D13579, AGR [COUNT @D13578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : BREAK, 
   [COORD @D13583, AGR [COUNT @D13582, PER @D13581, PLU @D13580, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT AWAY, PFORM FROM, ARITY 2] : BREAK, 
   [COORD @D13589, PAST @D13588, 
      AGR [CASE @D13587, COUNT @D13586, PER @D13585, PLU @D13584, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT AWAY, 
      PFORM FROM, ARITY 2] : BREAK, 
   [COORD @D13592, AGR [COUNT @D13591, PER @D13590, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BREAK, 
   [COORD @D13594, AGR [COUNT @D13593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BREAK, 
   [COORD @D13596, AGR [COUNT @D13595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : BREAK, 
   [COORD @D13600, AGR [COUNT @D13599, PER @D13598, PLU @D13597, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : BREAK, 
   [COORD @D13606, PAST @D13605, 
      AGR [CASE @D13604, COUNT @D13603, PER @D13602, PLU @D13601, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : BREAK, 
   [COORD @D13609, AGR [COUNT @D13608, PER @D13607, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13611, AGR [COUNT @D13610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13613, AGR [COUNT @D13612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13617, AGR [COUNT @D13616, PER @D13615, PLU @D13614, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : BREAK, 
   [COORD @D13623, PAST @D13622, 
      AGR [CASE @D13621, COUNT @D13620, PER @D13619, PLU @D13618, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : BREAK, 
   [COORD @D13626, AGR [COUNT @D13625, PER @D13624, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : BREAK, 
   [COORD @D13628, AGR [COUNT @D13627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : BREAK, 
   [COORD @D13630, AGR [COUNT @D13629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : BREAK, 
   [COORD @D13634, AGR [COUNT @D13633, PER @D13632, PLU @D13631, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : BREAK, 
   [COORD @D13640, PAST @D13639, 
      AGR [CASE @D13638, COUNT @D13637, PER @D13636, PLU @D13635, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : BREAK, 
   [COORD @D13643, AGR [COUNT @D13642, PER @D13641, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BREAK, 
   [COORD @D13645, AGR [COUNT @D13644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BREAK, 
   [COORD @D13647, AGR [COUNT @D13646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BREAK, 
   [COORD @D13651, AGR [COUNT @D13650, PER @D13649, PLU @D13648, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : BREAK, 
   [COORD @D13657, PAST @D13656, 
      AGR [CASE @D13655, COUNT @D13654, PER @D13653, PLU @D13652, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : BREAK, 
   [COORD @D13660, AGR [COUNT @D13659, PER @D13658, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, REG -, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13662, AGR [COUNT @D13661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, REG -, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13664, AGR [COUNT @D13663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, REG -, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13668, AGR [COUNT @D13667, PER @D13666, PLU @D13665, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, SUBCAT SC_AP, REG -, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13674, PAST @D13673, AGR [CASE @D13672, COUNT @D13671, 
            PER @D13670, PLU @D13669, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, LAT -, ARITY 2] : BREAK, 
   [COORD @D13677, AGR [COUNT @D13676, PER @D13675, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13679, AGR [COUNT @D13678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13681, AGR [COUNT @D13680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13685, AGR [COUNT @D13684, PER @D13683, PLU @D13682, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13691, PAST @D13690, AGR [CASE @D13689, COUNT @D13688, 
            PER @D13687, PLU @D13686, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, REG -, LAT -, ARITY 2] : BREAK, 
   [COORD @D13694, AGR [COUNT @D13693, PER @D13692, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM THROUGH, LAT -, ARITY 2] : BREAK, 
   [COORD @D13696, AGR [COUNT @D13695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM THROUGH, LAT -, ARITY 2] : BREAK, 
   [COORD @D13698, AGR [COUNT @D13697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM THROUGH, LAT -, ARITY 2] : BREAK, 
   [COORD @D13702, AGR [COUNT @D13701, PER @D13700, PLU @D13699, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM THROUGH, LAT -, ARITY 2] : BREAK, 
   [COORD @D13708, PAST @D13707, 
      AGR [CASE @D13706, COUNT @D13705, PER @D13704, PLU @D13703, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM THROUGH, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13711, AGR [COUNT @D13710, PER @D13709, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OUT_OF, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13713, AGR [COUNT @D13712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OUT_OF, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13715, AGR [COUNT @D13714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OUT_OF, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13719, AGR [COUNT @D13718, PER @D13717, PLU @D13716, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OUT_OF, LAT -, ARITY 2] : BREAK, 
   [COORD @D13725, PAST @D13724, 
      AGR [CASE @D13723, COUNT @D13722, PER @D13721, PLU @D13720, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OUT_OF, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13728, AGR [COUNT @D13727, PER @D13726, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OFF, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13730, AGR [COUNT @D13729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OFF, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13732, AGR [COUNT @D13731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OFF, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13736, AGR [COUNT @D13735, PER @D13734, PLU @D13733, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OFF, LAT -, ARITY 2] : BREAK, 
   [COORD @D13742, PAST @D13741, AGR 
         [CASE @D13740, COUNT @D13739, PER @D13738, PLU @D13737, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM OFF, LAT -, ARITY 2] : 
   BREAK, 
   [COORD @D13745, AGR [COUNT @D13744, PER @D13743, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM INTO, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13747, AGR [COUNT @D13746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM INTO, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13749, AGR [COUNT @D13748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM INTO, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13753, AGR [COUNT @D13752, PER @D13751, PLU @D13750, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM INTO, LAT -, ARITY 2] : BREAK, 
   [COORD @D13759, PAST @D13758, 
      AGR [CASE @D13757, COUNT @D13756, PER @D13755, PLU @D13754, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM INTO, LAT -, 
      ARITY 2] : BREAK, 
   [COORD @D13762, AGR [COUNT @D13761, PER @D13760, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13764, AGR [COUNT @D13763, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13766, AGR [COUNT @D13765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      LAT -, ARITY 2] : BREAK, 
   [COORD @D13770, AGR [COUNT @D13769, PER @D13768, PLU @D13767, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, LAT -, ARITY 2] : BREAK, 
   [COORD @D13776, PAST @D13775, AGR 
         [CASE @D13774, COUNT @D13773, PER @D13772, PLU @D13771, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, LAT -, ARITY 2] : 
   BREAK, 
   [COORD @D13779, AGR [COUNT @D13778, PER @D13777, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BREAK, 
   [COORD @D13781, AGR [COUNT @D13780, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BREAK, 
   [COORD @D13783, AGR [COUNT @D13782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BREAK, 
   [COORD @D13787, AGR [COUNT @D13786, PER @D13785, PLU @D13784, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : BREAK, 
   [COORD @D13793, PAST @D13792, 
      AGR [CASE @D13791, COUNT @D13790, PER @D13789, PLU @D13788, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : BREAK, 
   [COORD @D13796, AGR [COUNT @D13795, PER @D13794, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : BREAK, 
   [COORD @D13798, AGR [COUNT @D13797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : BREAK, 
   [COORD @D13800, AGR [COUNT @D13799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : BREAK, 
   [COORD @D13804, AGR [COUNT @D13803, PER @D13802, PLU @D13801, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : BREAK, 
   [COORD @D13810, PAST @D13809, 
      AGR [CASE @D13808, COUNT @D13807, PER @D13806, PLU @D13805, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT THROUGH, 
      ARITY 1] : BREAK, 
   [COORD @D13813, AGR [COUNT @D13812, PER @D13811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BREAK, 
   [COORD @D13815, AGR [COUNT @D13814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BREAK, 
   [COORD @D13817, AGR [COUNT @D13816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BREAK, 
   [COORD @D13821, AGR [COUNT @D13820, PER @D13819, PLU @D13818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : BREAK, 
   [COORD @D13827, PAST @D13826, 
      AGR [CASE @D13825, COUNT @D13824, PER @D13823, PLU @D13822, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : BREAK, 
   [COORD @D13830, AGR [COUNT @D13829, PER @D13828, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BREAK, 
   [COORD @D13832, AGR [COUNT @D13831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BREAK, 
   [COORD @D13834, AGR [COUNT @D13833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BREAK, 
   [COORD @D13838, AGR [COUNT @D13837, PER @D13836, PLU @D13835, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : BREAK, 
   [COORD @D13844, PAST @D13843, 
      AGR [CASE @D13842, COUNT @D13841, PER @D13840, PLU @D13839, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : BREAK, 
   [COORD @D13847, AGR [COUNT @D13846, PER @D13845, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : BREAK, 
   [COORD @D13849, AGR [COUNT @D13848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : BREAK, 
   [COORD @D13851, AGR [COUNT @D13850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : BREAK, 
   [COORD @D13855, AGR [COUNT @D13854, PER @D13853, PLU @D13852, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : BREAK, 
   [COORD @D13861, PAST @D13860, 
      AGR [CASE @D13859, COUNT @D13858, PER @D13857, PLU @D13856, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : BREAK, 
   [COORD @D13864, AGR [COUNT @D13863, PER @D13862, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BREAK, 
   [COORD @D13866, AGR [COUNT @D13865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BREAK, 
   [COORD @D13868, AGR [COUNT @D13867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BREAK, 
   [COORD @D13872, AGR [COUNT @D13871, PER @D13870, PLU @D13869, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : BREAK, 
   [COORD @D13878, PAST @D13877, 
      AGR [CASE @D13876, COUNT @D13875, PER @D13874, PLU @D13873, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : BREAK, 
   [COORD @D13881, AGR [COUNT @D13880, PER @D13879, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BREAK, 
   [COORD @D13883, AGR [COUNT @D13882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BREAK, 
   [COORD @D13885, AGR [COUNT @D13884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BREAK, 
   [COORD @D13889, AGR [COUNT @D13888, PER @D13887, PLU @D13886, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : BREAK, 
   [COORD @D13895, PAST @D13894, 
      AGR [CASE @D13893, COUNT @D13892, PER @D13891, PLU @D13890, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : BREAK, 
   [COORD @D13898, AGR [COUNT @D13897, PER @D13896, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BREAK, 
   [COORD @D13900, AGR [COUNT @D13899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BREAK, 
   [COORD @D13902, AGR [COUNT @D13901, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BREAK, 
   [COORD @D13906, AGR [COUNT @D13905, PER @D13904, PLU @D13903, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, 
      LAT -, ARITY 1] : BREAK, 
   [COORD @D13912, PAST @D13911, AGR [CASE @D13910, COUNT @D13909, 
            PER @D13908, PLU @D13907, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, REG -, LAT -, ARITY 1] : BREAK.

WORD breaked : 
   [COORD @D13924, AGR [CASE @D13923, COUNT @D13922, PER @D13921, 
            PLU @D13920, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM OF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13929, AGR [CASE @D13928, COUNT @D13927, PER @D13926, 
            PLU @D13925, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13934, AGR [CASE @D13933, COUNT @D13932, PER @D13931, 
            PLU @D13930, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13939, AGR [CASE @D13938, COUNT @D13937, PER @D13936, 
            PLU @D13935, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13944, AGR [CASE @D13943, COUNT @D13942, PER @D13941, 
            PLU @D13940, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13949, 
      AGR [CASE @D13948, COUNT @D13947, PER @D13946, PLU @D13945, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13954, AGR [CASE @D13953, COUNT @D13952, PER @D13951, 
            PLU @D13950, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT DOWN, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13959, AGR [CASE @D13958, COUNT @D13957, PER @D13956, 
            PLU @D13955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT DOWN, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13964, 
      AGR [CASE @D13963, COUNT @D13962, PER @D13961, PLU @D13960, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13969, AGR [CASE @D13968, COUNT @D13967, PER @D13966, 
            PLU @D13965, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13974, AGR [CASE @D13973, COUNT @D13972, PER @D13971, 
            PLU @D13970, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13979, AGR [CASE @D13978, COUNT @D13977, PER @D13976, 
            PLU @D13975, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13984, AGR [CASE @D13983, COUNT @D13982, PER @D13981, 
            PLU @D13980, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13989, AGR [CASE @D13988, COUNT @D13987, PER @D13986, 
            PLU @D13985, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13994, AGR [CASE @D13993, COUNT @D13992, PER @D13991, 
            PLU @D13990, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D13999, AGR [CASE @D13998, COUNT @D13997, PER @D13996, 
            PLU @D13995, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14004, AGR [CASE @D14003, COUNT @D14002, PER @D14001, 
            PLU @D14000, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14009, AGR [CASE @D14008, COUNT @D14007, PER @D14006, 
            PLU @D14005, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14014, AGR [CASE @D14013, COUNT @D14012, PER @D14011, 
            PLU @D14010, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14019, AGR [CASE @D14018, COUNT @D14017, PER @D14016, 
            PLU @D14015, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14024, 
      AGR [CASE @D14023, COUNT @D14022, PER @D14021, PLU @D14020, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : BREAK, 
   [COORD @D14029, AGR [CASE @D14028, COUNT @D14027, PER @D14026, 
            PLU @D14025, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14034, AGR [CASE @D14033, COUNT @D14032, PER @D14031, 
            PLU @D14030, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14039, AGR [CASE @D14038, COUNT @D14037, PER @D14036, 
            PLU @D14035, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14044, AGR [CASE @D14043, COUNT @D14042, PER @D14041, 
            PLU @D14040, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14049, AGR [CASE @D14048, COUNT @D14047, PER @D14046, 
            PLU @D14045, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14054, AGR [CASE @D14053, COUNT @D14052, PER @D14051, 
            PLU @D14050, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14059, AGR [CASE @D14058, COUNT @D14057, PER @D14056, 
            PLU @D14055, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14064, AGR [CASE @D14063, COUNT @D14062, PER @D14061, 
            PLU @D14060, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14069, AGR [CASE @D14068, COUNT @D14067, PER @D14066, 
            PLU @D14065, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14074, AGR [CASE @D14073, COUNT @D14072, PER @D14071, 
            PLU @D14070, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14079, AGR [CASE @D14078, COUNT @D14077, PER @D14076, 
            PLU @D14075, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14084, AGR [CASE @D14083, COUNT @D14082, PER @D14081, 
            PLU @D14080, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14089, 
      AGR [CASE @D14088, COUNT @D14087, PER @D14086, PLU @D14085, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14094, AGR [CASE @D14093, COUNT @D14092, PER @D14091, 
            PLU @D14090, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM IN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14099, AGR [CASE @D14098, COUNT @D14097, PER @D14096, 
            PLU @D14095, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM IN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14104, AGR [CASE @D14103, COUNT @D14102, PER @D14101, 
            PLU @D14100, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14109, 
      AGR [CASE @D14108, COUNT @D14107, PER @D14106, PLU @D14105, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14114, AGR [CASE @D14113, COUNT @D14112, PER @D14111, 
            PLU @D14110, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14119, AGR [CASE @D14118, COUNT @D14117, PER @D14116, 
            PLU @D14115, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14124, AGR [CASE @D14123, COUNT @D14122, PER @D14121, 
            PLU @D14120, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14129, AGR [CASE @D14128, COUNT @D14127, PER @D14126, 
            PLU @D14125, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14134, AGR [CASE @D14133, COUNT @D14132, PER @D14131, 
            PLU @D14130, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14139, AGR [CASE @D14138, COUNT @D14137, PER @D14136, 
            PLU @D14135, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14144, AGR [CASE @D14143, COUNT @D14142, PER @D14141, 
            PLU @D14140, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14149, AGR [CASE @D14148, COUNT @D14147, PER @D14146, 
            PLU @D14145, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14154, AGR [CASE @D14153, COUNT @D14152, PER @D14151, 
            PLU @D14150, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14159, AGR [CASE @D14158, COUNT @D14157, PER @D14156, 
            PLU @D14155, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14164, AGR [CASE @D14163, COUNT @D14162, PER @D14161, 
            PLU @D14160, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14169, AGR [CASE @D14168, COUNT @D14167, PER @D14166, 
            PLU @D14165, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14174, AGR [CASE @D14173, COUNT @D14172, PER @D14171, 
            PLU @D14170, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14179, AGR [CASE @D14178, COUNT @D14177, PER @D14176, 
            PLU @D14175, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14184, AGR [CASE @D14183, COUNT @D14182, PER @D14181, 
            PLU @D14180, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14189, AGR [CASE @D14188, COUNT @D14187, PER @D14186, 
            PLU @D14185, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14194, AGR [CASE @D14193, COUNT @D14192, PER @D14191, 
            PLU @D14190, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14199, AGR [CASE @D14198, COUNT @D14197, PER @D14196, 
            PLU @D14195, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14204, AGR [CASE @D14203, COUNT @D14202, PER @D14201, 
            PLU @D14200, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14209, AGR [CASE @D14208, COUNT @D14207, PER @D14206, 
            PLU @D14205, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14214, AGR [CASE @D14213, COUNT @D14212, PER @D14211, 
            PLU @D14210, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14219, AGR [CASE @D14218, COUNT @D14217, PER @D14216, 
            PLU @D14215, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14224, AGR [CASE @D14223, COUNT @D14222, PER @D14221, 
            PLU @D14220, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14229, AGR [CASE @D14228, COUNT @D14227, PER @D14226, 
            PLU @D14225, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14234, AGR [CASE @D14233, COUNT @D14232, PER @D14231, 
            PLU @D14230, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14239, AGR [CASE @D14238, COUNT @D14237, PER @D14236, 
            PLU @D14235, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREAK.

WORD breaking : 
   [COORD @D14256, PRD @D14255, AGR [CASE @D14254, COUNT @D14253, 
            PER @D14252, PLU @D14251, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14262, PRD @D14261, 
      AGR [CASE @D14260, COUNT @D14259, PER @D14258, PLU @D14257, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BREAK, 
   [COORD @D14268, PRD @D14267, AGR [CASE @D14266, COUNT @D14265, 
            PER @D14264, PLU @D14263, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14274, PRD @D14273, 
      AGR [CASE @D14272, COUNT @D14271, PER @D14270, PLU @D14269, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14280, PRD @D14279, AGR [CASE @D14278, COUNT @D14277, 
            PER @D14276, PLU @D14275, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM OFF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14286, PRD @D14285, 
      AGR [CASE @D14284, COUNT @D14283, PER @D14282, PLU @D14281, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREAK, 
   [COORD @D14292, PRD @D14291, AGR [CASE @D14290, COUNT @D14289, 
            PER @D14288, PLU @D14287, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14298, PRD @D14297, 
      AGR [CASE @D14296, COUNT @D14295, PER @D14294, PLU @D14293, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14304, PRD @D14303, AGR [CASE @D14302, COUNT @D14301, 
            PER @D14300, PLU @D14299, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14310, PRD @D14309, 
      AGR [CASE @D14308, COUNT @D14307, PER @D14306, PLU @D14305, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14316, PRD @D14315, AGR [CASE @D14314, COUNT @D14313, 
            PER @D14312, PLU @D14311, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14322, PRD @D14321, 
      AGR [CASE @D14320, COUNT @D14319, PER @D14318, PLU @D14317, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BREAK, 
   [COORD @D14328, PRD @D14327, AGR [CASE @D14326, COUNT @D14325, 
            PER @D14324, PLU @D14323, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14334, PRD @D14333, 
      AGR [CASE @D14332, COUNT @D14331, PER @D14330, PLU @D14329, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14340, PRD @D14339, AGR [CASE @D14338, COUNT @D14337, 
            PER @D14336, PLU @D14335, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14346, PRD @D14345, 
      AGR [CASE @D14344, COUNT @D14343, PER @D14342, PLU @D14341, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14352, PRD @D14351, AGR [CASE @D14350, COUNT @D14349, 
            PER @D14348, PLU @D14347, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14358, PRD @D14357, 
      AGR [CASE @D14356, COUNT @D14355, PER @D14354, PLU @D14353, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREAK, 
   [COORD @D14364, PRD @D14363, AGR [CASE @D14362, COUNT @D14361, 
            PER @D14360, PLU @D14359, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14370, PRD @D14369, 
      AGR [CASE @D14368, COUNT @D14367, PER @D14366, PLU @D14365, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREAK, 
   [COORD @D14376, PRD @D14375, AGR [CASE @D14374, COUNT @D14373, 
            PER @D14372, PLU @D14371, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14382, PRD @D14381, 
      AGR [CASE @D14380, COUNT @D14379, PER @D14378, PLU @D14377, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14388, PRD @D14387, AGR [CASE @D14386, COUNT @D14385, 
            PER @D14384, PLU @D14383, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14394, PRD @D14393, 
      AGR [CASE @D14392, COUNT @D14391, PER @D14390, PLU @D14389, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14400, PRD @D14399, AGR [CASE @D14398, COUNT @D14397, 
            PER @D14396, PLU @D14395, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14406, PRD @D14405, 
      AGR [CASE @D14404, COUNT @D14403, PER @D14402, PLU @D14401, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREAK, 
   [COORD @D14412, PRD @D14411, AGR [CASE @D14410, COUNT @D14409, 
            PER @D14408, PLU @D14407, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14418, PRD @D14417, 
      AGR [CASE @D14416, COUNT @D14415, PER @D14414, PLU @D14413, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREAK, 
   [COORD @D14424, PRD @D14423, AGR [CASE @D14422, COUNT @D14421, 
            PER @D14420, PLU @D14419, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14430, PRD @D14429, 
      AGR [CASE @D14428, COUNT @D14427, PER @D14426, PLU @D14425, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14436, PRD @D14435, AGR [CASE @D14434, COUNT @D14433, 
            PER @D14432, PLU @D14431, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14442, PRD @D14441, 
      AGR [CASE @D14440, COUNT @D14439, PER @D14438, PLU @D14437, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREAK, 
   [COORD @D14448, PRD @D14447, AGR [CASE @D14446, COUNT @D14445, 
            PER @D14444, PLU @D14443, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14454, PRD @D14453, 
      AGR [CASE @D14452, COUNT @D14451, PER @D14450, PLU @D14449, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREAK, 
   [COORD @D14460, PRD @D14459, AGR [CASE @D14458, COUNT @D14457, 
            PER @D14456, PLU @D14455, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BREAK, 
   [COORD @D14466, PRD @D14465, 
      AGR [CASE @D14464, COUNT @D14463, PER @D14462, PLU @D14461, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BREAK.

WORD breaks : 
   [COORD @D14478, DEMON @D14477, REFL @D14476, PRD @D14475, CASE 
         @D14474, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BREAK, 
   [COORD @D14480, 
      AGR [COUNT @D14479, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14482, 
      AGR [COUNT @D14481, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14484, AGR [COUNT @D14483, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : BREAK, 
   [COORD @D14486, AGR [COUNT @D14485, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14488, 
      AGR [COUNT @D14487, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14490, 
      AGR [COUNT @D14489, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14492, 
      AGR [COUNT @D14491, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14494, 
      AGR [COUNT @D14493, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14496, 
      AGR [COUNT @D14495, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14498, AGR [COUNT @D14497, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14500, AGR [COUNT @D14499, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14502, AGR [COUNT @D14501, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : BREAK, 
   [COORD @D14504, AGR [COUNT @D14503, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14506, AGR [COUNT @D14505, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14508, AGR [COUNT @D14507, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14510, AGR [COUNT @D14509, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14512, AGR [COUNT @D14511, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BREAK, 
   [COORD @D14514, AGR [COUNT @D14513, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14516, 
      AGR [COUNT @D14515, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14518, 
      AGR [COUNT @D14517, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14520, 
      AGR [COUNT @D14519, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14522, 
      AGR [COUNT @D14521, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14524, 
      AGR [COUNT @D14523, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14526, 
      AGR [COUNT @D14525, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14528, AGR [COUNT @D14527, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14530, 
      AGR [COUNT @D14529, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14532, 
      AGR [COUNT @D14531, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14534, 
      AGR [COUNT @D14533, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14536, 
      AGR [COUNT @D14535, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14538, 
      AGR [COUNT @D14537, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BREAK, 
   [COORD @D14540, AGR [COUNT @D14539, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14542, 
      AGR [COUNT @D14541, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14544, 
      AGR [COUNT @D14543, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14546, 
      AGR [COUNT @D14545, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14548, 
      AGR [COUNT @D14547, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK, 
   [COORD @D14550, 
      AGR [COUNT @D14549, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREAK.

WORD brew : 
   [COORD @D14558, AGR [COUNT @D14557, PER @D14556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BREW, 
   [COORD @D14560, AGR [COUNT @D14559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BREW, 
   [COORD @D14562, AGR [COUNT @D14561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BREW, 
   [COORD @D14566, AGR [COUNT @D14565, PER @D14564, PLU @D14563, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BREW, 
   [COORD @D14572, PAST @D14571, AGR [CASE @D14570, COUNT @D14569, 
            PER @D14568, PLU @D14567, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : BREW, 
   [COORD @D14575, AGR [COUNT @D14574, PER @D14573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT UP, LAT -, 
      ARITY 2] : BREW, 
   [COORD @D14577, AGR [COUNT @D14576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT UP, LAT -, 
      ARITY 2] : BREW, 
   [COORD @D14579, AGR [COUNT @D14578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT UP, LAT -, 
      ARITY 2] : BREW, 
   [COORD @D14583, AGR [COUNT @D14582, PER @D14581, PLU @D14580, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, 
      PRT UP, LAT -, ARITY 2] : BREW, 
   [COORD @D14589, PAST @D14588, AGR [CASE @D14587, COUNT @D14586, 
            PER @D14585, PLU @D14584, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      COMPOUND NOT, PRT UP, LAT -, ARITY 2] : BREW, 
   [COORD @D14592, AGR [COUNT @D14591, PER @D14590, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BREW, 
   [COORD @D14594, AGR [COUNT @D14593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BREW, 
   [COORD @D14596, AGR [COUNT @D14595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : BREW, 
   [COORD @D14600, AGR [COUNT @D14599, PER @D14598, PLU @D14597, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      LAT -, ARITY 1] : BREW, 
   [COORD @D14606, PAST @D14605, AGR [CASE @D14604, COUNT @D14603, 
            PER @D14602, PLU @D14601, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : BREW, 
   [COORD @D14609, AGR [COUNT @D14608, PER @D14607, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      LAT -, ARITY 1] : BREW, 
   [COORD @D14611, AGR [COUNT @D14610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      LAT -, ARITY 1] : BREW, 
   [COORD @D14613, AGR [COUNT @D14612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      LAT -, ARITY 1] : BREW, 
   [COORD @D14617, AGR [COUNT @D14616, PER @D14615, PLU @D14614, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, LAT -, ARITY 1] : BREW, 
   [COORD @D14623, PAST @D14622, AGR [CASE @D14621, COUNT @D14620, 
            PER @D14619, PLU @D14618, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, LAT -, ARITY 1] : BREW.

WORD brewed : 
   [COORD @D14634, AGR [CASE @D14633, COUNT @D14632, PER @D14631, 
            PLU @D14630, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BREW, 
   [COORD @D14639, AGR [CASE @D14638, COUNT @D14637, PER @D14636, 
            PLU @D14635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREW, 
   [COORD @D14644, AGR [CASE @D14643, COUNT @D14642, PER @D14641, 
            PLU @D14640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BREW, 
   [COORD @D14649, AGR [CASE @D14648, COUNT @D14647, PER @D14646, 
            PLU @D14645, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREW, 
   [COORD @D14654, AGR [CASE @D14653, COUNT @D14652, PER @D14651, 
            PLU @D14650, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREW, 
   [COORD @D14659, AGR [CASE @D14658, COUNT @D14657, PER @D14656, 
            PLU @D14655, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREW, 
   [COORD @D14664, AGR [CASE @D14663, COUNT @D14662, PER @D14661, 
            PLU @D14660, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BREW, 
   [COORD @D14669, AGR [CASE @D14668, COUNT @D14667, PER @D14666, 
            PLU @D14665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BREW, 
   [COORD @D14674, AGR [CASE @D14673, COUNT @D14672, PER @D14671, 
            PLU @D14670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREW, 
   [COORD @D14679, AGR [CASE @D14678, COUNT @D14677, PER @D14676, 
            PLU @D14675, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BREW.

WORD brewer : 
   [COORD @D14689, REFL @D14688, PRD @D14687, CASE @D14686, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BREWER.

WORD brewers : 
   [COORD @D14702, DEMON @D14701, REFL @D14700, PRD @D14699, 
      CASE @D14698, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BREWER.

WORD brewing : 
   [COORD @D14716, PRD @D14715, AGR [CASE @D14714, COUNT @D14713, 
            PER @D14712, PLU @D14711, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREW, 
   [COORD @D14722, PRD @D14721, 
      AGR [CASE @D14720, COUNT @D14719, PER @D14718, PLU @D14717, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREW, 
   [COORD @D14728, PRD @D14727, AGR [CASE @D14726, COUNT @D14725, 
            PER @D14724, PLU @D14723, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BREW, 
   [COORD @D14734, PRD @D14733, 
      AGR [CASE @D14732, COUNT @D14731, PER @D14730, PLU @D14729, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BREW.

WORD brews : 
   [COORD @D14742, AGR [COUNT @D14741, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREW, 
   [COORD @D14744, 
      AGR [COUNT @D14743, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREW, 
   [COORD @D14746, 
      AGR [COUNT @D14745, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREW, 
   [COORD @D14748, 
      AGR [COUNT @D14747, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BREW.

WORD brought : 
   [COORD @D14759, PAST @D14758, AGR [CASE @D14757, COUNT @D14756, 
            PER @D14755, PLU @D14754, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT OUT, FIN -, ARITY 3] : BRING, 
   [COORD @D14765, PAST @D14764, 
      AGR [CASE @D14763, COUNT @D14762, PER @D14761, PLU @D14760, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT OUT, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14771, PAST @D14770, AGR [CASE @D14769, COUNT @D14768, 
            PER @D14767, PLU @D14766, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PRT IN, FIN -, ARITY 3] : BRING, 
   [COORD @D14777, PAST @D14776, 
      AGR [CASE @D14775, COUNT @D14774, PER @D14773, PLU @D14772, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PRT IN, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14783, PAST @D14782, AGR [CASE @D14781, COUNT @D14780, 
            PER @D14779, PLU @D14778, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT IN, FIN -, ARITY 3] : BRING, 
   [COORD @D14789, PAST @D14788, 
      AGR [CASE @D14787, COUNT @D14786, PER @D14785, PLU @D14784, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT IN, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14795, PAST @D14794, AGR [CASE @D14793, COUNT @D14792, 
            PER @D14791, PLU @D14790, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT BACK, FIN -, ARITY 3] : BRING, 
   [COORD @D14801, PAST @D14800, 
      AGR [CASE @D14799, COUNT @D14798, PER @D14797, PLU @D14796, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT BACK, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14807, PAST @D14806, AGR [CASE @D14805, COUNT @D14804, 
            PER @D14803, PLU @D14802, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM UNDER, FIN -, ARITY 3] : BRING, 
   [COORD @D14813, PAST @D14812, 
      AGR [CASE @D14811, COUNT @D14810, PER @D14809, PLU @D14808, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM UNDER, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14819, PAST @D14818, AGR [CASE @D14817, COUNT @D14816, 
            PER @D14815, PLU @D14814, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, FIN -, ARITY 3] : BRING, 
   [COORD @D14825, PAST @D14824, 
      AGR [CASE @D14823, COUNT @D14822, PER @D14821, PLU @D14820, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM THROUGH, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14831, PAST @D14830, AGR [CASE @D14829, COUNT @D14828, 
            PER @D14827, PLU @D14826, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : BRING, 
   [COORD @D14837, PAST @D14836, 
      AGR [CASE @D14835, COUNT @D14834, PER @D14833, PLU @D14832, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14843, PAST @D14842, AGR [CASE @D14841, COUNT @D14840, 
            PER @D14839, PLU @D14838, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM ON, FIN -, ARITY 3] : BRING, 
   [COORD @D14849, PAST @D14848, 
      AGR [CASE @D14847, COUNT @D14846, PER @D14845, PLU @D14844, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT DOWN, PFORM ON, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D14855, PAST @D14854, AGR [CASE @D14853, COUNT @D14852, 
            PER @D14851, PLU @D14850, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : BRING, 
   [COORD @D14861, PAST @D14860, 
      AGR [CASE @D14859, COUNT @D14858, PER @D14857, PLU @D14856, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14867, PAST @D14866, AGR [CASE @D14865, COUNT @D14864, 
            PER @D14863, PLU @D14862, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PRT BACK, PFORM FOR, FIN -, ARITY 3] : BRING, 
   [COORD @D14873, PAST @D14872, 
      AGR [CASE @D14871, COUNT @D14870, PER @D14869, PLU @D14868, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PRT BACK, PFORM FOR, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D14879, PAST @D14878, AGR [CASE @D14877, COUNT @D14876, 
            PER @D14875, PLU @D14874, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT UP, PFORM AGAINST, FIN -, ARITY 3] : BRING, 
   [COORD @D14885, PAST @D14884, 
      AGR [CASE @D14883, COUNT @D14882, PER @D14881, PLU @D14880, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT UP, 
      PFORM AGAINST, FIN -, ARITY 3] : BRING, 
   [COORD @D14891, PAST @D14890, 
      AGR [CASE @D14889, COUNT @D14888, PER @D14887, PLU @D14886, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM TO, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D14897, PAST @D14896, AGR [CASE @D14895, COUNT @D14894, 
            PER @D14893, PLU @D14892, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14903, PAST @D14902, 
      AGR [CASE @D14901, COUNT @D14900, PER @D14899, PLU @D14898, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ROUND, 
      PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14909, PAST @D14908, AGR [CASE @D14907, COUNT @D14906, 
            PER @D14905, PLU @D14904, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ROUND, PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14915, PAST @D14914, 
      AGR [CASE @D14913, COUNT @D14912, PER @D14911, PLU @D14910, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, PFORM TO, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D14921, PAST @D14920, AGR [CASE @D14919, COUNT @D14918, 
            PER @D14917, PLU @D14916, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14927, PAST @D14926, 
      AGR [CASE @D14925, COUNT @D14924, PER @D14923, PLU @D14922, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, REG -, PRT BACK, 
      PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14933, PAST @D14932, AGR [CASE @D14931, COUNT @D14930, 
            PER @D14929, PLU @D14928, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE DMOVT, REG -, PRT BACK, PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14939, PAST @D14938, 
      AGR [CASE @D14937, COUNT @D14936, PER @D14935, PLU @D14934, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AROUND, 
      PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14945, PAST @D14944, AGR [CASE @D14943, COUNT @D14942, 
            PER @D14941, PLU @D14940, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AROUND, PFORM TO, FIN -, ARITY 3] : BRING, 
   [COORD @D14951, PAST @D14950, 
      AGR [CASE @D14949, COUNT @D14948, PER @D14947, PLU @D14946, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, PFORM IN, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D14957, PAST @D14956, AGR [CASE @D14955, COUNT @D14954, 
            PER @D14953, PLU @D14952, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, PFORM IN, FIN -, ARITY 3] : BRING, 
   [COORD @D14963, PAST @D14962, 
      AGR [CASE @D14961, COUNT @D14960, PER @D14959, PLU @D14958, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM FOR, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D14969, PAST @D14968, AGR [CASE @D14967, COUNT @D14966, 
            PER @D14965, PLU @D14964, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM FOR, FIN -, ARITY 3] : BRING, 
   [COORD @D14975, PAST @D14974, 
      AGR [CASE @D14973, COUNT @D14972, PER @D14971, PLU @D14970, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, LAT -, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14981, PAST @D14980, AGR [CASE @D14979, COUNT @D14978, 
            PER @D14977, PLU @D14976, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, LAT -, FIN -, ARITY 3] : BRING, 
   [COORD @D14987, PAST @D14986, 
      AGR [CASE @D14985, COUNT @D14984, PER @D14983, PLU @D14982, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, LAT -, FIN -, 
      ARITY 3] : BRING, 
   [COORD @D14993, PAST @D14992, AGR [CASE @D14991, COUNT @D14990, 
            PER @D14989, PLU @D14988, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, LAT -, FIN -, ARITY 3] : BRING, 
   [COORD @D14999, PAST @D14998, 
      AGR [CASE @D14997, COUNT @D14996, PER @D14995, PLU @D14994, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, FIN -, ARITY 3] : 
   BRING, 
   [COORD @D15005, PAST @D15004, AGR [CASE @D15003, COUNT @D15002, 
            PER @D15001, PLU @D15000, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, LAT -, FIN -, ARITY 3] : BRING, 
   [COORD @D15011, PAST @D15010, 
      AGR [CASE @D15009, COUNT @D15008, PER @D15007, PLU @D15006, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, LAT -, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D15017, PAST @D15016, AGR [CASE @D15015, COUNT @D15014, 
            PER @D15013, PLU @D15012, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, LAT -, FIN -, ARITY 3] : BRING, 
   [COORD @D15023, PAST @D15022, 
      AGR [CASE @D15021, COUNT @D15020, PER @D15019, PLU @D15018, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, LAT -, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D15029, PAST @D15028, AGR [CASE @D15027, COUNT @D15026, 
            PER @D15025, PLU @D15024, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, LAT -, FIN -, ARITY 3] : BRING, 
   [COORD @D15035, PAST @D15034, 
      AGR [CASE @D15033, COUNT @D15032, PER @D15031, PLU @D15030, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM AGAINST, LAT -, 
      FIN -, ARITY 3] : BRING, 
   [COORD @D15041, PAST @D15040, AGR [CASE @D15039, COUNT @D15038, 
            PER @D15037, PLU @D15036, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, LAT -, FIN -, ARITY 3] : BRING, 
   [COORD @D15045, 
      AGR [COUNT @D15044, PER @D15043, PLU @D15042, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT OUT, PAST +, ARITY 3] : BRING, 
   [COORD @D15049, AGR [COUNT @D15048, PER @D15047, PLU @D15046, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT IN, PAST +, ARITY 3] : BRING, 
   [COORD @D15053, AGR [COUNT @D15052, PER @D15051, PLU @D15050, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT IN, PAST +, ARITY 3] : BRING, 
   [COORD @D15057, AGR [COUNT @D15056, PER @D15055, PLU @D15054, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT BACK, PAST +, ARITY 3] : BRING, 
   [COORD @D15061, AGR [COUNT @D15060, PER @D15059, PLU @D15058, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM UNDER, PAST +, ARITY 3] : BRING, 
   [COORD @D15065, AGR [COUNT @D15064, PER @D15063, PLU @D15062, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, PAST +, ARITY 3] : BRING, 
   [COORD @D15069, AGR [COUNT @D15068, PER @D15067, PLU @D15066, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, PAST +, ARITY 3] : BRING, 
   [COORD @D15073, AGR [COUNT @D15072, PER @D15071, PLU @D15070, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM ON, PAST +, ARITY 3] : BRING, 
   [COORD @D15077, 
      AGR [COUNT @D15076, PER @D15075, PLU @D15074, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM INTO, PAST +, ARITY 3] : BRING, 
   [COORD @D15081, AGR [COUNT @D15080, PER @D15079, PLU @D15078, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT BACK, PFORM FOR, PAST +, ARITY 3] : BRING, 
   [COORD @D15085, 
      AGR [COUNT @D15084, PER @D15083, PLU @D15082, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT UP, 
      PFORM AGAINST, PAST +, ARITY 3] : BRING, 
   [COORD @D15089, AGR [COUNT @D15088, PER @D15087, PLU @D15086, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM TO, PAST +, ARITY 3] : BRING, 
   [COORD @D15093, AGR [COUNT @D15092, PER @D15091, PLU @D15090, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ROUND, PFORM TO, PAST +, ARITY 3] : BRING, 
   [COORD @D15097, AGR [COUNT @D15096, PER @D15095, PLU @D15094, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PFORM TO, PAST +, ARITY 3] : BRING, 
   [COORD @D15101, AGR [COUNT @D15100, PER @D15099, PLU @D15098, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, REG -, 
      PRT BACK, PFORM TO, PAST +, ARITY 3] : BRING, 
   [COORD @D15105, AGR [COUNT @D15104, PER @D15103, PLU @D15102, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AROUND, PFORM TO, PAST +, ARITY 3] : BRING, 
   [COORD @D15109, AGR [COUNT @D15108, PER @D15107, PLU @D15106, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, PFORM IN, PAST +, ARITY 3] : BRING, 
   [COORD @D15113, AGR [COUNT @D15112, PER @D15111, PLU @D15110, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM FOR, PAST +, ARITY 3] : BRING, 
   [COORD @D15117, AGR [COUNT @D15116, PER @D15115, PLU @D15114, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, PAST +, 
      LAT -, ARITY 3] : BRING, 
   [COORD @D15121, AGR [COUNT @D15120, PER @D15119, PLU @D15118, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PAST +, 
      LAT -, ARITY 3] : BRING, 
   [COORD @D15125, AGR [COUNT @D15124, PER @D15123, PLU @D15122, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, PAST +, LAT -, 
      ARITY 3] : BRING, 
   [COORD @D15129, AGR [COUNT @D15128, PER @D15127, PLU @D15126, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      PAST +, LAT -, ARITY 3] : BRING, 
   [COORD @D15133, AGR [COUNT @D15132, PER @D15131, PLU @D15130, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      PAST +, LAT -, ARITY 3] : BRING, 
   [COORD @D15137, AGR [COUNT @D15136, PER @D15135, PLU @D15134, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM AGAINST, 
      PAST +, LAT -, ARITY 3] : BRING, 
   [COORD @D15143, PAST @D15142, AGR [CASE @D15141, COUNT @D15140, 
            PER @D15139, PLU @D15138, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT UNDER, FIN -, ARITY 2] : BRING, 
   [COORD @D15149, PAST @D15148, 
      AGR [CASE @D15147, COUNT @D15146, PER @D15145, PLU @D15144, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT UNDER, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15155, PAST @D15154, AGR [CASE @D15153, COUNT @D15152, 
            PER @D15151, PLU @D15150, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT FORTH, FIN -, ARITY 2] : BRING, 
   [COORD @D15161, PAST @D15160, 
      AGR [CASE @D15159, COUNT @D15158, PER @D15157, PLU @D15156, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT FORTH, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15167, PAST @D15166, AGR [CASE @D15165, COUNT @D15164, 
            PER @D15163, PLU @D15162, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT ABOUT, FIN -, ARITY 2] : BRING, 
   [COORD @D15173, PAST @D15172, 
      AGR [CASE @D15171, COUNT @D15170, PER @D15169, PLU @D15168, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT ABOUT, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15179, PAST @D15178, AGR [CASE @D15177, COUNT @D15176, 
            PER @D15175, PLU @D15174, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : BRING, 
   [COORD @D15185, PAST @D15184, 
      AGR [CASE @D15183, COUNT @D15182, PER @D15181, PLU @D15180, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : BRING, 
   [COORD @D15191, PAST @D15190, AGR [CASE @D15189, COUNT @D15188, 
            PER @D15187, PLU @D15186, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TOGETHER, FIN -, ARITY 2] : BRING, 
   [COORD @D15197, PAST @D15196, 
      AGR [CASE @D15195, COUNT @D15194, PER @D15193, PLU @D15192, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, FIN -, ARITY 2] : BRING, 
   [COORD @D15203, PAST @D15202, 
      AGR [CASE @D15201, COUNT @D15200, PER @D15199, PLU @D15198, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TO, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15209, PAST @D15208, AGR [CASE @D15207, COUNT @D15206, 
            PER @D15205, PLU @D15204, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TO, FIN -, ARITY 2] : BRING, 
   [COORD @D15215, PAST @D15214, 
      AGR [CASE @D15213, COUNT @D15212, PER @D15211, PLU @D15210, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT THROUGH, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15221, PAST @D15220, AGR [CASE @D15219, COUNT @D15218, 
            PER @D15217, PLU @D15216, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, FIN -, ARITY 2] : BRING, 
   [COORD @D15227, PAST @D15226, 
      AGR [CASE @D15225, COUNT @D15224, PER @D15223, PLU @D15222, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ROUND, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15233, PAST @D15232, AGR [CASE @D15231, COUNT @D15230, 
            PER @D15229, PLU @D15228, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ROUND, FIN -, ARITY 2] : BRING, 
   [COORD @D15239, PAST @D15238, 
      AGR [CASE @D15237, COUNT @D15236, PER @D15235, PLU @D15234, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15245, PAST @D15244, AGR [CASE @D15243, COUNT @D15242, 
            PER @D15241, PLU @D15240, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : BRING, 
   [COORD @D15251, PAST @D15250, 
      AGR [CASE @D15249, COUNT @D15248, PER @D15247, PLU @D15246, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15257, PAST @D15256, AGR [CASE @D15255, COUNT @D15254, 
            PER @D15253, PLU @D15252, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : BRING, 
   [COORD @D15263, PAST @D15262, 
      AGR [CASE @D15261, COUNT @D15260, PER @D15259, PLU @D15258, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15269, PAST @D15268, AGR [CASE @D15267, COUNT @D15266, 
            PER @D15265, PLU @D15264, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, FIN -, ARITY 2] : BRING, 
   [COORD @D15275, PAST @D15274, 
      AGR [CASE @D15273, COUNT @D15272, PER @D15271, PLU @D15270, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15281, PAST @D15280, AGR [CASE @D15279, COUNT @D15278, 
            PER @D15277, PLU @D15276, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : BRING, 
   [COORD @D15287, PAST @D15286, 
      AGR [CASE @D15285, COUNT @D15284, PER @D15283, PLU @D15282, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15293, PAST @D15292, AGR [CASE @D15291, COUNT @D15290, 
            PER @D15289, PLU @D15288, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : BRING, 
   [COORD @D15299, PAST @D15298, 
      AGR [CASE @D15297, COUNT @D15296, PER @D15295, PLU @D15294, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT FORWARD, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15305, PAST @D15304, AGR [CASE @D15303, COUNT @D15302, 
            PER @D15301, PLU @D15300, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FORWARD, FIN -, ARITY 2] : BRING, 
   [COORD @D15311, PAST @D15310, 
      AGR [CASE @D15309, COUNT @D15308, PER @D15307, PLU @D15306, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15317, PAST @D15316, AGR [CASE @D15315, COUNT @D15314, 
            PER @D15313, PLU @D15312, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : BRING, 
   [COORD @D15323, PAST @D15322, 
      AGR [CASE @D15321, COUNT @D15320, PER @D15319, PLU @D15318, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15329, PAST @D15328, AGR [CASE @D15327, COUNT @D15326, 
            PER @D15325, PLU @D15324, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : BRING, 
   [COORD @D15335, PAST @D15334, 
      AGR [CASE @D15333, COUNT @D15332, PER @D15331, PLU @D15330, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AROUND, FIN -, 
      ARITY 2] : BRING, 
   [COORD @D15341, PAST @D15340, AGR [CASE @D15339, COUNT @D15338, 
            PER @D15337, PLU @D15336, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AROUND, FIN -, ARITY 2] : BRING, 
   [COORD @D15347, PAST @D15346, 
      AGR [CASE @D15345, COUNT @D15344, PER @D15343, PLU @D15342, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, FIN -, ARITY 2] : 
   BRING, 
   [COORD @D15353, PAST @D15352, AGR [CASE @D15351, COUNT @D15350, 
            PER @D15349, PLU @D15348, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, 
      REG -, LAT -, FIN -, ARITY 2] : BRING, 
   [COORD @D15357, AGR [COUNT @D15356, PER @D15355, PLU @D15354, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UNDER, PAST +, ARITY 2] : BRING, 
   [COORD @D15361, AGR [COUNT @D15360, PER @D15359, PLU @D15358, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT FORTH, PAST +, ARITY 2] : BRING, 
   [COORD @D15365, AGR [COUNT @D15364, PER @D15363, PLU @D15362, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ABOUT, PAST +, ARITY 2] : BRING, 
   [COORD @D15369, AGR [COUNT @D15368, PER @D15367, PLU @D15366, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : BRING, 
   [COORD @D15373, AGR [COUNT @D15372, PER @D15371, PLU @D15370, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, PAST +, ARITY 2] : BRING, 
   [COORD @D15377, AGR [COUNT @D15376, PER @D15375, PLU @D15374, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, PAST +, ARITY 2] : BRING, 
   [COORD @D15381, AGR [COUNT @D15380, PER @D15379, PLU @D15378, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, PAST +, ARITY 2] : BRING, 
   [COORD @D15385, AGR [COUNT @D15384, PER @D15383, PLU @D15382, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ROUND, PAST +, ARITY 2] : BRING, 
   [COORD @D15389, AGR [COUNT @D15388, PER @D15387, PLU @D15386, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PAST +, ARITY 2] : BRING, 
   [COORD @D15393, AGR [COUNT @D15392, PER @D15391, PLU @D15390, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : BRING, 
   [COORD @D15397, AGR [COUNT @D15396, PER @D15395, PLU @D15394, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, PAST +, ARITY 2] : BRING, 
   [COORD @D15401, AGR [COUNT @D15400, PER @D15399, PLU @D15398, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : BRING, 
   [COORD @D15405, AGR [COUNT @D15404, PER @D15403, PLU @D15402, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : BRING, 
   [COORD @D15409, AGR [COUNT @D15408, PER @D15407, PLU @D15406, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORWARD, PAST +, ARITY 2] : BRING, 
   [COORD @D15413, AGR [COUNT @D15412, PER @D15411, PLU @D15410, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PAST +, ARITY 2] : BRING, 
   [COORD @D15417, AGR [COUNT @D15416, PER @D15415, PLU @D15414, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PAST +, ARITY 2] : BRING, 
   [COORD @D15421, AGR [COUNT @D15420, PER @D15419, PLU @D15418, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AROUND, PAST +, ARITY 2] : BRING, 
   [COORD @D15425, AGR [COUNT @D15424, PER @D15423, PLU @D15422, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, PAST +, LAT -, 
      ARITY 2] : BRING, 
   [COORD @D15431, PAST @D15430, AGR [CASE @D15429, COUNT @D15428, 
            PER @D15427, PLU @D15426, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : BRING, 
   [COORD @D15437, PAST @D15436, 
      AGR [CASE @D15435, COUNT @D15434, PER @D15433, PLU @D15432, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UNDER, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15443, PAST @D15442, AGR [CASE @D15441, COUNT @D15440, 
            PER @D15439, PLU @D15438, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, FIN -, ARITY 1] : BRING, 
   [COORD @D15449, PAST @D15448, 
      AGR [CASE @D15447, COUNT @D15446, PER @D15445, PLU @D15444, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TO, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15455, PAST @D15454, AGR [CASE @D15453, COUNT @D15452, 
            PER @D15451, PLU @D15450, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, FIN -, ARITY 1] : BRING, 
   [COORD @D15461, PAST @D15460, 
      AGR [CASE @D15459, COUNT @D15458, PER @D15457, PLU @D15456, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ROUND, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15467, PAST @D15466, AGR [CASE @D15465, COUNT @D15464, 
            PER @D15463, PLU @D15462, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, FIN -, ARITY 1] : BRING, 
   [COORD @D15473, PAST @D15472, 
      AGR [CASE @D15471, COUNT @D15470, PER @D15469, PLU @D15468, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15479, PAST @D15478, AGR [CASE @D15477, COUNT @D15476, 
            PER @D15475, PLU @D15474, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : BRING, 
   [COORD @D15485, PAST @D15484, 
      AGR [CASE @D15483, COUNT @D15482, PER @D15481, PLU @D15480, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15491, PAST @D15490, AGR [CASE @D15489, COUNT @D15488, 
            PER @D15487, PLU @D15486, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : BRING, 
   [COORD @D15497, PAST @D15496, 
      AGR [CASE @D15495, COUNT @D15494, PER @D15493, PLU @D15492, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FORWARD, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15503, PAST @D15502, AGR [CASE @D15501, COUNT @D15500, 
            PER @D15499, PLU @D15498, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORTH, FIN -, ARITY 1] : BRING, 
   [COORD @D15509, PAST @D15508, 
      AGR [CASE @D15507, COUNT @D15506, PER @D15505, PLU @D15504, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15515, PAST @D15514, AGR [CASE @D15513, COUNT @D15512, 
            PER @D15511, PLU @D15510, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, FIN -, ARITY 1] : BRING, 
   [COORD @D15521, PAST @D15520, 
      AGR [CASE @D15519, COUNT @D15518, PER @D15517, PLU @D15516, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AROUND, FIN -, 
      ARITY 1] : BRING, 
   [COORD @D15527, PAST @D15526, AGR [CASE @D15525, COUNT @D15524, 
            PER @D15523, PLU @D15522, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, FIN -, ARITY 1] : BRING, 
   [COORD @D15531, 
      AGR [COUNT @D15530, PER @D15529, PLU @D15528, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : BRING, 
   [COORD @D15535, AGR [COUNT @D15534, PER @D15533, PLU @D15532, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UNDER, PAST +, ARITY 1] : BRING, 
   [COORD @D15539, AGR [COUNT @D15538, PER @D15537, PLU @D15536, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, PAST +, ARITY 1] : BRING, 
   [COORD @D15543, AGR [COUNT @D15542, PER @D15541, PLU @D15540, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, PAST +, ARITY 1] : BRING, 
   [COORD @D15547, AGR [COUNT @D15546, PER @D15545, PLU @D15544, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, PAST +, ARITY 1] : BRING, 
   [COORD @D15551, AGR [COUNT @D15550, PER @D15549, PLU @D15548, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ROUND, PAST +, ARITY 1] : BRING, 
   [COORD @D15555, AGR [COUNT @D15554, PER @D15553, PLU @D15552, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : BRING, 
   [COORD @D15559, AGR [COUNT @D15558, PER @D15557, PLU @D15556, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : BRING, 
   [COORD @D15563, AGR [COUNT @D15562, PER @D15561, PLU @D15560, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : BRING, 
   [COORD @D15567, AGR [COUNT @D15566, PER @D15565, PLU @D15564, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : BRING, 
   [COORD @D15571, AGR [COUNT @D15570, PER @D15569, PLU @D15568, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : BRING, 
   [COORD @D15575, AGR [COUNT @D15574, PER @D15573, PLU @D15572, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORWARD, PAST +, ARITY 1] : BRING, 
   [COORD @D15579, AGR [COUNT @D15578, PER @D15577, PLU @D15576, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORTH, PAST +, ARITY 1] : BRING, 
   [COORD @D15583, AGR [COUNT @D15582, PER @D15581, PLU @D15580, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : BRING, 
   [COORD @D15587, AGR [COUNT @D15586, PER @D15585, PLU @D15584, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : BRING, 
   [COORD @D15591, AGR [COUNT @D15590, PER @D15589, PLU @D15588, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, PAST +, ARITY 1] : BRING, 
   [COORD @D15595, AGR [COUNT @D15594, PER @D15593, PLU @D15592, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, PAST +, ARITY 1] : BRING.

WORD build : 
   [COORD @D15634, AGR [COUNT @D15633, PER @D15632, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : BUILD, 
   [COORD @D15636, AGR [COUNT @D15635, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : BUILD, 
   [COORD @D15638, AGR [COUNT @D15637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : BUILD, 
   [COORD @D15642, AGR [COUNT @D15641, PER @D15640, PLU @D15639, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : BUILD, 
   [COORD @D15648, PAST @D15647, 
      AGR [CASE @D15646, COUNT @D15645, PER @D15644, PLU @D15643, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, 
      ARITY 3] : BUILD, 
   [COORD @D15651, AGR [COUNT @D15650, PER @D15649, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15653, AGR [COUNT @D15652, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15655, AGR [COUNT @D15654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15659, AGR [COUNT @D15658, PER @D15657, PLU @D15656, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15665, PAST @D15664, 
      AGR [CASE @D15663, COUNT @D15662, PER @D15661, PLU @D15660, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, 
      ARITY 3] : BUILD, 
   [COORD @D15668, AGR [COUNT @D15667, PER @D15666, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15670, AGR [COUNT @D15669, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15672, AGR [COUNT @D15671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15676, AGR [COUNT @D15675, PER @D15674, PLU @D15673, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15682, PAST @D15681, 
      AGR [CASE @D15680, COUNT @D15679, PER @D15678, PLU @D15677, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM INTO, ARITY 3] : BUILD, 
   [COORD @D15685, AGR [COUNT @D15684, PER @D15683, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, 
      ARITY 3] : BUILD, 
   [COORD @D15687, AGR [COUNT @D15686, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, 
      ARITY 3] : BUILD, 
   [COORD @D15689, AGR [COUNT @D15688, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, 
      ARITY 3] : BUILD, 
   [COORD @D15693, AGR [COUNT @D15692, PER @D15691, PLU @D15690, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      LAT -, ARITY 3] : BUILD, 
   [COORD @D15699, PAST @D15698, AGR [CASE @D15697, COUNT @D15696, 
            PER @D15695, PLU @D15694, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, LAT -, ARITY 3] : BUILD, 
   [COORD @D15702, AGR [COUNT @D15701, PER @D15700, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OUT_OF, LAT -, ARITY 3] : BUILD, 
   [COORD @D15704, AGR [COUNT @D15703, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OUT_OF, LAT -, ARITY 3] : BUILD, 
   [COORD @D15706, AGR [COUNT @D15705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OUT_OF, LAT -, ARITY 3] : BUILD, 
   [COORD @D15710, AGR [COUNT @D15709, PER @D15708, PLU @D15707, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OUT_OF, LAT -, ARITY 3] : BUILD, 
   [COORD @D15716, PAST @D15715, 
      AGR [CASE @D15714, COUNT @D15713, PER @D15712, PLU @D15711, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OUT_OF, LAT -, 
      ARITY 3] : BUILD, 
   [COORD @D15719, AGR [COUNT @D15718, PER @D15717, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      LAT -, ARITY 3] : BUILD, 
   [COORD @D15721, AGR [COUNT @D15720, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      LAT -, ARITY 3] : BUILD, 
   [COORD @D15723, AGR [COUNT @D15722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      LAT -, ARITY 3] : BUILD, 
   [COORD @D15727, AGR [COUNT @D15726, PER @D15725, PLU @D15724, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, 
      PFORM FOR, LAT -, ARITY 3] : BUILD, 
   [COORD @D15733, PAST @D15732, AGR 
         [CASE @D15731, COUNT @D15730, PER @D15729, PLU @D15728, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, LAT -, 
      ARITY 3] : BUILD, 
   [COORD @D15736, AGR [COUNT @D15735, PER @D15734, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ON, ARITY 2] : BUILD, 
   [COORD @D15738, AGR [COUNT @D15737, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ON, ARITY 2] : BUILD, 
   [COORD @D15740, AGR [COUNT @D15739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ON, ARITY 2] : BUILD, 
   [COORD @D15744, AGR [COUNT @D15743, PER @D15742, PLU @D15741, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP ON, ARITY 2] : BUILD, 
   [COORD @D15750, PAST @D15749, 
      AGR [CASE @D15748, COUNT @D15747, PER @D15746, PLU @D15745, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP ON, 
      ARITY 2] : BUILD, 
   [COORD @D15753, AGR [COUNT @D15752, PER @D15751, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : BUILD, 
   [COORD @D15755, AGR [COUNT @D15754, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : BUILD, 
   [COORD @D15757, AGR [COUNT @D15756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : BUILD, 
   [COORD @D15761, AGR [COUNT @D15760, PER @D15759, PLU @D15758, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : BUILD, 
   [COORD @D15767, PAST @D15766, AGR [CASE @D15765, COUNT @D15764, 
            PER @D15763, PLU @D15762, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : BUILD, 
   [COORD @D15770, 
      AGR [COUNT @D15769, PER @D15768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : BUILD, 
   [COORD @D15772, AGR [COUNT @D15771, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : BUILD, 
   [COORD @D15774, AGR [COUNT @D15773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : BUILD, 
   [COORD @D15778, AGR [COUNT @D15777, PER @D15776, PLU @D15775, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : BUILD, 
   [COORD @D15784, PAST @D15783, 
      AGR [CASE @D15782, COUNT @D15781, PER @D15780, PLU @D15779, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : BUILD, 
   [COORD @D15787, AGR [COUNT @D15786, PER @D15785, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : BUILD, 
   [COORD @D15789, AGR [COUNT @D15788, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : BUILD, 
   [COORD @D15791, AGR [COUNT @D15790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : BUILD, 
   [COORD @D15795, AGR [COUNT @D15794, PER @D15793, PLU @D15792, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, ARITY 2] : BUILD, 
   [COORD @D15801, PAST @D15800, 
      AGR [CASE @D15799, COUNT @D15798, PER @D15797, PLU @D15796, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      ARITY 2] : BUILD, 
   [COORD @D15804, AGR [COUNT @D15803, PER @D15802, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BUILD, 
   [COORD @D15806, AGR [COUNT @D15805, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BUILD, 
   [COORD @D15808, AGR [COUNT @D15807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BUILD, 
   [COORD @D15812, AGR [COUNT @D15811, PER @D15810, PLU @D15809, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : BUILD, 
   [COORD @D15818, PAST @D15817, 
      AGR [CASE @D15816, COUNT @D15815, PER @D15814, PLU @D15813, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : BUILD, 
   [COORD @D15821, AGR [COUNT @D15820, PER @D15819, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D15823, AGR [COUNT @D15822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D15825, AGR [COUNT @D15824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D15829, AGR [COUNT @D15828, PER @D15827, PLU @D15826, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D15835, PAST @D15834, AGR [CASE @D15833, COUNT @D15832, 
            PER @D15831, PLU @D15830, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, REG -, LAT -, ARITY 2] : BUILD, 
   [COORD @D15838, AGR [COUNT @D15837, PER @D15836, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, REG -, PRT UP, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D15840, AGR [COUNT @D15839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, REG -, PRT UP, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D15842, AGR [COUNT @D15841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, REG -, PRT UP, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D15846, AGR [COUNT @D15845, PER @D15844, PLU @D15843, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, REG -, 
      PRT UP, LAT -, ARITY 2] : BUILD, 
   [COORD @D15852, PAST @D15851, AGR [CASE @D15850, COUNT @D15849, 
            PER @D15848, PLU @D15847, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      COMPOUND NOT, REG -, PRT UP, LAT -, ARITY 2] : BUILD, 
   [COORD @D15855, 
      AGR [COUNT @D15854, PER @D15853, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : BUILD, 
   [COORD @D15857, AGR [COUNT @D15856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : BUILD, 
   [COORD @D15859, AGR [COUNT @D15858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : BUILD, 
   [COORD @D15863, AGR [COUNT @D15862, PER @D15861, PLU @D15860, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : BUILD, 
   [COORD @D15869, PAST @D15868, 
      AGR [CASE @D15867, COUNT @D15866, PER @D15865, PLU @D15864, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : BUILD, 
   [COORD @D15872, AGR [COUNT @D15871, PER @D15870, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : BUILD, 
   [COORD @D15874, AGR [COUNT @D15873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : BUILD, 
   [COORD @D15876, AGR [COUNT @D15875, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : BUILD, 
   [COORD @D15880, AGR [COUNT @D15879, PER @D15878, PLU @D15877, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : BUILD, 
   [COORD @D15886, PAST @D15885, 
      AGR [CASE @D15884, COUNT @D15883, PER @D15882, PLU @D15881, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : BUILD, 
   [COORD @D15889, AGR [COUNT @D15888, PER @D15887, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BUILD, 
   [COORD @D15891, AGR [COUNT @D15890, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BUILD, 
   [COORD @D15893, AGR [COUNT @D15892, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BUILD, 
   [COORD @D15897, AGR [COUNT @D15896, PER @D15895, PLU @D15894, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : BUILD, 
   [COORD @D15903, PAST @D15902, 
      AGR [CASE @D15901, COUNT @D15900, PER @D15899, PLU @D15898, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : BUILD, 
   [COORD @D15906, AGR [COUNT @D15905, PER @D15904, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BUILD, 
   [COORD @D15908, AGR [COUNT @D15907, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BUILD, 
   [COORD @D15910, AGR [COUNT @D15909, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BUILD, 
   [COORD @D15914, AGR [COUNT @D15913, PER @D15912, PLU @D15911, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, 
      LAT -, ARITY 1] : BUILD, 
   [COORD @D15920, PAST @D15919, AGR [CASE @D15918, COUNT @D15917, 
            PER @D15916, PLU @D15915, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, REG -, LAT -, ARITY 1] : BUILD, 
   [COORD @D15923, AGR [COUNT @D15922, PER @D15921, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      LAT -, ARITY 1] : BUILD, 
   [COORD @D15925, AGR [COUNT @D15924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      LAT -, ARITY 1] : BUILD, 
   [COORD @D15927, AGR [COUNT @D15926, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      LAT -, ARITY 1] : BUILD, 
   [COORD @D15931, AGR [COUNT @D15930, PER @D15929, PLU @D15928, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, LAT -, ARITY 1] : BUILD, 
   [COORD @D15937, PAST @D15936, AGR [CASE @D15935, COUNT @D15934, 
            PER @D15933, PLU @D15932, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, LAT -, ARITY 1] : BUILD.

WORD building : 
   [COORD @D15958, REFL @D15957, COUNT @D15956, PRD @D15955, 
      CASE @D15954, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : BUILDING, 
   [COORD @D15964, PRD @D15963, 
      AGR [CASE @D15962, COUNT @D15961, PER @D15960, PLU @D15959, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BUILD, 
   [COORD @D15970, PRD @D15969, AGR [CASE @D15968, COUNT @D15967, 
            PER @D15966, PLU @D15965, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D15976, PRD @D15975, 
      AGR [CASE @D15974, COUNT @D15973, PER @D15972, PLU @D15971, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BUILD, 
   [COORD @D15982, PRD @D15981, AGR [CASE @D15980, COUNT @D15979, 
            PER @D15978, PLU @D15977, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D15988, PRD @D15987, 
      AGR [CASE @D15986, COUNT @D15985, PER @D15984, PLU @D15983, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BUILD, 
   [COORD @D15994, PRD @D15993, AGR [CASE @D15992, COUNT @D15991, 
            PER @D15990, PLU @D15989, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D16000, PRD @D15999, 
      AGR [CASE @D15998, COUNT @D15997, PER @D15996, PLU @D15995, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PREP ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUILD, 
   [COORD @D16006, PRD @D16005, AGR [CASE @D16004, COUNT @D16003, 
            PER @D16002, PLU @D16001, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D16012, PRD @D16011, 
      AGR [CASE @D16010, COUNT @D16009, PER @D16008, PLU @D16007, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUILD, 
   [COORD @D16018, PRD @D16017, AGR [CASE @D16016, COUNT @D16015, 
            PER @D16014, PLU @D16013, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D16024, PRD @D16023, 
      AGR [CASE @D16022, COUNT @D16021, PER @D16020, PLU @D16019, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUILD, 
   [COORD @D16030, PRD @D16029, AGR [CASE @D16028, COUNT @D16027, 
            PER @D16026, PLU @D16025, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D16036, PRD @D16035, 
      AGR [CASE @D16034, COUNT @D16033, PER @D16032, PLU @D16031, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUILD, 
   [COORD @D16042, PRD @D16041, AGR [CASE @D16040, COUNT @D16039, 
            PER @D16038, PLU @D16037, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D16048, PRD @D16047, 
      AGR [CASE @D16046, COUNT @D16045, PER @D16044, PLU @D16043, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUILD, 
   [COORD @D16054, PRD @D16053, AGR [CASE @D16052, COUNT @D16051, 
            PER @D16050, PLU @D16049, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUILD, 
   [COORD @D16060, PRD @D16059, 
      AGR [CASE @D16058, COUNT @D16057, PER @D16056, PLU @D16055, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   BUILD, 
   [COORD @D16066, PRD @D16065, AGR [CASE @D16064, COUNT @D16063, 
            PER @D16062, PLU @D16061, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUILD.

WORD buildings : 
   [COORD @D16082, DEMON @D16081, REFL @D16080, PRD @D16079, 
      CASE @D16078, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BUILDING.

WORD builds : 
   [COORD @D16091, AGR [COUNT @D16090, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BUILD, 
   [COORD @D16093, AGR [COUNT @D16092, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BUILD, 
   [COORD @D16095, AGR [COUNT @D16094, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : BUILD, 
   [COORD @D16097, AGR [COUNT @D16096, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16099, 
      AGR [COUNT @D16098, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   BUILD, 
   [COORD @D16101, AGR [COUNT @D16100, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : BUILD, 
   [COORD @D16103, AGR [COUNT @D16102, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16105, 
      AGR [COUNT @D16104, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16107, 
      AGR [COUNT @D16106, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16109, 
      AGR [COUNT @D16108, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16111, 
      AGR [COUNT @D16110, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16113, 
      AGR [COUNT @D16112, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16115, 
      AGR [COUNT @D16114, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16117, 
      AGR [COUNT @D16116, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16119, 
      AGR [COUNT @D16118, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16121, 
      AGR [COUNT @D16120, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16123, 
      AGR [COUNT @D16122, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD, 
   [COORD @D16125, 
      AGR [COUNT @D16124, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BUILD.

WORD built : 
   [COORD @D16137, PAST @D16136, AGR [CASE @D16135, COUNT @D16134, 
            PER @D16133, PLU @D16132, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : BUILD, 
   [COORD @D16143, PAST @D16142, 
      AGR [CASE @D16141, COUNT @D16140, PER @D16139, PLU @D16138, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, FIN -, 
      ARITY 3] : BUILD, 
   [COORD @D16149, PAST @D16148, AGR [CASE @D16147, COUNT @D16146, 
            PER @D16145, PLU @D16144, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : BUILD, 
   [COORD @D16155, PAST @D16154, 
      AGR [CASE @D16153, COUNT @D16152, PER @D16151, PLU @D16150, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, FIN -, 
      ARITY 3] : BUILD, 
   [COORD @D16161, PAST @D16160, AGR [CASE @D16159, COUNT @D16158, 
            PER @D16157, PLU @D16156, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM INTO, FIN -, ARITY 3] : BUILD, 
   [COORD @D16167, PAST @D16166, 
      AGR [CASE @D16165, COUNT @D16164, PER @D16163, PLU @D16162, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM INTO, FIN -, ARITY 3] : BUILD, 
   [COORD @D16173, PAST @D16172, 
      AGR [CASE @D16171, COUNT @D16170, PER @D16169, PLU @D16168, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, FIN -, ARITY 3] : 
   BUILD, 
   [COORD @D16179, PAST @D16178, AGR [CASE @D16177, COUNT @D16176, 
            PER @D16175, PLU @D16174, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, LAT -, FIN -, ARITY 3] : BUILD, 
   [COORD @D16185, PAST @D16184, 
      AGR [CASE @D16183, COUNT @D16182, PER @D16181, PLU @D16180, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OUT_OF, LAT -, 
      FIN -, ARITY 3] : BUILD, 
   [COORD @D16191, PAST @D16190, AGR [CASE @D16189, COUNT @D16188, 
            PER @D16187, PLU @D16186, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OUT_OF, LAT -, FIN -, ARITY 3] : BUILD, 
   [COORD @D16197, PAST @D16196, 
      AGR [CASE @D16195, COUNT @D16194, PER @D16193, PLU @D16192, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, LAT -, 
      FIN -, ARITY 3] : BUILD, 
   [COORD @D16203, PAST @D16202, AGR [CASE @D16201, COUNT @D16200, 
            PER @D16199, PLU @D16198, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, LAT -, FIN -, ARITY 3] : BUILD, 
   [COORD @D16207, AGR [COUNT @D16206, PER @D16205, PLU @D16204, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, PAST +, ARITY 3] : BUILD, 
   [COORD @D16211, AGR [COUNT @D16210, PER @D16209, PLU @D16208, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, PAST +, ARITY 3] : BUILD, 
   [COORD @D16215, AGR [COUNT @D16214, PER @D16213, PLU @D16212, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM INTO, PAST +, ARITY 3] : BUILD, 
   [COORD @D16219, AGR [COUNT @D16218, PER @D16217, PLU @D16216, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, PAST +, LAT -, 
      ARITY 3] : BUILD, 
   [COORD @D16223, AGR [COUNT @D16222, PER @D16221, PLU @D16220, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OUT_OF, 
      PAST +, LAT -, ARITY 3] : BUILD, 
   [COORD @D16227, AGR [COUNT @D16226, PER @D16225, PLU @D16224, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      PAST +, LAT -, ARITY 3] : BUILD, 
   [COORD @D16233, PAST @D16232, AGR [CASE @D16231, COUNT @D16230, 
            PER @D16229, PLU @D16228, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP ON, FIN -, ARITY 2] : BUILD, 
   [COORD @D16239, PAST @D16238, 
      AGR [CASE @D16237, COUNT @D16236, PER @D16235, PLU @D16234, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ON, FIN -, 
      ARITY 2] : BUILD, 
   [COORD @D16245, PAST @D16244, AGR [CASE @D16243, COUNT @D16242, 
            PER @D16241, PLU @D16240, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ON, FIN -, ARITY 2] : BUILD, 
   [COORD @D16251, PAST @D16250, 
      AGR [CASE @D16249, COUNT @D16248, PER @D16247, PLU @D16246, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : BUILD, 
   [COORD @D16257, PAST @D16256, AGR [CASE @D16255, COUNT @D16254, 
            PER @D16253, PLU @D16252, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : BUILD, 
   [COORD @D16263, PAST @D16262, 
      AGR [CASE @D16261, COUNT @D16260, PER @D16259, PLU @D16258, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, FIN -, 
      ARITY 2] : BUILD, 
   [COORD @D16269, PAST @D16268, AGR [CASE @D16267, COUNT @D16266, 
            PER @D16265, PLU @D16264, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, FIN -, ARITY 2] : BUILD, 
   [COORD @D16275, PAST @D16274, 
      AGR [CASE @D16273, COUNT @D16272, PER @D16271, PLU @D16270, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : BUILD, 
   [COORD @D16281, PAST @D16280, AGR [CASE @D16279, COUNT @D16278, 
            PER @D16277, PLU @D16276, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : BUILD, 
   [COORD @D16287, PAST @D16286, 
      AGR [CASE @D16285, COUNT @D16284, PER @D16283, PLU @D16282, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, FIN -, ARITY 2] : 
   BUILD, 
   [COORD @D16293, PAST @D16292, AGR [CASE @D16291, COUNT @D16290, 
            PER @D16289, PLU @D16288, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, 
      REG -, LAT -, FIN -, ARITY 2] : BUILD, 
   [COORD @D16299, PAST @D16298, 
      AGR [CASE @D16297, COUNT @D16296, PER @D16295, PLU @D16294, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, COMPOUND NOT, REG -, PRT UP, LAT -, FIN -, ARITY 2] : 
   BUILD, 
   [COORD @D16305, PAST @D16304, AGR [CASE @D16303, COUNT @D16302, 
            PER @D16301, PLU @D16300, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, COMPOUND NOT, REG -, 
      PRT UP, LAT -, FIN -, ARITY 2] : BUILD, 
   [COORD @D16309, AGR [COUNT @D16308, PER @D16307, PLU @D16306, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ON, PAST +, ARITY 2] : BUILD, 
   [COORD @D16313, AGR [COUNT @D16312, PER @D16311, PLU @D16310, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, PAST +, ARITY 2] : BUILD, 
   [COORD @D16317, AGR [COUNT @D16316, PER @D16315, PLU @D16314, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : BUILD, 
   [COORD @D16321, AGR [COUNT @D16320, PER @D16319, PLU @D16318, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, PAST +, ARITY 2] : BUILD, 
   [COORD @D16325, AGR [COUNT @D16324, PER @D16323, PLU @D16322, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : BUILD, 
   [COORD @D16329, AGR [COUNT @D16328, PER @D16327, PLU @D16326, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, PAST +, LAT -, 
      ARITY 2] : BUILD, 
   [COORD @D16333, AGR [COUNT @D16332, PER @D16331, PLU @D16330, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, COMPOUND NOT, REG -, PRT UP, PAST +, 
      LAT -, ARITY 2] : BUILD, 
   [COORD @D16339, PAST @D16338, AGR [CASE @D16337, COUNT @D16336, 
            PER @D16335, PLU @D16334, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : BUILD, 
   [COORD @D16345, PAST @D16344, 
      AGR [CASE @D16343, COUNT @D16342, PER @D16341, PLU @D16340, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, FIN -, 
      ARITY 1] : BUILD, 
   [COORD @D16351, PAST @D16350, AGR [CASE @D16349, COUNT @D16348, 
            PER @D16347, PLU @D16346, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : BUILD, 
   [COORD @D16357, PAST @D16356, 
      AGR [CASE @D16355, COUNT @D16354, PER @D16353, PLU @D16352, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBCAT NULL, REG -, LAT -, FIN -, ARITY 1] : BUILD, 
   [COORD @D16363, PAST @D16362, 
      AGR [CASE @D16361, COUNT @D16360, PER @D16359, PLU @D16358, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, LAT -, FIN -, ARITY 1] : 
   BUILD, 
   [COORD @D16367, AGR [COUNT @D16366, PER @D16365, PLU @D16364, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : BUILD, 
   [COORD @D16371, AGR [COUNT @D16370, PER @D16369, PLU @D16368, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : BUILD, 
   [COORD @D16375, AGR [COUNT @D16374, PER @D16373, PLU @D16372, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : BUILD, 
   [COORD @D16379, AGR [COUNT @D16378, PER @D16377, PLU @D16376, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, PAST +, LAT -, 
      ARITY 1] : BUILD, 
   [COORD @D16383, AGR [COUNT @D16382, PER @D16381, PLU @D16380, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, PAST +, 
      LAT -, ARITY 1] : BUILD.

WORD buried : 
   [COORD @D16416, AGR [CASE @D16415, COUNT @D16414, PER @D16413, 
            PLU @D16412, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BURY, 
   [COORD @D16421, AGR [CASE @D16420, COUNT @D16419, PER @D16418, 
            PLU @D16417, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BURY, 
   [COORD @D16426, AGR [CASE @D16425, COUNT @D16424, PER @D16423, 
            PLU @D16422, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : BURY, 
   [COORD @D16431, AGR [CASE @D16430, COUNT @D16429, PER @D16428, 
            PLU @D16427, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : BURY, 
   [COORD @D16436, AGR [CASE @D16435, COUNT @D16434, PER @D16433, 
            PLU @D16432, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : BURY, 
   [COORD @D16441, AGR [CASE @D16440, COUNT @D16439, PER @D16438, 
            PLU @D16437, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : BURY.

WORD buries : 
   [COORD @D16450, AGR [COUNT @D16449, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BURY, 
   [COORD @D16452, 
      AGR [COUNT @D16451, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : BURY.

WORD bury : 
   [COORD @D16461, AGR [COUNT @D16460, PER @D16459, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      LAT -, ARITY 3] : BURY, 
   [COORD @D16463, AGR [COUNT @D16462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      LAT -, ARITY 3] : BURY, 
   [COORD @D16465, AGR [COUNT @D16464, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      LAT -, ARITY 3] : BURY, 
   [COORD @D16469, AGR [COUNT @D16468, PER @D16467, PLU @D16466, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM IN, LAT -, ARITY 3] : BURY, 
   [COORD @D16475, PAST @D16474, AGR [CASE @D16473, COUNT @D16472, 
            PER @D16471, PLU @D16470, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, LAT -, ARITY 3] : BURY, 
   [COORD @D16478, AGR [COUNT @D16477, PER @D16476, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BURY, 
   [COORD @D16480, AGR [COUNT @D16479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BURY, 
   [COORD @D16482, AGR [COUNT @D16481, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BURY, 
   [COORD @D16486, AGR [COUNT @D16485, PER @D16484, PLU @D16483, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : BURY, 
   [COORD @D16492, PAST @D16491, AGR [CASE @D16490, COUNT @D16489, 
            PER @D16488, PLU @D16487, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : BURY.

WORD burying : 
   [COORD @D16507, PRD @D16506, AGR [CASE @D16505, COUNT @D16504, 
            PER @D16503, PLU @D16502, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BURY, 
   [COORD @D16513, PRD @D16512, 
      AGR [CASE @D16511, COUNT @D16510, PER @D16509, PLU @D16508, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BURY.

WORD business : 
   [COORD @D16522, REFL @D16521, PRD @D16520, CASE @D16519, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : BUSINESS, 
   [COORD @D16527, REFL @D16526, COUNT @D16525, PRD @D16524, 
      CASE @D16523, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : BUSINESS.

WORD businesses : 
   [COORD @D16538, DEMON @D16537, REFL @D16536, PRD @D16535, 
      CASE @D16534, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : BUSINESS.

WORD buy : 
   [COORD @D16546, AGR [COUNT @D16545, PER @D16544, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : BUY, 
   [COORD @D16548, AGR [COUNT @D16547, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : BUY, 
   [COORD @D16550, AGR [COUNT @D16549, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : BUY, 
   [COORD @D16554, AGR [COUNT @D16553, PER @D16552, PLU @D16551, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, ARITY 3] : BUY, 
   [COORD @D16560, PAST @D16559, 
      AGR [CASE @D16558, COUNT @D16557, PER @D16556, PLU @D16555, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, ARITY 3] : BUY, 
   [COORD @D16563, AGR [COUNT @D16562, PER @D16561, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16565, AGR [COUNT @D16564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16567, AGR [COUNT @D16566, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16571, AGR [COUNT @D16570, PER @D16569, PLU @D16568, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, 
      LAT -, ARITY 3] : BUY, 
   [COORD @D16577, PAST @D16576, AGR [CASE @D16575, COUNT @D16574, 
            PER @D16573, PLU @D16572, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, LAT -, ARITY 3] : BUY, 
   [COORD @D16580, AGR [COUNT @D16579, PER @D16578, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16582, AGR [COUNT @D16581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16584, AGR [COUNT @D16583, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16588, AGR [COUNT @D16587, PER @D16586, PLU @D16585, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      LAT -, ARITY 3] : BUY, 
   [COORD @D16594, PAST @D16593, AGR [CASE @D16592, COUNT @D16591, 
            PER @D16590, PLU @D16589, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, LAT -, ARITY 3] : BUY, 
   [COORD @D16597, AGR [COUNT @D16596, PER @D16595, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, LAT -, ARITY 3] : BUY, 
   [COORD @D16599, AGR [COUNT @D16598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, LAT -, ARITY 3] : BUY, 
   [COORD @D16601, AGR [COUNT @D16600, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, LAT -, ARITY 3] : BUY, 
   [COORD @D16605, AGR [COUNT @D16604, PER @D16603, PLU @D16602, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, LAT -, ARITY 3] : BUY, 
   [COORD @D16611, PAST @D16610, AGR [CASE @D16609, COUNT @D16608, 
            PER @D16607, PLU @D16606, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, LAT -, ARITY 3] : BUY, 
   [COORD @D16614, 
      AGR [COUNT @D16613, PER @D16612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FROM, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16616, AGR [COUNT @D16615, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FROM, LAT -, ARITY 3] : BUY, 
   [COORD @D16618, AGR [COUNT @D16617, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FROM, LAT -, ARITY 3] : BUY, 
   [COORD @D16622, AGR [COUNT @D16621, PER @D16620, PLU @D16619, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FROM, LAT -, ARITY 3] : BUY, 
   [COORD @D16628, PAST @D16627, AGR [CASE @D16626, COUNT @D16625, 
            PER @D16624, PLU @D16623, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FROM, LAT -, ARITY 3] : BUY, 
   [COORD @D16631, 
      AGR [COUNT @D16630, PER @D16629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, LAT -, 
      ARITY 3] : BUY, 
   [COORD @D16633, AGR [COUNT @D16632, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      LAT -, ARITY 3] : BUY, 
   [COORD @D16635, AGR [COUNT @D16634, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      LAT -, ARITY 3] : BUY, 
   [COORD @D16639, AGR [COUNT @D16638, PER @D16637, PLU @D16636, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, 
      PFORM FOR, LAT -, ARITY 3] : BUY, 
   [COORD @D16645, PAST @D16644, AGR [CASE @D16643, COUNT @D16642, 
            PER @D16641, PLU @D16640, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, LAT -, ARITY 3] : BUY, 
   [COORD @D16648, 
      AGR [COUNT @D16647, PER @D16646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : BUY, 
   [COORD @D16650, AGR [COUNT @D16649, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : BUY, 
   [COORD @D16652, AGR [COUNT @D16651, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : BUY, 
   [COORD @D16656, AGR [COUNT @D16655, PER @D16654, PLU @D16653, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : BUY, 
   [COORD @D16662, PAST @D16661, 
      AGR [CASE @D16660, COUNT @D16659, PER @D16658, PLU @D16657, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : BUY, 
   [COORD @D16665, AGR [COUNT @D16664, PER @D16663, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : BUY, 
   [COORD @D16667, AGR [COUNT @D16666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : BUY, 
   [COORD @D16669, AGR [COUNT @D16668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : BUY, 
   [COORD @D16673, AGR [COUNT @D16672, PER @D16671, PLU @D16670, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : BUY, 
   [COORD @D16679, PAST @D16678, 
      AGR [CASE @D16677, COUNT @D16676, PER @D16675, PLU @D16674, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : BUY, 
   [COORD @D16682, AGR [COUNT @D16681, PER @D16680, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : BUY, 
   [COORD @D16684, AGR [COUNT @D16683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : BUY, 
   [COORD @D16686, AGR [COUNT @D16685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : BUY, 
   [COORD @D16690, AGR [COUNT @D16689, PER @D16688, PLU @D16687, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : BUY, 
   [COORD @D16696, PAST @D16695, 
      AGR [CASE @D16694, COUNT @D16693, PER @D16692, PLU @D16691, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : BUY, 
   [COORD @D16699, AGR [COUNT @D16698, PER @D16697, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BUY, 
   [COORD @D16701, AGR [COUNT @D16700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BUY, 
   [COORD @D16703, AGR [COUNT @D16702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : BUY, 
   [COORD @D16707, AGR [COUNT @D16706, PER @D16705, PLU @D16704, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : BUY, 
   [COORD @D16713, PAST @D16712, 
      AGR [CASE @D16711, COUNT @D16710, PER @D16709, PLU @D16708, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : BUY, 
   [COORD @D16716, AGR [COUNT @D16715, PER @D16714, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUY, 
   [COORD @D16718, AGR [COUNT @D16717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUY, 
   [COORD @D16720, AGR [COUNT @D16719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUY, 
   [COORD @D16724, AGR [COUNT @D16723, PER @D16722, PLU @D16721, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, REG -, LAT -, 
      ARITY 2] : BUY, 
   [COORD @D16730, PAST @D16729, AGR [CASE @D16728, COUNT @D16727, 
            PER @D16726, PLU @D16725, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, REG -, LAT -, ARITY 2] : BUY, 
   [COORD @D16733, AGR [COUNT @D16732, PER @D16731, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, 
      LAT -, ARITY 2] : BUY, 
   [COORD @D16735, AGR [COUNT @D16734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, 
      LAT -, ARITY 2] : BUY, 
   [COORD @D16737, AGR [COUNT @D16736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, 
      LAT -, ARITY 2] : BUY, 
   [COORD @D16741, AGR [COUNT @D16740, PER @D16739, PLU @D16738, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, LAT -, ARITY 2] : BUY, 
   [COORD @D16747, PAST @D16746, AGR [CASE @D16745, COUNT @D16744, 
            PER @D16743, PLU @D16742, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM FROM, LAT -, ARITY 2] : BUY, 
   [COORD @D16750, 
      AGR [COUNT @D16749, PER @D16748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, LAT -, ARITY 2] : 
   BUY, 
   [COORD @D16752, AGR [COUNT @D16751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      LAT -, ARITY 2] : BUY, 
   [COORD @D16754, AGR [COUNT @D16753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      LAT -, ARITY 2] : BUY, 
   [COORD @D16758, AGR [COUNT @D16757, PER @D16756, PLU @D16755, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, LAT -, ARITY 2] : BUY, 
   [COORD @D16764, PAST @D16763, AGR [CASE @D16762, COUNT @D16761, 
            PER @D16760, PLU @D16759, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM FOR, LAT -, ARITY 2] : BUY, 
   [COORD @D16767, 
      AGR [COUNT @D16766, PER @D16765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : BUY, 
   [COORD @D16769, AGR [COUNT @D16768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : BUY, 
   [COORD @D16771, AGR [COUNT @D16770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : BUY, 
   [COORD @D16775, AGR [COUNT @D16774, PER @D16773, PLU @D16772, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : BUY, 
   [COORD @D16781, PAST @D16780, 
      AGR [CASE @D16779, COUNT @D16778, PER @D16777, PLU @D16776, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : BUY, 
   [COORD @D16784, AGR [COUNT @D16783, PER @D16782, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : BUY, 
   [COORD @D16786, AGR [COUNT @D16785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : BUY, 
   [COORD @D16788, AGR [COUNT @D16787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : BUY, 
   [COORD @D16792, AGR [COUNT @D16791, PER @D16790, PLU @D16789, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : BUY, 
   [COORD @D16798, PAST @D16797, 
      AGR [CASE @D16796, COUNT @D16795, PER @D16794, PLU @D16793, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : BUY, 
   [COORD @D16801, AGR [COUNT @D16800, PER @D16799, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : BUY, 
   [COORD @D16803, AGR [COUNT @D16802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : BUY, 
   [COORD @D16805, AGR [COUNT @D16804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : BUY, 
   [COORD @D16809, AGR [COUNT @D16808, PER @D16807, PLU @D16806, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : BUY, 
   [COORD @D16815, PAST @D16814, 
      AGR [CASE @D16813, COUNT @D16812, PER @D16811, PLU @D16810, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : BUY, 
   [COORD @D16818, AGR [COUNT @D16817, PER @D16816, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BUY, 
   [COORD @D16820, AGR [COUNT @D16819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BUY, 
   [COORD @D16822, AGR [COUNT @D16821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : BUY, 
   [COORD @D16826, AGR [COUNT @D16825, PER @D16824, PLU @D16823, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : BUY, 
   [COORD @D16832, PAST @D16831, 
      AGR [CASE @D16830, COUNT @D16829, PER @D16828, PLU @D16827, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : BUY, 
   [COORD @D16835, AGR [COUNT @D16834, PER @D16833, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BUY, 
   [COORD @D16837, AGR [COUNT @D16836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BUY, 
   [COORD @D16839, AGR [COUNT @D16838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, LAT -, 
      ARITY 1] : BUY, 
   [COORD @D16843, AGR [COUNT @D16842, PER @D16841, PLU @D16840, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, REG -, 
      LAT -, ARITY 1] : BUY, 
   [COORD @D16849, PAST @D16848, AGR [CASE @D16847, COUNT @D16846, 
            PER @D16845, PLU @D16844, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, REG -, LAT -, ARITY 1] : BUY.

WORD buying : 
   [COORD @D16863, PRD @D16862, AGR [CASE @D16861, COUNT @D16860, 
            PER @D16859, PLU @D16858, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16869, PRD @D16868, 
      AGR [CASE @D16867, COUNT @D16866, PER @D16865, PLU @D16864, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   
   [COORD @D16875, PRD @D16874, AGR [CASE @D16873, COUNT @D16872, PER 
               @D16871, PLU @D16870, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16881, PRD @D16880, AGR 
         [CASE @D16879, COUNT @D16878, PER @D16877, PLU @D16876, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BUY, 
   [COORD @D16887, PRD @D16886, AGR [CASE @D16885, COUNT @D16884, 
            PER @D16883, PLU @D16882, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16893, PRD @D16892, 
      AGR [CASE @D16891, COUNT @D16890, PER @D16889, PLU @D16888, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : BUY, 
   [COORD @D16899, PRD @D16898, AGR [CASE @D16897, COUNT @D16896, 
            PER @D16895, PLU @D16894, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16905, PRD @D16904, 
      AGR [CASE @D16903, COUNT @D16902, PER @D16901, PLU @D16900, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUY, 
   [COORD @D16911, PRD @D16910, AGR [CASE @D16909, COUNT @D16908, 
            PER @D16907, PLU @D16906, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16917, PRD @D16916, 
      AGR [CASE @D16915, COUNT @D16914, PER @D16913, PLU @D16912, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUY, 
   [COORD @D16923, PRD @D16922, AGR [CASE @D16921, COUNT @D16920, 
            PER @D16919, PLU @D16918, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16929, PRD @D16928, AGR 
         [CASE @D16927, COUNT @D16926, PER @D16925, PLU @D16924, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUY, 
   [COORD @D16935, PRD @D16934, AGR [CASE @D16933, COUNT @D16932, 
            PER @D16931, PLU @D16930, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16941, PRD @D16940, 
      AGR [CASE @D16939, COUNT @D16938, PER @D16937, PLU @D16936, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUY, 
   [COORD @D16947, PRD @D16946, AGR [CASE @D16945, COUNT @D16944, 
            PER @D16943, PLU @D16942, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16953, PRD @D16952, 
      AGR [CASE @D16951, COUNT @D16950, PER @D16949, PLU @D16948, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : BUY, 
   [COORD @D16959, PRD @D16958, AGR [CASE @D16957, COUNT @D16956, 
            PER @D16955, PLU @D16954, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY, 
   [COORD @D16965, PRD @D16964, 
      AGR [CASE @D16963, COUNT @D16962, PER @D16961, PLU @D16960, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : BUY.

WORD cable : 
   [COORD @D16976, REFL @D16975, PRD @D16974, CASE @D16973, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : CABLE, 
   [COORD @D16981, REFL @D16980, COUNT @D16979, PRD @D16978, 
      CASE @D16977, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CABLE, 
   [COORD @D16984, 
      AGR [COUNT @D16983, PER @D16982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : CABLE, 
   [COORD @D16986, AGR [COUNT @D16985, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : CABLE, 
   [COORD @D16988, AGR [COUNT @D16987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : CABLE, 
   [COORD @D16992, AGR [COUNT @D16991, PER @D16990, PLU @D16989, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : CABLE, 
   [COORD @D16998, PAST @D16997, AGR [CASE @D16996, COUNT @D16995, 
            PER @D16994, PLU @D16993, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : CABLE, 
   [COORD @D17001, AGR [COUNT @D17000, PER @D16999, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : CABLE, 
   [COORD @D17003, AGR [COUNT @D17002, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : CABLE, 
   [COORD @D17005, AGR [COUNT @D17004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : CABLE, 
   [COORD @D17009, AGR [COUNT @D17008, PER @D17007, PLU @D17006, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : CABLE, 
   [COORD @D17015, PAST @D17014, AGR [CASE @D17013, COUNT @D17012, 
            PER @D17011, PLU @D17010, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_SFIN, ARITY 3] : CABLE, 
   [COORD @D17018, AGR [COUNT @D17017, PER @D17016, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : CABLE, 
   [COORD @D17020, AGR [COUNT @D17019, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : CABLE, 
   [COORD @D17022, AGR [COUNT @D17021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : CABLE, 
   [COORD @D17026, AGR [COUNT @D17025, PER @D17024, PLU @D17023, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : CABLE, 
   [COORD @D17032, PAST @D17031, AGR [CASE @D17030, COUNT @D17029, 
            PER @D17028, PLU @D17027, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : CABLE, 
   [COORD @D17035, AGR [COUNT @D17034, PER @D17033, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CABLE, 
   [COORD @D17037, AGR [COUNT @D17036, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CABLE, 
   [COORD @D17039, AGR [COUNT @D17038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CABLE, 
   [COORD @D17043, AGR [COUNT @D17042, PER @D17041, PLU @D17040, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CABLE, 
   [COORD @D17049, PAST @D17048, 
      AGR [CASE @D17047, COUNT @D17046, PER @D17045, PLU @D17044, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : CABLE, 
   [COORD @D17052, AGR [COUNT @D17051, PER @D17050, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CABLE, 
   [COORD @D17054, AGR [COUNT @D17053, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CABLE, 
   [COORD @D17056, AGR [COUNT @D17055, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CABLE, 
   [COORD @D17060, AGR [COUNT @D17059, PER @D17058, PLU @D17057, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CABLE, 
   [COORD @D17066, PAST @D17065, AGR [CASE @D17064, COUNT @D17063, 
            PER @D17062, PLU @D17061, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : CABLE, 
   [COORD @D17069, AGR [COUNT @D17068, PER @D17067, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CABLE, 
   [COORD @D17071, AGR [COUNT @D17070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CABLE, 
   [COORD @D17073, AGR [COUNT @D17072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CABLE, 
   [COORD @D17077, AGR [COUNT @D17076, PER @D17075, PLU @D17074, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CABLE, 
   [COORD @D17083, PAST @D17082, AGR [CASE @D17081, COUNT @D17080, 
            PER @D17079, PLU @D17078, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CABLE, 
   [COORD @D17086, AGR [COUNT @D17085, PER @D17084, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CABLE, 
   [COORD @D17088, AGR [COUNT @D17087, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CABLE, 
   [COORD @D17090, AGR [COUNT @D17089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CABLE, 
   [COORD @D17094, AGR [COUNT @D17093, PER @D17092, PLU @D17091, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CABLE, 
   [COORD @D17100, PAST @D17099, AGR [CASE @D17098, COUNT @D17097, 
            PER @D17096, PLU @D17095, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CABLE.

WORD cabled : 
   [COORD @D17115, AGR [CASE @D17114, NFORM @D17113, COUNT @D17112, 
            PER @D17111, PLU @D17110, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CABLE, 
   [COORD @D17120, AGR [CASE @D17119, COUNT @D17118, PER @D17117, 
            PLU @D17116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17125, AGR [CASE @D17124, COUNT @D17123, PER @D17122, 
            PLU @D17121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17130, AGR [CASE @D17129, COUNT @D17128, PER @D17127, 
            PLU @D17126, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CABLE, 
   [COORD @D17135, AGR [CASE @D17134, COUNT @D17133, PER @D17132, 
            PLU @D17131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17140, AGR [CASE @D17139, COUNT @D17138, PER @D17137, 
            PLU @D17136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17145, AGR [CASE @D17144, COUNT @D17143, PER @D17142, 
            PLU @D17141, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CABLE, 
   [COORD @D17150, AGR [CASE @D17149, COUNT @D17148, PER @D17147, 
            PLU @D17146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17155, AGR [CASE @D17154, COUNT @D17153, PER @D17152, 
            PLU @D17151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17160, AGR [CASE @D17159, COUNT @D17158, PER @D17157, 
            PLU @D17156, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17165, AGR [CASE @D17164, COUNT @D17163, PER @D17162, 
            PLU @D17161, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17170, AGR [CASE @D17169, COUNT @D17168, PER @D17167, 
            PLU @D17166, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17175, AGR [UB @D17174, VFORM @D17173, SUBJ @D17172, 
            FIN @D17171, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CABLE, 
   [COORD @D17180, AGR [CASE @D17179, COUNT @D17178, PER @D17177, 
            PLU @D17176, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17185, AGR [CASE @D17184, COUNT @D17183, PER @D17182, 
            PLU @D17181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17190, AGR [CASE @D17189, COUNT @D17188, PER @D17187, 
            PLU @D17186, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CABLE, 
   [COORD @D17195, AGR [CASE @D17194, COUNT @D17193, PER @D17192, 
            PLU @D17191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17200, AGR [CASE @D17199, COUNT @D17198, PER @D17197, 
            PLU @D17196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17205, AGR [CASE @D17204, COUNT @D17203, PER @D17202, 
            PLU @D17201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17210, AGR [CASE @D17209, COUNT @D17208, PER @D17207, 
            PLU @D17206, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CABLE.

WORD cables : 
   [COORD @D17224, DEMON @D17223, REFL @D17222, PRD @D17221, CASE 
         @D17220, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CABLE, 
   [COORD @D17229, DEMON @D17228, REFL @D17227, PRD @D17226, 
      CASE @D17225, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CABLE, 
   [COORD @D17231, 
      AGR [COUNT @D17230, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CABLE, 
   [COORD @D17233, 
      AGR [COUNT @D17232, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CABLE, 
   [COORD @D17235, 
      AGR [COUNT @D17234, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CABLE, 
   [COORD @D17237, 
      AGR [COUNT @D17236, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CABLE, 
   [COORD @D17239, 
      AGR [COUNT @D17238, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CABLE, 
   [COORD @D17241, 
      AGR [COUNT @D17240, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CABLE, 
   [COORD @D17243, 
      AGR [COUNT @D17242, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CABLE.

WORD cabling : 
   [COORD @D17256, PRD @D17255, AGR [CASE @D17254, COUNT @D17253, 
            PER @D17252, PLU @D17251, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17262, PRD @D17261, 
      AGR [CASE @D17260, COUNT @D17259, PER @D17258, PLU @D17257, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CABLE, 
   [COORD @D17268, PRD @D17267, AGR [CASE @D17266, COUNT @D17265, 
            PER @D17264, PLU @D17263, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17274, PRD @D17273, 
      AGR [CASE @D17272, COUNT @D17271, PER @D17270, PLU @D17269, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CABLE, 
   [COORD @D17280, PRD @D17279, AGR [CASE @D17278, COUNT @D17277, 
            PER @D17276, PLU @D17275, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CABLE, 
   [COORD @D17286, PRD @D17285, 
      AGR [CASE @D17284, COUNT @D17283, PER @D17282, PLU @D17281, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CABLE, 
   [COORD @D17292, PRD @D17291, AGR [CASE @D17290, COUNT @D17289, 
            PER @D17288, PLU @D17287, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CABLE.

WORD call : 
   [COORD @D17299, REFL @D17298, PRD @D17297, CASE @D17296, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CALL, 
   [COORD @D17304, REFL @D17303, COUNT @D17302, PRD @D17301, 
      CASE @D17300, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CALL, 
   [COORD @D17308, REFL @D17307, PRD @D17306, CASE @D17305, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : CALL, 
   [COORD @D17312, REFL @D17311, PRD @D17310, CASE @D17309, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF, COUNT +] : CALL, 
   [COORD @D17315, 
      AGR [COUNT @D17314, PER @D17313, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM ON_FOR, ARITY 3] : CALL, 
   [COORD @D17317, AGR [COUNT @D17316, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_FOR, ARITY 3] : CALL, 
   [COORD @D17319, AGR [COUNT @D17318, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_FOR, ARITY 3] : CALL, 
   [COORD @D17323, AGR [COUNT @D17322, PER @D17321, PLU @D17320, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_FOR, ARITY 3] : CALL, 
   [COORD @D17329, PAST @D17328, 
      AGR [CASE @D17327, COUNT @D17326, PER @D17325, PLU @D17324, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_FOR, 
      ARITY 3] : CALL, 
   [COORD @D17332, AGR [COUNT @D17331, PER @D17330, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : CALL, 
   [COORD @D17334, AGR [COUNT @D17333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : CALL, 
   [COORD @D17336, AGR [COUNT @D17335, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : CALL, 
   [COORD @D17340, AGR [COUNT @D17339, PER @D17338, PLU @D17337, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : CALL, 
   [COORD @D17346, PAST @D17345, 
      AGR [CASE @D17344, COUNT @D17343, PER @D17342, PLU @D17341, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, 
      PFORM ON, ARITY 3] : CALL, 
   [COORD @D17349, AGR [COUNT @D17348, PER @D17347, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, LAT -, 
      ARITY 3] : CALL, 
   [COORD @D17351, AGR [COUNT @D17350, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, LAT -, 
      ARITY 3] : CALL, 
   [COORD @D17353, AGR [COUNT @D17352, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, LAT -, 
      ARITY 3] : CALL, 
   [COORD @D17357, AGR [COUNT @D17356, PER @D17355, PLU @D17354, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      LAT -, ARITY 3] : CALL, 
   [COORD @D17363, PAST @D17362, AGR [CASE @D17361, COUNT @D17360, 
            PER @D17359, PLU @D17358, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, LAT -, ARITY 3] : CALL, 
   [COORD @D17366, AGR [COUNT @D17365, PER @D17364, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, LAT -, 
      ARITY 3] : CALL, 
   [COORD @D17368, AGR [COUNT @D17367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, LAT -, 
      ARITY 3] : CALL, 
   [COORD @D17370, AGR [COUNT @D17369, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, LAT -, 
      ARITY 3] : CALL, 
   [COORD @D17374, AGR [COUNT @D17373, PER @D17372, PLU @D17371, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      LAT -, ARITY 3] : CALL, 
   [COORD @D17380, PAST @D17379, AGR [CASE @D17378, COUNT @D17377, 
            PER @D17376, PLU @D17375, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, LAT -, ARITY 3] : CALL, 
   [COORD @D17383, AGR [COUNT @D17382, PER @D17381, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT BY, ARITY 2] : CALL, 
   [COORD @D17385, AGR [COUNT @D17384, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT BY, ARITY 2] : CALL, 
   [COORD @D17387, AGR [COUNT @D17386, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT BY, ARITY 2] : CALL, 
   [COORD @D17391, AGR [COUNT @D17390, PER @D17389, PLU @D17388, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT BY, ARITY 2] : CALL, 
   [COORD @D17397, PAST @D17396, AGR 
         [CASE @D17395, COUNT @D17394, PER @D17393, PLU @D17392, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT BY, 
      ARITY 2] : CALL, 
   [COORD @D17400, AGR [COUNT @D17399, PER @D17398, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : CALL, 
   [COORD @D17402, AGR [COUNT @D17401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : CALL, 
   [COORD @D17404, AGR [COUNT @D17403, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : CALL, 
   [COORD @D17408, AGR [COUNT @D17407, PER @D17406, PLU @D17405, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : CALL, 
   [COORD @D17414, PAST @D17413, 
      AGR [CASE @D17412, COUNT @D17411, PER @D17410, PLU @D17409, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : CALL, 
   [COORD @D17417, AGR [COUNT @D17416, PER @D17415, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17419, AGR [COUNT @D17418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17421, AGR [COUNT @D17420, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17425, AGR [COUNT @D17424, PER @D17423, PLU @D17422, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17431, PAST @D17430, 
      AGR [CASE @D17429, COUNT @D17428, PER @D17427, PLU @D17426, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : CALL, 
   [COORD @D17434, AGR [COUNT @D17433, PER @D17432, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BY, PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17436, AGR [COUNT @D17435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BY, PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17438, AGR [COUNT @D17437, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BY, PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17442, AGR [COUNT @D17441, PER @D17440, PLU @D17439, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT BY, PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17448, PAST @D17447, 
      AGR [CASE @D17446, COUNT @D17445, PER @D17444, PLU @D17443, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT BY, 
      PFORM FOR, ARITY 2] : CALL, 
   [COORD @D17451, AGR [COUNT @D17450, PER @D17449, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BY, PFORM AT, ARITY 2] : CALL, 
   [COORD @D17453, AGR [COUNT @D17452, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BY, PFORM AT, ARITY 2] : CALL, 
   [COORD @D17455, AGR [COUNT @D17454, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BY, PFORM AT, ARITY 2] : CALL, 
   [COORD @D17459, AGR [COUNT @D17458, PER @D17457, PLU @D17456, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT BY, PFORM AT, ARITY 2] : CALL, 
   [COORD @D17465, PAST @D17464, 
      AGR [CASE @D17463, COUNT @D17462, PER @D17461, PLU @D17460, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT BY, 
      PFORM AT, ARITY 2] : CALL, 
   [COORD @D17468, AGR [COUNT @D17467, PER @D17466, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CALL, 
   [COORD @D17470, AGR [COUNT @D17469, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CALL, 
   [COORD @D17472, AGR [COUNT @D17471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CALL, 
   [COORD @D17476, AGR [COUNT @D17475, PER @D17474, PLU @D17473, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : CALL, 
   [COORD @D17482, PAST @D17481, 
      AGR [CASE @D17480, COUNT @D17479, PER @D17478, PLU @D17477, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : CALL, 
   [COORD @D17485, AGR [COUNT @D17484, PER @D17483, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CALL, 
   [COORD @D17487, AGR [COUNT @D17486, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CALL, 
   [COORD @D17489, AGR [COUNT @D17488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CALL, 
   [COORD @D17493, AGR [COUNT @D17492, PER @D17491, PLU @D17490, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : CALL, 
   [COORD @D17499, PAST @D17498, 
      AGR [CASE @D17497, COUNT @D17496, PER @D17495, PLU @D17494, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : CALL, 
   [COORD @D17502, AGR [COUNT @D17501, PER @D17500, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CALL, 
   [COORD @D17504, AGR [COUNT @D17503, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CALL, 
   [COORD @D17506, AGR [COUNT @D17505, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CALL, 
   [COORD @D17510, AGR [COUNT @D17509, PER @D17508, PLU @D17507, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : CALL, 
   [COORD @D17516, PAST @D17515, 
      AGR [CASE @D17514, COUNT @D17513, PER @D17512, PLU @D17511, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : CALL, 
   [COORD @D17519, AGR [COUNT @D17518, PER @D17517, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : CALL, 
   [COORD @D17521, AGR [COUNT @D17520, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : CALL, 
   [COORD @D17523, AGR [COUNT @D17522, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : CALL, 
   [COORD @D17527, AGR [COUNT @D17526, PER @D17525, PLU @D17524, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : CALL, 
   [COORD @D17533, PAST @D17532, 
      AGR [CASE @D17531, COUNT @D17530, PER @D17529, PLU @D17528, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : CALL, 
   [COORD @D17536, AGR [COUNT @D17535, PER @D17534, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORTH, ARITY 2] : CALL, 
   [COORD @D17538, AGR [COUNT @D17537, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORTH, ARITY 2] : CALL, 
   [COORD @D17540, AGR [COUNT @D17539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORTH, ARITY 2] : CALL, 
   [COORD @D17544, AGR [COUNT @D17543, PER @D17542, PLU @D17541, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT FORTH, ARITY 2] : CALL, 
   [COORD @D17550, PAST @D17549, 
      AGR [CASE @D17548, COUNT @D17547, PER @D17546, PLU @D17545, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORTH, ARITY 2] : CALL, 
   [COORD @D17553, AGR [COUNT @D17552, PER @D17551, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CALL, 
   [COORD @D17555, AGR [COUNT @D17554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CALL, 
   [COORD @D17557, AGR [COUNT @D17556, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CALL, 
   [COORD @D17561, AGR [COUNT @D17560, PER @D17559, PLU @D17558, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : CALL, 
   [COORD @D17567, PAST @D17566, 
      AGR [CASE @D17565, COUNT @D17564, PER @D17563, PLU @D17562, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CALL, 
   [COORD @D17570, AGR [COUNT @D17569, PER @D17568, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CALL, 
   [COORD @D17572, AGR [COUNT @D17571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CALL, 
   [COORD @D17574, AGR [COUNT @D17573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CALL, 
   [COORD @D17578, AGR [COUNT @D17577, PER @D17576, PLU @D17575, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, ARITY 2] : CALL, 
   [COORD @D17584, PAST @D17583, 
      AGR [CASE @D17582, COUNT @D17581, PER @D17580, PLU @D17579, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CALL, 
   [COORD @D17587, AGR [COUNT @D17586, PER @D17585, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17589, AGR [COUNT @D17588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17591, AGR [COUNT @D17590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17595, AGR [COUNT @D17594, PER @D17593, PLU @D17592, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17601, PAST @D17600, AGR [CASE @D17599, COUNT @D17598, 
            PER @D17597, PLU @D17596, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : CALL, 
   [COORD @D17604, AGR [COUNT @D17603, PER @D17602, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17606, AGR [COUNT @D17605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17608, AGR [COUNT @D17607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17612, AGR [COUNT @D17611, PER @D17610, PLU @D17609, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, LAT -, ARITY 2] : CALL, 
   [COORD @D17618, PAST @D17617, AGR [CASE @D17616, COUNT @D17615, 
            PER @D17614, PLU @D17613, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, LAT -, ARITY 2] : CALL, 
   [COORD @D17621, AGR [COUNT @D17620, PER @D17619, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17623, AGR [COUNT @D17622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17625, AGR [COUNT @D17624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17629, AGR [COUNT @D17628, PER @D17627, PLU @D17626, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, LAT -, ARITY 2] : CALL, 
   [COORD @D17635, PAST @D17634, AGR [CASE @D17633, COUNT @D17632, 
            PER @D17631, PLU @D17630, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, LAT -, ARITY 2] : CALL, 
   [COORD @D17638, AGR [COUNT @D17637, PER @D17636, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17640, AGR [COUNT @D17639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17642, AGR [COUNT @D17641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17646, AGR [COUNT @D17645, PER @D17644, PLU @D17643, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, LAT -, ARITY 2] : CALL, 
   [COORD @D17652, PAST @D17651, AGR [CASE @D17650, COUNT @D17649, 
            PER @D17648, PLU @D17647, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, LAT -, ARITY 2] : CALL, 
   [COORD @D17655, AGR [COUNT @D17654, PER @D17653, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17657, AGR [COUNT @D17656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17659, AGR [COUNT @D17658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17663, AGR [COUNT @D17662, PER @D17661, PLU @D17660, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, LAT -, ARITY 2] : CALL, 
   [COORD @D17669, PAST @D17668, AGR [CASE @D17667, COUNT @D17666, 
            PER @D17665, PLU @D17664, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, LAT -, ARITY 2] : CALL, 
   [COORD @D17672, AGR [COUNT @D17671, PER @D17670, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AT, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17674, AGR [COUNT @D17673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AT, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17676, AGR [COUNT @D17675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, PFORM AT, 
      LAT -, ARITY 2] : CALL, 
   [COORD @D17680, AGR [COUNT @D17679, PER @D17678, PLU @D17677, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, LAT -, ARITY 2] : CALL, 
   [COORD @D17686, PAST @D17685, AGR [CASE @D17684, COUNT @D17683, 
            PER @D17682, PLU @D17681, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, LAT -, ARITY 2] : CALL, 
   [COORD @D17689, AGR [COUNT @D17688, PER @D17687, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OUT, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17691, AGR [COUNT @D17690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OUT, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17693, AGR [COUNT @D17692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OUT, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17697, AGR [COUNT @D17696, PER @D17695, PLU @D17694, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, 
      PRT OUT, LAT -, ARITY 2] : CALL, 
   [COORD @D17703, PAST @D17702, AGR [CASE @D17701, COUNT @D17700, 
            PER @D17699, PLU @D17698, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      COMPOUND NOT, PRT OUT, LAT -, ARITY 2] : CALL, 
   [COORD @D17706, AGR [COUNT @D17705, PER @D17704, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OFF, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17708, AGR [COUNT @D17707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OFF, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17710, AGR [COUNT @D17709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, PRT OFF, LAT -, 
      ARITY 2] : CALL, 
   [COORD @D17714, AGR [COUNT @D17713, PER @D17712, PLU @D17711, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, 
      PRT OFF, LAT -, ARITY 2] : CALL, 
   [COORD @D17720, PAST @D17719, AGR [CASE @D17718, COUNT @D17717, 
            PER @D17716, PLU @D17715, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      COMPOUND NOT, PRT OFF, LAT -, ARITY 2] : CALL, 
   [COORD @D17723, AGR [COUNT @D17722, PER @D17721, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CALL, 
   [COORD @D17725, AGR [COUNT @D17724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CALL, 
   [COORD @D17727, AGR [COUNT @D17726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CALL, 
   [COORD @D17731, AGR [COUNT @D17730, PER @D17729, PLU @D17728, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CALL, 
   [COORD @D17737, PAST @D17736, 
      AGR [CASE @D17735, COUNT @D17734, PER @D17733, PLU @D17732, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CALL, 
   [COORD @D17740, AGR [COUNT @D17739, PER @D17738, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CALL, 
   [COORD @D17742, AGR [COUNT @D17741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CALL, 
   [COORD @D17744, AGR [COUNT @D17743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CALL, 
   [COORD @D17748, AGR [COUNT @D17747, PER @D17746, PLU @D17745, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CALL, 
   [COORD @D17754, PAST @D17753, 
      AGR [CASE @D17752, COUNT @D17751, PER @D17750, PLU @D17749, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CALL, 
   [COORD @D17757, AGR [COUNT @D17756, PER @D17755, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CALL, 
   [COORD @D17759, AGR [COUNT @D17758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CALL, 
   [COORD @D17761, AGR [COUNT @D17760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CALL, 
   [COORD @D17765, AGR [COUNT @D17764, PER @D17763, PLU @D17762, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CALL, 
   [COORD @D17771, PAST @D17770, 
      AGR [CASE @D17769, COUNT @D17768, PER @D17767, PLU @D17766, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : CALL, 
   [COORD @D17774, AGR [COUNT @D17773, PER @D17772, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CALL, 
   [COORD @D17776, AGR [COUNT @D17775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CALL, 
   [COORD @D17778, AGR [COUNT @D17777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CALL, 
   [COORD @D17782, AGR [COUNT @D17781, PER @D17780, PLU @D17779, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CALL, 
   [COORD @D17788, PAST @D17787, 
      AGR [CASE @D17786, COUNT @D17785, PER @D17784, PLU @D17783, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : CALL, 
   [COORD @D17791, AGR [COUNT @D17790, PER @D17789, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : CALL, 
   [COORD @D17793, AGR [COUNT @D17792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : CALL, 
   [COORD @D17795, AGR [COUNT @D17794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : CALL, 
   [COORD @D17799, AGR [COUNT @D17798, PER @D17797, PLU @D17796, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : CALL, 
   [COORD @D17805, PAST @D17804, 
      AGR [CASE @D17803, COUNT @D17802, PER @D17801, PLU @D17800, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT FORTH, 
      ARITY 1] : CALL, 
   [COORD @D17808, AGR [COUNT @D17807, PER @D17806, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CALL, 
   [COORD @D17810, AGR [COUNT @D17809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CALL, 
   [COORD @D17812, AGR [COUNT @D17811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CALL, 
   [COORD @D17816, AGR [COUNT @D17815, PER @D17814, PLU @D17813, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CALL, 
   [COORD @D17822, PAST @D17821, 
      AGR [CASE @D17820, COUNT @D17819, PER @D17818, PLU @D17817, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : CALL, 
   [COORD @D17825, AGR [COUNT @D17824, PER @D17823, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : CALL, 
   [COORD @D17827, AGR [COUNT @D17826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : CALL, 
   [COORD @D17829, AGR [COUNT @D17828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : CALL, 
   [COORD @D17833, AGR [COUNT @D17832, PER @D17831, PLU @D17830, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : CALL, 
   [COORD @D17839, PAST @D17838, 
      AGR [CASE @D17837, COUNT @D17836, PER @D17835, PLU @D17834, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BY, 
      ARITY 1] : CALL, 
   [COORD @D17842, AGR [COUNT @D17841, PER @D17840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CALL, 
   [COORD @D17844, AGR [COUNT @D17843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CALL, 
   [COORD @D17846, AGR [COUNT @D17845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CALL, 
   [COORD @D17850, AGR [COUNT @D17849, PER @D17848, PLU @D17847, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CALL, 
   [COORD @D17856, PAST @D17855, 
      AGR [CASE @D17854, COUNT @D17853, PER @D17852, PLU @D17851, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, 
      ARITY 1] : CALL, 
   [COORD @D17859, AGR [COUNT @D17858, PER @D17857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : CALL, 
   [COORD @D17861, AGR [COUNT @D17860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : CALL, 
   [COORD @D17863, AGR [COUNT @D17862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : CALL, 
   [COORD @D17867, AGR [COUNT @D17866, PER @D17865, PLU @D17864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      LAT -, ARITY 1] : CALL, 
   [COORD @D17873, PAST @D17872, AGR [CASE @D17871, COUNT @D17870, 
            PER @D17869, PLU @D17868, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : CALL, 
   [COORD @D17876, AGR [COUNT @D17875, PER @D17874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      LAT -, ARITY 1] : CALL, 
   [COORD @D17878, AGR [COUNT @D17877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      LAT -, ARITY 1] : CALL, 
   [COORD @D17880, AGR [COUNT @D17879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      LAT -, ARITY 1] : CALL, 
   [COORD @D17884, AGR [COUNT @D17883, PER @D17882, PLU @D17881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, LAT -, ARITY 1] : CALL, 
   [COORD @D17890, PAST @D17889, AGR [CASE @D17888, COUNT @D17887, 
            PER @D17886, PLU @D17885, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, LAT -, ARITY 1] : CALL, 
   [COORD @D17893, AGR [COUNT @D17892, PER @D17891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      LAT -, ARITY 1] : CALL, 
   [COORD @D17895, AGR [COUNT @D17894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      LAT -, ARITY 1] : CALL, 
   [COORD @D17897, AGR [COUNT @D17896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      LAT -, ARITY 1] : CALL, 
   [COORD @D17901, AGR [COUNT @D17900, PER @D17899, PLU @D17898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, LAT -, ARITY 1] : CALL, 
   [COORD @D17907, PAST @D17906, AGR [CASE @D17905, COUNT @D17904, 
            PER @D17903, PLU @D17902, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, LAT -, ARITY 1] : CALL.

WORD called : 
   [COORD @D17919, AGR [CASE @D17918, COUNT @D17917, PER @D17916, 
            PLU @D17915, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17924, AGR [CASE @D17923, COUNT @D17922, PER @D17921, 
            PLU @D17920, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D17929, AGR [CASE @D17928, COUNT @D17927, PER @D17926, 
            PLU @D17925, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE PVERB_OE, PFORM ON, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17934, AGR [CASE @D17933, COUNT @D17932, PER @D17931, 
            PLU @D17930, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17939, 
      AGR [CASE @D17938, COUNT @D17937, PER @D17936, PLU @D17935, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D17944, AGR [CASE @D17943, COUNT @D17942, PER @D17941, 
            PLU @D17940, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CALL, 
   [COORD @D17949, AGR [CASE @D17948, COUNT @D17947, PER @D17946, 
            PLU @D17945, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17954, AGR [CASE @D17953, COUNT @D17952, PER @D17951, 
            PLU @D17950, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D17959, AGR [CASE @D17958, COUNT @D17957, PER @D17956, 
            PLU @D17955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17964, AGR [CASE @D17963, COUNT @D17962, PER @D17961, 
            PLU @D17960, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D17970, AGR [CASE @D17969, NFORM @D17968, COUNT @D17967, 
            PER @D17966, PLU @D17965, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CALL, 
   [COORD @D17975, AGR [CASE @D17974, COUNT @D17973, PER @D17972, 
            PLU @D17971, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17980, AGR [CASE @D17979, COUNT @D17978, PER @D17977, 
            PLU @D17976, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17985, AGR [CASE @D17984, COUNT @D17983, PER @D17982, 
            PLU @D17981, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D17990, AGR [CASE @D17989, COUNT @D17988, PER @D17987, 
            PLU @D17986, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D17995, AGR [CASE @D17994, COUNT @D17993, PER @D17992, 
            PLU @D17991, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18000, AGR [CASE @D17999, COUNT @D17998, PER @D17997, 
            PLU @D17996, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18005, AGR [CASE @D18004, COUNT @D18003, PER @D18002, 
            PLU @D18001, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18010, AGR [CASE @D18009, COUNT @D18008, PER @D18007, 
            PLU @D18006, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18015, AGR [CASE @D18014, COUNT @D18013, PER @D18012, 
            PLU @D18011, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18020, AGR [CASE @D18019, COUNT @D18018, PER @D18017, 
            PLU @D18016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BY, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18025, AGR [CASE @D18024, COUNT @D18023, PER @D18022, 
            PLU @D18021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BY, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18030, AGR [CASE @D18029, COUNT @D18028, PER @D18027, 
            PLU @D18026, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BY, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18035, AGR [CASE @D18034, COUNT @D18033, PER @D18032, 
            PLU @D18031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BY, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18040, AGR [CASE @D18039, COUNT @D18038, PER @D18037, 
            PLU @D18036, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18045, AGR [CASE @D18044, COUNT @D18043, PER @D18042, 
            PLU @D18041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18050, AGR [CASE @D18049, COUNT @D18048, PER @D18047, 
            PLU @D18046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18055, AGR [CASE @D18054, COUNT @D18053, PER @D18052, 
            PLU @D18051, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18060, AGR [CASE @D18059, COUNT @D18058, PER @D18057, 
            PLU @D18056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18065, AGR [CASE @D18064, COUNT @D18063, PER @D18062, 
            PLU @D18061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18070, AGR [CASE @D18069, COUNT @D18068, PER @D18067, 
            PLU @D18066, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18075, AGR [CASE @D18074, COUNT @D18073, PER @D18072, 
            PLU @D18071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18080, AGR [CASE @D18079, COUNT @D18078, PER @D18077, 
            PLU @D18076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18085, AGR [CASE @D18084, COUNT @D18083, PER @D18082, 
            PLU @D18081, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18090, AGR [CASE @D18089, COUNT @D18088, PER @D18087, 
            PLU @D18086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18095, AGR [CASE @D18094, COUNT @D18093, PER @D18092, 
            PLU @D18091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18100, AGR [CASE @D18099, COUNT @D18098, PER @D18097, 
            PLU @D18096, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORTH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18105, AGR [CASE @D18104, COUNT @D18103, PER @D18102, 
            PLU @D18101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORTH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18110, AGR [CASE @D18109, COUNT @D18108, PER @D18107, 
            PLU @D18106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORTH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18115, AGR [CASE @D18114, COUNT @D18113, PER @D18112, 
            PLU @D18111, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18120, AGR [CASE @D18119, COUNT @D18118, PER @D18117, 
            PLU @D18116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18125, AGR [CASE @D18124, COUNT @D18123, PER @D18122, 
            PLU @D18121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18130, AGR [CASE @D18129, COUNT @D18128, PER @D18127, 
            PLU @D18126, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18135, AGR [CASE @D18134, COUNT @D18133, PER @D18132, 
            PLU @D18131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18140, AGR [CASE @D18139, COUNT @D18138, PER @D18137, 
            PLU @D18136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18145, AGR [CASE @D18144, COUNT @D18143, PER @D18142, 
            PLU @D18141, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CALL, 
   [COORD @D18150, AGR [CASE @D18149, COUNT @D18148, PER @D18147, 
            PLU @D18146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18155, AGR [CASE @D18154, COUNT @D18153, PER @D18152, 
            PLU @D18151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18160, AGR [CASE @D18159, COUNT @D18158, PER @D18157, 
            PLU @D18156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18165, AGR [CASE @D18164, COUNT @D18163, PER @D18162, 
            PLU @D18161, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18170, AGR [CASE @D18169, COUNT @D18168, PER @D18167, 
            PLU @D18166, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18175, AGR [CASE @D18174, COUNT @D18173, PER @D18172, 
            PLU @D18171, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18180, AGR [CASE @D18179, COUNT @D18178, PER @D18177, 
            PLU @D18176, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18185, AGR [CASE @D18184, COUNT @D18183, PER @D18182, 
            PLU @D18181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18190, AGR [CASE @D18189, COUNT @D18188, PER @D18187, 
            PLU @D18186, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18195, AGR [CASE @D18194, COUNT @D18193, PER @D18192, 
            PLU @D18191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18200, AGR [CASE @D18199, COUNT @D18198, PER @D18197, 
            PLU @D18196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18205, AGR [CASE @D18204, COUNT @D18203, PER @D18202, 
            PLU @D18201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18210, AGR [CASE @D18209, COUNT @D18208, PER @D18207, 
            PLU @D18206, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18215, AGR [CASE @D18214, COUNT @D18213, PER @D18212, 
            PLU @D18211, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18220, AGR [CASE @D18219, COUNT @D18218, PER @D18217, 
            PLU @D18216, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18225, AGR [CASE @D18224, COUNT @D18223, PER @D18222, 
            PLU @D18221, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18230, AGR [CASE @D18229, COUNT @D18228, PER @D18227, 
            PLU @D18226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18235, AGR [CASE @D18234, COUNT @D18233, PER @D18232, 
            PLU @D18231, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18240, AGR [CASE @D18239, COUNT @D18238, PER @D18237, 
            PLU @D18236, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18245, AGR [CASE @D18244, COUNT @D18243, PER @D18242, 
            PLU @D18241, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18250, AGR [CASE @D18249, COUNT @D18248, PER @D18247, 
            PLU @D18246, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18255, AGR [CASE @D18254, COUNT @D18253, PER @D18252, 
            PLU @D18251, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18260, AGR [CASE @D18259, COUNT @D18258, PER @D18257, 
            PLU @D18256, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18265, AGR [CASE @D18264, COUNT @D18263, PER @D18262, 
            PLU @D18261, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18270, AGR [CASE @D18269, COUNT @D18268, PER @D18267, 
            PLU @D18266, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18275, AGR [CASE @D18274, COUNT @D18273, PER @D18272, 
            PLU @D18271, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18280, AGR [CASE @D18279, COUNT @D18278, PER @D18277, 
            PLU @D18276, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18285, AGR [CASE @D18284, COUNT @D18283, PER @D18282, 
            PLU @D18281, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18290, AGR [CASE @D18289, COUNT @D18288, PER @D18287, 
            PLU @D18286, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18295, AGR [CASE @D18294, COUNT @D18293, PER @D18292, 
            PLU @D18291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18300, AGR [CASE @D18299, COUNT @D18298, PER @D18297, 
            PLU @D18296, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18305, AGR [CASE @D18304, COUNT @D18303, PER @D18302, 
            PLU @D18301, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18310, AGR [CASE @D18309, COUNT @D18308, PER @D18307, 
            PLU @D18306, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18315, AGR [CASE @D18314, COUNT @D18313, PER @D18312, 
            PLU @D18311, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18320, AGR [CASE @D18319, COUNT @D18318, PER @D18317, 
            PLU @D18316, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18325, AGR [CASE @D18324, COUNT @D18323, PER @D18322, 
            PLU @D18321, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18330, AGR [CASE @D18329, COUNT @D18328, PER @D18327, 
            PLU @D18326, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18335, AGR [CASE @D18334, COUNT @D18333, PER @D18332, 
            PLU @D18331, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL, 
   [COORD @D18340, AGR [CASE @D18339, COUNT @D18338, PER @D18337, 
            PLU @D18336, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18345, AGR [CASE @D18344, COUNT @D18343, PER @D18342, 
            PLU @D18341, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CALL.

WORD calling : 
   [COORD @D18362, REFL @D18361, PRD @D18360, CASE @D18359, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CALLING, 
   [COORD @D18367, REFL @D18366, COUNT @D18365, PRD @D18364, 
      CASE @D18363, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CALLING, 
   [COORD @D18371, REFL @D18370, PRD @D18369, CASE @D18368, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : CALLING, 
   [COORD @D18375, REFL @D18374, PRD @D18373, CASE @D18372, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : CALLING, 
   [COORD @D18379, REFL @D18378, PRD @D18377, CASE @D18376, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF, COUNT +] : CALLING, 
   [COORD @D18385, PRD @D18384, 
      AGR [CASE @D18383, COUNT @D18382, PER @D18381, PLU @D18380, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CALL, 
   [COORD @D18391, PRD @D18390, AGR [CASE @D18389, COUNT @D18388, 
            PER @D18387, PLU @D18386, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18397, PRD @D18396, 
      AGR [CASE @D18395, COUNT @D18394, PER @D18393, PLU @D18392, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CALL, 
   [COORD @D18403, PRD @D18402, AGR [CASE @D18401, COUNT @D18400, 
            PER @D18399, PLU @D18398, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18409, PRD @D18408, 
      AGR [CASE @D18407, COUNT @D18406, PER @D18405, PLU @D18404, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18415, PRD @D18414, AGR [CASE @D18413, COUNT @D18412, 
            PER @D18411, PLU @D18410, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18421, PRD @D18420, 
      AGR [CASE @D18419, COUNT @D18418, PER @D18417, PLU @D18416, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CALL, 
   [COORD @D18427, PRD @D18426, AGR [CASE @D18425, COUNT @D18424, 
            PER @D18423, PLU @D18422, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BY, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18433, PRD @D18432, 
      AGR [CASE @D18431, COUNT @D18430, PER @D18429, PLU @D18428, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT BY, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CALL, 
   [COORD @D18439, PRD @D18438, AGR [CASE @D18437, COUNT @D18436, 
            PER @D18435, PLU @D18434, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18445, PRD @D18444, 
      AGR [CASE @D18443, COUNT @D18442, PER @D18441, PLU @D18440, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18451, PRD @D18450, AGR [CASE @D18449, COUNT @D18448, 
            PER @D18447, PLU @D18446, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18457, PRD @D18456, 
      AGR [CASE @D18455, COUNT @D18454, PER @D18453, PLU @D18452, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18463, PRD @D18462, AGR [CASE @D18461, COUNT @D18460, 
            PER @D18459, PLU @D18458, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORTH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18469, PRD @D18468, 
      AGR [CASE @D18467, COUNT @D18466, PER @D18465, PLU @D18464, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18475, PRD @D18474, AGR [CASE @D18473, COUNT @D18472, 
            PER @D18471, PLU @D18470, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18481, PRD @D18480, 
      AGR [CASE @D18479, COUNT @D18478, PER @D18477, PLU @D18476, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CALL, 
   [COORD @D18487, PRD @D18486, AGR [CASE @D18485, COUNT @D18484, 
            PER @D18483, PLU @D18482, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18493, PRD @D18492, 
      AGR [CASE @D18491, COUNT @D18490, PER @D18489, PLU @D18488, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18499, PRD @D18498, AGR [CASE @D18497, COUNT @D18496, 
            PER @D18495, PLU @D18494, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18505, PRD @D18504, 
      AGR [CASE @D18503, COUNT @D18502, PER @D18501, PLU @D18500, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18511, PRD @D18510, AGR [CASE @D18509, COUNT @D18508, 
            PER @D18507, PLU @D18506, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18517, PRD @D18516, 
      AGR [CASE @D18515, COUNT @D18514, PER @D18513, PLU @D18512, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18523, PRD @D18522, AGR [CASE @D18521, COUNT @D18520, 
            PER @D18519, PLU @D18518, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18529, PRD @D18528, 
      AGR [CASE @D18527, COUNT @D18526, PER @D18525, PLU @D18524, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18535, PRD @D18534, AGR [CASE @D18533, COUNT @D18532, 
            PER @D18531, PLU @D18530, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18541, PRD @D18540, 
      AGR [CASE @D18539, COUNT @D18538, PER @D18537, PLU @D18536, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18547, PRD @D18546, AGR [CASE @D18545, COUNT @D18544, 
            PER @D18543, PLU @D18542, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18553, PRD @D18552, 
      AGR [CASE @D18551, COUNT @D18550, PER @D18549, PLU @D18548, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18559, PRD @D18558, AGR [CASE @D18557, COUNT @D18556, 
            PER @D18555, PLU @D18554, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18565, PRD @D18564, 
      AGR [CASE @D18563, COUNT @D18562, PER @D18561, PLU @D18560, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL, 
   [COORD @D18571, PRD @D18570, AGR [CASE @D18569, COUNT @D18568, 
            PER @D18567, PLU @D18566, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18577, PRD @D18576, 
      AGR [CASE @D18575, COUNT @D18574, PER @D18573, PLU @D18572, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CALL, 
   [COORD @D18583, PRD @D18582, AGR [CASE @D18581, COUNT @D18580, 
            PER @D18579, PLU @D18578, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CALL, 
   [COORD @D18589, PRD @D18588, 
      AGR [CASE @D18587, COUNT @D18586, PER @D18585, PLU @D18584, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CALL.

WORD callings : 
   [COORD @D18610, DEMON @D18609, REFL @D18608, PRD @D18607, 
      CASE @D18606, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CALLING, 
   
   [COORD @D18615, DEMON @D18614, REFL @D18613, PRD @D18612, CASE 
      @D18611, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CALLING, 
   
   [COORD @D18620, DEMON @D18619, REFL @D18618, PRD @D18617, CASE 
      @D18616, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CALLING, 
   [COORD @D18625, DEMON @D18624, REFL @D18623, PRD @D18622, 
      CASE @D18621, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CALLING, 
   [COORD @D18630, DEMON @D18629, REFL @D18628, PRD @D18627, 
      CASE @D18626, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CALLING.

WORD calls : 
   [COORD @D18642, DEMON @D18641, REFL @D18640, PRD @D18639, CASE 
         @D18638, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CALL, 
   [COORD @D18647, DEMON @D18646, REFL @D18645, PRD @D18644, 
      CASE @D18643, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CALL, 
   [COORD @D18652, DEMON @D18651, REFL @D18650, PRD @D18649, 
      CASE @D18648, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CALL, 
   [COORD @D18657, DEMON @D18656, REFL @D18655, PRD @D18654, CASE 
         @D18653, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CALL, 
   [COORD @D18659, 
      AGR [COUNT @D18658, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CALL, 
   [COORD @D18661, AGR [COUNT @D18660, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CALL, 
   [COORD @D18663, AGR [COUNT @D18662, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18665, 
      AGR [COUNT @D18664, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18667, 
      AGR [COUNT @D18666, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18669, 
      AGR [COUNT @D18668, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18671, 
      AGR [COUNT @D18670, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18673, 
      AGR [COUNT @D18672, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BY, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CALL, 
   [COORD @D18675, AGR [COUNT @D18674, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BY, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CALL, 
   [COORD @D18677, AGR [COUNT @D18676, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18679, 
      AGR [COUNT @D18678, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18681, 
      AGR [COUNT @D18680, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18683, 
      AGR [COUNT @D18682, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18685, 
      AGR [COUNT @D18684, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18687, 
      AGR [COUNT @D18686, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18689, 
      AGR [COUNT @D18688, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18691, 
      AGR [COUNT @D18690, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18693, 
      AGR [COUNT @D18692, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18695, 
      AGR [COUNT @D18694, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18697, 
      AGR [COUNT @D18696, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18699, 
      AGR [COUNT @D18698, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18701, 
      AGR [COUNT @D18700, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18703, 
      AGR [COUNT @D18702, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18705, 
      AGR [COUNT @D18704, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18707, 
      AGR [COUNT @D18706, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18709, 
      AGR [COUNT @D18708, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18711, 
      AGR [COUNT @D18710, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18713, 
      AGR [COUNT @D18712, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18715, 
      AGR [COUNT @D18714, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18717, 
      AGR [COUNT @D18716, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18719, 
      AGR [COUNT @D18718, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18721, 
      AGR [COUNT @D18720, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18723, 
      AGR [COUNT @D18722, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18725, 
      AGR [COUNT @D18724, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL, 
   [COORD @D18727, 
      AGR [COUNT @D18726, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CALL.

WORD candidate : 
   [COORD @D18736, REFL @D18735, PRD @D18734, CASE @D18733, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CANDIDATE.

WORD candidates : 
   [COORD @D18747, DEMON @D18746, REFL @D18745, PRD @D18744, 
      CASE @D18743, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CANDIDATE.

WORD cap : 
   [COORD @D18754, REFL @D18753, PRD @D18752, CASE @D18751, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CAP, 
   [COORD @D18757, 
      AGR [COUNT @D18756, PER @D18755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : CAP, 
   
   [COORD @D18759, AGR [COUNT @D18758, N +, V -, BAR 2, NFORM NORM, CASE 
            NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, 
      V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CAP, 
   [COORD @D18761, AGR [COUNT @D18760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CAP, 
   [COORD @D18765, AGR [COUNT @D18764, PER @D18763, PLU @D18762, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CAP, 
   [COORD @D18771, PAST @D18770, AGR [CASE @D18769, COUNT @D18768, 
            PER @D18767, PLU @D18766, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CAP.

WORD capped : 
   [COORD @D18781, AGR [CASE @D18780, COUNT @D18779, PER @D18778, 
            PLU @D18777, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CAP, 
   [COORD @D18786, AGR [CASE @D18785, COUNT @D18784, PER @D18783, 
            PLU @D18782, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CAP, 
   [COORD @D18791, AGR [CASE @D18790, COUNT @D18789, PER @D18788, 
            PLU @D18787, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CAP.

WORD capping : 
   [COORD @D18802, PRD @D18801, AGR [CASE @D18800, COUNT @D18799, 
            PER @D18798, PLU @D18797, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CAP.

WORD caps : 
   [COORD @D18812, DEMON @D18811, REFL @D18810, PRD @D18809, CASE 
         @D18808, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CAP, 
   [COORD @D18814, 
      AGR [COUNT @D18813, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CAP.

WORD care : 
   [COORD @D18824, REFL @D18823, COUNT @D18822, PRD @D18821, CASE 
         @D18820, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CARE, 
   [COORD @D18827, 
      AGR [COUNT @D18826, PER @D18825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, ARITY 2] : 
   CARE, 
   [COORD @D18829, AGR [COUNT @D18828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CARE, 
   [COORD @D18831, AGR [COUNT @D18830, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CARE, 
   [COORD @D18835, AGR [COUNT @D18834, PER @D18833, PLU @D18832, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : CARE, 
   [COORD @D18841, PAST @D18840, AGR [CASE @D18839, COUNT @D18838, 
            PER @D18837, PLU @D18836, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : CARE, 
   [COORD @D18844, AGR [COUNT @D18843, PER @D18842, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CARE, 
   [COORD @D18846, AGR [COUNT @D18845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CARE, 
   [COORD @D18848, AGR [COUNT @D18847, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CARE, 
   [COORD @D18852, AGR [COUNT @D18851, PER @D18850, PLU @D18849, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CARE, 
   [COORD @D18858, PAST @D18857, AGR [CASE @D18856, COUNT @D18855, 
            PER @D18854, PLU @D18853, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : CARE, 
   [COORD @D18861, AGR [COUNT @D18860, PER @D18859, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CARE, 
   [COORD @D18863, AGR [COUNT @D18862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CARE, 
   [COORD @D18865, AGR [COUNT @D18864, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CARE, 
   [COORD @D18869, AGR [COUNT @D18868, PER @D18867, PLU @D18866, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : CARE, 
   [COORD @D18875, PAST @D18874, 
      AGR [CASE @D18873, COUNT @D18872, PER @D18871, PLU @D18870, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : CARE, 
   [COORD @D18878, AGR [COUNT @D18877, PER @D18876, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : CARE, 
   [COORD @D18880, AGR [COUNT @D18879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : CARE, 
   [COORD @D18882, AGR [COUNT @D18881, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : CARE, 
   [COORD @D18886, AGR [COUNT @D18885, PER @D18884, PLU @D18883, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : CARE, 
   [COORD @D18892, PAST @D18891, 
      AGR [CASE @D18890, COUNT @D18889, PER @D18888, PLU @D18887, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      ARITY 2] : CARE, 
   [COORD @D18895, AGR [COUNT @D18894, PER @D18893, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CARE, 
   [COORD @D18897, AGR [COUNT @D18896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CARE, 
   [COORD @D18899, AGR [COUNT @D18898, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CARE, 
   [COORD @D18903, AGR [COUNT @D18902, PER @D18901, PLU @D18900, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CARE, 
   [COORD @D18909, PAST @D18908, AGR [CASE @D18907, COUNT @D18906, 
            PER @D18905, PLU @D18904, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CARE.

WORD cared : 
   [COORD @D18921, AGR [CASE @D18920, COUNT @D18919, PER @D18918, 
            PLU @D18917, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D18926, AGR [CASE @D18925, COUNT @D18924, PER @D18923, 
            PLU @D18922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARE, 
   [COORD @D18931, AGR [CASE @D18930, COUNT @D18929, PER @D18928, 
            PLU @D18927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D18936, AGR [CASE @D18935, COUNT @D18934, PER @D18933, 
            PLU @D18932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARE, 
   [COORD @D18941, AGR [CASE @D18940, COUNT @D18939, PER @D18938, 
            PLU @D18937, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D18946, AGR [CASE @D18945, COUNT @D18944, PER @D18943, 
            PLU @D18942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARE, 
   [COORD @D18951, AGR [CASE @D18950, COUNT @D18949, PER @D18948, 
            PLU @D18947, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D18956, AGR [CASE @D18955, COUNT @D18954, PER @D18953, 
            PLU @D18952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D18961, AGR [CASE @D18960, COUNT @D18959, PER @D18958, 
            PLU @D18957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARE, 
   [COORD @D18966, AGR [CASE @D18965, COUNT @D18964, PER @D18963, 
            PLU @D18962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D18971, AGR [CASE @D18970, COUNT @D18969, PER @D18968, 
            PLU @D18967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARE.

WORD cares : 
   [COORD @D18983, DEMON @D18982, REFL @D18981, PRD @D18980, CASE 
         @D18979, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CARE, 
   [COORD @D18985, 
      AGR [COUNT @D18984, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARE, 
   [COORD @D18987, 
      AGR [COUNT @D18986, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARE, 
   [COORD @D18989, 
      AGR [COUNT @D18988, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARE, 
   [COORD @D18991, 
      AGR [COUNT @D18990, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARE, 
   [COORD @D18993, 
      AGR [COUNT @D18992, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARE.

WORD caring : 
   [COORD @D19004, PRD @D19003, AGR [CASE @D19002, COUNT @D19001, 
            PER @D19000, PLU @D18999, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D19010, PRD @D19009, 
      AGR [CASE @D19008, COUNT @D19007, PER @D19006, PLU @D19005, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CARE, 
   [COORD @D19016, PRD @D19015, AGR [CASE @D19014, COUNT @D19013, 
            PER @D19012, PLU @D19011, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARE, 
   [COORD @D19022, PRD @D19021, 
      AGR [CASE @D19020, COUNT @D19019, PER @D19018, PLU @D19017, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARE, 
   [COORD @D19028, PRD @D19027, AGR [CASE @D19026, COUNT @D19025, 
            PER @D19024, PLU @D19023, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARE.

WORD carried : 
   [COORD @D19040, AGR [CASE @D19039, COUNT @D19038, PER @D19037, 
            PLU @D19036, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19045, AGR [CASE @D19044, COUNT @D19043, PER @D19042, 
            PLU @D19041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19050, AGR [CASE @D19049, COUNT @D19048, PER @D19047, 
            PLU @D19046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19055, AGR [CASE @D19054, COUNT @D19053, PER @D19052, 
            PLU @D19051, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19060, AGR [CASE @D19059, COUNT @D19058, PER @D19057, 
            PLU @D19056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19065, 
      AGR [CASE @D19064, COUNT @D19063, PER @D19062, PLU @D19061, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19070, AGR [CASE @D19069, COUNT @D19068, PER @D19067, 
            PLU @D19066, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19075, AGR [CASE @D19074, COUNT @D19073, PER @D19072, 
            PLU @D19071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19080, AGR [CASE @D19079, COUNT @D19078, PER @D19077, 
            PLU @D19076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19085, AGR [CASE @D19084, COUNT @D19083, PER @D19082, 
            PLU @D19081, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADVP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19090, AGR [CASE @D19089, COUNT @D19088, PER @D19087, 
            PLU @D19086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19095, AGR [CASE @D19094, COUNT @D19093, PER @D19092, 
            PLU @D19091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19100, AGR [CASE @D19099, COUNT @D19098, PER @D19097, 
            PLU @D19096, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19105, AGR [CASE @D19104, COUNT @D19103, PER @D19102, 
            PLU @D19101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19110, AGR [CASE @D19109, COUNT @D19108, PER @D19107, 
            PLU @D19106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19115, AGR [CASE @D19114, COUNT @D19113, PER @D19112, 
            PLU @D19111, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT ON, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19120, AGR [CASE @D19119, COUNT @D19118, PER @D19117, 
            PLU @D19116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT ON, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19125, 
      AGR [CASE @D19124, COUNT @D19123, PER @D19122, PLU @D19121, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT ON, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19130, AGR [CASE @D19129, COUNT @D19128, PER @D19127, 
            PLU @D19126, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT THROUGH, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19135, 
      AGR [CASE @D19134, COUNT @D19133, PER @D19132, PLU @D19131, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT THROUGH, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19140, AGR [CASE @D19139, COUNT @D19138, PER @D19137, 
            PLU @D19136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19145, 
      AGR [CASE @D19144, COUNT @D19143, PER @D19142, PLU @D19141, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19150, AGR [CASE @D19149, COUNT @D19148, PER @D19147, 
            PLU @D19146, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19155, AGR [CASE @D19154, COUNT @D19153, PER @D19152, 
            PLU @D19151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19160, AGR [CASE @D19159, COUNT @D19158, PER @D19157, 
            PLU @D19156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19165, AGR [CASE @D19164, COUNT @D19163, PER @D19162, 
            PLU @D19161, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19170, AGR [CASE @D19169, COUNT @D19168, PER @D19167, 
            PLU @D19166, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19175, AGR [CASE @D19174, COUNT @D19173, PER @D19172, 
            PLU @D19171, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19180, AGR [CASE @D19179, COUNT @D19178, PER @D19177, 
            PLU @D19176, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19185, AGR [CASE @D19184, COUNT @D19183, PER @D19182, 
            PLU @D19181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19190, AGR [CASE @D19189, COUNT @D19188, PER @D19187, 
            PLU @D19186, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19195, AGR [CASE @D19194, COUNT @D19193, PER @D19192, 
            PLU @D19191, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19200, AGR [CASE @D19199, COUNT @D19198, PER @D19197, 
            PLU @D19196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19205, AGR [CASE @D19204, COUNT @D19203, PER @D19202, 
            PLU @D19201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19210, AGR [CASE @D19209, COUNT @D19208, PER @D19207, 
            PLU @D19206, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORWARD, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19215, AGR [CASE @D19214, COUNT @D19213, PER @D19212, 
            PLU @D19211, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORWARD, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19220, AGR [CASE @D19219, COUNT @D19218, PER @D19217, 
            PLU @D19216, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORWARD, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19225, AGR [CASE @D19224, COUNT @D19223, PER @D19222, 
            PLU @D19221, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19230, AGR [CASE @D19229, COUNT @D19228, PER @D19227, 
            PLU @D19226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19235, AGR [CASE @D19234, COUNT @D19233, PER @D19232, 
            PLU @D19231, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19240, AGR [CASE @D19239, COUNT @D19238, PER @D19237, 
            PLU @D19236, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19245, AGR [CASE @D19244, COUNT @D19243, PER @D19242, 
            PLU @D19241, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19250, AGR [CASE @D19249, COUNT @D19248, PER @D19247, 
            PLU @D19246, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19255, AGR [CASE @D19254, COUNT @D19253, PER @D19252, 
            PLU @D19251, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19260, AGR [CASE @D19259, COUNT @D19258, PER @D19257, 
            PLU @D19256, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19265, AGR [CASE @D19264, COUNT @D19263, PER @D19262, 
            PLU @D19261, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19270, AGR [CASE @D19269, COUNT @D19268, PER @D19267, 
            PLU @D19266, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19275, AGR [CASE @D19274, COUNT @D19273, PER @D19272, 
            PLU @D19271, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19280, AGR [CASE @D19279, COUNT @D19278, PER @D19277, 
            PLU @D19276, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19285, AGR [CASE @D19284, COUNT @D19283, PER @D19282, 
            PLU @D19281, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19290, AGR [CASE @D19289, COUNT @D19288, PER @D19287, 
            PLU @D19286, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19295, AGR [CASE @D19294, COUNT @D19293, PER @D19292, 
            PLU @D19291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19297, AGR @D19296, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19299, AGR @D19298, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19304, AGR [CASE @D19303, COUNT @D19302, PER @D19301, 
            PLU @D19300, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19309, AGR [CASE @D19308, COUNT @D19307, PER @D19306, 
            PLU @D19305, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19314, AGR [CASE @D19313, COUNT @D19312, PER @D19311, 
            PLU @D19310, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19319, AGR [CASE @D19318, COUNT @D19317, PER @D19316, 
            PLU @D19315, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19324, AGR [CASE @D19323, COUNT @D19322, PER @D19321, 
            PLU @D19320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORWARD, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19329, AGR [CASE @D19328, COUNT @D19327, PER @D19326, 
            PLU @D19325, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORWARD, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19334, AGR [CASE @D19333, COUNT @D19332, PER @D19331, 
            PLU @D19330, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19339, AGR [CASE @D19338, COUNT @D19337, PER @D19336, 
            PLU @D19335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19344, AGR [CASE @D19343, COUNT @D19342, PER @D19341, 
            PLU @D19340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19349, AGR [CASE @D19348, COUNT @D19347, PER @D19346, 
            PLU @D19345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19354, AGR [CASE @D19353, COUNT @D19352, PER @D19351, 
            PLU @D19350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19359, AGR [CASE @D19358, COUNT @D19357, PER @D19356, 
            PLU @D19355, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CARRY.

WORD carries : 
   [COORD @D19368, AGR [COUNT @D19367, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM THROUGH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19370, AGR [COUNT @D19369, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19372, AGR [COUNT @D19371, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19374, 
      AGR [COUNT @D19373, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19376, 
      AGR [COUNT @D19375, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19378, 
      AGR [COUNT @D19377, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT ON, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CARRY, 
   [COORD @D19380, AGR [COUNT @D19379, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT THROUGH, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CARRY, 
   [COORD @D19382, AGR [COUNT @D19381, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CARRY, 
   [COORD @D19384, AGR [COUNT @D19383, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19386, 
      AGR [COUNT @D19385, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19388, 
      AGR [COUNT @D19387, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19390, 
      AGR [COUNT @D19389, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19392, 
      AGR [COUNT @D19391, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT FORWARD, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19394, 
      AGR [COUNT @D19393, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19396, 
      AGR [COUNT @D19395, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19398, 
      AGR [COUNT @D19397, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19400, 
      AGR [COUNT @D19399, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CARRY, 
   [COORD @D19402, AGR [COUNT @D19401, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19404, 
      AGR [COUNT @D19403, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19408, 
      AGR [CASE @D19407, NFORM @D19406, COUNT @D19405, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19413, 
      AGR [UB @D19412, VFORM @D19411, SUBJ @D19410, FIN @D19409, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19415, 
      AGR [COUNT @D19414, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19417, 
      AGR [COUNT @D19416, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19419, 
      AGR [COUNT @D19418, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT FORWARD, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CARRY, 
   [COORD @D19421, AGR [COUNT @D19420, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19423, 
      AGR [COUNT @D19422, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY, 
   [COORD @D19425, 
      AGR [COUNT @D19424, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARRY.

WORD carry : 
   [COORD @D19434, AGR [COUNT @D19433, PER @D19432, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : CARRY, 
   [COORD @D19436, AGR [COUNT @D19435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : CARRY, 
   [COORD @D19438, AGR [COUNT @D19437, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : CARRY, 
   [COORD @D19442, AGR [COUNT @D19441, PER @D19440, PLU @D19439, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : CARRY, 
   [COORD @D19448, PAST @D19447, 
      AGR [CASE @D19446, COUNT @D19445, PER @D19444, PLU @D19443, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM THROUGH, 
      ARITY 3] : CARRY, 
   [COORD @D19451, AGR [COUNT @D19450, PER @D19449, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, PFORM TO, ARITY 3] : CARRY, 
   [COORD @D19453, 
      AGR [COUNT @D19452, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT BACK, 
      PFORM TO, ARITY 3] : CARRY, 
   [COORD @D19455, AGR [COUNT @D19454, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, PFORM TO, ARITY 3] : CARRY, 
   [COORD @D19459, 
      AGR [COUNT @D19458, PER @D19457, PLU @D19456, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, PFORM TO, ARITY 3] : CARRY, 
   [COORD @D19465, PAST @D19464, 
      AGR [CASE @D19463, COUNT @D19462, PER @D19461, PLU @D19460, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, PFORM TO, ARITY 3] : CARRY, 
   [COORD @D19468, AGR [COUNT @D19467, PER @D19466, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, LAT -, 
      ARITY 3] : CARRY, 
   [COORD @D19470, AGR [COUNT @D19469, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, LAT -, 
      ARITY 3] : CARRY, 
   [COORD @D19472, AGR [COUNT @D19471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, LAT -, 
      ARITY 3] : CARRY, 
   [COORD @D19476, AGR [COUNT @D19475, PER @D19474, PLU @D19473, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_LOC, 
      LAT -, ARITY 3] : CARRY, 
   [COORD @D19482, PAST @D19481, AGR [CASE @D19480, COUNT @D19479, 
            PER @D19478, PLU @D19477, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_LOC, LAT -, ARITY 3] : CARRY, 
   [COORD @D19485, AGR [COUNT @D19484, PER @D19483, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADVP, LAT -, 
      ARITY 3] : CARRY, 
   [COORD @D19487, AGR [COUNT @D19486, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADVP, LAT -, 
      ARITY 3] : CARRY, 
   [COORD @D19489, AGR [COUNT @D19488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADVP, LAT -, 
      ARITY 3] : CARRY, 
   [COORD @D19493, AGR [COUNT @D19492, PER @D19491, PLU @D19490, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP_ADVP, 
      LAT -, ARITY 3] : CARRY, 
   [COORD @D19499, PAST @D19498, AGR [CASE @D19497, COUNT @D19496, 
            PER @D19495, PLU @D19494, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP_ADVP, LAT -, ARITY 3] : CARRY, 
   [COORD @D19502, AGR [COUNT @D19501, PER @D19500, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ON, ARITY 2] : CARRY, 
   [COORD @D19504, AGR [COUNT @D19503, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ON, ARITY 2] : CARRY, 
   [COORD @D19506, AGR [COUNT @D19505, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ON, ARITY 2] : CARRY, 
   [COORD @D19510, AGR [COUNT @D19509, PER @D19508, PLU @D19507, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT ON, ARITY 2] : CARRY, 
   [COORD @D19516, PAST @D19515, 
      AGR [CASE @D19514, COUNT @D19513, PER @D19512, PLU @D19511, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT ON, 
      ARITY 2] : CARRY, 
   [COORD @D19519, AGR [COUNT @D19518, PER @D19517, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT ON, PFORM WITH, ARITY 2] : CARRY, 
   [COORD @D19521, AGR [COUNT @D19520, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT ON, PFORM WITH, ARITY 2] : CARRY, 
   [COORD @D19523, AGR [COUNT @D19522, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT ON, PFORM WITH, ARITY 2] : CARRY, 
   [COORD @D19527, AGR [COUNT @D19526, PER @D19525, PLU @D19524, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT ON, PFORM WITH, ARITY 2] : CARRY, 
   [COORD @D19533, PAST @D19532, 
      AGR [CASE @D19531, COUNT @D19530, PER @D19529, PLU @D19528, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT ON, 
      PFORM WITH, ARITY 2] : CARRY, 
   [COORD @D19536, AGR [COUNT @D19535, PER @D19534, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT THROUGH, PFORM TO, ARITY 2] : CARRY, 
   [COORD @D19538, AGR [COUNT @D19537, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT THROUGH, PFORM TO, ARITY 2] : CARRY, 
   [COORD @D19540, AGR [COUNT @D19539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT THROUGH, PFORM TO, ARITY 2] : CARRY, 
   [COORD @D19544, AGR [COUNT @D19543, PER @D19542, PLU @D19541, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT THROUGH, PFORM TO, ARITY 2] : CARRY, 
   [COORD @D19550, PAST @D19549, 
      AGR [CASE @D19548, COUNT @D19547, PER @D19546, PLU @D19545, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT THROUGH, 
      PFORM TO, ARITY 2] : CARRY, 
   [COORD @D19553, AGR [COUNT @D19552, PER @D19551, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : CARRY, 
   [COORD @D19555, AGR [COUNT @D19554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : CARRY, 
   [COORD @D19557, AGR [COUNT @D19556, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : CARRY, 
   [COORD @D19561, AGR [COUNT @D19560, PER @D19559, PLU @D19558, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OVER, PFORM FROM, ARITY 2] : CARRY, 
   [COORD @D19567, PAST @D19566, 
      AGR [CASE @D19565, COUNT @D19564, PER @D19563, PLU @D19562, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OVER, 
      PFORM FROM, ARITY 2] : CARRY, 
   [COORD @D19570, AGR [COUNT @D19569, PER @D19568, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : CARRY, 
   [COORD @D19572, AGR [COUNT @D19571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : CARRY, 
   [COORD @D19574, AGR [COUNT @D19573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : CARRY, 
   [COORD @D19578, AGR [COUNT @D19577, PER @D19576, PLU @D19575, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT THROUGH, ARITY 2] : CARRY, 
   [COORD @D19584, PAST @D19583, 
      AGR [CASE @D19582, COUNT @D19581, PER @D19580, PLU @D19579, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : CARRY, 
   [COORD @D19587, AGR [COUNT @D19586, PER @D19585, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CARRY, 
   [COORD @D19589, AGR [COUNT @D19588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CARRY, 
   [COORD @D19591, AGR [COUNT @D19590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CARRY, 
   [COORD @D19595, AGR [COUNT @D19594, PER @D19593, PLU @D19592, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : CARRY, 
   [COORD @D19601, PAST @D19600, 
      AGR [CASE @D19599, COUNT @D19598, PER @D19597, PLU @D19596, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CARRY, 
   [COORD @D19604, AGR [COUNT @D19603, PER @D19602, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CARRY, 
   [COORD @D19606, AGR [COUNT @D19605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CARRY, 
   [COORD @D19608, AGR [COUNT @D19607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CARRY, 
   [COORD @D19612, AGR [COUNT @D19611, PER @D19610, PLU @D19609, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : CARRY, 
   [COORD @D19618, PAST @D19617, 
      AGR [CASE @D19616, COUNT @D19615, PER @D19614, PLU @D19613, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : CARRY, 
   [COORD @D19621, AGR [COUNT @D19620, PER @D19619, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CARRY, 
   [COORD @D19623, AGR [COUNT @D19622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CARRY, 
   [COORD @D19625, AGR [COUNT @D19624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CARRY, 
   [COORD @D19629, AGR [COUNT @D19628, PER @D19627, PLU @D19626, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : CARRY, 
   [COORD @D19635, PAST @D19634, 
      AGR [CASE @D19633, COUNT @D19632, PER @D19631, PLU @D19630, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : CARRY, 
   [COORD @D19638, AGR [COUNT @D19637, PER @D19636, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORWARD, ARITY 2] : CARRY, 
   [COORD @D19640, AGR [COUNT @D19639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORWARD, ARITY 2] : CARRY, 
   [COORD @D19642, AGR [COUNT @D19641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORWARD, ARITY 2] : CARRY, 
   [COORD @D19646, AGR [COUNT @D19645, PER @D19644, PLU @D19643, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT FORWARD, ARITY 2] : CARRY, 
   [COORD @D19652, PAST @D19651, 
      AGR [CASE @D19650, COUNT @D19649, PER @D19648, PLU @D19647, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT FORWARD, ARITY 2] : CARRY, 
   [COORD @D19655, AGR [COUNT @D19654, PER @D19653, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CARRY, 
   [COORD @D19657, AGR [COUNT @D19656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CARRY, 
   [COORD @D19659, AGR [COUNT @D19658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CARRY, 
   [COORD @D19663, AGR [COUNT @D19662, PER @D19661, PLU @D19660, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, ARITY 2] : CARRY, 
   [COORD @D19669, PAST @D19668, 
      AGR [CASE @D19667, COUNT @D19666, PER @D19665, PLU @D19664, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : CARRY, 
   [COORD @D19672, AGR [COUNT @D19671, PER @D19670, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CARRY, 
   [COORD @D19674, AGR [COUNT @D19673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CARRY, 
   [COORD @D19676, AGR [COUNT @D19675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CARRY, 
   [COORD @D19680, AGR [COUNT @D19679, PER @D19678, PLU @D19677, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : CARRY, 
   [COORD @D19686, PAST @D19685, 
      AGR [CASE @D19684, COUNT @D19683, PER @D19682, PLU @D19681, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CARRY, 
   [COORD @D19689, AGR [COUNT @D19688, PER @D19687, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CARRY, 
   [COORD @D19691, AGR [COUNT @D19690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CARRY, 
   [COORD @D19693, AGR [COUNT @D19692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CARRY, 
   [COORD @D19697, AGR [COUNT @D19696, PER @D19695, PLU @D19694, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NP, LAT -, 
      ARITY 2] : CARRY, 
   [COORD @D19703, PAST @D19702, AGR [CASE @D19701, COUNT @D19700, 
            PER @D19699, PLU @D19698, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NP, LAT -, ARITY 2] : CARRY, 
   [COORD @D19706, AGR [COUNT @D19705, PER @D19704, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : CARRY, 
   [COORD @D19708, AGR [COUNT @D19707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : CARRY, 
   [COORD @D19710, AGR [COUNT @D19709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : CARRY, 
   [COORD @D19714, AGR [COUNT @D19713, PER @D19712, PLU @D19711, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : CARRY, 
   [COORD @D19720, PAST @D19719, 
      AGR [CASE @D19718, COUNT @D19717, PER @D19716, PLU @D19715, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT THROUGH, 
      ARITY 1] : CARRY, 
   [COORD @D19723, AGR [COUNT @D19722, PER @D19721, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CARRY, 
   [COORD @D19725, AGR [COUNT @D19724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CARRY, 
   [COORD @D19727, AGR [COUNT @D19726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CARRY, 
   [COORD @D19731, AGR [COUNT @D19730, PER @D19729, PLU @D19728, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CARRY, 
   [COORD @D19737, PAST @D19736, 
      AGR [CASE @D19735, COUNT @D19734, PER @D19733, PLU @D19732, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : CARRY, 
   [COORD @D19740, AGR [COUNT @D19739, PER @D19738, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CARRY, 
   [COORD @D19742, AGR [COUNT @D19741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CARRY, 
   [COORD @D19744, AGR [COUNT @D19743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CARRY, 
   [COORD @D19748, AGR [COUNT @D19747, PER @D19746, PLU @D19745, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CARRY, 
   [COORD @D19754, PAST @D19753, 
      AGR [CASE @D19752, COUNT @D19751, PER @D19750, PLU @D19749, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CARRY, 
   [COORD @D19756, AGR [COUNT @D19755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19758, AGR [COUNT @D19757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19762, AGR [NFORM @D19761, COUNT @D19760, PER @D19759, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19766, AGR [COUNT @D19765, PER @D19764, PLU @D19763, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19769, AGR @D19768, PAST @D19767, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_ING, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19772, AGR [COUNT @D19771, PER @D19770, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19774, AGR [COUNT @D19773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19776, AGR [COUNT @D19775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19780, AGR [COUNT @D19779, PER @D19778, PLU @D19777, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : CARRY, 
   [COORD @D19786, PAST @D19785, 
      AGR [CASE @D19784, COUNT @D19783, PER @D19782, PLU @D19781, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : CARRY, 
   [COORD @D19789, AGR [COUNT @D19788, PER @D19787, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CARRY, 
   [COORD @D19791, AGR [COUNT @D19790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CARRY, 
   [COORD @D19793, AGR [COUNT @D19792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CARRY, 
   [COORD @D19797, AGR [COUNT @D19796, PER @D19795, PLU @D19794, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CARRY, 
   [COORD @D19803, PAST @D19802, 
      AGR [CASE @D19801, COUNT @D19800, PER @D19799, PLU @D19798, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : CARRY, 
   [COORD @D19806, AGR [COUNT @D19805, PER @D19804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : CARRY, 
   [COORD @D19808, AGR [COUNT @D19807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : CARRY, 
   [COORD @D19810, AGR [COUNT @D19809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : CARRY, 
   [COORD @D19814, AGR [COUNT @D19813, PER @D19812, PLU @D19811, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : CARRY, 
   [COORD @D19820, PAST @D19819, 
      AGR [CASE @D19818, COUNT @D19817, PER @D19816, PLU @D19815, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT FORWARD, 
      ARITY 1] : CARRY, 
   [COORD @D19823, AGR [COUNT @D19822, PER @D19821, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CARRY, 
   [COORD @D19825, AGR [COUNT @D19824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CARRY, 
   [COORD @D19827, AGR [COUNT @D19826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CARRY, 
   [COORD @D19831, AGR [COUNT @D19830, PER @D19829, PLU @D19828, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : CARRY, 
   [COORD @D19837, PAST @D19836, 
      AGR [CASE @D19835, COUNT @D19834, PER @D19833, PLU @D19832, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, 
      ARITY 1] : CARRY, 
   [COORD @D19840, AGR [COUNT @D19839, PER @D19838, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CARRY, 
   [COORD @D19842, AGR [COUNT @D19841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CARRY, 
   [COORD @D19844, AGR [COUNT @D19843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CARRY, 
   [COORD @D19848, AGR [COUNT @D19847, PER @D19846, PLU @D19845, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CARRY, 
   [COORD @D19854, PAST @D19853, 
      AGR [CASE @D19852, COUNT @D19851, PER @D19850, PLU @D19849, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : CARRY, 
   [COORD @D19857, AGR [COUNT @D19856, PER @D19855, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : CARRY, 
   [COORD @D19859, AGR [COUNT @D19858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : CARRY, 
   [COORD @D19861, AGR [COUNT @D19860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, LAT -, 
      ARITY 1] : CARRY, 
   [COORD @D19865, AGR [COUNT @D19864, PER @D19863, PLU @D19862, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, COMPOUND NOT, SUBCAT NULL, 
      LAT -, ARITY 1] : CARRY, 
   [COORD @D19871, PAST @D19870, AGR [CASE @D19869, COUNT @D19868, 
            PER @D19867, PLU @D19866, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, COMPOUND NOT, 
      SUBCAT NULL, LAT -, ARITY 1] : CARRY.

WORD carrying : 
   [COORD @D19886, PRD @D19885, AGR [CASE @D19884, COUNT @D19883, 
            PER @D19882, PLU @D19881, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19892, PRD @D19891, 
      AGR [CASE @D19890, COUNT @D19889, PER @D19888, PLU @D19887, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19898, PRD @D19897, AGR [CASE @D19896, COUNT @D19895, 
            PER @D19894, PLU @D19893, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19904, PRD @D19903, 
      AGR [CASE @D19902, COUNT @D19901, PER @D19900, PLU @D19899, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CARRY, 
   [COORD @D19910, PRD @D19909, AGR [CASE @D19908, COUNT @D19907, 
            PER @D19906, PLU @D19905, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19916, PRD @D19915, 
      AGR [CASE @D19914, COUNT @D19913, PER @D19912, PLU @D19911, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT ON, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19922, PRD @D19921, AGR [CASE @D19920, COUNT @D19919, 
            PER @D19918, PLU @D19917, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT THROUGH, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19928, PRD @D19927, 
      AGR [CASE @D19926, COUNT @D19925, PER @D19924, PLU @D19923, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D19934, PRD @D19933, AGR [CASE @D19932, COUNT @D19931, 
            PER @D19930, PLU @D19929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19940, PRD @D19939, 
      AGR [CASE @D19938, COUNT @D19937, PER @D19936, PLU @D19935, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARRY, 
   [COORD @D19946, PRD @D19945, AGR [CASE @D19944, COUNT @D19943, 
            PER @D19942, PLU @D19941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19952, PRD @D19951, 
      AGR [CASE @D19950, COUNT @D19949, PER @D19948, PLU @D19947, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARRY, 
   [COORD @D19958, PRD @D19957, AGR [CASE @D19956, COUNT @D19955, 
            PER @D19954, PLU @D19953, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORWARD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19964, PRD @D19963, 
      AGR [CASE @D19962, COUNT @D19961, PER @D19960, PLU @D19959, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARRY, 
   [COORD @D19970, PRD @D19969, AGR [CASE @D19968, COUNT @D19967, 
            PER @D19966, PLU @D19965, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19976, PRD @D19975, 
      AGR [CASE @D19974, COUNT @D19973, PER @D19972, PLU @D19971, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CARRY, 
   [COORD @D19982, PRD @D19981, AGR [CASE @D19980, COUNT @D19979, 
            PER @D19978, PLU @D19977, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19988, PRD @D19987, 
      AGR [CASE @D19986, COUNT @D19985, PER @D19984, PLU @D19983, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARRY, 
   [COORD @D19994, PRD @D19993, AGR [CASE @D19992, COUNT @D19991, 
            PER @D19990, PLU @D19989, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D19997, AGR @D19996, PRD @D19995, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CARRY, 
   [COORD @D20003, PRD @D20002, AGR [CASE @D20001, COUNT @D20000, 
            PER @D19999, PLU @D19998, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D20009, PRD @D20008, 
      AGR [CASE @D20007, COUNT @D20006, PER @D20005, PLU @D20004, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARRY, 
   [COORD @D20015, PRD @D20014, AGR [CASE @D20013, COUNT @D20012, 
            PER @D20011, PLU @D20010, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT FORWARD, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D20021, PRD @D20020, 
      AGR [CASE @D20019, COUNT @D20018, PER @D20017, PLU @D20016, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARRY, 
   [COORD @D20027, PRD @D20026, AGR [CASE @D20025, COUNT @D20024, 
            PER @D20023, PLU @D20022, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARRY, 
   [COORD @D20033, PRD @D20032, 
      AGR [CASE @D20031, COUNT @D20030, PER @D20029, PLU @D20028, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CARRY.

WORD carve : 
   [COORD @D20042, AGR [COUNT @D20041, PER @D20040, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CARVE, 
   [COORD @D20044, AGR [COUNT @D20043, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CARVE, 
   [COORD @D20046, AGR [COUNT @D20045, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CARVE, 
   [COORD @D20050, AGR [COUNT @D20049, PER @D20048, PLU @D20047, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : CARVE, 
   [COORD @D20056, PAST @D20055, 
      AGR [CASE @D20054, COUNT @D20053, PER @D20052, PLU @D20051, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : CARVE, 
   [COORD @D20059, AGR [COUNT @D20058, PER @D20057, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CARVE, 
   [COORD @D20061, AGR [COUNT @D20060, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CARVE, 
   [COORD @D20063, AGR [COUNT @D20062, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CARVE, 
   [COORD @D20067, AGR [COUNT @D20066, PER @D20065, PLU @D20064, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CARVE, 
   [COORD @D20073, PAST @D20072, 
      AGR [CASE @D20071, COUNT @D20070, PER @D20069, PLU @D20068, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CARVE.

WORD carved : 
   [COORD @D20085, AGR [CASE @D20084, COUNT @D20083, PER @D20082, 
            PLU @D20081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARVE, 
   [COORD @D20090, AGR [CASE @D20089, COUNT @D20088, PER @D20087, 
            PLU @D20086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARVE, 
   [COORD @D20095, AGR [CASE @D20094, COUNT @D20093, PER @D20092, 
            PLU @D20091, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CARVE, 
   [COORD @D20100, AGR [CASE @D20099, COUNT @D20098, PER @D20097, 
            PLU @D20096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CARVE, 
   [COORD @D20105, AGR [CASE @D20104, COUNT @D20103, PER @D20102, 
            PLU @D20101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CARVE.

WORD carves : 
   [COORD @D20114, AGR [COUNT @D20113, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARVE, 
   [COORD @D20116, 
      AGR [COUNT @D20115, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CARVE.

WORD carving : 
   [COORD @D20127, REFL @D20126, COUNT @D20125, PRD @D20124, 
      CASE @D20123, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CARVING, 
   [COORD @D20133, PRD @D20132, 
      AGR [CASE @D20131, COUNT @D20130, PER @D20129, PLU @D20128, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CARVE, 
   [COORD @D20139, PRD @D20138, AGR [CASE @D20137, COUNT @D20136, 
            PER @D20135, PLU @D20134, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CARVE.

WORD carvings : 
   [COORD @D20152, DEMON @D20151, REFL @D20150, PRD @D20149, 
      CASE @D20148, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CARVING.

WORD cater : 
   [COORD @D20158, AGR [COUNT @D20157, PER @D20156, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CATER, 
   [COORD @D20160, AGR [COUNT @D20159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CATER, 
   [COORD @D20162, AGR [COUNT @D20161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CATER, 
   [COORD @D20166, AGR [COUNT @D20165, PER @D20164, PLU @D20163, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CATER, 
   [COORD @D20172, PAST @D20171, AGR [CASE @D20170, COUNT @D20169, 
            PER @D20168, PLU @D20167, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CATER, 
   [COORD @D20175, AGR [COUNT @D20174, PER @D20173, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : CATER, 
   [COORD @D20177, AGR [COUNT @D20176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : CATER, 
   [COORD @D20179, AGR [COUNT @D20178, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : CATER, 
   [COORD @D20183, AGR [COUNT @D20182, PER @D20181, PLU @D20180, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : CATER, 
   [COORD @D20189, PAST @D20188, 
      AGR [CASE @D20187, COUNT @D20186, PER @D20185, PLU @D20184, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      ARITY 2] : CATER, 
   [COORD @D20192, AGR [COUNT @D20191, PER @D20190, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CATER, 
   [COORD @D20194, AGR [COUNT @D20193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CATER, 
   [COORD @D20196, AGR [COUNT @D20195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CATER, 
   [COORD @D20200, AGR [COUNT @D20199, PER @D20198, PLU @D20197, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : CATER, 
   [COORD @D20206, PAST @D20205, 
      AGR [CASE @D20204, COUNT @D20203, PER @D20202, PLU @D20201, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : CATER, 
   [COORD @D20209, AGR [COUNT @D20208, PER @D20207, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : CATER, 
   [COORD @D20211, AGR [COUNT @D20210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : CATER, 
   [COORD @D20213, AGR [COUNT @D20212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : CATER, 
   [COORD @D20217, AGR [COUNT @D20216, PER @D20215, PLU @D20214, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : CATER, 
   [COORD @D20223, PAST @D20222, 
      AGR [CASE @D20221, COUNT @D20220, PER @D20219, PLU @D20218, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AT, 
      ARITY 2] : CATER, 
   [COORD @D20226, AGR [COUNT @D20225, PER @D20224, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CATER, 
   [COORD @D20228, AGR [COUNT @D20227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CATER, 
   [COORD @D20230, AGR [COUNT @D20229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CATER, 
   [COORD @D20234, AGR [COUNT @D20233, PER @D20232, PLU @D20231, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CATER, 
   [COORD @D20240, PAST @D20239, AGR [CASE @D20238, COUNT @D20237, 
            PER @D20236, PLU @D20235, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CATER.

WORD catered : 
   [COORD @D20249, AGR [CASE @D20248, COUNT @D20247, PER @D20246, 
            PLU @D20245, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20254, AGR [CASE @D20253, COUNT @D20252, PER @D20251, 
            PLU @D20250, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CATER, 
   [COORD @D20259, AGR [CASE @D20258, COUNT @D20257, PER @D20256, 
            PLU @D20255, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CATER, 
   [COORD @D20264, AGR [CASE @D20263, COUNT @D20262, PER @D20261, 
            PLU @D20260, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20269, AGR [CASE @D20268, COUNT @D20267, PER @D20266, 
            PLU @D20265, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20274, AGR [CASE @D20273, COUNT @D20272, PER @D20271, 
            PLU @D20270, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CATER, 
   [COORD @D20279, AGR [CASE @D20278, COUNT @D20277, PER @D20276, 
            PLU @D20275, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20284, AGR [CASE @D20283, COUNT @D20282, PER @D20281, 
            PLU @D20280, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CATER, 
   [COORD @D20289, AGR [CASE @D20288, COUNT @D20287, PER @D20286, 
            PLU @D20285, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20294, AGR [CASE @D20293, COUNT @D20292, PER @D20291, 
            PLU @D20290, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20299, AGR [CASE @D20298, COUNT @D20297, PER @D20296, 
            PLU @D20295, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CATER, 
   [COORD @D20304, AGR [CASE @D20303, COUNT @D20302, PER @D20301, 
            PLU @D20300, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20309, AGR [CASE @D20308, COUNT @D20307, PER @D20306, 
            PLU @D20305, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CATER.

WORD catering : 
   [COORD @D20321, PRD @D20320, AGR [CASE @D20319, COUNT @D20318, 
            PER @D20317, PLU @D20316, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20327, PRD @D20326, 
      AGR [CASE @D20325, COUNT @D20324, PER @D20323, PLU @D20322, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CATER, 
   [COORD @D20333, PRD @D20332, AGR [CASE @D20331, COUNT @D20330, 
            PER @D20329, PLU @D20328, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CATER, 
   [COORD @D20339, PRD @D20338, 
      AGR [CASE @D20337, COUNT @D20336, PER @D20335, PLU @D20334, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CATER, 
   [COORD @D20345, PRD @D20344, AGR [CASE @D20343, COUNT @D20342, 
            PER @D20341, PLU @D20340, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CATER.

WORD caters : 
   [COORD @D20351, AGR [COUNT @D20350, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CATER, 
   [COORD @D20353, 
      AGR [COUNT @D20352, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CATER, 
   [COORD @D20355, 
      AGR [COUNT @D20354, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CATER, 
   [COORD @D20357, 
      AGR [COUNT @D20356, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CATER, 
   [COORD @D20359, 
      AGR [COUNT @D20358, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CATER.

WORD caught : 
   [COORD @D20367, AGR [CASE @D20366, COUNT @D20365, PER @D20364, 
            PLU @D20363, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, VFORM EN, 
      FIN -, PAST NOT, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PSVE +, PRT UP, PRD +, PFORM IN, ARITY 3] : CATCH, 
   [COORD @D20373, PAST @D20372, 
      AGR [CASE @D20371, COUNT @D20370, PER @D20369, PLU @D20368, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, PFORM WITH, FIN -, 
      ARITY 2] : CATCH, 
   [COORD @D20379, PAST @D20378, AGR [CASE @D20377, COUNT @D20376, 
            PER @D20375, PLU @D20374, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT ON, PFORM TO, FIN -, ARITY 2] : CATCH, 
   [COORD @D20385, PAST @D20384, 
      AGR [CASE @D20383, COUNT @D20382, PER @D20381, PLU @D20380, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, PFORM ON, FIN -, 
      ARITY 2] : CATCH, 
   [COORD @D20391, PAST @D20390, AGR [CASE @D20389, COUNT @D20388, 
            PER @D20387, PLU @D20386, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AT, FIN -, ARITY 2] : CATCH, 
   [COORD @D20397, PAST @D20396, 
      AGR [CASE @D20395, COUNT @D20394, PER @D20393, PLU @D20392, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, FIN -, 
      ARITY 2] : CATCH, 
   [COORD @D20403, PAST @D20402, AGR [CASE @D20401, COUNT @D20400, 
            PER @D20399, PLU @D20398, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : CATCH, 
   [COORD @D20409, PAST @D20408, 
      AGR [CASE @D20407, COUNT @D20406, PER @D20405, PLU @D20404, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : CATCH, 
   [COORD @D20415, PAST @D20414, AGR [CASE @D20413, COUNT @D20412, 
            PER @D20411, PLU @D20410, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : CATCH, 
   [COORD @D20421, PAST @D20420, 
      AGR [CASE @D20419, COUNT @D20418, PER @D20417, PLU @D20416, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : CATCH, 
   [COORD @D20425, AGR [COUNT @D20424, PER @D20423, PLU @D20422, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM WITH, PAST +, ARITY 2] : CATCH, 
   [COORD @D20429, AGR [COUNT @D20428, PER @D20427, PLU @D20426, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM TO, PAST +, ARITY 2] : CATCH, 
   [COORD @D20433, AGR [COUNT @D20432, PER @D20431, PLU @D20430, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM ON, PAST +, ARITY 2] : CATCH, 
   [COORD @D20437, AGR [COUNT @D20436, PER @D20435, PLU @D20434, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, PAST +, ARITY 2] : CATCH, 
   [COORD @D20441, AGR [COUNT @D20440, PER @D20439, PLU @D20438, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : CATCH, 
   [COORD @D20445, AGR [COUNT @D20444, PER @D20443, PLU @D20442, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : CATCH, 
   [COORD @D20451, PAST @D20450, AGR [CASE @D20449, COUNT @D20448, 
            PER @D20447, PLU @D20446, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : CATCH, 
   [COORD @D20457, PAST @D20456, 
      AGR [CASE @D20455, COUNT @D20454, PER @D20453, PLU @D20452, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : CATCH, 
   [COORD @D20463, PAST @D20462, AGR [CASE @D20461, COUNT @D20460, 
            PER @D20459, PLU @D20458, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : CATCH, 
   [COORD @D20467, 
      AGR [COUNT @D20466, PER @D20465, PLU @D20464, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : CATCH, 
   [COORD @D20471, AGR [COUNT @D20470, PER @D20469, PLU @D20468, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : CATCH, 
   [COORD @D20475, AGR [COUNT @D20474, PER @D20473, PLU @D20472, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : CATCH.

WORD cause : 
   [COORD @D20497, REFL @D20496, COUNT @D20495, PRD @D20494, CASE 
         @D20493, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CAUSE, 
   [COORD @D20500, 
      AGR [COUNT @D20499, PER @D20498, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   CAUSE, 
   [COORD @D20502, AGR [COUNT @D20501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : CAUSE, 
   [COORD @D20504, AGR [COUNT @D20503, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : CAUSE, 
   [COORD @D20508, AGR [COUNT @D20507, PER @D20506, PLU @D20505, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : CAUSE, 
   [COORD @D20514, PAST @D20513, AGR [CASE @D20512, COUNT @D20511, 
            PER @D20510, PLU @D20509, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : CAUSE, 
   [COORD @D20517, AGR [COUNT @D20516, PER @D20515, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CAUSE, 
   [COORD @D20519, AGR [COUNT @D20518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CAUSE, 
   [COORD @D20521, AGR [COUNT @D20520, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CAUSE, 
   [COORD @D20525, AGR [COUNT @D20524, PER @D20523, PLU @D20522, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CAUSE, 
   [COORD @D20531, PAST @D20530, 
      AGR [CASE @D20529, COUNT @D20528, PER @D20527, PLU @D20526, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : CAUSE, 
   [COORD @D20534, AGR [COUNT @D20533, PER @D20532, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CAUSE, 
   [COORD @D20536, AGR [COUNT @D20535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CAUSE, 
   [COORD @D20538, AGR [COUNT @D20537, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CAUSE, 
   [COORD @D20542, AGR [COUNT @D20541, PER @D20540, PLU @D20539, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CAUSE, 
   [COORD @D20548, PAST @D20547, 
      AGR [CASE @D20546, COUNT @D20545, PER @D20544, PLU @D20543, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : CAUSE, 
   [COORD @D20551, AGR [COUNT @D20550, PER @D20549, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CAUSE, 
   [COORD @D20553, AGR [COUNT @D20552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CAUSE, 
   [COORD @D20555, AGR [COUNT @D20554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CAUSE, 
   [COORD @D20559, AGR [COUNT @D20558, PER @D20557, PLU @D20556, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CAUSE, 
   [COORD @D20565, PAST @D20564, AGR [CASE @D20563, COUNT @D20562, 
            PER @D20561, PLU @D20560, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : CAUSE, 
   [COORD @D20568, AGR [COUNT @D20567, PER @D20566, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CAUSE, 
   [COORD @D20570, AGR [COUNT @D20569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CAUSE, 
   [COORD @D20572, AGR [COUNT @D20571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CAUSE, 
   [COORD @D20576, AGR [COUNT @D20575, PER @D20574, PLU @D20573, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CAUSE, 
   [COORD @D20582, PAST @D20581, AGR [CASE @D20580, COUNT @D20579, 
            PER @D20578, PLU @D20577, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CAUSE.

WORD caused : 
   [COORD @D20594, AGR [CASE @D20593, COUNT @D20592, PER @D20591, 
            PLU @D20590, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CAUSE, 
   [COORD @D20599, AGR [CASE @D20598, COUNT @D20597, PER @D20596, 
            PLU @D20595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20604, AGR [CASE @D20603, COUNT @D20602, PER @D20601, 
            PLU @D20600, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20609, AGR [CASE @D20608, COUNT @D20607, PER @D20606, 
            PLU @D20605, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20614, AGR [CASE @D20613, COUNT @D20612, PER @D20611, 
            PLU @D20610, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20619, AGR [CASE @D20618, COUNT @D20617, PER @D20616, 
            PLU @D20615, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20624, AGR [CASE @D20623, COUNT @D20622, PER @D20621, 
            PLU @D20620, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20629, AGR [CASE @D20628, COUNT @D20627, PER @D20626, 
            PLU @D20625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20634, AGR [CASE @D20633, COUNT @D20632, PER @D20631, 
            PLU @D20630, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20639, AGR [CASE @D20638, COUNT @D20637, PER @D20636, 
            PLU @D20635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20644, AGR [CASE @D20643, COUNT @D20642, PER @D20641, 
            PLU @D20640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20650, AGR [CASE @D20649, NFORM @D20648, COUNT @D20647, 
            PER @D20646, PLU @D20645, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CAUSE, 
   [COORD @D20655, AGR [UB @D20654, VFORM @D20653, SUBJ @D20652, 
            FIN @D20651, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CAUSE, 
   [COORD @D20660, AGR [CASE @D20659, COUNT @D20658, PER @D20657, 
            PLU @D20656, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CAUSE, 
   [COORD @D20665, AGR [CASE @D20664, COUNT @D20663, PER @D20662, 
            PLU @D20661, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20670, AGR [CASE @D20669, COUNT @D20668, PER @D20667, 
            PLU @D20666, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CAUSE.

WORD causes : 
   [COORD @D20682, DEMON @D20681, REFL @D20680, PRD @D20679, CASE 
         @D20678, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CAUSE, 
   [COORD @D20684, 
      AGR [COUNT @D20683, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20686, 
      AGR [COUNT @D20685, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20688, 
      AGR [COUNT @D20687, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20690, 
      AGR [COUNT @D20689, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20692, 
      AGR [COUNT @D20691, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CAUSE.

WORD causing : 
   [COORD @D20703, PRD @D20702, AGR [CASE @D20701, COUNT @D20700, 
            PER @D20699, PLU @D20698, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20709, PRD @D20708, 
      AGR [CASE @D20707, COUNT @D20706, PER @D20705, PLU @D20704, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CAUSE, 
   [COORD @D20715, PRD @D20714, AGR [CASE @D20713, COUNT @D20712, 
            PER @D20711, PLU @D20710, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CAUSE, 
   [COORD @D20721, PRD @D20720, 
      AGR [CASE @D20719, COUNT @D20718, PER @D20717, PLU @D20716, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CAUSE, 
   [COORD @D20727, PRD @D20726, AGR [CASE @D20725, COUNT @D20724, 
            PER @D20723, PLU @D20722, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CAUSE.

WORD cease : 
   [COORD @D20734, AGR [COUNT @D20733, PER @D20732, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CEASE, 
   [COORD @D20736, AGR [COUNT @D20735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CEASE, 
   [COORD @D20738, AGR [COUNT @D20737, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CEASE, 
   [COORD @D20742, AGR [COUNT @D20741, PER @D20740, PLU @D20739, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CEASE, 
   [COORD @D20748, PAST @D20747, AGR [CASE @D20746, COUNT @D20745, 
            PER @D20744, PLU @D20743, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CEASE, 
   [COORD @D20750, AGR [COUNT @D20749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CEASE, 
   [COORD @D20752, AGR [COUNT @D20751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CEASE, 
   [COORD @D20756, AGR [NFORM @D20755, COUNT @D20754, PER @D20753, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CEASE, 
   [COORD @D20760, AGR [COUNT @D20759, PER @D20758, PLU @D20757, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CEASE, 
   [COORD @D20763, AGR @D20762, PAST @D20761, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_ING, ARITY 1] : CEASE, 
   [COORD @D20765, AGR [COUNT @D20764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CEASE, 
   [COORD @D20767, AGR [COUNT @D20766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CEASE, 
   [COORD @D20771, AGR [NFORM @D20770, COUNT @D20769, PER @D20768, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CEASE, 
   [COORD @D20775, AGR [COUNT @D20774, PER @D20773, PLU @D20772, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CEASE, 
   [COORD @D20778, AGR @D20777, PAST @D20776, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, ARITY 1] : CEASE, 
   [COORD @D20781, AGR [COUNT @D20780, PER @D20779, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CEASE, 
   [COORD @D20783, AGR [COUNT @D20782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CEASE, 
   [COORD @D20785, AGR [COUNT @D20784, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CEASE, 
   [COORD @D20789, AGR [COUNT @D20788, PER @D20787, PLU @D20786, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CEASE, 
   [COORD @D20795, PAST @D20794, AGR [CASE @D20793, COUNT @D20792, 
            PER @D20791, PLU @D20790, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CEASE.

WORD ceased : 
   [COORD @D20805, AGR [CASE @D20804, COUNT @D20803, PER @D20802, 
            PLU @D20801, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CEASE, 
   [COORD @D20810, AGR [CASE @D20809, COUNT @D20808, PER @D20807, 
            PLU @D20806, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CEASE, 
   [COORD @D20815, AGR [CASE @D20814, COUNT @D20813, PER @D20812, 
            PLU @D20811, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CEASE, 
   [COORD @D20817, AGR @D20816, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CEASE, 
   [COORD @D20819, AGR @D20818, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : CEASE, 
   [COORD @D20821, AGR @D20820, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CEASE, 
   [COORD @D20823, AGR @D20822, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : CEASE, 
   [COORD @D20828, AGR [CASE @D20827, COUNT @D20826, PER @D20825, 
            PLU @D20824, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CEASE, 
   [COORD @D20833, AGR [CASE @D20832, COUNT @D20831, PER @D20830, 
            PLU @D20829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CEASE.

WORD ceases : 
   [COORD @D20840, AGR [COUNT @D20839, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CEASE, 
   [COORD @D20844, 
      AGR [CASE @D20843, NFORM @D20842, COUNT @D20841, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CEASE, 
   [COORD @D20849, 
      AGR [UB @D20848, VFORM @D20847, SUBJ @D20846, FIN @D20845, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CEASE, 
   [COORD @D20853, 
      AGR [CASE @D20852, NFORM @D20851, COUNT @D20850, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CEASE, 
   [COORD @D20858, 
      AGR [UB @D20857, VFORM @D20856, SUBJ @D20855, FIN @D20854, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CEASE, 
   [COORD @D20860, 
      AGR [COUNT @D20859, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CEASE.

WORD ceasing : 
   [COORD @D20870, PRD @D20869, AGR [CASE @D20868, COUNT @D20867, 
            PER @D20866, PLU @D20865, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CEASE, 
   [COORD @D20873, AGR @D20872, PRD @D20871, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CEASE, 
   [COORD @D20876, AGR @D20875, PRD @D20874, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CEASE, 
   [COORD @D20882, PRD @D20881, AGR [CASE @D20880, COUNT @D20879, 
            PER @D20878, PLU @D20877, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CEASE.

WORD centre : 
   [COORD @D20891, REFL @D20890, PRD @D20889, CASE @D20888, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CENTRE, 
   [COORD @D20895, REFL @D20894, PRD @D20893, CASE @D20892, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CENTRE, 
   [COORD @D20898, 
      AGR [COUNT @D20897, PER @D20896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM UPON, 
      ARITY 3] : CENTRE, 
   [COORD @D20900, AGR [COUNT @D20899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : CENTRE, 
   [COORD @D20902, AGR [COUNT @D20901, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : CENTRE, 
   [COORD @D20906, AGR [COUNT @D20905, PER @D20904, PLU @D20903, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : CENTRE, 
   [COORD @D20912, PAST @D20911, 
      AGR [CASE @D20910, COUNT @D20909, PER @D20908, PLU @D20907, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM UPON, 
      ARITY 3] : CENTRE, 
   [COORD @D20915, AGR [COUNT @D20914, PER @D20913, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ROUND, ARITY 3] : CENTRE, 
   [COORD @D20917, AGR [COUNT @D20916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ROUND, ARITY 3] : CENTRE, 
   [COORD @D20919, AGR [COUNT @D20918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ROUND, ARITY 3] : CENTRE, 
   [COORD @D20923, AGR [COUNT @D20922, PER @D20921, PLU @D20920, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ROUND, ARITY 3] : CENTRE, 
   [COORD @D20929, PAST @D20928, 
      AGR [CASE @D20927, COUNT @D20926, PER @D20925, PLU @D20924, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ROUND, 
      ARITY 3] : CENTRE, 
   [COORD @D20932, AGR [COUNT @D20931, PER @D20930, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : CENTRE, 
   [COORD @D20934, AGR [COUNT @D20933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : CENTRE, 
   [COORD @D20936, AGR [COUNT @D20935, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : CENTRE, 
   [COORD @D20940, AGR [COUNT @D20939, PER @D20938, PLU @D20937, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : CENTRE, 
   [COORD @D20946, PAST @D20945, 
      AGR [CASE @D20944, COUNT @D20943, PER @D20942, PLU @D20941, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ON, 
      ARITY 3] : CENTRE, 
   [COORD @D20949, AGR [COUNT @D20948, PER @D20947, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AROUND, ARITY 3] : CENTRE, 
   [COORD @D20951, AGR [COUNT @D20950, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AROUND, ARITY 3] : CENTRE, 
   [COORD @D20953, AGR [COUNT @D20952, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AROUND, ARITY 3] : CENTRE, 
   [COORD @D20957, AGR [COUNT @D20956, PER @D20955, PLU @D20954, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AROUND, ARITY 3] : CENTRE, 
   [COORD @D20963, PAST @D20962, 
      AGR [CASE @D20961, COUNT @D20960, PER @D20959, PLU @D20958, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AROUND, ARITY 3] : CENTRE, 
   [COORD @D20966, AGR [COUNT @D20965, PER @D20964, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CENTRE, 
   [COORD @D20968, AGR [COUNT @D20967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CENTRE, 
   [COORD @D20970, AGR [COUNT @D20969, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CENTRE, 
   [COORD @D20974, AGR [COUNT @D20973, PER @D20972, PLU @D20971, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CENTRE, 
   [COORD @D20980, PAST @D20979, AGR [CASE @D20978, COUNT @D20977, 
            PER @D20976, PLU @D20975, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CENTRE, 
   [COORD @D20983, AGR [COUNT @D20982, PER @D20981, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : CENTRE, 
   [COORD @D20985, AGR [COUNT @D20984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : CENTRE, 
   [COORD @D20987, AGR [COUNT @D20986, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : CENTRE, 
   [COORD @D20991, AGR [COUNT @D20990, PER @D20989, PLU @D20988, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM UPON, ARITY 2] : CENTRE, 
   [COORD @D20997, PAST @D20996, 
      AGR [CASE @D20995, COUNT @D20994, PER @D20993, PLU @D20992, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UPON, 
      ARITY 2] : CENTRE, 
   [COORD @D21000, AGR [COUNT @D20999, PER @D20998, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : CENTRE, 
   [COORD @D21002, AGR [COUNT @D21001, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : CENTRE, 
   [COORD @D21004, AGR [COUNT @D21003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : CENTRE, 
   [COORD @D21008, AGR [COUNT @D21007, PER @D21006, PLU @D21005, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ROUND, ARITY 2] : CENTRE, 
   [COORD @D21014, PAST @D21013, 
      AGR [CASE @D21012, COUNT @D21011, PER @D21010, PLU @D21009, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ROUND, 
      ARITY 2] : CENTRE, 
   [COORD @D21017, AGR [COUNT @D21016, PER @D21015, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : CENTRE, 
   [COORD @D21019, AGR [COUNT @D21018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : CENTRE, 
   [COORD @D21021, AGR [COUNT @D21020, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : CENTRE, 
   [COORD @D21025, AGR [COUNT @D21024, PER @D21023, PLU @D21022, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : CENTRE, 
   [COORD @D21031, PAST @D21030, 
      AGR [CASE @D21029, COUNT @D21028, PER @D21027, PLU @D21026, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      ARITY 2] : CENTRE, 
   [COORD @D21034, AGR [COUNT @D21033, PER @D21032, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AROUND, ARITY 2] : CENTRE, 
   [COORD @D21036, AGR [COUNT @D21035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AROUND, ARITY 2] : CENTRE, 
   [COORD @D21038, AGR [COUNT @D21037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AROUND, ARITY 2] : CENTRE, 
   [COORD @D21042, AGR [COUNT @D21041, PER @D21040, PLU @D21039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AROUND, ARITY 2] : CENTRE, 
   [COORD @D21048, PAST @D21047, 
      AGR [CASE @D21046, COUNT @D21045, PER @D21044, PLU @D21043, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AROUND, 
      ARITY 2] : CENTRE.

WORD centred : 
   [COORD @D21060, AGR [CASE @D21059, COUNT @D21058, PER @D21057, 
            PLU @D21056, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21065, AGR [CASE @D21064, COUNT @D21063, PER @D21062, 
            PLU @D21061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21070, AGR [CASE @D21069, COUNT @D21068, PER @D21067, 
            PLU @D21066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21075, AGR [CASE @D21074, COUNT @D21073, PER @D21072, 
            PLU @D21071, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21080, AGR [CASE @D21079, COUNT @D21078, PER @D21077, 
            PLU @D21076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21085, AGR [CASE @D21084, COUNT @D21083, PER @D21082, 
            PLU @D21081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21090, AGR [CASE @D21089, COUNT @D21088, PER @D21087, 
            PLU @D21086, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21095, AGR [CASE @D21094, COUNT @D21093, PER @D21092, 
            PLU @D21091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21100, AGR [CASE @D21099, COUNT @D21098, PER @D21097, 
            PLU @D21096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21105, AGR [CASE @D21104, COUNT @D21103, PER @D21102, 
            PLU @D21101, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21110, AGR [CASE @D21109, COUNT @D21108, PER @D21107, 
            PLU @D21106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21115, AGR [CASE @D21114, COUNT @D21113, PER @D21112, 
            PLU @D21111, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21120, AGR [CASE @D21119, COUNT @D21118, PER @D21117, 
            PLU @D21116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21125, AGR [CASE @D21124, COUNT @D21123, PER @D21122, 
            PLU @D21121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21130, AGR [CASE @D21129, COUNT @D21128, PER @D21127, 
            PLU @D21126, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CENTRE, 
   [COORD @D21135, AGR [CASE @D21134, COUNT @D21133, PER @D21132, 
            PLU @D21131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21140, AGR [CASE @D21139, COUNT @D21138, PER @D21137, 
            PLU @D21136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21145, AGR [CASE @D21144, COUNT @D21143, PER @D21142, 
            PLU @D21141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21150, AGR [CASE @D21149, COUNT @D21148, PER @D21147, 
            PLU @D21146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21155, AGR [CASE @D21154, COUNT @D21153, PER @D21152, 
            PLU @D21151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21160, AGR [CASE @D21159, COUNT @D21158, PER @D21157, 
            PLU @D21156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21165, AGR [CASE @D21164, COUNT @D21163, PER @D21162, 
            PLU @D21161, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21170, AGR [CASE @D21169, COUNT @D21168, PER @D21167, 
            PLU @D21166, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CENTRE.

WORD centres : 
   [COORD @D21182, DEMON @D21181, REFL @D21180, PRD @D21179, 
      CASE @D21178, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CENTRE, 
   [COORD @D21187, DEMON @D21186, REFL @D21185, PRD @D21184, 
      CASE @D21183, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : CENTRE, 
   [COORD @D21189, AGR [COUNT @D21188, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CENTRE, 
   [COORD @D21191, AGR [COUNT @D21190, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CENTRE, 
   [COORD @D21193, AGR [COUNT @D21192, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21195, 
      AGR [COUNT @D21194, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CENTRE, 
   [COORD @D21197, AGR [COUNT @D21196, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21199, 
      AGR [COUNT @D21198, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21201, 
      AGR [COUNT @D21200, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21203, 
      AGR [COUNT @D21202, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21205, 
      AGR [COUNT @D21204, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CENTRE.

WORD centring : 
   [COORD @D21216, PRD @D21215, AGR [CASE @D21214, COUNT @D21213, 
            PER @D21212, PLU @D21211, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21222, PRD @D21221, 
      AGR [CASE @D21220, COUNT @D21219, PER @D21218, PLU @D21217, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CENTRE, 
   [COORD @D21228, PRD @D21227, AGR [CASE @D21226, COUNT @D21225, 
            PER @D21224, PLU @D21223, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21234, PRD @D21233, 
      AGR [CASE @D21232, COUNT @D21231, PER @D21230, PLU @D21229, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CENTRE, 
   [COORD @D21240, PRD @D21239, AGR [CASE @D21238, COUNT @D21237, 
            PER @D21236, PLU @D21235, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21246, PRD @D21245, 
      AGR [CASE @D21244, COUNT @D21243, PER @D21242, PLU @D21241, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CENTRE, 
   [COORD @D21252, PRD @D21251, AGR [CASE @D21250, COUNT @D21249, 
            PER @D21248, PLU @D21247, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE, 
   [COORD @D21258, PRD @D21257, 
      AGR [CASE @D21256, COUNT @D21255, PER @D21254, PLU @D21253, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CENTRE, 
   [COORD @D21264, PRD @D21263, AGR [CASE @D21262, COUNT @D21261, 
            PER @D21260, PLU @D21259, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CENTRE.

WORD change : 
   [COORD @D21273, REFL @D21272, PRD @D21271, CASE @D21270, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CHANGE, 
   [COORD @D21278, REFL @D21277, COUNT @D21276, PRD @D21275, 
      CASE @D21274, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CHANGE, 
   [COORD @D21282, REFL @D21281, PRD @D21280, CASE @D21279, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CHANGE, 
   [COORD @D21286, REFL @D21285, PRD @D21284, CASE @D21283, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : CHANGE, 
   [COORD @D21289, 
      AGR [COUNT @D21288, PER @D21287, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : CHANGE, 
   [COORD @D21291, AGR [COUNT @D21290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : CHANGE, 
   [COORD @D21293, AGR [COUNT @D21292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : CHANGE, 
   [COORD @D21297, AGR [COUNT @D21296, PER @D21295, PLU @D21294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : CHANGE, 
   [COORD @D21303, PAST @D21302, 
      AGR [CASE @D21301, COUNT @D21300, PER @D21299, PLU @D21298, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, 
      ARITY 3] : CHANGE, 
   [COORD @D21306, AGR [COUNT @D21305, PER @D21304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHANGE, 
   [COORD @D21308, AGR [COUNT @D21307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHANGE, 
   [COORD @D21310, AGR [COUNT @D21309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHANGE, 
   [COORD @D21314, AGR [COUNT @D21313, PER @D21312, PLU @D21311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHANGE, 
   [COORD @D21320, PAST @D21319, 
      AGR [CASE @D21318, COUNT @D21317, PER @D21316, PLU @D21315, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : CHANGE, 
   [COORD @D21323, AGR [COUNT @D21322, PER @D21321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHANGE, 
   [COORD @D21325, AGR [COUNT @D21324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHANGE, 
   [COORD @D21327, AGR [COUNT @D21326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHANGE, 
   [COORD @D21331, AGR [COUNT @D21330, PER @D21329, PLU @D21328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CHANGE, 
   [COORD @D21337, PAST @D21336, AGR [CASE @D21335, COUNT @D21334, 
            PER @D21333, PLU @D21332, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CHANGE, 
   [COORD @D21340, AGR [COUNT @D21339, PER @D21338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21342, AGR [COUNT @D21341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21344, AGR [COUNT @D21343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21348, AGR [COUNT @D21347, PER @D21346, PLU @D21345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21354, PAST @D21353, 
      AGR [CASE @D21352, COUNT @D21351, PER @D21350, PLU @D21349, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : CHANGE, 
   [COORD @D21357, AGR [COUNT @D21356, PER @D21355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21359, AGR [COUNT @D21358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21361, AGR [COUNT @D21360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21365, AGR [COUNT @D21364, PER @D21363, PLU @D21362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21371, PAST @D21370, 
      AGR [CASE @D21369, COUNT @D21368, PER @D21367, PLU @D21366, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21374, AGR [COUNT @D21373, PER @D21372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21376, AGR [COUNT @D21375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21378, AGR [COUNT @D21377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21382, AGR [COUNT @D21381, PER @D21380, PLU @D21379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OVER, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21388, PAST @D21387, 
      AGR [CASE @D21386, COUNT @D21385, PER @D21384, PLU @D21383, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OVER, 
      PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21391, AGR [COUNT @D21390, PER @D21389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21393, AGR [COUNT @D21392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21395, AGR [COUNT @D21394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21399, AGR [COUNT @D21398, PER @D21397, PLU @D21396, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT DOWN, PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21405, PAST @D21404, 
      AGR [CASE @D21403, COUNT @D21402, PER @D21401, PLU @D21400, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT DOWN, 
      PFORM TO, ARITY 2] : CHANGE, 
   [COORD @D21408, AGR [COUNT @D21407, PER @D21406, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : CHANGE, 
   [COORD @D21410, AGR [COUNT @D21409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : CHANGE, 
   [COORD @D21412, AGR [COUNT @D21411, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : CHANGE, 
   [COORD @D21416, AGR [COUNT @D21415, PER @D21414, PLU @D21413, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OUT_OF, ARITY 2] : CHANGE, 
   [COORD @D21422, PAST @D21421, 
      AGR [CASE @D21420, COUNT @D21419, PER @D21418, PLU @D21417, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OUT_OF, 
      ARITY 2] : CHANGE, 
   [COORD @D21425, AGR [COUNT @D21424, PER @D21423, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21427, AGR [COUNT @D21426, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21429, AGR [COUNT @D21428, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21433, AGR [COUNT @D21432, PER @D21431, PLU @D21430, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21439, PAST @D21438, 
      AGR [CASE @D21437, COUNT @D21436, PER @D21435, PLU @D21434, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM INTO, 
      ARITY 2] : CHANGE, 
   [COORD @D21442, AGR [COUNT @D21441, PER @D21440, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21444, AGR [COUNT @D21443, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21446, AGR [COUNT @D21445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21450, AGR [COUNT @D21449, PER @D21448, PLU @D21447, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21456, PAST @D21455, 
      AGR [CASE @D21454, COUNT @D21453, PER @D21452, PLU @D21451, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21459, AGR [COUNT @D21458, PER @D21457, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21461, AGR [COUNT @D21460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21463, AGR [COUNT @D21462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21467, AGR [COUNT @D21466, PER @D21465, PLU @D21464, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT DOWN, PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21473, PAST @D21472, 
      AGR [CASE @D21471, COUNT @D21470, PER @D21469, PLU @D21468, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT DOWN, 
      PFORM INTO, ARITY 2] : CHANGE, 
   [COORD @D21476, AGR [COUNT @D21475, PER @D21474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21478, AGR [COUNT @D21477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21480, AGR [COUNT @D21479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21484, AGR [COUNT @D21483, PER @D21482, PLU @D21481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21490, PAST @D21489, 
      AGR [CASE @D21488, COUNT @D21487, PER @D21486, PLU @D21485, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, 
      ARITY 2] : CHANGE, 
   [COORD @D21493, AGR [COUNT @D21492, PER @D21491, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21495, AGR [COUNT @D21494, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21497, AGR [COUNT @D21496, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21501, AGR [COUNT @D21500, PER @D21499, PLU @D21498, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OVER, PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21507, PAST @D21506, 
      AGR [CASE @D21505, COUNT @D21504, PER @D21503, PLU @D21502, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OVER, 
      PFORM FROM, ARITY 2] : CHANGE, 
   [COORD @D21510, AGR [COUNT @D21509, PER @D21508, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHANGE, 
   [COORD @D21512, AGR [COUNT @D21511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHANGE, 
   [COORD @D21514, AGR [COUNT @D21513, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHANGE, 
   [COORD @D21518, AGR [COUNT @D21517, PER @D21516, PLU @D21515, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHANGE, 
   [COORD @D21524, PAST @D21523, AGR [CASE @D21522, COUNT @D21521, 
            PER @D21520, PLU @D21519, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CHANGE, 
   [COORD @D21527, AGR [COUNT @D21526, PER @D21525, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CHANGE, 
   [COORD @D21529, AGR [COUNT @D21528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CHANGE, 
   [COORD @D21531, AGR [COUNT @D21530, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CHANGE, 
   [COORD @D21535, AGR [COUNT @D21534, PER @D21533, PLU @D21532, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CHANGE, 
   [COORD @D21541, PAST @D21540, 
      AGR [CASE @D21539, COUNT @D21538, PER @D21537, PLU @D21536, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CHANGE, 
   [COORD @D21544, AGR [COUNT @D21543, PER @D21542, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHANGE, 
   [COORD @D21546, AGR [COUNT @D21545, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHANGE, 
   [COORD @D21548, AGR [COUNT @D21547, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHANGE, 
   [COORD @D21552, AGR [COUNT @D21551, PER @D21550, PLU @D21549, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHANGE, 
   [COORD @D21558, PAST @D21557, 
      AGR [CASE @D21556, COUNT @D21555, PER @D21554, PLU @D21553, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : CHANGE, 
   [COORD @D21561, AGR [COUNT @D21560, PER @D21559, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CHANGE, 
   [COORD @D21563, AGR [COUNT @D21562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CHANGE, 
   [COORD @D21565, AGR [COUNT @D21564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CHANGE, 
   [COORD @D21569, AGR [COUNT @D21568, PER @D21567, PLU @D21566, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CHANGE, 
   [COORD @D21575, PAST @D21574, 
      AGR [CASE @D21573, COUNT @D21572, PER @D21571, PLU @D21570, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : CHANGE.

WORD changed : 
   [COORD @D21587, AGR [CASE @D21586, COUNT @D21585, PER @D21584, 
            PLU @D21583, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21592, AGR [CASE @D21591, COUNT @D21590, PER @D21589, 
            PLU @D21588, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21597, AGR [CASE @D21596, COUNT @D21595, PER @D21594, 
            PLU @D21593, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21602, AGR [CASE @D21601, COUNT @D21600, PER @D21599, 
            PLU @D21598, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21607, AGR [CASE @D21606, COUNT @D21605, PER @D21604, 
            PLU @D21603, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21612, AGR [CASE @D21611, COUNT @D21610, PER @D21609, 
            PLU @D21608, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21617, AGR [CASE @D21616, COUNT @D21615, PER @D21614, 
            PLU @D21613, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21622, AGR [CASE @D21621, COUNT @D21620, PER @D21619, 
            PLU @D21618, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21627, AGR [CASE @D21626, COUNT @D21625, PER @D21624, 
            PLU @D21623, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CHANGE, 
   [COORD @D21632, AGR [CASE @D21631, COUNT @D21630, PER @D21629, 
            PLU @D21628, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21637, AGR [CASE @D21636, COUNT @D21635, PER @D21634, 
            PLU @D21633, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21642, AGR [CASE @D21641, COUNT @D21640, PER @D21639, 
            PLU @D21638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21647, AGR [CASE @D21646, COUNT @D21645, PER @D21644, 
            PLU @D21643, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21652, AGR [CASE @D21651, COUNT @D21650, PER @D21649, 
            PLU @D21648, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21657, AGR [CASE @D21656, COUNT @D21655, PER @D21654, 
            PLU @D21653, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21662, AGR [CASE @D21661, COUNT @D21660, PER @D21659, 
            PLU @D21658, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21667, AGR [CASE @D21666, COUNT @D21665, PER @D21664, 
            PLU @D21663, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21672, AGR [CASE @D21671, COUNT @D21670, PER @D21669, 
            PLU @D21668, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21677, AGR [CASE @D21676, COUNT @D21675, PER @D21674, 
            PLU @D21673, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21682, AGR [CASE @D21681, COUNT @D21680, PER @D21679, 
            PLU @D21678, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21687, AGR [CASE @D21686, COUNT @D21685, PER @D21684, 
            PLU @D21683, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21692, AGR [CASE @D21691, COUNT @D21690, PER @D21689, 
            PLU @D21688, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21697, AGR [CASE @D21696, COUNT @D21695, PER @D21694, 
            PLU @D21693, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21702, AGR [CASE @D21701, COUNT @D21700, PER @D21699, 
            PLU @D21698, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21707, 
      AGR [CASE @D21706, COUNT @D21705, PER @D21704, PLU @D21703, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21712, AGR [CASE @D21711, COUNT @D21710, PER @D21709, 
            PLU @D21708, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21717, AGR [CASE @D21716, COUNT @D21715, PER @D21714, 
            PLU @D21713, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21722, AGR [CASE @D21721, COUNT @D21720, PER @D21719, 
            PLU @D21718, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21727, 
      AGR [CASE @D21726, COUNT @D21725, PER @D21724, PLU @D21723, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21732, AGR [CASE @D21731, COUNT @D21730, PER @D21729, 
            PLU @D21728, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21737, AGR [CASE @D21736, COUNT @D21735, PER @D21734, 
            PLU @D21733, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21742, AGR [CASE @D21741, COUNT @D21740, PER @D21739, 
            PLU @D21738, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21747, AGR [CASE @D21746, COUNT @D21745, PER @D21744, 
            PLU @D21743, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21752, AGR [CASE @D21751, COUNT @D21750, PER @D21749, 
            PLU @D21748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21757, AGR [CASE @D21756, COUNT @D21755, PER @D21754, 
            PLU @D21753, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21762, AGR [CASE @D21761, COUNT @D21760, PER @D21759, 
            PLU @D21758, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21767, AGR [CASE @D21766, COUNT @D21765, PER @D21764, 
            PLU @D21763, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHANGE.

WORD changes : 
   [COORD @D21779, DEMON @D21778, REFL @D21777, PRD @D21776, 
      CASE @D21775, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CHANGE, 
   [COORD @D21784, DEMON @D21783, REFL @D21782, PRD @D21781, 
      CASE @D21780, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CHANGE, 
   [COORD @D21789, DEMON @D21788, REFL @D21787, PRD @D21786, 
      CASE @D21785, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : CHANGE, 
   [COORD @D21794, DEMON @D21793, REFL @D21792, PRD @D21791, 
      CASE @D21790, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CHANGE, 
   [COORD @D21796, AGR [COUNT @D21795, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CHANGE, 
   [COORD @D21798, AGR [COUNT @D21797, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21800, 
      AGR [COUNT @D21799, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21802, 
      AGR [COUNT @D21801, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21804, 
      AGR [COUNT @D21803, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHANGE, 
   [COORD @D21806, AGR [COUNT @D21805, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHANGE, 
   [COORD @D21808, AGR [COUNT @D21807, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHANGE, 
   [COORD @D21810, AGR [COUNT @D21809, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21812, 
      AGR [COUNT @D21811, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21814, 
      AGR [COUNT @D21813, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHANGE, 
   [COORD @D21816, AGR [COUNT @D21815, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CHANGE, 
   [COORD @D21818, AGR [COUNT @D21817, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21820, 
      AGR [COUNT @D21819, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CHANGE, 
   [COORD @D21822, AGR [COUNT @D21821, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21824, 
      AGR [COUNT @D21823, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21826, 
      AGR [COUNT @D21825, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21828, 
      AGR [COUNT @D21827, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHANGE.

WORD changing : 
   [COORD @D21839, PRD @D21838, AGR [CASE @D21837, COUNT @D21836, 
            PER @D21835, PLU @D21834, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21845, PRD @D21844, 
      AGR [CASE @D21843, COUNT @D21842, PER @D21841, PLU @D21840, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHANGE, 
   [COORD @D21851, PRD @D21850, AGR [CASE @D21849, COUNT @D21848, 
            PER @D21847, PLU @D21846, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21857, PRD @D21856, 
      AGR [CASE @D21855, COUNT @D21854, PER @D21853, PLU @D21852, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHANGE, 
   [COORD @D21863, PRD @D21862, AGR [CASE @D21861, COUNT @D21860, 
            PER @D21859, PLU @D21858, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21869, PRD @D21868, 
      AGR [CASE @D21867, COUNT @D21866, PER @D21865, PLU @D21864, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CHANGE, 
   [COORD @D21875, PRD @D21874, AGR [CASE @D21873, COUNT @D21872, 
            PER @D21871, PLU @D21870, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21881, PRD @D21880, 
      AGR [CASE @D21879, COUNT @D21878, PER @D21877, PLU @D21876, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHANGE, 
   [COORD @D21887, PRD @D21886, AGR [CASE @D21885, COUNT @D21884, 
            PER @D21883, PLU @D21882, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21893, PRD @D21892, 
      AGR [CASE @D21891, COUNT @D21890, PER @D21889, PLU @D21888, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CHANGE, 
   [COORD @D21899, PRD @D21898, AGR [CASE @D21897, COUNT @D21896, 
            PER @D21895, PLU @D21894, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21905, PRD @D21904, 
      AGR [CASE @D21903, COUNT @D21902, PER @D21901, PLU @D21900, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHANGE, 
   [COORD @D21911, PRD @D21910, AGR [CASE @D21909, COUNT @D21908, 
            PER @D21907, PLU @D21906, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21917, PRD @D21916, 
      AGR [CASE @D21915, COUNT @D21914, PER @D21913, PLU @D21912, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CHANGE, 
   [COORD @D21923, PRD @D21922, AGR [CASE @D21921, COUNT @D21920, 
            PER @D21919, PLU @D21918, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE, 
   [COORD @D21929, PRD @D21928, 
      AGR [CASE @D21927, COUNT @D21926, PER @D21925, PLU @D21924, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHANGE, 
   [COORD @D21935, PRD @D21934, AGR [CASE @D21933, COUNT @D21932, 
            PER @D21931, PLU @D21930, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHANGE.

WORD charge : 
   [COORD @D21942, AGR [COUNT @D21941, PER @D21940, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : CHARGE, 
   [COORD @D21944, AGR [COUNT @D21943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : CHARGE, 
   [COORD @D21946, AGR [COUNT @D21945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : CHARGE, 
   [COORD @D21950, AGR [COUNT @D21949, PER @D21948, PLU @D21947, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : CHARGE, 
   [COORD @D21956, PAST @D21955, AGR [CASE @D21954, COUNT @D21953, 
            PER @D21952, PLU @D21951, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : CHARGE, 
   [COORD @D21959, AGR [COUNT @D21958, PER @D21957, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CHARGE, 
   [COORD @D21961, AGR [COUNT @D21960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CHARGE, 
   [COORD @D21963, AGR [COUNT @D21962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CHARGE, 
   [COORD @D21967, AGR [COUNT @D21966, PER @D21965, PLU @D21964, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CHARGE, 
   [COORD @D21973, PAST @D21972, 
      AGR [CASE @D21971, COUNT @D21970, PER @D21969, PLU @D21968, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : CHARGE, 
   [COORD @D21976, AGR [COUNT @D21975, PER @D21974, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CHARGE, 
   [COORD @D21978, AGR [COUNT @D21977, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CHARGE, 
   [COORD @D21980, AGR [COUNT @D21979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CHARGE, 
   [COORD @D21984, AGR [COUNT @D21983, PER @D21982, PLU @D21981, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CHARGE, 
   [COORD @D21990, PAST @D21989, 
      AGR [CASE @D21988, COUNT @D21987, PER @D21986, PLU @D21985, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : CHARGE, 
   [COORD @D21993, AGR [COUNT @D21992, PER @D21991, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHARGE, 
   [COORD @D21995, AGR [COUNT @D21994, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHARGE, 
   [COORD @D21997, AGR [COUNT @D21996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHARGE, 
   [COORD @D22001, AGR [COUNT @D22000, PER @D21999, PLU @D21998, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : CHARGE, 
   [COORD @D22007, PAST @D22006, 
      AGR [CASE @D22005, COUNT @D22004, PER @D22003, PLU @D22002, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : CHARGE, 
   [COORD @D22010, AGR [COUNT @D22009, PER @D22008, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM WITH, ORDER POSTNP, ARITY 3] : CHARGE, 
   [COORD @D22012, 
      AGR [COUNT @D22011, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM WITH, ORDER POSTNP, ARITY 3] : CHARGE, 
   [COORD @D22014, AGR [COUNT @D22013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM WITH, ORDER POSTNP, ARITY 3] : CHARGE, 
   [COORD @D22018, 
      AGR [COUNT @D22017, PER @D22016, PLU @D22015, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM WITH, ORDER POSTNP, ARITY 3] : CHARGE, 
   [COORD @D22024, PAST @D22023, 
      AGR [CASE @D22022, COUNT @D22021, PER @D22020, PLU @D22019, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM WITH, ORDER POSTNP, ARITY 3] : CHARGE, 
   [COORD @D22027, AGR [COUNT @D22026, PER @D22025, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHARGE, 
   [COORD @D22029, AGR [COUNT @D22028, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHARGE, 
   [COORD @D22031, AGR [COUNT @D22030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHARGE, 
   [COORD @D22035, AGR [COUNT @D22034, PER @D22033, PLU @D22032, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHARGE, 
   [COORD @D22041, PAST @D22040, AGR [CASE @D22039, COUNT @D22038, 
            PER @D22037, PLU @D22036, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : CHARGE, 
   [COORD @D22044, AGR [COUNT @D22043, PER @D22042, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHARGE, 
   [COORD @D22046, AGR [COUNT @D22045, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHARGE, 
   [COORD @D22048, AGR [COUNT @D22047, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHARGE, 
   [COORD @D22052, AGR [COUNT @D22051, PER @D22050, PLU @D22049, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CHARGE, 
   [COORD @D22058, PAST @D22057, AGR [CASE @D22056, COUNT @D22055, 
            PER @D22054, PLU @D22053, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CHARGE, 
   [COORD @D22061, AGR [COUNT @D22060, PER @D22059, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CHARGE, 
   [COORD @D22063, AGR [COUNT @D22062, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CHARGE, 
   [COORD @D22065, AGR [COUNT @D22064, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CHARGE, 
   [COORD @D22069, AGR [COUNT @D22068, PER @D22067, PLU @D22066, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : CHARGE, 
   [COORD @D22075, PAST @D22074, 
      AGR [CASE @D22073, COUNT @D22072, PER @D22071, PLU @D22070, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : CHARGE, 
   [COORD @D22078, AGR [COUNT @D22077, PER @D22076, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : CHARGE, 
   [COORD @D22080, AGR [COUNT @D22079, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : CHARGE, 
   [COORD @D22082, AGR [COUNT @D22081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : CHARGE, 
   [COORD @D22086, AGR [COUNT @D22085, PER @D22084, PLU @D22083, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : CHARGE, 
   [COORD @D22092, PAST @D22091, 
      AGR [CASE @D22090, COUNT @D22089, PER @D22088, PLU @D22087, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AT, 
      ARITY 2] : CHARGE, 
   [COORD @D22095, AGR [COUNT @D22094, PER @D22093, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHARGE, 
   [COORD @D22097, AGR [COUNT @D22096, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHARGE, 
   [COORD @D22099, AGR [COUNT @D22098, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHARGE, 
   [COORD @D22103, AGR [COUNT @D22102, PER @D22101, PLU @D22100, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHARGE, 
   [COORD @D22109, PAST @D22108, AGR [CASE @D22107, COUNT @D22106, 
            PER @D22105, PLU @D22104, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CHARGE.

WORD charged : 
   [COADV @D22122, COORD @D22121, DEF @D22120, PRD @D22119, AGR 
            [CASE @D22118, COUNT @D22117, PER @D22116, PLU @D22115, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   CHARGED, 
   [COADV @D22130, COORD @D22129, DEF @D22128, PRD @D22127, AGR 
            [CASE @D22126, COUNT @D22125, PER @D22124, PLU @D22123, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, DISTR PRD, 
      ARITY 2] : CHARGED, 
   [COORD @D22135, AGR [CASE @D22134, COUNT @D22133, PER @D22132, 
            PLU @D22131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22140, AGR [CASE @D22139, COUNT @D22138, PER @D22137, 
            PLU @D22136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22146, AGR [CASE @D22145, NFORM @D22144, COUNT @D22143, 
            PER @D22142, PLU @D22141, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CHARGE, 
   [COORD @D22151, AGR [CASE @D22150, COUNT @D22149, PER @D22148, 
            PLU @D22147, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22156, AGR [CASE @D22155, COUNT @D22154, PER @D22153, 
            PLU @D22152, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22161, AGR [CASE @D22160, COUNT @D22159, PER @D22158, 
            PLU @D22157, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22166, AGR [CASE @D22165, COUNT @D22164, PER @D22163, 
            PLU @D22162, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22171, AGR [CASE @D22170, COUNT @D22169, PER @D22168, 
            PLU @D22167, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22176, AGR [CASE @D22175, COUNT @D22174, PER @D22173, 
            PLU @D22172, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22181, AGR [CASE @D22180, COUNT @D22179, PER @D22178, 
            PLU @D22177, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22186, AGR [CASE @D22185, COUNT @D22184, PER @D22183, 
            PLU @D22182, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22191, AGR [CASE @D22190, COUNT @D22189, PER @D22188, 
            PLU @D22187, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22196, AGR [CASE @D22195, COUNT @D22194, PER @D22193, 
            PLU @D22192, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM WITH, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22201, 
      AGR [CASE @D22200, COUNT @D22199, PER @D22198, PLU @D22197, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM WITH, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22206, AGR [CASE @D22205, COUNT @D22204, PER @D22203, 
            PLU @D22202, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM WITH, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22211, 
      AGR [CASE @D22210, COUNT @D22209, PER @D22208, PLU @D22207, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHARGE, 
   [COORD @D22216, AGR [CASE @D22215, COUNT @D22214, PER @D22213, 
            PLU @D22212, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22221, AGR [UB @D22220, VFORM @D22219, SUBJ @D22218, 
            FIN @D22217, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CHARGE, 
   [COORD @D22226, AGR [CASE @D22225, COUNT @D22224, PER @D22223, 
            PLU @D22222, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22231, AGR [CASE @D22230, COUNT @D22229, PER @D22228, 
            PLU @D22227, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22236, AGR [CASE @D22235, COUNT @D22234, PER @D22233, 
            PLU @D22232, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CHARGE, 
   [COORD @D22241, AGR [CASE @D22240, COUNT @D22239, PER @D22238, 
            PLU @D22237, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22246, AGR [CASE @D22245, COUNT @D22244, PER @D22243, 
            PLU @D22242, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22251, AGR [CASE @D22250, COUNT @D22249, PER @D22248, 
            PLU @D22247, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22256, AGR [CASE @D22255, COUNT @D22254, PER @D22253, 
            PLU @D22252, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22261, AGR [CASE @D22260, COUNT @D22259, PER @D22258, 
            PLU @D22257, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22266, AGR [CASE @D22265, COUNT @D22264, PER @D22263, 
            PLU @D22262, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHARGE.

WORD charges : 
   [COORD @D22273, AGR [COUNT @D22272, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22275, 
      AGR [COUNT @D22274, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHARGE, 
   [COORD @D22277, AGR [COUNT @D22276, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22279, 
      AGR [COUNT @D22278, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22281, 
      AGR [COUNT @D22280, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM WITH, ORDER POSTNP, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CHARGE, 
   [COORD @D22283, AGR [COUNT @D22282, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22285, 
      AGR [COUNT @D22284, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22287, 
      AGR [COUNT @D22286, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22289, 
      AGR [COUNT @D22288, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22291, 
      AGR [COUNT @D22290, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHARGE.

WORD charging : 
   [COORD @D22301, PRD @D22300, AGR [CASE @D22299, COUNT @D22298, 
            PER @D22297, PLU @D22296, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22307, PRD @D22306, 
      AGR [CASE @D22305, COUNT @D22304, PER @D22303, PLU @D22302, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CHARGE, 
   [COORD @D22313, PRD @D22312, AGR [CASE @D22311, COUNT @D22310, 
            PER @D22309, PLU @D22308, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22319, PRD @D22318, 
      AGR [CASE @D22317, COUNT @D22316, PER @D22315, PLU @D22314, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHARGE, 
   [COORD @D22325, PRD @D22324, AGR [CASE @D22323, COUNT @D22322, 
            PER @D22321, PLU @D22320, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM WITH, ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CHARGE, 
   [COORD @D22331, PRD @D22330, AGR [CASE @D22329, COUNT @D22328, 
            PER @D22327, PLU @D22326, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22337, PRD @D22336, 
      AGR [CASE @D22335, COUNT @D22334, PER @D22333, PLU @D22332, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CHARGE, 
   [COORD @D22343, PRD @D22342, AGR [CASE @D22341, COUNT @D22340, 
            PER @D22339, PLU @D22338, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHARGE, 
   [COORD @D22349, PRD @D22348, 
      AGR [CASE @D22347, COUNT @D22346, PER @D22345, PLU @D22344, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHARGE, 
   [COORD @D22355, PRD @D22354, AGR [CASE @D22353, COUNT @D22352, 
            PER @D22351, PLU @D22350, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHARGE.

WORD check : 
   [COORD @D22362, REFL @D22361, PRD @D22360, CASE @D22359, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : CHECK, 
   [COORD @D22366, REFL @D22365, PRD @D22364, CASE @D22363, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CHEQUE_CARD, 
   [COORD @D22370, REFL @D22369, PRD @D22368, CASE @D22367, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CHECK, 
   [COORD @D22375, REFL @D22374, COUNT @D22373, PRD @D22372, 
      CASE @D22371, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CHECK, 
   [COORD @D22379, REFL @D22378, PRD @D22377, CASE @D22376, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : CHECK, 
   [COORD @D22382, 
      AGR [COUNT @D22381, PER @D22380, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM OF, ARITY 3] : CHECK, 
   [COORD @D22384, AGR [COUNT @D22383, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : CHECK, 
   [COORD @D22386, AGR 
         [COUNT @D22385, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, PFORM OF, 
      ARITY 3] : CHECK, 
   [COORD @D22390, AGR [COUNT @D22389, PER @D22388, PLU @D22387, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : CHECK, 
   [COORD @D22396, PAST @D22395, 
      AGR [CASE @D22394, COUNT @D22393, PER @D22392, PLU @D22391, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM OF, ARITY 3] : CHECK, 
   [COORD @D22399, AGR [COUNT @D22398, PER @D22397, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CHECK, 
   [COORD @D22401, AGR [COUNT @D22400, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CHECK, 
   [COORD @D22403, AGR [COUNT @D22402, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CHECK, 
   [COORD @D22407, AGR [COUNT @D22406, PER @D22405, PLU @D22404, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CHECK, 
   [COORD @D22413, PAST @D22412, AGR [CASE @D22411, COUNT @D22410, 
            PER @D22409, PLU @D22408, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : CHECK, 
   [COORD @D22416, AGR [COUNT @D22415, PER @D22414, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CHECK, 
   [COORD @D22418, AGR [COUNT @D22417, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CHECK, 
   [COORD @D22420, AGR [COUNT @D22419, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CHECK, 
   [COORD @D22424, AGR [COUNT @D22423, PER @D22422, PLU @D22421, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : CHECK, 
   [COORD @D22430, PAST @D22429, AGR [CASE @D22428, COUNT @D22427, 
            PER @D22426, PLU @D22425, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : CHECK, 
   [COORD @D22433, AGR [COUNT @D22432, PER @D22431, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHECK, 
   [COORD @D22435, AGR [COUNT @D22434, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHECK, 
   [COORD @D22437, AGR [COUNT @D22436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHECK, 
   [COORD @D22441, AGR [COUNT @D22440, PER @D22439, PLU @D22438, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CHECK, 
   [COORD @D22447, PAST @D22446, AGR [CASE @D22445, COUNT @D22444, 
            PER @D22443, PLU @D22442, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : CHECK, 
   [COORD @D22450, AGR [COUNT @D22449, PER @D22448, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHECK, 
   [COORD @D22452, AGR [COUNT @D22451, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHECK, 
   [COORD @D22454, AGR [COUNT @D22453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CHECK, 
   [COORD @D22458, AGR [COUNT @D22457, PER @D22456, PLU @D22455, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CHECK, 
   [COORD @D22464, PAST @D22463, AGR [CASE @D22462, COUNT @D22461, 
            PER @D22460, PLU @D22459, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CHECK, 
   [COORD @D22467, AGR [COUNT @D22466, PER @D22465, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM WITH, ARITY 2] : CHECK, 
   [COORD @D22469, AGR [COUNT @D22468, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM WITH, ARITY 2] : CHECK, 
   [COORD @D22471, AGR [COUNT @D22470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM WITH, ARITY 2] : CHECK, 
   [COORD @D22475, AGR [COUNT @D22474, PER @D22473, PLU @D22472, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM WITH, ARITY 2] : CHECK, 
   [COORD @D22481, PAST @D22480, 
      AGR [CASE @D22479, COUNT @D22478, PER @D22477, PLU @D22476, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM WITH, ARITY 2] : CHECK, 
   [COORD @D22484, AGR [COUNT @D22483, PER @D22482, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM TO, ARITY 2] : CHECK, 
   [COORD @D22486, AGR [COUNT @D22485, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM TO, ARITY 2] : CHECK, 
   [COORD @D22488, AGR [COUNT @D22487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM TO, ARITY 2] : CHECK, 
   [COORD @D22492, AGR [COUNT @D22491, PER @D22490, PLU @D22489, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM TO, ARITY 2] : CHECK, 
   [COORD @D22498, PAST @D22497, 
      AGR [CASE @D22496, COUNT @D22495, PER @D22494, PLU @D22493, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM TO, ARITY 2] : CHECK, 
   [COORD @D22501, AGR [COUNT @D22500, PER @D22499, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM ON, ARITY 2] : CHECK, 
   [COORD @D22503, AGR [COUNT @D22502, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM ON, ARITY 2] : CHECK, 
   [COORD @D22505, AGR [COUNT @D22504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM ON, ARITY 2] : CHECK, 
   [COORD @D22509, AGR [COUNT @D22508, PER @D22507, PLU @D22506, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM ON, ARITY 2] : CHECK, 
   [COORD @D22515, PAST @D22514, 
      AGR [CASE @D22513, COUNT @D22512, PER @D22511, PLU @D22510, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM ON, 
      ARITY 2] : CHECK, 
   [COORD @D22518, AGR [COUNT @D22517, PER @D22516, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : CHECK, 
   [COORD @D22520, AGR [COUNT @D22519, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : CHECK, 
   [COORD @D22522, AGR [COUNT @D22521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : CHECK, 
   [COORD @D22526, AGR [COUNT @D22525, PER @D22524, PLU @D22523, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : CHECK, 
   [COORD @D22532, PAST @D22531, 
      AGR [CASE @D22530, COUNT @D22529, PER @D22528, PLU @D22527, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : CHECK, 
   [COORD @D22535, AGR [COUNT @D22534, PER @D22533, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM AT, ARITY 2] : CHECK, 
   [COORD @D22537, AGR [COUNT @D22536, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM AT, ARITY 2] : CHECK, 
   [COORD @D22539, AGR [COUNT @D22538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM AT, ARITY 2] : CHECK, 
   [COORD @D22543, AGR [COUNT @D22542, PER @D22541, PLU @D22540, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM AT, ARITY 2] : CHECK, 
   [COORD @D22549, PAST @D22548, 
      AGR [CASE @D22547, COUNT @D22546, PER @D22545, PLU @D22544, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM AT, ARITY 2] : CHECK, 
   [COORD @D22552, AGR [COUNT @D22551, PER @D22550, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CHECK, 
   [COORD @D22554, AGR [COUNT @D22553, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CHECK, 
   [COORD @D22556, AGR [COUNT @D22555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CHECK, 
   [COORD @D22560, AGR [COUNT @D22559, PER @D22558, PLU @D22557, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : CHECK, 
   [COORD @D22566, PAST @D22565, 
      AGR [CASE @D22564, COUNT @D22563, PER @D22562, PLU @D22561, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : CHECK, 
   [COORD @D22569, AGR [COUNT @D22568, PER @D22567, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CHECK, 
   [COORD @D22571, AGR [COUNT @D22570, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CHECK, 
   [COORD @D22573, AGR [COUNT @D22572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CHECK, 
   [COORD @D22577, AGR [COUNT @D22576, PER @D22575, PLU @D22574, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : CHECK, 
   [COORD @D22583, PAST @D22582, 
      AGR [CASE @D22581, COUNT @D22580, PER @D22579, PLU @D22578, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : CHECK, 
   [COORD @D22586, AGR [COUNT @D22585, PER @D22584, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CHECK, 
   [COORD @D22588, AGR [COUNT @D22587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CHECK, 
   [COORD @D22590, AGR [COUNT @D22589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CHECK, 
   [COORD @D22594, AGR [COUNT @D22593, PER @D22592, PLU @D22591, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : CHECK, 
   [COORD @D22600, PAST @D22599, 
      AGR [CASE @D22598, COUNT @D22597, PER @D22596, PLU @D22595, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : CHECK, 
   [COORD @D22603, AGR [COUNT @D22602, PER @D22601, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : CHECK, 
   [COORD @D22605, AGR [COUNT @D22604, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : CHECK, 
   [COORD @D22607, AGR [COUNT @D22606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : CHECK, 
   [COORD @D22611, AGR [COUNT @D22610, PER @D22609, PLU @D22608, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : CHECK, 
   [COORD @D22617, PAST @D22616, 
      AGR [CASE @D22615, COUNT @D22614, PER @D22613, PLU @D22612, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : CHECK, 
   [COORD @D22620, AGR [COUNT @D22619, PER @D22618, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHECK, 
   [COORD @D22622, AGR [COUNT @D22621, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHECK, 
   [COORD @D22624, AGR [COUNT @D22623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHECK, 
   [COORD @D22628, AGR [COUNT @D22627, PER @D22626, PLU @D22625, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CHECK, 
   [COORD @D22634, PAST @D22633, AGR [CASE @D22632, COUNT @D22631, 
            PER @D22630, PLU @D22629, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CHECK, 
   [COORD @D22637, AGR [COUNT @D22636, PER @D22635, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHECK, 
   [COORD @D22639, AGR [COUNT @D22638, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHECK, 
   [COORD @D22641, AGR [COUNT @D22640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHECK, 
   [COORD @D22645, AGR [COUNT @D22644, PER @D22643, PLU @D22642, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : CHECK, 
   [COORD @D22651, PAST @D22650, 
      AGR [CASE @D22649, COUNT @D22648, PER @D22647, PLU @D22646, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : CHECK, 
   [COORD @D22654, AGR [COUNT @D22653, PER @D22652, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CHECK, 
   [COORD @D22656, AGR [COUNT @D22655, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CHECK, 
   [COORD @D22658, AGR [COUNT @D22657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CHECK, 
   [COORD @D22662, AGR [COUNT @D22661, PER @D22660, PLU @D22659, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CHECK, 
   [COORD @D22668, PAST @D22667, 
      AGR [CASE @D22666, COUNT @D22665, PER @D22664, PLU @D22663, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CHECK, 
   [COORD @D22671, AGR [COUNT @D22670, PER @D22669, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CHECK, 
   [COORD @D22673, AGR [COUNT @D22672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CHECK, 
   [COORD @D22675, AGR [COUNT @D22674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CHECK, 
   [COORD @D22679, AGR [COUNT @D22678, PER @D22677, PLU @D22676, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CHECK, 
   [COORD @D22685, PAST @D22684, 
      AGR [CASE @D22683, COUNT @D22682, PER @D22681, PLU @D22680, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : CHECK, 
   [COORD @D22688, AGR [COUNT @D22687, PER @D22686, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CHECK, 
   [COORD @D22690, AGR [COUNT @D22689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CHECK, 
   [COORD @D22692, AGR [COUNT @D22691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CHECK, 
   [COORD @D22696, AGR [COUNT @D22695, PER @D22694, PLU @D22693, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CHECK, 
   [COORD @D22702, PAST @D22701, 
      AGR [CASE @D22700, COUNT @D22699, PER @D22698, PLU @D22697, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : CHECK.

WORD checked : 
   [COORD @D22712, AGR [CASE @D22711, COUNT @D22710, PER @D22709, 
            PLU @D22708, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22717, AGR [CASE @D22716, COUNT @D22715, PER @D22714, 
            PLU @D22713, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22722, 
      AGR [CASE @D22721, COUNT @D22720, PER @D22719, PLU @D22718, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22727, AGR [CASE @D22726, COUNT @D22725, PER @D22724, 
            PLU @D22723, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22732, AGR [CASE @D22731, COUNT @D22730, PER @D22729, 
            PLU @D22728, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22737, AGR [CASE @D22736, COUNT @D22735, PER @D22734, 
            PLU @D22733, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22742, AGR [CASE @D22741, COUNT @D22740, PER @D22739, 
            PLU @D22738, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22747, AGR [CASE @D22746, COUNT @D22745, PER @D22744, 
            PLU @D22743, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22752, AGR [CASE @D22751, COUNT @D22750, PER @D22749, 
            PLU @D22748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22757, AGR [UB @D22756, VFORM @D22755, SUBJ @D22754, 
            FIN @D22753, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CHECK, 
   [COORD @D22762, AGR [CASE @D22761, COUNT @D22760, PER @D22759, 
            PLU @D22758, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CHECK, 
   [COORD @D22767, AGR [CASE @D22766, COUNT @D22765, PER @D22764, 
            PLU @D22763, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22772, AGR [CASE @D22771, COUNT @D22770, PER @D22769, 
            PLU @D22768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22777, AGR [CASE @D22776, COUNT @D22775, PER @D22774, 
            PLU @D22773, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22782, 
      AGR [CASE @D22781, COUNT @D22780, PER @D22779, PLU @D22778, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : CHECK, 
   [COORD @D22787, AGR [CASE @D22786, COUNT @D22785, PER @D22784, 
            PLU @D22783, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22792, AGR [CASE @D22791, COUNT @D22790, PER @D22789, 
            PLU @D22788, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22797, AGR [CASE @D22796, COUNT @D22795, PER @D22794, 
            PLU @D22793, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22802, AGR [CASE @D22801, COUNT @D22800, PER @D22799, 
            PLU @D22798, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22807, AGR [CASE @D22806, COUNT @D22805, PER @D22804, 
            PLU @D22803, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22812, AGR [CASE @D22811, COUNT @D22810, PER @D22809, 
            PLU @D22808, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22817, AGR [CASE @D22816, COUNT @D22815, PER @D22814, 
            PLU @D22813, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22822, AGR [CASE @D22821, COUNT @D22820, PER @D22819, 
            PLU @D22818, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22827, AGR [CASE @D22826, COUNT @D22825, PER @D22824, 
            PLU @D22823, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22832, AGR [CASE @D22831, COUNT @D22830, PER @D22829, 
            PLU @D22828, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22837, AGR [CASE @D22836, COUNT @D22835, PER @D22834, 
            PLU @D22833, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22842, AGR [CASE @D22841, COUNT @D22840, PER @D22839, 
            PLU @D22838, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22847, AGR [CASE @D22846, COUNT @D22845, PER @D22844, 
            PLU @D22843, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22852, AGR [CASE @D22851, COUNT @D22850, PER @D22849, 
            PLU @D22848, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22857, AGR [CASE @D22856, COUNT @D22855, PER @D22854, 
            PLU @D22853, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22862, AGR [CASE @D22861, COUNT @D22860, PER @D22859, 
            PLU @D22858, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22867, AGR [CASE @D22866, COUNT @D22865, PER @D22864, 
            PLU @D22863, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22872, AGR [CASE @D22871, COUNT @D22870, PER @D22869, 
            PLU @D22868, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22877, AGR [CASE @D22876, COUNT @D22875, PER @D22874, 
            PLU @D22873, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22882, AGR [CASE @D22881, COUNT @D22880, PER @D22879, 
            PLU @D22878, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22887, AGR [CASE @D22886, COUNT @D22885, PER @D22884, 
            PLU @D22883, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22892, AGR [CASE @D22891, COUNT @D22890, PER @D22889, 
            PLU @D22888, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22897, AGR [CASE @D22896, COUNT @D22895, PER @D22894, 
            PLU @D22893, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22902, AGR [CASE @D22901, COUNT @D22900, PER @D22899, 
            PLU @D22898, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22907, AGR [CASE @D22906, COUNT @D22905, PER @D22904, 
            PLU @D22903, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22912, AGR [CASE @D22911, COUNT @D22910, PER @D22909, 
            PLU @D22908, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22917, AGR [CASE @D22916, COUNT @D22915, PER @D22914, 
            PLU @D22913, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22922, AGR [CASE @D22921, COUNT @D22920, PER @D22919, 
            PLU @D22918, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22927, AGR [CASE @D22926, COUNT @D22925, PER @D22924, 
            PLU @D22923, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22932, AGR [CASE @D22931, COUNT @D22930, PER @D22929, 
            PLU @D22928, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22937, AGR [CASE @D22936, COUNT @D22935, PER @D22934, 
            PLU @D22933, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CHECK.

WORD checking : 
   [COORD @D22952, PRD @D22951, AGR [CASE @D22950, COUNT @D22949, 
            PER @D22948, PLU @D22947, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22958, PRD @D22957, 
      AGR [CASE @D22956, COUNT @D22955, PER @D22954, PLU @D22953, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CHECK, 
   [COORD @D22964, PRD @D22963, AGR [CASE @D22962, COUNT @D22961, 
            PER @D22960, PLU @D22959, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22970, PRD @D22969, 
      AGR [CASE @D22968, COUNT @D22967, PER @D22966, PLU @D22965, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CHECK, 
   [COORD @D22976, PRD @D22975, AGR [CASE @D22974, COUNT @D22973, 
            PER @D22972, PLU @D22971, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22982, PRD @D22981, 
      AGR [CASE @D22980, COUNT @D22979, PER @D22978, PLU @D22977, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CHECK, 
   [COORD @D22988, PRD @D22987, AGR [CASE @D22986, COUNT @D22985, 
            PER @D22984, PLU @D22983, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D22994, PRD @D22993, 
      AGR [CASE @D22992, COUNT @D22991, PER @D22990, PLU @D22989, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CHECK, 
   [COORD @D23000, PRD @D22999, AGR [CASE @D22998, COUNT @D22997, 
            PER @D22996, PLU @D22995, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D23006, PRD @D23005, 
      AGR [CASE @D23004, COUNT @D23003, PER @D23002, PLU @D23001, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CHECK, 
   [COORD @D23012, PRD @D23011, AGR [CASE @D23010, COUNT @D23009, 
            PER @D23008, PLU @D23007, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D23018, PRD @D23017, 
      AGR [CASE @D23016, COUNT @D23015, PER @D23014, PLU @D23013, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHECK, 
   [COORD @D23024, PRD @D23023, AGR [CASE @D23022, COUNT @D23021, 
            PER @D23020, PLU @D23019, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D23030, PRD @D23029, 
      AGR [CASE @D23028, COUNT @D23027, PER @D23026, PLU @D23025, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHECK, 
   [COORD @D23036, PRD @D23035, AGR [CASE @D23034, COUNT @D23033, 
            PER @D23032, PLU @D23031, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D23042, PRD @D23041, 
      AGR [CASE @D23040, COUNT @D23039, PER @D23038, PLU @D23037, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHECK, 
   [COORD @D23048, PRD @D23047, AGR [CASE @D23046, COUNT @D23045, 
            PER @D23044, PLU @D23043, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK, 
   [COORD @D23054, PRD @D23053, 
      AGR [CASE @D23052, COUNT @D23051, PER @D23050, PLU @D23049, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CHECK, 
   [COORD @D23060, PRD @D23059, AGR [CASE @D23058, COUNT @D23057, 
            PER @D23056, PLU @D23055, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CHECK.

WORD checks : 
   [COORD @D23070, DEMON @D23069, REFL @D23068, PRD @D23067, CASE 
         @D23066, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CHEQUE_CARD, 
   [COORD @D23075, DEMON @D23074, REFL @D23073, PRD @D23072, 
      CASE @D23071, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CHECK, 
   [COORD @D23080, DEMON @D23079, REFL @D23078, PRD @D23077, 
      CASE @D23076, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CHECK, 
   [COORD @D23082, AGR [COUNT @D23081, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CHECK, 
   [COORD @D23084, AGR [COUNT @D23083, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23086, 
      AGR [COUNT @D23085, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23088, 
      AGR [COUNT @D23087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23090, 
      AGR [COUNT @D23089, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23092, 
      AGR [COUNT @D23091, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHECK, 
   [COORD @D23094, AGR [COUNT @D23093, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHECK, 
   [COORD @D23096, AGR [COUNT @D23095, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CHECK, 
   [COORD @D23098, AGR [COUNT @D23097, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHECK, 
   [COORD @D23100, AGR [COUNT @D23099, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CHECK, 
   [COORD @D23102, AGR [COUNT @D23101, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23104, 
      AGR [COUNT @D23103, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23106, 
      AGR [COUNT @D23105, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23108, 
      AGR [COUNT @D23107, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23110, 
      AGR [COUNT @D23109, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23112, 
      AGR [COUNT @D23111, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23114, 
      AGR [COUNT @D23113, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23116, 
      AGR [COUNT @D23115, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK, 
   [COORD @D23118, 
      AGR [COUNT @D23117, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CHECK.

WORD chef : 
   [COORD @D23125, REFL @D23124, PRD @D23123, CASE @D23122, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CHEF.

WORD chefs : 
   [COORD @D23134, DEMON @D23133, REFL @D23132, PRD @D23131, CASE 
         @D23130, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CHEF.

WORD chick : 
   [COORD @D23141, REFL @D23140, PRD @D23139, CASE @D23138, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, ADDRESS +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CHICK, 
   [COORD @D23145, REFL @D23144, PRD @D23143, CASE @D23142, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CHICK.

WORD chicks : 
   [COORD @D23154, DEMON @D23153, REFL @D23152, PRD @D23151, CASE 
         @D23150, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CHICK.

WORD claim : 
   [COORD @D23170, REFL @D23169, COUNT @D23168, PRD @D23167, CASE 
         @D23166, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CLAIM, 
   [COORD @D23174, REFL @D23173, PRD @D23172, CASE @D23171, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : CLAIM, 
   [COORD @D23178, REFL @D23177, PRD @D23176, CASE @D23175, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : CLAIM, 
   [COORD @D23182, REFL @D23181, PRD @D23180, CASE @D23179, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF, COUNT +] : CLAIM, 
   [COORD @D23186, REFL @D23185, PRD @D23184, CASE @D23183, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : CLAIM, 
   [COORD @D23190, REFL @D23189, PRD @D23188, CASE @D23187, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, COUNT +] : CLAIM, 
   [COORD @D23193, 
      AGR [COUNT @D23192, PER @D23191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   CLAIM, 
   [COORD @D23195, AGR [COUNT @D23194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CLAIM, 
   [COORD @D23197, AGR [COUNT @D23196, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CLAIM, 
   [COORD @D23201, AGR [COUNT @D23200, PER @D23199, PLU @D23198, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CLAIM, 
   [COORD @D23207, PAST @D23206, AGR [CASE @D23205, COUNT @D23204, 
            PER @D23203, PLU @D23202, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : CLAIM, 
   [COORD @D23210, AGR [COUNT @D23209, PER @D23208, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CLAIM, 
   [COORD @D23212, AGR [COUNT @D23211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CLAIM, 
   [COORD @D23214, AGR [COUNT @D23213, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CLAIM, 
   [COORD @D23218, AGR [COUNT @D23217, PER @D23216, PLU @D23215, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : CLAIM, 
   [COORD @D23224, PAST @D23223, AGR [CASE @D23222, COUNT @D23221, 
            PER @D23220, PLU @D23219, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : CLAIM, 
   [COORD @D23227, AGR [COUNT @D23226, PER @D23225, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CLAIM, 
   [COORD @D23229, AGR [COUNT @D23228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CLAIM, 
   [COORD @D23231, AGR [COUNT @D23230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CLAIM, 
   [COORD @D23235, AGR [COUNT @D23234, PER @D23233, PLU @D23232, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CLAIM, 
   [COORD @D23241, PAST @D23240, AGR [CASE @D23239, COUNT @D23238, 
            PER @D23237, PLU @D23236, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : CLAIM, 
   [COORD @D23244, AGR [COUNT @D23243, PER @D23242, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLAIM, 
   [COORD @D23246, AGR [COUNT @D23245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLAIM, 
   [COORD @D23248, AGR [COUNT @D23247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLAIM, 
   [COORD @D23252, AGR [COUNT @D23251, PER @D23250, PLU @D23249, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CLAIM, 
   [COORD @D23258, PAST @D23257, AGR [CASE @D23256, COUNT @D23255, 
            PER @D23254, PLU @D23253, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CLAIM, 
   [COORD @D23261, AGR [COUNT @D23260, PER @D23259, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : CLAIM, 
   [COORD @D23263, AGR [COUNT @D23262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : CLAIM, 
   [COORD @D23265, AGR [COUNT @D23264, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : CLAIM, 
   [COORD @D23269, AGR [COUNT @D23268, PER @D23267, PLU @D23266, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : CLAIM, 
   [COORD @D23275, PAST @D23274, 
      AGR [CASE @D23273, COUNT @D23272, PER @D23271, PLU @D23270, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      ARITY 2] : CLAIM, 
   [COORD @D23278, AGR [COUNT @D23277, PER @D23276, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CLAIM, 
   [COORD @D23280, AGR [COUNT @D23279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CLAIM, 
   [COORD @D23282, AGR [COUNT @D23281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CLAIM, 
   [COORD @D23286, AGR [COUNT @D23285, PER @D23284, PLU @D23283, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : CLAIM, 
   [COORD @D23292, PAST @D23291, 
      AGR [CASE @D23290, COUNT @D23289, PER @D23288, PLU @D23287, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : CLAIM, 
   [COORD @D23295, AGR [COUNT @D23294, PER @D23293, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLAIM, 
   [COORD @D23297, AGR [COUNT @D23296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLAIM, 
   [COORD @D23299, AGR [COUNT @D23298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLAIM, 
   [COORD @D23303, AGR [COUNT @D23302, PER @D23301, PLU @D23300, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLAIM, 
   [COORD @D23309, PAST @D23308, AGR [CASE @D23307, COUNT @D23306, 
            PER @D23305, PLU @D23304, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CLAIM.

WORD claimed : 
   [COORD @D23319, AGR [UB @D23318, VFORM @D23317, SUBJ @D23316, 
            FIN @D23315, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CLAIM, 
   [COORD @D23324, AGR [CASE @D23323, COUNT @D23322, PER @D23321, 
            PLU @D23320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23329, AGR [CASE @D23328, COUNT @D23327, PER @D23326, 
            PLU @D23325, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23334, AGR [CASE @D23333, COUNT @D23332, PER @D23331, 
            PLU @D23330, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23339, AGR [CASE @D23338, COUNT @D23337, PER @D23336, 
            PLU @D23335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23344, AGR [CASE @D23343, COUNT @D23342, PER @D23341, 
            PLU @D23340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23349, AGR [CASE @D23348, COUNT @D23347, PER @D23346, 
            PLU @D23345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23355, AGR [CASE @D23354, NFORM @D23353, COUNT @D23352, 
            PER @D23351, PLU @D23350, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CLAIM, 
   [COORD @D23360, AGR [UB @D23359, VFORM @D23358, SUBJ @D23357, 
            FIN @D23356, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CLAIM, 
   [COORD @D23365, AGR [CASE @D23364, COUNT @D23363, PER @D23362, 
            PLU @D23361, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23370, AGR [CASE @D23369, COUNT @D23368, PER @D23367, 
            PLU @D23366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23375, AGR [CASE @D23374, COUNT @D23373, PER @D23372, 
            PLU @D23371, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CLAIM, 
   [COORD @D23380, AGR [CASE @D23379, COUNT @D23378, PER @D23377, 
            PLU @D23376, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23385, AGR [CASE @D23384, COUNT @D23383, PER @D23382, 
            PLU @D23381, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23390, AGR [CASE @D23389, COUNT @D23388, PER @D23387, 
            PLU @D23386, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23395, AGR [CASE @D23394, COUNT @D23393, PER @D23392, 
            PLU @D23391, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23400, AGR [CASE @D23399, COUNT @D23398, PER @D23397, 
            PLU @D23396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23405, AGR [CASE @D23404, COUNT @D23403, PER @D23402, 
            PLU @D23401, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLAIM.

WORD claiming : 
   [COORD @D23420, PRD @D23419, AGR [CASE @D23418, COUNT @D23417, 
            PER @D23416, PLU @D23415, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23426, PRD @D23425, 
      AGR [CASE @D23424, COUNT @D23423, PER @D23422, PLU @D23421, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CLAIM, 
   [COORD @D23432, PRD @D23431, AGR [CASE @D23430, COUNT @D23429, 
            PER @D23428, PLU @D23427, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23438, PRD @D23437, 
      AGR [CASE @D23436, COUNT @D23435, PER @D23434, PLU @D23433, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CLAIM, 
   [COORD @D23444, PRD @D23443, AGR [CASE @D23442, COUNT @D23441, 
            PER @D23440, PLU @D23439, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23450, PRD @D23449, 
      AGR [CASE @D23448, COUNT @D23447, PER @D23446, PLU @D23445, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLAIM, 
   [COORD @D23456, PRD @D23455, AGR [CASE @D23454, COUNT @D23453, 
            PER @D23452, PLU @D23451, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLAIM.

WORD claims : 
   [COORD @D23466, DEMON @D23465, REFL @D23464, PRD @D23463, CASE 
         @D23462, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CLAIM, 
   [COORD @D23471, DEMON @D23470, REFL @D23469, PRD @D23468, 
      CASE @D23467, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CLAIM, 
   [COORD @D23476, DEMON @D23475, REFL @D23474, PRD @D23473, CASE 
         @D23472, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CLAIM, 
   [COORD @D23481, DEMON @D23480, REFL @D23479, PRD @D23478, CASE 
         @D23477, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CLAIM, 
   [COORD @D23486, DEMON @D23485, REFL @D23484, PRD @D23483, 
      CASE @D23482, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CLAIM, 
   [COORD @D23491, DEMON @D23490, REFL @D23489, PRD @D23488, CASE 
         @D23487, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SFIN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CLAIM, 
   [COORD @D23493, 
      AGR [COUNT @D23492, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23495, 
      AGR [COUNT @D23494, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23497, 
      AGR [COUNT @D23496, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23499, 
      AGR [COUNT @D23498, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23501, 
      AGR [COUNT @D23500, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23503, 
      AGR [COUNT @D23502, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLAIM, 
   [COORD @D23505, 
      AGR [COUNT @D23504, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLAIM.

WORD clean : 
   [COORD @D23511, AGR [COUNT @D23510, PER @D23509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLEAN, 
   [COORD @D23513, AGR [COUNT @D23512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLEAN, 
   [COORD @D23515, AGR [COUNT @D23514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLEAN, 
   [COORD @D23519, AGR [COUNT @D23518, PER @D23517, PLU @D23516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CLEAN, 
   [COORD @D23525, PAST @D23524, AGR [CASE @D23523, COUNT @D23522, 
            PER @D23521, PLU @D23520, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CLEAN, 
   [COORD @D23528, AGR [COUNT @D23527, PER @D23526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLEAN, 
   [COORD @D23530, AGR [COUNT @D23529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLEAN, 
   [COORD @D23532, AGR [COUNT @D23531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLEAN, 
   [COORD @D23536, AGR [COUNT @D23535, PER @D23534, PLU @D23533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : CLEAN, 
   [COORD @D23542, PAST @D23541, 
      AGR [CASE @D23540, COUNT @D23539, PER @D23538, PLU @D23537, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : CLEAN, 
   [COORD @D23545, AGR [COUNT @D23544, PER @D23543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLEAN, 
   [COORD @D23547, AGR [COUNT @D23546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLEAN, 
   [COORD @D23549, AGR [COUNT @D23548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLEAN, 
   [COORD @D23553, AGR [COUNT @D23552, PER @D23551, PLU @D23550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : CLEAN, 
   [COORD @D23559, PAST @D23558, 
      AGR [CASE @D23557, COUNT @D23556, PER @D23555, PLU @D23554, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : CLEAN, 
   [COORD @D23562, AGR [COUNT @D23561, PER @D23560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLEAN, 
   [COORD @D23564, AGR [COUNT @D23563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLEAN, 
   [COORD @D23566, AGR [COUNT @D23565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLEAN, 
   [COORD @D23570, AGR [COUNT @D23569, PER @D23568, PLU @D23567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : CLEAN, 
   [COORD @D23576, PAST @D23575, 
      AGR [CASE @D23574, COUNT @D23573, PER @D23572, PLU @D23571, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLEAN, 
   [COORD @D23579, AGR [COUNT @D23578, PER @D23577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAN, 
   [COORD @D23581, AGR [COUNT @D23580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAN, 
   [COORD @D23583, AGR [COUNT @D23582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAN, 
   [COORD @D23587, AGR [COUNT @D23586, PER @D23585, PLU @D23584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAN, 
   [COORD @D23593, PAST @D23592, AGR [CASE @D23591, COUNT @D23590, 
            PER @D23589, PLU @D23588, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CLEAN, 
   [COORD @D23596, AGR [COUNT @D23595, PER @D23594, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAN, 
   [COORD @D23598, AGR [COUNT @D23597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAN, 
   [COORD @D23600, AGR [COUNT @D23599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAN, 
   [COORD @D23604, AGR [COUNT @D23603, PER @D23602, PLU @D23601, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAN, 
   [COORD @D23610, PAST @D23609, 
      AGR [CASE @D23608, COUNT @D23607, PER @D23606, PLU @D23605, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CLEAN, 
   [COORD @D23613, AGR [COUNT @D23612, PER @D23611, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAN, 
   [COORD @D23615, AGR [COUNT @D23614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAN, 
   [COORD @D23617, AGR [COUNT @D23616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAN, 
   [COORD @D23621, AGR [COUNT @D23620, PER @D23619, PLU @D23618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAN, 
   [COORD @D23627, PAST @D23626, 
      AGR [CASE @D23625, COUNT @D23624, PER @D23623, PLU @D23622, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CLEAN, 
   [COORD @D23630, AGR [COUNT @D23629, PER @D23628, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLEAN, 
   [COORD @D23632, AGR [COUNT @D23631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLEAN, 
   [COORD @D23634, AGR [COUNT @D23633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLEAN, 
   [COORD @D23638, AGR [COUNT @D23637, PER @D23636, PLU @D23635, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLEAN, 
   [COORD @D23644, PAST @D23643, 
      AGR [CASE @D23642, COUNT @D23641, PER @D23640, PLU @D23639, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : CLEAN.

WORD cleaned : 
   [COORD @D23653, AGR [CASE @D23652, COUNT @D23651, PER @D23650, 
            PLU @D23649, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CLEAN, 
   [COORD @D23658, AGR [CASE @D23657, COUNT @D23656, PER @D23655, 
            PLU @D23654, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23663, AGR [CASE @D23662, COUNT @D23661, PER @D23660, 
            PLU @D23659, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23668, AGR [CASE @D23667, COUNT @D23666, PER @D23665, 
            PLU @D23664, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23673, AGR [CASE @D23672, COUNT @D23671, PER @D23670, 
            PLU @D23669, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23678, AGR [CASE @D23677, COUNT @D23676, PER @D23675, 
            PLU @D23674, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23683, AGR [CASE @D23682, COUNT @D23681, PER @D23680, 
            PLU @D23679, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23688, AGR [CASE @D23687, COUNT @D23686, PER @D23685, 
            PLU @D23684, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23693, AGR [CASE @D23692, COUNT @D23691, PER @D23690, 
            PLU @D23689, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23698, AGR [CASE @D23697, COUNT @D23696, PER @D23695, 
            PLU @D23694, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23703, AGR [CASE @D23702, COUNT @D23701, PER @D23700, 
            PLU @D23699, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23708, AGR [CASE @D23707, COUNT @D23706, PER @D23705, 
            PLU @D23704, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23713, AGR [CASE @D23712, COUNT @D23711, PER @D23710, 
            PLU @D23709, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23718, AGR [CASE @D23717, COUNT @D23716, PER @D23715, 
            PLU @D23714, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23723, AGR [CASE @D23722, COUNT @D23721, PER @D23720, 
            PLU @D23719, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23728, AGR [CASE @D23727, COUNT @D23726, PER @D23725, 
            PLU @D23724, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23733, AGR [CASE @D23732, COUNT @D23731, PER @D23730, 
            PLU @D23729, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23738, AGR [CASE @D23737, COUNT @D23736, PER @D23735, 
            PLU @D23734, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23743, AGR [CASE @D23742, COUNT @D23741, PER @D23740, 
            PLU @D23739, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23748, AGR [CASE @D23747, COUNT @D23746, PER @D23745, 
            PLU @D23744, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAN.

WORD cleaning : 
   [COORD @D23760, PRD @D23759, AGR [CASE @D23758, COUNT @D23757, 
            PER @D23756, PLU @D23755, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23766, PRD @D23765, 
      AGR [CASE @D23764, COUNT @D23763, PER @D23762, PLU @D23761, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAN, 
   [COORD @D23772, PRD @D23771, AGR [CASE @D23770, COUNT @D23769, 
            PER @D23768, PLU @D23767, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23778, PRD @D23777, 
      AGR [CASE @D23776, COUNT @D23775, PER @D23774, PLU @D23773, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAN, 
   [COORD @D23784, PRD @D23783, AGR [CASE @D23782, COUNT @D23781, 
            PER @D23780, PLU @D23779, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23790, PRD @D23789, 
      AGR [CASE @D23788, COUNT @D23787, PER @D23786, PLU @D23785, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAN, 
   [COORD @D23796, PRD @D23795, AGR [CASE @D23794, COUNT @D23793, 
            PER @D23792, PLU @D23791, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23802, PRD @D23801, 
      AGR [CASE @D23800, COUNT @D23799, PER @D23798, PLU @D23797, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAN.

WORD cleans : 
   [COORD @D23808, AGR [COUNT @D23807, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23810, 
      AGR [COUNT @D23809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23812, 
      AGR [COUNT @D23811, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23814, 
      AGR [COUNT @D23813, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23816, 
      AGR [COUNT @D23815, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23818, 
      AGR [COUNT @D23817, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23820, 
      AGR [COUNT @D23819, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN, 
   [COORD @D23822, 
      AGR [COUNT @D23821, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAN.

WORD clear : 
   [COORD @D23828, AGR [COUNT @D23827, PER @D23826, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : CLEAR, 
   [COORD @D23830, AGR [COUNT @D23829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : CLEAR, 
   [COORD @D23832, AGR [COUNT @D23831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : CLEAR, 
   [COORD @D23836, AGR [COUNT @D23835, PER @D23834, PLU @D23833, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : CLEAR, 
   [COORD @D23842, PAST @D23841, 
      AGR [CASE @D23840, COUNT @D23839, PER @D23838, PLU @D23837, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, 
      ARITY 3] : CLEAR, 
   [COORD @D23845, AGR [COUNT @D23844, PER @D23843, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : CLEAR, 
   [COORD @D23847, AGR [COUNT @D23846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : CLEAR, 
   [COORD @D23849, AGR [COUNT @D23848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : CLEAR, 
   [COORD @D23853, AGR [COUNT @D23852, PER @D23851, PLU @D23850, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : CLEAR, 
   [COORD @D23859, PAST @D23858, 
      AGR [CASE @D23857, COUNT @D23856, PER @D23855, PLU @D23854, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : CLEAR, 
   [COORD @D23862, AGR [COUNT @D23861, PER @D23860, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLEAR, 
   [COORD @D23864, AGR [COUNT @D23863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLEAR, 
   [COORD @D23866, AGR [COUNT @D23865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLEAR, 
   [COORD @D23870, AGR [COUNT @D23869, PER @D23868, PLU @D23867, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CLEAR, 
   [COORD @D23876, PAST @D23875, AGR [CASE @D23874, COUNT @D23873, 
            PER @D23872, PLU @D23871, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CLEAR, 
   [COORD @D23879, AGR [COUNT @D23878, PER @D23877, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : CLEAR, 
   [COORD @D23881, AGR [COUNT @D23880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : CLEAR, 
   [COORD @D23883, AGR [COUNT @D23882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : CLEAR, 
   [COORD @D23887, AGR [COUNT @D23886, PER @D23885, PLU @D23884, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : CLEAR, 
   [COORD @D23893, PAST @D23892, 
      AGR [CASE @D23891, COUNT @D23890, PER @D23889, PLU @D23888, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : CLEAR, 
   [COORD @D23896, AGR [COUNT @D23895, PER @D23894, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLEAR, 
   [COORD @D23898, AGR [COUNT @D23897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLEAR, 
   [COORD @D23900, AGR [COUNT @D23899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLEAR, 
   [COORD @D23904, AGR [COUNT @D23903, PER @D23902, PLU @D23901, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : CLEAR, 
   [COORD @D23910, PAST @D23909, 
      AGR [CASE @D23908, COUNT @D23907, PER @D23906, PLU @D23905, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : CLEAR, 
   [COORD @D23913, AGR [COUNT @D23912, PER @D23911, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLEAR, 
   [COORD @D23915, AGR [COUNT @D23914, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLEAR, 
   [COORD @D23917, AGR [COUNT @D23916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLEAR, 
   [COORD @D23921, AGR [COUNT @D23920, PER @D23919, PLU @D23918, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : CLEAR, 
   [COORD @D23927, PAST @D23926, 
      AGR [CASE @D23925, COUNT @D23924, PER @D23923, PLU @D23922, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : CLEAR, 
   [COORD @D23930, AGR [COUNT @D23929, PER @D23928, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CLEAR, 
   [COORD @D23932, AGR [COUNT @D23931, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CLEAR, 
   [COORD @D23934, AGR [COUNT @D23933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CLEAR, 
   [COORD @D23938, AGR [COUNT @D23937, PER @D23936, PLU @D23935, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : CLEAR, 
   [COORD @D23944, PAST @D23943, 
      AGR [CASE @D23942, COUNT @D23941, PER @D23940, PLU @D23939, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : CLEAR, 
   [COORD @D23947, AGR [COUNT @D23946, PER @D23945, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CLEAR, 
   [COORD @D23949, AGR [COUNT @D23948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CLEAR, 
   [COORD @D23951, AGR [COUNT @D23950, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CLEAR, 
   [COORD @D23955, AGR [COUNT @D23954, PER @D23953, PLU @D23952, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : CLEAR, 
   [COORD @D23961, PAST @D23960, 
      AGR [CASE @D23959, COUNT @D23958, PER @D23957, PLU @D23956, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : CLEAR, 
   [COORD @D23964, AGR [COUNT @D23963, PER @D23962, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAR, 
   [COORD @D23966, AGR [COUNT @D23965, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAR, 
   [COORD @D23968, AGR [COUNT @D23967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAR, 
   [COORD @D23972, AGR [COUNT @D23971, PER @D23970, PLU @D23969, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLEAR, 
   [COORD @D23978, PAST @D23977, AGR [CASE @D23976, COUNT @D23975, 
            PER @D23974, PLU @D23973, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CLEAR, 
   [COORD @D23981, AGR [COUNT @D23980, PER @D23979, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAR, 
   [COORD @D23983, AGR [COUNT @D23982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAR, 
   [COORD @D23985, AGR [COUNT @D23984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAR, 
   [COORD @D23989, AGR [COUNT @D23988, PER @D23987, PLU @D23986, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLEAR, 
   [COORD @D23995, PAST @D23994, 
      AGR [CASE @D23993, COUNT @D23992, PER @D23991, PLU @D23990, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CLEAR, 
   [COORD @D23998, AGR [COUNT @D23997, PER @D23996, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAR, 
   [COORD @D24000, AGR [COUNT @D23999, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAR, 
   [COORD @D24002, AGR [COUNT @D24001, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAR, 
   [COORD @D24006, AGR [COUNT @D24005, PER @D24004, PLU @D24003, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLEAR, 
   [COORD @D24012, PAST @D24011, 
      AGR [CASE @D24010, COUNT @D24009, PER @D24008, PLU @D24007, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CLEAR, 
   [COORD @D24015, AGR [COUNT @D24014, PER @D24013, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CLEAR, 
   [COORD @D24017, AGR [COUNT @D24016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CLEAR, 
   [COORD @D24019, AGR [COUNT @D24018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CLEAR, 
   [COORD @D24023, AGR [COUNT @D24022, PER @D24021, PLU @D24020, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CLEAR, 
   [COORD @D24029, PAST @D24028, 
      AGR [CASE @D24027, COUNT @D24026, PER @D24025, PLU @D24024, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : CLEAR, 
   [COORD @D24032, AGR [COUNT @D24031, PER @D24030, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CLEAR, 
   [COORD @D24034, AGR [COUNT @D24033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CLEAR, 
   [COORD @D24036, AGR [COUNT @D24035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CLEAR, 
   [COORD @D24040, AGR [COUNT @D24039, PER @D24038, PLU @D24037, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : CLEAR, 
   [COORD @D24046, PAST @D24045, 
      AGR [CASE @D24044, COUNT @D24043, PER @D24042, PLU @D24041, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : CLEAR.

WORD cleared : 
   [COORD @D24055, AGR [CASE @D24054, COUNT @D24053, PER @D24052, 
            PLU @D24051, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24060, AGR [CASE @D24059, COUNT @D24058, PER @D24057, 
            PLU @D24056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24065, AGR [CASE @D24064, COUNT @D24063, PER @D24062, 
            PLU @D24061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24070, AGR [CASE @D24069, COUNT @D24068, PER @D24067, 
            PLU @D24066, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24075, AGR [CASE @D24074, COUNT @D24073, PER @D24072, 
            PLU @D24071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24080, AGR [CASE @D24079, COUNT @D24078, PER @D24077, 
            PLU @D24076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24085, AGR [CASE @D24084, COUNT @D24083, PER @D24082, 
            PLU @D24081, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CLEAR, 
   [COORD @D24090, AGR [CASE @D24089, COUNT @D24088, PER @D24087, 
            PLU @D24086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24095, AGR [CASE @D24094, COUNT @D24093, PER @D24092, 
            PLU @D24091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24100, AGR [CASE @D24099, COUNT @D24098, PER @D24097, 
            PLU @D24096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24105, AGR [CASE @D24104, COUNT @D24103, PER @D24102, 
            PLU @D24101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24110, AGR [CASE @D24109, COUNT @D24108, PER @D24107, 
            PLU @D24106, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24115, AGR [CASE @D24114, COUNT @D24113, PER @D24112, 
            PLU @D24111, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24120, AGR [CASE @D24119, COUNT @D24118, PER @D24117, 
            PLU @D24116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24125, AGR [CASE @D24124, COUNT @D24123, PER @D24122, 
            PLU @D24121, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24130, AGR [CASE @D24129, COUNT @D24128, PER @D24127, 
            PLU @D24126, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24135, AGR [CASE @D24134, COUNT @D24133, PER @D24132, 
            PLU @D24131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24140, AGR [CASE @D24139, COUNT @D24138, PER @D24137, 
            PLU @D24136, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24145, AGR [CASE @D24144, COUNT @D24143, PER @D24142, 
            PLU @D24141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24150, AGR [CASE @D24149, COUNT @D24148, PER @D24147, 
            PLU @D24146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24155, AGR [CASE @D24154, COUNT @D24153, PER @D24152, 
            PLU @D24151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24160, AGR [CASE @D24159, COUNT @D24158, PER @D24157, 
            PLU @D24156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24165, AGR [CASE @D24164, COUNT @D24163, PER @D24162, 
            PLU @D24161, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24170, AGR [CASE @D24169, COUNT @D24168, PER @D24167, 
            PLU @D24166, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24175, AGR [CASE @D24174, COUNT @D24173, PER @D24172, 
            PLU @D24171, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24180, AGR [CASE @D24179, COUNT @D24178, PER @D24177, 
            PLU @D24176, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24185, AGR [CASE @D24184, COUNT @D24183, PER @D24182, 
            PLU @D24181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24190, AGR [CASE @D24189, COUNT @D24188, PER @D24187, 
            PLU @D24186, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24195, AGR [CASE @D24194, COUNT @D24193, PER @D24192, 
            PLU @D24191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24200, AGR [CASE @D24199, COUNT @D24198, PER @D24197, 
            PLU @D24196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24205, AGR [CASE @D24204, COUNT @D24203, PER @D24202, 
            PLU @D24201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24210, AGR [CASE @D24209, COUNT @D24208, PER @D24207, 
            PLU @D24206, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24215, AGR [CASE @D24214, COUNT @D24213, PER @D24212, 
            PLU @D24211, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLEAR.

WORD clearing : 
   [COORD @D24226, REFL @D24225, COUNT @D24224, PRD @D24223, 
      CASE @D24222, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CLEARING, 
   [COORD @D24232, PRD @D24231, 
      AGR [CASE @D24230, COUNT @D24229, PER @D24228, PLU @D24227, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAR, 
   [COORD @D24238, PRD @D24237, AGR [CASE @D24236, COUNT @D24235, 
            PER @D24234, PLU @D24233, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24244, PRD @D24243, 
      AGR [CASE @D24242, COUNT @D24241, PER @D24240, PLU @D24239, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CLEAR, 
   [COORD @D24250, PRD @D24249, AGR [CASE @D24248, COUNT @D24247, 
            PER @D24246, PLU @D24245, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24256, PRD @D24255, 
      AGR [CASE @D24254, COUNT @D24253, PER @D24252, PLU @D24251, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAR, 
   [COORD @D24262, PRD @D24261, AGR [CASE @D24260, COUNT @D24259, 
            PER @D24258, PLU @D24257, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24268, PRD @D24267, 
      AGR [CASE @D24266, COUNT @D24265, PER @D24264, PLU @D24263, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAR, 
   [COORD @D24274, PRD @D24273, AGR [CASE @D24272, COUNT @D24271, 
            PER @D24270, PLU @D24269, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24280, PRD @D24279, 
      AGR [CASE @D24278, COUNT @D24277, PER @D24276, PLU @D24275, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CLEAR, 
   [COORD @D24286, PRD @D24285, AGR [CASE @D24284, COUNT @D24283, 
            PER @D24282, PLU @D24281, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24292, PRD @D24291, 
      AGR [CASE @D24290, COUNT @D24289, PER @D24288, PLU @D24287, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAR, 
   [COORD @D24298, PRD @D24297, AGR [CASE @D24296, COUNT @D24295, 
            PER @D24294, PLU @D24293, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24304, PRD @D24303, 
      AGR [CASE @D24302, COUNT @D24301, PER @D24300, PLU @D24299, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLEAR.

WORD clearings : 
   [COORD @D24317, DEMON @D24316, REFL @D24315, PRD @D24314, 
      CASE @D24313, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CLEARING.

WORD clears : 
   [COORD @D24323, AGR [COUNT @D24322, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24325, 
      AGR [COUNT @D24324, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CLEAR, 
   [COORD @D24327, AGR [COUNT @D24326, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24329, 
      AGR [COUNT @D24328, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CLEAR, 
   [COORD @D24331, AGR [COUNT @D24330, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24333, 
      AGR [COUNT @D24332, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24335, 
      AGR [COUNT @D24334, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24337, 
      AGR [COUNT @D24336, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24339, 
      AGR [COUNT @D24338, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24341, 
      AGR [COUNT @D24340, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24343, 
      AGR [COUNT @D24342, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24345, 
      AGR [COUNT @D24344, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR, 
   [COORD @D24347, 
      AGR [COUNT @D24346, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLEAR.

WORD climb : 
   [COORD @D24353, AGR [COUNT @D24352, PER @D24351, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLIMB, 
   [COORD @D24355, AGR [COUNT @D24354, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLIMB, 
   [COORD @D24357, AGR [COUNT @D24356, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLIMB, 
   [COORD @D24361, AGR [COUNT @D24360, PER @D24359, PLU @D24358, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CLIMB, 
   [COORD @D24367, PAST @D24366, AGR [CASE @D24365, COUNT @D24364, 
            PER @D24363, PLU @D24362, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CLIMB, 
   [COORD @D24370, AGR [COUNT @D24369, PER @D24368, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : CLIMB, 
   [COORD @D24372, AGR [COUNT @D24371, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : CLIMB, 
   [COORD @D24374, AGR [COUNT @D24373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : CLIMB, 
   [COORD @D24378, AGR [COUNT @D24377, PER @D24376, PLU @D24375, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OUT_OF, ARITY 2] : CLIMB, 
   [COORD @D24384, PAST @D24383, 
      AGR [CASE @D24382, COUNT @D24381, PER @D24380, PLU @D24379, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OUT_OF, 
      ARITY 2] : CLIMB, 
   [COORD @D24387, AGR [COUNT @D24386, PER @D24385, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : CLIMB, 
   [COORD @D24389, AGR [COUNT @D24388, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : CLIMB, 
   [COORD @D24391, AGR [COUNT @D24390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : CLIMB, 
   [COORD @D24395, AGR [COUNT @D24394, PER @D24393, PLU @D24392, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : CLIMB, 
   [COORD @D24401, PAST @D24400, 
      AGR [CASE @D24399, COUNT @D24398, PER @D24397, PLU @D24396, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM INTO, 
      ARITY 2] : CLIMB, 
   [COORD @D24404, AGR [COUNT @D24403, PER @D24402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM FROM, ARITY 2] : CLIMB, 
   [COORD @D24406, AGR [COUNT @D24405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM FROM, ARITY 2] : CLIMB, 
   [COORD @D24408, AGR [COUNT @D24407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM FROM, ARITY 2] : CLIMB, 
   [COORD @D24412, AGR [COUNT @D24411, PER @D24410, PLU @D24409, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT DOWN, PFORM FROM, ARITY 2] : CLIMB, 
   [COORD @D24418, PAST @D24417, 
      AGR [CASE @D24416, COUNT @D24415, PER @D24414, PLU @D24413, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT DOWN, 
      PFORM FROM, ARITY 2] : CLIMB, 
   [COORD @D24421, AGR [COUNT @D24420, PER @D24419, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM DOWN, ARITY 2] : CLIMB, 
   [COORD @D24423, AGR [COUNT @D24422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM DOWN, ARITY 2] : CLIMB, 
   [COORD @D24425, AGR [COUNT @D24424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM DOWN, ARITY 2] : CLIMB, 
   [COORD @D24429, AGR [COUNT @D24428, PER @D24427, PLU @D24426, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM DOWN, ARITY 2] : CLIMB, 
   [COORD @D24435, PAST @D24434, 
      AGR [CASE @D24433, COUNT @D24432, PER @D24431, PLU @D24430, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM DOWN, 
      ARITY 2] : CLIMB, 
   [COORD @D24438, AGR [COUNT @D24437, PER @D24436, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLIMB, 
   [COORD @D24440, AGR [COUNT @D24439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLIMB, 
   [COORD @D24442, AGR [COUNT @D24441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLIMB, 
   [COORD @D24446, AGR [COUNT @D24445, PER @D24444, PLU @D24443, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLIMB, 
   [COORD @D24452, PAST @D24451, AGR [CASE @D24450, COUNT @D24449, 
            PER @D24448, PLU @D24447, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CLIMB, 
   [COORD @D24455, AGR [COUNT @D24454, PER @D24453, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLIMB, 
   [COORD @D24457, AGR [COUNT @D24456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLIMB, 
   [COORD @D24459, AGR [COUNT @D24458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLIMB, 
   [COORD @D24463, AGR [COUNT @D24462, PER @D24461, PLU @D24460, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLIMB, 
   [COORD @D24469, PAST @D24468, 
      AGR [CASE @D24467, COUNT @D24466, PER @D24465, PLU @D24464, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : CLIMB.

WORD climbed : 
   [COORD @D24478, AGR [CASE @D24477, COUNT @D24476, PER @D24475, 
            PLU @D24474, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24483, AGR [CASE @D24482, COUNT @D24481, PER @D24480, 
            PLU @D24479, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24488, AGR [CASE @D24487, COUNT @D24486, PER @D24485, 
            PLU @D24484, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CLIMB, 
   [COORD @D24493, AGR [CASE @D24492, COUNT @D24491, PER @D24490, 
            PLU @D24489, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24498, AGR [CASE @D24497, COUNT @D24496, PER @D24495, 
            PLU @D24494, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24503, AGR [CASE @D24502, COUNT @D24501, PER @D24500, 
            PLU @D24499, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24508, AGR [CASE @D24507, COUNT @D24506, PER @D24505, 
            PLU @D24504, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24513, AGR [CASE @D24512, COUNT @D24511, PER @D24510, 
            PLU @D24509, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24518, 
      AGR [CASE @D24517, COUNT @D24516, PER @D24515, PLU @D24514, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24523, AGR [CASE @D24522, COUNT @D24521, PER @D24520, 
            PLU @D24519, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24528, AGR [CASE @D24527, COUNT @D24526, PER @D24525, 
            PLU @D24524, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24533, AGR [CASE @D24532, COUNT @D24531, PER @D24530, 
            PLU @D24529, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24538, AGR [CASE @D24537, COUNT @D24536, PER @D24535, 
            PLU @D24534, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24543, AGR [CASE @D24542, COUNT @D24541, PER @D24540, 
            PLU @D24539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24548, AGR [CASE @D24547, COUNT @D24546, PER @D24545, 
            PLU @D24544, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24553, AGR [CASE @D24552, COUNT @D24551, PER @D24550, 
            PLU @D24549, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLIMB.

WORD climbing : 
   [COORD @D24565, PRD @D24564, AGR [CASE @D24563, COUNT @D24562, 
            PER @D24561, PLU @D24560, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24571, PRD @D24570, 
      AGR [CASE @D24569, COUNT @D24568, PER @D24567, PLU @D24566, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLIMB, 
   [COORD @D24577, PRD @D24576, AGR [CASE @D24575, COUNT @D24574, 
            PER @D24573, PLU @D24572, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24583, PRD @D24582, 
      AGR [CASE @D24581, COUNT @D24580, PER @D24579, PLU @D24578, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CLIMB, 
   [COORD @D24589, PRD @D24588, AGR [CASE @D24587, COUNT @D24586, 
            PER @D24585, PLU @D24584, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24595, PRD @D24594, 
      AGR [CASE @D24593, COUNT @D24592, PER @D24591, PLU @D24590, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CLIMB, 
   [COORD @D24601, PRD @D24600, AGR [CASE @D24599, COUNT @D24598, 
            PER @D24597, PLU @D24596, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLIMB.

WORD climbs : 
   [COORD @D24607, AGR [COUNT @D24606, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24609, 
      AGR [COUNT @D24608, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24611, 
      AGR [COUNT @D24610, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24613, 
      AGR [COUNT @D24612, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CLIMB, 
   [COORD @D24615, AGR [COUNT @D24614, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CLIMB, 
   [COORD @D24617, AGR [COUNT @D24616, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLIMB, 
   [COORD @D24619, 
      AGR [COUNT @D24618, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLIMB.

WORD close : 
   [COORD @D24626, AGR [COUNT @D24625, PER @D24624, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLOSE, 
   [COORD @D24628, AGR [COUNT @D24627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLOSE, 
   [COORD @D24630, AGR [COUNT @D24629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CLOSE, 
   [COORD @D24634, AGR [COUNT @D24633, PER @D24632, PLU @D24631, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CLOSE, 
   [COORD @D24640, PAST @D24639, AGR [CASE @D24638, COUNT @D24637, 
            PER @D24636, PLU @D24635, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CLOSE, 
   [COORD @D24643, AGR [COUNT @D24642, PER @D24641, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : CLOSE, 
   [COORD @D24645, AGR [COUNT @D24644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : CLOSE, 
   [COORD @D24647, AGR [COUNT @D24646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : CLOSE, 
   [COORD @D24651, AGR [COUNT @D24650, PER @D24649, PLU @D24648, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : CLOSE, 
   [COORD @D24657, PAST @D24656, 
      AGR [CASE @D24655, COUNT @D24654, PER @D24653, PLU @D24652, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      ARITY 2] : CLOSE, 
   [COORD @D24660, AGR [COUNT @D24659, PER @D24658, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM UPON, ARITY 2] : CLOSE, 
   [COORD @D24662, AGR [COUNT @D24661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM UPON, ARITY 2] : CLOSE, 
   [COORD @D24664, AGR [COUNT @D24663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM UPON, ARITY 2] : CLOSE, 
   [COORD @D24668, AGR [COUNT @D24667, PER @D24666, PLU @D24665, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM UPON, ARITY 2] : CLOSE, 
   [COORD @D24674, PAST @D24673, 
      AGR [CASE @D24672, COUNT @D24671, PER @D24670, PLU @D24669, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM UPON, ARITY 2] : CLOSE, 
   [COORD @D24677, AGR [COUNT @D24676, PER @D24675, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : CLOSE, 
   [COORD @D24679, AGR [COUNT @D24678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : CLOSE, 
   [COORD @D24681, AGR [COUNT @D24680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : CLOSE, 
   [COORD @D24685, AGR [COUNT @D24684, PER @D24683, PLU @D24682, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM ON, ARITY 2] : CLOSE, 
   [COORD @D24691, PAST @D24690, 
      AGR [CASE @D24689, COUNT @D24688, PER @D24687, PLU @D24686, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM ON, ARITY 2] : CLOSE, 
   [COORD @D24694, AGR [COUNT @D24693, PER @D24692, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLOSE, 
   [COORD @D24696, AGR [COUNT @D24695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLOSE, 
   [COORD @D24698, AGR [COUNT @D24697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CLOSE, 
   [COORD @D24702, AGR [COUNT @D24701, PER @D24700, PLU @D24699, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : CLOSE, 
   [COORD @D24708, PAST @D24707, 
      AGR [CASE @D24706, COUNT @D24705, PER @D24704, PLU @D24703, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : CLOSE, 
   [COORD @D24711, AGR [COUNT @D24710, PER @D24709, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLOSE, 
   [COORD @D24713, AGR [COUNT @D24712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLOSE, 
   [COORD @D24715, AGR [COUNT @D24714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CLOSE, 
   [COORD @D24719, AGR [COUNT @D24718, PER @D24717, PLU @D24716, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : CLOSE, 
   [COORD @D24725, PAST @D24724, 
      AGR [CASE @D24723, COUNT @D24722, PER @D24721, PLU @D24720, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : CLOSE, 
   [COORD @D24728, AGR [COUNT @D24727, PER @D24726, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLOSE, 
   [COORD @D24730, AGR [COUNT @D24729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLOSE, 
   [COORD @D24732, AGR [COUNT @D24731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLOSE, 
   [COORD @D24736, AGR [COUNT @D24735, PER @D24734, PLU @D24733, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : CLOSE, 
   [COORD @D24742, PAST @D24741, 
      AGR [CASE @D24740, COUNT @D24739, PER @D24738, PLU @D24737, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CLOSE, 
   [COORD @D24745, AGR [COUNT @D24744, PER @D24743, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLOSE, 
   [COORD @D24747, AGR [COUNT @D24746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLOSE, 
   [COORD @D24749, AGR [COUNT @D24748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLOSE, 
   [COORD @D24753, AGR [COUNT @D24752, PER @D24751, PLU @D24750, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CLOSE, 
   [COORD @D24759, PAST @D24758, AGR [CASE @D24757, COUNT @D24756, 
            PER @D24755, PLU @D24754, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CLOSE, 
   [COORD @D24762, AGR [COUNT @D24761, PER @D24760, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLOSE, 
   [COORD @D24764, AGR [COUNT @D24763, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLOSE, 
   [COORD @D24766, AGR [COUNT @D24765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLOSE, 
   [COORD @D24770, AGR [COUNT @D24769, PER @D24768, PLU @D24767, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CLOSE, 
   [COORD @D24776, PAST @D24775, 
      AGR [CASE @D24774, COUNT @D24773, PER @D24772, PLU @D24771, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CLOSE, 
   [COORD @D24779, AGR [COUNT @D24778, PER @D24777, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLOSE, 
   [COORD @D24781, AGR [COUNT @D24780, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLOSE, 
   [COORD @D24783, AGR [COUNT @D24782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLOSE, 
   [COORD @D24787, AGR [COUNT @D24786, PER @D24785, PLU @D24784, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CLOSE, 
   [COORD @D24793, PAST @D24792, 
      AGR [CASE @D24791, COUNT @D24790, PER @D24789, PLU @D24788, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CLOSE, 
   [COORD @D24796, AGR [COUNT @D24795, PER @D24794, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CLOSE, 
   [COORD @D24798, AGR [COUNT @D24797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CLOSE, 
   [COORD @D24800, AGR [COUNT @D24799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CLOSE, 
   [COORD @D24804, AGR [COUNT @D24803, PER @D24802, PLU @D24801, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : CLOSE, 
   [COORD @D24810, PAST @D24809, 
      AGR [CASE @D24808, COUNT @D24807, PER @D24806, PLU @D24805, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : CLOSE, 
   [COORD @D24813, AGR [COUNT @D24812, PER @D24811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLOSE, 
   [COORD @D24815, AGR [COUNT @D24814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLOSE, 
   [COORD @D24817, AGR [COUNT @D24816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLOSE, 
   [COORD @D24821, AGR [COUNT @D24820, PER @D24819, PLU @D24818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CLOSE, 
   [COORD @D24827, PAST @D24826, 
      AGR [CASE @D24825, COUNT @D24824, PER @D24823, PLU @D24822, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : CLOSE.

WORD closed : 
   [COADV @D24840, COORD @D24839, DEF @D24838, PRD @D24837, AGR 
            [CASE @D24836, COUNT @D24835, PER @D24834, PLU @D24833, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : CLOSED, 
   [COORD @D24845, AGR [CASE @D24844, COUNT @D24843, PER @D24842, 
            PLU @D24841, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CLOSE, 
   [COORD @D24850, AGR [CASE @D24849, COUNT @D24848, PER @D24847, 
            PLU @D24846, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24855, AGR [CASE @D24854, COUNT @D24853, PER @D24852, 
            PLU @D24851, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24860, AGR [CASE @D24859, COUNT @D24858, PER @D24857, 
            PLU @D24856, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24865, AGR [CASE @D24864, COUNT @D24863, PER @D24862, 
            PLU @D24861, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24870, AGR [CASE @D24869, COUNT @D24868, PER @D24867, 
            PLU @D24866, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24875, AGR [CASE @D24874, COUNT @D24873, PER @D24872, 
            PLU @D24871, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24880, AGR [CASE @D24879, COUNT @D24878, PER @D24877, 
            PLU @D24876, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24885, AGR [CASE @D24884, COUNT @D24883, PER @D24882, 
            PLU @D24881, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24890, AGR [CASE @D24889, COUNT @D24888, PER @D24887, 
            PLU @D24886, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24895, AGR [CASE @D24894, COUNT @D24893, PER @D24892, 
            PLU @D24891, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24900, AGR [CASE @D24899, COUNT @D24898, PER @D24897, 
            PLU @D24896, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24905, AGR [CASE @D24904, COUNT @D24903, PER @D24902, 
            PLU @D24901, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24910, AGR [CASE @D24909, COUNT @D24908, PER @D24907, 
            PLU @D24906, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24915, AGR [CASE @D24914, COUNT @D24913, PER @D24912, 
            PLU @D24911, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24920, AGR [CASE @D24919, COUNT @D24918, PER @D24917, 
            PLU @D24916, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24925, AGR [CASE @D24924, COUNT @D24923, PER @D24922, 
            PLU @D24921, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24930, AGR [CASE @D24929, COUNT @D24928, PER @D24927, 
            PLU @D24926, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24935, AGR [CASE @D24934, COUNT @D24933, PER @D24932, 
            PLU @D24931, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24940, AGR [CASE @D24939, COUNT @D24938, PER @D24937, 
            PLU @D24936, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24945, AGR [CASE @D24944, COUNT @D24943, PER @D24942, 
            PLU @D24941, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24950, AGR [CASE @D24949, COUNT @D24948, PER @D24947, 
            PLU @D24946, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24955, AGR [CASE @D24954, COUNT @D24953, PER @D24952, 
            PLU @D24951, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24960, AGR [CASE @D24959, COUNT @D24958, PER @D24957, 
            PLU @D24956, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24965, AGR [CASE @D24964, COUNT @D24963, PER @D24962, 
            PLU @D24961, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24970, AGR [CASE @D24969, COUNT @D24968, PER @D24967, 
            PLU @D24966, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24975, AGR [CASE @D24974, COUNT @D24973, PER @D24972, 
            PLU @D24971, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24980, AGR [CASE @D24979, COUNT @D24978, PER @D24977, 
            PLU @D24976, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24985, AGR [CASE @D24984, COUNT @D24983, PER @D24982, 
            PLU @D24981, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CLOSE.

WORD closes : 
   [COORD @D24992, AGR [COUNT @D24991, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24994, 
      AGR [COUNT @D24993, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D24996, 
      AGR [COUNT @D24995, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CLOSE, 
   [COORD @D24998, AGR [COUNT @D24997, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CLOSE, 
   [COORD @D25000, AGR [COUNT @D24999, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25002, 
      AGR [COUNT @D25001, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25004, 
      AGR [COUNT @D25003, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25006, 
      AGR [COUNT @D25005, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25008, 
      AGR [COUNT @D25007, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25010, 
      AGR [COUNT @D25009, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25012, 
      AGR [COUNT @D25011, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25014, 
      AGR [COUNT @D25013, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CLOSE.

WORD closing : 
   [COORD @D25024, PRD @D25023, AGR [CASE @D25022, COUNT @D25021, 
            PER @D25020, PLU @D25019, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25030, PRD @D25029, 
      AGR [CASE @D25028, COUNT @D25027, PER @D25026, PLU @D25025, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CLOSE, 
   [COORD @D25036, PRD @D25035, AGR [CASE @D25034, COUNT @D25033, 
            PER @D25032, PLU @D25031, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25042, PRD @D25041, 
      AGR [CASE @D25040, COUNT @D25039, PER @D25038, PLU @D25037, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CLOSE, 
   [COORD @D25048, PRD @D25047, AGR [CASE @D25046, COUNT @D25045, 
            PER @D25044, PLU @D25043, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25054, PRD @D25053, 
      AGR [CASE @D25052, COUNT @D25051, PER @D25050, PLU @D25049, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLOSE, 
   [COORD @D25060, PRD @D25059, AGR [CASE @D25058, COUNT @D25057, 
            PER @D25056, PLU @D25055, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25066, PRD @D25065, 
      AGR [CASE @D25064, COUNT @D25063, PER @D25062, PLU @D25061, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CLOSE, 
   [COORD @D25072, PRD @D25071, AGR [CASE @D25070, COUNT @D25069, 
            PER @D25068, PLU @D25067, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25078, PRD @D25077, 
      AGR [CASE @D25076, COUNT @D25075, PER @D25074, PLU @D25073, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLOSE, 
   [COORD @D25084, PRD @D25083, AGR [CASE @D25082, COUNT @D25081, 
            PER @D25080, PLU @D25079, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CLOSE, 
   [COORD @D25090, PRD @D25089, 
      AGR [CASE @D25088, COUNT @D25087, PER @D25086, PLU @D25085, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CLOSE.

WORD coach : 
   [COORD @D25098, REFL @D25097, COUNT @D25096, PRD @D25095, CASE 
         @D25094, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COACH, 
   [COORD @D25101, 
      AGR [COUNT @D25100, PER @D25099, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : COACH, 
   [COORD @D25103, AGR [COUNT @D25102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : COACH, 
   [COORD @D25105, AGR [COUNT @D25104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : COACH, 
   [COORD @D25109, AGR [COUNT @D25108, PER @D25107, PLU @D25106, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : COACH, 
   [COORD @D25115, PAST @D25114, 
      AGR [CASE @D25113, COUNT @D25112, PER @D25111, PLU @D25110, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : COACH, 
   [COORD @D25118, AGR [COUNT @D25117, PER @D25116, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : COACH, 
   [COORD @D25120, AGR [COUNT @D25119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : COACH, 
   [COORD @D25122, AGR [COUNT @D25121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : COACH, 
   [COORD @D25126, AGR [COUNT @D25125, PER @D25124, PLU @D25123, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : COACH, 
   [COORD @D25132, PAST @D25131, 
      AGR [CASE @D25130, COUNT @D25129, PER @D25128, PLU @D25127, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : COACH, 
   [COORD @D25135, AGR [COUNT @D25134, PER @D25133, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COACH, 
   [COORD @D25137, AGR [COUNT @D25136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COACH, 
   [COORD @D25139, AGR [COUNT @D25138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COACH, 
   [COORD @D25143, AGR [COUNT @D25142, PER @D25141, PLU @D25140, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COACH, 
   [COORD @D25149, PAST @D25148, AGR [CASE @D25147, COUNT @D25146, 
            PER @D25145, PLU @D25144, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COACH, 
   [COORD @D25152, AGR [COUNT @D25151, PER @D25150, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COACH, 
   [COORD @D25154, AGR [COUNT @D25153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COACH, 
   [COORD @D25156, AGR [COUNT @D25155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COACH, 
   [COORD @D25160, AGR [COUNT @D25159, PER @D25158, PLU @D25157, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COACH, 
   [COORD @D25166, PAST @D25165, AGR [CASE @D25164, COUNT @D25163, 
            PER @D25162, PLU @D25161, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COACH.

WORD coached : 
   [COORD @D25176, AGR [CASE @D25175, COUNT @D25174, PER @D25173, 
            PLU @D25172, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25181, AGR [CASE @D25180, COUNT @D25179, PER @D25178, 
            PLU @D25177, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25186, AGR [CASE @D25185, COUNT @D25184, PER @D25183, 
            PLU @D25182, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COACH, 
   [COORD @D25191, AGR [CASE @D25190, COUNT @D25189, PER @D25188, 
            PLU @D25187, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25196, AGR [CASE @D25195, COUNT @D25194, PER @D25193, 
            PLU @D25192, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25201, AGR [CASE @D25200, COUNT @D25199, PER @D25198, 
            PLU @D25197, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COACH, 
   [COORD @D25206, AGR [CASE @D25205, COUNT @D25204, PER @D25203, 
            PLU @D25202, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25211, AGR [CASE @D25210, COUNT @D25209, PER @D25208, 
            PLU @D25207, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COACH, 
   [COORD @D25216, AGR [CASE @D25215, COUNT @D25214, PER @D25213, 
            PLU @D25212, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COACH, 
   [COORD @D25221, AGR [CASE @D25220, COUNT @D25219, PER @D25218, 
            PLU @D25217, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25226, AGR [CASE @D25225, COUNT @D25224, PER @D25223, 
            PLU @D25222, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COACH.

WORD coaches : 
   [COORD @D25236, DEMON @D25235, REFL @D25234, PRD @D25233, 
      CASE @D25232, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : COACH, 
   [COORD @D25238, 
      AGR [COUNT @D25237, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COACH, 
   [COORD @D25240, 
      AGR [COUNT @D25239, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COACH, 
   [COORD @D25242, 
      AGR [COUNT @D25241, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COACH, 
   [COORD @D25244, 
      AGR [COUNT @D25243, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COACH.

WORD coaching : 
   [COORD @D25259, PRD @D25258, AGR [CASE @D25257, COUNT @D25256, 
            PER @D25255, PLU @D25254, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25265, PRD @D25264, 
      AGR [CASE @D25263, COUNT @D25262, PER @D25261, PLU @D25260, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COACH, 
   [COORD @D25271, PRD @D25270, AGR [CASE @D25269, COUNT @D25268, 
            PER @D25267, PLU @D25266, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COACH, 
   [COORD @D25277, PRD @D25276, 
      AGR [CASE @D25275, COUNT @D25274, PER @D25273, PLU @D25272, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COACH.

WORD coil : 
   [COORD @D25289, REFL @D25288, PRD @D25287, CASE @D25286, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : COIL, 
   [COORD @D25293, REFL @D25292, PRD @D25291, CASE @D25290, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : COIL, 
   [COORD @D25296, 
      AGR [COUNT @D25295, PER @D25294, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   COIL, 
   [COORD @D25298, AGR [COUNT @D25297, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COIL, 
   [COORD @D25300, AGR [COUNT @D25299, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COIL, 
   [COORD @D25304, AGR [COUNT @D25303, PER @D25302, PLU @D25301, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COIL, 
   [COORD @D25310, PAST @D25309, AGR [CASE @D25308, COUNT @D25307, 
            PER @D25306, PLU @D25305, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COIL, 
   [COORD @D25313, AGR [COUNT @D25312, PER @D25311, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COIL, 
   [COORD @D25315, AGR [COUNT @D25314, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COIL, 
   [COORD @D25317, AGR [COUNT @D25316, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COIL, 
   [COORD @D25321, AGR [COUNT @D25320, PER @D25319, PLU @D25318, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : COIL, 
   [COORD @D25327, PAST @D25326, 
      AGR [CASE @D25325, COUNT @D25324, PER @D25323, PLU @D25322, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : COIL, 
   [COORD @D25330, AGR [COUNT @D25329, PER @D25328, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COIL, 
   [COORD @D25332, AGR [COUNT @D25331, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COIL, 
   [COORD @D25334, AGR [COUNT @D25333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COIL, 
   [COORD @D25338, AGR [COUNT @D25337, PER @D25336, PLU @D25335, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COIL, 
   [COORD @D25344, PAST @D25343, 
      AGR [CASE @D25342, COUNT @D25341, PER @D25340, PLU @D25339, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : COIL.

WORD coiled : 
   [COORD @D25354, AGR [CASE @D25353, COUNT @D25352, PER @D25351, 
            PLU @D25350, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COIL, 
   [COORD @D25359, AGR [CASE @D25358, COUNT @D25357, PER @D25356, 
            PLU @D25355, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COIL, 
   [COORD @D25364, AGR [CASE @D25363, COUNT @D25362, PER @D25361, 
            PLU @D25360, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COIL, 
   [COORD @D25369, AGR [CASE @D25368, COUNT @D25367, PER @D25366, 
            PLU @D25365, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COIL, 
   [COORD @D25374, AGR [CASE @D25373, COUNT @D25372, PER @D25371, 
            PLU @D25370, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COIL, 
   [COORD @D25379, AGR [CASE @D25378, COUNT @D25377, PER @D25376, 
            PLU @D25375, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COIL, 
   [COORD @D25384, AGR [CASE @D25383, COUNT @D25382, PER @D25381, 
            PLU @D25380, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COIL, 
   [COORD @D25389, AGR [CASE @D25388, COUNT @D25387, PER @D25386, 
            PLU @D25385, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COIL.

WORD coiling : 
   [COORD @D25404, PRD @D25403, AGR [CASE @D25402, COUNT @D25401, 
            PER @D25400, PLU @D25399, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COIL, 
   [COORD @D25410, PRD @D25409, 
      AGR [CASE @D25408, COUNT @D25407, PER @D25406, PLU @D25405, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COIL, 
   [COORD @D25416, PRD @D25415, AGR [CASE @D25414, COUNT @D25413, 
            PER @D25412, PLU @D25411, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COIL.

WORD coils : 
   [COORD @D25426, DEMON @D25425, REFL @D25424, PRD @D25423, CASE 
         @D25422, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : COIL, 
   [COORD @D25431, DEMON @D25430, REFL @D25429, PRD @D25428, 
      CASE @D25427, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : COIL, 
   [COORD @D25433, AGR [COUNT @D25432, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COIL, 
   [COORD @D25435, 
      AGR [COUNT @D25434, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COIL, 
   [COORD @D25437, 
      AGR [COUNT @D25436, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COIL.

WORD coincide : 
   [COORD @D25444, AGR [COUNT @D25443, PER @D25442, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COINCIDE, 
   [COORD @D25446, AGR [COUNT @D25445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COINCIDE, 
   [COORD @D25448, AGR [COUNT @D25447, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COINCIDE, 
   [COORD @D25452, AGR [COUNT @D25451, PER @D25450, PLU @D25449, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : COINCIDE, 
   [COORD @D25458, PAST @D25457, 
      AGR [CASE @D25456, COUNT @D25455, PER @D25454, PLU @D25453, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : COINCIDE, 
   [COORD @D25461, AGR [COUNT @D25460, PER @D25459, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COINCIDE, 
   [COORD @D25463, AGR [COUNT @D25462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COINCIDE, 
   [COORD @D25465, AGR [COUNT @D25464, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COINCIDE, 
   [COORD @D25469, AGR [COUNT @D25468, PER @D25467, PLU @D25466, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COINCIDE, 
   [COORD @D25475, PAST @D25474, AGR [CASE @D25473, COUNT @D25472, 
            PER @D25471, PLU @D25470, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COINCIDE.

WORD coincided : 
   [COORD @D25485, AGR [CASE @D25484, COUNT @D25483, PER @D25482, 
            PLU @D25481, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COINCIDE, 
   [COORD @D25490, AGR [CASE @D25489, COUNT @D25488, PER @D25487, 
            PLU @D25486, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COINCIDE, 
   [COORD @D25495, AGR [CASE @D25494, COUNT @D25493, PER @D25492, 
            PLU @D25491, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COINCIDE, 
   [COORD @D25500, AGR [CASE @D25499, COUNT @D25498, PER @D25497, 
            PLU @D25496, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COINCIDE.

WORD coincides : 
   [COORD @D25507, AGR [COUNT @D25506, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COINCIDE, 
   
   [COORD @D25509, AGR [COUNT @D25508, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COINCIDE.

WORD coinciding : 
   [COORD @D25519, PRD @D25518, AGR [CASE @D25517, COUNT @D25516, 
            PER @D25515, PLU @D25514, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COINCIDE, 
   [COORD @D25525, PRD @D25524, 
      AGR [CASE @D25523, COUNT @D25522, PER @D25521, PLU @D25520, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COINCIDE.

WORD collapse : 
   [COORD @D25532, AGR [COUNT @D25531, PER @D25530, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COLLAPSE, 
   [COORD @D25534, AGR [COUNT @D25533, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COLLAPSE, 
   [COORD @D25536, AGR [COUNT @D25535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COLLAPSE, 
   [COORD @D25540, AGR [COUNT @D25539, PER @D25538, PLU @D25537, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COLLAPSE, 
   [COORD @D25546, PAST @D25545, AGR [CASE @D25544, COUNT @D25543, 
            PER @D25542, PLU @D25541, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COLLAPSE, 
   [COORD @D25549, AGR [COUNT @D25548, PER @D25547, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLLAPSE, 
   [COORD @D25551, AGR [COUNT @D25550, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLLAPSE, 
   [COORD @D25553, AGR [COUNT @D25552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLLAPSE, 
   [COORD @D25557, AGR [COUNT @D25556, PER @D25555, PLU @D25554, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLLAPSE, 
   [COORD @D25563, PAST @D25562, AGR [CASE @D25561, COUNT @D25560, 
            PER @D25559, PLU @D25558, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COLLAPSE.

WORD collapsed : 
   [COORD @D25573, AGR [CASE @D25572, COUNT @D25571, PER @D25570, 
            PLU @D25569, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COLLAPSE, 
   [COORD @D25578, AGR [CASE @D25577, COUNT @D25576, PER @D25575, 
            PLU @D25574, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COLLAPSE, 
   [COORD @D25583, AGR [CASE @D25582, COUNT @D25581, PER @D25580, 
            PLU @D25579, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COLLAPSE, 
   [COORD @D25588, AGR [CASE @D25587, COUNT @D25586, PER @D25585, 
            PLU @D25584, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COLLAPSE, 
   [COORD @D25593, AGR [CASE @D25592, COUNT @D25591, PER @D25590, 
            PLU @D25589, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COLLAPSE.

WORD collapses : 
   [COORD @D25600, AGR [COUNT @D25599, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COLLAPSE, 
   [COORD @D25602, 
      AGR [COUNT @D25601, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COLLAPSE.

WORD collapsing : 
   [COORD @D25612, PRD @D25611, AGR [CASE @D25610, COUNT @D25609, 
            PER @D25608, PLU @D25607, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COLLAPSE, 
   [COORD @D25618, PRD @D25617, 
      AGR [CASE @D25616, COUNT @D25615, PER @D25614, PLU @D25613, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COLLAPSE.

WORD colour : 
   [COORD @D25626, REFL @D25625, COUNT @D25624, PRD @D25623, CASE 
         @D25622, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COLOUR, 
   [COORD @D25629, 
      AGR [COUNT @D25628, PER @D25627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      ARITY 3] : COLOUR, 
   [COORD @D25631, AGR [COUNT @D25630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : COLOUR, 
   [COORD @D25633, AGR [COUNT @D25632, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : COLOUR, 
   [COORD @D25637, AGR [COUNT @D25636, PER @D25635, PLU @D25634, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : COLOUR, 
   [COORD @D25643, PAST @D25642, AGR [CASE @D25641, COUNT @D25640, 
            PER @D25639, PLU @D25638, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : COLOUR, 
   [COORD @D25646, AGR [COUNT @D25645, PER @D25644, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COLOUR, 
   [COORD @D25648, AGR [COUNT @D25647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COLOUR, 
   [COORD @D25650, AGR [COUNT @D25649, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COLOUR, 
   [COORD @D25654, AGR [COUNT @D25653, PER @D25652, PLU @D25651, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COLOUR, 
   [COORD @D25660, PAST @D25659, AGR [CASE @D25658, COUNT @D25657, 
            PER @D25656, PLU @D25655, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COLOUR, 
   [COORD @D25663, AGR [COUNT @D25662, PER @D25661, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : COLOUR, 
   [COORD @D25665, AGR [COUNT @D25664, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : COLOUR, 
   [COORD @D25667, AGR [COUNT @D25666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : COLOUR, 
   [COORD @D25671, AGR [COUNT @D25670, PER @D25669, PLU @D25668, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : COLOUR, 
   [COORD @D25677, PAST @D25676, 
      AGR [CASE @D25675, COUNT @D25674, PER @D25673, PLU @D25672, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : COLOUR, 
   [COORD @D25680, AGR [COUNT @D25679, PER @D25678, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLOUR, 
   [COORD @D25682, AGR [COUNT @D25681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLOUR, 
   [COORD @D25684, AGR [COUNT @D25683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLOUR, 
   [COORD @D25688, AGR [COUNT @D25687, PER @D25686, PLU @D25685, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COLOUR, 
   [COORD @D25694, PAST @D25693, AGR [CASE @D25692, COUNT @D25691, 
            PER @D25690, PLU @D25689, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COLOUR, 
   [COORD @D25697, AGR [COUNT @D25696, PER @D25695, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : COLOUR, 
   [COORD @D25699, AGR [COUNT @D25698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : COLOUR, 
   [COORD @D25701, AGR [COUNT @D25700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : COLOUR, 
   [COORD @D25705, AGR [COUNT @D25704, PER @D25703, PLU @D25702, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : COLOUR, 
   [COORD @D25711, PAST @D25710, 
      AGR [CASE @D25709, COUNT @D25708, PER @D25707, PLU @D25706, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : COLOUR.

WORD coloured : 
   [COORD @D25721, AGR [CASE @D25720, COUNT @D25719, PER @D25718, 
            PLU @D25717, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25726, AGR [CASE @D25725, COUNT @D25724, PER @D25723, 
            PLU @D25722, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25732, AGR [CASE @D25731, NFORM @D25730, COUNT @D25729, 
            PER @D25728, PLU @D25727, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COLOUR, 
   [COORD @D25737, AGR [CASE @D25736, COUNT @D25735, PER @D25734, 
            PLU @D25733, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COLOUR, 
   [COORD @D25742, AGR [CASE @D25741, COUNT @D25740, PER @D25739, 
            PLU @D25738, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25747, AGR [CASE @D25746, COUNT @D25745, PER @D25744, 
            PLU @D25743, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25752, AGR [CASE @D25751, COUNT @D25750, PER @D25749, 
            PLU @D25748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25757, AGR [CASE @D25756, COUNT @D25755, PER @D25754, 
            PLU @D25753, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25762, AGR [CASE @D25761, COUNT @D25760, PER @D25759, 
            PLU @D25758, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25767, AGR [CASE @D25766, COUNT @D25765, PER @D25764, 
            PLU @D25763, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25772, AGR [CASE @D25771, COUNT @D25770, PER @D25769, 
            PLU @D25768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25777, AGR [CASE @D25776, COUNT @D25775, PER @D25774, 
            PLU @D25773, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25782, AGR [CASE @D25781, COUNT @D25780, PER @D25779, 
            PLU @D25778, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COLOUR.

WORD colouring : 
   [COORD @D25797, PRD @D25796, AGR [CASE @D25795, COUNT @D25794, 
            PER @D25793, PLU @D25792, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25803, PRD @D25802, 
      AGR [CASE @D25801, COUNT @D25800, PER @D25799, PLU @D25798, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COLOUR, 
   [COORD @D25809, PRD @D25808, AGR [CASE @D25807, COUNT @D25806, 
            PER @D25805, PLU @D25804, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25815, PRD @D25814, 
      AGR [CASE @D25813, COUNT @D25812, PER @D25811, PLU @D25810, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COLOUR, 
   [COORD @D25821, PRD @D25820, AGR [CASE @D25819, COUNT @D25818, 
            PER @D25817, PLU @D25816, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COLOUR.

WORD colours : 
   [COORD @D25830, REFL @D25829, PRD @D25828, CASE @D25827, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : COLOURS, 
   [COORD @D25835, DEMON @D25834, REFL @D25833, PRD @D25832, 
      CASE @D25831, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : COLOUR, 
   [COORD @D25837, 
      AGR [COUNT @D25836, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25839, 
      AGR [COUNT @D25838, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25841, 
      AGR [COUNT @D25840, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25843, 
      AGR [COUNT @D25842, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COLOUR, 
   [COORD @D25845, 
      AGR [COUNT @D25844, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COLOUR.

WORD combine : 
   [COORD @D25863, AGR [COUNT @D25862, PER @D25861, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMBINE, 
   [COORD @D25865, AGR [COUNT @D25864, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMBINE, 
   [COORD @D25867, AGR [COUNT @D25866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMBINE, 
   [COORD @D25871, AGR [COUNT @D25870, PER @D25869, PLU @D25868, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMBINE, 
   [COORD @D25877, PAST @D25876, 
      AGR [CASE @D25875, COUNT @D25874, PER @D25873, PLU @D25872, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : COMBINE, 
   [COORD @D25880, AGR [COUNT @D25879, PER @D25878, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMBINE, 
   [COORD @D25882, AGR [COUNT @D25881, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMBINE, 
   [COORD @D25884, AGR [COUNT @D25883, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMBINE, 
   [COORD @D25888, AGR [COUNT @D25887, PER @D25886, PLU @D25885, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMBINE, 
   [COORD @D25894, PAST @D25893, AGR [CASE @D25892, COUNT @D25891, 
            PER @D25890, PLU @D25889, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMBINE, 
   [COORD @D25897, AGR [COUNT @D25896, PER @D25895, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COMBINE, 
   [COORD @D25899, AGR [COUNT @D25898, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COMBINE, 
   [COORD @D25901, AGR [COUNT @D25900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COMBINE, 
   [COORD @D25905, AGR [COUNT @D25904, PER @D25903, PLU @D25902, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : COMBINE, 
   [COORD @D25911, PAST @D25910, 
      AGR [CASE @D25909, COUNT @D25908, PER @D25907, PLU @D25906, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : COMBINE, 
   [COORD @D25914, AGR [COUNT @D25913, PER @D25912, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : COMBINE, 
   [COORD @D25916, AGR [COUNT @D25915, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : COMBINE, 
   [COORD @D25918, AGR [COUNT @D25917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : COMBINE, 
   [COORD @D25922, AGR [COUNT @D25921, PER @D25920, PLU @D25919, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : COMBINE, 
   [COORD @D25928, PAST @D25927, 
      AGR [CASE @D25926, COUNT @D25925, PER @D25924, PLU @D25923, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, 
      ARITY 2] : COMBINE, 
   [COORD @D25931, AGR [COUNT @D25930, PER @D25929, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COMBINE, 
   [COORD @D25933, AGR [COUNT @D25932, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COMBINE, 
   [COORD @D25935, AGR [COUNT @D25934, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COMBINE, 
   [COORD @D25939, AGR [COUNT @D25938, PER @D25937, PLU @D25936, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : COMBINE, 
   [COORD @D25945, PAST @D25944, 
      AGR [CASE @D25943, COUNT @D25942, PER @D25941, PLU @D25940, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COMBINE, 
   [COORD @D25948, AGR [COUNT @D25947, PER @D25946, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMBINE, 
   [COORD @D25950, AGR [COUNT @D25949, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMBINE, 
   [COORD @D25952, AGR [COUNT @D25951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMBINE, 
   [COORD @D25956, AGR [COUNT @D25955, PER @D25954, PLU @D25953, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMBINE, 
   [COORD @D25962, PAST @D25961, AGR [CASE @D25960, COUNT @D25959, 
            PER @D25958, PLU @D25957, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COMBINE, 
   [COORD @D25965, AGR [COUNT @D25964, PER @D25963, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COMBINE, 
   [COORD @D25967, AGR [COUNT @D25966, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COMBINE, 
   [COORD @D25969, AGR [COUNT @D25968, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COMBINE, 
   [COORD @D25973, AGR [COUNT @D25972, PER @D25971, PLU @D25970, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COMBINE, 
   [COORD @D25979, PAST @D25978, 
      AGR [CASE @D25977, COUNT @D25976, PER @D25975, PLU @D25974, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, 
      ARITY 1] : COMBINE.

WORD combined : 
   [COORD @D25990, AGR [CASE @D25989, COUNT @D25988, PER @D25987, 
            PLU @D25986, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D25995, AGR [CASE @D25994, COUNT @D25993, PER @D25992, 
            PLU @D25991, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26000, AGR [CASE @D25999, COUNT @D25998, PER @D25997, 
            PLU @D25996, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26005, AGR [CASE @D26004, COUNT @D26003, PER @D26002, 
            PLU @D26001, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COMBINE, 
   [COORD @D26010, AGR [CASE @D26009, COUNT @D26008, PER @D26007, 
            PLU @D26006, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26015, AGR [CASE @D26014, COUNT @D26013, PER @D26012, 
            PLU @D26011, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26020, AGR [CASE @D26019, COUNT @D26018, PER @D26017, 
            PLU @D26016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26025, AGR [CASE @D26024, COUNT @D26023, PER @D26022, 
            PLU @D26021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26030, AGR [CASE @D26029, COUNT @D26028, PER @D26027, 
            PLU @D26026, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26035, AGR [CASE @D26034, COUNT @D26033, PER @D26032, 
            PLU @D26031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26040, AGR [CASE @D26039, COUNT @D26038, PER @D26037, 
            PLU @D26036, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26045, AGR [CASE @D26044, COUNT @D26043, PER @D26042, 
            PLU @D26041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26050, AGR [CASE @D26049, COUNT @D26048, PER @D26047, 
            PLU @D26046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26055, AGR [CASE @D26054, COUNT @D26053, PER @D26052, 
            PLU @D26051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26060, AGR [CASE @D26059, COUNT @D26058, PER @D26057, 
            PLU @D26056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26065, AGR [CASE @D26064, COUNT @D26063, PER @D26062, 
            PLU @D26061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26070, AGR [CASE @D26069, COUNT @D26068, PER @D26067, 
            PLU @D26066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COMBINE.

WORD combines : 
   [COORD @D26078, AGR [COUNT @D26077, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COMBINE, 
   [COORD @D26080, AGR [COUNT @D26079, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26082, 
      AGR [COUNT @D26081, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26084, 
      AGR [COUNT @D26083, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COMBINE, 
   [COORD @D26086, AGR [COUNT @D26085, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26088, 
      AGR [COUNT @D26087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26090, 
      AGR [COUNT @D26089, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COMBINE.

WORD combining : 
   [COORD @D26101, PRD @D26100, AGR [CASE @D26099, COUNT @D26098, 
            PER @D26097, PLU @D26096, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26107, PRD @D26106, 
      AGR [CASE @D26105, COUNT @D26104, PER @D26103, PLU @D26102, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COMBINE, 
   [COORD @D26113, PRD @D26112, AGR [CASE @D26111, COUNT @D26110, 
            PER @D26109, PLU @D26108, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26119, PRD @D26118, 
      AGR [CASE @D26117, COUNT @D26116, PER @D26115, PLU @D26114, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COMBINE, 
   [COORD @D26125, PRD @D26124, AGR [CASE @D26123, COUNT @D26122, 
            PER @D26121, PLU @D26120, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE, 
   [COORD @D26131, PRD @D26130, 
      AGR [CASE @D26129, COUNT @D26128, PER @D26127, PLU @D26126, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COMBINE, 
   [COORD @D26137, PRD @D26136, AGR [CASE @D26135, COUNT @D26134, 
            PER @D26133, PLU @D26132, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COMBINE.

WORD come : 
   [COORD @D26144, AGR [COUNT @D26143, PER @D26142, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT DOWN, PFORM ON, ARITY 3] : COME, 
   [COORD @D26146, 
      AGR [COUNT @D26145, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, REG -, 
      PRT DOWN, PFORM ON, ARITY 3] : COME, 
   [COORD @D26148, AGR [COUNT @D26147, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT DOWN, PFORM ON, ARITY 3] : COME, 
   [COORD @D26152, 
      AGR [COUNT @D26151, PER @D26150, PLU @D26149, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT DOWN, PFORM ON, ARITY 3] : COME, 
   [COORD @D26158, PAST @D26157, 
      AGR [CASE @D26156, COUNT @D26155, PER @D26154, PLU @D26153, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, REG -, 
      PRT DOWN, PFORM ON, ARITY 3] : COME, 
   [COORD @D26161, AGR [COUNT @D26160, PER @D26159, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT PP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT DOWN, PFORM ON_FOR, ARITY 3] : COME, 
   [COORD @D26163, AGR [COUNT @D26162, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT PP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT DOWN, PFORM ON_FOR, ARITY 3] : COME, 
   [COORD @D26165, AGR [COUNT @D26164, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT PP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT DOWN, PFORM ON_FOR, ARITY 3] : COME, 
   [COORD @D26169, AGR [COUNT @D26168, PER @D26167, PLU @D26166, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT PP_PP, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, REG -, PRT DOWN, PFORM ON_FOR, ARITY 3] : COME, 
   [COORD @D26175, PAST @D26174, 
      AGR [CASE @D26173, COUNT @D26172, PER @D26171, PLU @D26170, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT PP_PP, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, REG -, PRT DOWN, 
      PFORM ON_FOR, ARITY 3] : COME, 
   [COORD @D26181, PAST @D26180, AGR [CASE @D26179, COUNT @D26178, 
            PER @D26177, PLU @D26176, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT DOWN, PFORM ON, FIN -, ARITY 3] : COME, 
   [COORD @D26187, PAST @D26186, 
      AGR [CASE @D26185, COUNT @D26184, PER @D26183, PLU @D26182, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, REG -, PRT DOWN, 
      PFORM ON, FIN -, ARITY 3] : COME, 
   [COORD @D26193, PAST @D26192, AGR [CASE @D26191, COUNT @D26190, 
            PER @D26189, PLU @D26188, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT PP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, REG -, PRT DOWN, PFORM ON_FOR, FIN -, ARITY 3] : COME, 
   [COORD @D26196, 
      AGR [COUNT @D26195, PER @D26194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, ARITY 2] : 
   COME, 
   [COORD @D26198, AGR [COUNT @D26197, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : COME, 
   [COORD @D26200, AGR [COUNT @D26199, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : COME, 
   [COORD @D26204, AGR [COUNT @D26203, PER @D26202, PLU @D26201, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 2] : COME, 
   [COORD @D26210, PAST @D26209, 
      AGR [CASE @D26208, COUNT @D26207, PER @D26206, PLU @D26205, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, ARITY 2] : 
   COME, 
   [COORD @D26213, AGR [COUNT @D26212, PER @D26211, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : COME, 
   [COORD @D26215, AGR [COUNT @D26214, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : COME, 
   [COORD @D26217, AGR [COUNT @D26216, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : COME, 
   [COORD @D26221, AGR [COUNT @D26220, PER @D26219, PLU @D26218, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : COME, 
   [COORD @D26227, PAST @D26226, 
      AGR [CASE @D26225, COUNT @D26224, PER @D26223, PLU @D26222, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, ARITY 2] : 
   COME, 
   [COORD @D26230, AGR [COUNT @D26229, PER @D26228, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : COME, 
   [COORD @D26232, AGR [COUNT @D26231, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : COME, 
   [COORD @D26234, AGR [COUNT @D26233, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : COME, 
   [COORD @D26238, AGR [COUNT @D26237, PER @D26236, PLU @D26235, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : COME, 
   [COORD @D26244, PAST @D26243, AGR [CASE @D26242, COUNT @D26241, 
            PER @D26240, PLU @D26239, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : COME, 
   [COORD @D26247, AGR [COUNT @D26246, PER @D26245, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OVER, ARITY 2] : COME, 
   [COORD @D26249, AGR [COUNT @D26248, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OVER, ARITY 2] : COME, 
   [COORD @D26251, AGR [COUNT @D26250, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OVER, ARITY 2] : COME, 
   [COORD @D26255, AGR [COUNT @D26254, PER @D26253, PLU @D26252, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PRT OVER, ARITY 2] : COME, 
   [COORD @D26261, PAST @D26260, 
      AGR [CASE @D26259, COUNT @D26258, PER @D26257, PLU @D26256, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT OVER, 
      ARITY 2] : COME, 
   [COORD @D26264, AGR [COUNT @D26263, PER @D26262, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26266, AGR [COUNT @D26265, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26268, AGR [COUNT @D26267, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26272, AGR [COUNT @D26271, PER @D26270, PLU @D26269, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26278, PAST @D26277, 
      AGR [CASE @D26276, COUNT @D26275, PER @D26274, PLU @D26273, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT OUT, 
      ARITY 2] : COME, 
   [COORD @D26281, AGR [COUNT @D26280, PER @D26279, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26283, AGR [COUNT @D26282, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26285, AGR [COUNT @D26284, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26289, AGR [COUNT @D26288, PER @D26287, PLU @D26286, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26295, PAST @D26294, 
      AGR [CASE @D26293, COUNT @D26292, PER @D26291, PLU @D26290, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, PRT OUT, 
      ARITY 2] : COME, 
   [COORD @D26298, AGR [COUNT @D26297, PER @D26296, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT OUT, ARITY 2] : COME, 
   [COORD @D26300, AGR [COUNT @D26299, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT OUT, ARITY 2] : COME, 
   [COORD @D26302, AGR [COUNT @D26301, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT OUT, ARITY 2] : COME, 
   [COORD @D26306, AGR [COUNT @D26305, PER @D26304, PLU @D26303, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26312, PAST @D26311, AGR [CASE @D26310, COUNT @D26309, 
            PER @D26308, PLU @D26307, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, REG -, PRT OUT, ARITY 2] : COME, 
   [COORD @D26315, 
      AGR [COUNT @D26314, PER @D26313, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT OFF, 
      ARITY 2] : COME, 
   [COORD @D26317, AGR [COUNT @D26316, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OFF, ARITY 2] : COME, 
   [COORD @D26319, AGR [COUNT @D26318, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT OFF, ARITY 2] : COME, 
   [COORD @D26323, AGR [COUNT @D26322, PER @D26321, PLU @D26320, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PRT OFF, ARITY 2] : COME, 
   [COORD @D26329, PAST @D26328, 
      AGR [CASE @D26327, COUNT @D26326, PER @D26325, PLU @D26324, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT OFF, 
      ARITY 2] : COME, 
   [COORD @D26332, AGR [COUNT @D26331, PER @D26330, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT OFF, ARITY 2] : COME, 
   [COORD @D26334, AGR [COUNT @D26333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT OFF, ARITY 2] : COME, 
   [COORD @D26336, AGR [COUNT @D26335, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT OFF, ARITY 2] : COME, 
   [COORD @D26340, AGR [COUNT @D26339, PER @D26338, PLU @D26337, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      REG -, PRT OFF, ARITY 2] : COME, 
   [COORD @D26346, PAST @D26345, AGR [CASE @D26344, COUNT @D26343, 
            PER @D26342, PLU @D26341, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, REG -, PRT OFF, ARITY 2] : COME, 
   [COORD @D26349, 
      AGR [COUNT @D26348, PER @D26347, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT IN, 
      ARITY 2] : COME, 
   [COORD @D26351, AGR [COUNT @D26350, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT IN, ARITY 2] : COME, 
   [COORD @D26353, AGR [COUNT @D26352, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT IN, ARITY 2] : COME, 
   [COORD @D26357, AGR [COUNT @D26356, PER @D26355, PLU @D26354, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PRT IN, ARITY 2] : COME, 
   [COORD @D26363, PAST @D26362, 
      AGR [CASE @D26361, COUNT @D26360, PER @D26359, PLU @D26358, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT IN, 
      ARITY 2] : COME, 
   [COORD @D26366, AGR [COUNT @D26365, PER @D26364, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT IN, ARITY 2] : COME, 
   [COORD @D26368, AGR [COUNT @D26367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT IN, ARITY 2] : COME, 
   [COORD @D26370, AGR [COUNT @D26369, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT IN, ARITY 2] : COME, 
   [COORD @D26374, AGR [COUNT @D26373, PER @D26372, PLU @D26371, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      REG -, PRT IN, ARITY 2] : COME, 
   [COORD @D26380, PAST @D26379, AGR [CASE @D26378, COUNT @D26377, 
            PER @D26376, PLU @D26375, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, REG -, PRT IN, ARITY 2] : COME, 
   [COORD @D26383, 
      AGR [COUNT @D26382, PER @D26381, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT BY, 
      ARITY 2] : COME, 
   [COORD @D26385, AGR [COUNT @D26384, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT BY, ARITY 2] : COME, 
   [COORD @D26387, AGR [COUNT @D26386, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT BY, ARITY 2] : COME, 
   [COORD @D26391, AGR [COUNT @D26390, PER @D26389, PLU @D26388, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT BY, ARITY 2] : COME, 
   [COORD @D26397, PAST @D26396, AGR [CASE @D26395, COUNT @D26394, 
            PER @D26393, PLU @D26392, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT BY, ARITY 2] : COME, 
   [COORD @D26400, 
      AGR [COUNT @D26399, PER @D26398, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, PRT ACROSS, 
      ARITY 2] : COME, 
   [COORD @D26402, AGR [COUNT @D26401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT ACROSS, ARITY 2] : COME, 
   [COORD @D26404, AGR [COUNT @D26403, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      PRT ACROSS, ARITY 2] : COME, 
   [COORD @D26408, AGR [COUNT @D26407, PER @D26406, PLU @D26405, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      REG -, PRT ACROSS, ARITY 2] : COME, 
   [COORD @D26414, PAST @D26413, AGR 
         [CASE @D26412, COUNT @D26411, PER @D26410, PLU @D26409, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, PRT ACROSS, 
      ARITY 2] : COME, 
   [COORD @D26417, AGR [COUNT @D26416, PER @D26415, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26419, AGR [COUNT @D26418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26421, AGR [COUNT @D26420, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26425, AGR [COUNT @D26424, PER @D26423, PLU @D26422, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26431, PAST @D26430, 
      AGR [CASE @D26429, COUNT @D26428, PER @D26427, PLU @D26426, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT ACROSS, 
      PREP AS, ARITY 2] : COME, 
   [COORD @D26434, AGR [COUNT @D26433, PER @D26432, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26436, AGR [COUNT @D26435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26438, AGR [COUNT @D26437, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26442, AGR [COUNT @D26441, PER @D26440, PLU @D26439, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PRT ACROSS, PREP AS, ARITY 2] : COME, 
   [COORD @D26448, PAST @D26447, 
      AGR [CASE @D26446, COUNT @D26445, PER @D26444, PLU @D26443, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT ACROSS, 
      PREP AS, ARITY 2] : COME, 
   [COORD @D26451, AGR [COUNT @D26450, PER @D26449, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26453, AGR [COUNT @D26452, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26455, AGR [COUNT @D26454, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26459, AGR [COUNT @D26458, PER @D26457, PLU @D26456, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26465, PAST @D26464, 
      AGR [CASE @D26463, COUNT @D26462, PER @D26461, PLU @D26460, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, 
      PFORM WITH, ARITY 2] : COME, 
   [COORD @D26468, AGR [COUNT @D26467, PER @D26466, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT THROUGH, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26470, AGR [COUNT @D26469, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT THROUGH, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26472, AGR [COUNT @D26471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT THROUGH, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26476, AGR [COUNT @D26475, PER @D26474, PLU @D26473, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT THROUGH, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26482, PAST @D26481, 
      AGR [CASE @D26480, COUNT @D26479, PER @D26478, PLU @D26477, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT THROUGH, 
      PFORM WITH, ARITY 2] : COME, 
   [COORD @D26485, AGR [COUNT @D26484, PER @D26483, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26487, AGR [COUNT @D26486, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26489, AGR [COUNT @D26488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26493, AGR [COUNT @D26492, PER @D26491, PLU @D26490, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26499, PAST @D26498, 
      AGR [CASE @D26497, COUNT @D26496, PER @D26495, PLU @D26494, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM WITH, ARITY 2] : COME, 
   [COORD @D26502, AGR [COUNT @D26501, PER @D26500, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26504, AGR [COUNT @D26503, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26506, AGR [COUNT @D26505, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26510, AGR [COUNT @D26509, PER @D26508, PLU @D26507, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT DOWN, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26516, PAST @D26515, 
      AGR [CASE @D26514, COUNT @D26513, PER @D26512, PLU @D26511, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT DOWN, 
      PFORM WITH, ARITY 2] : COME, 
   [COORD @D26519, AGR [COUNT @D26518, PER @D26517, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26521, AGR [COUNT @D26520, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26523, AGR [COUNT @D26522, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26527, AGR [COUNT @D26526, PER @D26525, PLU @D26524, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT BACK, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26533, PAST @D26532, 
      AGR [CASE @D26531, COUNT @D26530, PER @D26529, PLU @D26528, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, 
      PFORM WITH, ARITY 2] : COME, 
   [COORD @D26536, AGR [COUNT @D26535, PER @D26534, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT ACROSS, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26538, AGR [COUNT @D26537, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT ACROSS, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26540, AGR [COUNT @D26539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT ACROSS, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26544, AGR [COUNT @D26543, PER @D26542, PLU @D26541, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT ACROSS, PFORM WITH, ARITY 2] : COME, 
   [COORD @D26550, PAST @D26549, 
      AGR [CASE @D26548, COUNT @D26547, PER @D26546, PLU @D26545, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT ACROSS, 
      PFORM WITH, ARITY 2] : COME, 
   [COORD @D26553, AGR [COUNT @D26552, PER @D26551, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM UP_TO, ARITY 2] : COME, 
   [COORD @D26555, AGR [COUNT @D26554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM UP_TO, ARITY 2] : COME, 
   [COORD @D26557, AGR [COUNT @D26556, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM UP_TO, ARITY 2] : COME, 
   [COORD @D26561, AGR [COUNT @D26560, PER @D26559, PLU @D26558, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM UP_TO, ARITY 2] : COME, 
   [COORD @D26567, PAST @D26566, 
      AGR [CASE @D26565, COUNT @D26564, PER @D26563, PLU @D26562, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM UP_TO, 
      ARITY 2] : COME, 
   [COORD @D26570, AGR [COUNT @D26569, PER @D26568, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : COME, 
   [COORD @D26572, AGR [COUNT @D26571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : COME, 
   [COORD @D26574, AGR [COUNT @D26573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : COME, 
   [COORD @D26578, AGR [COUNT @D26577, PER @D26576, PLU @D26575, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : COME, 
   [COORD @D26584, PAST @D26583, AGR 
         [CASE @D26582, COUNT @D26581, PER @D26580, PLU @D26579, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM UPON, 
      ARITY 2] : COME, 
   [COORD @D26587, AGR [COUNT @D26586, PER @D26585, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UNDER, ARITY 2] : COME, 
   [COORD @D26589, AGR [COUNT @D26588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UNDER, ARITY 2] : COME, 
   [COORD @D26591, AGR [COUNT @D26590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UNDER, ARITY 2] : COME, 
   [COORD @D26595, AGR [COUNT @D26594, PER @D26593, PLU @D26592, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UNDER, ARITY 2] : COME, 
   [COORD @D26601, PAST @D26600, 
      AGR [CASE @D26599, COUNT @D26598, PER @D26597, PLU @D26596, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM UNDER, 
      ARITY 2] : COME, 
   [COORD @D26604, AGR [COUNT @D26603, PER @D26602, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : COME, 
   [COORD @D26606, AGR [COUNT @D26605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : COME, 
   [COORD @D26608, AGR [COUNT @D26607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : COME, 
   [COORD @D26612, AGR [COUNT @D26611, PER @D26610, PLU @D26609, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : COME, 
   [COORD @D26618, PAST @D26617, AGR [CASE @D26616, COUNT @D26615, 
            PER @D26614, PLU @D26613, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : COME, 
   [COORD @D26621, 
      AGR [COUNT @D26620, PER @D26619, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM TO, 
      ARITY 2] : COME, 
   [COORD @D26623, AGR [COUNT @D26622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : COME, 
   [COORD @D26625, AGR [COUNT @D26624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : COME, 
   [COORD @D26629, AGR [COUNT @D26628, PER @D26627, PLU @D26626, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : COME, 
   [COORD @D26635, PAST @D26634, 
      AGR [CASE @D26633, COUNT @D26632, PER @D26631, PLU @D26630, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM TO, 
      ARITY 2] : COME, 
   [COORD @D26638, AGR [COUNT @D26637, PER @D26636, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ROUND, PFORM TO, ARITY 2] : COME, 
   [COORD @D26640, AGR [COUNT @D26639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ROUND, PFORM TO, ARITY 2] : COME, 
   [COORD @D26642, AGR [COUNT @D26641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ROUND, PFORM TO, ARITY 2] : COME, 
   [COORD @D26646, AGR [COUNT @D26645, PER @D26644, PLU @D26643, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ROUND, PFORM TO, ARITY 2] : COME, 
   [COORD @D26652, PAST @D26651, 
      AGR [CASE @D26650, COUNT @D26649, PER @D26648, PLU @D26647, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ROUND, 
      PFORM TO, ARITY 2] : COME, 
   [COORD @D26655, AGR [COUNT @D26654, PER @D26653, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : COME, 
   [COORD @D26657, AGR [COUNT @D26656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : COME, 
   [COORD @D26659, AGR [COUNT @D26658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : COME, 
   [COORD @D26663, AGR [COUNT @D26662, PER @D26661, PLU @D26660, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OVER, PFORM TO, ARITY 2] : COME, 
   [COORD @D26669, PAST @D26668, 
      AGR [CASE @D26667, COUNT @D26666, PER @D26665, PLU @D26664, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, 
      PFORM TO, ARITY 2] : COME, 
   [COORD @D26672, AGR [COUNT @D26671, PER @D26670, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM TO, ARITY 2] : COME, 
   [COORD @D26674, AGR [COUNT @D26673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM TO, ARITY 2] : COME, 
   [COORD @D26676, AGR [COUNT @D26675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM TO, ARITY 2] : COME, 
   [COORD @D26680, AGR [COUNT @D26679, PER @D26678, PLU @D26677, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 2] : COME, 
   [COORD @D26686, PAST @D26685, 
      AGR [CASE @D26684, COUNT @D26683, PER @D26682, PLU @D26681, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT DOWN, 
      PFORM TO, ARITY 2] : COME, 
   [COORD @D26689, AGR [COUNT @D26688, PER @D26687, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM TO, ARITY 2] : COME, 
   [COORD @D26691, AGR [COUNT @D26690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM TO, ARITY 2] : COME, 
   [COORD @D26693, AGR [COUNT @D26692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM TO, ARITY 2] : COME, 
   [COORD @D26697, AGR [COUNT @D26696, PER @D26695, PLU @D26694, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT BACK, PFORM TO, ARITY 2] : COME, 
   [COORD @D26703, PAST @D26702, 
      AGR [CASE @D26701, COUNT @D26700, PER @D26699, PLU @D26698, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, 
      PFORM TO, ARITY 2] : COME, 
   [COORD @D26706, AGR [COUNT @D26705, PER @D26704, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : COME, 
   [COORD @D26708, AGR [COUNT @D26707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : COME, 
   [COORD @D26710, AGR [COUNT @D26709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : COME, 
   [COORD @D26714, AGR [COUNT @D26713, PER @D26712, PLU @D26711, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM THROUGH, ARITY 2] : COME, 
   [COORD @D26720, PAST @D26719, 
      AGR [CASE @D26718, COUNT @D26717, PER @D26716, PLU @D26715, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM THROUGH, 
      ARITY 2] : COME, 
   [COORD @D26723, AGR [COUNT @D26722, PER @D26721, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : COME, 
   [COORD @D26725, AGR [COUNT @D26724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : COME, 
   [COORD @D26727, AGR [COUNT @D26726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : COME, 
   [COORD @D26731, AGR [COUNT @D26730, PER @D26729, PLU @D26728, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OVER, ARITY 2] : COME, 
   [COORD @D26737, PAST @D26736, AGR 
         [CASE @D26735, COUNT @D26734, PER @D26733, PLU @D26732, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OVER, 
      ARITY 2] : COME, 
   [COORD @D26740, AGR [COUNT @D26739, PER @D26738, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : COME, 
   [COORD @D26742, AGR [COUNT @D26741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : COME, 
   [COORD @D26744, AGR [COUNT @D26743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : COME, 
   [COORD @D26748, AGR [COUNT @D26747, PER @D26746, PLU @D26745, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : COME, 
   [COORD @D26754, PAST @D26753, AGR [CASE @D26752, COUNT @D26751, 
            PER @D26750, PLU @D26749, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : COME, 
   [COORD @D26757, 
      AGR [COUNT @D26756, PER @D26755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, PFORM ON, 
      ARITY 2] : COME, 
   [COORD @D26759, AGR [COUNT @D26758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : COME, 
   [COORD @D26761, AGR [COUNT @D26760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : COME, 
   [COORD @D26765, AGR [COUNT @D26764, PER @D26763, PLU @D26762, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM ON, ARITY 2] : COME, 
   [COORD @D26771, PAST @D26770, 
      AGR [CASE @D26769, COUNT @D26768, PER @D26767, PLU @D26766, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, PFORM ON, 
      ARITY 2] : COME, 
   [COORD @D26774, AGR [COUNT @D26773, PER @D26772, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : COME, 
   [COORD @D26776, AGR [COUNT @D26775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : COME, 
   [COORD @D26778, AGR [COUNT @D26777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : COME, 
   [COORD @D26782, AGR [COUNT @D26781, PER @D26780, PLU @D26779, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT DOWN, PFORM ON, ARITY 2] : COME, 
   [COORD @D26788, PAST @D26787, 
      AGR [CASE @D26786, COUNT @D26785, PER @D26784, PLU @D26783, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT DOWN, 
      PFORM ON, ARITY 2] : COME, 
   [COORD @D26791, AGR [COUNT @D26790, PER @D26789, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : COME, 
   [COORD @D26793, AGR [COUNT @D26792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : COME, 
   [COORD @D26795, AGR [COUNT @D26794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : COME, 
   [COORD @D26799, AGR [COUNT @D26798, PER @D26797, PLU @D26796, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OFF, ARITY 2] : COME, 
   [COORD @D26805, PAST @D26804, AGR [CASE @D26803, COUNT @D26802, 
            PER @D26801, PLU @D26800, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, ARITY 2] : COME, 
   [COORD @D26808, 
      AGR [COUNT @D26807, PER @D26806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OF, 
      ARITY 2] : COME, 
   [COORD @D26810, AGR [COUNT @D26809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : COME, 
   [COORD @D26812, AGR [COUNT @D26811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : COME, 
   [COORD @D26816, AGR [COUNT @D26815, PER @D26814, PLU @D26813, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OF, ARITY 2] : COME, 
   [COORD @D26822, PAST @D26821, AGR [CASE @D26820, COUNT @D26819, 
            PER @D26818, PLU @D26817, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OF, ARITY 2] : COME, 
   [COORD @D26825, 
      AGR [COUNT @D26824, PER @D26823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, 
      ARITY 2] : COME, 
   [COORD @D26827, AGR [COUNT @D26826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : COME, 
   [COORD @D26829, AGR [COUNT @D26828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : COME, 
   [COORD @D26833, AGR [COUNT @D26832, PER @D26831, PLU @D26830, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM INTO, ARITY 2] : COME, 
   [COORD @D26839, PAST @D26838, AGR 
         [CASE @D26837, COUNT @D26836, PER @D26835, PLU @D26834, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, 
      ARITY 2] : COME, 
   [COORD @D26842, AGR [COUNT @D26841, PER @D26840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM IN, ARITY 2] : COME, 
   [COORD @D26844, AGR [COUNT @D26843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM IN, ARITY 2] : COME, 
   [COORD @D26846, AGR [COUNT @D26845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM IN, ARITY 2] : COME, 
   [COORD @D26850, AGR [COUNT @D26849, PER @D26848, PLU @D26847, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM IN, ARITY 2] : COME, 
   [COORD @D26856, PAST @D26855, 
      AGR [CASE @D26854, COUNT @D26853, PER @D26852, PLU @D26851, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM IN, ARITY 2] : COME, 
   [COORD @D26859, AGR [COUNT @D26858, PER @D26857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM IN, ARITY 2] : COME, 
   [COORD @D26861, AGR [COUNT @D26860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM IN, ARITY 2] : COME, 
   [COORD @D26863, AGR [COUNT @D26862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM IN, ARITY 2] : COME, 
   [COORD @D26867, AGR [COUNT @D26866, PER @D26865, PLU @D26864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM IN, ARITY 2] : COME, 
   [COORD @D26873, PAST @D26872, 
      AGR [CASE @D26871, COUNT @D26870, PER @D26869, PLU @D26868, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM IN, ARITY 2] : COME, 
   [COORD @D26876, AGR [COUNT @D26875, PER @D26874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : COME, 
   [COORD @D26878, AGR [COUNT @D26877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : COME, 
   [COORD @D26880, AGR [COUNT @D26879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : COME, 
   [COORD @D26884, AGR [COUNT @D26883, PER @D26882, PLU @D26881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26890, PAST @D26889, AGR 
         [CASE @D26888, COUNT @D26887, PER @D26886, PLU @D26885, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FROM, 
      ARITY 2] : COME, 
   [COORD @D26893, AGR [COUNT @D26892, PER @D26891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26895, AGR [COUNT @D26894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26897, AGR [COUNT @D26896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26901, AGR [COUNT @D26900, PER @D26899, PLU @D26898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OVER, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26907, PAST @D26906, 
      AGR [CASE @D26905, COUNT @D26904, PER @D26903, PLU @D26902, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, 
      PFORM FROM, ARITY 2] : COME, 
   [COORD @D26910, AGR [COUNT @D26909, PER @D26908, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26912, AGR [COUNT @D26911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26914, AGR [COUNT @D26913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26918, AGR [COUNT @D26917, PER @D26916, PLU @D26915, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26924, PAST @D26923, 
      AGR [CASE @D26922, COUNT @D26921, PER @D26920, PLU @D26919, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM FROM, ARITY 2] : COME, 
   [COORD @D26927, AGR [COUNT @D26926, PER @D26925, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26929, AGR [COUNT @D26928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26931, AGR [COUNT @D26930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26935, AGR [COUNT @D26934, PER @D26933, PLU @D26932, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT AWAY, PFORM FROM, ARITY 2] : COME, 
   [COORD @D26941, PAST @D26940, 
      AGR [CASE @D26939, COUNT @D26938, PER @D26937, PLU @D26936, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AWAY, 
      PFORM FROM, ARITY 2] : COME, 
   [COORD @D26944, AGR [COUNT @D26943, PER @D26942, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : COME, 
   [COORD @D26946, AGR [COUNT @D26945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : COME, 
   [COORD @D26948, AGR [COUNT @D26947, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : COME, 
   [COORD @D26952, AGR [COUNT @D26951, PER @D26950, PLU @D26949, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26958, PAST @D26957, AGR [CASE @D26956, COUNT @D26955, 
            PER @D26954, PLU @D26953, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26961, 
      AGR [COUNT @D26960, PER @D26959, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, ARITY 2] : COME, 
   [COORD @D26963, AGR [COUNT @D26962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26965, AGR [COUNT @D26964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26969, AGR [COUNT @D26968, PER @D26967, PLU @D26966, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26975, PAST @D26974, 
      AGR [CASE @D26973, COUNT @D26972, PER @D26971, PLU @D26970, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, ARITY 2] : COME, 
   [COORD @D26978, AGR [COUNT @D26977, PER @D26976, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26980, AGR [COUNT @D26979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26982, AGR [COUNT @D26981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26986, AGR [COUNT @D26985, PER @D26984, PLU @D26983, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM FOR, ARITY 2] : COME, 
   [COORD @D26992, PAST @D26991, 
      AGR [CASE @D26990, COUNT @D26989, PER @D26988, PLU @D26987, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, ARITY 2] : COME, 
   [COORD @D26995, AGR [COUNT @D26994, PER @D26993, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM DOWN_TO, ARITY 2] : COME, 
   [COORD @D26997, AGR [COUNT @D26996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM DOWN_TO, ARITY 2] : COME, 
   [COORD @D26999, AGR [COUNT @D26998, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM DOWN_TO, ARITY 2] : COME, 
   [COORD @D27003, AGR [COUNT @D27002, PER @D27001, PLU @D27000, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM DOWN_TO, ARITY 2] : COME, 
   [COORD @D27009, PAST @D27008, 
      AGR [CASE @D27007, COUNT @D27006, PER @D27005, PLU @D27004, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM DOWN_TO, 
      ARITY 2] : COME, 
   [COORD @D27012, AGR [COUNT @D27011, PER @D27010, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BETWEEN, ARITY 2] : COME, 
   [COORD @D27014, AGR [COUNT @D27013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BETWEEN, ARITY 2] : COME, 
   [COORD @D27016, AGR [COUNT @D27015, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BETWEEN, ARITY 2] : COME, 
   [COORD @D27020, AGR [COUNT @D27019, PER @D27018, PLU @D27017, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BETWEEN, ARITY 2] : COME, 
   [COORD @D27026, PAST @D27025, 
      AGR [CASE @D27024, COUNT @D27023, PER @D27022, PLU @D27021, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BETWEEN, 
      ARITY 2] : COME, 
   [COORD @D27029, AGR [COUNT @D27028, PER @D27027, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEFORE, ARITY 2] : COME, 
   [COORD @D27031, AGR [COUNT @D27030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEFORE, ARITY 2] : COME, 
   [COORD @D27033, AGR [COUNT @D27032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEFORE, ARITY 2] : COME, 
   [COORD @D27037, AGR [COUNT @D27036, PER @D27035, PLU @D27034, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BEFORE, ARITY 2] : COME, 
   [COORD @D27043, PAST @D27042, 
      AGR [CASE @D27041, COUNT @D27040, PER @D27039, PLU @D27038, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BEFORE, 
      ARITY 2] : COME, 
   [COORD @D27046, AGR [COUNT @D27045, PER @D27044, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : COME, 
   [COORD @D27048, AGR [COUNT @D27047, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : COME, 
   [COORD @D27050, AGR [COUNT @D27049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : COME, 
   [COORD @D27054, AGR [COUNT @D27053, PER @D27052, PLU @D27051, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : COME, 
   [COORD @D27060, PAST @D27059, AGR [CASE @D27058, COUNT @D27057, 
            PER @D27056, PLU @D27055, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : COME, 
   [COORD @D27063, 
      AGR [COUNT @D27062, PER @D27061, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM AT, ARITY 2] : COME, 
   [COORD @D27065, AGR [COUNT @D27064, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, ARITY 2] : COME, 
   [COORD @D27067, AGR [COUNT @D27066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, ARITY 2] : COME, 
   [COORD @D27071, AGR [COUNT @D27070, PER @D27069, PLU @D27068, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM AT, ARITY 2] : COME, 
   [COORD @D27077, PAST @D27076, 
      AGR [CASE @D27075, COUNT @D27074, PER @D27073, PLU @D27072, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM AT, ARITY 2] : COME, 
   [COORD @D27080, AGR [COUNT @D27079, PER @D27078, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM AT, ARITY 2] : COME, 
   [COORD @D27082, AGR [COUNT @D27081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM AT, ARITY 2] : COME, 
   [COORD @D27084, AGR [COUNT @D27083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM AT, ARITY 2] : COME, 
   [COORD @D27088, AGR [COUNT @D27087, PER @D27086, PLU @D27085, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT BACK, PFORM AT, ARITY 2] : COME, 
   [COORD @D27094, PAST @D27093, 
      AGR [CASE @D27092, COUNT @D27091, PER @D27090, PLU @D27089, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, 
      PFORM AT, ARITY 2] : COME, 
   [COORD @D27097, AGR [COUNT @D27096, PER @D27095, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ACROSS, PFORM AS, ARITY 2] : COME, 
   [COORD @D27099, AGR [COUNT @D27098, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ACROSS, PFORM AS, ARITY 2] : COME, 
   [COORD @D27101, AGR [COUNT @D27100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ACROSS, PFORM AS, ARITY 2] : COME, 
   [COORD @D27105, AGR [COUNT @D27104, PER @D27103, PLU @D27102, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ACROSS, PFORM AS, ARITY 2] : COME, 
   [COORD @D27111, PAST @D27110, 
      AGR [CASE @D27109, COUNT @D27108, PER @D27107, PLU @D27106, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ACROSS, 
      PFORM AS, ARITY 2] : COME, 
   [COORD @D27114, AGR [COUNT @D27113, PER @D27112, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27116, AGR [COUNT @D27115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27118, AGR [COUNT @D27117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27122, AGR [COUNT @D27121, PER @D27120, PLU @D27119, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27128, PAST @D27127, 
      AGR [CASE @D27126, COUNT @D27125, PER @D27124, PLU @D27123, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, 
      PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27131, AGR [COUNT @D27130, PER @D27129, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27133, AGR [COUNT @D27132, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27135, AGR [COUNT @D27134, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27139, AGR [COUNT @D27138, PER @D27137, PLU @D27136, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27145, PAST @D27144, 
      AGR [CASE @D27143, COUNT @D27142, PER @D27141, PLU @D27140, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM AGAINST, ARITY 2] : COME, 
   [COORD @D27148, AGR [COUNT @D27147, PER @D27146, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : COME, 
   [COORD @D27150, AGR [COUNT @D27149, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : COME, 
   [COORD @D27152, AGR [COUNT @D27151, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : COME, 
   [COORD @D27156, AGR [COUNT @D27155, PER @D27154, PLU @D27153, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ACROSS, ARITY 2] : COME, 
   [COORD @D27162, PAST @D27161, 
      AGR [CASE @D27160, COUNT @D27159, PER @D27158, PLU @D27157, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ACROSS, 
      ARITY 2] : COME, 
   [COORD @D27168, PAST @D27167, AGR [CASE @D27166, COUNT @D27165, 
            PER @D27164, PLU @D27163, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, FIN -, ARITY 2] : COME, 
   [COORD @D27174, PAST @D27173, 
      AGR [CASE @D27172, COUNT @D27171, PER @D27170, PLU @D27169, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, FIN -, ARITY 2] : COME, 
   
   [COORD @D27180, PAST @D27179, AGR [CASE @D27178, COUNT @D27177, PER 
               @D27176, PLU @D27175, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, FIN -, ARITY 2] : COME, 
   [COORD @D27186, PAST @D27185, 
      AGR [CASE @D27184, COUNT @D27183, PER @D27182, PLU @D27181, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT OVER, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27192, PAST @D27191, AGR [CASE @D27190, COUNT @D27189, 
            PER @D27188, PLU @D27187, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PRT OUT, FIN -, ARITY 2] : COME, 
   [COORD @D27198, PAST @D27197, 
      AGR [CASE @D27196, COUNT @D27195, PER @D27194, PLU @D27193, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, PRT OUT, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27204, PAST @D27203, AGR [CASE @D27202, COUNT @D27201, 
            PER @D27200, PLU @D27199, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, REG -, PRT OUT, FIN -, ARITY 2] : COME, 
   [COORD @D27210, PAST @D27209, 
      AGR [CASE @D27208, COUNT @D27207, PER @D27206, PLU @D27205, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT OFF, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27216, PAST @D27215, AGR [CASE @D27214, COUNT @D27213, 
            PER @D27212, PLU @D27211, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, REG -, PRT OFF, FIN -, ARITY 2] : COME, 
   [COORD @D27222, PAST @D27221, 
      AGR [CASE @D27220, COUNT @D27219, PER @D27218, PLU @D27217, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT IN, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27228, PAST @D27227, AGR [CASE @D27226, COUNT @D27225, 
            PER @D27224, PLU @D27223, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, REG -, PRT IN, FIN -, ARITY 2] : COME, 
   [COORD @D27234, PAST @D27233, 
      AGR [CASE @D27232, COUNT @D27231, PER @D27230, PLU @D27229, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT BY, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27240, PAST @D27239, AGR [CASE @D27238, COUNT @D27237, 
            PER @D27236, PLU @D27235, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT BY, FIN -, ARITY 2] : COME, 
   [COORD @D27246, PAST @D27245, 
      AGR [CASE @D27244, COUNT @D27243, PER @D27242, PLU @D27241, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, PRT ACROSS, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27252, PAST @D27251, AGR [CASE @D27250, COUNT @D27249, 
            PER @D27248, PLU @D27247, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT ACROSS, PREP AS, FIN -, ARITY 2] : COME, 
   [COORD @D27258, PAST @D27257, 
      AGR [CASE @D27256, COUNT @D27255, PER @D27254, PLU @D27253, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT ACROSS, PREP AS, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27264, PAST @D27263, AGR [CASE @D27262, COUNT @D27261, 
            PER @D27260, PLU @D27259, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM WITH, FIN -, ARITY 2] : COME, 
   [COORD @D27270, PAST @D27269, 
      AGR [CASE @D27268, COUNT @D27267, PER @D27266, PLU @D27265, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM WITH, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27276, PAST @D27275, AGR [CASE @D27274, COUNT @D27273, 
            PER @D27272, PLU @D27271, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT THROUGH, PFORM WITH, FIN -, ARITY 2] : COME, 
   [COORD @D27282, PAST @D27281, 
      AGR [CASE @D27280, COUNT @D27279, PER @D27278, PLU @D27277, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM WITH, FIN -, ARITY 2] : COME, 
   [COORD @D27288, PAST @D27287, AGR 
         [CASE @D27286, COUNT @D27285, PER @D27284, PLU @D27283, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, PFORM WITH, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27294, PAST @D27293, AGR [CASE @D27292, COUNT @D27291, 
            PER @D27290, PLU @D27289, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM WITH, FIN -, ARITY 2] : COME, 
   [COORD @D27300, PAST @D27299, 
      AGR [CASE @D27298, COUNT @D27297, PER @D27296, PLU @D27295, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT DOWN, PFORM WITH, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27306, PAST @D27305, AGR [CASE @D27304, COUNT @D27303, 
            PER @D27302, PLU @D27301, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT BACK, PFORM WITH, FIN -, ARITY 2] : COME, 
   [COORD @D27312, PAST @D27311, 
      AGR [CASE @D27310, COUNT @D27309, PER @D27308, PLU @D27307, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ACROSS, 
      PFORM WITH, FIN -, ARITY 2] : COME, 
   [COORD @D27318, PAST @D27317, AGR 
         [CASE @D27316, COUNT @D27315, PER @D27314, PLU @D27313, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT ACROSS, PFORM WITH, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27324, PAST @D27323, AGR [CASE @D27322, COUNT @D27321, 
            PER @D27320, PLU @D27319, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM UP_TO, FIN -, ARITY 2] : COME, 
   [COORD @D27330, PAST @D27329, 
      AGR [CASE @D27328, COUNT @D27327, PER @D27326, PLU @D27325, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM UPON, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27336, PAST @D27335, AGR [CASE @D27334, COUNT @D27333, 
            PER @D27332, PLU @D27331, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM UPON, FIN -, ARITY 2] : COME, 
   [COORD @D27342, PAST @D27341, 
      AGR [CASE @D27340, COUNT @D27339, PER @D27338, PLU @D27337, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM UNDER, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27348, PAST @D27347, AGR [CASE @D27346, COUNT @D27345, 
            PER @D27344, PLU @D27343, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM UNDER, FIN -, ARITY 2] : COME, 
   [COORD @D27354, PAST @D27353, 
      AGR [CASE @D27352, COUNT @D27351, PER @D27350, PLU @D27349, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM TO, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27360, PAST @D27359, AGR [CASE @D27358, COUNT @D27357, 
            PER @D27356, PLU @D27355, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : COME, 
   [COORD @D27366, PAST @D27365, 
      AGR [CASE @D27364, COUNT @D27363, PER @D27362, PLU @D27361, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM TO, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27372, PAST @D27371, AGR [CASE @D27370, COUNT @D27369, 
            PER @D27368, PLU @D27367, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT UP, PFORM TO, FIN -, ARITY 2] : COME, 
   [COORD @D27378, PAST @D27377, 
      AGR [CASE @D27376, COUNT @D27375, PER @D27374, PLU @D27373, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ROUND, PFORM TO, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27384, PAST @D27383, AGR [CASE @D27382, COUNT @D27381, 
            PER @D27380, PLU @D27379, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OVER, PFORM TO, FIN -, ARITY 2] : COME, 
   [COORD @D27390, PAST @D27389, 
      AGR [CASE @D27388, COUNT @D27387, PER @D27386, PLU @D27385, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, PFORM TO, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27396, PAST @D27395, AGR [CASE @D27394, COUNT @D27393, 
            PER @D27392, PLU @D27391, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT DOWN, PFORM TO, FIN -, ARITY 2] : COME, 
   [COORD @D27402, PAST @D27401, 
      AGR [CASE @D27400, COUNT @D27399, PER @D27398, PLU @D27397, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, PFORM TO, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27408, PAST @D27407, AGR [CASE @D27406, COUNT @D27405, 
            PER @D27404, PLU @D27403, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM THROUGH, FIN -, ARITY 2] : COME, 
   [COORD @D27414, PAST @D27413, 
      AGR [CASE @D27412, COUNT @D27411, PER @D27410, PLU @D27409, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM THROUGH, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27420, PAST @D27419, AGR [CASE @D27418, COUNT @D27417, 
            PER @D27416, PLU @D27415, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM OVER, FIN -, ARITY 2] : COME, 
   [COORD @D27426, PAST @D27425, 
      AGR [CASE @D27424, COUNT @D27423, PER @D27422, PLU @D27421, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OVER, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27432, PAST @D27431, AGR [CASE @D27430, COUNT @D27429, 
            PER @D27428, PLU @D27427, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ON, FIN -, ARITY 2] : COME, 
   [COORD @D27438, PAST @D27437, 
      AGR [CASE @D27436, COUNT @D27435, PER @D27434, PLU @D27433, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27444, PAST @D27443, AGR [CASE @D27442, COUNT @D27441, 
            PER @D27440, PLU @D27439, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, PFORM ON, FIN -, ARITY 2] : COME, 
   [COORD @D27450, PAST @D27449, 
      AGR [CASE @D27448, COUNT @D27447, PER @D27446, PLU @D27445, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, PFORM ON, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27456, PAST @D27455, AGR [CASE @D27454, COUNT @D27453, 
            PER @D27452, PLU @D27451, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM ON, FIN -, ARITY 2] : COME, 
   [COORD @D27462, PAST @D27461, 
      AGR [CASE @D27460, COUNT @D27459, PER @D27458, PLU @D27457, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT DOWN, PFORM ON, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27468, PAST @D27467, AGR [CASE @D27466, COUNT @D27465, 
            PER @D27464, PLU @D27463, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM OFF, FIN -, ARITY 2] : COME, 
   [COORD @D27474, PAST @D27473, 
      AGR [CASE @D27472, COUNT @D27471, PER @D27470, PLU @D27469, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27480, PAST @D27479, AGR [CASE @D27478, COUNT @D27477, 
            PER @D27476, PLU @D27475, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM OF, FIN -, ARITY 2] : COME, 
   [COORD @D27486, PAST @D27485, 
      AGR [CASE @D27484, COUNT @D27483, PER @D27482, PLU @D27481, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OF, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27492, PAST @D27491, AGR [CASE @D27490, COUNT @D27489, 
            PER @D27488, PLU @D27487, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM INTO, FIN -, ARITY 2] : COME, 
   [COORD @D27498, PAST @D27497, 
      AGR [CASE @D27496, COUNT @D27495, PER @D27494, PLU @D27493, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27504, PAST @D27503, AGR [CASE @D27502, COUNT @D27501, 
            PER @D27500, PLU @D27499, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM IN, FIN -, ARITY 2] : COME, 
   [COORD @D27510, PAST @D27509, 
      AGR [CASE @D27508, COUNT @D27507, PER @D27506, PLU @D27505, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, PFORM IN, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27516, PAST @D27515, AGR [CASE @D27514, COUNT @D27513, 
            PER @D27512, PLU @D27511, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT DOWN, PFORM IN, FIN -, ARITY 2] : COME, 
   [COORD @D27522, PAST @D27521, 
      AGR [CASE @D27520, COUNT @D27519, PER @D27518, PLU @D27517, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM FROM, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27528, PAST @D27527, AGR [CASE @D27526, COUNT @D27525, 
            PER @D27524, PLU @D27523, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM FROM, FIN -, ARITY 2] : COME, 
   [COORD @D27534, PAST @D27533, 
      AGR [CASE @D27532, COUNT @D27531, PER @D27530, PLU @D27529, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, PFORM FROM, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27540, PAST @D27539, AGR [CASE @D27538, COUNT @D27537, 
            PER @D27536, PLU @D27535, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT DOWN, PFORM FROM, FIN -, ARITY 2] : COME, 
   [COORD @D27546, PAST @D27545, 
      AGR [CASE @D27544, COUNT @D27543, PER @D27542, PLU @D27541, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AWAY, PFORM FROM, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27552, PAST @D27551, AGR [CASE @D27550, COUNT @D27549, 
            PER @D27548, PLU @D27547, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM FOR, FIN -, ARITY 2] : COME, 
   [COORD @D27558, PAST @D27557, 
      AGR [CASE @D27556, COUNT @D27555, PER @D27554, PLU @D27553, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27564, PAST @D27563, AGR [CASE @D27562, COUNT @D27561, 
            PER @D27560, PLU @D27559, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM FOR, FIN -, ARITY 2] : COME, 
   [COORD @D27570, PAST @D27569, 
      AGR [CASE @D27568, COUNT @D27567, PER @D27566, PLU @D27565, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, PFORM FOR, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27576, PAST @D27575, AGR [CASE @D27574, COUNT @D27573, 
            PER @D27572, PLU @D27571, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, PFORM FOR, FIN -, ARITY 2] : COME, 
   [COORD @D27582, PAST @D27581, 
      AGR [CASE @D27580, COUNT @D27579, PER @D27578, PLU @D27577, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, PFORM FOR, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27588, PAST @D27587, AGR [CASE @D27586, COUNT @D27585, 
            PER @D27584, PLU @D27583, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM DOWN_TO, FIN -, ARITY 2] : COME, 
   [COORD @D27594, PAST @D27593, 
      AGR [CASE @D27592, COUNT @D27591, PER @D27590, PLU @D27589, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM BETWEEN, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27600, PAST @D27599, AGR [CASE @D27598, COUNT @D27597, 
            PER @D27596, PLU @D27595, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM BETWEEN, FIN -, ARITY 2] : COME, 
   [COORD @D27606, PAST @D27605, 
      AGR [CASE @D27604, COUNT @D27603, PER @D27602, PLU @D27601, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM BEFORE, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27612, PAST @D27611, AGR [CASE @D27610, COUNT @D27609, 
            PER @D27608, PLU @D27607, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM BEFORE, FIN -, ARITY 2] : COME, 
   [COORD @D27618, PAST @D27617, 
      AGR [CASE @D27616, COUNT @D27615, PER @D27614, PLU @D27613, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM AT, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27624, PAST @D27623, AGR [CASE @D27622, COUNT @D27621, 
            PER @D27620, PLU @D27619, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM AT, FIN -, ARITY 2] : COME, 
   [COORD @D27630, PAST @D27629, 
      AGR [CASE @D27628, COUNT @D27627, PER @D27626, PLU @D27625, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, PFORM AT, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27636, PAST @D27635, AGR [CASE @D27634, COUNT @D27633, 
            PER @D27632, PLU @D27631, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT BACK, PFORM AT, FIN -, ARITY 2] : COME, 
   [COORD @D27642, PAST @D27641, 
      AGR [CASE @D27640, COUNT @D27639, PER @D27638, PLU @D27637, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ACROSS, PFORM AS, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27648, PAST @D27647, AGR [CASE @D27646, COUNT @D27645, 
            PER @D27644, PLU @D27643, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM AGAINST, FIN -, ARITY 2] : COME, 
   [COORD @D27654, PAST @D27653, 
      AGR [CASE @D27652, COUNT @D27651, PER @D27650, PLU @D27649, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM AGAINST, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27660, PAST @D27659, AGR [CASE @D27658, COUNT @D27657, 
            PER @D27656, PLU @D27655, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM AGAINST, FIN -, ARITY 2] : COME, 
   [COORD @D27666, PAST @D27665, 
      AGR [CASE @D27664, COUNT @D27663, PER @D27662, PLU @D27661, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, PFORM AGAINST, 
      FIN -, ARITY 2] : COME, 
   [COORD @D27672, PAST @D27671, AGR [CASE @D27670, COUNT @D27669, 
            PER @D27668, PLU @D27667, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ACROSS, FIN -, ARITY 2] : COME, 
   [COORD @D27678, PAST @D27677, 
      AGR [CASE @D27676, COUNT @D27675, PER @D27674, PLU @D27673, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ACROSS, FIN -, 
      ARITY 2] : COME, 
   [COORD @D27680, AGR [COUNT @D27679, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 1] : COME, 
   [COORD @D27682, AGR [COUNT @D27681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 1] : COME, 
   [COORD @D27686, AGR [NFORM @D27685, COUNT @D27684, PER @D27683, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 1] : COME, 
   [COORD @D27690, AGR [COUNT @D27689, PER @D27688, PLU @D27687, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 1] : COME, 
   [COORD @D27693, AGR @D27692, PAST @D27691, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      REG -, ARITY 1] : COME, 
   [COORD @D27696, AGR [COUNT @D27695, PER @D27694, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : COME, 
   [COORD @D27698, AGR [COUNT @D27697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : COME, 
   [COORD @D27700, AGR [COUNT @D27699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : COME, 
   [COORD @D27704, AGR [COUNT @D27703, PER @D27702, PLU @D27701, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : COME, 
   [COORD @D27710, PAST @D27709, 
      AGR [CASE @D27708, COUNT @D27707, PER @D27706, PLU @D27705, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   COME, 
   [COORD @D27713, AGR [COUNT @D27712, PER @D27711, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : COME, 
   [COORD @D27715, AGR [COUNT @D27714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : COME, 
   [COORD @D27717, AGR [COUNT @D27716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : COME, 
   [COORD @D27721, AGR [COUNT @D27720, PER @D27719, PLU @D27718, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : COME, 
   [COORD @D27727, PAST @D27726, 
      AGR [CASE @D27725, COUNT @D27724, PER @D27723, PLU @D27722, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : COME, 
   [COORD @D27730, AGR [COUNT @D27729, PER @D27728, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : COME, 
   [COORD @D27732, AGR [COUNT @D27731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : COME, 
   [COORD @D27734, AGR [COUNT @D27733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : COME, 
   [COORD @D27738, AGR [COUNT @D27737, PER @D27736, PLU @D27735, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, ARITY 1] : COME, 
   [COORD @D27744, PAST @D27743, 
      AGR [CASE @D27742, COUNT @D27741, PER @D27740, PLU @D27739, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TO, 
      ARITY 1] : COME, 
   [COORD @D27747, AGR [COUNT @D27746, PER @D27745, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : COME, 
   [COORD @D27749, AGR [COUNT @D27748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : COME, 
   [COORD @D27751, AGR [COUNT @D27750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : COME, 
   [COORD @D27755, AGR [COUNT @D27754, PER @D27753, PLU @D27752, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : COME, 
   [COORD @D27761, PAST @D27760, 
      AGR [CASE @D27759, COUNT @D27758, PER @D27757, PLU @D27756, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT THROUGH, 
      ARITY 1] : COME, 
   [COORD @D27764, AGR [COUNT @D27763, PER @D27762, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : COME, 
   [COORD @D27766, AGR [COUNT @D27765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : COME, 
   [COORD @D27768, AGR [COUNT @D27767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : COME, 
   [COORD @D27772, AGR [COUNT @D27771, PER @D27770, PLU @D27769, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ROUND, ARITY 1] : COME, 
   [COORD @D27778, PAST @D27777, 
      AGR [CASE @D27776, COUNT @D27775, PER @D27774, PLU @D27773, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ROUND, 
      ARITY 1] : COME, 
   [COORD @D27781, AGR [COUNT @D27780, PER @D27779, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : COME, 
   [COORD @D27783, AGR [COUNT @D27782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : COME, 
   [COORD @D27785, AGR [COUNT @D27784, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : COME, 
   [COORD @D27789, AGR [COUNT @D27788, PER @D27787, PLU @D27786, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : COME, 
   [COORD @D27795, PAST @D27794, 
      AGR [CASE @D27793, COUNT @D27792, PER @D27791, PLU @D27790, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : COME, 
   [COORD @D27798, AGR [COUNT @D27797, PER @D27796, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : COME, 
   [COORD @D27800, AGR [COUNT @D27799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : COME, 
   [COORD @D27802, AGR [COUNT @D27801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : COME, 
   [COORD @D27806, AGR [COUNT @D27805, PER @D27804, PLU @D27803, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : COME, 
   [COORD @D27812, PAST @D27811, 
      AGR [CASE @D27810, COUNT @D27809, PER @D27808, PLU @D27807, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : COME, 
   [COORD @D27814, AGR [COUNT @D27813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27816, AGR [COUNT @D27815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27820, AGR [NFORM @D27819, COUNT @D27818, PER @D27817, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27824, AGR [COUNT @D27823, PER @D27822, PLU @D27821, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27827, AGR @D27826, PAST @D27825, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27830, AGR [COUNT @D27829, PER @D27828, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27832, AGR [COUNT @D27831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27834, AGR [COUNT @D27833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27838, AGR [COUNT @D27837, PER @D27836, PLU @D27835, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : COME, 
   [COORD @D27844, PAST @D27843, 
      AGR [CASE @D27842, COUNT @D27841, PER @D27840, PLU @D27839, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : COME, 
   [COORD @D27847, AGR [COUNT @D27846, PER @D27845, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : COME, 
   [COORD @D27849, AGR [COUNT @D27848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : COME, 
   [COORD @D27851, AGR [COUNT @D27850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : COME, 
   [COORD @D27855, AGR [COUNT @D27854, PER @D27853, PLU @D27852, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : COME, 
   [COORD @D27861, PAST @D27860, 
      AGR [CASE @D27859, COUNT @D27858, PER @D27857, PLU @D27856, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : COME, 
   [COORD @D27864, AGR [COUNT @D27863, PER @D27862, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : COME, 
   [COORD @D27866, AGR [COUNT @D27865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : COME, 
   [COORD @D27868, AGR [COUNT @D27867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : COME, 
   [COORD @D27872, AGR [COUNT @D27871, PER @D27870, PLU @D27869, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : COME, 
   [COORD @D27878, PAST @D27877, 
      AGR [CASE @D27876, COUNT @D27875, PER @D27874, PLU @D27873, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : COME, 
   [COORD @D27881, AGR [COUNT @D27880, PER @D27879, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORWARD, ARITY 1] : COME, 
   [COORD @D27883, AGR [COUNT @D27882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORWARD, ARITY 1] : COME, 
   [COORD @D27885, AGR [COUNT @D27884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORWARD, ARITY 1] : COME, 
   [COORD @D27889, AGR [COUNT @D27888, PER @D27887, PLU @D27886, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORWARD, ARITY 1] : COME, 
   [COORD @D27895, PAST @D27894, 
      AGR [CASE @D27893, COUNT @D27892, PER @D27891, PLU @D27890, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FORWARD, 
      ARITY 1] : COME, 
   [COORD @D27898, AGR [COUNT @D27897, PER @D27896, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : COME, 
   [COORD @D27900, AGR [COUNT @D27899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : COME, 
   [COORD @D27902, AGR [COUNT @D27901, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : COME, 
   [COORD @D27906, AGR [COUNT @D27905, PER @D27904, PLU @D27903, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : COME, 
   [COORD @D27912, PAST @D27911, 
      AGR [CASE @D27910, COUNT @D27909, PER @D27908, PLU @D27907, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : COME, 
   [COORD @D27915, AGR [COUNT @D27914, PER @D27913, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : COME, 
   [COORD @D27917, AGR [COUNT @D27916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : COME, 
   [COORD @D27919, AGR [COUNT @D27918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : COME, 
   [COORD @D27923, AGR [COUNT @D27922, PER @D27921, PLU @D27920, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, ARITY 1] : COME, 
   [COORD @D27929, PAST @D27928, 
      AGR [CASE @D27927, COUNT @D27926, PER @D27925, PLU @D27924, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BY, 
      ARITY 1] : COME, 
   [COORD @D27932, AGR [COUNT @D27931, PER @D27930, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : COME, 
   [COORD @D27934, AGR [COUNT @D27933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : COME, 
   [COORD @D27936, AGR [COUNT @D27935, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : COME, 
   [COORD @D27940, AGR [COUNT @D27939, PER @D27938, PLU @D27937, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : COME, 
   [COORD @D27946, PAST @D27945, 
      AGR [CASE @D27944, COUNT @D27943, PER @D27942, PLU @D27941, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : COME, 
   [COORD @D27949, AGR [COUNT @D27948, PER @D27947, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : COME, 
   [COORD @D27951, AGR [COUNT @D27950, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : COME, 
   [COORD @D27953, AGR [COUNT @D27952, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : COME, 
   [COORD @D27957, AGR [COUNT @D27956, PER @D27955, PLU @D27954, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : COME, 
   [COORD @D27963, PAST @D27962, 
      AGR [CASE @D27961, COUNT @D27960, PER @D27959, PLU @D27958, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, 
      ARITY 1] : COME, 
   [COORD @D27966, AGR [COUNT @D27965, PER @D27964, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : COME, 
   [COORD @D27968, AGR [COUNT @D27967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : COME, 
   [COORD @D27970, AGR [COUNT @D27969, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : COME, 
   [COORD @D27974, AGR [COUNT @D27973, PER @D27972, PLU @D27971, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, ARITY 1] : COME, 
   [COORD @D27980, PAST @D27979, 
      AGR [CASE @D27978, COUNT @D27977, PER @D27976, PLU @D27975, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AROUND, 
      ARITY 1] : COME, 
   [COORD @D27983, AGR [COUNT @D27982, PER @D27981, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT APART, ARITY 1] : COME, 
   [COORD @D27985, AGR [COUNT @D27984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT APART, ARITY 1] : COME, 
   [COORD @D27987, AGR [COUNT @D27986, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT APART, ARITY 1] : COME, 
   [COORD @D27991, AGR [COUNT @D27990, PER @D27989, PLU @D27988, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT APART, ARITY 1] : COME, 
   [COORD @D27997, PAST @D27996, 
      AGR [CASE @D27995, COUNT @D27994, PER @D27993, PLU @D27992, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT APART, 
      ARITY 1] : COME, 
   [COORD @D28000, AGR [COUNT @D27999, PER @D27998, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : COME, 
   [COORD @D28002, AGR [COUNT @D28001, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : COME, 
   [COORD @D28004, AGR [COUNT @D28003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : COME, 
   [COORD @D28008, AGR [COUNT @D28007, PER @D28006, PLU @D28005, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALONG, ARITY 1] : COME, 
   [COORD @D28014, PAST @D28013, 
      AGR [CASE @D28012, COUNT @D28011, PER @D28010, PLU @D28009, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ALONG, 
      ARITY 1] : COME, 
   [COORD @D28017, AGR [COUNT @D28016, PER @D28015, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AGAIN, ARITY 1] : COME, 
   [COORD @D28019, AGR [COUNT @D28018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AGAIN, ARITY 1] : COME, 
   [COORD @D28021, AGR [COUNT @D28020, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AGAIN, ARITY 1] : COME, 
   [COORD @D28025, AGR [COUNT @D28024, PER @D28023, PLU @D28022, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AGAIN, ARITY 1] : COME, 
   [COORD @D28031, PAST @D28030, 
      AGR [CASE @D28029, COUNT @D28028, PER @D28027, PLU @D28026, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AGAIN, 
      ARITY 1] : COME, 
   [COORD @D28034, AGR [COUNT @D28033, PER @D28032, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : COME, 
   [COORD @D28036, AGR [COUNT @D28035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : COME, 
   [COORD @D28038, AGR [COUNT @D28037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : COME, 
   [COORD @D28042, AGR [COUNT @D28041, PER @D28040, PLU @D28039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : COME, 
   [COORD @D28048, PAST @D28047, 
      AGR [CASE @D28046, COUNT @D28045, PER @D28044, PLU @D28043, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, 
      ARITY 1] : COME, 
   [COORD @D28051, AGR @D28050, PAST @D28049, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, REG -, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28057, PAST @D28056, AGR [CASE @D28055, COUNT @D28054, 
            PER @D28053, PLU @D28052, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : COME, 
   [COORD @D28063, PAST @D28062, 
      AGR [CASE @D28061, COUNT @D28060, PER @D28059, PLU @D28058, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28069, PAST @D28068, AGR [CASE @D28067, COUNT @D28066, 
            PER @D28065, PLU @D28064, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, FIN -, ARITY 1] : COME, 
   [COORD @D28075, PAST @D28074, 
      AGR [CASE @D28073, COUNT @D28072, PER @D28071, PLU @D28070, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT THROUGH, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28081, PAST @D28080, AGR [CASE @D28079, COUNT @D28078, 
            PER @D28077, PLU @D28076, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ROUND, FIN -, ARITY 1] : COME, 
   [COORD @D28087, PAST @D28086, 
      AGR [CASE @D28085, COUNT @D28084, PER @D28083, PLU @D28082, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28093, PAST @D28092, AGR [CASE @D28091, COUNT @D28090, 
            PER @D28089, PLU @D28088, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : COME, 
   [COORD @D28096, AGR @D28095, PAST @D28094, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, REG -, PRT ON, 
      FIN -, ARITY 1] : COME, 
   [COORD @D28102, PAST @D28101, AGR [CASE @D28100, COUNT @D28099, 
            PER @D28098, PLU @D28097, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : COME, 
   [COORD @D28108, PAST @D28107, 
      AGR [CASE @D28106, COUNT @D28105, PER @D28104, PLU @D28103, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28114, PAST @D28113, AGR [CASE @D28112, COUNT @D28111, 
            PER @D28110, PLU @D28109, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : COME, 
   [COORD @D28120, PAST @D28119, 
      AGR [CASE @D28118, COUNT @D28117, PER @D28116, PLU @D28115, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FORWARD, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28126, PAST @D28125, AGR [CASE @D28124, COUNT @D28123, 
            PER @D28122, PLU @D28121, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : COME, 
   [COORD @D28132, PAST @D28131, 
      AGR [CASE @D28130, COUNT @D28129, PER @D28128, PLU @D28127, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BY, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28138, PAST @D28137, AGR [CASE @D28136, COUNT @D28135, 
            PER @D28134, PLU @D28133, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, FIN -, ARITY 1] : COME, 
   [COORD @D28144, PAST @D28143, 
      AGR [CASE @D28142, COUNT @D28141, PER @D28140, PLU @D28139, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28150, PAST @D28149, AGR [CASE @D28148, COUNT @D28147, 
            PER @D28146, PLU @D28145, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, FIN -, ARITY 1] : COME, 
   [COORD @D28156, PAST @D28155, 
      AGR [CASE @D28154, COUNT @D28153, PER @D28152, PLU @D28151, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT APART, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28162, PAST @D28161, AGR [CASE @D28160, COUNT @D28159, 
            PER @D28158, PLU @D28157, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALONG, FIN -, ARITY 1] : COME, 
   [COORD @D28168, PAST @D28167, 
      AGR [CASE @D28166, COUNT @D28165, PER @D28164, PLU @D28163, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AGAIN, FIN -, 
      ARITY 1] : COME, 
   [COORD @D28174, PAST @D28173, AGR [CASE @D28172, COUNT @D28171, 
            PER @D28170, PLU @D28169, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, FIN -, ARITY 1] : COME, 
   [COORD @D28179, PAST @D28178, 
      AGR [COUNT @D28177, PER @D28176, PLU @D28175, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM TO] : 
   COME, 
   [COORD @D28184, PAST @D28183, AGR [COUNT @D28182, PER @D28181, 
            PLU @D28180, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM TO, FIN -] : COME, 
   [COORD @D28189, PAST @D28188, AGR [COUNT @D28187, PER @D28186, 
            PLU @D28185, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PRT ABOUT, ARITY 1] : COME, 
   [COORD @D28194, PAST @D28193, 
      AGR [COUNT @D28192, PER @D28191, PLU @D28190, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT ABOUT, FIN -, ARITY 1] : 
   COME.

WORD comes : 
   [COORD @D28206, AGR [COUNT @D28205, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PRT DOWN, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28208, AGR [COUNT @D28207, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT PP_PP, CONJ NULL, 
      SUBTYPE PVERB, PRT DOWN, PFORM ON_FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28210, AGR [COUNT @D28209, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28212, 
      AGR [COUNT @D28211, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28214, 
      AGR [COUNT @D28213, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28216, 
      AGR [COUNT @D28215, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28218, 
      AGR [COUNT @D28217, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28220, 
      AGR [COUNT @D28219, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28222, 
      AGR [COUNT @D28221, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28224, 
      AGR [COUNT @D28223, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28226, 
      AGR [COUNT @D28225, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28228, 
      AGR [COUNT @D28227, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28230, 
      AGR [COUNT @D28229, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28232, 
      AGR [COUNT @D28231, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28234, 
      AGR [COUNT @D28233, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, PRT ACROSS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28236, 
      AGR [COUNT @D28235, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT ACROSS, PREP AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28238, AGR [COUNT @D28237, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, PRT ACROSS, PREP AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28240, AGR [COUNT @D28239, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28242, AGR [COUNT @D28241, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT THROUGH, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28244, AGR [COUNT @D28243, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28246, AGR [COUNT @D28245, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28248, AGR [COUNT @D28247, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BACK, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28250, AGR [COUNT @D28249, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT ACROSS, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28252, AGR [COUNT @D28251, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UP_TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28254, 
      AGR [COUNT @D28253, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28256, 
      AGR [COUNT @D28255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28258, 
      AGR [COUNT @D28257, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28260, 
      AGR [COUNT @D28259, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28262, AGR [COUNT @D28261, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ROUND, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28264, AGR [COUNT @D28263, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28266, AGR [COUNT @D28265, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28268, AGR [COUNT @D28267, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BACK, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28270, AGR [COUNT @D28269, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28272, AGR [COUNT @D28271, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28274, AGR [COUNT @D28273, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28276, AGR [COUNT @D28275, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28278, AGR [COUNT @D28277, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28280, AGR [COUNT @D28279, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28282, AGR [COUNT @D28281, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28284, AGR [COUNT @D28283, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28286, AGR [COUNT @D28285, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28288, AGR [COUNT @D28287, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28290, AGR [COUNT @D28289, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28292, AGR [COUNT @D28291, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28294, AGR [COUNT @D28293, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28296, AGR [COUNT @D28295, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28298, AGR [COUNT @D28297, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28300, AGR [COUNT @D28299, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28302, AGR [COUNT @D28301, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28304, AGR [COUNT @D28303, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM DOWN_TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28306, AGR [COUNT @D28305, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28308, AGR [COUNT @D28307, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BEFORE, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28310, AGR [COUNT @D28309, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28312, AGR [COUNT @D28311, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28314, AGR [COUNT @D28313, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BACK, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28316, AGR [COUNT @D28315, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ACROSS, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28318, AGR [COUNT @D28317, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28320, AGR [COUNT @D28319, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28322, AGR [COUNT @D28321, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28326, AGR [CASE @D28325, NFORM @D28324, COUNT @D28323, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28331, AGR [UB @D28330, VFORM @D28329, SUBJ @D28328, 
            FIN @D28327, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28333, AGR [COUNT @D28332, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28335, 
      AGR [COUNT @D28334, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28337, 
      AGR [COUNT @D28336, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28339, 
      AGR [COUNT @D28338, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28341, AGR [COUNT @D28340, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28343, 
      AGR [COUNT @D28342, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28345, 
      AGR [COUNT @D28344, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28349, 
      AGR [CASE @D28348, NFORM @D28347, COUNT @D28346, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28354, 
      AGR [UB @D28353, VFORM @D28352, SUBJ @D28351, FIN @D28350, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28356, 
      AGR [COUNT @D28355, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28358, 
      AGR [COUNT @D28357, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28360, 
      AGR [COUNT @D28359, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28362, 
      AGR [COUNT @D28361, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT FORWARD, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28364, AGR [COUNT @D28363, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28366, 
      AGR [COUNT @D28365, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28368, 
      AGR [COUNT @D28367, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28370, 
      AGR [COUNT @D28369, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28372, 
      AGR [COUNT @D28371, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28374, 
      AGR [COUNT @D28373, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT APART, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28376, 
      AGR [COUNT @D28375, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28378, 
      AGR [COUNT @D28377, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AGAIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28380, 
      AGR [COUNT @D28379, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28383, 
      AGR [CASE @D28382, COUNT @D28381, N +, V -, BAR 2, NFORM IT, PLU -, 
            PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME, 
   [COORD @D28386, 
      AGR [CASE @D28385, COUNT @D28384, N +, V -, BAR 2, NFORM IT, PLU -, 
            PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COME.

WORD comfort : 
   [COORD @D28395, REFL @D28394, COUNT @D28393, PRD @D28392, 
      CASE @D28391, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COMFORT, 
   [COORD @D28398, 
      AGR [COUNT @D28397, PER @D28396, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   COMFORT, 
   [COORD @D28400, AGR [COUNT @D28399, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMFORT, 
   [COORD @D28402, AGR [COUNT @D28401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMFORT, 
   [COORD @D28406, AGR [COUNT @D28405, PER @D28404, PLU @D28403, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMFORT, 
   [COORD @D28412, PAST @D28411, AGR [CASE @D28410, COUNT @D28409, 
            PER @D28408, PLU @D28407, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMFORT.

WORD comforted : 
   [COORD @D28423, AGR [CASE @D28422, COUNT @D28421, PER @D28420, 
            PLU @D28419, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COMFORT, 
   [COORD @D28428, AGR [CASE @D28427, COUNT @D28426, PER @D28425, 
            PLU @D28424, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMFORT, 
   [COORD @D28433, AGR [CASE @D28432, COUNT @D28431, PER @D28430, 
            PLU @D28429, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMFORT.

WORD comforting : 
   [COORD @D28449, PRD @D28448, AGR [CASE @D28447, COUNT @D28446, 
            PER @D28445, PLU @D28444, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMFORT.

WORD comforts : 
   [COORD @D28460, DEMON @D28459, REFL @D28458, PRD @D28457, 
      CASE @D28456, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : COMFORT, 
   
   [COORD @D28462, AGR [COUNT @D28461, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMFORT.

WORD coming : 
   [COADV @D28474, COORD @D28473, DEF @D28472, PRD @D28471, AGR 
            [CASE @D28470, COUNT @D28469, PER @D28468, PLU @D28467, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : COMING, 
   [COORD @D28478, REFL @D28477, PRD @D28476, CASE @D28475, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : COMING, 
   [COORD @D28484, PRD @D28483, 
      AGR [CASE @D28482, COUNT @D28481, PER @D28480, PLU @D28479, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PRT DOWN, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28490, PRD @D28489, AGR [CASE @D28488, COUNT @D28487, 
            PER @D28486, PLU @D28485, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT PP_PP, CONJ NULL, SUBTYPE PVERB, 
      PRT DOWN, PFORM ON_FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28496, PRD @D28495, AGR [CASE @D28494, COUNT @D28493, 
            PER @D28492, PLU @D28491, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28502, PRD @D28501, 
      AGR [CASE @D28500, COUNT @D28499, PER @D28498, PLU @D28497, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28508, PRD @D28507, AGR [CASE @D28506, COUNT @D28505, 
            PER @D28504, PLU @D28503, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28514, PRD @D28513, 
      AGR [CASE @D28512, COUNT @D28511, PER @D28510, PLU @D28509, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28520, PRD @D28519, AGR [CASE @D28518, COUNT @D28517, 
            PER @D28516, PLU @D28515, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28526, PRD @D28525, 
      AGR [CASE @D28524, COUNT @D28523, PER @D28522, PLU @D28521, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28532, PRD @D28531, AGR [CASE @D28530, COUNT @D28529, 
            PER @D28528, PLU @D28527, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28538, PRD @D28537, 
      AGR [CASE @D28536, COUNT @D28535, PER @D28534, PLU @D28533, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28544, PRD @D28543, AGR [CASE @D28542, COUNT @D28541, 
            PER @D28540, PLU @D28539, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28550, PRD @D28549, 
      AGR [CASE @D28548, COUNT @D28547, PER @D28546, PLU @D28545, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28556, PRD @D28555, AGR [CASE @D28554, COUNT @D28553, 
            PER @D28552, PLU @D28551, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28562, PRD @D28561, 
      AGR [CASE @D28560, COUNT @D28559, PER @D28558, PLU @D28557, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28568, PRD @D28567, AGR [CASE @D28566, COUNT @D28565, 
            PER @D28564, PLU @D28563, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, PRT ACROSS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28574, PRD @D28573, 
      AGR [CASE @D28572, COUNT @D28571, PER @D28570, PLU @D28569, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PRT ACROSS, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28580, PRD @D28579, AGR [CASE @D28578, COUNT @D28577, 
            PER @D28576, PLU @D28575, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, 
      PRT ACROSS, PREP AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28586, PRD @D28585, AGR [CASE @D28584, COUNT @D28583, 
            PER @D28582, PLU @D28581, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28592, PRD @D28591, 
      AGR [CASE @D28590, COUNT @D28589, PER @D28588, PLU @D28587, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT THROUGH, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28598, PRD @D28597, AGR [CASE @D28596, COUNT @D28595, 
            PER @D28594, PLU @D28593, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28604, PRD @D28603, 
      AGR [CASE @D28602, COUNT @D28601, PER @D28600, PLU @D28599, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28610, PRD @D28609, AGR [CASE @D28608, COUNT @D28607, 
            PER @D28606, PLU @D28605, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28616, PRD @D28615, 
      AGR [CASE @D28614, COUNT @D28613, PER @D28612, PLU @D28611, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT ACROSS, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28622, PRD @D28621, AGR [CASE @D28620, COUNT @D28619, 
            PER @D28618, PLU @D28617, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UP_TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28628, PRD @D28627, 
      AGR [CASE @D28626, COUNT @D28625, PER @D28624, PLU @D28623, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28634, PRD @D28633, AGR [CASE @D28632, COUNT @D28631, 
            PER @D28630, PLU @D28629, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UNDER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28640, PRD @D28639, 
      AGR [CASE @D28638, COUNT @D28637, PER @D28636, PLU @D28635, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28646, PRD @D28645, AGR [CASE @D28644, COUNT @D28643, 
            PER @D28642, PLU @D28641, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28652, PRD @D28651, 
      AGR [CASE @D28650, COUNT @D28649, PER @D28648, PLU @D28647, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ROUND, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28658, PRD @D28657, AGR [CASE @D28656, COUNT @D28655, 
            PER @D28654, PLU @D28653, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28664, PRD @D28663, 
      AGR [CASE @D28662, COUNT @D28661, PER @D28660, PLU @D28659, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28670, PRD @D28669, AGR [CASE @D28668, COUNT @D28667, 
            PER @D28666, PLU @D28665, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28676, PRD @D28675, 
      AGR [CASE @D28674, COUNT @D28673, PER @D28672, PLU @D28671, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28682, PRD @D28681, AGR [CASE @D28680, COUNT @D28679, 
            PER @D28678, PLU @D28677, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28688, PRD @D28687, 
      AGR [CASE @D28686, COUNT @D28685, PER @D28684, PLU @D28683, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28694, PRD @D28693, AGR [CASE @D28692, COUNT @D28691, 
            PER @D28690, PLU @D28689, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28700, PRD @D28699, 
      AGR [CASE @D28698, COUNT @D28697, PER @D28696, PLU @D28695, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28706, PRD @D28705, AGR [CASE @D28704, COUNT @D28703, 
            PER @D28702, PLU @D28701, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28712, PRD @D28711, 
      AGR [CASE @D28710, COUNT @D28709, PER @D28708, PLU @D28707, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28718, PRD @D28717, AGR [CASE @D28716, COUNT @D28715, 
            PER @D28714, PLU @D28713, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28724, PRD @D28723, 
      AGR [CASE @D28722, COUNT @D28721, PER @D28720, PLU @D28719, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28730, PRD @D28729, AGR [CASE @D28728, COUNT @D28727, 
            PER @D28726, PLU @D28725, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28736, PRD @D28735, 
      AGR [CASE @D28734, COUNT @D28733, PER @D28732, PLU @D28731, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28742, PRD @D28741, AGR [CASE @D28740, COUNT @D28739, 
            PER @D28738, PLU @D28737, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28748, PRD @D28747, 
      AGR [CASE @D28746, COUNT @D28745, PER @D28744, PLU @D28743, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28754, PRD @D28753, AGR [CASE @D28752, COUNT @D28751, 
            PER @D28750, PLU @D28749, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28760, PRD @D28759, 
      AGR [CASE @D28758, COUNT @D28757, PER @D28756, PLU @D28755, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28766, PRD @D28765, AGR [CASE @D28764, COUNT @D28763, 
            PER @D28762, PLU @D28761, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28772, PRD @D28771, 
      AGR [CASE @D28770, COUNT @D28769, PER @D28768, PLU @D28767, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28778, PRD @D28777, AGR [CASE @D28776, COUNT @D28775, 
            PER @D28774, PLU @D28773, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM DOWN_TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28784, PRD @D28783, 
      AGR [CASE @D28782, COUNT @D28781, PER @D28780, PLU @D28779, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28790, PRD @D28789, AGR [CASE @D28788, COUNT @D28787, 
            PER @D28786, PLU @D28785, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BEFORE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28796, PRD @D28795, 
      AGR [CASE @D28794, COUNT @D28793, PER @D28792, PLU @D28791, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28802, PRD @D28801, AGR [CASE @D28800, COUNT @D28799, 
            PER @D28798, PLU @D28797, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28808, PRD @D28807, 
      AGR [CASE @D28806, COUNT @D28805, PER @D28804, PLU @D28803, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT BACK, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28814, PRD @D28813, AGR [CASE @D28812, COUNT @D28811, 
            PER @D28810, PLU @D28809, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ACROSS, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28820, PRD @D28819, 
      AGR [CASE @D28818, COUNT @D28817, PER @D28816, PLU @D28815, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28826, PRD @D28825, AGR [CASE @D28824, COUNT @D28823, 
            PER @D28822, PLU @D28821, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28832, PRD @D28831, 
      AGR [CASE @D28830, COUNT @D28829, PER @D28828, PLU @D28827, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28835, AGR @D28834, PRD @D28833, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28841, PRD @D28840, AGR [CASE @D28839, COUNT @D28838, 
            PER @D28837, PLU @D28836, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28847, PRD @D28846, 
      AGR [CASE @D28845, COUNT @D28844, PER @D28843, PLU @D28842, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28853, PRD @D28852, AGR [CASE @D28851, COUNT @D28850, 
            PER @D28849, PLU @D28848, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28859, PRD @D28858, 
      AGR [CASE @D28857, COUNT @D28856, PER @D28855, PLU @D28854, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28865, PRD @D28864, AGR [CASE @D28863, COUNT @D28862, 
            PER @D28861, PLU @D28860, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28871, PRD @D28870, 
      AGR [CASE @D28869, COUNT @D28868, PER @D28867, PLU @D28866, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28877, PRD @D28876, AGR [CASE @D28875, COUNT @D28874, 
            PER @D28873, PLU @D28872, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28880, AGR @D28879, PRD @D28878, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COME, 
   [COORD @D28886, PRD @D28885, AGR [CASE @D28884, COUNT @D28883, 
            PER @D28882, PLU @D28881, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28892, PRD @D28891, 
      AGR [CASE @D28890, COUNT @D28889, PER @D28888, PLU @D28887, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28898, PRD @D28897, AGR [CASE @D28896, COUNT @D28895, 
            PER @D28894, PLU @D28893, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28904, PRD @D28903, 
      AGR [CASE @D28902, COUNT @D28901, PER @D28900, PLU @D28899, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT FORWARD, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COME, 
   [COORD @D28910, PRD @D28909, AGR [CASE @D28908, COUNT @D28907, 
            PER @D28906, PLU @D28905, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28916, PRD @D28915, 
      AGR [CASE @D28914, COUNT @D28913, PER @D28912, PLU @D28911, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28922, PRD @D28921, AGR [CASE @D28920, COUNT @D28919, 
            PER @D28918, PLU @D28917, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28928, PRD @D28927, 
      AGR [CASE @D28926, COUNT @D28925, PER @D28924, PLU @D28923, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28934, PRD @D28933, AGR [CASE @D28932, COUNT @D28931, 
            PER @D28930, PLU @D28929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28940, PRD @D28939, 
      AGR [CASE @D28938, COUNT @D28937, PER @D28936, PLU @D28935, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT APART, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28946, PRD @D28945, AGR [CASE @D28944, COUNT @D28943, 
            PER @D28942, PLU @D28941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28952, PRD @D28951, 
      AGR [CASE @D28950, COUNT @D28949, PER @D28948, PLU @D28947, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AGAIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COME, 
   [COORD @D28958, PRD @D28957, AGR [CASE @D28956, COUNT @D28955, 
            PER @D28954, PLU @D28953, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COME, 
   [COORD @D28963, PRD @D28962, 
      AGR [COUNT @D28961, PER @D28960, PLU @D28959, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COME, 
   [COORD @D28968, PRD @D28967, AGR [COUNT @D28966, PER @D28965, 
            PLU @D28964, NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COME.

WORD comment : 
   [COORD @D28984, REFL @D28983, COUNT @D28982, PRD @D28981, 
      CASE @D28980, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COMMENT, 
   [COORD @D28987, 
      AGR [COUNT @D28986, PER @D28985, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   COMMENT, 
   [COORD @D28989, AGR [COUNT @D28988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : COMMENT, 
   [COORD @D28991, AGR [COUNT @D28990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : COMMENT, 
   [COORD @D28995, AGR [COUNT @D28994, PER @D28993, PLU @D28992, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : COMMENT, 
   [COORD @D29001, PAST @D29000, AGR [CASE @D28999, COUNT @D28998, 
            PER @D28997, PLU @D28996, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : COMMENT, 
   [COORD @D29004, AGR [COUNT @D29003, PER @D29002, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : COMMENT, 
   [COORD @D29006, AGR [COUNT @D29005, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : COMMENT, 
   [COORD @D29008, AGR [COUNT @D29007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : COMMENT, 
   [COORD @D29012, AGR [COUNT @D29011, PER @D29010, PLU @D29009, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM UPON, ARITY 2] : COMMENT, 
   [COORD @D29018, PAST @D29017, 
      AGR [CASE @D29016, COUNT @D29015, PER @D29014, PLU @D29013, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UPON, 
      ARITY 2] : COMMENT, 
   [COORD @D29021, AGR [COUNT @D29020, PER @D29019, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : COMMENT, 
   [COORD @D29023, AGR [COUNT @D29022, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : COMMENT, 
   [COORD @D29025, AGR [COUNT @D29024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : COMMENT, 
   [COORD @D29029, AGR [COUNT @D29028, PER @D29027, PLU @D29026, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : COMMENT, 
   [COORD @D29035, PAST @D29034, 
      AGR [CASE @D29033, COUNT @D29032, PER @D29031, PLU @D29030, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      ARITY 2] : COMMENT, 
   [COORD @D29038, AGR [COUNT @D29037, PER @D29036, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMMENT, 
   [COORD @D29040, AGR [COUNT @D29039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMMENT, 
   [COORD @D29042, AGR [COUNT @D29041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMMENT, 
   [COORD @D29046, AGR [COUNT @D29045, PER @D29044, PLU @D29043, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMMENT, 
   [COORD @D29052, PAST @D29051, AGR [CASE @D29050, COUNT @D29049, 
            PER @D29048, PLU @D29047, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COMMENT.

WORD commented : 
   [COORD @D29063, AGR [UB @D29062, VFORM @D29061, SUBJ @D29060, 
            FIN @D29059, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COMMENT, 
   [COORD @D29068, AGR [CASE @D29067, COUNT @D29066, PER @D29065, 
            PLU @D29064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29073, AGR [CASE @D29072, COUNT @D29071, PER @D29070, 
            PLU @D29069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29078, AGR [CASE @D29077, COUNT @D29076, PER @D29075, 
            PLU @D29074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29083, AGR [CASE @D29082, COUNT @D29081, PER @D29080, 
            PLU @D29079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29088, AGR [CASE @D29087, COUNT @D29086, PER @D29085, 
            PLU @D29084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29093, AGR [CASE @D29092, COUNT @D29091, PER @D29090, 
            PLU @D29089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29098, AGR [CASE @D29097, COUNT @D29096, PER @D29095, 
            PLU @D29094, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29103, AGR [CASE @D29102, COUNT @D29101, PER @D29100, 
            PLU @D29099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMMENT.

WORD commenting : 
   [COORD @D29119, PRD @D29118, AGR [CASE @D29117, COUNT @D29116, 
            PER @D29115, PLU @D29114, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29125, PRD @D29124, 
      AGR [CASE @D29123, COUNT @D29122, PER @D29121, PLU @D29120, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COMMENT, 
   [COORD @D29131, PRD @D29130, AGR [CASE @D29129, COUNT @D29128, 
            PER @D29127, PLU @D29126, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29137, PRD @D29136, 
      AGR [CASE @D29135, COUNT @D29134, PER @D29133, PLU @D29132, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COMMENT.

WORD comments : 
   [COORD @D29148, DEMON @D29147, REFL @D29146, PRD @D29145, 
      CASE @D29144, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : COMMENT, 
   
   [COORD @D29150, AGR [COUNT @D29149, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29152, 
      AGR [COUNT @D29151, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29154, 
      AGR [COUNT @D29153, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMMENT, 
   [COORD @D29156, 
      AGR [COUNT @D29155, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMMENT.

WORD commit : 
   [COORD @D29163, AGR [COUNT @D29162, PER @D29161, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMMIT, 
   [COORD @D29165, AGR [COUNT @D29164, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMMIT, 
   [COORD @D29167, AGR [COUNT @D29166, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMMIT, 
   [COORD @D29171, AGR [COUNT @D29170, PER @D29169, PLU @D29168, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMMIT, 
   [COORD @D29177, PAST @D29176, 
      AGR [CASE @D29175, COUNT @D29174, PER @D29173, PLU @D29172, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : COMMIT, 
   [COORD @D29180, AGR [COUNT @D29179, PER @D29178, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMMIT, 
   [COORD @D29182, AGR [COUNT @D29181, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMMIT, 
   [COORD @D29184, AGR [COUNT @D29183, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMMIT, 
   [COORD @D29188, AGR [COUNT @D29187, PER @D29186, PLU @D29185, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMMIT, 
   [COORD @D29194, PAST @D29193, AGR [CASE @D29192, COUNT @D29191, 
            PER @D29190, PLU @D29189, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMMIT.

WORD commits : 
   [COORD @D29201, AGR [COUNT @D29200, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COMMIT, 
   [COORD @D29203, AGR [COUNT @D29202, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMMIT.

WORD committed : 
   [COADV @D29216, COORD @D29215, DEF @D29214, PRD @D29213, 
      AGR [CASE @D29212, COUNT @D29211, PER @D29210, PLU @D29209, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COMMITTED, 
   [COADV @D29224, COORD @D29223, DEF @D29222, PRD @D29221, 
      AGR [CASE @D29220, COUNT @D29219, PER @D29218, PLU @D29217, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR PRD] : 
   COMMITTED, 
   [COADV @D29232, COORD @D29231, DEF @D29230, PRD @D29229, 
      AGR [CASE @D29228, COUNT @D29227, PER @D29226, PLU @D29225, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, DISTR PRD, 
      ARITY 2] : COMMITTED, 
   [COORD @D29237, AGR [CASE @D29236, COUNT @D29235, PER @D29234, 
            PLU @D29233, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMMIT, 
   [COORD @D29242, AGR [CASE @D29241, COUNT @D29240, PER @D29239, 
            PLU @D29238, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMMIT, 
   [COORD @D29247, AGR [CASE @D29246, COUNT @D29245, PER @D29244, 
            PLU @D29243, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COMMIT, 
   [COORD @D29252, AGR [CASE @D29251, COUNT @D29250, PER @D29249, 
            PLU @D29248, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COMMIT, 
   [COORD @D29257, AGR [CASE @D29256, COUNT @D29255, PER @D29254, 
            PLU @D29253, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMMIT, 
   [COORD @D29262, AGR [CASE @D29261, COUNT @D29260, PER @D29259, 
            PLU @D29258, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMMIT.

WORD committing : 
   [COORD @D29275, PRD @D29274, AGR [CASE @D29273, COUNT @D29272, 
            PER @D29271, PLU @D29270, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COMMIT, 
   [COORD @D29281, PRD @D29280, 
      AGR [CASE @D29279, COUNT @D29278, PER @D29277, PLU @D29276, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COMMIT.

WORD compare : 
   [COORD @D29289, AGR [COUNT @D29288, PER @D29287, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMPARE, 
   [COORD @D29291, AGR [COUNT @D29290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMPARE, 
   [COORD @D29293, AGR [COUNT @D29292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMPARE, 
   [COORD @D29297, AGR [COUNT @D29296, PER @D29295, PLU @D29294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COMPARE, 
   [COORD @D29303, PAST @D29302, 
      AGR [CASE @D29301, COUNT @D29300, PER @D29299, PLU @D29298, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : COMPARE, 
   [COORD @D29306, AGR [COUNT @D29305, PER @D29304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMPARE, 
   [COORD @D29308, AGR [COUNT @D29307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMPARE, 
   [COORD @D29310, AGR [COUNT @D29309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMPARE, 
   [COORD @D29314, AGR [COUNT @D29313, PER @D29312, PLU @D29311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : COMPARE, 
   [COORD @D29320, PAST @D29319, 
      AGR [CASE @D29318, COUNT @D29317, PER @D29316, PLU @D29315, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : COMPARE, 
   [COORD @D29323, AGR [COUNT @D29322, PER @D29321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPARE, 
   [COORD @D29325, AGR [COUNT @D29324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPARE, 
   [COORD @D29327, AGR [COUNT @D29326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPARE, 
   [COORD @D29331, AGR [COUNT @D29330, PER @D29329, PLU @D29328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMPARE, 
   [COORD @D29337, PAST @D29336, AGR [CASE @D29335, COUNT @D29334, 
            PER @D29333, PLU @D29332, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMPARE, 
   [COORD @D29340, AGR [COUNT @D29339, PER @D29338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COMPARE, 
   [COORD @D29342, AGR [COUNT @D29341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COMPARE, 
   [COORD @D29344, AGR [COUNT @D29343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COMPARE, 
   [COORD @D29348, AGR [COUNT @D29347, PER @D29346, PLU @D29345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : COMPARE, 
   [COORD @D29354, PAST @D29353, 
      AGR [CASE @D29352, COUNT @D29351, PER @D29350, PLU @D29349, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      ARITY 2] : COMPARE.

WORD compared : 
   [COORD @D29365, AGR [CASE @D29364, COUNT @D29363, PER @D29362, 
            PLU @D29361, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29370, AGR [CASE @D29369, COUNT @D29368, PER @D29367, 
            PLU @D29366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29375, AGR [CASE @D29374, COUNT @D29373, PER @D29372, 
            PLU @D29371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29380, AGR [CASE @D29379, COUNT @D29378, PER @D29377, 
            PLU @D29376, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29385, AGR [CASE @D29384, COUNT @D29383, PER @D29382, 
            PLU @D29381, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29390, AGR [CASE @D29389, COUNT @D29388, PER @D29387, 
            PLU @D29386, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29395, AGR [CASE @D29394, COUNT @D29393, PER @D29392, 
            PLU @D29391, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COMPARE, 
   [COORD @D29400, AGR [CASE @D29399, COUNT @D29398, PER @D29397, 
            PLU @D29396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29405, AGR [CASE @D29404, COUNT @D29403, PER @D29402, 
            PLU @D29401, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29410, AGR [CASE @D29409, COUNT @D29408, PER @D29407, 
            PLU @D29406, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29415, AGR [CASE @D29414, COUNT @D29413, PER @D29412, 
            PLU @D29411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29420, AGR [CASE @D29419, COUNT @D29418, PER @D29417, 
            PLU @D29416, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COMPARE.

WORD compares : 
   [COORD @D29428, AGR [COUNT @D29427, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COMPARE, 
   [COORD @D29430, AGR [COUNT @D29429, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29432, 
      AGR [COUNT @D29431, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29434, 
      AGR [COUNT @D29433, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPARE.

WORD comparing : 
   [COORD @D29445, PRD @D29444, AGR [CASE @D29443, COUNT @D29442, 
            PER @D29441, PLU @D29440, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29451, PRD @D29450, 
      AGR [CASE @D29449, COUNT @D29448, PER @D29447, PLU @D29446, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COMPARE, 
   [COORD @D29457, PRD @D29456, AGR [CASE @D29455, COUNT @D29454, 
            PER @D29453, PLU @D29452, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPARE, 
   [COORD @D29463, PRD @D29462, 
      AGR [CASE @D29461, COUNT @D29460, PER @D29459, PLU @D29458, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COMPARE.

WORD complaint : 
   [COORD @D29472, REFL @D29471, COUNT @D29470, PRD @D29469, 
      CASE @D29468, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COMPLAINT.

WORD complaints : 
   [COORD @D29482, DEMON @D29481, REFL @D29480, PRD @D29479, 
      CASE @D29478, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   COMPLAINT.

WORD complete : 
   [COORD @D29490, AGR [COUNT @D29489, PER @D29488, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPLETE, 
   [COORD @D29492, AGR [COUNT @D29491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPLETE, 
   [COORD @D29494, AGR [COUNT @D29493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPLETE, 
   [COORD @D29498, AGR [COUNT @D29497, PER @D29496, PLU @D29495, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMPLETE, 
   [COORD @D29504, PAST @D29503, AGR [CASE @D29502, COUNT @D29501, 
            PER @D29500, PLU @D29499, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMPLETE.

WORD completed : 
   [COORD @D29515, AGR [CASE @D29514, COUNT @D29513, PER @D29512, 
            PLU @D29511, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COMPLETE, 
   [COORD @D29520, AGR [CASE @D29519, COUNT @D29518, PER @D29517, 
            PLU @D29516, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPLETE, 
   [COORD @D29525, AGR [CASE @D29524, COUNT @D29523, PER @D29522, 
            PLU @D29521, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMPLETE.

WORD completes : 
   [COORD @D29533, AGR [COUNT @D29532, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPLETE.

WORD completing : 
   [COORD @D29544, PRD @D29543, AGR [CASE @D29542, COUNT @D29541, 
            PER @D29540, PLU @D29539, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPLETE.

WORD complicate : 
   [COORD @D29552, AGR [COUNT @D29551, PER @D29550, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPLICATE, 
   [COORD @D29554, AGR [COUNT @D29553, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPLICATE, 
   [COORD @D29556, AGR [COUNT @D29555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPLICATE, 
   [COORD @D29560, AGR [COUNT @D29559, PER @D29558, PLU @D29557, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMPLICATE, 
   [COORD @D29566, PAST @D29565, AGR [CASE @D29564, COUNT @D29563, 
            PER @D29562, PLU @D29561, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMPLICATE.

WORD complicated : 
   [COADV @D29580, COORD @D29579, DEF @D29578, PRD @D29577, 
      AGR [CASE @D29576, COUNT @D29575, PER @D29574, PLU @D29573, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COMPLICATED, 
   [COORD @D29585, 
      AGR [CASE @D29584, COUNT @D29583, PER @D29582, PLU @D29581, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COMPLICATE, 
   [COORD @D29590, AGR [CASE @D29589, COUNT @D29588, PER @D29587, 
            PLU @D29586, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPLICATE, 
   [COORD @D29595, AGR [CASE @D29594, COUNT @D29593, PER @D29592, 
            PLU @D29591, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMPLICATE.

WORD complicates : 
   [COORD @D29603, AGR [COUNT @D29602, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPLICATE.

WORD complicating : 
   [COORD @D29614, PRD @D29613, AGR [CASE @D29612, COUNT @D29611, 
            PER @D29610, PLU @D29609, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPLICATE.

WORD compose : 
   [COORD @D29622, AGR [COUNT @D29621, PER @D29620, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPOSE, 
   [COORD @D29624, AGR [COUNT @D29623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPOSE, 
   [COORD @D29626, AGR [COUNT @D29625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPOSE, 
   [COORD @D29630, AGR [COUNT @D29629, PER @D29628, PLU @D29627, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMPOSE, 
   [COORD @D29636, PAST @D29635, AGR [CASE @D29634, COUNT @D29633, 
            PER @D29632, PLU @D29631, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMPOSE, 
   [COORD @D29639, AGR [COUNT @D29638, PER @D29637, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMPOSE, 
   [COORD @D29641, AGR [COUNT @D29640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMPOSE, 
   [COORD @D29643, AGR [COUNT @D29642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMPOSE, 
   [COORD @D29647, AGR [COUNT @D29646, PER @D29645, PLU @D29644, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COMPOSE, 
   [COORD @D29653, PAST @D29652, AGR [CASE @D29651, COUNT @D29650, 
            PER @D29649, PLU @D29648, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COMPOSE.

WORD composed : 
   [COORD @D29664, AGR [CASE @D29663, COUNT @D29662, PER @D29661, 
            PLU @D29660, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COMPOSE, 
   [COORD @D29669, AGR [CASE @D29668, COUNT @D29667, PER @D29666, 
            PLU @D29665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPOSE, 
   [COORD @D29674, AGR [CASE @D29673, COUNT @D29672, PER @D29671, 
            PLU @D29670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMPOSE, 
   [COORD @D29679, AGR [CASE @D29678, COUNT @D29677, PER @D29676, 
            PLU @D29675, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPOSE, 
   [COORD @D29684, AGR [CASE @D29683, COUNT @D29682, PER @D29681, 
            PLU @D29680, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMPOSE.

WORD composes : 
   [COORD @D29692, AGR [COUNT @D29691, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPOSE, 
   [COORD @D29694, 
      AGR [COUNT @D29693, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPOSE.

WORD composing : 
   [COORD @D29705, PRD @D29704, AGR [CASE @D29703, COUNT @D29702, 
            PER @D29701, PLU @D29700, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPOSE, 
   [COORD @D29711, PRD @D29710, 
      AGR [CASE @D29709, COUNT @D29708, PER @D29707, PLU @D29706, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COMPOSE.

WORD compost : 
   [COORD @D29720, REFL @D29719, PRD @D29718, CASE @D29717, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : COMPOST, 
   [COORD @D29723, AGR [COUNT @D29722, PER @D29721, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPOST, 
   [COORD @D29725, AGR [COUNT @D29724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPOST, 
   [COORD @D29727, AGR [COUNT @D29726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COMPOST, 
   [COORD @D29731, AGR [COUNT @D29730, PER @D29729, PLU @D29728, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COMPOST, 
   [COORD @D29737, PAST @D29736, AGR [CASE @D29735, COUNT @D29734, 
            PER @D29733, PLU @D29732, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COMPOST.

WORD composted : 
   [COORD @D29749, AGR [CASE @D29748, COUNT @D29747, PER @D29746, 
            PLU @D29745, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COMPOST, 
   [COORD @D29754, AGR [CASE @D29753, COUNT @D29752, PER @D29751, 
            PLU @D29750, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COMPOST, 
   [COORD @D29759, AGR [CASE @D29758, COUNT @D29757, PER @D29756, 
            PLU @D29755, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COMPOST.

WORD composting : 
   [COORD @D29774, PRD @D29773, AGR [CASE @D29772, COUNT @D29771, 
            PER @D29770, PLU @D29769, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COMPOST.

WORD composts : 
   [COORD @D29783, AGR [COUNT @D29782, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COMPOST.

WORD concern : 
   [COORD @D29790, REFL @D29789, PRD @D29788, CASE @D29787, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONCERN, 
   [COORD @D29794, REFL @D29793, PRD @D29792, CASE @D29791, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : CONCERN, 
   [COORD @D29799, REFL @D29798, COUNT @D29797, PRD @D29796, 
      CASE @D29795, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONCERN, 
   [COORD @D29802, 
      AGR [COUNT @D29801, PER @D29800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : CONCERN, 
   [COORD @D29804, AGR [COUNT @D29803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CONCERN, 
   [COORD @D29806, AGR [COUNT @D29805, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CONCERN, 
   [COORD @D29810, AGR [COUNT @D29809, PER @D29808, PLU @D29807, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CONCERN, 
   [COORD @D29816, PAST @D29815, 
      AGR [CASE @D29814, COUNT @D29813, PER @D29812, PLU @D29811, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : CONCERN, 
   [COORD @D29819, AGR [COUNT @D29818, PER @D29817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : CONCERN, 
   [COORD @D29821, AGR [COUNT @D29820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : CONCERN, 
   [COORD @D29823, AGR [COUNT @D29822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : CONCERN, 
   [COORD @D29827, AGR [COUNT @D29826, PER @D29825, PLU @D29824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : CONCERN, 
   [COORD @D29833, PAST @D29832, 
      AGR [CASE @D29831, COUNT @D29830, PER @D29829, PLU @D29828, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, 
      ARITY 3] : CONCERN, 
   [COORD @D29836, AGR [COUNT @D29835, PER @D29834, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONCERN, 
   [COORD @D29838, AGR [COUNT @D29837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONCERN, 
   [COORD @D29840, AGR [COUNT @D29839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONCERN, 
   [COORD @D29844, AGR [COUNT @D29843, PER @D29842, PLU @D29841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONCERN, 
   [COORD @D29850, PAST @D29849, AGR [CASE @D29848, COUNT @D29847, 
            PER @D29846, PLU @D29845, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONCERN.

WORD concerned : 
   [COADV @D29863, COORD @D29862, DEF @D29861, PRD @D29860, 
      AGR [CASE @D29859, COUNT @D29858, PER @D29857, PLU @D29856, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONCERNED, 
   [COADV @D29871, COORD @D29870, DEF @D29869, PRD @D29868, 
      AGR [CASE @D29867, COUNT @D29866, PER @D29865, PLU @D29864, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PST] : CONCERNED, 
   [COADV @D29879, COORD @D29878, DEF @D29877, PRD @D29876, 
      AGR [CASE @D29875, COUNT @D29874, PER @D29873, PLU @D29872, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, DISTR PRD, 
      ARITY 2] : CONCERNED, 
   [COADV @D29887, COORD @D29886, DEF @D29885, PRD @D29884, 
      AGR [CASE @D29883, COUNT @D29882, PER @D29881, PLU @D29880, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, GRADE +, 
      ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT PPING, PFORM ABOUT, DISTR PRD, 
      ARITY 2] : CONCERNED, 
   [COADV @D29895, COORD @D29894, DEF @D29893, PRD @D29892, 
      AGR [CASE @D29891, COUNT @D29890, PER @D29889, PLU @D29888, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      DISTR PRD, ARITY 2] : CONCERNED, 
   [COORD @D29900, AGR [CASE @D29899, COUNT @D29898, PER @D29897, 
            PLU @D29896, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29905, AGR [CASE @D29904, COUNT @D29903, PER @D29902, 
            PLU @D29901, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29910, AGR [CASE @D29909, COUNT @D29908, PER @D29907, 
            PLU @D29906, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29915, AGR [CASE @D29914, COUNT @D29913, PER @D29912, 
            PLU @D29911, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29920, AGR [CASE @D29919, COUNT @D29918, PER @D29917, 
            PLU @D29916, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29925, AGR [CASE @D29924, COUNT @D29923, PER @D29922, 
            PLU @D29921, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29930, AGR [CASE @D29929, COUNT @D29928, PER @D29927, 
            PLU @D29926, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONCERN, 
   [COORD @D29935, AGR [CASE @D29934, COUNT @D29933, PER @D29932, 
            PLU @D29931, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29940, AGR [CASE @D29939, COUNT @D29938, PER @D29937, 
            PLU @D29936, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONCERN.

WORD concerning : 
   [COORD @D29955, PRD @D29954, AGR [CASE @D29953, COUNT @D29952, 
            PER @D29951, PLU @D29950, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CONCERN, 
   [COORD @D29961, PRD @D29960, 
      AGR [CASE @D29959, COUNT @D29958, PER @D29957, PLU @D29956, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONCERN, 
   [COORD @D29967, PRD @D29966, AGR [CASE @D29965, COUNT @D29964, 
            PER @D29963, PLU @D29962, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONCERN.

WORD concerns : 
   [COORD @D29977, DEMON @D29976, REFL @D29975, PRD @D29974, 
      CASE @D29973, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CONCERN, 
   
   [COORD @D29979, AGR [COUNT @D29978, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CONCERN, 
   [COORD @D29981, AGR [COUNT @D29980, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CONCERN, 
   [COORD @D29983, AGR [COUNT @D29982, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONCERN.

WORD conduct : 
   [COORD @D29989, AGR [COUNT @D29988, PER @D29987, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONDUCT, 
   [COORD @D29991, AGR [COUNT @D29990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONDUCT, 
   [COORD @D29993, AGR [COUNT @D29992, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONDUCT, 
   [COORD @D29997, AGR [COUNT @D29996, PER @D29995, PLU @D29994, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONDUCT, 
   [COORD @D30003, PAST @D30002, AGR [CASE @D30001, COUNT @D30000, 
            PER @D29999, PLU @D29998, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : CONDUCT, 
   [COORD @D30006, AGR [COUNT @D30005, PER @D30004, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : CONDUCT, 
   [COORD @D30008, AGR [COUNT @D30007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : CONDUCT, 
   [COORD @D30010, AGR [COUNT @D30009, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : CONDUCT, 
   [COORD @D30014, AGR [COUNT @D30013, PER @D30012, PLU @D30011, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : CONDUCT, 
   [COORD @D30020, PAST @D30019, AGR 
         [CASE @D30018, COUNT @D30017, PER @D30016, PLU @D30015, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADVP, ARITY 3] : 
   CONDUCT, 
   [COORD @D30023, AGR [COUNT @D30022, PER @D30021, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONDUCT, 
   [COORD @D30025, AGR [COUNT @D30024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONDUCT, 
   [COORD @D30027, AGR [COUNT @D30026, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONDUCT, 
   [COORD @D30031, AGR [COUNT @D30030, PER @D30029, PLU @D30028, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONDUCT, 
   [COORD @D30037, PAST @D30036, AGR [CASE @D30035, COUNT @D30034, 
            PER @D30033, PLU @D30032, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONDUCT, 
   [COORD @D30040, AGR [COUNT @D30039, PER @D30038, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONDUCT, 
   [COORD @D30042, AGR [COUNT @D30041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONDUCT, 
   [COORD @D30044, AGR [COUNT @D30043, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONDUCT, 
   [COORD @D30048, AGR [COUNT @D30047, PER @D30046, PLU @D30045, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONDUCT, 
   [COORD @D30054, PAST @D30053, AGR [CASE @D30052, COUNT @D30051, 
            PER @D30050, PLU @D30049, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CONDUCT.

WORD conducted : 
   [COORD @D30063, AGR [CASE @D30062, COUNT @D30061, PER @D30060, 
            PLU @D30059, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30068, AGR [CASE @D30067, COUNT @D30066, PER @D30065, 
            PLU @D30064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30073, AGR [CASE @D30072, COUNT @D30071, PER @D30070, 
            PLU @D30069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30078, AGR [CASE @D30077, COUNT @D30076, PER @D30075, 
            PLU @D30074, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADVP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30083, AGR [CASE @D30082, COUNT @D30081, PER @D30080, 
            PLU @D30079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30088, AGR [CASE @D30087, COUNT @D30086, PER @D30085, 
            PLU @D30084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30093, AGR [CASE @D30092, COUNT @D30091, PER @D30090, 
            PLU @D30089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30098, AGR [CASE @D30097, COUNT @D30096, PER @D30095, 
            PLU @D30094, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30103, AGR [CASE @D30102, COUNT @D30101, PER @D30100, 
            PLU @D30099, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30108, AGR [CASE @D30107, COUNT @D30106, PER @D30105, 
            PLU @D30104, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30113, AGR [CASE @D30112, COUNT @D30111, PER @D30110, 
            PLU @D30109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONDUCT.

WORD conducting : 
   [COORD @D30125, PRD @D30124, AGR [CASE @D30123, COUNT @D30122, 
            PER @D30121, PLU @D30120, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30131, PRD @D30130, 
      AGR [CASE @D30129, COUNT @D30128, PER @D30127, PLU @D30126, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONDUCT, 
   [COORD @D30137, PRD @D30136, AGR [CASE @D30135, COUNT @D30134, 
            PER @D30133, PLU @D30132, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30143, PRD @D30142, 
      AGR [CASE @D30141, COUNT @D30140, PER @D30139, PLU @D30138, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONDUCT.

WORD conducts : 
   [COORD @D30149, AGR [COUNT @D30148, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30151, 
      AGR [COUNT @D30150, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30153, 
      AGR [COUNT @D30152, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONDUCT, 
   [COORD @D30155, 
      AGR [COUNT @D30154, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONDUCT.

WORD confine : 
   [COORD @D30162, AGR [COUNT @D30161, PER @D30160, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONFINE, 
   [COORD @D30164, AGR [COUNT @D30163, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONFINE, 
   [COORD @D30166, AGR [COUNT @D30165, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONFINE, 
   [COORD @D30170, AGR [COUNT @D30169, PER @D30168, PLU @D30167, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : CONFINE, 
   [COORD @D30176, PAST @D30175, AGR [CASE @D30174, COUNT @D30173, 
            PER @D30172, PLU @D30171, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : CONFINE, 
   [COORD @D30179, AGR [COUNT @D30178, PER @D30177, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CONFINE, 
   [COORD @D30181, AGR [COUNT @D30180, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CONFINE, 
   [COORD @D30183, AGR [COUNT @D30182, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CONFINE, 
   [COORD @D30187, AGR [COUNT @D30186, PER @D30185, PLU @D30184, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : CONFINE, 
   [COORD @D30193, PAST @D30192, 
      AGR [CASE @D30191, COUNT @D30190, PER @D30189, PLU @D30188, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : CONFINE, 
   [COORD @D30196, AGR [COUNT @D30195, PER @D30194, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONFINE, 
   [COORD @D30198, AGR [COUNT @D30197, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONFINE, 
   [COORD @D30200, AGR [COUNT @D30199, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONFINE, 
   [COORD @D30204, AGR [COUNT @D30203, PER @D30202, PLU @D30201, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONFINE, 
   [COORD @D30210, PAST @D30209, AGR [CASE @D30208, COUNT @D30207, 
            PER @D30206, PLU @D30205, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONFINE.

WORD confined : 
   [COORD @D30220, AGR [CASE @D30219, COUNT @D30218, PER @D30217, 
            PLU @D30216, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONFINE, 
   [COORD @D30225, AGR [CASE @D30224, COUNT @D30223, PER @D30222, 
            PLU @D30221, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30230, AGR [CASE @D30229, COUNT @D30228, PER @D30227, 
            PLU @D30226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30235, AGR [CASE @D30234, COUNT @D30233, PER @D30232, 
            PLU @D30231, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30240, AGR [CASE @D30239, COUNT @D30238, PER @D30237, 
            PLU @D30236, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30245, AGR [CASE @D30244, COUNT @D30243, PER @D30242, 
            PLU @D30241, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30250, AGR [CASE @D30249, COUNT @D30248, PER @D30247, 
            PLU @D30246, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONFINE, 
   [COORD @D30255, AGR [CASE @D30254, COUNT @D30253, PER @D30252, 
            PLU @D30251, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30260, AGR [CASE @D30259, COUNT @D30258, PER @D30257, 
            PLU @D30256, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONFINE.

WORD confines : 
   [COORD @D30267, AGR [COUNT @D30266, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30269, 
      AGR [COUNT @D30268, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30271, 
      AGR [COUNT @D30270, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONFINE.

WORD confining : 
   [COORD @D30281, PRD @D30280, AGR [CASE @D30279, COUNT @D30278, 
            PER @D30277, PLU @D30276, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONFINE, 
   [COORD @D30287, PRD @D30286, 
      AGR [CASE @D30285, COUNT @D30284, PER @D30283, PLU @D30282, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CONFINE, 
   [COORD @D30293, PRD @D30292, AGR [CASE @D30291, COUNT @D30290, 
            PER @D30289, PLU @D30288, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONFINE.

WORD connect : 
   [COORD @D30299, AGR [COUNT @D30298, PER @D30297, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CONNECT, 
   [COORD @D30301, AGR [COUNT @D30300, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CONNECT, 
   [COORD @D30303, AGR [COUNT @D30302, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CONNECT, 
   [COORD @D30307, AGR [COUNT @D30306, PER @D30305, PLU @D30304, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CONNECT, 
   [COORD @D30313, PAST @D30312, 
      AGR [CASE @D30311, COUNT @D30310, PER @D30309, PLU @D30308, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : CONNECT, 
   [COORD @D30316, AGR [COUNT @D30315, PER @D30314, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONNECT, 
   [COORD @D30318, AGR [COUNT @D30317, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONNECT, 
   [COORD @D30320, AGR [COUNT @D30319, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONNECT, 
   [COORD @D30324, AGR [COUNT @D30323, PER @D30322, PLU @D30321, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONNECT, 
   [COORD @D30330, PAST @D30329, AGR [CASE @D30328, COUNT @D30327, 
            PER @D30326, PLU @D30325, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONNECT, 
   [COORD @D30333, AGR [COUNT @D30332, PER @D30331, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30335, AGR [COUNT @D30334, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30337, AGR [COUNT @D30336, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30341, AGR [COUNT @D30340, PER @D30339, PLU @D30338, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30347, PAST @D30346, 
      AGR [CASE @D30345, COUNT @D30344, PER @D30343, PLU @D30342, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : CONNECT, 
   [COORD @D30350, AGR [COUNT @D30349, PER @D30348, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30352, AGR [COUNT @D30351, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30354, AGR [COUNT @D30353, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30358, AGR [COUNT @D30357, PER @D30356, PLU @D30355, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30364, PAST @D30363, 
      AGR [CASE @D30362, COUNT @D30361, PER @D30360, PLU @D30359, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30367, AGR [COUNT @D30366, PER @D30365, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT TOGETHER, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30369, AGR [COUNT @D30368, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT TOGETHER, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30371, AGR [COUNT @D30370, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT TOGETHER, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30375, AGR [COUNT @D30374, PER @D30373, PLU @D30372, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT TOGETHER, PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30381, PAST @D30380, 
      AGR [CASE @D30379, COUNT @D30378, PER @D30377, PLU @D30376, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT TOGETHER, 
      PFORM WITH, ARITY 2] : CONNECT, 
   [COORD @D30384, AGR [COUNT @D30383, PER @D30382, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CONNECT, 
   [COORD @D30386, AGR [COUNT @D30385, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CONNECT, 
   [COORD @D30388, AGR [COUNT @D30387, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CONNECT, 
   [COORD @D30392, AGR [COUNT @D30391, PER @D30390, PLU @D30389, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : CONNECT, 
   [COORD @D30398, PAST @D30397, 
      AGR [CASE @D30396, COUNT @D30395, PER @D30394, PLU @D30393, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : CONNECT, 
   [COORD @D30401, AGR [COUNT @D30400, PER @D30399, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : CONNECT, 
   [COORD @D30403, AGR [COUNT @D30402, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : CONNECT, 
   [COORD @D30405, AGR [COUNT @D30404, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : CONNECT, 
   [COORD @D30409, AGR [COUNT @D30408, PER @D30407, PLU @D30406, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : CONNECT, 
   [COORD @D30415, PAST @D30414, 
      AGR [CASE @D30413, COUNT @D30412, PER @D30411, PLU @D30410, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : CONNECT, 
   [COORD @D30418, AGR [COUNT @D30417, PER @D30416, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONNECT, 
   [COORD @D30420, AGR [COUNT @D30419, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONNECT, 
   [COORD @D30422, AGR [COUNT @D30421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONNECT, 
   [COORD @D30426, AGR [COUNT @D30425, PER @D30424, PLU @D30423, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONNECT, 
   [COORD @D30432, PAST @D30431, AGR [CASE @D30430, COUNT @D30429, 
            PER @D30428, PLU @D30427, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CONNECT, 
   [COORD @D30435, AGR [COUNT @D30434, PER @D30433, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CONNECT, 
   [COORD @D30437, AGR [COUNT @D30436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CONNECT, 
   [COORD @D30439, AGR [COUNT @D30438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CONNECT, 
   [COORD @D30443, AGR [COUNT @D30442, PER @D30441, PLU @D30440, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CONNECT, 
   [COORD @D30449, PAST @D30448, 
      AGR [CASE @D30447, COUNT @D30446, PER @D30445, PLU @D30444, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CONNECT, 
   [COORD @D30452, AGR [COUNT @D30451, PER @D30450, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : CONNECT, 
   [COORD @D30454, AGR [COUNT @D30453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : CONNECT, 
   [COORD @D30456, AGR [COUNT @D30455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : CONNECT, 
   [COORD @D30460, AGR [COUNT @D30459, PER @D30458, PLU @D30457, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : CONNECT, 
   [COORD @D30466, PAST @D30465, 
      AGR [CASE @D30464, COUNT @D30463, PER @D30462, PLU @D30461, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, 
      ARITY 1] : CONNECT.

WORD connected : 
   [COADV @D30478, COORD @D30477, DEF @D30476, PRD @D30475, 
      AGR [CASE @D30474, COUNT @D30473, PER @D30472, PLU @D30471, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   CONNECTED, 
   [COADV @D30486, COORD @D30485, DEF @D30484, PRD @D30483, 
      AGR [CASE @D30482, COUNT @D30481, PER @D30480, PLU @D30479, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      DISTR PRD, ARITY 2] : CONNECTED, 
   [COADV @D30494, COORD @D30493, DEF @D30492, PRD @D30491, 
      AGR [CASE @D30490, COUNT @D30489, PER @D30488, PLU @D30487, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      DISTR PRD, ARITY 2] : CONNECTED, 
   [COORD @D30499, AGR [CASE @D30498, COUNT @D30497, PER @D30496, 
            PLU @D30495, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30504, AGR [CASE @D30503, COUNT @D30502, PER @D30501, 
            PLU @D30500, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30509, AGR [CASE @D30508, COUNT @D30507, PER @D30506, 
            PLU @D30505, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30514, AGR [CASE @D30513, COUNT @D30512, PER @D30511, 
            PLU @D30510, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONNECT, 
   [COORD @D30519, AGR [CASE @D30518, COUNT @D30517, PER @D30516, 
            PLU @D30515, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30524, AGR [CASE @D30523, COUNT @D30522, PER @D30521, 
            PLU @D30520, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30529, AGR [CASE @D30528, COUNT @D30527, PER @D30526, 
            PLU @D30525, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30534, AGR [CASE @D30533, COUNT @D30532, PER @D30531, 
            PLU @D30530, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30539, AGR [CASE @D30538, COUNT @D30537, PER @D30536, 
            PLU @D30535, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30544, AGR [CASE @D30543, COUNT @D30542, PER @D30541, 
            PLU @D30540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30549, AGR [CASE @D30548, COUNT @D30547, PER @D30546, 
            PLU @D30545, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT TOGETHER, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30554, 
      AGR [CASE @D30553, COUNT @D30552, PER @D30551, PLU @D30550, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT TOGETHER, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30559, AGR [CASE @D30558, COUNT @D30557, PER @D30556, 
            PLU @D30555, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30564, AGR [CASE @D30563, COUNT @D30562, PER @D30561, 
            PLU @D30560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30569, AGR [CASE @D30568, COUNT @D30567, PER @D30566, 
            PLU @D30565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30574, AGR [CASE @D30573, COUNT @D30572, PER @D30571, 
            PLU @D30570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30579, AGR [CASE @D30578, COUNT @D30577, PER @D30576, 
            PLU @D30575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30584, AGR [CASE @D30583, COUNT @D30582, PER @D30581, 
            PLU @D30580, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30589, AGR [CASE @D30588, COUNT @D30587, PER @D30586, 
            PLU @D30585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30594, AGR [CASE @D30593, COUNT @D30592, PER @D30591, 
            PLU @D30590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30599, AGR [CASE @D30598, COUNT @D30597, PER @D30596, 
            PLU @D30595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30604, AGR [CASE @D30603, COUNT @D30602, PER @D30601, 
            PLU @D30600, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30609, AGR [CASE @D30608, COUNT @D30607, PER @D30606, 
            PLU @D30605, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30614, AGR [CASE @D30613, COUNT @D30612, PER @D30611, 
            PLU @D30610, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CONNECT.

WORD connecting : 
   [COORD @D30626, PRD @D30625, AGR [CASE @D30624, COUNT @D30623, 
            PER @D30622, PLU @D30621, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30632, PRD @D30631, 
      AGR [CASE @D30630, COUNT @D30629, PER @D30628, PLU @D30627, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONNECT, 
   [COORD @D30638, PRD @D30637, AGR [CASE @D30636, COUNT @D30635, 
            PER @D30634, PLU @D30633, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30644, PRD @D30643, 
      AGR [CASE @D30642, COUNT @D30641, PER @D30640, PLU @D30639, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONNECT, 
   [COORD @D30650, PRD @D30649, AGR [CASE @D30648, COUNT @D30647, 
            PER @D30646, PLU @D30645, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PRT TOGETHER, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONNECT, 
   [COORD @D30656, PRD @D30655, AGR [CASE @D30654, COUNT @D30653, 
            PER @D30652, PLU @D30651, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30662, PRD @D30661, 
      AGR [CASE @D30660, COUNT @D30659, PER @D30658, PLU @D30657, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONNECT, 
   [COORD @D30668, PRD @D30667, AGR [CASE @D30666, COUNT @D30665, 
            PER @D30664, PLU @D30663, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30674, PRD @D30673, 
      AGR [CASE @D30672, COUNT @D30671, PER @D30670, PLU @D30669, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CONNECT, 
   [COORD @D30680, PRD @D30679, AGR [CASE @D30678, COUNT @D30677, 
            PER @D30676, PLU @D30675, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CONNECT.

WORD connects : 
   [COORD @D30686, AGR [COUNT @D30685, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CONNECT, 
   [COORD @D30688, AGR [COUNT @D30687, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30690, 
      AGR [COUNT @D30689, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30692, 
      AGR [COUNT @D30691, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CONNECT, 
   [COORD @D30694, AGR [COUNT @D30693, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT TOGETHER, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CONNECT, 
   [COORD @D30696, AGR [COUNT @D30695, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30698, 
      AGR [COUNT @D30697, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30700, 
      AGR [COUNT @D30699, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30702, 
      AGR [COUNT @D30701, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONNECT, 
   [COORD @D30704, 
      AGR [COUNT @D30703, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CONNECT.

WORD consider : 
   [COORD @D30710, AGR [COUNT @D30709, PER @D30708, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CONSIDER, 
   [COORD @D30712, AGR [COUNT @D30711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CONSIDER, 
   [COORD @D30714, AGR [COUNT @D30713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CONSIDER, 
   [COORD @D30718, AGR [COUNT @D30717, PER @D30716, PLU @D30715, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : CONSIDER, 
   [COORD @D30724, PAST @D30723, AGR [CASE @D30722, COUNT @D30721, 
            PER @D30720, PLU @D30719, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : CONSIDER, 
   [COORD @D30727, AGR [COUNT @D30726, PER @D30725, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CONSIDER, 
   [COORD @D30729, AGR [COUNT @D30728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CONSIDER, 
   [COORD @D30731, AGR [COUNT @D30730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : CONSIDER, 
   [COORD @D30735, AGR [COUNT @D30734, PER @D30733, PLU @D30732, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : CONSIDER, 
   [COORD @D30741, PAST @D30740, AGR [CASE @D30739, COUNT @D30738, 
            PER @D30737, PLU @D30736, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : CONSIDER, 
   [COORD @D30744, AGR [COUNT @D30743, PER @D30742, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONSIDER, 
   [COORD @D30746, AGR [COUNT @D30745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONSIDER, 
   [COORD @D30748, AGR [COUNT @D30747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONSIDER, 
   [COORD @D30752, AGR [COUNT @D30751, PER @D30750, PLU @D30749, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONSIDER, 
   [COORD @D30758, PAST @D30757, AGR [CASE @D30756, COUNT @D30755, 
            PER @D30754, PLU @D30753, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : CONSIDER, 
   [COORD @D30761, AGR [COUNT @D30760, PER @D30759, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : CONSIDER, 
   [COORD @D30763, AGR [COUNT @D30762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : CONSIDER, 
   [COORD @D30765, AGR [COUNT @D30764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : CONSIDER, 
   [COORD @D30769, AGR [COUNT @D30768, PER @D30767, PLU @D30766, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : CONSIDER, 
   [COORD @D30775, PAST @D30774, AGR 
         [CASE @D30773, COUNT @D30772, PER @D30771, PLU @D30770, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : CONSIDER, 
   [COORD @D30778, AGR [COUNT @D30777, PER @D30776, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : CONSIDER, 
   [COORD @D30780, AGR [COUNT @D30779, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : CONSIDER, 
   [COORD @D30782, AGR [COUNT @D30781, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : CONSIDER, 
   [COORD @D30786, AGR [COUNT @D30785, PER @D30784, PLU @D30783, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : CONSIDER, 
   [COORD @D30792, PAST @D30791, AGR [CASE @D30790, COUNT @D30789, 
            PER @D30788, PLU @D30787, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_NP, ARITY 2] : CONSIDER, 
   [COORD @D30795, AGR [COUNT @D30794, PER @D30793, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CONSIDER, 
   [COORD @D30797, AGR [COUNT @D30796, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CONSIDER, 
   [COORD @D30799, AGR [COUNT @D30798, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CONSIDER, 
   [COORD @D30803, AGR [COUNT @D30802, PER @D30801, PLU @D30800, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : CONSIDER, 
   [COORD @D30809, PAST @D30808, AGR 
         [CASE @D30807, COUNT @D30806, PER @D30805, PLU @D30804, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : 
   CONSIDER, 
   [COORD @D30812, AGR [COUNT @D30811, PER @D30810, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : CONSIDER, 
   [COORD @D30814, AGR [COUNT @D30813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : CONSIDER, 
   [COORD @D30816, AGR [COUNT @D30815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : CONSIDER, 
   [COORD @D30820, AGR [COUNT @D30819, PER @D30818, PLU @D30817, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : CONSIDER, 
   [COORD @D30826, PAST @D30825, AGR [CASE @D30824, COUNT @D30823, 
            PER @D30822, PLU @D30821, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : CONSIDER, 
   [COORD @D30829, AGR [COUNT @D30828, PER @D30827, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONSIDER, 
   [COORD @D30831, AGR [COUNT @D30830, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONSIDER, 
   [COORD @D30833, AGR [COUNT @D30832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONSIDER, 
   [COORD @D30837, AGR [COUNT @D30836, PER @D30835, PLU @D30834, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONSIDER, 
   [COORD @D30843, PAST @D30842, AGR [CASE @D30841, COUNT @D30840, 
            PER @D30839, PLU @D30838, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONSIDER, 
   [COORD @D30846, AGR [COUNT @D30845, PER @D30844, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONSIDER, 
   [COORD @D30848, AGR [COUNT @D30847, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONSIDER, 
   [COORD @D30850, AGR [COUNT @D30849, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONSIDER, 
   [COORD @D30854, AGR [COUNT @D30853, PER @D30852, PLU @D30851, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONSIDER, 
   [COORD @D30860, PAST @D30859, AGR [CASE @D30858, COUNT @D30857, 
            PER @D30856, PLU @D30855, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CONSIDER.

WORD considered : 
   [COADV @D30872, COORD @D30871, DEF @D30870, PRD @D30869, 
      AGR [CASE @D30868, COUNT @D30867, PER @D30866, PLU @D30865, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONSIDERED, 
   [COADV @D30880, COORD @D30879, DEF @D30878, PRD @D30877, 
      AGR [CASE @D30876, COUNT @D30875, PER @D30874, PLU @D30873, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : CONSIDERED, 
   [COORD @D30885, AGR [CASE @D30884, COUNT @D30883, PER @D30882, 
            PLU @D30881, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30890, AGR [CASE @D30889, COUNT @D30888, PER @D30887, 
            PLU @D30886, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30895, AGR [CASE @D30894, COUNT @D30893, PER @D30892, 
            PLU @D30891, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30900, AGR [CASE @D30899, COUNT @D30898, PER @D30897, 
            PLU @D30896, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30905, AGR [UB @D30904, VFORM @D30903, SUBJ @D30902, 
            FIN @D30901, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONSIDER, 
   [COORD @D30910, AGR [CASE @D30909, COUNT @D30908, PER @D30907, 
            PLU @D30906, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30915, AGR [CASE @D30914, COUNT @D30913, PER @D30912, 
            PLU @D30911, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30920, AGR [CASE @D30919, COUNT @D30918, PER @D30917, 
            PLU @D30916, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30925, AGR [CASE @D30924, COUNT @D30923, PER @D30922, 
            PLU @D30921, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30930, AGR [CASE @D30929, COUNT @D30928, PER @D30927, 
            PLU @D30926, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30935, AGR [CASE @D30934, COUNT @D30933, PER @D30932, 
            PLU @D30931, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30940, AGR [CASE @D30939, COUNT @D30938, PER @D30937, 
            PLU @D30936, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30946, AGR [CASE @D30945, NFORM @D30944, COUNT @D30943, 
            PER @D30942, PLU @D30941, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30951, AGR [UB @D30950, VFORM @D30949, SUBJ @D30948, 
            FIN @D30947, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONSIDER, 
   [COORD @D30956, AGR [CASE @D30955, COUNT @D30954, PER @D30953, 
            PLU @D30952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30961, AGR [CASE @D30960, COUNT @D30959, PER @D30958, 
            PLU @D30957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30966, AGR [CASE @D30965, COUNT @D30964, PER @D30963, 
            PLU @D30962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30971, AGR [CASE @D30970, COUNT @D30969, PER @D30968, 
            PLU @D30967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30977, AGR [CASE @D30976, NFORM @D30975, COUNT @D30974, 
            PER @D30973, PLU @D30972, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30982, AGR [UB @D30981, VFORM @D30980, SUBJ @D30979, 
            FIN @D30978, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONSIDER, 
   [COORD @D30987, AGR [CASE @D30986, COUNT @D30985, PER @D30984, 
            PLU @D30983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30992, AGR [CASE @D30991, COUNT @D30990, PER @D30989, 
            PLU @D30988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D30997, AGR [CASE @D30996, COUNT @D30995, PER @D30994, 
            PLU @D30993, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31002, AGR [CASE @D31001, COUNT @D31000, PER @D30999, 
            PLU @D30998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31007, AGR [CASE @D31006, COUNT @D31005, PER @D31004, 
            PLU @D31003, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSIDER.

WORD considering : 
   [COORD @D31019, PRD @D31018, AGR [CASE @D31017, COUNT @D31016, 
            PER @D31015, PLU @D31014, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31025, PRD @D31024, 
      AGR [CASE @D31023, COUNT @D31022, PER @D31021, PLU @D31020, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONSIDER, 
   [COORD @D31031, PRD @D31030, AGR [CASE @D31029, COUNT @D31028, 
            PER @D31027, PLU @D31026, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31037, PRD @D31036, 
      AGR [CASE @D31035, COUNT @D31034, PER @D31033, PLU @D31032, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONSIDER, 
   [COORD @D31043, PRD @D31042, AGR [CASE @D31041, COUNT @D31040, 
            PER @D31039, PLU @D31038, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31049, PRD @D31048, 
      AGR [CASE @D31047, COUNT @D31046, PER @D31045, PLU @D31044, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONSIDER, 
   [COORD @D31055, PRD @D31054, AGR [CASE @D31053, COUNT @D31052, 
            PER @D31051, PLU @D31050, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31061, PRD @D31060, 
      AGR [CASE @D31059, COUNT @D31058, PER @D31057, PLU @D31056, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONSIDER, 
   [COORD @D31067, PRD @D31066, AGR [CASE @D31065, COUNT @D31064, 
            PER @D31063, PLU @D31062, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSIDER.

WORD considers : 
   [COORD @D31073, AGR [COUNT @D31072, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31075, 
      AGR [COUNT @D31074, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31077, 
      AGR [COUNT @D31076, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31079, 
      AGR [COUNT @D31078, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31081, 
      AGR [COUNT @D31080, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31083, 
      AGR [COUNT @D31082, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31085, 
      AGR [COUNT @D31084, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31087, 
      AGR [COUNT @D31086, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER, 
   [COORD @D31089, 
      AGR [COUNT @D31088, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSIDER.

WORD consist : 
   [COORD @D31095, AGR [COUNT @D31094, PER @D31093, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : CONSIST, 
   [COORD @D31097, AGR [COUNT @D31096, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : CONSIST, 
   [COORD @D31099, AGR [COUNT @D31098, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : CONSIST, 
   [COORD @D31103, AGR [COUNT @D31102, PER @D31101, PLU @D31100, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, ARITY 2] : CONSIST, 
   [COORD @D31109, PAST @D31108, 
      AGR [CASE @D31107, COUNT @D31106, PER @D31105, PLU @D31104, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM OF, 
      ARITY 2] : CONSIST, 
   [COORD @D31112, AGR [COUNT @D31111, PER @D31110, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : CONSIST, 
   [COORD @D31114, AGR [COUNT @D31113, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : CONSIST, 
   [COORD @D31116, AGR [COUNT @D31115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : CONSIST, 
   [COORD @D31120, AGR [COUNT @D31119, PER @D31118, PLU @D31117, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, ARITY 2] : CONSIST, 
   [COORD @D31126, PAST @D31125, 
      AGR [CASE @D31124, COUNT @D31123, PER @D31122, PLU @D31121, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM IN, 
      ARITY 2] : CONSIST.

WORD consisted : 
   [COORD @D31135, AGR [CASE @D31134, COUNT @D31133, PER @D31132, 
            PLU @D31131, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIST, 
   [COORD @D31140, AGR [CASE @D31139, COUNT @D31138, PER @D31137, 
            PLU @D31136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSIST, 
   [COORD @D31145, AGR [CASE @D31144, COUNT @D31143, PER @D31142, 
            PLU @D31141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CONSIST, 
   [COORD @D31150, AGR [CASE @D31149, COUNT @D31148, PER @D31147, 
            PLU @D31146, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSIST, 
   [COORD @D31155, AGR [CASE @D31154, COUNT @D31153, PER @D31152, 
            PLU @D31151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSIST, 
   [COORD @D31160, AGR [CASE @D31159, COUNT @D31158, PER @D31157, 
            PLU @D31156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CONSIST.

WORD consisting : 
   [COORD @D31172, PRD @D31171, AGR [CASE @D31170, COUNT @D31169, 
            PER @D31168, PLU @D31167, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CONSIST, 
   [COORD @D31178, PRD @D31177, 
      AGR [CASE @D31176, COUNT @D31175, PER @D31174, PLU @D31173, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CONSIST.

WORD consists : 
   [COORD @D31184, AGR [COUNT @D31183, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CONSIST, 
   [COORD @D31186, AGR [COUNT @D31185, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CONSIST.

WORD construct : 
   [COORD @D31192, AGR [COUNT @D31191, PER @D31190, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONSTRUCT, 
   [COORD @D31194, AGR [COUNT @D31193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONSTRUCT, 
   [COORD @D31196, AGR [COUNT @D31195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONSTRUCT, 
   [COORD @D31200, AGR [COUNT @D31199, PER @D31198, PLU @D31197, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONSTRUCT, 
   [COORD @D31206, PAST @D31205, AGR [CASE @D31204, COUNT @D31203, 
            PER @D31202, PLU @D31201, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONSTRUCT.

WORD constructed : 
   [COORD @D31215, AGR [CASE @D31214, COUNT @D31213, PER @D31212, 
            PLU @D31211, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONSTRUCT, 
   [COORD @D31220, AGR [CASE @D31219, COUNT @D31218, PER @D31217, 
            PLU @D31216, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONSTRUCT, 
   [COORD @D31225, AGR [CASE @D31224, COUNT @D31223, PER @D31222, 
            PLU @D31221, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONSTRUCT.

WORD constructing : 
   [COORD @D31237, PRD @D31236, AGR [CASE @D31235, COUNT @D31234, 
            PER @D31233, PLU @D31232, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONSTRUCT.

WORD constructs : 
   [COORD @D31243, AGR [COUNT @D31242, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONSTRUCT.

WORD contact : 
   [COADV @D31254, COORD @D31253, DEF @D31252, PRD @D31251, AGR 
            [CASE @D31250, COUNT @D31249, PER @D31248, PLU @D31247, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : CONTACT, 
   [COORD @D31259, REFL @D31258, COUNT @D31257, PRD @D31256, 
      CASE @D31255, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONTACT, 
   [COORD @D31262, 
      AGR [COUNT @D31261, PER @D31260, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   CONTACT, 
   [COORD @D31264, AGR [COUNT @D31263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTACT, 
   [COORD @D31266, AGR [COUNT @D31265, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTACT, 
   [COORD @D31270, AGR [COUNT @D31269, PER @D31268, PLU @D31267, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONTACT, 
   [COORD @D31276, PAST @D31275, AGR [CASE @D31274, COUNT @D31273, 
            PER @D31272, PLU @D31271, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONTACT.

WORD contacted : 
   [COORD @D31287, AGR [CASE @D31286, COUNT @D31285, PER @D31284, 
            PLU @D31283, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONTACT, 
   [COORD @D31292, AGR [CASE @D31291, COUNT @D31290, PER @D31289, 
            PLU @D31288, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTACT, 
   [COORD @D31297, AGR [CASE @D31296, COUNT @D31295, PER @D31294, 
            PLU @D31293, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTACT.

WORD contacting : 
   [COORD @D31315, PRD @D31314, AGR [CASE @D31313, COUNT @D31312, 
            PER @D31311, PLU @D31310, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONTACT.

WORD contacts : 
   [COORD @D31326, DEMON @D31325, REFL @D31324, PRD @D31323, 
      CASE @D31322, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CONTACT, 
   
   [COORD @D31328, AGR [COUNT @D31327, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTACT.

WORD contain : 
   [COORD @D31334, AGR [COUNT @D31333, PER @D31332, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTAIN, 
   [COORD @D31336, AGR [COUNT @D31335, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTAIN, 
   [COORD @D31338, AGR [COUNT @D31337, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTAIN, 
   [COORD @D31342, AGR [COUNT @D31341, PER @D31340, PLU @D31339, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONTAIN, 
   [COORD @D31348, PAST @D31347, AGR [CASE @D31346, COUNT @D31345, 
            PER @D31344, PLU @D31343, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONTAIN.

WORD contained : 
   [COADV @D31360, COORD @D31359, DEF @D31358, PRD @D31357, 
      AGR [CASE @D31356, COUNT @D31355, PER @D31354, PLU @D31353, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONTAINED, 
   [COORD @D31365, 
      AGR [CASE @D31364, COUNT @D31363, PER @D31362, PLU @D31361, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : CONTAIN, 
   
   [COORD @D31370, AGR [CASE @D31369, COUNT @D31368, PER @D31367, PLU 
               @D31366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONTAIN, 
   [COORD @D31375, AGR [CASE @D31374, COUNT @D31373, PER @D31372, 
            PLU @D31371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTAIN.

WORD containing : 
   [COORD @D31387, PRD @D31386, AGR [CASE @D31385, COUNT @D31384, 
            PER @D31383, PLU @D31382, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONTAIN.

WORD contains : 
   [COORD @D31393, AGR [COUNT @D31392, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTAIN.

WORD continue : 
   [COORD @D31400, AGR [COUNT @D31399, PER @D31398, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : CONTINUE, 
   [COORD @D31402, AGR [COUNT @D31401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : CONTINUE, 
   [COORD @D31404, AGR [COUNT @D31403, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : CONTINUE, 
   [COORD @D31408, AGR [COUNT @D31407, PER @D31406, PLU @D31405, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : CONTINUE, 
   [COORD @D31414, PAST @D31413, AGR 
         [CASE @D31412, COUNT @D31411, PER @D31410, PLU @D31409, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, ARITY 3] : 
   CONTINUE, 
   [COORD @D31417, AGR [COUNT @D31416, PER @D31415, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONTINUE, 
   [COORD @D31419, AGR [COUNT @D31418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONTINUE, 
   [COORD @D31421, AGR [COUNT @D31420, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONTINUE, 
   [COORD @D31425, AGR [COUNT @D31424, PER @D31423, PLU @D31422, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : CONTINUE, 
   [COORD @D31431, PAST @D31430, AGR [CASE @D31429, COUNT @D31428, 
            PER @D31427, PLU @D31426, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : CONTINUE, 
   [COORD @D31434, AGR [COUNT @D31433, PER @D31432, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTINUE, 
   [COORD @D31436, AGR [COUNT @D31435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTINUE, 
   [COORD @D31438, AGR [COUNT @D31437, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTINUE, 
   [COORD @D31442, AGR [COUNT @D31441, PER @D31440, PLU @D31439, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONTINUE, 
   [COORD @D31448, PAST @D31447, AGR [CASE @D31446, COUNT @D31445, 
            PER @D31444, PLU @D31443, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONTINUE, 
   [COORD @D31451, AGR [COUNT @D31450, PER @D31449, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : CONTINUE, 
   [COORD @D31453, AGR [COUNT @D31452, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : CONTINUE, 
   [COORD @D31455, AGR [COUNT @D31454, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : CONTINUE, 
   [COORD @D31459, AGR [COUNT @D31458, PER @D31457, PLU @D31456, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : CONTINUE, 
   [COORD @D31465, PAST @D31464, AGR [CASE @D31463, COUNT @D31462, 
            PER @D31461, PLU @D31460, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : CONTINUE, 
   [COORD @D31468, AGR [COUNT @D31467, PER @D31466, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : CONTINUE, 
   [COORD @D31470, AGR [COUNT @D31469, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : CONTINUE, 
   [COORD @D31472, AGR [COUNT @D31471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : CONTINUE, 
   [COORD @D31476, AGR [COUNT @D31475, PER @D31474, PLU @D31473, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, ARITY 2] : CONTINUE, 
   [COORD @D31482, PAST @D31481, AGR [CASE @D31480, COUNT @D31479, 
            PER @D31478, PLU @D31477, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, ARITY 2] : CONTINUE, 
   [COORD @D31484, AGR [COUNT @D31483, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CONTINUE, 
   [COORD @D31486, AGR [COUNT @D31485, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CONTINUE, 
   [COORD @D31490, AGR [NFORM @D31489, COUNT @D31488, PER @D31487, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CONTINUE, 
   [COORD @D31494, AGR [COUNT @D31493, PER @D31492, PLU @D31491, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : CONTINUE, 
   [COORD @D31497, AGR @D31496, PAST @D31495, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_ING, ARITY 1] : CONTINUE, 
   [COORD @D31499, AGR [COUNT @D31498, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CONTINUE, 
   [COORD @D31501, AGR [COUNT @D31500, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CONTINUE, 
   [COORD @D31505, AGR [NFORM @D31504, COUNT @D31503, PER @D31502, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CONTINUE, 
   [COORD @D31509, AGR [COUNT @D31508, PER @D31507, PLU @D31506, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : CONTINUE, 
   [COORD @D31512, AGR @D31511, PAST @D31510, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, ARITY 1] : CONTINUE, 
   [COORD @D31515, AGR [COUNT @D31514, PER @D31513, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONTINUE, 
   [COORD @D31517, AGR [COUNT @D31516, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONTINUE, 
   [COORD @D31519, AGR [COUNT @D31518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONTINUE, 
   [COORD @D31523, AGR [COUNT @D31522, PER @D31521, PLU @D31520, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CONTINUE, 
   [COORD @D31529, PAST @D31528, AGR [CASE @D31527, COUNT @D31526, 
            PER @D31525, PLU @D31524, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CONTINUE.

WORD continued : 
   [COORD @D31539, AGR [CASE @D31538, COUNT @D31537, PER @D31536, 
            PLU @D31535, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADL, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31544, AGR [CASE @D31543, COUNT @D31542, PER @D31541, 
            PLU @D31540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31549, AGR [CASE @D31548, COUNT @D31547, PER @D31546, 
            PLU @D31545, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31554, AGR [CASE @D31553, COUNT @D31552, PER @D31551, 
            PLU @D31550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31559, AGR [CASE @D31558, COUNT @D31557, PER @D31556, 
            PLU @D31555, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31564, AGR [UB @D31563, VFORM @D31562, SUBJ @D31561, 
            FIN @D31560, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONTINUE, 
   [COORD @D31569, AGR [CASE @D31568, COUNT @D31567, PER @D31566, 
            PLU @D31565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31574, AGR [CASE @D31573, COUNT @D31572, PER @D31571, 
            PLU @D31570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31579, AGR [CASE @D31578, COUNT @D31577, PER @D31576, 
            PLU @D31575, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31584, AGR [CASE @D31583, COUNT @D31582, PER @D31581, 
            PLU @D31580, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31589, AGR [CASE @D31588, COUNT @D31587, PER @D31586, 
            PLU @D31585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31594, AGR [CASE @D31593, COUNT @D31592, PER @D31591, 
            PLU @D31590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31599, AGR [CASE @D31598, COUNT @D31597, PER @D31596, 
            PLU @D31595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31601, AGR @D31600, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CONTINUE, 
   [COORD @D31603, AGR @D31602, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : CONTINUE, 
   [COORD @D31605, AGR @D31604, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CONTINUE, 
   [COORD @D31607, AGR @D31606, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : CONTINUE, 
   [COORD @D31612, AGR [CASE @D31611, COUNT @D31610, PER @D31609, 
            PLU @D31608, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31617, AGR [CASE @D31616, COUNT @D31615, PER @D31614, 
            PLU @D31613, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTINUE.

WORD continues : 
   [COORD @D31624, AGR [COUNT @D31623, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31626, 
      AGR [COUNT @D31625, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31628, 
      AGR [COUNT @D31627, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31630, 
      AGR [COUNT @D31629, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31632, 
      AGR [COUNT @D31631, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31636, 
      AGR [CASE @D31635, NFORM @D31634, COUNT @D31633, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31641, 
      AGR [UB @D31640, VFORM @D31639, SUBJ @D31638, FIN @D31637, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31645, 
      AGR [CASE @D31644, NFORM @D31643, COUNT @D31642, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31650, 
      AGR [UB @D31649, VFORM @D31648, SUBJ @D31647, FIN @D31646, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31652, 
      AGR [COUNT @D31651, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTINUE.

WORD continuing : 
   [COORD @D31662, PRD @D31661, AGR [CASE @D31660, COUNT @D31659, 
            PER @D31658, PLU @D31657, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31668, PRD @D31667, 
      AGR [CASE @D31666, COUNT @D31665, PER @D31664, PLU @D31663, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONTINUE, 
   [COORD @D31674, PRD @D31673, AGR [CASE @D31672, COUNT @D31671, 
            PER @D31670, PLU @D31669, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31680, PRD @D31679, 
      AGR [CASE @D31678, COUNT @D31677, PER @D31676, PLU @D31675, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CONTINUE, 
   [COORD @D31686, PRD @D31685, AGR [CASE @D31684, COUNT @D31683, 
            PER @D31682, PLU @D31681, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONTINUE, 
   [COORD @D31689, AGR @D31688, PRD @D31687, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONTINUE, 
   [COORD @D31692, AGR @D31691, PRD @D31690, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CONTINUE, 
   [COORD @D31698, PRD @D31697, AGR [CASE @D31696, COUNT @D31695, 
            PER @D31694, PLU @D31693, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONTINUE.

WORD control : 
   [COORD @D31706, REFL @D31705, COUNT @D31704, PRD @D31703, 
      CASE @D31702, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONTROL, 
   [COORD @D31710, REFL @D31709, PRD @D31708, CASE @D31707, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OVER] : CONTROL, 
   [COORD @D31714, REFL @D31713, PRD @D31712, CASE @D31711, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON] : CONTROL, 
   [COORD @D31718, REFL @D31717, PRD @D31716, CASE @D31715, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : CONTROL, 
   [COORD @D31723, REFL @D31722, COUNT @D31721, PRD @D31720, 
      CASE @D31719, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CONTROL, 
   [COORD @D31726, 
      AGR [COUNT @D31725, PER @D31724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   CONTROL, 
   [COORD @D31728, AGR [COUNT @D31727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTROL, 
   [COORD @D31730, AGR [COUNT @D31729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CONTROL, 
   [COORD @D31734, AGR [COUNT @D31733, PER @D31732, PLU @D31731, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CONTROL, 
   [COORD @D31740, PAST @D31739, AGR [CASE @D31738, COUNT @D31737, 
            PER @D31736, PLU @D31735, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CONTROL.

WORD controlled : 
   [COORD @D31754, AGR [CASE @D31753, COUNT @D31752, PER @D31751, 
            PLU @D31750, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CONTROL, 
   [COORD @D31759, AGR [CASE @D31758, COUNT @D31757, PER @D31756, 
            PLU @D31755, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CONTROL, 
   [COORD @D31764, AGR [CASE @D31763, COUNT @D31762, PER @D31761, 
            PLU @D31760, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CONTROL.

WORD controlling : 
   [COORD @D31783, PRD @D31782, AGR [CASE @D31781, COUNT @D31780, 
            PER @D31779, PLU @D31778, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CONTROL.

WORD controls : 
   [COORD @D31793, DEMON @D31792, REFL @D31791, PRD @D31790, 
      CASE @D31789, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CONTROL, 
   
   [COORD @D31798, DEMON @D31797, REFL @D31796, PRD @D31795, CASE 
      @D31794, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CONTROL, 
   
   [COORD @D31800, AGR [COUNT @D31799, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CONTROL.

WORD cook : 
   [COORD @D31806, AGR [COUNT @D31805, PER @D31804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COOK, 
   [COORD @D31808, AGR [COUNT @D31807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COOK, 
   [COORD @D31810, AGR [COUNT @D31809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COOK, 
   [COORD @D31814, AGR [COUNT @D31813, PER @D31812, PLU @D31811, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COOK, 
   [COORD @D31820, PAST @D31819, AGR [CASE @D31818, COUNT @D31817, 
            PER @D31816, PLU @D31815, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COOK, 
   [COORD @D31823, AGR [COUNT @D31822, PER @D31821, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COOK, 
   [COORD @D31825, AGR [COUNT @D31824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COOK, 
   [COORD @D31827, AGR [COUNT @D31826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COOK, 
   [COORD @D31831, AGR [COUNT @D31830, PER @D31829, PLU @D31828, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : COOK, 
   [COORD @D31837, PAST @D31836, 
      AGR [CASE @D31835, COUNT @D31834, PER @D31833, PLU @D31832, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : COOK, 
   [COORD @D31840, AGR [COUNT @D31839, PER @D31838, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COOK, 
   [COORD @D31842, AGR [COUNT @D31841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COOK, 
   [COORD @D31844, AGR [COUNT @D31843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COOK, 
   [COORD @D31848, AGR [COUNT @D31847, PER @D31846, PLU @D31845, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COOK, 
   [COORD @D31854, PAST @D31853, AGR [CASE @D31852, COUNT @D31851, 
            PER @D31850, PLU @D31849, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COOK, 
   [COORD @D31857, AGR [COUNT @D31856, PER @D31855, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COOK, 
   [COORD @D31859, AGR [COUNT @D31858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COOK, 
   [COORD @D31861, AGR [COUNT @D31860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COOK, 
   [COORD @D31865, AGR [COUNT @D31864, PER @D31863, PLU @D31862, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COOK, 
   [COORD @D31871, PAST @D31870, 
      AGR [CASE @D31869, COUNT @D31868, PER @D31867, PLU @D31866, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : COOK.

WORD cooked : 
   [COORD @D31880, AGR [CASE @D31879, COUNT @D31878, PER @D31877, 
            PLU @D31876, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COOK, 
   [COORD @D31885, AGR [CASE @D31884, COUNT @D31883, PER @D31882, 
            PLU @D31881, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COOK, 
   [COORD @D31890, AGR [CASE @D31889, COUNT @D31888, PER @D31887, 
            PLU @D31886, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COOK, 
   [COORD @D31895, AGR [CASE @D31894, COUNT @D31893, PER @D31892, 
            PLU @D31891, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COOK, 
   [COORD @D31900, AGR [CASE @D31899, COUNT @D31898, PER @D31897, 
            PLU @D31896, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COOK, 
   [COORD @D31905, AGR [CASE @D31904, COUNT @D31903, PER @D31902, 
            PLU @D31901, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COOK, 
   [COORD @D31910, AGR [CASE @D31909, COUNT @D31908, PER @D31907, 
            PLU @D31906, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COOK, 
   [COORD @D31915, AGR [CASE @D31914, COUNT @D31913, PER @D31912, 
            PLU @D31911, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COOK, 
   [COORD @D31920, AGR [CASE @D31919, COUNT @D31918, PER @D31917, 
            PLU @D31916, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COOK, 
   [COORD @D31925, AGR [CASE @D31924, COUNT @D31923, PER @D31922, 
            PLU @D31921, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COOK.

WORD cooking : 
   [COADV @D31939, COORD @D31938, DEF @D31937, PRD @D31936, AGR 
            [CASE @D31935, COUNT @D31934, PER @D31933, PLU @D31932, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : COOKING, 
   [COORD @D31945, PRD @D31944, AGR [CASE @D31943, COUNT @D31942, 
            PER @D31941, PLU @D31940, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COOK, 
   [COORD @D31951, PRD @D31950, 
      AGR [CASE @D31949, COUNT @D31948, PER @D31947, PLU @D31946, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COOK, 
   [COORD @D31957, PRD @D31956, AGR [CASE @D31955, COUNT @D31954, 
            PER @D31953, PLU @D31952, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COOK, 
   [COORD @D31963, PRD @D31962, 
      AGR [CASE @D31961, COUNT @D31960, PER @D31959, PLU @D31958, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COOK.

WORD cooks : 
   [COORD @D31969, AGR [COUNT @D31968, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COOK, 
   [COORD @D31971, 
      AGR [COUNT @D31970, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COOK, 
   [COORD @D31973, 
      AGR [COUNT @D31972, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COOK, 
   [COORD @D31975, 
      AGR [COUNT @D31974, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COOK.

WORD cost : 
   [COORD @D31982, REFL @D31981, PRD @D31980, CASE @D31979, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : COST, 
   [COORD @D31987, REFL @D31986, COUNT @D31985, PRD @D31984, 
      CASE @D31983, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COST, 
   [COORD @D31990, 
      AGR [COUNT @D31989, PER @D31988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, REG -, ARITY 3] : 
   COST, 
   [COORD @D31992, AGR [COUNT @D31991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, 
      REG -, ARITY 3] : COST, 
   [COORD @D31994, AGR [COUNT @D31993, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, 
      REG -, ARITY 3] : COST, 
   [COORD @D31998, AGR [COUNT @D31997, PER @D31996, PLU @D31995, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_MP, REG -, ARITY 3] : COST, 
   [COORD @D32004, PAST @D32003, 
      AGR [CASE @D32002, COUNT @D32001, PER @D32000, PLU @D31999, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, REG -, ARITY 3] : 
   COST, 
   [COORD @D32010, PAST @D32009, AGR [CASE @D32008, COUNT @D32007, 
            PER @D32006, PLU @D32005, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_MP, REG -, FIN -, ARITY 3] : COST, 
   [COORD @D32014, AGR [COUNT @D32013, PER @D32012, PLU @D32011, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, REG -, 
      PAST +, ARITY 3] : COST, 
   [COORD @D32017, AGR [COUNT @D32016, PER @D32015, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COST, 
   [COORD @D32019, AGR [COUNT @D32018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COST, 
   [COORD @D32021, AGR [COUNT @D32020, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COST, 
   [COORD @D32025, AGR [COUNT @D32024, PER @D32023, PLU @D32022, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COST, 
   [COORD @D32031, PAST @D32030, AGR [CASE @D32029, COUNT @D32028, 
            PER @D32027, PLU @D32026, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COST, 
   [COORD @D32034, AGR [COUNT @D32033, PER @D32032, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : COST, 
   [COORD @D32036, AGR [COUNT @D32035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : COST, 
   [COORD @D32038, AGR [COUNT @D32037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : COST, 
   [COORD @D32042, AGR [COUNT @D32041, PER @D32040, PLU @D32039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      REG -, ARITY 2] : COST, 
   [COORD @D32048, PAST @D32047, AGR [CASE @D32046, COUNT @D32045, 
            PER @D32044, PLU @D32043, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT MP, REG -, ARITY 2] : COST, 
   [COORD @D32054, PAST @D32053, 
      AGR [CASE @D32052, COUNT @D32051, PER @D32050, PLU @D32049, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : COST, 
   [COORD @D32060, PAST @D32059, AGR [CASE @D32058, COUNT @D32057, 
            PER @D32056, PLU @D32055, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : COST, 
   [COORD @D32066, PAST @D32065, 
      AGR [CASE @D32064, COUNT @D32063, PER @D32062, PLU @D32061, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, FIN -, ARITY 2] : COST, 
   [COORD @D32070, 
      AGR [COUNT @D32069, PER @D32068, PLU @D32067, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : COST, 
   [COORD @D32074, AGR [COUNT @D32073, PER @D32072, PLU @D32071, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, PAST +, 
      ARITY 2] : COST.

WORD costed : 
   [COORD @D32084, AGR [CASE @D32083, COUNT @D32082, PER @D32081, 
            PLU @D32080, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COST, 
   [COORD @D32089, AGR [CASE @D32088, COUNT @D32087, PER @D32086, 
            PLU @D32085, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COST, 
   [COORD @D32094, AGR [CASE @D32093, COUNT @D32092, PER @D32091, 
            PLU @D32090, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COST.

WORD costing : 
   [COORD @D32109, PRD @D32108, AGR [CASE @D32107, COUNT @D32106, 
            PER @D32105, PLU @D32104, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_MP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COST, 
   [COORD @D32115, PRD @D32114, 
      AGR [CASE @D32113, COUNT @D32112, PER @D32111, PLU @D32110, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   COST, 
   [COORD @D32121, PRD @D32120, AGR [CASE @D32119, COUNT @D32118, 
            PER @D32117, PLU @D32116, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT MP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COST.

WORD costs : 
   [COORD @D32130, REFL @D32129, PRD @D32128, CASE @D32127, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : COSTS, 
   [COORD @D32135, DEMON @D32134, REFL @D32133, PRD @D32132, 
      CASE @D32131, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : COST, 
   [COORD @D32137, 
      AGR [COUNT @D32136, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_MP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COST, 
   [COORD @D32139, 
      AGR [COUNT @D32138, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COST, 
   [COORD @D32141, 
      AGR [COUNT @D32140, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT MP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COST.

WORD couple : 
   [COORD @D32159, AGR [COUNT @D32158, PER @D32157, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COUPLE, 
   [COORD @D32161, AGR [COUNT @D32160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COUPLE, 
   [COORD @D32163, AGR [COUNT @D32162, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COUPLE, 
   [COORD @D32167, AGR [COUNT @D32166, PER @D32165, PLU @D32164, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : COUPLE, 
   [COORD @D32173, PAST @D32172, 
      AGR [CASE @D32171, COUNT @D32170, PER @D32169, PLU @D32168, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : COUPLE, 
   [COORD @D32176, AGR [COUNT @D32175, PER @D32174, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, PFORM TO, ARITY 3] : COUPLE, 
   [COORD @D32178, AGR 
         [COUNT @D32177, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, PFORM TO, 
      ARITY 3] : COUPLE, 
   [COORD @D32180, AGR [COUNT @D32179, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, PFORM TO, ARITY 3] : COUPLE, 
   [COORD @D32184, AGR 
         [COUNT @D32183, PER @D32182, PLU @D32181, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, PFORM TO, ARITY 3] : COUPLE, 
   [COORD @D32190, PAST @D32189, 
      AGR [CASE @D32188, COUNT @D32187, PER @D32186, PLU @D32185, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      PFORM TO, ARITY 3] : COUPLE, 
   [COORD @D32193, AGR [COUNT @D32192, PER @D32191, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COUPLE, 
   [COORD @D32195, AGR [COUNT @D32194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COUPLE, 
   [COORD @D32197, AGR [COUNT @D32196, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COUPLE, 
   [COORD @D32201, AGR [COUNT @D32200, PER @D32199, PLU @D32198, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COUPLE, 
   [COORD @D32207, PAST @D32206, AGR [CASE @D32205, COUNT @D32204, 
            PER @D32203, PLU @D32202, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COUPLE, 
   [COORD @D32210, AGR [COUNT @D32209, PER @D32208, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COUPLE, 
   [COORD @D32212, AGR [COUNT @D32211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COUPLE, 
   [COORD @D32214, AGR [COUNT @D32213, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : COUPLE, 
   [COORD @D32218, AGR [COUNT @D32217, PER @D32216, PLU @D32215, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : COUPLE, 
   [COORD @D32224, PAST @D32223, 
      AGR [CASE @D32222, COUNT @D32221, PER @D32220, PLU @D32219, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : COUPLE, 
   [COORD @D32227, AGR [COUNT @D32226, PER @D32225, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COUPLE, 
   [COORD @D32229, AGR [COUNT @D32228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COUPLE, 
   [COORD @D32231, AGR [COUNT @D32230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COUPLE, 
   [COORD @D32235, AGR [COUNT @D32234, PER @D32233, PLU @D32232, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : COUPLE, 
   [COORD @D32241, PAST @D32240, 
      AGR [CASE @D32239, COUNT @D32238, PER @D32237, PLU @D32236, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : COUPLE, 
   [COORD @D32244, AGR [COUNT @D32243, PER @D32242, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : COUPLE, 
   [COORD @D32246, AGR [COUNT @D32245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : COUPLE, 
   [COORD @D32248, AGR [COUNT @D32247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : COUPLE, 
   [COORD @D32252, AGR [COUNT @D32251, PER @D32250, PLU @D32249, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : COUPLE, 
   [COORD @D32258, PAST @D32257, 
      AGR [CASE @D32256, COUNT @D32255, PER @D32254, PLU @D32253, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : COUPLE, 
   [COORD @D32261, AGR [COUNT @D32260, PER @D32259, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COUPLE, 
   [COORD @D32263, AGR [COUNT @D32262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COUPLE, 
   [COORD @D32265, AGR [COUNT @D32264, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COUPLE, 
   [COORD @D32269, AGR [COUNT @D32268, PER @D32267, PLU @D32266, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COUPLE, 
   [COORD @D32275, PAST @D32274, AGR [CASE @D32273, COUNT @D32272, 
            PER @D32271, PLU @D32270, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COUPLE, 
   [COORD @D32278, AGR [COUNT @D32277, PER @D32276, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COUPLE, 
   [COORD @D32280, AGR [COUNT @D32279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COUPLE, 
   [COORD @D32282, AGR [COUNT @D32281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COUPLE, 
   [COORD @D32286, AGR [COUNT @D32285, PER @D32284, PLU @D32283, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : COUPLE, 
   [COORD @D32292, PAST @D32291, 
      AGR [CASE @D32290, COUNT @D32289, PER @D32288, PLU @D32287, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, 
      ARITY 1] : COUPLE, 
   [COORD @D32295, AGR [COUNT @D32294, PER @D32293, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : COUPLE, 
   [COORD @D32297, AGR [COUNT @D32296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : COUPLE, 
   [COORD @D32299, AGR [COUNT @D32298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : COUPLE, 
   [COORD @D32303, AGR [COUNT @D32302, PER @D32301, PLU @D32300, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : COUPLE, 
   [COORD @D32309, PAST @D32308, 
      AGR [CASE @D32307, COUNT @D32306, PER @D32305, PLU @D32304, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : COUPLE.

WORD coupled : 
   [COORD @D32320, AGR [CASE @D32319, COUNT @D32318, PER @D32317, 
            PLU @D32316, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32325, AGR [CASE @D32324, COUNT @D32323, PER @D32322, 
            PLU @D32321, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32330, AGR [CASE @D32329, COUNT @D32328, PER @D32327, 
            PLU @D32326, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32335, AGR [CASE @D32334, COUNT @D32333, PER @D32332, 
            PLU @D32331, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT ON, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32340, AGR [CASE @D32339, COUNT @D32338, PER @D32337, 
            PLU @D32336, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT ON, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32345, 
      AGR [CASE @D32344, COUNT @D32343, PER @D32342, PLU @D32341, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : COUPLE, 
   [COORD @D32350, AGR [CASE @D32349, COUNT @D32348, PER @D32347, 
            PLU @D32346, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COUPLE, 
   [COORD @D32355, AGR [CASE @D32354, COUNT @D32353, PER @D32352, 
            PLU @D32351, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32360, AGR [CASE @D32359, COUNT @D32358, PER @D32357, 
            PLU @D32356, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32365, AGR [CASE @D32364, COUNT @D32363, PER @D32362, 
            PLU @D32361, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32370, AGR [CASE @D32369, COUNT @D32368, PER @D32367, 
            PLU @D32366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32375, AGR [CASE @D32374, COUNT @D32373, PER @D32372, 
            PLU @D32371, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32380, AGR [CASE @D32379, COUNT @D32378, PER @D32377, 
            PLU @D32376, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32385, AGR [CASE @D32384, COUNT @D32383, PER @D32382, 
            PLU @D32381, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32390, AGR [CASE @D32389, COUNT @D32388, PER @D32387, 
            PLU @D32386, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32395, AGR [CASE @D32394, COUNT @D32393, PER @D32392, 
            PLU @D32391, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32400, AGR [CASE @D32399, COUNT @D32398, PER @D32397, 
            PLU @D32396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32405, AGR [CASE @D32404, COUNT @D32403, PER @D32402, 
            PLU @D32401, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32410, AGR [CASE @D32409, COUNT @D32408, PER @D32407, 
            PLU @D32406, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32415, AGR [CASE @D32414, COUNT @D32413, PER @D32412, 
            PLU @D32411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32420, AGR [CASE @D32419, COUNT @D32418, PER @D32417, 
            PLU @D32416, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32425, AGR [CASE @D32424, COUNT @D32423, PER @D32422, 
            PLU @D32421, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32430, AGR [CASE @D32429, COUNT @D32428, PER @D32427, 
            PLU @D32426, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COUPLE.

WORD couples : 
   [COORD @D32438, AGR [COUNT @D32437, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COUPLE, 
   [COORD @D32440, AGR [COUNT @D32439, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : COUPLE, 
   [COORD @D32442, AGR [COUNT @D32441, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32444, 
      AGR [COUNT @D32443, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32446, 
      AGR [COUNT @D32445, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32448, 
      AGR [COUNT @D32447, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32450, 
      AGR [COUNT @D32449, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32452, 
      AGR [COUNT @D32451, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COUPLE, 
   [COORD @D32454, AGR [COUNT @D32453, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COUPLE.

WORD coupling : 
   [COORD @D32465, PRD @D32464, AGR [CASE @D32463, COUNT @D32462, 
            PER @D32461, PLU @D32460, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32471, PRD @D32470, 
      AGR [CASE @D32469, COUNT @D32468, PER @D32467, PLU @D32466, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COUPLE, 
   [COORD @D32477, PRD @D32476, AGR [CASE @D32475, COUNT @D32474, 
            PER @D32473, PLU @D32472, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32483, PRD @D32482, 
      AGR [CASE @D32481, COUNT @D32480, PER @D32479, PLU @D32478, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COUPLE, 
   [COORD @D32489, PRD @D32488, AGR [CASE @D32487, COUNT @D32486, 
            PER @D32485, PLU @D32484, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32495, PRD @D32494, 
      AGR [CASE @D32493, COUNT @D32492, PER @D32491, PLU @D32490, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COUPLE, 
   [COORD @D32501, PRD @D32500, AGR [CASE @D32499, COUNT @D32498, 
            PER @D32497, PLU @D32496, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COUPLE, 
   [COORD @D32507, PRD @D32506, 
      AGR [CASE @D32505, COUNT @D32504, PER @D32503, PLU @D32502, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : COUPLE, 
   [COORD @D32513, PRD @D32512, AGR [CASE @D32511, COUNT @D32510, 
            PER @D32509, PLU @D32508, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COUPLE.

WORD courage : 
   [COORD @D32521, REFL @D32520, PRD @D32519, CASE @D32518, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : COURAGE.

WORD cover : 
   [COORD @D32534, REFL @D32533, COUNT @D32532, PRD @D32531, CASE 
         @D32530, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : COVER, 
   [COORD @D32538, REFL @D32537, PRD @D32536, CASE @D32535, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : COVER, 
   [COORD @D32541, 
      AGR [COUNT @D32540, PER @D32539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   COVER, 
   [COORD @D32543, AGR [COUNT @D32542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COVER, 
   [COORD @D32545, AGR [COUNT @D32544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : COVER, 
   [COORD @D32549, AGR [COUNT @D32548, PER @D32547, PLU @D32546, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : COVER, 
   [COORD @D32555, PAST @D32554, AGR [CASE @D32553, COUNT @D32552, 
            PER @D32551, PLU @D32550, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : COVER, 
   [COORD @D32558, AGR [COUNT @D32557, PER @D32556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : COVER, 
   [COORD @D32560, AGR [COUNT @D32559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : COVER, 
   [COORD @D32562, AGR [COUNT @D32561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : COVER, 
   [COORD @D32566, AGR [COUNT @D32565, PER @D32564, PLU @D32563, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM FOR, ARITY 2] : COVER, 
   [COORD @D32572, PAST @D32571, 
      AGR [CASE @D32570, COUNT @D32569, PER @D32568, PLU @D32567, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM FOR, 
      ARITY 2] : COVER, 
   [COORD @D32575, AGR [COUNT @D32574, PER @D32573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COVER, 
   [COORD @D32577, AGR [COUNT @D32576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COVER, 
   [COORD @D32579, AGR [COUNT @D32578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : COVER, 
   [COORD @D32583, AGR [COUNT @D32582, PER @D32581, PLU @D32580, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : COVER, 
   [COORD @D32589, PAST @D32588, 
      AGR [CASE @D32587, COUNT @D32586, PER @D32585, PLU @D32584, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : COVER, 
   [COORD @D32592, AGR [COUNT @D32591, PER @D32590, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : COVER, 
   [COORD @D32594, AGR [COUNT @D32593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : COVER, 
   [COORD @D32596, AGR [COUNT @D32595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : COVER, 
   [COORD @D32600, AGR [COUNT @D32599, PER @D32598, PLU @D32597, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : COVER, 
   [COORD @D32606, PAST @D32605, 
      AGR [CASE @D32604, COUNT @D32603, PER @D32602, PLU @D32601, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : COVER, 
   [COORD @D32609, AGR [COUNT @D32608, PER @D32607, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COVER, 
   [COORD @D32611, AGR [COUNT @D32610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COVER, 
   [COORD @D32613, AGR [COUNT @D32612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COVER, 
   [COORD @D32617, AGR [COUNT @D32616, PER @D32615, PLU @D32614, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : COVER, 
   [COORD @D32623, PAST @D32622, AGR [CASE @D32621, COUNT @D32620, 
            PER @D32619, PLU @D32618, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : COVER, 
   [COORD @D32626, AGR [COUNT @D32625, PER @D32624, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COVER, 
   [COORD @D32628, AGR [COUNT @D32627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COVER, 
   [COORD @D32630, AGR [COUNT @D32629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COVER, 
   [COORD @D32634, AGR [COUNT @D32633, PER @D32632, PLU @D32631, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : COVER, 
   [COORD @D32640, PAST @D32639, 
      AGR [CASE @D32638, COUNT @D32637, PER @D32636, PLU @D32635, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : COVER, 
   [COORD @D32643, AGR [COUNT @D32642, PER @D32641, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : COVER, 
   [COORD @D32645, AGR [COUNT @D32644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : COVER, 
   [COORD @D32647, AGR [COUNT @D32646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : COVER, 
   [COORD @D32651, AGR [COUNT @D32650, PER @D32649, PLU @D32648, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : COVER, 
   [COORD @D32657, PAST @D32656, 
      AGR [CASE @D32655, COUNT @D32654, PER @D32653, PLU @D32652, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : COVER.

WORD coverage : 
   [COORD @D32669, REFL @D32668, PRD @D32667, CASE @D32666, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : COVERAGE, 
   [COORD @D32673, REFL @D32672, PRD @D32671, CASE @D32670, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : COVERAGE.

WORD covered : 
   [COORD @D32692, AGR [CASE @D32691, COUNT @D32690, PER @D32689, 
            PLU @D32688, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COVER, 
   [COORD @D32697, AGR [CASE @D32696, COUNT @D32695, PER @D32694, 
            PLU @D32693, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32702, AGR [CASE @D32701, COUNT @D32700, PER @D32699, 
            PLU @D32698, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COVER, 
   [COORD @D32707, AGR [CASE @D32706, COUNT @D32705, PER @D32704, 
            PLU @D32703, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32712, AGR [CASE @D32711, COUNT @D32710, PER @D32709, 
            PLU @D32708, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : COVER, 
   [COORD @D32717, AGR [CASE @D32716, COUNT @D32715, PER @D32714, 
            PLU @D32713, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32722, AGR [CASE @D32721, COUNT @D32720, PER @D32719, 
            PLU @D32718, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32727, AGR [CASE @D32726, COUNT @D32725, PER @D32724, 
            PLU @D32723, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32732, AGR [CASE @D32731, COUNT @D32730, PER @D32729, 
            PLU @D32728, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COVER, 
   [COORD @D32737, AGR [CASE @D32736, COUNT @D32735, PER @D32734, 
            PLU @D32733, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32742, AGR [CASE @D32741, COUNT @D32740, PER @D32739, 
            PLU @D32738, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COVER, 
   [COORD @D32747, AGR [CASE @D32746, COUNT @D32745, PER @D32744, 
            PLU @D32743, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32752, AGR [CASE @D32751, COUNT @D32750, PER @D32749, 
            PLU @D32748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32757, AGR [CASE @D32756, COUNT @D32755, PER @D32754, 
            PLU @D32753, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : COVER, 
   [COORD @D32762, AGR [CASE @D32761, COUNT @D32760, PER @D32759, 
            PLU @D32758, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32767, AGR [CASE @D32766, COUNT @D32765, PER @D32764, 
            PLU @D32763, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COVER, 
   [COORD @D32772, AGR [CASE @D32771, COUNT @D32770, PER @D32769, 
            PLU @D32768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32777, AGR [CASE @D32776, COUNT @D32775, PER @D32774, 
            PLU @D32773, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : COVER.

WORD covering : 
   [COORD @D32792, PRD @D32791, AGR [CASE @D32790, COUNT @D32789, 
            PER @D32788, PLU @D32787, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32798, PRD @D32797, 
      AGR [CASE @D32796, COUNT @D32795, PER @D32794, PLU @D32793, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : COVER, 
   [COORD @D32804, PRD @D32803, AGR [CASE @D32802, COUNT @D32801, 
            PER @D32800, PLU @D32799, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32810, PRD @D32809, 
      AGR [CASE @D32808, COUNT @D32807, PER @D32806, PLU @D32805, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COVER, 
   [COORD @D32816, PRD @D32815, AGR [CASE @D32814, COUNT @D32813, 
            PER @D32812, PLU @D32811, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : COVER, 
   [COORD @D32822, PRD @D32821, 
      AGR [CASE @D32820, COUNT @D32819, PER @D32818, PLU @D32817, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : COVER, 
   [COORD @D32828, PRD @D32827, AGR [CASE @D32826, COUNT @D32825, 
            PER @D32824, PLU @D32823, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : COVER.

WORD covers : 
   [COORD @D32838, DEMON @D32837, REFL @D32836, PRD @D32835, CASE 
         @D32834, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : COVER, 
   [COORD @D32843, DEMON @D32842, REFL @D32841, PRD @D32840, 
      CASE @D32839, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : COVER, 
   [COORD @D32845, AGR [COUNT @D32844, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COVER, 
   [COORD @D32847, 
      AGR [COUNT @D32846, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   COVER, 
   [COORD @D32849, AGR [COUNT @D32848, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COVER, 
   [COORD @D32851, 
      AGR [COUNT @D32850, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COVER, 
   [COORD @D32853, 
      AGR [COUNT @D32852, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COVER, 
   [COORD @D32855, 
      AGR [COUNT @D32854, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COVER, 
   [COORD @D32857, 
      AGR [COUNT @D32856, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : COVER.

WORD cream : 
   [COADV @D32869, COORD @D32868, DEF @D32867, PRD @D32866, AGR 
            [CASE @D32865, COUNT @D32864, PER @D32863, PLU @D32862, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CREAM, 
   
   [COORD @D32874, REFL @D32873, COUNT @D32872, PRD @D32871, CASE 
      @D32870, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CREAM, 
   [COORD @D32878, REFL @D32877, PRD @D32876, CASE @D32875, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN +, ADDRESS -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : CREAM, 
   [COORD @D32883, REFL @D32882, COUNT @D32881, PRD @D32880, 
      CASE @D32879, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, 
      PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CREAM, 
   [COORD @D32886, 
      AGR [COUNT @D32885, PER @D32884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   CREAM, 
   [COORD @D32888, AGR [COUNT @D32887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CREAM, 
   [COORD @D32890, AGR [COUNT @D32889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CREAM, 
   [COORD @D32894, AGR [COUNT @D32893, PER @D32892, PLU @D32891, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CREAM, 
   [COORD @D32900, PAST @D32899, AGR [CASE @D32898, COUNT @D32897, 
            PER @D32896, PLU @D32895, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CREAM, 
   [COORD @D32903, AGR [COUNT @D32902, PER @D32901, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CREAM, 
   [COORD @D32905, AGR [COUNT @D32904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CREAM, 
   [COORD @D32907, AGR [COUNT @D32906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : CREAM, 
   [COORD @D32911, AGR [COUNT @D32910, PER @D32909, PLU @D32908, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : CREAM, 
   [COORD @D32917, PAST @D32916, 
      AGR [CASE @D32915, COUNT @D32914, PER @D32913, PLU @D32912, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : CREAM, 
   [COORD @D32920, AGR [COUNT @D32919, PER @D32918, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CREAM, 
   [COORD @D32922, AGR [COUNT @D32921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CREAM, 
   [COORD @D32924, AGR [COUNT @D32923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CREAM, 
   [COORD @D32928, AGR [COUNT @D32927, PER @D32926, PLU @D32925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CREAM, 
   [COORD @D32934, PAST @D32933, 
      AGR [CASE @D32932, COUNT @D32931, PER @D32930, PLU @D32929, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : CREAM.

WORD creamed : 
   [COORD @D32946, AGR [CASE @D32945, COUNT @D32944, PER @D32943, 
            PLU @D32942, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CREAM, 
   [COORD @D32951, AGR [CASE @D32950, COUNT @D32949, PER @D32948, 
            PLU @D32947, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CREAM, 
   [COORD @D32956, AGR [CASE @D32955, COUNT @D32954, PER @D32953, 
            PLU @D32952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CREAM, 
   [COORD @D32961, AGR [CASE @D32960, COUNT @D32959, PER @D32958, 
            PLU @D32957, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CREAM, 
   [COORD @D32966, AGR [CASE @D32965, COUNT @D32964, PER @D32963, 
            PLU @D32962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CREAM, 
   [COORD @D32971, AGR [CASE @D32970, COUNT @D32969, PER @D32968, 
            PLU @D32967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CREAM, 
   [COORD @D32976, AGR [CASE @D32975, COUNT @D32974, PER @D32973, 
            PLU @D32972, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CREAM, 
   [COORD @D32981, AGR [CASE @D32980, COUNT @D32979, PER @D32978, 
            PLU @D32977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CREAM.

WORD creaming : 
   [COORD @D33000, PRD @D32999, AGR [CASE @D32998, COUNT @D32997, 
            PER @D32996, PLU @D32995, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CREAM, 
   [COORD @D33006, PRD @D33005, 
      AGR [CASE @D33004, COUNT @D33003, PER @D33002, PLU @D33001, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CREAM, 
   [COORD @D33012, PRD @D33011, AGR [CASE @D33010, COUNT @D33009, 
            PER @D33008, PLU @D33007, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CREAM.

WORD creams : 
   [COORD @D33024, DEMON @D33023, REFL @D33022, PRD @D33021, CASE 
         @D33020, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CREAM, 
   [COORD @D33029, DEMON @D33028, REFL @D33027, PRD @D33026, 
      CASE @D33025, COMPOUND NOT, FIX NOT, PN +, ADDRESS -, ADV -, PART -, 
      CONJ NULL, SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : CREAM, 
   [COORD @D33034, DEMON @D33033, REFL @D33032, PRD @D33031, 
      CASE @D33030, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : CREAM, 
   [COORD @D33036, AGR [COUNT @D33035, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CREAM, 
   [COORD @D33038, 
      AGR [COUNT @D33037, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CREAM, 
   [COORD @D33040, 
      AGR [COUNT @D33039, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CREAM.

WORD create : 
   [COORD @D33048, AGR [COUNT @D33047, PER @D33046, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : CREATE, 
   [COORD @D33050, AGR [COUNT @D33049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : CREATE, 
   [COORD @D33052, AGR [COUNT @D33051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : CREATE, 
   [COORD @D33056, AGR [COUNT @D33055, PER @D33054, PLU @D33053, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : CREATE, 
   [COORD @D33062, PAST @D33061, AGR [CASE @D33060, COUNT @D33059, 
            PER @D33058, PLU @D33057, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_NP, ARITY 3] : CREATE, 
   [COORD @D33065, AGR [COUNT @D33064, PER @D33063, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CREATE, 
   [COORD @D33067, AGR [COUNT @D33066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CREATE, 
   [COORD @D33069, AGR [COUNT @D33068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CREATE, 
   [COORD @D33073, AGR [COUNT @D33072, PER @D33071, PLU @D33070, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CREATE, 
   [COORD @D33079, PAST @D33078, AGR [CASE @D33077, COUNT @D33076, 
            PER @D33075, PLU @D33074, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CREATE, 
   [COORD @D33082, AGR [COUNT @D33081, PER @D33080, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CREATE, 
   [COORD @D33084, AGR [COUNT @D33083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CREATE, 
   [COORD @D33086, AGR [COUNT @D33085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CREATE, 
   [COORD @D33090, AGR [COUNT @D33089, PER @D33088, PLU @D33087, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CREATE, 
   [COORD @D33096, PAST @D33095, AGR [CASE @D33094, COUNT @D33093, 
            PER @D33092, PLU @D33091, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CREATE.

WORD created : 
   [COORD @D33107, AGR [CASE @D33106, COUNT @D33105, PER @D33104, 
            PLU @D33103, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CREATE, 
   [COORD @D33112, AGR [CASE @D33111, COUNT @D33110, PER @D33109, 
            PLU @D33108, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CREATE, 
   [COORD @D33117, AGR [CASE @D33116, COUNT @D33115, PER @D33114, 
            PLU @D33113, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CREATE, 
   [COORD @D33122, AGR [CASE @D33121, COUNT @D33120, PER @D33119, 
            PLU @D33118, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CREATE, 
   [COORD @D33127, AGR [CASE @D33126, COUNT @D33125, PER @D33124, 
            PLU @D33123, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CREATE, 
   [COORD @D33132, AGR [CASE @D33131, COUNT @D33130, PER @D33129, 
            PLU @D33128, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CREATE, 
   [COORD @D33137, AGR [CASE @D33136, COUNT @D33135, PER @D33134, 
            PLU @D33133, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CREATE, 
   [COORD @D33142, AGR [CASE @D33141, COUNT @D33140, PER @D33139, 
            PLU @D33138, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CREATE.

WORD creates : 
   [COORD @D33150, AGR [COUNT @D33149, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CREATE, 
   [COORD @D33152, 
      AGR [COUNT @D33151, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CREATE, 
   [COORD @D33154, 
      AGR [COUNT @D33153, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CREATE.

WORD creating : 
   [COORD @D33165, PRD @D33164, AGR [CASE @D33163, COUNT @D33162, 
            PER @D33161, PLU @D33160, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CREATE, 
   [COORD @D33171, PRD @D33170, 
      AGR [CASE @D33169, COUNT @D33168, PER @D33167, PLU @D33166, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CREATE, 
   [COORD @D33177, PRD @D33176, AGR [CASE @D33175, COUNT @D33174, 
            PER @D33173, PLU @D33172, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CREATE.

WORD cried : 
   [COORD @D33187, AGR [CASE @D33186, COUNT @D33185, PER @D33184, 
            PLU @D33183, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CRY, 
   [COORD @D33192, AGR [CASE @D33191, COUNT @D33190, PER @D33189, 
            PLU @D33188, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33197, AGR [CASE @D33196, COUNT @D33195, PER @D33194, 
            PLU @D33193, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33202, AGR [CASE @D33201, COUNT @D33200, PER @D33199, 
            PLU @D33198, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33207, AGR [CASE @D33206, COUNT @D33205, PER @D33204, 
            PLU @D33203, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33212, AGR [CASE @D33211, COUNT @D33210, PER @D33209, 
            PLU @D33208, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33217, AGR [CASE @D33216, COUNT @D33215, PER @D33214, 
            PLU @D33213, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33222, 
      AGR [CASE @D33221, COUNT @D33220, PER @D33219, PLU @D33218, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33227, AGR [CASE @D33226, COUNT @D33225, PER @D33224, 
            PLU @D33223, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OUT, PFORM AGAINST, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33232, AGR [CASE @D33231, COUNT @D33230, PER @D33229, 
            PLU @D33228, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM AGAINST, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33237, 
      AGR [CASE @D33236, COUNT @D33235, PER @D33234, PLU @D33233, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33242, AGR [CASE @D33241, COUNT @D33240, PER @D33239, 
            PLU @D33238, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33247, AGR [CASE @D33246, COUNT @D33245, PER @D33244, 
            PLU @D33243, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33252, AGR [CASE @D33251, COUNT @D33250, PER @D33249, 
            PLU @D33248, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33257, AGR [CASE @D33256, COUNT @D33255, PER @D33254, 
            PLU @D33253, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33262, AGR [CASE @D33261, COUNT @D33260, PER @D33259, 
            PLU @D33258, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33267, AGR [CASE @D33266, COUNT @D33265, PER @D33264, 
            PLU @D33263, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33272, AGR [CASE @D33271, COUNT @D33270, PER @D33269, 
            PLU @D33268, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33277, AGR [CASE @D33276, COUNT @D33275, PER @D33274, 
            PLU @D33273, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33282, AGR [CASE @D33281, COUNT @D33280, PER @D33279, 
            PLU @D33278, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33287, AGR [CASE @D33286, COUNT @D33285, PER @D33284, 
            PLU @D33283, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33292, AGR [CASE @D33291, COUNT @D33290, PER @D33289, 
            PLU @D33288, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33297, AGR [CASE @D33296, COUNT @D33295, PER @D33294, 
            PLU @D33293, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33302, AGR [CASE @D33301, COUNT @D33300, PER @D33299, 
            PLU @D33298, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33307, AGR [CASE @D33306, COUNT @D33305, PER @D33304, 
            PLU @D33303, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33312, AGR [CASE @D33311, COUNT @D33310, PER @D33309, 
            PLU @D33308, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33317, AGR [CASE @D33316, COUNT @D33315, PER @D33314, 
            PLU @D33313, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33322, AGR [CASE @D33321, COUNT @D33320, PER @D33319, 
            PLU @D33318, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY, 
   [COORD @D33327, AGR [CASE @D33326, COUNT @D33325, PER @D33324, 
            PLU @D33323, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33332, AGR [CASE @D33331, COUNT @D33330, PER @D33329, 
            PLU @D33328, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CRY.

WORD cries : 
   [COORD @D33339, AGR [COUNT @D33338, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33341, 
      AGR [COUNT @D33340, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33343, 
      AGR [COUNT @D33342, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CRY, 
   [COORD @D33345, AGR [COUNT @D33344, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CRY, 
   [COORD @D33347, AGR [COUNT @D33346, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33349, 
      AGR [COUNT @D33348, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33351, 
      AGR [COUNT @D33350, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33353, 
      AGR [COUNT @D33352, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33355, 
      AGR [COUNT @D33354, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33357, 
      AGR [COUNT @D33356, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33359, 
      AGR [COUNT @D33358, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY, 
   [COORD @D33361, 
      AGR [COUNT @D33360, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CRY.

WORD crime : 
   [COORD @D33371, REFL @D33370, PRD @D33369, CASE @D33368, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CRIME, 
   [COORD @D33376, REFL @D33375, COUNT @D33374, PRD @D33373, 
      CASE @D33372, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CRIME.

WORD crimes : 
   [COORD @D33388, DEMON @D33387, REFL @D33386, PRD @D33385, CASE 
         @D33384, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CRIME.

WORD crop : 
   [COORD @D33396, REFL @D33395, PRD @D33394, CASE @D33393, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : CROP, 
   [COORD @D33399, 
      AGR [COUNT @D33398, PER @D33397, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      ARITY 3] : CROP, 
   [COORD @D33401, AGR [COUNT @D33400, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : CROP, 
   [COORD @D33403, AGR [COUNT @D33402, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : CROP, 
   [COORD @D33407, AGR [COUNT @D33406, PER @D33405, PLU @D33404, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : CROP, 
   [COORD @D33413, PAST @D33412, AGR [CASE @D33411, COUNT @D33410, 
            PER @D33409, PLU @D33408, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : CROP, 
   [COORD @D33416, AGR [COUNT @D33415, PER @D33414, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CROP, 
   [COORD @D33418, AGR [COUNT @D33417, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CROP, 
   [COORD @D33420, AGR [COUNT @D33419, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CROP, 
   [COORD @D33424, AGR [COUNT @D33423, PER @D33422, PLU @D33421, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : CROP, 
   [COORD @D33430, PAST @D33429, 
      AGR [CASE @D33428, COUNT @D33427, PER @D33426, PLU @D33425, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : CROP, 
   [COORD @D33433, AGR [COUNT @D33432, PER @D33431, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CROP, 
   [COORD @D33435, AGR [COUNT @D33434, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CROP, 
   [COORD @D33437, AGR [COUNT @D33436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CROP, 
   [COORD @D33441, AGR [COUNT @D33440, PER @D33439, PLU @D33438, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CROP, 
   [COORD @D33447, PAST @D33446, AGR [CASE @D33445, COUNT @D33444, 
            PER @D33443, PLU @D33442, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CROP, 
   [COORD @D33450, AGR [COUNT @D33449, PER @D33448, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : CROP, 
   [COORD @D33452, AGR [COUNT @D33451, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : CROP, 
   [COORD @D33454, AGR [COUNT @D33453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : CROP, 
   [COORD @D33458, AGR [COUNT @D33457, PER @D33456, PLU @D33455, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : CROP, 
   [COORD @D33464, PAST @D33463, AGR [CASE @D33462, COUNT @D33461, 
            PER @D33460, PLU @D33459, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : CROP, 
   [COORD @D33467, AGR [COUNT @D33466, PER @D33465, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CROP, 
   [COORD @D33469, AGR [COUNT @D33468, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CROP, 
   [COORD @D33471, AGR [COUNT @D33470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CROP, 
   [COORD @D33475, AGR [COUNT @D33474, PER @D33473, PLU @D33472, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CROP, 
   [COORD @D33481, PAST @D33480, 
      AGR [CASE @D33479, COUNT @D33478, PER @D33477, PLU @D33476, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CROP, 
   [COORD @D33484, AGR [COUNT @D33483, PER @D33482, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CROP, 
   [COORD @D33486, AGR [COUNT @D33485, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CROP, 
   [COORD @D33488, AGR [COUNT @D33487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CROP, 
   [COORD @D33492, AGR [COUNT @D33491, PER @D33490, PLU @D33489, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CROP, 
   [COORD @D33498, PAST @D33497, 
      AGR [CASE @D33496, COUNT @D33495, PER @D33494, PLU @D33493, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CROP.

WORD cropped : 
   [COORD @D33509, AGR [CASE @D33508, COUNT @D33507, PER @D33506, 
            PLU @D33505, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33514, AGR [CASE @D33513, COUNT @D33512, PER @D33511, 
            PLU @D33510, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CROP, 
   [COORD @D33520, AGR [CASE @D33519, NFORM @D33518, COUNT @D33517, 
            PER @D33516, PLU @D33515, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CROP, 
   [COORD @D33525, AGR [CASE @D33524, COUNT @D33523, PER @D33522, 
            PLU @D33521, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33530, AGR [CASE @D33529, COUNT @D33528, PER @D33527, 
            PLU @D33526, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33535, AGR [CASE @D33534, COUNT @D33533, PER @D33532, 
            PLU @D33531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : CROP, 
   [COORD @D33540, AGR [CASE @D33539, COUNT @D33538, PER @D33537, 
            PLU @D33536, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CROP, 
   [COORD @D33545, AGR [CASE @D33544, COUNT @D33543, PER @D33542, 
            PLU @D33541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33550, AGR [CASE @D33549, COUNT @D33548, PER @D33547, 
            PLU @D33546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CROP, 
   [COORD @D33555, AGR [CASE @D33554, COUNT @D33553, PER @D33552, 
            PLU @D33551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33560, AGR [CASE @D33559, COUNT @D33558, PER @D33557, 
            PLU @D33556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : CROP, 
   [COORD @D33565, AGR [CASE @D33564, COUNT @D33563, PER @D33562, 
            PLU @D33561, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33570, AGR [CASE @D33569, COUNT @D33568, PER @D33567, 
            PLU @D33566, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CROP, 
   [COORD @D33575, AGR [CASE @D33574, COUNT @D33573, PER @D33572, 
            PLU @D33571, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33580, AGR [CASE @D33579, COUNT @D33578, PER @D33577, 
            PLU @D33576, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : CROP.

WORD cropping : 
   [COORD @D33592, PRD @D33591, AGR [CASE @D33590, COUNT @D33589, 
            PER @D33588, PLU @D33587, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33598, PRD @D33597, 
      AGR [CASE @D33596, COUNT @D33595, PER @D33594, PLU @D33593, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CROP, 
   [COORD @D33604, PRD @D33603, AGR [CASE @D33602, COUNT @D33601, 
            PER @D33600, PLU @D33599, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33610, PRD @D33609, 
      AGR [CASE @D33608, COUNT @D33607, PER @D33606, PLU @D33605, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   CROP, 
   [COORD @D33616, PRD @D33615, AGR [CASE @D33614, COUNT @D33613, 
            PER @D33612, PLU @D33611, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CROP, 
   [COORD @D33622, PRD @D33621, 
      AGR [CASE @D33620, COUNT @D33619, PER @D33618, PLU @D33617, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CROP.

WORD crops : 
   [COORD @D33633, DEMON @D33632, REFL @D33631, PRD @D33630, CASE 
         @D33629, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CROP, 
   [COORD @D33635, 
      AGR [COUNT @D33634, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CROP, 
   [COORD @D33637, 
      AGR [COUNT @D33636, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CROP, 
   [COORD @D33639, AGR [COUNT @D33638, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CROP, 
   [COORD @D33641, 
      AGR [COUNT @D33640, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CROP, 
   [COORD @D33643, 
      AGR [COUNT @D33642, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CROP, 
   [COORD @D33645, 
      AGR [COUNT @D33644, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CROP.

WORD cry : 
   [COORD @D33656, AGR [COUNT @D33655, PER @D33654, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CRY, 
   [COORD @D33658, AGR [COUNT @D33657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CRY, 
   [COORD @D33660, AGR [COUNT @D33659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : CRY, 
   [COORD @D33664, AGR [COUNT @D33663, PER @D33662, PLU @D33661, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : CRY, 
   [COORD @D33670, PAST @D33669, AGR [CASE @D33668, COUNT @D33667, 
            PER @D33666, PLU @D33665, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : CRY, 
   [COORD @D33673, AGR [COUNT @D33672, PER @D33671, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33675, AGR [COUNT @D33674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33677, AGR [COUNT @D33676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33681, AGR [COUNT @D33680, PER @D33679, PLU @D33678, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33687, PAST @D33686, 
      AGR [CASE @D33685, COUNT @D33684, PER @D33683, PLU @D33682, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : CRY, 
   [COORD @D33690, AGR [COUNT @D33689, PER @D33688, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33692, AGR [COUNT @D33691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33694, AGR [COUNT @D33693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33698, AGR [COUNT @D33697, PER @D33696, PLU @D33695, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33704, PAST @D33703, 
      AGR [CASE @D33702, COUNT @D33701, PER @D33700, PLU @D33699, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM FOR, ARITY 2] : CRY, 
   [COORD @D33707, AGR [COUNT @D33706, PER @D33705, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM AGAINST, ARITY 2] : CRY, 
   [COORD @D33709, AGR [COUNT @D33708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM AGAINST, ARITY 2] : CRY, 
   [COORD @D33711, AGR [COUNT @D33710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM AGAINST, ARITY 2] : CRY, 
   [COORD @D33715, AGR [COUNT @D33714, PER @D33713, PLU @D33712, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM AGAINST, ARITY 2] : CRY, 
   [COORD @D33721, PAST @D33720, 
      AGR [CASE @D33719, COUNT @D33718, PER @D33717, PLU @D33716, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM AGAINST, ARITY 2] : CRY, 
   [COORD @D33724, AGR [COUNT @D33723, PER @D33722, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CRY, 
   [COORD @D33726, AGR [COUNT @D33725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CRY, 
   [COORD @D33728, AGR [COUNT @D33727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : CRY, 
   [COORD @D33732, AGR [COUNT @D33731, PER @D33730, PLU @D33729, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : CRY, 
   [COORD @D33738, PAST @D33737, 
      AGR [CASE @D33736, COUNT @D33735, PER @D33734, PLU @D33733, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : CRY, 
   [COORD @D33741, AGR [COUNT @D33740, PER @D33739, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CRY, 
   [COORD @D33743, AGR [COUNT @D33742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CRY, 
   [COORD @D33745, AGR [COUNT @D33744, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : CRY, 
   [COORD @D33749, AGR [COUNT @D33748, PER @D33747, PLU @D33746, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : CRY, 
   [COORD @D33755, PAST @D33754, 
      AGR [CASE @D33753, COUNT @D33752, PER @D33751, PLU @D33750, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : CRY, 
   [COORD @D33758, AGR [COUNT @D33757, PER @D33756, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CRY, 
   [COORD @D33760, AGR [COUNT @D33759, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CRY, 
   [COORD @D33762, AGR [COUNT @D33761, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CRY, 
   [COORD @D33766, AGR [COUNT @D33765, PER @D33764, PLU @D33763, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : CRY, 
   [COORD @D33772, PAST @D33771, 
      AGR [CASE @D33770, COUNT @D33769, PER @D33768, PLU @D33767, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : CRY, 
   [COORD @D33775, AGR [COUNT @D33774, PER @D33773, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CRY, 
   [COORD @D33777, AGR [COUNT @D33776, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CRY, 
   [COORD @D33779, AGR [COUNT @D33778, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CRY, 
   [COORD @D33783, AGR [COUNT @D33782, PER @D33781, PLU @D33780, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : CRY, 
   [COORD @D33789, PAST @D33788, AGR [CASE @D33787, COUNT @D33786, 
            PER @D33785, PLU @D33784, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : CRY, 
   [COORD @D33792, AGR [COUNT @D33791, PER @D33790, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CRY, 
   [COORD @D33794, AGR [COUNT @D33793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CRY, 
   [COORD @D33796, AGR [COUNT @D33795, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CRY, 
   [COORD @D33800, AGR [COUNT @D33799, PER @D33798, PLU @D33797, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : CRY, 
   [COORD @D33806, PAST @D33805, 
      AGR [CASE @D33804, COUNT @D33803, PER @D33802, PLU @D33801, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : CRY, 
   [COORD @D33809, AGR [COUNT @D33808, PER @D33807, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CRY, 
   [COORD @D33811, AGR [COUNT @D33810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CRY, 
   [COORD @D33813, AGR [COUNT @D33812, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CRY, 
   [COORD @D33817, AGR [COUNT @D33816, PER @D33815, PLU @D33814, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : CRY, 
   [COORD @D33823, PAST @D33822, 
      AGR [CASE @D33821, COUNT @D33820, PER @D33819, PLU @D33818, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : CRY, 
   [COORD @D33826, AGR [COUNT @D33825, PER @D33824, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CRY, 
   [COORD @D33828, AGR [COUNT @D33827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CRY, 
   [COORD @D33830, AGR [COUNT @D33829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CRY, 
   [COORD @D33834, AGR [COUNT @D33833, PER @D33832, PLU @D33831, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : CRY, 
   [COORD @D33840, PAST @D33839, 
      AGR [CASE @D33838, COUNT @D33837, PER @D33836, PLU @D33835, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : CRY, 
   [COORD @D33843, AGR [COUNT @D33842, PER @D33841, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CRY, 
   [COORD @D33845, AGR [COUNT @D33844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CRY, 
   [COORD @D33847, AGR [COUNT @D33846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CRY, 
   [COORD @D33851, AGR [COUNT @D33850, PER @D33849, PLU @D33848, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : CRY, 
   [COORD @D33857, PAST @D33856, 
      AGR [CASE @D33855, COUNT @D33854, PER @D33853, PLU @D33852, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : CRY.

WORD crying : 
   [COADV @D33872, COORD @D33871, DEF @D33870, PRD @D33869, AGR 
            [CASE @D33868, COUNT @D33867, PER @D33866, PLU @D33865, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : CRYING, 
   [COORD @D33878, PRD @D33877, AGR [CASE @D33876, COUNT @D33875, 
            PER @D33874, PLU @D33873, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33884, PRD @D33883, AGR 
         [CASE @D33882, COUNT @D33881, PER @D33880, PLU @D33879, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CRY, 
   [COORD @D33890, PRD @D33889, AGR [CASE @D33888, COUNT @D33887, 
            PER @D33886, PLU @D33885, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33896, PRD @D33895, 
      AGR [CASE @D33894, COUNT @D33893, PER @D33892, PLU @D33891, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CRY, 
   [COORD @D33902, PRD @D33901, AGR [CASE @D33900, COUNT @D33899, 
            PER @D33898, PLU @D33897, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33908, PRD @D33907, 
      AGR [CASE @D33906, COUNT @D33905, PER @D33904, PLU @D33903, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CRY, 
   [COORD @D33914, PRD @D33913, AGR [CASE @D33912, COUNT @D33911, 
            PER @D33910, PLU @D33909, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33920, PRD @D33919, 
      AGR [CASE @D33918, COUNT @D33917, PER @D33916, PLU @D33915, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   
   [COORD @D33926, PRD @D33925, AGR [CASE @D33924, COUNT @D33923, PER 
               @D33922, PLU @D33921, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33932, PRD @D33931, 
      AGR [CASE @D33930, COUNT @D33929, PER @D33928, PLU @D33927, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CRY, 
   [COORD @D33938, PRD @D33937, AGR [CASE @D33936, COUNT @D33935, 
            PER @D33934, PLU @D33933, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CRY, 
   [COORD @D33944, PRD @D33943, 
      AGR [CASE @D33942, COUNT @D33941, PER @D33940, PLU @D33939, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CRY.

WORD cut : 
   [COORD @D33951, REFL @D33950, PRD @D33949, CASE @D33948, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM AT, COUNT +] : CUT, 
   [COORD @D33956, REFL @D33955, COUNT @D33954, PRD @D33953, 
      CASE @D33952, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CUT, 
   [COORD @D33960, REFL @D33959, PRD @D33958, CASE @D33957, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, COUNT +] : CUT, 
   [COORD @D33964, REFL @D33963, PRD @D33962, CASE @D33961, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : CUT, 
   [COORD @D33969, REFL @D33968, COUNT @D33967, PRD @D33966, 
      CASE @D33965, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : CUT, 
   [COORD @D33972, 
      AGR [COUNT @D33971, PER @D33970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   CUT, 
   [COORD @D33974, AGR [COUNT @D33973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : CUT, 
   [COORD @D33976, AGR [COUNT @D33975, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : CUT, 
   [COORD @D33980, AGR [COUNT @D33979, PER @D33978, PLU @D33977, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : CUT, 
   [COORD @D33986, PAST @D33985, 
      AGR [CASE @D33984, COUNT @D33983, PER @D33982, PLU @D33981, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   CUT, 
   [COORD @D33989, AGR [COUNT @D33988, PER @D33987, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OFF, ARITY 3] : CUT, 
   [COORD @D33991, AGR [COUNT @D33990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OFF, ARITY 3] : CUT, 
   [COORD @D33993, AGR [COUNT @D33992, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OFF, ARITY 3] : CUT, 
   [COORD @D33997, AGR [COUNT @D33996, PER @D33995, PLU @D33994, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT OFF, ARITY 3] : CUT, 
   [COORD @D34003, PAST @D34002, 
      AGR [CASE @D34001, COUNT @D34000, PER @D33999, PLU @D33998, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT OFF, 
      ARITY 3] : CUT, 
   [COORD @D34006, AGR [COUNT @D34005, PER @D34004, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : CUT, 
   [COORD @D34008, AGR [COUNT @D34007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : CUT, 
   [COORD @D34010, AGR [COUNT @D34009, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : CUT, 
   [COORD @D34014, AGR [COUNT @D34013, PER @D34012, PLU @D34011, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM TO, ARITY 3] : CUT, 
   [COORD @D34020, PAST @D34019, 
      AGR [CASE @D34018, COUNT @D34017, PER @D34016, PLU @D34015, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT DOWN, 
      PFORM TO, ARITY 3] : CUT, 
   [COORD @D34023, AGR [COUNT @D34022, PER @D34021, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34025, AGR [COUNT @D34024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34027, AGR [COUNT @D34026, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34031, AGR [COUNT @D34030, PER @D34029, PLU @D34028, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34037, PAST @D34036, 
      AGR [CASE @D34035, COUNT @D34034, PER @D34033, PLU @D34032, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : CUT, 
   [COORD @D34040, AGR [COUNT @D34039, PER @D34038, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34042, AGR [COUNT @D34041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34044, AGR [COUNT @D34043, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34048, AGR [COUNT @D34047, PER @D34046, PLU @D34045, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PRT OFF, PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34054, PAST @D34053, 
      AGR [CASE @D34052, COUNT @D34051, PER @D34050, PLU @D34049, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PRT OFF, 
      PFORM FOR, ARITY 3] : CUT, 
   [COORD @D34057, AGR [COUNT @D34056, PER @D34055, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : CUT, 
   [COORD @D34059, AGR [COUNT @D34058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : CUT, 
   [COORD @D34061, AGR [COUNT @D34060, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : CUT, 
   [COORD @D34065, AGR [COUNT @D34064, PER @D34063, PLU @D34062, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, ARITY 3] : CUT, 
   [COORD @D34071, PAST @D34070, 
      AGR [CASE @D34069, COUNT @D34068, PER @D34067, PLU @D34066, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, ARITY 3] : CUT, 
   [COORD @D34074, AGR [COUNT @D34073, PER @D34072, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM FROM, ARITY 3] : CUT, 
   [COORD @D34076, AGR [COUNT @D34075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM FROM, ARITY 3] : CUT, 
   [COORD @D34078, AGR [COUNT @D34077, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM FROM, ARITY 3] : CUT, 
   [COORD @D34082, AGR [COUNT @D34081, PER @D34080, PLU @D34079, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM FROM, ARITY 3] : CUT, 
   [COORD @D34088, PAST @D34087, 
      AGR [CASE @D34086, COUNT @D34085, PER @D34084, PLU @D34083, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM FROM, ARITY 3] : CUT, 
   [COORD @D34094, PAST @D34093, AGR [CASE @D34092, COUNT @D34091, 
            PER @D34090, PLU @D34089, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : CUT, 
   [COORD @D34100, PAST @D34099, 
      AGR [CASE @D34098, COUNT @D34097, PER @D34096, PLU @D34095, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : CUT, 
   [COORD @D34106, PAST @D34105, 
      AGR [CASE @D34104, COUNT @D34103, PER @D34102, PLU @D34101, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT OFF, 
      FIN -, ARITY 3] : CUT, 
   [COORD @D34112, PAST @D34111, AGR [CASE @D34110, COUNT @D34109, 
            PER @D34108, PLU @D34107, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT OFF, FIN -, ARITY 3] : CUT, 
   [COORD @D34118, PAST @D34117, 
      AGR [CASE @D34116, COUNT @D34115, PER @D34114, PLU @D34113, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT DOWN, 
      PFORM TO, FIN -, ARITY 3] : CUT, 
   [COORD @D34124, PAST @D34123, AGR [CASE @D34122, COUNT @D34121, 
            PER @D34120, PLU @D34119, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM TO, FIN -, ARITY 3] : CUT, 
   [COORD @D34130, PAST @D34129, 
      AGR [CASE @D34128, COUNT @D34127, PER @D34126, PLU @D34125, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, FIN -, 
      ARITY 3] : CUT, 
   [COORD @D34136, PAST @D34135, AGR [CASE @D34134, COUNT @D34133, 
            PER @D34132, PLU @D34131, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : CUT, 
   [COORD @D34142, PAST @D34141, 
      AGR [CASE @D34140, COUNT @D34139, PER @D34138, PLU @D34137, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PRT OFF, PFORM FOR, 
      FIN -, ARITY 3] : CUT, 
   [COORD @D34148, PAST @D34147, AGR [CASE @D34146, COUNT @D34145, 
            PER @D34144, PLU @D34143, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PRT OFF, PFORM FOR, FIN -, ARITY 3] : CUT, 
   [COORD @D34154, PAST @D34153, 
      AGR [CASE @D34152, COUNT @D34151, PER @D34150, PLU @D34149, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 3] : CUT, 
   [COORD @D34160, PAST @D34159, AGR [CASE @D34158, COUNT @D34157, 
            PER @D34156, PLU @D34155, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : CUT, 
   [COORD @D34166, PAST @D34165, 
      AGR [CASE @D34164, COUNT @D34163, PER @D34162, PLU @D34161, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM FROM, FIN -, ARITY 3] : CUT, 
   [COORD @D34172, PAST @D34171, AGR [CASE @D34170, COUNT @D34169, 
            PER @D34168, PLU @D34167, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM FROM, FIN -, ARITY 3] : CUT, 
   [COORD @D34176, 
      AGR [COUNT @D34175, PER @D34174, PLU @D34173, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : CUT, 
   [COORD @D34180, AGR [COUNT @D34179, PER @D34178, PLU @D34177, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT OFF, PAST +, ARITY 3] : CUT, 
   [COORD @D34184, AGR [COUNT @D34183, PER @D34182, PLU @D34181, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PRT DOWN, PFORM TO, PAST +, ARITY 3] : CUT, 
   [COORD @D34188, AGR [COUNT @D34187, PER @D34186, PLU @D34185, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, PAST +, ARITY 3] : CUT, 
   [COORD @D34192, AGR [COUNT @D34191, PER @D34190, PLU @D34189, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, PAST +, ARITY 3] : CUT, 
   [COORD @D34196, AGR 
         [COUNT @D34195, PER @D34194, PLU @D34193, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PFORM OF, PAST +, ARITY 3] : CUT, 
   [COORD @D34200, AGR [COUNT @D34199, PER @D34198, PLU @D34197, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PFORM FROM, PAST +, ARITY 3] : CUT, 
   [COORD @D34203, AGR [COUNT @D34202, PER @D34201, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : CUT, 
   [COORD @D34205, AGR [COUNT @D34204, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : CUT, 
   [COORD @D34207, AGR [COUNT @D34206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : CUT, 
   [COORD @D34211, AGR [COUNT @D34210, PER @D34209, PLU @D34208, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : CUT, 
   [COORD @D34217, PAST @D34216, AGR [CASE @D34215, COUNT @D34214, 
            PER @D34213, PLU @D34212, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : CUT, 
   [COORD @D34220, AGR [COUNT @D34219, PER @D34218, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : CUT, 
   [COORD @D34222, AGR [COUNT @D34221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : CUT, 
   [COORD @D34224, AGR [COUNT @D34223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : CUT, 
   [COORD @D34228, AGR [COUNT @D34227, PER @D34226, PLU @D34225, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : CUT, 
   [COORD @D34234, PAST @D34233, AGR [CASE @D34232, COUNT @D34231, 
            PER @D34230, PLU @D34229, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : CUT, 
   [COORD @D34237, AGR [COUNT @D34236, PER @D34235, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34239, AGR [COUNT @D34238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34241, AGR [COUNT @D34240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34245, AGR [COUNT @D34244, PER @D34243, PLU @D34242, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT IN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34251, PAST @D34250, 
      AGR [CASE @D34249, COUNT @D34248, PER @D34247, PLU @D34246, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM ON, ARITY 2] : CUT, 
   [COORD @D34254, AGR [COUNT @D34253, PER @D34252, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34256, AGR [COUNT @D34255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34258, AGR [COUNT @D34257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34262, AGR [COUNT @D34261, PER @D34260, PLU @D34259, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34268, PAST @D34267, 
      AGR [CASE @D34266, COUNT @D34265, PER @D34264, PLU @D34263, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM ON, ARITY 2] : CUT, 
   [COORD @D34271, AGR [COUNT @D34270, PER @D34269, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34273, AGR [COUNT @D34272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34275, AGR [COUNT @D34274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34279, AGR [COUNT @D34278, PER @D34277, PLU @D34276, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT BACK, PFORM ON, ARITY 2] : CUT, 
   [COORD @D34285, PAST @D34284, 
      AGR [CASE @D34283, COUNT @D34282, PER @D34281, PLU @D34280, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, 
      PFORM ON, ARITY 2] : CUT, 
   [COORD @D34288, AGR [COUNT @D34287, PER @D34286, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : CUT, 
   [COORD @D34290, AGR [COUNT @D34289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : CUT, 
   [COORD @D34292, AGR [COUNT @D34291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : CUT, 
   [COORD @D34296, AGR [COUNT @D34295, PER @D34294, PLU @D34293, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : CUT, 
   [COORD @D34302, PAST @D34301, AGR [CASE @D34300, COUNT @D34299, 
            PER @D34298, PLU @D34297, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : CUT, 
   [COORD @D34305, 
      AGR [COUNT @D34304, PER @D34303, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ACROSS, 
      ARITY 2] : CUT, 
   [COORD @D34307, AGR [COUNT @D34306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : CUT, 
   [COORD @D34309, AGR [COUNT @D34308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : CUT, 
   [COORD @D34313, AGR [COUNT @D34312, PER @D34311, PLU @D34310, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ACROSS, ARITY 2] : CUT, 
   [COORD @D34319, PAST @D34318, 
      AGR [CASE @D34317, COUNT @D34316, PER @D34315, PLU @D34314, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ACROSS, 
      ARITY 2] : CUT, 
   [COORD @D34322, AGR [COUNT @D34321, PER @D34320, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : CUT, 
   [COORD @D34324, AGR [COUNT @D34323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : CUT, 
   [COORD @D34326, AGR [COUNT @D34325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : CUT, 
   [COORD @D34330, AGR [COUNT @D34329, PER @D34328, PLU @D34327, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : CUT, 
   [COORD @D34336, PAST @D34335, 
      AGR [CASE @D34334, COUNT @D34333, PER @D34332, PLU @D34331, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : CUT, 
   [COORD @D34339, AGR [COUNT @D34338, PER @D34337, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : CUT, 
   [COORD @D34341, AGR [COUNT @D34340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : CUT, 
   [COORD @D34343, AGR [COUNT @D34342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : CUT, 
   [COORD @D34347, AGR [COUNT @D34346, PER @D34345, PLU @D34344, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : CUT, 
   [COORD @D34353, PAST @D34352, 
      AGR [CASE @D34351, COUNT @D34350, PER @D34349, PLU @D34348, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : CUT, 
   [COORD @D34356, AGR [COUNT @D34355, PER @D34354, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : CUT, 
   [COORD @D34358, AGR [COUNT @D34357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : CUT, 
   [COORD @D34360, AGR [COUNT @D34359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : CUT, 
   [COORD @D34364, AGR [COUNT @D34363, PER @D34362, PLU @D34361, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : CUT, 
   [COORD @D34370, PAST @D34369, 
      AGR [CASE @D34368, COUNT @D34367, PER @D34366, PLU @D34365, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : CUT, 
   [COORD @D34373, AGR [COUNT @D34372, PER @D34371, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : CUT, 
   [COORD @D34375, AGR [COUNT @D34374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : CUT, 
   [COORD @D34377, AGR [COUNT @D34376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : CUT, 
   [COORD @D34381, AGR [COUNT @D34380, PER @D34379, PLU @D34378, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : CUT, 
   [COORD @D34387, PAST @D34386, 
      AGR [CASE @D34385, COUNT @D34384, PER @D34383, PLU @D34382, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : CUT, 
   [COORD @D34390, AGR [COUNT @D34389, PER @D34388, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : CUT, 
   [COORD @D34392, AGR [COUNT @D34391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : CUT, 
   [COORD @D34394, AGR [COUNT @D34393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : CUT, 
   [COORD @D34398, AGR [COUNT @D34397, PER @D34396, PLU @D34395, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : CUT, 
   [COORD @D34404, PAST @D34403, 
      AGR [CASE @D34402, COUNT @D34401, PER @D34400, PLU @D34399, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : CUT, 
   [COORD @D34407, AGR [COUNT @D34406, PER @D34405, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : CUT, 
   [COORD @D34409, AGR [COUNT @D34408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : CUT, 
   [COORD @D34411, AGR [COUNT @D34410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : CUT, 
   [COORD @D34415, AGR [COUNT @D34414, PER @D34413, PLU @D34412, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, ARITY 2] : CUT, 
   [COORD @D34421, PAST @D34420, 
      AGR [CASE @D34419, COUNT @D34418, PER @D34417, PLU @D34416, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : CUT, 
   [COORD @D34427, PAST @D34426, AGR [CASE @D34425, COUNT @D34424, 
            PER @D34423, PLU @D34422, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : CUT, 
   [COORD @D34433, PAST @D34432, 
      AGR [CASE @D34431, COUNT @D34430, PER @D34429, PLU @D34428, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : CUT, 
   [COORD @D34439, PAST @D34438, 
      AGR [CASE @D34437, COUNT @D34436, PER @D34435, PLU @D34434, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, FIN -, ARITY 2] : CUT, 
   [COORD @D34445, PAST @D34444, 
      AGR [CASE @D34443, COUNT @D34442, PER @D34441, PLU @D34440, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, PFORM ON, FIN -, 
      ARITY 2] : CUT, 
   [COORD @D34451, PAST @D34450, AGR [CASE @D34449, COUNT @D34448, 
            PER @D34447, PLU @D34446, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT DOWN, PFORM ON, FIN -, ARITY 2] : CUT, 
   [COORD @D34457, PAST @D34456, 
      AGR [CASE @D34455, COUNT @D34454, PER @D34453, PLU @D34452, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, PFORM ON, FIN -, 
      ARITY 2] : CUT, 
   [COORD @D34463, PAST @D34462, AGR [CASE @D34461, COUNT @D34460, 
            PER @D34459, PLU @D34458, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AT, FIN -, ARITY 2] : CUT, 
   [COORD @D34469, PAST @D34468, 
      AGR [CASE @D34467, COUNT @D34466, PER @D34465, PLU @D34464, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, FIN -, 
      ARITY 2] : CUT, 
   [COORD @D34475, PAST @D34474, AGR [CASE @D34473, COUNT @D34472, 
            PER @D34471, PLU @D34470, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ACROSS, FIN -, ARITY 2] : CUT, 
   [COORD @D34481, PAST @D34480, 
      AGR [CASE @D34479, COUNT @D34478, PER @D34477, PLU @D34476, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ACROSS, FIN -, 
      ARITY 2] : CUT, 
   [COORD @D34487, PAST @D34486, AGR [CASE @D34485, COUNT @D34484, 
            PER @D34483, PLU @D34482, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : CUT, 
   [COORD @D34493, PAST @D34492, 
      AGR [CASE @D34491, COUNT @D34490, PER @D34489, PLU @D34488, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : CUT, 
   [COORD @D34499, PAST @D34498, AGR [CASE @D34497, COUNT @D34496, 
            PER @D34495, PLU @D34494, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : CUT, 
   [COORD @D34505, PAST @D34504, 
      AGR [CASE @D34503, COUNT @D34502, PER @D34501, PLU @D34500, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : CUT, 
   [COORD @D34511, PAST @D34510, AGR [CASE @D34509, COUNT @D34508, 
            PER @D34507, PLU @D34506, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : CUT, 
   [COORD @D34517, PAST @D34516, 
      AGR [CASE @D34515, COUNT @D34514, PER @D34513, PLU @D34512, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : CUT, 
   [COORD @D34523, PAST @D34522, AGR [CASE @D34521, COUNT @D34520, 
            PER @D34519, PLU @D34518, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : CUT, 
   [COORD @D34529, PAST @D34528, 
      AGR [CASE @D34527, COUNT @D34526, PER @D34525, PLU @D34524, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      FIN -, ARITY 2] : CUT, 
   [COORD @D34535, PAST @D34534, AGR [CASE @D34533, COUNT @D34532, 
            PER @D34531, PLU @D34530, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : CUT, 
   [COORD @D34541, PAST @D34540, 
      AGR [CASE @D34539, COUNT @D34538, PER @D34537, PLU @D34536, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      FIN -, ARITY 2] : CUT, 
   [COORD @D34547, PAST @D34546, AGR [CASE @D34545, COUNT @D34544, 
            PER @D34543, PLU @D34542, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, FIN -, ARITY 2] : CUT, 
   [COORD @D34553, PAST @D34552, 
      AGR [CASE @D34551, COUNT @D34550, PER @D34549, PLU @D34548, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, 
      FIN -, ARITY 2] : CUT, 
   [COORD @D34557, AGR [COUNT @D34556, PER @D34555, PLU @D34554, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : CUT, 
   [COORD @D34561, AGR [COUNT @D34560, PER @D34559, PLU @D34558, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, PAST +, 
      ARITY 2] : CUT, 
   [COORD @D34565, AGR [COUNT @D34564, PER @D34563, PLU @D34562, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM ON, PAST +, ARITY 2] : CUT, 
   [COORD @D34569, AGR [COUNT @D34568, PER @D34567, PLU @D34566, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, PAST +, ARITY 2] : CUT, 
   [COORD @D34573, AGR [COUNT @D34572, PER @D34571, PLU @D34570, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, PAST +, ARITY 2] : CUT, 
   [COORD @D34577, AGR [COUNT @D34576, PER @D34575, PLU @D34574, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, PAST +, ARITY 2] : CUT, 
   [COORD @D34581, AGR [COUNT @D34580, PER @D34579, PLU @D34578, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, PAST +, ARITY 2] : CUT, 
   [COORD @D34585, AGR [COUNT @D34584, PER @D34583, PLU @D34582, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : CUT, 
   [COORD @D34589, AGR [COUNT @D34588, PER @D34587, PLU @D34586, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : CUT, 
   [COORD @D34593, AGR [COUNT @D34592, PER @D34591, PLU @D34590, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : CUT, 
   [COORD @D34597, AGR [COUNT @D34596, PER @D34595, PLU @D34594, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PAST +, ARITY 2] : CUT, 
   [COORD @D34601, AGR [COUNT @D34600, PER @D34599, PLU @D34598, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PAST +, ARITY 2] : CUT, 
   [COORD @D34605, AGR [COUNT @D34604, PER @D34603, PLU @D34602, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, PAST +, ARITY 2] : CUT, 
   [COORD @D34608, AGR [COUNT @D34607, PER @D34606, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : CUT, 
   [COORD @D34610, AGR [COUNT @D34609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : CUT, 
   [COORD @D34612, AGR [COUNT @D34611, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : CUT, 
   [COORD @D34616, AGR [COUNT @D34615, PER @D34614, PLU @D34613, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : CUT, 
   [COORD @D34622, PAST @D34621, AGR 
         [CASE @D34620, COUNT @D34619, PER @D34618, PLU @D34617, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   CUT, 
   [COORD @D34625, AGR [COUNT @D34624, PER @D34623, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : CUT, 
   [COORD @D34627, AGR [COUNT @D34626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : CUT, 
   [COORD @D34629, AGR [COUNT @D34628, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : CUT, 
   [COORD @D34633, AGR [COUNT @D34632, PER @D34631, PLU @D34630, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : CUT, 
   [COORD @D34639, PAST @D34638, 
      AGR [CASE @D34637, COUNT @D34636, PER @D34635, PLU @D34634, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : CUT, 
   [COORD @D34642, AGR [COUNT @D34641, PER @D34640, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : CUT, 
   [COORD @D34644, AGR [COUNT @D34643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : CUT, 
   [COORD @D34646, AGR [COUNT @D34645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : CUT, 
   [COORD @D34650, AGR [COUNT @D34649, PER @D34648, PLU @D34647, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : CUT, 
   [COORD @D34656, PAST @D34655, 
      AGR [CASE @D34654, COUNT @D34653, PER @D34652, PLU @D34651, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : CUT, 
   [COORD @D34659, AGR [COUNT @D34658, PER @D34657, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : CUT, 
   [COORD @D34661, AGR [COUNT @D34660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : CUT, 
   [COORD @D34663, AGR [COUNT @D34662, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : CUT, 
   [COORD @D34667, AGR [COUNT @D34666, PER @D34665, PLU @D34664, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : CUT, 
   [COORD @D34673, PAST @D34672, 
      AGR [CASE @D34671, COUNT @D34670, PER @D34669, PLU @D34668, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : CUT, 
   [COORD @D34676, AGR [COUNT @D34675, PER @D34674, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : CUT, 
   [COORD @D34678, AGR [COUNT @D34677, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : CUT, 
   [COORD @D34680, AGR [COUNT @D34679, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : CUT, 
   [COORD @D34684, AGR [COUNT @D34683, PER @D34682, PLU @D34681, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : CUT, 
   [COORD @D34690, PAST @D34689, 
      AGR [CASE @D34688, COUNT @D34687, PER @D34686, PLU @D34685, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : CUT, 
   [COORD @D34693, AGR [COUNT @D34692, PER @D34691, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : CUT, 
   [COORD @D34695, AGR [COUNT @D34694, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : CUT, 
   [COORD @D34697, AGR [COUNT @D34696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : CUT, 
   [COORD @D34701, AGR [COUNT @D34700, PER @D34699, PLU @D34698, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : CUT, 
   [COORD @D34707, PAST @D34706, 
      AGR [CASE @D34705, COUNT @D34704, PER @D34703, PLU @D34702, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : CUT, 
   [COORD @D34710, AGR [COUNT @D34709, PER @D34708, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : CUT, 
   [COORD @D34712, AGR [COUNT @D34711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : CUT, 
   [COORD @D34714, AGR [COUNT @D34713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : CUT, 
   [COORD @D34718, AGR [COUNT @D34717, PER @D34716, PLU @D34715, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : CUT, 
   [COORD @D34724, PAST @D34723, 
      AGR [CASE @D34722, COUNT @D34721, PER @D34720, PLU @D34719, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : CUT, 
   [COORD @D34727, AGR [COUNT @D34726, PER @D34725, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : CUT, 
   [COORD @D34729, AGR [COUNT @D34728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : CUT, 
   [COORD @D34731, AGR [COUNT @D34730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : CUT, 
   [COORD @D34735, AGR [COUNT @D34734, PER @D34733, PLU @D34732, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : CUT, 
   [COORD @D34741, PAST @D34740, 
      AGR [CASE @D34739, COUNT @D34738, PER @D34737, PLU @D34736, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, 
      ARITY 1] : CUT, 
   [COORD @D34747, PAST @D34746, AGR [CASE @D34745, COUNT @D34744, 
            PER @D34743, PLU @D34742, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : CUT, 
   [COORD @D34753, PAST @D34752, 
      AGR [CASE @D34751, COUNT @D34750, PER @D34749, PLU @D34748, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : CUT, 
   [COORD @D34759, PAST @D34758, AGR [CASE @D34757, COUNT @D34756, 
            PER @D34755, PLU @D34754, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : CUT, 
   [COORD @D34765, PAST @D34764, 
      AGR [CASE @D34763, COUNT @D34762, PER @D34761, PLU @D34760, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, FIN -, 
      ARITY 1] : CUT, 
   [COORD @D34771, PAST @D34770, AGR [CASE @D34769, COUNT @D34768, 
            PER @D34767, PLU @D34766, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : CUT, 
   [COORD @D34777, PAST @D34776, 
      AGR [CASE @D34775, COUNT @D34774, PER @D34773, PLU @D34772, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, FIN -, 
      ARITY 1] : CUT, 
   [COORD @D34783, PAST @D34782, AGR [CASE @D34781, COUNT @D34780, 
            PER @D34779, PLU @D34778, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, FIN -, ARITY 1] : CUT, 
   [COORD @D34789, PAST @D34788, 
      AGR [CASE @D34787, COUNT @D34786, PER @D34785, PLU @D34784, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, FIN -, 
      ARITY 1] : CUT, 
   [COORD @D34793, AGR [COUNT @D34792, PER @D34791, PLU @D34790, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : CUT, 
   [COORD @D34797, AGR [COUNT @D34796, PER @D34795, PLU @D34794, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : CUT, 
   [COORD @D34801, AGR [COUNT @D34800, PER @D34799, PLU @D34798, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : CUT, 
   [COORD @D34805, AGR [COUNT @D34804, PER @D34803, PLU @D34802, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : CUT, 
   [COORD @D34809, AGR [COUNT @D34808, PER @D34807, PLU @D34806, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : CUT, 
   [COORD @D34813, AGR [COUNT @D34812, PER @D34811, PLU @D34810, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : CUT, 
   [COORD @D34817, AGR [COUNT @D34816, PER @D34815, PLU @D34814, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : CUT, 
   [COORD @D34821, AGR [COUNT @D34820, PER @D34819, PLU @D34818, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, PAST +, ARITY 1] : CUT.

WORD cuts : 
   [COORD @D34831, DEMON @D34830, REFL @D34829, PRD @D34828, CASE 
         @D34827, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM AT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CUT, 
   [COORD @D34836, DEMON @D34835, REFL @D34834, PRD @D34833, CASE 
         @D34832, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CUT, 
   [COORD @D34841, DEMON @D34840, REFL @D34839, PRD @D34838, 
      CASE @D34837, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM IN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CUT, 
   [COORD @D34846, DEMON @D34845, REFL @D34844, PRD @D34843, CASE 
         @D34842, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   CUT, 
   [COORD @D34851, DEMON @D34850, REFL @D34849, PRD @D34848, CASE 
         @D34847, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : CUT, 
   [COORD @D34853, 
      AGR [COUNT @D34852, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34855, 
      AGR [COUNT @D34854, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34857, 
      AGR [COUNT @D34856, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D34859, AGR [COUNT @D34858, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D34861, AGR [COUNT @D34860, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PRT OFF, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CUT, 
   [COORD @D34863, AGR [COUNT @D34862, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CUT, 
   [COORD @D34865, AGR [COUNT @D34864, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : CUT, 
   [COORD @D34867, AGR [COUNT @D34866, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34869, 
      AGR [COUNT @D34868, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34871, 
      AGR [COUNT @D34870, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CUT, 
   [COORD @D34873, AGR [COUNT @D34872, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CUT, 
   [COORD @D34875, AGR [COUNT @D34874, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BACK, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   CUT, 
   [COORD @D34877, AGR [COUNT @D34876, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D34879, AGR [COUNT @D34878, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D34881, AGR [COUNT @D34880, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34883, 
      AGR [COUNT @D34882, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34885, 
      AGR [COUNT @D34884, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34887, 
      AGR [COUNT @D34886, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34889, 
      AGR [COUNT @D34888, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34891, 
      AGR [COUNT @D34890, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34893, 
      AGR [COUNT @D34892, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34895, 
      AGR [COUNT @D34894, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34897, 
      AGR [COUNT @D34896, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34899, 
      AGR [COUNT @D34898, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34901, 
      AGR [COUNT @D34900, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34903, 
      AGR [COUNT @D34902, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34905, 
      AGR [COUNT @D34904, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT, 
   [COORD @D34907, 
      AGR [COUNT @D34906, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : CUT.

WORD cutting : 
   [COORD @D34927, PRD @D34926, AGR [CASE @D34925, COUNT @D34924, 
            PER @D34923, PLU @D34922, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D34933, PRD @D34932, AGR 
         [CASE @D34931, COUNT @D34930, PER @D34929, PLU @D34928, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT, 
   [COORD @D34939, PRD @D34938, AGR [CASE @D34937, COUNT @D34936, 
            PER @D34935, PLU @D34934, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT DOWN, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D34945, PRD @D34944, 
      AGR [CASE @D34943, COUNT @D34942, PER @D34941, PLU @D34940, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D34951, PRD @D34950, AGR [CASE @D34949, COUNT @D34948, 
            PER @D34947, PLU @D34946, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PRT OFF, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D34957, PRD @D34956, 
      AGR [CASE @D34955, COUNT @D34954, PER @D34953, PLU @D34952, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : CUT, 
   [COORD @D34963, PRD @D34962, AGR [CASE @D34961, COUNT @D34960, 
            PER @D34959, PLU @D34958, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D34969, PRD @D34968, 
      AGR [CASE @D34967, COUNT @D34966, PER @D34965, PLU @D34964, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   
   [COORD @D34975, PRD @D34974, AGR [CASE @D34973, COUNT @D34972, PER 
               @D34971, PLU @D34970, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D34981, PRD @D34980, AGR 
         [CASE @D34979, COUNT @D34978, PER @D34977, PLU @D34976, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D34987, PRD @D34986, AGR [CASE @D34985, COUNT @D34984, 
            PER @D34983, PLU @D34982, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D34993, PRD @D34992, 
      AGR [CASE @D34991, COUNT @D34990, PER @D34989, PLU @D34988, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT BACK, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D34999, PRD @D34998, AGR [CASE @D34997, COUNT @D34996, 
            PER @D34995, PLU @D34994, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35005, PRD @D35004, 
      AGR [CASE @D35003, COUNT @D35002, PER @D35001, PLU @D35000, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : CUT, 
   [COORD @D35011, PRD @D35010, AGR [CASE @D35009, COUNT @D35008, 
            PER @D35007, PLU @D35006, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35017, PRD @D35016, 
      AGR [CASE @D35015, COUNT @D35014, PER @D35013, PLU @D35012, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT, 
   [COORD @D35023, PRD @D35022, AGR [CASE @D35021, COUNT @D35020, 
            PER @D35019, PLU @D35018, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35029, PRD @D35028, 
      AGR [CASE @D35027, COUNT @D35026, PER @D35025, PLU @D35024, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT, 
   [COORD @D35035, PRD @D35034, AGR [CASE @D35033, COUNT @D35032, 
            PER @D35031, PLU @D35030, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35041, PRD @D35040, 
      AGR [CASE @D35039, COUNT @D35038, PER @D35037, PLU @D35036, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT, 
   [COORD @D35047, PRD @D35046, AGR [CASE @D35045, COUNT @D35044, 
            PER @D35043, PLU @D35042, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35053, PRD @D35052, AGR 
         [CASE @D35051, COUNT @D35050, PER @D35049, PLU @D35048, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT, 
   [COORD @D35059, PRD @D35058, AGR [CASE @D35057, COUNT @D35056, 
            PER @D35055, PLU @D35054, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35065, PRD @D35064, 
      AGR [CASE @D35063, COUNT @D35062, PER @D35061, PLU @D35060, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT, 
   [COORD @D35071, PRD @D35070, AGR [CASE @D35069, COUNT @D35068, 
            PER @D35067, PLU @D35066, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35077, PRD @D35076, 
      AGR [CASE @D35075, COUNT @D35074, PER @D35073, PLU @D35072, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT, 
   [COORD @D35083, PRD @D35082, AGR [CASE @D35081, COUNT @D35080, 
            PER @D35079, PLU @D35078, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : CUT, 
   [COORD @D35089, PRD @D35088, 
      AGR [CASE @D35087, COUNT @D35086, PER @D35085, PLU @D35084, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : CUT.

WORD damage : 
   [COORD @D35098, REFL @D35097, PRD @D35096, CASE @D35095, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : DAMAGE, 
   [COORD @D35102, REFL @D35101, PRD @D35100, CASE @D35099, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DAMAGE, 
   [COORD @D35105, 
      AGR [COUNT @D35104, PER @D35103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   DAMAGE, 
   [COORD @D35107, AGR [COUNT @D35106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DAMAGE, 
   [COORD @D35109, AGR [COUNT @D35108, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DAMAGE, 
   [COORD @D35113, AGR [COUNT @D35112, PER @D35111, PLU @D35110, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DAMAGE, 
   [COORD @D35119, PAST @D35118, AGR [CASE @D35117, COUNT @D35116, 
            PER @D35115, PLU @D35114, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DAMAGE.

WORD damaged : 
   [COORD @D35131, AGR [CASE @D35130, COUNT @D35129, PER @D35128, 
            PLU @D35127, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DAMAGE, 
   [COORD @D35136, AGR [CASE @D35135, COUNT @D35134, PER @D35133, 
            PLU @D35132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DAMAGE, 
   [COORD @D35141, AGR [CASE @D35140, COUNT @D35139, PER @D35138, 
            PLU @D35137, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DAMAGE.

WORD damages : 
   [COORD @D35152, REFL @D35151, PRD @D35150, CASE @D35149, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : DAMAGES, 
   [COORD @D35157, DEMON @D35156, REFL @D35155, PRD @D35154, 
      CASE @D35153, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : DAMAGE, 
   [COORD @D35159, AGR [COUNT @D35158, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DAMAGE.

WORD damaging : 
   [COORD @D35182, PRD @D35181, AGR [CASE @D35180, COUNT @D35179, 
            PER @D35178, PLU @D35177, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DAMAGE.

WORD dance : 
   [COORD @D35191, REFL @D35190, PRD @D35189, CASE @D35188, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DANCE, 
   [COORD @D35195, REFL @D35194, PRD @D35193, CASE @D35192, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DANCE, 
   [COORD @D35198, 
      AGR [COUNT @D35197, PER @D35196, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   DANCE, 
   [COORD @D35200, AGR [COUNT @D35199, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DANCE, 
   [COORD @D35202, AGR [COUNT @D35201, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DANCE, 
   [COORD @D35206, AGR [COUNT @D35205, PER @D35204, PLU @D35203, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DANCE, 
   [COORD @D35212, PAST @D35211, AGR [CASE @D35210, COUNT @D35209, 
            PER @D35208, PLU @D35207, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : DANCE, 
   [COORD @D35215, AGR [COUNT @D35214, PER @D35213, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DANCE, 
   [COORD @D35217, AGR [COUNT @D35216, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DANCE, 
   [COORD @D35219, AGR [COUNT @D35218, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DANCE, 
   [COORD @D35223, AGR [COUNT @D35222, PER @D35221, PLU @D35220, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DANCE, 
   [COORD @D35229, PAST @D35228, AGR [CASE @D35227, COUNT @D35226, 
            PER @D35225, PLU @D35224, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DANCE, 
   [COORD @D35232, AGR [COUNT @D35231, PER @D35230, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : DANCE, 
   [COORD @D35234, AGR [COUNT @D35233, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : DANCE, 
   [COORD @D35236, AGR [COUNT @D35235, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : DANCE, 
   [COORD @D35240, AGR [COUNT @D35239, PER @D35238, PLU @D35237, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : DANCE, 
   [COORD @D35246, PAST @D35245, 
      AGR [CASE @D35244, COUNT @D35243, PER @D35242, PLU @D35241, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : DANCE, 
   [COORD @D35249, AGR [COUNT @D35248, PER @D35247, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DANCE, 
   [COORD @D35251, AGR [COUNT @D35250, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DANCE, 
   [COORD @D35253, AGR [COUNT @D35252, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DANCE, 
   [COORD @D35257, AGR [COUNT @D35256, PER @D35255, PLU @D35254, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DANCE, 
   [COORD @D35263, PAST @D35262, AGR [CASE @D35261, COUNT @D35260, 
            PER @D35259, PLU @D35258, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DANCE.

WORD danced : 
   [COORD @D35275, AGR [CASE @D35274, COUNT @D35273, PER @D35272, 
            PLU @D35271, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DANCE, 
   [COORD @D35280, AGR [CASE @D35279, COUNT @D35278, PER @D35277, 
            PLU @D35276, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35285, AGR [CASE @D35284, COUNT @D35283, PER @D35282, 
            PLU @D35281, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35290, AGR [CASE @D35289, COUNT @D35288, PER @D35287, 
            PLU @D35286, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35295, AGR [CASE @D35294, COUNT @D35293, PER @D35292, 
            PLU @D35291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35300, AGR [CASE @D35299, COUNT @D35298, PER @D35297, 
            PLU @D35296, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DANCE, 
   [COORD @D35305, AGR [CASE @D35304, COUNT @D35303, PER @D35302, 
            PLU @D35301, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35310, AGR [CASE @D35309, COUNT @D35308, PER @D35307, 
            PLU @D35306, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35315, AGR [CASE @D35314, COUNT @D35313, PER @D35312, 
            PLU @D35311, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35320, AGR [CASE @D35319, COUNT @D35318, PER @D35317, 
            PLU @D35316, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DANCE.

WORD dances : 
   [COORD @D35332, DEMON @D35331, REFL @D35330, PRD @D35329, CASE 
         @D35328, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DANCE, 
   [COORD @D35337, DEMON @D35336, REFL @D35335, PRD @D35334, 
      CASE @D35333, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : DANCE, 
   [COORD @D35339, AGR [COUNT @D35338, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DANCE, 
   [COORD @D35341, 
      AGR [COUNT @D35340, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DANCE, 
   [COORD @D35343, 
      AGR [COUNT @D35342, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DANCE, 
   [COORD @D35345, 
      AGR [COUNT @D35344, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DANCE.

WORD dancing : 
   [COORD @D35358, PRD @D35357, AGR [CASE @D35356, COUNT @D35355, 
            PER @D35354, PLU @D35353, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35364, PRD @D35363, 
      AGR [CASE @D35362, COUNT @D35361, PER @D35360, PLU @D35359, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DANCE, 
   [COORD @D35370, PRD @D35369, AGR [CASE @D35368, COUNT @D35367, 
            PER @D35366, PLU @D35365, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DANCE, 
   [COORD @D35376, PRD @D35375, 
      AGR [CASE @D35374, COUNT @D35373, PER @D35372, PLU @D35371, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DANCE.

WORD deal : 
   [COORD @D35383, REFL @D35382, PRD @D35381, CASE @D35380, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DEAL, 
   [COORD @D35388, REFL @D35387, COUNT @D35386, PRD @D35385, 
      CASE @D35384, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DEAL, 
   [COORD @D35392, REFL @D35391, PRD @D35390, CASE @D35389, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DEAL, 
   [COORD @D35396, REFL @D35395, PRD @D35394, CASE @D35393, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DEAL, 
   [COORD @D35400, REFL @D35399, PRD @D35398, CASE @D35397, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : DEAL, 
   [COORD @D35403, 
      AGR [COUNT @D35402, PER @D35401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   DEAL, 
   [COORD @D35405, AGR [COUNT @D35404, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : DEAL, 
   [COORD @D35407, AGR [COUNT @D35406, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : DEAL, 
   [COORD @D35411, AGR [COUNT @D35410, PER @D35409, PLU @D35408, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : DEAL, 
   [COORD @D35417, PAST @D35416, 
      AGR [CASE @D35415, COUNT @D35414, PER @D35413, PLU @D35412, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   DEAL, 
   [COORD @D35420, AGR [COUNT @D35419, PER @D35418, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OUT, ARITY 3] : DEAL, 
   [COORD @D35422, AGR [COUNT @D35421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OUT, ARITY 3] : DEAL, 
   [COORD @D35424, AGR [COUNT @D35423, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OUT, ARITY 3] : DEAL, 
   [COORD @D35428, AGR [COUNT @D35427, PER @D35426, PLU @D35425, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT OUT, ARITY 3] : DEAL, 
   [COORD @D35434, PAST @D35433, 
      AGR [CASE @D35432, COUNT @D35431, PER @D35430, PLU @D35429, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT OUT, 
      ARITY 3] : DEAL, 
   [COORD @D35437, AGR [COUNT @D35436, PER @D35435, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35439, AGR [COUNT @D35438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35441, AGR [COUNT @D35440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35445, AGR [COUNT @D35444, PER @D35443, PLU @D35442, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35451, PAST @D35450, 
      AGR [CASE @D35449, COUNT @D35448, PER @D35447, PLU @D35446, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : DEAL, 
   [COORD @D35454, AGR [COUNT @D35453, PER @D35452, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35456, AGR [COUNT @D35455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35458, AGR [COUNT @D35457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35462, AGR [COUNT @D35461, PER @D35460, PLU @D35459, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT OUT, PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35468, PAST @D35467, 
      AGR [CASE @D35466, COUNT @D35465, PER @D35464, PLU @D35463, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT OUT, 
      PFORM TO, ARITY 3] : DEAL, 
   [COORD @D35471, AGR [COUNT @D35470, PER @D35469, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DEAL, 
   [COORD @D35473, AGR [COUNT @D35472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DEAL, 
   [COORD @D35475, AGR [COUNT @D35474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DEAL, 
   [COORD @D35479, AGR [COUNT @D35478, PER @D35477, PLU @D35476, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : DEAL, 
   [COORD @D35485, PAST @D35484, AGR [CASE @D35483, COUNT @D35482, 
            PER @D35481, PLU @D35480, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : DEAL, 
   [COORD @D35488, AGR [COUNT @D35487, PER @D35486, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : DEAL, 
   [COORD @D35490, AGR [COUNT @D35489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : DEAL, 
   [COORD @D35492, AGR [COUNT @D35491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : DEAL, 
   [COORD @D35496, AGR [COUNT @D35495, PER @D35494, PLU @D35493, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : DEAL, 
   [COORD @D35502, PAST @D35501, AGR 
         [CASE @D35500, COUNT @D35499, PER @D35498, PLU @D35497, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : DEAL, 
   [COORD @D35505, AGR [COUNT @D35504, PER @D35503, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : DEAL, 
   [COORD @D35507, AGR [COUNT @D35506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : DEAL, 
   [COORD @D35509, AGR [COUNT @D35508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : DEAL, 
   [COORD @D35513, AGR [COUNT @D35512, PER @D35511, PLU @D35510, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM IN, ARITY 2] : DEAL, 
   [COORD @D35519, PAST @D35518, AGR [CASE @D35517, COUNT @D35516, 
            PER @D35515, PLU @D35514, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM IN, ARITY 2] : DEAL, 
   [COORD @D35522, 
      AGR [COUNT @D35521, PER @D35520, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, 
      ARITY 2] : DEAL, 
   [COORD @D35524, AGR [COUNT @D35523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : DEAL, 
   [COORD @D35526, AGR [COUNT @D35525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : DEAL, 
   [COORD @D35530, AGR [COUNT @D35529, PER @D35528, PLU @D35527, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : DEAL, 
   [COORD @D35536, PAST @D35535, AGR [CASE @D35534, COUNT @D35533, 
            PER @D35532, PLU @D35531, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : DEAL, 
   [COORD @D35539, 
      AGR [COUNT @D35538, PER @D35537, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : DEAL, 
   [COORD @D35541, AGR [COUNT @D35540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : DEAL, 
   [COORD @D35543, AGR [COUNT @D35542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : DEAL, 
   [COORD @D35547, AGR [COUNT @D35546, PER @D35545, PLU @D35544, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : DEAL, 
   [COORD @D35553, PAST @D35552, 
      AGR [CASE @D35551, COUNT @D35550, PER @D35549, PLU @D35548, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : DEAL, 
   [COORD @D35559, PAST @D35558, AGR [CASE @D35557, COUNT @D35556, 
            PER @D35555, PLU @D35554, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM WITH, FIN -, ARITY 2] : DEAL, 
   [COORD @D35565, PAST @D35564, 
      AGR [CASE @D35563, COUNT @D35562, PER @D35561, PLU @D35560, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, FIN -, 
      ARITY 2] : DEAL, 
   [COORD @D35569, AGR [COUNT @D35568, PER @D35567, PLU @D35566, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, PAST +, ARITY 2] : DEAL, 
   [COORD @D35572, AGR [COUNT @D35571, PER @D35570, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DEAL, 
   [COORD @D35574, AGR [COUNT @D35573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DEAL, 
   [COORD @D35576, AGR [COUNT @D35575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DEAL, 
   [COORD @D35580, AGR [COUNT @D35579, PER @D35578, PLU @D35577, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : DEAL, 
   [COORD @D35586, PAST @D35585, 
      AGR [CASE @D35584, COUNT @D35583, PER @D35582, PLU @D35581, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   DEAL, 
   [COORD @D35589, AGR [COUNT @D35588, PER @D35587, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : DEAL, 
   [COORD @D35591, AGR [COUNT @D35590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : DEAL, 
   [COORD @D35593, AGR [COUNT @D35592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : DEAL, 
   [COORD @D35597, AGR [COUNT @D35596, PER @D35595, PLU @D35594, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : DEAL, 
   [COORD @D35603, PAST @D35602, 
      AGR [CASE @D35601, COUNT @D35600, PER @D35599, PLU @D35598, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : DEAL.

WORD dealing : 
   [COORD @D35616, REFL @D35615, PRD @D35614, CASE @D35613, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : DEALING, 
   [COORD @D35622, PRD @D35621, 
      AGR [CASE @D35620, COUNT @D35619, PER @D35618, PLU @D35617, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DEAL, 
   [COORD @D35628, PRD @D35627, AGR [CASE @D35626, COUNT @D35625, 
            PER @D35624, PLU @D35623, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEAL, 
   [COORD @D35634, PRD @D35633, 
      AGR [CASE @D35632, COUNT @D35631, PER @D35630, PLU @D35629, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DEAL, 
   [COORD @D35640, PRD @D35639, AGR [CASE @D35638, COUNT @D35637, 
            PER @D35636, PLU @D35635, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT OUT, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEAL, 
   [COORD @D35646, PRD @D35645, 
      AGR [CASE @D35644, COUNT @D35643, PER @D35642, PLU @D35641, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DEAL, 
   [COORD @D35652, PRD @D35651, AGR [CASE @D35650, COUNT @D35649, 
            PER @D35648, PLU @D35647, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEAL, 
   [COORD @D35658, PRD @D35657, 
      AGR [CASE @D35656, COUNT @D35655, PER @D35654, PLU @D35653, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DEAL, 
   [COORD @D35664, PRD @D35663, AGR [CASE @D35662, COUNT @D35661, 
            PER @D35660, PLU @D35659, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEAL, 
   [COORD @D35670, PRD @D35669, 
      AGR [CASE @D35668, COUNT @D35667, PER @D35666, PLU @D35665, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DEAL, 
   [COORD @D35676, PRD @D35675, AGR [CASE @D35674, COUNT @D35673, 
            PER @D35672, PLU @D35671, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEAL, 
   [COORD @D35682, PRD @D35681, 
      AGR [CASE @D35680, COUNT @D35679, PER @D35678, PLU @D35677, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DEAL.

WORD dealings : 
   [COORD @D35698, REFL @D35697, PRD @D35696, CASE @D35695, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : DEALINGS.

WORD deals : 
   [COORD @D35721, DEMON @D35720, REFL @D35719, PRD @D35718, CASE 
         @D35717, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DEAL, 
   [COORD @D35726, DEMON @D35725, REFL @D35724, PRD @D35723, 
      CASE @D35722, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : DEAL, 
   [COORD @D35728, AGR [COUNT @D35727, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35730, 
      AGR [COUNT @D35729, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35732, 
      AGR [COUNT @D35731, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35734, 
      AGR [COUNT @D35733, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PRT OUT, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DEAL, 
   [COORD @D35736, AGR [COUNT @D35735, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35738, 
      AGR [COUNT @D35737, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35740, 
      AGR [COUNT @D35739, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35742, 
      AGR [COUNT @D35741, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35744, 
      AGR [COUNT @D35743, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35746, 
      AGR [COUNT @D35745, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL, 
   [COORD @D35748, 
      AGR [COUNT @D35747, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEAL.

WORD dealt : 
   [COORD @D35759, PAST @D35758, AGR [CASE @D35757, COUNT @D35756, 
            PER @D35755, PLU @D35754, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : DEAL, 
   [COORD @D35765, PAST @D35764, 
      AGR [CASE @D35763, COUNT @D35762, PER @D35761, PLU @D35760, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : DEAL, 
   
   [COORD @D35771, PAST @D35770, AGR [CASE @D35769, COUNT @D35768, PER 
               @D35767, PLU @D35766, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT OUT, FIN -, ARITY 3] : DEAL, 
   [COORD @D35777, PAST @D35776, 
      AGR [CASE @D35775, COUNT @D35774, PER @D35773, PLU @D35772, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT OUT, FIN -, 
      ARITY 3] : DEAL, 
   [COORD @D35783, PAST @D35782, AGR [CASE @D35781, COUNT @D35780, 
            PER @D35779, PLU @D35778, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : DEAL, 
   [COORD @D35789, PAST @D35788, 
      AGR [CASE @D35787, COUNT @D35786, PER @D35785, PLU @D35784, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : DEAL, 
   [COORD @D35795, PAST @D35794, AGR [CASE @D35793, COUNT @D35792, 
            PER @D35791, PLU @D35790, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT OUT, PFORM TO, FIN -, ARITY 3] : DEAL, 
   [COORD @D35801, PAST @D35800, 
      AGR [CASE @D35799, COUNT @D35798, PER @D35797, PLU @D35796, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT OUT, PFORM TO, 
      FIN -, ARITY 3] : DEAL, 
   [COORD @D35805, AGR [COUNT @D35804, PER @D35803, PLU @D35802, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : DEAL, 
   [COORD @D35809, AGR [COUNT @D35808, PER @D35807, PLU @D35806, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT OUT, PAST +, ARITY 3] : DEAL, 
   [COORD @D35813, AGR [COUNT @D35812, PER @D35811, PLU @D35810, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : DEAL, 
   [COORD @D35817, AGR [COUNT @D35816, PER @D35815, PLU @D35814, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PRT OUT, PFORM TO, PAST +, ARITY 3] : DEAL, 
   [COORD @D35823, PAST @D35822, 
      AGR [CASE @D35821, COUNT @D35820, PER @D35819, PLU @D35818, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : DEAL, 
   [COORD @D35829, PAST @D35828, AGR [CASE @D35827, COUNT @D35826, 
            PER @D35825, PLU @D35824, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : DEAL, 
   [COORD @D35835, PAST @D35834, 
      AGR [CASE @D35833, COUNT @D35832, PER @D35831, PLU @D35830, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM IN, FIN -, 
      ARITY 2] : DEAL, 
   [COORD @D35841, PAST @D35840, AGR [CASE @D35839, COUNT @D35838, 
            PER @D35837, PLU @D35836, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM IN, FIN -, ARITY 2] : DEAL, 
   [COORD @D35847, PAST @D35846, 
      AGR [CASE @D35845, COUNT @D35844, PER @D35843, PLU @D35842, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM AT, FIN -, 
      ARITY 2] : DEAL, 
   [COORD @D35853, PAST @D35852, AGR [CASE @D35851, COUNT @D35850, 
            PER @D35849, PLU @D35848, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM AT, FIN -, ARITY 2] : DEAL, 
   [COORD @D35859, PAST @D35858, 
      AGR [CASE @D35857, COUNT @D35856, PER @D35855, PLU @D35854, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : DEAL, 
   [COORD @D35865, PAST @D35864, AGR [CASE @D35863, COUNT @D35862, 
            PER @D35861, PLU @D35860, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : DEAL, 
   [COORD @D35869, 
      AGR [COUNT @D35868, PER @D35867, PLU @D35866, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : DEAL, 
   [COORD @D35873, AGR [COUNT @D35872, PER @D35871, PLU @D35870, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, PAST +, ARITY 2] : DEAL, 
   [COORD @D35877, AGR [COUNT @D35876, PER @D35875, PLU @D35874, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, PAST +, ARITY 2] : DEAL, 
   [COORD @D35881, AGR [COUNT @D35880, PER @D35879, PLU @D35878, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : DEAL, 
   [COORD @D35887, PAST @D35886, AGR [CASE @D35885, COUNT @D35884, 
            PER @D35883, PLU @D35882, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : DEAL, 
   [COORD @D35893, PAST @D35892, 
      AGR [CASE @D35891, COUNT @D35890, PER @D35889, PLU @D35888, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : DEAL, 
   [COORD @D35897, AGR [COUNT @D35896, PER @D35895, PLU @D35894, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : DEAL, 
   [COORD @D35901, AGR [COUNT @D35900, PER @D35899, PLU @D35898, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : DEAL.

WORD debate : 
   [COORD @D35932, REFL @D35931, PRD @D35930, CASE @D35929, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DEBATE, 
   [COORD @D35935, 
      AGR [COUNT @D35934, PER @D35933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM WITH_ABOUT, ARITY 3] : DEBATE, 
   [COORD @D35937, AGR [COUNT @D35936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM WITH_ABOUT, ARITY 3] : DEBATE, 
   [COORD @D35939, AGR 
         [COUNT @D35938, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM WITH_ABOUT, ARITY 3] : DEBATE, 
   [COORD @D35943, AGR [COUNT @D35942, PER @D35941, PLU @D35940, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM WITH_ABOUT, ARITY 3] : DEBATE, 
   [COORD @D35949, PAST @D35948, 
      AGR [CASE @D35947, COUNT @D35946, PER @D35945, PLU @D35944, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM WITH_ABOUT, ARITY 3] : DEBATE, 
   [COORD @D35952, AGR [COUNT @D35951, PER @D35950, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DEBATE, 
   [COORD @D35954, AGR [COUNT @D35953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DEBATE, 
   [COORD @D35956, AGR [COUNT @D35955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DEBATE, 
   [COORD @D35960, AGR [COUNT @D35959, PER @D35958, PLU @D35957, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DEBATE, 
   [COORD @D35966, PAST @D35965, 
      AGR [CASE @D35964, COUNT @D35963, PER @D35962, PLU @D35961, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : DEBATE, 
   [COORD @D35969, AGR [COUNT @D35968, PER @D35967, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEBATE, 
   [COORD @D35971, AGR [COUNT @D35970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEBATE, 
   [COORD @D35973, AGR [COUNT @D35972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEBATE, 
   [COORD @D35977, AGR [COUNT @D35976, PER @D35975, PLU @D35974, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DEBATE, 
   [COORD @D35983, PAST @D35982, AGR [CASE @D35981, COUNT @D35980, 
            PER @D35979, PLU @D35978, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DEBATE, 
   [COORD @D35986, AGR [COUNT @D35985, PER @D35984, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : DEBATE, 
   [COORD @D35988, AGR [COUNT @D35987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : DEBATE, 
   [COORD @D35990, AGR [COUNT @D35989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : DEBATE, 
   [COORD @D35994, AGR [COUNT @D35993, PER @D35992, PLU @D35991, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : DEBATE, 
   [COORD @D36000, PAST @D35999, 
      AGR [CASE @D35998, COUNT @D35997, PER @D35996, PLU @D35995, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : DEBATE, 
   [COORD @D36003, AGR [COUNT @D36002, PER @D36001, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : DEBATE, 
   [COORD @D36005, AGR [COUNT @D36004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : DEBATE, 
   [COORD @D36007, AGR [COUNT @D36006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : DEBATE, 
   [COORD @D36011, AGR [COUNT @D36010, PER @D36009, PLU @D36008, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM UPON, ARITY 2] : DEBATE, 
   [COORD @D36017, PAST @D36016, 
      AGR [CASE @D36015, COUNT @D36014, PER @D36013, PLU @D36012, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UPON, 
      ARITY 2] : DEBATE, 
   [COORD @D36020, AGR [COUNT @D36019, PER @D36018, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DEBATE, 
   [COORD @D36022, AGR [COUNT @D36021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DEBATE, 
   [COORD @D36024, AGR [COUNT @D36023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DEBATE, 
   [COORD @D36028, AGR [COUNT @D36027, PER @D36026, PLU @D36025, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : DEBATE, 
   [COORD @D36034, PAST @D36033, 
      AGR [CASE @D36032, COUNT @D36031, PER @D36030, PLU @D36029, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      ARITY 2] : DEBATE, 
   [COORD @D36037, AGR [COUNT @D36036, PER @D36035, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEBATE, 
   [COORD @D36039, AGR [COUNT @D36038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEBATE, 
   [COORD @D36041, AGR [COUNT @D36040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEBATE, 
   [COORD @D36045, AGR [COUNT @D36044, PER @D36043, PLU @D36042, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEBATE, 
   [COORD @D36051, PAST @D36050, AGR [CASE @D36049, COUNT @D36048, 
            PER @D36047, PLU @D36046, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DEBATE.

WORD debated : 
   [COORD @D36063, AGR [CASE @D36062, COUNT @D36061, PER @D36060, 
            PLU @D36059, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM WITH_ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36068, 
      AGR [CASE @D36067, COUNT @D36066, PER @D36065, PLU @D36064, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP_PP, PFORM WITH_ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : DEBATE, 
   [COORD @D36073, AGR [CASE @D36072, COUNT @D36071, PER @D36070, 
            PLU @D36069, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36078, AGR [CASE @D36077, COUNT @D36076, PER @D36075, 
            PLU @D36074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36083, AGR [CASE @D36082, COUNT @D36081, PER @D36080, 
            PLU @D36079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36088, AGR [CASE @D36087, COUNT @D36086, PER @D36085, 
            PLU @D36084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36093, AGR [CASE @D36092, COUNT @D36091, PER @D36090, 
            PLU @D36089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36098, AGR [CASE @D36097, COUNT @D36096, PER @D36095, 
            PLU @D36094, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DEBATE, 
   [COORD @D36103, AGR [CASE @D36102, COUNT @D36101, PER @D36100, 
            PLU @D36099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36108, AGR [CASE @D36107, COUNT @D36106, PER @D36105, 
            PLU @D36104, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36113, AGR [CASE @D36112, COUNT @D36111, PER @D36110, 
            PLU @D36109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36118, AGR [CASE @D36117, COUNT @D36116, PER @D36115, 
            PLU @D36114, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36123, AGR [CASE @D36122, COUNT @D36121, PER @D36120, 
            PLU @D36119, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36128, AGR [CASE @D36127, COUNT @D36126, PER @D36125, 
            PLU @D36124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36133, AGR [CASE @D36132, COUNT @D36131, PER @D36130, 
            PLU @D36129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36138, AGR [CASE @D36137, COUNT @D36136, PER @D36135, 
            PLU @D36134, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEBATE.

WORD debates : 
   [COORD @D36150, DEMON @D36149, REFL @D36148, PRD @D36147, 
      CASE @D36146, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DEBATE, 
   [COORD @D36152, 
      AGR [COUNT @D36151, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_PP, PFORM WITH_ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DEBATE, 
   [COORD @D36154, AGR [COUNT @D36153, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DEBATE, 
   [COORD @D36156, AGR [COUNT @D36155, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36158, 
      AGR [COUNT @D36157, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36160, 
      AGR [COUNT @D36159, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36162, 
      AGR [COUNT @D36161, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36164, 
      AGR [COUNT @D36163, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEBATE.

WORD debating : 
   [COORD @D36175, PRD @D36174, AGR [CASE @D36173, COUNT @D36172, 
            PER @D36171, PLU @D36170, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, 
      PFORM WITH_ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36181, PRD @D36180, 
      AGR [CASE @D36179, COUNT @D36178, PER @D36177, PLU @D36176, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DEBATE, 
   [COORD @D36187, PRD @D36186, AGR [CASE @D36185, COUNT @D36184, 
            PER @D36183, PLU @D36182, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36193, PRD @D36192, 
      AGR [CASE @D36191, COUNT @D36190, PER @D36189, PLU @D36188, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DEBATE, 
   [COORD @D36199, PRD @D36198, AGR [CASE @D36197, COUNT @D36196, 
            PER @D36195, PLU @D36194, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEBATE, 
   [COORD @D36205, PRD @D36204, 
      AGR [CASE @D36203, COUNT @D36202, PER @D36201, PLU @D36200, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DEBATE, 
   [COORD @D36211, PRD @D36210, AGR [CASE @D36209, COUNT @D36208, 
            PER @D36207, PLU @D36206, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEBATE.

WORD decide : 
   [COORD @D36218, AGR [COUNT @D36217, PER @D36216, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DECIDE, 
   [COORD @D36220, AGR [COUNT @D36219, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DECIDE, 
   [COORD @D36222, AGR [COUNT @D36221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DECIDE, 
   [COORD @D36226, AGR [COUNT @D36225, PER @D36224, PLU @D36223, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DECIDE, 
   [COORD @D36232, PAST @D36231, AGR [CASE @D36230, COUNT @D36229, 
            PER @D36228, PLU @D36227, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : DECIDE, 
   [COORD @D36235, AGR [COUNT @D36234, PER @D36233, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DECIDE, 
   [COORD @D36237, AGR [COUNT @D36236, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DECIDE, 
   [COORD @D36239, AGR [COUNT @D36238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DECIDE, 
   [COORD @D36243, AGR [COUNT @D36242, PER @D36241, PLU @D36240, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DECIDE, 
   [COORD @D36249, PAST @D36248, AGR [CASE @D36247, COUNT @D36246, 
            PER @D36245, PLU @D36244, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : DECIDE, 
   [COORD @D36252, AGR [COUNT @D36251, PER @D36250, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DECIDE, 
   [COORD @D36254, AGR [COUNT @D36253, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DECIDE, 
   [COORD @D36256, AGR [COUNT @D36255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DECIDE, 
   [COORD @D36260, AGR [COUNT @D36259, PER @D36258, PLU @D36257, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : DECIDE, 
   [COORD @D36266, PAST @D36265, AGR [CASE @D36264, COUNT @D36263, 
            PER @D36262, PLU @D36261, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : DECIDE, 
   [COORD @D36269, AGR [COUNT @D36268, PER @D36267, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECIDE, 
   [COORD @D36271, AGR [COUNT @D36270, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECIDE, 
   [COORD @D36273, AGR [COUNT @D36272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECIDE, 
   [COORD @D36277, AGR [COUNT @D36276, PER @D36275, PLU @D36274, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECIDE, 
   [COORD @D36283, PAST @D36282, AGR [CASE @D36281, COUNT @D36280, 
            PER @D36279, PLU @D36278, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : DECIDE, 
   [COORD @D36286, AGR [COUNT @D36285, PER @D36284, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DECIDE, 
   [COORD @D36288, AGR [COUNT @D36287, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DECIDE, 
   [COORD @D36290, AGR [COUNT @D36289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DECIDE, 
   [COORD @D36294, AGR [COUNT @D36293, PER @D36292, PLU @D36291, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DECIDE, 
   [COORD @D36300, PAST @D36299, AGR [CASE @D36298, COUNT @D36297, 
            PER @D36296, PLU @D36295, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DECIDE, 
   [COORD @D36303, AGR [COUNT @D36302, PER @D36301, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DECIDE, 
   [COORD @D36305, AGR [COUNT @D36304, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DECIDE, 
   [COORD @D36307, AGR [COUNT @D36306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DECIDE, 
   [COORD @D36311, AGR [COUNT @D36310, PER @D36309, PLU @D36308, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DECIDE, 
   [COORD @D36317, PAST @D36316, AGR [CASE @D36315, COUNT @D36314, 
            PER @D36313, PLU @D36312, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DECIDE, 
   [COORD @D36320, AGR [COUNT @D36319, PER @D36318, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP ON, ARITY 2] : DECIDE, 
   [COORD @D36322, AGR [COUNT @D36321, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP ON, ARITY 2] : DECIDE, 
   [COORD @D36324, AGR [COUNT @D36323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP ON, ARITY 2] : DECIDE, 
   [COORD @D36328, AGR [COUNT @D36327, PER @D36326, PLU @D36325, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP ON, ARITY 2] : DECIDE, 
   [COORD @D36334, PAST @D36333, 
      AGR [CASE @D36332, COUNT @D36331, PER @D36330, PLU @D36329, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP ON, ARITY 2] : DECIDE, 
   [COORD @D36337, AGR [COUNT @D36336, PER @D36335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : DECIDE, 
   [COORD @D36339, AGR [COUNT @D36338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : DECIDE, 
   [COORD @D36341, AGR [COUNT @D36340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : DECIDE, 
   [COORD @D36345, AGR [COUNT @D36344, PER @D36343, PLU @D36342, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : DECIDE, 
   [COORD @D36351, PAST @D36350, 
      AGR [CASE @D36349, COUNT @D36348, PER @D36347, PLU @D36346, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : DECIDE, 
   [COORD @D36354, AGR [COUNT @D36353, PER @D36352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECIDE, 
   [COORD @D36356, AGR [COUNT @D36355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECIDE, 
   [COORD @D36358, AGR [COUNT @D36357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECIDE, 
   [COORD @D36362, AGR [COUNT @D36361, PER @D36360, PLU @D36359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECIDE, 
   [COORD @D36368, PAST @D36367, AGR [CASE @D36366, COUNT @D36365, 
            PER @D36364, PLU @D36363, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DECIDE.

WORD decided : 
   [COADV @D36381, COORD @D36380, DEF @D36379, PRD @D36378, AGR 
            [CASE @D36377, COUNT @D36376, PER @D36375, PLU @D36374, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   DECIDED, 
   [COORD @D36386, AGR [CASE @D36385, COUNT @D36384, PER @D36383, 
            PLU @D36382, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36391, AGR [CASE @D36390, COUNT @D36389, PER @D36388, 
            PLU @D36387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36397, AGR [CASE @D36396, NFORM @D36395, COUNT @D36394, 
            PER @D36393, PLU @D36392, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DECIDE, 
   [COORD @D36402, AGR [CASE @D36401, COUNT @D36400, PER @D36399, 
            PLU @D36398, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36407, AGR [CASE @D36406, COUNT @D36405, PER @D36404, 
            PLU @D36403, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36412, AGR [CASE @D36411, COUNT @D36410, PER @D36409, 
            PLU @D36408, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36417, AGR [CASE @D36416, COUNT @D36415, PER @D36414, 
            PLU @D36413, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36422, AGR [CASE @D36421, COUNT @D36420, PER @D36419, 
            PLU @D36418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36427, AGR [CASE @D36426, COUNT @D36425, PER @D36424, 
            PLU @D36423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36432, AGR [UB @D36431, VFORM @D36430, SUBJ @D36429, 
            FIN @D36428, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DECIDE, 
   [COORD @D36437, AGR [CASE @D36436, COUNT @D36435, PER @D36434, 
            PLU @D36433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36442, AGR [CASE @D36441, COUNT @D36440, PER @D36439, 
            PLU @D36438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36447, AGR [CASE @D36446, COUNT @D36445, PER @D36444, 
            PLU @D36443, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36452, AGR [CASE @D36451, COUNT @D36450, PER @D36449, 
            PLU @D36448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36457, AGR [CASE @D36456, COUNT @D36455, PER @D36454, 
            PLU @D36453, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DECIDE, 
   [COORD @D36462, AGR [CASE @D36461, COUNT @D36460, PER @D36459, 
            PLU @D36458, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36467, AGR [CASE @D36466, COUNT @D36465, PER @D36464, 
            PLU @D36463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36472, AGR [CASE @D36471, COUNT @D36470, PER @D36469, 
            PLU @D36468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36477, AGR [CASE @D36476, COUNT @D36475, PER @D36474, 
            PLU @D36473, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36482, AGR [CASE @D36481, COUNT @D36480, PER @D36479, 
            PLU @D36478, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36487, AGR [CASE @D36486, COUNT @D36485, PER @D36484, 
            PLU @D36483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36492, AGR [CASE @D36491, COUNT @D36490, PER @D36489, 
            PLU @D36488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECIDE.

WORD decides : 
   [COORD @D36499, AGR [COUNT @D36498, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36501, 
      AGR [COUNT @D36500, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36503, 
      AGR [COUNT @D36502, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36505, 
      AGR [COUNT @D36504, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36507, 
      AGR [COUNT @D36506, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36509, 
      AGR [COUNT @D36508, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36511, 
      AGR [COUNT @D36510, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36513, 
      AGR [COUNT @D36512, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36515, 
      AGR [COUNT @D36514, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECIDE.

WORD deciding : 
   [COORD @D36525, PRD @D36524, AGR [CASE @D36523, COUNT @D36522, 
            PER @D36521, PLU @D36520, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36531, PRD @D36530, 
      AGR [CASE @D36529, COUNT @D36528, PER @D36527, PLU @D36526, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DECIDE, 
   [COORD @D36537, PRD @D36536, AGR [CASE @D36535, COUNT @D36534, 
            PER @D36533, PLU @D36532, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36543, PRD @D36542, 
      AGR [CASE @D36541, COUNT @D36540, PER @D36539, PLU @D36538, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DECIDE, 
   [COORD @D36549, PRD @D36548, AGR [CASE @D36547, COUNT @D36546, 
            PER @D36545, PLU @D36544, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36555, PRD @D36554, 
      AGR [CASE @D36553, COUNT @D36552, PER @D36551, PLU @D36550, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DECIDE, 
   [COORD @D36561, PRD @D36560, AGR [CASE @D36559, COUNT @D36558, 
            PER @D36557, PLU @D36556, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DECIDE, 
   [COORD @D36567, PRD @D36566, 
      AGR [CASE @D36565, COUNT @D36564, PER @D36563, PLU @D36562, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DECIDE, 
   [COORD @D36573, PRD @D36572, AGR [CASE @D36571, COUNT @D36570, 
            PER @D36569, PLU @D36568, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECIDE.

WORD declare : 
   [COORD @D36580, AGR [COUNT @D36579, PER @D36578, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECLARE, 
   [COORD @D36582, AGR [COUNT @D36581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECLARE, 
   [COORD @D36584, AGR [COUNT @D36583, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECLARE, 
   [COORD @D36588, AGR [COUNT @D36587, PER @D36586, PLU @D36585, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DECLARE, 
   [COORD @D36594, PAST @D36593, AGR [CASE @D36592, COUNT @D36591, 
            PER @D36590, PLU @D36589, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : DECLARE, 
   [COORD @D36597, AGR [COUNT @D36596, PER @D36595, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : DECLARE, 
   [COORD @D36599, AGR [COUNT @D36598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : DECLARE, 
   [COORD @D36601, AGR [COUNT @D36600, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : DECLARE, 
   [COORD @D36605, AGR [COUNT @D36604, PER @D36603, PLU @D36602, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : DECLARE, 
   [COORD @D36611, PAST @D36610, AGR [CASE @D36609, COUNT @D36608, 
            PER @D36607, PLU @D36606, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_NP, ARITY 2] : DECLARE, 
   [COORD @D36614, AGR [COUNT @D36613, PER @D36612, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DECLARE, 
   [COORD @D36616, AGR [COUNT @D36615, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DECLARE, 
   [COORD @D36618, AGR [COUNT @D36617, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DECLARE, 
   [COORD @D36622, AGR [COUNT @D36621, PER @D36620, PLU @D36619, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DECLARE, 
   [COORD @D36628, PAST @D36627, AGR [CASE @D36626, COUNT @D36625, 
            PER @D36624, PLU @D36623, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : DECLARE, 
   [COORD @D36631, AGR [COUNT @D36630, PER @D36629, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : DECLARE, 
   [COORD @D36633, AGR [COUNT @D36632, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : DECLARE, 
   [COORD @D36635, AGR [COUNT @D36634, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : DECLARE, 
   [COORD @D36639, AGR [COUNT @D36638, PER @D36637, PLU @D36636, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : DECLARE, 
   [COORD @D36645, PAST @D36644, AGR [CASE @D36643, COUNT @D36642, 
            PER @D36641, PLU @D36640, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : DECLARE, 
   [COORD @D36648, AGR [COUNT @D36647, PER @D36646, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DECLARE, 
   [COORD @D36650, AGR [COUNT @D36649, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DECLARE, 
   [COORD @D36652, AGR [COUNT @D36651, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DECLARE, 
   [COORD @D36656, AGR [COUNT @D36655, PER @D36654, PLU @D36653, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DECLARE, 
   [COORD @D36662, PAST @D36661, AGR [CASE @D36660, COUNT @D36659, 
            PER @D36658, PLU @D36657, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DECLARE, 
   [COORD @D36665, AGR [COUNT @D36664, PER @D36663, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : DECLARE, 
   [COORD @D36667, AGR [COUNT @D36666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : DECLARE, 
   [COORD @D36669, AGR [COUNT @D36668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : DECLARE, 
   [COORD @D36673, AGR [COUNT @D36672, PER @D36671, PLU @D36670, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : DECLARE, 
   [COORD @D36679, PAST @D36678, 
      AGR [CASE @D36677, COUNT @D36676, PER @D36675, PLU @D36674, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP FOR, ARITY 2] : DECLARE, 
   [COORD @D36682, AGR [COUNT @D36681, PER @D36680, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36684, AGR [COUNT @D36683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36686, AGR [COUNT @D36685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36690, AGR [COUNT @D36689, PER @D36688, PLU @D36687, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36696, PAST @D36695, 
      AGR [CASE @D36694, COUNT @D36693, PER @D36692, PLU @D36691, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36699, AGR [COUNT @D36698, PER @D36697, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : DECLARE, 
   [COORD @D36701, AGR [COUNT @D36700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : DECLARE, 
   [COORD @D36703, AGR [COUNT @D36702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : DECLARE, 
   [COORD @D36707, AGR [COUNT @D36706, PER @D36705, PLU @D36704, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : DECLARE, 
   [COORD @D36713, PAST @D36712, 
      AGR [CASE @D36711, COUNT @D36710, PER @D36709, PLU @D36708, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : DECLARE, 
   [COORD @D36716, AGR [COUNT @D36715, PER @D36714, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36718, AGR [COUNT @D36717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36720, AGR [COUNT @D36719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36724, AGR [COUNT @D36723, PER @D36722, PLU @D36721, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : DECLARE, 
   [COORD @D36730, PAST @D36729, 
      AGR [CASE @D36728, COUNT @D36727, PER @D36726, PLU @D36725, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, 
      ARITY 2] : DECLARE, 
   [COORD @D36733, AGR [COUNT @D36732, PER @D36731, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECLARE, 
   [COORD @D36735, AGR [COUNT @D36734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECLARE, 
   [COORD @D36737, AGR [COUNT @D36736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECLARE, 
   [COORD @D36741, AGR [COUNT @D36740, PER @D36739, PLU @D36738, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DECLARE, 
   [COORD @D36747, PAST @D36746, AGR [CASE @D36745, COUNT @D36744, 
            PER @D36743, PLU @D36742, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DECLARE.

WORD declared : 
   [COADV @D36760, COORD @D36759, DEF @D36758, PRD @D36757, AGR 
         [CASE @D36756, COUNT @D36755, PER @D36754, PLU @D36753, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DECLARED, 
   [COORD @D36765, 
      AGR [UB @D36764, VFORM @D36763, SUBJ @D36762, FIN @D36761, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, SUBCAT SFIN, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36770, 
      AGR [CASE @D36769, COUNT @D36768, PER @D36767, PLU @D36766, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DECLARE, 
   [COORD @D36775, AGR [CASE @D36774, COUNT @D36773, PER @D36772, 
            PLU @D36771, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36780, AGR [CASE @D36779, COUNT @D36778, PER @D36777, 
            PLU @D36776, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DECLARE, 
   [COORD @D36785, AGR [CASE @D36784, COUNT @D36783, PER @D36782, 
            PLU @D36781, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36790, AGR [CASE @D36789, COUNT @D36788, PER @D36787, 
            PLU @D36786, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36796, AGR [CASE @D36795, NFORM @D36794, COUNT @D36793, 
            PER @D36792, PLU @D36791, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DECLARE, 
   [COORD @D36801, AGR [UB @D36800, VFORM @D36799, SUBJ @D36798, 
            FIN @D36797, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DECLARE, 
   [COORD @D36806, AGR [CASE @D36805, COUNT @D36804, PER @D36803, 
            PLU @D36802, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36811, AGR [CASE @D36810, COUNT @D36809, PER @D36808, 
            PLU @D36807, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36816, AGR [CASE @D36815, COUNT @D36814, PER @D36813, 
            PLU @D36812, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36821, AGR [CASE @D36820, COUNT @D36819, PER @D36818, 
            PLU @D36817, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36827, AGR [CASE @D36826, NFORM @D36825, COUNT @D36824, 
            PER @D36823, PLU @D36822, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DECLARE, 
   [COORD @D36832, AGR [UB @D36831, VFORM @D36830, SUBJ @D36829, 
            FIN @D36828, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DECLARE, 
   [COORD @D36837, AGR [CASE @D36836, COUNT @D36835, PER @D36834, 
            PLU @D36833, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36842, AGR [CASE @D36841, COUNT @D36840, PER @D36839, 
            PLU @D36838, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36847, AGR [CASE @D36846, COUNT @D36845, PER @D36844, 
            PLU @D36843, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DECLARE, 
   [COORD @D36852, AGR [CASE @D36851, COUNT @D36850, PER @D36849, 
            PLU @D36848, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36857, AGR [CASE @D36856, COUNT @D36855, PER @D36854, 
            PLU @D36853, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36862, AGR [CASE @D36861, COUNT @D36860, PER @D36859, 
            PLU @D36858, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36867, AGR [CASE @D36866, COUNT @D36865, PER @D36864, 
            PLU @D36863, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36872, AGR [CASE @D36871, COUNT @D36870, PER @D36869, 
            PLU @D36868, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36877, AGR [CASE @D36876, COUNT @D36875, PER @D36874, 
            PLU @D36873, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36882, AGR [CASE @D36881, COUNT @D36880, PER @D36879, 
            PLU @D36878, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36887, AGR [CASE @D36886, COUNT @D36885, PER @D36884, 
            PLU @D36883, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36892, AGR [CASE @D36891, COUNT @D36890, PER @D36889, 
            PLU @D36888, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36897, AGR [CASE @D36896, COUNT @D36895, PER @D36894, 
            PLU @D36893, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36902, AGR [CASE @D36901, COUNT @D36900, PER @D36899, 
            PLU @D36898, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36907, AGR [CASE @D36906, COUNT @D36905, PER @D36904, 
            PLU @D36903, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DECLARE.

WORD declares : 
   [COORD @D36914, AGR [COUNT @D36913, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36916, 
      AGR [COUNT @D36915, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36918, 
      AGR [COUNT @D36917, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36920, 
      AGR [COUNT @D36919, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36922, 
      AGR [COUNT @D36921, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36924, 
      AGR [COUNT @D36923, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36926, 
      AGR [COUNT @D36925, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DECLARE, 
   [COORD @D36928, AGR [COUNT @D36927, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DECLARE, 
   [COORD @D36930, AGR [COUNT @D36929, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DECLARE, 
   [COORD @D36932, AGR [COUNT @D36931, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DECLARE.

WORD declaring : 
   [COORD @D36942, PRD @D36941, AGR [CASE @D36940, COUNT @D36939, 
            PER @D36938, PLU @D36937, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36948, PRD @D36947, 
      AGR [CASE @D36946, COUNT @D36945, PER @D36944, PLU @D36943, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DECLARE, 
   [COORD @D36954, PRD @D36953, AGR [CASE @D36952, COUNT @D36951, 
            PER @D36950, PLU @D36949, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36960, PRD @D36959, 
      AGR [CASE @D36958, COUNT @D36957, PER @D36956, PLU @D36955, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DECLARE, 
   [COORD @D36966, PRD @D36965, AGR [CASE @D36964, COUNT @D36963, 
            PER @D36962, PLU @D36961, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36972, PRD @D36971, 
      AGR [CASE @D36970, COUNT @D36969, PER @D36968, PLU @D36967, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DECLARE, 
   [COORD @D36978, PRD @D36977, AGR [CASE @D36976, COUNT @D36975, 
            PER @D36974, PLU @D36973, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, 
      PREP AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36984, PRD @D36983, 
      AGR [CASE @D36982, COUNT @D36981, PER @D36980, PLU @D36979, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DECLARE, 
   [COORD @D36990, PRD @D36989, AGR [CASE @D36988, COUNT @D36987, 
            PER @D36986, PLU @D36985, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DECLARE, 
   [COORD @D36996, PRD @D36995, 
      AGR [CASE @D36994, COUNT @D36993, PER @D36992, PLU @D36991, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DECLARE.

WORD dedicate : 
   [COORD @D37003, AGR [COUNT @D37002, PER @D37001, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEDICATE, 
   [COORD @D37005, AGR [COUNT @D37004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEDICATE, 
   [COORD @D37007, AGR [COUNT @D37006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEDICATE, 
   [COORD @D37011, AGR [COUNT @D37010, PER @D37009, PLU @D37008, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEDICATE, 
   [COORD @D37017, PAST @D37016, 
      AGR [CASE @D37015, COUNT @D37014, PER @D37013, PLU @D37012, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : DEDICATE, 
   [COORD @D37020, AGR [COUNT @D37019, PER @D37018, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, ARITY 3] : DEDICATE, 
   [COORD @D37022, 
      AGR [COUNT @D37021, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM TO, ORDER POSTNP, ARITY 3] : DEDICATE, 
   [COORD @D37024, AGR [COUNT @D37023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, ARITY 3] : DEDICATE, 
   [COORD @D37028, 
      AGR [COUNT @D37027, PER @D37026, PLU @D37025, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, ARITY 3] : DEDICATE, 
   [COORD @D37034, PAST @D37033, 
      AGR [CASE @D37032, COUNT @D37031, PER @D37030, PLU @D37029, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM TO, ORDER POSTNP, ARITY 3] : DEDICATE, 
   [COORD @D37037, AGR [COUNT @D37036, PER @D37035, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEDICATE, 
   [COORD @D37039, AGR [COUNT @D37038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEDICATE, 
   [COORD @D37041, AGR [COUNT @D37040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEDICATE, 
   [COORD @D37045, AGR [COUNT @D37044, PER @D37043, PLU @D37042, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DEDICATE, 
   [COORD @D37051, PAST @D37050, AGR [CASE @D37049, COUNT @D37048, 
            PER @D37047, PLU @D37046, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DEDICATE.

WORD dedicated : 
   [COADV @D37064, COORD @D37063, DEF @D37062, PRD @D37061, 
      AGR [CASE @D37060, COUNT @D37059, PER @D37058, PLU @D37057, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DEDICATED, 
   [COORD @D37069, 
      AGR [CASE @D37068, COUNT @D37067, PER @D37066, PLU @D37065, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37074, AGR [CASE @D37073, COUNT @D37072, PER @D37071, 
            PLU @D37070, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37079, AGR [CASE @D37078, COUNT @D37077, PER @D37076, 
            PLU @D37075, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37084, AGR [CASE @D37083, COUNT @D37082, PER @D37081, 
            PLU @D37080, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM TO, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37089, 
      AGR [CASE @D37088, COUNT @D37087, PER @D37086, PLU @D37085, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37094, AGR [CASE @D37093, COUNT @D37092, PER @D37091, 
            PLU @D37090, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : DEDICATE, 
   
   [COORD @D37099, AGR [CASE @D37098, COUNT @D37097, PER @D37096, PLU 
               @D37095, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DEDICATE, 
   [COORD @D37104, AGR [CASE @D37103, COUNT @D37102, PER @D37101, 
            PLU @D37100, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37109, AGR [CASE @D37108, COUNT @D37107, PER @D37106, 
            PLU @D37105, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEDICATE.

WORD dedicates : 
   [COORD @D37116, AGR [COUNT @D37115, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DEDICATE, 
   [COORD @D37118, AGR [COUNT @D37117, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST -, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37120, AGR [COUNT @D37119, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEDICATE.

WORD dedicating : 
   [COORD @D37130, PRD @D37129, AGR [CASE @D37128, COUNT @D37127, 
            PER @D37126, PLU @D37125, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37136, PRD @D37135, 
      AGR [CASE @D37134, COUNT @D37133, PER @D37132, PLU @D37131, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEDICATE, 
   [COORD @D37142, PRD @D37141, 
      AGR [CASE @D37140, COUNT @D37139, PER @D37138, PLU @D37137, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DEDICATE.

WORD defeat : 
   [COORD @D37150, REFL @D37149, COUNT @D37148, PRD @D37147, CASE 
         @D37146, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DEFEAT, 
   [COORD @D37153, 
      AGR [COUNT @D37152, PER @D37151, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   DEFEAT, 
   [COORD @D37155, AGR [COUNT @D37154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEFEAT, 
   [COORD @D37157, AGR [COUNT @D37156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEFEAT, 
   [COORD @D37161, AGR [COUNT @D37160, PER @D37159, PLU @D37158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DEFEAT, 
   [COORD @D37167, PAST @D37166, AGR [CASE @D37165, COUNT @D37164, 
            PER @D37163, PLU @D37162, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DEFEAT.

WORD defeated : 
   [COORD @D37177, AGR [CASE @D37176, COUNT @D37175, PER @D37174, 
            PLU @D37173, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DEFEAT, 
   [COORD @D37182, AGR [CASE @D37181, COUNT @D37180, PER @D37179, 
            PLU @D37178, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEFEAT, 
   [COORD @D37187, AGR [CASE @D37186, COUNT @D37185, PER @D37184, 
            PLU @D37183, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEFEAT.

WORD defeating : 
   [COORD @D37202, PRD @D37201, AGR [CASE @D37200, COUNT @D37199, 
            PER @D37198, PLU @D37197, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEFEAT.

WORD defeats : 
   [COORD @D37212, DEMON @D37211, REFL @D37210, PRD @D37209, 
      CASE @D37208, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DEFEAT, 
   [COORD @D37214, 
      AGR [COUNT @D37213, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEFEAT.

WORD deficit : 
   [COORD @D37221, REFL @D37220, PRD @D37219, CASE @D37218, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DEFICIT.

WORD deficits : 
   [COORD @D37230, DEMON @D37229, REFL @D37228, PRD @D37227, 
      CASE @D37226, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DEFICIT.

WORD define : 
   [COORD @D37237, AGR [COUNT @D37236, PER @D37235, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DEFINE, 
   [COORD @D37239, AGR [COUNT @D37238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DEFINE, 
   [COORD @D37241, AGR [COUNT @D37240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DEFINE, 
   [COORD @D37245, AGR [COUNT @D37244, PER @D37243, PLU @D37242, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DEFINE, 
   [COORD @D37251, PAST @D37250, 
      AGR [CASE @D37249, COUNT @D37248, PER @D37247, PLU @D37246, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : DEFINE, 
   [COORD @D37254, AGR [COUNT @D37253, PER @D37252, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEFINE, 
   [COORD @D37256, AGR [COUNT @D37255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEFINE, 
   [COORD @D37258, AGR [COUNT @D37257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEFINE, 
   [COORD @D37262, AGR [COUNT @D37261, PER @D37260, PLU @D37259, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DEFINE, 
   [COORD @D37268, PAST @D37267, AGR [CASE @D37266, COUNT @D37265, 
            PER @D37264, PLU @D37263, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DEFINE.

WORD defined : 
   [COORD @D37278, AGR [CASE @D37277, COUNT @D37276, PER @D37275, 
            PLU @D37274, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEFINE, 
   [COORD @D37283, AGR [CASE @D37282, COUNT @D37281, PER @D37280, 
            PLU @D37279, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEFINE, 
   [COORD @D37288, AGR [CASE @D37287, COUNT @D37286, PER @D37285, 
            PLU @D37284, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DEFINE, 
   [COORD @D37293, AGR [CASE @D37292, COUNT @D37291, PER @D37290, 
            PLU @D37289, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DEFINE, 
   [COORD @D37298, AGR [CASE @D37297, COUNT @D37296, PER @D37295, 
            PLU @D37294, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEFINE, 
   [COORD @D37303, AGR [CASE @D37302, COUNT @D37301, PER @D37300, 
            PLU @D37299, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEFINE.

WORD defines : 
   [COORD @D37310, AGR [COUNT @D37309, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DEFINE, 
   [COORD @D37312, AGR [COUNT @D37311, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEFINE.

WORD defining : 
   [COORD @D37322, PRD @D37321, AGR [CASE @D37320, COUNT @D37319, 
            PER @D37318, PLU @D37317, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEFINE, 
   [COORD @D37328, PRD @D37327, 
      AGR [CASE @D37326, COUNT @D37325, PER @D37324, PLU @D37323, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DEFINE.

WORD delay : 
   [COORD @D37336, REFL @D37335, COUNT @D37334, PRD @D37333, CASE 
         @D37332, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DELAY, 
   [COORD @D37339, 
      AGR [COUNT @D37338, PER @D37337, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : DELAY, 
   [COORD @D37341, AGR [COUNT @D37340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : DELAY, 
   [COORD @D37343, AGR [COUNT @D37342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : DELAY, 
   [COORD @D37347, AGR [COUNT @D37346, PER @D37345, PLU @D37344, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : DELAY, 
   [COORD @D37353, PAST @D37352, AGR [CASE @D37351, COUNT @D37350, 
            PER @D37349, PLU @D37348, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : DELAY, 
   [COORD @D37356, AGR [COUNT @D37355, PER @D37354, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELAY, 
   [COORD @D37358, AGR [COUNT @D37357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELAY, 
   [COORD @D37360, AGR [COUNT @D37359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELAY, 
   [COORD @D37364, AGR [COUNT @D37363, PER @D37362, PLU @D37361, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DELAY, 
   [COORD @D37370, PAST @D37369, AGR [CASE @D37368, COUNT @D37367, 
            PER @D37366, PLU @D37365, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DELAY, 
   [COORD @D37373, AGR [COUNT @D37372, PER @D37371, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELAY, 
   [COORD @D37375, AGR [COUNT @D37374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELAY, 
   [COORD @D37377, AGR [COUNT @D37376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELAY, 
   [COORD @D37381, AGR [COUNT @D37380, PER @D37379, PLU @D37378, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELAY, 
   [COORD @D37387, PAST @D37386, AGR [CASE @D37385, COUNT @D37384, 
            PER @D37383, PLU @D37382, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DELAY.

WORD delayed : 
   [COORD @D37397, AGR [CASE @D37396, COUNT @D37395, PER @D37394, 
            PLU @D37393, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELAY, 
   [COORD @D37402, AGR [CASE @D37401, COUNT @D37400, PER @D37399, 
            PLU @D37398, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELAY, 
   [COORD @D37407, AGR [CASE @D37406, COUNT @D37405, PER @D37404, 
            PLU @D37403, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELAY, 
   [COORD @D37412, AGR [CASE @D37411, COUNT @D37410, PER @D37409, 
            PLU @D37408, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELAY, 
   [COORD @D37417, AGR [CASE @D37416, COUNT @D37415, PER @D37414, 
            PLU @D37413, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DELAY, 
   [COORD @D37422, AGR [CASE @D37421, COUNT @D37420, PER @D37419, 
            PLU @D37418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELAY, 
   [COORD @D37427, AGR [CASE @D37426, COUNT @D37425, PER @D37424, 
            PLU @D37423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELAY.

WORD delaying : 
   [COORD @D37442, PRD @D37441, AGR [CASE @D37440, COUNT @D37439, 
            PER @D37438, PLU @D37437, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELAY, 
   [COORD @D37448, PRD @D37447, 
      AGR [CASE @D37446, COUNT @D37445, PER @D37444, PLU @D37443, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DELAY, 
   [COORD @D37454, PRD @D37453, AGR [CASE @D37452, COUNT @D37451, 
            PER @D37450, PLU @D37449, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELAY.

WORD delays : 
   [COORD @D37464, DEMON @D37463, REFL @D37462, PRD @D37461, CASE 
         @D37460, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DELAY, 
   [COORD @D37466, 
      AGR [COUNT @D37465, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELAY, 
   [COORD @D37468, 
      AGR [COUNT @D37467, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELAY, 
   [COORD @D37470, 
      AGR [COUNT @D37469, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELAY.

WORD delegate : 
   [COORD @D37479, REFL @D37478, PRD @D37477, CASE @D37476, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DELEGATE, 
   [COORD @D37482, 
      AGR [COUNT @D37481, PER @D37480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : DELEGATE, 
   [COORD @D37484, AGR [COUNT @D37483, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DELEGATE, 
   [COORD @D37486, AGR [COUNT @D37485, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DELEGATE, 
   [COORD @D37490, AGR [COUNT @D37489, PER @D37488, PLU @D37487, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DELEGATE, 
   [COORD @D37496, PAST @D37495, AGR 
         [CASE @D37494, COUNT @D37493, PER @D37492, PLU @D37491, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : 
   DELEGATE, 
   [COORD @D37499, AGR [COUNT @D37498, PER @D37497, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELEGATE, 
   [COORD @D37501, AGR [COUNT @D37500, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELEGATE, 
   [COORD @D37503, AGR [COUNT @D37502, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELEGATE, 
   [COORD @D37507, AGR [COUNT @D37506, PER @D37505, PLU @D37504, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELEGATE, 
   [COORD @D37513, PAST @D37512, 
      AGR [CASE @D37511, COUNT @D37510, PER @D37509, PLU @D37508, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : DELEGATE, 
   [COORD @D37516, AGR [COUNT @D37515, PER @D37514, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELEGATE, 
   [COORD @D37518, AGR [COUNT @D37517, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELEGATE, 
   [COORD @D37520, AGR [COUNT @D37519, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELEGATE, 
   [COORD @D37524, AGR [COUNT @D37523, PER @D37522, PLU @D37521, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DELEGATE, 
   [COORD @D37530, PAST @D37529, AGR [CASE @D37528, COUNT @D37527, 
            PER @D37526, PLU @D37525, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DELEGATE, 
   [COORD @D37533, AGR [COUNT @D37532, PER @D37531, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELEGATE, 
   [COORD @D37535, AGR [COUNT @D37534, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELEGATE, 
   [COORD @D37537, AGR [COUNT @D37536, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELEGATE, 
   [COORD @D37541, AGR [COUNT @D37540, PER @D37539, PLU @D37538, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELEGATE, 
   [COORD @D37547, PAST @D37546, AGR [CASE @D37545, COUNT @D37544, 
            PER @D37543, PLU @D37542, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DELEGATE.

WORD delegated : 
   [COORD @D37559, AGR [CASE @D37558, COUNT @D37557, PER @D37556, 
            PLU @D37555, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37564, AGR [CASE @D37563, COUNT @D37562, PER @D37561, 
            PLU @D37560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37570, AGR [CASE @D37569, NFORM @D37568, COUNT @D37567, 
            PER @D37566, PLU @D37565, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37575, AGR [CASE @D37574, COUNT @D37573, PER @D37572, 
            PLU @D37571, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37580, AGR [CASE @D37579, COUNT @D37578, PER @D37577, 
            PLU @D37576, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37585, AGR [CASE @D37584, COUNT @D37583, PER @D37582, 
            PLU @D37581, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37590, AGR [CASE @D37589, COUNT @D37588, PER @D37587, 
            PLU @D37586, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37595, AGR [CASE @D37594, COUNT @D37593, PER @D37592, 
            PLU @D37591, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37600, AGR [CASE @D37599, COUNT @D37598, PER @D37597, 
            PLU @D37596, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37605, AGR [CASE @D37604, COUNT @D37603, PER @D37602, 
            PLU @D37601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37610, AGR [CASE @D37609, COUNT @D37608, PER @D37607, 
            PLU @D37606, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELEGATE.

WORD delegates : 
   [COORD @D37622, DEMON @D37621, REFL @D37620, PRD @D37619, 
      CASE @D37618, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   DELEGATE, 
   [COORD @D37624, AGR [COUNT @D37623, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37626, 
      AGR [COUNT @D37625, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELEGATE, 
   
   [COORD @D37628, AGR [COUNT @D37627, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37630, 
      AGR [COUNT @D37629, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELEGATE.

WORD delegating : 
   [COORD @D37641, PRD @D37640, AGR [CASE @D37639, COUNT @D37638, 
            PER @D37637, PLU @D37636, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37647, PRD @D37646, 
      AGR [CASE @D37645, COUNT @D37644, PER @D37643, PLU @D37642, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DELEGATE, 
   [COORD @D37653, PRD @D37652, AGR [CASE @D37651, COUNT @D37650, 
            PER @D37649, PLU @D37648, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELEGATE, 
   [COORD @D37659, PRD @D37658, 
      AGR [CASE @D37657, COUNT @D37656, PER @D37655, PLU @D37654, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DELEGATE.

WORD deliver : 
   [COORD @D37665, AGR [COUNT @D37664, PER @D37663, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : DELIVER, 
   [COORD @D37667, AGR [COUNT @D37666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : DELIVER, 
   [COORD @D37669, AGR [COUNT @D37668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : DELIVER, 
   [COORD @D37673, AGR [COUNT @D37672, PER @D37671, PLU @D37670, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : DELIVER, 
   [COORD @D37679, PAST @D37678, AGR [CASE @D37677, COUNT @D37676, 
            PER @D37675, PLU @D37674, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : DELIVER, 
   [COORD @D37682, AGR [COUNT @D37681, PER @D37680, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37684, AGR [COUNT @D37683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37686, AGR [COUNT @D37685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37690, AGR [COUNT @D37689, PER @D37688, PLU @D37687, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37696, PAST @D37695, 
      AGR [CASE @D37694, COUNT @D37693, PER @D37692, PLU @D37691, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : DELIVER, 
   [COORD @D37699, AGR [COUNT @D37698, PER @D37697, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : DELIVER, 
   [COORD @D37701, AGR [COUNT @D37700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : DELIVER, 
   [COORD @D37703, AGR [COUNT @D37702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : DELIVER, 
   [COORD @D37707, AGR [COUNT @D37706, PER @D37705, PLU @D37704, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : DELIVER, 
   [COORD @D37713, PAST @D37712, 
      AGR [CASE @D37711, COUNT @D37710, PER @D37709, PLU @D37708, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, 
      ARITY 3] : DELIVER, 
   [COORD @D37716, AGR [COUNT @D37715, PER @D37714, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DELIVER, 
   [COORD @D37718, AGR [COUNT @D37717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DELIVER, 
   [COORD @D37720, AGR [COUNT @D37719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DELIVER, 
   [COORD @D37724, AGR [COUNT @D37723, PER @D37722, PLU @D37721, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DELIVER, 
   [COORD @D37730, PAST @D37729, 
      AGR [CASE @D37728, COUNT @D37727, PER @D37726, PLU @D37725, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : DELIVER, 
   [COORD @D37733, AGR [COUNT @D37732, PER @D37731, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37735, 
      AGR [COUNT @D37734, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, PFORM TO, 
      ARITY 3] : DELIVER, 
   [COORD @D37737, AGR [COUNT @D37736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37741, 
      AGR [COUNT @D37740, PER @D37739, PLU @D37738, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37747, PAST @D37746, 
      AGR [CASE @D37745, COUNT @D37744, PER @D37743, PLU @D37742, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM TO, ARITY 3] : DELIVER, 
   [COORD @D37750, AGR [COUNT @D37749, PER @D37748, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELIVER, 
   [COORD @D37752, AGR [COUNT @D37751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELIVER, 
   [COORD @D37754, AGR [COUNT @D37753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DELIVER, 
   [COORD @D37758, AGR [COUNT @D37757, PER @D37756, PLU @D37755, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DELIVER, 
   [COORD @D37764, PAST @D37763, AGR [CASE @D37762, COUNT @D37761, 
            PER @D37760, PLU @D37759, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DELIVER, 
   [COORD @D37767, AGR [COUNT @D37766, PER @D37765, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : DELIVER, 
   [COORD @D37769, AGR [COUNT @D37768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : DELIVER, 
   [COORD @D37771, AGR [COUNT @D37770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : DELIVER, 
   [COORD @D37775, AGR [COUNT @D37774, PER @D37773, PLU @D37772, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : DELIVER, 
   [COORD @D37781, PAST @D37780, 
      AGR [CASE @D37779, COUNT @D37778, PER @D37777, PLU @D37776, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      ARITY 2] : DELIVER, 
   [COORD @D37784, AGR [COUNT @D37783, PER @D37782, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DELIVER, 
   [COORD @D37786, AGR [COUNT @D37785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DELIVER, 
   [COORD @D37788, AGR [COUNT @D37787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DELIVER, 
   [COORD @D37792, AGR [COUNT @D37791, PER @D37790, PLU @D37789, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : DELIVER, 
   [COORD @D37798, PAST @D37797, 
      AGR [CASE @D37796, COUNT @D37795, PER @D37794, PLU @D37793, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : DELIVER, 
   [COORD @D37801, AGR [COUNT @D37800, PER @D37799, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELIVER, 
   [COORD @D37803, AGR [COUNT @D37802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELIVER, 
   [COORD @D37805, AGR [COUNT @D37804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELIVER, 
   [COORD @D37809, AGR [COUNT @D37808, PER @D37807, PLU @D37806, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DELIVER, 
   [COORD @D37815, PAST @D37814, AGR [CASE @D37813, COUNT @D37812, 
            PER @D37811, PLU @D37810, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DELIVER, 
   [COORD @D37818, AGR [COUNT @D37817, PER @D37816, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DELIVER, 
   [COORD @D37820, AGR [COUNT @D37819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DELIVER, 
   [COORD @D37822, AGR [COUNT @D37821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DELIVER, 
   [COORD @D37826, AGR [COUNT @D37825, PER @D37824, PLU @D37823, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DELIVER, 
   [COORD @D37832, PAST @D37831, 
      AGR [CASE @D37830, COUNT @D37829, PER @D37828, PLU @D37827, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : DELIVER.

WORD delivered : 
   [COORD @D37841, AGR [CASE @D37840, COUNT @D37839, PER @D37838, 
            PLU @D37837, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DELIVER, 
   [COORD @D37846, AGR [CASE @D37845, COUNT @D37844, PER @D37843, 
            PLU @D37842, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37851, AGR [CASE @D37850, COUNT @D37849, PER @D37848, 
            PLU @D37847, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37856, AGR [CASE @D37855, COUNT @D37854, PER @D37853, 
            PLU @D37852, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37861, AGR [CASE @D37860, COUNT @D37859, PER @D37858, 
            PLU @D37857, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37866, AGR [CASE @D37865, COUNT @D37864, PER @D37863, 
            PLU @D37862, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37871, AGR [CASE @D37870, COUNT @D37869, PER @D37868, 
            PLU @D37867, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37876, AGR [CASE @D37875, COUNT @D37874, PER @D37873, 
            PLU @D37872, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37881, AGR [CASE @D37880, COUNT @D37879, PER @D37878, 
            PLU @D37877, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37886, AGR [CASE @D37885, COUNT @D37884, PER @D37883, 
            PLU @D37882, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37891, AGR [CASE @D37890, COUNT @D37889, PER @D37888, 
            PLU @D37887, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37896, AGR [CASE @D37895, COUNT @D37894, PER @D37893, 
            PLU @D37892, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37901, AGR [CASE @D37900, COUNT @D37899, PER @D37898, 
            PLU @D37897, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37906, AGR [CASE @D37905, COUNT @D37904, PER @D37903, 
            PLU @D37902, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37911, 
      AGR [CASE @D37910, COUNT @D37909, PER @D37908, PLU @D37907, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : DELIVER, 
   [COORD @D37916, AGR [CASE @D37915, COUNT @D37914, PER @D37913, 
            PLU @D37912, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DELIVER, 
   [COORD @D37921, AGR [CASE @D37920, COUNT @D37919, PER @D37918, 
            PLU @D37917, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37926, AGR [CASE @D37925, COUNT @D37924, PER @D37923, 
            PLU @D37922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37931, AGR [CASE @D37930, COUNT @D37929, PER @D37928, 
            PLU @D37927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37936, AGR [CASE @D37935, COUNT @D37934, PER @D37933, 
            PLU @D37932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37941, AGR [CASE @D37940, COUNT @D37939, PER @D37938, 
            PLU @D37937, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37946, AGR [CASE @D37945, COUNT @D37944, PER @D37943, 
            PLU @D37942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37951, AGR [CASE @D37950, COUNT @D37949, PER @D37948, 
            PLU @D37947, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37956, AGR [CASE @D37955, COUNT @D37954, PER @D37953, 
            PLU @D37952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37961, AGR [CASE @D37960, COUNT @D37959, PER @D37958, 
            PLU @D37957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37966, AGR [CASE @D37965, COUNT @D37964, PER @D37963, 
            PLU @D37962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37971, AGR [CASE @D37970, COUNT @D37969, PER @D37968, 
            PLU @D37967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DELIVER.

WORD delivering : 
   [COORD @D37983, PRD @D37982, AGR [CASE @D37981, COUNT @D37980, 
            PER @D37979, PLU @D37978, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D37989, PRD @D37988, 
      AGR [CASE @D37987, COUNT @D37986, PER @D37985, PLU @D37984, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DELIVER, 
   [COORD @D37995, PRD @D37994, AGR [CASE @D37993, COUNT @D37992, 
            PER @D37991, PLU @D37990, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38001, PRD @D38000, 
      AGR [CASE @D37999, COUNT @D37998, PER @D37997, PLU @D37996, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DELIVER, 
   [COORD @D38007, PRD @D38006, AGR [CASE @D38005, COUNT @D38004, 
            PER @D38003, PLU @D38002, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38013, PRD @D38012, 
      AGR [CASE @D38011, COUNT @D38010, PER @D38009, PLU @D38008, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DELIVER, 
   [COORD @D38019, PRD @D38018, AGR [CASE @D38017, COUNT @D38016, 
            PER @D38015, PLU @D38014, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38025, PRD @D38024, 
      AGR [CASE @D38023, COUNT @D38022, PER @D38021, PLU @D38020, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DELIVER, 
   [COORD @D38031, PRD @D38030, AGR [CASE @D38029, COUNT @D38028, 
            PER @D38027, PLU @D38026, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38037, PRD @D38036, 
      AGR [CASE @D38035, COUNT @D38034, PER @D38033, PLU @D38032, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DELIVER.

WORD delivers : 
   [COORD @D38043, AGR [COUNT @D38042, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38045, 
      AGR [COUNT @D38044, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38047, 
      AGR [COUNT @D38046, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38049, 
      AGR [COUNT @D38048, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DELIVER, 
   [COORD @D38051, AGR [COUNT @D38050, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DELIVER, 
   [COORD @D38053, AGR [COUNT @D38052, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38055, 
      AGR [COUNT @D38054, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38057, 
      AGR [COUNT @D38056, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38059, 
      AGR [COUNT @D38058, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER, 
   [COORD @D38061, 
      AGR [COUNT @D38060, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DELIVER.

WORD demand : 
   [COORD @D38068, REFL @D38067, PRD @D38066, CASE @D38065, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : DEMAND, 
   [COORD @D38073, REFL @D38072, COUNT @D38071, PRD @D38070, 
      CASE @D38069, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DEMAND, 
   [COORD @D38078, REFL @D38077, COUNT @D38076, PRD @D38075, 
      CASE @D38074, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : 
   DEMAND, 
   [COORD @D38082, REFL @D38081, PRD @D38080, CASE @D38079, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, COUNT +] : DEMAND, 
   [COORD @D38086, REFL @D38085, PRD @D38084, CASE @D38083, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DEMAND, 
   [COORD @D38090, REFL @D38089, PRD @D38088, CASE @D38087, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : DEMAND, 
   [COORD @D38093, 
      AGR [COUNT @D38092, PER @D38091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : DEMAND, 
   [COORD @D38095, AGR [COUNT @D38094, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DEMAND, 
   [COORD @D38097, AGR [COUNT @D38096, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DEMAND, 
   [COORD @D38101, AGR [COUNT @D38100, PER @D38099, PLU @D38098, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DEMAND, 
   [COORD @D38107, PAST @D38106, AGR [CASE @D38105, COUNT @D38104, 
            PER @D38103, PLU @D38102, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DEMAND, 
   [COORD @D38110, AGR [COUNT @D38109, PER @D38108, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DEMAND, 
   [COORD @D38112, AGR [COUNT @D38111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DEMAND, 
   [COORD @D38114, AGR [COUNT @D38113, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DEMAND, 
   [COORD @D38118, AGR [COUNT @D38117, PER @D38116, PLU @D38115, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DEMAND, 
   [COORD @D38124, PAST @D38123, AGR [CASE @D38122, COUNT @D38121, 
            PER @D38120, PLU @D38119, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : DEMAND, 
   [COORD @D38127, AGR [COUNT @D38126, PER @D38125, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEMAND, 
   [COORD @D38129, AGR [COUNT @D38128, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEMAND, 
   [COORD @D38131, AGR [COUNT @D38130, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEMAND, 
   [COORD @D38135, AGR [COUNT @D38134, PER @D38133, PLU @D38132, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DEMAND, 
   [COORD @D38141, PAST @D38140, AGR [CASE @D38139, COUNT @D38138, 
            PER @D38137, PLU @D38136, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DEMAND.

WORD demanded : 
   [COORD @D38151, AGR [CASE @D38150, COUNT @D38149, PER @D38148, 
            PLU @D38147, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38156, AGR [CASE @D38155, COUNT @D38154, PER @D38153, 
            PLU @D38152, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38161, AGR [CASE @D38160, COUNT @D38159, PER @D38158, 
            PLU @D38157, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38166, AGR [CASE @D38165, COUNT @D38164, PER @D38163, 
            PLU @D38162, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38171, AGR [CASE @D38170, COUNT @D38169, PER @D38168, 
            PLU @D38167, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DEMAND, 
   [COORD @D38176, AGR [CASE @D38175, COUNT @D38174, PER @D38173, 
            PLU @D38172, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38181, AGR [CASE @D38180, COUNT @D38179, PER @D38178, 
            PLU @D38177, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEMAND.

WORD demanding : 
   [COORD @D38196, PRD @D38195, AGR [CASE @D38194, COUNT @D38193, 
            PER @D38192, PLU @D38191, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38202, PRD @D38201, 
      AGR [CASE @D38200, COUNT @D38199, PER @D38198, PLU @D38197, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DEMAND, 
   [COORD @D38208, PRD @D38207, AGR [CASE @D38206, COUNT @D38205, 
            PER @D38204, PLU @D38203, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEMAND.

WORD demands : 
   [COORD @D38218, DEMON @D38217, REFL @D38216, PRD @D38215, 
      CASE @D38214, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DEMAND, 
   [COORD @D38223, DEMON @D38222, REFL @D38221, PRD @D38220, 
      CASE @D38219, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   DEMAND, 
   [COORD @D38228, DEMON @D38227, REFL @D38226, PRD @D38225, CASE 
         @D38224, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SFIN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DEMAND, 
   [COORD @D38230, 
      AGR [COUNT @D38229, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38232, 
      AGR [COUNT @D38231, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEMAND, 
   [COORD @D38234, 
      AGR [COUNT @D38233, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEMAND.

WORD derive : 
   [COORD @D38245, AGR [COUNT @D38244, PER @D38243, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DERIVE, 
   [COORD @D38247, AGR [COUNT @D38246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DERIVE, 
   [COORD @D38249, AGR [COUNT @D38248, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DERIVE, 
   [COORD @D38253, AGR [COUNT @D38252, PER @D38251, PLU @D38250, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DERIVE, 
   [COORD @D38259, PAST @D38258, 
      AGR [CASE @D38257, COUNT @D38256, PER @D38255, PLU @D38254, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : DERIVE, 
   [COORD @D38262, AGR [COUNT @D38261, PER @D38260, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DERIVE, 
   [COORD @D38264, AGR [COUNT @D38263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DERIVE, 
   [COORD @D38266, AGR [COUNT @D38265, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DERIVE, 
   [COORD @D38270, AGR [COUNT @D38269, PER @D38268, PLU @D38267, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : DERIVE, 
   [COORD @D38276, PAST @D38275, 
      AGR [CASE @D38274, COUNT @D38273, PER @D38272, PLU @D38271, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, 
      ARITY 2] : DERIVE.

WORD derived : 
   [COORD @D38286, AGR [CASE @D38285, COUNT @D38284, PER @D38283, 
            PLU @D38282, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DERIVE, 
   [COORD @D38291, AGR [CASE @D38290, COUNT @D38289, PER @D38288, 
            PLU @D38287, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DERIVE, 
   [COORD @D38296, AGR [CASE @D38295, COUNT @D38294, PER @D38293, 
            PLU @D38292, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DERIVE, 
   [COORD @D38301, AGR [CASE @D38300, COUNT @D38299, PER @D38298, 
            PLU @D38297, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DERIVE, 
   [COORD @D38306, AGR [CASE @D38305, COUNT @D38304, PER @D38303, 
            PLU @D38302, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DERIVE, 
   [COORD @D38311, AGR [CASE @D38310, COUNT @D38309, PER @D38308, 
            PLU @D38307, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DERIVE.

WORD derives : 
   [COORD @D38318, AGR [COUNT @D38317, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DERIVE, 
   [COORD @D38320, AGR [COUNT @D38319, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DERIVE.

WORD deriving : 
   [COORD @D38330, PRD @D38329, AGR [CASE @D38328, COUNT @D38327, 
            PER @D38326, PLU @D38325, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DERIVE, 
   [COORD @D38336, PRD @D38335, 
      AGR [CASE @D38334, COUNT @D38333, PER @D38332, PLU @D38331, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DERIVE.

WORD describe : 
   [COORD @D38343, AGR [COUNT @D38342, PER @D38341, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : DESCRIBE, 
   [COORD @D38345, AGR [COUNT @D38344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : DESCRIBE, 
   [COORD @D38347, AGR [COUNT @D38346, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : DESCRIBE, 
   [COORD @D38351, AGR [COUNT @D38350, PER @D38349, PLU @D38348, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : DESCRIBE, 
   [COORD @D38357, PAST @D38356, 
      AGR [CASE @D38355, COUNT @D38354, PER @D38353, PLU @D38352, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, 
      ARITY 3] : DESCRIBE, 
   [COORD @D38360, AGR [COUNT @D38359, PER @D38358, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DESCRIBE, 
   [COORD @D38362, AGR [COUNT @D38361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DESCRIBE, 
   [COORD @D38364, AGR [COUNT @D38363, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DESCRIBE, 
   [COORD @D38368, AGR [COUNT @D38367, PER @D38366, PLU @D38365, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : DESCRIBE, 
   [COORD @D38374, PAST @D38373, 
      AGR [CASE @D38372, COUNT @D38371, PER @D38370, PLU @D38369, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : DESCRIBE, 
   [COORD @D38377, AGR [COUNT @D38376, PER @D38375, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DESCRIBE, 
   [COORD @D38379, AGR [COUNT @D38378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DESCRIBE, 
   [COORD @D38381, AGR [COUNT @D38380, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DESCRIBE, 
   [COORD @D38385, AGR [COUNT @D38384, PER @D38383, PLU @D38382, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DESCRIBE, 
   [COORD @D38391, PAST @D38390, AGR [CASE @D38389, COUNT @D38388, 
            PER @D38387, PLU @D38386, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : DESCRIBE, 
   [COORD @D38394, AGR [COUNT @D38393, PER @D38392, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DESCRIBE, 
   [COORD @D38396, AGR [COUNT @D38395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DESCRIBE, 
   [COORD @D38398, AGR [COUNT @D38397, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DESCRIBE, 
   [COORD @D38402, AGR [COUNT @D38401, PER @D38400, PLU @D38399, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : DESCRIBE, 
   [COORD @D38408, PAST @D38407, AGR [CASE @D38406, COUNT @D38405, 
            PER @D38404, PLU @D38403, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : DESCRIBE, 
   [COORD @D38411, AGR [COUNT @D38410, PER @D38409, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESCRIBE, 
   [COORD @D38413, AGR [COUNT @D38412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESCRIBE, 
   [COORD @D38415, AGR [COUNT @D38414, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESCRIBE, 
   [COORD @D38419, AGR [COUNT @D38418, PER @D38417, PLU @D38416, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DESCRIBE, 
   [COORD @D38425, PAST @D38424, AGR [CASE @D38423, COUNT @D38422, 
            PER @D38421, PLU @D38420, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DESCRIBE.

WORD described : 
   [COORD @D38435, AGR [CASE @D38434, COUNT @D38433, PER @D38432, 
            PLU @D38431, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38440, AGR [CASE @D38439, COUNT @D38438, PER @D38437, 
            PLU @D38436, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38446, AGR [CASE @D38445, NFORM @D38444, COUNT @D38443, 
            PER @D38442, PLU @D38441, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, PREP AS, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38451, AGR [CASE @D38450, COUNT @D38449, PER @D38448, 
            PLU @D38447, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38456, AGR [CASE @D38455, COUNT @D38454, PER @D38453, 
            PLU @D38452, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38461, AGR [CASE @D38460, COUNT @D38459, PER @D38458, 
            PLU @D38457, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38466, AGR [CASE @D38465, COUNT @D38464, PER @D38463, 
            PLU @D38462, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38471, AGR [CASE @D38470, COUNT @D38469, PER @D38468, 
            PLU @D38467, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38476, AGR [CASE @D38475, COUNT @D38474, PER @D38473, 
            PLU @D38472, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38481, AGR [CASE @D38480, COUNT @D38479, PER @D38478, 
            PLU @D38477, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38486, AGR [CASE @D38485, COUNT @D38484, PER @D38483, 
            PLU @D38482, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38491, AGR [CASE @D38490, COUNT @D38489, PER @D38488, 
            PLU @D38487, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38496, AGR [CASE @D38495, COUNT @D38494, PER @D38493, 
            PLU @D38492, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESCRIBE.

WORD describes : 
   [COORD @D38503, AGR [COUNT @D38502, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESCRIBE, 
   
   [COORD @D38505, AGR [COUNT @D38504, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DESCRIBE, 
   [COORD @D38507, AGR [COUNT @D38506, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38509, 
      AGR [COUNT @D38508, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38511, 
      AGR [COUNT @D38510, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESCRIBE.

WORD describing : 
   [COORD @D38521, PRD @D38520, AGR [CASE @D38519, COUNT @D38518, 
            PER @D38517, PLU @D38516, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38527, PRD @D38526, 
      AGR [CASE @D38525, COUNT @D38524, PER @D38523, PLU @D38522, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DESCRIBE, 
   [COORD @D38533, PRD @D38532, AGR [CASE @D38531, COUNT @D38530, 
            PER @D38529, PLU @D38528, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESCRIBE, 
   [COORD @D38539, PRD @D38538, 
      AGR [CASE @D38537, COUNT @D38536, PER @D38535, PLU @D38534, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DESCRIBE, 
   [COORD @D38545, PRD @D38544, AGR [CASE @D38543, COUNT @D38542, 
            PER @D38541, PLU @D38540, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESCRIBE.

WORD design : 
   [COORD @D38551, AGR [COUNT @D38550, PER @D38549, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DESIGN, 
   [COORD @D38553, AGR [COUNT @D38552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DESIGN, 
   [COORD @D38555, AGR [COUNT @D38554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DESIGN, 
   [COORD @D38559, AGR [COUNT @D38558, PER @D38557, PLU @D38556, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DESIGN, 
   [COORD @D38565, PAST @D38564, AGR [CASE @D38563, COUNT @D38562, 
            PER @D38561, PLU @D38560, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : DESIGN, 
   [COORD @D38568, AGR [COUNT @D38567, PER @D38566, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESIGN, 
   [COORD @D38570, AGR [COUNT @D38569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESIGN, 
   [COORD @D38572, AGR [COUNT @D38571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESIGN, 
   [COORD @D38576, AGR [COUNT @D38575, PER @D38574, PLU @D38573, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DESIGN, 
   [COORD @D38582, PAST @D38581, AGR [CASE @D38580, COUNT @D38579, 
            PER @D38578, PLU @D38577, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DESIGN, 
   [COORD @D38585, AGR [COUNT @D38584, PER @D38583, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESIGN, 
   [COORD @D38587, AGR [COUNT @D38586, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESIGN, 
   [COORD @D38589, AGR [COUNT @D38588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESIGN, 
   [COORD @D38593, AGR [COUNT @D38592, PER @D38591, PLU @D38590, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESIGN, 
   [COORD @D38599, PAST @D38598, AGR [CASE @D38597, COUNT @D38596, 
            PER @D38595, PLU @D38594, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DESIGN.

WORD designed : 
   [COORD @D38608, AGR [CASE @D38607, COUNT @D38606, PER @D38605, 
            PLU @D38604, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38613, AGR [CASE @D38612, COUNT @D38611, PER @D38610, 
            PLU @D38609, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38619, AGR [CASE @D38618, NFORM @D38617, COUNT @D38616, 
            PER @D38615, PLU @D38614, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DESIGN, 
   [COORD @D38624, AGR [CASE @D38623, COUNT @D38622, PER @D38621, 
            PLU @D38620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38629, AGR [CASE @D38628, COUNT @D38627, PER @D38626, 
            PLU @D38625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38634, AGR [CASE @D38633, COUNT @D38632, PER @D38631, 
            PLU @D38630, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DESIGN, 
   [COORD @D38639, AGR [CASE @D38638, COUNT @D38637, PER @D38636, 
            PLU @D38635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38644, AGR [CASE @D38643, COUNT @D38642, PER @D38641, 
            PLU @D38640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESIGN.

WORD designing : 
   [COORD @D38656, PRD @D38655, AGR [CASE @D38654, COUNT @D38653, 
            PER @D38652, PLU @D38651, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38662, PRD @D38661, 
      AGR [CASE @D38660, COUNT @D38659, PER @D38658, PLU @D38657, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DESIGN, 
   [COORD @D38668, PRD @D38667, AGR [CASE @D38666, COUNT @D38665, 
            PER @D38664, PLU @D38663, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESIGN.

WORD designs : 
   [COORD @D38674, AGR [COUNT @D38673, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38676, 
      AGR [COUNT @D38675, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESIGN, 
   [COORD @D38678, 
      AGR [COUNT @D38677, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESIGN.

WORD desire : 
   [COORD @D38688, REFL @D38687, COUNT @D38686, PRD @D38685, CASE 
         @D38684, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DESIRE, 
   [COORD @D38693, REFL @D38692, COUNT @D38691, PRD @D38690, 
      CASE @D38689, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : 
   DESIRE, 
   [COORD @D38698, REFL @D38697, COUNT @D38696, PRD @D38695, CASE 
         @D38694, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT VPINF] : DESIRE, 
   [COORD @D38703, REFL @D38702, COUNT @D38701, PRD @D38700, 
      CASE @D38699, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SBSE] : DESIRE, 
   [COORD @D38707, REFL @D38706, PRD @D38705, CASE @D38704, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, COUNT +] : DESIRE, 
   [COORD @D38710, 
      AGR [COUNT @D38709, PER @D38708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : DESIRE, 
   [COORD @D38712, AGR [COUNT @D38711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DESIRE, 
   [COORD @D38714, AGR [COUNT @D38713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DESIRE, 
   [COORD @D38718, AGR [COUNT @D38717, PER @D38716, PLU @D38715, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DESIRE, 
   [COORD @D38724, PAST @D38723, AGR [CASE @D38722, COUNT @D38721, 
            PER @D38720, PLU @D38719, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DESIRE, 
   [COORD @D38727, AGR [COUNT @D38726, PER @D38725, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DESIRE, 
   [COORD @D38729, AGR [COUNT @D38728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DESIRE, 
   [COORD @D38731, AGR [COUNT @D38730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DESIRE, 
   [COORD @D38735, AGR [COUNT @D38734, PER @D38733, PLU @D38732, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DESIRE, 
   [COORD @D38741, PAST @D38740, AGR [CASE @D38739, COUNT @D38738, 
            PER @D38737, PLU @D38736, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : DESIRE, 
   [COORD @D38744, AGR [COUNT @D38743, PER @D38742, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DESIRE, 
   [COORD @D38746, AGR [COUNT @D38745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DESIRE, 
   [COORD @D38748, AGR [COUNT @D38747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DESIRE, 
   [COORD @D38752, AGR [COUNT @D38751, PER @D38750, PLU @D38749, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DESIRE, 
   [COORD @D38758, PAST @D38757, AGR [CASE @D38756, COUNT @D38755, 
            PER @D38754, PLU @D38753, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : DESIRE, 
   [COORD @D38761, AGR [COUNT @D38760, PER @D38759, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESIRE, 
   [COORD @D38763, AGR [COUNT @D38762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESIRE, 
   [COORD @D38765, AGR [COUNT @D38764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DESIRE, 
   [COORD @D38769, AGR [COUNT @D38768, PER @D38767, PLU @D38766, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DESIRE, 
   [COORD @D38775, PAST @D38774, AGR [CASE @D38773, COUNT @D38772, 
            PER @D38771, PLU @D38770, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DESIRE.

WORD desired : 
   [COORD @D38787, AGR [CASE @D38786, COUNT @D38785, PER @D38784, 
            PLU @D38783, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38792, AGR [CASE @D38791, COUNT @D38790, PER @D38789, 
            PLU @D38788, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38797, AGR [CASE @D38796, COUNT @D38795, PER @D38794, 
            PLU @D38793, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38802, AGR [CASE @D38801, COUNT @D38800, PER @D38799, 
            PLU @D38798, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38807, AGR [CASE @D38806, COUNT @D38805, PER @D38804, 
            PLU @D38803, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38812, AGR [CASE @D38811, COUNT @D38810, PER @D38809, 
            PLU @D38808, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38818, AGR [CASE @D38817, NFORM @D38816, COUNT @D38815, 
            PER @D38814, PLU @D38813, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DESIRE, 
   [COORD @D38823, AGR [UB @D38822, VFORM @D38821, SUBJ @D38820, 
            FIN @D38819, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DESIRE, 
   [COORD @D38828, AGR [CASE @D38827, COUNT @D38826, PER @D38825, 
            PLU @D38824, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DESIRE, 
   [COORD @D38833, AGR [CASE @D38832, COUNT @D38831, PER @D38830, 
            PLU @D38829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38838, AGR [CASE @D38837, COUNT @D38836, PER @D38835, 
            PLU @D38834, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESIRE.

WORD desires : 
   [COORD @D38850, DEMON @D38849, REFL @D38848, PRD @D38847, 
      CASE @D38846, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DESIRE, 
   [COORD @D38855, DEMON @D38854, REFL @D38853, PRD @D38852, 
      CASE @D38851, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   DESIRE, 
   [COORD @D38860, DEMON @D38859, REFL @D38858, PRD @D38857, CASE 
         @D38856, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DESIRE, 
   [COORD @D38865, DEMON @D38864, REFL @D38863, PRD @D38862, 
      CASE @D38861, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SBSE, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DESIRE, 
   [COORD @D38870, DEMON @D38869, REFL @D38868, PRD @D38867, 
      CASE @D38866, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SFIN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DESIRE, 
   [COORD @D38872, 
      AGR [COUNT @D38871, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38874, 
      AGR [COUNT @D38873, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38876, 
      AGR [COUNT @D38875, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38878, 
      AGR [COUNT @D38877, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESIRE.

WORD desiring : 
   [COORD @D38889, PRD @D38888, AGR [CASE @D38887, COUNT @D38886, 
            PER @D38885, PLU @D38884, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38895, PRD @D38894, 
      AGR [CASE @D38893, COUNT @D38892, PER @D38891, PLU @D38890, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DESIRE, 
   [COORD @D38901, PRD @D38900, AGR [CASE @D38899, COUNT @D38898, 
            PER @D38897, PLU @D38896, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESIRE, 
   [COORD @D38907, PRD @D38906, 
      AGR [CASE @D38905, COUNT @D38904, PER @D38903, PLU @D38902, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DESIRE.

WORD despair : 
   [COORD @D38914, REFL @D38913, PRD @D38912, CASE @D38911, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : DESPAIR, 
   [COORD @D38918, REFL @D38917, PRD @D38916, CASE @D38915, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : DESPAIR, 
   [COORD @D38921, AGR [COUNT @D38920, PER @D38919, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DESPAIR, 
   [COORD @D38923, AGR [COUNT @D38922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DESPAIR, 
   [COORD @D38925, AGR [COUNT @D38924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DESPAIR, 
   [COORD @D38929, AGR [COUNT @D38928, PER @D38927, PLU @D38926, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OF, ARITY 2] : DESPAIR, 
   [COORD @D38935, PAST @D38934, 
      AGR [CASE @D38933, COUNT @D38932, PER @D38931, PLU @D38930, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, 
      ARITY 2] : DESPAIR, 
   [COORD @D38938, AGR [COUNT @D38937, PER @D38936, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESPAIR, 
   [COORD @D38940, AGR [COUNT @D38939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESPAIR, 
   [COORD @D38942, AGR [COUNT @D38941, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESPAIR, 
   [COORD @D38946, AGR [COUNT @D38945, PER @D38944, PLU @D38943, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DESPAIR, 
   [COORD @D38952, PAST @D38951, AGR [CASE @D38950, COUNT @D38949, 
            PER @D38948, PLU @D38947, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DESPAIR.

WORD despaired : 
   [COORD @D38962, AGR [CASE @D38961, COUNT @D38960, PER @D38959, 
            PLU @D38958, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DESPAIR, 
   [COORD @D38967, AGR [CASE @D38966, COUNT @D38965, PER @D38964, 
            PLU @D38963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DESPAIR, 
   [COORD @D38972, AGR [CASE @D38971, COUNT @D38970, PER @D38969, 
            PLU @D38968, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DESPAIR, 
   [COORD @D38977, AGR [CASE @D38976, COUNT @D38975, PER @D38974, 
            PLU @D38973, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DESPAIR.

WORD despairing : 
   [COORD @D38990, PRD @D38989, AGR [CASE @D38988, COUNT @D38987, 
            PER @D38986, PLU @D38985, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DESPAIR, 
   [COORD @D38996, PRD @D38995, 
      AGR [CASE @D38994, COUNT @D38993, PER @D38992, PLU @D38991, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DESPAIR.

WORD despairs : 
   [COORD @D39003, AGR [COUNT @D39002, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESPAIR, 
   [COORD @D39005, 
      AGR [COUNT @D39004, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DESPAIR.

WORD detain : 
   [COORD @D39011, AGR [COUNT @D39010, PER @D39009, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DETAIN, 
   [COORD @D39013, AGR [COUNT @D39012, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DETAIN, 
   [COORD @D39015, AGR [COUNT @D39014, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DETAIN, 
   [COORD @D39019, AGR [COUNT @D39018, PER @D39017, PLU @D39016, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DETAIN, 
   [COORD @D39025, PAST @D39024, AGR [CASE @D39023, COUNT @D39022, 
            PER @D39021, PLU @D39020, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : DETAIN, 
   [COORD @D39028, AGR [COUNT @D39027, PER @D39026, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DETAIN, 
   [COORD @D39030, AGR [COUNT @D39029, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DETAIN, 
   [COORD @D39032, AGR [COUNT @D39031, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DETAIN, 
   [COORD @D39036, AGR [COUNT @D39035, PER @D39034, PLU @D39033, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DETAIN, 
   [COORD @D39042, PAST @D39041, AGR [CASE @D39040, COUNT @D39039, 
            PER @D39038, PLU @D39037, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DETAIN.

WORD detained : 
   [COORD @D39051, AGR [CASE @D39050, COUNT @D39049, PER @D39048, 
            PLU @D39047, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DETAIN, 
   [COORD @D39056, AGR [CASE @D39055, COUNT @D39054, PER @D39053, 
            PLU @D39052, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DETAIN, 
   [COORD @D39061, AGR [CASE @D39060, COUNT @D39059, PER @D39058, 
            PLU @D39057, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DETAIN, 
   [COORD @D39066, AGR [CASE @D39065, COUNT @D39064, PER @D39063, 
            PLU @D39062, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DETAIN, 
   [COORD @D39071, AGR [CASE @D39070, COUNT @D39069, PER @D39068, 
            PLU @D39067, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DETAIN, 
   [COORD @D39076, AGR [CASE @D39075, COUNT @D39074, PER @D39073, 
            PLU @D39072, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DETAIN.

WORD detaining : 
   [COORD @D39088, PRD @D39087, AGR [CASE @D39086, COUNT @D39085, 
            PER @D39084, PLU @D39083, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DETAIN, 
   [COORD @D39094, PRD @D39093, 
      AGR [CASE @D39092, COUNT @D39091, PER @D39090, PLU @D39089, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DETAIN.

WORD detains : 
   [COORD @D39100, AGR [COUNT @D39099, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DETAIN, 
   [COORD @D39102, 
      AGR [COUNT @D39101, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DETAIN.

WORD develop : 
   [COORD @D39108, AGR [COUNT @D39107, PER @D39106, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DEVELOP, 
   [COORD @D39110, AGR [COUNT @D39109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DEVELOP, 
   [COORD @D39112, AGR [COUNT @D39111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DEVELOP, 
   [COORD @D39116, AGR [COUNT @D39115, PER @D39114, PLU @D39113, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DEVELOP, 
   [COORD @D39122, PAST @D39121, 
      AGR [CASE @D39120, COUNT @D39119, PER @D39118, PLU @D39117, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM INTO, 
      ARITY 3] : DEVELOP, 
   [COORD @D39125, AGR [COUNT @D39124, PER @D39123, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DEVELOP, 
   [COORD @D39127, AGR [COUNT @D39126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DEVELOP, 
   [COORD @D39129, AGR [COUNT @D39128, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DEVELOP, 
   [COORD @D39133, AGR [COUNT @D39132, PER @D39131, PLU @D39130, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DEVELOP, 
   [COORD @D39139, PAST @D39138, 
      AGR [CASE @D39137, COUNT @D39136, PER @D39135, PLU @D39134, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : DEVELOP, 
   [COORD @D39142, AGR [COUNT @D39141, PER @D39140, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEVELOP, 
   [COORD @D39144, AGR [COUNT @D39143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEVELOP, 
   [COORD @D39146, AGR [COUNT @D39145, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DEVELOP, 
   [COORD @D39150, AGR [COUNT @D39149, PER @D39148, PLU @D39147, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DEVELOP, 
   [COORD @D39156, PAST @D39155, AGR [CASE @D39154, COUNT @D39153, 
            PER @D39152, PLU @D39151, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DEVELOP, 
   [COORD @D39159, AGR [COUNT @D39158, PER @D39157, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : DEVELOP, 
   [COORD @D39161, AGR [COUNT @D39160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : DEVELOP, 
   [COORD @D39163, AGR [COUNT @D39162, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : DEVELOP, 
   [COORD @D39167, AGR [COUNT @D39166, PER @D39165, PLU @D39164, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : DEVELOP, 
   [COORD @D39173, PAST @D39172, 
      AGR [CASE @D39171, COUNT @D39170, PER @D39169, PLU @D39168, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM INTO, 
      ARITY 2] : DEVELOP, 
   [COORD @D39176, AGR [COUNT @D39175, PER @D39174, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DEVELOP, 
   [COORD @D39178, AGR [COUNT @D39177, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DEVELOP, 
   [COORD @D39180, AGR [COUNT @D39179, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DEVELOP, 
   [COORD @D39184, AGR [COUNT @D39183, PER @D39182, PLU @D39181, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : DEVELOP, 
   [COORD @D39190, PAST @D39189, 
      AGR [CASE @D39188, COUNT @D39187, PER @D39186, PLU @D39185, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, 
      ARITY 2] : DEVELOP, 
   [COORD @D39193, AGR [COUNT @D39192, PER @D39191, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEVELOP, 
   [COORD @D39195, AGR [COUNT @D39194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEVELOP, 
   [COORD @D39197, AGR [COUNT @D39196, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEVELOP, 
   [COORD @D39201, AGR [COUNT @D39200, PER @D39199, PLU @D39198, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DEVELOP, 
   [COORD @D39207, PAST @D39206, AGR [CASE @D39205, COUNT @D39204, 
            PER @D39203, PLU @D39202, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DEVELOP.

WORD developed : 
   [COORD @D39216, AGR [CASE @D39215, COUNT @D39214, PER @D39213, 
            PLU @D39212, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39221, AGR [CASE @D39220, COUNT @D39219, PER @D39218, 
            PLU @D39217, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39226, AGR [CASE @D39225, COUNT @D39224, PER @D39223, 
            PLU @D39222, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39231, AGR [CASE @D39230, COUNT @D39229, PER @D39228, 
            PLU @D39227, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39236, AGR [CASE @D39235, COUNT @D39234, PER @D39233, 
            PLU @D39232, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39241, AGR [CASE @D39240, COUNT @D39239, PER @D39238, 
            PLU @D39237, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39246, AGR [CASE @D39245, COUNT @D39244, PER @D39243, 
            PLU @D39242, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39251, AGR [CASE @D39250, COUNT @D39249, PER @D39248, 
            PLU @D39247, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39256, AGR [CASE @D39255, COUNT @D39254, PER @D39253, 
            PLU @D39252, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39261, AGR [CASE @D39260, COUNT @D39259, PER @D39258, 
            PLU @D39257, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39266, AGR [CASE @D39265, COUNT @D39264, PER @D39263, 
            PLU @D39262, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39271, AGR [CASE @D39270, COUNT @D39269, PER @D39268, 
            PLU @D39267, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39276, AGR [CASE @D39275, COUNT @D39274, PER @D39273, 
            PLU @D39272, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39281, AGR [CASE @D39280, COUNT @D39279, PER @D39278, 
            PLU @D39277, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39286, AGR [CASE @D39285, COUNT @D39284, PER @D39283, 
            PLU @D39282, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DEVELOP.

WORD developing : 
   [COORD @D39298, PRD @D39297, AGR [CASE @D39296, COUNT @D39295, 
            PER @D39294, PLU @D39293, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39304, PRD @D39303, 
      AGR [CASE @D39302, COUNT @D39301, PER @D39300, PLU @D39299, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DEVELOP, 
   [COORD @D39310, PRD @D39309, AGR [CASE @D39308, COUNT @D39307, 
            PER @D39306, PLU @D39305, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39316, PRD @D39315, 
      AGR [CASE @D39314, COUNT @D39313, PER @D39312, PLU @D39311, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DEVELOP, 
   [COORD @D39322, PRD @D39321, AGR [CASE @D39320, COUNT @D39319, 
            PER @D39318, PLU @D39317, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39328, PRD @D39327, 
      AGR [CASE @D39326, COUNT @D39325, PER @D39324, PLU @D39323, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DEVELOP.

WORD develops : 
   [COORD @D39334, AGR [COUNT @D39333, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DEVELOP, 
   [COORD @D39336, AGR [COUNT @D39335, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DEVELOP, 
   [COORD @D39338, AGR [COUNT @D39337, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39340, 
      AGR [COUNT @D39339, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39342, 
      AGR [COUNT @D39341, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEVELOP, 
   [COORD @D39344, 
      AGR [COUNT @D39343, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DEVELOP.

WORD devote : 
   [COORD @D39351, AGR [COUNT @D39350, PER @D39349, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEVOTE, 
   [COORD @D39353, AGR [COUNT @D39352, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEVOTE, 
   [COORD @D39355, AGR [COUNT @D39354, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEVOTE, 
   [COORD @D39359, AGR [COUNT @D39358, PER @D39357, PLU @D39356, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DEVOTE, 
   [COORD @D39365, PAST @D39364, 
      AGR [CASE @D39363, COUNT @D39362, PER @D39361, PLU @D39360, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : DEVOTE.

WORD devoted : 
   [COADV @D39378, COORD @D39377, DEF @D39376, PRD @D39375, AGR 
            [CASE @D39374, COUNT @D39373, PER @D39372, PLU @D39371, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   DEVOTED, 
   [COADV @D39386, COORD @D39385, DEF @D39384, PRD @D39383, AGR 
            [CASE @D39382, COUNT @D39381, PER @D39380, PLU @D39379, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, DISTR PRD, 
      ARITY 2] : DEVOTED, 
   [COORD @D39391, AGR [CASE @D39390, COUNT @D39389, PER @D39388, 
            PLU @D39387, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DEVOTE, 
   [COORD @D39396, AGR [CASE @D39395, COUNT @D39394, PER @D39393, 
            PLU @D39392, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DEVOTE, 
   [COORD @D39401, AGR [CASE @D39400, COUNT @D39399, PER @D39398, 
            PLU @D39397, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DEVOTE.

WORD devotes : 
   [COORD @D39408, AGR [COUNT @D39407, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DEVOTE.

WORD devoting : 
   [COORD @D39418, PRD @D39417, AGR [CASE @D39416, COUNT @D39415, 
            PER @D39414, PLU @D39413, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DEVOTE.

WORD die : 
   [COORD @D39425, AGR [COUNT @D39424, PER @D39423, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : DIE, 
   [COORD @D39427, AGR [COUNT @D39426, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : DIE, 
   [COORD @D39429, AGR [COUNT @D39428, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : DIE, 
   [COORD @D39433, AGR [COUNT @D39432, PER @D39431, PLU @D39430, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : DIE, 
   [COORD @D39439, PAST @D39438, AGR [CASE @D39437, COUNT @D39436, 
            PER @D39435, PLU @D39434, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : DIE, 
   [COORD @D39442, AGR [COUNT @D39441, PER @D39440, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DIE, 
   [COORD @D39444, AGR [COUNT @D39443, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DIE, 
   [COORD @D39446, AGR [COUNT @D39445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DIE, 
   [COORD @D39450, AGR [COUNT @D39449, PER @D39448, PLU @D39447, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : DIE, 
   [COORD @D39456, PAST @D39455, AGR [CASE @D39454, COUNT @D39453, 
            PER @D39452, PLU @D39451, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DIE, 
   [COORD @D39459, AGR [COUNT @D39458, PER @D39457, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DIE, 
   [COORD @D39461, AGR [COUNT @D39460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DIE, 
   [COORD @D39463, AGR [COUNT @D39462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DIE, 
   [COORD @D39467, AGR [COUNT @D39466, PER @D39465, PLU @D39464, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DIE, 
   [COORD @D39473, PAST @D39472, AGR [CASE @D39471, COUNT @D39470, 
            PER @D39469, PLU @D39468, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : DIE, 
   [COORD @D39476, AGR [COUNT @D39475, PER @D39474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIE, 
   [COORD @D39478, AGR [COUNT @D39477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIE, 
   [COORD @D39480, AGR [COUNT @D39479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIE, 
   [COORD @D39484, AGR [COUNT @D39483, PER @D39482, PLU @D39481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DIE, 
   [COORD @D39490, PAST @D39489, AGR [CASE @D39488, COUNT @D39487, 
            PER @D39486, PLU @D39485, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DIE, 
   [COORD @D39493, AGR [COUNT @D39492, PER @D39491, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DIE, 
   [COORD @D39495, AGR [COUNT @D39494, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DIE, 
   [COORD @D39497, AGR [COUNT @D39496, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DIE, 
   [COORD @D39501, AGR [COUNT @D39500, PER @D39499, PLU @D39498, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OF, ARITY 2] : DIE, 
   [COORD @D39507, PAST @D39506, 
      AGR [CASE @D39505, COUNT @D39504, PER @D39503, PLU @D39502, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, 
      ARITY 2] : DIE, 
   [COORD @D39510, AGR [COUNT @D39509, PER @D39508, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : DIE, 
   [COORD @D39512, AGR [COUNT @D39511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : DIE, 
   [COORD @D39514, AGR [COUNT @D39513, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : DIE, 
   [COORD @D39518, AGR [COUNT @D39517, PER @D39516, PLU @D39515, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : DIE, 
   [COORD @D39524, PAST @D39523, 
      AGR [CASE @D39522, COUNT @D39521, PER @D39520, PLU @D39519, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : DIE, 
   [COORD @D39527, AGR [COUNT @D39526, PER @D39525, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIE, 
   [COORD @D39529, AGR [COUNT @D39528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIE, 
   [COORD @D39531, AGR [COUNT @D39530, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIE, 
   [COORD @D39535, AGR [COUNT @D39534, PER @D39533, PLU @D39532, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIE, 
   [COORD @D39541, PAST @D39540, AGR [CASE @D39539, COUNT @D39538, 
            PER @D39537, PLU @D39536, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DIE, 
   [COORD @D39544, AGR [COUNT @D39543, PER @D39542, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DIE, 
   [COORD @D39546, AGR [COUNT @D39545, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DIE, 
   [COORD @D39548, AGR [COUNT @D39547, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DIE, 
   [COORD @D39552, AGR [COUNT @D39551, PER @D39550, PLU @D39549, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DIE, 
   [COORD @D39558, PAST @D39557, 
      AGR [CASE @D39556, COUNT @D39555, PER @D39554, PLU @D39553, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : DIE, 
   [COORD @D39561, AGR [COUNT @D39560, PER @D39559, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DIE, 
   [COORD @D39563, AGR [COUNT @D39562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DIE, 
   [COORD @D39565, AGR [COUNT @D39564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DIE, 
   [COORD @D39569, AGR [COUNT @D39568, PER @D39567, PLU @D39566, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DIE, 
   [COORD @D39575, PAST @D39574, 
      AGR [CASE @D39573, COUNT @D39572, PER @D39571, PLU @D39570, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : DIE, 
   [COORD @D39578, AGR [COUNT @D39577, PER @D39576, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DIE, 
   [COORD @D39580, AGR [COUNT @D39579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DIE, 
   [COORD @D39582, AGR [COUNT @D39581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DIE, 
   [COORD @D39586, AGR [COUNT @D39585, PER @D39584, PLU @D39583, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DIE, 
   [COORD @D39592, PAST @D39591, 
      AGR [CASE @D39590, COUNT @D39589, PER @D39588, PLU @D39587, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : DIE, 
   [COORD @D39595, AGR [COUNT @D39594, PER @D39593, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DIE, 
   [COORD @D39597, AGR [COUNT @D39596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DIE, 
   [COORD @D39599, AGR [COUNT @D39598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DIE, 
   [COORD @D39603, AGR [COUNT @D39602, PER @D39601, PLU @D39600, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DIE, 
   [COORD @D39609, PAST @D39608, 
      AGR [CASE @D39607, COUNT @D39606, PER @D39605, PLU @D39604, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, 
      ARITY 1] : DIE, 
   [COORD @D39612, AGR [COUNT @D39611, PER @D39610, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DIE, 
   [COORD @D39614, AGR [COUNT @D39613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DIE, 
   [COORD @D39616, AGR [COUNT @D39615, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DIE, 
   [COORD @D39620, AGR [COUNT @D39619, PER @D39618, PLU @D39617, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DIE, 
   [COORD @D39626, PAST @D39625, 
      AGR [CASE @D39624, COUNT @D39623, PER @D39622, PLU @D39621, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : DIE.

WORD died : 
   [COORD @D39636, AGR [CASE @D39635, COUNT @D39634, PER @D39633, 
            PLU @D39632, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39641, AGR [CASE @D39640, COUNT @D39639, PER @D39638, 
            PLU @D39637, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39646, AGR [CASE @D39645, COUNT @D39644, PER @D39643, 
            PLU @D39642, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39651, AGR [CASE @D39650, COUNT @D39649, PER @D39648, 
            PLU @D39647, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39656, AGR [CASE @D39655, COUNT @D39654, PER @D39653, 
            PLU @D39652, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39661, AGR [CASE @D39660, COUNT @D39659, PER @D39658, 
            PLU @D39657, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39666, AGR [CASE @D39665, COUNT @D39664, PER @D39663, 
            PLU @D39662, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39671, AGR [CASE @D39670, COUNT @D39669, PER @D39668, 
            PLU @D39667, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39676, AGR [CASE @D39675, COUNT @D39674, PER @D39673, 
            PLU @D39672, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DIE, 
   [COORD @D39681, AGR [CASE @D39680, COUNT @D39679, PER @D39678, 
            PLU @D39677, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39686, AGR [CASE @D39685, COUNT @D39684, PER @D39683, 
            PLU @D39682, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39691, AGR [CASE @D39690, COUNT @D39689, PER @D39688, 
            PLU @D39687, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39696, AGR [CASE @D39695, COUNT @D39694, PER @D39693, 
            PLU @D39692, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39701, AGR [CASE @D39700, COUNT @D39699, PER @D39698, 
            PLU @D39697, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39706, AGR [CASE @D39705, COUNT @D39704, PER @D39703, 
            PLU @D39702, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39711, AGR [CASE @D39710, COUNT @D39709, PER @D39708, 
            PLU @D39707, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39716, AGR [CASE @D39715, COUNT @D39714, PER @D39713, 
            PLU @D39712, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39721, AGR [CASE @D39720, COUNT @D39719, PER @D39718, 
            PLU @D39717, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39726, AGR [CASE @D39725, COUNT @D39724, PER @D39723, 
            PLU @D39722, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39731, AGR [CASE @D39730, COUNT @D39729, PER @D39728, 
            PLU @D39727, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39736, AGR [CASE @D39735, COUNT @D39734, PER @D39733, 
            PLU @D39732, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39741, AGR [CASE @D39740, COUNT @D39739, PER @D39738, 
            PLU @D39737, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39746, AGR [CASE @D39745, COUNT @D39744, PER @D39743, 
            PLU @D39742, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIE, 
   [COORD @D39751, AGR [CASE @D39750, COUNT @D39749, PER @D39748, 
            PLU @D39747, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D39756, AGR [CASE @D39755, COUNT @D39754, PER @D39753, 
            PLU @D39752, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIE.

WORD dies : 
   [COORD @D39763, AGR [COUNT @D39762, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39765, 
      AGR [COUNT @D39764, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39767, 
      AGR [COUNT @D39766, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39769, 
      AGR [COUNT @D39768, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39771, 
      AGR [COUNT @D39770, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39773, 
      AGR [COUNT @D39772, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39775, 
      AGR [COUNT @D39774, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39777, 
      AGR [COUNT @D39776, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39779, 
      AGR [COUNT @D39778, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39781, 
      AGR [COUNT @D39780, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39783, 
      AGR [COUNT @D39782, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE, 
   [COORD @D39785, 
      AGR [COUNT @D39784, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIE.

WORD direct : 
   [COORD @D39796, AGR [COUNT @D39795, PER @D39794, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DIRECT, 
   [COORD @D39798, AGR [COUNT @D39797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DIRECT, 
   [COORD @D39800, AGR [COUNT @D39799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DIRECT, 
   [COORD @D39804, AGR [COUNT @D39803, PER @D39802, PLU @D39801, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : DIRECT, 
   [COORD @D39810, PAST @D39809, AGR [CASE @D39808, COUNT @D39807, 
            PER @D39806, PLU @D39805, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : DIRECT, 
   [COORD @D39813, AGR [COUNT @D39812, PER @D39811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TOWARDS, ARITY 3] : DIRECT, 
   [COORD @D39815, AGR [COUNT @D39814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TOWARDS, ARITY 3] : DIRECT, 
   [COORD @D39817, AGR [COUNT @D39816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TOWARDS, ARITY 3] : DIRECT, 
   [COORD @D39821, AGR [COUNT @D39820, PER @D39819, PLU @D39818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TOWARDS, ARITY 3] : DIRECT, 
   [COORD @D39827, PAST @D39826, 
      AGR [CASE @D39825, COUNT @D39824, PER @D39823, PLU @D39822, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TOWARDS, ARITY 3] : DIRECT, 
   [COORD @D39830, AGR [COUNT @D39829, PER @D39828, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DIRECT, 
   [COORD @D39832, AGR [COUNT @D39831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DIRECT, 
   [COORD @D39834, AGR [COUNT @D39833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DIRECT, 
   [COORD @D39838, AGR [COUNT @D39837, PER @D39836, PLU @D39835, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : DIRECT, 
   [COORD @D39844, PAST @D39843, 
      AGR [CASE @D39842, COUNT @D39841, PER @D39840, PLU @D39839, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : DIRECT, 
   [COORD @D39847, AGR [COUNT @D39846, PER @D39845, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : DIRECT, 
   [COORD @D39849, AGR [COUNT @D39848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : DIRECT, 
   [COORD @D39851, AGR [COUNT @D39850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : DIRECT, 
   [COORD @D39855, AGR [COUNT @D39854, PER @D39853, PLU @D39852, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : DIRECT, 
   [COORD @D39861, PAST @D39860, 
      AGR [CASE @D39859, COUNT @D39858, PER @D39857, PLU @D39856, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, 
      ARITY 3] : DIRECT, 
   [COORD @D39864, AGR [COUNT @D39863, PER @D39862, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DIRECT, 
   [COORD @D39866, AGR [COUNT @D39865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DIRECT, 
   [COORD @D39868, AGR [COUNT @D39867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DIRECT, 
   [COORD @D39872, AGR [COUNT @D39871, PER @D39870, PLU @D39869, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : DIRECT, 
   [COORD @D39878, PAST @D39877, AGR [CASE @D39876, COUNT @D39875, 
            PER @D39874, PLU @D39873, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : DIRECT, 
   [COORD @D39881, AGR [COUNT @D39880, PER @D39879, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIRECT, 
   [COORD @D39883, AGR [COUNT @D39882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIRECT, 
   [COORD @D39885, AGR [COUNT @D39884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIRECT, 
   [COORD @D39889, AGR [COUNT @D39888, PER @D39887, PLU @D39886, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DIRECT, 
   [COORD @D39895, PAST @D39894, AGR [CASE @D39893, COUNT @D39892, 
            PER @D39891, PLU @D39890, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DIRECT.

WORD directed : 
   [COORD @D39905, AGR [CASE @D39904, COUNT @D39903, PER @D39902, 
            PLU @D39901, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39910, AGR [CASE @D39909, COUNT @D39908, PER @D39907, 
            PLU @D39906, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39916, AGR [CASE @D39915, NFORM @D39914, COUNT @D39913, 
            PER @D39912, PLU @D39911, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DIRECT, 
   [COORD @D39921, AGR [CASE @D39920, COUNT @D39919, PER @D39918, 
            PLU @D39917, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39926, AGR [CASE @D39925, COUNT @D39924, PER @D39923, 
            PLU @D39922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39931, AGR [CASE @D39930, COUNT @D39929, PER @D39928, 
            PLU @D39927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39936, AGR [CASE @D39935, COUNT @D39934, PER @D39933, 
            PLU @D39932, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39941, AGR [CASE @D39940, COUNT @D39939, PER @D39938, 
            PLU @D39937, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39946, AGR [CASE @D39945, COUNT @D39944, PER @D39943, 
            PLU @D39942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39951, AGR [CASE @D39950, COUNT @D39949, PER @D39948, 
            PLU @D39947, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39956, AGR [CASE @D39955, COUNT @D39954, PER @D39953, 
            PLU @D39952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39961, AGR [CASE @D39960, COUNT @D39959, PER @D39958, 
            PLU @D39957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39966, AGR [CASE @D39965, COUNT @D39964, PER @D39963, 
            PLU @D39962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39971, AGR [CASE @D39970, COUNT @D39969, PER @D39968, 
            PLU @D39967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39976, AGR [CASE @D39975, COUNT @D39974, PER @D39973, 
            PLU @D39972, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DIRECT, 
   [COORD @D39981, AGR [CASE @D39980, COUNT @D39979, PER @D39978, 
            PLU @D39977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D39986, AGR [CASE @D39985, COUNT @D39984, PER @D39983, 
            PLU @D39982, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIRECT.

WORD directing : 
   [COORD @D39999, PRD @D39998, AGR [CASE @D39997, COUNT @D39996, 
            PER @D39995, PLU @D39994, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D40005, PRD @D40004, 
      AGR [CASE @D40003, COUNT @D40002, PER @D40001, PLU @D40000, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DIRECT, 
   [COORD @D40011, PRD @D40010, AGR [CASE @D40009, COUNT @D40008, 
            PER @D40007, PLU @D40006, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D40017, PRD @D40016, 
      AGR [CASE @D40015, COUNT @D40014, PER @D40013, PLU @D40012, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DIRECT, 
   [COORD @D40023, PRD @D40022, AGR [CASE @D40021, COUNT @D40020, 
            PER @D40019, PLU @D40018, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIRECT, 
   [COORD @D40029, PRD @D40028, 
      AGR [CASE @D40027, COUNT @D40026, PER @D40025, PLU @D40024, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DIRECT.

WORD directs : 
   [COORD @D40036, AGR [COUNT @D40035, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIRECT, 
   [COORD @D40038, 
      AGR [COUNT @D40037, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DIRECT, 
   [COORD @D40040, AGR [COUNT @D40039, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIRECT, 
   [COORD @D40042, 
      AGR [COUNT @D40041, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIRECT, 
   [COORD @D40044, 
      AGR [COUNT @D40043, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIRECT, 
   [COORD @D40046, 
      AGR [COUNT @D40045, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIRECT.

WORD disappear : 
   [COORD @D40053, AGR [COUNT @D40052, PER @D40051, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DISAPPEAR, 
   [COORD @D40055, AGR [COUNT @D40054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DISAPPEAR, 
   [COORD @D40057, AGR [COUNT @D40056, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : DISAPPEAR, 
   [COORD @D40061, AGR [COUNT @D40060, PER @D40059, PLU @D40058, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : DISAPPEAR, 
   [COORD @D40067, PAST @D40066, 
      AGR [CASE @D40065, COUNT @D40064, PER @D40063, PLU @D40062, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, 
      ARITY 2] : DISAPPEAR, 
   [COORD @D40070, AGR [COUNT @D40069, PER @D40068, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISAPPEAR, 
   [COORD @D40072, AGR [COUNT @D40071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISAPPEAR, 
   [COORD @D40074, AGR [COUNT @D40073, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISAPPEAR, 
   [COORD @D40078, AGR [COUNT @D40077, PER @D40076, PLU @D40075, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISAPPEAR, 
   [COORD @D40084, PAST @D40083, AGR [CASE @D40082, COUNT @D40081, 
            PER @D40080, PLU @D40079, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DISAPPEAR.

WORD disappeared : 
   [COORD @D40094, AGR [CASE @D40093, COUNT @D40092, PER @D40091, 
            PLU @D40090, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISAPPEAR, 
   [COORD @D40099, AGR [CASE @D40098, COUNT @D40097, PER @D40096, 
            PLU @D40095, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DISAPPEAR, 
   [COORD @D40104, AGR [CASE @D40103, COUNT @D40102, PER @D40101, 
            PLU @D40100, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISAPPEAR, 
   [COORD @D40109, AGR [CASE @D40108, COUNT @D40107, PER @D40106, 
            PLU @D40105, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISAPPEAR.

WORD disappearing : 
   [COORD @D40122, PRD @D40121, AGR [CASE @D40120, COUNT @D40119, 
            PER @D40118, PLU @D40117, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DISAPPEAR, 
   [COORD @D40128, PRD @D40127, 
      AGR [CASE @D40126, COUNT @D40125, PER @D40124, PLU @D40123, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DISAPPEAR.

WORD disappears : 
   [COORD @D40135, AGR [COUNT @D40134, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DISAPPEAR, 
   [COORD @D40137, AGR [COUNT @D40136, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISAPPEAR.

WORD discipline : 
   [COORD @D40148, REFL @D40147, COUNT @D40146, PRD @D40145, 
      CASE @D40144, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DISCIPLINE, 
   [COORD @D40151, 
      AGR [COUNT @D40150, PER @D40149, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   DISCIPLINE, 
   [COORD @D40153, AGR [COUNT @D40152, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCIPLINE, 
   [COORD @D40155, AGR [COUNT @D40154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCIPLINE, 
   [COORD @D40159, AGR [COUNT @D40158, PER @D40157, PLU @D40156, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DISCIPLINE, 
   [COORD @D40165, PAST @D40164, AGR [CASE @D40163, COUNT @D40162, 
            PER @D40161, PLU @D40160, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DISCIPLINE.

WORD disciplined : 
   [COORD @D40178, AGR [CASE @D40177, COUNT @D40176, PER @D40175, 
            PLU @D40174, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DISCIPLINE, 
   [COORD @D40183, AGR [CASE @D40182, COUNT @D40181, PER @D40180, 
            PLU @D40179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCIPLINE, 
   [COORD @D40188, AGR [CASE @D40187, COUNT @D40186, PER @D40185, 
            PLU @D40184, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCIPLINE.

WORD disciplines : 
   [COORD @D40201, DEMON @D40200, REFL @D40199, PRD @D40198, 
      CASE @D40197, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   DISCIPLINE, 
   [COORD @D40203, AGR [COUNT @D40202, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISCIPLINE.

WORD disciplining : 
   [COORD @D40215, PRD @D40214, AGR [CASE @D40213, COUNT @D40212, 
            PER @D40211, PLU @D40210, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISCIPLINE.

WORD discover : 
   [COORD @D40222, AGR [COUNT @D40221, PER @D40220, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCOVER, 
   [COORD @D40224, AGR [COUNT @D40223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCOVER, 
   [COORD @D40226, AGR [COUNT @D40225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCOVER, 
   [COORD @D40230, AGR [COUNT @D40229, PER @D40228, PLU @D40227, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCOVER, 
   [COORD @D40236, PAST @D40235, AGR [CASE @D40234, COUNT @D40233, 
            PER @D40232, PLU @D40231, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : DISCOVER, 
   [COORD @D40239, AGR [COUNT @D40238, PER @D40237, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISCOVER, 
   [COORD @D40241, AGR [COUNT @D40240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISCOVER, 
   [COORD @D40243, AGR [COUNT @D40242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISCOVER, 
   [COORD @D40247, AGR [COUNT @D40246, PER @D40245, PLU @D40244, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : DISCOVER, 
   [COORD @D40253, PAST @D40252, AGR [CASE @D40251, COUNT @D40250, 
            PER @D40249, PLU @D40248, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : DISCOVER, 
   [COORD @D40256, AGR [COUNT @D40255, PER @D40254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DISCOVER, 
   [COORD @D40258, AGR [COUNT @D40257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DISCOVER, 
   [COORD @D40260, AGR [COUNT @D40259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DISCOVER, 
   [COORD @D40264, AGR [COUNT @D40263, PER @D40262, PLU @D40261, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DISCOVER, 
   [COORD @D40270, PAST @D40269, AGR [CASE @D40268, COUNT @D40267, 
            PER @D40266, PLU @D40265, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : DISCOVER, 
   [COORD @D40273, AGR [COUNT @D40272, PER @D40271, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DISCOVER, 
   [COORD @D40275, AGR [COUNT @D40274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DISCOVER, 
   [COORD @D40277, AGR [COUNT @D40276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DISCOVER, 
   [COORD @D40281, AGR [COUNT @D40280, PER @D40279, PLU @D40278, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : DISCOVER, 
   [COORD @D40287, PAST @D40286, AGR 
         [CASE @D40285, COUNT @D40284, PER @D40283, PLU @D40282, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : 
   DISCOVER, 
   [COORD @D40290, AGR [COUNT @D40289, PER @D40288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCOVER, 
   [COORD @D40292, AGR [COUNT @D40291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCOVER, 
   [COORD @D40294, AGR [COUNT @D40293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCOVER, 
   [COORD @D40298, AGR [COUNT @D40297, PER @D40296, PLU @D40295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DISCOVER, 
   [COORD @D40304, PAST @D40303, AGR [CASE @D40302, COUNT @D40301, 
            PER @D40300, PLU @D40299, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DISCOVER.

WORD discovered : 
   [COORD @D40314, AGR [CASE @D40313, COUNT @D40312, PER @D40311, 
            PLU @D40310, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40319, AGR [CASE @D40318, COUNT @D40317, PER @D40316, 
            PLU @D40315, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40324, AGR [CASE @D40323, COUNT @D40322, PER @D40321, 
            PLU @D40320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40329, AGR [CASE @D40328, COUNT @D40327, PER @D40326, 
            PLU @D40325, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40334, AGR [UB @D40333, VFORM @D40332, SUBJ @D40331, 
            FIN @D40330, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DISCOVER, 
   [COORD @D40339, AGR [CASE @D40338, COUNT @D40337, PER @D40336, 
            PLU @D40335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40344, AGR [CASE @D40343, COUNT @D40342, PER @D40341, 
            PLU @D40340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40349, AGR [CASE @D40348, COUNT @D40347, PER @D40346, 
            PLU @D40345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40354, AGR [CASE @D40353, COUNT @D40352, PER @D40351, 
            PLU @D40350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40360, AGR [CASE @D40359, NFORM @D40358, COUNT @D40357, 
            PER @D40356, PLU @D40355, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40365, AGR [UB @D40364, VFORM @D40363, SUBJ @D40362, 
            FIN @D40361, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DISCOVER, 
   [COORD @D40370, AGR [CASE @D40369, COUNT @D40368, PER @D40367, 
            PLU @D40366, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40375, AGR [CASE @D40374, COUNT @D40373, PER @D40372, 
            PLU @D40371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40380, AGR [CASE @D40379, COUNT @D40378, PER @D40377, 
            PLU @D40376, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCOVER.

WORD discovering : 
   [COORD @D40393, PRD @D40392, AGR [CASE @D40391, COUNT @D40390, 
            PER @D40389, PLU @D40388, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40399, PRD @D40398, 
      AGR [CASE @D40397, COUNT @D40396, PER @D40395, PLU @D40394, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DISCOVER, 
   [COORD @D40405, PRD @D40404, AGR [CASE @D40403, COUNT @D40402, 
            PER @D40401, PLU @D40400, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40411, PRD @D40410, 
      AGR [CASE @D40409, COUNT @D40408, PER @D40407, PLU @D40406, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DISCOVER, 
   [COORD @D40417, PRD @D40416, AGR [CASE @D40415, COUNT @D40414, 
            PER @D40413, PLU @D40412, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISCOVER.

WORD discovers : 
   [COORD @D40424, AGR [COUNT @D40423, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40426, 
      AGR [COUNT @D40425, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40428, 
      AGR [COUNT @D40427, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40430, 
      AGR [COUNT @D40429, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISCOVER, 
   [COORD @D40432, 
      AGR [COUNT @D40431, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISCOVER.

WORD discuss : 
   [COORD @D40439, AGR [COUNT @D40438, PER @D40437, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DISCUSS, 
   [COORD @D40441, AGR [COUNT @D40440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DISCUSS, 
   [COORD @D40443, AGR [COUNT @D40442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DISCUSS, 
   [COORD @D40447, AGR [COUNT @D40446, PER @D40445, PLU @D40444, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DISCUSS, 
   [COORD @D40453, PAST @D40452, 
      AGR [CASE @D40451, COUNT @D40450, PER @D40449, PLU @D40448, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : DISCUSS, 
   [COORD @D40456, AGR [COUNT @D40455, PER @D40454, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCUSS, 
   [COORD @D40458, AGR [COUNT @D40457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCUSS, 
   [COORD @D40460, AGR [COUNT @D40459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCUSS, 
   [COORD @D40464, AGR [COUNT @D40463, PER @D40462, PLU @D40461, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISCUSS, 
   [COORD @D40470, PAST @D40469, AGR [CASE @D40468, COUNT @D40467, 
            PER @D40466, PLU @D40465, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : DISCUSS, 
   [COORD @D40473, AGR [COUNT @D40472, PER @D40471, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISCUSS, 
   [COORD @D40475, AGR [COUNT @D40474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISCUSS, 
   [COORD @D40477, AGR [COUNT @D40476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISCUSS, 
   [COORD @D40481, AGR [COUNT @D40480, PER @D40479, PLU @D40478, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : DISCUSS, 
   [COORD @D40487, PAST @D40486, AGR [CASE @D40485, COUNT @D40484, 
            PER @D40483, PLU @D40482, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : DISCUSS, 
   [COORD @D40490, AGR [COUNT @D40489, PER @D40488, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCUSS, 
   [COORD @D40492, AGR [COUNT @D40491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCUSS, 
   [COORD @D40494, AGR [COUNT @D40493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISCUSS, 
   [COORD @D40498, AGR [COUNT @D40497, PER @D40496, PLU @D40495, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DISCUSS, 
   [COORD @D40504, PAST @D40503, AGR [CASE @D40502, COUNT @D40501, 
            PER @D40500, PLU @D40499, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DISCUSS.

WORD discussed : 
   [COORD @D40514, AGR [CASE @D40513, COUNT @D40512, PER @D40511, 
            PLU @D40510, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40519, AGR [CASE @D40518, COUNT @D40517, PER @D40516, 
            PLU @D40515, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40524, AGR [CASE @D40523, COUNT @D40522, PER @D40521, 
            PLU @D40520, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40529, AGR [CASE @D40528, COUNT @D40527, PER @D40526, 
            PLU @D40525, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40534, AGR [CASE @D40533, COUNT @D40532, PER @D40531, 
            PLU @D40530, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40539, AGR [CASE @D40538, COUNT @D40537, PER @D40536, 
            PLU @D40535, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40544, AGR [CASE @D40543, COUNT @D40542, PER @D40541, 
            PLU @D40540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40549, AGR [CASE @D40548, COUNT @D40547, PER @D40546, 
            PLU @D40545, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40554, AGR [CASE @D40553, COUNT @D40552, PER @D40551, 
            PLU @D40550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40559, AGR [CASE @D40558, COUNT @D40557, PER @D40556, 
            PLU @D40555, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISCUSS.

WORD discussing : 
   [COORD @D40572, PRD @D40571, AGR [CASE @D40570, COUNT @D40569, 
            PER @D40568, PLU @D40567, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40578, PRD @D40577, 
      AGR [CASE @D40576, COUNT @D40575, PER @D40574, PLU @D40573, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DISCUSS, 
   [COORD @D40584, PRD @D40583, AGR [CASE @D40582, COUNT @D40581, 
            PER @D40580, PLU @D40579, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISCUSS, 
   [COORD @D40590, PRD @D40589, 
      AGR [CASE @D40588, COUNT @D40587, PER @D40586, PLU @D40585, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DISCUSS.

WORD dispute : 
   [COORD @D40605, REFL @D40604, PRD @D40603, CASE @D40602, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DISPUTE, 
   [COORD @D40608, 
      AGR [COUNT @D40607, PER @D40606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, ARITY 2] : 
   DISPUTE, 
   [COORD @D40610, AGR [COUNT @D40609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISPUTE, 
   [COORD @D40612, AGR [COUNT @D40611, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISPUTE, 
   [COORD @D40616, AGR [COUNT @D40615, PER @D40614, PLU @D40613, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : DISPUTE, 
   [COORD @D40622, PAST @D40621, AGR [CASE @D40620, COUNT @D40619, 
            PER @D40618, PLU @D40617, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : DISPUTE, 
   [COORD @D40625, AGR [COUNT @D40624, PER @D40623, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISPUTE, 
   [COORD @D40627, AGR [COUNT @D40626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISPUTE, 
   [COORD @D40629, AGR [COUNT @D40628, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DISPUTE, 
   [COORD @D40633, AGR [COUNT @D40632, PER @D40631, PLU @D40630, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : DISPUTE, 
   [COORD @D40639, PAST @D40638, AGR [CASE @D40637, COUNT @D40636, 
            PER @D40635, PLU @D40634, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : DISPUTE, 
   [COORD @D40642, AGR [COUNT @D40641, PER @D40640, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISPUTE, 
   [COORD @D40644, AGR [COUNT @D40643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISPUTE, 
   [COORD @D40646, AGR [COUNT @D40645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DISPUTE, 
   [COORD @D40650, AGR [COUNT @D40649, PER @D40648, PLU @D40647, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DISPUTE, 
   [COORD @D40656, PAST @D40655, AGR [CASE @D40654, COUNT @D40653, 
            PER @D40652, PLU @D40651, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DISPUTE, 
   [COORD @D40659, AGR [COUNT @D40658, PER @D40657, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DISPUTE, 
   [COORD @D40661, AGR [COUNT @D40660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DISPUTE, 
   [COORD @D40663, AGR [COUNT @D40662, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DISPUTE, 
   [COORD @D40667, AGR [COUNT @D40666, PER @D40665, PLU @D40664, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : DISPUTE, 
   [COORD @D40673, PAST @D40672, 
      AGR [CASE @D40671, COUNT @D40670, PER @D40669, PLU @D40668, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      ARITY 2] : DISPUTE, 
   [COORD @D40676, AGR [COUNT @D40675, PER @D40674, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISPUTE, 
   [COORD @D40678, AGR [COUNT @D40677, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISPUTE, 
   [COORD @D40680, AGR [COUNT @D40679, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISPUTE, 
   [COORD @D40684, AGR [COUNT @D40683, PER @D40682, PLU @D40681, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DISPUTE, 
   [COORD @D40690, PAST @D40689, AGR [CASE @D40688, COUNT @D40687, 
            PER @D40686, PLU @D40685, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DISPUTE.

WORD disputed : 
   [COORD @D40703, AGR [CASE @D40702, COUNT @D40701, PER @D40700, 
            PLU @D40699, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40708, AGR [CASE @D40707, COUNT @D40706, PER @D40705, 
            PLU @D40704, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40713, AGR [CASE @D40712, COUNT @D40711, PER @D40710, 
            PLU @D40709, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40718, AGR [CASE @D40717, COUNT @D40716, PER @D40715, 
            PLU @D40714, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40723, AGR [CASE @D40722, COUNT @D40721, PER @D40720, 
            PLU @D40719, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40728, AGR [CASE @D40727, COUNT @D40726, PER @D40725, 
            PLU @D40724, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40733, AGR [CASE @D40732, COUNT @D40731, PER @D40730, 
            PLU @D40729, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40738, AGR [CASE @D40737, COUNT @D40736, PER @D40735, 
            PLU @D40734, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40743, AGR [CASE @D40742, COUNT @D40741, PER @D40740, 
            PLU @D40739, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40748, AGR [CASE @D40747, COUNT @D40746, PER @D40745, 
            PLU @D40744, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40753, AGR [CASE @D40752, COUNT @D40751, PER @D40750, 
            PLU @D40749, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DISPUTE.

WORD disputes : 
   [COORD @D40766, DEMON @D40765, REFL @D40764, PRD @D40763, 
      CASE @D40762, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DISPUTE, 
   
   [COORD @D40768, AGR [COUNT @D40767, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40770, 
      AGR [COUNT @D40769, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40772, 
      AGR [COUNT @D40771, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40774, 
      AGR [COUNT @D40773, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40776, 
      AGR [COUNT @D40775, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DISPUTE.

WORD disputing : 
   [COORD @D40788, PRD @D40787, AGR [CASE @D40786, COUNT @D40785, 
            PER @D40784, PLU @D40783, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40794, PRD @D40793, 
      AGR [CASE @D40792, COUNT @D40791, PER @D40790, PLU @D40789, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DISPUTE, 
   [COORD @D40800, PRD @D40799, AGR [CASE @D40798, COUNT @D40797, 
            PER @D40796, PLU @D40795, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISPUTE, 
   [COORD @D40806, PRD @D40805, 
      AGR [CASE @D40804, COUNT @D40803, PER @D40802, PLU @D40801, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DISPUTE, 
   [COORD @D40812, PRD @D40811, AGR [CASE @D40810, COUNT @D40809, 
            PER @D40808, PLU @D40807, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DISPUTE.

WORD divide : 
   [COORD @D40820, AGR [COUNT @D40819, PER @D40818, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DIVIDE, 
   [COORD @D40822, AGR [COUNT @D40821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DIVIDE, 
   [COORD @D40824, AGR [COUNT @D40823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DIVIDE, 
   [COORD @D40828, AGR [COUNT @D40827, PER @D40826, PLU @D40825, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : DIVIDE, 
   [COORD @D40834, PAST @D40833, 
      AGR [CASE @D40832, COUNT @D40831, PER @D40830, PLU @D40829, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : DIVIDE, 
   [COORD @D40837, AGR [COUNT @D40836, PER @D40835, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DIVIDE, 
   [COORD @D40839, AGR [COUNT @D40838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DIVIDE, 
   [COORD @D40841, AGR [COUNT @D40840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DIVIDE, 
   [COORD @D40845, AGR [COUNT @D40844, PER @D40843, PLU @D40842, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : DIVIDE, 
   [COORD @D40851, PAST @D40850, 
      AGR [CASE @D40849, COUNT @D40848, PER @D40847, PLU @D40846, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM INTO, 
      ARITY 3] : DIVIDE, 
   [COORD @D40854, AGR [COUNT @D40853, PER @D40852, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DIVIDE, 
   [COORD @D40856, AGR [COUNT @D40855, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DIVIDE, 
   [COORD @D40858, AGR [COUNT @D40857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DIVIDE, 
   [COORD @D40862, AGR [COUNT @D40861, PER @D40860, PLU @D40859, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DIVIDE, 
   [COORD @D40868, PAST @D40867, 
      AGR [CASE @D40866, COUNT @D40865, PER @D40864, PLU @D40863, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : DIVIDE, 
   [COORD @D40871, AGR [COUNT @D40870, PER @D40869, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BY, ARITY 3] : DIVIDE, 
   [COORD @D40873, AGR [COUNT @D40872, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BY, ARITY 3] : DIVIDE, 
   [COORD @D40875, AGR [COUNT @D40874, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BY, ARITY 3] : DIVIDE, 
   [COORD @D40879, AGR [COUNT @D40878, PER @D40877, PLU @D40876, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BY, ARITY 3] : DIVIDE, 
   [COORD @D40885, PAST @D40884, 
      AGR [CASE @D40883, COUNT @D40882, PER @D40881, PLU @D40880, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM BY, 
      ARITY 3] : DIVIDE, 
   [COORD @D40888, AGR [COUNT @D40887, PER @D40886, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : DIVIDE, 
   [COORD @D40890, AGR [COUNT @D40889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : DIVIDE, 
   [COORD @D40892, AGR [COUNT @D40891, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : DIVIDE, 
   [COORD @D40896, AGR [COUNT @D40895, PER @D40894, PLU @D40893, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : DIVIDE, 
   [COORD @D40902, PAST @D40901, 
      AGR [CASE @D40900, COUNT @D40899, PER @D40898, PLU @D40897, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM BETWEEN, ARITY 3] : DIVIDE, 
   [COORD @D40905, AGR [COUNT @D40904, PER @D40903, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : DIVIDE, 
   [COORD @D40907, AGR [COUNT @D40906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : DIVIDE, 
   [COORD @D40909, AGR [COUNT @D40908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : DIVIDE, 
   [COORD @D40913, AGR [COUNT @D40912, PER @D40911, PLU @D40910, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : DIVIDE, 
   [COORD @D40919, PAST @D40918, 
      AGR [CASE @D40917, COUNT @D40916, PER @D40915, PLU @D40914, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AMONG, 
      ARITY 3] : DIVIDE, 
   [COORD @D40922, AGR [COUNT @D40921, PER @D40920, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIVIDE, 
   [COORD @D40924, AGR [COUNT @D40923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIVIDE, 
   [COORD @D40926, AGR [COUNT @D40925, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIVIDE, 
   [COORD @D40930, AGR [COUNT @D40929, PER @D40928, PLU @D40927, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DIVIDE, 
   [COORD @D40936, PAST @D40935, AGR [CASE @D40934, COUNT @D40933, 
            PER @D40932, PLU @D40931, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DIVIDE, 
   [COORD @D40939, AGR [COUNT @D40938, PER @D40937, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : DIVIDE, 
   [COORD @D40941, AGR [COUNT @D40940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : DIVIDE, 
   [COORD @D40943, AGR [COUNT @D40942, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : DIVIDE, 
   [COORD @D40947, AGR [COUNT @D40946, PER @D40945, PLU @D40944, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : DIVIDE, 
   [COORD @D40953, PAST @D40952, 
      AGR [CASE @D40951, COUNT @D40950, PER @D40949, PLU @D40948, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM INTO, 
      ARITY 2] : DIVIDE, 
   [COORD @D40956, AGR [COUNT @D40955, PER @D40954, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DIVIDE, 
   [COORD @D40958, AGR [COUNT @D40957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DIVIDE, 
   [COORD @D40960, AGR [COUNT @D40959, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DIVIDE, 
   [COORD @D40964, AGR [COUNT @D40963, PER @D40962, PLU @D40961, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : DIVIDE, 
   [COORD @D40970, PAST @D40969, 
      AGR [CASE @D40968, COUNT @D40967, PER @D40966, PLU @D40965, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : DIVIDE, 
   [COORD @D40973, AGR [COUNT @D40972, PER @D40971, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVIDE, 
   [COORD @D40975, AGR [COUNT @D40974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVIDE, 
   [COORD @D40977, AGR [COUNT @D40976, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVIDE, 
   [COORD @D40981, AGR [COUNT @D40980, PER @D40979, PLU @D40978, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVIDE, 
   [COORD @D40987, PAST @D40986, AGR [CASE @D40985, COUNT @D40984, 
            PER @D40983, PLU @D40982, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DIVIDE, 
   [COORD @D40990, AGR [COUNT @D40989, PER @D40988, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DIVIDE, 
   [COORD @D40992, AGR [COUNT @D40991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DIVIDE, 
   [COORD @D40994, AGR [COUNT @D40993, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DIVIDE, 
   [COORD @D40998, AGR [COUNT @D40997, PER @D40996, PLU @D40995, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DIVIDE, 
   [COORD @D41004, PAST @D41003, 
      AGR [CASE @D41002, COUNT @D41001, PER @D41000, PLU @D40999, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : DIVIDE.

WORD divided : 
   [COORD @D41015, AGR [CASE @D41014, COUNT @D41013, PER @D41012, 
            PLU @D41011, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41020, AGR [CASE @D41019, COUNT @D41018, PER @D41017, 
            PLU @D41016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41025, AGR [CASE @D41024, COUNT @D41023, PER @D41022, 
            PLU @D41021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41030, AGR [CASE @D41029, COUNT @D41028, PER @D41027, 
            PLU @D41026, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41035, AGR [CASE @D41034, COUNT @D41033, PER @D41032, 
            PLU @D41031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41040, AGR [CASE @D41039, COUNT @D41038, PER @D41037, 
            PLU @D41036, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41045, AGR [CASE @D41044, COUNT @D41043, PER @D41042, 
            PLU @D41041, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41050, AGR [CASE @D41049, COUNT @D41048, PER @D41047, 
            PLU @D41046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41055, AGR [CASE @D41054, COUNT @D41053, PER @D41052, 
            PLU @D41051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41060, AGR [CASE @D41059, COUNT @D41058, PER @D41057, 
            PLU @D41056, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM BY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41065, AGR [CASE @D41064, COUNT @D41063, PER @D41062, 
            PLU @D41061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41070, AGR [CASE @D41069, COUNT @D41068, PER @D41067, 
            PLU @D41066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41075, AGR [CASE @D41074, COUNT @D41073, PER @D41072, 
            PLU @D41071, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41080, AGR [CASE @D41079, COUNT @D41078, PER @D41077, 
            PLU @D41076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41085, AGR [CASE @D41084, COUNT @D41083, PER @D41082, 
            PLU @D41081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41090, AGR [CASE @D41089, COUNT @D41088, PER @D41087, 
            PLU @D41086, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41095, AGR [CASE @D41094, COUNT @D41093, PER @D41092, 
            PLU @D41091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41100, AGR [CASE @D41099, COUNT @D41098, PER @D41097, 
            PLU @D41096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41105, AGR [CASE @D41104, COUNT @D41103, PER @D41102, 
            PLU @D41101, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41110, AGR [CASE @D41109, COUNT @D41108, PER @D41107, 
            PLU @D41106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41115, AGR [CASE @D41114, COUNT @D41113, PER @D41112, 
            PLU @D41111, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41120, AGR [CASE @D41119, COUNT @D41118, PER @D41117, 
            PLU @D41116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41125, AGR [CASE @D41124, COUNT @D41123, PER @D41122, 
            PLU @D41121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41130, AGR [CASE @D41129, COUNT @D41128, PER @D41127, 
            PLU @D41126, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41135, AGR [CASE @D41134, COUNT @D41133, PER @D41132, 
            PLU @D41131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41140, AGR [CASE @D41139, COUNT @D41138, PER @D41137, 
            PLU @D41136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41145, AGR [CASE @D41144, COUNT @D41143, PER @D41142, 
            PLU @D41141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41150, AGR [CASE @D41149, COUNT @D41148, PER @D41147, 
            PLU @D41146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41155, AGR [CASE @D41154, COUNT @D41153, PER @D41152, 
            PLU @D41151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41160, AGR [CASE @D41159, COUNT @D41158, PER @D41157, 
            PLU @D41156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DIVIDE.

WORD divides : 
   [COORD @D41168, AGR [COUNT @D41167, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DIVIDE, 
   [COORD @D41170, AGR [COUNT @D41169, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DIVIDE, 
   [COORD @D41172, AGR [COUNT @D41171, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DIVIDE, 
   [COORD @D41174, AGR [COUNT @D41173, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41176, 
      AGR [COUNT @D41175, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DIVIDE, 
   [COORD @D41178, AGR [COUNT @D41177, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AMONG, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DIVIDE, 
   [COORD @D41180, AGR [COUNT @D41179, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41182, 
      AGR [COUNT @D41181, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41184, 
      AGR [COUNT @D41183, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41186, 
      AGR [COUNT @D41185, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41188, 
      AGR [COUNT @D41187, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVIDE.

WORD dividing : 
   [COORD @D41199, PRD @D41198, AGR [CASE @D41197, COUNT @D41196, 
            PER @D41195, PLU @D41194, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41205, PRD @D41204, 
      AGR [CASE @D41203, COUNT @D41202, PER @D41201, PLU @D41200, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DIVIDE, 
   [COORD @D41211, PRD @D41210, AGR [CASE @D41209, COUNT @D41208, 
            PER @D41207, PLU @D41206, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41217, PRD @D41216, 
      AGR [CASE @D41215, COUNT @D41214, PER @D41213, PLU @D41212, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DIVIDE, 
   [COORD @D41223, PRD @D41222, AGR [CASE @D41221, COUNT @D41220, 
            PER @D41219, PLU @D41218, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41229, PRD @D41228, 
      AGR [CASE @D41227, COUNT @D41226, PER @D41225, PLU @D41224, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DIVIDE, 
   [COORD @D41235, PRD @D41234, AGR [CASE @D41233, COUNT @D41232, 
            PER @D41231, PLU @D41230, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41241, PRD @D41240, 
      AGR [CASE @D41239, COUNT @D41238, PER @D41237, PLU @D41236, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DIVIDE, 
   [COORD @D41247, PRD @D41246, AGR [CASE @D41245, COUNT @D41244, 
            PER @D41243, PLU @D41242, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE, 
   [COORD @D41253, PRD @D41252, 
      AGR [CASE @D41251, COUNT @D41250, PER @D41249, PLU @D41248, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DIVIDE, 
   [COORD @D41259, PRD @D41258, AGR [CASE @D41257, COUNT @D41256, 
            PER @D41255, PLU @D41254, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVIDE.

WORD divorce : 
   [COORD @D41270, REFL @D41269, COUNT @D41268, PRD @D41267, 
      CASE @D41266, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DIVORCE, 
   [COORD @D41273, 
      AGR [COUNT @D41272, PER @D41271, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : DIVORCE, 
   [COORD @D41275, AGR [COUNT @D41274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DIVORCE, 
   [COORD @D41277, AGR [COUNT @D41276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DIVORCE, 
   [COORD @D41281, AGR [COUNT @D41280, PER @D41279, PLU @D41278, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DIVORCE, 
   [COORD @D41287, PAST @D41286, 
      AGR [CASE @D41285, COUNT @D41284, PER @D41283, PLU @D41282, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : DIVORCE, 
   [COORD @D41290, AGR [COUNT @D41289, PER @D41288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIVORCE, 
   [COORD @D41292, AGR [COUNT @D41291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIVORCE, 
   [COORD @D41294, AGR [COUNT @D41293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DIVORCE, 
   [COORD @D41298, AGR [COUNT @D41297, PER @D41296, PLU @D41295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DIVORCE, 
   [COORD @D41304, PAST @D41303, AGR [CASE @D41302, COUNT @D41301, 
            PER @D41300, PLU @D41299, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DIVORCE, 
   [COORD @D41307, AGR [COUNT @D41306, PER @D41305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVORCE, 
   [COORD @D41309, AGR [COUNT @D41308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVORCE, 
   [COORD @D41311, AGR [COUNT @D41310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVORCE, 
   [COORD @D41315, AGR [COUNT @D41314, PER @D41313, PLU @D41312, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DIVORCE, 
   [COORD @D41321, PAST @D41320, AGR [CASE @D41319, COUNT @D41318, 
            PER @D41317, PLU @D41316, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DIVORCE.

WORD divorced : 
   [COORD @D41334, AGR [CASE @D41333, COUNT @D41332, PER @D41331, 
            PLU @D41330, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41339, AGR [CASE @D41338, COUNT @D41337, PER @D41336, 
            PLU @D41335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41344, AGR [CASE @D41343, COUNT @D41342, PER @D41341, 
            PLU @D41340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41349, AGR [CASE @D41348, COUNT @D41347, PER @D41346, 
            PLU @D41345, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41354, AGR [CASE @D41353, COUNT @D41352, PER @D41351, 
            PLU @D41350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41359, AGR [CASE @D41358, COUNT @D41357, PER @D41356, 
            PLU @D41355, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41364, AGR [CASE @D41363, COUNT @D41362, PER @D41361, 
            PLU @D41360, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41369, AGR [CASE @D41368, COUNT @D41367, PER @D41366, 
            PLU @D41365, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DIVORCE.

WORD divorces : 
   [COORD @D41382, DEMON @D41381, REFL @D41380, PRD @D41379, 
      CASE @D41378, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DIVORCE, 
   
   [COORD @D41384, AGR [COUNT @D41383, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DIVORCE, 
   [COORD @D41386, AGR [COUNT @D41385, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41388, 
      AGR [COUNT @D41387, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DIVORCE.

WORD divorcing : 
   [COORD @D41402, PRD @D41401, AGR [CASE @D41400, COUNT @D41399, 
            PER @D41398, PLU @D41397, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DIVORCE, 
   [COORD @D41408, PRD @D41407, 
      AGR [CASE @D41406, COUNT @D41405, PER @D41404, PLU @D41403, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DIVORCE, 
   [COORD @D41414, PRD @D41413, AGR [CASE @D41412, COUNT @D41411, 
            PER @D41410, PLU @D41409, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIVORCE.

WORD doubt : 
   [COORD @D41424, REFL @D41423, COUNT @D41422, PRD @D41421, CASE 
         @D41420, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DOUBT, 
   [COORD @D41429, REFL @D41428, COUNT @D41427, PRD @D41426, 
      CASE @D41425, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT] : 
   DOUBT, 
   [COORD @D41434, REFL @D41433, COUNT @D41432, PRD @D41431, CASE 
         @D41430, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DOUBT, 
   [COORD @D41439, REFL @D41438, COUNT @D41437, PRD @D41436, 
      CASE @D41435, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS] : DOUBT, 
   [COORD @D41444, REFL @D41443, COUNT @D41442, PRD @D41441, 
      CASE @D41440, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN] : DOUBT, 
   [COORD @D41447, 
      AGR [COUNT @D41446, PER @D41445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, ARITY 2] : 
   DOUBT, 
   [COORD @D41449, AGR [COUNT @D41448, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DOUBT, 
   [COORD @D41451, AGR [COUNT @D41450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : DOUBT, 
   [COORD @D41455, AGR [COUNT @D41454, PER @D41453, PLU @D41452, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : DOUBT, 
   [COORD @D41461, PAST @D41460, AGR [CASE @D41459, COUNT @D41458, 
            PER @D41457, PLU @D41456, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : DOUBT, 
   [COORD @D41464, AGR [COUNT @D41463, PER @D41462, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DOUBT, 
   [COORD @D41466, AGR [COUNT @D41465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DOUBT, 
   [COORD @D41468, AGR [COUNT @D41467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DOUBT, 
   [COORD @D41472, AGR [COUNT @D41471, PER @D41470, PLU @D41469, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DOUBT, 
   [COORD @D41478, PAST @D41477, AGR [CASE @D41476, COUNT @D41475, 
            PER @D41474, PLU @D41473, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : DOUBT, 
   [COORD @D41481, AGR [COUNT @D41480, PER @D41479, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DOUBT, 
   [COORD @D41483, AGR [COUNT @D41482, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DOUBT, 
   [COORD @D41485, AGR [COUNT @D41484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DOUBT, 
   [COORD @D41489, AGR [COUNT @D41488, PER @D41487, PLU @D41486, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DOUBT, 
   [COORD @D41495, PAST @D41494, AGR [CASE @D41493, COUNT @D41492, 
            PER @D41491, PLU @D41490, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DOUBT.

WORD doubted : 
   [COORD @D41507, AGR [CASE @D41506, COUNT @D41505, PER @D41504, 
            PLU @D41503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41512, AGR [CASE @D41511, COUNT @D41510, PER @D41509, 
            PLU @D41508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41517, AGR [CASE @D41516, COUNT @D41515, PER @D41514, 
            PLU @D41513, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41522, AGR [CASE @D41521, COUNT @D41520, PER @D41519, 
            PLU @D41518, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41527, AGR [UB @D41526, VFORM @D41525, SUBJ @D41524, 
            FIN @D41523, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DOUBT, 
   [COORD @D41532, AGR [CASE @D41531, COUNT @D41530, PER @D41529, 
            PLU @D41528, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DOUBT, 
   [COORD @D41537, AGR [CASE @D41536, COUNT @D41535, PER @D41534, 
            PLU @D41533, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41542, AGR [CASE @D41541, COUNT @D41540, PER @D41539, 
            PLU @D41538, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DOUBT.

WORD doubting : 
   [COORD @D41559, PRD @D41558, AGR [CASE @D41557, COUNT @D41556, 
            PER @D41555, PLU @D41554, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41565, PRD @D41564, 
      AGR [CASE @D41563, COUNT @D41562, PER @D41561, PLU @D41560, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DOUBT, 
   [COORD @D41571, PRD @D41570, AGR [CASE @D41569, COUNT @D41568, 
            PER @D41567, PLU @D41566, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DOUBT.

WORD doubts : 
   [COORD @D41583, DEMON @D41582, REFL @D41581, PRD @D41580, CASE 
         @D41579, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DOUBT, 
   [COORD @D41588, DEMON @D41587, REFL @D41586, PRD @D41585, 
      CASE @D41584, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   DOUBT, 
   [COORD @D41593, DEMON @D41592, REFL @D41591, PRD @D41590, CASE 
         @D41589, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DOUBT, 
   [COORD @D41598, DEMON @D41597, REFL @D41596, PRD @D41595, 
      CASE @D41594, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT WHS, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DOUBT, 
   [COORD @D41603, DEMON @D41602, REFL @D41601, PRD @D41600, 
      CASE @D41599, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SFIN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DOUBT, 
   [COORD @D41605, 
      AGR [COUNT @D41604, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41607, 
      AGR [COUNT @D41606, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DOUBT, 
   [COORD @D41609, 
      AGR [COUNT @D41608, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DOUBT.

WORD draw : 
   [COORD @D41615, AGR [COUNT @D41614, PER @D41613, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT ON, ARITY 3] : DRAW, 
   [COORD @D41617, AGR [COUNT @D41616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT ON, ARITY 3] : DRAW, 
   [COORD @D41619, AGR [COUNT @D41618, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT ON, ARITY 3] : DRAW, 
   [COORD @D41623, AGR [COUNT @D41622, PER @D41621, PLU @D41620, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PRT ON, ARITY 3] : DRAW, 
   [COORD @D41629, PAST @D41628, 
      AGR [CASE @D41627, COUNT @D41626, PER @D41625, PLU @D41624, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PRT ON, 
      ARITY 3] : DRAW, 
   [COORD @D41632, AGR [COUNT @D41631, PER @D41630, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : DRAW, 
   [COORD @D41634, AGR [COUNT @D41633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : DRAW, 
   [COORD @D41636, AGR [COUNT @D41635, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : DRAW, 
   [COORD @D41640, AGR [COUNT @D41639, PER @D41638, PLU @D41637, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : DRAW, 
   [COORD @D41646, PAST @D41645, 
      AGR [CASE @D41644, COUNT @D41643, PER @D41642, PLU @D41641, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      ARITY 3] : DRAW, 
   [COORD @D41649, AGR [COUNT @D41648, PER @D41647, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : DRAW, 
   [COORD @D41651, AGR [COUNT @D41650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : DRAW, 
   [COORD @D41653, AGR [COUNT @D41652, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : DRAW, 
   [COORD @D41657, AGR [COUNT @D41656, PER @D41655, PLU @D41654, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : DRAW, 
   [COORD @D41663, PAST @D41662, 
      AGR [CASE @D41661, COUNT @D41660, PER @D41659, PLU @D41658, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, 
      ARITY 3] : DRAW, 
   [COORD @D41666, AGR [COUNT @D41665, PER @D41664, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41668, AGR [COUNT @D41667, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41670, AGR [COUNT @D41669, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41674, AGR [COUNT @D41673, PER @D41672, PLU @D41671, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41680, PAST @D41679, 
      AGR [CASE @D41678, COUNT @D41677, PER @D41676, PLU @D41675, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FROM, 
      ARITY 3] : DRAW, 
   [COORD @D41683, AGR [COUNT @D41682, PER @D41681, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : DRAW, 
   [COORD @D41685, AGR [COUNT @D41684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : DRAW, 
   [COORD @D41687, AGR [COUNT @D41686, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : DRAW, 
   [COORD @D41691, AGR [COUNT @D41690, PER @D41689, PLU @D41688, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, ARITY 3] : DRAW, 
   [COORD @D41697, PAST @D41696, 
      AGR [CASE @D41695, COUNT @D41694, PER @D41693, PLU @D41692, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, ARITY 3] : DRAW, 
   [COORD @D41700, AGR [COUNT @D41699, PER @D41698, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41702, AGR [COUNT @D41701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41704, AGR [COUNT @D41703, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41708, AGR [COUNT @D41707, PER @D41706, PLU @D41705, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41714, PAST @D41713, 
      AGR [CASE @D41712, COUNT @D41711, PER @D41710, PLU @D41709, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41717, AGR [COUNT @D41716, PER @D41715, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT AWAY, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41719, AGR [COUNT @D41718, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT AWAY, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41721, AGR [COUNT @D41720, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT AWAY, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41725, AGR [COUNT @D41724, PER @D41723, PLU @D41722, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41731, PAST @D41730, 
      AGR [CASE @D41729, COUNT @D41728, PER @D41727, PLU @D41726, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, PFORM FROM, ARITY 3] : DRAW, 
   [COORD @D41734, AGR [COUNT @D41733, PER @D41732, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRAW, 
   [COORD @D41736, AGR [COUNT @D41735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRAW, 
   [COORD @D41738, AGR [COUNT @D41737, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRAW, 
   [COORD @D41742, AGR [COUNT @D41741, PER @D41740, PLU @D41739, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : DRAW, 
   [COORD @D41748, PAST @D41747, AGR [CASE @D41746, COUNT @D41745, 
            PER @D41744, PLU @D41743, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : DRAW, 
   [COORD @D41751, AGR [COUNT @D41750, PER @D41749, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : DRAW, 
   [COORD @D41753, AGR [COUNT @D41752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : DRAW, 
   [COORD @D41755, AGR [COUNT @D41754, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : DRAW, 
   [COORD @D41759, AGR [COUNT @D41758, PER @D41757, PLU @D41756, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : DRAW, 
   [COORD @D41765, PAST @D41764, AGR [CASE @D41763, COUNT @D41762, 
            PER @D41761, PLU @D41760, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : DRAW, 
   [COORD @D41768, AGR [COUNT @D41767, PER @D41766, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : DRAW, 
   [COORD @D41770, AGR [COUNT @D41769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : DRAW, 
   [COORD @D41772, AGR [COUNT @D41771, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : DRAW, 
   [COORD @D41776, AGR [COUNT @D41775, PER @D41774, PLU @D41773, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : DRAW, 
   [COORD @D41782, PAST @D41781, 
      AGR [CASE @D41780, COUNT @D41779, PER @D41778, PLU @D41777, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : 
   DRAW, 
   [COORD @D41785, AGR [COUNT @D41784, PER @D41783, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT DOWN, ARITY 2] : DRAW, 
   [COORD @D41787, AGR [COUNT @D41786, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT DOWN, ARITY 2] : DRAW, 
   [COORD @D41789, AGR [COUNT @D41788, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT DOWN, ARITY 2] : DRAW, 
   [COORD @D41793, AGR [COUNT @D41792, PER @D41791, PLU @D41790, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT DOWN, ARITY 2] : DRAW, 
   [COORD @D41799, PAST @D41798, AGR [CASE @D41797, COUNT @D41796, 
            PER @D41795, PLU @D41794, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT DOWN, ARITY 2] : DRAW, 
   [COORD @D41802, 
      AGR [COUNT @D41801, PER @D41800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT APART, 
      ARITY 2] : DRAW, 
   [COORD @D41804, AGR [COUNT @D41803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT APART, ARITY 2] : DRAW, 
   [COORD @D41806, AGR [COUNT @D41805, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT APART, ARITY 2] : DRAW, 
   [COORD @D41810, AGR [COUNT @D41809, PER @D41808, PLU @D41807, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT APART, ARITY 2] : DRAW, 
   [COORD @D41816, PAST @D41815, AGR [CASE @D41814, COUNT @D41813, 
            PER @D41812, PLU @D41811, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT APART, ARITY 2] : DRAW, 
   [COORD @D41819, 
      AGR [COUNT @D41818, PER @D41817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, PREP FOR, 
      ARITY 2] : DRAW, 
   [COORD @D41821, AGR [COUNT @D41820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP FOR, ARITY 2] : DRAW, 
   [COORD @D41823, AGR [COUNT @D41822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP FOR, ARITY 2] : DRAW, 
   [COORD @D41827, AGR [COUNT @D41826, PER @D41825, PLU @D41824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, PREP FOR, ARITY 2] : DRAW, 
   [COORD @D41833, PAST @D41832, AGR [CASE @D41831, COUNT @D41830, 
            PER @D41829, PLU @D41828, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, PREP FOR, ARITY 2] : DRAW, 
   [COORD @D41836, 
      AGR [COUNT @D41835, PER @D41834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, ARITY 2] : DRAW, 
   [COORD @D41838, AGR [COUNT @D41837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : DRAW, 
   [COORD @D41840, AGR [COUNT @D41839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : DRAW, 
   [COORD @D41844, AGR [COUNT @D41843, PER @D41842, PLU @D41841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : DRAW, 
   [COORD @D41850, PAST @D41849, 
      AGR [CASE @D41848, COUNT @D41847, PER @D41846, PLU @D41845, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, ARITY 2] : DRAW, 
   [COORD @D41853, AGR [COUNT @D41852, PER @D41851, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : DRAW, 
   [COORD @D41855, AGR [COUNT @D41854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : DRAW, 
   [COORD @D41857, AGR [COUNT @D41856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : DRAW, 
   [COORD @D41861, AGR [COUNT @D41860, PER @D41859, PLU @D41858, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : DRAW, 
   [COORD @D41867, PAST @D41866, AGR [CASE @D41865, COUNT @D41864, 
            PER @D41863, PLU @D41862, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : DRAW, 
   [COORD @D41870, 
      AGR [COUNT @D41869, PER @D41868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM OF, ARITY 2] : DRAW, 
   [COORD @D41872, AGR [COUNT @D41871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : DRAW, 
   [COORD @D41874, AGR [COUNT @D41873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : DRAW, 
   [COORD @D41878, AGR [COUNT @D41877, PER @D41876, PLU @D41875, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM OF, ARITY 2] : DRAW, 
   [COORD @D41884, PAST @D41883, 
      AGR [CASE @D41882, COUNT @D41881, PER @D41880, PLU @D41879, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM OF, ARITY 2] : DRAW, 
   [COORD @D41887, AGR [COUNT @D41886, PER @D41885, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41889, AGR [COUNT @D41888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41891, AGR [COUNT @D41890, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41895, AGR [COUNT @D41894, PER @D41893, PLU @D41892, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT BACK, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41901, PAST @D41900, 
      AGR [CASE @D41899, COUNT @D41898, PER @D41897, PLU @D41896, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, 
      PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41904, AGR [COUNT @D41903, PER @D41902, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41906, AGR [COUNT @D41905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41908, AGR [COUNT @D41907, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41912, AGR [COUNT @D41911, PER @D41910, PLU @D41909, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT AWAY, PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41918, PAST @D41917, 
      AGR [CASE @D41916, COUNT @D41915, PER @D41914, PLU @D41913, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AWAY, 
      PFORM FROM, ARITY 2] : DRAW, 
   [COORD @D41921, AGR [COUNT @D41920, PER @D41919, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : DRAW, 
   [COORD @D41923, AGR [COUNT @D41922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : DRAW, 
   [COORD @D41925, AGR [COUNT @D41924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : DRAW, 
   [COORD @D41929, AGR [COUNT @D41928, PER @D41927, PLU @D41926, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : DRAW, 
   [COORD @D41935, PAST @D41934, AGR [CASE @D41933, COUNT @D41932, 
            PER @D41931, PLU @D41930, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : DRAW, 
   [COORD @D41938, 
      AGR [COUNT @D41937, PER @D41936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : DRAW, 
   [COORD @D41940, AGR [COUNT @D41939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : DRAW, 
   [COORD @D41942, AGR [COUNT @D41941, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : DRAW, 
   [COORD @D41946, AGR [COUNT @D41945, PER @D41944, PLU @D41943, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : DRAW, 
   [COORD @D41952, PAST @D41951, 
      AGR [CASE @D41950, COUNT @D41949, PER @D41948, PLU @D41947, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : DRAW, 
   [COORD @D41955, AGR [COUNT @D41954, PER @D41953, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : DRAW, 
   [COORD @D41957, AGR [COUNT @D41956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : DRAW, 
   [COORD @D41959, AGR [COUNT @D41958, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : DRAW, 
   [COORD @D41963, AGR [COUNT @D41962, PER @D41961, PLU @D41960, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : DRAW, 
   [COORD @D41969, PAST @D41968, 
      AGR [CASE @D41967, COUNT @D41966, PER @D41965, PLU @D41964, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : DRAW, 
   [COORD @D41972, AGR [COUNT @D41971, PER @D41970, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : DRAW, 
   [COORD @D41974, AGR [COUNT @D41973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : DRAW, 
   [COORD @D41976, AGR [COUNT @D41975, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : DRAW, 
   [COORD @D41980, AGR [COUNT @D41979, PER @D41978, PLU @D41977, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, ARITY 2] : DRAW, 
   [COORD @D41986, PAST @D41985, 
      AGR [CASE @D41984, COUNT @D41983, PER @D41982, PLU @D41981, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      ARITY 2] : DRAW, 
   [COORD @D41989, AGR [COUNT @D41988, PER @D41987, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRAW, 
   [COORD @D41991, AGR [COUNT @D41990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRAW, 
   [COORD @D41993, AGR [COUNT @D41992, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRAW, 
   [COORD @D41997, AGR [COUNT @D41996, PER @D41995, PLU @D41994, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : DRAW, 
   [COORD @D42003, PAST @D42002, 
      AGR [CASE @D42001, COUNT @D42000, PER @D41999, PLU @D41998, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : DRAW, 
   [COORD @D42006, AGR [COUNT @D42005, PER @D42004, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRAW, 
   [COORD @D42008, AGR [COUNT @D42007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRAW, 
   [COORD @D42010, AGR [COUNT @D42009, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRAW, 
   [COORD @D42014, AGR [COUNT @D42013, PER @D42012, PLU @D42011, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : DRAW, 
   [COORD @D42020, PAST @D42019, 
      AGR [CASE @D42018, COUNT @D42017, PER @D42016, PLU @D42015, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : DRAW, 
   [COORD @D42023, AGR [COUNT @D42022, PER @D42021, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : DRAW, 
   [COORD @D42025, AGR [COUNT @D42024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : DRAW, 
   [COORD @D42027, AGR [COUNT @D42026, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : DRAW, 
   [COORD @D42031, AGR [COUNT @D42030, PER @D42029, PLU @D42028, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : DRAW, 
   [COORD @D42037, PAST @D42036, 
      AGR [CASE @D42035, COUNT @D42034, PER @D42033, PLU @D42032, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : DRAW, 
   [COORD @D42040, AGR [COUNT @D42039, PER @D42038, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRAW, 
   [COORD @D42042, AGR [COUNT @D42041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRAW, 
   [COORD @D42044, AGR [COUNT @D42043, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRAW, 
   [COORD @D42048, AGR [COUNT @D42047, PER @D42046, PLU @D42045, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, ARITY 2] : DRAW, 
   [COORD @D42054, PAST @D42053, 
      AGR [CASE @D42052, COUNT @D42051, PER @D42050, PLU @D42049, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRAW, 
   [COORD @D42057, AGR [COUNT @D42056, PER @D42055, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : DRAW, 
   [COORD @D42059, AGR [COUNT @D42058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : DRAW, 
   [COORD @D42061, AGR [COUNT @D42060, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : DRAW, 
   [COORD @D42065, AGR [COUNT @D42064, PER @D42063, PLU @D42062, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASIDE, ARITY 2] : DRAW, 
   [COORD @D42071, PAST @D42070, 
      AGR [CASE @D42069, COUNT @D42068, PER @D42067, PLU @D42066, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : DRAW, 
   [COORD @D42074, AGR [COUNT @D42073, PER @D42072, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRAW, 
   [COORD @D42076, AGR [COUNT @D42075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRAW, 
   [COORD @D42078, AGR [COUNT @D42077, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRAW, 
   [COORD @D42082, AGR [COUNT @D42081, PER @D42080, PLU @D42079, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : DRAW, 
   [COORD @D42088, PAST @D42087, 
      AGR [CASE @D42086, COUNT @D42085, PER @D42084, PLU @D42083, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   DRAW, 
   [COORD @D42091, AGR [COUNT @D42090, PER @D42089, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : DRAW, 
   [COORD @D42093, AGR [COUNT @D42092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : DRAW, 
   [COORD @D42095, AGR [COUNT @D42094, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : DRAW, 
   [COORD @D42099, AGR [COUNT @D42098, PER @D42097, PLU @D42096, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : DRAW, 
   [COORD @D42105, PAST @D42104, 
      AGR [CASE @D42103, COUNT @D42102, PER @D42101, PLU @D42100, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : DRAW, 
   [COORD @D42108, AGR [COUNT @D42107, PER @D42106, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : DRAW, 
   [COORD @D42110, AGR [COUNT @D42109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : DRAW, 
   [COORD @D42112, AGR [COUNT @D42111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : DRAW, 
   [COORD @D42116, AGR [COUNT @D42115, PER @D42114, PLU @D42113, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : DRAW, 
   [COORD @D42122, PAST @D42121, 
      AGR [CASE @D42120, COUNT @D42119, PER @D42118, PLU @D42117, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : DRAW, 
   [COORD @D42125, AGR [COUNT @D42124, PER @D42123, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : DRAW, 
   [COORD @D42127, AGR [COUNT @D42126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : DRAW, 
   [COORD @D42129, AGR [COUNT @D42128, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : DRAW, 
   [COORD @D42133, AGR [COUNT @D42132, PER @D42131, PLU @D42130, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : DRAW, 
   [COORD @D42139, PAST @D42138, 
      AGR [CASE @D42137, COUNT @D42136, PER @D42135, PLU @D42134, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : DRAW, 
   [COORD @D42142, AGR [COUNT @D42141, PER @D42140, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRAW, 
   [COORD @D42144, AGR [COUNT @D42143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRAW, 
   [COORD @D42146, AGR [COUNT @D42145, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRAW, 
   [COORD @D42150, AGR [COUNT @D42149, PER @D42148, PLU @D42147, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : DRAW, 
   [COORD @D42156, PAST @D42155, 
      AGR [CASE @D42154, COUNT @D42153, PER @D42152, PLU @D42151, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : DRAW, 
   [COORD @D42159, AGR [COUNT @D42158, PER @D42157, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRAW, 
   [COORD @D42161, AGR [COUNT @D42160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRAW, 
   [COORD @D42163, AGR [COUNT @D42162, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRAW, 
   [COORD @D42167, AGR [COUNT @D42166, PER @D42165, PLU @D42164, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : DRAW, 
   [COORD @D42173, PAST @D42172, 
      AGR [CASE @D42171, COUNT @D42170, PER @D42169, PLU @D42168, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : DRAW, 
   [COORD @D42176, AGR [COUNT @D42175, PER @D42174, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : DRAW, 
   [COORD @D42178, AGR [COUNT @D42177, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : DRAW, 
   [COORD @D42180, AGR [COUNT @D42179, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : DRAW, 
   [COORD @D42184, AGR [COUNT @D42183, PER @D42182, PLU @D42181, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : DRAW, 
   [COORD @D42190, PAST @D42189, 
      AGR [CASE @D42188, COUNT @D42187, PER @D42186, PLU @D42185, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : DRAW, 
   [COORD @D42193, AGR [COUNT @D42192, PER @D42191, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : DRAW, 
   [COORD @D42195, AGR [COUNT @D42194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : DRAW, 
   [COORD @D42197, AGR [COUNT @D42196, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : DRAW, 
   [COORD @D42201, AGR [COUNT @D42200, PER @D42199, PLU @D42198, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : DRAW, 
   [COORD @D42207, PAST @D42206, 
      AGR [CASE @D42205, COUNT @D42204, PER @D42203, PLU @D42202, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : DRAW, 
   [COORD @D42210, AGR [COUNT @D42209, PER @D42208, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : DRAW, 
   [COORD @D42212, AGR [COUNT @D42211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : DRAW, 
   [COORD @D42214, AGR [COUNT @D42213, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : DRAW, 
   [COORD @D42218, AGR [COUNT @D42217, PER @D42216, PLU @D42215, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : DRAW, 
   [COORD @D42224, PAST @D42223, 
      AGR [CASE @D42222, COUNT @D42221, PER @D42220, PLU @D42219, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, 
      ARITY 1] : DRAW, 
   [COORD @D42227, AGR [COUNT @D42226, PER @D42225, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : DRAW, 
   [COORD @D42229, AGR [COUNT @D42228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : DRAW, 
   [COORD @D42231, AGR [COUNT @D42230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : DRAW, 
   [COORD @D42235, AGR [COUNT @D42234, PER @D42233, PLU @D42232, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASIDE, ARITY 1] : DRAW, 
   [COORD @D42241, PAST @D42240, 
      AGR [CASE @D42239, COUNT @D42238, PER @D42237, PLU @D42236, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ASIDE, 
      ARITY 1] : DRAW, 
   [COORD @D42244, AGR [COUNT @D42243, PER @D42242, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT APART, ARITY 1] : DRAW, 
   [COORD @D42246, AGR [COUNT @D42245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT APART, ARITY 1] : DRAW, 
   [COORD @D42248, AGR [COUNT @D42247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT APART, ARITY 1] : DRAW, 
   [COORD @D42252, AGR [COUNT @D42251, PER @D42250, PLU @D42249, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT APART, ARITY 1] : DRAW, 
   [COORD @D42258, PAST @D42257, 
      AGR [CASE @D42256, COUNT @D42255, PER @D42254, PLU @D42253, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT APART, 
      ARITY 1] : DRAW.

WORD drawing : 
   [COORD @D42273, REFL @D42272, COUNT @D42271, PRD @D42270, 
      CASE @D42269, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DRAWING, 
   [COORD @D42279, PRD @D42278, 
      AGR [CASE @D42277, COUNT @D42276, PER @D42275, PLU @D42274, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DRAW, 
   [COORD @D42285, PRD @D42284, AGR [CASE @D42283, COUNT @D42282, 
            PER @D42281, PLU @D42280, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42291, PRD @D42290, 
      AGR [CASE @D42289, COUNT @D42288, PER @D42287, PLU @D42286, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DRAW, 
   [COORD @D42297, PRD @D42296, AGR [CASE @D42295, COUNT @D42294, 
            PER @D42293, PLU @D42292, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42303, PRD @D42302, 
      AGR [CASE @D42301, COUNT @D42300, PER @D42299, PLU @D42298, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DRAW, 
   [COORD @D42309, PRD @D42308, AGR [CASE @D42307, COUNT @D42306, 
            PER @D42305, PLU @D42304, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42315, PRD @D42314, 
      AGR [CASE @D42313, COUNT @D42312, PER @D42311, PLU @D42310, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DRAW, 
   [COORD @D42321, PRD @D42320, AGR [CASE @D42319, COUNT @D42318, 
            PER @D42317, PLU @D42316, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42327, PRD @D42326, 
      AGR [CASE @D42325, COUNT @D42324, PER @D42323, PLU @D42322, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DRAW, 
   [COORD @D42333, PRD @D42332, AGR [CASE @D42331, COUNT @D42330, 
            PER @D42329, PLU @D42328, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42339, PRD @D42338, 
      AGR [CASE @D42337, COUNT @D42336, PER @D42335, PLU @D42334, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42345, PRD @D42344, AGR [CASE @D42343, COUNT @D42342, 
            PER @D42341, PLU @D42340, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT APART, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42351, PRD @D42350, 
      AGR [CASE @D42349, COUNT @D42348, PER @D42347, PLU @D42346, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42357, PRD @D42356, AGR [CASE @D42355, COUNT @D42354, 
            PER @D42353, PLU @D42352, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42363, PRD @D42362, 
      AGR [CASE @D42361, COUNT @D42360, PER @D42359, PLU @D42358, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42369, PRD @D42368, AGR [CASE @D42367, COUNT @D42366, 
            PER @D42365, PLU @D42364, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42375, PRD @D42374, 
      AGR [CASE @D42373, COUNT @D42372, PER @D42371, PLU @D42370, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT BACK, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DRAW, 
   [COORD @D42381, PRD @D42380, AGR [CASE @D42379, COUNT @D42378, 
            PER @D42377, PLU @D42376, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42387, PRD @D42386, 
      AGR [CASE @D42385, COUNT @D42384, PER @D42383, PLU @D42382, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DRAW, 
   [COORD @D42393, PRD @D42392, AGR [CASE @D42391, COUNT @D42390, 
            PER @D42389, PLU @D42388, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42399, PRD @D42398, 
      AGR [CASE @D42397, COUNT @D42396, PER @D42395, PLU @D42394, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42405, PRD @D42404, AGR [CASE @D42403, COUNT @D42402, 
            PER @D42401, PLU @D42400, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42411, PRD @D42410, 
      AGR [CASE @D42409, COUNT @D42408, PER @D42407, PLU @D42406, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42417, PRD @D42416, AGR [CASE @D42415, COUNT @D42414, 
            PER @D42413, PLU @D42412, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42423, PRD @D42422, 
      AGR [CASE @D42421, COUNT @D42420, PER @D42419, PLU @D42418, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42429, PRD @D42428, AGR [CASE @D42427, COUNT @D42426, 
            PER @D42425, PLU @D42424, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42435, PRD @D42434, 
      AGR [CASE @D42433, COUNT @D42432, PER @D42431, PLU @D42430, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42441, PRD @D42440, AGR [CASE @D42439, COUNT @D42438, 
            PER @D42437, PLU @D42436, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42447, PRD @D42446, 
      AGR [CASE @D42445, COUNT @D42444, PER @D42443, PLU @D42442, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42453, PRD @D42452, AGR [CASE @D42451, COUNT @D42450, 
            PER @D42449, PLU @D42448, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42459, PRD @D42458, 
      AGR [CASE @D42457, COUNT @D42456, PER @D42455, PLU @D42454, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42465, PRD @D42464, AGR [CASE @D42463, COUNT @D42462, 
            PER @D42461, PLU @D42460, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42471, PRD @D42470, 
      AGR [CASE @D42469, COUNT @D42468, PER @D42467, PLU @D42466, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42477, PRD @D42476, AGR [CASE @D42475, COUNT @D42474, 
            PER @D42473, PLU @D42472, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42483, PRD @D42482, 
      AGR [CASE @D42481, COUNT @D42480, PER @D42479, PLU @D42478, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42489, PRD @D42488, AGR [CASE @D42487, COUNT @D42486, 
            PER @D42485, PLU @D42484, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW, 
   [COORD @D42495, PRD @D42494, 
      AGR [CASE @D42493, COUNT @D42492, PER @D42491, PLU @D42490, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRAW, 
   [COORD @D42501, PRD @D42500, AGR [CASE @D42499, COUNT @D42498, 
            PER @D42497, PLU @D42496, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT APART, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRAW.

WORD drawings : 
   [COORD @D42514, DEMON @D42513, REFL @D42512, PRD @D42511, 
      CASE @D42510, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DRAWING.

WORD draws : 
   [COORD @D42520, AGR [COUNT @D42519, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42522, 
      AGR [COUNT @D42521, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42524, 
      AGR [COUNT @D42523, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DRAW, 
   [COORD @D42526, AGR [COUNT @D42525, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DRAW, 
   [COORD @D42528, AGR [COUNT @D42527, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : DRAW, 
   [COORD @D42530, AGR [COUNT @D42529, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : DRAW, 
   [COORD @D42532, AGR [COUNT @D42531, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : DRAW, 
   [COORD @D42534, AGR [COUNT @D42533, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42536, 
      AGR [COUNT @D42535, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42538, 
      AGR [COUNT @D42537, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42540, 
      AGR [COUNT @D42539, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42542, 
      AGR [COUNT @D42541, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT APART, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42544, 
      AGR [COUNT @D42543, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42546, 
      AGR [COUNT @D42545, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DRAW, 
   [COORD @D42548, AGR [COUNT @D42547, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DRAW, 
   [COORD @D42550, AGR [COUNT @D42549, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DRAW, 
   [COORD @D42552, AGR [COUNT @D42551, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BACK, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DRAW, 
   [COORD @D42554, AGR [COUNT @D42553, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DRAW, 
   [COORD @D42556, AGR [COUNT @D42555, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : DRAW, 
   [COORD @D42558, AGR [COUNT @D42557, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42560, 
      AGR [COUNT @D42559, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42562, 
      AGR [COUNT @D42561, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42564, 
      AGR [COUNT @D42563, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42566, 
      AGR [COUNT @D42565, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42568, 
      AGR [COUNT @D42567, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42570, 
      AGR [COUNT @D42569, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42572, 
      AGR [COUNT @D42571, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42574, 
      AGR [COUNT @D42573, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42576, 
      AGR [COUNT @D42575, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42578, 
      AGR [COUNT @D42577, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42580, 
      AGR [COUNT @D42579, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42582, 
      AGR [COUNT @D42581, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42584, 
      AGR [COUNT @D42583, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42586, 
      AGR [COUNT @D42585, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42588, 
      AGR [COUNT @D42587, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42590, 
      AGR [COUNT @D42589, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42592, 
      AGR [COUNT @D42591, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW, 
   [COORD @D42594, 
      AGR [COUNT @D42593, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT APART, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRAW.

WORD dream : 
   [COORD @D42601, REFL @D42600, PRD @D42599, CASE @D42598, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DREAM, 
   [COORD @D42604, 
      AGR [COUNT @D42603, PER @D42602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   DREAM, 
   [COORD @D42606, AGR [COUNT @D42605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DREAM, 
   [COORD @D42608, AGR [COUNT @D42607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DREAM, 
   [COORD @D42612, AGR [COUNT @D42611, PER @D42610, PLU @D42609, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : DREAM, 
   [COORD @D42618, PAST @D42617, AGR [CASE @D42616, COUNT @D42615, 
            PER @D42614, PLU @D42613, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : DREAM, 
   [COORD @D42621, AGR [COUNT @D42620, PER @D42619, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DREAM, 
   [COORD @D42623, AGR [COUNT @D42622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DREAM, 
   [COORD @D42625, AGR [COUNT @D42624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DREAM, 
   [COORD @D42629, AGR [COUNT @D42628, PER @D42627, PLU @D42626, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DREAM, 
   [COORD @D42635, PAST @D42634, AGR [CASE @D42633, COUNT @D42632, 
            PER @D42631, PLU @D42630, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DREAM, 
   [COORD @D42638, AGR [COUNT @D42637, PER @D42636, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DREAM, 
   [COORD @D42640, AGR [COUNT @D42639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DREAM, 
   [COORD @D42642, AGR [COUNT @D42641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : DREAM, 
   [COORD @D42646, AGR [COUNT @D42645, PER @D42644, PLU @D42643, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OF, ARITY 2] : DREAM, 
   [COORD @D42652, PAST @D42651, 
      AGR [CASE @D42650, COUNT @D42649, PER @D42648, PLU @D42647, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, 
      ARITY 2] : DREAM, 
   [COORD @D42655, AGR [COUNT @D42654, PER @D42653, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DREAM, 
   [COORD @D42657, AGR [COUNT @D42656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DREAM, 
   [COORD @D42659, AGR [COUNT @D42658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : DREAM, 
   [COORD @D42663, AGR [COUNT @D42662, PER @D42661, PLU @D42660, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : DREAM, 
   [COORD @D42669, PAST @D42668, 
      AGR [CASE @D42667, COUNT @D42666, PER @D42665, PLU @D42664, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      ARITY 2] : DREAM, 
   [COORD @D42672, AGR [COUNT @D42671, PER @D42670, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DREAM, 
   [COORD @D42674, AGR [COUNT @D42673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DREAM, 
   [COORD @D42676, AGR [COUNT @D42675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DREAM, 
   [COORD @D42680, AGR [COUNT @D42679, PER @D42678, PLU @D42677, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : DREAM, 
   [COORD @D42686, PAST @D42685, 
      AGR [CASE @D42684, COUNT @D42683, PER @D42682, PLU @D42681, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : DREAM, 
   [COORD @D42689, AGR [COUNT @D42688, PER @D42687, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : DREAM, 
   [COORD @D42691, AGR [COUNT @D42690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : DREAM, 
   [COORD @D42693, AGR [COUNT @D42692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : DREAM, 
   [COORD @D42697, AGR [COUNT @D42696, PER @D42695, PLU @D42694, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : DREAM, 
   [COORD @D42703, PAST @D42702, 
      AGR [CASE @D42701, COUNT @D42700, PER @D42699, PLU @D42698, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : DREAM, 
   [COORD @D42706, AGR [COUNT @D42705, PER @D42704, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DREAM, 
   [COORD @D42708, AGR [COUNT @D42707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DREAM, 
   [COORD @D42710, AGR [COUNT @D42709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DREAM, 
   [COORD @D42714, AGR [COUNT @D42713, PER @D42712, PLU @D42711, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DREAM, 
   [COORD @D42720, PAST @D42719, AGR [CASE @D42718, COUNT @D42717, 
            PER @D42716, PLU @D42715, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DREAM, 
   [COORD @D42723, AGR [COUNT @D42722, PER @D42721, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DREAM, 
   [COORD @D42725, AGR [COUNT @D42724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DREAM, 
   [COORD @D42727, AGR [COUNT @D42726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DREAM, 
   [COORD @D42731, AGR [COUNT @D42730, PER @D42729, PLU @D42728, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DREAM, 
   [COORD @D42737, PAST @D42736, 
      AGR [CASE @D42735, COUNT @D42734, PER @D42733, PLU @D42732, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : DREAM, 
   [COORD @D42740, AGR [COUNT @D42739, PER @D42738, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DREAM, 
   [COORD @D42742, AGR [COUNT @D42741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DREAM, 
   [COORD @D42744, AGR [COUNT @D42743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DREAM, 
   [COORD @D42748, AGR [COUNT @D42747, PER @D42746, PLU @D42745, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DREAM, 
   [COORD @D42754, PAST @D42753, 
      AGR [CASE @D42752, COUNT @D42751, PER @D42750, PLU @D42749, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : DREAM.

WORD dreamed : 
   [COORD @D42764, AGR [CASE @D42763, COUNT @D42762, PER @D42761, 
            PLU @D42760, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42769, AGR [CASE @D42768, COUNT @D42767, PER @D42766, 
            PLU @D42765, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42774, AGR [UB @D42773, VFORM @D42772, SUBJ @D42771, 
            FIN @D42770, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DREAM, 
   [COORD @D42779, AGR [CASE @D42778, COUNT @D42777, PER @D42776, 
            PLU @D42775, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DREAM, 
   [COORD @D42784, AGR [CASE @D42783, COUNT @D42782, PER @D42781, 
            PLU @D42780, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42789, AGR [CASE @D42788, COUNT @D42787, PER @D42786, 
            PLU @D42785, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42794, AGR [CASE @D42793, COUNT @D42792, PER @D42791, 
            PLU @D42790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42799, AGR [CASE @D42798, COUNT @D42797, PER @D42796, 
            PLU @D42795, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42804, AGR [CASE @D42803, COUNT @D42802, PER @D42801, 
            PLU @D42800, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42809, AGR [CASE @D42808, COUNT @D42807, PER @D42806, 
            PLU @D42805, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42814, AGR [CASE @D42813, COUNT @D42812, PER @D42811, 
            PLU @D42810, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42819, AGR [CASE @D42818, COUNT @D42817, PER @D42816, 
            PLU @D42815, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42824, AGR [CASE @D42823, COUNT @D42822, PER @D42821, 
            PLU @D42820, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42829, AGR [CASE @D42828, COUNT @D42827, PER @D42826, 
            PLU @D42825, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42834, AGR [CASE @D42833, COUNT @D42832, PER @D42831, 
            PLU @D42830, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42839, AGR [CASE @D42838, COUNT @D42837, PER @D42836, 
            PLU @D42835, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42844, AGR [CASE @D42843, COUNT @D42842, PER @D42841, 
            PLU @D42840, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42849, AGR [CASE @D42848, COUNT @D42847, PER @D42846, 
            PLU @D42845, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42854, AGR [CASE @D42853, COUNT @D42852, PER @D42851, 
            PLU @D42850, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42859, AGR [CASE @D42858, COUNT @D42857, PER @D42856, 
            PLU @D42855, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42864, AGR [CASE @D42863, COUNT @D42862, PER @D42861, 
            PLU @D42860, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42869, AGR [CASE @D42868, COUNT @D42867, PER @D42866, 
            PLU @D42865, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DREAM.

WORD dreaming : 
   [COORD @D42884, PRD @D42883, AGR [CASE @D42882, COUNT @D42881, 
            PER @D42880, PLU @D42879, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42890, PRD @D42889, 
      AGR [CASE @D42888, COUNT @D42887, PER @D42886, PLU @D42885, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DREAM, 
   [COORD @D42896, PRD @D42895, AGR [CASE @D42894, COUNT @D42893, 
            PER @D42892, PLU @D42891, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42902, PRD @D42901, 
      AGR [CASE @D42900, COUNT @D42899, PER @D42898, PLU @D42897, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DREAM, 
   [COORD @D42908, PRD @D42907, AGR [CASE @D42906, COUNT @D42905, 
            PER @D42904, PLU @D42903, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42914, PRD @D42913, 
      AGR [CASE @D42912, COUNT @D42911, PER @D42910, PLU @D42909, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DREAM, 
   [COORD @D42920, PRD @D42919, AGR [CASE @D42918, COUNT @D42917, 
            PER @D42916, PLU @D42915, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DREAM, 
   [COORD @D42926, PRD @D42925, 
      AGR [CASE @D42924, COUNT @D42923, PER @D42922, PLU @D42921, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DREAM, 
   [COORD @D42932, PRD @D42931, AGR [CASE @D42930, COUNT @D42929, 
            PER @D42928, PLU @D42927, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DREAM.

WORD dreams : 
   [COORD @D42942, DEMON @D42941, REFL @D42940, PRD @D42939, CASE 
         @D42938, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DREAM, 
   [COORD @D42944, 
      AGR [COUNT @D42943, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42946, 
      AGR [COUNT @D42945, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42948, 
      AGR [COUNT @D42947, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42950, 
      AGR [COUNT @D42949, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42952, 
      AGR [COUNT @D42951, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42954, 
      AGR [COUNT @D42953, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42956, 
      AGR [COUNT @D42955, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42958, 
      AGR [COUNT @D42957, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM, 
   [COORD @D42960, 
      AGR [COUNT @D42959, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DREAM.

WORD dress : 
   [COORD @D42966, AGR [COUNT @D42965, PER @D42964, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DRESS, 
   [COORD @D42968, AGR [COUNT @D42967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DRESS, 
   [COORD @D42970, AGR [COUNT @D42969, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DRESS, 
   [COORD @D42974, AGR [COUNT @D42973, PER @D42972, PLU @D42971, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DRESS, 
   [COORD @D42980, PAST @D42979, AGR [CASE @D42978, COUNT @D42977, 
            PER @D42976, PLU @D42975, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : DRESS, 
   [COORD @D42983, AGR [COUNT @D42982, PER @D42981, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : DRESS, 
   [COORD @D42985, AGR [COUNT @D42984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : DRESS, 
   [COORD @D42987, AGR [COUNT @D42986, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : DRESS, 
   [COORD @D42991, AGR [COUNT @D42990, PER @D42989, PLU @D42988, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : DRESS, 
   [COORD @D42997, PAST @D42996, 
      AGR [CASE @D42995, COUNT @D42994, PER @D42993, PLU @D42992, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM IN, ARITY 3] : DRESS, 
   [COORD @D43000, AGR [COUNT @D42999, PER @D42998, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, PRT UP, PFORM AS, ARITY 3] : DRESS, 
   [COORD @D43002, AGR 
         [COUNT @D43001, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, PRT UP, PFORM AS, 
      ARITY 3] : DRESS, 
   [COORD @D43004, AGR [COUNT @D43003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, PRT UP, PFORM AS, ARITY 3] : DRESS, 
   [COORD @D43008, AGR 
         [COUNT @D43007, PER @D43006, PLU @D43005, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, PRT UP, PFORM AS, ARITY 3] : DRESS, 
   [COORD @D43014, PAST @D43013, 
      AGR [CASE @D43012, COUNT @D43011, PER @D43010, PLU @D43009, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, PRT UP, 
      PFORM AS, ARITY 3] : DRESS, 
   [COORD @D43017, AGR [COUNT @D43016, PER @D43015, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DRESS, 
   [COORD @D43019, AGR [COUNT @D43018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DRESS, 
   [COORD @D43021, AGR [COUNT @D43020, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DRESS, 
   [COORD @D43025, AGR [COUNT @D43024, PER @D43023, PLU @D43022, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DRESS, 
   [COORD @D43031, PAST @D43030, AGR [CASE @D43029, COUNT @D43028, 
            PER @D43027, PLU @D43026, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DRESS, 
   [COORD @D43034, AGR [COUNT @D43033, PER @D43032, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : DRESS, 
   [COORD @D43036, AGR [COUNT @D43035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : DRESS, 
   [COORD @D43038, AGR [COUNT @D43037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : DRESS, 
   [COORD @D43042, AGR [COUNT @D43041, PER @D43040, PLU @D43039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : DRESS, 
   [COORD @D43048, PAST @D43047, AGR [CASE @D43046, COUNT @D43045, 
            PER @D43044, PLU @D43043, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : DRESS, 
   [COORD @D43051, AGR [COUNT @D43050, PER @D43049, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43053, AGR [COUNT @D43052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43055, AGR [COUNT @D43054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43059, AGR [COUNT @D43058, PER @D43057, PLU @D43056, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43065, PAST @D43064, 
      AGR [CASE @D43063, COUNT @D43062, PER @D43061, PLU @D43060, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      ARITY 2] : DRESS, 
   [COORD @D43068, AGR [COUNT @D43067, PER @D43066, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43070, AGR [COUNT @D43069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43072, AGR [COUNT @D43071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43076, AGR [COUNT @D43075, PER @D43074, PLU @D43073, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43082, PAST @D43081, 
      AGR [CASE @D43080, COUNT @D43079, PER @D43078, PLU @D43077, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM IN, ARITY 2] : DRESS, 
   [COORD @D43085, AGR [COUNT @D43084, PER @D43083, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DRESS, 
   [COORD @D43087, AGR [COUNT @D43086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DRESS, 
   [COORD @D43089, AGR [COUNT @D43088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : DRESS, 
   [COORD @D43093, AGR [COUNT @D43092, PER @D43091, PLU @D43090, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : DRESS, 
   [COORD @D43099, PAST @D43098, 
      AGR [CASE @D43097, COUNT @D43096, PER @D43095, PLU @D43094, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : DRESS, 
   [COORD @D43102, AGR [COUNT @D43101, PER @D43100, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : DRESS, 
   [COORD @D43104, AGR [COUNT @D43103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : DRESS, 
   [COORD @D43106, AGR [COUNT @D43105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : DRESS, 
   [COORD @D43110, AGR [COUNT @D43109, PER @D43108, PLU @D43107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : DRESS, 
   [COORD @D43116, PAST @D43115, 
      AGR [CASE @D43114, COUNT @D43113, PER @D43112, PLU @D43111, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : DRESS, 
   [COORD @D43119, AGR [COUNT @D43118, PER @D43117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DRESS, 
   [COORD @D43121, AGR [COUNT @D43120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DRESS, 
   [COORD @D43123, AGR [COUNT @D43122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DRESS, 
   [COORD @D43127, AGR [COUNT @D43126, PER @D43125, PLU @D43124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DRESS, 
   [COORD @D43133, PAST @D43132, AGR [CASE @D43131, COUNT @D43130, 
            PER @D43129, PLU @D43128, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DRESS, 
   [COORD @D43136, AGR [COUNT @D43135, PER @D43134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DRESS, 
   [COORD @D43138, AGR [COUNT @D43137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DRESS, 
   [COORD @D43140, AGR [COUNT @D43139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DRESS, 
   [COORD @D43144, AGR [COUNT @D43143, PER @D43142, PLU @D43141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : DRESS, 
   [COORD @D43150, PAST @D43149, 
      AGR [CASE @D43148, COUNT @D43147, PER @D43146, PLU @D43145, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : DRESS, 
   [COORD @D43153, AGR [COUNT @D43152, PER @D43151, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DRESS, 
   [COORD @D43155, AGR [COUNT @D43154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DRESS, 
   [COORD @D43157, AGR [COUNT @D43156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DRESS, 
   [COORD @D43161, AGR [COUNT @D43160, PER @D43159, PLU @D43158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DRESS, 
   [COORD @D43167, PAST @D43166, 
      AGR [CASE @D43165, COUNT @D43164, PER @D43163, PLU @D43162, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : DRESS.

WORD dressed : 
   [COORD @D43176, AGR [CASE @D43175, COUNT @D43174, PER @D43173, 
            PLU @D43172, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DRESS, 
   [COORD @D43181, AGR [CASE @D43180, COUNT @D43179, PER @D43178, 
            PLU @D43177, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43186, AGR [CASE @D43185, COUNT @D43184, PER @D43183, 
            PLU @D43182, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43191, AGR [CASE @D43190, COUNT @D43189, PER @D43188, 
            PLU @D43187, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43196, AGR [CASE @D43195, COUNT @D43194, PER @D43193, 
            PLU @D43192, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43201, 
      AGR [CASE @D43200, COUNT @D43199, PER @D43198, PLU @D43197, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : DRESS, 
   [COORD @D43206, AGR [CASE @D43205, COUNT @D43204, PER @D43203, 
            PLU @D43202, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PRT UP, PFORM AS, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43211, AGR [CASE @D43210, COUNT @D43209, PER @D43208, 
            PLU @D43207, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PRT UP, PFORM AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43216, 
      AGR [CASE @D43215, COUNT @D43214, PER @D43213, PLU @D43212, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      CONJ NULL, SUBTYPE PVERB, PRT UP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43221, AGR [CASE @D43220, COUNT @D43219, PER @D43218, 
            PLU @D43217, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DRESS, 
   [COORD @D43226, AGR [CASE @D43225, COUNT @D43224, PER @D43223, 
            PLU @D43222, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43231, AGR [CASE @D43230, COUNT @D43229, PER @D43228, 
            PLU @D43227, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43236, AGR [CASE @D43235, COUNT @D43234, PER @D43233, 
            PLU @D43232, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43241, AGR [CASE @D43240, COUNT @D43239, PER @D43238, 
            PLU @D43237, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43246, AGR [CASE @D43245, COUNT @D43244, PER @D43243, 
            PLU @D43242, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43251, AGR [CASE @D43250, COUNT @D43249, PER @D43248, 
            PLU @D43247, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43256, AGR [CASE @D43255, COUNT @D43254, PER @D43253, 
            PLU @D43252, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM IN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43261, AGR [CASE @D43260, COUNT @D43259, PER @D43258, 
            PLU @D43257, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM IN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43266, AGR [CASE @D43265, COUNT @D43264, PER @D43263, 
            PLU @D43262, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43271, AGR [CASE @D43270, COUNT @D43269, PER @D43268, 
            PLU @D43267, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43276, AGR [CASE @D43275, COUNT @D43274, PER @D43273, 
            PLU @D43272, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43281, AGR [CASE @D43280, COUNT @D43279, PER @D43278, 
            PLU @D43277, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43286, AGR [CASE @D43285, COUNT @D43284, PER @D43283, 
            PLU @D43282, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43291, AGR [CASE @D43290, COUNT @D43289, PER @D43288, 
            PLU @D43287, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43296, AGR [CASE @D43295, COUNT @D43294, PER @D43293, 
            PLU @D43292, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43301, AGR [CASE @D43300, COUNT @D43299, PER @D43298, 
            PLU @D43297, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43306, AGR [CASE @D43305, COUNT @D43304, PER @D43303, 
            PLU @D43302, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43311, AGR [CASE @D43310, COUNT @D43309, PER @D43308, 
            PLU @D43307, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43316, AGR [CASE @D43315, COUNT @D43314, PER @D43313, 
            PLU @D43312, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43321, AGR [CASE @D43320, COUNT @D43319, PER @D43318, 
            PLU @D43317, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DRESS.

WORD dressing : 
   [COORD @D43333, PRD @D43332, AGR [CASE @D43331, COUNT @D43330, 
            PER @D43329, PLU @D43328, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43339, PRD @D43338, 
      AGR [CASE @D43337, COUNT @D43336, PER @D43335, PLU @D43334, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DRESS, 
   [COORD @D43345, PRD @D43344, AGR [CASE @D43343, COUNT @D43342, 
            PER @D43341, PLU @D43340, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PRT UP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43351, PRD @D43350, 
      AGR [CASE @D43349, COUNT @D43348, PER @D43347, PLU @D43346, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DRESS, 
   [COORD @D43357, PRD @D43356, AGR [CASE @D43355, COUNT @D43354, 
            PER @D43353, PLU @D43352, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43363, PRD @D43362, 
      AGR [CASE @D43361, COUNT @D43360, PER @D43359, PLU @D43358, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRESS, 
   [COORD @D43369, PRD @D43368, AGR [CASE @D43367, COUNT @D43366, 
            PER @D43365, PLU @D43364, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43375, PRD @D43374, 
      AGR [CASE @D43373, COUNT @D43372, PER @D43371, PLU @D43370, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRESS, 
   [COORD @D43381, PRD @D43380, AGR [CASE @D43379, COUNT @D43378, 
            PER @D43377, PLU @D43376, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43387, PRD @D43386, 
      AGR [CASE @D43385, COUNT @D43384, PER @D43383, PLU @D43382, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DRESS, 
   [COORD @D43393, PRD @D43392, AGR [CASE @D43391, COUNT @D43390, 
            PER @D43389, PLU @D43388, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRESS, 
   [COORD @D43399, PRD @D43398, 
      AGR [CASE @D43397, COUNT @D43396, PER @D43395, PLU @D43394, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRESS.

WORD drink : 
   [COORD @D43411, REFL @D43410, COUNT @D43409, PRD @D43408, CASE 
         @D43407, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DRINK, 
   [COORD @D43415, REFL @D43414, PRD @D43413, CASE @D43412, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DRINK, 
   [COORD @D43418, 
      AGR [COUNT @D43417, PER @D43416, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : DRINK, 
   [COORD @D43420, AGR [COUNT @D43419, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : DRINK, 
   [COORD @D43422, AGR [COUNT @D43421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : DRINK, 
   [COORD @D43426, AGR [COUNT @D43425, PER @D43424, PLU @D43423, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : DRINK, 
   [COORD @D43432, PAST @D43431, 
      AGR [CASE @D43430, COUNT @D43429, PER @D43428, PLU @D43427, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : DRINK, 
   [COORD @D43435, AGR [COUNT @D43434, PER @D43433, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRINK, 
   [COORD @D43437, AGR [COUNT @D43436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRINK, 
   [COORD @D43439, AGR [COUNT @D43438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRINK, 
   [COORD @D43443, AGR [COUNT @D43442, PER @D43441, PLU @D43440, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : DRINK, 
   [COORD @D43449, PAST @D43448, AGR [CASE @D43447, COUNT @D43446, 
            PER @D43445, PLU @D43444, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : DRINK, 
   [COORD @D43452, AGR [COUNT @D43451, PER @D43450, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : DRINK, 
   [COORD @D43454, AGR [COUNT @D43453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : DRINK, 
   [COORD @D43456, AGR [COUNT @D43455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : DRINK, 
   [COORD @D43460, AGR [COUNT @D43459, PER @D43458, PLU @D43457, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : DRINK, 
   [COORD @D43466, PAST @D43465, AGR [CASE @D43464, COUNT @D43463, 
            PER @D43462, PLU @D43461, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : DRINK, 
   [COORD @D43469, 
      AGR [COUNT @D43468, PER @D43467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : DRINK, 
   [COORD @D43471, AGR [COUNT @D43470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : DRINK, 
   [COORD @D43473, AGR [COUNT @D43472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : DRINK, 
   [COORD @D43477, AGR [COUNT @D43476, PER @D43475, PLU @D43474, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : DRINK, 
   [COORD @D43483, PAST @D43482, 
      AGR [CASE @D43481, COUNT @D43480, PER @D43479, PLU @D43478, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : DRINK, 
   [COORD @D43486, AGR [COUNT @D43485, PER @D43484, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRINK, 
   [COORD @D43488, AGR [COUNT @D43487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRINK, 
   [COORD @D43490, AGR [COUNT @D43489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRINK, 
   [COORD @D43494, AGR [COUNT @D43493, PER @D43492, PLU @D43491, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : DRINK, 
   [COORD @D43500, PAST @D43499, 
      AGR [CASE @D43498, COUNT @D43497, PER @D43496, PLU @D43495, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : DRINK, 
   [COORD @D43503, AGR [COUNT @D43502, PER @D43501, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRINK, 
   [COORD @D43505, AGR [COUNT @D43504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRINK, 
   [COORD @D43507, AGR [COUNT @D43506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRINK, 
   [COORD @D43511, AGR [COUNT @D43510, PER @D43509, PLU @D43508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : DRINK, 
   [COORD @D43517, PAST @D43516, 
      AGR [CASE @D43515, COUNT @D43514, PER @D43513, PLU @D43512, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : DRINK, 
   [COORD @D43520, AGR [COUNT @D43519, PER @D43518, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : DRINK, 
   [COORD @D43522, AGR [COUNT @D43521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : DRINK, 
   [COORD @D43524, AGR [COUNT @D43523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : DRINK, 
   [COORD @D43528, AGR [COUNT @D43527, PER @D43526, PLU @D43525, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : DRINK, 
   [COORD @D43534, PAST @D43533, 
      AGR [CASE @D43532, COUNT @D43531, PER @D43530, PLU @D43529, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : DRINK, 
   [COORD @D43537, AGR [COUNT @D43536, PER @D43535, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRINK, 
   [COORD @D43539, AGR [COUNT @D43538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRINK, 
   [COORD @D43541, AGR [COUNT @D43540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRINK, 
   [COORD @D43545, AGR [COUNT @D43544, PER @D43543, PLU @D43542, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : DRINK, 
   [COORD @D43551, PAST @D43550, 
      AGR [CASE @D43549, COUNT @D43548, PER @D43547, PLU @D43546, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   DRINK, 
   [COORD @D43554, AGR [COUNT @D43553, PER @D43552, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : DRINK, 
   [COORD @D43556, AGR [COUNT @D43555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : DRINK, 
   [COORD @D43558, AGR [COUNT @D43557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : DRINK, 
   [COORD @D43562, AGR [COUNT @D43561, PER @D43560, PLU @D43559, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : DRINK, 
   [COORD @D43568, PAST @D43567, 
      AGR [CASE @D43566, COUNT @D43565, PER @D43564, PLU @D43563, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : DRINK, 
   [COORD @D43571, AGR [COUNT @D43570, PER @D43569, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRINK, 
   [COORD @D43573, AGR [COUNT @D43572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRINK, 
   [COORD @D43575, AGR [COUNT @D43574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRINK, 
   [COORD @D43579, AGR [COUNT @D43578, PER @D43577, PLU @D43576, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : DRINK, 
   [COORD @D43585, PAST @D43584, 
      AGR [CASE @D43583, COUNT @D43582, PER @D43581, PLU @D43580, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : DRINK, 
   [COORD @D43588, AGR [COUNT @D43587, PER @D43586, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRINK, 
   [COORD @D43590, AGR [COUNT @D43589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRINK, 
   [COORD @D43592, AGR [COUNT @D43591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRINK, 
   [COORD @D43596, AGR [COUNT @D43595, PER @D43594, PLU @D43593, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : DRINK, 
   [COORD @D43602, PAST @D43601, 
      AGR [CASE @D43600, COUNT @D43599, PER @D43598, PLU @D43597, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : DRINK, 
   [COORD @D43605, AGR [COUNT @D43604, PER @D43603, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : DRINK, 
   [COORD @D43607, AGR [COUNT @D43606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : DRINK, 
   [COORD @D43609, AGR [COUNT @D43608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : DRINK, 
   [COORD @D43613, AGR [COUNT @D43612, PER @D43611, PLU @D43610, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : DRINK, 
   [COORD @D43619, PAST @D43618, 
      AGR [CASE @D43617, COUNT @D43616, PER @D43615, PLU @D43614, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : DRINK.

WORD drinking : 
   [COORD @D43639, PRD @D43638, AGR [CASE @D43637, COUNT @D43636, 
            PER @D43635, PLU @D43634, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRINK, 
   [COORD @D43645, PRD @D43644, 
      AGR [CASE @D43643, COUNT @D43642, PER @D43641, PLU @D43640, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DRINK, 
   [COORD @D43651, PRD @D43650, AGR [CASE @D43649, COUNT @D43648, 
            PER @D43647, PLU @D43646, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRINK, 
   [COORD @D43657, PRD @D43656, 
      AGR [CASE @D43655, COUNT @D43654, PER @D43653, PLU @D43652, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRINK, 
   [COORD @D43663, PRD @D43662, AGR [CASE @D43661, COUNT @D43660, 
            PER @D43659, PLU @D43658, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRINK, 
   [COORD @D43669, PRD @D43668, 
      AGR [CASE @D43667, COUNT @D43666, PER @D43665, PLU @D43664, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRINK, 
   [COORD @D43675, PRD @D43674, AGR [CASE @D43673, COUNT @D43672, 
            PER @D43671, PLU @D43670, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRINK, 
   [COORD @D43681, PRD @D43680, 
      AGR [CASE @D43679, COUNT @D43678, PER @D43677, PLU @D43676, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DRINK, 
   [COORD @D43687, PRD @D43686, AGR [CASE @D43685, COUNT @D43684, 
            PER @D43683, PLU @D43682, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRINK, 
   [COORD @D43693, PRD @D43692, 
      AGR [CASE @D43691, COUNT @D43690, PER @D43689, PLU @D43688, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRINK, 
   [COORD @D43699, PRD @D43698, AGR [CASE @D43697, COUNT @D43696, 
            PER @D43695, PLU @D43694, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRINK, 
   [COORD @D43705, PRD @D43704, 
      AGR [CASE @D43703, COUNT @D43702, PER @D43701, PLU @D43700, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRINK.

WORD drinks : 
   [COORD @D43715, DEMON @D43714, REFL @D43713, PRD @D43712, CASE 
         @D43711, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DRINK, 
   [COORD @D43720, DEMON @D43719, REFL @D43718, PRD @D43717, 
      CASE @D43716, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : DRINK, 
   [COORD @D43722, AGR [COUNT @D43721, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43724, 
      AGR [COUNT @D43723, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43726, 
      AGR [COUNT @D43725, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43728, 
      AGR [COUNT @D43727, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43730, 
      AGR [COUNT @D43729, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43732, 
      AGR [COUNT @D43731, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43734, 
      AGR [COUNT @D43733, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43736, 
      AGR [COUNT @D43735, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43738, 
      AGR [COUNT @D43737, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43740, 
      AGR [COUNT @D43739, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43742, 
      AGR [COUNT @D43741, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK, 
   [COORD @D43744, 
      AGR [COUNT @D43743, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRINK.

WORD drive : 
   [COORD @D43754, REFL @D43753, COUNT @D43752, PRD @D43751, CASE 
         @D43750, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : DRIVE, 
   [COORD @D43757, 
      AGR [COUNT @D43756, PER @D43755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   DRIVE, 
   [COORD @D43759, AGR [COUNT @D43758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43761, AGR [COUNT @D43760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43765, AGR [COUNT @D43764, PER @D43763, PLU @D43762, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : DRIVE, 
   [COORD @D43771, PAST @D43770, 
      AGR [CASE @D43769, COUNT @D43768, PER @D43767, PLU @D43766, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   DRIVE, 
   [COORD @D43774, AGR [COUNT @D43773, PER @D43772, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43776, AGR [COUNT @D43775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43778, AGR [COUNT @D43777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43782, AGR [COUNT @D43781, PER @D43780, PLU @D43779, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : DRIVE, 
   [COORD @D43788, PAST @D43787, 
      AGR [CASE @D43786, COUNT @D43785, PER @D43784, PLU @D43783, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : 
   DRIVE, 
   [COORD @D43791, AGR [COUNT @D43790, PER @D43789, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43793, AGR [COUNT @D43792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43795, AGR [COUNT @D43794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : DRIVE, 
   [COORD @D43799, AGR [COUNT @D43798, PER @D43797, PLU @D43796, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : DRIVE, 
   [COORD @D43805, PAST @D43804, 
      AGR [CASE @D43803, COUNT @D43802, PER @D43801, PLU @D43800, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   DRIVE, 
   [COORD @D43808, AGR [COUNT @D43807, PER @D43806, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : DRIVE, 
   [COORD @D43810, AGR [COUNT @D43809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : DRIVE, 
   [COORD @D43812, AGR [COUNT @D43811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : DRIVE, 
   [COORD @D43816, AGR [COUNT @D43815, PER @D43814, PLU @D43813, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : DRIVE, 
   [COORD @D43822, PAST @D43821, 
      AGR [CASE @D43820, COUNT @D43819, PER @D43818, PLU @D43817, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, 
      ARITY 3] : DRIVE, 
   [COORD @D43825, AGR [COUNT @D43824, PER @D43823, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRIVE, 
   [COORD @D43827, AGR [COUNT @D43826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRIVE, 
   [COORD @D43829, AGR [COUNT @D43828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : DRIVE, 
   [COORD @D43833, AGR [COUNT @D43832, PER @D43831, PLU @D43830, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : DRIVE, 
   [COORD @D43839, PAST @D43838, AGR [CASE @D43837, COUNT @D43836, 
            PER @D43835, PLU @D43834, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : DRIVE, 
   [COORD @D43842, AGR [COUNT @D43841, PER @D43840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : DRIVE, 
   [COORD @D43844, AGR [COUNT @D43843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : DRIVE, 
   [COORD @D43846, AGR [COUNT @D43845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : DRIVE, 
   [COORD @D43850, AGR [COUNT @D43849, PER @D43848, PLU @D43847, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : DRIVE, 
   [COORD @D43856, PAST @D43855, 
      AGR [CASE @D43854, COUNT @D43853, PER @D43852, PLU @D43851, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : 
   DRIVE, 
   [COORD @D43859, AGR [COUNT @D43858, PER @D43857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : DRIVE, 
   [COORD @D43861, AGR [COUNT @D43860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : DRIVE, 
   [COORD @D43863, AGR [COUNT @D43862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : DRIVE, 
   [COORD @D43867, AGR [COUNT @D43866, PER @D43865, PLU @D43864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : DRIVE, 
   [COORD @D43873, PAST @D43872, AGR [CASE @D43871, COUNT @D43870, 
            PER @D43869, PLU @D43868, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : DRIVE, 
   [COORD @D43876, 
      AGR [COUNT @D43875, PER @D43874, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : DRIVE, 
   [COORD @D43878, AGR [COUNT @D43877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRIVE, 
   [COORD @D43880, AGR [COUNT @D43879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : DRIVE, 
   [COORD @D43884, AGR [COUNT @D43883, PER @D43882, PLU @D43881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : DRIVE, 
   [COORD @D43890, PAST @D43889, 
      AGR [CASE @D43888, COUNT @D43887, PER @D43886, PLU @D43885, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : DRIVE, 
   [COORD @D43893, AGR [COUNT @D43892, PER @D43891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRIVE, 
   [COORD @D43895, AGR [COUNT @D43894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRIVE, 
   [COORD @D43897, AGR [COUNT @D43896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : DRIVE, 
   [COORD @D43901, AGR [COUNT @D43900, PER @D43899, PLU @D43898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : DRIVE, 
   [COORD @D43907, PAST @D43906, 
      AGR [CASE @D43905, COUNT @D43904, PER @D43903, PLU @D43902, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : DRIVE, 
   [COORD @D43910, AGR [COUNT @D43909, PER @D43908, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRIVE, 
   [COORD @D43912, AGR [COUNT @D43911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRIVE, 
   [COORD @D43914, AGR [COUNT @D43913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRIVE, 
   [COORD @D43918, AGR [COUNT @D43917, PER @D43916, PLU @D43915, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, ARITY 2] : DRIVE, 
   [COORD @D43924, PAST @D43923, 
      AGR [CASE @D43922, COUNT @D43921, PER @D43920, PLU @D43919, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : DRIVE, 
   [COORD @D43927, AGR [COUNT @D43926, PER @D43925, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRIVE, 
   [COORD @D43929, AGR [COUNT @D43928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRIVE, 
   [COORD @D43931, AGR [COUNT @D43930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : DRIVE, 
   [COORD @D43935, AGR [COUNT @D43934, PER @D43933, PLU @D43932, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : DRIVE, 
   [COORD @D43941, PAST @D43940, 
      AGR [CASE @D43939, COUNT @D43938, PER @D43937, PLU @D43936, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   DRIVE, 
   [COORD @D43944, AGR [COUNT @D43943, PER @D43942, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRIVE, 
   [COORD @D43946, AGR [COUNT @D43945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRIVE, 
   [COORD @D43948, AGR [COUNT @D43947, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : DRIVE, 
   [COORD @D43952, AGR [COUNT @D43951, PER @D43950, PLU @D43949, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : DRIVE, 
   [COORD @D43958, PAST @D43957, 
      AGR [CASE @D43956, COUNT @D43955, PER @D43954, PLU @D43953, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : DRIVE, 
   [COORD @D43961, AGR [COUNT @D43960, PER @D43959, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRIVE, 
   [COORD @D43963, AGR [COUNT @D43962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRIVE, 
   [COORD @D43965, AGR [COUNT @D43964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : DRIVE, 
   [COORD @D43969, AGR [COUNT @D43968, PER @D43967, PLU @D43966, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : DRIVE, 
   [COORD @D43975, PAST @D43974, 
      AGR [CASE @D43973, COUNT @D43972, PER @D43971, PLU @D43970, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : DRIVE, 
   [COORD @D43978, AGR [COUNT @D43977, PER @D43976, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : DRIVE, 
   [COORD @D43980, AGR [COUNT @D43979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : DRIVE, 
   [COORD @D43982, AGR [COUNT @D43981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : DRIVE, 
   [COORD @D43986, AGR [COUNT @D43985, PER @D43984, PLU @D43983, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : DRIVE, 
   [COORD @D43992, PAST @D43991, 
      AGR [CASE @D43990, COUNT @D43989, PER @D43988, PLU @D43987, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, 
      ARITY 1] : DRIVE.

WORD drives : 
   [COORD @D44011, DEMON @D44010, REFL @D44009, PRD @D44008, CASE 
         @D44007, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DRIVE, 
   [COORD @D44013, 
      AGR [COUNT @D44012, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44015, 
      AGR [COUNT @D44014, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44017, 
      AGR [COUNT @D44016, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44019, 
      AGR [COUNT @D44018, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DRIVE, 
   [COORD @D44021, AGR [COUNT @D44020, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44023, 
      AGR [COUNT @D44022, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44025, 
      AGR [COUNT @D44024, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44027, 
      AGR [COUNT @D44026, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44029, 
      AGR [COUNT @D44028, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44031, 
      AGR [COUNT @D44030, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44033, 
      AGR [COUNT @D44032, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44035, 
      AGR [COUNT @D44034, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44037, 
      AGR [COUNT @D44036, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44039, 
      AGR [COUNT @D44038, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRIVE.

WORD driving : 
   [COORD @D44050, PRD @D44049, AGR [CASE @D44048, COUNT @D44047, 
            PER @D44046, PLU @D44045, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44056, PRD @D44055, 
      AGR [CASE @D44054, COUNT @D44053, PER @D44052, PLU @D44051, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DRIVE, 
   [COORD @D44062, PRD @D44061, AGR [CASE @D44060, COUNT @D44059, 
            PER @D44058, PLU @D44057, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44068, PRD @D44067, 
      AGR [CASE @D44066, COUNT @D44065, PER @D44064, PLU @D44063, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DRIVE, 
   [COORD @D44074, PRD @D44073, AGR [CASE @D44072, COUNT @D44071, 
            PER @D44070, PLU @D44069, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44080, PRD @D44079, 
      AGR [CASE @D44078, COUNT @D44077, PER @D44076, PLU @D44075, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   DRIVE, 
   [COORD @D44086, PRD @D44085, AGR [CASE @D44084, COUNT @D44083, 
            PER @D44082, PLU @D44081, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44092, PRD @D44091, 
      AGR [CASE @D44090, COUNT @D44089, PER @D44088, PLU @D44087, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRIVE, 
   [COORD @D44098, PRD @D44097, AGR [CASE @D44096, COUNT @D44095, 
            PER @D44094, PLU @D44093, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44104, PRD @D44103, 
      AGR [CASE @D44102, COUNT @D44101, PER @D44100, PLU @D44099, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRIVE, 
   [COORD @D44110, PRD @D44109, AGR [CASE @D44108, COUNT @D44107, 
            PER @D44106, PLU @D44105, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44116, PRD @D44115, 
      AGR [CASE @D44114, COUNT @D44113, PER @D44112, PLU @D44111, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRIVE, 
   [COORD @D44122, PRD @D44121, AGR [CASE @D44120, COUNT @D44119, 
            PER @D44118, PLU @D44117, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DRIVE, 
   [COORD @D44128, PRD @D44127, 
      AGR [CASE @D44126, COUNT @D44125, PER @D44124, PLU @D44123, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DRIVE.

WORD drop : 
   [COORD @D44135, REFL @D44134, PRD @D44133, CASE @D44132, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DROP, 
   [COORD @D44139, REFL @D44138, PRD @D44137, CASE @D44136, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DROP, 
   [COORD @D44142, 
      AGR [COUNT @D44141, PER @D44140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   DROP, 
   [COORD @D44144, AGR [COUNT @D44143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DROP, 
   [COORD @D44146, AGR [COUNT @D44145, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DROP, 
   [COORD @D44150, AGR [COUNT @D44149, PER @D44148, PLU @D44147, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : DROP, 
   [COORD @D44156, PAST @D44155, AGR [CASE @D44154, COUNT @D44153, 
            PER @D44152, PLU @D44151, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : DROP, 
   [COORD @D44159, AGR [COUNT @D44158, PER @D44157, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DROP, 
   [COORD @D44161, AGR [COUNT @D44160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DROP, 
   [COORD @D44163, AGR [COUNT @D44162, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DROP, 
   [COORD @D44167, AGR [COUNT @D44166, PER @D44165, PLU @D44164, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : DROP, 
   [COORD @D44173, PAST @D44172, 
      AGR [CASE @D44171, COUNT @D44170, PER @D44169, PLU @D44168, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : DROP, 
   [COORD @D44176, AGR [COUNT @D44175, PER @D44174, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DROP, 
   [COORD @D44178, AGR [COUNT @D44177, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DROP, 
   [COORD @D44180, AGR [COUNT @D44179, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DROP, 
   [COORD @D44184, AGR [COUNT @D44183, PER @D44182, PLU @D44181, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DROP, 
   [COORD @D44190, PAST @D44189, AGR [CASE @D44188, COUNT @D44187, 
            PER @D44186, PLU @D44185, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DROP, 
   [COORD @D44193, AGR [COUNT @D44192, PER @D44191, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : DROP, 
   [COORD @D44195, AGR [COUNT @D44194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : DROP, 
   [COORD @D44197, AGR [COUNT @D44196, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : DROP, 
   [COORD @D44201, AGR [COUNT @D44200, PER @D44199, PLU @D44198, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ROUND, ARITY 2] : DROP, 
   [COORD @D44207, PAST @D44206, 
      AGR [CASE @D44205, COUNT @D44204, PER @D44203, PLU @D44202, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ROUND, 
      ARITY 2] : DROP, 
   [COORD @D44210, AGR [COUNT @D44209, PER @D44208, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : DROP, 
   [COORD @D44212, AGR [COUNT @D44211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : DROP, 
   [COORD @D44214, AGR [COUNT @D44213, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : DROP, 
   [COORD @D44218, AGR [COUNT @D44217, PER @D44216, PLU @D44215, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OVER, ARITY 2] : DROP, 
   [COORD @D44224, PAST @D44223, 
      AGR [CASE @D44222, COUNT @D44221, PER @D44220, PLU @D44219, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OVER, 
      ARITY 2] : DROP, 
   [COORD @D44227, AGR [COUNT @D44226, PER @D44225, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : DROP, 
   [COORD @D44229, AGR [COUNT @D44228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : DROP, 
   [COORD @D44231, AGR [COUNT @D44230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : DROP, 
   [COORD @D44235, AGR [COUNT @D44234, PER @D44233, PLU @D44232, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT IN, PFORM ON, ARITY 2] : DROP, 
   [COORD @D44241, PAST @D44240, 
      AGR [CASE @D44239, COUNT @D44238, PER @D44237, PLU @D44236, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, 
      ARITY 2] : DROP, 
   [COORD @D44244, AGR [COUNT @D44243, PER @D44242, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : DROP, 
   [COORD @D44246, AGR [COUNT @D44245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : DROP, 
   [COORD @D44248, AGR [COUNT @D44247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : DROP, 
   [COORD @D44252, AGR [COUNT @D44251, PER @D44250, PLU @D44249, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : DROP, 
   [COORD @D44258, PAST @D44257, 
      AGR [CASE @D44256, COUNT @D44255, PER @D44254, PLU @D44253, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : DROP, 
   [COORD @D44261, AGR [COUNT @D44260, PER @D44259, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : DROP, 
   [COORD @D44263, AGR [COUNT @D44262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : DROP, 
   [COORD @D44265, AGR [COUNT @D44264, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : DROP, 
   [COORD @D44269, AGR [COUNT @D44268, PER @D44267, PLU @D44266, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : DROP, 
   [COORD @D44275, PAST @D44274, 
      AGR [CASE @D44273, COUNT @D44272, PER @D44271, PLU @D44270, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      ARITY 2] : DROP, 
   [COORD @D44278, AGR [COUNT @D44277, PER @D44276, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, ARITY 2] : DROP, 
   [COORD @D44280, AGR [COUNT @D44279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, ARITY 2] : DROP, 
   [COORD @D44282, AGR [COUNT @D44281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, ARITY 2] : DROP, 
   [COORD @D44286, AGR [COUNT @D44285, PER @D44284, PLU @D44283, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM BY, ARITY 2] : DROP, 
   [COORD @D44292, PAST @D44291, 
      AGR [CASE @D44290, COUNT @D44289, PER @D44288, PLU @D44287, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM BY, 
      ARITY 2] : DROP, 
   [COORD @D44295, AGR [COUNT @D44294, PER @D44293, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : DROP, 
   [COORD @D44297, AGR [COUNT @D44296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : DROP, 
   [COORD @D44299, AGR [COUNT @D44298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : DROP, 
   [COORD @D44303, AGR [COUNT @D44302, PER @D44301, PLU @D44300, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : DROP, 
   [COORD @D44309, PAST @D44308, 
      AGR [CASE @D44307, COUNT @D44306, PER @D44305, PLU @D44304, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : DROP, 
   [COORD @D44312, AGR [COUNT @D44311, PER @D44310, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DROP, 
   [COORD @D44314, AGR [COUNT @D44313, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DROP, 
   [COORD @D44316, AGR [COUNT @D44315, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DROP, 
   [COORD @D44320, AGR [COUNT @D44319, PER @D44318, PLU @D44317, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DROP, 
   [COORD @D44326, PAST @D44325, AGR [CASE @D44324, COUNT @D44323, 
            PER @D44322, PLU @D44321, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DROP, 
   [COORD @D44329, AGR [COUNT @D44328, PER @D44327, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DROP, 
   [COORD @D44331, AGR [COUNT @D44330, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DROP, 
   [COORD @D44333, AGR [COUNT @D44332, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DROP, 
   [COORD @D44337, AGR [COUNT @D44336, PER @D44335, PLU @D44334, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : DROP, 
   [COORD @D44343, PAST @D44342, 
      AGR [CASE @D44341, COUNT @D44340, PER @D44339, PLU @D44338, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : DROP, 
   [COORD @D44346, AGR [COUNT @D44345, PER @D44344, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DROP, 
   [COORD @D44348, AGR [COUNT @D44347, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DROP, 
   [COORD @D44350, AGR [COUNT @D44349, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DROP, 
   [COORD @D44354, AGR [COUNT @D44353, PER @D44352, PLU @D44351, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : DROP, 
   [COORD @D44360, PAST @D44359, 
      AGR [CASE @D44358, COUNT @D44357, PER @D44356, PLU @D44355, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : DROP, 
   [COORD @D44363, AGR [COUNT @D44362, PER @D44361, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DROP, 
   [COORD @D44365, AGR [COUNT @D44364, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DROP, 
   [COORD @D44367, AGR [COUNT @D44366, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DROP, 
   [COORD @D44371, AGR [COUNT @D44370, PER @D44369, PLU @D44368, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : DROP, 
   [COORD @D44377, PAST @D44376, 
      AGR [CASE @D44375, COUNT @D44374, PER @D44373, PLU @D44372, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : DROP, 
   [COORD @D44380, AGR [COUNT @D44379, PER @D44378, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BEHIND, ARITY 1] : DROP, 
   [COORD @D44382, AGR [COUNT @D44381, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BEHIND, ARITY 1] : DROP, 
   [COORD @D44384, AGR [COUNT @D44383, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BEHIND, ARITY 1] : DROP, 
   [COORD @D44388, AGR [COUNT @D44387, PER @D44386, PLU @D44385, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BEHIND, ARITY 1] : DROP, 
   [COORD @D44394, PAST @D44393, 
      AGR [CASE @D44392, COUNT @D44391, PER @D44390, PLU @D44389, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BEHIND, 
      ARITY 1] : DROP, 
   [COORD @D44397, AGR [COUNT @D44396, PER @D44395, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DROP, 
   [COORD @D44399, AGR [COUNT @D44398, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DROP, 
   [COORD @D44401, AGR [COUNT @D44400, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DROP, 
   [COORD @D44405, AGR [COUNT @D44404, PER @D44403, PLU @D44402, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : DROP, 
   [COORD @D44411, PAST @D44410, 
      AGR [CASE @D44409, COUNT @D44408, PER @D44407, PLU @D44406, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, 
      ARITY 1] : DROP, 
   [COORD @D44414, AGR [COUNT @D44413, PER @D44412, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DROP, 
   [COORD @D44416, AGR [COUNT @D44415, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DROP, 
   [COORD @D44418, AGR [COUNT @D44417, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DROP, 
   [COORD @D44422, AGR [COUNT @D44421, PER @D44420, PLU @D44419, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : DROP, 
   [COORD @D44428, PAST @D44427, 
      AGR [CASE @D44426, COUNT @D44425, PER @D44424, PLU @D44423, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : DROP.

WORD dropped : 
   [COORD @D44438, AGR [CASE @D44437, COUNT @D44436, PER @D44435, 
            PLU @D44434, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DROP, 
   [COORD @D44443, AGR [CASE @D44442, COUNT @D44441, PER @D44440, 
            PLU @D44439, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44448, AGR [CASE @D44447, COUNT @D44446, PER @D44445, 
            PLU @D44444, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44453, AGR [CASE @D44452, COUNT @D44451, PER @D44450, 
            PLU @D44449, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44458, AGR [CASE @D44457, COUNT @D44456, PER @D44455, 
            PLU @D44454, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44463, AGR [CASE @D44462, COUNT @D44461, PER @D44460, 
            PLU @D44459, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44468, AGR [CASE @D44467, COUNT @D44466, PER @D44465, 
            PLU @D44464, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DROP, 
   [COORD @D44473, AGR [CASE @D44472, COUNT @D44471, PER @D44470, 
            PLU @D44469, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44478, AGR [CASE @D44477, COUNT @D44476, PER @D44475, 
            PLU @D44474, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44483, AGR [CASE @D44482, COUNT @D44481, PER @D44480, 
            PLU @D44479, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44488, AGR [CASE @D44487, COUNT @D44486, PER @D44485, 
            PLU @D44484, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44493, AGR [CASE @D44492, COUNT @D44491, PER @D44490, 
            PLU @D44489, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44498, AGR [CASE @D44497, COUNT @D44496, PER @D44495, 
            PLU @D44494, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44503, AGR [CASE @D44502, COUNT @D44501, PER @D44500, 
            PLU @D44499, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44508, AGR [CASE @D44507, COUNT @D44506, PER @D44505, 
            PLU @D44504, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44513, AGR [CASE @D44512, COUNT @D44511, PER @D44510, 
            PLU @D44509, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44518, AGR [CASE @D44517, COUNT @D44516, PER @D44515, 
            PLU @D44514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44523, AGR [CASE @D44522, COUNT @D44521, PER @D44520, 
            PLU @D44519, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44528, AGR [CASE @D44527, COUNT @D44526, PER @D44525, 
            PLU @D44524, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44533, AGR [CASE @D44532, COUNT @D44531, PER @D44530, 
            PLU @D44529, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44538, AGR [CASE @D44537, COUNT @D44536, PER @D44535, 
            PLU @D44534, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44543, AGR [CASE @D44542, COUNT @D44541, PER @D44540, 
            PLU @D44539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44548, AGR [CASE @D44547, COUNT @D44546, PER @D44545, 
            PLU @D44544, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44553, AGR [CASE @D44552, COUNT @D44551, PER @D44550, 
            PLU @D44549, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44558, AGR [CASE @D44557, COUNT @D44556, PER @D44555, 
            PLU @D44554, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44563, AGR [CASE @D44562, COUNT @D44561, PER @D44560, 
            PLU @D44559, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44568, AGR [CASE @D44567, COUNT @D44566, PER @D44565, 
            PLU @D44564, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44573, AGR [CASE @D44572, COUNT @D44571, PER @D44570, 
            PLU @D44569, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44578, AGR [CASE @D44577, COUNT @D44576, PER @D44575, 
            PLU @D44574, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44583, AGR [CASE @D44582, COUNT @D44581, PER @D44580, 
            PLU @D44579, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44588, AGR [CASE @D44587, COUNT @D44586, PER @D44585, 
            PLU @D44584, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44593, AGR [CASE @D44592, COUNT @D44591, PER @D44590, 
            PLU @D44589, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44598, AGR [CASE @D44597, COUNT @D44596, PER @D44595, 
            PLU @D44594, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44603, AGR [CASE @D44602, COUNT @D44601, PER @D44600, 
            PLU @D44599, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BEHIND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44608, AGR [CASE @D44607, COUNT @D44606, PER @D44605, 
            PLU @D44604, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BEHIND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44613, AGR [CASE @D44612, COUNT @D44611, PER @D44610, 
            PLU @D44609, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44618, AGR [CASE @D44617, COUNT @D44616, PER @D44615, 
            PLU @D44614, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP, 
   [COORD @D44623, AGR [CASE @D44622, COUNT @D44621, PER @D44620, 
            PLU @D44619, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44628, AGR [CASE @D44627, COUNT @D44626, PER @D44625, 
            PLU @D44624, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : DROP.

WORD dropping : 
   [COORD @D44639, PRD @D44638, AGR [CASE @D44637, COUNT @D44636, 
            PER @D44635, PLU @D44634, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44645, PRD @D44644, 
      AGR [CASE @D44643, COUNT @D44642, PER @D44641, PLU @D44640, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : DROP, 
   [COORD @D44651, PRD @D44650, AGR [CASE @D44649, COUNT @D44648, 
            PER @D44647, PLU @D44646, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44657, PRD @D44656, 
      AGR [CASE @D44655, COUNT @D44654, PER @D44653, PLU @D44652, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DROP, 
   [COORD @D44663, PRD @D44662, AGR [CASE @D44661, COUNT @D44660, 
            PER @D44659, PLU @D44658, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44669, PRD @D44668, 
      AGR [CASE @D44667, COUNT @D44666, PER @D44665, PLU @D44664, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DROP, 
   [COORD @D44675, PRD @D44674, AGR [CASE @D44673, COUNT @D44672, 
            PER @D44671, PLU @D44670, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44681, PRD @D44680, 
      AGR [CASE @D44679, COUNT @D44678, PER @D44677, PLU @D44676, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DROP, 
   [COORD @D44687, PRD @D44686, AGR [CASE @D44685, COUNT @D44684, 
            PER @D44683, PLU @D44682, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44693, PRD @D44692, 
      AGR [CASE @D44691, COUNT @D44690, PER @D44689, PLU @D44688, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DROP, 
   [COORD @D44699, PRD @D44698, AGR [CASE @D44697, COUNT @D44696, 
            PER @D44695, PLU @D44694, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44705, PRD @D44704, 
      AGR [CASE @D44703, COUNT @D44702, PER @D44701, PLU @D44700, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DROP, 
   [COORD @D44711, PRD @D44710, AGR [CASE @D44709, COUNT @D44708, 
            PER @D44707, PLU @D44706, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44717, PRD @D44716, 
      AGR [CASE @D44715, COUNT @D44714, PER @D44713, PLU @D44712, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DROP, 
   [COORD @D44723, PRD @D44722, AGR [CASE @D44721, COUNT @D44720, 
            PER @D44719, PLU @D44718, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT BEHIND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP, 
   [COORD @D44729, PRD @D44728, 
      AGR [CASE @D44727, COUNT @D44726, PER @D44725, PLU @D44724, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DROP, 
   [COORD @D44735, PRD @D44734, AGR [CASE @D44733, COUNT @D44732, 
            PER @D44731, PLU @D44730, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DROP.

WORD drops : 
   [COORD @D44744, REFL @D44743, PRD @D44742, CASE @D44741, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : DROPS, 
   [COORD @D44749, DEMON @D44748, REFL @D44747, PRD @D44746, 
      CASE @D44745, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DROP, 
   [COORD @D44751, 
      AGR [COUNT @D44750, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44753, 
      AGR [COUNT @D44752, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DROP, 
   [COORD @D44755, AGR [COUNT @D44754, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44757, 
      AGR [COUNT @D44756, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44759, 
      AGR [COUNT @D44758, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44761, 
      AGR [COUNT @D44760, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DROP, 
   [COORD @D44763, AGR [COUNT @D44762, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   DROP, 
   [COORD @D44765, AGR [COUNT @D44764, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44767, 
      AGR [COUNT @D44766, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44769, 
      AGR [COUNT @D44768, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44771, 
      AGR [COUNT @D44770, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44773, 
      AGR [COUNT @D44772, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44775, 
      AGR [COUNT @D44774, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44777, 
      AGR [COUNT @D44776, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44779, 
      AGR [COUNT @D44778, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BEHIND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44781, 
      AGR [COUNT @D44780, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP, 
   [COORD @D44783, 
      AGR [COUNT @D44782, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DROP.

WORD drug : 
   [COORD @D44800, REFL @D44799, PRD @D44798, CASE @D44797, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DRUG, 
   [COORD @D44803, 
      AGR [COUNT @D44802, PER @D44801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   DRUG, 
   [COORD @D44805, AGR [COUNT @D44804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DRUG, 
   [COORD @D44807, AGR [COUNT @D44806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DRUG, 
   [COORD @D44811, AGR [COUNT @D44810, PER @D44809, PLU @D44808, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DRUG, 
   [COORD @D44817, PAST @D44816, AGR [CASE @D44815, COUNT @D44814, 
            PER @D44813, PLU @D44812, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DRUG.

WORD drugged : 
   [COORD @D44827, AGR [CASE @D44826, COUNT @D44825, PER @D44824, 
            PLU @D44823, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DRUG, 
   [COORD @D44832, AGR [CASE @D44831, COUNT @D44830, PER @D44829, 
            PLU @D44828, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DRUG, 
   [COORD @D44837, AGR [CASE @D44836, COUNT @D44835, PER @D44834, 
            PLU @D44833, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DRUG.

WORD drugging : 
   [COORD @D44848, PRD @D44847, AGR [CASE @D44846, COUNT @D44845, 
            PER @D44844, PLU @D44843, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DRUG.

WORD drugs : 
   [COORD @D44858, DEMON @D44857, REFL @D44856, PRD @D44855, CASE 
         @D44854, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DRUG, 
   [COORD @D44860, 
      AGR [COUNT @D44859, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DRUG.

WORD dwarf : 
   [COORD @D44867, REFL @D44866, PRD @D44865, CASE @D44864, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : DWARF, 
   [COORD @D44870, 
      AGR [COUNT @D44869, PER @D44868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   DWARF, 
   [COORD @D44872, AGR [COUNT @D44871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DWARF, 
   [COORD @D44874, AGR [COUNT @D44873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DWARF, 
   [COORD @D44878, AGR [COUNT @D44877, PER @D44876, PLU @D44875, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DWARF, 
   [COORD @D44884, PAST @D44883, AGR [CASE @D44882, COUNT @D44881, 
            PER @D44880, PLU @D44879, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DWARF.

WORD dwarfed : 
   [COORD @D44894, AGR [CASE @D44893, COUNT @D44892, PER @D44891, 
            PLU @D44890, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DWARF, 
   [COORD @D44899, AGR [CASE @D44898, COUNT @D44897, PER @D44896, 
            PLU @D44895, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DWARF, 
   [COORD @D44904, AGR [CASE @D44903, COUNT @D44902, PER @D44901, 
            PLU @D44900, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DWARF.

WORD dwarfing : 
   [COORD @D44919, PRD @D44918, AGR [CASE @D44917, COUNT @D44916, 
            PER @D44915, PLU @D44914, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DWARF.

WORD dwarfs : 
   [COORD @D44929, DEMON @D44928, REFL @D44927, PRD @D44926, CASE 
         @D44925, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : DWARF, 
   [COORD @D44931, 
      AGR [COUNT @D44930, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DWARF.

WORD dye : 
   [COORD @D44942, AGR [COUNT @D44941, PER @D44940, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : DYE, 
   [COORD @D44944, AGR [COUNT @D44943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : DYE, 
   [COORD @D44946, AGR [COUNT @D44945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : DYE, 
   [COORD @D44950, AGR [COUNT @D44949, PER @D44948, PLU @D44947, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : DYE, 
   [COORD @D44956, PAST @D44955, AGR [CASE @D44954, COUNT @D44953, 
            PER @D44952, PLU @D44951, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : DYE, 
   [COORD @D44959, AGR [COUNT @D44958, PER @D44957, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DYE, 
   [COORD @D44961, AGR [COUNT @D44960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DYE, 
   [COORD @D44963, AGR [COUNT @D44962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DYE, 
   [COORD @D44967, AGR [COUNT @D44966, PER @D44965, PLU @D44964, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : DYE, 
   [COORD @D44973, PAST @D44972, AGR [CASE @D44971, COUNT @D44970, 
            PER @D44969, PLU @D44968, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : DYE, 
   [COORD @D44976, AGR [COUNT @D44975, PER @D44974, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DYE, 
   [COORD @D44978, AGR [COUNT @D44977, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DYE, 
   [COORD @D44980, AGR [COUNT @D44979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : DYE, 
   [COORD @D44984, AGR [COUNT @D44983, PER @D44982, PLU @D44981, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : DYE, 
   [COORD @D44990, PAST @D44989, AGR [CASE @D44988, COUNT @D44987, 
            PER @D44986, PLU @D44985, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : DYE, 
   [COORD @D44993, AGR [COUNT @D44992, PER @D44991, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DYE, 
   [COORD @D44995, AGR [COUNT @D44994, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DYE, 
   [COORD @D44997, AGR [COUNT @D44996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DYE, 
   [COORD @D45001, AGR [COUNT @D45000, PER @D44999, PLU @D44998, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : DYE, 
   [COORD @D45007, PAST @D45006, AGR [CASE @D45005, COUNT @D45004, 
            PER @D45003, PLU @D45002, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : DYE.

WORD dyed : 
   [COORD @D45018, AGR [CASE @D45017, COUNT @D45016, PER @D45015, 
            PLU @D45014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DYE, 
   [COORD @D45023, AGR [CASE @D45022, COUNT @D45021, PER @D45020, 
            PLU @D45019, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DYE, 
   [COORD @D45029, AGR [CASE @D45028, NFORM @D45027, COUNT @D45026, 
            PER @D45025, PLU @D45024, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DYE, 
   [COORD @D45034, AGR [CASE @D45033, COUNT @D45032, PER @D45031, 
            PLU @D45030, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DYE, 
   [COORD @D45039, AGR [CASE @D45038, COUNT @D45037, PER @D45036, 
            PLU @D45035, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DYE, 
   [COORD @D45044, AGR [CASE @D45043, COUNT @D45042, PER @D45041, 
            PLU @D45040, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : DYE, 
   [COORD @D45049, AGR [CASE @D45048, COUNT @D45047, PER @D45046, 
            PLU @D45045, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DYE, 
   [COORD @D45054, AGR [CASE @D45053, COUNT @D45052, PER @D45051, 
            PLU @D45050, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DYE, 
   [COORD @D45059, AGR [CASE @D45058, COUNT @D45057, PER @D45056, 
            PLU @D45055, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : DYE, 
   [COORD @D45064, AGR [CASE @D45063, COUNT @D45062, PER @D45061, 
            PLU @D45060, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : DYE.

WORD dyes : 
   [COORD @D45072, AGR [COUNT @D45071, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DYE, 
   [COORD @D45074, 
      AGR [COUNT @D45073, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DYE, 
   [COORD @D45076, 
      AGR [COUNT @D45075, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DYE, 
   [COORD @D45078, 
      AGR [COUNT @D45077, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : DYE.

WORD dying : 
   [COORD @D45089, PRD @D45088, AGR [CASE @D45087, COUNT @D45086, 
            PER @D45085, PLU @D45084, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DYE, 
   [COORD @D45095, PRD @D45094, AGR 
         [CASE @D45093, COUNT @D45092, PER @D45091, PLU @D45090, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DYE, 
   
   [COORD @D45101, PRD @D45100, AGR [CASE @D45099, COUNT @D45098, PER 
               @D45097, PLU @D45096, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DYE, 
   [COORD @D45107, PRD @D45106, AGR 
         [CASE @D45105, COUNT @D45104, PER @D45103, PLU @D45102, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DYE, 
   
   [COORD @D45113, PRD @D45112, AGR [CASE @D45111, COUNT @D45110, PER 
               @D45109, PLU @D45108, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D45119, PRD @D45118, AGR 
         [CASE @D45117, COUNT @D45116, PER @D45115, PLU @D45114, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DIE, 
   
   [COORD @D45125, PRD @D45124, AGR [CASE @D45123, COUNT @D45122, PER 
               @D45121, PLU @D45120, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D45131, PRD @D45130, AGR 
         [CASE @D45129, COUNT @D45128, PER @D45127, PLU @D45126, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : DIE, 
   
   [COORD @D45137, PRD @D45136, AGR [CASE @D45135, COUNT @D45134, PER 
               @D45133, PLU @D45132, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D45143, PRD @D45142, 
      AGR [CASE @D45141, COUNT @D45140, PER @D45139, PLU @D45138, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DIE, 
   [COORD @D45149, PRD @D45148, AGR [CASE @D45147, COUNT @D45146, 
            PER @D45145, PLU @D45144, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D45155, PRD @D45154, AGR 
         [CASE @D45153, COUNT @D45152, PER @D45151, PLU @D45150, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DIE, 
   [COORD @D45161, PRD @D45160, AGR [CASE @D45159, COUNT @D45158, 
            PER @D45157, PLU @D45156, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D45167, PRD @D45166, 
      AGR [CASE @D45165, COUNT @D45164, PER @D45163, PLU @D45162, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DIE, 
   [COORD @D45173, PRD @D45172, AGR [CASE @D45171, COUNT @D45170, 
            PER @D45169, PLU @D45168, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : DIE, 
   [COORD @D45179, PRD @D45178, 
      AGR [CASE @D45177, COUNT @D45176, PER @D45175, PLU @D45174, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : DIE.

WORD eat : 
   [COORD @D45192, AGR [COUNT @D45191, PER @D45190, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : EAT, 
   [COORD @D45194, AGR [COUNT @D45193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : EAT, 
   [COORD @D45196, AGR [COUNT @D45195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : EAT, 
   [COORD @D45200, AGR [COUNT @D45199, PER @D45198, PLU @D45197, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : EAT, 
   [COORD @D45206, PAST @D45205, AGR [CASE @D45204, COUNT @D45203, 
            PER @D45202, PLU @D45201, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : EAT, 
   [COORD @D45209, AGR [COUNT @D45208, PER @D45207, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : EAT, 
   [COORD @D45211, AGR [COUNT @D45210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : EAT, 
   [COORD @D45213, AGR [COUNT @D45212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : EAT, 
   [COORD @D45217, AGR [COUNT @D45216, PER @D45215, PLU @D45214, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM INTO, ARITY 2] : EAT, 
   [COORD @D45223, PAST @D45222, AGR [CASE @D45221, COUNT @D45220, 
            PER @D45219, PLU @D45218, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, ARITY 2] : EAT, 
   [COORD @D45226, 
      AGR [COUNT @D45225, PER @D45224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : EAT, 
   [COORD @D45228, AGR [COUNT @D45227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : EAT, 
   [COORD @D45230, AGR [COUNT @D45229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : EAT, 
   [COORD @D45234, AGR [COUNT @D45233, PER @D45232, PLU @D45231, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : EAT, 
   [COORD @D45240, PAST @D45239, 
      AGR [CASE @D45238, COUNT @D45237, PER @D45236, PLU @D45235, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : EAT, 
   [COORD @D45243, AGR [COUNT @D45242, PER @D45241, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : EAT, 
   [COORD @D45245, AGR [COUNT @D45244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : EAT, 
   [COORD @D45247, AGR [COUNT @D45246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : EAT, 
   [COORD @D45251, AGR [COUNT @D45250, PER @D45249, PLU @D45248, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, ARITY 2] : EAT, 
   [COORD @D45257, PAST @D45256, 
      AGR [CASE @D45255, COUNT @D45254, PER @D45253, PLU @D45252, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : EAT, 
   [COORD @D45260, AGR [COUNT @D45259, PER @D45258, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : EAT, 
   [COORD @D45262, AGR [COUNT @D45261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : EAT, 
   [COORD @D45264, AGR [COUNT @D45263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : EAT, 
   [COORD @D45268, AGR [COUNT @D45267, PER @D45266, PLU @D45265, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : EAT, 
   [COORD @D45274, PAST @D45273, AGR 
         [CASE @D45272, COUNT @D45271, PER @D45270, PLU @D45269, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   EAT, 
   [COORD @D45277, AGR [COUNT @D45276, PER @D45275, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : EAT, 
   [COORD @D45279, AGR [COUNT @D45278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : EAT, 
   [COORD @D45281, AGR [COUNT @D45280, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : EAT, 
   [COORD @D45285, AGR [COUNT @D45284, PER @D45283, PLU @D45282, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : EAT, 
   [COORD @D45291, PAST @D45290, 
      AGR [CASE @D45289, COUNT @D45288, PER @D45287, PLU @D45286, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : EAT, 
   [COORD @D45294, AGR [COUNT @D45293, PER @D45292, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : EAT, 
   [COORD @D45296, AGR [COUNT @D45295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : EAT, 
   [COORD @D45298, AGR [COUNT @D45297, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : EAT, 
   [COORD @D45302, AGR [COUNT @D45301, PER @D45300, PLU @D45299, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : EAT, 
   [COORD @D45308, PAST @D45307, 
      AGR [CASE @D45306, COUNT @D45305, PER @D45304, PLU @D45303, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, 
      ARITY 1] : EAT.

WORD eaten : 
   [COORD @D45317, PAST @D45316, AGR [CASE @D45315, COUNT @D45314, 
            PER @D45313, PLU @D45312, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : EAT, 
   [COORD @D45323, PAST @D45322, 
      AGR [CASE @D45321, COUNT @D45320, PER @D45319, PLU @D45318, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : EAT, 
   [COORD @D45329, PAST @D45328, 
      AGR [CASE @D45327, COUNT @D45326, PER @D45325, PLU @D45324, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM INTO, FIN -, 
      ARITY 2] : EAT, 
   [COORD @D45335, PAST @D45334, AGR [CASE @D45333, COUNT @D45332, 
            PER @D45331, PLU @D45330, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM INTO, FIN -, ARITY 2] : EAT, 
   [COORD @D45341, PAST @D45340, 
      AGR [CASE @D45339, COUNT @D45338, PER @D45337, PLU @D45336, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : EAT, 
   [COORD @D45347, PAST @D45346, AGR [CASE @D45345, COUNT @D45344, 
            PER @D45343, PLU @D45342, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : EAT, 
   [COORD @D45353, PAST @D45352, 
      AGR [CASE @D45351, COUNT @D45350, PER @D45349, PLU @D45348, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, FIN -, 
      ARITY 2] : EAT, 
   [COORD @D45359, PAST @D45358, AGR [CASE @D45357, COUNT @D45356, 
            PER @D45355, PLU @D45354, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, FIN -, ARITY 2] : EAT, 
   [COORD @D45365, PAST @D45364, 
      AGR [CASE @D45363, COUNT @D45362, PER @D45361, PLU @D45360, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, ARITY 1] : EAT, 
   [COORD @D45371, PAST @D45370, 
      AGR [CASE @D45369, COUNT @D45368, PER @D45367, PLU @D45366, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : EAT, 
   [COORD @D45377, PAST @D45376, AGR [CASE @D45375, COUNT @D45374, 
            PER @D45373, PLU @D45372, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, FIN -, ARITY 1] : EAT.

WORD eating : 
   [COORD @D45400, PRD @D45399, AGR [CASE @D45398, COUNT @D45397, 
            PER @D45396, PLU @D45395, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EAT, 
   [COORD @D45406, PRD @D45405, AGR 
         [CASE @D45404, COUNT @D45403, PER @D45402, PLU @D45401, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : EAT, 
   [COORD @D45412, PRD @D45411, AGR [CASE @D45410, COUNT @D45409, 
            PER @D45408, PLU @D45407, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EAT, 
   [COORD @D45418, PRD @D45417, 
      AGR [CASE @D45416, COUNT @D45415, PER @D45414, PLU @D45413, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : EAT, 
   [COORD @D45424, PRD @D45423, AGR [CASE @D45422, COUNT @D45421, 
            PER @D45420, PLU @D45419, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EAT, 
   [COORD @D45430, PRD @D45429, AGR 
         [CASE @D45428, COUNT @D45427, PER @D45426, PLU @D45425, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : EAT, 
   [COORD @D45436, PRD @D45435, AGR [CASE @D45434, COUNT @D45433, 
            PER @D45432, PLU @D45431, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EAT.

WORD eats : 
   [COORD @D45441, AGR [COUNT @D45440, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EAT, 
   [COORD @D45443, 
      AGR [COUNT @D45442, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EAT, 
   [COORD @D45445, 
      AGR [COUNT @D45444, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EAT, 
   [COORD @D45447, 
      AGR [COUNT @D45446, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EAT, 
   [COORD @D45449, 
      AGR [COUNT @D45448, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EAT, 
   [COORD @D45451, 
      AGR [COUNT @D45450, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EAT, 
   [COORD @D45453, 
      AGR [COUNT @D45452, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EAT.

WORD edge : 
   [COORD @D45460, AGR [COUNT @D45459, PER @D45458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : EDGE, 
   [COORD @D45462, AGR [COUNT @D45461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : EDGE, 
   [COORD @D45464, AGR [COUNT @D45463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : EDGE, 
   [COORD @D45468, AGR [COUNT @D45467, PER @D45466, PLU @D45465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : EDGE, 
   [COORD @D45474, PAST @D45473, AGR [CASE @D45472, COUNT @D45471, 
            PER @D45470, PLU @D45469, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : EDGE, 
   [COORD @D45477, AGR [COUNT @D45476, PER @D45475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : EDGE, 
   [COORD @D45479, AGR [COUNT @D45478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : EDGE, 
   [COORD @D45481, AGR [COUNT @D45480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : EDGE, 
   [COORD @D45485, AGR [COUNT @D45484, PER @D45483, PLU @D45482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : EDGE, 
   [COORD @D45491, PAST @D45490, 
      AGR [CASE @D45489, COUNT @D45488, PER @D45487, PLU @D45486, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : EDGE, 
   [COORD @D45494, AGR [COUNT @D45493, PER @D45492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EDGE, 
   [COORD @D45496, AGR [COUNT @D45495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EDGE, 
   [COORD @D45498, AGR [COUNT @D45497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EDGE, 
   [COORD @D45502, AGR [COUNT @D45501, PER @D45500, PLU @D45499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EDGE, 
   [COORD @D45508, PAST @D45507, AGR [CASE @D45506, COUNT @D45505, 
            PER @D45504, PLU @D45503, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EDGE, 
   [COORD @D45511, AGR [COUNT @D45510, PER @D45509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : EDGE, 
   [COORD @D45513, AGR [COUNT @D45512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : EDGE, 
   [COORD @D45515, AGR [COUNT @D45514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : EDGE, 
   [COORD @D45519, AGR [COUNT @D45518, PER @D45517, PLU @D45516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : EDGE, 
   [COORD @D45525, PAST @D45524, AGR [CASE @D45523, COUNT @D45522, 
            PER @D45521, PLU @D45520, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : EDGE, 
   [COORD @D45528, AGR [COUNT @D45527, PER @D45526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : EDGE, 
   [COORD @D45530, AGR [COUNT @D45529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : EDGE, 
   [COORD @D45532, AGR [COUNT @D45531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : EDGE, 
   [COORD @D45536, AGR [COUNT @D45535, PER @D45534, PLU @D45533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : EDGE, 
   [COORD @D45542, PAST @D45541, 
      AGR [CASE @D45540, COUNT @D45539, PER @D45538, PLU @D45537, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : EDGE, 
   [COORD @D45545, AGR [COUNT @D45544, PER @D45543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : EDGE, 
   [COORD @D45547, AGR [COUNT @D45546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : EDGE, 
   [COORD @D45549, AGR [COUNT @D45548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : EDGE, 
   [COORD @D45553, AGR [COUNT @D45552, PER @D45551, PLU @D45550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : EDGE, 
   [COORD @D45559, PAST @D45558, 
      AGR [CASE @D45557, COUNT @D45556, PER @D45555, PLU @D45554, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : EDGE.

WORD edged : 
   [COORD @D45569, AGR [CASE @D45568, COUNT @D45567, PER @D45566, 
            PLU @D45565, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EDGE, 
   [COORD @D45574, AGR [CASE @D45573, COUNT @D45572, PER @D45571, 
            PLU @D45570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45579, AGR [CASE @D45578, COUNT @D45577, PER @D45576, 
            PLU @D45575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45584, AGR [CASE @D45583, COUNT @D45582, PER @D45581, 
            PLU @D45580, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45589, AGR [CASE @D45588, COUNT @D45587, PER @D45586, 
            PLU @D45585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45594, AGR [CASE @D45593, COUNT @D45592, PER @D45591, 
            PLU @D45590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45599, AGR [CASE @D45598, COUNT @D45597, PER @D45596, 
            PLU @D45595, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EDGE, 
   [COORD @D45604, AGR [CASE @D45603, COUNT @D45602, PER @D45601, 
            PLU @D45600, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45609, AGR [CASE @D45608, COUNT @D45607, PER @D45606, 
            PLU @D45605, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45614, AGR [CASE @D45613, COUNT @D45612, PER @D45611, 
            PLU @D45610, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45619, AGR [CASE @D45618, COUNT @D45617, PER @D45616, 
            PLU @D45615, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45624, AGR [CASE @D45623, COUNT @D45622, PER @D45621, 
            PLU @D45620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45629, AGR [CASE @D45628, COUNT @D45627, PER @D45626, 
            PLU @D45625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45634, AGR [CASE @D45633, COUNT @D45632, PER @D45631, 
            PLU @D45630, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45639, AGR [CASE @D45638, COUNT @D45637, PER @D45636, 
            PLU @D45635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45644, AGR [CASE @D45643, COUNT @D45642, PER @D45641, 
            PLU @D45640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EDGE.

WORD edges : 
   [COORD @D45651, AGR [COUNT @D45650, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EDGE, 
   [COORD @D45653, 
      AGR [COUNT @D45652, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   EDGE, 
   [COORD @D45655, AGR [COUNT @D45654, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EDGE, 
   [COORD @D45657, 
      AGR [COUNT @D45656, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EDGE, 
   [COORD @D45659, 
      AGR [COUNT @D45658, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EDGE, 
   [COORD @D45661, 
      AGR [COUNT @D45660, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EDGE.

WORD edging : 
   [COORD @D45670, REFL @D45669, COUNT @D45668, PRD @D45667, CASE 
         @D45666, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : EDGING, 
   [COORD @D45676, PRD @D45675, 
      AGR [CASE @D45674, COUNT @D45673, PER @D45672, PLU @D45671, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EDGE, 
   [COORD @D45682, PRD @D45681, AGR [CASE @D45680, COUNT @D45679, 
            PER @D45678, PLU @D45677, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45688, PRD @D45687, 
      AGR [CASE @D45686, COUNT @D45685, PER @D45684, PLU @D45683, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EDGE, 
   [COORD @D45694, PRD @D45693, AGR [CASE @D45692, COUNT @D45691, 
            PER @D45690, PLU @D45689, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EDGE, 
   [COORD @D45700, PRD @D45699, 
      AGR [CASE @D45698, COUNT @D45697, PER @D45696, PLU @D45695, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : EDGE, 
   [COORD @D45706, PRD @D45705, AGR [CASE @D45704, COUNT @D45703, 
            PER @D45702, PLU @D45701, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EDGE.

WORD edgings : 
   [COORD @D45717, DEMON @D45716, REFL @D45715, PRD @D45714, 
      CASE @D45713, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : EDGING.

WORD emerge : 
   [COORD @D45723, AGR [COUNT @D45722, PER @D45721, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : EMERGE, 
   [COORD @D45725, AGR [COUNT @D45724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : EMERGE, 
   [COORD @D45727, AGR [COUNT @D45726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : EMERGE, 
   [COORD @D45731, AGR [COUNT @D45730, PER @D45729, PLU @D45728, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OUT_OF, ARITY 2] : EMERGE, 
   [COORD @D45737, PAST @D45736, 
      AGR [CASE @D45735, COUNT @D45734, PER @D45733, PLU @D45732, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OUT_OF, 
      ARITY 2] : EMERGE, 
   [COORD @D45740, AGR [COUNT @D45739, PER @D45738, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : EMERGE, 
   [COORD @D45742, AGR [COUNT @D45741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : EMERGE, 
   [COORD @D45744, AGR [COUNT @D45743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : EMERGE, 
   [COORD @D45748, AGR [COUNT @D45747, PER @D45746, PLU @D45745, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : EMERGE, 
   [COORD @D45754, PAST @D45753, 
      AGR [CASE @D45752, COUNT @D45751, PER @D45750, PLU @D45749, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, 
      ARITY 2] : EMERGE, 
   [COORD @D45757, AGR [COUNT @D45756, PER @D45755, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EMERGE, 
   [COORD @D45759, AGR [COUNT @D45758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EMERGE, 
   [COORD @D45761, AGR [COUNT @D45760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EMERGE, 
   [COORD @D45765, AGR [COUNT @D45764, PER @D45763, PLU @D45762, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EMERGE, 
   [COORD @D45771, PAST @D45770, AGR [CASE @D45769, COUNT @D45768, 
            PER @D45767, PLU @D45766, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : EMERGE.

WORD emerged : 
   [COORD @D45780, AGR [CASE @D45779, COUNT @D45778, PER @D45777, 
            PLU @D45776, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45785, AGR [CASE @D45784, COUNT @D45783, PER @D45782, 
            PLU @D45781, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45790, AGR [CASE @D45789, COUNT @D45788, PER @D45787, 
            PLU @D45786, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45795, AGR [CASE @D45794, COUNT @D45793, PER @D45792, 
            PLU @D45791, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45800, AGR [CASE @D45799, COUNT @D45798, PER @D45797, 
            PLU @D45796, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45805, AGR [CASE @D45804, COUNT @D45803, PER @D45802, 
            PLU @D45801, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EMERGE.

WORD emerges : 
   [COORD @D45811, AGR [COUNT @D45810, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45813, 
      AGR [COUNT @D45812, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45815, 
      AGR [COUNT @D45814, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EMERGE.

WORD emerging : 
   [COORD @D45824, PRD @D45823, AGR [CASE @D45822, COUNT @D45821, 
            PER @D45820, PLU @D45819, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : EMERGE, 
   [COORD @D45830, PRD @D45829, 
      AGR [CASE @D45828, COUNT @D45827, PER @D45826, PLU @D45825, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : EMERGE, 
   [COORD @D45836, PRD @D45835, AGR [CASE @D45834, COUNT @D45833, 
            PER @D45832, PLU @D45831, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EMERGE.

WORD employ : 
   [COORD @D45841, AGR [COUNT @D45840, PER @D45839, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : EMPLOY, 
   [COORD @D45843, AGR [COUNT @D45842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : EMPLOY, 
   [COORD @D45845, AGR [COUNT @D45844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : EMPLOY, 
   [COORD @D45849, AGR [COUNT @D45848, PER @D45847, PLU @D45846, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : EMPLOY, 
   [COORD @D45855, PAST @D45854, AGR [CASE @D45853, COUNT @D45852, 
            PER @D45851, PLU @D45850, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : EMPLOY, 
   [COORD @D45858, AGR [COUNT @D45857, PER @D45856, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : EMPLOY, 
   [COORD @D45860, AGR [COUNT @D45859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : EMPLOY, 
   [COORD @D45862, AGR [COUNT @D45861, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : EMPLOY, 
   [COORD @D45866, AGR [COUNT @D45865, PER @D45864, PLU @D45863, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : EMPLOY, 
   [COORD @D45872, PAST @D45871, 
      AGR [CASE @D45870, COUNT @D45869, PER @D45868, PLU @D45867, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : EMPLOY, 
   [COORD @D45875, AGR [COUNT @D45874, PER @D45873, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : EMPLOY, 
   [COORD @D45877, AGR [COUNT @D45876, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : EMPLOY, 
   [COORD @D45879, AGR [COUNT @D45878, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : EMPLOY, 
   [COORD @D45883, AGR [COUNT @D45882, PER @D45881, PLU @D45880, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : EMPLOY, 
   [COORD @D45889, PAST @D45888, 
      AGR [CASE @D45887, COUNT @D45886, PER @D45885, PLU @D45884, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : EMPLOY, 
   [COORD @D45892, AGR [COUNT @D45891, PER @D45890, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, ARITY 3] : EMPLOY, 
   [COORD @D45894, 
      AGR [COUNT @D45893, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM IN, ORDER POSTNP, ARITY 3] : EMPLOY, 
   [COORD @D45896, AGR [COUNT @D45895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, ARITY 3] : EMPLOY, 
   [COORD @D45900, 
      AGR [COUNT @D45899, PER @D45898, PLU @D45897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, ARITY 3] : EMPLOY, 
   [COORD @D45906, PAST @D45905, 
      AGR [CASE @D45904, COUNT @D45903, PER @D45902, PLU @D45901, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM IN, ORDER POSTNP, ARITY 3] : EMPLOY, 
   [COORD @D45909, AGR [COUNT @D45908, PER @D45907, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EMPLOY, 
   [COORD @D45911, AGR [COUNT @D45910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EMPLOY, 
   [COORD @D45913, AGR [COUNT @D45912, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EMPLOY, 
   [COORD @D45917, AGR [COUNT @D45916, PER @D45915, PLU @D45914, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EMPLOY, 
   [COORD @D45923, PAST @D45922, AGR [CASE @D45921, COUNT @D45920, 
            PER @D45919, PLU @D45918, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EMPLOY.

WORD employed : 
   [COORD @D45931, AGR [CASE @D45930, COUNT @D45929, PER @D45928, 
            PLU @D45927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45936, AGR [CASE @D45935, COUNT @D45934, PER @D45933, 
            PLU @D45932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45942, AGR [CASE @D45941, NFORM @D45940, COUNT @D45939, 
            PER @D45938, PLU @D45937, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45947, AGR [CASE @D45946, COUNT @D45945, PER @D45944, 
            PLU @D45943, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45952, AGR [CASE @D45951, COUNT @D45950, PER @D45949, 
            PLU @D45948, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45957, AGR [CASE @D45956, COUNT @D45955, PER @D45954, 
            PLU @D45953, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45962, AGR [CASE @D45961, COUNT @D45960, PER @D45959, 
            PLU @D45958, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45967, AGR [CASE @D45966, COUNT @D45965, PER @D45964, 
            PLU @D45963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45972, AGR [CASE @D45971, COUNT @D45970, PER @D45969, 
            PLU @D45968, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45977, AGR [CASE @D45976, COUNT @D45975, PER @D45974, 
            PLU @D45973, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM IN, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45982, 
      AGR [CASE @D45981, COUNT @D45980, PER @D45979, PLU @D45978, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45987, AGR [CASE @D45986, COUNT @D45985, PER @D45984, 
            PLU @D45983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45992, 
      AGR [CASE @D45991, COUNT @D45990, PER @D45989, PLU @D45988, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D45997, 
      AGR [CASE @D45996, COUNT @D45995, PER @D45994, PLU @D45993, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : EMPLOY, 
   [COORD @D46002, AGR [CASE @D46001, COUNT @D46000, PER @D45999, 
            PLU @D45998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EMPLOY.

WORD employing : 
   [COORD @D46013, PRD @D46012, AGR [CASE @D46011, COUNT @D46010, 
            PER @D46009, PLU @D46008, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D46019, PRD @D46018, 
      AGR [CASE @D46017, COUNT @D46016, PER @D46015, PLU @D46014, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : EMPLOY, 
   [COORD @D46025, PRD @D46024, AGR [CASE @D46023, COUNT @D46022, 
            PER @D46021, PLU @D46020, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D46031, PRD @D46030, 
      AGR [CASE @D46029, COUNT @D46028, PER @D46027, PLU @D46026, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D46037, PRD @D46036, 
      AGR [CASE @D46035, COUNT @D46034, PER @D46033, PLU @D46032, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EMPLOY.

WORD employs : 
   [COORD @D46042, AGR [COUNT @D46041, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D46044, 
      AGR [COUNT @D46043, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D46046, 
      AGR [COUNT @D46045, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EMPLOY, 
   [COORD @D46048, 
      AGR [COUNT @D46047, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : EMPLOY, 
   [COORD @D46050, AGR [COUNT @D46049, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EMPLOY.

WORD end : 
   [COORD @D46057, REFL @D46056, COUNT @D46055, PRD @D46054, CASE 
         @D46053, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : END, 
   [COORD @D46061, REFL @D46060, PRD @D46059, CASE @D46058, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : END, 
   [COORD @D46064, 
      AGR [COUNT @D46063, PER @D46062, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ARITY 3] : END, 
   [COORD @D46066, AGR [COUNT @D46065, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ARITY 3] : END, 
   [COORD @D46068, AGR [COUNT @D46067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ARITY 3] : END, 
   [COORD @D46072, AGR [COUNT @D46071, PER @D46070, PLU @D46069, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ARITY 3] : END, 
   [COORD @D46078, PAST @D46077, 
      AGR [CASE @D46076, COUNT @D46075, PER @D46074, PLU @D46073, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM IN, ARITY 3] : END, 
   [COORD @D46081, AGR [COUNT @D46080, PER @D46079, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM WITH, ARITY 3] : END, 
   [COORD @D46083, AGR 
         [COUNT @D46082, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM WITH, ARITY 3] : END, 
   [COORD @D46085, AGR [COUNT @D46084, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM WITH, ARITY 3] : END, 
   [COORD @D46089, AGR 
         [COUNT @D46088, PER @D46087, PLU @D46086, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM WITH, ARITY 3] : END, 
   [COORD @D46095, PAST @D46094, 
      AGR [CASE @D46093, COUNT @D46092, PER @D46091, PLU @D46090, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM WITH, ARITY 3] : END, 
   [COORD @D46098, AGR [COUNT @D46097, PER @D46096, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM BY, ARITY 3] : END, 
   [COORD @D46100, AGR [COUNT @D46099, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM BY, ARITY 3] : END, 
   [COORD @D46102, AGR [COUNT @D46101, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM BY, ARITY 3] : END, 
   [COORD @D46106, AGR [COUNT @D46105, PER @D46104, PLU @D46103, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM BY, ARITY 3] : END, 
   [COORD @D46112, PAST @D46111, 
      AGR [CASE @D46110, COUNT @D46109, PER @D46108, PLU @D46107, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM BY, ARITY 3] : END, 
   [COORD @D46115, AGR [COUNT @D46114, PER @D46113, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : END, 
   [COORD @D46117, AGR [COUNT @D46116, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : END, 
   [COORD @D46119, AGR [COUNT @D46118, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : END, 
   [COORD @D46123, AGR [COUNT @D46122, PER @D46121, PLU @D46120, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : END, 
   [COORD @D46129, PAST @D46128, AGR [CASE @D46127, COUNT @D46126, 
            PER @D46125, PLU @D46124, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : END, 
   [COORD @D46132, AGR [COUNT @D46131, PER @D46130, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT UP, ARITY 2] : END, 
   [COORD @D46134, AGR [COUNT @D46133, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT UP, ARITY 2] : END, 
   [COORD @D46136, AGR [COUNT @D46135, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT UP, ARITY 2] : END, 
   [COORD @D46140, AGR [COUNT @D46139, PER @D46138, PLU @D46137, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT UP, ARITY 2] : END, 
   [COORD @D46146, PAST @D46145, 
      AGR [CASE @D46144, COUNT @D46143, PER @D46142, PLU @D46141, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, 
      PRT UP, ARITY 2] : END, 
   [COORD @D46149, AGR [COUNT @D46148, PER @D46147, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT UP, ARITY 2] : END, 
   [COORD @D46151, AGR [COUNT @D46150, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT UP, ARITY 2] : END, 
   [COORD @D46153, AGR [COUNT @D46152, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT UP, ARITY 2] : END, 
   [COORD @D46157, AGR [COUNT @D46156, PER @D46155, PLU @D46154, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT UP, ARITY 2] : END, 
   [COORD @D46163, PAST @D46162, 
      AGR [CASE @D46161, COUNT @D46160, PER @D46159, PLU @D46158, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PRT UP, ARITY 2] : END, 
   [COORD @D46166, AGR [COUNT @D46165, PER @D46164, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT UP, ARITY 2] : END, 
   [COORD @D46168, AGR [COUNT @D46167, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT UP, ARITY 2] : END, 
   [COORD @D46170, AGR [COUNT @D46169, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT UP, ARITY 2] : END, 
   [COORD @D46174, AGR [COUNT @D46173, PER @D46172, PLU @D46171, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT UP, ARITY 2] : END, 
   [COORD @D46180, PAST @D46179, 
      AGR [CASE @D46178, COUNT @D46177, PER @D46176, PLU @D46175, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      PRT UP, ARITY 2] : END, 
   [COORD @D46183, AGR [COUNT @D46182, PER @D46181, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT UP, ARITY 2] : END, 
   [COORD @D46185, AGR [COUNT @D46184, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT UP, ARITY 2] : END, 
   [COORD @D46187, AGR [COUNT @D46186, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT UP, ARITY 2] : END, 
   [COORD @D46191, AGR [COUNT @D46190, PER @D46189, PLU @D46188, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, PRT UP, ARITY 2] : END, 
   [COORD @D46197, PAST @D46196, AGR 
         [CASE @D46195, COUNT @D46194, PER @D46193, PLU @D46192, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, PRT UP, 
      ARITY 2] : END, 
   [COORD @D46200, AGR [COUNT @D46199, PER @D46198, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : END, 
   [COORD @D46202, AGR [COUNT @D46201, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : END, 
   [COORD @D46204, AGR [COUNT @D46203, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : END, 
   [COORD @D46208, AGR [COUNT @D46207, PER @D46206, PLU @D46205, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : END, 
   [COORD @D46214, PAST @D46213, 
      AGR [CASE @D46212, COUNT @D46211, PER @D46210, PLU @D46209, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      ARITY 2] : END, 
   [COORD @D46217, AGR [COUNT @D46216, PER @D46215, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : END, 
   [COORD @D46219, AGR [COUNT @D46218, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : END, 
   [COORD @D46221, AGR [COUNT @D46220, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : END, 
   [COORD @D46225, AGR [COUNT @D46224, PER @D46223, PLU @D46222, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : END, 
   [COORD @D46231, PAST @D46230, 
      AGR [CASE @D46229, COUNT @D46228, PER @D46227, PLU @D46226, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : END, 
   [COORD @D46234, AGR [COUNT @D46233, PER @D46232, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : END, 
   [COORD @D46236, AGR [COUNT @D46235, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : END, 
   [COORD @D46238, AGR [COUNT @D46237, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : END, 
   [COORD @D46242, AGR [COUNT @D46241, PER @D46240, PLU @D46239, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : END, 
   [COORD @D46248, PAST @D46247, AGR [CASE @D46246, COUNT @D46245, 
            PER @D46244, PLU @D46243, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : END, 
   [COORD @D46251, AGR [COUNT @D46250, PER @D46249, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : END, 
   [COORD @D46253, AGR [COUNT @D46252, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : END, 
   [COORD @D46255, AGR [COUNT @D46254, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : END, 
   [COORD @D46259, AGR [COUNT @D46258, PER @D46257, PLU @D46256, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : END, 
   [COORD @D46265, PAST @D46264, 
      AGR [CASE @D46263, COUNT @D46262, PER @D46261, PLU @D46260, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : END.

WORD ended : 
   [COORD @D46274, AGR [CASE @D46273, COUNT @D46272, PER @D46271, 
            PLU @D46270, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM IN, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46279, AGR [CASE @D46278, COUNT @D46277, PER @D46276, 
            PLU @D46275, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46284, 
      AGR [CASE @D46283, COUNT @D46282, PER @D46281, PLU @D46280, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46289, AGR [CASE @D46288, COUNT @D46287, PER @D46286, 
            PLU @D46285, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46294, AGR [CASE @D46293, COUNT @D46292, PER @D46291, 
            PLU @D46290, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46299, 
      AGR [CASE @D46298, COUNT @D46297, PER @D46296, PLU @D46295, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46304, AGR [CASE @D46303, COUNT @D46302, PER @D46301, 
            PLU @D46300, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM BY, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46309, AGR [CASE @D46308, COUNT @D46307, PER @D46306, 
            PLU @D46305, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46314, 
      AGR [CASE @D46313, COUNT @D46312, PER @D46311, PLU @D46310, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46319, AGR [CASE @D46318, COUNT @D46317, PER @D46316, 
            PLU @D46315, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : END, 
   [COORD @D46324, AGR [CASE @D46323, COUNT @D46322, PER @D46321, 
            PLU @D46320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46329, AGR [CASE @D46328, COUNT @D46327, PER @D46326, 
            PLU @D46325, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46334, AGR [CASE @D46333, COUNT @D46332, PER @D46331, 
            PLU @D46330, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46339, AGR [CASE @D46338, COUNT @D46337, PER @D46336, 
            PLU @D46335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46344, AGR [CASE @D46343, COUNT @D46342, PER @D46341, 
            PLU @D46340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46349, AGR [CASE @D46348, COUNT @D46347, PER @D46346, 
            PLU @D46345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46354, AGR [CASE @D46353, COUNT @D46352, PER @D46351, 
            PLU @D46350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46359, AGR [CASE @D46358, COUNT @D46357, PER @D46356, 
            PLU @D46355, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46364, AGR [CASE @D46363, COUNT @D46362, PER @D46361, 
            PLU @D46360, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46369, AGR [CASE @D46368, COUNT @D46367, PER @D46366, 
            PLU @D46365, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46374, AGR [CASE @D46373, COUNT @D46372, PER @D46371, 
            PLU @D46370, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46379, AGR [CASE @D46378, COUNT @D46377, PER @D46376, 
            PLU @D46375, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46384, AGR [CASE @D46383, COUNT @D46382, PER @D46381, 
            PLU @D46380, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46389, AGR [CASE @D46388, COUNT @D46387, PER @D46386, 
            PLU @D46385, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46394, AGR [CASE @D46393, COUNT @D46392, PER @D46391, 
            PLU @D46390, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46399, AGR [CASE @D46398, COUNT @D46397, PER @D46396, 
            PLU @D46395, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46404, AGR [CASE @D46403, COUNT @D46402, PER @D46401, 
            PLU @D46400, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : END, 
   [COORD @D46409, AGR [CASE @D46408, COUNT @D46407, PER @D46406, 
            PLU @D46405, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46414, AGR [CASE @D46413, COUNT @D46412, PER @D46411, 
            PLU @D46410, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : END.

WORD ending : 
   [COORD @D46426, REFL @D46425, PRD @D46424, CASE @D46423, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : ENDING, 
   [COORD @D46432, PRD @D46431, 
      AGR [CASE @D46430, COUNT @D46429, PER @D46428, PLU @D46427, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : END, 
   [COORD @D46438, PRD @D46437, AGR [CASE @D46436, COUNT @D46435, 
            PER @D46434, PLU @D46433, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46444, PRD @D46443, 
      AGR [CASE @D46442, COUNT @D46441, PER @D46440, PLU @D46439, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : END, 
   [COORD @D46450, PRD @D46449, AGR [CASE @D46448, COUNT @D46447, 
            PER @D46446, PLU @D46445, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46456, PRD @D46455, AGR 
         [CASE @D46454, COUNT @D46453, PER @D46452, PLU @D46451, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : END, 
   [COORD @D46462, PRD @D46461, AGR [CASE @D46460, COUNT @D46459, 
            PER @D46458, PLU @D46457, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46468, PRD @D46467, 
      AGR [CASE @D46466, COUNT @D46465, PER @D46464, PLU @D46463, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : END, 
   [COORD @D46474, PRD @D46473, AGR [CASE @D46472, COUNT @D46471, 
            PER @D46470, PLU @D46469, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46480, PRD @D46479, 
      AGR [CASE @D46478, COUNT @D46477, PER @D46476, PLU @D46475, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : END, 
   [COORD @D46486, PRD @D46485, AGR [CASE @D46484, COUNT @D46483, 
            PER @D46482, PLU @D46481, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   [COORD @D46492, PRD @D46491, 
      AGR [CASE @D46490, COUNT @D46489, PER @D46488, PLU @D46487, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : END, 
   
   [COORD @D46498, PRD @D46497, AGR [CASE @D46496, COUNT @D46495, PER 
               @D46494, PLU @D46493, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : END.

WORD endings : 
   [COORD @D46514, DEMON @D46513, REFL @D46512, PRD @D46511, 
      CASE @D46510, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ENDING.

WORD ends : 
   [COORD @D46523, DEMON @D46522, REFL @D46521, PRD @D46520, CASE 
         @D46519, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : END, 
   [COORD @D46528, DEMON @D46527, REFL @D46526, PRD @D46525, 
      CASE @D46524, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   END, 
   [COORD @D46530, AGR [COUNT @D46529, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : END, 
   [COORD @D46532, AGR [COUNT @D46531, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : END, 
   [COORD @D46534, AGR [COUNT @D46533, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM BY, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : END, 
   [COORD @D46536, AGR [COUNT @D46535, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46538, 
      AGR [COUNT @D46537, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_NP, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46540, 
      AGR [COUNT @D46539, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46542, 
      AGR [COUNT @D46541, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46544, 
      AGR [COUNT @D46543, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46546, 
      AGR [COUNT @D46545, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46548, 
      AGR [COUNT @D46547, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46550, 
      AGR [COUNT @D46549, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END, 
   [COORD @D46552, 
      AGR [COUNT @D46551, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : END.

WORD engage : 
   [COORD @D46558, AGR [COUNT @D46557, PER @D46556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENGAGE, 
   [COORD @D46560, AGR [COUNT @D46559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENGAGE, 
   [COORD @D46562, AGR [COUNT @D46561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENGAGE, 
   [COORD @D46566, AGR [COUNT @D46565, PER @D46564, PLU @D46563, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENGAGE, 
   [COORD @D46572, PAST @D46571, AGR [CASE @D46570, COUNT @D46569, 
            PER @D46568, PLU @D46567, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : ENGAGE, 
   [COORD @D46575, AGR [COUNT @D46574, PER @D46573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENGAGE, 
   [COORD @D46577, AGR [COUNT @D46576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENGAGE, 
   [COORD @D46579, AGR [COUNT @D46578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENGAGE, 
   [COORD @D46583, AGR [COUNT @D46582, PER @D46581, PLU @D46580, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENGAGE, 
   [COORD @D46589, PAST @D46588, 
      AGR [CASE @D46587, COUNT @D46586, PER @D46585, PLU @D46584, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : ENGAGE, 
   [COORD @D46592, AGR [COUNT @D46591, PER @D46590, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ENGAGE, 
   [COORD @D46594, AGR [COUNT @D46593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ENGAGE, 
   [COORD @D46596, AGR [COUNT @D46595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ENGAGE, 
   [COORD @D46600, AGR [COUNT @D46599, PER @D46598, PLU @D46597, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ENGAGE, 
   [COORD @D46606, PAST @D46605, 
      AGR [CASE @D46604, COUNT @D46603, PER @D46602, PLU @D46601, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : ENGAGE, 
   [COORD @D46609, AGR [COUNT @D46608, PER @D46607, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, ARITY 3] : ENGAGE, 
   [COORD @D46611, 
      AGR [COUNT @D46610, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM IN, ORDER POSTNP, ARITY 3] : ENGAGE, 
   [COORD @D46613, AGR [COUNT @D46612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, ARITY 3] : ENGAGE, 
   [COORD @D46617, 
      AGR [COUNT @D46616, PER @D46615, PLU @D46614, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, ARITY 3] : ENGAGE, 
   [COORD @D46623, PAST @D46622, 
      AGR [CASE @D46621, COUNT @D46620, PER @D46619, PLU @D46618, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM IN, ORDER POSTNP, ARITY 3] : ENGAGE, 
   [COORD @D46626, AGR [COUNT @D46625, PER @D46624, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46628, AGR [COUNT @D46627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46630, AGR [COUNT @D46629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46634, AGR [COUNT @D46633, PER @D46632, PLU @D46631, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46640, PAST @D46639, AGR [CASE @D46638, COUNT @D46637, 
            PER @D46636, PLU @D46635, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46643, AGR [COUNT @D46642, PER @D46641, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46645, AGR [COUNT @D46644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46647, AGR [COUNT @D46646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46651, AGR [COUNT @D46650, PER @D46649, PLU @D46648, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46657, PAST @D46656, AGR [CASE @D46655, COUNT @D46654, 
            PER @D46653, PLU @D46652, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : ENGAGE, 
   [COORD @D46660, AGR [COUNT @D46659, PER @D46658, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENGAGE, 
   [COORD @D46662, AGR [COUNT @D46661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENGAGE, 
   [COORD @D46664, AGR [COUNT @D46663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENGAGE, 
   [COORD @D46668, AGR [COUNT @D46667, PER @D46666, PLU @D46665, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ENGAGE, 
   [COORD @D46674, PAST @D46673, AGR [CASE @D46672, COUNT @D46671, 
            PER @D46670, PLU @D46669, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ENGAGE, 
   [COORD @D46677, AGR [COUNT @D46676, PER @D46675, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : ENGAGE, 
   [COORD @D46679, AGR [COUNT @D46678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : ENGAGE, 
   [COORD @D46681, AGR [COUNT @D46680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : ENGAGE, 
   [COORD @D46685, AGR [COUNT @D46684, PER @D46683, PLU @D46682, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : ENGAGE, 
   [COORD @D46691, PAST @D46690, 
      AGR [CASE @D46689, COUNT @D46688, PER @D46687, PLU @D46686, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : ENGAGE, 
   [COORD @D46694, AGR [COUNT @D46693, PER @D46692, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : ENGAGE, 
   [COORD @D46696, AGR [COUNT @D46695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : ENGAGE, 
   [COORD @D46698, AGR [COUNT @D46697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : ENGAGE, 
   [COORD @D46702, AGR [COUNT @D46701, PER @D46700, PLU @D46699, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : ENGAGE, 
   [COORD @D46708, PAST @D46707, 
      AGR [CASE @D46706, COUNT @D46705, PER @D46704, PLU @D46703, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      ARITY 2] : ENGAGE, 
   [COORD @D46711, AGR [COUNT @D46710, PER @D46709, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : ENGAGE, 
   [COORD @D46713, AGR [COUNT @D46712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : ENGAGE, 
   [COORD @D46715, AGR [COUNT @D46714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : ENGAGE, 
   [COORD @D46719, AGR [COUNT @D46718, PER @D46717, PLU @D46716, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, ARITY 2] : ENGAGE, 
   [COORD @D46725, PAST @D46724, 
      AGR [CASE @D46723, COUNT @D46722, PER @D46721, PLU @D46720, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM IN, 
      ARITY 2] : ENGAGE, 
   [COORD @D46728, AGR [COUNT @D46727, PER @D46726, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ENGAGE, 
   [COORD @D46730, AGR [COUNT @D46729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ENGAGE, 
   [COORD @D46732, AGR [COUNT @D46731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ENGAGE, 
   [COORD @D46736, AGR [COUNT @D46735, PER @D46734, PLU @D46733, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : ENGAGE, 
   [COORD @D46742, PAST @D46741, 
      AGR [CASE @D46740, COUNT @D46739, PER @D46738, PLU @D46737, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : ENGAGE, 
   [COORD @D46745, AGR [COUNT @D46744, PER @D46743, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENGAGE, 
   [COORD @D46747, AGR [COUNT @D46746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENGAGE, 
   [COORD @D46749, AGR [COUNT @D46748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENGAGE, 
   [COORD @D46753, AGR [COUNT @D46752, PER @D46751, PLU @D46750, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENGAGE, 
   [COORD @D46759, PAST @D46758, AGR [CASE @D46757, COUNT @D46756, 
            PER @D46755, PLU @D46754, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ENGAGE.

WORD engaged : 
   [COADV @D46771, COORD @D46770, DEF @D46769, PRD @D46768, AGR 
            [CASE @D46767, COUNT @D46766, PER @D46765, PLU @D46764, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : ENGAGED, 
   [COADV @D46779, COORD @D46778, DEF @D46777, PRD @D46776, 
      AGR [CASE @D46775, COUNT @D46774, PER @D46773, PLU @D46772, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PRD] : ENGAGED, 
   [COADV @D46787, COORD @D46786, DEF @D46785, PRD @D46784, 
      AGR [CASE @D46783, COUNT @D46782, PER @D46781, PLU @D46780, BAR 2, 
            V -, N +, NFORM NORM], N +, V +, SUBCAT SINF, SUBTYPE NONE, 
      FIX NOT, INFL +, BAR 0, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, 
      NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR PRD, 
      ARITY 2] : ENGAGED, 
   [COADV @D46795, COORD @D46794, DEF @D46793, PRD @D46792, 
      AGR [CASE @D46791, COUNT @D46790, PER @D46789, PLU @D46788, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT SC_INF, 
      DISTR PRD, ARITY 2] : ENGAGED, 
   [COADV @D46803, COORD @D46802, DEF @D46801, PRD @D46800, 
      AGR [CASE @D46799, COUNT @D46798, PER @D46797, PLU @D46796, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      DISTR PRD, ARITY 2] : ENGAGED, 
   [COADV @D46811, COORD @D46810, DEF @D46809, PRD @D46808, 
      AGR [CASE @D46807, COUNT @D46806, PER @D46805, PLU @D46804, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      DISTR PRD, ARITY 2] : ENGAGED, 
   [COORD @D46817, AGR [CASE @D46816, NFORM @D46815, COUNT @D46814, 
            PER @D46813, PLU @D46812, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46822, AGR [CASE @D46821, COUNT @D46820, PER @D46819, 
            PLU @D46818, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46827, AGR [CASE @D46826, COUNT @D46825, PER @D46824, 
            PLU @D46823, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46832, AGR [CASE @D46831, COUNT @D46830, PER @D46829, 
            PLU @D46828, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM IN, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46837, AGR [CASE @D46836, COUNT @D46835, PER @D46834, 
            PLU @D46833, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM IN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46842, AGR [CASE @D46841, COUNT @D46840, PER @D46839, 
            PLU @D46838, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM IN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46847, AGR [CASE @D46846, COUNT @D46845, PER @D46844, 
            PLU @D46843, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46852, AGR [CASE @D46851, COUNT @D46850, PER @D46849, 
            PLU @D46848, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46857, AGR [CASE @D46856, COUNT @D46855, PER @D46854, 
            PLU @D46853, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46862, AGR [CASE @D46861, COUNT @D46860, PER @D46859, 
            PLU @D46858, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM IN, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46867, 
      AGR [CASE @D46866, COUNT @D46865, PER @D46864, PLU @D46863, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46872, AGR [CASE @D46871, COUNT @D46870, PER @D46869, 
            PLU @D46868, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46877, 
      AGR [CASE @D46876, COUNT @D46875, PER @D46874, PLU @D46873, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ENGAGE, 
   [COORD @D46882, AGR [CASE @D46881, COUNT @D46880, PER @D46879, 
            PLU @D46878, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46887, AGR [CASE @D46886, COUNT @D46885, PER @D46884, 
            PLU @D46883, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46892, AGR [CASE @D46891, COUNT @D46890, PER @D46889, 
            PLU @D46888, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46898, AGR [CASE @D46897, NFORM @D46896, COUNT @D46895, 
            PER @D46894, PLU @D46893, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46903, AGR [UB @D46902, VFORM @D46901, SUBJ @D46900, 
            FIN @D46899, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ENGAGE, 
   [COORD @D46908, AGR [CASE @D46907, COUNT @D46906, PER @D46905, 
            PLU @D46904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46913, AGR [CASE @D46912, COUNT @D46911, PER @D46910, 
            PLU @D46909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46918, AGR [CASE @D46917, COUNT @D46916, PER @D46915, 
            PLU @D46914, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46923, AGR [CASE @D46922, COUNT @D46921, PER @D46920, 
            PLU @D46919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46928, AGR [CASE @D46927, COUNT @D46926, PER @D46925, 
            PLU @D46924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46933, AGR [CASE @D46932, COUNT @D46931, PER @D46930, 
            PLU @D46929, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46938, AGR [CASE @D46937, COUNT @D46936, PER @D46935, 
            PLU @D46934, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46943, AGR [CASE @D46942, COUNT @D46941, PER @D46940, 
            PLU @D46939, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46948, AGR [CASE @D46947, COUNT @D46946, PER @D46945, 
            PLU @D46944, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46953, AGR [CASE @D46952, COUNT @D46951, PER @D46950, 
            PLU @D46949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46958, AGR [CASE @D46957, COUNT @D46956, PER @D46955, 
            PLU @D46954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46963, AGR [CASE @D46962, COUNT @D46961, PER @D46960, 
            PLU @D46959, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46968, AGR [CASE @D46967, COUNT @D46966, PER @D46965, 
            PLU @D46964, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46973, AGR [CASE @D46972, COUNT @D46971, PER @D46970, 
            PLU @D46969, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46978, AGR [CASE @D46977, COUNT @D46976, PER @D46975, 
            PLU @D46974, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46983, AGR [CASE @D46982, COUNT @D46981, PER @D46980, 
            PLU @D46979, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENGAGE.

WORD engages : 
   [COORD @D46989, AGR [COUNT @D46988, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46991, 
      AGR [COUNT @D46990, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46993, 
      AGR [COUNT @D46992, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46995, 
      AGR [COUNT @D46994, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : ENGAGE, 
   [COORD @D46997, AGR [COUNT @D46996, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D46999, 
      AGR [COUNT @D46998, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47001, 
      AGR [COUNT @D47000, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47003, 
      AGR [COUNT @D47002, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47005, 
      AGR [COUNT @D47004, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47007, 
      AGR [COUNT @D47006, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47009, 
      AGR [COUNT @D47008, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47011, 
      AGR [COUNT @D47010, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENGAGE.

WORD engaging : 
   [COORD @D47020, PRD @D47019, AGR [CASE @D47018, COUNT @D47017, 
            PER @D47016, PLU @D47015, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47026, PRD @D47025, 
      AGR [CASE @D47024, COUNT @D47023, PER @D47022, PLU @D47021, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ENGAGE, 
   [COORD @D47032, PRD @D47031, AGR [CASE @D47030, COUNT @D47029, 
            PER @D47028, PLU @D47027, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47038, PRD @D47037, 
      AGR [CASE @D47036, COUNT @D47035, PER @D47034, PLU @D47033, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM IN, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47044, PRD @D47043, 
      AGR [CASE @D47042, COUNT @D47041, PER @D47040, PLU @D47039, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ENGAGE, 
   [COORD @D47050, PRD @D47049, AGR [CASE @D47048, COUNT @D47047, 
            PER @D47046, PLU @D47045, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47056, PRD @D47055, 
      AGR [CASE @D47054, COUNT @D47053, PER @D47052, PLU @D47051, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ENGAGE, 
   [COORD @D47062, PRD @D47061, AGR [CASE @D47060, COUNT @D47059, 
            PER @D47058, PLU @D47057, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47068, PRD @D47067, 
      AGR [CASE @D47066, COUNT @D47065, PER @D47064, PLU @D47063, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ENGAGE, 
   [COORD @D47074, PRD @D47073, AGR [CASE @D47072, COUNT @D47071, 
            PER @D47070, PLU @D47069, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENGAGE, 
   [COORD @D47080, PRD @D47079, 
      AGR [CASE @D47078, COUNT @D47077, PER @D47076, PLU @D47075, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ENGAGE, 
   [COORD @D47086, PRD @D47085, AGR [CASE @D47084, COUNT @D47083, 
            PER @D47082, PLU @D47081, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENGAGE.

WORD enjoy : 
   [COORD @D47095, AGR [COUNT @D47094, PER @D47093, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : ENJOY, 
   [COORD @D47097, AGR [COUNT @D47096, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : ENJOY, 
   [COORD @D47099, AGR [COUNT @D47098, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : ENJOY, 
   [COORD @D47103, AGR [COUNT @D47102, PER @D47101, PLU @D47100, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : ENJOY, 
   [COORD @D47109, PAST @D47108, AGR [CASE @D47107, COUNT @D47106, 
            PER @D47105, PLU @D47104, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : ENJOY, 
   [COORD @D47112, AGR [COUNT @D47111, PER @D47110, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENJOY, 
   [COORD @D47114, AGR [COUNT @D47113, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENJOY, 
   [COORD @D47116, AGR [COUNT @D47115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENJOY, 
   [COORD @D47120, AGR [COUNT @D47119, PER @D47118, PLU @D47117, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ENJOY, 
   [COORD @D47126, PAST @D47125, AGR [CASE @D47124, COUNT @D47123, 
            PER @D47122, PLU @D47121, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ENJOY, 
   [COORD @D47129, AGR [COUNT @D47128, PER @D47127, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENJOY, 
   [COORD @D47131, AGR [COUNT @D47130, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENJOY, 
   [COORD @D47133, AGR [COUNT @D47132, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENJOY, 
   [COORD @D47137, AGR [COUNT @D47136, PER @D47135, PLU @D47134, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENJOY, 
   [COORD @D47143, PAST @D47142, AGR [CASE @D47141, COUNT @D47140, 
            PER @D47139, PLU @D47138, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ENJOY.

WORD enjoyed : 
   [COORD @D47151, AGR [CASE @D47150, COUNT @D47149, PER @D47148, 
            PLU @D47147, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47156, AGR [CASE @D47155, COUNT @D47154, PER @D47153, 
            PLU @D47152, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47161, AGR [CASE @D47160, COUNT @D47159, PER @D47158, 
            PLU @D47157, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47166, AGR [CASE @D47165, COUNT @D47164, PER @D47163, 
            PLU @D47162, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47171, AGR [CASE @D47170, COUNT @D47169, PER @D47168, 
            PLU @D47167, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ENJOY, 
   [COORD @D47176, AGR [CASE @D47175, COUNT @D47174, PER @D47173, 
            PLU @D47172, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47181, AGR [CASE @D47180, COUNT @D47179, PER @D47178, 
            PLU @D47177, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENJOY.

WORD enjoying : 
   [COORD @D47192, PRD @D47191, AGR [CASE @D47190, COUNT @D47189, 
            PER @D47188, PLU @D47187, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47198, PRD @D47197, 
      AGR [CASE @D47196, COUNT @D47195, PER @D47194, PLU @D47193, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ENJOY, 
   [COORD @D47204, PRD @D47203, AGR [CASE @D47202, COUNT @D47201, 
            PER @D47200, PLU @D47199, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENJOY.

WORD enjoys : 
   [COORD @D47209, AGR [COUNT @D47208, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47211, 
      AGR [COUNT @D47210, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENJOY, 
   [COORD @D47213, 
      AGR [COUNT @D47212, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENJOY.

WORD enter : 
   [COORD @D47218, AGR [COUNT @D47217, PER @D47216, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM INTO_WITH, ARITY 3] : ENTER, 
   [COORD @D47220, AGR [COUNT @D47219, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM INTO_WITH, ARITY 3] : ENTER, 
   [COORD @D47222, AGR [COUNT @D47221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM INTO_WITH, ARITY 3] : ENTER, 
   [COORD @D47226, AGR [COUNT @D47225, PER @D47224, PLU @D47223, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM INTO_WITH, ARITY 3] : ENTER, 
   [COORD @D47232, PAST @D47231, 
      AGR [CASE @D47230, COUNT @D47229, PER @D47228, PLU @D47227, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM INTO_WITH, ARITY 3] : ENTER, 
   [COORD @D47235, AGR [COUNT @D47234, PER @D47233, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENTER, 
   [COORD @D47237, AGR [COUNT @D47236, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENTER, 
   [COORD @D47239, AGR [COUNT @D47238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENTER, 
   [COORD @D47243, AGR [COUNT @D47242, PER @D47241, PLU @D47240, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ENTER, 
   [COORD @D47249, PAST @D47248, 
      AGR [CASE @D47247, COUNT @D47246, PER @D47245, PLU @D47244, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : ENTER, 
   [COORD @D47252, AGR [COUNT @D47251, PER @D47250, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ENTER, 
   [COORD @D47254, AGR [COUNT @D47253, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ENTER, 
   [COORD @D47256, AGR [COUNT @D47255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ENTER, 
   [COORD @D47260, AGR [COUNT @D47259, PER @D47258, PLU @D47257, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ENTER, 
   [COORD @D47266, PAST @D47265, 
      AGR [CASE @D47264, COUNT @D47263, PER @D47262, PLU @D47261, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : ENTER, 
   [COORD @D47269, AGR [COUNT @D47268, PER @D47267, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENTER, 
   [COORD @D47271, AGR [COUNT @D47270, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENTER, 
   [COORD @D47273, AGR [COUNT @D47272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ENTER, 
   [COORD @D47277, AGR [COUNT @D47276, PER @D47275, PLU @D47274, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ENTER, 
   [COORD @D47283, PAST @D47282, AGR [CASE @D47281, COUNT @D47280, 
            PER @D47279, PLU @D47278, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ENTER, 
   [COORD @D47286, AGR [COUNT @D47285, PER @D47284, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : ENTER, 
   [COORD @D47288, AGR [COUNT @D47287, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : ENTER, 
   [COORD @D47290, AGR [COUNT @D47289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : ENTER, 
   [COORD @D47294, AGR [COUNT @D47293, PER @D47292, PLU @D47291, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : ENTER, 
   [COORD @D47300, PAST @D47299, 
      AGR [CASE @D47298, COUNT @D47297, PER @D47296, PLU @D47295, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : ENTER, 
   [COORD @D47303, AGR [COUNT @D47302, PER @D47301, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : ENTER, 
   [COORD @D47305, AGR [COUNT @D47304, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : ENTER, 
   [COORD @D47307, AGR [COUNT @D47306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : ENTER, 
   [COORD @D47311, AGR [COUNT @D47310, PER @D47309, PLU @D47308, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, ARITY 2] : ENTER, 
   [COORD @D47317, PAST @D47316, 
      AGR [CASE @D47315, COUNT @D47314, PER @D47313, PLU @D47312, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      ARITY 2] : ENTER, 
   [COORD @D47320, AGR [COUNT @D47319, PER @D47318, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ENTER, 
   [COORD @D47322, AGR [COUNT @D47321, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ENTER, 
   [COORD @D47324, AGR [COUNT @D47323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ENTER, 
   [COORD @D47328, AGR [COUNT @D47327, PER @D47326, PLU @D47325, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : ENTER, 
   [COORD @D47334, PAST @D47333, 
      AGR [CASE @D47332, COUNT @D47331, PER @D47330, PLU @D47329, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : ENTER, 
   [COORD @D47337, AGR [COUNT @D47336, PER @D47335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : ENTER, 
   [COORD @D47339, AGR [COUNT @D47338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : ENTER, 
   [COORD @D47341, AGR [COUNT @D47340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : ENTER, 
   [COORD @D47345, AGR [COUNT @D47344, PER @D47343, PLU @D47342, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : ENTER, 
   [COORD @D47351, PAST @D47350, 
      AGR [CASE @D47349, COUNT @D47348, PER @D47347, PLU @D47346, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : ENTER, 
   [COORD @D47354, AGR [COUNT @D47353, PER @D47352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENTER, 
   [COORD @D47356, AGR [COUNT @D47355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENTER, 
   [COORD @D47358, AGR [COUNT @D47357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENTER, 
   [COORD @D47362, AGR [COUNT @D47361, PER @D47360, PLU @D47359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ENTER, 
   [COORD @D47368, PAST @D47367, AGR [CASE @D47366, COUNT @D47365, 
            PER @D47364, PLU @D47363, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ENTER, 
   [COORD @D47371, AGR [COUNT @D47370, PER @D47369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ENTER, 
   [COORD @D47373, AGR [COUNT @D47372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ENTER, 
   [COORD @D47375, AGR [COUNT @D47374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ENTER, 
   [COORD @D47379, AGR [COUNT @D47378, PER @D47377, PLU @D47376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ENTER, 
   [COORD @D47385, PAST @D47384, 
      AGR [CASE @D47383, COUNT @D47382, PER @D47381, PLU @D47380, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : ENTER.

WORD entered : 
   [COORD @D47393, AGR [CASE @D47392, COUNT @D47391, PER @D47390, 
            PLU @D47389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM INTO_WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47398, 
      AGR [CASE @D47397, COUNT @D47396, PER @D47395, PLU @D47394, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM INTO_WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47403, AGR [CASE @D47402, COUNT @D47401, PER @D47400, 
            PLU @D47399, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47408, AGR [CASE @D47407, COUNT @D47406, PER @D47405, 
            PLU @D47404, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47413, AGR [CASE @D47412, COUNT @D47411, PER @D47410, 
            PLU @D47409, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47418, AGR [CASE @D47417, COUNT @D47416, PER @D47415, 
            PLU @D47414, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47423, AGR [CASE @D47422, COUNT @D47421, PER @D47420, 
            PLU @D47419, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47428, AGR [CASE @D47427, COUNT @D47426, PER @D47425, 
            PLU @D47424, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47433, AGR [CASE @D47432, COUNT @D47431, PER @D47430, 
            PLU @D47429, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ENTER, 
   [COORD @D47438, AGR [CASE @D47437, COUNT @D47436, PER @D47435, 
            PLU @D47434, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47443, AGR [CASE @D47442, COUNT @D47441, PER @D47440, 
            PLU @D47439, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47448, AGR [CASE @D47447, COUNT @D47446, PER @D47445, 
            PLU @D47444, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47453, AGR [CASE @D47452, COUNT @D47451, PER @D47450, 
            PLU @D47449, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47458, AGR [CASE @D47457, COUNT @D47456, PER @D47455, 
            PLU @D47454, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47463, AGR [CASE @D47462, COUNT @D47461, PER @D47460, 
            PLU @D47459, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47468, AGR [CASE @D47467, COUNT @D47466, PER @D47465, 
            PLU @D47464, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47473, AGR [CASE @D47472, COUNT @D47471, PER @D47470, 
            PLU @D47469, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47478, AGR [CASE @D47477, COUNT @D47476, PER @D47475, 
            PLU @D47474, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47483, AGR [CASE @D47482, COUNT @D47481, PER @D47480, 
            PLU @D47479, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47488, AGR [CASE @D47487, COUNT @D47486, PER @D47485, 
            PLU @D47484, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47493, AGR [CASE @D47492, COUNT @D47491, PER @D47490, 
            PLU @D47489, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47498, AGR [CASE @D47497, COUNT @D47496, PER @D47495, 
            PLU @D47494, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47503, AGR [CASE @D47502, COUNT @D47501, PER @D47500, 
            PLU @D47499, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47508, AGR [CASE @D47507, COUNT @D47506, PER @D47505, 
            PLU @D47504, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47513, AGR [CASE @D47512, COUNT @D47511, PER @D47510, 
            PLU @D47509, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47518, AGR [CASE @D47517, COUNT @D47516, PER @D47515, 
            PLU @D47514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47523, AGR [CASE @D47522, COUNT @D47521, PER @D47520, 
            PLU @D47519, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ENTER.

WORD entering : 
   [COORD @D47534, PRD @D47533, AGR [CASE @D47532, COUNT @D47531, 
            PER @D47530, PLU @D47529, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM INTO_WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47540, PRD @D47539, 
      AGR [CASE @D47538, COUNT @D47537, PER @D47536, PLU @D47535, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ENTER, 
   [COORD @D47546, PRD @D47545, AGR [CASE @D47544, COUNT @D47543, 
            PER @D47542, PLU @D47541, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47552, PRD @D47551, 
      AGR [CASE @D47550, COUNT @D47549, PER @D47548, PLU @D47547, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ENTER, 
   [COORD @D47558, PRD @D47557, AGR [CASE @D47556, COUNT @D47555, 
            PER @D47554, PLU @D47553, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47564, PRD @D47563, 
      AGR [CASE @D47562, COUNT @D47561, PER @D47560, PLU @D47559, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ENTER, 
   [COORD @D47570, PRD @D47569, AGR [CASE @D47568, COUNT @D47567, 
            PER @D47566, PLU @D47565, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47576, PRD @D47575, 
      AGR [CASE @D47574, COUNT @D47573, PER @D47572, PLU @D47571, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ENTER, 
   [COORD @D47582, PRD @D47581, AGR [CASE @D47580, COUNT @D47579, 
            PER @D47578, PLU @D47577, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTER, 
   [COORD @D47588, PRD @D47587, 
      AGR [CASE @D47586, COUNT @D47585, PER @D47584, PLU @D47583, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ENTER.

WORD enters : 
   [COORD @D47593, AGR [COUNT @D47592, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM INTO_WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : ENTER, 
   [COORD @D47595, AGR [COUNT @D47594, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47597, 
      AGR [COUNT @D47596, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47599, 
      AGR [COUNT @D47598, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47601, 
      AGR [COUNT @D47600, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47603, 
      AGR [COUNT @D47602, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47605, 
      AGR [COUNT @D47604, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47607, 
      AGR [COUNT @D47606, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47609, 
      AGR [COUNT @D47608, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER, 
   [COORD @D47611, 
      AGR [COUNT @D47610, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTER.

WORD entitle : 
   [COORD @D47617, AGR [COUNT @D47616, PER @D47615, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : ENTITLE, 
   [COORD @D47619, AGR [COUNT @D47618, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : ENTITLE, 
   [COORD @D47621, AGR [COUNT @D47620, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : ENTITLE, 
   [COORD @D47625, AGR [COUNT @D47624, PER @D47623, PLU @D47622, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : ENTITLE, 
   [COORD @D47631, PAST @D47630, AGR [CASE @D47629, COUNT @D47628, 
            PER @D47627, PLU @D47626, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_NP, ARITY 3] : ENTITLE, 
   [COORD @D47634, AGR [COUNT @D47633, PER @D47632, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENTITLE, 
   [COORD @D47636, AGR [COUNT @D47635, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENTITLE, 
   [COORD @D47638, AGR [COUNT @D47637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENTITLE, 
   [COORD @D47642, AGR [COUNT @D47641, PER @D47640, PLU @D47639, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ENTITLE, 
   [COORD @D47648, PAST @D47647, AGR [CASE @D47646, COUNT @D47645, 
            PER @D47644, PLU @D47643, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : ENTITLE, 
   [COORD @D47651, AGR [COUNT @D47650, PER @D47649, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ENTITLE, 
   [COORD @D47653, AGR [COUNT @D47652, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ENTITLE, 
   [COORD @D47655, AGR [COUNT @D47654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ENTITLE, 
   [COORD @D47659, AGR [COUNT @D47658, PER @D47657, PLU @D47656, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ENTITLE, 
   [COORD @D47665, PAST @D47664, 
      AGR [CASE @D47663, COUNT @D47662, PER @D47661, PLU @D47660, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : ENTITLE.

WORD entitled : 
   [COORD @D47674, AGR [CASE @D47673, COUNT @D47672, PER @D47671, 
            PLU @D47670, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47679, AGR [CASE @D47678, COUNT @D47677, PER @D47676, 
            PLU @D47675, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47684, AGR [CASE @D47683, COUNT @D47682, PER @D47681, 
            PLU @D47680, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47689, AGR [CASE @D47688, COUNT @D47687, PER @D47686, 
            PLU @D47685, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47694, AGR [CASE @D47693, COUNT @D47692, PER @D47691, 
            PLU @D47690, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47700, AGR [CASE @D47699, NFORM @D47698, COUNT @D47697, 
            PER @D47696, PLU @D47695, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47705, AGR [CASE @D47704, COUNT @D47703, PER @D47702, 
            PLU @D47701, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47710, AGR [CASE @D47709, COUNT @D47708, PER @D47707, 
            PLU @D47706, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47715, AGR [CASE @D47714, COUNT @D47713, PER @D47712, 
            PLU @D47711, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ENTITLE.

WORD entitles : 
   [COORD @D47721, AGR [COUNT @D47720, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47723, 
      AGR [COUNT @D47722, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47725, 
      AGR [COUNT @D47724, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ENTITLE.

WORD entitling : 
   [COORD @D47734, PRD @D47733, AGR [CASE @D47732, COUNT @D47731, 
            PER @D47730, PLU @D47729, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ENTITLE, 
   [COORD @D47740, PRD @D47739, 
      AGR [CASE @D47738, COUNT @D47737, PER @D47736, PLU @D47735, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ENTITLE, 
   [COORD @D47746, PRD @D47745, AGR [CASE @D47744, COUNT @D47743, 
            PER @D47742, PLU @D47741, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ENTITLE.

WORD escape : 
   [COORD @D47754, REFL @D47753, PRD @D47752, CASE @D47751, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : ESCAPE, 
   [COORD @D47759, REFL @D47758, COUNT @D47757, PRD @D47756, 
      CASE @D47755, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ESCAPE, 
   [COORD @D47763, REFL @D47762, PRD @D47761, CASE @D47760, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : ESCAPE, 
   [COORD @D47768, REFL @D47767, COUNT @D47766, PRD @D47765, 
      CASE @D47764, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ESCAPE, 
   [COORD @D47773, REFL @D47772, COUNT @D47771, PRD @D47770, 
      CASE @D47769, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM] : 
   ESCAPE, 
   [COORD @D47778, REFL @D47777, COUNT @D47776, PRD @D47775, CASE 
         @D47774, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OUT_OF] : 
   ESCAPE, 
   [COORD @D47782, REFL @D47781, PRD @D47780, CASE @D47779, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : ESCAPE, 
   [COORD @D47787, REFL @D47786, COUNT @D47785, PRD @D47784, 
      CASE @D47783, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ESCAPE, 
   [COORD @D47790, 
      AGR [COUNT @D47789, PER @D47788, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : ESCAPE, 
   [COORD @D47792, AGR [COUNT @D47791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : ESCAPE, 
   [COORD @D47794, AGR [COUNT @D47793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : ESCAPE, 
   [COORD @D47798, AGR [COUNT @D47797, PER @D47796, PLU @D47795, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : ESCAPE, 
   [COORD @D47804, PAST @D47803, AGR [CASE @D47802, COUNT @D47801, 
            PER @D47800, PLU @D47799, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : ESCAPE, 
   [COORD @D47807, AGR [COUNT @D47806, PER @D47805, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESCAPE, 
   [COORD @D47809, AGR [COUNT @D47808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESCAPE, 
   [COORD @D47811, AGR [COUNT @D47810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESCAPE, 
   [COORD @D47815, AGR [COUNT @D47814, PER @D47813, PLU @D47812, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ESCAPE, 
   [COORD @D47821, PAST @D47820, AGR [CASE @D47819, COUNT @D47818, 
            PER @D47817, PLU @D47816, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ESCAPE, 
   [COORD @D47824, AGR [COUNT @D47823, PER @D47822, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : ESCAPE, 
   [COORD @D47826, AGR [COUNT @D47825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : ESCAPE, 
   [COORD @D47828, AGR [COUNT @D47827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OUT_OF, ARITY 2] : ESCAPE, 
   [COORD @D47832, AGR [COUNT @D47831, PER @D47830, PLU @D47829, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OUT_OF, ARITY 2] : ESCAPE, 
   [COORD @D47838, PAST @D47837, 
      AGR [CASE @D47836, COUNT @D47835, PER @D47834, PLU @D47833, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OUT_OF, 
      ARITY 2] : ESCAPE, 
   [COORD @D47841, AGR [COUNT @D47840, PER @D47839, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : ESCAPE, 
   [COORD @D47843, AGR [COUNT @D47842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : ESCAPE, 
   [COORD @D47845, AGR [COUNT @D47844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : ESCAPE, 
   [COORD @D47849, AGR [COUNT @D47848, PER @D47847, PLU @D47846, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : ESCAPE, 
   [COORD @D47855, PAST @D47854, 
      AGR [CASE @D47853, COUNT @D47852, PER @D47851, PLU @D47850, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, 
      ARITY 2] : ESCAPE, 
   [COORD @D47858, AGR [COUNT @D47857, PER @D47856, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESCAPE, 
   [COORD @D47860, AGR [COUNT @D47859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESCAPE, 
   [COORD @D47862, AGR [COUNT @D47861, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESCAPE, 
   [COORD @D47866, AGR [COUNT @D47865, PER @D47864, PLU @D47863, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESCAPE, 
   [COORD @D47872, PAST @D47871, AGR [CASE @D47870, COUNT @D47869, 
            PER @D47868, PLU @D47867, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ESCAPE.

WORD escaped : 
   [COORD @D47883, AGR [CASE @D47882, COUNT @D47881, PER @D47880, 
            PLU @D47879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47888, AGR [CASE @D47887, COUNT @D47886, PER @D47885, 
            PLU @D47884, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47893, AGR [CASE @D47892, COUNT @D47891, PER @D47890, 
            PLU @D47889, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47898, AGR [CASE @D47897, COUNT @D47896, PER @D47895, 
            PLU @D47894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47903, AGR [CASE @D47902, COUNT @D47901, PER @D47900, 
            PLU @D47899, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47908, AGR [CASE @D47907, COUNT @D47906, PER @D47905, 
            PLU @D47904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47913, AGR [CASE @D47912, COUNT @D47911, PER @D47910, 
            PLU @D47909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47918, AGR [CASE @D47917, COUNT @D47916, PER @D47915, 
            PLU @D47914, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47923, AGR [CASE @D47922, COUNT @D47921, PER @D47920, 
            PLU @D47919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47928, AGR [CASE @D47927, COUNT @D47926, PER @D47925, 
            PLU @D47924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47933, AGR [CASE @D47932, COUNT @D47931, PER @D47930, 
            PLU @D47929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESCAPE.

WORD escapes : 
   [COORD @D47944, DEMON @D47943, REFL @D47942, PRD @D47941, 
      CASE @D47940, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ESCAPE, 
   [COORD @D47949, DEMON @D47948, REFL @D47947, PRD @D47946, 
      CASE @D47945, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ESCAPE, 
   [COORD @D47954, DEMON @D47953, REFL @D47952, PRD @D47951, 
      CASE @D47950, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ESCAPE, 
   [COORD @D47959, DEMON @D47958, REFL @D47957, PRD @D47956, 
      CASE @D47955, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FROM, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   ESCAPE, 
   [COORD @D47964, DEMON @D47963, REFL @D47962, PRD @D47961, CASE 
         @D47960, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OUT_OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   ESCAPE, 
   [COORD @D47969, DEMON @D47968, REFL @D47967, PRD @D47966, CASE 
         @D47965, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   ESCAPE, 
   [COORD @D47974, DEMON @D47973, REFL @D47972, PRD @D47971, CASE 
         @D47970, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ESCAPE, 
   [COORD @D47976, 
      AGR [COUNT @D47975, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47978, 
      AGR [COUNT @D47977, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47980, 
      AGR [COUNT @D47979, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47982, 
      AGR [COUNT @D47981, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D47984, 
      AGR [COUNT @D47983, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESCAPE.

WORD escaping : 
   [COORD @D47994, PRD @D47993, AGR [CASE @D47992, COUNT @D47991, 
            PER @D47990, PLU @D47989, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D48000, PRD @D47999, 
      AGR [CASE @D47998, COUNT @D47997, PER @D47996, PLU @D47995, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ESCAPE, 
   [COORD @D48006, PRD @D48005, AGR [CASE @D48004, COUNT @D48003, 
            PER @D48002, PLU @D48001, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ESCAPE, 
   [COORD @D48012, PRD @D48011, 
      AGR [CASE @D48010, COUNT @D48009, PER @D48008, PLU @D48007, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ESCAPE, 
   [COORD @D48018, PRD @D48017, AGR [CASE @D48016, COUNT @D48015, 
            PER @D48014, PLU @D48013, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESCAPE.

WORD establish : 
   [COORD @D48024, AGR [COUNT @D48023, PER @D48022, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ESTABLISH, 
   [COORD @D48026, AGR [COUNT @D48025, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ESTABLISH, 
   [COORD @D48028, AGR [COUNT @D48027, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ESTABLISH, 
   [COORD @D48032, AGR [COUNT @D48031, PER @D48030, PLU @D48029, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : ESTABLISH, 
   [COORD @D48038, PAST @D48037, 
      AGR [CASE @D48036, COUNT @D48035, PER @D48034, PLU @D48033, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : ESTABLISH, 
   [COORD @D48041, AGR [COUNT @D48040, PER @D48039, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ESTABLISH, 
   [COORD @D48043, AGR [COUNT @D48042, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ESTABLISH, 
   [COORD @D48045, AGR [COUNT @D48044, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ESTABLISH, 
   [COORD @D48049, AGR [COUNT @D48048, PER @D48047, PLU @D48046, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : ESTABLISH, 
   [COORD @D48055, PAST @D48054, 
      AGR [CASE @D48053, COUNT @D48052, PER @D48051, PLU @D48050, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : ESTABLISH, 
   [COORD @D48058, AGR [COUNT @D48057, PER @D48056, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : ESTABLISH, 
   [COORD @D48060, AGR [COUNT @D48059, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : ESTABLISH, 
   [COORD @D48062, AGR [COUNT @D48061, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : ESTABLISH, 
   [COORD @D48066, AGR [COUNT @D48065, PER @D48064, PLU @D48063, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : ESTABLISH, 
   [COORD @D48072, PAST @D48071, AGR [CASE @D48070, COUNT @D48069, 
            PER @D48068, PLU @D48067, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : ESTABLISH, 
   [COORD @D48075, AGR [COUNT @D48074, PER @D48073, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTABLISH, 
   [COORD @D48077, AGR [COUNT @D48076, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTABLISH, 
   [COORD @D48079, AGR [COUNT @D48078, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTABLISH, 
   [COORD @D48083, AGR [COUNT @D48082, PER @D48081, PLU @D48080, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTABLISH, 
   [COORD @D48089, PAST @D48088, AGR [CASE @D48087, COUNT @D48086, 
            PER @D48085, PLU @D48084, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : ESTABLISH, 
   [COORD @D48092, AGR [COUNT @D48091, PER @D48090, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESTABLISH, 
   [COORD @D48094, AGR [COUNT @D48093, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESTABLISH, 
   [COORD @D48096, AGR [COUNT @D48095, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESTABLISH, 
   [COORD @D48100, AGR [COUNT @D48099, PER @D48098, PLU @D48097, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ESTABLISH, 
   [COORD @D48106, PAST @D48105, AGR [CASE @D48104, COUNT @D48103, 
            PER @D48102, PLU @D48101, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ESTABLISH.

WORD established : 
   [COORD @D48115, AGR [CASE @D48114, COUNT @D48113, PER @D48112, 
            PLU @D48111, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48120, AGR [CASE @D48119, COUNT @D48118, PER @D48117, 
            PLU @D48116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48125, AGR [CASE @D48124, COUNT @D48123, PER @D48122, 
            PLU @D48121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48130, AGR [CASE @D48129, COUNT @D48128, PER @D48127, 
            PLU @D48126, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48135, AGR [CASE @D48134, COUNT @D48133, PER @D48132, 
            PLU @D48131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48140, AGR 
         [CASE @D48139, COUNT @D48138, PER @D48137, PLU @D48136, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48145, AGR [CASE @D48144, COUNT @D48143, PER @D48142, 
            PLU @D48141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48150, AGR [CASE @D48149, COUNT @D48148, PER @D48147, 
            PLU @D48146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48155, AGR [CASE @D48154, COUNT @D48153, PER @D48152, 
            PLU @D48151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48160, AGR [CASE @D48159, COUNT @D48158, PER @D48157, 
            PLU @D48156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48165, AGR [UB @D48164, VFORM @D48163, SUBJ @D48162, 
            FIN @D48161, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ESTABLISH, 
   [COORD @D48170, AGR [CASE @D48169, COUNT @D48168, PER @D48167, 
            PLU @D48166, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48175, AGR [CASE @D48174, COUNT @D48173, PER @D48172, 
            PLU @D48171, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48180, AGR [CASE @D48179, COUNT @D48178, PER @D48177, 
            PLU @D48176, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESTABLISH.

WORD establishing : 
   [COORD @D48192, PRD @D48191, AGR [CASE @D48190, COUNT @D48189, 
            PER @D48188, PLU @D48187, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48198, PRD @D48197, 
      AGR [CASE @D48196, COUNT @D48195, PER @D48194, PLU @D48193, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ESTABLISH, 
   [COORD @D48204, PRD @D48203, AGR [CASE @D48202, COUNT @D48201, 
            PER @D48200, PLU @D48199, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESTABLISH, 
   [COORD @D48210, PRD @D48209, 
      AGR [CASE @D48208, COUNT @D48207, PER @D48206, PLU @D48205, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ESTABLISH, 
   [COORD @D48216, PRD @D48215, AGR [CASE @D48214, COUNT @D48213, 
            PER @D48212, PLU @D48211, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESTABLISH.

WORD estimate : 
   [COORD @D48227, AGR [COUNT @D48226, PER @D48225, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : ESTIMATE, 
   [COORD @D48229, AGR [COUNT @D48228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : ESTIMATE, 
   [COORD @D48231, AGR [COUNT @D48230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : ESTIMATE, 
   [COORD @D48235, AGR [COUNT @D48234, PER @D48233, PLU @D48232, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : ESTIMATE, 
   [COORD @D48241, PAST @D48240, 
      AGR [CASE @D48239, COUNT @D48238, PER @D48237, PLU @D48236, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, 
      ARITY 3] : ESTIMATE, 
   [COORD @D48244, AGR [COUNT @D48243, PER @D48242, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTIMATE, 
   [COORD @D48246, AGR [COUNT @D48245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTIMATE, 
   [COORD @D48248, AGR [COUNT @D48247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTIMATE, 
   [COORD @D48252, AGR [COUNT @D48251, PER @D48250, PLU @D48249, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ESTIMATE, 
   [COORD @D48258, PAST @D48257, AGR [CASE @D48256, COUNT @D48255, 
            PER @D48254, PLU @D48253, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : ESTIMATE, 
   [COORD @D48261, AGR [COUNT @D48260, PER @D48259, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ESTIMATE, 
   [COORD @D48263, AGR [COUNT @D48262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ESTIMATE, 
   [COORD @D48265, AGR [COUNT @D48264, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ESTIMATE, 
   [COORD @D48269, AGR [COUNT @D48268, PER @D48267, PLU @D48266, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ESTIMATE, 
   [COORD @D48275, PAST @D48274, AGR 
         [CASE @D48273, COUNT @D48272, PER @D48271, PLU @D48270, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : 
   ESTIMATE, 
   [COORD @D48278, AGR [COUNT @D48277, PER @D48276, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESTIMATE, 
   [COORD @D48280, AGR [COUNT @D48279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESTIMATE, 
   [COORD @D48282, AGR [COUNT @D48281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ESTIMATE, 
   [COORD @D48286, AGR [COUNT @D48285, PER @D48284, PLU @D48283, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ESTIMATE, 
   [COORD @D48292, PAST @D48291, AGR [CASE @D48290, COUNT @D48289, 
            PER @D48288, PLU @D48287, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ESTIMATE, 
   [COORD @D48295, AGR [COUNT @D48294, PER @D48293, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESTIMATE, 
   [COORD @D48297, AGR [COUNT @D48296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESTIMATE, 
   [COORD @D48299, AGR [COUNT @D48298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESTIMATE, 
   [COORD @D48303, AGR [COUNT @D48302, PER @D48301, PLU @D48300, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ESTIMATE, 
   [COORD @D48309, PAST @D48308, AGR [CASE @D48307, COUNT @D48306, 
            PER @D48305, PLU @D48304, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ESTIMATE.

WORD estimated : 
   [COORD @D48319, AGR [CASE @D48318, COUNT @D48317, PER @D48316, 
            PLU @D48315, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48324, AGR [CASE @D48323, COUNT @D48322, PER @D48321, 
            PLU @D48320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48329, AGR [CASE @D48328, COUNT @D48327, PER @D48326, 
            PLU @D48325, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48334, AGR [UB @D48333, VFORM @D48332, SUBJ @D48331, 
            FIN @D48330, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ESTIMATE, 
   [COORD @D48339, AGR [CASE @D48338, COUNT @D48337, PER @D48336, 
            PLU @D48335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48344, AGR [CASE @D48343, COUNT @D48342, PER @D48341, 
            PLU @D48340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48349, AGR [CASE @D48348, COUNT @D48347, PER @D48346, 
            PLU @D48345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48354, AGR [CASE @D48353, COUNT @D48352, PER @D48351, 
            PLU @D48350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48360, AGR [CASE @D48359, NFORM @D48358, COUNT @D48357, 
            PER @D48356, PLU @D48355, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48365, AGR [UB @D48364, VFORM @D48363, SUBJ @D48362, 
            FIN @D48361, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ESTIMATE, 
   [COORD @D48370, AGR [CASE @D48369, COUNT @D48368, PER @D48367, 
            PLU @D48366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48375, AGR [CASE @D48374, COUNT @D48373, PER @D48372, 
            PLU @D48371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48380, AGR [CASE @D48379, COUNT @D48378, PER @D48377, 
            PLU @D48376, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48385, AGR [CASE @D48384, COUNT @D48383, PER @D48382, 
            PLU @D48381, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48390, AGR [CASE @D48389, COUNT @D48388, PER @D48387, 
            PLU @D48386, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ESTIMATE.

WORD estimates : 
   [COORD @D48397, AGR [COUNT @D48396, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESTIMATE, 
   
   [COORD @D48399, AGR [COUNT @D48398, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48401, 
      AGR [COUNT @D48400, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48403, 
      AGR [COUNT @D48402, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48405, 
      AGR [COUNT @D48404, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ESTIMATE.

WORD estimating : 
   [COORD @D48415, PRD @D48414, AGR [CASE @D48413, COUNT @D48412, 
            PER @D48411, PLU @D48410, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48421, PRD @D48420, 
      AGR [CASE @D48419, COUNT @D48418, PER @D48417, PLU @D48416, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ESTIMATE, 
   [COORD @D48427, PRD @D48426, AGR [CASE @D48425, COUNT @D48424, 
            PER @D48423, PLU @D48422, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESTIMATE, 
   [COORD @D48433, PRD @D48432, 
      AGR [CASE @D48431, COUNT @D48430, PER @D48429, PLU @D48428, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ESTIMATE, 
   [COORD @D48439, PRD @D48438, AGR [CASE @D48437, COUNT @D48436, 
            PER @D48435, PLU @D48434, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ESTIMATE.

WORD et : 
   [COADV @D48446, COORD @D48445, DEF @D48444, AGR @D48443, PRD @D48442, 
      FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, N +, COMPAR NO, GRADE -, 
      AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, ADV +] : ETC_\..

WORD exercise : 
   [COORD @D48455, REFL @D48454, COUNT @D48453, PRD @D48452, 
      CASE @D48451, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : EXERCISE, 
   [COORD @D48458, 
      AGR [COUNT @D48457, PER @D48456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM BY, 
      ARITY 3] : EXERCISE, 
   [COORD @D48460, AGR [COUNT @D48459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BY, ARITY 3] : EXERCISE, 
   [COORD @D48462, AGR [COUNT @D48461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BY, ARITY 3] : EXERCISE, 
   [COORD @D48466, AGR [COUNT @D48465, PER @D48464, PLU @D48463, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BY, ARITY 3] : EXERCISE, 
   [COORD @D48472, PAST @D48471, 
      AGR [CASE @D48470, COUNT @D48469, PER @D48468, PLU @D48467, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM BY, 
      ARITY 3] : EXERCISE, 
   [COORD @D48475, AGR [COUNT @D48474, PER @D48473, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : EXERCISE, 
   [COORD @D48477, AGR [COUNT @D48476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : EXERCISE, 
   [COORD @D48479, AGR [COUNT @D48478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : EXERCISE, 
   [COORD @D48483, AGR [COUNT @D48482, PER @D48481, PLU @D48480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : EXERCISE, 
   [COORD @D48489, PAST @D48488, 
      AGR [CASE @D48487, COUNT @D48486, PER @D48485, PLU @D48484, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, 
      ARITY 3] : EXERCISE, 
   [COORD @D48492, AGR [COUNT @D48491, PER @D48490, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXERCISE, 
   [COORD @D48494, AGR [COUNT @D48493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXERCISE, 
   [COORD @D48496, AGR [COUNT @D48495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXERCISE, 
   [COORD @D48500, AGR [COUNT @D48499, PER @D48498, PLU @D48497, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EXERCISE, 
   [COORD @D48506, PAST @D48505, AGR [CASE @D48504, COUNT @D48503, 
            PER @D48502, PLU @D48501, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EXERCISE, 
   [COORD @D48509, AGR [COUNT @D48508, PER @D48507, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXERCISE, 
   [COORD @D48511, AGR [COUNT @D48510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXERCISE, 
   [COORD @D48513, AGR [COUNT @D48512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXERCISE, 
   [COORD @D48517, AGR [COUNT @D48516, PER @D48515, PLU @D48514, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXERCISE, 
   [COORD @D48523, PAST @D48522, AGR [CASE @D48521, COUNT @D48520, 
            PER @D48519, PLU @D48518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : EXERCISE.

WORD exercised : 
   [COORD @D48534, AGR [CASE @D48533, COUNT @D48532, PER @D48531, 
            PLU @D48530, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM BY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48539, AGR [CASE @D48538, COUNT @D48537, PER @D48536, 
            PLU @D48535, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48544, AGR [CASE @D48543, COUNT @D48542, PER @D48541, 
            PLU @D48540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48549, AGR [CASE @D48548, COUNT @D48547, PER @D48546, 
            PLU @D48545, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48554, AGR [CASE @D48553, COUNT @D48552, PER @D48551, 
            PLU @D48550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48559, AGR [CASE @D48558, COUNT @D48557, PER @D48556, 
            PLU @D48555, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48564, AGR [CASE @D48563, COUNT @D48562, PER @D48561, 
            PLU @D48560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48569, AGR [CASE @D48568, COUNT @D48567, PER @D48566, 
            PLU @D48565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48574, AGR [CASE @D48573, COUNT @D48572, PER @D48571, 
            PLU @D48570, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48579, AGR [CASE @D48578, COUNT @D48577, PER @D48576, 
            PLU @D48575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48584, AGR [CASE @D48583, COUNT @D48582, PER @D48581, 
            PLU @D48580, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXERCISE.

WORD exercises : 
   [COORD @D48594, REFL @D48593, PRD @D48592, CASE @D48591, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : EXERCISES, 
   [COORD @D48599, DEMON @D48598, REFL @D48597, PRD @D48596, 
      CASE @D48595, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   EXERCISE, 
   [COORD @D48601, AGR [COUNT @D48600, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXERCISE, 
   
   [COORD @D48603, AGR [COUNT @D48602, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   EXERCISE, 
   [COORD @D48605, AGR [COUNT @D48604, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48607, 
      AGR [COUNT @D48606, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXERCISE.

WORD exercising : 
   [COORD @D48628, PRD @D48627, AGR [CASE @D48626, COUNT @D48625, 
            PER @D48624, PLU @D48623, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48634, PRD @D48633, 
      AGR [CASE @D48632, COUNT @D48631, PER @D48630, PLU @D48629, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : EXERCISE, 
   [COORD @D48640, PRD @D48639, AGR [CASE @D48638, COUNT @D48637, 
            PER @D48636, PLU @D48635, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXERCISE, 
   [COORD @D48646, PRD @D48645, 
      AGR [CASE @D48644, COUNT @D48643, PER @D48642, PLU @D48641, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXERCISE.

WORD exist : 
   [COORD @D48651, AGR [COUNT @D48650, PER @D48649, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXIST, 
   [COORD @D48653, AGR [COUNT @D48652, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXIST, 
   [COORD @D48655, AGR [COUNT @D48654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXIST, 
   [COORD @D48659, AGR [COUNT @D48658, PER @D48657, PLU @D48656, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXIST, 
   [COORD @D48665, PAST @D48664, AGR [CASE @D48663, COUNT @D48662, 
            PER @D48661, PLU @D48660, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : EXIST.

WORD existed : 
   [COORD @D48673, AGR [CASE @D48672, COUNT @D48671, PER @D48670, 
            PLU @D48669, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXIST, 
   [COORD @D48678, AGR [CASE @D48677, COUNT @D48676, PER @D48675, 
            PLU @D48674, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXIST.

WORD existing : 
   [COORD @D48689, PRD @D48688, AGR [CASE @D48687, COUNT @D48686, 
            PER @D48685, PLU @D48684, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXIST.

WORD exists : 
   [COORD @D48694, AGR [COUNT @D48693, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXIST.

WORD expect : 
   [COORD @D48699, AGR [COUNT @D48698, PER @D48697, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPECT, 
   [COORD @D48701, AGR [COUNT @D48700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPECT, 
   [COORD @D48703, AGR [COUNT @D48702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPECT, 
   [COORD @D48707, AGR [COUNT @D48706, PER @D48705, PLU @D48704, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPECT, 
   [COORD @D48713, PAST @D48712, 
      AGR [CASE @D48711, COUNT @D48710, PER @D48709, PLU @D48708, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : EXPECT, 
   [COORD @D48716, AGR [COUNT @D48715, PER @D48714, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPECT, 
   [COORD @D48718, AGR [COUNT @D48717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPECT, 
   [COORD @D48720, AGR [COUNT @D48719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPECT, 
   [COORD @D48724, AGR [COUNT @D48723, PER @D48722, PLU @D48721, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPECT, 
   [COORD @D48730, PAST @D48729, AGR [CASE @D48728, COUNT @D48727, 
            PER @D48726, PLU @D48725, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : EXPECT, 
   [COORD @D48733, AGR [COUNT @D48732, PER @D48731, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : EXPECT, 
   [COORD @D48735, AGR [COUNT @D48734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : EXPECT, 
   [COORD @D48737, AGR [COUNT @D48736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : EXPECT, 
   [COORD @D48741, AGR [COUNT @D48740, PER @D48739, PLU @D48738, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : EXPECT, 
   [COORD @D48747, PAST @D48746, AGR [CASE @D48745, COUNT @D48744, 
            PER @D48743, PLU @D48742, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : EXPECT, 
   [COORD @D48750, AGR [COUNT @D48749, PER @D48748, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : EXPECT, 
   [COORD @D48752, AGR [COUNT @D48751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : EXPECT, 
   [COORD @D48754, AGR [COUNT @D48753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : EXPECT, 
   [COORD @D48758, AGR [COUNT @D48757, PER @D48756, PLU @D48755, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : EXPECT, 
   [COORD @D48764, PAST @D48763, AGR [CASE @D48762, COUNT @D48761, 
            PER @D48760, PLU @D48759, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : EXPECT, 
   [COORD @D48767, AGR [COUNT @D48766, PER @D48765, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPECT, 
   [COORD @D48769, AGR [COUNT @D48768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPECT, 
   [COORD @D48771, AGR [COUNT @D48770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPECT, 
   [COORD @D48775, AGR [COUNT @D48774, PER @D48773, PLU @D48772, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EXPECT, 
   [COORD @D48781, PAST @D48780, AGR [CASE @D48779, COUNT @D48778, 
            PER @D48777, PLU @D48776, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EXPECT.

WORD expected : 
   [COORD @D48789, AGR [CASE @D48788, COUNT @D48787, PER @D48786, 
            PLU @D48785, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48794, AGR [CASE @D48793, COUNT @D48792, PER @D48791, 
            PLU @D48790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48799, AGR [CASE @D48798, COUNT @D48797, PER @D48796, 
            PLU @D48795, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48804, AGR [UB @D48803, VFORM @D48802, SUBJ @D48801, 
            FIN @D48800, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : EXPECT, 
   [COORD @D48809, AGR [CASE @D48808, COUNT @D48807, PER @D48806, 
            PLU @D48805, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48814, AGR [CASE @D48813, COUNT @D48812, PER @D48811, 
            PLU @D48810, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48819, AGR [CASE @D48818, COUNT @D48817, PER @D48816, 
            PLU @D48815, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48824, AGR [CASE @D48823, COUNT @D48822, PER @D48821, 
            PLU @D48820, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48829, AGR [CASE @D48828, COUNT @D48827, PER @D48826, 
            PLU @D48825, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48834, AGR [CASE @D48833, COUNT @D48832, PER @D48831, 
            PLU @D48830, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48840, AGR [CASE @D48839, NFORM @D48838, COUNT @D48837, 
            PER @D48836, PLU @D48835, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXPECT, 
   [COORD @D48845, AGR [UB @D48844, VFORM @D48843, SUBJ @D48842, 
            FIN @D48841, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : EXPECT, 
   [COORD @D48850, AGR [CASE @D48849, COUNT @D48848, PER @D48847, 
            PLU @D48846, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXPECT, 
   [COORD @D48855, AGR [CASE @D48854, COUNT @D48853, PER @D48852, 
            PLU @D48851, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48860, AGR [CASE @D48859, COUNT @D48858, PER @D48857, 
            PLU @D48856, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPECT.

WORD expecting : 
   [COORD @D48871, PRD @D48870, AGR [CASE @D48869, COUNT @D48868, 
            PER @D48867, PLU @D48866, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48877, PRD @D48876, 
      AGR [CASE @D48875, COUNT @D48874, PER @D48873, PLU @D48872, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXPECT, 
   [COORD @D48883, PRD @D48882, AGR [CASE @D48881, COUNT @D48880, 
            PER @D48879, PLU @D48878, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48889, PRD @D48888, 
      AGR [CASE @D48887, COUNT @D48886, PER @D48885, PLU @D48884, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXPECT, 
   [COORD @D48895, PRD @D48894, AGR [CASE @D48893, COUNT @D48892, 
            PER @D48891, PLU @D48890, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPECT.

WORD expects : 
   [COORD @D48900, AGR [COUNT @D48899, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   EXPECT, 
   [COORD @D48902, AGR [COUNT @D48901, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48904, 
      AGR [COUNT @D48903, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48906, 
      AGR [COUNT @D48905, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPECT, 
   [COORD @D48908, 
      AGR [COUNT @D48907, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPECT.

WORD experience : 
   [COORD @D48917, REFL @D48916, COUNT @D48915, PRD @D48914, 
      CASE @D48913, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : EXPERIENCE, 
   [COORD @D48920, 
      AGR [COUNT @D48919, PER @D48918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   EXPERIENCE, 
   [COORD @D48922, AGR [COUNT @D48921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPERIENCE, 
   [COORD @D48924, AGR [COUNT @D48923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPERIENCE, 
   [COORD @D48928, AGR [COUNT @D48927, PER @D48926, PLU @D48925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EXPERIENCE, 
   [COORD @D48934, PAST @D48933, AGR [CASE @D48932, COUNT @D48931, 
            PER @D48930, PLU @D48929, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EXPERIENCE.

WORD experienced : 
   [COADV @D48948, COORD @D48947, DEF @D48946, PRD @D48945, 
      AGR [CASE @D48944, COUNT @D48943, PER @D48942, PLU @D48941, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : EXPERIENCED, 
   [COADV @D48956, COORD @D48955, DEF @D48954, PRD @D48953, 
      AGR [CASE @D48952, COUNT @D48951, PER @D48950, PLU @D48949, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, DISTR PRD, 
      ARITY 2] : EXPERIENCED, 
   [COORD @D48961, AGR [CASE @D48960, COUNT @D48959, PER @D48958, 
            PLU @D48957, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXPERIENCE, 
   [COORD @D48966, AGR [CASE @D48965, COUNT @D48964, PER @D48963, 
            PLU @D48962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPERIENCE, 
   [COORD @D48971, AGR [CASE @D48970, COUNT @D48969, PER @D48968, 
            PLU @D48967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPERIENCE.

WORD experiences : 
   [COORD @D48982, DEMON @D48981, REFL @D48980, PRD @D48979, 
      CASE @D48978, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   EXPERIENCE, 
   [COORD @D48984, AGR [COUNT @D48983, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPERIENCE.

WORD experiencing : 
   [COORD @D48996, PRD @D48995, AGR [CASE @D48994, COUNT @D48993, 
            PER @D48992, PLU @D48991, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPERIENCE.

WORD explain : 
   [COORD @D49001, AGR [COUNT @D49000, PER @D48999, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49003, AGR [COUNT @D49002, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49005, AGR [COUNT @D49004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49009, AGR [COUNT @D49008, PER @D49007, PLU @D49006, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49015, PAST @D49014, 
      AGR [CASE @D49013, COUNT @D49012, PER @D49011, PLU @D49010, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, 
      ARITY 3] : EXPLAIN, 
   [COORD @D49018, AGR [COUNT @D49017, PER @D49016, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49020, AGR [COUNT @D49019, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49022, AGR [COUNT @D49021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49026, AGR [COUNT @D49025, PER @D49024, PLU @D49023, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPLAIN, 
   [COORD @D49032, PAST @D49031, 
      AGR [CASE @D49030, COUNT @D49029, PER @D49028, PLU @D49027, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : EXPLAIN, 
   [COORD @D49035, AGR [COUNT @D49034, PER @D49033, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : EXPLAIN, 
   [COORD @D49037, AGR [COUNT @D49036, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : EXPLAIN, 
   [COORD @D49039, AGR [COUNT @D49038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : EXPLAIN, 
   [COORD @D49043, AGR [COUNT @D49042, PER @D49041, PLU @D49040, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : EXPLAIN, 
   [COORD @D49049, PAST @D49048, AGR [CASE @D49047, COUNT @D49046, 
            PER @D49045, PLU @D49044, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : EXPLAIN, 
   [COORD @D49052, AGR [COUNT @D49051, PER @D49050, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : EXPLAIN, 
   [COORD @D49054, AGR [COUNT @D49053, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : EXPLAIN, 
   [COORD @D49056, AGR [COUNT @D49055, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : EXPLAIN, 
   [COORD @D49060, AGR [COUNT @D49059, PER @D49058, PLU @D49057, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : EXPLAIN, 
   [COORD @D49066, PAST @D49065, AGR [CASE @D49064, COUNT @D49063, 
            PER @D49062, PLU @D49061, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : EXPLAIN, 
   [COORD @D49069, AGR [COUNT @D49068, PER @D49067, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPLAIN, 
   [COORD @D49071, AGR [COUNT @D49070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPLAIN, 
   [COORD @D49073, AGR [COUNT @D49072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPLAIN, 
   [COORD @D49077, AGR [COUNT @D49076, PER @D49075, PLU @D49074, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : EXPLAIN, 
   [COORD @D49083, PAST @D49082, AGR [CASE @D49081, COUNT @D49080, 
            PER @D49079, PLU @D49078, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : EXPLAIN, 
   [COORD @D49086, AGR [COUNT @D49085, PER @D49084, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPLAIN, 
   [COORD @D49088, AGR [COUNT @D49087, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPLAIN, 
   [COORD @D49090, AGR [COUNT @D49089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPLAIN, 
   [COORD @D49094, AGR [COUNT @D49093, PER @D49092, PLU @D49091, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EXPLAIN, 
   [COORD @D49100, PAST @D49099, AGR [CASE @D49098, COUNT @D49097, 
            PER @D49096, PLU @D49095, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EXPLAIN, 
   [COORD @D49103, AGR [COUNT @D49102, PER @D49101, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : EXPLAIN, 
   [COORD @D49105, AGR [COUNT @D49104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : EXPLAIN, 
   [COORD @D49107, AGR [COUNT @D49106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : EXPLAIN, 
   [COORD @D49111, AGR [COUNT @D49110, PER @D49109, PLU @D49108, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : EXPLAIN, 
   [COORD @D49117, PAST @D49116, 
      AGR [CASE @D49115, COUNT @D49114, PER @D49113, PLU @D49112, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : EXPLAIN, 
   [COORD @D49120, AGR [COUNT @D49119, PER @D49118, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXPLAIN, 
   [COORD @D49122, AGR [COUNT @D49121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXPLAIN, 
   [COORD @D49124, AGR [COUNT @D49123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXPLAIN, 
   [COORD @D49128, AGR [COUNT @D49127, PER @D49126, PLU @D49125, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : EXPLAIN, 
   [COORD @D49134, PAST @D49133, AGR [CASE @D49132, COUNT @D49131, 
            PER @D49130, PLU @D49129, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : EXPLAIN, 
   [COORD @D49137, AGR [COUNT @D49136, PER @D49135, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : EXPLAIN, 
   [COORD @D49139, AGR [COUNT @D49138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : EXPLAIN, 
   [COORD @D49141, AGR [COUNT @D49140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : EXPLAIN, 
   [COORD @D49145, AGR [COUNT @D49144, PER @D49143, PLU @D49142, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : EXPLAIN, 
   [COORD @D49151, PAST @D49150, 
      AGR [CASE @D49149, COUNT @D49148, PER @D49147, PLU @D49146, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : EXPLAIN.

WORD explained : 
   [COORD @D49159, AGR [CASE @D49158, COUNT @D49157, PER @D49156, 
            PLU @D49155, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49164, AGR [CASE @D49163, COUNT @D49162, PER @D49161, 
            PLU @D49160, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49169, AGR [CASE @D49168, COUNT @D49167, PER @D49166, 
            PLU @D49165, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49174, AGR [CASE @D49173, COUNT @D49172, PER @D49171, 
            PLU @D49170, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49179, AGR [CASE @D49178, COUNT @D49177, PER @D49176, 
            PLU @D49175, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49184, AGR [CASE @D49183, COUNT @D49182, PER @D49181, 
            PLU @D49180, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49189, AGR [CASE @D49188, COUNT @D49187, PER @D49186, 
            PLU @D49185, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49194, AGR [CASE @D49193, COUNT @D49192, PER @D49191, 
            PLU @D49190, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49199, AGR [CASE @D49198, COUNT @D49197, PER @D49196, 
            PLU @D49195, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49204, AGR [CASE @D49203, COUNT @D49202, PER @D49201, 
            PLU @D49200, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49209, AGR [CASE @D49208, COUNT @D49207, PER @D49206, 
            PLU @D49205, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49214, AGR [UB @D49213, VFORM @D49212, SUBJ @D49211, 
            FIN @D49210, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : EXPLAIN, 
   [COORD @D49219, AGR [CASE @D49218, COUNT @D49217, PER @D49216, 
            PLU @D49215, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49224, AGR [CASE @D49223, COUNT @D49222, PER @D49221, 
            PLU @D49220, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49229, AGR [CASE @D49228, COUNT @D49227, PER @D49226, 
            PLU @D49225, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49234, AGR [CASE @D49233, COUNT @D49232, PER @D49231, 
            PLU @D49230, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49239, AGR [CASE @D49238, COUNT @D49237, PER @D49236, 
            PLU @D49235, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49244, AGR [CASE @D49243, COUNT @D49242, PER @D49241, 
            PLU @D49240, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49249, AGR [CASE @D49248, COUNT @D49247, PER @D49246, 
            PLU @D49245, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49254, AGR [CASE @D49253, COUNT @D49252, PER @D49251, 
            PLU @D49250, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49259, AGR [CASE @D49258, COUNT @D49257, PER @D49256, 
            PLU @D49255, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49264, AGR [CASE @D49263, COUNT @D49262, PER @D49261, 
            PLU @D49260, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EXPLAIN.

WORD explaining : 
   [COORD @D49275, PRD @D49274, AGR [CASE @D49273, COUNT @D49272, 
            PER @D49271, PLU @D49270, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49281, PRD @D49280, 
      AGR [CASE @D49279, COUNT @D49278, PER @D49277, PLU @D49276, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : EXPLAIN, 
   [COORD @D49287, PRD @D49286, AGR [CASE @D49285, COUNT @D49284, 
            PER @D49283, PLU @D49282, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49293, PRD @D49292, 
      AGR [CASE @D49291, COUNT @D49290, PER @D49289, PLU @D49288, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXPLAIN, 
   [COORD @D49299, PRD @D49298, AGR [CASE @D49297, COUNT @D49296, 
            PER @D49295, PLU @D49294, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49305, PRD @D49304, 
      AGR [CASE @D49303, COUNT @D49302, PER @D49301, PLU @D49300, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXPLAIN, 
   [COORD @D49311, PRD @D49310, AGR [CASE @D49309, COUNT @D49308, 
            PER @D49307, PLU @D49306, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49317, PRD @D49316, 
      AGR [CASE @D49315, COUNT @D49314, PER @D49313, PLU @D49312, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXPLAIN, 
   [COORD @D49323, PRD @D49322, AGR [CASE @D49321, COUNT @D49320, 
            PER @D49319, PLU @D49318, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPLAIN.

WORD explains : 
   [COORD @D49328, AGR [COUNT @D49327, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   EXPLAIN, 
   [COORD @D49330, AGR [COUNT @D49329, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49332, 
      AGR [COUNT @D49331, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49334, 
      AGR [COUNT @D49333, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49336, 
      AGR [COUNT @D49335, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49338, 
      AGR [COUNT @D49337, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49340, 
      AGR [COUNT @D49339, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49342, 
      AGR [COUNT @D49341, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN, 
   [COORD @D49344, 
      AGR [COUNT @D49343, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPLAIN.

WORD expose : 
   [COORD @D49350, AGR [COUNT @D49349, PER @D49348, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPOSE, 
   [COORD @D49352, AGR [COUNT @D49351, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPOSE, 
   [COORD @D49354, AGR [COUNT @D49353, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPOSE, 
   [COORD @D49358, AGR [COUNT @D49357, PER @D49356, PLU @D49355, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPOSE, 
   [COORD @D49364, PAST @D49363, 
      AGR [CASE @D49362, COUNT @D49361, PER @D49360, PLU @D49359, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : EXPOSE, 
   [COORD @D49367, AGR [COUNT @D49366, PER @D49365, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPOSE, 
   [COORD @D49369, AGR [COUNT @D49368, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPOSE, 
   [COORD @D49371, AGR [COUNT @D49370, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPOSE, 
   [COORD @D49375, AGR [COUNT @D49374, PER @D49373, PLU @D49372, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EXPOSE, 
   [COORD @D49381, PAST @D49380, AGR [CASE @D49379, COUNT @D49378, 
            PER @D49377, PLU @D49376, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EXPOSE.

WORD exposed : 
   [COORD @D49390, AGR [CASE @D49389, COUNT @D49388, PER @D49387, 
            PLU @D49386, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPOSE, 
   [COORD @D49395, AGR [CASE @D49394, COUNT @D49393, PER @D49392, 
            PLU @D49391, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPOSE, 
   [COORD @D49400, AGR [CASE @D49399, COUNT @D49398, PER @D49397, 
            PLU @D49396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EXPOSE, 
   [COORD @D49405, AGR [CASE @D49404, COUNT @D49403, PER @D49402, 
            PLU @D49401, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXPOSE, 
   [COORD @D49410, AGR [CASE @D49409, COUNT @D49408, PER @D49407, 
            PLU @D49406, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPOSE, 
   [COORD @D49415, AGR [CASE @D49414, COUNT @D49413, PER @D49412, 
            PLU @D49411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPOSE.

WORD exposes : 
   [COORD @D49421, AGR [COUNT @D49420, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPOSE, 
   [COORD @D49423, 
      AGR [COUNT @D49422, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXPOSE.

WORD exposing : 
   [COORD @D49432, PRD @D49431, AGR [CASE @D49430, COUNT @D49429, 
            PER @D49428, PLU @D49427, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPOSE, 
   [COORD @D49438, PRD @D49437, 
      AGR [CASE @D49436, COUNT @D49435, PER @D49434, PLU @D49433, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXPOSE.

WORD express : 
   [COORD @D49443, AGR [COUNT @D49442, PER @D49441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPRESS, 
   [COORD @D49445, AGR [COUNT @D49444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPRESS, 
   [COORD @D49447, AGR [COUNT @D49446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPRESS, 
   [COORD @D49451, AGR [COUNT @D49450, PER @D49449, PLU @D49448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXPRESS, 
   [COORD @D49457, PAST @D49456, 
      AGR [CASE @D49455, COUNT @D49454, PER @D49453, PLU @D49452, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : EXPRESS, 
   [COORD @D49460, AGR [COUNT @D49459, PER @D49458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OUT_OF, ARITY 3] : EXPRESS, 
   [COORD @D49462, AGR [COUNT @D49461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OUT_OF, ARITY 3] : EXPRESS, 
   [COORD @D49464, AGR [COUNT @D49463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OUT_OF, ARITY 3] : EXPRESS, 
   [COORD @D49468, AGR [COUNT @D49467, PER @D49466, PLU @D49465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OUT_OF, ARITY 3] : EXPRESS, 
   [COORD @D49474, PAST @D49473, 
      AGR [CASE @D49472, COUNT @D49471, PER @D49470, PLU @D49469, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OUT_OF, ARITY 3] : EXPRESS, 
   [COORD @D49477, AGR [COUNT @D49476, PER @D49475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPRESS, 
   [COORD @D49479, AGR [COUNT @D49478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPRESS, 
   [COORD @D49481, AGR [COUNT @D49480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPRESS, 
   [COORD @D49485, AGR [COUNT @D49484, PER @D49483, PLU @D49482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : EXPRESS, 
   [COORD @D49491, PAST @D49490, 
      AGR [CASE @D49489, COUNT @D49488, PER @D49487, PLU @D49486, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : EXPRESS, 
   [COORD @D49494, AGR [COUNT @D49493, PER @D49492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : EXPRESS, 
   [COORD @D49496, AGR [COUNT @D49495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : EXPRESS, 
   [COORD @D49498, AGR [COUNT @D49497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : EXPRESS, 
   [COORD @D49502, AGR [COUNT @D49501, PER @D49500, PLU @D49499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : EXPRESS, 
   [COORD @D49508, PAST @D49507, AGR [CASE @D49506, COUNT @D49505, 
            PER @D49504, PLU @D49503, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : EXPRESS, 
   [COORD @D49511, AGR [COUNT @D49510, PER @D49509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPRESS, 
   [COORD @D49513, AGR [COUNT @D49512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPRESS, 
   [COORD @D49515, AGR [COUNT @D49514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXPRESS, 
   [COORD @D49519, AGR [COUNT @D49518, PER @D49517, PLU @D49516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EXPRESS, 
   [COORD @D49525, PAST @D49524, AGR [CASE @D49523, COUNT @D49522, 
            PER @D49521, PLU @D49520, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EXPRESS.

WORD expressed : 
   [COORD @D49533, AGR [CASE @D49532, COUNT @D49531, PER @D49530, 
            PLU @D49529, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49538, AGR [CASE @D49537, COUNT @D49536, PER @D49535, 
            PLU @D49534, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49543, AGR [CASE @D49542, COUNT @D49541, PER @D49540, 
            PLU @D49539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49548, AGR [CASE @D49547, COUNT @D49546, PER @D49545, 
            PLU @D49544, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49553, AGR [CASE @D49552, COUNT @D49551, PER @D49550, 
            PLU @D49549, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49558, AGR [CASE @D49557, COUNT @D49556, PER @D49555, 
            PLU @D49554, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49563, AGR [CASE @D49562, COUNT @D49561, PER @D49560, 
            PLU @D49559, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49568, AGR [CASE @D49567, COUNT @D49566, PER @D49565, 
            PLU @D49564, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49573, AGR [CASE @D49572, COUNT @D49571, PER @D49570, 
            PLU @D49569, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49578, AGR [CASE @D49577, COUNT @D49576, PER @D49575, 
            PLU @D49574, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49583, AGR [CASE @D49582, COUNT @D49581, PER @D49580, 
            PLU @D49579, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49588, AGR [CASE @D49587, COUNT @D49586, PER @D49585, 
            PLU @D49584, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49593, AGR [CASE @D49592, COUNT @D49591, PER @D49590, 
            PLU @D49589, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49598, AGR [CASE @D49597, COUNT @D49596, PER @D49595, 
            PLU @D49594, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXPRESS.

WORD expressing : 
   [COORD @D49609, PRD @D49608, AGR [CASE @D49607, COUNT @D49606, 
            PER @D49605, PLU @D49604, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49615, PRD @D49614, 
      AGR [CASE @D49613, COUNT @D49612, PER @D49611, PLU @D49610, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : EXPRESS, 
   [COORD @D49621, PRD @D49620, AGR [CASE @D49619, COUNT @D49618, 
            PER @D49617, PLU @D49616, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : EXPRESS, 
   [COORD @D49627, PRD @D49626, 
      AGR [CASE @D49625, COUNT @D49624, PER @D49623, PLU @D49622, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXPRESS, 
   [COORD @D49633, PRD @D49632, AGR [CASE @D49631, COUNT @D49630, 
            PER @D49629, PLU @D49628, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXPRESS.

WORD extend : 
   [COORD @D49641, AGR [COUNT @D49640, PER @D49639, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : EXTEND, 
   [COORD @D49643, AGR [COUNT @D49642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : EXTEND, 
   [COORD @D49645, AGR [COUNT @D49644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : EXTEND, 
   [COORD @D49649, AGR [COUNT @D49648, PER @D49647, PLU @D49646, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : EXTEND, 
   [COORD @D49655, PAST @D49654, AGR [CASE @D49653, COUNT @D49652, 
            PER @D49651, PLU @D49650, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : EXTEND, 
   [COORD @D49658, AGR [COUNT @D49657, PER @D49656, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXTEND, 
   [COORD @D49660, AGR [COUNT @D49659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXTEND, 
   [COORD @D49662, AGR [COUNT @D49661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXTEND, 
   [COORD @D49666, AGR [COUNT @D49665, PER @D49664, PLU @D49663, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : EXTEND, 
   [COORD @D49672, PAST @D49671, 
      AGR [CASE @D49670, COUNT @D49669, PER @D49668, PLU @D49667, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : EXTEND, 
   [COORD @D49675, AGR [COUNT @D49674, PER @D49673, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXTEND, 
   [COORD @D49677, AGR [COUNT @D49676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXTEND, 
   [COORD @D49679, AGR [COUNT @D49678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : EXTEND, 
   [COORD @D49683, AGR [COUNT @D49682, PER @D49681, PLU @D49680, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : EXTEND, 
   [COORD @D49689, PAST @D49688, AGR [CASE @D49687, COUNT @D49686, 
            PER @D49685, PLU @D49684, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : EXTEND, 
   [COORD @D49692, AGR [COUNT @D49691, PER @D49690, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : EXTEND, 
   [COORD @D49694, AGR [COUNT @D49693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : EXTEND, 
   [COORD @D49696, AGR [COUNT @D49695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : EXTEND, 
   [COORD @D49700, AGR [COUNT @D49699, PER @D49698, PLU @D49697, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : EXTEND, 
   [COORD @D49706, PAST @D49705, AGR [CASE @D49704, COUNT @D49703, 
            PER @D49702, PLU @D49701, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : EXTEND.

WORD extended : 
   [COORD @D49714, AGR [CASE @D49713, COUNT @D49712, PER @D49711, 
            PLU @D49710, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXTEND, 
   [COORD @D49719, AGR [CASE @D49718, COUNT @D49717, PER @D49716, 
            PLU @D49715, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49724, AGR [CASE @D49723, COUNT @D49722, PER @D49721, 
            PLU @D49720, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49729, AGR [CASE @D49728, COUNT @D49727, PER @D49726, 
            PLU @D49725, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49734, AGR [CASE @D49733, COUNT @D49732, PER @D49731, 
            PLU @D49730, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49739, AGR [CASE @D49738, COUNT @D49737, PER @D49736, 
            PLU @D49735, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49744, AGR [CASE @D49743, COUNT @D49742, PER @D49741, 
            PLU @D49740, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49749, AGR [CASE @D49748, COUNT @D49747, PER @D49746, 
            PLU @D49745, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49754, AGR [CASE @D49753, COUNT @D49752, PER @D49751, 
            PLU @D49750, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : EXTEND, 
   [COORD @D49759, AGR [CASE @D49758, COUNT @D49757, PER @D49756, 
            PLU @D49755, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49764, AGR [CASE @D49763, COUNT @D49762, PER @D49761, 
            PLU @D49760, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : EXTEND.

WORD extending : 
   [COORD @D49775, PRD @D49774, AGR [CASE @D49773, COUNT @D49772, 
            PER @D49771, PLU @D49770, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49781, PRD @D49780, 
      AGR [CASE @D49779, COUNT @D49778, PER @D49777, PLU @D49776, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : EXTEND, 
   [COORD @D49787, PRD @D49786, AGR [CASE @D49785, COUNT @D49784, 
            PER @D49783, PLU @D49782, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49793, PRD @D49792, 
      AGR [CASE @D49791, COUNT @D49790, PER @D49789, PLU @D49788, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   EXTEND.

WORD extends : 
   [COORD @D49798, AGR [COUNT @D49797, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49800, 
      AGR [COUNT @D49799, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49802, 
      AGR [COUNT @D49801, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXTEND, 
   [COORD @D49804, 
      AGR [COUNT @D49803, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : EXTEND.

WORD face : 
   [COORD @D49813, REFL @D49812, COUNT @D49811, PRD @D49810, CASE 
         @D49809, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FACE, 
   [COORD @D49816, 
      AGR [COUNT @D49815, PER @D49814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : FACE, 
   [COORD @D49818, AGR [COUNT @D49817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FACE, 
   [COORD @D49820, AGR [COUNT @D49819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FACE, 
   [COORD @D49824, AGR [COUNT @D49823, PER @D49822, PLU @D49821, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FACE, 
   [COORD @D49830, PAST @D49829, 
      AGR [CASE @D49828, COUNT @D49827, PER @D49826, PLU @D49825, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : FACE, 
   [COORD @D49833, AGR [COUNT @D49832, PER @D49831, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FACE, 
   [COORD @D49835, AGR [COUNT @D49834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FACE, 
   [COORD @D49837, AGR [COUNT @D49836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FACE, 
   [COORD @D49841, AGR [COUNT @D49840, PER @D49839, PLU @D49838, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FACE, 
   [COORD @D49847, PAST @D49846, AGR [CASE @D49845, COUNT @D49844, 
            PER @D49843, PLU @D49842, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FACE, 
   [COORD @D49850, AGR [COUNT @D49849, PER @D49848, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FACE, 
   [COORD @D49852, AGR [COUNT @D49851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FACE, 
   [COORD @D49854, AGR [COUNT @D49853, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FACE, 
   [COORD @D49858, AGR [COUNT @D49857, PER @D49856, PLU @D49855, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : FACE, 
   [COORD @D49864, PAST @D49863, AGR [CASE @D49862, COUNT @D49861, 
            PER @D49860, PLU @D49859, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : FACE, 
   [COORD @D49867, AGR [COUNT @D49866, PER @D49865, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : FACE, 
   [COORD @D49869, AGR [COUNT @D49868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : FACE, 
   [COORD @D49871, AGR [COUNT @D49870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : FACE, 
   [COORD @D49875, AGR [COUNT @D49874, PER @D49873, PLU @D49872, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : FACE, 
   [COORD @D49881, PAST @D49880, 
      AGR [CASE @D49879, COUNT @D49878, PER @D49877, PLU @D49876, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, 
      ARITY 2] : FACE, 
   [COORD @D49884, AGR [COUNT @D49883, PER @D49882, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FACE, 
   [COORD @D49886, AGR [COUNT @D49885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FACE, 
   [COORD @D49888, AGR [COUNT @D49887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FACE, 
   [COORD @D49892, AGR [COUNT @D49891, PER @D49890, PLU @D49889, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : FACE, 
   [COORD @D49898, PAST @D49897, 
      AGR [CASE @D49896, COUNT @D49895, PER @D49894, PLU @D49893, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : FACE, 
   [COORD @D49901, AGR [COUNT @D49900, PER @D49899, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FACE, 
   [COORD @D49903, AGR [COUNT @D49902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FACE, 
   [COORD @D49905, AGR [COUNT @D49904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FACE, 
   [COORD @D49909, AGR [COUNT @D49908, PER @D49907, PLU @D49906, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FACE, 
   [COORD @D49915, PAST @D49914, 
      AGR [CASE @D49913, COUNT @D49912, PER @D49911, PLU @D49910, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : FACE.

WORD faced : 
   [COORD @D49926, AGR [CASE @D49925, COUNT @D49924, PER @D49923, 
            PLU @D49922, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49931, AGR [CASE @D49930, COUNT @D49929, PER @D49928, 
            PLU @D49927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49936, AGR [CASE @D49935, COUNT @D49934, PER @D49933, 
            PLU @D49932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FACE, 
   [COORD @D49941, AGR [CASE @D49940, COUNT @D49939, PER @D49938, 
            PLU @D49937, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FACE, 
   [COORD @D49946, AGR [CASE @D49945, COUNT @D49944, PER @D49943, 
            PLU @D49942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49951, AGR [CASE @D49950, COUNT @D49949, PER @D49948, 
            PLU @D49947, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FACE, 
   [COORD @D49956, AGR [CASE @D49955, COUNT @D49954, PER @D49953, 
            PLU @D49952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49961, AGR [CASE @D49960, COUNT @D49959, PER @D49958, 
            PLU @D49957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FACE, 
   [COORD @D49966, AGR [CASE @D49965, COUNT @D49964, PER @D49963, 
            PLU @D49962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49971, AGR [CASE @D49970, COUNT @D49969, PER @D49968, 
            PLU @D49967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FACE, 
   [COORD @D49976, AGR [CASE @D49975, COUNT @D49974, PER @D49973, 
            PLU @D49972, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49981, AGR [CASE @D49980, COUNT @D49979, PER @D49978, 
            PLU @D49977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49986, AGR [CASE @D49985, COUNT @D49984, PER @D49983, 
            PLU @D49982, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FACE, 
   [COORD @D49991, AGR [CASE @D49990, COUNT @D49989, PER @D49988, 
            PLU @D49987, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D49996, AGR [CASE @D49995, COUNT @D49994, PER @D49993, 
            PLU @D49992, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D50001, AGR [CASE @D50000, COUNT @D49999, PER @D49998, 
            PLU @D49997, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FACE.

WORD faces : 
   [COORD @D50012, DEMON @D50011, REFL @D50010, PRD @D50009, CASE 
         @D50008, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FACE, 
   [COORD @D50014, 
      AGR [COUNT @D50013, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FACE, 
   [COORD @D50016, AGR [COUNT @D50015, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FACE, 
   [COORD @D50018, 
      AGR [COUNT @D50017, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FACE, 
   [COORD @D50020, 
      AGR [COUNT @D50019, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FACE, 
   [COORD @D50022, AGR [COUNT @D50021, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FACE, 
   [COORD @D50024, 
      AGR [COUNT @D50023, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FACE.

WORD facing : 
   [COORD @D50036, PRD @D50035, AGR [CASE @D50034, COUNT @D50033, 
            PER @D50032, PLU @D50031, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D50042, PRD @D50041, 
      AGR [CASE @D50040, COUNT @D50039, PER @D50038, PLU @D50037, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FACE, 
   [COORD @D50048, PRD @D50047, AGR [CASE @D50046, COUNT @D50045, 
            PER @D50044, PLU @D50043, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D50054, PRD @D50053, 
      AGR [CASE @D50052, COUNT @D50051, PER @D50050, PLU @D50049, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FACE, 
   [COORD @D50060, PRD @D50059, AGR [CASE @D50058, COUNT @D50057, 
            PER @D50056, PLU @D50055, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FACE, 
   [COORD @D50066, PRD @D50065, 
      AGR [CASE @D50064, COUNT @D50063, PER @D50062, PLU @D50061, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FACE.

WORD fail : 
   [COORD @D50071, AGR [COUNT @D50070, PER @D50069, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FAIL, 
   [COORD @D50073, AGR [COUNT @D50072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FAIL, 
   [COORD @D50075, AGR [COUNT @D50074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FAIL, 
   [COORD @D50079, AGR [COUNT @D50078, PER @D50077, PLU @D50076, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FAIL, 
   [COORD @D50085, PAST @D50084, AGR [CASE @D50083, COUNT @D50082, 
            PER @D50081, PLU @D50080, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FAIL, 
   [COORD @D50087, AGR [COUNT @D50086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : FAIL, 
   [COORD @D50089, AGR [COUNT @D50088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : FAIL, 
   [COORD @D50093, AGR [NFORM @D50092, COUNT @D50091, PER @D50090, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : FAIL, 
   [COORD @D50097, AGR [COUNT @D50096, PER @D50095, PLU @D50094, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : FAIL, 
   [COORD @D50100, AGR @D50099, PAST @D50098, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, ARITY 1] : FAIL, 
   [COORD @D50103, AGR [COUNT @D50102, PER @D50101, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAIL, 
   [COORD @D50105, AGR [COUNT @D50104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAIL, 
   [COORD @D50107, AGR [COUNT @D50106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAIL, 
   [COORD @D50111, AGR [COUNT @D50110, PER @D50109, PLU @D50108, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAIL, 
   [COORD @D50117, PAST @D50116, AGR [CASE @D50115, COUNT @D50114, 
            PER @D50113, PLU @D50112, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FAIL.

WORD failed : 
   [COORD @D50125, AGR [CASE @D50124, COUNT @D50123, PER @D50122, 
            PLU @D50121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FAIL, 
   [COORD @D50130, AGR [CASE @D50129, COUNT @D50128, PER @D50127, 
            PLU @D50126, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FAIL, 
   [COORD @D50135, AGR [CASE @D50134, COUNT @D50133, PER @D50132, 
            PLU @D50131, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FAIL, 
   [COORD @D50137, AGR @D50136, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FAIL, 
   [COORD @D50139, AGR @D50138, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : FAIL, 
   [COORD @D50144, AGR [CASE @D50143, COUNT @D50142, PER @D50141, 
            PLU @D50140, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FAIL, 
   [COORD @D50149, AGR [CASE @D50148, COUNT @D50147, PER @D50146, 
            PLU @D50145, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FAIL.

WORD failing : 
   [COORD @D50160, PRD @D50159, AGR [CASE @D50158, COUNT @D50157, 
            PER @D50156, PLU @D50155, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FAIL, 
   [COORD @D50163, AGR @D50162, PRD @D50161, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FAIL, 
   [COORD @D50169, PRD @D50168, AGR [CASE @D50167, COUNT @D50166, 
            PER @D50165, PLU @D50164, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FAIL.

WORD fails : 
   [COORD @D50174, AGR [COUNT @D50173, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAIL, 
   [COORD @D50178, 
      AGR [CASE @D50177, NFORM @D50176, COUNT @D50175, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAIL, 
   [COORD @D50183, 
      AGR [UB @D50182, VFORM @D50181, SUBJ @D50180, FIN @D50179, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAIL, 
   [COORD @D50185, 
      AGR [COUNT @D50184, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAIL.

WORD fall : 
   [COORD @D50191, REFL @D50190, PRD @D50189, CASE @D50188, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FALL, 
   [COORD @D50195, REFL @D50194, PRD @D50193, CASE @D50192, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FALL, 
   [COORD @D50199, REFL @D50198, PRD @D50197, CASE @D50196, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FALL, 
   [COORD @D50203, REFL @D50202, PRD @D50201, CASE @D50200, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, COUNT +] : FALL, 
   [COORD @D50207, REFL @D50206, PRD @D50205, CASE @D50204, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : FALL, 
   [COORD @D50211, REFL @D50210, PRD @D50209, CASE @D50208, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FALL, 
   [COORD @D50214, 
      AGR [COUNT @D50213, PER @D50212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, ARITY 2] : 
   FALL, 
   [COORD @D50216, AGR [COUNT @D50215, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : FALL, 
   [COORD @D50218, AGR [COUNT @D50217, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : FALL, 
   [COORD @D50222, AGR [COUNT @D50221, PER @D50220, PLU @D50219, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : FALL, 
   [COORD @D50228, PAST @D50227, 
      AGR [CASE @D50226, COUNT @D50225, PER @D50224, PLU @D50223, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, ARITY 2] : 
   FALL, 
   [COORD @D50231, AGR [COUNT @D50230, PER @D50229, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FALL, 
   [COORD @D50233, AGR [COUNT @D50232, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FALL, 
   [COORD @D50235, AGR [COUNT @D50234, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FALL, 
   [COORD @D50239, AGR [COUNT @D50238, PER @D50237, PLU @D50236, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : FALL, 
   [COORD @D50245, PAST @D50244, AGR [CASE @D50243, COUNT @D50242, 
            PER @D50241, PLU @D50240, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : FALL, 
   [COORD @D50248, AGR [COUNT @D50247, PER @D50246, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : FALL, 
   [COORD @D50250, AGR [COUNT @D50249, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : FALL, 
   [COORD @D50252, AGR [COUNT @D50251, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : FALL, 
   [COORD @D50256, AGR [COUNT @D50255, PER @D50254, PLU @D50253, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : FALL, 
   [COORD @D50262, PAST @D50261, AGR [CASE @D50260, COUNT @D50259, 
            PER @D50258, PLU @D50257, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : FALL, 
   [COORD @D50265, AGR [COUNT @D50264, PER @D50263, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP TO, ARITY 2] : FALL, 
   [COORD @D50267, AGR [COUNT @D50266, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP TO, ARITY 2] : FALL, 
   [COORD @D50269, AGR [COUNT @D50268, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP TO, ARITY 2] : FALL, 
   [COORD @D50273, AGR [COUNT @D50272, PER @D50271, PLU @D50270, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP TO, ARITY 2] : FALL, 
   [COORD @D50279, PAST @D50278, 
      AGR [CASE @D50277, COUNT @D50276, PER @D50275, PLU @D50274, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP TO, 
      ARITY 2] : FALL, 
   [COORD @D50282, AGR [COUNT @D50281, PER @D50280, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50284, AGR [COUNT @D50283, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50286, AGR [COUNT @D50285, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50290, AGR [COUNT @D50289, PER @D50288, PLU @D50287, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50296, PAST @D50295, 
      AGR [CASE @D50294, COUNT @D50293, PER @D50292, PLU @D50291, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50299, AGR [COUNT @D50298, PER @D50297, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50301, AGR [COUNT @D50300, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50303, AGR [COUNT @D50302, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50307, AGR [COUNT @D50306, PER @D50305, PLU @D50304, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50313, PAST @D50312, 
      AGR [CASE @D50311, COUNT @D50310, PER @D50309, PLU @D50308, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, 
      PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50316, AGR [COUNT @D50315, PER @D50314, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BEHIND, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50318, AGR [COUNT @D50317, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BEHIND, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50320, AGR [COUNT @D50319, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BEHIND, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50324, AGR [COUNT @D50323, PER @D50322, PLU @D50321, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT BEHIND, PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50330, PAST @D50329, 
      AGR [CASE @D50328, COUNT @D50327, PER @D50326, PLU @D50325, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BEHIND, 
      PFORM WITH, ARITY 2] : FALL, 
   [COORD @D50333, AGR [COUNT @D50332, PER @D50331, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50335, AGR [COUNT @D50334, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50337, AGR [COUNT @D50336, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50341, AGR [COUNT @D50340, PER @D50339, PLU @D50338, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50347, PAST @D50346, AGR 
         [CASE @D50345, COUNT @D50344, PER @D50343, PLU @D50342, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM UPON, 
      ARITY 2] : FALL, 
   [COORD @D50350, AGR [COUNT @D50349, PER @D50348, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50352, AGR [COUNT @D50351, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50354, AGR [COUNT @D50353, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50358, AGR [COUNT @D50357, PER @D50356, PLU @D50355, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT BACK, PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50364, PAST @D50363, 
      AGR [CASE @D50362, COUNT @D50361, PER @D50360, PLU @D50359, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT BACK, 
      PFORM UPON, ARITY 2] : FALL, 
   [COORD @D50367, AGR [COUNT @D50366, PER @D50365, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : FALL, 
   [COORD @D50369, AGR [COUNT @D50368, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : FALL, 
   [COORD @D50371, AGR [COUNT @D50370, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : FALL, 
   [COORD @D50375, AGR [COUNT @D50374, PER @D50373, PLU @D50372, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : FALL, 
   [COORD @D50381, PAST @D50380, AGR [CASE @D50379, COUNT @D50378, 
            PER @D50377, PLU @D50376, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : FALL, 
   [COORD @D50384, 
      AGR [COUNT @D50383, PER @D50382, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, 
      ARITY 2] : FALL, 
   [COORD @D50386, AGR [COUNT @D50385, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : FALL, 
   [COORD @D50388, AGR [COUNT @D50387, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : FALL, 
   [COORD @D50392, AGR [COUNT @D50391, PER @D50390, PLU @D50389, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50398, PAST @D50397, AGR [CASE @D50396, COUNT @D50395, 
            PER @D50394, PLU @D50393, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50401, 
      AGR [COUNT @D50400, PER @D50399, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM ON, ARITY 2] : FALL, 
   [COORD @D50403, AGR [COUNT @D50402, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50405, AGR [COUNT @D50404, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50409, AGR [COUNT @D50408, PER @D50407, PLU @D50406, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50415, PAST @D50414, 
      AGR [CASE @D50413, COUNT @D50412, PER @D50411, PLU @D50410, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM ON, ARITY 2] : FALL, 
   [COORD @D50418, AGR [COUNT @D50417, PER @D50416, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50420, AGR [COUNT @D50419, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50422, AGR [COUNT @D50421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50426, AGR [COUNT @D50425, PER @D50424, PLU @D50423, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT BACK, PFORM ON, ARITY 2] : FALL, 
   [COORD @D50432, PAST @D50431, 
      AGR [CASE @D50430, COUNT @D50429, PER @D50428, PLU @D50427, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT BACK, 
      PFORM ON, ARITY 2] : FALL, 
   [COORD @D50435, AGR [COUNT @D50434, PER @D50433, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FALL, 
   [COORD @D50437, AGR [COUNT @D50436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FALL, 
   [COORD @D50439, AGR [COUNT @D50438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FALL, 
   [COORD @D50443, AGR [COUNT @D50442, PER @D50441, PLU @D50440, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : FALL, 
   [COORD @D50449, PAST @D50448, AGR [CASE @D50447, COUNT @D50446, 
            PER @D50445, PLU @D50444, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : FALL, 
   [COORD @D50452, 
      AGR [COUNT @D50451, PER @D50450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : FALL, 
   [COORD @D50454, AGR [COUNT @D50453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : FALL, 
   [COORD @D50456, AGR [COUNT @D50455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : FALL, 
   [COORD @D50460, AGR [COUNT @D50459, PER @D50458, PLU @D50457, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : FALL, 
   [COORD @D50466, PAST @D50465, 
      AGR [CASE @D50464, COUNT @D50463, PER @D50462, PLU @D50461, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : FALL, 
   [COORD @D50469, AGR [COUNT @D50468, PER @D50467, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FALL, 
   [COORD @D50471, AGR [COUNT @D50470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FALL, 
   [COORD @D50473, AGR [COUNT @D50472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FALL, 
   [COORD @D50477, AGR [COUNT @D50476, PER @D50475, PLU @D50474, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : FALL, 
   [COORD @D50483, PAST @D50482, 
      AGR [CASE @D50481, COUNT @D50480, PER @D50479, PLU @D50478, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   FALL, 
   [COORD @D50486, AGR [COUNT @D50485, PER @D50484, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : FALL, 
   [COORD @D50488, AGR [COUNT @D50487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : FALL, 
   [COORD @D50490, AGR [COUNT @D50489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : FALL, 
   [COORD @D50494, AGR [COUNT @D50493, PER @D50492, PLU @D50491, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, ARITY 1] : FALL, 
   [COORD @D50500, PAST @D50499, 
      AGR [CASE @D50498, COUNT @D50497, PER @D50496, PLU @D50495, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TO, 
      ARITY 1] : FALL, 
   [COORD @D50503, AGR [COUNT @D50502, PER @D50501, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : FALL, 
   [COORD @D50505, AGR [COUNT @D50504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : FALL, 
   [COORD @D50507, AGR [COUNT @D50506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : FALL, 
   [COORD @D50511, AGR [COUNT @D50510, PER @D50509, PLU @D50508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : FALL, 
   [COORD @D50517, PAST @D50516, 
      AGR [CASE @D50515, COUNT @D50514, PER @D50513, PLU @D50512, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT THROUGH, 
      ARITY 1] : FALL, 
   [COORD @D50520, AGR [COUNT @D50519, PER @D50518, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : FALL, 
   [COORD @D50522, AGR [COUNT @D50521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : FALL, 
   [COORD @D50524, AGR [COUNT @D50523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : FALL, 
   [COORD @D50528, AGR [COUNT @D50527, PER @D50526, PLU @D50525, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : FALL, 
   [COORD @D50534, PAST @D50533, 
      AGR [CASE @D50532, COUNT @D50531, PER @D50530, PLU @D50529, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : FALL, 
   [COORD @D50537, AGR [COUNT @D50536, PER @D50535, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FALL, 
   [COORD @D50539, AGR [COUNT @D50538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FALL, 
   [COORD @D50541, AGR [COUNT @D50540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FALL, 
   [COORD @D50545, AGR [COUNT @D50544, PER @D50543, PLU @D50542, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : FALL, 
   [COORD @D50551, PAST @D50550, 
      AGR [CASE @D50549, COUNT @D50548, PER @D50547, PLU @D50546, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : FALL, 
   [COORD @D50554, AGR [COUNT @D50553, PER @D50552, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : FALL, 
   [COORD @D50556, AGR [COUNT @D50555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : FALL, 
   [COORD @D50558, AGR [COUNT @D50557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : FALL, 
   [COORD @D50562, AGR [COUNT @D50561, PER @D50560, PLU @D50559, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : FALL, 
   [COORD @D50568, PAST @D50567, 
      AGR [CASE @D50566, COUNT @D50565, PER @D50564, PLU @D50563, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : FALL, 
   [COORD @D50571, AGR [COUNT @D50570, PER @D50569, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : FALL, 
   [COORD @D50573, AGR [COUNT @D50572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : FALL, 
   [COORD @D50575, AGR [COUNT @D50574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : FALL, 
   [COORD @D50579, AGR [COUNT @D50578, PER @D50577, PLU @D50576, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : FALL, 
   [COORD @D50585, PAST @D50584, 
      AGR [CASE @D50583, COUNT @D50582, PER @D50581, PLU @D50580, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : FALL, 
   [COORD @D50588, AGR [COUNT @D50587, PER @D50586, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : FALL, 
   [COORD @D50590, AGR [COUNT @D50589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : FALL, 
   [COORD @D50592, AGR [COUNT @D50591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : FALL, 
   [COORD @D50596, AGR [COUNT @D50595, PER @D50594, PLU @D50593, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : FALL, 
   [COORD @D50602, PAST @D50601, 
      AGR [CASE @D50600, COUNT @D50599, PER @D50598, PLU @D50597, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : FALL, 
   [COORD @D50605, AGR [COUNT @D50604, PER @D50603, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BEHIND, ARITY 1] : FALL, 
   [COORD @D50607, AGR [COUNT @D50606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BEHIND, ARITY 1] : FALL, 
   [COORD @D50609, AGR [COUNT @D50608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BEHIND, ARITY 1] : FALL, 
   [COORD @D50613, AGR [COUNT @D50612, PER @D50611, PLU @D50610, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BEHIND, ARITY 1] : FALL, 
   [COORD @D50619, PAST @D50618, 
      AGR [CASE @D50617, COUNT @D50616, PER @D50615, PLU @D50614, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BEHIND, 
      ARITY 1] : FALL, 
   [COORD @D50622, AGR [COUNT @D50621, PER @D50620, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : FALL, 
   [COORD @D50624, AGR [COUNT @D50623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : FALL, 
   [COORD @D50626, AGR [COUNT @D50625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : FALL, 
   [COORD @D50630, AGR [COUNT @D50629, PER @D50628, PLU @D50627, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : FALL, 
   [COORD @D50636, PAST @D50635, 
      AGR [CASE @D50634, COUNT @D50633, PER @D50632, PLU @D50631, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : FALL, 
   [COORD @D50639, AGR [COUNT @D50638, PER @D50637, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : FALL, 
   [COORD @D50641, AGR [COUNT @D50640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : FALL, 
   [COORD @D50643, AGR [COUNT @D50642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : FALL, 
   [COORD @D50647, AGR [COUNT @D50646, PER @D50645, PLU @D50644, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : FALL, 
   [COORD @D50653, PAST @D50652, 
      AGR [CASE @D50651, COUNT @D50650, PER @D50649, PLU @D50648, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, 
      ARITY 1] : FALL, 
   [COORD @D50658, PAST @D50657, AGR [COUNT @D50656, PER @D50655, 
            PLU @D50654, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, REG -, PFORM TO, ARITY 2] : FALL, 
   [COORD @D50663, PAST @D50662, 
      AGR [COUNT @D50661, PER @D50660, PLU @D50659, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT OUT, 
      ARITY 1] : FALL.

WORD falling : 
   [COORD @D50687, PRD @D50686, AGR [CASE @D50685, COUNT @D50684, 
            PER @D50683, PLU @D50682, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50693, PRD @D50692, 
      AGR [CASE @D50691, COUNT @D50690, PER @D50689, PLU @D50688, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FALL, 
   [COORD @D50699, PRD @D50698, AGR [CASE @D50697, COUNT @D50696, 
            PER @D50695, PLU @D50694, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50705, PRD @D50704, 
      AGR [CASE @D50703, COUNT @D50702, PER @D50701, PLU @D50700, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PREP TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FALL, 
   [COORD @D50711, PRD @D50710, AGR [CASE @D50709, COUNT @D50708, 
            PER @D50707, PLU @D50706, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50717, PRD @D50716, 
      AGR [CASE @D50715, COUNT @D50714, PER @D50713, PLU @D50712, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FALL, 
   [COORD @D50723, PRD @D50722, AGR [CASE @D50721, COUNT @D50720, 
            PER @D50719, PLU @D50718, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BEHIND, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50729, PRD @D50728, 
      AGR [CASE @D50727, COUNT @D50726, PER @D50725, PLU @D50724, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50735, PRD @D50734, AGR [CASE @D50733, COUNT @D50732, 
            PER @D50731, PLU @D50730, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT BACK, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50741, PRD @D50740, 
      AGR [CASE @D50739, COUNT @D50738, PER @D50737, PLU @D50736, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FALL, 
   [COORD @D50747, PRD @D50746, AGR [CASE @D50745, COUNT @D50744, 
            PER @D50743, PLU @D50742, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50753, PRD @D50752, 
      AGR [CASE @D50751, COUNT @D50750, PER @D50749, PLU @D50748, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50759, PRD @D50758, AGR [CASE @D50757, COUNT @D50756, 
            PER @D50755, PLU @D50754, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT BACK, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50765, PRD @D50764, 
      AGR [CASE @D50763, COUNT @D50762, PER @D50761, PLU @D50760, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50771, PRD @D50770, AGR [CASE @D50769, COUNT @D50768, 
            PER @D50767, PLU @D50766, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50777, PRD @D50776, 
      AGR [CASE @D50775, COUNT @D50774, PER @D50773, PLU @D50772, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FALL, 
   [COORD @D50783, PRD @D50782, AGR [CASE @D50781, COUNT @D50780, 
            PER @D50779, PLU @D50778, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50789, PRD @D50788, 
      AGR [CASE @D50787, COUNT @D50786, PER @D50785, PLU @D50784, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50795, PRD @D50794, AGR [CASE @D50793, COUNT @D50792, 
            PER @D50791, PLU @D50790, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50801, PRD @D50800, 
      AGR [CASE @D50799, COUNT @D50798, PER @D50797, PLU @D50796, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FALL, 
   [COORD @D50807, PRD @D50806, AGR [CASE @D50805, COUNT @D50804, 
            PER @D50803, PLU @D50802, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50813, PRD @D50812, 
      AGR [CASE @D50811, COUNT @D50810, PER @D50809, PLU @D50808, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FALL, 
   [COORD @D50819, PRD @D50818, AGR [CASE @D50817, COUNT @D50816, 
            PER @D50815, PLU @D50814, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50825, PRD @D50824, 
      AGR [CASE @D50823, COUNT @D50822, PER @D50821, PLU @D50820, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BEHIND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FALL, 
   [COORD @D50831, PRD @D50830, AGR [CASE @D50829, COUNT @D50828, 
            PER @D50827, PLU @D50826, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50837, PRD @D50836, 
      AGR [CASE @D50835, COUNT @D50834, PER @D50833, PLU @D50832, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FALL, 
   [COORD @D50842, PRD @D50841, AGR [COUNT @D50840, PER @D50839, 
            PLU @D50838, NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL, 
   [COORD @D50847, PRD @D50846, 
      AGR [COUNT @D50845, PER @D50844, PLU @D50843, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FALL.

WORD falls : 
   [COORD @D50857, REFL @D50856, PRD @D50855, CASE @D50854, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : FALLS, 
   [COORD @D50862, DEMON @D50861, REFL @D50860, PRD @D50859, 
      CASE @D50858, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FALL, 
   [COORD @D50867, DEMON @D50866, REFL @D50865, PRD @D50864, 
      CASE @D50863, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : FALL, 
   [COORD @D50869, AGR [COUNT @D50868, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50871, 
      AGR [COUNT @D50870, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50873, 
      AGR [COUNT @D50872, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50875, 
      AGR [COUNT @D50874, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50877, 
      AGR [COUNT @D50876, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FALL, 
   [COORD @D50879, AGR [COUNT @D50878, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : FALL, 
   [COORD @D50881, AGR [COUNT @D50880, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BEHIND, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50883, AGR [COUNT @D50882, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50885, AGR [COUNT @D50884, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT BACK, PFORM UPON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : FALL, 
   [COORD @D50887, AGR [COUNT @D50886, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50889, AGR [COUNT @D50888, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50891, AGR [COUNT @D50890, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FALL, 
   [COORD @D50893, AGR [COUNT @D50892, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT BACK, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : FALL, 
   [COORD @D50895, AGR [COUNT @D50894, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FALL, 
   [COORD @D50897, AGR [COUNT @D50896, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50899, 
      AGR [COUNT @D50898, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50901, 
      AGR [COUNT @D50900, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50903, 
      AGR [COUNT @D50902, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FALL, 
   [COORD @D50905, AGR [COUNT @D50904, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50907, 
      AGR [COUNT @D50906, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50909, 
      AGR [COUNT @D50908, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50911, 
      AGR [COUNT @D50910, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50913, 
      AGR [COUNT @D50912, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50915, 
      AGR [COUNT @D50914, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BEHIND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50917, 
      AGR [COUNT @D50916, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50919, 
      AGR [COUNT @D50918, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FALL, 
   [COORD @D50922, 
      AGR [CASE @D50921, COUNT @D50920, N +, V -, BAR 2, NFORM IT, PLU -, 
            PER 3], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FALL, 
   [COORD @D50925, AGR [CASE @D50924, COUNT @D50923, N +, V -, BAR 2, 
            NFORM IT, PLU -, PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FALL.

WORD fan : 
   [COORD @D50942, REFL @D50941, PRD @D50940, CASE @D50939, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FAN, 
   [COORD @D50945, 
      AGR [COUNT @D50944, PER @D50943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : FAN, 
   
   [COORD @D50947, AGR [COUNT @D50946, N +, V -, BAR 2, NFORM NORM, CASE 
            NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, 
      V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FAN, 
   [COORD @D50949, AGR [COUNT @D50948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FAN, 
   [COORD @D50953, AGR [COUNT @D50952, PER @D50951, PLU @D50950, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FAN, 
   [COORD @D50959, PAST @D50958, AGR [CASE @D50957, COUNT @D50956, 
            PER @D50955, PLU @D50954, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FAN, 
   [COORD @D50962, AGR [COUNT @D50961, PER @D50960, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FAN, 
   [COORD @D50964, AGR [COUNT @D50963, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FAN, 
   [COORD @D50966, AGR [COUNT @D50965, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FAN, 
   [COORD @D50970, AGR [COUNT @D50969, PER @D50968, PLU @D50967, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : FAN, 
   [COORD @D50976, PAST @D50975, 
      AGR [CASE @D50974, COUNT @D50973, PER @D50972, PLU @D50971, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : FAN, 
   [COORD @D50979, AGR [COUNT @D50978, PER @D50977, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAN, 
   [COORD @D50981, AGR [COUNT @D50980, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAN, 
   [COORD @D50983, AGR [COUNT @D50982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAN, 
   [COORD @D50987, AGR [COUNT @D50986, PER @D50985, PLU @D50984, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FAN, 
   [COORD @D50993, PAST @D50992, AGR [CASE @D50991, COUNT @D50990, 
            PER @D50989, PLU @D50988, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FAN, 
   [COORD @D50996, AGR [COUNT @D50995, PER @D50994, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FAN, 
   [COORD @D50998, AGR [COUNT @D50997, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FAN, 
   [COORD @D51000, AGR [COUNT @D50999, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FAN, 
   [COORD @D51004, AGR [COUNT @D51003, PER @D51002, PLU @D51001, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FAN, 
   [COORD @D51010, PAST @D51009, 
      AGR [CASE @D51008, COUNT @D51007, PER @D51006, PLU @D51005, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : FAN.

WORD fanned : 
   [COORD @D51019, AGR [CASE @D51018, COUNT @D51017, PER @D51016, 
            PLU @D51015, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FAN, 
   [COORD @D51024, AGR [CASE @D51023, COUNT @D51022, PER @D51021, 
            PLU @D51020, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FAN, 
   [COORD @D51029, AGR [CASE @D51028, COUNT @D51027, PER @D51026, 
            PLU @D51025, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FAN, 
   [COORD @D51034, AGR [CASE @D51033, COUNT @D51032, PER @D51031, 
            PLU @D51030, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FAN, 
   [COORD @D51039, AGR [CASE @D51038, COUNT @D51037, PER @D51036, 
            PLU @D51035, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FAN, 
   [COORD @D51044, AGR [CASE @D51043, COUNT @D51042, PER @D51041, 
            PLU @D51040, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FAN, 
   [COORD @D51049, AGR [CASE @D51048, COUNT @D51047, PER @D51046, 
            PLU @D51045, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FAN, 
   [COORD @D51054, AGR [CASE @D51053, COUNT @D51052, PER @D51051, 
            PLU @D51050, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FAN, 
   [COORD @D51059, AGR [CASE @D51058, COUNT @D51057, PER @D51056, 
            PLU @D51055, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FAN, 
   [COORD @D51064, AGR [CASE @D51063, COUNT @D51062, PER @D51061, 
            PLU @D51060, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FAN.

WORD fanning : 
   [COORD @D51076, PRD @D51075, AGR [CASE @D51074, COUNT @D51073, 
            PER @D51072, PLU @D51071, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FAN, 
   [COORD @D51082, PRD @D51081, AGR 
         [CASE @D51080, COUNT @D51079, PER @D51078, PLU @D51077, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FAN, 
   [COORD @D51088, PRD @D51087, AGR [CASE @D51086, COUNT @D51085, 
            PER @D51084, PLU @D51083, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FAN, 
   [COORD @D51094, PRD @D51093, AGR 
         [CASE @D51092, COUNT @D51091, PER @D51090, PLU @D51089, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FAN.

WORD fans : 
   [COORD @D51103, DEMON @D51102, REFL @D51101, PRD @D51100, CASE 
         @D51099, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FAN, 
   [COORD @D51105, 
      AGR [COUNT @D51104, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAN, 
   [COORD @D51107, 
      AGR [COUNT @D51106, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAN, 
   [COORD @D51109, 
      AGR [COUNT @D51108, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAN, 
   [COORD @D51111, 
      AGR [COUNT @D51110, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FAN.

WORD fear : 
   [COORD @D51118, REFL @D51117, PRD @D51116, CASE @D51115, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FEAR, 
   [COORD @D51123, REFL @D51122, COUNT @D51121, PRD @D51120, 
      CASE @D51119, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FEAR, 
   [COORD @D51127, REFL @D51126, PRD @D51125, CASE @D51124, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN] : FEAR, 
   [COORD @D51130, AGR [COUNT @D51129, PER @D51128, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FEAR, 
   [COORD @D51132, AGR [COUNT @D51131, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FEAR, 
   [COORD @D51134, AGR [COUNT @D51133, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FEAR, 
   [COORD @D51138, AGR [COUNT @D51137, PER @D51136, PLU @D51135, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FEAR, 
   [COORD @D51144, PAST @D51143, AGR [CASE @D51142, COUNT @D51141, 
            PER @D51140, PLU @D51139, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : FEAR, 
   [COORD @D51147, AGR [COUNT @D51146, PER @D51145, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FEAR, 
   [COORD @D51149, AGR [COUNT @D51148, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FEAR, 
   [COORD @D51151, AGR [COUNT @D51150, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FEAR, 
   [COORD @D51155, AGR [COUNT @D51154, PER @D51153, PLU @D51152, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FEAR, 
   [COORD @D51161, PAST @D51160, AGR [CASE @D51159, COUNT @D51158, 
            PER @D51157, PLU @D51156, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : FEAR, 
   [COORD @D51164, AGR [COUNT @D51163, PER @D51162, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEAR, 
   [COORD @D51166, AGR [COUNT @D51165, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEAR, 
   [COORD @D51168, AGR [COUNT @D51167, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEAR, 
   [COORD @D51172, AGR [COUNT @D51171, PER @D51170, PLU @D51169, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FEAR, 
   [COORD @D51178, PAST @D51177, AGR [CASE @D51176, COUNT @D51175, 
            PER @D51174, PLU @D51173, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FEAR, 
   [COORD @D51181, AGR [COUNT @D51180, PER @D51179, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : FEAR, 
   [COORD @D51183, AGR [COUNT @D51182, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : FEAR, 
   [COORD @D51185, AGR [COUNT @D51184, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : FEAR, 
   [COORD @D51189, AGR [COUNT @D51188, PER @D51187, PLU @D51186, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : FEAR, 
   [COORD @D51195, PAST @D51194, 
      AGR [CASE @D51193, COUNT @D51192, PER @D51191, PLU @D51190, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : FEAR, 
   [COORD @D51198, AGR [COUNT @D51197, PER @D51196, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEAR, 
   [COORD @D51200, AGR [COUNT @D51199, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEAR, 
   [COORD @D51202, AGR [COUNT @D51201, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEAR, 
   [COORD @D51206, AGR [COUNT @D51205, PER @D51204, PLU @D51203, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEAR, 
   [COORD @D51212, PAST @D51211, AGR [CASE @D51210, COUNT @D51209, 
            PER @D51208, PLU @D51207, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FEAR.

WORD feared : 
   [COORD @D51222, AGR [CASE @D51221, COUNT @D51220, PER @D51219, 
            PLU @D51218, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51227, AGR [CASE @D51226, COUNT @D51225, PER @D51224, 
            PLU @D51223, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51232, AGR [CASE @D51231, COUNT @D51230, PER @D51229, 
            PLU @D51228, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51237, AGR [CASE @D51236, COUNT @D51235, PER @D51234, 
            PLU @D51233, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51242, AGR [CASE @D51241, COUNT @D51240, PER @D51239, 
            PLU @D51238, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FEAR, 
   [COORD @D51247, AGR [CASE @D51246, COUNT @D51245, PER @D51244, 
            PLU @D51243, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51252, AGR [CASE @D51251, COUNT @D51250, PER @D51249, 
            PLU @D51248, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51257, AGR [CASE @D51256, COUNT @D51255, PER @D51254, 
            PLU @D51253, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51262, AGR [CASE @D51261, COUNT @D51260, PER @D51259, 
            PLU @D51258, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51267, AGR [CASE @D51266, COUNT @D51265, PER @D51264, 
            PLU @D51263, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51272, AGR [CASE @D51271, COUNT @D51270, PER @D51269, 
            PLU @D51268, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FEAR.

WORD fearing : 
   [COORD @D51287, PRD @D51286, AGR [CASE @D51285, COUNT @D51284, 
            PER @D51283, PLU @D51282, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51293, PRD @D51292, 
      AGR [CASE @D51291, COUNT @D51290, PER @D51289, PLU @D51288, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEAR, 
   [COORD @D51299, PRD @D51298, AGR [CASE @D51297, COUNT @D51296, 
            PER @D51295, PLU @D51294, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEAR, 
   [COORD @D51305, PRD @D51304, 
      AGR [CASE @D51303, COUNT @D51302, PER @D51301, PLU @D51300, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FEAR, 
   [COORD @D51311, PRD @D51310, AGR [CASE @D51309, COUNT @D51308, 
            PER @D51307, PLU @D51306, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEAR.

WORD fears : 
   [COORD @D51321, DEMON @D51320, REFL @D51319, PRD @D51318, CASE 
         @D51317, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FEAR, 
   [COORD @D51323, 
      AGR [COUNT @D51322, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEAR, 
   [COORD @D51325, 
      AGR [COUNT @D51324, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEAR, 
   [COORD @D51327, 
      AGR [COUNT @D51326, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEAR, 
   [COORD @D51329, 
      AGR [COUNT @D51328, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEAR, 
   [COORD @D51331, 
      AGR [COUNT @D51330, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEAR.

WORD feature : 
   [COORD @D51340, REFL @D51339, PRD @D51338, CASE @D51337, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FEATURE, 
   [COORD @D51343, 
      AGR [COUNT @D51342, PER @D51341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   FEATURE, 
   [COORD @D51345, AGR [COUNT @D51344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEATURE, 
   [COORD @D51347, AGR [COUNT @D51346, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEATURE, 
   [COORD @D51351, AGR [COUNT @D51350, PER @D51349, PLU @D51348, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FEATURE, 
   [COORD @D51357, PAST @D51356, AGR [CASE @D51355, COUNT @D51354, 
            PER @D51353, PLU @D51352, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FEATURE, 
   [COORD @D51360, AGR [COUNT @D51359, PER @D51358, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEATURE, 
   [COORD @D51362, AGR [COUNT @D51361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEATURE, 
   [COORD @D51364, AGR [COUNT @D51363, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEATURE, 
   [COORD @D51368, AGR [COUNT @D51367, PER @D51366, PLU @D51365, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FEATURE, 
   [COORD @D51374, PAST @D51373, AGR [CASE @D51372, COUNT @D51371, 
            PER @D51370, PLU @D51369, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FEATURE.

WORD featured : 
   [COORD @D51386, AGR [CASE @D51385, COUNT @D51384, PER @D51383, 
            PLU @D51382, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FEATURE, 
   [COORD @D51391, AGR [CASE @D51390, COUNT @D51389, PER @D51388, 
            PLU @D51387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FEATURE, 
   [COORD @D51396, AGR [CASE @D51395, COUNT @D51394, PER @D51393, 
            PLU @D51392, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FEATURE, 
   [COORD @D51401, AGR [CASE @D51400, COUNT @D51399, PER @D51398, 
            PLU @D51397, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FEATURE, 
   [COORD @D51406, AGR [CASE @D51405, COUNT @D51404, PER @D51403, 
            PLU @D51402, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FEATURE.

WORD features : 
   [COORD @D51417, REFL @D51416, PRD @D51415, CASE @D51414, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : FEATURES, 
   [COORD @D51422, DEMON @D51421, REFL @D51420, PRD @D51419, 
      CASE @D51418, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FEATURE, 
   
   [COORD @D51424, AGR [COUNT @D51423, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEATURE, 
   [COORD @D51426, 
      AGR [COUNT @D51425, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEATURE.

WORD featuring : 
   [COORD @D51449, PRD @D51448, AGR [CASE @D51447, COUNT @D51446, 
            PER @D51445, PLU @D51444, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEATURE, 
   [COORD @D51455, PRD @D51454, 
      AGR [CASE @D51453, COUNT @D51452, PER @D51451, PLU @D51450, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEATURE.

WORD fee : 
   [COORD @D51464, AGR [COUNT @D51463, PER @D51462, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEE, 
   [COORD @D51466, AGR [COUNT @D51465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEE, 
   [COORD @D51468, AGR [COUNT @D51467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FEE, 
   [COORD @D51472, AGR [COUNT @D51471, PER @D51470, PLU @D51469, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FEE, 
   [COORD @D51478, PAST @D51477, AGR [CASE @D51476, COUNT @D51475, 
            PER @D51474, PLU @D51473, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FEE.

WORD feed : 
   [COORD @D51486, REFL @D51485, PRD @D51484, CASE @D51483, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FEED, 
   [COORD @D51491, REFL @D51490, COUNT @D51489, PRD @D51488, 
      CASE @D51487, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FEED, 
   [COORD @D51494, 
      AGR [COUNT @D51493, PER @D51492, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   FEED, 
   [COORD @D51496, AGR [COUNT @D51495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : FEED, 
   [COORD @D51498, AGR [COUNT @D51497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : FEED, 
   [COORD @D51502, AGR [COUNT @D51501, PER @D51500, PLU @D51499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : FEED, 
   [COORD @D51508, PAST @D51507, 
      AGR [CASE @D51506, COUNT @D51505, PER @D51504, PLU @D51503, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   FEED, 
   [COORD @D51511, AGR [COUNT @D51510, PER @D51509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FEED, 
   [COORD @D51513, AGR [COUNT @D51512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FEED, 
   [COORD @D51515, AGR [COUNT @D51514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FEED, 
   [COORD @D51519, AGR [COUNT @D51518, PER @D51517, PLU @D51516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : FEED, 
   [COORD @D51525, PAST @D51524, 
      AGR [CASE @D51523, COUNT @D51522, PER @D51521, PLU @D51520, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   FEED, 
   [COORD @D51528, AGR [COUNT @D51527, PER @D51526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : FEED, 
   [COORD @D51530, AGR [COUNT @D51529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : FEED, 
   [COORD @D51532, AGR [COUNT @D51531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : FEED, 
   [COORD @D51536, AGR [COUNT @D51535, PER @D51534, PLU @D51533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : FEED, 
   [COORD @D51542, PAST @D51541, 
      AGR [CASE @D51540, COUNT @D51539, PER @D51538, PLU @D51537, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      ARITY 3] : FEED, 
   [COORD @D51545, AGR [COUNT @D51544, PER @D51543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : FEED, 
   [COORD @D51547, AGR [COUNT @D51546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : FEED, 
   [COORD @D51549, AGR [COUNT @D51548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : FEED, 
   [COORD @D51553, AGR [COUNT @D51552, PER @D51551, PLU @D51550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : FEED, 
   [COORD @D51559, PAST @D51558, 
      AGR [CASE @D51557, COUNT @D51556, PER @D51555, PLU @D51554, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : FEED, 
   [COORD @D51562, AGR [COUNT @D51561, PER @D51560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : FEED, 
   [COORD @D51564, AGR [COUNT @D51563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : FEED, 
   [COORD @D51566, AGR [COUNT @D51565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : FEED, 
   [COORD @D51570, AGR [COUNT @D51569, PER @D51568, PLU @D51567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : FEED, 
   [COORD @D51576, PAST @D51575, 
      AGR [CASE @D51574, COUNT @D51573, PER @D51572, PLU @D51571, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      ARITY 3] : FEED, 
   [COORD @D51579, AGR [COUNT @D51578, PER @D51577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FEED, 
   [COORD @D51581, AGR [COUNT @D51580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FEED, 
   [COORD @D51583, AGR [COUNT @D51582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FEED, 
   [COORD @D51587, AGR [COUNT @D51586, PER @D51585, PLU @D51584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : FEED, 
   [COORD @D51593, PAST @D51592, AGR [CASE @D51591, COUNT @D51590, 
            PER @D51589, PLU @D51588, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : FEED, 
   [COORD @D51596, AGR [COUNT @D51595, PER @D51594, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : FEED, 
   [COORD @D51598, AGR [COUNT @D51597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : FEED, 
   [COORD @D51600, AGR [COUNT @D51599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : FEED, 
   [COORD @D51604, AGR [COUNT @D51603, PER @D51602, PLU @D51601, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : FEED, 
   [COORD @D51610, PAST @D51609, 
      AGR [CASE @D51608, COUNT @D51607, PER @D51606, PLU @D51605, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : FEED, 
   [COORD @D51613, AGR [COUNT @D51612, PER @D51611, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : FEED, 
   [COORD @D51615, AGR [COUNT @D51614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : FEED, 
   [COORD @D51617, AGR [COUNT @D51616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : FEED, 
   [COORD @D51621, AGR [COUNT @D51620, PER @D51619, PLU @D51618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, ARITY 2] : FEED, 
   [COORD @D51627, PAST @D51626, 
      AGR [CASE @D51625, COUNT @D51624, PER @D51623, PLU @D51622, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      ARITY 2] : FEED, 
   [COORD @D51630, AGR [COUNT @D51629, PER @D51628, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FEED, 
   [COORD @D51632, AGR [COUNT @D51631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FEED, 
   [COORD @D51634, AGR [COUNT @D51633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FEED, 
   [COORD @D51638, AGR [COUNT @D51637, PER @D51636, PLU @D51635, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : FEED, 
   [COORD @D51644, PAST @D51643, 
      AGR [CASE @D51642, COUNT @D51641, PER @D51640, PLU @D51639, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   FEED, 
   [COORD @D51647, AGR [COUNT @D51646, PER @D51645, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : FEED, 
   [COORD @D51649, AGR [COUNT @D51648, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : FEED, 
   [COORD @D51651, AGR [COUNT @D51650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : FEED, 
   [COORD @D51655, AGR [COUNT @D51654, PER @D51653, PLU @D51652, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : FEED, 
   [COORD @D51661, PAST @D51660, 
      AGR [CASE @D51659, COUNT @D51658, PER @D51657, PLU @D51656, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : FEED, 
   [COORD @D51664, AGR [COUNT @D51663, PER @D51662, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : FEED, 
   [COORD @D51666, AGR [COUNT @D51665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : FEED, 
   [COORD @D51668, AGR [COUNT @D51667, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : FEED, 
   [COORD @D51672, AGR [COUNT @D51671, PER @D51670, PLU @D51669, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : FEED, 
   [COORD @D51678, PAST @D51677, 
      AGR [CASE @D51676, COUNT @D51675, PER @D51674, PLU @D51673, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : FEED, 
   [COORD @D51683, AGR [CASE @D51682, COUNT @D51681, PER @D51680, 
            PLU @D51679, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FEE, 
   [COORD @D51688, AGR [CASE @D51687, COUNT @D51686, PER @D51685, 
            PLU @D51684, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FEE, 
   [COORD @D51693, AGR [CASE @D51692, COUNT @D51691, PER @D51690, 
            PLU @D51689, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FEE.

WORD feeding : 
   [COORD @D51712, PRD @D51711, AGR [CASE @D51710, COUNT @D51709, 
            PER @D51708, PLU @D51707, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEED, 
   [COORD @D51718, PRD @D51717, 
      AGR [CASE @D51716, COUNT @D51715, PER @D51714, PLU @D51713, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEED, 
   [COORD @D51724, PRD @D51723, AGR [CASE @D51722, COUNT @D51721, 
            PER @D51720, PLU @D51719, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FEED, 
   [COORD @D51730, PRD @D51729, 
      AGR [CASE @D51728, COUNT @D51727, PER @D51726, PLU @D51725, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FEED, 
   [COORD @D51736, PRD @D51735, AGR [CASE @D51734, COUNT @D51733, 
            PER @D51732, PLU @D51731, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FEED, 
   [COORD @D51742, PRD @D51741, 
      AGR [CASE @D51740, COUNT @D51739, PER @D51738, PLU @D51737, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEED, 
   [COORD @D51748, PRD @D51747, AGR [CASE @D51746, COUNT @D51745, 
            PER @D51744, PLU @D51743, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FEED, 
   [COORD @D51754, PRD @D51753, 
      AGR [CASE @D51752, COUNT @D51751, PER @D51750, PLU @D51749, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FEED, 
   [COORD @D51760, PRD @D51759, AGR [CASE @D51758, COUNT @D51757, 
            PER @D51756, PLU @D51755, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEED, 
   [COORD @D51766, PRD @D51765, 
      AGR [CASE @D51764, COUNT @D51763, PER @D51762, PLU @D51761, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FEED, 
   [COORD @D51772, PRD @D51771, AGR [CASE @D51770, COUNT @D51769, 
            PER @D51768, PLU @D51767, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FEED.

WORD feeds : 
   [COORD @D51785, DEMON @D51784, REFL @D51783, PRD @D51782, CASE 
         @D51781, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FEED, 
   [COORD @D51787, 
      AGR [COUNT @D51786, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51789, 
      AGR [COUNT @D51788, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51791, 
      AGR [COUNT @D51790, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FEED, 
   [COORD @D51793, AGR [COUNT @D51792, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FEED, 
   [COORD @D51795, AGR [COUNT @D51794, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51797, 
      AGR [COUNT @D51796, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51799, 
      AGR [COUNT @D51798, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51801, 
      AGR [COUNT @D51800, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51803, 
      AGR [COUNT @D51802, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51805, 
      AGR [COUNT @D51804, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED, 
   [COORD @D51807, 
      AGR [COUNT @D51806, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEED.

WORD feel : 
   [COORD @D51814, AGR [COUNT @D51813, PER @D51812, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : FEEL, 
   [COORD @D51816, AGR [COUNT @D51815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : FEEL, 
   [COORD @D51818, AGR [COUNT @D51817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : FEEL, 
   [COORD @D51822, AGR [COUNT @D51821, PER @D51820, PLU @D51819, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51828, PAST @D51827, AGR [CASE @D51826, COUNT @D51825, 
            PER @D51824, PLU @D51823, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, ARITY 2] : FEEL, 
   [COORD @D51831, AGR [COUNT @D51830, PER @D51829, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51833, AGR [COUNT @D51832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51835, AGR [COUNT @D51834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51839, AGR [COUNT @D51838, PER @D51837, PLU @D51836, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : FEEL, 
   [COORD @D51845, PAST @D51844, 
      AGR [CASE @D51843, COUNT @D51842, PER @D51841, PLU @D51840, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   FEEL, 
   [COORD @D51848, AGR [COUNT @D51847, PER @D51846, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51850, AGR [COUNT @D51849, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51852, AGR [COUNT @D51851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51856, AGR [COUNT @D51855, PER @D51854, PLU @D51853, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, REG -, ARITY 2] : FEEL, 
   [COORD @D51862, PAST @D51861, 
      AGR [CASE @D51860, COUNT @D51859, PER @D51858, PLU @D51857, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, REG -, ARITY 2] : 
   FEEL, 
   [COORD @D51865, AGR [COUNT @D51864, PER @D51863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51867, AGR [COUNT @D51866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51869, AGR [COUNT @D51868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51873, AGR [COUNT @D51872, PER @D51871, PLU @D51870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : FEEL, 
   [COORD @D51879, PAST @D51878, 
      AGR [CASE @D51877, COUNT @D51876, PER @D51875, PLU @D51874, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, ARITY 2] : 
   FEEL, 
   [COORD @D51882, AGR [COUNT @D51881, PER @D51880, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51884, AGR [COUNT @D51883, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51886, AGR [COUNT @D51885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51890, AGR [COUNT @D51889, PER @D51888, PLU @D51887, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, ARITY 2] : FEEL, 
   [COORD @D51896, PAST @D51895, 
      AGR [CASE @D51894, COUNT @D51893, PER @D51892, PLU @D51891, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, REG -, ARITY 2] : 
   FEEL, 
   [COORD @D51899, AGR [COUNT @D51898, PER @D51897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FEEL, 
   [COORD @D51901, AGR [COUNT @D51900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FEEL, 
   [COORD @D51903, AGR [COUNT @D51902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FEEL, 
   [COORD @D51907, AGR [COUNT @D51906, PER @D51905, PLU @D51904, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : FEEL, 
   [COORD @D51913, PAST @D51912, AGR [CASE @D51911, COUNT @D51910, 
            PER @D51909, PLU @D51908, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : FEEL, 
   [COORD @D51916, AGR [COUNT @D51915, PER @D51914, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51918, AGR [COUNT @D51917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51920, AGR [COUNT @D51919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51924, AGR [COUNT @D51923, PER @D51922, PLU @D51921, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51930, PAST @D51929, AGR [CASE @D51928, COUNT @D51927, 
            PER @D51926, PLU @D51925, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51933, 
      AGR [COUNT @D51932, PER @D51931, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ABOUT, 
      PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51935, AGR [COUNT @D51934, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51937, AGR [COUNT @D51936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51941, AGR [COUNT @D51940, PER @D51939, PLU @D51938, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ABOUT, PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51947, PAST @D51946, 
      AGR [CASE @D51945, COUNT @D51944, PER @D51943, PLU @D51942, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ABOUT, 
      PFORM FOR, ARITY 2] : FEEL, 
   [COORD @D51950, AGR [COUNT @D51949, PER @D51948, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : FEEL, 
   [COORD @D51952, AGR [COUNT @D51951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : FEEL, 
   [COORD @D51954, AGR [COUNT @D51953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : FEEL, 
   [COORD @D51958, AGR [COUNT @D51957, PER @D51956, PLU @D51955, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM AFTER, ARITY 2] : FEEL, 
   [COORD @D51964, PAST @D51963, 
      AGR [CASE @D51962, COUNT @D51961, PER @D51960, PLU @D51959, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM AFTER, 
      ARITY 2] : FEEL, 
   [COORD @D51967, AGR [COUNT @D51966, PER @D51965, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : FEEL, 
   [COORD @D51969, AGR [COUNT @D51968, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : FEEL, 
   [COORD @D51971, AGR [COUNT @D51970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : FEEL, 
   [COORD @D51975, AGR [COUNT @D51974, PER @D51973, PLU @D51972, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : FEEL, 
   [COORD @D51981, PAST @D51980, 
      AGR [CASE @D51979, COUNT @D51978, PER @D51977, PLU @D51976, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : FEEL, 
   [COORD @D51984, AGR [COUNT @D51983, PER @D51982, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FEEL, 
   [COORD @D51986, AGR [COUNT @D51985, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FEEL, 
   [COORD @D51988, AGR [COUNT @D51987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FEEL, 
   [COORD @D51992, AGR [COUNT @D51991, PER @D51990, PLU @D51989, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : FEEL, 
   [COORD @D51998, PAST @D51997, 
      AGR [CASE @D51996, COUNT @D51995, PER @D51994, PLU @D51993, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   FEEL, 
   [COORD @D52001, AGR [COUNT @D52000, PER @D51999, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FEEL, 
   [COORD @D52003, AGR [COUNT @D52002, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FEEL, 
   [COORD @D52005, AGR [COUNT @D52004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FEEL, 
   [COORD @D52009, AGR [COUNT @D52008, PER @D52007, PLU @D52006, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : FEEL, 
   [COORD @D52015, PAST @D52014, 
      AGR [CASE @D52013, COUNT @D52012, PER @D52011, PLU @D52010, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : FEEL, 
   [COORD @D52018, AGR [COUNT @D52017, PER @D52016, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : FEEL, 
   [COORD @D52020, AGR [COUNT @D52019, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : FEEL, 
   [COORD @D52022, AGR [COUNT @D52021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : FEEL, 
   [COORD @D52026, AGR [COUNT @D52025, PER @D52024, PLU @D52023, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : FEEL, 
   [COORD @D52032, PAST @D52031, 
      AGR [CASE @D52030, COUNT @D52029, PER @D52028, PLU @D52027, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, 
      ARITY 1] : FEEL.

WORD feeling : 
   [COADV @D52051, COORD @D52050, DEF @D52049, PRD @D52048, AGR 
            [CASE @D52047, COUNT @D52046, PER @D52045, PLU @D52044, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR ATT] : 
   FEELING, 
   [COORD @D52055, REFL @D52054, PRD @D52053, CASE @D52052, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : FEELING, 
   [COORD @D52059, REFL @D52058, PRD @D52057, CASE @D52056, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : FEELING, 
   [COORD @D52063, REFL @D52062, PRD @D52061, CASE @D52060, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FEELING, 
   [COORD @D52068, REFL @D52067, COUNT @D52066, PRD @D52065, 
      CASE @D52064, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FEELING, 
   [COORD @D52072, REFL @D52071, PRD @D52070, CASE @D52069, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : FEELING, 
   [COORD @D52076, REFL @D52075, PRD @D52074, CASE @D52073, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, COUNT +] : FEELING, 
   [COORD @D52080, REFL @D52079, PRD @D52078, CASE @D52077, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FEELING, 
   [COORD @D52086, PRD @D52085, 
      AGR [CASE @D52084, COUNT @D52083, PER @D52082, PLU @D52081, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEEL, 
   [COORD @D52092, PRD @D52091, AGR [CASE @D52090, COUNT @D52089, 
            PER @D52088, PLU @D52087, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEEL, 
   [COORD @D52098, PRD @D52097, 
      AGR [CASE @D52096, COUNT @D52095, PER @D52094, PLU @D52093, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEEL, 
   [COORD @D52104, PRD @D52103, AGR [CASE @D52102, COUNT @D52101, 
            PER @D52100, PLU @D52099, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEEL, 
   [COORD @D52110, PRD @D52109, 
      AGR [CASE @D52108, COUNT @D52107, PER @D52106, PLU @D52105, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEEL, 
   [COORD @D52116, PRD @D52115, AGR [CASE @D52114, COUNT @D52113, 
            PER @D52112, PLU @D52111, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FEEL, 
   [COORD @D52122, PRD @D52121, 
      AGR [CASE @D52120, COUNT @D52119, PER @D52118, PLU @D52117, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FEEL, 
   [COORD @D52128, PRD @D52127, AGR [CASE @D52126, COUNT @D52125, 
            PER @D52124, PLU @D52123, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ABOUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FEEL, 
   [COORD @D52134, PRD @D52133, 
      AGR [CASE @D52132, COUNT @D52131, PER @D52130, PLU @D52129, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FEEL, 
   [COORD @D52140, PRD @D52139, AGR [CASE @D52138, COUNT @D52137, 
            PER @D52136, PLU @D52135, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FEEL, 
   [COORD @D52146, PRD @D52145, 
      AGR [CASE @D52144, COUNT @D52143, PER @D52142, PLU @D52141, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FEEL, 
   [COORD @D52152, PRD @D52151, AGR [CASE @D52150, COUNT @D52149, 
            PER @D52148, PLU @D52147, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FEEL, 
   [COORD @D52158, PRD @D52157, 
      AGR [CASE @D52156, COUNT @D52155, PER @D52154, PLU @D52153, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FEEL.

WORD feelings : 
   [COORD @D52176, REFL @D52175, PRD @D52174, CASE @D52173, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : FEELINGS, 
   [COORD @D52181, DEMON @D52180, REFL @D52179, PRD @D52178, 
      CASE @D52177, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FEELING.

WORD feels : 
   [COORD @D52208, AGR [COUNT @D52207, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52210, 
      AGR [COUNT @D52209, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52212, 
      AGR [COUNT @D52211, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52214, 
      AGR [COUNT @D52213, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52216, 
      AGR [COUNT @D52215, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52218, 
      AGR [COUNT @D52217, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52220, 
      AGR [COUNT @D52219, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52222, 
      AGR [COUNT @D52221, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ABOUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FEEL, 
   [COORD @D52224, AGR [COUNT @D52223, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52226, 
      AGR [COUNT @D52225, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52228, 
      AGR [COUNT @D52227, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52230, 
      AGR [COUNT @D52229, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL, 
   [COORD @D52232, 
      AGR [COUNT @D52231, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEEL.

WORD fees : 
   [COORD @D52238, AGR [COUNT @D52237, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FEE.

WORD felt : 
   [COORD @D52248, REFL @D52247, PRD @D52246, CASE @D52245, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : FELT, 
   [COORD @D52254, PAST @D52253, 
      AGR [CASE @D52252, COUNT @D52251, PER @D52250, PLU @D52249, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, FIN -, ARITY 2] : FEEL, 
   [COORD @D52260, PAST @D52259, 
      AGR [CASE @D52258, COUNT @D52257, PER @D52256, PLU @D52255, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, ARITY 2] : FEEL, 
   [COORD @D52266, PAST @D52265, 
      AGR [CASE @D52264, COUNT @D52263, PER @D52262, PLU @D52261, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, REG -, FIN -, 
      ARITY 2] : FEEL, 
   [COORD @D52272, PAST @D52271, AGR [CASE @D52270, COUNT @D52269, 
            PER @D52268, PLU @D52267, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, REG -, FIN -, ARITY 2] : FEEL, 
   [COORD @D52278, PAST @D52277, 
      AGR [CASE @D52276, COUNT @D52275, PER @D52274, PLU @D52273, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, FIN -, ARITY 2] : FEEL, 
   
   [COORD @D52281, AGR @D52280, PAST @D52279, VFORM EN, SUBCAT OC_INF, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : FEEL, 
   [COORD @D52287, PAST @D52286, AGR [CASE @D52285, COUNT @D52284, 
            PER @D52283, PLU @D52282, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 2] : FEEL, 
   [COORD @D52293, PAST @D52292, 
      AGR [CASE @D52291, COUNT @D52290, PER @D52289, PLU @D52288, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : FEEL, 
   [COORD @D52299, PAST @D52298, AGR [CASE @D52297, COUNT @D52296, 
            PER @D52295, PLU @D52294, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : FEEL, 
   [COORD @D52305, PAST @D52304, 
      AGR [CASE @D52303, COUNT @D52302, PER @D52301, PLU @D52300, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM FOR, FIN -, 
      ARITY 2] : FEEL, 
   [COORD @D52311, PAST @D52310, AGR [CASE @D52309, COUNT @D52308, 
            PER @D52307, PLU @D52306, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM FOR, FIN -, ARITY 2] : FEEL, 
   [COORD @D52317, PAST @D52316, 
      AGR [CASE @D52315, COUNT @D52314, PER @D52313, PLU @D52312, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ABOUT, PFORM FOR, 
      FIN -, ARITY 2] : FEEL, 
   [COORD @D52323, PAST @D52322, AGR [CASE @D52321, COUNT @D52320, 
            PER @D52319, PLU @D52318, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM AFTER, FIN -, ARITY 2] : FEEL, 
   [COORD @D52329, PAST @D52328, 
      AGR [CASE @D52327, COUNT @D52326, PER @D52325, PLU @D52324, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : FEEL, 
   [COORD @D52335, PAST @D52334, AGR [CASE @D52333, COUNT @D52332, 
            PER @D52331, PLU @D52330, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : FEEL, 
   [COORD @D52339, 
      AGR [COUNT @D52338, PER @D52337, PLU @D52336, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, PAST +, 
      ARITY 2] : FEEL, 
   [COORD @D52343, AGR [COUNT @D52342, PER @D52341, PLU @D52340, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : FEEL, 
   [COORD @D52347, AGR [COUNT @D52346, PER @D52345, PLU @D52344, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, 
      REG -, PAST +, ARITY 2] : FEEL, 
   [COORD @D52351, AGR [COUNT @D52350, PER @D52349, PLU @D52348, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PAST +, ARITY 2] : FEEL, 
   [COORD @D52355, AGR [COUNT @D52354, PER @D52353, PLU @D52352, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PAST +, ARITY 2] : FEEL, 
   [COORD @D52359, AGR [COUNT @D52358, PER @D52357, PLU @D52356, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : FEEL, 
   [COORD @D52363, AGR [COUNT @D52362, PER @D52361, PLU @D52360, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : FEEL, 
   [COORD @D52367, AGR [COUNT @D52366, PER @D52365, PLU @D52364, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM FOR, PAST +, ARITY 2] : FEEL, 
   [COORD @D52371, AGR [COUNT @D52370, PER @D52369, PLU @D52368, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AFTER, PAST +, ARITY 2] : FEEL, 
   [COORD @D52375, AGR [COUNT @D52374, PER @D52373, PLU @D52372, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : FEEL, 
   [COORD @D52381, PAST @D52380, AGR [CASE @D52379, COUNT @D52378, 
            PER @D52377, PLU @D52376, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : FEEL, 
   [COORD @D52387, PAST @D52386, 
      AGR [CASE @D52385, COUNT @D52384, PER @D52383, PLU @D52382, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : FEEL, 
   [COORD @D52393, PAST @D52392, AGR [CASE @D52391, COUNT @D52390, 
            PER @D52389, PLU @D52388, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, FIN -, ARITY 1] : FEEL, 
   [COORD @D52397, 
      AGR [COUNT @D52396, PER @D52395, PLU @D52394, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : FEEL, 
   [COORD @D52401, AGR [COUNT @D52400, PER @D52399, PLU @D52398, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : FEEL, 
   [COORD @D52405, AGR [COUNT @D52404, PER @D52403, PLU @D52402, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, PAST +, ARITY 1] : FEEL.

WORD fight : 
   [COORD @D52427, REFL @D52426, COUNT @D52425, PRD @D52424, CASE 
         @D52423, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FIGHT, 
   [COORD @D52430, 
      AGR [COUNT @D52429, PER @D52428, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : 
   FIGHT, 
   [COORD @D52432, AGR [COUNT @D52431, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FIGHT, 
   [COORD @D52434, AGR [COUNT @D52433, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FIGHT, 
   [COORD @D52438, AGR [COUNT @D52437, PER @D52436, PLU @D52435, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : FIGHT, 
   [COORD @D52444, PAST @D52443, AGR [CASE @D52442, COUNT @D52441, 
            PER @D52440, PLU @D52439, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : FIGHT, 
   [COORD @D52447, AGR [COUNT @D52446, PER @D52445, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OUT, ARITY 2] : FIGHT, 
   [COORD @D52449, AGR [COUNT @D52448, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OUT, ARITY 2] : FIGHT, 
   [COORD @D52451, AGR [COUNT @D52450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OUT, ARITY 2] : FIGHT, 
   [COORD @D52455, AGR [COUNT @D52454, PER @D52453, PLU @D52452, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT OUT, ARITY 2] : FIGHT, 
   [COORD @D52461, PAST @D52460, AGR [CASE @D52459, COUNT @D52458, 
            PER @D52457, PLU @D52456, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, ARITY 2] : FIGHT, 
   [COORD @D52464, 
      AGR [COUNT @D52463, PER @D52462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : FIGHT, 
   [COORD @D52466, AGR [COUNT @D52465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : FIGHT, 
   [COORD @D52468, AGR [COUNT @D52467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : FIGHT, 
   [COORD @D52472, AGR [COUNT @D52471, PER @D52470, PLU @D52469, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : FIGHT, 
   [COORD @D52478, PAST @D52477, 
      AGR [CASE @D52476, COUNT @D52475, PER @D52474, PLU @D52473, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : FIGHT, 
   [COORD @D52481, AGR [COUNT @D52480, PER @D52479, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : FIGHT, 
   [COORD @D52483, AGR [COUNT @D52482, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : FIGHT, 
   [COORD @D52485, AGR [COUNT @D52484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : FIGHT, 
   [COORD @D52489, AGR [COUNT @D52488, PER @D52487, PLU @D52486, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM OVER, ARITY 2] : FIGHT, 
   [COORD @D52495, PAST @D52494, 
      AGR [CASE @D52493, COUNT @D52492, PER @D52491, PLU @D52490, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM OVER, 
      ARITY 2] : FIGHT, 
   [COORD @D52498, AGR [COUNT @D52497, PER @D52496, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : FIGHT, 
   [COORD @D52500, AGR [COUNT @D52499, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : FIGHT, 
   [COORD @D52502, AGR [COUNT @D52501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : FIGHT, 
   [COORD @D52506, AGR [COUNT @D52505, PER @D52504, PLU @D52503, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM AGAINST, ARITY 2] : FIGHT, 
   [COORD @D52512, PAST @D52511, 
      AGR [CASE @D52510, COUNT @D52509, PER @D52508, PLU @D52507, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM AGAINST, 
      ARITY 2] : FIGHT, 
   [COORD @D52515, AGR [COUNT @D52514, PER @D52513, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : FIGHT, 
   [COORD @D52517, AGR [COUNT @D52516, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : FIGHT, 
   [COORD @D52519, AGR [COUNT @D52518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : FIGHT, 
   [COORD @D52523, AGR [COUNT @D52522, PER @D52521, PLU @D52520, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : FIGHT, 
   [COORD @D52529, PAST @D52528, 
      AGR [CASE @D52527, COUNT @D52526, PER @D52525, PLU @D52524, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : FIGHT, 
   [COORD @D52532, AGR [COUNT @D52531, PER @D52530, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FIGHT, 
   [COORD @D52534, AGR [COUNT @D52533, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FIGHT, 
   [COORD @D52536, AGR [COUNT @D52535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FIGHT, 
   [COORD @D52540, AGR [COUNT @D52539, PER @D52538, PLU @D52537, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : FIGHT, 
   [COORD @D52546, PAST @D52545, 
      AGR [CASE @D52544, COUNT @D52543, PER @D52542, PLU @D52541, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   FIGHT, 
   [COORD @D52549, AGR [COUNT @D52548, PER @D52547, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FIGHT, 
   [COORD @D52551, AGR [COUNT @D52550, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FIGHT, 
   [COORD @D52553, AGR [COUNT @D52552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FIGHT, 
   [COORD @D52557, AGR [COUNT @D52556, PER @D52555, PLU @D52554, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : FIGHT, 
   [COORD @D52563, PAST @D52562, 
      AGR [CASE @D52561, COUNT @D52560, PER @D52559, PLU @D52558, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : FIGHT, 
   [COORD @D52566, AGR [COUNT @D52565, PER @D52564, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : FIGHT, 
   [COORD @D52568, AGR [COUNT @D52567, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : FIGHT, 
   [COORD @D52570, AGR [COUNT @D52569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : FIGHT, 
   [COORD @D52574, AGR [COUNT @D52573, PER @D52572, PLU @D52571, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : FIGHT, 
   [COORD @D52580, PAST @D52579, 
      AGR [CASE @D52578, COUNT @D52577, PER @D52576, PLU @D52575, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : FIGHT, 
   [COORD @D52583, AGR [COUNT @D52582, PER @D52581, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : FIGHT, 
   [COORD @D52585, AGR [COUNT @D52584, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : FIGHT, 
   [COORD @D52587, AGR [COUNT @D52586, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : FIGHT, 
   [COORD @D52591, AGR [COUNT @D52590, PER @D52589, PLU @D52588, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : FIGHT, 
   [COORD @D52597, PAST @D52596, 
      AGR [CASE @D52595, COUNT @D52594, PER @D52593, PLU @D52592, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : FIGHT, 
   [COORD @D52600, AGR [COUNT @D52599, PER @D52598, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : FIGHT, 
   [COORD @D52602, AGR [COUNT @D52601, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : FIGHT, 
   [COORD @D52604, AGR [COUNT @D52603, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : FIGHT, 
   [COORD @D52608, AGR [COUNT @D52607, PER @D52606, PLU @D52605, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : FIGHT, 
   [COORD @D52614, PAST @D52613, 
      AGR [CASE @D52612, COUNT @D52611, PER @D52610, PLU @D52609, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : FIGHT.

WORD fighting : 
   [COORD @D52632, PRD @D52631, AGR [CASE @D52630, COUNT @D52629, 
            PER @D52628, PLU @D52627, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52638, PRD @D52637, 
      AGR [CASE @D52636, COUNT @D52635, PER @D52634, PLU @D52633, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGHT, 
   [COORD @D52644, PRD @D52643, AGR [CASE @D52642, COUNT @D52641, 
            PER @D52640, PLU @D52639, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52650, PRD @D52649, 
      AGR [CASE @D52648, COUNT @D52647, PER @D52646, PLU @D52645, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGHT, 
   [COORD @D52656, PRD @D52655, AGR [CASE @D52654, COUNT @D52653, 
            PER @D52652, PLU @D52651, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52662, PRD @D52661, 
      AGR [CASE @D52660, COUNT @D52659, PER @D52658, PLU @D52657, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGHT, 
   [COORD @D52668, PRD @D52667, AGR [CASE @D52666, COUNT @D52665, 
            PER @D52664, PLU @D52663, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52674, PRD @D52673, 
      AGR [CASE @D52672, COUNT @D52671, PER @D52670, PLU @D52669, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGHT, 
   [COORD @D52680, PRD @D52679, AGR [CASE @D52678, COUNT @D52677, 
            PER @D52676, PLU @D52675, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52686, PRD @D52685, 
      AGR [CASE @D52684, COUNT @D52683, PER @D52682, PLU @D52681, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGHT, 
   [COORD @D52692, PRD @D52691, AGR [CASE @D52690, COUNT @D52689, 
            PER @D52688, PLU @D52687, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGHT.

WORD fights : 
   [COORD @D52701, DEMON @D52700, REFL @D52699, PRD @D52698, CASE 
         @D52697, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FIGHT, 
   [COORD @D52703, 
      AGR [COUNT @D52702, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52705, 
      AGR [COUNT @D52704, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52707, 
      AGR [COUNT @D52706, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52709, 
      AGR [COUNT @D52708, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52711, 
      AGR [COUNT @D52710, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FIGHT, 
   [COORD @D52713, AGR [COUNT @D52712, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52715, 
      AGR [COUNT @D52714, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52717, 
      AGR [COUNT @D52716, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52719, 
      AGR [COUNT @D52718, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52721, 
      AGR [COUNT @D52720, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT, 
   [COORD @D52723, 
      AGR [COUNT @D52722, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGHT.

WORD figure : 
   [COORD @D52731, REFL @D52730, PRD @D52729, CASE @D52728, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : FIGURE, 
   [COORD @D52735, REFL @D52734, PRD @D52733, CASE @D52732, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FIGURE, 
   [COORD @D52738, 
      AGR [COUNT @D52737, PER @D52736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   FIGURE, 
   [COORD @D52740, AGR [COUNT @D52739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : FIGURE, 
   [COORD @D52742, AGR [COUNT @D52741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : FIGURE, 
   [COORD @D52746, AGR [COUNT @D52745, PER @D52744, PLU @D52743, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : FIGURE, 
   [COORD @D52752, PAST @D52751, AGR [CASE @D52750, COUNT @D52749, 
            PER @D52748, PLU @D52747, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : FIGURE, 
   [COORD @D52755, AGR [COUNT @D52754, PER @D52753, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52757, AGR [COUNT @D52756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52759, AGR [COUNT @D52758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52763, AGR [COUNT @D52762, PER @D52761, PLU @D52760, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52769, PAST @D52768, 
      AGR [CASE @D52767, COUNT @D52766, PER @D52765, PLU @D52764, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, PRT OUT, 
      ARITY 2] : FIGURE, 
   [COORD @D52772, AGR [COUNT @D52771, PER @D52770, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52774, AGR [COUNT @D52773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52776, AGR [COUNT @D52775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52780, AGR [COUNT @D52779, PER @D52778, PLU @D52777, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52786, PAST @D52785, 
      AGR [CASE @D52784, COUNT @D52783, PER @D52782, PLU @D52781, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, PRT OUT, 
      ARITY 2] : FIGURE, 
   [COORD @D52789, AGR [COUNT @D52788, PER @D52787, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52791, AGR [COUNT @D52790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52793, AGR [COUNT @D52792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52797, AGR [COUNT @D52796, PER @D52795, PLU @D52794, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52803, PAST @D52802, 
      AGR [CASE @D52801, COUNT @D52800, PER @D52799, PLU @D52798, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52806, AGR [COUNT @D52805, PER @D52804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52808, AGR [COUNT @D52807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52810, AGR [COUNT @D52809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52814, AGR [COUNT @D52813, PER @D52812, PLU @D52811, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52820, PAST @D52819, 
      AGR [CASE @D52818, COUNT @D52817, PER @D52816, PLU @D52815, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, PRT ON, 
      ARITY 2] : FIGURE, 
   [COORD @D52823, AGR [COUNT @D52822, PER @D52821, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52825, AGR [COUNT @D52824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52827, AGR [COUNT @D52826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52831, AGR [COUNT @D52830, PER @D52829, PLU @D52828, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT ON, ARITY 2] : FIGURE, 
   [COORD @D52837, PAST @D52836, 
      AGR [CASE @D52835, COUNT @D52834, PER @D52833, PLU @D52832, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT ON, 
      ARITY 2] : FIGURE, 
   [COORD @D52840, AGR [COUNT @D52839, PER @D52838, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : FIGURE, 
   [COORD @D52842, AGR [COUNT @D52841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : FIGURE, 
   [COORD @D52844, AGR [COUNT @D52843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : FIGURE, 
   [COORD @D52848, AGR [COUNT @D52847, PER @D52846, PLU @D52845, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : FIGURE, 
   [COORD @D52854, PAST @D52853, 
      AGR [CASE @D52852, COUNT @D52851, PER @D52850, PLU @D52849, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      ARITY 2] : FIGURE, 
   [COORD @D52857, AGR [COUNT @D52856, PER @D52855, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : FIGURE, 
   [COORD @D52859, AGR [COUNT @D52858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : FIGURE, 
   [COORD @D52861, AGR [COUNT @D52860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : FIGURE, 
   [COORD @D52865, AGR [COUNT @D52864, PER @D52863, PLU @D52862, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AS, ARITY 2] : FIGURE, 
   [COORD @D52871, PAST @D52870, 
      AGR [CASE @D52869, COUNT @D52868, PER @D52867, PLU @D52866, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AS, 
      ARITY 2] : FIGURE, 
   [COORD @D52874, AGR [COUNT @D52873, PER @D52872, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52876, AGR [COUNT @D52875, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52878, AGR [COUNT @D52877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52882, AGR [COUNT @D52881, PER @D52880, PLU @D52879, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : FIGURE, 
   [COORD @D52888, PAST @D52887, 
      AGR [CASE @D52886, COUNT @D52885, PER @D52884, PLU @D52883, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : FIGURE, 
   [COORD @D52891, AGR [COUNT @D52890, PER @D52889, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FIGURE, 
   [COORD @D52893, AGR [COUNT @D52892, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FIGURE, 
   [COORD @D52895, AGR [COUNT @D52894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FIGURE, 
   [COORD @D52899, AGR [COUNT @D52898, PER @D52897, PLU @D52896, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : FIGURE, 
   [COORD @D52905, PAST @D52904, 
      AGR [CASE @D52903, COUNT @D52902, PER @D52901, PLU @D52900, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : FIGURE, 
   [COORD @D52908, AGR [COUNT @D52907, PER @D52906, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIGURE, 
   [COORD @D52910, AGR [COUNT @D52909, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIGURE, 
   [COORD @D52912, AGR [COUNT @D52911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIGURE, 
   [COORD @D52916, AGR [COUNT @D52915, PER @D52914, PLU @D52913, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIGURE, 
   [COORD @D52922, PAST @D52921, AGR [CASE @D52920, COUNT @D52919, 
            PER @D52918, PLU @D52917, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FIGURE, 
   [COORD @D52925, AGR [COUNT @D52924, PER @D52923, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIGURE, 
   [COORD @D52927, AGR [COUNT @D52926, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIGURE, 
   [COORD @D52929, AGR [COUNT @D52928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIGURE, 
   [COORD @D52933, AGR [COUNT @D52932, PER @D52931, PLU @D52930, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIGURE, 
   [COORD @D52939, PAST @D52938, 
      AGR [CASE @D52937, COUNT @D52936, PER @D52935, PLU @D52934, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : FIGURE, 
   [COORD @D52942, AGR [COUNT @D52941, PER @D52940, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIGURE, 
   [COORD @D52944, AGR [COUNT @D52943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIGURE, 
   [COORD @D52946, AGR [COUNT @D52945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIGURE, 
   [COORD @D52950, AGR [COUNT @D52949, PER @D52948, PLU @D52947, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIGURE, 
   [COORD @D52956, PAST @D52955, 
      AGR [CASE @D52954, COUNT @D52953, PER @D52952, PLU @D52951, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : FIGURE, 
   [COORD @D52959, AGR [COUNT @D52958, PER @D52957, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIGURE, 
   [COORD @D52961, AGR [COUNT @D52960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIGURE, 
   [COORD @D52963, AGR [COUNT @D52962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIGURE, 
   [COORD @D52967, AGR [COUNT @D52966, PER @D52965, PLU @D52964, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIGURE, 
   [COORD @D52973, PAST @D52972, 
      AGR [CASE @D52971, COUNT @D52970, PER @D52969, PLU @D52968, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : FIGURE.

WORD figured : 
   [COORD @D52984, AGR [CASE @D52983, COUNT @D52982, PER @D52981, 
            PLU @D52980, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D52989, AGR [CASE @D52988, COUNT @D52987, PER @D52986, 
            PLU @D52985, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D52994, AGR [UB @D52993, VFORM @D52992, SUBJ @D52991, 
            FIN @D52990, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FIGURE, 
   [COORD @D52999, AGR [CASE @D52998, COUNT @D52997, PER @D52996, 
            PLU @D52995, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53004, AGR [CASE @D53003, COUNT @D53002, PER @D53001, 
            PLU @D53000, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53009, AGR [CASE @D53008, COUNT @D53007, PER @D53006, 
            PLU @D53005, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53014, AGR [CASE @D53013, COUNT @D53012, PER @D53011, 
            PLU @D53010, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53019, AGR [CASE @D53018, COUNT @D53017, PER @D53016, 
            PLU @D53015, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53024, AGR [CASE @D53023, COUNT @D53022, PER @D53021, 
            PLU @D53020, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53029, AGR [CASE @D53028, COUNT @D53027, PER @D53026, 
            PLU @D53025, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53034, AGR [CASE @D53033, COUNT @D53032, PER @D53031, 
            PLU @D53030, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53039, AGR [CASE @D53038, COUNT @D53037, PER @D53036, 
            PLU @D53035, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53044, AGR [CASE @D53043, COUNT @D53042, PER @D53041, 
            PLU @D53040, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53049, AGR [CASE @D53048, COUNT @D53047, PER @D53046, 
            PLU @D53045, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53054, AGR [CASE @D53053, COUNT @D53052, PER @D53051, 
            PLU @D53050, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53059, AGR [CASE @D53058, COUNT @D53057, PER @D53056, 
            PLU @D53055, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53064, AGR [CASE @D53063, COUNT @D53062, PER @D53061, 
            PLU @D53060, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53069, AGR [CASE @D53068, COUNT @D53067, PER @D53066, 
            PLU @D53065, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53074, AGR [CASE @D53073, COUNT @D53072, PER @D53071, 
            PLU @D53070, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53079, AGR [CASE @D53078, COUNT @D53077, PER @D53076, 
            PLU @D53075, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53084, AGR [CASE @D53083, COUNT @D53082, PER @D53081, 
            PLU @D53080, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53089, AGR [CASE @D53088, COUNT @D53087, PER @D53086, 
            PLU @D53085, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53094, AGR [CASE @D53093, COUNT @D53092, PER @D53091, 
            PLU @D53090, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53099, AGR [CASE @D53098, COUNT @D53097, PER @D53096, 
            PLU @D53095, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53104, AGR [CASE @D53103, COUNT @D53102, PER @D53101, 
            PLU @D53100, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53109, AGR [CASE @D53108, COUNT @D53107, PER @D53106, 
            PLU @D53105, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53114, AGR [CASE @D53113, COUNT @D53112, PER @D53111, 
            PLU @D53110, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53119, AGR [CASE @D53118, COUNT @D53117, PER @D53116, 
            PLU @D53115, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53124, AGR [CASE @D53123, COUNT @D53122, PER @D53121, 
            PLU @D53120, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53129, AGR [CASE @D53128, COUNT @D53127, PER @D53126, 
            PLU @D53125, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53134, AGR [CASE @D53133, COUNT @D53132, PER @D53131, 
            PLU @D53130, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53139, AGR [CASE @D53138, COUNT @D53137, PER @D53136, 
            PLU @D53135, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53144, AGR [CASE @D53143, COUNT @D53142, PER @D53141, 
            PLU @D53140, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIGURE.

WORD figures : 
   [COORD @D53154, REFL @D53153, PRD @D53152, CASE @D53151, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : FIGURES, 
   [COORD @D53159, DEMON @D53158, REFL @D53157, PRD @D53156, 
      CASE @D53155, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FIGURE, 
   [COORD @D53164, DEMON @D53163, REFL @D53162, PRD @D53161, 
      CASE @D53160, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FIGURE, 
   [COORD @D53166, 
      AGR [COUNT @D53165, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53168, 
      AGR [COUNT @D53167, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53170, 
      AGR [COUNT @D53169, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53172, 
      AGR [COUNT @D53171, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53174, 
      AGR [COUNT @D53173, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53176, 
      AGR [COUNT @D53175, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53178, 
      AGR [COUNT @D53177, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53180, 
      AGR [COUNT @D53179, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53182, 
      AGR [COUNT @D53181, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53184, 
      AGR [COUNT @D53183, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53186, 
      AGR [COUNT @D53185, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53188, 
      AGR [COUNT @D53187, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53190, 
      AGR [COUNT @D53189, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53192, 
      AGR [COUNT @D53191, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIGURE.

WORD figuring : 
   [COORD @D53213, PRD @D53212, AGR [CASE @D53211, COUNT @D53210, 
            PER @D53209, PLU @D53208, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53219, PRD @D53218, 
      AGR [CASE @D53217, COUNT @D53216, PER @D53215, PLU @D53214, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGURE, 
   [COORD @D53225, PRD @D53224, AGR [CASE @D53223, COUNT @D53222, 
            PER @D53221, PLU @D53220, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53231, PRD @D53230, 
      AGR [CASE @D53229, COUNT @D53228, PER @D53227, PLU @D53226, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGURE, 
   [COORD @D53237, PRD @D53236, AGR [CASE @D53235, COUNT @D53234, 
            PER @D53233, PLU @D53232, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53243, PRD @D53242, 
      AGR [CASE @D53241, COUNT @D53240, PER @D53239, PLU @D53238, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGURE, 
   [COORD @D53249, PRD @D53248, AGR [CASE @D53247, COUNT @D53246, 
            PER @D53245, PLU @D53244, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53255, PRD @D53254, 
      AGR [CASE @D53253, COUNT @D53252, PER @D53251, PLU @D53250, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGURE, 
   [COORD @D53261, PRD @D53260, AGR [CASE @D53259, COUNT @D53258, 
            PER @D53257, PLU @D53256, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53267, PRD @D53266, 
      AGR [CASE @D53265, COUNT @D53264, PER @D53263, PLU @D53262, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGURE, 
   [COORD @D53273, PRD @D53272, AGR [CASE @D53271, COUNT @D53270, 
            PER @D53269, PLU @D53268, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53279, PRD @D53278, 
      AGR [CASE @D53277, COUNT @D53276, PER @D53275, PLU @D53274, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGURE, 
   [COORD @D53285, PRD @D53284, AGR [CASE @D53283, COUNT @D53282, 
            PER @D53281, PLU @D53280, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIGURE, 
   [COORD @D53291, PRD @D53290, 
      AGR [CASE @D53289, COUNT @D53288, PER @D53287, PLU @D53286, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIGURE.

WORD file : 
   [COORD @D53300, REFL @D53299, COUNT @D53298, PRD @D53297, CASE 
         @D53296, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FILE, 
   [COORD @D53304, REFL @D53303, PRD @D53302, CASE @D53301, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : FILE, 
   [COORD @D53307, 
      AGR [COUNT @D53306, PER @D53305, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, ARITY 3] : 
   FILE, 
   [COORD @D53309, AGR [COUNT @D53308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : FILE, 
   [COORD @D53311, AGR [COUNT @D53310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : FILE, 
   [COORD @D53315, AGR [COUNT @D53314, PER @D53313, PLU @D53312, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : FILE, 
   [COORD @D53321, PAST @D53320, AGR [CASE @D53319, COUNT @D53318, 
            PER @D53317, PLU @D53316, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_ADL, ARITY 3] : FILE, 
   [COORD @D53324, AGR [COUNT @D53323, PER @D53322, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AWAY, ARITY 3] : FILE, 
   [COORD @D53326, AGR [COUNT @D53325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AWAY, ARITY 3] : FILE, 
   [COORD @D53328, AGR [COUNT @D53327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AWAY, ARITY 3] : FILE, 
   [COORD @D53332, AGR [COUNT @D53331, PER @D53330, PLU @D53329, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AWAY, ARITY 3] : FILE, 
   [COORD @D53338, PAST @D53337, 
      AGR [CASE @D53336, COUNT @D53335, PER @D53334, PLU @D53333, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AWAY, 
      ARITY 3] : FILE, 
   [COORD @D53341, AGR [COUNT @D53340, PER @D53339, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILE, 
   [COORD @D53343, AGR [COUNT @D53342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILE, 
   [COORD @D53345, AGR [COUNT @D53344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILE, 
   [COORD @D53349, AGR [COUNT @D53348, PER @D53347, PLU @D53346, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FILE, 
   [COORD @D53355, PAST @D53354, AGR [CASE @D53353, COUNT @D53352, 
            PER @D53351, PLU @D53350, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FILE, 
   [COORD @D53358, AGR [COUNT @D53357, PER @D53356, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FILE, 
   [COORD @D53360, AGR [COUNT @D53359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FILE, 
   [COORD @D53362, AGR [COUNT @D53361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FILE, 
   [COORD @D53366, AGR [COUNT @D53365, PER @D53364, PLU @D53363, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : FILE, 
   [COORD @D53372, PAST @D53371, AGR [CASE @D53370, COUNT @D53369, 
            PER @D53368, PLU @D53367, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : FILE, 
   [COORD @D53375, AGR [COUNT @D53374, PER @D53373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : FILE, 
   [COORD @D53377, AGR [COUNT @D53376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : FILE, 
   [COORD @D53379, AGR [COUNT @D53378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : FILE, 
   [COORD @D53383, AGR [COUNT @D53382, PER @D53381, PLU @D53380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : FILE, 
   [COORD @D53389, PAST @D53388, 
      AGR [CASE @D53387, COUNT @D53386, PER @D53385, PLU @D53384, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : FILE, 
   [COORD @D53392, AGR [COUNT @D53391, PER @D53390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : FILE, 
   [COORD @D53394, AGR [COUNT @D53393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : FILE, 
   [COORD @D53396, AGR [COUNT @D53395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : FILE, 
   [COORD @D53400, AGR [COUNT @D53399, PER @D53398, PLU @D53397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : FILE, 
   [COORD @D53406, PAST @D53405, 
      AGR [CASE @D53404, COUNT @D53403, PER @D53402, PLU @D53401, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : FILE.

WORD filed : 
   [COORD @D53417, AGR [CASE @D53416, COUNT @D53415, PER @D53414, 
            PLU @D53413, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADL, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FILE, 
   [COORD @D53422, AGR [CASE @D53421, COUNT @D53420, PER @D53419, 
            PLU @D53418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53427, AGR [CASE @D53426, COUNT @D53425, PER @D53424, 
            PLU @D53423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILE, 
   [COORD @D53432, AGR [CASE @D53431, COUNT @D53430, PER @D53429, 
            PLU @D53428, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AWAY, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53437, AGR [CASE @D53436, COUNT @D53435, PER @D53434, 
            PLU @D53433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AWAY, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53442, AGR [CASE @D53441, COUNT @D53440, PER @D53439, 
            PLU @D53438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AWAY, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FILE, 
   [COORD @D53447, AGR [CASE @D53446, COUNT @D53445, PER @D53444, 
            PLU @D53443, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FILE, 
   [COORD @D53452, AGR [CASE @D53451, COUNT @D53450, PER @D53449, 
            PLU @D53448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53457, AGR [CASE @D53456, COUNT @D53455, PER @D53454, 
            PLU @D53453, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILE, 
   [COORD @D53462, AGR [CASE @D53461, COUNT @D53460, PER @D53459, 
            PLU @D53458, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53467, AGR [CASE @D53466, COUNT @D53465, PER @D53464, 
            PLU @D53463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILE, 
   [COORD @D53472, AGR [CASE @D53471, COUNT @D53470, PER @D53469, 
            PLU @D53468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53477, AGR [CASE @D53476, COUNT @D53475, PER @D53474, 
            PLU @D53473, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILE, 
   [COORD @D53482, AGR [CASE @D53481, COUNT @D53480, PER @D53479, 
            PLU @D53478, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53487, AGR [CASE @D53486, COUNT @D53485, PER @D53484, 
            PLU @D53483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53492, AGR [CASE @D53491, COUNT @D53490, PER @D53489, 
            PLU @D53488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILE.

WORD files : 
   [COORD @D53503, DEMON @D53502, REFL @D53501, PRD @D53500, CASE 
         @D53499, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FILE, 
   [COORD @D53508, DEMON @D53507, REFL @D53506, PRD @D53505, 
      CASE @D53504, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   FILE, 
   [COORD @D53510, AGR [COUNT @D53509, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILE, 
   [COORD @D53512, 
      AGR [COUNT @D53511, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FILE, 
   [COORD @D53514, AGR [COUNT @D53513, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILE, 
   [COORD @D53516, 
      AGR [COUNT @D53515, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILE, 
   [COORD @D53518, 
      AGR [COUNT @D53517, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILE, 
   [COORD @D53520, 
      AGR [COUNT @D53519, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILE.

WORD filing : 
   [COORD @D53530, PRD @D53529, AGR [CASE @D53528, COUNT @D53527, 
            PER @D53526, PLU @D53525, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53536, PRD @D53535, 
      AGR [CASE @D53534, COUNT @D53533, PER @D53532, PLU @D53531, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AWAY, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FILE, 
   [COORD @D53542, PRD @D53541, AGR [CASE @D53540, COUNT @D53539, 
            PER @D53538, PLU @D53537, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53548, PRD @D53547, 
      AGR [CASE @D53546, COUNT @D53545, PER @D53544, PLU @D53543, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FILE, 
   [COORD @D53554, PRD @D53553, AGR [CASE @D53552, COUNT @D53551, 
            PER @D53550, PLU @D53549, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILE, 
   [COORD @D53560, PRD @D53559, 
      AGR [CASE @D53558, COUNT @D53557, PER @D53556, PLU @D53555, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FILE.

WORD fill : 
   [COORD @D53567, AGR [COUNT @D53566, PER @D53565, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FILL, 
   [COORD @D53569, AGR [COUNT @D53568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FILL, 
   [COORD @D53571, AGR [COUNT @D53570, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FILL, 
   [COORD @D53575, AGR [COUNT @D53574, PER @D53573, PLU @D53572, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FILL, 
   [COORD @D53581, PAST @D53580, AGR [CASE @D53579, COUNT @D53578, 
            PER @D53577, PLU @D53576, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : FILL, 
   [COORD @D53584, AGR [COUNT @D53583, PER @D53582, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FILL, 
   [COORD @D53586, AGR [COUNT @D53585, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FILL, 
   [COORD @D53588, AGR [COUNT @D53587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FILL, 
   [COORD @D53592, AGR [COUNT @D53591, PER @D53590, PLU @D53589, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FILL, 
   [COORD @D53598, PAST @D53597, 
      AGR [CASE @D53596, COUNT @D53595, PER @D53594, PLU @D53593, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : FILL, 
   [COORD @D53601, AGR [COUNT @D53600, PER @D53599, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM ON, ARITY 3] : FILL, 
   [COORD @D53603, AGR [COUNT @D53602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM ON, ARITY 3] : FILL, 
   [COORD @D53605, AGR [COUNT @D53604, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM ON, ARITY 3] : FILL, 
   [COORD @D53609, AGR [COUNT @D53608, PER @D53607, PLU @D53606, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM ON, ARITY 3] : FILL, 
   [COORD @D53615, PAST @D53614, 
      AGR [CASE @D53613, COUNT @D53612, PER @D53611, PLU @D53610, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      PFORM ON, ARITY 3] : FILL, 
   [COORD @D53618, AGR [COUNT @D53617, PER @D53616, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILL, 
   [COORD @D53620, AGR [COUNT @D53619, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILL, 
   [COORD @D53622, AGR [COUNT @D53621, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILL, 
   [COORD @D53626, AGR [COUNT @D53625, PER @D53624, PLU @D53623, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FILL, 
   [COORD @D53632, PAST @D53631, AGR [CASE @D53630, COUNT @D53629, 
            PER @D53628, PLU @D53627, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FILL, 
   [COORD @D53635, AGR [COUNT @D53634, PER @D53633, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : FILL, 
   [COORD @D53637, AGR [COUNT @D53636, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : FILL, 
   [COORD @D53639, AGR [COUNT @D53638, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : FILL, 
   [COORD @D53643, AGR [COUNT @D53642, PER @D53641, PLU @D53640, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : FILL, 
   [COORD @D53649, PAST @D53648, 
      AGR [CASE @D53647, COUNT @D53646, PER @D53645, PLU @D53644, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : FILL, 
   [COORD @D53652, AGR [COUNT @D53651, PER @D53650, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM FOR, ARITY 2] : FILL, 
   [COORD @D53654, AGR [COUNT @D53653, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM FOR, ARITY 2] : FILL, 
   [COORD @D53656, AGR [COUNT @D53655, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM FOR, ARITY 2] : FILL, 
   [COORD @D53660, AGR [COUNT @D53659, PER @D53658, PLU @D53657, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM FOR, ARITY 2] : FILL, 
   [COORD @D53666, PAST @D53665, 
      AGR [CASE @D53664, COUNT @D53663, PER @D53662, PLU @D53661, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM FOR, ARITY 2] : FILL, 
   [COORD @D53669, AGR [COUNT @D53668, PER @D53667, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FILL, 
   [COORD @D53671, AGR [COUNT @D53670, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FILL, 
   [COORD @D53673, AGR [COUNT @D53672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FILL, 
   [COORD @D53677, AGR [COUNT @D53676, PER @D53675, PLU @D53674, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : FILL, 
   [COORD @D53683, PAST @D53682, 
      AGR [CASE @D53681, COUNT @D53680, PER @D53679, PLU @D53678, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : FILL, 
   [COORD @D53686, AGR [COUNT @D53685, PER @D53684, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FILL, 
   [COORD @D53688, AGR [COUNT @D53687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FILL, 
   [COORD @D53690, AGR [COUNT @D53689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FILL, 
   [COORD @D53694, AGR [COUNT @D53693, PER @D53692, PLU @D53691, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : FILL, 
   [COORD @D53700, PAST @D53699, 
      AGR [CASE @D53698, COUNT @D53697, PER @D53696, PLU @D53695, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : FILL, 
   [COORD @D53703, AGR [COUNT @D53702, PER @D53701, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FILL, 
   [COORD @D53705, AGR [COUNT @D53704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FILL, 
   [COORD @D53707, AGR [COUNT @D53706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FILL, 
   [COORD @D53711, AGR [COUNT @D53710, PER @D53709, PLU @D53708, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : FILL, 
   [COORD @D53717, PAST @D53716, 
      AGR [CASE @D53715, COUNT @D53714, PER @D53713, PLU @D53712, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : FILL, 
   [COORD @D53720, AGR [COUNT @D53719, PER @D53718, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILL, 
   [COORD @D53722, AGR [COUNT @D53721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILL, 
   [COORD @D53724, AGR [COUNT @D53723, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILL, 
   [COORD @D53728, AGR [COUNT @D53727, PER @D53726, PLU @D53725, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILL, 
   [COORD @D53734, PAST @D53733, AGR [CASE @D53732, COUNT @D53731, 
            PER @D53730, PLU @D53729, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FILL, 
   [COORD @D53737, AGR [COUNT @D53736, PER @D53735, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FILL, 
   [COORD @D53739, AGR [COUNT @D53738, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FILL, 
   [COORD @D53741, AGR [COUNT @D53740, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FILL, 
   [COORD @D53745, AGR [COUNT @D53744, PER @D53743, PLU @D53742, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FILL, 
   [COORD @D53751, PAST @D53750, 
      AGR [CASE @D53749, COUNT @D53748, PER @D53747, PLU @D53746, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : FILL, 
   [COORD @D53754, AGR [COUNT @D53753, PER @D53752, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FILL, 
   [COORD @D53756, AGR [COUNT @D53755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FILL, 
   [COORD @D53758, AGR [COUNT @D53757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FILL, 
   [COORD @D53762, AGR [COUNT @D53761, PER @D53760, PLU @D53759, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FILL, 
   [COORD @D53768, PAST @D53767, 
      AGR [CASE @D53766, COUNT @D53765, PER @D53764, PLU @D53763, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : FILL, 
   [COORD @D53771, AGR [COUNT @D53770, PER @D53769, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FILL, 
   [COORD @D53773, AGR [COUNT @D53772, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FILL, 
   [COORD @D53775, AGR [COUNT @D53774, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FILL, 
   [COORD @D53779, AGR [COUNT @D53778, PER @D53777, PLU @D53776, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FILL, 
   [COORD @D53785, PAST @D53784, 
      AGR [CASE @D53783, COUNT @D53782, PER @D53781, PLU @D53780, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : FILL.

WORD filled : 
   [COORD @D53796, AGR [CASE @D53795, COUNT @D53794, PER @D53793, 
            PLU @D53792, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FILL, 
   [COORD @D53801, AGR [CASE @D53800, COUNT @D53799, PER @D53798, 
            PLU @D53797, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53806, AGR [CASE @D53805, COUNT @D53804, PER @D53803, 
            PLU @D53802, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53811, AGR [CASE @D53810, COUNT @D53809, PER @D53808, 
            PLU @D53807, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53816, AGR [CASE @D53815, COUNT @D53814, PER @D53813, 
            PLU @D53812, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53821, AGR [CASE @D53820, COUNT @D53819, PER @D53818, 
            PLU @D53817, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53826, AGR [CASE @D53825, COUNT @D53824, PER @D53823, 
            PLU @D53822, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM ON, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53831, AGR [CASE @D53830, COUNT @D53829, PER @D53828, 
            PLU @D53827, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53836, 
      AGR [CASE @D53835, COUNT @D53834, PER @D53833, PLU @D53832, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : FILL, 
   [COORD @D53841, AGR [CASE @D53840, COUNT @D53839, PER @D53838, 
            PLU @D53837, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FILL, 
   [COORD @D53846, AGR [CASE @D53845, COUNT @D53844, PER @D53843, 
            PLU @D53842, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53851, AGR [CASE @D53850, COUNT @D53849, PER @D53848, 
            PLU @D53847, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53856, AGR [CASE @D53855, COUNT @D53854, PER @D53853, 
            PLU @D53852, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53861, AGR [CASE @D53860, COUNT @D53859, PER @D53858, 
            PLU @D53857, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53866, AGR [CASE @D53865, COUNT @D53864, PER @D53863, 
            PLU @D53862, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53871, AGR [CASE @D53870, COUNT @D53869, PER @D53868, 
            PLU @D53867, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53876, AGR [CASE @D53875, COUNT @D53874, PER @D53873, 
            PLU @D53872, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53881, AGR [CASE @D53880, COUNT @D53879, PER @D53878, 
            PLU @D53877, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53886, AGR [CASE @D53885, COUNT @D53884, PER @D53883, 
            PLU @D53882, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53891, AGR [CASE @D53890, COUNT @D53889, PER @D53888, 
            PLU @D53887, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53896, AGR [CASE @D53895, COUNT @D53894, PER @D53893, 
            PLU @D53892, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53901, AGR [CASE @D53900, COUNT @D53899, PER @D53898, 
            PLU @D53897, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53906, AGR [CASE @D53905, COUNT @D53904, PER @D53903, 
            PLU @D53902, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53911, AGR [CASE @D53910, COUNT @D53909, PER @D53908, 
            PLU @D53907, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53916, AGR [CASE @D53915, COUNT @D53914, PER @D53913, 
            PLU @D53912, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53921, AGR [CASE @D53920, COUNT @D53919, PER @D53918, 
            PLU @D53917, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53926, AGR [CASE @D53925, COUNT @D53924, PER @D53923, 
            PLU @D53922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53931, AGR [CASE @D53930, COUNT @D53929, PER @D53928, 
            PLU @D53927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53936, AGR [CASE @D53935, COUNT @D53934, PER @D53933, 
            PLU @D53932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53941, AGR [CASE @D53940, COUNT @D53939, PER @D53938, 
            PLU @D53937, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53946, AGR [CASE @D53945, COUNT @D53944, PER @D53943, 
            PLU @D53942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILL, 
   [COORD @D53951, AGR [CASE @D53950, COUNT @D53949, PER @D53948, 
            PLU @D53947, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53956, AGR [CASE @D53955, COUNT @D53954, PER @D53953, 
            PLU @D53952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILL.

WORD filling : 
   [COORD @D53971, PRD @D53970, AGR [CASE @D53969, COUNT @D53968, 
            PER @D53967, PLU @D53966, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53977, PRD @D53976, 
      AGR [CASE @D53975, COUNT @D53974, PER @D53973, PLU @D53972, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FILL, 
   [COORD @D53983, PRD @D53982, AGR [CASE @D53981, COUNT @D53980, 
            PER @D53979, PLU @D53978, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D53989, PRD @D53988, 
      AGR [CASE @D53987, COUNT @D53986, PER @D53985, PLU @D53984, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FILL, 
   [COORD @D53995, PRD @D53994, AGR [CASE @D53993, COUNT @D53992, 
            PER @D53991, PLU @D53990, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D54001, PRD @D54000, 
      AGR [CASE @D53999, COUNT @D53998, PER @D53997, PLU @D53996, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FILL, 
   [COORD @D54007, PRD @D54006, AGR [CASE @D54005, COUNT @D54004, 
            PER @D54003, PLU @D54002, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D54013, PRD @D54012, 
      AGR [CASE @D54011, COUNT @D54010, PER @D54009, PLU @D54008, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FILL, 
   [COORD @D54019, PRD @D54018, AGR [CASE @D54017, COUNT @D54016, 
            PER @D54015, PLU @D54014, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D54025, PRD @D54024, 
      AGR [CASE @D54023, COUNT @D54022, PER @D54021, PLU @D54020, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FILL, 
   [COORD @D54031, PRD @D54030, AGR [CASE @D54029, COUNT @D54028, 
            PER @D54027, PLU @D54026, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL, 
   [COORD @D54037, PRD @D54036, 
      AGR [CASE @D54035, COUNT @D54034, PER @D54033, PLU @D54032, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FILL, 
   [COORD @D54043, PRD @D54042, AGR [CASE @D54041, COUNT @D54040, 
            PER @D54039, PLU @D54038, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FILL.

WORD fills : 
   [COORD @D54051, AGR [COUNT @D54050, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54053, 
      AGR [COUNT @D54052, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FILL, 
   [COORD @D54055, AGR [COUNT @D54054, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FILL, 
   [COORD @D54057, AGR [COUNT @D54056, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54059, 
      AGR [COUNT @D54058, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54061, 
      AGR [COUNT @D54060, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FILL, 
   [COORD @D54063, AGR [COUNT @D54062, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54065, 
      AGR [COUNT @D54064, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54067, 
      AGR [COUNT @D54066, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54069, 
      AGR [COUNT @D54068, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54071, 
      AGR [COUNT @D54070, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54073, 
      AGR [COUNT @D54072, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL, 
   [COORD @D54075, 
      AGR [COUNT @D54074, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILL.

WORD film : 
   [COORD @D54083, REFL @D54082, PRD @D54081, CASE @D54080, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FILM, 
   [COORD @D54088, REFL @D54087, COUNT @D54086, PRD @D54085, 
      CASE @D54084, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FILM, 
   [COORD @D54091, 
      AGR [COUNT @D54090, PER @D54089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   FILM, 
   [COORD @D54093, AGR [COUNT @D54092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILM, 
   [COORD @D54095, AGR [COUNT @D54094, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FILM, 
   [COORD @D54099, AGR [COUNT @D54098, PER @D54097, PLU @D54096, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FILM, 
   [COORD @D54105, PAST @D54104, AGR [CASE @D54103, COUNT @D54102, 
            PER @D54101, PLU @D54100, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FILM, 
   [COORD @D54108, AGR [COUNT @D54107, PER @D54106, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : FILM, 
   [COORD @D54110, AGR [COUNT @D54109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : FILM, 
   [COORD @D54112, AGR [COUNT @D54111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : FILM, 
   [COORD @D54116, AGR [COUNT @D54115, PER @D54114, PLU @D54113, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : FILM, 
   [COORD @D54122, PAST @D54121, AGR [CASE @D54120, COUNT @D54119, 
            PER @D54118, PLU @D54117, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : FILM, 
   [COORD @D54125, AGR [COUNT @D54124, PER @D54123, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILM, 
   [COORD @D54127, AGR [COUNT @D54126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILM, 
   [COORD @D54129, AGR [COUNT @D54128, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILM, 
   [COORD @D54133, AGR [COUNT @D54132, PER @D54131, PLU @D54130, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FILM, 
   [COORD @D54139, PAST @D54138, AGR [CASE @D54137, COUNT @D54136, 
            PER @D54135, PLU @D54134, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FILM, 
   [COORD @D54142, AGR [COUNT @D54141, PER @D54140, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : FILM, 
   [COORD @D54144, AGR [COUNT @D54143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : FILM, 
   [COORD @D54146, AGR [COUNT @D54145, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : FILM, 
   [COORD @D54150, AGR [COUNT @D54149, PER @D54148, PLU @D54147, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : FILM, 
   [COORD @D54156, PAST @D54155, 
      AGR [CASE @D54154, COUNT @D54153, PER @D54152, PLU @D54151, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : FILM.

WORD filmed : 
   [COORD @D54167, AGR [CASE @D54166, COUNT @D54165, PER @D54164, 
            PLU @D54163, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FILM, 
   [COORD @D54172, AGR [CASE @D54171, COUNT @D54170, PER @D54169, 
            PLU @D54168, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILM, 
   [COORD @D54177, AGR [CASE @D54176, COUNT @D54175, PER @D54174, 
            PLU @D54173, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILM, 
   [COORD @D54182, AGR [CASE @D54181, COUNT @D54180, PER @D54179, 
            PLU @D54178, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILM, 
   [COORD @D54187, AGR [CASE @D54186, COUNT @D54185, PER @D54184, 
            PLU @D54183, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILM, 
   [COORD @D54192, AGR [CASE @D54191, COUNT @D54190, PER @D54189, 
            PLU @D54188, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FILM, 
   [COORD @D54197, AGR [CASE @D54196, COUNT @D54195, PER @D54194, 
            PLU @D54193, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FILM, 
   [COORD @D54202, AGR [CASE @D54201, COUNT @D54200, PER @D54199, 
            PLU @D54198, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILM, 
   [COORD @D54207, AGR [CASE @D54206, COUNT @D54205, PER @D54204, 
            PLU @D54203, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FILM.

WORD filming : 
   [COORD @D54223, PRD @D54222, AGR [CASE @D54221, COUNT @D54220, 
            PER @D54219, PLU @D54218, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILM, 
   [COORD @D54229, PRD @D54228, 
      AGR [CASE @D54227, COUNT @D54226, PER @D54225, PLU @D54224, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FILM, 
   [COORD @D54235, PRD @D54234, AGR [CASE @D54233, COUNT @D54232, 
            PER @D54231, PLU @D54230, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FILM, 
   [COORD @D54241, PRD @D54240, 
      AGR [CASE @D54239, COUNT @D54238, PER @D54237, PLU @D54236, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FILM.

WORD films : 
   [COORD @D54252, DEMON @D54251, REFL @D54250, PRD @D54249, CASE 
         @D54248, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FILM, 
   [COORD @D54254, 
      AGR [COUNT @D54253, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILM, 
   [COORD @D54256, 
      AGR [COUNT @D54255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILM, 
   [COORD @D54258, 
      AGR [COUNT @D54257, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILM, 
   [COORD @D54260, 
      AGR [COUNT @D54259, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FILM.

WORD finance : 
   [COORD @D54268, REFL @D54267, PRD @D54266, CASE @D54265, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : FINANCE, 
   [COORD @D54271, AGR [COUNT @D54270, PER @D54269, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FINANCE, 
   [COORD @D54273, AGR [COUNT @D54272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FINANCE, 
   [COORD @D54275, AGR [COUNT @D54274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FINANCE, 
   [COORD @D54279, AGR [COUNT @D54278, PER @D54277, PLU @D54276, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FINANCE, 
   [COORD @D54285, PAST @D54284, AGR [CASE @D54283, COUNT @D54282, 
            PER @D54281, PLU @D54280, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FINANCE.

WORD financed : 
   [COORD @D54296, AGR [CASE @D54295, COUNT @D54294, PER @D54293, 
            PLU @D54292, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FINANCE, 
   [COORD @D54301, AGR [CASE @D54300, COUNT @D54299, PER @D54298, 
            PLU @D54297, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINANCE, 
   [COORD @D54306, AGR [CASE @D54305, COUNT @D54304, PER @D54303, 
            PLU @D54302, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FINANCE.

WORD finances : 
   [COORD @D54316, REFL @D54315, PRD @D54314, CASE @D54313, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : FINANCES, 
   [COORD @D54318, 
      AGR [COUNT @D54317, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FINANCE.

WORD financing : 
   [COORD @D54339, PRD @D54338, AGR [CASE @D54337, COUNT @D54336, 
            PER @D54335, PLU @D54334, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINANCE.

WORD find : 
   [COORD @D54344, AGR [COUNT @D54343, PER @D54342, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54346, AGR [COUNT @D54345, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54348, AGR [COUNT @D54347, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54352, AGR [COUNT @D54351, PER @D54350, PLU @D54349, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, REG -, ARITY 3] : FIND, 
   [COORD @D54358, PAST @D54357, 
      AGR [CASE @D54356, COUNT @D54355, PER @D54354, PLU @D54353, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, REG -, ARITY 3] : 
   FIND, 
   [COORD @D54361, AGR [COUNT @D54360, PER @D54359, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54363, AGR [COUNT @D54362, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54365, AGR [COUNT @D54364, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54369, AGR [COUNT @D54368, PER @D54367, PLU @D54366, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, ARITY 3] : FIND, 
   [COORD @D54375, PAST @D54374, 
      AGR [CASE @D54373, COUNT @D54372, PER @D54371, PLU @D54370, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, ARITY 3] : 
   FIND, 
   [COORD @D54378, AGR [COUNT @D54377, PER @D54376, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54380, AGR [COUNT @D54379, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54382, AGR [COUNT @D54381, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54386, AGR [COUNT @D54385, PER @D54384, PLU @D54383, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : FIND, 
   [COORD @D54392, PAST @D54391, 
      AGR [CASE @D54390, COUNT @D54389, PER @D54388, PLU @D54387, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   FIND, 
   [COORD @D54395, AGR [COUNT @D54394, PER @D54393, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54397, AGR [COUNT @D54396, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54399, AGR [COUNT @D54398, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54403, AGR [COUNT @D54402, PER @D54401, PLU @D54400, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : FIND, 
   [COORD @D54409, PAST @D54408, 
      AGR [CASE @D54407, COUNT @D54406, PER @D54405, PLU @D54404, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : 
   FIND, 
   [COORD @D54412, AGR [COUNT @D54411, PER @D54410, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54414, AGR [COUNT @D54413, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54416, AGR [COUNT @D54415, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54420, AGR [COUNT @D54419, PER @D54418, PLU @D54417, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : FIND, 
   [COORD @D54426, PAST @D54425, 
      AGR [CASE @D54424, COUNT @D54423, PER @D54422, PLU @D54421, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   FIND, 
   [COORD @D54429, AGR [COUNT @D54428, PER @D54427, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54431, AGR [COUNT @D54430, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54433, AGR [COUNT @D54432, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FIND, 
   [COORD @D54437, AGR [COUNT @D54436, PER @D54435, PLU @D54434, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : FIND, 
   [COORD @D54443, PAST @D54442, 
      AGR [CASE @D54441, COUNT @D54440, PER @D54439, PLU @D54438, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   FIND, 
   [COORD @D54446, AGR [COUNT @D54445, PER @D54444, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : FIND, 
   [COORD @D54448, AGR [COUNT @D54447, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : FIND, 
   [COORD @D54450, AGR [COUNT @D54449, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : FIND, 
   [COORD @D54454, AGR [COUNT @D54453, PER @D54452, PLU @D54451, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM IN, ARITY 3] : FIND, 
   [COORD @D54460, PAST @D54459, 
      AGR [CASE @D54458, COUNT @D54457, PER @D54456, PLU @D54455, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM IN, 
      ARITY 3] : FIND, 
   [COORD @D54463, AGR [COUNT @D54462, PER @D54461, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : FIND, 
   [COORD @D54465, AGR [COUNT @D54464, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : FIND, 
   [COORD @D54467, AGR [COUNT @D54466, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : FIND, 
   [COORD @D54471, AGR [COUNT @D54470, PER @D54469, PLU @D54468, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : FIND, 
   [COORD @D54477, PAST @D54476, 
      AGR [CASE @D54475, COUNT @D54474, PER @D54473, PLU @D54472, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : FIND, 
   [COORD @D54480, AGR [COUNT @D54479, PER @D54478, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : FIND, 
   [COORD @D54482, AGR [COUNT @D54481, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : FIND, 
   [COORD @D54484, AGR [COUNT @D54483, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : FIND, 
   [COORD @D54488, AGR [COUNT @D54487, PER @D54486, PLU @D54485, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : FIND, 
   [COORD @D54494, PAST @D54493, 
      AGR [CASE @D54492, COUNT @D54491, PER @D54490, PLU @D54489, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   FIND, 
   [COORD @D54497, AGR [COUNT @D54496, PER @D54495, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FIND, 
   [COORD @D54499, AGR [COUNT @D54498, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FIND, 
   [COORD @D54501, AGR [COUNT @D54500, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FIND, 
   [COORD @D54505, AGR [COUNT @D54504, PER @D54503, PLU @D54502, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : FIND, 
   [COORD @D54511, PAST @D54510, AGR [CASE @D54509, COUNT @D54508, 
            PER @D54507, PLU @D54506, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : FIND, 
   [COORD @D54514, AGR [COUNT @D54513, PER @D54512, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54516, AGR [COUNT @D54515, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54518, AGR [COUNT @D54517, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54522, AGR [COUNT @D54521, PER @D54520, PLU @D54519, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54528, PAST @D54527, 
      AGR [CASE @D54526, COUNT @D54525, PER @D54524, PLU @D54523, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, PRT OUT, 
      ARITY 2] : FIND, 
   [COORD @D54531, AGR [COUNT @D54530, PER @D54529, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, ARITY 2] : FIND, 
   [COORD @D54533, AGR [COUNT @D54532, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, ARITY 2] : FIND, 
   [COORD @D54535, AGR [COUNT @D54534, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, ARITY 2] : FIND, 
   [COORD @D54539, AGR [COUNT @D54538, PER @D54537, PLU @D54536, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54545, PAST @D54544, AGR [CASE @D54543, COUNT @D54542, 
            PER @D54541, PLU @D54540, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54548, 
      AGR [COUNT @D54547, PER @D54546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT OUT, 
      ARITY 2] : FIND, 
   [COORD @D54550, AGR [COUNT @D54549, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54552, AGR [COUNT @D54551, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54556, AGR [COUNT @D54555, PER @D54554, PLU @D54553, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54562, PAST @D54561, 
      AGR [CASE @D54560, COUNT @D54559, PER @D54558, PLU @D54557, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT OUT, 
      ARITY 2] : FIND, 
   [COORD @D54565, AGR [COUNT @D54564, PER @D54563, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FIND, 
   [COORD @D54567, AGR [COUNT @D54566, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FIND, 
   [COORD @D54569, AGR [COUNT @D54568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : FIND, 
   [COORD @D54573, AGR [COUNT @D54572, PER @D54571, PLU @D54570, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : FIND, 
   [COORD @D54579, PAST @D54578, AGR [CASE @D54577, COUNT @D54576, 
            PER @D54575, PLU @D54574, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : FIND, 
   [COORD @D54582, 
      AGR [COUNT @D54581, PER @D54580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : FIND, 
   [COORD @D54584, AGR [COUNT @D54583, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : FIND, 
   [COORD @D54586, AGR [COUNT @D54585, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : FIND, 
   [COORD @D54590, AGR [COUNT @D54589, PER @D54588, PLU @D54587, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : FIND, 
   [COORD @D54596, PAST @D54595, 
      AGR [CASE @D54594, COUNT @D54593, PER @D54592, PLU @D54591, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : FIND, 
   [COORD @D54599, AGR [COUNT @D54598, PER @D54597, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FIND, 
   [COORD @D54601, AGR [COUNT @D54600, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FIND, 
   [COORD @D54603, AGR [COUNT @D54602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : FIND, 
   [COORD @D54607, AGR [COUNT @D54606, PER @D54605, PLU @D54604, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : FIND, 
   [COORD @D54613, PAST @D54612, 
      AGR [CASE @D54611, COUNT @D54610, PER @D54609, PLU @D54608, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : FIND.

WORD finding : 
   [COORD @D54625, REFL @D54624, PRD @D54623, CASE @D54622, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FINDING, 
   [COORD @D54631, PRD @D54630, 
      AGR [CASE @D54629, COUNT @D54628, PER @D54627, PLU @D54626, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FIND, 
   [COORD @D54637, PRD @D54636, AGR [CASE @D54635, COUNT @D54634, 
            PER @D54633, PLU @D54632, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIND, 
   [COORD @D54643, PRD @D54642, 
      AGR [CASE @D54641, COUNT @D54640, PER @D54639, PLU @D54638, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FIND, 
   [COORD @D54649, PRD @D54648, AGR [CASE @D54647, COUNT @D54646, 
            PER @D54645, PLU @D54644, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIND, 
   [COORD @D54655, PRD @D54654, 
      AGR [CASE @D54653, COUNT @D54652, PER @D54651, PLU @D54650, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FIND, 
   [COORD @D54661, PRD @D54660, AGR [CASE @D54659, COUNT @D54658, 
            PER @D54657, PLU @D54656, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIND, 
   [COORD @D54667, PRD @D54666, 
      AGR [CASE @D54665, COUNT @D54664, PER @D54663, PLU @D54662, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FIND, 
   [COORD @D54673, PRD @D54672, AGR [CASE @D54671, COUNT @D54670, 
            PER @D54669, PLU @D54668, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIND, 
   [COORD @D54679, PRD @D54678, 
      AGR [CASE @D54677, COUNT @D54676, PER @D54675, PLU @D54674, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FIND, 
   [COORD @D54685, PRD @D54684, AGR [CASE @D54683, COUNT @D54682, 
            PER @D54681, PLU @D54680, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIND, 
   [COORD @D54691, PRD @D54690, 
      AGR [CASE @D54689, COUNT @D54688, PER @D54687, PLU @D54686, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIND, 
   [COORD @D54697, PRD @D54696, AGR [CASE @D54695, COUNT @D54694, 
            PER @D54693, PLU @D54692, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIND, 
   [COORD @D54703, PRD @D54702, 
      AGR [CASE @D54701, COUNT @D54700, PER @D54699, PLU @D54698, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIND, 
   [COORD @D54709, PRD @D54708, AGR [CASE @D54707, COUNT @D54706, 
            PER @D54705, PLU @D54704, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIND, 
   [COORD @D54715, PRD @D54714, 
      AGR [CASE @D54713, COUNT @D54712, PER @D54711, PLU @D54710, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIND, 
   [COORD @D54721, PRD @D54720, AGR [CASE @D54719, COUNT @D54718, 
            PER @D54717, PLU @D54716, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIND.

WORD findings : 
   [COORD @D54733, DEMON @D54732, REFL @D54731, PRD @D54730, 
      CASE @D54729, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FINDING.

WORD finds : 
   [COORD @D54738, AGR [COUNT @D54737, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54740, 
      AGR [COUNT @D54739, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54742, 
      AGR [COUNT @D54741, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54744, 
      AGR [COUNT @D54743, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54746, 
      AGR [COUNT @D54745, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54748, 
      AGR [COUNT @D54747, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54750, 
      AGR [COUNT @D54749, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54752, 
      AGR [COUNT @D54751, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54754, 
      AGR [COUNT @D54753, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54756, 
      AGR [COUNT @D54755, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54758, 
      AGR [COUNT @D54757, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54760, 
      AGR [COUNT @D54759, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54762, 
      AGR [COUNT @D54761, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54764, 
      AGR [COUNT @D54763, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54766, 
      AGR [COUNT @D54765, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND, 
   [COORD @D54768, 
      AGR [COUNT @D54767, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIND.

WORD finish : 
   [COORD @D54773, AGR [COUNT @D54772, PER @D54771, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FINISH, 
   [COORD @D54775, AGR [COUNT @D54774, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FINISH, 
   [COORD @D54777, AGR [COUNT @D54776, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FINISH, 
   [COORD @D54781, AGR [COUNT @D54780, PER @D54779, PLU @D54778, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : FINISH, 
   [COORD @D54787, PAST @D54786, AGR [CASE @D54785, COUNT @D54784, 
            PER @D54783, PLU @D54782, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : FINISH, 
   [COORD @D54790, AGR [COUNT @D54789, PER @D54788, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FINISH, 
   [COORD @D54792, AGR [COUNT @D54791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FINISH, 
   [COORD @D54794, AGR [COUNT @D54793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FINISH, 
   [COORD @D54798, AGR [COUNT @D54797, PER @D54796, PLU @D54795, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FINISH, 
   [COORD @D54804, PAST @D54803, AGR [CASE @D54802, COUNT @D54801, 
            PER @D54800, PLU @D54799, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FINISH, 
   [COORD @D54807, AGR [COUNT @D54806, PER @D54805, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : FINISH, 
   [COORD @D54809, AGR [COUNT @D54808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : FINISH, 
   [COORD @D54811, AGR [COUNT @D54810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : FINISH, 
   [COORD @D54815, AGR [COUNT @D54814, PER @D54813, PLU @D54812, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, ARITY 2] : FINISH, 
   [COORD @D54821, PAST @D54820, AGR [CASE @D54819, COUNT @D54818, 
            PER @D54817, PLU @D54816, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, ARITY 2] : FINISH, 
   [COORD @D54824, AGR [COUNT @D54823, PER @D54822, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      PRT UP, ARITY 2] : FINISH, 
   [COORD @D54826, AGR [COUNT @D54825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      PRT UP, ARITY 2] : FINISH, 
   [COORD @D54828, AGR [COUNT @D54827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      PRT UP, ARITY 2] : FINISH, 
   [COORD @D54832, AGR [COUNT @D54831, PER @D54830, PLU @D54829, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, PRT UP, ARITY 2] : FINISH, 
   [COORD @D54838, PAST @D54837, 
      AGR [CASE @D54836, COUNT @D54835, PER @D54834, PLU @D54833, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, PRT UP, 
      ARITY 2] : FINISH, 
   [COORD @D54841, AGR [COUNT @D54840, PER @D54839, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : FINISH, 
   [COORD @D54843, AGR [COUNT @D54842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : FINISH, 
   [COORD @D54845, AGR [COUNT @D54844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : FINISH, 
   [COORD @D54849, AGR [COUNT @D54848, PER @D54847, PLU @D54846, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : FINISH, 
   [COORD @D54855, PAST @D54854, 
      AGR [CASE @D54853, COUNT @D54852, PER @D54851, PLU @D54850, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      ARITY 2] : FINISH, 
   [COORD @D54858, AGR [COUNT @D54857, PER @D54856, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FINISH, 
   [COORD @D54860, AGR [COUNT @D54859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FINISH, 
   [COORD @D54862, AGR [COUNT @D54861, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FINISH, 
   [COORD @D54866, AGR [COUNT @D54865, PER @D54864, PLU @D54863, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : FINISH, 
   [COORD @D54872, PAST @D54871, 
      AGR [CASE @D54870, COUNT @D54869, PER @D54868, PLU @D54867, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : FINISH, 
   [COORD @D54875, AGR [COUNT @D54874, PER @D54873, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : FINISH, 
   [COORD @D54877, AGR [COUNT @D54876, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : FINISH, 
   [COORD @D54879, AGR [COUNT @D54878, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : FINISH, 
   [COORD @D54883, AGR [COUNT @D54882, PER @D54881, PLU @D54880, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : FINISH, 
   [COORD @D54889, PAST @D54888, 
      AGR [CASE @D54887, COUNT @D54886, PER @D54885, PLU @D54884, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : FINISH, 
   [COORD @D54892, AGR [COUNT @D54891, PER @D54890, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FINISH, 
   [COORD @D54894, AGR [COUNT @D54893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FINISH, 
   [COORD @D54896, AGR [COUNT @D54895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FINISH, 
   [COORD @D54900, AGR [COUNT @D54899, PER @D54898, PLU @D54897, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FINISH, 
   [COORD @D54906, PAST @D54905, AGR [CASE @D54904, COUNT @D54903, 
            PER @D54902, PLU @D54901, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FINISH, 
   [COORD @D54909, AGR [COUNT @D54908, PER @D54907, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FINISH, 
   [COORD @D54911, AGR [COUNT @D54910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FINISH, 
   [COORD @D54913, AGR [COUNT @D54912, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FINISH, 
   [COORD @D54917, AGR [COUNT @D54916, PER @D54915, PLU @D54914, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FINISH, 
   [COORD @D54923, PAST @D54922, 
      AGR [CASE @D54921, COUNT @D54920, PER @D54919, PLU @D54918, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : FINISH, 
   [COORD @D54926, AGR [COUNT @D54925, PER @D54924, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : FINISH, 
   [COORD @D54928, AGR [COUNT @D54927, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : FINISH, 
   [COORD @D54930, AGR [COUNT @D54929, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : FINISH, 
   [COORD @D54934, AGR [COUNT @D54933, PER @D54932, PLU @D54931, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : FINISH, 
   [COORD @D54940, PAST @D54939, 
      AGR [CASE @D54938, COUNT @D54937, PER @D54936, PLU @D54935, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : FINISH.

WORD finished : 
   [COADV @D54951, COORD @D54950, DEF @D54949, PRD @D54948, AGR 
         [CASE @D54947, COUNT @D54946, PER @D54945, PLU @D54944, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FINISHED, 
   [COADV @D54959, COORD @D54958, DEF @D54957, PRD @D54956, 
      AGR [CASE @D54955, COUNT @D54954, PER @D54953, PLU @D54952, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR ATT] : 
   FINISHED, 
   [COADV @D54967, COORD @D54966, DEF @D54965, PRD @D54964, AGR 
         [CASE @D54963, COUNT @D54962, PER @D54961, PLU @D54960, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PRD] : FINISHED, 
   [COORD @D54972, AGR [CASE @D54971, COUNT @D54970, PER @D54969, 
            PLU @D54968, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D54977, AGR [CASE @D54976, COUNT @D54975, PER @D54974, 
            PLU @D54973, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D54982, AGR [CASE @D54981, COUNT @D54980, PER @D54979, 
            PLU @D54978, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FINISH, 
   [COORD @D54987, AGR [CASE @D54986, COUNT @D54985, PER @D54984, 
            PLU @D54983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D54992, AGR [CASE @D54991, COUNT @D54990, PER @D54989, 
            PLU @D54988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D54997, AGR [CASE @D54996, COUNT @D54995, PER @D54994, 
            PLU @D54993, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55002, AGR [CASE @D55001, COUNT @D55000, PER @D54999, 
            PLU @D54998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55007, AGR [CASE @D55006, COUNT @D55005, PER @D55004, 
            PLU @D55003, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55012, AGR [CASE @D55011, COUNT @D55010, PER @D55009, 
            PLU @D55008, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55017, AGR [CASE @D55016, COUNT @D55015, PER @D55014, 
            PLU @D55013, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55022, AGR [CASE @D55021, COUNT @D55020, PER @D55019, 
            PLU @D55018, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55027, AGR [CASE @D55026, COUNT @D55025, PER @D55024, 
            PLU @D55023, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55032, AGR [CASE @D55031, COUNT @D55030, PER @D55029, 
            PLU @D55028, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55037, AGR [CASE @D55036, COUNT @D55035, PER @D55034, 
            PLU @D55033, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55042, AGR [CASE @D55041, COUNT @D55040, PER @D55039, 
            PLU @D55038, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55047, AGR [CASE @D55046, COUNT @D55045, PER @D55044, 
            PLU @D55043, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55052, AGR [CASE @D55051, COUNT @D55050, PER @D55049, 
            PLU @D55048, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55057, AGR [CASE @D55056, COUNT @D55055, PER @D55054, 
            PLU @D55053, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55062, AGR [CASE @D55061, COUNT @D55060, PER @D55059, 
            PLU @D55058, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55067, AGR [CASE @D55066, COUNT @D55065, PER @D55064, 
            PLU @D55063, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55072, AGR [CASE @D55071, COUNT @D55070, PER @D55069, 
            PLU @D55068, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55077, AGR [CASE @D55076, COUNT @D55075, PER @D55074, 
            PLU @D55073, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55082, AGR [CASE @D55081, COUNT @D55080, PER @D55079, 
            PLU @D55078, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55087, AGR [CASE @D55086, COUNT @D55085, PER @D55084, 
            PLU @D55083, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FINISH.

WORD finishing : 
   [COORD @D55098, PRD @D55097, AGR [CASE @D55096, COUNT @D55095, 
            PER @D55094, PLU @D55093, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55104, PRD @D55103, 
      AGR [CASE @D55102, COUNT @D55101, PER @D55100, PLU @D55099, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FINISH, 
   [COORD @D55110, PRD @D55109, AGR [CASE @D55108, COUNT @D55107, 
            PER @D55106, PLU @D55105, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55116, PRD @D55115, 
      AGR [CASE @D55114, COUNT @D55113, PER @D55112, PLU @D55111, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FINISH, 
   [COORD @D55122, PRD @D55121, AGR [CASE @D55120, COUNT @D55119, 
            PER @D55118, PLU @D55117, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55128, PRD @D55127, 
      AGR [CASE @D55126, COUNT @D55125, PER @D55124, PLU @D55123, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FINISH, 
   [COORD @D55134, PRD @D55133, AGR [CASE @D55132, COUNT @D55131, 
            PER @D55130, PLU @D55129, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55140, PRD @D55139, 
      AGR [CASE @D55138, COUNT @D55137, PER @D55136, PLU @D55135, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FINISH, 
   [COORD @D55146, PRD @D55145, AGR [CASE @D55144, COUNT @D55143, 
            PER @D55142, PLU @D55141, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FINISH, 
   [COORD @D55152, PRD @D55151, 
      AGR [CASE @D55150, COUNT @D55149, PER @D55148, PLU @D55147, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FINISH.

WORD fit : 
   [COADV @D55165, COORD @D55164, DEF @D55163, PRD @D55162, AGR 
            [CASE @D55161, COUNT @D55160, PER @D55159, PLU @D55158, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR INFL, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : FIT, 
   [COADV @D55173, COORD @D55172, DEF @D55171, PRD @D55170, 
      AGR [CASE @D55169, COUNT @D55168, PER @D55167, PLU @D55166, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR INFL, GRADE +, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PRD] : FIT, 
   [COADV @D55181, COORD @D55180, DEF @D55179, PRD @D55178, 
      AGR [CASE @D55177, COUNT @D55176, PER @D55175, PLU @D55174, BAR 2, 
            V -, N +, NFORM NORM], N +, V +, SUBCAT SINF, SUBTYPE NONE, 
      FIX NOT, INFL +, BAR 0, COMPAR INFL, GRADE +, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PRD, ARITY 2] : FIT, 
   [COADV @D55189, COORD @D55188, DEF @D55187, PRD @D55186, 
      AGR [CASE @D55185, COUNT @D55184, PER @D55183, PLU @D55182, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      COMPAR INFL, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT SC_INF, 
      DISTR PRD, ARITY 2] : FIT, 
   [COADV @D55197, COORD @D55196, DEF @D55195, PRD @D55194, 
      AGR [CASE @D55193, COUNT @D55192, PER @D55191, PLU @D55190, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR INFL, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      DISTR PRD, ARITY 2] : FIT, 
   [COORD @D55201, REFL @D55200, PRD @D55199, CASE @D55198, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FIT, 
   [COORD @D55205, REFL @D55204, PRD @D55203, CASE @D55202, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FIT, 
   [COORD @D55210, REFL @D55209, COUNT @D55208, PRD @D55207, 
      CASE @D55206, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FIT, 
   [COORD @D55214, REFL @D55213, PRD @D55212, CASE @D55211, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : FIT, 
   [COORD @D55217, 
      AGR [COUNT @D55216, PER @D55215, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : FIT, 
   [COORD @D55219, AGR [COUNT @D55218, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : FIT, 
   [COORD @D55221, AGR [COUNT @D55220, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : FIT, 
   [COORD @D55225, AGR [COUNT @D55224, PER @D55223, PLU @D55222, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : FIT, 
   [COORD @D55231, PAST @D55230, AGR [CASE @D55229, COUNT @D55228, 
            PER @D55227, PLU @D55226, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : FIT, 
   [COORD @D55234, AGR [COUNT @D55233, PER @D55232, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIT, 
   [COORD @D55236, AGR [COUNT @D55235, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIT, 
   [COORD @D55238, AGR [COUNT @D55237, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIT, 
   [COORD @D55242, AGR [COUNT @D55241, PER @D55240, PLU @D55239, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIT, 
   [COORD @D55248, PAST @D55247, 
      AGR [CASE @D55246, COUNT @D55245, PER @D55244, PLU @D55243, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : FIT, 
   [COORD @D55251, AGR [COUNT @D55250, PER @D55249, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55253, AGR [COUNT @D55252, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55255, AGR [COUNT @D55254, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55259, AGR [COUNT @D55258, PER @D55257, PLU @D55256, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55265, PAST @D55264, 
      AGR [CASE @D55263, COUNT @D55262, PER @D55261, PLU @D55260, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55268, AGR [COUNT @D55267, PER @D55266, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55270, AGR 
         [COUNT @D55269, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55272, AGR [COUNT @D55271, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55276, AGR 
         [COUNT @D55275, PER @D55274, PLU @D55273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55282, PAST @D55281, 
      AGR [CASE @D55280, COUNT @D55279, PER @D55278, PLU @D55277, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55285, AGR [COUNT @D55284, PER @D55283, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55287, AGR [COUNT @D55286, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55289, AGR [COUNT @D55288, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55293, AGR [COUNT @D55292, PER @D55291, PLU @D55290, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55299, PAST @D55298, 
      AGR [CASE @D55297, COUNT @D55296, PER @D55295, PLU @D55294, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      PFORM WITH, ARITY 3] : FIT, 
   [COORD @D55302, AGR [COUNT @D55301, PER @D55300, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM AS, ARITY 3] : FIT, 
   [COORD @D55304, AGR [COUNT @D55303, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM AS, ARITY 3] : FIT, 
   [COORD @D55306, AGR [COUNT @D55305, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM AS, ARITY 3] : FIT, 
   [COORD @D55310, AGR [COUNT @D55309, PER @D55308, PLU @D55307, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM AS, ARITY 3] : FIT, 
   [COORD @D55316, PAST @D55315, 
      AGR [CASE @D55314, COUNT @D55313, PER @D55312, PLU @D55311, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM AS, ARITY 3] : FIT, 
   [COORD @D55319, AGR [COUNT @D55318, PER @D55317, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FIT, 
   [COORD @D55321, AGR [COUNT @D55320, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FIT, 
   [COORD @D55323, AGR [COUNT @D55322, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FIT, 
   [COORD @D55327, AGR [COUNT @D55326, PER @D55325, PLU @D55324, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FIT, 
   [COORD @D55333, PAST @D55332, AGR [CASE @D55331, COUNT @D55330, 
            PER @D55329, PLU @D55328, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FIT, 
   [COORD @D55336, AGR [COUNT @D55335, PER @D55334, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : FIT, 
   [COORD @D55338, AGR [COUNT @D55337, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : FIT, 
   [COORD @D55340, AGR [COUNT @D55339, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : FIT, 
   [COORD @D55344, AGR [COUNT @D55343, PER @D55342, PLU @D55341, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM WITH, ARITY 2] : FIT, 
   [COORD @D55350, PAST @D55349, 
      AGR [CASE @D55348, COUNT @D55347, PER @D55346, PLU @D55345, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM WITH, ARITY 2] : FIT, 
   [COORD @D55353, AGR [COUNT @D55352, PER @D55351, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FIT, 
   [COORD @D55355, AGR [COUNT @D55354, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FIT, 
   [COORD @D55357, AGR [COUNT @D55356, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FIT, 
   [COORD @D55361, AGR [COUNT @D55360, PER @D55359, PLU @D55358, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : FIT, 
   [COORD @D55367, PAST @D55366, 
      AGR [CASE @D55365, COUNT @D55364, PER @D55363, PLU @D55362, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : FIT, 
   [COORD @D55370, AGR [COUNT @D55369, PER @D55368, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FIT, 
   [COORD @D55372, AGR [COUNT @D55371, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FIT, 
   [COORD @D55374, AGR [COUNT @D55373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FIT, 
   [COORD @D55378, AGR [COUNT @D55377, PER @D55376, PLU @D55375, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : FIT, 
   [COORD @D55384, PAST @D55383, 
      AGR [CASE @D55382, COUNT @D55381, PER @D55380, PLU @D55379, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : FIT, 
   [COORD @D55387, AGR [COUNT @D55386, PER @D55385, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FIT, 
   [COORD @D55389, AGR [COUNT @D55388, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FIT, 
   [COORD @D55391, AGR [COUNT @D55390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : FIT, 
   [COORD @D55395, AGR [COUNT @D55394, PER @D55393, PLU @D55392, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : FIT, 
   [COORD @D55401, PAST @D55400, 
      AGR [CASE @D55399, COUNT @D55398, PER @D55397, PLU @D55396, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : FIT, 
   [COORD @D55404, AGR [COUNT @D55403, PER @D55402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIT, 
   [COORD @D55406, AGR [COUNT @D55405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIT, 
   [COORD @D55408, AGR [COUNT @D55407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIT, 
   [COORD @D55412, AGR [COUNT @D55411, PER @D55410, PLU @D55409, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FIT, 
   [COORD @D55418, PAST @D55417, AGR [CASE @D55416, COUNT @D55415, 
            PER @D55414, PLU @D55413, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FIT, 
   [COORD @D55421, AGR [COUNT @D55420, PER @D55419, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIT, 
   [COORD @D55423, AGR [COUNT @D55422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIT, 
   [COORD @D55425, AGR [COUNT @D55424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIT, 
   [COORD @D55429, AGR [COUNT @D55428, PER @D55427, PLU @D55426, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIT, 
   [COORD @D55435, PAST @D55434, 
      AGR [CASE @D55433, COUNT @D55432, PER @D55431, PLU @D55430, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : FIT, 
   [COORD @D55438, AGR [COUNT @D55437, PER @D55436, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIT, 
   [COORD @D55440, AGR [COUNT @D55439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIT, 
   [COORD @D55442, AGR [COUNT @D55441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIT, 
   [COORD @D55446, AGR [COUNT @D55445, PER @D55444, PLU @D55443, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FIT, 
   [COORD @D55452, PAST @D55451, 
      AGR [CASE @D55450, COUNT @D55449, PER @D55448, PLU @D55447, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : FIT, 
   [COORD @D55455, AGR [COUNT @D55454, PER @D55453, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIT, 
   [COORD @D55457, AGR [COUNT @D55456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIT, 
   [COORD @D55459, AGR [COUNT @D55458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIT, 
   [COORD @D55463, AGR [COUNT @D55462, PER @D55461, PLU @D55460, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : FIT, 
   [COORD @D55469, PAST @D55468, 
      AGR [CASE @D55467, COUNT @D55466, PER @D55465, PLU @D55464, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : FIT.

WORD fits : 
   [COORD @D55479, DEMON @D55478, REFL @D55477, PRD @D55476, CASE 
         @D55475, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FIT, 
   [COORD @D55484, DEMON @D55483, REFL @D55482, PRD @D55481, 
      CASE @D55480, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FIT, 
   [COORD @D55489, DEMON @D55488, REFL @D55487, PRD @D55486, 
      CASE @D55485, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   FIT, 
   [COORD @D55491, AGR [COUNT @D55490, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55493, 
      AGR [COUNT @D55492, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55495, 
      AGR [COUNT @D55494, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FIT, 
   [COORD @D55497, AGR [COUNT @D55496, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : FIT, 
   [COORD @D55499, AGR [COUNT @D55498, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : FIT, 
   [COORD @D55501, AGR [COUNT @D55500, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FIT, 
   [COORD @D55503, AGR [COUNT @D55502, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55505, 
      AGR [COUNT @D55504, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FIT, 
   [COORD @D55507, AGR [COUNT @D55506, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55509, 
      AGR [COUNT @D55508, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55511, 
      AGR [COUNT @D55510, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55513, 
      AGR [COUNT @D55512, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55515, 
      AGR [COUNT @D55514, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55517, 
      AGR [COUNT @D55516, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT, 
   [COORD @D55519, 
      AGR [COUNT @D55518, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FIT.

WORD fitted : 
   [COADV @D55532, COORD @D55531, DEF @D55530, PRD @D55529, AGR 
            [CASE @D55528, COUNT @D55527, PER @D55526, PLU @D55525, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : FITTED, 
   [COADV @D55540, COORD @D55539, DEF @D55538, PRD @D55537, 
      AGR [CASE @D55536, COUNT @D55535, PER @D55534, PLU @D55533, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      DISTR PRD, ARITY 2] : FITTED, 
   [COORD @D55545, AGR [CASE @D55544, COUNT @D55543, PER @D55542, 
            PLU @D55541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55550, AGR [CASE @D55549, COUNT @D55548, PER @D55547, 
            PLU @D55546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55556, AGR [CASE @D55555, NFORM @D55554, COUNT @D55553, 
            PER @D55552, PLU @D55551, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FIT, 
   [COORD @D55561, AGR [CASE @D55560, COUNT @D55559, PER @D55558, 
            PLU @D55557, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55566, AGR [CASE @D55565, COUNT @D55564, PER @D55563, 
            PLU @D55562, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55571, AGR [CASE @D55570, COUNT @D55569, PER @D55568, 
            PLU @D55567, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55576, AGR [CASE @D55575, COUNT @D55574, PER @D55573, 
            PLU @D55572, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55581, AGR [CASE @D55580, COUNT @D55579, PER @D55578, 
            PLU @D55577, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55586, 
      AGR [CASE @D55585, COUNT @D55584, PER @D55583, PLU @D55582, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55591, AGR [CASE @D55590, COUNT @D55589, PER @D55588, 
            PLU @D55587, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55596, AGR [CASE @D55595, COUNT @D55594, PER @D55593, 
            PLU @D55592, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55601, 
      AGR [CASE @D55600, COUNT @D55599, PER @D55598, PLU @D55597, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55606, AGR [CASE @D55605, COUNT @D55604, PER @D55603, 
            PLU @D55602, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55611, AGR [CASE @D55610, COUNT @D55609, PER @D55608, 
            PLU @D55607, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55616, 
      AGR [CASE @D55615, COUNT @D55614, PER @D55613, PLU @D55612, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55621, AGR [CASE @D55620, COUNT @D55619, PER @D55618, 
            PLU @D55617, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM AS, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55626, AGR [CASE @D55625, COUNT @D55624, PER @D55623, 
            PLU @D55622, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55631, 
      AGR [CASE @D55630, COUNT @D55629, PER @D55628, PLU @D55627, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : FIT, 
   [COORD @D55636, AGR [CASE @D55635, COUNT @D55634, PER @D55633, 
            PLU @D55632, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FIT, 
   [COORD @D55641, AGR [CASE @D55640, COUNT @D55639, PER @D55638, 
            PLU @D55637, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55646, AGR [CASE @D55645, COUNT @D55644, PER @D55643, 
            PLU @D55642, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55651, AGR [CASE @D55650, COUNT @D55649, PER @D55648, 
            PLU @D55647, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55656, AGR [CASE @D55655, COUNT @D55654, PER @D55653, 
            PLU @D55652, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55661, AGR [CASE @D55660, COUNT @D55659, PER @D55658, 
            PLU @D55657, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55666, AGR [CASE @D55665, COUNT @D55664, PER @D55663, 
            PLU @D55662, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55671, AGR [CASE @D55670, COUNT @D55669, PER @D55668, 
            PLU @D55667, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55676, AGR [CASE @D55675, COUNT @D55674, PER @D55673, 
            PLU @D55672, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55681, AGR [CASE @D55680, COUNT @D55679, PER @D55678, 
            PLU @D55677, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55686, AGR [CASE @D55685, COUNT @D55684, PER @D55683, 
            PLU @D55682, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55691, AGR [CASE @D55690, COUNT @D55689, PER @D55688, 
            PLU @D55687, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55696, AGR [CASE @D55695, COUNT @D55694, PER @D55693, 
            PLU @D55692, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55701, AGR [CASE @D55700, COUNT @D55699, PER @D55698, 
            PLU @D55697, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55706, AGR [CASE @D55705, COUNT @D55704, PER @D55703, 
            PLU @D55702, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55711, AGR [CASE @D55710, COUNT @D55709, PER @D55708, 
            PLU @D55707, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55716, AGR [CASE @D55715, COUNT @D55714, PER @D55713, 
            PLU @D55712, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55721, AGR [CASE @D55720, COUNT @D55719, PER @D55718, 
            PLU @D55717, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55726, AGR [CASE @D55725, COUNT @D55724, PER @D55723, 
            PLU @D55722, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55731, AGR [CASE @D55730, COUNT @D55729, PER @D55728, 
            PLU @D55727, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIT, 
   [COORD @D55736, AGR [CASE @D55735, COUNT @D55734, PER @D55733, 
            PLU @D55732, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55741, AGR [CASE @D55740, COUNT @D55739, PER @D55738, 
            PLU @D55737, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIT.

WORD fitting : 
   [COORD @D55758, PRD @D55757, AGR [CASE @D55756, COUNT @D55755, 
            PER @D55754, PLU @D55753, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55764, PRD @D55763, AGR 
         [CASE @D55762, COUNT @D55761, PER @D55760, PLU @D55759, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIT, 
   [COORD @D55770, PRD @D55769, AGR [CASE @D55768, COUNT @D55767, 
            PER @D55766, PLU @D55765, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55776, PRD @D55775, 
      AGR [CASE @D55774, COUNT @D55773, PER @D55772, PLU @D55771, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FIT, 
   [COORD @D55782, PRD @D55781, AGR [CASE @D55780, COUNT @D55779, 
            PER @D55778, PLU @D55777, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55788, PRD @D55787, 
      AGR [CASE @D55786, COUNT @D55785, PER @D55784, PLU @D55783, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FIT, 
   [COORD @D55794, PRD @D55793, AGR [CASE @D55792, COUNT @D55791, 
            PER @D55790, PLU @D55789, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55800, PRD @D55799, AGR 
         [CASE @D55798, COUNT @D55797, PER @D55796, PLU @D55795, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FIT, 
   [COORD @D55806, PRD @D55805, AGR [CASE @D55804, COUNT @D55803, 
            PER @D55802, PLU @D55801, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55812, PRD @D55811, 
      AGR [CASE @D55810, COUNT @D55809, PER @D55808, PLU @D55807, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIT, 
   [COORD @D55818, PRD @D55817, AGR [CASE @D55816, COUNT @D55815, 
            PER @D55814, PLU @D55813, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55824, PRD @D55823, 
      AGR [CASE @D55822, COUNT @D55821, PER @D55820, PLU @D55819, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   
   [COORD @D55830, PRD @D55829, AGR [CASE @D55828, COUNT @D55827, PER 
               @D55826, PLU @D55825, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT, 
   [COORD @D55836, PRD @D55835, 
      AGR [CASE @D55834, COUNT @D55833, PER @D55832, PLU @D55831, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIT, 
   [COORD @D55842, PRD @D55841, AGR [CASE @D55840, COUNT @D55839, 
            PER @D55838, PLU @D55837, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIT.

WORD fix : 
   [COORD @D55847, AGR [COUNT @D55846, PER @D55845, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FIX, 
   [COORD @D55849, AGR [COUNT @D55848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FIX, 
   [COORD @D55851, AGR [COUNT @D55850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FIX, 
   [COORD @D55855, AGR [COUNT @D55854, PER @D55853, PLU @D55852, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : FIX, 
   [COORD @D55861, PAST @D55860, AGR [CASE @D55859, COUNT @D55858, 
            PER @D55857, PLU @D55856, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : FIX, 
   [COORD @D55864, AGR [COUNT @D55863, PER @D55862, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : FIX, 
   [COORD @D55866, AGR [COUNT @D55865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : FIX, 
   [COORD @D55868, AGR [COUNT @D55867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : FIX, 
   [COORD @D55872, AGR [COUNT @D55871, PER @D55870, PLU @D55869, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : FIX, 
   [COORD @D55878, PAST @D55877, AGR [CASE @D55876, COUNT @D55875, 
            PER @D55874, PLU @D55873, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : FIX, 
   [COORD @D55881, AGR [COUNT @D55880, PER @D55879, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT ON, ARITY 3] : FIX, 
   [COORD @D55883, AGR [COUNT @D55882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT ON, ARITY 3] : FIX, 
   [COORD @D55885, AGR [COUNT @D55884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT ON, ARITY 3] : FIX, 
   [COORD @D55889, AGR [COUNT @D55888, PER @D55887, PLU @D55886, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT ON, ARITY 3] : FIX, 
   [COORD @D55895, PAST @D55894, 
      AGR [CASE @D55893, COUNT @D55892, PER @D55891, PLU @D55890, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, PRT ON, 
      ARITY 3] : FIX, 
   [COORD @D55898, AGR [COUNT @D55897, PER @D55896, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55900, AGR [COUNT @D55899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55902, AGR [COUNT @D55901, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55906, AGR [COUNT @D55905, PER @D55904, PLU @D55903, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55912, PAST @D55911, 
      AGR [CASE @D55910, COUNT @D55909, PER @D55908, PLU @D55907, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : FIX, 
   [COORD @D55915, AGR [COUNT @D55914, PER @D55913, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIX, 
   [COORD @D55917, AGR [COUNT @D55916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIX, 
   [COORD @D55919, AGR [COUNT @D55918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIX, 
   [COORD @D55923, AGR [COUNT @D55922, PER @D55921, PLU @D55920, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : FIX, 
   [COORD @D55929, PAST @D55928, 
      AGR [CASE @D55927, COUNT @D55926, PER @D55925, PLU @D55924, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : FIX, 
   [COORD @D55932, AGR [COUNT @D55931, PER @D55930, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55934, AGR [COUNT @D55933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55936, AGR [COUNT @D55935, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55940, AGR [COUNT @D55939, PER @D55938, PLU @D55937, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55946, PAST @D55945, 
      AGR [CASE @D55944, COUNT @D55943, PER @D55942, PLU @D55941, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM WITH, ARITY 3] : FIX, 
   [COORD @D55949, AGR [COUNT @D55948, PER @D55947, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : FIX, 
   [COORD @D55951, AGR [COUNT @D55950, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : FIX, 
   [COORD @D55953, AGR [COUNT @D55952, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : FIX, 
   [COORD @D55957, AGR [COUNT @D55956, PER @D55955, PLU @D55954, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : FIX, 
   [COORD @D55963, PAST @D55962, AGR [CASE @D55961, COUNT @D55960, 
            PER @D55959, PLU @D55958, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : FIX, 
   [COORD @D55966, AGR [COUNT @D55965, PER @D55964, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FIX, 
   [COORD @D55968, AGR [COUNT @D55967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FIX, 
   [COORD @D55970, AGR [COUNT @D55969, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FIX, 
   [COORD @D55974, AGR [COUNT @D55973, PER @D55972, PLU @D55971, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : FIX, 
   [COORD @D55980, PAST @D55979, AGR [CASE @D55978, COUNT @D55977, 
            PER @D55976, PLU @D55975, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : FIX, 
   [COORD @D55983, AGR [COUNT @D55982, PER @D55981, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FIX, 
   [COORD @D55985, AGR [COUNT @D55984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FIX, 
   [COORD @D55987, AGR [COUNT @D55986, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FIX, 
   [COORD @D55991, AGR [COUNT @D55990, PER @D55989, PLU @D55988, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FIX, 
   [COORD @D55997, PAST @D55996, AGR [CASE @D55995, COUNT @D55994, 
            PER @D55993, PLU @D55992, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FIX, 
   [COORD @D56000, AGR [COUNT @D55999, PER @D55998, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT UP, ARITY 2] : FIX, 
   [COORD @D56002, AGR [COUNT @D56001, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT UP, ARITY 2] : FIX, 
   [COORD @D56004, AGR [COUNT @D56003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT UP, ARITY 2] : FIX, 
   [COORD @D56008, AGR [COUNT @D56007, PER @D56006, PLU @D56005, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT UP, ARITY 2] : FIX, 
   [COORD @D56014, PAST @D56013, 
      AGR [CASE @D56012, COUNT @D56011, PER @D56010, PLU @D56009, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, PRT UP, 
      ARITY 2] : FIX, 
   [COORD @D56017, AGR [COUNT @D56016, PER @D56015, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : FIX, 
   [COORD @D56019, AGR [COUNT @D56018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : FIX, 
   [COORD @D56021, AGR [COUNT @D56020, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : FIX, 
   [COORD @D56025, AGR [COUNT @D56024, PER @D56023, PLU @D56022, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : FIX, 
   [COORD @D56031, PAST @D56030, 
      AGR [CASE @D56029, COUNT @D56028, PER @D56027, PLU @D56026, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      PRT UP, ARITY 2] : FIX, 
   [COORD @D56034, AGR [COUNT @D56033, PER @D56032, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT ON, ARITY 2] : FIX, 
   [COORD @D56036, AGR [COUNT @D56035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT ON, ARITY 2] : FIX, 
   [COORD @D56038, AGR [COUNT @D56037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT ON, ARITY 2] : FIX, 
   [COORD @D56042, AGR [COUNT @D56041, PER @D56040, PLU @D56039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT ON, ARITY 2] : FIX, 
   [COORD @D56048, PAST @D56047, 
      AGR [CASE @D56046, COUNT @D56045, PER @D56044, PLU @D56043, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, PRT ON, 
      ARITY 2] : FIX, 
   [COORD @D56051, AGR [COUNT @D56050, PER @D56049, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIX, 
   [COORD @D56053, AGR [COUNT @D56052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIX, 
   [COORD @D56055, AGR [COUNT @D56054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIX, 
   [COORD @D56059, AGR [COUNT @D56058, PER @D56057, PLU @D56056, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT ON, ARITY 2] : FIX, 
   [COORD @D56065, PAST @D56064, 
      AGR [CASE @D56063, COUNT @D56062, PER @D56061, PLU @D56060, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PRT ON, ARITY 2] : FIX, 
   [COORD @D56068, AGR [COUNT @D56067, PER @D56066, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FIX, 
   [COORD @D56070, AGR [COUNT @D56069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FIX, 
   [COORD @D56072, AGR [COUNT @D56071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FIX, 
   [COORD @D56076, AGR [COUNT @D56075, PER @D56074, PLU @D56073, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : FIX, 
   [COORD @D56082, PAST @D56081, 
      AGR [CASE @D56080, COUNT @D56079, PER @D56078, PLU @D56077, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : FIX, 
   [COORD @D56085, AGR [COUNT @D56084, PER @D56083, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : FIX, 
   [COORD @D56087, AGR [COUNT @D56086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : FIX, 
   [COORD @D56089, AGR [COUNT @D56088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : FIX, 
   [COORD @D56093, AGR [COUNT @D56092, PER @D56091, PLU @D56090, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : FIX, 
   [COORD @D56099, PAST @D56098, 
      AGR [CASE @D56097, COUNT @D56096, PER @D56095, PLU @D56094, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : FIX, 
   [COORD @D56102, AGR [COUNT @D56101, PER @D56100, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIX, 
   [COORD @D56104, AGR [COUNT @D56103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIX, 
   [COORD @D56106, AGR [COUNT @D56105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIX, 
   [COORD @D56110, AGR [COUNT @D56109, PER @D56108, PLU @D56107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FIX, 
   [COORD @D56116, PAST @D56115, 
      AGR [CASE @D56114, COUNT @D56113, PER @D56112, PLU @D56111, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : FIX, 
   [COORD @D56119, AGR [COUNT @D56118, PER @D56117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIX, 
   [COORD @D56121, AGR [COUNT @D56120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIX, 
   [COORD @D56123, AGR [COUNT @D56122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIX, 
   [COORD @D56127, AGR [COUNT @D56126, PER @D56125, PLU @D56124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FIX, 
   [COORD @D56133, PAST @D56132, 
      AGR [CASE @D56131, COUNT @D56130, PER @D56129, PLU @D56128, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : FIX.

WORD fixed : 
   [COADV @D56144, COORD @D56143, DEF @D56142, PRD @D56141, AGR 
            [CASE @D56140, COUNT @D56139, PER @D56138, PLU @D56137, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FIXED, 
   
   [COORD @D56149, AGR [CASE @D56148, COUNT @D56147, PER @D56146, PLU 
               @D56145, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FIX, 
   [COORD @D56154, AGR [CASE @D56153, COUNT @D56152, PER @D56151, 
            PLU @D56150, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56159, AGR [CASE @D56158, COUNT @D56157, PER @D56156, 
            PLU @D56155, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56164, AGR [CASE @D56163, COUNT @D56162, PER @D56161, 
            PLU @D56160, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FIX, 
   [COORD @D56169, AGR [CASE @D56168, COUNT @D56167, PER @D56166, 
            PLU @D56165, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56174, AGR [CASE @D56173, COUNT @D56172, PER @D56171, 
            PLU @D56170, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56179, AGR [CASE @D56178, COUNT @D56177, PER @D56176, 
            PLU @D56175, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56184, AGR [CASE @D56183, COUNT @D56182, PER @D56181, 
            PLU @D56180, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56189, AGR [CASE @D56188, COUNT @D56187, PER @D56186, 
            PLU @D56185, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56194, AGR [CASE @D56193, COUNT @D56192, PER @D56191, 
            PLU @D56190, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56199, AGR [CASE @D56198, COUNT @D56197, PER @D56196, 
            PLU @D56195, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56204, AGR [CASE @D56203, COUNT @D56202, PER @D56201, 
            PLU @D56200, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56209, AGR [CASE @D56208, COUNT @D56207, PER @D56206, 
            PLU @D56205, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56214, AGR [CASE @D56213, COUNT @D56212, PER @D56211, 
            PLU @D56210, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56219, AGR [CASE @D56218, COUNT @D56217, PER @D56216, 
            PLU @D56215, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56224, AGR [CASE @D56223, COUNT @D56222, PER @D56221, 
            PLU @D56220, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56229, AGR [CASE @D56228, COUNT @D56227, PER @D56226, 
            PLU @D56225, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56234, 
      AGR [CASE @D56233, COUNT @D56232, PER @D56231, PLU @D56230, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56239, AGR [CASE @D56238, COUNT @D56237, PER @D56236, 
            PLU @D56235, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56244, AGR [CASE @D56243, COUNT @D56242, PER @D56241, 
            PLU @D56240, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56249, AGR [CASE @D56248, COUNT @D56247, PER @D56246, 
            PLU @D56245, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56254, AGR [CASE @D56253, COUNT @D56252, PER @D56251, 
            PLU @D56250, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56259, AGR [CASE @D56258, COUNT @D56257, PER @D56256, 
            PLU @D56255, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FIX, 
   [COORD @D56264, AGR [CASE @D56263, COUNT @D56262, PER @D56261, 
            PLU @D56260, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56269, AGR [CASE @D56268, COUNT @D56267, PER @D56266, 
            PLU @D56265, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56274, AGR [CASE @D56273, COUNT @D56272, PER @D56271, 
            PLU @D56270, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56279, AGR [CASE @D56278, COUNT @D56277, PER @D56276, 
            PLU @D56275, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56284, AGR [CASE @D56283, COUNT @D56282, PER @D56281, 
            PLU @D56280, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56289, AGR [CASE @D56288, COUNT @D56287, PER @D56286, 
            PLU @D56285, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56294, AGR [CASE @D56293, COUNT @D56292, PER @D56291, 
            PLU @D56290, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56299, AGR [CASE @D56298, COUNT @D56297, PER @D56296, 
            PLU @D56295, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56304, AGR [CASE @D56303, COUNT @D56302, PER @D56301, 
            PLU @D56300, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56309, AGR [CASE @D56308, COUNT @D56307, PER @D56306, 
            PLU @D56305, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56314, AGR [CASE @D56313, COUNT @D56312, PER @D56311, 
            PLU @D56310, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56319, AGR [CASE @D56318, COUNT @D56317, PER @D56316, 
            PLU @D56315, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56324, AGR [CASE @D56323, COUNT @D56322, PER @D56321, 
            PLU @D56320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56329, AGR [CASE @D56328, COUNT @D56327, PER @D56326, 
            PLU @D56325, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56334, AGR [CASE @D56333, COUNT @D56332, PER @D56331, 
            PLU @D56330, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56339, AGR [CASE @D56338, COUNT @D56337, PER @D56336, 
            PLU @D56335, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56344, AGR [CASE @D56343, COUNT @D56342, PER @D56341, 
            PLU @D56340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56349, AGR [CASE @D56348, COUNT @D56347, PER @D56346, 
            PLU @D56345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX, 
   [COORD @D56354, AGR [CASE @D56353, COUNT @D56352, PER @D56351, 
            PLU @D56350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56359, AGR [CASE @D56358, COUNT @D56357, PER @D56356, 
            PLU @D56355, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FIX.

WORD fixing : 
   [COORD @D56370, PRD @D56369, AGR [CASE @D56368, COUNT @D56367, 
            PER @D56366, PLU @D56365, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56376, PRD @D56375, AGR 
         [CASE @D56374, COUNT @D56373, PER @D56372, PLU @D56371, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   
   [COORD @D56382, PRD @D56381, AGR [CASE @D56380, COUNT @D56379, PER 
               @D56378, PLU @D56377, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56388, PRD @D56387, 
      AGR [CASE @D56386, COUNT @D56385, PER @D56384, PLU @D56383, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FIX, 
   [COORD @D56394, PRD @D56393, AGR [CASE @D56392, COUNT @D56391, 
            PER @D56390, PLU @D56389, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56400, PRD @D56399, 
      AGR [CASE @D56398, COUNT @D56397, PER @D56396, PLU @D56395, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FIX, 
   [COORD @D56406, PRD @D56405, AGR [CASE @D56404, COUNT @D56403, 
            PER @D56402, PLU @D56401, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56412, PRD @D56411, AGR 
         [CASE @D56410, COUNT @D56409, PER @D56408, PLU @D56407, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   
   [COORD @D56418, PRD @D56417, AGR [CASE @D56416, COUNT @D56415, PER 
               @D56414, PLU @D56413, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56424, PRD @D56423, AGR 
         [CASE @D56422, COUNT @D56421, PER @D56420, PLU @D56419, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIX, 
   [COORD @D56430, PRD @D56429, AGR [CASE @D56428, COUNT @D56427, 
            PER @D56426, PLU @D56425, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56436, PRD @D56435, 
      AGR [CASE @D56434, COUNT @D56433, PER @D56432, PLU @D56431, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIX, 
   [COORD @D56442, PRD @D56441, AGR [CASE @D56440, COUNT @D56439, 
            PER @D56438, PLU @D56437, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56448, PRD @D56447, 
      AGR [CASE @D56446, COUNT @D56445, PER @D56444, PLU @D56443, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIX, 
   [COORD @D56454, PRD @D56453, AGR [CASE @D56452, COUNT @D56451, 
            PER @D56450, PLU @D56449, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX, 
   [COORD @D56460, PRD @D56459, 
      AGR [CASE @D56458, COUNT @D56457, PER @D56456, PLU @D56455, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FIX, 
   [COORD @D56466, PRD @D56465, AGR [CASE @D56464, COUNT @D56463, 
            PER @D56462, PLU @D56461, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FIX.

WORD flies : 
   [COORD @D56490, DEMON @D56489, REFL @D56488, PRD @D56487, CASE 
         @D56486, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FLY, 
   [COORD @D56495, DEMON @D56494, REFL @D56493, PRD @D56492, 
      CASE @D56491, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FLY, 
   [COORD @D56499, REFL @D56498, PRD @D56497, CASE @D56496, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : FLIES, 
   [COORD @D56501, 
      AGR [COUNT @D56500, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLY, 
   [COORD @D56503, 
      AGR [COUNT @D56502, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLY, 
   [COORD @D56505, 
      AGR [COUNT @D56504, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLY, 
   [COORD @D56507, 
      AGR [COUNT @D56506, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLY, 
   [COORD @D56509, 
      AGR [COUNT @D56508, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLY, 
   [COORD @D56511, 
      AGR [COUNT @D56510, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLY.

WORD flow : 
   [COORD @D56532, REFL @D56531, PRD @D56530, CASE @D56529, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FLOW, 
   [COORD @D56536, REFL @D56535, PRD @D56534, CASE @D56533, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : FLOW, 
   [COORD @D56540, REFL @D56539, PRD @D56538, CASE @D56537, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : FLOW, 
   [COORD @D56545, REFL @D56544, COUNT @D56543, PRD @D56542, 
      CASE @D56541, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FLOW, 
   [COORD @D56548, 
      AGR [COUNT @D56547, PER @D56546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, ARITY 2] : 
   FLOW, 
   [COORD @D56550, AGR [COUNT @D56549, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FLOW, 
   [COORD @D56552, AGR [COUNT @D56551, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : FLOW, 
   [COORD @D56556, AGR [COUNT @D56555, PER @D56554, PLU @D56553, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : FLOW, 
   [COORD @D56562, PAST @D56561, AGR [CASE @D56560, COUNT @D56559, 
            PER @D56558, PLU @D56557, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : FLOW, 
   [COORD @D56565, AGR [COUNT @D56564, PER @D56563, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FLOW, 
   [COORD @D56567, AGR [COUNT @D56566, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FLOW, 
   [COORD @D56569, AGR [COUNT @D56568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FLOW, 
   [COORD @D56573, AGR [COUNT @D56572, PER @D56571, PLU @D56570, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FLOW, 
   [COORD @D56579, PAST @D56578, AGR [CASE @D56577, COUNT @D56576, 
            PER @D56575, PLU @D56574, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FLOW.

WORD flowed : 
   [COORD @D56591, AGR [CASE @D56590, COUNT @D56589, PER @D56588, 
            PLU @D56587, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FLOW, 
   [COORD @D56596, AGR [CASE @D56595, COUNT @D56594, PER @D56593, 
            PLU @D56592, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FLOW, 
   [COORD @D56601, AGR [CASE @D56600, COUNT @D56599, PER @D56598, 
            PLU @D56597, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FLOW, 
   [COORD @D56606, AGR [CASE @D56605, COUNT @D56604, PER @D56603, 
            PLU @D56602, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FLOW.

WORD flower : 
   [COORD @D56617, REFL @D56616, PRD @D56615, CASE @D56614, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FLOWER, 
   [COORD @D56621, REFL @D56620, PRD @D56619, CASE @D56618, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : FLOWER, 
   [COORD @D56626, REFL @D56625, COUNT @D56624, PRD @D56623, 
      CASE @D56622, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FLOWER, 
   [COORD @D56629, 
      AGR [COUNT @D56628, PER @D56627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   FLOWER, 
   [COORD @D56631, AGR [COUNT @D56630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FLOWER, 
   [COORD @D56633, AGR [COUNT @D56632, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FLOWER, 
   [COORD @D56637, AGR [COUNT @D56636, PER @D56635, PLU @D56634, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FLOWER, 
   [COORD @D56643, PAST @D56642, AGR [CASE @D56641, COUNT @D56640, 
            PER @D56639, PLU @D56638, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FLOWER.

WORD flowered : 
   [COORD @D56659, AGR [CASE @D56658, COUNT @D56657, PER @D56656, 
            PLU @D56655, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FLOWER, 
   [COORD @D56664, AGR [CASE @D56663, COUNT @D56662, PER @D56661, 
            PLU @D56660, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FLOWER.

WORD flowering : 
   [COORD @D56683, REFL @D56682, PRD @D56681, CASE @D56680, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FLOWERING, 
   [COORD @D56689, PRD @D56688, 
      AGR [CASE @D56687, COUNT @D56686, PER @D56685, PLU @D56684, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FLOWER.

WORD flowers : 
   [COORD @D56723, DEMON @D56722, REFL @D56721, PRD @D56720, 
      CASE @D56719, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FLOWER, 
   [COORD @D56728, DEMON @D56727, REFL @D56726, PRD @D56725, 
      CASE @D56724, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FLOWER, 
   [COORD @D56730, 
      AGR [COUNT @D56729, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLOWER.

WORD flowing : 
   [COORD @D56747, PRD @D56746, AGR [CASE @D56745, COUNT @D56744, 
            PER @D56743, PLU @D56742, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FLOW, 
   [COORD @D56753, PRD @D56752, 
      AGR [CASE @D56751, COUNT @D56750, PER @D56749, PLU @D56748, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FLOW.

WORD flows : 
   [COORD @D56765, DEMON @D56764, REFL @D56763, PRD @D56762, CASE 
         @D56761, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FLOW, 
   [COORD @D56767, 
      AGR [COUNT @D56766, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLOW, 
   [COORD @D56769, 
      AGR [COUNT @D56768, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FLOW.

WORD flung : 
   [COORD @D56780, PAST @D56779, AGR [CASE @D56778, COUNT @D56777, 
            PER @D56776, PLU @D56775, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : FLING, 
   [COORD @D56786, PAST @D56785, 
      AGR [CASE @D56784, COUNT @D56783, PER @D56782, PLU @D56781, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : 
   FLING, 
   [COORD @D56792, PAST @D56791, AGR [CASE @D56790, COUNT @D56789, 
            PER @D56788, PLU @D56787, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : FLING, 
   [COORD @D56798, PAST @D56797, 
      AGR [CASE @D56796, COUNT @D56795, PER @D56794, PLU @D56793, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : 
   FLING, 
   [COORD @D56804, PAST @D56803, AGR [CASE @D56802, COUNT @D56801, 
            PER @D56800, PLU @D56799, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : FLING, 
   [COORD @D56810, PAST @D56809, 
      AGR [CASE @D56808, COUNT @D56807, PER @D56806, PLU @D56805, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : FLING, 
   [COORD @D56814, AGR [COUNT @D56813, PER @D56812, PLU @D56811, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : FLING, 
   [COORD @D56818, AGR [COUNT @D56817, PER @D56816, PLU @D56815, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : FLING, 
   [COORD @D56822, AGR [COUNT @D56821, PER @D56820, PLU @D56819, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : FLING, 
   [COORD @D56828, PAST @D56827, 
      AGR [CASE @D56826, COUNT @D56825, PER @D56824, PLU @D56823, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : FLING, 
   [COORD @D56834, PAST @D56833, AGR [CASE @D56832, COUNT @D56831, 
            PER @D56830, PLU @D56829, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : FLING, 
   [COORD @D56840, PAST @D56839, 
      AGR [CASE @D56838, COUNT @D56837, PER @D56836, PLU @D56835, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : FLING, 
   [COORD @D56846, PAST @D56845, AGR [CASE @D56844, COUNT @D56843, 
            PER @D56842, PLU @D56841, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : FLING, 
   [COORD @D56852, PAST @D56851, 
      AGR [CASE @D56850, COUNT @D56849, PER @D56848, PLU @D56847, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : FLING, 
   [COORD @D56858, PAST @D56857, AGR [CASE @D56856, COUNT @D56855, 
            PER @D56854, PLU @D56853, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : FLING, 
   [COORD @D56864, PAST @D56863, 
      AGR [CASE @D56862, COUNT @D56861, PER @D56860, PLU @D56859, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, FIN -, 
      ARITY 2] : FLING, 
   [COORD @D56870, PAST @D56869, AGR [CASE @D56868, COUNT @D56867, 
            PER @D56866, PLU @D56865, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, FIN -, ARITY 2] : FLING, 
   [COORD @D56874, 
      AGR [COUNT @D56873, PER @D56872, PLU @D56871, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : FLING, 
   [COORD @D56878, AGR [COUNT @D56877, PER @D56876, PLU @D56875, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : FLING, 
   [COORD @D56882, AGR [COUNT @D56881, PER @D56880, PLU @D56879, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : FLING, 
   [COORD @D56886, AGR [COUNT @D56885, PER @D56884, PLU @D56883, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, PAST +, ARITY 2] : FLING, 
   [COORD @D56892, PAST @D56891, AGR 
         [CASE @D56890, COUNT @D56889, PER @D56888, PLU @D56887, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : FLING, 
   [COORD @D56898, PAST @D56897, AGR [CASE @D56896, COUNT @D56895, 
            PER @D56894, PLU @D56893, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : FLING, 
   [COORD @D56904, PAST @D56903, 
      AGR [CASE @D56902, COUNT @D56901, PER @D56900, PLU @D56899, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, FIN -, 
      ARITY 1] : FLING, 
   [COORD @D56908, AGR [COUNT @D56907, PER @D56906, PLU @D56905, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : FLING, 
   [COORD @D56912, AGR [COUNT @D56911, PER @D56910, PLU @D56909, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : FLING, 
   [COORD @D56916, AGR [COUNT @D56915, PER @D56914, PLU @D56913, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, PAST +, ARITY 1] : FLING.

WORD fly : 
   [COADV @D56947, COORD @D56946, DEF @D56945, PRD @D56944, AGR 
            [CASE @D56943, COUNT @D56942, PER @D56941, PLU @D56940, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FLY, 
   [COORD @D56951, REFL @D56950, PRD @D56949, CASE @D56948, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : FLY, 
   [COORD @D56955, REFL @D56954, PRD @D56953, CASE @D56952, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FLY, 
   [COORD @D56958, 
      AGR [COUNT @D56957, PER @D56956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   FLY, 
   [COORD @D56960, AGR [COUNT @D56959, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FLY, 
   [COORD @D56962, AGR [COUNT @D56961, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : FLY, 
   [COORD @D56966, AGR [COUNT @D56965, PER @D56964, PLU @D56963, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : FLY, 
   [COORD @D56972, PAST @D56971, 
      AGR [CASE @D56970, COUNT @D56969, PER @D56968, PLU @D56967, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   FLY, 
   [COORD @D56975, AGR [COUNT @D56974, PER @D56973, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FLY, 
   [COORD @D56977, AGR [COUNT @D56976, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FLY, 
   [COORD @D56979, AGR [COUNT @D56978, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : FLY, 
   [COORD @D56983, AGR [COUNT @D56982, PER @D56981, PLU @D56980, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : FLY, 
   [COORD @D56989, PAST @D56988, AGR [CASE @D56987, COUNT @D56986, 
            PER @D56985, PLU @D56984, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : FLY, 
   [COORD @D56992, AGR [COUNT @D56991, PER @D56990, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : FLY, 
   [COORD @D56994, AGR [COUNT @D56993, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : FLY, 
   [COORD @D56996, AGR [COUNT @D56995, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : FLY, 
   [COORD @D57000, AGR [COUNT @D56999, PER @D56998, PLU @D56997, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : FLY, 
   [COORD @D57006, PAST @D57005, AGR [CASE @D57004, COUNT @D57003, 
            PER @D57002, PLU @D57001, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : FLY, 
   [COORD @D57009, AGR [COUNT @D57008, PER @D57007, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : FLY, 
   [COORD @D57011, AGR [COUNT @D57010, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : FLY, 
   [COORD @D57013, AGR [COUNT @D57012, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : FLY, 
   [COORD @D57017, AGR [COUNT @D57016, PER @D57015, PLU @D57014, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FROM, ARITY 2] : FLY, 
   [COORD @D57023, PAST @D57022, AGR [CASE @D57021, COUNT @D57020, 
            PER @D57019, PLU @D57018, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM FROM, ARITY 2] : FLY, 
   [COORD @D57026, 
      AGR [COUNT @D57025, PER @D57024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, 
      ARITY 2] : FLY, 
   [COORD @D57028, AGR [COUNT @D57027, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : FLY, 
   [COORD @D57030, AGR [COUNT @D57029, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : FLY, 
   [COORD @D57034, AGR [COUNT @D57033, PER @D57032, PLU @D57031, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : FLY, 
   [COORD @D57040, PAST @D57039, AGR [CASE @D57038, COUNT @D57037, 
            PER @D57036, PLU @D57035, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : FLY, 
   [COORD @D57043, 
      AGR [COUNT @D57042, PER @D57041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   FLY, 
   [COORD @D57045, AGR [COUNT @D57044, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FLY, 
   [COORD @D57047, AGR [COUNT @D57046, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : FLY, 
   [COORD @D57051, AGR [COUNT @D57050, PER @D57049, PLU @D57048, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : FLY, 
   [COORD @D57057, PAST @D57056, AGR 
         [CASE @D57055, COUNT @D57054, PER @D57053, PLU @D57052, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   FLY.

WORD flying : 
   [COADV @D57079, COORD @D57078, DEF @D57077, PRD @D57076, AGR 
            [CASE @D57075, COUNT @D57074, PER @D57073, PLU @D57072, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : FLYING, 
   [COORD @D57083, REFL @D57082, PRD @D57081, CASE @D57080, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : FLYING, 
   [COORD @D57089, PRD @D57088, 
      AGR [CASE @D57087, COUNT @D57086, PER @D57085, PLU @D57084, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FLY, 
   
   [COORD @D57095, PRD @D57094, AGR [CASE @D57093, COUNT @D57092, PER 
               @D57091, PLU @D57090, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FLY, 
   [COORD @D57101, PRD @D57100, AGR 
         [CASE @D57099, COUNT @D57098, PER @D57097, PLU @D57096, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FLY, 
   
   [COORD @D57107, PRD @D57106, AGR [CASE @D57105, COUNT @D57104, PER 
               @D57103, PLU @D57102, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FLY, 
   [COORD @D57113, PRD @D57112, 
      AGR [CASE @D57111, COUNT @D57110, PER @D57109, PLU @D57108, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FLY, 
   [COORD @D57119, PRD @D57118, AGR [CASE @D57117, COUNT @D57116, 
            PER @D57115, PLU @D57114, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FLY.

WORD follow : 
   [COORD @D57143, AGR [COUNT @D57142, PER @D57141, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FOLLOW, 
   [COORD @D57145, 
      AGR [COUNT @D57144, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM WITH, ARITY 3] : FOLLOW, 
   [COORD @D57147, AGR [COUNT @D57146, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FOLLOW, 
   [COORD @D57151, 
      AGR [COUNT @D57150, PER @D57149, PLU @D57148, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : FOLLOW, 
   [COORD @D57157, PAST @D57156, 
      AGR [CASE @D57155, COUNT @D57154, PER @D57153, PLU @D57152, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM WITH, ARITY 3] : FOLLOW, 
   [COORD @D57160, AGR [COUNT @D57159, PER @D57158, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FOLLOW, 
   [COORD @D57162, AGR [COUNT @D57161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FOLLOW, 
   [COORD @D57164, AGR [COUNT @D57163, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FOLLOW, 
   [COORD @D57168, AGR [COUNT @D57167, PER @D57166, PLU @D57165, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FOLLOW, 
   [COORD @D57174, PAST @D57173, AGR [CASE @D57172, COUNT @D57171, 
            PER @D57170, PLU @D57169, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FOLLOW, 
   [COORD @D57177, AGR [COUNT @D57176, PER @D57175, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ROUND, ARITY 2] : FOLLOW, 
   [COORD @D57179, AGR [COUNT @D57178, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ROUND, ARITY 2] : FOLLOW, 
   [COORD @D57181, AGR [COUNT @D57180, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ROUND, ARITY 2] : FOLLOW, 
   [COORD @D57185, AGR [COUNT @D57184, PER @D57183, PLU @D57182, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT ROUND, ARITY 2] : FOLLOW, 
   [COORD @D57191, PAST @D57190, 
      AGR [CASE @D57189, COUNT @D57188, PER @D57187, PLU @D57186, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT ROUND, 
      ARITY 2] : FOLLOW, 
   [COORD @D57194, AGR [COUNT @D57193, PER @D57192, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : FOLLOW, 
   [COORD @D57196, AGR [COUNT @D57195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : FOLLOW, 
   [COORD @D57198, AGR [COUNT @D57197, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : FOLLOW, 
   [COORD @D57202, AGR [COUNT @D57201, PER @D57200, PLU @D57199, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT AROUND, ARITY 2] : FOLLOW, 
   [COORD @D57208, PAST @D57207, 
      AGR [CASE @D57206, COUNT @D57205, PER @D57204, PLU @D57203, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT AROUND, 
      ARITY 2] : FOLLOW, 
   [COORD @D57211, AGR [COUNT @D57210, PER @D57209, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ABOUT, ARITY 2] : FOLLOW, 
   [COORD @D57213, AGR [COUNT @D57212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ABOUT, ARITY 2] : FOLLOW, 
   [COORD @D57215, AGR [COUNT @D57214, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ABOUT, ARITY 2] : FOLLOW, 
   [COORD @D57219, AGR [COUNT @D57218, PER @D57217, PLU @D57216, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT ABOUT, ARITY 2] : FOLLOW, 
   [COORD @D57225, PAST @D57224, 
      AGR [CASE @D57223, COUNT @D57222, PER @D57221, PLU @D57220, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT ABOUT, 
      ARITY 2] : FOLLOW, 
   [COORD @D57228, AGR [COUNT @D57227, PER @D57226, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57230, AGR [COUNT @D57229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57232, AGR [COUNT @D57231, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57236, AGR [COUNT @D57235, PER @D57234, PLU @D57233, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57242, PAST @D57241, 
      AGR [CASE @D57240, COUNT @D57239, PER @D57238, PLU @D57237, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : FOLLOW, 
   [COORD @D57245, AGR [COUNT @D57244, PER @D57243, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57247, AGR [COUNT @D57246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57249, AGR [COUNT @D57248, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57253, AGR [COUNT @D57252, PER @D57251, PLU @D57250, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57259, PAST @D57258, 
      AGR [CASE @D57257, COUNT @D57256, PER @D57255, PLU @D57254, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM ON, ARITY 2] : FOLLOW, 
   [COORD @D57262, AGR [COUNT @D57261, PER @D57260, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM FROM, ARITY 2] : FOLLOW, 
   [COORD @D57264, AGR [COUNT @D57263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM FROM, ARITY 2] : FOLLOW, 
   [COORD @D57266, AGR [COUNT @D57265, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM FROM, ARITY 2] : FOLLOW, 
   [COORD @D57270, AGR [COUNT @D57269, PER @D57268, PLU @D57267, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ON, PFORM FROM, ARITY 2] : FOLLOW, 
   [COORD @D57276, PAST @D57275, 
      AGR [CASE @D57274, COUNT @D57273, PER @D57272, PLU @D57271, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT ON, 
      PFORM FROM, ARITY 2] : FOLLOW, 
   [COORD @D57279, AGR [COUNT @D57278, PER @D57277, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FOLLOW, 
   [COORD @D57281, AGR [COUNT @D57280, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FOLLOW, 
   [COORD @D57283, AGR [COUNT @D57282, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : FOLLOW, 
   [COORD @D57287, AGR [COUNT @D57286, PER @D57285, PLU @D57284, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : FOLLOW, 
   [COORD @D57293, PAST @D57292, 
      AGR [CASE @D57291, COUNT @D57290, PER @D57289, PLU @D57288, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : FOLLOW, 
   [COORD @D57296, AGR [COUNT @D57295, PER @D57294, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : FOLLOW, 
   [COORD @D57298, AGR [COUNT @D57297, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : FOLLOW, 
   [COORD @D57300, AGR [COUNT @D57299, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : FOLLOW, 
   [COORD @D57304, AGR [COUNT @D57303, PER @D57302, PLU @D57301, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT THROUGH, ARITY 2] : FOLLOW, 
   [COORD @D57310, PAST @D57309, 
      AGR [CASE @D57308, COUNT @D57307, PER @D57306, PLU @D57305, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : FOLLOW, 
   [COORD @D57313, AGR [COUNT @D57312, PER @D57311, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FOLLOW, 
   [COORD @D57315, AGR [COUNT @D57314, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FOLLOW, 
   [COORD @D57317, AGR [COUNT @D57316, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : FOLLOW, 
   [COORD @D57321, AGR [COUNT @D57320, PER @D57319, PLU @D57318, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : FOLLOW, 
   [COORD @D57327, PAST @D57326, 
      AGR [CASE @D57325, COUNT @D57324, PER @D57323, PLU @D57322, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : FOLLOW, 
   [COORD @D57330, AGR [COUNT @D57329, PER @D57328, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FOLLOW, 
   [COORD @D57332, AGR [COUNT @D57331, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FOLLOW, 
   [COORD @D57334, AGR [COUNT @D57333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FOLLOW, 
   [COORD @D57338, AGR [COUNT @D57337, PER @D57336, PLU @D57335, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FOLLOW, 
   [COORD @D57344, PAST @D57343, AGR [CASE @D57342, COUNT @D57341, 
            PER @D57340, PLU @D57339, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FOLLOW, 
   [COORD @D57347, AGR [COUNT @D57346, PER @D57345, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FOLLOW, 
   [COORD @D57349, AGR [COUNT @D57348, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FOLLOW, 
   [COORD @D57351, AGR [COUNT @D57350, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FOLLOW, 
   [COORD @D57355, AGR [COUNT @D57354, PER @D57353, PLU @D57352, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FOLLOW, 
   [COORD @D57361, PAST @D57360, 
      AGR [CASE @D57359, COUNT @D57358, PER @D57357, PLU @D57356, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : FOLLOW, 
   [COORD @D57364, AGR [COUNT @D57363, PER @D57362, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : FOLLOW, 
   [COORD @D57366, AGR [COUNT @D57365, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : FOLLOW, 
   [COORD @D57368, AGR [COUNT @D57367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : FOLLOW, 
   [COORD @D57372, AGR [COUNT @D57371, PER @D57370, PLU @D57369, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : FOLLOW, 
   [COORD @D57378, PAST @D57377, 
      AGR [CASE @D57376, COUNT @D57375, PER @D57374, PLU @D57373, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT THROUGH, 
      ARITY 1] : FOLLOW, 
   [COORD @D57381, AGR [COUNT @D57380, PER @D57379, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : FOLLOW, 
   [COORD @D57383, AGR [COUNT @D57382, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : FOLLOW, 
   [COORD @D57385, AGR [COUNT @D57384, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : FOLLOW, 
   [COORD @D57389, AGR [COUNT @D57388, PER @D57387, PLU @D57386, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : FOLLOW, 
   [COORD @D57395, PAST @D57394, 
      AGR [CASE @D57393, COUNT @D57392, PER @D57391, PLU @D57390, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ROUND, 
      ARITY 1] : FOLLOW, 
   [COORD @D57398, AGR [COUNT @D57397, PER @D57396, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FOLLOW, 
   [COORD @D57400, AGR [COUNT @D57399, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FOLLOW, 
   [COORD @D57402, AGR [COUNT @D57401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FOLLOW, 
   [COORD @D57406, AGR [COUNT @D57405, PER @D57404, PLU @D57403, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : FOLLOW, 
   [COORD @D57412, PAST @D57411, 
      AGR [CASE @D57410, COUNT @D57409, PER @D57408, PLU @D57407, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : FOLLOW, 
   [COORD @D57415, AGR [COUNT @D57414, PER @D57413, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FOLLOW, 
   [COORD @D57417, AGR [COUNT @D57416, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FOLLOW, 
   [COORD @D57419, AGR [COUNT @D57418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FOLLOW, 
   [COORD @D57423, AGR [COUNT @D57422, PER @D57421, PLU @D57420, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : FOLLOW, 
   [COORD @D57429, PAST @D57428, 
      AGR [CASE @D57427, COUNT @D57426, PER @D57425, PLU @D57424, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : FOLLOW, 
   [COORD @D57432, AGR [COUNT @D57431, PER @D57430, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : FOLLOW, 
   [COORD @D57434, AGR [COUNT @D57433, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : FOLLOW, 
   [COORD @D57436, AGR [COUNT @D57435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : FOLLOW, 
   [COORD @D57440, AGR [COUNT @D57439, PER @D57438, PLU @D57437, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : FOLLOW, 
   [COORD @D57446, PAST @D57445, 
      AGR [CASE @D57444, COUNT @D57443, PER @D57442, PLU @D57441, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AROUND, 
      ARITY 1] : FOLLOW, 
   [COORD @D57449, AGR [COUNT @D57448, PER @D57447, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : FOLLOW, 
   [COORD @D57451, AGR [COUNT @D57450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : FOLLOW, 
   [COORD @D57453, AGR [COUNT @D57452, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : FOLLOW, 
   [COORD @D57457, AGR [COUNT @D57456, PER @D57455, PLU @D57454, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : FOLLOW, 
   [COORD @D57463, PAST @D57462, 
      AGR [CASE @D57461, COUNT @D57460, PER @D57459, PLU @D57458, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ABOUT, 
      ARITY 1] : FOLLOW, 
   [COORD @D57468, PAST @D57467, AGR [COUNT @D57466, PER @D57465, 
            PLU @D57464, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, V +, 
      SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 1] : FOLLOW.

WORD followed : 
   [COORD @D57476, AGR [CASE @D57475, COUNT @D57474, PER @D57473, 
            PLU @D57472, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57481, AGR [CASE @D57480, COUNT @D57479, PER @D57478, 
            PLU @D57477, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57486, 
      AGR [CASE @D57485, COUNT @D57484, PER @D57483, PLU @D57482, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57491, AGR [CASE @D57490, COUNT @D57489, PER @D57488, 
            PLU @D57487, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57496, AGR [CASE @D57495, COUNT @D57494, PER @D57493, 
            PLU @D57492, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57501, AGR [CASE @D57500, COUNT @D57499, PER @D57498, 
            PLU @D57497, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57506, AGR [CASE @D57505, COUNT @D57504, PER @D57503, 
            PLU @D57502, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57511, AGR [CASE @D57510, COUNT @D57509, PER @D57508, 
            PLU @D57507, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57516, AGR [CASE @D57515, COUNT @D57514, PER @D57513, 
            PLU @D57512, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57521, AGR [CASE @D57520, COUNT @D57519, PER @D57518, 
            PLU @D57517, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57526, AGR [CASE @D57525, COUNT @D57524, PER @D57523, 
            PLU @D57522, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57531, AGR [CASE @D57530, COUNT @D57529, PER @D57528, 
            PLU @D57527, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57536, AGR [CASE @D57535, COUNT @D57534, PER @D57533, 
            PLU @D57532, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57541, AGR [CASE @D57540, COUNT @D57539, PER @D57538, 
            PLU @D57537, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57546, AGR [CASE @D57545, COUNT @D57544, PER @D57543, 
            PLU @D57542, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57551, AGR [CASE @D57550, COUNT @D57549, PER @D57548, 
            PLU @D57547, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57556, AGR [CASE @D57555, COUNT @D57554, PER @D57553, 
            PLU @D57552, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57561, AGR [CASE @D57560, COUNT @D57559, PER @D57558, 
            PLU @D57557, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57566, AGR [CASE @D57565, COUNT @D57564, PER @D57563, 
            PLU @D57562, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57571, AGR [CASE @D57570, COUNT @D57569, PER @D57568, 
            PLU @D57567, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57576, AGR [CASE @D57575, COUNT @D57574, PER @D57573, 
            PLU @D57572, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57581, AGR [CASE @D57580, COUNT @D57579, PER @D57578, 
            PLU @D57577, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57586, AGR [CASE @D57585, COUNT @D57584, PER @D57583, 
            PLU @D57582, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57591, AGR [CASE @D57590, COUNT @D57589, PER @D57588, 
            PLU @D57587, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57596, AGR [CASE @D57595, COUNT @D57594, PER @D57593, 
            PLU @D57592, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57601, AGR [CASE @D57600, COUNT @D57599, PER @D57598, 
            PLU @D57597, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57606, AGR [CASE @D57605, COUNT @D57604, PER @D57603, 
            PLU @D57602, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57611, AGR [CASE @D57610, COUNT @D57609, PER @D57608, 
            PLU @D57607, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57616, AGR [CASE @D57615, COUNT @D57614, PER @D57613, 
            PLU @D57612, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57621, AGR [CASE @D57620, COUNT @D57619, PER @D57618, 
            PLU @D57617, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57626, AGR [CASE @D57625, COUNT @D57624, PER @D57623, 
            PLU @D57622, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57631, AGR [CASE @D57630, COUNT @D57629, PER @D57628, 
            PLU @D57627, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57636, AGR [CASE @D57635, COUNT @D57634, PER @D57633, 
            PLU @D57632, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57641, AGR [CASE @D57640, COUNT @D57639, PER @D57638, 
            PLU @D57637, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57646, AGR [CASE @D57645, COUNT @D57644, PER @D57643, 
            PLU @D57642, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57651, AGR [CASE @D57650, COUNT @D57649, PER @D57648, 
            PLU @D57647, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57656, AGR [CASE @D57655, COUNT @D57654, PER @D57653, 
            PLU @D57652, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57661, AGR [CASE @D57660, COUNT @D57659, PER @D57658, 
            PLU @D57657, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57666, AGR [CASE @D57665, COUNT @D57664, PER @D57663, 
            PLU @D57662, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57671, AGR [CASE @D57670, COUNT @D57669, PER @D57668, 
            PLU @D57667, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57676, AGR [CASE @D57675, COUNT @D57674, PER @D57673, 
            PLU @D57672, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57681, AGR [CASE @D57680, COUNT @D57679, PER @D57678, 
            PLU @D57677, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57686, AGR [CASE @D57685, COUNT @D57684, PER @D57683, 
            PLU @D57682, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57691, AGR [CASE @D57690, COUNT @D57689, PER @D57688, 
            PLU @D57687, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57696, AGR [CASE @D57695, COUNT @D57694, PER @D57693, 
            PLU @D57692, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57701, AGR [CASE @D57700, COUNT @D57699, PER @D57698, 
            PLU @D57697, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57706, AGR [CASE @D57705, COUNT @D57704, PER @D57703, 
            PLU @D57702, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57710, AGR [COUNT @D57709, PER @D57708, PLU @D57707, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57714, AGR [COUNT @D57713, PER @D57712, PLU @D57711, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : FOLLOW.

WORD following : 
   [COORD @D57725, PRD @D57724, AGR [CASE @D57723, COUNT @D57722, 
            PER @D57721, PLU @D57720, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57731, PRD @D57730, 
      AGR [CASE @D57729, COUNT @D57728, PER @D57727, PLU @D57726, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FOLLOW, 
   [COORD @D57737, PRD @D57736, AGR [CASE @D57735, COUNT @D57734, 
            PER @D57733, PLU @D57732, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57743, PRD @D57742, 
      AGR [CASE @D57741, COUNT @D57740, PER @D57739, PLU @D57738, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FOLLOW, 
   [COORD @D57749, PRD @D57748, AGR [CASE @D57747, COUNT @D57746, 
            PER @D57745, PLU @D57744, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57755, PRD @D57754, 
      AGR [CASE @D57753, COUNT @D57752, PER @D57751, PLU @D57750, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FOLLOW, 
   [COORD @D57761, PRD @D57760, AGR [CASE @D57759, COUNT @D57758, 
            PER @D57757, PLU @D57756, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57767, PRD @D57766, 
      AGR [CASE @D57765, COUNT @D57764, PER @D57763, PLU @D57762, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ON, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FOLLOW, 
   [COORD @D57773, PRD @D57772, AGR [CASE @D57771, COUNT @D57770, 
            PER @D57769, PLU @D57768, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57779, PRD @D57778, 
      AGR [CASE @D57777, COUNT @D57776, PER @D57775, PLU @D57774, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FOLLOW, 
   [COORD @D57785, PRD @D57784, AGR [CASE @D57783, COUNT @D57782, 
            PER @D57781, PLU @D57780, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57791, PRD @D57790, 
      AGR [CASE @D57789, COUNT @D57788, PER @D57787, PLU @D57786, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FOLLOW, 
   [COORD @D57797, PRD @D57796, AGR [CASE @D57795, COUNT @D57794, 
            PER @D57793, PLU @D57792, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57803, PRD @D57802, 
      AGR [CASE @D57801, COUNT @D57800, PER @D57799, PLU @D57798, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FOLLOW, 
   [COORD @D57809, PRD @D57808, AGR [CASE @D57807, COUNT @D57806, 
            PER @D57805, PLU @D57804, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57815, PRD @D57814, 
      AGR [CASE @D57813, COUNT @D57812, PER @D57811, PLU @D57810, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FOLLOW, 
   [COORD @D57821, PRD @D57820, AGR [CASE @D57819, COUNT @D57818, 
            PER @D57817, PLU @D57816, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57827, PRD @D57826, 
      AGR [CASE @D57825, COUNT @D57824, PER @D57823, PLU @D57822, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FOLLOW, 
   [COORD @D57833, PRD @D57832, AGR [CASE @D57831, COUNT @D57830, 
            PER @D57829, PLU @D57828, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57838, PRD @D57837, 
      AGR [COUNT @D57836, PER @D57835, PLU @D57834, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FOLLOW.

WORD follows : 
   [COORD @D57843, AGR [COUNT @D57842, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57845, AGR [COUNT @D57844, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57847, 
      AGR [COUNT @D57846, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57849, 
      AGR [COUNT @D57848, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57851, 
      AGR [COUNT @D57850, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57853, 
      AGR [COUNT @D57852, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57855, 
      AGR [COUNT @D57854, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FOLLOW, 
   [COORD @D57857, AGR [COUNT @D57856, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ON, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FOLLOW, 
   [COORD @D57859, AGR [COUNT @D57858, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57861, 
      AGR [COUNT @D57860, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57863, 
      AGR [COUNT @D57862, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57865, 
      AGR [COUNT @D57864, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57867, 
      AGR [COUNT @D57866, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57869, 
      AGR [COUNT @D57868, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FOLLOW, 
   [COORD @D57871, AGR [COUNT @D57870, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57873, 
      AGR [COUNT @D57872, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57875, 
      AGR [COUNT @D57874, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57877, 
      AGR [COUNT @D57876, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57879, 
      AGR [COUNT @D57878, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW, 
   [COORD @D57882, 
      AGR [CASE @D57881, COUNT @D57880, N +, V -, BAR 2, NFORM IT, PLU -, 
            PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOLLOW.

WORD football : 
   [COORD @D57889, REFL @D57888, COUNT @D57887, PRD @D57886, 
      CASE @D57885, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FOOTBALL.

WORD footballs : 
   [COORD @D57898, DEMON @D57897, REFL @D57896, PRD @D57895, 
      CASE @D57894, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FOOTBALL.

WORD force : 
   [COORD @D57909, REFL @D57908, COUNT @D57907, PRD @D57906, CASE 
         @D57905, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FORCE, 
   [COORD @D57912, 
      AGR [COUNT @D57911, PER @D57910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : FORCE, 
   [COORD @D57914, AGR [COUNT @D57913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : FORCE, 
   [COORD @D57916, AGR [COUNT @D57915, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : FORCE, 
   [COORD @D57920, AGR [COUNT @D57919, PER @D57918, PLU @D57917, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : FORCE, 
   [COORD @D57926, PAST @D57925, AGR [CASE @D57924, COUNT @D57923, 
            PER @D57922, PLU @D57921, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : FORCE, 
   [COORD @D57929, AGR [COUNT @D57928, PER @D57927, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : FORCE, 
   [COORD @D57931, AGR [COUNT @D57930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : FORCE, 
   [COORD @D57933, AGR [COUNT @D57932, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : FORCE, 
   [COORD @D57937, AGR [COUNT @D57936, PER @D57935, PLU @D57934, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : FORCE, 
   [COORD @D57943, PAST @D57942, AGR [CASE @D57941, COUNT @D57940, 
            PER @D57939, PLU @D57938, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : FORCE, 
   [COORD @D57946, AGR [COUNT @D57945, PER @D57944, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PREP OUT_OF, ARITY 3] : FORCE, 
   [COORD @D57948, AGR [COUNT @D57947, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PREP OUT_OF, ARITY 3] : FORCE, 
   [COORD @D57950, AGR [COUNT @D57949, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PREP OUT_OF, ARITY 3] : FORCE, 
   [COORD @D57954, AGR [COUNT @D57953, PER @D57952, PLU @D57951, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PREP OUT_OF, ARITY 3] : FORCE, 
   [COORD @D57960, PAST @D57959, 
      AGR [CASE @D57958, COUNT @D57957, PER @D57956, PLU @D57955, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, PREP OUT_OF, 
      ARITY 3] : FORCE, 
   [COORD @D57963, AGR [COUNT @D57962, PER @D57961, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FORCE, 
   [COORD @D57965, AGR [COUNT @D57964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FORCE, 
   [COORD @D57967, AGR [COUNT @D57966, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FORCE, 
   [COORD @D57971, AGR [COUNT @D57970, PER @D57969, PLU @D57968, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FORCE, 
   [COORD @D57977, PAST @D57976, 
      AGR [CASE @D57975, COUNT @D57974, PER @D57973, PLU @D57972, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, 
      ARITY 3] : FORCE, 
   [COORD @D57980, AGR [COUNT @D57979, PER @D57978, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FORCE, 
   [COORD @D57982, AGR [COUNT @D57981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FORCE, 
   [COORD @D57984, AGR [COUNT @D57983, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FORCE, 
   [COORD @D57988, AGR [COUNT @D57987, PER @D57986, PLU @D57985, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FORCE, 
   [COORD @D57994, PAST @D57993, 
      AGR [CASE @D57992, COUNT @D57991, PER @D57990, PLU @D57989, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, 
      ARITY 3] : FORCE, 
   [COORD @D57997, AGR [COUNT @D57996, PER @D57995, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORCE, 
   [COORD @D57999, AGR [COUNT @D57998, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORCE, 
   [COORD @D58001, AGR [COUNT @D58000, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORCE, 
   [COORD @D58005, AGR [COUNT @D58004, PER @D58003, PLU @D58002, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORCE, 
   [COORD @D58011, PAST @D58010, 
      AGR [CASE @D58009, COUNT @D58008, PER @D58007, PLU @D58006, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM INTO, 
      ARITY 3] : FORCE, 
   [COORD @D58014, AGR [COUNT @D58013, PER @D58012, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORCE, 
   [COORD @D58016, AGR [COUNT @D58015, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORCE, 
   [COORD @D58018, AGR [COUNT @D58017, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORCE, 
   [COORD @D58022, AGR [COUNT @D58021, PER @D58020, PLU @D58019, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORCE, 
   [COORD @D58028, PAST @D58027, 
      AGR [CASE @D58026, COUNT @D58025, PER @D58024, PLU @D58023, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : FORCE, 
   [COORD @D58031, AGR [COUNT @D58030, PER @D58029, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FORCE, 
   [COORD @D58033, AGR [COUNT @D58032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FORCE, 
   [COORD @D58035, AGR [COUNT @D58034, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FORCE, 
   [COORD @D58039, AGR [COUNT @D58038, PER @D58037, PLU @D58036, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FORCE, 
   [COORD @D58045, PAST @D58044, AGR [CASE @D58043, COUNT @D58042, 
            PER @D58041, PLU @D58040, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FORCE.

WORD forced : 
   [COADV @D58061, COORD @D58060, DEF @D58059, PRD @D58058, AGR 
            [CASE @D58057, COUNT @D58056, PER @D58055, PLU @D58054, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : FORCED, 
   [COORD @D58067, AGR [CASE @D58066, NFORM @D58065, COUNT @D58064, 
            PER @D58063, PLU @D58062, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FORCE, 
   [COORD @D58072, AGR [CASE @D58071, COUNT @D58070, PER @D58069, 
            PLU @D58068, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58077, AGR [CASE @D58076, COUNT @D58075, PER @D58074, 
            PLU @D58073, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58082, AGR [CASE @D58081, COUNT @D58080, PER @D58079, 
            PLU @D58078, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58087, AGR [CASE @D58086, COUNT @D58085, PER @D58084, 
            PLU @D58083, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58093, AGR [CASE @D58092, NFORM @D58091, COUNT @D58090, 
            PER @D58089, PLU @D58088, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FORCE, 
   [COORD @D58098, AGR [CASE @D58097, COUNT @D58096, PER @D58095, 
            PLU @D58094, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, PREP OUT_OF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58103, AGR [CASE @D58102, COUNT @D58101, PER @D58100, 
            PLU @D58099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PREP OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58108, AGR [CASE @D58107, COUNT @D58106, PER @D58105, 
            PLU @D58104, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PREP OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58113, AGR [CASE @D58112, COUNT @D58111, PER @D58110, 
            PLU @D58109, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58118, AGR [CASE @D58117, COUNT @D58116, PER @D58115, 
            PLU @D58114, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58123, AGR [CASE @D58122, COUNT @D58121, PER @D58120, 
            PLU @D58119, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58128, AGR [CASE @D58127, COUNT @D58126, PER @D58125, 
            PLU @D58124, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58133, AGR [CASE @D58132, COUNT @D58131, PER @D58130, 
            PLU @D58129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58138, AGR [CASE @D58137, COUNT @D58136, PER @D58135, 
            PLU @D58134, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58143, AGR [CASE @D58142, COUNT @D58141, PER @D58140, 
            PLU @D58139, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58148, AGR [CASE @D58147, COUNT @D58146, PER @D58145, 
            PLU @D58144, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58153, AGR [CASE @D58152, COUNT @D58151, PER @D58150, 
            PLU @D58149, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58158, AGR [CASE @D58157, COUNT @D58156, PER @D58155, 
            PLU @D58154, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58163, AGR [CASE @D58162, COUNT @D58161, PER @D58160, 
            PLU @D58159, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58168, AGR [CASE @D58167, COUNT @D58166, PER @D58165, 
            PLU @D58164, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58173, AGR [CASE @D58172, COUNT @D58171, PER @D58170, 
            PLU @D58169, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FORCE, 
   [COORD @D58178, AGR [CASE @D58177, COUNT @D58176, PER @D58175, 
            PLU @D58174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58183, AGR [CASE @D58182, COUNT @D58181, PER @D58180, 
            PLU @D58179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FORCE.

WORD forces : 
   [COORD @D58195, REFL @D58194, PRD @D58193, CASE @D58192, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : FORCES, 
   [COORD @D58200, DEMON @D58199, REFL @D58198, PRD @D58197, 
      CASE @D58196, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FORCE, 
   [COORD @D58202, 
      AGR [COUNT @D58201, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FORCE, 
   [COORD @D58204, 
      AGR [COUNT @D58203, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FORCE, 
   [COORD @D58206, 
      AGR [COUNT @D58205, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PREP OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FORCE, 
   [COORD @D58208, AGR [COUNT @D58207, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FORCE, 
   [COORD @D58210, AGR [COUNT @D58209, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FORCE, 
   [COORD @D58212, AGR [COUNT @D58211, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FORCE, 
   [COORD @D58214, AGR [COUNT @D58213, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FORCE, 
   [COORD @D58216, AGR [COUNT @D58215, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FORCE.

WORD forcing : 
   [COORD @D58243, PRD @D58242, AGR [CASE @D58241, COUNT @D58240, 
            PER @D58239, PLU @D58238, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58249, PRD @D58248, 
      AGR [CASE @D58247, COUNT @D58246, PER @D58245, PLU @D58244, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FORCE, 
   [COORD @D58255, PRD @D58254, AGR [CASE @D58253, COUNT @D58252, 
            PER @D58251, PLU @D58250, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, 
      PREP OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58261, PRD @D58260, 
      AGR [CASE @D58259, COUNT @D58258, PER @D58257, PLU @D58256, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FORCE, 
   [COORD @D58267, PRD @D58266, AGR [CASE @D58265, COUNT @D58264, 
            PER @D58263, PLU @D58262, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58273, PRD @D58272, 
      AGR [CASE @D58271, COUNT @D58270, PER @D58269, PLU @D58268, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FORCE, 
   [COORD @D58279, PRD @D58278, AGR [CASE @D58277, COUNT @D58276, 
            PER @D58275, PLU @D58274, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FORCE, 
   [COORD @D58285, PRD @D58284, 
      AGR [CASE @D58283, COUNT @D58282, PER @D58281, PLU @D58280, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FORCE.

WORD form : 
   [COORD @D58292, REFL @D58291, PRD @D58290, CASE @D58289, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : FORM, 
   [COORD @D58297, REFL @D58296, COUNT @D58295, PRD @D58294, 
      CASE @D58293, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FORM, 
   [COORD @D58301, REFL @D58300, PRD @D58299, CASE @D58298, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : FORM, 
   [COORD @D58304, 
      AGR [COUNT @D58303, PER @D58302, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OUT_OF, ARITY 3] : FORM, 
   [COORD @D58306, AGR [COUNT @D58305, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OUT_OF, ARITY 3] : FORM, 
   [COORD @D58308, AGR [COUNT @D58307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OUT_OF, ARITY 3] : FORM, 
   [COORD @D58312, AGR [COUNT @D58311, PER @D58310, PLU @D58309, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OUT_OF, ARITY 3] : FORM, 
   [COORD @D58318, PAST @D58317, 
      AGR [CASE @D58316, COUNT @D58315, PER @D58314, PLU @D58313, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OUT_OF, ARITY 3] : FORM, 
   [COORD @D58321, AGR [COUNT @D58320, PER @D58319, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORM, 
   [COORD @D58323, AGR [COUNT @D58322, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORM, 
   [COORD @D58325, AGR [COUNT @D58324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORM, 
   [COORD @D58329, AGR [COUNT @D58328, PER @D58327, PLU @D58326, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : FORM, 
   [COORD @D58335, PAST @D58334, 
      AGR [CASE @D58333, COUNT @D58332, PER @D58331, PLU @D58330, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM INTO, 
      ARITY 3] : FORM, 
   [COORD @D58338, AGR [COUNT @D58337, PER @D58336, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORM, 
   [COORD @D58340, AGR [COUNT @D58339, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORM, 
   [COORD @D58342, AGR [COUNT @D58341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORM, 
   [COORD @D58346, AGR [COUNT @D58345, PER @D58344, PLU @D58343, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : FORM, 
   [COORD @D58352, PAST @D58351, 
      AGR [CASE @D58350, COUNT @D58349, PER @D58348, PLU @D58347, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : FORM, 
   [COORD @D58355, AGR [COUNT @D58354, PER @D58353, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : FORM, 
   [COORD @D58357, AGR [COUNT @D58356, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : FORM, 
   [COORD @D58359, AGR [COUNT @D58358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : FORM, 
   [COORD @D58363, AGR [COUNT @D58362, PER @D58361, PLU @D58360, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : FORM, 
   [COORD @D58369, PAST @D58368, AGR [CASE @D58367, COUNT @D58366, 
            PER @D58365, PLU @D58364, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : FORM, 
   [COORD @D58372, AGR [COUNT @D58371, PER @D58370, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FORM, 
   [COORD @D58374, AGR [COUNT @D58373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FORM, 
   [COORD @D58376, AGR [COUNT @D58375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FORM, 
   [COORD @D58380, AGR [COUNT @D58379, PER @D58378, PLU @D58377, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FORM, 
   [COORD @D58386, PAST @D58385, AGR [CASE @D58384, COUNT @D58383, 
            PER @D58382, PLU @D58381, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FORM, 
   [COORD @D58389, AGR [COUNT @D58388, PER @D58387, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM INTO, ARITY 2] : FORM, 
   [COORD @D58391, AGR [COUNT @D58390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM INTO, ARITY 2] : FORM, 
   [COORD @D58393, AGR [COUNT @D58392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM INTO, ARITY 2] : FORM, 
   [COORD @D58397, AGR [COUNT @D58396, PER @D58395, PLU @D58394, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM INTO, ARITY 2] : FORM, 
   [COORD @D58403, PAST @D58402, 
      AGR [CASE @D58401, COUNT @D58400, PER @D58399, PLU @D58398, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM INTO, ARITY 2] : FORM, 
   [COORD @D58406, AGR [COUNT @D58405, PER @D58404, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FORM, 
   [COORD @D58408, AGR [COUNT @D58407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FORM, 
   [COORD @D58410, AGR [COUNT @D58409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FORM, 
   [COORD @D58414, AGR [COUNT @D58413, PER @D58412, PLU @D58411, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FORM, 
   [COORD @D58420, PAST @D58419, AGR [CASE @D58418, COUNT @D58417, 
            PER @D58416, PLU @D58415, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FORM, 
   [COORD @D58423, AGR [COUNT @D58422, PER @D58421, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FORM, 
   [COORD @D58425, AGR [COUNT @D58424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FORM, 
   [COORD @D58427, AGR [COUNT @D58426, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FORM, 
   [COORD @D58431, AGR [COUNT @D58430, PER @D58429, PLU @D58428, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : FORM, 
   [COORD @D58437, PAST @D58436, 
      AGR [CASE @D58435, COUNT @D58434, PER @D58433, PLU @D58432, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : FORM.

WORD formed : 
   [COORD @D58450, AGR [CASE @D58449, COUNT @D58448, PER @D58447, 
            PLU @D58446, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58455, AGR [CASE @D58454, COUNT @D58453, PER @D58452, 
            PLU @D58451, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58460, AGR [CASE @D58459, COUNT @D58458, PER @D58457, 
            PLU @D58456, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OUT_OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORM, 
   [COORD @D58465, AGR [CASE @D58464, COUNT @D58463, PER @D58462, 
            PLU @D58461, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58470, AGR [CASE @D58469, COUNT @D58468, PER @D58467, 
            PLU @D58466, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58475, AGR [CASE @D58474, COUNT @D58473, PER @D58472, 
            PLU @D58471, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORM, 
   [COORD @D58480, AGR [CASE @D58479, COUNT @D58478, PER @D58477, 
            PLU @D58476, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58485, AGR [CASE @D58484, COUNT @D58483, PER @D58482, 
            PLU @D58481, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58490, AGR [CASE @D58489, COUNT @D58488, PER @D58487, 
            PLU @D58486, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORM, 
   [COORD @D58495, AGR [CASE @D58494, COUNT @D58493, PER @D58492, 
            PLU @D58491, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58500, AGR [CASE @D58499, COUNT @D58498, PER @D58497, 
            PLU @D58496, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FORM, 
   [COORD @D58505, AGR [CASE @D58504, COUNT @D58503, PER @D58502, 
            PLU @D58501, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58510, AGR [CASE @D58509, COUNT @D58508, PER @D58507, 
            PLU @D58506, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FORM, 
   [COORD @D58515, AGR [CASE @D58514, COUNT @D58513, PER @D58512, 
            PLU @D58511, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FORM, 
   [COORD @D58520, AGR [CASE @D58519, COUNT @D58518, PER @D58517, 
            PLU @D58516, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58525, AGR [CASE @D58524, COUNT @D58523, PER @D58522, 
            PLU @D58521, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FORM, 
   [COORD @D58530, AGR [CASE @D58529, COUNT @D58528, PER @D58527, 
            PLU @D58526, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58535, AGR [CASE @D58534, COUNT @D58533, PER @D58532, 
            PLU @D58531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FORM, 
   [COORD @D58540, AGR [CASE @D58539, COUNT @D58538, PER @D58537, 
            PLU @D58536, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58545, AGR [CASE @D58544, COUNT @D58543, PER @D58542, 
            PLU @D58541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : FORM.

WORD forming : 
   [COORD @D58564, PRD @D58563, AGR [CASE @D58562, COUNT @D58561, 
            PER @D58560, PLU @D58559, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58570, PRD @D58569, 
      AGR [CASE @D58568, COUNT @D58567, PER @D58566, PLU @D58565, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FORM, 
   [COORD @D58576, PRD @D58575, AGR [CASE @D58574, COUNT @D58573, 
            PER @D58572, PLU @D58571, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58582, PRD @D58581, 
      AGR [CASE @D58580, COUNT @D58579, PER @D58578, PLU @D58577, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   FORM, 
   [COORD @D58588, PRD @D58587, AGR [CASE @D58586, COUNT @D58585, 
            PER @D58584, PLU @D58583, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58594, PRD @D58593, 
      AGR [CASE @D58592, COUNT @D58591, PER @D58590, PLU @D58589, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FORM, 
   [COORD @D58600, PRD @D58599, AGR [CASE @D58598, COUNT @D58597, 
            PER @D58596, PLU @D58595, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FORM, 
   [COORD @D58606, PRD @D58605, 
      AGR [CASE @D58604, COUNT @D58603, PER @D58602, PLU @D58601, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : FORM.

WORD forms : 
   [COORD @D58618, DEMON @D58617, REFL @D58616, PRD @D58615, CASE 
         @D58614, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FORM, 
   [COORD @D58623, DEMON @D58622, REFL @D58621, PRD @D58620, 
      CASE @D58619, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FORM, 
   [COORD @D58628, DEMON @D58627, REFL @D58626, PRD @D58625, 
      CASE @D58624, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   FORM, 
   [COORD @D58630, AGR [COUNT @D58629, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FORM, 
   [COORD @D58632, AGR [COUNT @D58631, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FORM, 
   [COORD @D58634, AGR [COUNT @D58633, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FORM, 
   [COORD @D58636, AGR [COUNT @D58635, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FORM, 
   [COORD @D58638, 
      AGR [COUNT @D58637, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FORM, 
   [COORD @D58640, 
      AGR [COUNT @D58639, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   FORM, 
   [COORD @D58642, AGR [COUNT @D58641, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FORM, 
   [COORD @D58644, 
      AGR [COUNT @D58643, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FORM.

WORD fought : 
   [COORD @D58652, PAST @D58651, AGR [CASE @D58650, COUNT @D58649, 
            PER @D58648, PLU @D58647, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : FIGHT, 
   [COORD @D58658, PAST @D58657, 
      AGR [CASE @D58656, COUNT @D58655, PER @D58654, PLU @D58653, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : FIGHT, 
   [COORD @D58664, PAST @D58663, 
      AGR [CASE @D58662, COUNT @D58661, PER @D58660, PLU @D58659, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, FIN -, 
      ARITY 2] : FIGHT, 
   [COORD @D58670, PAST @D58669, AGR [CASE @D58668, COUNT @D58667, 
            PER @D58666, PLU @D58665, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT OUT, FIN -, ARITY 2] : FIGHT, 
   [COORD @D58676, PAST @D58675, 
      AGR [CASE @D58674, COUNT @D58673, PER @D58672, PLU @D58671, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM WITH, FIN -, 
      ARITY 2] : FIGHT, 
   [COORD @D58682, PAST @D58681, AGR [CASE @D58680, COUNT @D58679, 
            PER @D58678, PLU @D58677, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM OVER, FIN -, ARITY 2] : FIGHT, 
   [COORD @D58688, PAST @D58687, 
      AGR [CASE @D58686, COUNT @D58685, PER @D58684, PLU @D58683, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM AGAINST, FIN -, 
      ARITY 2] : FIGHT, 
   [COORD @D58694, PAST @D58693, AGR [CASE @D58692, COUNT @D58691, 
            PER @D58690, PLU @D58689, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : FIGHT, 
   [COORD @D58700, PAST @D58699, 
      AGR [CASE @D58698, COUNT @D58697, PER @D58696, PLU @D58695, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : FIGHT, 
   [COORD @D58704, AGR [COUNT @D58703, PER @D58702, PLU @D58701, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : FIGHT, 
   [COORD @D58708, AGR [COUNT @D58707, PER @D58706, PLU @D58705, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, 
      PAST +, ARITY 2] : FIGHT, 
   [COORD @D58712, AGR [COUNT @D58711, PER @D58710, PLU @D58709, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM WITH, PAST +, ARITY 2] : FIGHT, 
   [COORD @D58716, AGR [COUNT @D58715, PER @D58714, PLU @D58713, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OVER, PAST +, ARITY 2] : FIGHT, 
   [COORD @D58720, AGR [COUNT @D58719, PER @D58718, PLU @D58717, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, PAST +, ARITY 2] : FIGHT, 
   [COORD @D58724, AGR [COUNT @D58723, PER @D58722, PLU @D58721, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : FIGHT, 
   [COORD @D58730, PAST @D58729, AGR [CASE @D58728, COUNT @D58727, 
            PER @D58726, PLU @D58725, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : FIGHT, 
   [COORD @D58736, PAST @D58735, 
      AGR [CASE @D58734, COUNT @D58733, PER @D58732, PLU @D58731, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : FIGHT, 
   [COORD @D58742, PAST @D58741, AGR [CASE @D58740, COUNT @D58739, 
            PER @D58738, PLU @D58737, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : FIGHT, 
   [COORD @D58748, PAST @D58747, 
      AGR [CASE @D58746, COUNT @D58745, PER @D58744, PLU @D58743, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, FIN -, 
      ARITY 1] : FIGHT, 
   [COORD @D58754, PAST @D58753, AGR [CASE @D58752, COUNT @D58751, 
            PER @D58750, PLU @D58749, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, FIN -, ARITY 1] : FIGHT, 
   [COORD @D58758, 
      AGR [COUNT @D58757, PER @D58756, PLU @D58755, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : FIGHT, 
   [COORD @D58762, AGR [COUNT @D58761, PER @D58760, PLU @D58759, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : FIGHT, 
   [COORD @D58766, AGR [COUNT @D58765, PER @D58764, PLU @D58763, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : FIGHT, 
   [COORD @D58770, AGR [COUNT @D58769, PER @D58768, PLU @D58767, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : FIGHT, 
   [COORD @D58774, AGR [COUNT @D58773, PER @D58772, PLU @D58771, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : FIGHT.

WORD found : 
   [COORD @D58788, AGR [COUNT @D58787, PER @D58786, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FOUND, 
   [COORD @D58790, AGR [COUNT @D58789, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FOUND, 
   [COORD @D58792, AGR [COUNT @D58791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FOUND, 
   [COORD @D58796, AGR [COUNT @D58795, PER @D58794, PLU @D58793, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : FOUND, 
   [COORD @D58802, PAST @D58801, 
      AGR [CASE @D58800, COUNT @D58799, PER @D58798, PLU @D58797, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, 
      ARITY 3] : FOUND, 
   [COORD @D58805, AGR [COUNT @D58804, PER @D58803, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FOUND, 
   [COORD @D58807, AGR [COUNT @D58806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FOUND, 
   [COORD @D58809, AGR [COUNT @D58808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FOUND, 
   [COORD @D58813, AGR [COUNT @D58812, PER @D58811, PLU @D58810, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : FOUND, 
   [COORD @D58819, PAST @D58818, 
      AGR [CASE @D58817, COUNT @D58816, PER @D58815, PLU @D58814, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, 
      ARITY 3] : FOUND, 
   [COORD @D58825, PAST @D58824, AGR [CASE @D58823, COUNT @D58822, 
            PER @D58821, PLU @D58820, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, REG -, FIN -, ARITY 3] : FIND, 
   [COORD @D58831, PAST @D58830, 
      AGR [CASE @D58829, COUNT @D58828, PER @D58827, PLU @D58826, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, REG -, FIN -, ARITY 3] : 
   FIND, 
   [COORD @D58837, PAST @D58836, AGR [CASE @D58835, COUNT @D58834, 
            PER @D58833, PLU @D58832, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, FIN -, ARITY 3] : FIND, 
   [COORD @D58843, PAST @D58842, 
      AGR [CASE @D58841, COUNT @D58840, PER @D58839, PLU @D58838, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, FIN -, ARITY 3] : 
   FIND, 
   [COORD @D58849, PAST @D58848, AGR [CASE @D58847, COUNT @D58846, 
            PER @D58845, PLU @D58844, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : FIND, 
   [COORD @D58855, PAST @D58854, 
      AGR [CASE @D58853, COUNT @D58852, PER @D58851, PLU @D58850, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, ARITY 3] : 
   FIND, 
   [COORD @D58861, PAST @D58860, AGR [CASE @D58859, COUNT @D58858, 
            PER @D58857, PLU @D58856, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : FIND, 
   [COORD @D58867, PAST @D58866, 
      AGR [CASE @D58865, COUNT @D58864, PER @D58863, PLU @D58862, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, ARITY 3] : 
   FIND, 
   [COORD @D58873, PAST @D58872, AGR [CASE @D58871, COUNT @D58870, 
            PER @D58869, PLU @D58868, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : FIND, 
   [COORD @D58879, PAST @D58878, 
      AGR [CASE @D58877, COUNT @D58876, PER @D58875, PLU @D58874, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : FIND, 
   
   [COORD @D58885, PAST @D58884, AGR [CASE @D58883, COUNT @D58882, PER 
               @D58881, PLU @D58880, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : FIND, 
   [COORD @D58891, PAST @D58890, 
      AGR [CASE @D58889, COUNT @D58888, PER @D58887, PLU @D58886, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : 
   FIND, 
   [COORD @D58897, PAST @D58896, AGR [CASE @D58895, COUNT @D58894, 
            PER @D58893, PLU @D58892, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM IN, FIN -, ARITY 3] : FIND, 
   [COORD @D58903, PAST @D58902, 
      AGR [CASE @D58901, COUNT @D58900, PER @D58899, PLU @D58898, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM IN, FIN -, 
      ARITY 3] : FIND, 
   [COORD @D58909, PAST @D58908, AGR [CASE @D58907, COUNT @D58906, 
            PER @D58905, PLU @D58904, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : FIND, 
   [COORD @D58915, PAST @D58914, 
      AGR [CASE @D58913, COUNT @D58912, PER @D58911, PLU @D58910, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, FIN -, 
      ARITY 3] : FIND, 
   [COORD @D58919, AGR [COUNT @D58918, PER @D58917, PLU @D58916, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, PAST +, ARITY 3] : FIND, 
   [COORD @D58923, AGR [COUNT @D58922, PER @D58921, PLU @D58920, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, PAST +, ARITY 3] : FIND, 
   [COORD @D58927, AGR [COUNT @D58926, PER @D58925, PLU @D58924, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PAST +, ARITY 3] : FIND, 
   [COORD @D58931, AGR [COUNT @D58930, PER @D58929, PLU @D58928, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PAST +, ARITY 3] : FIND, 
   [COORD @D58935, AGR [COUNT @D58934, PER @D58933, PLU @D58932, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : FIND, 
   [COORD @D58939, AGR [COUNT @D58938, PER @D58937, PLU @D58936, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : FIND, 
   [COORD @D58943, AGR [COUNT @D58942, PER @D58941, PLU @D58940, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM IN, PAST +, ARITY 3] : FIND, 
   [COORD @D58947, AGR [COUNT @D58946, PER @D58945, PLU @D58944, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, PAST +, ARITY 3] : FIND, 
   [COORD @D58950, AGR [COUNT @D58949, PER @D58948, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FOUND, 
   [COORD @D58952, AGR [COUNT @D58951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FOUND, 
   [COORD @D58954, AGR [COUNT @D58953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FOUND, 
   [COORD @D58958, AGR [COUNT @D58957, PER @D58956, PLU @D58955, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FOUND, 
   [COORD @D58964, PAST @D58963, AGR [CASE @D58962, COUNT @D58961, 
            PER @D58960, PLU @D58959, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FOUND, 
   [COORD @D58970, PAST @D58969, 
      AGR [CASE @D58968, COUNT @D58967, PER @D58966, PLU @D58965, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, ARITY 2] : FIND, 
   [COORD @D58976, PAST @D58975, 
      AGR [CASE @D58974, COUNT @D58973, PER @D58972, PLU @D58971, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : FIND, 
   [COORD @D58982, PAST @D58981, AGR [CASE @D58980, COUNT @D58979, 
            PER @D58978, PLU @D58977, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : FIND, 
   [COORD @D58988, PAST @D58987, 
      AGR [CASE @D58986, COUNT @D58985, PER @D58984, PLU @D58983, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, PRT OUT, FIN -, 
      ARITY 2] : FIND, 
   [COORD @D58994, PAST @D58993, AGR [CASE @D58992, COUNT @D58991, 
            PER @D58990, PLU @D58989, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PRT OUT, FIN -, ARITY 2] : FIND, 
   [COORD @D59000, PAST @D58999, 
      AGR [CASE @D58998, COUNT @D58997, PER @D58996, PLU @D58995, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT OUT, FIN -, 
      ARITY 2] : FIND, 
   [COORD @D59006, PAST @D59005, AGR [CASE @D59004, COUNT @D59003, 
            PER @D59002, PLU @D59001, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM FOR, FIN -, ARITY 2] : FIND, 
   [COORD @D59012, PAST @D59011, 
      AGR [CASE @D59010, COUNT @D59009, PER @D59008, PLU @D59007, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, FIN -, 
      ARITY 2] : FIND, 
   [COORD @D59018, PAST @D59017, AGR [CASE @D59016, COUNT @D59015, 
            PER @D59014, PLU @D59013, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : FIND, 
   [COORD @D59024, PAST @D59023, 
      AGR [CASE @D59022, COUNT @D59021, PER @D59020, PLU @D59019, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : FIND, 
   [COORD @D59028, AGR [COUNT @D59027, PER @D59026, PLU @D59025, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : FIND, 
   [COORD @D59032, AGR [COUNT @D59031, PER @D59030, PLU @D59029, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : FIND, 
   [COORD @D59036, AGR [COUNT @D59035, PER @D59034, PLU @D59033, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, 
      PRT OUT, PAST +, ARITY 2] : FIND, 
   [COORD @D59040, AGR [COUNT @D59039, PER @D59038, PLU @D59037, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, PAST +, ARITY 2] : FIND, 
   [COORD @D59044, AGR [COUNT @D59043, PER @D59042, PLU @D59041, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PRT OUT, PAST +, ARITY 2] : FIND, 
   [COORD @D59048, AGR [COUNT @D59047, PER @D59046, PLU @D59045, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : FIND, 
   [COORD @D59052, AGR [COUNT @D59051, PER @D59050, PLU @D59049, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : FIND, 
   [COORD @D59058, PAST @D59057, AGR [CASE @D59056, COUNT @D59055, 
            PER @D59054, PLU @D59053, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : FIND, 
   [COORD @D59062, 
      AGR [COUNT @D59061, PER @D59060, PLU @D59059, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : FIND.

WORD founded : 
   [COORD @D59070, AGR [CASE @D59069, COUNT @D59068, PER @D59067, 
            PLU @D59066, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59075, AGR [CASE @D59074, COUNT @D59073, PER @D59072, 
            PLU @D59071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59080, AGR [CASE @D59079, COUNT @D59078, PER @D59077, 
            PLU @D59076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59085, AGR [CASE @D59084, COUNT @D59083, PER @D59082, 
            PLU @D59081, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59090, AGR [CASE @D59089, COUNT @D59088, PER @D59087, 
            PLU @D59086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59095, AGR [CASE @D59094, COUNT @D59093, PER @D59092, 
            PLU @D59091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59100, AGR [CASE @D59099, COUNT @D59098, PER @D59097, 
            PLU @D59096, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FOUND, 
   [COORD @D59105, AGR [CASE @D59104, COUNT @D59103, PER @D59102, 
            PLU @D59101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59110, AGR [CASE @D59109, COUNT @D59108, PER @D59107, 
            PLU @D59106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FOUND.

WORD founding : 
   [COORD @D59121, PRD @D59120, AGR [CASE @D59119, COUNT @D59118, 
            PER @D59117, PLU @D59116, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FOUND, 
   [COORD @D59127, PRD @D59126, 
      AGR [CASE @D59125, COUNT @D59124, PER @D59123, PLU @D59122, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : FOUND, 
   [COORD @D59133, PRD @D59132, AGR [CASE @D59131, COUNT @D59130, 
            PER @D59129, PLU @D59128, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FOUND.

WORD founds : 
   [COORD @D59138, AGR [COUNT @D59137, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FOUND, 
   [COORD @D59140, AGR [COUNT @D59139, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : FOUND, 
   [COORD @D59142, AGR [COUNT @D59141, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FOUND.

WORD fund : 
   [COORD @D59151, AGR [COUNT @D59150, PER @D59149, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FUND, 
   [COORD @D59153, AGR [COUNT @D59152, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FUND, 
   [COORD @D59155, AGR [COUNT @D59154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FUND, 
   [COORD @D59159, AGR [COUNT @D59158, PER @D59157, PLU @D59156, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FUND, 
   [COORD @D59165, PAST @D59164, AGR [CASE @D59163, COUNT @D59162, 
            PER @D59161, PLU @D59160, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FUND.

WORD funded : 
   [COORD @D59173, AGR [CASE @D59172, COUNT @D59171, PER @D59170, 
            PLU @D59169, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FUND, 
   [COORD @D59178, AGR [CASE @D59177, COUNT @D59176, PER @D59175, 
            PLU @D59174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FUND, 
   [COORD @D59183, AGR [CASE @D59182, COUNT @D59181, PER @D59180, 
            PLU @D59179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FUND.

WORD funding : 
   [COORD @D59194, PRD @D59193, AGR [CASE @D59192, COUNT @D59191, 
            PER @D59190, PLU @D59189, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FUND.

WORD funds : 
   [COORD @D59199, AGR [COUNT @D59198, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FUND.

WORD fur : 
   [COORD @D59205, REFL @D59204, PRD @D59203, CASE @D59202, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : FUR, 
   [COORD @D59210, REFL @D59209, COUNT @D59208, PRD @D59207, 
      CASE @D59206, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : FUR, 
   [COORD @D59213, 
      AGR [COUNT @D59212, PER @D59211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : FUR, 
   
   [COORD @D59215, AGR [COUNT @D59214, N +, V -, BAR 2, NFORM NORM, CASE 
            NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, 
      V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FUR, 
   [COORD @D59217, AGR [COUNT @D59216, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : FUR, 
   [COORD @D59221, AGR [COUNT @D59220, PER @D59219, PLU @D59218, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : FUR, 
   [COORD @D59227, PAST @D59226, AGR [CASE @D59225, COUNT @D59224, 
            PER @D59223, PLU @D59222, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : FUR, 
   [COORD @D59230, AGR [COUNT @D59229, PER @D59228, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FUR, 
   [COORD @D59232, AGR [COUNT @D59231, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FUR, 
   [COORD @D59234, AGR [COUNT @D59233, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FUR, 
   [COORD @D59238, AGR [COUNT @D59237, PER @D59236, PLU @D59235, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : FUR, 
   [COORD @D59244, PAST @D59243, AGR [CASE @D59242, COUNT @D59241, 
            PER @D59240, PLU @D59239, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : FUR.

WORD fured : 
   [COORD @D59253, AGR [CASE @D59252, COUNT @D59251, PER @D59250, 
            PLU @D59249, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FUR, 
   [COORD @D59258, AGR [CASE @D59257, COUNT @D59256, PER @D59255, 
            PLU @D59254, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FUR, 
   [COORD @D59263, AGR [CASE @D59262, COUNT @D59261, PER @D59260, 
            PLU @D59259, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : FUR, 
   [COORD @D59268, AGR [CASE @D59267, COUNT @D59266, PER @D59265, 
            PLU @D59264, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : FUR, 
   [COORD @D59273, AGR [CASE @D59272, COUNT @D59271, PER @D59270, 
            PLU @D59269, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : FUR.

WORD furing : 
   [COORD @D59287, PRD @D59286, AGR [CASE @D59285, COUNT @D59284, 
            PER @D59283, PLU @D59282, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : FUR, 
   [COORD @D59293, PRD @D59292, AGR 
         [CASE @D59291, COUNT @D59290, PER @D59289, PLU @D59288, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : FUR.

WORD furs : 
   [COORD @D59302, DEMON @D59301, REFL @D59300, PRD @D59299, CASE 
         @D59298, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FUR, 
   [COORD @D59307, DEMON @D59306, REFL @D59305, PRD @D59304, 
      CASE @D59303, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : FUR, 
   [COORD @D59309, 
      AGR [COUNT @D59308, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FUR, 
   [COORD @D59311, 
      AGR [COUNT @D59310, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : FUR.

WORD gain : 
   [COORD @D59318, REFL @D59317, COUNT @D59316, PRD @D59315, CASE 
         @D59314, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : GAIN, 
   [COORD @D59321, 
      AGR [COUNT @D59320, PER @D59319, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   GAIN, 
   [COORD @D59323, AGR [COUNT @D59322, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GAIN, 
   [COORD @D59325, AGR [COUNT @D59324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GAIN, 
   [COORD @D59329, AGR [COUNT @D59328, PER @D59327, PLU @D59326, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : GAIN, 
   [COORD @D59335, PAST @D59334, AGR [CASE @D59333, COUNT @D59332, 
            PER @D59331, PLU @D59330, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : GAIN, 
   [COORD @D59338, AGR [COUNT @D59337, PER @D59336, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : GAIN, 
   [COORD @D59340, AGR [COUNT @D59339, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : GAIN, 
   [COORD @D59342, AGR [COUNT @D59341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : GAIN, 
   [COORD @D59346, AGR [COUNT @D59345, PER @D59344, PLU @D59343, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : GAIN, 
   [COORD @D59352, PAST @D59351, 
      AGR [CASE @D59350, COUNT @D59349, PER @D59348, PLU @D59347, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      ARITY 2] : GAIN, 
   [COORD @D59355, AGR [COUNT @D59354, PER @D59353, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : GAIN, 
   [COORD @D59357, AGR [COUNT @D59356, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : GAIN, 
   [COORD @D59359, AGR [COUNT @D59358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : GAIN, 
   [COORD @D59363, AGR [COUNT @D59362, PER @D59361, PLU @D59360, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : GAIN, 
   [COORD @D59369, PAST @D59368, 
      AGR [CASE @D59367, COUNT @D59366, PER @D59365, PLU @D59364, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : GAIN, 
   [COORD @D59372, AGR [COUNT @D59371, PER @D59370, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GAIN, 
   [COORD @D59374, AGR [COUNT @D59373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GAIN, 
   [COORD @D59376, AGR [COUNT @D59375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GAIN, 
   [COORD @D59380, AGR [COUNT @D59379, PER @D59378, PLU @D59377, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GAIN, 
   [COORD @D59386, PAST @D59385, AGR [CASE @D59384, COUNT @D59383, 
            PER @D59382, PLU @D59381, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : GAIN.

WORD gained : 
   [COORD @D59395, AGR [CASE @D59394, COUNT @D59393, PER @D59392, 
            PLU @D59391, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59400, AGR [CASE @D59399, COUNT @D59398, PER @D59397, 
            PLU @D59396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59405, AGR [CASE @D59404, COUNT @D59403, PER @D59402, 
            PLU @D59401, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GAIN, 
   [COORD @D59410, AGR [CASE @D59409, COUNT @D59408, PER @D59407, 
            PLU @D59406, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59415, AGR [CASE @D59414, COUNT @D59413, PER @D59412, 
            PLU @D59411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59420, AGR [CASE @D59419, COUNT @D59418, PER @D59417, 
            PLU @D59416, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59425, AGR [CASE @D59424, COUNT @D59423, PER @D59422, 
            PLU @D59421, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59430, AGR [CASE @D59429, COUNT @D59428, PER @D59427, 
            PLU @D59426, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59435, AGR [CASE @D59434, COUNT @D59433, PER @D59432, 
            PLU @D59431, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59440, AGR [CASE @D59439, COUNT @D59438, PER @D59437, 
            PLU @D59436, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59445, AGR [CASE @D59444, COUNT @D59443, PER @D59442, 
            PLU @D59441, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GAIN.

WORD gaining : 
   [COORD @D59459, PRD @D59458, AGR [CASE @D59457, COUNT @D59456, 
            PER @D59455, PLU @D59454, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59465, PRD @D59464, 
      AGR [CASE @D59463, COUNT @D59462, PER @D59461, PLU @D59460, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GAIN, 
   [COORD @D59471, PRD @D59470, AGR [CASE @D59469, COUNT @D59468, 
            PER @D59467, PLU @D59466, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GAIN, 
   [COORD @D59477, PRD @D59476, 
      AGR [CASE @D59475, COUNT @D59474, PER @D59473, PLU @D59472, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GAIN.

WORD gains : 
   [COORD @D59486, DEMON @D59485, REFL @D59484, PRD @D59483, CASE 
         @D59482, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : GAIN, 
   [COORD @D59488, 
      AGR [COUNT @D59487, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GAIN, 
   [COORD @D59490, 
      AGR [COUNT @D59489, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GAIN, 
   [COORD @D59492, 
      AGR [COUNT @D59491, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GAIN, 
   [COORD @D59494, 
      AGR [COUNT @D59493, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GAIN.

WORD garden : 
   [COORD @D59500, REFL @D59499, PRD @D59498, CASE @D59497, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : GARDEN, 
   [COORD @D59503, 
      AGR [COUNT @D59502, PER @D59501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   GARDEN, 
   [COORD @D59505, AGR [COUNT @D59504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GARDEN, 
   [COORD @D59507, AGR [COUNT @D59506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GARDEN, 
   [COORD @D59511, AGR [COUNT @D59510, PER @D59509, PLU @D59508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GARDEN, 
   [COORD @D59517, PAST @D59516, AGR [CASE @D59515, COUNT @D59514, 
            PER @D59513, PLU @D59512, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : GARDEN.

WORD gardening : 
   [COORD @D59529, REFL @D59528, PRD @D59527, CASE @D59526, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : GARDENING, 
   [COORD @D59535, PRD @D59534, 
      AGR [CASE @D59533, COUNT @D59532, PER @D59531, PLU @D59530, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   GARDEN.

WORD gardenned : 
   [COORD @D59555, AGR [CASE @D59554, COUNT @D59553, PER @D59552, 
            PLU @D59551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GARDEN, 
   [COORD @D59560, AGR [CASE @D59559, COUNT @D59558, PER @D59557, 
            PLU @D59556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GARDEN.

WORD gardenning : 
   [COORD @D59572, PRD @D59571, AGR [CASE @D59570, COUNT @D59569, 
            PER @D59568, PLU @D59567, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GARDEN.

WORD gardens : 
   [COORD @D59581, DEMON @D59580, REFL @D59579, PRD @D59578, 
      CASE @D59577, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : GARDEN, 
   [COORD @D59583, 
      AGR [COUNT @D59582, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GARDEN.

WORD gesture : 
   [COORD @D59592, REFL @D59591, COUNT @D59590, PRD @D59589, 
      CASE @D59588, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : GESTURE, 
   [COORD @D59595, 
      AGR [COUNT @D59594, PER @D59593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   GESTURE, 
   [COORD @D59597, AGR [COUNT @D59596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GESTURE, 
   [COORD @D59599, AGR [COUNT @D59598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GESTURE, 
   [COORD @D59603, AGR [COUNT @D59602, PER @D59601, PLU @D59600, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GESTURE, 
   [COORD @D59609, PAST @D59608, AGR [CASE @D59607, COUNT @D59606, 
            PER @D59605, PLU @D59604, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : GESTURE.

WORD gestured : 
   [COORD @D59620, AGR [CASE @D59619, COUNT @D59618, PER @D59617, 
            PLU @D59616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GESTURE, 
   [COORD @D59625, AGR [CASE @D59624, COUNT @D59623, PER @D59622, 
            PLU @D59621, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GESTURE.

WORD gestures : 
   [COORD @D59636, DEMON @D59635, REFL @D59634, PRD @D59633, 
      CASE @D59632, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : GESTURE, 
   
   [COORD @D59638, AGR [COUNT @D59637, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GESTURE.

WORD gesturing : 
   [COORD @D59648, PRD @D59647, AGR [CASE @D59646, COUNT @D59645, 
            PER @D59644, PLU @D59643, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GESTURE.

WORD glide : 
   [COORD @D59654, AGR [COUNT @D59653, PER @D59652, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : GLIDE, 
   [COORD @D59656, AGR [COUNT @D59655, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : GLIDE, 
   [COORD @D59658, AGR [COUNT @D59657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : GLIDE, 
   [COORD @D59662, AGR [COUNT @D59661, PER @D59660, PLU @D59659, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : GLIDE, 
   [COORD @D59668, PAST @D59667, AGR [CASE @D59666, COUNT @D59665, 
            PER @D59664, PLU @D59663, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : GLIDE, 
   [COORD @D59671, AGR [COUNT @D59670, PER @D59669, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GLIDE, 
   [COORD @D59673, AGR [COUNT @D59672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GLIDE, 
   [COORD @D59675, AGR [COUNT @D59674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GLIDE, 
   [COORD @D59679, AGR [COUNT @D59678, PER @D59677, PLU @D59676, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : GLIDE, 
   [COORD @D59685, PAST @D59684, AGR [CASE @D59683, COUNT @D59682, 
            PER @D59681, PLU @D59680, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : GLIDE.

WORD glided : 
   [COORD @D59694, AGR [CASE @D59693, COUNT @D59692, PER @D59691, 
            PLU @D59690, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GLIDE, 
   [COORD @D59699, AGR [CASE @D59698, COUNT @D59697, PER @D59696, 
            PLU @D59695, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GLIDE, 
   [COORD @D59704, AGR [CASE @D59703, COUNT @D59702, PER @D59701, 
            PLU @D59700, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GLIDE, 
   [COORD @D59709, AGR [CASE @D59708, COUNT @D59707, PER @D59706, 
            PLU @D59705, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GLIDE.

WORD glider : 
   [COORD @D59717, REFL @D59716, PRD @D59715, CASE @D59714, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : GLIDER.

WORD gliders : 
   [COORD @D59728, DEMON @D59727, REFL @D59726, PRD @D59725, 
      CASE @D59724, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : GLIDER.

WORD glides : 
   [COORD @D59734, AGR [COUNT @D59733, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GLIDE, 
   [COORD @D59736, 
      AGR [COUNT @D59735, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GLIDE.

WORD gliding : 
   [COORD @D59743, REFL @D59742, PRD @D59741, CASE @D59740, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : GLIDING, 
   [COORD @D59749, PRD @D59748, 
      AGR [CASE @D59747, COUNT @D59746, PER @D59745, PLU @D59744, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   GLIDE, 
   [COORD @D59755, PRD @D59754, AGR [CASE @D59753, COUNT @D59752, 
            PER @D59751, PLU @D59750, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GLIDE.

WORD go : 
   [COORD @D59765, AGR [COUNT @D59764, PER @D59763, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : GO, 
   [COORD @D59767, AGR [COUNT @D59766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : GO, 
   [COORD @D59769, AGR [COUNT @D59768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : GO, 
   [COORD @D59773, AGR [COUNT @D59772, PER @D59771, PLU @D59770, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : GO, 
   [COORD @D59779, PAST @D59778, AGR [CASE @D59777, COUNT @D59776, 
            PER @D59775, PLU @D59774, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : GO, 
   [COORD @D59782, AGR [COUNT @D59781, PER @D59780, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : GO, 
   [COORD @D59784, AGR [COUNT @D59783, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : GO, 
   [COORD @D59786, AGR [COUNT @D59785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : GO, 
   [COORD @D59790, AGR [COUNT @D59789, PER @D59788, PLU @D59787, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 2] : GO, 
   [COORD @D59796, PAST @D59795, 
      AGR [CASE @D59794, COUNT @D59793, PER @D59792, PLU @D59791, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, ARITY 2] : 
   GO, 
   [COORD @D59799, AGR [COUNT @D59798, PER @D59797, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : GO, 
   [COORD @D59801, AGR [COUNT @D59800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : GO, 
   [COORD @D59803, AGR [COUNT @D59802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : GO, 
   [COORD @D59807, AGR [COUNT @D59806, PER @D59805, PLU @D59804, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : GO, 
   [COORD @D59813, PAST @D59812, AGR 
         [CASE @D59811, COUNT @D59810, PER @D59809, PLU @D59808, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, ARITY 2] : 
   GO, 
   [COORD @D59816, AGR [COUNT @D59815, PER @D59814, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : GO, 
   [COORD @D59818, AGR [COUNT @D59817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : GO, 
   [COORD @D59820, AGR [COUNT @D59819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : GO, 
   [COORD @D59824, AGR [COUNT @D59823, PER @D59822, PLU @D59821, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : GO, 
   [COORD @D59830, PAST @D59829, AGR [CASE @D59828, COUNT @D59827, 
            PER @D59826, PLU @D59825, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : GO, 
   [COORD @D59833, AGR [COUNT @D59832, PER @D59831, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : GO, 
   [COORD @D59835, AGR [COUNT @D59834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : GO, 
   [COORD @D59837, AGR [COUNT @D59836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : GO, 
   [COORD @D59841, AGR [COUNT @D59840, PER @D59839, PLU @D59838, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : GO, 
   [COORD @D59847, PAST @D59846, AGR [CASE @D59845, COUNT @D59844, 
            PER @D59843, PLU @D59842, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : GO, 
   [COORD @D59850, AGR [COUNT @D59849, PER @D59848, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OVER, ARITY 2] : GO, 
   [COORD @D59852, AGR [COUNT @D59851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OVER, ARITY 2] : GO, 
   [COORD @D59854, AGR [COUNT @D59853, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OVER, ARITY 2] : GO, 
   [COORD @D59858, AGR [COUNT @D59857, PER @D59856, PLU @D59855, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, PRT OVER, ARITY 2] : GO, 
   [COORD @D59864, PAST @D59863, 
      AGR [CASE @D59862, COUNT @D59861, PER @D59860, PLU @D59859, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, PRT OVER, 
      ARITY 2] : GO, 
   [COORD @D59867, AGR [COUNT @D59866, PER @D59865, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59869, AGR [COUNT @D59868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59871, AGR [COUNT @D59870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59875, AGR [COUNT @D59874, PER @D59873, PLU @D59872, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59881, PAST @D59880, 
      AGR [CASE @D59879, COUNT @D59878, PER @D59877, PLU @D59876, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT ON, 
      ARITY 2] : GO, 
   [COORD @D59884, AGR [COUNT @D59883, PER @D59882, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59886, AGR [COUNT @D59885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59888, AGR [COUNT @D59887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59892, AGR [COUNT @D59891, PER @D59890, PLU @D59889, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PRT ON, ARITY 2] : GO, 
   [COORD @D59898, PAST @D59897, 
      AGR [CASE @D59896, COUNT @D59895, PER @D59894, PLU @D59893, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, PRT ON, 
      ARITY 2] : GO, 
   [COORD @D59901, AGR [COUNT @D59900, PER @D59899, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OFF, ARITY 2] : GO, 
   [COORD @D59903, AGR [COUNT @D59902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OFF, ARITY 2] : GO, 
   [COORD @D59905, AGR [COUNT @D59904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, PRT OFF, ARITY 2] : GO, 
   [COORD @D59909, AGR [COUNT @D59908, PER @D59907, PLU @D59906, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, PRT OFF, ARITY 2] : GO, 
   [COORD @D59915, PAST @D59914, 
      AGR [CASE @D59913, COUNT @D59912, PER @D59911, PLU @D59910, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, PRT OFF, 
      ARITY 2] : GO, 
   [COORD @D59918, AGR [COUNT @D59917, PER @D59916, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT BACK, ARITY 2] : GO, 
   [COORD @D59920, AGR [COUNT @D59919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT BACK, ARITY 2] : GO, 
   [COORD @D59922, AGR [COUNT @D59921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT BACK, ARITY 2] : GO, 
   [COORD @D59926, AGR [COUNT @D59925, PER @D59924, PLU @D59923, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, PRT BACK, ARITY 2] : GO, 
   [COORD @D59932, PAST @D59931, AGR [CASE @D59930, COUNT @D59929, 
            PER @D59928, PLU @D59927, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, PRT BACK, ARITY 2] : GO, 
   [COORD @D59935, 
      AGR [COUNT @D59934, PER @D59933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT IN, 
      PREP FOR, ARITY 2] : GO, 
   [COORD @D59937, AGR [COUNT @D59936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT IN, PREP FOR, ARITY 2] : GO, 
   [COORD @D59939, AGR [COUNT @D59938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT IN, PREP FOR, ARITY 2] : GO, 
   [COORD @D59943, AGR [COUNT @D59942, PER @D59941, PLU @D59940, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT IN, PREP FOR, ARITY 2] : GO, 
   [COORD @D59949, PAST @D59948, 
      AGR [CASE @D59947, COUNT @D59946, PER @D59945, PLU @D59944, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT IN, 
      PREP FOR, ARITY 2] : GO, 
   [COORD @D59952, AGR [COUNT @D59951, PER @D59950, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ABOUT, ARITY 2] : GO, 
   [COORD @D59954, AGR [COUNT @D59953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ABOUT, ARITY 2] : GO, 
   [COORD @D59956, AGR [COUNT @D59955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ABOUT, ARITY 2] : GO, 
   [COORD @D59960, AGR [COUNT @D59959, PER @D59958, PLU @D59957, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP ABOUT, ARITY 2] : GO, 
   [COORD @D59966, PAST @D59965, 
      AGR [CASE @D59964, COUNT @D59963, PER @D59962, PLU @D59961, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP ABOUT, 
      ARITY 2] : GO, 
   [COORD @D59969, AGR [COUNT @D59968, PER @D59967, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITHOUT, ARITY 2] : GO, 
   [COORD @D59971, AGR [COUNT @D59970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITHOUT, ARITY 2] : GO, 
   [COORD @D59973, AGR [COUNT @D59972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITHOUT, ARITY 2] : GO, 
   [COORD @D59977, AGR [COUNT @D59976, PER @D59975, PLU @D59974, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITHOUT, ARITY 2] : GO, 
   [COORD @D59983, PAST @D59982, 
      AGR [CASE @D59981, COUNT @D59980, PER @D59979, PLU @D59978, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITHOUT, 
      ARITY 2] : GO, 
   [COORD @D59986, AGR [COUNT @D59985, PER @D59984, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D59988, AGR [COUNT @D59987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D59990, AGR [COUNT @D59989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D59994, AGR [COUNT @D59993, PER @D59992, PLU @D59991, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60000, PAST @D59999, AGR [CASE @D59998, COUNT @D59997, 
            PER @D59996, PLU @D59995, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60003, 
      AGR [COUNT @D60002, PER @D60001, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT THROUGH, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60005, AGR [COUNT @D60004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT THROUGH, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60007, AGR [COUNT @D60006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT THROUGH, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60011, AGR [COUNT @D60010, PER @D60009, PLU @D60008, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT THROUGH, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60017, PAST @D60016, 
      AGR [CASE @D60015, COUNT @D60014, PER @D60013, PLU @D60012, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT THROUGH, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60020, AGR [COUNT @D60019, PER @D60018, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60022, AGR [COUNT @D60021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60024, AGR [COUNT @D60023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60028, AGR [COUNT @D60027, PER @D60026, PLU @D60025, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60034, PAST @D60033, 
      AGR [CASE @D60032, COUNT @D60031, PER @D60030, PLU @D60029, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60037, AGR [COUNT @D60036, PER @D60035, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60039, AGR [COUNT @D60038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60041, AGR [COUNT @D60040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60045, AGR [COUNT @D60044, PER @D60043, PLU @D60042, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ON, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60051, PAST @D60050, 
      AGR [CASE @D60049, COUNT @D60048, PER @D60047, PLU @D60046, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60054, AGR [COUNT @D60053, PER @D60052, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60056, AGR [COUNT @D60055, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60058, AGR [COUNT @D60057, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60062, AGR [COUNT @D60061, PER @D60060, PLU @D60059, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OFF, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60068, PAST @D60067, 
      AGR [CASE @D60066, COUNT @D60065, PER @D60064, PLU @D60063, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60071, AGR [COUNT @D60070, PER @D60069, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60073, AGR [COUNT @D60072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60075, AGR [COUNT @D60074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60079, AGR [COUNT @D60078, PER @D60077, PLU @D60076, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60085, PAST @D60084, 
      AGR [CASE @D60083, COUNT @D60082, PER @D60081, PLU @D60080, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60088, AGR [COUNT @D60087, PER @D60086, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AROUND, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60090, AGR [COUNT @D60089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AROUND, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60092, AGR [COUNT @D60091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AROUND, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60096, AGR [COUNT @D60095, PER @D60094, PLU @D60093, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT AROUND, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60102, PAST @D60101, 
      AGR [CASE @D60100, COUNT @D60099, PER @D60098, PLU @D60097, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AROUND, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60105, AGR [COUNT @D60104, PER @D60103, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALONG, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60107, AGR [COUNT @D60106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALONG, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60109, AGR [COUNT @D60108, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALONG, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60113, AGR [COUNT @D60112, PER @D60111, PLU @D60110, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ALONG, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60119, PAST @D60118, 
      AGR [CASE @D60117, COUNT @D60116, PER @D60115, PLU @D60114, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ALONG, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60122, AGR [COUNT @D60121, PER @D60120, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AHEAD, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60124, AGR [COUNT @D60123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AHEAD, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60126, AGR [COUNT @D60125, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AHEAD, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60130, AGR [COUNT @D60129, PER @D60128, PLU @D60127, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT AHEAD, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60136, PAST @D60135, 
      AGR [CASE @D60134, COUNT @D60133, PER @D60132, PLU @D60131, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AHEAD, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60139, AGR [COUNT @D60138, PER @D60137, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60141, AGR [COUNT @D60140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60143, AGR [COUNT @D60142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ABOUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60147, AGR [COUNT @D60146, PER @D60145, PLU @D60144, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ABOUT, PFORM WITH, ARITY 2] : GO, 
   [COORD @D60153, PAST @D60152, 
      AGR [CASE @D60151, COUNT @D60150, PER @D60149, PLU @D60148, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ABOUT, 
      PFORM WITH, ARITY 2] : GO, 
   [COORD @D60156, AGR [COUNT @D60155, PER @D60154, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60158, AGR [COUNT @D60157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60160, AGR [COUNT @D60159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60164, AGR [COUNT @D60163, PER @D60162, PLU @D60161, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : GO, 
   [COORD @D60170, PAST @D60169, AGR [CASE @D60168, COUNT @D60167, 
            PER @D60166, PLU @D60165, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : GO, 
   [COORD @D60173, 
      AGR [COUNT @D60172, PER @D60171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60175, AGR [COUNT @D60174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : GO, 
   [COORD @D60177, AGR [COUNT @D60176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : GO, 
   [COORD @D60181, AGR [COUNT @D60180, PER @D60179, PLU @D60178, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : GO, 
   [COORD @D60187, PAST @D60186, 
      AGR [CASE @D60185, COUNT @D60184, PER @D60183, PLU @D60182, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60190, AGR [COUNT @D60189, PER @D60188, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : GO, 
   [COORD @D60192, AGR [COUNT @D60191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : GO, 
   [COORD @D60194, AGR [COUNT @D60193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : GO, 
   [COORD @D60198, AGR [COUNT @D60197, PER @D60196, PLU @D60195, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OVER, PFORM TO, ARITY 2] : GO, 
   [COORD @D60204, PAST @D60203, 
      AGR [CASE @D60202, COUNT @D60201, PER @D60200, PLU @D60199, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60207, AGR [COUNT @D60206, PER @D60205, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM TO, ARITY 2] : GO, 
   [COORD @D60209, AGR [COUNT @D60208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM TO, ARITY 2] : GO, 
   [COORD @D60211, AGR [COUNT @D60210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM TO, ARITY 2] : GO, 
   [COORD @D60215, AGR [COUNT @D60214, PER @D60213, PLU @D60212, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM TO, ARITY 2] : GO, 
   [COORD @D60221, PAST @D60220, 
      AGR [CASE @D60219, COUNT @D60218, PER @D60217, PLU @D60216, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60224, AGR [COUNT @D60223, PER @D60222, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM TO, ARITY 2] : GO, 
   [COORD @D60226, AGR [COUNT @D60225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM TO, ARITY 2] : GO, 
   [COORD @D60228, AGR [COUNT @D60227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM TO, ARITY 2] : GO, 
   [COORD @D60232, AGR [COUNT @D60231, PER @D60230, PLU @D60229, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 2] : GO, 
   [COORD @D60238, PAST @D60237, 
      AGR [CASE @D60236, COUNT @D60235, PER @D60234, PLU @D60233, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60241, AGR [COUNT @D60240, PER @D60239, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM TO, ARITY 2] : GO, 
   [COORD @D60243, AGR [COUNT @D60242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM TO, ARITY 2] : GO, 
   [COORD @D60245, AGR [COUNT @D60244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM TO, ARITY 2] : GO, 
   [COORD @D60249, AGR [COUNT @D60248, PER @D60247, PLU @D60246, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT BACK, PFORM TO, ARITY 2] : GO, 
   [COORD @D60255, PAST @D60254, 
      AGR [CASE @D60253, COUNT @D60252, PER @D60251, PLU @D60250, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, 
      PFORM TO, ARITY 2] : GO, 
   [COORD @D60258, AGR [COUNT @D60257, PER @D60256, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : GO, 
   [COORD @D60260, AGR [COUNT @D60259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : GO, 
   [COORD @D60262, AGR [COUNT @D60261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : GO, 
   [COORD @D60266, AGR [COUNT @D60265, PER @D60264, PLU @D60263, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM THROUGH, ARITY 2] : GO, 
   [COORD @D60272, PAST @D60271, 
      AGR [CASE @D60270, COUNT @D60269, PER @D60268, PLU @D60267, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM THROUGH, 
      ARITY 2] : GO, 
   [COORD @D60275, AGR [COUNT @D60274, PER @D60273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ROUND, ARITY 2] : GO, 
   [COORD @D60277, AGR [COUNT @D60276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ROUND, ARITY 2] : GO, 
   [COORD @D60279, AGR [COUNT @D60278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ROUND, ARITY 2] : GO, 
   [COORD @D60283, AGR [COUNT @D60282, PER @D60281, PLU @D60280, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ROUND, ARITY 2] : GO, 
   [COORD @D60289, PAST @D60288, AGR [CASE @D60287, COUNT @D60286, 
            PER @D60285, PLU @D60284, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ROUND, ARITY 2] : GO, 
   [COORD @D60292, 
      AGR [COUNT @D60291, PER @D60290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OVER, 
      ARITY 2] : GO, 
   [COORD @D60294, AGR [COUNT @D60293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : GO, 
   [COORD @D60296, AGR [COUNT @D60295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : GO, 
   [COORD @D60300, AGR [COUNT @D60299, PER @D60298, PLU @D60297, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OVER, ARITY 2] : GO, 
   [COORD @D60306, PAST @D60305, AGR [CASE @D60304, COUNT @D60303, 
            PER @D60302, PLU @D60301, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OVER, ARITY 2] : GO, 
   [COORD @D60309, 
      AGR [COUNT @D60308, PER @D60307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, 
      ARITY 2] : GO, 
   [COORD @D60311, AGR [COUNT @D60310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : GO, 
   [COORD @D60313, AGR [COUNT @D60312, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : GO, 
   [COORD @D60317, AGR [COUNT @D60316, PER @D60315, PLU @D60314, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : GO, 
   [COORD @D60323, PAST @D60322, AGR [CASE @D60321, COUNT @D60320, 
            PER @D60319, PLU @D60318, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : GO, 
   [COORD @D60326, 
      AGR [COUNT @D60325, PER @D60324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT BACK, 
      PFORM ON, ARITY 2] : GO, 
   [COORD @D60328, AGR [COUNT @D60327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : GO, 
   [COORD @D60330, AGR [COUNT @D60329, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM ON, ARITY 2] : GO, 
   [COORD @D60334, AGR [COUNT @D60333, PER @D60332, PLU @D60331, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT BACK, PFORM ON, ARITY 2] : GO, 
   [COORD @D60340, PAST @D60339, 
      AGR [CASE @D60338, COUNT @D60337, PER @D60336, PLU @D60335, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT BACK, 
      PFORM ON, ARITY 2] : GO, 
   [COORD @D60343, AGR [COUNT @D60342, PER @D60341, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : GO, 
   [COORD @D60345, AGR [COUNT @D60344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : GO, 
   [COORD @D60347, AGR [COUNT @D60346, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : GO, 
   [COORD @D60351, AGR [COUNT @D60350, PER @D60349, PLU @D60348, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OFF, ARITY 2] : GO, 
   [COORD @D60357, PAST @D60356, AGR [CASE @D60355, COUNT @D60354, 
            PER @D60353, PLU @D60352, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, ARITY 2] : GO, 
   [COORD @D60360, 
      AGR [COUNT @D60359, PER @D60358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM LIKE, 
      ARITY 2] : GO, 
   [COORD @D60362, AGR [COUNT @D60361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM LIKE, ARITY 2] : GO, 
   [COORD @D60364, AGR [COUNT @D60363, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM LIKE, ARITY 2] : GO, 
   [COORD @D60368, AGR [COUNT @D60367, PER @D60366, PLU @D60365, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM LIKE, ARITY 2] : GO, 
   [COORD @D60374, PAST @D60373, AGR [CASE @D60372, COUNT @D60371, 
            PER @D60370, PLU @D60369, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM LIKE, ARITY 2] : GO, 
   [COORD @D60377, 
      AGR [COUNT @D60376, PER @D60375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, 
      ARITY 2] : GO, 
   [COORD @D60379, AGR [COUNT @D60378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : GO, 
   [COORD @D60381, AGR [COUNT @D60380, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : GO, 
   [COORD @D60385, AGR [COUNT @D60384, PER @D60383, PLU @D60382, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM INTO, ARITY 2] : GO, 
   [COORD @D60391, PAST @D60390, AGR [CASE @D60389, COUNT @D60388, 
            PER @D60387, PLU @D60386, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, ARITY 2] : GO, 
   [COORD @D60394, 
      AGR [COUNT @D60393, PER @D60392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM IN, 
      ARITY 2] : GO, 
   [COORD @D60396, AGR [COUNT @D60395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : GO, 
   [COORD @D60398, AGR [COUNT @D60397, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : GO, 
   [COORD @D60402, AGR [COUNT @D60401, PER @D60400, PLU @D60399, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM IN, ARITY 2] : GO, 
   [COORD @D60408, PAST @D60407, AGR [CASE @D60406, COUNT @D60405, 
            PER @D60404, PLU @D60403, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM IN, ARITY 2] : GO, 
   [COORD @D60411, 
      AGR [COUNT @D60410, PER @D60409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM IN, ARITY 2] : GO, 
   [COORD @D60413, AGR [COUNT @D60412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM IN, ARITY 2] : GO, 
   [COORD @D60415, AGR [COUNT @D60414, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM IN, ARITY 2] : GO, 
   [COORD @D60419, AGR [COUNT @D60418, PER @D60417, PLU @D60416, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM IN, ARITY 2] : GO, 
   [COORD @D60425, PAST @D60424, 
      AGR [CASE @D60423, COUNT @D60422, PER @D60421, PLU @D60420, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM IN, ARITY 2] : GO, 
   [COORD @D60428, AGR [COUNT @D60427, PER @D60426, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60430, AGR [COUNT @D60429, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60432, AGR [COUNT @D60431, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60436, AGR [COUNT @D60435, PER @D60434, PLU @D60433, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OVER, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60442, PAST @D60441, 
      AGR [CASE @D60440, COUNT @D60439, PER @D60438, PLU @D60437, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, 
      PFORM FROM, ARITY 2] : GO, 
   [COORD @D60445, AGR [COUNT @D60444, PER @D60443, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60447, AGR [COUNT @D60446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60449, AGR [COUNT @D60448, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60453, AGR [COUNT @D60452, PER @D60451, PLU @D60450, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM FROM, ARITY 2] : GO, 
   [COORD @D60459, PAST @D60458, 
      AGR [CASE @D60457, COUNT @D60456, PER @D60455, PLU @D60454, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM FROM, ARITY 2] : GO, 
   [COORD @D60462, AGR [COUNT @D60461, PER @D60460, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : GO, 
   [COORD @D60464, AGR [COUNT @D60463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : GO, 
   [COORD @D60466, AGR [COUNT @D60465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : GO, 
   [COORD @D60470, AGR [COUNT @D60469, PER @D60468, PLU @D60467, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60476, PAST @D60475, AGR [CASE @D60474, COUNT @D60473, 
            PER @D60472, PLU @D60471, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60479, 
      AGR [COUNT @D60478, PER @D60477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM FOR, ARITY 2] : GO, 
   [COORD @D60481, AGR [COUNT @D60480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60483, AGR [COUNT @D60482, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60487, AGR [COUNT @D60486, PER @D60485, PLU @D60484, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ON, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60493, PAST @D60492, 
      AGR [CASE @D60491, COUNT @D60490, PER @D60489, PLU @D60488, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM FOR, ARITY 2] : GO, 
   [COORD @D60496, AGR [COUNT @D60495, PER @D60494, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60498, AGR [COUNT @D60497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60500, AGR [COUNT @D60499, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60504, AGR [COUNT @D60503, PER @D60502, PLU @D60501, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM FOR, ARITY 2] : GO, 
   [COORD @D60510, PAST @D60509, 
      AGR [CASE @D60508, COUNT @D60507, PER @D60506, PLU @D60505, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, ARITY 2] : GO, 
   [COORD @D60513, AGR [COUNT @D60512, PER @D60511, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : GO, 
   [COORD @D60515, AGR [COUNT @D60514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : GO, 
   [COORD @D60517, AGR [COUNT @D60516, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : GO, 
   [COORD @D60521, AGR [COUNT @D60520, PER @D60519, PLU @D60518, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BY, ARITY 2] : GO, 
   [COORD @D60527, PAST @D60526, AGR [CASE @D60525, COUNT @D60524, 
            PER @D60523, PLU @D60522, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BY, ARITY 2] : GO, 
   [COORD @D60530, 
      AGR [COUNT @D60529, PER @D60528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM BEFORE, ARITY 2] : GO, 
   [COORD @D60532, AGR [COUNT @D60531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM BEFORE, ARITY 2] : GO, 
   [COORD @D60534, AGR [COUNT @D60533, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM BEFORE, ARITY 2] : GO, 
   [COORD @D60538, AGR [COUNT @D60537, PER @D60536, PLU @D60535, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM BEFORE, ARITY 2] : GO, 
   [COORD @D60544, PAST @D60543, 
      AGR [CASE @D60542, COUNT @D60541, PER @D60540, PLU @D60539, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM BEFORE, ARITY 2] : GO, 
   [COORD @D60547, AGR [COUNT @D60546, PER @D60545, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : GO, 
   [COORD @D60549, AGR [COUNT @D60548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : GO, 
   [COORD @D60551, AGR [COUNT @D60550, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : GO, 
   [COORD @D60555, AGR [COUNT @D60554, PER @D60553, PLU @D60552, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : GO, 
   [COORD @D60561, PAST @D60560, AGR [CASE @D60559, COUNT @D60558, 
            PER @D60557, PLU @D60556, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : GO, 
   [COORD @D60564, 
      AGR [COUNT @D60563, PER @D60562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM AT, ARITY 2] : GO, 
   [COORD @D60566, AGR [COUNT @D60565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM AT, ARITY 2] : GO, 
   [COORD @D60568, AGR [COUNT @D60567, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM AT, ARITY 2] : GO, 
   [COORD @D60572, AGR [COUNT @D60571, PER @D60570, PLU @D60569, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ON, PFORM AT, ARITY 2] : GO, 
   [COORD @D60578, PAST @D60577, 
      AGR [CASE @D60576, COUNT @D60575, PER @D60574, PLU @D60573, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM AT, ARITY 2] : GO, 
   [COORD @D60581, AGR [COUNT @D60580, PER @D60579, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : GO, 
   [COORD @D60583, AGR [COUNT @D60582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : GO, 
   [COORD @D60585, AGR [COUNT @D60584, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : GO, 
   [COORD @D60589, AGR [COUNT @D60588, PER @D60587, PLU @D60586, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AGAINST, ARITY 2] : GO, 
   [COORD @D60595, PAST @D60594, 
      AGR [CASE @D60593, COUNT @D60592, PER @D60591, PLU @D60590, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AGAINST, 
      ARITY 2] : GO, 
   [COORD @D60598, AGR [COUNT @D60597, PER @D60596, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : GO, 
   [COORD @D60600, AGR [COUNT @D60599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : GO, 
   [COORD @D60602, AGR [COUNT @D60601, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : GO, 
   [COORD @D60606, AGR [COUNT @D60605, PER @D60604, PLU @D60603, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AFTER, ARITY 2] : GO, 
   [COORD @D60612, PAST @D60611, AGR [CASE @D60610, COUNT @D60609, 
            PER @D60608, PLU @D60607, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AFTER, ARITY 2] : GO, 
   [COORD @D60615, 
      AGR [COUNT @D60614, PER @D60613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, 
      ARITY 2] : GO, 
   [COORD @D60617, AGR [COUNT @D60616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : GO, 
   [COORD @D60619, AGR [COUNT @D60618, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : GO, 
   [COORD @D60623, AGR [COUNT @D60622, PER @D60621, PLU @D60620, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, ARITY 2] : GO, 
   [COORD @D60629, PAST @D60628, AGR [CASE @D60627, COUNT @D60626, 
            PER @D60625, PLU @D60624, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, ARITY 2] : GO, 
   [COORD @D60632, 
      AGR [COUNT @D60631, PER @D60630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   GO, 
   [COORD @D60634, AGR [COUNT @D60633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : GO, 
   [COORD @D60636, AGR [COUNT @D60635, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : GO, 
   [COORD @D60640, AGR [COUNT @D60639, PER @D60638, PLU @D60637, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : GO, 
   [COORD @D60646, PAST @D60645, AGR [CASE @D60644, COUNT @D60643, 
            PER @D60642, PLU @D60641, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : GO, 
   [COORD @D60649, AGR [COUNT @D60648, PER @D60647, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT WITHOUT, ARITY 1] : GO, 
   [COORD @D60651, AGR [COUNT @D60650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT WITHOUT, ARITY 1] : GO, 
   [COORD @D60653, AGR [COUNT @D60652, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT WITHOUT, ARITY 1] : GO, 
   [COORD @D60657, AGR [COUNT @D60656, PER @D60655, PLU @D60654, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT WITHOUT, ARITY 1] : GO, 
   [COORD @D60663, PAST @D60662, 
      AGR [CASE @D60661, COUNT @D60660, PER @D60659, PLU @D60658, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT WITHOUT, 
      ARITY 1] : GO, 
   [COORD @D60666, AGR [COUNT @D60665, PER @D60664, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : GO, 
   [COORD @D60668, AGR [COUNT @D60667, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : GO, 
   [COORD @D60670, AGR [COUNT @D60669, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : GO, 
   [COORD @D60674, AGR [COUNT @D60673, PER @D60672, PLU @D60671, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : GO, 
   [COORD @D60680, PAST @D60679, 
      AGR [CASE @D60678, COUNT @D60677, PER @D60676, PLU @D60675, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : GO, 
   [COORD @D60683, AGR [COUNT @D60682, PER @D60681, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UNDER, ARITY 1] : GO, 
   [COORD @D60685, AGR [COUNT @D60684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UNDER, ARITY 1] : GO, 
   [COORD @D60687, AGR [COUNT @D60686, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UNDER, ARITY 1] : GO, 
   [COORD @D60691, AGR [COUNT @D60690, PER @D60689, PLU @D60688, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UNDER, ARITY 1] : GO, 
   [COORD @D60697, PAST @D60696, 
      AGR [CASE @D60695, COUNT @D60694, PER @D60693, PLU @D60692, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UNDER, 
      ARITY 1] : GO, 
   [COORD @D60700, AGR [COUNT @D60699, PER @D60698, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : GO, 
   [COORD @D60702, AGR [COUNT @D60701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : GO, 
   [COORD @D60704, AGR [COUNT @D60703, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : GO, 
   [COORD @D60708, AGR [COUNT @D60707, PER @D60706, PLU @D60705, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, ARITY 1] : GO, 
   [COORD @D60714, PAST @D60713, 
      AGR [CASE @D60712, COUNT @D60711, PER @D60710, PLU @D60709, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TOGETHER, 
      ARITY 1] : GO, 
   [COORD @D60717, AGR [COUNT @D60716, PER @D60715, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : GO, 
   [COORD @D60719, AGR [COUNT @D60718, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : GO, 
   [COORD @D60721, AGR [COUNT @D60720, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : GO, 
   [COORD @D60725, AGR [COUNT @D60724, PER @D60723, PLU @D60722, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : GO, 
   [COORD @D60731, PAST @D60730, 
      AGR [CASE @D60729, COUNT @D60728, PER @D60727, PLU @D60726, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT THROUGH, 
      ARITY 1] : GO, 
   [COORD @D60734, AGR [COUNT @D60733, PER @D60732, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : GO, 
   [COORD @D60736, AGR [COUNT @D60735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : GO, 
   [COORD @D60738, AGR [COUNT @D60737, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : GO, 
   [COORD @D60742, AGR [COUNT @D60741, PER @D60740, PLU @D60739, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ROUND, ARITY 1] : GO, 
   [COORD @D60748, PAST @D60747, 
      AGR [CASE @D60746, COUNT @D60745, PER @D60744, PLU @D60743, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ROUND, 
      ARITY 1] : GO, 
   [COORD @D60751, AGR [COUNT @D60750, PER @D60749, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : GO, 
   [COORD @D60753, AGR [COUNT @D60752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : GO, 
   [COORD @D60755, AGR [COUNT @D60754, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : GO, 
   [COORD @D60759, AGR [COUNT @D60758, PER @D60757, PLU @D60756, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : GO, 
   [COORD @D60765, PAST @D60764, 
      AGR [CASE @D60763, COUNT @D60762, PER @D60761, PLU @D60760, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : GO, 
   [COORD @D60768, AGR [COUNT @D60767, PER @D60766, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : GO, 
   [COORD @D60770, AGR [COUNT @D60769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : GO, 
   [COORD @D60772, AGR [COUNT @D60771, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : GO, 
   [COORD @D60776, AGR [COUNT @D60775, PER @D60774, PLU @D60773, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : GO, 
   [COORD @D60782, PAST @D60781, 
      AGR [CASE @D60780, COUNT @D60779, PER @D60778, PLU @D60777, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : GO, 
   [COORD @D60785, AGR [COUNT @D60784, PER @D60783, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : GO, 
   [COORD @D60787, AGR [COUNT @D60786, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : GO, 
   [COORD @D60789, AGR [COUNT @D60788, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : GO, 
   [COORD @D60793, AGR [COUNT @D60792, PER @D60791, PLU @D60790, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : GO, 
   [COORD @D60799, PAST @D60798, 
      AGR [CASE @D60797, COUNT @D60796, PER @D60795, PLU @D60794, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : GO, 
   [COORD @D60802, AGR [COUNT @D60801, PER @D60800, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FAR, ARITY 1] : GO, 
   [COORD @D60804, AGR [COUNT @D60803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FAR, ARITY 1] : GO, 
   [COORD @D60806, AGR [COUNT @D60805, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FAR, ARITY 1] : GO, 
   [COORD @D60810, AGR [COUNT @D60809, PER @D60808, PLU @D60807, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FAR, ARITY 1] : GO, 
   [COORD @D60816, PAST @D60815, 
      AGR [CASE @D60814, COUNT @D60813, PER @D60812, PLU @D60811, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FAR, 
      ARITY 1] : GO, 
   [COORD @D60819, AGR [COUNT @D60818, PER @D60817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : GO, 
   [COORD @D60821, AGR [COUNT @D60820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : GO, 
   [COORD @D60823, AGR [COUNT @D60822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : GO, 
   [COORD @D60827, AGR [COUNT @D60826, PER @D60825, PLU @D60824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : GO, 
   [COORD @D60833, PAST @D60832, 
      AGR [CASE @D60831, COUNT @D60830, PER @D60829, PLU @D60828, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : GO, 
   [COORD @D60836, AGR [COUNT @D60835, PER @D60834, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : GO, 
   [COORD @D60838, AGR [COUNT @D60837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : GO, 
   [COORD @D60840, AGR [COUNT @D60839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : GO, 
   [COORD @D60844, AGR [COUNT @D60843, PER @D60842, PLU @D60841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, ARITY 1] : GO, 
   [COORD @D60850, PAST @D60849, 
      AGR [CASE @D60848, COUNT @D60847, PER @D60846, PLU @D60845, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BY, 
      ARITY 1] : GO, 
   [COORD @D60853, AGR [COUNT @D60852, PER @D60851, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : GO, 
   [COORD @D60855, AGR [COUNT @D60854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : GO, 
   [COORD @D60857, AGR [COUNT @D60856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : GO, 
   [COORD @D60861, AGR [COUNT @D60860, PER @D60859, PLU @D60858, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : GO, 
   [COORD @D60867, PAST @D60866, 
      AGR [CASE @D60865, COUNT @D60864, PER @D60863, PLU @D60862, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : GO, 
   [COORD @D60870, AGR [COUNT @D60869, PER @D60868, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : GO, 
   [COORD @D60872, AGR [COUNT @D60871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : GO, 
   [COORD @D60874, AGR [COUNT @D60873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : GO, 
   [COORD @D60878, AGR [COUNT @D60877, PER @D60876, PLU @D60875, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, ARITY 1] : GO, 
   [COORD @D60884, PAST @D60883, 
      AGR [CASE @D60882, COUNT @D60881, PER @D60880, PLU @D60879, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AROUND, 
      ARITY 1] : GO, 
   [COORD @D60887, AGR [COUNT @D60886, PER @D60885, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : GO, 
   [COORD @D60889, AGR [COUNT @D60888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : GO, 
   [COORD @D60891, AGR [COUNT @D60890, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : GO, 
   [COORD @D60895, AGR [COUNT @D60894, PER @D60893, PLU @D60892, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALONG, ARITY 1] : GO, 
   [COORD @D60901, PAST @D60900, 
      AGR [CASE @D60899, COUNT @D60898, PER @D60897, PLU @D60896, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ALONG, 
      ARITY 1] : GO, 
   [COORD @D60904, AGR [COUNT @D60903, PER @D60902, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AHEAD, ARITY 1] : GO, 
   [COORD @D60906, AGR [COUNT @D60905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AHEAD, ARITY 1] : GO, 
   [COORD @D60908, AGR [COUNT @D60907, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AHEAD, ARITY 1] : GO, 
   [COORD @D60912, AGR [COUNT @D60911, PER @D60910, PLU @D60909, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AHEAD, ARITY 1] : GO, 
   [COORD @D60918, PAST @D60917, 
      AGR [CASE @D60916, COUNT @D60915, PER @D60914, PLU @D60913, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AHEAD, 
      ARITY 1] : GO, 
   [COORD @D60921, AGR [COUNT @D60920, PER @D60919, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : GO, 
   [COORD @D60923, AGR [COUNT @D60922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : GO, 
   [COORD @D60925, AGR [COUNT @D60924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : GO, 
   [COORD @D60929, AGR [COUNT @D60928, PER @D60927, PLU @D60926, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : GO, 
   [COORD @D60935, PAST @D60934, 
      AGR [CASE @D60933, COUNT @D60932, PER @D60931, PLU @D60930, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, 
      ARITY 1] : GO.

WORD going : 
   [COADV @D60955, COORD @D60954, DEF @D60953, PRD @D60952, AGR 
            [CASE @D60951, COUNT @D60950, PER @D60949, PLU @D60948, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PST] : GOING, 
   [COADV @D60963, COORD @D60962, DEF @D60961, PRD @D60960, 
      AGR [CASE @D60959, COUNT @D60958, PER @D60957, PLU @D60956, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : GOING, 
   [COORD @D60967, REFL @D60966, PRD @D60965, CASE @D60964, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : GOING, 
   [COORD @D60973, PRD @D60972, 
      AGR [CASE @D60971, COUNT @D60970, PER @D60969, PLU @D60968, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D60979, PRD @D60978, 
      AGR [CASE @D60977, COUNT @D60976, PER @D60975, PLU @D60974, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D60985, PRD @D60984, 
      AGR [CASE @D60983, COUNT @D60982, PER @D60981, PLU @D60980, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D60991, PRD @D60990, 
      AGR [CASE @D60989, COUNT @D60988, PER @D60987, PLU @D60986, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D60997, PRD @D60996, 
      AGR [CASE @D60995, COUNT @D60994, PER @D60993, PLU @D60992, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61003, PRD @D61002, 
      AGR [CASE @D61001, COUNT @D61000, PER @D60999, PLU @D60998, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61009, PRD @D61008, AGR [CASE @D61007, COUNT @D61006, 
            PER @D61005, PLU @D61004, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61015, PRD @D61014, 
      AGR [CASE @D61013, COUNT @D61012, PER @D61011, PLU @D61010, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61021, PRD @D61020, AGR [CASE @D61019, COUNT @D61018, 
            PER @D61017, PLU @D61016, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61027, PRD @D61026, 
      AGR [CASE @D61025, COUNT @D61024, PER @D61023, PLU @D61022, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61033, PRD @D61032, AGR [CASE @D61031, COUNT @D61030, 
            PER @D61029, PLU @D61028, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT IN, 
      PREP FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61039, PRD @D61038, 
      AGR [CASE @D61037, COUNT @D61036, PER @D61035, PLU @D61034, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PREP ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61045, PRD @D61044, AGR [CASE @D61043, COUNT @D61042, 
            PER @D61041, PLU @D61040, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITHOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61051, PRD @D61050, 
      AGR [CASE @D61049, COUNT @D61048, PER @D61047, PLU @D61046, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61057, PRD @D61056, AGR [CASE @D61055, COUNT @D61054, 
            PER @D61053, PLU @D61052, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PRT THROUGH, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61063, PRD @D61062, 
      AGR [CASE @D61061, COUNT @D61060, PER @D61059, PLU @D61058, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61069, PRD @D61068, AGR [CASE @D61067, COUNT @D61066, 
            PER @D61065, PLU @D61064, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61075, PRD @D61074, 
      AGR [CASE @D61073, COUNT @D61072, PER @D61071, PLU @D61070, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61081, PRD @D61080, AGR [CASE @D61079, COUNT @D61078, 
            PER @D61077, PLU @D61076, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61087, PRD @D61086, 
      AGR [CASE @D61085, COUNT @D61084, PER @D61083, PLU @D61082, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AROUND, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GO, 
   [COORD @D61093, PRD @D61092, AGR [CASE @D61091, COUNT @D61090, 
            PER @D61089, PLU @D61088, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALONG, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61099, PRD @D61098, 
      AGR [CASE @D61097, COUNT @D61096, PER @D61095, PLU @D61094, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AHEAD, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GO, 
   [COORD @D61105, PRD @D61104, AGR [CASE @D61103, COUNT @D61102, 
            PER @D61101, PLU @D61100, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ABOUT, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61111, PRD @D61110, 
      AGR [CASE @D61109, COUNT @D61108, PER @D61107, PLU @D61106, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61117, PRD @D61116, AGR [CASE @D61115, COUNT @D61114, 
            PER @D61113, PLU @D61112, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61123, PRD @D61122, 
      AGR [CASE @D61121, COUNT @D61120, PER @D61119, PLU @D61118, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61129, PRD @D61128, AGR [CASE @D61127, COUNT @D61126, 
            PER @D61125, PLU @D61124, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61135, PRD @D61134, 
      AGR [CASE @D61133, COUNT @D61132, PER @D61131, PLU @D61130, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61141, PRD @D61140, AGR [CASE @D61139, COUNT @D61138, 
            PER @D61137, PLU @D61136, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61147, PRD @D61146, 
      AGR [CASE @D61145, COUNT @D61144, PER @D61143, PLU @D61142, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61153, PRD @D61152, AGR [CASE @D61151, COUNT @D61150, 
            PER @D61149, PLU @D61148, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61159, PRD @D61158, 
      AGR [CASE @D61157, COUNT @D61156, PER @D61155, PLU @D61154, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61165, PRD @D61164, AGR [CASE @D61163, COUNT @D61162, 
            PER @D61161, PLU @D61160, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61171, PRD @D61170, 
      AGR [CASE @D61169, COUNT @D61168, PER @D61167, PLU @D61166, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT BACK, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GO, 
   [COORD @D61177, PRD @D61176, AGR [CASE @D61175, COUNT @D61174, 
            PER @D61173, PLU @D61172, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61183, PRD @D61182, 
      AGR [CASE @D61181, COUNT @D61180, PER @D61179, PLU @D61178, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM LIKE, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61189, PRD @D61188, AGR [CASE @D61187, COUNT @D61186, 
            PER @D61185, PLU @D61184, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61195, PRD @D61194, 
      AGR [CASE @D61193, COUNT @D61192, PER @D61191, PLU @D61190, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61201, PRD @D61200, AGR [CASE @D61199, COUNT @D61198, 
            PER @D61197, PLU @D61196, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61207, PRD @D61206, 
      AGR [CASE @D61205, COUNT @D61204, PER @D61203, PLU @D61202, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GO, 
   [COORD @D61213, PRD @D61212, AGR [CASE @D61211, COUNT @D61210, 
            PER @D61209, PLU @D61208, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61219, PRD @D61218, 
      AGR [CASE @D61217, COUNT @D61216, PER @D61215, PLU @D61214, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61225, PRD @D61224, AGR [CASE @D61223, COUNT @D61222, 
            PER @D61221, PLU @D61220, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61231, PRD @D61230, 
      AGR [CASE @D61229, COUNT @D61228, PER @D61227, PLU @D61226, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GO, 
   [COORD @D61237, PRD @D61236, AGR [CASE @D61235, COUNT @D61234, 
            PER @D61233, PLU @D61232, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61243, PRD @D61242, 
      AGR [CASE @D61241, COUNT @D61240, PER @D61239, PLU @D61238, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM BEFORE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GO, 
   [COORD @D61249, PRD @D61248, AGR [CASE @D61247, COUNT @D61246, 
            PER @D61245, PLU @D61244, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61255, PRD @D61254, 
      AGR [CASE @D61253, COUNT @D61252, PER @D61251, PLU @D61250, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ON, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61261, PRD @D61260, AGR [CASE @D61259, COUNT @D61258, 
            PER @D61257, PLU @D61256, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61267, PRD @D61266, 
      AGR [CASE @D61265, COUNT @D61264, PER @D61263, PLU @D61262, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61273, PRD @D61272, AGR [CASE @D61271, COUNT @D61270, 
            PER @D61269, PLU @D61268, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61279, PRD @D61278, 
      AGR [CASE @D61277, COUNT @D61276, PER @D61275, PLU @D61274, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61285, PRD @D61284, 
      AGR [CASE @D61283, COUNT @D61282, PER @D61281, PLU @D61280, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT WITHOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61291, PRD @D61290, AGR [CASE @D61289, COUNT @D61288, 
            PER @D61287, PLU @D61286, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61297, PRD @D61296, 
      AGR [CASE @D61295, COUNT @D61294, PER @D61293, PLU @D61292, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UNDER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61303, PRD @D61302, AGR [CASE @D61301, COUNT @D61300, 
            PER @D61299, PLU @D61298, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61309, PRD @D61308, 
      AGR [CASE @D61307, COUNT @D61306, PER @D61305, PLU @D61304, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GO, 
   [COORD @D61315, PRD @D61314, AGR [CASE @D61313, COUNT @D61312, 
            PER @D61311, PLU @D61310, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61321, PRD @D61320, 
      AGR [CASE @D61319, COUNT @D61318, PER @D61317, PLU @D61316, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61327, PRD @D61326, AGR [CASE @D61325, COUNT @D61324, 
            PER @D61323, PLU @D61322, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61333, PRD @D61332, 
      AGR [CASE @D61331, COUNT @D61330, PER @D61329, PLU @D61328, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61339, PRD @D61338, AGR [CASE @D61337, COUNT @D61336, 
            PER @D61335, PLU @D61334, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FAR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61345, PRD @D61344, 
      AGR [CASE @D61343, COUNT @D61342, PER @D61341, PLU @D61340, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61351, PRD @D61350, AGR [CASE @D61349, COUNT @D61348, 
            PER @D61347, PLU @D61346, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61357, PRD @D61356, 
      AGR [CASE @D61355, COUNT @D61354, PER @D61353, PLU @D61352, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61363, PRD @D61362, AGR [CASE @D61361, COUNT @D61360, 
            PER @D61359, PLU @D61358, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61369, PRD @D61368, 
      AGR [CASE @D61367, COUNT @D61366, PER @D61365, PLU @D61364, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO, 
   [COORD @D61375, PRD @D61374, AGR [CASE @D61373, COUNT @D61372, 
            PER @D61371, PLU @D61370, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GO, 
   [COORD @D61381, PRD @D61380, 
      AGR [CASE @D61379, COUNT @D61378, PER @D61377, PLU @D61376, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : GO.

WORD goings : 
   [COORD @D61393, REFL @D61392, PRD @D61391, CASE @D61390, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : GOINGS.

WORD goingses : 
   [COORD @D61409, DEMON @D61408, REFL @D61407, PRD @D61406, 
      CASE @D61405, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : GOINGS.

WORD got : 
   [COORD @D61421, PAST @D61420, AGR [CASE @D61419, COUNT @D61418, 
            PER @D61417, PLU @D61416, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : GET, 
   [COORD @D61427, PAST @D61426, 
      AGR [CASE @D61425, COUNT @D61424, PER @D61423, PLU @D61422, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : GET, 
   [COORD @D61433, PAST @D61432, 
      AGR [CASE @D61431, COUNT @D61430, PER @D61429, PLU @D61428, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : GET, 
   [COORD @D61439, PAST @D61438, AGR [CASE @D61437, COUNT @D61436, 
            PER @D61435, PLU @D61434, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : GET, 
   [COORD @D61445, PAST @D61444, 
      AGR [CASE @D61443, COUNT @D61442, PER @D61441, PLU @D61440, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_SFIN, REG -, 
      PRT THROUGH, PFORM TO, FIN -, ARITY 3] : GET, 
   [COORD @D61451, PAST @D61450, 
      AGR [CASE @D61449, COUNT @D61448, PER @D61447, PLU @D61446, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP_SFIN, REG -, PRT THROUGH, 
      PFORM TO, FIN -, ARITY 3] : GET, 
   [COORD @D61457, PAST @D61456, AGR [CASE @D61455, COUNT @D61454, 
            PER @D61453, PLU @D61452, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, FIN -, ARITY 3] : GET, 
   [COORD @D61463, PAST @D61462, 
      AGR [CASE @D61461, COUNT @D61460, PER @D61459, PLU @D61458, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM THROUGH, FIN -, 
      ARITY 3] : GET, 
   [COORD @D61469, PAST @D61468, AGR [CASE @D61467, COUNT @D61466, 
            PER @D61465, PLU @D61464, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : GET, 
   [COORD @D61475, PAST @D61474, 
      AGR [CASE @D61473, COUNT @D61472, PER @D61471, PLU @D61470, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 3] : GET, 
   [COORD @D61481, PAST @D61480, AGR [CASE @D61479, COUNT @D61478, 
            PER @D61477, PLU @D61476, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : GET, 
   [COORD @D61487, PAST @D61486, 
      AGR [CASE @D61485, COUNT @D61484, PER @D61483, PLU @D61482, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, FIN -, 
      ARITY 3] : GET, 
   [COORD @D61493, PAST @D61492, AGR [CASE @D61491, COUNT @D61490, 
            PER @D61489, PLU @D61488, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : GET, 
   [COORD @D61499, PAST @D61498, 
      AGR [CASE @D61497, COUNT @D61496, PER @D61495, PLU @D61494, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, FIN -, 
      ARITY 3] : GET, 
   [COORD @D61505, PAST @D61504, AGR [CASE @D61503, COUNT @D61502, 
            PER @D61501, PLU @D61500, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM WITH, FIN -, ARITY 3] : GET, 
   [COORD @D61511, PAST @D61510, 
      AGR [CASE @D61509, COUNT @D61508, PER @D61507, PLU @D61506, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM WITH, FIN -, ARITY 3] : GET, 
   [COORD @D61517, PAST @D61516, AGR [CASE @D61515, COUNT @D61514, 
            PER @D61513, PLU @D61512, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, PFORM TO, FIN -, ARITY 3] : GET, 
   [COORD @D61523, PAST @D61522, 
      AGR [CASE @D61521, COUNT @D61520, PER @D61519, PLU @D61518, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, PFORM TO, FIN -, ARITY 3] : GET, 
   [COORD @D61529, PAST @D61528, 
      AGR [CASE @D61527, COUNT @D61526, PER @D61525, PLU @D61524, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, PFORM TO, 
      FIN -, ARITY 3] : GET, 
   [COORD @D61535, PAST @D61534, AGR [CASE @D61533, COUNT @D61532, 
            PER @D61531, PLU @D61530, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, PFORM TO, FIN -, ARITY 3] : GET, 
   [COORD @D61541, PAST @D61540, 
      AGR [CASE @D61539, COUNT @D61538, PER @D61537, PLU @D61536, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ACROSS, 
      PFORM TO, FIN -, ARITY 3] : GET, 
   [COORD @D61547, PAST @D61546, AGR [CASE @D61545, COUNT @D61544, 
            PER @D61543, PLU @D61542, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ACROSS, PFORM TO, FIN -, ARITY 3] : GET, 
   [COORD @D61553, PAST @D61552, 
      AGR [CASE @D61551, COUNT @D61550, PER @D61549, PLU @D61548, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 3] : GET, 
   [COORD @D61559, PAST @D61558, AGR [CASE @D61557, COUNT @D61556, 
            PER @D61555, PLU @D61554, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : GET, 
   [COORD @D61563, 
      AGR [COUNT @D61562, PER @D61561, PLU @D61560, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : GET, 
   [COORD @D61567, AGR [COUNT @D61566, PER @D61565, PLU @D61564, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : GET, 
   [COORD @D61571, AGR [COUNT @D61570, PER @D61569, PLU @D61568, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_SFIN, REG -, 
      PRT THROUGH, PFORM TO, PAST +, ARITY 3] : GET, 
   [COORD @D61575, AGR [COUNT @D61574, PER @D61573, PLU @D61572, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, PAST +, ARITY 3] : GET, 
   [COORD @D61579, AGR [COUNT @D61578, PER @D61577, PLU @D61576, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, PAST +, ARITY 3] : GET, 
   [COORD @D61583, AGR [COUNT @D61582, PER @D61581, PLU @D61580, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, PAST +, ARITY 3] : GET, 
   [COORD @D61587, AGR [COUNT @D61586, PER @D61585, PLU @D61584, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, PAST +, ARITY 3] : GET, 
   [COORD @D61591, AGR [COUNT @D61590, PER @D61589, PLU @D61588, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PFORM WITH, PAST +, ARITY 3] : GET, 
   [COORD @D61595, AGR [COUNT @D61594, PER @D61593, PLU @D61592, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, PFORM TO, PAST +, ARITY 3] : GET, 
   [COORD @D61599, AGR [COUNT @D61598, PER @D61597, PLU @D61596, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PFORM TO, PAST +, ARITY 3] : GET, 
   [COORD @D61603, AGR [COUNT @D61602, PER @D61601, PLU @D61600, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ACROSS, PFORM TO, PAST +, ARITY 3] : GET, 
   [COORD @D61607, AGR [COUNT @D61606, PER @D61605, PLU @D61604, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PFORM OF, PAST +, ARITY 3] : GET, 
   [COORD @D61613, PAST @D61612, 
      AGR [CASE @D61611, COUNT @D61610, PER @D61609, PLU @D61608, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_PASS, REG -, FIN -, ARITY 2] : 
   GET, 
   [COORD @D61619, PAST @D61618, AGR [CASE @D61617, COUNT @D61616, 
            PER @D61615, PLU @D61614, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, REG -, FIN -, ARITY 2] : GET, 
   [COORD @D61622, AGR @D61621, PAST @D61620, VFORM EN, SUBCAT OC_INF, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61628, PAST @D61627, AGR [CASE @D61626, COUNT @D61625, 
            PER @D61624, PLU @D61623, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 2] : GET, 
   [COORD @D61631, AGR @D61630, PAST @D61629, VFORM EN, SUBCAT OC_AP, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61637, PAST @D61636, AGR [CASE @D61635, COUNT @D61634, 
            PER @D61633, PLU @D61632, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 2] : GET, 
   [COORD @D61643, PAST @D61642, 
      AGR [CASE @D61641, COUNT @D61640, PER @D61639, PLU @D61638, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61649, PAST @D61648, AGR [CASE @D61647, COUNT @D61646, 
            PER @D61645, PLU @D61644, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : GET, 
   [COORD @D61655, PAST @D61654, 
      AGR [CASE @D61653, COUNT @D61652, PER @D61651, PLU @D61650, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, FIN -, ARITY 2] : GET, 
   [COORD @D61661, PAST @D61660, 
      AGR [CASE @D61659, COUNT @D61658, PER @D61657, PLU @D61656, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT THROUGH, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61667, PAST @D61666, AGR [CASE @D61665, COUNT @D61664, 
            PER @D61663, PLU @D61662, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT OVER_WITH, FIN -, ARITY 2] : GET, 
   [COORD @D61673, PAST @D61672, 
      AGR [CASE @D61671, COUNT @D61670, PER @D61669, PLU @D61668, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT OVER_WITH, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61679, PAST @D61678, AGR [CASE @D61677, COUNT @D61676, 
            PER @D61675, PLU @D61674, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT AWAY, PREP WITH, FIN -, ARITY 2] : GET, 
   [COORD @D61685, PAST @D61684, 
      AGR [CASE @D61683, COUNT @D61682, PER @D61681, PLU @D61680, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT ROUND, PREP TO, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61691, PAST @D61690, AGR [CASE @D61689, COUNT @D61688, 
            PER @D61687, PLU @D61686, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT DOWN, PREP TO, FIN -, ARITY 2] : GET, 
   [COORD @D61697, PAST @D61696, 
      AGR [CASE @D61695, COUNT @D61694, PER @D61693, PLU @D61692, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT AROUND, PREP TO, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61703, PAST @D61702, AGR [CASE @D61701, COUNT @D61700, 
            PER @D61699, PLU @D61698, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT OUT, PREP OF, FIN -, ARITY 2] : GET, 
   [COORD @D61709, PAST @D61708, 
      AGR [CASE @D61707, COUNT @D61706, PER @D61705, PLU @D61704, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT TOGETHER, PFORM WITH, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61715, PAST @D61714, AGR [CASE @D61713, COUNT @D61712, 
            PER @D61711, PLU @D61710, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT THROUGH, PFORM WITH, FIN -, ARITY 2] : GET, 
   [COORD @D61721, PAST @D61720, 
      AGR [CASE @D61719, COUNT @D61718, PER @D61717, PLU @D61716, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, PFORM WITH, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61727, PAST @D61726, AGR [CASE @D61725, COUNT @D61724, 
            PER @D61723, PLU @D61722, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM WITH, FIN -, ARITY 2] : GET, 
   [COORD @D61733, PAST @D61732, 
      AGR [CASE @D61731, COUNT @D61730, PER @D61729, PLU @D61728, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OFF, PFORM WITH, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61739, PAST @D61738, AGR [CASE @D61737, COUNT @D61736, 
            PER @D61735, PLU @D61734, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT BEHIND, PFORM WITH, FIN -, ARITY 2] : GET, 
   [COORD @D61745, PAST @D61744, 
      AGR [CASE @D61743, COUNT @D61742, PER @D61741, PLU @D61740, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, 
      PFORM WITH, FIN -, ARITY 2] : GET, 
   [COORD @D61751, PAST @D61750, AGR [CASE @D61749, COUNT @D61748, 
            PER @D61747, PLU @D61746, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT AWAY, PFORM WITH, FIN -, ARITY 2] : GET, 
   [COORD @D61757, PAST @D61756, 
      AGR [CASE @D61755, COUNT @D61754, PER @D61753, PLU @D61752, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ALONG, PFORM WITH, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61763, PAST @D61762, AGR [CASE @D61761, COUNT @D61760, 
            PER @D61759, PLU @D61758, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM TO, FIN -, ARITY 2] : GET, 
   [COORD @D61769, PAST @D61768, 
      AGR [CASE @D61767, COUNT @D61766, PER @D61765, PLU @D61764, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM TO, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61775, PAST @D61774, AGR [CASE @D61773, COUNT @D61772, 
            PER @D61771, PLU @D61770, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT THROUGH, PFORM TO, FIN -, ARITY 2] : GET, 
   [COORD @D61781, PAST @D61780, 
      AGR [CASE @D61779, COUNT @D61778, PER @D61777, PLU @D61776, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ROUND, 
      PFORM TO, FIN -, ARITY 2] : GET, 
   [COORD @D61787, PAST @D61786, AGR [CASE @D61785, COUNT @D61784, 
            PER @D61783, PLU @D61782, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT ROUND, PFORM TO, FIN -, ARITY 2] : GET, 
   [COORD @D61793, PAST @D61792, 
      AGR [CASE @D61791, COUNT @D61790, PER @D61789, PLU @D61788, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, PFORM TO, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61799, PAST @D61798, AGR [CASE @D61797, COUNT @D61796, 
            PER @D61795, PLU @D61794, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM TO, FIN -, ARITY 2] : GET, 
   [COORD @D61805, PAST @D61804, 
      AGR [CASE @D61803, COUNT @D61802, PER @D61801, PLU @D61800, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT DOWN, PFORM TO, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61811, PAST @D61810, AGR [CASE @D61809, COUNT @D61808, 
            PER @D61807, PLU @D61806, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AROUND, PFORM TO, FIN -, ARITY 2] : GET, 
   [COORD @D61817, PAST @D61816, 
      AGR [CASE @D61815, COUNT @D61814, PER @D61813, PLU @D61812, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT AROUND, PFORM TO, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61823, PAST @D61822, AGR [CASE @D61821, COUNT @D61820, 
            PER @D61819, PLU @D61818, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT ACROSS, PFORM TO, FIN -, ARITY 2] : GET, 
   [COORD @D61829, PAST @D61828, 
      AGR [CASE @D61827, COUNT @D61826, PER @D61825, PLU @D61824, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM THROUGH, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61835, PAST @D61834, AGR [CASE @D61833, COUNT @D61832, 
            PER @D61831, PLU @D61830, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM THROUGH, FIN -, ARITY 2] : GET, 
   [COORD @D61841, PAST @D61840, 
      AGR [CASE @D61839, COUNT @D61838, PER @D61837, PLU @D61836, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ROUND, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61847, PAST @D61846, AGR [CASE @D61845, COUNT @D61844, 
            PER @D61843, PLU @D61842, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ROUND, FIN -, ARITY 2] : GET, 
   [COORD @D61853, PAST @D61852, 
      AGR [CASE @D61851, COUNT @D61850, PER @D61849, PLU @D61848, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM OVER, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61859, PAST @D61858, AGR [CASE @D61857, COUNT @D61856, 
            PER @D61855, PLU @D61854, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM OVER, FIN -, ARITY 2] : GET, 
   [COORD @D61865, PAST @D61864, 
      AGR [CASE @D61863, COUNT @D61862, PER @D61861, PLU @D61860, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ONTO, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61871, PAST @D61870, AGR [CASE @D61869, COUNT @D61868, 
            PER @D61867, PLU @D61866, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ONTO, FIN -, ARITY 2] : GET, 
   [COORD @D61877, PAST @D61876, 
      AGR [CASE @D61875, COUNT @D61874, PER @D61873, PLU @D61872, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ON, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61883, PAST @D61882, AGR [CASE @D61881, COUNT @D61880, 
            PER @D61879, PLU @D61878, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ON, FIN -, ARITY 2] : GET, 
   [COORD @D61889, PAST @D61888, 
      AGR [CASE @D61887, COUNT @D61886, PER @D61885, PLU @D61884, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, PFORM ON, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61895, PAST @D61894, AGR [CASE @D61893, COUNT @D61892, 
            PER @D61891, PLU @D61890, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM OFF, FIN -, ARITY 2] : GET, 
   [COORD @D61901, PAST @D61900, 
      AGR [CASE @D61899, COUNT @D61898, PER @D61897, PLU @D61896, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61907, PAST @D61906, AGR [CASE @D61905, COUNT @D61904, 
            PER @D61903, PLU @D61902, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, FIN -, ARITY 2] : GET, 
   [COORD @D61913, PAST @D61912, 
      AGR [CASE @D61911, COUNT @D61910, PER @D61909, PLU @D61908, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 2] : GET, 
   [COORD @D61919, PAST @D61918, AGR [CASE @D61917, COUNT @D61916, 
            PER @D61915, PLU @D61914, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT AHEAD, PFORM OF, FIN -, ARITY 2] : GET, 
   [COORD @D61925, PAST @D61924, 
      AGR [CASE @D61923, COUNT @D61922, PER @D61921, PLU @D61920, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM INTO, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61931, PAST @D61930, AGR [CASE @D61929, COUNT @D61928, 
            PER @D61927, PLU @D61926, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM INTO, FIN -, ARITY 2] : GET, 
   [COORD @D61937, PAST @D61936, 
      AGR [CASE @D61935, COUNT @D61934, PER @D61933, PLU @D61932, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM IN, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61943, PAST @D61942, AGR [CASE @D61941, COUNT @D61940, 
            PER @D61939, PLU @D61938, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM IN, FIN -, ARITY 2] : GET, 
   [COORD @D61949, PAST @D61948, 
      AGR [CASE @D61947, COUNT @D61946, PER @D61945, PLU @D61944, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, PFORM IN, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61955, PAST @D61954, AGR [CASE @D61953, COUNT @D61952, 
            PER @D61951, PLU @D61950, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT AWAY, PFORM FROM, FIN -, ARITY 2] : GET, 
   [COORD @D61961, PAST @D61960, 
      AGR [CASE @D61959, COUNT @D61958, PER @D61957, PLU @D61956, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, PFORM FOR, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61967, PAST @D61966, AGR [CASE @D61965, COUNT @D61964, 
            PER @D61963, PLU @D61962, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AT, FIN -, ARITY 2] : GET, 
   [COORD @D61973, PAST @D61972, 
      AGR [CASE @D61971, COUNT @D61970, PER @D61969, PLU @D61968, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61979, PAST @D61978, AGR [CASE @D61977, COUNT @D61976, 
            PER @D61975, PLU @D61974, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT IN, PFORM AT, FIN -, ARITY 2] : GET, 
   [COORD @D61985, PAST @D61984, 
      AGR [CASE @D61983, COUNT @D61982, PER @D61981, PLU @D61980, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT BACK, PFORM AT, FIN -, 
      ARITY 2] : GET, 
   [COORD @D61991, PAST @D61990, AGR [CASE @D61989, COUNT @D61988, 
            PER @D61987, PLU @D61986, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AROUND, FIN -, ARITY 2] : GET, 
   [COORD @D61997, PAST @D61996, 
      AGR [CASE @D61995, COUNT @D61994, PER @D61993, PLU @D61992, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AROUND, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62003, PAST @D62002, AGR [CASE @D62001, COUNT @D62000, 
            PER @D61999, PLU @D61998, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ACROSS, FIN -, ARITY 2] : GET, 
   [COORD @D62009, PAST @D62008, 
      AGR [CASE @D62007, COUNT @D62006, PER @D62005, PLU @D62004, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ACROSS, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62015, PAST @D62014, AGR [CASE @D62013, COUNT @D62012, 
            PER @D62011, PLU @D62010, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : GET, 
   [COORD @D62021, PAST @D62020, 
      AGR [CASE @D62019, COUNT @D62018, PER @D62017, PLU @D62016, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : GET, 
   [COORD @D62027, PAST @D62026, AGR [CASE @D62025, COUNT @D62024, 
            PER @D62023, PLU @D62022, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, FIN -, ARITY 2] : GET, 
   [COORD @D62033, PAST @D62032, 
      AGR [CASE @D62031, COUNT @D62030, PER @D62029, PLU @D62028, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, FIN -, ARITY 2] : GET, 
   [COORD @D62039, PAST @D62038, AGR 
         [CASE @D62037, COUNT @D62036, PER @D62035, PLU @D62034, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ROUND, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62045, PAST @D62044, AGR [CASE @D62043, COUNT @D62042, 
            PER @D62041, PLU @D62040, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ROUND, FIN -, ARITY 2] : GET, 
   [COORD @D62051, PAST @D62050, 
      AGR [CASE @D62049, COUNT @D62048, PER @D62047, PLU @D62046, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62057, PAST @D62056, AGR [CASE @D62055, COUNT @D62054, 
            PER @D62053, PLU @D62052, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : GET, 
   [COORD @D62063, PAST @D62062, 
      AGR [CASE @D62061, COUNT @D62060, PER @D62059, PLU @D62058, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62069, PAST @D62068, AGR [CASE @D62067, COUNT @D62066, 
            PER @D62065, PLU @D62064, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : GET, 
   [COORD @D62075, PAST @D62074, 
      AGR [CASE @D62073, COUNT @D62072, PER @D62071, PLU @D62070, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62081, PAST @D62080, AGR [CASE @D62079, COUNT @D62078, 
            PER @D62077, PLU @D62076, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : GET, 
   [COORD @D62087, PAST @D62086, 
      AGR [CASE @D62085, COUNT @D62084, PER @D62083, PLU @D62082, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62093, PAST @D62092, AGR [CASE @D62091, COUNT @D62090, 
            PER @D62089, PLU @D62088, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : GET, 
   [COORD @D62099, PAST @D62098, 
      AGR [CASE @D62097, COUNT @D62096, PER @D62095, PLU @D62094, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62105, PAST @D62104, AGR [CASE @D62103, COUNT @D62102, 
            PER @D62101, PLU @D62100, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : GET, 
   [COORD @D62111, PAST @D62110, 
      AGR [CASE @D62109, COUNT @D62108, PER @D62107, PLU @D62106, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62117, PAST @D62116, AGR [CASE @D62115, COUNT @D62114, 
            PER @D62113, PLU @D62112, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : GET, 
   [COORD @D62123, PAST @D62122, 
      AGR [CASE @D62121, COUNT @D62120, PER @D62119, PLU @D62118, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ACROSS, FIN -, 
      ARITY 2] : GET, 
   [COORD @D62129, PAST @D62128, AGR [CASE @D62127, COUNT @D62126, 
            PER @D62125, PLU @D62124, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ACROSS, FIN -, ARITY 2] : GET, 
   [COORD @D62133, 
      AGR [COUNT @D62132, PER @D62131, PLU @D62130, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_PASS, REG -, PAST +, 
      ARITY 2] : GET, 
   [COORD @D62137, AGR [COUNT @D62136, PER @D62135, PLU @D62134, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, PAST +, ARITY 2] : GET, 
   [COORD @D62141, AGR [COUNT @D62140, PER @D62139, PLU @D62138, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PAST +, ARITY 2] : GET, 
   [COORD @D62145, AGR [COUNT @D62144, PER @D62143, PLU @D62142, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, PAST +, ARITY 2] : GET, 
   [COORD @D62149, AGR [COUNT @D62148, PER @D62147, PLU @D62146, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : GET, 
   [COORD @D62153, AGR [COUNT @D62152, PER @D62151, PLU @D62150, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, PAST +, 
      ARITY 2] : GET, 
   [COORD @D62157, AGR [COUNT @D62156, PER @D62155, PLU @D62154, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PRT THROUGH, PAST +, ARITY 2] : GET, 
   [COORD @D62161, AGR [COUNT @D62160, PER @D62159, PLU @D62158, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OVER_WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62165, AGR [COUNT @D62164, PER @D62163, PLU @D62162, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT AWAY, PREP WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62169, 
      AGR [COUNT @D62168, PER @D62167, PLU @D62166, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT ROUND, 
      PREP TO, PAST +, ARITY 2] : GET, 
   [COORD @D62173, AGR [COUNT @D62172, PER @D62171, PLU @D62170, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT DOWN, PREP TO, PAST +, ARITY 2] : GET, 
   [COORD @D62177, AGR [COUNT @D62176, PER @D62175, PLU @D62174, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT AROUND, PREP TO, PAST +, ARITY 2] : GET, 
   [COORD @D62181, 
      AGR [COUNT @D62180, PER @D62179, PLU @D62178, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT OUT, 
      PREP OF, PAST +, ARITY 2] : GET, 
   [COORD @D62185, AGR [COUNT @D62184, PER @D62183, PLU @D62182, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT TOGETHER, PFORM WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62189, AGR [COUNT @D62188, PER @D62187, PLU @D62186, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT THROUGH, PFORM WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62193, AGR [COUNT @D62192, PER @D62191, PLU @D62190, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62197, AGR [COUNT @D62196, PER @D62195, PLU @D62194, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62201, AGR [COUNT @D62200, PER @D62199, PLU @D62198, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BEHIND, PFORM WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62205, AGR [COUNT @D62204, PER @D62203, PLU @D62202, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62209, AGR [COUNT @D62208, PER @D62207, PLU @D62206, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALONG, PFORM WITH, PAST +, ARITY 2] : GET, 
   [COORD @D62213, AGR [COUNT @D62212, PER @D62211, PLU @D62210, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, PAST +, ARITY 2] : GET, 
   [COORD @D62217, AGR [COUNT @D62216, PER @D62215, PLU @D62214, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT THROUGH, PFORM TO, PAST +, ARITY 2] : GET, 
   [COORD @D62221, AGR [COUNT @D62220, PER @D62219, PLU @D62218, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT ROUND, PFORM TO, PAST +, ARITY 2] : GET, 
   [COORD @D62225, AGR [COUNT @D62224, PER @D62223, PLU @D62222, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, PAST +, ARITY 2] : GET, 
   [COORD @D62229, AGR [COUNT @D62228, PER @D62227, PLU @D62226, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM TO, PAST +, ARITY 2] : GET, 
   [COORD @D62233, AGR [COUNT @D62232, PER @D62231, PLU @D62230, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AROUND, PFORM TO, PAST +, ARITY 2] : GET, 
   [COORD @D62237, AGR [COUNT @D62236, PER @D62235, PLU @D62234, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ACROSS, PFORM TO, PAST +, ARITY 2] : GET, 
   [COORD @D62241, AGR [COUNT @D62240, PER @D62239, PLU @D62238, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, PAST +, ARITY 2] : GET, 
   [COORD @D62245, AGR [COUNT @D62244, PER @D62243, PLU @D62242, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ROUND, PAST +, ARITY 2] : GET, 
   [COORD @D62249, AGR [COUNT @D62248, PER @D62247, PLU @D62246, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, PAST +, ARITY 2] : GET, 
   [COORD @D62253, AGR [COUNT @D62252, PER @D62251, PLU @D62250, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, PAST +, ARITY 2] : GET, 
   [COORD @D62257, AGR [COUNT @D62256, PER @D62255, PLU @D62254, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, PAST +, ARITY 2] : GET, 
   [COORD @D62261, AGR [COUNT @D62260, PER @D62259, PLU @D62258, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM ON, PAST +, ARITY 2] : GET, 
   [COORD @D62265, AGR [COUNT @D62264, PER @D62263, PLU @D62262, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, PAST +, ARITY 2] : GET, 
   [COORD @D62269, AGR [COUNT @D62268, PER @D62267, PLU @D62266, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, PAST +, ARITY 2] : GET, 
   [COORD @D62273, AGR [COUNT @D62272, PER @D62271, PLU @D62270, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AHEAD, PFORM OF, PAST +, ARITY 2] : GET, 
   [COORD @D62277, AGR [COUNT @D62276, PER @D62275, PLU @D62274, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, PAST +, ARITY 2] : GET, 
   [COORD @D62281, AGR [COUNT @D62280, PER @D62279, PLU @D62278, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, PAST +, ARITY 2] : GET, 
   [COORD @D62285, AGR [COUNT @D62284, PER @D62283, PLU @D62282, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM IN, PAST +, ARITY 2] : GET, 
   [COORD @D62289, AGR [COUNT @D62288, PER @D62287, PLU @D62286, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, PAST +, ARITY 2] : GET, 
   [COORD @D62293, AGR [COUNT @D62292, PER @D62291, PLU @D62290, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM FOR, PAST +, ARITY 2] : GET, 
   [COORD @D62297, AGR [COUNT @D62296, PER @D62295, PLU @D62294, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, PAST +, ARITY 2] : GET, 
   [COORD @D62301, AGR [COUNT @D62300, PER @D62299, PLU @D62298, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM AT, PAST +, ARITY 2] : GET, 
   [COORD @D62305, AGR [COUNT @D62304, PER @D62303, PLU @D62302, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT BACK, PFORM AT, PAST +, ARITY 2] : GET, 
   [COORD @D62309, AGR [COUNT @D62308, PER @D62307, PLU @D62306, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AROUND, PAST +, ARITY 2] : GET, 
   [COORD @D62313, AGR [COUNT @D62312, PER @D62311, PLU @D62310, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, PAST +, ARITY 2] : GET, 
   [COORD @D62317, AGR [COUNT @D62316, PER @D62315, PLU @D62314, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : GET, 
   [COORD @D62321, AGR [COUNT @D62320, PER @D62319, PLU @D62318, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, PAST +, ARITY 2] : GET, 
   [COORD @D62325, AGR [COUNT @D62324, PER @D62323, PLU @D62322, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ROUND, PAST +, ARITY 2] : GET, 
   [COORD @D62329, AGR [COUNT @D62328, PER @D62327, PLU @D62326, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PAST +, ARITY 2] : GET, 
   [COORD @D62333, AGR [COUNT @D62332, PER @D62331, PLU @D62330, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : GET, 
   [COORD @D62337, AGR [COUNT @D62336, PER @D62335, PLU @D62334, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : GET, 
   [COORD @D62341, AGR [COUNT @D62340, PER @D62339, PLU @D62338, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : GET, 
   [COORD @D62345, AGR [COUNT @D62344, PER @D62343, PLU @D62342, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PAST +, ARITY 2] : GET, 
   [COORD @D62349, AGR [COUNT @D62348, PER @D62347, PLU @D62346, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PAST +, ARITY 2] : GET, 
   [COORD @D62353, AGR [COUNT @D62352, PER @D62351, PLU @D62350, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ACROSS, PAST +, ARITY 2] : GET, 
   [COORD @D62356, AGR @D62355, PAST @D62354, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_PASS, REG -, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62359, AGR @D62358, PAST @D62357, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP, REG -, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62362, AGR @D62361, PAST @D62360, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62365, AGR @D62364, PAST @D62363, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, REG -, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62368, AGR @D62367, PAST @D62366, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_AP, REG -, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62374, PAST @D62373, AGR [CASE @D62372, COUNT @D62371, 
            PER @D62370, PLU @D62369, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : GET, 
   [COORD @D62380, PAST @D62379, 
      AGR [CASE @D62378, COUNT @D62377, PER @D62376, PLU @D62375, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TOGETHER, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62386, PAST @D62385, AGR [CASE @D62384, COUNT @D62383, 
            PER @D62382, PLU @D62381, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, FIN -, ARITY 1] : GET, 
   [COORD @D62392, PAST @D62391, 
      AGR [CASE @D62390, COUNT @D62389, PER @D62388, PLU @D62387, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ROUND, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62398, PAST @D62397, AGR [CASE @D62396, COUNT @D62395, 
            PER @D62394, PLU @D62393, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER_WITH, FIN -, ARITY 1] : GET, 
   [COORD @D62404, PAST @D62403, 
      AGR [CASE @D62402, COUNT @D62401, PER @D62400, PLU @D62399, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62410, PAST @D62409, AGR [CASE @D62408, COUNT @D62407, 
            PER @D62406, PLU @D62405, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : GET, 
   [COORD @D62416, PAST @D62415, 
      AGR [CASE @D62414, COUNT @D62413, PER @D62412, PLU @D62411, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62422, PAST @D62421, AGR [CASE @D62420, COUNT @D62419, 
            PER @D62418, PLU @D62417, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : GET, 
   [COORD @D62428, PAST @D62427, 
      AGR [CASE @D62426, COUNT @D62425, PER @D62424, PLU @D62423, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62434, PAST @D62433, AGR [CASE @D62432, COUNT @D62431, 
            PER @D62430, PLU @D62429, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : GET, 
   [COORD @D62440, PAST @D62439, 
      AGR [CASE @D62438, COUNT @D62437, PER @D62436, PLU @D62435, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BY, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62446, PAST @D62445, AGR [CASE @D62444, COUNT @D62443, 
            PER @D62442, PLU @D62441, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BEHIND, FIN -, ARITY 1] : GET, 
   [COORD @D62452, PAST @D62451, 
      AGR [CASE @D62450, COUNT @D62449, PER @D62448, PLU @D62447, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62458, PAST @D62457, AGR [CASE @D62456, COUNT @D62455, 
            PER @D62454, PLU @D62453, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, FIN -, ARITY 1] : GET, 
   [COORD @D62464, PAST @D62463, 
      AGR [CASE @D62462, COUNT @D62461, PER @D62460, PLU @D62459, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ALONG, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62470, PAST @D62469, AGR [CASE @D62468, COUNT @D62467, 
            PER @D62466, PLU @D62465, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AHEAD, FIN -, ARITY 1] : GET, 
   [COORD @D62476, PAST @D62475, 
      AGR [CASE @D62474, COUNT @D62473, PER @D62472, PLU @D62471, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ACROSS, FIN -, 
      ARITY 1] : GET, 
   [COORD @D62482, PAST @D62481, AGR [CASE @D62480, COUNT @D62479, 
            PER @D62478, PLU @D62477, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, FIN -, ARITY 1] : GET, 
   [COORD @D62484, AGR @D62483, FIX NOT, V +, N -, VFORM NOT, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_PASS, REG -, PAST +, 
      ARITY 1] : GET, 
   [COORD @D62486, AGR @D62485, FIX NOT, V +, N -, VFORM NOT, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP, REG -, PAST +, 
      ARITY 1] : GET, 
   [COORD @D62488, AGR @D62487, FIX NOT, V +, N -, VFORM NOT, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, PAST +, 
      ARITY 1] : GET, 
   [COORD @D62490, AGR @D62489, FIX NOT, V +, N -, VFORM NOT, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF, REG -, PAST +, 
      ARITY 1] : GET, 
   [COORD @D62492, AGR @D62491, FIX NOT, V +, N -, VFORM NOT, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_AP, REG -, PAST +, 
      ARITY 1] : GET, 
   [COORD @D62496, AGR [COUNT @D62495, PER @D62494, PLU @D62493, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : GET, 
   [COORD @D62500, AGR [COUNT @D62499, PER @D62498, PLU @D62497, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, PAST +, ARITY 1] : GET, 
   [COORD @D62504, AGR [COUNT @D62503, PER @D62502, PLU @D62501, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, PAST +, ARITY 1] : GET, 
   [COORD @D62508, AGR [COUNT @D62507, PER @D62506, PLU @D62505, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ROUND, PAST +, ARITY 1] : GET, 
   [COORD @D62512, AGR [COUNT @D62511, PER @D62510, PLU @D62509, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER_WITH, PAST +, ARITY 1] : GET, 
   [COORD @D62516, AGR [COUNT @D62515, PER @D62514, PLU @D62513, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : GET, 
   [COORD @D62520, AGR [COUNT @D62519, PER @D62518, PLU @D62517, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : GET, 
   [COORD @D62524, AGR [COUNT @D62523, PER @D62522, PLU @D62521, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : GET, 
   [COORD @D62528, AGR [COUNT @D62527, PER @D62526, PLU @D62525, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : GET, 
   [COORD @D62532, AGR [COUNT @D62531, PER @D62530, PLU @D62529, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : GET, 
   [COORD @D62536, AGR [COUNT @D62535, PER @D62534, PLU @D62533, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : GET, 
   [COORD @D62540, AGR [COUNT @D62539, PER @D62538, PLU @D62537, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, PAST +, ARITY 1] : GET, 
   [COORD @D62544, AGR [COUNT @D62543, PER @D62542, PLU @D62541, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BEHIND, PAST +, ARITY 1] : GET, 
   [COORD @D62548, AGR [COUNT @D62547, PER @D62546, PLU @D62545, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : GET, 
   [COORD @D62552, AGR [COUNT @D62551, PER @D62550, PLU @D62549, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, PAST +, ARITY 1] : GET, 
   [COORD @D62556, AGR [COUNT @D62555, PER @D62554, PLU @D62553, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ALONG, PAST +, ARITY 1] : GET, 
   [COORD @D62560, AGR [COUNT @D62559, PER @D62558, PLU @D62557, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AHEAD, PAST +, ARITY 1] : GET, 
   [COORD @D62564, AGR [COUNT @D62563, PER @D62562, PLU @D62561, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ACROSS, PAST +, ARITY 1] : GET, 
   [COORD @D62568, AGR [COUNT @D62567, PER @D62566, PLU @D62565, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, PAST +, ARITY 1] : GET.

WORD grant : 
   [COORD @D62586, REFL @D62585, PRD @D62584, CASE @D62583, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : GRANT, 
   [COORD @D62589, 
      AGR [COUNT @D62588, PER @D62587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, ARITY 3] : 
   GRANT, 
   [COORD @D62591, AGR [COUNT @D62590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : GRANT, 
   [COORD @D62593, AGR [COUNT @D62592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : GRANT, 
   [COORD @D62597, AGR [COUNT @D62596, PER @D62595, PLU @D62594, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : GRANT, 
   [COORD @D62603, PAST @D62602, AGR [CASE @D62601, COUNT @D62600, 
            PER @D62599, PLU @D62598, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_SFIN, ARITY 3] : GRANT, 
   [COORD @D62606, AGR [COUNT @D62605, PER @D62604, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GRANT, 
   [COORD @D62608, AGR [COUNT @D62607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GRANT, 
   [COORD @D62610, AGR [COUNT @D62609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GRANT, 
   [COORD @D62614, AGR [COUNT @D62613, PER @D62612, PLU @D62611, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GRANT, 
   [COORD @D62620, PAST @D62619, AGR [CASE @D62618, COUNT @D62617, 
            PER @D62616, PLU @D62615, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : GRANT, 
   [COORD @D62623, AGR [COUNT @D62622, PER @D62621, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : GRANT, 
   [COORD @D62625, AGR [COUNT @D62624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : GRANT, 
   [COORD @D62627, AGR [COUNT @D62626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : GRANT, 
   [COORD @D62631, AGR [COUNT @D62630, PER @D62629, PLU @D62628, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : GRANT, 
   [COORD @D62637, PAST @D62636, 
      AGR [CASE @D62635, COUNT @D62634, PER @D62633, PLU @D62632, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : GRANT, 
   [COORD @D62640, AGR [COUNT @D62639, PER @D62638, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GRANT, 
   [COORD @D62642, AGR [COUNT @D62641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GRANT, 
   [COORD @D62644, AGR [COUNT @D62643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GRANT, 
   [COORD @D62648, AGR [COUNT @D62647, PER @D62646, PLU @D62645, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GRANT, 
   [COORD @D62654, PAST @D62653, AGR [CASE @D62652, COUNT @D62651, 
            PER @D62650, PLU @D62649, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : GRANT, 
   [COORD @D62657, AGR [COUNT @D62656, PER @D62655, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GRANT, 
   [COORD @D62659, AGR [COUNT @D62658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GRANT, 
   [COORD @D62661, AGR [COUNT @D62660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GRANT, 
   [COORD @D62665, AGR [COUNT @D62664, PER @D62663, PLU @D62662, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : GRANT, 
   [COORD @D62671, PAST @D62670, AGR [CASE @D62669, COUNT @D62668, 
            PER @D62667, PLU @D62666, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : GRANT.

WORD granted : 
   [COORD @D62680, AGR [CASE @D62679, COUNT @D62678, PER @D62677, 
            PLU @D62676, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GRANT, 
   [COORD @D62685, AGR [CASE @D62684, COUNT @D62683, PER @D62682, 
            PLU @D62681, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62690, AGR [CASE @D62689, COUNT @D62688, PER @D62687, 
            PLU @D62686, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62695, AGR [CASE @D62694, COUNT @D62693, PER @D62692, 
            PLU @D62691, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GRANT, 
   [COORD @D62700, AGR [CASE @D62699, COUNT @D62698, PER @D62697, 
            PLU @D62696, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62705, AGR [CASE @D62704, COUNT @D62703, PER @D62702, 
            PLU @D62701, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62710, AGR [CASE @D62709, COUNT @D62708, PER @D62707, 
            PLU @D62706, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62715, AGR [CASE @D62714, COUNT @D62713, PER @D62712, 
            PLU @D62711, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62720, AGR [CASE @D62719, COUNT @D62718, PER @D62717, 
            PLU @D62716, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62725, AGR [CASE @D62724, COUNT @D62723, PER @D62722, 
            PLU @D62721, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62730, AGR [CASE @D62729, COUNT @D62728, PER @D62727, 
            PLU @D62726, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62735, AGR [UB @D62734, VFORM @D62733, SUBJ @D62732, 
            FIN @D62731, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GRANT, 
   [COORD @D62740, AGR [CASE @D62739, COUNT @D62738, PER @D62737, 
            PLU @D62736, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GRANT, 
   [COORD @D62745, AGR [CASE @D62744, COUNT @D62743, PER @D62742, 
            PLU @D62741, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62750, AGR [CASE @D62749, COUNT @D62748, PER @D62747, 
            PLU @D62746, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GRANT.

WORD granting : 
   [COORD @D62764, PRD @D62763, AGR [CASE @D62762, COUNT @D62761, 
            PER @D62760, PLU @D62759, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62770, PRD @D62769, 
      AGR [CASE @D62768, COUNT @D62767, PER @D62766, PLU @D62765, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   GRANT, 
   [COORD @D62776, PRD @D62775, AGR [CASE @D62774, COUNT @D62773, 
            PER @D62772, PLU @D62771, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : GRANT, 
   [COORD @D62782, PRD @D62781, 
      AGR [CASE @D62780, COUNT @D62779, PER @D62778, PLU @D62777, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   GRANT, 
   [COORD @D62788, PRD @D62787, AGR [CASE @D62786, COUNT @D62785, 
            PER @D62784, PLU @D62783, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GRANT.

WORD grants : 
   [COORD @D62797, DEMON @D62796, REFL @D62795, PRD @D62794, CASE 
         @D62793, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : GRANT, 
   [COORD @D62799, 
      AGR [COUNT @D62798, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GRANT, 
   [COORD @D62801, 
      AGR [COUNT @D62800, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GRANT, 
   [COORD @D62803, 
      AGR [COUNT @D62802, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GRANT, 
   [COORD @D62805, 
      AGR [COUNT @D62804, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GRANT, 
   [COORD @D62807, 
      AGR [COUNT @D62806, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GRANT.

WORD guarantee : 
   [COORD @D62813, AGR [COUNT @D62812, PER @D62811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GUARANTEE, 
   [COORD @D62815, AGR [COUNT @D62814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GUARANTEE, 
   [COORD @D62817, AGR [COUNT @D62816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GUARANTEE, 
   [COORD @D62821, AGR [COUNT @D62820, PER @D62819, PLU @D62818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : GUARANTEE, 
   [COORD @D62827, PAST @D62826, AGR 
         [CASE @D62825, COUNT @D62824, PER @D62823, PLU @D62822, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   GUARANTEE, 
   [COORD @D62830, AGR [COUNT @D62829, PER @D62828, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GUARANTEE, 
   [COORD @D62832, AGR [COUNT @D62831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GUARANTEE, 
   [COORD @D62834, AGR [COUNT @D62833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GUARANTEE, 
   [COORD @D62838, AGR [COUNT @D62837, PER @D62836, PLU @D62835, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : GUARANTEE, 
   [COORD @D62844, PAST @D62843, AGR [CASE @D62842, COUNT @D62841, 
            PER @D62840, PLU @D62839, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : GUARANTEE, 
   [COORD @D62847, AGR [COUNT @D62846, PER @D62845, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GUARANTEE, 
   [COORD @D62849, AGR [COUNT @D62848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GUARANTEE, 
   [COORD @D62851, AGR [COUNT @D62850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GUARANTEE, 
   [COORD @D62855, AGR [COUNT @D62854, PER @D62853, PLU @D62852, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : GUARANTEE, 
   [COORD @D62861, PAST @D62860, AGR [CASE @D62859, COUNT @D62858, 
            PER @D62857, PLU @D62856, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : GUARANTEE.

WORD guaranteed : 
   [COORD @D62870, AGR [CASE @D62869, COUNT @D62868, PER @D62867, 
            PLU @D62866, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62875, AGR [CASE @D62874, COUNT @D62873, PER @D62872, 
            PLU @D62871, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62880, AGR [CASE @D62879, COUNT @D62878, PER @D62877, 
            PLU @D62876, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62885, AGR [CASE @D62884, COUNT @D62883, PER @D62882, 
            PLU @D62881, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62890, AGR [CASE @D62889, COUNT @D62888, PER @D62887, 
            PLU @D62886, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62895, AGR [UB @D62894, VFORM @D62893, SUBJ @D62892, 
            FIN @D62891, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : GUARANTEE, 
   [COORD @D62900, AGR [CASE @D62899, COUNT @D62898, PER @D62897, 
            PLU @D62896, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62905, AGR [CASE @D62904, COUNT @D62903, PER @D62902, 
            PLU @D62901, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62910, AGR [CASE @D62909, COUNT @D62908, PER @D62907, 
            PLU @D62906, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GUARANTEE.

WORD guarantees : 
   [COORD @D62916, AGR [COUNT @D62915, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62918, 
      AGR [COUNT @D62917, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GUARANTEE, 
   [COORD @D62920, 
      AGR [COUNT @D62919, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GUARANTEE.

WORD guide : 
   [COORD @D62932, REFL @D62931, COUNT @D62930, PRD @D62929, CASE 
         @D62928, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : GUIDE, 
   [COORD @D62936, REFL @D62935, PRD @D62934, CASE @D62933, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : GUIDE, 
   [COORD @D62939, 
      AGR [COUNT @D62938, PER @D62937, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   GUIDE, 
   [COORD @D62941, AGR [COUNT @D62940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : GUIDE, 
   [COORD @D62943, AGR [COUNT @D62942, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : GUIDE, 
   [COORD @D62947, AGR [COUNT @D62946, PER @D62945, PLU @D62944, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : GUIDE, 
   [COORD @D62953, PAST @D62952, AGR [CASE @D62951, COUNT @D62950, 
            PER @D62949, PLU @D62948, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : GUIDE, 
   [COORD @D62956, AGR [COUNT @D62955, PER @D62954, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GUIDE, 
   [COORD @D62958, AGR [COUNT @D62957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GUIDE, 
   [COORD @D62960, AGR [COUNT @D62959, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : GUIDE, 
   [COORD @D62964, AGR [COUNT @D62963, PER @D62962, PLU @D62961, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : GUIDE, 
   [COORD @D62970, PAST @D62969, AGR [CASE @D62968, COUNT @D62967, 
            PER @D62966, PLU @D62965, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : GUIDE.

WORD guided : 
   [COORD @D62981, AGR [CASE @D62980, COUNT @D62979, PER @D62978, 
            PLU @D62977, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GUIDE, 
   [COORD @D62986, AGR [CASE @D62985, COUNT @D62984, PER @D62983, 
            PLU @D62982, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GUIDE, 
   [COORD @D62991, AGR [CASE @D62990, COUNT @D62989, PER @D62988, 
            PLU @D62987, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GUIDE, 
   [COORD @D62996, AGR [CASE @D62995, COUNT @D62994, PER @D62993, 
            PLU @D62992, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : GUIDE, 
   [COORD @D63001, AGR [CASE @D63000, COUNT @D62999, PER @D62998, 
            PLU @D62997, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : GUIDE, 
   [COORD @D63006, AGR [CASE @D63005, COUNT @D63004, PER @D63003, 
            PLU @D63002, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : GUIDE.

WORD guides : 
   [COORD @D63017, DEMON @D63016, REFL @D63015, PRD @D63014, CASE 
         @D63013, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : GUIDE, 
   [COORD @D63022, DEMON @D63021, REFL @D63020, PRD @D63019, 
      CASE @D63018, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   GUIDE, 
   [COORD @D63024, AGR [COUNT @D63023, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GUIDE, 
   [COORD @D63026, 
      AGR [COUNT @D63025, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : GUIDE.

WORD guiding : 
   [COORD @D63036, PRD @D63035, AGR [CASE @D63034, COUNT @D63033, 
            PER @D63032, PLU @D63031, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : GUIDE, 
   [COORD @D63042, PRD @D63041, 
      AGR [CASE @D63040, COUNT @D63039, PER @D63038, PLU @D63037, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   GUIDE.

WORD handle : 
   [COORD @D63049, AGR [COUNT @D63048, PER @D63047, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HANDLE, 
   [COORD @D63051, AGR [COUNT @D63050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HANDLE, 
   [COORD @D63053, AGR [COUNT @D63052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HANDLE, 
   [COORD @D63057, AGR [COUNT @D63056, PER @D63055, PLU @D63054, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : HANDLE, 
   [COORD @D63063, PAST @D63062, AGR [CASE @D63061, COUNT @D63060, 
            PER @D63059, PLU @D63058, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : HANDLE, 
   [COORD @D63066, AGR [COUNT @D63065, PER @D63064, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : HANDLE, 
   [COORD @D63068, AGR [COUNT @D63067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : HANDLE, 
   [COORD @D63070, AGR [COUNT @D63069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : HANDLE, 
   [COORD @D63074, AGR [COUNT @D63073, PER @D63072, PLU @D63071, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : HANDLE, 
   [COORD @D63080, PAST @D63079, AGR [CASE @D63078, COUNT @D63077, 
            PER @D63076, PLU @D63075, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : HANDLE.

WORD handled : 
   [COORD @D63090, AGR [CASE @D63089, COUNT @D63088, PER @D63087, 
            PLU @D63086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HANDLE, 
   [COORD @D63095, AGR [CASE @D63094, COUNT @D63093, PER @D63092, 
            PLU @D63091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HANDLE, 
   [COORD @D63100, AGR [CASE @D63099, COUNT @D63098, PER @D63097, 
            PLU @D63096, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HANDLE, 
   [COORD @D63105, AGR [CASE @D63104, COUNT @D63103, PER @D63102, 
            PLU @D63101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HANDLE, 
   [COORD @D63110, AGR [CASE @D63109, COUNT @D63108, PER @D63107, 
            PLU @D63106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HANDLE.

WORD handles : 
   [COORD @D63117, AGR [COUNT @D63116, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANDLE, 
   [COORD @D63119, 
      AGR [COUNT @D63118, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANDLE.

WORD handling : 
   [COORD @D63129, PRD @D63128, AGR [CASE @D63127, COUNT @D63126, 
            PER @D63125, PLU @D63124, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HANDLE, 
   [COORD @D63135, PRD @D63134, 
      AGR [CASE @D63133, COUNT @D63132, PER @D63131, PLU @D63130, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HANDLE.

WORD hang : 
   [COORD @D63141, AGR [COUNT @D63140, PER @D63139, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : HANG, 
   [COORD @D63143, AGR [COUNT @D63142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : HANG, 
   [COORD @D63145, AGR [COUNT @D63144, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : HANG, 
   [COORD @D63149, AGR [COUNT @D63148, PER @D63147, PLU @D63146, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : HANG, 
   [COORD @D63155, PAST @D63154, 
      AGR [CASE @D63153, COUNT @D63152, PER @D63151, PLU @D63150, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   HANG, 
   [COORD @D63158, AGR [COUNT @D63157, PER @D63156, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM ON, ARITY 3] : HANG, 
   [COORD @D63160, AGR [COUNT @D63159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM ON, ARITY 3] : HANG, 
   [COORD @D63162, AGR [COUNT @D63161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM ON, ARITY 3] : HANG, 
   [COORD @D63166, AGR [COUNT @D63165, PER @D63164, PLU @D63163, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM ON, ARITY 3] : HANG, 
   [COORD @D63172, PAST @D63171, 
      AGR [CASE @D63170, COUNT @D63169, PER @D63168, PLU @D63167, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM ON, ARITY 3] : HANG, 
   [COORD @D63175, AGR [COUNT @D63174, PER @D63173, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HANG, 
   [COORD @D63177, AGR [COUNT @D63176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HANG, 
   [COORD @D63179, AGR [COUNT @D63178, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HANG, 
   [COORD @D63183, AGR [COUNT @D63182, PER @D63181, PLU @D63180, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : HANG, 
   [COORD @D63189, PAST @D63188, AGR [CASE @D63187, COUNT @D63186, 
            PER @D63185, PLU @D63184, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : HANG, 
   [COORD @D63192, AGR [COUNT @D63191, PER @D63190, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : HANG, 
   [COORD @D63194, AGR [COUNT @D63193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : HANG, 
   [COORD @D63196, AGR [COUNT @D63195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : HANG, 
   [COORD @D63200, AGR [COUNT @D63199, PER @D63198, PLU @D63197, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : HANG, 
   [COORD @D63206, PAST @D63205, 
      AGR [CASE @D63204, COUNT @D63203, PER @D63202, PLU @D63201, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : 
   HANG, 
   [COORD @D63209, AGR [COUNT @D63208, PER @D63207, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP UPON, ARITY 2] : HANG, 
   [COORD @D63211, AGR [COUNT @D63210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP UPON, ARITY 2] : HANG, 
   [COORD @D63213, AGR [COUNT @D63212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP UPON, ARITY 2] : HANG, 
   [COORD @D63217, AGR [COUNT @D63216, PER @D63215, PLU @D63214, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, PREP UPON, ARITY 2] : HANG, 
   [COORD @D63223, PAST @D63222, AGR [CASE @D63221, COUNT @D63220, 
            PER @D63219, PLU @D63218, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, PREP UPON, ARITY 2] : HANG, 
   [COORD @D63226, 
      AGR [COUNT @D63225, PER @D63224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, PREP ON, 
      ARITY 2] : HANG, 
   [COORD @D63228, AGR [COUNT @D63227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP ON, ARITY 2] : HANG, 
   [COORD @D63230, AGR [COUNT @D63229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP ON, ARITY 2] : HANG, 
   [COORD @D63234, AGR [COUNT @D63233, PER @D63232, PLU @D63231, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, PREP ON, ARITY 2] : HANG, 
   [COORD @D63240, PAST @D63239, AGR [CASE @D63238, COUNT @D63237, 
            PER @D63236, PLU @D63235, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, PREP ON, ARITY 2] : HANG, 
   [COORD @D63243, 
      AGR [COUNT @D63242, PER @D63241, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM UPON, 
      ARITY 2] : HANG, 
   [COORD @D63245, AGR [COUNT @D63244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : HANG, 
   [COORD @D63247, AGR [COUNT @D63246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : HANG, 
   [COORD @D63251, AGR [COUNT @D63250, PER @D63249, PLU @D63248, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : HANG, 
   [COORD @D63257, PAST @D63256, AGR 
         [CASE @D63255, COUNT @D63254, PER @D63253, PLU @D63252, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM UPON, 
      ARITY 2] : HANG, 
   [COORD @D63260, AGR [COUNT @D63259, PER @D63258, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM TO, ARITY 2] : HANG, 
   [COORD @D63262, AGR [COUNT @D63261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM TO, ARITY 2] : HANG, 
   [COORD @D63264, AGR [COUNT @D63263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM TO, ARITY 2] : HANG, 
   [COORD @D63268, AGR [COUNT @D63267, PER @D63266, PLU @D63265, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ON, PFORM TO, ARITY 2] : HANG, 
   [COORD @D63274, PAST @D63273, 
      AGR [CASE @D63272, COUNT @D63271, PER @D63270, PLU @D63269, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM TO, ARITY 2] : HANG, 
   [COORD @D63277, AGR [COUNT @D63276, PER @D63275, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : HANG, 
   [COORD @D63279, AGR [COUNT @D63278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : HANG, 
   [COORD @D63281, AGR [COUNT @D63280, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : HANG, 
   [COORD @D63285, AGR [COUNT @D63284, PER @D63283, PLU @D63282, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OVER, ARITY 2] : HANG, 
   [COORD @D63291, PAST @D63290, AGR 
         [CASE @D63289, COUNT @D63288, PER @D63287, PLU @D63286, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OVER, 
      ARITY 2] : HANG, 
   [COORD @D63294, AGR [COUNT @D63293, PER @D63292, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, ARITY 2] : HANG, 
   [COORD @D63296, AGR [COUNT @D63295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, ARITY 2] : HANG, 
   [COORD @D63298, AGR [COUNT @D63297, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, ARITY 2] : HANG, 
   [COORD @D63302, AGR [COUNT @D63301, PER @D63300, PLU @D63299, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ONTO, ARITY 2] : HANG, 
   [COORD @D63308, PAST @D63307, AGR 
         [CASE @D63306, COUNT @D63305, PER @D63304, PLU @D63303, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ONTO, 
      ARITY 2] : HANG, 
   [COORD @D63311, AGR [COUNT @D63310, PER @D63309, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : HANG, 
   [COORD @D63313, AGR [COUNT @D63312, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : HANG, 
   [COORD @D63315, AGR [COUNT @D63314, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : HANG, 
   [COORD @D63319, AGR [COUNT @D63318, PER @D63317, PLU @D63316, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : HANG, 
   [COORD @D63325, PAST @D63324, AGR [CASE @D63323, COUNT @D63322, 
            PER @D63321, PLU @D63320, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : HANG, 
   [COORD @D63328, 
      AGR [COUNT @D63327, PER @D63326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM IN, ARITY 2] : HANG, 
   [COORD @D63330, AGR [COUNT @D63329, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM IN, ARITY 2] : HANG, 
   [COORD @D63332, AGR [COUNT @D63331, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM IN, ARITY 2] : HANG, 
   [COORD @D63336, AGR [COUNT @D63335, PER @D63334, PLU @D63333, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM IN, ARITY 2] : HANG, 
   [COORD @D63342, PAST @D63341, 
      AGR [CASE @D63340, COUNT @D63339, PER @D63338, PLU @D63337, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM IN, ARITY 2] : HANG, 
   [COORD @D63345, AGR [COUNT @D63344, PER @D63343, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : HANG, 
   [COORD @D63347, AGR [COUNT @D63346, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : HANG, 
   [COORD @D63349, AGR [COUNT @D63348, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, ARITY 2] : HANG, 
   [COORD @D63353, AGR [COUNT @D63352, PER @D63351, PLU @D63350, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OVER, PFORM FROM, ARITY 2] : HANG, 
   [COORD @D63359, PAST @D63358, 
      AGR [CASE @D63357, COUNT @D63356, PER @D63355, PLU @D63354, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, 
      PFORM FROM, ARITY 2] : HANG, 
   [COORD @D63362, AGR [COUNT @D63361, PER @D63360, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, ARITY 2] : HANG, 
   [COORD @D63364, AGR [COUNT @D63363, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, ARITY 2] : HANG, 
   [COORD @D63366, AGR [COUNT @D63365, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, ARITY 2] : HANG, 
   [COORD @D63370, AGR [COUNT @D63369, PER @D63368, PLU @D63367, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM AT, ARITY 2] : HANG, 
   [COORD @D63376, PAST @D63375, 
      AGR [CASE @D63374, COUNT @D63373, PER @D63372, PLU @D63371, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM AT, ARITY 2] : HANG, 
   [COORD @D63379, AGR [COUNT @D63378, PER @D63377, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AROUND, ARITY 2] : HANG, 
   [COORD @D63381, AGR [COUNT @D63380, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AROUND, ARITY 2] : HANG, 
   [COORD @D63383, AGR [COUNT @D63382, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AROUND, ARITY 2] : HANG, 
   [COORD @D63387, AGR [COUNT @D63386, PER @D63385, PLU @D63384, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AROUND, ARITY 2] : HANG, 
   [COORD @D63393, PAST @D63392, 
      AGR [CASE @D63391, COUNT @D63390, PER @D63389, PLU @D63388, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AROUND, 
      ARITY 2] : HANG, 
   [COORD @D63396, AGR [COUNT @D63395, PER @D63394, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : HANG, 
   [COORD @D63398, AGR [COUNT @D63397, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : HANG, 
   [COORD @D63400, AGR [COUNT @D63399, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : HANG, 
   [COORD @D63404, AGR [COUNT @D63403, PER @D63402, PLU @D63401, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, ARITY 2] : HANG, 
   [COORD @D63410, PAST @D63409, 
      AGR [CASE @D63408, COUNT @D63407, PER @D63406, PLU @D63405, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, 
      ARITY 2] : HANG, 
   [COORD @D63413, AGR [COUNT @D63412, PER @D63411, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : HANG, 
   [COORD @D63415, AGR [COUNT @D63414, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : HANG, 
   [COORD @D63417, AGR [COUNT @D63416, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : HANG, 
   [COORD @D63421, AGR [COUNT @D63420, PER @D63419, PLU @D63418, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : HANG, 
   [COORD @D63427, PAST @D63426, 
      AGR [CASE @D63425, COUNT @D63424, PER @D63423, PLU @D63422, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : HANG, 
   [COORD @D63430, AGR [COUNT @D63429, PER @D63428, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HANG, 
   [COORD @D63432, AGR [COUNT @D63431, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HANG, 
   [COORD @D63434, AGR [COUNT @D63433, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HANG, 
   [COORD @D63438, AGR [COUNT @D63437, PER @D63436, PLU @D63435, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : HANG, 
   [COORD @D63444, PAST @D63443, 
      AGR [CASE @D63442, COUNT @D63441, PER @D63440, PLU @D63439, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   HANG, 
   [COORD @D63447, AGR [COUNT @D63446, PER @D63445, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : HANG, 
   [COORD @D63449, AGR [COUNT @D63448, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : HANG, 
   [COORD @D63451, AGR [COUNT @D63450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : HANG, 
   [COORD @D63455, AGR [COUNT @D63454, PER @D63453, PLU @D63452, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : HANG, 
   [COORD @D63461, PAST @D63460, 
      AGR [CASE @D63459, COUNT @D63458, PER @D63457, PLU @D63456, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : HANG, 
   [COORD @D63464, AGR [COUNT @D63463, PER @D63462, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : HANG, 
   [COORD @D63466, AGR [COUNT @D63465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : HANG, 
   [COORD @D63468, AGR [COUNT @D63467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : HANG, 
   [COORD @D63472, AGR [COUNT @D63471, PER @D63470, PLU @D63469, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, ARITY 1] : HANG, 
   [COORD @D63478, PAST @D63477, 
      AGR [CASE @D63476, COUNT @D63475, PER @D63474, PLU @D63473, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TOGETHER, 
      ARITY 1] : HANG, 
   [COORD @D63481, AGR [COUNT @D63480, PER @D63479, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : HANG, 
   [COORD @D63483, AGR [COUNT @D63482, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : HANG, 
   [COORD @D63485, AGR [COUNT @D63484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : HANG, 
   [COORD @D63489, AGR [COUNT @D63488, PER @D63487, PLU @D63486, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : HANG, 
   [COORD @D63495, PAST @D63494, 
      AGR [CASE @D63493, COUNT @D63492, PER @D63491, PLU @D63490, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : HANG, 
   [COORD @D63498, AGR [COUNT @D63497, PER @D63496, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : HANG, 
   [COORD @D63500, AGR [COUNT @D63499, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : HANG, 
   [COORD @D63502, AGR [COUNT @D63501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : HANG, 
   [COORD @D63506, AGR [COUNT @D63505, PER @D63504, PLU @D63503, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : HANG, 
   [COORD @D63512, PAST @D63511, 
      AGR [CASE @D63510, COUNT @D63509, PER @D63508, PLU @D63507, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : HANG, 
   [COORD @D63515, AGR [COUNT @D63514, PER @D63513, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : HANG, 
   [COORD @D63517, AGR [COUNT @D63516, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : HANG, 
   [COORD @D63519, AGR [COUNT @D63518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : HANG, 
   [COORD @D63523, AGR [COUNT @D63522, PER @D63521, PLU @D63520, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : HANG, 
   [COORD @D63529, PAST @D63528, 
      AGR [CASE @D63527, COUNT @D63526, PER @D63525, PLU @D63524, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : HANG, 
   [COORD @D63532, AGR [COUNT @D63531, PER @D63530, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : HANG, 
   [COORD @D63534, AGR [COUNT @D63533, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : HANG, 
   [COORD @D63536, AGR [COUNT @D63535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : HANG, 
   [COORD @D63540, AGR [COUNT @D63539, PER @D63538, PLU @D63537, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, ARITY 1] : HANG, 
   [COORD @D63546, PAST @D63545, 
      AGR [CASE @D63544, COUNT @D63543, PER @D63542, PLU @D63541, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AROUND, 
      ARITY 1] : HANG, 
   [COORD @D63549, AGR [COUNT @D63548, PER @D63547, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : HANG, 
   [COORD @D63551, AGR [COUNT @D63550, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : HANG, 
   [COORD @D63553, AGR [COUNT @D63552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : HANG, 
   [COORD @D63557, AGR [COUNT @D63556, PER @D63555, PLU @D63554, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : HANG, 
   [COORD @D63563, PAST @D63562, 
      AGR [CASE @D63561, COUNT @D63560, PER @D63559, PLU @D63558, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, 
      ARITY 1] : HANG.

WORD hanging : 
   [COORD @D63578, REFL @D63577, COUNT @D63576, PRD @D63575, 
      CASE @D63574, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HANGING, 
   [COORD @D63584, PRD @D63583, 
      AGR [CASE @D63582, COUNT @D63581, PER @D63580, PLU @D63579, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HANG, 
   [COORD @D63590, PRD @D63589, AGR [CASE @D63588, COUNT @D63587, 
            PER @D63586, PLU @D63585, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63596, PRD @D63595, 
      AGR [CASE @D63594, COUNT @D63593, PER @D63592, PLU @D63591, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HANG, 
   [COORD @D63602, PRD @D63601, AGR [CASE @D63600, COUNT @D63599, 
            PER @D63598, PLU @D63597, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63608, PRD @D63607, 
      AGR [CASE @D63606, COUNT @D63605, PER @D63604, PLU @D63603, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, PREP UPON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HANG, 
   [COORD @D63614, PRD @D63613, AGR [CASE @D63612, COUNT @D63611, 
            PER @D63610, PLU @D63609, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63620, PRD @D63619, 
      AGR [CASE @D63618, COUNT @D63617, PER @D63616, PLU @D63615, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63626, PRD @D63625, AGR [CASE @D63624, COUNT @D63623, 
            PER @D63622, PLU @D63621, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63632, PRD @D63631, 
      AGR [CASE @D63630, COUNT @D63629, PER @D63628, PLU @D63627, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63638, PRD @D63637, AGR [CASE @D63636, COUNT @D63635, 
            PER @D63634, PLU @D63633, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63644, PRD @D63643, 
      AGR [CASE @D63642, COUNT @D63641, PER @D63640, PLU @D63639, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HANG, 
   [COORD @D63650, PRD @D63649, AGR [CASE @D63648, COUNT @D63647, 
            PER @D63646, PLU @D63645, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63656, PRD @D63655, 
      AGR [CASE @D63654, COUNT @D63653, PER @D63652, PLU @D63651, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HANG, 
   [COORD @D63662, PRD @D63661, AGR [CASE @D63660, COUNT @D63659, 
            PER @D63658, PLU @D63657, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63668, PRD @D63667, 
      AGR [CASE @D63666, COUNT @D63665, PER @D63664, PLU @D63663, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63674, PRD @D63673, AGR [CASE @D63672, COUNT @D63671, 
            PER @D63670, PLU @D63669, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63680, PRD @D63679, 
      AGR [CASE @D63678, COUNT @D63677, PER @D63676, PLU @D63675, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HANG, 
   [COORD @D63686, PRD @D63685, AGR [CASE @D63684, COUNT @D63683, 
            PER @D63682, PLU @D63681, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63692, PRD @D63691, 
      AGR [CASE @D63690, COUNT @D63689, PER @D63688, PLU @D63687, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HANG, 
   [COORD @D63698, PRD @D63697, AGR [CASE @D63696, COUNT @D63695, 
            PER @D63694, PLU @D63693, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63704, PRD @D63703, 
      AGR [CASE @D63702, COUNT @D63701, PER @D63700, PLU @D63699, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HANG, 
   [COORD @D63710, PRD @D63709, AGR [CASE @D63708, COUNT @D63707, 
            PER @D63706, PLU @D63705, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63716, PRD @D63715, 
      AGR [CASE @D63714, COUNT @D63713, PER @D63712, PLU @D63711, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HANG, 
   [COORD @D63722, PRD @D63721, AGR [CASE @D63720, COUNT @D63719, 
            PER @D63718, PLU @D63717, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HANG, 
   [COORD @D63728, PRD @D63727, 
      AGR [CASE @D63726, COUNT @D63725, PER @D63724, PLU @D63723, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HANG.

WORD hangings : 
   [COORD @D63740, REFL @D63739, PRD @D63738, CASE @D63737, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : HANGINGS, 
   [COORD @D63745, DEMON @D63744, REFL @D63743, PRD @D63742, 
      CASE @D63741, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HANGING.

WORD hangs : 
   [COORD @D63762, AGR [COUNT @D63761, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63764, 
      AGR [COUNT @D63763, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HANG, 
   [COORD @D63766, AGR [COUNT @D63765, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63768, 
      AGR [COUNT @D63767, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63770, 
      AGR [COUNT @D63769, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63772, 
      AGR [COUNT @D63771, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63774, 
      AGR [COUNT @D63773, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63776, 
      AGR [COUNT @D63775, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ON, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HANG, 
   [COORD @D63778, AGR [COUNT @D63777, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63780, AGR [COUNT @D63779, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63782, AGR [COUNT @D63781, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63784, AGR [COUNT @D63783, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HANG, 
   [COORD @D63786, AGR [COUNT @D63785, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63788, AGR [COUNT @D63787, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HANG, 
   [COORD @D63790, AGR [COUNT @D63789, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63792, AGR [COUNT @D63791, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HANG, 
   [COORD @D63794, AGR [COUNT @D63793, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63796, 
      AGR [COUNT @D63795, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63798, 
      AGR [COUNT @D63797, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63800, 
      AGR [COUNT @D63799, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HANG, 
   [COORD @D63802, AGR [COUNT @D63801, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63804, 
      AGR [COUNT @D63803, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63806, 
      AGR [COUNT @D63805, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63808, 
      AGR [COUNT @D63807, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG, 
   [COORD @D63810, 
      AGR [COUNT @D63809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HANG.

WORD happen : 
   [COORD @D63816, AGR [COUNT @D63815, PER @D63814, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : HAPPEN, 
   [COORD @D63818, AGR [COUNT @D63817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : HAPPEN, 
   [COORD @D63820, AGR [COUNT @D63819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : HAPPEN, 
   [COORD @D63824, AGR [COUNT @D63823, PER @D63822, PLU @D63821, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : HAPPEN, 
   [COORD @D63830, PAST @D63829, 
      AGR [CASE @D63828, COUNT @D63827, PER @D63826, PLU @D63825, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      ARITY 2] : HAPPEN, 
   [COORD @D63833, AGR [COUNT @D63832, PER @D63831, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : HAPPEN, 
   [COORD @D63835, AGR [COUNT @D63834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : HAPPEN, 
   [COORD @D63837, AGR [COUNT @D63836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : HAPPEN, 
   [COORD @D63841, AGR [COUNT @D63840, PER @D63839, PLU @D63838, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : HAPPEN, 
   [COORD @D63847, PAST @D63846, 
      AGR [CASE @D63845, COUNT @D63844, PER @D63843, PLU @D63842, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : HAPPEN, 
   [COORD @D63849, AGR [COUNT @D63848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : HAPPEN, 
   [COORD @D63851, AGR [COUNT @D63850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : HAPPEN, 
   [COORD @D63855, AGR [NFORM @D63854, COUNT @D63853, PER @D63852, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : HAPPEN, 
   [COORD @D63859, AGR [COUNT @D63858, PER @D63857, PLU @D63856, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : HAPPEN, 
   [COORD @D63862, AGR @D63861, PAST @D63860, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, ARITY 1] : HAPPEN, 
   [COORD @D63865, AGR [COUNT @D63864, PER @D63863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HAPPEN, 
   [COORD @D63867, AGR [COUNT @D63866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HAPPEN, 
   [COORD @D63869, AGR [COUNT @D63868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HAPPEN, 
   [COORD @D63873, AGR [COUNT @D63872, PER @D63871, PLU @D63870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HAPPEN, 
   [COORD @D63879, PAST @D63878, AGR [CASE @D63877, COUNT @D63876, 
            PER @D63875, PLU @D63874, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : HAPPEN, 
   [COORD @D63884, PAST @D63883, 
      AGR [COUNT @D63882, PER @D63881, PLU @D63880, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 1] : HAPPEN.

WORD happened : 
   [COORD @D63893, AGR [CASE @D63892, COUNT @D63891, PER @D63890, 
            PLU @D63889, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63898, AGR [CASE @D63897, COUNT @D63896, PER @D63895, 
            PLU @D63894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63903, AGR [CASE @D63902, COUNT @D63901, PER @D63900, 
            PLU @D63899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63908, AGR [CASE @D63907, COUNT @D63906, PER @D63905, 
            PLU @D63904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63913, AGR [CASE @D63912, COUNT @D63911, PER @D63910, 
            PLU @D63909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63918, AGR [CASE @D63917, COUNT @D63916, PER @D63915, 
            PLU @D63914, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63920, AGR @D63919, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HAPPEN, 
   [COORD @D63922, AGR @D63921, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : HAPPEN, 
   [COORD @D63927, AGR [CASE @D63926, COUNT @D63925, PER @D63924, 
            PLU @D63923, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63932, AGR [CASE @D63931, COUNT @D63930, PER @D63929, 
            PLU @D63928, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63936, AGR [COUNT @D63935, PER @D63934, PLU @D63933, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63940, AGR [COUNT @D63939, PER @D63938, PLU @D63937, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : HAPPEN.

WORD happening : 
   [COORD @D63950, REFL @D63949, PRD @D63948, CASE @D63947, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HAPPENING, 
   [COORD @D63956, PRD @D63955, 
      AGR [CASE @D63954, COUNT @D63953, PER @D63952, PLU @D63951, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HAPPEN, 
   [COORD @D63962, PRD @D63961, AGR [CASE @D63960, COUNT @D63959, 
            PER @D63958, PLU @D63957, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63965, AGR @D63964, PRD @D63963, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HAPPEN, 
   [COORD @D63971, PRD @D63970, AGR [CASE @D63969, COUNT @D63968, 
            PER @D63967, PLU @D63966, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D63976, PRD @D63975, 
      AGR [COUNT @D63974, PER @D63973, PLU @D63972, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HAPPEN.

WORD happenings : 
   [COORD @D63989, DEMON @D63988, REFL @D63987, PRD @D63986, 
      CASE @D63985, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   HAPPENING.

WORD happens : 
   [COORD @D63995, AGR [COUNT @D63994, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HAPPEN, 
   [COORD @D63997, AGR [COUNT @D63996, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HAPPEN, 
   [COORD @D64001, AGR [CASE @D64000, NFORM @D63999, COUNT @D63998, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HAPPEN, 
   [COORD @D64006, AGR [UB @D64005, VFORM @D64004, SUBJ @D64003, 
            FIN @D64002, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HAPPEN, 
   [COORD @D64008, AGR [COUNT @D64007, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HAPPEN, 
   [COORD @D64011, 
      AGR [CASE @D64010, COUNT @D64009, N +, V -, BAR 2, NFORM IT, PLU -, 
            PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HAPPEN.

WORD harvest : 
   [COORD @D64018, REFL @D64017, PRD @D64016, CASE @D64015, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HARVEST, 
   [COORD @D64023, REFL @D64022, COUNT @D64021, PRD @D64020, 
      CASE @D64019, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HARVEST, 
   [COORD @D64026, 
      AGR [COUNT @D64025, PER @D64024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   HARVEST, 
   [COORD @D64028, AGR [COUNT @D64027, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HARVEST, 
   [COORD @D64030, AGR [COUNT @D64029, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HARVEST, 
   [COORD @D64034, AGR [COUNT @D64033, PER @D64032, PLU @D64031, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : HARVEST, 
   [COORD @D64040, PAST @D64039, AGR [CASE @D64038, COUNT @D64037, 
            PER @D64036, PLU @D64035, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : HARVEST.

WORD harvested : 
   [COORD @D64050, AGR [CASE @D64049, COUNT @D64048, PER @D64047, 
            PLU @D64046, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HARVEST, 
   [COORD @D64055, AGR [CASE @D64054, COUNT @D64053, PER @D64052, 
            PLU @D64051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HARVEST, 
   [COORD @D64060, AGR [CASE @D64059, COUNT @D64058, PER @D64057, 
            PLU @D64056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HARVEST.

WORD harvesting : 
   [COORD @D64075, PRD @D64074, AGR [CASE @D64073, COUNT @D64072, 
            PER @D64071, PLU @D64070, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HARVEST.

WORD harvests : 
   [COORD @D64085, DEMON @D64084, REFL @D64083, PRD @D64082, 
      CASE @D64081, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HARVEST, 
   
   [COORD @D64087, AGR [COUNT @D64086, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HARVEST.

WORD head : 
   [COADV @D64099, COORD @D64098, DEF @D64097, PRD @D64096, AGR 
            [CASE @D64095, COUNT @D64094, PER @D64093, PLU @D64092, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : HEAD, 
   [COORD @D64103, REFL @D64102, PRD @D64101, CASE @D64100, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HEAD, 
   [COORD @D64107, REFL @D64106, PRD @D64105, CASE @D64104, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HEAD, 
   [COORD @D64111, REFL @D64110, PRD @D64109, CASE @D64108, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : HEAD, 
   [COORD @D64114, 
      AGR [COUNT @D64113, PER @D64112, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   HEAD, 
   [COORD @D64116, AGR [COUNT @D64115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : HEAD, 
   [COORD @D64118, AGR [COUNT @D64117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : HEAD, 
   [COORD @D64122, AGR [COUNT @D64121, PER @D64120, PLU @D64119, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : HEAD, 
   [COORD @D64128, PAST @D64127, AGR [CASE @D64126, COUNT @D64125, 
            PER @D64124, PLU @D64123, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : HEAD, 
   [COORD @D64131, AGR [COUNT @D64130, PER @D64129, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HEAD, 
   [COORD @D64133, AGR [COUNT @D64132, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HEAD, 
   [COORD @D64135, AGR [COUNT @D64134, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HEAD, 
   [COORD @D64139, AGR [COUNT @D64138, PER @D64137, PLU @D64136, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : HEAD, 
   [COORD @D64145, PAST @D64144, AGR [CASE @D64143, COUNT @D64142, 
            PER @D64141, PLU @D64140, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : HEAD, 
   [COORD @D64148, AGR [COUNT @D64147, PER @D64146, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : HEAD, 
   [COORD @D64150, AGR [COUNT @D64149, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : HEAD, 
   [COORD @D64152, AGR [COUNT @D64151, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : HEAD, 
   [COORD @D64156, AGR [COUNT @D64155, PER @D64154, PLU @D64153, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : HEAD, 
   [COORD @D64162, PAST @D64161, AGR [CASE @D64160, COUNT @D64159, 
            PER @D64158, PLU @D64157, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : HEAD, 
   [COORD @D64165, AGR [COUNT @D64164, PER @D64163, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : HEAD, 
   [COORD @D64167, AGR [COUNT @D64166, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : HEAD, 
   [COORD @D64169, AGR [COUNT @D64168, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : HEAD, 
   [COORD @D64173, AGR [COUNT @D64172, PER @D64171, PLU @D64170, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : HEAD, 
   [COORD @D64179, PAST @D64178, 
      AGR [CASE @D64177, COUNT @D64176, PER @D64175, PLU @D64174, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : HEAD, 
   [COORD @D64182, AGR [COUNT @D64181, PER @D64180, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : HEAD, 
   [COORD @D64184, AGR [COUNT @D64183, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : HEAD, 
   [COORD @D64186, AGR [COUNT @D64185, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : HEAD, 
   [COORD @D64190, AGR [COUNT @D64189, PER @D64188, PLU @D64187, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : HEAD, 
   [COORD @D64196, PAST @D64195, 
      AGR [CASE @D64194, COUNT @D64193, PER @D64192, PLU @D64191, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : HEAD, 
   [COORD @D64199, AGR [COUNT @D64198, PER @D64197, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : HEAD, 
   [COORD @D64201, AGR [COUNT @D64200, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : HEAD, 
   [COORD @D64203, AGR [COUNT @D64202, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : HEAD, 
   [COORD @D64207, AGR [COUNT @D64206, PER @D64205, PLU @D64204, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : HEAD, 
   [COORD @D64213, PAST @D64212, 
      AGR [CASE @D64211, COUNT @D64210, PER @D64209, PLU @D64208, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : HEAD.

WORD headed : 
   [COORD @D64225, AGR [CASE @D64224, COUNT @D64223, PER @D64222, 
            PLU @D64221, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HEAD, 
   [COORD @D64230, AGR [CASE @D64229, COUNT @D64228, PER @D64227, 
            PLU @D64226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64235, AGR [CASE @D64234, COUNT @D64233, PER @D64232, 
            PLU @D64231, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64240, AGR [CASE @D64239, COUNT @D64238, PER @D64237, 
            PLU @D64236, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HEAD, 
   [COORD @D64245, AGR [CASE @D64244, COUNT @D64243, PER @D64242, 
            PLU @D64241, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64250, AGR [CASE @D64249, COUNT @D64248, PER @D64247, 
            PLU @D64246, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64255, AGR [CASE @D64254, COUNT @D64253, PER @D64252, 
            PLU @D64251, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64260, AGR [CASE @D64259, COUNT @D64258, PER @D64257, 
            PLU @D64256, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64265, AGR [CASE @D64264, COUNT @D64263, PER @D64262, 
            PLU @D64261, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64270, AGR [CASE @D64269, COUNT @D64268, PER @D64267, 
            PLU @D64266, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64275, AGR [CASE @D64274, COUNT @D64273, PER @D64272, 
            PLU @D64271, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64280, AGR [CASE @D64279, COUNT @D64278, PER @D64277, 
            PLU @D64276, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64285, AGR [CASE @D64284, COUNT @D64283, PER @D64282, 
            PLU @D64281, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64290, AGR [CASE @D64289, COUNT @D64288, PER @D64287, 
            PLU @D64286, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64295, AGR [CASE @D64294, COUNT @D64293, PER @D64292, 
            PLU @D64291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64300, AGR [CASE @D64299, COUNT @D64298, PER @D64297, 
            PLU @D64296, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HEAD.

WORD heading : 
   [COORD @D64317, REFL @D64316, PRD @D64315, CASE @D64314, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HEADING, 
   [COORD @D64323, PRD @D64322, 
      AGR [CASE @D64321, COUNT @D64320, PER @D64319, PLU @D64318, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HEAD, 
   [COORD @D64329, PRD @D64328, AGR [CASE @D64327, COUNT @D64326, 
            PER @D64325, PLU @D64324, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64335, PRD @D64334, 
      AGR [CASE @D64333, COUNT @D64332, PER @D64331, PLU @D64330, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HEAD, 
   [COORD @D64341, PRD @D64340, AGR [CASE @D64339, COUNT @D64338, 
            PER @D64337, PLU @D64336, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAD, 
   [COORD @D64347, PRD @D64346, 
      AGR [CASE @D64345, COUNT @D64344, PER @D64343, PLU @D64342, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HEAD, 
   [COORD @D64353, PRD @D64352, AGR [CASE @D64351, COUNT @D64350, 
            PER @D64349, PLU @D64348, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAD.

WORD headings : 
   [COORD @D64375, DEMON @D64374, REFL @D64373, PRD @D64372, 
      CASE @D64371, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HEADING.

WORD heads : 
   [COORD @D64387, DEMON @D64386, REFL @D64385, PRD @D64384, CASE 
         @D64383, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HEAD, 
   [COORD @D64389, 
      AGR [COUNT @D64388, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAD, 
   [COORD @D64391, 
      AGR [COUNT @D64390, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAD, 
   [COORD @D64393, 
      AGR [COUNT @D64392, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAD, 
   [COORD @D64395, 
      AGR [COUNT @D64394, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAD, 
   [COORD @D64397, 
      AGR [COUNT @D64396, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAD, 
   [COORD @D64399, 
      AGR [COUNT @D64398, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAD.

WORD hear : 
   [COORD @D64406, AGR [COUNT @D64405, PER @D64404, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : HEAR, 
   [COORD @D64408, AGR [COUNT @D64407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : HEAR, 
   [COORD @D64410, AGR [COUNT @D64409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : HEAR, 
   [COORD @D64414, AGR [COUNT @D64413, PER @D64412, PLU @D64411, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, ARITY 3] : HEAR, 
   [COORD @D64420, PAST @D64419, 
      AGR [CASE @D64418, COUNT @D64417, PER @D64416, PLU @D64415, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, ARITY 3] : 
   HEAR, 
   [COORD @D64423, AGR [COUNT @D64422, PER @D64421, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : HEAR, 
   [COORD @D64425, AGR [COUNT @D64424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : HEAR, 
   [COORD @D64427, AGR [COUNT @D64426, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : HEAR, 
   [COORD @D64431, AGR [COUNT @D64430, PER @D64429, PLU @D64428, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, REG -, ARITY 3] : HEAR, 
   [COORD @D64437, PAST @D64436, 
      AGR [CASE @D64435, COUNT @D64434, PER @D64433, PLU @D64432, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, REG -, ARITY 3] : 
   HEAR, 
   [COORD @D64440, AGR [COUNT @D64439, PER @D64438, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, ARITY 3] : HEAR, 
   [COORD @D64442, AGR [COUNT @D64441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, ARITY 3] : HEAR, 
   [COORD @D64444, AGR [COUNT @D64443, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, ARITY 3] : HEAR, 
   [COORD @D64448, AGR [COUNT @D64447, PER @D64446, PLU @D64445, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OF, ARITY 3] : HEAR, 
   [COORD @D64454, PAST @D64453, 
      AGR [CASE @D64452, COUNT @D64451, PER @D64450, PLU @D64449, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OF, 
      ARITY 3] : HEAR, 
   [COORD @D64457, AGR [COUNT @D64456, PER @D64455, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ABOUT, ARITY 3] : HEAR, 
   [COORD @D64459, AGR [COUNT @D64458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ABOUT, ARITY 3] : HEAR, 
   [COORD @D64461, AGR [COUNT @D64460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ABOUT, ARITY 3] : HEAR, 
   [COORD @D64465, AGR [COUNT @D64464, PER @D64463, PLU @D64462, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ABOUT, ARITY 3] : HEAR, 
   [COORD @D64471, PAST @D64470, 
      AGR [CASE @D64469, COUNT @D64468, PER @D64467, PLU @D64466, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ABOUT, 
      ARITY 3] : HEAR, 
   [COORD @D64474, AGR [COUNT @D64473, PER @D64472, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : HEAR, 
   [COORD @D64476, AGR [COUNT @D64475, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : HEAR, 
   [COORD @D64478, AGR [COUNT @D64477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : HEAR, 
   [COORD @D64482, AGR [COUNT @D64481, PER @D64480, PLU @D64479, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, ARITY 2] : HEAR, 
   [COORD @D64488, PAST @D64487, AGR [CASE @D64486, COUNT @D64485, 
            PER @D64484, PLU @D64483, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, ARITY 2] : HEAR, 
   [COORD @D64491, AGR [COUNT @D64490, PER @D64489, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : HEAR, 
   [COORD @D64493, AGR [COUNT @D64492, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : HEAR, 
   [COORD @D64495, AGR [COUNT @D64494, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : HEAR, 
   [COORD @D64499, AGR [COUNT @D64498, PER @D64497, PLU @D64496, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : HEAR, 
   [COORD @D64505, PAST @D64504, 
      AGR [CASE @D64503, COUNT @D64502, PER @D64501, PLU @D64500, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   HEAR, 
   [COORD @D64508, AGR [COUNT @D64507, PER @D64506, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HEAR, 
   [COORD @D64510, AGR [COUNT @D64509, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HEAR, 
   [COORD @D64512, AGR [COUNT @D64511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HEAR, 
   [COORD @D64516, AGR [COUNT @D64515, PER @D64514, PLU @D64513, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : HEAR, 
   [COORD @D64522, PAST @D64521, AGR [CASE @D64520, COUNT @D64519, 
            PER @D64518, PLU @D64517, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : HEAR, 
   [COORD @D64525, AGR [COUNT @D64524, PER @D64523, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64527, AGR [COUNT @D64526, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64529, AGR [COUNT @D64528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64533, AGR [COUNT @D64532, PER @D64531, PLU @D64530, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64539, PAST @D64538, AGR [CASE @D64537, COUNT @D64536, 
            PER @D64535, PLU @D64534, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64542, 
      AGR [COUNT @D64541, PER @D64540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, 
      PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64544, AGR [COUNT @D64543, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64546, 
      AGR [COUNT @D64545, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, 
      PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64550, AGR [COUNT @D64549, PER @D64548, PLU @D64547, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64556, PAST @D64555, 
      AGR [CASE @D64554, COUNT @D64553, PER @D64552, PLU @D64551, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, 
      PFORM OF, ARITY 2] : HEAR, 
   [COORD @D64559, AGR [COUNT @D64558, PER @D64557, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : HEAR, 
   [COORD @D64561, AGR [COUNT @D64560, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : HEAR, 
   [COORD @D64563, AGR [COUNT @D64562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : HEAR, 
   [COORD @D64567, AGR [COUNT @D64566, PER @D64565, PLU @D64564, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FROM, ARITY 2] : HEAR, 
   [COORD @D64573, PAST @D64572, AGR 
         [CASE @D64571, COUNT @D64570, PER @D64569, PLU @D64568, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FROM, 
      ARITY 2] : HEAR, 
   [COORD @D64576, AGR [COUNT @D64575, PER @D64574, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64578, AGR [COUNT @D64577, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64580, AGR [COUNT @D64579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64584, AGR [COUNT @D64583, PER @D64582, PLU @D64581, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64590, PAST @D64589, 
      AGR [CASE @D64588, COUNT @D64587, PER @D64586, PLU @D64585, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, 
      ARITY 2] : HEAR, 
   [COORD @D64593, AGR [COUNT @D64592, PER @D64591, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64595, 
      AGR [COUNT @D64594, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, 
      PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64597, AGR [COUNT @D64596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64601, 
      AGR [COUNT @D64600, PER @D64599, PLU @D64598, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64607, PAST @D64606, 
      AGR [CASE @D64605, COUNT @D64604, PER @D64603, PLU @D64602, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, 
      PFORM ABOUT, ARITY 2] : HEAR, 
   [COORD @D64610, AGR [COUNT @D64609, PER @D64608, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : HEAR, 
   [COORD @D64612, AGR [COUNT @D64611, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : HEAR, 
   [COORD @D64614, AGR [COUNT @D64613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : HEAR, 
   [COORD @D64618, AGR [COUNT @D64617, PER @D64616, PLU @D64615, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : HEAR, 
   [COORD @D64624, PAST @D64623, 
      AGR [CASE @D64622, COUNT @D64621, PER @D64620, PLU @D64619, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : HEAR, 
   [COORD @D64627, AGR [COUNT @D64626, PER @D64625, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HEAR, 
   [COORD @D64629, AGR [COUNT @D64628, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HEAR, 
   [COORD @D64631, AGR [COUNT @D64630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HEAR, 
   [COORD @D64635, AGR [COUNT @D64634, PER @D64633, PLU @D64632, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : HEAR, 
   [COORD @D64641, PAST @D64640, 
      AGR [CASE @D64639, COUNT @D64638, PER @D64637, PLU @D64636, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   HEAR, 
   [COORD @D64644, AGR [COUNT @D64643, PER @D64642, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : HEAR, 
   [COORD @D64646, AGR [COUNT @D64645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : HEAR, 
   [COORD @D64648, AGR [COUNT @D64647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : HEAR, 
   [COORD @D64652, AGR [COUNT @D64651, PER @D64650, PLU @D64649, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : HEAR, 
   [COORD @D64658, PAST @D64657, 
      AGR [CASE @D64656, COUNT @D64655, PER @D64654, PLU @D64653, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : HEAR.

WORD heard : 
   [COORD @D64669, PAST @D64668, AGR [CASE @D64667, COUNT @D64666, 
            PER @D64665, PLU @D64664, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, FIN -, ARITY 3] : HEAR, 
   [COORD @D64675, PAST @D64674, 
      AGR [CASE @D64673, COUNT @D64672, PER @D64671, PLU @D64670, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, FIN -, ARITY 3] : 
   HEAR, 
   [COORD @D64681, PAST @D64680, AGR [CASE @D64679, COUNT @D64678, 
            PER @D64677, PLU @D64676, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, REG -, FIN -, ARITY 3] : HEAR, 
   [COORD @D64687, PAST @D64686, 
      AGR [CASE @D64685, COUNT @D64684, PER @D64683, PLU @D64682, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, REG -, FIN -, ARITY 3] : 
   HEAR, 
   [COORD @D64693, PAST @D64692, AGR [CASE @D64691, COUNT @D64690, 
            PER @D64689, PLU @D64688, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OF, FIN -, ARITY 3] : HEAR, 
   [COORD @D64699, PAST @D64698, 
      AGR [CASE @D64697, COUNT @D64696, PER @D64695, PLU @D64694, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OF, FIN -, 
      ARITY 3] : HEAR, 
   [COORD @D64705, PAST @D64704, AGR [CASE @D64703, COUNT @D64702, 
            PER @D64701, PLU @D64700, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ABOUT, FIN -, ARITY 3] : HEAR, 
   [COORD @D64711, PAST @D64710, 
      AGR [CASE @D64709, COUNT @D64708, PER @D64707, PLU @D64706, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ABOUT, FIN -, 
      ARITY 3] : HEAR, 
   [COORD @D64715, AGR [COUNT @D64714, PER @D64713, PLU @D64712, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, PAST +, ARITY 3] : HEAR, 
   [COORD @D64719, AGR [COUNT @D64718, PER @D64717, PLU @D64716, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, PAST +, ARITY 3] : HEAR, 
   [COORD @D64723, AGR [COUNT @D64722, PER @D64721, PLU @D64720, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, PAST +, ARITY 3] : HEAR, 
   [COORD @D64727, AGR [COUNT @D64726, PER @D64725, PLU @D64724, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ABOUT, PAST +, ARITY 3] : HEAR, 
   [COORD @D64733, PAST @D64732, 
      AGR [CASE @D64731, COUNT @D64730, PER @D64729, PLU @D64728, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, FIN -, ARITY 2] : HEAR, 
   [COORD @D64739, PAST @D64738, 
      AGR [CASE @D64737, COUNT @D64736, PER @D64735, PLU @D64734, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, ARITY 2] : HEAR, 
   [COORD @D64745, PAST @D64744, 
      AGR [CASE @D64743, COUNT @D64742, PER @D64741, PLU @D64740, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : HEAR, 
   [COORD @D64751, PAST @D64750, AGR [CASE @D64749, COUNT @D64748, 
            PER @D64747, PLU @D64746, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : HEAR, 
   [COORD @D64757, PAST @D64756, 
      AGR [CASE @D64755, COUNT @D64754, PER @D64753, PLU @D64752, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM OF, FIN -, 
      ARITY 2] : HEAR, 
   [COORD @D64763, PAST @D64762, AGR [CASE @D64761, COUNT @D64760, 
            PER @D64759, PLU @D64758, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM OF, FIN -, ARITY 2] : HEAR, 
   [COORD @D64769, PAST @D64768, 
      AGR [CASE @D64767, COUNT @D64766, PER @D64765, PLU @D64764, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, PFORM OF, 
      FIN -, ARITY 2] : HEAR, 
   [COORD @D64775, PAST @D64774, AGR [CASE @D64773, COUNT @D64772, 
            PER @D64771, PLU @D64770, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, PFORM OF, FIN -, ARITY 2] : 
   HEAR, 
   [COORD @D64781, PAST @D64780, AGR [CASE @D64779, COUNT @D64778, 
            PER @D64777, PLU @D64776, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM FROM, FIN -, ARITY 2] : HEAR, 
   [COORD @D64787, PAST @D64786, 
      AGR [CASE @D64785, COUNT @D64784, PER @D64783, PLU @D64782, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FROM, FIN -, 
      ARITY 2] : HEAR, 
   [COORD @D64793, PAST @D64792, AGR [CASE @D64791, COUNT @D64790, 
            PER @D64789, PLU @D64788, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ABOUT, FIN -, ARITY 2] : HEAR, 
   [COORD @D64799, PAST @D64798, 
      AGR [CASE @D64797, COUNT @D64796, PER @D64795, PLU @D64794, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, FIN -, 
      ARITY 2] : HEAR, 
   [COORD @D64805, PAST @D64804, AGR [CASE @D64803, COUNT @D64802, 
            PER @D64801, PLU @D64800, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM ABOUT, FIN -, ARITY 2] : HEAR, 
   [COORD @D64811, PAST @D64810, 
      AGR [CASE @D64809, COUNT @D64808, PER @D64807, PLU @D64806, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, PFORM ABOUT, 
      FIN -, ARITY 2] : HEAR, 
   [COORD @D64817, PAST @D64816, AGR [CASE @D64815, COUNT @D64814, 
            PER @D64813, PLU @D64812, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : HEAR, 
   [COORD @D64823, PAST @D64822, 
      AGR [CASE @D64821, COUNT @D64820, PER @D64819, PLU @D64818, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : HEAR, 
   [COORD @D64827, AGR [COUNT @D64826, PER @D64825, PLU @D64824, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, PAST +, 
      ARITY 2] : HEAR, 
   [COORD @D64831, AGR [COUNT @D64830, PER @D64829, PLU @D64828, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : HEAR, 
   [COORD @D64835, AGR [COUNT @D64834, PER @D64833, PLU @D64832, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : HEAR, 
   [COORD @D64839, AGR [COUNT @D64838, PER @D64837, PLU @D64836, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, PAST +, ARITY 2] : HEAR, 
   [COORD @D64843, AGR [COUNT @D64842, PER @D64841, PLU @D64840, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM OF, PAST +, ARITY 2] : HEAR, 
   [COORD @D64847, 
      AGR [COUNT @D64846, PER @D64845, PLU @D64844, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FROM, 
      PAST +, ARITY 2] : HEAR, 
   [COORD @D64851, AGR [COUNT @D64850, PER @D64849, PLU @D64848, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, PAST +, ARITY 2] : HEAR, 
   [COORD @D64855, AGR [COUNT @D64854, PER @D64853, PLU @D64852, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM ABOUT, PAST +, ARITY 2] : HEAR, 
   [COORD @D64859, 
      AGR [COUNT @D64858, PER @D64857, PLU @D64856, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : HEAR, 
   [COORD @D64865, PAST @D64864, AGR [CASE @D64863, COUNT @D64862, 
            PER @D64861, PLU @D64860, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : HEAR, 
   [COORD @D64871, PAST @D64870, 
      AGR [CASE @D64869, COUNT @D64868, PER @D64867, PLU @D64866, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : HEAR, 
   [COORD @D64875, AGR [COUNT @D64874, PER @D64873, PLU @D64872, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : HEAR, 
   [COORD @D64879, AGR [COUNT @D64878, PER @D64877, PLU @D64876, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : HEAR.

WORD hearing : 
   [COORD @D64913, REFL @D64912, COUNT @D64911, PRD @D64910, 
      CASE @D64909, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HEARING, 
   [COORD @D64919, PRD @D64918, 
      AGR [CASE @D64917, COUNT @D64916, PER @D64915, PLU @D64914, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HEAR, 
   [COORD @D64925, PRD @D64924, AGR [CASE @D64923, COUNT @D64922, 
            PER @D64921, PLU @D64920, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAR, 
   [COORD @D64931, PRD @D64930, 
      AGR [CASE @D64929, COUNT @D64928, PER @D64927, PLU @D64926, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HEAR, 
   [COORD @D64937, PRD @D64936, AGR [CASE @D64935, COUNT @D64934, 
            PER @D64933, PLU @D64932, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAR, 
   [COORD @D64943, PRD @D64942, 
      AGR [CASE @D64941, COUNT @D64940, PER @D64939, PLU @D64938, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HEAR, 
   [COORD @D64949, PRD @D64948, AGR [CASE @D64947, COUNT @D64946, 
            PER @D64945, PLU @D64944, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAR, 
   [COORD @D64955, PRD @D64954, 
      AGR [CASE @D64953, COUNT @D64952, PER @D64951, PLU @D64950, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HEAR, 
   [COORD @D64961, PRD @D64960, AGR [CASE @D64959, COUNT @D64958, 
            PER @D64957, PLU @D64956, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAR, 
   [COORD @D64967, PRD @D64966, 
      AGR [CASE @D64965, COUNT @D64964, PER @D64963, PLU @D64962, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HEAR, 
   [COORD @D64973, PRD @D64972, AGR [CASE @D64971, COUNT @D64970, 
            PER @D64969, PLU @D64968, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAR, 
   [COORD @D64979, PRD @D64978, 
      AGR [CASE @D64977, COUNT @D64976, PER @D64975, PLU @D64974, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HEAR, 
   [COORD @D64985, PRD @D64984, AGR [CASE @D64983, COUNT @D64982, 
            PER @D64981, PLU @D64980, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAR, 
   [COORD @D64991, PRD @D64990, 
      AGR [CASE @D64989, COUNT @D64988, PER @D64987, PLU @D64986, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HEAR, 
   [COORD @D64997, PRD @D64996, AGR [CASE @D64995, COUNT @D64994, 
            PER @D64993, PLU @D64992, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAR, 
   [COORD @D65003, PRD @D65002, 
      AGR [CASE @D65001, COUNT @D65000, PER @D64999, PLU @D64998, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HEAR.

WORD hearings : 
   [COORD @D65017, DEMON @D65016, REFL @D65015, PRD @D65014, 
      CASE @D65013, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HEARING.

WORD hears : 
   [COORD @D65024, AGR [COUNT @D65023, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65026, 
      AGR [COUNT @D65025, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65028, 
      AGR [COUNT @D65027, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65030, 
      AGR [COUNT @D65029, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HEAR, 
   [COORD @D65032, AGR [COUNT @D65031, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65034, 
      AGR [COUNT @D65033, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65036, 
      AGR [COUNT @D65035, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65038, 
      AGR [COUNT @D65037, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65040, 
      AGR [COUNT @D65039, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HEAR, 
   [COORD @D65042, AGR [COUNT @D65041, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HEAR, 
   [COORD @D65044, AGR [COUNT @D65043, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HEAR, 
   [COORD @D65046, AGR [COUNT @D65045, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM ABOUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : HEAR, 
   [COORD @D65048, AGR [COUNT @D65047, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65050, 
      AGR [COUNT @D65049, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR, 
   [COORD @D65052, 
      AGR [COUNT @D65051, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAR.

WORD heat : 
   [COORD @D65059, AGR [COUNT @D65058, PER @D65057, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HEAT, 
   [COORD @D65061, AGR [COUNT @D65060, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HEAT, 
   [COORD @D65063, AGR [COUNT @D65062, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HEAT, 
   [COORD @D65067, AGR [COUNT @D65066, PER @D65065, PLU @D65064, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : HEAT, 
   [COORD @D65073, PAST @D65072, AGR [CASE @D65071, COUNT @D65070, 
            PER @D65069, PLU @D65068, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : HEAT, 
   [COORD @D65076, AGR [COUNT @D65075, PER @D65074, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : HEAT, 
   [COORD @D65078, AGR [COUNT @D65077, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : HEAT, 
   [COORD @D65080, AGR [COUNT @D65079, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : HEAT, 
   [COORD @D65084, AGR [COUNT @D65083, PER @D65082, PLU @D65081, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : HEAT, 
   [COORD @D65090, PAST @D65089, 
      AGR [CASE @D65088, COUNT @D65087, PER @D65086, PLU @D65085, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : HEAT, 
   [COORD @D65093, AGR [COUNT @D65092, PER @D65091, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HEAT, 
   [COORD @D65095, AGR [COUNT @D65094, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HEAT, 
   [COORD @D65097, AGR [COUNT @D65096, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HEAT, 
   [COORD @D65101, AGR [COUNT @D65100, PER @D65099, PLU @D65098, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HEAT, 
   [COORD @D65107, PAST @D65106, AGR [CASE @D65105, COUNT @D65104, 
            PER @D65103, PLU @D65102, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : HEAT, 
   [COORD @D65110, AGR [COUNT @D65109, PER @D65108, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : HEAT, 
   [COORD @D65112, AGR [COUNT @D65111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : HEAT, 
   [COORD @D65114, AGR [COUNT @D65113, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : HEAT, 
   [COORD @D65118, AGR [COUNT @D65117, PER @D65116, PLU @D65115, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : HEAT, 
   [COORD @D65124, PAST @D65123, 
      AGR [CASE @D65122, COUNT @D65121, PER @D65120, PLU @D65119, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : HEAT.

WORD heated : 
   [COORD @D65134, AGR [CASE @D65133, COUNT @D65132, PER @D65131, 
            PLU @D65130, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HEAT, 
   [COORD @D65139, AGR [CASE @D65138, COUNT @D65137, PER @D65136, 
            PLU @D65135, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65144, AGR [CASE @D65143, COUNT @D65142, PER @D65141, 
            PLU @D65140, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65149, AGR [CASE @D65148, COUNT @D65147, PER @D65146, 
            PLU @D65145, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65154, AGR [CASE @D65153, COUNT @D65152, PER @D65151, 
            PLU @D65150, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65159, AGR [CASE @D65158, COUNT @D65157, PER @D65156, 
            PLU @D65155, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65164, AGR [CASE @D65163, COUNT @D65162, PER @D65161, 
            PLU @D65160, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65169, AGR [CASE @D65168, COUNT @D65167, PER @D65166, 
            PLU @D65165, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65174, AGR [CASE @D65173, COUNT @D65172, PER @D65171, 
            PLU @D65170, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65179, AGR [CASE @D65178, COUNT @D65177, PER @D65176, 
            PLU @D65175, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HEAT.

WORD heating : 
   [COORD @D65190, REFL @D65189, PRD @D65188, CASE @D65187, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : HEATING, 
   [COORD @D65196, PRD @D65195, 
      AGR [CASE @D65194, COUNT @D65193, PER @D65192, PLU @D65191, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HEAT, 
   [COORD @D65202, PRD @D65201, AGR [CASE @D65200, COUNT @D65199, 
            PER @D65198, PLU @D65197, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAT, 
   [COORD @D65208, PRD @D65207, 
      AGR [CASE @D65206, COUNT @D65205, PER @D65204, PLU @D65203, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HEAT, 
   [COORD @D65214, PRD @D65213, AGR [CASE @D65212, COUNT @D65211, 
            PER @D65210, PLU @D65209, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HEAT.

WORD heats : 
   [COORD @D65230, AGR [COUNT @D65229, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAT, 
   [COORD @D65232, 
      AGR [COUNT @D65231, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAT, 
   [COORD @D65234, 
      AGR [COUNT @D65233, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAT, 
   [COORD @D65236, 
      AGR [COUNT @D65235, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HEAT.

WORD height : 
   [COORD @D65245, REFL @D65244, COUNT @D65243, PRD @D65242, CASE 
         @D65241, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HEIGHT.

WORD heights : 
   [COORD @D65255, DEMON @D65254, REFL @D65253, PRD @D65252, 
      CASE @D65251, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HEIGHT.

WORD held : 
   [COORD @D65265, PAST @D65264, AGR [CASE @D65263, COUNT @D65262, 
            PER @D65261, PLU @D65260, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : HOLD, 
   [COORD @D65271, PAST @D65270, 
      AGR [CASE @D65269, COUNT @D65268, PER @D65267, PLU @D65266, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, ARITY 3] : 
   HOLD, 
   [COORD @D65277, PAST @D65276, AGR [CASE @D65275, COUNT @D65274, 
            PER @D65273, PLU @D65272, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : HOLD, 
   [COORD @D65283, PAST @D65282, 
      AGR [CASE @D65281, COUNT @D65280, PER @D65279, PLU @D65278, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : 
   HOLD, 
   [COORD @D65289, PAST @D65288, AGR [CASE @D65287, COUNT @D65286, 
            PER @D65285, PLU @D65284, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : HOLD, 
   [COORD @D65295, PAST @D65294, 
      AGR [CASE @D65293, COUNT @D65292, PER @D65291, PLU @D65290, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : HOLD, 
   [COORD @D65301, PAST @D65300, AGR [CASE @D65299, COUNT @D65298, 
            PER @D65297, PLU @D65296, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OVER, FIN -, ARITY 3] : HOLD, 
   [COORD @D65307, PAST @D65306, 
      AGR [CASE @D65305, COUNT @D65304, PER @D65303, PLU @D65302, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OVER, FIN -, 
      ARITY 3] : HOLD, 
   [COORD @D65313, PAST @D65312, AGR [CASE @D65311, COUNT @D65310, 
            PER @D65309, PLU @D65308, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AGAINST, FIN -, ARITY 3] : HOLD, 
   [COORD @D65319, PAST @D65318, 
      AGR [CASE @D65317, COUNT @D65316, PER @D65315, PLU @D65314, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM AGAINST, FIN -, 
      ARITY 3] : HOLD, 
   [COORD @D65325, PAST @D65324, AGR [CASE @D65323, COUNT @D65322, 
            PER @D65321, PLU @D65320, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM TO, FIN -, ARITY 3] : HOLD, 
   [COORD @D65331, PAST @D65330, 
      AGR [CASE @D65329, COUNT @D65328, PER @D65327, PLU @D65326, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM TO, FIN -, ARITY 3] : HOLD, 
   [COORD @D65335, AGR [COUNT @D65334, PER @D65333, PLU @D65332, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PAST +, ARITY 3] : HOLD, 
   [COORD @D65339, AGR [COUNT @D65338, PER @D65337, PLU @D65336, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : HOLD, 
   [COORD @D65343, AGR [COUNT @D65342, PER @D65341, PLU @D65340, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : HOLD, 
   [COORD @D65347, AGR [COUNT @D65346, PER @D65345, PLU @D65344, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, PAST +, ARITY 3] : HOLD, 
   [COORD @D65351, AGR [COUNT @D65350, PER @D65349, PLU @D65348, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, PAST +, ARITY 3] : HOLD, 
   [COORD @D65355, AGR [COUNT @D65354, PER @D65353, PLU @D65352, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM TO, PAST +, ARITY 3] : HOLD, 
   [COORD @D65361, PAST @D65360, 
      AGR [CASE @D65359, COUNT @D65358, PER @D65357, PLU @D65356, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, ARITY 2] : HOLD, 
   [COORD @D65367, PAST @D65366, 
      AGR [CASE @D65365, COUNT @D65364, PER @D65363, PLU @D65362, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, REG -, FIN -, ARITY 2] : 
   HOLD, 
   [COORD @D65370, AGR @D65369, PAST @D65368, VFORM EN, SUBCAT OC_INF, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : HOLD, 
   [COORD @D65376, PAST @D65375, AGR [CASE @D65374, COUNT @D65373, 
            PER @D65372, PLU @D65371, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 2] : HOLD, 
   [COORD @D65379, AGR @D65378, PAST @D65377, VFORM EN, SUBCAT OC_AP, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : HOLD, 
   [COORD @D65385, PAST @D65384, AGR [CASE @D65383, COUNT @D65382, 
            PER @D65381, PLU @D65380, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 2] : HOLD, 
   [COORD @D65391, PAST @D65390, 
      AGR [CASE @D65389, COUNT @D65388, PER @D65387, PLU @D65386, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65397, PAST @D65396, AGR [CASE @D65395, COUNT @D65394, 
            PER @D65393, PLU @D65392, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : HOLD, 
   [COORD @D65403, PAST @D65402, 
      AGR [CASE @D65401, COUNT @D65400, PER @D65399, PLU @D65398, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM WITH, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65409, PAST @D65408, AGR [CASE @D65407, COUNT @D65406, 
            PER @D65405, PLU @D65404, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM WITH, FIN -, ARITY 2] : HOLD, 
   [COORD @D65415, PAST @D65414, 
      AGR [CASE @D65413, COUNT @D65412, PER @D65411, PLU @D65410, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM TO, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65421, PAST @D65420, AGR [CASE @D65419, COUNT @D65418, 
            PER @D65417, PLU @D65416, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : HOLD, 
   [COORD @D65427, PAST @D65426, 
      AGR [CASE @D65425, COUNT @D65424, PER @D65423, PLU @D65422, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ONTO, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65433, PAST @D65432, AGR [CASE @D65431, COUNT @D65430, 
            PER @D65429, PLU @D65428, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ONTO, FIN -, ARITY 2] : HOLD, 
   [COORD @D65439, PAST @D65438, 
      AGR [CASE @D65437, COUNT @D65436, PER @D65435, PLU @D65434, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM ON, 
      FIN -, ARITY 2] : HOLD, 
   [COORD @D65445, PAST @D65444, AGR [CASE @D65443, COUNT @D65442, 
            PER @D65441, PLU @D65440, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT OUT, PFORM ON, FIN -, ARITY 2] : HOLD, 
   [COORD @D65451, PAST @D65450, 
      AGR [CASE @D65449, COUNT @D65448, PER @D65447, PLU @D65446, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT FORTH, PFORM ON, 
      FIN -, ARITY 2] : HOLD, 
   [COORD @D65457, PAST @D65456, AGR [CASE @D65455, COUNT @D65454, 
            PER @D65453, PLU @D65452, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OFF, PFORM FROM, FIN -, ARITY 2] : HOLD, 
   [COORD @D65463, PAST @D65462, 
      AGR [CASE @D65461, COUNT @D65460, PER @D65459, PLU @D65458, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM FOR, 
      FIN -, ARITY 2] : HOLD, 
   [COORD @D65469, PAST @D65468, AGR [CASE @D65467, COUNT @D65466, 
            PER @D65465, PLU @D65464, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT OUT, PFORM FOR, FIN -, ARITY 2] : HOLD, 
   [COORD @D65475, PAST @D65474, 
      AGR [CASE @D65473, COUNT @D65472, PER @D65471, PLU @D65470, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM BY, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65481, PAST @D65480, AGR [CASE @D65479, COUNT @D65478, 
            PER @D65477, PLU @D65476, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM BY, FIN -, ARITY 2] : HOLD, 
   [COORD @D65487, PAST @D65486, 
      AGR [CASE @D65485, COUNT @D65484, PER @D65483, PLU @D65482, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65493, PAST @D65492, AGR [CASE @D65491, COUNT @D65490, 
            PER @D65489, PLU @D65488, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : HOLD, 
   [COORD @D65499, PAST @D65498, 
      AGR [CASE @D65497, COUNT @D65496, PER @D65495, PLU @D65494, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TOGETHER, 
      FIN -, ARITY 2] : HOLD, 
   [COORD @D65505, PAST @D65504, AGR [CASE @D65503, COUNT @D65502, 
            PER @D65501, PLU @D65500, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TOGETHER, FIN -, ARITY 2] : HOLD, 
   [COORD @D65511, PAST @D65510, 
      AGR [CASE @D65509, COUNT @D65508, PER @D65507, PLU @D65506, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65517, PAST @D65516, AGR [CASE @D65515, COUNT @D65514, 
            PER @D65513, PLU @D65512, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : HOLD, 
   [COORD @D65523, PAST @D65522, 
      AGR [CASE @D65521, COUNT @D65520, PER @D65519, PLU @D65518, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65529, PAST @D65528, AGR [CASE @D65527, COUNT @D65526, 
            PER @D65525, PLU @D65524, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : HOLD, 
   [COORD @D65535, PAST @D65534, 
      AGR [CASE @D65533, COUNT @D65532, PER @D65531, PLU @D65530, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65541, PAST @D65540, AGR [CASE @D65539, COUNT @D65538, 
            PER @D65537, PLU @D65536, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : HOLD, 
   [COORD @D65547, PAST @D65546, 
      AGR [CASE @D65545, COUNT @D65544, PER @D65543, PLU @D65542, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65553, PAST @D65552, AGR [CASE @D65551, COUNT @D65550, 
            PER @D65549, PLU @D65548, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : HOLD, 
   [COORD @D65559, PAST @D65558, 
      AGR [CASE @D65557, COUNT @D65556, PER @D65555, PLU @D65554, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : HOLD, 
   [COORD @D65565, PAST @D65564, AGR [CASE @D65563, COUNT @D65562, 
            PER @D65561, PLU @D65560, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : HOLD, 
   [COORD @D65569, 
      AGR [COUNT @D65568, PER @D65567, PLU @D65566, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : HOLD, 
   [COORD @D65573, AGR [COUNT @D65572, PER @D65571, PLU @D65570, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, PAST +, ARITY 2] : HOLD, 
   [COORD @D65577, AGR [COUNT @D65576, PER @D65575, PLU @D65574, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PAST +, ARITY 2] : HOLD, 
   [COORD @D65581, AGR [COUNT @D65580, PER @D65579, PLU @D65578, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, PAST +, ARITY 2] : HOLD, 
   [COORD @D65585, AGR [COUNT @D65584, PER @D65583, PLU @D65582, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : HOLD, 
   [COORD @D65589, AGR [COUNT @D65588, PER @D65587, PLU @D65586, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, PAST +, ARITY 2] : HOLD, 
   [COORD @D65593, AGR [COUNT @D65592, PER @D65591, PLU @D65590, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, PAST +, ARITY 2] : HOLD, 
   [COORD @D65597, AGR [COUNT @D65596, PER @D65595, PLU @D65594, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, PAST +, ARITY 2] : HOLD, 
   [COORD @D65601, AGR [COUNT @D65600, PER @D65599, PLU @D65598, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, PAST +, ARITY 2] : HOLD, 
   [COORD @D65605, AGR [COUNT @D65604, PER @D65603, PLU @D65602, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT FORTH, PFORM ON, PAST +, ARITY 2] : HOLD, 
   [COORD @D65609, AGR [COUNT @D65608, PER @D65607, PLU @D65606, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM FROM, PAST +, ARITY 2] : HOLD, 
   [COORD @D65613, AGR [COUNT @D65612, PER @D65611, PLU @D65610, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, PAST +, ARITY 2] : HOLD, 
   [COORD @D65617, AGR [COUNT @D65616, PER @D65615, PLU @D65614, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, PAST +, ARITY 2] : HOLD, 
   [COORD @D65621, AGR [COUNT @D65620, PER @D65619, PLU @D65618, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : HOLD, 
   [COORD @D65625, AGR [COUNT @D65624, PER @D65623, PLU @D65622, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, PAST +, ARITY 2] : HOLD, 
   [COORD @D65629, AGR [COUNT @D65628, PER @D65627, PLU @D65626, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PAST +, ARITY 2] : HOLD, 
   [COORD @D65633, AGR [COUNT @D65632, PER @D65631, PLU @D65630, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : HOLD, 
   [COORD @D65637, AGR [COUNT @D65636, PER @D65635, PLU @D65634, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : HOLD, 
   [COORD @D65641, AGR [COUNT @D65640, PER @D65639, PLU @D65638, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PAST +, ARITY 2] : HOLD, 
   [COORD @D65645, AGR [COUNT @D65644, PER @D65643, PLU @D65642, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PAST +, ARITY 2] : HOLD, 
   [COORD @D65651, PAST @D65650, AGR [CASE @D65649, COUNT @D65648, 
            PER @D65647, PLU @D65646, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : HOLD, 
   [COORD @D65657, PAST @D65656, 
      AGR [CASE @D65655, COUNT @D65654, PER @D65653, PLU @D65652, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : HOLD, 
   [COORD @D65663, PAST @D65662, AGR [CASE @D65661, COUNT @D65660, 
            PER @D65659, PLU @D65658, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, FIN -, ARITY 1] : HOLD, 
   [COORD @D65669, PAST @D65668, 
      AGR [CASE @D65667, COUNT @D65666, PER @D65665, PLU @D65664, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, FIN -, 
      ARITY 1] : HOLD, 
   [COORD @D65675, PAST @D65674, AGR [CASE @D65673, COUNT @D65672, 
            PER @D65671, PLU @D65670, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : HOLD, 
   [COORD @D65681, PAST @D65680, 
      AGR [CASE @D65679, COUNT @D65678, PER @D65677, PLU @D65676, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, FIN -, 
      ARITY 1] : HOLD, 
   [COORD @D65687, PAST @D65686, AGR [CASE @D65685, COUNT @D65684, 
            PER @D65683, PLU @D65682, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : HOLD, 
   [COORD @D65693, PAST @D65692, 
      AGR [CASE @D65691, COUNT @D65690, PER @D65689, PLU @D65688, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FORTH, FIN -, 
      ARITY 1] : HOLD, 
   [COORD @D65699, PAST @D65698, AGR [CASE @D65697, COUNT @D65696, 
            PER @D65695, PLU @D65694, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : HOLD, 
   [COORD @D65705, PAST @D65704, 
      AGR [CASE @D65703, COUNT @D65702, PER @D65701, PLU @D65700, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, FIN -, 
      ARITY 1] : HOLD, 
   [COORD @D65709, AGR [COUNT @D65708, PER @D65707, PLU @D65706, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : HOLD, 
   [COORD @D65713, AGR [COUNT @D65712, PER @D65711, PLU @D65710, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : HOLD, 
   [COORD @D65717, AGR [COUNT @D65716, PER @D65715, PLU @D65714, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, PAST +, ARITY 1] : HOLD, 
   [COORD @D65721, AGR [COUNT @D65720, PER @D65719, PLU @D65718, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : HOLD, 
   [COORD @D65725, AGR [COUNT @D65724, PER @D65723, PLU @D65722, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : HOLD, 
   [COORD @D65729, AGR [COUNT @D65728, PER @D65727, PLU @D65726, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : HOLD, 
   [COORD @D65733, AGR [COUNT @D65732, PER @D65731, PLU @D65730, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : HOLD, 
   [COORD @D65737, AGR [COUNT @D65736, PER @D65735, PLU @D65734, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORTH, PAST +, ARITY 1] : HOLD, 
   [COORD @D65741, AGR [COUNT @D65740, PER @D65739, PLU @D65738, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : HOLD, 
   [COORD @D65745, AGR [COUNT @D65744, PER @D65743, PLU @D65742, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : HOLD.

WORD help : 
   [COORD @D65768, REFL @D65767, PRD @D65766, CASE @D65765, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HELP, 
   [COORD @D65773, REFL @D65772, COUNT @D65771, PRD @D65770, 
      CASE @D65769, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HELP, 
   [COORD @D65777, REFL @D65776, PRD @D65775, CASE @D65774, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : HELP, 
   [COORD @D65781, REFL @D65780, PRD @D65779, CASE @D65778, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : HELP, 
   [COORD @D65784, 
      AGR [COUNT @D65783, PER @D65782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      ARITY 3] : HELP, 
   [COORD @D65786, AGR [COUNT @D65785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : HELP, 
   [COORD @D65788, AGR [COUNT @D65787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : HELP, 
   [COORD @D65792, AGR [COUNT @D65791, PER @D65790, PLU @D65789, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : HELP, 
   [COORD @D65798, PAST @D65797, AGR [CASE @D65796, COUNT @D65795, 
            PER @D65794, PLU @D65793, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_ING, ARITY 3] : HELP, 
   [COORD @D65801, AGR [COUNT @D65800, PER @D65799, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : HELP, 
   [COORD @D65803, AGR [COUNT @D65802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : HELP, 
   [COORD @D65805, AGR [COUNT @D65804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : HELP, 
   [COORD @D65809, AGR [COUNT @D65808, PER @D65807, PLU @D65806, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : HELP, 
   [COORD @D65815, PAST @D65814, AGR [CASE @D65813, COUNT @D65812, 
            PER @D65811, PLU @D65810, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : HELP, 
   [COORD @D65818, AGR [COUNT @D65817, PER @D65816, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : HELP, 
   [COORD @D65820, AGR [COUNT @D65819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : HELP, 
   [COORD @D65822, AGR [COUNT @D65821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : HELP, 
   [COORD @D65826, AGR [COUNT @D65825, PER @D65824, PLU @D65823, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : HELP, 
   [COORD @D65832, PAST @D65831, AGR [CASE @D65830, COUNT @D65829, 
            PER @D65828, PLU @D65827, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_BSE, ARITY 3] : HELP, 
   [COORD @D65835, AGR [COUNT @D65834, PER @D65833, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : HELP, 
   [COORD @D65837, AGR [COUNT @D65836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : HELP, 
   [COORD @D65839, AGR [COUNT @D65838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : HELP, 
   [COORD @D65843, AGR [COUNT @D65842, PER @D65841, PLU @D65840, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : HELP, 
   [COORD @D65849, PAST @D65848, 
      AGR [CASE @D65847, COUNT @D65846, PER @D65845, PLU @D65844, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : HELP, 
   [COORD @D65852, AGR [COUNT @D65851, PER @D65850, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM WITH, ARITY 3] : HELP, 
   [COORD @D65854, 
      AGR [COUNT @D65853, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM WITH, ARITY 3] : HELP, 
   [COORD @D65856, AGR [COUNT @D65855, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM WITH, ARITY 3] : HELP, 
   [COORD @D65860, 
      AGR [COUNT @D65859, PER @D65858, PLU @D65857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM WITH, ARITY 3] : HELP, 
   [COORD @D65866, PAST @D65865, 
      AGR [CASE @D65864, COUNT @D65863, PER @D65862, PLU @D65861, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM WITH, ARITY 3] : HELP, 
   [COORD @D65869, AGR [COUNT @D65868, PER @D65867, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : HELP, 
   [COORD @D65871, AGR [COUNT @D65870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : HELP, 
   [COORD @D65873, AGR [COUNT @D65872, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : HELP, 
   [COORD @D65877, AGR [COUNT @D65876, PER @D65875, PLU @D65874, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : HELP, 
   [COORD @D65883, PAST @D65882, AGR [CASE @D65881, COUNT @D65880, 
            PER @D65879, PLU @D65878, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : HELP, 
   [COORD @D65886, AGR [COUNT @D65885, PER @D65884, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HELP, 
   [COORD @D65888, AGR [COUNT @D65887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HELP, 
   [COORD @D65890, AGR [COUNT @D65889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HELP, 
   [COORD @D65894, AGR [COUNT @D65893, PER @D65892, PLU @D65891, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : HELP, 
   [COORD @D65900, PAST @D65899, AGR [CASE @D65898, COUNT @D65897, 
            PER @D65896, PLU @D65895, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : HELP, 
   [COORD @D65903, AGR [COUNT @D65902, PER @D65901, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM WITH, ARITY 2] : HELP, 
   [COORD @D65905, AGR [COUNT @D65904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM WITH, ARITY 2] : HELP, 
   [COORD @D65907, AGR [COUNT @D65906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM WITH, ARITY 2] : HELP, 
   [COORD @D65911, AGR [COUNT @D65910, PER @D65909, PLU @D65908, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM WITH, ARITY 2] : HELP, 
   [COORD @D65917, PAST @D65916, 
      AGR [CASE @D65915, COUNT @D65914, PER @D65913, PLU @D65912, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM WITH, ARITY 2] : HELP, 
   [COORD @D65920, AGR [COUNT @D65919, PER @D65918, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : HELP, 
   [COORD @D65922, AGR [COUNT @D65921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : HELP, 
   [COORD @D65924, AGR [COUNT @D65923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : HELP, 
   [COORD @D65928, AGR [COUNT @D65927, PER @D65926, PLU @D65925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : HELP, 
   [COORD @D65934, PAST @D65933, 
      AGR [CASE @D65932, COUNT @D65931, PER @D65930, PLU @D65929, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : HELP, 
   [COORD @D65937, AGR @D65936, PAST @D65935, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT SFIN, ARITY 1] : HELP, 
   [COORD @D65940, AGR [COUNT @D65939, PER @D65938, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HELP, 
   [COORD @D65942, AGR [COUNT @D65941, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HELP, 
   [COORD @D65944, AGR [COUNT @D65943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HELP, 
   [COORD @D65948, AGR [COUNT @D65947, PER @D65946, PLU @D65945, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HELP, 
   [COORD @D65954, PAST @D65953, AGR [CASE @D65952, COUNT @D65951, 
            PER @D65950, PLU @D65949, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : HELP, 
   [COORD @D65957, AGR [COUNT @D65956, PER @D65955, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : HELP, 
   [COORD @D65959, AGR [COUNT @D65958, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : HELP, 
   [COORD @D65961, AGR [COUNT @D65960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : HELP, 
   [COORD @D65965, AGR [COUNT @D65964, PER @D65963, PLU @D65962, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : HELP, 
   [COORD @D65971, PAST @D65970, 
      AGR [CASE @D65969, COUNT @D65968, PER @D65967, PLU @D65966, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : HELP.

WORD helped : 
   [COORD @D65982, AGR [CASE @D65981, COUNT @D65980, PER @D65979, 
            PLU @D65978, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HELP, 
   [COORD @D65987, AGR [CASE @D65986, COUNT @D65985, PER @D65984, 
            PLU @D65983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D65992, AGR [CASE @D65991, COUNT @D65990, PER @D65989, 
            PLU @D65988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D65997, AGR [CASE @D65996, COUNT @D65995, PER @D65994, 
            PLU @D65993, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66002, AGR [CASE @D66001, COUNT @D66000, PER @D65999, 
            PLU @D65998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66008, AGR [CASE @D66007, NFORM @D66006, COUNT @D66005, 
            PER @D66004, PLU @D66003, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HELP, 
   [COORD @D66013, AGR [CASE @D66012, COUNT @D66011, PER @D66010, 
            PLU @D66009, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66018, AGR [CASE @D66017, COUNT @D66016, PER @D66015, 
            PLU @D66014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66023, AGR [CASE @D66022, COUNT @D66021, PER @D66020, 
            PLU @D66019, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66028, AGR [CASE @D66027, COUNT @D66026, PER @D66025, 
            PLU @D66024, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66033, AGR [CASE @D66032, COUNT @D66031, PER @D66030, 
            PLU @D66029, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66038, AGR [CASE @D66037, COUNT @D66036, PER @D66035, 
            PLU @D66034, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66043, AGR [CASE @D66042, COUNT @D66041, PER @D66040, 
            PLU @D66039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66048, 
      AGR [CASE @D66047, COUNT @D66046, PER @D66045, PLU @D66044, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66053, AGR [CASE @D66052, COUNT @D66051, PER @D66050, 
            PLU @D66049, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66058, AGR [CASE @D66057, COUNT @D66056, PER @D66055, 
            PLU @D66054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66063, AGR [CASE @D66062, COUNT @D66061, PER @D66060, 
            PLU @D66059, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HELP, 
   [COORD @D66068, AGR [CASE @D66067, COUNT @D66066, PER @D66065, 
            PLU @D66064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66073, AGR [CASE @D66072, COUNT @D66071, PER @D66070, 
            PLU @D66069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66078, AGR [CASE @D66077, COUNT @D66076, PER @D66075, 
            PLU @D66074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66083, 
      AGR [CASE @D66082, COUNT @D66081, PER @D66080, PLU @D66079, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : HELP, 
   [COORD @D66088, AGR [CASE @D66087, COUNT @D66086, PER @D66085, 
            PLU @D66084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66093, AGR [CASE @D66092, COUNT @D66091, PER @D66090, 
            PLU @D66089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66098, AGR [CASE @D66097, COUNT @D66096, PER @D66095, 
            PLU @D66094, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66100, AGR @D66099, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HELP, 
   [COORD @D66102, AGR @D66101, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : HELP, 
   [COORD @D66107, AGR [CASE @D66106, COUNT @D66105, PER @D66104, 
            PLU @D66103, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66112, AGR [CASE @D66111, COUNT @D66110, PER @D66109, 
            PLU @D66108, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HELP, 
   [COORD @D66117, AGR [CASE @D66116, COUNT @D66115, PER @D66114, 
            PLU @D66113, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66122, AGR [CASE @D66121, COUNT @D66120, PER @D66119, 
            PLU @D66118, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HELP.

WORD helping : 
   [COORD @D66136, REFL @D66135, PRD @D66134, CASE @D66133, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HELPING, 
   [COORD @D66142, PRD @D66141, 
      AGR [CASE @D66140, COUNT @D66139, PER @D66138, PLU @D66137, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HELP, 
   [COORD @D66148, PRD @D66147, AGR [CASE @D66146, COUNT @D66145, 
            PER @D66144, PLU @D66143, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66154, PRD @D66153, 
      AGR [CASE @D66152, COUNT @D66151, PER @D66150, PLU @D66149, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HELP, 
   [COORD @D66160, PRD @D66159, AGR [CASE @D66158, COUNT @D66157, 
            PER @D66156, PLU @D66155, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66166, PRD @D66165, 
      AGR [CASE @D66164, COUNT @D66163, PER @D66162, PLU @D66161, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HELP, 
   [COORD @D66172, PRD @D66171, AGR [CASE @D66170, COUNT @D66169, 
            PER @D66168, PLU @D66167, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66178, PRD @D66177, 
      AGR [CASE @D66176, COUNT @D66175, PER @D66174, PLU @D66173, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HELP, 
   [COORD @D66184, PRD @D66183, AGR [CASE @D66182, COUNT @D66181, 
            PER @D66180, PLU @D66179, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66190, PRD @D66189, 
      AGR [CASE @D66188, COUNT @D66187, PER @D66186, PLU @D66185, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HELP, 
   [COORD @D66193, AGR @D66192, PRD @D66191, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HELP, 
   [COORD @D66199, PRD @D66198, AGR [CASE @D66197, COUNT @D66196, 
            PER @D66195, PLU @D66194, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HELP, 
   [COORD @D66205, PRD @D66204, 
      AGR [CASE @D66203, COUNT @D66202, PER @D66201, PLU @D66200, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HELP.

WORD helpings : 
   [COORD @D66223, DEMON @D66222, REFL @D66221, PRD @D66220, 
      CASE @D66219, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HELPING.

WORD helps : 
   [COORD @D66234, DEMON @D66233, REFL @D66232, PRD @D66231, CASE 
         @D66230, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HELP, 
   [COORD @D66239, DEMON @D66238, REFL @D66237, PRD @D66236, 
      CASE @D66235, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HELP, 
   [COORD @D66244, DEMON @D66243, REFL @D66242, PRD @D66241, 
      CASE @D66240, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   HELP, 
   [COORD @D66246, AGR [COUNT @D66245, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66248, 
      AGR [COUNT @D66247, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66250, 
      AGR [COUNT @D66249, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66252, 
      AGR [COUNT @D66251, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66254, 
      AGR [COUNT @D66253, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HELP, 
   [COORD @D66256, AGR [COUNT @D66255, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66258, 
      AGR [COUNT @D66257, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66260, 
      AGR [COUNT @D66259, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HELP, 
   [COORD @D66262, AGR [COUNT @D66261, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66266, 
      AGR [CASE @D66265, NFORM @D66264, COUNT @D66263, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EXTRAP, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66271, 
      AGR [UB @D66270, VFORM @D66269, SUBJ @D66268, FIN @D66267, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EXTRAP, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66273, 
      AGR [COUNT @D66272, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP, 
   [COORD @D66275, 
      AGR [COUNT @D66274, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HELP.

WORD hide : 
   [COORD @D66282, AGR [COUNT @D66281, PER @D66280, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HIDE, 
   [COORD @D66284, AGR [COUNT @D66283, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HIDE, 
   [COORD @D66286, AGR [COUNT @D66285, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HIDE, 
   [COORD @D66290, AGR [COUNT @D66289, PER @D66288, PLU @D66287, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : HIDE, 
   [COORD @D66296, PAST @D66295, AGR [CASE @D66294, COUNT @D66293, 
            PER @D66292, PLU @D66291, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : HIDE, 
   [COORD @D66299, AGR [COUNT @D66298, PER @D66297, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HIDE, 
   [COORD @D66301, AGR [COUNT @D66300, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HIDE, 
   [COORD @D66303, AGR [COUNT @D66302, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HIDE, 
   [COORD @D66307, AGR [COUNT @D66306, PER @D66305, PLU @D66304, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : HIDE, 
   [COORD @D66313, PAST @D66312, 
      AGR [CASE @D66311, COUNT @D66310, PER @D66309, PLU @D66308, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   HIDE.

WORD hides : 
   [COORD @D66325, AGR [COUNT @D66324, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIDE, 
   [COORD @D66327, 
      AGR [COUNT @D66326, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIDE.

WORD hiding : 
   [COORD @D66336, REFL @D66335, COUNT @D66334, PRD @D66333, CASE 
         @D66332, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HIDING, 
   [COORD @D66342, PRD @D66341, 
      AGR [CASE @D66340, COUNT @D66339, PER @D66338, PLU @D66337, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HIDE, 
   [COORD @D66348, PRD @D66347, AGR [CASE @D66346, COUNT @D66345, 
            PER @D66344, PLU @D66343, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HIDE.

WORD hidings : 
   [COORD @D66359, DEMON @D66358, REFL @D66357, PRD @D66356, 
      CASE @D66355, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HIDING.

WORD hit : 
   [COORD @D66366, REFL @D66365, PRD @D66364, CASE @D66363, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HIT, 
   [COORD @D66369, 
      AGR [COUNT @D66368, PER @D66367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : HIT, 
   
   [COORD @D66371, AGR [COUNT @D66370, N +, V -, BAR 2, NFORM NORM, CASE 
            NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HIT, 
   [COORD @D66373, AGR [COUNT @D66372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HIT, 
   [COORD @D66377, AGR [COUNT @D66376, PER @D66375, PLU @D66374, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : HIT, 
   [COORD @D66383, PAST @D66382, AGR [CASE @D66381, COUNT @D66380, 
            PER @D66379, PLU @D66378, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : HIT, 
   [COORD @D66386, AGR [COUNT @D66385, PER @D66384, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : HIT, 
   [COORD @D66388, AGR [COUNT @D66387, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : HIT, 
   [COORD @D66390, AGR [COUNT @D66389, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : HIT, 
   [COORD @D66394, AGR [COUNT @D66393, PER @D66392, PLU @D66391, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : HIT, 
   [COORD @D66400, PAST @D66399, AGR [CASE @D66398, COUNT @D66397, 
            PER @D66396, PLU @D66395, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM UPON, ARITY 2] : HIT, 
   [COORD @D66403, 
      AGR [COUNT @D66402, PER @D66401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, 
      ARITY 2] : HIT, 
   [COORD @D66405, AGR [COUNT @D66404, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : HIT, 
   [COORD @D66407, AGR [COUNT @D66406, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : HIT, 
   [COORD @D66411, AGR [COUNT @D66410, PER @D66409, PLU @D66408, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : HIT, 
   [COORD @D66417, PAST @D66416, AGR [CASE @D66415, COUNT @D66414, 
            PER @D66413, PLU @D66412, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : HIT, 
   [COORD @D66420, 
      AGR [COUNT @D66419, PER @D66418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, 
      ARITY 2] : HIT, 
   [COORD @D66422, AGR [COUNT @D66421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : HIT, 
   [COORD @D66424, AGR [COUNT @D66423, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : HIT, 
   [COORD @D66428, AGR [COUNT @D66427, PER @D66426, PLU @D66425, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : HIT, 
   [COORD @D66434, PAST @D66433, AGR [CASE @D66432, COUNT @D66431, 
            PER @D66430, PLU @D66429, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : HIT, 
   [COORD @D66437, 
      AGR [COUNT @D66436, PER @D66435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM AT, ARITY 2] : HIT, 
   [COORD @D66439, AGR [COUNT @D66438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, ARITY 2] : HIT, 
   [COORD @D66441, AGR [COUNT @D66440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, ARITY 2] : HIT, 
   [COORD @D66445, AGR [COUNT @D66444, PER @D66443, PLU @D66442, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM AT, ARITY 2] : HIT, 
   [COORD @D66451, PAST @D66450, 
      AGR [CASE @D66449, COUNT @D66448, PER @D66447, PLU @D66446, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM AT, ARITY 2] : HIT, 
   [COORD @D66454, AGR [COUNT @D66453, PER @D66452, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : HIT, 
   [COORD @D66456, AGR [COUNT @D66455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : HIT, 
   [COORD @D66458, AGR [COUNT @D66457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : HIT, 
   [COORD @D66462, AGR [COUNT @D66461, PER @D66460, PLU @D66459, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : HIT, 
   [COORD @D66468, PAST @D66467, 
      AGR [CASE @D66466, COUNT @D66465, PER @D66464, PLU @D66463, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : HIT, 
   [COORD @D66474, PAST @D66473, AGR [CASE @D66472, COUNT @D66471, 
            PER @D66470, PLU @D66469, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : HIT, 
   [COORD @D66480, PAST @D66479, 
      AGR [CASE @D66478, COUNT @D66477, PER @D66476, PLU @D66475, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : HIT, 
   [COORD @D66486, PAST @D66485, 
      AGR [CASE @D66484, COUNT @D66483, PER @D66482, PLU @D66481, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM UPON, FIN -, 
      ARITY 2] : HIT, 
   [COORD @D66492, PAST @D66491, AGR [CASE @D66490, COUNT @D66489, 
            PER @D66488, PLU @D66487, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM UPON, FIN -, ARITY 2] : HIT, 
   [COORD @D66498, PAST @D66497, 
      AGR [CASE @D66496, COUNT @D66495, PER @D66494, PLU @D66493, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ON, FIN -, 
      ARITY 2] : HIT, 
   [COORD @D66504, PAST @D66503, AGR [CASE @D66502, COUNT @D66501, 
            PER @D66500, PLU @D66499, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ON, FIN -, ARITY 2] : HIT, 
   [COORD @D66510, PAST @D66509, 
      AGR [CASE @D66508, COUNT @D66507, PER @D66506, PLU @D66505, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM AT, FIN -, 
      ARITY 2] : HIT, 
   [COORD @D66516, PAST @D66515, AGR [CASE @D66514, COUNT @D66513, 
            PER @D66512, PLU @D66511, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM AT, FIN -, ARITY 2] : HIT, 
   [COORD @D66522, PAST @D66521, 
      AGR [CASE @D66520, COUNT @D66519, PER @D66518, PLU @D66517, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM AT, 
      FIN -, ARITY 2] : HIT, 
   [COORD @D66528, PAST @D66527, AGR [CASE @D66526, COUNT @D66525, 
            PER @D66524, PLU @D66523, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT OUT, PFORM AT, FIN -, ARITY 2] : HIT, 
   [COORD @D66534, PAST @D66533, 
      AGR [CASE @D66532, COUNT @D66531, PER @D66530, PLU @D66529, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : HIT, 
   [COORD @D66540, PAST @D66539, AGR [CASE @D66538, COUNT @D66537, 
            PER @D66536, PLU @D66535, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : HIT, 
   [COORD @D66544, 
      AGR [COUNT @D66543, PER @D66542, PLU @D66541, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : HIT, 
   [COORD @D66548, AGR [COUNT @D66547, PER @D66546, PLU @D66545, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, PAST +, ARITY 2] : HIT, 
   [COORD @D66552, AGR [COUNT @D66551, PER @D66550, PLU @D66549, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, PAST +, ARITY 2] : HIT, 
   [COORD @D66556, AGR [COUNT @D66555, PER @D66554, PLU @D66553, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, PAST +, ARITY 2] : HIT, 
   [COORD @D66560, AGR [COUNT @D66559, PER @D66558, PLU @D66557, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM AT, PAST +, ARITY 2] : HIT, 
   [COORD @D66564, AGR [COUNT @D66563, PER @D66562, PLU @D66561, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : HIT, 
   [COORD @D66567, AGR [COUNT @D66566, PER @D66565, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : HIT, 
   [COORD @D66569, AGR [COUNT @D66568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : HIT, 
   [COORD @D66571, AGR [COUNT @D66570, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : HIT, 
   [COORD @D66575, AGR [COUNT @D66574, PER @D66573, PLU @D66572, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : HIT, 
   [COORD @D66581, PAST @D66580, 
      AGR [CASE @D66579, COUNT @D66578, PER @D66577, PLU @D66576, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : HIT, 
   [COORD @D66587, PAST @D66586, AGR [CASE @D66585, COUNT @D66584, 
            PER @D66583, PLU @D66582, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : HIT, 
   [COORD @D66591, 
      AGR [COUNT @D66590, PER @D66589, PLU @D66588, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : HIT.

WORD hits : 
   [COORD @D66601, DEMON @D66600, REFL @D66599, PRD @D66598, CASE 
         @D66597, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HIT, 
   [COORD @D66603, 
      AGR [COUNT @D66602, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIT, 
   [COORD @D66605, 
      AGR [COUNT @D66604, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIT, 
   [COORD @D66607, 
      AGR [COUNT @D66606, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIT, 
   [COORD @D66609, 
      AGR [COUNT @D66608, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIT, 
   [COORD @D66611, 
      AGR [COUNT @D66610, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HIT, 
   [COORD @D66613, AGR [COUNT @D66612, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIT, 
   [COORD @D66615, 
      AGR [COUNT @D66614, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HIT.

WORD hitting : 
   [COORD @D66635, PRD @D66634, AGR [CASE @D66633, COUNT @D66632, 
            PER @D66631, PLU @D66630, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HIT, 
   [COORD @D66641, PRD @D66640, AGR 
         [CASE @D66639, COUNT @D66638, PER @D66637, PLU @D66636, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HIT, 
   [COORD @D66647, PRD @D66646, AGR [CASE @D66645, COUNT @D66644, 
            PER @D66643, PLU @D66642, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HIT, 
   [COORD @D66653, PRD @D66652, 
      AGR [CASE @D66651, COUNT @D66650, PER @D66649, PLU @D66648, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HIT, 
   [COORD @D66659, PRD @D66658, AGR [CASE @D66657, COUNT @D66656, 
            PER @D66655, PLU @D66654, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HIT, 
   [COORD @D66665, PRD @D66664, 
      AGR [CASE @D66663, COUNT @D66662, PER @D66661, PLU @D66660, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HIT, 
   [COORD @D66671, PRD @D66670, AGR [CASE @D66669, COUNT @D66668, 
            PER @D66667, PLU @D66666, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HIT.

WORD hold : 
   [COORD @D66679, REFL @D66678, COUNT @D66677, PRD @D66676, CASE 
         @D66675, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HOLD, 
   [COORD @D66682, 
      AGR [COUNT @D66681, PER @D66680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : 
   HOLD, 
   [COORD @D66684, AGR [COUNT @D66683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : HOLD, 
   [COORD @D66686, AGR [COUNT @D66685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : HOLD, 
   [COORD @D66690, AGR [COUNT @D66689, PER @D66688, PLU @D66687, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : HOLD, 
   [COORD @D66696, PAST @D66695, 
      AGR [CASE @D66694, COUNT @D66693, PER @D66692, PLU @D66691, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : 
   HOLD, 
   [COORD @D66699, AGR [COUNT @D66698, PER @D66697, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : HOLD, 
   [COORD @D66701, AGR [COUNT @D66700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : HOLD, 
   [COORD @D66703, AGR [COUNT @D66702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : HOLD, 
   [COORD @D66707, AGR [COUNT @D66706, PER @D66705, PLU @D66704, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : HOLD, 
   [COORD @D66713, PAST @D66712, 
      AGR [CASE @D66711, COUNT @D66710, PER @D66709, PLU @D66708, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   HOLD, 
   [COORD @D66716, AGR [COUNT @D66715, PER @D66714, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66718, AGR [COUNT @D66717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66720, AGR [COUNT @D66719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66724, AGR [COUNT @D66723, PER @D66722, PLU @D66721, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66730, PAST @D66729, 
      AGR [CASE @D66728, COUNT @D66727, PER @D66726, PLU @D66725, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : HOLD, 
   [COORD @D66733, AGR [COUNT @D66732, PER @D66731, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : HOLD, 
   [COORD @D66735, AGR [COUNT @D66734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : HOLD, 
   [COORD @D66737, AGR [COUNT @D66736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : HOLD, 
   [COORD @D66741, AGR [COUNT @D66740, PER @D66739, PLU @D66738, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OVER, ARITY 3] : HOLD, 
   [COORD @D66747, PAST @D66746, 
      AGR [CASE @D66745, COUNT @D66744, PER @D66743, PLU @D66742, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OVER, 
      ARITY 3] : HOLD, 
   [COORD @D66750, AGR [COUNT @D66749, PER @D66748, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, ARITY 3] : HOLD, 
   [COORD @D66752, AGR [COUNT @D66751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, ARITY 3] : HOLD, 
   [COORD @D66754, AGR [COUNT @D66753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, ARITY 3] : HOLD, 
   [COORD @D66758, AGR [COUNT @D66757, PER @D66756, PLU @D66755, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AGAINST, ARITY 3] : HOLD, 
   [COORD @D66764, PAST @D66763, 
      AGR [CASE @D66762, COUNT @D66761, PER @D66760, PLU @D66759, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM AGAINST, 
      ARITY 3] : HOLD, 
   [COORD @D66767, AGR [COUNT @D66766, PER @D66765, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66769, AGR [COUNT @D66768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66771, AGR [COUNT @D66770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66775, AGR [COUNT @D66774, PER @D66773, PLU @D66772, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66781, PAST @D66780, 
      AGR [CASE @D66779, COUNT @D66778, PER @D66777, PLU @D66776, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM TO, ARITY 3] : HOLD, 
   [COORD @D66784, AGR [COUNT @D66783, PER @D66782, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66786, AGR [COUNT @D66785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66788, AGR [COUNT @D66787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66792, AGR [COUNT @D66791, PER @D66790, PLU @D66789, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : HOLD, 
   [COORD @D66798, PAST @D66797, 
      AGR [CASE @D66796, COUNT @D66795, PER @D66794, PLU @D66793, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   HOLD, 
   [COORD @D66801, AGR [COUNT @D66800, PER @D66799, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66803, AGR [COUNT @D66802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66805, AGR [COUNT @D66804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66809, AGR [COUNT @D66808, PER @D66807, PLU @D66806, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, ARITY 2] : HOLD, 
   [COORD @D66815, PAST @D66814, 
      AGR [CASE @D66813, COUNT @D66812, PER @D66811, PLU @D66810, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, REG -, ARITY 2] : 
   HOLD, 
   [COORD @D66818, AGR [COUNT @D66817, PER @D66816, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66820, AGR [COUNT @D66819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66822, AGR [COUNT @D66821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66826, AGR [COUNT @D66825, PER @D66824, PLU @D66823, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, ARITY 2] : HOLD, 
   [COORD @D66832, PAST @D66831, 
      AGR [CASE @D66830, COUNT @D66829, PER @D66828, PLU @D66827, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, REG -, ARITY 2] : 
   HOLD, 
   [COORD @D66835, AGR [COUNT @D66834, PER @D66833, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66837, AGR [COUNT @D66836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66839, AGR [COUNT @D66838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66843, AGR [COUNT @D66842, PER @D66841, PLU @D66840, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, ARITY 2] : HOLD, 
   [COORD @D66849, PAST @D66848, 
      AGR [CASE @D66847, COUNT @D66846, PER @D66845, PLU @D66844, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, REG -, ARITY 2] : 
   HOLD, 
   [COORD @D66852, AGR [COUNT @D66851, PER @D66850, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HOLD, 
   [COORD @D66854, AGR [COUNT @D66853, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HOLD, 
   [COORD @D66856, AGR [COUNT @D66855, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : HOLD, 
   [COORD @D66860, AGR [COUNT @D66859, PER @D66858, PLU @D66857, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : HOLD, 
   [COORD @D66866, PAST @D66865, AGR [CASE @D66864, COUNT @D66863, 
            PER @D66862, PLU @D66861, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : HOLD, 
   [COORD @D66869, AGR [COUNT @D66868, PER @D66867, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : HOLD, 
   [COORD @D66871, AGR [COUNT @D66870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : HOLD, 
   [COORD @D66873, AGR [COUNT @D66872, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : HOLD, 
   [COORD @D66877, AGR [COUNT @D66876, PER @D66875, PLU @D66874, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : HOLD, 
   [COORD @D66883, PAST @D66882, AGR 
         [CASE @D66881, COUNT @D66880, PER @D66879, PLU @D66878, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : HOLD, 
   [COORD @D66886, AGR [COUNT @D66885, PER @D66884, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : HOLD, 
   [COORD @D66888, AGR [COUNT @D66887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : HOLD, 
   [COORD @D66890, AGR [COUNT @D66889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : HOLD, 
   [COORD @D66894, AGR [COUNT @D66893, PER @D66892, PLU @D66891, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : HOLD, 
   [COORD @D66900, PAST @D66899, AGR [CASE @D66898, COUNT @D66897, 
            PER @D66896, PLU @D66895, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : HOLD, 
   [COORD @D66903, 
      AGR [COUNT @D66902, PER @D66901, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ONTO, 
      ARITY 2] : HOLD, 
   [COORD @D66905, AGR [COUNT @D66904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, ARITY 2] : HOLD, 
   [COORD @D66907, AGR [COUNT @D66906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, ARITY 2] : HOLD, 
   [COORD @D66911, AGR [COUNT @D66910, PER @D66909, PLU @D66908, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ONTO, ARITY 2] : HOLD, 
   [COORD @D66917, PAST @D66916, AGR 
         [CASE @D66915, COUNT @D66914, PER @D66913, PLU @D66912, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ONTO, 
      ARITY 2] : HOLD, 
   [COORD @D66920, AGR [COUNT @D66919, PER @D66918, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66922, AGR [COUNT @D66921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66924, AGR [COUNT @D66923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66928, AGR [COUNT @D66927, PER @D66926, PLU @D66925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66934, PAST @D66933, 
      AGR [CASE @D66932, COUNT @D66931, PER @D66930, PLU @D66929, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66937, AGR [COUNT @D66936, PER @D66935, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT FORTH, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66939, AGR [COUNT @D66938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT FORTH, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66941, AGR [COUNT @D66940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT FORTH, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66945, AGR [COUNT @D66944, PER @D66943, PLU @D66942, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT FORTH, PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66951, PAST @D66950, 
      AGR [CASE @D66949, COUNT @D66948, PER @D66947, PLU @D66946, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT FORTH, 
      PFORM ON, ARITY 2] : HOLD, 
   [COORD @D66954, AGR [COUNT @D66953, PER @D66952, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM FROM, ARITY 2] : HOLD, 
   [COORD @D66956, AGR [COUNT @D66955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM FROM, ARITY 2] : HOLD, 
   [COORD @D66958, AGR [COUNT @D66957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM FROM, ARITY 2] : HOLD, 
   [COORD @D66962, AGR [COUNT @D66961, PER @D66960, PLU @D66959, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OFF, PFORM FROM, ARITY 2] : HOLD, 
   [COORD @D66968, PAST @D66967, 
      AGR [CASE @D66966, COUNT @D66965, PER @D66964, PLU @D66963, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM FROM, ARITY 2] : HOLD, 
   [COORD @D66971, AGR [COUNT @D66970, PER @D66969, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : HOLD, 
   [COORD @D66973, AGR [COUNT @D66972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : HOLD, 
   [COORD @D66975, AGR [COUNT @D66974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : HOLD, 
   [COORD @D66979, AGR [COUNT @D66978, PER @D66977, PLU @D66976, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM FOR, ARITY 2] : HOLD, 
   [COORD @D66985, PAST @D66984, 
      AGR [CASE @D66983, COUNT @D66982, PER @D66981, PLU @D66980, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, ARITY 2] : HOLD, 
   [COORD @D66988, AGR [COUNT @D66987, PER @D66986, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : HOLD, 
   [COORD @D66990, AGR [COUNT @D66989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : HOLD, 
   [COORD @D66992, AGR [COUNT @D66991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : HOLD, 
   [COORD @D66996, AGR [COUNT @D66995, PER @D66994, PLU @D66993, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BY, ARITY 2] : HOLD, 
   [COORD @D67002, PAST @D67001, AGR [CASE @D67000, COUNT @D66999, 
            PER @D66998, PLU @D66997, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BY, ARITY 2] : HOLD, 
   [COORD @D67005, 
      AGR [COUNT @D67004, PER @D67003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : HOLD, 
   [COORD @D67007, AGR [COUNT @D67006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : HOLD, 
   [COORD @D67009, AGR [COUNT @D67008, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : HOLD, 
   [COORD @D67013, AGR [COUNT @D67012, PER @D67011, PLU @D67010, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : HOLD, 
   [COORD @D67019, PAST @D67018, 
      AGR [CASE @D67017, COUNT @D67016, PER @D67015, PLU @D67014, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : HOLD, 
   [COORD @D67022, AGR [COUNT @D67021, PER @D67020, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : HOLD, 
   [COORD @D67024, AGR [COUNT @D67023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : HOLD, 
   [COORD @D67026, AGR [COUNT @D67025, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : HOLD, 
   [COORD @D67030, AGR [COUNT @D67029, PER @D67028, PLU @D67027, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TOGETHER, ARITY 2] : HOLD, 
   [COORD @D67036, PAST @D67035, 
      AGR [CASE @D67034, COUNT @D67033, PER @D67032, PLU @D67031, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : HOLD, 
   [COORD @D67039, AGR [COUNT @D67038, PER @D67037, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : HOLD, 
   [COORD @D67041, AGR [COUNT @D67040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : HOLD, 
   [COORD @D67043, AGR [COUNT @D67042, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : HOLD, 
   [COORD @D67047, AGR [COUNT @D67046, PER @D67045, PLU @D67044, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : HOLD, 
   [COORD @D67053, PAST @D67052, 
      AGR [CASE @D67051, COUNT @D67050, PER @D67049, PLU @D67048, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : HOLD, 
   [COORD @D67056, AGR [COUNT @D67055, PER @D67054, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : HOLD, 
   [COORD @D67058, AGR [COUNT @D67057, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : HOLD, 
   [COORD @D67060, AGR [COUNT @D67059, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : HOLD, 
   [COORD @D67064, AGR [COUNT @D67063, PER @D67062, PLU @D67061, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : HOLD, 
   [COORD @D67070, PAST @D67069, 
      AGR [CASE @D67068, COUNT @D67067, PER @D67066, PLU @D67065, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : HOLD, 
   [COORD @D67073, AGR [COUNT @D67072, PER @D67071, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : HOLD, 
   [COORD @D67075, AGR [COUNT @D67074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : HOLD, 
   [COORD @D67077, AGR [COUNT @D67076, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : HOLD, 
   [COORD @D67081, AGR [COUNT @D67080, PER @D67079, PLU @D67078, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : HOLD, 
   [COORD @D67087, PAST @D67086, 
      AGR [CASE @D67085, COUNT @D67084, PER @D67083, PLU @D67082, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : HOLD, 
   [COORD @D67090, AGR [COUNT @D67089, PER @D67088, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : HOLD, 
   [COORD @D67092, AGR [COUNT @D67091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : HOLD, 
   [COORD @D67094, AGR [COUNT @D67093, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : HOLD, 
   [COORD @D67098, AGR [COUNT @D67097, PER @D67096, PLU @D67095, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : HOLD, 
   [COORD @D67104, PAST @D67103, 
      AGR [CASE @D67102, COUNT @D67101, PER @D67100, PLU @D67099, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : HOLD, 
   [COORD @D67107, AGR [COUNT @D67106, PER @D67105, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : HOLD, 
   [COORD @D67109, AGR [COUNT @D67108, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : HOLD, 
   [COORD @D67111, AGR [COUNT @D67110, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : HOLD, 
   [COORD @D67115, AGR [COUNT @D67114, PER @D67113, PLU @D67112, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : HOLD, 
   [COORD @D67121, PAST @D67120, 
      AGR [CASE @D67119, COUNT @D67118, PER @D67117, PLU @D67116, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : HOLD, 
   [COORD @D67124, AGR [COUNT @D67123, PER @D67122, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HOLD, 
   [COORD @D67126, AGR [COUNT @D67125, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HOLD, 
   [COORD @D67128, AGR [COUNT @D67127, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : HOLD, 
   [COORD @D67132, AGR [COUNT @D67131, PER @D67130, PLU @D67129, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : HOLD, 
   [COORD @D67138, PAST @D67137, 
      AGR [CASE @D67136, COUNT @D67135, PER @D67134, PLU @D67133, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   HOLD, 
   [COORD @D67141, AGR [COUNT @D67140, PER @D67139, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : HOLD, 
   [COORD @D67143, AGR [COUNT @D67142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : HOLD, 
   [COORD @D67145, AGR [COUNT @D67144, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : HOLD, 
   [COORD @D67149, AGR [COUNT @D67148, PER @D67147, PLU @D67146, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : HOLD, 
   [COORD @D67155, PAST @D67154, 
      AGR [CASE @D67153, COUNT @D67152, PER @D67151, PLU @D67150, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : HOLD, 
   [COORD @D67158, AGR [COUNT @D67157, PER @D67156, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : HOLD, 
   [COORD @D67160, AGR [COUNT @D67159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : HOLD, 
   [COORD @D67162, AGR [COUNT @D67161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : HOLD, 
   [COORD @D67166, AGR [COUNT @D67165, PER @D67164, PLU @D67163, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, ARITY 1] : HOLD, 
   [COORD @D67172, PAST @D67171, 
      AGR [CASE @D67170, COUNT @D67169, PER @D67168, PLU @D67167, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TOGETHER, 
      ARITY 1] : HOLD, 
   [COORD @D67175, AGR [COUNT @D67174, PER @D67173, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : HOLD, 
   [COORD @D67177, AGR [COUNT @D67176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : HOLD, 
   [COORD @D67179, AGR [COUNT @D67178, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : HOLD, 
   [COORD @D67183, AGR [COUNT @D67182, PER @D67181, PLU @D67180, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : HOLD, 
   [COORD @D67189, PAST @D67188, 
      AGR [CASE @D67187, COUNT @D67186, PER @D67185, PLU @D67184, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : HOLD, 
   [COORD @D67192, AGR [COUNT @D67191, PER @D67190, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : HOLD, 
   [COORD @D67194, AGR [COUNT @D67193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : HOLD, 
   [COORD @D67196, AGR [COUNT @D67195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : HOLD, 
   [COORD @D67200, AGR [COUNT @D67199, PER @D67198, PLU @D67197, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : HOLD, 
   [COORD @D67206, PAST @D67205, 
      AGR [CASE @D67204, COUNT @D67203, PER @D67202, PLU @D67201, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : HOLD, 
   [COORD @D67209, AGR [COUNT @D67208, PER @D67207, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : HOLD, 
   [COORD @D67211, AGR [COUNT @D67210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : HOLD, 
   [COORD @D67213, AGR [COUNT @D67212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : HOLD, 
   [COORD @D67217, AGR [COUNT @D67216, PER @D67215, PLU @D67214, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : HOLD, 
   [COORD @D67223, PAST @D67222, 
      AGR [CASE @D67221, COUNT @D67220, PER @D67219, PLU @D67218, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : HOLD, 
   [COORD @D67226, AGR [COUNT @D67225, PER @D67224, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : HOLD, 
   [COORD @D67228, AGR [COUNT @D67227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : HOLD, 
   [COORD @D67230, AGR [COUNT @D67229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : HOLD, 
   [COORD @D67234, AGR [COUNT @D67233, PER @D67232, PLU @D67231, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : HOLD, 
   [COORD @D67240, PAST @D67239, 
      AGR [CASE @D67238, COUNT @D67237, PER @D67236, PLU @D67235, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : HOLD, 
   [COORD @D67243, AGR [COUNT @D67242, PER @D67241, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : HOLD, 
   [COORD @D67245, AGR [COUNT @D67244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : HOLD, 
   [COORD @D67247, AGR [COUNT @D67246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : HOLD, 
   [COORD @D67251, AGR [COUNT @D67250, PER @D67249, PLU @D67248, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORTH, ARITY 1] : HOLD, 
   [COORD @D67257, PAST @D67256, 
      AGR [CASE @D67255, COUNT @D67254, PER @D67253, PLU @D67252, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FORTH, 
      ARITY 1] : HOLD, 
   [COORD @D67260, AGR [COUNT @D67259, PER @D67258, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : HOLD, 
   [COORD @D67262, AGR [COUNT @D67261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : HOLD, 
   [COORD @D67264, AGR [COUNT @D67263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : HOLD, 
   [COORD @D67268, AGR [COUNT @D67267, PER @D67266, PLU @D67265, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : HOLD, 
   [COORD @D67274, PAST @D67273, 
      AGR [CASE @D67272, COUNT @D67271, PER @D67270, PLU @D67269, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : HOLD, 
   [COORD @D67277, AGR [COUNT @D67276, PER @D67275, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : HOLD, 
   [COORD @D67279, AGR [COUNT @D67278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : HOLD, 
   [COORD @D67281, AGR [COUNT @D67280, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : HOLD, 
   [COORD @D67285, AGR [COUNT @D67284, PER @D67283, PLU @D67282, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : HOLD, 
   [COORD @D67291, PAST @D67290, 
      AGR [CASE @D67289, COUNT @D67288, PER @D67287, PLU @D67286, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : HOLD.

WORD holding : 
   [COORD @D67309, REFL @D67308, PRD @D67307, CASE @D67306, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HOLDING, 
   [COORD @D67315, PRD @D67314, 
      AGR [CASE @D67313, COUNT @D67312, PER @D67311, PLU @D67310, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67321, PRD @D67320, AGR [CASE @D67319, COUNT @D67318, 
            PER @D67317, PLU @D67316, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67327, PRD @D67326, 
      AGR [CASE @D67325, COUNT @D67324, PER @D67323, PLU @D67322, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HOLD, 
   [COORD @D67333, PRD @D67332, AGR [CASE @D67331, COUNT @D67330, 
            PER @D67329, PLU @D67328, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM OVER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67339, PRD @D67338, 
      AGR [CASE @D67337, COUNT @D67336, PER @D67335, PLU @D67334, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HOLD, 
   [COORD @D67345, PRD @D67344, AGR [CASE @D67343, COUNT @D67342, 
            PER @D67341, PLU @D67340, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67351, PRD @D67350, 
      AGR [CASE @D67349, COUNT @D67348, PER @D67347, PLU @D67346, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67357, PRD @D67356, AGR [CASE @D67355, COUNT @D67354, 
            PER @D67353, PLU @D67352, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67363, PRD @D67362, 
      AGR [CASE @D67361, COUNT @D67360, PER @D67359, PLU @D67358, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67369, PRD @D67368, AGR [CASE @D67367, COUNT @D67366, 
            PER @D67365, PLU @D67364, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67375, PRD @D67374, 
      AGR [CASE @D67373, COUNT @D67372, PER @D67371, PLU @D67370, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67381, PRD @D67380, AGR [CASE @D67379, COUNT @D67378, 
            PER @D67377, PLU @D67376, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67387, PRD @D67386, 
      AGR [CASE @D67385, COUNT @D67384, PER @D67383, PLU @D67382, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOLD, 
   [COORD @D67393, PRD @D67392, AGR [CASE @D67391, COUNT @D67390, 
            PER @D67389, PLU @D67388, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67399, PRD @D67398, 
      AGR [CASE @D67397, COUNT @D67396, PER @D67395, PLU @D67394, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HOLD, 
   [COORD @D67405, PRD @D67404, AGR [CASE @D67403, COUNT @D67402, 
            PER @D67401, PLU @D67400, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT FORTH, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67411, PRD @D67410, 
      AGR [CASE @D67409, COUNT @D67408, PER @D67407, PLU @D67406, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OFF, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HOLD, 
   [COORD @D67417, PRD @D67416, AGR [CASE @D67415, COUNT @D67414, 
            PER @D67413, PLU @D67412, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67423, PRD @D67422, 
      AGR [CASE @D67421, COUNT @D67420, PER @D67419, PLU @D67418, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOLD, 
   [COORD @D67429, PRD @D67428, AGR [CASE @D67427, COUNT @D67426, 
            PER @D67425, PLU @D67424, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67435, PRD @D67434, 
      AGR [CASE @D67433, COUNT @D67432, PER @D67431, PLU @D67430, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HOLD, 
   [COORD @D67441, PRD @D67440, AGR [CASE @D67439, COUNT @D67438, 
            PER @D67437, PLU @D67436, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67447, PRD @D67446, 
      AGR [CASE @D67445, COUNT @D67444, PER @D67443, PLU @D67442, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOLD, 
   [COORD @D67453, PRD @D67452, AGR [CASE @D67451, COUNT @D67450, 
            PER @D67449, PLU @D67448, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67459, PRD @D67458, 
      AGR [CASE @D67457, COUNT @D67456, PER @D67455, PLU @D67454, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOLD, 
   [COORD @D67465, PRD @D67464, AGR [CASE @D67463, COUNT @D67462, 
            PER @D67461, PLU @D67460, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67471, PRD @D67470, 
      AGR [CASE @D67469, COUNT @D67468, PER @D67467, PLU @D67466, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67477, PRD @D67476, AGR [CASE @D67475, COUNT @D67474, 
            PER @D67473, PLU @D67472, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67483, PRD @D67482, 
      AGR [CASE @D67481, COUNT @D67480, PER @D67479, PLU @D67478, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HOLD, 
   [COORD @D67489, PRD @D67488, AGR [CASE @D67487, COUNT @D67486, 
            PER @D67485, PLU @D67484, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67495, PRD @D67494, 
      AGR [CASE @D67493, COUNT @D67492, PER @D67491, PLU @D67490, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOLD, 
   [COORD @D67501, PRD @D67500, AGR [CASE @D67499, COUNT @D67498, 
            PER @D67497, PLU @D67496, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67507, PRD @D67506, 
      AGR [CASE @D67505, COUNT @D67504, PER @D67503, PLU @D67502, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOLD, 
   [COORD @D67513, PRD @D67512, AGR [CASE @D67511, COUNT @D67510, 
            PER @D67509, PLU @D67508, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD, 
   [COORD @D67519, PRD @D67518, 
      AGR [CASE @D67517, COUNT @D67516, PER @D67515, PLU @D67514, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOLD, 
   [COORD @D67525, PRD @D67524, AGR [CASE @D67523, COUNT @D67522, 
            PER @D67521, PLU @D67520, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : HOLD.

WORD holdings : 
   [COORD @D67542, DEMON @D67541, REFL @D67540, PRD @D67539, 
      CASE @D67538, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HOLDING.

WORD holds : 
   [COORD @D67552, DEMON @D67551, REFL @D67550, PRD @D67549, CASE 
         @D67548, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HOLD, 
   [COORD @D67554, 
      AGR [COUNT @D67553, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67556, 
      AGR [COUNT @D67555, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67558, 
      AGR [COUNT @D67557, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67560, 
      AGR [COUNT @D67559, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67562, AGR [COUNT @D67561, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : HOLD, 
   [COORD @D67564, AGR [COUNT @D67563, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HOLD, 
   [COORD @D67566, AGR [COUNT @D67565, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67568, 
      AGR [COUNT @D67567, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67570, 
      AGR [COUNT @D67569, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67572, 
      AGR [COUNT @D67571, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67574, 
      AGR [COUNT @D67573, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67576, 
      AGR [COUNT @D67575, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67578, 
      AGR [COUNT @D67577, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67580, 
      AGR [COUNT @D67579, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67582, 
      AGR [COUNT @D67581, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67584, AGR [COUNT @D67583, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT FORTH, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67586, AGR [COUNT @D67585, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OFF, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67588, AGR [COUNT @D67587, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : HOLD, 
   [COORD @D67590, AGR [COUNT @D67589, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : HOLD, 
   [COORD @D67592, AGR [COUNT @D67591, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67594, 
      AGR [COUNT @D67593, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67596, 
      AGR [COUNT @D67595, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67598, 
      AGR [COUNT @D67597, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67600, 
      AGR [COUNT @D67599, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67602, 
      AGR [COUNT @D67601, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67604, 
      AGR [COUNT @D67603, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67606, 
      AGR [COUNT @D67605, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67608, 
      AGR [COUNT @D67607, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67610, 
      AGR [COUNT @D67609, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   HOLD, 
   [COORD @D67612, AGR [COUNT @D67611, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67614, 
      AGR [COUNT @D67613, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67616, 
      AGR [COUNT @D67615, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67618, 
      AGR [COUNT @D67617, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67620, 
      AGR [COUNT @D67619, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67622, 
      AGR [COUNT @D67621, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD, 
   [COORD @D67624, 
      AGR [COUNT @D67623, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOLD.

WORD hop : 
   [COORD @D67631, REFL @D67630, PRD @D67629, CASE @D67628, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HOP, 
   [COORD @D67635, REFL @D67634, PRD @D67633, CASE @D67632, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HOP, 
   [COORD @D67639, REFL @D67638, PRD @D67637, CASE @D67636, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HOP, 
   [COORD @D67642, 
      AGR [COUNT @D67641, PER @D67640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : HOP, 
   
   [COORD @D67644, AGR [COUNT @D67643, N +, V -, BAR 2, NFORM NORM, CASE 
            NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, 
      V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HOP, 
   [COORD @D67646, AGR [COUNT @D67645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HOP, 
   [COORD @D67650, AGR [COUNT @D67649, PER @D67648, PLU @D67647, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : HOP, 
   [COORD @D67656, PAST @D67655, AGR [CASE @D67654, COUNT @D67653, 
            PER @D67652, PLU @D67651, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : HOP, 
   [COORD @D67659, AGR [COUNT @D67658, PER @D67657, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOP, 
   [COORD @D67661, AGR [COUNT @D67660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOP, 
   [COORD @D67663, AGR [COUNT @D67662, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOP, 
   [COORD @D67667, AGR [COUNT @D67666, PER @D67665, PLU @D67664, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOP, 
   [COORD @D67673, PAST @D67672, AGR [CASE @D67671, COUNT @D67670, 
            PER @D67669, PLU @D67668, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : HOP.

WORD hope : 
   [COORD @D67685, REFL @D67684, COUNT @D67683, PRD @D67682, CASE 
         @D67681, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : HOPE, 
   [COORD @D67690, REFL @D67689, COUNT @D67688, PRD @D67687, 
      CASE @D67686, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN] : HOPE, 
   [COORD @D67693, 
      AGR [COUNT @D67692, PER @D67691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, ARITY 2] : 
   HOPE, 
   [COORD @D67695, AGR [COUNT @D67694, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : HOPE, 
   [COORD @D67697, AGR [COUNT @D67696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : HOPE, 
   [COORD @D67701, AGR [COUNT @D67700, PER @D67699, PLU @D67698, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : HOPE, 
   [COORD @D67707, PAST @D67706, AGR [CASE @D67705, COUNT @D67704, 
            PER @D67703, PLU @D67702, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SINF, ARITY 2] : HOPE, 
   [COORD @D67710, AGR [COUNT @D67709, PER @D67708, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : HOPE, 
   [COORD @D67712, AGR [COUNT @D67711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : HOPE, 
   [COORD @D67714, AGR [COUNT @D67713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : HOPE, 
   [COORD @D67718, AGR [COUNT @D67717, PER @D67716, PLU @D67715, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : HOPE, 
   [COORD @D67724, PAST @D67723, AGR [CASE @D67722, COUNT @D67721, 
            PER @D67720, PLU @D67719, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : HOPE, 
   [COORD @D67727, AGR [COUNT @D67726, PER @D67725, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : HOPE, 
   [COORD @D67729, AGR [COUNT @D67728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : HOPE, 
   [COORD @D67731, AGR [COUNT @D67730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : HOPE, 
   [COORD @D67735, AGR [COUNT @D67734, PER @D67733, PLU @D67732, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : HOPE, 
   [COORD @D67741, PAST @D67740, AGR [CASE @D67739, COUNT @D67738, 
            PER @D67737, PLU @D67736, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : HOPE, 
   [COORD @D67744, AGR [COUNT @D67743, PER @D67742, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : HOPE, 
   [COORD @D67746, AGR [COUNT @D67745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : HOPE, 
   [COORD @D67748, AGR [COUNT @D67747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : HOPE, 
   [COORD @D67752, AGR [COUNT @D67751, PER @D67750, PLU @D67749, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : HOPE, 
   [COORD @D67758, PAST @D67757, 
      AGR [CASE @D67756, COUNT @D67755, PER @D67754, PLU @D67753, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : HOPE, 
   [COORD @D67761, AGR [COUNT @D67760, PER @D67759, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOPE, 
   [COORD @D67763, AGR [COUNT @D67762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOPE, 
   [COORD @D67765, AGR [COUNT @D67764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOPE, 
   [COORD @D67769, AGR [COUNT @D67768, PER @D67767, PLU @D67766, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : HOPE, 
   [COORD @D67775, PAST @D67774, AGR [CASE @D67773, COUNT @D67772, 
            PER @D67771, PLU @D67770, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : HOPE.

WORD hoped : 
   [COORD @D67789, AGR [CASE @D67788, COUNT @D67787, PER @D67786, 
            PLU @D67785, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOP, 
   [COORD @D67794, AGR [CASE @D67793, COUNT @D67792, PER @D67791, 
            PLU @D67790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOP, 
   [COORD @D67799, AGR [CASE @D67798, COUNT @D67797, PER @D67796, 
            PLU @D67795, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HOP, 
   [COORD @D67804, AGR [CASE @D67803, COUNT @D67802, PER @D67801, 
            PLU @D67800, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOP, 
   [COORD @D67809, AGR [CASE @D67808, COUNT @D67807, PER @D67806, 
            PLU @D67805, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOP, 
   [COORD @D67814, AGR [CASE @D67813, COUNT @D67812, PER @D67811, 
            PLU @D67810, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67819, AGR [CASE @D67818, COUNT @D67817, PER @D67816, 
            PLU @D67815, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67824, AGR [CASE @D67823, COUNT @D67822, PER @D67821, 
            PLU @D67820, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67829, AGR [CASE @D67828, COUNT @D67827, PER @D67826, 
            PLU @D67825, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67834, AGR [UB @D67833, VFORM @D67832, SUBJ @D67831, 
            FIN @D67830, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : HOPE, 
   [COORD @D67839, AGR [CASE @D67838, COUNT @D67837, PER @D67836, 
            PLU @D67835, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67844, AGR [CASE @D67843, COUNT @D67842, PER @D67841, 
            PLU @D67840, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67849, AGR [CASE @D67848, COUNT @D67847, PER @D67846, 
            PLU @D67845, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67854, AGR [CASE @D67853, COUNT @D67852, PER @D67851, 
            PLU @D67850, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67859, AGR [CASE @D67858, COUNT @D67857, PER @D67856, 
            PLU @D67855, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67864, AGR [CASE @D67863, COUNT @D67862, PER @D67861, 
            PLU @D67860, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOPE.

WORD hopes : 
   [COORD @D67878, DEMON @D67877, REFL @D67876, PRD @D67875, CASE 
         @D67874, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HOPE, 
   [COORD @D67883, DEMON @D67882, REFL @D67881, PRD @D67880, 
      CASE @D67879, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SFIN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HOPE, 
   [COORD @D67885, 
      AGR [COUNT @D67884, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOPE, 
   [COORD @D67887, 
      AGR [COUNT @D67886, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOPE, 
   [COORD @D67889, 
      AGR [COUNT @D67888, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOPE, 
   [COORD @D67891, 
      AGR [COUNT @D67890, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOPE, 
   [COORD @D67893, 
      AGR [COUNT @D67892, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOPE.

WORD hoping : 
   [COORD @D67910, PRD @D67909, AGR [CASE @D67908, COUNT @D67907, 
            PER @D67906, PLU @D67905, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOP, 
   [COORD @D67916, PRD @D67915, AGR 
         [CASE @D67914, COUNT @D67913, PER @D67912, PLU @D67911, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HOP, 
   
   [COORD @D67922, PRD @D67921, AGR [CASE @D67920, COUNT @D67919, PER 
               @D67918, PLU @D67917, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67928, PRD @D67927, 
      AGR [CASE @D67926, COUNT @D67925, PER @D67924, PLU @D67923, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HOPE, 
   [COORD @D67934, PRD @D67933, AGR [CASE @D67932, COUNT @D67931, 
            PER @D67930, PLU @D67929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOPE, 
   [COORD @D67940, PRD @D67939, 
      AGR [CASE @D67938, COUNT @D67937, PER @D67936, PLU @D67935, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : HOPE, 
   [COORD @D67946, PRD @D67945, AGR [CASE @D67944, COUNT @D67943, 
            PER @D67942, PLU @D67941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOPE.

WORD hopped : 
   [COORD @D67958, AGR [CASE @D67957, COUNT @D67956, PER @D67955, 
            PLU @D67954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOP, 
   [COORD @D67963, AGR [CASE @D67962, COUNT @D67961, PER @D67960, 
            PLU @D67959, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOP, 
   [COORD @D67968, AGR [CASE @D67967, COUNT @D67966, PER @D67965, 
            PLU @D67964, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HOP, 
   [COORD @D67973, AGR [CASE @D67972, COUNT @D67971, PER @D67970, 
            PLU @D67969, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOP, 
   [COORD @D67978, AGR [CASE @D67977, COUNT @D67976, PER @D67975, 
            PLU @D67974, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOP.

WORD hopping : 
   [COORD @D67991, PRD @D67990, AGR [CASE @D67989, COUNT @D67988, 
            PER @D67987, PLU @D67986, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : HOP, 
   [COORD @D67997, PRD @D67996, AGR 
         [CASE @D67995, COUNT @D67994, PER @D67993, PLU @D67992, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : HOP.

WORD hops : 
   [COORD @D68009, DEMON @D68008, REFL @D68007, PRD @D68006, CASE 
         @D68005, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : HOP, 
   [COORD @D68014, DEMON @D68013, REFL @D68012, PRD @D68011, 
      CASE @D68010, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : HOP, 
   [COORD @D68016, AGR [COUNT @D68015, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOP, 
   [COORD @D68018, 
      AGR [COUNT @D68017, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOP.

WORD house : 
   [COORD @D68029, REFL @D68028, PRD @D68027, CASE @D68026, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : HOUSE, 
   [COORD @D68032, 
      AGR [COUNT @D68031, PER @D68030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   HOUSE, 
   [COORD @D68034, AGR [COUNT @D68033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HOUSE, 
   [COORD @D68036, AGR [COUNT @D68035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : HOUSE, 
   [COORD @D68040, AGR [COUNT @D68039, PER @D68038, PLU @D68037, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : HOUSE, 
   [COORD @D68046, PAST @D68045, AGR [CASE @D68044, COUNT @D68043, 
            PER @D68042, PLU @D68041, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : HOUSE.

WORD housed : 
   [COORD @D68058, AGR [CASE @D68057, COUNT @D68056, PER @D68055, 
            PLU @D68054, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : HOUSE, 
   [COORD @D68063, AGR [CASE @D68062, COUNT @D68061, PER @D68060, 
            PLU @D68059, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : HOUSE, 
   [COORD @D68068, AGR [CASE @D68067, COUNT @D68066, PER @D68065, 
            PLU @D68064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : HOUSE.

WORD houses : 
   [COORD @D68077, AGR [COUNT @D68076, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : HOUSE.

WORD housing : 
   [COORD @D68088, REFL @D68087, PRD @D68086, CASE @D68085, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : HOUSING, 
   [COORD @D68094, PRD @D68093, 
      AGR [CASE @D68092, COUNT @D68091, PER @D68090, PLU @D68089, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   HOUSE.

WORD hung : 
   [COORD @D68110, PAST @D68109, AGR [CASE @D68108, COUNT @D68107, 
            PER @D68106, PLU @D68105, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : HANG, 
   [COORD @D68116, PAST @D68115, 
      AGR [CASE @D68114, COUNT @D68113, PER @D68112, PLU @D68111, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : 
   HANG, 
   [COORD @D68122, PAST @D68121, AGR [CASE @D68120, COUNT @D68119, 
            PER @D68118, PLU @D68117, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM ON, FIN -, ARITY 3] : HANG, 
   [COORD @D68128, PAST @D68127, 
      AGR [CASE @D68126, COUNT @D68125, PER @D68124, PLU @D68123, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM ON, FIN -, ARITY 3] : HANG, 
   [COORD @D68132, AGR [COUNT @D68131, PER @D68130, PLU @D68129, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : HANG, 
   [COORD @D68136, AGR [COUNT @D68135, PER @D68134, PLU @D68133, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM ON, PAST +, ARITY 3] : HANG, 
   [COORD @D68142, PAST @D68141, 
      AGR [CASE @D68140, COUNT @D68139, PER @D68138, PLU @D68137, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68148, PAST @D68147, AGR [CASE @D68146, COUNT @D68145, 
            PER @D68144, PLU @D68143, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : HANG, 
   [COORD @D68154, PAST @D68153, 
      AGR [CASE @D68152, COUNT @D68151, PER @D68150, PLU @D68149, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, FIN -, ARITY 2] : HANG, 
   [COORD @D68160, PAST @D68159, 
      AGR [CASE @D68158, COUNT @D68157, PER @D68156, PLU @D68155, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, PREP UPON, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68166, PAST @D68165, AGR [CASE @D68164, COUNT @D68163, 
            PER @D68162, PLU @D68161, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PREP ON, FIN -, ARITY 2] : HANG, 
   [COORD @D68172, PAST @D68171, 
      AGR [CASE @D68170, COUNT @D68169, PER @D68168, PLU @D68167, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM UPON, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68178, PAST @D68177, AGR [CASE @D68176, COUNT @D68175, 
            PER @D68174, PLU @D68173, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM UPON, FIN -, ARITY 2] : HANG, 
   [COORD @D68184, PAST @D68183, 
      AGR [CASE @D68182, COUNT @D68181, PER @D68180, PLU @D68179, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, PFORM TO, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68190, PAST @D68189, AGR [CASE @D68188, COUNT @D68187, 
            PER @D68186, PLU @D68185, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM OVER, FIN -, ARITY 2] : HANG, 
   [COORD @D68196, PAST @D68195, 
      AGR [CASE @D68194, COUNT @D68193, PER @D68192, PLU @D68191, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OVER, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68202, PAST @D68201, AGR [CASE @D68200, COUNT @D68199, 
            PER @D68198, PLU @D68197, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ONTO, FIN -, ARITY 2] : HANG, 
   [COORD @D68208, PAST @D68207, 
      AGR [CASE @D68206, COUNT @D68205, PER @D68204, PLU @D68203, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ONTO, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68214, PAST @D68213, AGR [CASE @D68212, COUNT @D68211, 
            PER @D68210, PLU @D68209, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ON, FIN -, ARITY 2] : HANG, 
   [COORD @D68220, PAST @D68219, 
      AGR [CASE @D68218, COUNT @D68217, PER @D68216, PLU @D68215, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68226, PAST @D68225, AGR [CASE @D68224, COUNT @D68223, 
            PER @D68222, PLU @D68221, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM IN, FIN -, ARITY 2] : HANG, 
   [COORD @D68232, PAST @D68231, 
      AGR [CASE @D68230, COUNT @D68229, PER @D68228, PLU @D68227, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, PFORM FROM, 
      FIN -, ARITY 2] : HANG, 
   [COORD @D68238, PAST @D68237, AGR [CASE @D68236, COUNT @D68235, 
            PER @D68234, PLU @D68233, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM AT, FIN -, ARITY 2] : HANG, 
   [COORD @D68244, PAST @D68243, 
      AGR [CASE @D68242, COUNT @D68241, PER @D68240, PLU @D68239, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM AROUND, 
      FIN -, ARITY 2] : HANG, 
   [COORD @D68250, PAST @D68249, AGR [CASE @D68248, COUNT @D68247, 
            PER @D68246, PLU @D68245, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM AROUND, FIN -, ARITY 2] : HANG, 
   [COORD @D68256, PAST @D68255, 
      AGR [CASE @D68254, COUNT @D68253, PER @D68252, PLU @D68251, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ABOUT, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68262, PAST @D68261, AGR [CASE @D68260, COUNT @D68259, 
            PER @D68258, PLU @D68257, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ABOUT, FIN -, ARITY 2] : HANG, 
   [COORD @D68268, PAST @D68267, 
      AGR [CASE @D68266, COUNT @D68265, PER @D68264, PLU @D68263, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : HANG, 
   [COORD @D68274, PAST @D68273, AGR [CASE @D68272, COUNT @D68271, 
            PER @D68270, PLU @D68269, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : HANG, 
   [COORD @D68278, 
      AGR [COUNT @D68277, PER @D68276, PLU @D68275, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : HANG, 
   [COORD @D68282, AGR [COUNT @D68281, PER @D68280, PLU @D68279, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, 
      PAST +, ARITY 2] : HANG, 
   [COORD @D68286, AGR [COUNT @D68285, PER @D68284, PLU @D68283, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP UPON, PAST +, ARITY 2] : HANG, 
   [COORD @D68290, AGR [COUNT @D68289, PER @D68288, PLU @D68287, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PREP ON, PAST +, ARITY 2] : HANG, 
   [COORD @D68294, AGR [COUNT @D68293, PER @D68292, PLU @D68291, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, PAST +, ARITY 2] : HANG, 
   [COORD @D68298, AGR [COUNT @D68297, PER @D68296, PLU @D68295, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM TO, PAST +, ARITY 2] : HANG, 
   [COORD @D68302, AGR [COUNT @D68301, PER @D68300, PLU @D68299, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OVER, PAST +, ARITY 2] : HANG, 
   [COORD @D68306, AGR [COUNT @D68305, PER @D68304, PLU @D68303, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ONTO, PAST +, ARITY 2] : HANG, 
   [COORD @D68310, AGR [COUNT @D68309, PER @D68308, PLU @D68307, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, PAST +, ARITY 2] : HANG, 
   [COORD @D68314, AGR [COUNT @D68313, PER @D68312, PLU @D68311, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM IN, PAST +, ARITY 2] : HANG, 
   [COORD @D68318, AGR [COUNT @D68317, PER @D68316, PLU @D68315, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM FROM, PAST +, ARITY 2] : HANG, 
   [COORD @D68322, AGR [COUNT @D68321, PER @D68320, PLU @D68319, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM AT, PAST +, ARITY 2] : HANG, 
   [COORD @D68326, AGR [COUNT @D68325, PER @D68324, PLU @D68323, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AROUND, PAST +, ARITY 2] : HANG, 
   [COORD @D68330, AGR [COUNT @D68329, PER @D68328, PLU @D68327, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, PAST +, ARITY 2] : HANG, 
   [COORD @D68334, AGR [COUNT @D68333, PER @D68332, PLU @D68331, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : HANG, 
   [COORD @D68340, PAST @D68339, AGR [CASE @D68338, COUNT @D68337, 
            PER @D68336, PLU @D68335, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : HANG, 
   [COORD @D68346, PAST @D68345, 
      AGR [CASE @D68344, COUNT @D68343, PER @D68342, PLU @D68341, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : HANG, 
   [COORD @D68352, PAST @D68351, AGR [CASE @D68350, COUNT @D68349, 
            PER @D68348, PLU @D68347, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, FIN -, ARITY 1] : HANG, 
   [COORD @D68358, PAST @D68357, 
      AGR [CASE @D68356, COUNT @D68355, PER @D68354, PLU @D68353, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, FIN -, 
      ARITY 1] : HANG, 
   [COORD @D68364, PAST @D68363, AGR [CASE @D68362, COUNT @D68361, 
            PER @D68360, PLU @D68359, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : HANG, 
   [COORD @D68370, PAST @D68369, 
      AGR [CASE @D68368, COUNT @D68367, PER @D68366, PLU @D68365, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, FIN -, 
      ARITY 1] : HANG, 
   [COORD @D68376, PAST @D68375, AGR [CASE @D68374, COUNT @D68373, 
            PER @D68372, PLU @D68371, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, FIN -, ARITY 1] : HANG, 
   [COORD @D68382, PAST @D68381, 
      AGR [CASE @D68380, COUNT @D68379, PER @D68378, PLU @D68377, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, FIN -, 
      ARITY 1] : HANG, 
   [COORD @D68386, AGR [COUNT @D68385, PER @D68384, PLU @D68383, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : HANG, 
   [COORD @D68390, AGR [COUNT @D68389, PER @D68388, PLU @D68387, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : HANG, 
   [COORD @D68394, AGR [COUNT @D68393, PER @D68392, PLU @D68391, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, PAST +, ARITY 1] : HANG, 
   [COORD @D68398, AGR [COUNT @D68397, PER @D68396, PLU @D68395, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : HANG, 
   [COORD @D68402, AGR [COUNT @D68401, PER @D68400, PLU @D68399, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : HANG, 
   [COORD @D68406, AGR [COUNT @D68405, PER @D68404, PLU @D68403, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : HANG, 
   [COORD @D68410, AGR [COUNT @D68409, PER @D68408, PLU @D68407, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, PAST +, ARITY 1] : HANG, 
   [COORD @D68414, AGR [COUNT @D68413, PER @D68412, PLU @D68411, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, PAST +, ARITY 1] : HANG.

WORD identified : 
   [COORD @D68436, AGR [CASE @D68435, COUNT @D68434, PER @D68433, 
            PLU @D68432, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68441, AGR [CASE @D68440, COUNT @D68439, PER @D68438, 
            PLU @D68437, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68446, AGR [CASE @D68445, COUNT @D68444, PER @D68443, 
            PLU @D68442, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68451, AGR [CASE @D68450, COUNT @D68449, PER @D68448, 
            PLU @D68447, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68456, AGR [CASE @D68455, COUNT @D68454, PER @D68453, 
            PLU @D68452, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68461, AGR [CASE @D68460, COUNT @D68459, PER @D68458, 
            PLU @D68457, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68466, AGR [CASE @D68465, COUNT @D68464, PER @D68463, 
            PLU @D68462, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68471, AGR [CASE @D68470, COUNT @D68469, PER @D68468, 
            PLU @D68467, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68476, AGR [CASE @D68475, COUNT @D68474, PER @D68473, 
            PLU @D68472, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : IDENTIFY.

WORD identifies : 
   [COORD @D68483, AGR [COUNT @D68482, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : IDENTIFY, 
   [COORD @D68485, AGR [COUNT @D68484, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68487, 
      AGR [COUNT @D68486, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IDENTIFY.

WORD identify : 
   [COORD @D68494, AGR [COUNT @D68493, PER @D68492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : IDENTIFY, 
   [COORD @D68496, AGR [COUNT @D68495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : IDENTIFY, 
   [COORD @D68498, AGR [COUNT @D68497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : IDENTIFY, 
   [COORD @D68502, AGR [COUNT @D68501, PER @D68500, PLU @D68499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : IDENTIFY, 
   [COORD @D68508, PAST @D68507, 
      AGR [CASE @D68506, COUNT @D68505, PER @D68504, PLU @D68503, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : IDENTIFY, 
   [COORD @D68511, AGR [COUNT @D68510, PER @D68509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IDENTIFY, 
   [COORD @D68513, AGR [COUNT @D68512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IDENTIFY, 
   [COORD @D68515, AGR [COUNT @D68514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IDENTIFY, 
   [COORD @D68519, AGR [COUNT @D68518, PER @D68517, PLU @D68516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : IDENTIFY, 
   [COORD @D68525, PAST @D68524, AGR [CASE @D68523, COUNT @D68522, 
            PER @D68521, PLU @D68520, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : IDENTIFY, 
   [COORD @D68528, AGR [COUNT @D68527, PER @D68526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : IDENTIFY, 
   [COORD @D68530, AGR [COUNT @D68529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : IDENTIFY, 
   [COORD @D68532, AGR [COUNT @D68531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : IDENTIFY, 
   [COORD @D68536, AGR [COUNT @D68535, PER @D68534, PLU @D68533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : IDENTIFY, 
   [COORD @D68542, PAST @D68541, 
      AGR [CASE @D68540, COUNT @D68539, PER @D68538, PLU @D68537, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      ARITY 2] : IDENTIFY.

WORD identifying : 
   [COORD @D68555, PRD @D68554, AGR [CASE @D68553, COUNT @D68552, 
            PER @D68551, PLU @D68550, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : IDENTIFY, 
   [COORD @D68561, PRD @D68560, 
      AGR [CASE @D68559, COUNT @D68558, PER @D68557, PLU @D68556, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   IDENTIFY, 
   [COORD @D68567, PRD @D68566, AGR [CASE @D68565, COUNT @D68564, 
            PER @D68563, PLU @D68562, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : IDENTIFY.

WORD illustrate : 
   [COORD @D68574, AGR [COUNT @D68573, PER @D68572, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ILLUSTRATE, 
   [COORD @D68576, AGR [COUNT @D68575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ILLUSTRATE, 
   [COORD @D68578, AGR [COUNT @D68577, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ILLUSTRATE, 
   [COORD @D68582, AGR [COUNT @D68581, PER @D68580, PLU @D68579, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ILLUSTRATE, 
   [COORD @D68588, PAST @D68587, AGR [CASE @D68586, COUNT @D68585, 
            PER @D68584, PLU @D68583, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ILLUSTRATE.

WORD illustrated : 
   [COORD @D68598, AGR [CASE @D68597, COUNT @D68596, PER @D68595, 
            PLU @D68594, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ILLUSTRATE, 
   [COORD @D68603, AGR [CASE @D68602, COUNT @D68601, PER @D68600, 
            PLU @D68599, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ILLUSTRATE, 
   [COORD @D68608, AGR [CASE @D68607, COUNT @D68606, PER @D68605, 
            PLU @D68604, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ILLUSTRATE.

WORD illustrates : 
   [COORD @D68615, AGR [COUNT @D68614, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ILLUSTRATE.

WORD illustrating : 
   [COORD @D68625, PRD @D68624, AGR [CASE @D68623, COUNT @D68622, 
            PER @D68621, PLU @D68620, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ILLUSTRATE.

WORD impose : 
   [COORD @D68632, AGR [COUNT @D68631, PER @D68630, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : IMPOSE, 
   [COORD @D68634, AGR [COUNT @D68633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : IMPOSE, 
   [COORD @D68636, AGR [COUNT @D68635, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : IMPOSE, 
   [COORD @D68640, AGR [COUNT @D68639, PER @D68638, PLU @D68637, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : IMPOSE, 
   [COORD @D68646, PAST @D68645, 
      AGR [CASE @D68644, COUNT @D68643, PER @D68642, PLU @D68641, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM UPON, 
      ARITY 3] : IMPOSE, 
   [COORD @D68649, AGR [COUNT @D68648, PER @D68647, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : IMPOSE, 
   [COORD @D68651, AGR [COUNT @D68650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : IMPOSE, 
   [COORD @D68653, AGR [COUNT @D68652, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : IMPOSE, 
   [COORD @D68657, AGR [COUNT @D68656, PER @D68655, PLU @D68654, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : IMPOSE, 
   [COORD @D68663, PAST @D68662, 
      AGR [CASE @D68661, COUNT @D68660, PER @D68659, PLU @D68658, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ON, 
      ARITY 3] : IMPOSE, 
   [COORD @D68666, AGR [COUNT @D68665, PER @D68664, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IMPOSE, 
   [COORD @D68668, AGR [COUNT @D68667, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IMPOSE, 
   [COORD @D68670, AGR [COUNT @D68669, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IMPOSE, 
   [COORD @D68674, AGR [COUNT @D68673, PER @D68672, PLU @D68671, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : IMPOSE, 
   [COORD @D68680, PAST @D68679, AGR [CASE @D68678, COUNT @D68677, 
            PER @D68676, PLU @D68675, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : IMPOSE, 
   [COORD @D68683, AGR [COUNT @D68682, PER @D68681, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : IMPOSE, 
   [COORD @D68685, AGR [COUNT @D68684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : IMPOSE, 
   [COORD @D68687, AGR [COUNT @D68686, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UPON, ARITY 2] : IMPOSE, 
   [COORD @D68691, AGR [COUNT @D68690, PER @D68689, PLU @D68688, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM UPON, ARITY 2] : IMPOSE, 
   [COORD @D68697, PAST @D68696, 
      AGR [CASE @D68695, COUNT @D68694, PER @D68693, PLU @D68692, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UPON, 
      ARITY 2] : IMPOSE, 
   [COORD @D68700, AGR [COUNT @D68699, PER @D68698, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : IMPOSE, 
   [COORD @D68702, AGR [COUNT @D68701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : IMPOSE, 
   [COORD @D68704, AGR [COUNT @D68703, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : IMPOSE, 
   [COORD @D68708, AGR [COUNT @D68707, PER @D68706, PLU @D68705, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : IMPOSE, 
   [COORD @D68714, PAST @D68713, 
      AGR [CASE @D68712, COUNT @D68711, PER @D68710, PLU @D68709, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      ARITY 2] : IMPOSE, 
   [COORD @D68717, AGR [COUNT @D68716, PER @D68715, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPOSE, 
   [COORD @D68719, AGR [COUNT @D68718, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPOSE, 
   [COORD @D68721, AGR [COUNT @D68720, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPOSE, 
   [COORD @D68725, AGR [COUNT @D68724, PER @D68723, PLU @D68722, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPOSE, 
   [COORD @D68731, PAST @D68730, AGR [CASE @D68729, COUNT @D68728, 
            PER @D68727, PLU @D68726, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : IMPOSE.

WORD imposed : 
   [COORD @D68741, AGR [CASE @D68740, COUNT @D68739, PER @D68738, 
            PLU @D68737, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68746, AGR [CASE @D68745, COUNT @D68744, PER @D68743, 
            PLU @D68742, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68751, AGR [CASE @D68750, COUNT @D68749, PER @D68748, 
            PLU @D68747, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68756, AGR [CASE @D68755, COUNT @D68754, PER @D68753, 
            PLU @D68752, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68761, AGR [CASE @D68760, COUNT @D68759, PER @D68758, 
            PLU @D68757, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68766, AGR [CASE @D68765, COUNT @D68764, PER @D68763, 
            PLU @D68762, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68771, AGR [CASE @D68770, COUNT @D68769, PER @D68768, 
            PLU @D68767, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68776, AGR [CASE @D68775, COUNT @D68774, PER @D68773, 
            PLU @D68772, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68781, AGR [CASE @D68780, COUNT @D68779, PER @D68778, 
            PLU @D68777, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68786, AGR [CASE @D68785, COUNT @D68784, PER @D68783, 
            PLU @D68782, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68791, AGR [CASE @D68790, COUNT @D68789, PER @D68788, 
            PLU @D68787, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68796, AGR [CASE @D68795, COUNT @D68794, PER @D68793, 
            PLU @D68792, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68801, AGR [CASE @D68800, COUNT @D68799, PER @D68798, 
            PLU @D68797, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68806, AGR [CASE @D68805, COUNT @D68804, PER @D68803, 
            PLU @D68802, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68811, AGR [CASE @D68810, COUNT @D68809, PER @D68808, 
            PLU @D68807, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : IMPOSE.

WORD imposes : 
   [COORD @D68818, AGR [COUNT @D68817, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   IMPOSE, 
   [COORD @D68820, AGR [COUNT @D68819, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68822, 
      AGR [COUNT @D68821, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68824, 
      AGR [COUNT @D68823, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68826, 
      AGR [COUNT @D68825, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68828, 
      AGR [COUNT @D68827, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPOSE.

WORD imposing : 
   [COORD @D68838, PRD @D68837, AGR [CASE @D68836, COUNT @D68835, 
            PER @D68834, PLU @D68833, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68844, PRD @D68843, 
      AGR [CASE @D68842, COUNT @D68841, PER @D68840, PLU @D68839, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : IMPOSE, 
   [COORD @D68850, PRD @D68849, AGR [CASE @D68848, COUNT @D68847, 
            PER @D68846, PLU @D68845, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68856, PRD @D68855, 
      AGR [CASE @D68854, COUNT @D68853, PER @D68852, PLU @D68851, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : IMPOSE, 
   [COORD @D68862, PRD @D68861, AGR [CASE @D68860, COUNT @D68859, 
            PER @D68858, PLU @D68857, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : IMPOSE, 
   [COORD @D68868, PRD @D68867, 
      AGR [CASE @D68866, COUNT @D68865, PER @D68864, PLU @D68863, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   IMPOSE.

WORD improve : 
   [COORD @D68875, AGR [COUNT @D68874, PER @D68873, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IMPROVE, 
   [COORD @D68877, AGR [COUNT @D68876, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IMPROVE, 
   [COORD @D68879, AGR [COUNT @D68878, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : IMPROVE, 
   [COORD @D68883, AGR [COUNT @D68882, PER @D68881, PLU @D68880, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : IMPROVE, 
   [COORD @D68889, PAST @D68888, AGR [CASE @D68887, COUNT @D68886, 
            PER @D68885, PLU @D68884, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : IMPROVE, 
   [COORD @D68892, AGR [COUNT @D68891, PER @D68890, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : IMPROVE, 
   [COORD @D68894, AGR [COUNT @D68893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : IMPROVE, 
   [COORD @D68896, AGR [COUNT @D68895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : IMPROVE, 
   [COORD @D68900, AGR [COUNT @D68899, PER @D68898, PLU @D68897, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : IMPROVE, 
   [COORD @D68906, PAST @D68905, 
      AGR [CASE @D68904, COUNT @D68903, PER @D68902, PLU @D68901, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      ARITY 2] : IMPROVE, 
   [COORD @D68909, AGR [COUNT @D68908, PER @D68907, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : IMPROVE, 
   [COORD @D68911, AGR [COUNT @D68910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : IMPROVE, 
   [COORD @D68913, AGR [COUNT @D68912, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : IMPROVE, 
   [COORD @D68917, AGR [COUNT @D68916, PER @D68915, PLU @D68914, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : IMPROVE, 
   [COORD @D68923, PAST @D68922, 
      AGR [CASE @D68921, COUNT @D68920, PER @D68919, PLU @D68918, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : IMPROVE, 
   [COORD @D68926, AGR [COUNT @D68925, PER @D68924, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPROVE, 
   [COORD @D68928, AGR [COUNT @D68927, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPROVE, 
   [COORD @D68930, AGR [COUNT @D68929, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPROVE, 
   [COORD @D68934, AGR [COUNT @D68933, PER @D68932, PLU @D68931, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : IMPROVE, 
   [COORD @D68940, PAST @D68939, AGR [CASE @D68938, COUNT @D68937, 
            PER @D68936, PLU @D68935, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : IMPROVE.

WORD improved : 
   [COORD @D68950, AGR [CASE @D68949, COUNT @D68948, PER @D68947, 
            PLU @D68946, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68955, AGR [CASE @D68954, COUNT @D68953, PER @D68952, 
            PLU @D68951, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68960, AGR [CASE @D68959, COUNT @D68958, PER @D68957, 
            PLU @D68956, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68965, AGR [CASE @D68964, COUNT @D68963, PER @D68962, 
            PLU @D68961, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68970, AGR [CASE @D68969, COUNT @D68968, PER @D68967, 
            PLU @D68966, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68975, AGR [CASE @D68974, COUNT @D68973, PER @D68972, 
            PLU @D68971, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68980, AGR [CASE @D68979, COUNT @D68978, PER @D68977, 
            PLU @D68976, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68985, AGR [CASE @D68984, COUNT @D68983, PER @D68982, 
            PLU @D68981, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68990, AGR [CASE @D68989, COUNT @D68988, PER @D68987, 
            PLU @D68986, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D68995, AGR [CASE @D68994, COUNT @D68993, PER @D68992, 
            PLU @D68991, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D69000, AGR [CASE @D68999, COUNT @D68998, PER @D68997, 
            PLU @D68996, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : IMPROVE.

WORD improves : 
   [COORD @D69007, AGR [COUNT @D69006, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D69009, 
      AGR [COUNT @D69008, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D69011, 
      AGR [COUNT @D69010, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D69013, 
      AGR [COUNT @D69012, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : IMPROVE.

WORD improving : 
   [COORD @D69023, PRD @D69022, AGR [CASE @D69021, COUNT @D69020, 
            PER @D69019, PLU @D69018, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D69029, PRD @D69028, 
      AGR [CASE @D69027, COUNT @D69026, PER @D69025, PLU @D69024, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : IMPROVE, 
   [COORD @D69035, PRD @D69034, AGR [CASE @D69033, COUNT @D69032, 
            PER @D69031, PLU @D69030, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : IMPROVE, 
   [COORD @D69041, PRD @D69040, 
      AGR [CASE @D69039, COUNT @D69038, PER @D69037, PLU @D69036, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   IMPROVE.

WORD include : 
   [COORD @D69049, AGR [COUNT @D69048, PER @D69047, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INCLUDE, 
   [COORD @D69051, AGR [COUNT @D69050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INCLUDE, 
   [COORD @D69053, AGR [COUNT @D69052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INCLUDE, 
   [COORD @D69057, AGR [COUNT @D69056, PER @D69055, PLU @D69054, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INCLUDE, 
   [COORD @D69063, PAST @D69062, AGR [CASE @D69061, COUNT @D69060, 
            PER @D69059, PLU @D69058, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INCLUDE.

WORD included : 
   [COADV @D69077, COORD @D69076, DEF @D69075, PRD @D69074, AGR 
         [CASE @D69073, COUNT @D69072, PER @D69071, PLU @D69070, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PST] : INCLUDED, 
   [COORD @D69082, AGR [CASE @D69081, COUNT @D69080, PER @D69079, 
            PLU @D69078, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INCLUDE, 
   [COORD @D69087, AGR [CASE @D69086, COUNT @D69085, PER @D69084, 
            PLU @D69083, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INCLUDE, 
   [COORD @D69092, AGR [CASE @D69091, COUNT @D69090, PER @D69089, 
            PLU @D69088, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INCLUDE.

WORD includes : 
   [COORD @D69100, AGR [COUNT @D69099, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INCLUDE.

WORD including : 
   [COORD @D69111, PRD @D69110, AGR [CASE @D69109, COUNT @D69108, 
            PER @D69107, PLU @D69106, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INCLUDE.

WORD increase : 
   [COORD @D69122, REFL @D69121, COUNT @D69120, PRD @D69119, 
      CASE @D69118, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : INCREASE, 
   [COORD @D69125, 
      AGR [COUNT @D69124, PER @D69123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   INCREASE, 
   [COORD @D69127, AGR [COUNT @D69126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INCREASE, 
   [COORD @D69129, AGR [COUNT @D69128, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INCREASE, 
   [COORD @D69133, AGR [COUNT @D69132, PER @D69131, PLU @D69130, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INCREASE, 
   [COORD @D69139, PAST @D69138, AGR [CASE @D69137, COUNT @D69136, 
            PER @D69135, PLU @D69134, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INCREASE, 
   [COORD @D69142, AGR [COUNT @D69141, PER @D69140, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INCREASE, 
   [COORD @D69144, AGR [COUNT @D69143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INCREASE, 
   [COORD @D69146, AGR [COUNT @D69145, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INCREASE, 
   [COORD @D69150, AGR [COUNT @D69149, PER @D69148, PLU @D69147, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INCREASE, 
   [COORD @D69156, PAST @D69155, AGR [CASE @D69154, COUNT @D69153, 
            PER @D69152, PLU @D69151, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : INCREASE.

WORD increased : 
   [COORD @D69169, AGR [CASE @D69168, COUNT @D69167, PER @D69166, 
            PLU @D69165, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INCREASE, 
   [COORD @D69174, AGR [CASE @D69173, COUNT @D69172, PER @D69171, 
            PLU @D69170, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INCREASE, 
   [COORD @D69179, AGR [CASE @D69178, COUNT @D69177, PER @D69176, 
            PLU @D69175, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INCREASE, 
   [COORD @D69184, AGR [CASE @D69183, COUNT @D69182, PER @D69181, 
            PLU @D69180, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INCREASE, 
   [COORD @D69189, AGR [CASE @D69188, COUNT @D69187, PER @D69186, 
            PLU @D69185, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INCREASE.

WORD increases : 
   [COORD @D69202, DEMON @D69201, REFL @D69200, PRD @D69199, 
      CASE @D69198, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INCREASE, 
   [COORD @D69204, AGR [COUNT @D69203, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INCREASE, 
   [COORD @D69206, 
      AGR [COUNT @D69205, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INCREASE.

WORD increasing : 
   [COORD @D69218, PRD @D69217, AGR [CASE @D69216, COUNT @D69215, 
            PER @D69214, PLU @D69213, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INCREASE, 
   [COORD @D69224, PRD @D69223, 
      AGR [CASE @D69222, COUNT @D69221, PER @D69220, PLU @D69219, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INCREASE.

WORD indicate : 
   [COORD @D69232, AGR [COUNT @D69231, PER @D69230, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : INDICATE, 
   [COORD @D69234, AGR [COUNT @D69233, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : INDICATE, 
   [COORD @D69236, AGR [COUNT @D69235, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : INDICATE, 
   [COORD @D69240, AGR [COUNT @D69239, PER @D69238, PLU @D69237, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : INDICATE, 
   [COORD @D69246, PAST @D69245, AGR [CASE @D69244, COUNT @D69243, 
            PER @D69242, PLU @D69241, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : INDICATE, 
   [COORD @D69249, AGR [COUNT @D69248, PER @D69247, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : INDICATE, 
   [COORD @D69251, AGR [COUNT @D69250, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : INDICATE, 
   [COORD @D69253, AGR [COUNT @D69252, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : INDICATE, 
   [COORD @D69257, AGR [COUNT @D69256, PER @D69255, PLU @D69254, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : INDICATE, 
   [COORD @D69263, PAST @D69262, AGR [CASE @D69261, COUNT @D69260, 
            PER @D69259, PLU @D69258, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : INDICATE, 
   [COORD @D69266, AGR [COUNT @D69265, PER @D69264, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : INDICATE, 
   [COORD @D69268, AGR [COUNT @D69267, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : INDICATE, 
   [COORD @D69270, AGR [COUNT @D69269, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : INDICATE, 
   [COORD @D69274, AGR [COUNT @D69273, PER @D69272, PLU @D69271, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : INDICATE, 
   [COORD @D69280, PAST @D69279, AGR [CASE @D69278, COUNT @D69277, 
            PER @D69276, PLU @D69275, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : INDICATE, 
   [COORD @D69283, AGR [COUNT @D69282, PER @D69281, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INDICATE, 
   [COORD @D69285, AGR [COUNT @D69284, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INDICATE, 
   [COORD @D69287, AGR [COUNT @D69286, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INDICATE, 
   [COORD @D69291, AGR [COUNT @D69290, PER @D69289, PLU @D69288, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INDICATE, 
   [COORD @D69297, PAST @D69296, AGR [CASE @D69295, COUNT @D69294, 
            PER @D69293, PLU @D69292, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INDICATE, 
   [COORD @D69300, AGR [COUNT @D69299, PER @D69298, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INDICATE, 
   [COORD @D69302, AGR [COUNT @D69301, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INDICATE, 
   [COORD @D69304, AGR [COUNT @D69303, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INDICATE, 
   [COORD @D69308, AGR [COUNT @D69307, PER @D69306, PLU @D69305, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INDICATE, 
   [COORD @D69314, PAST @D69313, AGR [CASE @D69312, COUNT @D69311, 
            PER @D69310, PLU @D69309, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : INDICATE.

WORD indicated : 
   [COORD @D69325, AGR [CASE @D69324, COUNT @D69323, PER @D69322, 
            PLU @D69321, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69330, AGR [CASE @D69329, COUNT @D69328, PER @D69327, 
            PLU @D69326, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69335, AGR [CASE @D69334, COUNT @D69333, PER @D69332, 
            PLU @D69331, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69340, AGR [CASE @D69339, COUNT @D69338, PER @D69337, 
            PLU @D69336, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69345, AGR [CASE @D69344, COUNT @D69343, PER @D69342, 
            PLU @D69341, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69350, AGR [CASE @D69349, COUNT @D69348, PER @D69347, 
            PLU @D69346, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69355, AGR [UB @D69354, VFORM @D69353, SUBJ @D69352, 
            FIN @D69351, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INDICATE, 
   [COORD @D69360, AGR [CASE @D69359, COUNT @D69358, PER @D69357, 
            PLU @D69356, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69365, AGR [CASE @D69364, COUNT @D69363, PER @D69362, 
            PLU @D69361, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69370, AGR [CASE @D69369, COUNT @D69368, PER @D69367, 
            PLU @D69366, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INDICATE, 
   [COORD @D69375, AGR [CASE @D69374, COUNT @D69373, PER @D69372, 
            PLU @D69371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69380, AGR [CASE @D69379, COUNT @D69378, PER @D69377, 
            PLU @D69376, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INDICATE.

WORD indicates : 
   [COORD @D69388, AGR [COUNT @D69387, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69390, 
      AGR [COUNT @D69389, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69392, 
      AGR [COUNT @D69391, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69394, 
      AGR [COUNT @D69393, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69396, 
      AGR [COUNT @D69395, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INDICATE.

WORD indicating : 
   [COORD @D69407, PRD @D69406, AGR [CASE @D69405, COUNT @D69404, 
            PER @D69403, PLU @D69402, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69413, PRD @D69412, 
      AGR [CASE @D69411, COUNT @D69410, PER @D69409, PLU @D69408, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INDICATE, 
   [COORD @D69419, PRD @D69418, AGR [CASE @D69417, COUNT @D69416, 
            PER @D69415, PLU @D69414, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INDICATE, 
   [COORD @D69425, PRD @D69424, 
      AGR [CASE @D69423, COUNT @D69422, PER @D69421, PLU @D69420, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INDICATE, 
   [COORD @D69431, PRD @D69430, AGR [CASE @D69429, COUNT @D69428, 
            PER @D69427, PLU @D69426, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INDICATE.

WORD influence : 
   [COORD @D69442, REFL @D69441, COUNT @D69440, PRD @D69439, 
      CASE @D69438, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : INFLUENCE, 
   [COORD @D69447, REFL @D69446, COUNT @D69445, PRD @D69444, 
      CASE @D69443, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UPON] : 
   INFLUENCE, 
   [COORD @D69452, REFL @D69451, COUNT @D69450, PRD @D69449, 
      CASE @D69448, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : INFLUENCE, 
   [COORD @D69457, REFL @D69456, COUNT @D69455, PRD @D69454, 
      CASE @D69453, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH] : 
   INFLUENCE, 
   [COORD @D69462, REFL @D69461, COUNT @D69460, PRD @D69459, 
      CASE @D69458, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON] : 
   INFLUENCE, 
   [COORD @D69467, REFL @D69466, COUNT @D69465, PRD @D69464, 
      CASE @D69463, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OVER] : 
   INFLUENCE, 
   [COORD @D69472, REFL @D69471, COUNT @D69470, PRD @D69469, 
      CASE @D69468, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : INFLUENCE, 
   [COORD @D69475, 
      AGR [COUNT @D69474, PER @D69473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : INFLUENCE, 
   [COORD @D69477, AGR [COUNT @D69476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : INFLUENCE, 
   [COORD @D69479, AGR [COUNT @D69478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : INFLUENCE, 
   [COORD @D69483, AGR [COUNT @D69482, PER @D69481, PLU @D69480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : INFLUENCE, 
   [COORD @D69489, PAST @D69488, 
      AGR [CASE @D69487, COUNT @D69486, PER @D69485, PLU @D69484, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : 
   INFLUENCE, 
   [COORD @D69492, AGR [COUNT @D69491, PER @D69490, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INFLUENCE, 
   [COORD @D69494, AGR [COUNT @D69493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INFLUENCE, 
   [COORD @D69496, AGR [COUNT @D69495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INFLUENCE, 
   [COORD @D69500, AGR [COUNT @D69499, PER @D69498, PLU @D69497, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INFLUENCE, 
   [COORD @D69506, PAST @D69505, AGR [CASE @D69504, COUNT @D69503, 
            PER @D69502, PLU @D69501, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INFLUENCE.

WORD influenced : 
   [COORD @D69519, AGR [CASE @D69518, COUNT @D69517, PER @D69516, 
            PLU @D69515, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INFLUENCE, 
   [COORD @D69524, AGR [CASE @D69523, COUNT @D69522, PER @D69521, 
            PLU @D69520, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INFLUENCE, 
   [COORD @D69530, AGR [CASE @D69529, NFORM @D69528, COUNT @D69527, 
            PER @D69526, PLU @D69525, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INFLUENCE, 
   [COORD @D69535, AGR [CASE @D69534, COUNT @D69533, PER @D69532, 
            PLU @D69531, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INFLUENCE, 
   [COORD @D69540, AGR [CASE @D69539, COUNT @D69538, PER @D69537, 
            PLU @D69536, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INFLUENCE, 
   [COORD @D69545, AGR [CASE @D69544, COUNT @D69543, PER @D69542, 
            PLU @D69541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INFLUENCE.

WORD influences : 
   [COORD @D69558, DEMON @D69557, REFL @D69556, PRD @D69555, 
      CASE @D69554, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INFLUENCE, 
   [COORD @D69563, DEMON @D69562, REFL @D69561, PRD @D69560, 
      CASE @D69559, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM UPON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INFLUENCE, 
   [COORD @D69568, DEMON @D69567, REFL @D69566, PRD @D69565, 
      CASE @D69564, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INFLUENCE, 
   [COORD @D69573, DEMON @D69572, REFL @D69571, PRD @D69570, 
      CASE @D69569, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM WITH, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INFLUENCE, 
   [COORD @D69578, DEMON @D69577, REFL @D69576, PRD @D69575, 
      CASE @D69574, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INFLUENCE, 
   [COORD @D69583, DEMON @D69582, REFL @D69581, PRD @D69580, 
      CASE @D69579, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OVER, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INFLUENCE, 
   [COORD @D69588, DEMON @D69587, REFL @D69586, PRD @D69585, 
      CASE @D69584, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   INFLUENCE, 
   [COORD @D69590, AGR [COUNT @D69589, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INFLUENCE, 
   [COORD @D69592, 
      AGR [COUNT @D69591, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INFLUENCE.

WORD influencing : 
   [COORD @D69606, PRD @D69605, AGR [CASE @D69604, COUNT @D69603, 
            PER @D69602, PLU @D69601, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INFLUENCE, 
   [COORD @D69612, PRD @D69611, 
      AGR [CASE @D69610, COUNT @D69609, PER @D69608, PLU @D69607, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INFLUENCE.

WORD inform : 
   [COORD @D69619, AGR [COUNT @D69618, PER @D69617, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : INFORM, 
   [COORD @D69621, AGR [COUNT @D69620, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : INFORM, 
   [COORD @D69623, AGR [COUNT @D69622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : INFORM, 
   [COORD @D69627, AGR [COUNT @D69626, PER @D69625, PLU @D69624, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : INFORM, 
   [COORD @D69633, PAST @D69632, AGR [CASE @D69631, COUNT @D69630, 
            PER @D69629, PLU @D69628, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_SFIN, ARITY 3] : INFORM, 
   [COORD @D69636, AGR [COUNT @D69635, PER @D69634, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : INFORM, 
   [COORD @D69638, AGR [COUNT @D69637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : INFORM, 
   [COORD @D69640, AGR [COUNT @D69639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : INFORM, 
   [COORD @D69644, AGR [COUNT @D69643, PER @D69642, PLU @D69641, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : INFORM, 
   [COORD @D69650, PAST @D69649, 
      AGR [CASE @D69648, COUNT @D69647, PER @D69646, PLU @D69645, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, 
      ARITY 3] : INFORM, 
   [COORD @D69653, AGR [COUNT @D69652, PER @D69651, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : INFORM, 
   [COORD @D69655, AGR [COUNT @D69654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : INFORM, 
   [COORD @D69657, AGR [COUNT @D69656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : INFORM, 
   [COORD @D69661, AGR [COUNT @D69660, PER @D69659, PLU @D69658, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : INFORM, 
   [COORD @D69667, PAST @D69666, 
      AGR [CASE @D69665, COUNT @D69664, PER @D69663, PLU @D69662, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, 
      ARITY 3] : INFORM, 
   [COORD @D69670, AGR [COUNT @D69669, PER @D69668, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INFORM, 
   [COORD @D69672, AGR [COUNT @D69671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INFORM, 
   [COORD @D69674, AGR [COUNT @D69673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INFORM, 
   [COORD @D69678, AGR [COUNT @D69677, PER @D69676, PLU @D69675, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INFORM, 
   [COORD @D69684, PAST @D69683, AGR [CASE @D69682, COUNT @D69681, 
            PER @D69680, PLU @D69679, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INFORM, 
   [COORD @D69687, AGR [COUNT @D69686, PER @D69685, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : INFORM, 
   [COORD @D69689, AGR [COUNT @D69688, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : INFORM, 
   [COORD @D69691, AGR [COUNT @D69690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : INFORM, 
   [COORD @D69695, AGR [COUNT @D69694, PER @D69693, PLU @D69692, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : INFORM, 
   [COORD @D69701, PAST @D69700, 
      AGR [CASE @D69699, COUNT @D69698, PER @D69697, PLU @D69696, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      ARITY 2] : INFORM, 
   [COORD @D69704, AGR [COUNT @D69703, PER @D69702, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : INFORM, 
   [COORD @D69706, AGR [COUNT @D69705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : INFORM, 
   [COORD @D69708, AGR [COUNT @D69707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : INFORM, 
   [COORD @D69712, AGR [COUNT @D69711, PER @D69710, PLU @D69709, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : INFORM, 
   [COORD @D69718, PAST @D69717, 
      AGR [CASE @D69716, COUNT @D69715, PER @D69714, PLU @D69713, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : INFORM, 
   [COORD @D69721, AGR [COUNT @D69720, PER @D69719, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : INFORM, 
   [COORD @D69723, AGR [COUNT @D69722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : INFORM, 
   [COORD @D69725, AGR [COUNT @D69724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : INFORM, 
   [COORD @D69729, AGR [COUNT @D69728, PER @D69727, PLU @D69726, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : INFORM, 
   [COORD @D69735, PAST @D69734, 
      AGR [CASE @D69733, COUNT @D69732, PER @D69731, PLU @D69730, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, 
      ARITY 2] : INFORM.

WORD informed : 
   [COADV @D69748, COORD @D69747, DEF @D69746, PRD @D69745, AGR 
         [CASE @D69744, COUNT @D69743, PER @D69742, PLU @D69741, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : INFORMED, 
   [COORD @D69753, 
      AGR [CASE @D69752, COUNT @D69751, PER @D69750, PLU @D69749, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_SFIN, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INFORM, 
   [COORD @D69758, AGR [CASE @D69757, COUNT @D69756, PER @D69755, 
            PLU @D69754, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69763, AGR [CASE @D69762, COUNT @D69761, PER @D69760, 
            PLU @D69759, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69768, AGR [CASE @D69767, COUNT @D69766, PER @D69765, 
            PLU @D69764, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69773, AGR [CASE @D69772, COUNT @D69771, PER @D69770, 
            PLU @D69769, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69778, AGR [CASE @D69777, COUNT @D69776, PER @D69775, 
            PLU @D69774, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69783, AGR [CASE @D69782, COUNT @D69781, PER @D69780, 
            PLU @D69779, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69788, AGR [CASE @D69787, COUNT @D69786, PER @D69785, 
            PLU @D69784, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69793, AGR [CASE @D69792, COUNT @D69791, PER @D69790, 
            PLU @D69789, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69798, AGR [CASE @D69797, COUNT @D69796, PER @D69795, 
            PLU @D69794, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69803, AGR [CASE @D69802, COUNT @D69801, PER @D69800, 
            PLU @D69799, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69808, AGR [CASE @D69807, COUNT @D69806, PER @D69805, 
            PLU @D69804, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INFORM, 
   [COORD @D69813, AGR [CASE @D69812, COUNT @D69811, PER @D69810, 
            PLU @D69809, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69818, AGR [CASE @D69817, COUNT @D69816, PER @D69815, 
            PLU @D69814, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69823, AGR [CASE @D69822, COUNT @D69821, PER @D69820, 
            PLU @D69819, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69828, AGR [CASE @D69827, COUNT @D69826, PER @D69825, 
            PLU @D69824, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69833, AGR [CASE @D69832, COUNT @D69831, PER @D69830, 
            PLU @D69829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69838, AGR [CASE @D69837, COUNT @D69836, PER @D69835, 
            PLU @D69834, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69843, AGR [CASE @D69842, COUNT @D69841, PER @D69840, 
            PLU @D69839, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69848, AGR [CASE @D69847, COUNT @D69846, PER @D69845, 
            PLU @D69844, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69853, AGR [CASE @D69852, COUNT @D69851, PER @D69850, 
            PLU @D69849, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : INFORM.

WORD informing : 
   [COORD @D69866, PRD @D69865, AGR [CASE @D69864, COUNT @D69863, 
            PER @D69862, PLU @D69861, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69872, PRD @D69871, 
      AGR [CASE @D69870, COUNT @D69869, PER @D69868, PLU @D69867, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : INFORM, 
   [COORD @D69878, PRD @D69877, AGR [CASE @D69876, COUNT @D69875, 
            PER @D69874, PLU @D69873, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69884, PRD @D69883, 
      AGR [CASE @D69882, COUNT @D69881, PER @D69880, PLU @D69879, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INFORM, 
   [COORD @D69890, PRD @D69889, AGR [CASE @D69888, COUNT @D69887, 
            PER @D69886, PLU @D69885, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INFORM, 
   [COORD @D69896, PRD @D69895, 
      AGR [CASE @D69894, COUNT @D69893, PER @D69892, PLU @D69891, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : INFORM, 
   [COORD @D69902, PRD @D69901, AGR [CASE @D69900, COUNT @D69899, 
            PER @D69898, PLU @D69897, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : INFORM.

WORD informs : 
   [COORD @D69909, AGR [COUNT @D69908, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INFORM, 
   [COORD @D69911, 
      AGR [COUNT @D69910, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INFORM, 
   [COORD @D69913, 
      AGR [COUNT @D69912, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   INFORM, 
   [COORD @D69915, AGR [COUNT @D69914, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INFORM, 
   [COORD @D69917, 
      AGR [COUNT @D69916, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INFORM, 
   [COORD @D69919, 
      AGR [COUNT @D69918, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INFORM, 
   [COORD @D69921, 
      AGR [COUNT @D69920, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   INFORM.

WORD input : 
   [COORD @D69929, REFL @D69928, PRD @D69927, CASE @D69926, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : INPUT, 
   [COORD @D69933, REFL @D69932, PRD @D69931, CASE @D69930, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO] : INPUT, 
   [COORD @D69937, REFL @D69936, PRD @D69935, CASE @D69934, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : INPUT, 
   [COORD @D69941, REFL @D69940, PRD @D69939, CASE @D69938, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : INPUT.

WORD inspire : 
   [COORD @D69954, AGR [COUNT @D69953, PER @D69952, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : INSPIRE, 
   [COORD @D69956, AGR [COUNT @D69955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : INSPIRE, 
   [COORD @D69958, AGR [COUNT @D69957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : INSPIRE, 
   [COORD @D69962, AGR [COUNT @D69961, PER @D69960, PLU @D69959, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : INSPIRE, 
   [COORD @D69968, PAST @D69967, AGR [CASE @D69966, COUNT @D69965, 
            PER @D69964, PLU @D69963, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : INSPIRE, 
   [COORD @D69971, AGR [COUNT @D69970, PER @D69969, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INSPIRE, 
   [COORD @D69973, AGR [COUNT @D69972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INSPIRE, 
   [COORD @D69975, AGR [COUNT @D69974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INSPIRE, 
   [COORD @D69979, AGR [COUNT @D69978, PER @D69977, PLU @D69976, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INSPIRE, 
   [COORD @D69985, PAST @D69984, 
      AGR [CASE @D69983, COUNT @D69982, PER @D69981, PLU @D69980, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : INSPIRE, 
   [COORD @D69988, AGR [COUNT @D69987, PER @D69986, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INSPIRE, 
   [COORD @D69990, AGR [COUNT @D69989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INSPIRE, 
   [COORD @D69992, AGR [COUNT @D69991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INSPIRE, 
   [COORD @D69996, AGR [COUNT @D69995, PER @D69994, PLU @D69993, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INSPIRE, 
   [COORD @D70002, PAST @D70001, 
      AGR [CASE @D70000, COUNT @D69999, PER @D69998, PLU @D69997, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : INSPIRE, 
   [COORD @D70005, AGR [COUNT @D70004, PER @D70003, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSPIRE, 
   [COORD @D70007, AGR [COUNT @D70006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSPIRE, 
   [COORD @D70009, AGR [COUNT @D70008, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSPIRE, 
   [COORD @D70013, AGR [COUNT @D70012, PER @D70011, PLU @D70010, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSPIRE, 
   [COORD @D70019, PAST @D70018, 
      AGR [CASE @D70017, COUNT @D70016, PER @D70015, PLU @D70014, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : INSPIRE, 
   [COORD @D70022, AGR @D70021, PAST @D70020, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQU_EXTRAP, 
      SUBCAT OC_INF, ARITY 2] : INSPIRE, 
   [COORD @D70025, AGR @D70024, PAST @D70023, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT NP_SFIN, ARITY 2] : INSPIRE, 
   [COORD @D70028, AGR [COUNT @D70027, PER @D70026, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INSPIRE, 
   [COORD @D70030, AGR [COUNT @D70029, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INSPIRE, 
   [COORD @D70032, AGR [COUNT @D70031, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INSPIRE, 
   [COORD @D70036, AGR [COUNT @D70035, PER @D70034, PLU @D70033, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INSPIRE, 
   [COORD @D70042, PAST @D70041, AGR [CASE @D70040, COUNT @D70039, 
            PER @D70038, PLU @D70037, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INSPIRE.

WORD inspired : 
   [COADV @D70056, COORD @D70055, DEF @D70054, PRD @D70053, AGR 
         [CASE @D70052, COUNT @D70051, PER @D70050, PLU @D70049, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : INSPIRED, 
   [COORD @D70061, 
      AGR [CASE @D70060, COUNT @D70059, PER @D70058, PLU @D70057, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : INSPIRE, 
   [COORD @D70066, AGR [CASE @D70065, COUNT @D70064, PER @D70063, 
            PLU @D70062, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70072, AGR [CASE @D70071, NFORM @D70070, COUNT @D70069, 
            PER @D70068, PLU @D70067, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70077, AGR [CASE @D70076, COUNT @D70075, PER @D70074, 
            PLU @D70073, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70082, AGR [CASE @D70081, COUNT @D70080, PER @D70079, 
            PLU @D70078, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70087, AGR [CASE @D70086, COUNT @D70085, PER @D70084, 
            PLU @D70083, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70092, AGR [CASE @D70091, COUNT @D70090, PER @D70089, 
            PLU @D70088, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70097, AGR [CASE @D70096, COUNT @D70095, PER @D70094, 
            PLU @D70093, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70102, AGR [CASE @D70101, COUNT @D70100, PER @D70099, 
            PLU @D70098, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70107, AGR [CASE @D70106, COUNT @D70105, PER @D70104, 
            PLU @D70103, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70112, AGR [CASE @D70111, COUNT @D70110, PER @D70109, 
            PLU @D70108, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70117, AGR [CASE @D70116, COUNT @D70115, PER @D70114, 
            PLU @D70113, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70119, AGR @D70118, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70121, AGR @D70120, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70126, AGR [CASE @D70125, COUNT @D70124, PER @D70123, 
            PLU @D70122, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, CONJ NULL, SUBTYPE EXTRAP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70128, AGR @D70127, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70130, AGR @D70129, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70135, AGR [CASE @D70134, COUNT @D70133, PER @D70132, 
            PLU @D70131, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70140, AGR [CASE @D70139, COUNT @D70138, PER @D70137, 
            PLU @D70136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70145, AGR [CASE @D70144, COUNT @D70143, PER @D70142, 
            PLU @D70141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INSPIRE.

WORD inspires : 
   [COORD @D70153, AGR [COUNT @D70152, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70155, 
      AGR [COUNT @D70154, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   INSPIRE, 
   [COORD @D70157, AGR [COUNT @D70156, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70159, 
      AGR [COUNT @D70158, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70163, 
      AGR [CASE @D70162, NFORM @D70161, COUNT @D70160, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQU_EXTRAP, 
      CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   INSPIRE, 
   [COORD @D70168, AGR [UB @D70167, VFORM @D70166, SUBJ @D70165, 
            FIN @D70164, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQU_EXTRAP, CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70172, AGR [CASE @D70171, NFORM @D70170, COUNT @D70169, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70177, AGR [UB @D70176, VFORM @D70175, SUBJ @D70174, 
            FIN @D70173, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70179, AGR [COUNT @D70178, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INSPIRE.

WORD inspiring : 
   [COORD @D70190, PRD @D70189, AGR [CASE @D70188, COUNT @D70187, 
            PER @D70186, PLU @D70185, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70196, PRD @D70195, 
      AGR [CASE @D70194, COUNT @D70193, PER @D70192, PLU @D70191, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70202, PRD @D70201, AGR [CASE @D70200, COUNT @D70199, 
            PER @D70198, PLU @D70197, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70208, PRD @D70207, 
      AGR [CASE @D70206, COUNT @D70205, PER @D70204, PLU @D70203, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : INSPIRE, 
   [COORD @D70211, AGR @D70210, PRD @D70209, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INSPIRE, 
   [COORD @D70214, AGR @D70213, PRD @D70212, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INSPIRE, 
   [COORD @D70220, PRD @D70219, AGR [CASE @D70218, COUNT @D70217, 
            PER @D70216, PLU @D70215, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INSPIRE.

WORD install : 
   [COORD @D70227, AGR [COUNT @D70226, PER @D70225, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSTALL, 
   [COORD @D70229, AGR [COUNT @D70228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSTALL, 
   [COORD @D70231, AGR [COUNT @D70230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSTALL, 
   [COORD @D70235, AGR [COUNT @D70234, PER @D70233, PLU @D70232, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INSTALL, 
   [COORD @D70241, PAST @D70240, 
      AGR [CASE @D70239, COUNT @D70238, PER @D70237, PLU @D70236, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : INSTALL, 
   [COORD @D70244, AGR [COUNT @D70243, PER @D70242, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INSTALL, 
   [COORD @D70246, AGR [COUNT @D70245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INSTALL, 
   [COORD @D70248, AGR [COUNT @D70247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INSTALL, 
   [COORD @D70252, AGR [COUNT @D70251, PER @D70250, PLU @D70249, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INSTALL, 
   [COORD @D70258, PAST @D70257, AGR [CASE @D70256, COUNT @D70255, 
            PER @D70254, PLU @D70253, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INSTALL.

WORD installed : 
   [COORD @D70269, AGR [CASE @D70268, COUNT @D70267, PER @D70266, 
            PLU @D70265, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INSTALL, 
   [COORD @D70274, AGR [CASE @D70273, COUNT @D70272, PER @D70271, 
            PLU @D70270, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INSTALL, 
   [COORD @D70279, AGR [CASE @D70278, COUNT @D70277, PER @D70276, 
            PLU @D70275, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INSTALL, 
   [COORD @D70284, AGR [CASE @D70283, COUNT @D70282, PER @D70281, 
            PLU @D70280, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INSTALL, 
   [COORD @D70289, AGR [CASE @D70288, COUNT @D70287, PER @D70286, 
            PLU @D70285, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INSTALL, 
   [COORD @D70294, AGR [CASE @D70293, COUNT @D70292, PER @D70291, 
            PLU @D70290, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INSTALL.

WORD installing : 
   [COORD @D70309, PRD @D70308, AGR [CASE @D70307, COUNT @D70306, 
            PER @D70305, PLU @D70304, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INSTALL, 
   [COORD @D70315, PRD @D70314, 
      AGR [CASE @D70313, COUNT @D70312, PER @D70311, PLU @D70310, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INSTALL.

WORD installs : 
   [COORD @D70323, AGR [COUNT @D70322, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INSTALL, 
   [COORD @D70325, 
      AGR [COUNT @D70324, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INSTALL.

WORD intend : 
   [COORD @D70332, AGR [COUNT @D70331, PER @D70330, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : INTEND, 
   [COORD @D70334, AGR [COUNT @D70333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : INTEND, 
   [COORD @D70336, AGR [COUNT @D70335, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : INTEND, 
   [COORD @D70340, AGR [COUNT @D70339, PER @D70338, PLU @D70337, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : INTEND, 
   [COORD @D70346, PAST @D70345, 
      AGR [CASE @D70344, COUNT @D70343, PER @D70342, PLU @D70341, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : INTEND, 
   [COORD @D70349, AGR [COUNT @D70348, PER @D70347, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTEND, 
   [COORD @D70351, AGR [COUNT @D70350, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTEND, 
   [COORD @D70353, AGR [COUNT @D70352, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTEND, 
   [COORD @D70357, AGR [COUNT @D70356, PER @D70355, PLU @D70354, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTEND, 
   [COORD @D70363, PAST @D70362, 
      AGR [CASE @D70361, COUNT @D70360, PER @D70359, PLU @D70358, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : INTEND, 
   [COORD @D70366, AGR [COUNT @D70365, PER @D70364, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : INTEND, 
   [COORD @D70368, AGR [COUNT @D70367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : INTEND, 
   [COORD @D70370, AGR [COUNT @D70369, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : INTEND, 
   [COORD @D70374, AGR [COUNT @D70373, PER @D70372, PLU @D70371, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : INTEND, 
   [COORD @D70380, PAST @D70379, AGR [CASE @D70378, COUNT @D70377, 
            PER @D70376, PLU @D70375, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : INTEND, 
   [COORD @D70383, AGR [COUNT @D70382, PER @D70381, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : INTEND, 
   [COORD @D70385, AGR [COUNT @D70384, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : INTEND, 
   [COORD @D70387, AGR [COUNT @D70386, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : INTEND, 
   [COORD @D70391, AGR [COUNT @D70390, PER @D70389, PLU @D70388, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : INTEND, 
   [COORD @D70397, PAST @D70396, AGR [CASE @D70395, COUNT @D70394, 
            PER @D70393, PLU @D70392, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : INTEND, 
   [COORD @D70400, AGR [COUNT @D70399, PER @D70398, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : INTEND, 
   [COORD @D70402, AGR [COUNT @D70401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : INTEND, 
   [COORD @D70404, AGR [COUNT @D70403, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : INTEND, 
   [COORD @D70408, AGR [COUNT @D70407, PER @D70406, PLU @D70405, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : INTEND, 
   [COORD @D70414, PAST @D70413, AGR [CASE @D70412, COUNT @D70411, 
            PER @D70410, PLU @D70409, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : INTEND.

WORD intended : 
   [COORD @D70423, REFL @D70422, PRD @D70421, CASE @D70420, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : INTENDED, 
   [COORD @D70428, 
      AGR [CASE @D70427, COUNT @D70426, PER @D70425, PLU @D70424, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INTEND, 
   [COORD @D70433, AGR [CASE @D70432, COUNT @D70431, PER @D70430, 
            PLU @D70429, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70438, AGR [CASE @D70437, COUNT @D70436, PER @D70435, 
            PLU @D70434, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70443, AGR [CASE @D70442, COUNT @D70441, PER @D70440, 
            PLU @D70439, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70448, AGR [CASE @D70447, COUNT @D70446, PER @D70445, 
            PLU @D70444, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70453, AGR [CASE @D70452, COUNT @D70451, PER @D70450, 
            PLU @D70449, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AS, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70458, AGR [CASE @D70457, COUNT @D70456, PER @D70455, 
            PLU @D70454, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70463, AGR [CASE @D70462, COUNT @D70461, PER @D70460, 
            PLU @D70459, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70468, AGR [CASE @D70467, COUNT @D70466, PER @D70465, 
            PLU @D70464, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70473, AGR [CASE @D70472, COUNT @D70471, PER @D70470, 
            PLU @D70469, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70479, AGR [CASE @D70478, NFORM @D70477, COUNT @D70476, 
            PER @D70475, PLU @D70474, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INTEND, 
   [COORD @D70484, AGR [UB @D70483, VFORM @D70482, SUBJ @D70481, 
            FIN @D70480, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INTEND, 
   [COORD @D70489, AGR [CASE @D70488, COUNT @D70487, PER @D70486, 
            PLU @D70485, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70494, AGR [CASE @D70493, COUNT @D70492, PER @D70491, 
            PLU @D70490, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INTEND.

WORD intendeds : 
   [COORD @D70506, DEMON @D70505, REFL @D70504, PRD @D70503, 
      CASE @D70502, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : INTENDED.

WORD intending : 
   [COORD @D70519, PRD @D70518, AGR [CASE @D70517, COUNT @D70516, 
            PER @D70515, PLU @D70514, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70525, PRD @D70524, 
      AGR [CASE @D70523, COUNT @D70522, PER @D70521, PLU @D70520, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : INTEND, 
   [COORD @D70531, PRD @D70530, AGR [CASE @D70529, COUNT @D70528, 
            PER @D70527, PLU @D70526, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTEND, 
   [COORD @D70537, PRD @D70536, 
      AGR [CASE @D70535, COUNT @D70534, PER @D70533, PLU @D70532, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INTEND, 
   [COORD @D70543, PRD @D70542, AGR [CASE @D70541, COUNT @D70540, 
            PER @D70539, PLU @D70538, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTEND.

WORD intends : 
   [COORD @D70550, AGR [COUNT @D70549, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTEND, 
   [COORD @D70552, 
      AGR [COUNT @D70551, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTEND, 
   [COORD @D70554, 
      AGR [COUNT @D70553, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTEND, 
   [COORD @D70556, 
      AGR [COUNT @D70555, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTEND, 
   [COORD @D70558, 
      AGR [COUNT @D70557, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTEND.

WORD interpret : 
   [COORD @D70565, AGR [COUNT @D70564, PER @D70563, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTERPRET, 
   [COORD @D70567, AGR [COUNT @D70566, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTERPRET, 
   [COORD @D70569, AGR [COUNT @D70568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTERPRET, 
   [COORD @D70573, AGR [COUNT @D70572, PER @D70571, PLU @D70570, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : INTERPRET, 
   [COORD @D70579, PAST @D70578, 
      AGR [CASE @D70577, COUNT @D70576, PER @D70575, PLU @D70574, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : INTERPRET, 
   [COORD @D70582, AGR [COUNT @D70581, PER @D70580, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INTERPRET, 
   [COORD @D70584, AGR [COUNT @D70583, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INTERPRET, 
   [COORD @D70586, AGR [COUNT @D70585, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INTERPRET, 
   [COORD @D70590, AGR [COUNT @D70589, PER @D70588, PLU @D70587, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INTERPRET, 
   [COORD @D70596, PAST @D70595, AGR [CASE @D70594, COUNT @D70593, 
            PER @D70592, PLU @D70591, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INTERPRET, 
   [COORD @D70599, AGR [COUNT @D70598, PER @D70597, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INTERPRET, 
   [COORD @D70601, AGR [COUNT @D70600, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INTERPRET, 
   [COORD @D70603, AGR [COUNT @D70602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INTERPRET, 
   [COORD @D70607, AGR [COUNT @D70606, PER @D70605, PLU @D70604, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : INTERPRET, 
   [COORD @D70613, PAST @D70612, AGR [CASE @D70611, COUNT @D70610, 
            PER @D70609, PLU @D70608, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : INTERPRET.

WORD interpreted : 
   [COORD @D70623, AGR [CASE @D70622, COUNT @D70621, PER @D70620, 
            PLU @D70619, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70628, AGR [CASE @D70627, COUNT @D70626, PER @D70625, 
            PLU @D70624, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70633, AGR 
         [CASE @D70632, COUNT @D70631, PER @D70630, PLU @D70629, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70638, AGR [CASE @D70637, COUNT @D70636, PER @D70635, 
            PLU @D70634, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70643, AGR [CASE @D70642, COUNT @D70641, PER @D70640, 
            PLU @D70639, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70648, AGR [CASE @D70647, COUNT @D70646, PER @D70645, 
            PLU @D70644, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70653, AGR [CASE @D70652, COUNT @D70651, PER @D70650, 
            PLU @D70649, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70658, AGR [CASE @D70657, COUNT @D70656, PER @D70655, 
            PLU @D70654, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INTERPRET.

WORD interpreting : 
   [COORD @D70671, PRD @D70670, AGR [CASE @D70669, COUNT @D70668, 
            PER @D70667, PLU @D70666, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70677, PRD @D70676, 
      AGR [CASE @D70675, COUNT @D70674, PER @D70673, PLU @D70672, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   INTERPRET, 
   [COORD @D70683, PRD @D70682, AGR [CASE @D70681, COUNT @D70680, 
            PER @D70679, PLU @D70678, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTERPRET.

WORD interprets : 
   [COORD @D70690, AGR [COUNT @D70689, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : INTERPRET, 
   [COORD @D70692, AGR [COUNT @D70691, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTERPRET, 
   [COORD @D70694, 
      AGR [COUNT @D70693, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTERPRET.

WORD introduce : 
   [COORD @D70702, AGR [COUNT @D70701, PER @D70700, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INTRODUCE, 
   [COORD @D70704, AGR [COUNT @D70703, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INTRODUCE, 
   [COORD @D70706, AGR [COUNT @D70705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INTRODUCE, 
   [COORD @D70710, AGR [COUNT @D70709, PER @D70708, PLU @D70707, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : INTRODUCE, 
   [COORD @D70716, PAST @D70715, 
      AGR [CASE @D70714, COUNT @D70713, PER @D70712, PLU @D70711, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : INTRODUCE, 
   [COORD @D70719, AGR [COUNT @D70718, PER @D70717, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : INTRODUCE, 
   [COORD @D70721, AGR [COUNT @D70720, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : INTRODUCE, 
   [COORD @D70723, AGR [COUNT @D70722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : INTRODUCE, 
   [COORD @D70727, AGR [COUNT @D70726, PER @D70725, PLU @D70724, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : INTRODUCE, 
   [COORD @D70733, PAST @D70732, 
      AGR [CASE @D70731, COUNT @D70730, PER @D70729, PLU @D70728, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, 
      ARITY 3] : INTRODUCE, 
   [COORD @D70736, AGR [COUNT @D70735, PER @D70734, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INTRODUCE, 
   [COORD @D70738, AGR [COUNT @D70737, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INTRODUCE, 
   [COORD @D70740, AGR [COUNT @D70739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INTRODUCE, 
   [COORD @D70744, AGR [COUNT @D70743, PER @D70742, PLU @D70741, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INTRODUCE, 
   [COORD @D70750, PAST @D70749, AGR [CASE @D70748, COUNT @D70747, 
            PER @D70746, PLU @D70745, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INTRODUCE.

WORD introduced : 
   [COORD @D70761, AGR [CASE @D70760, COUNT @D70759, PER @D70758, 
            PLU @D70757, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70766, AGR [CASE @D70765, COUNT @D70764, PER @D70763, 
            PLU @D70762, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70771, AGR 
         [CASE @D70770, COUNT @D70769, PER @D70768, PLU @D70767, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70776, AGR [CASE @D70775, COUNT @D70774, PER @D70773, 
            PLU @D70772, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70781, AGR [CASE @D70780, COUNT @D70779, PER @D70778, 
            PLU @D70777, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70786, AGR 
         [CASE @D70785, COUNT @D70784, PER @D70783, PLU @D70782, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70791, AGR [CASE @D70790, COUNT @D70789, PER @D70788, 
            PLU @D70787, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70796, AGR [CASE @D70795, COUNT @D70794, PER @D70793, 
            PLU @D70792, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70801, AGR [CASE @D70800, COUNT @D70799, PER @D70798, 
            PLU @D70797, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INTRODUCE.

WORD introduces : 
   [COORD @D70809, AGR [COUNT @D70808, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : INTRODUCE, 
   [COORD @D70811, AGR [COUNT @D70810, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : INTRODUCE, 
   [COORD @D70813, AGR [COUNT @D70812, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INTRODUCE.

WORD introducing : 
   [COORD @D70825, PRD @D70824, AGR [CASE @D70823, COUNT @D70822, 
            PER @D70821, PLU @D70820, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : INTRODUCE, 
   [COORD @D70831, PRD @D70830, 
      AGR [CASE @D70829, COUNT @D70828, PER @D70827, PLU @D70826, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : INTRODUCE, 
   [COORD @D70837, PRD @D70836, AGR [CASE @D70835, COUNT @D70834, 
            PER @D70833, PLU @D70832, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INTRODUCE.

WORD involve : 
   [COORD @D70845, AGR [COUNT @D70844, PER @D70843, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INVOLVE, 
   [COORD @D70847, AGR [COUNT @D70846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INVOLVE, 
   [COORD @D70849, AGR [COUNT @D70848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INVOLVE, 
   [COORD @D70853, AGR [COUNT @D70852, PER @D70851, PLU @D70850, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : INVOLVE, 
   [COORD @D70859, PAST @D70858, 
      AGR [CASE @D70857, COUNT @D70856, PER @D70855, PLU @D70854, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : INVOLVE, 
   [COORD @D70862, AGR [COUNT @D70861, PER @D70860, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INVOLVE, 
   [COORD @D70864, AGR [COUNT @D70863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INVOLVE, 
   [COORD @D70866, AGR [COUNT @D70865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INVOLVE, 
   [COORD @D70870, AGR [COUNT @D70869, PER @D70868, PLU @D70867, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : INVOLVE, 
   [COORD @D70876, PAST @D70875, 
      AGR [CASE @D70874, COUNT @D70873, PER @D70872, PLU @D70871, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : INVOLVE, 
   [COORD @D70879, AGR [COUNT @D70878, PER @D70877, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INVOLVE, 
   [COORD @D70881, AGR [COUNT @D70880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INVOLVE, 
   [COORD @D70883, AGR [COUNT @D70882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : INVOLVE, 
   [COORD @D70887, AGR [COUNT @D70886, PER @D70885, PLU @D70884, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : INVOLVE, 
   [COORD @D70893, PAST @D70892, AGR [CASE @D70891, COUNT @D70890, 
            PER @D70889, PLU @D70888, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : INVOLVE.

WORD involved : 
   [COADV @D70907, COORD @D70906, DEF @D70905, PRD @D70904, AGR 
         [CASE @D70903, COUNT @D70902, PER @D70901, PLU @D70900, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : INVOLVED, 
   [COADV @D70915, COORD @D70914, DEF @D70913, PRD @D70912, 
      AGR [CASE @D70911, COUNT @D70910, PER @D70909, PLU @D70908, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, DISTR PRD, 
      ARITY 2] : INVOLVED, 
   [COORD @D70920, AGR [CASE @D70919, COUNT @D70918, PER @D70917, 
            PLU @D70916, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70925, AGR [CASE @D70924, COUNT @D70923, PER @D70922, 
            PLU @D70921, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70930, AGR [CASE @D70929, COUNT @D70928, PER @D70927, 
            PLU @D70926, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70935, AGR [CASE @D70934, COUNT @D70933, PER @D70932, 
            PLU @D70931, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70940, AGR [CASE @D70939, COUNT @D70938, PER @D70937, 
            PLU @D70936, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70945, AGR [CASE @D70944, COUNT @D70943, PER @D70942, 
            PLU @D70941, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70950, AGR [CASE @D70949, COUNT @D70948, PER @D70947, 
            PLU @D70946, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70955, AGR [CASE @D70954, COUNT @D70953, PER @D70952, 
            PLU @D70951, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70960, AGR [CASE @D70959, COUNT @D70958, PER @D70957, 
            PLU @D70956, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : INVOLVE.

WORD involves : 
   [COORD @D70968, AGR [COUNT @D70967, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   INVOLVE, 
   [COORD @D70970, AGR [COUNT @D70969, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70972, 
      AGR [COUNT @D70971, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : INVOLVE.

WORD involving : 
   [COORD @D70983, PRD @D70982, AGR [CASE @D70981, COUNT @D70980, 
            PER @D70979, PLU @D70978, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : INVOLVE, 
   [COORD @D70989, PRD @D70988, 
      AGR [CASE @D70987, COUNT @D70986, PER @D70985, PLU @D70984, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : INVOLVE, 
   [COORD @D70995, PRD @D70994, AGR [CASE @D70993, COUNT @D70992, 
            PER @D70991, PLU @D70990, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : INVOLVE.

WORD issue : 
   [COORD @D71006, REFL @D71005, COUNT @D71004, PRD @D71003, CASE 
         @D71002, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ISSUE, 
   [COORD @D71010, REFL @D71009, PRD @D71008, CASE @D71007, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, GROUP +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT -] : ISSUE, 
   [COORD @D71013, 
      AGR [COUNT @D71012, PER @D71011, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : ISSUE, 
   [COORD @D71015, AGR [COUNT @D71014, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : ISSUE, 
   [COORD @D71017, AGR [COUNT @D71016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : ISSUE, 
   [COORD @D71021, AGR [COUNT @D71020, PER @D71019, PLU @D71018, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : ISSUE, 
   [COORD @D71027, PAST @D71026, 
      AGR [CASE @D71025, COUNT @D71024, PER @D71023, PLU @D71022, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : ISSUE, 
   [COORD @D71030, AGR [COUNT @D71029, PER @D71028, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ISSUE, 
   [COORD @D71032, AGR [COUNT @D71031, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ISSUE, 
   [COORD @D71034, AGR [COUNT @D71033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ISSUE, 
   [COORD @D71038, AGR [COUNT @D71037, PER @D71036, PLU @D71035, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : ISSUE, 
   [COORD @D71044, PAST @D71043, 
      AGR [CASE @D71042, COUNT @D71041, PER @D71040, PLU @D71039, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : ISSUE, 
   [COORD @D71047, AGR [COUNT @D71046, PER @D71045, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ISSUE, 
   [COORD @D71049, AGR [COUNT @D71048, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ISSUE, 
   [COORD @D71051, AGR [COUNT @D71050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ISSUE, 
   [COORD @D71055, AGR [COUNT @D71054, PER @D71053, PLU @D71052, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ISSUE, 
   [COORD @D71061, PAST @D71060, AGR [CASE @D71059, COUNT @D71058, 
            PER @D71057, PLU @D71056, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ISSUE, 
   [COORD @D71064, AGR [COUNT @D71063, PER @D71062, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : ISSUE, 
   [COORD @D71066, AGR [COUNT @D71065, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : ISSUE, 
   [COORD @D71068, AGR [COUNT @D71067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : ISSUE, 
   [COORD @D71072, AGR [COUNT @D71071, PER @D71070, PLU @D71069, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : ISSUE, 
   [COORD @D71078, PAST @D71077, 
      AGR [CASE @D71076, COUNT @D71075, PER @D71074, PLU @D71073, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, 
      ARITY 2] : ISSUE, 
   [COORD @D71081, AGR [COUNT @D71080, PER @D71079, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : ISSUE, 
   [COORD @D71083, AGR [COUNT @D71082, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : ISSUE, 
   [COORD @D71085, AGR [COUNT @D71084, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : ISSUE, 
   [COORD @D71089, AGR [COUNT @D71088, PER @D71087, PLU @D71086, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORTH, ARITY 1] : ISSUE, 
   [COORD @D71095, PAST @D71094, 
      AGR [CASE @D71093, COUNT @D71092, PER @D71091, PLU @D71090, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT FORTH, 
      ARITY 1] : ISSUE.

WORD issued : 
   [COORD @D71108, AGR [CASE @D71107, COUNT @D71106, PER @D71105, 
            PLU @D71104, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71113, AGR [CASE @D71112, COUNT @D71111, PER @D71110, 
            PLU @D71109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71118, AGR [CASE @D71117, COUNT @D71116, PER @D71115, 
            PLU @D71114, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71123, AGR [CASE @D71122, COUNT @D71121, PER @D71120, 
            PLU @D71119, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71128, AGR [CASE @D71127, COUNT @D71126, PER @D71125, 
            PLU @D71124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71133, AGR [CASE @D71132, COUNT @D71131, PER @D71130, 
            PLU @D71129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71138, AGR [CASE @D71137, COUNT @D71136, PER @D71135, 
            PLU @D71134, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71143, AGR [CASE @D71142, COUNT @D71141, PER @D71140, 
            PLU @D71139, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71148, AGR [CASE @D71147, COUNT @D71146, PER @D71145, 
            PLU @D71144, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ISSUE, 
   [COORD @D71153, AGR [CASE @D71152, COUNT @D71151, PER @D71150, 
            PLU @D71149, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71158, AGR [CASE @D71157, COUNT @D71156, PER @D71155, 
            PLU @D71154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71163, AGR [CASE @D71162, COUNT @D71161, PER @D71160, 
            PLU @D71159, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71168, AGR [CASE @D71167, COUNT @D71166, PER @D71165, 
            PLU @D71164, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71173, AGR [CASE @D71172, COUNT @D71171, PER @D71170, 
            PLU @D71169, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ISSUE.

WORD issues : 
   [COORD @D71186, DEMON @D71185, REFL @D71184, PRD @D71183, CASE 
         @D71182, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : ISSUE, 
   [COORD @D71188, 
      AGR [COUNT @D71187, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ISSUE, 
   [COORD @D71190, AGR [COUNT @D71189, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71192, 
      AGR [COUNT @D71191, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71194, 
      AGR [COUNT @D71193, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71196, 
      AGR [COUNT @D71195, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ISSUE.

WORD issuing : 
   [COORD @D71208, PRD @D71207, AGR [CASE @D71206, COUNT @D71205, 
            PER @D71204, PLU @D71203, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71214, PRD @D71213, 
      AGR [CASE @D71212, COUNT @D71211, PER @D71210, PLU @D71209, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ISSUE, 
   [COORD @D71220, PRD @D71219, AGR [CASE @D71218, COUNT @D71217, 
            PER @D71216, PLU @D71215, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ISSUE, 
   [COORD @D71226, PRD @D71225, 
      AGR [CASE @D71224, COUNT @D71223, PER @D71222, PLU @D71221, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ISSUE, 
   [COORD @D71232, PRD @D71231, AGR [CASE @D71230, COUNT @D71229, 
            PER @D71228, PLU @D71227, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ISSUE.

WORD jay : 
   [COORD @D71238, REFL @D71237, PRD @D71236, CASE @D71235, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : JAY.

WORD jays : 
   [COORD @D71246, DEMON @D71245, REFL @D71244, PRD @D71243, CASE 
         @D71242, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : JAY.

WORD join : 
   [COORD @D71251, AGR [COUNT @D71250, PER @D71249, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : JOIN, 
   [COORD @D71253, AGR [COUNT @D71252, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : JOIN, 
   [COORD @D71255, AGR [COUNT @D71254, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : JOIN, 
   [COORD @D71259, AGR [COUNT @D71258, PER @D71257, PLU @D71256, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : JOIN, 
   [COORD @D71265, PAST @D71264, 
      AGR [CASE @D71263, COUNT @D71262, PER @D71261, PLU @D71260, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : JOIN, 
   [COORD @D71268, AGR [COUNT @D71267, PER @D71266, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : JOIN, 
   [COORD @D71270, AGR [COUNT @D71269, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : JOIN, 
   [COORD @D71272, AGR [COUNT @D71271, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : JOIN, 
   [COORD @D71276, AGR [COUNT @D71275, PER @D71274, PLU @D71273, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : JOIN, 
   [COORD @D71282, PAST @D71281, 
      AGR [CASE @D71280, COUNT @D71279, PER @D71278, PLU @D71277, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : JOIN, 
   [COORD @D71285, AGR [COUNT @D71284, PER @D71283, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JOIN, 
   [COORD @D71287, AGR [COUNT @D71286, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JOIN, 
   [COORD @D71289, AGR [COUNT @D71288, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JOIN, 
   [COORD @D71293, AGR [COUNT @D71292, PER @D71291, PLU @D71290, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : JOIN, 
   [COORD @D71299, PAST @D71298, AGR [CASE @D71297, COUNT @D71296, 
            PER @D71295, PLU @D71294, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : JOIN, 
   [COORD @D71302, AGR [COUNT @D71301, PER @D71300, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : JOIN, 
   [COORD @D71304, AGR [COUNT @D71303, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : JOIN, 
   [COORD @D71306, AGR [COUNT @D71305, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : JOIN, 
   [COORD @D71310, AGR [COUNT @D71309, PER @D71308, PLU @D71307, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM WITH, ARITY 2] : JOIN, 
   [COORD @D71316, PAST @D71315, 
      AGR [CASE @D71314, COUNT @D71313, PER @D71312, PLU @D71311, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM WITH, ARITY 2] : JOIN, 
   [COORD @D71319, AGR [COUNT @D71318, PER @D71317, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : JOIN, 
   [COORD @D71321, AGR [COUNT @D71320, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : JOIN, 
   [COORD @D71323, AGR [COUNT @D71322, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : JOIN, 
   [COORD @D71327, AGR [COUNT @D71326, PER @D71325, PLU @D71324, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : JOIN, 
   [COORD @D71333, PAST @D71332, 
      AGR [CASE @D71331, COUNT @D71330, PER @D71329, PLU @D71328, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : JOIN, 
   [COORD @D71336, AGR [COUNT @D71335, PER @D71334, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : JOIN, 
   [COORD @D71338, AGR [COUNT @D71337, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : JOIN, 
   [COORD @D71340, AGR [COUNT @D71339, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : JOIN, 
   [COORD @D71344, AGR [COUNT @D71343, PER @D71342, PLU @D71341, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : JOIN, 
   [COORD @D71350, PAST @D71349, 
      AGR [CASE @D71348, COUNT @D71347, PER @D71346, PLU @D71345, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : JOIN, 
   [COORD @D71353, AGR [COUNT @D71352, PER @D71351, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JOIN, 
   [COORD @D71355, AGR [COUNT @D71354, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JOIN, 
   [COORD @D71357, AGR [COUNT @D71356, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JOIN, 
   [COORD @D71361, AGR [COUNT @D71360, PER @D71359, PLU @D71358, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JOIN, 
   [COORD @D71367, PAST @D71366, AGR [CASE @D71365, COUNT @D71364, 
            PER @D71363, PLU @D71362, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : JOIN, 
   [COORD @D71370, AGR [COUNT @D71369, PER @D71368, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : JOIN, 
   [COORD @D71372, AGR [COUNT @D71371, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : JOIN, 
   [COORD @D71374, AGR [COUNT @D71373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : JOIN, 
   [COORD @D71378, AGR [COUNT @D71377, PER @D71376, PLU @D71375, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : JOIN, 
   [COORD @D71384, PAST @D71383, 
      AGR [CASE @D71382, COUNT @D71381, PER @D71380, PLU @D71379, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : JOIN, 
   [COORD @D71387, AGR [COUNT @D71386, PER @D71385, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : JOIN, 
   [COORD @D71389, AGR [COUNT @D71388, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : JOIN, 
   [COORD @D71391, AGR [COUNT @D71390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : JOIN, 
   [COORD @D71395, AGR [COUNT @D71394, PER @D71393, PLU @D71392, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : JOIN, 
   [COORD @D71401, PAST @D71400, 
      AGR [CASE @D71399, COUNT @D71398, PER @D71397, PLU @D71396, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, 
      ARITY 1] : JOIN, 
   [COORD @D71404, AGR [COUNT @D71403, PER @D71402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : JOIN, 
   [COORD @D71406, AGR [COUNT @D71405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : JOIN, 
   [COORD @D71408, AGR [COUNT @D71407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : JOIN, 
   [COORD @D71412, AGR [COUNT @D71411, PER @D71410, PLU @D71409, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : JOIN, 
   [COORD @D71418, PAST @D71417, 
      AGR [CASE @D71416, COUNT @D71415, PER @D71414, PLU @D71413, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : JOIN.

WORD joined : 
   [COORD @D71426, AGR [CASE @D71425, COUNT @D71424, PER @D71423, 
            PLU @D71422, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71431, AGR [CASE @D71430, COUNT @D71429, PER @D71428, 
            PLU @D71427, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71436, AGR [CASE @D71435, COUNT @D71434, PER @D71433, 
            PLU @D71432, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71441, AGR [CASE @D71440, COUNT @D71439, PER @D71438, 
            PLU @D71437, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71446, AGR [CASE @D71445, COUNT @D71444, PER @D71443, 
            PLU @D71442, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71451, AGR [CASE @D71450, COUNT @D71449, PER @D71448, 
            PLU @D71447, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71456, AGR [CASE @D71455, COUNT @D71454, PER @D71453, 
            PLU @D71452, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : JOIN, 
   [COORD @D71461, AGR [CASE @D71460, COUNT @D71459, PER @D71458, 
            PLU @D71457, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71466, AGR [CASE @D71465, COUNT @D71464, PER @D71463, 
            PLU @D71462, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71471, AGR [CASE @D71470, COUNT @D71469, PER @D71468, 
            PLU @D71467, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71476, AGR [CASE @D71475, COUNT @D71474, PER @D71473, 
            PLU @D71472, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71481, AGR [CASE @D71480, COUNT @D71479, PER @D71478, 
            PLU @D71477, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71486, AGR [CASE @D71485, COUNT @D71484, PER @D71483, 
            PLU @D71482, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71491, AGR [CASE @D71490, COUNT @D71489, PER @D71488, 
            PLU @D71487, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71496, AGR [CASE @D71495, COUNT @D71494, PER @D71493, 
            PLU @D71492, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71501, AGR [CASE @D71500, COUNT @D71499, PER @D71498, 
            PLU @D71497, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71506, AGR [CASE @D71505, COUNT @D71504, PER @D71503, 
            PLU @D71502, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71511, AGR [CASE @D71510, COUNT @D71509, PER @D71508, 
            PLU @D71507, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71516, AGR [CASE @D71515, COUNT @D71514, PER @D71513, 
            PLU @D71512, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71521, AGR [CASE @D71520, COUNT @D71519, PER @D71518, 
            PLU @D71517, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71526, AGR [CASE @D71525, COUNT @D71524, PER @D71523, 
            PLU @D71522, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71531, AGR [CASE @D71530, COUNT @D71529, PER @D71528, 
            PLU @D71527, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71536, AGR [CASE @D71535, COUNT @D71534, PER @D71533, 
            PLU @D71532, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71541, AGR [CASE @D71540, COUNT @D71539, PER @D71538, 
            PLU @D71537, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71546, AGR [CASE @D71545, COUNT @D71544, PER @D71543, 
            PLU @D71542, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JOIN.

WORD joining : 
   [COORD @D71557, PRD @D71556, AGR [CASE @D71555, COUNT @D71554, 
            PER @D71553, PLU @D71552, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71563, PRD @D71562, 
      AGR [CASE @D71561, COUNT @D71560, PER @D71559, PLU @D71558, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : JOIN, 
   [COORD @D71569, PRD @D71568, AGR [CASE @D71567, COUNT @D71566, 
            PER @D71565, PLU @D71564, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71575, PRD @D71574, 
      AGR [CASE @D71573, COUNT @D71572, PER @D71571, PLU @D71570, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : JOIN, 
   [COORD @D71581, PRD @D71580, AGR [CASE @D71579, COUNT @D71578, 
            PER @D71577, PLU @D71576, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71587, PRD @D71586, 
      AGR [CASE @D71585, COUNT @D71584, PER @D71583, PLU @D71582, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : JOIN, 
   [COORD @D71593, PRD @D71592, AGR [CASE @D71591, COUNT @D71590, 
            PER @D71589, PLU @D71588, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71599, PRD @D71598, 
      AGR [CASE @D71597, COUNT @D71596, PER @D71595, PLU @D71594, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : JOIN, 
   [COORD @D71605, PRD @D71604, AGR [CASE @D71603, COUNT @D71602, 
            PER @D71601, PLU @D71600, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : JOIN, 
   [COORD @D71611, PRD @D71610, 
      AGR [CASE @D71609, COUNT @D71608, PER @D71607, PLU @D71606, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : JOIN.

WORD joins : 
   [COORD @D71616, AGR [COUNT @D71615, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN, 
   [COORD @D71618, 
      AGR [COUNT @D71617, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN, 
   [COORD @D71620, 
      AGR [COUNT @D71619, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN, 
   [COORD @D71622, 
      AGR [COUNT @D71621, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   JOIN, 
   [COORD @D71624, AGR [COUNT @D71623, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN, 
   [COORD @D71626, 
      AGR [COUNT @D71625, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN, 
   [COORD @D71628, 
      AGR [COUNT @D71627, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN, 
   [COORD @D71630, 
      AGR [COUNT @D71629, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN, 
   [COORD @D71632, 
      AGR [COUNT @D71631, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   JOIN, 
   [COORD @D71634, AGR [COUNT @D71633, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOIN.

WORD joint : 
   [COORD @D71641, REFL @D71640, PRD @D71639, CASE @D71638, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : JOINT, 
   [COORD @D71644, 
      AGR [COUNT @D71643, PER @D71642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   JOINT, 
   [COORD @D71646, AGR [COUNT @D71645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JOINT, 
   [COORD @D71648, AGR [COUNT @D71647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JOINT, 
   [COORD @D71652, AGR [COUNT @D71651, PER @D71650, PLU @D71649, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : JOINT, 
   [COORD @D71658, PAST @D71657, AGR [CASE @D71656, COUNT @D71655, 
            PER @D71654, PLU @D71653, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : JOINT.

WORD jointed : 
   [COORD @D71669, AGR [CASE @D71668, COUNT @D71667, PER @D71666, 
            PLU @D71665, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : JOINT, 
   [COORD @D71674, AGR [CASE @D71673, COUNT @D71672, PER @D71671, 
            PLU @D71670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JOINT, 
   [COORD @D71679, AGR [CASE @D71678, COUNT @D71677, PER @D71676, 
            PLU @D71675, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JOINT.

WORD jointing : 
   [COORD @D71697, PRD @D71696, AGR [CASE @D71695, COUNT @D71694, 
            PER @D71693, PLU @D71692, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JOINT.

WORD joints : 
   [COORD @D71708, DEMON @D71707, REFL @D71706, PRD @D71705, CASE 
         @D71704, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : JOINT, 
   [COORD @D71710, 
      AGR [COUNT @D71709, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JOINT.

WORD judge : 
   [COORD @D71722, REFL @D71721, PRD @D71720, CASE @D71719, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, ADDRESS +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : JUDGE, 
   [COORD @D71726, REFL @D71725, PRD @D71724, CASE @D71723, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : JUDGE, 
   [COORD @D71731, REFL @D71730, COUNT @D71729, PRD @D71728, 
      CASE @D71727, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : JUDGE, 
   [COORD @D71735, REFL @D71734, PRD @D71733, CASE @D71732, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : JUDGE, 
   [COORD @D71738, 
      AGR [COUNT @D71737, PER @D71736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, ARITY 2] : 
   JUDGE, 
   [COORD @D71740, AGR [COUNT @D71739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : JUDGE, 
   [COORD @D71742, AGR [COUNT @D71741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : JUDGE, 
   [COORD @D71746, AGR [COUNT @D71745, PER @D71744, PLU @D71743, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : JUDGE, 
   [COORD @D71752, PAST @D71751, AGR [CASE @D71750, COUNT @D71749, 
            PER @D71748, PLU @D71747, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : JUDGE, 
   [COORD @D71755, AGR [COUNT @D71754, PER @D71753, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : JUDGE, 
   [COORD @D71757, AGR [COUNT @D71756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : JUDGE, 
   [COORD @D71759, AGR [COUNT @D71758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : JUDGE, 
   [COORD @D71763, AGR [COUNT @D71762, PER @D71761, PLU @D71760, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : JUDGE, 
   [COORD @D71769, PAST @D71768, AGR [CASE @D71767, COUNT @D71766, 
            PER @D71765, PLU @D71764, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : JUDGE, 
   [COORD @D71772, AGR [COUNT @D71771, PER @D71770, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : JUDGE, 
   [COORD @D71774, AGR [COUNT @D71773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : JUDGE, 
   [COORD @D71776, AGR [COUNT @D71775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : JUDGE, 
   [COORD @D71780, AGR [COUNT @D71779, PER @D71778, PLU @D71777, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : JUDGE, 
   [COORD @D71786, PAST @D71785, AGR [CASE @D71784, COUNT @D71783, 
            PER @D71782, PLU @D71781, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_NP, ARITY 2] : JUDGE, 
   [COORD @D71789, AGR [COUNT @D71788, PER @D71787, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : JUDGE, 
   [COORD @D71791, AGR [COUNT @D71790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : JUDGE, 
   [COORD @D71793, AGR [COUNT @D71792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : JUDGE, 
   [COORD @D71797, AGR [COUNT @D71796, PER @D71795, PLU @D71794, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : JUDGE, 
   [COORD @D71803, PAST @D71802, AGR [CASE @D71801, COUNT @D71800, 
            PER @D71799, PLU @D71798, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : JUDGE, 
   [COORD @D71806, AGR [COUNT @D71805, PER @D71804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : JUDGE, 
   [COORD @D71808, AGR [COUNT @D71807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : JUDGE, 
   [COORD @D71810, AGR [COUNT @D71809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : JUDGE, 
   [COORD @D71814, AGR [COUNT @D71813, PER @D71812, PLU @D71811, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : JUDGE, 
   [COORD @D71820, PAST @D71819, AGR [CASE @D71818, COUNT @D71817, 
            PER @D71816, PLU @D71815, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : JUDGE, 
   [COORD @D71823, AGR [COUNT @D71822, PER @D71821, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JUDGE, 
   [COORD @D71825, AGR [COUNT @D71824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JUDGE, 
   [COORD @D71827, AGR [COUNT @D71826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JUDGE, 
   [COORD @D71831, AGR [COUNT @D71830, PER @D71829, PLU @D71828, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : JUDGE, 
   [COORD @D71837, PAST @D71836, AGR [CASE @D71835, COUNT @D71834, 
            PER @D71833, PLU @D71832, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : JUDGE, 
   [COORD @D71840, AGR [COUNT @D71839, PER @D71838, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUDGE, 
   [COORD @D71842, AGR [COUNT @D71841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUDGE, 
   [COORD @D71844, AGR [COUNT @D71843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUDGE, 
   [COORD @D71848, AGR [COUNT @D71847, PER @D71846, PLU @D71845, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUDGE, 
   [COORD @D71854, PAST @D71853, AGR [CASE @D71852, COUNT @D71851, 
            PER @D71850, PLU @D71849, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : JUDGE.

WORD judged : 
   [COORD @D71865, AGR [CASE @D71864, COUNT @D71863, PER @D71862, 
            PLU @D71861, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71870, AGR [CASE @D71869, COUNT @D71868, PER @D71867, 
            PLU @D71866, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71875, AGR [UB @D71874, VFORM @D71873, SUBJ @D71872, 
            FIN @D71871, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : JUDGE, 
   [COORD @D71880, AGR [CASE @D71879, COUNT @D71878, PER @D71877, 
            PLU @D71876, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71885, AGR [CASE @D71884, COUNT @D71883, PER @D71882, 
            PLU @D71881, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71890, AGR [CASE @D71889, COUNT @D71888, PER @D71887, 
            PLU @D71886, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : JUDGE, 
   [COORD @D71895, AGR [CASE @D71894, COUNT @D71893, PER @D71892, 
            PLU @D71891, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71900, AGR [CASE @D71899, COUNT @D71898, PER @D71897, 
            PLU @D71896, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71906, AGR [CASE @D71905, NFORM @D71904, COUNT @D71903, 
            PER @D71902, PLU @D71901, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : JUDGE, 
   [COORD @D71911, AGR [UB @D71910, VFORM @D71909, SUBJ @D71908, 
            FIN @D71907, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : JUDGE, 
   [COORD @D71916, AGR [CASE @D71915, COUNT @D71914, PER @D71913, 
            PLU @D71912, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71921, AGR [CASE @D71920, COUNT @D71919, PER @D71918, 
            PLU @D71917, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71926, AGR [CASE @D71925, COUNT @D71924, PER @D71923, 
            PLU @D71922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71931, AGR [CASE @D71930, COUNT @D71929, PER @D71928, 
            PLU @D71927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71937, AGR [CASE @D71936, NFORM @D71935, COUNT @D71934, 
            PER @D71933, PLU @D71932, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : JUDGE, 
   [COORD @D71942, AGR [UB @D71941, VFORM @D71940, SUBJ @D71939, 
            FIN @D71938, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : JUDGE, 
   [COORD @D71947, AGR [CASE @D71946, COUNT @D71945, PER @D71944, 
            PLU @D71943, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71952, AGR [CASE @D71951, COUNT @D71950, PER @D71949, 
            PLU @D71948, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71957, AGR [CASE @D71956, COUNT @D71955, PER @D71954, 
            PLU @D71953, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : JUDGE, 
   [COORD @D71962, AGR [CASE @D71961, COUNT @D71960, PER @D71959, 
            PLU @D71958, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71967, AGR [CASE @D71966, COUNT @D71965, PER @D71964, 
            PLU @D71963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUDGE.

WORD judges : 
   [COORD @D71978, DEMON @D71977, REFL @D71976, PRD @D71975, CASE 
         @D71974, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : JUDGE, 
   [COORD @D71983, DEMON @D71982, REFL @D71981, PRD @D71980, 
      CASE @D71979, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : JUDGE, 
   [COORD @D71988, DEMON @D71987, REFL @D71986, PRD @D71985, 
      CASE @D71984, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   JUDGE, 
   [COORD @D71990, AGR [COUNT @D71989, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71992, 
      AGR [COUNT @D71991, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71994, 
      AGR [COUNT @D71993, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71996, 
      AGR [COUNT @D71995, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUDGE, 
   [COORD @D71998, 
      AGR [COUNT @D71997, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUDGE, 
   [COORD @D72000, 
      AGR [COUNT @D71999, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUDGE, 
   [COORD @D72002, 
      AGR [COUNT @D72001, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUDGE.

WORD judging : 
   [COORD @D72012, PRD @D72011, AGR [CASE @D72010, COUNT @D72009, 
            PER @D72008, PLU @D72007, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D72018, PRD @D72017, 
      AGR [CASE @D72016, COUNT @D72015, PER @D72014, PLU @D72013, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   JUDGE, 
   [COORD @D72024, PRD @D72023, AGR [CASE @D72022, COUNT @D72021, 
            PER @D72020, PLU @D72019, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D72030, PRD @D72029, 
      AGR [CASE @D72028, COUNT @D72027, PER @D72026, PLU @D72025, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   JUDGE, 
   [COORD @D72036, PRD @D72035, AGR [CASE @D72034, COUNT @D72033, 
            PER @D72032, PLU @D72031, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUDGE, 
   [COORD @D72042, PRD @D72041, 
      AGR [CASE @D72040, COUNT @D72039, PER @D72038, PLU @D72037, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   JUDGE, 
   [COORD @D72048, PRD @D72047, AGR [CASE @D72046, COUNT @D72045, 
            PER @D72044, PLU @D72043, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUDGE.

WORD jump : 
   [COORD @D72054, REFL @D72053, PRD @D72052, CASE @D72051, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : JUMP, 
   [COORD @D72057, 
      AGR [COUNT @D72056, PER @D72055, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   JUMP, 
   [COORD @D72059, AGR [COUNT @D72058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JUMP, 
   [COORD @D72061, AGR [COUNT @D72060, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : JUMP, 
   [COORD @D72065, AGR [COUNT @D72064, PER @D72063, PLU @D72062, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : JUMP, 
   [COORD @D72071, PAST @D72070, AGR [CASE @D72069, COUNT @D72068, 
            PER @D72067, PLU @D72066, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : JUMP, 
   [COORD @D72074, AGR [COUNT @D72073, PER @D72072, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : JUMP, 
   [COORD @D72076, AGR [COUNT @D72075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : JUMP, 
   [COORD @D72078, AGR [COUNT @D72077, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : JUMP, 
   [COORD @D72082, AGR [COUNT @D72081, PER @D72080, PLU @D72079, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, ARITY 2] : JUMP, 
   [COORD @D72088, PAST @D72087, 
      AGR [CASE @D72086, COUNT @D72085, PER @D72084, PLU @D72083, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      ARITY 2] : JUMP, 
   [COORD @D72091, AGR [COUNT @D72090, PER @D72089, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : JUMP, 
   [COORD @D72093, AGR [COUNT @D72092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : JUMP, 
   [COORD @D72095, AGR [COUNT @D72094, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : JUMP, 
   [COORD @D72099, AGR [COUNT @D72098, PER @D72097, PLU @D72096, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : JUMP, 
   [COORD @D72105, PAST @D72104, 
      AGR [CASE @D72103, COUNT @D72102, PER @D72101, PLU @D72100, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : JUMP, 
   [COORD @D72108, AGR [COUNT @D72107, PER @D72106, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUMP, 
   [COORD @D72110, AGR [COUNT @D72109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUMP, 
   [COORD @D72112, AGR [COUNT @D72111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUMP, 
   [COORD @D72116, AGR [COUNT @D72115, PER @D72114, PLU @D72113, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : JUMP, 
   [COORD @D72122, PAST @D72121, AGR [CASE @D72120, COUNT @D72119, 
            PER @D72118, PLU @D72117, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : JUMP, 
   [COORD @D72125, AGR [COUNT @D72124, PER @D72123, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : JUMP, 
   [COORD @D72127, AGR [COUNT @D72126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : JUMP, 
   [COORD @D72129, AGR [COUNT @D72128, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : JUMP, 
   [COORD @D72133, AGR [COUNT @D72132, PER @D72131, PLU @D72130, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : JUMP, 
   [COORD @D72139, PAST @D72138, 
      AGR [CASE @D72137, COUNT @D72136, PER @D72135, PLU @D72134, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : JUMP.

WORD jumped : 
   [COORD @D72148, AGR [CASE @D72147, COUNT @D72146, PER @D72145, 
            PLU @D72144, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : JUMP, 
   [COORD @D72153, AGR [CASE @D72152, COUNT @D72151, PER @D72150, 
            PLU @D72149, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72158, AGR [CASE @D72157, COUNT @D72156, PER @D72155, 
            PLU @D72154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72163, AGR [CASE @D72162, COUNT @D72161, PER @D72160, 
            PLU @D72159, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72168, AGR [CASE @D72167, COUNT @D72166, PER @D72165, 
            PLU @D72164, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72173, AGR [CASE @D72172, COUNT @D72171, PER @D72170, 
            PLU @D72169, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72178, AGR [CASE @D72177, COUNT @D72176, PER @D72175, 
            PLU @D72174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72183, AGR [CASE @D72182, COUNT @D72181, PER @D72180, 
            PLU @D72179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72188, AGR [CASE @D72187, COUNT @D72186, PER @D72185, 
            PLU @D72184, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72193, AGR [CASE @D72192, COUNT @D72191, PER @D72190, 
            PLU @D72189, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72198, AGR [CASE @D72197, COUNT @D72196, PER @D72195, 
            PLU @D72194, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72203, AGR [CASE @D72202, COUNT @D72201, PER @D72200, 
            PLU @D72199, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72208, AGR [CASE @D72207, COUNT @D72206, PER @D72205, 
            PLU @D72204, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : JUMP.

WORD jumping : 
   [COORD @D72222, PRD @D72221, AGR [CASE @D72220, COUNT @D72219, 
            PER @D72218, PLU @D72217, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72228, PRD @D72227, 
      AGR [CASE @D72226, COUNT @D72225, PER @D72224, PLU @D72223, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : JUMP, 
   [COORD @D72234, PRD @D72233, AGR [CASE @D72232, COUNT @D72231, 
            PER @D72230, PLU @D72229, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : JUMP, 
   [COORD @D72240, PRD @D72239, 
      AGR [CASE @D72238, COUNT @D72237, PER @D72236, PLU @D72235, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   JUMP, 
   [COORD @D72246, PRD @D72245, AGR [CASE @D72244, COUNT @D72243, 
            PER @D72242, PLU @D72241, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : JUMP.

WORD jumps : 
   [COORD @D72254, REFL @D72253, PRD @D72252, CASE @D72251, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : JUMPS, 
   [COORD @D72259, DEMON @D72258, REFL @D72257, PRD @D72256, 
      CASE @D72255, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : JUMP, 
   [COORD @D72261, 
      AGR [COUNT @D72260, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUMP, 
   [COORD @D72263, 
      AGR [COUNT @D72262, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUMP, 
   [COORD @D72265, 
      AGR [COUNT @D72264, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUMP, 
   [COORD @D72267, 
      AGR [COUNT @D72266, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUMP, 
   [COORD @D72269, 
      AGR [COUNT @D72268, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : JUMP.

WORD keep : 
   [COORD @D72283, AGR [COUNT @D72282, PER @D72281, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72285, AGR [COUNT @D72284, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72287, AGR [COUNT @D72286, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72291, AGR [COUNT @D72290, PER @D72289, PLU @D72288, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, REG -, ARITY 3] : KEEP, 
   [COORD @D72297, PAST @D72296, 
      AGR [CASE @D72295, COUNT @D72294, PER @D72293, PLU @D72292, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, REG -, ARITY 3] : 
   KEEP, 
   [COORD @D72300, AGR [COUNT @D72299, PER @D72298, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72302, AGR [COUNT @D72301, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72304, AGR [COUNT @D72303, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72308, AGR [COUNT @D72307, PER @D72306, PLU @D72305, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, ARITY 3] : KEEP, 
   [COORD @D72314, PAST @D72313, 
      AGR [CASE @D72312, COUNT @D72311, PER @D72310, PLU @D72309, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, ARITY 3] : 
   KEEP, 
   [COORD @D72317, AGR [COUNT @D72316, PER @D72315, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72319, AGR [COUNT @D72318, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72321, AGR [COUNT @D72320, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72325, AGR [COUNT @D72324, PER @D72323, PLU @D72322, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : KEEP, 
   [COORD @D72331, PAST @D72330, 
      AGR [CASE @D72329, COUNT @D72328, PER @D72327, PLU @D72326, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : 
   KEEP, 
   [COORD @D72334, AGR [COUNT @D72333, PER @D72332, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72336, AGR [COUNT @D72335, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72338, AGR [COUNT @D72337, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : KEEP, 
   [COORD @D72342, AGR [COUNT @D72341, PER @D72340, PLU @D72339, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : KEEP, 
   [COORD @D72348, PAST @D72347, 
      AGR [CASE @D72346, COUNT @D72345, PER @D72344, PLU @D72343, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   KEEP, 
   [COORD @D72351, AGR [COUNT @D72350, PER @D72349, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : KEEP, 
   [COORD @D72353, AGR [COUNT @D72352, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : KEEP, 
   [COORD @D72355, AGR [COUNT @D72354, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : KEEP, 
   [COORD @D72359, AGR [COUNT @D72358, PER @D72357, PLU @D72356, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : KEEP, 
   [COORD @D72365, PAST @D72364, 
      AGR [CASE @D72363, COUNT @D72362, PER @D72361, PLU @D72360, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : KEEP, 
   [COORD @D72368, AGR [COUNT @D72367, PER @D72366, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72370, AGR [COUNT @D72369, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72372, AGR [COUNT @D72371, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72376, AGR [COUNT @D72375, PER @D72374, PLU @D72373, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72382, PAST @D72381, 
      AGR [CASE @D72380, COUNT @D72379, PER @D72378, PLU @D72377, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, 
      PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72385, AGR [COUNT @D72384, PER @D72383, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM FROM, ARITY 3] : KEEP, 
   [COORD @D72387, AGR [COUNT @D72386, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM FROM, ARITY 3] : KEEP, 
   [COORD @D72389, AGR [COUNT @D72388, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM FROM, ARITY 3] : KEEP, 
   [COORD @D72393, AGR [COUNT @D72392, PER @D72391, PLU @D72390, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM FROM, ARITY 3] : KEEP, 
   [COORD @D72399, PAST @D72398, 
      AGR [CASE @D72397, COUNT @D72396, PER @D72395, PLU @D72394, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM FROM, 
      ARITY 3] : KEEP, 
   [COORD @D72402, AGR [COUNT @D72401, PER @D72400, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : KEEP, 
   [COORD @D72404, AGR [COUNT @D72403, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : KEEP, 
   [COORD @D72406, AGR [COUNT @D72405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : KEEP, 
   [COORD @D72410, AGR [COUNT @D72409, PER @D72408, PLU @D72407, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : KEEP, 
   [COORD @D72416, PAST @D72415, 
      AGR [CASE @D72414, COUNT @D72413, PER @D72412, PLU @D72411, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : KEEP, 
   [COORD @D72419, AGR [COUNT @D72418, PER @D72417, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72421, AGR [COUNT @D72420, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72423, AGR [COUNT @D72422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72427, AGR [COUNT @D72426, PER @D72425, PLU @D72424, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72433, PAST @D72432, 
      AGR [CASE @D72431, COUNT @D72430, PER @D72429, PLU @D72428, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM AT, 
      ARITY 3] : KEEP, 
   [COORD @D72436, AGR [COUNT @D72435, PER @D72434, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT ON, PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72438, 
      AGR [COUNT @D72437, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, REG -, PRT ON, 
      PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72440, AGR [COUNT @D72439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT ON, PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72444, 
      AGR [COUNT @D72443, PER @D72442, PLU @D72441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT ON, PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72450, PAST @D72449, 
      AGR [CASE @D72448, COUNT @D72447, PER @D72446, PLU @D72445, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, REG -, PRT ON, 
      PFORM AT, ARITY 3] : KEEP, 
   [COORD @D72453, AGR [COUNT @D72452, PER @D72451, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72455, AGR [COUNT @D72454, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72457, AGR [COUNT @D72456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72461, AGR [COUNT @D72460, PER @D72459, PLU @D72458, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72467, PAST @D72466, 
      AGR [CASE @D72465, COUNT @D72464, PER @D72463, PLU @D72462, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, ARITY 3] : KEEP, 
   [COORD @D72470, AGR [COUNT @D72469, PER @D72468, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : KEEP, 
   [COORD @D72472, AGR [COUNT @D72471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : KEEP, 
   [COORD @D72474, AGR [COUNT @D72473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : KEEP, 
   [COORD @D72478, AGR [COUNT @D72477, PER @D72476, PLU @D72475, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : KEEP, 
   [COORD @D72484, PAST @D72483, 
      AGR [CASE @D72482, COUNT @D72481, PER @D72480, PLU @D72479, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, ARITY 2] : 
   KEEP, 
   [COORD @D72487, AGR [COUNT @D72486, PER @D72485, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : KEEP, 
   [COORD @D72489, AGR [COUNT @D72488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : KEEP, 
   [COORD @D72491, AGR [COUNT @D72490, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : KEEP, 
   [COORD @D72495, AGR [COUNT @D72494, PER @D72493, PLU @D72492, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : KEEP, 
   [COORD @D72501, PAST @D72500, AGR [CASE @D72499, COUNT @D72498, 
            PER @D72497, PLU @D72496, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : KEEP, 
   [COORD @D72504, AGR [COUNT @D72503, PER @D72502, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : KEEP, 
   [COORD @D72506, AGR [COUNT @D72505, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : KEEP, 
   [COORD @D72508, AGR [COUNT @D72507, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : KEEP, 
   [COORD @D72512, AGR [COUNT @D72511, PER @D72510, PLU @D72509, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : KEEP, 
   [COORD @D72518, PAST @D72517, 
      AGR [CASE @D72516, COUNT @D72515, PER @D72514, PLU @D72513, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : 
   KEEP, 
   [COORD @D72521, AGR [COUNT @D72520, PER @D72519, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UNDER, ARITY 2] : KEEP, 
   [COORD @D72523, AGR [COUNT @D72522, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UNDER, ARITY 2] : KEEP, 
   [COORD @D72525, AGR [COUNT @D72524, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UNDER, ARITY 2] : KEEP, 
   [COORD @D72529, AGR [COUNT @D72528, PER @D72527, PLU @D72526, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT UNDER, ARITY 2] : KEEP, 
   [COORD @D72535, PAST @D72534, AGR [CASE @D72533, COUNT @D72532, 
            PER @D72531, PLU @D72530, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT UNDER, ARITY 2] : KEEP, 
   [COORD @D72538, 
      AGR [COUNT @D72537, PER @D72536, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP FROM, 
      ARITY 2] : KEEP, 
   [COORD @D72540, AGR [COUNT @D72539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP FROM, ARITY 2] : KEEP, 
   [COORD @D72542, AGR [COUNT @D72541, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP FROM, ARITY 2] : KEEP, 
   [COORD @D72546, AGR [COUNT @D72545, PER @D72544, PLU @D72543, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP FROM, ARITY 2] : KEEP, 
   [COORD @D72552, PAST @D72551, 
      AGR [CASE @D72550, COUNT @D72549, PER @D72548, PLU @D72547, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP FROM, 
      ARITY 2] : KEEP, 
   [COORD @D72555, AGR [COUNT @D72554, PER @D72553, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72557, AGR [COUNT @D72556, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72559, AGR [COUNT @D72558, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72563, AGR [COUNT @D72562, PER @D72561, PLU @D72560, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72569, PAST @D72568, 
      AGR [CASE @D72567, COUNT @D72566, PER @D72565, PLU @D72564, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72572, AGR [COUNT @D72571, PER @D72570, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72574, AGR [COUNT @D72573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72576, AGR [COUNT @D72575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72580, AGR [COUNT @D72579, PER @D72578, PLU @D72577, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72586, PAST @D72585, 
      AGR [CASE @D72584, COUNT @D72583, PER @D72582, PLU @D72581, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, 
      PFORM WITH, ARITY 2] : KEEP, 
   [COORD @D72589, AGR [COUNT @D72588, PER @D72587, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : KEEP, 
   [COORD @D72591, AGR [COUNT @D72590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : KEEP, 
   [COORD @D72593, AGR [COUNT @D72592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : KEEP, 
   [COORD @D72597, AGR [COUNT @D72596, PER @D72595, PLU @D72594, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : KEEP, 
   [COORD @D72603, PAST @D72602, AGR [CASE @D72601, COUNT @D72600, 
            PER @D72599, PLU @D72598, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : KEEP, 
   [COORD @D72606, 
      AGR [COUNT @D72605, PER @D72604, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, 
      ARITY 2] : KEEP, 
   [COORD @D72608, AGR [COUNT @D72607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : KEEP, 
   [COORD @D72610, AGR [COUNT @D72609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : KEEP, 
   [COORD @D72614, AGR [COUNT @D72613, PER @D72612, PLU @D72611, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OFF, ARITY 2] : KEEP, 
   [COORD @D72620, PAST @D72619, AGR [CASE @D72618, COUNT @D72617, 
            PER @D72616, PLU @D72615, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, ARITY 2] : KEEP, 
   [COORD @D72623, 
      AGR [COUNT @D72622, PER @D72621, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM OF, ARITY 2] : KEEP, 
   [COORD @D72625, AGR [COUNT @D72624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : KEEP, 
   [COORD @D72627, AGR [COUNT @D72626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : KEEP, 
   [COORD @D72631, AGR [COUNT @D72630, PER @D72629, PLU @D72628, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM OF, ARITY 2] : KEEP, 
   [COORD @D72637, PAST @D72636, 
      AGR [CASE @D72635, COUNT @D72634, PER @D72633, PLU @D72632, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM OF, ARITY 2] : KEEP, 
   [COORD @D72640, AGR [COUNT @D72639, PER @D72638, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM FROM, ARITY 2] : KEEP, 
   [COORD @D72642, 
      AGR [COUNT @D72641, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, 
      PFORM FROM, ARITY 2] : KEEP, 
   [COORD @D72644, AGR [COUNT @D72643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM FROM, ARITY 2] : KEEP, 
   [COORD @D72648, 
      AGR [COUNT @D72647, PER @D72646, PLU @D72645, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM FROM, ARITY 2] : KEEP, 
   [COORD @D72654, PAST @D72653, 
      AGR [CASE @D72652, COUNT @D72651, PER @D72650, PLU @D72649, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, 
      PFORM FROM, ARITY 2] : KEEP, 
   [COORD @D72657, AGR [COUNT @D72656, PER @D72655, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72659, AGR [COUNT @D72658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72661, AGR [COUNT @D72660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72665, AGR [COUNT @D72664, PER @D72663, PLU @D72662, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72671, PAST @D72670, AGR [CASE @D72669, COUNT @D72668, 
            PER @D72667, PLU @D72666, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72674, 
      AGR [COUNT @D72673, PER @D72672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT ON, PFORM AT, 
      ARITY 2] : KEEP, 
   [COORD @D72676, AGR [COUNT @D72675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT ON, PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72678, AGR [COUNT @D72677, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT ON, PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72682, AGR [COUNT @D72681, PER @D72680, PLU @D72679, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT ON, PFORM AT, ARITY 2] : KEEP, 
   [COORD @D72688, PAST @D72687, 
      AGR [CASE @D72686, COUNT @D72685, PER @D72684, PLU @D72683, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT ON, PFORM AT, 
      ARITY 2] : KEEP, 
   [COORD @D72691, AGR [COUNT @D72690, PER @D72689, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM ABOUT, ARITY 2] : KEEP, 
   [COORD @D72693, AGR [COUNT @D72692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM ABOUT, ARITY 2] : KEEP, 
   [COORD @D72695, AGR [COUNT @D72694, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ON, PFORM ABOUT, ARITY 2] : KEEP, 
   [COORD @D72699, AGR [COUNT @D72698, PER @D72697, PLU @D72696, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ON, PFORM ABOUT, ARITY 2] : KEEP, 
   [COORD @D72705, PAST @D72704, 
      AGR [CASE @D72703, COUNT @D72702, PER @D72701, PLU @D72700, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM ABOUT, ARITY 2] : KEEP, 
   [COORD @D72708, AGR [COUNT @D72707, PER @D72706, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : KEEP, 
   [COORD @D72710, AGR [COUNT @D72709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : KEEP, 
   [COORD @D72712, AGR [COUNT @D72711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : KEEP, 
   [COORD @D72716, AGR [COUNT @D72715, PER @D72714, PLU @D72713, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : KEEP, 
   [COORD @D72722, PAST @D72721, 
      AGR [CASE @D72720, COUNT @D72719, PER @D72718, PLU @D72717, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : KEEP, 
   [COORD @D72725, AGR [COUNT @D72724, PER @D72723, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : KEEP, 
   [COORD @D72727, AGR [COUNT @D72726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : KEEP, 
   [COORD @D72729, AGR [COUNT @D72728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : KEEP, 
   [COORD @D72733, AGR [COUNT @D72732, PER @D72731, PLU @D72730, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : KEEP, 
   [COORD @D72739, PAST @D72738, 
      AGR [CASE @D72737, COUNT @D72736, PER @D72735, PLU @D72734, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : KEEP, 
   [COORD @D72742, AGR [COUNT @D72741, PER @D72740, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : KEEP, 
   [COORD @D72744, AGR [COUNT @D72743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : KEEP, 
   [COORD @D72746, AGR [COUNT @D72745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : KEEP, 
   [COORD @D72750, AGR [COUNT @D72749, PER @D72748, PLU @D72747, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, ARITY 2] : KEEP, 
   [COORD @D72756, PAST @D72755, 
      AGR [CASE @D72754, COUNT @D72753, PER @D72752, PLU @D72751, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      ARITY 2] : KEEP, 
   [COORD @D72759, AGR [COUNT @D72758, PER @D72757, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : KEEP, 
   [COORD @D72761, AGR [COUNT @D72760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : KEEP, 
   [COORD @D72763, AGR [COUNT @D72762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : KEEP, 
   [COORD @D72767, AGR [COUNT @D72766, PER @D72765, PLU @D72764, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : KEEP, 
   [COORD @D72773, PAST @D72772, 
      AGR [CASE @D72771, COUNT @D72770, PER @D72769, PLU @D72768, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : KEEP, 
   [COORD @D72776, AGR [COUNT @D72775, PER @D72774, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : KEEP, 
   [COORD @D72778, AGR [COUNT @D72777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : KEEP, 
   [COORD @D72780, AGR [COUNT @D72779, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : KEEP, 
   [COORD @D72784, AGR [COUNT @D72783, PER @D72782, PLU @D72781, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : KEEP, 
   [COORD @D72790, PAST @D72789, 
      AGR [CASE @D72788, COUNT @D72787, PER @D72786, PLU @D72785, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : KEEP, 
   [COORD @D72793, AGR [COUNT @D72792, PER @D72791, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : KEEP, 
   [COORD @D72795, AGR [COUNT @D72794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : KEEP, 
   [COORD @D72797, AGR [COUNT @D72796, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : KEEP, 
   [COORD @D72801, AGR [COUNT @D72800, PER @D72799, PLU @D72798, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : KEEP, 
   [COORD @D72807, PAST @D72806, 
      AGR [CASE @D72805, COUNT @D72804, PER @D72803, PLU @D72802, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : KEEP, 
   [COORD @D72810, AGR [COUNT @D72809, PER @D72808, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : KEEP, 
   [COORD @D72812, AGR [COUNT @D72811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : KEEP, 
   [COORD @D72814, AGR [COUNT @D72813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : KEEP, 
   [COORD @D72818, AGR [COUNT @D72817, PER @D72816, PLU @D72815, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : KEEP, 
   [COORD @D72824, PAST @D72823, 
      AGR [CASE @D72822, COUNT @D72821, PER @D72820, PLU @D72819, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : KEEP, 
   [COORD @D72826, AGR [COUNT @D72825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 1] : KEEP, 
   [COORD @D72828, AGR [COUNT @D72827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 1] : KEEP, 
   [COORD @D72832, AGR [NFORM @D72831, COUNT @D72830, PER @D72829, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 1] : KEEP, 
   [COORD @D72836, AGR [COUNT @D72835, PER @D72834, PLU @D72833, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 1] : KEEP, 
   [COORD @D72839, AGR @D72838, PAST @D72837, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      REG -, ARITY 1] : KEEP, 
   [COORD @D72842, AGR [COUNT @D72841, PER @D72840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : KEEP, 
   [COORD @D72844, AGR [COUNT @D72843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : KEEP, 
   [COORD @D72846, AGR [COUNT @D72845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : KEEP, 
   [COORD @D72850, AGR [COUNT @D72849, PER @D72848, PLU @D72847, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : KEEP, 
   [COORD @D72856, PAST @D72855, 
      AGR [CASE @D72854, COUNT @D72853, PER @D72852, PLU @D72851, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   KEEP, 
   [COORD @D72859, AGR [COUNT @D72858, PER @D72857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : KEEP, 
   [COORD @D72861, AGR [COUNT @D72860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : KEEP, 
   [COORD @D72863, AGR [COUNT @D72862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : KEEP, 
   [COORD @D72867, AGR [COUNT @D72866, PER @D72865, PLU @D72864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : KEEP, 
   [COORD @D72873, PAST @D72872, 
      AGR [CASE @D72871, COUNT @D72870, PER @D72869, PLU @D72868, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : KEEP, 
   [COORD @D72876, AGR [COUNT @D72875, PER @D72874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UNDER, ARITY 1] : KEEP, 
   [COORD @D72878, AGR [COUNT @D72877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UNDER, ARITY 1] : KEEP, 
   [COORD @D72880, AGR [COUNT @D72879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UNDER, ARITY 1] : KEEP, 
   [COORD @D72884, AGR [COUNT @D72883, PER @D72882, PLU @D72881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UNDER, ARITY 1] : KEEP, 
   [COORD @D72890, PAST @D72889, 
      AGR [CASE @D72888, COUNT @D72887, PER @D72886, PLU @D72885, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UNDER, 
      ARITY 1] : KEEP, 
   [COORD @D72893, AGR [COUNT @D72892, PER @D72891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : KEEP, 
   [COORD @D72895, AGR [COUNT @D72894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : KEEP, 
   [COORD @D72897, AGR [COUNT @D72896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : KEEP, 
   [COORD @D72901, AGR [COUNT @D72900, PER @D72899, PLU @D72898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : KEEP, 
   [COORD @D72907, PAST @D72906, 
      AGR [CASE @D72905, COUNT @D72904, PER @D72903, PLU @D72902, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : KEEP, 
   [COORD @D72909, AGR [COUNT @D72908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72911, AGR [COUNT @D72910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72915, AGR [NFORM @D72914, COUNT @D72913, PER @D72912, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72919, AGR [COUNT @D72918, PER @D72917, PLU @D72916, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72922, AGR @D72921, PAST @D72920, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72925, AGR [COUNT @D72924, PER @D72923, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72927, AGR [COUNT @D72926, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72929, AGR [COUNT @D72928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72933, AGR [COUNT @D72932, PER @D72931, PLU @D72930, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : KEEP, 
   [COORD @D72939, PAST @D72938, 
      AGR [CASE @D72937, COUNT @D72936, PER @D72935, PLU @D72934, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : KEEP, 
   [COORD @D72942, AGR [COUNT @D72941, PER @D72940, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : KEEP, 
   [COORD @D72944, AGR [COUNT @D72943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : KEEP, 
   [COORD @D72946, AGR [COUNT @D72945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : KEEP, 
   [COORD @D72950, AGR [COUNT @D72949, PER @D72948, PLU @D72947, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : KEEP, 
   [COORD @D72956, PAST @D72955, 
      AGR [CASE @D72954, COUNT @D72953, PER @D72952, PLU @D72951, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : KEEP, 
   [COORD @D72959, AGR [COUNT @D72958, PER @D72957, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : KEEP, 
   [COORD @D72961, AGR [COUNT @D72960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : KEEP, 
   [COORD @D72963, AGR [COUNT @D72962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : KEEP, 
   [COORD @D72967, AGR [COUNT @D72966, PER @D72965, PLU @D72964, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : KEEP, 
   [COORD @D72973, PAST @D72972, 
      AGR [CASE @D72971, COUNT @D72970, PER @D72969, PLU @D72968, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : KEEP, 
   [COORD @D72976, AGR [COUNT @D72975, PER @D72974, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : KEEP, 
   [COORD @D72978, AGR [COUNT @D72977, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : KEEP, 
   [COORD @D72980, AGR [COUNT @D72979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : KEEP, 
   [COORD @D72984, AGR [COUNT @D72983, PER @D72982, PLU @D72981, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : KEEP, 
   [COORD @D72990, PAST @D72989, 
      AGR [CASE @D72988, COUNT @D72987, PER @D72986, PLU @D72985, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : KEEP, 
   [COORD @D72993, AGR [COUNT @D72992, PER @D72991, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : KEEP, 
   [COORD @D72995, AGR [COUNT @D72994, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : KEEP, 
   [COORD @D72997, AGR [COUNT @D72996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : KEEP, 
   [COORD @D73001, AGR [COUNT @D73000, PER @D72999, PLU @D72998, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : KEEP, 
   [COORD @D73007, PAST @D73006, 
      AGR [CASE @D73005, COUNT @D73004, PER @D73003, PLU @D73002, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : KEEP.

WORD keeping : 
   [COORD @D73017, REFL @D73016, COUNT @D73015, PRD @D73014, 
      CASE @D73013, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : KEEPING, 
   [COORD @D73023, PRD @D73022, 
      AGR [CASE @D73021, COUNT @D73020, PER @D73019, PLU @D73018, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   KEEP, 
   [COORD @D73029, PRD @D73028, AGR [CASE @D73027, COUNT @D73026, 
            PER @D73025, PLU @D73024, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73035, PRD @D73034, 
      AGR [CASE @D73033, COUNT @D73032, PER @D73031, PLU @D73030, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   KEEP, 
   [COORD @D73041, PRD @D73040, AGR [CASE @D73039, COUNT @D73038, 
            PER @D73037, PLU @D73036, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73047, PRD @D73046, 
      AGR [CASE @D73045, COUNT @D73044, PER @D73043, PLU @D73042, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73053, PRD @D73052, AGR [CASE @D73051, COUNT @D73050, 
            PER @D73049, PLU @D73048, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73059, PRD @D73058, 
      AGR [CASE @D73057, COUNT @D73056, PER @D73055, PLU @D73054, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73065, PRD @D73064, AGR [CASE @D73063, COUNT @D73062, 
            PER @D73061, PLU @D73060, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73071, PRD @D73070, 
      AGR [CASE @D73069, COUNT @D73068, PER @D73067, PLU @D73066, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73077, PRD @D73076, AGR [CASE @D73075, COUNT @D73074, 
            PER @D73073, PLU @D73072, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, 
      PRT ON, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73083, PRD @D73082, 
      AGR [CASE @D73081, COUNT @D73080, PER @D73079, PLU @D73078, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73089, PRD @D73088, AGR [CASE @D73087, COUNT @D73086, 
            PER @D73085, PLU @D73084, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73095, PRD @D73094, 
      AGR [CASE @D73093, COUNT @D73092, PER @D73091, PLU @D73090, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   KEEP, 
   [COORD @D73101, PRD @D73100, AGR [CASE @D73099, COUNT @D73098, 
            PER @D73097, PLU @D73096, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73107, PRD @D73106, 
      AGR [CASE @D73105, COUNT @D73104, PER @D73103, PLU @D73102, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT UNDER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73113, PRD @D73112, AGR [CASE @D73111, COUNT @D73110, 
            PER @D73109, PLU @D73108, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, 
      PREP FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73119, PRD @D73118, 
      AGR [CASE @D73117, COUNT @D73116, PER @D73115, PLU @D73114, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73125, PRD @D73124, AGR [CASE @D73123, COUNT @D73122, 
            PER @D73121, PLU @D73120, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73131, PRD @D73130, 
      AGR [CASE @D73129, COUNT @D73128, PER @D73127, PLU @D73126, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73137, PRD @D73136, AGR [CASE @D73135, COUNT @D73134, 
            PER @D73133, PLU @D73132, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73143, PRD @D73142, 
      AGR [CASE @D73141, COUNT @D73140, PER @D73139, PLU @D73138, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73149, PRD @D73148, AGR [CASE @D73147, COUNT @D73146, 
            PER @D73145, PLU @D73144, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73155, PRD @D73154, 
      AGR [CASE @D73153, COUNT @D73152, PER @D73151, PLU @D73150, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73161, PRD @D73160, AGR [CASE @D73159, COUNT @D73158, 
            PER @D73157, PLU @D73156, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT ON, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73167, PRD @D73166, 
      AGR [CASE @D73165, COUNT @D73164, PER @D73163, PLU @D73162, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ON, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73173, PRD @D73172, AGR [CASE @D73171, COUNT @D73170, 
            PER @D73169, PLU @D73168, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73179, PRD @D73178, 
      AGR [CASE @D73177, COUNT @D73176, PER @D73175, PLU @D73174, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73185, PRD @D73184, AGR [CASE @D73183, COUNT @D73182, 
            PER @D73181, PLU @D73180, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73191, PRD @D73190, 
      AGR [CASE @D73189, COUNT @D73188, PER @D73187, PLU @D73186, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73197, PRD @D73196, AGR [CASE @D73195, COUNT @D73194, 
            PER @D73193, PLU @D73192, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73203, PRD @D73202, 
      AGR [CASE @D73201, COUNT @D73200, PER @D73199, PLU @D73198, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73209, PRD @D73208, AGR [CASE @D73207, COUNT @D73206, 
            PER @D73205, PLU @D73204, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73212, AGR @D73211, PRD @D73210, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73218, PRD @D73217, AGR [CASE @D73216, COUNT @D73215, 
            PER @D73214, PLU @D73213, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73224, PRD @D73223, 
      AGR [CASE @D73222, COUNT @D73221, PER @D73220, PLU @D73219, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73230, PRD @D73229, AGR [CASE @D73228, COUNT @D73227, 
            PER @D73226, PLU @D73225, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UNDER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73236, PRD @D73235, 
      AGR [CASE @D73234, COUNT @D73233, PER @D73232, PLU @D73231, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73239, AGR @D73238, PRD @D73237, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73245, PRD @D73244, AGR [CASE @D73243, COUNT @D73242, 
            PER @D73241, PLU @D73240, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73251, PRD @D73250, 
      AGR [CASE @D73249, COUNT @D73248, PER @D73247, PLU @D73246, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73257, PRD @D73256, AGR [CASE @D73255, COUNT @D73254, 
            PER @D73253, PLU @D73252, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP, 
   [COORD @D73263, PRD @D73262, 
      AGR [CASE @D73261, COUNT @D73260, PER @D73259, PLU @D73258, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KEEP, 
   [COORD @D73269, PRD @D73268, AGR [CASE @D73267, COUNT @D73266, 
            PER @D73265, PLU @D73264, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KEEP.

WORD keepings : 
   [COORD @D73281, DEMON @D73280, REFL @D73279, PRD @D73278, 
      CASE @D73277, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : KEEPING.

WORD keeps : 
   [COORD @D73286, AGR [COUNT @D73285, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73288, 
      AGR [COUNT @D73287, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73290, 
      AGR [COUNT @D73289, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73292, 
      AGR [COUNT @D73291, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73294, 
      AGR [COUNT @D73293, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73296, 
      AGR [COUNT @D73295, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73298, AGR [COUNT @D73297, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73300, AGR [COUNT @D73299, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73302, AGR [COUNT @D73301, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73304, AGR [COUNT @D73303, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PRT ON, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73306, AGR [COUNT @D73305, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73308, AGR [COUNT @D73307, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73310, 
      AGR [COUNT @D73309, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73312, 
      AGR [COUNT @D73311, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73314, 
      AGR [COUNT @D73313, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT UNDER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73316, 
      AGR [COUNT @D73315, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   KEEP, 
   [COORD @D73318, AGR [COUNT @D73317, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   KEEP, 
   [COORD @D73320, AGR [COUNT @D73319, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73322, AGR [COUNT @D73321, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73324, AGR [COUNT @D73323, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73326, AGR [COUNT @D73325, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73328, AGR [COUNT @D73327, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73330, AGR [COUNT @D73329, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KEEP, 
   [COORD @D73332, AGR [COUNT @D73331, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT ON, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : KEEP, 
   [COORD @D73334, AGR [COUNT @D73333, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ON, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   KEEP, 
   [COORD @D73336, AGR [COUNT @D73335, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73338, 
      AGR [COUNT @D73337, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73340, 
      AGR [COUNT @D73339, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73342, 
      AGR [COUNT @D73341, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73344, 
      AGR [COUNT @D73343, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73346, 
      AGR [COUNT @D73345, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73348, 
      AGR [COUNT @D73347, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73352, 
      AGR [CASE @D73351, NFORM @D73350, COUNT @D73349, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73357, 
      AGR [UB @D73356, VFORM @D73355, SUBJ @D73354, FIN @D73353, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73359, 
      AGR [COUNT @D73358, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73361, 
      AGR [COUNT @D73360, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73363, 
      AGR [COUNT @D73362, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UNDER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73365, 
      AGR [COUNT @D73364, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73369, 
      AGR [CASE @D73368, NFORM @D73367, COUNT @D73366, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73374, 
      AGR [UB @D73373, VFORM @D73372, SUBJ @D73371, FIN @D73370, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73376, 
      AGR [COUNT @D73375, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73378, 
      AGR [COUNT @D73377, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73380, 
      AGR [COUNT @D73379, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73382, 
      AGR [COUNT @D73381, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP, 
   [COORD @D73384, 
      AGR [COUNT @D73383, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KEEP.

WORD kept : 
   [COORD @D73392, PAST @D73391, AGR [CASE @D73390, COUNT @D73389, 
            PER @D73388, PLU @D73387, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, REG -, FIN -, ARITY 3] : KEEP, 
   [COORD @D73398, PAST @D73397, 
      AGR [CASE @D73396, COUNT @D73395, PER @D73394, PLU @D73393, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, REG -, FIN -, ARITY 3] : 
   KEEP, 
   [COORD @D73404, PAST @D73403, AGR [CASE @D73402, COUNT @D73401, 
            PER @D73400, PLU @D73399, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, FIN -, ARITY 3] : KEEP, 
   [COORD @D73410, PAST @D73409, 
      AGR [CASE @D73408, COUNT @D73407, PER @D73406, PLU @D73405, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, FIN -, ARITY 3] : 
   KEEP, 
   [COORD @D73416, PAST @D73415, AGR [CASE @D73414, COUNT @D73413, 
            PER @D73412, PLU @D73411, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : KEEP, 
   [COORD @D73422, PAST @D73421, 
      AGR [CASE @D73420, COUNT @D73419, PER @D73418, PLU @D73417, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, ARITY 3] : 
   KEEP, 
   [COORD @D73428, PAST @D73427, AGR [CASE @D73426, COUNT @D73425, 
            PER @D73424, PLU @D73423, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : KEEP, 
   [COORD @D73434, PAST @D73433, 
      AGR [CASE @D73432, COUNT @D73431, PER @D73430, PLU @D73429, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : KEEP, 
   
   [COORD @D73440, PAST @D73439, AGR [CASE @D73438, COUNT @D73437, PER 
               @D73436, PLU @D73435, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : KEEP, 
   [COORD @D73446, PAST @D73445, 
      AGR [CASE @D73444, COUNT @D73443, PER @D73442, PLU @D73441, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : KEEP, 
   [COORD @D73452, PAST @D73451, AGR [CASE @D73450, COUNT @D73449, 
            PER @D73448, PLU @D73447, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : KEEP, 
   [COORD @D73458, PAST @D73457, 
      AGR [CASE @D73456, COUNT @D73455, PER @D73454, PLU @D73453, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 3] : KEEP, 
   [COORD @D73464, PAST @D73463, AGR [CASE @D73462, COUNT @D73461, 
            PER @D73460, PLU @D73459, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM FROM, FIN -, ARITY 3] : KEEP, 
   [COORD @D73470, PAST @D73469, 
      AGR [CASE @D73468, COUNT @D73467, PER @D73466, PLU @D73465, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM FROM, FIN -, 
      ARITY 3] : KEEP, 
   [COORD @D73476, PAST @D73475, AGR [CASE @D73474, COUNT @D73473, 
            PER @D73472, PLU @D73471, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : KEEP, 
   [COORD @D73482, PAST @D73481, 
      AGR [CASE @D73480, COUNT @D73479, PER @D73478, PLU @D73477, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, FIN -, 
      ARITY 3] : KEEP, 
   [COORD @D73488, PAST @D73487, AGR [CASE @D73486, COUNT @D73485, 
            PER @D73484, PLU @D73483, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AT, FIN -, ARITY 3] : KEEP, 
   [COORD @D73494, PAST @D73493, 
      AGR [CASE @D73492, COUNT @D73491, PER @D73490, PLU @D73489, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM AT, FIN -, 
      ARITY 3] : KEEP, 
   [COORD @D73500, PAST @D73499, AGR [CASE @D73498, COUNT @D73497, 
            PER @D73496, PLU @D73495, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT ON, PFORM AT, FIN -, ARITY 3] : KEEP, 
   [COORD @D73506, PAST @D73505, 
      AGR [CASE @D73504, COUNT @D73503, PER @D73502, PLU @D73501, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, REG -, PRT ON, 
      PFORM AT, FIN -, ARITY 3] : KEEP, 
   [COORD @D73512, PAST @D73511, AGR [CASE @D73510, COUNT @D73509, 
            PER @D73508, PLU @D73507, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : KEEP, 
   [COORD @D73518, PAST @D73517, 
      AGR [CASE @D73516, COUNT @D73515, PER @D73514, PLU @D73513, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, FIN -, ARITY 3] : KEEP, 
   [COORD @D73522, AGR [COUNT @D73521, PER @D73520, PLU @D73519, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      REG -, PAST +, ARITY 3] : KEEP, 
   [COORD @D73526, AGR [COUNT @D73525, PER @D73524, PLU @D73523, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, PAST +, ARITY 3] : KEEP, 
   [COORD @D73530, AGR [COUNT @D73529, PER @D73528, PLU @D73527, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PAST +, ARITY 3] : KEEP, 
   [COORD @D73534, AGR [COUNT @D73533, PER @D73532, PLU @D73531, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : KEEP, 
   [COORD @D73538, AGR [COUNT @D73537, PER @D73536, PLU @D73535, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : KEEP, 
   [COORD @D73542, AGR [COUNT @D73541, PER @D73540, PLU @D73539, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, PAST +, ARITY 3] : KEEP, 
   [COORD @D73546, AGR 
         [COUNT @D73545, PER @D73544, PLU @D73543, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM FROM, PAST +, ARITY 3] : KEEP, 
   [COORD @D73550, AGR [COUNT @D73549, PER @D73548, PLU @D73547, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, PAST +, ARITY 3] : KEEP, 
   [COORD @D73554, AGR [COUNT @D73553, PER @D73552, PLU @D73551, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, PAST +, ARITY 3] : KEEP, 
   [COORD @D73558, AGR [COUNT @D73557, PER @D73556, PLU @D73555, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, REG -, PRT ON, PFORM AT, PAST +, ARITY 3] : KEEP, 
   [COORD @D73562, 
      AGR [COUNT @D73561, PER @D73560, PLU @D73559, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PFORM OF, PAST +, ARITY 3] : KEEP, 
   [COORD @D73568, PAST @D73567, 
      AGR [CASE @D73566, COUNT @D73565, PER @D73564, PLU @D73563, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, FIN -, ARITY 2] : KEEP, 
   
   [COORD @D73574, PAST @D73573, AGR [CASE @D73572, COUNT @D73571, PER 
               @D73570, PLU @D73569, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : KEEP, 
   [COORD @D73580, PAST @D73579, 
      AGR [CASE @D73578, COUNT @D73577, PER @D73576, PLU @D73575, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : KEEP, 
   [COORD @D73586, PAST @D73585, 
      AGR [CASE @D73584, COUNT @D73583, PER @D73582, PLU @D73581, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, FIN -, ARITY 2] : KEEP, 
   [COORD @D73592, PAST @D73591, 
      AGR [CASE @D73590, COUNT @D73589, PER @D73588, PLU @D73587, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT UNDER, 
      FIN -, ARITY 2] : KEEP, 
   [COORD @D73598, PAST @D73597, AGR [CASE @D73596, COUNT @D73595, 
            PER @D73594, PLU @D73593, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT UNDER, FIN -, ARITY 2] : KEEP, 
   [COORD @D73604, PAST @D73603, 
      AGR [CASE @D73602, COUNT @D73601, PER @D73600, PLU @D73599, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP FROM, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73610, PAST @D73609, AGR [CASE @D73608, COUNT @D73607, 
            PER @D73606, PLU @D73605, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM WITH, FIN -, ARITY 2] : KEEP, 
   [COORD @D73616, PAST @D73615, 
      AGR [CASE @D73614, COUNT @D73613, PER @D73612, PLU @D73611, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, PFORM WITH, 
      FIN -, ARITY 2] : KEEP, 
   [COORD @D73622, PAST @D73621, AGR [CASE @D73620, COUNT @D73619, 
            PER @D73618, PLU @D73617, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT IN, PFORM WITH, FIN -, ARITY 2] : KEEP, 
   [COORD @D73628, PAST @D73627, 
      AGR [CASE @D73626, COUNT @D73625, PER @D73624, PLU @D73623, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM TO, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73634, PAST @D73633, AGR [CASE @D73632, COUNT @D73631, 
            PER @D73630, PLU @D73629, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : KEEP, 
   [COORD @D73640, PAST @D73639, 
      AGR [CASE @D73638, COUNT @D73637, PER @D73636, PLU @D73635, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM OFF, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73646, PAST @D73645, AGR [CASE @D73644, COUNT @D73643, 
            PER @D73642, PLU @D73641, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM OFF, FIN -, ARITY 2] : KEEP, 
   [COORD @D73652, PAST @D73651, 
      AGR [CASE @D73650, COUNT @D73649, PER @D73648, PLU @D73647, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 2] : KEEP, 
   [COORD @D73658, PAST @D73657, AGR [CASE @D73656, COUNT @D73655, 
            PER @D73654, PLU @D73653, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT OUT, PFORM OF, FIN -, ARITY 2] : KEEP, 
   [COORD @D73664, PAST @D73663, 
      AGR [CASE @D73662, COUNT @D73661, PER @D73660, PLU @D73659, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, PFORM FROM, 
      FIN -, ARITY 2] : KEEP, 
   [COORD @D73670, PAST @D73669, AGR [CASE @D73668, COUNT @D73667, 
            PER @D73666, PLU @D73665, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, REG -, PFORM FROM, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73676, PAST @D73675, AGR [CASE @D73674, COUNT @D73673, 
            PER @D73672, PLU @D73671, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AT, FIN -, ARITY 2] : KEEP, 
   [COORD @D73682, PAST @D73681, 
      AGR [CASE @D73680, COUNT @D73679, PER @D73678, PLU @D73677, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73688, PAST @D73687, AGR [CASE @D73686, COUNT @D73685, 
            PER @D73684, PLU @D73683, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, PFORM AT, FIN -, ARITY 2] : KEEP, 
   [COORD @D73694, PAST @D73693, 
      AGR [CASE @D73692, COUNT @D73691, PER @D73690, PLU @D73689, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT ON, PFORM AT, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73700, PAST @D73699, AGR [CASE @D73698, COUNT @D73697, 
            PER @D73696, PLU @D73695, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT ON, PFORM ABOUT, FIN -, ARITY 2] : KEEP, 
   [COORD @D73706, PAST @D73705, 
      AGR [CASE @D73704, COUNT @D73703, PER @D73702, PLU @D73701, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73712, PAST @D73711, AGR [CASE @D73710, COUNT @D73709, 
            PER @D73708, PLU @D73707, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : KEEP, 
   [COORD @D73718, PAST @D73717, 
      AGR [CASE @D73716, COUNT @D73715, PER @D73714, PLU @D73713, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73724, PAST @D73723, AGR [CASE @D73722, COUNT @D73721, 
            PER @D73720, PLU @D73719, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : KEEP, 
   [COORD @D73730, PAST @D73729, 
      AGR [CASE @D73728, COUNT @D73727, PER @D73726, PLU @D73725, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73736, PAST @D73735, AGR [CASE @D73734, COUNT @D73733, 
            PER @D73732, PLU @D73731, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, FIN -, ARITY 2] : KEEP, 
   [COORD @D73742, PAST @D73741, 
      AGR [CASE @D73740, COUNT @D73739, PER @D73738, PLU @D73737, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73748, PAST @D73747, AGR [CASE @D73746, COUNT @D73745, 
            PER @D73744, PLU @D73743, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : KEEP, 
   [COORD @D73754, PAST @D73753, 
      AGR [CASE @D73752, COUNT @D73751, PER @D73750, PLU @D73749, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73760, PAST @D73759, AGR [CASE @D73758, COUNT @D73757, 
            PER @D73756, PLU @D73755, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : KEEP, 
   [COORD @D73766, PAST @D73765, 
      AGR [CASE @D73764, COUNT @D73763, PER @D73762, PLU @D73761, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73772, PAST @D73771, AGR [CASE @D73770, COUNT @D73769, 
            PER @D73768, PLU @D73767, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : KEEP, 
   [COORD @D73778, PAST @D73777, 
      AGR [CASE @D73776, COUNT @D73775, PER @D73774, PLU @D73773, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : KEEP, 
   [COORD @D73784, PAST @D73783, AGR [CASE @D73782, COUNT @D73781, 
            PER @D73780, PLU @D73779, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : KEEP, 
   [COORD @D73788, 
      AGR [COUNT @D73787, PER @D73786, PLU @D73785, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PAST +, 
      ARITY 2] : KEEP, 
   [COORD @D73792, AGR [COUNT @D73791, PER @D73790, PLU @D73789, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : KEEP, 
   [COORD @D73796, AGR [COUNT @D73795, PER @D73794, PLU @D73793, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, 
      PAST +, ARITY 2] : KEEP, 
   [COORD @D73800, AGR [COUNT @D73799, PER @D73798, PLU @D73797, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UNDER, PAST +, ARITY 2] : KEEP, 
   [COORD @D73804, AGR [COUNT @D73803, PER @D73802, PLU @D73801, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP FROM, PAST +, ARITY 2] : KEEP, 
   [COORD @D73808, AGR [COUNT @D73807, PER @D73806, PLU @D73805, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM WITH, PAST +, ARITY 2] : KEEP, 
   [COORD @D73812, AGR [COUNT @D73811, PER @D73810, PLU @D73809, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM WITH, PAST +, ARITY 2] : KEEP, 
   [COORD @D73816, AGR [COUNT @D73815, PER @D73814, PLU @D73813, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, PAST +, ARITY 2] : KEEP, 
   [COORD @D73820, AGR [COUNT @D73819, PER @D73818, PLU @D73817, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, PAST +, ARITY 2] : KEEP, 
   [COORD @D73824, AGR [COUNT @D73823, PER @D73822, PLU @D73821, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, PAST +, ARITY 2] : KEEP, 
   [COORD @D73828, AGR [COUNT @D73827, PER @D73826, PLU @D73825, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, REG -, PFORM FROM, PAST +, ARITY 2] : KEEP, 
   [COORD @D73832, 
      AGR [COUNT @D73831, PER @D73830, PLU @D73829, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, 
      PAST +, ARITY 2] : KEEP, 
   [COORD @D73836, AGR [COUNT @D73835, PER @D73834, PLU @D73833, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT ON, PFORM AT, PAST +, ARITY 2] : KEEP, 
   [COORD @D73840, AGR [COUNT @D73839, PER @D73838, PLU @D73837, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ON, 
      PFORM ABOUT, PAST +, ARITY 2] : KEEP, 
   [COORD @D73844, AGR [COUNT @D73843, PER @D73842, PLU @D73841, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : KEEP, 
   [COORD @D73848, AGR [COUNT @D73847, PER @D73846, PLU @D73845, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : KEEP, 
   [COORD @D73852, AGR [COUNT @D73851, PER @D73850, PLU @D73849, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, PAST +, ARITY 2] : KEEP, 
   [COORD @D73856, AGR [COUNT @D73855, PER @D73854, PLU @D73853, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : KEEP, 
   [COORD @D73860, AGR [COUNT @D73859, PER @D73858, PLU @D73857, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : KEEP, 
   [COORD @D73864, AGR [COUNT @D73863, PER @D73862, PLU @D73861, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PAST +, ARITY 2] : KEEP, 
   [COORD @D73868, AGR [COUNT @D73867, PER @D73866, PLU @D73865, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PAST +, ARITY 2] : KEEP, 
   [COORD @D73871, AGR @D73870, PAST @D73869, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, FIN -, 
      ARITY 1] : KEEP, 
   [COORD @D73877, PAST @D73876, AGR [CASE @D73875, COUNT @D73874, 
            PER @D73873, PLU @D73872, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : KEEP, 
   [COORD @D73883, PAST @D73882, 
      AGR [CASE @D73881, COUNT @D73880, PER @D73879, PLU @D73878, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : KEEP, 
   [COORD @D73889, PAST @D73888, AGR [CASE @D73887, COUNT @D73886, 
            PER @D73885, PLU @D73884, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UNDER, FIN -, ARITY 1] : KEEP, 
   [COORD @D73895, PAST @D73894, 
      AGR [CASE @D73893, COUNT @D73892, PER @D73891, PLU @D73890, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : KEEP, 
   [COORD @D73898, AGR @D73897, PAST @D73896, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, PRT ON, 
      FIN -, ARITY 1] : KEEP, 
   [COORD @D73904, PAST @D73903, AGR [CASE @D73902, COUNT @D73901, 
            PER @D73900, PLU @D73899, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : KEEP, 
   [COORD @D73910, PAST @D73909, 
      AGR [CASE @D73908, COUNT @D73907, PER @D73906, PLU @D73905, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, FIN -, 
      ARITY 1] : KEEP, 
   [COORD @D73916, PAST @D73915, AGR [CASE @D73914, COUNT @D73913, 
            PER @D73912, PLU @D73911, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : KEEP, 
   [COORD @D73922, PAST @D73921, 
      AGR [CASE @D73920, COUNT @D73919, PER @D73918, PLU @D73917, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, FIN -, 
      ARITY 1] : KEEP, 
   [COORD @D73928, PAST @D73927, AGR [CASE @D73926, COUNT @D73925, 
            PER @D73924, PLU @D73923, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, FIN -, ARITY 1] : KEEP, 
   [COORD @D73930, AGR @D73929, FIX NOT, V +, N -, VFORM NOT, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, PAST +, 
      ARITY 1] : KEEP, 
   [COORD @D73934, AGR [COUNT @D73933, PER @D73932, PLU @D73931, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : KEEP, 
   [COORD @D73938, AGR [COUNT @D73937, PER @D73936, PLU @D73935, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : KEEP, 
   [COORD @D73942, AGR [COUNT @D73941, PER @D73940, PLU @D73939, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UNDER, PAST +, ARITY 1] : KEEP, 
   [COORD @D73946, AGR [COUNT @D73945, PER @D73944, PLU @D73943, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : KEEP, 
   [COORD @D73948, AGR @D73947, FIX NOT, V +, N -, VFORM NOT, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, PRT ON, 
      PAST +, ARITY 1] : KEEP, 
   [COORD @D73952, AGR [COUNT @D73951, PER @D73950, PLU @D73949, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : KEEP, 
   [COORD @D73956, AGR [COUNT @D73955, PER @D73954, PLU @D73953, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : KEEP, 
   [COORD @D73960, AGR [COUNT @D73959, PER @D73958, PLU @D73957, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : KEEP, 
   [COORD @D73964, AGR [COUNT @D73963, PER @D73962, PLU @D73961, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : KEEP, 
   [COORD @D73968, AGR [COUNT @D73967, PER @D73966, PLU @D73965, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : KEEP.

WORD kick : 
   [COORD @D73984, REFL @D73983, COUNT @D73982, PRD @D73981, CASE 
         @D73980, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : KICK, 
   [COORD @D73987, 
      AGR [COUNT @D73986, PER @D73985, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   KICK, 
   [COORD @D73989, AGR [COUNT @D73988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : KICK, 
   [COORD @D73991, AGR [COUNT @D73990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : KICK, 
   [COORD @D73995, AGR [COUNT @D73994, PER @D73993, PLU @D73992, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : KICK, 
   [COORD @D74001, PAST @D74000, AGR [CASE @D73999, COUNT @D73998, 
            PER @D73997, PLU @D73996, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : KICK, 
   [COORD @D74004, AGR [COUNT @D74003, PER @D74002, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : KICK, 
   [COORD @D74006, AGR [COUNT @D74005, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : KICK, 
   [COORD @D74008, AGR [COUNT @D74007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : KICK, 
   [COORD @D74012, AGR [COUNT @D74011, PER @D74010, PLU @D74009, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : KICK, 
   [COORD @D74018, PAST @D74017, 
      AGR [CASE @D74016, COUNT @D74015, PER @D74014, PLU @D74013, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM OF, ARITY 3] : KICK, 
   [COORD @D74021, AGR [COUNT @D74020, PER @D74019, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : KICK, 
   [COORD @D74023, AGR [COUNT @D74022, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : KICK, 
   [COORD @D74025, AGR [COUNT @D74024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : KICK, 
   [COORD @D74029, AGR [COUNT @D74028, PER @D74027, PLU @D74026, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : KICK, 
   [COORD @D74035, PAST @D74034, AGR [CASE @D74033, COUNT @D74032, 
            PER @D74031, PLU @D74030, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : KICK, 
   [COORD @D74038, AGR [COUNT @D74037, PER @D74036, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : KICK, 
   [COORD @D74040, AGR [COUNT @D74039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : KICK, 
   [COORD @D74042, AGR [COUNT @D74041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : KICK, 
   [COORD @D74046, AGR [COUNT @D74045, PER @D74044, PLU @D74043, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT AROUND, ARITY 2] : KICK, 
   [COORD @D74052, PAST @D74051, 
      AGR [CASE @D74050, COUNT @D74049, PER @D74048, PLU @D74047, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT AROUND, 
      ARITY 2] : KICK, 
   [COORD @D74055, AGR [COUNT @D74054, PER @D74053, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ABOUT, ARITY 2] : KICK, 
   [COORD @D74057, AGR [COUNT @D74056, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ABOUT, ARITY 2] : KICK, 
   [COORD @D74059, AGR [COUNT @D74058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ABOUT, ARITY 2] : KICK, 
   [COORD @D74063, AGR [COUNT @D74062, PER @D74061, PLU @D74060, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT ABOUT, ARITY 2] : KICK, 
   [COORD @D74069, PAST @D74068, 
      AGR [CASE @D74067, COUNT @D74066, PER @D74065, PLU @D74064, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, PRT ABOUT, 
      ARITY 2] : KICK, 
   [COORD @D74072, AGR [COUNT @D74071, PER @D74070, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : KICK, 
   [COORD @D74074, AGR [COUNT @D74073, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : KICK, 
   [COORD @D74076, AGR [COUNT @D74075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : KICK, 
   [COORD @D74080, AGR [COUNT @D74079, PER @D74078, PLU @D74077, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : KICK, 
   [COORD @D74086, PAST @D74085, 
      AGR [CASE @D74084, COUNT @D74083, PER @D74082, PLU @D74081, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP AT, ARITY 2] : KICK, 
   [COORD @D74089, AGR [COUNT @D74088, PER @D74087, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : KICK, 
   [COORD @D74091, AGR [COUNT @D74090, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : KICK, 
   [COORD @D74093, AGR [COUNT @D74092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : KICK, 
   [COORD @D74097, AGR [COUNT @D74096, PER @D74095, PLU @D74094, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AGAINST, ARITY 2] : KICK, 
   [COORD @D74103, PAST @D74102, 
      AGR [CASE @D74101, COUNT @D74100, PER @D74099, PLU @D74098, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP AGAINST, ARITY 2] : KICK, 
   [COORD @D74106, AGR [COUNT @D74105, PER @D74104, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AROUND, ARITY 2] : KICK, 
   [COORD @D74108, AGR [COUNT @D74107, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AROUND, ARITY 2] : KICK, 
   [COORD @D74110, AGR [COUNT @D74109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AROUND, ARITY 2] : KICK, 
   [COORD @D74114, AGR [COUNT @D74113, PER @D74112, PLU @D74111, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AROUND, ARITY 2] : KICK, 
   [COORD @D74120, PAST @D74119, 
      AGR [CASE @D74118, COUNT @D74117, PER @D74116, PLU @D74115, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AROUND, 
      ARITY 2] : KICK, 
   [COORD @D74123, AGR [COUNT @D74122, PER @D74121, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : KICK, 
   [COORD @D74125, AGR [COUNT @D74124, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : KICK, 
   [COORD @D74127, AGR [COUNT @D74126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : KICK, 
   [COORD @D74131, AGR [COUNT @D74130, PER @D74129, PLU @D74128, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : KICK, 
   [COORD @D74137, PAST @D74136, 
      AGR [CASE @D74135, COUNT @D74134, PER @D74133, PLU @D74132, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, 
      ARITY 2] : KICK, 
   [COORD @D74140, AGR [COUNT @D74139, PER @D74138, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : KICK, 
   [COORD @D74142, AGR [COUNT @D74141, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : KICK, 
   [COORD @D74144, AGR [COUNT @D74143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : KICK, 
   [COORD @D74148, AGR [COUNT @D74147, PER @D74146, PLU @D74145, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : KICK, 
   [COORD @D74154, PAST @D74153, 
      AGR [CASE @D74152, COUNT @D74151, PER @D74150, PLU @D74149, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : KICK, 
   [COORD @D74157, AGR [COUNT @D74156, PER @D74155, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : KICK, 
   [COORD @D74159, AGR [COUNT @D74158, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : KICK, 
   [COORD @D74161, AGR [COUNT @D74160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : KICK, 
   [COORD @D74165, AGR [COUNT @D74164, PER @D74163, PLU @D74162, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : KICK, 
   [COORD @D74171, PAST @D74170, 
      AGR [CASE @D74169, COUNT @D74168, PER @D74167, PLU @D74166, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : KICK, 
   [COORD @D74174, AGR [COUNT @D74173, PER @D74172, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KICK, 
   [COORD @D74176, AGR [COUNT @D74175, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KICK, 
   [COORD @D74178, AGR [COUNT @D74177, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KICK, 
   [COORD @D74182, AGR [COUNT @D74181, PER @D74180, PLU @D74179, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KICK, 
   [COORD @D74188, PAST @D74187, AGR [CASE @D74186, COUNT @D74185, 
            PER @D74184, PLU @D74183, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : KICK, 
   [COORD @D74191, AGR [COUNT @D74190, PER @D74189, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : KICK, 
   [COORD @D74193, AGR [COUNT @D74192, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : KICK, 
   [COORD @D74195, AGR [COUNT @D74194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : KICK, 
   [COORD @D74199, AGR [COUNT @D74198, PER @D74197, PLU @D74196, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : KICK, 
   [COORD @D74205, PAST @D74204, 
      AGR [CASE @D74203, COUNT @D74202, PER @D74201, PLU @D74200, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : KICK, 
   [COORD @D74208, AGR [COUNT @D74207, PER @D74206, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : KICK, 
   [COORD @D74210, AGR [COUNT @D74209, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : KICK, 
   [COORD @D74212, AGR [COUNT @D74211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : KICK, 
   [COORD @D74216, AGR [COUNT @D74215, PER @D74214, PLU @D74213, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : KICK, 
   [COORD @D74222, PAST @D74221, 
      AGR [CASE @D74220, COUNT @D74219, PER @D74218, PLU @D74217, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : KICK, 
   [COORD @D74225, AGR [COUNT @D74224, PER @D74223, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KICK, 
   [COORD @D74227, AGR [COUNT @D74226, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KICK, 
   [COORD @D74229, AGR [COUNT @D74228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KICK, 
   [COORD @D74233, AGR [COUNT @D74232, PER @D74231, PLU @D74230, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KICK, 
   [COORD @D74239, PAST @D74238, 
      AGR [CASE @D74237, COUNT @D74236, PER @D74235, PLU @D74234, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : KICK, 
   [COORD @D74242, AGR [COUNT @D74241, PER @D74240, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : KICK, 
   [COORD @D74244, AGR [COUNT @D74243, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : KICK, 
   [COORD @D74246, AGR [COUNT @D74245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : KICK, 
   [COORD @D74250, AGR [COUNT @D74249, PER @D74248, PLU @D74247, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : KICK, 
   [COORD @D74256, PAST @D74255, 
      AGR [CASE @D74254, COUNT @D74253, PER @D74252, PLU @D74251, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AROUND, 
      ARITY 1] : KICK, 
   [COORD @D74259, AGR [COUNT @D74258, PER @D74257, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : KICK, 
   [COORD @D74261, AGR [COUNT @D74260, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : KICK, 
   [COORD @D74263, AGR [COUNT @D74262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : KICK, 
   [COORD @D74267, AGR [COUNT @D74266, PER @D74265, PLU @D74264, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : KICK, 
   [COORD @D74273, PAST @D74272, 
      AGR [CASE @D74271, COUNT @D74270, PER @D74269, PLU @D74268, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ABOUT, 
      ARITY 1] : KICK.

WORD kicked : 
   [COORD @D74282, AGR [CASE @D74281, COUNT @D74280, PER @D74279, 
            PLU @D74278, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : KICK, 
   [COORD @D74287, AGR [CASE @D74286, COUNT @D74285, PER @D74284, 
            PLU @D74283, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74292, AGR [CASE @D74291, COUNT @D74290, PER @D74289, 
            PLU @D74288, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74297, AGR [CASE @D74296, COUNT @D74295, PER @D74294, 
            PLU @D74293, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74302, AGR [CASE @D74301, COUNT @D74300, PER @D74299, 
            PLU @D74298, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74307, 
      AGR [CASE @D74306, COUNT @D74305, PER @D74304, PLU @D74303, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74312, AGR [CASE @D74311, COUNT @D74310, PER @D74309, 
            PLU @D74308, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : KICK, 
   [COORD @D74317, AGR [CASE @D74316, COUNT @D74315, PER @D74314, 
            PLU @D74313, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74322, AGR [CASE @D74321, COUNT @D74320, PER @D74319, 
            PLU @D74318, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74327, AGR [CASE @D74326, COUNT @D74325, PER @D74324, 
            PLU @D74323, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74332, AGR [CASE @D74331, COUNT @D74330, PER @D74329, 
            PLU @D74328, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74337, AGR [CASE @D74336, COUNT @D74335, PER @D74334, 
            PLU @D74333, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74342, AGR [CASE @D74341, COUNT @D74340, PER @D74339, 
            PLU @D74338, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74347, AGR [CASE @D74346, COUNT @D74345, PER @D74344, 
            PLU @D74343, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74352, AGR [CASE @D74351, COUNT @D74350, PER @D74349, 
            PLU @D74348, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74357, AGR [CASE @D74356, COUNT @D74355, PER @D74354, 
            PLU @D74353, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74362, AGR [CASE @D74361, COUNT @D74360, PER @D74359, 
            PLU @D74358, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74367, AGR [CASE @D74366, COUNT @D74365, PER @D74364, 
            PLU @D74363, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74372, AGR [CASE @D74371, COUNT @D74370, PER @D74369, 
            PLU @D74368, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74377, AGR [CASE @D74376, COUNT @D74375, PER @D74374, 
            PLU @D74373, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74382, AGR [CASE @D74381, COUNT @D74380, PER @D74379, 
            PLU @D74378, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74387, AGR [CASE @D74386, COUNT @D74385, PER @D74384, 
            PLU @D74383, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74392, AGR [CASE @D74391, COUNT @D74390, PER @D74389, 
            PLU @D74388, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74397, AGR [CASE @D74396, COUNT @D74395, PER @D74394, 
            PLU @D74393, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74402, AGR [CASE @D74401, COUNT @D74400, PER @D74399, 
            PLU @D74398, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74407, AGR [CASE @D74406, COUNT @D74405, PER @D74404, 
            PLU @D74403, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74412, AGR [CASE @D74411, COUNT @D74410, PER @D74409, 
            PLU @D74408, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74417, AGR [CASE @D74416, COUNT @D74415, PER @D74414, 
            PLU @D74413, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74422, AGR [CASE @D74421, COUNT @D74420, PER @D74419, 
            PLU @D74418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74427, AGR [CASE @D74426, COUNT @D74425, PER @D74424, 
            PLU @D74423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74432, AGR [CASE @D74431, COUNT @D74430, PER @D74429, 
            PLU @D74428, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74437, AGR [CASE @D74436, COUNT @D74435, PER @D74434, 
            PLU @D74433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74442, AGR [CASE @D74441, COUNT @D74440, PER @D74439, 
            PLU @D74438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74447, AGR [CASE @D74446, COUNT @D74445, PER @D74444, 
            PLU @D74443, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74452, AGR [CASE @D74451, COUNT @D74450, PER @D74449, 
            PLU @D74448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74457, AGR [CASE @D74456, COUNT @D74455, PER @D74454, 
            PLU @D74453, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74462, AGR [CASE @D74461, COUNT @D74460, PER @D74459, 
            PLU @D74458, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74467, AGR [CASE @D74466, COUNT @D74465, PER @D74464, 
            PLU @D74463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74472, AGR [CASE @D74471, COUNT @D74470, PER @D74469, 
            PLU @D74468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74477, AGR [CASE @D74476, COUNT @D74475, PER @D74474, 
            PLU @D74473, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74482, AGR [CASE @D74481, COUNT @D74480, PER @D74479, 
            PLU @D74478, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : KICK, 
   [COORD @D74487, AGR [CASE @D74486, COUNT @D74485, PER @D74484, 
            PLU @D74483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74492, AGR [CASE @D74491, COUNT @D74490, PER @D74489, 
            PLU @D74488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KICK.

WORD kicking : 
   [COORD @D74506, PRD @D74505, AGR [CASE @D74504, COUNT @D74503, 
            PER @D74502, PLU @D74501, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74512, PRD @D74511, 
      AGR [CASE @D74510, COUNT @D74509, PER @D74508, PLU @D74507, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : KICK, 
   [COORD @D74518, PRD @D74517, AGR [CASE @D74516, COUNT @D74515, 
            PER @D74514, PLU @D74513, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74524, PRD @D74523, 
      AGR [CASE @D74522, COUNT @D74521, PER @D74520, PLU @D74519, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KICK, 
   [COORD @D74530, PRD @D74529, AGR [CASE @D74528, COUNT @D74527, 
            PER @D74526, PLU @D74525, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74536, PRD @D74535, 
      AGR [CASE @D74534, COUNT @D74533, PER @D74532, PLU @D74531, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PREP AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KICK, 
   [COORD @D74542, PRD @D74541, AGR [CASE @D74540, COUNT @D74539, 
            PER @D74538, PLU @D74537, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, 
      PREP AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74548, PRD @D74547, 
      AGR [CASE @D74546, COUNT @D74545, PER @D74544, PLU @D74543, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : KICK, 
   [COORD @D74554, PRD @D74553, AGR [CASE @D74552, COUNT @D74551, 
            PER @D74550, PLU @D74549, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74560, PRD @D74559, 
      AGR [CASE @D74558, COUNT @D74557, PER @D74556, PLU @D74555, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KICK, 
   [COORD @D74566, PRD @D74565, AGR [CASE @D74564, COUNT @D74563, 
            PER @D74562, PLU @D74561, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74572, PRD @D74571, 
      AGR [CASE @D74570, COUNT @D74569, PER @D74568, PLU @D74567, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   KICK, 
   [COORD @D74578, PRD @D74577, AGR [CASE @D74576, COUNT @D74575, 
            PER @D74574, PLU @D74573, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74584, PRD @D74583, 
      AGR [CASE @D74582, COUNT @D74581, PER @D74580, PLU @D74579, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KICK, 
   [COORD @D74590, PRD @D74589, AGR [CASE @D74588, COUNT @D74587, 
            PER @D74586, PLU @D74585, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK, 
   [COORD @D74596, PRD @D74595, 
      AGR [CASE @D74594, COUNT @D74593, PER @D74592, PLU @D74591, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KICK, 
   [COORD @D74602, PRD @D74601, AGR [CASE @D74600, COUNT @D74599, 
            PER @D74598, PLU @D74597, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : KICK.

WORD kicks : 
   [COORD @D74610, REFL @D74609, PRD @D74608, CASE @D74607, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : KICKS, 
   [COORD @D74615, DEMON @D74614, REFL @D74613, PRD @D74612, 
      CASE @D74611, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : KICK, 
   [COORD @D74617, 
      AGR [COUNT @D74616, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74619, 
      AGR [COUNT @D74618, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   KICK, 
   [COORD @D74621, AGR [COUNT @D74620, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74623, 
      AGR [COUNT @D74622, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74625, 
      AGR [COUNT @D74624, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74627, 
      AGR [COUNT @D74626, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74629, 
      AGR [COUNT @D74628, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   KICK, 
   [COORD @D74631, AGR [COUNT @D74630, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KICK, 
   [COORD @D74633, AGR [COUNT @D74632, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : KICK, 
   [COORD @D74635, AGR [COUNT @D74634, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74637, 
      AGR [COUNT @D74636, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74639, 
      AGR [COUNT @D74638, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74641, 
      AGR [COUNT @D74640, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74643, 
      AGR [COUNT @D74642, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74645, 
      AGR [COUNT @D74644, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74647, 
      AGR [COUNT @D74646, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK, 
   [COORD @D74649, 
      AGR [COUNT @D74648, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KICK.

WORD kill : 
   [COORD @D74663, AGR [COUNT @D74662, PER @D74661, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : KILL, 
   [COORD @D74665, AGR [COUNT @D74664, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : KILL, 
   [COORD @D74667, AGR [COUNT @D74666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : KILL, 
   [COORD @D74671, AGR [COUNT @D74670, PER @D74669, PLU @D74668, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : KILL, 
   [COORD @D74677, PAST @D74676, AGR [CASE @D74675, COUNT @D74674, 
            PER @D74673, PLU @D74672, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : KILL, 
   [COORD @D74680, AGR [COUNT @D74679, PER @D74678, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : KILL, 
   [COORD @D74682, AGR [COUNT @D74681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : KILL, 
   [COORD @D74684, AGR [COUNT @D74683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : KILL, 
   [COORD @D74688, AGR [COUNT @D74687, PER @D74686, PLU @D74685, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : KILL, 
   [COORD @D74694, PAST @D74693, 
      AGR [CASE @D74692, COUNT @D74691, PER @D74690, PLU @D74689, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : KILL, 
   [COORD @D74697, AGR [COUNT @D74696, PER @D74695, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KILL, 
   [COORD @D74699, AGR [COUNT @D74698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KILL, 
   [COORD @D74701, AGR [COUNT @D74700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KILL, 
   [COORD @D74705, AGR [COUNT @D74704, PER @D74703, PLU @D74702, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : KILL, 
   [COORD @D74711, PAST @D74710, AGR [CASE @D74709, COUNT @D74708, 
            PER @D74707, PLU @D74706, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : KILL, 
   [COORD @D74714, AGR [COUNT @D74713, PER @D74712, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KILL, 
   [COORD @D74716, AGR [COUNT @D74715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KILL, 
   [COORD @D74718, AGR [COUNT @D74717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KILL, 
   [COORD @D74722, AGR [COUNT @D74721, PER @D74720, PLU @D74719, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : KILL, 
   [COORD @D74728, PAST @D74727, 
      AGR [CASE @D74726, COUNT @D74725, PER @D74724, PLU @D74723, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : KILL.

WORD killed : 
   [COORD @D74737, AGR [CASE @D74736, COUNT @D74735, PER @D74734, 
            PLU @D74733, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : KILL, 
   [COORD @D74742, AGR [CASE @D74741, COUNT @D74740, PER @D74739, 
            PLU @D74738, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KILL, 
   [COORD @D74747, AGR [CASE @D74746, COUNT @D74745, PER @D74744, 
            PLU @D74743, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : KILL, 
   [COORD @D74752, AGR [CASE @D74751, COUNT @D74750, PER @D74749, 
            PLU @D74748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KILL, 
   [COORD @D74757, AGR [CASE @D74756, COUNT @D74755, PER @D74754, 
            PLU @D74753, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KILL, 
   [COORD @D74762, AGR [CASE @D74761, COUNT @D74760, PER @D74759, 
            PLU @D74758, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KILL, 
   [COORD @D74767, AGR [CASE @D74766, COUNT @D74765, PER @D74764, 
            PLU @D74763, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : KILL, 
   [COORD @D74772, AGR [CASE @D74771, COUNT @D74770, PER @D74769, 
            PLU @D74768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : KILL, 
   [COORD @D74777, AGR [CASE @D74776, COUNT @D74775, PER @D74774, 
            PLU @D74773, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KILL, 
   [COORD @D74782, AGR [CASE @D74781, COUNT @D74780, PER @D74779, 
            PLU @D74778, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : KILL.

WORD killing : 
   [COORD @D74795, PRD @D74794, AGR [CASE @D74793, COUNT @D74792, 
            PER @D74791, PLU @D74790, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KILL, 
   [COORD @D74801, PRD @D74800, 
      AGR [CASE @D74799, COUNT @D74798, PER @D74797, PLU @D74796, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KILL, 
   [COORD @D74807, PRD @D74806, AGR [CASE @D74805, COUNT @D74804, 
            PER @D74803, PLU @D74802, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : KILL, 
   [COORD @D74813, PRD @D74812, 
      AGR [CASE @D74811, COUNT @D74810, PER @D74809, PLU @D74808, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : KILL.

WORD kills : 
   [COORD @D74819, AGR [COUNT @D74818, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KILL, 
   [COORD @D74821, 
      AGR [COUNT @D74820, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KILL, 
   [COORD @D74823, 
      AGR [COUNT @D74822, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KILL, 
   [COORD @D74825, 
      AGR [COUNT @D74824, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : KILL.

WORD lager : 
   [COORD @D74833, REFL @D74832, COUNT @D74831, PRD @D74830, CASE 
         @D74829, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LAGER.

WORD lagers : 
   [COORD @D74842, DEMON @D74841, REFL @D74840, PRD @D74839, CASE 
         @D74838, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LAGER.

WORD laid : 
   [COORD @D74852, PAST @D74851, AGR [CASE @D74850, COUNT @D74849, 
            PER @D74848, PLU @D74847, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, REG -, FIN -, ARITY 3] : LAY, 
   [COORD @D74858, PAST @D74857, 
      AGR [CASE @D74856, COUNT @D74855, PER @D74854, PLU @D74853, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, REG -, FIN -, ARITY 3] : LAY, 
   
   [COORD @D74864, PAST @D74863, AGR [CASE @D74862, COUNT @D74861, PER 
               @D74860, PLU @D74859, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT UPON, FIN -, ARITY 3] : LAY, 
   [COORD @D74870, PAST @D74869, 
      AGR [CASE @D74868, COUNT @D74867, PER @D74866, PLU @D74865, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT UPON, FIN -, 
      ARITY 3] : LAY, 
   [COORD @D74876, PAST @D74875, AGR [CASE @D74874, COUNT @D74873, 
            PER @D74872, PLU @D74871, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT ON, FIN -, ARITY 3] : LAY, 
   [COORD @D74882, PAST @D74881, 
      AGR [CASE @D74880, COUNT @D74879, PER @D74878, PLU @D74877, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT ON, FIN -, 
      ARITY 3] : LAY, 
   [COORD @D74888, PAST @D74887, AGR [CASE @D74886, COUNT @D74885, 
            PER @D74884, PLU @D74883, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, FIN -, ARITY 3] : LAY, 
   [COORD @D74894, PAST @D74893, 
      AGR [CASE @D74892, COUNT @D74891, PER @D74890, PLU @D74889, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, FIN -, 
      ARITY 3] : LAY, 
   [COORD @D74900, PAST @D74899, AGR [CASE @D74898, COUNT @D74897, 
            PER @D74896, PLU @D74895, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : LAY, 
   [COORD @D74906, PAST @D74905, 
      AGR [CASE @D74904, COUNT @D74903, PER @D74902, PLU @D74901, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, FIN -, 
      ARITY 3] : LAY, 
   [COORD @D74912, PAST @D74911, AGR [CASE @D74910, COUNT @D74909, 
            PER @D74908, PLU @D74907, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OFF, FIN -, ARITY 3] : LAY, 
   [COORD @D74918, PAST @D74917, 
      AGR [CASE @D74916, COUNT @D74915, PER @D74914, PLU @D74913, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OFF, FIN -, 
      ARITY 3] : LAY, 
   [COORD @D74924, PAST @D74923, AGR [CASE @D74922, COUNT @D74921, 
            PER @D74920, PLU @D74919, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM AT, FIN -, ARITY 3] : LAY, 
   [COORD @D74930, PAST @D74929, 
      AGR [CASE @D74928, COUNT @D74927, PER @D74926, PLU @D74925, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM AT, FIN -, 
      ARITY 3] : LAY, 
   [COORD @D74936, PAST @D74935, AGR [CASE @D74934, COUNT @D74933, 
            PER @D74932, PLU @D74931, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OPEN, PFORM TO, FIN -, ARITY 3] : LAY, 
   [COORD @D74942, PAST @D74941, 
      AGR [CASE @D74940, COUNT @D74939, PER @D74938, PLU @D74937, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OPEN, 
      PFORM TO, FIN -, ARITY 3] : LAY, 
   [COORD @D74948, PAST @D74947, AGR [CASE @D74946, COUNT @D74945, 
            PER @D74944, PLU @D74943, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, PFORM TO, FIN -, ARITY 3] : LAY, 
   [COORD @D74954, PAST @D74953, 
      AGR [CASE @D74952, COUNT @D74951, PER @D74950, PLU @D74949, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      PFORM TO, FIN -, ARITY 3] : LAY, 
   [COORD @D74960, PAST @D74959, AGR [CASE @D74958, COUNT @D74957, 
            PER @D74956, PLU @D74955, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, PFORM FOR, FIN -, ARITY 3] : LAY, 
   [COORD @D74966, PAST @D74965, 
      AGR [CASE @D74964, COUNT @D74963, PER @D74962, PLU @D74961, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      PFORM FOR, FIN -, ARITY 3] : LAY, 
   [COORD @D74972, PAST @D74971, AGR [CASE @D74970, COUNT @D74969, 
            PER @D74968, PLU @D74967, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM FOR, FIN -, ARITY 3] : LAY, 
   [COORD @D74978, PAST @D74977, 
      AGR [CASE @D74976, COUNT @D74975, PER @D74974, PLU @D74973, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      PFORM FOR, FIN -, ARITY 3] : LAY, 
   [COORD @D74982, AGR [COUNT @D74981, PER @D74980, PLU @D74979, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, REG -, 
      PAST +, ARITY 3] : LAY, 
   [COORD @D74986, AGR [COUNT @D74985, PER @D74984, PLU @D74983, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT UPON, PAST +, ARITY 3] : LAY, 
   [COORD @D74990, AGR [COUNT @D74989, PER @D74988, PLU @D74987, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT ON, PAST +, ARITY 3] : LAY, 
   [COORD @D74994, AGR [COUNT @D74993, PER @D74992, PLU @D74991, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, PAST +, ARITY 3] : LAY, 
   [COORD @D74998, AGR [COUNT @D74997, PER @D74996, PLU @D74995, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ON, PAST +, ARITY 3] : LAY, 
   [COORD @D75002, AGR [COUNT @D75001, PER @D75000, PLU @D74999, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OFF, PAST +, ARITY 3] : LAY, 
   [COORD @D75006, AGR [COUNT @D75005, PER @D75004, PLU @D75003, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM AT, PAST +, ARITY 3] : LAY, 
   [COORD @D75010, AGR [COUNT @D75009, PER @D75008, PLU @D75007, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OPEN, PFORM TO, PAST +, ARITY 3] : LAY, 
   [COORD @D75014, AGR [COUNT @D75013, PER @D75012, PLU @D75011, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, PFORM TO, PAST +, ARITY 3] : LAY, 
   [COORD @D75018, AGR [COUNT @D75017, PER @D75016, PLU @D75015, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, PFORM FOR, PAST +, ARITY 3] : LAY, 
   [COORD @D75022, AGR [COUNT @D75021, PER @D75020, PLU @D75019, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PFORM FOR, PAST +, ARITY 3] : LAY, 
   [COORD @D75028, PAST @D75027, 
      AGR [CASE @D75026, COUNT @D75025, PER @D75024, PLU @D75023, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, FIN -, ARITY 2] : LAY, 
   
   [COORD @D75034, PAST @D75033, AGR [CASE @D75032, COUNT @D75031, PER 
               @D75030, PLU @D75029, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : LAY, 
   [COORD @D75040, PAST @D75039, 
      AGR [CASE @D75038, COUNT @D75037, PER @D75036, PLU @D75035, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : LAY, 
   [COORD @D75046, PAST @D75045, 
      AGR [CASE @D75044, COUNT @D75043, PER @D75042, PLU @D75041, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT LOW, FIN -, 
      ARITY 2] : LAY, 
   [COORD @D75052, PAST @D75051, AGR [CASE @D75050, COUNT @D75049, 
            PER @D75048, PLU @D75047, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT LOW, FIN -, ARITY 2] : LAY, 
   [COORD @D75058, PAST @D75057, 
      AGR [CASE @D75056, COUNT @D75055, PER @D75054, PLU @D75053, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT BY, FIN -, 
      ARITY 2] : LAY, 
   [COORD @D75064, PAST @D75063, AGR [CASE @D75062, COUNT @D75061, 
            PER @D75060, PLU @D75059, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT BY, FIN -, ARITY 2] : LAY, 
   [COORD @D75070, PAST @D75069, 
      AGR [CASE @D75068, COUNT @D75067, PER @D75066, PLU @D75065, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT WASTE, PFORM TO, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75076, PAST @D75075, AGR [CASE @D75074, COUNT @D75073, 
            PER @D75072, PLU @D75071, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM OFF, FIN -, ARITY 2] : LAY, 
   [COORD @D75082, PAST @D75081, 
      AGR [CASE @D75080, COUNT @D75079, PER @D75078, PLU @D75077, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, FIN -, 
      ARITY 2] : LAY, 
   [COORD @D75088, PAST @D75087, AGR [CASE @D75086, COUNT @D75085, 
            PER @D75084, PLU @D75083, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM INTO, FIN -, ARITY 2] : LAY, 
   [COORD @D75094, PAST @D75093, 
      AGR [CASE @D75092, COUNT @D75091, PER @D75090, PLU @D75089, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, FIN -, 
      ARITY 2] : LAY, 
   [COORD @D75100, PAST @D75099, AGR [CASE @D75098, COUNT @D75097, 
            PER @D75096, PLU @D75095, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ABOUT, FIN -, ARITY 2] : LAY, 
   [COORD @D75106, PAST @D75105, 
      AGR [CASE @D75104, COUNT @D75103, PER @D75102, PLU @D75101, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, FIN -, 
      ARITY 2] : LAY, 
   [COORD @D75112, PAST @D75111, AGR [CASE @D75110, COUNT @D75109, 
            PER @D75108, PLU @D75107, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT WASTE, FIN -, ARITY 2] : LAY, 
   [COORD @D75118, PAST @D75117, 
      AGR [CASE @D75116, COUNT @D75115, PER @D75114, PLU @D75113, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT WASTE, FIN -, ARITY 2] : LAY, 
   [COORD @D75124, PAST @D75123, AGR [CASE @D75122, COUNT @D75121, 
            PER @D75120, PLU @D75119, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : LAY, 
   [COORD @D75130, PAST @D75129, 
      AGR [CASE @D75128, COUNT @D75127, PER @D75126, PLU @D75125, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75136, PAST @D75135, AGR [CASE @D75134, COUNT @D75133, 
            PER @D75132, PLU @D75131, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TO, FIN -, ARITY 2] : LAY, 
   [COORD @D75142, PAST @D75141, 
      AGR [CASE @D75140, COUNT @D75139, PER @D75138, PLU @D75137, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TO, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75148, PAST @D75147, AGR [CASE @D75146, COUNT @D75145, 
            PER @D75144, PLU @D75143, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : LAY, 
   [COORD @D75154, PAST @D75153, 
      AGR [CASE @D75152, COUNT @D75151, PER @D75150, PLU @D75149, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75160, PAST @D75159, AGR [CASE @D75158, COUNT @D75157, 
            PER @D75156, PLU @D75155, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OPEN, FIN -, ARITY 2] : LAY, 
   [COORD @D75166, PAST @D75165, 
      AGR [CASE @D75164, COUNT @D75163, PER @D75162, PLU @D75161, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OPEN, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75172, PAST @D75171, AGR [CASE @D75170, COUNT @D75169, 
            PER @D75168, PLU @D75167, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, FIN -, ARITY 2] : LAY, 
   [COORD @D75178, PAST @D75177, 
      AGR [CASE @D75176, COUNT @D75175, PER @D75174, PLU @D75173, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75184, PAST @D75183, AGR [CASE @D75182, COUNT @D75181, 
            PER @D75180, PLU @D75179, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : LAY, 
   [COORD @D75190, PAST @D75189, 
      AGR [CASE @D75188, COUNT @D75187, PER @D75186, PLU @D75185, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75196, PAST @D75195, AGR [CASE @D75194, COUNT @D75193, 
            PER @D75192, PLU @D75191, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : LAY, 
   [COORD @D75202, PAST @D75201, 
      AGR [CASE @D75200, COUNT @D75199, PER @D75198, PLU @D75197, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75208, PAST @D75207, AGR [CASE @D75206, COUNT @D75205, 
            PER @D75204, PLU @D75203, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FLAT, FIN -, ARITY 2] : LAY, 
   [COORD @D75214, PAST @D75213, 
      AGR [CASE @D75212, COUNT @D75211, PER @D75210, PLU @D75209, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT FLAT, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75220, PAST @D75219, AGR [CASE @D75218, COUNT @D75217, 
            PER @D75216, PLU @D75215, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : LAY, 
   [COORD @D75226, PAST @D75225, 
      AGR [CASE @D75224, COUNT @D75223, PER @D75222, PLU @D75221, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      FIN -, ARITY 2] : LAY, 
   [COORD @D75232, PAST @D75231, AGR [CASE @D75230, COUNT @D75229, 
            PER @D75228, PLU @D75227, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASIDE, FIN -, ARITY 2] : LAY, 
   [COORD @D75238, PAST @D75237, 
      AGR [CASE @D75236, COUNT @D75235, PER @D75234, PLU @D75233, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, FIN -, ARITY 2] : LAY, 
   [COORD @D75242, AGR [COUNT @D75241, PER @D75240, PLU @D75239, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PAST +, ARITY 2] : LAY, 
   [COORD @D75246, AGR [COUNT @D75245, PER @D75244, PLU @D75243, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : LAY, 
   [COORD @D75250, AGR [COUNT @D75249, PER @D75248, PLU @D75247, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT LOW, 
      PAST +, ARITY 2] : LAY, 
   [COORD @D75254, AGR [COUNT @D75253, PER @D75252, PLU @D75251, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT BY, 
      PAST +, ARITY 2] : LAY, 
   [COORD @D75258, AGR [COUNT @D75257, PER @D75256, PLU @D75255, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT WASTE, PFORM TO, PAST +, ARITY 2] : LAY, 
   [COORD @D75262, AGR [COUNT @D75261, PER @D75260, PLU @D75259, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, PAST +, ARITY 2] : LAY, 
   [COORD @D75266, AGR [COUNT @D75265, PER @D75264, PLU @D75263, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, PAST +, ARITY 2] : LAY, 
   [COORD @D75270, AGR [COUNT @D75269, PER @D75268, PLU @D75267, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, PAST +, ARITY 2] : LAY, 
   [COORD @D75274, AGR [COUNT @D75273, PER @D75272, PLU @D75271, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT WASTE, PAST +, ARITY 2] : LAY, 
   [COORD @D75278, AGR [COUNT @D75277, PER @D75276, PLU @D75275, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : LAY, 
   [COORD @D75282, AGR [COUNT @D75281, PER @D75280, PLU @D75279, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, PAST +, ARITY 2] : LAY, 
   [COORD @D75286, AGR [COUNT @D75285, PER @D75284, PLU @D75283, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : LAY, 
   [COORD @D75290, AGR [COUNT @D75289, PER @D75288, PLU @D75287, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OPEN, PAST +, ARITY 2] : LAY, 
   [COORD @D75294, AGR [COUNT @D75293, PER @D75292, PLU @D75291, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, PAST +, ARITY 2] : LAY, 
   [COORD @D75298, AGR [COUNT @D75297, PER @D75296, PLU @D75295, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : LAY, 
   [COORD @D75302, AGR [COUNT @D75301, PER @D75300, PLU @D75299, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : LAY, 
   [COORD @D75306, AGR [COUNT @D75305, PER @D75304, PLU @D75303, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FLAT, PAST +, ARITY 2] : LAY, 
   [COORD @D75310, AGR [COUNT @D75309, PER @D75308, PLU @D75307, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PAST +, ARITY 2] : LAY, 
   [COORD @D75314, AGR [COUNT @D75313, PER @D75312, PLU @D75311, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, PAST +, ARITY 2] : LAY, 
   [COORD @D75320, PAST @D75319, AGR [CASE @D75318, COUNT @D75317, 
            PER @D75316, PLU @D75315, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : LAY, 
   [COORD @D75326, PAST @D75325, 
      AGR [CASE @D75324, COUNT @D75323, PER @D75322, PLU @D75321, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT WASTE, FIN -, 
      ARITY 1] : LAY, 
   [COORD @D75332, PAST @D75331, AGR [CASE @D75330, COUNT @D75329, 
            PER @D75328, PLU @D75327, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : LAY, 
   [COORD @D75338, PAST @D75337, 
      AGR [CASE @D75336, COUNT @D75335, PER @D75334, PLU @D75333, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TO, FIN -, 
      ARITY 1] : LAY, 
   [COORD @D75344, PAST @D75343, AGR [CASE @D75342, COUNT @D75341, 
            PER @D75340, PLU @D75339, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, FIN -, ARITY 1] : LAY, 
   [COORD @D75350, PAST @D75349, 
      AGR [CASE @D75348, COUNT @D75347, PER @D75346, PLU @D75345, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : LAY, 
   [COORD @D75356, PAST @D75355, AGR [CASE @D75354, COUNT @D75353, 
            PER @D75352, PLU @D75351, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OPEN, FIN -, ARITY 1] : LAY, 
   [COORD @D75362, PAST @D75361, 
      AGR [CASE @D75360, COUNT @D75359, PER @D75358, PLU @D75357, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, FIN -, 
      ARITY 1] : LAY, 
   [COORD @D75368, PAST @D75367, AGR [CASE @D75366, COUNT @D75365, 
            PER @D75364, PLU @D75363, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : LAY, 
   [COORD @D75374, PAST @D75373, 
      AGR [CASE @D75372, COUNT @D75371, PER @D75370, PLU @D75369, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT LOW, FIN -, 
      ARITY 1] : LAY, 
   [COORD @D75380, PAST @D75379, AGR [CASE @D75378, COUNT @D75377, 
            PER @D75376, PLU @D75375, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : LAY, 
   [COORD @D75386, PAST @D75385, 
      AGR [CASE @D75384, COUNT @D75383, PER @D75382, PLU @D75381, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FLAT, FIN -, 
      ARITY 1] : LAY, 
   [COORD @D75392, PAST @D75391, AGR [CASE @D75390, COUNT @D75389, 
            PER @D75388, PLU @D75387, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : LAY, 
   [COORD @D75398, PAST @D75397, 
      AGR [CASE @D75396, COUNT @D75395, PER @D75394, PLU @D75393, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BY, FIN -, 
      ARITY 1] : LAY, 
   [COORD @D75404, PAST @D75403, AGR [CASE @D75402, COUNT @D75401, 
            PER @D75400, PLU @D75399, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASIDE, FIN -, ARITY 1] : LAY, 
   [COORD @D75408, 
      AGR [COUNT @D75407, PER @D75406, PLU @D75405, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : LAY, 
   [COORD @D75412, AGR [COUNT @D75411, PER @D75410, PLU @D75409, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT WASTE, PAST +, ARITY 1] : LAY, 
   [COORD @D75416, AGR [COUNT @D75415, PER @D75414, PLU @D75413, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : LAY, 
   [COORD @D75420, AGR [COUNT @D75419, PER @D75418, PLU @D75417, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, PAST +, ARITY 1] : LAY, 
   [COORD @D75424, AGR [COUNT @D75423, PER @D75422, PLU @D75421, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : LAY, 
   [COORD @D75428, AGR [COUNT @D75427, PER @D75426, PLU @D75425, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : LAY, 
   [COORD @D75432, AGR [COUNT @D75431, PER @D75430, PLU @D75429, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OPEN, PAST +, ARITY 1] : LAY, 
   [COORD @D75436, AGR [COUNT @D75435, PER @D75434, PLU @D75433, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : LAY, 
   [COORD @D75440, AGR [COUNT @D75439, PER @D75438, PLU @D75437, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : LAY, 
   [COORD @D75444, AGR [COUNT @D75443, PER @D75442, PLU @D75441, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT LOW, PAST +, ARITY 1] : LAY, 
   [COORD @D75448, AGR [COUNT @D75447, PER @D75446, PLU @D75445, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : LAY, 
   [COORD @D75452, AGR [COUNT @D75451, PER @D75450, PLU @D75449, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FLAT, PAST +, ARITY 1] : LAY, 
   [COORD @D75456, AGR [COUNT @D75455, PER @D75454, PLU @D75453, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : LAY, 
   [COORD @D75460, AGR [COUNT @D75459, PER @D75458, PLU @D75457, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, PAST +, ARITY 1] : LAY, 
   [COORD @D75464, AGR [COUNT @D75463, PER @D75462, PLU @D75461, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ASIDE, PAST +, ARITY 1] : LAY.

WORD land : 
   [COORD @D75487, REFL @D75486, COUNT @D75485, PRD @D75484, CASE 
         @D75483, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LAND, 
   [COORD @D75491, REFL @D75490, PRD @D75489, CASE @D75488, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LAND, 
   [COORD @D75494, 
      AGR [COUNT @D75493, PER @D75492, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   LAND, 
   [COORD @D75496, AGR [COUNT @D75495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : LAND, 
   [COORD @D75498, AGR [COUNT @D75497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : LAND, 
   [COORD @D75502, AGR [COUNT @D75501, PER @D75500, PLU @D75499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : LAND, 
   [COORD @D75508, PAST @D75507, AGR [CASE @D75506, COUNT @D75505, 
            PER @D75504, PLU @D75503, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : LAND, 
   [COORD @D75511, AGR [COUNT @D75510, PER @D75509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAND, 
   [COORD @D75513, AGR [COUNT @D75512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAND, 
   [COORD @D75515, AGR [COUNT @D75514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAND, 
   [COORD @D75519, AGR [COUNT @D75518, PER @D75517, PLU @D75516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAND, 
   [COORD @D75525, PAST @D75524, AGR [CASE @D75523, COUNT @D75522, 
            PER @D75521, PLU @D75520, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : LAND, 
   [COORD @D75528, AGR [COUNT @D75527, PER @D75526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAND, 
   [COORD @D75530, AGR [COUNT @D75529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAND, 
   [COORD @D75532, AGR [COUNT @D75531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAND, 
   [COORD @D75536, AGR [COUNT @D75535, PER @D75534, PLU @D75533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LAND, 
   [COORD @D75542, PAST @D75541, AGR [CASE @D75540, COUNT @D75539, 
            PER @D75538, PLU @D75537, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LAND, 
   [COORD @D75545, AGR [COUNT @D75544, PER @D75543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LAND, 
   [COORD @D75547, AGR [COUNT @D75546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LAND, 
   [COORD @D75549, AGR [COUNT @D75548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LAND, 
   [COORD @D75553, AGR [COUNT @D75552, PER @D75551, PLU @D75550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : LAND, 
   [COORD @D75559, PAST @D75558, AGR [CASE @D75557, COUNT @D75556, 
            PER @D75555, PLU @D75554, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : LAND, 
   [COORD @D75562, AGR [COUNT @D75561, PER @D75560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT UP, ARITY 2] : LAND, 
   [COORD @D75564, AGR [COUNT @D75563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT UP, ARITY 2] : LAND, 
   [COORD @D75566, AGR [COUNT @D75565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT UP, ARITY 2] : LAND, 
   [COORD @D75570, AGR [COUNT @D75569, PER @D75568, PLU @D75567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, PRT UP, ARITY 2] : LAND, 
   [COORD @D75576, PAST @D75575, 
      AGR [CASE @D75574, COUNT @D75573, PER @D75572, PLU @D75571, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, PRT UP, 
      ARITY 2] : LAND, 
   [COORD @D75579, AGR [COUNT @D75578, PER @D75577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAND, 
   [COORD @D75581, AGR [COUNT @D75580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAND, 
   [COORD @D75583, AGR [COUNT @D75582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAND, 
   [COORD @D75587, AGR [COUNT @D75586, PER @D75585, PLU @D75584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAND, 
   [COORD @D75593, PAST @D75592, AGR [CASE @D75591, COUNT @D75590, 
            PER @D75589, PLU @D75588, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LAND.

WORD landed : 
   [COORD @D75603, AGR [CASE @D75602, COUNT @D75601, PER @D75600, 
            PLU @D75599, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAND, 
   [COORD @D75608, AGR [CASE @D75607, COUNT @D75606, PER @D75605, 
            PLU @D75604, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75613, AGR [CASE @D75612, COUNT @D75611, PER @D75610, 
            PLU @D75609, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAND, 
   [COORD @D75618, AGR [CASE @D75617, COUNT @D75616, PER @D75615, 
            PLU @D75614, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAND, 
   [COORD @D75623, AGR [CASE @D75622, COUNT @D75621, PER @D75620, 
            PLU @D75619, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75628, AGR [CASE @D75627, COUNT @D75626, PER @D75625, 
            PLU @D75624, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAND, 
   [COORD @D75633, AGR [CASE @D75632, COUNT @D75631, PER @D75630, 
            PLU @D75629, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75638, AGR [CASE @D75637, COUNT @D75636, PER @D75635, 
            PLU @D75634, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAND, 
   [COORD @D75643, AGR [CASE @D75642, COUNT @D75641, PER @D75640, 
            PLU @D75639, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAND, 
   [COORD @D75648, AGR [CASE @D75647, COUNT @D75646, PER @D75645, 
            PLU @D75644, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75653, AGR [CASE @D75652, COUNT @D75651, PER @D75650, 
            PLU @D75649, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAND, 
   [COORD @D75658, AGR [CASE @D75657, COUNT @D75656, PER @D75655, 
            PLU @D75654, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75663, AGR [CASE @D75662, COUNT @D75661, PER @D75660, 
            PLU @D75659, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAND, 
   [COORD @D75668, AGR [CASE @D75667, COUNT @D75666, PER @D75665, 
            PLU @D75664, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75673, AGR [CASE @D75672, COUNT @D75671, PER @D75670, 
            PLU @D75669, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAND.

WORD landing : 
   [COORD @D75686, REFL @D75685, PRD @D75684, CASE @D75683, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LANDING, 
   [COORD @D75692, PRD @D75691, 
      AGR [CASE @D75690, COUNT @D75689, PER @D75688, PLU @D75687, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LAND, 
   [COORD @D75698, PRD @D75697, AGR [CASE @D75696, COUNT @D75695, 
            PER @D75694, PLU @D75693, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75704, PRD @D75703, 
      AGR [CASE @D75702, COUNT @D75701, PER @D75700, PLU @D75699, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LAND, 
   [COORD @D75710, PRD @D75709, AGR [CASE @D75708, COUNT @D75707, 
            PER @D75706, PLU @D75705, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAND, 
   [COORD @D75716, PRD @D75715, 
      AGR [CASE @D75714, COUNT @D75713, PER @D75712, PLU @D75711, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAND, 
   [COORD @D75722, PRD @D75721, AGR [CASE @D75720, COUNT @D75719, 
            PER @D75718, PLU @D75717, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAND.

WORD landings : 
   [COORD @D75739, DEMON @D75738, REFL @D75737, PRD @D75736, 
      CASE @D75735, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LANDING.

WORD lands : 
   [COORD @D75748, REFL @D75747, PRD @D75746, CASE @D75745, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : LANDS, 
   [COORD @D75753, DEMON @D75752, REFL @D75751, PRD @D75750, 
      CASE @D75749, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LAND, 
   [COORD @D75758, DEMON @D75757, REFL @D75756, PRD @D75755, 
      CASE @D75754, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : LAND, 
   [COORD @D75760, AGR [COUNT @D75759, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAND, 
   [COORD @D75762, 
      AGR [COUNT @D75761, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAND, 
   [COORD @D75764, 
      AGR [COUNT @D75763, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAND, 
   [COORD @D75766, 
      AGR [COUNT @D75765, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAND, 
   [COORD @D75768, 
      AGR [COUNT @D75767, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAND, 
   [COORD @D75770, 
      AGR [COUNT @D75769, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAND.

WORD laugh : 
   [COORD @D75786, AGR [COUNT @D75785, PER @D75784, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : LAUGH, 
   [COORD @D75788, AGR [COUNT @D75787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : LAUGH, 
   [COORD @D75790, AGR [COUNT @D75789, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : LAUGH, 
   [COORD @D75794, AGR [COUNT @D75793, PER @D75792, PLU @D75791, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : LAUGH, 
   [COORD @D75800, PAST @D75799, AGR [CASE @D75798, COUNT @D75797, 
            PER @D75796, PLU @D75795, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : LAUGH, 
   [COORD @D75803, AGR [COUNT @D75802, PER @D75801, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAUGH, 
   [COORD @D75805, AGR [COUNT @D75804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAUGH, 
   [COORD @D75807, AGR [COUNT @D75806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAUGH, 
   [COORD @D75811, AGR [COUNT @D75810, PER @D75809, PLU @D75808, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LAUGH, 
   [COORD @D75817, PAST @D75816, AGR [CASE @D75815, COUNT @D75814, 
            PER @D75813, PLU @D75812, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : LAUGH, 
   [COORD @D75820, AGR [COUNT @D75819, PER @D75818, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAUGH, 
   [COORD @D75822, AGR [COUNT @D75821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAUGH, 
   [COORD @D75824, AGR [COUNT @D75823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAUGH, 
   [COORD @D75828, AGR [COUNT @D75827, PER @D75826, PLU @D75825, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LAUGH, 
   [COORD @D75834, PAST @D75833, AGR [CASE @D75832, COUNT @D75831, 
            PER @D75830, PLU @D75829, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LAUGH, 
   [COORD @D75837, AGR [COUNT @D75836, PER @D75835, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : LAUGH, 
   [COORD @D75839, AGR [COUNT @D75838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : LAUGH, 
   [COORD @D75841, AGR [COUNT @D75840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : LAUGH, 
   [COORD @D75845, AGR [COUNT @D75844, PER @D75843, PLU @D75842, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, ARITY 2] : LAUGH, 
   [COORD @D75851, PAST @D75850, 
      AGR [CASE @D75849, COUNT @D75848, PER @D75847, PLU @D75846, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      ARITY 2] : LAUGH, 
   [COORD @D75854, AGR [COUNT @D75853, PER @D75852, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : LAUGH, 
   [COORD @D75856, AGR [COUNT @D75855, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : LAUGH, 
   [COORD @D75858, AGR [COUNT @D75857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : LAUGH, 
   [COORD @D75862, AGR [COUNT @D75861, PER @D75860, PLU @D75859, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : LAUGH, 
   [COORD @D75868, PAST @D75867, 
      AGR [CASE @D75866, COUNT @D75865, PER @D75864, PLU @D75863, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : LAUGH, 
   [COORD @D75871, AGR [COUNT @D75870, PER @D75869, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LAUGH, 
   [COORD @D75873, AGR [COUNT @D75872, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LAUGH, 
   [COORD @D75875, AGR [COUNT @D75874, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LAUGH, 
   [COORD @D75879, AGR [COUNT @D75878, PER @D75877, PLU @D75876, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : LAUGH, 
   [COORD @D75885, PAST @D75884, 
      AGR [CASE @D75883, COUNT @D75882, PER @D75881, PLU @D75880, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LAUGH, 
   [COORD @D75888, AGR [COUNT @D75887, PER @D75886, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAUGH, 
   [COORD @D75890, AGR [COUNT @D75889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAUGH, 
   [COORD @D75892, AGR [COUNT @D75891, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAUGH, 
   [COORD @D75896, AGR [COUNT @D75895, PER @D75894, PLU @D75893, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LAUGH, 
   [COORD @D75902, PAST @D75901, AGR [CASE @D75900, COUNT @D75899, 
            PER @D75898, PLU @D75897, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LAUGH, 
   [COORD @D75905, AGR [COUNT @D75904, PER @D75903, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LAUGH, 
   [COORD @D75907, AGR [COUNT @D75906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LAUGH, 
   [COORD @D75909, AGR [COUNT @D75908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LAUGH, 
   [COORD @D75913, AGR [COUNT @D75912, PER @D75911, PLU @D75910, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LAUGH, 
   [COORD @D75919, PAST @D75918, 
      AGR [CASE @D75917, COUNT @D75916, PER @D75915, PLU @D75914, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : LAUGH, 
   [COORD @D75922, AGR [COUNT @D75921, PER @D75920, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LAUGH, 
   [COORD @D75924, AGR [COUNT @D75923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LAUGH, 
   [COORD @D75926, AGR [COUNT @D75925, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LAUGH, 
   [COORD @D75930, AGR [COUNT @D75929, PER @D75928, PLU @D75927, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LAUGH, 
   [COORD @D75936, PAST @D75935, 
      AGR [CASE @D75934, COUNT @D75933, PER @D75932, PLU @D75931, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : LAUGH.

WORD laughed : 
   [COORD @D75945, AGR [CASE @D75944, COUNT @D75943, PER @D75942, 
            PLU @D75941, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D75950, AGR [CASE @D75949, COUNT @D75948, PER @D75947, 
            PLU @D75946, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D75956, AGR [CASE @D75955, NFORM @D75954, COUNT @D75953, 
            PER @D75952, PLU @D75951, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAUGH, 
   [COORD @D75961, AGR [CASE @D75960, COUNT @D75959, PER @D75958, 
            PLU @D75957, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAUGH, 
   [COORD @D75966, AGR [CASE @D75965, COUNT @D75964, PER @D75963, 
            PLU @D75962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D75971, AGR [CASE @D75970, COUNT @D75969, PER @D75968, 
            PLU @D75967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D75976, AGR [CASE @D75975, COUNT @D75974, PER @D75973, 
            PLU @D75972, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAUGH, 
   [COORD @D75981, AGR [CASE @D75980, COUNT @D75979, PER @D75978, 
            PLU @D75977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D75986, AGR [CASE @D75985, COUNT @D75984, PER @D75983, 
            PLU @D75982, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D75991, AGR [CASE @D75990, COUNT @D75989, PER @D75988, 
            PLU @D75987, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D75996, AGR [CASE @D75995, COUNT @D75994, PER @D75993, 
            PLU @D75992, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76001, AGR [CASE @D76000, COUNT @D75999, PER @D75998, 
            PLU @D75997, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76006, AGR [CASE @D76005, COUNT @D76004, PER @D76003, 
            PLU @D76002, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76011, AGR [CASE @D76010, COUNT @D76009, PER @D76008, 
            PLU @D76007, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76016, AGR [CASE @D76015, COUNT @D76014, PER @D76013, 
            PLU @D76012, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76021, AGR [CASE @D76020, COUNT @D76019, PER @D76018, 
            PLU @D76017, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76026, AGR [CASE @D76025, COUNT @D76024, PER @D76023, 
            PLU @D76022, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76031, AGR [CASE @D76030, COUNT @D76029, PER @D76028, 
            PLU @D76027, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76036, AGR [CASE @D76035, COUNT @D76034, PER @D76033, 
            PLU @D76032, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76041, AGR [CASE @D76040, COUNT @D76039, PER @D76038, 
            PLU @D76037, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76046, AGR [CASE @D76045, COUNT @D76044, PER @D76043, 
            PLU @D76042, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76051, AGR [CASE @D76050, COUNT @D76049, PER @D76048, 
            PLU @D76047, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76056, AGR [CASE @D76055, COUNT @D76054, PER @D76053, 
            PLU @D76052, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76061, AGR [CASE @D76060, COUNT @D76059, PER @D76058, 
            PLU @D76057, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUGH.

WORD laughing : 
   [COORD @D76073, PRD @D76072, AGR [CASE @D76071, COUNT @D76070, 
            PER @D76069, PLU @D76068, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76079, PRD @D76078, 
      AGR [CASE @D76077, COUNT @D76076, PER @D76075, PLU @D76074, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LAUGH, 
   [COORD @D76085, PRD @D76084, AGR [CASE @D76083, COUNT @D76082, 
            PER @D76081, PLU @D76080, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76091, PRD @D76090, 
      AGR [CASE @D76089, COUNT @D76088, PER @D76087, PLU @D76086, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAUGH, 
   [COORD @D76097, PRD @D76096, AGR [CASE @D76095, COUNT @D76094, 
            PER @D76093, PLU @D76092, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76103, PRD @D76102, 
      AGR [CASE @D76101, COUNT @D76100, PER @D76099, PLU @D76098, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAUGH, 
   [COORD @D76109, PRD @D76108, AGR [CASE @D76107, COUNT @D76106, 
            PER @D76105, PLU @D76104, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76115, PRD @D76114, 
      AGR [CASE @D76113, COUNT @D76112, PER @D76111, PLU @D76110, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAUGH, 
   [COORD @D76121, PRD @D76120, AGR [CASE @D76119, COUNT @D76118, 
            PER @D76117, PLU @D76116, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAUGH.

WORD laughs : 
   [COORD @D76127, AGR [COUNT @D76126, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76129, 
      AGR [COUNT @D76128, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76131, 
      AGR [COUNT @D76130, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76133, 
      AGR [COUNT @D76132, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76135, 
      AGR [COUNT @D76134, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76137, 
      AGR [COUNT @D76136, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76139, 
      AGR [COUNT @D76138, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76141, 
      AGR [COUNT @D76140, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH, 
   [COORD @D76143, 
      AGR [COUNT @D76142, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAUGH.

WORD launch : 
   [COORD @D76149, AGR [COUNT @D76148, PER @D76147, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : LAUNCH, 
   [COORD @D76151, AGR [COUNT @D76150, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : LAUNCH, 
   [COORD @D76153, AGR [COUNT @D76152, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : LAUNCH, 
   [COORD @D76157, AGR [COUNT @D76156, PER @D76155, PLU @D76154, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : LAUNCH, 
   [COORD @D76163, PAST @D76162, 
      AGR [CASE @D76161, COUNT @D76160, PER @D76159, PLU @D76158, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, 
      ARITY 3] : LAUNCH, 
   [COORD @D76166, AGR [COUNT @D76165, PER @D76164, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAUNCH, 
   [COORD @D76168, AGR [COUNT @D76167, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAUNCH, 
   [COORD @D76170, AGR [COUNT @D76169, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LAUNCH, 
   [COORD @D76174, AGR [COUNT @D76173, PER @D76172, PLU @D76171, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LAUNCH, 
   [COORD @D76180, PAST @D76179, AGR [CASE @D76178, COUNT @D76177, 
            PER @D76176, PLU @D76175, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LAUNCH, 
   [COORD @D76183, AGR [COUNT @D76182, PER @D76181, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT OUT, ARITY 2] : LAUNCH, 
   [COORD @D76185, AGR [COUNT @D76184, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT OUT, ARITY 2] : LAUNCH, 
   [COORD @D76187, AGR [COUNT @D76186, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      PRT OUT, ARITY 2] : LAUNCH, 
   [COORD @D76191, AGR [COUNT @D76190, PER @D76189, PLU @D76188, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, PRT OUT, ARITY 2] : LAUNCH, 
   [COORD @D76197, PAST @D76196, 
      AGR [CASE @D76195, COUNT @D76194, PER @D76193, PLU @D76192, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, PRT OUT, 
      ARITY 2] : LAUNCH, 
   [COORD @D76200, AGR [COUNT @D76199, PER @D76198, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : LAUNCH, 
   [COORD @D76202, AGR [COUNT @D76201, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : LAUNCH, 
   [COORD @D76204, AGR [COUNT @D76203, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : LAUNCH, 
   [COORD @D76208, AGR [COUNT @D76207, PER @D76206, PLU @D76205, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, ARITY 2] : LAUNCH, 
   [COORD @D76214, PAST @D76213, 
      AGR [CASE @D76212, COUNT @D76211, PER @D76210, PLU @D76209, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      ARITY 2] : LAUNCH.

WORD launched : 
   [COORD @D76223, AGR [CASE @D76222, COUNT @D76221, PER @D76220, 
            PLU @D76219, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76228, AGR [CASE @D76227, COUNT @D76226, PER @D76225, 
            PLU @D76224, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76233, AGR [CASE @D76232, COUNT @D76231, PER @D76230, 
            PLU @D76229, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76238, AGR [CASE @D76237, COUNT @D76236, PER @D76235, 
            PLU @D76234, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76243, AGR [CASE @D76242, COUNT @D76241, PER @D76240, 
            PLU @D76239, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76248, AGR [CASE @D76247, COUNT @D76246, PER @D76245, 
            PLU @D76244, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76253, AGR [CASE @D76252, COUNT @D76251, PER @D76250, 
            PLU @D76249, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76258, AGR [CASE @D76257, COUNT @D76256, PER @D76255, 
            PLU @D76254, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76263, AGR [CASE @D76262, COUNT @D76261, PER @D76260, 
            PLU @D76259, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76268, AGR [CASE @D76267, COUNT @D76266, PER @D76265, 
            PLU @D76264, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76273, AGR [CASE @D76272, COUNT @D76271, PER @D76270, 
            PLU @D76269, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LAUNCH.

WORD launching : 
   [COORD @D76285, PRD @D76284, AGR [CASE @D76283, COUNT @D76282, 
            PER @D76281, PLU @D76280, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76291, PRD @D76290, 
      AGR [CASE @D76289, COUNT @D76288, PER @D76287, PLU @D76286, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LAUNCH, 
   [COORD @D76297, PRD @D76296, AGR [CASE @D76295, COUNT @D76294, 
            PER @D76293, PLU @D76292, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAUNCH, 
   [COORD @D76303, PRD @D76302, 
      AGR [CASE @D76301, COUNT @D76300, PER @D76299, PLU @D76298, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LAUNCH.

WORD lay : 
   [COORD @D76313, AGR [COUNT @D76312, PER @D76311, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : LAY, 
   [COORD @D76315, AGR [COUNT @D76314, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : LAY, 
   [COORD @D76317, AGR [COUNT @D76316, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : LAY, 
   [COORD @D76321, AGR [COUNT @D76320, PER @D76319, PLU @D76318, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, REG -, ARITY 3] : LAY, 
   [COORD @D76327, PAST @D76326, 
      AGR [CASE @D76325, COUNT @D76324, PER @D76323, PLU @D76322, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, REG -, ARITY 3] : 
   LAY, 
   [COORD @D76330, AGR [COUNT @D76329, PER @D76328, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT UPON, ARITY 3] : LAY, 
   [COORD @D76332, AGR [COUNT @D76331, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT UPON, ARITY 3] : LAY, 
   [COORD @D76334, AGR [COUNT @D76333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT UPON, ARITY 3] : LAY, 
   [COORD @D76338, AGR [COUNT @D76337, PER @D76336, PLU @D76335, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT UPON, ARITY 3] : LAY, 
   [COORD @D76344, PAST @D76343, 
      AGR [CASE @D76342, COUNT @D76341, PER @D76340, PLU @D76339, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT UPON, 
      ARITY 3] : LAY, 
   [COORD @D76347, AGR [COUNT @D76346, PER @D76345, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT ON, ARITY 3] : LAY, 
   [COORD @D76349, AGR [COUNT @D76348, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT ON, ARITY 3] : LAY, 
   [COORD @D76351, AGR [COUNT @D76350, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT ON, ARITY 3] : LAY, 
   [COORD @D76355, AGR [COUNT @D76354, PER @D76353, PLU @D76352, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT ON, ARITY 3] : LAY, 
   [COORD @D76361, PAST @D76360, 
      AGR [CASE @D76359, COUNT @D76358, PER @D76357, PLU @D76356, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT ON, 
      ARITY 3] : LAY, 
   [COORD @D76364, AGR [COUNT @D76363, PER @D76362, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : LAY, 
   [COORD @D76366, AGR [COUNT @D76365, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : LAY, 
   [COORD @D76368, AGR [COUNT @D76367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : LAY, 
   [COORD @D76372, AGR [COUNT @D76371, PER @D76370, PLU @D76369, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : LAY, 
   [COORD @D76378, PAST @D76377, 
      AGR [CASE @D76376, COUNT @D76375, PER @D76374, PLU @D76373, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      ARITY 3] : LAY, 
   [COORD @D76381, AGR [COUNT @D76380, PER @D76379, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : LAY, 
   [COORD @D76383, AGR [COUNT @D76382, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : LAY, 
   [COORD @D76385, AGR [COUNT @D76384, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : LAY, 
   [COORD @D76389, AGR [COUNT @D76388, PER @D76387, PLU @D76386, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : LAY, 
   [COORD @D76395, PAST @D76394, 
      AGR [CASE @D76393, COUNT @D76392, PER @D76391, PLU @D76390, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      ARITY 3] : LAY, 
   [COORD @D76398, AGR [COUNT @D76397, PER @D76396, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OFF, ARITY 3] : LAY, 
   [COORD @D76400, AGR [COUNT @D76399, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OFF, ARITY 3] : LAY, 
   [COORD @D76402, AGR [COUNT @D76401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OFF, ARITY 3] : LAY, 
   [COORD @D76406, AGR [COUNT @D76405, PER @D76404, PLU @D76403, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OFF, ARITY 3] : LAY, 
   [COORD @D76412, PAST @D76411, 
      AGR [CASE @D76410, COUNT @D76409, PER @D76408, PLU @D76407, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OFF, 
      ARITY 3] : LAY, 
   [COORD @D76415, AGR [COUNT @D76414, PER @D76413, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : LAY, 
   [COORD @D76417, AGR [COUNT @D76416, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : LAY, 
   [COORD @D76419, AGR [COUNT @D76418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : LAY, 
   [COORD @D76423, AGR [COUNT @D76422, PER @D76421, PLU @D76420, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM AT, ARITY 3] : LAY, 
   [COORD @D76429, PAST @D76428, 
      AGR [CASE @D76427, COUNT @D76426, PER @D76425, PLU @D76424, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM AT, 
      ARITY 3] : LAY, 
   [COORD @D76432, AGR [COUNT @D76431, PER @D76430, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OPEN, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76434, AGR [COUNT @D76433, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OPEN, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76436, AGR [COUNT @D76435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OPEN, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76440, AGR [COUNT @D76439, PER @D76438, PLU @D76437, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OPEN, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76446, PAST @D76445, 
      AGR [CASE @D76444, COUNT @D76443, PER @D76442, PLU @D76441, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OPEN, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76449, AGR [COUNT @D76448, PER @D76447, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76451, AGR [COUNT @D76450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76453, AGR [COUNT @D76452, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76457, AGR [COUNT @D76456, PER @D76455, PLU @D76454, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, PFORM TO, ARITY 3] : LAY, 
   [COORD @D76463, PAST @D76462, 
      AGR [CASE @D76461, COUNT @D76460, PER @D76459, PLU @D76458, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      PFORM TO, ARITY 3] : LAY, 
   [COORD @D76466, AGR [COUNT @D76465, PER @D76464, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76468, AGR [COUNT @D76467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76470, AGR [COUNT @D76469, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76474, AGR [COUNT @D76473, PER @D76472, PLU @D76471, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76480, PAST @D76479, 
      AGR [CASE @D76478, COUNT @D76477, PER @D76476, PLU @D76475, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76483, AGR [COUNT @D76482, PER @D76481, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76485, AGR [COUNT @D76484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76487, AGR [COUNT @D76486, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76491, AGR [COUNT @D76490, PER @D76489, PLU @D76488, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76497, PAST @D76496, 
      AGR [CASE @D76495, COUNT @D76494, PER @D76493, PLU @D76492, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, PFORM FOR, ARITY 3] : LAY, 
   [COORD @D76501, AGR [COUNT @D76500, PER @D76499, PLU @D76498, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : LIE, 
   [COORD @D76504, AGR [COUNT @D76503, PER @D76502, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : LAY, 
   [COORD @D76506, AGR [COUNT @D76505, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : LAY, 
   [COORD @D76508, AGR [COUNT @D76507, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : LAY, 
   [COORD @D76512, AGR [COUNT @D76511, PER @D76510, PLU @D76509, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 2] : LAY, 
   [COORD @D76518, PAST @D76517, 
      AGR [CASE @D76516, COUNT @D76515, PER @D76514, PLU @D76513, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, ARITY 2] : 
   LAY, 
   [COORD @D76521, AGR [COUNT @D76520, PER @D76519, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LAY, 
   [COORD @D76523, AGR [COUNT @D76522, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LAY, 
   [COORD @D76525, AGR [COUNT @D76524, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LAY, 
   [COORD @D76529, AGR [COUNT @D76528, PER @D76527, PLU @D76526, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : LAY, 
   [COORD @D76535, PAST @D76534, AGR [CASE @D76533, COUNT @D76532, 
            PER @D76531, PLU @D76530, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : LAY, 
   [COORD @D76538, AGR [COUNT @D76537, PER @D76536, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT LOW, ARITY 2] : LAY, 
   [COORD @D76540, AGR [COUNT @D76539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT LOW, ARITY 2] : LAY, 
   [COORD @D76542, AGR [COUNT @D76541, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT LOW, ARITY 2] : LAY, 
   [COORD @D76546, AGR [COUNT @D76545, PER @D76544, PLU @D76543, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT LOW, ARITY 2] : LAY, 
   [COORD @D76552, PAST @D76551, AGR [CASE @D76550, COUNT @D76549, 
            PER @D76548, PLU @D76547, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT LOW, ARITY 2] : LAY, 
   [COORD @D76555, 
      AGR [COUNT @D76554, PER @D76553, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT BY, 
      ARITY 2] : LAY, 
   [COORD @D76557, AGR [COUNT @D76556, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT BY, ARITY 2] : LAY, 
   [COORD @D76559, AGR [COUNT @D76558, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT BY, ARITY 2] : LAY, 
   [COORD @D76563, AGR [COUNT @D76562, PER @D76561, PLU @D76560, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT BY, ARITY 2] : LAY, 
   [COORD @D76569, PAST @D76568, AGR [CASE @D76567, COUNT @D76566, 
            PER @D76565, PLU @D76564, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT BY, ARITY 2] : LAY, 
   [COORD @D76572, 
      AGR [COUNT @D76571, PER @D76570, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT WASTE, 
      PFORM TO, ARITY 2] : LAY, 
   [COORD @D76574, AGR [COUNT @D76573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT WASTE, PFORM TO, ARITY 2] : LAY, 
   [COORD @D76576, AGR [COUNT @D76575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT WASTE, PFORM TO, ARITY 2] : LAY, 
   [COORD @D76580, AGR [COUNT @D76579, PER @D76578, PLU @D76577, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT WASTE, PFORM TO, ARITY 2] : LAY, 
   [COORD @D76586, PAST @D76585, 
      AGR [CASE @D76584, COUNT @D76583, PER @D76582, PLU @D76581, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT WASTE, 
      PFORM TO, ARITY 2] : LAY, 
   [COORD @D76589, AGR [COUNT @D76588, PER @D76587, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : LAY, 
   [COORD @D76591, AGR [COUNT @D76590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : LAY, 
   [COORD @D76593, AGR [COUNT @D76592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OFF, ARITY 2] : LAY, 
   [COORD @D76597, AGR [COUNT @D76596, PER @D76595, PLU @D76594, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OFF, ARITY 2] : LAY, 
   [COORD @D76603, PAST @D76602, AGR [CASE @D76601, COUNT @D76600, 
            PER @D76599, PLU @D76598, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OFF, ARITY 2] : LAY, 
   [COORD @D76606, 
      AGR [COUNT @D76605, PER @D76604, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, 
      ARITY 2] : LAY, 
   [COORD @D76608, AGR [COUNT @D76607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : LAY, 
   [COORD @D76610, AGR [COUNT @D76609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : LAY, 
   [COORD @D76614, AGR [COUNT @D76613, PER @D76612, PLU @D76611, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM INTO, ARITY 2] : LAY, 
   [COORD @D76620, PAST @D76619, AGR [CASE @D76618, COUNT @D76617, 
            PER @D76616, PLU @D76615, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, ARITY 2] : LAY, 
   [COORD @D76623, 
      AGR [COUNT @D76622, PER @D76621, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, 
      ARITY 2] : LAY, 
   [COORD @D76625, AGR [COUNT @D76624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : LAY, 
   [COORD @D76627, AGR [COUNT @D76626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : LAY, 
   [COORD @D76631, AGR [COUNT @D76630, PER @D76629, PLU @D76628, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, ARITY 2] : LAY, 
   [COORD @D76637, PAST @D76636, AGR 
         [CASE @D76635, COUNT @D76634, PER @D76633, PLU @D76632, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, 
      ARITY 2] : LAY, 
   [COORD @D76640, AGR [COUNT @D76639, PER @D76638, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT WASTE, ARITY 2] : LAY, 
   [COORD @D76642, AGR [COUNT @D76641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT WASTE, ARITY 2] : LAY, 
   [COORD @D76644, AGR [COUNT @D76643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT WASTE, ARITY 2] : LAY, 
   [COORD @D76648, AGR [COUNT @D76647, PER @D76646, PLU @D76645, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT WASTE, ARITY 2] : LAY, 
   [COORD @D76654, PAST @D76653, 
      AGR [CASE @D76652, COUNT @D76651, PER @D76650, PLU @D76649, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT WASTE, ARITY 2] : LAY, 
   [COORD @D76657, AGR [COUNT @D76656, PER @D76655, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : LAY, 
   [COORD @D76659, AGR [COUNT @D76658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : LAY, 
   [COORD @D76661, AGR [COUNT @D76660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : LAY, 
   [COORD @D76665, AGR [COUNT @D76664, PER @D76663, PLU @D76662, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : LAY, 
   [COORD @D76671, PAST @D76670, 
      AGR [CASE @D76669, COUNT @D76668, PER @D76667, PLU @D76666, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : LAY, 
   [COORD @D76674, AGR [COUNT @D76673, PER @D76672, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : LAY, 
   [COORD @D76676, AGR [COUNT @D76675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : LAY, 
   [COORD @D76678, AGR [COUNT @D76677, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : LAY, 
   [COORD @D76682, AGR [COUNT @D76681, PER @D76680, PLU @D76679, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TO, ARITY 2] : LAY, 
   [COORD @D76688, PAST @D76687, 
      AGR [CASE @D76686, COUNT @D76685, PER @D76684, PLU @D76683, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TO, 
      ARITY 2] : LAY, 
   [COORD @D76691, AGR [COUNT @D76690, PER @D76689, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : LAY, 
   [COORD @D76693, AGR [COUNT @D76692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : LAY, 
   [COORD @D76695, AGR [COUNT @D76694, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : LAY, 
   [COORD @D76699, AGR [COUNT @D76698, PER @D76697, PLU @D76696, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : LAY, 
   [COORD @D76705, PAST @D76704, 
      AGR [CASE @D76703, COUNT @D76702, PER @D76701, PLU @D76700, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : LAY, 
   [COORD @D76708, AGR [COUNT @D76707, PER @D76706, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OPEN, ARITY 2] : LAY, 
   [COORD @D76710, AGR [COUNT @D76709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OPEN, ARITY 2] : LAY, 
   [COORD @D76712, AGR [COUNT @D76711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OPEN, ARITY 2] : LAY, 
   [COORD @D76716, AGR [COUNT @D76715, PER @D76714, PLU @D76713, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OPEN, ARITY 2] : LAY, 
   [COORD @D76722, PAST @D76721, 
      AGR [CASE @D76720, COUNT @D76719, PER @D76718, PLU @D76717, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OPEN, ARITY 2] : LAY, 
   [COORD @D76725, AGR [COUNT @D76724, PER @D76723, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : LAY, 
   [COORD @D76727, AGR [COUNT @D76726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : LAY, 
   [COORD @D76729, AGR [COUNT @D76728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : LAY, 
   [COORD @D76733, AGR [COUNT @D76732, PER @D76731, PLU @D76730, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, ARITY 2] : LAY, 
   [COORD @D76739, PAST @D76738, 
      AGR [CASE @D76737, COUNT @D76736, PER @D76735, PLU @D76734, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      ARITY 2] : LAY, 
   [COORD @D76742, AGR [COUNT @D76741, PER @D76740, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LAY, 
   [COORD @D76744, AGR [COUNT @D76743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LAY, 
   [COORD @D76746, AGR [COUNT @D76745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LAY, 
   [COORD @D76750, AGR [COUNT @D76749, PER @D76748, PLU @D76747, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : LAY, 
   [COORD @D76756, PAST @D76755, 
      AGR [CASE @D76754, COUNT @D76753, PER @D76752, PLU @D76751, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : LAY, 
   [COORD @D76759, AGR [COUNT @D76758, PER @D76757, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : LAY, 
   [COORD @D76761, AGR [COUNT @D76760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : LAY, 
   [COORD @D76763, AGR [COUNT @D76762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : LAY, 
   [COORD @D76767, AGR [COUNT @D76766, PER @D76765, PLU @D76764, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : LAY, 
   [COORD @D76773, PAST @D76772, 
      AGR [CASE @D76771, COUNT @D76770, PER @D76769, PLU @D76768, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : LAY, 
   [COORD @D76776, AGR [COUNT @D76775, PER @D76774, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FLAT, ARITY 2] : LAY, 
   [COORD @D76778, AGR [COUNT @D76777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FLAT, ARITY 2] : LAY, 
   [COORD @D76780, AGR [COUNT @D76779, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FLAT, ARITY 2] : LAY, 
   [COORD @D76784, AGR [COUNT @D76783, PER @D76782, PLU @D76781, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FLAT, ARITY 2] : LAY, 
   [COORD @D76790, PAST @D76789, 
      AGR [CASE @D76788, COUNT @D76787, PER @D76786, PLU @D76785, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FLAT, ARITY 2] : LAY, 
   [COORD @D76793, AGR [COUNT @D76792, PER @D76791, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : LAY, 
   [COORD @D76795, AGR [COUNT @D76794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : LAY, 
   [COORD @D76797, AGR [COUNT @D76796, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : LAY, 
   [COORD @D76801, AGR [COUNT @D76800, PER @D76799, PLU @D76798, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : LAY, 
   [COORD @D76807, PAST @D76806, 
      AGR [CASE @D76805, COUNT @D76804, PER @D76803, PLU @D76802, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : LAY, 
   [COORD @D76810, AGR [COUNT @D76809, PER @D76808, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : LAY, 
   [COORD @D76812, AGR [COUNT @D76811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : LAY, 
   [COORD @D76814, AGR [COUNT @D76813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : LAY, 
   [COORD @D76818, AGR [COUNT @D76817, PER @D76816, PLU @D76815, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASIDE, ARITY 2] : LAY, 
   [COORD @D76824, PAST @D76823, 
      AGR [CASE @D76822, COUNT @D76821, PER @D76820, PLU @D76819, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : LAY, 
   [COORD @D76828, AGR [COUNT @D76827, PER @D76826, PLU @D76825, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, PAST +, ARITY 2] : LIE, 
   [COORD @D76832, AGR [COUNT @D76831, PER @D76830, PLU @D76829, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, PAST +, 
      ARITY 2] : LIE, 
   [COORD @D76836, AGR [COUNT @D76835, PER @D76834, PLU @D76833, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT DOWN, PAST +, ARITY 2] : LIE, 
   [COORD @D76840, AGR [COUNT @D76839, PER @D76838, PLU @D76837, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, PAST +, ARITY 2] : LIE, 
   [COORD @D76844, AGR [COUNT @D76843, PER @D76842, PLU @D76841, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM UNDER, PAST +, ARITY 2] : LIE, 
   [COORD @D76848, AGR [COUNT @D76847, PER @D76846, PLU @D76845, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEHIND, PAST +, ARITY 2] : LIE, 
   [COORD @D76851, AGR [COUNT @D76850, PER @D76849, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LAY, 
   [COORD @D76853, AGR [COUNT @D76852, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LAY, 
   [COORD @D76855, AGR [COUNT @D76854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LAY, 
   [COORD @D76859, AGR [COUNT @D76858, PER @D76857, PLU @D76856, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : LAY, 
   [COORD @D76865, PAST @D76864, AGR 
         [CASE @D76863, COUNT @D76862, PER @D76861, PLU @D76860, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   LAY, 
   [COORD @D76868, AGR [COUNT @D76867, PER @D76866, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT WASTE, ARITY 1] : LAY, 
   [COORD @D76870, AGR [COUNT @D76869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT WASTE, ARITY 1] : LAY, 
   [COORD @D76872, AGR [COUNT @D76871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT WASTE, ARITY 1] : LAY, 
   [COORD @D76876, AGR [COUNT @D76875, PER @D76874, PLU @D76873, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT WASTE, ARITY 1] : LAY, 
   [COORD @D76882, PAST @D76881, 
      AGR [CASE @D76880, COUNT @D76879, PER @D76878, PLU @D76877, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT WASTE, 
      ARITY 1] : LAY, 
   [COORD @D76885, AGR [COUNT @D76884, PER @D76883, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : LAY, 
   [COORD @D76887, AGR [COUNT @D76886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : LAY, 
   [COORD @D76889, AGR [COUNT @D76888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : LAY, 
   [COORD @D76893, AGR [COUNT @D76892, PER @D76891, PLU @D76890, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : LAY, 
   [COORD @D76899, PAST @D76898, 
      AGR [CASE @D76897, COUNT @D76896, PER @D76895, PLU @D76894, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : LAY, 
   [COORD @D76902, AGR [COUNT @D76901, PER @D76900, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : LAY, 
   [COORD @D76904, AGR [COUNT @D76903, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : LAY, 
   [COORD @D76906, AGR [COUNT @D76905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : LAY, 
   [COORD @D76910, AGR [COUNT @D76909, PER @D76908, PLU @D76907, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, ARITY 1] : LAY, 
   [COORD @D76916, PAST @D76915, 
      AGR [CASE @D76914, COUNT @D76913, PER @D76912, PLU @D76911, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TO, 
      ARITY 1] : LAY, 
   [COORD @D76919, AGR [COUNT @D76918, PER @D76917, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LAY, 
   [COORD @D76921, AGR [COUNT @D76920, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LAY, 
   [COORD @D76923, AGR [COUNT @D76922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LAY, 
   [COORD @D76927, AGR [COUNT @D76926, PER @D76925, PLU @D76924, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : LAY, 
   [COORD @D76933, PAST @D76932, 
      AGR [CASE @D76931, COUNT @D76930, PER @D76929, PLU @D76928, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : LAY, 
   [COORD @D76936, AGR [COUNT @D76935, PER @D76934, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LAY, 
   [COORD @D76938, AGR [COUNT @D76937, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LAY, 
   [COORD @D76940, AGR [COUNT @D76939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LAY, 
   [COORD @D76944, AGR [COUNT @D76943, PER @D76942, PLU @D76941, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : LAY, 
   [COORD @D76950, PAST @D76949, 
      AGR [CASE @D76948, COUNT @D76947, PER @D76946, PLU @D76945, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : LAY, 
   [COORD @D76953, AGR [COUNT @D76952, PER @D76951, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OPEN, ARITY 1] : LAY, 
   [COORD @D76955, AGR [COUNT @D76954, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OPEN, ARITY 1] : LAY, 
   [COORD @D76957, AGR [COUNT @D76956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OPEN, ARITY 1] : LAY, 
   [COORD @D76961, AGR [COUNT @D76960, PER @D76959, PLU @D76958, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OPEN, ARITY 1] : LAY, 
   [COORD @D76967, PAST @D76966, 
      AGR [CASE @D76965, COUNT @D76964, PER @D76963, PLU @D76962, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OPEN, 
      ARITY 1] : LAY, 
   [COORD @D76970, AGR [COUNT @D76969, PER @D76968, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : LAY, 
   [COORD @D76972, AGR [COUNT @D76971, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : LAY, 
   [COORD @D76974, AGR [COUNT @D76973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : LAY, 
   [COORD @D76978, AGR [COUNT @D76977, PER @D76976, PLU @D76975, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : LAY, 
   [COORD @D76984, PAST @D76983, 
      AGR [CASE @D76982, COUNT @D76981, PER @D76980, PLU @D76979, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : LAY, 
   [COORD @D76987, AGR [COUNT @D76986, PER @D76985, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LAY, 
   [COORD @D76989, AGR [COUNT @D76988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LAY, 
   [COORD @D76991, AGR [COUNT @D76990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LAY, 
   [COORD @D76995, AGR [COUNT @D76994, PER @D76993, PLU @D76992, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : LAY, 
   [COORD @D77001, PAST @D77000, 
      AGR [CASE @D76999, COUNT @D76998, PER @D76997, PLU @D76996, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : LAY, 
   [COORD @D77004, AGR [COUNT @D77003, PER @D77002, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT LOW, ARITY 1] : LAY, 
   [COORD @D77006, AGR [COUNT @D77005, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT LOW, ARITY 1] : LAY, 
   [COORD @D77008, AGR [COUNT @D77007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT LOW, ARITY 1] : LAY, 
   [COORD @D77012, AGR [COUNT @D77011, PER @D77010, PLU @D77009, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT LOW, ARITY 1] : LAY, 
   [COORD @D77018, PAST @D77017, 
      AGR [CASE @D77016, COUNT @D77015, PER @D77014, PLU @D77013, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT LOW, 
      ARITY 1] : LAY, 
   [COORD @D77021, AGR [COUNT @D77020, PER @D77019, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : LAY, 
   [COORD @D77023, AGR [COUNT @D77022, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : LAY, 
   [COORD @D77025, AGR [COUNT @D77024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : LAY, 
   [COORD @D77029, AGR [COUNT @D77028, PER @D77027, PLU @D77026, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : LAY, 
   [COORD @D77035, PAST @D77034, 
      AGR [CASE @D77033, COUNT @D77032, PER @D77031, PLU @D77030, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : LAY, 
   [COORD @D77038, AGR [COUNT @D77037, PER @D77036, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FLAT, ARITY 1] : LAY, 
   [COORD @D77040, AGR [COUNT @D77039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FLAT, ARITY 1] : LAY, 
   [COORD @D77042, AGR [COUNT @D77041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FLAT, ARITY 1] : LAY, 
   [COORD @D77046, AGR [COUNT @D77045, PER @D77044, PLU @D77043, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FLAT, ARITY 1] : LAY, 
   [COORD @D77052, PAST @D77051, 
      AGR [CASE @D77050, COUNT @D77049, PER @D77048, PLU @D77047, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FLAT, 
      ARITY 1] : LAY, 
   [COORD @D77055, AGR [COUNT @D77054, PER @D77053, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : LAY, 
   [COORD @D77057, AGR [COUNT @D77056, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : LAY, 
   [COORD @D77059, AGR [COUNT @D77058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : LAY, 
   [COORD @D77063, AGR [COUNT @D77062, PER @D77061, PLU @D77060, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : LAY, 
   [COORD @D77069, PAST @D77068, 
      AGR [CASE @D77067, COUNT @D77066, PER @D77065, PLU @D77064, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : LAY, 
   [COORD @D77072, AGR [COUNT @D77071, PER @D77070, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : LAY, 
   [COORD @D77074, AGR [COUNT @D77073, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : LAY, 
   [COORD @D77076, AGR [COUNT @D77075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : LAY, 
   [COORD @D77080, AGR [COUNT @D77079, PER @D77078, PLU @D77077, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, ARITY 1] : LAY, 
   [COORD @D77086, PAST @D77085, 
      AGR [CASE @D77084, COUNT @D77083, PER @D77082, PLU @D77081, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BY, 
      ARITY 1] : LAY, 
   [COORD @D77089, AGR [COUNT @D77088, PER @D77087, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : LAY, 
   [COORD @D77091, AGR [COUNT @D77090, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : LAY, 
   [COORD @D77093, AGR [COUNT @D77092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : LAY, 
   [COORD @D77097, AGR [COUNT @D77096, PER @D77095, PLU @D77094, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASIDE, ARITY 1] : LAY, 
   [COORD @D77103, PAST @D77102, 
      AGR [CASE @D77101, COUNT @D77100, PER @D77099, PLU @D77098, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ASIDE, 
      ARITY 1] : LAY, 
   [COORD @D77107, AGR [COUNT @D77106, PER @D77105, PLU @D77104, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : LIE, 
   [COORD @D77111, AGR [COUNT @D77110, PER @D77109, PLU @D77108, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : LIE, 
   [COORD @D77115, AGR [COUNT @D77114, PER @D77113, PLU @D77112, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, PAST +, ARITY 1] : LIE, 
   [COORD @D77119, AGR [COUNT @D77118, PER @D77117, PLU @D77116, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : LIE, 
   [COORD @D77123, AGR [COUNT @D77122, PER @D77121, PLU @D77120, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : LIE, 
   [COORD @D77127, AGR [COUNT @D77126, PER @D77125, PLU @D77124, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : LIE, 
   [COORD @D77131, AGR [COUNT @D77130, PER @D77129, PLU @D77128, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : LIE, 
   [COORD @D77135, AGR [COUNT @D77134, PER @D77133, PLU @D77132, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, PAST +, ARITY 1] : LIE.

WORD laying : 
   [COORD @D77147, PRD @D77146, AGR [CASE @D77145, COUNT @D77144, 
            PER @D77143, PLU @D77142, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77153, PRD @D77152, AGR 
         [CASE @D77151, COUNT @D77150, PER @D77149, PLU @D77148, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, PRT UPON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77159, PRD @D77158, AGR [CASE @D77157, COUNT @D77156, 
            PER @D77155, PLU @D77154, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77165, PRD @D77164, 
      AGR [CASE @D77163, COUNT @D77162, PER @D77161, PLU @D77160, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77171, PRD @D77170, AGR [CASE @D77169, COUNT @D77168, 
            PER @D77167, PLU @D77166, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77177, PRD @D77176, 
      AGR [CASE @D77175, COUNT @D77174, PER @D77173, PLU @D77172, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77183, PRD @D77182, AGR [CASE @D77181, COUNT @D77180, 
            PER @D77179, PLU @D77178, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77189, PRD @D77188, 
      AGR [CASE @D77187, COUNT @D77186, PER @D77185, PLU @D77184, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OPEN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAY, 
   [COORD @D77195, PRD @D77194, AGR [CASE @D77193, COUNT @D77192, 
            PER @D77191, PLU @D77190, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77201, PRD @D77200, 
      AGR [CASE @D77199, COUNT @D77198, PER @D77197, PLU @D77196, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LAY, 
   [COORD @D77207, PRD @D77206, AGR [CASE @D77205, COUNT @D77204, 
            PER @D77203, PLU @D77202, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77213, PRD @D77212, 
      AGR [CASE @D77211, COUNT @D77210, PER @D77209, PLU @D77208, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   
   [COORD @D77219, PRD @D77218, AGR [CASE @D77217, COUNT @D77216, PER 
               @D77215, PLU @D77214, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77225, PRD @D77224, AGR 
         [CASE @D77223, COUNT @D77222, PER @D77221, PLU @D77220, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, PRT LOW, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77231, PRD @D77230, AGR [CASE @D77229, COUNT @D77228, 
            PER @D77227, PLU @D77226, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77237, PRD @D77236, 
      AGR [CASE @D77235, COUNT @D77234, PER @D77233, PLU @D77232, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT WASTE, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77243, PRD @D77242, AGR [CASE @D77241, COUNT @D77240, 
            PER @D77239, PLU @D77238, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77249, PRD @D77248, 
      AGR [CASE @D77247, COUNT @D77246, PER @D77245, PLU @D77244, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77255, PRD @D77254, AGR [CASE @D77253, COUNT @D77252, 
            PER @D77251, PLU @D77250, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77261, PRD @D77260, 
      AGR [CASE @D77259, COUNT @D77258, PER @D77257, PLU @D77256, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT WASTE, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77267, PRD @D77266, AGR [CASE @D77265, COUNT @D77264, 
            PER @D77263, PLU @D77262, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77273, PRD @D77272, 
      AGR [CASE @D77271, COUNT @D77270, PER @D77269, PLU @D77268, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77279, PRD @D77278, AGR [CASE @D77277, COUNT @D77276, 
            PER @D77275, PLU @D77274, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77285, PRD @D77284, 
      AGR [CASE @D77283, COUNT @D77282, PER @D77281, PLU @D77280, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OPEN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77291, PRD @D77290, AGR [CASE @D77289, COUNT @D77288, 
            PER @D77287, PLU @D77286, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77297, PRD @D77296, 
      AGR [CASE @D77295, COUNT @D77294, PER @D77293, PLU @D77292, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77303, PRD @D77302, AGR [CASE @D77301, COUNT @D77300, 
            PER @D77299, PLU @D77298, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77309, PRD @D77308, 
      AGR [CASE @D77307, COUNT @D77306, PER @D77305, PLU @D77304, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT FLAT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77315, PRD @D77314, AGR [CASE @D77313, COUNT @D77312, 
            PER @D77311, PLU @D77310, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77321, PRD @D77320, 
      AGR [CASE @D77319, COUNT @D77318, PER @D77317, PLU @D77316, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77327, PRD @D77326, AGR [CASE @D77325, COUNT @D77324, 
            PER @D77323, PLU @D77322, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77333, PRD @D77332, AGR 
         [CASE @D77331, COUNT @D77330, PER @D77329, PLU @D77328, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT WASTE, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77339, PRD @D77338, AGR [CASE @D77337, COUNT @D77336, 
            PER @D77335, PLU @D77334, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77345, PRD @D77344, 
      AGR [CASE @D77343, COUNT @D77342, PER @D77341, PLU @D77340, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77351, PRD @D77350, AGR [CASE @D77349, COUNT @D77348, 
            PER @D77347, PLU @D77346, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77357, PRD @D77356, 
      AGR [CASE @D77355, COUNT @D77354, PER @D77353, PLU @D77352, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77363, PRD @D77362, AGR [CASE @D77361, COUNT @D77360, 
            PER @D77359, PLU @D77358, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OPEN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77369, PRD @D77368, 
      AGR [CASE @D77367, COUNT @D77366, PER @D77365, PLU @D77364, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77375, PRD @D77374, AGR [CASE @D77373, COUNT @D77372, 
            PER @D77371, PLU @D77370, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77381, PRD @D77380, 
      AGR [CASE @D77379, COUNT @D77378, PER @D77377, PLU @D77376, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT LOW, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77387, PRD @D77386, AGR [CASE @D77385, COUNT @D77384, 
            PER @D77383, PLU @D77382, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77393, PRD @D77392, 
      AGR [CASE @D77391, COUNT @D77390, PER @D77389, PLU @D77388, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT FLAT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77399, PRD @D77398, AGR [CASE @D77397, COUNT @D77396, 
            PER @D77395, PLU @D77394, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY, 
   [COORD @D77405, PRD @D77404, 
      AGR [CASE @D77403, COUNT @D77402, PER @D77401, PLU @D77400, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LAY, 
   [COORD @D77411, PRD @D77410, AGR [CASE @D77409, COUNT @D77408, 
            PER @D77407, PLU @D77406, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ASIDE, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LAY.

WORD lays : 
   [COORD @D77417, AGR [COUNT @D77416, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77419, 
      AGR [COUNT @D77418, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77421, 
      AGR [COUNT @D77420, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77423, 
      AGR [COUNT @D77422, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LAY, 
   [COORD @D77425, AGR [COUNT @D77424, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77427, 
      AGR [COUNT @D77426, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77429, 
      AGR [COUNT @D77428, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77431, 
      AGR [COUNT @D77430, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OPEN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LAY, 
   [COORD @D77433, AGR [COUNT @D77432, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77435, AGR [COUNT @D77434, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LAY, 
   [COORD @D77437, AGR [COUNT @D77436, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LAY, 
   [COORD @D77439, AGR [COUNT @D77438, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77441, 
      AGR [COUNT @D77440, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77443, 
      AGR [COUNT @D77442, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT LOW, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77445, 
      AGR [COUNT @D77444, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77447, 
      AGR [COUNT @D77446, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT WASTE, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LAY, 
   [COORD @D77449, AGR [COUNT @D77448, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77451, AGR [COUNT @D77450, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77453, AGR [COUNT @D77452, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LAY, 
   [COORD @D77455, AGR [COUNT @D77454, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT WASTE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77457, 
      AGR [COUNT @D77456, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77459, 
      AGR [COUNT @D77458, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77461, 
      AGR [COUNT @D77460, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77463, 
      AGR [COUNT @D77462, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OPEN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77465, 
      AGR [COUNT @D77464, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77467, 
      AGR [COUNT @D77466, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77469, 
      AGR [COUNT @D77468, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77471, 
      AGR [COUNT @D77470, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT FLAT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77473, 
      AGR [COUNT @D77472, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77475, 
      AGR [COUNT @D77474, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77477, 
      AGR [COUNT @D77476, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77479, 
      AGR [COUNT @D77478, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT WASTE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77481, 
      AGR [COUNT @D77480, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77483, 
      AGR [COUNT @D77482, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77485, 
      AGR [COUNT @D77484, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77487, 
      AGR [COUNT @D77486, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77489, 
      AGR [COUNT @D77488, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OPEN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77491, 
      AGR [COUNT @D77490, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77493, 
      AGR [COUNT @D77492, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77495, 
      AGR [COUNT @D77494, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT LOW, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77497, 
      AGR [COUNT @D77496, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77499, 
      AGR [COUNT @D77498, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT FLAT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77501, 
      AGR [COUNT @D77500, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77503, 
      AGR [COUNT @D77502, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY, 
   [COORD @D77505, 
      AGR [COUNT @D77504, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LAY.

WORD lead : 
   [COORD @D77513, REFL @D77512, PRD @D77511, CASE @D77510, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LEAD, 
   [COORD @D77517, REFL @D77516, PRD @D77515, CASE @D77514, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OVER, COUNT +] : LEAD, 
   [COORD @D77521, REFL @D77520, PRD @D77519, CASE @D77518, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : LEAD, 
   [COORD @D77525, REFL @D77524, PRD @D77523, CASE @D77522, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LEAD, 
   [COORD @D77530, REFL @D77529, COUNT @D77528, PRD @D77527, 
      CASE @D77526, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LEAD, 
   [COORD @D77534, REFL @D77533, PRD @D77532, CASE @D77531, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LEAD, 
   [COORD @D77538, REFL @D77537, PRD @D77536, CASE @D77535, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : LEAD, 
   [COORD @D77541, 
      AGR [COUNT @D77540, PER @D77539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   LEAD, 
   [COORD @D77543, AGR [COUNT @D77542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : LEAD, 
   [COORD @D77545, AGR [COUNT @D77544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : LEAD, 
   [COORD @D77549, AGR [COUNT @D77548, PER @D77547, PLU @D77546, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : LEAD, 
   [COORD @D77555, PAST @D77554, 
      AGR [CASE @D77553, COUNT @D77552, PER @D77551, PLU @D77550, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   LEAD, 
   [COORD @D77558, AGR [COUNT @D77557, PER @D77556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LEAD, 
   [COORD @D77560, AGR [COUNT @D77559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LEAD, 
   [COORD @D77562, AGR [COUNT @D77561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LEAD, 
   [COORD @D77566, AGR [COUNT @D77565, PER @D77564, PLU @D77563, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : LEAD, 
   [COORD @D77572, PAST @D77571, 
      AGR [CASE @D77570, COUNT @D77569, PER @D77568, PLU @D77567, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   LEAD, 
   [COORD @D77575, AGR [COUNT @D77574, PER @D77573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT ON, ARITY 3] : LEAD, 
   [COORD @D77577, AGR [COUNT @D77576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT ON, ARITY 3] : LEAD, 
   [COORD @D77579, AGR [COUNT @D77578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT ON, ARITY 3] : LEAD, 
   [COORD @D77583, AGR [COUNT @D77582, PER @D77581, PLU @D77580, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PRT ON, ARITY 3] : LEAD, 
   [COORD @D77589, PAST @D77588, 
      AGR [CASE @D77587, COUNT @D77586, PER @D77585, PLU @D77584, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PRT ON, 
      ARITY 3] : LEAD, 
   [COORD @D77592, AGR [COUNT @D77591, PER @D77590, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LEAD, 
   [COORD @D77594, AGR [COUNT @D77593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LEAD, 
   [COORD @D77596, AGR [COUNT @D77595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LEAD, 
   [COORD @D77600, AGR [COUNT @D77599, PER @D77598, PLU @D77597, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : LEAD, 
   [COORD @D77606, PAST @D77605, 
      AGR [CASE @D77604, COUNT @D77603, PER @D77602, PLU @D77601, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : LEAD, 
   [COORD @D77609, AGR [COUNT @D77608, PER @D77607, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77611, AGR [COUNT @D77610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77613, AGR [COUNT @D77612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77617, AGR [COUNT @D77616, PER @D77615, PLU @D77614, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77623, PAST @D77622, 
      AGR [CASE @D77621, COUNT @D77620, PER @D77619, PLU @D77618, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM INTO, 
      ARITY 3] : LEAD, 
   [COORD @D77626, AGR [COUNT @D77625, PER @D77624, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT ON, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77628, AGR [COUNT @D77627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT ON, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77630, AGR [COUNT @D77629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT ON, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77634, AGR [COUNT @D77633, PER @D77632, PLU @D77631, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT ON, PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77640, PAST @D77639, 
      AGR [CASE @D77638, COUNT @D77637, PER @D77636, PLU @D77635, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT ON, 
      PFORM INTO, ARITY 3] : LEAD, 
   [COORD @D77643, AGR [COUNT @D77642, PER @D77641, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LEAD, 
   [COORD @D77645, AGR [COUNT @D77644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LEAD, 
   [COORD @D77647, AGR [COUNT @D77646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LEAD, 
   [COORD @D77651, AGR [COUNT @D77650, PER @D77649, PLU @D77648, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : LEAD, 
   [COORD @D77657, PAST @D77656, AGR [CASE @D77655, COUNT @D77654, 
            PER @D77653, PLU @D77652, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : LEAD, 
   [COORD @D77660, AGR [COUNT @D77659, PER @D77658, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : LEAD, 
   [COORD @D77662, AGR [COUNT @D77661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : LEAD, 
   [COORD @D77664, AGR [COUNT @D77663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : LEAD, 
   [COORD @D77668, AGR [COUNT @D77667, PER @D77666, PLU @D77665, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : LEAD, 
   [COORD @D77674, PAST @D77673, AGR [CASE @D77672, COUNT @D77671, 
            PER @D77670, PLU @D77669, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : LEAD, 
   [COORD @D77677, AGR [COUNT @D77676, PER @D77675, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ON, ARITY 2] : LEAD, 
   [COORD @D77679, AGR [COUNT @D77678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ON, ARITY 2] : LEAD, 
   [COORD @D77681, AGR [COUNT @D77680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ON, ARITY 2] : LEAD, 
   [COORD @D77685, AGR [COUNT @D77684, PER @D77683, PLU @D77682, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT ON, ARITY 2] : LEAD, 
   [COORD @D77691, PAST @D77690, AGR [CASE @D77689, COUNT @D77688, 
            PER @D77687, PLU @D77686, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT ON, ARITY 2] : LEAD, 
   [COORD @D77694, 
      AGR [COUNT @D77693, PER @D77692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : LEAD, 
   [COORD @D77696, AGR [COUNT @D77695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77698, AGR [COUNT @D77697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77702, AGR [COUNT @D77701, PER @D77700, PLU @D77699, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77708, PAST @D77707, AGR 
         [CASE @D77706, COUNT @D77705, PER @D77704, PLU @D77703, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : LEAD, 
   [COORD @D77711, AGR [COUNT @D77710, PER @D77709, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77713, AGR [COUNT @D77712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77715, AGR [COUNT @D77714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77719, AGR [COUNT @D77718, PER @D77717, PLU @D77716, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OFF, PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77725, PAST @D77724, 
      AGR [CASE @D77723, COUNT @D77722, PER @D77721, PLU @D77720, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM WITH, ARITY 2] : LEAD, 
   [COORD @D77728, AGR [COUNT @D77727, PER @D77726, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77730, AGR [COUNT @D77729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77732, AGR [COUNT @D77731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77736, AGR [COUNT @D77735, PER @D77734, PLU @D77733, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77742, PAST @D77741, AGR [CASE @D77740, COUNT @D77739, 
            PER @D77738, PLU @D77737, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77745, 
      AGR [COUNT @D77744, PER @D77743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM TO, 
      ARITY 2] : LEAD, 
   [COORD @D77747, AGR [COUNT @D77746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77749, AGR [COUNT @D77748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77753, AGR [COUNT @D77752, PER @D77751, PLU @D77750, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : LEAD, 
   [COORD @D77759, PAST @D77758, 
      AGR [CASE @D77757, COUNT @D77756, PER @D77755, PLU @D77754, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM TO, 
      ARITY 2] : LEAD, 
   [COORD @D77762, AGR [COUNT @D77761, PER @D77760, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LEAD, 
   [COORD @D77764, AGR [COUNT @D77763, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LEAD, 
   [COORD @D77766, AGR [COUNT @D77765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LEAD, 
   [COORD @D77770, AGR [COUNT @D77769, PER @D77768, PLU @D77767, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : LEAD, 
   [COORD @D77776, PAST @D77775, 
      AGR [CASE @D77774, COUNT @D77773, PER @D77772, PLU @D77771, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : LEAD, 
   [COORD @D77779, AGR [COUNT @D77778, PER @D77777, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASTRAY, ARITY 2] : LEAD, 
   [COORD @D77781, AGR [COUNT @D77780, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASTRAY, ARITY 2] : LEAD, 
   [COORD @D77783, AGR [COUNT @D77782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASTRAY, ARITY 2] : LEAD, 
   [COORD @D77787, AGR [COUNT @D77786, PER @D77785, PLU @D77784, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASTRAY, ARITY 2] : LEAD, 
   [COORD @D77793, PAST @D77792, 
      AGR [CASE @D77791, COUNT @D77790, PER @D77789, PLU @D77788, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASTRAY, ARITY 2] : LEAD, 
   [COORD @D77796, AGR [COUNT @D77795, PER @D77794, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALONG, ARITY 2] : LEAD, 
   [COORD @D77798, AGR [COUNT @D77797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALONG, ARITY 2] : LEAD, 
   [COORD @D77800, AGR [COUNT @D77799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALONG, ARITY 2] : LEAD, 
   [COORD @D77804, AGR [COUNT @D77803, PER @D77802, PLU @D77801, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ALONG, ARITY 2] : LEAD, 
   [COORD @D77810, PAST @D77809, 
      AGR [CASE @D77808, COUNT @D77807, PER @D77806, PLU @D77805, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALONG, ARITY 2] : LEAD, 
   [COORD @D77813, AGR [COUNT @D77812, PER @D77811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LEAD, 
   [COORD @D77815, AGR [COUNT @D77814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LEAD, 
   [COORD @D77817, AGR [COUNT @D77816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LEAD, 
   [COORD @D77821, AGR [COUNT @D77820, PER @D77819, PLU @D77818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : LEAD, 
   [COORD @D77827, PAST @D77826, 
      AGR [CASE @D77825, COUNT @D77824, PER @D77823, PLU @D77822, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   LEAD, 
   [COORD @D77830, AGR [COUNT @D77829, PER @D77828, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : LEAD, 
   [COORD @D77832, AGR [COUNT @D77831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : LEAD, 
   [COORD @D77834, AGR [COUNT @D77833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : LEAD, 
   [COORD @D77838, AGR [COUNT @D77837, PER @D77836, PLU @D77835, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : LEAD, 
   [COORD @D77844, PAST @D77843, 
      AGR [CASE @D77842, COUNT @D77841, PER @D77840, PLU @D77839, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      ARITY 1] : LEAD, 
   [COORD @D77847, AGR [COUNT @D77846, PER @D77845, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LEAD, 
   [COORD @D77849, AGR [COUNT @D77848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LEAD, 
   [COORD @D77851, AGR [COUNT @D77850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LEAD, 
   [COORD @D77855, AGR [COUNT @D77854, PER @D77853, PLU @D77852, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : LEAD, 
   [COORD @D77861, PAST @D77860, 
      AGR [CASE @D77859, COUNT @D77858, PER @D77857, PLU @D77856, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : LEAD, 
   [COORD @D77864, AGR [COUNT @D77863, PER @D77862, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASTRAY, ARITY 1] : LEAD, 
   [COORD @D77866, AGR [COUNT @D77865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASTRAY, ARITY 1] : LEAD, 
   [COORD @D77868, AGR [COUNT @D77867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASTRAY, ARITY 1] : LEAD, 
   [COORD @D77872, AGR [COUNT @D77871, PER @D77870, PLU @D77869, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASTRAY, ARITY 1] : LEAD, 
   [COORD @D77878, PAST @D77877, 
      AGR [CASE @D77876, COUNT @D77875, PER @D77874, PLU @D77873, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ASTRAY, 
      ARITY 1] : LEAD, 
   [COORD @D77881, AGR [COUNT @D77880, PER @D77879, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : LEAD, 
   [COORD @D77883, AGR [COUNT @D77882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : LEAD, 
   [COORD @D77885, AGR [COUNT @D77884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : LEAD, 
   [COORD @D77889, AGR [COUNT @D77888, PER @D77887, PLU @D77886, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALONG, ARITY 1] : LEAD, 
   [COORD @D77895, PAST @D77894, 
      AGR [CASE @D77893, COUNT @D77892, PER @D77891, PLU @D77890, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ALONG, 
      ARITY 1] : LEAD.

WORD leading : 
   [COORD @D77911, PRD @D77910, AGR [CASE @D77909, COUNT @D77908, 
            PER @D77907, PLU @D77906, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D77917, PRD @D77916, 
      AGR [CASE @D77915, COUNT @D77914, PER @D77913, PLU @D77912, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEAD, 
   [COORD @D77923, PRD @D77922, AGR [CASE @D77921, COUNT @D77920, 
            PER @D77919, PLU @D77918, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D77929, PRD @D77928, 
      AGR [CASE @D77927, COUNT @D77926, PER @D77925, PLU @D77924, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAD, 
   [COORD @D77935, PRD @D77934, AGR [CASE @D77933, COUNT @D77932, 
            PER @D77931, PLU @D77930, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D77941, PRD @D77940, 
      AGR [CASE @D77939, COUNT @D77938, PER @D77937, PLU @D77936, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PRT ON, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LEAD, 
   [COORD @D77947, PRD @D77946, AGR [CASE @D77945, COUNT @D77944, 
            PER @D77943, PLU @D77942, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D77953, PRD @D77952, 
      AGR [CASE @D77951, COUNT @D77950, PER @D77949, PLU @D77948, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEAD, 
   [COORD @D77959, PRD @D77958, AGR [CASE @D77957, COUNT @D77956, 
            PER @D77955, PLU @D77954, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D77965, PRD @D77964, 
      AGR [CASE @D77963, COUNT @D77962, PER @D77961, PLU @D77960, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAD, 
   [COORD @D77971, PRD @D77970, AGR [CASE @D77969, COUNT @D77968, 
            PER @D77967, PLU @D77966, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D77977, PRD @D77976, 
      AGR [CASE @D77975, COUNT @D77974, PER @D77973, PLU @D77972, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAD, 
   [COORD @D77983, PRD @D77982, AGR [CASE @D77981, COUNT @D77980, 
            PER @D77979, PLU @D77978, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D77989, PRD @D77988, 
      AGR [CASE @D77987, COUNT @D77986, PER @D77985, PLU @D77984, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAD, 
   [COORD @D77995, PRD @D77994, AGR [CASE @D77993, COUNT @D77992, 
            PER @D77991, PLU @D77990, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ASTRAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D78001, PRD @D78000, 
      AGR [CASE @D77999, COUNT @D77998, PER @D77997, PLU @D77996, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAD, 
   [COORD @D78007, PRD @D78006, AGR [CASE @D78005, COUNT @D78004, 
            PER @D78003, PLU @D78002, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D78013, PRD @D78012, 
      AGR [CASE @D78011, COUNT @D78010, PER @D78009, PLU @D78008, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAD, 
   [COORD @D78019, PRD @D78018, AGR [CASE @D78017, COUNT @D78016, 
            PER @D78015, PLU @D78014, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD, 
   [COORD @D78025, PRD @D78024, 
      AGR [CASE @D78023, COUNT @D78022, PER @D78021, PLU @D78020, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ASTRAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAD, 
   [COORD @D78031, PRD @D78030, AGR [CASE @D78029, COUNT @D78028, 
            PER @D78027, PLU @D78026, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAD.

WORD leads : 
   [COORD @D78041, REFL @D78040, PRD @D78039, CASE @D78038, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : LEADS, 
   [COORD @D78046, DEMON @D78045, REFL @D78044, PRD @D78043, 
      CASE @D78042, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LEAD, 
   [COORD @D78051, DEMON @D78050, REFL @D78049, PRD @D78048, 
      CASE @D78047, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LEAD, 
   [COORD @D78053, 
      AGR [COUNT @D78052, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78055, 
      AGR [COUNT @D78054, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78057, 
      AGR [COUNT @D78056, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78059, 
      AGR [COUNT @D78058, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78061, 
      AGR [COUNT @D78060, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LEAD, 
   [COORD @D78063, AGR [COUNT @D78062, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PRT ON, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LEAD, 
   [COORD @D78065, AGR [COUNT @D78064, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78067, 
      AGR [COUNT @D78066, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78069, 
      AGR [COUNT @D78068, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78071, 
      AGR [COUNT @D78070, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78073, 
      AGR [COUNT @D78072, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LEAD, 
   [COORD @D78075, AGR [COUNT @D78074, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LEAD, 
   [COORD @D78077, AGR [COUNT @D78076, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LEAD, 
   [COORD @D78079, AGR [COUNT @D78078, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78081, 
      AGR [COUNT @D78080, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ASTRAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78083, 
      AGR [COUNT @D78082, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78085, 
      AGR [COUNT @D78084, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78087, 
      AGR [COUNT @D78086, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78089, 
      AGR [COUNT @D78088, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78091, 
      AGR [COUNT @D78090, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ASTRAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD, 
   [COORD @D78093, 
      AGR [COUNT @D78092, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAD.

WORD leaf : 
   [COORD @D78112, REFL @D78111, PRD @D78110, CASE @D78109, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LEAF, 
   [COORD @D78116, REFL @D78115, PRD @D78114, CASE @D78113, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : LEAF_MOULD, 
   [COORD @D78119, 
      AGR [COUNT @D78118, PER @D78117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LEAF, 
   [COORD @D78121, AGR [COUNT @D78120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LEAF, 
   [COORD @D78123, AGR [COUNT @D78122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LEAF, 
   [COORD @D78127, AGR [COUNT @D78126, PER @D78125, PLU @D78124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, ARITY 2] : LEAF, 
   [COORD @D78133, PAST @D78132, 
      AGR [CASE @D78131, COUNT @D78130, PER @D78129, PLU @D78128, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, 
      ARITY 2] : LEAF, 
   [COORD @D78136, AGR [COUNT @D78135, PER @D78134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEAF, 
   [COORD @D78138, AGR [COUNT @D78137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEAF, 
   [COORD @D78140, AGR [COUNT @D78139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEAF, 
   [COORD @D78144, AGR [COUNT @D78143, PER @D78142, PLU @D78141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEAF, 
   [COORD @D78150, PAST @D78149, AGR [CASE @D78148, COUNT @D78147, 
            PER @D78146, PLU @D78145, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LEAF, 
   [COORD @D78153, AGR [COUNT @D78152, PER @D78151, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LEAF, 
   [COORD @D78155, AGR [COUNT @D78154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LEAF, 
   [COORD @D78157, AGR [COUNT @D78156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LEAF, 
   [COORD @D78161, AGR [COUNT @D78160, PER @D78159, PLU @D78158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LEAF, 
   [COORD @D78167, PAST @D78166, 
      AGR [CASE @D78165, COUNT @D78164, PER @D78163, PLU @D78162, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT THROUGH, 
      ARITY 1] : LEAF, 
   [COORD @D78170, AGR [COUNT @D78169, PER @D78168, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LEAF, 
   [COORD @D78172, AGR [COUNT @D78171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LEAF, 
   [COORD @D78174, AGR [COUNT @D78173, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LEAF, 
   [COORD @D78178, AGR [COUNT @D78177, PER @D78176, PLU @D78175, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LEAF, 
   [COORD @D78184, PAST @D78183, 
      AGR [CASE @D78182, COUNT @D78181, PER @D78180, PLU @D78179, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : LEAF.

WORD leafed : 
   [COORD @D78195, AGR [CASE @D78194, COUNT @D78193, PER @D78192, 
            PLU @D78191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78200, AGR [CASE @D78199, COUNT @D78198, PER @D78197, 
            PLU @D78196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78205, AGR [CASE @D78204, COUNT @D78203, PER @D78202, 
            PLU @D78201, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78210, AGR [CASE @D78209, COUNT @D78208, PER @D78207, 
            PLU @D78206, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78215, AGR [CASE @D78214, COUNT @D78213, PER @D78212, 
            PLU @D78211, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78220, AGR [CASE @D78219, COUNT @D78218, PER @D78217, 
            PLU @D78216, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78225, AGR [CASE @D78224, COUNT @D78223, PER @D78222, 
            PLU @D78221, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78230, AGR [CASE @D78229, COUNT @D78228, PER @D78227, 
            PLU @D78226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78235, AGR [CASE @D78234, COUNT @D78233, PER @D78232, 
            PLU @D78231, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LEAF.

WORD leafing : 
   [COORD @D78249, PRD @D78248, AGR [CASE @D78247, COUNT @D78246, 
            PER @D78245, PLU @D78244, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78255, PRD @D78254, 
      AGR [CASE @D78253, COUNT @D78252, PER @D78251, PLU @D78250, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEAF, 
   [COORD @D78261, PRD @D78260, AGR [CASE @D78259, COUNT @D78258, 
            PER @D78257, PLU @D78256, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAF, 
   [COORD @D78267, PRD @D78266, 
      AGR [CASE @D78265, COUNT @D78264, PER @D78263, PLU @D78262, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAF.

WORD leafs : 
   [COORD @D78275, AGR [COUNT @D78274, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LEAF, 
   [COORD @D78277, AGR [COUNT @D78276, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAF, 
   [COORD @D78279, 
      AGR [COUNT @D78278, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LEAF, 
   [COORD @D78281, AGR [COUNT @D78280, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAF.

WORD learn : 
   [COORD @D78288, AGR [COUNT @D78287, PER @D78286, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : LEARN, 
   [COORD @D78290, AGR [COUNT @D78289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : LEARN, 
   [COORD @D78292, AGR [COUNT @D78291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : LEARN, 
   [COORD @D78296, AGR [COUNT @D78295, PER @D78294, PLU @D78293, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : LEARN, 
   [COORD @D78302, PAST @D78301, AGR [CASE @D78300, COUNT @D78299, 
            PER @D78298, PLU @D78297, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : LEARN, 
   [COORD @D78305, AGR [COUNT @D78304, PER @D78303, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : LEARN, 
   [COORD @D78307, AGR [COUNT @D78306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : LEARN, 
   [COORD @D78309, AGR [COUNT @D78308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : LEARN, 
   [COORD @D78313, AGR [COUNT @D78312, PER @D78311, PLU @D78310, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : LEARN, 
   [COORD @D78319, PAST @D78318, AGR [CASE @D78317, COUNT @D78316, 
            PER @D78315, PLU @D78314, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : LEARN, 
   [COORD @D78322, AGR [COUNT @D78321, PER @D78320, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : LEARN, 
   [COORD @D78324, AGR [COUNT @D78323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : LEARN, 
   [COORD @D78326, AGR [COUNT @D78325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : LEARN, 
   [COORD @D78330, AGR [COUNT @D78329, PER @D78328, PLU @D78327, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : LEARN, 
   [COORD @D78336, PAST @D78335, AGR [CASE @D78334, COUNT @D78333, 
            PER @D78332, PLU @D78331, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : LEARN, 
   [COORD @D78339, AGR [COUNT @D78338, PER @D78337, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LEARN, 
   [COORD @D78341, AGR [COUNT @D78340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LEARN, 
   [COORD @D78343, AGR [COUNT @D78342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LEARN, 
   [COORD @D78347, AGR [COUNT @D78346, PER @D78345, PLU @D78344, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LEARN, 
   [COORD @D78353, PAST @D78352, AGR [CASE @D78351, COUNT @D78350, 
            PER @D78349, PLU @D78348, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : LEARN, 
   [COORD @D78356, AGR [COUNT @D78355, PER @D78354, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LEARN, 
   [COORD @D78358, AGR [COUNT @D78357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LEARN, 
   [COORD @D78360, AGR [COUNT @D78359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LEARN, 
   [COORD @D78364, AGR [COUNT @D78363, PER @D78362, PLU @D78361, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LEARN, 
   [COORD @D78370, PAST @D78369, AGR [CASE @D78368, COUNT @D78367, 
            PER @D78366, PLU @D78365, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LEARN, 
   [COORD @D78373, AGR [COUNT @D78372, PER @D78371, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : LEARN, 
   [COORD @D78375, AGR [COUNT @D78374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : LEARN, 
   [COORD @D78377, AGR [COUNT @D78376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : LEARN, 
   [COORD @D78381, AGR [COUNT @D78380, PER @D78379, PLU @D78378, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OF, ARITY 2] : LEARN, 
   [COORD @D78387, PAST @D78386, 
      AGR [CASE @D78385, COUNT @D78384, PER @D78383, PLU @D78382, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, 
      ARITY 2] : LEARN, 
   [COORD @D78390, AGR [COUNT @D78389, PER @D78388, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : LEARN, 
   [COORD @D78392, AGR [COUNT @D78391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : LEARN, 
   [COORD @D78394, AGR [COUNT @D78393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : LEARN, 
   [COORD @D78398, AGR [COUNT @D78397, PER @D78396, PLU @D78395, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : LEARN, 
   [COORD @D78404, PAST @D78403, 
      AGR [CASE @D78402, COUNT @D78401, PER @D78400, PLU @D78399, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, 
      ARITY 2] : LEARN, 
   [COORD @D78407, AGR [COUNT @D78406, PER @D78405, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEARN, 
   [COORD @D78409, AGR [COUNT @D78408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEARN, 
   [COORD @D78411, AGR [COUNT @D78410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEARN, 
   [COORD @D78415, AGR [COUNT @D78414, PER @D78413, PLU @D78412, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LEARN, 
   [COORD @D78421, PAST @D78420, AGR [CASE @D78419, COUNT @D78418, 
            PER @D78417, PLU @D78416, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LEARN.

WORD learned : 
   [COADV @D78434, COORD @D78433, DEF @D78432, PRD @D78431, AGR 
            [CASE @D78430, COUNT @D78429, PER @D78428, PLU @D78427, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   LEARNED, 
   [COADV @D78442, COORD @D78441, DEF @D78440, PRD @D78439, AGR 
            [CASE @D78438, COUNT @D78437, PER @D78436, PLU @D78435, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : LEARNED, 
   [COORD @D78447, AGR [CASE @D78446, COUNT @D78445, PER @D78444, 
            PLU @D78443, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78452, AGR [CASE @D78451, COUNT @D78450, PER @D78449, 
            PLU @D78448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78457, AGR [CASE @D78456, COUNT @D78455, PER @D78454, 
            PLU @D78453, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78462, AGR [CASE @D78461, COUNT @D78460, PER @D78459, 
            PLU @D78458, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78467, AGR [CASE @D78466, COUNT @D78465, PER @D78464, 
            PLU @D78463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78472, AGR [CASE @D78471, COUNT @D78470, PER @D78469, 
            PLU @D78468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78477, AGR [UB @D78476, VFORM @D78475, SUBJ @D78474, 
            FIN @D78473, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LEARN, 
   [COORD @D78482, AGR [CASE @D78481, COUNT @D78480, PER @D78479, 
            PLU @D78478, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78487, AGR [CASE @D78486, COUNT @D78485, PER @D78484, 
            PLU @D78483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78492, AGR [CASE @D78491, COUNT @D78490, PER @D78489, 
            PLU @D78488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78497, AGR [CASE @D78496, COUNT @D78495, PER @D78494, 
            PLU @D78493, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78502, AGR [CASE @D78501, COUNT @D78500, PER @D78499, 
            PLU @D78498, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LEARN, 
   [COORD @D78507, AGR [CASE @D78506, COUNT @D78505, PER @D78504, 
            PLU @D78503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78512, AGR [CASE @D78511, COUNT @D78510, PER @D78509, 
            PLU @D78508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78517, AGR [CASE @D78516, COUNT @D78515, PER @D78514, 
            PLU @D78513, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78522, AGR [CASE @D78521, COUNT @D78520, PER @D78519, 
            PLU @D78518, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78527, AGR [CASE @D78526, COUNT @D78525, PER @D78524, 
            PLU @D78523, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78532, AGR [CASE @D78531, COUNT @D78530, PER @D78529, 
            PLU @D78528, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LEARN.

WORD learning : 
   [COORD @D78543, REFL @D78542, PRD @D78541, CASE @D78540, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : LEARNING, 
   [COORD @D78549, PRD @D78548, 
      AGR [CASE @D78547, COUNT @D78546, PER @D78545, PLU @D78544, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEARN, 
   [COORD @D78555, PRD @D78554, AGR [CASE @D78553, COUNT @D78552, 
            PER @D78551, PLU @D78550, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78561, PRD @D78560, 
      AGR [CASE @D78559, COUNT @D78558, PER @D78557, PLU @D78556, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEARN, 
   [COORD @D78567, PRD @D78566, AGR [CASE @D78565, COUNT @D78564, 
            PER @D78563, PLU @D78562, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78573, PRD @D78572, 
      AGR [CASE @D78571, COUNT @D78570, PER @D78569, PLU @D78568, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEARN, 
   [COORD @D78579, PRD @D78578, AGR [CASE @D78577, COUNT @D78576, 
            PER @D78575, PLU @D78574, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEARN, 
   [COORD @D78585, PRD @D78584, 
      AGR [CASE @D78583, COUNT @D78582, PER @D78581, PLU @D78580, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEARN, 
   [COORD @D78591, PRD @D78590, AGR [CASE @D78589, COUNT @D78588, 
            PER @D78587, PLU @D78586, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEARN.

WORD learns : 
   [COORD @D78607, AGR [COUNT @D78606, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN, 
   [COORD @D78609, 
      AGR [COUNT @D78608, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN, 
   [COORD @D78611, 
      AGR [COUNT @D78610, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN, 
   [COORD @D78613, 
      AGR [COUNT @D78612, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN, 
   [COORD @D78615, 
      AGR [COUNT @D78614, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN, 
   [COORD @D78617, 
      AGR [COUNT @D78616, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN, 
   [COORD @D78619, 
      AGR [COUNT @D78618, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN, 
   [COORD @D78621, 
      AGR [COUNT @D78620, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEARN.

WORD leave : 
   [COORD @D78631, REFL @D78630, PRD @D78629, CASE @D78628, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF] : LEAVE, 
   [COORD @D78636, REFL @D78635, COUNT @D78634, PRD @D78633, 
      CASE @D78632, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LEAVE, 
   [COORD @D78639, 
      AGR [COUNT @D78638, PER @D78637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   LEAVE, 
   [COORD @D78641, AGR [COUNT @D78640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78643, AGR [COUNT @D78642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78647, AGR [COUNT @D78646, PER @D78645, PLU @D78644, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : LEAVE, 
   [COORD @D78653, PAST @D78652, 
      AGR [CASE @D78651, COUNT @D78650, PER @D78649, PLU @D78648, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   LEAVE, 
   [COORD @D78656, AGR [COUNT @D78655, PER @D78654, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78658, AGR [COUNT @D78657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78660, AGR [COUNT @D78659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78664, AGR [COUNT @D78663, PER @D78662, PLU @D78661, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : LEAVE, 
   [COORD @D78670, PAST @D78669, 
      AGR [CASE @D78668, COUNT @D78667, PER @D78666, PLU @D78665, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : 
   LEAVE, 
   [COORD @D78673, AGR [COUNT @D78672, PER @D78671, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78675, AGR [COUNT @D78674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78677, AGR [COUNT @D78676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78681, AGR [COUNT @D78680, PER @D78679, PLU @D78678, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : LEAVE, 
   [COORD @D78687, PAST @D78686, 
      AGR [CASE @D78685, COUNT @D78684, PER @D78683, PLU @D78682, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   LEAVE, 
   [COORD @D78690, AGR [COUNT @D78689, PER @D78688, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78692, AGR [COUNT @D78691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78694, AGR [COUNT @D78693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LEAVE, 
   [COORD @D78698, AGR [COUNT @D78697, PER @D78696, PLU @D78695, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : LEAVE, 
   [COORD @D78704, PAST @D78703, 
      AGR [CASE @D78702, COUNT @D78701, PER @D78700, PLU @D78699, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   LEAVE, 
   [COORD @D78707, AGR [COUNT @D78706, PER @D78705, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : LEAVE, 
   [COORD @D78709, AGR [COUNT @D78708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : LEAVE, 
   [COORD @D78711, AGR [COUNT @D78710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : LEAVE, 
   [COORD @D78715, AGR [COUNT @D78714, PER @D78713, PLU @D78712, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : LEAVE, 
   [COORD @D78721, PAST @D78720, 
      AGR [CASE @D78719, COUNT @D78718, PER @D78717, PLU @D78716, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      ARITY 3] : LEAVE, 
   [COORD @D78724, AGR [COUNT @D78723, PER @D78722, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LEAVE, 
   [COORD @D78726, AGR [COUNT @D78725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LEAVE, 
   [COORD @D78728, AGR [COUNT @D78727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LEAVE, 
   [COORD @D78732, AGR [COUNT @D78731, PER @D78730, PLU @D78729, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : LEAVE, 
   [COORD @D78738, PAST @D78737, 
      AGR [CASE @D78736, COUNT @D78735, PER @D78734, PLU @D78733, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : LEAVE, 
   [COORD @D78741, AGR [COUNT @D78740, PER @D78739, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : LEAVE, 
   [COORD @D78743, AGR [COUNT @D78742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : LEAVE, 
   [COORD @D78745, AGR [COUNT @D78744, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : LEAVE, 
   [COORD @D78749, AGR [COUNT @D78748, PER @D78747, PLU @D78746, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : LEAVE, 
   [COORD @D78755, PAST @D78754, 
      AGR [CASE @D78753, COUNT @D78752, PER @D78751, PLU @D78750, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : LEAVE, 
   [COORD @D78758, AGR [COUNT @D78757, PER @D78756, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : LEAVE, 
   [COORD @D78760, AGR [COUNT @D78759, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : LEAVE, 
   [COORD @D78762, AGR [COUNT @D78761, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : LEAVE, 
   [COORD @D78766, AGR [COUNT @D78765, PER @D78764, PLU @D78763, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, ARITY 3] : LEAVE, 
   [COORD @D78772, PAST @D78771, 
      AGR [CASE @D78770, COUNT @D78769, PER @D78768, PLU @D78767, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, ARITY 3] : LEAVE, 
   [COORD @D78775, AGR [COUNT @D78774, PER @D78773, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LEAVE, 
   [COORD @D78777, AGR [COUNT @D78776, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LEAVE, 
   [COORD @D78779, AGR [COUNT @D78778, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LEAVE, 
   [COORD @D78783, AGR [COUNT @D78782, PER @D78781, PLU @D78780, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : LEAVE, 
   [COORD @D78789, PAST @D78788, AGR [CASE @D78787, COUNT @D78786, 
            PER @D78785, PLU @D78784, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : LEAVE, 
   [COORD @D78792, AGR [COUNT @D78791, PER @D78790, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78794, AGR [COUNT @D78793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78796, AGR [COUNT @D78795, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78800, AGR [COUNT @D78799, PER @D78798, PLU @D78797, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78806, PAST @D78805, 
      AGR [CASE @D78804, COUNT @D78803, PER @D78802, PLU @D78801, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT OFF, 
      ARITY 2] : LEAVE, 
   [COORD @D78809, AGR [COUNT @D78808, PER @D78807, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : LEAVE, 
   [COORD @D78811, AGR [COUNT @D78810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : LEAVE, 
   [COORD @D78813, AGR [COUNT @D78812, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : LEAVE, 
   [COORD @D78817, AGR [COUNT @D78816, PER @D78815, PLU @D78814, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : LEAVE, 
   [COORD @D78823, PAST @D78822, AGR 
         [CASE @D78821, COUNT @D78820, PER @D78819, PLU @D78818, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      ARITY 2] : LEAVE, 
   [COORD @D78826, AGR [COUNT @D78825, PER @D78824, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : LEAVE, 
   [COORD @D78828, AGR [COUNT @D78827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : LEAVE, 
   [COORD @D78830, AGR [COUNT @D78829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : LEAVE, 
   [COORD @D78834, AGR [COUNT @D78833, PER @D78832, PLU @D78831, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : LEAVE, 
   [COORD @D78840, PAST @D78839, 
      AGR [CASE @D78838, COUNT @D78837, PER @D78836, PLU @D78835, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : LEAVE, 
   [COORD @D78843, AGR [COUNT @D78842, PER @D78841, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : LEAVE, 
   [COORD @D78845, AGR [COUNT @D78844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : LEAVE, 
   [COORD @D78847, AGR [COUNT @D78846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : LEAVE, 
   [COORD @D78851, AGR [COUNT @D78850, PER @D78849, PLU @D78848, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : LEAVE, 
   [COORD @D78857, PAST @D78856, 
      AGR [CASE @D78855, COUNT @D78854, PER @D78853, PLU @D78852, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : LEAVE, 
   [COORD @D78860, AGR [COUNT @D78859, PER @D78858, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78862, AGR [COUNT @D78861, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78864, AGR [COUNT @D78863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78868, AGR [COUNT @D78867, PER @D78866, PLU @D78865, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : LEAVE, 
   [COORD @D78874, PAST @D78873, 
      AGR [CASE @D78872, COUNT @D78871, PER @D78870, PLU @D78869, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : LEAVE, 
   [COORD @D78877, AGR [COUNT @D78876, PER @D78875, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BEHIND, ARITY 2] : LEAVE, 
   [COORD @D78879, AGR [COUNT @D78878, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BEHIND, ARITY 2] : LEAVE, 
   [COORD @D78881, AGR [COUNT @D78880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BEHIND, ARITY 2] : LEAVE, 
   [COORD @D78885, AGR [COUNT @D78884, PER @D78883, PLU @D78882, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BEHIND, ARITY 2] : LEAVE, 
   [COORD @D78891, PAST @D78890, 
      AGR [CASE @D78889, COUNT @D78888, PER @D78887, PLU @D78886, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BEHIND, ARITY 2] : LEAVE, 
   [COORD @D78894, AGR [COUNT @D78893, PER @D78892, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LEAVE, 
   [COORD @D78896, AGR [COUNT @D78895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LEAVE, 
   [COORD @D78898, AGR [COUNT @D78897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LEAVE, 
   [COORD @D78902, AGR [COUNT @D78901, PER @D78900, PLU @D78899, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : LEAVE, 
   [COORD @D78908, PAST @D78907, 
      AGR [CASE @D78906, COUNT @D78905, PER @D78904, PLU @D78903, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   LEAVE, 
   [COORD @D78911, AGR [COUNT @D78910, PER @D78909, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LEAVE, 
   [COORD @D78913, AGR [COUNT @D78912, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LEAVE, 
   [COORD @D78915, AGR [COUNT @D78914, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LEAVE, 
   [COORD @D78919, AGR [COUNT @D78918, PER @D78917, PLU @D78916, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : LEAVE, 
   [COORD @D78925, PAST @D78924, 
      AGR [CASE @D78923, COUNT @D78922, PER @D78921, PLU @D78920, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : LEAVE, 
   [COORD @D78928, AGR [COUNT @D78927, PER @D78926, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LEAVE, 
   [COORD @D78930, AGR [COUNT @D78929, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LEAVE, 
   [COORD @D78932, AGR [COUNT @D78931, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LEAVE, 
   [COORD @D78936, AGR [COUNT @D78935, PER @D78934, PLU @D78933, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : LEAVE, 
   [COORD @D78942, PAST @D78941, 
      AGR [CASE @D78940, COUNT @D78939, PER @D78938, PLU @D78937, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : LEAVE, 
   [COORD @D78945, AGR [COUNT @D78944, PER @D78943, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LEAVE, 
   [COORD @D78947, AGR [COUNT @D78946, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LEAVE, 
   [COORD @D78949, AGR [COUNT @D78948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LEAVE, 
   [COORD @D78953, AGR [COUNT @D78952, PER @D78951, PLU @D78950, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : LEAVE, 
   [COORD @D78959, PAST @D78958, 
      AGR [CASE @D78957, COUNT @D78956, PER @D78955, PLU @D78954, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : LEAVE, 
   [COORD @D78962, AGR [COUNT @D78961, PER @D78960, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BEHIND, ARITY 1] : LEAVE, 
   [COORD @D78964, AGR [COUNT @D78963, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BEHIND, ARITY 1] : LEAVE, 
   [COORD @D78966, AGR [COUNT @D78965, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BEHIND, ARITY 1] : LEAVE, 
   [COORD @D78970, AGR [COUNT @D78969, PER @D78968, PLU @D78967, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BEHIND, ARITY 1] : LEAVE, 
   [COORD @D78976, PAST @D78975, 
      AGR [CASE @D78974, COUNT @D78973, PER @D78972, PLU @D78971, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BEHIND, 
      ARITY 1] : LEAVE.

WORD leaves : 
   [COORD @D78997, DEMON @D78996, REFL @D78995, PRD @D78994, CASE 
         @D78993, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LEAVE, 
   [COORD @D78999, 
      AGR [COUNT @D78998, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79001, 
      AGR [COUNT @D79000, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79003, 
      AGR [COUNT @D79002, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79005, 
      AGR [COUNT @D79004, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79007, 
      AGR [COUNT @D79006, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LEAVE, 
   [COORD @D79009, AGR [COUNT @D79008, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LEAVE, 
   [COORD @D79011, AGR [COUNT @D79010, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LEAVE, 
   [COORD @D79013, AGR [COUNT @D79012, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LEAVE, 
   [COORD @D79015, AGR [COUNT @D79014, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79017, 
      AGR [COUNT @D79016, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79019, 
      AGR [COUNT @D79018, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79021, 
      AGR [COUNT @D79020, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79023, 
      AGR [COUNT @D79022, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79025, 
      AGR [COUNT @D79024, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79027, 
      AGR [COUNT @D79026, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BEHIND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79029, 
      AGR [COUNT @D79028, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79031, 
      AGR [COUNT @D79030, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79033, 
      AGR [COUNT @D79032, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79035, 
      AGR [COUNT @D79034, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79037, 
      AGR [COUNT @D79036, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BEHIND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LEAVE.

WORD leaving : 
   [COORD @D79049, PRD @D79048, AGR [CASE @D79047, COUNT @D79046, 
            PER @D79045, PLU @D79044, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79055, PRD @D79054, 
      AGR [CASE @D79053, COUNT @D79052, PER @D79051, PLU @D79050, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEAVE, 
   [COORD @D79061, PRD @D79060, AGR [CASE @D79059, COUNT @D79058, 
            PER @D79057, PLU @D79056, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79067, PRD @D79066, 
      AGR [CASE @D79065, COUNT @D79064, PER @D79063, PLU @D79062, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEAVE, 
   [COORD @D79073, PRD @D79072, AGR [CASE @D79071, COUNT @D79070, 
            PER @D79069, PLU @D79068, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79079, PRD @D79078, 
      AGR [CASE @D79077, COUNT @D79076, PER @D79075, PLU @D79074, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LEAVE, 
   [COORD @D79085, PRD @D79084, AGR [CASE @D79083, COUNT @D79082, 
            PER @D79081, PLU @D79080, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79091, PRD @D79090, 
      AGR [CASE @D79089, COUNT @D79088, PER @D79087, PLU @D79086, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LEAVE, 
   [COORD @D79097, PRD @D79096, AGR [CASE @D79095, COUNT @D79094, 
            PER @D79093, PLU @D79092, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79103, PRD @D79102, 
      AGR [CASE @D79101, COUNT @D79100, PER @D79099, PLU @D79098, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAVE, 
   [COORD @D79109, PRD @D79108, AGR [CASE @D79107, COUNT @D79106, 
            PER @D79105, PLU @D79104, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79115, PRD @D79114, 
      AGR [CASE @D79113, COUNT @D79112, PER @D79111, PLU @D79110, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAVE, 
   [COORD @D79121, PRD @D79120, AGR [CASE @D79119, COUNT @D79118, 
            PER @D79117, PLU @D79116, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79127, PRD @D79126, 
      AGR [CASE @D79125, COUNT @D79124, PER @D79123, PLU @D79122, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAVE, 
   [COORD @D79133, PRD @D79132, AGR [CASE @D79131, COUNT @D79130, 
            PER @D79129, PLU @D79128, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BEHIND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79139, PRD @D79138, 
      AGR [CASE @D79137, COUNT @D79136, PER @D79135, PLU @D79134, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LEAVE, 
   [COORD @D79145, PRD @D79144, AGR [CASE @D79143, COUNT @D79142, 
            PER @D79141, PLU @D79140, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79151, PRD @D79150, 
      AGR [CASE @D79149, COUNT @D79148, PER @D79147, PLU @D79146, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAVE, 
   [COORD @D79157, PRD @D79156, AGR [CASE @D79155, COUNT @D79154, 
            PER @D79153, PLU @D79152, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LEAVE, 
   [COORD @D79163, PRD @D79162, 
      AGR [CASE @D79161, COUNT @D79160, PER @D79159, PLU @D79158, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BEHIND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LEAVE.

WORD led : 
   [COORD @D79173, PAST @D79172, AGR [CASE @D79171, COUNT @D79170, 
            PER @D79169, PLU @D79168, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : LEAD, 
   [COORD @D79179, PAST @D79178, 
      AGR [CASE @D79177, COUNT @D79176, PER @D79175, PLU @D79174, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, ARITY 3] : 
   LEAD, 
   [COORD @D79185, PAST @D79184, AGR [CASE @D79183, COUNT @D79182, 
            PER @D79181, PLU @D79180, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : LEAD, 
   [COORD @D79191, PAST @D79190, 
      AGR [CASE @D79189, COUNT @D79188, PER @D79187, PLU @D79186, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : 
   LEAD, 
   [COORD @D79197, PAST @D79196, AGR [CASE @D79195, COUNT @D79194, 
            PER @D79193, PLU @D79192, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PRT ON, FIN -, ARITY 3] : LEAD, 
   [COORD @D79203, PAST @D79202, 
      AGR [CASE @D79201, COUNT @D79200, PER @D79199, PLU @D79198, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PRT ON, FIN -, 
      ARITY 3] : LEAD, 
   [COORD @D79209, PAST @D79208, AGR [CASE @D79207, COUNT @D79206, 
            PER @D79205, PLU @D79204, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : LEAD, 
   [COORD @D79215, PAST @D79214, 
      AGR [CASE @D79213, COUNT @D79212, PER @D79211, PLU @D79210, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : LEAD, 
   [COORD @D79221, PAST @D79220, AGR [CASE @D79219, COUNT @D79218, 
            PER @D79217, PLU @D79216, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : LEAD, 
   [COORD @D79227, PAST @D79226, 
      AGR [CASE @D79225, COUNT @D79224, PER @D79223, PLU @D79222, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM INTO, FIN -, 
      ARITY 3] : LEAD, 
   [COORD @D79233, PAST @D79232, AGR [CASE @D79231, COUNT @D79230, 
            PER @D79229, PLU @D79228, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT ON, PFORM INTO, FIN -, ARITY 3] : LEAD, 
   [COORD @D79239, PAST @D79238, 
      AGR [CASE @D79237, COUNT @D79236, PER @D79235, PLU @D79234, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT ON, PFORM INTO, 
      FIN -, ARITY 3] : LEAD, 
   [COORD @D79243, AGR [COUNT @D79242, PER @D79241, PLU @D79240, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PAST +, ARITY 3] : LEAD, 
   [COORD @D79247, AGR [COUNT @D79246, PER @D79245, PLU @D79244, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : LEAD, 
   [COORD @D79251, AGR [COUNT @D79250, PER @D79249, PLU @D79248, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, PRT ON, PAST +, ARITY 3] : LEAD, 
   [COORD @D79255, AGR [COUNT @D79254, PER @D79253, PLU @D79252, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : LEAD, 
   [COORD @D79259, AGR [COUNT @D79258, PER @D79257, PLU @D79256, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM INTO, PAST +, ARITY 3] : LEAD, 
   [COORD @D79263, AGR [COUNT @D79262, PER @D79261, PLU @D79260, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PRT ON, PFORM INTO, PAST +, ARITY 3] : LEAD, 
   [COORD @D79269, PAST @D79268, 
      AGR [CASE @D79267, COUNT @D79266, PER @D79265, PLU @D79264, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : LEAD, 
   [COORD @D79275, PAST @D79274, AGR [CASE @D79273, COUNT @D79272, 
            PER @D79271, PLU @D79270, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : LEAD, 
   [COORD @D79281, PAST @D79280, 
      AGR [CASE @D79279, COUNT @D79278, PER @D79277, PLU @D79276, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, FIN -, ARITY 2] : LEAD, 
   [COORD @D79287, PAST @D79286, 
      AGR [CASE @D79285, COUNT @D79284, PER @D79283, PLU @D79282, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT ON, FIN -, 
      ARITY 2] : LEAD, 
   [COORD @D79293, PAST @D79292, AGR [CASE @D79291, COUNT @D79290, 
            PER @D79289, PLU @D79288, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT ON, FIN -, ARITY 2] : LEAD, 
   [COORD @D79299, PAST @D79298, 
      AGR [CASE @D79297, COUNT @D79296, PER @D79295, PLU @D79294, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM WITH, FIN -, 
      ARITY 2] : LEAD, 
   [COORD @D79305, PAST @D79304, AGR [CASE @D79303, COUNT @D79302, 
            PER @D79301, PLU @D79300, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OFF, PFORM WITH, FIN -, ARITY 2] : LEAD, 
   [COORD @D79311, PAST @D79310, 
      AGR [CASE @D79309, COUNT @D79308, PER @D79307, PLU @D79306, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM TO, FIN -, 
      ARITY 2] : LEAD, 
   [COORD @D79317, PAST @D79316, AGR [CASE @D79315, COUNT @D79314, 
            PER @D79313, PLU @D79312, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : LEAD, 
   [COORD @D79323, PAST @D79322, 
      AGR [CASE @D79321, COUNT @D79320, PER @D79319, PLU @D79318, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM TO, 
      FIN -, ARITY 2] : LEAD, 
   [COORD @D79329, PAST @D79328, AGR [CASE @D79327, COUNT @D79326, 
            PER @D79325, PLU @D79324, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT UP, PFORM TO, FIN -, ARITY 2] : LEAD, 
   [COORD @D79335, PAST @D79334, 
      AGR [CASE @D79333, COUNT @D79332, PER @D79331, PLU @D79330, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : LEAD, 
   [COORD @D79341, PAST @D79340, AGR [CASE @D79339, COUNT @D79338, 
            PER @D79337, PLU @D79336, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : LEAD, 
   [COORD @D79347, PAST @D79346, 
      AGR [CASE @D79345, COUNT @D79344, PER @D79343, PLU @D79342, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ASTRAY, FIN -, 
      ARITY 2] : LEAD, 
   [COORD @D79353, PAST @D79352, AGR [CASE @D79351, COUNT @D79350, 
            PER @D79349, PLU @D79348, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASTRAY, FIN -, ARITY 2] : LEAD, 
   [COORD @D79359, PAST @D79358, 
      AGR [CASE @D79357, COUNT @D79356, PER @D79355, PLU @D79354, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ALONG, FIN -, 
      ARITY 2] : LEAD, 
   [COORD @D79365, PAST @D79364, AGR [CASE @D79363, COUNT @D79362, 
            PER @D79361, PLU @D79360, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ALONG, FIN -, ARITY 2] : LEAD, 
   [COORD @D79369, 
      AGR [COUNT @D79368, PER @D79367, PLU @D79366, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : LEAD, 
   [COORD @D79373, AGR [COUNT @D79372, PER @D79371, PLU @D79370, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, PAST +, 
      ARITY 2] : LEAD, 
   [COORD @D79377, AGR [COUNT @D79376, PER @D79375, PLU @D79374, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT ON, 
      PAST +, ARITY 2] : LEAD, 
   [COORD @D79381, AGR [COUNT @D79380, PER @D79379, PLU @D79378, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM WITH, PAST +, ARITY 2] : LEAD, 
   [COORD @D79385, AGR [COUNT @D79384, PER @D79383, PLU @D79382, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM WITH, PAST +, ARITY 2] : LEAD, 
   [COORD @D79389, AGR [COUNT @D79388, PER @D79387, PLU @D79386, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, PAST +, ARITY 2] : LEAD, 
   [COORD @D79393, AGR [COUNT @D79392, PER @D79391, PLU @D79390, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, PAST +, ARITY 2] : LEAD, 
   [COORD @D79397, AGR [COUNT @D79396, PER @D79395, PLU @D79394, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : LEAD, 
   [COORD @D79401, AGR [COUNT @D79400, PER @D79399, PLU @D79398, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASTRAY, PAST +, ARITY 2] : LEAD, 
   [COORD @D79405, AGR [COUNT @D79404, PER @D79403, PLU @D79402, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALONG, PAST +, ARITY 2] : LEAD, 
   [COORD @D79411, PAST @D79410, AGR 
         [CASE @D79409, COUNT @D79408, PER @D79407, PLU @D79406, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, ARITY 1] : LEAD, 
   [COORD @D79417, PAST @D79416, 
      AGR [CASE @D79415, COUNT @D79414, PER @D79413, PLU @D79412, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, FIN -, 
      ARITY 1] : LEAD, 
   [COORD @D79423, PAST @D79422, AGR [CASE @D79421, COUNT @D79420, 
            PER @D79419, PLU @D79418, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : LEAD, 
   [COORD @D79429, PAST @D79428, 
      AGR [CASE @D79427, COUNT @D79426, PER @D79425, PLU @D79424, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ASTRAY, FIN -, 
      ARITY 1] : LEAD, 
   [COORD @D79435, PAST @D79434, AGR [CASE @D79433, COUNT @D79432, 
            PER @D79431, PLU @D79430, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALONG, FIN -, ARITY 1] : LEAD, 
   [COORD @D79439, 
      AGR [COUNT @D79438, PER @D79437, PLU @D79436, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : LEAD, 
   [COORD @D79443, AGR [COUNT @D79442, PER @D79441, PLU @D79440, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : LEAD, 
   [COORD @D79447, AGR [COUNT @D79446, PER @D79445, PLU @D79444, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : LEAD, 
   [COORD @D79451, AGR [COUNT @D79450, PER @D79449, PLU @D79448, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ASTRAY, PAST +, ARITY 1] : LEAD, 
   [COORD @D79455, AGR [COUNT @D79454, PER @D79453, PLU @D79452, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ALONG, PAST +, ARITY 1] : LEAD.

WORD left : 
   [COADV @D79482, COORD @D79481, DEF @D79480, PRD @D79479, AGR 
            [CASE @D79478, COUNT @D79477, PER @D79476, PLU @D79475, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : LEFT, 
   [COADV @D79490, COORD @D79489, DEF @D79488, PRD @D79487, 
      AGR [CASE @D79486, COUNT @D79485, PER @D79484, PLU @D79483, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR INFL, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : LEFT, 
   [COADV @D79495, COORD @D79494, DEF @D79493, AGR @D79492, PRD @D79491, 
      FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, N +, COMPAR NO, GRADE -, 
      AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, ADV +] : LEFT, 
   [COORD @D79500, REFL @D79499, COUNT @D79498, PRD @D79497, 
      CASE @D79496, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LEFT, 
   [COORD @D79504, REFL @D79503, PRD @D79502, CASE @D79501, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, GROUP +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT -] : LEFT, 
   [COORD @D79510, PAST @D79509, 
      AGR [CASE @D79508, COUNT @D79507, PER @D79506, PLU @D79505, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, ARITY 3] : 
   LEAVE, 
   [COORD @D79516, PAST @D79515, AGR [CASE @D79514, COUNT @D79513, 
            PER @D79512, PLU @D79511, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79522, PAST @D79521, 
      AGR [CASE @D79520, COUNT @D79519, PER @D79518, PLU @D79517, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, ARITY 3] : 
   LEAVE, 
   [COORD @D79528, PAST @D79527, AGR [CASE @D79526, COUNT @D79525, 
            PER @D79524, PLU @D79523, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79534, PAST @D79533, 
      AGR [CASE @D79532, COUNT @D79531, PER @D79530, PLU @D79529, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : LEAVE, 
   [COORD @D79540, PAST @D79539, AGR [CASE @D79538, COUNT @D79537, 
            PER @D79536, PLU @D79535, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79546, PAST @D79545, 
      AGR [CASE @D79544, COUNT @D79543, PER @D79542, PLU @D79541, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : LEAVE, 
   [COORD @D79552, PAST @D79551, AGR [CASE @D79550, COUNT @D79549, 
            PER @D79548, PLU @D79547, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79558, PAST @D79557, 
      AGR [CASE @D79556, COUNT @D79555, PER @D79554, PLU @D79553, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      FIN -, ARITY 3] : LEAVE, 
   [COORD @D79564, PAST @D79563, AGR [CASE @D79562, COUNT @D79561, 
            PER @D79560, PLU @D79559, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79570, PAST @D79569, 
      AGR [CASE @D79568, COUNT @D79567, PER @D79566, PLU @D79565, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : LEAVE, 
   [COORD @D79576, PAST @D79575, AGR [CASE @D79574, COUNT @D79573, 
            PER @D79572, PLU @D79571, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79582, PAST @D79581, 
      AGR [CASE @D79580, COUNT @D79579, PER @D79578, PLU @D79577, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, FIN -, 
      ARITY 3] : LEAVE, 
   [COORD @D79588, PAST @D79587, AGR [CASE @D79586, COUNT @D79585, 
            PER @D79584, PLU @D79583, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79594, PAST @D79593, 
      AGR [CASE @D79592, COUNT @D79591, PER @D79590, PLU @D79589, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 3] : LEAVE, 
   [COORD @D79600, PAST @D79599, AGR [CASE @D79598, COUNT @D79597, 
            PER @D79596, PLU @D79595, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : LEAVE, 
   [COORD @D79604, 
      AGR [COUNT @D79603, PER @D79602, PLU @D79601, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PAST +, 
      ARITY 3] : LEAVE, 
   [COORD @D79608, AGR [COUNT @D79607, PER @D79606, PLU @D79605, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PAST +, ARITY 3] : LEAVE, 
   [COORD @D79612, AGR [COUNT @D79611, PER @D79610, PLU @D79609, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : LEAVE, 
   [COORD @D79616, AGR [COUNT @D79615, PER @D79614, PLU @D79613, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      PAST +, ARITY 3] : LEAVE, 
   [COORD @D79620, AGR [COUNT @D79619, PER @D79618, PLU @D79617, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, PAST +, ARITY 3] : LEAVE, 
   [COORD @D79624, AGR [COUNT @D79623, PER @D79622, PLU @D79621, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : LEAVE, 
   [COORD @D79628, AGR [COUNT @D79627, PER @D79626, PLU @D79625, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, PAST +, ARITY 3] : LEAVE, 
   [COORD @D79632, AGR [COUNT @D79631, PER @D79630, PLU @D79629, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PFORM OF, PAST +, ARITY 3] : LEAVE, 
   [COORD @D79638, PAST @D79637, 
      AGR [CASE @D79636, COUNT @D79635, PER @D79634, PLU @D79633, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : LEAVE, 
   [COORD @D79644, PAST @D79643, AGR [CASE @D79642, COUNT @D79641, 
            PER @D79640, PLU @D79639, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : LEAVE, 
   [COORD @D79650, PAST @D79649, 
      AGR [CASE @D79648, COUNT @D79647, PER @D79646, PLU @D79645, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT OFF, FIN -, 
      ARITY 2] : LEAVE, 
   [COORD @D79656, PAST @D79655, AGR [CASE @D79654, COUNT @D79653, 
            PER @D79652, PLU @D79651, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM FOR, FIN -, ARITY 2] : LEAVE, 
   [COORD @D79662, PAST @D79661, 
      AGR [CASE @D79660, COUNT @D79659, PER @D79658, PLU @D79657, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : LEAVE, 
   [COORD @D79668, PAST @D79667, AGR [CASE @D79666, COUNT @D79665, 
            PER @D79664, PLU @D79663, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : LEAVE, 
   [COORD @D79674, PAST @D79673, 
      AGR [CASE @D79672, COUNT @D79671, PER @D79670, PLU @D79669, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : LEAVE, 
   [COORD @D79680, PAST @D79679, AGR [CASE @D79678, COUNT @D79677, 
            PER @D79676, PLU @D79675, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : LEAVE, 
   [COORD @D79686, PAST @D79685, 
      AGR [CASE @D79684, COUNT @D79683, PER @D79682, PLU @D79681, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : LEAVE, 
   [COORD @D79692, PAST @D79691, AGR [CASE @D79690, COUNT @D79689, 
            PER @D79688, PLU @D79687, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : LEAVE, 
   [COORD @D79698, PAST @D79697, 
      AGR [CASE @D79696, COUNT @D79695, PER @D79694, PLU @D79693, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BEHIND, FIN -, 
      ARITY 2] : LEAVE, 
   [COORD @D79704, PAST @D79703, AGR [CASE @D79702, COUNT @D79701, 
            PER @D79700, PLU @D79699, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BEHIND, FIN -, ARITY 2] : LEAVE, 
   [COORD @D79708, 
      AGR [COUNT @D79707, PER @D79706, PLU @D79705, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : LEAVE, 
   [COORD @D79712, AGR [COUNT @D79711, PER @D79710, PLU @D79709, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT OFF, PAST +, ARITY 2] : LEAVE, 
   [COORD @D79716, AGR [COUNT @D79715, PER @D79714, PLU @D79713, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : LEAVE, 
   [COORD @D79720, AGR [COUNT @D79719, PER @D79718, PLU @D79717, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PAST +, ARITY 2] : LEAVE, 
   [COORD @D79724, AGR [COUNT @D79723, PER @D79722, PLU @D79721, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : LEAVE, 
   [COORD @D79728, AGR [COUNT @D79727, PER @D79726, PLU @D79725, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : LEAVE, 
   [COORD @D79732, AGR [COUNT @D79731, PER @D79730, PLU @D79729, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BEHIND, PAST +, ARITY 2] : LEAVE, 
   [COORD @D79738, PAST @D79737, 
      AGR [CASE @D79736, COUNT @D79735, PER @D79734, PLU @D79733, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, ARITY 1] : LEAVE, 
   
   [COORD @D79744, PAST @D79743, AGR [CASE @D79742, COUNT @D79741, PER 
               @D79740, PLU @D79739, BAR 2, V -, N +, NFORM NORM], FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, FIN -, ARITY 1] : LEAVE, 
   [COORD @D79750, PAST @D79749, 
      AGR [CASE @D79748, COUNT @D79747, PER @D79746, PLU @D79745, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : LEAVE, 
   [COORD @D79756, PAST @D79755, AGR [CASE @D79754, COUNT @D79753, 
            PER @D79752, PLU @D79751, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : LEAVE, 
   [COORD @D79762, PAST @D79761, 
      AGR [CASE @D79760, COUNT @D79759, PER @D79758, PLU @D79757, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BEHIND, FIN -, 
      ARITY 1] : LEAVE, 
   [COORD @D79766, AGR [COUNT @D79765, PER @D79764, PLU @D79763, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : LEAVE, 
   [COORD @D79770, AGR [COUNT @D79769, PER @D79768, PLU @D79767, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : LEAVE, 
   [COORD @D79774, AGR [COUNT @D79773, PER @D79772, PLU @D79771, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : LEAVE, 
   [COORD @D79778, AGR [COUNT @D79777, PER @D79776, PLU @D79775, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : LEAVE, 
   [COORD @D79782, AGR [COUNT @D79781, PER @D79780, PLU @D79779, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BEHIND, PAST +, ARITY 1] : LEAVE.

WORD lefts : 
   [COORD @D79815, DEMON @D79814, REFL @D79813, PRD @D79812, CASE 
         @D79811, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LEFT.

WORD libel : 
   [COORD @D79826, REFL @D79825, COUNT @D79824, PRD @D79823, CASE 
         @D79822, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LIBEL, 
   [COORD @D79829, 
      AGR [COUNT @D79828, PER @D79827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   LIBEL, 
   [COORD @D79831, AGR [COUNT @D79830, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIBEL, 
   [COORD @D79833, AGR [COUNT @D79832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIBEL, 
   [COORD @D79837, AGR [COUNT @D79836, PER @D79835, PLU @D79834, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LIBEL, 
   [COORD @D79843, PAST @D79842, AGR [CASE @D79841, COUNT @D79840, 
            PER @D79839, PLU @D79838, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LIBEL.

WORD libelled : 
   [COORD @D79860, AGR [CASE @D79859, COUNT @D79858, PER @D79857, 
            PLU @D79856, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIBEL, 
   [COORD @D79865, AGR [CASE @D79864, COUNT @D79863, PER @D79862, 
            PLU @D79861, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIBEL, 
   [COORD @D79870, AGR [CASE @D79869, COUNT @D79868, PER @D79867, 
            PLU @D79866, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIBEL.

WORD libelling : 
   [COORD @D79892, PRD @D79891, AGR [CASE @D79890, COUNT @D79889, 
            PER @D79888, PLU @D79887, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIBEL.

WORD libels : 
   [COORD @D79905, DEMON @D79904, REFL @D79903, PRD @D79902, CASE 
         @D79901, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LIBEL, 
   [COORD @D79907, 
      AGR [COUNT @D79906, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIBEL.

WORD lie : 
   [COORD @D79917, REFL @D79916, PRD @D79915, CASE @D79914, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LIE, 
   [COORD @D79920, 
      AGR [COUNT @D79919, PER @D79918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   LIE, 
   [COORD @D79922, AGR [COUNT @D79921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LIE, 
   [COORD @D79924, AGR [COUNT @D79923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LIE, 
   [COORD @D79928, AGR [COUNT @D79927, PER @D79926, PLU @D79925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : LIE, 
   [COORD @D79934, PAST @D79933, 
      AGR [CASE @D79932, COUNT @D79931, PER @D79930, PLU @D79929, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   LIE, 
   [COORD @D79937, AGR [COUNT @D79936, PER @D79935, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : LIE, 
   [COORD @D79939, AGR [COUNT @D79938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : LIE, 
   [COORD @D79941, AGR [COUNT @D79940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : LIE, 
   [COORD @D79945, AGR [COUNT @D79944, PER @D79943, PLU @D79942, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : LIE, 
   [COORD @D79951, PAST @D79950, 
      AGR [CASE @D79949, COUNT @D79948, PER @D79947, PLU @D79946, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, ARITY 2] : 
   LIE, 
   [COORD @D79954, AGR [COUNT @D79953, PER @D79952, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : LIE, 
   [COORD @D79956, AGR [COUNT @D79955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : LIE, 
   [COORD @D79958, AGR [COUNT @D79957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : LIE, 
   [COORD @D79962, AGR [COUNT @D79961, PER @D79960, PLU @D79959, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : LIE, 
   [COORD @D79968, PAST @D79967, AGR [CASE @D79966, COUNT @D79965, 
            PER @D79964, PLU @D79963, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : LIE, 
   [COORD @D79971, AGR [COUNT @D79970, PER @D79969, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT DOWN, ARITY 2] : LIE, 
   [COORD @D79973, AGR [COUNT @D79972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT DOWN, ARITY 2] : LIE, 
   [COORD @D79975, AGR [COUNT @D79974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT DOWN, ARITY 2] : LIE, 
   [COORD @D79979, AGR [COUNT @D79978, PER @D79977, PLU @D79976, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, PRT DOWN, ARITY 2] : LIE, 
   [COORD @D79985, PAST @D79984, AGR [CASE @D79983, COUNT @D79982, 
            PER @D79981, PLU @D79980, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, PRT DOWN, ARITY 2] : LIE, 
   [COORD @D79988, 
      AGR [COUNT @D79987, PER @D79986, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : LIE, 
   [COORD @D79990, AGR [COUNT @D79989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : LIE, 
   [COORD @D79992, AGR [COUNT @D79991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : LIE, 
   [COORD @D79996, AGR [COUNT @D79995, PER @D79994, PLU @D79993, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : LIE, 
   [COORD @D80002, PAST @D80001, AGR [CASE @D80000, COUNT @D79999, 
            PER @D79998, PLU @D79997, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, ARITY 2] : LIE, 
   [COORD @D80005, 
      AGR [COUNT @D80004, PER @D80003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM UNDER, ARITY 2] : LIE, 
   [COORD @D80007, AGR [COUNT @D80006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM UNDER, ARITY 2] : LIE, 
   [COORD @D80009, AGR [COUNT @D80008, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT DOWN, PFORM UNDER, ARITY 2] : LIE, 
   [COORD @D80013, AGR [COUNT @D80012, PER @D80011, PLU @D80010, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT DOWN, PFORM UNDER, ARITY 2] : LIE, 
   [COORD @D80019, PAST @D80018, 
      AGR [CASE @D80017, COUNT @D80016, PER @D80015, PLU @D80014, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM UNDER, ARITY 2] : LIE, 
   [COORD @D80022, AGR [COUNT @D80021, PER @D80020, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEHIND, ARITY 2] : LIE, 
   [COORD @D80024, AGR [COUNT @D80023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEHIND, ARITY 2] : LIE, 
   [COORD @D80026, AGR [COUNT @D80025, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BEHIND, ARITY 2] : LIE, 
   [COORD @D80030, AGR [COUNT @D80029, PER @D80028, PLU @D80027, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BEHIND, ARITY 2] : LIE, 
   [COORD @D80036, PAST @D80035, 
      AGR [CASE @D80034, COUNT @D80033, PER @D80032, PLU @D80031, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BEHIND, 
      ARITY 2] : LIE, 
   [COORD @D80039, AGR [COUNT @D80038, PER @D80037, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LIE, 
   [COORD @D80041, AGR [COUNT @D80040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LIE, 
   [COORD @D80043, AGR [COUNT @D80042, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LIE, 
   [COORD @D80047, AGR [COUNT @D80046, PER @D80045, PLU @D80044, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : LIE, 
   [COORD @D80053, PAST @D80052, AGR 
         [CASE @D80051, COUNT @D80050, PER @D80049, PLU @D80048, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   LIE, 
   [COORD @D80056, AGR [COUNT @D80055, PER @D80054, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : LIE, 
   [COORD @D80058, AGR [COUNT @D80057, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : LIE, 
   [COORD @D80060, AGR [COUNT @D80059, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : LIE, 
   [COORD @D80064, AGR [COUNT @D80063, PER @D80062, PLU @D80061, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : LIE, 
   [COORD @D80070, PAST @D80069, 
      AGR [CASE @D80068, COUNT @D80067, PER @D80066, PLU @D80065, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : LIE, 
   [COORD @D80073, AGR [COUNT @D80072, PER @D80071, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : LIE, 
   [COORD @D80075, AGR [COUNT @D80074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : LIE, 
   [COORD @D80077, AGR [COUNT @D80076, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : LIE, 
   [COORD @D80081, AGR [COUNT @D80080, PER @D80079, PLU @D80078, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, ARITY 1] : LIE, 
   [COORD @D80087, PAST @D80086, 
      AGR [CASE @D80085, COUNT @D80084, PER @D80083, PLU @D80082, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TO, 
      ARITY 1] : LIE, 
   [COORD @D80090, AGR [COUNT @D80089, PER @D80088, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LIE, 
   [COORD @D80092, AGR [COUNT @D80091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LIE, 
   [COORD @D80094, AGR [COUNT @D80093, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : LIE, 
   [COORD @D80098, AGR [COUNT @D80097, PER @D80096, PLU @D80095, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : LIE, 
   [COORD @D80104, PAST @D80103, 
      AGR [CASE @D80102, COUNT @D80101, PER @D80100, PLU @D80099, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : LIE, 
   [COORD @D80107, AGR [COUNT @D80106, PER @D80105, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LIE, 
   [COORD @D80109, AGR [COUNT @D80108, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LIE, 
   [COORD @D80111, AGR [COUNT @D80110, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : LIE, 
   [COORD @D80115, AGR [COUNT @D80114, PER @D80113, PLU @D80112, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : LIE, 
   [COORD @D80121, PAST @D80120, 
      AGR [CASE @D80119, COUNT @D80118, PER @D80117, PLU @D80116, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : LIE, 
   [COORD @D80124, AGR [COUNT @D80123, PER @D80122, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : LIE, 
   [COORD @D80126, AGR [COUNT @D80125, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : LIE, 
   [COORD @D80128, AGR [COUNT @D80127, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : LIE, 
   [COORD @D80132, AGR [COUNT @D80131, PER @D80130, PLU @D80129, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : LIE, 
   [COORD @D80138, PAST @D80137, 
      AGR [CASE @D80136, COUNT @D80135, PER @D80134, PLU @D80133, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : LIE, 
   [COORD @D80141, AGR [COUNT @D80140, PER @D80139, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : LIE, 
   [COORD @D80143, AGR [COUNT @D80142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : LIE, 
   [COORD @D80145, AGR [COUNT @D80144, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : LIE, 
   [COORD @D80149, AGR [COUNT @D80148, PER @D80147, PLU @D80146, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : LIE, 
   [COORD @D80155, PAST @D80154, 
      AGR [CASE @D80153, COUNT @D80152, PER @D80151, PLU @D80150, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      ARITY 1] : LIE, 
   [COORD @D80158, AGR [COUNT @D80157, PER @D80156, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : LIE, 
   [COORD @D80160, AGR [COUNT @D80159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : LIE, 
   [COORD @D80162, AGR [COUNT @D80161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : LIE, 
   [COORD @D80166, AGR [COUNT @D80165, PER @D80164, PLU @D80163, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : LIE, 
   [COORD @D80172, PAST @D80171, 
      AGR [CASE @D80170, COUNT @D80169, PER @D80168, PLU @D80167, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ABOUT, 
      ARITY 1] : LIE.

WORD lies : 
   [COORD @D80193, DEMON @D80192, REFL @D80191, PRD @D80190, CASE 
         @D80189, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LIE, 
   [COORD @D80195, 
      AGR [COUNT @D80194, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80197, 
      AGR [COUNT @D80196, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80199, 
      AGR [COUNT @D80198, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80201, 
      AGR [COUNT @D80200, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80203, 
      AGR [COUNT @D80202, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80205, 
      AGR [COUNT @D80204, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT DOWN, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LIE, 
   [COORD @D80207, AGR [COUNT @D80206, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BEHIND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LIE, 
   [COORD @D80209, AGR [COUNT @D80208, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80211, 
      AGR [COUNT @D80210, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80213, 
      AGR [COUNT @D80212, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80215, 
      AGR [COUNT @D80214, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80217, 
      AGR [COUNT @D80216, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80219, 
      AGR [COUNT @D80218, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80221, 
      AGR [COUNT @D80220, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE, 
   [COORD @D80223, 
      AGR [COUNT @D80222, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIE.

WORD lift : 
   [COORD @D80233, REFL @D80232, PRD @D80231, CASE @D80230, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LIFT, 
   [COORD @D80238, REFL @D80237, COUNT @D80236, PRD @D80235, 
      CASE @D80234, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LIFT, 
   [COORD @D80241, 
      AGR [COUNT @D80240, PER @D80239, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : LIFT, 
   [COORD @D80243, AGR [COUNT @D80242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : LIFT, 
   [COORD @D80245, AGR [COUNT @D80244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : LIFT, 
   [COORD @D80249, AGR [COUNT @D80248, PER @D80247, PLU @D80246, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : LIFT, 
   [COORD @D80255, PAST @D80254, 
      AGR [CASE @D80253, COUNT @D80252, PER @D80251, PLU @D80250, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : LIFT, 
   [COORD @D80258, AGR [COUNT @D80257, PER @D80256, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIFT, 
   [COORD @D80260, AGR [COUNT @D80259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIFT, 
   [COORD @D80262, AGR [COUNT @D80261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIFT, 
   [COORD @D80266, AGR [COUNT @D80265, PER @D80264, PLU @D80263, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LIFT, 
   [COORD @D80272, PAST @D80271, AGR [CASE @D80270, COUNT @D80269, 
            PER @D80268, PLU @D80267, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LIFT, 
   [COORD @D80275, AGR [COUNT @D80274, PER @D80273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LIFT, 
   [COORD @D80277, AGR [COUNT @D80276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LIFT, 
   [COORD @D80279, AGR [COUNT @D80278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LIFT, 
   [COORD @D80283, AGR [COUNT @D80282, PER @D80281, PLU @D80280, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : LIFT, 
   [COORD @D80289, PAST @D80288, 
      AGR [CASE @D80287, COUNT @D80286, PER @D80285, PLU @D80284, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : LIFT, 
   [COORD @D80292, AGR [COUNT @D80291, PER @D80290, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIFT, 
   [COORD @D80294, AGR [COUNT @D80293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIFT, 
   [COORD @D80296, AGR [COUNT @D80295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIFT, 
   [COORD @D80300, AGR [COUNT @D80299, PER @D80298, PLU @D80297, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIFT, 
   [COORD @D80306, PAST @D80305, AGR [CASE @D80304, COUNT @D80303, 
            PER @D80302, PLU @D80301, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LIFT, 
   [COORD @D80309, AGR [COUNT @D80308, PER @D80307, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIFT, 
   [COORD @D80311, AGR [COUNT @D80310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIFT, 
   [COORD @D80313, AGR [COUNT @D80312, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIFT, 
   [COORD @D80317, AGR [COUNT @D80316, PER @D80315, PLU @D80314, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIFT, 
   [COORD @D80323, PAST @D80322, 
      AGR [CASE @D80321, COUNT @D80320, PER @D80319, PLU @D80318, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : LIFT, 
   [COORD @D80326, AGR [COUNT @D80325, PER @D80324, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LIFT, 
   [COORD @D80328, AGR [COUNT @D80327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LIFT, 
   [COORD @D80330, AGR [COUNT @D80329, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LIFT, 
   [COORD @D80334, AGR [COUNT @D80333, PER @D80332, PLU @D80331, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : LIFT, 
   [COORD @D80340, PAST @D80339, 
      AGR [CASE @D80338, COUNT @D80337, PER @D80336, PLU @D80335, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : LIFT.

WORD lifted : 
   [COORD @D80353, AGR [CASE @D80352, COUNT @D80351, PER @D80350, 
            PLU @D80349, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80358, AGR [CASE @D80357, COUNT @D80356, PER @D80355, 
            PLU @D80354, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80363, AGR [CASE @D80362, COUNT @D80361, PER @D80360, 
            PLU @D80359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80368, AGR [CASE @D80367, COUNT @D80366, PER @D80365, 
            PLU @D80364, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIFT, 
   [COORD @D80373, AGR [CASE @D80372, COUNT @D80371, PER @D80370, 
            PLU @D80369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80378, AGR [CASE @D80377, COUNT @D80376, PER @D80375, 
            PLU @D80374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80383, AGR [CASE @D80382, COUNT @D80381, PER @D80380, 
            PLU @D80379, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80388, AGR [CASE @D80387, COUNT @D80386, PER @D80385, 
            PLU @D80384, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80393, AGR [CASE @D80392, COUNT @D80391, PER @D80390, 
            PLU @D80389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80398, AGR [CASE @D80397, COUNT @D80396, PER @D80395, 
            PLU @D80394, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80403, AGR [CASE @D80402, COUNT @D80401, PER @D80400, 
            PLU @D80399, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80408, AGR [CASE @D80407, COUNT @D80406, PER @D80405, 
            PLU @D80404, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80413, AGR [CASE @D80412, COUNT @D80411, PER @D80410, 
            PLU @D80409, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80418, AGR [CASE @D80417, COUNT @D80416, PER @D80415, 
            PLU @D80414, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80423, AGR [CASE @D80422, COUNT @D80421, PER @D80420, 
            PLU @D80419, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIFT.

WORD lifting : 
   [COORD @D80441, PRD @D80440, AGR [CASE @D80439, COUNT @D80438, 
            PER @D80437, PLU @D80436, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80447, PRD @D80446, 
      AGR [CASE @D80445, COUNT @D80444, PER @D80443, PLU @D80442, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LIFT, 
   [COORD @D80453, PRD @D80452, AGR [CASE @D80451, COUNT @D80450, 
            PER @D80449, PLU @D80448, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80459, PRD @D80458, 
      AGR [CASE @D80457, COUNT @D80456, PER @D80455, PLU @D80454, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LIFT, 
   [COORD @D80465, PRD @D80464, AGR [CASE @D80463, COUNT @D80462, 
            PER @D80461, PLU @D80460, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIFT, 
   [COORD @D80471, PRD @D80470, 
      AGR [CASE @D80469, COUNT @D80468, PER @D80467, PLU @D80466, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIFT.

WORD lifts : 
   [COORD @D80484, DEMON @D80483, REFL @D80482, PRD @D80481, CASE 
         @D80480, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LIFT, 
   [COORD @D80486, 
      AGR [COUNT @D80485, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIFT, 
   [COORD @D80488, 
      AGR [COUNT @D80487, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIFT, 
   [COORD @D80490, 
      AGR [COUNT @D80489, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIFT, 
   [COORD @D80492, 
      AGR [COUNT @D80491, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIFT, 
   [COORD @D80494, 
      AGR [COUNT @D80493, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIFT, 
   [COORD @D80496, 
      AGR [COUNT @D80495, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIFT.

WORD light : 
   [COORD @D80505, AGR [COUNT @D80504, PER @D80503, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LIGHT, 
   [COORD @D80507, AGR [COUNT @D80506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LIGHT, 
   [COORD @D80509, AGR [COUNT @D80508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : LIGHT, 
   [COORD @D80513, AGR [COUNT @D80512, PER @D80511, PLU @D80510, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : LIGHT, 
   [COORD @D80519, PAST @D80518, 
      AGR [CASE @D80517, COUNT @D80516, PER @D80515, PLU @D80514, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   LIGHT, 
   [COORD @D80522, AGR [COUNT @D80521, PER @D80520, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LIGHT, 
   [COORD @D80524, AGR [COUNT @D80523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LIGHT, 
   [COORD @D80526, AGR [COUNT @D80525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LIGHT, 
   [COORD @D80530, AGR [COUNT @D80529, PER @D80528, PLU @D80527, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : LIGHT, 
   [COORD @D80536, PAST @D80535, AGR [CASE @D80534, COUNT @D80533, 
            PER @D80532, PLU @D80531, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : LIGHT, 
   [COORD @D80539, AGR [COUNT @D80538, PER @D80537, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80541, AGR [COUNT @D80540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80543, AGR [COUNT @D80542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80547, AGR [COUNT @D80546, PER @D80545, PLU @D80544, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80553, PAST @D80552, 
      AGR [CASE @D80551, COUNT @D80550, PER @D80549, PLU @D80548, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      ARITY 2] : LIGHT, 
   [COORD @D80556, AGR [COUNT @D80555, PER @D80554, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80558, AGR [COUNT @D80557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80560, AGR [COUNT @D80559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80564, AGR [COUNT @D80563, PER @D80562, PLU @D80561, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : LIGHT, 
   [COORD @D80570, PAST @D80569, 
      AGR [CASE @D80568, COUNT @D80567, PER @D80566, PLU @D80565, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM UPON, 
      ARITY 2] : LIGHT, 
   [COORD @D80573, AGR [COUNT @D80572, PER @D80571, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : LIGHT, 
   [COORD @D80575, AGR [COUNT @D80574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : LIGHT, 
   [COORD @D80577, AGR [COUNT @D80576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : LIGHT, 
   [COORD @D80581, AGR [COUNT @D80580, PER @D80579, PLU @D80578, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : LIGHT, 
   [COORD @D80587, PAST @D80586, AGR [CASE @D80585, COUNT @D80584, 
            PER @D80583, PLU @D80582, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM ON, ARITY 2] : LIGHT, 
   [COORD @D80590, 
      AGR [COUNT @D80589, PER @D80588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM FOR, ARITY 2] : LIGHT, 
   [COORD @D80592, AGR [COUNT @D80591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : LIGHT, 
   [COORD @D80594, AGR [COUNT @D80593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : LIGHT, 
   [COORD @D80598, AGR [COUNT @D80597, PER @D80596, PLU @D80595, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM FOR, ARITY 2] : LIGHT, 
   [COORD @D80604, PAST @D80603, 
      AGR [CASE @D80602, COUNT @D80601, PER @D80600, PLU @D80599, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM FOR, ARITY 2] : LIGHT, 
   [COORD @D80607, AGR [COUNT @D80606, PER @D80605, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LIGHT, 
   [COORD @D80609, AGR [COUNT @D80608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LIGHT, 
   [COORD @D80611, AGR [COUNT @D80610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LIGHT, 
   [COORD @D80615, AGR [COUNT @D80614, PER @D80613, PLU @D80612, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : LIGHT, 
   [COORD @D80621, PAST @D80620, 
      AGR [CASE @D80619, COUNT @D80618, PER @D80617, PLU @D80616, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : LIGHT, 
   [COORD @D80624, AGR [COUNT @D80623, PER @D80622, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LIGHT, 
   [COORD @D80626, AGR [COUNT @D80625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LIGHT, 
   [COORD @D80628, AGR [COUNT @D80627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LIGHT, 
   [COORD @D80632, AGR [COUNT @D80631, PER @D80630, PLU @D80629, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : LIGHT, 
   [COORD @D80638, PAST @D80637, 
      AGR [CASE @D80636, COUNT @D80635, PER @D80634, PLU @D80633, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   LIGHT, 
   [COORD @D80641, AGR [COUNT @D80640, PER @D80639, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIGHT, 
   [COORD @D80643, AGR [COUNT @D80642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIGHT, 
   [COORD @D80645, AGR [COUNT @D80644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIGHT, 
   [COORD @D80649, AGR [COUNT @D80648, PER @D80647, PLU @D80646, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LIGHT, 
   [COORD @D80655, PAST @D80654, 
      AGR [CASE @D80653, COUNT @D80652, PER @D80651, PLU @D80650, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : LIGHT, 
   [COORD @D80658, AGR [COUNT @D80657, PER @D80656, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIGHT, 
   [COORD @D80660, AGR [COUNT @D80659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIGHT, 
   [COORD @D80662, AGR [COUNT @D80661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIGHT, 
   [COORD @D80666, AGR [COUNT @D80665, PER @D80664, PLU @D80663, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIGHT, 
   [COORD @D80672, PAST @D80671, 
      AGR [CASE @D80670, COUNT @D80669, PER @D80668, PLU @D80667, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : LIGHT.

WORD lighting : 
   [COORD @D80685, REFL @D80684, PRD @D80683, CASE @D80682, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : LIGHTING, 
   [COORD @D80691, PRD @D80690, 
      AGR [CASE @D80689, COUNT @D80688, PER @D80687, PLU @D80686, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LIGHT, 
   [COORD @D80697, PRD @D80696, AGR [CASE @D80695, COUNT @D80694, 
            PER @D80693, PLU @D80692, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80703, PRD @D80702, 
      AGR [CASE @D80701, COUNT @D80700, PER @D80699, PLU @D80698, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LIGHT, 
   [COORD @D80709, PRD @D80708, AGR [CASE @D80707, COUNT @D80706, 
            PER @D80705, PLU @D80704, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80715, PRD @D80714, 
      AGR [CASE @D80713, COUNT @D80712, PER @D80711, PLU @D80710, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIGHT, 
   [COORD @D80721, PRD @D80720, AGR [CASE @D80719, COUNT @D80718, 
            PER @D80717, PLU @D80716, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80727, PRD @D80726, 
      AGR [CASE @D80725, COUNT @D80724, PER @D80723, PLU @D80722, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIGHT, 
   [COORD @D80733, PRD @D80732, AGR [CASE @D80731, COUNT @D80730, 
            PER @D80729, PLU @D80728, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80739, PRD @D80738, 
      AGR [CASE @D80737, COUNT @D80736, PER @D80735, PLU @D80734, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIGHT, 
   [COORD @D80745, PRD @D80744, AGR [CASE @D80743, COUNT @D80742, 
            PER @D80741, PLU @D80740, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIGHT.

WORD lights : 
   [COORD @D80765, AGR [COUNT @D80764, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80767, 
      AGR [COUNT @D80766, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80769, 
      AGR [COUNT @D80768, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80771, 
      AGR [COUNT @D80770, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80773, 
      AGR [COUNT @D80772, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80775, 
      AGR [COUNT @D80774, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LIGHT, 
   [COORD @D80777, AGR [COUNT @D80776, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80779, 
      AGR [COUNT @D80778, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80781, 
      AGR [COUNT @D80780, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT, 
   [COORD @D80783, 
      AGR [COUNT @D80782, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIGHT.

WORD like : 
   [COORD @D80800, NEG @D80799, PRD @D80798, FIX NOT, INFL +, BAR 0, N -, 
      V -, PRO -, CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, 
      SUBCAT SFIN, PFORM NORM] : LIKE, 
   [MODTYPE @D80804, COORD @D80803, NEG @D80802, PRD @D80801, FIX NOT, 
      INFL +, BAR 0, V -, N -, SUBCAT NP, PRO -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, LOC -, PFORM NORM] : LIKE, 
   [MODTYPE @D80808, COORD @D80807, NEG @D80806, PRD @D80805, FIX NOT, 
      INFL +, BAR 0, V -, N -, SUBCAT NP, PRO -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, LOC -, PFORM LIKE] : LIKE, 
   [COORD @D80811, AGR [COUNT @D80810, PER @D80809, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LIKE, 
   [COORD @D80813, AGR [COUNT @D80812, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LIKE, 
   [COORD @D80815, AGR [COUNT @D80814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LIKE, 
   [COORD @D80819, AGR [COUNT @D80818, PER @D80817, PLU @D80816, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LIKE, 
   [COORD @D80825, PAST @D80824, AGR [CASE @D80823, COUNT @D80822, 
            PER @D80821, PLU @D80820, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SINF, ARITY 2] : LIKE, 
   [COORD @D80828, AGR [COUNT @D80827, PER @D80826, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LIKE, 
   [COORD @D80830, AGR [COUNT @D80829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LIKE, 
   [COORD @D80832, AGR [COUNT @D80831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LIKE, 
   [COORD @D80836, AGR [COUNT @D80835, PER @D80834, PLU @D80833, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LIKE, 
   [COORD @D80842, PAST @D80841, AGR [CASE @D80840, COUNT @D80839, 
            PER @D80838, PLU @D80837, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : LIKE, 
   [COORD @D80845, AGR [COUNT @D80844, PER @D80843, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LIKE, 
   [COORD @D80847, AGR [COUNT @D80846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LIKE, 
   [COORD @D80849, AGR [COUNT @D80848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LIKE, 
   [COORD @D80853, AGR [COUNT @D80852, PER @D80851, PLU @D80850, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LIKE, 
   [COORD @D80859, PAST @D80858, AGR [CASE @D80857, COUNT @D80856, 
            PER @D80855, PLU @D80854, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : LIKE, 
   [COORD @D80862, AGR [COUNT @D80861, PER @D80860, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : LIKE, 
   [COORD @D80864, AGR [COUNT @D80863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : LIKE, 
   [COORD @D80866, AGR [COUNT @D80865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : LIKE, 
   [COORD @D80870, AGR [COUNT @D80869, PER @D80868, PLU @D80867, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : LIKE, 
   [COORD @D80876, PAST @D80875, AGR [CASE @D80874, COUNT @D80873, 
            PER @D80872, PLU @D80871, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : LIKE, 
   [COORD @D80879, AGR [COUNT @D80878, PER @D80877, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LIKE, 
   [COORD @D80881, AGR [COUNT @D80880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LIKE, 
   [COORD @D80883, AGR [COUNT @D80882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LIKE, 
   [COORD @D80887, AGR [COUNT @D80886, PER @D80885, PLU @D80884, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LIKE, 
   [COORD @D80893, PAST @D80892, AGR [CASE @D80891, COUNT @D80890, 
            PER @D80889, PLU @D80888, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : LIKE, 
   [COORD @D80896, AGR [COUNT @D80895, PER @D80894, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIKE, 
   [COORD @D80898, AGR [COUNT @D80897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIKE, 
   [COORD @D80900, AGR [COUNT @D80899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIKE, 
   [COORD @D80904, AGR [COUNT @D80903, PER @D80902, PLU @D80901, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LIKE, 
   [COORD @D80910, PAST @D80909, AGR [CASE @D80908, COUNT @D80907, 
            PER @D80906, PLU @D80905, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LIKE.

WORD liked : 
   [COORD @D80925, AGR [CASE @D80924, COUNT @D80923, PER @D80922, 
            PLU @D80921, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80930, AGR [CASE @D80929, COUNT @D80928, PER @D80927, 
            PLU @D80926, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80935, AGR [CASE @D80934, COUNT @D80933, PER @D80932, 
            PLU @D80931, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80940, AGR [CASE @D80939, COUNT @D80938, PER @D80937, 
            PLU @D80936, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80945, AGR [CASE @D80944, COUNT @D80943, PER @D80942, 
            PLU @D80941, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80950, AGR [CASE @D80949, COUNT @D80948, PER @D80947, 
            PLU @D80946, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80955, AGR [CASE @D80954, COUNT @D80953, PER @D80952, 
            PLU @D80951, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIKE, 
   [COORD @D80960, AGR [CASE @D80959, COUNT @D80958, PER @D80957, 
            PLU @D80956, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80965, AGR [CASE @D80964, COUNT @D80963, PER @D80962, 
            PLU @D80961, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80970, AGR [CASE @D80969, COUNT @D80968, PER @D80967, 
            PLU @D80966, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80975, AGR [CASE @D80974, COUNT @D80973, PER @D80972, 
            PLU @D80971, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIKE, 
   [COORD @D80981, AGR [CASE @D80980, NFORM @D80979, COUNT @D80978, 
            PER @D80977, PLU @D80976, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIKE, 
   [COORD @D80986, AGR [UB @D80985, VFORM @D80984, SUBJ @D80983, 
            FIN @D80982, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LIKE, 
   [COORD @D80991, AGR [CASE @D80990, COUNT @D80989, PER @D80988, 
            PLU @D80987, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIKE, 
   [COORD @D80996, AGR [CASE @D80995, COUNT @D80994, PER @D80993, 
            PLU @D80992, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D81001, AGR [CASE @D81000, COUNT @D80999, PER @D80998, 
            PLU @D80997, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIKE.

WORD likes : 
   [COORD @D81013, AGR [COUNT @D81012, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIKE, 
   [COORD @D81015, 
      AGR [COUNT @D81014, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIKE, 
   [COORD @D81017, 
      AGR [COUNT @D81016, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIKE, 
   [COORD @D81019, 
      AGR [COUNT @D81018, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIKE, 
   [COORD @D81021, 
      AGR [COUNT @D81020, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIKE, 
   [COORD @D81023, 
      AGR [COUNT @D81022, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIKE.

WORD liking : 
   [COORD @D81037, PRD @D81036, AGR [CASE @D81035, COUNT @D81034, 
            PER @D81033, PLU @D81032, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D81043, PRD @D81042, 
      AGR [CASE @D81041, COUNT @D81040, PER @D81039, PLU @D81038, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LIKE, 
   [COORD @D81049, PRD @D81048, AGR [CASE @D81047, COUNT @D81046, 
            PER @D81045, PLU @D81044, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D81055, PRD @D81054, 
      AGR [CASE @D81053, COUNT @D81052, PER @D81051, PLU @D81050, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LIKE, 
   [COORD @D81061, PRD @D81060, AGR [CASE @D81059, COUNT @D81058, 
            PER @D81057, PLU @D81056, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIKE, 
   [COORD @D81067, PRD @D81066, 
      AGR [CASE @D81065, COUNT @D81064, PER @D81063, PLU @D81062, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LIKE.

WORD limb : 
   [COORD @D81077, REFL @D81076, PRD @D81075, CASE @D81074, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LIMB.

WORD limbs : 
   [COORD @D81089, DEMON @D81088, REFL @D81087, PRD @D81086, CASE 
         @D81085, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LIMB.

WORD limit : 
   [COORD @D81100, REFL @D81099, COUNT @D81098, PRD @D81097, CASE 
         @D81096, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LIMIT, 
   [COORD @D81104, REFL @D81103, PRD @D81102, CASE @D81101, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LIMIT, 
   [COORD @D81108, REFL @D81107, PRD @D81106, CASE @D81105, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : LIMIT, 
   [COORD @D81111, 
      AGR [COUNT @D81110, PER @D81109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : LIMIT, 
   [COORD @D81113, AGR [COUNT @D81112, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : LIMIT, 
   [COORD @D81115, AGR [COUNT @D81114, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : LIMIT, 
   [COORD @D81119, AGR [COUNT @D81118, PER @D81117, PLU @D81116, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : LIMIT, 
   [COORD @D81125, PAST @D81124, 
      AGR [CASE @D81123, COUNT @D81122, PER @D81121, PLU @D81120, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : LIMIT, 
   [COORD @D81128, AGR [COUNT @D81127, PER @D81126, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIMIT, 
   [COORD @D81130, AGR [COUNT @D81129, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIMIT, 
   [COORD @D81132, AGR [COUNT @D81131, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIMIT, 
   [COORD @D81136, AGR [COUNT @D81135, PER @D81134, PLU @D81133, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LIMIT, 
   [COORD @D81142, PAST @D81141, AGR [CASE @D81140, COUNT @D81139, 
            PER @D81138, PLU @D81137, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LIMIT.

WORD limited : 
   [COADV @D81158, COORD @D81157, DEF @D81156, PRD @D81155, AGR 
            [CASE @D81154, COUNT @D81153, PER @D81152, PLU @D81151, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   LIMITED, 
   [COADV @D81166, COORD @D81165, DEF @D81164, PRD @D81163, AGR 
            [CASE @D81162, COUNT @D81161, PER @D81160, PLU @D81159, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PST] : LIMITED, 
   [COADV @D81174, COORD @D81173, DEF @D81172, PRD @D81171, 
      AGR [CASE @D81170, COUNT @D81169, PER @D81168, PLU @D81167, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : LIMITED, 
   [COORD @D81179, AGR [CASE @D81178, COUNT @D81177, PER @D81176, 
            PLU @D81175, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81184, AGR [CASE @D81183, COUNT @D81182, PER @D81181, 
            PLU @D81180, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81189, AGR [CASE @D81188, COUNT @D81187, PER @D81186, 
            PLU @D81185, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81194, AGR [CASE @D81193, COUNT @D81192, PER @D81191, 
            PLU @D81190, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIMIT, 
   [COORD @D81199, AGR [CASE @D81198, COUNT @D81197, PER @D81196, 
            PLU @D81195, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81204, AGR [CASE @D81203, COUNT @D81202, PER @D81201, 
            PLU @D81200, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIMIT.

WORD limits : 
   [COORD @D81217, DEMON @D81216, REFL @D81215, PRD @D81214, CASE 
         @D81213, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LIMIT, 
   [COORD @D81222, DEMON @D81221, REFL @D81220, PRD @D81219, 
      CASE @D81218, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : LIMIT, 
   [COORD @D81227, DEMON @D81226, REFL @D81225, PRD @D81224, 
      CASE @D81223, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   LIMIT, 
   [COORD @D81229, AGR [COUNT @D81228, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81231, 
      AGR [COUNT @D81230, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIMIT.

WORD limitted : 
   [COORD @D81244, AGR [CASE @D81243, COUNT @D81242, PER @D81241, 
            PLU @D81240, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81249, AGR [CASE @D81248, COUNT @D81247, PER @D81246, 
            PLU @D81245, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81254, AGR [CASE @D81253, COUNT @D81252, PER @D81251, 
            PLU @D81250, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81259, AGR [CASE @D81258, COUNT @D81257, PER @D81256, 
            PLU @D81255, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIMIT, 
   [COORD @D81264, AGR [CASE @D81263, COUNT @D81262, PER @D81261, 
            PLU @D81260, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81269, AGR [CASE @D81268, COUNT @D81267, PER @D81266, 
            PLU @D81265, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIMIT.

WORD limitting : 
   [COORD @D81287, PRD @D81286, AGR [CASE @D81285, COUNT @D81284, 
            PER @D81283, PLU @D81282, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIMIT, 
   [COORD @D81293, PRD @D81292, 
      AGR [CASE @D81291, COUNT @D81290, PER @D81289, PLU @D81288, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LIMIT.

WORD link : 
   [COORD @D81303, REFL @D81302, PRD @D81301, CASE @D81300, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LINK, 
   [COORD @D81306, 
      AGR [COUNT @D81305, PER @D81304, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   LINK, 
   [COORD @D81308, AGR [COUNT @D81307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LINK, 
   [COORD @D81310, AGR [COUNT @D81309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LINK, 
   [COORD @D81314, AGR [COUNT @D81313, PER @D81312, PLU @D81311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LINK, 
   [COORD @D81320, PAST @D81319, AGR [CASE @D81318, COUNT @D81317, 
            PER @D81316, PLU @D81315, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LINK, 
   [COORD @D81323, AGR [COUNT @D81322, PER @D81321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : LINK, 
   [COORD @D81325, AGR [COUNT @D81324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : LINK, 
   [COORD @D81327, AGR [COUNT @D81326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : LINK, 
   [COORD @D81331, AGR [COUNT @D81330, PER @D81329, PLU @D81328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : LINK, 
   [COORD @D81337, PAST @D81336, 
      AGR [CASE @D81335, COUNT @D81334, PER @D81333, PLU @D81332, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : LINK, 
   [COORD @D81340, AGR [COUNT @D81339, PER @D81338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LINK, 
   [COORD @D81342, AGR [COUNT @D81341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LINK, 
   [COORD @D81344, AGR [COUNT @D81343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LINK, 
   [COORD @D81348, AGR [COUNT @D81347, PER @D81346, PLU @D81345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LINK, 
   [COORD @D81354, PAST @D81353, AGR [CASE @D81352, COUNT @D81351, 
            PER @D81350, PLU @D81349, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LINK, 
   [COORD @D81357, AGR [COUNT @D81356, PER @D81355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LINK, 
   [COORD @D81359, AGR [COUNT @D81358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LINK, 
   [COORD @D81361, AGR [COUNT @D81360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LINK, 
   [COORD @D81365, AGR [COUNT @D81364, PER @D81363, PLU @D81362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LINK, 
   [COORD @D81371, PAST @D81370, 
      AGR [CASE @D81369, COUNT @D81368, PER @D81367, PLU @D81366, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : LINK, 
   [COORD @D81374, AGR [COUNT @D81373, PER @D81372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LINK, 
   [COORD @D81376, AGR [COUNT @D81375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LINK, 
   [COORD @D81378, AGR [COUNT @D81377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LINK, 
   [COORD @D81382, AGR [COUNT @D81381, PER @D81380, PLU @D81379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LINK, 
   [COORD @D81388, PAST @D81387, 
      AGR [CASE @D81386, COUNT @D81385, PER @D81384, PLU @D81383, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, 
      ARITY 1] : LINK.

WORD linked : 
   [COORD @D81401, AGR [CASE @D81400, COUNT @D81399, PER @D81398, 
            PLU @D81397, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LINK, 
   [COORD @D81406, AGR [CASE @D81405, COUNT @D81404, PER @D81403, 
            PLU @D81402, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81411, AGR [CASE @D81410, COUNT @D81409, PER @D81408, 
            PLU @D81407, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LINK, 
   [COORD @D81416, AGR [CASE @D81415, COUNT @D81414, PER @D81413, 
            PLU @D81412, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81421, AGR [CASE @D81420, COUNT @D81419, PER @D81418, 
            PLU @D81417, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81426, AGR [CASE @D81425, COUNT @D81424, PER @D81423, 
            PLU @D81422, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LINK, 
   [COORD @D81431, AGR [CASE @D81430, COUNT @D81429, PER @D81428, 
            PLU @D81427, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81436, AGR [CASE @D81435, COUNT @D81434, PER @D81433, 
            PLU @D81432, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LINK, 
   [COORD @D81441, AGR [CASE @D81440, COUNT @D81439, PER @D81438, 
            PLU @D81437, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81446, AGR [CASE @D81445, COUNT @D81444, PER @D81443, 
            PLU @D81442, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LINK, 
   [COORD @D81451, AGR [CASE @D81450, COUNT @D81449, PER @D81448, 
            PLU @D81447, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81456, AGR [CASE @D81455, COUNT @D81454, PER @D81453, 
            PLU @D81452, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LINK.

WORD linking : 
   [COORD @D81474, PRD @D81473, AGR [CASE @D81472, COUNT @D81471, 
            PER @D81470, PLU @D81469, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81480, PRD @D81479, 
      AGR [CASE @D81478, COUNT @D81477, PER @D81476, PLU @D81475, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LINK, 
   [COORD @D81486, PRD @D81485, AGR [CASE @D81484, COUNT @D81483, 
            PER @D81482, PLU @D81481, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LINK, 
   [COORD @D81492, PRD @D81491, 
      AGR [CASE @D81490, COUNT @D81489, PER @D81488, PLU @D81487, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LINK, 
   [COORD @D81498, PRD @D81497, AGR [CASE @D81496, COUNT @D81495, 
            PER @D81494, PLU @D81493, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LINK.

WORD links : 
   [COORD @D81510, REFL @D81509, PRD @D81508, CASE @D81507, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LINKS, 
   [COORD @D81514, REFL @D81513, PRD @D81512, CASE @D81511, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : LINKS, 
   [COORD @D81519, DEMON @D81518, REFL @D81517, PRD @D81516, 
      CASE @D81515, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LINK, 
   [COORD @D81521, 
      AGR [COUNT @D81520, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LINK, 
   [COORD @D81523, 
      AGR [COUNT @D81522, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LINK, 
   [COORD @D81525, 
      AGR [COUNT @D81524, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LINK, 
   [COORD @D81527, 
      AGR [COUNT @D81526, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LINK, 
   [COORD @D81529, 
      AGR [COUNT @D81528, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LINK.

WORD list : 
   [COORD @D81551, AGR [COUNT @D81550, PER @D81549, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIST, 
   [COORD @D81553, AGR [COUNT @D81552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIST, 
   [COORD @D81555, AGR [COUNT @D81554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIST, 
   [COORD @D81559, AGR [COUNT @D81558, PER @D81557, PLU @D81556, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LIST, 
   [COORD @D81565, PAST @D81564, AGR [CASE @D81563, COUNT @D81562, 
            PER @D81561, PLU @D81560, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LIST, 
   [COORD @D81568, AGR [COUNT @D81567, PER @D81566, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : LIST, 
   [COORD @D81570, AGR [COUNT @D81569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : LIST, 
   [COORD @D81572, AGR [COUNT @D81571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : LIST, 
   [COORD @D81576, AGR [COUNT @D81575, PER @D81574, PLU @D81573, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : LIST, 
   [COORD @D81582, PAST @D81581, 
      AGR [CASE @D81580, COUNT @D81579, PER @D81578, PLU @D81577, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : LIST, 
   [COORD @D81585, AGR [COUNT @D81584, PER @D81583, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIST, 
   [COORD @D81587, AGR [COUNT @D81586, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIST, 
   [COORD @D81589, AGR [COUNT @D81588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIST, 
   [COORD @D81593, AGR [COUNT @D81592, PER @D81591, PLU @D81590, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIST, 
   [COORD @D81599, PAST @D81598, AGR [CASE @D81597, COUNT @D81596, 
            PER @D81595, PLU @D81594, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LIST.

WORD listed : 
   [COORD @D81611, AGR [CASE @D81610, COUNT @D81609, PER @D81608, 
            PLU @D81607, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIST, 
   [COORD @D81616, AGR [CASE @D81615, COUNT @D81614, PER @D81613, 
            PLU @D81612, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIST, 
   [COORD @D81621, AGR [CASE @D81620, COUNT @D81619, PER @D81618, 
            PLU @D81617, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIST, 
   [COORD @D81626, AGR [CASE @D81625, COUNT @D81624, PER @D81623, 
            PLU @D81622, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIST, 
   [COORD @D81631, AGR [CASE @D81630, COUNT @D81629, PER @D81628, 
            PLU @D81627, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIST, 
   [COORD @D81636, AGR [CASE @D81635, COUNT @D81634, PER @D81633, 
            PLU @D81632, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIST, 
   [COORD @D81641, AGR [CASE @D81640, COUNT @D81639, PER @D81638, 
            PLU @D81637, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIST.

WORD listing : 
   [COORD @D81656, PRD @D81655, AGR [CASE @D81654, COUNT @D81653, 
            PER @D81652, PLU @D81651, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIST, 
   [COORD @D81662, PRD @D81661, 
      AGR [CASE @D81660, COUNT @D81659, PER @D81658, PLU @D81657, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIST, 
   [COORD @D81668, PRD @D81667, AGR [CASE @D81666, COUNT @D81665, 
            PER @D81664, PLU @D81663, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIST.

WORD lists : 
   [COORD @D81677, AGR [COUNT @D81676, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIST, 
   [COORD @D81679, 
      AGR [COUNT @D81678, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIST, 
   [COORD @D81681, 
      AGR [COUNT @D81680, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIST.

WORD live : 
   [COORD @D81697, AGR [COUNT @D81696, PER @D81695, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIVE, 
   [COORD @D81699, AGR [COUNT @D81698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIVE, 
   [COORD @D81701, AGR [COUNT @D81700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LIVE, 
   [COORD @D81705, AGR [COUNT @D81704, PER @D81703, PLU @D81702, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LIVE, 
   [COORD @D81711, PAST @D81710, AGR [CASE @D81709, COUNT @D81708, 
            PER @D81707, PLU @D81706, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LIVE, 
   [COORD @D81714, AGR [COUNT @D81713, PER @D81712, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LIVE, 
   [COORD @D81716, AGR [COUNT @D81715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LIVE, 
   [COORD @D81718, AGR [COUNT @D81717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LIVE, 
   [COORD @D81722, AGR [COUNT @D81721, PER @D81720, PLU @D81719, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : LIVE, 
   [COORD @D81728, PAST @D81727, AGR [CASE @D81726, COUNT @D81725, 
            PER @D81724, PLU @D81723, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : LIVE, 
   [COORD @D81731, AGR [COUNT @D81730, PER @D81729, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : LIVE, 
   [COORD @D81733, AGR [COUNT @D81732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : LIVE, 
   [COORD @D81735, AGR [COUNT @D81734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : LIVE, 
   [COORD @D81739, AGR [COUNT @D81738, PER @D81737, PLU @D81736, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : LIVE, 
   [COORD @D81745, PAST @D81744, 
      AGR [CASE @D81743, COUNT @D81742, PER @D81741, PLU @D81740, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP BY, ARITY 2] : LIVE, 
   [COORD @D81748, AGR [COUNT @D81747, PER @D81746, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : LIVE, 
   [COORD @D81750, AGR [COUNT @D81749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : LIVE, 
   [COORD @D81752, AGR [COUNT @D81751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : LIVE, 
   [COORD @D81756, AGR [COUNT @D81755, PER @D81754, PLU @D81753, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : LIVE, 
   [COORD @D81762, PAST @D81761, 
      AGR [CASE @D81760, COUNT @D81759, PER @D81758, PLU @D81757, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      ARITY 2] : LIVE, 
   [COORD @D81765, AGR [COUNT @D81764, PER @D81763, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : LIVE, 
   [COORD @D81767, AGR [COUNT @D81766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : LIVE, 
   [COORD @D81769, AGR [COUNT @D81768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : LIVE, 
   [COORD @D81773, AGR [COUNT @D81772, PER @D81771, PLU @D81770, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : LIVE, 
   [COORD @D81779, PAST @D81778, 
      AGR [CASE @D81777, COUNT @D81776, PER @D81775, PLU @D81774, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, 
      ARITY 2] : LIVE, 
   [COORD @D81782, AGR [COUNT @D81781, PER @D81780, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LIVE, 
   [COORD @D81784, AGR [COUNT @D81783, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LIVE, 
   [COORD @D81786, AGR [COUNT @D81785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LIVE, 
   [COORD @D81790, AGR [COUNT @D81789, PER @D81788, PLU @D81787, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, ARITY 2] : LIVE, 
   [COORD @D81796, PAST @D81795, 
      AGR [CASE @D81794, COUNT @D81793, PER @D81792, PLU @D81791, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, 
      ARITY 2] : LIVE, 
   [COORD @D81799, AGR [COUNT @D81798, PER @D81797, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : LIVE, 
   [COORD @D81801, AGR [COUNT @D81800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : LIVE, 
   [COORD @D81803, AGR [COUNT @D81802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : LIVE, 
   [COORD @D81807, AGR [COUNT @D81806, PER @D81805, PLU @D81804, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : LIVE, 
   [COORD @D81813, PAST @D81812, 
      AGR [CASE @D81811, COUNT @D81810, PER @D81809, PLU @D81808, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : LIVE, 
   [COORD @D81816, AGR [COUNT @D81815, PER @D81814, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OFF, ARITY 2] : LIVE, 
   [COORD @D81818, AGR [COUNT @D81817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OFF, ARITY 2] : LIVE, 
   [COORD @D81820, AGR [COUNT @D81819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OFF, ARITY 2] : LIVE, 
   [COORD @D81824, AGR [COUNT @D81823, PER @D81822, PLU @D81821, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OFF, ARITY 2] : LIVE, 
   [COORD @D81830, PAST @D81829, 
      AGR [CASE @D81828, COUNT @D81827, PER @D81826, PLU @D81825, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM OFF, 
      ARITY 2] : LIVE, 
   [COORD @D81833, AGR [COUNT @D81832, PER @D81831, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : LIVE, 
   [COORD @D81835, AGR [COUNT @D81834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : LIVE, 
   [COORD @D81837, AGR [COUNT @D81836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : LIVE, 
   [COORD @D81841, AGR [COUNT @D81840, PER @D81839, PLU @D81838, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : LIVE, 
   [COORD @D81847, PAST @D81846, 
      AGR [CASE @D81845, COUNT @D81844, PER @D81843, PLU @D81842, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : LIVE, 
   [COORD @D81850, AGR [COUNT @D81849, PER @D81848, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : LIVE, 
   [COORD @D81852, AGR [COUNT @D81851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : LIVE, 
   [COORD @D81854, AGR [COUNT @D81853, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : LIVE, 
   [COORD @D81858, AGR [COUNT @D81857, PER @D81856, PLU @D81855, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM BY, ARITY 2] : LIVE, 
   [COORD @D81864, PAST @D81863, 
      AGR [CASE @D81862, COUNT @D81861, PER @D81860, PLU @D81859, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM BY, 
      ARITY 2] : LIVE, 
   [COORD @D81867, AGR [COUNT @D81866, PER @D81865, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LIVE, 
   [COORD @D81869, AGR [COUNT @D81868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LIVE, 
   [COORD @D81871, AGR [COUNT @D81870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LIVE, 
   [COORD @D81875, AGR [COUNT @D81874, PER @D81873, PLU @D81872, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : LIVE, 
   [COORD @D81881, PAST @D81880, 
      AGR [CASE @D81879, COUNT @D81878, PER @D81877, PLU @D81876, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : LIVE, 
   [COORD @D81884, AGR [COUNT @D81883, PER @D81882, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LIVE, 
   [COORD @D81886, AGR [COUNT @D81885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LIVE, 
   [COORD @D81888, AGR [COUNT @D81887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LIVE, 
   [COORD @D81892, AGR [COUNT @D81891, PER @D81890, PLU @D81889, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : LIVE, 
   [COORD @D81898, PAST @D81897, 
      AGR [CASE @D81896, COUNT @D81895, PER @D81894, PLU @D81893, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : LIVE, 
   [COORD @D81901, AGR [COUNT @D81900, PER @D81899, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIVE, 
   [COORD @D81903, AGR [COUNT @D81902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIVE, 
   [COORD @D81905, AGR [COUNT @D81904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIVE, 
   [COORD @D81909, AGR [COUNT @D81908, PER @D81907, PLU @D81906, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LIVE, 
   [COORD @D81915, PAST @D81914, AGR [CASE @D81913, COUNT @D81912, 
            PER @D81911, PLU @D81910, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LIVE, 
   [COORD @D81918, AGR [COUNT @D81917, PER @D81916, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LIVE, 
   [COORD @D81920, AGR [COUNT @D81919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LIVE, 
   [COORD @D81922, AGR [COUNT @D81921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LIVE, 
   [COORD @D81926, AGR [COUNT @D81925, PER @D81924, PLU @D81923, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : LIVE, 
   [COORD @D81932, PAST @D81931, 
      AGR [CASE @D81930, COUNT @D81929, PER @D81928, PLU @D81927, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, 
      ARITY 1] : LIVE, 
   [COORD @D81935, AGR [COUNT @D81934, PER @D81933, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIVE, 
   [COORD @D81937, AGR [COUNT @D81936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIVE, 
   [COORD @D81939, AGR [COUNT @D81938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIVE, 
   [COORD @D81943, AGR [COUNT @D81942, PER @D81941, PLU @D81940, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LIVE, 
   [COORD @D81949, PAST @D81948, 
      AGR [CASE @D81947, COUNT @D81946, PER @D81945, PLU @D81944, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : LIVE, 
   [COORD @D81952, AGR [COUNT @D81951, PER @D81950, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LIVE, 
   [COORD @D81954, AGR [COUNT @D81953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LIVE, 
   [COORD @D81956, AGR [COUNT @D81955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LIVE, 
   [COORD @D81960, AGR [COUNT @D81959, PER @D81958, PLU @D81957, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LIVE, 
   [COORD @D81966, PAST @D81965, 
      AGR [CASE @D81964, COUNT @D81963, PER @D81962, PLU @D81961, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : LIVE, 
   [COORD @D81969, AGR [COUNT @D81968, PER @D81967, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LIVE, 
   [COORD @D81971, AGR [COUNT @D81970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LIVE, 
   [COORD @D81973, AGR [COUNT @D81972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LIVE, 
   [COORD @D81977, AGR [COUNT @D81976, PER @D81975, PLU @D81974, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LIVE, 
   [COORD @D81983, PAST @D81982, 
      AGR [CASE @D81981, COUNT @D81980, PER @D81979, PLU @D81978, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : LIVE, 
   [COORD @D81986, AGR [COUNT @D81985, PER @D81984, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LIVE, 
   [COORD @D81988, AGR [COUNT @D81987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LIVE, 
   [COORD @D81990, AGR [COUNT @D81989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LIVE, 
   [COORD @D81994, AGR [COUNT @D81993, PER @D81992, PLU @D81991, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : LIVE, 
   [COORD @D82000, PAST @D81999, 
      AGR [CASE @D81998, COUNT @D81997, PER @D81996, PLU @D81995, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : LIVE.

WORD lived : 
   [COORD @D82013, AGR [CASE @D82012, COUNT @D82011, PER @D82010, 
            PLU @D82009, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LIVE, 
   [COORD @D82018, AGR [CASE @D82017, COUNT @D82016, PER @D82015, 
            PLU @D82014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82023, AGR [CASE @D82022, COUNT @D82021, PER @D82020, 
            PLU @D82019, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82028, AGR [CASE @D82027, COUNT @D82026, PER @D82025, 
            PLU @D82024, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82033, AGR [CASE @D82032, COUNT @D82031, PER @D82030, 
            PLU @D82029, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82038, AGR [CASE @D82037, COUNT @D82036, PER @D82035, 
            PLU @D82034, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82043, AGR [CASE @D82042, COUNT @D82041, PER @D82040, 
            PLU @D82039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82048, AGR [CASE @D82047, COUNT @D82046, PER @D82045, 
            PLU @D82044, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82053, AGR [CASE @D82052, COUNT @D82051, PER @D82050, 
            PLU @D82049, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82058, AGR [CASE @D82057, COUNT @D82056, PER @D82055, 
            PLU @D82054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82063, AGR [CASE @D82062, COUNT @D82061, PER @D82060, 
            PLU @D82059, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82068, AGR [CASE @D82067, COUNT @D82066, PER @D82065, 
            PLU @D82064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82073, AGR [CASE @D82072, COUNT @D82071, PER @D82070, 
            PLU @D82069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82078, AGR [CASE @D82077, COUNT @D82076, PER @D82075, 
            PLU @D82074, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82083, AGR [CASE @D82082, COUNT @D82081, PER @D82080, 
            PLU @D82079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82088, AGR [CASE @D82087, COUNT @D82086, PER @D82085, 
            PLU @D82084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82093, AGR [CASE @D82092, COUNT @D82091, PER @D82090, 
            PLU @D82089, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82098, AGR [CASE @D82097, COUNT @D82096, PER @D82095, 
            PLU @D82094, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82103, AGR [CASE @D82102, COUNT @D82101, PER @D82100, 
            PLU @D82099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82108, AGR [CASE @D82107, COUNT @D82106, PER @D82105, 
            PLU @D82104, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82113, AGR [CASE @D82112, COUNT @D82111, PER @D82110, 
            PLU @D82109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82118, AGR [CASE @D82117, COUNT @D82116, PER @D82115, 
            PLU @D82114, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82123, AGR [CASE @D82122, COUNT @D82121, PER @D82120, 
            PLU @D82119, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82128, AGR [CASE @D82127, COUNT @D82126, PER @D82125, 
            PLU @D82124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82133, AGR [CASE @D82132, COUNT @D82131, PER @D82130, 
            PLU @D82129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82138, AGR [CASE @D82137, COUNT @D82136, PER @D82135, 
            PLU @D82134, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM BY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82143, AGR [CASE @D82142, COUNT @D82141, PER @D82140, 
            PLU @D82139, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82148, AGR [CASE @D82147, COUNT @D82146, PER @D82145, 
            PLU @D82144, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82153, AGR [CASE @D82152, COUNT @D82151, PER @D82150, 
            PLU @D82149, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82158, AGR [CASE @D82157, COUNT @D82156, PER @D82155, 
            PLU @D82154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82163, AGR [CASE @D82162, COUNT @D82161, PER @D82160, 
            PLU @D82159, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82168, AGR [CASE @D82167, COUNT @D82166, PER @D82165, 
            PLU @D82164, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82173, AGR [CASE @D82172, COUNT @D82171, PER @D82170, 
            PLU @D82169, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82178, AGR [CASE @D82177, COUNT @D82176, PER @D82175, 
            PLU @D82174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82183, AGR [CASE @D82182, COUNT @D82181, PER @D82180, 
            PLU @D82179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82188, AGR [CASE @D82187, COUNT @D82186, PER @D82185, 
            PLU @D82184, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82193, AGR [CASE @D82192, COUNT @D82191, PER @D82190, 
            PLU @D82189, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82198, AGR [CASE @D82197, COUNT @D82196, PER @D82195, 
            PLU @D82194, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82203, AGR [CASE @D82202, COUNT @D82201, PER @D82200, 
            PLU @D82199, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82208, AGR [CASE @D82207, COUNT @D82206, PER @D82205, 
            PLU @D82204, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82213, AGR [CASE @D82212, COUNT @D82211, PER @D82210, 
            PLU @D82209, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82218, AGR [CASE @D82217, COUNT @D82216, PER @D82215, 
            PLU @D82214, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82223, AGR [CASE @D82222, COUNT @D82221, PER @D82220, 
            PLU @D82219, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82228, AGR [CASE @D82227, COUNT @D82226, PER @D82225, 
            PLU @D82224, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82233, AGR [CASE @D82232, COUNT @D82231, PER @D82230, 
            PLU @D82229, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82238, AGR [CASE @D82237, COUNT @D82236, PER @D82235, 
            PLU @D82234, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LIVE.

WORD lives : 
   [COORD @D82248, AGR [COUNT @D82247, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82250, 
      AGR [COUNT @D82249, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82252, 
      AGR [COUNT @D82251, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82254, 
      AGR [COUNT @D82253, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82256, 
      AGR [COUNT @D82255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LIVE, 
   [COORD @D82258, AGR [COUNT @D82257, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82260, AGR [COUNT @D82259, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82262, AGR [COUNT @D82261, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82264, AGR [COUNT @D82263, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82266, AGR [COUNT @D82265, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82268, AGR [COUNT @D82267, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82270, 
      AGR [COUNT @D82269, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82272, 
      AGR [COUNT @D82271, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82274, 
      AGR [COUNT @D82273, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LIVE, 
   [COORD @D82276, AGR [COUNT @D82275, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82278, 
      AGR [COUNT @D82277, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82280, 
      AGR [COUNT @D82279, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE, 
   [COORD @D82282, 
      AGR [COUNT @D82281, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LIVE.

WORD living : 
   [COORD @D82295, PRD @D82294, AGR [CASE @D82293, COUNT @D82292, 
            PER @D82291, PLU @D82290, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82301, PRD @D82300, 
      AGR [CASE @D82299, COUNT @D82298, PER @D82297, PLU @D82296, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LIVE, 
   [COORD @D82307, PRD @D82306, AGR [CASE @D82305, COUNT @D82304, 
            PER @D82303, PLU @D82302, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82313, PRD @D82312, 
      AGR [CASE @D82311, COUNT @D82310, PER @D82309, PLU @D82308, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82319, PRD @D82318, AGR [CASE @D82317, COUNT @D82316, 
            PER @D82315, PLU @D82314, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82325, PRD @D82324, 
      AGR [CASE @D82323, COUNT @D82322, PER @D82321, PLU @D82320, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82331, PRD @D82330, AGR [CASE @D82329, COUNT @D82328, 
            PER @D82327, PLU @D82326, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82337, PRD @D82336, 
      AGR [CASE @D82335, COUNT @D82334, PER @D82333, PLU @D82332, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82343, PRD @D82342, AGR [CASE @D82341, COUNT @D82340, 
            PER @D82339, PLU @D82338, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82349, PRD @D82348, 
      AGR [CASE @D82347, COUNT @D82346, PER @D82345, PLU @D82344, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIVE, 
   [COORD @D82355, PRD @D82354, AGR [CASE @D82353, COUNT @D82352, 
            PER @D82351, PLU @D82350, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82361, PRD @D82360, 
      AGR [CASE @D82359, COUNT @D82358, PER @D82357, PLU @D82356, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIVE, 
   [COORD @D82367, PRD @D82366, AGR [CASE @D82365, COUNT @D82364, 
            PER @D82363, PLU @D82362, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82373, PRD @D82372, 
      AGR [CASE @D82371, COUNT @D82370, PER @D82369, PLU @D82368, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LIVE, 
   [COORD @D82379, PRD @D82378, AGR [CASE @D82377, COUNT @D82376, 
            PER @D82375, PLU @D82374, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82385, PRD @D82384, 
      AGR [CASE @D82383, COUNT @D82382, PER @D82381, PLU @D82380, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIVE, 
   [COORD @D82391, PRD @D82390, AGR [CASE @D82389, COUNT @D82388, 
            PER @D82387, PLU @D82386, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LIVE, 
   [COORD @D82397, PRD @D82396, 
      AGR [CASE @D82395, COUNT @D82394, PER @D82393, PLU @D82392, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LIVE.

WORD locate : 
   [COORD @D82404, AGR [COUNT @D82403, PER @D82402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCATE, 
   [COORD @D82406, AGR [COUNT @D82405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCATE, 
   [COORD @D82408, AGR [COUNT @D82407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCATE, 
   [COORD @D82412, AGR [COUNT @D82411, PER @D82410, PLU @D82409, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCATE, 
   [COORD @D82418, PAST @D82417, AGR [CASE @D82416, COUNT @D82415, 
            PER @D82414, PLU @D82413, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : LOCATE, 
   [COORD @D82421, AGR [COUNT @D82420, PER @D82419, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOCATE, 
   [COORD @D82423, AGR [COUNT @D82422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOCATE, 
   [COORD @D82425, AGR [COUNT @D82424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOCATE, 
   [COORD @D82429, AGR [COUNT @D82428, PER @D82427, PLU @D82426, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LOCATE, 
   [COORD @D82435, PAST @D82434, AGR [CASE @D82433, COUNT @D82432, 
            PER @D82431, PLU @D82430, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LOCATE, 
   [COORD @D82438, AGR [COUNT @D82437, PER @D82436, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LOCATE, 
   [COORD @D82440, AGR [COUNT @D82439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LOCATE, 
   [COORD @D82442, AGR [COUNT @D82441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LOCATE, 
   [COORD @D82446, AGR [COUNT @D82445, PER @D82444, PLU @D82443, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : LOCATE, 
   [COORD @D82452, PAST @D82451, AGR [CASE @D82450, COUNT @D82449, 
            PER @D82448, PLU @D82447, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : LOCATE.

WORD located : 
   [COADV @D82465, COORD @D82464, DEF @D82463, PRD @D82462, AGR 
            [CASE @D82461, COUNT @D82460, PER @D82459, PLU @D82458, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      DISTR PRD, ARITY 2] : LOCATED, 
   [COORD @D82470, AGR [CASE @D82469, COUNT @D82468, PER @D82467, 
            PLU @D82466, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOCATE, 
   [COORD @D82475, AGR [CASE @D82474, COUNT @D82473, PER @D82472, 
            PLU @D82471, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82480, AGR [CASE @D82479, COUNT @D82478, PER @D82477, 
            PLU @D82476, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82485, AGR [CASE @D82484, COUNT @D82483, PER @D82482, 
            PLU @D82481, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82490, AGR [CASE @D82489, COUNT @D82488, PER @D82487, 
            PLU @D82486, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82495, AGR [CASE @D82494, COUNT @D82493, PER @D82492, 
            PLU @D82491, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOCATE, 
   [COORD @D82500, AGR [CASE @D82499, COUNT @D82498, PER @D82497, 
            PLU @D82496, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82505, AGR [CASE @D82504, COUNT @D82503, PER @D82502, 
            PLU @D82501, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOCATE.

WORD locates : 
   [COORD @D82512, AGR [COUNT @D82511, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82514, 
      AGR [COUNT @D82513, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82516, 
      AGR [COUNT @D82515, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCATE.

WORD locating : 
   [COORD @D82526, PRD @D82525, AGR [CASE @D82524, COUNT @D82523, 
            PER @D82522, PLU @D82521, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCATE, 
   [COORD @D82532, PRD @D82531, 
      AGR [CASE @D82530, COUNT @D82529, PER @D82528, PLU @D82527, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOCATE, 
   [COORD @D82538, PRD @D82537, AGR [CASE @D82536, COUNT @D82535, 
            PER @D82534, PLU @D82533, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCATE.

WORD lock : 
   [COORD @D82544, AGR [COUNT @D82543, PER @D82542, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCK, 
   [COORD @D82546, AGR [COUNT @D82545, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCK, 
   [COORD @D82548, AGR [COUNT @D82547, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCK, 
   [COORD @D82552, AGR [COUNT @D82551, PER @D82550, PLU @D82549, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : LOCK, 
   [COORD @D82558, PAST @D82557, AGR [CASE @D82556, COUNT @D82555, 
            PER @D82554, PLU @D82553, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : LOCK, 
   [COORD @D82561, AGR [COUNT @D82560, PER @D82559, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : LOCK, 
   [COORD @D82563, AGR [COUNT @D82562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : LOCK, 
   [COORD @D82565, AGR [COUNT @D82564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : LOCK, 
   [COORD @D82569, AGR [COUNT @D82568, PER @D82567, PLU @D82566, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM OF, ARITY 3] : LOCK, 
   [COORD @D82575, PAST @D82574, 
      AGR [CASE @D82573, COUNT @D82572, PER @D82571, PLU @D82570, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM OF, ARITY 3] : LOCK, 
   [COORD @D82578, AGR [COUNT @D82577, PER @D82576, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOCK, 
   [COORD @D82580, AGR [COUNT @D82579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOCK, 
   [COORD @D82582, AGR [COUNT @D82581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOCK, 
   [COORD @D82586, AGR [COUNT @D82585, PER @D82584, PLU @D82583, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LOCK, 
   [COORD @D82592, PAST @D82591, AGR [CASE @D82590, COUNT @D82589, 
            PER @D82588, PLU @D82587, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LOCK, 
   [COORD @D82595, AGR [COUNT @D82594, PER @D82593, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : LOCK, 
   [COORD @D82597, AGR [COUNT @D82596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : LOCK, 
   [COORD @D82599, AGR [COUNT @D82598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : LOCK, 
   [COORD @D82603, AGR [COUNT @D82602, PER @D82601, PLU @D82600, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ONTO, ARITY 2] : LOCK, 
   [COORD @D82609, PAST @D82608, 
      AGR [CASE @D82607, COUNT @D82606, PER @D82605, PLU @D82604, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, 
      ARITY 2] : LOCK, 
   [COORD @D82612, AGR [COUNT @D82611, PER @D82610, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LOCK, 
   [COORD @D82614, AGR [COUNT @D82613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LOCK, 
   [COORD @D82616, AGR [COUNT @D82615, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LOCK, 
   [COORD @D82620, AGR [COUNT @D82619, PER @D82618, PLU @D82617, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : LOCK, 
   [COORD @D82626, PAST @D82625, 
      AGR [CASE @D82624, COUNT @D82623, PER @D82622, PLU @D82621, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : LOCK, 
   [COORD @D82629, AGR [COUNT @D82628, PER @D82627, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LOCK, 
   [COORD @D82631, AGR [COUNT @D82630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LOCK, 
   [COORD @D82633, AGR [COUNT @D82632, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LOCK, 
   [COORD @D82637, AGR [COUNT @D82636, PER @D82635, PLU @D82634, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : LOCK, 
   [COORD @D82643, PAST @D82642, 
      AGR [CASE @D82641, COUNT @D82640, PER @D82639, PLU @D82638, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : LOCK, 
   [COORD @D82646, AGR [COUNT @D82645, PER @D82644, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : LOCK, 
   [COORD @D82648, AGR [COUNT @D82647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : LOCK, 
   [COORD @D82650, AGR [COUNT @D82649, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : LOCK, 
   [COORD @D82654, AGR [COUNT @D82653, PER @D82652, PLU @D82651, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : LOCK, 
   [COORD @D82660, PAST @D82659, 
      AGR [CASE @D82658, COUNT @D82657, PER @D82656, PLU @D82655, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : LOCK, 
   [COORD @D82663, AGR [COUNT @D82662, PER @D82661, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : LOCK, 
   [COORD @D82665, AGR [COUNT @D82664, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : LOCK, 
   [COORD @D82667, AGR [COUNT @D82666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : LOCK, 
   [COORD @D82671, AGR [COUNT @D82670, PER @D82669, PLU @D82668, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : LOCK, 
   [COORD @D82677, PAST @D82676, 
      AGR [CASE @D82675, COUNT @D82674, PER @D82673, PLU @D82672, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : LOCK, 
   [COORD @D82680, AGR [COUNT @D82679, PER @D82678, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOCK, 
   [COORD @D82682, AGR [COUNT @D82681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOCK, 
   [COORD @D82684, AGR [COUNT @D82683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOCK, 
   [COORD @D82688, AGR [COUNT @D82687, PER @D82686, PLU @D82685, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOCK, 
   [COORD @D82694, PAST @D82693, AGR [CASE @D82692, COUNT @D82691, 
            PER @D82690, PLU @D82689, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LOCK, 
   [COORD @D82697, AGR [COUNT @D82696, PER @D82695, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOCK, 
   [COORD @D82699, AGR [COUNT @D82698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOCK, 
   [COORD @D82701, AGR [COUNT @D82700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOCK, 
   [COORD @D82705, AGR [COUNT @D82704, PER @D82703, PLU @D82702, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOCK, 
   [COORD @D82711, PAST @D82710, 
      AGR [CASE @D82709, COUNT @D82708, PER @D82707, PLU @D82706, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : LOCK, 
   [COORD @D82714, AGR [COUNT @D82713, PER @D82712, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOCK, 
   [COORD @D82716, AGR [COUNT @D82715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOCK, 
   [COORD @D82718, AGR [COUNT @D82717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOCK, 
   [COORD @D82722, AGR [COUNT @D82721, PER @D82720, PLU @D82719, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOCK, 
   [COORD @D82728, PAST @D82727, 
      AGR [CASE @D82726, COUNT @D82725, PER @D82724, PLU @D82723, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : LOCK, 
   [COORD @D82731, AGR [COUNT @D82730, PER @D82729, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOCK, 
   [COORD @D82733, AGR [COUNT @D82732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOCK, 
   [COORD @D82735, AGR [COUNT @D82734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOCK, 
   [COORD @D82739, AGR [COUNT @D82738, PER @D82737, PLU @D82736, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOCK, 
   [COORD @D82745, PAST @D82744, 
      AGR [CASE @D82743, COUNT @D82742, PER @D82741, PLU @D82740, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : LOCK, 
   [COORD @D82748, AGR [COUNT @D82747, PER @D82746, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : LOCK, 
   [COORD @D82750, AGR [COUNT @D82749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : LOCK, 
   [COORD @D82752, AGR [COUNT @D82751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : LOCK, 
   [COORD @D82756, AGR [COUNT @D82755, PER @D82754, PLU @D82753, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : LOCK, 
   [COORD @D82762, PAST @D82761, 
      AGR [CASE @D82760, COUNT @D82759, PER @D82758, PLU @D82757, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : LOCK.

WORD locked : 
   [COORD @D82771, AGR [CASE @D82770, COUNT @D82769, PER @D82768, 
            PLU @D82767, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOCK, 
   [COORD @D82776, AGR [CASE @D82775, COUNT @D82774, PER @D82773, 
            PLU @D82772, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82781, AGR [CASE @D82780, COUNT @D82779, PER @D82778, 
            PLU @D82777, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82786, AGR [CASE @D82785, COUNT @D82784, PER @D82783, 
            PLU @D82782, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82791, AGR [CASE @D82790, COUNT @D82789, PER @D82788, 
            PLU @D82787, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82796, 
      AGR [CASE @D82795, COUNT @D82794, PER @D82793, PLU @D82792, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82801, AGR [CASE @D82800, COUNT @D82799, PER @D82798, 
            PLU @D82797, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOCK, 
   [COORD @D82806, AGR [CASE @D82805, COUNT @D82804, PER @D82803, 
            PLU @D82802, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82811, AGR [CASE @D82810, COUNT @D82809, PER @D82808, 
            PLU @D82807, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82816, AGR [CASE @D82815, COUNT @D82814, PER @D82813, 
            PLU @D82812, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82821, AGR [CASE @D82820, COUNT @D82819, PER @D82818, 
            PLU @D82817, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82826, AGR [CASE @D82825, COUNT @D82824, PER @D82823, 
            PLU @D82822, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ONTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82831, AGR [CASE @D82830, COUNT @D82829, PER @D82828, 
            PLU @D82827, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82836, AGR [CASE @D82835, COUNT @D82834, PER @D82833, 
            PLU @D82832, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82841, AGR [CASE @D82840, COUNT @D82839, PER @D82838, 
            PLU @D82837, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82846, AGR [CASE @D82845, COUNT @D82844, PER @D82843, 
            PLU @D82842, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82851, AGR [CASE @D82850, COUNT @D82849, PER @D82848, 
            PLU @D82847, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82856, AGR [CASE @D82855, COUNT @D82854, PER @D82853, 
            PLU @D82852, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82861, AGR [CASE @D82860, COUNT @D82859, PER @D82858, 
            PLU @D82857, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82866, AGR [CASE @D82865, COUNT @D82864, PER @D82863, 
            PLU @D82862, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82871, AGR [CASE @D82870, COUNT @D82869, PER @D82868, 
            PLU @D82867, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82876, AGR [CASE @D82875, COUNT @D82874, PER @D82873, 
            PLU @D82872, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82881, AGR [CASE @D82880, COUNT @D82879, PER @D82878, 
            PLU @D82877, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82886, AGR [CASE @D82885, COUNT @D82884, PER @D82883, 
            PLU @D82882, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82891, AGR [CASE @D82890, COUNT @D82889, PER @D82888, 
            PLU @D82887, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82896, AGR [CASE @D82895, COUNT @D82894, PER @D82893, 
            PLU @D82892, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82901, AGR [CASE @D82900, COUNT @D82899, PER @D82898, 
            PLU @D82897, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82906, AGR [CASE @D82905, COUNT @D82904, PER @D82903, 
            PLU @D82902, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82911, AGR [CASE @D82910, COUNT @D82909, PER @D82908, 
            PLU @D82907, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82916, AGR [CASE @D82915, COUNT @D82914, PER @D82913, 
            PLU @D82912, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82921, AGR [CASE @D82920, COUNT @D82919, PER @D82918, 
            PLU @D82917, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82926, AGR [CASE @D82925, COUNT @D82924, PER @D82923, 
            PLU @D82922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82931, AGR [CASE @D82930, COUNT @D82929, PER @D82928, 
            PLU @D82927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82936, AGR [CASE @D82935, COUNT @D82934, PER @D82933, 
            PLU @D82932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOCK.

WORD locking : 
   [COORD @D82948, PRD @D82947, AGR [CASE @D82946, COUNT @D82945, 
            PER @D82944, PLU @D82943, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82954, PRD @D82953, 
      AGR [CASE @D82952, COUNT @D82951, PER @D82950, PLU @D82949, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOCK, 
   [COORD @D82960, PRD @D82959, AGR [CASE @D82958, COUNT @D82957, 
            PER @D82956, PLU @D82955, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82966, PRD @D82965, 
      AGR [CASE @D82964, COUNT @D82963, PER @D82962, PLU @D82961, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOCK, 
   [COORD @D82972, PRD @D82971, AGR [CASE @D82970, COUNT @D82969, 
            PER @D82968, PLU @D82967, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82978, PRD @D82977, 
      AGR [CASE @D82976, COUNT @D82975, PER @D82974, PLU @D82973, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOCK, 
   [COORD @D82984, PRD @D82983, AGR [CASE @D82982, COUNT @D82981, 
            PER @D82980, PLU @D82979, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D82990, PRD @D82989, 
      AGR [CASE @D82988, COUNT @D82987, PER @D82986, PLU @D82985, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOCK, 
   [COORD @D82996, PRD @D82995, AGR [CASE @D82994, COUNT @D82993, 
            PER @D82992, PLU @D82991, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D83002, PRD @D83001, 
      AGR [CASE @D83000, COUNT @D82999, PER @D82998, PLU @D82997, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOCK, 
   [COORD @D83008, PRD @D83007, AGR [CASE @D83006, COUNT @D83005, 
            PER @D83004, PLU @D83003, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOCK, 
   [COORD @D83014, PRD @D83013, 
      AGR [CASE @D83012, COUNT @D83011, PER @D83010, PLU @D83009, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOCK, 
   [COORD @D83020, PRD @D83019, AGR [CASE @D83018, COUNT @D83017, 
            PER @D83016, PLU @D83015, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOCK.

WORD locks : 
   [COORD @D83026, AGR [COUNT @D83025, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83028, 
      AGR [COUNT @D83027, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOCK, 
   [COORD @D83030, AGR [COUNT @D83029, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83032, 
      AGR [COUNT @D83031, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83034, 
      AGR [COUNT @D83033, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83036, 
      AGR [COUNT @D83035, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83038, 
      AGR [COUNT @D83037, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83040, 
      AGR [COUNT @D83039, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83042, 
      AGR [COUNT @D83041, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83044, 
      AGR [COUNT @D83043, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83046, 
      AGR [COUNT @D83045, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83048, 
      AGR [COUNT @D83047, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK, 
   [COORD @D83050, 
      AGR [COUNT @D83049, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOCK.

WORD look : 
   [COORD @D83057, REFL @D83056, PRD @D83055, CASE @D83054, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM AT, COUNT +] : LOOK, 
   [COORD @D83061, REFL @D83060, PRD @D83059, CASE @D83058, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LOOK, 
   [COORD @D83066, REFL @D83065, COUNT @D83064, PRD @D83063, 
      CASE @D83062, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LOOK, 
   [COORD @D83069, 
      AGR [COUNT @D83068, PER @D83067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, PREP AT, 
      ARITY 3] : LOOK, 
   [COORD @D83071, AGR [COUNT @D83070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, PREP AT, ARITY 3] : LOOK, 
   [COORD @D83073, AGR [COUNT @D83072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, PREP AT, ARITY 3] : LOOK, 
   [COORD @D83077, AGR [COUNT @D83076, PER @D83075, PLU @D83074, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, PREP AT, ARITY 3] : LOOK, 
   [COORD @D83083, PAST @D83082, 
      AGR [CASE @D83081, COUNT @D83080, PER @D83079, PLU @D83078, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, PREP AT, 
      ARITY 3] : LOOK, 
   [COORD @D83086, AGR [COUNT @D83085, PER @D83084, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM TO_FOR, ARITY 3] : LOOK, 
   [COORD @D83088, AGR [COUNT @D83087, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM TO_FOR, ARITY 3] : LOOK, 
   [COORD @D83090, AGR [COUNT @D83089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM TO_FOR, ARITY 3] : LOOK, 
   [COORD @D83094, AGR [COUNT @D83093, PER @D83092, PLU @D83091, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM TO_FOR, ARITY 3] : LOOK, 
   [COORD @D83100, PAST @D83099, 
      AGR [CASE @D83098, COUNT @D83097, PER @D83096, PLU @D83095, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM TO_FOR, 
      ARITY 3] : LOOK, 
   [COORD @D83103, AGR [COUNT @D83102, PER @D83101, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : LOOK, 
   [COORD @D83105, AGR [COUNT @D83104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : LOOK, 
   [COORD @D83107, AGR [COUNT @D83106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : LOOK, 
   [COORD @D83111, AGR [COUNT @D83110, PER @D83109, PLU @D83108, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : LOOK, 
   [COORD @D83117, PAST @D83116, 
      AGR [CASE @D83115, COUNT @D83114, PER @D83113, PLU @D83112, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, 
      PFORM TO, ARITY 3] : LOOK, 
   [COORD @D83120, AGR [COUNT @D83119, PER @D83118, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_WITH, ARITY 3] : LOOK, 
   [COORD @D83122, AGR [COUNT @D83121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_WITH, ARITY 3] : LOOK, 
   [COORD @D83124, AGR [COUNT @D83123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_WITH, ARITY 3] : LOOK, 
   [COORD @D83128, AGR [COUNT @D83127, PER @D83126, PLU @D83125, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_WITH, ARITY 3] : LOOK, 
   [COORD @D83134, PAST @D83133, 
      AGR [CASE @D83132, COUNT @D83131, PER @D83130, PLU @D83129, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_WITH, 
      ARITY 3] : LOOK, 
   [COORD @D83137, AGR [COUNT @D83136, PER @D83135, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_AS, ARITY 3] : LOOK, 
   [COORD @D83139, AGR [COUNT @D83138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_AS, ARITY 3] : LOOK, 
   [COORD @D83141, AGR [COUNT @D83140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_AS, ARITY 3] : LOOK, 
   [COORD @D83145, AGR [COUNT @D83144, PER @D83143, PLU @D83142, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_AS, ARITY 3] : LOOK, 
   [COORD @D83151, PAST @D83150, 
      AGR [CASE @D83149, COUNT @D83148, PER @D83147, PLU @D83146, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_AS, 
      ARITY 3] : LOOK, 
   [COORD @D83154, AGR [COUNT @D83153, PER @D83152, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83156, AGR [COUNT @D83155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83158, AGR [COUNT @D83157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83162, AGR [COUNT @D83161, PER @D83160, PLU @D83159, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83168, PAST @D83167, 
      AGR [CASE @D83166, COUNT @D83165, PER @D83164, PLU @D83163, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83171, AGR [COUNT @D83170, PER @D83169, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_BSE, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83173, AGR [COUNT @D83172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_BSE, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83175, AGR [COUNT @D83174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_BSE, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83179, AGR [COUNT @D83178, PER @D83177, PLU @D83176, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_BSE, PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83185, PAST @D83184, 
      AGR [CASE @D83183, COUNT @D83182, PER @D83181, PLU @D83180, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_BSE, 
      PFORM AT, ARITY 3] : LOOK, 
   [COORD @D83188, AGR [COUNT @D83187, PER @D83186, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : LOOK, 
   [COORD @D83190, AGR [COUNT @D83189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : LOOK, 
   [COORD @D83192, AGR [COUNT @D83191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : LOOK, 
   [COORD @D83196, AGR [COUNT @D83195, PER @D83194, PLU @D83193, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : LOOK, 
   [COORD @D83202, PAST @D83201, AGR [CASE @D83200, COUNT @D83199, 
            PER @D83198, PLU @D83197, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : LOOK, 
   [COORD @D83205, AGR [COUNT @D83204, PER @D83203, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOOK, 
   [COORD @D83207, AGR [COUNT @D83206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOOK, 
   [COORD @D83209, AGR [COUNT @D83208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOOK, 
   [COORD @D83213, AGR [COUNT @D83212, PER @D83211, PLU @D83210, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOOK, 
   [COORD @D83219, PAST @D83218, AGR [CASE @D83217, COUNT @D83216, 
            PER @D83215, PLU @D83214, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : LOOK, 
   [COORD @D83222, AGR [COUNT @D83221, PER @D83220, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : LOOK, 
   [COORD @D83224, AGR [COUNT @D83223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : LOOK, 
   [COORD @D83226, AGR [COUNT @D83225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : LOOK, 
   [COORD @D83230, AGR [COUNT @D83229, PER @D83228, PLU @D83227, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : LOOK, 
   [COORD @D83236, PAST @D83235, AGR [CASE @D83234, COUNT @D83233, 
            PER @D83232, PLU @D83231, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : LOOK, 
   [COORD @D83239, AGR [COUNT @D83238, PER @D83237, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOOK, 
   [COORD @D83241, AGR [COUNT @D83240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOOK, 
   [COORD @D83243, AGR [COUNT @D83242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOOK, 
   [COORD @D83247, AGR [COUNT @D83246, PER @D83245, PLU @D83244, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LOOK, 
   [COORD @D83253, PAST @D83252, AGR [CASE @D83251, COUNT @D83250, 
            PER @D83249, PLU @D83248, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LOOK, 
   [COORD @D83256, AGR [COUNT @D83255, PER @D83254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LOOK, 
   [COORD @D83258, AGR [COUNT @D83257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LOOK, 
   [COORD @D83260, AGR [COUNT @D83259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : LOOK, 
   [COORD @D83264, AGR [COUNT @D83263, PER @D83262, PLU @D83261, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : LOOK, 
   [COORD @D83270, PAST @D83269, AGR [CASE @D83268, COUNT @D83267, 
            PER @D83266, PLU @D83265, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : LOOK, 
   [COORD @D83273, AGR [COUNT @D83272, PER @D83271, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT FORWARD, PREP TO, ARITY 2] : LOOK, 
   [COORD @D83275, 
      AGR [COUNT @D83274, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, PRT FORWARD, 
      PREP TO, ARITY 2] : LOOK, 
   [COORD @D83277, AGR [COUNT @D83276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT FORWARD, PREP TO, ARITY 2] : LOOK, 
   [COORD @D83281, 
      AGR [COUNT @D83280, PER @D83279, PLU @D83278, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PRT FORWARD, PREP TO, ARITY 2] : LOOK, 
   [COORD @D83287, PAST @D83286, 
      AGR [CASE @D83285, COUNT @D83284, PER @D83283, PLU @D83282, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PRT FORWARD, PREP TO, ARITY 2] : LOOK, 
   [COORD @D83290, AGR [COUNT @D83289, PER @D83288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM WITH, ARITY 2] : LOOK, 
   [COORD @D83292, AGR [COUNT @D83291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM WITH, ARITY 2] : LOOK, 
   [COORD @D83294, AGR [COUNT @D83293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM WITH, ARITY 2] : LOOK, 
   [COORD @D83298, AGR [COUNT @D83297, PER @D83296, PLU @D83295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ON, PFORM WITH, ARITY 2] : LOOK, 
   [COORD @D83304, PAST @D83303, 
      AGR [CASE @D83302, COUNT @D83301, PER @D83300, PLU @D83299, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT ON, 
      PFORM WITH, ARITY 2] : LOOK, 
   [COORD @D83307, AGR [COUNT @D83306, PER @D83305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83309, AGR [COUNT @D83308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83311, AGR [COUNT @D83310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83315, AGR [COUNT @D83314, PER @D83313, PLU @D83312, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83321, PAST @D83320, 
      AGR [CASE @D83319, COUNT @D83318, PER @D83317, PLU @D83316, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      ARITY 2] : LOOK, 
   [COORD @D83324, AGR [COUNT @D83323, PER @D83322, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83326, AGR [COUNT @D83325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83328, AGR [COUNT @D83327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83332, AGR [COUNT @D83331, PER @D83330, PLU @D83329, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83338, PAST @D83337, 
      AGR [CASE @D83336, COUNT @D83335, PER @D83334, PLU @D83333, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, 
      ARITY 2] : LOOK, 
   [COORD @D83341, AGR [COUNT @D83340, PER @D83339, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT FORWARD, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83343, AGR [COUNT @D83342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT FORWARD, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83345, AGR [COUNT @D83344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT FORWARD, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83349, AGR [COUNT @D83348, PER @D83347, PLU @D83346, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT FORWARD, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83355, PAST @D83354, 
      AGR [CASE @D83353, COUNT @D83352, PER @D83351, PLU @D83350, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT FORWARD, 
      PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83358, AGR [COUNT @D83357, PER @D83356, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BACK, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83360, AGR [COUNT @D83359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BACK, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83362, AGR [COUNT @D83361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BACK, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83366, AGR [COUNT @D83365, PER @D83364, PLU @D83363, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT BACK, PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83372, PAST @D83371, 
      AGR [CASE @D83370, COUNT @D83369, PER @D83368, PLU @D83367, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT BACK, 
      PFORM TO, ARITY 2] : LOOK, 
   [COORD @D83375, AGR [COUNT @D83374, PER @D83373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LOOK, 
   [COORD @D83377, AGR [COUNT @D83376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LOOK, 
   [COORD @D83379, AGR [COUNT @D83378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : LOOK, 
   [COORD @D83383, AGR [COUNT @D83382, PER @D83381, PLU @D83380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, ARITY 2] : LOOK, 
   [COORD @D83389, PAST @D83388, 
      AGR [CASE @D83387, COUNT @D83386, PER @D83385, PLU @D83384, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, 
      ARITY 2] : LOOK, 
   [COORD @D83392, AGR [COUNT @D83391, PER @D83390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : LOOK, 
   [COORD @D83394, AGR [COUNT @D83393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : LOOK, 
   [COORD @D83396, AGR [COUNT @D83395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : LOOK, 
   [COORD @D83400, AGR [COUNT @D83399, PER @D83398, PLU @D83397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ROUND, ARITY 2] : LOOK, 
   [COORD @D83406, PAST @D83405, 
      AGR [CASE @D83404, COUNT @D83403, PER @D83402, PLU @D83401, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, 
      ARITY 2] : LOOK, 
   [COORD @D83409, AGR [COUNT @D83408, PER @D83407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM OVER, ARITY 2] : LOOK, 
   [COORD @D83411, AGR [COUNT @D83410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM OVER, ARITY 2] : LOOK, 
   [COORD @D83413, AGR [COUNT @D83412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM OVER, ARITY 2] : LOOK, 
   [COORD @D83417, AGR [COUNT @D83416, PER @D83415, PLU @D83414, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM OVER, ARITY 2] : LOOK, 
   [COORD @D83423, PAST @D83422, 
      AGR [CASE @D83421, COUNT @D83420, PER @D83419, PLU @D83418, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM OVER, ARITY 2] : LOOK, 
   [COORD @D83426, AGR [COUNT @D83425, PER @D83424, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : LOOK, 
   [COORD @D83428, AGR [COUNT @D83427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : LOOK, 
   [COORD @D83430, AGR [COUNT @D83429, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ONTO, ARITY 2] : LOOK, 
   [COORD @D83434, AGR [COUNT @D83433, PER @D83432, PLU @D83431, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ONTO, ARITY 2] : LOOK, 
   [COORD @D83440, PAST @D83439, 
      AGR [CASE @D83438, COUNT @D83437, PER @D83436, PLU @D83435, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, 
      ARITY 2] : LOOK, 
   [COORD @D83443, AGR [COUNT @D83442, PER @D83441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83445, AGR [COUNT @D83444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83447, AGR [COUNT @D83446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83451, AGR [COUNT @D83450, PER @D83449, PLU @D83448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83457, PAST @D83456, 
      AGR [CASE @D83455, COUNT @D83454, PER @D83453, PLU @D83452, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, 
      ARITY 2] : LOOK, 
   [COORD @D83460, AGR [COUNT @D83459, PER @D83458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83462, AGR [COUNT @D83461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83464, AGR [COUNT @D83463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83468, AGR [COUNT @D83467, PER @D83466, PLU @D83465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83474, PAST @D83473, 
      AGR [CASE @D83472, COUNT @D83471, PER @D83470, PLU @D83469, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83477, AGR [COUNT @D83476, PER @D83475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83479, AGR [COUNT @D83478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83481, AGR [COUNT @D83480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83485, AGR [COUNT @D83484, PER @D83483, PLU @D83482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT DOWN, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83491, PAST @D83490, 
      AGR [CASE @D83489, COUNT @D83488, PER @D83487, PLU @D83486, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT DOWN, 
      PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83494, AGR [COUNT @D83493, PER @D83492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BACK, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83496, AGR [COUNT @D83495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BACK, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83498, AGR [COUNT @D83497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT BACK, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83502, AGR [COUNT @D83501, PER @D83500, PLU @D83499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT BACK, PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83508, PAST @D83507, 
      AGR [CASE @D83506, COUNT @D83505, PER @D83504, PLU @D83503, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT BACK, 
      PFORM ON, ARITY 2] : LOOK, 
   [COORD @D83511, AGR [COUNT @D83510, PER @D83509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : LOOK, 
   [COORD @D83513, AGR [COUNT @D83512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : LOOK, 
   [COORD @D83515, AGR [COUNT @D83514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : LOOK, 
   [COORD @D83519, AGR [COUNT @D83518, PER @D83517, PLU @D83516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, ARITY 2] : LOOK, 
   [COORD @D83525, PAST @D83524, 
      AGR [CASE @D83523, COUNT @D83522, PER @D83521, PLU @D83520, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      ARITY 2] : LOOK, 
   [COORD @D83528, AGR [COUNT @D83527, PER @D83526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83530, AGR [COUNT @D83529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83532, AGR [COUNT @D83531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83536, AGR [COUNT @D83535, PER @D83534, PLU @D83533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83542, PAST @D83541, 
      AGR [CASE @D83540, COUNT @D83539, PER @D83538, PLU @D83537, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : LOOK, 
   [COORD @D83545, AGR [COUNT @D83544, PER @D83543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83547, AGR [COUNT @D83546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83549, AGR [COUNT @D83548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83553, AGR [COUNT @D83552, PER @D83551, PLU @D83550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83559, PAST @D83558, 
      AGR [CASE @D83557, COUNT @D83556, PER @D83555, PLU @D83554, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT ROUND, 
      PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83562, AGR [COUNT @D83561, PER @D83560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83564, AGR [COUNT @D83563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83566, AGR [COUNT @D83565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83570, AGR [COUNT @D83569, PER @D83568, PLU @D83567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83576, PAST @D83575, 
      AGR [CASE @D83574, COUNT @D83573, PER @D83572, PLU @D83571, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83579, AGR [COUNT @D83578, PER @D83577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83581, AGR [COUNT @D83580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83583, AGR [COUNT @D83582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83587, AGR [COUNT @D83586, PER @D83585, PLU @D83584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT AROUND, PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83593, PAST @D83592, 
      AGR [CASE @D83591, COUNT @D83590, PER @D83589, PLU @D83588, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT AROUND, 
      PFORM FOR, ARITY 2] : LOOK, 
   [COORD @D83596, AGR [COUNT @D83595, PER @D83594, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83598, AGR [COUNT @D83597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83600, AGR [COUNT @D83599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83604, AGR [COUNT @D83603, PER @D83602, PLU @D83601, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83610, PAST @D83609, 
      AGR [CASE @D83608, COUNT @D83607, PER @D83606, PLU @D83605, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      ARITY 2] : LOOK, 
   [COORD @D83613, AGR [COUNT @D83612, PER @D83611, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83615, AGR [COUNT @D83614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83617, AGR [COUNT @D83616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83621, AGR [COUNT @D83620, PER @D83619, PLU @D83618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83627, PAST @D83626, 
      AGR [CASE @D83625, COUNT @D83624, PER @D83623, PLU @D83622, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM AT, ARITY 2] : LOOK, 
   [COORD @D83630, AGR [COUNT @D83629, PER @D83628, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, ARITY 2] : LOOK, 
   [COORD @D83632, AGR [COUNT @D83631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, ARITY 2] : LOOK, 
   [COORD @D83634, AGR [COUNT @D83633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, ARITY 2] : LOOK, 
   [COORD @D83638, AGR [COUNT @D83637, PER @D83636, PLU @D83635, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AFTER, ARITY 2] : LOOK, 
   [COORD @D83644, PAST @D83643, 
      AGR [CASE @D83642, COUNT @D83641, PER @D83640, PLU @D83639, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, 
      ARITY 2] : LOOK, 
   [COORD @D83647, AGR [COUNT @D83646, PER @D83645, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : LOOK, 
   [COORD @D83649, AGR [COUNT @D83648, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : LOOK, 
   [COORD @D83651, AGR [COUNT @D83650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : LOOK, 
   [COORD @D83655, AGR [COUNT @D83654, PER @D83653, PLU @D83652, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : LOOK, 
   [COORD @D83661, PAST @D83660, 
      AGR [CASE @D83659, COUNT @D83658, PER @D83657, PLU @D83656, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, 
      ARITY 2] : LOOK, 
   [COORD @D83664, AGR [COUNT @D83663, PER @D83662, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LOOK, 
   [COORD @D83666, AGR [COUNT @D83665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LOOK, 
   [COORD @D83668, AGR [COUNT @D83667, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : LOOK, 
   [COORD @D83672, AGR [COUNT @D83671, PER @D83670, PLU @D83669, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : LOOK, 
   [COORD @D83678, PAST @D83677, 
      AGR [CASE @D83676, COUNT @D83675, PER @D83674, PLU @D83673, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : LOOK, 
   [COORD @D83681, AGR [COUNT @D83680, PER @D83679, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : LOOK, 
   [COORD @D83683, AGR [COUNT @D83682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : LOOK, 
   [COORD @D83685, AGR [COUNT @D83684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : LOOK, 
   [COORD @D83689, AGR [COUNT @D83688, PER @D83687, PLU @D83686, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT THROUGH, ARITY 2] : LOOK, 
   [COORD @D83695, PAST @D83694, 
      AGR [CASE @D83693, COUNT @D83692, PER @D83691, PLU @D83690, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : LOOK, 
   [COORD @D83698, AGR [COUNT @D83697, PER @D83696, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : LOOK, 
   [COORD @D83700, AGR [COUNT @D83699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : LOOK, 
   [COORD @D83702, AGR [COUNT @D83701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : LOOK, 
   [COORD @D83706, AGR [COUNT @D83705, PER @D83704, PLU @D83703, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : LOOK, 
   [COORD @D83712, PAST @D83711, 
      AGR [CASE @D83710, COUNT @D83709, PER @D83708, PLU @D83707, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : LOOK, 
   [COORD @D83715, AGR [COUNT @D83714, PER @D83713, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LOOK, 
   [COORD @D83717, AGR [COUNT @D83716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LOOK, 
   [COORD @D83719, AGR [COUNT @D83718, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : LOOK, 
   [COORD @D83723, AGR [COUNT @D83722, PER @D83721, PLU @D83720, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : LOOK, 
   [COORD @D83729, PAST @D83728, 
      AGR [CASE @D83727, COUNT @D83726, PER @D83725, PLU @D83724, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : LOOK, 
   [COORD @D83732, AGR [COUNT @D83731, PER @D83730, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOOK, 
   [COORD @D83734, AGR [COUNT @D83733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOOK, 
   [COORD @D83736, AGR [COUNT @D83735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOOK, 
   [COORD @D83740, AGR [COUNT @D83739, PER @D83738, PLU @D83737, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : LOOK, 
   [COORD @D83746, PAST @D83745, AGR [CASE @D83744, COUNT @D83743, 
            PER @D83742, PLU @D83741, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : LOOK, 
   [COORD @D83749, AGR [COUNT @D83748, PER @D83747, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOOK, 
   [COORD @D83751, AGR [COUNT @D83750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOOK, 
   [COORD @D83753, AGR [COUNT @D83752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOOK, 
   [COORD @D83757, AGR [COUNT @D83756, PER @D83755, PLU @D83754, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : LOOK, 
   [COORD @D83763, PAST @D83762, 
      AGR [CASE @D83761, COUNT @D83760, PER @D83759, PLU @D83758, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : LOOK, 
   [COORD @D83766, AGR [COUNT @D83765, PER @D83764, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LOOK, 
   [COORD @D83768, AGR [COUNT @D83767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LOOK, 
   [COORD @D83770, AGR [COUNT @D83769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LOOK, 
   [COORD @D83774, AGR [COUNT @D83773, PER @D83772, PLU @D83771, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : LOOK, 
   [COORD @D83780, PAST @D83779, 
      AGR [CASE @D83778, COUNT @D83777, PER @D83776, PLU @D83775, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT THROUGH, 
      ARITY 1] : LOOK, 
   [COORD @D83783, AGR [COUNT @D83782, PER @D83781, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : LOOK, 
   [COORD @D83785, AGR [COUNT @D83784, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : LOOK, 
   [COORD @D83787, AGR [COUNT @D83786, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : LOOK, 
   [COORD @D83791, AGR [COUNT @D83790, PER @D83789, PLU @D83788, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : LOOK, 
   [COORD @D83797, PAST @D83796, 
      AGR [CASE @D83795, COUNT @D83794, PER @D83793, PLU @D83792, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ROUND, 
      ARITY 1] : LOOK, 
   [COORD @D83800, AGR [COUNT @D83799, PER @D83798, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : LOOK, 
   [COORD @D83802, AGR [COUNT @D83801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : LOOK, 
   [COORD @D83804, AGR [COUNT @D83803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : LOOK, 
   [COORD @D83808, AGR [COUNT @D83807, PER @D83806, PLU @D83805, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : LOOK, 
   [COORD @D83814, PAST @D83813, 
      AGR [CASE @D83812, COUNT @D83811, PER @D83810, PLU @D83809, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : LOOK, 
   [COORD @D83817, AGR [COUNT @D83816, PER @D83815, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOOK, 
   [COORD @D83819, AGR [COUNT @D83818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOOK, 
   [COORD @D83821, AGR [COUNT @D83820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOOK, 
   [COORD @D83825, AGR [COUNT @D83824, PER @D83823, PLU @D83822, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : LOOK, 
   [COORD @D83831, PAST @D83830, 
      AGR [CASE @D83829, COUNT @D83828, PER @D83827, PLU @D83826, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : LOOK, 
   [COORD @D83834, AGR [COUNT @D83833, PER @D83832, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LOOK, 
   [COORD @D83836, AGR [COUNT @D83835, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LOOK, 
   [COORD @D83838, AGR [COUNT @D83837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LOOK, 
   [COORD @D83842, AGR [COUNT @D83841, PER @D83840, PLU @D83839, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : LOOK, 
   [COORD @D83848, PAST @D83847, 
      AGR [CASE @D83846, COUNT @D83845, PER @D83844, PLU @D83843, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : LOOK, 
   [COORD @D83851, AGR [COUNT @D83850, PER @D83849, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOOK, 
   [COORD @D83853, AGR [COUNT @D83852, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOOK, 
   [COORD @D83855, AGR [COUNT @D83854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOOK, 
   [COORD @D83859, AGR [COUNT @D83858, PER @D83857, PLU @D83856, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : LOOK, 
   [COORD @D83865, PAST @D83864, 
      AGR [CASE @D83863, COUNT @D83862, PER @D83861, PLU @D83860, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : LOOK, 
   [COORD @D83868, AGR [COUNT @D83867, PER @D83866, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : LOOK, 
   [COORD @D83870, AGR [COUNT @D83869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : LOOK, 
   [COORD @D83872, AGR [COUNT @D83871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : LOOK, 
   [COORD @D83876, AGR [COUNT @D83875, PER @D83874, PLU @D83873, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : LOOK, 
   [COORD @D83882, PAST @D83881, 
      AGR [CASE @D83880, COUNT @D83879, PER @D83878, PLU @D83877, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BACK, 
      ARITY 1] : LOOK, 
   [COORD @D83885, AGR [COUNT @D83884, PER @D83883, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : LOOK, 
   [COORD @D83887, AGR [COUNT @D83886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : LOOK, 
   [COORD @D83889, AGR [COUNT @D83888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : LOOK, 
   [COORD @D83893, AGR [COUNT @D83892, PER @D83891, PLU @D83890, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : LOOK, 
   [COORD @D83899, PAST @D83898, 
      AGR [CASE @D83897, COUNT @D83896, PER @D83895, PLU @D83894, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AROUND, 
      ARITY 1] : LOOK, 
   [COORD @D83902, AGR [COUNT @D83901, PER @D83900, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : LOOK, 
   [COORD @D83904, AGR [COUNT @D83903, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : LOOK, 
   [COORD @D83906, AGR [COUNT @D83905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : LOOK, 
   [COORD @D83910, AGR [COUNT @D83909, PER @D83908, PLU @D83907, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : LOOK, 
   [COORD @D83916, PAST @D83915, 
      AGR [CASE @D83914, COUNT @D83913, PER @D83912, PLU @D83911, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AHEAD, 
      ARITY 1] : LOOK.

WORD looked : 
   [COORD @D83926, AGR [CASE @D83925, COUNT @D83924, PER @D83923, 
            PLU @D83922, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADL, SUBTYPE NONE, CONJ NULL, PREP AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83931, AGR [CASE @D83930, COUNT @D83929, PER @D83928, 
            PLU @D83927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, PREP AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83936, AGR [CASE @D83935, COUNT @D83934, PER @D83933, 
            PLU @D83932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, PREP AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83941, AGR [CASE @D83940, COUNT @D83939, PER @D83938, 
            PLU @D83937, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM TO_FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83946, AGR [CASE @D83945, COUNT @D83944, PER @D83943, 
            PLU @D83942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM TO_FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83951, AGR [CASE @D83950, COUNT @D83949, PER @D83948, 
            PLU @D83947, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE PVERB_OE, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83956, AGR [CASE @D83955, COUNT @D83954, PER @D83953, 
            PLU @D83952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83961, 
      AGR [CASE @D83960, COUNT @D83959, PER @D83958, PLU @D83957, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83966, AGR [CASE @D83965, COUNT @D83964, PER @D83963, 
            PLU @D83962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83971, AGR [CASE @D83970, COUNT @D83969, PER @D83968, 
            PLU @D83967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83976, AGR [CASE @D83975, COUNT @D83974, PER @D83973, 
            PLU @D83972, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83981, AGR [CASE @D83980, COUNT @D83979, PER @D83978, 
            PLU @D83977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83986, AGR [CASE @D83985, COUNT @D83984, PER @D83983, 
            PLU @D83982, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM AT, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83991, AGR [CASE @D83990, COUNT @D83989, PER @D83988, 
            PLU @D83987, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D83996, 
      AGR [CASE @D83995, COUNT @D83994, PER @D83993, PLU @D83992, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84001, AGR [CASE @D84000, COUNT @D83999, PER @D83998, 
            PLU @D83997, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_BSE, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84006, 
      AGR [CASE @D84005, COUNT @D84004, PER @D84003, PLU @D84002, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_BSE, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84011, AGR [CASE @D84010, COUNT @D84009, PER @D84008, 
            PLU @D84007, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84016, AGR [CASE @D84015, COUNT @D84014, PER @D84013, 
            PLU @D84012, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84021, AGR [CASE @D84020, COUNT @D84019, PER @D84018, 
            PLU @D84017, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84026, AGR [CASE @D84025, COUNT @D84024, PER @D84023, 
            PLU @D84022, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84031, AGR [CASE @D84030, COUNT @D84029, PER @D84028, 
            PLU @D84027, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84036, AGR [CASE @D84035, COUNT @D84034, PER @D84033, 
            PLU @D84032, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84041, AGR [CASE @D84040, COUNT @D84039, PER @D84038, 
            PLU @D84037, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84046, AGR [CASE @D84045, COUNT @D84044, PER @D84043, 
            PLU @D84042, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84051, AGR [CASE @D84050, COUNT @D84049, PER @D84048, 
            PLU @D84047, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84056, AGR [CASE @D84055, COUNT @D84054, PER @D84053, 
            PLU @D84052, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84061, AGR [CASE @D84060, COUNT @D84059, PER @D84058, 
            PLU @D84057, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84066, AGR [CASE @D84065, COUNT @D84064, PER @D84063, 
            PLU @D84062, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT FORWARD, PREP TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84071, 
      AGR [CASE @D84070, COUNT @D84069, PER @D84068, PLU @D84067, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PRT FORWARD, PREP TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84076, AGR [CASE @D84075, COUNT @D84074, PER @D84073, 
            PLU @D84072, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84081, AGR [CASE @D84080, COUNT @D84079, PER @D84078, 
            PLU @D84077, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84086, AGR [CASE @D84085, COUNT @D84084, PER @D84083, 
            PLU @D84082, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84091, AGR [CASE @D84090, COUNT @D84089, PER @D84088, 
            PLU @D84087, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84096, AGR [CASE @D84095, COUNT @D84094, PER @D84093, 
            PLU @D84092, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84101, AGR [CASE @D84100, COUNT @D84099, PER @D84098, 
            PLU @D84097, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84106, AGR [CASE @D84105, COUNT @D84104, PER @D84103, 
            PLU @D84102, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84111, AGR [CASE @D84110, COUNT @D84109, PER @D84108, 
            PLU @D84107, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84116, AGR [CASE @D84115, COUNT @D84114, PER @D84113, 
            PLU @D84112, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT FORWARD, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84121, AGR [CASE @D84120, COUNT @D84119, PER @D84118, 
            PLU @D84117, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT FORWARD, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84126, 
      AGR [CASE @D84125, COUNT @D84124, PER @D84123, PLU @D84122, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT FORWARD, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84131, AGR [CASE @D84130, COUNT @D84129, PER @D84128, 
            PLU @D84127, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84136, AGR [CASE @D84135, COUNT @D84134, PER @D84133, 
            PLU @D84132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84141, AGR [CASE @D84140, COUNT @D84139, PER @D84138, 
            PLU @D84137, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84146, AGR [CASE @D84145, COUNT @D84144, PER @D84143, 
            PLU @D84142, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84151, AGR [CASE @D84150, COUNT @D84149, PER @D84148, 
            PLU @D84147, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84156, AGR [CASE @D84155, COUNT @D84154, PER @D84153, 
            PLU @D84152, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84161, AGR [CASE @D84160, COUNT @D84159, PER @D84158, 
            PLU @D84157, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84166, AGR [CASE @D84165, COUNT @D84164, PER @D84163, 
            PLU @D84162, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84171, AGR [CASE @D84170, COUNT @D84169, PER @D84168, 
            PLU @D84167, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OUT, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84176, AGR [CASE @D84175, COUNT @D84174, PER @D84173, 
            PLU @D84172, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84181, 
      AGR [CASE @D84180, COUNT @D84179, PER @D84178, PLU @D84177, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84186, AGR [CASE @D84185, COUNT @D84184, PER @D84183, 
            PLU @D84182, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ONTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84191, AGR [CASE @D84190, COUNT @D84189, PER @D84188, 
            PLU @D84187, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84196, AGR [CASE @D84195, COUNT @D84194, PER @D84193, 
            PLU @D84192, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84201, AGR [CASE @D84200, COUNT @D84199, PER @D84198, 
            PLU @D84197, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OUT, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84206, AGR [CASE @D84205, COUNT @D84204, PER @D84203, 
            PLU @D84202, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84211, AGR [CASE @D84210, COUNT @D84209, PER @D84208, 
            PLU @D84207, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84216, AGR [CASE @D84215, COUNT @D84214, PER @D84213, 
            PLU @D84212, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84221, AGR [CASE @D84220, COUNT @D84219, PER @D84218, 
            PLU @D84217, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84226, AGR [CASE @D84225, COUNT @D84224, PER @D84223, 
            PLU @D84222, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT DOWN, PFORM ON, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84231, AGR [CASE @D84230, COUNT @D84229, PER @D84228, 
            PLU @D84227, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84236, 
      AGR [CASE @D84235, COUNT @D84234, PER @D84233, PLU @D84232, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84241, AGR [CASE @D84240, COUNT @D84239, PER @D84238, 
            PLU @D84237, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84246, AGR [CASE @D84245, COUNT @D84244, PER @D84243, 
            PLU @D84242, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84251, AGR [CASE @D84250, COUNT @D84249, PER @D84248, 
            PLU @D84247, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84256, AGR [CASE @D84255, COUNT @D84254, PER @D84253, 
            PLU @D84252, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84261, AGR [CASE @D84260, COUNT @D84259, PER @D84258, 
            PLU @D84257, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84266, AGR [CASE @D84265, COUNT @D84264, PER @D84263, 
            PLU @D84262, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84271, AGR [CASE @D84270, COUNT @D84269, PER @D84268, 
            PLU @D84267, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84276, AGR [CASE @D84275, COUNT @D84274, PER @D84273, 
            PLU @D84272, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84281, AGR [CASE @D84280, COUNT @D84279, PER @D84278, 
            PLU @D84277, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ROUND, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84286, 
      AGR [CASE @D84285, COUNT @D84284, PER @D84283, PLU @D84282, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ROUND, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84291, AGR [CASE @D84290, COUNT @D84289, PER @D84288, 
            PLU @D84287, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84296, AGR [CASE @D84295, COUNT @D84294, PER @D84293, 
            PLU @D84292, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84301, AGR [CASE @D84300, COUNT @D84299, PER @D84298, 
            PLU @D84297, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84306, 
      AGR [CASE @D84305, COUNT @D84304, PER @D84303, PLU @D84302, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AROUND, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84311, AGR [CASE @D84310, COUNT @D84309, PER @D84308, 
            PLU @D84307, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84316, AGR [CASE @D84315, COUNT @D84314, PER @D84313, 
            PLU @D84312, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84321, AGR [CASE @D84320, COUNT @D84319, PER @D84318, 
            PLU @D84317, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84326, AGR [CASE @D84325, COUNT @D84324, PER @D84323, 
            PLU @D84322, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84331, AGR [CASE @D84330, COUNT @D84329, PER @D84328, 
            PLU @D84327, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84336, AGR [CASE @D84335, COUNT @D84334, PER @D84333, 
            PLU @D84332, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AFTER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84341, AGR [CASE @D84340, COUNT @D84339, PER @D84338, 
            PLU @D84337, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84346, AGR [CASE @D84345, COUNT @D84344, PER @D84343, 
            PLU @D84342, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84351, AGR [CASE @D84350, COUNT @D84349, PER @D84348, 
            PLU @D84347, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84356, AGR [CASE @D84355, COUNT @D84354, PER @D84353, 
            PLU @D84352, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84361, AGR [CASE @D84360, COUNT @D84359, PER @D84358, 
            PLU @D84357, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84366, AGR [CASE @D84365, COUNT @D84364, PER @D84363, 
            PLU @D84362, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84371, AGR [CASE @D84370, COUNT @D84369, PER @D84368, 
            PLU @D84367, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84376, AGR [CASE @D84375, COUNT @D84374, PER @D84373, 
            PLU @D84372, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84381, AGR [CASE @D84380, COUNT @D84379, PER @D84378, 
            PLU @D84377, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84386, AGR [CASE @D84385, COUNT @D84384, PER @D84383, 
            PLU @D84382, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84391, AGR [CASE @D84390, COUNT @D84389, PER @D84388, 
            PLU @D84387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84396, AGR [CASE @D84395, COUNT @D84394, PER @D84393, 
            PLU @D84392, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84401, AGR [CASE @D84400, COUNT @D84399, PER @D84398, 
            PLU @D84397, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84406, AGR [CASE @D84405, COUNT @D84404, PER @D84403, 
            PLU @D84402, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84411, AGR [CASE @D84410, COUNT @D84409, PER @D84408, 
            PLU @D84407, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84416, AGR [CASE @D84415, COUNT @D84414, PER @D84413, 
            PLU @D84412, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84421, AGR [CASE @D84420, COUNT @D84419, PER @D84418, 
            PLU @D84417, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84426, AGR [CASE @D84425, COUNT @D84424, PER @D84423, 
            PLU @D84422, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84431, AGR [CASE @D84430, COUNT @D84429, PER @D84428, 
            PLU @D84427, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84436, AGR [CASE @D84435, COUNT @D84434, PER @D84433, 
            PLU @D84432, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84441, AGR [CASE @D84440, COUNT @D84439, PER @D84438, 
            PLU @D84437, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84446, AGR [CASE @D84445, COUNT @D84444, PER @D84443, 
            PLU @D84442, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84451, AGR [CASE @D84450, COUNT @D84449, PER @D84448, 
            PLU @D84447, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84456, AGR [CASE @D84455, COUNT @D84454, PER @D84453, 
            PLU @D84452, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84461, AGR [CASE @D84460, COUNT @D84459, PER @D84458, 
            PLU @D84457, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84466, AGR [CASE @D84465, COUNT @D84464, PER @D84463, 
            PLU @D84462, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84471, AGR [CASE @D84470, COUNT @D84469, PER @D84468, 
            PLU @D84467, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84476, AGR [CASE @D84475, COUNT @D84474, PER @D84473, 
            PLU @D84472, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84481, AGR [CASE @D84480, COUNT @D84479, PER @D84478, 
            PLU @D84477, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84486, AGR [CASE @D84485, COUNT @D84484, PER @D84483, 
            PLU @D84482, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84491, AGR [CASE @D84490, COUNT @D84489, PER @D84488, 
            PLU @D84487, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84496, AGR [CASE @D84495, COUNT @D84494, PER @D84493, 
            PLU @D84492, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84501, AGR [CASE @D84500, COUNT @D84499, PER @D84498, 
            PLU @D84497, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84506, AGR [CASE @D84505, COUNT @D84504, PER @D84503, 
            PLU @D84502, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84511, AGR [CASE @D84510, COUNT @D84509, PER @D84508, 
            PLU @D84507, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84516, AGR [CASE @D84515, COUNT @D84514, PER @D84513, 
            PLU @D84512, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84521, AGR [CASE @D84520, COUNT @D84519, PER @D84518, 
            PLU @D84517, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84526, AGR [CASE @D84525, COUNT @D84524, PER @D84523, 
            PLU @D84522, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84531, AGR [CASE @D84530, COUNT @D84529, PER @D84528, 
            PLU @D84527, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : LOOK.

WORD looking : 
   [COORD @D84546, PRD @D84545, AGR [CASE @D84544, COUNT @D84543, 
            PER @D84542, PLU @D84541, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, PREP AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84552, PRD @D84551, 
      AGR [CASE @D84550, COUNT @D84549, PER @D84548, PLU @D84547, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84558, PRD @D84557, AGR [CASE @D84556, COUNT @D84555, 
            PER @D84554, PLU @D84553, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84564, PRD @D84563, 
      AGR [CASE @D84562, COUNT @D84561, PER @D84560, PLU @D84559, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84570, PRD @D84569, AGR [CASE @D84568, COUNT @D84567, 
            PER @D84566, PLU @D84565, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM ON_AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84576, PRD @D84575, 
      AGR [CASE @D84574, COUNT @D84573, PER @D84572, PLU @D84571, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84582, PRD @D84581, AGR [CASE @D84580, COUNT @D84579, 
            PER @D84578, PLU @D84577, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_BSE, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84588, PRD @D84587, 
      AGR [CASE @D84586, COUNT @D84585, PER @D84584, PLU @D84583, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84594, PRD @D84593, AGR [CASE @D84592, COUNT @D84591, 
            PER @D84590, PLU @D84589, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84600, PRD @D84599, 
      AGR [CASE @D84598, COUNT @D84597, PER @D84596, PLU @D84595, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84606, PRD @D84605, AGR [CASE @D84604, COUNT @D84603, 
            PER @D84602, PLU @D84601, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84612, PRD @D84611, 
      AGR [CASE @D84610, COUNT @D84609, PER @D84608, PLU @D84607, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84618, PRD @D84617, AGR [CASE @D84616, COUNT @D84615, 
            PER @D84614, PLU @D84613, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, 
      PRT FORWARD, PREP TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84624, PRD @D84623, AGR [CASE @D84622, COUNT @D84621, 
            PER @D84620, PLU @D84619, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84630, PRD @D84629, 
      AGR [CASE @D84628, COUNT @D84627, PER @D84626, PLU @D84625, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOOK, 
   [COORD @D84636, PRD @D84635, AGR [CASE @D84634, COUNT @D84633, 
            PER @D84632, PLU @D84631, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84642, PRD @D84641, 
      AGR [CASE @D84640, COUNT @D84639, PER @D84638, PLU @D84637, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT FORWARD, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84648, PRD @D84647, AGR [CASE @D84646, COUNT @D84645, 
            PER @D84644, PLU @D84643, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84654, PRD @D84653, 
      AGR [CASE @D84652, COUNT @D84651, PER @D84650, PLU @D84649, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84660, PRD @D84659, AGR [CASE @D84658, COUNT @D84657, 
            PER @D84656, PLU @D84655, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84666, PRD @D84665, 
      AGR [CASE @D84664, COUNT @D84663, PER @D84662, PLU @D84661, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84672, PRD @D84671, AGR [CASE @D84670, COUNT @D84669, 
            PER @D84668, PLU @D84667, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84678, PRD @D84677, 
      AGR [CASE @D84676, COUNT @D84675, PER @D84674, PLU @D84673, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84684, PRD @D84683, AGR [CASE @D84682, COUNT @D84681, 
            PER @D84680, PLU @D84679, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84690, PRD @D84689, 
      AGR [CASE @D84688, COUNT @D84687, PER @D84686, PLU @D84685, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84696, PRD @D84695, AGR [CASE @D84694, COUNT @D84693, 
            PER @D84692, PLU @D84691, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT BACK, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84702, PRD @D84701, 
      AGR [CASE @D84700, COUNT @D84699, PER @D84698, PLU @D84697, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84708, PRD @D84707, AGR [CASE @D84706, COUNT @D84705, 
            PER @D84704, PLU @D84703, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84714, PRD @D84713, 
      AGR [CASE @D84712, COUNT @D84711, PER @D84710, PLU @D84709, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ROUND, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84720, PRD @D84719, AGR [CASE @D84718, COUNT @D84717, 
            PER @D84716, PLU @D84715, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84726, PRD @D84725, 
      AGR [CASE @D84724, COUNT @D84723, PER @D84722, PLU @D84721, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AROUND, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84732, PRD @D84731, AGR [CASE @D84730, COUNT @D84729, 
            PER @D84728, PLU @D84727, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84738, PRD @D84737, 
      AGR [CASE @D84736, COUNT @D84735, PER @D84734, PLU @D84733, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84744, PRD @D84743, AGR [CASE @D84742, COUNT @D84741, 
            PER @D84740, PLU @D84739, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84750, PRD @D84749, 
      AGR [CASE @D84748, COUNT @D84747, PER @D84746, PLU @D84745, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84756, PRD @D84755, AGR [CASE @D84754, COUNT @D84753, 
            PER @D84752, PLU @D84751, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84762, PRD @D84761, 
      AGR [CASE @D84760, COUNT @D84759, PER @D84758, PLU @D84757, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84768, PRD @D84767, AGR [CASE @D84766, COUNT @D84765, 
            PER @D84764, PLU @D84763, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84774, PRD @D84773, 
      AGR [CASE @D84772, COUNT @D84771, PER @D84770, PLU @D84769, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOOK, 
   [COORD @D84780, PRD @D84779, AGR [CASE @D84778, COUNT @D84777, 
            PER @D84776, PLU @D84775, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84786, PRD @D84785, 
      AGR [CASE @D84784, COUNT @D84783, PER @D84782, PLU @D84781, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOOK, 
   [COORD @D84792, PRD @D84791, AGR [CASE @D84790, COUNT @D84789, 
            PER @D84788, PLU @D84787, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84798, PRD @D84797, 
      AGR [CASE @D84796, COUNT @D84795, PER @D84794, PLU @D84793, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOOK, 
   [COORD @D84804, PRD @D84803, AGR [CASE @D84802, COUNT @D84801, 
            PER @D84800, PLU @D84799, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84810, PRD @D84809, 
      AGR [CASE @D84808, COUNT @D84807, PER @D84806, PLU @D84805, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOOK, 
   [COORD @D84816, PRD @D84815, AGR [CASE @D84814, COUNT @D84813, 
            PER @D84812, PLU @D84811, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84822, PRD @D84821, 
      AGR [CASE @D84820, COUNT @D84819, PER @D84818, PLU @D84817, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOOK, 
   [COORD @D84828, PRD @D84827, AGR [CASE @D84826, COUNT @D84825, 
            PER @D84824, PLU @D84823, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK, 
   [COORD @D84834, PRD @D84833, 
      AGR [CASE @D84832, COUNT @D84831, PER @D84830, PLU @D84829, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOOK, 
   [COORD @D84840, PRD @D84839, AGR [CASE @D84838, COUNT @D84837, 
            PER @D84836, PLU @D84835, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOOK.

WORD looks : 
   [COORD @D84849, REFL @D84848, PRD @D84847, CASE @D84846, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : LOOKS, 
   [COORD @D84854, DEMON @D84853, REFL @D84852, PRD @D84851, 
      CASE @D84850, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM AT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   LOOK, 
   [COORD @D84859, DEMON @D84858, REFL @D84857, PRD @D84856, CASE 
         @D84855, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LOOK, 
   [COORD @D84861, 
      AGR [COUNT @D84860, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, PREP AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84863, 
      AGR [COUNT @D84862, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM TO_FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84865, AGR [COUNT @D84864, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84867, AGR [COUNT @D84866, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84869, AGR [COUNT @D84868, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84871, AGR [COUNT @D84870, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84873, AGR [COUNT @D84872, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_BSE, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84875, AGR [COUNT @D84874, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84877, 
      AGR [COUNT @D84876, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84879, 
      AGR [COUNT @D84878, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84881, 
      AGR [COUNT @D84880, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84883, 
      AGR [COUNT @D84882, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84885, 
      AGR [COUNT @D84884, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT FORWARD, PREP TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84887, AGR [COUNT @D84886, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ON, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84889, AGR [COUNT @D84888, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84891, AGR [COUNT @D84890, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84893, AGR [COUNT @D84892, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT FORWARD, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84895, AGR [COUNT @D84894, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BACK, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84897, AGR [COUNT @D84896, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84899, AGR [COUNT @D84898, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84901, AGR [COUNT @D84900, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84903, AGR [COUNT @D84902, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84905, AGR [COUNT @D84904, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84907, AGR [COUNT @D84906, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84909, AGR [COUNT @D84908, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : LOOK, 
   [COORD @D84911, AGR [COUNT @D84910, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT BACK, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84913, AGR [COUNT @D84912, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84915, AGR [COUNT @D84914, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84917, AGR [COUNT @D84916, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ROUND, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84919, AGR [COUNT @D84918, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84921, AGR [COUNT @D84920, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AROUND, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84923, AGR [COUNT @D84922, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84925, AGR [COUNT @D84924, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84927, AGR [COUNT @D84926, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84929, AGR [COUNT @D84928, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : LOOK, 
   [COORD @D84931, AGR [COUNT @D84930, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84933, 
      AGR [COUNT @D84932, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84935, 
      AGR [COUNT @D84934, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84937, 
      AGR [COUNT @D84936, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84939, 
      AGR [COUNT @D84938, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84941, 
      AGR [COUNT @D84940, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84943, 
      AGR [COUNT @D84942, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOOK, 
   [COORD @D84945, AGR [COUNT @D84944, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84947, 
      AGR [COUNT @D84946, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84949, 
      AGR [COUNT @D84948, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84951, 
      AGR [COUNT @D84950, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84953, 
      AGR [COUNT @D84952, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84955, 
      AGR [COUNT @D84954, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84957, 
      AGR [COUNT @D84956, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK, 
   [COORD @D84959, 
      AGR [COUNT @D84958, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AHEAD, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOOK.

WORD lose : 
   [COORD @D84982, AGR [COUNT @D84981, PER @D84980, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : LOSE, 
   [COORD @D84984, AGR [COUNT @D84983, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : LOSE, 
   [COORD @D84986, AGR [COUNT @D84985, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : LOSE, 
   [COORD @D84990, AGR [COUNT @D84989, PER @D84988, PLU @D84987, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : LOSE, 
   [COORD @D84996, PAST @D84995, 
      AGR [CASE @D84994, COUNT @D84993, PER @D84992, PLU @D84991, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   LOSE, 
   [COORD @D84999, AGR [COUNT @D84998, PER @D84997, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LOSE, 
   [COORD @D85001, AGR [COUNT @D85000, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LOSE, 
   [COORD @D85003, AGR [COUNT @D85002, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : LOSE, 
   [COORD @D85007, AGR [COUNT @D85006, PER @D85005, PLU @D85004, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : LOSE, 
   [COORD @D85013, PAST @D85012, 
      AGR [CASE @D85011, COUNT @D85010, PER @D85009, PLU @D85008, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : LOSE, 
   [COORD @D85016, AGR [COUNT @D85015, PER @D85014, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : LOSE, 
   [COORD @D85018, AGR [COUNT @D85017, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : LOSE, 
   [COORD @D85020, AGR [COUNT @D85019, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : LOSE, 
   [COORD @D85024, AGR [COUNT @D85023, PER @D85022, PLU @D85021, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : LOSE, 
   [COORD @D85030, PAST @D85029, 
      AGR [CASE @D85028, COUNT @D85027, PER @D85026, PLU @D85025, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      ARITY 3] : LOSE, 
   [COORD @D85033, AGR [COUNT @D85032, PER @D85031, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : LOSE, 
   [COORD @D85035, AGR [COUNT @D85034, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : LOSE, 
   [COORD @D85037, AGR [COUNT @D85036, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : LOSE, 
   [COORD @D85041, AGR [COUNT @D85040, PER @D85039, PLU @D85038, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, ARITY 3] : LOSE, 
   [COORD @D85047, PAST @D85046, 
      AGR [CASE @D85045, COUNT @D85044, PER @D85043, PLU @D85042, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM IN, 
      ARITY 3] : LOSE, 
   [COORD @D85050, AGR [COUNT @D85049, PER @D85048, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : LOSE, 
   [COORD @D85052, AGR [COUNT @D85051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : LOSE, 
   [COORD @D85054, AGR [COUNT @D85053, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : LOSE, 
   [COORD @D85058, AGR [COUNT @D85057, PER @D85056, PLU @D85055, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM BY, ARITY 3] : LOSE, 
   [COORD @D85064, PAST @D85063, 
      AGR [CASE @D85062, COUNT @D85061, PER @D85060, PLU @D85059, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM BY, 
      ARITY 3] : LOSE, 
   [COORD @D85067, AGR [COUNT @D85066, PER @D85065, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LOSE, 
   [COORD @D85069, AGR [COUNT @D85068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LOSE, 
   [COORD @D85071, AGR [COUNT @D85070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : LOSE, 
   [COORD @D85075, AGR [COUNT @D85074, PER @D85073, PLU @D85072, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : LOSE, 
   [COORD @D85081, PAST @D85080, AGR [CASE @D85079, COUNT @D85078, 
            PER @D85077, PLU @D85076, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : LOSE, 
   [COORD @D85084, AGR [COUNT @D85083, PER @D85082, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : LOSE, 
   [COORD @D85086, AGR [COUNT @D85085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : LOSE, 
   [COORD @D85088, AGR [COUNT @D85087, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : LOSE, 
   [COORD @D85092, AGR [COUNT @D85091, PER @D85090, PLU @D85089, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : LOSE, 
   [COORD @D85098, PAST @D85097, AGR [CASE @D85096, COUNT @D85095, 
            PER @D85094, PLU @D85093, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM TO, ARITY 2] : LOSE, 
   [COORD @D85101, 
      AGR [COUNT @D85100, PER @D85099, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM ON, 
      ARITY 2] : LOSE, 
   [COORD @D85103, AGR [COUNT @D85102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85105, AGR [COUNT @D85104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85109, AGR [COUNT @D85108, PER @D85107, PLU @D85106, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85115, PAST @D85114, AGR [CASE @D85113, COUNT @D85112, 
            PER @D85111, PLU @D85110, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85118, 
      AGR [COUNT @D85117, PER @D85116, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85120, AGR [COUNT @D85119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85122, AGR [COUNT @D85121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85126, AGR [COUNT @D85125, PER @D85124, PLU @D85123, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85132, PAST @D85131, 
      AGR [CASE @D85130, COUNT @D85129, PER @D85128, PLU @D85127, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM ON, ARITY 2] : LOSE, 
   [COORD @D85135, AGR [COUNT @D85134, PER @D85133, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : LOSE, 
   [COORD @D85137, AGR [COUNT @D85136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : LOSE, 
   [COORD @D85139, AGR [COUNT @D85138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : LOSE, 
   [COORD @D85143, AGR [COUNT @D85142, PER @D85141, PLU @D85140, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM BY, ARITY 2] : LOSE, 
   [COORD @D85149, PAST @D85148, AGR [CASE @D85147, COUNT @D85146, 
            PER @D85145, PLU @D85144, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM BY, ARITY 2] : LOSE, 
   [COORD @D85152, 
      AGR [COUNT @D85151, PER @D85150, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   LOSE, 
   [COORD @D85154, AGR [COUNT @D85153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LOSE, 
   [COORD @D85156, AGR [COUNT @D85155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : LOSE, 
   [COORD @D85160, AGR [COUNT @D85159, PER @D85158, PLU @D85157, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : LOSE, 
   [COORD @D85166, PAST @D85165, 
      AGR [CASE @D85164, COUNT @D85163, PER @D85162, PLU @D85161, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   LOSE, 
   [COORD @D85169, AGR [COUNT @D85168, PER @D85167, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LOSE, 
   [COORD @D85171, AGR [COUNT @D85170, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LOSE, 
   [COORD @D85173, AGR [COUNT @D85172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : LOSE, 
   [COORD @D85177, AGR [COUNT @D85176, PER @D85175, PLU @D85174, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : LOSE, 
   [COORD @D85183, PAST @D85182, 
      AGR [CASE @D85181, COUNT @D85180, PER @D85179, PLU @D85178, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : LOSE.

WORD loses : 
   [COORD @D85190, AGR [COUNT @D85189, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85192, 
      AGR [COUNT @D85191, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85194, 
      AGR [COUNT @D85193, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85196, 
      AGR [COUNT @D85195, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85198, 
      AGR [COUNT @D85197, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85200, 
      AGR [COUNT @D85199, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85202, 
      AGR [COUNT @D85201, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85204, 
      AGR [COUNT @D85203, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85206, 
      AGR [COUNT @D85205, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   LOSE, 
   [COORD @D85208, AGR [COUNT @D85207, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85210, 
      AGR [COUNT @D85209, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE, 
   [COORD @D85212, 
      AGR [COUNT @D85211, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOSE.

WORD losing : 
   [COORD @D85222, PRD @D85221, AGR [CASE @D85220, COUNT @D85219, 
            PER @D85218, PLU @D85217, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOSE, 
   [COORD @D85228, PRD @D85227, 
      AGR [CASE @D85226, COUNT @D85225, PER @D85224, PLU @D85223, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOSE, 
   [COORD @D85234, PRD @D85233, AGR [CASE @D85232, COUNT @D85231, 
            PER @D85230, PLU @D85229, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOSE, 
   [COORD @D85240, PRD @D85239, 
      AGR [CASE @D85238, COUNT @D85237, PER @D85236, PLU @D85235, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOSE, 
   [COORD @D85246, PRD @D85245, AGR [CASE @D85244, COUNT @D85243, 
            PER @D85242, PLU @D85241, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOSE, 
   [COORD @D85252, PRD @D85251, 
      AGR [CASE @D85250, COUNT @D85249, PER @D85248, PLU @D85247, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOSE, 
   [COORD @D85258, PRD @D85257, AGR [CASE @D85256, COUNT @D85255, 
            PER @D85254, PLU @D85253, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : LOSE, 
   [COORD @D85264, PRD @D85263, 
      AGR [CASE @D85262, COUNT @D85261, PER @D85260, PLU @D85259, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOSE, 
   [COORD @D85270, PRD @D85269, AGR [CASE @D85268, COUNT @D85267, 
            PER @D85266, PLU @D85265, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : LOSE, 
   [COORD @D85276, PRD @D85275, 
      AGR [CASE @D85274, COUNT @D85273, PER @D85272, PLU @D85271, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOSE, 
   [COORD @D85282, PRD @D85281, AGR [CASE @D85280, COUNT @D85279, 
            PER @D85278, PLU @D85277, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOSE, 
   [COORD @D85288, PRD @D85287, 
      AGR [CASE @D85286, COUNT @D85285, PER @D85284, PLU @D85283, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : LOSE.

WORD lost : 
   [COADV @D85300, COORD @D85299, DEF @D85298, PRD @D85297, AGR 
            [CASE @D85296, COUNT @D85295, PER @D85294, PLU @D85293, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : LOST, 
   [COADV @D85308, COORD @D85307, DEF @D85306, PRD @D85305, 
      AGR [CASE @D85304, COUNT @D85303, PER @D85302, PLU @D85301, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PRD] : LOST, 
   [COADV @D85316, COORD @D85315, DEF @D85314, PRD @D85313, 
      AGR [CASE @D85312, COUNT @D85311, PER @D85310, PLU @D85309, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UP, 
      DISTR PRD, ARITY 2] : LOST, 
   [COADV @D85324, COORD @D85323, DEF @D85322, PRD @D85321, 
      AGR [CASE @D85320, COUNT @D85319, PER @D85318, PLU @D85317, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      DISTR PRD, ARITY 2] : LOST, 
   [COADV @D85332, COORD @D85331, DEF @D85330, PRD @D85329, 
      AGR [CASE @D85328, COUNT @D85327, PER @D85326, PLU @D85325, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      DISTR PRD, ARITY 2] : LOST, 
   [COORD @D85338, PAST @D85337, AGR [CASE @D85336, COUNT @D85335, 
            PER @D85334, PLU @D85333, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : LOSE, 
   [COORD @D85344, PAST @D85343, 
      AGR [CASE @D85342, COUNT @D85341, PER @D85340, PLU @D85339, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : LOSE, 
   
   [COORD @D85350, PAST @D85349, AGR [CASE @D85348, COUNT @D85347, PER 
               @D85346, PLU @D85345, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : LOSE, 
   [COORD @D85356, PAST @D85355, 
      AGR [CASE @D85354, COUNT @D85353, PER @D85352, PLU @D85351, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : LOSE, 
   [COORD @D85362, PAST @D85361, AGR [CASE @D85360, COUNT @D85359, 
            PER @D85358, PLU @D85357, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : LOSE, 
   [COORD @D85368, PAST @D85367, 
      AGR [CASE @D85366, COUNT @D85365, PER @D85364, PLU @D85363, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, FIN -, 
      ARITY 3] : LOSE, 
   [COORD @D85374, PAST @D85373, AGR [CASE @D85372, COUNT @D85371, 
            PER @D85370, PLU @D85369, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, FIN -, ARITY 3] : LOSE, 
   [COORD @D85380, PAST @D85379, 
      AGR [CASE @D85378, COUNT @D85377, PER @D85376, PLU @D85375, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM IN, FIN -, 
      ARITY 3] : LOSE, 
   [COORD @D85386, PAST @D85385, AGR [CASE @D85384, COUNT @D85383, 
            PER @D85382, PLU @D85381, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM BY, FIN -, ARITY 3] : LOSE, 
   [COORD @D85392, PAST @D85391, 
      AGR [CASE @D85390, COUNT @D85389, PER @D85388, PLU @D85387, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM BY, FIN -, 
      ARITY 3] : LOSE, 
   [COORD @D85396, AGR [COUNT @D85395, PER @D85394, PLU @D85393, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : LOSE, 
   [COORD @D85400, AGR [COUNT @D85399, PER @D85398, PLU @D85397, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : LOSE, 
   [COORD @D85404, AGR [COUNT @D85403, PER @D85402, PLU @D85401, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ON, PAST +, ARITY 3] : LOSE, 
   [COORD @D85408, AGR [COUNT @D85407, PER @D85406, PLU @D85405, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM IN, PAST +, ARITY 3] : LOSE, 
   [COORD @D85412, AGR [COUNT @D85411, PER @D85410, PLU @D85409, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM BY, PAST +, ARITY 3] : LOSE, 
   [COORD @D85418, PAST @D85417, AGR [CASE @D85416, COUNT @D85415, 
            PER @D85414, PLU @D85413, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : LOSE, 
   [COORD @D85424, PAST @D85423, 
      AGR [CASE @D85422, COUNT @D85421, PER @D85420, PLU @D85419, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : LOSE, 
   [COORD @D85430, PAST @D85429, 
      AGR [CASE @D85428, COUNT @D85427, PER @D85426, PLU @D85425, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM TO, FIN -, 
      ARITY 2] : LOSE, 
   [COORD @D85436, PAST @D85435, AGR [CASE @D85434, COUNT @D85433, 
            PER @D85432, PLU @D85431, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM ON, FIN -, ARITY 2] : LOSE, 
   [COORD @D85442, PAST @D85441, 
      AGR [CASE @D85440, COUNT @D85439, PER @D85438, PLU @D85437, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, PFORM ON, FIN -, 
      ARITY 2] : LOSE, 
   [COORD @D85448, PAST @D85447, AGR [CASE @D85446, COUNT @D85445, 
            PER @D85444, PLU @D85443, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM BY, FIN -, ARITY 2] : LOSE, 
   [COORD @D85452, 
      AGR [COUNT @D85451, PER @D85450, PLU @D85449, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : LOSE, 
   [COORD @D85456, AGR [COUNT @D85455, PER @D85454, PLU @D85453, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, PAST +, ARITY 2] : LOSE, 
   [COORD @D85460, AGR [COUNT @D85459, PER @D85458, PLU @D85457, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM ON, PAST +, ARITY 2] : LOSE, 
   [COORD @D85464, AGR [COUNT @D85463, PER @D85462, PLU @D85461, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM ON, PAST +, ARITY 2] : LOSE, 
   [COORD @D85468, AGR [COUNT @D85467, PER @D85466, PLU @D85465, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM BY, PAST +, ARITY 2] : LOSE, 
   [COORD @D85474, PAST @D85473, AGR [CASE @D85472, COUNT @D85471, 
            PER @D85470, PLU @D85469, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : LOSE, 
   [COORD @D85480, PAST @D85479, 
      AGR [CASE @D85478, COUNT @D85477, PER @D85476, PLU @D85475, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : LOSE, 
   [COORD @D85484, AGR [COUNT @D85483, PER @D85482, PLU @D85481, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : LOSE, 
   [COORD @D85488, AGR [COUNT @D85487, PER @D85486, PLU @D85485, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : LOSE.

WORD love : 
   [COORD @D85517, REFL @D85516, PRD @D85515, CASE @D85514, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, ADDRESS +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : LOVE, 
   [COORD @D85521, REFL @D85520, PRD @D85519, CASE @D85518, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : LOVE, 
   [COORD @D85525, REFL @D85524, PRD @D85523, CASE @D85522, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : LOVE, 
   [COORD @D85530, REFL @D85529, COUNT @D85528, PRD @D85527, 
      CASE @D85526, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : LOVE, 
   [COORD @D85535, REFL @D85534, COUNT @D85533, PRD @D85532, 
      CASE @D85531, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : 
   LOVE, 
   [COORD @D85538, AGR [COUNT @D85537, PER @D85536, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LOVE, 
   [COORD @D85540, AGR [COUNT @D85539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LOVE, 
   [COORD @D85542, AGR [COUNT @D85541, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LOVE, 
   [COORD @D85546, AGR [COUNT @D85545, PER @D85544, PLU @D85543, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : LOVE, 
   [COORD @D85552, PAST @D85551, AGR [CASE @D85550, COUNT @D85549, 
            PER @D85548, PLU @D85547, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SINF, ARITY 2] : LOVE, 
   [COORD @D85555, AGR [COUNT @D85554, PER @D85553, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LOVE, 
   [COORD @D85557, AGR [COUNT @D85556, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LOVE, 
   [COORD @D85559, AGR [COUNT @D85558, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LOVE, 
   [COORD @D85563, AGR [COUNT @D85562, PER @D85561, PLU @D85560, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : LOVE, 
   [COORD @D85569, PAST @D85568, AGR [CASE @D85567, COUNT @D85566, 
            PER @D85565, PLU @D85564, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : LOVE, 
   [COORD @D85572, AGR [COUNT @D85571, PER @D85570, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOVE, 
   [COORD @D85574, AGR [COUNT @D85573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOVE, 
   [COORD @D85576, AGR [COUNT @D85575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOVE, 
   [COORD @D85580, AGR [COUNT @D85579, PER @D85578, PLU @D85577, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : LOVE, 
   [COORD @D85586, PAST @D85585, AGR [CASE @D85584, COUNT @D85583, 
            PER @D85582, PLU @D85581, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : LOVE, 
   [COORD @D85589, AGR [COUNT @D85588, PER @D85587, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LOVE, 
   [COORD @D85591, AGR [COUNT @D85590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LOVE, 
   [COORD @D85593, AGR [COUNT @D85592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LOVE, 
   [COORD @D85597, AGR [COUNT @D85596, PER @D85595, PLU @D85594, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : LOVE, 
   [COORD @D85603, PAST @D85602, AGR [CASE @D85601, COUNT @D85600, 
            PER @D85599, PLU @D85598, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : LOVE, 
   [COORD @D85606, AGR [COUNT @D85605, PER @D85604, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOVE, 
   [COORD @D85608, AGR [COUNT @D85607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOVE, 
   [COORD @D85610, AGR [COUNT @D85609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : LOVE, 
   [COORD @D85614, AGR [COUNT @D85613, PER @D85612, PLU @D85611, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : LOVE, 
   [COORD @D85620, PAST @D85619, AGR [CASE @D85618, COUNT @D85617, 
            PER @D85616, PLU @D85615, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : LOVE.

WORD loved : 
   [COORD @D85632, AGR [CASE @D85631, COUNT @D85630, PER @D85629, 
            PLU @D85628, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85637, AGR [CASE @D85636, COUNT @D85635, PER @D85634, 
            PLU @D85633, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85642, AGR [CASE @D85641, COUNT @D85640, PER @D85639, 
            PLU @D85638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85647, AGR [CASE @D85646, COUNT @D85645, PER @D85644, 
            PLU @D85643, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85652, AGR [CASE @D85651, COUNT @D85650, PER @D85649, 
            PLU @D85648, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85657, AGR [CASE @D85656, COUNT @D85655, PER @D85654, 
            PLU @D85653, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85662, AGR [CASE @D85661, COUNT @D85660, PER @D85659, 
            PLU @D85658, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85667, AGR [CASE @D85666, COUNT @D85665, PER @D85664, 
            PLU @D85663, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85673, AGR [CASE @D85672, NFORM @D85671, COUNT @D85670, 
            PER @D85669, PLU @D85668, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOVE, 
   [COORD @D85678, AGR [UB @D85677, VFORM @D85676, SUBJ @D85675, 
            FIN @D85674, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : LOVE, 
   [COORD @D85683, AGR [CASE @D85682, COUNT @D85681, PER @D85680, 
            PLU @D85679, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : LOVE, 
   [COORD @D85688, AGR [CASE @D85687, COUNT @D85686, PER @D85685, 
            PLU @D85684, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85693, AGR [CASE @D85692, COUNT @D85691, PER @D85690, 
            PLU @D85689, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : LOVE.

WORD loves : 
   [COORD @D85705, DEMON @D85704, REFL @D85703, PRD @D85702, CASE 
         @D85701, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : LOVE, 
   [COORD @D85710, DEMON @D85709, REFL @D85708, PRD @D85707, 
      CASE @D85706, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   LOVE, 
   [COORD @D85712, AGR [COUNT @D85711, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOVE, 
   [COORD @D85714, 
      AGR [COUNT @D85713, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOVE, 
   [COORD @D85716, 
      AGR [COUNT @D85715, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOVE, 
   [COORD @D85718, 
      AGR [COUNT @D85717, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOVE, 
   [COORD @D85720, 
      AGR [COUNT @D85719, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : LOVE.

WORD loving : 
   [COORD @D85731, PRD @D85730, AGR [CASE @D85729, COUNT @D85728, 
            PER @D85727, PLU @D85726, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85737, PRD @D85736, 
      AGR [CASE @D85735, COUNT @D85734, PER @D85733, PLU @D85732, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOVE, 
   [COORD @D85743, PRD @D85742, AGR [CASE @D85741, COUNT @D85740, 
            PER @D85739, PLU @D85738, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOVE, 
   [COORD @D85749, PRD @D85748, 
      AGR [CASE @D85747, COUNT @D85746, PER @D85745, PLU @D85744, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   LOVE, 
   [COORD @D85755, PRD @D85754, AGR [CASE @D85753, COUNT @D85752, 
            PER @D85751, PLU @D85750, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : LOVE.

WORD made : 
   [COADV @D85769, COORD @D85768, DEF @D85767, PRD @D85766, AGR 
            [CASE @D85765, COUNT @D85764, PER @D85763, PLU @D85762, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : MADE, 
   [COADV @D85778, COORD @D85777, DISTR @D85776, DEF @D85775, 
      PRD @D85774, 
      AGR [CASE @D85773, COUNT @D85772, PER @D85771, PLU @D85770, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP] : MADE, 
   [COADV @D85786, COORD @D85785, DEF @D85784, PRD @D85783, 
      AGR [CASE @D85782, COUNT @D85781, PER @D85780, PLU @D85779, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM OF, DISTR PRD, ARITY 2] : MADE, 
   [COADV @D85794, COORD @D85793, DEF @D85792, PRD @D85791, 
      AGR [CASE @D85790, COUNT @D85789, PER @D85788, PLU @D85787, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      DISTR PRD, ARITY 2] : MADE, 
   [COORD @D85800, PAST @D85799, AGR [CASE @D85798, COUNT @D85797, 
            PER @D85796, PLU @D85795, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : MAKE, 
   [COORD @D85806, PAST @D85805, 
      AGR [CASE @D85804, COUNT @D85803, PER @D85802, PLU @D85801, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : MAKE, 
   
   [COORD @D85812, PAST @D85811, AGR [CASE @D85810, COUNT @D85809, PER 
               @D85808, PLU @D85807, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : MAKE, 
   [COORD @D85818, PAST @D85817, 
      AGR [CASE @D85816, COUNT @D85815, PER @D85814, PLU @D85813, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : MAKE, 
   [COORD @D85824, PAST @D85823, AGR [CASE @D85822, COUNT @D85821, 
            PER @D85820, PLU @D85819, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OUT_OF, FIN -, ARITY 3] : MAKE, 
   [COORD @D85830, PAST @D85829, 
      AGR [CASE @D85828, COUNT @D85827, PER @D85826, PLU @D85825, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OUT_OF, FIN -, 
      ARITY 3] : MAKE, 
   [COORD @D85836, PAST @D85835, AGR [CASE @D85834, COUNT @D85833, 
            PER @D85832, PLU @D85831, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OF, FIN -, ARITY 3] : MAKE, 
   [COORD @D85842, PAST @D85841, 
      AGR [CASE @D85840, COUNT @D85839, PER @D85838, PLU @D85837, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OF, FIN -, 
      ARITY 3] : MAKE, 
   [COORD @D85848, PAST @D85847, AGR [CASE @D85846, COUNT @D85845, 
            PER @D85844, PLU @D85843, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : MAKE, 
   [COORD @D85854, PAST @D85853, 
      AGR [CASE @D85852, COUNT @D85851, PER @D85850, PLU @D85849, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM INTO, FIN -, 
      ARITY 3] : MAKE, 
   [COORD @D85860, PAST @D85859, AGR [CASE @D85858, COUNT @D85857, 
            PER @D85856, PLU @D85855, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : MAKE, 
   [COORD @D85866, PAST @D85865, 
      AGR [CASE @D85864, COUNT @D85863, PER @D85862, PLU @D85861, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, FIN -, 
      ARITY 3] : MAKE, 
   [COORD @D85872, PAST @D85871, AGR [CASE @D85870, COUNT @D85869, 
            PER @D85868, PLU @D85867, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM WITH, FIN -, ARITY 3] : MAKE, 
   [COORD @D85878, PAST @D85877, 
      AGR [CASE @D85876, COUNT @D85875, PER @D85874, PLU @D85873, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, FIN -, ARITY 3] : MAKE, 
   [COORD @D85884, PAST @D85883, AGR 
         [CASE @D85882, COUNT @D85881, PER @D85880, PLU @D85879, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM TO, 
      FIN -, ARITY 3] : MAKE, 
   [COORD @D85890, PAST @D85889, AGR [CASE @D85888, COUNT @D85887, 
            PER @D85886, PLU @D85885, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM TO, FIN -, ARITY 3] : MAKE, 
   [COORD @D85896, PAST @D85895, 
      AGR [CASE @D85894, COUNT @D85893, PER @D85892, PLU @D85891, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, PFORM TO, 
      FIN -, ARITY 3] : MAKE, 
   [COORD @D85902, PAST @D85901, AGR [CASE @D85900, COUNT @D85899, 
            PER @D85898, PLU @D85897, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, PFORM TO, FIN -, ARITY 3] : MAKE, 
   [COORD @D85908, PAST @D85907, 
      AGR [CASE @D85906, COUNT @D85905, PER @D85904, PLU @D85903, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM INTO, 
      FIN -, ARITY 3] : MAKE, 
   [COORD @D85914, PAST @D85913, AGR [CASE @D85912, COUNT @D85911, 
            PER @D85910, PLU @D85909, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM INTO, FIN -, ARITY 3] : MAKE, 
   [COORD @D85920, PAST @D85919, 
      AGR [CASE @D85918, COUNT @D85917, PER @D85916, PLU @D85915, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, 
      PFORM INTO, FIN -, ARITY 3] : MAKE, 
   [COORD @D85926, PAST @D85925, AGR 
         [CASE @D85924, COUNT @D85923, PER @D85922, PLU @D85921, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, 
      PFORM INTO, FIN -, ARITY 3] : MAKE, 
   [COORD @D85932, PAST @D85931, AGR 
         [CASE @D85930, COUNT @D85929, PER @D85928, PLU @D85927, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, REG -, PRT UP, 
      PFORM AS, FIN -, ARITY 3] : MAKE, 
   [COORD @D85938, PAST @D85937, AGR [CASE @D85936, COUNT @D85935, 
            PER @D85934, PLU @D85933, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, REG -, PRT UP, PFORM AS, FIN -, ARITY 3] : MAKE, 
   [COORD @D85942, 
      AGR [COUNT @D85941, PER @D85940, PLU @D85939, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : MAKE, 
   [COORD @D85946, AGR [COUNT @D85945, PER @D85944, PLU @D85943, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : MAKE, 
   [COORD @D85950, AGR [COUNT @D85949, PER @D85948, PLU @D85947, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OUT_OF, PAST +, ARITY 3] : MAKE, 
   [COORD @D85954, AGR [COUNT @D85953, PER @D85952, PLU @D85951, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, PAST +, ARITY 3] : MAKE, 
   [COORD @D85958, AGR [COUNT @D85957, PER @D85956, PLU @D85955, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM INTO, PAST +, ARITY 3] : MAKE, 
   [COORD @D85962, AGR [COUNT @D85961, PER @D85960, PLU @D85959, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, PAST +, ARITY 3] : MAKE, 
   [COORD @D85966, AGR [COUNT @D85965, PER @D85964, PLU @D85963, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM WITH, PAST +, ARITY 3] : MAKE, 
   [COORD @D85970, AGR [COUNT @D85969, PER @D85968, PLU @D85967, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM TO, PAST +, ARITY 3] : MAKE, 
   [COORD @D85974, AGR [COUNT @D85973, PER @D85972, PLU @D85971, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PFORM TO, PAST +, ARITY 3] : MAKE, 
   [COORD @D85978, AGR [COUNT @D85977, PER @D85976, PLU @D85975, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM INTO, PAST +, ARITY 3] : MAKE, 
   [COORD @D85982, AGR [COUNT @D85981, PER @D85980, PLU @D85979, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PFORM INTO, PAST +, ARITY 3] : MAKE, 
   [COORD @D85986, AGR [COUNT @D85985, PER @D85984, PLU @D85983, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, REG -, 
      PRT UP, PFORM AS, PAST +, ARITY 3] : MAKE, 
   [COORD @D85991, AGR [CASE @D85990, COUNT @D85989, PER @D85988, 
            PLU @D85987, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, VFORM EN, FIN -, PAST NOT, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PSVE +, PRD +, ARITY 2] : MAKE, 
   [COORD @D85997, PAST @D85996, 
      AGR [CASE @D85995, COUNT @D85994, PER @D85993, PLU @D85992, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, FIN -, ARITY 2] : 
   MAKE, 
   [COORD @D86003, PAST @D86002, AGR [CASE @D86001, COUNT @D86000, 
            PER @D85999, PLU @D85998, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, FIN -, ARITY 2] : MAKE, 
   [COORD @D86006, AGR @D86005, PAST @D86004, VFORM EN, SUBCAT OC_BSE, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86012, PAST @D86011, AGR [CASE @D86010, COUNT @D86009, 
            PER @D86008, PLU @D86007, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, REG -, FIN -, ARITY 2] : MAKE, 
   [COORD @D86015, AGR @D86014, PAST @D86013, VFORM EN, SUBCAT OC_AP, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86021, PAST @D86020, AGR [CASE @D86019, COUNT @D86018, 
            PER @D86017, PLU @D86016, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 2] : MAKE, 
   [COORD @D86027, PAST @D86026, 
      AGR [CASE @D86025, COUNT @D86024, PER @D86023, PLU @D86022, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86033, PAST @D86032, AGR [CASE @D86031, COUNT @D86030, 
            PER @D86029, PLU @D86028, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : MAKE, 
   [COORD @D86039, PAST @D86038, 
      AGR [CASE @D86037, COUNT @D86036, PER @D86035, PLU @D86034, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, FIN -, ARITY 2] : MAKE, 
   [COORD @D86045, PAST @D86044, 
      AGR [CASE @D86043, COUNT @D86042, PER @D86041, PLU @D86040, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, PRT OUT, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86051, PAST @D86050, AGR [CASE @D86049, COUNT @D86048, 
            PER @D86047, PLU @D86046, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PRT OUT, FIN -, ARITY 2] : MAKE, 
   [COORD @D86057, PAST @D86056, 
      AGR [CASE @D86055, COUNT @D86054, PER @D86053, PLU @D86052, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT OUT, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86060, AGR @D86059, PAST @D86058, VFORM EN, SUBCAT OC_INF, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, FIN -, ARITY 2] : MAKE, 
   [COORD @D86066, PAST @D86065, AGR [CASE @D86064, COUNT @D86063, 
            PER @D86062, PLU @D86061, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, PRT OUT, FIN -, ARITY 2] : MAKE, 
   [COORD @D86069, AGR @D86068, PAST @D86067, VFORM EN, SUBCAT OC_AP, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, FIN -, ARITY 2] : MAKE, 
   [COORD @D86075, PAST @D86074, AGR [CASE @D86073, COUNT @D86072, 
            PER @D86071, PLU @D86070, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, PRT OUT, FIN -, ARITY 2] : MAKE, 
   [COORD @D86081, PAST @D86080, 
      AGR [CASE @D86079, COUNT @D86078, PER @D86077, PLU @D86076, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM WITH, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86087, PAST @D86086, AGR [CASE @D86085, COUNT @D86084, 
            PER @D86083, PLU @D86082, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM WITH, FIN -, ARITY 2] : MAKE, 
   [COORD @D86093, PAST @D86092, 
      AGR [CASE @D86091, COUNT @D86090, PER @D86089, PLU @D86088, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, PFORM WITH, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86099, PAST @D86098, AGR [CASE @D86097, COUNT @D86096, 
            PER @D86095, PLU @D86094, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM WITH, FIN -, ARITY 2] : MAKE, 
   [COORD @D86105, PAST @D86104, 
      AGR [CASE @D86103, COUNT @D86102, PER @D86101, PLU @D86100, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OFF, PFORM WITH, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86111, PAST @D86110, AGR [CASE @D86109, COUNT @D86108, 
            PER @D86107, PLU @D86106, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, PFORM WITH, FIN -, ARITY 2] : MAKE, 
   [COORD @D86117, PAST @D86116, 
      AGR [CASE @D86115, COUNT @D86114, PER @D86113, PLU @D86112, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, PFORM WITH, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86123, PAST @D86122, AGR [CASE @D86121, COUNT @D86120, 
            PER @D86119, PLU @D86118, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM TOWARDS, FIN -, ARITY 2] : MAKE, 
   [COORD @D86129, PAST @D86128, 
      AGR [CASE @D86127, COUNT @D86126, PER @D86125, PLU @D86124, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TOWARDS, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86135, PAST @D86134, AGR [CASE @D86133, COUNT @D86132, 
            PER @D86131, PLU @D86130, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM TOWARD, FIN -, ARITY 2] : MAKE, 
   [COORD @D86141, PAST @D86140, 
      AGR [CASE @D86139, COUNT @D86138, PER @D86137, PLU @D86136, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TOWARD, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86147, PAST @D86146, AGR [CASE @D86145, COUNT @D86144, 
            PER @D86143, PLU @D86142, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM TO, FIN -, ARITY 2] : MAKE, 
   [COORD @D86153, PAST @D86152, 
      AGR [CASE @D86151, COUNT @D86150, PER @D86149, PLU @D86148, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM TO, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86159, PAST @D86158, AGR [CASE @D86157, COUNT @D86156, 
            PER @D86155, PLU @D86154, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM INTO, FIN -, ARITY 2] : MAKE, 
   [COORD @D86165, PAST @D86164, 
      AGR [CASE @D86163, COUNT @D86162, PER @D86161, PLU @D86160, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM FOR, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86171, PAST @D86170, AGR [CASE @D86169, COUNT @D86168, 
            PER @D86167, PLU @D86166, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM FOR, FIN -, ARITY 2] : MAKE, 
   [COORD @D86177, PAST @D86176, 
      AGR [CASE @D86175, COUNT @D86174, PER @D86173, PLU @D86172, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM FOR, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86183, PAST @D86182, AGR [CASE @D86181, COUNT @D86180, 
            PER @D86179, PLU @D86178, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT UP, PFORM FOR, FIN -, ARITY 2] : MAKE, 
   [COORD @D86189, PAST @D86188, 
      AGR [CASE @D86187, COUNT @D86186, PER @D86185, PLU @D86184, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, PFORM AS, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86195, PAST @D86194, AGR [CASE @D86193, COUNT @D86192, 
            PER @D86191, PLU @D86190, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AFTER, FIN -, ARITY 2] : MAKE, 
   [COORD @D86201, PAST @D86200, 
      AGR [CASE @D86199, COUNT @D86198, PER @D86197, PLU @D86196, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AFTER, FIN -, 
      ARITY 2] : MAKE, 
   [COORD @D86207, PAST @D86206, AGR [CASE @D86205, COUNT @D86204, 
            PER @D86203, PLU @D86202, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : MAKE, 
   [COORD @D86213, PAST @D86212, 
      AGR [CASE @D86211, COUNT @D86210, PER @D86209, PLU @D86208, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86219, PAST @D86218, AGR [CASE @D86217, COUNT @D86216, 
            PER @D86215, PLU @D86214, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : MAKE, 
   [COORD @D86225, PAST @D86224, 
      AGR [CASE @D86223, COUNT @D86222, PER @D86221, PLU @D86220, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86231, PAST @D86230, AGR [CASE @D86229, COUNT @D86228, 
            PER @D86227, PLU @D86226, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : MAKE, 
   [COORD @D86237, PAST @D86236, 
      AGR [CASE @D86235, COUNT @D86234, PER @D86233, PLU @D86232, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : MAKE, 
   [COORD @D86241, AGR [COUNT @D86240, PER @D86239, PLU @D86238, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PAST +, ARITY 2] : MAKE, 
   [COORD @D86245, AGR [COUNT @D86244, PER @D86243, PLU @D86242, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, PAST +, ARITY 2] : MAKE, 
   [COORD @D86249, AGR [COUNT @D86248, PER @D86247, PLU @D86246, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_BSE, 
      REG -, PAST +, ARITY 2] : MAKE, 
   [COORD @D86253, AGR [COUNT @D86252, PER @D86251, PLU @D86250, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, PAST +, ARITY 2] : MAKE, 
   [COORD @D86257, AGR [COUNT @D86256, PER @D86255, PLU @D86254, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : MAKE, 
   [COORD @D86261, AGR [COUNT @D86260, PER @D86259, PLU @D86258, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, PAST +, 
      ARITY 2] : MAKE, 
   [COORD @D86265, AGR [COUNT @D86264, PER @D86263, PLU @D86262, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, 
      PRT OUT, PAST +, ARITY 2] : MAKE, 
   [COORD @D86269, AGR [COUNT @D86268, PER @D86267, PLU @D86266, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, PAST +, ARITY 2] : MAKE, 
   [COORD @D86273, AGR [COUNT @D86272, PER @D86271, PLU @D86270, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PRT OUT, PAST +, ARITY 2] : MAKE, 
   [COORD @D86277, AGR [COUNT @D86276, PER @D86275, PLU @D86274, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PRT OUT, PAST +, ARITY 2] : MAKE, 
   [COORD @D86281, AGR [COUNT @D86280, PER @D86279, PLU @D86278, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, PRT OUT, PAST +, ARITY 2] : MAKE, 
   [COORD @D86285, AGR [COUNT @D86284, PER @D86283, PLU @D86282, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, PAST +, ARITY 2] : MAKE, 
   [COORD @D86289, AGR [COUNT @D86288, PER @D86287, PLU @D86286, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM WITH, PAST +, ARITY 2] : MAKE, 
   [COORD @D86293, AGR [COUNT @D86292, PER @D86291, PLU @D86290, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, PAST +, ARITY 2] : MAKE, 
   [COORD @D86297, AGR [COUNT @D86296, PER @D86295, PLU @D86294, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, PAST +, ARITY 2] : MAKE, 
   [COORD @D86301, AGR [COUNT @D86300, PER @D86299, PLU @D86298, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARDS, PAST +, ARITY 2] : MAKE, 
   [COORD @D86305, AGR [COUNT @D86304, PER @D86303, PLU @D86302, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARD, PAST +, ARITY 2] : MAKE, 
   [COORD @D86309, AGR [COUNT @D86308, PER @D86307, PLU @D86306, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, PAST +, ARITY 2] : MAKE, 
   [COORD @D86313, AGR [COUNT @D86312, PER @D86311, PLU @D86310, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM INTO, PAST +, ARITY 2] : MAKE, 
   [COORD @D86317, AGR [COUNT @D86316, PER @D86315, PLU @D86314, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : MAKE, 
   [COORD @D86321, AGR [COUNT @D86320, PER @D86319, PLU @D86318, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, PAST +, ARITY 2] : MAKE, 
   [COORD @D86325, AGR [COUNT @D86324, PER @D86323, PLU @D86322, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM AS, PAST +, ARITY 2] : MAKE, 
   [COORD @D86329, AGR [COUNT @D86328, PER @D86327, PLU @D86326, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, PAST +, ARITY 2] : MAKE, 
   [COORD @D86333, AGR [COUNT @D86332, PER @D86331, PLU @D86330, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : MAKE, 
   [COORD @D86337, AGR [COUNT @D86336, PER @D86335, PLU @D86334, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PAST +, ARITY 2] : MAKE, 
   [COORD @D86341, AGR [COUNT @D86340, PER @D86339, PLU @D86338, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : MAKE, 
   [COORD @D86347, PAST @D86346, AGR [CASE @D86345, COUNT @D86344, 
            PER @D86343, PLU @D86342, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : MAKE, 
   [COORD @D86353, PAST @D86352, 
      AGR [CASE @D86351, COUNT @D86350, PER @D86349, PLU @D86348, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, FIN -, 
      ARITY 1] : MAKE, 
   [COORD @D86359, PAST @D86358, AGR [CASE @D86357, COUNT @D86356, 
            PER @D86355, PLU @D86354, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : MAKE, 
   [COORD @D86365, PAST @D86364, 
      AGR [CASE @D86363, COUNT @D86362, PER @D86361, PLU @D86360, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, FIN -, 
      ARITY 1] : MAKE, 
   [COORD @D86369, AGR [COUNT @D86368, PER @D86367, PLU @D86366, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : MAKE, 
   [COORD @D86373, AGR [COUNT @D86372, PER @D86371, PLU @D86370, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : MAKE, 
   [COORD @D86377, AGR [COUNT @D86376, PER @D86375, PLU @D86374, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : MAKE, 
   [COORD @D86381, AGR [COUNT @D86380, PER @D86379, PLU @D86378, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : MAKE.

WORD make : 
   [COORD @D86417, REFL @D86416, PRD @D86415, CASE @D86414, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MAKE, 
   [COORD @D86420, 
      AGR [COUNT @D86419, PER @D86418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   MAKE, 
   [COORD @D86422, AGR [COUNT @D86421, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : MAKE, 
   [COORD @D86424, AGR [COUNT @D86423, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : MAKE, 
   [COORD @D86428, AGR [COUNT @D86427, PER @D86426, PLU @D86425, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : MAKE, 
   [COORD @D86434, PAST @D86433, 
      AGR [CASE @D86432, COUNT @D86431, PER @D86430, PLU @D86429, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   MAKE, 
   [COORD @D86437, AGR [COUNT @D86436, PER @D86435, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86439, AGR [COUNT @D86438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86441, AGR [COUNT @D86440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86445, AGR [COUNT @D86444, PER @D86443, PLU @D86442, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86451, PAST @D86450, 
      AGR [CASE @D86449, COUNT @D86448, PER @D86447, PLU @D86446, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : MAKE, 
   [COORD @D86454, AGR [COUNT @D86453, PER @D86452, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OUT_OF, ARITY 3] : MAKE, 
   [COORD @D86456, AGR [COUNT @D86455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OUT_OF, ARITY 3] : MAKE, 
   [COORD @D86458, AGR [COUNT @D86457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OUT_OF, ARITY 3] : MAKE, 
   [COORD @D86462, AGR [COUNT @D86461, PER @D86460, PLU @D86459, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OUT_OF, ARITY 3] : MAKE, 
   [COORD @D86468, PAST @D86467, 
      AGR [CASE @D86466, COUNT @D86465, PER @D86464, PLU @D86463, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OUT_OF, ARITY 3] : MAKE, 
   [COORD @D86471, AGR [COUNT @D86470, PER @D86469, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, ARITY 3] : MAKE, 
   [COORD @D86473, AGR [COUNT @D86472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, ARITY 3] : MAKE, 
   [COORD @D86475, AGR [COUNT @D86474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OF, ARITY 3] : MAKE, 
   [COORD @D86479, AGR [COUNT @D86478, PER @D86477, PLU @D86476, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OF, ARITY 3] : MAKE, 
   [COORD @D86485, PAST @D86484, 
      AGR [CASE @D86483, COUNT @D86482, PER @D86481, PLU @D86480, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OF, 
      ARITY 3] : MAKE, 
   [COORD @D86488, AGR [COUNT @D86487, PER @D86486, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86490, AGR [COUNT @D86489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86492, AGR [COUNT @D86491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86496, AGR [COUNT @D86495, PER @D86494, PLU @D86493, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86502, PAST @D86501, 
      AGR [CASE @D86500, COUNT @D86499, PER @D86498, PLU @D86497, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM INTO, 
      ARITY 3] : MAKE, 
   [COORD @D86505, AGR [COUNT @D86504, PER @D86503, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : MAKE, 
   [COORD @D86507, AGR [COUNT @D86506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : MAKE, 
   [COORD @D86509, AGR [COUNT @D86508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : MAKE, 
   [COORD @D86513, AGR [COUNT @D86512, PER @D86511, PLU @D86510, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : MAKE, 
   [COORD @D86519, PAST @D86518, 
      AGR [CASE @D86517, COUNT @D86516, PER @D86515, PLU @D86514, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : MAKE, 
   [COORD @D86522, AGR [COUNT @D86521, PER @D86520, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : MAKE, 
   [COORD @D86524, AGR [COUNT @D86523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : MAKE, 
   [COORD @D86526, AGR [COUNT @D86525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : MAKE, 
   [COORD @D86530, AGR [COUNT @D86529, PER @D86528, PLU @D86527, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM WITH, ARITY 3] : MAKE, 
   [COORD @D86536, PAST @D86535, 
      AGR [CASE @D86534, COUNT @D86533, PER @D86532, PLU @D86531, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, ARITY 3] : MAKE, 
   [COORD @D86539, AGR [COUNT @D86538, PER @D86537, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86541, AGR [COUNT @D86540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86543, AGR [COUNT @D86542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86547, AGR [COUNT @D86546, PER @D86545, PLU @D86544, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86553, PAST @D86552, 
      AGR [CASE @D86551, COUNT @D86550, PER @D86549, PLU @D86548, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86556, AGR [COUNT @D86555, PER @D86554, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86558, AGR [COUNT @D86557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86560, AGR [COUNT @D86559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86564, AGR [COUNT @D86563, PER @D86562, PLU @D86561, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86570, PAST @D86569, 
      AGR [CASE @D86568, COUNT @D86567, PER @D86566, PLU @D86565, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PFORM TO, ARITY 3] : MAKE, 
   [COORD @D86573, AGR [COUNT @D86572, PER @D86571, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86575, AGR [COUNT @D86574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86577, AGR [COUNT @D86576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86581, AGR [COUNT @D86580, PER @D86579, PLU @D86578, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86587, PAST @D86586, 
      AGR [CASE @D86585, COUNT @D86584, PER @D86583, PLU @D86582, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86590, AGR [COUNT @D86589, PER @D86588, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86592, AGR [COUNT @D86591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86594, AGR [COUNT @D86593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86598, AGR [COUNT @D86597, PER @D86596, PLU @D86595, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86604, PAST @D86603, 
      AGR [CASE @D86602, COUNT @D86601, PER @D86600, PLU @D86599, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PFORM INTO, ARITY 3] : MAKE, 
   [COORD @D86607, AGR [COUNT @D86606, PER @D86605, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT UP, PFORM AS, ARITY 3] : MAKE, 
   [COORD @D86609, AGR [COUNT @D86608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT UP, PFORM AS, ARITY 3] : MAKE, 
   [COORD @D86611, AGR [COUNT @D86610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT UP, PFORM AS, ARITY 3] : MAKE, 
   [COORD @D86615, AGR [COUNT @D86614, PER @D86613, PLU @D86612, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, REG -, PRT UP, PFORM AS, ARITY 3] : MAKE, 
   [COORD @D86621, PAST @D86620, 
      AGR [CASE @D86619, COUNT @D86618, PER @D86617, PLU @D86616, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, REG -, PRT UP, 
      PFORM AS, ARITY 3] : MAKE, 
   [COORD @D86624, AGR [COUNT @D86623, PER @D86622, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86626, AGR [COUNT @D86625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86628, AGR [COUNT @D86627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86632, AGR [COUNT @D86631, PER @D86630, PLU @D86629, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 2] : MAKE, 
   [COORD @D86638, PAST @D86637, 
      AGR [CASE @D86636, COUNT @D86635, PER @D86634, PLU @D86633, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, ARITY 2] : 
   MAKE, 
   [COORD @D86641, AGR [COUNT @D86640, PER @D86639, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86643, AGR [COUNT @D86642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86645, AGR [COUNT @D86644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86649, AGR [COUNT @D86648, PER @D86647, PLU @D86646, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, ARITY 2] : MAKE, 
   [COORD @D86655, PAST @D86654, 
      AGR [CASE @D86653, COUNT @D86652, PER @D86651, PLU @D86650, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, REG -, ARITY 2] : 
   MAKE, 
   [COORD @D86658, AGR [COUNT @D86657, PER @D86656, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_BSE, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86660, AGR [COUNT @D86659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_BSE, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86662, AGR [COUNT @D86661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_BSE, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86666, AGR [COUNT @D86665, PER @D86664, PLU @D86663, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, REG -, ARITY 2] : MAKE, 
   [COORD @D86672, PAST @D86671, 
      AGR [CASE @D86670, COUNT @D86669, PER @D86668, PLU @D86667, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_BSE, REG -, ARITY 2] : 
   MAKE, 
   [COORD @D86675, AGR [COUNT @D86674, PER @D86673, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86677, AGR [COUNT @D86676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86679, AGR [COUNT @D86678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86683, AGR [COUNT @D86682, PER @D86681, PLU @D86680, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, ARITY 2] : MAKE, 
   [COORD @D86689, PAST @D86688, 
      AGR [CASE @D86687, COUNT @D86686, PER @D86685, PLU @D86684, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, REG -, ARITY 2] : 
   MAKE, 
   [COORD @D86692, AGR [COUNT @D86691, PER @D86690, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MAKE, 
   [COORD @D86694, AGR [COUNT @D86693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MAKE, 
   [COORD @D86696, AGR [COUNT @D86695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MAKE, 
   [COORD @D86700, AGR [COUNT @D86699, PER @D86698, PLU @D86697, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86706, PAST @D86705, AGR [CASE @D86704, COUNT @D86703, 
            PER @D86702, PLU @D86701, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : MAKE, 
   [COORD @D86709, AGR [COUNT @D86708, PER @D86707, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : MAKE, 
   [COORD @D86711, AGR [COUNT @D86710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : MAKE, 
   [COORD @D86713, AGR [COUNT @D86712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : MAKE, 
   [COORD @D86717, AGR [COUNT @D86716, PER @D86715, PLU @D86714, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      REG -, ARITY 2] : MAKE, 
   [COORD @D86723, PAST @D86722, AGR [CASE @D86721, COUNT @D86720, 
            PER @D86719, PLU @D86718, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT MP, REG -, ARITY 2] : MAKE, 
   [COORD @D86726, AGR [COUNT @D86725, PER @D86724, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86728, AGR [COUNT @D86727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86730, AGR [COUNT @D86729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86734, AGR [COUNT @D86733, PER @D86732, PLU @D86731, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86740, PAST @D86739, 
      AGR [CASE @D86738, COUNT @D86737, PER @D86736, PLU @D86735, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, PRT OUT, 
      ARITY 2] : MAKE, 
   [COORD @D86743, AGR [COUNT @D86742, PER @D86741, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86745, AGR [COUNT @D86744, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86747, AGR [COUNT @D86746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86751, AGR [COUNT @D86750, PER @D86749, PLU @D86748, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86757, PAST @D86756, AGR [CASE @D86755, COUNT @D86754, 
            PER @D86753, PLU @D86752, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86760, 
      AGR [COUNT @D86759, PER @D86758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT OUT, 
      ARITY 2] : MAKE, 
   [COORD @D86762, AGR [COUNT @D86761, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86764, AGR [COUNT @D86763, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86768, AGR [COUNT @D86767, PER @D86766, PLU @D86765, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86774, PAST @D86773, 
      AGR [CASE @D86772, COUNT @D86771, PER @D86770, PLU @D86769, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT OUT, 
      ARITY 2] : MAKE, 
   [COORD @D86777, AGR [COUNT @D86776, PER @D86775, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86779, AGR [COUNT @D86778, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86781, AGR [COUNT @D86780, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86785, AGR [COUNT @D86784, PER @D86783, PLU @D86782, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86791, PAST @D86790, 
      AGR [CASE @D86789, COUNT @D86788, PER @D86787, PLU @D86786, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, REG -, PRT OUT, 
      ARITY 2] : MAKE, 
   [COORD @D86794, AGR [COUNT @D86793, PER @D86792, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86796, AGR [COUNT @D86795, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86798, AGR [COUNT @D86797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86802, AGR [COUNT @D86801, PER @D86800, PLU @D86799, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D86808, PAST @D86807, 
      AGR [CASE @D86806, COUNT @D86805, PER @D86804, PLU @D86803, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, REG -, PRT OUT, 
      ARITY 2] : MAKE, 
   [COORD @D86811, AGR [COUNT @D86810, PER @D86809, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86813, AGR [COUNT @D86812, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86815, AGR [COUNT @D86814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86819, AGR [COUNT @D86818, PER @D86817, PLU @D86816, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86825, PAST @D86824, AGR 
         [CASE @D86823, COUNT @D86822, PER @D86821, PLU @D86820, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : MAKE, 
   [COORD @D86828, AGR [COUNT @D86827, PER @D86826, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86830, AGR [COUNT @D86829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86832, AGR [COUNT @D86831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86836, AGR [COUNT @D86835, PER @D86834, PLU @D86833, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86842, PAST @D86841, 
      AGR [CASE @D86840, COUNT @D86839, PER @D86838, PLU @D86837, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86845, AGR [COUNT @D86844, PER @D86843, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86847, AGR [COUNT @D86846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86849, AGR [COUNT @D86848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86853, AGR [COUNT @D86852, PER @D86851, PLU @D86850, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OFF, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86859, PAST @D86858, 
      AGR [CASE @D86857, COUNT @D86856, PER @D86855, PLU @D86854, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OFF, 
      PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86862, AGR [COUNT @D86861, PER @D86860, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86864, AGR [COUNT @D86863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86866, AGR [COUNT @D86865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86870, AGR [COUNT @D86869, PER @D86868, PLU @D86867, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT AWAY, PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86876, PAST @D86875, 
      AGR [CASE @D86874, COUNT @D86873, PER @D86872, PLU @D86871, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, 
      PFORM WITH, ARITY 2] : MAKE, 
   [COORD @D86879, AGR [COUNT @D86878, PER @D86877, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARDS, ARITY 2] : MAKE, 
   [COORD @D86881, AGR [COUNT @D86880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARDS, ARITY 2] : MAKE, 
   [COORD @D86883, AGR [COUNT @D86882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARDS, ARITY 2] : MAKE, 
   [COORD @D86887, AGR [COUNT @D86886, PER @D86885, PLU @D86884, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TOWARDS, ARITY 2] : MAKE, 
   [COORD @D86893, PAST @D86892, 
      AGR [CASE @D86891, COUNT @D86890, PER @D86889, PLU @D86888, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TOWARDS, 
      ARITY 2] : MAKE, 
   [COORD @D86896, AGR [COUNT @D86895, PER @D86894, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARD, ARITY 2] : MAKE, 
   [COORD @D86898, AGR [COUNT @D86897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARD, ARITY 2] : MAKE, 
   [COORD @D86900, AGR [COUNT @D86899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TOWARD, ARITY 2] : MAKE, 
   [COORD @D86904, AGR [COUNT @D86903, PER @D86902, PLU @D86901, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TOWARD, ARITY 2] : MAKE, 
   [COORD @D86910, PAST @D86909, 
      AGR [CASE @D86908, COUNT @D86907, PER @D86906, PLU @D86905, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TOWARD, 
      ARITY 2] : MAKE, 
   [COORD @D86913, AGR [COUNT @D86912, PER @D86911, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : MAKE, 
   [COORD @D86915, AGR [COUNT @D86914, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : MAKE, 
   [COORD @D86917, AGR [COUNT @D86916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : MAKE, 
   [COORD @D86921, AGR [COUNT @D86920, PER @D86919, PLU @D86918, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : MAKE, 
   [COORD @D86927, PAST @D86926, 
      AGR [CASE @D86925, COUNT @D86924, PER @D86923, PLU @D86922, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, PFORM TO, 
      ARITY 2] : MAKE, 
   [COORD @D86930, AGR [COUNT @D86929, PER @D86928, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM INTO, ARITY 2] : MAKE, 
   [COORD @D86932, AGR [COUNT @D86931, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM INTO, ARITY 2] : MAKE, 
   [COORD @D86934, AGR [COUNT @D86933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM INTO, ARITY 2] : MAKE, 
   [COORD @D86938, AGR [COUNT @D86937, PER @D86936, PLU @D86935, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM INTO, ARITY 2] : MAKE, 
   [COORD @D86944, PAST @D86943, 
      AGR [CASE @D86942, COUNT @D86941, PER @D86940, PLU @D86939, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM INTO, ARITY 2] : MAKE, 
   [COORD @D86947, AGR [COUNT @D86946, PER @D86945, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86949, AGR [COUNT @D86948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86951, AGR [COUNT @D86950, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86955, AGR [COUNT @D86954, PER @D86953, PLU @D86952, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86961, PAST @D86960, AGR [CASE @D86959, COUNT @D86958, 
            PER @D86957, PLU @D86956, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86964, 
      AGR [COUNT @D86963, PER @D86962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, 
      PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86966, AGR [COUNT @D86965, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86968, AGR [COUNT @D86967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86972, AGR [COUNT @D86971, PER @D86970, PLU @D86969, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86978, PAST @D86977, 
      AGR [CASE @D86976, COUNT @D86975, PER @D86974, PLU @D86973, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, 
      PFORM FOR, ARITY 2] : MAKE, 
   [COORD @D86981, AGR [COUNT @D86980, PER @D86979, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AS, ARITY 2] : MAKE, 
   [COORD @D86983, AGR [COUNT @D86982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AS, ARITY 2] : MAKE, 
   [COORD @D86985, AGR [COUNT @D86984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AS, ARITY 2] : MAKE, 
   [COORD @D86989, AGR [COUNT @D86988, PER @D86987, PLU @D86986, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM AS, ARITY 2] : MAKE, 
   [COORD @D86995, PAST @D86994, 
      AGR [CASE @D86993, COUNT @D86992, PER @D86991, PLU @D86990, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM AS, ARITY 2] : MAKE, 
   [COORD @D86998, AGR [COUNT @D86997, PER @D86996, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : MAKE, 
   [COORD @D87000, AGR [COUNT @D86999, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : MAKE, 
   [COORD @D87002, AGR [COUNT @D87001, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : MAKE, 
   [COORD @D87006, AGR [COUNT @D87005, PER @D87004, PLU @D87003, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AFTER, ARITY 2] : MAKE, 
   [COORD @D87012, PAST @D87011, 
      AGR [CASE @D87010, COUNT @D87009, PER @D87008, PLU @D87007, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AFTER, 
      ARITY 2] : MAKE, 
   [COORD @D87015, AGR [COUNT @D87014, PER @D87013, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : MAKE, 
   [COORD @D87017, AGR [COUNT @D87016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : MAKE, 
   [COORD @D87019, AGR [COUNT @D87018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : MAKE, 
   [COORD @D87023, AGR [COUNT @D87022, PER @D87021, PLU @D87020, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : MAKE, 
   [COORD @D87029, PAST @D87028, 
      AGR [CASE @D87027, COUNT @D87026, PER @D87025, PLU @D87024, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : MAKE, 
   [COORD @D87032, AGR [COUNT @D87031, PER @D87030, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : MAKE, 
   [COORD @D87034, AGR [COUNT @D87033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : MAKE, 
   [COORD @D87036, AGR [COUNT @D87035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : MAKE, 
   [COORD @D87040, AGR [COUNT @D87039, PER @D87038, PLU @D87037, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : MAKE, 
   [COORD @D87046, PAST @D87045, 
      AGR [CASE @D87044, COUNT @D87043, PER @D87042, PLU @D87041, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : MAKE, 
   [COORD @D87049, AGR [COUNT @D87048, PER @D87047, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : MAKE, 
   [COORD @D87051, AGR [COUNT @D87050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : MAKE, 
   [COORD @D87053, AGR [COUNT @D87052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : MAKE, 
   [COORD @D87057, AGR [COUNT @D87056, PER @D87055, PLU @D87054, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : MAKE, 
   [COORD @D87063, PAST @D87062, 
      AGR [CASE @D87061, COUNT @D87060, PER @D87059, PLU @D87058, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : MAKE, 
   [COORD @D87066, AGR [COUNT @D87065, PER @D87064, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : MAKE, 
   [COORD @D87068, AGR [COUNT @D87067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : MAKE, 
   [COORD @D87070, AGR [COUNT @D87069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : MAKE, 
   [COORD @D87074, AGR [COUNT @D87073, PER @D87072, PLU @D87071, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : MAKE, 
   [COORD @D87080, PAST @D87079, 
      AGR [CASE @D87078, COUNT @D87077, PER @D87076, PLU @D87075, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : MAKE, 
   [COORD @D87083, AGR [COUNT @D87082, PER @D87081, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : MAKE, 
   [COORD @D87085, AGR [COUNT @D87084, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : MAKE, 
   [COORD @D87087, AGR [COUNT @D87086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : MAKE, 
   [COORD @D87091, AGR [COUNT @D87090, PER @D87089, PLU @D87088, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : MAKE, 
   [COORD @D87097, PAST @D87096, 
      AGR [CASE @D87095, COUNT @D87094, PER @D87093, PLU @D87092, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : MAKE, 
   [COORD @D87100, AGR [COUNT @D87099, PER @D87098, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : MAKE, 
   [COORD @D87102, AGR [COUNT @D87101, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : MAKE, 
   [COORD @D87104, AGR [COUNT @D87103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : MAKE, 
   [COORD @D87108, AGR [COUNT @D87107, PER @D87106, PLU @D87105, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : MAKE, 
   [COORD @D87114, PAST @D87113, 
      AGR [CASE @D87112, COUNT @D87111, PER @D87110, PLU @D87109, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : MAKE, 
   [COORD @D87117, AGR [COUNT @D87116, PER @D87115, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : MAKE, 
   [COORD @D87119, AGR [COUNT @D87118, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : MAKE, 
   [COORD @D87121, AGR [COUNT @D87120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : MAKE, 
   [COORD @D87125, AGR [COUNT @D87124, PER @D87123, PLU @D87122, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : MAKE, 
   [COORD @D87131, PAST @D87130, 
      AGR [CASE @D87129, COUNT @D87128, PER @D87127, PLU @D87126, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : MAKE.

WORD makes : 
   [COORD @D87144, DEMON @D87143, REFL @D87142, PRD @D87141, CASE 
         @D87140, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MAKE, 
   [COORD @D87146, 
      AGR [COUNT @D87145, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87148, 
      AGR [COUNT @D87147, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87150, 
      AGR [COUNT @D87149, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87152, AGR [COUNT @D87151, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87154, AGR [COUNT @D87153, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87156, AGR [COUNT @D87155, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87158, AGR [COUNT @D87157, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87160, AGR [COUNT @D87159, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87162, AGR [COUNT @D87161, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87164, AGR [COUNT @D87163, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87166, AGR [COUNT @D87165, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87168, AGR [COUNT @D87167, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, CONJ NULL, 
      SUBTYPE PVERB, PRT UP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87170, AGR [COUNT @D87169, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87172, 
      AGR [COUNT @D87171, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87174, 
      AGR [COUNT @D87173, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87176, 
      AGR [COUNT @D87175, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87178, 
      AGR [COUNT @D87177, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87180, 
      AGR [COUNT @D87179, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT MP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87182, 
      AGR [COUNT @D87181, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87184, 
      AGR [COUNT @D87183, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87186, 
      AGR [COUNT @D87185, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87188, 
      AGR [COUNT @D87187, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87190, 
      AGR [COUNT @D87189, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87192, 
      AGR [COUNT @D87191, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87194, 
      AGR [COUNT @D87193, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87196, AGR [COUNT @D87195, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87198, AGR [COUNT @D87197, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87200, AGR [COUNT @D87199, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87202, AGR [COUNT @D87201, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TOWARD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87204, AGR [COUNT @D87203, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87206, AGR [COUNT @D87205, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87208, AGR [COUNT @D87207, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87210, AGR [COUNT @D87209, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87212, AGR [COUNT @D87211, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87214, AGR [COUNT @D87213, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87216, AGR [COUNT @D87215, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87218, 
      AGR [COUNT @D87217, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87220, 
      AGR [COUNT @D87219, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87222, 
      AGR [COUNT @D87221, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87224, 
      AGR [COUNT @D87223, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87226, 
      AGR [COUNT @D87225, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE, 
   [COORD @D87228, 
      AGR [COUNT @D87227, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MAKE.

WORD making : 
   [COORD @D87238, REFL @D87237, PRD @D87236, CASE @D87235, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MAKING, 
   [COORD @D87242, REFL @D87241, PRD @D87240, CASE @D87239, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN +, ADDRESS -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : MAKING, 
   [COORD @D87247, REFL @D87246, COUNT @D87245, PRD @D87244, 
      CASE @D87243, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, 
      PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : MAKING, 
   
   [COORD @D87253, PRD @D87252, AGR [CASE @D87251, COUNT @D87250, PER 
               @D87249, PLU @D87248, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87259, PRD @D87258, 
      AGR [CASE @D87257, COUNT @D87256, PER @D87255, PLU @D87254, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87265, PRD @D87264, AGR [CASE @D87263, COUNT @D87262, 
            PER @D87261, PLU @D87260, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM OUT_OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87271, PRD @D87270, 
      AGR [CASE @D87269, COUNT @D87268, PER @D87267, PLU @D87266, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87277, PRD @D87276, AGR [CASE @D87275, COUNT @D87274, 
            PER @D87273, PLU @D87272, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87283, PRD @D87282, 
      AGR [CASE @D87281, COUNT @D87280, PER @D87279, PLU @D87278, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87289, PRD @D87288, AGR [CASE @D87287, COUNT @D87286, 
            PER @D87285, PLU @D87284, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87295, PRD @D87294, 
      AGR [CASE @D87293, COUNT @D87292, PER @D87291, PLU @D87290, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87301, PRD @D87300, AGR [CASE @D87299, COUNT @D87298, 
            PER @D87297, PLU @D87296, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87307, PRD @D87306, 
      AGR [CASE @D87305, COUNT @D87304, PER @D87303, PLU @D87302, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87313, PRD @D87312, AGR [CASE @D87311, COUNT @D87310, 
            PER @D87309, PLU @D87308, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87319, PRD @D87318, 
      AGR [CASE @D87317, COUNT @D87316, PER @D87315, PLU @D87314, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      CONJ NULL, SUBTYPE PVERB, PRT UP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87325, PRD @D87324, AGR [CASE @D87323, COUNT @D87322, 
            PER @D87321, PLU @D87320, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87331, PRD @D87330, 
      AGR [CASE @D87329, COUNT @D87328, PER @D87327, PLU @D87326, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87337, PRD @D87336, AGR [CASE @D87335, COUNT @D87334, 
            PER @D87333, PLU @D87332, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_BSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87343, PRD @D87342, 
      AGR [CASE @D87341, COUNT @D87340, PER @D87339, PLU @D87338, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87349, PRD @D87348, AGR [CASE @D87347, COUNT @D87346, 
            PER @D87345, PLU @D87344, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87355, PRD @D87354, 
      AGR [CASE @D87353, COUNT @D87352, PER @D87351, PLU @D87350, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT MP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MAKE, 
   [COORD @D87361, PRD @D87360, AGR [CASE @D87359, COUNT @D87358, 
            PER @D87357, PLU @D87356, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87367, PRD @D87366, 
      AGR [CASE @D87365, COUNT @D87364, PER @D87363, PLU @D87362, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MAKE, 
   [COORD @D87373, PRD @D87372, AGR [CASE @D87371, COUNT @D87370, 
            PER @D87369, PLU @D87368, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87379, PRD @D87378, 
      AGR [CASE @D87377, COUNT @D87376, PER @D87375, PLU @D87374, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87385, PRD @D87384, AGR [CASE @D87383, COUNT @D87382, 
            PER @D87381, PLU @D87380, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87391, PRD @D87390, 
      AGR [CASE @D87389, COUNT @D87388, PER @D87387, PLU @D87386, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87397, PRD @D87396, AGR [CASE @D87395, COUNT @D87394, 
            PER @D87393, PLU @D87392, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87403, PRD @D87402, 
      AGR [CASE @D87401, COUNT @D87400, PER @D87399, PLU @D87398, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87409, PRD @D87408, AGR [CASE @D87407, COUNT @D87406, 
            PER @D87405, PLU @D87404, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT AWAY, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87415, PRD @D87414, 
      AGR [CASE @D87413, COUNT @D87412, PER @D87411, PLU @D87410, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87421, PRD @D87420, AGR [CASE @D87419, COUNT @D87418, 
            PER @D87417, PLU @D87416, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TOWARD, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87427, PRD @D87426, 
      AGR [CASE @D87425, COUNT @D87424, PER @D87423, PLU @D87422, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MAKE, 
   [COORD @D87433, PRD @D87432, AGR [CASE @D87431, COUNT @D87430, 
            PER @D87429, PLU @D87428, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87439, PRD @D87438, 
      AGR [CASE @D87437, COUNT @D87436, PER @D87435, PLU @D87434, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87445, PRD @D87444, AGR [CASE @D87443, COUNT @D87442, 
            PER @D87441, PLU @D87440, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87451, PRD @D87450, 
      AGR [CASE @D87449, COUNT @D87448, PER @D87447, PLU @D87446, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MAKE, 
   [COORD @D87457, PRD @D87456, AGR [CASE @D87455, COUNT @D87454, 
            PER @D87453, PLU @D87452, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87463, PRD @D87462, 
      AGR [CASE @D87461, COUNT @D87460, PER @D87459, PLU @D87458, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MAKE, 
   [COORD @D87469, PRD @D87468, AGR [CASE @D87467, COUNT @D87466, 
            PER @D87465, PLU @D87464, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87475, PRD @D87474, 
      AGR [CASE @D87473, COUNT @D87472, PER @D87471, PLU @D87470, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MAKE, 
   [COORD @D87481, PRD @D87480, AGR [CASE @D87479, COUNT @D87478, 
            PER @D87477, PLU @D87476, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87487, PRD @D87486, 
      AGR [CASE @D87485, COUNT @D87484, PER @D87483, PLU @D87482, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MAKE, 
   [COORD @D87493, PRD @D87492, AGR [CASE @D87491, COUNT @D87490, 
            PER @D87489, PLU @D87488, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MAKE, 
   [COORD @D87499, PRD @D87498, 
      AGR [CASE @D87497, COUNT @D87496, PER @D87495, PLU @D87494, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MAKE.

WORD makings : 
   [COORD @D87512, REFL @D87511, PRD @D87510, CASE @D87509, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, NFORM NORM, PER 3, 
      ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM OF, COUNT +] : MAKINGS, 
   [COORD @D87516, REFL @D87515, PRD @D87514, CASE @D87513, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : MAKINGS, 
   [COORD @D87521, DEMON @D87520, REFL @D87519, PRD @D87518, 
      CASE @D87517, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MAKING, 
   [COORD @D87526, DEMON @D87525, REFL @D87524, PRD @D87523, 
      CASE @D87522, COMPOUND NOT, FIX NOT, PN +, ADDRESS -, ADV -, PART -, 
      CONJ NULL, SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : MAKING, 
   [COORD @D87531, DEMON @D87530, REFL @D87529, PRD @D87528, 
      CASE @D87527, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : MAKING.

WORD manage : 
   [COORD @D87552, AGR [COUNT @D87551, PER @D87550, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : MANAGE, 
   [COORD @D87554, AGR [COUNT @D87553, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : MANAGE, 
   [COORD @D87556, AGR [COUNT @D87555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : MANAGE, 
   [COORD @D87560, AGR [COUNT @D87559, PER @D87558, PLU @D87557, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : MANAGE, 
   [COORD @D87566, PAST @D87565, AGR [CASE @D87564, COUNT @D87563, 
            PER @D87562, PLU @D87561, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : MANAGE, 
   [COORD @D87569, AGR [COUNT @D87568, PER @D87567, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MANAGE, 
   [COORD @D87571, AGR [COUNT @D87570, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MANAGE, 
   [COORD @D87573, AGR [COUNT @D87572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MANAGE, 
   [COORD @D87577, AGR [COUNT @D87576, PER @D87575, PLU @D87574, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MANAGE, 
   [COORD @D87583, PAST @D87582, AGR [CASE @D87581, COUNT @D87580, 
            PER @D87579, PLU @D87578, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MANAGE, 
   [COORD @D87586, AGR [COUNT @D87585, PER @D87584, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MANAGE, 
   [COORD @D87588, AGR [COUNT @D87587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MANAGE, 
   [COORD @D87590, AGR [COUNT @D87589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MANAGE, 
   [COORD @D87594, AGR [COUNT @D87593, PER @D87592, PLU @D87591, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MANAGE, 
   [COORD @D87600, PAST @D87599, AGR [CASE @D87598, COUNT @D87597, 
            PER @D87596, PLU @D87595, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MANAGE.

WORD managed : 
   [COORD @D87612, AGR [CASE @D87611, COUNT @D87610, PER @D87609, 
            PLU @D87608, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87617, AGR [CASE @D87616, COUNT @D87615, PER @D87614, 
            PLU @D87613, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87622, AGR [CASE @D87621, COUNT @D87620, PER @D87619, 
            PLU @D87618, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87627, AGR [CASE @D87626, COUNT @D87625, PER @D87624, 
            PLU @D87623, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87632, AGR [CASE @D87631, COUNT @D87630, PER @D87629, 
            PLU @D87628, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MANAGE, 
   [COORD @D87637, AGR [CASE @D87636, COUNT @D87635, PER @D87634, 
            PLU @D87633, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87642, AGR [CASE @D87641, COUNT @D87640, PER @D87639, 
            PLU @D87638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MANAGE.

WORD manages : 
   [COORD @D87651, AGR [COUNT @D87650, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87653, 
      AGR [COUNT @D87652, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87655, 
      AGR [COUNT @D87654, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MANAGE.

WORD managing : 
   [COORD @D87667, PRD @D87666, AGR [CASE @D87665, COUNT @D87664, 
            PER @D87663, PLU @D87662, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MANAGE, 
   [COORD @D87673, PRD @D87672, 
      AGR [CASE @D87671, COUNT @D87670, PER @D87669, PLU @D87668, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MANAGE, 
   [COORD @D87679, PRD @D87678, AGR [CASE @D87677, COUNT @D87676, 
            PER @D87675, PLU @D87674, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MANAGE.

WORD mark : 
   [COORD @D87691, REFL @D87690, PRD @D87689, CASE @D87688, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MARK, 
   [COORD @D87696, REFL @D87695, COUNT @D87694, PRD @D87693, 
      CASE @D87692, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : MARK, 
   [COORD @D87700, REFL @D87699, PRD @D87698, CASE @D87697, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MARK, 
   [COORD @D87703, 
      AGR [COUNT @D87702, PER @D87701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      ARITY 3] : MARK, 
   [COORD @D87705, AGR [COUNT @D87704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : MARK, 
   [COORD @D87707, AGR [COUNT @D87706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : MARK, 
   [COORD @D87711, AGR [COUNT @D87710, PER @D87709, PLU @D87708, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : MARK, 
   [COORD @D87717, PAST @D87716, AGR [CASE @D87715, COUNT @D87714, 
            PER @D87713, PLU @D87712, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : MARK, 
   [COORD @D87720, AGR [COUNT @D87719, PER @D87718, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MARK, 
   [COORD @D87722, AGR [COUNT @D87721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MARK, 
   [COORD @D87724, AGR [COUNT @D87723, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MARK, 
   [COORD @D87728, AGR [COUNT @D87727, PER @D87726, PLU @D87725, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MARK, 
   [COORD @D87734, PAST @D87733, 
      AGR [CASE @D87732, COUNT @D87731, PER @D87730, PLU @D87729, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : MARK, 
   [COORD @D87737, AGR [COUNT @D87736, PER @D87735, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM FOR, ARITY 3] : MARK, 
   [COORD @D87739, AGR 
         [COUNT @D87738, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM FOR, ARITY 3] : MARK, 
   [COORD @D87741, AGR [COUNT @D87740, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM FOR, ARITY 3] : MARK, 
   [COORD @D87745, AGR 
         [COUNT @D87744, PER @D87743, PLU @D87742, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM FOR, ARITY 3] : MARK, 
   [COORD @D87751, PAST @D87750, 
      AGR [CASE @D87749, COUNT @D87748, PER @D87747, PLU @D87746, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM FOR, ARITY 3] : MARK, 
   [COORD @D87754, AGR [COUNT @D87753, PER @D87752, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MARK, 
   [COORD @D87756, AGR [COUNT @D87755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MARK, 
   [COORD @D87758, AGR [COUNT @D87757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MARK, 
   [COORD @D87762, AGR [COUNT @D87761, PER @D87760, PLU @D87759, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MARK, 
   [COORD @D87768, PAST @D87767, AGR [CASE @D87766, COUNT @D87765, 
            PER @D87764, PLU @D87763, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MARK, 
   [COORD @D87771, AGR [COUNT @D87770, PER @D87769, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MARK, 
   [COORD @D87773, AGR [COUNT @D87772, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MARK, 
   [COORD @D87775, AGR [COUNT @D87774, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MARK, 
   [COORD @D87779, AGR [COUNT @D87778, PER @D87777, PLU @D87776, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : MARK, 
   [COORD @D87785, PAST @D87784, 
      AGR [CASE @D87783, COUNT @D87782, PER @D87781, PLU @D87780, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : MARK, 
   [COORD @D87788, AGR [COUNT @D87787, PER @D87786, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : MARK, 
   [COORD @D87790, AGR [COUNT @D87789, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : MARK, 
   [COORD @D87792, AGR [COUNT @D87791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : MARK, 
   [COORD @D87796, AGR [COUNT @D87795, PER @D87794, PLU @D87793, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : MARK, 
   [COORD @D87802, PAST @D87801, 
      AGR [CASE @D87800, COUNT @D87799, PER @D87798, PLU @D87797, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : MARK, 
   [COORD @D87805, AGR [COUNT @D87804, PER @D87803, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : MARK, 
   [COORD @D87807, AGR [COUNT @D87806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : MARK, 
   [COORD @D87809, AGR [COUNT @D87808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : MARK, 
   [COORD @D87813, AGR [COUNT @D87812, PER @D87811, PLU @D87810, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : MARK, 
   [COORD @D87819, PAST @D87818, 
      AGR [CASE @D87817, COUNT @D87816, PER @D87815, PLU @D87814, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : MARK, 
   [COORD @D87822, AGR [COUNT @D87821, PER @D87820, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MARK, 
   [COORD @D87824, AGR [COUNT @D87823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MARK, 
   [COORD @D87826, AGR [COUNT @D87825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MARK, 
   [COORD @D87830, AGR [COUNT @D87829, PER @D87828, PLU @D87827, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : MARK, 
   [COORD @D87836, PAST @D87835, 
      AGR [CASE @D87834, COUNT @D87833, PER @D87832, PLU @D87831, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MARK, 
   [COORD @D87839, AGR [COUNT @D87838, PER @D87837, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARK, 
   [COORD @D87841, AGR [COUNT @D87840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARK, 
   [COORD @D87843, AGR [COUNT @D87842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARK, 
   [COORD @D87847, AGR [COUNT @D87846, PER @D87845, PLU @D87844, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARK, 
   [COORD @D87853, PAST @D87852, AGR [CASE @D87851, COUNT @D87850, 
            PER @D87849, PLU @D87848, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MARK, 
   [COORD @D87856, AGR [COUNT @D87855, PER @D87854, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MARK, 
   [COORD @D87858, AGR [COUNT @D87857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MARK, 
   [COORD @D87860, AGR [COUNT @D87859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MARK, 
   [COORD @D87864, AGR [COUNT @D87863, PER @D87862, PLU @D87861, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MARK, 
   [COORD @D87870, PAST @D87869, 
      AGR [CASE @D87868, COUNT @D87867, PER @D87866, PLU @D87865, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : MARK, 
   [COORD @D87873, AGR [COUNT @D87872, PER @D87871, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MARK, 
   [COORD @D87875, AGR [COUNT @D87874, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MARK, 
   [COORD @D87877, AGR [COUNT @D87876, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MARK, 
   [COORD @D87881, AGR [COUNT @D87880, PER @D87879, PLU @D87878, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MARK, 
   [COORD @D87887, PAST @D87886, 
      AGR [CASE @D87885, COUNT @D87884, PER @D87883, PLU @D87882, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : MARK, 
   [COORD @D87890, AGR [COUNT @D87889, PER @D87888, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MARK, 
   [COORD @D87892, AGR [COUNT @D87891, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MARK, 
   [COORD @D87894, AGR [COUNT @D87893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MARK, 
   [COORD @D87898, AGR [COUNT @D87897, PER @D87896, PLU @D87895, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MARK, 
   [COORD @D87904, PAST @D87903, 
      AGR [CASE @D87902, COUNT @D87901, PER @D87900, PLU @D87899, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : MARK, 
   [COORD @D87907, AGR [COUNT @D87906, PER @D87905, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MARK, 
   [COORD @D87909, AGR [COUNT @D87908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MARK, 
   [COORD @D87911, AGR [COUNT @D87910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MARK, 
   [COORD @D87915, AGR [COUNT @D87914, PER @D87913, PLU @D87912, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MARK, 
   [COORD @D87921, PAST @D87920, 
      AGR [CASE @D87919, COUNT @D87918, PER @D87917, PLU @D87916, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : MARK.

WORD marked : 
   [COADV @D87935, COORD @D87934, DEF @D87933, PRD @D87932, AGR 
            [CASE @D87931, COUNT @D87930, PER @D87929, PLU @D87928, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : MARKED, 
   [COADV @D87943, COORD @D87942, DEF @D87941, PRD @D87940, 
      AGR [CASE @D87939, COUNT @D87938, PER @D87937, PLU @D87936, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM BY, 
      DISTR PRD, ARITY 2] : MARKED, 
   [COORD @D87948, AGR [CASE @D87947, COUNT @D87946, PER @D87945, 
            PLU @D87944, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D87953, AGR [CASE @D87952, COUNT @D87951, PER @D87950, 
            PLU @D87949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D87959, AGR [CASE @D87958, NFORM @D87957, COUNT @D87956, 
            PER @D87955, PLU @D87954, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MARK, 
   [COORD @D87964, AGR [CASE @D87963, COUNT @D87962, PER @D87961, 
            PLU @D87960, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D87969, AGR [CASE @D87968, COUNT @D87967, PER @D87966, 
            PLU @D87965, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D87974, AGR [CASE @D87973, COUNT @D87972, PER @D87971, 
            PLU @D87970, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D87979, AGR [CASE @D87978, COUNT @D87977, PER @D87976, 
            PLU @D87975, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D87984, AGR [CASE @D87983, COUNT @D87982, PER @D87981, 
            PLU @D87980, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D87989, 
      AGR [CASE @D87988, COUNT @D87987, PER @D87986, PLU @D87985, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D87994, AGR [CASE @D87993, COUNT @D87992, PER @D87991, 
            PLU @D87990, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MARK, 
   [COORD @D87999, AGR [CASE @D87998, COUNT @D87997, PER @D87996, 
            PLU @D87995, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88004, AGR [CASE @D88003, COUNT @D88002, PER @D88001, 
            PLU @D88000, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88009, AGR [CASE @D88008, COUNT @D88007, PER @D88006, 
            PLU @D88005, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88014, AGR [CASE @D88013, COUNT @D88012, PER @D88011, 
            PLU @D88010, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88019, AGR [CASE @D88018, COUNT @D88017, PER @D88016, 
            PLU @D88015, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88024, AGR [CASE @D88023, COUNT @D88022, PER @D88021, 
            PLU @D88020, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88029, AGR [CASE @D88028, COUNT @D88027, PER @D88026, 
            PLU @D88025, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88034, AGR [CASE @D88033, COUNT @D88032, PER @D88031, 
            PLU @D88030, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88039, AGR [CASE @D88038, COUNT @D88037, PER @D88036, 
            PLU @D88035, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88044, AGR [CASE @D88043, COUNT @D88042, PER @D88041, 
            PLU @D88040, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88049, AGR [CASE @D88048, COUNT @D88047, PER @D88046, 
            PLU @D88045, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88054, AGR [CASE @D88053, COUNT @D88052, PER @D88051, 
            PLU @D88050, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88059, AGR [CASE @D88058, COUNT @D88057, PER @D88056, 
            PLU @D88055, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88064, AGR [CASE @D88063, COUNT @D88062, PER @D88061, 
            PLU @D88060, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88069, AGR [CASE @D88068, COUNT @D88067, PER @D88066, 
            PLU @D88065, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88074, AGR [CASE @D88073, COUNT @D88072, PER @D88071, 
            PLU @D88070, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88079, AGR [CASE @D88078, COUNT @D88077, PER @D88076, 
            PLU @D88075, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88084, AGR [CASE @D88083, COUNT @D88082, PER @D88081, 
            PLU @D88080, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88089, AGR [CASE @D88088, COUNT @D88087, PER @D88086, 
            PLU @D88085, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88094, AGR [CASE @D88093, COUNT @D88092, PER @D88091, 
            PLU @D88090, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88099, AGR [CASE @D88098, COUNT @D88097, PER @D88096, 
            PLU @D88095, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88104, AGR [CASE @D88103, COUNT @D88102, PER @D88101, 
            PLU @D88100, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK, 
   [COORD @D88109, AGR [CASE @D88108, COUNT @D88107, PER @D88106, 
            PLU @D88105, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88114, AGR [CASE @D88113, COUNT @D88112, PER @D88111, 
            PLU @D88110, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MARK.

WORD market : 
   [COORD @D88124, REFL @D88123, PRD @D88122, CASE @D88121, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MARKET, 
   [COORD @D88129, REFL @D88128, COUNT @D88127, PRD @D88126, 
      CASE @D88125, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : MARKET, 
   [COORD @D88133, REFL @D88132, PRD @D88131, CASE @D88130, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : MARKET, 
   [COORD @D88136, 
      AGR [COUNT @D88135, PER @D88134, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   MARKET, 
   [COORD @D88138, AGR [COUNT @D88137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MARKET, 
   [COORD @D88140, AGR [COUNT @D88139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MARKET, 
   [COORD @D88144, AGR [COUNT @D88143, PER @D88142, PLU @D88141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MARKET, 
   [COORD @D88150, PAST @D88149, AGR [CASE @D88148, COUNT @D88147, 
            PER @D88146, PLU @D88145, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MARKET, 
   [COORD @D88153, AGR [COUNT @D88152, PER @D88151, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARKET, 
   [COORD @D88155, AGR [COUNT @D88154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARKET, 
   [COORD @D88157, AGR [COUNT @D88156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARKET, 
   [COORD @D88161, AGR [COUNT @D88160, PER @D88159, PLU @D88158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MARKET, 
   [COORD @D88167, PAST @D88166, AGR [CASE @D88165, COUNT @D88164, 
            PER @D88163, PLU @D88162, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MARKET.

WORD marketing : 
   [COORD @D88185, REFL @D88184, PRD @D88183, CASE @D88182, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : MARKETING, 
   [COORD @D88191, PRD @D88190, 
      AGR [CASE @D88189, COUNT @D88188, PER @D88187, PLU @D88186, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MARKET, 
   [COORD @D88197, PRD @D88196, AGR [CASE @D88195, COUNT @D88194, 
            PER @D88193, PLU @D88192, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARKET.

WORD markets : 
   [COORD @D88229, DEMON @D88228, REFL @D88227, PRD @D88226, 
      CASE @D88225, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MARKET, 
   [COORD @D88234, DEMON @D88233, REFL @D88232, PRD @D88231, 
      CASE @D88230, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MARKET, 
   [COORD @D88239, DEMON @D88238, REFL @D88237, PRD @D88236, 
      CASE @D88235, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   MARKET, 
   [COORD @D88241, AGR [COUNT @D88240, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARKET, 
   [COORD @D88243, 
      AGR [COUNT @D88242, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARKET.

WORD marketted : 
   [COORD @D88258, AGR [CASE @D88257, COUNT @D88256, PER @D88255, 
            PLU @D88254, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MARKET, 
   [COORD @D88263, AGR [CASE @D88262, COUNT @D88261, PER @D88260, 
            PLU @D88259, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARKET, 
   [COORD @D88268, AGR [CASE @D88267, COUNT @D88266, PER @D88265, 
            PLU @D88264, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MARKET, 
   [COORD @D88273, AGR [CASE @D88272, COUNT @D88271, PER @D88270, 
            PLU @D88269, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MARKET, 
   [COORD @D88278, AGR [CASE @D88277, COUNT @D88276, PER @D88275, 
            PLU @D88274, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MARKET.

WORD marketting : 
   [COORD @D88298, PRD @D88297, AGR [CASE @D88296, COUNT @D88295, 
            PER @D88294, PLU @D88293, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARKET, 
   [COORD @D88304, PRD @D88303, 
      AGR [CASE @D88302, COUNT @D88301, PER @D88300, PLU @D88299, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MARKET.

WORD marking : 
   [COORD @D88320, PRD @D88319, AGR [CASE @D88318, COUNT @D88317, 
            PER @D88316, PLU @D88315, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88326, PRD @D88325, 
      AGR [CASE @D88324, COUNT @D88323, PER @D88322, PLU @D88321, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MARK, 
   [COORD @D88332, PRD @D88331, AGR [CASE @D88330, COUNT @D88329, 
            PER @D88328, PLU @D88327, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88338, PRD @D88337, 
      AGR [CASE @D88336, COUNT @D88335, PER @D88334, PLU @D88333, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MARK, 
   [COORD @D88344, PRD @D88343, AGR [CASE @D88342, COUNT @D88341, 
            PER @D88340, PLU @D88339, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88350, PRD @D88349, 
      AGR [CASE @D88348, COUNT @D88347, PER @D88346, PLU @D88345, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MARK, 
   [COORD @D88356, PRD @D88355, AGR [CASE @D88354, COUNT @D88353, 
            PER @D88352, PLU @D88351, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88362, PRD @D88361, 
      AGR [CASE @D88360, COUNT @D88359, PER @D88358, PLU @D88357, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MARK, 
   [COORD @D88368, PRD @D88367, AGR [CASE @D88366, COUNT @D88365, 
            PER @D88364, PLU @D88363, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88374, PRD @D88373, 
      AGR [CASE @D88372, COUNT @D88371, PER @D88370, PLU @D88369, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MARK, 
   [COORD @D88380, PRD @D88379, AGR [CASE @D88378, COUNT @D88377, 
            PER @D88376, PLU @D88375, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK, 
   [COORD @D88386, PRD @D88385, 
      AGR [CASE @D88384, COUNT @D88383, PER @D88382, PLU @D88381, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MARK, 
   [COORD @D88392, PRD @D88391, AGR [CASE @D88390, COUNT @D88389, 
            PER @D88388, PLU @D88387, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MARK.

WORD marks : 
   [COORD @D88403, DEMON @D88402, REFL @D88401, PRD @D88400, CASE 
         @D88399, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MARK, 
   [COORD @D88408, DEMON @D88407, REFL @D88406, PRD @D88405, 
      CASE @D88404, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : MARK, 
   [COORD @D88410, AGR [COUNT @D88409, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88412, 
      AGR [COUNT @D88411, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MARK, 
   [COORD @D88414, AGR [COUNT @D88413, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MARK, 
   [COORD @D88416, AGR [COUNT @D88415, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88418, 
      AGR [COUNT @D88417, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88420, 
      AGR [COUNT @D88419, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88422, 
      AGR [COUNT @D88421, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88424, 
      AGR [COUNT @D88423, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88426, 
      AGR [COUNT @D88425, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88428, 
      AGR [COUNT @D88427, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88430, 
      AGR [COUNT @D88429, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88432, 
      AGR [COUNT @D88431, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK, 
   [COORD @D88434, 
      AGR [COUNT @D88433, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MARK.

WORD match : 
   [COORD @D88448, REFL @D88447, PRD @D88446, CASE @D88445, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MATCH, 
   [COORD @D88452, REFL @D88451, PRD @D88450, CASE @D88449, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MATCH, 
   [COORD @D88456, REFL @D88455, PRD @D88454, CASE @D88453, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : MATCH, 
   [COORD @D88459, 
      AGR [COUNT @D88458, PER @D88457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : MATCH, 
   [COORD @D88461, AGR [COUNT @D88460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MATCH, 
   [COORD @D88463, AGR [COUNT @D88462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MATCH, 
   [COORD @D88467, AGR [COUNT @D88466, PER @D88465, PLU @D88464, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MATCH, 
   [COORD @D88473, PAST @D88472, 
      AGR [CASE @D88471, COUNT @D88470, PER @D88469, PLU @D88468, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : MATCH, 
   [COORD @D88476, AGR [COUNT @D88475, PER @D88474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : MATCH, 
   [COORD @D88478, AGR [COUNT @D88477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : MATCH, 
   [COORD @D88480, AGR [COUNT @D88479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : MATCH, 
   [COORD @D88484, AGR [COUNT @D88483, PER @D88482, PLU @D88481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : MATCH, 
   [COORD @D88490, PAST @D88489, 
      AGR [CASE @D88488, COUNT @D88487, PER @D88486, PLU @D88485, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : MATCH, 
   [COORD @D88493, AGR [COUNT @D88492, PER @D88491, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MATCH, 
   [COORD @D88495, AGR [COUNT @D88494, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MATCH, 
   [COORD @D88497, AGR [COUNT @D88496, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MATCH, 
   [COORD @D88501, AGR [COUNT @D88500, PER @D88499, PLU @D88498, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MATCH, 
   [COORD @D88507, PAST @D88506, 
      AGR [CASE @D88505, COUNT @D88504, PER @D88503, PLU @D88502, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : MATCH, 
   [COORD @D88510, AGR [COUNT @D88509, PER @D88508, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : MATCH, 
   [COORD @D88512, AGR [COUNT @D88511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : MATCH, 
   [COORD @D88514, AGR [COUNT @D88513, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : MATCH, 
   [COORD @D88518, AGR [COUNT @D88517, PER @D88516, PLU @D88515, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : MATCH, 
   [COORD @D88524, PAST @D88523, 
      AGR [CASE @D88522, COUNT @D88521, PER @D88520, PLU @D88519, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AGAINST, ARITY 3] : MATCH, 
   [COORD @D88527, AGR [COUNT @D88526, PER @D88525, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MATCH, 
   [COORD @D88529, AGR [COUNT @D88528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MATCH, 
   [COORD @D88531, AGR [COUNT @D88530, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MATCH, 
   [COORD @D88535, AGR [COUNT @D88534, PER @D88533, PLU @D88532, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MATCH, 
   [COORD @D88541, PAST @D88540, AGR [CASE @D88539, COUNT @D88538, 
            PER @D88537, PLU @D88536, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MATCH, 
   [COORD @D88544, AGR [COUNT @D88543, PER @D88542, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : MATCH, 
   [COORD @D88546, AGR [COUNT @D88545, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : MATCH, 
   [COORD @D88548, AGR [COUNT @D88547, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : MATCH, 
   [COORD @D88552, AGR [COUNT @D88551, PER @D88550, PLU @D88549, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : MATCH, 
   [COORD @D88558, PAST @D88557, 
      AGR [CASE @D88556, COUNT @D88555, PER @D88554, PLU @D88553, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, 
      ARITY 2] : MATCH, 
   [COORD @D88561, AGR [COUNT @D88560, PER @D88559, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MATCH, 
   [COORD @D88563, AGR [COUNT @D88562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MATCH, 
   [COORD @D88565, AGR [COUNT @D88564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MATCH, 
   [COORD @D88569, AGR [COUNT @D88568, PER @D88567, PLU @D88566, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : MATCH, 
   [COORD @D88575, PAST @D88574, 
      AGR [CASE @D88573, COUNT @D88572, PER @D88571, PLU @D88570, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : MATCH, 
   [COORD @D88578, AGR [COUNT @D88577, PER @D88576, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATCH, 
   [COORD @D88580, AGR [COUNT @D88579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATCH, 
   [COORD @D88582, AGR [COUNT @D88581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATCH, 
   [COORD @D88586, AGR [COUNT @D88585, PER @D88584, PLU @D88583, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATCH, 
   [COORD @D88592, PAST @D88591, AGR [CASE @D88590, COUNT @D88589, 
            PER @D88588, PLU @D88587, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MATCH, 
   [COORD @D88595, AGR [COUNT @D88594, PER @D88593, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MATCH, 
   [COORD @D88597, AGR [COUNT @D88596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MATCH, 
   [COORD @D88599, AGR [COUNT @D88598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MATCH, 
   [COORD @D88603, AGR [COUNT @D88602, PER @D88601, PLU @D88600, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MATCH, 
   [COORD @D88609, PAST @D88608, 
      AGR [CASE @D88607, COUNT @D88606, PER @D88605, PLU @D88604, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : MATCH.

WORD matched : 
   [COORD @D88622, AGR [CASE @D88621, COUNT @D88620, PER @D88619, 
            PLU @D88618, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88627, AGR [CASE @D88626, COUNT @D88625, PER @D88624, 
            PLU @D88623, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88632, AGR [CASE @D88631, COUNT @D88630, PER @D88629, 
            PLU @D88628, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88637, AGR [CASE @D88636, COUNT @D88635, PER @D88634, 
            PLU @D88633, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88642, AGR [CASE @D88641, COUNT @D88640, PER @D88639, 
            PLU @D88638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88647, AGR [CASE @D88646, COUNT @D88645, PER @D88644, 
            PLU @D88643, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88652, AGR [CASE @D88651, COUNT @D88650, PER @D88649, 
            PLU @D88648, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88657, AGR [CASE @D88656, COUNT @D88655, PER @D88654, 
            PLU @D88653, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88662, AGR [CASE @D88661, COUNT @D88660, PER @D88659, 
            PLU @D88658, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88667, AGR [CASE @D88666, COUNT @D88665, PER @D88664, 
            PLU @D88663, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88672, AGR [CASE @D88671, COUNT @D88670, PER @D88669, 
            PLU @D88668, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88677, AGR [CASE @D88676, COUNT @D88675, PER @D88674, 
            PLU @D88673, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88682, AGR [CASE @D88681, COUNT @D88680, PER @D88679, 
            PLU @D88678, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MATCH, 
   [COORD @D88687, AGR [CASE @D88686, COUNT @D88685, PER @D88684, 
            PLU @D88683, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88692, AGR [CASE @D88691, COUNT @D88690, PER @D88689, 
            PLU @D88688, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88697, AGR [CASE @D88696, COUNT @D88695, PER @D88694, 
            PLU @D88693, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88702, AGR [CASE @D88701, COUNT @D88700, PER @D88699, 
            PLU @D88698, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88707, AGR [CASE @D88706, COUNT @D88705, PER @D88704, 
            PLU @D88703, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88712, AGR [CASE @D88711, COUNT @D88710, PER @D88709, 
            PLU @D88708, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88717, AGR [CASE @D88716, COUNT @D88715, PER @D88714, 
            PLU @D88713, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88722, AGR [CASE @D88721, COUNT @D88720, PER @D88719, 
            PLU @D88718, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88727, AGR [CASE @D88726, COUNT @D88725, PER @D88724, 
            PLU @D88723, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88732, AGR [CASE @D88731, COUNT @D88730, PER @D88729, 
            PLU @D88728, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88737, AGR [CASE @D88736, COUNT @D88735, PER @D88734, 
            PLU @D88733, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88742, AGR [CASE @D88741, COUNT @D88740, PER @D88739, 
            PLU @D88738, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MATCH.

WORD matches : 
   [COORD @D88755, DEMON @D88754, REFL @D88753, PRD @D88752, 
      CASE @D88751, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MATCH, 
   [COORD @D88757, 
      AGR [COUNT @D88756, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MATCH, 
   [COORD @D88759, AGR [COUNT @D88758, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATCH, 
   [COORD @D88761, 
      AGR [COUNT @D88760, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATCH, 
   [COORD @D88763, 
      AGR [COUNT @D88762, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MATCH, 
   [COORD @D88765, AGR [COUNT @D88764, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATCH, 
   [COORD @D88767, 
      AGR [COUNT @D88766, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MATCH, 
   [COORD @D88769, AGR [COUNT @D88768, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATCH, 
   [COORD @D88771, 
      AGR [COUNT @D88770, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATCH, 
   [COORD @D88773, 
      AGR [COUNT @D88772, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATCH.

WORD matching : 
   [COORD @D88791, PRD @D88790, AGR [CASE @D88789, COUNT @D88788, 
            PER @D88787, PLU @D88786, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88797, PRD @D88796, 
      AGR [CASE @D88795, COUNT @D88794, PER @D88793, PLU @D88792, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MATCH, 
   [COORD @D88803, PRD @D88802, AGR [CASE @D88801, COUNT @D88800, 
            PER @D88799, PLU @D88798, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88809, PRD @D88808, 
      AGR [CASE @D88807, COUNT @D88806, PER @D88805, PLU @D88804, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MATCH, 
   [COORD @D88815, PRD @D88814, AGR [CASE @D88813, COUNT @D88812, 
            PER @D88811, PLU @D88810, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88821, PRD @D88820, 
      AGR [CASE @D88819, COUNT @D88818, PER @D88817, PLU @D88816, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MATCH, 
   [COORD @D88827, PRD @D88826, AGR [CASE @D88825, COUNT @D88824, 
            PER @D88823, PLU @D88822, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH, 
   [COORD @D88833, PRD @D88832, 
      AGR [CASE @D88831, COUNT @D88830, PER @D88829, PLU @D88828, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MATCH, 
   [COORD @D88839, PRD @D88838, AGR [CASE @D88837, COUNT @D88836, 
            PER @D88835, PLU @D88834, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATCH.

WORD mate : 
   [COORD @D88857, REFL @D88856, PRD @D88855, CASE @D88854, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, ADDRESS +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MATE, 
   [COORD @D88862, REFL @D88861, COUNT @D88860, PRD @D88859, 
      CASE @D88858, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : MATE, 
   [COORD @D88865, 
      AGR [COUNT @D88864, PER @D88863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : MATE, 
   [COORD @D88867, AGR [COUNT @D88866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MATE, 
   [COORD @D88869, AGR [COUNT @D88868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MATE, 
   [COORD @D88873, AGR [COUNT @D88872, PER @D88871, PLU @D88870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : MATE, 
   [COORD @D88879, PAST @D88878, 
      AGR [CASE @D88877, COUNT @D88876, PER @D88875, PLU @D88874, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : MATE, 
   [COORD @D88882, AGR [COUNT @D88881, PER @D88880, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MATE, 
   [COORD @D88884, AGR [COUNT @D88883, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MATE, 
   [COORD @D88886, AGR [COUNT @D88885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MATE, 
   [COORD @D88890, AGR [COUNT @D88889, PER @D88888, PLU @D88887, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MATE, 
   [COORD @D88896, PAST @D88895, AGR [CASE @D88894, COUNT @D88893, 
            PER @D88892, PLU @D88891, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MATE, 
   [COORD @D88899, AGR [COUNT @D88898, PER @D88897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : MATE, 
   [COORD @D88901, AGR [COUNT @D88900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : MATE, 
   [COORD @D88903, AGR [COUNT @D88902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : MATE, 
   [COORD @D88907, AGR [COUNT @D88906, PER @D88905, PLU @D88904, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : MATE, 
   [COORD @D88913, PAST @D88912, 
      AGR [CASE @D88911, COUNT @D88910, PER @D88909, PLU @D88908, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : MATE, 
   [COORD @D88916, AGR [COUNT @D88915, PER @D88914, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATE, 
   [COORD @D88918, AGR [COUNT @D88917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATE, 
   [COORD @D88920, AGR [COUNT @D88919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATE, 
   [COORD @D88924, AGR [COUNT @D88923, PER @D88922, PLU @D88921, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATE, 
   [COORD @D88930, PAST @D88929, AGR [CASE @D88928, COUNT @D88927, 
            PER @D88926, PLU @D88925, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MATE.

WORD mated : 
   [COORD @D88943, AGR [CASE @D88942, COUNT @D88941, PER @D88940, 
            PLU @D88939, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATE, 
   [COORD @D88948, AGR [CASE @D88947, COUNT @D88946, PER @D88945, 
            PLU @D88944, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATE, 
   [COORD @D88953, AGR [CASE @D88952, COUNT @D88951, PER @D88950, 
            PLU @D88949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MATE, 
   [COORD @D88958, AGR [CASE @D88957, COUNT @D88956, PER @D88955, 
            PLU @D88954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATE, 
   [COORD @D88963, AGR [CASE @D88962, COUNT @D88961, PER @D88960, 
            PLU @D88959, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MATE, 
   [COORD @D88968, AGR [CASE @D88967, COUNT @D88966, PER @D88965, 
            PLU @D88964, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MATE, 
   [COORD @D88973, AGR [CASE @D88972, COUNT @D88971, PER @D88970, 
            PLU @D88969, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATE, 
   [COORD @D88978, AGR [CASE @D88977, COUNT @D88976, PER @D88975, 
            PLU @D88974, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MATE, 
   [COORD @D88983, AGR [CASE @D88982, COUNT @D88981, PER @D88980, 
            PLU @D88979, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATE, 
   [COORD @D88988, AGR [CASE @D88987, COUNT @D88986, PER @D88985, 
            PLU @D88984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MATE.

WORD mates : 
   [COORD @D89001, DEMON @D89000, REFL @D88999, PRD @D88998, CASE 
         @D88997, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MATE, 
   [COORD @D89003, 
      AGR [COUNT @D89002, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MATE, 
   [COORD @D89005, AGR [COUNT @D89004, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATE, 
   [COORD @D89007, 
      AGR [COUNT @D89006, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATE, 
   [COORD @D89009, 
      AGR [COUNT @D89008, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATE.

WORD mating : 
   [COORD @D89021, PRD @D89020, AGR [CASE @D89019, COUNT @D89018, 
            PER @D89017, PLU @D89016, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MATE, 
   [COORD @D89027, PRD @D89026, 
      AGR [CASE @D89025, COUNT @D89024, PER @D89023, PLU @D89022, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MATE, 
   [COORD @D89033, PRD @D89032, AGR [CASE @D89031, COUNT @D89030, 
            PER @D89029, PLU @D89028, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATE, 
   [COORD @D89039, PRD @D89038, 
      AGR [CASE @D89037, COUNT @D89036, PER @D89035, PLU @D89034, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MATE.

WORD matter : 
   [COORD @D89049, REFL @D89048, PRD @D89047, CASE @D89046, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MATTER, 
   [COORD @D89054, REFL @D89053, COUNT @D89052, PRD @D89051, 
      CASE @D89050, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : MATTER, 
   [COORD @D89057, AGR @D89056, PAST @D89055, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 2] : MATTER, 
   [COORD @D89060, AGR [COUNT @D89059, PER @D89058, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : MATTER, 
   [COORD @D89062, AGR [COUNT @D89061, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : MATTER, 
   [COORD @D89064, AGR [COUNT @D89063, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : MATTER, 
   [COORD @D89068, AGR [COUNT @D89067, PER @D89066, PLU @D89065, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : MATTER, 
   [COORD @D89074, PAST @D89073, 
      AGR [CASE @D89072, COUNT @D89071, PER @D89070, PLU @D89069, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : MATTER, 
   [COORD @D89077, AGR @D89076, PAST @D89075, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT SFIN, ARITY 1] : MATTER, 
   [COORD @D89080, AGR [COUNT @D89079, PER @D89078, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATTER, 
   [COORD @D89082, AGR [COUNT @D89081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATTER, 
   [COORD @D89084, AGR [COUNT @D89083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATTER, 
   [COORD @D89088, AGR [COUNT @D89087, PER @D89086, PLU @D89085, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MATTER, 
   [COORD @D89094, PAST @D89093, AGR [CASE @D89092, COUNT @D89091, 
            PER @D89090, PLU @D89089, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MATTER.

WORD mattered : 
   [COORD @D89104, AGR @D89103, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MATTER, 
   [COORD @D89106, AGR @D89105, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : MATTER, 
   [COORD @D89111, AGR [CASE @D89110, COUNT @D89109, PER @D89108, 
            PLU @D89107, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATTER, 
   [COORD @D89116, AGR [CASE @D89115, COUNT @D89114, PER @D89113, 
            PLU @D89112, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MATTER, 
   [COORD @D89118, AGR @D89117, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MATTER, 
   [COORD @D89120, AGR @D89119, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : MATTER, 
   [COORD @D89125, AGR [CASE @D89124, COUNT @D89123, PER @D89122, 
            PLU @D89121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATTER, 
   [COORD @D89130, AGR [CASE @D89129, COUNT @D89128, PER @D89127, 
            PLU @D89126, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MATTER.

WORD mattering : 
   [COORD @D89145, AGR @D89144, PRD @D89143, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MATTER, 
   [COORD @D89151, PRD @D89150, AGR [CASE @D89149, COUNT @D89148, 
            PER @D89147, PLU @D89146, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MATTER, 
   [COORD @D89154, AGR @D89153, PRD @D89152, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MATTER, 
   [COORD @D89160, PRD @D89159, AGR [CASE @D89158, COUNT @D89157, 
            PER @D89156, PLU @D89155, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MATTER.

WORD matters : 
   [COORD @D89173, DEMON @D89172, REFL @D89171, PRD @D89170, 
      CASE @D89169, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MATTER, 
   [COORD @D89177, 
      AGR [CASE @D89176, NFORM @D89175, COUNT @D89174, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EXTRAP, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MATTER, 
   [COORD @D89182, AGR [UB @D89181, VFORM @D89180, SUBJ @D89179, 
            FIN @D89178, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST -, BAR 0, V +, N -] : MATTER, 
   [COORD @D89184, AGR [COUNT @D89183, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATTER, 
   [COORD @D89188, 
      AGR [CASE @D89187, NFORM @D89186, COUNT @D89185, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EXTRAP, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATTER, 
   [COORD @D89193, 
      AGR [UB @D89192, VFORM @D89191, SUBJ @D89190, FIN @D89189, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EXTRAP, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATTER, 
   [COORD @D89195, 
      AGR [COUNT @D89194, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MATTER.

WORD mean : 
   [COORD @D89203, AGR [COUNT @D89202, PER @D89201, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : MEAN, 
   [COORD @D89205, AGR [COUNT @D89204, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : MEAN, 
   [COORD @D89207, AGR [COUNT @D89206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : MEAN, 
   [COORD @D89211, AGR [COUNT @D89210, PER @D89209, PLU @D89208, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : MEAN, 
   [COORD @D89217, PAST @D89216, 
      AGR [CASE @D89215, COUNT @D89214, PER @D89213, PLU @D89212, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   MEAN, 
   [COORD @D89220, AGR [COUNT @D89219, PER @D89218, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : MEAN, 
   [COORD @D89222, AGR [COUNT @D89221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : MEAN, 
   [COORD @D89224, AGR [COUNT @D89223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : MEAN, 
   [COORD @D89228, AGR [COUNT @D89227, PER @D89226, PLU @D89225, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : MEAN, 
   [COORD @D89234, PAST @D89233, 
      AGR [CASE @D89232, COUNT @D89231, PER @D89230, PLU @D89229, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : MEAN, 
   [COORD @D89237, AGR [COUNT @D89236, PER @D89235, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : MEAN, 
   [COORD @D89239, AGR [COUNT @D89238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : MEAN, 
   [COORD @D89241, AGR [COUNT @D89240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : MEAN, 
   [COORD @D89245, AGR [COUNT @D89244, PER @D89243, PLU @D89242, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : MEAN, 
   [COORD @D89251, PAST @D89250, 
      AGR [CASE @D89249, COUNT @D89248, PER @D89247, PLU @D89246, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : MEAN, 
   [COORD @D89254, AGR [COUNT @D89253, PER @D89252, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89256, AGR [COUNT @D89255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89258, AGR [COUNT @D89257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89262, AGR [COUNT @D89261, PER @D89260, PLU @D89259, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, REG -, ARITY 2] : MEAN, 
   [COORD @D89268, PAST @D89267, 
      AGR [CASE @D89266, COUNT @D89265, PER @D89264, PLU @D89263, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, REG -, ARITY 2] : 
   MEAN, 
   [COORD @D89271, AGR [COUNT @D89270, PER @D89269, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89273, AGR [COUNT @D89272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89275, AGR [COUNT @D89274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89279, AGR [COUNT @D89278, PER @D89277, PLU @D89276, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : MEAN, 
   [COORD @D89285, PAST @D89284, 
      AGR [CASE @D89283, COUNT @D89282, PER @D89281, PLU @D89280, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   MEAN, 
   [COORD @D89288, AGR [COUNT @D89287, PER @D89286, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89290, AGR [COUNT @D89289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89292, AGR [COUNT @D89291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89296, AGR [COUNT @D89295, PER @D89294, PLU @D89293, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 2] : MEAN, 
   [COORD @D89302, PAST @D89301, 
      AGR [CASE @D89300, COUNT @D89299, PER @D89298, PLU @D89297, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, ARITY 2] : 
   MEAN, 
   [COORD @D89305, AGR [COUNT @D89304, PER @D89303, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89307, AGR [COUNT @D89306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89309, AGR [COUNT @D89308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89313, AGR [COUNT @D89312, PER @D89311, PLU @D89310, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, ARITY 2] : MEAN, 
   [COORD @D89319, PAST @D89318, 
      AGR [CASE @D89317, COUNT @D89316, PER @D89315, PLU @D89314, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, REG -, ARITY 2] : 
   MEAN, 
   [COORD @D89322, AGR [COUNT @D89321, PER @D89320, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MEAN, 
   [COORD @D89324, AGR [COUNT @D89323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MEAN, 
   [COORD @D89326, AGR [COUNT @D89325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MEAN, 
   [COORD @D89330, AGR [COUNT @D89329, PER @D89328, PLU @D89327, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89336, PAST @D89335, AGR [CASE @D89334, COUNT @D89333, 
            PER @D89332, PLU @D89331, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : MEAN, 
   [COORD @D89339, AGR [COUNT @D89338, PER @D89337, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89341, AGR [COUNT @D89340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89343, AGR [COUNT @D89342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : MEAN, 
   [COORD @D89347, AGR [COUNT @D89346, PER @D89345, PLU @D89344, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : MEAN, 
   [COORD @D89353, PAST @D89352, 
      AGR [CASE @D89351, COUNT @D89350, PER @D89349, PLU @D89348, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : 
   MEAN.

WORD meaning : 
   [COADV @D89369, COORD @D89368, DEF @D89367, PRD @D89366, AGR 
            [CASE @D89365, COUNT @D89364, PER @D89363, PLU @D89362, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   MEANING, 
   [COADV @D89377, COORD @D89376, DEF @D89375, PRD @D89374, AGR 
            [CASE @D89373, COUNT @D89372, PER @D89371, PLU @D89370, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR ATT] : 
   MEANING, 
   [COORD @D89382, REFL @D89381, COUNT @D89380, PRD @D89379, 
      CASE @D89378, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : MEANING, 
   [COORD @D89388, PRD @D89387, 
      AGR [CASE @D89386, COUNT @D89385, PER @D89384, PLU @D89383, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MEAN, 
   [COORD @D89394, PRD @D89393, AGR [CASE @D89392, COUNT @D89391, 
            PER @D89390, PLU @D89389, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MEAN, 
   [COORD @D89400, PRD @D89399, 
      AGR [CASE @D89398, COUNT @D89397, PER @D89396, PLU @D89395, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MEAN, 
   [COORD @D89406, PRD @D89405, AGR [CASE @D89404, COUNT @D89403, 
            PER @D89402, PLU @D89401, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEAN, 
   [COORD @D89412, PRD @D89411, 
      AGR [CASE @D89410, COUNT @D89409, PER @D89408, PLU @D89407, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MEAN, 
   [COORD @D89418, PRD @D89417, AGR [CASE @D89416, COUNT @D89415, 
            PER @D89414, PLU @D89413, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEAN, 
   [COORD @D89424, PRD @D89423, 
      AGR [CASE @D89422, COUNT @D89421, PER @D89420, PLU @D89419, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MEAN, 
   [COORD @D89430, PRD @D89429, AGR [CASE @D89428, COUNT @D89427, 
            PER @D89426, PLU @D89425, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEAN, 
   [COORD @D89436, PRD @D89435, 
      AGR [CASE @D89434, COUNT @D89433, PER @D89432, PLU @D89431, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MEAN.

WORD meanings : 
   [COORD @D89452, DEMON @D89451, REFL @D89450, PRD @D89449, 
      CASE @D89448, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MEANING.

WORD means : 
   [COORD @D89460, AGR [COUNT @D89459, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89462, 
      AGR [COUNT @D89461, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89464, 
      AGR [COUNT @D89463, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89466, 
      AGR [COUNT @D89465, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89468, 
      AGR [COUNT @D89467, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89470, 
      AGR [COUNT @D89469, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89472, 
      AGR [COUNT @D89471, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89474, 
      AGR [COUNT @D89473, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN, 
   [COORD @D89476, 
      AGR [COUNT @D89475, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEAN.

WORD meant : 
   [COORD @D89488, PAST @D89487, AGR [CASE @D89486, COUNT @D89485, 
            PER @D89484, PLU @D89483, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : MEAN, 
   [COORD @D89494, PAST @D89493, 
      AGR [CASE @D89492, COUNT @D89491, PER @D89490, PLU @D89489, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : MEAN, 
   
   [COORD @D89500, PAST @D89499, AGR [CASE @D89498, COUNT @D89497, PER 
               @D89496, PLU @D89495, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : MEAN, 
   [COORD @D89506, PAST @D89505, 
      AGR [CASE @D89504, COUNT @D89503, PER @D89502, PLU @D89501, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : MEAN, 
   [COORD @D89512, PAST @D89511, AGR [CASE @D89510, COUNT @D89509, 
            PER @D89508, PLU @D89507, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : MEAN, 
   [COORD @D89518, PAST @D89517, 
      AGR [CASE @D89516, COUNT @D89515, PER @D89514, PLU @D89513, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, FIN -, 
      ARITY 3] : MEAN, 
   [COORD @D89522, AGR [COUNT @D89521, PER @D89520, PLU @D89519, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : MEAN, 
   [COORD @D89526, AGR [COUNT @D89525, PER @D89524, PLU @D89523, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : MEAN, 
   [COORD @D89530, AGR [COUNT @D89529, PER @D89528, PLU @D89527, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FOR, PAST +, ARITY 3] : MEAN, 
   [COORD @D89536, PAST @D89535, AGR 
         [CASE @D89534, COUNT @D89533, PER @D89532, PLU @D89531, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, REG -, FIN -, 
      ARITY 2] : MEAN, 
   [COORD @D89542, PAST @D89541, AGR [CASE @D89540, COUNT @D89539, 
            PER @D89538, PLU @D89537, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, REG -, FIN -, ARITY 2] : MEAN, 
   [COORD @D89548, PAST @D89547, 
      AGR [CASE @D89546, COUNT @D89545, PER @D89544, PLU @D89543, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, ARITY 2] : MEAN, 
   [COORD @D89554, PAST @D89553, 
      AGR [CASE @D89552, COUNT @D89551, PER @D89550, PLU @D89549, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, FIN -, ARITY 2] : 
   MEAN, 
   [COORD @D89557, AGR @D89556, PAST @D89555, VFORM EN, SUBCAT OC_INF, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : MEAN, 
   [COORD @D89563, PAST @D89562, AGR [CASE @D89561, COUNT @D89560, 
            PER @D89559, PLU @D89558, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 2] : MEAN, 
   [COORD @D89569, PAST @D89568, 
      AGR [CASE @D89567, COUNT @D89566, PER @D89565, PLU @D89564, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : MEAN, 
   [COORD @D89575, PAST @D89574, AGR [CASE @D89573, COUNT @D89572, 
            PER @D89571, PLU @D89570, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : MEAN, 
   [COORD @D89581, PAST @D89580, 
      AGR [CASE @D89579, COUNT @D89578, PER @D89577, PLU @D89576, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, FIN -, ARITY 2] : MEAN, 
   [COORD @D89585, 
      AGR [COUNT @D89584, PER @D89583, PLU @D89582, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, REG -, 
      PAST +, ARITY 2] : MEAN, 
   [COORD @D89589, AGR [COUNT @D89588, PER @D89587, PLU @D89586, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : MEAN, 
   [COORD @D89593, AGR [COUNT @D89592, PER @D89591, PLU @D89590, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PAST +, ARITY 2] : MEAN, 
   [COORD @D89597, AGR [COUNT @D89596, PER @D89595, PLU @D89594, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, PAST +, ARITY 2] : MEAN, 
   [COORD @D89601, AGR [COUNT @D89600, PER @D89599, PLU @D89598, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : MEAN, 
   [COORD @D89605, AGR [COUNT @D89604, PER @D89603, PLU @D89602, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, 
      PAST +, ARITY 2] : MEAN.

WORD measure : 
   [COORD @D89642, REFL @D89641, PRD @D89640, CASE @D89639, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MEASURE, 
   [COORD @D89646, REFL @D89645, PRD @D89644, CASE @D89643, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MEASURE, 
   [COORD @D89650, REFL @D89649, PRD @D89648, CASE @D89647, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : MEASURE, 
   [COORD @D89654, REFL @D89653, PRD @D89652, CASE @D89651, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : MEASURE, 
   [COORD @D89659, REFL @D89658, COUNT @D89657, PRD @D89656, 
      CASE @D89655, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : MEASURE, 
   [COORD @D89662, 
      AGR [COUNT @D89661, PER @D89660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AGAINST, ARITY 3] : MEASURE, 
   [COORD @D89664, AGR [COUNT @D89663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : MEASURE, 
   [COORD @D89666, AGR [COUNT @D89665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : MEASURE, 
   [COORD @D89670, AGR [COUNT @D89669, PER @D89668, PLU @D89667, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : MEASURE, 
   [COORD @D89676, PAST @D89675, 
      AGR [CASE @D89674, COUNT @D89673, PER @D89672, PLU @D89671, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, 
      ARITY 3] : MEASURE, 
   [COORD @D89679, AGR [COUNT @D89678, PER @D89677, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MEASURE, 
   [COORD @D89681, AGR [COUNT @D89680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MEASURE, 
   [COORD @D89683, AGR [COUNT @D89682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MEASURE, 
   [COORD @D89687, AGR [COUNT @D89686, PER @D89685, PLU @D89684, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MEASURE, 
   [COORD @D89693, PAST @D89692, AGR [CASE @D89691, COUNT @D89690, 
            PER @D89689, PLU @D89688, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MEASURE, 
   [COORD @D89696, AGR [COUNT @D89695, PER @D89694, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      ARITY 2] : MEASURE, 
   [COORD @D89698, AGR [COUNT @D89697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      ARITY 2] : MEASURE, 
   [COORD @D89700, AGR [COUNT @D89699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      ARITY 2] : MEASURE, 
   [COORD @D89704, AGR [COUNT @D89703, PER @D89702, PLU @D89701, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT MP, ARITY 2] : MEASURE, 
   [COORD @D89710, PAST @D89709, AGR [CASE @D89708, COUNT @D89707, 
            PER @D89706, PLU @D89705, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT MP, ARITY 2] : MEASURE, 
   [COORD @D89713, AGR [COUNT @D89712, PER @D89711, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : MEASURE, 
   [COORD @D89715, AGR [COUNT @D89714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : MEASURE, 
   [COORD @D89717, AGR [COUNT @D89716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : MEASURE, 
   [COORD @D89721, AGR [COUNT @D89720, PER @D89719, PLU @D89718, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : MEASURE, 
   [COORD @D89727, PAST @D89726, 
      AGR [CASE @D89725, COUNT @D89724, PER @D89723, PLU @D89722, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : MEASURE, 
   [COORD @D89730, AGR [COUNT @D89729, PER @D89728, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : MEASURE, 
   [COORD @D89732, AGR [COUNT @D89731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : MEASURE, 
   [COORD @D89734, AGR [COUNT @D89733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : MEASURE, 
   [COORD @D89738, AGR [COUNT @D89737, PER @D89736, PLU @D89735, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : MEASURE, 
   [COORD @D89744, PAST @D89743, 
      AGR [CASE @D89742, COUNT @D89741, PER @D89740, PLU @D89739, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : MEASURE, 
   [COORD @D89747, AGR [COUNT @D89746, PER @D89745, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : MEASURE, 
   [COORD @D89749, AGR [COUNT @D89748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : MEASURE, 
   [COORD @D89751, AGR [COUNT @D89750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : MEASURE, 
   [COORD @D89755, AGR [COUNT @D89754, PER @D89753, PLU @D89752, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : MEASURE, 
   [COORD @D89761, PAST @D89760, 
      AGR [CASE @D89759, COUNT @D89758, PER @D89757, PLU @D89756, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : MEASURE, 
   [COORD @D89764, AGR [COUNT @D89763, PER @D89762, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MEASURE, 
   [COORD @D89766, AGR [COUNT @D89765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MEASURE, 
   [COORD @D89768, AGR [COUNT @D89767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MEASURE, 
   [COORD @D89772, AGR [COUNT @D89771, PER @D89770, PLU @D89769, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MEASURE, 
   [COORD @D89778, PAST @D89777, AGR [CASE @D89776, COUNT @D89775, 
            PER @D89774, PLU @D89773, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MEASURE, 
   [COORD @D89781, AGR [COUNT @D89780, PER @D89779, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MEASURE, 
   [COORD @D89783, AGR [COUNT @D89782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MEASURE, 
   [COORD @D89785, AGR [COUNT @D89784, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MEASURE, 
   [COORD @D89789, AGR [COUNT @D89788, PER @D89787, PLU @D89786, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MEASURE, 
   [COORD @D89795, PAST @D89794, 
      AGR [CASE @D89793, COUNT @D89792, PER @D89791, PLU @D89790, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : MEASURE, 
   [COORD @D89798, AGR [COUNT @D89797, PER @D89796, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MEASURE, 
   [COORD @D89800, AGR [COUNT @D89799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MEASURE, 
   [COORD @D89802, AGR [COUNT @D89801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MEASURE, 
   [COORD @D89806, AGR [COUNT @D89805, PER @D89804, PLU @D89803, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MEASURE, 
   [COORD @D89812, PAST @D89811, 
      AGR [CASE @D89810, COUNT @D89809, PER @D89808, PLU @D89807, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : MEASURE, 
   [COORD @D89815, AGR [COUNT @D89814, PER @D89813, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MEASURE, 
   [COORD @D89817, AGR [COUNT @D89816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MEASURE, 
   [COORD @D89819, AGR [COUNT @D89818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MEASURE, 
   [COORD @D89823, AGR [COUNT @D89822, PER @D89821, PLU @D89820, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MEASURE, 
   [COORD @D89829, PAST @D89828, 
      AGR [CASE @D89827, COUNT @D89826, PER @D89825, PLU @D89824, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : MEASURE.

WORD measured : 
   [COORD @D89843, AGR [CASE @D89842, COUNT @D89841, PER @D89840, 
            PLU @D89839, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89848, AGR [CASE @D89847, COUNT @D89846, PER @D89845, 
            PLU @D89844, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89853, AGR [CASE @D89852, COUNT @D89851, PER @D89850, 
            PLU @D89849, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89858, AGR [CASE @D89857, COUNT @D89856, PER @D89855, 
            PLU @D89854, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MEASURE, 
   [COORD @D89863, AGR [CASE @D89862, COUNT @D89861, PER @D89860, 
            PLU @D89859, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89868, AGR [CASE @D89867, COUNT @D89866, PER @D89865, 
            PLU @D89864, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89873, AGR [CASE @D89872, COUNT @D89871, PER @D89870, 
            PLU @D89869, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT MP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89878, AGR [CASE @D89877, COUNT @D89876, PER @D89875, 
            PLU @D89874, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT MP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89883, AGR [CASE @D89882, COUNT @D89881, PER @D89880, 
            PLU @D89879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89888, AGR [CASE @D89887, COUNT @D89886, PER @D89885, 
            PLU @D89884, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89893, AGR [CASE @D89892, COUNT @D89891, PER @D89890, 
            PLU @D89889, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89898, AGR [CASE @D89897, COUNT @D89896, PER @D89895, 
            PLU @D89894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89903, AGR [CASE @D89902, COUNT @D89901, PER @D89900, 
            PLU @D89899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89908, AGR [CASE @D89907, COUNT @D89906, PER @D89905, 
            PLU @D89904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89913, AGR [CASE @D89912, COUNT @D89911, PER @D89910, 
            PLU @D89909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89918, AGR [CASE @D89917, COUNT @D89916, PER @D89915, 
            PLU @D89914, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89923, AGR [CASE @D89922, COUNT @D89921, PER @D89920, 
            PLU @D89919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89928, AGR [CASE @D89927, COUNT @D89926, PER @D89925, 
            PLU @D89924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89933, AGR [CASE @D89932, COUNT @D89931, PER @D89930, 
            PLU @D89929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89938, AGR [CASE @D89937, COUNT @D89936, PER @D89935, 
            PLU @D89934, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89943, AGR [CASE @D89942, COUNT @D89941, PER @D89940, 
            PLU @D89939, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89948, AGR [CASE @D89947, COUNT @D89946, PER @D89945, 
            PLU @D89944, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89953, AGR [CASE @D89952, COUNT @D89951, PER @D89950, 
            PLU @D89949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89958, AGR [CASE @D89957, COUNT @D89956, PER @D89955, 
            PLU @D89954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MEASURE.

WORD measures : 
   [COORD @D89972, DEMON @D89971, REFL @D89970, PRD @D89969, 
      CASE @D89968, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MEASURE, 
   
   [COORD @D89977, DEMON @D89976, REFL @D89975, PRD @D89974, CASE 
      @D89973, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MEASURE, 
   
   [COORD @D89979, AGR [COUNT @D89978, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : MEASURE, 
   [COORD @D89981, AGR [COUNT @D89980, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89983, 
      AGR [COUNT @D89982, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT MP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89985, 
      AGR [COUNT @D89984, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MEASURE, 
   [COORD @D89987, AGR [COUNT @D89986, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89989, 
      AGR [COUNT @D89988, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89991, 
      AGR [COUNT @D89990, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89993, 
      AGR [COUNT @D89992, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89995, 
      AGR [COUNT @D89994, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE, 
   [COORD @D89997, 
      AGR [COUNT @D89996, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEASURE.

WORD measuring : 
   [COORD @D90010, PRD @D90009, AGR [CASE @D90008, COUNT @D90007, 
            PER @D90006, PLU @D90005, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D90016, PRD @D90015, 
      AGR [CASE @D90014, COUNT @D90013, PER @D90012, PLU @D90011, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MEASURE, 
   [COORD @D90022, PRD @D90021, AGR [CASE @D90020, COUNT @D90019, 
            PER @D90018, PLU @D90017, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT MP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D90028, PRD @D90027, 
      AGR [CASE @D90026, COUNT @D90025, PER @D90024, PLU @D90023, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MEASURE, 
   [COORD @D90034, PRD @D90033, AGR [CASE @D90032, COUNT @D90031, 
            PER @D90030, PLU @D90029, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D90040, PRD @D90039, 
      AGR [CASE @D90038, COUNT @D90037, PER @D90036, PLU @D90035, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MEASURE, 
   [COORD @D90046, PRD @D90045, AGR [CASE @D90044, COUNT @D90043, 
            PER @D90042, PLU @D90041, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D90052, PRD @D90051, 
      AGR [CASE @D90050, COUNT @D90049, PER @D90048, PLU @D90047, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MEASURE, 
   [COORD @D90058, PRD @D90057, AGR [CASE @D90056, COUNT @D90055, 
            PER @D90054, PLU @D90053, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MEASURE, 
   [COORD @D90064, PRD @D90063, 
      AGR [CASE @D90062, COUNT @D90061, PER @D90060, PLU @D90059, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MEASURE.

WORD meet : 
   [COORD @D90072, AGR [COUNT @D90071, PER @D90070, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : MEET, 
   [COORD @D90074, AGR [COUNT @D90073, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : MEET, 
   [COORD @D90076, AGR [COUNT @D90075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : MEET, 
   [COORD @D90080, AGR [COUNT @D90079, PER @D90078, PLU @D90077, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : MEET, 
   [COORD @D90086, PAST @D90085, 
      AGR [CASE @D90084, COUNT @D90083, PER @D90082, PLU @D90081, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      ARITY 3] : MEET, 
   [COORD @D90089, AGR [COUNT @D90088, PER @D90087, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MEET, 
   [COORD @D90091, AGR [COUNT @D90090, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MEET, 
   [COORD @D90093, AGR [COUNT @D90092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : MEET, 
   [COORD @D90097, AGR [COUNT @D90096, PER @D90095, PLU @D90094, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : MEET, 
   [COORD @D90103, PAST @D90102, AGR [CASE @D90101, COUNT @D90100, 
            PER @D90099, PLU @D90098, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : MEET, 
   [COORD @D90106, AGR [COUNT @D90105, PER @D90104, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90108, AGR [COUNT @D90107, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90110, AGR [COUNT @D90109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90114, AGR [COUNT @D90113, PER @D90112, PLU @D90111, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90120, PAST @D90119, AGR 
         [CASE @D90118, COUNT @D90117, PER @D90116, PLU @D90115, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : MEET, 
   [COORD @D90123, AGR [COUNT @D90122, PER @D90121, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90125, AGR [COUNT @D90124, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90127, AGR [COUNT @D90126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90131, AGR [COUNT @D90130, PER @D90129, PLU @D90128, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90137, PAST @D90136, 
      AGR [CASE @D90135, COUNT @D90134, PER @D90133, PLU @D90132, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM WITH, ARITY 2] : MEET, 
   [COORD @D90140, AGR [COUNT @D90139, PER @D90138, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : MEET, 
   [COORD @D90142, AGR [COUNT @D90141, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : MEET, 
   [COORD @D90144, AGR [COUNT @D90143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : MEET, 
   [COORD @D90148, AGR [COUNT @D90147, PER @D90146, PLU @D90145, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : MEET, 
   [COORD @D90154, PAST @D90153, 
      AGR [CASE @D90152, COUNT @D90151, PER @D90150, PLU @D90149, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   MEET, 
   [COORD @D90157, AGR [COUNT @D90156, PER @D90155, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : MEET, 
   [COORD @D90159, AGR [COUNT @D90158, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : MEET, 
   [COORD @D90161, AGR [COUNT @D90160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : MEET, 
   [COORD @D90165, AGR [COUNT @D90164, PER @D90163, PLU @D90162, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : MEET, 
   [COORD @D90171, PAST @D90170, 
      AGR [CASE @D90169, COUNT @D90168, PER @D90167, PLU @D90166, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : MEET.

WORD meeting : 
   [COORD @D90183, REFL @D90182, PRD @D90181, CASE @D90180, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MEETING, 
   [COORD @D90187, REFL @D90186, PRD @D90185, CASE @D90184, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, GROUP +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT -] : MEETING, 
   [COORD @D90193, PRD @D90192, 
      AGR [CASE @D90191, COUNT @D90190, PER @D90189, PLU @D90188, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MEET, 
   [COORD @D90199, PRD @D90198, AGR [CASE @D90197, COUNT @D90196, 
            PER @D90195, PLU @D90194, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MEET, 
   [COORD @D90205, PRD @D90204, 
      AGR [CASE @D90203, COUNT @D90202, PER @D90201, PLU @D90200, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MEET, 
   [COORD @D90211, PRD @D90210, AGR [CASE @D90209, COUNT @D90208, 
            PER @D90207, PLU @D90206, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MEET, 
   [COORD @D90217, PRD @D90216, 
      AGR [CASE @D90215, COUNT @D90214, PER @D90213, PLU @D90212, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MEET, 
   [COORD @D90223, PRD @D90222, AGR [CASE @D90221, COUNT @D90220, 
            PER @D90219, PLU @D90218, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MEET.

WORD meetings : 
   [COORD @D90238, DEMON @D90237, REFL @D90236, PRD @D90235, 
      CASE @D90234, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MEETING.

WORD meets : 
   [COORD @D90246, AGR [COUNT @D90245, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MEET, 
   [COORD @D90248, AGR [COUNT @D90247, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEET, 
   [COORD @D90250, 
      AGR [COUNT @D90249, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEET, 
   [COORD @D90252, 
      AGR [COUNT @D90251, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MEET, 
   [COORD @D90254, AGR [COUNT @D90253, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEET, 
   [COORD @D90256, 
      AGR [COUNT @D90255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MEET.

WORD mention : 
   [COORD @D90264, AGR [COUNT @D90263, PER @D90262, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MENTION, 
   [COORD @D90266, AGR [COUNT @D90265, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MENTION, 
   [COORD @D90268, AGR [COUNT @D90267, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MENTION, 
   [COORD @D90272, AGR [COUNT @D90271, PER @D90270, PLU @D90269, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MENTION, 
   [COORD @D90278, PAST @D90277, AGR [CASE @D90276, COUNT @D90275, 
            PER @D90274, PLU @D90273, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : MENTION, 
   [COORD @D90281, AGR [COUNT @D90280, PER @D90279, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MENTION, 
   [COORD @D90283, AGR [COUNT @D90282, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MENTION, 
   [COORD @D90285, AGR [COUNT @D90284, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MENTION, 
   [COORD @D90289, AGR [COUNT @D90288, PER @D90287, PLU @D90286, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MENTION, 
   [COORD @D90295, PAST @D90294, AGR [CASE @D90293, COUNT @D90292, 
            PER @D90291, PLU @D90290, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MENTION.

WORD mentioned : 
   [COORD @D90306, AGR [CASE @D90305, COUNT @D90304, PER @D90303, 
            PLU @D90302, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MENTION, 
   [COORD @D90311, AGR [CASE @D90310, COUNT @D90309, PER @D90308, 
            PLU @D90307, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MENTION, 
   [COORD @D90316, AGR [UB @D90315, VFORM @D90314, SUBJ @D90313, 
            FIN @D90312, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MENTION, 
   [COORD @D90321, AGR [CASE @D90320, COUNT @D90319, PER @D90318, 
            PLU @D90317, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MENTION, 
   [COORD @D90326, AGR [CASE @D90325, COUNT @D90324, PER @D90323, 
            PLU @D90322, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MENTION, 
   [COORD @D90331, AGR [CASE @D90330, COUNT @D90329, PER @D90328, 
            PLU @D90327, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MENTION.

WORD mentioning : 
   [COORD @D90345, PRD @D90344, AGR [CASE @D90343, COUNT @D90342, 
            PER @D90341, PLU @D90340, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MENTION, 
   [COORD @D90351, PRD @D90350, 
      AGR [CASE @D90349, COUNT @D90348, PER @D90347, PLU @D90346, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MENTION.

WORD mentions : 
   [COORD @D90359, AGR [COUNT @D90358, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MENTION, 
   [COORD @D90361, 
      AGR [COUNT @D90360, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MENTION.

WORD met : 
   [COORD @D90372, PAST @D90371, AGR [CASE @D90370, COUNT @D90369, 
            PER @D90368, PLU @D90367, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, FIN -, ARITY 3] : MEET, 
   [COORD @D90378, PAST @D90377, 
      AGR [CASE @D90376, COUNT @D90375, PER @D90374, PLU @D90373, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, FIN -, 
      ARITY 3] : MEET, 
   [COORD @D90382, AGR [COUNT @D90381, PER @D90380, PLU @D90379, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, PAST +, ARITY 3] : MEET, 
   [COORD @D90388, PAST @D90387, 
      AGR [CASE @D90386, COUNT @D90385, PER @D90384, PLU @D90383, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : MEET, 
   [COORD @D90394, PAST @D90393, AGR [CASE @D90392, COUNT @D90391, 
            PER @D90390, PLU @D90389, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : MEET, 
   [COORD @D90400, PAST @D90399, 
      AGR [CASE @D90398, COUNT @D90397, PER @D90396, PLU @D90395, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM WITH, FIN -, 
      ARITY 2] : MEET, 
   [COORD @D90406, PAST @D90405, AGR [CASE @D90404, COUNT @D90403, 
            PER @D90402, PLU @D90401, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM WITH, FIN -, ARITY 2] : MEET, 
   [COORD @D90412, PAST @D90411, 
      AGR [CASE @D90410, COUNT @D90409, PER @D90408, PLU @D90407, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, PFORM WITH, FIN -, 
      ARITY 2] : MEET, 
   [COORD @D90416, AGR [COUNT @D90415, PER @D90414, PLU @D90413, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : MEET, 
   [COORD @D90420, AGR [COUNT @D90419, PER @D90418, PLU @D90417, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, PAST +, ARITY 2] : MEET, 
   [COORD @D90424, AGR [COUNT @D90423, PER @D90422, PLU @D90421, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM WITH, PAST +, ARITY 2] : MEET, 
   [COORD @D90430, PAST @D90429, 
      AGR [CASE @D90428, COUNT @D90427, PER @D90426, PLU @D90425, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, ARITY 1] : MEET, 
   [COORD @D90436, PAST @D90435, 
      AGR [CASE @D90434, COUNT @D90433, PER @D90432, PLU @D90431, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : MEET, 
   [COORD @D90440, AGR [COUNT @D90439, PER @D90438, PLU @D90437, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : MEET, 
   [COORD @D90444, AGR [COUNT @D90443, PER @D90442, PLU @D90441, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : MEET.

WORD mind : 
   [COORD @D90472, REFL @D90471, PRD @D90470, CASE @D90469, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MIND, 
   [COORD @D90475, 
      AGR [COUNT @D90474, PER @D90473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, ARITY 2] : 
   MIND, 
   [COORD @D90477, AGR [COUNT @D90476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : MIND, 
   [COORD @D90479, AGR [COUNT @D90478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : MIND, 
   [COORD @D90483, AGR [COUNT @D90482, PER @D90481, PLU @D90480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : MIND, 
   [COORD @D90489, PAST @D90488, AGR [CASE @D90487, COUNT @D90486, 
            PER @D90485, PLU @D90484, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : MIND, 
   [COORD @D90492, AGR [COUNT @D90491, PER @D90490, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MIND, 
   [COORD @D90494, AGR [COUNT @D90493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MIND, 
   [COORD @D90496, AGR [COUNT @D90495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MIND, 
   [COORD @D90500, AGR [COUNT @D90499, PER @D90498, PLU @D90497, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MIND, 
   [COORD @D90506, PAST @D90505, AGR [CASE @D90504, COUNT @D90503, 
            PER @D90502, PLU @D90501, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : MIND, 
   [COORD @D90509, AGR [COUNT @D90508, PER @D90507, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : MIND, 
   [COORD @D90511, AGR [COUNT @D90510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : MIND, 
   [COORD @D90513, AGR [COUNT @D90512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : MIND, 
   [COORD @D90517, AGR [COUNT @D90516, PER @D90515, PLU @D90514, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : MIND, 
   [COORD @D90523, PAST @D90522, AGR [CASE @D90521, COUNT @D90520, 
            PER @D90519, PLU @D90518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : MIND, 
   [COORD @D90526, AGR [COUNT @D90525, PER @D90524, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : MIND, 
   [COORD @D90528, AGR [COUNT @D90527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : MIND, 
   [COORD @D90530, AGR [COUNT @D90529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : MIND, 
   [COORD @D90534, AGR [COUNT @D90533, PER @D90532, PLU @D90531, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : MIND, 
   [COORD @D90540, PAST @D90539, AGR [CASE @D90538, COUNT @D90537, 
            PER @D90536, PLU @D90535, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : MIND, 
   [COORD @D90543, AGR [COUNT @D90542, PER @D90541, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : MIND, 
   [COORD @D90545, AGR [COUNT @D90544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : MIND, 
   [COORD @D90547, AGR [COUNT @D90546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : MIND, 
   [COORD @D90551, AGR [COUNT @D90550, PER @D90549, PLU @D90548, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : MIND, 
   [COORD @D90557, PAST @D90556, AGR [CASE @D90555, COUNT @D90554, 
            PER @D90553, PLU @D90552, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : MIND, 
   [COORD @D90560, AGR [COUNT @D90559, PER @D90558, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MIND, 
   [COORD @D90562, AGR [COUNT @D90561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MIND, 
   [COORD @D90564, AGR [COUNT @D90563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MIND, 
   [COORD @D90568, AGR [COUNT @D90567, PER @D90566, PLU @D90565, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MIND, 
   [COORD @D90574, PAST @D90573, AGR [CASE @D90572, COUNT @D90571, 
            PER @D90570, PLU @D90569, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MIND, 
   [COORD @D90577, AGR [COUNT @D90576, PER @D90575, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIND, 
   [COORD @D90579, AGR [COUNT @D90578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIND, 
   [COORD @D90581, AGR [COUNT @D90580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIND, 
   [COORD @D90585, AGR [COUNT @D90584, PER @D90583, PLU @D90582, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIND, 
   [COORD @D90591, PAST @D90590, AGR [CASE @D90589, COUNT @D90588, 
            PER @D90587, PLU @D90586, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MIND, 
   [COORD @D90594, AGR [COUNT @D90593, PER @D90592, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MIND, 
   [COORD @D90596, AGR [COUNT @D90595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MIND, 
   [COORD @D90598, AGR [COUNT @D90597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MIND, 
   [COORD @D90602, AGR [COUNT @D90601, PER @D90600, PLU @D90599, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MIND, 
   [COORD @D90608, PAST @D90607, 
      AGR [CASE @D90606, COUNT @D90605, PER @D90604, PLU @D90603, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : MIND.

WORD minded : 
   [COORD @D90621, AGR [CASE @D90620, COUNT @D90619, PER @D90618, 
            PLU @D90617, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90626, AGR [CASE @D90625, COUNT @D90624, PER @D90623, 
            PLU @D90622, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIND, 
   [COORD @D90631, AGR [UB @D90630, VFORM @D90629, SUBJ @D90628, 
            FIN @D90627, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MIND, 
   [COORD @D90636, AGR [CASE @D90635, COUNT @D90634, PER @D90633, 
            PLU @D90632, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90641, AGR [CASE @D90640, COUNT @D90639, PER @D90638, 
            PLU @D90637, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIND, 
   [COORD @D90646, AGR [CASE @D90645, COUNT @D90644, PER @D90643, 
            PLU @D90642, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90651, AGR [CASE @D90650, COUNT @D90649, PER @D90648, 
            PLU @D90647, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIND, 
   [COORD @D90656, AGR [CASE @D90655, COUNT @D90654, PER @D90653, 
            PLU @D90652, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MIND, 
   [COORD @D90661, AGR [CASE @D90660, COUNT @D90659, PER @D90658, 
            PLU @D90657, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90666, AGR [CASE @D90665, COUNT @D90664, PER @D90663, 
            PLU @D90662, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIND, 
   [COORD @D90671, AGR [CASE @D90670, COUNT @D90669, PER @D90668, 
            PLU @D90667, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90676, AGR [CASE @D90675, COUNT @D90674, PER @D90673, 
            PLU @D90672, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIND, 
   [COORD @D90682, AGR [CASE @D90681, NFORM @D90680, COUNT @D90679, 
            PER @D90678, PLU @D90677, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MIND, 
   [COORD @D90687, AGR [UB @D90686, VFORM @D90685, SUBJ @D90684, 
            FIN @D90683, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MIND, 
   [COORD @D90692, AGR [CASE @D90691, COUNT @D90690, PER @D90689, 
            PLU @D90688, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90697, AGR [CASE @D90696, COUNT @D90695, PER @D90694, 
            PLU @D90693, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIND, 
   [COORD @D90702, AGR [CASE @D90701, COUNT @D90700, PER @D90699, 
            PLU @D90698, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MIND, 
   [COORD @D90707, AGR [CASE @D90706, COUNT @D90705, PER @D90704, 
            PLU @D90703, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90712, AGR [CASE @D90711, COUNT @D90710, PER @D90709, 
            PLU @D90708, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIND, 
   [COORD @D90717, AGR [CASE @D90716, COUNT @D90715, PER @D90714, 
            PLU @D90713, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90722, AGR [CASE @D90721, COUNT @D90720, PER @D90719, 
            PLU @D90718, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MIND.

WORD minding : 
   [COORD @D90740, PRD @D90739, AGR [CASE @D90738, COUNT @D90737, 
            PER @D90736, PLU @D90735, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90746, PRD @D90745, 
      AGR [CASE @D90744, COUNT @D90743, PER @D90742, PLU @D90741, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MIND, 
   [COORD @D90752, PRD @D90751, AGR [CASE @D90750, COUNT @D90749, 
            PER @D90748, PLU @D90747, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90758, PRD @D90757, 
      AGR [CASE @D90756, COUNT @D90755, PER @D90754, PLU @D90753, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MIND, 
   [COORD @D90764, PRD @D90763, AGR [CASE @D90762, COUNT @D90761, 
            PER @D90760, PLU @D90759, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90770, PRD @D90769, 
      AGR [CASE @D90768, COUNT @D90767, PER @D90766, PLU @D90765, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MIND, 
   [COORD @D90776, PRD @D90775, AGR [CASE @D90774, COUNT @D90773, 
            PER @D90772, PLU @D90771, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIND, 
   [COORD @D90782, PRD @D90781, 
      AGR [CASE @D90780, COUNT @D90779, PER @D90778, PLU @D90777, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MIND.

WORD minds : 
   [COORD @D90795, DEMON @D90794, REFL @D90793, PRD @D90792, CASE 
         @D90791, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MIND, 
   [COORD @D90797, 
      AGR [COUNT @D90796, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND, 
   [COORD @D90799, 
      AGR [COUNT @D90798, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND, 
   [COORD @D90801, 
      AGR [COUNT @D90800, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND, 
   [COORD @D90803, 
      AGR [COUNT @D90802, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND, 
   [COORD @D90805, 
      AGR [COUNT @D90804, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND, 
   [COORD @D90807, 
      AGR [COUNT @D90806, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND, 
   [COORD @D90809, 
      AGR [COUNT @D90808, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND, 
   [COORD @D90811, 
      AGR [COUNT @D90810, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MIND.

WORD mix : 
   [COORD @D90819, AGR [COUNT @D90818, PER @D90817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : MIX, 
   [COORD @D90821, AGR [COUNT @D90820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : MIX, 
   [COORD @D90823, AGR [COUNT @D90822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : MIX, 
   [COORD @D90827, AGR [COUNT @D90826, PER @D90825, PLU @D90824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : MIX, 
   [COORD @D90833, PAST @D90832, AGR [CASE @D90831, COUNT @D90830, 
            PER @D90829, PLU @D90828, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : MIX, 
   [COORD @D90836, AGR [COUNT @D90835, PER @D90834, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MIX, 
   [COORD @D90838, AGR [COUNT @D90837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MIX, 
   [COORD @D90840, AGR [COUNT @D90839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MIX, 
   [COORD @D90844, AGR [COUNT @D90843, PER @D90842, PLU @D90841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : MIX, 
   [COORD @D90850, PAST @D90849, 
      AGR [CASE @D90848, COUNT @D90847, PER @D90846, PLU @D90845, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : MIX, 
   [COORD @D90853, AGR [COUNT @D90852, PER @D90851, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : MIX, 
   [COORD @D90855, AGR [COUNT @D90854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : MIX, 
   [COORD @D90857, AGR [COUNT @D90856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : MIX, 
   [COORD @D90861, AGR [COUNT @D90860, PER @D90859, PLU @D90858, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : MIX, 
   [COORD @D90867, PAST @D90866, 
      AGR [CASE @D90865, COUNT @D90864, PER @D90863, PLU @D90862, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM WITH, ARITY 3] : MIX, 
   [COORD @D90870, AGR [COUNT @D90869, PER @D90868, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MIX, 
   [COORD @D90872, AGR [COUNT @D90871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MIX, 
   [COORD @D90874, AGR [COUNT @D90873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MIX, 
   [COORD @D90878, AGR [COUNT @D90877, PER @D90876, PLU @D90875, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MIX, 
   [COORD @D90884, PAST @D90883, AGR [CASE @D90882, COUNT @D90881, 
            PER @D90880, PLU @D90879, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MIX, 
   [COORD @D90887, AGR [COUNT @D90886, PER @D90885, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : MIX, 
   [COORD @D90889, AGR [COUNT @D90888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : MIX, 
   [COORD @D90891, AGR [COUNT @D90890, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : MIX, 
   [COORD @D90895, AGR [COUNT @D90894, PER @D90893, PLU @D90892, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : MIX, 
   [COORD @D90901, PAST @D90900, 
      AGR [CASE @D90899, COUNT @D90898, PER @D90897, PLU @D90896, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH, 
      ARITY 2] : MIX, 
   [COORD @D90904, AGR [COUNT @D90903, PER @D90902, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MIX, 
   [COORD @D90906, AGR [COUNT @D90905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MIX, 
   [COORD @D90908, AGR [COUNT @D90907, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MIX, 
   [COORD @D90912, AGR [COUNT @D90911, PER @D90910, PLU @D90909, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : MIX, 
   [COORD @D90918, PAST @D90917, 
      AGR [CASE @D90916, COUNT @D90915, PER @D90914, PLU @D90913, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : MIX, 
   [COORD @D90921, AGR [COUNT @D90920, PER @D90919, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : MIX, 
   [COORD @D90923, AGR [COUNT @D90922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : MIX, 
   [COORD @D90925, AGR [COUNT @D90924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : MIX, 
   [COORD @D90929, AGR [COUNT @D90928, PER @D90927, PLU @D90926, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : MIX, 
   [COORD @D90935, PAST @D90934, 
      AGR [CASE @D90933, COUNT @D90932, PER @D90931, PLU @D90930, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : MIX, 
   [COORD @D90938, AGR [COUNT @D90937, PER @D90936, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIX, 
   [COORD @D90940, AGR [COUNT @D90939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIX, 
   [COORD @D90942, AGR [COUNT @D90941, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIX, 
   [COORD @D90946, AGR [COUNT @D90945, PER @D90944, PLU @D90943, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MIX, 
   [COORD @D90952, PAST @D90951, AGR [CASE @D90950, COUNT @D90949, 
            PER @D90948, PLU @D90947, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MIX, 
   [COORD @D90955, AGR [COUNT @D90954, PER @D90953, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MIX, 
   [COORD @D90957, AGR [COUNT @D90956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MIX, 
   [COORD @D90959, AGR [COUNT @D90958, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MIX, 
   [COORD @D90963, AGR [COUNT @D90962, PER @D90961, PLU @D90960, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MIX, 
   [COORD @D90969, PAST @D90968, 
      AGR [CASE @D90967, COUNT @D90966, PER @D90965, PLU @D90964, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : MIX, 
   [COORD @D90972, AGR [COUNT @D90971, PER @D90970, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MIX, 
   [COORD @D90974, AGR [COUNT @D90973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MIX, 
   [COORD @D90976, AGR [COUNT @D90975, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MIX, 
   [COORD @D90980, AGR [COUNT @D90979, PER @D90978, PLU @D90977, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MIX, 
   [COORD @D90986, PAST @D90985, 
      AGR [CASE @D90984, COUNT @D90983, PER @D90982, PLU @D90981, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : MIX.

WORD mixed : 
   [COADV @D91000, COORD @D90999, DEF @D90998, PRD @D90997, AGR 
            [CASE @D90996, COUNT @D90995, PER @D90994, PLU @D90993, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : MIXED, 
   [COORD @D91005, AGR [CASE @D91004, COUNT @D91003, PER @D91002, 
            PLU @D91001, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MIX, 
   [COORD @D91010, AGR [CASE @D91009, COUNT @D91008, PER @D91007, 
            PLU @D91006, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91015, AGR [CASE @D91014, COUNT @D91013, PER @D91012, 
            PLU @D91011, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91020, AGR [CASE @D91019, COUNT @D91018, PER @D91017, 
            PLU @D91016, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91025, AGR [CASE @D91024, COUNT @D91023, PER @D91022, 
            PLU @D91021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91030, AGR [CASE @D91029, COUNT @D91028, PER @D91027, 
            PLU @D91026, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91035, AGR [CASE @D91034, COUNT @D91033, PER @D91032, 
            PLU @D91031, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91040, AGR [CASE @D91039, COUNT @D91038, PER @D91037, 
            PLU @D91036, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91045, 
      AGR [CASE @D91044, COUNT @D91043, PER @D91042, PLU @D91041, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91050, AGR [CASE @D91049, COUNT @D91048, PER @D91047, 
            PLU @D91046, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MIX, 
   [COORD @D91055, AGR [CASE @D91054, COUNT @D91053, PER @D91052, 
            PLU @D91051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91060, AGR [CASE @D91059, COUNT @D91058, PER @D91057, 
            PLU @D91056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91065, AGR [CASE @D91064, COUNT @D91063, PER @D91062, 
            PLU @D91061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91070, AGR [CASE @D91069, COUNT @D91068, PER @D91067, 
            PLU @D91066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91075, AGR [CASE @D91074, COUNT @D91073, PER @D91072, 
            PLU @D91071, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91080, AGR [CASE @D91079, COUNT @D91078, PER @D91077, 
            PLU @D91076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91085, AGR [CASE @D91084, COUNT @D91083, PER @D91082, 
            PLU @D91081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91090, AGR [CASE @D91089, COUNT @D91088, PER @D91087, 
            PLU @D91086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91095, AGR [CASE @D91094, COUNT @D91093, PER @D91092, 
            PLU @D91091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91100, AGR [CASE @D91099, COUNT @D91098, PER @D91097, 
            PLU @D91096, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91105, AGR [CASE @D91104, COUNT @D91103, PER @D91102, 
            PLU @D91101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91110, AGR [CASE @D91109, COUNT @D91108, PER @D91107, 
            PLU @D91106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91115, AGR [CASE @D91114, COUNT @D91113, PER @D91112, 
            PLU @D91111, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91120, AGR [CASE @D91119, COUNT @D91118, PER @D91117, 
            PLU @D91116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MIX, 
   [COORD @D91125, AGR [CASE @D91124, COUNT @D91123, PER @D91122, 
            PLU @D91121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91130, AGR [CASE @D91129, COUNT @D91128, PER @D91127, 
            PLU @D91126, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MIX.

WORD mixing : 
   [COORD @D91144, PRD @D91143, AGR [CASE @D91142, COUNT @D91141, 
            PER @D91140, PLU @D91139, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91150, PRD @D91149, AGR 
         [CASE @D91148, COUNT @D91147, PER @D91146, PLU @D91145, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MIX, 
   [COORD @D91156, PRD @D91155, AGR [CASE @D91154, COUNT @D91153, 
            PER @D91152, PLU @D91151, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91162, PRD @D91161, 
      AGR [CASE @D91160, COUNT @D91159, PER @D91158, PLU @D91157, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   
   [COORD @D91168, PRD @D91167, AGR [CASE @D91166, COUNT @D91165, PER 
               @D91164, PLU @D91163, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91174, PRD @D91173, 
      AGR [CASE @D91172, COUNT @D91171, PER @D91170, PLU @D91169, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MIX, 
   [COORD @D91180, PRD @D91179, AGR [CASE @D91178, COUNT @D91177, 
            PER @D91176, PLU @D91175, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91186, PRD @D91185, 
      AGR [CASE @D91184, COUNT @D91183, PER @D91182, PLU @D91181, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   
   [COORD @D91192, PRD @D91191, AGR [CASE @D91190, COUNT @D91189, PER 
               @D91188, PLU @D91187, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MIX, 
   [COORD @D91198, PRD @D91197, 
      AGR [CASE @D91196, COUNT @D91195, PER @D91194, PLU @D91193, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MIX.

WORD move : 
   [COORD @D91214, REFL @D91213, PRD @D91212, CASE @D91211, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MOVE, 
   [COORD @D91218, REFL @D91217, PRD @D91216, CASE @D91215, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : MOVE, 
   [COORD @D91221, 
      AGR [COUNT @D91220, PER @D91219, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : MOVE, 
   [COORD @D91223, AGR [COUNT @D91222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : MOVE, 
   [COORD @D91225, AGR [COUNT @D91224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : MOVE, 
   [COORD @D91229, AGR [COUNT @D91228, PER @D91227, PLU @D91226, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : MOVE, 
   [COORD @D91235, PAST @D91234, AGR [CASE @D91233, COUNT @D91232, 
            PER @D91231, PLU @D91230, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : MOVE, 
   [COORD @D91238, AGR [COUNT @D91237, PER @D91236, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : MOVE, 
   [COORD @D91240, AGR [COUNT @D91239, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : MOVE, 
   [COORD @D91242, AGR [COUNT @D91241, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : MOVE, 
   [COORD @D91246, AGR [COUNT @D91245, PER @D91244, PLU @D91243, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : MOVE, 
   [COORD @D91252, PAST @D91251, AGR [CASE @D91250, COUNT @D91249, 
            PER @D91248, PLU @D91247, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : MOVE, 
   [COORD @D91255, AGR [COUNT @D91254, PER @D91253, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : MOVE, 
   [COORD @D91257, AGR [COUNT @D91256, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : MOVE, 
   [COORD @D91259, AGR [COUNT @D91258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : MOVE, 
   [COORD @D91263, AGR [COUNT @D91262, PER @D91261, PLU @D91260, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : MOVE, 
   [COORD @D91269, PAST @D91268, 
      AGR [CASE @D91267, COUNT @D91266, PER @D91265, PLU @D91264, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : MOVE, 
   [COORD @D91272, AGR [COUNT @D91271, PER @D91270, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MOVE, 
   [COORD @D91274, AGR [COUNT @D91273, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MOVE, 
   [COORD @D91276, AGR [COUNT @D91275, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MOVE, 
   [COORD @D91280, AGR [COUNT @D91279, PER @D91278, PLU @D91277, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : MOVE, 
   [COORD @D91286, PAST @D91285, AGR [CASE @D91284, COUNT @D91283, 
            PER @D91282, PLU @D91281, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : MOVE, 
   [COORD @D91289, AGR [COUNT @D91288, PER @D91287, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : MOVE, 
   [COORD @D91291, AGR [COUNT @D91290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : MOVE, 
   [COORD @D91293, AGR [COUNT @D91292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : MOVE, 
   [COORD @D91297, AGR [COUNT @D91296, PER @D91295, PLU @D91294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : MOVE, 
   [COORD @D91303, PAST @D91302, AGR [CASE @D91301, COUNT @D91300, 
            PER @D91299, PLU @D91298, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : MOVE, 
   [COORD @D91306, AGR [COUNT @D91305, PER @D91304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MOVE, 
   [COORD @D91308, AGR [COUNT @D91307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MOVE, 
   [COORD @D91310, AGR [COUNT @D91309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : MOVE, 
   [COORD @D91314, AGR [COUNT @D91313, PER @D91312, PLU @D91311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : MOVE, 
   [COORD @D91320, PAST @D91319, AGR [CASE @D91318, COUNT @D91317, 
            PER @D91316, PLU @D91315, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : MOVE, 
   [COORD @D91323, AGR [COUNT @D91322, PER @D91321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : MOVE, 
   [COORD @D91325, AGR [COUNT @D91324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : MOVE, 
   [COORD @D91327, AGR [COUNT @D91326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : MOVE, 
   [COORD @D91331, AGR [COUNT @D91330, PER @D91329, PLU @D91328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : MOVE, 
   [COORD @D91337, PAST @D91336, AGR [CASE @D91335, COUNT @D91334, 
            PER @D91333, PLU @D91332, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : MOVE, 
   [COORD @D91340, AGR [COUNT @D91339, PER @D91338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM TO, ARITY 2] : MOVE, 
   [COORD @D91342, AGR [COUNT @D91341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM TO, ARITY 2] : MOVE, 
   [COORD @D91344, AGR [COUNT @D91343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM TO, ARITY 2] : MOVE, 
   [COORD @D91348, AGR [COUNT @D91347, PER @D91346, PLU @D91345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ON, PFORM TO, ARITY 2] : MOVE, 
   [COORD @D91354, PAST @D91353, 
      AGR [CASE @D91352, COUNT @D91351, PER @D91350, PLU @D91349, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT ON, 
      PFORM TO, ARITY 2] : MOVE, 
   [COORD @D91357, AGR [COUNT @D91356, PER @D91355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91359, AGR [COUNT @D91358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91361, AGR [COUNT @D91360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91365, AGR [COUNT @D91364, PER @D91363, PLU @D91362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91371, PAST @D91370, 
      AGR [CASE @D91369, COUNT @D91368, PER @D91367, PLU @D91366, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      ARITY 2] : MOVE, 
   [COORD @D91374, AGR [COUNT @D91373, PER @D91372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91376, AGR [COUNT @D91375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91378, AGR [COUNT @D91377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91382, AGR [COUNT @D91381, PER @D91380, PLU @D91379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91388, PAST @D91387, 
      AGR [CASE @D91386, COUNT @D91385, PER @D91384, PLU @D91383, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT IN, 
      PFORM ON, ARITY 2] : MOVE, 
   [COORD @D91391, AGR [COUNT @D91390, PER @D91389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : MOVE, 
   [COORD @D91393, AGR [COUNT @D91392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : MOVE, 
   [COORD @D91395, AGR [COUNT @D91394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : MOVE, 
   [COORD @D91399, AGR [COUNT @D91398, PER @D91397, PLU @D91396, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : MOVE, 
   [COORD @D91405, PAST @D91404, 
      AGR [CASE @D91403, COUNT @D91402, PER @D91401, PLU @D91400, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT OUT, 
      PFORM OF, ARITY 2] : MOVE, 
   [COORD @D91408, AGR [COUNT @D91407, PER @D91406, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : MOVE, 
   [COORD @D91410, AGR [COUNT @D91409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : MOVE, 
   [COORD @D91412, AGR [COUNT @D91411, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : MOVE, 
   [COORD @D91416, AGR [COUNT @D91415, PER @D91414, PLU @D91413, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : MOVE, 
   [COORD @D91422, PAST @D91421, 
      AGR [CASE @D91420, COUNT @D91419, PER @D91418, PLU @D91417, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, 
      ARITY 2] : MOVE, 
   [COORD @D91425, AGR [COUNT @D91424, PER @D91423, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : MOVE, 
   [COORD @D91427, AGR [COUNT @D91426, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : MOVE, 
   [COORD @D91429, AGR [COUNT @D91428, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : MOVE, 
   [COORD @D91433, AGR [COUNT @D91432, PER @D91431, PLU @D91430, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : MOVE, 
   [COORD @D91439, PAST @D91438, 
      AGR [CASE @D91437, COUNT @D91436, PER @D91435, PLU @D91434, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      ARITY 2] : MOVE, 
   [COORD @D91442, AGR [COUNT @D91441, PER @D91440, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AMONG, ARITY 2] : MOVE, 
   [COORD @D91444, AGR [COUNT @D91443, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AMONG, ARITY 2] : MOVE, 
   [COORD @D91446, AGR [COUNT @D91445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AMONG, ARITY 2] : MOVE, 
   [COORD @D91450, AGR [COUNT @D91449, PER @D91448, PLU @D91447, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AMONG, ARITY 2] : MOVE, 
   [COORD @D91456, PAST @D91455, 
      AGR [CASE @D91454, COUNT @D91453, PER @D91452, PLU @D91451, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AMONG, 
      ARITY 2] : MOVE, 
   [COORD @D91459, AGR [COUNT @D91458, PER @D91457, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MOVE, 
   [COORD @D91461, AGR [COUNT @D91460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MOVE, 
   [COORD @D91463, AGR [COUNT @D91462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : MOVE, 
   [COORD @D91467, AGR [COUNT @D91466, PER @D91465, PLU @D91464, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : MOVE, 
   [COORD @D91473, PAST @D91472, 
      AGR [CASE @D91471, COUNT @D91470, PER @D91469, PLU @D91468, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : MOVE, 
   [COORD @D91476, AGR [COUNT @D91475, PER @D91474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : MOVE, 
   [COORD @D91478, AGR [COUNT @D91477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : MOVE, 
   [COORD @D91480, AGR [COUNT @D91479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : MOVE, 
   [COORD @D91484, AGR [COUNT @D91483, PER @D91482, PLU @D91481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : MOVE, 
   [COORD @D91490, PAST @D91489, 
      AGR [CASE @D91488, COUNT @D91487, PER @D91486, PLU @D91485, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : MOVE, 
   [COORD @D91493, AGR [COUNT @D91492, PER @D91491, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : MOVE, 
   [COORD @D91495, AGR [COUNT @D91494, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : MOVE, 
   [COORD @D91497, AGR [COUNT @D91496, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : MOVE, 
   [COORD @D91501, AGR [COUNT @D91500, PER @D91499, PLU @D91498, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : MOVE, 
   [COORD @D91507, PAST @D91506, 
      AGR [CASE @D91505, COUNT @D91504, PER @D91503, PLU @D91502, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : MOVE, 
   [COORD @D91510, AGR [COUNT @D91509, PER @D91508, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MOVE, 
   [COORD @D91512, AGR [COUNT @D91511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MOVE, 
   [COORD @D91514, AGR [COUNT @D91513, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MOVE, 
   [COORD @D91518, AGR [COUNT @D91517, PER @D91516, PLU @D91515, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : MOVE, 
   [COORD @D91524, PAST @D91523, 
      AGR [CASE @D91522, COUNT @D91521, PER @D91520, PLU @D91519, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : MOVE, 
   [COORD @D91527, AGR [COUNT @D91526, PER @D91525, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AROUND, ARITY 2] : MOVE, 
   [COORD @D91529, AGR [COUNT @D91528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AROUND, ARITY 2] : MOVE, 
   [COORD @D91531, AGR [COUNT @D91530, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AROUND, ARITY 2] : MOVE, 
   [COORD @D91535, AGR [COUNT @D91534, PER @D91533, PLU @D91532, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AROUND, ARITY 2] : MOVE, 
   [COORD @D91541, PAST @D91540, 
      AGR [CASE @D91539, COUNT @D91538, PER @D91537, PLU @D91536, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AROUND, ARITY 2] : MOVE, 
   [COORD @D91544, AGR [COUNT @D91543, PER @D91542, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : MOVE, 
   [COORD @D91546, AGR [COUNT @D91545, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : MOVE, 
   [COORD @D91548, AGR [COUNT @D91547, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : MOVE, 
   [COORD @D91552, AGR [COUNT @D91551, PER @D91550, PLU @D91549, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ALONG, ARITY 2] : MOVE, 
   [COORD @D91558, PAST @D91557, 
      AGR [CASE @D91556, COUNT @D91555, PER @D91554, PLU @D91553, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : MOVE, 
   [COORD @D91561, AGR [COUNT @D91560, PER @D91559, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : MOVE, 
   [COORD @D91563, AGR [COUNT @D91562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : MOVE, 
   [COORD @D91565, AGR [COUNT @D91564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : MOVE, 
   [COORD @D91569, AGR [COUNT @D91568, PER @D91567, PLU @D91566, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ABOUT, ARITY 2] : MOVE, 
   [COORD @D91575, PAST @D91574, 
      AGR [CASE @D91573, COUNT @D91572, PER @D91571, PLU @D91570, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : MOVE, 
   [COORD @D91578, AGR [COUNT @D91577, PER @D91576, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MOVE, 
   [COORD @D91580, AGR [COUNT @D91579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MOVE, 
   [COORD @D91582, AGR [COUNT @D91581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MOVE, 
   [COORD @D91586, AGR [COUNT @D91585, PER @D91584, PLU @D91583, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : MOVE, 
   [COORD @D91592, PAST @D91591, AGR [CASE @D91590, COUNT @D91589, 
            PER @D91588, PLU @D91587, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : MOVE, 
   [COORD @D91595, AGR [COUNT @D91594, PER @D91593, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MOVE, 
   [COORD @D91597, AGR [COUNT @D91596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MOVE, 
   [COORD @D91599, AGR [COUNT @D91598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MOVE, 
   [COORD @D91603, AGR [COUNT @D91602, PER @D91601, PLU @D91600, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : MOVE, 
   [COORD @D91609, PAST @D91608, 
      AGR [CASE @D91607, COUNT @D91606, PER @D91605, PLU @D91604, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : MOVE, 
   [COORD @D91612, AGR [COUNT @D91611, PER @D91610, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : MOVE, 
   [COORD @D91614, AGR [COUNT @D91613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : MOVE, 
   [COORD @D91616, AGR [COUNT @D91615, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : MOVE, 
   [COORD @D91620, AGR [COUNT @D91619, PER @D91618, PLU @D91617, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : MOVE, 
   [COORD @D91626, PAST @D91625, 
      AGR [CASE @D91624, COUNT @D91623, PER @D91622, PLU @D91621, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : MOVE, 
   [COORD @D91629, AGR [COUNT @D91628, PER @D91627, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MOVE, 
   [COORD @D91631, AGR [COUNT @D91630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MOVE, 
   [COORD @D91633, AGR [COUNT @D91632, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MOVE, 
   [COORD @D91637, AGR [COUNT @D91636, PER @D91635, PLU @D91634, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : MOVE, 
   [COORD @D91643, PAST @D91642, 
      AGR [CASE @D91641, COUNT @D91640, PER @D91639, PLU @D91638, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : MOVE, 
   [COORD @D91646, AGR [COUNT @D91645, PER @D91644, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : MOVE, 
   [COORD @D91648, AGR [COUNT @D91647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : MOVE, 
   [COORD @D91650, AGR [COUNT @D91649, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : MOVE, 
   [COORD @D91654, AGR [COUNT @D91653, PER @D91652, PLU @D91651, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : MOVE, 
   [COORD @D91660, PAST @D91659, 
      AGR [CASE @D91658, COUNT @D91657, PER @D91656, PLU @D91655, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : MOVE, 
   [COORD @D91663, AGR [COUNT @D91662, PER @D91661, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MOVE, 
   [COORD @D91665, AGR [COUNT @D91664, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MOVE, 
   [COORD @D91667, AGR [COUNT @D91666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MOVE, 
   [COORD @D91671, AGR [COUNT @D91670, PER @D91669, PLU @D91668, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : MOVE, 
   [COORD @D91677, PAST @D91676, 
      AGR [CASE @D91675, COUNT @D91674, PER @D91673, PLU @D91672, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : MOVE, 
   [COORD @D91680, AGR [COUNT @D91679, PER @D91678, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MOVE, 
   [COORD @D91682, AGR [COUNT @D91681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MOVE, 
   [COORD @D91684, AGR [COUNT @D91683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MOVE, 
   [COORD @D91688, AGR [COUNT @D91687, PER @D91686, PLU @D91685, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : MOVE, 
   [COORD @D91694, PAST @D91693, 
      AGR [CASE @D91692, COUNT @D91691, PER @D91690, PLU @D91689, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : MOVE, 
   [COORD @D91697, AGR [COUNT @D91696, PER @D91695, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MOVE, 
   [COORD @D91699, AGR [COUNT @D91698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MOVE, 
   [COORD @D91701, AGR [COUNT @D91700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MOVE, 
   [COORD @D91705, AGR [COUNT @D91704, PER @D91703, PLU @D91702, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : MOVE, 
   [COORD @D91711, PAST @D91710, 
      AGR [CASE @D91709, COUNT @D91708, PER @D91707, PLU @D91706, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : MOVE, 
   [COORD @D91714, AGR [COUNT @D91713, PER @D91712, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : MOVE, 
   [COORD @D91716, AGR [COUNT @D91715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : MOVE, 
   [COORD @D91718, AGR [COUNT @D91717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : MOVE, 
   [COORD @D91722, AGR [COUNT @D91721, PER @D91720, PLU @D91719, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : MOVE, 
   [COORD @D91728, PAST @D91727, 
      AGR [CASE @D91726, COUNT @D91725, PER @D91724, PLU @D91723, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : MOVE, 
   [COORD @D91731, AGR [COUNT @D91730, PER @D91729, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : MOVE, 
   [COORD @D91733, AGR [COUNT @D91732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : MOVE, 
   [COORD @D91735, AGR [COUNT @D91734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : MOVE, 
   [COORD @D91739, AGR [COUNT @D91738, PER @D91737, PLU @D91736, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : MOVE, 
   [COORD @D91745, PAST @D91744, 
      AGR [CASE @D91743, COUNT @D91742, PER @D91741, PLU @D91740, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AROUND, 
      ARITY 1] : MOVE, 
   [COORD @D91748, AGR [COUNT @D91747, PER @D91746, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : MOVE, 
   [COORD @D91750, AGR [COUNT @D91749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : MOVE, 
   [COORD @D91752, AGR [COUNT @D91751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : MOVE, 
   [COORD @D91756, AGR [COUNT @D91755, PER @D91754, PLU @D91753, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : MOVE, 
   [COORD @D91762, PAST @D91761, 
      AGR [CASE @D91760, COUNT @D91759, PER @D91758, PLU @D91757, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ALONG, 
      ARITY 1] : MOVE, 
   [COORD @D91765, AGR [COUNT @D91764, PER @D91763, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : MOVE, 
   [COORD @D91767, AGR [COUNT @D91766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : MOVE, 
   [COORD @D91769, AGR [COUNT @D91768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : MOVE, 
   [COORD @D91773, AGR [COUNT @D91772, PER @D91771, PLU @D91770, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : MOVE, 
   [COORD @D91779, PAST @D91778, 
      AGR [CASE @D91777, COUNT @D91776, PER @D91775, PLU @D91774, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ABOUT, 
      ARITY 1] : MOVE.

WORD moved : 
   [COORD @D91792, AGR [CASE @D91791, COUNT @D91790, PER @D91789, 
            PLU @D91788, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91797, AGR [CASE @D91796, COUNT @D91795, PER @D91794, 
            PLU @D91793, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91803, AGR [CASE @D91802, NFORM @D91801, COUNT @D91800, 
            PER @D91799, PLU @D91798, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MOVE, 
   [COORD @D91808, AGR [CASE @D91807, COUNT @D91806, PER @D91805, 
            PLU @D91804, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MOVE, 
   [COORD @D91813, AGR [CASE @D91812, COUNT @D91811, PER @D91810, 
            PLU @D91809, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91818, AGR [CASE @D91817, COUNT @D91816, PER @D91815, 
            PLU @D91814, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91823, AGR [CASE @D91822, COUNT @D91821, PER @D91820, 
            PLU @D91819, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91828, AGR [CASE @D91827, COUNT @D91826, PER @D91825, 
            PLU @D91824, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91833, AGR [CASE @D91832, COUNT @D91831, PER @D91830, 
            PLU @D91829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91838, AGR [CASE @D91837, COUNT @D91836, PER @D91835, 
            PLU @D91834, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91843, AGR [CASE @D91842, COUNT @D91841, PER @D91840, 
            PLU @D91839, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91848, AGR [UB @D91847, VFORM @D91846, SUBJ @D91845, 
            FIN @D91844, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MOVE, 
   [COORD @D91853, AGR [CASE @D91852, COUNT @D91851, PER @D91850, 
            PLU @D91849, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91858, AGR [CASE @D91857, COUNT @D91856, PER @D91855, 
            PLU @D91854, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91863, AGR [CASE @D91862, COUNT @D91861, PER @D91860, 
            PLU @D91859, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : MOVE, 
   [COORD @D91868, AGR [CASE @D91867, COUNT @D91866, PER @D91865, 
            PLU @D91864, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91873, AGR [CASE @D91872, COUNT @D91871, PER @D91870, 
            PLU @D91869, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91878, AGR [CASE @D91877, COUNT @D91876, PER @D91875, 
            PLU @D91874, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91883, AGR [CASE @D91882, COUNT @D91881, PER @D91880, 
            PLU @D91879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91888, AGR [CASE @D91887, COUNT @D91886, PER @D91885, 
            PLU @D91884, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91893, AGR [CASE @D91892, COUNT @D91891, PER @D91890, 
            PLU @D91889, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91898, AGR [CASE @D91897, COUNT @D91896, PER @D91895, 
            PLU @D91894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91903, AGR [CASE @D91902, COUNT @D91901, PER @D91900, 
            PLU @D91899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91908, AGR [CASE @D91907, COUNT @D91906, PER @D91905, 
            PLU @D91904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91913, AGR [CASE @D91912, COUNT @D91911, PER @D91910, 
            PLU @D91909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91918, AGR [CASE @D91917, COUNT @D91916, PER @D91915, 
            PLU @D91914, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91923, AGR [CASE @D91922, COUNT @D91921, PER @D91920, 
            PLU @D91919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91928, AGR [CASE @D91927, COUNT @D91926, PER @D91925, 
            PLU @D91924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91933, AGR [CASE @D91932, COUNT @D91931, PER @D91930, 
            PLU @D91929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91938, AGR [CASE @D91937, COUNT @D91936, PER @D91935, 
            PLU @D91934, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91943, AGR [CASE @D91942, COUNT @D91941, PER @D91940, 
            PLU @D91939, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91948, AGR [CASE @D91947, COUNT @D91946, PER @D91945, 
            PLU @D91944, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91953, AGR [CASE @D91952, COUNT @D91951, PER @D91950, 
            PLU @D91949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AMONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91958, AGR [CASE @D91957, COUNT @D91956, PER @D91955, 
            PLU @D91954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AMONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91963, AGR [CASE @D91962, COUNT @D91961, PER @D91960, 
            PLU @D91959, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91968, AGR [CASE @D91967, COUNT @D91966, PER @D91965, 
            PLU @D91964, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91973, AGR [CASE @D91972, COUNT @D91971, PER @D91970, 
            PLU @D91969, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91978, AGR [CASE @D91977, COUNT @D91976, PER @D91975, 
            PLU @D91974, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91983, AGR [CASE @D91982, COUNT @D91981, PER @D91980, 
            PLU @D91979, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91988, AGR [CASE @D91987, COUNT @D91986, PER @D91985, 
            PLU @D91984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91993, AGR [CASE @D91992, COUNT @D91991, PER @D91990, 
            PLU @D91989, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D91998, AGR [CASE @D91997, COUNT @D91996, PER @D91995, 
            PLU @D91994, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92003, AGR [CASE @D92002, COUNT @D92001, PER @D92000, 
            PLU @D91999, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92008, AGR [CASE @D92007, COUNT @D92006, PER @D92005, 
            PLU @D92004, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92013, AGR [CASE @D92012, COUNT @D92011, PER @D92010, 
            PLU @D92009, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92018, AGR [CASE @D92017, COUNT @D92016, PER @D92015, 
            PLU @D92014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92023, AGR [CASE @D92022, COUNT @D92021, PER @D92020, 
            PLU @D92019, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92028, AGR [CASE @D92027, COUNT @D92026, PER @D92025, 
            PLU @D92024, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92033, AGR [CASE @D92032, COUNT @D92031, PER @D92030, 
            PLU @D92029, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92038, AGR [CASE @D92037, COUNT @D92036, PER @D92035, 
            PLU @D92034, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92043, AGR [CASE @D92042, COUNT @D92041, PER @D92040, 
            PLU @D92039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92048, AGR [CASE @D92047, COUNT @D92046, PER @D92045, 
            PLU @D92044, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92053, AGR [CASE @D92052, COUNT @D92051, PER @D92050, 
            PLU @D92049, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92058, AGR [CASE @D92057, COUNT @D92056, PER @D92055, 
            PLU @D92054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92063, AGR [CASE @D92062, COUNT @D92061, PER @D92060, 
            PLU @D92059, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92068, AGR [CASE @D92067, COUNT @D92066, PER @D92065, 
            PLU @D92064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92073, AGR [CASE @D92072, COUNT @D92071, PER @D92070, 
            PLU @D92069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92078, AGR [CASE @D92077, COUNT @D92076, PER @D92075, 
            PLU @D92074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92083, AGR [CASE @D92082, COUNT @D92081, PER @D92080, 
            PLU @D92079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92088, AGR [CASE @D92087, COUNT @D92086, PER @D92085, 
            PLU @D92084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92093, AGR [CASE @D92092, COUNT @D92091, PER @D92090, 
            PLU @D92089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92098, AGR [CASE @D92097, COUNT @D92096, PER @D92095, 
            PLU @D92094, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92103, AGR [CASE @D92102, COUNT @D92101, PER @D92100, 
            PLU @D92099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92108, AGR [CASE @D92107, COUNT @D92106, PER @D92105, 
            PLU @D92104, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92113, AGR [CASE @D92112, COUNT @D92111, PER @D92110, 
            PLU @D92109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92118, AGR [CASE @D92117, COUNT @D92116, PER @D92115, 
            PLU @D92114, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92123, AGR [CASE @D92122, COUNT @D92121, PER @D92120, 
            PLU @D92119, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92128, AGR [CASE @D92127, COUNT @D92126, PER @D92125, 
            PLU @D92124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92133, AGR [CASE @D92132, COUNT @D92131, PER @D92130, 
            PLU @D92129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92138, AGR [CASE @D92137, COUNT @D92136, PER @D92135, 
            PLU @D92134, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92143, AGR [CASE @D92142, COUNT @D92141, PER @D92140, 
            PLU @D92139, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92148, AGR [CASE @D92147, COUNT @D92146, PER @D92145, 
            PLU @D92144, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92153, AGR [CASE @D92152, COUNT @D92151, PER @D92150, 
            PLU @D92149, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92158, AGR [CASE @D92157, COUNT @D92156, PER @D92155, 
            PLU @D92154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92163, AGR [CASE @D92162, COUNT @D92161, PER @D92160, 
            PLU @D92159, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92168, AGR [CASE @D92167, COUNT @D92166, PER @D92165, 
            PLU @D92164, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92173, AGR [CASE @D92172, COUNT @D92171, PER @D92170, 
            PLU @D92169, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92178, AGR [CASE @D92177, COUNT @D92176, PER @D92175, 
            PLU @D92174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92183, AGR [CASE @D92182, COUNT @D92181, PER @D92180, 
            PLU @D92179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : MOVE.

WORD moves : 
   [COORD @D92196, DEMON @D92195, REFL @D92194, PRD @D92193, CASE 
         @D92192, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : MOVE, 
   [COORD @D92198, 
      AGR [COUNT @D92197, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92200, 
      AGR [COUNT @D92199, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92202, 
      AGR [COUNT @D92201, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92204, 
      AGR [COUNT @D92203, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92206, 
      AGR [COUNT @D92205, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92208, 
      AGR [COUNT @D92207, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92210, 
      AGR [COUNT @D92209, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92212, 
      AGR [COUNT @D92211, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ON, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MOVE, 
   [COORD @D92214, AGR [COUNT @D92213, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92216, 
      AGR [COUNT @D92215, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MOVE, 
   [COORD @D92218, AGR [COUNT @D92217, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   MOVE, 
   [COORD @D92220, AGR [COUNT @D92219, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92222, 
      AGR [COUNT @D92221, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92224, 
      AGR [COUNT @D92223, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AMONG, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92226, 
      AGR [COUNT @D92225, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92228, 
      AGR [COUNT @D92227, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92230, 
      AGR [COUNT @D92229, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92232, 
      AGR [COUNT @D92231, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92234, 
      AGR [COUNT @D92233, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92236, 
      AGR [COUNT @D92235, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92238, 
      AGR [COUNT @D92237, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92240, 
      AGR [COUNT @D92239, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92242, 
      AGR [COUNT @D92241, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92244, 
      AGR [COUNT @D92243, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92246, 
      AGR [COUNT @D92245, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92248, 
      AGR [COUNT @D92247, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92250, 
      AGR [COUNT @D92249, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92252, 
      AGR [COUNT @D92251, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92254, 
      AGR [COUNT @D92253, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92256, 
      AGR [COUNT @D92255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92258, 
      AGR [COUNT @D92257, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92260, 
      AGR [COUNT @D92259, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE, 
   [COORD @D92262, 
      AGR [COUNT @D92261, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : MOVE.

WORD moving : 
   [COORD @D92274, PRD @D92273, AGR [CASE @D92272, COUNT @D92271, 
            PER @D92270, PLU @D92269, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92280, PRD @D92279, 
      AGR [CASE @D92278, COUNT @D92277, PER @D92276, PLU @D92275, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MOVE, 
   [COORD @D92286, PRD @D92285, AGR [CASE @D92284, COUNT @D92283, 
            PER @D92282, PLU @D92281, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92292, PRD @D92291, 
      AGR [CASE @D92290, COUNT @D92289, PER @D92288, PLU @D92287, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MOVE, 
   [COORD @D92298, PRD @D92297, AGR [CASE @D92296, COUNT @D92295, 
            PER @D92294, PLU @D92293, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92304, PRD @D92303, 
      AGR [CASE @D92302, COUNT @D92301, PER @D92300, PLU @D92299, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MOVE, 
   [COORD @D92310, PRD @D92309, AGR [CASE @D92308, COUNT @D92307, 
            PER @D92306, PLU @D92305, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92316, PRD @D92315, 
      AGR [CASE @D92314, COUNT @D92313, PER @D92312, PLU @D92311, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ON, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MOVE, 
   [COORD @D92322, PRD @D92321, AGR [CASE @D92320, COUNT @D92319, 
            PER @D92318, PLU @D92317, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92328, PRD @D92327, 
      AGR [CASE @D92326, COUNT @D92325, PER @D92324, PLU @D92323, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : MOVE, 
   [COORD @D92334, PRD @D92333, AGR [CASE @D92332, COUNT @D92331, 
            PER @D92330, PLU @D92329, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92340, PRD @D92339, 
      AGR [CASE @D92338, COUNT @D92337, PER @D92336, PLU @D92335, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92346, PRD @D92345, AGR [CASE @D92344, COUNT @D92343, 
            PER @D92342, PLU @D92341, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92352, PRD @D92351, 
      AGR [CASE @D92350, COUNT @D92349, PER @D92348, PLU @D92347, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AMONG, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92358, PRD @D92357, AGR [CASE @D92356, COUNT @D92355, 
            PER @D92354, PLU @D92353, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92364, PRD @D92363, 
      AGR [CASE @D92362, COUNT @D92361, PER @D92360, PLU @D92359, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92370, PRD @D92369, AGR [CASE @D92368, COUNT @D92367, 
            PER @D92366, PLU @D92365, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92376, PRD @D92375, 
      AGR [CASE @D92374, COUNT @D92373, PER @D92372, PLU @D92371, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92382, PRD @D92381, AGR [CASE @D92380, COUNT @D92379, 
            PER @D92378, PLU @D92377, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92388, PRD @D92387, 
      AGR [CASE @D92386, COUNT @D92385, PER @D92384, PLU @D92383, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92394, PRD @D92393, AGR [CASE @D92392, COUNT @D92391, 
            PER @D92390, PLU @D92389, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92400, PRD @D92399, 
      AGR [CASE @D92398, COUNT @D92397, PER @D92396, PLU @D92395, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   MOVE, 
   [COORD @D92406, PRD @D92405, AGR [CASE @D92404, COUNT @D92403, 
            PER @D92402, PLU @D92401, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92412, PRD @D92411, 
      AGR [CASE @D92410, COUNT @D92409, PER @D92408, PLU @D92407, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92418, PRD @D92417, AGR [CASE @D92416, COUNT @D92415, 
            PER @D92414, PLU @D92413, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92424, PRD @D92423, 
      AGR [CASE @D92422, COUNT @D92421, PER @D92420, PLU @D92419, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92430, PRD @D92429, AGR [CASE @D92428, COUNT @D92427, 
            PER @D92426, PLU @D92425, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92436, PRD @D92435, 
      AGR [CASE @D92434, COUNT @D92433, PER @D92432, PLU @D92431, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92442, PRD @D92441, AGR [CASE @D92440, COUNT @D92439, 
            PER @D92438, PLU @D92437, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92448, PRD @D92447, 
      AGR [CASE @D92446, COUNT @D92445, PER @D92444, PLU @D92443, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92454, PRD @D92453, AGR [CASE @D92452, COUNT @D92451, 
            PER @D92450, PLU @D92449, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE, 
   [COORD @D92460, PRD @D92459, 
      AGR [CASE @D92458, COUNT @D92457, PER @D92456, PLU @D92455, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : MOVE, 
   [COORD @D92466, PRD @D92465, AGR [CASE @D92464, COUNT @D92463, 
            PER @D92462, PLU @D92461, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : MOVE.

WORD name : 
   [COORD @D92474, REFL @D92473, PRD @D92472, CASE @D92471, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : NAME, 
   [COORD @D92478, REFL @D92477, PRD @D92476, CASE @D92475, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : NAME, 
   [COORD @D92483, REFL @D92482, COUNT @D92481, PRD @D92480, 
      CASE @D92479, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : NAME, 
   [COORD @D92487, REFL @D92486, PRD @D92485, CASE @D92484, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : NAME, 
   [COORD @D92490, 
      AGR [COUNT @D92489, PER @D92488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      ARITY 3] : NAME, 
   [COORD @D92492, AGR [COUNT @D92491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : NAME, 
   [COORD @D92494, AGR [COUNT @D92493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : NAME, 
   [COORD @D92498, AGR [COUNT @D92497, PER @D92496, PLU @D92495, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : NAME, 
   [COORD @D92504, PAST @D92503, AGR [CASE @D92502, COUNT @D92501, 
            PER @D92500, PLU @D92499, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_NP, ARITY 3] : NAME, 
   [COORD @D92507, AGR [COUNT @D92506, PER @D92505, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : NAME, 
   [COORD @D92509, AGR [COUNT @D92508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : NAME, 
   [COORD @D92511, AGR [COUNT @D92510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : NAME, 
   [COORD @D92515, AGR [COUNT @D92514, PER @D92513, PLU @D92512, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : NAME, 
   [COORD @D92521, PAST @D92520, AGR [CASE @D92519, COUNT @D92518, 
            PER @D92517, PLU @D92516, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : NAME, 
   [COORD @D92524, AGR [COUNT @D92523, PER @D92522, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : NAME, 
   [COORD @D92526, AGR [COUNT @D92525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : NAME, 
   [COORD @D92528, AGR [COUNT @D92527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : NAME, 
   [COORD @D92532, AGR [COUNT @D92531, PER @D92530, PLU @D92529, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : NAME, 
   [COORD @D92538, PAST @D92537, 
      AGR [CASE @D92536, COUNT @D92535, PER @D92534, PLU @D92533, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : NAME, 
   [COORD @D92541, AGR [COUNT @D92540, PER @D92539, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : NAME, 
   [COORD @D92543, AGR [COUNT @D92542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : NAME, 
   [COORD @D92545, AGR [COUNT @D92544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : NAME, 
   [COORD @D92549, AGR [COUNT @D92548, PER @D92547, PLU @D92546, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : NAME, 
   [COORD @D92555, PAST @D92554, 
      AGR [CASE @D92553, COUNT @D92552, PER @D92551, PLU @D92550, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : NAME, 
   [COORD @D92558, AGR [COUNT @D92557, PER @D92556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AFTER, ARITY 3] : NAME, 
   [COORD @D92560, AGR [COUNT @D92559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AFTER, ARITY 3] : NAME, 
   [COORD @D92562, AGR [COUNT @D92561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AFTER, ARITY 3] : NAME, 
   [COORD @D92566, AGR [COUNT @D92565, PER @D92564, PLU @D92563, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AFTER, ARITY 3] : NAME, 
   [COORD @D92572, PAST @D92571, 
      AGR [CASE @D92570, COUNT @D92569, PER @D92568, PLU @D92567, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AFTER, 
      ARITY 3] : NAME, 
   [COORD @D92575, AGR [COUNT @D92574, PER @D92573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NAME, 
   [COORD @D92577, AGR [COUNT @D92576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NAME, 
   [COORD @D92579, AGR [COUNT @D92578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NAME, 
   [COORD @D92583, AGR [COUNT @D92582, PER @D92581, PLU @D92580, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : NAME, 
   [COORD @D92589, PAST @D92588, AGR [CASE @D92587, COUNT @D92586, 
            PER @D92585, PLU @D92584, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : NAME.

WORD named : 
   [COORD @D92600, AGR [CASE @D92599, COUNT @D92598, PER @D92597, 
            PLU @D92596, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NAME, 
   [COORD @D92605, AGR [CASE @D92604, COUNT @D92603, PER @D92602, 
            PLU @D92601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92610, AGR [CASE @D92609, COUNT @D92608, PER @D92607, 
            PLU @D92606, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NAME, 
   [COORD @D92615, AGR [CASE @D92614, COUNT @D92613, PER @D92612, 
            PLU @D92611, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92620, AGR [CASE @D92619, COUNT @D92618, PER @D92617, 
            PLU @D92616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NAME, 
   [COORD @D92626, AGR [CASE @D92625, NFORM @D92624, COUNT @D92623, 
            PER @D92622, PLU @D92621, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NAME, 
   [COORD @D92631, AGR [CASE @D92630, COUNT @D92629, PER @D92628, 
            PLU @D92627, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92636, AGR [CASE @D92635, COUNT @D92634, PER @D92633, 
            PLU @D92632, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92641, AGR [CASE @D92640, COUNT @D92639, PER @D92638, 
            PLU @D92637, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : NAME, 
   [COORD @D92646, AGR [CASE @D92645, COUNT @D92644, PER @D92643, 
            PLU @D92642, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92651, AGR [CASE @D92650, COUNT @D92649, PER @D92648, 
            PLU @D92647, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92656, AGR [CASE @D92655, COUNT @D92654, PER @D92653, 
            PLU @D92652, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : NAME, 
   [COORD @D92661, AGR [CASE @D92660, COUNT @D92659, PER @D92658, 
            PLU @D92657, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AFTER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92666, AGR [CASE @D92665, COUNT @D92664, PER @D92663, 
            PLU @D92662, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AFTER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92671, AGR [CASE @D92670, COUNT @D92669, PER @D92668, 
            PLU @D92667, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AFTER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : NAME, 
   [COORD @D92676, AGR [CASE @D92675, COUNT @D92674, PER @D92673, 
            PLU @D92672, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NAME, 
   [COORD @D92681, AGR [CASE @D92680, COUNT @D92679, PER @D92678, 
            PLU @D92677, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92686, AGR [CASE @D92685, COUNT @D92684, PER @D92683, 
            PLU @D92682, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NAME.

WORD names : 
   [COORD @D92697, DEMON @D92696, REFL @D92695, PRD @D92694, CASE 
         @D92693, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : NAME, 
   [COORD @D92702, DEMON @D92701, REFL @D92700, PRD @D92699, 
      CASE @D92698, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : NAME, 
   [COORD @D92707, DEMON @D92706, REFL @D92705, PRD @D92704, 
      CASE @D92703, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   NAME, 
   [COORD @D92709, AGR [COUNT @D92708, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NAME, 
   [COORD @D92711, 
      AGR [COUNT @D92710, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NAME, 
   [COORD @D92713, 
      AGR [COUNT @D92712, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NAME, 
   [COORD @D92715, 
      AGR [COUNT @D92714, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NAME, 
   [COORD @D92717, 
      AGR [COUNT @D92716, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   NAME, 
   [COORD @D92719, AGR [COUNT @D92718, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NAME.

WORD naming : 
   [COORD @D92729, PRD @D92728, AGR [CASE @D92727, COUNT @D92726, 
            PER @D92725, PLU @D92724, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92735, PRD @D92734, 
      AGR [CASE @D92733, COUNT @D92732, PER @D92731, PLU @D92730, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NAME, 
   [COORD @D92741, PRD @D92740, AGR [CASE @D92739, COUNT @D92738, 
            PER @D92737, PLU @D92736, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92747, PRD @D92746, 
      AGR [CASE @D92745, COUNT @D92744, PER @D92743, PLU @D92742, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : NAME, 
   [COORD @D92753, PRD @D92752, AGR [CASE @D92751, COUNT @D92750, 
            PER @D92749, PLU @D92748, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM AFTER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : NAME, 
   [COORD @D92759, PRD @D92758, 
      AGR [CASE @D92757, COUNT @D92756, PER @D92755, PLU @D92754, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : NAME.

WORD need : 
   [COORD @D92763, AGR @D92762, FIX NOT, V +, N -, VFORM NOT, PRO -, AUX +, 
      NEG -, CONEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DEO, INV +, PAST -, SUBCAT MODAL_BSE] : 
   NEED, 
   [COORD @D92768, REFL @D92767, COUNT @D92766, PRD @D92765, CASE 
         @D92764, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : NEED, 
   [COORD @D92772, REFL @D92771, PRD @D92770, CASE @D92769, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : NEED, 
   [COORD @D92776, REFL @D92775, PRD @D92774, CASE @D92773, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : NEED, 
   [COORD @D92780, REFL @D92779, PRD @D92778, CASE @D92777, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : NEED, 
   [COORD @D92784, REFL @D92783, PRD @D92782, CASE @D92781, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : NEED, 
   [COORD @D92789, REFL @D92788, COUNT @D92787, PRD @D92786, 
      CASE @D92785, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : NEED, 
   [COORD @D92793, REFL @D92792, PRD @D92791, CASE @D92790, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : NEED, 
   [COORD @D92797, REFL @D92796, PRD @D92795, CASE @D92794, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : NEED, 
   [COORD @D92800, 
      AGR [COUNT @D92799, PER @D92798, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SINF, ARITY 2] : 
   NEED, 
   [COORD @D92802, AGR [COUNT @D92801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : NEED, 
   [COORD @D92804, AGR [COUNT @D92803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : NEED, 
   [COORD @D92808, AGR [COUNT @D92807, PER @D92806, PLU @D92805, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : NEED, 
   [COORD @D92814, PAST @D92813, AGR [CASE @D92812, COUNT @D92811, 
            PER @D92810, PLU @D92809, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SINF, ARITY 2] : NEED, 
   [COORD @D92817, AGR [COUNT @D92816, PER @D92815, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : NEED, 
   [COORD @D92819, AGR [COUNT @D92818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : NEED, 
   [COORD @D92821, AGR [COUNT @D92820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : NEED, 
   [COORD @D92825, AGR [COUNT @D92824, PER @D92823, PLU @D92822, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : NEED, 
   [COORD @D92831, PAST @D92830, AGR [CASE @D92829, COUNT @D92828, 
            PER @D92827, PLU @D92826, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : NEED, 
   [COORD @D92834, AGR [COUNT @D92833, PER @D92832, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : NEED, 
   [COORD @D92836, AGR [COUNT @D92835, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : NEED, 
   [COORD @D92838, AGR [COUNT @D92837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : NEED, 
   [COORD @D92842, AGR [COUNT @D92841, PER @D92840, PLU @D92839, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : NEED, 
   [COORD @D92848, PAST @D92847, AGR [CASE @D92846, COUNT @D92845, 
            PER @D92844, PLU @D92843, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_PASS, ARITY 2] : NEED, 
   [COORD @D92851, AGR [COUNT @D92850, PER @D92849, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NEED, 
   [COORD @D92853, AGR [COUNT @D92852, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NEED, 
   [COORD @D92855, AGR [COUNT @D92854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NEED, 
   [COORD @D92859, AGR [COUNT @D92858, PER @D92857, PLU @D92856, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NEED, 
   [COORD @D92865, PAST @D92864, AGR [CASE @D92863, COUNT @D92862, 
            PER @D92861, PLU @D92860, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : NEED, 
   [COORD @D92868, AGR [COUNT @D92867, PER @D92866, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : NEED, 
   [COORD @D92870, AGR [COUNT @D92869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : NEED, 
   [COORD @D92872, AGR [COUNT @D92871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : NEED, 
   [COORD @D92876, AGR [COUNT @D92875, PER @D92874, PLU @D92873, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : NEED, 
   [COORD @D92882, PAST @D92881, AGR [CASE @D92880, COUNT @D92879, 
            PER @D92878, PLU @D92877, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : NEED, 
   [COORD @D92885, AGR [COUNT @D92884, PER @D92883, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NEED, 
   [COORD @D92887, AGR [COUNT @D92886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NEED, 
   [COORD @D92889, AGR [COUNT @D92888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NEED, 
   [COORD @D92893, AGR [COUNT @D92892, PER @D92891, PLU @D92890, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : NEED, 
   [COORD @D92899, PAST @D92898, AGR [CASE @D92897, COUNT @D92896, 
            PER @D92895, PLU @D92894, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : NEED, 
   [COORD @D92901, AGR [COUNT @D92900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : NEED, 
   [COORD @D92903, AGR [COUNT @D92902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : NEED, 
   [COORD @D92907, AGR [NFORM @D92906, COUNT @D92905, PER @D92904, N +, 
            V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : NEED, 
   [COORD @D92911, AGR [COUNT @D92910, PER @D92909, PLU @D92908, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : NEED, 
   [COORD @D92914, AGR @D92913, PAST @D92912, FIX NOT, V +, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, ARITY 1] : NEED.

WORD needed : 
   [COORD @D92924, AGR [CASE @D92923, COUNT @D92922, PER @D92921, 
            PLU @D92920, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D92929, AGR [CASE @D92928, COUNT @D92927, PER @D92926, 
            PLU @D92925, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NEED, 
   [COORD @D92934, AGR [CASE @D92933, COUNT @D92932, PER @D92931, 
            PLU @D92930, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D92939, AGR [CASE @D92938, COUNT @D92937, PER @D92936, 
            PLU @D92935, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NEED, 
   [COORD @D92944, AGR [CASE @D92943, COUNT @D92942, PER @D92941, 
            PLU @D92940, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_PASS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D92949, AGR [CASE @D92948, COUNT @D92947, PER @D92946, 
            PLU @D92945, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_PASS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NEED, 
   [COORD @D92954, AGR [CASE @D92953, COUNT @D92952, PER @D92951, 
            PLU @D92950, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NEED, 
   [COORD @D92959, AGR [CASE @D92958, COUNT @D92957, PER @D92956, 
            PLU @D92955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D92964, AGR [CASE @D92963, COUNT @D92962, PER @D92961, 
            PLU @D92960, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NEED, 
   [COORD @D92969, AGR [CASE @D92968, COUNT @D92967, PER @D92966, 
            PLU @D92965, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D92974, AGR [CASE @D92973, COUNT @D92972, PER @D92971, 
            PLU @D92970, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NEED, 
   [COORD @D92980, AGR [CASE @D92979, NFORM @D92978, COUNT @D92977, 
            PER @D92976, PLU @D92975, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NEED, 
   [COORD @D92985, AGR [UB @D92984, VFORM @D92983, SUBJ @D92982, 
            FIN @D92981, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : NEED, 
   [COORD @D92990, AGR [CASE @D92989, COUNT @D92988, PER @D92987, 
            PLU @D92986, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D92995, AGR [CASE @D92994, COUNT @D92993, PER @D92992, 
            PLU @D92991, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NEED, 
   [COORD @D93000, AGR [CASE @D92999, COUNT @D92998, PER @D92997, 
            PLU @D92996, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NEED, 
   [COORD @D93002, AGR @D93001, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : NEED, 
   [COORD @D93004, AGR @D93003, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : NEED.

WORD needing : 
   [COORD @D93019, PRD @D93018, AGR [CASE @D93017, COUNT @D93016, 
            PER @D93015, PLU @D93014, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D93025, PRD @D93024, 
      AGR [CASE @D93023, COUNT @D93022, PER @D93021, PLU @D93020, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NEED, 
   [COORD @D93031, PRD @D93030, AGR [CASE @D93029, COUNT @D93028, 
            PER @D93027, PLU @D93026, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_PASS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D93037, PRD @D93036, 
      AGR [CASE @D93035, COUNT @D93034, PER @D93033, PLU @D93032, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NEED, 
   [COORD @D93043, PRD @D93042, AGR [CASE @D93041, COUNT @D93040, 
            PER @D93039, PLU @D93038, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NEED, 
   [COORD @D93049, PRD @D93048, 
      AGR [CASE @D93047, COUNT @D93046, PER @D93045, PLU @D93044, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NEED, 
   [COORD @D93052, AGR @D93051, PRD @D93050, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : NEED.

WORD needs : 
   [COADV @D93062, COORD @D93061, DEF @D93060, AGR @D93059, PRD @D93058, 
      FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, N +, GRADE +, AFORM NONE, 
      PART -, NEG -, SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, ADV +] : NEEDS, 
   [COORD @D93067, DEMON @D93066, REFL @D93065, PRD @D93064, 
      CASE @D93063, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : NEED, 
   [COORD @D93072, DEMON @D93071, REFL @D93070, PRD @D93069, 
      CASE @D93068, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : NEED, 
   [COORD @D93074, 
      AGR [COUNT @D93073, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED, 
   [COORD @D93076, 
      AGR [COUNT @D93075, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED, 
   [COORD @D93078, 
      AGR [COUNT @D93077, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_PASS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED, 
   [COORD @D93080, 
      AGR [COUNT @D93079, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED, 
   [COORD @D93082, 
      AGR [COUNT @D93081, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED, 
   [COORD @D93084, 
      AGR [COUNT @D93083, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED, 
   [COORD @D93088, 
      AGR [CASE @D93087, NFORM @D93086, COUNT @D93085, PLU -, PER 3, N +, 
            V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED, 
   [COORD @D93093, 
      AGR [UB @D93092, VFORM @D93091, SUBJ @D93090, FIN @D93089, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_INF, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NEED.

WORD note : 
   [COORD @D93107, REFL @D93106, PRD @D93105, CASE @D93104, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : NOTE, 
   [COORD @D93111, REFL @D93110, PRD @D93109, CASE @D93108, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : NOTE, 
   [COORD @D93115, REFL @D93114, PRD @D93113, CASE @D93112, FIX NOT, N +, 
      V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : NOTE, 
   [COORD @D93118, 
      AGR [COUNT @D93117, PER @D93116, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, ARITY 2] : 
   NOTE, 
   [COORD @D93120, AGR [COUNT @D93119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : NOTE, 
   [COORD @D93122, AGR [COUNT @D93121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : NOTE, 
   [COORD @D93126, AGR [COUNT @D93125, PER @D93124, PLU @D93123, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : NOTE, 
   [COORD @D93132, PAST @D93131, AGR [CASE @D93130, COUNT @D93129, 
            PER @D93128, PLU @D93127, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : NOTE, 
   [COORD @D93135, AGR [COUNT @D93134, PER @D93133, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : NOTE, 
   [COORD @D93137, AGR [COUNT @D93136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : NOTE, 
   [COORD @D93139, AGR [COUNT @D93138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : NOTE, 
   [COORD @D93143, AGR [COUNT @D93142, PER @D93141, PLU @D93140, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : NOTE, 
   [COORD @D93149, PAST @D93148, AGR [CASE @D93147, COUNT @D93146, 
            PER @D93145, PLU @D93144, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : NOTE, 
   [COORD @D93152, AGR [COUNT @D93151, PER @D93150, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTE, 
   [COORD @D93154, AGR [COUNT @D93153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTE, 
   [COORD @D93156, AGR [COUNT @D93155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTE, 
   [COORD @D93160, AGR [COUNT @D93159, PER @D93158, PLU @D93157, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTE, 
   [COORD @D93166, PAST @D93165, AGR [CASE @D93164, COUNT @D93163, 
            PER @D93162, PLU @D93161, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : NOTE, 
   [COORD @D93169, AGR [COUNT @D93168, PER @D93167, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NOTE, 
   [COORD @D93171, AGR [COUNT @D93170, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NOTE, 
   [COORD @D93173, AGR [COUNT @D93172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NOTE, 
   [COORD @D93177, AGR [COUNT @D93176, PER @D93175, PLU @D93174, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : NOTE, 
   [COORD @D93183, PAST @D93182, AGR [CASE @D93181, COUNT @D93180, 
            PER @D93179, PLU @D93178, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : NOTE.

WORD noted : 
   [COADV @D93199, COORD @D93198, DEF @D93197, PRD @D93196, AGR 
            [CASE @D93195, COUNT @D93194, PER @D93193, PLU @D93192, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : NOTED, 
   
   [COADV @D93207, COORD @D93206, DEF @D93205, PRD @D93204, AGR [CASE 
               @D93203, COUNT @D93202, PER @D93201, PLU @D93200, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, DISTR PRD, 
      ARITY 2] : NOTED, 
   [COORD @D93212, AGR [CASE @D93211, COUNT @D93210, PER @D93209, 
            PLU @D93208, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93217, AGR [CASE @D93216, COUNT @D93215, PER @D93214, 
            PLU @D93213, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93222, AGR [CASE @D93221, COUNT @D93220, PER @D93219, 
            PLU @D93218, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93227, AGR [CASE @D93226, COUNT @D93225, PER @D93224, 
            PLU @D93223, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93232, AGR [CASE @D93231, COUNT @D93230, PER @D93229, 
            PLU @D93228, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93237, AGR [CASE @D93236, COUNT @D93235, PER @D93234, 
            PLU @D93233, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93242, AGR [UB @D93241, VFORM @D93240, SUBJ @D93239, 
            FIN @D93238, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : NOTE, 
   [COORD @D93247, AGR [CASE @D93246, COUNT @D93245, PER @D93244, 
            PLU @D93243, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NOTE, 
   [COORD @D93252, AGR [CASE @D93251, COUNT @D93250, PER @D93249, 
            PLU @D93248, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93257, AGR [CASE @D93256, COUNT @D93255, PER @D93254, 
            PLU @D93253, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTE.

WORD notes : 
   [COORD @D93270, DEMON @D93269, REFL @D93268, PRD @D93267, CASE 
         @D93266, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : NOTE, 
   [COORD @D93272, 
      AGR [COUNT @D93271, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTE, 
   [COORD @D93274, 
      AGR [COUNT @D93273, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTE, 
   [COORD @D93276, 
      AGR [COUNT @D93275, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTE, 
   [COORD @D93278, 
      AGR [COUNT @D93277, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTE.

WORD notice : 
   [COORD @D93292, REFL @D93291, COUNT @D93290, PRD @D93289, CASE 
         @D93288, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : NOTICE, 
   [COORD @D93295, 
      AGR [COUNT @D93294, PER @D93293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, ARITY 2] : 
   NOTICE, 
   [COORD @D93297, AGR [COUNT @D93296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : NOTICE, 
   [COORD @D93299, AGR [COUNT @D93298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : NOTICE, 
   [COORD @D93303, AGR [COUNT @D93302, PER @D93301, PLU @D93300, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : NOTICE, 
   [COORD @D93309, PAST @D93308, AGR [CASE @D93307, COUNT @D93306, 
            PER @D93305, PLU @D93304, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : NOTICE, 
   [COORD @D93312, AGR [COUNT @D93311, PER @D93310, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : NOTICE, 
   [COORD @D93314, AGR [COUNT @D93313, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : NOTICE, 
   [COORD @D93316, AGR [COUNT @D93315, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : NOTICE, 
   [COORD @D93320, AGR [COUNT @D93319, PER @D93318, PLU @D93317, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : NOTICE, 
   [COORD @D93326, PAST @D93325, AGR [CASE @D93324, COUNT @D93323, 
            PER @D93322, PLU @D93321, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : NOTICE, 
   [COORD @D93329, AGR [COUNT @D93328, PER @D93327, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTICE, 
   [COORD @D93331, AGR [COUNT @D93330, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTICE, 
   [COORD @D93333, AGR [COUNT @D93332, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTICE, 
   [COORD @D93337, AGR [COUNT @D93336, PER @D93335, PLU @D93334, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : NOTICE, 
   [COORD @D93343, PAST @D93342, AGR [CASE @D93341, COUNT @D93340, 
            PER @D93339, PLU @D93338, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : NOTICE, 
   [COORD @D93346, AGR [COUNT @D93345, PER @D93344, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NOTICE, 
   [COORD @D93348, AGR [COUNT @D93347, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NOTICE, 
   [COORD @D93350, AGR [COUNT @D93349, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NOTICE, 
   [COORD @D93354, AGR [COUNT @D93353, PER @D93352, PLU @D93351, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : NOTICE, 
   [COORD @D93360, PAST @D93359, AGR [CASE @D93358, COUNT @D93357, 
            PER @D93356, PLU @D93355, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : NOTICE, 
   [COORD @D93363, AGR [COUNT @D93362, PER @D93361, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : NOTICE, 
   [COORD @D93365, AGR [COUNT @D93364, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : NOTICE, 
   [COORD @D93367, AGR [COUNT @D93366, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : NOTICE, 
   [COORD @D93371, AGR [COUNT @D93370, PER @D93369, PLU @D93368, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : NOTICE, 
   [COORD @D93377, PAST @D93376, AGR [CASE @D93375, COUNT @D93374, 
            PER @D93373, PLU @D93372, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_BSE, ARITY 2] : NOTICE, 
   [COORD @D93380, AGR [COUNT @D93379, PER @D93378, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NOTICE, 
   [COORD @D93382, AGR [COUNT @D93381, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NOTICE, 
   [COORD @D93384, AGR [COUNT @D93383, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : NOTICE, 
   [COORD @D93388, AGR [COUNT @D93387, PER @D93386, PLU @D93385, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : NOTICE, 
   [COORD @D93394, PAST @D93393, AGR [CASE @D93392, COUNT @D93391, 
            PER @D93390, PLU @D93389, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : NOTICE, 
   [COORD @D93397, AGR [COUNT @D93396, PER @D93395, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : NOTICE, 
   [COORD @D93399, AGR [COUNT @D93398, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : NOTICE, 
   [COORD @D93401, AGR [COUNT @D93400, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : NOTICE, 
   [COORD @D93405, AGR [COUNT @D93404, PER @D93403, PLU @D93402, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : NOTICE, 
   [COORD @D93411, PAST @D93410, AGR [CASE @D93409, COUNT @D93408, 
            PER @D93407, PLU @D93406, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : NOTICE.

WORD noticed : 
   [COORD @D93427, AGR [CASE @D93426, COUNT @D93425, PER @D93424, 
            PLU @D93423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93432, AGR [CASE @D93431, COUNT @D93430, PER @D93429, 
            PLU @D93428, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93437, AGR [CASE @D93436, COUNT @D93435, PER @D93434, 
            PLU @D93433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93442, AGR [CASE @D93441, COUNT @D93440, PER @D93439, 
            PLU @D93438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93447, AGR [UB @D93446, VFORM @D93445, SUBJ @D93444, 
            FIN @D93443, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : NOTICE, 
   [COORD @D93452, AGR [CASE @D93451, COUNT @D93450, PER @D93449, 
            PLU @D93448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93457, AGR [CASE @D93456, COUNT @D93455, PER @D93454, 
            PLU @D93453, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93462, AGR [CASE @D93461, COUNT @D93460, PER @D93459, 
            PLU @D93458, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NOTICE, 
   [COORD @D93467, AGR [CASE @D93466, COUNT @D93465, PER @D93464, 
            PLU @D93463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93472, AGR [CASE @D93471, COUNT @D93470, PER @D93469, 
            PLU @D93468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93477, AGR [CASE @D93476, COUNT @D93475, PER @D93474, 
            PLU @D93473, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93482, AGR [CASE @D93481, COUNT @D93480, PER @D93479, 
            PLU @D93478, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93487, AGR [CASE @D93486, COUNT @D93485, PER @D93484, 
            PLU @D93483, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : NOTICE, 
   [COORD @D93492, AGR [CASE @D93491, COUNT @D93490, PER @D93489, 
            PLU @D93488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93497, AGR [CASE @D93496, COUNT @D93495, PER @D93494, 
            PLU @D93493, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93502, AGR [CASE @D93501, COUNT @D93500, PER @D93499, 
            PLU @D93498, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93507, AGR [CASE @D93506, COUNT @D93505, PER @D93504, 
            PLU @D93503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : NOTICE.

WORD notices : 
   [COORD @D93523, DEMON @D93522, REFL @D93521, PRD @D93520, 
      CASE @D93519, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : NOTICE, 
   [COORD @D93525, 
      AGR [COUNT @D93524, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93527, 
      AGR [COUNT @D93526, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93529, 
      AGR [COUNT @D93528, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93531, 
      AGR [COUNT @D93530, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93533, 
      AGR [COUNT @D93532, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93535, 
      AGR [COUNT @D93534, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93537, 
      AGR [COUNT @D93536, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : NOTICE.

WORD noticing : 
   [COORD @D93554, PRD @D93553, AGR [CASE @D93552, COUNT @D93551, 
            PER @D93550, PLU @D93549, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93560, PRD @D93559, 
      AGR [CASE @D93558, COUNT @D93557, PER @D93556, PLU @D93555, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NOTICE, 
   [COORD @D93566, PRD @D93565, AGR [CASE @D93564, COUNT @D93563, 
            PER @D93562, PLU @D93561, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93572, PRD @D93571, 
      AGR [CASE @D93570, COUNT @D93569, PER @D93568, PLU @D93567, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NOTICE, 
   [COORD @D93578, PRD @D93577, AGR [CASE @D93576, COUNT @D93575, 
            PER @D93574, PLU @D93573, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_BSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NOTICE, 
   [COORD @D93584, PRD @D93583, 
      AGR [CASE @D93582, COUNT @D93581, PER @D93580, PLU @D93579, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NOTICE, 
   [COORD @D93590, PRD @D93589, AGR [CASE @D93588, COUNT @D93587, 
            PER @D93586, PLU @D93585, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NOTICE.

WORD noting : 
   [COORD @D93604, PRD @D93603, AGR [CASE @D93602, COUNT @D93601, 
            PER @D93600, PLU @D93599, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93610, PRD @D93609, 
      AGR [CASE @D93608, COUNT @D93607, PER @D93606, PLU @D93605, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   NOTE, 
   [COORD @D93616, PRD @D93615, AGR [CASE @D93614, COUNT @D93613, 
            PER @D93612, PLU @D93611, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : NOTE, 
   [COORD @D93622, PRD @D93621, 
      AGR [CASE @D93620, COUNT @D93619, PER @D93618, PLU @D93617, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : NOTE.

WORD obituaries : 
   [COORD @D93631, DEMON @D93630, REFL @D93629, PRD @D93628, 
      CASE @D93627, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : OBITUARY.

WORD obituary : 
   [COORD @D93638, REFL @D93637, PRD @D93636, CASE @D93635, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : OBITUARY.

WORD object : 
   [COORD @D93645, REFL @D93644, COUNT @D93643, PRD @D93642, CASE 
         @D93641, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : OBJECT, 
   [COORD @D93649, REFL @D93648, PRD @D93647, CASE @D93646, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : OBJECT, 
   [COORD @D93652, 
      AGR [COUNT @D93651, PER @D93650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   OBJECT, 
   [COORD @D93654, AGR [COUNT @D93653, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OBJECT, 
   [COORD @D93656, AGR [COUNT @D93655, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OBJECT, 
   [COORD @D93660, AGR [COUNT @D93659, PER @D93658, PLU @D93657, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OBJECT, 
   [COORD @D93666, PAST @D93665, AGR [CASE @D93664, COUNT @D93663, 
            PER @D93662, PLU @D93661, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : OBJECT, 
   [COORD @D93669, AGR [COUNT @D93668, PER @D93667, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : OBJECT, 
   [COORD @D93671, AGR [COUNT @D93670, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : OBJECT, 
   [COORD @D93673, AGR [COUNT @D93672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : OBJECT, 
   [COORD @D93677, AGR [COUNT @D93676, PER @D93675, PLU @D93674, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : OBJECT, 
   [COORD @D93683, PAST @D93682, 
      AGR [CASE @D93681, COUNT @D93680, PER @D93679, PLU @D93678, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : OBJECT, 
   [COORD @D93686, AGR [COUNT @D93685, PER @D93684, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OBJECT, 
   [COORD @D93688, AGR [COUNT @D93687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OBJECT, 
   [COORD @D93690, AGR [COUNT @D93689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OBJECT, 
   [COORD @D93694, AGR [COUNT @D93693, PER @D93692, PLU @D93691, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OBJECT, 
   [COORD @D93700, PAST @D93699, AGR [CASE @D93698, COUNT @D93697, 
            PER @D93696, PLU @D93695, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : OBJECT.

WORD objected : 
   [COORD @D93709, AGR [CASE @D93708, COUNT @D93707, PER @D93706, 
            PLU @D93705, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93714, AGR [CASE @D93713, COUNT @D93712, PER @D93711, 
            PLU @D93710, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93719, AGR [UB @D93718, VFORM @D93717, SUBJ @D93716, 
            FIN @D93715, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OBJECT, 
   [COORD @D93724, AGR [CASE @D93723, COUNT @D93722, PER @D93721, 
            PLU @D93720, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93729, AGR [CASE @D93728, COUNT @D93727, PER @D93726, 
            PLU @D93725, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93734, AGR [CASE @D93733, COUNT @D93732, PER @D93731, 
            PLU @D93730, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93739, AGR [CASE @D93738, COUNT @D93737, PER @D93736, 
            PLU @D93735, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBJECT.

WORD objecting : 
   [COORD @D93753, PRD @D93752, AGR [CASE @D93751, COUNT @D93750, 
            PER @D93749, PLU @D93748, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93759, PRD @D93758, 
      AGR [CASE @D93757, COUNT @D93756, PER @D93755, PLU @D93754, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OBJECT, 
   [COORD @D93765, PRD @D93764, AGR [CASE @D93763, COUNT @D93762, 
            PER @D93761, PLU @D93760, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OBJECT.

WORD objects : 
   [COORD @D93774, DEMON @D93773, REFL @D93772, PRD @D93771, 
      CASE @D93770, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : OBJECT, 
   [COORD @D93779, DEMON @D93778, REFL @D93777, PRD @D93776, 
      CASE @D93775, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   OBJECT, 
   [COORD @D93781, AGR [COUNT @D93780, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93783, 
      AGR [COUNT @D93782, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBJECT, 
   [COORD @D93785, 
      AGR [COUNT @D93784, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBJECT.

WORD observe : 
   [COORD @D93791, AGR [COUNT @D93790, PER @D93789, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : OBSERVE, 
   [COORD @D93793, AGR [COUNT @D93792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : OBSERVE, 
   [COORD @D93795, AGR [COUNT @D93794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : OBSERVE, 
   [COORD @D93799, AGR [COUNT @D93798, PER @D93797, PLU @D93796, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_SFIN, PFORM TO, ARITY 3] : OBSERVE, 
   [COORD @D93805, PAST @D93804, 
      AGR [CASE @D93803, COUNT @D93802, PER @D93801, PLU @D93800, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, 
      ARITY 3] : OBSERVE, 
   [COORD @D93808, AGR [COUNT @D93807, PER @D93806, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : OBSERVE, 
   [COORD @D93810, AGR [COUNT @D93809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : OBSERVE, 
   [COORD @D93812, AGR [COUNT @D93811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : OBSERVE, 
   [COORD @D93816, AGR [COUNT @D93815, PER @D93814, PLU @D93813, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : OBSERVE, 
   [COORD @D93822, PAST @D93821, AGR [CASE @D93820, COUNT @D93819, 
            PER @D93818, PLU @D93817, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : OBSERVE, 
   [COORD @D93825, AGR [COUNT @D93824, PER @D93823, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : OBSERVE, 
   [COORD @D93827, AGR [COUNT @D93826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : OBSERVE, 
   [COORD @D93829, AGR [COUNT @D93828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : OBSERVE, 
   [COORD @D93833, AGR [COUNT @D93832, PER @D93831, PLU @D93830, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : OBSERVE, 
   [COORD @D93839, PAST @D93838, AGR [CASE @D93837, COUNT @D93836, 
            PER @D93835, PLU @D93834, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : OBSERVE, 
   [COORD @D93842, AGR [COUNT @D93841, PER @D93840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OBSERVE, 
   [COORD @D93844, AGR [COUNT @D93843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OBSERVE, 
   [COORD @D93846, AGR [COUNT @D93845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OBSERVE, 
   [COORD @D93850, AGR [COUNT @D93849, PER @D93848, PLU @D93847, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OBSERVE, 
   [COORD @D93856, PAST @D93855, AGR [CASE @D93854, COUNT @D93853, 
            PER @D93852, PLU @D93851, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : OBSERVE, 
   [COORD @D93859, AGR [COUNT @D93858, PER @D93857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : OBSERVE, 
   [COORD @D93861, AGR [COUNT @D93860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : OBSERVE, 
   [COORD @D93863, AGR [COUNT @D93862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : OBSERVE, 
   [COORD @D93867, AGR [COUNT @D93866, PER @D93865, PLU @D93864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : OBSERVE, 
   [COORD @D93873, PAST @D93872, AGR [CASE @D93871, COUNT @D93870, 
            PER @D93869, PLU @D93868, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : OBSERVE, 
   [COORD @D93876, AGR [COUNT @D93875, PER @D93874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : OBSERVE, 
   [COORD @D93878, AGR [COUNT @D93877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : OBSERVE, 
   [COORD @D93880, AGR [COUNT @D93879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : OBSERVE, 
   [COORD @D93884, AGR [COUNT @D93883, PER @D93882, PLU @D93881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : OBSERVE, 
   [COORD @D93890, PAST @D93889, AGR [CASE @D93888, COUNT @D93887, 
            PER @D93886, PLU @D93885, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : OBSERVE, 
   [COORD @D93893, AGR [COUNT @D93892, PER @D93891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : OBSERVE, 
   [COORD @D93895, AGR [COUNT @D93894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : OBSERVE, 
   [COORD @D93897, AGR [COUNT @D93896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : OBSERVE, 
   [COORD @D93901, AGR [COUNT @D93900, PER @D93899, PLU @D93898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_BSE, ARITY 2] : OBSERVE, 
   [COORD @D93907, PAST @D93906, AGR [CASE @D93905, COUNT @D93904, 
            PER @D93903, PLU @D93902, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_BSE, ARITY 2] : OBSERVE, 
   [COORD @D93910, AGR [COUNT @D93909, PER @D93908, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OBSERVE, 
   [COORD @D93912, AGR [COUNT @D93911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OBSERVE, 
   [COORD @D93914, AGR [COUNT @D93913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OBSERVE, 
   [COORD @D93918, AGR [COUNT @D93917, PER @D93916, PLU @D93915, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OBSERVE, 
   [COORD @D93924, PAST @D93923, AGR [CASE @D93922, COUNT @D93921, 
            PER @D93920, PLU @D93919, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : OBSERVE, 
   [COORD @D93927, AGR [COUNT @D93926, PER @D93925, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OBSERVE, 
   [COORD @D93929, AGR [COUNT @D93928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OBSERVE, 
   [COORD @D93931, AGR [COUNT @D93930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OBSERVE, 
   [COORD @D93935, AGR [COUNT @D93934, PER @D93933, PLU @D93932, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : OBSERVE, 
   [COORD @D93941, PAST @D93940, AGR [CASE @D93939, COUNT @D93938, 
            PER @D93937, PLU @D93936, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : OBSERVE.

WORD observed : 
   [COORD @D93950, AGR [CASE @D93949, COUNT @D93948, PER @D93947, 
            PLU @D93946, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93955, AGR [CASE @D93954, COUNT @D93953, PER @D93952, 
            PLU @D93951, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93960, AGR [CASE @D93959, COUNT @D93958, PER @D93957, 
            PLU @D93956, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93965, AGR [CASE @D93964, COUNT @D93963, PER @D93962, 
            PLU @D93961, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93970, AGR [CASE @D93969, COUNT @D93968, PER @D93967, 
            PLU @D93966, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93975, AGR [CASE @D93974, COUNT @D93973, PER @D93972, 
            PLU @D93971, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93980, AGR [UB @D93979, VFORM @D93978, SUBJ @D93977, 
            FIN @D93976, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OBSERVE, 
   [COORD @D93985, AGR [CASE @D93984, COUNT @D93983, PER @D93982, 
            PLU @D93981, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93990, AGR [CASE @D93989, COUNT @D93988, PER @D93987, 
            PLU @D93986, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D93995, AGR [CASE @D93994, COUNT @D93993, PER @D93992, 
            PLU @D93991, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94000, AGR [CASE @D93999, COUNT @D93998, PER @D93997, 
            PLU @D93996, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94005, AGR [CASE @D94004, COUNT @D94003, PER @D94002, 
            PLU @D94001, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94011, AGR [CASE @D94010, NFORM @D94009, COUNT @D94008, 
            PER @D94007, PLU @D94006, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94016, AGR [UB @D94015, VFORM @D94014, SUBJ @D94013, 
            FIN @D94012, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OBSERVE, 
   [COORD @D94021, AGR [CASE @D94020, COUNT @D94019, PER @D94018, 
            PLU @D94017, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94026, AGR [CASE @D94025, COUNT @D94024, PER @D94023, 
            PLU @D94022, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94031, AGR [CASE @D94030, COUNT @D94029, PER @D94028, 
            PLU @D94027, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94036, AGR [CASE @D94035, COUNT @D94034, PER @D94033, 
            PLU @D94032, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94041, AGR [CASE @D94040, COUNT @D94039, PER @D94038, 
            PLU @D94037, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94046, AGR [CASE @D94045, COUNT @D94044, PER @D94043, 
            PLU @D94042, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94052, AGR [CASE @D94051, NFORM @D94050, COUNT @D94049, 
            PER @D94048, PLU @D94047, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94057, AGR [UB @D94056, VFORM @D94055, SUBJ @D94054, 
            FIN @D94053, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OBSERVE, 
   [COORD @D94062, AGR [CASE @D94061, COUNT @D94060, PER @D94059, 
            PLU @D94058, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94067, AGR [CASE @D94066, COUNT @D94065, PER @D94064, 
            PLU @D94063, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94072, AGR [CASE @D94071, COUNT @D94070, PER @D94069, 
            PLU @D94068, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OBSERVE.

WORD observes : 
   [COORD @D94078, AGR [COUNT @D94077, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   OBSERVE, 
   [COORD @D94080, AGR [COUNT @D94079, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94082, 
      AGR [COUNT @D94081, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94084, 
      AGR [COUNT @D94083, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94086, 
      AGR [COUNT @D94085, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94088, 
      AGR [COUNT @D94087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94090, 
      AGR [COUNT @D94089, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94092, 
      AGR [COUNT @D94091, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94094, 
      AGR [COUNT @D94093, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OBSERVE.

WORD observing : 
   [COORD @D94103, PRD @D94102, AGR [CASE @D94101, COUNT @D94100, 
            PER @D94099, PLU @D94098, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94109, PRD @D94108, 
      AGR [CASE @D94107, COUNT @D94106, PER @D94105, PLU @D94104, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OBSERVE, 
   [COORD @D94115, PRD @D94114, AGR [CASE @D94113, COUNT @D94112, 
            PER @D94111, PLU @D94110, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94121, PRD @D94120, 
      AGR [CASE @D94119, COUNT @D94118, PER @D94117, PLU @D94116, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OBSERVE, 
   [COORD @D94127, PRD @D94126, AGR [CASE @D94125, COUNT @D94124, 
            PER @D94123, PLU @D94122, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94133, PRD @D94132, 
      AGR [CASE @D94131, COUNT @D94130, PER @D94129, PLU @D94128, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OBSERVE, 
   [COORD @D94139, PRD @D94138, AGR [CASE @D94137, COUNT @D94136, 
            PER @D94135, PLU @D94134, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_BSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OBSERVE, 
   [COORD @D94145, PRD @D94144, 
      AGR [CASE @D94143, COUNT @D94142, PER @D94141, PLU @D94140, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OBSERVE, 
   [COORD @D94151, PRD @D94150, AGR [CASE @D94149, COUNT @D94148, 
            PER @D94147, PLU @D94146, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OBSERVE.

WORD occur : 
   [COORD @D94156, AGR [COUNT @D94155, PER @D94154, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : OCCUR, 
   [COORD @D94158, AGR [COUNT @D94157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : OCCUR, 
   [COORD @D94160, AGR [COUNT @D94159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : OCCUR, 
   [COORD @D94164, AGR [COUNT @D94163, PER @D94162, PLU @D94161, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : OCCUR, 
   [COORD @D94170, PAST @D94169, 
      AGR [CASE @D94168, COUNT @D94167, PER @D94166, PLU @D94165, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      ARITY 2] : OCCUR, 
   [COORD @D94173, AGR [COUNT @D94172, PER @D94171, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OCCUR, 
   [COORD @D94175, AGR [COUNT @D94174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OCCUR, 
   [COORD @D94177, AGR [COUNT @D94176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OCCUR, 
   [COORD @D94181, AGR [COUNT @D94180, PER @D94179, PLU @D94178, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OCCUR, 
   [COORD @D94187, PAST @D94186, AGR [CASE @D94185, COUNT @D94184, 
            PER @D94183, PLU @D94182, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : OCCUR, 
   [COORD @D94192, PAST @D94191, 
      AGR [COUNT @D94190, PER @D94189, PLU @D94188, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, 
      ARITY 2] : OCCUR.

WORD occurred : 
   [COORD @D94200, AGR [CASE @D94199, COUNT @D94198, PER @D94197, 
            PLU @D94196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94205, AGR [CASE @D94204, COUNT @D94203, PER @D94202, 
            PLU @D94201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94210, AGR [CASE @D94209, COUNT @D94208, PER @D94207, 
            PLU @D94206, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94215, AGR [CASE @D94214, COUNT @D94213, PER @D94212, 
            PLU @D94211, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94220, AGR [CASE @D94219, COUNT @D94218, PER @D94217, 
            PLU @D94216, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94224, AGR [COUNT @D94223, PER @D94222, PLU @D94221, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94228, AGR [COUNT @D94227, PER @D94226, PLU @D94225, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OCCUR.

WORD occurring : 
   [COORD @D94237, PRD @D94236, AGR [CASE @D94235, COUNT @D94234, 
            PER @D94233, PLU @D94232, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94243, PRD @D94242, 
      AGR [CASE @D94241, COUNT @D94240, PER @D94239, PLU @D94238, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OCCUR, 
   [COORD @D94248, PRD @D94247, AGR [COUNT @D94246, PER @D94245, 
            PLU @D94244, NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OCCUR.

WORD occurs : 
   [COORD @D94253, AGR [COUNT @D94252, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : OCCUR, 
   [COORD @D94255, AGR [COUNT @D94254, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OCCUR, 
   [COORD @D94258, 
      AGR [CASE @D94257, COUNT @D94256, N +, V -, BAR 2, NFORM IT, PLU -, 
            PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   OCCUR.

WORD offer : 
   [COORD @D94269, REFL @D94268, COUNT @D94267, PRD @D94266, CASE 
         @D94265, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : OFFER, 
   [COORD @D94273, REFL @D94272, PRD @D94271, CASE @D94270, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF, COUNT +] : OFFER, 
   [COORD @D94277, REFL @D94276, PRD @D94275, CASE @D94274, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : OFFER, 
   [COORD @D94280, 
      AGR [COUNT @D94279, PER @D94278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   OFFER, 
   [COORD @D94282, AGR [COUNT @D94281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : OFFER, 
   [COORD @D94284, AGR [COUNT @D94283, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : OFFER, 
   [COORD @D94288, AGR [COUNT @D94287, PER @D94286, PLU @D94285, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : OFFER, 
   [COORD @D94294, PAST @D94293, AGR [CASE @D94292, COUNT @D94291, 
            PER @D94290, PLU @D94289, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : OFFER, 
   [COORD @D94297, AGR [COUNT @D94296, PER @D94295, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OFFER, 
   [COORD @D94299, AGR [COUNT @D94298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OFFER, 
   [COORD @D94301, AGR [COUNT @D94300, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OFFER, 
   [COORD @D94305, AGR [COUNT @D94304, PER @D94303, PLU @D94302, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OFFER, 
   [COORD @D94311, PAST @D94310, 
      AGR [CASE @D94309, COUNT @D94308, PER @D94307, PLU @D94306, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : OFFER, 
   [COORD @D94314, AGR [COUNT @D94313, PER @D94312, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : OFFER, 
   [COORD @D94316, AGR [COUNT @D94315, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : OFFER, 
   [COORD @D94318, AGR [COUNT @D94317, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : OFFER, 
   [COORD @D94322, AGR [COUNT @D94321, PER @D94320, PLU @D94319, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : OFFER, 
   [COORD @D94328, PAST @D94327, 
      AGR [CASE @D94326, COUNT @D94325, PER @D94324, PLU @D94323, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : OFFER, 
   [COORD @D94331, AGR [COUNT @D94330, PER @D94329, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : OFFER, 
   [COORD @D94333, AGR [COUNT @D94332, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : OFFER, 
   [COORD @D94335, AGR [COUNT @D94334, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : OFFER, 
   [COORD @D94339, AGR [COUNT @D94338, PER @D94337, PLU @D94336, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : OFFER, 
   [COORD @D94345, PAST @D94344, AGR [CASE @D94343, COUNT @D94342, 
            PER @D94341, PLU @D94340, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : OFFER, 
   [COORD @D94348, AGR [COUNT @D94347, PER @D94346, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OFFER, 
   [COORD @D94350, AGR [COUNT @D94349, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OFFER, 
   [COORD @D94352, AGR [COUNT @D94351, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OFFER, 
   [COORD @D94356, AGR [COUNT @D94355, PER @D94354, PLU @D94353, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : OFFER, 
   [COORD @D94362, PAST @D94361, AGR [CASE @D94360, COUNT @D94359, 
            PER @D94358, PLU @D94357, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : OFFER, 
   [COORD @D94365, AGR [COUNT @D94364, PER @D94363, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : OFFER, 
   [COORD @D94367, AGR [COUNT @D94366, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : OFFER, 
   [COORD @D94369, AGR [COUNT @D94368, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : OFFER, 
   [COORD @D94373, AGR [COUNT @D94372, PER @D94371, PLU @D94370, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : OFFER, 
   [COORD @D94379, PAST @D94378, 
      AGR [CASE @D94377, COUNT @D94376, PER @D94375, PLU @D94374, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : OFFER, 
   [COORD @D94382, AGR [COUNT @D94381, PER @D94380, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OFFER, 
   [COORD @D94384, AGR [COUNT @D94383, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OFFER, 
   [COORD @D94386, AGR [COUNT @D94385, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OFFER, 
   [COORD @D94390, AGR [COUNT @D94389, PER @D94388, PLU @D94387, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OFFER, 
   [COORD @D94396, PAST @D94395, AGR [CASE @D94394, COUNT @D94393, 
            PER @D94392, PLU @D94391, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : OFFER, 
   [COORD @D94399, AGR [COUNT @D94398, PER @D94397, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OFFER, 
   [COORD @D94401, AGR [COUNT @D94400, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OFFER, 
   [COORD @D94403, AGR [COUNT @D94402, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OFFER, 
   [COORD @D94407, AGR [COUNT @D94406, PER @D94405, PLU @D94404, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OFFER, 
   [COORD @D94413, PAST @D94412, 
      AGR [CASE @D94411, COUNT @D94410, PER @D94409, PLU @D94408, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : OFFER.

WORD offered : 
   [COORD @D94427, AGR [CASE @D94426, COUNT @D94425, PER @D94424, 
            PLU @D94423, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OFFER, 
   [COORD @D94432, AGR [CASE @D94431, COUNT @D94430, PER @D94429, 
            PLU @D94428, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94437, AGR [CASE @D94436, COUNT @D94435, PER @D94434, 
            PLU @D94433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94442, AGR [CASE @D94441, COUNT @D94440, PER @D94439, 
            PLU @D94438, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94447, AGR [CASE @D94446, COUNT @D94445, PER @D94444, 
            PLU @D94443, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94452, AGR [CASE @D94451, COUNT @D94450, PER @D94449, 
            PLU @D94448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94457, AGR [CASE @D94456, COUNT @D94455, PER @D94454, 
            PLU @D94453, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94462, AGR [CASE @D94461, COUNT @D94460, PER @D94459, 
            PLU @D94458, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94467, AGR [CASE @D94466, COUNT @D94465, PER @D94464, 
            PLU @D94463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94472, AGR [CASE @D94471, COUNT @D94470, PER @D94469, 
            PLU @D94468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94477, AGR [CASE @D94476, COUNT @D94475, PER @D94474, 
            PLU @D94473, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94482, AGR [CASE @D94481, COUNT @D94480, PER @D94479, 
            PLU @D94478, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OFFER, 
   [COORD @D94487, AGR [CASE @D94486, COUNT @D94485, PER @D94484, 
            PLU @D94483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94492, AGR [CASE @D94491, COUNT @D94490, PER @D94489, 
            PLU @D94488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94497, AGR [CASE @D94496, COUNT @D94495, PER @D94494, 
            PLU @D94493, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94502, AGR [CASE @D94501, COUNT @D94500, PER @D94499, 
            PLU @D94498, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94507, AGR [CASE @D94506, COUNT @D94505, PER @D94504, 
            PLU @D94503, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94512, AGR [CASE @D94511, COUNT @D94510, PER @D94509, 
            PLU @D94508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94517, AGR [CASE @D94516, COUNT @D94515, PER @D94514, 
            PLU @D94513, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94522, AGR [CASE @D94521, COUNT @D94520, PER @D94519, 
            PLU @D94518, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94527, AGR [CASE @D94526, COUNT @D94525, PER @D94524, 
            PLU @D94523, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OFFER.

WORD offering : 
   [COORD @D94546, PRD @D94545, AGR [CASE @D94544, COUNT @D94543, 
            PER @D94542, PLU @D94541, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94552, PRD @D94551, 
      AGR [CASE @D94550, COUNT @D94549, PER @D94548, PLU @D94547, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OFFER, 
   [COORD @D94558, PRD @D94557, AGR [CASE @D94556, COUNT @D94555, 
            PER @D94554, PLU @D94553, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94564, PRD @D94563, 
      AGR [CASE @D94562, COUNT @D94561, PER @D94560, PLU @D94559, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OFFER, 
   [COORD @D94570, PRD @D94569, AGR [CASE @D94568, COUNT @D94567, 
            PER @D94566, PLU @D94565, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94576, PRD @D94575, 
      AGR [CASE @D94574, COUNT @D94573, PER @D94572, PLU @D94571, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OFFER, 
   [COORD @D94582, PRD @D94581, AGR [CASE @D94580, COUNT @D94579, 
            PER @D94578, PLU @D94577, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OFFER, 
   [COORD @D94588, PRD @D94587, 
      AGR [CASE @D94586, COUNT @D94585, PER @D94584, PLU @D94583, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OFFER.

WORD offers : 
   [COORD @D94602, DEMON @D94601, REFL @D94600, PRD @D94599, CASE 
         @D94598, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : OFFER, 
   [COORD @D94607, DEMON @D94606, REFL @D94605, PRD @D94604, 
      CASE @D94603, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : OFFER, 
   [COORD @D94612, DEMON @D94611, REFL @D94610, PRD @D94609, 
      CASE @D94608, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   OFFER, 
   [COORD @D94614, AGR [COUNT @D94613, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER, 
   [COORD @D94616, 
      AGR [COUNT @D94615, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER, 
   [COORD @D94618, 
      AGR [COUNT @D94617, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER, 
   [COORD @D94620, 
      AGR [COUNT @D94619, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER, 
   [COORD @D94622, 
      AGR [COUNT @D94621, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER, 
   [COORD @D94624, 
      AGR [COUNT @D94623, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER, 
   [COORD @D94626, 
      AGR [COUNT @D94625, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER, 
   [COORD @D94628, 
      AGR [COUNT @D94627, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OFFER.

WORD open : [FIX NOT, PRT OPEN, INFL -] : OPEN, 
   [COORD @D94633, AGR [COUNT @D94632, PER @D94631, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM TO, ARITY 3] : OPEN, 
   [COORD @D94635, AGR [COUNT @D94634, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM TO, ARITY 3] : OPEN, 
   [COORD @D94637, AGR [COUNT @D94636, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM TO, ARITY 3] : OPEN, 
   [COORD @D94641, AGR [COUNT @D94640, PER @D94639, PLU @D94638, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM TO, ARITY 3] : OPEN, 
   [COORD @D94647, PAST @D94646, 
      AGR [CASE @D94645, COUNT @D94644, PER @D94643, PLU @D94642, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM TO, ARITY 3] : OPEN, 
   [COORD @D94650, AGR [COUNT @D94649, PER @D94648, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPEN, 
   [COORD @D94652, AGR [COUNT @D94651, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPEN, 
   [COORD @D94654, AGR [COUNT @D94653, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPEN, 
   [COORD @D94658, AGR [COUNT @D94657, PER @D94656, PLU @D94655, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : OPEN, 
   [COORD @D94664, PAST @D94663, AGR [CASE @D94662, COUNT @D94661, 
            PER @D94660, PLU @D94659, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : OPEN, 
   [COORD @D94667, AGR [COUNT @D94666, PER @D94665, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : OPEN, 
   [COORD @D94669, AGR [COUNT @D94668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : OPEN, 
   [COORD @D94671, AGR [COUNT @D94670, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : OPEN, 
   [COORD @D94675, AGR [COUNT @D94674, PER @D94673, PLU @D94672, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : OPEN, 
   [COORD @D94681, PAST @D94680, 
      AGR [CASE @D94679, COUNT @D94678, PER @D94677, PLU @D94676, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : OPEN, 
   [COORD @D94684, AGR [COUNT @D94683, PER @D94682, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : OPEN, 
   [COORD @D94686, AGR [COUNT @D94685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : OPEN, 
   [COORD @D94688, AGR [COUNT @D94687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : OPEN, 
   [COORD @D94692, AGR [COUNT @D94691, PER @D94690, PLU @D94689, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : OPEN, 
   [COORD @D94698, PAST @D94697, 
      AGR [CASE @D94696, COUNT @D94695, PER @D94694, PLU @D94693, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : OPEN, 
   [COORD @D94701, AGR [COUNT @D94700, PER @D94699, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPEN, 
   [COORD @D94703, AGR [COUNT @D94702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPEN, 
   [COORD @D94705, AGR [COUNT @D94704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPEN, 
   [COORD @D94709, AGR [COUNT @D94708, PER @D94707, PLU @D94706, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPEN, 
   [COORD @D94715, PAST @D94714, AGR [CASE @D94713, COUNT @D94712, 
            PER @D94711, PLU @D94710, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : OPEN, 
   [COORD @D94718, AGR [COUNT @D94717, PER @D94716, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OPEN, 
   [COORD @D94720, AGR [COUNT @D94719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OPEN, 
   [COORD @D94722, AGR [COUNT @D94721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OPEN, 
   [COORD @D94726, AGR [COUNT @D94725, PER @D94724, PLU @D94723, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OPEN, 
   [COORD @D94732, PAST @D94731, 
      AGR [CASE @D94730, COUNT @D94729, PER @D94728, PLU @D94727, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : OPEN, 
   [COORD @D94735, AGR [COUNT @D94734, PER @D94733, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : OPEN, 
   [COORD @D94737, AGR [COUNT @D94736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : OPEN, 
   [COORD @D94739, AGR [COUNT @D94738, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : OPEN, 
   [COORD @D94743, AGR [COUNT @D94742, PER @D94741, PLU @D94740, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : OPEN, 
   [COORD @D94749, PAST @D94748, 
      AGR [CASE @D94747, COUNT @D94746, PER @D94745, PLU @D94744, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : OPEN.

WORD opened : 
   [COORD @D94758, AGR [CASE @D94757, COUNT @D94756, PER @D94755, 
            PLU @D94754, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94763, AGR [CASE @D94762, COUNT @D94761, PER @D94760, 
            PLU @D94759, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94768, 
      AGR [CASE @D94767, COUNT @D94766, PER @D94765, PLU @D94764, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : OPEN, 
   [COORD @D94773, AGR [CASE @D94772, COUNT @D94771, PER @D94770, 
            PLU @D94769, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OPEN, 
   [COORD @D94778, AGR [CASE @D94777, COUNT @D94776, PER @D94775, 
            PLU @D94774, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94783, AGR [CASE @D94782, COUNT @D94781, PER @D94780, 
            PLU @D94779, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94788, AGR [CASE @D94787, COUNT @D94786, PER @D94785, 
            PLU @D94784, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94793, AGR [CASE @D94792, COUNT @D94791, PER @D94790, 
            PLU @D94789, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94798, AGR [CASE @D94797, COUNT @D94796, PER @D94795, 
            PLU @D94794, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94803, AGR [CASE @D94802, COUNT @D94801, PER @D94800, 
            PLU @D94799, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94808, AGR [CASE @D94807, COUNT @D94806, PER @D94805, 
            PLU @D94804, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94813, AGR [CASE @D94812, COUNT @D94811, PER @D94810, 
            PLU @D94809, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94818, AGR [CASE @D94817, COUNT @D94816, PER @D94815, 
            PLU @D94814, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94823, AGR [CASE @D94822, COUNT @D94821, PER @D94820, 
            PLU @D94819, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94828, AGR [CASE @D94827, COUNT @D94826, PER @D94825, 
            PLU @D94824, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94833, AGR [CASE @D94832, COUNT @D94831, PER @D94830, 
            PLU @D94829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94838, AGR [CASE @D94837, COUNT @D94836, PER @D94835, 
            PLU @D94834, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94843, AGR [CASE @D94842, COUNT @D94841, PER @D94840, 
            PLU @D94839, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OPEN.

WORD opening : 
   [COADV @D94857, COORD @D94856, DEF @D94855, PRD @D94854, AGR 
            [CASE @D94853, COUNT @D94852, PER @D94851, PLU @D94850, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : OPENING, 
   [COORD @D94861, REFL @D94860, PRD @D94859, CASE @D94858, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM AT, COUNT +] : OPENING, 
   [COORD @D94865, REFL @D94864, PRD @D94863, CASE @D94862, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, COUNT +] : OPENING, 
   [COORD @D94870, REFL @D94869, COUNT @D94868, PRD @D94867, 
      CASE @D94866, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : OPENING, 
   [COORD @D94874, REFL @D94873, PRD @D94872, CASE @D94871, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : OPENING, 
   [COORD @D94879, REFL @D94878, COUNT @D94877, PRD @D94876, 
      CASE @D94875, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : OPENING, 
   [COORD @D94885, PRD @D94884, 
      AGR [CASE @D94883, COUNT @D94882, PER @D94881, PLU @D94880, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OPEN, 
   [COORD @D94891, PRD @D94890, AGR [CASE @D94889, COUNT @D94888, 
            PER @D94887, PLU @D94886, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94897, PRD @D94896, 
      AGR [CASE @D94895, COUNT @D94894, PER @D94893, PLU @D94892, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OPEN, 
   [COORD @D94903, PRD @D94902, AGR [CASE @D94901, COUNT @D94900, 
            PER @D94899, PLU @D94898, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94909, PRD @D94908, 
      AGR [CASE @D94907, COUNT @D94906, PER @D94905, PLU @D94904, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OPEN, 
   [COORD @D94915, PRD @D94914, AGR [CASE @D94913, COUNT @D94912, 
            PER @D94911, PLU @D94910, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OPEN, 
   [COORD @D94921, PRD @D94920, 
      AGR [CASE @D94919, COUNT @D94918, PER @D94917, PLU @D94916, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OPEN.

WORD openings : 
   [COORD @D94935, DEMON @D94934, REFL @D94933, PRD @D94932, 
      CASE @D94931, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM AT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   OPENING, 
   [COORD @D94940, DEMON @D94939, REFL @D94938, PRD @D94937, 
      CASE @D94936, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM IN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   OPENING, 
   [COORD @D94945, DEMON @D94944, REFL @D94943, PRD @D94942, 
      CASE @D94941, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : OPENING, 
   
   [COORD @D94950, DEMON @D94949, REFL @D94948, PRD @D94947, CASE 
      @D94946, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   OPENING, 
   [COORD @D94955, DEMON @D94954, REFL @D94953, PRD @D94952, 
      CASE @D94951, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : OPENING.

WORD opens : 
   [COORD @D94961, AGR [COUNT @D94960, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : OPEN, 
   [COORD @D94963, AGR [COUNT @D94962, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPEN, 
   [COORD @D94965, 
      AGR [COUNT @D94964, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPEN, 
   [COORD @D94967, 
      AGR [COUNT @D94966, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPEN, 
   [COORD @D94969, 
      AGR [COUNT @D94968, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPEN, 
   [COORD @D94971, 
      AGR [COUNT @D94970, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPEN, 
   [COORD @D94973, 
      AGR [COUNT @D94972, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPEN.

WORD operate : 
   [COORD @D94979, AGR [COUNT @D94978, PER @D94977, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPERATE, 
   [COORD @D94981, AGR [COUNT @D94980, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPERATE, 
   [COORD @D94983, AGR [COUNT @D94982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPERATE, 
   [COORD @D94987, AGR [COUNT @D94986, PER @D94985, PLU @D94984, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : OPERATE, 
   [COORD @D94993, PAST @D94992, AGR [CASE @D94991, COUNT @D94990, 
            PER @D94989, PLU @D94988, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : OPERATE, 
   [COORD @D94996, AGR [COUNT @D94995, PER @D94994, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : OPERATE, 
   [COORD @D94998, AGR [COUNT @D94997, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : OPERATE, 
   [COORD @D95000, AGR [COUNT @D94999, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : OPERATE, 
   [COORD @D95004, AGR [COUNT @D95003, PER @D95002, PLU @D95001, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, ARITY 2] : OPERATE, 
   [COORD @D95010, PAST @D95009, AGR [CASE @D95008, COUNT @D95007, 
            PER @D95006, PLU @D95005, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, ARITY 2] : OPERATE, 
   [COORD @D95013, AGR [COUNT @D95012, PER @D95011, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : OPERATE, 
   [COORD @D95015, AGR [COUNT @D95014, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : OPERATE, 
   [COORD @D95017, AGR [COUNT @D95016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : OPERATE, 
   [COORD @D95021, AGR [COUNT @D95020, PER @D95019, PLU @D95018, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : OPERATE, 
   [COORD @D95027, PAST @D95026, 
      AGR [CASE @D95025, COUNT @D95024, PER @D95023, PLU @D95022, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, 
      ARITY 2] : OPERATE, 
   [COORD @D95030, AGR [COUNT @D95029, PER @D95028, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : OPERATE, 
   [COORD @D95032, AGR [COUNT @D95031, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : OPERATE, 
   [COORD @D95034, AGR [COUNT @D95033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : OPERATE, 
   [COORD @D95038, AGR [COUNT @D95037, PER @D95036, PLU @D95035, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : OPERATE, 
   [COORD @D95044, PAST @D95043, 
      AGR [CASE @D95042, COUNT @D95041, PER @D95040, PLU @D95039, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : OPERATE, 
   [COORD @D95047, AGR [COUNT @D95046, PER @D95045, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPERATE, 
   [COORD @D95049, AGR [COUNT @D95048, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPERATE, 
   [COORD @D95051, AGR [COUNT @D95050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPERATE, 
   [COORD @D95055, AGR [COUNT @D95054, PER @D95053, PLU @D95052, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : OPERATE, 
   [COORD @D95061, PAST @D95060, AGR [CASE @D95059, COUNT @D95058, 
            PER @D95057, PLU @D95056, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : OPERATE.

WORD operated : 
   [COORD @D95070, AGR [CASE @D95069, COUNT @D95068, PER @D95067, 
            PLU @D95066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95075, AGR [CASE @D95074, COUNT @D95073, PER @D95072, 
            PLU @D95071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95080, AGR [CASE @D95079, COUNT @D95078, PER @D95077, 
            PLU @D95076, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OPERATE, 
   [COORD @D95085, AGR [CASE @D95084, COUNT @D95083, PER @D95082, 
            PLU @D95081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95090, AGR [CASE @D95089, COUNT @D95088, PER @D95087, 
            PLU @D95086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95095, AGR [CASE @D95094, COUNT @D95093, PER @D95092, 
            PLU @D95091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95100, AGR [CASE @D95099, COUNT @D95098, PER @D95097, 
            PLU @D95096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95105, AGR [CASE @D95104, COUNT @D95103, PER @D95102, 
            PLU @D95101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95110, AGR [CASE @D95109, COUNT @D95108, PER @D95107, 
            PLU @D95106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95115, AGR [CASE @D95114, COUNT @D95113, PER @D95112, 
            PLU @D95111, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95120, AGR [CASE @D95119, COUNT @D95118, PER @D95117, 
            PLU @D95116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OPERATE.

WORD operates : 
   [COORD @D95126, AGR [COUNT @D95125, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95128, 
      AGR [COUNT @D95127, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95130, 
      AGR [COUNT @D95129, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95132, 
      AGR [COUNT @D95131, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95134, 
      AGR [COUNT @D95133, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPERATE.

WORD operating : 
   [COORD @D95143, PRD @D95142, AGR [CASE @D95141, COUNT @D95140, 
            PER @D95139, PLU @D95138, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95149, PRD @D95148, 
      AGR [CASE @D95147, COUNT @D95146, PER @D95145, PLU @D95144, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OPERATE, 
   [COORD @D95155, PRD @D95154, AGR [CASE @D95153, COUNT @D95152, 
            PER @D95151, PLU @D95150, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OPERATE, 
   [COORD @D95161, PRD @D95160, 
      AGR [CASE @D95159, COUNT @D95158, PER @D95157, PLU @D95156, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OPERATE, 
   [COORD @D95167, PRD @D95166, AGR [CASE @D95165, COUNT @D95164, 
            PER @D95163, PLU @D95162, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPERATE.

WORD oppose : 
   [COORD @D95173, AGR [COUNT @D95172, PER @D95171, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OPPOSE, 
   [COORD @D95175, AGR [COUNT @D95174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OPPOSE, 
   [COORD @D95177, AGR [COUNT @D95176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OPPOSE, 
   [COORD @D95181, AGR [COUNT @D95180, PER @D95179, PLU @D95178, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : OPPOSE, 
   [COORD @D95187, PAST @D95186, 
      AGR [CASE @D95185, COUNT @D95184, PER @D95183, PLU @D95182, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : OPPOSE, 
   [COORD @D95190, AGR [COUNT @D95189, PER @D95188, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPPOSE, 
   [COORD @D95192, AGR [COUNT @D95191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPPOSE, 
   [COORD @D95194, AGR [COUNT @D95193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OPPOSE, 
   [COORD @D95198, AGR [COUNT @D95197, PER @D95196, PLU @D95195, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : OPPOSE, 
   [COORD @D95204, PAST @D95203, AGR [CASE @D95202, COUNT @D95201, 
            PER @D95200, PLU @D95199, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : OPPOSE.

WORD opposed : 
   [COORD @D95213, AGR [CASE @D95212, COUNT @D95211, PER @D95210, 
            PLU @D95209, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPPOSE, 
   [COORD @D95218, AGR [CASE @D95217, COUNT @D95216, PER @D95215, 
            PLU @D95214, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OPPOSE, 
   [COORD @D95223, AGR [CASE @D95222, COUNT @D95221, PER @D95220, 
            PLU @D95219, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OPPOSE, 
   [COORD @D95228, AGR [CASE @D95227, COUNT @D95226, PER @D95225, 
            PLU @D95224, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OPPOSE, 
   [COORD @D95233, AGR [CASE @D95232, COUNT @D95231, PER @D95230, 
            PLU @D95229, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OPPOSE, 
   [COORD @D95238, AGR [CASE @D95237, COUNT @D95236, PER @D95235, 
            PLU @D95234, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OPPOSE.

WORD opposes : 
   [COORD @D95244, AGR [COUNT @D95243, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPPOSE, 
   [COORD @D95246, 
      AGR [COUNT @D95245, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OPPOSE.

WORD opposing : 
   [COORD @D95255, PRD @D95254, AGR [CASE @D95253, COUNT @D95252, 
            PER @D95251, PLU @D95250, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OPPOSE, 
   [COORD @D95261, PRD @D95260, 
      AGR [CASE @D95259, COUNT @D95258, PER @D95257, PLU @D95256, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   OPPOSE.

WORD order : 
   [COORD @D95268, AGR [COUNT @D95267, PER @D95266, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : ORDER, 
   [COORD @D95270, AGR [COUNT @D95269, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : ORDER, 
   [COORD @D95272, AGR [COUNT @D95271, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : ORDER, 
   [COORD @D95276, AGR [COUNT @D95275, PER @D95274, PLU @D95273, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : ORDER, 
   [COORD @D95282, PAST @D95281, AGR [CASE @D95280, COUNT @D95279, 
            PER @D95278, PLU @D95277, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : ORDER, 
   [COORD @D95285, AGR [COUNT @D95284, PER @D95283, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : ORDER, 
   [COORD @D95287, AGR [COUNT @D95286, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : ORDER, 
   [COORD @D95289, AGR [COUNT @D95288, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : ORDER, 
   [COORD @D95293, AGR [COUNT @D95292, PER @D95291, PLU @D95290, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : ORDER, 
   [COORD @D95299, PAST @D95298, AGR [CASE @D95297, COUNT @D95296, 
            PER @D95295, PLU @D95294, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : ORDER, 
   [COORD @D95302, AGR [COUNT @D95301, PER @D95300, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : ORDER, 
   [COORD @D95304, AGR [COUNT @D95303, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : ORDER, 
   [COORD @D95306, AGR [COUNT @D95305, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : ORDER, 
   [COORD @D95310, AGR [COUNT @D95309, PER @D95308, PLU @D95307, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : ORDER, 
   [COORD @D95316, PAST @D95315, AGR [CASE @D95314, COUNT @D95313, 
            PER @D95312, PLU @D95311, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_ADL, ARITY 3] : ORDER, 
   [COORD @D95319, AGR [COUNT @D95318, PER @D95317, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ORDER, 
   [COORD @D95321, AGR [COUNT @D95320, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ORDER, 
   [COORD @D95323, AGR [COUNT @D95322, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ORDER, 
   [COORD @D95327, AGR [COUNT @D95326, PER @D95325, PLU @D95324, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : ORDER, 
   [COORD @D95333, PAST @D95332, 
      AGR [CASE @D95331, COUNT @D95330, PER @D95329, PLU @D95328, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : ORDER, 
   [COORD @D95336, AGR [COUNT @D95335, PER @D95334, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ORDER, 
   [COORD @D95338, AGR [COUNT @D95337, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ORDER, 
   [COORD @D95340, AGR [COUNT @D95339, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ORDER, 
   [COORD @D95344, AGR [COUNT @D95343, PER @D95342, PLU @D95341, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : ORDER, 
   [COORD @D95350, PAST @D95349, AGR [CASE @D95348, COUNT @D95347, 
            PER @D95346, PLU @D95345, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : ORDER, 
   [COORD @D95353, AGR [COUNT @D95352, PER @D95351, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : ORDER, 
   [COORD @D95355, AGR [COUNT @D95354, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : ORDER, 
   [COORD @D95357, AGR [COUNT @D95356, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : ORDER, 
   [COORD @D95361, AGR [COUNT @D95360, PER @D95359, PLU @D95358, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : ORDER, 
   [COORD @D95367, PAST @D95366, AGR [CASE @D95365, COUNT @D95364, 
            PER @D95363, PLU @D95362, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : ORDER, 
   [COORD @D95370, AGR [COUNT @D95369, PER @D95368, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ORDER, 
   [COORD @D95372, AGR [COUNT @D95371, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ORDER, 
   [COORD @D95374, AGR [COUNT @D95373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ORDER, 
   [COORD @D95378, AGR [COUNT @D95377, PER @D95376, PLU @D95375, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : ORDER, 
   [COORD @D95384, PAST @D95383, AGR [CASE @D95382, COUNT @D95381, 
            PER @D95380, PLU @D95379, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : ORDER, 
   [COORD @D95387, AGR [COUNT @D95386, PER @D95385, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ORDER, 
   [COORD @D95389, AGR [COUNT @D95388, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ORDER, 
   [COORD @D95391, AGR [COUNT @D95390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ORDER, 
   [COORD @D95395, AGR [COUNT @D95394, PER @D95393, PLU @D95392, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ORDER, 
   [COORD @D95401, PAST @D95400, AGR [CASE @D95399, COUNT @D95398, 
            PER @D95397, PLU @D95396, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ORDER, 
   [COORD @D95404, AGR [COUNT @D95403, PER @D95402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : ORDER, 
   [COORD @D95406, AGR [COUNT @D95405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : ORDER, 
   [COORD @D95408, AGR [COUNT @D95407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : ORDER, 
   [COORD @D95412, AGR [COUNT @D95411, PER @D95410, PLU @D95409, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ABOUT, ARITY 2] : ORDER, 
   [COORD @D95418, PAST @D95417, 
      AGR [CASE @D95416, COUNT @D95415, PER @D95414, PLU @D95413, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : ORDER, 
   [COORD @D95421, AGR [COUNT @D95420, PER @D95419, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ORDER, 
   [COORD @D95423, AGR [COUNT @D95422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ORDER, 
   [COORD @D95425, AGR [COUNT @D95424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ORDER, 
   [COORD @D95429, AGR [COUNT @D95428, PER @D95427, PLU @D95426, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ORDER, 
   [COORD @D95435, PAST @D95434, 
      AGR [CASE @D95433, COUNT @D95432, PER @D95431, PLU @D95430, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ABOUT, 
      ARITY 1] : ORDER.

WORD ordered : 
   [COADV @D95448, COORD @D95447, DEF @D95446, PRD @D95445, AGR 
            [CASE @D95444, COUNT @D95443, PER @D95442, PLU @D95441, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   ORDERED, 
   [COORD @D95453, AGR [CASE @D95452, COUNT @D95451, PER @D95450, 
            PLU @D95449, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ORDER, 
   [COORD @D95458, AGR [CASE @D95457, COUNT @D95456, PER @D95455, 
            PLU @D95454, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95463, AGR [CASE @D95462, COUNT @D95461, PER @D95460, 
            PLU @D95459, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95468, AGR [CASE @D95467, COUNT @D95466, PER @D95465, 
            PLU @D95464, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ORDER, 
   [COORD @D95473, AGR [CASE @D95472, COUNT @D95471, PER @D95470, 
            PLU @D95469, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95478, AGR [CASE @D95477, COUNT @D95476, PER @D95475, 
            PLU @D95474, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95483, AGR [CASE @D95482, COUNT @D95481, PER @D95480, 
            PLU @D95479, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADL, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ORDER, 
   [COORD @D95488, AGR [CASE @D95487, COUNT @D95486, PER @D95485, 
            PLU @D95484, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95493, AGR [CASE @D95492, COUNT @D95491, PER @D95490, 
            PLU @D95489, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95498, AGR [CASE @D95497, COUNT @D95496, PER @D95495, 
            PLU @D95494, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95503, AGR [CASE @D95502, COUNT @D95501, PER @D95500, 
            PLU @D95499, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95508, AGR [CASE @D95507, COUNT @D95506, PER @D95505, 
            PLU @D95504, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95513, AGR [UB @D95512, VFORM @D95511, SUBJ @D95510, 
            FIN @D95509, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ORDER, 
   [COORD @D95518, AGR [CASE @D95517, COUNT @D95516, PER @D95515, 
            PLU @D95514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95523, AGR [CASE @D95522, COUNT @D95521, PER @D95520, 
            PLU @D95519, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95528, AGR [CASE @D95527, COUNT @D95526, PER @D95525, 
            PLU @D95524, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95533, AGR [CASE @D95532, COUNT @D95531, PER @D95530, 
            PLU @D95529, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95538, AGR [CASE @D95537, COUNT @D95536, PER @D95535, 
            PLU @D95534, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95543, AGR [CASE @D95542, COUNT @D95541, PER @D95540, 
            PLU @D95539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95549, AGR [CASE @D95548, NFORM @D95547, COUNT @D95546, 
            PER @D95545, PLU @D95544, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ORDER, 
   [COORD @D95554, AGR [UB @D95553, VFORM @D95552, SUBJ @D95551, 
            FIN @D95550, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ORDER, 
   [COORD @D95559, AGR [CASE @D95558, COUNT @D95557, PER @D95556, 
            PLU @D95555, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ORDER, 
   [COORD @D95564, AGR [CASE @D95563, COUNT @D95562, PER @D95561, 
            PLU @D95560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95569, AGR [CASE @D95568, COUNT @D95567, PER @D95566, 
            PLU @D95565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95574, AGR [CASE @D95573, COUNT @D95572, PER @D95571, 
            PLU @D95570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95579, AGR [CASE @D95578, COUNT @D95577, PER @D95576, 
            PLU @D95575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95584, AGR [CASE @D95583, COUNT @D95582, PER @D95581, 
            PLU @D95580, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95589, AGR [CASE @D95588, COUNT @D95587, PER @D95586, 
            PLU @D95585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95594, AGR [CASE @D95593, COUNT @D95592, PER @D95591, 
            PLU @D95590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ORDER.

WORD ordering : 
   [COORD @D95607, PRD @D95606, AGR [CASE @D95605, COUNT @D95604, 
            PER @D95603, PLU @D95602, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95613, PRD @D95612, 
      AGR [CASE @D95611, COUNT @D95610, PER @D95609, PLU @D95608, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ORDER, 
   [COORD @D95619, PRD @D95618, AGR [CASE @D95617, COUNT @D95616, 
            PER @D95615, PLU @D95614, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95625, PRD @D95624, 
      AGR [CASE @D95623, COUNT @D95622, PER @D95621, PLU @D95620, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ORDER, 
   [COORD @D95631, PRD @D95630, AGR [CASE @D95629, COUNT @D95628, 
            PER @D95627, PLU @D95626, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95637, PRD @D95636, 
      AGR [CASE @D95635, COUNT @D95634, PER @D95633, PLU @D95632, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ORDER, 
   [COORD @D95643, PRD @D95642, AGR [CASE @D95641, COUNT @D95640, 
            PER @D95639, PLU @D95638, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95649, PRD @D95648, 
      AGR [CASE @D95647, COUNT @D95646, PER @D95645, PLU @D95644, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ORDER, 
   [COORD @D95655, PRD @D95654, AGR [CASE @D95653, COUNT @D95652, 
            PER @D95651, PLU @D95650, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ORDER, 
   [COORD @D95661, PRD @D95660, 
      AGR [CASE @D95659, COUNT @D95658, PER @D95657, PLU @D95656, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ORDER.

WORD orders : 
   [COORD @D95668, AGR [COUNT @D95667, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95670, 
      AGR [COUNT @D95669, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95672, 
      AGR [COUNT @D95671, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95674, 
      AGR [COUNT @D95673, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95676, 
      AGR [COUNT @D95675, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95678, 
      AGR [COUNT @D95677, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95680, 
      AGR [COUNT @D95679, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95682, 
      AGR [COUNT @D95681, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95684, 
      AGR [COUNT @D95683, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER, 
   [COORD @D95686, 
      AGR [COUNT @D95685, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORDER.

WORD organise : 
   [COORD @D95693, AGR [COUNT @D95692, PER @D95691, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ORGANIZE, 
   [COORD @D95695, AGR [COUNT @D95694, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ORGANIZE, 
   [COORD @D95697, AGR [COUNT @D95696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ORGANIZE, 
   [COORD @D95701, AGR [COUNT @D95700, PER @D95699, PLU @D95698, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : ORGANIZE, 
   [COORD @D95707, PAST @D95706, AGR 
         [CASE @D95705, COUNT @D95704, PER @D95703, PLU @D95702, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : 
   ORGANIZE, 
   [COORD @D95710, AGR [COUNT @D95709, PER @D95708, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : ORGANIZE, 
   [COORD @D95712, AGR [COUNT @D95711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : ORGANIZE, 
   [COORD @D95714, AGR [COUNT @D95713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : ORGANIZE, 
   [COORD @D95718, AGR [COUNT @D95717, PER @D95716, PLU @D95715, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : ORGANIZE, 
   [COORD @D95724, PAST @D95723, 
      AGR [CASE @D95722, COUNT @D95721, PER @D95720, PLU @D95719, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM INTO, 
      ARITY 3] : ORGANIZE, 
   [COORD @D95727, AGR [COUNT @D95726, PER @D95725, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ORGANIZE, 
   [COORD @D95729, AGR [COUNT @D95728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ORGANIZE, 
   [COORD @D95731, AGR [COUNT @D95730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ORGANIZE, 
   [COORD @D95735, AGR [COUNT @D95734, PER @D95733, PLU @D95732, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ORGANIZE, 
   [COORD @D95741, PAST @D95740, AGR [CASE @D95739, COUNT @D95738, 
            PER @D95737, PLU @D95736, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ORGANIZE, 
   [COORD @D95744, AGR [COUNT @D95743, PER @D95742, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ORGANIZE, 
   [COORD @D95746, AGR [COUNT @D95745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ORGANIZE, 
   [COORD @D95748, AGR [COUNT @D95747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ORGANIZE, 
   [COORD @D95752, AGR [COUNT @D95751, PER @D95750, PLU @D95749, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ORGANIZE, 
   [COORD @D95758, PAST @D95757, AGR [CASE @D95756, COUNT @D95755, 
            PER @D95754, PLU @D95753, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ORGANIZE.

WORD organised : 
   [COADV @D95771, COORD @D95770, DEF @D95769, PRD @D95768, 
      AGR [CASE @D95767, COUNT @D95766, PER @D95765, PLU @D95764, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, 
      N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : ORGANIZED, 
   [COORD @D95776, 
      AGR [CASE @D95775, COUNT @D95774, PER @D95773, PLU @D95772, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ORGANIZE, 
   [COORD @D95781, AGR [CASE @D95780, COUNT @D95779, PER @D95778, 
            PLU @D95777, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95787, AGR [CASE @D95786, NFORM @D95785, COUNT @D95784, 
            PER @D95783, PLU @D95782, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95792, AGR [CASE @D95791, COUNT @D95790, PER @D95789, 
            PLU @D95788, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95797, AGR [CASE @D95796, COUNT @D95795, PER @D95794, 
            PLU @D95793, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95802, AGR [CASE @D95801, COUNT @D95800, PER @D95799, 
            PLU @D95798, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95807, AGR [CASE @D95806, COUNT @D95805, PER @D95804, 
            PLU @D95803, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95812, AGR [CASE @D95811, COUNT @D95810, PER @D95809, 
            PLU @D95808, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95817, AGR [CASE @D95816, COUNT @D95815, PER @D95814, 
            PLU @D95813, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95822, AGR [CASE @D95821, COUNT @D95820, PER @D95819, 
            PLU @D95818, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95827, AGR [CASE @D95826, COUNT @D95825, PER @D95824, 
            PLU @D95823, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ORGANIZE.

WORD organises : 
   [COORD @D95834, AGR [COUNT @D95833, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95836, 
      AGR [COUNT @D95835, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   ORGANIZE, 
   [COORD @D95838, AGR [COUNT @D95837, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95840, 
      AGR [COUNT @D95839, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ORGANIZE.

WORD organising : 
   [COORD @D95850, PRD @D95849, AGR [CASE @D95848, COUNT @D95847, 
            PER @D95846, PLU @D95845, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95856, PRD @D95855, 
      AGR [CASE @D95854, COUNT @D95853, PER @D95852, PLU @D95851, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ORGANIZE, 
   [COORD @D95862, PRD @D95861, AGR [CASE @D95860, COUNT @D95859, 
            PER @D95858, PLU @D95857, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ORGANIZE, 
   [COORD @D95868, PRD @D95867, 
      AGR [CASE @D95866, COUNT @D95865, PER @D95864, PLU @D95863, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   ORGANIZE.

WORD outlook : 
   [COORD @D95876, REFL @D95875, COUNT @D95874, PRD @D95873, 
      CASE @D95872, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : OUTLOOK, 
   [COORD @D95880, REFL @D95879, PRD @D95878, CASE @D95877, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : OUTLOOK.

WORD outlooks : 
   [COORD @D95889, DEMON @D95888, REFL @D95887, PRD @D95886, 
      CASE @D95885, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : OUTLOOK, 
   
   [COORD @D95894, DEMON @D95893, REFL @D95892, PRD @D95891, CASE 
      @D95890, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   OUTLOOK.

WORD own : 
   [COORD @D95899, AGR [COUNT @D95898, PER @D95897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OWN, 
   [COORD @D95901, AGR [COUNT @D95900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OWN, 
   [COORD @D95903, AGR [COUNT @D95902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OWN, 
   [COORD @D95907, AGR [COUNT @D95906, PER @D95905, PLU @D95904, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : OWN, 
   [COORD @D95913, PAST @D95912, AGR [CASE @D95911, COUNT @D95910, 
            PER @D95909, PLU @D95908, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : OWN, 
   [COORD @D95916, AGR [COUNT @D95915, PER @D95914, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : OWN, 
   [COORD @D95918, AGR [COUNT @D95917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : OWN, 
   [COORD @D95920, AGR [COUNT @D95919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : OWN, 
   [COORD @D95924, AGR [COUNT @D95923, PER @D95922, PLU @D95921, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : OWN, 
   [COORD @D95930, PAST @D95929, AGR [CASE @D95928, COUNT @D95927, 
            PER @D95926, PLU @D95925, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_NP, ARITY 2] : OWN, 
   [COORD @D95933, AGR [COUNT @D95932, PER @D95931, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OWN, 
   [COORD @D95935, AGR [COUNT @D95934, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OWN, 
   [COORD @D95937, AGR [COUNT @D95936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OWN, 
   [COORD @D95941, AGR [COUNT @D95940, PER @D95939, PLU @D95938, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : OWN, 
   [COORD @D95947, PAST @D95946, AGR [CASE @D95945, COUNT @D95944, 
            PER @D95943, PLU @D95942, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : OWN, 
   [COORD @D95950, AGR [COUNT @D95949, PER @D95948, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OWN, 
   [COORD @D95952, AGR [COUNT @D95951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OWN, 
   [COORD @D95954, AGR [COUNT @D95953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : OWN, 
   [COORD @D95958, AGR [COUNT @D95957, PER @D95956, PLU @D95955, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : OWN, 
   [COORD @D95964, PAST @D95963, AGR [CASE @D95962, COUNT @D95961, 
            PER @D95960, PLU @D95959, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : OWN, 
   [COORD @D95967, AGR [COUNT @D95966, PER @D95965, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP TO, ARITY 2] : OWN, 
   [COORD @D95969, AGR [COUNT @D95968, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP TO, ARITY 2] : OWN, 
   [COORD @D95971, AGR [COUNT @D95970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP TO, ARITY 2] : OWN, 
   [COORD @D95975, AGR [COUNT @D95974, PER @D95973, PLU @D95972, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP TO, ARITY 2] : OWN, 
   [COORD @D95981, PAST @D95980, 
      AGR [CASE @D95979, COUNT @D95978, PER @D95977, PLU @D95976, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP TO, ARITY 2] : OWN, 
   [COORD @D95984, AGR [COUNT @D95983, PER @D95982, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : OWN, 
   [COORD @D95986, AGR [COUNT @D95985, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : OWN, 
   [COORD @D95988, AGR [COUNT @D95987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : OWN, 
   [COORD @D95992, AGR [COUNT @D95991, PER @D95990, PLU @D95989, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : OWN, 
   [COORD @D95998, PAST @D95997, 
      AGR [CASE @D95996, COUNT @D95995, PER @D95994, PLU @D95993, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      ARITY 2] : OWN, 
   [COORD @D96001, AGR [COUNT @D96000, PER @D95999, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : OWN, 
   [COORD @D96003, AGR [COUNT @D96002, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : OWN, 
   [COORD @D96005, AGR [COUNT @D96004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : OWN, 
   [COORD @D96009, AGR [COUNT @D96008, PER @D96007, PLU @D96006, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : OWN, 
   [COORD @D96015, PAST @D96014, 
      AGR [CASE @D96013, COUNT @D96012, PER @D96011, PLU @D96010, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : OWN, 
   [COORD @D96018, AGR [COUNT @D96017, PER @D96016, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OWN, 
   [COORD @D96020, AGR [COUNT @D96019, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OWN, 
   [COORD @D96022, AGR [COUNT @D96021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OWN, 
   [COORD @D96026, AGR [COUNT @D96025, PER @D96024, PLU @D96023, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : OWN, 
   [COORD @D96032, PAST @D96031, 
      AGR [CASE @D96030, COUNT @D96029, PER @D96028, PLU @D96027, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : OWN.

WORD owned : 
   [COORD @D96040, AGR [UB @D96039, VFORM @D96038, SUBJ @D96037, 
            FIN @D96036, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OWN, 
   [COORD @D96045, AGR [CASE @D96044, COUNT @D96043, PER @D96042, 
            PLU @D96041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96050, AGR [CASE @D96049, COUNT @D96048, PER @D96047, 
            PLU @D96046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OWN, 
   [COORD @D96055, AGR [CASE @D96054, COUNT @D96053, PER @D96052, 
            PLU @D96051, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OWN, 
   [COORD @D96060, AGR [CASE @D96059, COUNT @D96058, PER @D96057, 
            PLU @D96056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96065, AGR [CASE @D96064, COUNT @D96063, PER @D96062, 
            PLU @D96061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OWN, 
   [COORD @D96070, AGR [CASE @D96069, COUNT @D96068, PER @D96067, 
            PLU @D96066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96075, AGR [CASE @D96074, COUNT @D96073, PER @D96072, 
            PLU @D96071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OWN, 
   [COORD @D96081, AGR [CASE @D96080, NFORM @D96079, COUNT @D96078, 
            PER @D96077, PLU @D96076, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OWN, 
   [COORD @D96086, AGR [UB @D96085, VFORM @D96084, SUBJ @D96083, 
            FIN @D96082, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : OWN, 
   [COORD @D96091, AGR [CASE @D96090, COUNT @D96089, PER @D96088, 
            PLU @D96087, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96096, AGR [CASE @D96095, COUNT @D96094, PER @D96093, 
            PLU @D96092, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : OWN, 
   [COORD @D96101, AGR [CASE @D96100, COUNT @D96099, PER @D96098, 
            PLU @D96097, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : OWN, 
   [COORD @D96106, AGR [CASE @D96105, COUNT @D96104, PER @D96103, 
            PLU @D96102, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96111, AGR [CASE @D96110, COUNT @D96109, PER @D96108, 
            PLU @D96107, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OWN, 
   [COORD @D96116, AGR [CASE @D96115, COUNT @D96114, PER @D96113, 
            PLU @D96112, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96121, AGR [CASE @D96120, COUNT @D96119, PER @D96118, 
            PLU @D96117, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OWN, 
   [COORD @D96126, AGR [CASE @D96125, COUNT @D96124, PER @D96123, 
            PLU @D96122, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96131, AGR [CASE @D96130, COUNT @D96129, PER @D96128, 
            PLU @D96127, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96136, AGR [CASE @D96135, COUNT @D96134, PER @D96133, 
            PLU @D96132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : OWN, 
   [COORD @D96141, AGR [CASE @D96140, COUNT @D96139, PER @D96138, 
            PLU @D96137, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96146, AGR [CASE @D96145, COUNT @D96144, PER @D96143, 
            PLU @D96142, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : OWN.

WORD owning : 
   [COORD @D96157, PRD @D96156, AGR [CASE @D96155, COUNT @D96154, 
            PER @D96153, PLU @D96152, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96163, PRD @D96162, AGR 
         [CASE @D96161, COUNT @D96160, PER @D96159, PLU @D96158, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : OWN, 
   
   [COORD @D96169, PRD @D96168, AGR [CASE @D96167, COUNT @D96166, PER 
               @D96165, PLU @D96164, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96175, PRD @D96174, AGR 
         [CASE @D96173, COUNT @D96172, PER @D96171, PLU @D96170, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : OWN, 
   
   [COORD @D96181, PRD @D96180, AGR [CASE @D96179, COUNT @D96178, PER 
               @D96177, PLU @D96176, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96187, PRD @D96186, 
      AGR [CASE @D96185, COUNT @D96184, PER @D96183, PLU @D96182, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OWN, 
   [COORD @D96193, PRD @D96192, AGR [CASE @D96191, COUNT @D96190, 
            PER @D96189, PLU @D96188, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : OWN, 
   [COORD @D96199, PRD @D96198, 
      AGR [CASE @D96197, COUNT @D96196, PER @D96195, PLU @D96194, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : OWN.

WORD owns : 
   [COORD @D96204, AGR [COUNT @D96203, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OWN, 
   [COORD @D96206, 
      AGR [COUNT @D96205, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OWN, 
   [COORD @D96208, 
      AGR [COUNT @D96207, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OWN, 
   [COORD @D96210, 
      AGR [COUNT @D96209, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OWN, 
   [COORD @D96212, 
      AGR [COUNT @D96211, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OWN, 
   [COORD @D96214, 
      AGR [COUNT @D96213, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OWN, 
   [COORD @D96216, 
      AGR [COUNT @D96215, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   OWN, 
   [COORD @D96218, AGR [COUNT @D96217, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : OWN.

WORD pack : 
   [COORD @D96223, AGR [COUNT @D96222, PER @D96221, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PACK, 
   [COORD @D96225, AGR [COUNT @D96224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PACK, 
   [COORD @D96227, AGR [COUNT @D96226, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PACK, 
   [COORD @D96231, AGR [COUNT @D96230, PER @D96229, PLU @D96228, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PACK, 
   [COORD @D96237, PAST @D96236, AGR [CASE @D96235, COUNT @D96234, 
            PER @D96233, PLU @D96232, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : PACK, 
   [COORD @D96240, AGR [COUNT @D96239, PER @D96238, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PACK, 
   [COORD @D96242, AGR [COUNT @D96241, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PACK, 
   [COORD @D96244, AGR [COUNT @D96243, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PACK, 
   [COORD @D96248, AGR [COUNT @D96247, PER @D96246, PLU @D96245, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PACK, 
   [COORD @D96254, PAST @D96253, AGR [CASE @D96252, COUNT @D96251, 
            PER @D96250, PLU @D96249, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PACK, 
   [COORD @D96257, AGR [COUNT @D96256, PER @D96255, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PACK, 
   [COORD @D96259, AGR [COUNT @D96258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PACK, 
   [COORD @D96261, AGR [COUNT @D96260, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PACK, 
   [COORD @D96265, AGR [COUNT @D96264, PER @D96263, PLU @D96262, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PACK, 
   [COORD @D96271, PAST @D96270, 
      AGR [CASE @D96269, COUNT @D96268, PER @D96267, PLU @D96266, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : PACK, 
   [COORD @D96274, AGR [COUNT @D96273, PER @D96272, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM TO, ARITY 3] : PACK, 
   [COORD @D96276, AGR [COUNT @D96275, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM TO, ARITY 3] : PACK, 
   [COORD @D96278, AGR [COUNT @D96277, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM TO, ARITY 3] : PACK, 
   [COORD @D96282, AGR [COUNT @D96281, PER @D96280, PLU @D96279, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM TO, ARITY 3] : PACK, 
   [COORD @D96288, PAST @D96287, 
      AGR [CASE @D96286, COUNT @D96285, PER @D96284, PLU @D96283, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM TO, ARITY 3] : PACK, 
   [COORD @D96291, AGR [COUNT @D96290, PER @D96289, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PACK, 
   [COORD @D96293, AGR [COUNT @D96292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PACK, 
   [COORD @D96295, AGR [COUNT @D96294, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PACK, 
   [COORD @D96299, AGR [COUNT @D96298, PER @D96297, PLU @D96296, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PACK, 
   [COORD @D96305, PAST @D96304, AGR [CASE @D96303, COUNT @D96302, 
            PER @D96301, PLU @D96300, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PACK, 
   [COORD @D96308, AGR [COUNT @D96307, PER @D96306, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PACK, 
   [COORD @D96310, AGR [COUNT @D96309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PACK, 
   [COORD @D96312, AGR [COUNT @D96311, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PACK, 
   [COORD @D96316, AGR [COUNT @D96315, PER @D96314, PLU @D96313, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PACK, 
   [COORD @D96322, PAST @D96321, AGR [CASE @D96320, COUNT @D96319, 
            PER @D96318, PLU @D96317, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : PACK, 
   [COORD @D96325, AGR [COUNT @D96324, PER @D96323, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PACK, 
   [COORD @D96327, AGR [COUNT @D96326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PACK, 
   [COORD @D96329, AGR [COUNT @D96328, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PACK, 
   [COORD @D96333, AGR [COUNT @D96332, PER @D96331, PLU @D96330, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : PACK, 
   [COORD @D96339, PAST @D96338, 
      AGR [CASE @D96337, COUNT @D96336, PER @D96335, PLU @D96334, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PACK, 
   [COORD @D96342, AGR [COUNT @D96341, PER @D96340, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PACK, 
   [COORD @D96344, AGR [COUNT @D96343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PACK, 
   [COORD @D96346, AGR [COUNT @D96345, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PACK, 
   [COORD @D96350, AGR [COUNT @D96349, PER @D96348, PLU @D96347, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : PACK, 
   [COORD @D96356, PAST @D96355, 
      AGR [CASE @D96354, COUNT @D96353, PER @D96352, PLU @D96351, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : PACK, 
   [COORD @D96359, AGR [COUNT @D96358, PER @D96357, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PACK, 
   [COORD @D96361, AGR [COUNT @D96360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PACK, 
   [COORD @D96363, AGR [COUNT @D96362, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PACK, 
   [COORD @D96367, AGR [COUNT @D96366, PER @D96365, PLU @D96364, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : PACK, 
   [COORD @D96373, PAST @D96372, 
      AGR [CASE @D96371, COUNT @D96370, PER @D96369, PLU @D96368, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : PACK, 
   [COORD @D96376, AGR [COUNT @D96375, PER @D96374, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PACK, 
   [COORD @D96378, AGR [COUNT @D96377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PACK, 
   [COORD @D96380, AGR [COUNT @D96379, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PACK, 
   [COORD @D96384, AGR [COUNT @D96383, PER @D96382, PLU @D96381, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : PACK, 
   [COORD @D96390, PAST @D96389, 
      AGR [CASE @D96388, COUNT @D96387, PER @D96386, PLU @D96385, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PACK, 
   [COORD @D96393, AGR [COUNT @D96392, PER @D96391, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PACK, 
   [COORD @D96395, AGR [COUNT @D96394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PACK, 
   [COORD @D96397, AGR [COUNT @D96396, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PACK, 
   [COORD @D96401, AGR [COUNT @D96400, PER @D96399, PLU @D96398, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PACK, 
   [COORD @D96407, PAST @D96406, AGR [CASE @D96405, COUNT @D96404, 
            PER @D96403, PLU @D96402, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PACK, 
   [COORD @D96410, AGR [COUNT @D96409, PER @D96408, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PACK, 
   [COORD @D96412, AGR [COUNT @D96411, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PACK, 
   [COORD @D96414, AGR [COUNT @D96413, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PACK, 
   [COORD @D96418, AGR [COUNT @D96417, PER @D96416, PLU @D96415, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PACK, 
   [COORD @D96424, PAST @D96423, 
      AGR [CASE @D96422, COUNT @D96421, PER @D96420, PLU @D96419, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : PACK, 
   [COORD @D96427, AGR [COUNT @D96426, PER @D96425, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PACK, 
   [COORD @D96429, AGR [COUNT @D96428, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PACK, 
   [COORD @D96431, AGR [COUNT @D96430, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PACK, 
   [COORD @D96435, AGR [COUNT @D96434, PER @D96433, PLU @D96432, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PACK, 
   [COORD @D96441, PAST @D96440, 
      AGR [CASE @D96439, COUNT @D96438, PER @D96437, PLU @D96436, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT TOGETHER, 
      ARITY 1] : PACK, 
   [COORD @D96444, AGR [COUNT @D96443, PER @D96442, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PACK, 
   [COORD @D96446, AGR [COUNT @D96445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PACK, 
   [COORD @D96448, AGR [COUNT @D96447, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PACK, 
   [COORD @D96452, AGR [COUNT @D96451, PER @D96450, PLU @D96449, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PACK, 
   [COORD @D96458, PAST @D96457, 
      AGR [CASE @D96456, COUNT @D96455, PER @D96454, PLU @D96453, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : PACK, 
   [COORD @D96461, AGR [COUNT @D96460, PER @D96459, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PACK, 
   [COORD @D96463, AGR [COUNT @D96462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PACK, 
   [COORD @D96465, AGR [COUNT @D96464, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PACK, 
   [COORD @D96469, AGR [COUNT @D96468, PER @D96467, PLU @D96466, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PACK, 
   [COORD @D96475, PAST @D96474, 
      AGR [CASE @D96473, COUNT @D96472, PER @D96471, PLU @D96470, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT IN, 
      ARITY 1] : PACK, 
   [COORD @D96478, AGR [COUNT @D96477, PER @D96476, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PACK, 
   [COORD @D96480, AGR [COUNT @D96479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PACK, 
   [COORD @D96482, AGR [COUNT @D96481, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PACK, 
   [COORD @D96486, AGR [COUNT @D96485, PER @D96484, PLU @D96483, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PACK, 
   [COORD @D96492, PAST @D96491, 
      AGR [CASE @D96490, COUNT @D96489, PER @D96488, PLU @D96487, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : PACK.

WORD packed : 
   [COADV @D96503, COORD @D96502, DEF @D96501, PRD @D96500, AGR 
            [CASE @D96499, COUNT @D96498, PER @D96497, PLU @D96496, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   PACKED, 
   [COORD @D96508, AGR [CASE @D96507, COUNT @D96506, PER @D96505, 
            PLU @D96504, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PACK, 
   [COORD @D96513, AGR [CASE @D96512, COUNT @D96511, PER @D96510, 
            PLU @D96509, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96518, AGR [CASE @D96517, COUNT @D96516, PER @D96515, 
            PLU @D96514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96523, AGR [CASE @D96522, COUNT @D96521, PER @D96520, 
            PLU @D96519, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PACK, 
   [COORD @D96528, AGR [CASE @D96527, COUNT @D96526, PER @D96525, 
            PLU @D96524, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96533, AGR [CASE @D96532, COUNT @D96531, PER @D96530, 
            PLU @D96529, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96538, AGR [CASE @D96537, COUNT @D96536, PER @D96535, 
            PLU @D96534, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96543, AGR [CASE @D96542, COUNT @D96541, PER @D96540, 
            PLU @D96539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96548, AGR [CASE @D96547, COUNT @D96546, PER @D96545, 
            PLU @D96544, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96553, AGR [CASE @D96552, COUNT @D96551, PER @D96550, 
            PLU @D96549, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96558, AGR [CASE @D96557, COUNT @D96556, PER @D96555, 
            PLU @D96554, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96563, 
      AGR [CASE @D96562, COUNT @D96561, PER @D96560, PLU @D96559, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96568, AGR [CASE @D96567, COUNT @D96566, PER @D96565, 
            PLU @D96564, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PACK, 
   [COORD @D96573, AGR [CASE @D96572, COUNT @D96571, PER @D96570, 
            PLU @D96569, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96578, AGR [CASE @D96577, COUNT @D96576, PER @D96575, 
            PLU @D96574, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96583, AGR [CASE @D96582, COUNT @D96581, PER @D96580, 
            PLU @D96579, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96588, AGR [CASE @D96587, COUNT @D96586, PER @D96585, 
            PLU @D96584, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96593, AGR [CASE @D96592, COUNT @D96591, PER @D96590, 
            PLU @D96589, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96598, AGR [CASE @D96597, COUNT @D96596, PER @D96595, 
            PLU @D96594, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96603, AGR [CASE @D96602, COUNT @D96601, PER @D96600, 
            PLU @D96599, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96608, AGR [CASE @D96607, COUNT @D96606, PER @D96605, 
            PLU @D96604, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96613, AGR [CASE @D96612, COUNT @D96611, PER @D96610, 
            PLU @D96609, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96618, AGR [CASE @D96617, COUNT @D96616, PER @D96615, 
            PLU @D96614, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96623, AGR [CASE @D96622, COUNT @D96621, PER @D96620, 
            PLU @D96619, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96628, AGR [CASE @D96627, COUNT @D96626, PER @D96625, 
            PLU @D96624, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96633, AGR [CASE @D96632, COUNT @D96631, PER @D96630, 
            PLU @D96629, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96638, AGR [CASE @D96637, COUNT @D96636, PER @D96635, 
            PLU @D96634, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96643, AGR [CASE @D96642, COUNT @D96641, PER @D96640, 
            PLU @D96639, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96648, AGR [CASE @D96647, COUNT @D96646, PER @D96645, 
            PLU @D96644, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96653, AGR [CASE @D96652, COUNT @D96651, PER @D96650, 
            PLU @D96649, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96658, AGR [CASE @D96657, COUNT @D96656, PER @D96655, 
            PLU @D96654, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96663, AGR [CASE @D96662, COUNT @D96661, PER @D96660, 
            PLU @D96659, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96668, AGR [CASE @D96667, COUNT @D96666, PER @D96665, 
            PLU @D96664, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96673, AGR [CASE @D96672, COUNT @D96671, PER @D96670, 
            PLU @D96669, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96678, AGR [CASE @D96677, COUNT @D96676, PER @D96675, 
            PLU @D96674, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96683, AGR [CASE @D96682, COUNT @D96681, PER @D96680, 
            PLU @D96679, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96688, AGR [CASE @D96687, COUNT @D96686, PER @D96685, 
            PLU @D96684, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96693, AGR [CASE @D96692, COUNT @D96691, PER @D96690, 
            PLU @D96689, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96698, AGR [CASE @D96697, COUNT @D96696, PER @D96695, 
            PLU @D96694, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PACK, 
   [COORD @D96703, AGR [CASE @D96702, COUNT @D96701, PER @D96700, 
            PLU @D96699, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96708, AGR [CASE @D96707, COUNT @D96706, PER @D96705, 
            PLU @D96704, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PACK.

WORD packing : 
   [COORD @D96717, REFL @D96716, PRD @D96715, CASE @D96714, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : PACKING, 
   [COORD @D96723, PRD @D96722, 
      AGR [CASE @D96721, COUNT @D96720, PER @D96719, PLU @D96718, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PACK, 
   [COORD @D96729, PRD @D96728, AGR [CASE @D96727, COUNT @D96726, 
            PER @D96725, PLU @D96724, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96735, PRD @D96734, 
      AGR [CASE @D96733, COUNT @D96732, PER @D96731, PLU @D96730, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PACK, 
   [COORD @D96741, PRD @D96740, AGR [CASE @D96739, COUNT @D96738, 
            PER @D96737, PLU @D96736, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96747, PRD @D96746, 
      AGR [CASE @D96745, COUNT @D96744, PER @D96743, PLU @D96742, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PACK, 
   [COORD @D96753, PRD @D96752, AGR [CASE @D96751, COUNT @D96750, 
            PER @D96749, PLU @D96748, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96759, PRD @D96758, 
      AGR [CASE @D96757, COUNT @D96756, PER @D96755, PLU @D96754, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PACK, 
   [COORD @D96765, PRD @D96764, AGR [CASE @D96763, COUNT @D96762, 
            PER @D96761, PLU @D96760, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96771, PRD @D96770, 
      AGR [CASE @D96769, COUNT @D96768, PER @D96767, PLU @D96766, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PACK, 
   [COORD @D96777, PRD @D96776, AGR [CASE @D96775, COUNT @D96774, 
            PER @D96773, PLU @D96772, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96783, PRD @D96782, 
      AGR [CASE @D96781, COUNT @D96780, PER @D96779, PLU @D96778, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PACK, 
   [COORD @D96789, PRD @D96788, AGR [CASE @D96787, COUNT @D96786, 
            PER @D96785, PLU @D96784, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96795, PRD @D96794, 
      AGR [CASE @D96793, COUNT @D96792, PER @D96791, PLU @D96790, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PACK, 
   [COORD @D96801, PRD @D96800, AGR [CASE @D96799, COUNT @D96798, 
            PER @D96797, PLU @D96796, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK, 
   [COORD @D96807, PRD @D96806, 
      AGR [CASE @D96805, COUNT @D96804, PER @D96803, PLU @D96802, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PACK, 
   [COORD @D96813, PRD @D96812, AGR [CASE @D96811, COUNT @D96810, 
            PER @D96809, PLU @D96808, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PACK.

WORD packs : 
   [COORD @D96825, AGR [COUNT @D96824, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96827, 
      AGR [COUNT @D96826, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96829, 
      AGR [COUNT @D96828, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96831, 
      AGR [COUNT @D96830, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PACK, 
   [COORD @D96833, AGR [COUNT @D96832, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96835, 
      AGR [COUNT @D96834, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96837, 
      AGR [COUNT @D96836, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96839, 
      AGR [COUNT @D96838, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96841, 
      AGR [COUNT @D96840, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96843, 
      AGR [COUNT @D96842, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96845, 
      AGR [COUNT @D96844, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96847, 
      AGR [COUNT @D96846, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96849, 
      AGR [COUNT @D96848, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PACK, 
   [COORD @D96851, AGR [COUNT @D96850, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96853, 
      AGR [COUNT @D96852, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK, 
   [COORD @D96855, 
      AGR [COUNT @D96854, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PACK.

WORD paid : 
   [COORD @D96865, PAST @D96864, AGR [CASE @D96863, COUNT @D96862, 
            PER @D96861, PLU @D96860, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : PAY, 
   [COORD @D96871, PAST @D96870, 
      AGR [CASE @D96869, COUNT @D96868, PER @D96867, PLU @D96866, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, ARITY 3] : 
   PAY, 
   [COORD @D96877, PAST @D96876, AGR [CASE @D96875, COUNT @D96874, 
            PER @D96873, PLU @D96872, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : PAY, 
   [COORD @D96883, PAST @D96882, 
      AGR [CASE @D96881, COUNT @D96880, PER @D96879, PLU @D96878, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, ARITY 3] : PAY, 
   [COORD @D96889, PAST @D96888, 
      AGR [CASE @D96887, COUNT @D96886, PER @D96885, PLU @D96884, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT BACK, 
      FIN -, ARITY 3] : PAY, 
   [COORD @D96895, PAST @D96894, AGR [CASE @D96893, COUNT @D96892, 
            PER @D96891, PLU @D96890, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT BACK, FIN -, ARITY 3] : PAY, 
   [COORD @D96901, PAST @D96900, 
      AGR [CASE @D96899, COUNT @D96898, PER @D96897, PLU @D96896, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, FIN -, 
      ARITY 3] : PAY, 
   [COORD @D96907, PAST @D96906, AGR [CASE @D96905, COUNT @D96904, 
            PER @D96903, PLU @D96902, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : PAY, 
   [COORD @D96913, PAST @D96912, 
      AGR [CASE @D96911, COUNT @D96910, PER @D96909, PLU @D96908, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PRT BACK, PFORM TO, 
      FIN -, ARITY 3] : PAY, 
   [COORD @D96919, PAST @D96918, AGR [CASE @D96917, COUNT @D96916, 
            PER @D96915, PLU @D96914, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PRT BACK, PFORM TO, FIN -, ARITY 3] : PAY, 
   [COORD @D96925, PAST @D96924, 
      AGR [CASE @D96923, COUNT @D96922, PER @D96921, PLU @D96920, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, FIN -, 
      ARITY 3] : PAY, 
   [COORD @D96931, PAST @D96930, AGR [CASE @D96929, COUNT @D96928, 
            PER @D96927, PLU @D96926, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : PAY, 
   [COORD @D96937, PAST @D96936, 
      AGR [CASE @D96935, COUNT @D96934, PER @D96933, PLU @D96932, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      FIN -, ARITY 3] : PAY, 
   [COORD @D96943, PAST @D96942, AGR [CASE @D96941, COUNT @D96940, 
            PER @D96939, PLU @D96938, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : PAY, 
   [COORD @D96949, PAST @D96948, 
      AGR [CASE @D96947, COUNT @D96946, PER @D96945, PLU @D96944, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, PFORM TO, 
      FIN -, ARITY 3] : PAY, 
   [COORD @D96955, PAST @D96954, AGR [CASE @D96953, COUNT @D96952, 
            PER @D96951, PLU @D96950, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, PFORM TO, FIN -, ARITY 3] : PAY, 
   [COORD @D96961, PAST @D96960, 
      AGR [CASE @D96959, COUNT @D96958, PER @D96957, PLU @D96956, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      PFORM FOR, FIN -, ARITY 3] : PAY, 
   [COORD @D96967, PAST @D96966, AGR [CASE @D96965, COUNT @D96964, 
            PER @D96963, PLU @D96962, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, PFORM FOR, FIN -, ARITY 3] : PAY, 
   [COORD @D96971, 
      AGR [COUNT @D96970, PER @D96969, PLU @D96968, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PAST +, 
      ARITY 3] : PAY, 
   [COORD @D96975, AGR [COUNT @D96974, PER @D96973, PLU @D96972, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : PAY, 
   [COORD @D96979, AGR [COUNT @D96978, PER @D96977, PLU @D96976, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT BACK, PAST +, ARITY 3] : PAY, 
   [COORD @D96983, AGR [COUNT @D96982, PER @D96981, PLU @D96980, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, PAST +, ARITY 3] : PAY, 
   [COORD @D96987, AGR [COUNT @D96986, PER @D96985, PLU @D96984, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT BACK, PFORM TO, PAST +, ARITY 3] : PAY, 
   [COORD @D96991, AGR 
         [COUNT @D96990, PER @D96989, PLU @D96988, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM INTO, PAST +, ARITY 3] : PAY, 
   [COORD @D96995, AGR [COUNT @D96994, PER @D96993, PLU @D96992, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FOR, PAST +, ARITY 3] : PAY, 
   [COORD @D96999, AGR [COUNT @D96998, PER @D96997, PLU @D96996, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PFORM TO, PAST +, ARITY 3] : PAY, 
   [COORD @D97003, AGR [COUNT @D97002, PER @D97001, PLU @D97000, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM FOR, PAST +, ARITY 3] : PAY, 
   [COORD @D97009, PAST @D97008, 
      AGR [CASE @D97007, COUNT @D97006, PER @D97005, PLU @D97004, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, FIN -, ARITY 2] : PAY, 
   
   [COORD @D97015, PAST @D97014, AGR [CASE @D97013, COUNT @D97012, PER 
               @D97011, PLU @D97010, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : PAY, 
   [COORD @D97021, PAST @D97020, 
      AGR [CASE @D97019, COUNT @D97018, PER @D97017, PLU @D97016, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, ARITY 2] : PAY, 
   [COORD @D97027, PAST @D97026, 
      AGR [CASE @D97025, COUNT @D97024, PER @D97023, PLU @D97022, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, FIN -, ARITY 2] : PAY, 
   [COORD @D97033, PAST @D97032, 
      AGR [CASE @D97031, COUNT @D97030, PER @D97029, PLU @D97028, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM FOR, FIN -, 
      ARITY 2] : PAY, 
   [COORD @D97039, PAST @D97038, AGR [CASE @D97037, COUNT @D97036, 
            PER @D97035, PLU @D97034, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM FOR, FIN -, ARITY 2] : PAY, 
   [COORD @D97045, PAST @D97044, 
      AGR [CASE @D97043, COUNT @D97042, PER @D97041, PLU @D97040, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : PAY, 
   [COORD @D97051, PAST @D97050, AGR [CASE @D97049, COUNT @D97048, 
            PER @D97047, PLU @D97046, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : PAY, 
   [COORD @D97057, PAST @D97056, 
      AGR [CASE @D97055, COUNT @D97054, PER @D97053, PLU @D97052, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : PAY, 
   [COORD @D97063, PAST @D97062, AGR [CASE @D97061, COUNT @D97060, 
            PER @D97059, PLU @D97058, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : PAY, 
   [COORD @D97069, PAST @D97068, 
      AGR [CASE @D97067, COUNT @D97066, PER @D97065, PLU @D97064, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : PAY, 
   [COORD @D97075, PAST @D97074, AGR [CASE @D97073, COUNT @D97072, 
            PER @D97071, PLU @D97070, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : PAY, 
   [COORD @D97081, PAST @D97080, 
      AGR [CASE @D97079, COUNT @D97078, PER @D97077, PLU @D97076, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : PAY, 
   [COORD @D97087, PAST @D97086, AGR [CASE @D97085, COUNT @D97084, 
            PER @D97083, PLU @D97082, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : PAY, 
   [COORD @D97093, PAST @D97092, 
      AGR [CASE @D97091, COUNT @D97090, PER @D97089, PLU @D97088, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : PAY, 
   [COORD @D97099, PAST @D97098, AGR [CASE @D97097, COUNT @D97096, 
            PER @D97095, PLU @D97094, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : PAY, 
   [COORD @D97103, 
      AGR [COUNT @D97102, PER @D97101, PLU @D97100, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, PAST +, 
      ARITY 2] : PAY, 
   [COORD @D97107, AGR [COUNT @D97106, PER @D97105, PLU @D97104, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : PAY, 
   [COORD @D97111, AGR [COUNT @D97110, PER @D97109, PLU @D97108, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, 
      PAST +, ARITY 2] : PAY, 
   [COORD @D97115, AGR [COUNT @D97114, PER @D97113, PLU @D97112, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : PAY, 
   [COORD @D97119, AGR [COUNT @D97118, PER @D97117, PLU @D97116, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PAST +, ARITY 2] : PAY, 
   [COORD @D97123, AGR [COUNT @D97122, PER @D97121, PLU @D97120, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PAST +, ARITY 2] : PAY, 
   [COORD @D97127, AGR [COUNT @D97126, PER @D97125, PLU @D97124, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, PAST +, ARITY 2] : PAY, 
   [COORD @D97131, AGR [COUNT @D97130, PER @D97129, PLU @D97128, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, PAST +, ARITY 2] : PAY, 
   [COORD @D97135, AGR [COUNT @D97134, PER @D97133, PLU @D97132, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PAST +, ARITY 2] : PAY, 
   [COORD @D97141, PAST @D97140, AGR [CASE @D97139, COUNT @D97138, 
            PER @D97137, PLU @D97136, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : PAY, 
   [COORD @D97147, PAST @D97146, 
      AGR [CASE @D97145, COUNT @D97144, PER @D97143, PLU @D97142, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, FIN -, 
      ARITY 1] : PAY, 
   [COORD @D97153, PAST @D97152, AGR [CASE @D97151, COUNT @D97150, 
            PER @D97149, PLU @D97148, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, FIN -, ARITY 1] : PAY, 
   [COORD @D97159, PAST @D97158, 
      AGR [CASE @D97157, COUNT @D97156, PER @D97155, PLU @D97154, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, FIN -, 
      ARITY 1] : PAY, 
   [COORD @D97165, PAST @D97164, AGR [CASE @D97163, COUNT @D97162, 
            PER @D97161, PLU @D97160, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : PAY, 
   [COORD @D97171, PAST @D97170, 
      AGR [CASE @D97169, COUNT @D97168, PER @D97167, PLU @D97166, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, FIN -, 
      ARITY 1] : PAY, 
   [COORD @D97177, PAST @D97176, AGR [CASE @D97175, COUNT @D97174, 
            PER @D97173, PLU @D97172, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, FIN -, ARITY 1] : PAY, 
   [COORD @D97181, 
      AGR [COUNT @D97180, PER @D97179, PLU @D97178, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : PAY, 
   [COORD @D97185, AGR [COUNT @D97184, PER @D97183, PLU @D97182, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : PAY, 
   [COORD @D97189, AGR [COUNT @D97188, PER @D97187, PLU @D97186, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : PAY, 
   [COORD @D97193, AGR [COUNT @D97192, PER @D97191, PLU @D97190, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : PAY, 
   [COORD @D97197, AGR [COUNT @D97196, PER @D97195, PLU @D97194, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : PAY, 
   [COORD @D97201, AGR [COUNT @D97200, PER @D97199, PLU @D97198, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : PAY, 
   [COORD @D97205, AGR [COUNT @D97204, PER @D97203, PLU @D97202, BAR 2, 
            V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : PAY.

WORD paint : 
   [COORD @D97227, AGR [COUNT @D97226, PER @D97225, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : PAINT, 
   [COORD @D97229, AGR [COUNT @D97228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : PAINT, 
   [COORD @D97231, AGR [COUNT @D97230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : PAINT, 
   [COORD @D97235, AGR [COUNT @D97234, PER @D97233, PLU @D97232, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : PAINT, 
   [COORD @D97241, PAST @D97240, AGR [CASE @D97239, COUNT @D97238, 
            PER @D97237, PLU @D97236, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_NP, ARITY 3] : PAINT, 
   [COORD @D97244, AGR [COUNT @D97243, PER @D97242, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PAINT, 
   [COORD @D97246, AGR [COUNT @D97245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PAINT, 
   [COORD @D97248, AGR [COUNT @D97247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PAINT, 
   [COORD @D97252, AGR [COUNT @D97251, PER @D97250, PLU @D97249, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PAINT, 
   [COORD @D97258, PAST @D97257, AGR [CASE @D97256, COUNT @D97255, 
            PER @D97254, PLU @D97253, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : PAINT, 
   [COORD @D97261, AGR [COUNT @D97260, PER @D97259, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PAINT, 
   [COORD @D97263, AGR [COUNT @D97262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PAINT, 
   [COORD @D97265, AGR [COUNT @D97264, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PAINT, 
   [COORD @D97269, AGR [COUNT @D97268, PER @D97267, PLU @D97266, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PAINT, 
   [COORD @D97275, PAST @D97274, AGR [CASE @D97273, COUNT @D97272, 
            PER @D97271, PLU @D97270, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PAINT, 
   [COORD @D97278, AGR [COUNT @D97277, PER @D97276, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAINT, 
   [COORD @D97280, AGR [COUNT @D97279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAINT, 
   [COORD @D97282, AGR [COUNT @D97281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAINT, 
   [COORD @D97286, AGR [COUNT @D97285, PER @D97284, PLU @D97283, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAINT, 
   [COORD @D97292, PAST @D97291, AGR [CASE @D97290, COUNT @D97289, 
            PER @D97288, PLU @D97287, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PAINT.

WORD painted : 
   [COORD @D97302, AGR [CASE @D97301, COUNT @D97300, PER @D97299, 
            PLU @D97298, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PAINT, 
   [COORD @D97307, AGR [CASE @D97306, COUNT @D97305, PER @D97304, 
            PLU @D97303, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97312, AGR [CASE @D97311, COUNT @D97310, PER @D97309, 
            PLU @D97308, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97317, AGR [CASE @D97316, COUNT @D97315, PER @D97314, 
            PLU @D97313, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97322, AGR [CASE @D97321, COUNT @D97320, PER @D97319, 
            PLU @D97318, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97328, AGR [CASE @D97327, NFORM @D97326, COUNT @D97325, 
            PER @D97324, PLU @D97323, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PAINT, 
   [COORD @D97333, AGR [CASE @D97332, COUNT @D97331, PER @D97330, 
            PLU @D97329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97338, AGR [CASE @D97337, COUNT @D97336, PER @D97335, 
            PLU @D97334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97343, AGR [CASE @D97342, COUNT @D97341, PER @D97340, 
            PLU @D97339, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PAINT, 
   [COORD @D97348, AGR [CASE @D97347, COUNT @D97346, PER @D97345, 
            PLU @D97344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97353, AGR [CASE @D97352, COUNT @D97351, PER @D97350, 
            PLU @D97349, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PAINT.

WORD painter : 
   [COORD @D97362, REFL @D97361, PRD @D97360, CASE @D97359, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PAINTER.

WORD painters : 
   [COORD @D97374, DEMON @D97373, REFL @D97372, PRD @D97371, 
      CASE @D97370, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : PAINTER.

WORD painting : 
   [COORD @D97386, REFL @D97385, COUNT @D97384, PRD @D97383, 
      CASE @D97382, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PAINTING, 
   [COORD @D97392, PRD @D97391, 
      AGR [CASE @D97390, COUNT @D97389, PER @D97388, PLU @D97387, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PAINT, 
   [COORD @D97398, PRD @D97397, AGR [CASE @D97396, COUNT @D97395, 
            PER @D97394, PLU @D97393, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PAINT, 
   [COORD @D97404, PRD @D97403, 
      AGR [CASE @D97402, COUNT @D97401, PER @D97400, PLU @D97399, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PAINT, 
   [COORD @D97410, PRD @D97409, AGR [CASE @D97408, COUNT @D97407, 
            PER @D97406, PLU @D97405, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PAINT.

WORD paintings : 
   [COORD @D97424, DEMON @D97423, REFL @D97422, PRD @D97421, 
      CASE @D97420, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : PAINTING.

WORD paints : 
   [COORD @D97431, AGR [COUNT @D97430, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAINT, 
   [COORD @D97433, 
      AGR [COUNT @D97432, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAINT, 
   [COORD @D97435, 
      AGR [COUNT @D97434, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAINT, 
   [COORD @D97437, 
      AGR [COUNT @D97436, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAINT.

WORD park : 
   [COORD @D97442, AGR [COUNT @D97441, PER @D97440, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PARK, 
   [COORD @D97444, AGR [COUNT @D97443, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PARK, 
   [COORD @D97446, AGR [COUNT @D97445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PARK, 
   [COORD @D97450, AGR [COUNT @D97449, PER @D97448, PLU @D97447, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PARK, 
   [COORD @D97456, PAST @D97455, AGR [CASE @D97454, COUNT @D97453, 
            PER @D97452, PLU @D97451, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PARK, 
   [COORD @D97459, AGR [COUNT @D97458, PER @D97457, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PARK, 
   [COORD @D97461, AGR [COUNT @D97460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PARK, 
   [COORD @D97463, AGR [COUNT @D97462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PARK, 
   [COORD @D97467, AGR [COUNT @D97466, PER @D97465, PLU @D97464, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PARK, 
   [COORD @D97473, PAST @D97472, AGR [CASE @D97471, COUNT @D97470, 
            PER @D97469, PLU @D97468, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PARK, 
   [COORD @D97476, AGR [COUNT @D97475, PER @D97474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PARK, 
   [COORD @D97478, AGR [COUNT @D97477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PARK, 
   [COORD @D97480, AGR [COUNT @D97479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PARK, 
   [COORD @D97484, AGR [COUNT @D97483, PER @D97482, PLU @D97481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PARK, 
   [COORD @D97490, PAST @D97489, AGR [CASE @D97488, COUNT @D97487, 
            PER @D97486, PLU @D97485, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PARK.

WORD parked : 
   [COORD @D97498, AGR [CASE @D97497, COUNT @D97496, PER @D97495, 
            PLU @D97494, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PARK, 
   [COORD @D97503, AGR [CASE @D97502, COUNT @D97501, PER @D97500, 
            PLU @D97499, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PARK, 
   [COORD @D97508, AGR [CASE @D97507, COUNT @D97506, PER @D97505, 
            PLU @D97504, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PARK, 
   [COORD @D97513, AGR [CASE @D97512, COUNT @D97511, PER @D97510, 
            PLU @D97509, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PARK, 
   [COORD @D97518, AGR [CASE @D97517, COUNT @D97516, PER @D97515, 
            PLU @D97514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PARK, 
   [COORD @D97523, AGR [CASE @D97522, COUNT @D97521, PER @D97520, 
            PLU @D97519, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PARK, 
   [COORD @D97528, AGR [CASE @D97527, COUNT @D97526, PER @D97525, 
            PLU @D97524, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PARK, 
   [COORD @D97533, AGR [CASE @D97532, COUNT @D97531, PER @D97530, 
            PLU @D97529, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PARK.

WORD parking : 
   [COORD @D97542, REFL @D97541, PRD @D97540, CASE @D97539, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : PARKING, 
   [COORD @D97548, PRD @D97547, 
      AGR [CASE @D97546, COUNT @D97545, PER @D97544, PLU @D97543, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PARK, 
   [COORD @D97554, PRD @D97553, AGR [CASE @D97552, COUNT @D97551, 
            PER @D97550, PLU @D97549, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PARK, 
   [COORD @D97560, PRD @D97559, 
      AGR [CASE @D97558, COUNT @D97557, PER @D97556, PLU @D97555, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PARK.

WORD parks : 
   [COORD @D97572, AGR [COUNT @D97571, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PARK, 
   [COORD @D97574, 
      AGR [COUNT @D97573, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PARK, 
   [COORD @D97576, 
      AGR [COUNT @D97575, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PARK.

WORD pass : 
   [COORD @D97582, REFL @D97581, PRD @D97580, CASE @D97579, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PASS, 
   [COORD @D97586, REFL @D97585, PRD @D97584, CASE @D97583, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PASS, 
   [COORD @D97589, 
      AGR [COUNT @D97588, PER @D97587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   PASS, 
   [COORD @D97591, AGR [COUNT @D97590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PASS, 
   [COORD @D97593, AGR [COUNT @D97592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PASS, 
   [COORD @D97597, AGR [COUNT @D97596, PER @D97595, PLU @D97594, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PASS, 
   [COORD @D97603, PAST @D97602, AGR [CASE @D97601, COUNT @D97600, 
            PER @D97599, PLU @D97598, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : PASS, 
   [COORD @D97606, AGR [COUNT @D97605, PER @D97604, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PASS, 
   [COORD @D97608, AGR [COUNT @D97607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PASS, 
   [COORD @D97610, AGR [COUNT @D97609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PASS, 
   [COORD @D97614, AGR [COUNT @D97613, PER @D97612, PLU @D97611, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PASS, 
   [COORD @D97620, PAST @D97619, AGR [CASE @D97618, COUNT @D97617, 
            PER @D97616, PLU @D97615, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PASS, 
   [COORD @D97623, AGR [COUNT @D97622, PER @D97621, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : PASS, 
   [COORD @D97625, AGR [COUNT @D97624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : PASS, 
   [COORD @D97627, AGR [COUNT @D97626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : PASS, 
   [COORD @D97631, AGR [COUNT @D97630, PER @D97629, PLU @D97628, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : PASS, 
   [COORD @D97637, PAST @D97636, 
      AGR [CASE @D97635, COUNT @D97634, PER @D97633, PLU @D97632, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM UPON, 
      ARITY 3] : PASS, 
   [COORD @D97640, AGR [COUNT @D97639, PER @D97638, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PASS, 
   [COORD @D97642, AGR [COUNT @D97641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PASS, 
   [COORD @D97644, AGR [COUNT @D97643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PASS, 
   [COORD @D97648, AGR [COUNT @D97647, PER @D97646, PLU @D97645, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PASS, 
   [COORD @D97654, PAST @D97653, 
      AGR [CASE @D97652, COUNT @D97651, PER @D97650, PLU @D97649, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : PASS, 
   [COORD @D97657, AGR [COUNT @D97656, PER @D97655, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PASS, 
   [COORD @D97659, AGR [COUNT @D97658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PASS, 
   [COORD @D97661, AGR [COUNT @D97660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PASS, 
   [COORD @D97665, AGR [COUNT @D97664, PER @D97663, PLU @D97662, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PASS, 
   [COORD @D97671, PAST @D97670, 
      AGR [CASE @D97669, COUNT @D97668, PER @D97667, PLU @D97666, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ON, 
      ARITY 3] : PASS, 
   [COORD @D97674, AGR [COUNT @D97673, PER @D97672, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97676, AGR [COUNT @D97675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97678, AGR [COUNT @D97677, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97682, AGR [COUNT @D97681, PER @D97680, PLU @D97679, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97688, PAST @D97687, 
      AGR [CASE @D97686, COUNT @D97685, PER @D97684, PLU @D97683, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, 
      ARITY 3] : PASS, 
   [COORD @D97691, AGR [COUNT @D97690, PER @D97689, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97693, AGR [COUNT @D97692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97695, AGR [COUNT @D97694, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97699, AGR [COUNT @D97698, PER @D97697, PLU @D97696, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM AS, ARITY 3] : PASS, 
   [COORD @D97705, PAST @D97704, 
      AGR [CASE @D97703, COUNT @D97702, PER @D97701, PLU @D97700, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM AS, ARITY 3] : PASS, 
   [COORD @D97708, AGR [COUNT @D97707, PER @D97706, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PASS, 
   [COORD @D97710, AGR [COUNT @D97709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PASS, 
   [COORD @D97712, AGR [COUNT @D97711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PASS, 
   [COORD @D97716, AGR [COUNT @D97715, PER @D97714, PLU @D97713, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PASS, 
   [COORD @D97722, PAST @D97721, AGR [CASE @D97720, COUNT @D97719, 
            PER @D97718, PLU @D97717, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PASS, 
   [COORD @D97725, AGR [COUNT @D97724, PER @D97723, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PASS, 
   [COORD @D97727, AGR [COUNT @D97726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PASS, 
   [COORD @D97729, AGR [COUNT @D97728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PASS, 
   [COORD @D97733, AGR [COUNT @D97732, PER @D97731, PLU @D97730, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : PASS, 
   [COORD @D97739, PAST @D97738, AGR [CASE @D97737, COUNT @D97736, 
            PER @D97735, PLU @D97734, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : PASS, 
   [COORD @D97742, AGR [COUNT @D97741, PER @D97740, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT OFF, ARITY 2] : PASS, 
   [COORD @D97744, AGR [COUNT @D97743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT OFF, ARITY 2] : PASS, 
   [COORD @D97746, AGR [COUNT @D97745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT OFF, ARITY 2] : PASS, 
   [COORD @D97750, AGR [COUNT @D97749, PER @D97748, PLU @D97747, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT OFF, ARITY 2] : PASS, 
   [COORD @D97756, PAST @D97755, 
      AGR [CASE @D97754, COUNT @D97753, PER @D97752, PLU @D97751, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, PRT OFF, 
      ARITY 2] : PASS, 
   [COORD @D97759, AGR [COUNT @D97758, PER @D97757, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UNDER, ARITY 2] : PASS, 
   [COORD @D97761, AGR [COUNT @D97760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UNDER, ARITY 2] : PASS, 
   [COORD @D97763, AGR [COUNT @D97762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UNDER, ARITY 2] : PASS, 
   [COORD @D97767, AGR [COUNT @D97766, PER @D97765, PLU @D97764, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM UNDER, ARITY 2] : PASS, 
   [COORD @D97773, PAST @D97772, 
      AGR [CASE @D97771, COUNT @D97770, PER @D97769, PLU @D97768, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UNDER, 
      ARITY 2] : PASS, 
   [COORD @D97776, AGR [COUNT @D97775, PER @D97774, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : PASS, 
   [COORD @D97778, AGR [COUNT @D97777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : PASS, 
   [COORD @D97780, AGR [COUNT @D97779, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : PASS, 
   [COORD @D97784, AGR [COUNT @D97783, PER @D97782, PLU @D97781, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : PASS, 
   [COORD @D97790, PAST @D97789, 
      AGR [CASE @D97788, COUNT @D97787, PER @D97786, PLU @D97785, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, 
      ARITY 2] : PASS, 
   [COORD @D97793, AGR [COUNT @D97792, PER @D97791, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : PASS, 
   [COORD @D97795, AGR [COUNT @D97794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : PASS, 
   [COORD @D97797, AGR [COUNT @D97796, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, ARITY 2] : PASS, 
   [COORD @D97801, AGR [COUNT @D97800, PER @D97799, PLU @D97798, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, ARITY 2] : PASS, 
   [COORD @D97807, PAST @D97806, 
      AGR [CASE @D97805, COUNT @D97804, PER @D97803, PLU @D97802, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, 
      ARITY 2] : PASS, 
   [COORD @D97810, AGR [COUNT @D97809, PER @D97808, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OVER, ARITY 2] : PASS, 
   [COORD @D97812, AGR [COUNT @D97811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OVER, ARITY 2] : PASS, 
   [COORD @D97814, AGR [COUNT @D97813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OVER, ARITY 2] : PASS, 
   [COORD @D97818, AGR [COUNT @D97817, PER @D97816, PLU @D97815, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OVER, ARITY 2] : PASS, 
   [COORD @D97824, PAST @D97823, 
      AGR [CASE @D97822, COUNT @D97821, PER @D97820, PLU @D97819, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, 
      ARITY 2] : PASS, 
   [COORD @D97827, AGR [COUNT @D97826, PER @D97825, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : PASS, 
   [COORD @D97829, AGR [COUNT @D97828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : PASS, 
   [COORD @D97831, AGR [COUNT @D97830, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : PASS, 
   [COORD @D97835, AGR [COUNT @D97834, PER @D97833, PLU @D97832, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : PASS, 
   [COORD @D97841, PAST @D97840, 
      AGR [CASE @D97839, COUNT @D97838, PER @D97837, PLU @D97836, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM INTO, 
      ARITY 2] : PASS, 
   [COORD @D97844, AGR [COUNT @D97843, PER @D97842, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PASS, 
   [COORD @D97846, AGR [COUNT @D97845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PASS, 
   [COORD @D97848, AGR [COUNT @D97847, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PASS, 
   [COORD @D97852, AGR [COUNT @D97851, PER @D97850, PLU @D97849, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : PASS, 
   [COORD @D97858, PAST @D97857, 
      AGR [CASE @D97856, COUNT @D97855, PER @D97854, PLU @D97853, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, 
      ARITY 2] : PASS, 
   [COORD @D97861, AGR [COUNT @D97860, PER @D97859, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PASS, 
   [COORD @D97863, AGR [COUNT @D97862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PASS, 
   [COORD @D97865, AGR [COUNT @D97864, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PASS, 
   [COORD @D97869, AGR [COUNT @D97868, PER @D97867, PLU @D97866, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : PASS, 
   [COORD @D97875, PAST @D97874, 
      AGR [CASE @D97873, COUNT @D97872, PER @D97871, PLU @D97870, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, 
      ARITY 2] : PASS, 
   [COORD @D97878, AGR [COUNT @D97877, PER @D97876, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BETWEEN, ARITY 2] : PASS, 
   [COORD @D97880, AGR [COUNT @D97879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BETWEEN, ARITY 2] : PASS, 
   [COORD @D97882, AGR [COUNT @D97881, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BETWEEN, ARITY 2] : PASS, 
   [COORD @D97886, AGR [COUNT @D97885, PER @D97884, PLU @D97883, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM BETWEEN, ARITY 2] : PASS, 
   [COORD @D97892, PAST @D97891, 
      AGR [CASE @D97890, COUNT @D97889, PER @D97888, PLU @D97887, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM BETWEEN, 
      ARITY 2] : PASS, 
   [COORD @D97895, AGR [COUNT @D97894, PER @D97893, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : PASS, 
   [COORD @D97897, AGR [COUNT @D97896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : PASS, 
   [COORD @D97899, AGR [COUNT @D97898, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : PASS, 
   [COORD @D97903, AGR [COUNT @D97902, PER @D97901, PLU @D97900, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AS, ARITY 2] : PASS, 
   [COORD @D97909, PAST @D97908, 
      AGR [CASE @D97907, COUNT @D97906, PER @D97905, PLU @D97904, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AS, 
      ARITY 2] : PASS, 
   [COORD @D97912, AGR [COUNT @D97911, PER @D97910, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PASS, 
   [COORD @D97914, AGR [COUNT @D97913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PASS, 
   [COORD @D97916, AGR [COUNT @D97915, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PASS, 
   [COORD @D97920, AGR [COUNT @D97919, PER @D97918, PLU @D97917, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : PASS, 
   [COORD @D97926, PAST @D97925, 
      AGR [CASE @D97924, COUNT @D97923, PER @D97922, PLU @D97921, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : PASS, 
   [COORD @D97929, AGR [COUNT @D97928, PER @D97927, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PASS, 
   [COORD @D97931, AGR [COUNT @D97930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PASS, 
   [COORD @D97933, AGR [COUNT @D97932, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PASS, 
   [COORD @D97937, AGR [COUNT @D97936, PER @D97935, PLU @D97934, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : PASS, 
   [COORD @D97943, PAST @D97942, 
      AGR [CASE @D97941, COUNT @D97940, PER @D97939, PLU @D97938, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PASS, 
   [COORD @D97946, AGR [COUNT @D97945, PER @D97944, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PASS, 
   [COORD @D97948, AGR [COUNT @D97947, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PASS, 
   [COORD @D97950, AGR [COUNT @D97949, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PASS, 
   [COORD @D97954, AGR [COUNT @D97953, PER @D97952, PLU @D97951, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : PASS, 
   [COORD @D97960, PAST @D97959, 
      AGR [CASE @D97958, COUNT @D97957, PER @D97956, PLU @D97955, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : PASS, 
   [COORD @D97963, AGR [COUNT @D97962, PER @D97961, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PASS, 
   [COORD @D97965, AGR [COUNT @D97964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PASS, 
   [COORD @D97967, AGR [COUNT @D97966, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PASS, 
   [COORD @D97971, AGR [COUNT @D97970, PER @D97969, PLU @D97968, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : PASS, 
   [COORD @D97977, PAST @D97976, 
      AGR [CASE @D97975, COUNT @D97974, PER @D97973, PLU @D97972, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : PASS, 
   [COORD @D97980, AGR [COUNT @D97979, PER @D97978, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PASS, 
   [COORD @D97982, AGR [COUNT @D97981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PASS, 
   [COORD @D97984, AGR [COUNT @D97983, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PASS, 
   [COORD @D97988, AGR [COUNT @D97987, PER @D97986, PLU @D97985, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : PASS, 
   [COORD @D97994, PAST @D97993, 
      AGR [CASE @D97992, COUNT @D97991, PER @D97990, PLU @D97989, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PASS, 
   [COORD @D97997, AGR [COUNT @D97996, PER @D97995, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BY, ARITY 2] : PASS, 
   [COORD @D97999, AGR [COUNT @D97998, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BY, ARITY 2] : PASS, 
   [COORD @D98001, AGR [COUNT @D98000, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BY, ARITY 2] : PASS, 
   [COORD @D98005, AGR [COUNT @D98004, PER @D98003, PLU @D98002, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BY, ARITY 2] : PASS, 
   [COORD @D98011, PAST @D98010, 
      AGR [CASE @D98009, COUNT @D98008, PER @D98007, PLU @D98006, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT BY, 
      ARITY 2] : PASS, 
   [COORD @D98014, AGR [COUNT @D98013, PER @D98012, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PASS, 
   [COORD @D98016, AGR [COUNT @D98015, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PASS, 
   [COORD @D98018, AGR [COUNT @D98017, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PASS, 
   [COORD @D98022, AGR [COUNT @D98021, PER @D98020, PLU @D98019, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PASS, 
   [COORD @D98028, PAST @D98027, AGR [CASE @D98026, COUNT @D98025, 
            PER @D98024, PLU @D98023, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PASS, 
   [COORD @D98031, AGR [COUNT @D98030, PER @D98029, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PASS, 
   [COORD @D98033, AGR [COUNT @D98032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PASS, 
   [COORD @D98035, AGR [COUNT @D98034, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PASS, 
   [COORD @D98039, AGR [COUNT @D98038, PER @D98037, PLU @D98036, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PASS, 
   [COORD @D98045, PAST @D98044, 
      AGR [CASE @D98043, COUNT @D98042, PER @D98041, PLU @D98040, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT UP, 
      ARITY 1] : PASS, 
   [COORD @D98048, AGR [COUNT @D98047, PER @D98046, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PASS, 
   [COORD @D98050, AGR [COUNT @D98049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PASS, 
   [COORD @D98052, AGR [COUNT @D98051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PASS, 
   [COORD @D98056, AGR [COUNT @D98055, PER @D98054, PLU @D98053, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PASS, 
   [COORD @D98062, PAST @D98061, 
      AGR [CASE @D98060, COUNT @D98059, PER @D98058, PLU @D98057, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OVER, 
      ARITY 1] : PASS, 
   [COORD @D98065, AGR [COUNT @D98064, PER @D98063, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PASS, 
   [COORD @D98067, AGR [COUNT @D98066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PASS, 
   [COORD @D98069, AGR [COUNT @D98068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PASS, 
   [COORD @D98073, AGR [COUNT @D98072, PER @D98071, PLU @D98070, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PASS, 
   [COORD @D98079, PAST @D98078, 
      AGR [CASE @D98077, COUNT @D98076, PER @D98075, PLU @D98074, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OUT, 
      ARITY 1] : PASS, 
   [COORD @D98082, AGR [COUNT @D98081, PER @D98080, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PASS, 
   [COORD @D98084, AGR [COUNT @D98083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PASS, 
   [COORD @D98086, AGR [COUNT @D98085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PASS, 
   [COORD @D98090, AGR [COUNT @D98089, PER @D98088, PLU @D98087, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PASS, 
   [COORD @D98096, PAST @D98095, 
      AGR [CASE @D98094, COUNT @D98093, PER @D98092, PLU @D98091, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT ON, 
      ARITY 1] : PASS, 
   [COORD @D98099, AGR [COUNT @D98098, PER @D98097, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PASS, 
   [COORD @D98101, AGR [COUNT @D98100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PASS, 
   [COORD @D98103, AGR [COUNT @D98102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PASS, 
   [COORD @D98107, AGR [COUNT @D98106, PER @D98105, PLU @D98104, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PASS, 
   [COORD @D98113, PAST @D98112, 
      AGR [CASE @D98111, COUNT @D98110, PER @D98109, PLU @D98108, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT OFF, 
      ARITY 1] : PASS, 
   [COORD @D98116, AGR [COUNT @D98115, PER @D98114, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PASS, 
   [COORD @D98118, AGR [COUNT @D98117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PASS, 
   [COORD @D98120, AGR [COUNT @D98119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PASS, 
   [COORD @D98124, AGR [COUNT @D98123, PER @D98122, PLU @D98121, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PASS, 
   [COORD @D98130, PAST @D98129, 
      AGR [CASE @D98128, COUNT @D98127, PER @D98126, PLU @D98125, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT DOWN, 
      ARITY 1] : PASS, 
   [COORD @D98133, AGR [COUNT @D98132, PER @D98131, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : PASS, 
   [COORD @D98135, AGR [COUNT @D98134, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : PASS, 
   [COORD @D98137, AGR [COUNT @D98136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : PASS, 
   [COORD @D98141, AGR [COUNT @D98140, PER @D98139, PLU @D98138, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : PASS, 
   [COORD @D98147, PAST @D98146, 
      AGR [CASE @D98145, COUNT @D98144, PER @D98143, PLU @D98142, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT BY, 
      ARITY 1] : PASS, 
   [COORD @D98150, AGR [COUNT @D98149, PER @D98148, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PASS, 
   [COORD @D98152, AGR [COUNT @D98151, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PASS, 
   [COORD @D98154, AGR [COUNT @D98153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PASS, 
   [COORD @D98158, AGR [COUNT @D98157, PER @D98156, PLU @D98155, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PASS, 
   [COORD @D98164, PAST @D98163, 
      AGR [CASE @D98162, COUNT @D98161, PER @D98160, PLU @D98159, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, PRT AWAY, 
      ARITY 1] : PASS.

WORD passed : 
   [COORD @D98173, AGR [CASE @D98172, COUNT @D98171, PER @D98170, 
            PLU @D98169, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PASS, 
   [COORD @D98178, AGR [CASE @D98177, COUNT @D98176, PER @D98175, 
            PLU @D98174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98183, AGR [CASE @D98182, COUNT @D98181, PER @D98180, 
            PLU @D98179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98188, AGR [CASE @D98187, COUNT @D98186, PER @D98185, 
            PLU @D98184, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PASS, 
   [COORD @D98193, AGR [CASE @D98192, COUNT @D98191, PER @D98190, 
            PLU @D98189, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98198, AGR [CASE @D98197, COUNT @D98196, PER @D98195, 
            PLU @D98194, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98203, AGR [CASE @D98202, COUNT @D98201, PER @D98200, 
            PLU @D98199, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98208, AGR [CASE @D98207, COUNT @D98206, PER @D98205, 
            PLU @D98204, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98213, AGR [CASE @D98212, COUNT @D98211, PER @D98210, 
            PLU @D98209, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98218, AGR [CASE @D98217, COUNT @D98216, PER @D98215, 
            PLU @D98214, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98223, AGR [CASE @D98222, COUNT @D98221, PER @D98220, 
            PLU @D98219, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98228, AGR [CASE @D98227, COUNT @D98226, PER @D98225, 
            PLU @D98224, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98233, AGR [CASE @D98232, COUNT @D98231, PER @D98230, 
            PLU @D98229, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98238, AGR [CASE @D98237, COUNT @D98236, PER @D98235, 
            PLU @D98234, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98243, AGR [CASE @D98242, COUNT @D98241, PER @D98240, 
            PLU @D98239, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98248, AGR [CASE @D98247, COUNT @D98246, PER @D98245, 
            PLU @D98244, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98253, AGR [CASE @D98252, COUNT @D98251, PER @D98250, 
            PLU @D98249, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98258, AGR [CASE @D98257, COUNT @D98256, PER @D98255, 
            PLU @D98254, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98263, AGR [CASE @D98262, COUNT @D98261, PER @D98260, 
            PLU @D98259, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AS, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98268, AGR [CASE @D98267, COUNT @D98266, PER @D98265, 
            PLU @D98264, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98273, 
      AGR [CASE @D98272, COUNT @D98271, PER @D98270, PLU @D98269, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98278, AGR [CASE @D98277, COUNT @D98276, PER @D98275, 
            PLU @D98274, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PASS, 
   [COORD @D98283, AGR [CASE @D98282, COUNT @D98281, PER @D98280, 
            PLU @D98279, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98288, AGR [CASE @D98287, COUNT @D98286, PER @D98285, 
            PLU @D98284, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98293, AGR [CASE @D98292, COUNT @D98291, PER @D98290, 
            PLU @D98289, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98298, AGR [CASE @D98297, COUNT @D98296, PER @D98295, 
            PLU @D98294, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98303, AGR [CASE @D98302, COUNT @D98301, PER @D98300, 
            PLU @D98299, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98308, AGR [CASE @D98307, COUNT @D98306, PER @D98305, 
            PLU @D98304, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98313, AGR [CASE @D98312, COUNT @D98311, PER @D98310, 
            PLU @D98309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UNDER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98318, AGR [CASE @D98317, COUNT @D98316, PER @D98315, 
            PLU @D98314, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UNDER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98323, AGR [CASE @D98322, COUNT @D98321, PER @D98320, 
            PLU @D98319, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98328, AGR [CASE @D98327, COUNT @D98326, PER @D98325, 
            PLU @D98324, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98333, AGR [CASE @D98332, COUNT @D98331, PER @D98330, 
            PLU @D98329, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98338, AGR [CASE @D98337, COUNT @D98336, PER @D98335, 
            PLU @D98334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98343, AGR [CASE @D98342, COUNT @D98341, PER @D98340, 
            PLU @D98339, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98348, AGR [CASE @D98347, COUNT @D98346, PER @D98345, 
            PLU @D98344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98353, AGR [CASE @D98352, COUNT @D98351, PER @D98350, 
            PLU @D98349, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98358, AGR [CASE @D98357, COUNT @D98356, PER @D98355, 
            PLU @D98354, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98363, AGR [CASE @D98362, COUNT @D98361, PER @D98360, 
            PLU @D98359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98368, AGR [CASE @D98367, COUNT @D98366, PER @D98365, 
            PLU @D98364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98373, AGR [CASE @D98372, COUNT @D98371, PER @D98370, 
            PLU @D98369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98378, AGR [CASE @D98377, COUNT @D98376, PER @D98375, 
            PLU @D98374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98383, AGR [CASE @D98382, COUNT @D98381, PER @D98380, 
            PLU @D98379, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98388, AGR [CASE @D98387, COUNT @D98386, PER @D98385, 
            PLU @D98384, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98393, AGR [CASE @D98392, COUNT @D98391, PER @D98390, 
            PLU @D98389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98398, AGR [CASE @D98397, COUNT @D98396, PER @D98395, 
            PLU @D98394, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98403, AGR [CASE @D98402, COUNT @D98401, PER @D98400, 
            PLU @D98399, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98408, AGR [CASE @D98407, COUNT @D98406, PER @D98405, 
            PLU @D98404, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98413, AGR [CASE @D98412, COUNT @D98411, PER @D98410, 
            PLU @D98409, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98418, AGR [CASE @D98417, COUNT @D98416, PER @D98415, 
            PLU @D98414, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98423, AGR [CASE @D98422, COUNT @D98421, PER @D98420, 
            PLU @D98419, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98428, AGR [CASE @D98427, COUNT @D98426, PER @D98425, 
            PLU @D98424, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98433, AGR [CASE @D98432, COUNT @D98431, PER @D98430, 
            PLU @D98429, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98438, AGR [CASE @D98437, COUNT @D98436, PER @D98435, 
            PLU @D98434, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98443, AGR [CASE @D98442, COUNT @D98441, PER @D98440, 
            PLU @D98439, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98448, AGR [CASE @D98447, COUNT @D98446, PER @D98445, 
            PLU @D98444, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98453, AGR [CASE @D98452, COUNT @D98451, PER @D98450, 
            PLU @D98449, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98458, AGR [CASE @D98457, COUNT @D98456, PER @D98455, 
            PLU @D98454, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98463, AGR [CASE @D98462, COUNT @D98461, PER @D98460, 
            PLU @D98459, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98468, AGR [CASE @D98467, COUNT @D98466, PER @D98465, 
            PLU @D98464, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98473, AGR [CASE @D98472, COUNT @D98471, PER @D98470, 
            PLU @D98469, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98478, AGR [CASE @D98477, COUNT @D98476, PER @D98475, 
            PLU @D98474, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98483, AGR [CASE @D98482, COUNT @D98481, PER @D98480, 
            PLU @D98479, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98488, AGR [CASE @D98487, COUNT @D98486, PER @D98485, 
            PLU @D98484, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98493, AGR [CASE @D98492, COUNT @D98491, PER @D98490, 
            PLU @D98489, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98498, AGR [CASE @D98497, COUNT @D98496, PER @D98495, 
            PLU @D98494, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98503, AGR [CASE @D98502, COUNT @D98501, PER @D98500, 
            PLU @D98499, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98508, AGR [CASE @D98507, COUNT @D98506, PER @D98505, 
            PLU @D98504, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98513, AGR [CASE @D98512, COUNT @D98511, PER @D98510, 
            PLU @D98509, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98518, AGR [CASE @D98517, COUNT @D98516, PER @D98515, 
            PLU @D98514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98523, AGR [CASE @D98522, COUNT @D98521, PER @D98520, 
            PLU @D98519, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98528, AGR [CASE @D98527, COUNT @D98526, PER @D98525, 
            PLU @D98524, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98533, AGR [CASE @D98532, COUNT @D98531, PER @D98530, 
            PLU @D98529, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98538, AGR [CASE @D98537, COUNT @D98536, PER @D98535, 
            PLU @D98534, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98543, AGR [CASE @D98542, COUNT @D98541, PER @D98540, 
            PLU @D98539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98548, AGR [CASE @D98547, COUNT @D98546, PER @D98545, 
            PLU @D98544, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98553, AGR [CASE @D98552, COUNT @D98551, PER @D98550, 
            PLU @D98549, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98558, AGR [CASE @D98557, COUNT @D98556, PER @D98555, 
            PLU @D98554, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98563, AGR [CASE @D98562, COUNT @D98561, PER @D98560, 
            PLU @D98559, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98568, AGR [CASE @D98567, COUNT @D98566, PER @D98565, 
            PLU @D98564, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98573, AGR [CASE @D98572, COUNT @D98571, PER @D98570, 
            PLU @D98569, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98578, AGR [CASE @D98577, COUNT @D98576, PER @D98575, 
            PLU @D98574, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS, 
   [COORD @D98583, AGR [CASE @D98582, COUNT @D98581, PER @D98580, 
            PLU @D98579, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98588, AGR [CASE @D98587, COUNT @D98586, PER @D98585, 
            PLU @D98584, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PASS.

WORD passenger : 
   [COORD @D98596, REFL @D98595, PRD @D98594, CASE @D98593, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PASSENGER.

WORD passengers : 
   [COORD @D98606, DEMON @D98605, REFL @D98604, PRD @D98603, 
      CASE @D98602, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PASSENGER.

WORD passes : 
   [COORD @D98615, DEMON @D98614, REFL @D98613, PRD @D98612, CASE 
         @D98611, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : PASS, 
   [COORD @D98617, 
      AGR [COUNT @D98616, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98619, 
      AGR [COUNT @D98618, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98621, 
      AGR [COUNT @D98620, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PASS, 
   [COORD @D98623, AGR [COUNT @D98622, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PASS, 
   [COORD @D98625, AGR [COUNT @D98624, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98627, 
      AGR [COUNT @D98626, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98629, 
      AGR [COUNT @D98628, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PASS, 
   [COORD @D98631, AGR [COUNT @D98630, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98633, 
      AGR [COUNT @D98632, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98635, 
      AGR [COUNT @D98634, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98637, 
      AGR [COUNT @D98636, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98639, 
      AGR [COUNT @D98638, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98641, 
      AGR [COUNT @D98640, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PASS, 
   [COORD @D98643, AGR [COUNT @D98642, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PASS, 
   [COORD @D98645, AGR [COUNT @D98644, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98647, 
      AGR [COUNT @D98646, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98649, 
      AGR [COUNT @D98648, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98651, 
      AGR [COUNT @D98650, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PASS, 
   [COORD @D98653, AGR [COUNT @D98652, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98655, 
      AGR [COUNT @D98654, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98657, 
      AGR [COUNT @D98656, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98659, 
      AGR [COUNT @D98658, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98661, 
      AGR [COUNT @D98660, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98663, 
      AGR [COUNT @D98662, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98665, 
      AGR [COUNT @D98664, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98667, 
      AGR [COUNT @D98666, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98669, 
      AGR [COUNT @D98668, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98671, 
      AGR [COUNT @D98670, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98673, 
      AGR [COUNT @D98672, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98675, 
      AGR [COUNT @D98674, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98677, 
      AGR [COUNT @D98676, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98679, 
      AGR [COUNT @D98678, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98681, 
      AGR [COUNT @D98680, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS, 
   [COORD @D98683, 
      AGR [COUNT @D98682, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PASS.

WORD passing : 
   [COADV @D98699, COORD @D98698, DEF @D98697, PRD @D98696, AGR 
            [CASE @D98695, COUNT @D98694, PER @D98693, PLU @D98692, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : PASSING, 
   [COADV @D98704, COORD @D98703, DEF @D98702, AGR @D98701, PRD @D98700, 
      FIX NOT, V +, SUBTYPE NONE, INFL +, BAR 0, N +, COMPAR NO, GRADE -, 
      AFORM NONE, PART -, NEG -, SUBCAT NULL, DISTR ATT, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, ADV +] : PASSING, 
   [COORD @D98708, REFL @D98707, PRD @D98706, CASE @D98705, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : PASSING, 
   [COORD @D98714, PRD @D98713, 
      AGR [CASE @D98712, COUNT @D98711, PER @D98710, PLU @D98709, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PASS, 
   [COORD @D98720, PRD @D98719, AGR [CASE @D98718, COUNT @D98717, 
            PER @D98716, PLU @D98715, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98726, PRD @D98725, 
      AGR [CASE @D98724, COUNT @D98723, PER @D98722, PLU @D98721, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PASS, 
   [COORD @D98732, PRD @D98731, AGR [CASE @D98730, COUNT @D98729, 
            PER @D98728, PLU @D98727, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98738, PRD @D98737, 
      AGR [CASE @D98736, COUNT @D98735, PER @D98734, PLU @D98733, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98744, PRD @D98743, AGR [CASE @D98742, COUNT @D98741, 
            PER @D98740, PLU @D98739, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98750, PRD @D98749, 
      AGR [CASE @D98748, COUNT @D98747, PER @D98746, PLU @D98745, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PASS, 
   [COORD @D98756, PRD @D98755, AGR [CASE @D98754, COUNT @D98753, 
            PER @D98752, PLU @D98751, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98762, PRD @D98761, 
      AGR [CASE @D98760, COUNT @D98759, PER @D98758, PLU @D98757, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PASS, 
   [COORD @D98768, PRD @D98767, AGR [CASE @D98766, COUNT @D98765, 
            PER @D98764, PLU @D98763, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98774, PRD @D98773, 
      AGR [CASE @D98772, COUNT @D98771, PER @D98770, PLU @D98769, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98780, PRD @D98779, AGR [CASE @D98778, COUNT @D98777, 
            PER @D98776, PLU @D98775, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98786, PRD @D98785, 
      AGR [CASE @D98784, COUNT @D98783, PER @D98782, PLU @D98781, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PASS, 
   [COORD @D98792, PRD @D98791, AGR [CASE @D98790, COUNT @D98789, 
            PER @D98788, PLU @D98787, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98798, PRD @D98797, 
      AGR [CASE @D98796, COUNT @D98795, PER @D98794, PLU @D98793, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98804, PRD @D98803, AGR [CASE @D98802, COUNT @D98801, 
            PER @D98800, PLU @D98799, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98810, PRD @D98809, 
      AGR [CASE @D98808, COUNT @D98807, PER @D98806, PLU @D98805, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98816, PRD @D98815, AGR [CASE @D98814, COUNT @D98813, 
            PER @D98812, PLU @D98811, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98822, PRD @D98821, 
      AGR [CASE @D98820, COUNT @D98819, PER @D98818, PLU @D98817, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98828, PRD @D98827, AGR [CASE @D98826, COUNT @D98825, 
            PER @D98824, PLU @D98823, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98834, PRD @D98833, 
      AGR [CASE @D98832, COUNT @D98831, PER @D98830, PLU @D98829, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98840, PRD @D98839, AGR [CASE @D98838, COUNT @D98837, 
            PER @D98836, PLU @D98835, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98846, PRD @D98845, 
      AGR [CASE @D98844, COUNT @D98843, PER @D98842, PLU @D98841, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98852, PRD @D98851, AGR [CASE @D98850, COUNT @D98849, 
            PER @D98848, PLU @D98847, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98858, PRD @D98857, 
      AGR [CASE @D98856, COUNT @D98855, PER @D98854, PLU @D98853, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98864, PRD @D98863, AGR [CASE @D98862, COUNT @D98861, 
            PER @D98860, PLU @D98859, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98870, PRD @D98869, 
      AGR [CASE @D98868, COUNT @D98867, PER @D98866, PLU @D98865, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98876, PRD @D98875, AGR [CASE @D98874, COUNT @D98873, 
            PER @D98872, PLU @D98871, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98882, PRD @D98881, 
      AGR [CASE @D98880, COUNT @D98879, PER @D98878, PLU @D98877, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98888, PRD @D98887, AGR [CASE @D98886, COUNT @D98885, 
            PER @D98884, PLU @D98883, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98894, PRD @D98893, 
      AGR [CASE @D98892, COUNT @D98891, PER @D98890, PLU @D98889, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98900, PRD @D98899, AGR [CASE @D98898, COUNT @D98897, 
            PER @D98896, PLU @D98895, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS, 
   [COORD @D98906, PRD @D98905, 
      AGR [CASE @D98904, COUNT @D98903, PER @D98902, PLU @D98901, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PASS, 
   [COORD @D98912, PRD @D98911, AGR [CASE @D98910, COUNT @D98909, 
            PER @D98908, PLU @D98907, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PASS.

WORD pause : 
   [COORD @D98937, REFL @D98936, PRD @D98935, CASE @D98934, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, COUNT +] : PAUSE, 
   [COORD @D98942, REFL @D98941, COUNT @D98940, PRD @D98939, 
      CASE @D98938, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PAUSE, 
   [COORD @D98945, 
      AGR [COUNT @D98944, PER @D98943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PAUSE, 
   [COORD @D98947, AGR [COUNT @D98946, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PAUSE, 
   [COORD @D98949, AGR [COUNT @D98948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PAUSE, 
   [COORD @D98953, AGR [COUNT @D98952, PER @D98951, PLU @D98950, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : PAUSE, 
   [COORD @D98959, PAST @D98958, 
      AGR [CASE @D98957, COUNT @D98956, PER @D98955, PLU @D98954, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      ARITY 2] : PAUSE, 
   [COORD @D98962, AGR [COUNT @D98961, PER @D98960, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAUSE, 
   [COORD @D98964, AGR [COUNT @D98963, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAUSE, 
   [COORD @D98966, AGR [COUNT @D98965, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAUSE, 
   [COORD @D98970, AGR [COUNT @D98969, PER @D98968, PLU @D98967, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PAUSE, 
   [COORD @D98976, PAST @D98975, AGR [CASE @D98974, COUNT @D98973, 
            PER @D98972, PLU @D98971, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PAUSE.

WORD paused : 
   [COORD @D98987, AGR [CASE @D98986, COUNT @D98985, PER @D98984, 
            PLU @D98983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PAUSE, 
   [COORD @D98992, AGR [CASE @D98991, COUNT @D98990, PER @D98989, 
            PLU @D98988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PAUSE, 
   [COORD @D98997, AGR [CASE @D98996, COUNT @D98995, PER @D98994, 
            PLU @D98993, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PAUSE, 
   [COORD @D99002, AGR [CASE @D99001, COUNT @D99000, PER @D98999, 
            PLU @D98998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PAUSE, 
   [COORD @D99007, AGR [CASE @D99006, COUNT @D99005, PER @D99004, 
            PLU @D99003, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PAUSE.

WORD pauses : 
   [COORD @D99018, DEMON @D99017, REFL @D99016, PRD @D99015, CASE 
         @D99014, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM IN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PAUSE, 
   [COORD @D99023, DEMON @D99022, REFL @D99021, PRD @D99020, CASE 
         @D99019, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : PAUSE, 
   [COORD @D99025, 
      AGR [COUNT @D99024, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAUSE, 
   [COORD @D99027, 
      AGR [COUNT @D99026, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAUSE.

WORD pausing : 
   [COORD @D99037, PRD @D99036, AGR [CASE @D99035, COUNT @D99034, 
            PER @D99033, PLU @D99032, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAUSE, 
   [COORD @D99043, PRD @D99042, 
      AGR [CASE @D99041, COUNT @D99040, PER @D99039, PLU @D99038, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PAUSE.

WORD pay : 
   [COORD @D99049, REFL @D99048, PRD @D99047, CASE @D99046, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : PAY, 
   [COORD @D99052, AGR [COUNT @D99051, PER @D99050, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : PAY, 
   [COORD @D99054, AGR [COUNT @D99053, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : PAY, 
   [COORD @D99056, AGR [COUNT @D99055, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : PAY, 
   [COORD @D99060, AGR [COUNT @D99059, PER @D99058, PLU @D99057, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : PAY, 
   [COORD @D99066, PAST @D99065, 
      AGR [CASE @D99064, COUNT @D99063, PER @D99062, PLU @D99061, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, ARITY 3] : 
   PAY, 
   [COORD @D99069, AGR [COUNT @D99068, PER @D99067, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : PAY, 
   [COORD @D99071, AGR [COUNT @D99070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : PAY, 
   [COORD @D99073, AGR [COUNT @D99072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : PAY, 
   [COORD @D99077, AGR [COUNT @D99076, PER @D99075, PLU @D99074, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : PAY, 
   [COORD @D99083, PAST @D99082, 
      AGR [CASE @D99081, COUNT @D99080, PER @D99079, PLU @D99078, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   PAY, 
   [COORD @D99086, AGR [COUNT @D99085, PER @D99084, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT BACK, ARITY 3] : PAY, 
   [COORD @D99088, AGR [COUNT @D99087, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT BACK, ARITY 3] : PAY, 
   [COORD @D99090, AGR [COUNT @D99089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT BACK, ARITY 3] : PAY, 
   [COORD @D99094, AGR [COUNT @D99093, PER @D99092, PLU @D99091, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT BACK, ARITY 3] : PAY, 
   [COORD @D99100, PAST @D99099, 
      AGR [CASE @D99098, COUNT @D99097, PER @D99096, PLU @D99095, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT BACK, 
      ARITY 3] : PAY, 
   [COORD @D99103, AGR [COUNT @D99102, PER @D99101, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99105, AGR [COUNT @D99104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99107, AGR [COUNT @D99106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99111, AGR [COUNT @D99110, PER @D99109, PLU @D99108, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99117, PAST @D99116, 
      AGR [CASE @D99115, COUNT @D99114, PER @D99113, PLU @D99112, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      ARITY 3] : PAY, 
   [COORD @D99120, AGR [COUNT @D99119, PER @D99118, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT BACK, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99122, AGR [COUNT @D99121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT BACK, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99124, AGR [COUNT @D99123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT BACK, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99128, AGR [COUNT @D99127, PER @D99126, PLU @D99125, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PRT BACK, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99134, PAST @D99133, 
      AGR [CASE @D99132, COUNT @D99131, PER @D99130, PLU @D99129, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PRT BACK, 
      PFORM TO, ARITY 3] : PAY, 
   [COORD @D99137, AGR [COUNT @D99136, PER @D99135, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : PAY, 
   [COORD @D99139, AGR [COUNT @D99138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : PAY, 
   [COORD @D99141, AGR [COUNT @D99140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : PAY, 
   [COORD @D99145, AGR [COUNT @D99144, PER @D99143, PLU @D99142, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : PAY, 
   [COORD @D99151, PAST @D99150, 
      AGR [CASE @D99149, COUNT @D99148, PER @D99147, PLU @D99146, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, 
      ARITY 3] : PAY, 
   [COORD @D99154, AGR [COUNT @D99153, PER @D99152, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99156, AGR [COUNT @D99155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99158, AGR [COUNT @D99157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99162, AGR [COUNT @D99161, PER @D99160, PLU @D99159, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99168, PAST @D99167, 
      AGR [CASE @D99166, COUNT @D99165, PER @D99164, PLU @D99163, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      ARITY 3] : PAY, 
   [COORD @D99171, AGR [COUNT @D99170, PER @D99169, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99173, AGR [COUNT @D99172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99175, AGR [COUNT @D99174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99179, AGR [COUNT @D99178, PER @D99177, PLU @D99176, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99185, PAST @D99184, 
      AGR [CASE @D99183, COUNT @D99182, PER @D99181, PLU @D99180, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, PFORM TO, ARITY 3] : PAY, 
   [COORD @D99188, AGR [COUNT @D99187, PER @D99186, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99190, AGR [COUNT @D99189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99192, AGR [COUNT @D99191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99196, AGR [COUNT @D99195, PER @D99194, PLU @D99193, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99202, PAST @D99201, 
      AGR [CASE @D99200, COUNT @D99199, PER @D99198, PLU @D99197, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM FOR, ARITY 3] : PAY, 
   [COORD @D99205, AGR [COUNT @D99204, PER @D99203, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : PAY, 
   [COORD @D99207, AGR [COUNT @D99206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : PAY, 
   [COORD @D99209, AGR [COUNT @D99208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : PAY, 
   [COORD @D99213, AGR [COUNT @D99212, PER @D99211, PLU @D99210, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 2] : PAY, 
   [COORD @D99219, PAST @D99218, 
      AGR [CASE @D99217, COUNT @D99216, PER @D99215, PLU @D99214, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, ARITY 2] : 
   PAY, 
   [COORD @D99222, AGR [COUNT @D99221, PER @D99220, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : PAY, 
   [COORD @D99224, AGR [COUNT @D99223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : PAY, 
   [COORD @D99226, AGR [COUNT @D99225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : PAY, 
   [COORD @D99230, AGR [COUNT @D99229, PER @D99228, PLU @D99227, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : PAY, 
   [COORD @D99236, PAST @D99235, AGR [CASE @D99234, COUNT @D99233, 
            PER @D99232, PLU @D99231, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : PAY, 
   [COORD @D99239, AGR [COUNT @D99238, PER @D99237, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : PAY, 
   [COORD @D99241, AGR [COUNT @D99240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : PAY, 
   [COORD @D99243, AGR [COUNT @D99242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : PAY, 
   [COORD @D99247, AGR [COUNT @D99246, PER @D99245, PLU @D99244, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : PAY, 
   [COORD @D99253, PAST @D99252, AGR 
         [CASE @D99251, COUNT @D99250, PER @D99249, PLU @D99248, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : 
   PAY, 
   [COORD @D99256, AGR [COUNT @D99255, PER @D99254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : PAY, 
   [COORD @D99258, AGR [COUNT @D99257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : PAY, 
   [COORD @D99260, AGR [COUNT @D99259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : PAY, 
   [COORD @D99264, AGR [COUNT @D99263, PER @D99262, PLU @D99261, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : PAY, 
   [COORD @D99270, PAST @D99269, AGR [CASE @D99268, COUNT @D99267, 
            PER @D99266, PLU @D99265, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : PAY, 
   [COORD @D99273, 
      AGR [COUNT @D99272, PER @D99271, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, 
      ARITY 2] : PAY, 
   [COORD @D99275, AGR [COUNT @D99274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : PAY, 
   [COORD @D99277, AGR [COUNT @D99276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : PAY, 
   [COORD @D99281, AGR [COUNT @D99280, PER @D99279, PLU @D99278, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : PAY, 
   [COORD @D99287, PAST @D99286, 
      AGR [CASE @D99285, COUNT @D99284, PER @D99283, PLU @D99282, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : PAY, 
   [COORD @D99290, AGR [COUNT @D99289, PER @D99288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : PAY, 
   [COORD @D99292, AGR [COUNT @D99291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : PAY, 
   [COORD @D99294, AGR [COUNT @D99293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : PAY, 
   [COORD @D99298, AGR [COUNT @D99297, PER @D99296, PLU @D99295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : PAY, 
   [COORD @D99304, PAST @D99303, 
      AGR [CASE @D99302, COUNT @D99301, PER @D99300, PLU @D99299, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : PAY, 
   [COORD @D99307, AGR [COUNT @D99306, PER @D99305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : PAY, 
   [COORD @D99309, AGR [COUNT @D99308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : PAY, 
   [COORD @D99311, AGR [COUNT @D99310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : PAY, 
   [COORD @D99315, AGR [COUNT @D99314, PER @D99313, PLU @D99312, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : PAY, 
   [COORD @D99321, PAST @D99320, 
      AGR [CASE @D99319, COUNT @D99318, PER @D99317, PLU @D99316, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : PAY, 
   [COORD @D99324, AGR [COUNT @D99323, PER @D99322, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : PAY, 
   [COORD @D99326, AGR [COUNT @D99325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : PAY, 
   [COORD @D99328, AGR [COUNT @D99327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : PAY, 
   [COORD @D99332, AGR [COUNT @D99331, PER @D99330, PLU @D99329, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : PAY, 
   [COORD @D99338, PAST @D99337, 
      AGR [CASE @D99336, COUNT @D99335, PER @D99334, PLU @D99333, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : PAY, 
   [COORD @D99341, AGR [COUNT @D99340, PER @D99339, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PAY, 
   [COORD @D99343, AGR [COUNT @D99342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PAY, 
   [COORD @D99345, AGR [COUNT @D99344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PAY, 
   [COORD @D99349, AGR [COUNT @D99348, PER @D99347, PLU @D99346, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : PAY, 
   [COORD @D99355, PAST @D99354, 
      AGR [CASE @D99353, COUNT @D99352, PER @D99351, PLU @D99350, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PAY, 
   [COORD @D99358, AGR [COUNT @D99357, PER @D99356, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : PAY, 
   [COORD @D99360, AGR [COUNT @D99359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : PAY, 
   [COORD @D99362, AGR [COUNT @D99361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : PAY, 
   [COORD @D99366, AGR [COUNT @D99365, PER @D99364, PLU @D99363, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : PAY, 
   [COORD @D99372, PAST @D99371, AGR 
         [CASE @D99370, COUNT @D99369, PER @D99368, PLU @D99367, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   PAY, 
   [COORD @D99375, AGR [COUNT @D99374, PER @D99373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : PAY, 
   [COORD @D99377, AGR [COUNT @D99376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : PAY, 
   [COORD @D99379, AGR [COUNT @D99378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : PAY, 
   [COORD @D99383, AGR [COUNT @D99382, PER @D99381, PLU @D99380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : PAY, 
   [COORD @D99389, PAST @D99388, 
      AGR [CASE @D99387, COUNT @D99386, PER @D99385, PLU @D99384, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      ARITY 1] : PAY, 
   [COORD @D99392, AGR [COUNT @D99391, PER @D99390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : PAY, 
   [COORD @D99394, AGR [COUNT @D99393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : PAY, 
   [COORD @D99396, AGR [COUNT @D99395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : PAY, 
   [COORD @D99400, AGR [COUNT @D99399, PER @D99398, PLU @D99397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : PAY, 
   [COORD @D99406, PAST @D99405, 
      AGR [CASE @D99404, COUNT @D99403, PER @D99402, PLU @D99401, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      ARITY 1] : PAY, 
   [COORD @D99409, AGR [COUNT @D99408, PER @D99407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : PAY, 
   [COORD @D99411, AGR [COUNT @D99410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : PAY, 
   [COORD @D99413, AGR [COUNT @D99412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : PAY, 
   [COORD @D99417, AGR [COUNT @D99416, PER @D99415, PLU @D99414, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : PAY, 
   [COORD @D99423, PAST @D99422, 
      AGR [CASE @D99421, COUNT @D99420, PER @D99419, PLU @D99418, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      ARITY 1] : PAY, 
   [COORD @D99426, AGR [COUNT @D99425, PER @D99424, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : PAY, 
   [COORD @D99428, AGR [COUNT @D99427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : PAY, 
   [COORD @D99430, AGR [COUNT @D99429, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : PAY, 
   [COORD @D99434, AGR [COUNT @D99433, PER @D99432, PLU @D99431, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : PAY, 
   [COORD @D99440, PAST @D99439, 
      AGR [CASE @D99438, COUNT @D99437, PER @D99436, PLU @D99435, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      ARITY 1] : PAY, 
   [COORD @D99443, AGR [COUNT @D99442, PER @D99441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : PAY, 
   [COORD @D99445, AGR [COUNT @D99444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : PAY, 
   [COORD @D99447, AGR [COUNT @D99446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : PAY, 
   [COORD @D99451, AGR [COUNT @D99450, PER @D99449, PLU @D99448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : PAY, 
   [COORD @D99457, PAST @D99456, 
      AGR [CASE @D99455, COUNT @D99454, PER @D99453, PLU @D99452, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      ARITY 1] : PAY, 
   [COORD @D99460, AGR [COUNT @D99459, PER @D99458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : PAY, 
   [COORD @D99462, AGR [COUNT @D99461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : PAY, 
   [COORD @D99464, AGR [COUNT @D99463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : PAY, 
   [COORD @D99468, AGR [COUNT @D99467, PER @D99466, PLU @D99465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : PAY, 
   [COORD @D99474, PAST @D99473, 
      AGR [CASE @D99472, COUNT @D99471, PER @D99470, PLU @D99469, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      ARITY 1] : PAY.

WORD paying : 
   [COORD @D99486, PRD @D99485, AGR [CASE @D99484, COUNT @D99483, 
            PER @D99482, PLU @D99481, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99492, PRD @D99491, AGR 
         [CASE @D99490, COUNT @D99489, PER @D99488, PLU @D99487, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   
   [COORD @D99498, PRD @D99497, AGR [CASE @D99496, COUNT @D99495, PER 
               @D99494, PLU @D99493, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99504, PRD @D99503, 
      AGR [CASE @D99502, COUNT @D99501, PER @D99500, PLU @D99499, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PAY, 
   [COORD @D99510, PRD @D99509, AGR [CASE @D99508, COUNT @D99507, 
            PER @D99506, PLU @D99505, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PRT BACK, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   
   [COORD @D99516, PRD @D99515, AGR [CASE @D99514, COUNT @D99513, PER 
               @D99512, PLU @D99511, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99522, PRD @D99521, 
      AGR [CASE @D99520, COUNT @D99519, PER @D99518, PLU @D99517, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PAY, 
   [COORD @D99528, PRD @D99527, AGR [CASE @D99526, COUNT @D99525, 
            PER @D99524, PLU @D99523, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99534, PRD @D99533, 
      AGR [CASE @D99532, COUNT @D99531, PER @D99530, PLU @D99529, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PAY, 
   [COORD @D99540, PRD @D99539, AGR [CASE @D99538, COUNT @D99537, 
            PER @D99536, PLU @D99535, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99546, PRD @D99545, AGR 
         [CASE @D99544, COUNT @D99543, PER @D99542, PLU @D99541, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   
   [COORD @D99552, PRD @D99551, AGR [CASE @D99550, COUNT @D99549, PER 
               @D99548, PLU @D99547, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99558, PRD @D99557, AGR 
         [CASE @D99556, COUNT @D99555, PER @D99554, PLU @D99553, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PAY, 
   [COORD @D99564, PRD @D99563, AGR [CASE @D99562, COUNT @D99561, 
            PER @D99560, PLU @D99559, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99570, PRD @D99569, 
      AGR [CASE @D99568, COUNT @D99567, PER @D99566, PLU @D99565, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PAY, 
   [COORD @D99576, PRD @D99575, AGR [CASE @D99574, COUNT @D99573, 
            PER @D99572, PLU @D99571, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99582, PRD @D99581, 
      AGR [CASE @D99580, COUNT @D99579, PER @D99578, PLU @D99577, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PAY, 
   [COORD @D99588, PRD @D99587, AGR [CASE @D99586, COUNT @D99585, 
            PER @D99584, PLU @D99583, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99594, PRD @D99593, 
      AGR [CASE @D99592, COUNT @D99591, PER @D99590, PLU @D99589, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   
   [COORD @D99600, PRD @D99599, AGR [CASE @D99598, COUNT @D99597, PER 
               @D99596, PLU @D99595, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99606, PRD @D99605, 
      AGR [CASE @D99604, COUNT @D99603, PER @D99602, PLU @D99601, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PAY, 
   [COORD @D99612, PRD @D99611, AGR [CASE @D99610, COUNT @D99609, 
            PER @D99608, PLU @D99607, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99618, PRD @D99617, 
      AGR [CASE @D99616, COUNT @D99615, PER @D99614, PLU @D99613, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PAY, 
   [COORD @D99624, PRD @D99623, AGR [CASE @D99622, COUNT @D99621, 
            PER @D99620, PLU @D99619, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PAY, 
   [COORD @D99630, PRD @D99629, 
      AGR [CASE @D99628, COUNT @D99627, PER @D99626, PLU @D99625, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PAY.

WORD pays : 
   [COORD @D99636, AGR [COUNT @D99635, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99638, 
      AGR [COUNT @D99637, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99640, 
      AGR [COUNT @D99639, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99642, 
      AGR [COUNT @D99641, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99644, 
      AGR [COUNT @D99643, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PRT BACK, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PAY, 
   [COORD @D99646, AGR [COUNT @D99645, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PAY, 
   [COORD @D99648, AGR [COUNT @D99647, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99650, 
      AGR [COUNT @D99649, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PAY, 
   [COORD @D99652, AGR [COUNT @D99651, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PAY, 
   [COORD @D99654, AGR [COUNT @D99653, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99656, 
      AGR [COUNT @D99655, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99658, 
      AGR [COUNT @D99657, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99660, 
      AGR [COUNT @D99659, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99662, 
      AGR [COUNT @D99661, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99664, 
      AGR [COUNT @D99663, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99666, 
      AGR [COUNT @D99665, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99668, 
      AGR [COUNT @D99667, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99670, 
      AGR [COUNT @D99669, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99672, 
      AGR [COUNT @D99671, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99674, 
      AGR [COUNT @D99673, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99676, 
      AGR [COUNT @D99675, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99678, 
      AGR [COUNT @D99677, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99680, 
      AGR [COUNT @D99679, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99682, 
      AGR [COUNT @D99681, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY, 
   [COORD @D99684, 
      AGR [COUNT @D99683, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PAY.

WORD perform : 
   [COORD @D99690, AGR [COUNT @D99689, PER @D99688, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PERFORM, 
   [COORD @D99692, AGR [COUNT @D99691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PERFORM, 
   [COORD @D99694, AGR [COUNT @D99693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PERFORM, 
   [COORD @D99698, AGR [COUNT @D99697, PER @D99696, PLU @D99695, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PERFORM, 
   [COORD @D99704, PAST @D99703, AGR [CASE @D99702, COUNT @D99701, 
            PER @D99700, PLU @D99699, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PERFORM, 
   [COORD @D99707, AGR [COUNT @D99706, PER @D99705, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PERFORM, 
   [COORD @D99709, AGR [COUNT @D99708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PERFORM, 
   [COORD @D99711, AGR [COUNT @D99710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PERFORM, 
   [COORD @D99715, AGR [COUNT @D99714, PER @D99713, PLU @D99712, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PERFORM, 
   [COORD @D99721, PAST @D99720, AGR [CASE @D99719, COUNT @D99718, 
            PER @D99717, PLU @D99716, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : PERFORM, 
   [COORD @D99724, AGR [COUNT @D99723, PER @D99722, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERFORM, 
   [COORD @D99726, AGR [COUNT @D99725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERFORM, 
   [COORD @D99728, AGR [COUNT @D99727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERFORM, 
   [COORD @D99732, AGR [COUNT @D99731, PER @D99730, PLU @D99729, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERFORM, 
   [COORD @D99738, PAST @D99737, AGR [CASE @D99736, COUNT @D99735, 
            PER @D99734, PLU @D99733, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PERFORM.

WORD performed : 
   [COORD @D99747, AGR [CASE @D99746, COUNT @D99745, PER @D99744, 
            PLU @D99743, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99752, AGR [CASE @D99751, COUNT @D99750, PER @D99749, 
            PLU @D99748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99757, AGR [CASE @D99756, COUNT @D99755, PER @D99754, 
            PLU @D99753, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PERFORM, 
   [COORD @D99762, AGR [CASE @D99761, COUNT @D99760, PER @D99759, 
            PLU @D99758, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99767, AGR [CASE @D99766, COUNT @D99765, PER @D99764, 
            PLU @D99763, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99772, AGR [CASE @D99771, COUNT @D99770, PER @D99769, 
            PLU @D99768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99777, AGR [CASE @D99776, COUNT @D99775, PER @D99774, 
            PLU @D99773, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PERFORM.

WORD performing : 
   [COORD @D99789, PRD @D99788, AGR [CASE @D99787, COUNT @D99786, 
            PER @D99785, PLU @D99784, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99795, PRD @D99794, 
      AGR [CASE @D99793, COUNT @D99792, PER @D99791, PLU @D99790, BAR 2, 
            V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PERFORM, 
   [COORD @D99801, PRD @D99800, AGR [CASE @D99799, COUNT @D99798, 
            PER @D99797, PLU @D99796, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PERFORM.

WORD performs : 
   [COORD @D99807, AGR [COUNT @D99806, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99809, 
      AGR [COUNT @D99808, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERFORM, 
   [COORD @D99811, 
      AGR [COUNT @D99810, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERFORM.

WORD permit : 
   [COORD @D99817, AGR [COUNT @D99816, PER @D99815, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PERMIT, 
   [COORD @D99819, AGR [COUNT @D99818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PERMIT, 
   [COORD @D99821, AGR [COUNT @D99820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PERMIT, 
   [COORD @D99825, AGR [COUNT @D99824, PER @D99823, PLU @D99822, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PERMIT, 
   [COORD @D99831, PAST @D99830, AGR [CASE @D99829, COUNT @D99828, 
            PER @D99827, PLU @D99826, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PERMIT, 
   [COORD @D99834, AGR [COUNT @D99833, PER @D99832, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PERMIT, 
   [COORD @D99836, AGR [COUNT @D99835, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PERMIT, 
   [COORD @D99838, AGR [COUNT @D99837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PERMIT, 
   [COORD @D99842, AGR [COUNT @D99841, PER @D99840, PLU @D99839, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PERMIT, 
   [COORD @D99848, PAST @D99847, AGR [CASE @D99846, COUNT @D99845, 
            PER @D99844, PLU @D99843, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : PERMIT, 
   [COORD @D99851, AGR [COUNT @D99850, PER @D99849, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PERMIT, 
   [COORD @D99853, AGR [COUNT @D99852, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PERMIT, 
   [COORD @D99855, AGR [COUNT @D99854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PERMIT, 
   [COORD @D99859, AGR [COUNT @D99858, PER @D99857, PLU @D99856, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PERMIT, 
   [COORD @D99865, PAST @D99864, AGR [CASE @D99863, COUNT @D99862, 
            PER @D99861, PLU @D99860, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PERMIT, 
   [COORD @D99868, AGR [COUNT @D99867, PER @D99866, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : PERMIT, 
   [COORD @D99870, AGR [COUNT @D99869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : PERMIT, 
   [COORD @D99872, AGR [COUNT @D99871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : PERMIT, 
   [COORD @D99876, AGR [COUNT @D99875, PER @D99874, PLU @D99873, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, ARITY 2] : PERMIT, 
   [COORD @D99882, PAST @D99881, 
      AGR [CASE @D99880, COUNT @D99879, PER @D99878, PLU @D99877, BAR 2, 
            V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PFORM OF, 
      ARITY 2] : PERMIT, 
   [COORD @D99885, AGR [COUNT @D99884, PER @D99883, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERMIT, 
   [COORD @D99887, AGR [COUNT @D99886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERMIT, 
   [COORD @D99889, AGR [COUNT @D99888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERMIT, 
   [COORD @D99893, AGR [COUNT @D99892, PER @D99891, PLU @D99890, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PERMIT, 
   [COORD @D99899, PAST @D99898, AGR [CASE @D99897, COUNT @D99896, 
            PER @D99895, PLU @D99894, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PERMIT.

WORD permits : 
   [COORD @D99905, AGR [COUNT @D99904, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99907, 
      AGR [COUNT @D99906, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99909, 
      AGR [COUNT @D99908, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99911, 
      AGR [COUNT @D99910, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99913, 
      AGR [COUNT @D99912, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PERMIT.

WORD permitted : 
   [COORD @D99922, AGR [CASE @D99921, COUNT @D99920, PER @D99919, 
            PLU @D99918, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PERMIT, 
   [COORD @D99927, AGR [CASE @D99926, COUNT @D99925, PER @D99924, 
            PLU @D99923, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99932, AGR [CASE @D99931, COUNT @D99930, PER @D99929, 
            PLU @D99928, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99937, AGR [CASE @D99936, COUNT @D99935, PER @D99934, 
            PLU @D99933, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99942, AGR [CASE @D99941, COUNT @D99940, PER @D99939, 
            PLU @D99938, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99948, AGR [CASE @D99947, NFORM @D99946, COUNT @D99945, 
            PER @D99944, PLU @D99943, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PERMIT, 
   [COORD @D99953, AGR [UB @D99952, VFORM @D99951, SUBJ @D99950, 
            FIN @D99949, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PERMIT, 
   [COORD @D99958, AGR [CASE @D99957, COUNT @D99956, PER @D99955, 
            PLU @D99954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99963, AGR [CASE @D99962, COUNT @D99961, PER @D99960, 
            PLU @D99959, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99968, AGR [CASE @D99967, COUNT @D99966, PER @D99965, 
            PLU @D99964, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PERMIT, 
   [COORD @D99973, AGR [CASE @D99972, COUNT @D99971, PER @D99970, 
            PLU @D99969, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99978, AGR [CASE @D99977, COUNT @D99976, PER @D99975, 
            PLU @D99974, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99983, AGR [CASE @D99982, COUNT @D99981, PER @D99980, 
            PLU @D99979, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99988, AGR [CASE @D99987, COUNT @D99986, PER @D99985, 
            PLU @D99984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D99993, AGR [CASE @D99992, COUNT @D99991, PER @D99990, 
            PLU @D99989, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PERMIT.

WORD permitting : 
   [COORD @D100005, PRD @D100004, AGR [CASE @D100003, COUNT @D100002, 
            PER @D100001, PLU @D100000, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D100011, PRD @D100010, 
      AGR [CASE @D100009, COUNT @D100008, PER @D100007, PLU @D100006, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PERMIT, 
   [COORD @D100017, PRD @D100016, AGR [CASE @D100015, COUNT @D100014, 
            PER @D100013, PLU @D100012, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PERMIT, 
   [COORD @D100023, PRD @D100022, 
      AGR [CASE @D100021, COUNT @D100020, PER @D100019, PLU @D100018, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PERMIT, 
   [COORD @D100029, PRD @D100028, AGR [CASE @D100027, COUNT @D100026, 
            PER @D100025, PLU @D100024, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PERMIT.

WORD pick : 
   [COORD @D100034, AGR [COUNT @D100033, PER @D100032, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PICK, 
   [COORD @D100036, AGR [COUNT @D100035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PICK, 
   [COORD @D100038, AGR [COUNT @D100037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PICK, 
   [COORD @D100042, AGR [COUNT @D100041, PER @D100040, PLU @D100039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PICK, 
   [COORD @D100048, PAST @D100047, AGR [CASE @D100046, COUNT @D100045, 
            PER @D100044, PLU @D100043, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : PICK, 
   [COORD @D100051, AGR [COUNT @D100050, PER @D100049, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PICK, 
   [COORD @D100053, AGR [COUNT @D100052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PICK, 
   [COORD @D100055, AGR [COUNT @D100054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PICK, 
   [COORD @D100059, AGR [COUNT @D100058, PER @D100057, PLU @D100056, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PICK, 
   [COORD @D100065, PAST @D100064, AGR [CASE @D100063, COUNT @D100062, 
            PER @D100061, PLU @D100060, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : PICK, 
   [COORD @D100068, AGR [COUNT @D100067, PER @D100066, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PICK, 
   [COORD @D100070, AGR [COUNT @D100069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PICK, 
   [COORD @D100072, AGR [COUNT @D100071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PICK, 
   [COORD @D100076, AGR [COUNT @D100075, PER @D100074, PLU @D100073, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PICK, 
   [COORD @D100082, PAST @D100081, 
      AGR [CASE @D100080, COUNT @D100079, PER @D100078, PLU @D100077, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : PICK, 
   [COORD @D100085, AGR [COUNT @D100084, PER @D100083, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : PICK, 
   [COORD @D100087, AGR [COUNT @D100086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : PICK, 
   [COORD @D100089, AGR [COUNT @D100088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : PICK, 
   [COORD @D100093, AGR [COUNT @D100092, PER @D100091, PLU @D100090, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : PICK, 
   [COORD @D100099, PAST @D100098, 
      AGR [CASE @D100097, COUNT @D100096, PER @D100095, PLU @D100094, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM ON, ARITY 3] : PICK, 
   [COORD @D100102, AGR [COUNT @D100101, PER @D100100, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PICK, 
   [COORD @D100104, AGR [COUNT @D100103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PICK, 
   [COORD @D100106, AGR [COUNT @D100105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PICK, 
   [COORD @D100110, AGR [COUNT @D100109, PER @D100108, PLU @D100107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PICK, 
   [COORD @D100116, PAST @D100115, 
      AGR [CASE @D100114, COUNT @D100113, PER @D100112, PLU @D100111, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM IN, ARITY 3] : PICK, 
   [COORD @D100119, AGR [COUNT @D100118, PER @D100117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : PICK, 
   [COORD @D100121, AGR [COUNT @D100120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : PICK, 
   [COORD @D100123, AGR [COUNT @D100122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : PICK, 
   [COORD @D100127, AGR [COUNT @D100126, PER @D100125, PLU @D100124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : PICK, 
   [COORD @D100133, PAST @D100132, 
      AGR [CASE @D100131, COUNT @D100130, PER @D100129, PLU @D100128, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : PICK, 
   [COORD @D100136, AGR [COUNT @D100135, PER @D100134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PICK, 
   [COORD @D100138, AGR [COUNT @D100137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PICK, 
   [COORD @D100140, AGR [COUNT @D100139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PICK, 
   [COORD @D100144, AGR [COUNT @D100143, PER @D100142, PLU @D100141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PICK, 
   [COORD @D100150, PAST @D100149, 
      AGR [CASE @D100148, COUNT @D100147, PER @D100146, PLU @D100145, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : PICK, 
   [COORD @D100153, AGR [COUNT @D100152, PER @D100151, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PICK, 
   [COORD @D100155, AGR [COUNT @D100154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PICK, 
   [COORD @D100157, AGR [COUNT @D100156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PICK, 
   [COORD @D100161, AGR [COUNT @D100160, PER @D100159, PLU @D100158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PICK, 
   [COORD @D100167, PAST @D100166, AGR [CASE @D100165, COUNT @D100164, 
            PER @D100163, PLU @D100162, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PICK, 
   [COORD @D100170, AGR [COUNT @D100169, PER @D100168, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PICK, 
   [COORD @D100172, AGR [COUNT @D100171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PICK, 
   [COORD @D100174, AGR [COUNT @D100173, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PICK, 
   [COORD @D100178, AGR [COUNT @D100177, PER @D100176, PLU @D100175, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : PICK, 
   [COORD @D100184, PAST @D100183, 
      AGR [CASE @D100182, COUNT @D100181, PER @D100180, PLU @D100179, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PICK, 
   [COORD @D100187, AGR [COUNT @D100186, PER @D100185, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PICK, 
   [COORD @D100189, AGR [COUNT @D100188, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PICK, 
   [COORD @D100191, AGR [COUNT @D100190, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PICK, 
   [COORD @D100195, AGR [COUNT @D100194, PER @D100193, PLU @D100192, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, ARITY 2] : PICK, 
   [COORD @D100201, PAST @D100200, 
      AGR [CASE @D100199, COUNT @D100198, PER @D100197, PLU @D100196, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PICK, 
   [COORD @D100204, AGR [COUNT @D100203, PER @D100202, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM AFTER, ARITY 2] : PICK, 
   [COORD @D100206, AGR [COUNT @D100205, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM AFTER, ARITY 2] : PICK, 
   [COORD @D100208, AGR [COUNT @D100207, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM AFTER, ARITY 2] : PICK, 
   [COORD @D100212, AGR [COUNT @D100211, PER @D100210, PLU @D100209, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM AFTER, ARITY 2] : PICK, 
   [COORD @D100218, PAST @D100217, 
      AGR [CASE @D100216, COUNT @D100215, PER @D100214, PLU @D100213, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM AFTER, ARITY 2] : PICK, 
   [COORD @D100221, AGR [COUNT @D100220, PER @D100219, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PICK, 
   [COORD @D100223, AGR [COUNT @D100222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PICK, 
   [COORD @D100225, AGR [COUNT @D100224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PICK, 
   [COORD @D100229, AGR [COUNT @D100228, PER @D100227, PLU @D100226, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : PICK, 
   [COORD @D100235, PAST @D100234, 
      AGR [CASE @D100233, COUNT @D100232, PER @D100231, PLU @D100230, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : PICK, 
   [COORD @D100238, AGR [COUNT @D100237, PER @D100236, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PICK, 
   [COORD @D100240, AGR [COUNT @D100239, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PICK, 
   [COORD @D100242, AGR [COUNT @D100241, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PICK, 
   [COORD @D100246, AGR [COUNT @D100245, PER @D100244, PLU @D100243, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : PICK, 
   [COORD @D100252, PAST @D100251, 
      AGR [CASE @D100250, COUNT @D100249, PER @D100248, PLU @D100247, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PICK, 
   [COORD @D100255, AGR [COUNT @D100254, PER @D100253, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PICK, 
   [COORD @D100257, AGR [COUNT @D100256, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PICK, 
   [COORD @D100259, AGR [COUNT @D100258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PICK, 
   [COORD @D100263, AGR [COUNT @D100262, PER @D100261, PLU @D100260, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : PICK, 
   [COORD @D100269, PAST @D100268, 
      AGR [CASE @D100267, COUNT @D100266, PER @D100265, PLU @D100264, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : PICK, 
   [COORD @D100272, AGR [COUNT @D100271, PER @D100270, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PICK, 
   [COORD @D100274, AGR [COUNT @D100273, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PICK, 
   [COORD @D100276, AGR [COUNT @D100275, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PICK, 
   [COORD @D100280, AGR [COUNT @D100279, PER @D100278, PLU @D100277, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : PICK, 
   [COORD @D100286, PAST @D100285, 
      AGR [CASE @D100284, COUNT @D100283, PER @D100282, PLU @D100281, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : PICK, 
   [COORD @D100289, AGR [COUNT @D100288, PER @D100287, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PICK, 
   [COORD @D100291, AGR [COUNT @D100290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PICK, 
   [COORD @D100293, AGR [COUNT @D100292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PICK, 
   [COORD @D100297, AGR [COUNT @D100296, PER @D100295, PLU @D100294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PICK, 
   [COORD @D100303, PAST @D100302, 
      AGR [CASE @D100301, COUNT @D100300, PER @D100299, PLU @D100298, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : PICK, 
   [COORD @D100306, AGR [COUNT @D100305, PER @D100304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PICK, 
   [COORD @D100308, AGR [COUNT @D100307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PICK, 
   [COORD @D100310, AGR [COUNT @D100309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PICK, 
   [COORD @D100314, AGR [COUNT @D100313, PER @D100312, PLU @D100311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PICK, 
   [COORD @D100320, PAST @D100319, 
      AGR [CASE @D100318, COUNT @D100317, PER @D100316, PLU @D100315, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : PICK, 
   [COORD @D100323, AGR [COUNT @D100322, PER @D100321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PICK, 
   [COORD @D100325, AGR [COUNT @D100324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PICK, 
   [COORD @D100327, AGR [COUNT @D100326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PICK, 
   [COORD @D100331, AGR [COUNT @D100330, PER @D100329, PLU @D100328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PICK, 
   [COORD @D100337, PAST @D100336, 
      AGR [CASE @D100335, COUNT @D100334, PER @D100333, PLU @D100332, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : PICK, 
   [COORD @D100340, AGR [COUNT @D100339, PER @D100338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PICK, 
   [COORD @D100342, AGR [COUNT @D100341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PICK, 
   [COORD @D100344, AGR [COUNT @D100343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PICK, 
   [COORD @D100348, AGR [COUNT @D100347, PER @D100346, PLU @D100345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PICK, 
   [COORD @D100354, PAST @D100353, 
      AGR [CASE @D100352, COUNT @D100351, PER @D100350, PLU @D100349, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : PICK.

WORD picked : 
   [COADV @D100365, COORD @D100364, DEF @D100363, PRD @D100362, 
      AGR [CASE @D100361, COUNT @D100360, PER @D100359, PLU @D100358, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : PICKED, 
   [COORD @D100370, AGR [CASE @D100369, COUNT @D100368, PER @D100367, 
            PLU @D100366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100375, AGR [CASE @D100374, COUNT @D100373, PER @D100372, 
            PLU @D100371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100381, AGR [CASE @D100380, NFORM @D100379, COUNT @D100378, 
            PER @D100377, PLU @D100376, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100386, AGR [CASE @D100385, COUNT @D100384, PER @D100383, 
            PLU @D100382, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100391, AGR [CASE @D100390, COUNT @D100389, PER @D100388, 
            PLU @D100387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100396, AGR [CASE @D100395, COUNT @D100394, PER @D100393, 
            PLU @D100392, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100401, AGR [CASE @D100400, COUNT @D100399, PER @D100398, 
            PLU @D100397, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100406, AGR [CASE @D100405, COUNT @D100404, PER @D100403, 
            PLU @D100402, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100411, AGR [CASE @D100410, COUNT @D100409, PER @D100408, 
            PLU @D100407, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100416, AGR [CASE @D100415, COUNT @D100414, PER @D100413, 
            PLU @D100412, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE PVERB_OE, PFORM ON, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100421, AGR [CASE @D100420, COUNT @D100419, PER @D100418, 
            PLU @D100417, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100426, 
      AGR [CASE @D100425, COUNT @D100424, PER @D100423, PLU @D100422, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100431, AGR [CASE @D100430, COUNT @D100429, PER @D100428, 
            PLU @D100427, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100436, AGR [CASE @D100435, COUNT @D100434, PER @D100433, 
            PLU @D100432, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100441, AGR [CASE @D100440, COUNT @D100439, PER @D100438, 
            PLU @D100437, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100446, AGR [CASE @D100445, COUNT @D100444, PER @D100443, 
            PLU @D100442, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100451, AGR [CASE @D100450, COUNT @D100449, PER @D100448, 
            PLU @D100447, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100456, AGR [CASE @D100455, COUNT @D100454, PER @D100453, 
            PLU @D100452, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100461, AGR [CASE @D100460, COUNT @D100459, PER @D100458, 
            PLU @D100457, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100466, AGR [CASE @D100465, COUNT @D100464, PER @D100463, 
            PLU @D100462, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100471, AGR [CASE @D100470, COUNT @D100469, PER @D100468, 
            PLU @D100467, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100476, AGR [CASE @D100475, COUNT @D100474, PER @D100473, 
            PLU @D100472, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100481, AGR [CASE @D100480, COUNT @D100479, PER @D100478, 
            PLU @D100477, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100486, AGR [CASE @D100485, COUNT @D100484, PER @D100483, 
            PLU @D100482, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100491, AGR [CASE @D100490, COUNT @D100489, PER @D100488, 
            PLU @D100487, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100496, AGR [CASE @D100495, COUNT @D100494, PER @D100493, 
            PLU @D100492, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100501, AGR [CASE @D100500, COUNT @D100499, PER @D100498, 
            PLU @D100497, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100506, AGR [CASE @D100505, COUNT @D100504, PER @D100503, 
            PLU @D100502, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100511, AGR [CASE @D100510, COUNT @D100509, PER @D100508, 
            PLU @D100507, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100516, AGR [CASE @D100515, COUNT @D100514, PER @D100513, 
            PLU @D100512, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100521, AGR [CASE @D100520, COUNT @D100519, PER @D100518, 
            PLU @D100517, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM AFTER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100526, 
      AGR [CASE @D100525, COUNT @D100524, PER @D100523, PLU @D100522, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM AFTER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100531, AGR [CASE @D100530, COUNT @D100529, PER @D100528, 
            PLU @D100527, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100536, AGR [CASE @D100535, COUNT @D100534, PER @D100533, 
            PLU @D100532, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100541, AGR [CASE @D100540, COUNT @D100539, PER @D100538, 
            PLU @D100537, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100546, AGR [CASE @D100545, COUNT @D100544, PER @D100543, 
            PLU @D100542, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100551, AGR [CASE @D100550, COUNT @D100549, PER @D100548, 
            PLU @D100547, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100556, AGR [CASE @D100555, COUNT @D100554, PER @D100553, 
            PLU @D100552, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100561, AGR [CASE @D100560, COUNT @D100559, PER @D100558, 
            PLU @D100557, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100566, AGR [CASE @D100565, COUNT @D100564, PER @D100563, 
            PLU @D100562, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100571, AGR [CASE @D100570, COUNT @D100569, PER @D100568, 
            PLU @D100567, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100576, AGR [CASE @D100575, COUNT @D100574, PER @D100573, 
            PLU @D100572, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100581, AGR [CASE @D100580, COUNT @D100579, PER @D100578, 
            PLU @D100577, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100586, AGR [CASE @D100585, COUNT @D100584, PER @D100583, 
            PLU @D100582, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100591, AGR [CASE @D100590, COUNT @D100589, PER @D100588, 
            PLU @D100587, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100596, AGR [CASE @D100595, COUNT @D100594, PER @D100593, 
            PLU @D100592, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100601, AGR [CASE @D100600, COUNT @D100599, PER @D100598, 
            PLU @D100597, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100606, AGR [CASE @D100605, COUNT @D100604, PER @D100603, 
            PLU @D100602, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100611, AGR [CASE @D100610, COUNT @D100609, PER @D100608, 
            PLU @D100607, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100616, AGR [CASE @D100615, COUNT @D100614, PER @D100613, 
            PLU @D100612, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK, 
   [COORD @D100621, AGR [CASE @D100620, COUNT @D100619, PER @D100618, 
            PLU @D100617, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100626, AGR [CASE @D100625, COUNT @D100624, PER @D100623, 
            PLU @D100622, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PICK.

WORD picking : 
   [COORD @D100637, PRD @D100636, AGR [CASE @D100635, COUNT @D100634, 
            PER @D100633, PLU @D100632, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100643, PRD @D100642, 
      AGR [CASE @D100641, COUNT @D100640, PER @D100639, PLU @D100638, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100649, PRD @D100648, AGR [CASE @D100647, COUNT @D100646, 
            PER @D100645, PLU @D100644, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100655, PRD @D100654, 
      AGR [CASE @D100653, COUNT @D100652, PER @D100651, PLU @D100650, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100661, PRD @D100660, AGR [CASE @D100659, COUNT @D100658, 
            PER @D100657, PLU @D100656, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100667, PRD @D100666, 
      AGR [CASE @D100665, COUNT @D100664, PER @D100663, PLU @D100662, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100673, PRD @D100672, AGR [CASE @D100671, COUNT @D100670, 
            PER @D100669, PLU @D100668, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100679, PRD @D100678, 
      AGR [CASE @D100677, COUNT @D100676, PER @D100675, PLU @D100674, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PICK, 
   [COORD @D100685, PRD @D100684, AGR [CASE @D100683, COUNT @D100682, 
            PER @D100681, PLU @D100680, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100691, PRD @D100690, 
      AGR [CASE @D100689, COUNT @D100688, PER @D100687, PLU @D100686, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PICK, 
   [COORD @D100697, PRD @D100696, AGR [CASE @D100695, COUNT @D100694, 
            PER @D100693, PLU @D100692, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM AFTER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100703, PRD @D100702, 
      AGR [CASE @D100701, COUNT @D100700, PER @D100699, PLU @D100698, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PICK, 
   [COORD @D100709, PRD @D100708, AGR [CASE @D100707, COUNT @D100706, 
            PER @D100705, PLU @D100704, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100715, PRD @D100714, 
      AGR [CASE @D100713, COUNT @D100712, PER @D100711, PLU @D100710, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PICK, 
   [COORD @D100721, PRD @D100720, AGR [CASE @D100719, COUNT @D100718, 
            PER @D100717, PLU @D100716, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100727, PRD @D100726, 
      AGR [CASE @D100725, COUNT @D100724, PER @D100723, PLU @D100722, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100733, PRD @D100732, AGR [CASE @D100731, COUNT @D100730, 
            PER @D100729, PLU @D100728, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK, 
   [COORD @D100739, PRD @D100738, 
      AGR [CASE @D100737, COUNT @D100736, PER @D100735, PLU @D100734, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100745, PRD @D100744, AGR [CASE @D100743, COUNT @D100742, 
            PER @D100741, PLU @D100740, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PICK.

WORD picks : 
   [COORD @D100750, AGR [COUNT @D100749, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PICK, 
   [COORD @D100752, AGR [COUNT @D100751, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PICK, 
   [COORD @D100754, 
      AGR [COUNT @D100753, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PICK, 
   [COORD @D100756, AGR [COUNT @D100755, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PICK, 
   [COORD @D100758, AGR [COUNT @D100757, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100760, AGR [COUNT @D100759, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100762, AGR [COUNT @D100761, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100764, AGR [COUNT @D100763, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PICK, 
   [COORD @D100766, 
      AGR [COUNT @D100765, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PICK, 
   [COORD @D100768, 
      AGR [COUNT @D100767, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PICK, 
   [COORD @D100770, 
      AGR [COUNT @D100769, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PICK, 
   [COORD @D100772, AGR [COUNT @D100771, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100774, AGR [COUNT @D100773, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100776, AGR [COUNT @D100775, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100778, AGR [COUNT @D100777, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100780, AGR [COUNT @D100779, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PICK, 
   [COORD @D100782, AGR [COUNT @D100781, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100784, AGR [COUNT @D100783, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK, 
   [COORD @D100786, AGR [COUNT @D100785, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PICK.

WORD pilot : 
   [COADV @D100796, COORD @D100795, DEF @D100794, PRD @D100793, 
      AGR [CASE @D100792, COUNT @D100791, PER @D100790, PLU @D100789, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : PILOT, 
   [COORD @D100800, REFL @D100799, PRD @D100798, CASE @D100797, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PILOT, 
   [COORD @D100803, 
      AGR [COUNT @D100802, PER @D100801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   PILOT, 
   [COORD @D100805, AGR [COUNT @D100804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PILOT, 
   [COORD @D100807, AGR [COUNT @D100806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PILOT, 
   [COORD @D100811, AGR [COUNT @D100810, PER @D100809, PLU @D100808, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PILOT, 
   [COORD @D100817, PAST @D100816, AGR [CASE @D100815, COUNT @D100814, 
            PER @D100813, PLU @D100812, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PILOT, 
   [COORD @D100820, AGR [COUNT @D100819, PER @D100818, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : PILOT, 
   [COORD @D100822, AGR [COUNT @D100821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : PILOT, 
   [COORD @D100824, AGR [COUNT @D100823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : PILOT, 
   [COORD @D100828, AGR [COUNT @D100827, PER @D100826, PLU @D100825, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM THROUGH, ARITY 3] : PILOT, 
   [COORD @D100834, PAST @D100833, 
      AGR [CASE @D100832, COUNT @D100831, PER @D100830, PLU @D100829, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM THROUGH, ARITY 3] : PILOT, 
   [COORD @D100837, AGR [COUNT @D100836, PER @D100835, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PILOT, 
   [COORD @D100839, AGR [COUNT @D100838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PILOT, 
   [COORD @D100841, AGR [COUNT @D100840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PILOT, 
   [COORD @D100845, AGR [COUNT @D100844, PER @D100843, PLU @D100842, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PILOT, 
   [COORD @D100851, PAST @D100850, AGR [CASE @D100849, COUNT @D100848, 
            PER @D100847, PLU @D100846, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PILOT.

WORD pilots : 
   [COORD @D100861, DEMON @D100860, REFL @D100859, PRD @D100858, 
      CASE @D100857, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PILOT, 
   [COORD @D100863, AGR [COUNT @D100862, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PILOT, 
   [COORD @D100865, AGR [COUNT @D100864, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PILOT, 
   [COORD @D100867, AGR [COUNT @D100866, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PILOT.

WORD pilotted : 
   [COORD @D100877, AGR [CASE @D100876, COUNT @D100875, PER @D100874, 
            PLU @D100873, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PILOT, 
   [COORD @D100882, AGR [CASE @D100881, COUNT @D100880, PER @D100879, 
            PLU @D100878, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100887, AGR [CASE @D100886, COUNT @D100885, PER @D100884, 
            PLU @D100883, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100892, AGR [CASE @D100891, COUNT @D100890, PER @D100889, 
            PLU @D100888, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100897, AGR [CASE @D100896, COUNT @D100895, PER @D100894, 
            PLU @D100893, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100902, AGR [CASE @D100901, COUNT @D100900, PER @D100899, 
            PLU @D100898, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100907, AGR [CASE @D100906, COUNT @D100905, PER @D100904, 
            PLU @D100903, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PILOT, 
   [COORD @D100912, AGR [CASE @D100911, COUNT @D100910, PER @D100909, 
            PLU @D100908, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100917, AGR [CASE @D100916, COUNT @D100915, PER @D100914, 
            PLU @D100913, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PILOT.

WORD pilotting : 
   [COORD @D100934, PRD @D100933, AGR [CASE @D100932, COUNT @D100931, 
            PER @D100930, PLU @D100929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100940, PRD @D100939, 
      AGR [CASE @D100938, COUNT @D100937, PER @D100936, PLU @D100935, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PILOT, 
   [COORD @D100946, PRD @D100945, AGR [CASE @D100944, COUNT @D100943, 
            PER @D100942, PLU @D100941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PILOT.

WORD place : 
   [COORD @D100955, REFL @D100954, COUNT @D100953, PRD @D100952, 
      CASE @D100951, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PLACE, 
   [COORD @D100959, REFL @D100958, PRD @D100957, CASE @D100956, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PLACE, 
   [COORD @D100963, REFL @D100962, PRD @D100961, CASE @D100960, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : PLACE, 
   [COORD @D100966, 
      AGR [COUNT @D100965, PER @D100964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   PLACE, 
   [COORD @D100968, AGR [COUNT @D100967, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PLACE, 
   [COORD @D100970, AGR [COUNT @D100969, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PLACE, 
   [COORD @D100974, AGR [COUNT @D100973, PER @D100972, PLU @D100971, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PLACE, 
   [COORD @D100980, PAST @D100979, AGR [CASE @D100978, COUNT @D100977, 
            PER @D100976, PLU @D100975, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PLACE, 
   [COORD @D100983, AGR [COUNT @D100982, PER @D100981, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLACE, 
   [COORD @D100985, AGR [COUNT @D100984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLACE, 
   [COORD @D100987, AGR [COUNT @D100986, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLACE, 
   [COORD @D100991, AGR [COUNT @D100990, PER @D100989, PLU @D100988, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PLACE, 
   [COORD @D100997, PAST @D100996, AGR [CASE @D100995, COUNT @D100994, 
            PER @D100993, PLU @D100992, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PLACE, 
   [COORD @D101000, AGR [COUNT @D100999, PER @D100998, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLACE, 
   [COORD @D101002, AGR [COUNT @D101001, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLACE, 
   [COORD @D101004, AGR [COUNT @D101003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLACE, 
   [COORD @D101008, AGR [COUNT @D101007, PER @D101006, PLU @D101005, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLACE, 
   [COORD @D101014, PAST @D101013, AGR [CASE @D101012, COUNT @D101011, 
            PER @D101010, PLU @D101009, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PLACE.

WORD placed : 
   [COADV @D101028, COORD @D101027, DEF @D101026, PRD @D101025, 
      AGR [CASE @D101024, COUNT @D101023, PER @D101022, PLU @D101021, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   PLACED, 
   [COORD @D101033, AGR [CASE @D101032, COUNT @D101031, PER @D101030, 
            PLU @D101029, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLACE, 
   [COORD @D101038, AGR [CASE @D101037, COUNT @D101036, PER @D101035, 
            PLU @D101034, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLACE, 
   [COORD @D101043, AGR [CASE @D101042, COUNT @D101041, PER @D101040, 
            PLU @D101039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLACE, 
   [COORD @D101048, AGR [CASE @D101047, COUNT @D101046, PER @D101045, 
            PLU @D101044, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLACE, 
   [COORD @D101053, AGR [CASE @D101052, COUNT @D101051, PER @D101050, 
            PLU @D101049, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLACE, 
   [COORD @D101058, AGR [CASE @D101057, COUNT @D101056, PER @D101055, 
            PLU @D101054, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLACE, 
   [COORD @D101063, AGR [CASE @D101062, COUNT @D101061, PER @D101060, 
            PLU @D101059, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLACE, 
   [COORD @D101068, AGR [CASE @D101067, COUNT @D101066, PER @D101065, 
            PLU @D101064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLACE.

WORD places : 
   [COORD @D101079, DEMON @D101078, REFL @D101077, PRD @D101076, 
      CASE @D101075, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PLACE, 
   [COORD @D101084, DEMON @D101083, REFL @D101082, PRD @D101081, 
      CASE @D101080, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PLACE, 
   [COORD @D101086, AGR [COUNT @D101085, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PLACE, 
   [COORD @D101088, AGR [COUNT @D101087, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLACE, 
   [COORD @D101090, 
      AGR [COUNT @D101089, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLACE.

WORD placing : 
   [COORD @D101102, PRD @D101101, AGR [CASE @D101100, COUNT @D101099, 
            PER @D101098, PLU @D101097, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLACE, 
   [COORD @D101108, PRD @D101107, 
      AGR [CASE @D101106, COUNT @D101105, PER @D101104, PLU @D101103, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLACE, 
   [COORD @D101114, PRD @D101113, AGR [CASE @D101112, COUNT @D101111, 
            PER @D101110, PLU @D101109, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLACE.

WORD plan : 
   [COORD @D101120, REFL @D101119, PRD @D101118, CASE @D101117, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PLAN, 
   [COORD @D101123, 
      AGR [COUNT @D101122, PER @D101121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : PLAN, 
   [COORD @D101125, AGR [COUNT @D101124, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PLAN, 
   [COORD @D101127, AGR [COUNT @D101126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PLAN, 
   [COORD @D101131, AGR [COUNT @D101130, PER @D101129, PLU @D101128, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PLAN, 
   [COORD @D101137, PAST @D101136, AGR [CASE @D101135, COUNT @D101134, 
            PER @D101133, PLU @D101132, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : PLAN, 
   [COORD @D101140, AGR [COUNT @D101139, PER @D101138, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLAN, 
   [COORD @D101142, AGR [COUNT @D101141, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLAN, 
   [COORD @D101144, AGR [COUNT @D101143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLAN, 
   [COORD @D101148, AGR [COUNT @D101147, PER @D101146, PLU @D101145, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PLAN, 
   [COORD @D101154, PAST @D101153, AGR [CASE @D101152, COUNT @D101151, 
            PER @D101150, PLU @D101149, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PLAN, 
   [COORD @D101157, AGR [COUNT @D101156, PER @D101155, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAN, 
   [COORD @D101159, AGR [COUNT @D101158, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAN, 
   [COORD @D101161, AGR [COUNT @D101160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAN, 
   [COORD @D101165, AGR [COUNT @D101164, PER @D101163, PLU @D101162, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : PLAN, 
   [COORD @D101171, PAST @D101170, 
      AGR [CASE @D101169, COUNT @D101168, PER @D101167, PLU @D101166, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAN, 
   [COORD @D101174, AGR [COUNT @D101173, PER @D101172, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAN, 
   [COORD @D101176, AGR [COUNT @D101175, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAN, 
   [COORD @D101178, AGR [COUNT @D101177, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAN, 
   [COORD @D101182, AGR [COUNT @D101181, PER @D101180, PLU @D101179, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : PLAN, 
   [COORD @D101188, PAST @D101187, 
      AGR [CASE @D101186, COUNT @D101185, PER @D101184, PLU @D101183, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAN, 
   [COORD @D101191, AGR [COUNT @D101190, PER @D101189, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PLAN, 
   [COORD @D101193, AGR [COUNT @D101192, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PLAN, 
   [COORD @D101195, AGR [COUNT @D101194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PLAN, 
   [COORD @D101199, AGR [COUNT @D101198, PER @D101197, PLU @D101196, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : PLAN, 
   [COORD @D101205, PAST @D101204, 
      AGR [CASE @D101203, COUNT @D101202, PER @D101201, PLU @D101200, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : PLAN, 
   [COORD @D101208, AGR [COUNT @D101207, PER @D101206, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAN, 
   [COORD @D101210, AGR [COUNT @D101209, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAN, 
   [COORD @D101212, AGR [COUNT @D101211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAN, 
   [COORD @D101216, AGR [COUNT @D101215, PER @D101214, PLU @D101213, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAN, 
   [COORD @D101222, PAST @D101221, AGR [CASE @D101220, COUNT @D101219, 
            PER @D101218, PLU @D101217, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PLAN, 
   [COORD @D101225, AGR [COUNT @D101224, PER @D101223, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLAN, 
   [COORD @D101227, AGR [COUNT @D101226, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLAN, 
   [COORD @D101229, AGR [COUNT @D101228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLAN, 
   [COORD @D101233, AGR [COUNT @D101232, PER @D101231, PLU @D101230, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLAN, 
   [COORD @D101239, PAST @D101238, 
      AGR [CASE @D101237, COUNT @D101236, PER @D101235, PLU @D101234, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : PLAN, 
   [COORD @D101242, AGR [COUNT @D101241, PER @D101240, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PLAN, 
   [COORD @D101244, AGR [COUNT @D101243, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PLAN, 
   [COORD @D101246, AGR [COUNT @D101245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PLAN, 
   [COORD @D101250, AGR [COUNT @D101249, PER @D101248, PLU @D101247, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PLAN, 
   [COORD @D101256, PAST @D101255, 
      AGR [CASE @D101254, COUNT @D101253, PER @D101252, PLU @D101251, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AHEAD, ARITY 1] : PLAN.

WORD planned : 
   [COORD @D101265, AGR [CASE @D101264, COUNT @D101263, PER @D101262, 
            PLU @D101261, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101270, AGR [CASE @D101269, COUNT @D101268, PER @D101267, 
            PLU @D101266, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101275, AGR [CASE @D101274, COUNT @D101273, PER @D101272, 
            PLU @D101271, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAN, 
   [COORD @D101280, AGR [CASE @D101279, COUNT @D101278, PER @D101277, 
            PLU @D101276, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101285, AGR [CASE @D101284, COUNT @D101283, PER @D101282, 
            PLU @D101281, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101290, AGR [CASE @D101289, COUNT @D101288, PER @D101287, 
            PLU @D101286, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101295, AGR [CASE @D101294, COUNT @D101293, PER @D101292, 
            PLU @D101291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101300, AGR [CASE @D101299, COUNT @D101298, PER @D101297, 
            PLU @D101296, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101305, AGR [CASE @D101304, COUNT @D101303, PER @D101302, 
            PLU @D101301, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101310, AGR [CASE @D101309, COUNT @D101308, PER @D101307, 
            PLU @D101306, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101315, AGR [CASE @D101314, COUNT @D101313, PER @D101312, 
            PLU @D101311, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101320, AGR [CASE @D101319, COUNT @D101318, PER @D101317, 
            PLU @D101316, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101325, AGR [CASE @D101324, COUNT @D101323, PER @D101322, 
            PLU @D101321, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101330, AGR [CASE @D101329, COUNT @D101328, PER @D101327, 
            PLU @D101326, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101335, AGR [CASE @D101334, COUNT @D101333, PER @D101332, 
            PLU @D101331, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101340, AGR [CASE @D101339, COUNT @D101338, PER @D101337, 
            PLU @D101336, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101345, AGR [CASE @D101344, COUNT @D101343, PER @D101342, 
            PLU @D101341, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101350, AGR [CASE @D101349, COUNT @D101348, PER @D101347, 
            PLU @D101346, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAN.

WORD planning : 
   [COORD @D101362, PRD @D101361, AGR [CASE @D101360, COUNT @D101359, 
            PER @D101358, PLU @D101357, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101368, PRD @D101367, 
      AGR [CASE @D101366, COUNT @D101365, PER @D101364, PLU @D101363, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAN, 
   [COORD @D101374, PRD @D101373, AGR [CASE @D101372, COUNT @D101371, 
            PER @D101370, PLU @D101369, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101380, PRD @D101379, 
      AGR [CASE @D101378, COUNT @D101377, PER @D101376, PLU @D101375, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAN, 
   [COORD @D101386, PRD @D101385, AGR [CASE @D101384, COUNT @D101383, 
            PER @D101382, PLU @D101381, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101392, PRD @D101391, 
      AGR [CASE @D101390, COUNT @D101389, PER @D101388, PLU @D101387, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAN, 
   [COORD @D101398, PRD @D101397, AGR [CASE @D101396, COUNT @D101395, 
            PER @D101394, PLU @D101393, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAN, 
   [COORD @D101404, PRD @D101403, 
      AGR [CASE @D101402, COUNT @D101401, PER @D101400, PLU @D101399, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAN.

WORD plans : 
   [COORD @D101413, DEMON @D101412, REFL @D101411, PRD @D101410, 
      CASE @D101409, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PLAN, 
   [COORD @D101415, AGR [COUNT @D101414, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PLAN, 
   [COORD @D101417, AGR [COUNT @D101416, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAN, 
   [COORD @D101419, 
      AGR [COUNT @D101418, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAN, 
   [COORD @D101421, 
      AGR [COUNT @D101420, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAN, 
   [COORD @D101423, 
      AGR [COUNT @D101422, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAN, 
   [COORD @D101425, 
      AGR [COUNT @D101424, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAN, 
   [COORD @D101427, 
      AGR [COUNT @D101426, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAN, 
   [COORD @D101429, 
      AGR [COUNT @D101428, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AHEAD, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAN.

WORD plant : 
   [COORD @D101438, REFL @D101437, COUNT @D101436, PRD @D101435, 
      CASE @D101434, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PLANT, 
   [COORD @D101441, 
      AGR [COUNT @D101440, PER @D101439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : PLANT, 
   [COORD @D101443, AGR [COUNT @D101442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PLANT, 
   [COORD @D101445, AGR [COUNT @D101444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PLANT, 
   [COORD @D101449, AGR [COUNT @D101448, PER @D101447, PLU @D101446, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PLANT, 
   [COORD @D101455, PAST @D101454, 
      AGR [CASE @D101453, COUNT @D101452, PER @D101451, PLU @D101450, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : PLANT, 
   [COORD @D101458, AGR [COUNT @D101457, PER @D101456, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLANT, 
   [COORD @D101460, AGR [COUNT @D101459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLANT, 
   [COORD @D101462, AGR [COUNT @D101461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLANT, 
   [COORD @D101466, AGR [COUNT @D101465, PER @D101464, PLU @D101463, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLANT, 
   [COORD @D101472, PAST @D101471, 
      AGR [CASE @D101470, COUNT @D101469, PER @D101468, PLU @D101467, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : PLANT, 
   [COORD @D101475, AGR [COUNT @D101474, PER @D101473, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLANT, 
   [COORD @D101477, AGR [COUNT @D101476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLANT, 
   [COORD @D101479, AGR [COUNT @D101478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLANT, 
   [COORD @D101483, AGR [COUNT @D101482, PER @D101481, PLU @D101480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLANT, 
   [COORD @D101489, PAST @D101488, 
      AGR [CASE @D101487, COUNT @D101486, PER @D101485, PLU @D101484, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM IN, ARITY 3] : PLANT, 
   [COORD @D101492, AGR [COUNT @D101491, PER @D101490, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLANT, 
   [COORD @D101494, AGR [COUNT @D101493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLANT, 
   [COORD @D101496, AGR [COUNT @D101495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLANT, 
   [COORD @D101500, AGR [COUNT @D101499, PER @D101498, PLU @D101497, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PLANT, 
   [COORD @D101506, PAST @D101505, AGR [CASE @D101504, COUNT @D101503, 
            PER @D101502, PLU @D101501, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PLANT, 
   [COORD @D101509, AGR [COUNT @D101508, PER @D101507, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PLANT, 
   [COORD @D101511, AGR [COUNT @D101510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PLANT, 
   [COORD @D101513, AGR [COUNT @D101512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PLANT, 
   [COORD @D101517, AGR [COUNT @D101516, PER @D101515, PLU @D101514, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : PLANT, 
   [COORD @D101523, PAST @D101522, 
      AGR [CASE @D101521, COUNT @D101520, PER @D101519, PLU @D101518, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : PLANT, 
   [COORD @D101526, AGR [COUNT @D101525, PER @D101524, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLANT, 
   [COORD @D101528, AGR [COUNT @D101527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLANT, 
   [COORD @D101530, AGR [COUNT @D101529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLANT, 
   [COORD @D101534, AGR [COUNT @D101533, PER @D101532, PLU @D101531, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLANT, 
   [COORD @D101540, PAST @D101539, AGR [CASE @D101538, COUNT @D101537, 
            PER @D101536, PLU @D101535, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PLANT, 
   [COORD @D101543, AGR [COUNT @D101542, PER @D101541, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLANT, 
   [COORD @D101545, AGR [COUNT @D101544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLANT, 
   [COORD @D101547, AGR [COUNT @D101546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLANT, 
   [COORD @D101551, AGR [COUNT @D101550, PER @D101549, PLU @D101548, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PLANT, 
   [COORD @D101557, PAST @D101556, 
      AGR [CASE @D101555, COUNT @D101554, PER @D101553, PLU @D101552, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : PLANT.

WORD planted : 
   [COORD @D101570, AGR [CASE @D101569, COUNT @D101568, PER @D101567, 
            PLU @D101566, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101575, AGR [CASE @D101574, COUNT @D101573, PER @D101572, 
            PLU @D101571, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101580, AGR [CASE @D101579, COUNT @D101578, PER @D101577, 
            PLU @D101576, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101585, AGR [CASE @D101584, COUNT @D101583, PER @D101582, 
            PLU @D101581, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101590, AGR [CASE @D101589, COUNT @D101588, PER @D101587, 
            PLU @D101586, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101595, AGR [CASE @D101594, COUNT @D101593, PER @D101592, 
            PLU @D101591, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101600, AGR [CASE @D101599, COUNT @D101598, PER @D101597, 
            PLU @D101596, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101605, AGR [CASE @D101604, COUNT @D101603, PER @D101602, 
            PLU @D101601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101610, AGR [CASE @D101609, COUNT @D101608, PER @D101607, 
            PLU @D101606, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101615, AGR [CASE @D101614, COUNT @D101613, PER @D101612, 
            PLU @D101611, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLANT, 
   [COORD @D101620, AGR [CASE @D101619, COUNT @D101618, PER @D101617, 
            PLU @D101616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101625, AGR [CASE @D101624, COUNT @D101623, PER @D101622, 
            PLU @D101621, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101630, AGR [CASE @D101629, COUNT @D101628, PER @D101627, 
            PLU @D101626, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101635, AGR [CASE @D101634, COUNT @D101633, PER @D101632, 
            PLU @D101631, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101640, AGR [CASE @D101639, COUNT @D101638, PER @D101637, 
            PLU @D101636, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101645, AGR [CASE @D101644, COUNT @D101643, PER @D101642, 
            PLU @D101641, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101650, AGR [CASE @D101649, COUNT @D101648, PER @D101647, 
            PLU @D101646, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101655, AGR [CASE @D101654, COUNT @D101653, PER @D101652, 
            PLU @D101651, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101660, AGR [CASE @D101659, COUNT @D101658, PER @D101657, 
            PLU @D101656, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLANT.

WORD planting : 
   [COORD @D101682, PRD @D101681, AGR [CASE @D101680, COUNT @D101679, 
            PER @D101678, PLU @D101677, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101688, PRD @D101687, 
      AGR [CASE @D101686, COUNT @D101685, PER @D101684, PLU @D101683, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLANT, 
   [COORD @D101694, PRD @D101693, AGR [CASE @D101692, COUNT @D101691, 
            PER @D101690, PLU @D101689, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101700, PRD @D101699, 
      AGR [CASE @D101698, COUNT @D101697, PER @D101696, PLU @D101695, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLANT, 
   [COORD @D101706, PRD @D101705, AGR [CASE @D101704, COUNT @D101703, 
            PER @D101702, PLU @D101701, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLANT, 
   [COORD @D101712, PRD @D101711, 
      AGR [CASE @D101710, COUNT @D101709, PER @D101708, PLU @D101707, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLANT, 
   [COORD @D101718, PRD @D101717, AGR [CASE @D101716, COUNT @D101715, 
            PER @D101714, PLU @D101713, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLANT.

WORD plants : 
   [COORD @D101731, DEMON @D101730, REFL @D101729, PRD @D101728, 
      CASE @D101727, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PLANT, 
   [COORD @D101733, AGR [COUNT @D101732, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLANT, 
   [COORD @D101735, AGR [COUNT @D101734, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLANT, 
   [COORD @D101737, AGR [COUNT @D101736, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLANT, 
   [COORD @D101739, AGR [COUNT @D101738, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLANT, 
   [COORD @D101741, 
      AGR [COUNT @D101740, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLANT, 
   [COORD @D101743, 
      AGR [COUNT @D101742, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLANT, 
   [COORD @D101745, 
      AGR [COUNT @D101744, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLANT.

WORD play : 
   [COORD @D101751, REFL @D101750, PRD @D101749, CASE @D101748, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PLAY, 
   [COORD @D101756, REFL @D101755, COUNT @D101754, PRD @D101753, 
      CASE @D101752, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PLAY, 
   [COORD @D101759, 
      AGR [COUNT @D101758, PER @D101757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   PLAY, 
   [COORD @D101761, AGR [COUNT @D101760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PLAY, 
   [COORD @D101763, AGR [COUNT @D101762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PLAY, 
   [COORD @D101767, AGR [COUNT @D101766, PER @D101765, PLU @D101764, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PLAY, 
   [COORD @D101773, PAST @D101772, AGR [CASE @D101771, COUNT @D101770, 
            PER @D101769, PLU @D101768, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : PLAY, 
   [COORD @D101776, AGR [COUNT @D101775, PER @D101774, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PLAY, 
   [COORD @D101778, AGR [COUNT @D101777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PLAY, 
   [COORD @D101780, AGR [COUNT @D101779, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PLAY, 
   [COORD @D101784, AGR [COUNT @D101783, PER @D101782, PLU @D101781, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PLAY, 
   [COORD @D101790, PAST @D101789, AGR [CASE @D101788, COUNT @D101787, 
            PER @D101786, PLU @D101785, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PLAY, 
   [COORD @D101793, AGR [COUNT @D101792, PER @D101791, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PLAY, 
   [COORD @D101795, AGR [COUNT @D101794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PLAY, 
   [COORD @D101797, AGR [COUNT @D101796, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PLAY, 
   [COORD @D101801, AGR [COUNT @D101800, PER @D101799, PLU @D101798, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PLAY, 
   [COORD @D101807, PAST @D101806, 
      AGR [CASE @D101805, COUNT @D101804, PER @D101803, PLU @D101802, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : PLAY, 
   [COORD @D101810, AGR [COUNT @D101809, PER @D101808, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLAY, 
   [COORD @D101812, AGR [COUNT @D101811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLAY, 
   [COORD @D101814, AGR [COUNT @D101813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLAY, 
   [COORD @D101818, AGR [COUNT @D101817, PER @D101816, PLU @D101815, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PLAY, 
   [COORD @D101824, PAST @D101823, 
      AGR [CASE @D101822, COUNT @D101821, PER @D101820, PLU @D101819, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : PLAY, 
   [COORD @D101827, AGR [COUNT @D101826, PER @D101825, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLAY, 
   [COORD @D101829, AGR [COUNT @D101828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLAY, 
   [COORD @D101831, AGR [COUNT @D101830, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLAY, 
   [COORD @D101835, AGR [COUNT @D101834, PER @D101833, PLU @D101832, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PLAY, 
   [COORD @D101841, PAST @D101840, 
      AGR [CASE @D101839, COUNT @D101838, PER @D101837, PLU @D101836, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM IN, ARITY 3] : PLAY, 
   [COORD @D101844, AGR [COUNT @D101843, PER @D101842, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PLAY, 
   [COORD @D101846, AGR [COUNT @D101845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PLAY, 
   [COORD @D101848, AGR [COUNT @D101847, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PLAY, 
   [COORD @D101852, AGR [COUNT @D101851, PER @D101850, PLU @D101849, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PLAY, 
   [COORD @D101858, PAST @D101857, 
      AGR [CASE @D101856, COUNT @D101855, PER @D101854, PLU @D101853, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : PLAY, 
   [COORD @D101861, AGR [COUNT @D101860, PER @D101859, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : PLAY, 
   [COORD @D101863, AGR [COUNT @D101862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : PLAY, 
   [COORD @D101865, AGR [COUNT @D101864, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : PLAY, 
   [COORD @D101869, AGR [COUNT @D101868, PER @D101867, PLU @D101866, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : PLAY, 
   [COORD @D101875, PAST @D101874, 
      AGR [CASE @D101873, COUNT @D101872, PER @D101871, PLU @D101870, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AT, ARITY 3] : PLAY, 
   [COORD @D101878, AGR [COUNT @D101877, PER @D101876, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PLAY, 
   [COORD @D101880, AGR [COUNT @D101879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PLAY, 
   [COORD @D101882, AGR [COUNT @D101881, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PLAY, 
   [COORD @D101886, AGR [COUNT @D101885, PER @D101884, PLU @D101883, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PLAY, 
   [COORD @D101892, PAST @D101891, 
      AGR [CASE @D101890, COUNT @D101889, PER @D101888, PLU @D101887, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : PLAY, 
   [COORD @D101895, AGR [COUNT @D101894, PER @D101893, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM AGAINST, ARITY 3] : PLAY, 
   [COORD @D101897, 
      AGR [COUNT @D101896, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM AGAINST, ARITY 3] : PLAY, 
   [COORD @D101899, AGR [COUNT @D101898, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM AGAINST, ARITY 3] : PLAY, 
   [COORD @D101903, 
      AGR [COUNT @D101902, PER @D101901, PLU @D101900, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM AGAINST, ARITY 3] : PLAY, 
   [COORD @D101909, PAST @D101908, 
      AGR [CASE @D101907, COUNT @D101906, PER @D101905, PLU @D101904, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM AGAINST, ARITY 3] : PLAY, 
   [COORD @D101912, AGR [COUNT @D101911, PER @D101910, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : PLAY, 
   [COORD @D101914, AGR [COUNT @D101913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : PLAY, 
   [COORD @D101916, AGR [COUNT @D101915, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : PLAY, 
   [COORD @D101920, AGR [COUNT @D101919, PER @D101918, PLU @D101917, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : PLAY, 
   [COORD @D101926, PAST @D101925, AGR [CASE @D101924, COUNT @D101923, 
            PER @D101922, PLU @D101921, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : PLAY, 
   [COORD @D101929, AGR [COUNT @D101928, PER @D101927, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : PLAY, 
   [COORD @D101931, AGR [COUNT @D101930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : PLAY, 
   [COORD @D101933, AGR [COUNT @D101932, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : PLAY, 
   [COORD @D101937, AGR [COUNT @D101936, PER @D101935, PLU @D101934, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : PLAY, 
   [COORD @D101943, PAST @D101942, AGR [CASE @D101941, COUNT @D101940, 
            PER @D101939, PLU @D101938, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : PLAY, 
   [COORD @D101946, AGR [COUNT @D101945, PER @D101944, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLAY, 
   [COORD @D101948, AGR [COUNT @D101947, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLAY, 
   [COORD @D101950, AGR [COUNT @D101949, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PLAY, 
   [COORD @D101954, AGR [COUNT @D101953, PER @D101952, PLU @D101951, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PLAY, 
   [COORD @D101960, PAST @D101959, AGR [CASE @D101958, COUNT @D101957, 
            PER @D101956, PLU @D101955, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PLAY, 
   [COORD @D101963, AGR [COUNT @D101962, PER @D101961, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PLAY, 
   [COORD @D101965, AGR [COUNT @D101964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PLAY, 
   [COORD @D101967, AGR [COUNT @D101966, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PLAY, 
   [COORD @D101971, AGR [COUNT @D101970, PER @D101969, PLU @D101968, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : PLAY, 
   [COORD @D101977, PAST @D101976, AGR [CASE @D101975, COUNT @D101974, 
            PER @D101973, PLU @D101972, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : PLAY, 
   [COORD @D101980, AGR [COUNT @D101979, PER @D101978, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PLAY, 
   [COORD @D101982, AGR [COUNT @D101981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PLAY, 
   [COORD @D101984, AGR [COUNT @D101983, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PLAY, 
   [COORD @D101988, AGR [COUNT @D101987, PER @D101986, PLU @D101985, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PLAY, 
   [COORD @D101994, PAST @D101993, AGR [CASE @D101992, COUNT @D101991, 
            PER @D101990, PLU @D101989, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : PLAY, 
   [COORD @D101997, AGR [COUNT @D101996, PER @D101995, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : PLAY, 
   [COORD @D101999, AGR [COUNT @D101998, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : PLAY, 
   [COORD @D102001, AGR [COUNT @D102000, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : PLAY, 
   [COORD @D102005, AGR [COUNT @D102004, PER @D102003, PLU @D102002, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP AT, ARITY 2] : PLAY, 
   [COORD @D102011, PAST @D102010, 
      AGR [CASE @D102009, COUNT @D102008, PER @D102007, PLU @D102006, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP AT, ARITY 2] : PLAY, 
   [COORD @D102014, AGR [COUNT @D102013, PER @D102012, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102016, AGR [COUNT @D102015, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102018, AGR [COUNT @D102017, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102022, AGR [COUNT @D102021, PER @D102020, PLU @D102019, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102028, PAST @D102027, 
      AGR [CASE @D102026, COUNT @D102025, PER @D102024, PLU @D102023, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102031, AGR [COUNT @D102030, PER @D102029, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102033, AGR [COUNT @D102032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102035, AGR [COUNT @D102034, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102039, AGR [COUNT @D102038, PER @D102037, PLU @D102036, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT AROUND, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102045, PAST @D102044, 
      AGR [CASE @D102043, COUNT @D102042, PER @D102041, PLU @D102040, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102048, AGR [COUNT @D102047, PER @D102046, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102050, AGR [COUNT @D102049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102052, AGR [COUNT @D102051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102056, AGR [COUNT @D102055, PER @D102054, PLU @D102053, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ALONG, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102062, PAST @D102061, 
      AGR [CASE @D102060, COUNT @D102059, PER @D102058, PLU @D102057, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102065, AGR [COUNT @D102064, PER @D102063, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ABOUT, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102067, AGR [COUNT @D102066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ABOUT, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102069, AGR [COUNT @D102068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ABOUT, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102073, AGR [COUNT @D102072, PER @D102071, PLU @D102070, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ABOUT, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102079, PAST @D102078, 
      AGR [CASE @D102077, COUNT @D102076, PER @D102075, PLU @D102074, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ABOUT, PFORM WITH, ARITY 2] : PLAY, 
   [COORD @D102082, AGR [COUNT @D102081, PER @D102080, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : PLAY, 
   [COORD @D102084, AGR [COUNT @D102083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : PLAY, 
   [COORD @D102086, AGR [COUNT @D102085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : PLAY, 
   [COORD @D102090, AGR [COUNT @D102089, PER @D102088, PLU @D102087, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : PLAY, 
   [COORD @D102096, PAST @D102095, 
      AGR [CASE @D102094, COUNT @D102093, PER @D102092, PLU @D102091, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : PLAY, 
   [COORD @D102099, AGR [COUNT @D102098, PER @D102097, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : PLAY, 
   [COORD @D102101, AGR [COUNT @D102100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : PLAY, 
   [COORD @D102103, AGR [COUNT @D102102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : PLAY, 
   [COORD @D102107, AGR [COUNT @D102106, PER @D102105, PLU @D102104, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : PLAY, 
   [COORD @D102113, PAST @D102112, 
      AGR [CASE @D102111, COUNT @D102110, PER @D102109, PLU @D102108, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, ARITY 2] : PLAY, 
   [COORD @D102116, AGR [COUNT @D102115, PER @D102114, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAY, 
   [COORD @D102118, AGR [COUNT @D102117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAY, 
   [COORD @D102120, AGR [COUNT @D102119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAY, 
   [COORD @D102124, AGR [COUNT @D102123, PER @D102122, PLU @D102121, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : PLAY, 
   [COORD @D102130, PAST @D102129, 
      AGR [CASE @D102128, COUNT @D102127, PER @D102126, PLU @D102125, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PLAY, 
   [COORD @D102133, AGR [COUNT @D102132, PER @D102131, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAY, 
   [COORD @D102135, AGR [COUNT @D102134, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAY, 
   [COORD @D102137, AGR [COUNT @D102136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAY, 
   [COORD @D102141, AGR [COUNT @D102140, PER @D102139, PLU @D102138, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : PLAY, 
   [COORD @D102147, PAST @D102146, 
      AGR [CASE @D102145, COUNT @D102144, PER @D102143, PLU @D102142, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PLAY, 
   [COORD @D102150, AGR [COUNT @D102149, PER @D102148, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PLAY, 
   [COORD @D102152, AGR [COUNT @D102151, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PLAY, 
   [COORD @D102154, AGR [COUNT @D102153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PLAY, 
   [COORD @D102158, AGR [COUNT @D102157, PER @D102156, PLU @D102155, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, ARITY 2] : PLAY, 
   [COORD @D102164, PAST @D102163, 
      AGR [CASE @D102162, COUNT @D102161, PER @D102160, PLU @D102159, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PLAY, 
   [COORD @D102167, AGR [COUNT @D102166, PER @D102165, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PLAY, 
   [COORD @D102169, AGR [COUNT @D102168, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PLAY, 
   [COORD @D102171, AGR [COUNT @D102170, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PLAY, 
   [COORD @D102175, AGR [COUNT @D102174, PER @D102173, PLU @D102172, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : PLAY, 
   [COORD @D102181, PAST @D102180, 
      AGR [CASE @D102179, COUNT @D102178, PER @D102177, PLU @D102176, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PLAY, 
   [COORD @D102184, AGR [COUNT @D102183, PER @D102182, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PLAY, 
   [COORD @D102186, AGR [COUNT @D102185, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PLAY, 
   [COORD @D102188, AGR [COUNT @D102187, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PLAY, 
   [COORD @D102192, AGR [COUNT @D102191, PER @D102190, PLU @D102189, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : PLAY, 
   [COORD @D102198, PAST @D102197, 
      AGR [CASE @D102196, COUNT @D102195, PER @D102194, PLU @D102193, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : PLAY, 
   [COORD @D102201, AGR [COUNT @D102200, PER @D102199, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PLAY, 
   [COORD @D102203, AGR [COUNT @D102202, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PLAY, 
   [COORD @D102205, AGR [COUNT @D102204, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PLAY, 
   [COORD @D102209, AGR [COUNT @D102208, PER @D102207, PLU @D102206, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : PLAY, 
   [COORD @D102215, PAST @D102214, 
      AGR [CASE @D102213, COUNT @D102212, PER @D102211, PLU @D102210, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : PLAY, 
   [COORD @D102218, AGR [COUNT @D102217, PER @D102216, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PLAY, 
   [COORD @D102220, AGR [COUNT @D102219, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PLAY, 
   [COORD @D102222, AGR [COUNT @D102221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PLAY, 
   [COORD @D102226, AGR [COUNT @D102225, PER @D102224, PLU @D102223, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : PLAY, 
   [COORD @D102232, PAST @D102231, 
      AGR [CASE @D102230, COUNT @D102229, PER @D102228, PLU @D102227, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : PLAY, 
   [COORD @D102235, AGR [COUNT @D102234, PER @D102233, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PLAY, 
   [COORD @D102237, AGR [COUNT @D102236, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PLAY, 
   [COORD @D102239, AGR [COUNT @D102238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PLAY, 
   [COORD @D102243, AGR [COUNT @D102242, PER @D102241, PLU @D102240, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : PLAY, 
   [COORD @D102249, PAST @D102248, 
      AGR [CASE @D102247, COUNT @D102246, PER @D102245, PLU @D102244, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : PLAY, 
   [COORD @D102252, AGR [COUNT @D102251, PER @D102250, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PLAY, 
   [COORD @D102254, AGR [COUNT @D102253, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PLAY, 
   [COORD @D102256, AGR [COUNT @D102255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PLAY, 
   [COORD @D102260, AGR [COUNT @D102259, PER @D102258, PLU @D102257, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : PLAY, 
   [COORD @D102266, PAST @D102265, 
      AGR [CASE @D102264, COUNT @D102263, PER @D102262, PLU @D102261, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PLAY, 
   [COORD @D102269, AGR [COUNT @D102268, PER @D102267, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PLAY, 
   [COORD @D102271, AGR [COUNT @D102270, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PLAY, 
   [COORD @D102273, AGR [COUNT @D102272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PLAY, 
   [COORD @D102277, AGR [COUNT @D102276, PER @D102275, PLU @D102274, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, ARITY 2] : PLAY, 
   [COORD @D102283, PAST @D102282, 
      AGR [CASE @D102281, COUNT @D102280, PER @D102279, PLU @D102278, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PLAY, 
   [COORD @D102286, AGR [COUNT @D102285, PER @D102284, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : PLAY, 
   [COORD @D102288, AGR [COUNT @D102287, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : PLAY, 
   [COORD @D102290, AGR [COUNT @D102289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : PLAY, 
   [COORD @D102294, AGR [COUNT @D102293, PER @D102292, PLU @D102291, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ALONG, ARITY 2] : PLAY, 
   [COORD @D102300, PAST @D102299, 
      AGR [CASE @D102298, COUNT @D102297, PER @D102296, PLU @D102295, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ALONG, ARITY 2] : PLAY, 
   [COORD @D102303, AGR [COUNT @D102302, PER @D102301, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAY, 
   [COORD @D102305, AGR [COUNT @D102304, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAY, 
   [COORD @D102307, AGR [COUNT @D102306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAY, 
   [COORD @D102311, AGR [COUNT @D102310, PER @D102309, PLU @D102308, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PLAY, 
   [COORD @D102317, PAST @D102316, AGR [CASE @D102315, COUNT @D102314, 
            PER @D102313, PLU @D102312, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PLAY, 
   [COORD @D102320, AGR [COUNT @D102319, PER @D102318, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PLAY, 
   [COORD @D102322, AGR [COUNT @D102321, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PLAY, 
   [COORD @D102324, AGR [COUNT @D102323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PLAY, 
   [COORD @D102328, AGR [COUNT @D102327, PER @D102326, PLU @D102325, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PLAY, 
   [COORD @D102334, PAST @D102333, 
      AGR [CASE @D102332, COUNT @D102331, PER @D102330, PLU @D102329, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : PLAY, 
   [COORD @D102337, AGR [COUNT @D102336, PER @D102335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PLAY, 
   [COORD @D102339, AGR [COUNT @D102338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PLAY, 
   [COORD @D102341, AGR [COUNT @D102340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PLAY, 
   [COORD @D102345, AGR [COUNT @D102344, PER @D102343, PLU @D102342, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PLAY, 
   [COORD @D102351, PAST @D102350, 
      AGR [CASE @D102349, COUNT @D102348, PER @D102347, PLU @D102346, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT THROUGH, ARITY 1] : PLAY, 
   [COORD @D102354, AGR [COUNT @D102353, PER @D102352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PLAY, 
   [COORD @D102356, AGR [COUNT @D102355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PLAY, 
   [COORD @D102358, AGR [COUNT @D102357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PLAY, 
   [COORD @D102362, AGR [COUNT @D102361, PER @D102360, PLU @D102359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PLAY, 
   [COORD @D102368, PAST @D102367, 
      AGR [CASE @D102366, COUNT @D102365, PER @D102364, PLU @D102363, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : PLAY, 
   [COORD @D102371, AGR [COUNT @D102370, PER @D102369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PLAY, 
   [COORD @D102373, AGR [COUNT @D102372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PLAY, 
   [COORD @D102375, AGR [COUNT @D102374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PLAY, 
   [COORD @D102379, AGR [COUNT @D102378, PER @D102377, PLU @D102376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PLAY, 
   [COORD @D102385, PAST @D102384, 
      AGR [CASE @D102383, COUNT @D102382, PER @D102381, PLU @D102380, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : PLAY, 
   [COORD @D102388, AGR [COUNT @D102387, PER @D102386, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PLAY, 
   [COORD @D102390, AGR [COUNT @D102389, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PLAY, 
   [COORD @D102392, AGR [COUNT @D102391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PLAY, 
   [COORD @D102396, AGR [COUNT @D102395, PER @D102394, PLU @D102393, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PLAY, 
   [COORD @D102402, PAST @D102401, 
      AGR [CASE @D102400, COUNT @D102399, PER @D102398, PLU @D102397, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : PLAY, 
   [COORD @D102405, AGR [COUNT @D102404, PER @D102403, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PLAY, 
   [COORD @D102407, AGR [COUNT @D102406, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PLAY, 
   [COORD @D102409, AGR [COUNT @D102408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PLAY, 
   [COORD @D102413, AGR [COUNT @D102412, PER @D102411, PLU @D102410, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PLAY, 
   [COORD @D102419, PAST @D102418, 
      AGR [CASE @D102417, COUNT @D102416, PER @D102415, PLU @D102414, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : PLAY, 
   [COORD @D102422, AGR [COUNT @D102421, PER @D102420, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PLAY, 
   [COORD @D102424, AGR [COUNT @D102423, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PLAY, 
   [COORD @D102426, AGR [COUNT @D102425, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PLAY, 
   [COORD @D102430, AGR [COUNT @D102429, PER @D102428, PLU @D102427, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PLAY, 
   [COORD @D102436, PAST @D102435, 
      AGR [CASE @D102434, COUNT @D102433, PER @D102432, PLU @D102431, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT BACK, ARITY 1] : PLAY, 
   [COORD @D102439, AGR [COUNT @D102438, PER @D102437, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PLAY, 
   [COORD @D102441, AGR [COUNT @D102440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PLAY, 
   [COORD @D102443, AGR [COUNT @D102442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PLAY, 
   [COORD @D102447, AGR [COUNT @D102446, PER @D102445, PLU @D102444, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PLAY, 
   [COORD @D102453, PAST @D102452, 
      AGR [CASE @D102451, COUNT @D102450, PER @D102449, PLU @D102448, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AROUND, ARITY 1] : PLAY, 
   [COORD @D102456, AGR [COUNT @D102455, PER @D102454, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PLAY, 
   [COORD @D102458, AGR [COUNT @D102457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PLAY, 
   [COORD @D102460, AGR [COUNT @D102459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PLAY, 
   [COORD @D102464, AGR [COUNT @D102463, PER @D102462, PLU @D102461, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PLAY, 
   [COORD @D102470, PAST @D102469, 
      AGR [CASE @D102468, COUNT @D102467, PER @D102466, PLU @D102465, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ALONG, ARITY 1] : PLAY, 
   [COORD @D102473, AGR [COUNT @D102472, PER @D102471, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PLAY, 
   [COORD @D102475, AGR [COUNT @D102474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PLAY, 
   [COORD @D102477, AGR [COUNT @D102476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PLAY, 
   [COORD @D102481, AGR [COUNT @D102480, PER @D102479, PLU @D102478, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PLAY, 
   [COORD @D102487, PAST @D102486, 
      AGR [CASE @D102485, COUNT @D102484, PER @D102483, PLU @D102482, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ABOUT, ARITY 1] : PLAY.

WORD played : 
   [COORD @D102496, AGR [CASE @D102495, COUNT @D102494, PER @D102493, 
            PLU @D102492, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D102501, AGR [CASE @D102500, COUNT @D102499, PER @D102498, 
            PLU @D102497, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102506, AGR [CASE @D102505, COUNT @D102504, PER @D102503, 
            PLU @D102502, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102511, AGR [CASE @D102510, COUNT @D102509, PER @D102508, 
            PLU @D102507, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D102516, AGR [CASE @D102515, COUNT @D102514, PER @D102513, 
            PLU @D102512, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102521, AGR [CASE @D102520, COUNT @D102519, PER @D102518, 
            PLU @D102517, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102526, AGR [CASE @D102525, COUNT @D102524, PER @D102523, 
            PLU @D102522, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102531, AGR [CASE @D102530, COUNT @D102529, PER @D102528, 
            PLU @D102527, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102536, AGR [CASE @D102535, COUNT @D102534, PER @D102533, 
            PLU @D102532, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102541, AGR [CASE @D102540, COUNT @D102539, PER @D102538, 
            PLU @D102537, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102546, AGR [CASE @D102545, COUNT @D102544, PER @D102543, 
            PLU @D102542, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102551, AGR [CASE @D102550, COUNT @D102549, PER @D102548, 
            PLU @D102547, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102556, AGR [CASE @D102555, COUNT @D102554, PER @D102553, 
            PLU @D102552, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102561, AGR [CASE @D102560, COUNT @D102559, PER @D102558, 
            PLU @D102557, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102566, AGR [CASE @D102565, COUNT @D102564, PER @D102563, 
            PLU @D102562, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102571, AGR [CASE @D102570, COUNT @D102569, PER @D102568, 
            PLU @D102567, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102576, AGR [CASE @D102575, COUNT @D102574, PER @D102573, 
            PLU @D102572, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102581, AGR [CASE @D102580, COUNT @D102579, PER @D102578, 
            PLU @D102577, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102586, AGR [CASE @D102585, COUNT @D102584, PER @D102583, 
            PLU @D102582, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102591, AGR [CASE @D102590, COUNT @D102589, PER @D102588, 
            PLU @D102587, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102596, AGR [CASE @D102595, COUNT @D102594, PER @D102593, 
            PLU @D102592, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102601, AGR [CASE @D102600, COUNT @D102599, PER @D102598, 
            PLU @D102597, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102606, AGR [CASE @D102605, COUNT @D102604, PER @D102603, 
            PLU @D102602, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102611, AGR [CASE @D102610, COUNT @D102609, PER @D102608, 
            PLU @D102607, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102616, AGR [CASE @D102615, COUNT @D102614, PER @D102613, 
            PLU @D102612, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AGAINST, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102621, AGR [CASE @D102620, COUNT @D102619, PER @D102618, 
            PLU @D102617, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AGAINST, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102626, 
      AGR [CASE @D102625, COUNT @D102624, PER @D102623, PLU @D102622, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102631, AGR [CASE @D102630, COUNT @D102629, PER @D102628, 
            PLU @D102627, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102636, AGR [CASE @D102635, COUNT @D102634, PER @D102633, 
            PLU @D102632, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102641, AGR [CASE @D102640, COUNT @D102639, PER @D102638, 
            PLU @D102637, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102646, AGR [CASE @D102645, COUNT @D102644, PER @D102643, 
            PLU @D102642, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102651, AGR [CASE @D102650, COUNT @D102649, PER @D102648, 
            PLU @D102647, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D102656, AGR [CASE @D102655, COUNT @D102654, PER @D102653, 
            PLU @D102652, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102661, AGR [CASE @D102660, COUNT @D102659, PER @D102658, 
            PLU @D102657, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102666, AGR [CASE @D102665, COUNT @D102664, PER @D102663, 
            PLU @D102662, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102671, AGR [CASE @D102670, COUNT @D102669, PER @D102668, 
            PLU @D102667, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102676, AGR [CASE @D102675, COUNT @D102674, PER @D102673, 
            PLU @D102672, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102681, AGR [CASE @D102680, COUNT @D102679, PER @D102678, 
            PLU @D102677, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102686, AGR [CASE @D102685, COUNT @D102684, PER @D102683, 
            PLU @D102682, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102691, AGR [CASE @D102690, COUNT @D102689, PER @D102688, 
            PLU @D102687, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102696, AGR [CASE @D102695, COUNT @D102694, PER @D102693, 
            PLU @D102692, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102701, AGR [CASE @D102700, COUNT @D102699, PER @D102698, 
            PLU @D102697, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102706, AGR [CASE @D102705, COUNT @D102704, PER @D102703, 
            PLU @D102702, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102711, AGR [CASE @D102710, COUNT @D102709, PER @D102708, 
            PLU @D102707, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102716, 
      AGR [CASE @D102715, COUNT @D102714, PER @D102713, PLU @D102712, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102721, AGR [CASE @D102720, COUNT @D102719, PER @D102718, 
            PLU @D102717, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALONG, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102726, 
      AGR [CASE @D102725, COUNT @D102724, PER @D102723, PLU @D102722, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALONG, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102731, AGR [CASE @D102730, COUNT @D102729, PER @D102728, 
            PLU @D102727, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ABOUT, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102736, 
      AGR [CASE @D102735, COUNT @D102734, PER @D102733, PLU @D102732, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ABOUT, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102741, AGR [CASE @D102740, COUNT @D102739, PER @D102738, 
            PLU @D102737, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102746, AGR [CASE @D102745, COUNT @D102744, PER @D102743, 
            PLU @D102742, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102751, AGR [CASE @D102750, COUNT @D102749, PER @D102748, 
            PLU @D102747, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102756, AGR [CASE @D102755, COUNT @D102754, PER @D102753, 
            PLU @D102752, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102761, AGR [CASE @D102760, COUNT @D102759, PER @D102758, 
            PLU @D102757, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102766, AGR [CASE @D102765, COUNT @D102764, PER @D102763, 
            PLU @D102762, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102771, AGR [CASE @D102770, COUNT @D102769, PER @D102768, 
            PLU @D102767, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102776, AGR [CASE @D102775, COUNT @D102774, PER @D102773, 
            PLU @D102772, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102781, AGR [CASE @D102780, COUNT @D102779, PER @D102778, 
            PLU @D102777, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102786, AGR [CASE @D102785, COUNT @D102784, PER @D102783, 
            PLU @D102782, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102791, AGR [CASE @D102790, COUNT @D102789, PER @D102788, 
            PLU @D102787, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102796, AGR [CASE @D102795, COUNT @D102794, PER @D102793, 
            PLU @D102792, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102801, AGR [CASE @D102800, COUNT @D102799, PER @D102798, 
            PLU @D102797, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102806, AGR [CASE @D102805, COUNT @D102804, PER @D102803, 
            PLU @D102802, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102811, AGR [CASE @D102810, COUNT @D102809, PER @D102808, 
            PLU @D102807, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102816, AGR [CASE @D102815, COUNT @D102814, PER @D102813, 
            PLU @D102812, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102821, AGR [CASE @D102820, COUNT @D102819, PER @D102818, 
            PLU @D102817, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102826, AGR [CASE @D102825, COUNT @D102824, PER @D102823, 
            PLU @D102822, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102831, AGR [CASE @D102830, COUNT @D102829, PER @D102828, 
            PLU @D102827, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102836, AGR [CASE @D102835, COUNT @D102834, PER @D102833, 
            PLU @D102832, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102841, AGR [CASE @D102840, COUNT @D102839, PER @D102838, 
            PLU @D102837, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102846, AGR [CASE @D102845, COUNT @D102844, PER @D102843, 
            PLU @D102842, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102851, AGR [CASE @D102850, COUNT @D102849, PER @D102848, 
            PLU @D102847, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102856, AGR [CASE @D102855, COUNT @D102854, PER @D102853, 
            PLU @D102852, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102861, AGR [CASE @D102860, COUNT @D102859, PER @D102858, 
            PLU @D102857, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102866, AGR [CASE @D102865, COUNT @D102864, PER @D102863, 
            PLU @D102862, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102871, AGR [CASE @D102870, COUNT @D102869, PER @D102868, 
            PLU @D102867, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102876, AGR [CASE @D102875, COUNT @D102874, PER @D102873, 
            PLU @D102872, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102881, AGR [CASE @D102880, COUNT @D102879, PER @D102878, 
            PLU @D102877, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102886, AGR [CASE @D102885, COUNT @D102884, PER @D102883, 
            PLU @D102882, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102891, AGR [CASE @D102890, COUNT @D102889, PER @D102888, 
            PLU @D102887, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102896, AGR [CASE @D102895, COUNT @D102894, PER @D102893, 
            PLU @D102892, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102901, AGR [CASE @D102900, COUNT @D102899, PER @D102898, 
            PLU @D102897, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102906, AGR [CASE @D102905, COUNT @D102904, PER @D102903, 
            PLU @D102902, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102911, AGR [CASE @D102910, COUNT @D102909, PER @D102908, 
            PLU @D102907, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102916, AGR [CASE @D102915, COUNT @D102914, PER @D102913, 
            PLU @D102912, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102921, AGR [CASE @D102920, COUNT @D102919, PER @D102918, 
            PLU @D102917, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102926, AGR [CASE @D102925, COUNT @D102924, PER @D102923, 
            PLU @D102922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102931, AGR [CASE @D102930, COUNT @D102929, PER @D102928, 
            PLU @D102927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102936, AGR [CASE @D102935, COUNT @D102934, PER @D102933, 
            PLU @D102932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102941, AGR [CASE @D102940, COUNT @D102939, PER @D102938, 
            PLU @D102937, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102946, AGR [CASE @D102945, COUNT @D102944, PER @D102943, 
            PLU @D102942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102951, AGR [CASE @D102950, COUNT @D102949, PER @D102948, 
            PLU @D102947, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102956, AGR [CASE @D102955, COUNT @D102954, PER @D102953, 
            PLU @D102952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102961, AGR [CASE @D102960, COUNT @D102959, PER @D102958, 
            PLU @D102957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102966, AGR [CASE @D102965, COUNT @D102964, PER @D102963, 
            PLU @D102962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102971, AGR [CASE @D102970, COUNT @D102969, PER @D102968, 
            PLU @D102967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102976, AGR [CASE @D102975, COUNT @D102974, PER @D102973, 
            PLU @D102972, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102981, AGR [CASE @D102980, COUNT @D102979, PER @D102978, 
            PLU @D102977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102986, AGR [CASE @D102985, COUNT @D102984, PER @D102983, 
            PLU @D102982, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102991, AGR [CASE @D102990, COUNT @D102989, PER @D102988, 
            PLU @D102987, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D102996, AGR [CASE @D102995, COUNT @D102994, PER @D102993, 
            PLU @D102992, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103001, AGR [CASE @D103000, COUNT @D102999, PER @D102998, 
            PLU @D102997, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103006, AGR [CASE @D103005, COUNT @D103004, PER @D103003, 
            PLU @D103002, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103011, AGR [CASE @D103010, COUNT @D103009, PER @D103008, 
            PLU @D103007, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103016, AGR [CASE @D103015, COUNT @D103014, PER @D103013, 
            PLU @D103012, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103021, AGR [CASE @D103020, COUNT @D103019, PER @D103018, 
            PLU @D103017, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103026, AGR [CASE @D103025, COUNT @D103024, PER @D103023, 
            PLU @D103022, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103031, AGR [CASE @D103030, COUNT @D103029, PER @D103028, 
            PLU @D103027, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PLAY.

WORD playing : 
   [COORD @D103045, PRD @D103044, AGR [CASE @D103043, COUNT @D103042, 
            PER @D103041, PLU @D103040, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103051, PRD @D103050, 
      AGR [CASE @D103049, COUNT @D103048, PER @D103047, PLU @D103046, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103057, PRD @D103056, AGR [CASE @D103055, COUNT @D103054, 
            PER @D103053, PLU @D103052, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103063, PRD @D103062, 
      AGR [CASE @D103061, COUNT @D103060, PER @D103059, PLU @D103058, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103069, PRD @D103068, AGR [CASE @D103067, COUNT @D103066, 
            PER @D103065, PLU @D103064, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103075, PRD @D103074, 
      AGR [CASE @D103073, COUNT @D103072, PER @D103071, PLU @D103070, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103081, PRD @D103080, AGR [CASE @D103079, COUNT @D103078, 
            PER @D103077, PLU @D103076, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103087, PRD @D103086, 
      AGR [CASE @D103085, COUNT @D103084, PER @D103083, PLU @D103082, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103093, PRD @D103092, AGR [CASE @D103091, COUNT @D103090, 
            PER @D103089, PLU @D103088, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103099, PRD @D103098, 
      AGR [CASE @D103097, COUNT @D103096, PER @D103095, PLU @D103094, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103105, PRD @D103104, AGR [CASE @D103103, COUNT @D103102, 
            PER @D103101, PLU @D103100, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103111, PRD @D103110, 
      AGR [CASE @D103109, COUNT @D103108, PER @D103107, PLU @D103106, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAY, 
   [COORD @D103117, PRD @D103116, AGR [CASE @D103115, COUNT @D103114, 
            PER @D103113, PLU @D103112, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103123, PRD @D103122, 
      AGR [CASE @D103121, COUNT @D103120, PER @D103119, PLU @D103118, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103129, PRD @D103128, AGR [CASE @D103127, COUNT @D103126, 
            PER @D103125, PLU @D103124, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103135, PRD @D103134, 
      AGR [CASE @D103133, COUNT @D103132, PER @D103131, PLU @D103130, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103141, PRD @D103140, AGR [CASE @D103139, COUNT @D103138, 
            PER @D103137, PLU @D103136, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103147, PRD @D103146, 
      AGR [CASE @D103145, COUNT @D103144, PER @D103143, PLU @D103142, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALONG, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103153, PRD @D103152, 
      AGR [CASE @D103151, COUNT @D103150, PER @D103149, PLU @D103148, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ABOUT, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103159, PRD @D103158, 
      AGR [CASE @D103157, COUNT @D103156, PER @D103155, PLU @D103154, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103165, PRD @D103164, AGR [CASE @D103163, COUNT @D103162, 
            PER @D103161, PLU @D103160, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103171, PRD @D103170, 
      AGR [CASE @D103169, COUNT @D103168, PER @D103167, PLU @D103166, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAY, 
   [COORD @D103177, PRD @D103176, AGR [CASE @D103175, COUNT @D103174, 
            PER @D103173, PLU @D103172, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103183, PRD @D103182, 
      AGR [CASE @D103181, COUNT @D103180, PER @D103179, PLU @D103178, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAY, 
   [COORD @D103189, PRD @D103188, AGR [CASE @D103187, COUNT @D103186, 
            PER @D103185, PLU @D103184, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103195, PRD @D103194, 
      AGR [CASE @D103193, COUNT @D103192, PER @D103191, PLU @D103190, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAY, 
   [COORD @D103201, PRD @D103200, AGR [CASE @D103199, COUNT @D103198, 
            PER @D103197, PLU @D103196, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103207, PRD @D103206, 
      AGR [CASE @D103205, COUNT @D103204, PER @D103203, PLU @D103202, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAY, 
   [COORD @D103213, PRD @D103212, AGR [CASE @D103211, COUNT @D103210, 
            PER @D103209, PLU @D103208, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103219, PRD @D103218, 
      AGR [CASE @D103217, COUNT @D103216, PER @D103215, PLU @D103214, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAY, 
   [COORD @D103225, PRD @D103224, AGR [CASE @D103223, COUNT @D103222, 
            PER @D103221, PLU @D103220, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103231, PRD @D103230, 
      AGR [CASE @D103229, COUNT @D103228, PER @D103227, PLU @D103226, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PLAY, 
   [COORD @D103237, PRD @D103236, AGR [CASE @D103235, COUNT @D103234, 
            PER @D103233, PLU @D103232, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103243, PRD @D103242, 
      AGR [CASE @D103241, COUNT @D103240, PER @D103239, PLU @D103238, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103249, PRD @D103248, AGR [CASE @D103247, COUNT @D103246, 
            PER @D103245, PLU @D103244, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103255, PRD @D103254, 
      AGR [CASE @D103253, COUNT @D103252, PER @D103251, PLU @D103250, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103261, PRD @D103260, AGR [CASE @D103259, COUNT @D103258, 
            PER @D103257, PLU @D103256, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103267, PRD @D103266, 
      AGR [CASE @D103265, COUNT @D103264, PER @D103263, PLU @D103262, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103273, PRD @D103272, AGR [CASE @D103271, COUNT @D103270, 
            PER @D103269, PLU @D103268, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103279, PRD @D103278, 
      AGR [CASE @D103277, COUNT @D103276, PER @D103275, PLU @D103274, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103285, PRD @D103284, AGR [CASE @D103283, COUNT @D103282, 
            PER @D103281, PLU @D103280, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY, 
   [COORD @D103291, PRD @D103290, 
      AGR [CASE @D103289, COUNT @D103288, PER @D103287, PLU @D103286, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103297, PRD @D103296, AGR [CASE @D103295, COUNT @D103294, 
            PER @D103293, PLU @D103292, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PLAY.

WORD plays : 
   [COORD @D103306, DEMON @D103305, REFL @D103304, PRD @D103303, 
      CASE @D103302, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PLAY, 
   [COORD @D103308, AGR [COUNT @D103307, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103310, 
      AGR [COUNT @D103309, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103312, 
      AGR [COUNT @D103311, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103314, 
      AGR [COUNT @D103313, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103316, 
      AGR [COUNT @D103315, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103318, 
      AGR [COUNT @D103317, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103320, 
      AGR [COUNT @D103319, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103322, 
      AGR [COUNT @D103321, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103324, 
      AGR [COUNT @D103323, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103326, AGR [COUNT @D103325, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103328, 
      AGR [COUNT @D103327, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103330, 
      AGR [COUNT @D103329, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103332, 
      AGR [COUNT @D103331, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103334, 
      AGR [COUNT @D103333, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103336, 
      AGR [COUNT @D103335, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103338, 
      AGR [COUNT @D103337, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103340, 
      AGR [COUNT @D103339, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AROUND, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103342, AGR [COUNT @D103341, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ALONG, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103344, AGR [COUNT @D103343, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT ABOUT, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103346, AGR [COUNT @D103345, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103348, AGR [COUNT @D103347, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PLAY, 
   [COORD @D103350, AGR [COUNT @D103349, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103352, AGR [COUNT @D103351, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103354, AGR [COUNT @D103353, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103356, AGR [COUNT @D103355, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103358, AGR [COUNT @D103357, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103360, AGR [COUNT @D103359, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103362, AGR [COUNT @D103361, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103364, AGR [COUNT @D103363, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103366, AGR [COUNT @D103365, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103368, AGR [COUNT @D103367, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103370, AGR [COUNT @D103369, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103372, AGR [COUNT @D103371, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103374, 
      AGR [COUNT @D103373, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PLAY, 
   [COORD @D103376, 
      AGR [COUNT @D103375, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PLAY, 
   [COORD @D103378, AGR [COUNT @D103377, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PLAY, 
   [COORD @D103380, AGR [COUNT @D103379, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103382, AGR [COUNT @D103381, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PLAY, 
   [COORD @D103384, AGR [COUNT @D103383, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103386, AGR [COUNT @D103385, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103388, AGR [COUNT @D103387, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103390, AGR [COUNT @D103389, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY, 
   [COORD @D103392, AGR [COUNT @D103391, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PLAY.

WORD point : 
   [COORD @D103398, REFL @D103397, PRD @D103396, CASE @D103395, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : POINT, 
   [COORD @D103403, REFL @D103402, COUNT @D103401, PRD @D103400, 
      CASE @D103399, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : POINT, 
   [COORD @D103407, REFL @D103406, PRD @D103405, CASE @D103404, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : POINT, 
   [COORD @D103411, REFL @D103410, PRD @D103409, CASE @D103408, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : POINT, 
   [COORD @D103414, 
      AGR [COUNT @D103413, PER @D103412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TOWARDS, ARITY 3] : POINT, 
   [COORD @D103416, AGR [COUNT @D103415, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TOWARDS, ARITY 3] : POINT, 
   [COORD @D103418, AGR [COUNT @D103417, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TOWARDS, ARITY 3] : POINT, 
   [COORD @D103422, AGR [COUNT @D103421, PER @D103420, PLU @D103419, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TOWARDS, ARITY 3] : POINT, 
   [COORD @D103428, PAST @D103427, 
      AGR [CASE @D103426, COUNT @D103425, PER @D103424, PLU @D103423, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TOWARDS, ARITY 3] : POINT, 
   [COORD @D103431, AGR [COUNT @D103430, PER @D103429, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POINT, 
   [COORD @D103433, AGR [COUNT @D103432, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POINT, 
   [COORD @D103435, AGR [COUNT @D103434, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POINT, 
   [COORD @D103439, AGR [COUNT @D103438, PER @D103437, PLU @D103436, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POINT, 
   [COORD @D103445, PAST @D103444, 
      AGR [CASE @D103443, COUNT @D103442, PER @D103441, PLU @D103440, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AT, ARITY 3] : POINT, 
   [COORD @D103448, AGR [COUNT @D103447, PER @D103446, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM TO, ARITY 3] : POINT, 
   [COORD @D103450, 
      AGR [COUNT @D103449, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, PFORM TO, 
      ARITY 3] : POINT, 
   [COORD @D103452, AGR [COUNT @D103451, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM TO, ARITY 3] : POINT, 
   [COORD @D103456, 
      AGR [COUNT @D103455, PER @D103454, PLU @D103453, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM TO, ARITY 3] : POINT, 
   [COORD @D103462, PAST @D103461, 
      AGR [CASE @D103460, COUNT @D103459, PER @D103458, PLU @D103457, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM TO, ARITY 3] : POINT, 
   [COORD @D103465, AGR [COUNT @D103464, PER @D103463, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POINT, 
   [COORD @D103467, AGR [COUNT @D103466, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POINT, 
   [COORD @D103469, AGR [COUNT @D103468, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POINT, 
   [COORD @D103473, AGR [COUNT @D103472, PER @D103471, PLU @D103470, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : POINT, 
   [COORD @D103479, PAST @D103478, AGR [CASE @D103477, COUNT @D103476, 
            PER @D103475, PLU @D103474, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : POINT, 
   [COORD @D103482, AGR [COUNT @D103481, PER @D103480, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT OUT, ARITY 2] : POINT, 
   [COORD @D103484, AGR [COUNT @D103483, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT OUT, ARITY 2] : POINT, 
   [COORD @D103486, AGR [COUNT @D103485, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT OUT, ARITY 2] : POINT, 
   [COORD @D103490, AGR [COUNT @D103489, PER @D103488, PLU @D103487, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT OUT, ARITY 2] : POINT, 
   [COORD @D103496, PAST @D103495, 
      AGR [CASE @D103494, COUNT @D103493, PER @D103492, PLU @D103491, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      PRT OUT, ARITY 2] : POINT, 
   [COORD @D103499, AGR [COUNT @D103498, PER @D103497, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TOWARDS, ARITY 2] : POINT, 
   [COORD @D103501, AGR [COUNT @D103500, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TOWARDS, ARITY 2] : POINT, 
   [COORD @D103503, AGR [COUNT @D103502, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TOWARDS, ARITY 2] : POINT, 
   [COORD @D103507, AGR [COUNT @D103506, PER @D103505, PLU @D103504, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TOWARDS, ARITY 2] : POINT, 
   [COORD @D103513, PAST @D103512, 
      AGR [CASE @D103511, COUNT @D103510, PER @D103509, PLU @D103508, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TOWARDS, ARITY 2] : POINT, 
   [COORD @D103516, AGR [COUNT @D103515, PER @D103514, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : POINT, 
   [COORD @D103518, AGR [COUNT @D103517, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : POINT, 
   [COORD @D103520, AGR [COUNT @D103519, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : POINT, 
   [COORD @D103524, AGR [COUNT @D103523, PER @D103522, PLU @D103521, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : POINT, 
   [COORD @D103530, PAST @D103529, 
      AGR [CASE @D103528, COUNT @D103527, PER @D103526, PLU @D103525, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : POINT, 
   [COORD @D103533, AGR [COUNT @D103532, PER @D103531, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POINT, 
   [COORD @D103535, AGR [COUNT @D103534, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POINT, 
   [COORD @D103537, AGR [COUNT @D103536, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POINT, 
   [COORD @D103541, AGR [COUNT @D103540, PER @D103539, PLU @D103538, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : POINT, 
   [COORD @D103547, PAST @D103546, 
      AGR [CASE @D103545, COUNT @D103544, PER @D103543, PLU @D103542, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POINT, 
   [COORD @D103550, AGR [COUNT @D103549, PER @D103548, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : POINT, 
   [COORD @D103552, AGR [COUNT @D103551, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : POINT, 
   [COORD @D103554, AGR [COUNT @D103553, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : POINT, 
   [COORD @D103558, AGR [COUNT @D103557, PER @D103556, PLU @D103555, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : POINT, 
   [COORD @D103564, PAST @D103563, 
      AGR [CASE @D103562, COUNT @D103561, PER @D103560, PLU @D103559, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : POINT, 
   [COORD @D103567, AGR [COUNT @D103566, PER @D103565, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : POINT, 
   [COORD @D103569, AGR [COUNT @D103568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : POINT, 
   [COORD @D103571, AGR [COUNT @D103570, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : POINT, 
   [COORD @D103575, AGR [COUNT @D103574, PER @D103573, PLU @D103572, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : POINT, 
   [COORD @D103581, PAST @D103580, 
      AGR [CASE @D103579, COUNT @D103578, PER @D103577, PLU @D103576, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : POINT, 
   [COORD @D103584, AGR [COUNT @D103583, PER @D103582, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POINT, 
   [COORD @D103586, AGR [COUNT @D103585, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POINT, 
   [COORD @D103588, AGR [COUNT @D103587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POINT, 
   [COORD @D103592, AGR [COUNT @D103591, PER @D103590, PLU @D103589, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POINT, 
   [COORD @D103598, PAST @D103597, AGR [CASE @D103596, COUNT @D103595, 
            PER @D103594, PLU @D103593, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : POINT, 
   [COORD @D103601, AGR [COUNT @D103600, PER @D103599, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POINT, 
   [COORD @D103603, AGR [COUNT @D103602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POINT, 
   [COORD @D103605, AGR [COUNT @D103604, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POINT, 
   [COORD @D103609, AGR [COUNT @D103608, PER @D103607, PLU @D103606, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POINT, 
   [COORD @D103615, PAST @D103614, 
      AGR [CASE @D103613, COUNT @D103612, PER @D103611, PLU @D103610, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : POINT, 
   [COORD @D103618, AGR [COUNT @D103617, PER @D103616, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POINT, 
   [COORD @D103620, AGR [COUNT @D103619, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POINT, 
   [COORD @D103622, AGR [COUNT @D103621, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POINT, 
   [COORD @D103626, AGR [COUNT @D103625, PER @D103624, PLU @D103623, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POINT, 
   [COORD @D103632, PAST @D103631, 
      AGR [CASE @D103630, COUNT @D103629, PER @D103628, PLU @D103627, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : POINT.

WORD pointed : 
   [COADV @D103644, COORD @D103643, DEF @D103642, PRD @D103641, 
      AGR [CASE @D103640, COUNT @D103639, PER @D103638, PLU @D103637, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   POINTED, 
   [COORD @D103649, AGR [CASE @D103648, COUNT @D103647, PER @D103646, 
            PLU @D103645, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103654, AGR [CASE @D103653, COUNT @D103652, PER @D103651, 
            PLU @D103650, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103659, AGR [CASE @D103658, COUNT @D103657, PER @D103656, 
            PLU @D103655, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103664, AGR [CASE @D103663, COUNT @D103662, PER @D103661, 
            PLU @D103660, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103669, AGR [CASE @D103668, COUNT @D103667, PER @D103666, 
            PLU @D103665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103674, AGR [CASE @D103673, COUNT @D103672, PER @D103671, 
            PLU @D103670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103679, AGR [CASE @D103678, COUNT @D103677, PER @D103676, 
            PLU @D103675, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103684, AGR [CASE @D103683, COUNT @D103682, PER @D103681, 
            PLU @D103680, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103689, 
      AGR [CASE @D103688, COUNT @D103687, PER @D103686, PLU @D103685, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103694, AGR [CASE @D103693, COUNT @D103692, PER @D103691, 
            PLU @D103690, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POINT, 
   [COORD @D103699, AGR [CASE @D103698, COUNT @D103697, PER @D103696, 
            PLU @D103695, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103704, AGR [CASE @D103703, COUNT @D103702, PER @D103701, 
            PLU @D103700, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103709, AGR [CASE @D103708, COUNT @D103707, PER @D103706, 
            PLU @D103705, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103714, AGR [CASE @D103713, COUNT @D103712, PER @D103711, 
            PLU @D103710, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103719, AGR [UB @D103718, VFORM @D103717, SUBJ @D103716, 
            FIN @D103715, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POINT, 
   [COORD @D103724, AGR [CASE @D103723, COUNT @D103722, PER @D103721, 
            PLU @D103720, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103729, AGR [CASE @D103728, COUNT @D103727, PER @D103726, 
            PLU @D103725, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103734, AGR [CASE @D103733, COUNT @D103732, PER @D103731, 
            PLU @D103730, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TOWARDS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103739, AGR [CASE @D103738, COUNT @D103737, PER @D103736, 
            PLU @D103735, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103744, AGR [CASE @D103743, COUNT @D103742, PER @D103741, 
            PLU @D103740, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103749, AGR [CASE @D103748, COUNT @D103747, PER @D103746, 
            PLU @D103745, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103754, AGR [CASE @D103753, COUNT @D103752, PER @D103751, 
            PLU @D103750, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103759, AGR [CASE @D103758, COUNT @D103757, PER @D103756, 
            PLU @D103755, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103764, AGR [CASE @D103763, COUNT @D103762, PER @D103761, 
            PLU @D103760, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103769, AGR [CASE @D103768, COUNT @D103767, PER @D103766, 
            PLU @D103765, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103774, AGR [CASE @D103773, COUNT @D103772, PER @D103771, 
            PLU @D103770, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103779, AGR [CASE @D103778, COUNT @D103777, PER @D103776, 
            PLU @D103775, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103784, AGR [CASE @D103783, COUNT @D103782, PER @D103781, 
            PLU @D103780, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103789, AGR [CASE @D103788, COUNT @D103787, PER @D103786, 
            PLU @D103785, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103794, AGR [CASE @D103793, COUNT @D103792, PER @D103791, 
            PLU @D103790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103799, AGR [CASE @D103798, COUNT @D103797, PER @D103796, 
            PLU @D103795, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103804, AGR [CASE @D103803, COUNT @D103802, PER @D103801, 
            PLU @D103800, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103809, AGR [CASE @D103808, COUNT @D103807, PER @D103806, 
            PLU @D103805, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT, 
   [COORD @D103814, AGR [CASE @D103813, COUNT @D103812, PER @D103811, 
            PLU @D103810, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103819, AGR [CASE @D103818, COUNT @D103817, PER @D103816, 
            PLU @D103815, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POINT.

WORD pointing : 
   [COORD @D103833, PRD @D103832, AGR [CASE @D103831, COUNT @D103830, 
            PER @D103829, PLU @D103828, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103839, PRD @D103838, 
      AGR [CASE @D103837, COUNT @D103836, PER @D103835, PLU @D103834, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POINT, 
   [COORD @D103845, PRD @D103844, AGR [CASE @D103843, COUNT @D103842, 
            PER @D103841, PLU @D103840, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103851, PRD @D103850, 
      AGR [CASE @D103849, COUNT @D103848, PER @D103847, PLU @D103846, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : POINT, 
   [COORD @D103857, PRD @D103856, AGR [CASE @D103855, COUNT @D103854, 
            PER @D103853, PLU @D103852, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103863, PRD @D103862, 
      AGR [CASE @D103861, COUNT @D103860, PER @D103859, PLU @D103858, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : POINT, 
   [COORD @D103869, PRD @D103868, AGR [CASE @D103867, COUNT @D103866, 
            PER @D103865, PLU @D103864, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103875, PRD @D103874, 
      AGR [CASE @D103873, COUNT @D103872, PER @D103871, PLU @D103870, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POINT, 
   [COORD @D103881, PRD @D103880, AGR [CASE @D103879, COUNT @D103878, 
            PER @D103877, PLU @D103876, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103887, PRD @D103886, 
      AGR [CASE @D103885, COUNT @D103884, PER @D103883, PLU @D103882, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : POINT, 
   [COORD @D103893, PRD @D103892, AGR [CASE @D103891, COUNT @D103890, 
            PER @D103889, PLU @D103888, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POINT, 
   [COORD @D103899, PRD @D103898, 
      AGR [CASE @D103897, COUNT @D103896, PER @D103895, PLU @D103894, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POINT, 
   [COORD @D103905, PRD @D103904, AGR [CASE @D103903, COUNT @D103902, 
            PER @D103901, PLU @D103900, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POINT.

WORD points : 
   [COORD @D103913, REFL @D103912, PRD @D103911, CASE @D103910, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : POINTS, 
   [COORD @D103918, DEMON @D103917, REFL @D103916, PRD @D103915, 
      CASE @D103914, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   POINT, 
   [COORD @D103923, DEMON @D103922, REFL @D103921, PRD @D103920, 
      CASE @D103919, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   POINT, 
   [COORD @D103928, DEMON @D103927, REFL @D103926, PRD @D103925, 
      CASE @D103924, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : POINT, 
   [COORD @D103933, DEMON @D103932, REFL @D103931, PRD @D103930, 
      CASE @D103929, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   POINT, 
   [COORD @D103935, AGR [COUNT @D103934, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POINT, 
   [COORD @D103937, AGR [COUNT @D103936, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POINT, 
   [COORD @D103939, AGR [COUNT @D103938, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : POINT, 
   [COORD @D103941, AGR [COUNT @D103940, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POINT, 
   [COORD @D103943, 
      AGR [COUNT @D103942, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POINT, 
   [COORD @D103945, 
      AGR [COUNT @D103944, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TOWARDS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   POINT, 
   [COORD @D103947, AGR [COUNT @D103946, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POINT, 
   [COORD @D103949, AGR [COUNT @D103948, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   POINT, 
   [COORD @D103951, AGR [COUNT @D103950, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POINT, 
   [COORD @D103953, AGR [COUNT @D103952, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POINT, 
   [COORD @D103955, AGR [COUNT @D103954, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POINT, 
   [COORD @D103957, 
      AGR [COUNT @D103956, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POINT, 
   [COORD @D103959, 
      AGR [COUNT @D103958, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POINT.

WORD police : 
   [COORD @D103974, AGR [COUNT @D103973, PER @D103972, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POLICE, 
   [COORD @D103976, AGR [COUNT @D103975, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POLICE, 
   [COORD @D103978, AGR [COUNT @D103977, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POLICE, 
   [COORD @D103982, AGR [COUNT @D103981, PER @D103980, PLU @D103979, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : POLICE, 
   [COORD @D103988, PAST @D103987, AGR [CASE @D103986, COUNT @D103985, 
            PER @D103984, PLU @D103983, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : POLICE.

WORD policed : 
   [COORD @D103997, AGR [CASE @D103996, COUNT @D103995, PER @D103994, 
            PLU @D103993, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POLICE, 
   [COORD @D104002, AGR [CASE @D104001, COUNT @D104000, PER @D103999, 
            PLU @D103998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POLICE, 
   [COORD @D104007, AGR [CASE @D104006, COUNT @D104005, PER @D104004, 
            PLU @D104003, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POLICE.

WORD polices : 
   [COORD @D104013, AGR [COUNT @D104012, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POLICE.

WORD policing : 
   [COORD @D104023, PRD @D104022, AGR [CASE @D104021, COUNT @D104020, 
            PER @D104019, PLU @D104018, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POLICE.

WORD pose : 
   [COORD @D104031, REFL @D104030, PRD @D104029, CASE @D104028, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : POSE, 
   [COORD @D104034, 
      AGR [COUNT @D104033, PER @D104032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   POSE, 
   [COORD @D104036, AGR [COUNT @D104035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : POSE, 
   [COORD @D104038, AGR [COUNT @D104037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : POSE, 
   [COORD @D104042, AGR [COUNT @D104041, PER @D104040, PLU @D104039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : POSE, 
   [COORD @D104048, PAST @D104047, AGR [CASE @D104046, COUNT @D104045, 
            PER @D104044, PLU @D104043, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : POSE, 
   [COORD @D104051, AGR [COUNT @D104050, PER @D104049, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : POSE, 
   [COORD @D104053, AGR [COUNT @D104052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : POSE, 
   [COORD @D104055, AGR [COUNT @D104054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : POSE, 
   [COORD @D104059, AGR [COUNT @D104058, PER @D104057, PLU @D104056, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : POSE, 
   [COORD @D104065, PAST @D104064, 
      AGR [CASE @D104063, COUNT @D104062, PER @D104061, PLU @D104060, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : POSE, 
   [COORD @D104068, AGR [COUNT @D104067, PER @D104066, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : POSE, 
   [COORD @D104070, AGR [COUNT @D104069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : POSE, 
   [COORD @D104072, AGR [COUNT @D104071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : POSE, 
   [COORD @D104076, AGR [COUNT @D104075, PER @D104074, PLU @D104073, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : POSE, 
   [COORD @D104082, PAST @D104081, 
      AGR [CASE @D104080, COUNT @D104079, PER @D104078, PLU @D104077, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : POSE, 
   [COORD @D104085, AGR [COUNT @D104084, PER @D104083, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POSE, 
   [COORD @D104087, AGR [COUNT @D104086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POSE, 
   [COORD @D104089, AGR [COUNT @D104088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POSE, 
   [COORD @D104093, AGR [COUNT @D104092, PER @D104091, PLU @D104090, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : POSE, 
   [COORD @D104099, PAST @D104098, AGR [CASE @D104097, COUNT @D104096, 
            PER @D104095, PLU @D104094, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : POSE, 
   [COORD @D104102, AGR [COUNT @D104101, PER @D104100, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : POSE, 
   [COORD @D104104, AGR [COUNT @D104103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : POSE, 
   [COORD @D104106, AGR [COUNT @D104105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : POSE, 
   [COORD @D104110, AGR [COUNT @D104109, PER @D104108, PLU @D104107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : POSE, 
   [COORD @D104116, PAST @D104115, 
      AGR [CASE @D104114, COUNT @D104113, PER @D104112, PLU @D104111, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : POSE, 
   [COORD @D104119, AGR [COUNT @D104118, PER @D104117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : POSE, 
   [COORD @D104121, AGR [COUNT @D104120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : POSE, 
   [COORD @D104123, AGR [COUNT @D104122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : POSE, 
   [COORD @D104127, AGR [COUNT @D104126, PER @D104125, PLU @D104124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AS, ARITY 2] : POSE, 
   [COORD @D104133, PAST @D104132, 
      AGR [CASE @D104131, COUNT @D104130, PER @D104129, PLU @D104128, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : POSE, 
   [COORD @D104136, AGR [COUNT @D104135, PER @D104134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POSE, 
   [COORD @D104138, AGR [COUNT @D104137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POSE, 
   [COORD @D104140, AGR [COUNT @D104139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POSE, 
   [COORD @D104144, AGR [COUNT @D104143, PER @D104142, PLU @D104141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POSE, 
   [COORD @D104150, PAST @D104149, AGR [CASE @D104148, COUNT @D104147, 
            PER @D104146, PLU @D104145, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : POSE.

WORD posed : 
   [COORD @D104161, AGR [CASE @D104160, COUNT @D104159, PER @D104158, 
            PLU @D104157, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POSE, 
   [COORD @D104166, AGR [CASE @D104165, COUNT @D104164, PER @D104163, 
            PLU @D104162, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104171, AGR [CASE @D104170, COUNT @D104169, PER @D104168, 
            PLU @D104167, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POSE, 
   [COORD @D104176, AGR [CASE @D104175, COUNT @D104174, PER @D104173, 
            PLU @D104172, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104181, AGR [CASE @D104180, COUNT @D104179, PER @D104178, 
            PLU @D104177, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104186, AGR [CASE @D104185, COUNT @D104184, PER @D104183, 
            PLU @D104182, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : POSE, 
   [COORD @D104191, AGR [CASE @D104190, COUNT @D104189, PER @D104188, 
            PLU @D104187, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104196, AGR [CASE @D104195, COUNT @D104194, PER @D104193, 
            PLU @D104192, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104201, AGR [CASE @D104200, COUNT @D104199, PER @D104198, 
            PLU @D104197, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : POSE, 
   [COORD @D104206, AGR [CASE @D104205, COUNT @D104204, PER @D104203, 
            PLU @D104202, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104211, AGR [CASE @D104210, COUNT @D104209, PER @D104208, 
            PLU @D104207, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POSE, 
   [COORD @D104216, AGR [CASE @D104215, COUNT @D104214, PER @D104213, 
            PLU @D104212, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POSE, 
   [COORD @D104221, AGR [CASE @D104220, COUNT @D104219, PER @D104218, 
            PLU @D104217, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104226, AGR [CASE @D104225, COUNT @D104224, PER @D104223, 
            PLU @D104222, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POSE, 
   [COORD @D104231, AGR [CASE @D104230, COUNT @D104229, PER @D104228, 
            PLU @D104227, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104236, AGR [CASE @D104235, COUNT @D104234, PER @D104233, 
            PLU @D104232, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POSE, 
   [COORD @D104241, AGR [CASE @D104240, COUNT @D104239, PER @D104238, 
            PLU @D104237, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104246, AGR [CASE @D104245, COUNT @D104244, PER @D104243, 
            PLU @D104242, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POSE.

WORD poses : 
   [COORD @D104257, DEMON @D104256, REFL @D104255, PRD @D104254, 
      CASE @D104253, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   POSE, 
   [COORD @D104259, AGR [COUNT @D104258, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POSE, 
   [COORD @D104261, 
      AGR [COUNT @D104260, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POSE, 
   [COORD @D104263, 
      AGR [COUNT @D104262, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POSE, 
   [COORD @D104265, 
      AGR [COUNT @D104264, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POSE, 
   [COORD @D104267, 
      AGR [COUNT @D104266, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POSE, 
   [COORD @D104269, 
      AGR [COUNT @D104268, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POSE, 
   [COORD @D104271, 
      AGR [COUNT @D104270, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POSE.

WORD posing : 
   [COORD @D104281, PRD @D104280, AGR [CASE @D104279, COUNT @D104278, 
            PER @D104277, PLU @D104276, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104287, PRD @D104286, 
      AGR [CASE @D104285, COUNT @D104284, PER @D104283, PLU @D104282, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : POSE, 
   [COORD @D104293, PRD @D104292, AGR [CASE @D104291, COUNT @D104290, 
            PER @D104289, PLU @D104288, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104299, PRD @D104298, 
      AGR [CASE @D104297, COUNT @D104296, PER @D104295, PLU @D104294, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : POSE, 
   [COORD @D104305, PRD @D104304, AGR [CASE @D104303, COUNT @D104302, 
            PER @D104301, PLU @D104300, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POSE, 
   [COORD @D104311, PRD @D104310, 
      AGR [CASE @D104309, COUNT @D104308, PER @D104307, PLU @D104306, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POSE, 
   [COORD @D104317, PRD @D104316, AGR [CASE @D104315, COUNT @D104314, 
            PER @D104313, PLU @D104312, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POSE.

WORD pound : 
   [COORD @D104323, REFL @D104322, PRD @D104321, CASE @D104320, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : POUND, 
   [COORD @D104327, REFL @D104326, PRD @D104325, CASE @D104324, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : POUND, 
   [COORD @D104330, 
      AGR [COUNT @D104329, PER @D104328, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ON, 
      ARITY 3] : POUND, 
   [COORD @D104332, AGR [COUNT @D104331, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : POUND, 
   [COORD @D104334, AGR [COUNT @D104333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : POUND, 
   [COORD @D104338, AGR [COUNT @D104337, PER @D104336, PLU @D104335, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : POUND, 
   [COORD @D104344, PAST @D104343, 
      AGR [CASE @D104342, COUNT @D104341, PER @D104340, PLU @D104339, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : POUND, 
   [COORD @D104347, AGR [COUNT @D104346, PER @D104345, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POUND, 
   [COORD @D104349, AGR [COUNT @D104348, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POUND, 
   [COORD @D104351, AGR [COUNT @D104350, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POUND, 
   [COORD @D104355, AGR [COUNT @D104354, PER @D104353, PLU @D104352, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : POUND, 
   [COORD @D104361, PAST @D104360, 
      AGR [CASE @D104359, COUNT @D104358, PER @D104357, PLU @D104356, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AT, ARITY 3] : POUND, 
   [COORD @D104364, AGR [COUNT @D104363, PER @D104362, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : POUND, 
   [COORD @D104366, AGR [COUNT @D104365, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : POUND, 
   [COORD @D104368, AGR [COUNT @D104367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : POUND, 
   [COORD @D104372, AGR [COUNT @D104371, PER @D104370, PLU @D104369, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : POUND, 
   [COORD @D104378, PAST @D104377, 
      AGR [CASE @D104376, COUNT @D104375, PER @D104374, PLU @D104373, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AGAINST, ARITY 3] : POUND, 
   [COORD @D104381, AGR [COUNT @D104380, PER @D104379, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POUND, 
   [COORD @D104383, AGR [COUNT @D104382, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POUND, 
   [COORD @D104385, AGR [COUNT @D104384, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : POUND, 
   [COORD @D104389, AGR [COUNT @D104388, PER @D104387, PLU @D104386, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : POUND, 
   [COORD @D104395, PAST @D104394, AGR [CASE @D104393, COUNT @D104392, 
            PER @D104391, PLU @D104390, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : POUND, 
   [COORD @D104398, AGR [COUNT @D104397, PER @D104396, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : POUND, 
   [COORD @D104400, AGR [COUNT @D104399, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : POUND, 
   [COORD @D104402, AGR [COUNT @D104401, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : POUND, 
   [COORD @D104406, AGR [COUNT @D104405, PER @D104404, PLU @D104403, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : POUND, 
   [COORD @D104412, PAST @D104411, AGR [CASE @D104410, COUNT @D104409, 
            PER @D104408, PLU @D104407, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : POUND, 
   [COORD @D104415, AGR [COUNT @D104414, PER @D104413, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : POUND, 
   [COORD @D104417, AGR [COUNT @D104416, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : POUND, 
   [COORD @D104419, AGR [COUNT @D104418, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : POUND, 
   [COORD @D104423, AGR [COUNT @D104422, PER @D104421, PLU @D104420, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : POUND, 
   [COORD @D104429, PAST @D104428, 
      AGR [CASE @D104427, COUNT @D104426, PER @D104425, PLU @D104424, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : POUND, 
   [COORD @D104432, AGR [COUNT @D104431, PER @D104430, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POUND, 
   [COORD @D104434, AGR [COUNT @D104433, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POUND, 
   [COORD @D104436, AGR [COUNT @D104435, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POUND, 
   [COORD @D104440, AGR [COUNT @D104439, PER @D104438, PLU @D104437, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : POUND, 
   [COORD @D104446, PAST @D104445, 
      AGR [CASE @D104444, COUNT @D104443, PER @D104442, PLU @D104441, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : POUND, 
   [COORD @D104449, AGR [COUNT @D104448, PER @D104447, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : POUND, 
   [COORD @D104451, AGR [COUNT @D104450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : POUND, 
   [COORD @D104453, AGR [COUNT @D104452, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : POUND, 
   [COORD @D104457, AGR [COUNT @D104456, PER @D104455, PLU @D104454, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : POUND, 
   [COORD @D104463, PAST @D104462, 
      AGR [CASE @D104461, COUNT @D104460, PER @D104459, PLU @D104458, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : POUND, 
   [COORD @D104466, AGR [COUNT @D104465, PER @D104464, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : POUND, 
   [COORD @D104468, AGR [COUNT @D104467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : POUND, 
   [COORD @D104470, AGR [COUNT @D104469, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : POUND, 
   [COORD @D104474, AGR [COUNT @D104473, PER @D104472, PLU @D104471, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : POUND, 
   [COORD @D104480, PAST @D104479, 
      AGR [CASE @D104478, COUNT @D104477, PER @D104476, PLU @D104475, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : POUND, 
   [COORD @D104483, AGR [COUNT @D104482, PER @D104481, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : POUND, 
   [COORD @D104485, AGR [COUNT @D104484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : POUND, 
   [COORD @D104487, AGR [COUNT @D104486, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : POUND, 
   [COORD @D104491, AGR [COUNT @D104490, PER @D104489, PLU @D104488, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : POUND, 
   [COORD @D104497, PAST @D104496, 
      AGR [CASE @D104495, COUNT @D104494, PER @D104493, PLU @D104492, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : POUND, 
   [COORD @D104500, AGR [COUNT @D104499, PER @D104498, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POUND, 
   [COORD @D104502, AGR [COUNT @D104501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POUND, 
   [COORD @D104504, AGR [COUNT @D104503, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POUND, 
   [COORD @D104508, AGR [COUNT @D104507, PER @D104506, PLU @D104505, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : POUND, 
   [COORD @D104514, PAST @D104513, AGR [CASE @D104512, COUNT @D104511, 
            PER @D104510, PLU @D104509, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : POUND, 
   [COORD @D104517, AGR [COUNT @D104516, PER @D104515, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POUND, 
   [COORD @D104519, AGR [COUNT @D104518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POUND, 
   [COORD @D104521, AGR [COUNT @D104520, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POUND, 
   [COORD @D104525, AGR [COUNT @D104524, PER @D104523, PLU @D104522, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : POUND, 
   [COORD @D104531, PAST @D104530, 
      AGR [CASE @D104529, COUNT @D104528, PER @D104527, PLU @D104526, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : POUND, 
   [COORD @D104534, AGR [COUNT @D104533, PER @D104532, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POUND, 
   [COORD @D104536, AGR [COUNT @D104535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POUND, 
   [COORD @D104538, AGR [COUNT @D104537, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POUND, 
   [COORD @D104542, AGR [COUNT @D104541, PER @D104540, PLU @D104539, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : POUND, 
   [COORD @D104548, PAST @D104547, 
      AGR [CASE @D104546, COUNT @D104545, PER @D104544, PLU @D104543, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : POUND, 
   [COORD @D104551, AGR [COUNT @D104550, PER @D104549, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : POUND, 
   [COORD @D104553, AGR [COUNT @D104552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : POUND, 
   [COORD @D104555, AGR [COUNT @D104554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : POUND, 
   [COORD @D104559, AGR [COUNT @D104558, PER @D104557, PLU @D104556, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : POUND, 
   [COORD @D104565, PAST @D104564, 
      AGR [CASE @D104563, COUNT @D104562, PER @D104561, PLU @D104560, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AWAY, ARITY 1] : POUND.

WORD pounded : 
   [COORD @D104574, AGR [CASE @D104573, COUNT @D104572, PER @D104571, 
            PLU @D104570, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104579, AGR [CASE @D104578, COUNT @D104577, PER @D104576, 
            PLU @D104575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104584, AGR [CASE @D104583, COUNT @D104582, PER @D104581, 
            PLU @D104580, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104589, AGR [CASE @D104588, COUNT @D104587, PER @D104586, 
            PLU @D104585, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104594, AGR [CASE @D104593, COUNT @D104592, PER @D104591, 
            PLU @D104590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104599, AGR [CASE @D104598, COUNT @D104597, PER @D104596, 
            PLU @D104595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104604, AGR [CASE @D104603, COUNT @D104602, PER @D104601, 
            PLU @D104600, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104609, AGR [CASE @D104608, COUNT @D104607, PER @D104606, 
            PLU @D104605, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104614, AGR [CASE @D104613, COUNT @D104612, PER @D104611, 
            PLU @D104610, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104619, AGR [CASE @D104618, COUNT @D104617, PER @D104616, 
            PLU @D104615, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POUND, 
   [COORD @D104624, AGR [CASE @D104623, COUNT @D104622, PER @D104621, 
            PLU @D104620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104629, AGR [CASE @D104628, COUNT @D104627, PER @D104626, 
            PLU @D104625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104634, AGR [CASE @D104633, COUNT @D104632, PER @D104631, 
            PLU @D104630, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104639, AGR [CASE @D104638, COUNT @D104637, PER @D104636, 
            PLU @D104635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104644, AGR [CASE @D104643, COUNT @D104642, PER @D104641, 
            PLU @D104640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104649, AGR [CASE @D104648, COUNT @D104647, PER @D104646, 
            PLU @D104645, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104654, AGR [CASE @D104653, COUNT @D104652, PER @D104651, 
            PLU @D104650, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104659, AGR [CASE @D104658, COUNT @D104657, PER @D104656, 
            PLU @D104655, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104664, AGR [CASE @D104663, COUNT @D104662, PER @D104661, 
            PLU @D104660, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104669, AGR [CASE @D104668, COUNT @D104667, PER @D104666, 
            PLU @D104665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104674, AGR [CASE @D104673, COUNT @D104672, PER @D104671, 
            PLU @D104670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104679, AGR [CASE @D104678, COUNT @D104677, PER @D104676, 
            PLU @D104675, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104684, AGR [CASE @D104683, COUNT @D104682, PER @D104681, 
            PLU @D104680, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104689, AGR [CASE @D104688, COUNT @D104687, PER @D104686, 
            PLU @D104685, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104694, AGR [CASE @D104693, COUNT @D104692, PER @D104691, 
            PLU @D104690, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104699, AGR [CASE @D104698, COUNT @D104697, PER @D104696, 
            PLU @D104695, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104704, AGR [CASE @D104703, COUNT @D104702, PER @D104701, 
            PLU @D104700, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104709, AGR [CASE @D104708, COUNT @D104707, PER @D104706, 
            PLU @D104705, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104714, AGR [CASE @D104713, COUNT @D104712, PER @D104711, 
            PLU @D104710, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104719, AGR [CASE @D104718, COUNT @D104717, PER @D104716, 
            PLU @D104715, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104724, AGR [CASE @D104723, COUNT @D104722, PER @D104721, 
            PLU @D104720, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104729, AGR [CASE @D104728, COUNT @D104727, PER @D104726, 
            PLU @D104725, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104734, AGR [CASE @D104733, COUNT @D104732, PER @D104731, 
            PLU @D104730, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND, 
   [COORD @D104739, AGR [CASE @D104738, COUNT @D104737, PER @D104736, 
            PLU @D104735, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104744, AGR [CASE @D104743, COUNT @D104742, PER @D104741, 
            PLU @D104740, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : POUND.

WORD pounding : 
   [COORD @D104758, PRD @D104757, AGR [CASE @D104756, COUNT @D104755, 
            PER @D104754, PLU @D104753, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104764, PRD @D104763, 
      AGR [CASE @D104762, COUNT @D104761, PER @D104760, PLU @D104759, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POUND, 
   [COORD @D104770, PRD @D104769, AGR [CASE @D104768, COUNT @D104767, 
            PER @D104766, PLU @D104765, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104776, PRD @D104775, 
      AGR [CASE @D104774, COUNT @D104773, PER @D104772, PLU @D104771, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : POUND, 
   [COORD @D104782, PRD @D104781, AGR [CASE @D104780, COUNT @D104779, 
            PER @D104778, PLU @D104777, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104788, PRD @D104787, 
      AGR [CASE @D104786, COUNT @D104785, PER @D104784, PLU @D104783, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POUND, 
   [COORD @D104794, PRD @D104793, AGR [CASE @D104792, COUNT @D104791, 
            PER @D104790, PLU @D104789, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104800, PRD @D104799, 
      AGR [CASE @D104798, COUNT @D104797, PER @D104796, PLU @D104795, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : POUND, 
   [COORD @D104806, PRD @D104805, AGR [CASE @D104804, COUNT @D104803, 
            PER @D104802, PLU @D104801, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104812, PRD @D104811, 
      AGR [CASE @D104810, COUNT @D104809, PER @D104808, PLU @D104807, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : POUND, 
   [COORD @D104818, PRD @D104817, AGR [CASE @D104816, COUNT @D104815, 
            PER @D104814, PLU @D104813, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104824, PRD @D104823, 
      AGR [CASE @D104822, COUNT @D104821, PER @D104820, PLU @D104819, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POUND, 
   [COORD @D104830, PRD @D104829, AGR [CASE @D104828, COUNT @D104827, 
            PER @D104826, PLU @D104825, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : POUND, 
   [COORD @D104836, PRD @D104835, 
      AGR [CASE @D104834, COUNT @D104833, PER @D104832, PLU @D104831, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : POUND.

WORD pounds : 
   [COORD @D104845, DEMON @D104844, REFL @D104843, PRD @D104842, 
      CASE @D104841, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   POUND, 
   [COORD @D104850, DEMON @D104849, REFL @D104848, PRD @D104847, 
      CASE @D104846, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : POUND, 
   [COORD @D104852, AGR [COUNT @D104851, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POUND, 
   [COORD @D104854, AGR [COUNT @D104853, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POUND, 
   [COORD @D104856, AGR [COUNT @D104855, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : POUND, 
   [COORD @D104858, AGR [COUNT @D104857, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104860, 
      AGR [COUNT @D104859, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104862, 
      AGR [COUNT @D104861, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104864, 
      AGR [COUNT @D104863, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104866, 
      AGR [COUNT @D104865, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104868, 
      AGR [COUNT @D104867, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104870, 
      AGR [COUNT @D104869, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104872, 
      AGR [COUNT @D104871, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104874, 
      AGR [COUNT @D104873, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104876, 
      AGR [COUNT @D104875, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND, 
   [COORD @D104878, 
      AGR [COUNT @D104877, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : POUND.

WORD practice : 
   [COORD @D104887, REFL @D104886, COUNT @D104885, PRD @D104884, 
      CASE @D104883, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PRACTICE, 
   [COORD @D104890, 
      AGR [COUNT @D104889, PER @D104888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM UPON, 
      ARITY 3] : PRACTISE, 
   [COORD @D104892, AGR [COUNT @D104891, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : PRACTISE, 
   [COORD @D104894, AGR [COUNT @D104893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : PRACTISE, 
   [COORD @D104898, AGR [COUNT @D104897, PER @D104896, PLU @D104895, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : PRACTISE, 
   [COORD @D104904, PAST @D104903, 
      AGR [CASE @D104902, COUNT @D104901, PER @D104900, PLU @D104899, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM UPON, ARITY 3] : PRACTISE, 
   [COORD @D104907, AGR [COUNT @D104906, PER @D104905, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PRACTISE, 
   [COORD @D104909, AGR [COUNT @D104908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PRACTISE, 
   [COORD @D104911, AGR [COUNT @D104910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PRACTISE, 
   [COORD @D104915, AGR [COUNT @D104914, PER @D104913, PLU @D104912, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PRACTISE, 
   [COORD @D104921, PAST @D104920, 
      AGR [CASE @D104919, COUNT @D104918, PER @D104917, PLU @D104916, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : PRACTISE, 
   [COORD @D104924, AGR [COUNT @D104923, PER @D104922, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : PRACTISE, 
   [COORD @D104926, AGR [COUNT @D104925, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : PRACTISE, 
   [COORD @D104928, AGR [COUNT @D104927, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : PRACTISE, 
   [COORD @D104932, AGR [COUNT @D104931, PER @D104930, PLU @D104929, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : PRACTISE, 
   [COORD @D104938, PAST @D104937, 
      AGR [CASE @D104936, COUNT @D104935, PER @D104934, PLU @D104933, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : PRACTISE, 
   [COORD @D104941, AGR [COUNT @D104940, PER @D104939, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRACTISE, 
   [COORD @D104943, AGR [COUNT @D104942, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRACTISE, 
   [COORD @D104945, AGR [COUNT @D104944, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRACTISE, 
   [COORD @D104949, AGR [COUNT @D104948, PER @D104947, PLU @D104946, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PRACTISE, 
   [COORD @D104955, PAST @D104954, AGR [CASE @D104953, COUNT @D104952, 
            PER @D104951, PLU @D104950, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PRACTISE, 
   [COORD @D104958, AGR [COUNT @D104957, PER @D104956, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : PRACTISE, 
   [COORD @D104960, AGR [COUNT @D104959, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : PRACTISE, 
   [COORD @D104962, AGR [COUNT @D104961, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : PRACTISE, 
   [COORD @D104966, AGR [COUNT @D104965, PER @D104964, PLU @D104963, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AS, ARITY 2] : PRACTISE, 
   [COORD @D104972, PAST @D104971, 
      AGR [CASE @D104970, COUNT @D104969, PER @D104968, PLU @D104967, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : PRACTISE, 
   [COORD @D104975, AGR [COUNT @D104974, PER @D104973, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRACTISE, 
   [COORD @D104977, AGR [COUNT @D104976, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRACTISE, 
   [COORD @D104979, AGR [COUNT @D104978, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRACTISE, 
   [COORD @D104983, AGR [COUNT @D104982, PER @D104981, PLU @D104980, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRACTISE, 
   [COORD @D104989, PAST @D104988, AGR 
         [CASE @D104987, COUNT @D104986, PER @D104985, PLU @D104984, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      ARITY 1] : PRACTISE.

WORD practiced : 
   [COORD @D105000, AGR [CASE @D104999, COUNT @D104998, PER @D104997, 
            PLU @D104996, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105005, AGR [CASE @D105004, COUNT @D105003, PER @D105002, 
            PLU @D105001, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105010, AGR 
         [CASE @D105009, COUNT @D105008, PER @D105007, PLU @D105006, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105015, AGR [CASE @D105014, COUNT @D105013, PER @D105012, 
            PLU @D105011, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105020, AGR [CASE @D105019, COUNT @D105018, PER @D105017, 
            PLU @D105016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105025, AGR [CASE @D105024, COUNT @D105023, PER @D105022, 
            PLU @D105021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105030, AGR [CASE @D105029, COUNT @D105028, PER @D105027, 
            PLU @D105026, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105035, AGR [CASE @D105034, COUNT @D105033, PER @D105032, 
            PLU @D105031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105040, AGR [CASE @D105039, COUNT @D105038, PER @D105037, 
            PLU @D105036, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105045, AGR [CASE @D105044, COUNT @D105043, PER @D105042, 
            PLU @D105041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105050, AGR [CASE @D105049, COUNT @D105048, PER @D105047, 
            PLU @D105046, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105055, AGR [CASE @D105054, COUNT @D105053, PER @D105052, 
            PLU @D105051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105060, AGR [CASE @D105059, COUNT @D105058, PER @D105057, 
            PLU @D105056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105065, AGR [CASE @D105064, COUNT @D105063, PER @D105062, 
            PLU @D105061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105070, AGR [CASE @D105069, COUNT @D105068, PER @D105067, 
            PLU @D105066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRACTISE.

WORD practices : 
   [COORD @D105081, DEMON @D105080, REFL @D105079, PRD @D105078, 
      CASE @D105077, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PRACTICE, 
   [COORD @D105083, AGR [COUNT @D105082, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PRACTISE, 
   [COORD @D105085, AGR [COUNT @D105084, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PRACTISE, 
   [COORD @D105087, AGR [COUNT @D105086, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PRACTISE, 
   [COORD @D105089, AGR [COUNT @D105088, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRACTISE, 
   
   [COORD @D105091, AGR [COUNT @D105090, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRACTISE, 
   
   [COORD @D105093, AGR [COUNT @D105092, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRACTISE.

WORD practicing : 
   [COORD @D105105, PRD @D105104, AGR [CASE @D105103, COUNT @D105102, 
            PER @D105101, PLU @D105100, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105111, PRD @D105110, 
      AGR [CASE @D105109, COUNT @D105108, PER @D105107, PLU @D105106, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105117, PRD @D105116, AGR [CASE @D105115, COUNT @D105114, 
            PER @D105113, PLU @D105112, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105123, PRD @D105122, 
      AGR [CASE @D105121, COUNT @D105120, PER @D105119, PLU @D105118, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PRACTISE, 
   [COORD @D105129, PRD @D105128, AGR [CASE @D105127, COUNT @D105126, 
            PER @D105125, PLU @D105124, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PRACTISE, 
   [COORD @D105135, PRD @D105134, 
      AGR [CASE @D105133, COUNT @D105132, PER @D105131, PLU @D105130, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PRACTISE.

WORD prepare : 
   [COORD @D105141, AGR [COUNT @D105140, PER @D105139, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PREPARE, 
   [COORD @D105143, AGR [COUNT @D105142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PREPARE, 
   [COORD @D105145, AGR [COUNT @D105144, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PREPARE, 
   [COORD @D105149, AGR [COUNT @D105148, PER @D105147, PLU @D105146, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PREPARE, 
   [COORD @D105155, PAST @D105154, 
      AGR [CASE @D105153, COUNT @D105152, PER @D105151, PLU @D105150, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : PREPARE, 
   [COORD @D105158, AGR [COUNT @D105157, PER @D105156, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PREPARE, 
   [COORD @D105160, AGR [COUNT @D105159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PREPARE, 
   [COORD @D105162, AGR [COUNT @D105161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PREPARE, 
   [COORD @D105166, AGR [COUNT @D105165, PER @D105164, PLU @D105163, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PREPARE, 
   [COORD @D105172, PAST @D105171, AGR 
         [CASE @D105170, COUNT @D105169, PER @D105168, PLU @D105167, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      ARITY 3] : PREPARE, 
   [COORD @D105175, AGR [COUNT @D105174, PER @D105173, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PREPARE, 
   [COORD @D105177, AGR [COUNT @D105176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PREPARE, 
   [COORD @D105179, AGR [COUNT @D105178, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PREPARE, 
   [COORD @D105183, AGR [COUNT @D105182, PER @D105181, PLU @D105180, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PREPARE, 
   [COORD @D105189, PAST @D105188, 
      AGR [CASE @D105187, COUNT @D105186, PER @D105185, PLU @D105184, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : PREPARE, 
   [COORD @D105192, AGR [COUNT @D105191, PER @D105190, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER POSTNP, ARITY 3] : PREPARE, 
   [COORD @D105194, 
      AGR [COUNT @D105193, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM FOR, ORDER POSTNP, ARITY 3] : PREPARE, 
   [COORD @D105196, AGR [COUNT @D105195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER POSTNP, ARITY 3] : PREPARE, 
   [COORD @D105200, 
      AGR [COUNT @D105199, PER @D105198, PLU @D105197, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER POSTNP, ARITY 3] : PREPARE, 
   [COORD @D105206, PAST @D105205, 
      AGR [CASE @D105204, COUNT @D105203, PER @D105202, PLU @D105201, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER POSTNP, ARITY 3] : PREPARE, 
   [COORD @D105209, 
      AGR [COUNT @D105208, PER @D105207, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : PREPARE, 
   [COORD @D105211, AGR [COUNT @D105210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PREPARE, 
   [COORD @D105213, AGR [COUNT @D105212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PREPARE, 
   [COORD @D105217, AGR [COUNT @D105216, PER @D105215, PLU @D105214, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PREPARE, 
   [COORD @D105223, PAST @D105222, 
      AGR [CASE @D105221, COUNT @D105220, PER @D105219, PLU @D105218, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : PREPARE, 
   [COORD @D105226, AGR [COUNT @D105225, PER @D105224, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PREPARE, 
   [COORD @D105228, AGR [COUNT @D105227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PREPARE, 
   [COORD @D105230, AGR [COUNT @D105229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PREPARE, 
   [COORD @D105234, AGR [COUNT @D105233, PER @D105232, PLU @D105231, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PREPARE, 
   [COORD @D105240, PAST @D105239, AGR [CASE @D105238, COUNT @D105237, 
            PER @D105236, PLU @D105235, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PREPARE, 
   [COORD @D105243, AGR [COUNT @D105242, PER @D105241, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : PREPARE, 
   [COORD @D105245, AGR [COUNT @D105244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : PREPARE, 
   [COORD @D105247, AGR [COUNT @D105246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : PREPARE, 
   [COORD @D105251, AGR [COUNT @D105250, PER @D105249, PLU @D105248, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FOR, ARITY 2] : PREPARE, 
   [COORD @D105257, PAST @D105256, 
      AGR [CASE @D105255, COUNT @D105254, PER @D105253, PLU @D105252, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP FOR, ARITY 2] : PREPARE, 
   [COORD @D105260, AGR [COUNT @D105259, PER @D105258, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PREPARE, 
   [COORD @D105262, AGR [COUNT @D105261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PREPARE, 
   [COORD @D105264, AGR [COUNT @D105263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PREPARE, 
   [COORD @D105268, AGR [COUNT @D105267, PER @D105266, PLU @D105265, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : PREPARE, 
   [COORD @D105274, PAST @D105273, 
      AGR [CASE @D105272, COUNT @D105271, PER @D105270, PLU @D105269, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PREPARE.

WORD prepared : 
   [COADV @D105286, COORD @D105285, DEF @D105284, PRD @D105283, 
      AGR [CASE @D105282, COUNT @D105281, PER @D105280, PLU @D105279, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : PREPARED, 
   [COADV @D105294, COORD @D105293, DEF @D105292, PRD @D105291, 
      AGR [CASE @D105290, COUNT @D105289, PER @D105288, PLU @D105287, 
            BAR 2, V -, N +, NFORM NORM], N +, V +, SUBCAT SINF, 
      SUBTYPE NONE, FIX NOT, INFL +, BAR 0, COMPAR NO, GRADE -, ADV -, 
      AFORM NONE, PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, DISTR PRD, ARITY 2] : PREPARED, 
   [COADV @D105302, COORD @D105301, DEF @D105300, PRD @D105299, 
      AGR [CASE @D105298, COUNT @D105297, PER @D105296, PLU @D105295, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT SC_INF, 
      DISTR PRD, ARITY 2] : PREPARED, 
   [COORD @D105307, AGR [CASE @D105306, COUNT @D105305, PER @D105304, 
            PLU @D105303, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105312, AGR [CASE @D105311, COUNT @D105310, PER @D105309, 
            PLU @D105308, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105318, AGR [CASE @D105317, NFORM @D105316, COUNT @D105315, 
            PER @D105314, PLU @D105313, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PREPARE, 
   [COORD @D105323, AGR [CASE @D105322, COUNT @D105321, PER @D105320, 
            PLU @D105319, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PREPARE, 
   [COORD @D105328, AGR [CASE @D105327, COUNT @D105326, PER @D105325, 
            PLU @D105324, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105333, AGR [CASE @D105332, COUNT @D105331, PER @D105330, 
            PLU @D105329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105338, AGR [CASE @D105337, COUNT @D105336, PER @D105335, 
            PLU @D105334, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105343, AGR [CASE @D105342, COUNT @D105341, PER @D105340, 
            PLU @D105339, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105348, AGR [CASE @D105347, COUNT @D105346, PER @D105345, 
            PLU @D105344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105353, AGR [CASE @D105352, COUNT @D105351, PER @D105350, 
            PLU @D105349, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM FOR, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105358, 
      AGR [CASE @D105357, COUNT @D105356, PER @D105355, PLU @D105354, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM FOR, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105363, AGR [CASE @D105362, COUNT @D105361, PER @D105360, 
            PLU @D105359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM FOR, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105368, 
      AGR [CASE @D105367, COUNT @D105366, PER @D105365, PLU @D105364, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PREPARE, 
   [COORD @D105373, AGR [CASE @D105372, COUNT @D105371, PER @D105370, 
            PLU @D105369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105378, AGR [CASE @D105377, COUNT @D105376, PER @D105375, 
            PLU @D105374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105383, AGR [CASE @D105382, COUNT @D105381, PER @D105380, 
            PLU @D105379, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105388, AGR [CASE @D105387, COUNT @D105386, PER @D105385, 
            PLU @D105384, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PREPARE, 
   [COORD @D105393, AGR [CASE @D105392, COUNT @D105391, PER @D105390, 
            PLU @D105389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105398, AGR [CASE @D105397, COUNT @D105396, PER @D105395, 
            PLU @D105394, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105403, AGR [CASE @D105402, COUNT @D105401, PER @D105400, 
            PLU @D105399, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105408, AGR [CASE @D105407, COUNT @D105406, PER @D105405, 
            PLU @D105404, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105413, AGR [CASE @D105412, COUNT @D105411, PER @D105410, 
            PLU @D105409, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PREPARE.

WORD prepares : 
   [COORD @D105419, AGR [COUNT @D105418, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PREPARE, 
   [COORD @D105421, AGR [COUNT @D105420, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105423, 
      AGR [COUNT @D105422, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105425, 
      AGR [COUNT @D105424, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM FOR, ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PREPARE, 
   [COORD @D105427, AGR [COUNT @D105426, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PREPARE, 
   [COORD @D105429, AGR [COUNT @D105428, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105431, 
      AGR [COUNT @D105430, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105433, 
      AGR [COUNT @D105432, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PREPARE.

WORD preparing : 
   [COORD @D105442, PRD @D105441, AGR [CASE @D105440, COUNT @D105439, 
            PER @D105438, PLU @D105437, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105448, PRD @D105447, 
      AGR [CASE @D105446, COUNT @D105445, PER @D105444, PLU @D105443, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PREPARE, 
   [COORD @D105454, PRD @D105453, AGR [CASE @D105452, COUNT @D105451, 
            PER @D105450, PLU @D105449, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105460, PRD @D105459, 
      AGR [CASE @D105458, COUNT @D105457, PER @D105456, PLU @D105455, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM FOR, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105466, PRD @D105465, 
      AGR [CASE @D105464, COUNT @D105463, PER @D105462, PLU @D105461, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PREPARE, 
   [COORD @D105472, PRD @D105471, AGR [CASE @D105470, COUNT @D105469, 
            PER @D105468, PLU @D105467, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PREPARE, 
   [COORD @D105478, PRD @D105477, 
      AGR [CASE @D105476, COUNT @D105475, PER @D105474, PLU @D105473, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PREPARE, 
   [COORD @D105484, PRD @D105483, AGR [CASE @D105482, COUNT @D105481, 
            PER @D105480, PLU @D105479, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PREPARE.

WORD present : 
   [COORD @D105490, REFL @D105489, PRD @D105488, CASE @D105487, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PRESENT, 
   [COORD @D105494, REFL @D105493, PRD @D105492, CASE @D105491, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PRESENT, 
   [COORD @D105497, 
      AGR [COUNT @D105496, PER @D105495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : PRESENT, 
   [COORD @D105499, AGR [COUNT @D105498, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PRESENT, 
   [COORD @D105501, AGR [COUNT @D105500, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PRESENT, 
   [COORD @D105505, AGR [COUNT @D105504, PER @D105503, PLU @D105502, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PRESENT, 
   [COORD @D105511, PAST @D105510, 
      AGR [CASE @D105509, COUNT @D105508, PER @D105507, PLU @D105506, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : PRESENT, 
   [COORD @D105514, AGR [COUNT @D105513, PER @D105512, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PRESENT, 
   [COORD @D105516, AGR [COUNT @D105515, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PRESENT, 
   [COORD @D105518, AGR [COUNT @D105517, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PRESENT, 
   [COORD @D105522, AGR [COUNT @D105521, PER @D105520, PLU @D105519, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PRESENT, 
   [COORD @D105528, PAST @D105527, 
      AGR [CASE @D105526, COUNT @D105525, PER @D105524, PLU @D105523, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : PRESENT, 
   [COORD @D105531, AGR [COUNT @D105530, PER @D105529, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRESENT, 
   [COORD @D105533, AGR [COUNT @D105532, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRESENT, 
   [COORD @D105535, AGR [COUNT @D105534, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRESENT, 
   [COORD @D105539, AGR [COUNT @D105538, PER @D105537, PLU @D105536, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PRESENT, 
   [COORD @D105545, PAST @D105544, AGR [CASE @D105543, COUNT @D105542, 
            PER @D105541, PLU @D105540, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PRESENT.

WORD presented : 
   [COORD @D105554, AGR [CASE @D105553, COUNT @D105552, PER @D105551, 
            PLU @D105550, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105559, AGR [CASE @D105558, COUNT @D105557, PER @D105556, 
            PLU @D105555, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105564, AGR [CASE @D105563, COUNT @D105562, PER @D105561, 
            PLU @D105560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105569, AGR [CASE @D105568, COUNT @D105567, PER @D105566, 
            PLU @D105565, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105574, AGR [CASE @D105573, COUNT @D105572, PER @D105571, 
            PLU @D105570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105579, AGR [CASE @D105578, COUNT @D105577, PER @D105576, 
            PLU @D105575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105584, AGR [CASE @D105583, COUNT @D105582, PER @D105581, 
            PLU @D105580, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRESENT, 
   [COORD @D105589, AGR [CASE @D105588, COUNT @D105587, PER @D105586, 
            PLU @D105585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105594, AGR [CASE @D105593, COUNT @D105592, PER @D105591, 
            PLU @D105590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRESENT.

WORD presenting : 
   [COORD @D105608, PRD @D105607, AGR [CASE @D105606, COUNT @D105605, 
            PER @D105604, PLU @D105603, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PRESENT, 
   [COORD @D105614, PRD @D105613, 
      AGR [CASE @D105612, COUNT @D105611, PER @D105610, PLU @D105609, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRESENT, 
   [COORD @D105620, PRD @D105619, AGR [CASE @D105618, COUNT @D105617, 
            PER @D105616, PLU @D105615, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRESENT.

WORD presents : 
   [COORD @D105628, REFL @D105627, PRD @D105626, CASE @D105625, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PRESENTS, 
   [COORD @D105633, DEMON @D105632, REFL @D105631, PRD @D105630, 
      CASE @D105629, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PRESENT, 
   [COORD @D105638, DEMON @D105637, REFL @D105636, PRD @D105635, 
      CASE @D105634, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : PRESENT, 
   [COORD @D105640, AGR [COUNT @D105639, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PRESENT, 
   [COORD @D105642, AGR [COUNT @D105641, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PRESENT, 
   [COORD @D105644, AGR [COUNT @D105643, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRESENT.

WORD presentses : 
   [COORD @D105658, DEMON @D105657, REFL @D105656, PRD @D105655, 
      CASE @D105654, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PRESENTS.

WORD price : 
   [COORD @D105666, REFL @D105665, PRD @D105664, CASE @D105663, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PRICE, 
   [COORD @D105670, REFL @D105669, PRD @D105668, CASE @D105667, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PRICE, 
   [COORD @D105673, 
      AGR [COUNT @D105672, PER @D105671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      ARITY 3] : PRICE, 
   [COORD @D105675, AGR [COUNT @D105674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PRICE, 
   [COORD @D105677, AGR [COUNT @D105676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PRICE, 
   [COORD @D105681, AGR [COUNT @D105680, PER @D105679, PLU @D105678, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PRICE, 
   [COORD @D105687, PAST @D105686, AGR [CASE @D105685, COUNT @D105684, 
            PER @D105683, PLU @D105682, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : PRICE, 
   [COORD @D105690, AGR [COUNT @D105689, PER @D105688, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : PRICE, 
   [COORD @D105692, AGR [COUNT @D105691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : PRICE, 
   [COORD @D105694, AGR [COUNT @D105693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : PRICE, 
   [COORD @D105698, AGR [COUNT @D105697, PER @D105696, PLU @D105695, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : PRICE, 
   [COORD @D105704, PAST @D105703, AGR [CASE @D105702, COUNT @D105701, 
            PER @D105700, PLU @D105699, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_ADL, ARITY 3] : PRICE, 
   [COORD @D105707, AGR [COUNT @D105706, PER @D105705, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OUT, PFORM OF, ARITY 3] : PRICE, 
   [COORD @D105709, 
      AGR [COUNT @D105708, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, 
      PFORM OF, ARITY 3] : PRICE, 
   [COORD @D105711, AGR [COUNT @D105710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OUT, PFORM OF, ARITY 3] : PRICE, 
   [COORD @D105715, 
      AGR [COUNT @D105714, PER @D105713, PLU @D105712, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OUT, PFORM OF, ARITY 3] : PRICE, 
   [COORD @D105721, PAST @D105720, 
      AGR [CASE @D105719, COUNT @D105718, PER @D105717, PLU @D105716, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PRT OUT, PFORM OF, ARITY 3] : PRICE, 
   [COORD @D105724, AGR [COUNT @D105723, PER @D105722, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRICE, 
   [COORD @D105726, AGR [COUNT @D105725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRICE, 
   [COORD @D105728, AGR [COUNT @D105727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRICE, 
   [COORD @D105732, AGR [COUNT @D105731, PER @D105730, PLU @D105729, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PRICE, 
   [COORD @D105738, PAST @D105737, AGR [CASE @D105736, COUNT @D105735, 
            PER @D105734, PLU @D105733, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PRICE.

WORD priced : 
   [COORD @D105749, AGR [CASE @D105748, COUNT @D105747, PER @D105746, 
            PLU @D105745, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105754, AGR [CASE @D105753, COUNT @D105752, PER @D105751, 
            PLU @D105750, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105760, AGR [CASE @D105759, NFORM @D105758, COUNT @D105757, 
            PER @D105756, PLU @D105755, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRICE, 
   [COORD @D105765, AGR [CASE @D105764, COUNT @D105763, PER @D105762, 
            PLU @D105761, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADL, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRICE, 
   [COORD @D105770, AGR [CASE @D105769, COUNT @D105768, PER @D105767, 
            PLU @D105766, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105775, AGR [CASE @D105774, COUNT @D105773, PER @D105772, 
            PLU @D105771, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105780, AGR [CASE @D105779, COUNT @D105778, PER @D105777, 
            PLU @D105776, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105785, AGR [CASE @D105784, COUNT @D105783, PER @D105782, 
            PLU @D105781, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105790, 
      AGR [CASE @D105789, COUNT @D105788, PER @D105787, PLU @D105786, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105795, AGR [CASE @D105794, COUNT @D105793, PER @D105792, 
            PLU @D105791, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRICE, 
   [COORD @D105800, AGR [CASE @D105799, COUNT @D105798, PER @D105797, 
            PLU @D105796, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105805, AGR [CASE @D105804, COUNT @D105803, PER @D105802, 
            PLU @D105801, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRICE.

WORD prices : 
   [COORD @D105816, DEMON @D105815, REFL @D105814, PRD @D105813, 
      CASE @D105812, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PRICE, 
   [COORD @D105818, AGR [COUNT @D105817, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PRICE, 
   [COORD @D105820, AGR [COUNT @D105819, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PRICE, 
   [COORD @D105822, AGR [COUNT @D105821, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PRICE, 
   [COORD @D105824, AGR [COUNT @D105823, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRICE.

WORD pricing : 
   [COORD @D105836, PRD @D105835, AGR [CASE @D105834, COUNT @D105833, 
            PER @D105832, PLU @D105831, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105842, PRD @D105841, 
      AGR [CASE @D105840, COUNT @D105839, PER @D105838, PLU @D105837, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PRICE, 
   [COORD @D105848, PRD @D105847, AGR [CASE @D105846, COUNT @D105845, 
            PER @D105844, PLU @D105843, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PRICE, 
   [COORD @D105854, PRD @D105853, 
      AGR [CASE @D105852, COUNT @D105851, PER @D105850, PLU @D105849, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PRICE.

WORD print : 
   [COORD @D105859, AGR [COUNT @D105858, PER @D105857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PRINT, 
   [COORD @D105861, AGR [COUNT @D105860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PRINT, 
   [COORD @D105863, AGR [COUNT @D105862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PRINT, 
   [COORD @D105867, AGR [COUNT @D105866, PER @D105865, PLU @D105864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PRINT, 
   [COORD @D105873, PAST @D105872, 
      AGR [CASE @D105871, COUNT @D105870, PER @D105869, PLU @D105868, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : PRINT, 
   [COORD @D105876, AGR [COUNT @D105875, PER @D105874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRINT, 
   [COORD @D105878, AGR [COUNT @D105877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRINT, 
   [COORD @D105880, AGR [COUNT @D105879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRINT, 
   [COORD @D105884, AGR [COUNT @D105883, PER @D105882, PLU @D105881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PRINT, 
   [COORD @D105890, PAST @D105889, AGR [CASE @D105888, COUNT @D105887, 
            PER @D105886, PLU @D105885, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PRINT, 
   [COORD @D105893, AGR [COUNT @D105892, PER @D105891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PRINT, 
   [COORD @D105895, AGR [COUNT @D105894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PRINT, 
   [COORD @D105897, AGR [COUNT @D105896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PRINT, 
   [COORD @D105901, AGR [COUNT @D105900, PER @D105899, PLU @D105898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : PRINT, 
   [COORD @D105907, PAST @D105906, AGR [CASE @D105905, COUNT @D105904, 
            PER @D105903, PLU @D105902, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : PRINT, 
   [COORD @D105910, AGR [COUNT @D105909, PER @D105908, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PRINT, 
   [COORD @D105912, AGR [COUNT @D105911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PRINT, 
   [COORD @D105914, AGR [COUNT @D105913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PRINT, 
   [COORD @D105918, AGR [COUNT @D105917, PER @D105916, PLU @D105915, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : PRINT, 
   [COORD @D105924, PAST @D105923, 
      AGR [CASE @D105922, COUNT @D105921, PER @D105920, PLU @D105919, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : PRINT, 
   [COORD @D105927, AGR [COUNT @D105926, PER @D105925, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PRINT, 
   [COORD @D105929, AGR [COUNT @D105928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PRINT, 
   [COORD @D105931, AGR [COUNT @D105930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PRINT, 
   [COORD @D105935, AGR [COUNT @D105934, PER @D105933, PLU @D105932, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : PRINT, 
   [COORD @D105941, PAST @D105940, 
      AGR [CASE @D105939, COUNT @D105938, PER @D105937, PLU @D105936, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : PRINT, 
   [COORD @D105944, AGR [COUNT @D105943, PER @D105942, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRINT, 
   [COORD @D105946, AGR [COUNT @D105945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRINT, 
   [COORD @D105948, AGR [COUNT @D105947, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRINT, 
   [COORD @D105952, AGR [COUNT @D105951, PER @D105950, PLU @D105949, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRINT, 
   [COORD @D105958, PAST @D105957, AGR [CASE @D105956, COUNT @D105955, 
            PER @D105954, PLU @D105953, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PRINT, 
   [COORD @D105961, AGR [COUNT @D105960, PER @D105959, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PRINT, 
   [COORD @D105963, AGR [COUNT @D105962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PRINT, 
   [COORD @D105965, AGR [COUNT @D105964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PRINT, 
   [COORD @D105969, AGR [COUNT @D105968, PER @D105967, PLU @D105966, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PRINT, 
   [COORD @D105975, PAST @D105974, 
      AGR [CASE @D105973, COUNT @D105972, PER @D105971, PLU @D105970, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : PRINT, 
   [COORD @D105978, AGR [COUNT @D105977, PER @D105976, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PRINT, 
   [COORD @D105980, AGR [COUNT @D105979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PRINT, 
   [COORD @D105982, AGR [COUNT @D105981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PRINT, 
   [COORD @D105986, AGR [COUNT @D105985, PER @D105984, PLU @D105983, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PRINT, 
   [COORD @D105992, PAST @D105991, 
      AGR [CASE @D105990, COUNT @D105989, PER @D105988, PLU @D105987, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : PRINT.

WORD printed : 
   [COORD @D106000, AGR [CASE @D105999, COUNT @D105998, PER @D105997, 
            PLU @D105996, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106005, AGR [CASE @D106004, COUNT @D106003, PER @D106002, 
            PLU @D106001, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106010, AGR [CASE @D106009, COUNT @D106008, PER @D106007, 
            PLU @D106006, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106015, AGR [CASE @D106014, COUNT @D106013, PER @D106012, 
            PLU @D106011, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRINT, 
   [COORD @D106020, AGR [CASE @D106019, COUNT @D106018, PER @D106017, 
            PLU @D106016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106025, AGR [CASE @D106024, COUNT @D106023, PER @D106022, 
            PLU @D106021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106030, AGR [CASE @D106029, COUNT @D106028, PER @D106027, 
            PLU @D106026, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106035, AGR [CASE @D106034, COUNT @D106033, PER @D106032, 
            PLU @D106031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106040, AGR [CASE @D106039, COUNT @D106038, PER @D106037, 
            PLU @D106036, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106045, AGR [CASE @D106044, COUNT @D106043, PER @D106042, 
            PLU @D106041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106050, AGR [CASE @D106049, COUNT @D106048, PER @D106047, 
            PLU @D106046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106055, AGR [CASE @D106054, COUNT @D106053, PER @D106052, 
            PLU @D106051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106060, AGR [CASE @D106059, COUNT @D106058, PER @D106057, 
            PLU @D106056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106065, AGR [CASE @D106064, COUNT @D106063, PER @D106062, 
            PLU @D106061, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106070, AGR [CASE @D106069, COUNT @D106068, PER @D106067, 
            PLU @D106066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106075, AGR [CASE @D106074, COUNT @D106073, PER @D106072, 
            PLU @D106071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106080, AGR [CASE @D106079, COUNT @D106078, PER @D106077, 
            PLU @D106076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106085, AGR [CASE @D106084, COUNT @D106083, PER @D106082, 
            PLU @D106081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106090, AGR [CASE @D106089, COUNT @D106088, PER @D106087, 
            PLU @D106086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106095, AGR [CASE @D106094, COUNT @D106093, PER @D106092, 
            PLU @D106091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PRINT.

WORD printing : 
   [COORD @D106105, REFL @D106104, COUNT @D106103, PRD @D106102, 
      CASE @D106101, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PRINTING, 
   [COORD @D106111, PRD @D106110, 
      AGR [CASE @D106109, COUNT @D106108, PER @D106107, PLU @D106106, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRINT, 
   [COORD @D106117, PRD @D106116, AGR [CASE @D106115, COUNT @D106114, 
            PER @D106113, PLU @D106112, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106123, PRD @D106122, 
      AGR [CASE @D106121, COUNT @D106120, PER @D106119, PLU @D106118, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PRINT, 
   [COORD @D106129, PRD @D106128, AGR [CASE @D106127, COUNT @D106126, 
            PER @D106125, PLU @D106124, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106135, PRD @D106134, 
      AGR [CASE @D106133, COUNT @D106132, PER @D106131, PLU @D106130, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PRINT, 
   [COORD @D106141, PRD @D106140, AGR [CASE @D106139, COUNT @D106138, 
            PER @D106137, PLU @D106136, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRINT, 
   [COORD @D106147, PRD @D106146, 
      AGR [CASE @D106145, COUNT @D106144, PER @D106143, PLU @D106142, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRINT, 
   [COORD @D106153, PRD @D106152, AGR [CASE @D106151, COUNT @D106150, 
            PER @D106149, PLU @D106148, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PRINT.

WORD printings : 
   [COORD @D106165, DEMON @D106164, REFL @D106163, PRD @D106162, 
      CASE @D106161, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PRINTING.

WORD prints : 
   [COORD @D106170, AGR [COUNT @D106169, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PRINT, 
   [COORD @D106172, AGR [COUNT @D106171, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRINT, 
   [COORD @D106174, 
      AGR [COUNT @D106173, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRINT, 
   [COORD @D106176, 
      AGR [COUNT @D106175, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRINT, 
   [COORD @D106178, 
      AGR [COUNT @D106177, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRINT, 
   [COORD @D106180, 
      AGR [COUNT @D106179, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRINT, 
   [COORD @D106182, 
      AGR [COUNT @D106181, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRINT, 
   [COORD @D106184, 
      AGR [COUNT @D106183, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRINT.

WORD proceed : 
   [COORD @D106189, AGR [COUNT @D106188, PER @D106187, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROCEED, 
   [COORD @D106191, AGR [COUNT @D106190, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROCEED, 
   [COORD @D106193, AGR [COUNT @D106192, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROCEED, 
   [COORD @D106197, AGR [COUNT @D106196, PER @D106195, PLU @D106194, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROCEED, 
   [COORD @D106203, PAST @D106202, 
      AGR [CASE @D106201, COUNT @D106200, PER @D106199, PLU @D106198, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : PROCEED, 
   [COORD @D106206, AGR [COUNT @D106205, PER @D106204, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PROCEED, 
   [COORD @D106208, AGR [COUNT @D106207, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PROCEED, 
   [COORD @D106210, AGR [COUNT @D106209, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : PROCEED, 
   [COORD @D106214, AGR [COUNT @D106213, PER @D106212, PLU @D106211, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : PROCEED, 
   [COORD @D106220, PAST @D106219, AGR [CASE @D106218, COUNT @D106217, 
            PER @D106216, PLU @D106215, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : PROCEED, 
   [COORD @D106223, AGR [COUNT @D106222, PER @D106221, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PROCEED, 
   [COORD @D106225, AGR [COUNT @D106224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PROCEED, 
   [COORD @D106227, AGR [COUNT @D106226, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PROCEED, 
   [COORD @D106231, AGR [COUNT @D106230, PER @D106229, PLU @D106228, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : PROCEED, 
   [COORD @D106237, PAST @D106236, 
      AGR [CASE @D106235, COUNT @D106234, PER @D106233, PLU @D106232, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : PROCEED, 
   [COORD @D106240, AGR [COUNT @D106239, PER @D106238, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROCEED, 
   [COORD @D106242, AGR [COUNT @D106241, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROCEED, 
   [COORD @D106244, AGR [COUNT @D106243, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROCEED, 
   [COORD @D106248, AGR [COUNT @D106247, PER @D106246, PLU @D106245, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : PROCEED, 
   [COORD @D106254, PAST @D106253, 
      AGR [CASE @D106252, COUNT @D106251, PER @D106250, PLU @D106249, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROCEED, 
   [COORD @D106257, AGR [COUNT @D106256, PER @D106255, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROCEED, 
   [COORD @D106259, AGR [COUNT @D106258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROCEED, 
   [COORD @D106261, AGR [COUNT @D106260, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROCEED, 
   [COORD @D106265, AGR [COUNT @D106264, PER @D106263, PLU @D106262, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : PROCEED, 
   [COORD @D106271, PAST @D106270, 
      AGR [CASE @D106269, COUNT @D106268, PER @D106267, PLU @D106266, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROCEED, 
   [COORD @D106274, AGR [COUNT @D106273, PER @D106272, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROCEED, 
   [COORD @D106276, AGR [COUNT @D106275, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROCEED, 
   [COORD @D106278, AGR [COUNT @D106277, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROCEED, 
   [COORD @D106282, AGR [COUNT @D106281, PER @D106280, PLU @D106279, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : PROCEED, 
   [COORD @D106288, PAST @D106287, 
      AGR [CASE @D106286, COUNT @D106285, PER @D106284, PLU @D106283, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROCEED, 
   [COORD @D106291, AGR [COUNT @D106290, PER @D106289, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCEED, 
   [COORD @D106293, AGR [COUNT @D106292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCEED, 
   [COORD @D106295, AGR [COUNT @D106294, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCEED, 
   [COORD @D106299, AGR [COUNT @D106298, PER @D106297, PLU @D106296, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCEED, 
   [COORD @D106305, PAST @D106304, AGR [CASE @D106303, COUNT @D106302, 
            PER @D106301, PLU @D106300, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PROCEED.

WORD proceeded : 
   [COORD @D106313, AGR [CASE @D106312, COUNT @D106311, PER @D106310, 
            PLU @D106309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106318, AGR [CASE @D106317, COUNT @D106316, PER @D106315, 
            PLU @D106314, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106323, AGR [CASE @D106322, COUNT @D106321, PER @D106320, 
            PLU @D106319, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106328, AGR [CASE @D106327, COUNT @D106326, PER @D106325, 
            PLU @D106324, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106333, AGR [CASE @D106332, COUNT @D106331, PER @D106330, 
            PLU @D106329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106338, AGR [CASE @D106337, COUNT @D106336, PER @D106335, 
            PLU @D106334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106343, AGR [CASE @D106342, COUNT @D106341, PER @D106340, 
            PLU @D106339, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106348, AGR [CASE @D106347, COUNT @D106346, PER @D106345, 
            PLU @D106344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106353, AGR [CASE @D106352, COUNT @D106351, PER @D106350, 
            PLU @D106349, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106358, AGR [CASE @D106357, COUNT @D106356, PER @D106355, 
            PLU @D106354, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106363, AGR [CASE @D106362, COUNT @D106361, PER @D106360, 
            PLU @D106359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106368, AGR [CASE @D106367, COUNT @D106366, PER @D106365, 
            PLU @D106364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106373, AGR [CASE @D106372, COUNT @D106371, PER @D106370, 
            PLU @D106369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106378, AGR [CASE @D106377, COUNT @D106376, PER @D106375, 
            PLU @D106374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106383, AGR [CASE @D106382, COUNT @D106381, PER @D106380, 
            PLU @D106379, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106388, AGR [CASE @D106387, COUNT @D106386, PER @D106385, 
            PLU @D106384, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106393, AGR [CASE @D106392, COUNT @D106391, PER @D106390, 
            PLU @D106389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROCEED.

WORD proceeding : 
   [COORD @D106404, PRD @D106403, AGR [CASE @D106402, COUNT @D106401, 
            PER @D106400, PLU @D106399, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106410, PRD @D106409, 
      AGR [CASE @D106408, COUNT @D106407, PER @D106406, PLU @D106405, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROCEED, 
   [COORD @D106416, PRD @D106415, AGR [CASE @D106414, COUNT @D106413, 
            PER @D106412, PLU @D106411, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106422, PRD @D106421, 
      AGR [CASE @D106420, COUNT @D106419, PER @D106418, PLU @D106417, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROCEED, 
   [COORD @D106428, PRD @D106427, AGR [CASE @D106426, COUNT @D106425, 
            PER @D106424, PLU @D106423, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106434, PRD @D106433, 
      AGR [CASE @D106432, COUNT @D106431, PER @D106430, PLU @D106429, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROCEED, 
   [COORD @D106440, PRD @D106439, AGR [CASE @D106438, COUNT @D106437, 
            PER @D106436, PLU @D106435, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROCEED.

WORD proceeds : 
   [COORD @D106447, REFL @D106446, PRD @D106445, CASE @D106444, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : PROCEEDS, 
   [COORD @D106449, 
      AGR [COUNT @D106448, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106451, 
      AGR [COUNT @D106450, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106453, 
      AGR [COUNT @D106452, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106455, 
      AGR [COUNT @D106454, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106457, 
      AGR [COUNT @D106456, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROCEED, 
   [COORD @D106459, 
      AGR [COUNT @D106458, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PROCEED, 
   [COORD @D106461, AGR [COUNT @D106460, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROCEED.

WORD process : 
   [COORD @D106472, AGR [COUNT @D106471, PER @D106470, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROCESS, 
   [COORD @D106474, AGR [COUNT @D106473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROCESS, 
   [COORD @D106476, AGR [COUNT @D106475, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROCESS, 
   [COORD @D106480, AGR [COUNT @D106479, PER @D106478, PLU @D106477, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROCESS, 
   [COORD @D106486, PAST @D106485, AGR [CASE @D106484, COUNT @D106483, 
            PER @D106482, PLU @D106481, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROCESS, 
   [COORD @D106489, AGR [COUNT @D106488, PER @D106487, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCESS, 
   [COORD @D106491, AGR [COUNT @D106490, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCESS, 
   [COORD @D106493, AGR [COUNT @D106492, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCESS, 
   [COORD @D106497, AGR [COUNT @D106496, PER @D106495, PLU @D106494, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROCESS, 
   [COORD @D106503, PAST @D106502, AGR [CASE @D106501, COUNT @D106500, 
            PER @D106499, PLU @D106498, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PROCESS.

WORD processed : 
   [COORD @D106511, AGR [CASE @D106510, COUNT @D106509, PER @D106508, 
            PLU @D106507, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROCESS, 
   [COORD @D106516, AGR [CASE @D106515, COUNT @D106514, PER @D106513, 
            PLU @D106512, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROCESS, 
   [COORD @D106521, AGR [CASE @D106520, COUNT @D106519, PER @D106518, 
            PLU @D106517, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROCESS, 
   [COORD @D106526, AGR [CASE @D106525, COUNT @D106524, PER @D106523, 
            PLU @D106522, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROCESS, 
   [COORD @D106531, AGR [CASE @D106530, COUNT @D106529, PER @D106528, 
            PLU @D106527, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROCESS.

WORD processing : 
   [COORD @D106542, PRD @D106541, AGR [CASE @D106540, COUNT @D106539, 
            PER @D106538, PLU @D106537, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROCESS, 
   [COORD @D106548, PRD @D106547, 
      AGR [CASE @D106546, COUNT @D106545, PER @D106544, PLU @D106543, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROCESS.

WORD produce : 
   [COORD @D106559, REFL @D106558, PRD @D106557, CASE @D106556, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : PRODUCE, 
   [COORD @D106562, AGR [COUNT @D106561, PER @D106560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRODUCE, 
   [COORD @D106564, AGR [COUNT @D106563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRODUCE, 
   [COORD @D106566, AGR [COUNT @D106565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PRODUCE, 
   [COORD @D106570, AGR [COUNT @D106569, PER @D106568, PLU @D106567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PRODUCE, 
   [COORD @D106576, PAST @D106575, AGR [CASE @D106574, COUNT @D106573, 
            PER @D106572, PLU @D106571, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PRODUCE, 
   [COORD @D106579, AGR [COUNT @D106578, PER @D106577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRODUCE, 
   [COORD @D106581, AGR [COUNT @D106580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRODUCE, 
   [COORD @D106583, AGR [COUNT @D106582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRODUCE, 
   [COORD @D106587, AGR [COUNT @D106586, PER @D106585, PLU @D106584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PRODUCE, 
   [COORD @D106593, PAST @D106592, AGR [CASE @D106591, COUNT @D106590, 
            PER @D106589, PLU @D106588, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PRODUCE.

WORD produced : 
   [COORD @D106604, AGR [CASE @D106603, COUNT @D106602, PER @D106601, 
            PLU @D106600, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRODUCE, 
   [COORD @D106609, AGR [CASE @D106608, COUNT @D106607, PER @D106606, 
            PLU @D106605, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRODUCE, 
   [COORD @D106614, AGR [CASE @D106613, COUNT @D106612, PER @D106611, 
            PLU @D106610, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PRODUCE, 
   [COORD @D106619, AGR [CASE @D106618, COUNT @D106617, PER @D106616, 
            PLU @D106615, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PRODUCE, 
   [COORD @D106624, AGR [CASE @D106623, COUNT @D106622, PER @D106621, 
            PLU @D106620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PRODUCE.

WORD produces : 
   [COORD @D106632, AGR [COUNT @D106631, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRODUCE, 
   [COORD @D106634, 
      AGR [COUNT @D106633, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PRODUCE.

WORD producing : 
   [COORD @D106646, PRD @D106645, AGR [CASE @D106644, COUNT @D106643, 
            PER @D106642, PLU @D106641, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PRODUCE, 
   [COORD @D106652, PRD @D106651, 
      AGR [CASE @D106650, COUNT @D106649, PER @D106648, PLU @D106647, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PRODUCE.

WORD profit : 
   [COORD @D106659, REFL @D106658, COUNT @D106657, PRD @D106656, 
      CASE @D106655, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PROFIT, 
   [COORD @D106662, 
      AGR [COUNT @D106661, PER @D106660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   PROFIT, 
   [COORD @D106664, AGR [COUNT @D106663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PROFIT, 
   [COORD @D106666, AGR [COUNT @D106665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PROFIT, 
   [COORD @D106670, AGR [COUNT @D106669, PER @D106668, PLU @D106667, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PROFIT, 
   [COORD @D106676, PAST @D106675, AGR [CASE @D106674, COUNT @D106673, 
            PER @D106672, PLU @D106671, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : PROFIT, 
   [COORD @D106679, AGR [COUNT @D106678, PER @D106677, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROFIT, 
   [COORD @D106681, AGR [COUNT @D106680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROFIT, 
   [COORD @D106683, AGR [COUNT @D106682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROFIT, 
   [COORD @D106687, AGR [COUNT @D106686, PER @D106685, PLU @D106684, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROFIT, 
   [COORD @D106693, PAST @D106692, AGR [CASE @D106691, COUNT @D106690, 
            PER @D106689, PLU @D106688, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROFIT, 
   [COORD @D106696, AGR [COUNT @D106695, PER @D106694, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FROM, ARITY 2] : PROFIT, 
   [COORD @D106698, AGR [COUNT @D106697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FROM, ARITY 2] : PROFIT, 
   [COORD @D106700, AGR [COUNT @D106699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FROM, ARITY 2] : PROFIT, 
   [COORD @D106704, AGR [COUNT @D106703, PER @D106702, PLU @D106701, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP FROM, ARITY 2] : PROFIT, 
   [COORD @D106710, PAST @D106709, 
      AGR [CASE @D106708, COUNT @D106707, PER @D106706, PLU @D106705, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP FROM, ARITY 2] : PROFIT, 
   [COORD @D106713, AGR [COUNT @D106712, PER @D106711, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : PROFIT, 
   [COORD @D106715, AGR [COUNT @D106714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : PROFIT, 
   [COORD @D106717, AGR [COUNT @D106716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : PROFIT, 
   [COORD @D106721, AGR [COUNT @D106720, PER @D106719, PLU @D106718, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, PREP BY, ARITY 2] : PROFIT, 
   [COORD @D106727, PAST @D106726, 
      AGR [CASE @D106725, COUNT @D106724, PER @D106723, PLU @D106722, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      PREP BY, ARITY 2] : PROFIT, 
   [COORD @D106730, AGR [COUNT @D106729, PER @D106728, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROFIT, 
   [COORD @D106732, AGR [COUNT @D106731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROFIT, 
   [COORD @D106734, AGR [COUNT @D106733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROFIT, 
   [COORD @D106738, AGR [COUNT @D106737, PER @D106736, PLU @D106735, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : PROFIT, 
   [COORD @D106744, PAST @D106743, 
      AGR [CASE @D106742, COUNT @D106741, PER @D106740, PLU @D106739, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : PROFIT, 
   [COORD @D106747, AGR [COUNT @D106746, PER @D106745, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : PROFIT, 
   [COORD @D106749, AGR [COUNT @D106748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : PROFIT, 
   [COORD @D106751, AGR [COUNT @D106750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : PROFIT, 
   [COORD @D106755, AGR [COUNT @D106754, PER @D106753, PLU @D106752, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM BY, ARITY 2] : PROFIT, 
   [COORD @D106761, PAST @D106760, 
      AGR [CASE @D106759, COUNT @D106758, PER @D106757, PLU @D106756, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : PROFIT.

WORD profits : 
   [COORD @D106770, DEMON @D106769, REFL @D106768, PRD @D106767, 
      CASE @D106766, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PROFIT, 
   [COORD @D106772, AGR [COUNT @D106771, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106774, 
      AGR [COUNT @D106773, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106776, 
      AGR [COUNT @D106775, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PROFIT, 
   [COORD @D106778, AGR [COUNT @D106777, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, PREP BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROFIT, 
   [COORD @D106780, AGR [COUNT @D106779, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROFIT, 
   [COORD @D106782, AGR [COUNT @D106781, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROFIT.

WORD profitted : 
   [COORD @D106791, AGR [CASE @D106790, COUNT @D106789, PER @D106788, 
            PLU @D106787, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROFIT, 
   [COORD @D106796, AGR [CASE @D106795, COUNT @D106794, PER @D106793, 
            PLU @D106792, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106801, AGR [CASE @D106800, COUNT @D106799, PER @D106798, 
            PLU @D106797, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106806, AGR [CASE @D106805, COUNT @D106804, PER @D106803, 
            PLU @D106802, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106811, AGR [CASE @D106810, COUNT @D106809, PER @D106808, 
            PLU @D106807, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106816, AGR [CASE @D106815, COUNT @D106814, PER @D106813, 
            PLU @D106812, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROFIT, 
   [COORD @D106821, AGR [CASE @D106820, COUNT @D106819, PER @D106818, 
            PLU @D106817, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106826, AGR [CASE @D106825, COUNT @D106824, PER @D106823, 
            PLU @D106822, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106831, AGR [CASE @D106830, COUNT @D106829, PER @D106828, 
            PLU @D106827, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106836, AGR [CASE @D106835, COUNT @D106834, PER @D106833, 
            PLU @D106832, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106841, AGR [CASE @D106840, COUNT @D106839, PER @D106838, 
            PLU @D106837, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106846, AGR [CASE @D106845, COUNT @D106844, PER @D106843, 
            PLU @D106842, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106851, AGR [CASE @D106850, COUNT @D106849, PER @D106848, 
            PLU @D106847, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106856, AGR [CASE @D106855, COUNT @D106854, PER @D106853, 
            PLU @D106852, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM BY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106861, AGR [CASE @D106860, COUNT @D106859, PER @D106858, 
            PLU @D106857, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106866, AGR [CASE @D106865, COUNT @D106864, PER @D106863, 
            PLU @D106862, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROFIT.

WORD profitting : 
   [COORD @D106880, PRD @D106879, AGR [CASE @D106878, COUNT @D106877, 
            PER @D106876, PLU @D106875, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106886, PRD @D106885, 
      AGR [CASE @D106884, COUNT @D106883, PER @D106882, PLU @D106881, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROFIT, 
   [COORD @D106892, PRD @D106891, AGR [CASE @D106890, COUNT @D106889, 
            PER @D106888, PLU @D106887, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, 
      PREP FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106898, PRD @D106897, 
      AGR [CASE @D106896, COUNT @D106895, PER @D106894, PLU @D106893, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROFIT, 
   [COORD @D106904, PRD @D106903, AGR [CASE @D106902, COUNT @D106901, 
            PER @D106900, PLU @D106899, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROFIT, 
   [COORD @D106910, PRD @D106909, 
      AGR [CASE @D106908, COUNT @D106907, PER @D106906, PLU @D106905, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROFIT.

WORD program : 
   [COORD @D106915, AGR [COUNT @D106914, PER @D106913, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAM, 
   [COORD @D106917, AGR [COUNT @D106916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAM, 
   [COORD @D106919, AGR [COUNT @D106918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAM, 
   [COORD @D106923, AGR [COUNT @D106922, PER @D106921, PLU @D106920, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAM, 
   [COORD @D106929, PAST @D106928, 
      AGR [CASE @D106927, COUNT @D106926, PER @D106925, PLU @D106924, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : PROGRAM, 
   [COORD @D106932, AGR [COUNT @D106931, PER @D106930, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROGRAM, 
   [COORD @D106934, AGR [COUNT @D106933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROGRAM, 
   [COORD @D106936, AGR [COUNT @D106935, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROGRAM, 
   [COORD @D106940, AGR [COUNT @D106939, PER @D106938, PLU @D106937, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROGRAM, 
   [COORD @D106946, PAST @D106945, AGR [CASE @D106944, COUNT @D106943, 
            PER @D106942, PLU @D106941, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROGRAM.

WORD programme : 
   [COORD @D106955, AGR [COUNT @D106954, PER @D106953, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAMME, 
   [COORD @D106957, AGR [COUNT @D106956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAMME, 
   [COORD @D106959, AGR [COUNT @D106958, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAMME, 
   [COORD @D106963, AGR [COUNT @D106962, PER @D106961, PLU @D106960, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PROGRAMME, 
   [COORD @D106969, PAST @D106968, 
      AGR [CASE @D106967, COUNT @D106966, PER @D106965, PLU @D106964, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : PROGRAMME, 
   [COORD @D106972, AGR [COUNT @D106971, PER @D106970, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROGRAMME, 
   [COORD @D106974, AGR [COUNT @D106973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROGRAMME, 
   [COORD @D106976, AGR [COUNT @D106975, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROGRAMME, 
   [COORD @D106980, AGR [COUNT @D106979, PER @D106978, PLU @D106977, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROGRAMME, 
   [COORD @D106986, PAST @D106985, AGR [CASE @D106984, COUNT @D106983, 
            PER @D106982, PLU @D106981, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROGRAMME.

WORD programmed : 
   [COORD @D107000, AGR [CASE @D106999, NFORM @D106998, COUNT @D106997, 
            PER @D106996, PLU @D106995, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROGRAMME, 
   [COORD @D107005, AGR [CASE @D107004, COUNT @D107003, PER @D107002, 
            PLU @D107001, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROGRAMME, 
   [COORD @D107010, AGR [CASE @D107009, COUNT @D107008, PER @D107007, 
            PLU @D107006, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROGRAMME, 
   [COORD @D107015, AGR [CASE @D107014, COUNT @D107013, PER @D107012, 
            PLU @D107011, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROGRAMME, 
   [COORD @D107020, AGR [CASE @D107019, COUNT @D107018, PER @D107017, 
            PLU @D107016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROGRAMME, 
   [COORD @D107025, AGR [CASE @D107024, COUNT @D107023, PER @D107022, 
            PLU @D107021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROGRAMME, 
   [COORD @D107030, AGR [CASE @D107029, COUNT @D107028, PER @D107027, 
            PLU @D107026, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROGRAM, 
   [COORD @D107035, AGR [CASE @D107034, COUNT @D107033, PER @D107032, 
            PLU @D107031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROGRAM, 
   [COORD @D107041, AGR [CASE @D107040, NFORM @D107039, COUNT @D107038, 
            PER @D107037, PLU @D107036, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROGRAM, 
   [COORD @D107046, AGR [CASE @D107045, COUNT @D107044, PER @D107043, 
            PLU @D107042, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROGRAM, 
   [COORD @D107051, AGR [CASE @D107050, COUNT @D107049, PER @D107048, 
            PLU @D107047, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROGRAM, 
   [COORD @D107056, AGR [CASE @D107055, COUNT @D107054, PER @D107053, 
            PLU @D107052, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROGRAM.

WORD programmes : 
   [COORD @D107066, AGR [COUNT @D107065, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PROGRAMME, 
   [COORD @D107068, AGR [COUNT @D107067, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROGRAMME.

WORD programming : 
   [COORD @D107082, PRD @D107081, AGR [CASE @D107080, COUNT @D107079, 
            PER @D107078, PLU @D107077, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROGRAMME, 
   [COORD @D107088, PRD @D107087, 
      AGR [CASE @D107086, COUNT @D107085, PER @D107084, PLU @D107083, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROGRAMME, 
   [COORD @D107094, PRD @D107093, AGR [CASE @D107092, COUNT @D107091, 
            PER @D107090, PLU @D107089, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROGRAM, 
   [COORD @D107100, PRD @D107099, 
      AGR [CASE @D107098, COUNT @D107097, PER @D107096, PLU @D107095, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROGRAM.

WORD programs : 
   [COORD @D107105, AGR [COUNT @D107104, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PROGRAM, 
   [COORD @D107107, AGR [COUNT @D107106, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROGRAM.

WORD progress : 
   [COORD @D107114, REFL @D107113, COUNT @D107112, PRD @D107111, 
      CASE @D107110, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PROGRESS, 
   [COORD @D107117, 
      AGR [COUNT @D107116, PER @D107115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, ARITY 1] : 
   PROGRESS, 
   [COORD @D107119, AGR [COUNT @D107118, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROGRESS, 
   [COORD @D107121, AGR [COUNT @D107120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROGRESS, 
   [COORD @D107125, AGR [COUNT @D107124, PER @D107123, PLU @D107122, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROGRESS, 
   [COORD @D107131, PAST @D107130, AGR 
         [CASE @D107129, COUNT @D107128, PER @D107127, PLU @D107126, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      ARITY 1] : PROGRESS.

WORD progressed : 
   [COORD @D107140, AGR [CASE @D107139, COUNT @D107138, PER @D107137, 
            PLU @D107136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROGRESS, 
   [COORD @D107145, AGR [CASE @D107144, COUNT @D107143, PER @D107142, 
            PLU @D107141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROGRESS.

WORD progresses : 
   [COORD @D107154, DEMON @D107153, REFL @D107152, PRD @D107151, 
      CASE @D107150, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PROGRESS, 
   [COORD @D107156, AGR [COUNT @D107155, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROGRESS.

WORD progressing : 
   [COORD @D107170, PRD @D107169, AGR [CASE @D107168, COUNT @D107167, 
            PER @D107166, PLU @D107165, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROGRESS.

WORD project : 
   [COORD @D107180, REFL @D107179, PRD @D107178, CASE @D107177, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PROJECT, 
   [COORD @D107183, 
      AGR [COUNT @D107182, PER @D107181, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ONTO, 
      ARITY 3] : PROJECT, 
   [COORD @D107185, AGR [COUNT @D107184, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : PROJECT, 
   [COORD @D107187, AGR [COUNT @D107186, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : PROJECT, 
   [COORD @D107191, AGR [COUNT @D107190, PER @D107189, PLU @D107188, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : PROJECT, 
   [COORD @D107197, PAST @D107196, 
      AGR [CASE @D107195, COUNT @D107194, PER @D107193, PLU @D107192, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ONTO, ARITY 3] : PROJECT, 
   [COORD @D107200, AGR [COUNT @D107199, PER @D107198, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PROJECT, 
   [COORD @D107202, AGR [COUNT @D107201, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PROJECT, 
   [COORD @D107204, AGR [COUNT @D107203, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PROJECT, 
   [COORD @D107208, AGR [COUNT @D107207, PER @D107206, PLU @D107205, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PROJECT, 
   [COORD @D107214, PAST @D107213, 
      AGR [CASE @D107212, COUNT @D107211, PER @D107210, PLU @D107209, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : PROJECT, 
   [COORD @D107217, AGR [COUNT @D107216, PER @D107215, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PROJECT, 
   [COORD @D107219, AGR [COUNT @D107218, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PROJECT, 
   [COORD @D107221, AGR [COUNT @D107220, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PROJECT, 
   [COORD @D107225, AGR [COUNT @D107224, PER @D107223, PLU @D107222, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PROJECT, 
   [COORD @D107231, PAST @D107230, 
      AGR [CASE @D107229, COUNT @D107228, PER @D107227, PLU @D107226, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : PROJECT, 
   [COORD @D107234, AGR [COUNT @D107233, PER @D107232, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROJECT, 
   [COORD @D107236, AGR [COUNT @D107235, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROJECT, 
   [COORD @D107238, AGR [COUNT @D107237, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROJECT, 
   [COORD @D107242, AGR [COUNT @D107241, PER @D107240, PLU @D107239, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROJECT, 
   [COORD @D107248, PAST @D107247, AGR [CASE @D107246, COUNT @D107245, 
            PER @D107244, PLU @D107243, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROJECT, 
   [COORD @D107251, AGR [COUNT @D107250, PER @D107249, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROJECT, 
   [COORD @D107253, AGR [COUNT @D107252, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROJECT, 
   [COORD @D107255, AGR [COUNT @D107254, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROJECT, 
   [COORD @D107259, AGR [COUNT @D107258, PER @D107257, PLU @D107256, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROJECT, 
   [COORD @D107265, PAST @D107264, AGR [CASE @D107263, COUNT @D107262, 
            PER @D107261, PLU @D107260, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PROJECT.

WORD projected : 
   [COORD @D107274, AGR [CASE @D107273, COUNT @D107272, PER @D107271, 
            PLU @D107270, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107279, AGR [CASE @D107278, COUNT @D107277, PER @D107276, 
            PLU @D107275, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107284, AGR [CASE @D107283, COUNT @D107282, PER @D107281, 
            PLU @D107280, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107289, AGR [CASE @D107288, COUNT @D107287, PER @D107286, 
            PLU @D107285, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107294, AGR [CASE @D107293, COUNT @D107292, PER @D107291, 
            PLU @D107290, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107299, AGR [CASE @D107298, COUNT @D107297, PER @D107296, 
            PLU @D107295, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107304, AGR [CASE @D107303, COUNT @D107302, PER @D107301, 
            PLU @D107300, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107309, AGR [CASE @D107308, COUNT @D107307, PER @D107306, 
            PLU @D107305, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107314, AGR [CASE @D107313, COUNT @D107312, PER @D107311, 
            PLU @D107310, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107319, AGR [CASE @D107318, COUNT @D107317, PER @D107316, 
            PLU @D107315, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107324, AGR [CASE @D107323, COUNT @D107322, PER @D107321, 
            PLU @D107320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107329, AGR [CASE @D107328, COUNT @D107327, PER @D107326, 
            PLU @D107325, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROJECT, 
   [COORD @D107334, AGR [CASE @D107333, COUNT @D107332, PER @D107331, 
            PLU @D107330, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107339, AGR [CASE @D107338, COUNT @D107337, PER @D107336, 
            PLU @D107335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROJECT.

WORD projecting : 
   [COORD @D107353, PRD @D107352, AGR [CASE @D107351, COUNT @D107350, 
            PER @D107349, PLU @D107348, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM ONTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107359, PRD @D107358, 
      AGR [CASE @D107357, COUNT @D107356, PER @D107355, PLU @D107354, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROJECT, 
   [COORD @D107365, PRD @D107364, AGR [CASE @D107363, COUNT @D107362, 
            PER @D107361, PLU @D107360, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107371, PRD @D107370, 
      AGR [CASE @D107369, COUNT @D107368, PER @D107367, PLU @D107366, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROJECT, 
   [COORD @D107377, PRD @D107376, AGR [CASE @D107375, COUNT @D107374, 
            PER @D107373, PLU @D107372, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROJECT.

WORD projects : 
   [COORD @D107386, DEMON @D107385, REFL @D107384, PRD @D107383, 
      CASE @D107382, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PROJECT, 
   [COORD @D107388, AGR [COUNT @D107387, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROJECT, 
   [COORD @D107390, AGR [COUNT @D107389, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROJECT, 
   [COORD @D107392, AGR [COUNT @D107391, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROJECT, 
   [COORD @D107394, AGR [COUNT @D107393, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROJECT, 
   [COORD @D107396, 
      AGR [COUNT @D107395, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROJECT.

WORD propose : 
   [COORD @D107402, AGR [COUNT @D107401, PER @D107400, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROPOSE, 
   [COORD @D107404, AGR [COUNT @D107403, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROPOSE, 
   [COORD @D107406, AGR [COUNT @D107405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROPOSE, 
   [COORD @D107410, AGR [COUNT @D107409, PER @D107408, PLU @D107407, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROPOSE, 
   [COORD @D107416, PAST @D107415, 
      AGR [CASE @D107414, COUNT @D107413, PER @D107412, PLU @D107411, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : PROPOSE, 
   [COORD @D107419, AGR [COUNT @D107418, PER @D107417, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROPOSE, 
   [COORD @D107421, AGR [COUNT @D107420, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROPOSE, 
   [COORD @D107423, AGR [COUNT @D107422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROPOSE, 
   [COORD @D107427, AGR [COUNT @D107426, PER @D107425, PLU @D107424, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROPOSE, 
   [COORD @D107433, PAST @D107432, 
      AGR [CASE @D107431, COUNT @D107430, PER @D107429, PLU @D107428, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : PROPOSE, 
   [COORD @D107436, AGR [COUNT @D107435, PER @D107434, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PROPOSE, 
   [COORD @D107438, AGR [COUNT @D107437, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PROPOSE, 
   [COORD @D107440, AGR [COUNT @D107439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PROPOSE, 
   [COORD @D107444, AGR [COUNT @D107443, PER @D107442, PLU @D107441, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : PROPOSE, 
   [COORD @D107450, PAST @D107449, 
      AGR [CASE @D107448, COUNT @D107447, PER @D107446, PLU @D107445, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : PROPOSE, 
   [COORD @D107453, AGR [COUNT @D107452, PER @D107451, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROPOSE, 
   [COORD @D107455, AGR [COUNT @D107454, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROPOSE, 
   [COORD @D107457, AGR [COUNT @D107456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROPOSE, 
   [COORD @D107461, AGR [COUNT @D107460, PER @D107459, PLU @D107458, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : PROPOSE, 
   [COORD @D107467, PAST @D107466, 
      AGR [CASE @D107465, COUNT @D107464, PER @D107463, PLU @D107462, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : PROPOSE, 
   [COORD @D107470, AGR [COUNT @D107469, PER @D107468, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : PROPOSE, 
   [COORD @D107472, AGR [COUNT @D107471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : PROPOSE, 
   [COORD @D107474, AGR [COUNT @D107473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : PROPOSE, 
   [COORD @D107478, AGR [COUNT @D107477, PER @D107476, PLU @D107475, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : PROPOSE, 
   [COORD @D107484, PAST @D107483, AGR [CASE @D107482, COUNT @D107481, 
            PER @D107480, PLU @D107479, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : PROPOSE, 
   [COORD @D107487, AGR [COUNT @D107486, PER @D107485, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROPOSE, 
   [COORD @D107489, AGR [COUNT @D107488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROPOSE, 
   [COORD @D107491, AGR [COUNT @D107490, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROPOSE, 
   [COORD @D107495, AGR [COUNT @D107494, PER @D107493, PLU @D107492, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROPOSE, 
   [COORD @D107501, PAST @D107500, AGR [CASE @D107499, COUNT @D107498, 
            PER @D107497, PLU @D107496, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROPOSE, 
   [COORD @D107504, AGR [COUNT @D107503, PER @D107502, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROPOSE, 
   [COORD @D107506, AGR [COUNT @D107505, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROPOSE, 
   [COORD @D107508, AGR [COUNT @D107507, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROPOSE, 
   [COORD @D107512, AGR [COUNT @D107511, PER @D107510, PLU @D107509, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : PROPOSE, 
   [COORD @D107518, PAST @D107517, 
      AGR [CASE @D107516, COUNT @D107515, PER @D107514, PLU @D107513, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : PROPOSE, 
   [COORD @D107521, AGR [COUNT @D107520, PER @D107519, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROPOSE, 
   [COORD @D107523, AGR [COUNT @D107522, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROPOSE, 
   [COORD @D107525, AGR [COUNT @D107524, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROPOSE, 
   [COORD @D107529, AGR [COUNT @D107528, PER @D107527, PLU @D107526, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROPOSE, 
   [COORD @D107535, PAST @D107534, AGR [CASE @D107533, COUNT @D107532, 
            PER @D107531, PLU @D107530, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PROPOSE.

WORD proposed : 
   [COORD @D107544, AGR [CASE @D107543, COUNT @D107542, PER @D107541, 
            PLU @D107540, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107549, AGR [CASE @D107548, COUNT @D107547, PER @D107546, 
            PLU @D107545, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107554, AGR [CASE @D107553, COUNT @D107552, PER @D107551, 
            PLU @D107550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107559, AGR [CASE @D107558, COUNT @D107557, PER @D107556, 
            PLU @D107555, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107564, AGR [CASE @D107563, COUNT @D107562, PER @D107561, 
            PLU @D107560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107569, AGR [CASE @D107568, COUNT @D107567, PER @D107566, 
            PLU @D107565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107574, AGR [CASE @D107573, COUNT @D107572, PER @D107571, 
            PLU @D107570, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107579, AGR [CASE @D107578, COUNT @D107577, PER @D107576, 
            PLU @D107575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107584, AGR [CASE @D107583, COUNT @D107582, PER @D107581, 
            PLU @D107580, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107589, AGR [CASE @D107588, COUNT @D107587, PER @D107586, 
            PLU @D107585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107594, AGR [CASE @D107593, COUNT @D107592, PER @D107591, 
            PLU @D107590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107599, AGR [CASE @D107598, COUNT @D107597, PER @D107596, 
            PLU @D107595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107604, AGR [CASE @D107603, COUNT @D107602, PER @D107601, 
            PLU @D107600, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107609, AGR [CASE @D107608, COUNT @D107607, PER @D107606, 
            PLU @D107605, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107614, AGR [CASE @D107613, COUNT @D107612, PER @D107611, 
            PLU @D107610, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107619, AGR [CASE @D107618, COUNT @D107617, PER @D107616, 
            PLU @D107615, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107624, AGR [CASE @D107623, COUNT @D107622, PER @D107621, 
            PLU @D107620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107629, AGR [CASE @D107628, COUNT @D107627, PER @D107626, 
            PLU @D107625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107634, AGR [CASE @D107633, COUNT @D107632, PER @D107631, 
            PLU @D107630, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107639, AGR [CASE @D107638, COUNT @D107637, PER @D107636, 
            PLU @D107635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROPOSE.

WORD proposes : 
   [COORD @D107645, AGR [COUNT @D107644, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROPOSE, 
   [COORD @D107647, AGR [COUNT @D107646, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROPOSE, 
   [COORD @D107649, AGR [COUNT @D107648, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROPOSE, 
   [COORD @D107651, AGR [COUNT @D107650, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PROPOSE, 
   [COORD @D107653, AGR [COUNT @D107652, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107655, 
      AGR [COUNT @D107654, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107657, 
      AGR [COUNT @D107656, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107659, 
      AGR [COUNT @D107658, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROPOSE.

WORD proposing : 
   [COORD @D107668, PRD @D107667, AGR [CASE @D107666, COUNT @D107665, 
            PER @D107664, PLU @D107663, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107674, PRD @D107673, 
      AGR [CASE @D107672, COUNT @D107671, PER @D107670, PLU @D107669, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107680, PRD @D107679, AGR [CASE @D107678, COUNT @D107677, 
            PER @D107676, PLU @D107675, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107686, PRD @D107685, 
      AGR [CASE @D107684, COUNT @D107683, PER @D107682, PLU @D107681, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROPOSE, 
   [COORD @D107692, PRD @D107691, AGR [CASE @D107690, COUNT @D107689, 
            PER @D107688, PLU @D107687, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107698, PRD @D107697, 
      AGR [CASE @D107696, COUNT @D107695, PER @D107694, PLU @D107693, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROPOSE, 
   [COORD @D107704, PRD @D107703, AGR [CASE @D107702, COUNT @D107701, 
            PER @D107700, PLU @D107699, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROPOSE, 
   [COORD @D107710, PRD @D107709, 
      AGR [CASE @D107708, COUNT @D107707, PER @D107706, PLU @D107705, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROPOSE.

WORD prove : 
   [COORD @D107716, AGR [COUNT @D107715, PER @D107714, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROVE, 
   [COORD @D107718, AGR [COUNT @D107717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROVE, 
   [COORD @D107720, AGR [COUNT @D107719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROVE, 
   [COORD @D107724, AGR [COUNT @D107723, PER @D107722, PLU @D107721, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : PROVE, 
   [COORD @D107730, PAST @D107729, 
      AGR [CASE @D107728, COUNT @D107727, PER @D107726, PLU @D107725, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : PROVE, 
   [COORD @D107733, AGR [COUNT @D107732, PER @D107731, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : PROVE, 
   [COORD @D107735, AGR [COUNT @D107734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : PROVE, 
   [COORD @D107737, AGR [COUNT @D107736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : PROVE, 
   [COORD @D107741, AGR [COUNT @D107740, PER @D107739, PLU @D107738, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : PROVE, 
   [COORD @D107747, PAST @D107746, AGR [CASE @D107745, COUNT @D107744, 
            PER @D107743, PLU @D107742, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : PROVE, 
   [COORD @D107750, AGR [COUNT @D107749, PER @D107748, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVE, 
   [COORD @D107752, AGR [COUNT @D107751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVE, 
   [COORD @D107754, AGR [COUNT @D107753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVE, 
   [COORD @D107758, AGR [COUNT @D107757, PER @D107756, PLU @D107755, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVE, 
   [COORD @D107764, PAST @D107763, AGR [CASE @D107762, COUNT @D107761, 
            PER @D107760, PLU @D107759, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : PROVE, 
   [COORD @D107767, AGR [COUNT @D107766, PER @D107765, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : PROVE, 
   [COORD @D107769, AGR [COUNT @D107768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : PROVE, 
   [COORD @D107771, AGR [COUNT @D107770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : PROVE, 
   [COORD @D107775, AGR [COUNT @D107774, PER @D107773, PLU @D107772, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : PROVE, 
   [COORD @D107781, PAST @D107780, AGR [CASE @D107779, COUNT @D107778, 
            PER @D107777, PLU @D107776, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_NP, ARITY 2] : PROVE, 
   [COORD @D107784, AGR [COUNT @D107783, PER @D107782, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PROVE, 
   [COORD @D107786, AGR [COUNT @D107785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PROVE, 
   [COORD @D107788, AGR [COUNT @D107787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PROVE, 
   [COORD @D107792, AGR [COUNT @D107791, PER @D107790, PLU @D107789, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : PROVE, 
   [COORD @D107798, PAST @D107797, AGR [CASE @D107796, COUNT @D107795, 
            PER @D107794, PLU @D107793, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : PROVE, 
   [COORD @D107801, AGR [COUNT @D107800, PER @D107799, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : PROVE, 
   [COORD @D107803, AGR [COUNT @D107802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : PROVE, 
   [COORD @D107805, AGR [COUNT @D107804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : PROVE, 
   [COORD @D107809, AGR [COUNT @D107808, PER @D107807, PLU @D107806, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : PROVE, 
   [COORD @D107815, PAST @D107814, AGR [CASE @D107813, COUNT @D107812, 
            PER @D107811, PLU @D107810, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : PROVE, 
   [COORD @D107818, AGR [COUNT @D107817, PER @D107816, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROVE, 
   [COORD @D107820, AGR [COUNT @D107819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROVE, 
   [COORD @D107822, AGR [COUNT @D107821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROVE, 
   [COORD @D107826, AGR [COUNT @D107825, PER @D107824, PLU @D107823, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROVE, 
   [COORD @D107832, PAST @D107831, AGR [CASE @D107830, COUNT @D107829, 
            PER @D107828, PLU @D107827, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROVE, 
   [COORD @D107834, AGR [COUNT @D107833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : PROVE, 
   [COORD @D107836, AGR [COUNT @D107835, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : PROVE, 
   [COORD @D107840, AGR [NFORM @D107839, COUNT @D107838, PER @D107837, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : PROVE, 
   [COORD @D107844, AGR [COUNT @D107843, PER @D107842, PLU @D107841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : PROVE, 
   [COORD @D107847, AGR @D107846, PAST @D107845, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_NP, ARITY 1] : PROVE, 
   [COORD @D107849, AGR [COUNT @D107848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : PROVE, 
   [COORD @D107851, AGR [COUNT @D107850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : PROVE, 
   [COORD @D107855, AGR [NFORM @D107854, COUNT @D107853, PER @D107852, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : PROVE, 
   [COORD @D107859, AGR [COUNT @D107858, PER @D107857, PLU @D107856, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : PROVE, 
   [COORD @D107862, AGR @D107861, PAST @D107860, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_AP, ARITY 1] : PROVE, 
   [COORD @D107865, AGR [COUNT @D107864, PER @D107863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROVE, 
   [COORD @D107867, AGR [COUNT @D107866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROVE, 
   [COORD @D107869, AGR [COUNT @D107868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROVE, 
   [COORD @D107873, AGR [COUNT @D107872, PER @D107871, PLU @D107870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PROVE, 
   [COORD @D107879, PAST @D107878, AGR [CASE @D107877, COUNT @D107876, 
            PER @D107875, PLU @D107874, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PROVE.

WORD proved : 
   [COORD @D107888, AGR [CASE @D107887, COUNT @D107886, PER @D107885, 
            PLU @D107884, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107893, AGR [CASE @D107892, COUNT @D107891, PER @D107890, 
            PLU @D107889, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107898, AGR [CASE @D107897, COUNT @D107896, PER @D107895, 
            PLU @D107894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107903, AGR [CASE @D107902, COUNT @D107901, PER @D107900, 
            PLU @D107899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107908, AGR [CASE @D107907, COUNT @D107906, PER @D107905, 
            PLU @D107904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107913, AGR [UB @D107912, VFORM @D107911, SUBJ @D107910, 
            FIN @D107909, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D107918, AGR [CASE @D107917, COUNT @D107916, PER @D107915, 
            PLU @D107914, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107923, AGR [CASE @D107922, COUNT @D107921, PER @D107920, 
            PLU @D107919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107928, AGR [CASE @D107927, COUNT @D107926, PER @D107925, 
            PLU @D107924, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROVE, 
   [COORD @D107933, AGR [CASE @D107932, COUNT @D107931, PER @D107930, 
            PLU @D107929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107938, AGR [CASE @D107937, COUNT @D107936, PER @D107935, 
            PLU @D107934, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107944, AGR [CASE @D107943, NFORM @D107942, COUNT @D107941, 
            PER @D107940, PLU @D107939, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROVE, 
   [COORD @D107949, AGR [UB @D107948, VFORM @D107947, SUBJ @D107946, 
            FIN @D107945, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D107954, AGR [CASE @D107953, COUNT @D107952, PER @D107951, 
            PLU @D107950, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107959, AGR [CASE @D107958, COUNT @D107957, PER @D107956, 
            PLU @D107955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107964, AGR [CASE @D107963, COUNT @D107962, PER @D107961, 
            PLU @D107960, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107969, AGR [CASE @D107968, COUNT @D107967, PER @D107966, 
            PLU @D107965, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107975, AGR [CASE @D107974, NFORM @D107973, COUNT @D107972, 
            PER @D107971, PLU @D107970, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROVE, 
   [COORD @D107980, AGR [UB @D107979, VFORM @D107978, SUBJ @D107977, 
            FIN @D107976, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D107985, AGR [CASE @D107984, COUNT @D107983, PER @D107982, 
            PLU @D107981, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107990, AGR [CASE @D107989, COUNT @D107988, PER @D107987, 
            PLU @D107986, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVE, 
   [COORD @D107995, AGR [CASE @D107994, COUNT @D107993, PER @D107992, 
            PLU @D107991, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROVE, 
   [COORD @D107997, AGR @D107996, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROVE, 
   [COORD @D107999, AGR @D107998, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D108001, AGR @D108000, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROVE, 
   [COORD @D108003, AGR @D108002, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D108008, AGR [CASE @D108007, COUNT @D108006, PER @D108005, 
            PLU @D108004, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D108013, AGR [CASE @D108012, COUNT @D108011, PER @D108010, 
            PLU @D108009, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVE.

WORD proves : 
   [COORD @D108019, AGR [COUNT @D108018, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D108021, AGR [COUNT @D108020, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108023, 
      AGR [COUNT @D108022, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108025, 
      AGR [COUNT @D108024, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108027, 
      AGR [COUNT @D108026, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108029, 
      AGR [COUNT @D108028, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108031, 
      AGR [COUNT @D108030, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108035, 
      AGR [CASE @D108034, NFORM @D108033, COUNT @D108032, PLU -, PER 3, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT SC_NP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108040, 
      AGR [UB @D108039, VFORM @D108038, SUBJ @D108037, FIN @D108036, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_NP, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108044, 
      AGR [CASE @D108043, NFORM @D108042, COUNT @D108041, PLU -, PER 3, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT SC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108049, 
      AGR [UB @D108048, VFORM @D108047, SUBJ @D108046, FIN @D108045, N -, 
            V +, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_AP, 
      CONJ NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE, 
   [COORD @D108051, 
      AGR [COUNT @D108050, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVE.

WORD provide : 
   [COORD @D108058, AGR [COUNT @D108057, PER @D108056, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PROVIDE, 
   [COORD @D108060, AGR [COUNT @D108059, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PROVIDE, 
   [COORD @D108062, AGR [COUNT @D108061, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PROVIDE, 
   [COORD @D108066, AGR [COUNT @D108065, PER @D108064, PLU @D108063, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : PROVIDE, 
   [COORD @D108072, PAST @D108071, 
      AGR [CASE @D108070, COUNT @D108069, PER @D108068, PLU @D108067, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : PROVIDE, 
   [COORD @D108075, AGR [COUNT @D108074, PER @D108073, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROVIDE, 
   [COORD @D108077, AGR [COUNT @D108076, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROVIDE, 
   [COORD @D108079, AGR [COUNT @D108078, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROVIDE, 
   [COORD @D108083, AGR [COUNT @D108082, PER @D108081, PLU @D108080, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PROVIDE, 
   [COORD @D108089, PAST @D108088, 
      AGR [CASE @D108087, COUNT @D108086, PER @D108085, PLU @D108084, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : PROVIDE, 
   [COORD @D108092, AGR [COUNT @D108091, PER @D108090, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVIDE, 
   [COORD @D108094, AGR [COUNT @D108093, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVIDE, 
   [COORD @D108096, AGR [COUNT @D108095, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVIDE, 
   [COORD @D108100, AGR [COUNT @D108099, PER @D108098, PLU @D108097, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : PROVIDE, 
   [COORD @D108106, PAST @D108105, AGR [CASE @D108104, COUNT @D108103, 
            PER @D108102, PLU @D108101, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : PROVIDE, 
   [COORD @D108109, AGR [COUNT @D108108, PER @D108107, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROVIDE, 
   [COORD @D108111, AGR [COUNT @D108110, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROVIDE, 
   [COORD @D108113, AGR [COUNT @D108112, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PROVIDE, 
   [COORD @D108117, AGR [COUNT @D108116, PER @D108115, PLU @D108114, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PROVIDE, 
   [COORD @D108123, PAST @D108122, AGR [CASE @D108121, COUNT @D108120, 
            PER @D108119, PLU @D108118, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PROVIDE, 
   [COORD @D108126, AGR [COUNT @D108125, PER @D108124, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PROVIDE, 
   [COORD @D108128, AGR [COUNT @D108127, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PROVIDE, 
   [COORD @D108130, AGR [COUNT @D108129, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PROVIDE, 
   [COORD @D108134, AGR [COUNT @D108133, PER @D108132, PLU @D108131, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : PROVIDE, 
   [COORD @D108140, PAST @D108139, 
      AGR [CASE @D108138, COUNT @D108137, PER @D108136, PLU @D108135, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PROVIDE, 
   [COORD @D108143, AGR [COUNT @D108142, PER @D108141, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROVIDE, 
   [COORD @D108145, AGR [COUNT @D108144, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROVIDE, 
   [COORD @D108147, AGR [COUNT @D108146, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROVIDE, 
   [COORD @D108151, AGR [COUNT @D108150, PER @D108149, PLU @D108148, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : PROVIDE, 
   [COORD @D108157, PAST @D108156, 
      AGR [CASE @D108155, COUNT @D108154, PER @D108153, PLU @D108152, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : PROVIDE.

WORD provided : 
   [COORD @D108167, AGR [CASE @D108166, COUNT @D108165, PER @D108164, 
            PLU @D108163, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108172, AGR [CASE @D108171, COUNT @D108170, PER @D108169, 
            PLU @D108168, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108177, AGR [CASE @D108176, COUNT @D108175, PER @D108174, 
            PLU @D108173, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108182, AGR [CASE @D108181, COUNT @D108180, PER @D108179, 
            PLU @D108178, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108187, AGR [CASE @D108186, COUNT @D108185, PER @D108184, 
            PLU @D108183, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108192, AGR [CASE @D108191, COUNT @D108190, PER @D108189, 
            PLU @D108188, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108197, AGR [UB @D108196, VFORM @D108195, SUBJ @D108194, 
            FIN @D108193, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVIDE, 
   [COORD @D108202, AGR [CASE @D108201, COUNT @D108200, PER @D108199, 
            PLU @D108198, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108207, AGR [CASE @D108206, COUNT @D108205, PER @D108204, 
            PLU @D108203, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108212, AGR [CASE @D108211, COUNT @D108210, PER @D108209, 
            PLU @D108208, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108217, AGR [CASE @D108216, COUNT @D108215, PER @D108214, 
            PLU @D108213, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108222, AGR [CASE @D108221, COUNT @D108220, PER @D108219, 
            PLU @D108218, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108227, AGR [CASE @D108226, COUNT @D108225, PER @D108224, 
            PLU @D108223, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108232, AGR [CASE @D108231, COUNT @D108230, PER @D108229, 
            PLU @D108228, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108237, AGR [CASE @D108236, COUNT @D108235, PER @D108234, 
            PLU @D108233, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108242, AGR [CASE @D108241, COUNT @D108240, PER @D108239, 
            PLU @D108238, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108247, AGR [CASE @D108246, COUNT @D108245, PER @D108244, 
            PLU @D108243, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108252, AGR [CASE @D108251, COUNT @D108250, PER @D108249, 
            PLU @D108248, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVIDE.

WORD provides : 
   [COORD @D108259, AGR [COUNT @D108258, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROVIDE, 
   [COORD @D108261, AGR [COUNT @D108260, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PROVIDE, 
   [COORD @D108263, AGR [COUNT @D108262, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108265, 
      AGR [COUNT @D108264, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108267, 
      AGR [COUNT @D108266, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108269, 
      AGR [COUNT @D108268, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PROVIDE.

WORD providing : 
   [COORD @D108279, PRD @D108278, AGR [CASE @D108277, COUNT @D108276, 
            PER @D108275, PLU @D108274, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108285, PRD @D108284, 
      AGR [CASE @D108283, COUNT @D108282, PER @D108281, PLU @D108280, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108291, PRD @D108290, AGR [CASE @D108289, COUNT @D108288, 
            PER @D108287, PLU @D108286, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108297, PRD @D108296, 
      AGR [CASE @D108295, COUNT @D108294, PER @D108293, PLU @D108292, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PROVIDE, 
   [COORD @D108303, PRD @D108302, AGR [CASE @D108301, COUNT @D108300, 
            PER @D108299, PLU @D108298, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROVIDE, 
   [COORD @D108309, PRD @D108308, 
      AGR [CASE @D108307, COUNT @D108306, PER @D108305, PLU @D108304, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVIDE.

WORD proving : 
   [COORD @D108318, PRD @D108317, AGR [CASE @D108316, COUNT @D108315, 
            PER @D108314, PLU @D108313, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D108324, PRD @D108323, 
      AGR [CASE @D108322, COUNT @D108321, PER @D108320, PLU @D108319, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D108330, PRD @D108329, AGR [CASE @D108328, COUNT @D108327, 
            PER @D108326, PLU @D108325, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D108336, PRD @D108335, 
      AGR [CASE @D108334, COUNT @D108333, PER @D108332, PLU @D108331, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PROVE, 
   [COORD @D108342, PRD @D108341, AGR [CASE @D108340, COUNT @D108339, 
            PER @D108338, PLU @D108337, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D108348, PRD @D108347, 
      AGR [CASE @D108346, COUNT @D108345, PER @D108344, PLU @D108343, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PROVE, 
   [COORD @D108354, PRD @D108353, AGR [CASE @D108352, COUNT @D108351, 
            PER @D108350, PLU @D108349, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVE, 
   [COORD @D108357, AGR @D108356, PRD @D108355, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D108360, AGR @D108359, PRD @D108358, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PROVE, 
   [COORD @D108366, PRD @D108365, AGR [CASE @D108364, COUNT @D108363, 
            PER @D108362, PLU @D108361, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PROVE.

WORD publish : 
   [COORD @D108371, AGR [COUNT @D108370, PER @D108369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUBLISH, 
   [COORD @D108373, AGR [COUNT @D108372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUBLISH, 
   [COORD @D108375, AGR [COUNT @D108374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUBLISH, 
   [COORD @D108379, AGR [COUNT @D108378, PER @D108377, PLU @D108376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PUBLISH, 
   [COORD @D108385, PAST @D108384, AGR [CASE @D108383, COUNT @D108382, 
            PER @D108381, PLU @D108380, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PUBLISH, 
   [COORD @D108388, AGR [COUNT @D108387, PER @D108386, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUBLISH, 
   [COORD @D108390, AGR [COUNT @D108389, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUBLISH, 
   [COORD @D108392, AGR [COUNT @D108391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUBLISH, 
   [COORD @D108396, AGR [COUNT @D108395, PER @D108394, PLU @D108393, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUBLISH, 
   [COORD @D108402, PAST @D108401, AGR [CASE @D108400, COUNT @D108399, 
            PER @D108398, PLU @D108397, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PUBLISH.

WORD published : 
   [COORD @D108410, AGR [CASE @D108409, COUNT @D108408, PER @D108407, 
            PLU @D108406, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUBLISH, 
   [COORD @D108415, AGR [CASE @D108414, COUNT @D108413, PER @D108412, 
            PLU @D108411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUBLISH, 
   [COORD @D108420, AGR [CASE @D108419, COUNT @D108418, PER @D108417, 
            PLU @D108416, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUBLISH, 
   [COORD @D108425, AGR [CASE @D108424, COUNT @D108423, PER @D108422, 
            PLU @D108421, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUBLISH, 
   [COORD @D108430, AGR [CASE @D108429, COUNT @D108428, PER @D108427, 
            PLU @D108426, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUBLISH.

WORD publishing : 
   [COORD @D108439, REFL @D108438, PRD @D108437, CASE @D108436, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : PUBLISHING, 
   [COORD @D108445, PRD @D108444, 
      AGR [CASE @D108443, COUNT @D108442, PER @D108441, PLU @D108440, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUBLISH, 
   [COORD @D108451, PRD @D108450, AGR [CASE @D108449, COUNT @D108448, 
            PER @D108447, PLU @D108446, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUBLISH.

WORD pull : 
   [COORD @D108466, AGR [COUNT @D108465, PER @D108464, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PULL, 
   [COORD @D108468, AGR [COUNT @D108467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PULL, 
   [COORD @D108470, AGR [COUNT @D108469, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PULL, 
   [COORD @D108474, AGR [COUNT @D108473, PER @D108472, PLU @D108471, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : PULL, 
   [COORD @D108480, PAST @D108479, AGR [CASE @D108478, COUNT @D108477, 
            PER @D108476, PLU @D108475, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : PULL, 
   [COORD @D108483, AGR [COUNT @D108482, PER @D108481, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PULL, 
   [COORD @D108485, AGR [COUNT @D108484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PULL, 
   [COORD @D108487, AGR [COUNT @D108486, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PULL, 
   [COORD @D108491, AGR [COUNT @D108490, PER @D108489, PLU @D108488, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PULL, 
   [COORD @D108497, PAST @D108496, 
      AGR [CASE @D108495, COUNT @D108494, PER @D108493, PLU @D108492, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : PULL, 
   [COORD @D108500, AGR [COUNT @D108499, PER @D108498, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PULL, 
   [COORD @D108502, AGR [COUNT @D108501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PULL, 
   [COORD @D108504, AGR [COUNT @D108503, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PULL, 
   [COORD @D108508, AGR [COUNT @D108507, PER @D108506, PLU @D108505, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PULL, 
   [COORD @D108514, PAST @D108513, 
      AGR [CASE @D108512, COUNT @D108511, PER @D108510, PLU @D108509, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : PULL, 
   [COORD @D108517, AGR [COUNT @D108516, PER @D108515, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PULL, 
   [COORD @D108519, AGR [COUNT @D108518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PULL, 
   [COORD @D108521, AGR [COUNT @D108520, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PULL, 
   [COORD @D108525, AGR [COUNT @D108524, PER @D108523, PLU @D108522, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PULL, 
   [COORD @D108531, PAST @D108530, AGR [CASE @D108529, COUNT @D108528, 
            PER @D108527, PLU @D108526, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PULL, 
   [COORD @D108534, AGR [COUNT @D108533, PER @D108532, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : PULL, 
   [COORD @D108536, AGR [COUNT @D108535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : PULL, 
   [COORD @D108538, AGR [COUNT @D108537, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : PULL, 
   [COORD @D108542, AGR [COUNT @D108541, PER @D108540, PLU @D108539, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM WITH, ARITY 2] : PULL, 
   [COORD @D108548, PAST @D108547, 
      AGR [CASE @D108546, COUNT @D108545, PER @D108544, PLU @D108543, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : PULL, 
   [COORD @D108551, AGR [COUNT @D108550, PER @D108549, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : PULL, 
   [COORD @D108553, AGR [COUNT @D108552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : PULL, 
   [COORD @D108555, AGR [COUNT @D108554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : PULL, 
   [COORD @D108559, AGR [COUNT @D108558, PER @D108557, PLU @D108556, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : PULL, 
   [COORD @D108565, PAST @D108564, 
      AGR [CASE @D108563, COUNT @D108562, PER @D108561, PLU @D108560, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : PULL, 
   [COORD @D108568, AGR [COUNT @D108567, PER @D108566, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PULL, 
   [COORD @D108570, AGR [COUNT @D108569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PULL, 
   [COORD @D108572, AGR [COUNT @D108571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PULL, 
   [COORD @D108576, AGR [COUNT @D108575, PER @D108574, PLU @D108573, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : PULL, 
   [COORD @D108582, PAST @D108581, 
      AGR [CASE @D108580, COUNT @D108579, PER @D108578, PLU @D108577, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : PULL, 
   [COORD @D108585, AGR [COUNT @D108584, PER @D108583, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108587, AGR [COUNT @D108586, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108589, AGR [COUNT @D108588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108593, AGR [COUNT @D108592, PER @D108591, PLU @D108590, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108599, PAST @D108598, 
      AGR [CASE @D108597, COUNT @D108596, PER @D108595, PLU @D108594, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108602, AGR [COUNT @D108601, PER @D108600, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108604, AGR [COUNT @D108603, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108606, AGR [COUNT @D108605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108610, AGR [COUNT @D108609, PER @D108608, PLU @D108607, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT AHEAD, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108616, PAST @D108615, 
      AGR [CASE @D108614, COUNT @D108613, PER @D108612, PLU @D108611, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM OF, ARITY 2] : PULL, 
   [COORD @D108619, AGR [COUNT @D108618, PER @D108617, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : PULL, 
   [COORD @D108621, AGR [COUNT @D108620, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : PULL, 
   [COORD @D108623, AGR [COUNT @D108622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : PULL, 
   [COORD @D108627, AGR [COUNT @D108626, PER @D108625, PLU @D108624, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT AWAY, PFORM FROM, ARITY 2] : PULL, 
   [COORD @D108633, PAST @D108632, 
      AGR [CASE @D108631, COUNT @D108630, PER @D108629, PLU @D108628, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : PULL, 
   [COORD @D108636, AGR [COUNT @D108635, PER @D108634, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PULL, 
   [COORD @D108638, AGR [COUNT @D108637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PULL, 
   [COORD @D108640, AGR [COUNT @D108639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PULL, 
   [COORD @D108644, AGR [COUNT @D108643, PER @D108642, PLU @D108641, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, ARITY 2] : PULL, 
   [COORD @D108650, PAST @D108649, 
      AGR [CASE @D108648, COUNT @D108647, PER @D108646, PLU @D108645, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : PULL, 
   [COORD @D108653, AGR [COUNT @D108652, PER @D108651, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PULL, 
   [COORD @D108655, AGR [COUNT @D108654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PULL, 
   [COORD @D108657, AGR [COUNT @D108656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PULL, 
   [COORD @D108661, AGR [COUNT @D108660, PER @D108659, PLU @D108658, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : PULL, 
   [COORD @D108667, PAST @D108666, 
      AGR [CASE @D108665, COUNT @D108664, PER @D108663, PLU @D108662, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : PULL, 
   [COORD @D108670, AGR [COUNT @D108669, PER @D108668, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PULL, 
   [COORD @D108672, AGR [COUNT @D108671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PULL, 
   [COORD @D108674, AGR [COUNT @D108673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PULL, 
   [COORD @D108678, AGR [COUNT @D108677, PER @D108676, PLU @D108675, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : PULL, 
   [COORD @D108684, PAST @D108683, 
      AGR [CASE @D108682, COUNT @D108681, PER @D108680, PLU @D108679, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : PULL, 
   [COORD @D108687, AGR [COUNT @D108686, PER @D108685, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : PULL, 
   [COORD @D108689, AGR [COUNT @D108688, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : PULL, 
   [COORD @D108691, AGR [COUNT @D108690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : PULL, 
   [COORD @D108695, AGR [COUNT @D108694, PER @D108693, PLU @D108692, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT THROUGH, ARITY 2] : PULL, 
   [COORD @D108701, PAST @D108700, 
      AGR [CASE @D108699, COUNT @D108698, PER @D108697, PLU @D108696, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : PULL, 
   [COORD @D108704, AGR [COUNT @D108703, PER @D108702, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ROUND, ARITY 2] : PULL, 
   [COORD @D108706, AGR [COUNT @D108705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ROUND, ARITY 2] : PULL, 
   [COORD @D108708, AGR [COUNT @D108707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ROUND, ARITY 2] : PULL, 
   [COORD @D108712, AGR [COUNT @D108711, PER @D108710, PLU @D108709, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ROUND, ARITY 2] : PULL, 
   [COORD @D108718, PAST @D108717, 
      AGR [CASE @D108716, COUNT @D108715, PER @D108714, PLU @D108713, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ROUND, ARITY 2] : PULL, 
   [COORD @D108721, AGR [COUNT @D108720, PER @D108719, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PULL, 
   [COORD @D108723, AGR [COUNT @D108722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PULL, 
   [COORD @D108725, AGR [COUNT @D108724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PULL, 
   [COORD @D108729, AGR [COUNT @D108728, PER @D108727, PLU @D108726, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : PULL, 
   [COORD @D108735, PAST @D108734, 
      AGR [CASE @D108733, COUNT @D108732, PER @D108731, PLU @D108730, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : PULL, 
   [COORD @D108738, AGR [COUNT @D108737, PER @D108736, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PULL, 
   [COORD @D108740, AGR [COUNT @D108739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PULL, 
   [COORD @D108742, AGR [COUNT @D108741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PULL, 
   [COORD @D108746, AGR [COUNT @D108745, PER @D108744, PLU @D108743, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : PULL, 
   [COORD @D108752, PAST @D108751, 
      AGR [CASE @D108750, COUNT @D108749, PER @D108748, PLU @D108747, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : PULL, 
   [COORD @D108755, AGR [COUNT @D108754, PER @D108753, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PULL, 
   [COORD @D108757, AGR [COUNT @D108756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PULL, 
   [COORD @D108759, AGR [COUNT @D108758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PULL, 
   [COORD @D108763, AGR [COUNT @D108762, PER @D108761, PLU @D108760, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : PULL, 
   [COORD @D108769, PAST @D108768, 
      AGR [CASE @D108767, COUNT @D108766, PER @D108765, PLU @D108764, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : PULL, 
   [COORD @D108772, AGR [COUNT @D108771, PER @D108770, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PULL, 
   [COORD @D108774, AGR [COUNT @D108773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PULL, 
   [COORD @D108776, AGR [COUNT @D108775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : PULL, 
   [COORD @D108780, AGR [COUNT @D108779, PER @D108778, PLU @D108777, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : PULL, 
   [COORD @D108786, PAST @D108785, 
      AGR [CASE @D108784, COUNT @D108783, PER @D108782, PLU @D108781, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : PULL, 
   [COORD @D108789, AGR [COUNT @D108788, PER @D108787, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PULL, 
   [COORD @D108791, AGR [COUNT @D108790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PULL, 
   [COORD @D108793, AGR [COUNT @D108792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PULL, 
   [COORD @D108797, AGR [COUNT @D108796, PER @D108795, PLU @D108794, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : PULL, 
   [COORD @D108803, PAST @D108802, 
      AGR [CASE @D108801, COUNT @D108800, PER @D108799, PLU @D108798, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : PULL, 
   [COORD @D108806, AGR [COUNT @D108805, PER @D108804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PULL, 
   [COORD @D108808, AGR [COUNT @D108807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PULL, 
   [COORD @D108810, AGR [COUNT @D108809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PULL, 
   [COORD @D108814, AGR [COUNT @D108813, PER @D108812, PLU @D108811, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : PULL, 
   [COORD @D108820, PAST @D108819, 
      AGR [CASE @D108818, COUNT @D108817, PER @D108816, PLU @D108815, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : PULL, 
   [COORD @D108823, AGR [COUNT @D108822, PER @D108821, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : PULL, 
   [COORD @D108825, AGR [COUNT @D108824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : PULL, 
   [COORD @D108827, AGR [COUNT @D108826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : PULL, 
   [COORD @D108831, AGR [COUNT @D108830, PER @D108829, PLU @D108828, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : PULL, 
   [COORD @D108837, PAST @D108836, 
      AGR [CASE @D108835, COUNT @D108834, PER @D108833, PLU @D108832, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : PULL, 
   [COORD @D108840, AGR [COUNT @D108839, PER @D108838, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : PULL, 
   [COORD @D108842, AGR [COUNT @D108841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : PULL, 
   [COORD @D108844, AGR [COUNT @D108843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : PULL, 
   [COORD @D108848, AGR [COUNT @D108847, PER @D108846, PLU @D108845, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ABOUT, ARITY 2] : PULL, 
   [COORD @D108854, PAST @D108853, 
      AGR [CASE @D108852, COUNT @D108851, PER @D108850, PLU @D108849, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ABOUT, ARITY 2] : PULL, 
   [COORD @D108857, AGR [COUNT @D108856, PER @D108855, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PULL, 
   [COORD @D108859, AGR [COUNT @D108858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PULL, 
   [COORD @D108861, AGR [COUNT @D108860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PULL, 
   [COORD @D108865, AGR [COUNT @D108864, PER @D108863, PLU @D108862, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PULL, 
   [COORD @D108871, PAST @D108870, AGR [CASE @D108869, COUNT @D108868, 
            PER @D108867, PLU @D108866, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PULL, 
   [COORD @D108874, AGR [COUNT @D108873, PER @D108872, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PULL, 
   [COORD @D108876, AGR [COUNT @D108875, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PULL, 
   [COORD @D108878, AGR [COUNT @D108877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PULL, 
   [COORD @D108882, AGR [COUNT @D108881, PER @D108880, PLU @D108879, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PULL, 
   [COORD @D108888, PAST @D108887, 
      AGR [CASE @D108886, COUNT @D108885, PER @D108884, PLU @D108883, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : PULL, 
   [COORD @D108891, AGR [COUNT @D108890, PER @D108889, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PULL, 
   [COORD @D108893, AGR [COUNT @D108892, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PULL, 
   [COORD @D108895, AGR [COUNT @D108894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PULL, 
   [COORD @D108899, AGR [COUNT @D108898, PER @D108897, PLU @D108896, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : PULL, 
   [COORD @D108905, PAST @D108904, 
      AGR [CASE @D108903, COUNT @D108902, PER @D108901, PLU @D108900, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT TOGETHER, ARITY 1] : PULL, 
   [COORD @D108908, AGR [COUNT @D108907, PER @D108906, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PULL, 
   [COORD @D108910, AGR [COUNT @D108909, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PULL, 
   [COORD @D108912, AGR [COUNT @D108911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PULL, 
   [COORD @D108916, AGR [COUNT @D108915, PER @D108914, PLU @D108913, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PULL, 
   [COORD @D108922, PAST @D108921, 
      AGR [CASE @D108920, COUNT @D108919, PER @D108918, PLU @D108917, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT THROUGH, ARITY 1] : PULL, 
   [COORD @D108925, AGR [COUNT @D108924, PER @D108923, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : PULL, 
   [COORD @D108927, AGR [COUNT @D108926, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : PULL, 
   [COORD @D108929, AGR [COUNT @D108928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : PULL, 
   [COORD @D108933, AGR [COUNT @D108932, PER @D108931, PLU @D108930, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : PULL, 
   [COORD @D108939, PAST @D108938, 
      AGR [CASE @D108937, COUNT @D108936, PER @D108935, PLU @D108934, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ROUND, ARITY 1] : PULL, 
   [COORD @D108942, AGR [COUNT @D108941, PER @D108940, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PULL, 
   [COORD @D108944, AGR [COUNT @D108943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PULL, 
   [COORD @D108946, AGR [COUNT @D108945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PULL, 
   [COORD @D108950, AGR [COUNT @D108949, PER @D108948, PLU @D108947, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : PULL, 
   [COORD @D108956, PAST @D108955, 
      AGR [CASE @D108954, COUNT @D108953, PER @D108952, PLU @D108951, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : PULL, 
   [COORD @D108959, AGR [COUNT @D108958, PER @D108957, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PULL, 
   [COORD @D108961, AGR [COUNT @D108960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PULL, 
   [COORD @D108963, AGR [COUNT @D108962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PULL, 
   [COORD @D108967, AGR [COUNT @D108966, PER @D108965, PLU @D108964, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PULL, 
   [COORD @D108973, PAST @D108972, 
      AGR [CASE @D108971, COUNT @D108970, PER @D108969, PLU @D108968, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : PULL, 
   [COORD @D108976, AGR [COUNT @D108975, PER @D108974, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PULL, 
   [COORD @D108978, AGR [COUNT @D108977, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PULL, 
   [COORD @D108980, AGR [COUNT @D108979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PULL, 
   [COORD @D108984, AGR [COUNT @D108983, PER @D108982, PLU @D108981, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PULL, 
   [COORD @D108990, PAST @D108989, 
      AGR [CASE @D108988, COUNT @D108987, PER @D108986, PLU @D108985, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : PULL, 
   [COORD @D108993, AGR [COUNT @D108992, PER @D108991, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PULL, 
   [COORD @D108995, AGR [COUNT @D108994, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PULL, 
   [COORD @D108997, AGR [COUNT @D108996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PULL, 
   [COORD @D109001, AGR [COUNT @D109000, PER @D108999, PLU @D108998, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PULL, 
   [COORD @D109007, PAST @D109006, 
      AGR [CASE @D109005, COUNT @D109004, PER @D109003, PLU @D109002, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : PULL, 
   [COORD @D109010, AGR [COUNT @D109009, PER @D109008, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PULL, 
   [COORD @D109012, AGR [COUNT @D109011, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PULL, 
   [COORD @D109014, AGR [COUNT @D109013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PULL, 
   [COORD @D109018, AGR [COUNT @D109017, PER @D109016, PLU @D109015, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PULL, 
   [COORD @D109024, PAST @D109023, 
      AGR [CASE @D109022, COUNT @D109021, PER @D109020, PLU @D109019, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : PULL, 
   [COORD @D109027, AGR [COUNT @D109026, PER @D109025, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PULL, 
   [COORD @D109029, AGR [COUNT @D109028, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PULL, 
   [COORD @D109031, AGR [COUNT @D109030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PULL, 
   [COORD @D109035, AGR [COUNT @D109034, PER @D109033, PLU @D109032, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PULL, 
   [COORD @D109041, PAST @D109040, 
      AGR [CASE @D109039, COUNT @D109038, PER @D109037, PLU @D109036, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : PULL, 
   [COORD @D109044, AGR [COUNT @D109043, PER @D109042, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PULL, 
   [COORD @D109046, AGR [COUNT @D109045, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PULL, 
   [COORD @D109048, AGR [COUNT @D109047, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PULL, 
   [COORD @D109052, AGR [COUNT @D109051, PER @D109050, PLU @D109049, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PULL, 
   [COORD @D109058, PAST @D109057, 
      AGR [CASE @D109056, COUNT @D109055, PER @D109054, PLU @D109053, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT BACK, ARITY 1] : PULL, 
   [COORD @D109061, AGR [COUNT @D109060, PER @D109059, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PULL, 
   [COORD @D109063, AGR [COUNT @D109062, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PULL, 
   [COORD @D109065, AGR [COUNT @D109064, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PULL, 
   [COORD @D109069, AGR [COUNT @D109068, PER @D109067, PLU @D109066, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : PULL, 
   [COORD @D109075, PAST @D109074, 
      AGR [CASE @D109073, COUNT @D109072, PER @D109071, PLU @D109070, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AWAY, ARITY 1] : PULL, 
   [COORD @D109078, AGR [COUNT @D109077, PER @D109076, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PULL, 
   [COORD @D109080, AGR [COUNT @D109079, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PULL, 
   [COORD @D109082, AGR [COUNT @D109081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PULL, 
   [COORD @D109086, AGR [COUNT @D109085, PER @D109084, PLU @D109083, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PULL, 
   [COORD @D109092, PAST @D109091, 
      AGR [CASE @D109090, COUNT @D109089, PER @D109088, PLU @D109087, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AHEAD, ARITY 1] : PULL, 
   [COORD @D109095, AGR [COUNT @D109094, PER @D109093, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PULL, 
   [COORD @D109097, AGR [COUNT @D109096, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PULL, 
   [COORD @D109099, AGR [COUNT @D109098, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PULL, 
   [COORD @D109103, AGR [COUNT @D109102, PER @D109101, PLU @D109100, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : PULL, 
   [COORD @D109109, PAST @D109108, 
      AGR [CASE @D109107, COUNT @D109106, PER @D109105, PLU @D109104, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ABOUT, ARITY 1] : PULL.

WORD pulled : 
   [COORD @D109118, AGR [CASE @D109117, COUNT @D109116, PER @D109115, 
            PLU @D109114, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109123, AGR [CASE @D109122, COUNT @D109121, PER @D109120, 
            PLU @D109119, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109128, AGR [CASE @D109127, COUNT @D109126, PER @D109125, 
            PLU @D109124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109133, AGR [CASE @D109132, COUNT @D109131, PER @D109130, 
            PLU @D109129, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109138, AGR [CASE @D109137, COUNT @D109136, PER @D109135, 
            PLU @D109134, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109143, AGR [CASE @D109142, COUNT @D109141, PER @D109140, 
            PLU @D109139, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109148, AGR [CASE @D109147, COUNT @D109146, PER @D109145, 
            PLU @D109144, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109153, AGR [CASE @D109152, COUNT @D109151, PER @D109150, 
            PLU @D109149, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109158, AGR [CASE @D109157, COUNT @D109156, PER @D109155, 
            PLU @D109154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109163, AGR [CASE @D109162, COUNT @D109161, PER @D109160, 
            PLU @D109159, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109168, AGR [CASE @D109167, COUNT @D109166, PER @D109165, 
            PLU @D109164, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109173, AGR [CASE @D109172, COUNT @D109171, PER @D109170, 
            PLU @D109169, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109178, AGR [CASE @D109177, COUNT @D109176, PER @D109175, 
            PLU @D109174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109183, AGR [CASE @D109182, COUNT @D109181, PER @D109180, 
            PLU @D109179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109188, AGR [CASE @D109187, COUNT @D109186, PER @D109185, 
            PLU @D109184, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109193, AGR [CASE @D109192, COUNT @D109191, PER @D109190, 
            PLU @D109189, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109198, AGR [CASE @D109197, COUNT @D109196, PER @D109195, 
            PLU @D109194, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109203, AGR [CASE @D109202, COUNT @D109201, PER @D109200, 
            PLU @D109199, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109208, AGR [CASE @D109207, COUNT @D109206, PER @D109205, 
            PLU @D109204, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109213, AGR [CASE @D109212, COUNT @D109211, PER @D109210, 
            PLU @D109209, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109218, AGR [CASE @D109217, COUNT @D109216, PER @D109215, 
            PLU @D109214, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109223, AGR [CASE @D109222, COUNT @D109221, PER @D109220, 
            PLU @D109219, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AHEAD, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109228, 
      AGR [CASE @D109227, COUNT @D109226, PER @D109225, PLU @D109224, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AHEAD, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109233, AGR [CASE @D109232, COUNT @D109231, PER @D109230, 
            PLU @D109229, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT AWAY, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109238, AGR [CASE @D109237, COUNT @D109236, PER @D109235, 
            PLU @D109234, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109243, 
      AGR [CASE @D109242, COUNT @D109241, PER @D109240, PLU @D109239, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109248, AGR [CASE @D109247, COUNT @D109246, PER @D109245, 
            PLU @D109244, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109253, AGR [CASE @D109252, COUNT @D109251, PER @D109250, 
            PLU @D109249, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109258, AGR [CASE @D109257, COUNT @D109256, PER @D109255, 
            PLU @D109254, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109263, AGR [CASE @D109262, COUNT @D109261, PER @D109260, 
            PLU @D109259, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109268, AGR [CASE @D109267, COUNT @D109266, PER @D109265, 
            PLU @D109264, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109273, AGR [CASE @D109272, COUNT @D109271, PER @D109270, 
            PLU @D109269, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109278, AGR [CASE @D109277, COUNT @D109276, PER @D109275, 
            PLU @D109274, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109283, AGR [CASE @D109282, COUNT @D109281, PER @D109280, 
            PLU @D109279, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109288, AGR [CASE @D109287, COUNT @D109286, PER @D109285, 
            PLU @D109284, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109293, AGR [CASE @D109292, COUNT @D109291, PER @D109290, 
            PLU @D109289, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109298, AGR [CASE @D109297, COUNT @D109296, PER @D109295, 
            PLU @D109294, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109303, AGR [CASE @D109302, COUNT @D109301, PER @D109300, 
            PLU @D109299, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109308, AGR [CASE @D109307, COUNT @D109306, PER @D109305, 
            PLU @D109304, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109313, AGR [CASE @D109312, COUNT @D109311, PER @D109310, 
            PLU @D109309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109318, AGR [CASE @D109317, COUNT @D109316, PER @D109315, 
            PLU @D109314, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109323, AGR [CASE @D109322, COUNT @D109321, PER @D109320, 
            PLU @D109319, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109328, AGR [CASE @D109327, COUNT @D109326, PER @D109325, 
            PLU @D109324, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109333, AGR [CASE @D109332, COUNT @D109331, PER @D109330, 
            PLU @D109329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109338, AGR [CASE @D109337, COUNT @D109336, PER @D109335, 
            PLU @D109334, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109343, AGR [CASE @D109342, COUNT @D109341, PER @D109340, 
            PLU @D109339, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109348, AGR [CASE @D109347, COUNT @D109346, PER @D109345, 
            PLU @D109344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109353, AGR [CASE @D109352, COUNT @D109351, PER @D109350, 
            PLU @D109349, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109358, AGR [CASE @D109357, COUNT @D109356, PER @D109355, 
            PLU @D109354, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109363, AGR [CASE @D109362, COUNT @D109361, PER @D109360, 
            PLU @D109359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109368, AGR [CASE @D109367, COUNT @D109366, PER @D109365, 
            PLU @D109364, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109373, AGR [CASE @D109372, COUNT @D109371, PER @D109370, 
            PLU @D109369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109378, AGR [CASE @D109377, COUNT @D109376, PER @D109375, 
            PLU @D109374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109383, AGR [CASE @D109382, COUNT @D109381, PER @D109380, 
            PLU @D109379, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109388, AGR [CASE @D109387, COUNT @D109386, PER @D109385, 
            PLU @D109384, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109393, AGR [CASE @D109392, COUNT @D109391, PER @D109390, 
            PLU @D109389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109398, AGR [CASE @D109397, COUNT @D109396, PER @D109395, 
            PLU @D109394, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109403, AGR [CASE @D109402, COUNT @D109401, PER @D109400, 
            PLU @D109399, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109408, AGR [CASE @D109407, COUNT @D109406, PER @D109405, 
            PLU @D109404, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109413, AGR [CASE @D109412, COUNT @D109411, PER @D109410, 
            PLU @D109409, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109418, AGR [CASE @D109417, COUNT @D109416, PER @D109415, 
            PLU @D109414, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109423, AGR [CASE @D109422, COUNT @D109421, PER @D109420, 
            PLU @D109419, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109428, AGR [CASE @D109427, COUNT @D109426, PER @D109425, 
            PLU @D109424, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109433, AGR [CASE @D109432, COUNT @D109431, PER @D109430, 
            PLU @D109429, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109438, AGR [CASE @D109437, COUNT @D109436, PER @D109435, 
            PLU @D109434, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109443, AGR [CASE @D109442, COUNT @D109441, PER @D109440, 
            PLU @D109439, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109448, AGR [CASE @D109447, COUNT @D109446, PER @D109445, 
            PLU @D109444, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109453, AGR [CASE @D109452, COUNT @D109451, PER @D109450, 
            PLU @D109449, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109458, AGR [CASE @D109457, COUNT @D109456, PER @D109455, 
            PLU @D109454, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109463, AGR [CASE @D109462, COUNT @D109461, PER @D109460, 
            PLU @D109459, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109468, AGR [CASE @D109467, COUNT @D109466, PER @D109465, 
            PLU @D109464, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109473, AGR [CASE @D109472, COUNT @D109471, PER @D109470, 
            PLU @D109469, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109478, AGR [CASE @D109477, COUNT @D109476, PER @D109475, 
            PLU @D109474, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109483, AGR [CASE @D109482, COUNT @D109481, PER @D109480, 
            PLU @D109479, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109488, AGR [CASE @D109487, COUNT @D109486, PER @D109485, 
            PLU @D109484, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109493, AGR [CASE @D109492, COUNT @D109491, PER @D109490, 
            PLU @D109489, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109498, AGR [CASE @D109497, COUNT @D109496, PER @D109495, 
            PLU @D109494, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109503, AGR [CASE @D109502, COUNT @D109501, PER @D109500, 
            PLU @D109499, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109508, AGR [CASE @D109507, COUNT @D109506, PER @D109505, 
            PLU @D109504, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109513, AGR [CASE @D109512, COUNT @D109511, PER @D109510, 
            PLU @D109509, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109518, AGR [CASE @D109517, COUNT @D109516, PER @D109515, 
            PLU @D109514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109523, AGR [CASE @D109522, COUNT @D109521, PER @D109520, 
            PLU @D109519, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109528, AGR [CASE @D109527, COUNT @D109526, PER @D109525, 
            PLU @D109524, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109533, AGR [CASE @D109532, COUNT @D109531, PER @D109530, 
            PLU @D109529, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109538, AGR [CASE @D109537, COUNT @D109536, PER @D109535, 
            PLU @D109534, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109543, AGR [CASE @D109542, COUNT @D109541, PER @D109540, 
            PLU @D109539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109548, AGR [CASE @D109547, COUNT @D109546, PER @D109545, 
            PLU @D109544, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109553, AGR [CASE @D109552, COUNT @D109551, PER @D109550, 
            PLU @D109549, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109558, AGR [CASE @D109557, COUNT @D109556, PER @D109555, 
            PLU @D109554, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109563, AGR [CASE @D109562, COUNT @D109561, PER @D109560, 
            PLU @D109559, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109568, AGR [CASE @D109567, COUNT @D109566, PER @D109565, 
            PLU @D109564, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109573, AGR [CASE @D109572, COUNT @D109571, PER @D109570, 
            PLU @D109569, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109578, AGR [CASE @D109577, COUNT @D109576, PER @D109575, 
            PLU @D109574, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL, 
   [COORD @D109583, AGR [CASE @D109582, COUNT @D109581, PER @D109580, 
            PLU @D109579, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109588, AGR [CASE @D109587, COUNT @D109586, PER @D109585, 
            PLU @D109584, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PULL.

WORD pulling : 
   [COORD @D109601, PRD @D109600, AGR [CASE @D109599, COUNT @D109598, 
            PER @D109597, PLU @D109596, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109607, PRD @D109606, 
      AGR [CASE @D109605, COUNT @D109604, PER @D109603, PLU @D109602, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109613, PRD @D109612, AGR [CASE @D109611, COUNT @D109610, 
            PER @D109609, PLU @D109608, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109619, PRD @D109618, 
      AGR [CASE @D109617, COUNT @D109616, PER @D109615, PLU @D109614, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PULL, 
   [COORD @D109625, PRD @D109624, AGR [CASE @D109623, COUNT @D109622, 
            PER @D109621, PLU @D109620, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109631, PRD @D109630, 
      AGR [CASE @D109629, COUNT @D109628, PER @D109627, PLU @D109626, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109637, PRD @D109636, AGR [CASE @D109635, COUNT @D109634, 
            PER @D109633, PLU @D109632, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109643, PRD @D109642, 
      AGR [CASE @D109641, COUNT @D109640, PER @D109639, PLU @D109638, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109649, PRD @D109648, AGR [CASE @D109647, COUNT @D109646, 
            PER @D109645, PLU @D109644, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AHEAD, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109655, PRD @D109654, 
      AGR [CASE @D109653, COUNT @D109652, PER @D109651, PLU @D109650, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109661, PRD @D109660, AGR [CASE @D109659, COUNT @D109658, 
            PER @D109657, PLU @D109656, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109667, PRD @D109666, 
      AGR [CASE @D109665, COUNT @D109664, PER @D109663, PLU @D109662, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PULL, 
   [COORD @D109673, PRD @D109672, AGR [CASE @D109671, COUNT @D109670, 
            PER @D109669, PLU @D109668, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109679, PRD @D109678, 
      AGR [CASE @D109677, COUNT @D109676, PER @D109675, PLU @D109674, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109685, PRD @D109684, AGR [CASE @D109683, COUNT @D109682, 
            PER @D109681, PLU @D109680, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109691, PRD @D109690, 
      AGR [CASE @D109689, COUNT @D109688, PER @D109687, PLU @D109686, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PULL, 
   [COORD @D109697, PRD @D109696, AGR [CASE @D109695, COUNT @D109694, 
            PER @D109693, PLU @D109692, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109703, PRD @D109702, 
      AGR [CASE @D109701, COUNT @D109700, PER @D109699, PLU @D109698, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PULL, 
   [COORD @D109709, PRD @D109708, AGR [CASE @D109707, COUNT @D109706, 
            PER @D109705, PLU @D109704, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109715, PRD @D109714, 
      AGR [CASE @D109713, COUNT @D109712, PER @D109711, PLU @D109710, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PULL, 
   [COORD @D109721, PRD @D109720, AGR [CASE @D109719, COUNT @D109718, 
            PER @D109717, PLU @D109716, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109727, PRD @D109726, 
      AGR [CASE @D109725, COUNT @D109724, PER @D109723, PLU @D109722, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PULL, 
   [COORD @D109733, PRD @D109732, AGR [CASE @D109731, COUNT @D109730, 
            PER @D109729, PLU @D109728, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109739, PRD @D109738, 
      AGR [CASE @D109737, COUNT @D109736, PER @D109735, PLU @D109734, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109745, PRD @D109744, AGR [CASE @D109743, COUNT @D109742, 
            PER @D109741, PLU @D109740, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109751, PRD @D109750, 
      AGR [CASE @D109749, COUNT @D109748, PER @D109747, PLU @D109746, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109757, PRD @D109756, AGR [CASE @D109755, COUNT @D109754, 
            PER @D109753, PLU @D109752, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109763, PRD @D109762, 
      AGR [CASE @D109761, COUNT @D109760, PER @D109759, PLU @D109758, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109769, PRD @D109768, AGR [CASE @D109767, COUNT @D109766, 
            PER @D109765, PLU @D109764, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109775, PRD @D109774, 
      AGR [CASE @D109773, COUNT @D109772, PER @D109771, PLU @D109770, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109781, PRD @D109780, AGR [CASE @D109779, COUNT @D109778, 
            PER @D109777, PLU @D109776, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109787, PRD @D109786, 
      AGR [CASE @D109785, COUNT @D109784, PER @D109783, PLU @D109782, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109793, PRD @D109792, AGR [CASE @D109791, COUNT @D109790, 
            PER @D109789, PLU @D109788, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109799, PRD @D109798, 
      AGR [CASE @D109797, COUNT @D109796, PER @D109795, PLU @D109794, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109805, PRD @D109804, AGR [CASE @D109803, COUNT @D109802, 
            PER @D109801, PLU @D109800, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109811, PRD @D109810, 
      AGR [CASE @D109809, COUNT @D109808, PER @D109807, PLU @D109806, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109817, PRD @D109816, AGR [CASE @D109815, COUNT @D109814, 
            PER @D109813, PLU @D109812, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PULL, 
   [COORD @D109823, PRD @D109822, 
      AGR [CASE @D109821, COUNT @D109820, PER @D109819, PLU @D109818, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PULL.

WORD pulls : 
   [COORD @D109833, AGR [COUNT @D109832, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PULL, 
   [COORD @D109835, 
      AGR [COUNT @D109834, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PULL, 
   [COORD @D109837, 
      AGR [COUNT @D109836, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PULL, 
   [COORD @D109839, 
      AGR [COUNT @D109838, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PULL, 
   [COORD @D109841, 
      AGR [COUNT @D109840, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PULL, 
   [COORD @D109843, AGR [COUNT @D109842, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109845, AGR [COUNT @D109844, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109847, AGR [COUNT @D109846, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109849, AGR [COUNT @D109848, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AHEAD, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109851, AGR [COUNT @D109850, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PULL, 
   [COORD @D109853, AGR [COUNT @D109852, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109855, AGR [COUNT @D109854, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109857, AGR [COUNT @D109856, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109859, AGR [COUNT @D109858, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109861, AGR [COUNT @D109860, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109863, AGR [COUNT @D109862, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109865, AGR [COUNT @D109864, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109867, AGR [COUNT @D109866, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109869, AGR [COUNT @D109868, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109871, AGR [COUNT @D109870, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109873, AGR [COUNT @D109872, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109875, AGR [COUNT @D109874, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109877, AGR [COUNT @D109876, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109879, AGR [COUNT @D109878, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PULL, 
   [COORD @D109881, 
      AGR [COUNT @D109880, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PULL, 
   [COORD @D109883, 
      AGR [COUNT @D109882, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PULL, 
   [COORD @D109885, AGR [COUNT @D109884, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109887, AGR [COUNT @D109886, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109889, AGR [COUNT @D109888, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109891, AGR [COUNT @D109890, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109893, AGR [COUNT @D109892, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PULL, 
   [COORD @D109895, AGR [COUNT @D109894, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109897, AGR [COUNT @D109896, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PULL, 
   [COORD @D109899, AGR [COUNT @D109898, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109901, AGR [COUNT @D109900, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109903, AGR [COUNT @D109902, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109905, AGR [COUNT @D109904, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL, 
   [COORD @D109907, AGR [COUNT @D109906, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PULL.

WORD punch : 
   [COORD @D109913, REFL @D109912, PRD @D109911, CASE @D109910, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, COUNT +] : PUNCH, 
   [COORD @D109918, REFL @D109917, COUNT @D109916, PRD @D109915, 
      CASE @D109914, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PUNCH, 
   [COORD @D109922, REFL @D109921, PRD @D109920, CASE @D109919, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : PUNCH, 
   [COORD @D109925, 
      AGR [COUNT @D109924, PER @D109923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM IN, 
      ARITY 3] : PUNCH, 
   [COORD @D109927, AGR [COUNT @D109926, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PUNCH, 
   [COORD @D109929, AGR [COUNT @D109928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PUNCH, 
   [COORD @D109933, AGR [COUNT @D109932, PER @D109931, PLU @D109930, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : PUNCH, 
   [COORD @D109939, PAST @D109938, 
      AGR [CASE @D109937, COUNT @D109936, PER @D109935, PLU @D109934, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM IN, ARITY 3] : PUNCH, 
   [COORD @D109942, AGR [COUNT @D109941, PER @D109940, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUNCH, 
   [COORD @D109944, AGR [COUNT @D109943, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUNCH, 
   [COORD @D109946, AGR [COUNT @D109945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUNCH, 
   [COORD @D109950, AGR [COUNT @D109949, PER @D109948, PLU @D109947, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PUNCH, 
   [COORD @D109956, PAST @D109955, AGR [CASE @D109954, COUNT @D109953, 
            PER @D109952, PLU @D109951, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PUNCH, 
   [COORD @D109959, AGR [COUNT @D109958, PER @D109957, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PUNCH, 
   [COORD @D109961, AGR [COUNT @D109960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PUNCH, 
   [COORD @D109963, AGR [COUNT @D109962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PUNCH, 
   [COORD @D109967, AGR [COUNT @D109966, PER @D109965, PLU @D109964, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : PUNCH, 
   [COORD @D109973, PAST @D109972, 
      AGR [CASE @D109971, COUNT @D109970, PER @D109969, PLU @D109968, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : PUNCH, 
   [COORD @D109976, AGR [COUNT @D109975, PER @D109974, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PUNCH, 
   [COORD @D109978, AGR [COUNT @D109977, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PUNCH, 
   [COORD @D109980, AGR [COUNT @D109979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : PUNCH, 
   [COORD @D109984, AGR [COUNT @D109983, PER @D109982, PLU @D109981, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : PUNCH, 
   [COORD @D109990, PAST @D109989, 
      AGR [CASE @D109988, COUNT @D109987, PER @D109986, PLU @D109985, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : PUNCH, 
   [COORD @D109993, AGR [COUNT @D109992, PER @D109991, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUNCH, 
   [COORD @D109995, AGR [COUNT @D109994, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUNCH, 
   [COORD @D109997, AGR [COUNT @D109996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUNCH, 
   [COORD @D110001, AGR [COUNT @D110000, PER @D109999, PLU @D109998, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUNCH, 
   [COORD @D110007, PAST @D110006, 
      AGR [CASE @D110005, COUNT @D110004, PER @D110003, PLU @D110002, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : PUNCH, 
   [COORD @D110010, AGR [COUNT @D110009, PER @D110008, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUNCH, 
   [COORD @D110012, AGR [COUNT @D110011, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUNCH, 
   [COORD @D110014, AGR [COUNT @D110013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUNCH, 
   [COORD @D110018, AGR [COUNT @D110017, PER @D110016, PLU @D110015, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUNCH, 
   [COORD @D110024, PAST @D110023, 
      AGR [CASE @D110022, COUNT @D110021, PER @D110020, PLU @D110019, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : PUNCH.

WORD punched : 
   [COORD @D110033, AGR [CASE @D110032, COUNT @D110031, PER @D110030, 
            PLU @D110029, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110038, AGR [CASE @D110037, COUNT @D110036, PER @D110035, 
            PLU @D110034, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110043, AGR [CASE @D110042, COUNT @D110041, PER @D110040, 
            PLU @D110039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110048, AGR [CASE @D110047, COUNT @D110046, PER @D110045, 
            PLU @D110044, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUNCH, 
   [COORD @D110053, AGR [CASE @D110052, COUNT @D110051, PER @D110050, 
            PLU @D110049, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110058, AGR [CASE @D110057, COUNT @D110056, PER @D110055, 
            PLU @D110054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110063, AGR [CASE @D110062, COUNT @D110061, PER @D110060, 
            PLU @D110059, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110068, AGR [CASE @D110067, COUNT @D110066, PER @D110065, 
            PLU @D110064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110073, AGR [CASE @D110072, COUNT @D110071, PER @D110070, 
            PLU @D110069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110078, AGR [CASE @D110077, COUNT @D110076, PER @D110075, 
            PLU @D110074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110083, AGR [CASE @D110082, COUNT @D110081, PER @D110080, 
            PLU @D110079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110088, AGR [CASE @D110087, COUNT @D110086, PER @D110085, 
            PLU @D110084, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110093, AGR [CASE @D110092, COUNT @D110091, PER @D110090, 
            PLU @D110089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110098, AGR [CASE @D110097, COUNT @D110096, PER @D110095, 
            PLU @D110094, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110103, AGR [CASE @D110102, COUNT @D110101, PER @D110100, 
            PLU @D110099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110108, AGR [CASE @D110107, COUNT @D110106, PER @D110105, 
            PLU @D110104, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUNCH.

WORD punches : 
   [COORD @D110117, DEMON @D110116, REFL @D110115, PRD @D110114, 
      CASE @D110113, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM IN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PUNCH, 
   [COORD @D110122, DEMON @D110121, REFL @D110120, PRD @D110119, 
      CASE @D110118, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PUNCH, 
   [COORD @D110127, DEMON @D110126, REFL @D110125, PRD @D110124, 
      CASE @D110123, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PUNCH, 
   [COORD @D110129, AGR [COUNT @D110128, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUNCH, 
   [COORD @D110131, AGR [COUNT @D110130, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110133, 
      AGR [COUNT @D110132, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110135, 
      AGR [COUNT @D110134, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110137, 
      AGR [COUNT @D110136, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110139, 
      AGR [COUNT @D110138, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUNCH.

WORD punching : 
   [COORD @D110153, PRD @D110152, AGR [CASE @D110151, COUNT @D110150, 
            PER @D110149, PLU @D110148, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110159, PRD @D110158, 
      AGR [CASE @D110157, COUNT @D110156, PER @D110155, PLU @D110154, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUNCH, 
   [COORD @D110165, PRD @D110164, AGR [CASE @D110163, COUNT @D110162, 
            PER @D110161, PLU @D110160, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110171, PRD @D110170, 
      AGR [CASE @D110169, COUNT @D110168, PER @D110167, PLU @D110166, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUNCH, 
   [COORD @D110177, PRD @D110176, AGR [CASE @D110175, COUNT @D110174, 
            PER @D110173, PLU @D110172, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUNCH, 
   [COORD @D110183, PRD @D110182, 
      AGR [CASE @D110181, COUNT @D110180, PER @D110179, PLU @D110178, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUNCH.

WORD push : 
   [COORD @D110192, AGR [COUNT @D110191, PER @D110190, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PUSH, 
   [COORD @D110194, AGR [COUNT @D110193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PUSH, 
   [COORD @D110196, AGR [COUNT @D110195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PUSH, 
   [COORD @D110200, AGR [COUNT @D110199, PER @D110198, PLU @D110197, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : PUSH, 
   [COORD @D110206, PAST @D110205, AGR [CASE @D110204, COUNT @D110203, 
            PER @D110202, PLU @D110201, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : PUSH, 
   [COORD @D110209, AGR [COUNT @D110208, PER @D110207, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PUSH, 
   [COORD @D110211, AGR [COUNT @D110210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PUSH, 
   [COORD @D110213, AGR [COUNT @D110212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PUSH, 
   [COORD @D110217, AGR [COUNT @D110216, PER @D110215, PLU @D110214, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : PUSH, 
   [COORD @D110223, PAST @D110222, AGR [CASE @D110221, COUNT @D110220, 
            PER @D110219, PLU @D110218, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : PUSH, 
   [COORD @D110226, AGR [COUNT @D110225, PER @D110224, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PUSH, 
   [COORD @D110228, AGR [COUNT @D110227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PUSH, 
   [COORD @D110230, AGR [COUNT @D110229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PUSH, 
   [COORD @D110234, AGR [COUNT @D110233, PER @D110232, PLU @D110231, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : PUSH, 
   [COORD @D110240, PAST @D110239, AGR [CASE @D110238, COUNT @D110237, 
            PER @D110236, PLU @D110235, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : PUSH, 
   [COORD @D110243, AGR [COUNT @D110242, PER @D110241, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT ON, ARITY 3] : PUSH, 
   [COORD @D110245, AGR [COUNT @D110244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT ON, ARITY 3] : PUSH, 
   [COORD @D110247, AGR [COUNT @D110246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT ON, ARITY 3] : PUSH, 
   [COORD @D110251, AGR [COUNT @D110250, PER @D110249, PLU @D110248, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT ON, ARITY 3] : PUSH, 
   [COORD @D110257, PAST @D110256, 
      AGR [CASE @D110255, COUNT @D110254, PER @D110253, PLU @D110252, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      PRT ON, ARITY 3] : PUSH, 
   [COORD @D110260, AGR [COUNT @D110259, PER @D110258, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : PUSH, 
   [COORD @D110262, AGR [COUNT @D110261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : PUSH, 
   [COORD @D110264, AGR [COUNT @D110263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : PUSH, 
   [COORD @D110268, AGR [COUNT @D110267, PER @D110266, PLU @D110265, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : PUSH, 
   [COORD @D110274, PAST @D110273, 
      AGR [CASE @D110272, COUNT @D110271, PER @D110270, PLU @D110269, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ONTO, ARITY 3] : PUSH, 
   [COORD @D110277, AGR [COUNT @D110276, PER @D110275, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PUSH, 
   [COORD @D110279, AGR [COUNT @D110278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PUSH, 
   [COORD @D110281, AGR [COUNT @D110280, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PUSH, 
   [COORD @D110285, AGR [COUNT @D110284, PER @D110283, PLU @D110282, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : PUSH, 
   [COORD @D110291, PAST @D110290, 
      AGR [CASE @D110289, COUNT @D110288, PER @D110287, PLU @D110286, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : PUSH, 
   [COORD @D110294, AGR [COUNT @D110293, PER @D110292, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PUSH, 
   [COORD @D110296, AGR [COUNT @D110295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PUSH, 
   [COORD @D110298, AGR [COUNT @D110297, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PUSH, 
   [COORD @D110302, AGR [COUNT @D110301, PER @D110300, PLU @D110299, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : PUSH, 
   [COORD @D110308, PAST @D110307, 
      AGR [CASE @D110306, COUNT @D110305, PER @D110304, PLU @D110303, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : PUSH, 
   [COORD @D110311, AGR [COUNT @D110310, PER @D110309, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PUSH, 
   [COORD @D110313, AGR [COUNT @D110312, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PUSH, 
   [COORD @D110315, AGR [COUNT @D110314, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PUSH, 
   [COORD @D110319, AGR [COUNT @D110318, PER @D110317, PLU @D110316, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : PUSH, 
   [COORD @D110325, PAST @D110324, 
      AGR [CASE @D110323, COUNT @D110322, PER @D110321, PLU @D110320, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : PUSH, 
   [COORD @D110328, AGR [COUNT @D110327, PER @D110326, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUSH, 
   [COORD @D110330, AGR [COUNT @D110329, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUSH, 
   [COORD @D110332, AGR [COUNT @D110331, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUSH, 
   [COORD @D110336, AGR [COUNT @D110335, PER @D110334, PLU @D110333, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PUSH, 
   [COORD @D110342, PAST @D110341, AGR [CASE @D110340, COUNT @D110339, 
            PER @D110338, PLU @D110337, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PUSH, 
   [COORD @D110345, AGR [COUNT @D110344, PER @D110343, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT THROUGH, ARITY 2] : PUSH, 
   [COORD @D110347, AGR [COUNT @D110346, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT THROUGH, ARITY 2] : PUSH, 
   [COORD @D110349, AGR [COUNT @D110348, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT THROUGH, ARITY 2] : PUSH, 
   [COORD @D110353, AGR [COUNT @D110352, PER @D110351, PLU @D110350, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT THROUGH, ARITY 2] : PUSH, 
   [COORD @D110359, PAST @D110358, 
      AGR [CASE @D110357, COUNT @D110356, PER @D110355, PLU @D110354, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT THROUGH, ARITY 2] : PUSH, 
   [COORD @D110362, AGR [COUNT @D110361, PER @D110360, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT FORWARD, ARITY 2] : PUSH, 
   [COORD @D110364, AGR [COUNT @D110363, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT FORWARD, ARITY 2] : PUSH, 
   [COORD @D110366, AGR [COUNT @D110365, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT FORWARD, ARITY 2] : PUSH, 
   [COORD @D110370, AGR [COUNT @D110369, PER @D110368, PLU @D110367, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT FORWARD, ARITY 2] : PUSH, 
   [COORD @D110376, PAST @D110375, 
      AGR [CASE @D110374, COUNT @D110373, PER @D110372, PLU @D110371, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT FORWARD, ARITY 2] : PUSH, 
   [COORD @D110379, AGR [COUNT @D110378, PER @D110377, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : PUSH, 
   [COORD @D110381, AGR [COUNT @D110380, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : PUSH, 
   [COORD @D110383, AGR [COUNT @D110382, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : PUSH, 
   [COORD @D110387, AGR [COUNT @D110386, PER @D110385, PLU @D110384, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT AROUND, ARITY 2] : PUSH, 
   [COORD @D110393, PAST @D110392, 
      AGR [CASE @D110391, COUNT @D110390, PER @D110389, PLU @D110388, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT AROUND, ARITY 2] : PUSH, 
   [COORD @D110396, AGR [COUNT @D110395, PER @D110394, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110398, AGR [COUNT @D110397, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110400, AGR [COUNT @D110399, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110404, AGR [COUNT @D110403, PER @D110402, PLU @D110401, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ON, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110410, PAST @D110409, 
      AGR [CASE @D110408, COUNT @D110407, PER @D110406, PLU @D110405, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ON, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110413, AGR [COUNT @D110412, PER @D110411, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT FORWARD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110415, AGR [COUNT @D110414, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT FORWARD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110417, AGR [COUNT @D110416, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT FORWARD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110421, AGR [COUNT @D110420, PER @D110419, PLU @D110418, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT FORWARD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110427, PAST @D110426, 
      AGR [CASE @D110425, COUNT @D110424, PER @D110423, PLU @D110422, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT FORWARD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110430, AGR [COUNT @D110429, PER @D110428, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110432, AGR [COUNT @D110431, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110434, AGR [COUNT @D110433, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110438, AGR [COUNT @D110437, PER @D110436, PLU @D110435, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT ALONG, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110444, PAST @D110443, 
      AGR [CASE @D110442, COUNT @D110441, PER @D110440, PLU @D110439, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT ALONG, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110447, AGR [COUNT @D110446, PER @D110445, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110449, AGR [COUNT @D110448, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110451, AGR [COUNT @D110450, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110455, AGR [COUNT @D110454, PER @D110453, PLU @D110452, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT AHEAD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110461, PAST @D110460, 
      AGR [CASE @D110459, COUNT @D110458, PER @D110457, PLU @D110456, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AHEAD, PFORM TO, ARITY 2] : PUSH, 
   [COORD @D110464, AGR [COUNT @D110463, PER @D110462, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PUSH, 
   [COORD @D110466, AGR [COUNT @D110465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PUSH, 
   [COORD @D110468, AGR [COUNT @D110467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PUSH, 
   [COORD @D110472, AGR [COUNT @D110471, PER @D110470, PLU @D110469, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : PUSH, 
   [COORD @D110478, PAST @D110477, 
      AGR [CASE @D110476, COUNT @D110475, PER @D110474, PLU @D110473, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : PUSH, 
   [COORD @D110481, AGR [COUNT @D110480, PER @D110479, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PUSH, 
   [COORD @D110483, AGR [COUNT @D110482, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PUSH, 
   [COORD @D110485, AGR [COUNT @D110484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : PUSH, 
   [COORD @D110489, AGR [COUNT @D110488, PER @D110487, PLU @D110486, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : PUSH, 
   [COORD @D110495, PAST @D110494, 
      AGR [CASE @D110493, COUNT @D110492, PER @D110491, PLU @D110490, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : PUSH, 
   [COORD @D110498, AGR [COUNT @D110497, PER @D110496, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PUSH, 
   [COORD @D110500, AGR [COUNT @D110499, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PUSH, 
   [COORD @D110502, AGR [COUNT @D110501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : PUSH, 
   [COORD @D110506, AGR [COUNT @D110505, PER @D110504, PLU @D110503, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : PUSH, 
   [COORD @D110512, PAST @D110511, 
      AGR [CASE @D110510, COUNT @D110509, PER @D110508, PLU @D110507, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : PUSH, 
   [COORD @D110515, AGR [COUNT @D110514, PER @D110513, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PUSH, 
   [COORD @D110517, AGR [COUNT @D110516, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PUSH, 
   [COORD @D110519, AGR [COUNT @D110518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : PUSH, 
   [COORD @D110523, AGR [COUNT @D110522, PER @D110521, PLU @D110520, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : PUSH, 
   [COORD @D110529, PAST @D110528, 
      AGR [CASE @D110527, COUNT @D110526, PER @D110525, PLU @D110524, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : PUSH, 
   [COORD @D110532, AGR [COUNT @D110531, PER @D110530, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PUSH, 
   [COORD @D110534, AGR [COUNT @D110533, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PUSH, 
   [COORD @D110536, AGR [COUNT @D110535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PUSH, 
   [COORD @D110540, AGR [COUNT @D110539, PER @D110538, PLU @D110537, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, ARITY 2] : PUSH, 
   [COORD @D110546, PAST @D110545, 
      AGR [CASE @D110544, COUNT @D110543, PER @D110542, PLU @D110541, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : PUSH, 
   [COORD @D110549, AGR [COUNT @D110548, PER @D110547, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUSH, 
   [COORD @D110551, AGR [COUNT @D110550, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUSH, 
   [COORD @D110553, AGR [COUNT @D110552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUSH, 
   [COORD @D110557, AGR [COUNT @D110556, PER @D110555, PLU @D110554, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUSH, 
   [COORD @D110563, PAST @D110562, AGR [CASE @D110561, COUNT @D110560, 
            PER @D110559, PLU @D110558, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PUSH, 
   [COORD @D110566, AGR [COUNT @D110565, PER @D110564, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PUSH, 
   [COORD @D110568, AGR [COUNT @D110567, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PUSH, 
   [COORD @D110570, AGR [COUNT @D110569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PUSH, 
   [COORD @D110574, AGR [COUNT @D110573, PER @D110572, PLU @D110571, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : PUSH, 
   [COORD @D110580, PAST @D110579, 
      AGR [CASE @D110578, COUNT @D110577, PER @D110576, PLU @D110575, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : PUSH, 
   [COORD @D110583, AGR [COUNT @D110582, PER @D110581, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PUSH, 
   [COORD @D110585, AGR [COUNT @D110584, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PUSH, 
   [COORD @D110587, AGR [COUNT @D110586, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PUSH, 
   [COORD @D110591, AGR [COUNT @D110590, PER @D110589, PLU @D110588, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : PUSH, 
   [COORD @D110597, PAST @D110596, 
      AGR [CASE @D110595, COUNT @D110594, PER @D110593, PLU @D110592, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT THROUGH, ARITY 1] : PUSH, 
   [COORD @D110600, AGR [COUNT @D110599, PER @D110598, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUSH, 
   [COORD @D110602, AGR [COUNT @D110601, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUSH, 
   [COORD @D110604, AGR [COUNT @D110603, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUSH, 
   [COORD @D110608, AGR [COUNT @D110607, PER @D110606, PLU @D110605, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : PUSH, 
   [COORD @D110614, PAST @D110613, 
      AGR [CASE @D110612, COUNT @D110611, PER @D110610, PLU @D110609, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : PUSH, 
   [COORD @D110617, AGR [COUNT @D110616, PER @D110615, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PUSH, 
   [COORD @D110619, AGR [COUNT @D110618, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PUSH, 
   [COORD @D110621, AGR [COUNT @D110620, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PUSH, 
   [COORD @D110625, AGR [COUNT @D110624, PER @D110623, PLU @D110622, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : PUSH, 
   [COORD @D110631, PAST @D110630, 
      AGR [CASE @D110629, COUNT @D110628, PER @D110627, PLU @D110626, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : PUSH, 
   [COORD @D110634, AGR [COUNT @D110633, PER @D110632, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PUSH, 
   [COORD @D110636, AGR [COUNT @D110635, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PUSH, 
   [COORD @D110638, AGR [COUNT @D110637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PUSH, 
   [COORD @D110642, AGR [COUNT @D110641, PER @D110640, PLU @D110639, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : PUSH, 
   [COORD @D110648, PAST @D110647, 
      AGR [CASE @D110646, COUNT @D110645, PER @D110644, PLU @D110643, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : PUSH, 
   [COORD @D110651, AGR [COUNT @D110650, PER @D110649, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUSH, 
   [COORD @D110653, AGR [COUNT @D110652, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUSH, 
   [COORD @D110655, AGR [COUNT @D110654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUSH, 
   [COORD @D110659, AGR [COUNT @D110658, PER @D110657, PLU @D110656, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : PUSH, 
   [COORD @D110665, PAST @D110664, 
      AGR [CASE @D110663, COUNT @D110662, PER @D110661, PLU @D110660, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : PUSH, 
   [COORD @D110668, AGR [COUNT @D110667, PER @D110666, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : PUSH, 
   [COORD @D110670, AGR [COUNT @D110669, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : PUSH, 
   [COORD @D110672, AGR [COUNT @D110671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : PUSH, 
   [COORD @D110676, AGR [COUNT @D110675, PER @D110674, PLU @D110673, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT FORWARD, ARITY 1] : PUSH, 
   [COORD @D110682, PAST @D110681, 
      AGR [CASE @D110680, COUNT @D110679, PER @D110678, PLU @D110677, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT FORWARD, ARITY 1] : PUSH, 
   [COORD @D110685, AGR [COUNT @D110684, PER @D110683, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PUSH, 
   [COORD @D110687, AGR [COUNT @D110686, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PUSH, 
   [COORD @D110689, AGR [COUNT @D110688, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PUSH, 
   [COORD @D110693, AGR [COUNT @D110692, PER @D110691, PLU @D110690, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : PUSH, 
   [COORD @D110699, PAST @D110698, 
      AGR [CASE @D110697, COUNT @D110696, PER @D110695, PLU @D110694, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : PUSH, 
   [COORD @D110702, AGR [COUNT @D110701, PER @D110700, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PUSH, 
   [COORD @D110704, AGR [COUNT @D110703, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PUSH, 
   [COORD @D110706, AGR [COUNT @D110705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PUSH, 
   [COORD @D110710, AGR [COUNT @D110709, PER @D110708, PLU @D110707, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : PUSH, 
   [COORD @D110716, PAST @D110715, 
      AGR [CASE @D110714, COUNT @D110713, PER @D110712, PLU @D110711, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT BACK, ARITY 1] : PUSH, 
   [COORD @D110719, AGR [COUNT @D110718, PER @D110717, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PUSH, 
   [COORD @D110721, AGR [COUNT @D110720, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PUSH, 
   [COORD @D110723, AGR [COUNT @D110722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PUSH, 
   [COORD @D110727, AGR [COUNT @D110726, PER @D110725, PLU @D110724, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : PUSH, 
   [COORD @D110733, PAST @D110732, 
      AGR [CASE @D110731, COUNT @D110730, PER @D110729, PLU @D110728, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AROUND, ARITY 1] : PUSH, 
   [COORD @D110736, AGR [COUNT @D110735, PER @D110734, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PUSH, 
   [COORD @D110738, AGR [COUNT @D110737, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PUSH, 
   [COORD @D110740, AGR [COUNT @D110739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PUSH, 
   [COORD @D110744, AGR [COUNT @D110743, PER @D110742, PLU @D110741, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ALONG, ARITY 1] : PUSH, 
   [COORD @D110750, PAST @D110749, 
      AGR [CASE @D110748, COUNT @D110747, PER @D110746, PLU @D110745, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ALONG, ARITY 1] : PUSH, 
   [COORD @D110753, AGR [COUNT @D110752, PER @D110751, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PUSH, 
   [COORD @D110755, AGR [COUNT @D110754, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PUSH, 
   [COORD @D110757, AGR [COUNT @D110756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PUSH, 
   [COORD @D110761, AGR [COUNT @D110760, PER @D110759, PLU @D110758, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AHEAD, ARITY 1] : PUSH, 
   [COORD @D110767, PAST @D110766, 
      AGR [CASE @D110765, COUNT @D110764, PER @D110763, PLU @D110762, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AHEAD, ARITY 1] : PUSH.

WORD pushed : 
   [COADV @D110778, COORD @D110777, DEF @D110776, PRD @D110775, 
      AGR [CASE @D110774, COUNT @D110773, PER @D110772, PLU @D110771, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   PUSHED, 
   [COADV @D110786, COORD @D110785, DEF @D110784, PRD @D110783, 
      AGR [CASE @D110782, COUNT @D110781, PER @D110780, PLU @D110779, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR PRD] : 
   PUSHED, 
   [COADV @D110794, COORD @D110793, DEF @D110792, PRD @D110791, 
      AGR [CASE @D110790, COUNT @D110789, PER @D110788, PLU @D110787, 
            BAR 2, V -, N +, NFORM NORM], N +, V +, SUBCAT SINF, 
      SUBTYPE NONE, FIX NOT, INFL +, BAR 0, GRADE +, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PRD, ARITY 2] : PUSHED, 
   [COADV @D110802, COORD @D110801, DEF @D110800, PRD @D110799, 
      AGR [CASE @D110798, COUNT @D110797, PER @D110796, PLU @D110795, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT SC_INF, DISTR PRD, 
      ARITY 2] : PUSHED, 
   [COADV @D110810, COORD @D110809, DEF @D110808, PRD @D110807, 
      AGR [CASE @D110806, COUNT @D110805, PER @D110804, PLU @D110803, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, DISTR PRD, 
      ARITY 2] : PUSHED, 
   [COORD @D110816, AGR [CASE @D110815, NFORM @D110814, COUNT @D110813, 
            PER @D110812, PLU @D110811, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D110821, AGR [CASE @D110820, COUNT @D110819, PER @D110818, 
            PLU @D110817, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110826, AGR [CASE @D110825, COUNT @D110824, PER @D110823, 
            PLU @D110822, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110832, AGR [CASE @D110831, NFORM @D110830, COUNT @D110829, 
            PER @D110828, PLU @D110827, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D110837, AGR [CASE @D110836, COUNT @D110835, PER @D110834, 
            PLU @D110833, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110842, AGR [CASE @D110841, COUNT @D110840, PER @D110839, 
            PLU @D110838, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110847, AGR [CASE @D110846, COUNT @D110845, PER @D110844, 
            PLU @D110843, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D110852, AGR [CASE @D110851, COUNT @D110850, PER @D110849, 
            PLU @D110848, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110857, AGR [CASE @D110856, COUNT @D110855, PER @D110854, 
            PLU @D110853, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110862, AGR [CASE @D110861, COUNT @D110860, PER @D110859, 
            PLU @D110858, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110867, AGR [CASE @D110866, COUNT @D110865, PER @D110864, 
            PLU @D110863, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110873, AGR [CASE @D110872, NFORM @D110871, COUNT @D110870, 
            PER @D110869, PLU @D110868, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110878, AGR [CASE @D110877, COUNT @D110876, PER @D110875, 
            PLU @D110874, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110883, AGR [CASE @D110882, COUNT @D110881, PER @D110880, 
            PLU @D110879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110888, AGR [CASE @D110887, COUNT @D110886, PER @D110885, 
            PLU @D110884, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110893, AGR [CASE @D110892, COUNT @D110891, PER @D110890, 
            PLU @D110889, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110898, AGR [CASE @D110897, COUNT @D110896, PER @D110895, 
            PLU @D110894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110903, AGR [CASE @D110902, COUNT @D110901, PER @D110900, 
            PLU @D110899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110908, AGR [CASE @D110907, COUNT @D110906, PER @D110905, 
            PLU @D110904, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110913, AGR [CASE @D110912, COUNT @D110911, PER @D110910, 
            PLU @D110909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110918, AGR [CASE @D110917, COUNT @D110916, PER @D110915, 
            PLU @D110914, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110923, AGR [CASE @D110922, COUNT @D110921, PER @D110920, 
            PLU @D110919, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110928, AGR [CASE @D110927, COUNT @D110926, PER @D110925, 
            PLU @D110924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110933, AGR [CASE @D110932, COUNT @D110931, PER @D110930, 
            PLU @D110929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110938, AGR [CASE @D110937, COUNT @D110936, PER @D110935, 
            PLU @D110934, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D110943, AGR [CASE @D110942, COUNT @D110941, PER @D110940, 
            PLU @D110939, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110948, AGR [CASE @D110947, COUNT @D110946, PER @D110945, 
            PLU @D110944, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110953, AGR [CASE @D110952, COUNT @D110951, PER @D110950, 
            PLU @D110949, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110958, AGR [CASE @D110957, COUNT @D110956, PER @D110955, 
            PLU @D110954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110963, AGR [CASE @D110962, COUNT @D110961, PER @D110960, 
            PLU @D110959, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110968, AGR [CASE @D110967, COUNT @D110966, PER @D110965, 
            PLU @D110964, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORWARD, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110973, AGR [CASE @D110972, COUNT @D110971, PER @D110970, 
            PLU @D110969, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT FORWARD, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110978, AGR [CASE @D110977, COUNT @D110976, PER @D110975, 
            PLU @D110974, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT FORWARD, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110983, AGR [CASE @D110982, COUNT @D110981, PER @D110980, 
            PLU @D110979, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110988, AGR [CASE @D110987, COUNT @D110986, PER @D110985, 
            PLU @D110984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110993, AGR [CASE @D110992, COUNT @D110991, PER @D110990, 
            PLU @D110989, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D110998, AGR [CASE @D110997, COUNT @D110996, PER @D110995, 
            PLU @D110994, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111003, AGR [CASE @D111002, COUNT @D111001, PER @D111000, 
            PLU @D110999, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111008, AGR [CASE @D111007, COUNT @D111006, PER @D111005, 
            PLU @D111004, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT FORWARD, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111013, 
      AGR [CASE @D111012, COUNT @D111011, PER @D111010, PLU @D111009, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT FORWARD, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111018, AGR [CASE @D111017, COUNT @D111016, PER @D111015, 
            PLU @D111014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALONG, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111023, 
      AGR [CASE @D111022, COUNT @D111021, PER @D111020, PLU @D111019, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALONG, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111028, AGR [CASE @D111027, COUNT @D111026, PER @D111025, 
            PLU @D111024, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AHEAD, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111033, 
      AGR [CASE @D111032, COUNT @D111031, PER @D111030, PLU @D111029, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AHEAD, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111038, AGR [CASE @D111037, COUNT @D111036, PER @D111035, 
            PLU @D111034, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111043, AGR [CASE @D111042, COUNT @D111041, PER @D111040, 
            PLU @D111039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111048, AGR [CASE @D111047, COUNT @D111046, PER @D111045, 
            PLU @D111044, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111053, AGR [CASE @D111052, COUNT @D111051, PER @D111050, 
            PLU @D111049, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111058, AGR [CASE @D111057, COUNT @D111056, PER @D111055, 
            PLU @D111054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111063, AGR [CASE @D111062, COUNT @D111061, PER @D111060, 
            PLU @D111059, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111068, AGR [CASE @D111067, COUNT @D111066, PER @D111065, 
            PLU @D111064, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111073, AGR [CASE @D111072, COUNT @D111071, PER @D111070, 
            PLU @D111069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111078, AGR [CASE @D111077, COUNT @D111076, PER @D111075, 
            PLU @D111074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111083, AGR [CASE @D111082, COUNT @D111081, PER @D111080, 
            PLU @D111079, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111088, AGR [CASE @D111087, COUNT @D111086, PER @D111085, 
            PLU @D111084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111093, AGR [CASE @D111092, COUNT @D111091, PER @D111090, 
            PLU @D111089, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111098, AGR [CASE @D111097, COUNT @D111096, PER @D111095, 
            PLU @D111094, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111103, AGR [CASE @D111102, COUNT @D111101, PER @D111100, 
            PLU @D111099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111108, AGR [CASE @D111107, COUNT @D111106, PER @D111105, 
            PLU @D111104, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111113, AGR [CASE @D111112, COUNT @D111111, PER @D111110, 
            PLU @D111109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111118, AGR [CASE @D111117, COUNT @D111116, PER @D111115, 
            PLU @D111114, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111123, AGR [CASE @D111122, COUNT @D111121, PER @D111120, 
            PLU @D111119, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111128, AGR [CASE @D111127, COUNT @D111126, PER @D111125, 
            PLU @D111124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111133, AGR [CASE @D111132, COUNT @D111131, PER @D111130, 
            PLU @D111129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111138, AGR [CASE @D111137, COUNT @D111136, PER @D111135, 
            PLU @D111134, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111143, AGR [CASE @D111142, COUNT @D111141, PER @D111140, 
            PLU @D111139, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111148, AGR [CASE @D111147, COUNT @D111146, PER @D111145, 
            PLU @D111144, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111153, AGR [CASE @D111152, COUNT @D111151, PER @D111150, 
            PLU @D111149, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111158, AGR [CASE @D111157, COUNT @D111156, PER @D111155, 
            PLU @D111154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111163, AGR [CASE @D111162, COUNT @D111161, PER @D111160, 
            PLU @D111159, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111168, AGR [CASE @D111167, COUNT @D111166, PER @D111165, 
            PLU @D111164, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111173, AGR [CASE @D111172, COUNT @D111171, PER @D111170, 
            PLU @D111169, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111178, AGR [CASE @D111177, COUNT @D111176, PER @D111175, 
            PLU @D111174, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111183, AGR [CASE @D111182, COUNT @D111181, PER @D111180, 
            PLU @D111179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORWARD, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111188, AGR [CASE @D111187, COUNT @D111186, PER @D111185, 
            PLU @D111184, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORWARD, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111193, AGR [CASE @D111192, COUNT @D111191, PER @D111190, 
            PLU @D111189, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111198, AGR [CASE @D111197, COUNT @D111196, PER @D111195, 
            PLU @D111194, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111203, AGR [CASE @D111202, COUNT @D111201, PER @D111200, 
            PLU @D111199, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111208, AGR [CASE @D111207, COUNT @D111206, PER @D111205, 
            PLU @D111204, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111213, AGR [CASE @D111212, COUNT @D111211, PER @D111210, 
            PLU @D111209, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111218, AGR [CASE @D111217, COUNT @D111216, PER @D111215, 
            PLU @D111214, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111223, AGR [CASE @D111222, COUNT @D111221, PER @D111220, 
            PLU @D111219, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111228, AGR [CASE @D111227, COUNT @D111226, PER @D111225, 
            PLU @D111224, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111233, AGR [CASE @D111232, COUNT @D111231, PER @D111230, 
            PLU @D111229, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111238, AGR [CASE @D111237, COUNT @D111236, PER @D111235, 
            PLU @D111234, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : PUSH.

WORD pushing : 
   [COORD @D111249, PRD @D111248, AGR [CASE @D111247, COUNT @D111246, 
            PER @D111245, PLU @D111244, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111255, PRD @D111254, 
      AGR [CASE @D111253, COUNT @D111252, PER @D111251, PLU @D111250, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   PUSH, 
   [COORD @D111261, PRD @D111260, AGR [CASE @D111259, COUNT @D111258, 
            PER @D111257, PLU @D111256, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111267, PRD @D111266, 
      AGR [CASE @D111265, COUNT @D111264, PER @D111263, PLU @D111262, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUSH, 
   [COORD @D111273, PRD @D111272, AGR [CASE @D111271, COUNT @D111270, 
            PER @D111269, PLU @D111268, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ONTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111279, PRD @D111278, 
      AGR [CASE @D111277, COUNT @D111276, PER @D111275, PLU @D111274, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUSH, 
   [COORD @D111285, PRD @D111284, AGR [CASE @D111283, COUNT @D111282, 
            PER @D111281, PLU @D111280, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111291, PRD @D111290, 
      AGR [CASE @D111289, COUNT @D111288, PER @D111287, PLU @D111286, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111297, PRD @D111296, AGR [CASE @D111295, COUNT @D111294, 
            PER @D111293, PLU @D111292, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111303, PRD @D111302, 
      AGR [CASE @D111301, COUNT @D111300, PER @D111299, PLU @D111298, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT THROUGH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111309, PRD @D111308, AGR [CASE @D111307, COUNT @D111306, 
            PER @D111305, PLU @D111304, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT FORWARD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111315, PRD @D111314, 
      AGR [CASE @D111313, COUNT @D111312, PER @D111311, PLU @D111310, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111321, PRD @D111320, AGR [CASE @D111319, COUNT @D111318, 
            PER @D111317, PLU @D111316, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ON, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111327, PRD @D111326, 
      AGR [CASE @D111325, COUNT @D111324, PER @D111323, PLU @D111322, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT FORWARD, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111333, PRD @D111332, 
      AGR [CASE @D111331, COUNT @D111330, PER @D111329, PLU @D111328, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALONG, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111339, PRD @D111338, AGR [CASE @D111337, COUNT @D111336, 
            PER @D111335, PLU @D111334, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AHEAD, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111345, PRD @D111344, 
      AGR [CASE @D111343, COUNT @D111342, PER @D111341, PLU @D111340, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUSH, 
   [COORD @D111351, PRD @D111350, AGR [CASE @D111349, COUNT @D111348, 
            PER @D111347, PLU @D111346, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111357, PRD @D111356, 
      AGR [CASE @D111355, COUNT @D111354, PER @D111353, PLU @D111352, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUSH, 
   [COORD @D111363, PRD @D111362, AGR [CASE @D111361, COUNT @D111360, 
            PER @D111359, PLU @D111358, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111369, PRD @D111368, 
      AGR [CASE @D111367, COUNT @D111366, PER @D111365, PLU @D111364, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUSH, 
   [COORD @D111375, PRD @D111374, AGR [CASE @D111373, COUNT @D111372, 
            PER @D111371, PLU @D111370, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111381, PRD @D111380, 
      AGR [CASE @D111379, COUNT @D111378, PER @D111377, PLU @D111376, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111387, PRD @D111386, AGR [CASE @D111385, COUNT @D111384, 
            PER @D111383, PLU @D111382, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111393, PRD @D111392, 
      AGR [CASE @D111391, COUNT @D111390, PER @D111389, PLU @D111388, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111399, PRD @D111398, AGR [CASE @D111397, COUNT @D111396, 
            PER @D111395, PLU @D111394, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111405, PRD @D111404, 
      AGR [CASE @D111403, COUNT @D111402, PER @D111401, PLU @D111400, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111411, PRD @D111410, AGR [CASE @D111409, COUNT @D111408, 
            PER @D111407, PLU @D111406, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111417, PRD @D111416, 
      AGR [CASE @D111415, COUNT @D111414, PER @D111413, PLU @D111412, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORWARD, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111423, PRD @D111422, AGR [CASE @D111421, COUNT @D111420, 
            PER @D111419, PLU @D111418, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111429, PRD @D111428, 
      AGR [CASE @D111427, COUNT @D111426, PER @D111425, PLU @D111424, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111435, PRD @D111434, AGR [CASE @D111433, COUNT @D111432, 
            PER @D111431, PLU @D111430, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH, 
   [COORD @D111441, PRD @D111440, 
      AGR [CASE @D111439, COUNT @D111438, PER @D111437, PLU @D111436, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUSH, 
   [COORD @D111447, PRD @D111446, AGR [CASE @D111445, COUNT @D111444, 
            PER @D111443, PLU @D111442, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUSH.

WORD put : 
   [COADV @D111460, COORD @D111459, DEF @D111458, PRD @D111457, AGR 
            [CASE @D111456, COUNT @D111455, PER @D111454, PLU @D111453, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : PUT, 
   [COORD @D111464, REFL @D111463, PRD @D111462, CASE @D111461, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : PUT, 
   [COORD @D111467, 
      AGR [COUNT @D111466, PER @D111465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : PUT, 
   
   [COORD @D111469, AGR [COUNT @D111468, N +, V -, BAR 2, NFORM NORM, CASE 
               NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, 
      ARITY 3] : PUT, 
   [COORD @D111471, AGR [COUNT @D111470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111475, AGR [COUNT @D111474, PER @D111473, PLU @D111472, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : PUT, 
   [COORD @D111481, PAST @D111480, 
      AGR [CASE @D111479, COUNT @D111478, PER @D111477, PLU @D111476, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111484, AGR [COUNT @D111483, PER @D111482, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111486, AGR [COUNT @D111485, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111488, AGR [COUNT @D111487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111492, AGR [COUNT @D111491, PER @D111490, PLU @D111489, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : PUT, 
   [COORD @D111498, PAST @D111497, 
      AGR [CASE @D111496, COUNT @D111495, PER @D111494, PLU @D111493, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : PUT, 
   [COORD @D111501, AGR [COUNT @D111500, PER @D111499, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADVP, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111503, AGR [COUNT @D111502, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADVP, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111505, AGR [COUNT @D111504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADVP, 
      REG -, ARITY 3] : PUT, 
   [COORD @D111509, AGR [COUNT @D111508, PER @D111507, PLU @D111506, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, REG -, ARITY 3] : PUT, 
   [COORD @D111515, PAST @D111514, 
      AGR [CASE @D111513, COUNT @D111512, PER @D111511, PLU @D111510, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADVP, REG -, 
      ARITY 3] : PUT, 
   [COORD @D111518, AGR [COUNT @D111517, PER @D111516, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : PUT, 
   [COORD @D111520, AGR [COUNT @D111519, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : PUT, 
   [COORD @D111522, AGR [COUNT @D111521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : PUT, 
   [COORD @D111526, AGR [COUNT @D111525, PER @D111524, PLU @D111523, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PRT DOWN, PREP AS, ARITY 3] : PUT, 
   [COORD @D111532, PAST @D111531, 
      AGR [CASE @D111530, COUNT @D111529, PER @D111528, PLU @D111527, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : PUT, 
   [COORD @D111535, AGR [COUNT @D111534, PER @D111533, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111537, AGR [COUNT @D111536, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111539, AGR [COUNT @D111538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111543, AGR [COUNT @D111542, PER @D111541, PLU @D111540, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111549, PAST @D111548, 
      AGR [CASE @D111547, COUNT @D111546, PER @D111545, PLU @D111544, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111552, AGR [COUNT @D111551, PER @D111550, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111554, AGR [COUNT @D111553, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111556, AGR [COUNT @D111555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111560, AGR [COUNT @D111559, PER @D111558, PLU @D111557, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT UP, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111566, PAST @D111565, 
      AGR [CASE @D111564, COUNT @D111563, PER @D111562, PLU @D111561, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111569, AGR [COUNT @D111568, PER @D111567, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111571, AGR [COUNT @D111570, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111573, AGR [COUNT @D111572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111577, AGR [COUNT @D111576, PER @D111575, PLU @D111574, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111583, PAST @D111582, 
      AGR [CASE @D111581, COUNT @D111580, PER @D111579, PLU @D111578, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111586, AGR [COUNT @D111585, PER @D111584, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : PUT, 
   [COORD @D111588, AGR [COUNT @D111587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : PUT, 
   [COORD @D111590, AGR [COUNT @D111589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : PUT, 
   [COORD @D111594, AGR [COUNT @D111593, PER @D111592, PLU @D111591, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, ARITY 3] : PUT, 
   [COORD @D111600, PAST @D111599, 
      AGR [CASE @D111598, COUNT @D111597, PER @D111596, PLU @D111595, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : PUT, 
   [COORD @D111603, AGR [COUNT @D111602, PER @D111601, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ONTO, ARITY 3] : PUT, 
   [COORD @D111605, AGR [COUNT @D111604, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ONTO, ARITY 3] : PUT, 
   [COORD @D111607, AGR [COUNT @D111606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ONTO, ARITY 3] : PUT, 
   [COORD @D111611, AGR [COUNT @D111610, PER @D111609, PLU @D111608, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ONTO, ARITY 3] : PUT, 
   [COORD @D111617, PAST @D111616, 
      AGR [CASE @D111615, COUNT @D111614, PER @D111613, PLU @D111612, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ONTO, ARITY 3] : PUT, 
   [COORD @D111620, AGR [COUNT @D111619, PER @D111618, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111622, AGR [COUNT @D111621, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111624, AGR [COUNT @D111623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111628, AGR [COUNT @D111627, PER @D111626, PLU @D111625, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111634, PAST @D111633, 
      AGR [CASE @D111632, COUNT @D111631, PER @D111630, PLU @D111629, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111637, AGR [COUNT @D111636, PER @D111635, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OVER, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111639, AGR [COUNT @D111638, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OVER, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111641, AGR [COUNT @D111640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OVER, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111645, AGR [COUNT @D111644, PER @D111643, PLU @D111642, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OVER, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111651, PAST @D111650, 
      AGR [CASE @D111649, COUNT @D111648, PER @D111647, PLU @D111646, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OVER, PFORM ON, ARITY 3] : PUT, 
   [COORD @D111654, AGR [COUNT @D111653, PER @D111652, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111656, 
      AGR [COUNT @D111655, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, REG -, 
      PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111658, AGR [COUNT @D111657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111662, 
      AGR [COUNT @D111661, PER @D111660, PLU @D111659, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111668, PAST @D111667, 
      AGR [CASE @D111666, COUNT @D111665, PER @D111664, PLU @D111663, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111671, 
      AGR [COUNT @D111670, PER @D111669, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OFF, 
      ARITY 3] : PUT, 
   [COORD @D111673, AGR [COUNT @D111672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111675, AGR [COUNT @D111674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111679, AGR [COUNT @D111678, PER @D111677, PLU @D111676, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111685, PAST @D111684, 
      AGR [CASE @D111683, COUNT @D111682, PER @D111681, PLU @D111680, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OFF, ARITY 3] : PUT, 
   [COORD @D111688, AGR [COUNT @D111687, PER @D111686, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : PUT, 
   [COORD @D111690, AGR [COUNT @D111689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : PUT, 
   [COORD @D111692, AGR [COUNT @D111691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : PUT, 
   [COORD @D111696, AGR [COUNT @D111695, PER @D111694, PLU @D111693, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : PUT, 
   [COORD @D111702, PAST @D111701, 
      AGR [CASE @D111700, COUNT @D111699, PER @D111698, PLU @D111697, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : PUT, 
   [COORD @D111705, AGR [COUNT @D111704, PER @D111703, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT IN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111707, AGR [COUNT @D111706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT IN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111709, AGR [COUNT @D111708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT IN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111713, AGR [COUNT @D111712, PER @D111711, PLU @D111710, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT IN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111719, PAST @D111718, 
      AGR [CASE @D111717, COUNT @D111716, PER @D111715, PLU @D111714, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT IN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111722, AGR [COUNT @D111721, PER @D111720, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111724, AGR [COUNT @D111723, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111726, AGR [COUNT @D111725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111730, AGR [COUNT @D111729, PER @D111728, PLU @D111727, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111736, PAST @D111735, 
      AGR [CASE @D111734, COUNT @D111733, PER @D111732, PLU @D111731, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111739, AGR [COUNT @D111738, PER @D111737, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111741, AGR [COUNT @D111740, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111743, AGR [COUNT @D111742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111747, AGR [COUNT @D111746, PER @D111745, PLU @D111744, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111753, PAST @D111752, 
      AGR [CASE @D111751, COUNT @D111750, PER @D111749, PLU @D111748, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111756, AGR [COUNT @D111755, PER @D111754, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : PUT, 
   [COORD @D111758, AGR [COUNT @D111757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : PUT, 
   [COORD @D111760, AGR [COUNT @D111759, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : PUT, 
   [COORD @D111764, AGR [COUNT @D111763, PER @D111762, PLU @D111761, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM AS, ARITY 3] : PUT, 
   [COORD @D111770, PAST @D111769, 
      AGR [CASE @D111768, COUNT @D111767, PER @D111766, PLU @D111765, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : PUT, 
   [COORD @D111773, AGR [COUNT @D111772, PER @D111771, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ACROSS, ARITY 3] : PUT, 
   [COORD @D111775, AGR [COUNT @D111774, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ACROSS, ARITY 3] : PUT, 
   [COORD @D111777, AGR [COUNT @D111776, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ACROSS, ARITY 3] : PUT, 
   [COORD @D111781, AGR [COUNT @D111780, PER @D111779, PLU @D111778, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ACROSS, ARITY 3] : PUT, 
   [COORD @D111787, PAST @D111786, 
      AGR [CASE @D111785, COUNT @D111784, PER @D111783, PLU @D111782, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ACROSS, ARITY 3] : PUT, 
   [COORD @D111790, AGR [COUNT @D111789, PER @D111788, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111792, AGR [COUNT @D111791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111794, AGR [COUNT @D111793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111798, AGR [COUNT @D111797, PER @D111796, PLU @D111795, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111804, PAST @D111803, 
      AGR [CASE @D111802, COUNT @D111801, PER @D111800, PLU @D111799, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111807, AGR [COUNT @D111806, PER @D111805, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111809, AGR [COUNT @D111808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111811, AGR [COUNT @D111810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111815, AGR [COUNT @D111814, PER @D111813, PLU @D111812, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111821, PAST @D111820, 
      AGR [CASE @D111819, COUNT @D111818, PER @D111817, PLU @D111816, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM UNTIL, ARITY 3] : PUT, 
   [COORD @D111824, AGR [COUNT @D111823, PER @D111822, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT THROUGH, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111826, AGR [COUNT @D111825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT THROUGH, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111828, AGR [COUNT @D111827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT THROUGH, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111832, AGR [COUNT @D111831, PER @D111830, PLU @D111829, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111838, PAST @D111837, 
      AGR [CASE @D111836, COUNT @D111835, PER @D111834, PLU @D111833, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111841, AGR [COUNT @D111840, PER @D111839, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111843, AGR [COUNT @D111842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111845, AGR [COUNT @D111844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111849, AGR [COUNT @D111848, PER @D111847, PLU @D111846, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111855, PAST @D111854, 
      AGR [CASE @D111853, COUNT @D111852, PER @D111851, PLU @D111850, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM TO, ARITY 3] : PUT, 
   [COORD @D111858, AGR [COUNT @D111857, PER @D111856, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111860, AGR [COUNT @D111859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111862, AGR [COUNT @D111861, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111866, AGR [COUNT @D111865, PER @D111864, PLU @D111863, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111872, PAST @D111871, 
      AGR [CASE @D111870, COUNT @D111869, PER @D111868, PLU @D111867, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111875, AGR [COUNT @D111874, PER @D111873, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111877, AGR [COUNT @D111876, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111879, AGR [COUNT @D111878, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111883, AGR [COUNT @D111882, PER @D111881, PLU @D111880, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111889, PAST @D111888, 
      AGR [CASE @D111887, COUNT @D111886, PER @D111885, PLU @D111884, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM TILL, ARITY 3] : PUT, 
   [COORD @D111892, AGR [COUNT @D111891, PER @D111890, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111894, AGR [COUNT @D111893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111896, AGR [COUNT @D111895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111900, AGR [COUNT @D111899, PER @D111898, PLU @D111897, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111906, PAST @D111905, 
      AGR [CASE @D111904, COUNT @D111903, PER @D111902, PLU @D111901, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM FOR, ARITY 3] : PUT, 
   [COORD @D111909, AGR [COUNT @D111908, PER @D111907, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111911, AGR [COUNT @D111910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111913, AGR [COUNT @D111912, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111917, AGR [COUNT @D111916, PER @D111915, PLU @D111914, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM AT, ARITY 3] : PUT, 
   [COORD @D111923, PAST @D111922, 
      AGR [CASE @D111921, COUNT @D111920, PER @D111919, PLU @D111918, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM AT, ARITY 3] : PUT, 
   [COORD @D111929, PAST @D111928, AGR [CASE @D111927, COUNT @D111926, 
            PER @D111925, PLU @D111924, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : PUT, 
   [COORD @D111935, PAST @D111934, 
      AGR [CASE @D111933, COUNT @D111932, PER @D111931, PLU @D111930, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, 
      ARITY 3] : PUT, 
   [COORD @D111941, PAST @D111940, AGR [CASE @D111939, COUNT @D111938, 
            PER @D111937, PLU @D111936, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : PUT, 
   [COORD @D111947, PAST @D111946, 
      AGR [CASE @D111945, COUNT @D111944, PER @D111943, PLU @D111942, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : PUT, 
   [COORD @D111953, PAST @D111952, AGR [CASE @D111951, COUNT @D111950, 
            PER @D111949, PLU @D111948, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, REG -, FIN -, ARITY 3] : PUT, 
   [COORD @D111959, PAST @D111958, 
      AGR [CASE @D111957, COUNT @D111956, PER @D111955, PLU @D111954, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADVP, REG -, FIN -, 
      ARITY 3] : PUT, 
   [COORD @D111965, PAST @D111964, AGR [CASE @D111963, COUNT @D111962, 
            PER @D111961, PLU @D111960, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PRT DOWN, PREP AS, FIN -, ARITY 3] : PUT, 
   [COORD @D111971, PAST @D111970, 
      AGR [CASE @D111969, COUNT @D111968, PER @D111967, PLU @D111966, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, PRT DOWN, 
      PREP AS, FIN -, ARITY 3] : PUT, 
   [COORD @D111977, PAST @D111976, AGR [CASE @D111975, COUNT @D111974, 
            PER @D111973, PLU @D111972, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D111983, PAST @D111982, 
      AGR [CASE @D111981, COUNT @D111980, PER @D111979, PLU @D111978, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D111989, PAST @D111988, AGR [CASE @D111987, COUNT @D111986, 
            PER @D111985, PLU @D111984, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT UP, PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D111995, PAST @D111994, 
      AGR [CASE @D111993, COUNT @D111992, PER @D111991, PLU @D111990, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT UP, 
      PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D112001, PAST @D112000, AGR [CASE @D111999, COUNT @D111998, 
            PER @D111997, PLU @D111996, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D112007, PAST @D112006, 
      AGR [CASE @D112005, COUNT @D112004, PER @D112003, PLU @D112002, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT DOWN, 
      PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D112013, PAST @D112012, AGR [CASE @D112011, COUNT @D112010, 
            PER @D112009, PLU @D112008, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, FIN -, ARITY 3] : PUT, 
   [COORD @D112019, PAST @D112018, 
      AGR [CASE @D112017, COUNT @D112016, PER @D112015, PLU @D112014, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM THROUGH, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112025, PAST @D112024, AGR [CASE @D112023, COUNT @D112022, 
            PER @D112021, PLU @D112020, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ONTO, FIN -, ARITY 3] : PUT, 
   [COORD @D112031, PAST @D112030, 
      AGR [CASE @D112029, COUNT @D112028, PER @D112027, PLU @D112026, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ONTO, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112037, PAST @D112036, AGR [CASE @D112035, COUNT @D112034, 
            PER @D112033, PLU @D112032, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : PUT, 
   [COORD @D112043, PAST @D112042, 
      AGR [CASE @D112041, COUNT @D112040, PER @D112039, PLU @D112038, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112049, PAST @D112048, AGR [CASE @D112047, COUNT @D112046, 
            PER @D112045, PLU @D112044, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OVER, PFORM ON, FIN -, ARITY 3] : PUT, 
   [COORD @D112055, PAST @D112054, 
      AGR [CASE @D112053, COUNT @D112052, PER @D112051, PLU @D112050, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OVER, 
      PFORM ON, FIN -, ARITY 3] : PUT, 
   [COORD @D112061, PAST @D112060, AGR [CASE @D112059, COUNT @D112058, 
            PER @D112057, PLU @D112056, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, REG -, PFORM OFF, FIN -, ARITY 3] : PUT, 
   [COORD @D112067, PAST @D112066, 
      AGR [CASE @D112065, COUNT @D112064, PER @D112063, PLU @D112062, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, REG -, 
      PFORM OFF, FIN -, ARITY 3] : PUT, 
   [COORD @D112073, PAST @D112072, AGR 
         [CASE @D112071, COUNT @D112070, PER @D112069, PLU @D112068, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OFF, FIN -, 
      ARITY 3] : PUT, 
   [COORD @D112079, PAST @D112078, AGR [CASE @D112077, COUNT @D112076, 
            PER @D112075, PLU @D112074, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OFF, FIN -, ARITY 3] : PUT, 
   [COORD @D112085, PAST @D112084, 
      AGR [CASE @D112083, COUNT @D112082, PER @D112081, PLU @D112080, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112091, PAST @D112090, AGR [CASE @D112089, COUNT @D112088, 
            PER @D112087, PLU @D112086, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : PUT, 
   [COORD @D112097, PAST @D112096, 
      AGR [CASE @D112095, COUNT @D112094, PER @D112093, PLU @D112092, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT IN, 
      PFORM FOR, FIN -, ARITY 3] : PUT, 
   [COORD @D112103, PAST @D112102, AGR 
         [CASE @D112101, COUNT @D112100, PER @D112099, PLU @D112098, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT IN, 
      PFORM FOR, FIN -, ARITY 3] : PUT, 
   [COORD @D112109, PAST @D112108, AGR 
         [CASE @D112107, COUNT @D112106, PER @D112105, PLU @D112104, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT DOWN, PFORM FOR, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112115, PAST @D112114, AGR [CASE @D112113, COUNT @D112112, 
            PER @D112111, PLU @D112110, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM FOR, FIN -, ARITY 3] : PUT, 
   [COORD @D112121, PAST @D112120, 
      AGR [CASE @D112119, COUNT @D112118, PER @D112117, PLU @D112116, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM AT, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112127, PAST @D112126, AGR [CASE @D112125, COUNT @D112124, 
            PER @D112123, PLU @D112122, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AT, FIN -, ARITY 3] : PUT, 
   [COORD @D112133, PAST @D112132, 
      AGR [CASE @D112131, COUNT @D112130, PER @D112129, PLU @D112128, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT DOWN, 
      PFORM AS, FIN -, ARITY 3] : PUT, 
   [COORD @D112139, PAST @D112138, AGR [CASE @D112137, COUNT @D112136, 
            PER @D112135, PLU @D112134, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM AS, FIN -, ARITY 3] : PUT, 
   [COORD @D112145, PAST @D112144, 
      AGR [CASE @D112143, COUNT @D112142, PER @D112141, PLU @D112140, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ACROSS, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112151, PAST @D112150, AGR [CASE @D112149, COUNT @D112148, 
            PER @D112147, PLU @D112146, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ACROSS, FIN -, ARITY 3] : PUT, 
   [COORD @D112157, PAST @D112156, 
      AGR [CASE @D112155, COUNT @D112154, PER @D112153, PLU @D112152, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM UNTIL, FIN -, ARITY 3] : PUT, 
   [COORD @D112163, PAST @D112162, 
      AGR [CASE @D112161, COUNT @D112160, PER @D112159, PLU @D112158, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM UNTIL, FIN -, ARITY 3] : PUT, 
   [COORD @D112169, PAST @D112168, 
      AGR [CASE @D112167, COUNT @D112166, PER @D112165, PLU @D112164, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      PFORM UNTIL, FIN -, ARITY 3] : PUT, 
   [COORD @D112175, PAST @D112174, 
      AGR [CASE @D112173, COUNT @D112172, PER @D112171, PLU @D112170, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      PFORM UNTIL, FIN -, ARITY 3] : PUT, 
   [COORD @D112181, PAST @D112180, 
      AGR [CASE @D112179, COUNT @D112178, PER @D112177, PLU @D112176, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D112187, PAST @D112186, 
      AGR [CASE @D112185, COUNT @D112184, PER @D112183, PLU @D112182, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D112193, PAST @D112192, 
      AGR [CASE @D112191, COUNT @D112190, PER @D112189, PLU @D112188, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D112199, PAST @D112198, AGR [CASE @D112197, COUNT @D112196, 
            PER @D112195, PLU @D112194, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, PFORM TO, FIN -, ARITY 3] : PUT, 
   [COORD @D112205, PAST @D112204, 
      AGR [CASE @D112203, COUNT @D112202, PER @D112201, PLU @D112200, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM TILL, FIN -, ARITY 3] : PUT, 
   [COORD @D112211, PAST @D112210, 
      AGR [CASE @D112209, COUNT @D112208, PER @D112207, PLU @D112206, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM TILL, FIN -, ARITY 3] : PUT, 
   [COORD @D112217, PAST @D112216, 
      AGR [CASE @D112215, COUNT @D112214, PER @D112213, PLU @D112212, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      PFORM TILL, FIN -, ARITY 3] : PUT, 
   [COORD @D112223, PAST @D112222, 
      AGR [CASE @D112221, COUNT @D112220, PER @D112219, PLU @D112218, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      PFORM TILL, FIN -, ARITY 3] : PUT, 
   [COORD @D112229, PAST @D112228, 
      AGR [CASE @D112227, COUNT @D112226, PER @D112225, PLU @D112224, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM FOR, FIN -, ARITY 3] : PUT, 
   [COORD @D112235, PAST @D112234, AGR 
         [CASE @D112233, COUNT @D112232, PER @D112231, PLU @D112230, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM FOR, FIN -, ARITY 3] : PUT, 
   [COORD @D112241, PAST @D112240, AGR 
         [CASE @D112239, COUNT @D112238, PER @D112237, PLU @D112236, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM AT, 
      FIN -, ARITY 3] : PUT, 
   [COORD @D112247, PAST @D112246, AGR [CASE @D112245, COUNT @D112244, 
            PER @D112243, PLU @D112242, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM AT, FIN -, ARITY 3] : PUT, 
   [COORD @D112251, 
      AGR [COUNT @D112250, PER @D112249, PLU @D112248, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, PAST +, 
      ARITY 3] : PUT, 
   [COORD @D112255, AGR [COUNT @D112254, PER @D112253, PLU @D112252, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : PUT, 
   [COORD @D112259, AGR [COUNT @D112258, PER @D112257, PLU @D112256, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, REG -, PAST +, ARITY 3] : PUT, 
   [COORD @D112263, AGR [COUNT @D112262, PER @D112261, PLU @D112260, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PRT DOWN, PREP AS, PAST +, ARITY 3] : PUT, 
   [COORD @D112267, 
      AGR [COUNT @D112266, PER @D112265, PLU @D112264, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : PUT, 
   [COORD @D112271, AGR [COUNT @D112270, PER @D112269, PLU @D112268, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT UP, PFORM TO, PAST +, ARITY 3] : PUT, 
   [COORD @D112275, 
      AGR [COUNT @D112274, PER @D112273, PLU @D112272, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PRT DOWN, PFORM TO, PAST +, ARITY 3] : PUT, 
   [COORD @D112279, AGR [COUNT @D112278, PER @D112277, PLU @D112276, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, PAST +, ARITY 3] : PUT, 
   [COORD @D112283, 
      AGR [COUNT @D112282, PER @D112281, PLU @D112280, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM ONTO, PAST +, ARITY 3] : PUT, 
   [COORD @D112287, AGR [COUNT @D112286, PER @D112285, PLU @D112284, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, PAST +, ARITY 3] : PUT, 
   [COORD @D112291, 
      AGR [COUNT @D112290, PER @D112289, PLU @D112288, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PRT OVER, PFORM ON, PAST +, ARITY 3] : PUT, 
   [COORD @D112295, AGR [COUNT @D112294, PER @D112293, PLU @D112292, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, REG -, PFORM OFF, PAST +, ARITY 3] : PUT, 
   [COORD @D112299, 
      AGR [COUNT @D112298, PER @D112297, PLU @D112296, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM OFF, PAST +, ARITY 3] : PUT, 
   [COORD @D112303, AGR [COUNT @D112302, PER @D112301, PLU @D112300, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, PAST +, ARITY 3] : PUT, 
   [COORD @D112307, 
      AGR [COUNT @D112306, PER @D112305, PLU @D112304, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT IN, 
      PFORM FOR, PAST +, ARITY 3] : PUT, 
   [COORD @D112311, AGR [COUNT @D112310, PER @D112309, PLU @D112308, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM FOR, PAST +, ARITY 3] : PUT, 
   [COORD @D112315, 
      AGR [COUNT @D112314, PER @D112313, PLU @D112312, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM AT, PAST +, ARITY 3] : PUT, 
   [COORD @D112319, AGR [COUNT @D112318, PER @D112317, PLU @D112316, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM AS, PAST +, ARITY 3] : PUT, 
   [COORD @D112323, 
      AGR [COUNT @D112322, PER @D112321, PLU @D112320, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM ACROSS, PAST +, ARITY 3] : PUT, 
   [COORD @D112327, AGR [COUNT @D112326, PER @D112325, PLU @D112324, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM UNTIL, PAST +, ARITY 3] : PUT, 
   [COORD @D112331, 
      AGR [COUNT @D112330, PER @D112329, PLU @D112328, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM UNTIL, PAST +, ARITY 3] : PUT, 
   [COORD @D112335, AGR [COUNT @D112334, PER @D112333, PLU @D112332, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, PFORM TO, PAST +, ARITY 3] : PUT, 
   [COORD @D112339, 
      AGR [COUNT @D112338, PER @D112337, PLU @D112336, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM TO, PAST +, ARITY 3] : PUT, 
   [COORD @D112343, AGR [COUNT @D112342, PER @D112341, PLU @D112340, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM TILL, PAST +, ARITY 3] : PUT, 
   [COORD @D112347, 
      AGR [COUNT @D112346, PER @D112345, PLU @D112344, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PFORM TILL, PAST +, ARITY 3] : PUT, 
   [COORD @D112351, AGR [COUNT @D112350, PER @D112349, PLU @D112348, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM FOR, PAST +, ARITY 3] : PUT, 
   [COORD @D112355, 
      AGR [COUNT @D112354, PER @D112353, PLU @D112352, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PFORM AT, PAST +, ARITY 3] : PUT, 
   [COORD @D112358, AGR [COUNT @D112357, PER @D112356, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : PUT, 
   [COORD @D112360, AGR [COUNT @D112359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : PUT, 
   [COORD @D112362, AGR [COUNT @D112361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : PUT, 
   [COORD @D112366, AGR [COUNT @D112365, PER @D112364, PLU @D112363, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : PUT, 
   [COORD @D112372, PAST @D112371, AGR [CASE @D112370, COUNT @D112369, 
            PER @D112368, PLU @D112367, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : PUT, 
   [COORD @D112375, AGR [COUNT @D112374, PER @D112373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT UP, ARITY 2] : PUT, 
   [COORD @D112377, AGR [COUNT @D112376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT UP, ARITY 2] : PUT, 
   [COORD @D112379, AGR [COUNT @D112378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT UP, ARITY 2] : PUT, 
   [COORD @D112383, AGR [COUNT @D112382, PER @D112381, PLU @D112380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, PRT UP, ARITY 2] : PUT, 
   [COORD @D112389, PAST @D112388, AGR [CASE @D112387, COUNT @D112386, 
            PER @D112385, PLU @D112384, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, PRT UP, ARITY 2] : PUT, 
   [COORD @D112392, 
      AGR [COUNT @D112391, PER @D112390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT OFF, 
      ARITY 2] : PUT, 
   [COORD @D112394, AGR [COUNT @D112393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT OFF, ARITY 2] : PUT, 
   [COORD @D112396, AGR [COUNT @D112395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT OFF, ARITY 2] : PUT, 
   [COORD @D112400, AGR [COUNT @D112399, PER @D112398, PLU @D112397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT OFF, ARITY 2] : PUT, 
   [COORD @D112406, PAST @D112405, 
      AGR [CASE @D112404, COUNT @D112403, PER @D112402, PLU @D112401, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT OFF, ARITY 2] : PUT, 
   [COORD @D112409, AGR [COUNT @D112408, PER @D112407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT IN, ARITY 2] : PUT, 
   [COORD @D112411, AGR [COUNT @D112410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT IN, ARITY 2] : PUT, 
   [COORD @D112413, AGR [COUNT @D112412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT IN, ARITY 2] : PUT, 
   [COORD @D112417, AGR [COUNT @D112416, PER @D112415, PLU @D112414, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PRT IN, ARITY 2] : PUT, 
   [COORD @D112423, PAST @D112422, 
      AGR [CASE @D112421, COUNT @D112420, PER @D112419, PLU @D112418, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PRT IN, ARITY 2] : PUT, 
   [COORD @D112426, AGR @D112425, PAST @D112424, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, SUBCAT SFIN, 
      REG -, PRT ABOUT, ARITY 2] : PUT, 
   [COORD @D112429, AGR [COUNT @D112428, PER @D112427, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : PUT, 
   [COORD @D112431, AGR [COUNT @D112430, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : PUT, 
   [COORD @D112433, AGR [COUNT @D112432, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : PUT, 
   [COORD @D112437, AGR [COUNT @D112436, PER @D112435, PLU @D112434, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM WITH, ARITY 2] : PUT, 
   [COORD @D112443, PAST @D112442, 
      AGR [CASE @D112441, COUNT @D112440, PER @D112439, PLU @D112438, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM WITH, ARITY 2] : PUT, 
   [COORD @D112446, AGR [COUNT @D112445, PER @D112444, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : PUT, 
   [COORD @D112448, AGR [COUNT @D112447, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : PUT, 
   [COORD @D112450, AGR [COUNT @D112449, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : PUT, 
   [COORD @D112454, AGR [COUNT @D112453, PER @D112452, PLU @D112451, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : PUT, 
   [COORD @D112460, PAST @D112459, 
      AGR [CASE @D112458, COUNT @D112457, PER @D112456, PLU @D112455, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : PUT, 
   [COORD @D112463, AGR [COUNT @D112462, PER @D112461, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112465, AGR [COUNT @D112464, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112467, AGR [COUNT @D112466, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112471, AGR [COUNT @D112470, PER @D112469, PLU @D112468, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OVER, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112477, PAST @D112476, 
      AGR [CASE @D112475, COUNT @D112474, PER @D112473, PLU @D112472, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OVER, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112480, AGR [COUNT @D112479, PER @D112478, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112482, AGR [COUNT @D112481, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112484, AGR [COUNT @D112483, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112488, AGR [COUNT @D112487, PER @D112486, PLU @D112485, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM TO, ARITY 2] : PUT, 
   [COORD @D112494, PAST @D112493, 
      AGR [CASE @D112492, COUNT @D112491, PER @D112490, PLU @D112489, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM TO, ARITY 2] : PUT, 
   [COORD @D112497, AGR [COUNT @D112496, PER @D112495, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : PUT, 
   [COORD @D112499, AGR [COUNT @D112498, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : PUT, 
   [COORD @D112501, AGR [COUNT @D112500, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : PUT, 
   [COORD @D112505, AGR [COUNT @D112504, PER @D112503, PLU @D112502, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : PUT, 
   [COORD @D112511, PAST @D112510, AGR [CASE @D112509, COUNT @D112508, 
            PER @D112507, PLU @D112506, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : PUT, 
   [COORD @D112514, 
      AGR [COUNT @D112513, PER @D112512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM INTO, 
      ARITY 2] : PUT, 
   [COORD @D112516, AGR [COUNT @D112515, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : PUT, 
   [COORD @D112518, AGR [COUNT @D112517, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : PUT, 
   [COORD @D112522, AGR [COUNT @D112521, PER @D112520, PLU @D112519, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM INTO, ARITY 2] : PUT, 
   [COORD @D112528, PAST @D112527, 
      AGR [CASE @D112526, COUNT @D112525, PER @D112524, PLU @D112523, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : PUT, 
   [COORD @D112531, AGR [COUNT @D112530, PER @D112529, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112533, AGR [COUNT @D112532, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112535, AGR [COUNT @D112534, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112539, AGR [COUNT @D112538, PER @D112537, PLU @D112536, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112545, PAST @D112544, 
      AGR [CASE @D112543, COUNT @D112542, PER @D112541, PLU @D112540, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112548, AGR [COUNT @D112547, PER @D112546, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112550, AGR [COUNT @D112549, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112552, AGR [COUNT @D112551, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112556, AGR [COUNT @D112555, PER @D112554, PLU @D112553, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112562, PAST @D112561, 
      AGR [CASE @D112560, COUNT @D112559, PER @D112558, PLU @D112557, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112565, AGR [COUNT @D112564, PER @D112563, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112567, AGR [COUNT @D112566, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112569, AGR [COUNT @D112568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112573, AGR [COUNT @D112572, PER @D112571, PLU @D112570, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112579, PAST @D112578, 
      AGR [CASE @D112577, COUNT @D112576, PER @D112575, PLU @D112574, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : PUT, 
   [COORD @D112582, AGR [COUNT @D112581, PER @D112580, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM AT, ARITY 2] : PUT, 
   [COORD @D112584, AGR [COUNT @D112583, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM AT, ARITY 2] : PUT, 
   [COORD @D112586, AGR [COUNT @D112585, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM AT, ARITY 2] : PUT, 
   [COORD @D112590, AGR [COUNT @D112589, PER @D112588, PLU @D112587, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT IN, PFORM AT, ARITY 2] : PUT, 
   [COORD @D112596, PAST @D112595, 
      AGR [CASE @D112594, COUNT @D112593, PER @D112592, PLU @D112591, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM AT, ARITY 2] : PUT, 
   [COORD @D112599, AGR [COUNT @D112598, PER @D112597, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : PUT, 
   [COORD @D112601, AGR [COUNT @D112600, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : PUT, 
   [COORD @D112603, AGR [COUNT @D112602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : PUT, 
   [COORD @D112607, AGR [COUNT @D112606, PER @D112605, PLU @D112604, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : PUT, 
   [COORD @D112613, PAST @D112612, 
      AGR [CASE @D112611, COUNT @D112610, PER @D112609, PLU @D112608, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : PUT, 
   [COORD @D112616, AGR [COUNT @D112615, PER @D112614, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : PUT, 
   [COORD @D112618, AGR [COUNT @D112617, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : PUT, 
   [COORD @D112620, AGR [COUNT @D112619, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : PUT, 
   [COORD @D112624, AGR [COUNT @D112623, PER @D112622, PLU @D112621, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TOGETHER, ARITY 2] : PUT, 
   [COORD @D112630, PAST @D112629, 
      AGR [CASE @D112628, COUNT @D112627, PER @D112626, PLU @D112625, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, ARITY 2] : PUT, 
   [COORD @D112633, AGR [COUNT @D112632, PER @D112631, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : PUT, 
   [COORD @D112635, AGR [COUNT @D112634, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : PUT, 
   [COORD @D112637, AGR [COUNT @D112636, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : PUT, 
   [COORD @D112641, AGR [COUNT @D112640, PER @D112639, PLU @D112638, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TO, ARITY 2] : PUT, 
   [COORD @D112647, PAST @D112646, 
      AGR [CASE @D112645, COUNT @D112644, PER @D112643, PLU @D112642, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TO, 
      ARITY 2] : PUT, 
   [COORD @D112650, AGR [COUNT @D112649, PER @D112648, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : PUT, 
   [COORD @D112652, AGR [COUNT @D112651, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : PUT, 
   [COORD @D112654, AGR [COUNT @D112653, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : PUT, 
   [COORD @D112658, AGR [COUNT @D112657, PER @D112656, PLU @D112655, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, ARITY 2] : PUT, 
   [COORD @D112664, PAST @D112663, 
      AGR [CASE @D112662, COUNT @D112661, PER @D112660, PLU @D112659, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : PUT, 
   [COORD @D112667, AGR [COUNT @D112666, PER @D112665, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : PUT, 
   [COORD @D112669, AGR [COUNT @D112668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : PUT, 
   [COORD @D112671, AGR [COUNT @D112670, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : PUT, 
   [COORD @D112675, AGR [COUNT @D112674, PER @D112673, PLU @D112672, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : PUT, 
   [COORD @D112681, PAST @D112680, 
      AGR [CASE @D112679, COUNT @D112678, PER @D112677, PLU @D112676, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : PUT, 
   [COORD @D112684, AGR [COUNT @D112683, PER @D112682, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : PUT, 
   [COORD @D112686, AGR [COUNT @D112685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : PUT, 
   [COORD @D112688, AGR [COUNT @D112687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : PUT, 
   [COORD @D112692, AGR [COUNT @D112691, PER @D112690, PLU @D112689, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : PUT, 
   [COORD @D112698, PAST @D112697, 
      AGR [CASE @D112696, COUNT @D112695, PER @D112694, PLU @D112693, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : PUT, 
   [COORD @D112701, AGR [COUNT @D112700, PER @D112699, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : PUT, 
   [COORD @D112703, AGR [COUNT @D112702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : PUT, 
   [COORD @D112705, AGR [COUNT @D112704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : PUT, 
   [COORD @D112709, AGR [COUNT @D112708, PER @D112707, PLU @D112706, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, ARITY 2] : PUT, 
   [COORD @D112715, PAST @D112714, 
      AGR [CASE @D112713, COUNT @D112712, PER @D112711, PLU @D112710, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      ARITY 2] : PUT, 
   [COORD @D112718, AGR [COUNT @D112717, PER @D112716, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : PUT, 
   [COORD @D112720, AGR [COUNT @D112719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : PUT, 
   [COORD @D112722, AGR [COUNT @D112721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : PUT, 
   [COORD @D112726, AGR [COUNT @D112725, PER @D112724, PLU @D112723, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : PUT, 
   [COORD @D112732, PAST @D112731, 
      AGR [CASE @D112730, COUNT @D112729, PER @D112728, PLU @D112727, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : PUT, 
   [COORD @D112735, AGR [COUNT @D112734, PER @D112733, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : PUT, 
   [COORD @D112737, AGR [COUNT @D112736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : PUT, 
   [COORD @D112739, AGR [COUNT @D112738, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : PUT, 
   [COORD @D112743, AGR [COUNT @D112742, PER @D112741, PLU @D112740, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : PUT, 
   [COORD @D112749, PAST @D112748, 
      AGR [CASE @D112747, COUNT @D112746, PER @D112745, PLU @D112744, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : PUT, 
   [COORD @D112752, AGR [COUNT @D112751, PER @D112750, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORWARD, ARITY 2] : PUT, 
   [COORD @D112754, AGR [COUNT @D112753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORWARD, ARITY 2] : PUT, 
   [COORD @D112756, AGR [COUNT @D112755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORWARD, ARITY 2] : PUT, 
   [COORD @D112760, AGR [COUNT @D112759, PER @D112758, PLU @D112757, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FORWARD, ARITY 2] : PUT, 
   [COORD @D112766, PAST @D112765, 
      AGR [CASE @D112764, COUNT @D112763, PER @D112762, PLU @D112761, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORWARD, ARITY 2] : PUT, 
   [COORD @D112769, AGR [COUNT @D112768, PER @D112767, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORTH, ARITY 2] : PUT, 
   [COORD @D112771, AGR [COUNT @D112770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORTH, ARITY 2] : PUT, 
   [COORD @D112773, AGR [COUNT @D112772, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORTH, ARITY 2] : PUT, 
   [COORD @D112777, AGR [COUNT @D112776, PER @D112775, PLU @D112774, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FORTH, ARITY 2] : PUT, 
   [COORD @D112783, PAST @D112782, 
      AGR [CASE @D112781, COUNT @D112780, PER @D112779, PLU @D112778, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT FORTH, ARITY 2] : PUT, 
   [COORD @D112786, AGR [COUNT @D112785, PER @D112784, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : PUT, 
   [COORD @D112788, AGR [COUNT @D112787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : PUT, 
   [COORD @D112790, AGR [COUNT @D112789, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : PUT, 
   [COORD @D112794, AGR [COUNT @D112793, PER @D112792, PLU @D112791, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : PUT, 
   [COORD @D112800, PAST @D112799, 
      AGR [CASE @D112798, COUNT @D112797, PER @D112796, PLU @D112795, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : PUT, 
   [COORD @D112803, AGR [COUNT @D112802, PER @D112801, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BY, ARITY 2] : PUT, 
   [COORD @D112805, AGR [COUNT @D112804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BY, ARITY 2] : PUT, 
   [COORD @D112807, AGR [COUNT @D112806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BY, ARITY 2] : PUT, 
   [COORD @D112811, AGR [COUNT @D112810, PER @D112809, PLU @D112808, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BY, ARITY 2] : PUT, 
   [COORD @D112817, PAST @D112816, 
      AGR [CASE @D112815, COUNT @D112814, PER @D112813, PLU @D112812, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BY, 
      ARITY 2] : PUT, 
   [COORD @D112820, AGR [COUNT @D112819, PER @D112818, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PUT, 
   [COORD @D112822, AGR [COUNT @D112821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PUT, 
   [COORD @D112824, AGR [COUNT @D112823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PUT, 
   [COORD @D112828, AGR [COUNT @D112827, PER @D112826, PLU @D112825, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : PUT, 
   [COORD @D112834, PAST @D112833, 
      AGR [CASE @D112832, COUNT @D112831, PER @D112830, PLU @D112829, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : PUT, 
   [COORD @D112837, AGR [COUNT @D112836, PER @D112835, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : PUT, 
   [COORD @D112839, AGR [COUNT @D112838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : PUT, 
   [COORD @D112841, AGR [COUNT @D112840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : PUT, 
   [COORD @D112845, AGR [COUNT @D112844, PER @D112843, PLU @D112842, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, ARITY 2] : PUT, 
   [COORD @D112851, PAST @D112850, 
      AGR [CASE @D112849, COUNT @D112848, PER @D112847, PLU @D112846, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : PUT, 
   [COORD @D112854, AGR [COUNT @D112853, PER @D112852, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : PUT, 
   [COORD @D112856, AGR [COUNT @D112855, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : PUT, 
   [COORD @D112858, AGR [COUNT @D112857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : PUT, 
   [COORD @D112862, AGR [COUNT @D112861, PER @D112860, PLU @D112859, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASIDE, ARITY 2] : PUT, 
   [COORD @D112868, PAST @D112867, 
      AGR [CASE @D112866, COUNT @D112865, PER @D112864, PLU @D112863, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : PUT, 
   [COORD @D112871, AGR [COUNT @D112870, PER @D112869, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AHEAD, ARITY 2] : PUT, 
   [COORD @D112873, AGR [COUNT @D112872, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AHEAD, ARITY 2] : PUT, 
   [COORD @D112875, AGR [COUNT @D112874, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AHEAD, ARITY 2] : PUT, 
   [COORD @D112879, AGR [COUNT @D112878, PER @D112877, PLU @D112876, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AHEAD, ARITY 2] : PUT, 
   [COORD @D112885, PAST @D112884, 
      AGR [CASE @D112883, COUNT @D112882, PER @D112881, PLU @D112880, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AHEAD, ARITY 2] : PUT, 
   [COORD @D112888, AGR [COUNT @D112887, PER @D112886, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ACROSS, ARITY 2] : PUT, 
   [COORD @D112890, AGR [COUNT @D112889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ACROSS, ARITY 2] : PUT, 
   [COORD @D112892, AGR [COUNT @D112891, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ACROSS, ARITY 2] : PUT, 
   [COORD @D112896, AGR [COUNT @D112895, PER @D112894, PLU @D112893, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ACROSS, ARITY 2] : PUT, 
   [COORD @D112902, PAST @D112901, 
      AGR [CASE @D112900, COUNT @D112899, PER @D112898, PLU @D112897, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ACROSS, ARITY 2] : PUT, 
   [COORD @D112905, AGR [COUNT @D112904, PER @D112903, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ABOUT, ARITY 2] : PUT, 
   [COORD @D112907, AGR [COUNT @D112906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ABOUT, ARITY 2] : PUT, 
   [COORD @D112909, AGR [COUNT @D112908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ABOUT, ARITY 2] : PUT, 
   [COORD @D112913, AGR [COUNT @D112912, PER @D112911, PLU @D112910, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ABOUT, ARITY 2] : PUT, 
   [COORD @D112919, PAST @D112918, 
      AGR [CASE @D112917, COUNT @D112916, PER @D112915, PLU @D112914, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ABOUT, ARITY 2] : PUT, 
   [COORD @D112925, PAST @D112924, AGR [CASE @D112923, COUNT @D112922, 
            PER @D112921, PLU @D112920, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : PUT, 
   [COORD @D112931, PAST @D112930, 
      AGR [CASE @D112929, COUNT @D112928, PER @D112927, PLU @D112926, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D112937, PAST @D112936, AGR [CASE @D112935, COUNT @D112934, 
            PER @D112933, PLU @D112932, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PRT UP, FIN -, ARITY 2] : PUT, 
   [COORD @D112943, PAST @D112942, 
      AGR [CASE @D112941, COUNT @D112940, PER @D112939, PLU @D112938, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT OFF, 
      FIN -, ARITY 2] : PUT, 
   [COORD @D112949, PAST @D112948, AGR [CASE @D112947, COUNT @D112946, 
            PER @D112945, PLU @D112944, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PRT IN, FIN -, ARITY 2] : PUT, 
   [COORD @D112952, AGR @D112951, PAST @D112950, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, SUBCAT SFIN, REG -, 
      PRT ABOUT, FIN -, ARITY 2] : PUT, 
   [COORD @D112958, PAST @D112957, AGR 
         [CASE @D112956, COUNT @D112955, PER @D112954, PLU @D112953, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM WITH, 
      FIN -, ARITY 2] : PUT, 
   [COORD @D112964, PAST @D112963, AGR [CASE @D112962, COUNT @D112961, 
            PER @D112960, PLU @D112959, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT UP, PFORM WITH, FIN -, ARITY 2] : PUT, 
   [COORD @D112970, PAST @D112969, 
      AGR [CASE @D112968, COUNT @D112967, PER @D112966, PLU @D112965, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM UPON, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D112976, PAST @D112975, AGR [CASE @D112974, COUNT @D112973, 
            PER @D112972, PLU @D112971, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM UPON, FIN -, ARITY 2] : PUT, 
   [COORD @D112982, PAST @D112981, 
      AGR [CASE @D112980, COUNT @D112979, PER @D112978, PLU @D112977, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OVER, 
      PFORM TO, FIN -, ARITY 2] : PUT, 
   [COORD @D112988, PAST @D112987, AGR [CASE @D112986, COUNT @D112985, 
            PER @D112984, PLU @D112983, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM TO, FIN -, ARITY 2] : PUT, 
   [COORD @D112994, PAST @D112993, 
      AGR [CASE @D112992, COUNT @D112991, PER @D112990, PLU @D112989, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ON, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113000, PAST @D112999, AGR [CASE @D112998, COUNT @D112997, 
            PER @D112996, PLU @D112995, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ON, FIN -, ARITY 2] : PUT, 
   [COORD @D113006, PAST @D113005, 
      AGR [CASE @D113004, COUNT @D113003, PER @D113002, PLU @D113001, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM INTO, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113012, PAST @D113011, AGR [CASE @D113010, COUNT @D113009, 
            PER @D113008, PLU @D113007, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM INTO, FIN -, ARITY 2] : PUT, 
   [COORD @D113018, PAST @D113017, 
      AGR [CASE @D113016, COUNT @D113015, PER @D113014, PLU @D113013, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM FOR, FIN -, ARITY 2] : PUT, 
   [COORD @D113024, PAST @D113023, AGR 
         [CASE @D113022, COUNT @D113021, PER @D113020, PLU @D113019, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, FIN -, ARITY 2] : PUT, 
   [COORD @D113030, PAST @D113029, AGR 
         [CASE @D113028, COUNT @D113027, PER @D113026, PLU @D113025, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, PFORM FOR, 
      FIN -, ARITY 2] : PUT, 
   [COORD @D113036, PAST @D113035, AGR [CASE @D113034, COUNT @D113033, 
            PER @D113032, PLU @D113031, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT IN, PFORM FOR, FIN -, ARITY 2] : PUT, 
   [COORD @D113042, PAST @D113041, 
      AGR [CASE @D113040, COUNT @D113039, PER @D113038, PLU @D113037, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM AT, FIN -, ARITY 2] : PUT, 
   [COORD @D113048, PAST @D113047, AGR [CASE @D113046, COUNT @D113045, 
            PER @D113044, PLU @D113043, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : PUT, 
   [COORD @D113054, PAST @D113053, 
      AGR [CASE @D113052, COUNT @D113051, PER @D113050, PLU @D113049, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : PUT, 
   [COORD @D113060, PAST @D113059, AGR [CASE @D113058, COUNT @D113057, 
            PER @D113056, PLU @D113055, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TOGETHER, FIN -, ARITY 2] : PUT, 
   [COORD @D113066, PAST @D113065, 
      AGR [CASE @D113064, COUNT @D113063, PER @D113062, PLU @D113061, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TOGETHER, FIN -, ARITY 2] : PUT, 
   [COORD @D113072, PAST @D113071, 
      AGR [CASE @D113070, COUNT @D113069, PER @D113068, PLU @D113067, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TO, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113078, PAST @D113077, AGR [CASE @D113076, COUNT @D113075, 
            PER @D113074, PLU @D113073, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TO, FIN -, ARITY 2] : PUT, 
   [COORD @D113084, PAST @D113083, 
      AGR [CASE @D113082, COUNT @D113081, PER @D113080, PLU @D113079, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT THROUGH, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113090, PAST @D113089, AGR [CASE @D113088, COUNT @D113087, 
            PER @D113086, PLU @D113085, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, FIN -, ARITY 2] : PUT, 
   [COORD @D113096, PAST @D113095, 
      AGR [CASE @D113094, COUNT @D113093, PER @D113092, PLU @D113091, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113102, PAST @D113101, AGR [CASE @D113100, COUNT @D113099, 
            PER @D113098, PLU @D113097, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : PUT, 
   [COORD @D113108, PAST @D113107, 
      AGR [CASE @D113106, COUNT @D113105, PER @D113104, PLU @D113103, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113114, PAST @D113113, AGR [CASE @D113112, COUNT @D113111, 
            PER @D113110, PLU @D113109, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : PUT, 
   [COORD @D113120, PAST @D113119, 
      AGR [CASE @D113118, COUNT @D113117, PER @D113116, PLU @D113115, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113126, PAST @D113125, AGR [CASE @D113124, COUNT @D113123, 
            PER @D113122, PLU @D113121, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, FIN -, ARITY 2] : PUT, 
   [COORD @D113132, PAST @D113131, 
      AGR [CASE @D113130, COUNT @D113129, PER @D113128, PLU @D113127, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113138, PAST @D113137, AGR [CASE @D113136, COUNT @D113135, 
            PER @D113134, PLU @D113133, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : PUT, 
   [COORD @D113144, PAST @D113143, 
      AGR [CASE @D113142, COUNT @D113141, PER @D113140, PLU @D113139, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113150, PAST @D113149, AGR [CASE @D113148, COUNT @D113147, 
            PER @D113146, PLU @D113145, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : PUT, 
   [COORD @D113156, PAST @D113155, 
      AGR [CASE @D113154, COUNT @D113153, PER @D113152, PLU @D113151, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT FORWARD, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113162, PAST @D113161, AGR [CASE @D113160, COUNT @D113159, 
            PER @D113158, PLU @D113157, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FORWARD, FIN -, ARITY 2] : PUT, 
   [COORD @D113168, PAST @D113167, 
      AGR [CASE @D113166, COUNT @D113165, PER @D113164, PLU @D113163, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT FORTH, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113174, PAST @D113173, AGR [CASE @D113172, COUNT @D113171, 
            PER @D113170, PLU @D113169, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FORTH, FIN -, ARITY 2] : PUT, 
   [COORD @D113180, PAST @D113179, 
      AGR [CASE @D113178, COUNT @D113177, PER @D113176, PLU @D113175, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113186, PAST @D113185, AGR [CASE @D113184, COUNT @D113183, 
            PER @D113182, PLU @D113181, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : PUT, 
   [COORD @D113192, PAST @D113191, 
      AGR [CASE @D113190, COUNT @D113189, PER @D113188, PLU @D113187, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BY, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113198, PAST @D113197, AGR [CASE @D113196, COUNT @D113195, 
            PER @D113194, PLU @D113193, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BY, FIN -, ARITY 2] : PUT, 
   [COORD @D113204, PAST @D113203, 
      AGR [CASE @D113202, COUNT @D113201, PER @D113200, PLU @D113199, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113210, PAST @D113209, AGR [CASE @D113208, COUNT @D113207, 
            PER @D113206, PLU @D113205, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : PUT, 
   [COORD @D113216, PAST @D113215, 
      AGR [CASE @D113214, COUNT @D113213, PER @D113212, PLU @D113211, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113222, PAST @D113221, AGR [CASE @D113220, COUNT @D113219, 
            PER @D113218, PLU @D113217, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, FIN -, ARITY 2] : PUT, 
   [COORD @D113228, PAST @D113227, 
      AGR [CASE @D113226, COUNT @D113225, PER @D113224, PLU @D113223, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ASIDE, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113234, PAST @D113233, AGR [CASE @D113232, COUNT @D113231, 
            PER @D113230, PLU @D113229, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASIDE, FIN -, ARITY 2] : PUT, 
   [COORD @D113240, PAST @D113239, 
      AGR [CASE @D113238, COUNT @D113237, PER @D113236, PLU @D113235, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AHEAD, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113246, PAST @D113245, AGR [CASE @D113244, COUNT @D113243, 
            PER @D113242, PLU @D113241, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AHEAD, FIN -, ARITY 2] : PUT, 
   [COORD @D113252, PAST @D113251, 
      AGR [CASE @D113250, COUNT @D113249, PER @D113248, PLU @D113247, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ACROSS, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113258, PAST @D113257, AGR [CASE @D113256, COUNT @D113255, 
            PER @D113254, PLU @D113253, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ACROSS, FIN -, ARITY 2] : PUT, 
   [COORD @D113264, PAST @D113263, 
      AGR [CASE @D113262, COUNT @D113261, PER @D113260, PLU @D113259, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ABOUT, FIN -, 
      ARITY 2] : PUT, 
   [COORD @D113270, PAST @D113269, AGR [CASE @D113268, COUNT @D113267, 
            PER @D113266, PLU @D113265, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ABOUT, FIN -, ARITY 2] : PUT, 
   [COORD @D113274, 
      AGR [COUNT @D113273, PER @D113272, PLU @D113271, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : PUT, 
   [COORD @D113278, AGR [COUNT @D113277, PER @D113276, PLU @D113275, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PRT UP, PAST +, ARITY 2] : PUT, 
   [COORD @D113282, 
      AGR [COUNT @D113281, PER @D113280, PLU @D113279, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PRT OFF, 
      PAST +, ARITY 2] : PUT, 
   [COORD @D113286, AGR [COUNT @D113285, PER @D113284, PLU @D113283, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PRT IN, PAST +, ARITY 2] : PUT, 
   [COORD @D113288, AGR @D113287, FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, SUBCAT SFIN, REG -, 
      PRT ABOUT, PAST +, ARITY 2] : PUT, 
   [COORD @D113292, AGR [COUNT @D113291, PER @D113290, PLU @D113289, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM WITH, PAST +, ARITY 2] : PUT, 
   [COORD @D113296, 
      AGR [COUNT @D113295, PER @D113294, PLU @D113293, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM UPON, 
      PAST +, ARITY 2] : PUT, 
   [COORD @D113300, AGR [COUNT @D113299, PER @D113298, PLU @D113297, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OVER, PFORM TO, PAST +, ARITY 2] : PUT, 
   [COORD @D113304, 
      AGR [COUNT @D113303, PER @D113302, PLU @D113301, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM TO, PAST +, ARITY 2] : PUT, 
   [COORD @D113308, AGR [COUNT @D113307, PER @D113306, PLU @D113305, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, PAST +, ARITY 2] : PUT, 
   [COORD @D113312, AGR [COUNT @D113311, PER @D113310, PLU @D113309, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM INTO, PAST +, ARITY 2] : PUT, 
   [COORD @D113316, AGR [COUNT @D113315, PER @D113314, PLU @D113313, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM FOR, PAST +, ARITY 2] : PUT, 
   [COORD @D113320, 
      AGR [COUNT @D113319, PER @D113318, PLU @D113317, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, PAST +, ARITY 2] : PUT, 
   [COORD @D113324, AGR [COUNT @D113323, PER @D113322, PLU @D113321, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM FOR, PAST +, ARITY 2] : PUT, 
   [COORD @D113328, AGR 
         [COUNT @D113327, PER @D113326, PLU @D113325, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM AT, PAST +, ARITY 2] : PUT, 
   [COORD @D113332, AGR [COUNT @D113331, PER @D113330, PLU @D113329, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : PUT, 
   [COORD @D113336, AGR [COUNT @D113335, PER @D113334, PLU @D113333, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT TOGETHER, PAST +, ARITY 2] : PUT, 
   [COORD @D113340, AGR [COUNT @D113339, PER @D113338, PLU @D113337, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT TO, PAST +, ARITY 2] : PUT, 
   [COORD @D113344, AGR [COUNT @D113343, PER @D113342, PLU @D113341, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT THROUGH, PAST +, ARITY 2] : PUT, 
   [COORD @D113348, AGR [COUNT @D113347, PER @D113346, PLU @D113345, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PAST +, ARITY 2] : PUT, 
   [COORD @D113352, AGR [COUNT @D113351, PER @D113350, PLU @D113349, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : PUT, 
   [COORD @D113356, AGR [COUNT @D113355, PER @D113354, PLU @D113353, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PAST +, ARITY 2] : PUT, 
   [COORD @D113360, AGR [COUNT @D113359, PER @D113358, PLU @D113357, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : PUT, 
   [COORD @D113364, AGR [COUNT @D113363, PER @D113362, PLU @D113361, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT IN, PAST +, ARITY 2] : PUT, 
   [COORD @D113368, AGR [COUNT @D113367, PER @D113366, PLU @D113365, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT FORWARD, PAST +, ARITY 2] : PUT, 
   [COORD @D113372, AGR [COUNT @D113371, PER @D113370, PLU @D113369, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT FORTH, PAST +, ARITY 2] : PUT, 
   [COORD @D113376, AGR [COUNT @D113375, PER @D113374, PLU @D113373, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : PUT, 
   [COORD @D113380, AGR [COUNT @D113379, PER @D113378, PLU @D113377, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BY, PAST +, ARITY 2] : PUT, 
   [COORD @D113384, AGR [COUNT @D113383, PER @D113382, PLU @D113381, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PAST +, ARITY 2] : PUT, 
   [COORD @D113388, AGR [COUNT @D113387, PER @D113386, PLU @D113385, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT AWAY, PAST +, ARITY 2] : PUT, 
   [COORD @D113392, AGR [COUNT @D113391, PER @D113390, PLU @D113389, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ASIDE, PAST +, ARITY 2] : PUT, 
   [COORD @D113396, AGR [COUNT @D113395, PER @D113394, PLU @D113393, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT AHEAD, PAST +, ARITY 2] : PUT, 
   [COORD @D113400, AGR [COUNT @D113399, PER @D113398, PLU @D113397, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ACROSS, PAST +, ARITY 2] : PUT, 
   [COORD @D113404, AGR [COUNT @D113403, PER @D113402, PLU @D113401, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ABOUT, PAST +, ARITY 2] : PUT, 
   [COORD @D113407, AGR [COUNT @D113406, PER @D113405, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : PUT, 
   [COORD @D113409, AGR [COUNT @D113408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : PUT, 
   [COORD @D113411, AGR [COUNT @D113410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : PUT, 
   [COORD @D113415, AGR [COUNT @D113414, PER @D113413, PLU @D113412, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : PUT, 
   [COORD @D113421, PAST @D113420, 
      AGR [CASE @D113419, COUNT @D113418, PER @D113417, PLU @D113416, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : PUT, 
   [COORD @D113424, AGR [COUNT @D113423, PER @D113422, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : PUT, 
   [COORD @D113426, AGR [COUNT @D113425, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : PUT, 
   [COORD @D113428, AGR [COUNT @D113427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : PUT, 
   [COORD @D113432, AGR [COUNT @D113431, PER @D113430, PLU @D113429, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, ARITY 1] : PUT, 
   [COORD @D113438, PAST @D113437, 
      AGR [CASE @D113436, COUNT @D113435, PER @D113434, PLU @D113433, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, ARITY 1] : PUT, 
   [COORD @D113441, AGR [COUNT @D113440, PER @D113439, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : PUT, 
   [COORD @D113443, AGR [COUNT @D113442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : PUT, 
   [COORD @D113445, AGR [COUNT @D113444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : PUT, 
   [COORD @D113449, AGR [COUNT @D113448, PER @D113447, PLU @D113446, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, ARITY 1] : PUT, 
   [COORD @D113455, PAST @D113454, 
      AGR [CASE @D113453, COUNT @D113452, PER @D113451, PLU @D113450, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, ARITY 1] : PUT, 
   [COORD @D113458, AGR [COUNT @D113457, PER @D113456, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : PUT, 
   [COORD @D113460, AGR [COUNT @D113459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : PUT, 
   [COORD @D113462, AGR [COUNT @D113461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : PUT, 
   [COORD @D113466, AGR [COUNT @D113465, PER @D113464, PLU @D113463, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : PUT, 
   [COORD @D113472, PAST @D113471, 
      AGR [CASE @D113470, COUNT @D113469, PER @D113468, PLU @D113467, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, ARITY 1] : PUT, 
   [COORD @D113475, AGR [COUNT @D113474, PER @D113473, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : PUT, 
   [COORD @D113477, AGR [COUNT @D113476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : PUT, 
   [COORD @D113479, AGR [COUNT @D113478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : PUT, 
   [COORD @D113483, AGR [COUNT @D113482, PER @D113481, PLU @D113480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : PUT, 
   [COORD @D113489, PAST @D113488, 
      AGR [CASE @D113487, COUNT @D113486, PER @D113485, PLU @D113484, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, ARITY 1] : PUT, 
   [COORD @D113492, AGR [COUNT @D113491, PER @D113490, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : PUT, 
   [COORD @D113494, AGR [COUNT @D113493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : PUT, 
   [COORD @D113496, AGR [COUNT @D113495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : PUT, 
   [COORD @D113500, AGR [COUNT @D113499, PER @D113498, PLU @D113497, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : PUT, 
   [COORD @D113506, PAST @D113505, 
      AGR [CASE @D113504, COUNT @D113503, PER @D113502, PLU @D113501, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : PUT, 
   [COORD @D113509, AGR [COUNT @D113508, PER @D113507, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : PUT, 
   [COORD @D113511, AGR [COUNT @D113510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : PUT, 
   [COORD @D113513, AGR [COUNT @D113512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : PUT, 
   [COORD @D113517, AGR [COUNT @D113516, PER @D113515, PLU @D113514, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : PUT, 
   [COORD @D113523, PAST @D113522, 
      AGR [CASE @D113521, COUNT @D113520, PER @D113519, PLU @D113518, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, ARITY 1] : PUT, 
   [COORD @D113526, AGR [COUNT @D113525, PER @D113524, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : PUT, 
   [COORD @D113528, AGR [COUNT @D113527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : PUT, 
   [COORD @D113530, AGR [COUNT @D113529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : PUT, 
   [COORD @D113534, AGR [COUNT @D113533, PER @D113532, PLU @D113531, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : PUT, 
   [COORD @D113540, PAST @D113539, 
      AGR [CASE @D113538, COUNT @D113537, PER @D113536, PLU @D113535, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : PUT, 
   [COORD @D113543, AGR [COUNT @D113542, PER @D113541, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : PUT, 
   [COORD @D113545, AGR [COUNT @D113544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : PUT, 
   [COORD @D113547, AGR [COUNT @D113546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : PUT, 
   [COORD @D113551, AGR [COUNT @D113550, PER @D113549, PLU @D113548, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : PUT, 
   [COORD @D113557, PAST @D113556, 
      AGR [CASE @D113555, COUNT @D113554, PER @D113553, PLU @D113552, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : PUT, 
   [COORD @D113560, AGR [COUNT @D113559, PER @D113558, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORWARD, ARITY 1] : PUT, 
   [COORD @D113562, AGR [COUNT @D113561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORWARD, ARITY 1] : PUT, 
   [COORD @D113564, AGR [COUNT @D113563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORWARD, ARITY 1] : PUT, 
   [COORD @D113568, AGR [COUNT @D113567, PER @D113566, PLU @D113565, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORWARD, ARITY 1] : PUT, 
   [COORD @D113574, PAST @D113573, 
      AGR [CASE @D113572, COUNT @D113571, PER @D113570, PLU @D113569, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORWARD, ARITY 1] : PUT, 
   [COORD @D113577, AGR [COUNT @D113576, PER @D113575, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : PUT, 
   [COORD @D113579, AGR [COUNT @D113578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : PUT, 
   [COORD @D113581, AGR [COUNT @D113580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : PUT, 
   [COORD @D113585, AGR [COUNT @D113584, PER @D113583, PLU @D113582, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORTH, ARITY 1] : PUT, 
   [COORD @D113591, PAST @D113590, 
      AGR [CASE @D113589, COUNT @D113588, PER @D113587, PLU @D113586, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORTH, ARITY 1] : PUT, 
   [COORD @D113594, AGR [COUNT @D113593, PER @D113592, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : PUT, 
   [COORD @D113596, AGR [COUNT @D113595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : PUT, 
   [COORD @D113598, AGR [COUNT @D113597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : PUT, 
   [COORD @D113602, AGR [COUNT @D113601, PER @D113600, PLU @D113599, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : PUT, 
   [COORD @D113608, PAST @D113607, 
      AGR [CASE @D113606, COUNT @D113605, PER @D113604, PLU @D113603, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : PUT, 
   [COORD @D113611, AGR [COUNT @D113610, PER @D113609, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : PUT, 
   [COORD @D113613, AGR [COUNT @D113612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : PUT, 
   [COORD @D113615, AGR [COUNT @D113614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : PUT, 
   [COORD @D113619, AGR [COUNT @D113618, PER @D113617, PLU @D113616, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, ARITY 1] : PUT, 
   [COORD @D113625, PAST @D113624, 
      AGR [CASE @D113623, COUNT @D113622, PER @D113621, PLU @D113620, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, ARITY 1] : PUT, 
   [COORD @D113628, AGR [COUNT @D113627, PER @D113626, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : PUT, 
   [COORD @D113630, AGR [COUNT @D113629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : PUT, 
   [COORD @D113632, AGR [COUNT @D113631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : PUT, 
   [COORD @D113636, AGR [COUNT @D113635, PER @D113634, PLU @D113633, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : PUT, 
   [COORD @D113642, PAST @D113641, 
      AGR [CASE @D113640, COUNT @D113639, PER @D113638, PLU @D113637, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, ARITY 1] : PUT, 
   [COORD @D113645, AGR [COUNT @D113644, PER @D113643, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : PUT, 
   [COORD @D113647, AGR [COUNT @D113646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : PUT, 
   [COORD @D113649, AGR [COUNT @D113648, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : PUT, 
   [COORD @D113653, AGR [COUNT @D113652, PER @D113651, PLU @D113650, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : PUT, 
   [COORD @D113659, PAST @D113658, 
      AGR [CASE @D113657, COUNT @D113656, PER @D113655, PLU @D113654, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, ARITY 1] : PUT, 
   [COORD @D113662, AGR [COUNT @D113661, PER @D113660, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : PUT, 
   [COORD @D113664, AGR [COUNT @D113663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : PUT, 
   [COORD @D113666, AGR [COUNT @D113665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : PUT, 
   [COORD @D113670, AGR [COUNT @D113669, PER @D113668, PLU @D113667, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASIDE, ARITY 1] : PUT, 
   [COORD @D113676, PAST @D113675, 
      AGR [CASE @D113674, COUNT @D113673, PER @D113672, PLU @D113671, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ASIDE, ARITY 1] : PUT, 
   [COORD @D113679, AGR [COUNT @D113678, PER @D113677, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AHEAD, ARITY 1] : PUT, 
   [COORD @D113681, AGR [COUNT @D113680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AHEAD, ARITY 1] : PUT, 
   [COORD @D113683, AGR [COUNT @D113682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AHEAD, ARITY 1] : PUT, 
   [COORD @D113687, AGR [COUNT @D113686, PER @D113685, PLU @D113684, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AHEAD, ARITY 1] : PUT, 
   [COORD @D113693, PAST @D113692, 
      AGR [CASE @D113691, COUNT @D113690, PER @D113689, PLU @D113688, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AHEAD, ARITY 1] : PUT, 
   [COORD @D113696, AGR [COUNT @D113695, PER @D113694, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ACROSS, ARITY 1] : PUT, 
   [COORD @D113698, AGR [COUNT @D113697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ACROSS, ARITY 1] : PUT, 
   [COORD @D113700, AGR [COUNT @D113699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ACROSS, ARITY 1] : PUT, 
   [COORD @D113704, AGR [COUNT @D113703, PER @D113702, PLU @D113701, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ACROSS, ARITY 1] : PUT, 
   [COORD @D113710, PAST @D113709, 
      AGR [CASE @D113708, COUNT @D113707, PER @D113706, PLU @D113705, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ACROSS, ARITY 1] : PUT, 
   [COORD @D113713, AGR [COUNT @D113712, PER @D113711, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : PUT, 
   [COORD @D113715, AGR [COUNT @D113714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : PUT, 
   [COORD @D113717, AGR [COUNT @D113716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : PUT, 
   [COORD @D113721, AGR [COUNT @D113720, PER @D113719, PLU @D113718, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : PUT, 
   [COORD @D113727, PAST @D113726, 
      AGR [CASE @D113725, COUNT @D113724, PER @D113723, PLU @D113722, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, ARITY 1] : PUT, 
   [COORD @D113733, PAST @D113732, AGR [CASE @D113731, COUNT @D113730, 
            PER @D113729, PLU @D113728, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : PUT, 
   [COORD @D113739, PAST @D113738, 
      AGR [CASE @D113737, COUNT @D113736, PER @D113735, PLU @D113734, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TOGETHER, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113745, PAST @D113744, AGR [CASE @D113743, COUNT @D113742, 
            PER @D113741, PLU @D113740, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, FIN -, ARITY 1] : PUT, 
   [COORD @D113751, PAST @D113750, 
      AGR [CASE @D113749, COUNT @D113748, PER @D113747, PLU @D113746, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT THROUGH, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113757, PAST @D113756, AGR [CASE @D113755, COUNT @D113754, 
            PER @D113753, PLU @D113752, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, FIN -, ARITY 1] : PUT, 
   [COORD @D113763, PAST @D113762, 
      AGR [CASE @D113761, COUNT @D113760, PER @D113759, PLU @D113758, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113769, PAST @D113768, AGR [CASE @D113767, COUNT @D113766, 
            PER @D113765, PLU @D113764, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : PUT, 
   [COORD @D113775, PAST @D113774, 
      AGR [CASE @D113773, COUNT @D113772, PER @D113771, PLU @D113770, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113781, PAST @D113780, AGR [CASE @D113779, COUNT @D113778, 
            PER @D113777, PLU @D113776, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : PUT, 
   [COORD @D113787, PAST @D113786, 
      AGR [CASE @D113785, COUNT @D113784, PER @D113783, PLU @D113782, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FORWARD, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113793, PAST @D113792, AGR [CASE @D113791, COUNT @D113790, 
            PER @D113789, PLU @D113788, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORTH, FIN -, ARITY 1] : PUT, 
   [COORD @D113799, PAST @D113798, 
      AGR [CASE @D113797, COUNT @D113796, PER @D113795, PLU @D113794, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113805, PAST @D113804, AGR [CASE @D113803, COUNT @D113802, 
            PER @D113801, PLU @D113800, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, FIN -, ARITY 1] : PUT, 
   [COORD @D113811, PAST @D113810, 
      AGR [CASE @D113809, COUNT @D113808, PER @D113807, PLU @D113806, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113817, PAST @D113816, AGR [CASE @D113815, COUNT @D113814, 
            PER @D113813, PLU @D113812, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, FIN -, ARITY 1] : PUT, 
   [COORD @D113823, PAST @D113822, 
      AGR [CASE @D113821, COUNT @D113820, PER @D113819, PLU @D113818, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ASIDE, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113829, PAST @D113828, AGR [CASE @D113827, COUNT @D113826, 
            PER @D113825, PLU @D113824, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AHEAD, FIN -, ARITY 1] : PUT, 
   [COORD @D113835, PAST @D113834, 
      AGR [CASE @D113833, COUNT @D113832, PER @D113831, PLU @D113830, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ACROSS, 
      FIN -, ARITY 1] : PUT, 
   [COORD @D113841, PAST @D113840, AGR [CASE @D113839, COUNT @D113838, 
            PER @D113837, PLU @D113836, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, FIN -, ARITY 1] : PUT, 
   [COORD @D113845, 
      AGR [COUNT @D113844, PER @D113843, PLU @D113842, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : PUT, 
   [COORD @D113849, AGR [COUNT @D113848, PER @D113847, PLU @D113846, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, PAST +, ARITY 1] : PUT, 
   [COORD @D113853, 
      AGR [COUNT @D113852, PER @D113851, PLU @D113850, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, PAST +, ARITY 1] : PUT, 
   [COORD @D113857, AGR [COUNT @D113856, PER @D113855, PLU @D113854, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, PAST +, ARITY 1] : PUT, 
   [COORD @D113861, 
      AGR [COUNT @D113860, PER @D113859, PLU @D113858, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : PUT, 
   [COORD @D113865, AGR [COUNT @D113864, PER @D113863, PLU @D113862, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, PAST +, ARITY 1] : PUT, 
   [COORD @D113869, 
      AGR [COUNT @D113868, PER @D113867, PLU @D113866, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, PAST +, ARITY 1] : PUT, 
   [COORD @D113873, AGR [COUNT @D113872, PER @D113871, PLU @D113870, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : PUT, 
   [COORD @D113877, 
      AGR [COUNT @D113876, PER @D113875, PLU @D113874, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : PUT, 
   [COORD @D113881, AGR [COUNT @D113880, PER @D113879, PLU @D113878, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORWARD, PAST +, ARITY 1] : PUT, 
   [COORD @D113885, 
      AGR [COUNT @D113884, PER @D113883, PLU @D113882, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORTH, PAST +, ARITY 1] : PUT, 
   [COORD @D113889, AGR [COUNT @D113888, PER @D113887, PLU @D113886, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, PAST +, ARITY 1] : PUT, 
   [COORD @D113893, 
      AGR [COUNT @D113892, PER @D113891, PLU @D113890, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, PAST +, ARITY 1] : PUT, 
   [COORD @D113897, AGR [COUNT @D113896, PER @D113895, PLU @D113894, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, PAST +, ARITY 1] : PUT, 
   [COORD @D113901, 
      AGR [COUNT @D113900, PER @D113899, PLU @D113898, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, PAST +, ARITY 1] : PUT, 
   [COORD @D113905, AGR [COUNT @D113904, PER @D113903, PLU @D113902, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASIDE, PAST +, ARITY 1] : PUT, 
   [COORD @D113909, 
      AGR [COUNT @D113908, PER @D113907, PLU @D113906, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AHEAD, PAST +, ARITY 1] : PUT, 
   [COORD @D113913, AGR [COUNT @D113912, PER @D113911, PLU @D113910, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ACROSS, PAST +, ARITY 1] : PUT, 
   [COORD @D113917, 
      AGR [COUNT @D113916, PER @D113915, PLU @D113914, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, PAST +, ARITY 1] : PUT.

WORD puts : 
   [COORD @D113927, DEMON @D113926, REFL @D113925, PRD @D113924, 
      CASE @D113923, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   PUT, 
   [COORD @D113929, AGR [COUNT @D113928, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D113931, AGR [COUNT @D113930, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D113933, AGR [COUNT @D113932, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D113935, AGR [COUNT @D113934, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, PRT DOWN, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113937, AGR [COUNT @D113936, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113939, AGR [COUNT @D113938, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113941, AGR [COUNT @D113940, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113943, AGR [COUNT @D113942, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM THROUGH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113945, AGR [COUNT @D113944, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113947, AGR [COUNT @D113946, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113949, AGR [COUNT @D113948, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OVER, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113951, AGR [COUNT @D113950, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM OFF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113953, AGR [COUNT @D113952, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113955, AGR [COUNT @D113954, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113957, AGR [COUNT @D113956, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113959, AGR [COUNT @D113958, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT DOWN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113961, AGR [COUNT @D113960, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113963, AGR [COUNT @D113962, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT DOWN, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113965, AGR [COUNT @D113964, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113967, AGR [COUNT @D113966, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM UNTIL, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113969, AGR [COUNT @D113968, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM UNTIL, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113971, AGR [COUNT @D113970, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113973, AGR [COUNT @D113972, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113975, AGR [COUNT @D113974, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM TILL, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113977, AGR [COUNT @D113976, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TILL, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113979, AGR [COUNT @D113978, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113981, AGR [COUNT @D113980, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D113983, AGR [COUNT @D113982, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUT, 
   [COORD @D113985, 
      AGR [COUNT @D113984, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUT, 
   [COORD @D113987, 
      AGR [COUNT @D113986, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUT, 
   [COORD @D113989, 
      AGR [COUNT @D113988, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUT, 
   [COORD @D113993, 
      AGR [CASE @D113992, NFORM @D113991, COUNT @D113990, PLU -, PER 3, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EXTRAP, 
      CONJ NULL, SUBCAT SFIN, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D113998, AGR [UB @D113997, VFORM @D113996, SUBJ @D113995, 
            FIN @D113994, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT SFIN, PRT ABOUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114000, AGR [COUNT @D113999, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114002, AGR [COUNT @D114001, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114004, AGR [COUNT @D114003, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114006, AGR [COUNT @D114005, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114008, AGR [COUNT @D114007, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114010, AGR [COUNT @D114009, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114012, AGR [COUNT @D114011, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114014, AGR [COUNT @D114013, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114016, AGR [COUNT @D114015, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114018, AGR [COUNT @D114017, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114020, AGR [COUNT @D114019, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114022, AGR [COUNT @D114021, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114024, AGR [COUNT @D114023, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114026, AGR [COUNT @D114025, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114028, AGR [COUNT @D114027, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114030, AGR [COUNT @D114029, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114032, AGR [COUNT @D114031, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114034, AGR [COUNT @D114033, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114036, AGR [COUNT @D114035, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114038, AGR [COUNT @D114037, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT FORWARD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114040, AGR [COUNT @D114039, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114042, AGR [COUNT @D114041, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114044, AGR [COUNT @D114043, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114046, AGR [COUNT @D114045, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114048, AGR [COUNT @D114047, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114050, AGR [COUNT @D114049, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114052, AGR [COUNT @D114051, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AHEAD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114054, AGR [COUNT @D114053, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ACROSS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114056, AGR [COUNT @D114055, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114058, AGR [COUNT @D114057, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D114060, AGR [COUNT @D114059, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114062, AGR [COUNT @D114061, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D114064, AGR [COUNT @D114063, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114066, AGR [COUNT @D114065, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114068, AGR [COUNT @D114067, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114070, AGR [COUNT @D114069, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D114072, AGR [COUNT @D114071, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114074, AGR [COUNT @D114073, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D114076, AGR [COUNT @D114075, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT FORWARD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114078, AGR [COUNT @D114077, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114080, AGR [COUNT @D114079, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114082, AGR [COUNT @D114081, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   PUT, 
   [COORD @D114084, AGR [COUNT @D114083, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114086, AGR [COUNT @D114085, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114088, AGR [COUNT @D114087, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114090, AGR [COUNT @D114089, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114092, AGR [COUNT @D114091, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ACROSS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114094, AGR [COUNT @D114093, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : PUT.

WORD putt : 
   [COORD @D114102, AGR [COUNT @D114101, PER @D114100, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUTT, 
   [COORD @D114104, AGR [COUNT @D114103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUTT, 
   [COORD @D114106, AGR [COUNT @D114105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : PUTT, 
   [COORD @D114110, AGR [COUNT @D114109, PER @D114108, PLU @D114107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : PUTT, 
   [COORD @D114116, PAST @D114115, AGR [CASE @D114114, COUNT @D114113, 
            PER @D114112, PLU @D114111, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : PUTT, 
   [COORD @D114119, AGR [COUNT @D114118, PER @D114117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUTT, 
   [COORD @D114121, AGR [COUNT @D114120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUTT, 
   [COORD @D114123, AGR [COUNT @D114122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUTT, 
   [COORD @D114127, AGR [COUNT @D114126, PER @D114125, PLU @D114124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : PUTT, 
   [COORD @D114133, PAST @D114132, AGR [CASE @D114131, COUNT @D114130, 
            PER @D114129, PLU @D114128, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : PUTT.

WORD putted : 
   [COORD @D114144, AGR [CASE @D114143, COUNT @D114142, PER @D114141, 
            PLU @D114140, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUTT, 
   [COORD @D114149, AGR [CASE @D114148, COUNT @D114147, PER @D114146, 
            PLU @D114145, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUTT, 
   [COORD @D114154, AGR [CASE @D114153, COUNT @D114152, PER @D114151, 
            PLU @D114150, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUTT, 
   [COORD @D114159, AGR [CASE @D114158, COUNT @D114157, PER @D114156, 
            PLU @D114155, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUTT, 
   [COORD @D114164, AGR [CASE @D114163, COUNT @D114162, PER @D114161, 
            PLU @D114160, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : PUTT.

WORD putting : 
   [COORD @D114184, PRD @D114183, AGR [CASE @D114182, COUNT @D114181, 
            PER @D114180, PLU @D114179, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUTT, 
   [COORD @D114190, PRD @D114189, 
      AGR [CASE @D114188, COUNT @D114187, PER @D114186, PLU @D114185, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUTT, 
   [COORD @D114196, PRD @D114195, AGR [CASE @D114194, COUNT @D114193, 
            PER @D114192, PLU @D114191, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114202, PRD @D114201, 
      AGR [CASE @D114200, COUNT @D114199, PER @D114198, PLU @D114197, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114208, PRD @D114207, AGR [CASE @D114206, COUNT @D114205, 
            PER @D114204, PLU @D114203, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114214, PRD @D114213, 
      AGR [CASE @D114212, COUNT @D114211, PER @D114210, PLU @D114209, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, PRT DOWN, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114220, PRD @D114219, AGR [CASE @D114218, COUNT @D114217, 
            PER @D114216, PLU @D114215, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114226, PRD @D114225, 
      AGR [CASE @D114224, COUNT @D114223, PER @D114222, PLU @D114221, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114232, PRD @D114231, AGR [CASE @D114230, COUNT @D114229, 
            PER @D114228, PLU @D114227, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PRT DOWN, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   
   [COORD @D114238, PRD @D114237, AGR [CASE @D114236, COUNT @D114235, PER 
               @D114234, PLU @D114233, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114244, PRD @D114243, 
      AGR [CASE @D114242, COUNT @D114241, PER @D114240, PLU @D114239, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114250, PRD @D114249, AGR [CASE @D114248, COUNT @D114247, 
            PER @D114246, PLU @D114245, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114256, PRD @D114255, 
      AGR [CASE @D114254, COUNT @D114253, PER @D114252, PLU @D114251, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OVER, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114262, PRD @D114261, AGR [CASE @D114260, COUNT @D114259, 
            PER @D114258, PLU @D114257, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM OFF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114268, PRD @D114267, 
      AGR [CASE @D114266, COUNT @D114265, PER @D114264, PLU @D114263, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114274, PRD @D114273, AGR [CASE @D114272, COUNT @D114271, 
            PER @D114270, PLU @D114269, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114280, PRD @D114279, 
      AGR [CASE @D114278, COUNT @D114277, PER @D114276, PLU @D114275, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114286, PRD @D114285, AGR [CASE @D114284, COUNT @D114283, 
            PER @D114282, PLU @D114281, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PRT DOWN, PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   
   [COORD @D114292, PRD @D114291, AGR [CASE @D114290, COUNT @D114289, PER 
               @D114288, PLU @D114287, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114298, PRD @D114297, 
      AGR [CASE @D114296, COUNT @D114295, PER @D114294, PLU @D114293, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT DOWN, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114304, PRD @D114303, AGR [CASE @D114302, COUNT @D114301, 
            PER @D114300, PLU @D114299, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114310, PRD @D114309, 
      AGR [CASE @D114308, COUNT @D114307, PER @D114306, PLU @D114305, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM UNTIL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114316, PRD @D114315, 
      AGR [CASE @D114314, COUNT @D114313, PER @D114312, PLU @D114311, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM UNTIL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114322, PRD @D114321, 
      AGR [CASE @D114320, COUNT @D114319, PER @D114318, PLU @D114317, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114328, PRD @D114327, 
      AGR [CASE @D114326, COUNT @D114325, PER @D114324, PLU @D114323, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114334, PRD @D114333, 
      AGR [CASE @D114332, COUNT @D114331, PER @D114330, PLU @D114329, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM TILL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114340, PRD @D114339, 
      AGR [CASE @D114338, COUNT @D114337, PER @D114336, PLU @D114335, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT BACK, PFORM TILL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114346, PRD @D114345, 
      AGR [CASE @D114344, COUNT @D114343, PER @D114342, PLU @D114341, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114352, PRD @D114351, AGR [CASE @D114350, COUNT @D114349, 
            PER @D114348, PLU @D114347, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114358, PRD @D114357, 
      AGR [CASE @D114356, COUNT @D114355, PER @D114354, PLU @D114353, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUT, 
   [COORD @D114364, PRD @D114363, AGR [CASE @D114362, COUNT @D114361, 
            PER @D114360, PLU @D114359, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114370, PRD @D114369, 
      AGR [CASE @D114368, COUNT @D114367, PER @D114366, PLU @D114365, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114376, PRD @D114375, AGR [CASE @D114374, COUNT @D114373, 
            PER @D114372, PLU @D114371, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114379, AGR @D114378, PRD @D114377, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT SFIN, PRT ABOUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114385, PRD @D114384, AGR [CASE @D114383, COUNT @D114382, 
            PER @D114381, PLU @D114380, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114391, PRD @D114390, 
      AGR [CASE @D114389, COUNT @D114388, PER @D114387, PLU @D114386, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114397, PRD @D114396, AGR [CASE @D114395, COUNT @D114394, 
            PER @D114393, PLU @D114392, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114403, PRD @D114402, 
      AGR [CASE @D114401, COUNT @D114400, PER @D114399, PLU @D114398, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114409, PRD @D114408, AGR [CASE @D114407, COUNT @D114406, 
            PER @D114405, PLU @D114404, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114415, PRD @D114414, 
      AGR [CASE @D114413, COUNT @D114412, PER @D114411, PLU @D114410, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114421, PRD @D114420, AGR [CASE @D114419, COUNT @D114418, 
            PER @D114417, PLU @D114416, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114427, PRD @D114426, 
      AGR [CASE @D114425, COUNT @D114424, PER @D114423, PLU @D114422, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114433, PRD @D114432, AGR [CASE @D114431, COUNT @D114430, 
            PER @D114429, PLU @D114428, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114439, PRD @D114438, 
      AGR [CASE @D114437, COUNT @D114436, PER @D114435, PLU @D114434, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114445, PRD @D114444, AGR [CASE @D114443, COUNT @D114442, 
            PER @D114441, PLU @D114440, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114451, PRD @D114450, 
      AGR [CASE @D114449, COUNT @D114448, PER @D114447, PLU @D114446, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114457, PRD @D114456, AGR [CASE @D114455, COUNT @D114454, 
            PER @D114453, PLU @D114452, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114463, PRD @D114462, 
      AGR [CASE @D114461, COUNT @D114460, PER @D114459, PLU @D114458, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114469, PRD @D114468, AGR [CASE @D114467, COUNT @D114466, 
            PER @D114465, PLU @D114464, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114475, PRD @D114474, 
      AGR [CASE @D114473, COUNT @D114472, PER @D114471, PLU @D114470, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUT, 
   [COORD @D114481, PRD @D114480, AGR [CASE @D114479, COUNT @D114478, 
            PER @D114477, PLU @D114476, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114487, PRD @D114486, 
      AGR [CASE @D114485, COUNT @D114484, PER @D114483, PLU @D114482, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUT, 
   [COORD @D114493, PRD @D114492, AGR [CASE @D114491, COUNT @D114490, 
            PER @D114489, PLU @D114488, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114499, PRD @D114498, 
      AGR [CASE @D114497, COUNT @D114496, PER @D114495, PLU @D114494, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT FORWARD, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114505, PRD @D114504, AGR [CASE @D114503, COUNT @D114502, 
            PER @D114501, PLU @D114500, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT FORTH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114511, PRD @D114510, 
      AGR [CASE @D114509, COUNT @D114508, PER @D114507, PLU @D114506, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUT, 
   [COORD @D114517, PRD @D114516, AGR [CASE @D114515, COUNT @D114514, 
            PER @D114513, PLU @D114512, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114523, PRD @D114522, 
      AGR [CASE @D114521, COUNT @D114520, PER @D114519, PLU @D114518, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUT, 
   [COORD @D114529, PRD @D114528, AGR [CASE @D114527, COUNT @D114526, 
            PER @D114525, PLU @D114524, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114535, PRD @D114534, 
      AGR [CASE @D114533, COUNT @D114532, PER @D114531, PLU @D114530, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : PUT, 
   [COORD @D114541, PRD @D114540, AGR [CASE @D114539, COUNT @D114538, 
            PER @D114537, PLU @D114536, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AHEAD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114547, PRD @D114546, 
      AGR [CASE @D114545, COUNT @D114544, PER @D114543, PLU @D114542, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ACROSS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : PUT, 
   [COORD @D114553, PRD @D114552, AGR [CASE @D114551, COUNT @D114550, 
            PER @D114549, PLU @D114548, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114559, PRD @D114558, 
      AGR [CASE @D114557, COUNT @D114556, PER @D114555, PLU @D114554, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114565, PRD @D114564, AGR [CASE @D114563, COUNT @D114562, 
            PER @D114561, PLU @D114560, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114571, PRD @D114570, 
      AGR [CASE @D114569, COUNT @D114568, PER @D114567, PLU @D114566, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114577, PRD @D114576, AGR [CASE @D114575, COUNT @D114574, 
            PER @D114573, PLU @D114572, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114583, PRD @D114582, 
      AGR [CASE @D114581, COUNT @D114580, PER @D114579, PLU @D114578, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114589, PRD @D114588, AGR [CASE @D114587, COUNT @D114586, 
            PER @D114585, PLU @D114584, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114595, PRD @D114594, 
      AGR [CASE @D114593, COUNT @D114592, PER @D114591, PLU @D114590, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114601, PRD @D114600, AGR [CASE @D114599, COUNT @D114598, 
            PER @D114597, PLU @D114596, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114607, PRD @D114606, 
      AGR [CASE @D114605, COUNT @D114604, PER @D114603, PLU @D114602, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114613, PRD @D114612, AGR [CASE @D114611, COUNT @D114610, 
            PER @D114609, PLU @D114608, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT FORWARD, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114619, PRD @D114618, 
      AGR [CASE @D114617, COUNT @D114616, PER @D114615, PLU @D114614, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114625, PRD @D114624, AGR [CASE @D114623, COUNT @D114622, 
            PER @D114621, PLU @D114620, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114631, PRD @D114630, 
      AGR [CASE @D114629, COUNT @D114628, PER @D114627, PLU @D114626, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114637, PRD @D114636, AGR [CASE @D114635, COUNT @D114634, 
            PER @D114633, PLU @D114632, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114643, PRD @D114642, 
      AGR [CASE @D114641, COUNT @D114640, PER @D114639, PLU @D114638, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114649, PRD @D114648, AGR [CASE @D114647, COUNT @D114646, 
            PER @D114645, PLU @D114644, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ASIDE, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114655, PRD @D114654, 
      AGR [CASE @D114653, COUNT @D114652, PER @D114651, PLU @D114650, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AHEAD, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT, 
   [COORD @D114661, PRD @D114660, AGR [CASE @D114659, COUNT @D114658, 
            PER @D114657, PLU @D114656, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT ACROSS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : PUT, 
   [COORD @D114667, PRD @D114666, 
      AGR [CASE @D114665, COUNT @D114664, PER @D114663, PLU @D114662, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : PUT.

WORD putts : 
   [COORD @D114675, AGR [COUNT @D114674, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUTT, 
   [COORD @D114677, 
      AGR [COUNT @D114676, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : PUTT.

WORD question : 
   [COORD @D114683, REFL @D114682, PRD @D114681, CASE @D114680, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : QUESTION, 
   [COORD @D114686, 
      AGR [COUNT @D114685, PER @D114684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ABOUT, 
      ARITY 3] : QUESTION, 
   [COORD @D114688, AGR [COUNT @D114687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : QUESTION, 
   [COORD @D114690, AGR [COUNT @D114689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : QUESTION, 
   [COORD @D114694, AGR [COUNT @D114693, PER @D114692, PLU @D114691, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ABOUT, ARITY 3] : QUESTION, 
   [COORD @D114700, PAST @D114699, 
      AGR [CASE @D114698, COUNT @D114697, PER @D114696, PLU @D114695, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ABOUT, ARITY 3] : QUESTION, 
   [COORD @D114703, AGR [COUNT @D114702, PER @D114701, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : QUESTION, 
   [COORD @D114705, AGR [COUNT @D114704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : QUESTION, 
   [COORD @D114707, AGR [COUNT @D114706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : QUESTION, 
   [COORD @D114711, AGR [COUNT @D114710, PER @D114709, PLU @D114708, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : QUESTION, 
   [COORD @D114717, PAST @D114716, AGR [CASE @D114715, COUNT @D114714, 
            PER @D114713, PLU @D114712, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : QUESTION, 
   [COORD @D114720, AGR [COUNT @D114719, PER @D114718, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : QUESTION, 
   [COORD @D114722, AGR [COUNT @D114721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : QUESTION, 
   [COORD @D114724, AGR [COUNT @D114723, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : QUESTION, 
   [COORD @D114728, AGR [COUNT @D114727, PER @D114726, PLU @D114725, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : QUESTION, 
   [COORD @D114734, PAST @D114733, AGR [CASE @D114732, COUNT @D114731, 
            PER @D114730, PLU @D114729, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : QUESTION.

WORD questioned : 
   [COORD @D114743, AGR [CASE @D114742, COUNT @D114741, PER @D114740, 
            PLU @D114739, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : QUESTION, 
   [COORD @D114748, AGR [CASE @D114747, COUNT @D114746, PER @D114745, 
            PLU @D114744, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : QUESTION, 
   [COORD @D114753, AGR 
         [CASE @D114752, COUNT @D114751, PER @D114750, PLU @D114749, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : QUESTION, 
   [COORD @D114758, AGR [CASE @D114757, COUNT @D114756, PER @D114755, 
            PLU @D114754, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : QUESTION, 
   [COORD @D114763, AGR [CASE @D114762, COUNT @D114761, PER @D114760, 
            PLU @D114759, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : QUESTION, 
   [COORD @D114768, AGR [CASE @D114767, COUNT @D114766, PER @D114765, 
            PLU @D114764, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : QUESTION, 
   [COORD @D114773, AGR [CASE @D114772, COUNT @D114771, PER @D114770, 
            PLU @D114769, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : QUESTION, 
   [COORD @D114778, AGR [CASE @D114777, COUNT @D114776, PER @D114775, 
            PLU @D114774, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : QUESTION.

WORD questioning : 
   [COORD @D114792, PRD @D114791, AGR [CASE @D114790, COUNT @D114789, 
            PER @D114788, PLU @D114787, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : QUESTION, 
   [COORD @D114798, PRD @D114797, 
      AGR [CASE @D114796, COUNT @D114795, PER @D114794, PLU @D114793, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : QUESTION, 
   [COORD @D114804, PRD @D114803, AGR [CASE @D114802, COUNT @D114801, 
            PER @D114800, PLU @D114799, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : QUESTION.

WORD questions : 
   [COORD @D114813, DEMON @D114812, REFL @D114811, PRD @D114810, 
      CASE @D114809, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   QUESTION, 
   [COORD @D114815, AGR [COUNT @D114814, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : QUESTION, 
   [COORD @D114817, AGR [COUNT @D114816, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : QUESTION, 
   
   [COORD @D114819, AGR [COUNT @D114818, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : QUESTION.

WORD quote : 
   [COORD @D114825, AGR [COUNT @D114824, PER @D114823, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : QUOTE, 
   [COORD @D114827, AGR [COUNT @D114826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : QUOTE, 
   [COORD @D114829, AGR [COUNT @D114828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : QUOTE, 
   [COORD @D114833, AGR [COUNT @D114832, PER @D114831, PLU @D114830, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : QUOTE, 
   [COORD @D114839, PAST @D114838, AGR [CASE @D114837, COUNT @D114836, 
            PER @D114835, PLU @D114834, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : QUOTE, 
   [COORD @D114842, AGR [COUNT @D114841, PER @D114840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : QUOTE, 
   [COORD @D114844, AGR [COUNT @D114843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : QUOTE, 
   [COORD @D114846, AGR [COUNT @D114845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : QUOTE, 
   [COORD @D114850, AGR [COUNT @D114849, PER @D114848, PLU @D114847, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : QUOTE, 
   [COORD @D114856, PAST @D114855, 
      AGR [CASE @D114854, COUNT @D114853, PER @D114852, PLU @D114851, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : QUOTE, 
   [COORD @D114859, AGR [COUNT @D114858, PER @D114857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : QUOTE, 
   [COORD @D114861, AGR [COUNT @D114860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : QUOTE, 
   [COORD @D114863, AGR [COUNT @D114862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : QUOTE, 
   [COORD @D114867, AGR [COUNT @D114866, PER @D114865, PLU @D114864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : QUOTE, 
   [COORD @D114873, PAST @D114872, AGR [CASE @D114871, COUNT @D114870, 
            PER @D114869, PLU @D114868, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : QUOTE, 
   [COORD @D114876, AGR [COUNT @D114875, PER @D114874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : QUOTE, 
   [COORD @D114878, AGR [COUNT @D114877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : QUOTE, 
   [COORD @D114880, AGR [COUNT @D114879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : QUOTE, 
   [COORD @D114884, AGR [COUNT @D114883, PER @D114882, PLU @D114881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : QUOTE, 
   [COORD @D114890, PAST @D114889, 
      AGR [CASE @D114888, COUNT @D114887, PER @D114886, PLU @D114885, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : QUOTE, 
   [COORD @D114893, AGR [COUNT @D114892, PER @D114891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : QUOTE, 
   [COORD @D114895, AGR [COUNT @D114894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : QUOTE, 
   [COORD @D114897, AGR [COUNT @D114896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : QUOTE, 
   [COORD @D114901, AGR [COUNT @D114900, PER @D114899, PLU @D114898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : QUOTE, 
   [COORD @D114907, PAST @D114906, AGR [CASE @D114905, COUNT @D114904, 
            PER @D114903, PLU @D114902, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : QUOTE.

WORD quoted : 
   [COORD @D114916, AGR [CASE @D114915, COUNT @D114914, PER @D114913, 
            PLU @D114912, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : QUOTE, 
   [COORD @D114921, AGR [CASE @D114920, COUNT @D114919, PER @D114918, 
            PLU @D114917, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114926, AGR [CASE @D114925, COUNT @D114924, PER @D114923, 
            PLU @D114922, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114931, AGR [CASE @D114930, COUNT @D114929, PER @D114928, 
            PLU @D114927, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114936, AGR [CASE @D114935, COUNT @D114934, PER @D114933, 
            PLU @D114932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114941, AGR [CASE @D114940, COUNT @D114939, PER @D114938, 
            PLU @D114937, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114946, AGR [CASE @D114945, COUNT @D114944, PER @D114943, 
            PLU @D114942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114951, AGR [CASE @D114950, COUNT @D114949, PER @D114948, 
            PLU @D114947, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114956, AGR [CASE @D114955, COUNT @D114954, PER @D114953, 
            PLU @D114952, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : QUOTE, 
   [COORD @D114961, AGR [CASE @D114960, COUNT @D114959, PER @D114958, 
            PLU @D114957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114966, AGR [CASE @D114965, COUNT @D114964, PER @D114963, 
            PLU @D114962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114971, AGR [CASE @D114970, COUNT @D114969, PER @D114968, 
            PLU @D114967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114976, AGR [CASE @D114975, COUNT @D114974, PER @D114973, 
            PLU @D114972, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : QUOTE.

WORD quotes : 
   [COORD @D114982, AGR [COUNT @D114981, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114984, 
      AGR [COUNT @D114983, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114986, 
      AGR [COUNT @D114985, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114988, 
      AGR [COUNT @D114987, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : QUOTE, 
   [COORD @D114990, 
      AGR [COUNT @D114989, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : QUOTE.

WORD quoting : 
   [COORD @D114999, PRD @D114998, AGR [CASE @D114997, COUNT @D114996, 
            PER @D114995, PLU @D114994, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D115005, PRD @D115004, 
      AGR [CASE @D115003, COUNT @D115002, PER @D115001, PLU @D115000, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : QUOTE, 
   [COORD @D115011, PRD @D115010, AGR [CASE @D115009, COUNT @D115008, 
            PER @D115007, PLU @D115006, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : QUOTE, 
   [COORD @D115017, PRD @D115016, 
      AGR [CASE @D115015, COUNT @D115014, PER @D115013, PLU @D115012, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : QUOTE, 
   [COORD @D115023, PRD @D115022, AGR [CASE @D115021, COUNT @D115020, 
            PER @D115019, PLU @D115018, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : QUOTE.

WORD raise : 
   [COORD @D115031, REFL @D115030, PRD @D115029, CASE @D115028, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RAISE, 
   [COORD @D115034, 
      AGR [COUNT @D115033, PER @D115032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : RAISE, 
   [COORD @D115036, AGR [COUNT @D115035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RAISE, 
   [COORD @D115038, AGR [COUNT @D115037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RAISE, 
   [COORD @D115042, AGR [COUNT @D115041, PER @D115040, PLU @D115039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RAISE, 
   [COORD @D115048, PAST @D115047, 
      AGR [CASE @D115046, COUNT @D115045, PER @D115044, PLU @D115043, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : RAISE, 
   [COORD @D115051, AGR [COUNT @D115050, PER @D115049, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RAISE, 
   [COORD @D115053, AGR [COUNT @D115052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RAISE, 
   [COORD @D115055, AGR [COUNT @D115054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RAISE, 
   [COORD @D115059, AGR [COUNT @D115058, PER @D115057, PLU @D115056, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RAISE, 
   [COORD @D115065, PAST @D115064, AGR [CASE @D115063, COUNT @D115062, 
            PER @D115061, PLU @D115060, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RAISE.

WORD raised : 
   [COORD @D115076, AGR [CASE @D115075, COUNT @D115074, PER @D115073, 
            PLU @D115072, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RAISE, 
   [COORD @D115081, AGR [CASE @D115080, COUNT @D115079, PER @D115078, 
            PLU @D115077, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RAISE, 
   [COORD @D115086, AGR [CASE @D115085, COUNT @D115084, PER @D115083, 
            PLU @D115082, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RAISE, 
   [COORD @D115091, AGR [CASE @D115090, COUNT @D115089, PER @D115088, 
            PLU @D115087, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RAISE, 
   [COORD @D115096, AGR [CASE @D115095, COUNT @D115094, PER @D115093, 
            PLU @D115092, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RAISE, 
   [COORD @D115101, AGR [CASE @D115100, COUNT @D115099, PER @D115098, 
            PLU @D115097, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RAISE.

WORD raises : 
   [COORD @D115112, DEMON @D115111, REFL @D115110, PRD @D115109, 
      CASE @D115108, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RAISE, 
   [COORD @D115114, AGR [COUNT @D115113, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RAISE, 
   [COORD @D115116, AGR [COUNT @D115115, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RAISE.

WORD raising : 
   [COORD @D115126, PRD @D115125, AGR [CASE @D115124, COUNT @D115123, 
            PER @D115122, PLU @D115121, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RAISE, 
   [COORD @D115132, PRD @D115131, 
      AGR [CASE @D115130, COUNT @D115129, PER @D115128, PLU @D115127, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RAISE.

WORD reach : 
   [COORD @D115137, AGR [COUNT @D115136, PER @D115135, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM FOR, ARITY 3] : REACH, 
   [COORD @D115139, 
      AGR [COUNT @D115138, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM FOR, ARITY 3] : REACH, 
   [COORD @D115141, AGR [COUNT @D115140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM FOR, ARITY 3] : REACH, 
   [COORD @D115145, 
      AGR [COUNT @D115144, PER @D115143, PLU @D115142, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM FOR, ARITY 3] : REACH, 
   [COORD @D115151, PAST @D115150, 
      AGR [CASE @D115149, COUNT @D115148, PER @D115147, PLU @D115146, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM FOR, ARITY 3] : REACH, 
   [COORD @D115154, AGR [COUNT @D115153, PER @D115152, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REACH, 
   [COORD @D115156, AGR [COUNT @D115155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REACH, 
   [COORD @D115158, AGR [COUNT @D115157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REACH, 
   [COORD @D115162, AGR [COUNT @D115161, PER @D115160, PLU @D115159, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REACH, 
   [COORD @D115168, PAST @D115167, AGR [CASE @D115166, COUNT @D115165, 
            PER @D115164, PLU @D115163, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REACH, 
   [COORD @D115171, AGR [COUNT @D115170, PER @D115169, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : REACH, 
   [COORD @D115173, AGR [COUNT @D115172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : REACH, 
   [COORD @D115175, AGR [COUNT @D115174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : REACH, 
   [COORD @D115179, AGR [COUNT @D115178, PER @D115177, PLU @D115176, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : REACH, 
   [COORD @D115185, PAST @D115184, AGR [CASE @D115183, COUNT @D115182, 
            PER @D115181, PLU @D115180, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : REACH, 
   [COORD @D115188, AGR [COUNT @D115187, PER @D115186, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : REACH, 
   [COORD @D115190, AGR [COUNT @D115189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : REACH, 
   [COORD @D115192, AGR [COUNT @D115191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : REACH, 
   [COORD @D115196, AGR [COUNT @D115195, PER @D115194, PLU @D115193, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : REACH, 
   [COORD @D115202, PAST @D115201, 
      AGR [CASE @D115200, COUNT @D115199, PER @D115198, PLU @D115197, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : REACH, 
   [COORD @D115205, AGR [COUNT @D115204, PER @D115203, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : REACH, 
   [COORD @D115207, AGR [COUNT @D115206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : REACH, 
   [COORD @D115209, AGR [COUNT @D115208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : REACH, 
   [COORD @D115213, AGR [COUNT @D115212, PER @D115211, PLU @D115210, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : REACH, 
   [COORD @D115219, PAST @D115218, 
      AGR [CASE @D115217, COUNT @D115216, PER @D115215, PLU @D115214, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : REACH, 
   [COORD @D115222, AGR [COUNT @D115221, PER @D115220, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REACH, 
   [COORD @D115224, AGR [COUNT @D115223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REACH, 
   [COORD @D115226, AGR [COUNT @D115225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REACH, 
   [COORD @D115230, AGR [COUNT @D115229, PER @D115228, PLU @D115227, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REACH, 
   [COORD @D115236, PAST @D115235, AGR [CASE @D115234, COUNT @D115233, 
            PER @D115232, PLU @D115231, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REACH, 
   [COORD @D115239, AGR [COUNT @D115238, PER @D115237, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : REACH, 
   [COORD @D115241, AGR [COUNT @D115240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : REACH, 
   [COORD @D115243, AGR [COUNT @D115242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : REACH, 
   [COORD @D115247, AGR [COUNT @D115246, PER @D115245, PLU @D115244, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : REACH, 
   [COORD @D115253, PAST @D115252, 
      AGR [CASE @D115251, COUNT @D115250, PER @D115249, PLU @D115248, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : REACH, 
   [COORD @D115256, AGR [COUNT @D115255, PER @D115254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : REACH, 
   [COORD @D115258, AGR [COUNT @D115257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : REACH, 
   [COORD @D115260, AGR [COUNT @D115259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : REACH, 
   [COORD @D115264, AGR [COUNT @D115263, PER @D115262, PLU @D115261, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : REACH, 
   [COORD @D115270, PAST @D115269, 
      AGR [CASE @D115268, COUNT @D115267, PER @D115266, PLU @D115265, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : REACH.

WORD reached : 
   [COORD @D115278, AGR [CASE @D115277, COUNT @D115276, PER @D115275, 
            PLU @D115274, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115283, AGR [CASE @D115282, COUNT @D115281, PER @D115280, 
            PLU @D115279, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115288, 
      AGR [CASE @D115287, COUNT @D115286, PER @D115285, PLU @D115284, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REACH, 
   [COORD @D115293, AGR [CASE @D115292, COUNT @D115291, PER @D115290, 
            PLU @D115289, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REACH, 
   [COORD @D115298, AGR [CASE @D115297, COUNT @D115296, PER @D115295, 
            PLU @D115294, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115303, AGR [CASE @D115302, COUNT @D115301, PER @D115300, 
            PLU @D115299, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REACH, 
   [COORD @D115308, AGR [CASE @D115307, COUNT @D115306, PER @D115305, 
            PLU @D115304, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115313, AGR [CASE @D115312, COUNT @D115311, PER @D115310, 
            PLU @D115309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REACH, 
   [COORD @D115318, AGR [CASE @D115317, COUNT @D115316, PER @D115315, 
            PLU @D115314, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115323, AGR [CASE @D115322, COUNT @D115321, PER @D115320, 
            PLU @D115319, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115328, AGR [CASE @D115327, COUNT @D115326, PER @D115325, 
            PLU @D115324, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REACH, 
   [COORD @D115333, AGR [CASE @D115332, COUNT @D115331, PER @D115330, 
            PLU @D115329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115338, AGR [CASE @D115337, COUNT @D115336, PER @D115335, 
            PLU @D115334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REACH, 
   [COORD @D115343, AGR [CASE @D115342, COUNT @D115341, PER @D115340, 
            PLU @D115339, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115348, AGR [CASE @D115347, COUNT @D115346, PER @D115345, 
            PLU @D115344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115353, AGR [CASE @D115352, COUNT @D115351, PER @D115350, 
            PLU @D115349, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REACH, 
   [COORD @D115358, AGR [CASE @D115357, COUNT @D115356, PER @D115355, 
            PLU @D115354, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115363, AGR [CASE @D115362, COUNT @D115361, PER @D115360, 
            PLU @D115359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REACH, 
   [COORD @D115368, AGR [CASE @D115367, COUNT @D115366, PER @D115365, 
            PLU @D115364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115373, AGR [CASE @D115372, COUNT @D115371, PER @D115370, 
            PLU @D115369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REACH.

WORD reaching : 
   [COORD @D115384, PRD @D115383, AGR [CASE @D115382, COUNT @D115381, 
            PER @D115380, PLU @D115379, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115390, PRD @D115389, 
      AGR [CASE @D115388, COUNT @D115387, PER @D115386, PLU @D115385, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REACH, 
   [COORD @D115396, PRD @D115395, AGR [CASE @D115394, COUNT @D115393, 
            PER @D115392, PLU @D115391, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115402, PRD @D115401, 
      AGR [CASE @D115400, COUNT @D115399, PER @D115398, PLU @D115397, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REACH, 
   [COORD @D115408, PRD @D115407, AGR [CASE @D115406, COUNT @D115405, 
            PER @D115404, PLU @D115403, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115414, PRD @D115413, 
      AGR [CASE @D115412, COUNT @D115411, PER @D115410, PLU @D115409, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REACH, 
   [COORD @D115420, PRD @D115419, AGR [CASE @D115418, COUNT @D115417, 
            PER @D115416, PLU @D115415, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REACH, 
   [COORD @D115426, PRD @D115425, 
      AGR [CASE @D115424, COUNT @D115423, PER @D115422, PLU @D115421, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REACH.

WORD read : 
   [COORD @D115435, REFL @D115434, PRD @D115433, CASE @D115432, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : READ, 
   [COORD @D115438, 
      AGR [COUNT @D115437, PER @D115436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   READ, 
   [COORD @D115440, AGR [COUNT @D115439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : READ, 
   [COORD @D115442, AGR [COUNT @D115441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : READ, 
   [COORD @D115446, AGR [COUNT @D115445, PER @D115444, PLU @D115443, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : READ, 
   [COORD @D115452, PAST @D115451, 
      AGR [CASE @D115450, COUNT @D115449, PER @D115448, PLU @D115447, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : READ, 
   [COORD @D115455, AGR [COUNT @D115454, PER @D115453, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT ALOUD, ARITY 3] : READ, 
   [COORD @D115457, AGR [COUNT @D115456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT ALOUD, ARITY 3] : READ, 
   [COORD @D115459, AGR [COUNT @D115458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT ALOUD, ARITY 3] : READ, 
   [COORD @D115463, AGR [COUNT @D115462, PER @D115461, PLU @D115460, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT ALOUD, ARITY 3] : READ, 
   [COORD @D115469, PAST @D115468, 
      AGR [CASE @D115467, COUNT @D115466, PER @D115465, PLU @D115464, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT ALOUD, ARITY 3] : READ, 
   [COORD @D115472, AGR [COUNT @D115471, PER @D115470, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : READ, 
   [COORD @D115474, AGR [COUNT @D115473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : READ, 
   [COORD @D115476, AGR [COUNT @D115475, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : READ, 
   [COORD @D115480, AGR [COUNT @D115479, PER @D115478, PLU @D115477, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : READ, 
   [COORD @D115486, PAST @D115485, 
      AGR [CASE @D115484, COUNT @D115483, PER @D115482, PLU @D115481, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : READ, 
   [COORD @D115489, AGR [COUNT @D115488, PER @D115487, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT ALOUD, PFORM TO, ARITY 3] : READ, 
   [COORD @D115491, AGR [COUNT @D115490, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT ALOUD, PFORM TO, ARITY 3] : READ, 
   [COORD @D115493, AGR [COUNT @D115492, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT ALOUD, PFORM TO, ARITY 3] : READ, 
   [COORD @D115497, AGR [COUNT @D115496, PER @D115495, PLU @D115494, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT ALOUD, PFORM TO, ARITY 3] : READ, 
   [COORD @D115503, PAST @D115502, 
      AGR [CASE @D115501, COUNT @D115500, PER @D115499, PLU @D115498, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PRT ALOUD, PFORM TO, ARITY 3] : READ, 
   [COORD @D115506, AGR [COUNT @D115505, PER @D115504, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : READ, 
   [COORD @D115508, AGR [COUNT @D115507, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : READ, 
   [COORD @D115510, AGR [COUNT @D115509, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : READ, 
   [COORD @D115514, AGR [COUNT @D115513, PER @D115512, PLU @D115511, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : READ, 
   [COORD @D115520, PAST @D115519, 
      AGR [CASE @D115518, COUNT @D115517, PER @D115516, PLU @D115515, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : READ, 
   [COORD @D115523, AGR [COUNT @D115522, PER @D115521, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AS, ARITY 3] : READ, 
   [COORD @D115525, AGR [COUNT @D115524, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AS, ARITY 3] : READ, 
   [COORD @D115527, AGR [COUNT @D115526, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AS, ARITY 3] : READ, 
   [COORD @D115531, AGR [COUNT @D115530, PER @D115529, PLU @D115528, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AS, ARITY 3] : READ, 
   [COORD @D115537, PAST @D115536, 
      AGR [CASE @D115535, COUNT @D115534, PER @D115533, PLU @D115532, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AS, ARITY 3] : READ, 
   [COORD @D115543, PAST @D115542, AGR 
         [CASE @D115541, COUNT @D115540, PER @D115539, PLU @D115538, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : READ, 
   [COORD @D115549, PAST @D115548, AGR [CASE @D115547, COUNT @D115546, 
            PER @D115545, PLU @D115544, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : READ, 
   [COORD @D115555, PAST @D115554, 
      AGR [CASE @D115553, COUNT @D115552, PER @D115551, PLU @D115550, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT ALOUD, 
      FIN -, ARITY 3] : READ, 
   [COORD @D115561, PAST @D115560, AGR [CASE @D115559, COUNT @D115558, 
            PER @D115557, PLU @D115556, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT ALOUD, FIN -, ARITY 3] : READ, 
   [COORD @D115567, PAST @D115566, 
      AGR [CASE @D115565, COUNT @D115564, PER @D115563, PLU @D115562, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : READ, 
   [COORD @D115573, PAST @D115572, AGR [CASE @D115571, COUNT @D115570, 
            PER @D115569, PLU @D115568, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : READ, 
   [COORD @D115579, PAST @D115578, 
      AGR [CASE @D115577, COUNT @D115576, PER @D115575, PLU @D115574, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT ALOUD, 
      PFORM TO, FIN -, ARITY 3] : READ, 
   [COORD @D115585, PAST @D115584, AGR 
         [CASE @D115583, COUNT @D115582, PER @D115581, PLU @D115580, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT ALOUD, 
      PFORM TO, FIN -, ARITY 3] : READ, 
   [COORD @D115591, PAST @D115590, AGR 
         [CASE @D115589, COUNT @D115588, PER @D115587, PLU @D115586, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, FIN -, 
      ARITY 3] : READ, 
   [COORD @D115597, PAST @D115596, AGR [CASE @D115595, COUNT @D115594, 
            PER @D115593, PLU @D115592, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : READ, 
   [COORD @D115603, PAST @D115602, 
      AGR [CASE @D115601, COUNT @D115600, PER @D115599, PLU @D115598, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM AS, 
      FIN -, ARITY 3] : READ, 
   [COORD @D115609, PAST @D115608, AGR [CASE @D115607, COUNT @D115606, 
            PER @D115605, PLU @D115604, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AS, FIN -, ARITY 3] : READ, 
   [COORD @D115613, 
      AGR [COUNT @D115612, PER @D115611, PLU @D115610, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PAST +, ARITY 3] : READ, 
   [COORD @D115617, AGR [COUNT @D115616, PER @D115615, PLU @D115614, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT ALOUD, PAST +, ARITY 3] : READ, 
   [COORD @D115621, 
      AGR [COUNT @D115620, PER @D115619, PLU @D115618, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : READ, 
   [COORD @D115625, AGR [COUNT @D115624, PER @D115623, PLU @D115622, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT ALOUD, PFORM TO, PAST +, ARITY 3] : READ, 
   [COORD @D115629, 
      AGR [COUNT @D115628, PER @D115627, PLU @D115626, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM INTO, PAST +, ARITY 3] : READ, 
   [COORD @D115633, AGR [COUNT @D115632, PER @D115631, PLU @D115630, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AS, PAST +, ARITY 3] : READ, 
   [COORD @D115636, 
      AGR [COUNT @D115635, PER @D115634, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   READ, 
   [COORD @D115638, AGR [COUNT @D115637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : READ, 
   [COORD @D115640, AGR [COUNT @D115639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : READ, 
   [COORD @D115644, AGR [COUNT @D115643, PER @D115642, PLU @D115641, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : READ, 
   [COORD @D115650, PAST @D115649, 
      AGR [CASE @D115648, COUNT @D115647, PER @D115646, PLU @D115645, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : READ, 
   [COORD @D115653, AGR [COUNT @D115652, PER @D115651, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : READ, 
   [COORD @D115655, AGR [COUNT @D115654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : READ, 
   [COORD @D115657, AGR [COUNT @D115656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : READ, 
   [COORD @D115661, AGR [COUNT @D115660, PER @D115659, PLU @D115658, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : READ, 
   [COORD @D115667, PAST @D115666, AGR [CASE @D115665, COUNT @D115664, 
            PER @D115663, PLU @D115662, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : READ, 
   [COORD @D115670, AGR [COUNT @D115669, PER @D115668, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : READ, 
   [COORD @D115672, AGR [COUNT @D115671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : READ, 
   [COORD @D115674, AGR [COUNT @D115673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : READ, 
   [COORD @D115678, AGR [COUNT @D115677, PER @D115676, PLU @D115675, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : READ, 
   [COORD @D115684, PAST @D115683, 
      AGR [CASE @D115682, COUNT @D115681, PER @D115680, PLU @D115679, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, 
      ARITY 2] : READ, 
   [COORD @D115687, AGR [COUNT @D115686, PER @D115685, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : READ, 
   [COORD @D115689, AGR [COUNT @D115688, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : READ, 
   [COORD @D115691, AGR [COUNT @D115690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : READ, 
   [COORD @D115695, AGR [COUNT @D115694, PER @D115693, PLU @D115692, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : READ, 
   [COORD @D115701, PAST @D115700, AGR 
         [CASE @D115699, COUNT @D115698, PER @D115697, PLU @D115696, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : READ, 
   [COORD @D115704, AGR [COUNT @D115703, PER @D115702, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALOUD, PFORM TO, ARITY 2] : READ, 
   [COORD @D115706, AGR [COUNT @D115705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALOUD, PFORM TO, ARITY 2] : READ, 
   [COORD @D115708, AGR [COUNT @D115707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALOUD, PFORM TO, ARITY 2] : READ, 
   [COORD @D115712, AGR [COUNT @D115711, PER @D115710, PLU @D115709, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT ALOUD, PFORM TO, ARITY 2] : READ, 
   [COORD @D115718, PAST @D115717, 
      AGR [CASE @D115716, COUNT @D115715, PER @D115714, PLU @D115713, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALOUD, PFORM TO, ARITY 2] : READ, 
   [COORD @D115721, AGR [COUNT @D115720, PER @D115719, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM ON, ARITY 2] : READ, 
   [COORD @D115723, AGR [COUNT @D115722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM ON, ARITY 2] : READ, 
   [COORD @D115725, AGR [COUNT @D115724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM ON, ARITY 2] : READ, 
   [COORD @D115729, AGR [COUNT @D115728, PER @D115727, PLU @D115726, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM ON, ARITY 2] : READ, 
   [COORD @D115735, PAST @D115734, 
      AGR [CASE @D115733, COUNT @D115732, PER @D115731, PLU @D115730, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM ON, ARITY 2] : READ, 
   [COORD @D115738, AGR [COUNT @D115737, PER @D115736, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : READ, 
   [COORD @D115740, AGR [COUNT @D115739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : READ, 
   [COORD @D115742, AGR [COUNT @D115741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : READ, 
   [COORD @D115746, AGR [COUNT @D115745, PER @D115744, PLU @D115743, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : READ, 
   [COORD @D115752, PAST @D115751, 
      AGR [CASE @D115750, COUNT @D115749, PER @D115748, PLU @D115747, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : READ, 
   [COORD @D115755, AGR [COUNT @D115754, PER @D115753, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : READ, 
   [COORD @D115757, AGR [COUNT @D115756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : READ, 
   [COORD @D115759, AGR [COUNT @D115758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : READ, 
   [COORD @D115763, AGR [COUNT @D115762, PER @D115761, PLU @D115760, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : READ, 
   [COORD @D115769, PAST @D115768, 
      AGR [CASE @D115767, COUNT @D115766, PER @D115765, PLU @D115764, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : READ, 
   [COORD @D115772, AGR [COUNT @D115771, PER @D115770, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : READ, 
   [COORD @D115774, AGR [COUNT @D115773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : READ, 
   [COORD @D115776, AGR [COUNT @D115775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : READ, 
   [COORD @D115780, AGR [COUNT @D115779, PER @D115778, PLU @D115777, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, ARITY 2] : READ, 
   [COORD @D115786, PAST @D115785, 
      AGR [CASE @D115784, COUNT @D115783, PER @D115782, PLU @D115781, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : READ, 
   [COORD @D115789, AGR [COUNT @D115788, PER @D115787, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : READ, 
   [COORD @D115791, AGR [COUNT @D115790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : READ, 
   [COORD @D115793, AGR [COUNT @D115792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : READ, 
   [COORD @D115797, AGR [COUNT @D115796, PER @D115795, PLU @D115794, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : READ, 
   [COORD @D115803, PAST @D115802, 
      AGR [CASE @D115801, COUNT @D115800, PER @D115799, PLU @D115798, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : READ, 
   [COORD @D115806, AGR [COUNT @D115805, PER @D115804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALOUD, ARITY 2] : READ, 
   [COORD @D115808, AGR [COUNT @D115807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALOUD, ARITY 2] : READ, 
   [COORD @D115810, AGR [COUNT @D115809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALOUD, ARITY 2] : READ, 
   [COORD @D115814, AGR [COUNT @D115813, PER @D115812, PLU @D115811, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ALOUD, ARITY 2] : READ, 
   [COORD @D115820, PAST @D115819, 
      AGR [CASE @D115818, COUNT @D115817, PER @D115816, PLU @D115815, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ALOUD, ARITY 2] : READ, 
   [COORD @D115826, PAST @D115825, AGR [CASE @D115824, COUNT @D115823, 
            PER @D115822, PLU @D115821, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, FIN -, ARITY 2] : READ, 
   [COORD @D115832, PAST @D115831, 
      AGR [CASE @D115830, COUNT @D115829, PER @D115828, PLU @D115827, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : READ, 
   [COORD @D115838, PAST @D115837, AGR [CASE @D115836, COUNT @D115835, 
            PER @D115834, PLU @D115833, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : READ, 
   [COORD @D115844, PAST @D115843, 
      AGR [CASE @D115842, COUNT @D115841, PER @D115840, PLU @D115839, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, FIN -, 
      ARITY 2] : READ, 
   [COORD @D115850, PAST @D115849, AGR [CASE @D115848, COUNT @D115847, 
            PER @D115846, PLU @D115845, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : READ, 
   [COORD @D115856, PAST @D115855, 
      AGR [CASE @D115854, COUNT @D115853, PER @D115852, PLU @D115851, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT ALOUD, 
      PFORM TO, FIN -, ARITY 2] : READ, 
   [COORD @D115862, PAST @D115861, AGR 
         [CASE @D115860, COUNT @D115859, PER @D115858, PLU @D115857, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM ON, FIN -, ARITY 2] : READ, 
   [COORD @D115868, PAST @D115867, AGR 
         [CASE @D115866, COUNT @D115865, PER @D115864, PLU @D115863, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM FOR, FIN -, 
      ARITY 2] : READ, 
   [COORD @D115874, PAST @D115873, AGR [CASE @D115872, COUNT @D115871, 
            PER @D115870, PLU @D115869, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM FOR, FIN -, ARITY 2] : READ, 
   [COORD @D115880, PAST @D115879, 
      AGR [CASE @D115878, COUNT @D115877, PER @D115876, PLU @D115875, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : READ, 
   [COORD @D115886, PAST @D115885, AGR [CASE @D115884, COUNT @D115883, 
            PER @D115882, PLU @D115881, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : READ, 
   [COORD @D115892, PAST @D115891, 
      AGR [CASE @D115890, COUNT @D115889, PER @D115888, PLU @D115887, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT THROUGH, FIN -, 
      ARITY 2] : READ, 
   [COORD @D115898, PAST @D115897, AGR [CASE @D115896, COUNT @D115895, 
            PER @D115894, PLU @D115893, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, FIN -, ARITY 2] : READ, 
   [COORD @D115904, PAST @D115903, 
      AGR [CASE @D115902, COUNT @D115901, PER @D115900, PLU @D115899, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : READ, 
   [COORD @D115910, PAST @D115909, AGR [CASE @D115908, COUNT @D115907, 
            PER @D115906, PLU @D115905, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : READ, 
   [COORD @D115916, PAST @D115915, 
      AGR [CASE @D115914, COUNT @D115913, PER @D115912, PLU @D115911, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ALOUD, FIN -, 
      ARITY 2] : READ, 
   [COORD @D115922, PAST @D115921, AGR [CASE @D115920, COUNT @D115919, 
            PER @D115918, PLU @D115917, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ALOUD, FIN -, ARITY 2] : READ, 
   [COORD @D115926, 
      AGR [COUNT @D115925, PER @D115924, PLU @D115923, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : READ, 
   [COORD @D115930, AGR [COUNT @D115929, PER @D115928, PLU @D115927, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : READ, 
   [COORD @D115934, AGR [COUNT @D115933, PER @D115932, PLU @D115931, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, PAST +, ARITY 2] : READ, 
   [COORD @D115938, AGR [COUNT @D115937, PER @D115936, PLU @D115935, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM TO, PAST +, ARITY 2] : READ, 
   [COORD @D115942, 
      AGR [COUNT @D115941, PER @D115940, PLU @D115939, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT ALOUD, PFORM TO, PAST +, ARITY 2] : READ, 
   [COORD @D115946, AGR [COUNT @D115945, PER @D115944, PLU @D115943, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM ON, PAST +, ARITY 2] : READ, 
   [COORD @D115950, 
      AGR [COUNT @D115949, PER @D115948, PLU @D115947, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, 
      PAST +, ARITY 2] : READ, 
   [COORD @D115954, AGR [COUNT @D115953, PER @D115952, PLU @D115951, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : READ, 
   [COORD @D115958, AGR [COUNT @D115957, PER @D115956, PLU @D115955, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT THROUGH, PAST +, ARITY 2] : READ, 
   [COORD @D115962, AGR [COUNT @D115961, PER @D115960, PLU @D115959, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : READ, 
   [COORD @D115966, AGR [COUNT @D115965, PER @D115964, PLU @D115963, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ALOUD, PAST +, ARITY 2] : READ, 
   [COORD @D115969, AGR [COUNT @D115968, PER @D115967, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : READ, 
   [COORD @D115971, AGR [COUNT @D115970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : READ, 
   [COORD @D115973, AGR [COUNT @D115972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : READ, 
   [COORD @D115977, AGR [COUNT @D115976, PER @D115975, PLU @D115974, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : READ, 
   [COORD @D115983, PAST @D115982, 
      AGR [CASE @D115981, COUNT @D115980, PER @D115979, PLU @D115978, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : READ, 
   [COORD @D115986, AGR [COUNT @D115985, PER @D115984, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : READ, 
   [COORD @D115988, AGR [COUNT @D115987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : READ, 
   [COORD @D115990, AGR [COUNT @D115989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : READ, 
   [COORD @D115994, AGR [COUNT @D115993, PER @D115992, PLU @D115991, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : READ, 
   [COORD @D116000, PAST @D115999, 
      AGR [CASE @D115998, COUNT @D115997, PER @D115996, PLU @D115995, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : READ, 
   [COORD @D116003, AGR [COUNT @D116002, PER @D116001, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : READ, 
   [COORD @D116005, AGR [COUNT @D116004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : READ, 
   [COORD @D116007, AGR [COUNT @D116006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : READ, 
   [COORD @D116011, AGR [COUNT @D116010, PER @D116009, PLU @D116008, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : READ, 
   [COORD @D116017, PAST @D116016, 
      AGR [CASE @D116015, COUNT @D116014, PER @D116013, PLU @D116012, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, ARITY 1] : READ, 
   [COORD @D116020, AGR [COUNT @D116019, PER @D116018, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : READ, 
   [COORD @D116022, AGR [COUNT @D116021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : READ, 
   [COORD @D116024, AGR [COUNT @D116023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : READ, 
   [COORD @D116028, AGR [COUNT @D116027, PER @D116026, PLU @D116025, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : READ, 
   [COORD @D116034, PAST @D116033, 
      AGR [CASE @D116032, COUNT @D116031, PER @D116030, PLU @D116029, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : READ, 
   [COORD @D116037, AGR [COUNT @D116036, PER @D116035, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALOUD, ARITY 1] : READ, 
   [COORD @D116039, AGR [COUNT @D116038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALOUD, ARITY 1] : READ, 
   [COORD @D116041, AGR [COUNT @D116040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALOUD, ARITY 1] : READ, 
   [COORD @D116045, AGR [COUNT @D116044, PER @D116043, PLU @D116042, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALOUD, ARITY 1] : READ, 
   [COORD @D116051, PAST @D116050, 
      AGR [CASE @D116049, COUNT @D116048, PER @D116047, PLU @D116046, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ALOUD, ARITY 1] : READ, 
   [COORD @D116057, PAST @D116056, AGR [CASE @D116055, COUNT @D116054, 
            PER @D116053, PLU @D116052, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : READ, 
   [COORD @D116063, PAST @D116062, 
      AGR [CASE @D116061, COUNT @D116060, PER @D116059, PLU @D116058, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      FIN -, ARITY 1] : READ, 
   [COORD @D116069, PAST @D116068, AGR [CASE @D116067, COUNT @D116066, 
            PER @D116065, PLU @D116064, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, FIN -, ARITY 1] : READ, 
   [COORD @D116075, PAST @D116074, 
      AGR [CASE @D116073, COUNT @D116072, PER @D116071, PLU @D116070, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : READ, 
   [COORD @D116081, PAST @D116080, AGR [CASE @D116079, COUNT @D116078, 
            PER @D116077, PLU @D116076, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALOUD, FIN -, ARITY 1] : READ, 
   [COORD @D116085, 
      AGR [COUNT @D116084, PER @D116083, PLU @D116082, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : READ, 
   [COORD @D116089, AGR [COUNT @D116088, PER @D116087, PLU @D116086, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : READ, 
   [COORD @D116093, 
      AGR [COUNT @D116092, PER @D116091, PLU @D116090, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, PAST +, ARITY 1] : READ, 
   [COORD @D116097, AGR [COUNT @D116096, PER @D116095, PLU @D116094, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, PAST +, ARITY 1] : READ, 
   [COORD @D116101, 
      AGR [COUNT @D116100, PER @D116099, PLU @D116098, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ALOUD, PAST +, ARITY 1] : READ.

WORD reading : 
   [COORD @D116111, REFL @D116110, PRD @D116109, CASE @D116108, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : READING, 
   [COORD @D116115, REFL @D116114, PRD @D116113, CASE @D116112, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : READING, 
   [COORD @D116120, REFL @D116119, COUNT @D116118, PRD @D116117, 
      CASE @D116116, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : READING, 
   [COORD @D116124, REFL @D116123, PRD @D116122, CASE @D116121, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : READING, 
   [COORD @D116130, PRD @D116129, 
      AGR [CASE @D116128, COUNT @D116127, PER @D116126, PLU @D116125, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116136, PRD @D116135, AGR [CASE @D116134, COUNT @D116133, 
            PER @D116132, PLU @D116131, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, 
      PRT ALOUD, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116142, PRD @D116141, 
      AGR [CASE @D116140, COUNT @D116139, PER @D116138, PLU @D116137, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116148, PRD @D116147, AGR [CASE @D116146, COUNT @D116145, 
            PER @D116144, PLU @D116143, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PRT ALOUD, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   READ, 
   [COORD @D116154, PRD @D116153, AGR [CASE @D116152, COUNT @D116151, 
            PER @D116150, PLU @D116149, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116160, PRD @D116159, 
      AGR [CASE @D116158, COUNT @D116157, PER @D116156, PLU @D116155, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116166, PRD @D116165, AGR [CASE @D116164, COUNT @D116163, 
            PER @D116162, PLU @D116161, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116172, PRD @D116171, 
      AGR [CASE @D116170, COUNT @D116169, PER @D116168, PLU @D116167, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : READ, 
   [COORD @D116178, PRD @D116177, AGR [CASE @D116176, COUNT @D116175, 
            PER @D116174, PLU @D116173, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116184, PRD @D116183, 
      AGR [CASE @D116182, COUNT @D116181, PER @D116180, PLU @D116179, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : READ, 
   [COORD @D116190, PRD @D116189, AGR [CASE @D116188, COUNT @D116187, 
            PER @D116186, PLU @D116185, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT ALOUD, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116196, PRD @D116195, 
      AGR [CASE @D116194, COUNT @D116193, PER @D116192, PLU @D116191, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116202, PRD @D116201, AGR [CASE @D116200, COUNT @D116199, 
            PER @D116198, PLU @D116197, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116208, PRD @D116207, 
      AGR [CASE @D116206, COUNT @D116205, PER @D116204, PLU @D116203, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : READ, 
   [COORD @D116214, PRD @D116213, AGR [CASE @D116212, COUNT @D116211, 
            PER @D116210, PLU @D116209, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116220, PRD @D116219, 
      AGR [CASE @D116218, COUNT @D116217, PER @D116216, PLU @D116215, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : READ, 
   [COORD @D116226, PRD @D116225, AGR [CASE @D116224, COUNT @D116223, 
            PER @D116222, PLU @D116221, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ALOUD, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116232, PRD @D116231, 
      AGR [CASE @D116230, COUNT @D116229, PER @D116228, PLU @D116227, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116238, PRD @D116237, AGR [CASE @D116236, COUNT @D116235, 
            PER @D116234, PLU @D116233, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116244, PRD @D116243, 
      AGR [CASE @D116242, COUNT @D116241, PER @D116240, PLU @D116239, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : READ, 
   [COORD @D116250, PRD @D116249, AGR [CASE @D116248, COUNT @D116247, 
            PER @D116246, PLU @D116245, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : READ, 
   [COORD @D116256, PRD @D116255, 
      AGR [CASE @D116254, COUNT @D116253, PER @D116252, PLU @D116251, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALOUD, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : READ.

WORD readings : 
   [COORD @D116269, DEMON @D116268, REFL @D116267, PRD @D116266, 
      CASE @D116265, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   READING, 
   [COORD @D116274, DEMON @D116273, REFL @D116272, PRD @D116271, 
      CASE @D116270, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   READING, 
   [COORD @D116279, DEMON @D116278, REFL @D116277, PRD @D116276, 
      CASE @D116275, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   READING, 
   [COORD @D116284, DEMON @D116283, REFL @D116282, PRD @D116281, 
      CASE @D116280, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   READING.

WORD reads : 
   [COORD @D116290, AGR [COUNT @D116289, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116292, 
      AGR [COUNT @D116291, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT ALOUD, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116294, 
      AGR [COUNT @D116293, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116296, 
      AGR [COUNT @D116295, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PRT ALOUD, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116298, AGR [COUNT @D116297, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116300, AGR [COUNT @D116299, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116302, AGR [COUNT @D116301, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116304, 
      AGR [COUNT @D116303, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116306, 
      AGR [COUNT @D116305, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116308, 
      AGR [COUNT @D116307, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116310, 
      AGR [COUNT @D116309, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT ALOUD, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   READ, 
   [COORD @D116312, AGR [COUNT @D116311, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116314, AGR [COUNT @D116313, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116316, AGR [COUNT @D116315, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116318, AGR [COUNT @D116317, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116320, AGR [COUNT @D116319, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116322, AGR [COUNT @D116321, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ALOUD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116324, AGR [COUNT @D116323, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116326, 
      AGR [COUNT @D116325, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : READ, 
   [COORD @D116328, 
      AGR [COUNT @D116327, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   READ, 
   [COORD @D116330, AGR [COUNT @D116329, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ, 
   [COORD @D116332, AGR [COUNT @D116331, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ALOUD, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : READ.

WORD realise : 
   [COORD @D116338, AGR [COUNT @D116337, PER @D116336, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : REALIZE, 
   [COORD @D116340, AGR [COUNT @D116339, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : REALIZE, 
   [COORD @D116342, AGR [COUNT @D116341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : REALIZE, 
   [COORD @D116346, AGR [COUNT @D116345, PER @D116344, PLU @D116343, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : REALIZE, 
   [COORD @D116352, PAST @D116351, AGR [CASE @D116350, COUNT @D116349, 
            PER @D116348, PLU @D116347, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : REALIZE, 
   [COORD @D116355, AGR [COUNT @D116354, PER @D116353, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REALIZE, 
   [COORD @D116357, AGR [COUNT @D116356, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REALIZE, 
   [COORD @D116359, AGR [COUNT @D116358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REALIZE, 
   [COORD @D116363, AGR [COUNT @D116362, PER @D116361, PLU @D116360, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REALIZE, 
   [COORD @D116369, PAST @D116368, AGR [CASE @D116367, COUNT @D116366, 
            PER @D116365, PLU @D116364, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : REALIZE, 
   [COORD @D116372, AGR [COUNT @D116371, PER @D116370, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REALIZE, 
   [COORD @D116374, AGR [COUNT @D116373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REALIZE, 
   [COORD @D116376, AGR [COUNT @D116375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REALIZE, 
   [COORD @D116380, AGR [COUNT @D116379, PER @D116378, PLU @D116377, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REALIZE, 
   [COORD @D116386, PAST @D116385, AGR [CASE @D116384, COUNT @D116383, 
            PER @D116382, PLU @D116381, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REALIZE.

WORD realised : 
   [COORD @D116395, AGR [CASE @D116394, COUNT @D116393, PER @D116392, 
            PLU @D116391, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116400, AGR [CASE @D116399, COUNT @D116398, PER @D116397, 
            PLU @D116396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116405, AGR [CASE @D116404, COUNT @D116403, PER @D116402, 
            PLU @D116401, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116410, AGR [CASE @D116409, COUNT @D116408, PER @D116407, 
            PLU @D116406, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116415, AGR [UB @D116414, VFORM @D116413, SUBJ @D116412, 
            FIN @D116411, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REALIZE, 
   [COORD @D116420, AGR [CASE @D116419, COUNT @D116418, PER @D116417, 
            PLU @D116416, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REALIZE, 
   [COORD @D116425, AGR [CASE @D116424, COUNT @D116423, PER @D116422, 
            PLU @D116421, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116430, AGR [CASE @D116429, COUNT @D116428, PER @D116427, 
            PLU @D116426, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REALIZE.

WORD realises : 
   [COORD @D116436, AGR [COUNT @D116435, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116438, 
      AGR [COUNT @D116437, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116440, 
      AGR [COUNT @D116439, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REALIZE.

WORD realising : 
   [COORD @D116449, PRD @D116448, AGR [CASE @D116447, COUNT @D116446, 
            PER @D116445, PLU @D116444, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REALIZE, 
   [COORD @D116455, PRD @D116454, 
      AGR [CASE @D116453, COUNT @D116452, PER @D116451, PLU @D116450, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REALIZE, 
   [COORD @D116461, PRD @D116460, AGR [CASE @D116459, COUNT @D116458, 
            PER @D116457, PLU @D116456, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REALIZE.

WORD rebel : 
   [COORD @D116467, REFL @D116466, PRD @D116465, CASE @D116464, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : REBEL, 
   [COORD @D116470, 
      AGR [COUNT @D116469, PER @D116468, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, 
      ARITY 2] : REBEL, 
   [COORD @D116472, AGR [COUNT @D116471, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : REBEL, 
   [COORD @D116474, AGR [COUNT @D116473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : REBEL, 
   [COORD @D116478, AGR [COUNT @D116477, PER @D116476, PLU @D116475, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : REBEL, 
   [COORD @D116484, PAST @D116483, 
      AGR [CASE @D116482, COUNT @D116481, PER @D116480, PLU @D116479, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : REBEL, 
   [COORD @D116487, AGR [COUNT @D116486, PER @D116485, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REBEL, 
   [COORD @D116489, AGR [COUNT @D116488, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REBEL, 
   [COORD @D116491, AGR [COUNT @D116490, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REBEL, 
   [COORD @D116495, AGR [COUNT @D116494, PER @D116493, PLU @D116492, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REBEL, 
   [COORD @D116501, PAST @D116500, AGR [CASE @D116499, COUNT @D116498, 
            PER @D116497, PLU @D116496, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REBEL.

WORD rebelled : 
   [COORD @D116514, AGR [CASE @D116513, COUNT @D116512, PER @D116511, 
            PLU @D116510, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REBEL, 
   [COORD @D116519, AGR [CASE @D116518, COUNT @D116517, PER @D116516, 
            PLU @D116515, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REBEL, 
   [COORD @D116524, AGR [CASE @D116523, COUNT @D116522, PER @D116521, 
            PLU @D116520, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REBEL, 
   [COORD @D116529, AGR [CASE @D116528, COUNT @D116527, PER @D116526, 
            PLU @D116525, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REBEL.

WORD rebelling : 
   [COORD @D116547, PRD @D116546, AGR [CASE @D116545, COUNT @D116544, 
            PER @D116543, PLU @D116542, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REBEL, 
   [COORD @D116553, PRD @D116552, 
      AGR [CASE @D116551, COUNT @D116550, PER @D116549, PLU @D116548, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REBEL.

WORD rebels : 
   [COORD @D116562, DEMON @D116561, REFL @D116560, PRD @D116559, 
      CASE @D116558, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REBEL, 
   [COORD @D116564, AGR [COUNT @D116563, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REBEL, 
   [COORD @D116566, AGR [COUNT @D116565, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REBEL.

WORD receive : 
   [COORD @D116572, AGR [COUNT @D116571, PER @D116570, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECEIVE, 
   [COORD @D116574, AGR [COUNT @D116573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECEIVE, 
   [COORD @D116576, AGR [COUNT @D116575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECEIVE, 
   [COORD @D116580, AGR [COUNT @D116579, PER @D116578, PLU @D116577, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RECEIVE, 
   [COORD @D116586, PAST @D116585, AGR [CASE @D116584, COUNT @D116583, 
            PER @D116582, PLU @D116581, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RECEIVE, 
   [COORD @D116589, AGR [COUNT @D116588, PER @D116587, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECEIVE, 
   [COORD @D116591, AGR [COUNT @D116590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECEIVE, 
   [COORD @D116593, AGR [COUNT @D116592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECEIVE, 
   [COORD @D116597, AGR [COUNT @D116596, PER @D116595, PLU @D116594, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECEIVE, 
   [COORD @D116603, PAST @D116602, AGR [CASE @D116601, COUNT @D116600, 
            PER @D116599, PLU @D116598, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : RECEIVE.

WORD received : 
   [COADV @D116615, COORD @D116614, DEF @D116613, PRD @D116612, 
      AGR [CASE @D116611, COUNT @D116610, PER @D116609, PLU @D116608, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : RECEIVED, 
   [COORD @D116620, AGR [CASE @D116619, COUNT @D116618, PER @D116617, 
            PLU @D116616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECEIVE, 
   [COORD @D116625, AGR [CASE @D116624, COUNT @D116623, PER @D116622, 
            PLU @D116621, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECEIVE, 
   [COORD @D116630, AGR [CASE @D116629, COUNT @D116628, PER @D116627, 
            PLU @D116626, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECEIVE, 
   [COORD @D116635, AGR [CASE @D116634, COUNT @D116633, PER @D116632, 
            PLU @D116631, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECEIVE, 
   [COORD @D116640, AGR [CASE @D116639, COUNT @D116638, PER @D116637, 
            PLU @D116636, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECEIVE.

WORD receives : 
   [COORD @D116646, AGR [COUNT @D116645, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RECEIVE, 
   [COORD @D116648, 
      AGR [COUNT @D116647, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RECEIVE.

WORD receiving : 
   [COORD @D116657, PRD @D116656, AGR [CASE @D116655, COUNT @D116654, 
            PER @D116653, PLU @D116652, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECEIVE, 
   [COORD @D116663, PRD @D116662, 
      AGR [CASE @D116661, COUNT @D116660, PER @D116659, PLU @D116658, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RECEIVE.

WORD recognise : 
   [COORD @D116669, AGR [COUNT @D116668, PER @D116667, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOGNIZE, 
   [COORD @D116671, AGR [COUNT @D116670, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOGNIZE, 
   [COORD @D116673, AGR [COUNT @D116672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOGNIZE, 
   [COORD @D116677, AGR [COUNT @D116676, PER @D116675, PLU @D116674, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOGNIZE, 
   [COORD @D116683, PAST @D116682, 
      AGR [CASE @D116681, COUNT @D116680, PER @D116679, PLU @D116678, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : RECOGNIZE, 
   [COORD @D116686, AGR [COUNT @D116685, PER @D116684, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOGNIZE, 
   [COORD @D116688, AGR [COUNT @D116687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOGNIZE, 
   [COORD @D116690, AGR [COUNT @D116689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOGNIZE, 
   [COORD @D116694, AGR [COUNT @D116693, PER @D116692, PLU @D116691, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOGNIZE, 
   [COORD @D116700, PAST @D116699, 
      AGR [CASE @D116698, COUNT @D116697, PER @D116696, PLU @D116695, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : RECOGNIZE, 
   [COORD @D116703, AGR [COUNT @D116702, PER @D116701, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RECOGNIZE, 
   [COORD @D116705, AGR [COUNT @D116704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RECOGNIZE, 
   [COORD @D116707, AGR [COUNT @D116706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RECOGNIZE, 
   [COORD @D116711, AGR [COUNT @D116710, PER @D116709, PLU @D116708, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RECOGNIZE, 
   [COORD @D116717, PAST @D116716, 
      AGR [CASE @D116715, COUNT @D116714, PER @D116713, PLU @D116712, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      ARITY 2] : RECOGNIZE, 
   [COORD @D116720, AGR [COUNT @D116719, PER @D116718, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECOGNIZE, 
   [COORD @D116722, AGR [COUNT @D116721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECOGNIZE, 
   [COORD @D116724, AGR [COUNT @D116723, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECOGNIZE, 
   [COORD @D116728, AGR [COUNT @D116727, PER @D116726, PLU @D116725, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RECOGNIZE, 
   [COORD @D116734, PAST @D116733, AGR [CASE @D116732, COUNT @D116731, 
            PER @D116730, PLU @D116729, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RECOGNIZE.

WORD recognised : 
   [COORD @D116743, AGR [CASE @D116742, COUNT @D116741, PER @D116740, 
            PLU @D116739, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116748, AGR [CASE @D116747, COUNT @D116746, PER @D116745, 
            PLU @D116744, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116754, AGR [CASE @D116753, NFORM @D116752, COUNT @D116751, 
            PER @D116750, PLU @D116749, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116759, AGR [CASE @D116758, COUNT @D116757, PER @D116756, 
            PLU @D116755, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116764, AGR [CASE @D116763, COUNT @D116762, PER @D116761, 
            PLU @D116760, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116769, 
      AGR [CASE @D116768, COUNT @D116767, PER @D116766, PLU @D116765, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116774, AGR [CASE @D116773, COUNT @D116772, PER @D116771, 
            PLU @D116770, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116779, AGR [CASE @D116778, COUNT @D116777, PER @D116776, 
            PLU @D116775, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116784, AGR [UB @D116783, VFORM @D116782, SUBJ @D116781, 
            FIN @D116780, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RECOGNIZE, 
   [COORD @D116789, AGR [CASE @D116788, COUNT @D116787, PER @D116786, 
            PLU @D116785, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116794, AGR [CASE @D116793, COUNT @D116792, PER @D116791, 
            PLU @D116790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116799, AGR [CASE @D116798, COUNT @D116797, PER @D116796, 
            PLU @D116795, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOGNIZE.

WORD recognises : 
   [COORD @D116805, AGR [COUNT @D116804, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RECOGNIZE, 
   [COORD @D116807, AGR [COUNT @D116806, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RECOGNIZE, 
   [COORD @D116809, AGR [COUNT @D116808, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RECOGNIZE, 
   [COORD @D116811, AGR [COUNT @D116810, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RECOGNIZE.

WORD recognising : 
   [COORD @D116820, PRD @D116819, AGR [CASE @D116818, COUNT @D116817, 
            PER @D116816, PLU @D116815, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116826, PRD @D116825, 
      AGR [CASE @D116824, COUNT @D116823, PER @D116822, PLU @D116821, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RECOGNIZE, 
   [COORD @D116832, PRD @D116831, AGR [CASE @D116830, COUNT @D116829, 
            PER @D116828, PLU @D116827, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOGNIZE, 
   [COORD @D116838, PRD @D116837, 
      AGR [CASE @D116836, COUNT @D116835, PER @D116834, PLU @D116833, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RECOGNIZE.

WORD recommend : 
   [COORD @D116843, AGR [COUNT @D116842, PER @D116841, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOMMEND, 
   [COORD @D116845, AGR [COUNT @D116844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOMMEND, 
   [COORD @D116847, AGR [COUNT @D116846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOMMEND, 
   [COORD @D116851, AGR [COUNT @D116850, PER @D116849, PLU @D116848, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : RECOMMEND, 
   [COORD @D116857, PAST @D116856, 
      AGR [CASE @D116855, COUNT @D116854, PER @D116853, PLU @D116852, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : RECOMMEND, 
   [COORD @D116860, AGR [COUNT @D116859, PER @D116858, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RECOMMEND, 
   [COORD @D116862, AGR [COUNT @D116861, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RECOMMEND, 
   [COORD @D116864, AGR [COUNT @D116863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RECOMMEND, 
   [COORD @D116868, AGR [COUNT @D116867, PER @D116866, PLU @D116865, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RECOMMEND, 
   [COORD @D116874, PAST @D116873, 
      AGR [CASE @D116872, COUNT @D116871, PER @D116870, PLU @D116869, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      ARITY 3] : RECOMMEND, 
   [COORD @D116877, AGR [COUNT @D116876, PER @D116875, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RECOMMEND, 
   [COORD @D116879, AGR [COUNT @D116878, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RECOMMEND, 
   [COORD @D116881, AGR [COUNT @D116880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RECOMMEND, 
   [COORD @D116885, AGR [COUNT @D116884, PER @D116883, PLU @D116882, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RECOMMEND, 
   [COORD @D116891, PAST @D116890, 
      AGR [CASE @D116889, COUNT @D116888, PER @D116887, PLU @D116886, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : RECOMMEND, 
   [COORD @D116894, AGR [COUNT @D116893, PER @D116892, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RECOMMEND, 
   [COORD @D116896, AGR [COUNT @D116895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RECOMMEND, 
   [COORD @D116898, AGR [COUNT @D116897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RECOMMEND, 
   [COORD @D116902, AGR [COUNT @D116901, PER @D116900, PLU @D116899, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RECOMMEND, 
   [COORD @D116908, PAST @D116907, 
      AGR [CASE @D116906, COUNT @D116905, PER @D116904, PLU @D116903, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : RECOMMEND, 
   [COORD @D116911, AGR [COUNT @D116910, PER @D116909, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOMMEND, 
   [COORD @D116913, AGR [COUNT @D116912, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOMMEND, 
   [COORD @D116915, AGR [COUNT @D116914, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOMMEND, 
   [COORD @D116919, AGR [COUNT @D116918, PER @D116917, PLU @D116916, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : RECOMMEND, 
   [COORD @D116925, PAST @D116924, 
      AGR [CASE @D116923, COUNT @D116922, PER @D116921, PLU @D116920, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : RECOMMEND, 
   [COORD @D116928, AGR [COUNT @D116927, PER @D116926, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : RECOMMEND, 
   [COORD @D116930, AGR [COUNT @D116929, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : RECOMMEND, 
   [COORD @D116932, AGR [COUNT @D116931, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : RECOMMEND, 
   [COORD @D116936, AGR [COUNT @D116935, PER @D116934, PLU @D116933, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : RECOMMEND, 
   [COORD @D116942, PAST @D116941, 
      AGR [CASE @D116940, COUNT @D116939, PER @D116938, PLU @D116937, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SBSE, 
      ARITY 2] : RECOMMEND, 
   [COORD @D116945, AGR [COUNT @D116944, PER @D116943, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECOMMEND, 
   [COORD @D116947, AGR [COUNT @D116946, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECOMMEND, 
   [COORD @D116949, AGR [COUNT @D116948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECOMMEND, 
   [COORD @D116953, AGR [COUNT @D116952, PER @D116951, PLU @D116950, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RECOMMEND, 
   [COORD @D116959, PAST @D116958, AGR [CASE @D116957, COUNT @D116956, 
            PER @D116955, PLU @D116954, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RECOMMEND.

WORD recommended : 
   [COORD @D116967, AGR [CASE @D116966, COUNT @D116965, PER @D116964, 
            PLU @D116963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D116972, AGR [CASE @D116971, COUNT @D116970, PER @D116969, 
            PLU @D116968, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D116978, AGR [CASE @D116977, NFORM @D116976, COUNT @D116975, 
            PER @D116974, PLU @D116973, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D116983, AGR [CASE @D116982, COUNT @D116981, PER @D116980, 
            PLU @D116979, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D116988, AGR [CASE @D116987, COUNT @D116986, PER @D116985, 
            PLU @D116984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D116993, AGR [CASE @D116992, COUNT @D116991, PER @D116990, 
            PLU @D116989, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D116998, AGR [CASE @D116997, COUNT @D116996, PER @D116995, 
            PLU @D116994, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117003, AGR [CASE @D117002, COUNT @D117001, PER @D117000, 
            PLU @D116999, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117008, 
      AGR [CASE @D117007, COUNT @D117006, PER @D117005, PLU @D117004, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117013, AGR [CASE @D117012, COUNT @D117011, PER @D117010, 
            PLU @D117009, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117018, AGR [CASE @D117017, COUNT @D117016, PER @D117015, 
            PLU @D117014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117023, 
      AGR [CASE @D117022, COUNT @D117021, PER @D117020, PLU @D117019, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117028, AGR [CASE @D117027, COUNT @D117026, PER @D117025, 
            PLU @D117024, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AS, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117033, AGR [CASE @D117032, COUNT @D117031, PER @D117030, 
            PLU @D117029, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117038, AGR [CASE @D117037, COUNT @D117036, PER @D117035, 
            PLU @D117034, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117043, AGR [CASE @D117042, COUNT @D117041, PER @D117040, 
            PLU @D117039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117048, AGR [CASE @D117047, COUNT @D117046, PER @D117045, 
            PLU @D117044, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117053, AGR [CASE @D117052, COUNT @D117051, PER @D117050, 
            PLU @D117049, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117058, AGR [CASE @D117057, COUNT @D117056, PER @D117055, 
            PLU @D117054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117063, AGR [CASE @D117062, COUNT @D117061, PER @D117060, 
            PLU @D117059, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECOMMEND.

WORD recommending : 
   [COORD @D117074, PRD @D117073, AGR [CASE @D117072, COUNT @D117071, 
            PER @D117070, PLU @D117069, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117080, PRD @D117079, 
      AGR [CASE @D117078, COUNT @D117077, PER @D117076, PLU @D117075, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RECOMMEND, 
   [COORD @D117086, PRD @D117085, AGR [CASE @D117084, COUNT @D117083, 
            PER @D117082, PLU @D117081, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117092, PRD @D117091, 
      AGR [CASE @D117090, COUNT @D117089, PER @D117088, PLU @D117087, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117098, PRD @D117097, AGR [CASE @D117096, COUNT @D117095, 
            PER @D117094, PLU @D117093, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RECOMMEND, 
   [COORD @D117104, PRD @D117103, 
      AGR [CASE @D117102, COUNT @D117101, PER @D117100, PLU @D117099, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RECOMMEND, 
   [COORD @D117110, PRD @D117109, AGR [CASE @D117108, COUNT @D117107, 
            PER @D117106, PLU @D117105, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECOMMEND.

WORD recommends : 
   [COORD @D117115, AGR [COUNT @D117114, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RECOMMEND, 
   [COORD @D117117, AGR [COUNT @D117116, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RECOMMEND, 
   [COORD @D117119, AGR [COUNT @D117118, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RECOMMEND, 
   [COORD @D117121, AGR [COUNT @D117120, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RECOMMEND, 
   [COORD @D117123, AGR [COUNT @D117122, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RECOMMEND, 
   [COORD @D117125, AGR [COUNT @D117124, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RECOMMEND, 
   [COORD @D117127, AGR [COUNT @D117126, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RECOMMEND.

WORD record : 
   [COORD @D117134, REFL @D117133, COUNT @D117132, PRD @D117131, 
      CASE @D117130, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RECORD, 
   [COORD @D117137, 
      AGR [COUNT @D117136, PER @D117135, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   RECORD, 
   [COORD @D117139, AGR [COUNT @D117138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECORD, 
   [COORD @D117141, AGR [COUNT @D117140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RECORD, 
   [COORD @D117145, AGR [COUNT @D117144, PER @D117143, PLU @D117142, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RECORD, 
   [COORD @D117151, PAST @D117150, AGR [CASE @D117149, COUNT @D117148, 
            PER @D117147, PLU @D117146, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RECORD, 
   [COORD @D117154, AGR [COUNT @D117153, PER @D117152, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECORD, 
   [COORD @D117156, AGR [COUNT @D117155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECORD, 
   [COORD @D117158, AGR [COUNT @D117157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECORD, 
   [COORD @D117162, AGR [COUNT @D117161, PER @D117160, PLU @D117159, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RECORD, 
   [COORD @D117168, PAST @D117167, AGR [CASE @D117166, COUNT @D117165, 
            PER @D117164, PLU @D117163, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : RECORD.

WORD recorded : 
   [COORD @D117177, AGR [CASE @D117176, COUNT @D117175, PER @D117174, 
            PLU @D117173, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECORD, 
   [COORD @D117182, AGR [CASE @D117181, COUNT @D117180, PER @D117179, 
            PLU @D117178, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECORD, 
   [COORD @D117187, AGR [CASE @D117186, COUNT @D117185, PER @D117184, 
            PLU @D117183, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RECORD, 
   [COORD @D117192, AGR [CASE @D117191, COUNT @D117190, PER @D117189, 
            PLU @D117188, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RECORD, 
   [COORD @D117197, AGR [CASE @D117196, COUNT @D117195, PER @D117194, 
            PLU @D117193, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RECORD.

WORD recording : 
   [COORD @D117209, REFL @D117208, PRD @D117207, CASE @D117206, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RECORDING, 
   [COORD @D117215, PRD @D117214, 
      AGR [CASE @D117213, COUNT @D117212, PER @D117211, PLU @D117210, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RECORD, 
   [COORD @D117221, PRD @D117220, AGR [CASE @D117219, COUNT @D117218, 
            PER @D117217, PLU @D117216, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RECORD.

WORD recordings : 
   [COORD @D117237, DEMON @D117236, REFL @D117235, PRD @D117234, 
      CASE @D117233, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RECORDING.

WORD records : 
   [COORD @D117246, DEMON @D117245, REFL @D117244, PRD @D117243, 
      CASE @D117242, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RECORD, 
   [COORD @D117248, AGR [COUNT @D117247, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RECORD, 
   [COORD @D117250, 
      AGR [COUNT @D117249, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RECORD.

WORD reduce : 
   [COORD @D117256, AGR [COUNT @D117255, PER @D117254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_TO, ARITY 4] : REDUCE, 
   [COORD @D117258, 
      AGR [COUNT @D117257, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP_PP, 
      PFORM FROM_TO, ARITY 4] : REDUCE, 
   [COORD @D117260, AGR [COUNT @D117259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_TO, ARITY 4] : REDUCE, 
   [COORD @D117264, 
      AGR [COUNT @D117263, PER @D117262, PLU @D117261, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_TO, ARITY 4] : REDUCE, 
   [COORD @D117270, PAST @D117269, 
      AGR [CASE @D117268, COUNT @D117267, PER @D117266, PLU @D117265, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_TO, ARITY 4] : REDUCE, 
   [COORD @D117273, 
      AGR [COUNT @D117272, PER @D117271, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : REDUCE, 
   [COORD @D117275, AGR [COUNT @D117274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REDUCE, 
   [COORD @D117277, AGR [COUNT @D117276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REDUCE, 
   [COORD @D117281, AGR [COUNT @D117280, PER @D117279, PLU @D117278, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REDUCE, 
   [COORD @D117287, PAST @D117286, 
      AGR [CASE @D117285, COUNT @D117284, PER @D117283, PLU @D117282, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : REDUCE, 
   [COORD @D117290, AGR [COUNT @D117289, PER @D117288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REDUCE, 
   [COORD @D117292, AGR [COUNT @D117291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REDUCE, 
   [COORD @D117294, AGR [COUNT @D117293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REDUCE, 
   [COORD @D117298, AGR [COUNT @D117297, PER @D117296, PLU @D117295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REDUCE, 
   [COORD @D117304, PAST @D117303, 
      AGR [CASE @D117302, COUNT @D117301, PER @D117300, PLU @D117299, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : REDUCE, 
   [COORD @D117307, AGR [COUNT @D117306, PER @D117305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, ARITY 3] : REDUCE, 
   [COORD @D117309, 
      AGR [COUNT @D117308, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM TO, ORDER POSTNP, ARITY 3] : REDUCE, 
   [COORD @D117311, AGR [COUNT @D117310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, ARITY 3] : REDUCE, 
   [COORD @D117315, 
      AGR [COUNT @D117314, PER @D117313, PLU @D117312, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, ARITY 3] : REDUCE, 
   [COORD @D117321, PAST @D117320, 
      AGR [CASE @D117319, COUNT @D117318, PER @D117317, PLU @D117316, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, ARITY 3] : REDUCE, 
   [COORD @D117324, 
      AGR [COUNT @D117323, PER @D117322, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   REDUCE, 
   [COORD @D117326, AGR [COUNT @D117325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REDUCE, 
   [COORD @D117328, AGR [COUNT @D117327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REDUCE, 
   [COORD @D117332, AGR [COUNT @D117331, PER @D117330, PLU @D117329, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REDUCE, 
   [COORD @D117338, PAST @D117337, AGR [CASE @D117336, COUNT @D117335, 
            PER @D117334, PLU @D117333, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REDUCE, 
   [COORD @D117341, AGR [COUNT @D117340, PER @D117339, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REDUCE, 
   [COORD @D117343, AGR [COUNT @D117342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REDUCE, 
   [COORD @D117345, AGR [COUNT @D117344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REDUCE, 
   [COORD @D117349, AGR [COUNT @D117348, PER @D117347, PLU @D117346, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REDUCE, 
   [COORD @D117355, PAST @D117354, AGR [CASE @D117353, COUNT @D117352, 
            PER @D117351, PLU @D117350, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REDUCE.

WORD reduced : 
   [COORD @D117364, AGR [CASE @D117363, COUNT @D117362, PER @D117361, 
            PLU @D117360, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM_TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117369, AGR [CASE @D117368, COUNT @D117367, PER @D117366, 
            PLU @D117365, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117374, 
      AGR [CASE @D117373, COUNT @D117372, PER @D117371, PLU @D117370, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117379, AGR [CASE @D117378, COUNT @D117377, PER @D117376, 
            PLU @D117375, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117384, AGR [CASE @D117383, COUNT @D117382, PER @D117381, 
            PLU @D117380, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117389, AGR [CASE @D117388, COUNT @D117387, PER @D117386, 
            PLU @D117385, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117394, AGR [CASE @D117393, COUNT @D117392, PER @D117391, 
            PLU @D117390, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117399, AGR [CASE @D117398, COUNT @D117397, PER @D117396, 
            PLU @D117395, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117404, AGR [CASE @D117403, COUNT @D117402, PER @D117401, 
            PLU @D117400, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117409, AGR [CASE @D117408, COUNT @D117407, PER @D117406, 
            PLU @D117405, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM TO, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117414, 
      AGR [CASE @D117413, COUNT @D117412, PER @D117411, PLU @D117410, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117419, AGR [CASE @D117418, COUNT @D117417, PER @D117416, 
            PLU @D117415, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117424, 
      AGR [CASE @D117423, COUNT @D117422, PER @D117421, PLU @D117420, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REDUCE, 
   [COORD @D117429, AGR [CASE @D117428, COUNT @D117427, PER @D117426, 
            PLU @D117425, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117434, AGR [CASE @D117433, COUNT @D117432, PER @D117431, 
            PLU @D117430, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REDUCE, 
   [COORD @D117439, AGR [CASE @D117438, COUNT @D117437, PER @D117436, 
            PLU @D117435, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117444, AGR [CASE @D117443, COUNT @D117442, PER @D117441, 
            PLU @D117440, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REDUCE.

WORD reduces : 
   [COORD @D117450, AGR [COUNT @D117449, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REDUCE, 
   [COORD @D117452, AGR [COUNT @D117451, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REDUCE, 
   [COORD @D117454, AGR [COUNT @D117453, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REDUCE, 
   [COORD @D117456, AGR [COUNT @D117455, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST -, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117458, AGR [COUNT @D117457, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117460, 
      AGR [COUNT @D117459, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REDUCE.

WORD reducing : 
   [COORD @D117470, PRD @D117469, AGR [CASE @D117468, COUNT @D117467, 
            PER @D117466, PLU @D117465, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, 
      PFORM FROM_TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117476, PRD @D117475, 
      AGR [CASE @D117474, COUNT @D117473, PER @D117472, PLU @D117471, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REDUCE, 
   [COORD @D117482, PRD @D117481, AGR [CASE @D117480, COUNT @D117479, 
            PER @D117478, PLU @D117477, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117488, PRD @D117487, 
      AGR [CASE @D117486, COUNT @D117485, PER @D117484, PLU @D117483, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM TO, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REDUCE, 
   [COORD @D117494, PRD @D117493, 
      AGR [CASE @D117492, COUNT @D117491, PER @D117490, PLU @D117489, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REDUCE, 
   [COORD @D117500, PRD @D117499, AGR [CASE @D117498, COUNT @D117497, 
            PER @D117496, PLU @D117495, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REDUCE.

WORD refer : 
   [COORD @D117505, AGR [COUNT @D117504, PER @D117503, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REFER, 
   [COORD @D117507, AGR [COUNT @D117506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REFER, 
   [COORD @D117509, AGR [COUNT @D117508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REFER, 
   [COORD @D117513, AGR [COUNT @D117512, PER @D117511, PLU @D117510, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REFER, 
   [COORD @D117519, PAST @D117518, 
      AGR [CASE @D117517, COUNT @D117516, PER @D117515, PLU @D117514, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : REFER, 
   [COORD @D117522, AGR [COUNT @D117521, PER @D117520, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : REFER, 
   [COORD @D117524, AGR [COUNT @D117523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : REFER, 
   [COORD @D117526, AGR [COUNT @D117525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : REFER, 
   [COORD @D117530, AGR [COUNT @D117529, PER @D117528, PLU @D117527, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : REFER, 
   [COORD @D117536, PAST @D117535, 
      AGR [CASE @D117534, COUNT @D117533, PER @D117532, PLU @D117531, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : REFER.

WORD referred : 
   [COORD @D117544, AGR [CASE @D117543, COUNT @D117542, PER @D117541, 
            PLU @D117540, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REFER, 
   [COORD @D117549, AGR [CASE @D117548, COUNT @D117547, PER @D117546, 
            PLU @D117545, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REFER, 
   [COORD @D117554, AGR [CASE @D117553, COUNT @D117552, PER @D117551, 
            PLU @D117550, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFER, 
   [COORD @D117559, AGR [CASE @D117558, COUNT @D117557, PER @D117556, 
            PLU @D117555, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFER, 
   [COORD @D117564, AGR [CASE @D117563, COUNT @D117562, PER @D117561, 
            PLU @D117560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFER, 
   [COORD @D117569, AGR [CASE @D117568, COUNT @D117567, PER @D117566, 
            PLU @D117565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REFER.

WORD referring : 
   [COORD @D117578, PRD @D117577, AGR [CASE @D117576, COUNT @D117575, 
            PER @D117574, PLU @D117573, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REFER, 
   [COORD @D117584, PRD @D117583, 
      AGR [CASE @D117582, COUNT @D117581, PER @D117580, PLU @D117579, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REFER.

WORD refers : 
   [COORD @D117589, AGR [COUNT @D117588, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REFER, 
   [COORD @D117591, AGR [COUNT @D117590, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REFER.

WORD reflect : 
   [COORD @D117596, AGR [COUNT @D117595, PER @D117594, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : REFLECT, 
   [COORD @D117598, AGR [COUNT @D117597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : REFLECT, 
   [COORD @D117600, AGR [COUNT @D117599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : REFLECT, 
   [COORD @D117604, AGR [COUNT @D117603, PER @D117602, PLU @D117601, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : REFLECT, 
   [COORD @D117610, PAST @D117609, 
      AGR [CASE @D117608, COUNT @D117607, PER @D117606, PLU @D117605, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM UPON, ARITY 3] : REFLECT, 
   [COORD @D117613, AGR [COUNT @D117612, PER @D117611, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : REFLECT, 
   [COORD @D117615, AGR [COUNT @D117614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : REFLECT, 
   [COORD @D117617, AGR [COUNT @D117616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : REFLECT, 
   [COORD @D117621, AGR [COUNT @D117620, PER @D117619, PLU @D117618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : REFLECT, 
   [COORD @D117627, PAST @D117626, 
      AGR [CASE @D117625, COUNT @D117624, PER @D117623, PLU @D117622, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : REFLECT, 
   [COORD @D117630, AGR [COUNT @D117629, PER @D117628, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REFLECT, 
   [COORD @D117632, AGR [COUNT @D117631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REFLECT, 
   [COORD @D117634, AGR [COUNT @D117633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REFLECT, 
   [COORD @D117638, AGR [COUNT @D117637, PER @D117636, PLU @D117635, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REFLECT, 
   [COORD @D117644, PAST @D117643, AGR [CASE @D117642, COUNT @D117641, 
            PER @D117640, PLU @D117639, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : REFLECT, 
   [COORD @D117647, AGR [COUNT @D117646, PER @D117645, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REFLECT, 
   [COORD @D117649, AGR [COUNT @D117648, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REFLECT, 
   [COORD @D117651, AGR [COUNT @D117650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REFLECT, 
   [COORD @D117655, AGR [COUNT @D117654, PER @D117653, PLU @D117652, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REFLECT, 
   [COORD @D117661, PAST @D117660, AGR [CASE @D117659, COUNT @D117658, 
            PER @D117657, PLU @D117656, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REFLECT, 
   [COORD @D117664, AGR [COUNT @D117663, PER @D117662, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117666, AGR [COUNT @D117665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117668, AGR [COUNT @D117667, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117672, AGR [COUNT @D117671, PER @D117670, PLU @D117669, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117678, PAST @D117677, 
      AGR [CASE @D117676, COUNT @D117675, PER @D117674, PLU @D117673, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117681, AGR [COUNT @D117680, PER @D117679, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117683, AGR [COUNT @D117682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117685, AGR [COUNT @D117684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117689, AGR [COUNT @D117688, PER @D117687, PLU @D117686, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117695, PAST @D117694, 
      AGR [CASE @D117693, COUNT @D117692, PER @D117691, PLU @D117690, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP UPON, ARITY 2] : REFLECT, 
   [COORD @D117698, AGR [COUNT @D117697, PER @D117696, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117700, AGR [COUNT @D117699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117702, AGR [COUNT @D117701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117706, AGR [COUNT @D117705, PER @D117704, PLU @D117703, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117712, PAST @D117711, 
      AGR [CASE @D117710, COUNT @D117709, PER @D117708, PLU @D117707, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117715, AGR [COUNT @D117714, PER @D117713, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117717, AGR [COUNT @D117716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117719, AGR [COUNT @D117718, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117723, AGR [COUNT @D117722, PER @D117721, PLU @D117720, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117729, PAST @D117728, 
      AGR [CASE @D117727, COUNT @D117726, PER @D117725, PLU @D117724, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PREP ON, ARITY 2] : REFLECT, 
   [COORD @D117732, AGR [COUNT @D117731, PER @D117730, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REFLECT, 
   [COORD @D117734, AGR [COUNT @D117733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REFLECT, 
   [COORD @D117736, AGR [COUNT @D117735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REFLECT, 
   [COORD @D117740, AGR [COUNT @D117739, PER @D117738, PLU @D117737, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : REFLECT, 
   [COORD @D117746, PAST @D117745, 
      AGR [CASE @D117744, COUNT @D117743, PER @D117742, PLU @D117741, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REFLECT, 
   [COORD @D117749, AGR [COUNT @D117748, PER @D117747, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REFLECT, 
   [COORD @D117751, AGR [COUNT @D117750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REFLECT, 
   [COORD @D117753, AGR [COUNT @D117752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REFLECT, 
   [COORD @D117757, AGR [COUNT @D117756, PER @D117755, PLU @D117754, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : REFLECT, 
   [COORD @D117763, PAST @D117762, 
      AGR [CASE @D117761, COUNT @D117760, PER @D117759, PLU @D117758, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REFLECT, 
   [COORD @D117766, AGR [COUNT @D117765, PER @D117764, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFLECT, 
   [COORD @D117768, AGR [COUNT @D117767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFLECT, 
   [COORD @D117770, AGR [COUNT @D117769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFLECT, 
   [COORD @D117774, AGR [COUNT @D117773, PER @D117772, PLU @D117771, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFLECT, 
   [COORD @D117780, PAST @D117779, AGR [CASE @D117778, COUNT @D117777, 
            PER @D117776, PLU @D117775, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REFLECT.

WORD reflected : 
   [COORD @D117788, AGR [CASE @D117787, COUNT @D117786, PER @D117785, 
            PLU @D117784, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117793, AGR [CASE @D117792, COUNT @D117791, PER @D117790, 
            PLU @D117789, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117798, AGR [CASE @D117797, COUNT @D117796, PER @D117795, 
            PLU @D117794, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117803, AGR [CASE @D117802, COUNT @D117801, PER @D117800, 
            PLU @D117799, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117808, AGR [CASE @D117807, COUNT @D117806, PER @D117805, 
            PLU @D117804, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117813, AGR [CASE @D117812, COUNT @D117811, PER @D117810, 
            PLU @D117809, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117818, AGR [CASE @D117817, COUNT @D117816, PER @D117815, 
            PLU @D117814, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117823, AGR [CASE @D117822, COUNT @D117821, PER @D117820, 
            PLU @D117819, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117828, AGR [UB @D117827, VFORM @D117826, SUBJ @D117825, 
            FIN @D117824, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REFLECT, 
   [COORD @D117833, AGR [CASE @D117832, COUNT @D117831, PER @D117830, 
            PLU @D117829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117838, AGR [CASE @D117837, COUNT @D117836, PER @D117835, 
            PLU @D117834, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117843, AGR [CASE @D117842, COUNT @D117841, PER @D117840, 
            PLU @D117839, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REFLECT, 
   [COORD @D117848, AGR [CASE @D117847, COUNT @D117846, PER @D117845, 
            PLU @D117844, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PREP UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117853, AGR [CASE @D117852, COUNT @D117851, PER @D117850, 
            PLU @D117849, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PREP UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117858, AGR [CASE @D117857, COUNT @D117856, PER @D117855, 
            PLU @D117854, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117863, AGR [CASE @D117862, COUNT @D117861, PER @D117860, 
            PLU @D117859, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117868, AGR [CASE @D117867, COUNT @D117866, PER @D117865, 
            PLU @D117864, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PREP ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117873, AGR [CASE @D117872, COUNT @D117871, PER @D117870, 
            PLU @D117869, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PREP ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117878, AGR [CASE @D117877, COUNT @D117876, PER @D117875, 
            PLU @D117874, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117883, AGR [CASE @D117882, COUNT @D117881, PER @D117880, 
            PLU @D117879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117888, AGR [CASE @D117887, COUNT @D117886, PER @D117885, 
            PLU @D117884, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117893, AGR [CASE @D117892, COUNT @D117891, PER @D117890, 
            PLU @D117889, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117898, AGR [CASE @D117897, COUNT @D117896, PER @D117895, 
            PLU @D117894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117903, AGR [CASE @D117902, COUNT @D117901, PER @D117900, 
            PLU @D117899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117908, AGR [CASE @D117907, COUNT @D117906, PER @D117905, 
            PLU @D117904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117913, AGR [CASE @D117912, COUNT @D117911, PER @D117910, 
            PLU @D117909, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117918, AGR [CASE @D117917, COUNT @D117916, PER @D117915, 
            PLU @D117914, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117923, AGR [CASE @D117922, COUNT @D117921, PER @D117920, 
            PLU @D117919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REFLECT.

WORD reflecting : 
   [COORD @D117934, PRD @D117933, AGR [CASE @D117932, COUNT @D117931, 
            PER @D117930, PLU @D117929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117940, PRD @D117939, 
      AGR [CASE @D117938, COUNT @D117937, PER @D117936, PLU @D117935, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REFLECT, 
   [COORD @D117946, PRD @D117945, AGR [CASE @D117944, COUNT @D117943, 
            PER @D117942, PLU @D117941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117952, PRD @D117951, 
      AGR [CASE @D117950, COUNT @D117949, PER @D117948, PLU @D117947, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REFLECT, 
   [COORD @D117958, PRD @D117957, AGR [CASE @D117956, COUNT @D117955, 
            PER @D117954, PLU @D117953, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PREP UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117964, PRD @D117963, 
      AGR [CASE @D117962, COUNT @D117961, PER @D117960, PLU @D117959, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP UPON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REFLECT, 
   [COORD @D117970, PRD @D117969, AGR [CASE @D117968, COUNT @D117967, 
            PER @D117966, PLU @D117965, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PREP ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117976, PRD @D117975, 
      AGR [CASE @D117974, COUNT @D117973, PER @D117972, PLU @D117971, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PREP ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REFLECT, 
   [COORD @D117982, PRD @D117981, AGR [CASE @D117980, COUNT @D117979, 
            PER @D117978, PLU @D117977, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REFLECT, 
   [COORD @D117988, PRD @D117987, 
      AGR [CASE @D117986, COUNT @D117985, PER @D117984, PLU @D117983, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REFLECT, 
   [COORD @D117994, PRD @D117993, AGR [CASE @D117992, COUNT @D117991, 
            PER @D117990, PLU @D117989, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFLECT.

WORD reflects : 
   [COORD @D117999, AGR [COUNT @D117998, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REFLECT, 
   [COORD @D118001, AGR [COUNT @D118000, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REFLECT, 
   [COORD @D118003, AGR [COUNT @D118002, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118005, 
      AGR [COUNT @D118004, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118007, 
      AGR [COUNT @D118006, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, PREP UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118009, 
      AGR [COUNT @D118008, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118011, 
      AGR [COUNT @D118010, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, PREP ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118013, 
      AGR [COUNT @D118012, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PREP ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118015, 
      AGR [COUNT @D118014, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118017, 
      AGR [COUNT @D118016, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT, 
   [COORD @D118019, 
      AGR [COUNT @D118018, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFLECT.

WORD refuse : 
   [COORD @D118027, REFL @D118026, PRD @D118025, CASE @D118024, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : REFUSE, 
   [COORD @D118030, AGR [COUNT @D118029, PER @D118028, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : REFUSE, 
   [COORD @D118032, AGR [COUNT @D118031, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : REFUSE, 
   [COORD @D118034, AGR [COUNT @D118033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : REFUSE, 
   [COORD @D118038, AGR [COUNT @D118037, PER @D118036, PLU @D118035, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : REFUSE, 
   [COORD @D118044, PAST @D118043, AGR [CASE @D118042, COUNT @D118041, 
            PER @D118040, PLU @D118039, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : REFUSE, 
   [COORD @D118047, AGR [COUNT @D118046, PER @D118045, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : REFUSE, 
   [COORD @D118049, AGR [COUNT @D118048, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : REFUSE, 
   [COORD @D118051, AGR [COUNT @D118050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : REFUSE, 
   [COORD @D118055, AGR [COUNT @D118054, PER @D118053, PLU @D118052, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : REFUSE, 
   [COORD @D118061, PAST @D118060, AGR 
         [CASE @D118059, COUNT @D118058, PER @D118057, PLU @D118056, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : REFUSE, 
   [COORD @D118064, AGR [COUNT @D118063, PER @D118062, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REFUSE, 
   [COORD @D118066, AGR [COUNT @D118065, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REFUSE, 
   [COORD @D118068, AGR [COUNT @D118067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REFUSE, 
   [COORD @D118072, AGR [COUNT @D118071, PER @D118070, PLU @D118069, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REFUSE, 
   [COORD @D118078, PAST @D118077, AGR [CASE @D118076, COUNT @D118075, 
            PER @D118074, PLU @D118073, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REFUSE, 
   [COORD @D118081, AGR [COUNT @D118080, PER @D118079, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFUSE, 
   [COORD @D118083, AGR [COUNT @D118082, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFUSE, 
   [COORD @D118085, AGR [COUNT @D118084, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFUSE, 
   [COORD @D118089, AGR [COUNT @D118088, PER @D118087, PLU @D118086, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REFUSE, 
   [COORD @D118095, PAST @D118094, AGR [CASE @D118093, COUNT @D118092, 
            PER @D118091, PLU @D118090, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REFUSE.

WORD refused : 
   [COORD @D118106, AGR [CASE @D118105, COUNT @D118104, PER @D118103, 
            PLU @D118102, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REFUSE, 
   [COORD @D118111, AGR [CASE @D118110, COUNT @D118109, PER @D118108, 
            PLU @D118107, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118116, AGR [CASE @D118115, COUNT @D118114, PER @D118113, 
            PLU @D118112, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118121, AGR [CASE @D118120, COUNT @D118119, PER @D118118, 
            PLU @D118117, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118126, AGR [CASE @D118125, COUNT @D118124, PER @D118123, 
            PLU @D118122, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118131, AGR [CASE @D118130, COUNT @D118129, PER @D118128, 
            PLU @D118127, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118136, AGR [CASE @D118135, COUNT @D118134, PER @D118133, 
            PLU @D118132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118141, AGR [CASE @D118140, COUNT @D118139, PER @D118138, 
            PLU @D118137, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REFUSE, 
   [COORD @D118146, AGR [CASE @D118145, COUNT @D118144, PER @D118143, 
            PLU @D118142, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118151, AGR [CASE @D118150, COUNT @D118149, PER @D118148, 
            PLU @D118147, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REFUSE.

WORD refuses : 
   [COORD @D118159, AGR [COUNT @D118158, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118161, 
      AGR [COUNT @D118160, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118163, 
      AGR [COUNT @D118162, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118165, 
      AGR [COUNT @D118164, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REFUSE.

WORD refusing : 
   [COORD @D118175, PRD @D118174, AGR [CASE @D118173, COUNT @D118172, 
            PER @D118171, PLU @D118170, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118181, PRD @D118180, 
      AGR [CASE @D118179, COUNT @D118178, PER @D118177, PLU @D118176, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REFUSE, 
   [COORD @D118187, PRD @D118186, AGR [CASE @D118185, COUNT @D118184, 
            PER @D118183, PLU @D118182, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REFUSE, 
   [COORD @D118193, PRD @D118192, 
      AGR [CASE @D118191, COUNT @D118190, PER @D118189, PLU @D118188, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REFUSE.

WORD relate : 
   [COORD @D118199, AGR [COUNT @D118198, PER @D118197, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RELATE, 
   [COORD @D118201, AGR [COUNT @D118200, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RELATE, 
   [COORD @D118203, AGR [COUNT @D118202, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RELATE, 
   [COORD @D118207, AGR [COUNT @D118206, PER @D118205, PLU @D118204, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RELATE, 
   [COORD @D118213, PAST @D118212, 
      AGR [CASE @D118211, COUNT @D118210, PER @D118209, PLU @D118208, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : RELATE, 
   [COORD @D118216, AGR [COUNT @D118215, PER @D118214, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RELATE, 
   [COORD @D118218, AGR [COUNT @D118217, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RELATE, 
   [COORD @D118220, AGR [COUNT @D118219, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RELATE, 
   [COORD @D118224, AGR [COUNT @D118223, PER @D118222, PLU @D118221, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RELATE, 
   [COORD @D118230, PAST @D118229, AGR [CASE @D118228, COUNT @D118227, 
            PER @D118226, PLU @D118225, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RELATE, 
   [COORD @D118233, AGR [COUNT @D118232, PER @D118231, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RELATE, 
   [COORD @D118235, AGR [COUNT @D118234, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RELATE, 
   [COORD @D118237, AGR [COUNT @D118236, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RELATE, 
   [COORD @D118241, AGR [COUNT @D118240, PER @D118239, PLU @D118238, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : RELATE, 
   [COORD @D118247, PAST @D118246, 
      AGR [CASE @D118245, COUNT @D118244, PER @D118243, PLU @D118242, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RELATE.

WORD related : 
   [COADV @D118259, COORD @D118258, DEF @D118257, PRD @D118256, 
      AGR [CASE @D118255, COUNT @D118254, PER @D118253, PLU @D118252, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : RELATED, 
   [COADV @D118267, COORD @D118266, DEF @D118265, PRD @D118264, 
      AGR [CASE @D118263, COUNT @D118262, PER @D118261, PLU @D118260, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, DISTR PRD, ARITY 2] : RELATED, 
   [COADV @D118275, COORD @D118274, DEF @D118273, PRD @D118272, 
      AGR [CASE @D118271, COUNT @D118270, PER @D118269, PLU @D118268, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, DISTR PRD, ARITY 2] : RELATED, 
   [COORD @D118280, AGR [CASE @D118279, COUNT @D118278, PER @D118277, 
            PLU @D118276, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118285, AGR [CASE @D118284, COUNT @D118283, PER @D118282, 
            PLU @D118281, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118290, AGR [CASE @D118289, COUNT @D118288, PER @D118287, 
            PLU @D118286, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118295, AGR [CASE @D118294, COUNT @D118293, PER @D118292, 
            PLU @D118291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118300, AGR [CASE @D118299, COUNT @D118298, PER @D118297, 
            PLU @D118296, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118305, AGR [CASE @D118304, COUNT @D118303, PER @D118302, 
            PLU @D118301, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RELATE, 
   [COORD @D118310, AGR [CASE @D118309, COUNT @D118308, PER @D118307, 
            PLU @D118306, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118315, AGR [CASE @D118314, COUNT @D118313, PER @D118312, 
            PLU @D118311, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118320, AGR [CASE @D118319, COUNT @D118318, PER @D118317, 
            PLU @D118316, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RELATE.

WORD relates : 
   [COORD @D118326, AGR [COUNT @D118325, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RELATE, 
   [COORD @D118328, AGR [COUNT @D118327, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RELATE, 
   [COORD @D118330, 
      AGR [COUNT @D118329, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RELATE.

WORD relating : 
   [COORD @D118339, PRD @D118338, AGR [CASE @D118337, COUNT @D118336, 
            PER @D118335, PLU @D118334, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RELATE, 
   [COORD @D118345, PRD @D118344, 
      AGR [CASE @D118343, COUNT @D118342, PER @D118341, PLU @D118340, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RELATE, 
   [COORD @D118351, PRD @D118350, AGR [CASE @D118349, COUNT @D118348, 
            PER @D118347, PLU @D118346, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RELATE.

WORD release : 
   [COORD @D118360, REFL @D118359, COUNT @D118358, PRD @D118357, 
      CASE @D118356, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RELEASE, 
   [COORD @D118364, REFL @D118363, PRD @D118362, CASE @D118361, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM] : RELEASE, 
   [COORD @D118368, REFL @D118367, PRD @D118366, CASE @D118365, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, COUNT +] : RELEASE, 
   [COORD @D118372, REFL @D118371, PRD @D118370, CASE @D118369, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RELEASE, 
   [COORD @D118375, 
      AGR [COUNT @D118374, PER @D118373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FROM, 
      ARITY 3] : RELEASE, 
   [COORD @D118377, AGR [COUNT @D118376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : RELEASE, 
   [COORD @D118379, AGR [COUNT @D118378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : RELEASE, 
   [COORD @D118383, AGR [COUNT @D118382, PER @D118381, PLU @D118380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : RELEASE, 
   [COORD @D118389, PAST @D118388, 
      AGR [CASE @D118387, COUNT @D118386, PER @D118385, PLU @D118384, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : RELEASE, 
   [COORD @D118392, AGR [COUNT @D118391, PER @D118390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RELEASE, 
   [COORD @D118394, AGR [COUNT @D118393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RELEASE, 
   [COORD @D118396, AGR [COUNT @D118395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RELEASE, 
   [COORD @D118400, AGR [COUNT @D118399, PER @D118398, PLU @D118397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RELEASE, 
   [COORD @D118406, PAST @D118405, AGR [CASE @D118404, COUNT @D118403, 
            PER @D118402, PLU @D118401, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RELEASE.

WORD released : 
   [COORD @D118417, AGR [CASE @D118416, COUNT @D118415, PER @D118414, 
            PLU @D118413, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RELEASE, 
   [COORD @D118422, AGR [CASE @D118421, COUNT @D118420, PER @D118419, 
            PLU @D118418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RELEASE, 
   [COORD @D118427, AGR [CASE @D118426, COUNT @D118425, PER @D118424, 
            PLU @D118423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : RELEASE, 
   [COORD @D118432, AGR [CASE @D118431, COUNT @D118430, PER @D118429, 
            PLU @D118428, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RELEASE, 
   [COORD @D118437, AGR [CASE @D118436, COUNT @D118435, PER @D118434, 
            PLU @D118433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RELEASE, 
   [COORD @D118442, AGR [CASE @D118441, COUNT @D118440, PER @D118439, 
            PLU @D118438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RELEASE.

WORD releases : 
   [COORD @D118453, DEMON @D118452, REFL @D118451, PRD @D118450, 
      CASE @D118449, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RELEASE, 
   [COORD @D118455, AGR [COUNT @D118454, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RELEASE, 
   [COORD @D118457, AGR [COUNT @D118456, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RELEASE.

WORD releasing : 
   [COORD @D118467, PRD @D118466, AGR [CASE @D118465, COUNT @D118464, 
            PER @D118463, PLU @D118462, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RELEASE, 
   [COORD @D118473, PRD @D118472, 
      AGR [CASE @D118471, COUNT @D118470, PER @D118469, PLU @D118468, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RELEASE.

WORD remain : 
   [COORD @D118478, AGR [COUNT @D118477, PER @D118476, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : REMAIN, 
   [COORD @D118480, AGR [COUNT @D118479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : REMAIN, 
   [COORD @D118482, AGR [COUNT @D118481, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : REMAIN, 
   [COORD @D118486, AGR [COUNT @D118485, PER @D118484, PLU @D118483, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : REMAIN, 
   [COORD @D118492, PAST @D118491, AGR [CASE @D118490, COUNT @D118489, 
            PER @D118488, PLU @D118487, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : REMAIN, 
   [COORD @D118495, AGR [COUNT @D118494, PER @D118493, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : REMAIN, 
   [COORD @D118497, AGR [COUNT @D118496, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : REMAIN, 
   [COORD @D118499, AGR [COUNT @D118498, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : REMAIN, 
   [COORD @D118503, AGR [COUNT @D118502, PER @D118501, PLU @D118500, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : REMAIN, 
   [COORD @D118509, PAST @D118508, AGR [CASE @D118507, COUNT @D118506, 
            PER @D118505, PLU @D118504, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : REMAIN, 
   [COORD @D118512, AGR [COUNT @D118511, PER @D118510, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : REMAIN, 
   [COORD @D118514, AGR [COUNT @D118513, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : REMAIN, 
   [COORD @D118516, AGR [COUNT @D118515, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : REMAIN, 
   [COORD @D118520, AGR [COUNT @D118519, PER @D118518, PLU @D118517, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : REMAIN, 
   [COORD @D118526, PAST @D118525, AGR [CASE @D118524, COUNT @D118523, 
            PER @D118522, PLU @D118521, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : REMAIN, 
   [COORD @D118529, AGR [COUNT @D118528, PER @D118527, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMAIN, 
   [COORD @D118531, AGR [COUNT @D118530, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMAIN, 
   [COORD @D118533, AGR [COUNT @D118532, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMAIN, 
   [COORD @D118537, AGR [COUNT @D118536, PER @D118535, PLU @D118534, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMAIN, 
   [COORD @D118543, PAST @D118542, AGR [CASE @D118541, COUNT @D118540, 
            PER @D118539, PLU @D118538, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REMAIN.

WORD remained : 
   [COORD @D118551, AGR [CASE @D118550, COUNT @D118549, PER @D118548, 
            PLU @D118547, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118556, AGR [CASE @D118555, COUNT @D118554, PER @D118553, 
            PLU @D118552, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118561, AGR [CASE @D118560, COUNT @D118559, PER @D118558, 
            PLU @D118557, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118566, AGR [CASE @D118565, COUNT @D118564, PER @D118563, 
            PLU @D118562, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118571, AGR [CASE @D118570, COUNT @D118569, PER @D118568, 
            PLU @D118567, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118576, AGR [CASE @D118575, COUNT @D118574, PER @D118573, 
            PLU @D118572, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118581, AGR [CASE @D118580, COUNT @D118579, PER @D118578, 
            PLU @D118577, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118586, AGR [CASE @D118585, COUNT @D118584, PER @D118583, 
            PLU @D118582, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REMAIN.

WORD remaining : 
   [COORD @D118597, PRD @D118596, AGR [CASE @D118595, COUNT @D118594, 
            PER @D118593, PLU @D118592, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118603, PRD @D118602, 
      AGR [CASE @D118601, COUNT @D118600, PER @D118599, PLU @D118598, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REMAIN, 
   [COORD @D118609, PRD @D118608, AGR [CASE @D118607, COUNT @D118606, 
            PER @D118605, PLU @D118604, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118615, PRD @D118614, 
      AGR [CASE @D118613, COUNT @D118612, PER @D118611, PLU @D118610, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REMAIN.

WORD remains : 
   [COORD @D118622, REFL @D118621, PRD @D118620, CASE @D118619, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, NFORM NORM, PER 3, 
      ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM OF, COUNT +] : REMAINS, 
   [COORD @D118626, REFL @D118625, PRD @D118624, CASE @D118623, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : REMAINS, 
   [COORD @D118628, 
      AGR [COUNT @D118627, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118630, 
      AGR [COUNT @D118629, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118632, 
      AGR [COUNT @D118631, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMAIN, 
   [COORD @D118634, 
      AGR [COUNT @D118633, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMAIN.

WORD remark : 
   [COORD @D118646, REFL @D118645, PRD @D118644, CASE @D118643, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : REMARK, 
   [COORD @D118650, REFL @D118649, PRD @D118648, CASE @D118647, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, COUNT +] : REMARK, 
   [COORD @D118655, REFL @D118654, COUNT @D118653, PRD @D118652, 
      CASE @D118651, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : REMARK, 
   [COORD @D118659, REFL @D118658, PRD @D118657, CASE @D118656, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : REMARK, 
   [COORD @D118662, 
      AGR [COUNT @D118661, PER @D118660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   REMARK, 
   [COORD @D118664, AGR [COUNT @D118663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REMARK, 
   [COORD @D118666, AGR [COUNT @D118665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REMARK, 
   [COORD @D118670, AGR [COUNT @D118669, PER @D118668, PLU @D118667, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REMARK, 
   [COORD @D118676, PAST @D118675, AGR [CASE @D118674, COUNT @D118673, 
            PER @D118672, PLU @D118671, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : REMARK, 
   [COORD @D118679, AGR [COUNT @D118678, PER @D118677, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REMARK, 
   [COORD @D118681, AGR [COUNT @D118680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REMARK, 
   [COORD @D118683, AGR [COUNT @D118682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REMARK, 
   [COORD @D118687, AGR [COUNT @D118686, PER @D118685, PLU @D118684, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : REMARK, 
   [COORD @D118693, PAST @D118692, 
      AGR [CASE @D118691, COUNT @D118690, PER @D118689, PLU @D118688, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REMARK, 
   [COORD @D118696, AGR [COUNT @D118695, PER @D118694, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REMARK, 
   [COORD @D118698, AGR [COUNT @D118697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REMARK, 
   [COORD @D118700, AGR [COUNT @D118699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REMARK, 
   [COORD @D118704, AGR [COUNT @D118703, PER @D118702, PLU @D118701, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : REMARK, 
   [COORD @D118710, PAST @D118709, 
      AGR [CASE @D118708, COUNT @D118707, PER @D118706, PLU @D118705, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REMARK.

WORD remarked : 
   [COORD @D118719, AGR [CASE @D118718, COUNT @D118717, PER @D118716, 
            PLU @D118715, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118724, AGR [CASE @D118723, COUNT @D118722, PER @D118721, 
            PLU @D118720, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118729, AGR [UB @D118728, VFORM @D118727, SUBJ @D118726, 
            FIN @D118725, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REMARK, 
   [COORD @D118734, AGR [CASE @D118733, COUNT @D118732, PER @D118731, 
            PLU @D118730, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118739, AGR [CASE @D118738, COUNT @D118737, PER @D118736, 
            PLU @D118735, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118744, AGR [CASE @D118743, COUNT @D118742, PER @D118741, 
            PLU @D118740, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118749, AGR [CASE @D118748, COUNT @D118747, PER @D118746, 
            PLU @D118745, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118754, AGR [CASE @D118753, COUNT @D118752, PER @D118751, 
            PLU @D118750, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118759, AGR [CASE @D118758, COUNT @D118757, PER @D118756, 
            PLU @D118755, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REMARK.

WORD remarking : 
   [COORD @D118773, PRD @D118772, AGR [CASE @D118771, COUNT @D118770, 
            PER @D118769, PLU @D118768, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMARK, 
   [COORD @D118779, PRD @D118778, 
      AGR [CASE @D118777, COUNT @D118776, PER @D118775, PLU @D118774, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REMARK, 
   [COORD @D118785, PRD @D118784, AGR [CASE @D118783, COUNT @D118782, 
            PER @D118781, PLU @D118780, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REMARK.

WORD remarks : 
   [COORD @D118794, DEMON @D118793, REFL @D118792, PRD @D118791, 
      CASE @D118790, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REMARK, 
   [COORD @D118799, DEMON @D118798, REFL @D118797, PRD @D118796, 
      CASE @D118795, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REMARK, 
   [COORD @D118804, DEMON @D118803, REFL @D118802, PRD @D118801, 
      CASE @D118800, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REMARK, 
   [COORD @D118809, DEMON @D118808, REFL @D118807, PRD @D118806, 
      CASE @D118805, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REMARK, 
   [COORD @D118811, AGR [COUNT @D118810, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMARK, 
   [COORD @D118813, 
      AGR [COUNT @D118812, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMARK, 
   [COORD @D118815, 
      AGR [COUNT @D118814, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMARK.

WORD remove : 
   [COORD @D118821, AGR [COUNT @D118820, PER @D118819, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REMOVE, 
   [COORD @D118823, AGR [COUNT @D118822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REMOVE, 
   [COORD @D118825, AGR [COUNT @D118824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REMOVE, 
   [COORD @D118829, AGR [COUNT @D118828, PER @D118827, PLU @D118826, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : REMOVE, 
   [COORD @D118835, PAST @D118834, 
      AGR [CASE @D118833, COUNT @D118832, PER @D118831, PLU @D118830, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : REMOVE, 
   [COORD @D118838, AGR [COUNT @D118837, PER @D118836, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REMOVE, 
   [COORD @D118840, AGR [COUNT @D118839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REMOVE, 
   [COORD @D118842, AGR [COUNT @D118841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REMOVE, 
   [COORD @D118846, AGR [COUNT @D118845, PER @D118844, PLU @D118843, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REMOVE, 
   [COORD @D118852, PAST @D118851, AGR [CASE @D118850, COUNT @D118849, 
            PER @D118848, PLU @D118847, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REMOVE, 
   [COORD @D118855, AGR [COUNT @D118854, PER @D118853, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REMOVE, 
   [COORD @D118857, AGR [COUNT @D118856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REMOVE, 
   [COORD @D118859, AGR [COUNT @D118858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REMOVE, 
   [COORD @D118863, AGR [COUNT @D118862, PER @D118861, PLU @D118860, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : REMOVE, 
   [COORD @D118869, PAST @D118868, 
      AGR [CASE @D118867, COUNT @D118866, PER @D118865, PLU @D118864, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REMOVE, 
   [COORD @D118872, AGR [COUNT @D118871, PER @D118870, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REMOVE, 
   [COORD @D118874, AGR [COUNT @D118873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REMOVE, 
   [COORD @D118876, AGR [COUNT @D118875, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REMOVE, 
   [COORD @D118880, AGR [COUNT @D118879, PER @D118878, PLU @D118877, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : REMOVE, 
   [COORD @D118886, PAST @D118885, 
      AGR [CASE @D118884, COUNT @D118883, PER @D118882, PLU @D118881, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REMOVE, 
   [COORD @D118889, AGR [COUNT @D118888, PER @D118887, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMOVE, 
   [COORD @D118891, AGR [COUNT @D118890, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMOVE, 
   [COORD @D118893, AGR [COUNT @D118892, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMOVE, 
   [COORD @D118897, AGR [COUNT @D118896, PER @D118895, PLU @D118894, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REMOVE, 
   [COORD @D118903, PAST @D118902, AGR [CASE @D118901, COUNT @D118900, 
            PER @D118899, PLU @D118898, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REMOVE.

WORD removed : 
   [COORD @D118912, AGR [CASE @D118911, COUNT @D118910, PER @D118909, 
            PLU @D118908, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118917, AGR [CASE @D118916, COUNT @D118915, PER @D118914, 
            PLU @D118913, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118922, AGR [CASE @D118921, COUNT @D118920, PER @D118919, 
            PLU @D118918, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118927, AGR [CASE @D118926, COUNT @D118925, PER @D118924, 
            PLU @D118923, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118932, AGR [CASE @D118931, COUNT @D118930, PER @D118929, 
            PLU @D118928, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118937, AGR [CASE @D118936, COUNT @D118935, PER @D118934, 
            PLU @D118933, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REMOVE, 
   [COORD @D118942, AGR [CASE @D118941, COUNT @D118940, PER @D118939, 
            PLU @D118938, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118947, AGR [CASE @D118946, COUNT @D118945, PER @D118944, 
            PLU @D118943, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118952, AGR [CASE @D118951, COUNT @D118950, PER @D118949, 
            PLU @D118948, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118957, AGR [CASE @D118956, COUNT @D118955, PER @D118954, 
            PLU @D118953, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118962, AGR [CASE @D118961, COUNT @D118960, PER @D118959, 
            PLU @D118958, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118967, AGR [CASE @D118966, COUNT @D118965, PER @D118964, 
            PLU @D118963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REMOVE.

WORD removes : 
   [COORD @D118973, AGR [COUNT @D118972, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REMOVE, 
   [COORD @D118975, AGR [COUNT @D118974, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118977, 
      AGR [COUNT @D118976, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118979, 
      AGR [COUNT @D118978, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118981, 
      AGR [COUNT @D118980, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REMOVE.

WORD removing : 
   [COORD @D118990, PRD @D118989, AGR [CASE @D118988, COUNT @D118987, 
            PER @D118986, PLU @D118985, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D118996, PRD @D118995, 
      AGR [CASE @D118994, COUNT @D118993, PER @D118992, PLU @D118991, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REMOVE, 
   [COORD @D119002, PRD @D119001, AGR [CASE @D119000, COUNT @D118999, 
            PER @D118998, PLU @D118997, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REMOVE, 
   [COORD @D119008, PRD @D119007, 
      AGR [CASE @D119006, COUNT @D119005, PER @D119004, PLU @D119003, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REMOVE, 
   [COORD @D119014, PRD @D119013, AGR [CASE @D119012, COUNT @D119011, 
            PER @D119010, PLU @D119009, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REMOVE.

WORD repeat : 
   [COORD @D119019, AGR [COUNT @D119018, PER @D119017, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPEAT, 
   [COORD @D119021, AGR [COUNT @D119020, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPEAT, 
   [COORD @D119023, AGR [COUNT @D119022, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPEAT, 
   [COORD @D119027, AGR [COUNT @D119026, PER @D119025, PLU @D119024, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPEAT, 
   [COORD @D119033, PAST @D119032, AGR [CASE @D119031, COUNT @D119030, 
            PER @D119029, PLU @D119028, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : REPEAT, 
   [COORD @D119036, AGR [COUNT @D119035, PER @D119034, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPEAT, 
   [COORD @D119038, AGR [COUNT @D119037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPEAT, 
   [COORD @D119040, AGR [COUNT @D119039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPEAT, 
   [COORD @D119044, AGR [COUNT @D119043, PER @D119042, PLU @D119041, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REPEAT, 
   [COORD @D119050, PAST @D119049, AGR [CASE @D119048, COUNT @D119047, 
            PER @D119046, PLU @D119045, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REPEAT, 
   [COORD @D119053, AGR [COUNT @D119052, PER @D119051, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPEAT, 
   [COORD @D119055, AGR [COUNT @D119054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPEAT, 
   [COORD @D119057, AGR [COUNT @D119056, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPEAT, 
   [COORD @D119061, AGR [COUNT @D119060, PER @D119059, PLU @D119058, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPEAT, 
   [COORD @D119067, PAST @D119066, AGR [CASE @D119065, COUNT @D119064, 
            PER @D119063, PLU @D119062, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REPEAT.

WORD repeated : 
   [COADV @D119078, COORD @D119077, DEF @D119076, PRD @D119075, 
      AGR [CASE @D119074, COUNT @D119073, PER @D119072, PLU @D119071, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : REPEATED, 
   [COORD @D119083, AGR [CASE @D119082, COUNT @D119081, PER @D119080, 
            PLU @D119079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119088, AGR [CASE @D119087, COUNT @D119086, PER @D119085, 
            PLU @D119084, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119093, AGR [UB @D119092, VFORM @D119091, SUBJ @D119090, 
            FIN @D119089, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REPEAT, 
   [COORD @D119098, AGR [CASE @D119097, COUNT @D119096, PER @D119095, 
            PLU @D119094, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119103, AGR [CASE @D119102, COUNT @D119101, PER @D119100, 
            PLU @D119099, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119108, AGR [CASE @D119107, COUNT @D119106, PER @D119105, 
            PLU @D119104, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REPEAT, 
   [COORD @D119113, AGR [CASE @D119112, COUNT @D119111, PER @D119110, 
            PLU @D119109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119118, AGR [CASE @D119117, COUNT @D119116, PER @D119115, 
            PLU @D119114, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPEAT.

WORD repeating : 
   [COORD @D119129, PRD @D119128, AGR [CASE @D119127, COUNT @D119126, 
            PER @D119125, PLU @D119124, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119135, PRD @D119134, 
      AGR [CASE @D119133, COUNT @D119132, PER @D119131, PLU @D119130, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REPEAT, 
   [COORD @D119141, PRD @D119140, AGR [CASE @D119139, COUNT @D119138, 
            PER @D119137, PLU @D119136, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPEAT.

WORD repeats : 
   [COORD @D119146, AGR [COUNT @D119145, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119148, 
      AGR [COUNT @D119147, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPEAT, 
   [COORD @D119150, 
      AGR [COUNT @D119149, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPEAT.

WORD report : 
   [COORD @D119157, REFL @D119156, COUNT @D119155, PRD @D119154, 
      CASE @D119153, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : REPORT, 
   [COORD @D119160, 
      AGR [COUNT @D119159, PER @D119158, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : REPORT, 
   [COORD @D119162, AGR [COUNT @D119161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REPORT, 
   [COORD @D119164, AGR [COUNT @D119163, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REPORT, 
   [COORD @D119168, AGR [COUNT @D119167, PER @D119166, PLU @D119165, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REPORT, 
   [COORD @D119174, PAST @D119173, 
      AGR [CASE @D119172, COUNT @D119171, PER @D119170, PLU @D119169, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : REPORT, 
   [COORD @D119177, AGR [COUNT @D119176, PER @D119175, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_TO, ARITY 3] : REPORT, 
   [COORD @D119179, AGR [COUNT @D119178, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_TO, ARITY 3] : REPORT, 
   [COORD @D119181, AGR [COUNT @D119180, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_TO, ARITY 3] : REPORT, 
   [COORD @D119185, AGR [COUNT @D119184, PER @D119183, PLU @D119182, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_PP, PFORM ON_TO, ARITY 3] : REPORT, 
   [COORD @D119191, PAST @D119190, 
      AGR [CASE @D119189, COUNT @D119188, PER @D119187, PLU @D119186, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_PP, 
      PFORM ON_TO, ARITY 3] : REPORT, 
   [COORD @D119194, AGR [COUNT @D119193, PER @D119192, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : REPORT, 
   [COORD @D119196, AGR [COUNT @D119195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : REPORT, 
   [COORD @D119198, AGR [COUNT @D119197, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : REPORT, 
   [COORD @D119202, AGR [COUNT @D119201, PER @D119200, PLU @D119199, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : REPORT, 
   [COORD @D119208, PAST @D119207, 
      AGR [CASE @D119206, COUNT @D119205, PER @D119204, PLU @D119203, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : REPORT, 
   [COORD @D119211, AGR [COUNT @D119210, PER @D119209, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPORT, 
   [COORD @D119213, AGR [COUNT @D119212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPORT, 
   [COORD @D119215, AGR [COUNT @D119214, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPORT, 
   [COORD @D119219, AGR [COUNT @D119218, PER @D119217, PLU @D119216, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REPORT, 
   [COORD @D119225, PAST @D119224, AGR [CASE @D119223, COUNT @D119222, 
            PER @D119221, PLU @D119220, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : REPORT, 
   [COORD @D119228, AGR [COUNT @D119227, PER @D119226, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REPORT, 
   [COORD @D119230, AGR [COUNT @D119229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REPORT, 
   [COORD @D119232, AGR [COUNT @D119231, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REPORT, 
   [COORD @D119236, AGR [COUNT @D119235, PER @D119234, PLU @D119233, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REPORT, 
   [COORD @D119242, PAST @D119241, AGR 
         [CASE @D119240, COUNT @D119239, PER @D119238, PLU @D119237, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : REPORT, 
   [COORD @D119245, AGR [COUNT @D119244, PER @D119243, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REPORT, 
   [COORD @D119247, AGR [COUNT @D119246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REPORT, 
   [COORD @D119249, AGR [COUNT @D119248, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REPORT, 
   [COORD @D119253, AGR [COUNT @D119252, PER @D119251, PLU @D119250, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REPORT, 
   [COORD @D119259, PAST @D119258, AGR 
         [CASE @D119257, COUNT @D119256, PER @D119255, PLU @D119254, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      ARITY 2] : REPORT, 
   [COORD @D119262, AGR [COUNT @D119261, PER @D119260, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPORT, 
   [COORD @D119264, AGR [COUNT @D119263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPORT, 
   [COORD @D119266, AGR [COUNT @D119265, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPORT, 
   [COORD @D119270, AGR [COUNT @D119269, PER @D119268, PLU @D119267, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REPORT, 
   [COORD @D119276, PAST @D119275, AGR [CASE @D119274, COUNT @D119273, 
            PER @D119272, PLU @D119271, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REPORT, 
   [COORD @D119279, AGR [COUNT @D119278, PER @D119277, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119281, AGR [COUNT @D119280, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119283, AGR [COUNT @D119282, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119287, AGR [COUNT @D119286, PER @D119285, PLU @D119284, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119293, PAST @D119292, 
      AGR [CASE @D119291, COUNT @D119290, PER @D119289, PLU @D119288, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119296, AGR [COUNT @D119295, PER @D119294, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REPORT, 
   [COORD @D119298, AGR [COUNT @D119297, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REPORT, 
   [COORD @D119300, AGR [COUNT @D119299, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REPORT, 
   [COORD @D119304, AGR [COUNT @D119303, PER @D119302, PLU @D119301, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : REPORT, 
   [COORD @D119310, PAST @D119309, 
      AGR [CASE @D119308, COUNT @D119307, PER @D119306, PLU @D119305, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : REPORT, 
   [COORD @D119313, AGR [COUNT @D119312, PER @D119311, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REPORT, 
   [COORD @D119315, AGR [COUNT @D119314, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REPORT, 
   [COORD @D119317, AGR [COUNT @D119316, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REPORT, 
   [COORD @D119321, AGR [COUNT @D119320, PER @D119319, PLU @D119318, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : REPORT, 
   [COORD @D119327, PAST @D119326, 
      AGR [CASE @D119325, COUNT @D119324, PER @D119323, PLU @D119322, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REPORT, 
   [COORD @D119330, AGR [COUNT @D119329, PER @D119328, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : REPORT, 
   [COORD @D119332, AGR [COUNT @D119331, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : REPORT, 
   [COORD @D119334, AGR [COUNT @D119333, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : REPORT, 
   [COORD @D119338, AGR [COUNT @D119337, PER @D119336, PLU @D119335, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : REPORT, 
   [COORD @D119344, PAST @D119343, 
      AGR [CASE @D119342, COUNT @D119341, PER @D119340, PLU @D119339, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : REPORT, 
   [COORD @D119347, AGR [COUNT @D119346, PER @D119345, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119349, AGR [COUNT @D119348, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119351, AGR [COUNT @D119350, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119355, AGR [COUNT @D119354, PER @D119353, PLU @D119352, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119361, PAST @D119360, 
      AGR [CASE @D119359, COUNT @D119358, PER @D119357, PLU @D119356, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : REPORT, 
   [COORD @D119364, AGR [COUNT @D119363, PER @D119362, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPORT, 
   [COORD @D119366, AGR [COUNT @D119365, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPORT, 
   [COORD @D119368, AGR [COUNT @D119367, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPORT, 
   [COORD @D119372, AGR [COUNT @D119371, PER @D119370, PLU @D119369, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REPORT, 
   [COORD @D119378, PAST @D119377, AGR [CASE @D119376, COUNT @D119375, 
            PER @D119374, PLU @D119373, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REPORT, 
   [COORD @D119381, AGR [COUNT @D119380, PER @D119379, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : REPORT, 
   [COORD @D119383, AGR [COUNT @D119382, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : REPORT, 
   [COORD @D119385, AGR [COUNT @D119384, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : REPORT, 
   [COORD @D119389, AGR [COUNT @D119388, PER @D119387, PLU @D119386, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : REPORT, 
   [COORD @D119395, PAST @D119394, 
      AGR [CASE @D119393, COUNT @D119392, PER @D119391, PLU @D119390, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT BACK, ARITY 1] : REPORT.

WORD reported : 
   [COORD @D119404, AGR [CASE @D119403, COUNT @D119402, PER @D119401, 
            PLU @D119400, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119409, AGR [CASE @D119408, COUNT @D119407, PER @D119406, 
            PLU @D119405, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119414, AGR [CASE @D119413, COUNT @D119412, PER @D119411, 
            PLU @D119410, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119419, AGR [CASE @D119418, COUNT @D119417, PER @D119416, 
            PLU @D119415, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119424, AGR [CASE @D119423, COUNT @D119422, PER @D119421, 
            PLU @D119420, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119429, AGR [CASE @D119428, COUNT @D119427, PER @D119426, 
            PLU @D119425, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119434, AGR [CASE @D119433, COUNT @D119432, PER @D119431, 
            PLU @D119430, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119439, AGR [CASE @D119438, COUNT @D119437, PER @D119436, 
            PLU @D119435, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119444, AGR [UB @D119443, VFORM @D119442, SUBJ @D119441, 
            FIN @D119440, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REPORT, 
   [COORD @D119449, AGR [CASE @D119448, COUNT @D119447, PER @D119446, 
            PLU @D119445, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119454, AGR [CASE @D119453, COUNT @D119452, PER @D119451, 
            PLU @D119450, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119459, AGR [CASE @D119458, COUNT @D119457, PER @D119456, 
            PLU @D119455, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119464, AGR [CASE @D119463, COUNT @D119462, PER @D119461, 
            PLU @D119460, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119469, AGR [UB @D119468, VFORM @D119467, SUBJ @D119466, 
            FIN @D119465, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REPORT, 
   [COORD @D119474, AGR [CASE @D119473, COUNT @D119472, PER @D119471, 
            PLU @D119470, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119479, AGR [CASE @D119478, COUNT @D119477, PER @D119476, 
            PLU @D119475, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119485, AGR [CASE @D119484, NFORM @D119483, COUNT @D119482, 
            PER @D119481, PLU @D119480, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REPORT, 
   [COORD @D119490, AGR [CASE @D119489, COUNT @D119488, PER @D119487, 
            PLU @D119486, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REPORT, 
   [COORD @D119495, AGR [CASE @D119494, COUNT @D119493, PER @D119492, 
            PLU @D119491, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119500, AGR [CASE @D119499, COUNT @D119498, PER @D119497, 
            PLU @D119496, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119505, AGR [CASE @D119504, COUNT @D119503, PER @D119502, 
            PLU @D119501, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119510, AGR [CASE @D119509, COUNT @D119508, PER @D119507, 
            PLU @D119506, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119515, AGR [UB @D119514, VFORM @D119513, SUBJ @D119512, 
            FIN @D119511, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REPORT, 
   [COORD @D119520, AGR [CASE @D119519, COUNT @D119518, PER @D119517, 
            PLU @D119516, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119525, AGR [CASE @D119524, COUNT @D119523, PER @D119522, 
            PLU @D119521, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119530, AGR [CASE @D119529, COUNT @D119528, PER @D119527, 
            PLU @D119526, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119535, AGR [CASE @D119534, COUNT @D119533, PER @D119532, 
            PLU @D119531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119540, AGR [CASE @D119539, COUNT @D119538, PER @D119537, 
            PLU @D119536, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119545, AGR [CASE @D119544, COUNT @D119543, PER @D119542, 
            PLU @D119541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119550, AGR [CASE @D119549, COUNT @D119548, PER @D119547, 
            PLU @D119546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119555, AGR [CASE @D119554, COUNT @D119553, PER @D119552, 
            PLU @D119551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119560, AGR [CASE @D119559, COUNT @D119558, PER @D119557, 
            PLU @D119556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119565, AGR [CASE @D119564, COUNT @D119563, PER @D119562, 
            PLU @D119561, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119570, AGR [CASE @D119569, COUNT @D119568, PER @D119567, 
            PLU @D119566, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119575, AGR [CASE @D119574, COUNT @D119573, PER @D119572, 
            PLU @D119571, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119580, AGR [CASE @D119579, COUNT @D119578, PER @D119577, 
            PLU @D119576, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119585, AGR [CASE @D119584, COUNT @D119583, PER @D119582, 
            PLU @D119581, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPORT.

WORD reporting : 
   [COORD @D119599, PRD @D119598, AGR [CASE @D119597, COUNT @D119596, 
            PER @D119595, PLU @D119594, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119605, PRD @D119604, 
      AGR [CASE @D119603, COUNT @D119602, PER @D119601, PLU @D119600, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REPORT, 
   [COORD @D119611, PRD @D119610, AGR [CASE @D119609, COUNT @D119608, 
            PER @D119607, PLU @D119606, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119617, PRD @D119616, 
      AGR [CASE @D119615, COUNT @D119614, PER @D119613, PLU @D119612, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REPORT, 
   [COORD @D119623, PRD @D119622, AGR [CASE @D119621, COUNT @D119620, 
            PER @D119619, PLU @D119618, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119629, PRD @D119628, 
      AGR [CASE @D119627, COUNT @D119626, PER @D119625, PLU @D119624, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   REPORT, 
   [COORD @D119635, PRD @D119634, AGR [CASE @D119633, COUNT @D119632, 
            PER @D119631, PLU @D119630, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119641, PRD @D119640, 
      AGR [CASE @D119639, COUNT @D119638, PER @D119637, PLU @D119636, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REPORT, 
   [COORD @D119647, PRD @D119646, AGR [CASE @D119645, COUNT @D119644, 
            PER @D119643, PLU @D119642, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119653, PRD @D119652, 
      AGR [CASE @D119651, COUNT @D119650, PER @D119649, PLU @D119648, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REPORT, 
   [COORD @D119659, PRD @D119658, AGR [CASE @D119657, COUNT @D119656, 
            PER @D119655, PLU @D119654, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119665, PRD @D119664, 
      AGR [CASE @D119663, COUNT @D119662, PER @D119661, PLU @D119660, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REPORT, 
   [COORD @D119671, PRD @D119670, AGR [CASE @D119669, COUNT @D119668, 
            PER @D119667, PLU @D119666, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPORT, 
   [COORD @D119677, PRD @D119676, 
      AGR [CASE @D119675, COUNT @D119674, PER @D119673, PLU @D119672, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REPORT.

WORD reports : 
   [COORD @D119686, DEMON @D119685, REFL @D119684, PRD @D119683, 
      CASE @D119682, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REPORT, 
   [COORD @D119688, AGR [COUNT @D119687, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REPORT, 
   [COORD @D119690, AGR [COUNT @D119689, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_PP, PFORM ON_TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REPORT, 
   [COORD @D119692, AGR [COUNT @D119691, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REPORT, 
   [COORD @D119694, AGR [COUNT @D119693, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119696, 
      AGR [COUNT @D119695, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119698, 
      AGR [COUNT @D119697, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119700, 
      AGR [COUNT @D119699, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119702, 
      AGR [COUNT @D119701, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119704, 
      AGR [COUNT @D119703, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119706, 
      AGR [COUNT @D119705, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119708, 
      AGR [COUNT @D119707, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119710, 
      AGR [COUNT @D119709, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119712, 
      AGR [COUNT @D119711, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT, 
   [COORD @D119714, 
      AGR [COUNT @D119713, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPORT.

WORD represent : 
   [COORD @D119719, AGR [COUNT @D119718, PER @D119717, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_SFIN, ARITY 3] : REPRESENT, 
   [COORD @D119721, AGR [COUNT @D119720, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_SFIN, ARITY 3] : REPRESENT, 
   [COORD @D119723, AGR [COUNT @D119722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_SFIN, ARITY 3] : REPRESENT, 
   [COORD @D119727, AGR [COUNT @D119726, PER @D119725, PLU @D119724, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP_SFIN, ARITY 3] : REPRESENT, 
   [COORD @D119733, PAST @D119732, 
      AGR [CASE @D119731, COUNT @D119730, PER @D119729, PLU @D119728, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_SFIN, 
      ARITY 3] : REPRESENT, 
   [COORD @D119736, AGR [COUNT @D119735, PER @D119734, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : REPRESENT, 
   [COORD @D119738, AGR [COUNT @D119737, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : REPRESENT, 
   [COORD @D119740, AGR [COUNT @D119739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : REPRESENT, 
   [COORD @D119744, AGR [COUNT @D119743, PER @D119742, PLU @D119741, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : REPRESENT, 
   [COORD @D119750, PAST @D119749, 
      AGR [CASE @D119748, COUNT @D119747, PER @D119746, PLU @D119745, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : REPRESENT, 
   [COORD @D119753, AGR [COUNT @D119752, PER @D119751, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : REPRESENT, 
   [COORD @D119755, AGR [COUNT @D119754, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : REPRESENT, 
   [COORD @D119757, AGR [COUNT @D119756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : REPRESENT, 
   [COORD @D119761, AGR [COUNT @D119760, PER @D119759, PLU @D119758, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PREP AS, ARITY 3] : REPRESENT, 
   [COORD @D119767, PAST @D119766, 
      AGR [CASE @D119765, COUNT @D119764, PER @D119763, PLU @D119762, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      PREP AS, ARITY 3] : REPRESENT, 
   [COORD @D119770, AGR [COUNT @D119769, PER @D119768, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REPRESENT, 
   [COORD @D119772, AGR [COUNT @D119771, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REPRESENT, 
   [COORD @D119774, AGR [COUNT @D119773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REPRESENT, 
   [COORD @D119778, AGR [COUNT @D119777, PER @D119776, PLU @D119775, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : REPRESENT, 
   [COORD @D119784, PAST @D119783, 
      AGR [CASE @D119782, COUNT @D119781, PER @D119780, PLU @D119779, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : REPRESENT, 
   [COORD @D119787, AGR [COUNT @D119786, PER @D119785, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REPRESENT, 
   [COORD @D119789, AGR [COUNT @D119788, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REPRESENT, 
   [COORD @D119791, AGR [COUNT @D119790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REPRESENT, 
   [COORD @D119795, AGR [COUNT @D119794, PER @D119793, PLU @D119792, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REPRESENT, 
   [COORD @D119801, PAST @D119800, 
      AGR [CASE @D119799, COUNT @D119798, PER @D119797, PLU @D119796, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : REPRESENT, 
   [COORD @D119804, AGR [COUNT @D119803, PER @D119802, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, ARITY 3] : REPRESENT, 
   [COORD @D119806, 
      AGR [COUNT @D119805, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, 
      PFORM AS, ORDER POSTNP, ARITY 3] : REPRESENT, 
   [COORD @D119808, AGR [COUNT @D119807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, ARITY 3] : REPRESENT, 
   [COORD @D119812, 
      AGR [COUNT @D119811, PER @D119810, PLU @D119809, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, ARITY 3] : REPRESENT, 
   [COORD @D119818, PAST @D119817, 
      AGR [CASE @D119816, COUNT @D119815, PER @D119814, PLU @D119813, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, ARITY 3] : REPRESENT, 
   [COORD @D119821, 
      AGR [COUNT @D119820, PER @D119819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   REPRESENT, 
   [COORD @D119823, AGR [COUNT @D119822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPRESENT, 
   [COORD @D119825, AGR [COUNT @D119824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REPRESENT, 
   [COORD @D119829, AGR [COUNT @D119828, PER @D119827, PLU @D119826, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REPRESENT, 
   [COORD @D119835, PAST @D119834, AGR [CASE @D119833, COUNT @D119832, 
            PER @D119831, PLU @D119830, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REPRESENT.

WORD represented : 
   [COORD @D119843, AGR [CASE @D119842, COUNT @D119841, PER @D119840, 
            PLU @D119839, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119848, AGR [CASE @D119847, COUNT @D119846, PER @D119845, 
            PLU @D119844, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119854, AGR [CASE @D119853, NFORM @D119852, COUNT @D119851, 
            PER @D119850, PLU @D119849, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119859, AGR [CASE @D119858, COUNT @D119857, PER @D119856, 
            PLU @D119855, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119864, AGR [CASE @D119863, COUNT @D119862, PER @D119861, 
            PLU @D119860, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119869, AGR [CASE @D119868, COUNT @D119867, PER @D119866, 
            PLU @D119865, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119874, AGR [CASE @D119873, COUNT @D119872, PER @D119871, 
            PLU @D119870, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119880, AGR [CASE @D119879, NFORM @D119878, COUNT @D119877, 
            PER @D119876, PLU @D119875, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, PREP AS, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119885, AGR [CASE @D119884, COUNT @D119883, PER @D119882, 
            PLU @D119881, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119890, AGR [CASE @D119889, COUNT @D119888, PER @D119887, 
            PLU @D119886, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119895, 
      AGR [CASE @D119894, COUNT @D119893, PER @D119892, PLU @D119891, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119900, AGR [CASE @D119899, COUNT @D119898, PER @D119897, 
            PLU @D119896, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119905, AGR [CASE @D119904, COUNT @D119903, PER @D119902, 
            PLU @D119901, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119910, 
      AGR [CASE @D119909, COUNT @D119908, PER @D119907, PLU @D119906, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119915, AGR [CASE @D119914, COUNT @D119913, PER @D119912, 
            PLU @D119911, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM AS, 
      ORDER POSTNP, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, 
      PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119920, 
      AGR [CASE @D119919, COUNT @D119918, PER @D119917, PLU @D119916, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119925, 
      AGR [CASE @D119924, COUNT @D119923, PER @D119922, PLU @D119921, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119930, 
      AGR [CASE @D119929, COUNT @D119928, PER @D119927, PLU @D119926, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, 
      FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   REPRESENT, 
   [COORD @D119935, AGR [CASE @D119934, COUNT @D119933, PER @D119932, 
            PLU @D119931, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119940, AGR [CASE @D119939, COUNT @D119938, PER @D119937, 
            PLU @D119936, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REPRESENT.

WORD representing : 
   [COORD @D119951, PRD @D119950, AGR [CASE @D119949, COUNT @D119948, 
            PER @D119947, PLU @D119946, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP_SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119957, PRD @D119956, 
      AGR [CASE @D119955, COUNT @D119954, PER @D119953, PLU @D119952, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   REPRESENT, 
   [COORD @D119963, PRD @D119962, AGR [CASE @D119961, COUNT @D119960, 
            PER @D119959, PLU @D119958, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119969, PRD @D119968, 
      AGR [CASE @D119967, COUNT @D119966, PER @D119965, PLU @D119964, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REPRESENT, 
   [COORD @D119975, PRD @D119974, AGR [CASE @D119973, COUNT @D119972, 
            PER @D119971, PLU @D119970, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119981, PRD @D119980, 
      AGR [CASE @D119979, COUNT @D119978, PER @D119977, PLU @D119976, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D119987, PRD @D119986, 
      AGR [CASE @D119985, COUNT @D119984, PER @D119983, PLU @D119982, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REPRESENT.

WORD represents : 
   [COORD @D119992, AGR [COUNT @D119991, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   REPRESENT, 
   [COORD @D119994, AGR [COUNT @D119993, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   REPRESENT, 
   [COORD @D119996, AGR [COUNT @D119995, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, PREP AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REPRESENT, 
   [COORD @D119998, AGR [COUNT @D119997, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REPRESENT, 
   [COORD @D120000, AGR [COUNT @D119999, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REPRESENT, 
   [COORD @D120002, AGR [COUNT @D120001, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM AS, ORDER POSTNP, AUX -, 
      INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST -, BAR 0, V +, N -] : REPRESENT, 
   [COORD @D120004, AGR [COUNT @D120003, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REPRESENT.

WORD require : 
   [COORD @D120010, AGR [COUNT @D120009, PER @D120008, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : REQUIRE, 
   [COORD @D120012, AGR [COUNT @D120011, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : REQUIRE, 
   [COORD @D120014, AGR [COUNT @D120013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : REQUIRE, 
   [COORD @D120018, AGR [COUNT @D120017, PER @D120016, PLU @D120015, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : REQUIRE, 
   [COORD @D120024, PAST @D120023, 
      AGR [CASE @D120022, COUNT @D120021, PER @D120020, PLU @D120019, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OF, ARITY 3] : REQUIRE, 
   [COORD @D120027, AGR [COUNT @D120026, PER @D120025, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REQUIRE, 
   [COORD @D120029, AGR [COUNT @D120028, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REQUIRE, 
   [COORD @D120031, AGR [COUNT @D120030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REQUIRE, 
   [COORD @D120035, AGR [COUNT @D120034, PER @D120033, PLU @D120032, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : REQUIRE, 
   [COORD @D120041, PAST @D120040, 
      AGR [CASE @D120039, COUNT @D120038, PER @D120037, PLU @D120036, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : REQUIRE, 
   [COORD @D120044, AGR [COUNT @D120043, PER @D120042, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : REQUIRE, 
   [COORD @D120046, AGR [COUNT @D120045, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : REQUIRE, 
   [COORD @D120048, AGR [COUNT @D120047, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : REQUIRE, 
   [COORD @D120052, AGR [COUNT @D120051, PER @D120050, PLU @D120049, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : REQUIRE, 
   [COORD @D120058, PAST @D120057, AGR [CASE @D120056, COUNT @D120055, 
            PER @D120054, PLU @D120053, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : REQUIRE, 
   [COORD @D120061, AGR [COUNT @D120060, PER @D120059, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REQUIRE, 
   [COORD @D120063, AGR [COUNT @D120062, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REQUIRE, 
   [COORD @D120065, AGR [COUNT @D120064, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REQUIRE, 
   [COORD @D120069, AGR [COUNT @D120068, PER @D120067, PLU @D120066, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REQUIRE, 
   [COORD @D120075, PAST @D120074, 
      AGR [CASE @D120073, COUNT @D120072, PER @D120071, PLU @D120070, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      ARITY 2] : REQUIRE, 
   [COORD @D120078, AGR [COUNT @D120077, PER @D120076, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REQUIRE, 
   [COORD @D120080, AGR [COUNT @D120079, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REQUIRE, 
   [COORD @D120082, AGR [COUNT @D120081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REQUIRE, 
   [COORD @D120086, AGR [COUNT @D120085, PER @D120084, PLU @D120083, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REQUIRE, 
   [COORD @D120092, PAST @D120091, AGR [CASE @D120090, COUNT @D120089, 
            PER @D120088, PLU @D120087, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REQUIRE.

WORD required : 
   [COORD @D120101, AGR [CASE @D120100, COUNT @D120099, PER @D120098, 
            PLU @D120097, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120106, AGR [CASE @D120105, COUNT @D120104, PER @D120103, 
            PLU @D120102, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120111, AGR [CASE @D120110, COUNT @D120109, PER @D120108, 
            PLU @D120107, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120116, AGR [CASE @D120115, COUNT @D120114, PER @D120113, 
            PLU @D120112, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120121, AGR [CASE @D120120, COUNT @D120119, PER @D120118, 
            PLU @D120117, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120126, AGR [CASE @D120125, COUNT @D120124, PER @D120123, 
            PLU @D120122, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120131, AGR [CASE @D120130, COUNT @D120129, PER @D120128, 
            PLU @D120127, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120136, AGR [CASE @D120135, COUNT @D120134, PER @D120133, 
            PLU @D120132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120141, AGR [CASE @D120140, COUNT @D120139, PER @D120138, 
            PLU @D120137, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120147, AGR [CASE @D120146, NFORM @D120145, COUNT @D120144, 
            PER @D120143, PLU @D120142, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120152, AGR [UB @D120151, VFORM @D120150, SUBJ @D120149, 
            FIN @D120148, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REQUIRE, 
   [COORD @D120157, AGR [CASE @D120156, COUNT @D120155, PER @D120154, 
            PLU @D120153, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120162, AGR [CASE @D120161, COUNT @D120160, PER @D120159, 
            PLU @D120158, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120167, AGR [CASE @D120166, COUNT @D120165, PER @D120164, 
            PLU @D120163, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REQUIRE.

WORD requires : 
   [COORD @D120173, AGR [COUNT @D120172, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REQUIRE, 
   [COORD @D120175, AGR [COUNT @D120174, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   REQUIRE, 
   [COORD @D120177, AGR [COUNT @D120176, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120179, 
      AGR [COUNT @D120178, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120181, 
      AGR [COUNT @D120180, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REQUIRE.

WORD requiring : 
   [COORD @D120190, PRD @D120189, AGR [CASE @D120188, COUNT @D120187, 
            PER @D120186, PLU @D120185, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120196, PRD @D120195, 
      AGR [CASE @D120194, COUNT @D120193, PER @D120192, PLU @D120191, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REQUIRE, 
   [COORD @D120202, PRD @D120201, AGR [CASE @D120200, COUNT @D120199, 
            PER @D120198, PLU @D120197, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REQUIRE, 
   [COORD @D120208, PRD @D120207, 
      AGR [CASE @D120206, COUNT @D120205, PER @D120204, PLU @D120203, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   REQUIRE, 
   [COORD @D120214, PRD @D120213, AGR [CASE @D120212, COUNT @D120211, 
            PER @D120210, PLU @D120209, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REQUIRE.

WORD research : 
   [COORD @D120221, REFL @D120220, COUNT @D120219, PRD @D120218, 
      CASE @D120217, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RESEARCH, 
   [COORD @D120224, 
      AGR [COUNT @D120223, PER @D120222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   RESEARCH, 
   [COORD @D120226, AGR [COUNT @D120225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RESEARCH, 
   [COORD @D120228, AGR [COUNT @D120227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RESEARCH, 
   [COORD @D120232, AGR [COUNT @D120231, PER @D120230, PLU @D120229, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RESEARCH, 
   [COORD @D120238, PAST @D120237, AGR [CASE @D120236, COUNT @D120235, 
            PER @D120234, PLU @D120233, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RESEARCH, 
   [COORD @D120241, AGR [COUNT @D120240, PER @D120239, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RESEARCH, 
   [COORD @D120243, AGR [COUNT @D120242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RESEARCH, 
   [COORD @D120245, AGR [COUNT @D120244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RESEARCH, 
   [COORD @D120249, AGR [COUNT @D120248, PER @D120247, PLU @D120246, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : RESEARCH, 
   [COORD @D120255, PAST @D120254, 
      AGR [CASE @D120253, COUNT @D120252, PER @D120251, PLU @D120250, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RESEARCH, 
   [COORD @D120258, AGR [COUNT @D120257, PER @D120256, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : RESEARCH, 
   [COORD @D120260, AGR [COUNT @D120259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : RESEARCH, 
   [COORD @D120262, AGR [COUNT @D120261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : RESEARCH, 
   [COORD @D120266, AGR [COUNT @D120265, PER @D120264, PLU @D120263, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : RESEARCH, 
   [COORD @D120272, PAST @D120271, 
      AGR [CASE @D120270, COUNT @D120269, PER @D120268, PLU @D120267, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : RESEARCH, 
   [COORD @D120275, AGR [COUNT @D120274, PER @D120273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESEARCH, 
   [COORD @D120277, AGR [COUNT @D120276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESEARCH, 
   [COORD @D120279, AGR [COUNT @D120278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESEARCH, 
   [COORD @D120283, AGR [COUNT @D120282, PER @D120281, PLU @D120280, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESEARCH, 
   [COORD @D120289, PAST @D120288, AGR 
         [CASE @D120287, COUNT @D120286, PER @D120285, PLU @D120284, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      ARITY 1] : RESEARCH.

WORD researched : 
   [COORD @D120298, AGR [CASE @D120297, COUNT @D120296, PER @D120295, 
            PLU @D120294, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120303, AGR [CASE @D120302, COUNT @D120301, PER @D120300, 
            PLU @D120299, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120308, AGR [CASE @D120307, COUNT @D120306, PER @D120305, 
            PLU @D120304, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120313, AGR [CASE @D120312, COUNT @D120311, PER @D120310, 
            PLU @D120309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120318, AGR [CASE @D120317, COUNT @D120316, PER @D120315, 
            PLU @D120314, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120323, AGR [CASE @D120322, COUNT @D120321, PER @D120320, 
            PLU @D120319, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120328, AGR [CASE @D120327, COUNT @D120326, PER @D120325, 
            PLU @D120324, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120333, AGR [CASE @D120332, COUNT @D120331, PER @D120330, 
            PLU @D120329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120338, AGR [CASE @D120337, COUNT @D120336, PER @D120335, 
            PLU @D120334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RESEARCH.

WORD researches : 
   [COORD @D120347, DEMON @D120346, REFL @D120345, PRD @D120344, 
      CASE @D120343, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RESEARCH, 
   [COORD @D120349, AGR [COUNT @D120348, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESEARCH, 
   
   [COORD @D120351, AGR [COUNT @D120350, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESEARCH, 
   
   [COORD @D120353, AGR [COUNT @D120352, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESEARCH, 
   
   [COORD @D120355, AGR [COUNT @D120354, NFORM NORM, PLU -, PER 3, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESEARCH.

WORD researching : 
   [COORD @D120369, PRD @D120368, AGR [CASE @D120367, COUNT @D120366, 
            PER @D120365, PLU @D120364, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120375, PRD @D120374, 
      AGR [CASE @D120373, COUNT @D120372, PER @D120371, PLU @D120370, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120381, PRD @D120380, AGR [CASE @D120379, COUNT @D120378, 
            PER @D120377, PLU @D120376, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RESEARCH, 
   [COORD @D120387, PRD @D120386, 
      AGR [CASE @D120385, COUNT @D120384, PER @D120383, PLU @D120382, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RESEARCH.

WORD reserve : 
   [COORD @D120397, AGR [COUNT @D120396, PER @D120395, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RESERVE, 
   [COORD @D120399, AGR [COUNT @D120398, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RESERVE, 
   [COORD @D120401, AGR [COUNT @D120400, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RESERVE, 
   [COORD @D120405, AGR [COUNT @D120404, PER @D120403, PLU @D120402, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RESERVE, 
   [COORD @D120411, PAST @D120410, AGR 
         [CASE @D120409, COUNT @D120408, PER @D120407, PLU @D120406, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      ARITY 3] : RESERVE, 
   [COORD @D120414, AGR [COUNT @D120413, PER @D120412, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RESERVE, 
   [COORD @D120416, AGR [COUNT @D120415, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RESERVE, 
   [COORD @D120418, AGR [COUNT @D120417, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RESERVE, 
   [COORD @D120422, AGR [COUNT @D120421, PER @D120420, PLU @D120419, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : RESERVE, 
   [COORD @D120428, PAST @D120427, 
      AGR [CASE @D120426, COUNT @D120425, PER @D120424, PLU @D120423, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : RESERVE, 
   [COORD @D120431, AGR [COUNT @D120430, PER @D120429, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RESERVE, 
   [COORD @D120433, AGR [COUNT @D120432, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RESERVE, 
   [COORD @D120435, AGR [COUNT @D120434, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RESERVE, 
   [COORD @D120439, AGR [COUNT @D120438, PER @D120437, PLU @D120436, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RESERVE, 
   [COORD @D120445, PAST @D120444, AGR [CASE @D120443, COUNT @D120442, 
            PER @D120441, PLU @D120440, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RESERVE.

WORD reserved : 
   [COADV @D120457, COORD @D120456, DEF @D120455, PRD @D120454, 
      AGR [CASE @D120453, COUNT @D120452, PER @D120451, PLU @D120450, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : RESERVED, 
   [COORD @D120462, AGR [CASE @D120461, COUNT @D120460, PER @D120459, 
            PLU @D120458, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RESERVE, 
   [COORD @D120467, AGR [CASE @D120466, COUNT @D120465, PER @D120464, 
            PLU @D120463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120472, AGR [CASE @D120471, COUNT @D120470, PER @D120469, 
            PLU @D120468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120477, AGR [CASE @D120476, COUNT @D120475, PER @D120474, 
            PLU @D120473, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120482, AGR [CASE @D120481, COUNT @D120480, PER @D120479, 
            PLU @D120478, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120487, AGR [CASE @D120486, COUNT @D120485, PER @D120484, 
            PLU @D120483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120492, AGR [CASE @D120491, COUNT @D120490, PER @D120489, 
            PLU @D120488, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RESERVE, 
   [COORD @D120497, AGR [CASE @D120496, COUNT @D120495, PER @D120494, 
            PLU @D120493, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120502, AGR [CASE @D120501, COUNT @D120500, PER @D120499, 
            PLU @D120498, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RESERVE.

WORD reserves : 
   [COORD @D120508, AGR [COUNT @D120507, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120510, 
      AGR [COUNT @D120509, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120512, 
      AGR [COUNT @D120511, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESERVE.

WORD reserving : 
   [COORD @D120521, PRD @D120520, AGR [CASE @D120519, COUNT @D120518, 
            PER @D120517, PLU @D120516, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESERVE, 
   [COORD @D120527, PRD @D120526, 
      AGR [CASE @D120525, COUNT @D120524, PER @D120523, PLU @D120522, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RESERVE, 
   [COORD @D120533, PRD @D120532, AGR [CASE @D120531, COUNT @D120530, 
            PER @D120529, PLU @D120528, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESERVE.

WORD rest : 
   [COORD @D120539, REFL @D120538, PRD @D120537, CASE @D120536, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : REST, 
   [COORD @D120544, REFL @D120543, COUNT @D120542, PRD @D120541, 
      CASE @D120540, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : REST, 
   [COORD @D120548, REFL @D120547, PRD @D120546, CASE @D120545, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, GROUP +, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT -] : REST, 
   [COORD @D120553, REFL @D120552, COUNT @D120551, PRD @D120550, 
      CASE @D120549, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM] : 
   REST, 
   [COORD @D120558, REFL @D120557, COUNT @D120556, PRD @D120555, 
      CASE @D120554, FIX NOT, BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      GROUP +, INFL -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : REST, 
   [COORD @D120561, 
      AGR [COUNT @D120560, PER @D120559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM ON, 
      ARITY 3] : REST, 
   [COORD @D120563, AGR [COUNT @D120562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : REST, 
   [COORD @D120565, AGR [COUNT @D120564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : REST, 
   [COORD @D120569, AGR [COUNT @D120568, PER @D120567, PLU @D120566, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : REST, 
   [COORD @D120575, PAST @D120574, 
      AGR [CASE @D120573, COUNT @D120572, PER @D120571, PLU @D120570, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : REST, 
   [COORD @D120578, AGR [COUNT @D120577, PER @D120576, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : REST, 
   [COORD @D120580, AGR [COUNT @D120579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : REST, 
   [COORD @D120582, AGR [COUNT @D120581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : REST, 
   [COORD @D120586, AGR [COUNT @D120585, PER @D120584, PLU @D120583, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : REST, 
   [COORD @D120592, PAST @D120591, 
      AGR [CASE @D120590, COUNT @D120589, PER @D120588, PLU @D120587, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AGAINST, ARITY 3] : REST, 
   [COORD @D120595, AGR [COUNT @D120594, PER @D120593, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REST, 
   [COORD @D120597, AGR [COUNT @D120596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REST, 
   [COORD @D120599, AGR [COUNT @D120598, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REST, 
   [COORD @D120603, AGR [COUNT @D120602, PER @D120601, PLU @D120600, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REST, 
   [COORD @D120609, PAST @D120608, AGR [CASE @D120607, COUNT @D120606, 
            PER @D120605, PLU @D120604, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REST, 
   [COORD @D120612, AGR [COUNT @D120611, PER @D120610, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : REST, 
   [COORD @D120614, AGR [COUNT @D120613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : REST, 
   [COORD @D120616, AGR [COUNT @D120615, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : REST, 
   [COORD @D120620, AGR [COUNT @D120619, PER @D120618, PLU @D120617, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : REST, 
   [COORD @D120626, PAST @D120625, 
      AGR [CASE @D120624, COUNT @D120623, PER @D120622, PLU @D120621, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : REST, 
   [COORD @D120629, AGR [COUNT @D120628, PER @D120627, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REST, 
   [COORD @D120631, AGR [COUNT @D120630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REST, 
   [COORD @D120633, AGR [COUNT @D120632, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REST, 
   [COORD @D120637, AGR [COUNT @D120636, PER @D120635, PLU @D120634, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : REST, 
   [COORD @D120643, PAST @D120642, 
      AGR [CASE @D120641, COUNT @D120640, PER @D120639, PLU @D120638, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : REST, 
   [COORD @D120646, AGR [COUNT @D120645, PER @D120644, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REST, 
   [COORD @D120648, AGR [COUNT @D120647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REST, 
   [COORD @D120650, AGR [COUNT @D120649, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REST, 
   [COORD @D120654, AGR [COUNT @D120653, PER @D120652, PLU @D120651, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : REST, 
   [COORD @D120660, PAST @D120659, 
      AGR [CASE @D120658, COUNT @D120657, PER @D120656, PLU @D120655, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : REST, 
   [COORD @D120663, AGR [COUNT @D120662, PER @D120661, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REST, 
   [COORD @D120665, AGR [COUNT @D120664, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REST, 
   [COORD @D120667, AGR [COUNT @D120666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REST, 
   [COORD @D120671, AGR [COUNT @D120670, PER @D120669, PLU @D120668, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : REST, 
   [COORD @D120677, PAST @D120676, 
      AGR [CASE @D120675, COUNT @D120674, PER @D120673, PLU @D120672, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : REST, 
   [COORD @D120680, AGR [COUNT @D120679, PER @D120678, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REST, 
   [COORD @D120682, AGR [COUNT @D120681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REST, 
   [COORD @D120684, AGR [COUNT @D120683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REST, 
   [COORD @D120688, AGR [COUNT @D120687, PER @D120686, PLU @D120685, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REST, 
   [COORD @D120694, PAST @D120693, AGR [CASE @D120692, COUNT @D120691, 
            PER @D120690, PLU @D120689, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REST.

WORD rested : 
   [COORD @D120703, AGR [CASE @D120702, COUNT @D120701, PER @D120700, 
            PLU @D120699, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120708, AGR [CASE @D120707, COUNT @D120706, PER @D120705, 
            PLU @D120704, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120713, AGR [CASE @D120712, COUNT @D120711, PER @D120710, 
            PLU @D120709, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REST, 
   [COORD @D120718, AGR [CASE @D120717, COUNT @D120716, PER @D120715, 
            PLU @D120714, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120723, AGR [CASE @D120722, COUNT @D120721, PER @D120720, 
            PLU @D120719, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120728, AGR [CASE @D120727, COUNT @D120726, PER @D120725, 
            PLU @D120724, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REST, 
   [COORD @D120733, AGR [CASE @D120732, COUNT @D120731, PER @D120730, 
            PLU @D120729, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120738, AGR [CASE @D120737, COUNT @D120736, PER @D120735, 
            PLU @D120734, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REST, 
   [COORD @D120743, AGR [CASE @D120742, COUNT @D120741, PER @D120740, 
            PLU @D120739, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REST, 
   [COORD @D120748, AGR [CASE @D120747, COUNT @D120746, PER @D120745, 
            PLU @D120744, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120753, AGR [CASE @D120752, COUNT @D120751, PER @D120750, 
            PLU @D120749, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120758, AGR [CASE @D120757, COUNT @D120756, PER @D120755, 
            PLU @D120754, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REST, 
   [COORD @D120763, AGR [CASE @D120762, COUNT @D120761, PER @D120760, 
            PLU @D120759, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120768, AGR [CASE @D120767, COUNT @D120766, PER @D120765, 
            PLU @D120764, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120773, AGR [CASE @D120772, COUNT @D120771, PER @D120770, 
            PLU @D120769, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REST, 
   [COORD @D120778, AGR [CASE @D120777, COUNT @D120776, PER @D120775, 
            PLU @D120774, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120783, AGR [CASE @D120782, COUNT @D120781, PER @D120780, 
            PLU @D120779, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REST, 
   [COORD @D120788, AGR [CASE @D120787, COUNT @D120786, PER @D120785, 
            PLU @D120784, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120793, AGR [CASE @D120792, COUNT @D120791, PER @D120790, 
            PLU @D120789, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120798, AGR [CASE @D120797, COUNT @D120796, PER @D120795, 
            PLU @D120794, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : REST, 
   [COORD @D120803, AGR [CASE @D120802, COUNT @D120801, PER @D120800, 
            PLU @D120799, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120808, AGR [CASE @D120807, COUNT @D120806, PER @D120805, 
            PLU @D120804, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REST.

WORD resting : 
   [COORD @D120822, PRD @D120821, AGR [CASE @D120820, COUNT @D120819, 
            PER @D120818, PLU @D120817, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120828, PRD @D120827, 
      AGR [CASE @D120826, COUNT @D120825, PER @D120824, PLU @D120823, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120834, PRD @D120833, AGR [CASE @D120832, COUNT @D120831, 
            PER @D120830, PLU @D120829, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120840, PRD @D120839, 
      AGR [CASE @D120838, COUNT @D120837, PER @D120836, PLU @D120835, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REST, 
   [COORD @D120846, PRD @D120845, AGR [CASE @D120844, COUNT @D120843, 
            PER @D120842, PLU @D120841, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120852, PRD @D120851, 
      AGR [CASE @D120850, COUNT @D120849, PER @D120848, PLU @D120847, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REST, 
   [COORD @D120858, PRD @D120857, AGR [CASE @D120856, COUNT @D120855, 
            PER @D120854, PLU @D120853, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REST, 
   [COORD @D120864, PRD @D120863, 
      AGR [CASE @D120862, COUNT @D120861, PER @D120860, PLU @D120859, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REST.

WORD rests : 
   [COORD @D120873, DEMON @D120872, REFL @D120871, PRD @D120870, 
      CASE @D120869, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REST, 
   [COORD @D120878, DEMON @D120877, REFL @D120876, PRD @D120875, 
      CASE @D120874, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FROM, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REST, 
   [COORD @D120880, AGR [COUNT @D120879, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REST, 
   [COORD @D120882, AGR [COUNT @D120881, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REST, 
   [COORD @D120884, AGR [COUNT @D120883, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REST, 
   [COORD @D120886, 
      AGR [COUNT @D120885, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REST, 
   [COORD @D120888, 
      AGR [COUNT @D120887, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REST, 
   [COORD @D120890, 
      AGR [COUNT @D120889, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REST, 
   [COORD @D120892, 
      AGR [COUNT @D120891, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REST, 
   [COORD @D120894, 
      AGR [COUNT @D120893, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REST.

WORD result : 
   [COORD @D120901, REFL @D120900, COUNT @D120899, PRD @D120898, 
      CASE @D120897, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RESULT, 
   [COORD @D120904, 
      AGR [COUNT @D120903, PER @D120902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : RESULT, 
   [COORD @D120906, AGR [COUNT @D120905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : RESULT, 
   [COORD @D120908, AGR [COUNT @D120907, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : RESULT, 
   [COORD @D120912, AGR [COUNT @D120911, PER @D120910, PLU @D120909, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, ARITY 2] : RESULT, 
   [COORD @D120918, PAST @D120917, 
      AGR [CASE @D120916, COUNT @D120915, PER @D120914, PLU @D120913, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : RESULT, 
   [COORD @D120921, AGR [COUNT @D120920, PER @D120919, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RESULT, 
   [COORD @D120923, AGR [COUNT @D120922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RESULT, 
   [COORD @D120925, AGR [COUNT @D120924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RESULT, 
   [COORD @D120929, AGR [COUNT @D120928, PER @D120927, PLU @D120926, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : RESULT, 
   [COORD @D120935, PAST @D120934, 
      AGR [CASE @D120933, COUNT @D120932, PER @D120931, PLU @D120930, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RESULT, 
   [COORD @D120938, AGR [COUNT @D120937, PER @D120936, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESULT, 
   [COORD @D120940, AGR [COUNT @D120939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESULT, 
   [COORD @D120942, AGR [COUNT @D120941, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESULT, 
   [COORD @D120946, AGR [COUNT @D120945, PER @D120944, PLU @D120943, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RESULT, 
   [COORD @D120952, PAST @D120951, AGR [CASE @D120950, COUNT @D120949, 
            PER @D120948, PLU @D120947, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : RESULT.

WORD resulted : 
   [COORD @D120961, AGR [CASE @D120960, COUNT @D120959, PER @D120958, 
            PLU @D120957, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RESULT, 
   [COORD @D120966, AGR [CASE @D120965, COUNT @D120964, PER @D120963, 
            PLU @D120962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESULT, 
   [COORD @D120971, AGR [CASE @D120970, COUNT @D120969, PER @D120968, 
            PLU @D120967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RESULT, 
   [COORD @D120976, AGR [CASE @D120975, COUNT @D120974, PER @D120973, 
            PLU @D120972, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESULT, 
   [COORD @D120981, AGR [CASE @D120980, COUNT @D120979, PER @D120978, 
            PLU @D120977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RESULT, 
   [COORD @D120986, AGR [CASE @D120985, COUNT @D120984, PER @D120983, 
            PLU @D120982, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RESULT, 
   [COORD @D120991, AGR [CASE @D120990, COUNT @D120989, PER @D120988, 
            PLU @D120987, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RESULT, 
   [COORD @D120996, AGR [CASE @D120995, COUNT @D120994, PER @D120993, 
            PLU @D120992, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RESULT.

WORD resulting : 
   [COORD @D121010, PRD @D121009, AGR [CASE @D121008, COUNT @D121007, 
            PER @D121006, PLU @D121005, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RESULT, 
   [COORD @D121016, PRD @D121015, 
      AGR [CASE @D121014, COUNT @D121013, PER @D121012, PLU @D121011, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RESULT, 
   [COORD @D121022, PRD @D121021, AGR [CASE @D121020, COUNT @D121019, 
            PER @D121018, PLU @D121017, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RESULT.

WORD results : 
   [COORD @D121031, DEMON @D121030, REFL @D121029, PRD @D121028, 
      CASE @D121027, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RESULT, 
   [COORD @D121033, AGR [COUNT @D121032, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RESULT, 
   [COORD @D121035, AGR [COUNT @D121034, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RESULT, 
   [COORD @D121037, AGR [COUNT @D121036, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RESULT.

WORD return : 
   [COADV @D121047, COORD @D121046, DEF @D121045, PRD @D121044, 
      AGR [CASE @D121043, COUNT @D121042, PER @D121041, PLU @D121040, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : RETURN, 
   [COORD @D121051, REFL @D121050, PRD @D121049, CASE @D121048, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RETURN, 
   [COORD @D121056, REFL @D121055, COUNT @D121054, PRD @D121053, 
      CASE @D121052, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RETURN, 
   [COORD @D121060, REFL @D121059, PRD @D121058, CASE @D121057, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : RETURN, 
   [COORD @D121064, REFL @D121063, PRD @D121062, CASE @D121061, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, COUNT +] : RETURN, 
   [COORD @D121068, REFL @D121067, PRD @D121066, CASE @D121065, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : RETURN, 
   [COORD @D121071, 
      AGR [COUNT @D121070, PER @D121069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      ARITY 3] : RETURN, 
   [COORD @D121073, AGR [COUNT @D121072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : RETURN, 
   [COORD @D121075, AGR [COUNT @D121074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : RETURN, 
   [COORD @D121079, AGR [COUNT @D121078, PER @D121077, PLU @D121076, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : RETURN, 
   [COORD @D121085, PAST @D121084, AGR [CASE @D121083, COUNT @D121082, 
            PER @D121081, PLU @D121080, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : RETURN, 
   [COORD @D121088, AGR [COUNT @D121087, PER @D121086, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RETURN, 
   [COORD @D121090, AGR [COUNT @D121089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RETURN, 
   [COORD @D121092, AGR [COUNT @D121091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RETURN, 
   [COORD @D121096, AGR [COUNT @D121095, PER @D121094, PLU @D121093, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : RETURN, 
   [COORD @D121102, PAST @D121101, AGR [CASE @D121100, COUNT @D121099, 
            PER @D121098, PLU @D121097, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : RETURN, 
   [COORD @D121105, AGR [COUNT @D121104, PER @D121103, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RETURN, 
   [COORD @D121107, AGR [COUNT @D121106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RETURN, 
   [COORD @D121109, AGR [COUNT @D121108, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RETURN, 
   [COORD @D121113, AGR [COUNT @D121112, PER @D121111, PLU @D121110, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : RETURN, 
   [COORD @D121119, PAST @D121118, 
      AGR [CASE @D121117, COUNT @D121116, PER @D121115, PLU @D121114, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : RETURN, 
   [COORD @D121122, AGR [COUNT @D121121, PER @D121120, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM FROM_TO, ARITY 3] : RETURN, 
   [COORD @D121124, AGR [COUNT @D121123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM FROM_TO, ARITY 3] : RETURN, 
   [COORD @D121126, AGR [COUNT @D121125, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM FROM_TO, ARITY 3] : RETURN, 
   [COORD @D121130, AGR [COUNT @D121129, PER @D121128, PLU @D121127, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM FROM_TO, ARITY 3] : RETURN, 
   [COORD @D121136, PAST @D121135, 
      AGR [CASE @D121134, COUNT @D121133, PER @D121132, PLU @D121131, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM FROM_TO, ARITY 3] : RETURN, 
   [COORD @D121139, AGR [COUNT @D121138, PER @D121137, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RETURN, 
   [COORD @D121141, AGR [COUNT @D121140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RETURN, 
   [COORD @D121143, AGR [COUNT @D121142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RETURN, 
   [COORD @D121147, AGR [COUNT @D121146, PER @D121145, PLU @D121144, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RETURN, 
   [COORD @D121153, PAST @D121152, AGR [CASE @D121151, COUNT @D121150, 
            PER @D121149, PLU @D121148, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : RETURN, 
   [COORD @D121156, AGR [COUNT @D121155, PER @D121154, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RETURN, 
   [COORD @D121158, AGR [COUNT @D121157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RETURN, 
   [COORD @D121160, AGR [COUNT @D121159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RETURN, 
   [COORD @D121164, AGR [COUNT @D121163, PER @D121162, PLU @D121161, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RETURN, 
   [COORD @D121170, PAST @D121169, AGR [CASE @D121168, COUNT @D121167, 
            PER @D121166, PLU @D121165, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RETURN, 
   [COORD @D121173, AGR [COUNT @D121172, PER @D121171, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RETURN, 
   [COORD @D121175, AGR [COUNT @D121174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RETURN, 
   [COORD @D121177, AGR [COUNT @D121176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RETURN, 
   [COORD @D121181, AGR [COUNT @D121180, PER @D121179, PLU @D121178, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : RETURN, 
   [COORD @D121187, PAST @D121186, 
      AGR [CASE @D121185, COUNT @D121184, PER @D121183, PLU @D121182, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : RETURN, 
   [COORD @D121190, AGR [COUNT @D121189, PER @D121188, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RETURN, 
   [COORD @D121192, AGR [COUNT @D121191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RETURN, 
   [COORD @D121194, AGR [COUNT @D121193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RETURN, 
   [COORD @D121198, AGR [COUNT @D121197, PER @D121196, PLU @D121195, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : RETURN, 
   [COORD @D121204, PAST @D121203, 
      AGR [CASE @D121202, COUNT @D121201, PER @D121200, PLU @D121199, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : RETURN, 
   [COORD @D121207, AGR [COUNT @D121206, PER @D121205, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RETURN, 
   [COORD @D121209, AGR [COUNT @D121208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RETURN, 
   [COORD @D121211, AGR [COUNT @D121210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RETURN, 
   [COORD @D121215, AGR [COUNT @D121214, PER @D121213, PLU @D121212, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RETURN, 
   [COORD @D121221, PAST @D121220, AGR [CASE @D121219, COUNT @D121218, 
            PER @D121217, PLU @D121216, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : RETURN.

WORD returned : 
   [COORD @D121231, AGR [CASE @D121230, COUNT @D121229, PER @D121228, 
            PLU @D121227, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121236, AGR [CASE @D121235, COUNT @D121234, PER @D121233, 
            PLU @D121232, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121242, AGR [CASE @D121241, NFORM @D121240, COUNT @D121239, 
            PER @D121238, PLU @D121237, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RETURN, 
   [COORD @D121247, AGR [CASE @D121246, COUNT @D121245, PER @D121244, 
            PLU @D121243, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RETURN, 
   [COORD @D121252, AGR [CASE @D121251, COUNT @D121250, PER @D121249, 
            PLU @D121248, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121257, AGR [CASE @D121256, COUNT @D121255, PER @D121254, 
            PLU @D121253, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121262, AGR [CASE @D121261, COUNT @D121260, PER @D121259, 
            PLU @D121258, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121267, AGR [CASE @D121266, COUNT @D121265, PER @D121264, 
            PLU @D121263, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121272, AGR [CASE @D121271, COUNT @D121270, PER @D121269, 
            PLU @D121268, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121277, AGR [CASE @D121276, COUNT @D121275, PER @D121274, 
            PLU @D121273, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM FROM_TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121282, AGR [CASE @D121281, COUNT @D121280, PER @D121279, 
            PLU @D121278, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM FROM_TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121287, AGR [CASE @D121286, COUNT @D121285, PER @D121284, 
            PLU @D121283, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121292, AGR [CASE @D121291, COUNT @D121290, PER @D121289, 
            PLU @D121288, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121297, AGR [UB @D121296, VFORM @D121295, SUBJ @D121294, 
            FIN @D121293, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RETURN, 
   [COORD @D121302, AGR [CASE @D121301, COUNT @D121300, PER @D121299, 
            PLU @D121298, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121307, AGR [CASE @D121306, COUNT @D121305, PER @D121304, 
            PLU @D121303, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121312, AGR [CASE @D121311, COUNT @D121310, PER @D121309, 
            PLU @D121308, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RETURN, 
   [COORD @D121317, AGR [CASE @D121316, COUNT @D121315, PER @D121314, 
            PLU @D121313, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121322, AGR [CASE @D121321, COUNT @D121320, PER @D121319, 
            PLU @D121318, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121327, AGR [CASE @D121326, COUNT @D121325, PER @D121324, 
            PLU @D121323, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121332, AGR [CASE @D121331, COUNT @D121330, PER @D121329, 
            PLU @D121328, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121337, AGR [CASE @D121336, COUNT @D121335, PER @D121334, 
            PLU @D121333, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121342, AGR [CASE @D121341, COUNT @D121340, PER @D121339, 
            PLU @D121338, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121347, AGR [CASE @D121346, COUNT @D121345, PER @D121344, 
            PLU @D121343, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RETURN.

WORD returning : 
   [COORD @D121364, PRD @D121363, AGR [CASE @D121362, COUNT @D121361, 
            PER @D121360, PLU @D121359, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121370, PRD @D121369, 
      AGR [CASE @D121368, COUNT @D121367, PER @D121366, PLU @D121365, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RETURN, 
   [COORD @D121376, PRD @D121375, AGR [CASE @D121374, COUNT @D121373, 
            PER @D121372, PLU @D121371, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121382, PRD @D121381, 
      AGR [CASE @D121380, COUNT @D121379, PER @D121378, PLU @D121377, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM FROM_TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121388, PRD @D121387, AGR [CASE @D121386, COUNT @D121385, 
            PER @D121384, PLU @D121383, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121394, PRD @D121393, 
      AGR [CASE @D121392, COUNT @D121391, PER @D121390, PLU @D121389, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RETURN, 
   [COORD @D121400, PRD @D121399, AGR [CASE @D121398, COUNT @D121397, 
            PER @D121396, PLU @D121395, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RETURN, 
   [COORD @D121406, PRD @D121405, 
      AGR [CASE @D121404, COUNT @D121403, PER @D121402, PLU @D121401, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RETURN, 
   [COORD @D121412, PRD @D121411, AGR [CASE @D121410, COUNT @D121409, 
            PER @D121408, PLU @D121407, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RETURN.

WORD returns : 
   [COORD @D121421, REFL @D121420, PRD @D121419, CASE @D121418, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : RETURNS, 
   [COORD @D121426, DEMON @D121425, REFL @D121424, PRD @D121423, 
      CASE @D121422, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RETURN, 
   [COORD @D121431, DEMON @D121430, REFL @D121429, PRD @D121428, 
      CASE @D121427, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RETURN, 
   [COORD @D121436, DEMON @D121435, REFL @D121434, PRD @D121433, 
      CASE @D121432, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RETURN, 
   [COORD @D121441, DEMON @D121440, REFL @D121439, PRD @D121438, 
      CASE @D121437, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FROM, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RETURN, 
   [COORD @D121446, DEMON @D121445, REFL @D121444, PRD @D121443, 
      CASE @D121442, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RETURN, 
   [COORD @D121448, AGR [COUNT @D121447, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RETURN, 
   [COORD @D121450, AGR [COUNT @D121449, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RETURN, 
   [COORD @D121452, 
      AGR [COUNT @D121451, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RETURN, 
   [COORD @D121454, 
      AGR [COUNT @D121453, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP_PP, PFORM FROM_TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RETURN, 
   [COORD @D121456, AGR [COUNT @D121455, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RETURN, 
   [COORD @D121458, 
      AGR [COUNT @D121457, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RETURN, 
   [COORD @D121460, 
      AGR [COUNT @D121459, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RETURN, 
   [COORD @D121462, 
      AGR [COUNT @D121461, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RETURN, 
   [COORD @D121464, 
      AGR [COUNT @D121463, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RETURN.

WORD reveal : 
   [COORD @D121481, AGR [COUNT @D121480, PER @D121479, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REVEAL, 
   [COORD @D121483, AGR [COUNT @D121482, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REVEAL, 
   [COORD @D121485, AGR [COUNT @D121484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REVEAL, 
   [COORD @D121489, AGR [COUNT @D121488, PER @D121487, PLU @D121486, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : REVEAL, 
   [COORD @D121495, PAST @D121494, 
      AGR [CASE @D121493, COUNT @D121492, PER @D121491, PLU @D121490, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : REVEAL, 
   [COORD @D121498, AGR [COUNT @D121497, PER @D121496, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REVEAL, 
   [COORD @D121500, AGR [COUNT @D121499, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REVEAL, 
   [COORD @D121502, AGR [COUNT @D121501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REVEAL, 
   [COORD @D121506, AGR [COUNT @D121505, PER @D121504, PLU @D121503, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : REVEAL, 
   [COORD @D121512, PAST @D121511, AGR [CASE @D121510, COUNT @D121509, 
            PER @D121508, PLU @D121507, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : REVEAL, 
   [COORD @D121515, AGR [COUNT @D121514, PER @D121513, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : REVEAL, 
   [COORD @D121517, AGR [COUNT @D121516, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : REVEAL, 
   [COORD @D121519, AGR [COUNT @D121518, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : REVEAL, 
   [COORD @D121523, AGR [COUNT @D121522, PER @D121521, PLU @D121520, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, ARITY 2] : REVEAL, 
   [COORD @D121529, PAST @D121528, AGR [CASE @D121527, COUNT @D121526, 
            PER @D121525, PLU @D121524, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_NP, ARITY 2] : REVEAL, 
   [COORD @D121532, AGR [COUNT @D121531, PER @D121530, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REVEAL, 
   [COORD @D121534, AGR [COUNT @D121533, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REVEAL, 
   [COORD @D121536, AGR [COUNT @D121535, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REVEAL, 
   [COORD @D121540, AGR [COUNT @D121539, PER @D121538, PLU @D121537, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : REVEAL, 
   [COORD @D121546, PAST @D121545, AGR 
         [CASE @D121544, COUNT @D121543, PER @D121542, PLU @D121541, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      ARITY 2] : REVEAL, 
   [COORD @D121549, AGR [COUNT @D121548, PER @D121547, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : REVEAL, 
   [COORD @D121551, AGR [COUNT @D121550, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : REVEAL, 
   [COORD @D121553, AGR [COUNT @D121552, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : REVEAL, 
   [COORD @D121557, AGR [COUNT @D121556, PER @D121555, PLU @D121554, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : REVEAL, 
   [COORD @D121563, PAST @D121562, AGR [CASE @D121561, COUNT @D121560, 
            PER @D121559, PLU @D121558, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : REVEAL, 
   [COORD @D121566, AGR [COUNT @D121565, PER @D121564, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REVEAL, 
   [COORD @D121568, AGR [COUNT @D121567, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REVEAL, 
   [COORD @D121570, AGR [COUNT @D121569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REVEAL, 
   [COORD @D121574, AGR [COUNT @D121573, PER @D121572, PLU @D121571, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REVEAL, 
   [COORD @D121580, PAST @D121579, AGR [CASE @D121578, COUNT @D121577, 
            PER @D121576, PLU @D121575, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REVEAL.

WORD revealed : 
   [COORD @D121588, AGR [CASE @D121587, COUNT @D121586, PER @D121585, 
            PLU @D121584, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121593, AGR [CASE @D121592, COUNT @D121591, PER @D121590, 
            PLU @D121589, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121598, AGR [CASE @D121597, COUNT @D121596, PER @D121595, 
            PLU @D121594, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121603, AGR [UB @D121602, VFORM @D121601, SUBJ @D121600, 
            FIN @D121599, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REVEAL, 
   [COORD @D121608, AGR [CASE @D121607, COUNT @D121606, PER @D121605, 
            PLU @D121604, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121613, AGR [CASE @D121612, COUNT @D121611, PER @D121610, 
            PLU @D121609, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121618, AGR [CASE @D121617, COUNT @D121616, PER @D121615, 
            PLU @D121614, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REVEAL, 
   [COORD @D121623, AGR [CASE @D121622, COUNT @D121621, PER @D121620, 
            PLU @D121619, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121628, AGR [CASE @D121627, COUNT @D121626, PER @D121625, 
            PLU @D121624, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121634, AGR [CASE @D121633, NFORM @D121632, COUNT @D121631, 
            PER @D121630, PLU @D121629, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REVEAL, 
   [COORD @D121639, AGR [UB @D121638, VFORM @D121637, SUBJ @D121636, 
            FIN @D121635, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REVEAL, 
   [COORD @D121644, AGR [CASE @D121643, COUNT @D121642, PER @D121641, 
            PLU @D121640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121649, AGR [CASE @D121648, COUNT @D121647, PER @D121646, 
            PLU @D121645, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121654, AGR [CASE @D121653, COUNT @D121652, PER @D121651, 
            PLU @D121650, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121659, AGR [CASE @D121658, COUNT @D121657, PER @D121656, 
            PLU @D121655, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121665, AGR [CASE @D121664, NFORM @D121663, COUNT @D121662, 
            PER @D121661, PLU @D121660, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REVEAL, 
   [COORD @D121670, AGR [UB @D121669, VFORM @D121668, SUBJ @D121667, 
            FIN @D121666, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REVEAL, 
   [COORD @D121675, AGR [CASE @D121674, COUNT @D121673, PER @D121672, 
            PLU @D121671, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REVEAL, 
   [COORD @D121680, AGR [CASE @D121679, COUNT @D121678, PER @D121677, 
            PLU @D121676, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121685, AGR [CASE @D121684, COUNT @D121683, PER @D121682, 
            PLU @D121681, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REVEAL.

WORD revealing : 
   [COORD @D121696, PRD @D121695, AGR [CASE @D121694, COUNT @D121693, 
            PER @D121692, PLU @D121691, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121702, PRD @D121701, 
      AGR [CASE @D121700, COUNT @D121699, PER @D121698, PLU @D121697, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REVEAL, 
   [COORD @D121708, PRD @D121707, AGR [CASE @D121706, COUNT @D121705, 
            PER @D121704, PLU @D121703, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121714, PRD @D121713, 
      AGR [CASE @D121712, COUNT @D121711, PER @D121710, PLU @D121709, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   REVEAL, 
   [COORD @D121720, PRD @D121719, AGR [CASE @D121718, COUNT @D121717, 
            PER @D121716, PLU @D121715, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121726, PRD @D121725, 
      AGR [CASE @D121724, COUNT @D121723, PER @D121722, PLU @D121721, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : REVEAL.

WORD reveals : 
   [COORD @D121731, AGR [COUNT @D121730, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : REVEAL, 
   [COORD @D121733, AGR [COUNT @D121732, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121735, 
      AGR [COUNT @D121734, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121737, 
      AGR [COUNT @D121736, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121739, 
      AGR [COUNT @D121738, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REVEAL, 
   [COORD @D121741, 
      AGR [COUNT @D121740, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REVEAL.

WORD review : 
   [COORD @D121748, REFL @D121747, COUNT @D121746, PRD @D121745, 
      CASE @D121744, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : REVIEW, 
   [COORD @D121751, 
      AGR [COUNT @D121750, PER @D121749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   REVIEW, 
   [COORD @D121753, AGR [COUNT @D121752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REVIEW, 
   [COORD @D121755, AGR [COUNT @D121754, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : REVIEW, 
   [COORD @D121759, AGR [COUNT @D121758, PER @D121757, PLU @D121756, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : REVIEW, 
   [COORD @D121765, PAST @D121764, AGR [CASE @D121763, COUNT @D121762, 
            PER @D121761, PLU @D121760, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : REVIEW, 
   [COORD @D121768, AGR [COUNT @D121767, PER @D121766, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REVIEW, 
   [COORD @D121770, AGR [COUNT @D121769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REVIEW, 
   [COORD @D121772, AGR [COUNT @D121771, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REVIEW, 
   [COORD @D121776, AGR [COUNT @D121775, PER @D121774, PLU @D121773, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : REVIEW, 
   [COORD @D121782, PAST @D121781, AGR [CASE @D121780, COUNT @D121779, 
            PER @D121778, PLU @D121777, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : REVIEW.

WORD reviewed : 
   [COORD @D121791, AGR [CASE @D121790, COUNT @D121789, PER @D121788, 
            PLU @D121787, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REVIEW, 
   [COORD @D121796, AGR [CASE @D121795, COUNT @D121794, PER @D121793, 
            PLU @D121792, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REVIEW, 
   [COORD @D121801, AGR [CASE @D121800, COUNT @D121799, PER @D121798, 
            PLU @D121797, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : REVIEW, 
   [COORD @D121806, AGR [CASE @D121805, COUNT @D121804, PER @D121803, 
            PLU @D121802, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : REVIEW, 
   [COORD @D121811, AGR [CASE @D121810, COUNT @D121809, PER @D121808, 
            PLU @D121807, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : REVIEW.

WORD reviewing : 
   [COORD @D121825, PRD @D121824, AGR [CASE @D121823, COUNT @D121822, 
            PER @D121821, PLU @D121820, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : REVIEW, 
   [COORD @D121831, PRD @D121830, 
      AGR [CASE @D121829, COUNT @D121828, PER @D121827, PLU @D121826, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : REVIEW.

WORD reviews : 
   [COORD @D121840, DEMON @D121839, REFL @D121838, PRD @D121837, 
      CASE @D121836, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   REVIEW, 
   [COORD @D121842, AGR [COUNT @D121841, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REVIEW, 
   [COORD @D121844, 
      AGR [COUNT @D121843, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : REVIEW.

WORD ride : 
   [COORD @D121852, REFL @D121851, PRD @D121850, CASE @D121849, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RIDE, 
   [COORD @D121856, REFL @D121855, PRD @D121854, CASE @D121853, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, COUNT +] : RIDE, 
   [COORD @D121861, REFL @D121860, COUNT @D121859, PRD @D121858, 
      CASE @D121857, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RIDE, 
   [COORD @D121865, REFL @D121864, PRD @D121863, CASE @D121862, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : RIDE, 
   [COORD @D121868, 
      AGR [COUNT @D121867, PER @D121866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, 
      ARITY 3] : RIDE, 
   [COORD @D121870, AGR [COUNT @D121869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : RIDE, 
   [COORD @D121872, AGR [COUNT @D121871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : RIDE, 
   [COORD @D121876, AGR [COUNT @D121875, PER @D121874, PLU @D121873, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : RIDE, 
   [COORD @D121882, PAST @D121881, 
      AGR [CASE @D121880, COUNT @D121879, PER @D121878, PLU @D121877, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : RIDE, 
   [COORD @D121885, AGR [COUNT @D121884, PER @D121883, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121887, AGR [COUNT @D121886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121889, AGR [COUNT @D121888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121893, AGR [COUNT @D121892, PER @D121891, PLU @D121890, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : RIDE, 
   [COORD @D121899, PAST @D121898, 
      AGR [CASE @D121897, COUNT @D121896, PER @D121895, PLU @D121894, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121902, AGR [COUNT @D121901, PER @D121900, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121904, AGR [COUNT @D121903, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121906, AGR [COUNT @D121905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121910, AGR [COUNT @D121909, PER @D121908, PLU @D121907, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121916, PAST @D121915, AGR [CASE @D121914, COUNT @D121913, 
            PER @D121912, PLU @D121911, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : RIDE, 
   [COORD @D121919, AGR [COUNT @D121918, PER @D121917, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121921, AGR [COUNT @D121920, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121923, AGR [COUNT @D121922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121927, AGR [COUNT @D121926, PER @D121925, PLU @D121924, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121933, PAST @D121932, AGR [CASE @D121931, COUNT @D121930, 
            PER @D121929, PLU @D121928, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT MP, REG -, ARITY 2] : RIDE, 
   [COORD @D121936, AGR [COUNT @D121935, PER @D121934, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121938, AGR [COUNT @D121937, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121940, AGR [COUNT @D121939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121944, AGR [COUNT @D121943, PER @D121942, PLU @D121941, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121950, PAST @D121949, AGR [CASE @D121948, COUNT @D121947, 
            PER @D121946, PLU @D121945, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : RIDE, 
   [COORD @D121953, AGR 
         [COUNT @D121952, PER @D121951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, ARITY 2] : 
   RIDE, 
   [COORD @D121955, AGR [COUNT @D121954, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121957, AGR [COUNT @D121956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      REG -, ARITY 2] : RIDE, 
   [COORD @D121961, AGR [COUNT @D121960, PER @D121959, PLU @D121958, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, REG -, ARITY 2] : RIDE, 
   [COORD @D121967, PAST @D121966, 
      AGR [CASE @D121965, COUNT @D121964, PER @D121963, PLU @D121962, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, REG -, 
      ARITY 2] : RIDE, 
   [COORD @D121970, AGR [COUNT @D121969, PER @D121968, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : RIDE, 
   [COORD @D121972, AGR [COUNT @D121971, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : RIDE, 
   [COORD @D121974, AGR [COUNT @D121973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : RIDE, 
   [COORD @D121978, AGR [COUNT @D121977, PER @D121976, PLU @D121975, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : RIDE, 
   [COORD @D121984, PAST @D121983, AGR 
         [CASE @D121982, COUNT @D121981, PER @D121980, PLU @D121979, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : RIDE, 
   [COORD @D121987, AGR [COUNT @D121986, PER @D121985, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : RIDE, 
   [COORD @D121989, AGR [COUNT @D121988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : RIDE, 
   [COORD @D121991, AGR [COUNT @D121990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : RIDE, 
   [COORD @D121995, AGR [COUNT @D121994, PER @D121993, PLU @D121992, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM IN, ARITY 2] : RIDE, 
   [COORD @D122001, PAST @D122000, AGR 
         [CASE @D121999, COUNT @D121998, PER @D121997, PLU @D121996, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : RIDE, 
   [COORD @D122004, AGR [COUNT @D122003, PER @D122002, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RIDE, 
   [COORD @D122006, AGR [COUNT @D122005, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RIDE, 
   [COORD @D122008, AGR [COUNT @D122007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RIDE, 
   [COORD @D122012, AGR [COUNT @D122011, PER @D122010, PLU @D122009, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : RIDE, 
   [COORD @D122018, PAST @D122017, 
      AGR [CASE @D122016, COUNT @D122015, PER @D122014, PLU @D122013, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : RIDE, 
   [COORD @D122021, AGR [COUNT @D122020, PER @D122019, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RIDE, 
   [COORD @D122023, AGR [COUNT @D122022, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RIDE, 
   [COORD @D122025, AGR [COUNT @D122024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RIDE, 
   [COORD @D122029, AGR [COUNT @D122028, PER @D122027, PLU @D122026, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : RIDE, 
   [COORD @D122035, PAST @D122034, 
      AGR [CASE @D122033, COUNT @D122032, PER @D122031, PLU @D122030, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RIDE, 
   [COORD @D122038, AGR [COUNT @D122037, PER @D122036, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RIDE, 
   [COORD @D122040, AGR [COUNT @D122039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RIDE, 
   [COORD @D122042, AGR [COUNT @D122041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RIDE, 
   [COORD @D122046, AGR [COUNT @D122045, PER @D122044, PLU @D122043, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : RIDE, 
   [COORD @D122052, PAST @D122051, 
      AGR [CASE @D122050, COUNT @D122049, PER @D122048, PLU @D122047, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : RIDE, 
   [COORD @D122055, AGR [COUNT @D122054, PER @D122053, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RIDE, 
   [COORD @D122057, AGR [COUNT @D122056, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RIDE, 
   [COORD @D122059, AGR [COUNT @D122058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RIDE, 
   [COORD @D122063, AGR [COUNT @D122062, PER @D122061, PLU @D122060, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : RIDE, 
   [COORD @D122069, PAST @D122068, 
      AGR [CASE @D122067, COUNT @D122066, PER @D122065, PLU @D122064, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : RIDE, 
   [COORD @D122072, AGR [COUNT @D122071, PER @D122070, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RIDE, 
   [COORD @D122074, AGR [COUNT @D122073, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RIDE, 
   [COORD @D122076, AGR [COUNT @D122075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RIDE, 
   [COORD @D122080, AGR [COUNT @D122079, PER @D122078, PLU @D122077, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : RIDE, 
   [COORD @D122086, PAST @D122085, 
      AGR [CASE @D122084, COUNT @D122083, PER @D122082, PLU @D122081, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : RIDE, 
   [COORD @D122089, AGR [COUNT @D122088, PER @D122087, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : RIDE, 
   [COORD @D122091, AGR [COUNT @D122090, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : RIDE, 
   [COORD @D122093, AGR [COUNT @D122092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : RIDE, 
   [COORD @D122097, AGR [COUNT @D122096, PER @D122095, PLU @D122094, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : RIDE, 
   [COORD @D122103, PAST @D122102, 
      AGR [CASE @D122101, COUNT @D122100, PER @D122099, PLU @D122098, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : RIDE.

WORD rides : 
   [COORD @D122120, DEMON @D122119, REFL @D122118, PRD @D122117, 
      CASE @D122116, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RIDE, 
   [COORD @D122125, DEMON @D122124, REFL @D122123, PRD @D122122, 
      CASE @D122121, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM IN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RIDE, 
   [COORD @D122130, DEMON @D122129, REFL @D122128, PRD @D122127, 
      CASE @D122126, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RIDE, 
   [COORD @D122135, DEMON @D122134, REFL @D122133, PRD @D122132, 
      CASE @D122131, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RIDE, 
   [COORD @D122137, AGR [COUNT @D122136, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RIDE, 
   [COORD @D122139, AGR [COUNT @D122138, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122141, 
      AGR [COUNT @D122140, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122143, 
      AGR [COUNT @D122142, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT MP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122145, 
      AGR [COUNT @D122144, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122147, 
      AGR [COUNT @D122146, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122149, 
      AGR [COUNT @D122148, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122151, 
      AGR [COUNT @D122150, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122153, 
      AGR [COUNT @D122152, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122155, 
      AGR [COUNT @D122154, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122157, 
      AGR [COUNT @D122156, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122159, 
      AGR [COUNT @D122158, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122161, 
      AGR [COUNT @D122160, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE, 
   [COORD @D122163, 
      AGR [COUNT @D122162, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RIDE.

WORD riding : 
   [COORD @D122173, PRD @D122172, AGR [CASE @D122171, COUNT @D122170, 
            PER @D122169, PLU @D122168, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RIDE, 
   [COORD @D122179, PRD @D122178, 
      AGR [CASE @D122177, COUNT @D122176, PER @D122175, PLU @D122174, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RIDE, 
   [COORD @D122185, PRD @D122184, AGR [CASE @D122183, COUNT @D122182, 
            PER @D122181, PLU @D122180, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RIDE, 
   [COORD @D122191, PRD @D122190, 
      AGR [CASE @D122189, COUNT @D122188, PER @D122187, PLU @D122186, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT MP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RIDE, 
   [COORD @D122197, PRD @D122196, AGR [CASE @D122195, COUNT @D122194, 
            PER @D122193, PLU @D122192, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RIDE, 
   [COORD @D122203, PRD @D122202, 
      AGR [CASE @D122201, COUNT @D122200, PER @D122199, PLU @D122198, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RIDE, 
   [COORD @D122209, PRD @D122208, AGR [CASE @D122207, COUNT @D122206, 
            PER @D122205, PLU @D122204, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RIDE, 
   [COORD @D122215, PRD @D122214, 
      AGR [CASE @D122213, COUNT @D122212, PER @D122211, PLU @D122210, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RIDE, 
   [COORD @D122221, PRD @D122220, AGR [CASE @D122219, COUNT @D122218, 
            PER @D122217, PLU @D122216, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RIDE, 
   [COORD @D122227, PRD @D122226, 
      AGR [CASE @D122225, COUNT @D122224, PER @D122223, PLU @D122222, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RIDE, 
   [COORD @D122233, PRD @D122232, AGR [CASE @D122231, COUNT @D122230, 
            PER @D122229, PLU @D122228, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RIDE, 
   [COORD @D122239, PRD @D122238, 
      AGR [CASE @D122237, COUNT @D122236, PER @D122235, PLU @D122234, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RIDE, 
   [COORD @D122245, PRD @D122244, AGR [CASE @D122243, COUNT @D122242, 
            PER @D122241, PLU @D122240, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RIDE, 
   [COORD @D122251, PRD @D122250, 
      AGR [CASE @D122249, COUNT @D122248, PER @D122247, PLU @D122246, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RIDE.

WORD ring : 
   [COORD @D122257, REFL @D122256, PRD @D122255, CASE @D122254, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RING, 
   [COORD @D122261, REFL @D122260, PRD @D122259, CASE @D122258, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RING, 
   [COORD @D122265, REFL @D122264, PRD @D122263, CASE @D122262, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RING, 
   [COORD @D122269, REFL @D122268, PRD @D122267, CASE @D122266, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RING, 
   [COORD @D122273, REFL @D122272, PRD @D122271, CASE @D122270, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : RING, 
   [COORD @D122276, 
      AGR [COUNT @D122275, PER @D122274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      ARITY 3] : RING, 
   [COORD @D122278, AGR [COUNT @D122277, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : RING, 
   [COORD @D122280, AGR [COUNT @D122279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : RING, 
   [COORD @D122284, AGR [COUNT @D122283, PER @D122282, PLU @D122281, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : RING, 
   [COORD @D122290, PAST @D122289, 
      AGR [CASE @D122288, COUNT @D122287, PER @D122286, PLU @D122285, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, ARITY 3] : RING, 
   [COORD @D122293, AGR [COUNT @D122292, PER @D122291, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : RING, 
   [COORD @D122295, AGR [COUNT @D122294, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : RING, 
   [COORD @D122297, AGR [COUNT @D122296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : RING, 
   [COORD @D122301, AGR [COUNT @D122300, PER @D122299, PLU @D122298, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : RING, 
   [COORD @D122307, PAST @D122306, 
      AGR [CASE @D122305, COUNT @D122304, PER @D122303, PLU @D122302, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FOR, ARITY 3] : RING, 
   [COORD @D122310, AGR [COUNT @D122309, PER @D122308, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RING, 
   [COORD @D122312, AGR [COUNT @D122311, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RING, 
   [COORD @D122314, AGR [COUNT @D122313, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RING, 
   [COORD @D122318, AGR [COUNT @D122317, PER @D122316, PLU @D122315, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : RING, 
   [COORD @D122324, PAST @D122323, AGR [CASE @D122322, COUNT @D122321, 
            PER @D122320, PLU @D122319, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : RING, 
   [COORD @D122327, AGR [COUNT @D122326, PER @D122325, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : RING, 
   [COORD @D122329, AGR [COUNT @D122328, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : RING, 
   [COORD @D122331, AGR [COUNT @D122330, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : RING, 
   [COORD @D122335, AGR [COUNT @D122334, PER @D122333, PLU @D122332, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : RING, 
   [COORD @D122341, PAST @D122340, 
      AGR [CASE @D122339, COUNT @D122338, PER @D122337, PLU @D122336, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : RING, 
   [COORD @D122344, AGR [COUNT @D122343, PER @D122342, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RING, 
   [COORD @D122346, AGR [COUNT @D122345, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RING, 
   [COORD @D122348, AGR [COUNT @D122347, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RING, 
   [COORD @D122352, AGR [COUNT @D122351, PER @D122350, PLU @D122349, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : RING, 
   [COORD @D122358, PAST @D122357, 
      AGR [CASE @D122356, COUNT @D122355, PER @D122354, PLU @D122353, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RING, 
   [COORD @D122361, AGR [COUNT @D122360, PER @D122359, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : RING, 
   [COORD @D122363, AGR [COUNT @D122362, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : RING, 
   [COORD @D122365, AGR [COUNT @D122364, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : RING, 
   [COORD @D122369, AGR [COUNT @D122368, PER @D122367, PLU @D122366, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : RING, 
   [COORD @D122375, PAST @D122374, 
      AGR [CASE @D122373, COUNT @D122372, PER @D122371, PLU @D122370, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : RING, 
   [COORD @D122378, AGR [COUNT @D122377, PER @D122376, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RING, 
   [COORD @D122380, AGR [COUNT @D122379, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RING, 
   [COORD @D122382, AGR [COUNT @D122381, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RING, 
   [COORD @D122386, AGR [COUNT @D122385, PER @D122384, PLU @D122383, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : RING, 
   [COORD @D122392, PAST @D122391, 
      AGR [CASE @D122390, COUNT @D122389, PER @D122388, PLU @D122387, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : RING, 
   [COORD @D122395, AGR [COUNT @D122394, PER @D122393, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : RING, 
   [COORD @D122397, AGR [COUNT @D122396, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : RING, 
   [COORD @D122399, AGR [COUNT @D122398, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : RING, 
   [COORD @D122403, AGR [COUNT @D122402, PER @D122401, PLU @D122400, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : RING, 
   [COORD @D122409, PAST @D122408, 
      AGR [CASE @D122407, COUNT @D122406, PER @D122405, PLU @D122404, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : RING, 
   [COORD @D122412, AGR [COUNT @D122411, PER @D122410, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RING, 
   [COORD @D122414, AGR [COUNT @D122413, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RING, 
   [COORD @D122416, AGR [COUNT @D122415, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RING, 
   [COORD @D122420, AGR [COUNT @D122419, PER @D122418, PLU @D122417, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : RING, 
   [COORD @D122426, PAST @D122425, 
      AGR [CASE @D122424, COUNT @D122423, PER @D122422, PLU @D122421, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : RING, 
   [COORD @D122429, AGR [COUNT @D122428, PER @D122427, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RING, 
   [COORD @D122431, AGR [COUNT @D122430, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RING, 
   [COORD @D122433, AGR [COUNT @D122432, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RING, 
   [COORD @D122437, AGR [COUNT @D122436, PER @D122435, PLU @D122434, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : RING, 
   [COORD @D122443, PAST @D122442, 
      AGR [CASE @D122441, COUNT @D122440, PER @D122439, PLU @D122438, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : RING, 
   [COORD @D122446, AGR [COUNT @D122445, PER @D122444, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RING, 
   [COORD @D122448, AGR [COUNT @D122447, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RING, 
   [COORD @D122450, AGR [COUNT @D122449, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RING, 
   [COORD @D122454, AGR [COUNT @D122453, PER @D122452, PLU @D122451, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : RING, 
   [COORD @D122460, PAST @D122459, 
      AGR [CASE @D122458, COUNT @D122457, PER @D122456, PLU @D122455, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : RING, 
   [COORD @D122463, AGR [COUNT @D122462, PER @D122461, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : RING, 
   [COORD @D122465, AGR [COUNT @D122464, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : RING, 
   [COORD @D122467, AGR [COUNT @D122466, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : RING, 
   [COORD @D122471, AGR [COUNT @D122470, PER @D122469, PLU @D122468, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : RING, 
   [COORD @D122477, PAST @D122476, 
      AGR [CASE @D122475, COUNT @D122474, PER @D122473, PLU @D122472, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : RING, 
   [COORD @D122480, AGR [COUNT @D122479, PER @D122478, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : RING, 
   [COORD @D122482, AGR [COUNT @D122481, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : RING, 
   [COORD @D122484, AGR [COUNT @D122483, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : RING, 
   [COORD @D122488, AGR [COUNT @D122487, PER @D122486, PLU @D122485, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : RING, 
   [COORD @D122494, PAST @D122493, 
      AGR [CASE @D122492, COUNT @D122491, PER @D122490, PLU @D122489, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : RING.

WORD ringing : 
   [COORD @D122512, PRD @D122511, AGR [CASE @D122510, COUNT @D122509, 
            PER @D122508, PLU @D122507, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RING, 
   [COORD @D122518, PRD @D122517, 
      AGR [CASE @D122516, COUNT @D122515, PER @D122514, PLU @D122513, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RING, 
   [COORD @D122524, PRD @D122523, AGR [CASE @D122522, COUNT @D122521, 
            PER @D122520, PLU @D122519, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RING, 
   [COORD @D122530, PRD @D122529, 
      AGR [CASE @D122528, COUNT @D122527, PER @D122526, PLU @D122525, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RING, 
   [COORD @D122536, PRD @D122535, AGR [CASE @D122534, COUNT @D122533, 
            PER @D122532, PLU @D122531, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RING, 
   [COORD @D122542, PRD @D122541, 
      AGR [CASE @D122540, COUNT @D122539, PER @D122538, PLU @D122537, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RING, 
   [COORD @D122548, PRD @D122547, AGR [CASE @D122546, COUNT @D122545, 
            PER @D122544, PLU @D122543, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RING, 
   [COORD @D122554, PRD @D122553, 
      AGR [CASE @D122552, COUNT @D122551, PER @D122550, PLU @D122549, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RING, 
   [COORD @D122560, PRD @D122559, AGR [CASE @D122558, COUNT @D122557, 
            PER @D122556, PLU @D122555, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RING, 
   [COORD @D122566, PRD @D122565, 
      AGR [CASE @D122564, COUNT @D122563, PER @D122562, PLU @D122561, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RING, 
   [COORD @D122572, PRD @D122571, AGR [CASE @D122570, COUNT @D122569, 
            PER @D122568, PLU @D122567, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RING, 
   [COORD @D122578, PRD @D122577, 
      AGR [CASE @D122576, COUNT @D122575, PER @D122574, PLU @D122573, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RING, 
   [COORD @D122584, PRD @D122583, AGR [CASE @D122582, COUNT @D122581, 
            PER @D122580, PLU @D122579, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RING.

WORD rings : 
   [COORD @D122593, DEMON @D122592, REFL @D122591, PRD @D122590, 
      CASE @D122589, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RING, 
   [COORD @D122598, DEMON @D122597, REFL @D122596, PRD @D122595, 
      CASE @D122594, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : RING, 
   [COORD @D122600, AGR [COUNT @D122599, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RING, 
   [COORD @D122602, AGR [COUNT @D122601, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RING, 
   [COORD @D122604, AGR [COUNT @D122603, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122606, 
      AGR [COUNT @D122605, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122608, 
      AGR [COUNT @D122607, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122610, 
      AGR [COUNT @D122609, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122612, 
      AGR [COUNT @D122611, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122614, 
      AGR [COUNT @D122613, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122616, 
      AGR [COUNT @D122615, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122618, 
      AGR [COUNT @D122617, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122620, 
      AGR [COUNT @D122619, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122622, 
      AGR [COUNT @D122621, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING, 
   [COORD @D122624, 
      AGR [COUNT @D122623, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RING.

WORD rise : 
   [COORD @D122632, REFL @D122631, PRD @D122630, CASE @D122629, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RISE, 
   [COORD @D122636, REFL @D122635, PRD @D122634, CASE @D122633, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, COUNT +] : RISE, 
   [COORD @D122641, REFL @D122640, COUNT @D122639, PRD @D122638, 
      CASE @D122637, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RISE, 
   [COORD @D122644, 
      AGR [COUNT @D122643, PER @D122642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : 
   RISE, 
   [COORD @D122646, AGR [COUNT @D122645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RISE, 
   [COORD @D122648, AGR [COUNT @D122647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RISE, 
   [COORD @D122652, AGR [COUNT @D122651, PER @D122650, PLU @D122649, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : RISE, 
   [COORD @D122658, PAST @D122657, AGR [CASE @D122656, COUNT @D122655, 
            PER @D122654, PLU @D122653, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : RISE, 
   [COORD @D122661, AGR 
         [COUNT @D122660, PER @D122659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM TO, 
      ARITY 2] : RISE, 
   [COORD @D122663, AGR [COUNT @D122662, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : RISE, 
   [COORD @D122665, AGR [COUNT @D122664, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : RISE, 
   [COORD @D122669, AGR [COUNT @D122668, PER @D122667, PLU @D122666, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : RISE, 
   [COORD @D122675, PAST @D122674, AGR 
         [CASE @D122673, COUNT @D122672, PER @D122671, PLU @D122670, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : RISE, 
   [COORD @D122678, AGR [COUNT @D122677, PER @D122676, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : RISE, 
   [COORD @D122680, AGR [COUNT @D122679, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : RISE, 
   [COORD @D122682, AGR [COUNT @D122681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : RISE, 
   [COORD @D122686, AGR [COUNT @D122685, PER @D122684, PLU @D122683, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FROM, ARITY 2] : RISE, 
   [COORD @D122692, PAST @D122691, 
      AGR [CASE @D122690, COUNT @D122689, PER @D122688, PLU @D122687, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FROM, ARITY 2] : RISE, 
   [COORD @D122695, AGR [COUNT @D122694, PER @D122693, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122697, AGR [COUNT @D122696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122699, AGR [COUNT @D122698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122703, AGR [COUNT @D122702, PER @D122701, PLU @D122700, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122709, PAST @D122708, 
      AGR [CASE @D122707, COUNT @D122706, PER @D122705, PLU @D122704, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122712, AGR [COUNT @D122711, PER @D122710, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122714, AGR [COUNT @D122713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122716, AGR [COUNT @D122715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122720, AGR [COUNT @D122719, PER @D122718, PLU @D122717, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122726, PAST @D122725, 
      AGR [CASE @D122724, COUNT @D122723, PER @D122722, PLU @D122721, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RISE, 
   [COORD @D122729, AGR [COUNT @D122728, PER @D122727, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOVE, ARITY 2] : RISE, 
   [COORD @D122731, AGR [COUNT @D122730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOVE, ARITY 2] : RISE, 
   [COORD @D122733, AGR [COUNT @D122732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOVE, ARITY 2] : RISE, 
   [COORD @D122737, AGR [COUNT @D122736, PER @D122735, PLU @D122734, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOVE, ARITY 2] : RISE, 
   [COORD @D122743, PAST @D122742, 
      AGR [CASE @D122741, COUNT @D122740, PER @D122739, PLU @D122738, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOVE, ARITY 2] : RISE, 
   [COORD @D122746, AGR [COUNT @D122745, PER @D122744, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RISE, 
   [COORD @D122748, AGR [COUNT @D122747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RISE, 
   [COORD @D122750, AGR [COUNT @D122749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RISE, 
   [COORD @D122754, AGR [COUNT @D122753, PER @D122752, PLU @D122751, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : RISE, 
   [COORD @D122760, PAST @D122759, 
      AGR [CASE @D122758, COUNT @D122757, PER @D122756, PLU @D122755, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : RISE, 
   [COORD @D122763, AGR [COUNT @D122762, PER @D122761, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RISE, 
   [COORD @D122765, AGR [COUNT @D122764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RISE, 
   [COORD @D122767, AGR [COUNT @D122766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RISE, 
   [COORD @D122771, AGR [COUNT @D122770, PER @D122769, PLU @D122768, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : RISE, 
   [COORD @D122777, PAST @D122776, 
      AGR [CASE @D122775, COUNT @D122774, PER @D122773, PLU @D122772, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : RISE.

WORD rises : 
   [COORD @D122794, DEMON @D122793, REFL @D122792, PRD @D122791, 
      CASE @D122790, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RISE, 
   [COORD @D122799, DEMON @D122798, REFL @D122797, PRD @D122796, 
      CASE @D122795, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM IN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RISE, 
   [COORD @D122804, DEMON @D122803, REFL @D122802, PRD @D122801, 
      CASE @D122800, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RISE, 
   [COORD @D122806, AGR [COUNT @D122805, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RISE, 
   [COORD @D122808, 
      AGR [COUNT @D122807, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RISE, 
   [COORD @D122810, 
      AGR [COUNT @D122809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RISE, 
   [COORD @D122812, 
      AGR [COUNT @D122811, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RISE, 
   [COORD @D122814, AGR [COUNT @D122813, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RISE, 
   [COORD @D122816, AGR [COUNT @D122815, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOVE, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RISE, 
   [COORD @D122818, AGR [COUNT @D122817, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RISE, 
   [COORD @D122820, 
      AGR [COUNT @D122819, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RISE.

WORD rising : 
   [COORD @D122828, REFL @D122827, PRD @D122826, CASE @D122825, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RISING, 
   [COORD @D122834, PRD @D122833, 
      AGR [CASE @D122832, COUNT @D122831, PER @D122830, PLU @D122829, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RISE, 
   [COORD @D122840, PRD @D122839, AGR [CASE @D122838, COUNT @D122837, 
            PER @D122836, PLU @D122835, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RISE, 
   [COORD @D122846, PRD @D122845, 
      AGR [CASE @D122844, COUNT @D122843, PER @D122842, PLU @D122841, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RISE, 
   [COORD @D122852, PRD @D122851, AGR [CASE @D122850, COUNT @D122849, 
            PER @D122848, PLU @D122847, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RISE, 
   [COORD @D122858, PRD @D122857, 
      AGR [CASE @D122856, COUNT @D122855, PER @D122854, PLU @D122853, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RISE, 
   [COORD @D122864, PRD @D122863, AGR [CASE @D122862, COUNT @D122861, 
            PER @D122860, PLU @D122859, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOVE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RISE, 
   [COORD @D122870, PRD @D122869, 
      AGR [CASE @D122868, COUNT @D122867, PER @D122866, PLU @D122865, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RISE, 
   [COORD @D122876, PRD @D122875, AGR [CASE @D122874, COUNT @D122873, 
            PER @D122872, PLU @D122871, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RISE.

WORD risings : 
   [COORD @D122888, DEMON @D122887, REFL @D122886, PRD @D122885, 
      CASE @D122884, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RISING.

WORD risk : 
   [COORD @D122896, REFL @D122895, PRD @D122894, CASE @D122893, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RISK, 
   [COORD @D122900, REFL @D122899, PRD @D122898, CASE @D122897, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : RISK, 
   [COORD @D122904, REFL @D122903, PRD @D122902, CASE @D122901, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : RISK, 
   [COORD @D122909, REFL @D122908, COUNT @D122907, PRD @D122906, 
      CASE @D122905, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RISK, 
   [COORD @D122912, 
      AGR [COUNT @D122911, PER @D122910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : RISK, 
   [COORD @D122914, AGR [COUNT @D122913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : RISK, 
   [COORD @D122916, AGR [COUNT @D122915, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : RISK, 
   [COORD @D122920, AGR [COUNT @D122919, PER @D122918, PLU @D122917, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : RISK, 
   [COORD @D122926, PAST @D122925, AGR [CASE @D122924, COUNT @D122923, 
            PER @D122922, PLU @D122921, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : RISK, 
   [COORD @D122929, AGR [COUNT @D122928, PER @D122927, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RISK, 
   [COORD @D122931, AGR [COUNT @D122930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RISK, 
   [COORD @D122933, AGR [COUNT @D122932, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RISK, 
   [COORD @D122937, AGR [COUNT @D122936, PER @D122935, PLU @D122934, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RISK, 
   [COORD @D122943, PAST @D122942, AGR [CASE @D122941, COUNT @D122940, 
            PER @D122939, PLU @D122938, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RISK.

WORD risked : 
   [COORD @D122954, AGR [CASE @D122953, COUNT @D122952, PER @D122951, 
            PLU @D122950, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RISK, 
   [COORD @D122959, AGR [CASE @D122958, COUNT @D122957, PER @D122956, 
            PLU @D122955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RISK, 
   [COORD @D122964, AGR [CASE @D122963, COUNT @D122962, PER @D122961, 
            PLU @D122960, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RISK, 
   [COORD @D122969, AGR [CASE @D122968, COUNT @D122967, PER @D122966, 
            PLU @D122965, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RISK, 
   [COORD @D122974, AGR [CASE @D122973, COUNT @D122972, PER @D122971, 
            PLU @D122970, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RISK.

WORD risking : 
   [COORD @D122990, PRD @D122989, AGR [CASE @D122988, COUNT @D122987, 
            PER @D122986, PLU @D122985, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RISK, 
   [COORD @D122996, PRD @D122995, 
      AGR [CASE @D122994, COUNT @D122993, PER @D122992, PLU @D122991, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RISK.

WORD risks : 
   [COORD @D123007, DEMON @D123006, REFL @D123005, PRD @D123004, 
      CASE @D123003, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RISK, 
   [COORD @D123009, AGR [COUNT @D123008, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RISK, 
   [COORD @D123011, AGR [COUNT @D123010, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RISK.

WORD root : 
   [COORD @D123016, AGR [COUNT @D123015, PER @D123014, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : ROOT, 
   [COORD @D123018, AGR [COUNT @D123017, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : ROOT, 
   [COORD @D123020, AGR [COUNT @D123019, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : ROOT, 
   [COORD @D123024, AGR [COUNT @D123023, PER @D123022, PLU @D123021, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : ROOT, 
   [COORD @D123030, PAST @D123029, 
      AGR [CASE @D123028, COUNT @D123027, PER @D123026, PLU @D123025, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      PRT OUT, ARITY 3] : ROOT, 
   [COORD @D123033, AGR [COUNT @D123032, PER @D123031, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PRT OUT, PFORM FOR, ARITY 3] : ROOT, 
   [COORD @D123035, 
      AGR [COUNT @D123034, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, PRT OUT, 
      PFORM FOR, ARITY 3] : ROOT, 
   [COORD @D123037, AGR [COUNT @D123036, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PRT OUT, PFORM FOR, ARITY 3] : ROOT, 
   [COORD @D123041, 
      AGR [COUNT @D123040, PER @D123039, PLU @D123038, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PRT OUT, PFORM FOR, ARITY 3] : ROOT, 
   [COORD @D123047, PAST @D123046, 
      AGR [CASE @D123045, COUNT @D123044, PER @D123043, PLU @D123042, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PRT OUT, PFORM FOR, ARITY 3] : ROOT, 
   [COORD @D123050, AGR [COUNT @D123049, PER @D123048, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ROOT, 
   [COORD @D123052, AGR [COUNT @D123051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ROOT, 
   [COORD @D123054, AGR [COUNT @D123053, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : ROOT, 
   [COORD @D123058, AGR [COUNT @D123057, PER @D123056, PLU @D123055, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : ROOT, 
   [COORD @D123064, PAST @D123063, AGR [CASE @D123062, COUNT @D123061, 
            PER @D123060, PLU @D123059, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : ROOT, 
   [COORD @D123067, AGR [COUNT @D123066, PER @D123065, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ROOT, 
   [COORD @D123069, AGR [COUNT @D123068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ROOT, 
   [COORD @D123071, AGR [COUNT @D123070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ROOT, 
   [COORD @D123075, AGR [COUNT @D123074, PER @D123073, PLU @D123072, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : ROOT, 
   [COORD @D123081, PAST @D123080, 
      AGR [CASE @D123079, COUNT @D123078, PER @D123077, PLU @D123076, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : ROOT, 
   [COORD @D123084, AGR [COUNT @D123083, PER @D123082, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : ROOT, 
   [COORD @D123086, AGR [COUNT @D123085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : ROOT, 
   [COORD @D123088, AGR [COUNT @D123087, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : ROOT, 
   [COORD @D123092, AGR [COUNT @D123091, PER @D123090, PLU @D123089, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : ROOT, 
   [COORD @D123098, PAST @D123097, 
      AGR [CASE @D123096, COUNT @D123095, PER @D123094, PLU @D123093, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : ROOT, 
   [COORD @D123101, AGR [COUNT @D123100, PER @D123099, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : ROOT, 
   [COORD @D123103, AGR [COUNT @D123102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : ROOT, 
   [COORD @D123105, AGR [COUNT @D123104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : ROOT, 
   [COORD @D123109, AGR [COUNT @D123108, PER @D123107, PLU @D123106, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : ROOT, 
   [COORD @D123115, PAST @D123114, 
      AGR [CASE @D123113, COUNT @D123112, PER @D123111, PLU @D123110, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : ROOT, 
   [COORD @D123118, AGR [COUNT @D123117, PER @D123116, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ROOT, 
   [COORD @D123120, AGR [COUNT @D123119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ROOT, 
   [COORD @D123122, AGR [COUNT @D123121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ROOT, 
   [COORD @D123126, AGR [COUNT @D123125, PER @D123124, PLU @D123123, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : ROOT, 
   [COORD @D123132, PAST @D123131, AGR [CASE @D123130, COUNT @D123129, 
            PER @D123128, PLU @D123127, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : ROOT, 
   [COORD @D123135, AGR [COUNT @D123134, PER @D123133, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ROOT, 
   [COORD @D123137, AGR [COUNT @D123136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ROOT, 
   [COORD @D123139, AGR [COUNT @D123138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ROOT, 
   [COORD @D123143, AGR [COUNT @D123142, PER @D123141, PLU @D123140, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : ROOT, 
   [COORD @D123149, PAST @D123148, 
      AGR [CASE @D123147, COUNT @D123146, PER @D123145, PLU @D123144, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : ROOT, 
   [COORD @D123152, AGR [COUNT @D123151, PER @D123150, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : ROOT, 
   [COORD @D123154, AGR [COUNT @D123153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : ROOT, 
   [COORD @D123156, AGR [COUNT @D123155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : ROOT, 
   [COORD @D123160, AGR [COUNT @D123159, PER @D123158, PLU @D123157, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : ROOT, 
   [COORD @D123166, PAST @D123165, 
      AGR [CASE @D123164, COUNT @D123163, PER @D123162, PLU @D123161, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : ROOT, 
   [COORD @D123169, AGR [COUNT @D123168, PER @D123167, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : ROOT, 
   [COORD @D123171, AGR [COUNT @D123170, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : ROOT, 
   [COORD @D123173, AGR [COUNT @D123172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : ROOT, 
   [COORD @D123177, AGR [COUNT @D123176, PER @D123175, PLU @D123174, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : ROOT, 
   [COORD @D123183, PAST @D123182, 
      AGR [CASE @D123181, COUNT @D123180, PER @D123179, PLU @D123178, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AROUND, ARITY 1] : ROOT, 
   [COORD @D123186, AGR [COUNT @D123185, PER @D123184, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ROOT, 
   [COORD @D123188, AGR [COUNT @D123187, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ROOT, 
   [COORD @D123190, AGR [COUNT @D123189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ROOT, 
   [COORD @D123194, AGR [COUNT @D123193, PER @D123192, PLU @D123191, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : ROOT, 
   [COORD @D123200, PAST @D123199, 
      AGR [CASE @D123198, COUNT @D123197, PER @D123196, PLU @D123195, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ABOUT, ARITY 1] : ROOT.

WORD rooted : 
   [COADV @D123211, COORD @D123210, DEF @D123209, PRD @D123208, 
      AGR [CASE @D123207, COUNT @D123206, PER @D123205, PLU @D123204, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : ROOTED, 
   [COADV @D123219, COORD @D123218, DEF @D123217, PRD @D123216, 
      AGR [CASE @D123215, COUNT @D123214, PER @D123213, PLU @D123212, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, DISTR PRD, ARITY 2] : ROOTED, 
   [COORD @D123224, AGR [CASE @D123223, COUNT @D123222, PER @D123221, 
            PLU @D123220, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123229, AGR [CASE @D123228, COUNT @D123227, PER @D123226, 
            PLU @D123225, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123234, AGR [CASE @D123233, COUNT @D123232, PER @D123231, 
            PLU @D123230, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123239, AGR [CASE @D123238, COUNT @D123237, PER @D123236, 
            PLU @D123235, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123244, AGR [CASE @D123243, COUNT @D123242, PER @D123241, 
            PLU @D123240, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123249, 
      AGR [CASE @D123248, COUNT @D123247, PER @D123246, PLU @D123245, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123254, AGR [CASE @D123253, COUNT @D123252, PER @D123251, 
            PLU @D123250, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ROOT, 
   [COORD @D123259, AGR [CASE @D123258, COUNT @D123257, PER @D123256, 
            PLU @D123255, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123264, AGR [CASE @D123263, COUNT @D123262, PER @D123261, 
            PLU @D123260, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123269, AGR [CASE @D123268, COUNT @D123267, PER @D123266, 
            PLU @D123265, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123274, AGR [CASE @D123273, COUNT @D123272, PER @D123271, 
            PLU @D123270, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123279, AGR [CASE @D123278, COUNT @D123277, PER @D123276, 
            PLU @D123275, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123284, AGR [CASE @D123283, COUNT @D123282, PER @D123281, 
            PLU @D123280, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123289, AGR [CASE @D123288, COUNT @D123287, PER @D123286, 
            PLU @D123285, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123294, AGR [CASE @D123293, COUNT @D123292, PER @D123291, 
            PLU @D123290, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123299, AGR [CASE @D123298, COUNT @D123297, PER @D123296, 
            PLU @D123295, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123304, AGR [CASE @D123303, COUNT @D123302, PER @D123301, 
            PLU @D123300, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123309, AGR [CASE @D123308, COUNT @D123307, PER @D123306, 
            PLU @D123305, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123314, AGR [CASE @D123313, COUNT @D123312, PER @D123311, 
            PLU @D123310, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123319, AGR [CASE @D123318, COUNT @D123317, PER @D123316, 
            PLU @D123315, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123324, AGR [CASE @D123323, COUNT @D123322, PER @D123321, 
            PLU @D123320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123329, AGR [CASE @D123328, COUNT @D123327, PER @D123326, 
            PLU @D123325, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123334, AGR [CASE @D123333, COUNT @D123332, PER @D123331, 
            PLU @D123330, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123339, AGR [CASE @D123338, COUNT @D123337, PER @D123336, 
            PLU @D123335, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123344, AGR [CASE @D123343, COUNT @D123342, PER @D123341, 
            PLU @D123340, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123349, AGR [CASE @D123348, COUNT @D123347, PER @D123346, 
            PLU @D123345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123354, AGR [CASE @D123353, COUNT @D123352, PER @D123351, 
            PLU @D123350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123359, AGR [CASE @D123358, COUNT @D123357, PER @D123356, 
            PLU @D123355, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : ROOT.

WORD rooting : 
   [COORD @D123370, PRD @D123369, AGR [CASE @D123368, COUNT @D123367, 
            PER @D123366, PLU @D123365, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123376, PRD @D123375, 
      AGR [CASE @D123374, COUNT @D123373, PER @D123372, PLU @D123371, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ROOT, 
   [COORD @D123382, PRD @D123381, AGR [CASE @D123380, COUNT @D123379, 
            PER @D123378, PLU @D123377, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123388, PRD @D123387, 
      AGR [CASE @D123386, COUNT @D123385, PER @D123384, PLU @D123383, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : ROOT, 
   [COORD @D123394, PRD @D123393, AGR [CASE @D123392, COUNT @D123391, 
            PER @D123390, PLU @D123389, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123400, PRD @D123399, 
      AGR [CASE @D123398, COUNT @D123397, PER @D123396, PLU @D123395, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : ROOT, 
   [COORD @D123406, PRD @D123405, AGR [CASE @D123404, COUNT @D123403, 
            PER @D123402, PLU @D123401, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123412, PRD @D123411, 
      AGR [CASE @D123410, COUNT @D123409, PER @D123408, PLU @D123407, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ROOT, 
   [COORD @D123418, PRD @D123417, AGR [CASE @D123416, COUNT @D123415, 
            PER @D123414, PLU @D123413, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ROOT, 
   [COORD @D123424, PRD @D123423, 
      AGR [CASE @D123422, COUNT @D123421, PER @D123420, PLU @D123419, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : ROOT, 
   [COORD @D123430, PRD @D123429, AGR [CASE @D123428, COUNT @D123427, 
            PER @D123426, PLU @D123425, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : ROOT.

WORD roots : 
   [COORD @D123435, AGR [COUNT @D123434, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : ROOT, 
   [COORD @D123437, AGR [COUNT @D123436, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : ROOT, 
   [COORD @D123439, AGR [COUNT @D123438, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123441, 
      AGR [COUNT @D123440, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123443, 
      AGR [COUNT @D123442, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123445, 
      AGR [COUNT @D123444, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123447, 
      AGR [COUNT @D123446, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123449, 
      AGR [COUNT @D123448, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123451, 
      AGR [COUNT @D123450, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123453, 
      AGR [COUNT @D123452, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT, 
   [COORD @D123455, 
      AGR [COUNT @D123454, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : ROOT.

WORD rugby : 
   [COORD @D123466, REFL @D123465, PRD @D123464, CASE @D123463, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : RUGBY.

WORD rule : 
   [COORD @D123474, REFL @D123473, PRD @D123472, CASE @D123471, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SBSE, COUNT +] : RULE, 
   [COORD @D123479, REFL @D123478, COUNT @D123477, PRD @D123476, 
      CASE @D123475, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : RULE, 
   [COORD @D123483, REFL @D123482, PRD @D123481, CASE @D123480, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, COUNT +] : RULE, 
   [COORD @D123486, 
      AGR [COUNT @D123485, PER @D123484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 2] : 
   RULE, 
   [COORD @D123488, AGR [COUNT @D123487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RULE, 
   [COORD @D123490, AGR [COUNT @D123489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RULE, 
   [COORD @D123494, AGR [COUNT @D123493, PER @D123492, PLU @D123491, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : RULE, 
   [COORD @D123500, PAST @D123499, AGR [CASE @D123498, COUNT @D123497, 
            PER @D123496, PLU @D123495, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : RULE, 
   [COORD @D123503, AGR [COUNT @D123502, PER @D123501, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RULE, 
   [COORD @D123505, AGR [COUNT @D123504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RULE, 
   [COORD @D123507, AGR [COUNT @D123506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : RULE, 
   [COORD @D123511, AGR [COUNT @D123510, PER @D123509, PLU @D123508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : RULE, 
   [COORD @D123517, PAST @D123516, AGR [CASE @D123515, COUNT @D123514, 
            PER @D123513, PLU @D123512, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : RULE, 
   [COORD @D123520, AGR [COUNT @D123519, PER @D123518, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : RULE, 
   [COORD @D123522, AGR [COUNT @D123521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : RULE, 
   [COORD @D123524, AGR [COUNT @D123523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : RULE, 
   [COORD @D123528, AGR [COUNT @D123527, PER @D123526, PLU @D123525, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OVER, ARITY 2] : RULE, 
   [COORD @D123534, PAST @D123533, 
      AGR [CASE @D123532, COUNT @D123531, PER @D123530, PLU @D123529, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : RULE, 
   [COORD @D123537, AGR [COUNT @D123536, PER @D123535, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RULE, 
   [COORD @D123539, AGR [COUNT @D123538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RULE, 
   [COORD @D123541, AGR [COUNT @D123540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RULE, 
   [COORD @D123545, AGR [COUNT @D123544, PER @D123543, PLU @D123542, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : RULE, 
   [COORD @D123551, PAST @D123550, 
      AGR [CASE @D123549, COUNT @D123548, PER @D123547, PLU @D123546, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : RULE, 
   [COORD @D123554, AGR [COUNT @D123553, PER @D123552, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : RULE, 
   [COORD @D123556, AGR [COUNT @D123555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : RULE, 
   [COORD @D123558, AGR [COUNT @D123557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : RULE, 
   [COORD @D123562, AGR [COUNT @D123561, PER @D123560, PLU @D123559, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : RULE, 
   [COORD @D123568, PAST @D123567, 
      AGR [CASE @D123566, COUNT @D123565, PER @D123564, PLU @D123563, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : RULE, 
   [COORD @D123571, AGR [COUNT @D123570, PER @D123569, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : RULE, 
   [COORD @D123573, AGR [COUNT @D123572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : RULE, 
   [COORD @D123575, AGR [COUNT @D123574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : RULE, 
   [COORD @D123579, AGR [COUNT @D123578, PER @D123577, PLU @D123576, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : RULE, 
   [COORD @D123585, PAST @D123584, 
      AGR [CASE @D123583, COUNT @D123582, PER @D123581, PLU @D123580, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : RULE, 
   [COORD @D123588, AGR [COUNT @D123587, PER @D123586, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : RULE, 
   [COORD @D123590, AGR [COUNT @D123589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : RULE, 
   [COORD @D123592, AGR [COUNT @D123591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : RULE, 
   [COORD @D123596, AGR [COUNT @D123595, PER @D123594, PLU @D123593, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : RULE, 
   [COORD @D123602, PAST @D123601, 
      AGR [CASE @D123600, COUNT @D123599, PER @D123598, PLU @D123597, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : RULE, 
   [COORD @D123605, AGR [COUNT @D123604, PER @D123603, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RULE, 
   [COORD @D123607, AGR [COUNT @D123606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RULE, 
   [COORD @D123609, AGR [COUNT @D123608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RULE, 
   [COORD @D123613, AGR [COUNT @D123612, PER @D123611, PLU @D123610, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : RULE, 
   [COORD @D123619, PAST @D123618, AGR [CASE @D123617, COUNT @D123616, 
            PER @D123615, PLU @D123614, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : RULE, 
   [COORD @D123622, AGR [COUNT @D123621, PER @D123620, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : RULE, 
   [COORD @D123624, AGR [COUNT @D123623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : RULE, 
   [COORD @D123626, AGR [COUNT @D123625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : RULE, 
   [COORD @D123630, AGR [COUNT @D123629, PER @D123628, PLU @D123627, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : RULE, 
   [COORD @D123636, PAST @D123635, 
      AGR [CASE @D123634, COUNT @D123633, PER @D123632, PLU @D123631, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : RULE, 
   [COORD @D123639, AGR [COUNT @D123638, PER @D123637, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : RULE, 
   [COORD @D123641, AGR [COUNT @D123640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : RULE, 
   [COORD @D123643, AGR [COUNT @D123642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : RULE, 
   [COORD @D123647, AGR [COUNT @D123646, PER @D123645, PLU @D123644, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : RULE, 
   [COORD @D123653, PAST @D123652, 
      AGR [CASE @D123651, COUNT @D123650, PER @D123649, PLU @D123648, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : RULE.

WORD ruled : 
   [COORD @D123664, AGR [CASE @D123663, COUNT @D123662, PER @D123661, 
            PLU @D123660, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123669, AGR [CASE @D123668, COUNT @D123667, PER @D123666, 
            PLU @D123665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123674, AGR [UB @D123673, VFORM @D123672, SUBJ @D123671, 
            FIN @D123670, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RULE, 
   [COORD @D123679, AGR [CASE @D123678, COUNT @D123677, PER @D123676, 
            PLU @D123675, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RULE, 
   [COORD @D123684, AGR [CASE @D123683, COUNT @D123682, PER @D123681, 
            PLU @D123680, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123689, AGR [CASE @D123688, COUNT @D123687, PER @D123686, 
            PLU @D123685, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123694, AGR [CASE @D123693, COUNT @D123692, PER @D123691, 
            PLU @D123690, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123699, AGR [CASE @D123698, COUNT @D123697, PER @D123696, 
            PLU @D123695, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123704, AGR [CASE @D123703, COUNT @D123702, PER @D123701, 
            PLU @D123700, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123709, AGR [CASE @D123708, COUNT @D123707, PER @D123706, 
            PLU @D123705, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123714, AGR [CASE @D123713, COUNT @D123712, PER @D123711, 
            PLU @D123710, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123719, AGR [CASE @D123718, COUNT @D123717, PER @D123716, 
            PLU @D123715, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123724, AGR [CASE @D123723, COUNT @D123722, PER @D123721, 
            PLU @D123720, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123729, AGR [CASE @D123728, COUNT @D123727, PER @D123726, 
            PLU @D123725, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123734, AGR [CASE @D123733, COUNT @D123732, PER @D123731, 
            PLU @D123730, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123739, AGR [CASE @D123738, COUNT @D123737, PER @D123736, 
            PLU @D123735, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123744, AGR [CASE @D123743, COUNT @D123742, PER @D123741, 
            PLU @D123740, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123749, AGR [CASE @D123748, COUNT @D123747, PER @D123746, 
            PLU @D123745, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123754, AGR [CASE @D123753, COUNT @D123752, PER @D123751, 
            PLU @D123750, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123759, AGR [CASE @D123758, COUNT @D123757, PER @D123756, 
            PLU @D123755, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123764, AGR [CASE @D123763, COUNT @D123762, PER @D123761, 
            PLU @D123760, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123769, AGR [CASE @D123768, COUNT @D123767, PER @D123766, 
            PLU @D123765, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RULE, 
   [COORD @D123774, AGR [CASE @D123773, COUNT @D123772, PER @D123771, 
            PLU @D123770, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123779, AGR [CASE @D123778, COUNT @D123777, PER @D123776, 
            PLU @D123775, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : RULE.

WORD rules : 
   [COORD @D123790, DEMON @D123789, REFL @D123788, PRD @D123787, 
      CASE @D123786, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SBSE, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : RULE, 
   [COORD @D123795, DEMON @D123794, REFL @D123793, PRD @D123792, 
      CASE @D123791, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RULE, 
   [COORD @D123800, DEMON @D123799, REFL @D123798, PRD @D123797, 
      CASE @D123796, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SFIN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : RULE, 
   [COORD @D123802, 
      AGR [COUNT @D123801, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RULE, 
   [COORD @D123804, 
      AGR [COUNT @D123803, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RULE, 
   [COORD @D123806, 
      AGR [COUNT @D123805, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RULE, 
   [COORD @D123808, 
      AGR [COUNT @D123807, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RULE, 
   [COORD @D123810, 
      AGR [COUNT @D123809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RULE, 
   [COORD @D123812, AGR [COUNT @D123811, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RULE, 
   [COORD @D123814, AGR [COUNT @D123813, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RULE, 
   [COORD @D123816, AGR [COUNT @D123815, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RULE, 
   [COORD @D123818, 
      AGR [COUNT @D123817, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RULE, 
   [COORD @D123820, 
      AGR [COUNT @D123819, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RULE.

WORD ruling : 
   [COORD @D123830, PRD @D123829, AGR [CASE @D123828, COUNT @D123827, 
            PER @D123826, PLU @D123825, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123836, PRD @D123835, 
      AGR [CASE @D123834, COUNT @D123833, PER @D123832, PLU @D123831, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RULE, 
   [COORD @D123842, PRD @D123841, AGR [CASE @D123840, COUNT @D123839, 
            PER @D123838, PLU @D123837, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123848, PRD @D123847, 
      AGR [CASE @D123846, COUNT @D123845, PER @D123844, PLU @D123843, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RULE, 
   [COORD @D123854, PRD @D123853, AGR [CASE @D123852, COUNT @D123851, 
            PER @D123850, PLU @D123849, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123860, PRD @D123859, 
      AGR [CASE @D123858, COUNT @D123857, PER @D123856, PLU @D123855, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RULE, 
   [COORD @D123866, PRD @D123865, AGR [CASE @D123864, COUNT @D123863, 
            PER @D123862, PLU @D123861, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123872, PRD @D123871, 
      AGR [CASE @D123870, COUNT @D123869, PER @D123868, PLU @D123867, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RULE, 
   [COORD @D123878, PRD @D123877, AGR [CASE @D123876, COUNT @D123875, 
            PER @D123874, PLU @D123873, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RULE, 
   [COORD @D123884, PRD @D123883, 
      AGR [CASE @D123882, COUNT @D123881, PER @D123880, PLU @D123879, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RULE.

WORD run : 
   [COORD @D123890, REFL @D123889, PRD @D123888, CASE @D123887, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : RUN, 
   [COORD @D123894, REFL @D123893, PRD @D123892, CASE @D123891, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RUN, 
   [COORD @D123898, REFL @D123897, PRD @D123896, CASE @D123895, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : RUN, 
   [COORD @D123901, 
      AGR [COUNT @D123900, PER @D123899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   RUN, 
   [COORD @D123903, AGR [COUNT @D123902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : RUN, 
   [COORD @D123905, AGR [COUNT @D123904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : RUN, 
   [COORD @D123909, AGR [COUNT @D123908, PER @D123907, PLU @D123906, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : RUN, 
   [COORD @D123915, PAST @D123914, 
      AGR [CASE @D123913, COUNT @D123912, PER @D123911, PLU @D123910, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : RUN, 
   [COORD @D123918, AGR [COUNT @D123917, PER @D123916, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : RUN, 
   [COORD @D123920, AGR [COUNT @D123919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : RUN, 
   [COORD @D123922, AGR [COUNT @D123921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : RUN, 
   [COORD @D123926, AGR [COUNT @D123925, PER @D123924, PLU @D123923, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : RUN, 
   [COORD @D123932, PAST @D123931, 
      AGR [CASE @D123930, COUNT @D123929, PER @D123928, PLU @D123927, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : RUN, 
   [COORD @D123935, AGR [COUNT @D123934, PER @D123933, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OFF, ARITY 3] : RUN, 
   [COORD @D123937, AGR [COUNT @D123936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OFF, ARITY 3] : RUN, 
   [COORD @D123939, AGR [COUNT @D123938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, PRT OFF, ARITY 3] : RUN, 
   [COORD @D123943, AGR [COUNT @D123942, PER @D123941, PLU @D123940, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT OFF, ARITY 3] : RUN, 
   [COORD @D123949, PAST @D123948, 
      AGR [CASE @D123947, COUNT @D123946, PER @D123945, PLU @D123944, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      PRT OFF, ARITY 3] : RUN, 
   [COORD @D123952, AGR [COUNT @D123951, PER @D123950, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : RUN, 
   [COORD @D123954, AGR [COUNT @D123953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : RUN, 
   [COORD @D123956, AGR [COUNT @D123955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : RUN, 
   [COORD @D123960, AGR [COUNT @D123959, PER @D123958, PLU @D123957, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, ARITY 3] : RUN, 
   [COORD @D123966, PAST @D123965, 
      AGR [CASE @D123964, COUNT @D123963, PER @D123962, PLU @D123961, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : RUN, 
   [COORD @D123969, AGR [COUNT @D123968, PER @D123967, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : RUN, 
   [COORD @D123971, AGR [COUNT @D123970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : RUN, 
   [COORD @D123973, AGR [COUNT @D123972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : RUN, 
   [COORD @D123977, AGR [COUNT @D123976, PER @D123975, PLU @D123974, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : RUN, 
   [COORD @D123983, PAST @D123982, 
      AGR [CASE @D123981, COUNT @D123980, PER @D123979, PLU @D123978, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ON, ARITY 3] : RUN, 
   [COORD @D123986, AGR [COUNT @D123985, PER @D123984, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : RUN, 
   [COORD @D123988, AGR [COUNT @D123987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : RUN, 
   [COORD @D123990, AGR [COUNT @D123989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : RUN, 
   [COORD @D123994, AGR [COUNT @D123993, PER @D123992, PLU @D123991, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, ARITY 3] : RUN, 
   [COORD @D124000, PAST @D123999, 
      AGR [CASE @D123998, COUNT @D123997, PER @D123996, PLU @D123995, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : RUN, 
   [COORD @D124003, AGR [COUNT @D124002, PER @D124001, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : RUN, 
   [COORD @D124005, AGR [COUNT @D124004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : RUN, 
   [COORD @D124007, AGR [COUNT @D124006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : RUN, 
   [COORD @D124011, AGR [COUNT @D124010, PER @D124009, PLU @D124008, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, ARITY 3] : RUN, 
   [COORD @D124017, PAST @D124016, 
      AGR [CASE @D124015, COUNT @D124014, PER @D124013, PLU @D124012, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM INTO, ARITY 3] : RUN, 
   [COORD @D124020, AGR [COUNT @D124019, PER @D124018, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124022, AGR [COUNT @D124021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124024, AGR [COUNT @D124023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124028, AGR [COUNT @D124027, PER @D124026, PLU @D124025, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124034, PAST @D124033, 
      AGR [CASE @D124032, COUNT @D124031, PER @D124030, PLU @D124029, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124037, AGR [COUNT @D124036, PER @D124035, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124039, AGR [COUNT @D124038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124041, AGR [COUNT @D124040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124045, AGR [COUNT @D124044, PER @D124043, PLU @D124042, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PRT OFF, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124051, PAST @D124050, 
      AGR [CASE @D124049, COUNT @D124048, PER @D124047, PLU @D124046, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 3] : RUN, 
   [COORD @D124054, AGR [COUNT @D124053, PER @D124052, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : RUN, 
   [COORD @D124056, AGR [COUNT @D124055, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : RUN, 
   [COORD @D124058, AGR [COUNT @D124057, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : RUN, 
   [COORD @D124062, AGR [COUNT @D124061, PER @D124060, PLU @D124059, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM BY, ARITY 3] : RUN, 
   [COORD @D124068, PAST @D124067, 
      AGR [CASE @D124066, COUNT @D124065, PER @D124064, PLU @D124063, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM BY, ARITY 3] : RUN, 
   [COORD @D124071, AGR [COUNT @D124070, PER @D124069, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ACROSS, ARITY 3] : RUN, 
   [COORD @D124073, AGR [COUNT @D124072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ACROSS, ARITY 3] : RUN, 
   [COORD @D124075, AGR [COUNT @D124074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ACROSS, ARITY 3] : RUN, 
   [COORD @D124079, AGR [COUNT @D124078, PER @D124077, PLU @D124076, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ACROSS, ARITY 3] : RUN, 
   [COORD @D124085, PAST @D124084, 
      AGR [CASE @D124083, COUNT @D124082, PER @D124081, PLU @D124080, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ACROSS, ARITY 3] : RUN, 
   [COORD @D124091, PAST @D124090, AGR [CASE @D124089, COUNT @D124088, 
            PER @D124087, PLU @D124086, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : RUN, 
   [COORD @D124097, PAST @D124096, 
      AGR [CASE @D124095, COUNT @D124094, PER @D124093, PLU @D124092, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : RUN, 
   [COORD @D124103, PAST @D124102, AGR [CASE @D124101, COUNT @D124100, 
            PER @D124099, PLU @D124098, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : RUN, 
   [COORD @D124109, PAST @D124108, 
      AGR [CASE @D124107, COUNT @D124106, PER @D124105, PLU @D124104, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : RUN, 
   [COORD @D124115, PAST @D124114, AGR [CASE @D124113, COUNT @D124112, 
            PER @D124111, PLU @D124110, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PRT OFF, FIN -, ARITY 3] : RUN, 
   [COORD @D124121, PAST @D124120, 
      AGR [CASE @D124119, COUNT @D124118, PER @D124117, PLU @D124116, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, PRT OFF, 
      FIN -, ARITY 3] : RUN, 
   [COORD @D124127, PAST @D124126, AGR [CASE @D124125, COUNT @D124124, 
            PER @D124123, PLU @D124122, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, FIN -, ARITY 3] : RUN, 
   [COORD @D124133, PAST @D124132, 
      AGR [CASE @D124131, COUNT @D124130, PER @D124129, PLU @D124128, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM THROUGH, 
      FIN -, ARITY 3] : RUN, 
   [COORD @D124139, PAST @D124138, AGR [CASE @D124137, COUNT @D124136, 
            PER @D124135, PLU @D124134, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : RUN, 
   [COORD @D124145, PAST @D124144, 
      AGR [CASE @D124143, COUNT @D124142, PER @D124141, PLU @D124140, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      FIN -, ARITY 3] : RUN, 
   [COORD @D124151, PAST @D124150, AGR [CASE @D124149, COUNT @D124148, 
            PER @D124147, PLU @D124146, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : RUN, 
   [COORD @D124157, PAST @D124156, 
      AGR [CASE @D124155, COUNT @D124154, PER @D124153, PLU @D124152, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, 
      PFORM OF, FIN -, ARITY 3] : RUN, 
   [COORD @D124163, PAST @D124162, AGR [CASE @D124161, COUNT @D124160, 
            PER @D124159, PLU @D124158, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : RUN, 
   [COORD @D124169, PAST @D124168, 
      AGR [CASE @D124167, COUNT @D124166, PER @D124165, PLU @D124164, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM INTO, 
      FIN -, ARITY 3] : RUN, 
   [COORD @D124175, PAST @D124174, AGR [CASE @D124173, COUNT @D124172, 
            PER @D124171, PLU @D124170, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : RUN, 
   [COORD @D124181, PAST @D124180, 
      AGR [CASE @D124179, COUNT @D124178, PER @D124177, PLU @D124176, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      FIN -, ARITY 3] : RUN, 
   [COORD @D124187, PAST @D124186, AGR [CASE @D124185, COUNT @D124184, 
            PER @D124183, PLU @D124182, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PRT OFF, PFORM FOR, FIN -, ARITY 3] : RUN, 
   [COORD @D124193, PAST @D124192, 
      AGR [CASE @D124191, COUNT @D124190, PER @D124189, PLU @D124188, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PRT OFF, 
      PFORM FOR, FIN -, ARITY 3] : RUN, 
   [COORD @D124199, PAST @D124198, AGR 
         [CASE @D124197, COUNT @D124196, PER @D124195, PLU @D124194, N +, 
            V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM BY, 
      FIN -, ARITY 3] : RUN, 
   [COORD @D124205, PAST @D124204, AGR [CASE @D124203, COUNT @D124202, 
            PER @D124201, PLU @D124200, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM BY, FIN -, ARITY 3] : RUN, 
   [COORD @D124211, PAST @D124210, 
      AGR [CASE @D124209, COUNT @D124208, PER @D124207, PLU @D124206, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ACROSS, FIN -, ARITY 3] : RUN, 
   [COORD @D124217, PAST @D124216, 
      AGR [CASE @D124215, COUNT @D124214, PER @D124213, PLU @D124212, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ACROSS, FIN -, ARITY 3] : RUN, 
   [COORD @D124220, AGR [COUNT @D124219, PER @D124218, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RUN, 
   [COORD @D124222, AGR [COUNT @D124221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RUN, 
   [COORD @D124224, AGR [COUNT @D124223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RUN, 
   [COORD @D124228, AGR [COUNT @D124227, PER @D124226, PLU @D124225, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : RUN, 
   [COORD @D124234, PAST @D124233, 
      AGR [CASE @D124232, COUNT @D124231, PER @D124230, PLU @D124229, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : RUN, 
   [COORD @D124237, AGR [COUNT @D124236, PER @D124235, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124239, AGR [COUNT @D124238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124241, AGR [COUNT @D124240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124245, AGR [COUNT @D124244, PER @D124243, PLU @D124242, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : RUN, 
   [COORD @D124251, PAST @D124250, AGR [CASE @D124249, COUNT @D124248, 
            PER @D124247, PLU @D124246, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : RUN, 
   [COORD @D124254, AGR [COUNT @D124253, PER @D124252, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124256, AGR [COUNT @D124255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124258, AGR [COUNT @D124257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124262, AGR [COUNT @D124261, PER @D124260, PLU @D124259, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      REG -, ARITY 2] : RUN, 
   [COORD @D124268, PAST @D124267, AGR [CASE @D124266, COUNT @D124265, 
            PER @D124264, PLU @D124263, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT MP, REG -, ARITY 2] : RUN, 
   [COORD @D124271, AGR [COUNT @D124270, PER @D124269, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124273, AGR [COUNT @D124272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124275, AGR [COUNT @D124274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : RUN, 
   [COORD @D124279, AGR [COUNT @D124278, PER @D124277, PLU @D124276, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : RUN, 
   [COORD @D124285, PAST @D124284, AGR [CASE @D124283, COUNT @D124282, 
            PER @D124281, PLU @D124280, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : RUN, 
   [COORD @D124288, AGR [COUNT @D124287, PER @D124286, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : RUN, 
   [COORD @D124290, AGR [COUNT @D124289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : RUN, 
   [COORD @D124292, AGR [COUNT @D124291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : RUN, 
   [COORD @D124296, AGR [COUNT @D124295, PER @D124294, PLU @D124293, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT THROUGH, ARITY 2] : RUN, 
   [COORD @D124302, PAST @D124301, 
      AGR [CASE @D124300, COUNT @D124299, PER @D124298, PLU @D124297, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : RUN, 
   [COORD @D124305, AGR [COUNT @D124304, PER @D124303, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT BACK, ARITY 2] : RUN, 
   [COORD @D124307, AGR [COUNT @D124306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT BACK, ARITY 2] : RUN, 
   [COORD @D124309, AGR [COUNT @D124308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT BACK, ARITY 2] : RUN, 
   [COORD @D124313, AGR [COUNT @D124312, PER @D124311, PLU @D124310, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT BACK, ARITY 2] : RUN, 
   [COORD @D124319, PAST @D124318, AGR [CASE @D124317, COUNT @D124316, 
            PER @D124315, PLU @D124314, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT BACK, ARITY 2] : RUN, 
   [COORD @D124322, 
      AGR [COUNT @D124321, PER @D124320, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OFF, 
      PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124324, AGR [COUNT @D124323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124326, AGR [COUNT @D124325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124330, AGR [COUNT @D124329, PER @D124328, PLU @D124327, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OFF, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124336, PAST @D124335, 
      AGR [CASE @D124334, COUNT @D124333, PER @D124332, PLU @D124331, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OFF, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124339, AGR [COUNT @D124338, PER @D124337, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124341, AGR [COUNT @D124340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124343, AGR [COUNT @D124342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124347, AGR [COUNT @D124346, PER @D124345, PLU @D124344, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT AWAY, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124353, PAST @D124352, 
      AGR [CASE @D124351, COUNT @D124350, PER @D124349, PLU @D124348, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT AWAY, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124356, AGR [COUNT @D124355, PER @D124354, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AROUND, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124358, AGR [COUNT @D124357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AROUND, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124360, AGR [COUNT @D124359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AROUND, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124364, AGR [COUNT @D124363, PER @D124362, PLU @D124361, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT AROUND, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124370, PAST @D124369, 
      AGR [CASE @D124368, COUNT @D124367, PER @D124366, PLU @D124365, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AROUND, PFORM WITH, ARITY 2] : RUN, 
   [COORD @D124373, AGR [COUNT @D124372, PER @D124371, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : RUN, 
   [COORD @D124375, AGR [COUNT @D124374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : RUN, 
   [COORD @D124377, AGR [COUNT @D124376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : RUN, 
   [COORD @D124381, AGR [COUNT @D124380, PER @D124379, PLU @D124378, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : RUN, 
   [COORD @D124387, PAST @D124386, 
      AGR [CASE @D124385, COUNT @D124384, PER @D124383, PLU @D124382, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : RUN, 
   [COORD @D124390, AGR [COUNT @D124389, PER @D124388, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : RUN, 
   [COORD @D124392, AGR [COUNT @D124391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : RUN, 
   [COORD @D124394, AGR [COUNT @D124393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : RUN, 
   [COORD @D124398, AGR [COUNT @D124397, PER @D124396, PLU @D124395, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : RUN, 
   [COORD @D124404, PAST @D124403, AGR [CASE @D124402, COUNT @D124401, 
            PER @D124400, PLU @D124399, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : RUN, 
   [COORD @D124407, 
      AGR [COUNT @D124406, PER @D124405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM THROUGH, 
      ARITY 2] : RUN, 
   [COORD @D124409, AGR [COUNT @D124408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : RUN, 
   [COORD @D124411, AGR [COUNT @D124410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : RUN, 
   [COORD @D124415, AGR [COUNT @D124414, PER @D124413, PLU @D124412, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM THROUGH, ARITY 2] : RUN, 
   [COORD @D124421, PAST @D124420, 
      AGR [CASE @D124419, COUNT @D124418, PER @D124417, PLU @D124416, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : RUN, 
   [COORD @D124424, AGR [COUNT @D124423, PER @D124422, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM OVER, ARITY 2] : RUN, 
   [COORD @D124426, AGR [COUNT @D124425, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM OVER, ARITY 2] : RUN, 
   [COORD @D124428, AGR [COUNT @D124427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM OVER, ARITY 2] : RUN, 
   [COORD @D124432, AGR [COUNT @D124431, PER @D124430, PLU @D124429, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT BACK, PFORM OVER, ARITY 2] : RUN, 
   [COORD @D124438, PAST @D124437, 
      AGR [CASE @D124436, COUNT @D124435, PER @D124434, PLU @D124433, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT BACK, PFORM OVER, ARITY 2] : RUN, 
   [COORD @D124441, AGR [COUNT @D124440, PER @D124439, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : RUN, 
   [COORD @D124443, AGR [COUNT @D124442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : RUN, 
   [COORD @D124445, AGR [COUNT @D124444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : RUN, 
   [COORD @D124449, AGR [COUNT @D124448, PER @D124447, PLU @D124446, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : RUN, 
   [COORD @D124455, PAST @D124454, AGR [CASE @D124453, COUNT @D124452, 
            PER @D124451, PLU @D124450, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : RUN, 
   [COORD @D124458, 
      AGR [COUNT @D124457, PER @D124456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM ON, ARITY 2] : RUN, 
   [COORD @D124460, AGR [COUNT @D124459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : RUN, 
   [COORD @D124462, AGR [COUNT @D124461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : RUN, 
   [COORD @D124466, AGR [COUNT @D124465, PER @D124464, PLU @D124463, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM ON, ARITY 2] : RUN, 
   [COORD @D124472, PAST @D124471, 
      AGR [CASE @D124470, COUNT @D124469, PER @D124468, PLU @D124467, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM ON, ARITY 2] : RUN, 
   [COORD @D124475, AGR [COUNT @D124474, PER @D124473, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : RUN, 
   [COORD @D124477, AGR [COUNT @D124476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : RUN, 
   [COORD @D124479, AGR [COUNT @D124478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : RUN, 
   [COORD @D124483, AGR [COUNT @D124482, PER @D124481, PLU @D124480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM OF, ARITY 2] : RUN, 
   [COORD @D124489, PAST @D124488, 
      AGR [CASE @D124487, COUNT @D124486, PER @D124485, PLU @D124484, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : RUN, 
   [COORD @D124492, AGR [COUNT @D124491, PER @D124490, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : RUN, 
   [COORD @D124494, AGR [COUNT @D124493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : RUN, 
   [COORD @D124496, AGR [COUNT @D124495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : RUN, 
   [COORD @D124500, AGR [COUNT @D124499, PER @D124498, PLU @D124497, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM INTO, ARITY 2] : RUN, 
   [COORD @D124506, PAST @D124505, 
      AGR [CASE @D124504, COUNT @D124503, PER @D124502, PLU @D124501, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM INTO, ARITY 2] : RUN, 
   [COORD @D124509, AGR [COUNT @D124508, PER @D124507, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : RUN, 
   [COORD @D124511, AGR [COUNT @D124510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : RUN, 
   [COORD @D124513, AGR [COUNT @D124512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM IN, ARITY 2] : RUN, 
   [COORD @D124517, AGR [COUNT @D124516, PER @D124515, PLU @D124514, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM IN, ARITY 2] : RUN, 
   [COORD @D124523, PAST @D124522, AGR [CASE @D124521, COUNT @D124520, 
            PER @D124519, PLU @D124518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM IN, ARITY 2] : RUN, 
   [COORD @D124526, 
      AGR [COUNT @D124525, PER @D124524, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AWAY, 
      PFORM FROM, ARITY 2] : RUN, 
   [COORD @D124528, AGR [COUNT @D124527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : RUN, 
   [COORD @D124530, AGR [COUNT @D124529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : RUN, 
   [COORD @D124534, AGR [COUNT @D124533, PER @D124532, PLU @D124531, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT AWAY, PFORM FROM, ARITY 2] : RUN, 
   [COORD @D124540, PAST @D124539, 
      AGR [CASE @D124538, COUNT @D124537, PER @D124536, PLU @D124535, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FROM, ARITY 2] : RUN, 
   [COORD @D124543, AGR [COUNT @D124542, PER @D124541, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RUN, 
   [COORD @D124545, AGR [COUNT @D124544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RUN, 
   [COORD @D124547, AGR [COUNT @D124546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RUN, 
   [COORD @D124551, AGR [COUNT @D124550, PER @D124549, PLU @D124548, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : RUN, 
   [COORD @D124557, PAST @D124556, AGR 
         [CASE @D124555, COUNT @D124554, PER @D124553, PLU @D124552, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : RUN, 
   [COORD @D124560, AGR [COUNT @D124559, PER @D124558, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : RUN, 
   [COORD @D124562, AGR [COUNT @D124561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : RUN, 
   [COORD @D124564, AGR [COUNT @D124563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : RUN, 
   [COORD @D124568, AGR [COUNT @D124567, PER @D124566, PLU @D124565, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM BY, ARITY 2] : RUN, 
   [COORD @D124574, PAST @D124573, AGR [CASE @D124572, COUNT @D124571, 
            PER @D124570, PLU @D124569, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP, REG -, PFORM BY, ARITY 2] : RUN, 
   [COORD @D124577, 
      AGR [COUNT @D124576, PER @D124575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, 
      ARITY 2] : RUN, 
   [COORD @D124579, AGR [COUNT @D124578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : RUN, 
   [COORD @D124581, AGR [COUNT @D124580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : RUN, 
   [COORD @D124585, AGR [COUNT @D124584, PER @D124583, PLU @D124582, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : RUN, 
   [COORD @D124591, PAST @D124590, AGR [CASE @D124589, COUNT @D124588, 
            PER @D124587, PLU @D124586, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, ARITY 2] : RUN, 
   [COORD @D124594, 
      AGR [COUNT @D124593, PER @D124592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM AGAINST, 
      ARITY 2] : RUN, 
   [COORD @D124596, AGR [COUNT @D124595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124598, AGR [COUNT @D124597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124602, AGR [COUNT @D124601, PER @D124600, PLU @D124599, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124608, PAST @D124607, 
      AGR [CASE @D124606, COUNT @D124605, PER @D124604, PLU @D124603, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124611, AGR [COUNT @D124610, PER @D124609, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124613, AGR [COUNT @D124612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124615, AGR [COUNT @D124614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124619, AGR [COUNT @D124618, PER @D124617, PLU @D124616, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124625, PAST @D124624, 
      AGR [CASE @D124623, COUNT @D124622, PER @D124621, PLU @D124620, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM AGAINST, ARITY 2] : RUN, 
   [COORD @D124628, AGR [COUNT @D124627, PER @D124626, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : RUN, 
   [COORD @D124630, AGR [COUNT @D124629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : RUN, 
   [COORD @D124632, AGR [COUNT @D124631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : RUN, 
   [COORD @D124636, AGR [COUNT @D124635, PER @D124634, PLU @D124633, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AFTER, ARITY 2] : RUN, 
   [COORD @D124642, PAST @D124641, 
      AGR [CASE @D124640, COUNT @D124639, PER @D124638, PLU @D124637, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AFTER, ARITY 2] : RUN, 
   [COORD @D124645, AGR [COUNT @D124644, PER @D124643, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : RUN, 
   [COORD @D124647, AGR [COUNT @D124646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : RUN, 
   [COORD @D124649, AGR [COUNT @D124648, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : RUN, 
   [COORD @D124653, AGR [COUNT @D124652, PER @D124651, PLU @D124650, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ACROSS, ARITY 2] : RUN, 
   [COORD @D124659, PAST @D124658, 
      AGR [CASE @D124657, COUNT @D124656, PER @D124655, PLU @D124654, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ACROSS, ARITY 2] : RUN, 
   [COORD @D124662, AGR [COUNT @D124661, PER @D124660, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : RUN, 
   [COORD @D124664, AGR [COUNT @D124663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : RUN, 
   [COORD @D124666, AGR [COUNT @D124665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : RUN, 
   [COORD @D124670, AGR [COUNT @D124669, PER @D124668, PLU @D124667, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : RUN, 
   [COORD @D124676, PAST @D124675, 
      AGR [CASE @D124674, COUNT @D124673, PER @D124672, PLU @D124671, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : RUN, 
   [COORD @D124679, AGR [COUNT @D124678, PER @D124677, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : RUN, 
   [COORD @D124681, AGR [COUNT @D124680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : RUN, 
   [COORD @D124683, AGR [COUNT @D124682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : RUN, 
   [COORD @D124687, AGR [COUNT @D124686, PER @D124685, PLU @D124684, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : RUN, 
   [COORD @D124693, PAST @D124692, 
      AGR [CASE @D124691, COUNT @D124690, PER @D124689, PLU @D124688, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : RUN, 
   [COORD @D124696, AGR [COUNT @D124695, PER @D124694, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RUN, 
   [COORD @D124698, AGR [COUNT @D124697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RUN, 
   [COORD @D124700, AGR [COUNT @D124699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : RUN, 
   [COORD @D124704, AGR [COUNT @D124703, PER @D124702, PLU @D124701, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : RUN, 
   [COORD @D124710, PAST @D124709, 
      AGR [CASE @D124708, COUNT @D124707, PER @D124706, PLU @D124705, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : RUN, 
   [COORD @D124713, AGR [COUNT @D124712, PER @D124711, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : RUN, 
   [COORD @D124715, AGR [COUNT @D124714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : RUN, 
   [COORD @D124717, AGR [COUNT @D124716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ON, ARITY 2] : RUN, 
   [COORD @D124721, AGR [COUNT @D124720, PER @D124719, PLU @D124718, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, ARITY 2] : RUN, 
   [COORD @D124727, PAST @D124726, 
      AGR [CASE @D124725, COUNT @D124724, PER @D124723, PLU @D124722, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, 
      ARITY 2] : RUN, 
   [COORD @D124730, AGR [COUNT @D124729, PER @D124728, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : RUN, 
   [COORD @D124732, AGR [COUNT @D124731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : RUN, 
   [COORD @D124734, AGR [COUNT @D124733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : RUN, 
   [COORD @D124738, AGR [COUNT @D124737, PER @D124736, PLU @D124735, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : RUN, 
   [COORD @D124744, PAST @D124743, 
      AGR [CASE @D124742, COUNT @D124741, PER @D124740, PLU @D124739, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : RUN, 
   [COORD @D124747, AGR [COUNT @D124746, PER @D124745, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : RUN, 
   [COORD @D124749, AGR [COUNT @D124748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : RUN, 
   [COORD @D124751, AGR [COUNT @D124750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : RUN, 
   [COORD @D124755, AGR [COUNT @D124754, PER @D124753, PLU @D124752, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : RUN, 
   [COORD @D124761, PAST @D124760, 
      AGR [CASE @D124759, COUNT @D124758, PER @D124757, PLU @D124756, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : RUN, 
   [COORD @D124764, AGR [COUNT @D124763, PER @D124762, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RUN, 
   [COORD @D124766, AGR [COUNT @D124765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RUN, 
   [COORD @D124768, AGR [COUNT @D124767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RUN, 
   [COORD @D124772, AGR [COUNT @D124771, PER @D124770, PLU @D124769, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : RUN, 
   [COORD @D124778, PAST @D124777, 
      AGR [CASE @D124776, COUNT @D124775, PER @D124774, PLU @D124773, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : RUN, 
   [COORD @D124784, PAST @D124783, AGR [CASE @D124782, COUNT @D124781, 
            PER @D124780, PLU @D124779, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, FIN -, ARITY 2] : RUN, 
   [COORD @D124790, PAST @D124789, 
      AGR [CASE @D124788, COUNT @D124787, PER @D124786, PLU @D124785, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D124796, PAST @D124795, AGR [CASE @D124794, COUNT @D124793, 
            PER @D124792, PLU @D124791, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : RUN, 
   [COORD @D124802, PAST @D124801, 
      AGR [CASE @D124800, COUNT @D124799, PER @D124798, PLU @D124797, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D124808, PAST @D124807, AGR [CASE @D124806, COUNT @D124805, 
            PER @D124804, PLU @D124803, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, FIN -, ARITY 2] : RUN, 
   [COORD @D124814, PAST @D124813, 
      AGR [CASE @D124812, COUNT @D124811, PER @D124810, PLU @D124809, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT THROUGH, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D124820, PAST @D124819, AGR [CASE @D124818, COUNT @D124817, 
            PER @D124816, PLU @D124815, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT THROUGH, FIN -, ARITY 2] : RUN, 
   [COORD @D124826, PAST @D124825, 
      AGR [CASE @D124824, COUNT @D124823, PER @D124822, PLU @D124821, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT BACK, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D124832, PAST @D124831, AGR [CASE @D124830, COUNT @D124829, 
            PER @D124828, PLU @D124827, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT BACK, FIN -, ARITY 2] : RUN, 
   [COORD @D124838, PAST @D124837, 
      AGR [CASE @D124836, COUNT @D124835, PER @D124834, PLU @D124833, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM WITH, FIN -, ARITY 2] : RUN, 
   [COORD @D124844, PAST @D124843, 
      AGR [CASE @D124842, COUNT @D124841, PER @D124840, PLU @D124839, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OFF, 
      PFORM WITH, FIN -, ARITY 2] : RUN, 
   [COORD @D124850, PAST @D124849, 
      AGR [CASE @D124848, COUNT @D124847, PER @D124846, PLU @D124845, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, 
      PFORM WITH, FIN -, ARITY 2] : RUN, 
   [COORD @D124856, PAST @D124855, 
      AGR [CASE @D124854, COUNT @D124853, PER @D124852, PLU @D124851, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, 
      PFORM WITH, FIN -, ARITY 2] : RUN, 
   [COORD @D124862, PAST @D124861, 
      AGR [CASE @D124860, COUNT @D124859, PER @D124858, PLU @D124857, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AROUND, 
      PFORM WITH, FIN -, ARITY 2] : RUN, 
   [COORD @D124868, PAST @D124867, 
      AGR [CASE @D124866, COUNT @D124865, PER @D124864, PLU @D124863, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM UPON, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D124874, PAST @D124873, AGR [CASE @D124872, COUNT @D124871, 
            PER @D124870, PLU @D124869, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM UPON, FIN -, ARITY 2] : RUN, 
   [COORD @D124880, PAST @D124879, 
      AGR [CASE @D124878, COUNT @D124877, PER @D124876, PLU @D124875, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM TO, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D124886, PAST @D124885, AGR [CASE @D124884, COUNT @D124883, 
            PER @D124882, PLU @D124881, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : RUN, 
   [COORD @D124892, PAST @D124891, 
      AGR [CASE @D124890, COUNT @D124889, PER @D124888, PLU @D124887, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM THROUGH, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D124898, PAST @D124897, AGR [CASE @D124896, COUNT @D124895, 
            PER @D124894, PLU @D124893, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM THROUGH, FIN -, ARITY 2] : RUN, 
   [COORD @D124904, PAST @D124903, 
      AGR [CASE @D124902, COUNT @D124901, PER @D124900, PLU @D124899, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      PFORM OVER, FIN -, ARITY 2] : RUN, 
   [COORD @D124910, PAST @D124909, 
      AGR [CASE @D124908, COUNT @D124907, PER @D124906, PLU @D124905, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT BACK, 
      PFORM OVER, FIN -, ARITY 2] : RUN, 
   [COORD @D124916, PAST @D124915, 
      AGR [CASE @D124914, COUNT @D124913, PER @D124912, PLU @D124911, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ON, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D124922, PAST @D124921, AGR [CASE @D124920, COUNT @D124919, 
            PER @D124918, PLU @D124917, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ON, FIN -, ARITY 2] : RUN, 
   [COORD @D124928, PAST @D124927, 
      AGR [CASE @D124926, COUNT @D124925, PER @D124924, PLU @D124923, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM ON, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D124934, PAST @D124933, AGR [CASE @D124932, COUNT @D124931, 
            PER @D124930, PLU @D124929, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT OUT, PFORM ON, FIN -, ARITY 2] : RUN, 
   [COORD @D124940, PAST @D124939, 
      AGR [CASE @D124938, COUNT @D124937, PER @D124936, PLU @D124935, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM OF, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D124946, PAST @D124945, AGR [CASE @D124944, COUNT @D124943, 
            PER @D124942, PLU @D124941, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT OUT, PFORM OF, FIN -, ARITY 2] : RUN, 
   [COORD @D124952, PAST @D124951, 
      AGR [CASE @D124950, COUNT @D124949, PER @D124948, PLU @D124947, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM INTO, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D124958, PAST @D124957, AGR [CASE @D124956, COUNT @D124955, 
            PER @D124954, PLU @D124953, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM INTO, FIN -, ARITY 2] : RUN, 
   [COORD @D124964, PAST @D124963, 
      AGR [CASE @D124962, COUNT @D124961, PER @D124960, PLU @D124959, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM IN, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D124970, PAST @D124969, AGR [CASE @D124968, COUNT @D124967, 
            PER @D124966, PLU @D124965, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT AWAY, PFORM FROM, FIN -, ARITY 2] : RUN, 
   [COORD @D124976, PAST @D124975, 
      AGR [CASE @D124974, COUNT @D124973, PER @D124972, PLU @D124971, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D124982, PAST @D124981, AGR [CASE @D124980, COUNT @D124979, 
            PER @D124978, PLU @D124977, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM BY, FIN -, ARITY 2] : RUN, 
   [COORD @D124988, PAST @D124987, 
      AGR [CASE @D124986, COUNT @D124985, PER @D124984, PLU @D124983, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM AT, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D124994, PAST @D124993, AGR [CASE @D124992, COUNT @D124991, 
            PER @D124990, PLU @D124989, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM AT, FIN -, ARITY 2] : RUN, 
   [COORD @D125000, PAST @D124999, 
      AGR [CASE @D124998, COUNT @D124997, PER @D124996, PLU @D124995, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM AGAINST, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D125006, PAST @D125005, AGR [CASE @D125004, COUNT @D125003, 
            PER @D125002, PLU @D125001, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM AGAINST, FIN -, ARITY 2] : RUN, 
   [COORD @D125012, PAST @D125011, 
      AGR [CASE @D125010, COUNT @D125009, PER @D125008, PLU @D125007, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT UP, 
      PFORM AGAINST, FIN -, ARITY 2] : RUN, 
   [COORD @D125018, PAST @D125017, 
      AGR [CASE @D125016, COUNT @D125015, PER @D125014, PLU @D125013, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM AFTER, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125024, PAST @D125023, AGR [CASE @D125022, COUNT @D125021, 
            PER @D125020, PLU @D125019, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM AFTER, FIN -, ARITY 2] : RUN, 
   [COORD @D125030, PAST @D125029, 
      AGR [CASE @D125028, COUNT @D125027, PER @D125026, PLU @D125025, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ACROSS, 
      FIN -, ARITY 2] : RUN, 
   [COORD @D125036, PAST @D125035, AGR [CASE @D125034, COUNT @D125033, 
            PER @D125032, PLU @D125031, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ACROSS, FIN -, ARITY 2] : RUN, 
   [COORD @D125042, PAST @D125041, 
      AGR [CASE @D125040, COUNT @D125039, PER @D125038, PLU @D125037, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125048, PAST @D125047, AGR [CASE @D125046, COUNT @D125045, 
            PER @D125044, PLU @D125043, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : RUN, 
   [COORD @D125054, PAST @D125053, 
      AGR [CASE @D125052, COUNT @D125051, PER @D125050, PLU @D125049, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125060, PAST @D125059, AGR [CASE @D125058, COUNT @D125057, 
            PER @D125056, PLU @D125055, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : RUN, 
   [COORD @D125066, PAST @D125065, 
      AGR [CASE @D125064, COUNT @D125063, PER @D125062, PLU @D125061, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125072, PAST @D125071, AGR [CASE @D125070, COUNT @D125069, 
            PER @D125068, PLU @D125067, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : RUN, 
   [COORD @D125078, PAST @D125077, 
      AGR [CASE @D125076, COUNT @D125075, PER @D125074, PLU @D125073, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125084, PAST @D125083, AGR [CASE @D125082, COUNT @D125081, 
            PER @D125080, PLU @D125079, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, FIN -, ARITY 2] : RUN, 
   [COORD @D125090, PAST @D125089, 
      AGR [CASE @D125088, COUNT @D125087, PER @D125086, PLU @D125085, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125096, PAST @D125095, AGR [CASE @D125094, COUNT @D125093, 
            PER @D125092, PLU @D125091, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : RUN, 
   [COORD @D125102, PAST @D125101, 
      AGR [CASE @D125100, COUNT @D125099, PER @D125098, PLU @D125097, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125108, PAST @D125107, AGR [CASE @D125106, COUNT @D125105, 
            PER @D125104, PLU @D125103, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : RUN, 
   [COORD @D125114, PAST @D125113, 
      AGR [CASE @D125112, COUNT @D125111, PER @D125110, PLU @D125109, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : RUN, 
   [COORD @D125120, PAST @D125119, AGR [CASE @D125118, COUNT @D125117, 
            PER @D125116, PLU @D125115, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : RUN, 
   [COORD @D125123, 
      AGR [COUNT @D125122, PER @D125121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   RUN, 
   [COORD @D125125, AGR [COUNT @D125124, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RUN, 
   [COORD @D125127, AGR [COUNT @D125126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : RUN, 
   [COORD @D125131, AGR [COUNT @D125130, PER @D125129, PLU @D125128, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : RUN, 
   [COORD @D125137, PAST @D125136, 
      AGR [CASE @D125135, COUNT @D125134, PER @D125133, PLU @D125132, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : RUN, 
   [COORD @D125140, AGR [COUNT @D125139, PER @D125138, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RUN, 
   [COORD @D125142, AGR [COUNT @D125141, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RUN, 
   [COORD @D125144, AGR [COUNT @D125143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : RUN, 
   [COORD @D125148, AGR [COUNT @D125147, PER @D125146, PLU @D125145, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : RUN, 
   [COORD @D125154, PAST @D125153, 
      AGR [CASE @D125152, COUNT @D125151, PER @D125150, PLU @D125149, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : RUN, 
   [COORD @D125157, AGR [COUNT @D125156, PER @D125155, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : RUN, 
   [COORD @D125159, AGR [COUNT @D125158, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : RUN, 
   [COORD @D125161, AGR [COUNT @D125160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : RUN, 
   [COORD @D125165, AGR [COUNT @D125164, PER @D125163, PLU @D125162, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : RUN, 
   [COORD @D125171, PAST @D125170, 
      AGR [CASE @D125169, COUNT @D125168, PER @D125167, PLU @D125166, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, ARITY 1] : RUN, 
   [COORD @D125174, AGR [COUNT @D125173, PER @D125172, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : RUN, 
   [COORD @D125176, AGR [COUNT @D125175, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : RUN, 
   [COORD @D125178, AGR [COUNT @D125177, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : RUN, 
   [COORD @D125182, AGR [COUNT @D125181, PER @D125180, PLU @D125179, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : RUN, 
   [COORD @D125188, PAST @D125187, 
      AGR [CASE @D125186, COUNT @D125185, PER @D125184, PLU @D125183, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, ARITY 1] : RUN, 
   [COORD @D125191, AGR [COUNT @D125190, PER @D125189, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RUN, 
   [COORD @D125193, AGR [COUNT @D125192, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RUN, 
   [COORD @D125195, AGR [COUNT @D125194, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : RUN, 
   [COORD @D125199, AGR [COUNT @D125198, PER @D125197, PLU @D125196, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : RUN, 
   [COORD @D125205, PAST @D125204, 
      AGR [CASE @D125203, COUNT @D125202, PER @D125201, PLU @D125200, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : RUN, 
   [COORD @D125208, AGR [COUNT @D125207, PER @D125206, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : RUN, 
   [COORD @D125210, AGR [COUNT @D125209, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : RUN, 
   [COORD @D125212, AGR [COUNT @D125211, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : RUN, 
   [COORD @D125216, AGR [COUNT @D125215, PER @D125214, PLU @D125213, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : RUN, 
   [COORD @D125222, PAST @D125221, 
      AGR [CASE @D125220, COUNT @D125219, PER @D125218, PLU @D125217, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, ARITY 1] : RUN, 
   [COORD @D125225, AGR [COUNT @D125224, PER @D125223, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : RUN, 
   [COORD @D125227, AGR [COUNT @D125226, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : RUN, 
   [COORD @D125229, AGR [COUNT @D125228, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : RUN, 
   [COORD @D125233, AGR [COUNT @D125232, PER @D125231, PLU @D125230, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : RUN, 
   [COORD @D125239, PAST @D125238, 
      AGR [CASE @D125237, COUNT @D125236, PER @D125235, PLU @D125234, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : RUN, 
   [COORD @D125242, AGR [COUNT @D125241, PER @D125240, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : RUN, 
   [COORD @D125244, AGR [COUNT @D125243, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : RUN, 
   [COORD @D125246, AGR [COUNT @D125245, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : RUN, 
   [COORD @D125250, AGR [COUNT @D125249, PER @D125248, PLU @D125247, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : RUN, 
   [COORD @D125256, PAST @D125255, 
      AGR [CASE @D125254, COUNT @D125253, PER @D125252, PLU @D125251, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : RUN, 
   [COORD @D125259, AGR [COUNT @D125258, PER @D125257, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : RUN, 
   [COORD @D125261, AGR [COUNT @D125260, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : RUN, 
   [COORD @D125263, AGR [COUNT @D125262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : RUN, 
   [COORD @D125267, AGR [COUNT @D125266, PER @D125265, PLU @D125264, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : RUN, 
   [COORD @D125273, PAST @D125272, 
      AGR [CASE @D125271, COUNT @D125270, PER @D125269, PLU @D125268, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : RUN, 
   [COORD @D125276, AGR [COUNT @D125275, PER @D125274, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : RUN, 
   [COORD @D125278, AGR [COUNT @D125277, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : RUN, 
   [COORD @D125280, AGR [COUNT @D125279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : RUN, 
   [COORD @D125284, AGR [COUNT @D125283, PER @D125282, PLU @D125281, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : RUN, 
   [COORD @D125290, PAST @D125289, 
      AGR [CASE @D125288, COUNT @D125287, PER @D125286, PLU @D125285, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, ARITY 1] : RUN, 
   [COORD @D125293, AGR [COUNT @D125292, PER @D125291, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : RUN, 
   [COORD @D125295, AGR [COUNT @D125294, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : RUN, 
   [COORD @D125297, AGR [COUNT @D125296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : RUN, 
   [COORD @D125301, AGR [COUNT @D125300, PER @D125299, PLU @D125298, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : RUN, 
   [COORD @D125307, PAST @D125306, 
      AGR [CASE @D125305, COUNT @D125304, PER @D125303, PLU @D125302, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, ARITY 1] : RUN, 
   [COORD @D125310, AGR [COUNT @D125309, PER @D125308, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : RUN, 
   [COORD @D125312, AGR [COUNT @D125311, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : RUN, 
   [COORD @D125314, AGR [COUNT @D125313, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : RUN, 
   [COORD @D125318, AGR [COUNT @D125317, PER @D125316, PLU @D125315, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, ARITY 1] : RUN, 
   [COORD @D125324, PAST @D125323, 
      AGR [CASE @D125322, COUNT @D125321, PER @D125320, PLU @D125319, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, ARITY 1] : RUN, 
   [COORD @D125327, AGR [COUNT @D125326, PER @D125325, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : RUN, 
   [COORD @D125329, AGR [COUNT @D125328, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : RUN, 
   [COORD @D125331, AGR [COUNT @D125330, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ALONG, ARITY 1] : RUN, 
   [COORD @D125335, AGR [COUNT @D125334, PER @D125333, PLU @D125332, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALONG, ARITY 1] : RUN, 
   [COORD @D125341, PAST @D125340, 
      AGR [CASE @D125339, COUNT @D125338, PER @D125337, PLU @D125336, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ALONG, ARITY 1] : RUN, 
   [COORD @D125347, PAST @D125346, AGR [CASE @D125345, COUNT @D125344, 
            PER @D125343, PLU @D125342, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : RUN, 
   [COORD @D125353, PAST @D125352, 
      AGR [CASE @D125351, COUNT @D125350, PER @D125349, PLU @D125348, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      FIN -, ARITY 1] : RUN, 
   [COORD @D125359, PAST @D125358, AGR [CASE @D125357, COUNT @D125356, 
            PER @D125355, PLU @D125354, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, FIN -, ARITY 1] : RUN, 
   [COORD @D125365, PAST @D125364, 
      AGR [CASE @D125363, COUNT @D125362, PER @D125361, PLU @D125360, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      FIN -, ARITY 1] : RUN, 
   [COORD @D125371, PAST @D125370, AGR [CASE @D125369, COUNT @D125368, 
            PER @D125367, PLU @D125366, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : RUN, 
   [COORD @D125377, PAST @D125376, 
      AGR [CASE @D125375, COUNT @D125374, PER @D125373, PLU @D125372, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT ON, 
      FIN -, ARITY 1] : RUN, 
   [COORD @D125383, PAST @D125382, AGR [CASE @D125381, COUNT @D125380, 
            PER @D125379, PLU @D125378, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : RUN, 
   [COORD @D125389, PAST @D125388, 
      AGR [CASE @D125387, COUNT @D125386, PER @D125385, PLU @D125384, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      FIN -, ARITY 1] : RUN, 
   [COORD @D125395, PAST @D125394, AGR [CASE @D125393, COUNT @D125392, 
            PER @D125391, PLU @D125390, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : RUN, 
   [COORD @D125401, PAST @D125400, 
      AGR [CASE @D125399, COUNT @D125398, PER @D125397, PLU @D125396, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      FIN -, ARITY 1] : RUN, 
   [COORD @D125407, PAST @D125406, AGR [CASE @D125405, COUNT @D125404, 
            PER @D125403, PLU @D125402, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, FIN -, ARITY 1] : RUN, 
   [COORD @D125413, PAST @D125412, 
      AGR [CASE @D125411, COUNT @D125410, PER @D125409, PLU @D125408, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AROUND, 
      FIN -, ARITY 1] : RUN, 
   [COORD @D125419, PAST @D125418, AGR [CASE @D125417, COUNT @D125416, 
            PER @D125415, PLU @D125414, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ALONG, FIN -, ARITY 1] : RUN.

WORD running : 
   [COORD @D125435, PRD @D125434, AGR [CASE @D125433, COUNT @D125432, 
            PER @D125431, PLU @D125430, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125441, PRD @D125440, 
      AGR [CASE @D125439, COUNT @D125438, PER @D125437, PLU @D125436, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125447, PRD @D125446, AGR [CASE @D125445, COUNT @D125444, 
            PER @D125443, PLU @D125442, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125453, PRD @D125452, 
      AGR [CASE @D125451, COUNT @D125450, PER @D125449, PLU @D125448, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM THROUGH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125459, PRD @D125458, AGR [CASE @D125457, COUNT @D125456, 
            PER @D125455, PLU @D125454, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125465, PRD @D125464, 
      AGR [CASE @D125463, COUNT @D125462, PER @D125461, PLU @D125460, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125471, PRD @D125470, AGR [CASE @D125469, COUNT @D125468, 
            PER @D125467, PLU @D125466, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125477, PRD @D125476, 
      AGR [CASE @D125475, COUNT @D125474, PER @D125473, PLU @D125472, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125483, PRD @D125482, AGR [CASE @D125481, COUNT @D125480, 
            PER @D125479, PLU @D125478, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PRT OFF, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125489, PRD @D125488, 
      AGR [CASE @D125487, COUNT @D125486, PER @D125485, PLU @D125484, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125495, PRD @D125494, AGR [CASE @D125493, COUNT @D125492, 
            PER @D125491, PLU @D125490, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125501, PRD @D125500, 
      AGR [CASE @D125499, COUNT @D125498, PER @D125497, PLU @D125496, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125507, PRD @D125506, AGR [CASE @D125505, COUNT @D125504, 
            PER @D125503, PLU @D125502, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125513, PRD @D125512, 
      AGR [CASE @D125511, COUNT @D125510, PER @D125509, PLU @D125508, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT MP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RUN, 
   [COORD @D125519, PRD @D125518, AGR [CASE @D125517, COUNT @D125516, 
            PER @D125515, PLU @D125514, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125525, PRD @D125524, 
      AGR [CASE @D125523, COUNT @D125522, PER @D125521, PLU @D125520, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT THROUGH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125531, PRD @D125530, AGR [CASE @D125529, COUNT @D125528, 
            PER @D125527, PLU @D125526, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125537, PRD @D125536, 
      AGR [CASE @D125535, COUNT @D125534, PER @D125533, PLU @D125532, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125543, PRD @D125542, AGR [CASE @D125541, COUNT @D125540, 
            PER @D125539, PLU @D125538, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT AWAY, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125549, PRD @D125548, 
      AGR [CASE @D125547, COUNT @D125546, PER @D125545, PLU @D125544, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125555, PRD @D125554, 
      AGR [CASE @D125553, COUNT @D125552, PER @D125551, PLU @D125550, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125561, PRD @D125560, AGR [CASE @D125559, COUNT @D125558, 
            PER @D125557, PLU @D125556, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125567, PRD @D125566, 
      AGR [CASE @D125565, COUNT @D125564, PER @D125563, PLU @D125562, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125573, PRD @D125572, AGR [CASE @D125571, COUNT @D125570, 
            PER @D125569, PLU @D125568, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT BACK, 
      PFORM OVER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125579, PRD @D125578, 
      AGR [CASE @D125577, COUNT @D125576, PER @D125575, PLU @D125574, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RUN, 
   [COORD @D125585, PRD @D125584, AGR [CASE @D125583, COUNT @D125582, 
            PER @D125581, PLU @D125580, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125591, PRD @D125590, 
      AGR [CASE @D125589, COUNT @D125588, PER @D125587, PLU @D125586, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125597, PRD @D125596, AGR [CASE @D125595, COUNT @D125594, 
            PER @D125593, PLU @D125592, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125603, PRD @D125602, 
      AGR [CASE @D125601, COUNT @D125600, PER @D125599, PLU @D125598, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125609, PRD @D125608, AGR [CASE @D125607, COUNT @D125606, 
            PER @D125605, PLU @D125604, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125615, PRD @D125614, 
      AGR [CASE @D125613, COUNT @D125612, PER @D125611, PLU @D125610, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125621, PRD @D125620, AGR [CASE @D125619, COUNT @D125618, 
            PER @D125617, PLU @D125616, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125627, PRD @D125626, 
      AGR [CASE @D125625, COUNT @D125624, PER @D125623, PLU @D125622, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RUN, 
   [COORD @D125633, PRD @D125632, AGR [CASE @D125631, COUNT @D125630, 
            PER @D125629, PLU @D125628, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125639, PRD @D125638, 
      AGR [CASE @D125637, COUNT @D125636, PER @D125635, PLU @D125634, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125645, PRD @D125644, AGR [CASE @D125643, COUNT @D125642, 
            PER @D125641, PLU @D125640, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AFTER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125651, PRD @D125650, 
      AGR [CASE @D125649, COUNT @D125648, PER @D125647, PLU @D125646, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125657, PRD @D125656, AGR [CASE @D125655, COUNT @D125654, 
            PER @D125653, PLU @D125652, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125663, PRD @D125662, 
      AGR [CASE @D125661, COUNT @D125660, PER @D125659, PLU @D125658, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RUN, 
   [COORD @D125669, PRD @D125668, AGR [CASE @D125667, COUNT @D125666, 
            PER @D125665, PLU @D125664, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125675, PRD @D125674, 
      AGR [CASE @D125673, COUNT @D125672, PER @D125671, PLU @D125670, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RUN, 
   [COORD @D125681, PRD @D125680, AGR [CASE @D125679, COUNT @D125678, 
            PER @D125677, PLU @D125676, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125687, PRD @D125686, 
      AGR [CASE @D125685, COUNT @D125684, PER @D125683, PLU @D125682, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : RUN, 
   [COORD @D125693, PRD @D125692, AGR [CASE @D125691, COUNT @D125690, 
            PER @D125689, PLU @D125688, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125699, PRD @D125698, 
      AGR [CASE @D125697, COUNT @D125696, PER @D125695, PLU @D125694, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125705, PRD @D125704, AGR [CASE @D125703, COUNT @D125702, 
            PER @D125701, PLU @D125700, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125711, PRD @D125710, 
      AGR [CASE @D125709, COUNT @D125708, PER @D125707, PLU @D125706, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125717, PRD @D125716, AGR [CASE @D125715, COUNT @D125714, 
            PER @D125713, PLU @D125712, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125723, PRD @D125722, 
      AGR [CASE @D125721, COUNT @D125720, PER @D125719, PLU @D125718, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125729, PRD @D125728, AGR [CASE @D125727, COUNT @D125726, 
            PER @D125725, PLU @D125724, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125735, PRD @D125734, 
      AGR [CASE @D125733, COUNT @D125732, PER @D125731, PLU @D125730, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125741, PRD @D125740, AGR [CASE @D125739, COUNT @D125738, 
            PER @D125737, PLU @D125736, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125747, PRD @D125746, 
      AGR [CASE @D125745, COUNT @D125744, PER @D125743, PLU @D125742, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125753, PRD @D125752, AGR [CASE @D125751, COUNT @D125750, 
            PER @D125749, PLU @D125748, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125759, PRD @D125758, 
      AGR [CASE @D125757, COUNT @D125756, PER @D125755, PLU @D125754, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125765, PRD @D125764, AGR [CASE @D125763, COUNT @D125762, 
            PER @D125761, PLU @D125760, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : RUN, 
   [COORD @D125771, PRD @D125770, 
      AGR [CASE @D125769, COUNT @D125768, PER @D125767, PLU @D125766, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : RUN.

WORD runs : 
   [COORD @D125779, REFL @D125778, PRD @D125777, CASE @D125776, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : RUNS, 
   [COORD @D125784, DEMON @D125783, REFL @D125782, PRD @D125781, 
      CASE @D125780, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   RUN, 
   [COORD @D125786, AGR [COUNT @D125785, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125788, 
      AGR [COUNT @D125787, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125790, 
      AGR [COUNT @D125789, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125792, 
      AGR [COUNT @D125791, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RUN, 
   [COORD @D125794, AGR [COUNT @D125793, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125796, AGR [COUNT @D125795, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125798, AGR [COUNT @D125797, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125800, AGR [COUNT @D125799, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125802, AGR [COUNT @D125801, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PRT OFF, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125804, AGR [COUNT @D125803, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125806, AGR [COUNT @D125805, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125808, AGR [COUNT @D125807, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125810, 
      AGR [COUNT @D125809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125812, 
      AGR [COUNT @D125811, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT MP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125814, 
      AGR [COUNT @D125813, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125816, 
      AGR [COUNT @D125815, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125818, 
      AGR [COUNT @D125817, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125820, 
      AGR [COUNT @D125819, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RUN, 
   [COORD @D125822, AGR [COUNT @D125821, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125824, AGR [COUNT @D125823, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AROUND, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125826, AGR [COUNT @D125825, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125828, AGR [COUNT @D125827, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125830, AGR [COUNT @D125829, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125832, AGR [COUNT @D125831, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT BACK, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125834, AGR [COUNT @D125833, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125836, AGR [COUNT @D125835, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125838, AGR [COUNT @D125837, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125840, AGR [COUNT @D125839, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125842, AGR [COUNT @D125841, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RUN, 
   [COORD @D125844, AGR [COUNT @D125843, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125846, AGR [COUNT @D125845, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125848, AGR [COUNT @D125847, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RUN, 
   [COORD @D125850, AGR [COUNT @D125849, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125852, AGR [COUNT @D125851, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125854, AGR [COUNT @D125853, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : RUN, 
   [COORD @D125856, AGR [COUNT @D125855, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AFTER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125858, AGR [COUNT @D125857, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ACROSS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125860, AGR [COUNT @D125859, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125862, AGR [COUNT @D125861, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125864, AGR [COUNT @D125863, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125866, AGR [COUNT @D125865, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125868, AGR [COUNT @D125867, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125870, AGR [COUNT @D125869, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125872, AGR [COUNT @D125871, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125874, AGR [COUNT @D125873, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125876, 
      AGR [COUNT @D125875, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : RUN, 
   [COORD @D125878, 
      AGR [COUNT @D125877, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RUN, 
   [COORD @D125880, AGR [COUNT @D125879, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125882, AGR [COUNT @D125881, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125884, AGR [COUNT @D125883, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RUN, 
   [COORD @D125886, AGR [COUNT @D125885, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125888, AGR [COUNT @D125887, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   RUN, 
   [COORD @D125890, AGR [COUNT @D125889, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125892, AGR [COUNT @D125891, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125894, AGR [COUNT @D125893, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125896, AGR [COUNT @D125895, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN, 
   [COORD @D125898, AGR [COUNT @D125897, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ALONG, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : RUN.

WORD said : 
   [COADV @D125920, COORD @D125919, DEF @D125918, PRD @D125917, AGR 
         [CASE @D125916, COUNT @D125915, PER @D125914, PLU @D125913, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR ATT] : SAID, 
   [COORD @D125926, PAST @D125925, 
      AGR [CASE @D125924, COUNT @D125923, PER @D125922, PLU @D125921, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : SAY, 
   [COORD @D125932, PAST @D125931, AGR [CASE @D125930, COUNT @D125929, 
            PER @D125928, PLU @D125927, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : SAY, 
   [COORD @D125938, PAST @D125937, 
      AGR [CASE @D125936, COUNT @D125935, PER @D125934, PLU @D125933, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      FIN -, ARITY 3] : SAY, 
   [COORD @D125944, PAST @D125943, AGR [CASE @D125942, COUNT @D125941, 
            PER @D125940, PLU @D125939, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : SAY, 
   [COORD @D125948, 
      AGR [COUNT @D125947, PER @D125946, PLU @D125945, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : SAY, 
   [COORD @D125952, AGR [COUNT @D125951, PER @D125950, PLU @D125949, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, PAST +, ARITY 3] : SAY, 
   [COORD @D125958, PAST @D125957, 
      AGR [CASE @D125956, COUNT @D125955, PER @D125954, PLU @D125953, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, FIN -, 
      ARITY 2] : SAY, 
   [COORD @D125964, PAST @D125963, AGR [CASE @D125962, COUNT @D125961, 
            PER @D125960, PLU @D125959, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, FIN -, ARITY 2] : SAY, 
   [COORD @D125970, PAST @D125969, 
      AGR [CASE @D125968, COUNT @D125967, PER @D125966, PLU @D125965, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, 
      ARITY 2] : SAY, 
   [COORD @D125976, PAST @D125975, AGR [CASE @D125974, COUNT @D125973, 
            PER @D125972, PLU @D125971, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, FIN -, ARITY 2] : SAY, 
   [COORD @D125982, PAST @D125981, 
      AGR [CASE @D125980, COUNT @D125979, PER @D125978, PLU @D125977, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SAY, 
   [COORD @D125988, PAST @D125987, AGR [CASE @D125986, COUNT @D125985, 
            PER @D125984, PLU @D125983, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SAY, 
   [COORD @D125992, AGR [COUNT @D125991, PER @D125990, PLU @D125989, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, PAST +, ARITY 2] : SAY, 
   [COORD @D125996, AGR [COUNT @D125995, PER @D125994, PLU @D125993, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PAST +, ARITY 2] : SAY, 
   [COORD @D126000, AGR [COUNT @D125999, PER @D125998, PLU @D125997, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PAST +, ARITY 2] : SAY, 
   [COORD @D126004, AGR [COUNT @D126003, PER @D126002, PLU @D126001, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PAST +, ARITY 2] : SAY, 
   [COORD @D126008, AGR [COUNT @D126007, PER @D126006, PLU @D126005, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SAY, 
   [COORD @D126014, PAST @D126013, 
      AGR [CASE @D126012, COUNT @D126011, PER @D126010, PLU @D126009, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SAY, 
   [COORD @D126020, PAST @D126019, AGR [CASE @D126018, COUNT @D126017, 
            PER @D126016, PLU @D126015, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : SAY, 
   [COORD @D126024, 
      AGR [COUNT @D126023, PER @D126022, PLU @D126021, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : SAY, 
   [COORD @D126028, AGR [COUNT @D126027, PER @D126026, PLU @D126025, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, PAST +, ARITY 1] : SAY.

WORD sat : 
   [COORD @D126060, PAST @D126059, AGR [CASE @D126058, COUNT @D126057, 
            PER @D126056, PLU @D126055, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SIT, 
   [COORD @D126066, PAST @D126065, 
      AGR [CASE @D126064, COUNT @D126063, PER @D126062, PLU @D126061, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SIT, 
   [COORD @D126072, PAST @D126071, AGR [CASE @D126070, COUNT @D126069, 
            PER @D126068, PLU @D126067, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, FIN -, ARITY 2] : SIT, 
   [COORD @D126078, PAST @D126077, 
      AGR [CASE @D126076, COUNT @D126075, PER @D126074, PLU @D126073, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT UP, FIN -, 
      ARITY 2] : SIT, 
   [COORD @D126084, PAST @D126083, AGR [CASE @D126082, COUNT @D126081, 
            PER @D126080, PLU @D126079, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT UP, FIN -, ARITY 2] : SIT, 
   [COORD @D126090, PAST @D126089, 
      AGR [CASE @D126088, COUNT @D126087, PER @D126086, PLU @D126085, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, PRT DOWN, 
      FIN -, ARITY 2] : SIT, 
   [COORD @D126096, PAST @D126095, AGR [CASE @D126094, COUNT @D126093, 
            PER @D126092, PLU @D126091, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM WITH, FIN -, ARITY 2] : SIT, 
   [COORD @D126102, PAST @D126101, 
      AGR [CASE @D126100, COUNT @D126099, PER @D126098, PLU @D126097, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      FIN -, ARITY 2] : SIT, 
   [COORD @D126108, PAST @D126107, AGR [CASE @D126106, COUNT @D126105, 
            PER @D126104, PLU @D126103, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM UNDER, FIN -, ARITY 2] : SIT, 
   [COORD @D126114, PAST @D126113, 
      AGR [CASE @D126112, COUNT @D126111, PER @D126110, PLU @D126109, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT DOWN, 
      PFORM UNDER, FIN -, ARITY 2] : SIT, 
   [COORD @D126120, PAST @D126119, 
      AGR [CASE @D126118, COUNT @D126117, PER @D126116, PLU @D126115, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, FIN -, ARITY 2] : SIT, 
   [COORD @D126126, PAST @D126125, AGR [CASE @D126124, COUNT @D126123, 
            PER @D126122, PLU @D126121, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ON, FIN -, ARITY 2] : SIT, 
   [COORD @D126132, PAST @D126131, 
      AGR [CASE @D126130, COUNT @D126129, PER @D126128, PLU @D126127, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, FIN -, 
      ARITY 2] : SIT, 
   [COORD @D126138, PAST @D126137, AGR [CASE @D126136, COUNT @D126135, 
            PER @D126134, PLU @D126133, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, PFORM ON, FIN -, ARITY 2] : SIT, 
   [COORD @D126144, PAST @D126143, 
      AGR [CASE @D126142, COUNT @D126141, PER @D126140, PLU @D126139, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, PFORM ON, 
      FIN -, ARITY 2] : SIT, 
   [COORD @D126150, PAST @D126149, AGR [CASE @D126148, COUNT @D126147, 
            PER @D126146, PLU @D126145, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM FOR, FIN -, ARITY 2] : SIT, 
   [COORD @D126156, PAST @D126155, 
      AGR [CASE @D126154, COUNT @D126153, PER @D126152, PLU @D126151, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, FIN -, 
      ARITY 2] : SIT, 
   [COORD @D126162, PAST @D126161, AGR [CASE @D126160, COUNT @D126159, 
            PER @D126158, PLU @D126157, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM FOR, FIN -, ARITY 2] : SIT, 
   [COORD @D126168, PAST @D126167, 
      AGR [CASE @D126166, COUNT @D126165, PER @D126164, PLU @D126163, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, FIN -, ARITY 2] : SIT, 
   [COORD @D126174, PAST @D126173, AGR 
         [CASE @D126172, COUNT @D126171, PER @D126170, PLU @D126169, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM AT, FIN -, ARITY 2] : SIT, 
   [COORD @D126180, PAST @D126179, AGR [CASE @D126178, COUNT @D126177, 
            PER @D126176, PLU @D126175, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT IN, PFORM AS, FIN -, ARITY 2] : SIT, 
   [COORD @D126186, PAST @D126185, 
      AGR [CASE @D126184, COUNT @D126183, PER @D126182, PLU @D126181, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : SIT, 
   [COORD @D126192, PAST @D126191, AGR [CASE @D126190, COUNT @D126189, 
            PER @D126188, PLU @D126187, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SIT, 
   [COORD @D126198, PAST @D126197, 
      AGR [CASE @D126196, COUNT @D126195, PER @D126194, PLU @D126193, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : SIT, 
   [COORD @D126204, PAST @D126203, AGR [CASE @D126202, COUNT @D126201, 
            PER @D126200, PLU @D126199, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : SIT, 
   [COORD @D126208, 
      AGR [COUNT @D126207, PER @D126206, PLU @D126205, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : SIT, 
   [COORD @D126212, AGR [COUNT @D126211, PER @D126210, PLU @D126209, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PAST +, ARITY 2] : SIT, 
   [COORD @D126216, AGR [COUNT @D126215, PER @D126214, PLU @D126213, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT UP, PAST +, ARITY 2] : SIT, 
   [COORD @D126220, AGR 
         [COUNT @D126219, PER @D126218, PLU @D126217, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT DOWN, PAST +, ARITY 2] : SIT, 
   [COORD @D126224, AGR [COUNT @D126223, PER @D126222, PLU @D126221, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, PAST +, ARITY 2] : SIT, 
   [COORD @D126228, AGR [COUNT @D126227, PER @D126226, PLU @D126225, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT DOWN, PFORM UNDER, PAST +, ARITY 2] : SIT, 
   [COORD @D126232, 
      AGR [COUNT @D126231, PER @D126230, PLU @D126229, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, PAST +, ARITY 2] : SIT, 
   [COORD @D126236, AGR [COUNT @D126235, PER @D126234, PLU @D126233, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, PAST +, ARITY 2] : SIT, 
   [COORD @D126240, AGR [COUNT @D126239, PER @D126238, PLU @D126237, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM ON, PAST +, ARITY 2] : SIT, 
   [COORD @D126244, AGR [COUNT @D126243, PER @D126242, PLU @D126241, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, PAST +, ARITY 2] : SIT, 
   [COORD @D126248, AGR [COUNT @D126247, PER @D126246, PLU @D126245, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM FOR, PAST +, ARITY 2] : SIT, 
   [COORD @D126252, 
      AGR [COUNT @D126251, PER @D126250, PLU @D126249, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, PAST +, ARITY 2] : SIT, 
   [COORD @D126256, AGR [COUNT @D126255, PER @D126254, PLU @D126253, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM AT, PAST +, ARITY 2] : SIT, 
   [COORD @D126260, 
      AGR [COUNT @D126259, PER @D126258, PLU @D126257, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM AS, PAST +, ARITY 2] : SIT, 
   [COORD @D126264, AGR [COUNT @D126263, PER @D126262, PLU @D126261, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SIT, 
   [COORD @D126268, AGR [COUNT @D126267, PER @D126266, PLU @D126265, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : SIT, 
   [COORD @D126274, PAST @D126273, 
      AGR [CASE @D126272, COUNT @D126271, PER @D126270, PLU @D126269, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SIT, 
   [COORD @D126280, PAST @D126279, AGR [CASE @D126278, COUNT @D126277, 
            PER @D126276, PLU @D126275, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : SIT, 
   [COORD @D126286, PAST @D126285, 
      AGR [CASE @D126284, COUNT @D126283, PER @D126282, PLU @D126281, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : SIT, 
   [COORD @D126292, PAST @D126291, AGR [CASE @D126290, COUNT @D126289, 
            PER @D126288, PLU @D126287, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : SIT, 
   [COORD @D126298, PAST @D126297, 
      AGR [CASE @D126296, COUNT @D126295, PER @D126294, PLU @D126293, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      FIN -, ARITY 1] : SIT, 
   [COORD @D126304, PAST @D126303, AGR [CASE @D126302, COUNT @D126301, 
            PER @D126300, PLU @D126299, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, FIN -, ARITY 1] : SIT, 
   [COORD @D126310, PAST @D126309, 
      AGR [CASE @D126308, COUNT @D126307, PER @D126306, PLU @D126305, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      FIN -, ARITY 1] : SIT, 
   [COORD @D126316, PAST @D126315, AGR [CASE @D126314, COUNT @D126313, 
            PER @D126312, PLU @D126311, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, FIN -, ARITY 1] : SIT, 
   [COORD @D126320, 
      AGR [COUNT @D126319, PER @D126318, PLU @D126317, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : SIT, 
   [COORD @D126324, AGR [COUNT @D126323, PER @D126322, PLU @D126321, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SIT, 
   [COORD @D126328, 
      AGR [COUNT @D126327, PER @D126326, PLU @D126325, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : SIT, 
   [COORD @D126332, AGR [COUNT @D126331, PER @D126330, PLU @D126329, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, PAST +, ARITY 1] : SIT, 
   [COORD @D126336, 
      AGR [COUNT @D126335, PER @D126334, PLU @D126333, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : SIT, 
   [COORD @D126340, AGR [COUNT @D126339, PER @D126338, PLU @D126337, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, PAST +, ARITY 1] : SIT, 
   [COORD @D126344, 
      AGR [COUNT @D126343, PER @D126342, PLU @D126341, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, PAST +, ARITY 1] : SIT, 
   [COORD @D126348, AGR [COUNT @D126347, PER @D126346, PLU @D126345, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, PAST +, ARITY 1] : SIT.

WORD sauce : 
   [COORD @D126370, REFL @D126369, COUNT @D126368, PRD @D126367, 
      CASE @D126366, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SAUCE, 
   [COORD @D126373, 
      AGR [COUNT @D126372, PER @D126371, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   SAUCE, 
   [COORD @D126375, AGR [COUNT @D126374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SAUCE, 
   [COORD @D126377, AGR [COUNT @D126376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SAUCE, 
   [COORD @D126381, AGR [COUNT @D126380, PER @D126379, PLU @D126378, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SAUCE, 
   [COORD @D126387, PAST @D126386, AGR [CASE @D126385, COUNT @D126384, 
            PER @D126383, PLU @D126382, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SAUCE.

WORD sauced : 
   [COORD @D126399, AGR [CASE @D126398, COUNT @D126397, PER @D126396, 
            PLU @D126395, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAUCE, 
   [COORD @D126404, AGR [CASE @D126403, COUNT @D126402, PER @D126401, 
            PLU @D126400, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAUCE, 
   [COORD @D126409, AGR [CASE @D126408, COUNT @D126407, PER @D126406, 
            PLU @D126405, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SAUCE.

WORD sauces : 
   [COORD @D126421, DEMON @D126420, REFL @D126419, PRD @D126418, 
      CASE @D126417, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SAUCE, 
   [COORD @D126423, AGR [COUNT @D126422, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAUCE.

WORD saucing : 
   [COORD @D126436, PRD @D126435, AGR [CASE @D126434, COUNT @D126433, 
            PER @D126432, PLU @D126431, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAUCE.

WORD save : 
   [COORD @D126443, AGR [COUNT @D126442, PER @D126441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : SAVE, 
   [COORD @D126445, AGR [COUNT @D126444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : SAVE, 
   [COORD @D126447, AGR [COUNT @D126446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : SAVE, 
   [COORD @D126451, AGR [COUNT @D126450, PER @D126449, PLU @D126448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : SAVE, 
   [COORD @D126457, PAST @D126456, AGR [CASE @D126455, COUNT @D126454, 
            PER @D126453, PLU @D126452, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_ING, ARITY 3] : SAVE, 
   [COORD @D126460, AGR [COUNT @D126459, PER @D126458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SAVE, 
   [COORD @D126462, AGR [COUNT @D126461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SAVE, 
   [COORD @D126464, AGR [COUNT @D126463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SAVE, 
   [COORD @D126468, AGR [COUNT @D126467, PER @D126466, PLU @D126465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SAVE, 
   [COORD @D126474, PAST @D126473, AGR [CASE @D126472, COUNT @D126471, 
            PER @D126470, PLU @D126469, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : SAVE, 
   [COORD @D126477, AGR [COUNT @D126476, PER @D126475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SAVE, 
   [COORD @D126479, AGR [COUNT @D126478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SAVE, 
   [COORD @D126481, AGR [COUNT @D126480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SAVE, 
   [COORD @D126485, AGR [COUNT @D126484, PER @D126483, PLU @D126482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SAVE, 
   [COORD @D126491, PAST @D126490, 
      AGR [CASE @D126489, COUNT @D126488, PER @D126487, PLU @D126486, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : SAVE, 
   [COORD @D126494, AGR [COUNT @D126493, PER @D126492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SAVE, 
   [COORD @D126496, AGR [COUNT @D126495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SAVE, 
   [COORD @D126498, AGR [COUNT @D126497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SAVE, 
   [COORD @D126502, AGR [COUNT @D126501, PER @D126500, PLU @D126499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SAVE, 
   [COORD @D126508, PAST @D126507, 
      AGR [CASE @D126506, COUNT @D126505, PER @D126504, PLU @D126503, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : SAVE, 
   [COORD @D126511, AGR [COUNT @D126510, PER @D126509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SAVE, 
   [COORD @D126513, AGR [COUNT @D126512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SAVE, 
   [COORD @D126515, AGR [COUNT @D126514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SAVE, 
   [COORD @D126519, AGR [COUNT @D126518, PER @D126517, PLU @D126516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SAVE, 
   [COORD @D126525, PAST @D126524, 
      AGR [CASE @D126523, COUNT @D126522, PER @D126521, PLU @D126520, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : SAVE, 
   [COORD @D126528, AGR [COUNT @D126527, PER @D126526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : SAVE, 
   [COORD @D126530, AGR [COUNT @D126529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : SAVE, 
   [COORD @D126532, AGR [COUNT @D126531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : SAVE, 
   [COORD @D126536, AGR [COUNT @D126535, PER @D126534, PLU @D126533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : SAVE, 
   [COORD @D126542, PAST @D126541, AGR [CASE @D126540, COUNT @D126539, 
            PER @D126538, PLU @D126537, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : SAVE, 
   [COORD @D126545, AGR [COUNT @D126544, PER @D126543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SAVE, 
   [COORD @D126547, AGR [COUNT @D126546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SAVE, 
   [COORD @D126549, AGR [COUNT @D126548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SAVE, 
   [COORD @D126553, AGR [COUNT @D126552, PER @D126551, PLU @D126550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SAVE, 
   [COORD @D126559, PAST @D126558, AGR [CASE @D126557, COUNT @D126556, 
            PER @D126555, PLU @D126554, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SAVE, 
   [COORD @D126562, AGR [COUNT @D126561, PER @D126560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SAVE, 
   [COORD @D126564, AGR [COUNT @D126563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SAVE, 
   [COORD @D126566, AGR [COUNT @D126565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SAVE, 
   [COORD @D126570, AGR [COUNT @D126569, PER @D126568, PLU @D126567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : SAVE, 
   [COORD @D126576, PAST @D126575, 
      AGR [CASE @D126574, COUNT @D126573, PER @D126572, PLU @D126571, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SAVE, 
   [COORD @D126579, AGR [COUNT @D126578, PER @D126577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126581, AGR [COUNT @D126580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126583, AGR [COUNT @D126582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126587, AGR [COUNT @D126586, PER @D126585, PLU @D126584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126593, PAST @D126592, 
      AGR [CASE @D126591, COUNT @D126590, PER @D126589, PLU @D126588, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126596, AGR [COUNT @D126595, PER @D126594, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126598, AGR [COUNT @D126597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126600, AGR [COUNT @D126599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126604, AGR [COUNT @D126603, PER @D126602, PLU @D126601, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126610, PAST @D126609, 
      AGR [CASE @D126608, COUNT @D126607, PER @D126606, PLU @D126605, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : SAVE, 
   [COORD @D126613, AGR [COUNT @D126612, PER @D126611, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SAVE, 
   [COORD @D126615, AGR [COUNT @D126614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SAVE, 
   [COORD @D126617, AGR [COUNT @D126616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SAVE, 
   [COORD @D126621, AGR [COUNT @D126620, PER @D126619, PLU @D126618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SAVE, 
   [COORD @D126627, PAST @D126626, AGR [CASE @D126625, COUNT @D126624, 
            PER @D126623, PLU @D126622, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SAVE, 
   [COORD @D126630, AGR [COUNT @D126629, PER @D126628, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SAVE, 
   [COORD @D126632, AGR [COUNT @D126631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SAVE, 
   [COORD @D126634, AGR [COUNT @D126633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SAVE, 
   [COORD @D126638, AGR [COUNT @D126637, PER @D126636, PLU @D126635, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SAVE, 
   [COORD @D126644, PAST @D126643, 
      AGR [CASE @D126642, COUNT @D126641, PER @D126640, PLU @D126639, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : SAVE.

WORD saved : 
   [COORD @D126654, AGR [CASE @D126653, COUNT @D126652, PER @D126651, 
            PLU @D126650, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAVE, 
   [COORD @D126659, AGR [CASE @D126658, COUNT @D126657, PER @D126656, 
            PLU @D126655, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126664, AGR [CASE @D126663, COUNT @D126662, PER @D126661, 
            PLU @D126660, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126669, AGR [CASE @D126668, COUNT @D126667, PER @D126666, 
            PLU @D126665, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAVE, 
   [COORD @D126674, AGR [CASE @D126673, COUNT @D126672, PER @D126671, 
            PLU @D126670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126679, AGR [CASE @D126678, COUNT @D126677, PER @D126676, 
            PLU @D126675, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126684, AGR [CASE @D126683, COUNT @D126682, PER @D126681, 
            PLU @D126680, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126689, AGR [CASE @D126688, COUNT @D126687, PER @D126686, 
            PLU @D126685, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126694, AGR [CASE @D126693, COUNT @D126692, PER @D126691, 
            PLU @D126690, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126699, AGR [CASE @D126698, COUNT @D126697, PER @D126696, 
            PLU @D126695, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126704, AGR [CASE @D126703, COUNT @D126702, PER @D126701, 
            PLU @D126700, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126709, AGR [CASE @D126708, COUNT @D126707, PER @D126706, 
            PLU @D126705, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126714, AGR [CASE @D126713, COUNT @D126712, PER @D126711, 
            PLU @D126710, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126719, AGR [CASE @D126718, COUNT @D126717, PER @D126716, 
            PLU @D126715, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126724, AGR [CASE @D126723, COUNT @D126722, PER @D126721, 
            PLU @D126720, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126729, AGR [CASE @D126728, COUNT @D126727, PER @D126726, 
            PLU @D126725, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126734, AGR [CASE @D126733, COUNT @D126732, PER @D126731, 
            PLU @D126730, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126739, AGR [CASE @D126738, COUNT @D126737, PER @D126736, 
            PLU @D126735, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126744, AGR [CASE @D126743, COUNT @D126742, PER @D126741, 
            PLU @D126740, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126749, AGR [CASE @D126748, COUNT @D126747, PER @D126746, 
            PLU @D126745, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAVE, 
   [COORD @D126754, AGR [CASE @D126753, COUNT @D126752, PER @D126751, 
            PLU @D126750, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126759, AGR [CASE @D126758, COUNT @D126757, PER @D126756, 
            PLU @D126755, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126764, AGR [CASE @D126763, COUNT @D126762, PER @D126761, 
            PLU @D126760, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126769, AGR [CASE @D126768, COUNT @D126767, PER @D126766, 
            PLU @D126765, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126774, AGR [CASE @D126773, COUNT @D126772, PER @D126771, 
            PLU @D126770, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126779, AGR [CASE @D126778, COUNT @D126777, PER @D126776, 
            PLU @D126775, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126784, AGR [CASE @D126783, COUNT @D126782, PER @D126781, 
            PLU @D126780, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126789, AGR [CASE @D126788, COUNT @D126787, PER @D126786, 
            PLU @D126785, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126794, AGR [CASE @D126793, COUNT @D126792, PER @D126791, 
            PLU @D126790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126799, AGR [CASE @D126798, COUNT @D126797, PER @D126796, 
            PLU @D126795, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126804, AGR [CASE @D126803, COUNT @D126802, PER @D126801, 
            PLU @D126800, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SAVE.

WORD saves : 
   [COORD @D126811, AGR [COUNT @D126810, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SAVE, 
   [COORD @D126813, AGR [COUNT @D126812, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAVE, 
   [COORD @D126815, 
      AGR [COUNT @D126814, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAVE, 
   [COORD @D126817, 
      AGR [COUNT @D126816, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SAVE, 
   [COORD @D126819, AGR [COUNT @D126818, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SAVE, 
   [COORD @D126821, AGR [COUNT @D126820, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SAVE, 
   [COORD @D126823, AGR [COUNT @D126822, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAVE, 
   [COORD @D126825, 
      AGR [COUNT @D126824, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAVE, 
   [COORD @D126827, 
      AGR [COUNT @D126826, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAVE, 
   [COORD @D126829, 
      AGR [COUNT @D126828, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SAVE, 
   [COORD @D126831, AGR [COUNT @D126830, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAVE, 
   [COORD @D126833, 
      AGR [COUNT @D126832, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAVE.

WORD saving : 
   [COADV @D126845, COORD @D126844, DEF @D126843, PRD @D126842, 
      AGR [CASE @D126841, COUNT @D126840, PER @D126839, PLU @D126838, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : SAVING, 
   [COORD @D126851, PRD @D126850, AGR [CASE @D126849, COUNT @D126848, 
            PER @D126847, PLU @D126846, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126857, PRD @D126856, 
      AGR [CASE @D126855, COUNT @D126854, PER @D126853, PLU @D126852, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SAVE, 
   [COORD @D126863, PRD @D126862, AGR [CASE @D126861, COUNT @D126860, 
            PER @D126859, PLU @D126858, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126869, PRD @D126868, 
      AGR [CASE @D126867, COUNT @D126866, PER @D126865, PLU @D126864, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAVE, 
   [COORD @D126875, PRD @D126874, AGR [CASE @D126873, COUNT @D126872, 
            PER @D126871, PLU @D126870, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126881, PRD @D126880, 
      AGR [CASE @D126879, COUNT @D126878, PER @D126877, PLU @D126876, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SAVE, 
   [COORD @D126887, PRD @D126886, AGR [CASE @D126885, COUNT @D126884, 
            PER @D126883, PLU @D126882, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126893, PRD @D126892, 
      AGR [CASE @D126891, COUNT @D126890, PER @D126889, PLU @D126888, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SAVE, 
   [COORD @D126899, PRD @D126898, AGR [CASE @D126897, COUNT @D126896, 
            PER @D126895, PLU @D126894, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126905, PRD @D126904, 
      AGR [CASE @D126903, COUNT @D126902, PER @D126901, PLU @D126900, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126911, PRD @D126910, AGR [CASE @D126909, COUNT @D126908, 
            PER @D126907, PLU @D126906, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAVE, 
   [COORD @D126917, PRD @D126916, 
      AGR [CASE @D126915, COUNT @D126914, PER @D126913, PLU @D126912, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAVE.

WORD say : 
   [COORD @D126924, REFL @D126923, PRD @D126922, CASE @D126921, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SAY, 
   [COORD @D126928, REFL @D126927, PRD @D126926, CASE @D126925, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : SAY, 
   [COORD @D126931, AGR [COUNT @D126930, PER @D126929, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SAY, 
   [COORD @D126933, AGR [COUNT @D126932, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SAY, 
   [COORD @D126935, AGR [COUNT @D126934, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SAY, 
   [COORD @D126939, AGR [COUNT @D126938, PER @D126937, PLU @D126936, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : SAY, 
   [COORD @D126945, PAST @D126944, 
      AGR [CASE @D126943, COUNT @D126942, PER @D126941, PLU @D126940, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM TO, ARITY 3] : SAY, 
   [COORD @D126948, AGR [COUNT @D126947, PER @D126946, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SAY, 
   [COORD @D126950, AGR [COUNT @D126949, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SAY, 
   [COORD @D126952, AGR [COUNT @D126951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SAY, 
   [COORD @D126956, AGR [COUNT @D126955, PER @D126954, PLU @D126953, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : SAY, 
   [COORD @D126962, PAST @D126961, 
      AGR [CASE @D126960, COUNT @D126959, PER @D126958, PLU @D126957, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FOR, ARITY 3] : SAY, 
   [COORD @D126965, AGR [COUNT @D126964, PER @D126963, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SAY, 
   [COORD @D126967, AGR [COUNT @D126966, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SAY, 
   [COORD @D126969, AGR [COUNT @D126968, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SAY, 
   [COORD @D126973, AGR [COUNT @D126972, PER @D126971, PLU @D126970, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, ARITY 2] : SAY, 
   [COORD @D126979, PAST @D126978, 
      AGR [CASE @D126977, COUNT @D126976, PER @D126975, PLU @D126974, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, 
      ARITY 2] : SAY, 
   [COORD @D126982, AGR [COUNT @D126981, PER @D126980, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SAY, 
   [COORD @D126984, AGR [COUNT @D126983, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SAY, 
   [COORD @D126986, AGR [COUNT @D126985, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SAY, 
   [COORD @D126990, AGR [COUNT @D126989, PER @D126988, PLU @D126987, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, ARITY 2] : SAY, 
   [COORD @D126996, PAST @D126995, AGR [CASE @D126994, COUNT @D126993, 
            PER @D126992, PLU @D126991, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, ARITY 2] : SAY, 
   [COORD @D126999, AGR [COUNT @D126998, PER @D126997, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127001, AGR [COUNT @D127000, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127003, AGR [COUNT @D127002, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127007, AGR [COUNT @D127006, PER @D127005, PLU @D127004, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : SAY, 
   [COORD @D127013, PAST @D127012, 
      AGR [CASE @D127011, COUNT @D127010, PER @D127009, PLU @D127008, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : SAY, 
   [COORD @D127016, AGR [COUNT @D127015, PER @D127014, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127018, AGR [COUNT @D127017, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127020, AGR [COUNT @D127019, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127024, AGR [COUNT @D127023, PER @D127022, PLU @D127021, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 2] : SAY, 
   [COORD @D127030, PAST @D127029, 
      AGR [CASE @D127028, COUNT @D127027, PER @D127026, PLU @D127025, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127033, AGR [COUNT @D127032, PER @D127031, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SAY, 
   [COORD @D127035, AGR [COUNT @D127034, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SAY, 
   [COORD @D127037, AGR [COUNT @D127036, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SAY, 
   [COORD @D127041, AGR [COUNT @D127040, PER @D127039, PLU @D127038, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SAY, 
   [COORD @D127047, PAST @D127046, AGR [CASE @D127045, COUNT @D127044, 
            PER @D127043, PLU @D127042, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SAY, 
   [COORD @D127050, AGR [COUNT @D127049, PER @D127048, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SAY, 
   [COORD @D127052, AGR [COUNT @D127051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SAY, 
   [COORD @D127054, AGR [COUNT @D127053, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SAY, 
   [COORD @D127058, AGR [COUNT @D127057, PER @D127056, PLU @D127055, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SAY, 
   [COORD @D127064, PAST @D127063, 
      AGR [CASE @D127062, COUNT @D127061, PER @D127060, PLU @D127059, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SAY, 
   [COORD @D127067, AGR [COUNT @D127066, PER @D127065, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : SAY, 
   [COORD @D127069, AGR [COUNT @D127068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : SAY, 
   [COORD @D127071, AGR [COUNT @D127070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ON, ARITY 1] : SAY, 
   [COORD @D127075, AGR [COUNT @D127074, PER @D127073, PLU @D127072, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, ARITY 1] : SAY, 
   [COORD @D127081, PAST @D127080, 
      AGR [CASE @D127079, COUNT @D127078, PER @D127077, PLU @D127076, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ON, ARITY 1] : SAY.

WORD saying : 
   [COORD @D127092, REFL @D127091, PRD @D127090, CASE @D127089, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SAYING, 
   [COORD @D127098, PRD @D127097, 
      AGR [CASE @D127096, COUNT @D127095, PER @D127094, PLU @D127093, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAY, 
   [COORD @D127104, PRD @D127103, AGR [CASE @D127102, COUNT @D127101, 
            PER @D127100, PLU @D127099, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SAY, 
   [COORD @D127110, PRD @D127109, 
      AGR [CASE @D127108, COUNT @D127107, PER @D127106, PLU @D127105, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SAY, 
   [COORD @D127116, PRD @D127115, AGR [CASE @D127114, COUNT @D127113, 
            PER @D127112, PLU @D127111, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAY, 
   [COORD @D127122, PRD @D127121, 
      AGR [CASE @D127120, COUNT @D127119, PER @D127118, PLU @D127117, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SAY, 
   [COORD @D127128, PRD @D127127, AGR [CASE @D127126, COUNT @D127125, 
            PER @D127124, PLU @D127123, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAY, 
   [COORD @D127134, PRD @D127133, 
      AGR [CASE @D127132, COUNT @D127131, PER @D127130, PLU @D127129, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SAY, 
   [COORD @D127140, PRD @D127139, AGR [CASE @D127138, COUNT @D127137, 
            PER @D127136, PLU @D127135, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SAY, 
   [COORD @D127146, PRD @D127145, 
      AGR [CASE @D127144, COUNT @D127143, PER @D127142, PLU @D127141, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SAY.

WORD sayings : 
   [COORD @D127160, DEMON @D127159, REFL @D127158, PRD @D127157, 
      CASE @D127156, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SAYING.

WORD says : 
   [COORD @D127167, AGR [COUNT @D127166, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SAY, 
   [COORD @D127169, AGR [COUNT @D127168, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SAY, 
   [COORD @D127171, AGR [COUNT @D127170, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAY, 
   [COORD @D127173, 
      AGR [COUNT @D127172, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAY, 
   [COORD @D127175, 
      AGR [COUNT @D127174, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAY, 
   [COORD @D127177, 
      AGR [COUNT @D127176, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAY, 
   [COORD @D127179, 
      AGR [COUNT @D127178, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAY, 
   [COORD @D127181, 
      AGR [COUNT @D127180, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAY, 
   [COORD @D127183, 
      AGR [COUNT @D127182, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SAY.

WORD school : 
   [COORD @D127189, AGR [COUNT @D127188, PER @D127187, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SCHOOL, 
   [COORD @D127191, AGR [COUNT @D127190, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SCHOOL, 
   [COORD @D127193, AGR [COUNT @D127192, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SCHOOL, 
   [COORD @D127197, AGR [COUNT @D127196, PER @D127195, PLU @D127194, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SCHOOL, 
   [COORD @D127203, PAST @D127202, AGR 
         [CASE @D127201, COUNT @D127200, PER @D127199, PLU @D127198, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : SCHOOL, 
   [COORD @D127206, AGR [COUNT @D127205, PER @D127204, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SCHOOL, 
   [COORD @D127208, AGR [COUNT @D127207, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SCHOOL, 
   [COORD @D127210, AGR [COUNT @D127209, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SCHOOL, 
   [COORD @D127214, AGR [COUNT @D127213, PER @D127212, PLU @D127211, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SCHOOL, 
   [COORD @D127220, PAST @D127219, 
      AGR [CASE @D127218, COUNT @D127217, PER @D127216, PLU @D127215, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM IN, ARITY 3] : SCHOOL, 
   [COORD @D127223, AGR [COUNT @D127222, PER @D127221, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCHOOL, 
   [COORD @D127225, AGR [COUNT @D127224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCHOOL, 
   [COORD @D127227, AGR [COUNT @D127226, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCHOOL, 
   [COORD @D127231, AGR [COUNT @D127230, PER @D127229, PLU @D127228, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SCHOOL, 
   [COORD @D127237, PAST @D127236, AGR [CASE @D127235, COUNT @D127234, 
            PER @D127233, PLU @D127232, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SCHOOL.

WORD schooled : 
   [COORD @D127246, AGR [CASE @D127245, COUNT @D127244, PER @D127243, 
            PLU @D127242, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127251, AGR [CASE @D127250, COUNT @D127249, PER @D127248, 
            PLU @D127247, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127257, AGR [CASE @D127256, NFORM @D127255, COUNT @D127254, 
            PER @D127253, PLU @D127252, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127262, AGR [CASE @D127261, COUNT @D127260, PER @D127259, 
            PLU @D127258, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127267, AGR [CASE @D127266, COUNT @D127265, PER @D127264, 
            PLU @D127263, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127272, AGR [CASE @D127271, COUNT @D127270, PER @D127269, 
            PLU @D127268, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127277, AGR [CASE @D127276, COUNT @D127275, PER @D127274, 
            PLU @D127273, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127282, AGR [CASE @D127281, COUNT @D127280, PER @D127279, 
            PLU @D127278, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127287, AGR [CASE @D127286, COUNT @D127285, PER @D127284, 
            PLU @D127283, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SCHOOL.

WORD schooling : 
   [COORD @D127297, REFL @D127296, PRD @D127295, CASE @D127294, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : SCHOOLING, 
   [COORD @D127303, PRD @D127302, 
      AGR [CASE @D127301, COUNT @D127300, PER @D127299, PLU @D127298, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   SCHOOL, 
   [COORD @D127309, PRD @D127308, AGR [CASE @D127307, COUNT @D127306, 
            PER @D127305, PLU @D127304, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCHOOL, 
   [COORD @D127315, PRD @D127314, 
      AGR [CASE @D127313, COUNT @D127312, PER @D127311, PLU @D127310, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SCHOOL.

WORD schools : 
   [COORD @D127329, AGR [COUNT @D127328, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SCHOOL, 
   [COORD @D127331, AGR [COUNT @D127330, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCHOOL, 
   [COORD @D127333, AGR [COUNT @D127332, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCHOOL.

WORD score : 
   [COORD @D127340, AGR [COUNT @D127339, PER @D127338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SCORE, 
   [COORD @D127342, AGR [COUNT @D127341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SCORE, 
   [COORD @D127344, AGR [COUNT @D127343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SCORE, 
   [COORD @D127348, AGR [COUNT @D127347, PER @D127346, PLU @D127345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SCORE, 
   [COORD @D127354, PAST @D127353, 
      AGR [CASE @D127352, COUNT @D127351, PER @D127350, PLU @D127349, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : SCORE, 
   [COORD @D127357, AGR [COUNT @D127356, PER @D127355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OVER, ARITY 3] : SCORE, 
   [COORD @D127359, AGR [COUNT @D127358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OVER, ARITY 3] : SCORE, 
   [COORD @D127361, AGR [COUNT @D127360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OVER, ARITY 3] : SCORE, 
   [COORD @D127365, AGR [COUNT @D127364, PER @D127363, PLU @D127362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OVER, ARITY 3] : SCORE, 
   [COORD @D127371, PAST @D127370, 
      AGR [CASE @D127369, COUNT @D127368, PER @D127367, PLU @D127366, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OVER, ARITY 3] : SCORE, 
   [COORD @D127374, AGR [COUNT @D127373, PER @D127372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : SCORE, 
   [COORD @D127376, AGR [COUNT @D127375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : SCORE, 
   [COORD @D127378, AGR [COUNT @D127377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : SCORE, 
   [COORD @D127382, AGR [COUNT @D127381, PER @D127380, PLU @D127379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : SCORE, 
   [COORD @D127388, PAST @D127387, 
      AGR [CASE @D127386, COUNT @D127385, PER @D127384, PLU @D127383, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OFF, ARITY 3] : SCORE, 
   [COORD @D127391, AGR [COUNT @D127390, PER @D127389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SCORE, 
   [COORD @D127393, AGR [COUNT @D127392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SCORE, 
   [COORD @D127395, AGR [COUNT @D127394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SCORE, 
   [COORD @D127399, AGR [COUNT @D127398, PER @D127397, PLU @D127396, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SCORE, 
   [COORD @D127405, PAST @D127404, 
      AGR [CASE @D127403, COUNT @D127402, PER @D127401, PLU @D127400, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : SCORE, 
   [COORD @D127408, AGR [COUNT @D127407, PER @D127406, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : SCORE, 
   [COORD @D127410, AGR [COUNT @D127409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : SCORE, 
   [COORD @D127412, AGR [COUNT @D127411, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : SCORE, 
   [COORD @D127416, AGR [COUNT @D127415, PER @D127414, PLU @D127413, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : SCORE, 
   [COORD @D127422, PAST @D127421, 
      AGR [CASE @D127420, COUNT @D127419, PER @D127418, PLU @D127417, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AGAINST, ARITY 3] : SCORE, 
   [COORD @D127425, AGR [COUNT @D127424, PER @D127423, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCORE, 
   [COORD @D127427, AGR [COUNT @D127426, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCORE, 
   [COORD @D127429, AGR [COUNT @D127428, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCORE, 
   [COORD @D127433, AGR [COUNT @D127432, PER @D127431, PLU @D127430, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SCORE, 
   [COORD @D127439, PAST @D127438, AGR [CASE @D127437, COUNT @D127436, 
            PER @D127435, PLU @D127434, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SCORE, 
   [COORD @D127442, AGR [COUNT @D127441, PER @D127440, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : SCORE, 
   [COORD @D127444, AGR [COUNT @D127443, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : SCORE, 
   [COORD @D127446, AGR [COUNT @D127445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : SCORE, 
   [COORD @D127450, AGR [COUNT @D127449, PER @D127448, PLU @D127447, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, ARITY 2] : SCORE, 
   [COORD @D127456, PAST @D127455, AGR [CASE @D127454, COUNT @D127453, 
            PER @D127452, PLU @D127451, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, ARITY 2] : SCORE, 
   [COORD @D127459, AGR [COUNT @D127458, PER @D127457, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SCORE, 
   [COORD @D127461, AGR [COUNT @D127460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SCORE, 
   [COORD @D127463, AGR [COUNT @D127462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SCORE, 
   [COORD @D127467, AGR [COUNT @D127466, PER @D127465, PLU @D127464, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : SCORE, 
   [COORD @D127473, PAST @D127472, 
      AGR [CASE @D127471, COUNT @D127470, PER @D127469, PLU @D127468, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SCORE, 
   [COORD @D127476, AGR [COUNT @D127475, PER @D127474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SCORE, 
   [COORD @D127478, AGR [COUNT @D127477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SCORE, 
   [COORD @D127480, AGR [COUNT @D127479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SCORE, 
   [COORD @D127484, AGR [COUNT @D127483, PER @D127482, PLU @D127481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OVER, ARITY 2] : SCORE, 
   [COORD @D127490, PAST @D127489, 
      AGR [CASE @D127488, COUNT @D127487, PER @D127486, PLU @D127485, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SCORE, 
   [COORD @D127493, AGR [COUNT @D127492, PER @D127491, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OFF, ARITY 2] : SCORE, 
   [COORD @D127495, AGR [COUNT @D127494, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OFF, ARITY 2] : SCORE, 
   [COORD @D127497, AGR [COUNT @D127496, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OFF, ARITY 2] : SCORE, 
   [COORD @D127501, AGR [COUNT @D127500, PER @D127499, PLU @D127498, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OFF, ARITY 2] : SCORE, 
   [COORD @D127507, PAST @D127506, 
      AGR [CASE @D127505, COUNT @D127504, PER @D127503, PLU @D127502, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OFF, ARITY 2] : SCORE, 
   [COORD @D127510, AGR [COUNT @D127509, PER @D127508, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SCORE, 
   [COORD @D127512, AGR [COUNT @D127511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SCORE, 
   [COORD @D127514, AGR [COUNT @D127513, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SCORE, 
   [COORD @D127518, AGR [COUNT @D127517, PER @D127516, PLU @D127515, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SCORE, 
   [COORD @D127524, PAST @D127523, 
      AGR [CASE @D127522, COUNT @D127521, PER @D127520, PLU @D127519, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SCORE, 
   [COORD @D127527, AGR [COUNT @D127526, PER @D127525, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : SCORE, 
   [COORD @D127529, AGR [COUNT @D127528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : SCORE, 
   [COORD @D127531, AGR [COUNT @D127530, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : SCORE, 
   [COORD @D127535, AGR [COUNT @D127534, PER @D127533, PLU @D127532, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : SCORE, 
   [COORD @D127541, PAST @D127540, 
      AGR [CASE @D127539, COUNT @D127538, PER @D127537, PLU @D127536, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : SCORE, 
   [COORD @D127544, AGR [COUNT @D127543, PER @D127542, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SCORE, 
   [COORD @D127546, AGR [COUNT @D127545, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SCORE, 
   [COORD @D127548, AGR [COUNT @D127547, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SCORE, 
   [COORD @D127552, AGR [COUNT @D127551, PER @D127550, PLU @D127549, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : SCORE, 
   [COORD @D127558, PAST @D127557, 
      AGR [CASE @D127556, COUNT @D127555, PER @D127554, PLU @D127553, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : SCORE, 
   [COORD @D127561, AGR [COUNT @D127560, PER @D127559, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SCORE, 
   [COORD @D127563, AGR [COUNT @D127562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SCORE, 
   [COORD @D127565, AGR [COUNT @D127564, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SCORE, 
   [COORD @D127569, AGR [COUNT @D127568, PER @D127567, PLU @D127566, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SCORE, 
   [COORD @D127575, PAST @D127574, AGR [CASE @D127573, COUNT @D127572, 
            PER @D127571, PLU @D127570, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SCORE, 
   [COORD @D127578, AGR [COUNT @D127577, PER @D127576, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCORE, 
   [COORD @D127580, AGR [COUNT @D127579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCORE, 
   [COORD @D127582, AGR [COUNT @D127581, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCORE, 
   [COORD @D127586, AGR [COUNT @D127585, PER @D127584, PLU @D127583, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCORE, 
   [COORD @D127592, PAST @D127591, 
      AGR [CASE @D127590, COUNT @D127589, PER @D127588, PLU @D127587, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SCORE.

WORD scored : 
   [COORD @D127602, AGR [CASE @D127601, COUNT @D127600, PER @D127599, 
            PLU @D127598, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127607, AGR [CASE @D127606, COUNT @D127605, PER @D127604, 
            PLU @D127603, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127612, AGR [CASE @D127611, COUNT @D127610, PER @D127609, 
            PLU @D127608, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127617, AGR [CASE @D127616, COUNT @D127615, PER @D127614, 
            PLU @D127613, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OVER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127622, AGR [CASE @D127621, COUNT @D127620, PER @D127619, 
            PLU @D127618, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OVER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127627, AGR [CASE @D127626, COUNT @D127625, PER @D127624, 
            PLU @D127623, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OVER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127632, AGR [CASE @D127631, COUNT @D127630, PER @D127629, 
            PLU @D127628, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127637, AGR [CASE @D127636, COUNT @D127635, PER @D127634, 
            PLU @D127633, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127642, AGR [CASE @D127641, COUNT @D127640, PER @D127639, 
            PLU @D127638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127647, AGR [CASE @D127646, COUNT @D127645, PER @D127644, 
            PLU @D127643, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127652, AGR [CASE @D127651, COUNT @D127650, PER @D127649, 
            PLU @D127648, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127657, AGR [CASE @D127656, COUNT @D127655, PER @D127654, 
            PLU @D127653, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127662, AGR [CASE @D127661, COUNT @D127660, PER @D127659, 
            PLU @D127658, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127667, AGR [CASE @D127666, COUNT @D127665, PER @D127664, 
            PLU @D127663, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127672, AGR [CASE @D127671, COUNT @D127670, PER @D127669, 
            PLU @D127668, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127677, AGR [CASE @D127676, COUNT @D127675, PER @D127674, 
            PLU @D127673, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCORE, 
   [COORD @D127682, AGR [CASE @D127681, COUNT @D127680, PER @D127679, 
            PLU @D127678, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127687, AGR [CASE @D127686, COUNT @D127685, PER @D127684, 
            PLU @D127683, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127692, AGR [CASE @D127691, COUNT @D127690, PER @D127689, 
            PLU @D127688, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127697, AGR [CASE @D127696, COUNT @D127695, PER @D127694, 
            PLU @D127693, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127702, AGR [CASE @D127701, COUNT @D127700, PER @D127699, 
            PLU @D127698, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127707, AGR [CASE @D127706, COUNT @D127705, PER @D127704, 
            PLU @D127703, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127712, AGR [CASE @D127711, COUNT @D127710, PER @D127709, 
            PLU @D127708, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127717, AGR [CASE @D127716, COUNT @D127715, PER @D127714, 
            PLU @D127713, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127722, AGR [CASE @D127721, COUNT @D127720, PER @D127719, 
            PLU @D127718, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127727, AGR [CASE @D127726, COUNT @D127725, PER @D127724, 
            PLU @D127723, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127732, AGR [CASE @D127731, COUNT @D127730, PER @D127729, 
            PLU @D127728, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127737, AGR [CASE @D127736, COUNT @D127735, PER @D127734, 
            PLU @D127733, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127742, AGR [CASE @D127741, COUNT @D127740, PER @D127739, 
            PLU @D127738, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127747, AGR [CASE @D127746, COUNT @D127745, PER @D127744, 
            PLU @D127743, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127752, AGR [CASE @D127751, COUNT @D127750, PER @D127749, 
            PLU @D127748, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127757, AGR [CASE @D127756, COUNT @D127755, PER @D127754, 
            PLU @D127753, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127762, AGR [CASE @D127761, COUNT @D127760, PER @D127759, 
            PLU @D127758, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127767, AGR [CASE @D127766, COUNT @D127765, PER @D127764, 
            PLU @D127763, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127772, AGR [CASE @D127771, COUNT @D127770, PER @D127769, 
            PLU @D127768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127777, AGR [CASE @D127776, COUNT @D127775, PER @D127774, 
            PLU @D127773, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127782, AGR [CASE @D127781, COUNT @D127780, PER @D127779, 
            PLU @D127778, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127787, AGR [CASE @D127786, COUNT @D127785, PER @D127784, 
            PLU @D127783, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCORE.

WORD scores : 
   [COORD @D127794, AGR [COUNT @D127793, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCORE, 
   [COORD @D127796, AGR [COUNT @D127795, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCORE, 
   [COORD @D127798, AGR [COUNT @D127797, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCORE, 
   [COORD @D127800, AGR [COUNT @D127799, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCORE, 
   [COORD @D127802, AGR [COUNT @D127801, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCORE, 
   [COORD @D127804, AGR [COUNT @D127803, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE, 
   [COORD @D127806, 
      AGR [COUNT @D127805, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE, 
   [COORD @D127808, 
      AGR [COUNT @D127807, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE, 
   [COORD @D127810, 
      AGR [COUNT @D127809, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE, 
   [COORD @D127812, 
      AGR [COUNT @D127811, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE, 
   [COORD @D127814, 
      AGR [COUNT @D127813, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE, 
   [COORD @D127816, 
      AGR [COUNT @D127815, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SCORE, 
   [COORD @D127818, AGR [COUNT @D127817, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCORE, 
   [COORD @D127820, AGR [COUNT @D127819, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE, 
   [COORD @D127822, 
      AGR [COUNT @D127821, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCORE.

WORD scoring : 
   [COORD @D127832, PRD @D127831, AGR [CASE @D127830, COUNT @D127829, 
            PER @D127828, PLU @D127827, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127838, PRD @D127837, 
      AGR [CASE @D127836, COUNT @D127835, PER @D127834, PLU @D127833, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCORE, 
   [COORD @D127844, PRD @D127843, AGR [CASE @D127842, COUNT @D127841, 
            PER @D127840, PLU @D127839, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM OFF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127850, PRD @D127849, 
      AGR [CASE @D127848, COUNT @D127847, PER @D127846, PLU @D127845, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCORE, 
   [COORD @D127856, PRD @D127855, AGR [CASE @D127854, COUNT @D127853, 
            PER @D127852, PLU @D127851, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127862, PRD @D127861, 
      AGR [CASE @D127860, COUNT @D127859, PER @D127858, PLU @D127857, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SCORE, 
   [COORD @D127868, PRD @D127867, AGR [CASE @D127866, COUNT @D127865, 
            PER @D127864, PLU @D127863, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127874, PRD @D127873, 
      AGR [CASE @D127872, COUNT @D127871, PER @D127870, PLU @D127869, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCORE, 
   [COORD @D127880, PRD @D127879, AGR [CASE @D127878, COUNT @D127877, 
            PER @D127876, PLU @D127875, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127886, PRD @D127885, 
      AGR [CASE @D127884, COUNT @D127883, PER @D127882, PLU @D127881, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCORE, 
   [COORD @D127892, PRD @D127891, AGR [CASE @D127890, COUNT @D127889, 
            PER @D127888, PLU @D127887, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127898, PRD @D127897, 
      AGR [CASE @D127896, COUNT @D127895, PER @D127894, PLU @D127893, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCORE, 
   [COORD @D127904, PRD @D127903, AGR [CASE @D127902, COUNT @D127901, 
            PER @D127900, PLU @D127899, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE, 
   [COORD @D127910, PRD @D127909, 
      AGR [CASE @D127908, COUNT @D127907, PER @D127906, PLU @D127905, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SCORE, 
   [COORD @D127916, PRD @D127915, AGR [CASE @D127914, COUNT @D127913, 
            PER @D127912, PLU @D127911, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCORE.

WORD screen : 
   [COORD @D127922, AGR [COUNT @D127921, PER @D127920, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SCREEN, 
   [COORD @D127924, AGR [COUNT @D127923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SCREEN, 
   [COORD @D127926, AGR [COUNT @D127925, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SCREEN, 
   [COORD @D127930, AGR [COUNT @D127929, PER @D127928, PLU @D127927, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SCREEN, 
   [COORD @D127936, PAST @D127935, 
      AGR [CASE @D127934, COUNT @D127933, PER @D127932, PLU @D127931, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : SCREEN, 
   [COORD @D127939, AGR [COUNT @D127938, PER @D127937, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCREEN, 
   [COORD @D127941, AGR [COUNT @D127940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCREEN, 
   [COORD @D127943, AGR [COUNT @D127942, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SCREEN, 
   [COORD @D127947, AGR [COUNT @D127946, PER @D127945, PLU @D127944, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SCREEN, 
   [COORD @D127953, PAST @D127952, AGR [CASE @D127951, COUNT @D127950, 
            PER @D127949, PLU @D127948, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SCREEN, 
   [COORD @D127956, AGR [COUNT @D127955, PER @D127954, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SCREEN, 
   [COORD @D127958, AGR [COUNT @D127957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SCREEN, 
   [COORD @D127960, AGR [COUNT @D127959, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SCREEN, 
   [COORD @D127964, AGR [COUNT @D127963, PER @D127962, PLU @D127961, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : SCREEN, 
   [COORD @D127970, PAST @D127969, 
      AGR [CASE @D127968, COUNT @D127967, PER @D127966, PLU @D127965, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : SCREEN, 
   [COORD @D127973, AGR [COUNT @D127972, PER @D127971, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : SCREEN, 
   [COORD @D127975, AGR [COUNT @D127974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : SCREEN, 
   [COORD @D127977, AGR [COUNT @D127976, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : SCREEN, 
   [COORD @D127981, AGR [COUNT @D127980, PER @D127979, PLU @D127978, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : SCREEN, 
   [COORD @D127987, PAST @D127986, 
      AGR [CASE @D127985, COUNT @D127984, PER @D127983, PLU @D127982, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : SCREEN, 
   [COORD @D127990, AGR [COUNT @D127989, PER @D127988, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCREEN, 
   [COORD @D127992, AGR [COUNT @D127991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCREEN, 
   [COORD @D127994, AGR [COUNT @D127993, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCREEN, 
   [COORD @D127998, AGR [COUNT @D127997, PER @D127996, PLU @D127995, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SCREEN, 
   [COORD @D128004, PAST @D128003, 
      AGR [CASE @D128002, COUNT @D128001, PER @D128000, PLU @D127999, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SCREEN, 
   [COORD @D128007, AGR [COUNT @D128006, PER @D128005, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SCREEN, 
   [COORD @D128009, AGR [COUNT @D128008, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SCREEN, 
   [COORD @D128011, AGR [COUNT @D128010, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SCREEN, 
   [COORD @D128015, AGR [COUNT @D128014, PER @D128013, PLU @D128012, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SCREEN, 
   [COORD @D128021, PAST @D128020, 
      AGR [CASE @D128019, COUNT @D128018, PER @D128017, PLU @D128016, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : SCREEN.

WORD screened : 
   [COORD @D128030, AGR [CASE @D128029, COUNT @D128028, PER @D128027, 
            PLU @D128026, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128035, AGR [CASE @D128034, COUNT @D128033, PER @D128032, 
            PLU @D128031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128040, AGR [CASE @D128039, COUNT @D128038, PER @D128037, 
            PLU @D128036, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128045, AGR [CASE @D128044, COUNT @D128043, PER @D128042, 
            PLU @D128041, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCREEN, 
   [COORD @D128050, AGR [CASE @D128049, COUNT @D128048, PER @D128047, 
            PLU @D128046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128055, AGR [CASE @D128054, COUNT @D128053, PER @D128052, 
            PLU @D128051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128060, AGR [CASE @D128059, COUNT @D128058, PER @D128057, 
            PLU @D128056, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128065, AGR [CASE @D128064, COUNT @D128063, PER @D128062, 
            PLU @D128061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128070, AGR [CASE @D128069, COUNT @D128068, PER @D128067, 
            PLU @D128066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128075, AGR [CASE @D128074, COUNT @D128073, PER @D128072, 
            PLU @D128071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128080, AGR [CASE @D128079, COUNT @D128078, PER @D128077, 
            PLU @D128076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128085, AGR [CASE @D128084, COUNT @D128083, PER @D128082, 
            PLU @D128081, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128090, AGR [CASE @D128089, COUNT @D128088, PER @D128087, 
            PLU @D128086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128095, AGR [CASE @D128094, COUNT @D128093, PER @D128092, 
            PLU @D128091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128100, AGR [CASE @D128099, COUNT @D128098, PER @D128097, 
            PLU @D128096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128105, AGR [CASE @D128104, COUNT @D128103, PER @D128102, 
            PLU @D128101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SCREEN.

WORD screening : 
   [COORD @D128116, REFL @D128115, COUNT @D128114, PRD @D128113, 
      CASE @D128112, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SCREENING, 
   [COORD @D128122, PRD @D128121, 
      AGR [CASE @D128120, COUNT @D128119, PER @D128118, PLU @D128117, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCREEN, 
   [COORD @D128128, PRD @D128127, AGR [CASE @D128126, COUNT @D128125, 
            PER @D128124, PLU @D128123, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128134, PRD @D128133, 
      AGR [CASE @D128132, COUNT @D128131, PER @D128130, PLU @D128129, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SCREEN, 
   [COORD @D128140, PRD @D128139, AGR [CASE @D128138, COUNT @D128137, 
            PER @D128136, PLU @D128135, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128146, PRD @D128145, 
      AGR [CASE @D128144, COUNT @D128143, PER @D128142, PLU @D128141, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SCREEN, 
   [COORD @D128152, PRD @D128151, AGR [CASE @D128150, COUNT @D128149, 
            PER @D128148, PLU @D128147, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SCREEN.

WORD screenings : 
   [COORD @D128165, DEMON @D128164, REFL @D128163, PRD @D128162, 
      CASE @D128161, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SCREENING.

WORD screens : 
   [COORD @D128171, AGR [COUNT @D128170, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SCREEN, 
   [COORD @D128173, AGR [COUNT @D128172, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128175, 
      AGR [COUNT @D128174, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128177, 
      AGR [COUNT @D128176, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128179, 
      AGR [COUNT @D128178, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCREEN, 
   [COORD @D128181, 
      AGR [COUNT @D128180, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SCREEN.

WORD see : 
   [COORD @D128188, AGR [COUNT @D128187, PER @D128186, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PASS, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128190, AGR [COUNT @D128189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PASS, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128192, AGR [COUNT @D128191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PASS, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128196, AGR [COUNT @D128195, PER @D128194, PLU @D128193, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PASS, REG -, ARITY 3] : SEE, 
   [COORD @D128202, PAST @D128201, 
      AGR [CASE @D128200, COUNT @D128199, PER @D128198, PLU @D128197, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PASS, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128205, AGR [COUNT @D128204, PER @D128203, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128207, AGR [COUNT @D128206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128209, AGR [COUNT @D128208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128213, AGR [COUNT @D128212, PER @D128211, PLU @D128210, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, ARITY 3] : SEE, 
   [COORD @D128219, PAST @D128218, 
      AGR [CASE @D128217, COUNT @D128216, PER @D128215, PLU @D128214, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128222, AGR [COUNT @D128221, PER @D128220, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128224, AGR [COUNT @D128223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128226, AGR [COUNT @D128225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128230, AGR [COUNT @D128229, PER @D128228, PLU @D128227, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, REG -, ARITY 3] : SEE, 
   [COORD @D128236, PAST @D128235, 
      AGR [CASE @D128234, COUNT @D128233, PER @D128232, PLU @D128231, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_BSE, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128239, AGR [COUNT @D128238, PER @D128237, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128241, AGR [COUNT @D128240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128243, AGR [COUNT @D128242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SEE, 
   [COORD @D128247, AGR [COUNT @D128246, PER @D128245, PLU @D128244, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : SEE, 
   [COORD @D128253, PAST @D128252, 
      AGR [CASE @D128251, COUNT @D128250, PER @D128249, PLU @D128248, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : SEE, 
   [COORD @D128256, AGR [COUNT @D128255, PER @D128254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : SEE, 
   [COORD @D128258, AGR [COUNT @D128257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : SEE, 
   [COORD @D128260, AGR [COUNT @D128259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : SEE, 
   [COORD @D128264, AGR [COUNT @D128263, PER @D128262, PLU @D128261, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM THROUGH, ARITY 3] : SEE, 
   [COORD @D128270, PAST @D128269, 
      AGR [CASE @D128268, COUNT @D128267, PER @D128266, PLU @D128265, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM THROUGH, ARITY 3] : SEE, 
   [COORD @D128273, AGR [COUNT @D128272, PER @D128271, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM AT, ARITY 3] : SEE, 
   [COORD @D128275, AGR [COUNT @D128274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM AT, ARITY 3] : SEE, 
   [COORD @D128277, AGR [COUNT @D128276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM AT, ARITY 3] : SEE, 
   [COORD @D128281, AGR [COUNT @D128280, PER @D128279, PLU @D128278, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM AT, ARITY 3] : SEE, 
   [COORD @D128287, PAST @D128286, 
      AGR [CASE @D128285, COUNT @D128284, PER @D128283, PLU @D128282, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM AT, ARITY 3] : SEE, 
   [COORD @D128290, AGR [COUNT @D128289, PER @D128288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128292, AGR [COUNT @D128291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128294, AGR [COUNT @D128293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128298, AGR [COUNT @D128297, PER @D128296, PLU @D128295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, ARITY 2] : SEE, 
   [COORD @D128304, PAST @D128303, 
      AGR [CASE @D128302, COUNT @D128301, PER @D128300, PLU @D128299, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128307, AGR [COUNT @D128306, PER @D128305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128309, AGR [COUNT @D128308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128311, AGR [COUNT @D128310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128315, AGR [COUNT @D128314, PER @D128313, PLU @D128312, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128321, PAST @D128320, AGR [CASE @D128319, COUNT @D128318, 
            PER @D128317, PLU @D128316, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, ARITY 2] : SEE, 
   [COORD @D128324, AGR [COUNT @D128323, PER @D128322, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128326, AGR [COUNT @D128325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128328, AGR [COUNT @D128327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128332, AGR [COUNT @D128331, PER @D128330, PLU @D128329, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : SEE, 
   [COORD @D128338, PAST @D128337, 
      AGR [CASE @D128336, COUNT @D128335, PER @D128334, PLU @D128333, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128341, AGR [COUNT @D128340, PER @D128339, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128343, AGR [COUNT @D128342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128345, AGR [COUNT @D128344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128349, AGR [COUNT @D128348, PER @D128347, PLU @D128346, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 2] : SEE, 
   [COORD @D128355, PAST @D128354, 
      AGR [CASE @D128353, COUNT @D128352, PER @D128351, PLU @D128350, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128358, AGR [COUNT @D128357, PER @D128356, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_PASS, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128360, AGR [COUNT @D128359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_PASS, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128362, AGR [COUNT @D128361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_PASS, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128366, AGR [COUNT @D128365, PER @D128364, PLU @D128363, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, REG -, ARITY 2] : SEE, 
   [COORD @D128372, PAST @D128371, 
      AGR [CASE @D128370, COUNT @D128369, PER @D128368, PLU @D128367, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_PASS, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128375, AGR [COUNT @D128374, PER @D128373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128377, AGR [COUNT @D128376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128379, AGR [COUNT @D128378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128383, AGR [COUNT @D128382, PER @D128381, PLU @D128380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, REG -, ARITY 2] : SEE, 
   [COORD @D128389, PAST @D128388, 
      AGR [CASE @D128387, COUNT @D128386, PER @D128385, PLU @D128384, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128392, AGR [COUNT @D128391, PER @D128390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128394, AGR [COUNT @D128393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128396, AGR [COUNT @D128395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SEE, 
   [COORD @D128400, AGR [COUNT @D128399, PER @D128398, PLU @D128397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SEE, 
   [COORD @D128406, PAST @D128405, AGR [CASE @D128404, COUNT @D128403, 
            PER @D128402, PLU @D128401, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SEE, 
   [COORD @D128409, AGR [COUNT @D128408, PER @D128407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : SEE, 
   [COORD @D128411, AGR [COUNT @D128410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : SEE, 
   [COORD @D128413, AGR [COUNT @D128412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : SEE, 
   [COORD @D128417, AGR [COUNT @D128416, PER @D128415, PLU @D128414, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT THROUGH, ARITY 2] : SEE, 
   [COORD @D128423, PAST @D128422, 
      AGR [CASE @D128421, COUNT @D128420, PER @D128419, PLU @D128418, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT THROUGH, ARITY 2] : SEE, 
   [COORD @D128426, AGR [COUNT @D128425, PER @D128424, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SEE, 
   [COORD @D128428, AGR [COUNT @D128427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SEE, 
   [COORD @D128430, AGR [COUNT @D128429, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SEE, 
   [COORD @D128434, AGR [COUNT @D128433, PER @D128432, PLU @D128431, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT ROUND, ARITY 2] : SEE, 
   [COORD @D128440, PAST @D128439, AGR 
         [CASE @D128438, COUNT @D128437, PER @D128436, PLU @D128435, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SEE, 
   [COORD @D128443, AGR [COUNT @D128442, PER @D128441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OVER, ARITY 2] : SEE, 
   [COORD @D128445, AGR [COUNT @D128444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OVER, ARITY 2] : SEE, 
   [COORD @D128447, AGR [COUNT @D128446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OVER, ARITY 2] : SEE, 
   [COORD @D128451, AGR [COUNT @D128450, PER @D128449, PLU @D128448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT OVER, ARITY 2] : SEE, 
   [COORD @D128457, PAST @D128456, AGR [CASE @D128455, COUNT @D128454, 
            PER @D128453, PLU @D128452, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT OVER, ARITY 2] : SEE, 
   [COORD @D128460, 
      AGR [COUNT @D128459, PER @D128458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, 
      ARITY 2] : SEE, 
   [COORD @D128462, AGR [COUNT @D128461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : SEE, 
   [COORD @D128464, AGR [COUNT @D128463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : SEE, 
   [COORD @D128468, AGR [COUNT @D128467, PER @D128466, PLU @D128465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : SEE, 
   [COORD @D128474, PAST @D128473, AGR [CASE @D128472, COUNT @D128471, 
            PER @D128470, PLU @D128469, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM TO, ARITY 2] : SEE, 
   [COORD @D128477, 
      AGR [COUNT @D128476, PER @D128475, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM THROUGH, 
      ARITY 2] : SEE, 
   [COORD @D128479, AGR [COUNT @D128478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : SEE, 
   [COORD @D128481, AGR [COUNT @D128480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : SEE, 
   [COORD @D128485, AGR [COUNT @D128484, PER @D128483, PLU @D128482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM THROUGH, ARITY 2] : SEE, 
   [COORD @D128491, PAST @D128490, 
      AGR [CASE @D128489, COUNT @D128488, PER @D128487, PLU @D128486, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : SEE, 
   [COORD @D128494, AGR [COUNT @D128493, PER @D128492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SEE, 
   [COORD @D128496, AGR [COUNT @D128495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SEE, 
   [COORD @D128498, AGR [COUNT @D128497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SEE, 
   [COORD @D128502, AGR [COUNT @D128501, PER @D128500, PLU @D128499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, ARITY 2] : SEE, 
   [COORD @D128508, PAST @D128507, 
      AGR [CASE @D128506, COUNT @D128505, PER @D128504, PLU @D128503, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SEE, 
   [COORD @D128511, AGR [COUNT @D128510, PER @D128509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SEE, 
   [COORD @D128513, AGR [COUNT @D128512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SEE, 
   [COORD @D128515, AGR [COUNT @D128514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SEE, 
   [COORD @D128519, AGR [COUNT @D128518, PER @D128517, PLU @D128516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SEE, 
   [COORD @D128525, PAST @D128524, 
      AGR [CASE @D128523, COUNT @D128522, PER @D128521, PLU @D128520, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SEE, 
   [COORD @D128528, AGR [COUNT @D128527, PER @D128526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SEE, 
   [COORD @D128530, AGR [COUNT @D128529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SEE, 
   [COORD @D128532, AGR [COUNT @D128531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SEE, 
   [COORD @D128536, AGR [COUNT @D128535, PER @D128534, PLU @D128533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : SEE, 
   [COORD @D128542, PAST @D128541, 
      AGR [CASE @D128540, COUNT @D128539, PER @D128538, PLU @D128537, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : SEE, 
   [COORD @D128545, AGR [COUNT @D128544, PER @D128543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SEE, 
   [COORD @D128547, AGR [COUNT @D128546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SEE, 
   [COORD @D128549, AGR [COUNT @D128548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SEE, 
   [COORD @D128553, AGR [COUNT @D128552, PER @D128551, PLU @D128550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SEE, 
   [COORD @D128559, PAST @D128558, 
      AGR [CASE @D128557, COUNT @D128556, PER @D128555, PLU @D128554, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SEE, 
   [COORD @D128562, AGR [COUNT @D128561, PER @D128560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : SEE, 
   [COORD @D128564, AGR [COUNT @D128563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : SEE, 
   [COORD @D128566, AGR [COUNT @D128565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : SEE, 
   [COORD @D128570, AGR [COUNT @D128569, PER @D128568, PLU @D128567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : SEE, 
   [COORD @D128576, PAST @D128575, 
      AGR [CASE @D128574, COUNT @D128573, PER @D128572, PLU @D128571, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, ARITY 1] : SEE, 
   [COORD @D128579, AGR [COUNT @D128578, PER @D128577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : SEE, 
   [COORD @D128581, AGR [COUNT @D128580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : SEE, 
   [COORD @D128583, AGR [COUNT @D128582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : SEE, 
   [COORD @D128587, AGR [COUNT @D128586, PER @D128585, PLU @D128584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ROUND, ARITY 1] : SEE, 
   [COORD @D128593, PAST @D128592, 
      AGR [CASE @D128591, COUNT @D128590, PER @D128589, PLU @D128588, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ROUND, ARITY 1] : SEE, 
   [COORD @D128596, AGR [COUNT @D128595, PER @D128594, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : SEE, 
   [COORD @D128598, AGR [COUNT @D128597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : SEE, 
   [COORD @D128600, AGR [COUNT @D128599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : SEE, 
   [COORD @D128604, AGR [COUNT @D128603, PER @D128602, PLU @D128601, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : SEE, 
   [COORD @D128610, PAST @D128609, 
      AGR [CASE @D128608, COUNT @D128607, PER @D128606, PLU @D128605, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, ARITY 1] : SEE, 
   [COORD @D128613, AGR [COUNT @D128612, PER @D128611, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SEE, 
   [COORD @D128615, AGR [COUNT @D128614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SEE, 
   [COORD @D128617, AGR [COUNT @D128616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SEE, 
   [COORD @D128621, AGR [COUNT @D128620, PER @D128619, PLU @D128618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SEE, 
   [COORD @D128627, PAST @D128626, 
      AGR [CASE @D128625, COUNT @D128624, PER @D128623, PLU @D128622, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SEE, 
   [COORD @D128630, AGR [COUNT @D128629, PER @D128628, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SEE, 
   [COORD @D128632, AGR [COUNT @D128631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SEE, 
   [COORD @D128634, AGR [COUNT @D128633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SEE, 
   [COORD @D128638, AGR [COUNT @D128637, PER @D128636, PLU @D128635, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : SEE, 
   [COORD @D128644, PAST @D128643, 
      AGR [CASE @D128642, COUNT @D128641, PER @D128640, PLU @D128639, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : SEE.

WORD seed : 
   [COORD @D128653, REFL @D128652, PRD @D128651, CASE @D128650, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : SEED, 
   [COORD @D128658, REFL @D128657, COUNT @D128656, PRD @D128655, 
      CASE @D128654, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SEED, 
   [COORD @D128662, REFL @D128661, PRD @D128660, CASE @D128659, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : SEED, 
   [COORD @D128665, 
      AGR [COUNT @D128664, PER @D128663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_NP, 
      ARITY 3] : SEED, 
   [COORD @D128667, AGR [COUNT @D128666, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : SEED, 
   [COORD @D128669, AGR [COUNT @D128668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : SEED, 
   [COORD @D128673, AGR [COUNT @D128672, PER @D128671, PLU @D128670, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_NP, ARITY 3] : SEED, 
   [COORD @D128679, PAST @D128678, AGR [CASE @D128677, COUNT @D128676, 
            PER @D128675, PLU @D128674, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_NP, ARITY 3] : SEED, 
   [COORD @D128682, AGR [COUNT @D128681, PER @D128680, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SEED, 
   [COORD @D128684, AGR [COUNT @D128683, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SEED, 
   [COORD @D128686, AGR [COUNT @D128685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SEED, 
   [COORD @D128690, AGR [COUNT @D128689, PER @D128688, PLU @D128687, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SEED, 
   [COORD @D128696, PAST @D128695, 
      AGR [CASE @D128694, COUNT @D128693, PER @D128692, PLU @D128691, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : SEED, 
   [COORD @D128699, AGR [COUNT @D128698, PER @D128697, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SEED, 
   [COORD @D128701, AGR [COUNT @D128700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SEED, 
   [COORD @D128703, AGR [COUNT @D128702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SEED, 
   [COORD @D128707, AGR [COUNT @D128706, PER @D128705, PLU @D128704, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SEED, 
   [COORD @D128713, PAST @D128712, AGR [CASE @D128711, COUNT @D128710, 
            PER @D128709, PLU @D128708, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SEED, 
   [COORD @D128716, AGR [COUNT @D128715, PER @D128714, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SEED, 
   [COORD @D128718, AGR [COUNT @D128717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SEED, 
   [COORD @D128720, AGR [COUNT @D128719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SEED, 
   [COORD @D128724, AGR [COUNT @D128723, PER @D128722, PLU @D128721, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SEED, 
   [COORD @D128730, PAST @D128729, AGR [CASE @D128728, COUNT @D128727, 
            PER @D128726, PLU @D128725, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SEED.

WORD seeded : 
   [COORD @D128744, AGR [CASE @D128743, COUNT @D128742, PER @D128741, 
            PLU @D128740, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_NP, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SEED, 
   [COORD @D128749, AGR [CASE @D128748, COUNT @D128747, PER @D128746, 
            PLU @D128745, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SEED, 
   [COORD @D128754, AGR [CASE @D128753, COUNT @D128752, PER @D128751, 
            PLU @D128750, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SEED, 
   [COORD @D128759, AGR [CASE @D128758, COUNT @D128757, PER @D128756, 
            PLU @D128755, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SEED, 
   [COORD @D128764, AGR [CASE @D128763, COUNT @D128762, PER @D128761, 
            PLU @D128760, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SEED, 
   [COORD @D128769, AGR [CASE @D128768, COUNT @D128767, PER @D128766, 
            PLU @D128765, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SEED, 
   [COORD @D128774, AGR [CASE @D128773, COUNT @D128772, PER @D128771, 
            PLU @D128770, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SEED, 
   [COORD @D128779, AGR [CASE @D128778, COUNT @D128777, PER @D128776, 
            PLU @D128775, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SEED, 
   [COORD @D128784, AGR [CASE @D128783, COUNT @D128782, PER @D128781, 
            PLU @D128780, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SEED, 
   [COORD @D128789, AGR [CASE @D128788, COUNT @D128787, PER @D128786, 
            PLU @D128785, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SEED, 
   [COORD @D128794, AGR [CASE @D128793, COUNT @D128792, PER @D128791, 
            PLU @D128790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SEED.

WORD seeding : 
   [COORD @D128814, PRD @D128813, AGR [CASE @D128812, COUNT @D128811, 
            PER @D128810, PLU @D128809, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SEED, 
   [COORD @D128820, PRD @D128819, 
      AGR [CASE @D128818, COUNT @D128817, PER @D128816, PLU @D128815, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SEED, 
   [COORD @D128826, PRD @D128825, AGR [CASE @D128824, COUNT @D128823, 
            PER @D128822, PLU @D128821, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SEED, 
   [COORD @D128832, PRD @D128831, 
      AGR [CASE @D128830, COUNT @D128829, PER @D128828, PLU @D128827, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SEED.

WORD seeds : 
   [COORD @D128846, DEMON @D128845, REFL @D128844, PRD @D128843, 
      CASE @D128842, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SEED, 
   [COORD @D128851, DEMON @D128850, REFL @D128849, PRD @D128848, 
      CASE @D128847, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SEED, 
   [COORD @D128853, AGR [COUNT @D128852, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEED, 
   [COORD @D128855, AGR [COUNT @D128854, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEED, 
   [COORD @D128857, AGR [COUNT @D128856, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEED, 
   [COORD @D128859, 
      AGR [COUNT @D128858, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEED.

WORD seem : 
   [COORD @D128866, AGR [COUNT @D128865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : SEEM, 
   [COORD @D128868, AGR [COUNT @D128867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : SEEM, 
   [COORD @D128872, AGR [NFORM @D128871, COUNT @D128870, PER @D128869, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : SEEM, 
   [COORD @D128876, AGR [COUNT @D128875, PER @D128874, PLU @D128873, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 1] : SEEM, 
   [COORD @D128879, AGR @D128878, PAST @D128877, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_NP, ARITY 1] : SEEM, 
   [COORD @D128881, AGR [COUNT @D128880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : SEEM, 
   [COORD @D128883, AGR [COUNT @D128882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : SEEM, 
   [COORD @D128887, AGR [NFORM @D128886, COUNT @D128885, PER @D128884, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : SEEM, 
   [COORD @D128891, AGR [COUNT @D128890, PER @D128889, PLU @D128888, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : SEEM, 
   [COORD @D128894, AGR @D128893, PAST @D128892, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, ARITY 1] : SEEM, 
   [COORD @D128896, AGR [COUNT @D128895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : SEEM, 
   [COORD @D128898, AGR [COUNT @D128897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : SEEM, 
   [COORD @D128902, AGR [NFORM @D128901, COUNT @D128900, PER @D128899, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : SEEM, 
   [COORD @D128906, AGR [COUNT @D128905, PER @D128904, PLU @D128903, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : SEEM, 
   [COORD @D128909, AGR @D128908, PAST @D128907, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_AP, ARITY 1] : SEEM, 
   [COORD @D128914, PAST @D128913, AGR [COUNT @D128912, PER @D128911, 
            PLU @D128910, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT PP_SFIN, PFORM TO, ARITY 2] : SEEM, 
   [COORD @D128919, PAST @D128918, 
      AGR [COUNT @D128917, PER @D128916, PLU @D128915, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE ASIF, SUBCAT WHS, ARITY 1] : SEEM, 
   [COORD @D128924, PAST @D128923, 
      AGR [COUNT @D128922, PER @D128921, PLU @D128920, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, ARITY 1] : SEEM.

WORD seemed : 
   [COORD @D128935, AGR @D128934, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SEEM, 
   [COORD @D128937, AGR @D128936, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D128939, AGR @D128938, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SEEM, 
   [COORD @D128941, AGR @D128940, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D128943, AGR @D128942, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SEEM, 
   [COORD @D128945, AGR @D128944, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D128949, AGR [COUNT @D128948, PER @D128947, PLU @D128946, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SEEM, 
   [COORD @D128953, AGR [COUNT @D128952, PER @D128951, PLU @D128950, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SEEM, 
   [COORD @D128957, AGR [COUNT @D128956, PER @D128955, PLU @D128954, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE ASIF, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SEEM, 
   [COORD @D128961, AGR [COUNT @D128960, PER @D128959, PLU @D128958, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE ASIF, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : SEEM, 
   [COORD @D128965, AGR [COUNT @D128964, PER @D128963, PLU @D128962, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SEEM, 
   [COORD @D128969, AGR [COUNT @D128968, PER @D128967, PLU @D128966, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : SEEM.

WORD seeming : 
   [COORD @D128984, AGR @D128983, PRD @D128982, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D128987, AGR @D128986, PRD @D128985, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D128990, AGR @D128989, PRD @D128988, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D128995, PRD @D128994, AGR [COUNT @D128993, PER @D128992, 
            PLU @D128991, NFORM IT, CASE NOM, N +, V -, BAR 2], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_SFIN, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SEEM, 
   [COORD @D129000, PRD @D128999, 
      AGR [COUNT @D128998, PER @D128997, PLU @D128996, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE ASIF, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SEEM, 
   [COORD @D129005, PRD @D129004, 
      AGR [COUNT @D129003, PER @D129002, PLU @D129001, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SEEM.

WORD seems : 
   [COORD @D129017, AGR [CASE @D129016, NFORM @D129015, COUNT @D129014, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_NP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D129022, AGR [UB @D129021, VFORM @D129020, SUBJ @D129019, 
            FIN @D129018, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_NP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D129026, AGR [CASE @D129025, NFORM @D129024, COUNT @D129023, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D129031, AGR [UB @D129030, VFORM @D129029, SUBJ @D129028, 
            FIN @D129027, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D129035, AGR [CASE @D129034, NFORM @D129033, COUNT @D129032, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D129040, AGR [UB @D129039, VFORM @D129038, SUBJ @D129037, 
            FIN @D129036, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D129043, AGR [CASE @D129042, COUNT @D129041, N +, V -, BAR 2, 
            NFORM IT, PLU -, PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP_SFIN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEEM, 
   [COORD @D129046, AGR [CASE @D129045, COUNT @D129044, N +, V -, BAR 2, 
            NFORM IT, PLU -, PER 3], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE ASIF, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEEM, 
   [COORD @D129049, AGR [CASE @D129048, COUNT @D129047, N +, V -, BAR 2, 
            NFORM IT, PLU -, PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEEM.

WORD sees : 
   [COORD @D129056, AGR [COUNT @D129055, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_PASS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEE, 
   [COORD @D129058, AGR [COUNT @D129057, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEE, 
   [COORD @D129060, AGR [COUNT @D129059, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEE, 
   [COORD @D129062, AGR [COUNT @D129061, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEE, 
   [COORD @D129064, AGR [COUNT @D129063, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM THROUGH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SEE, 
   [COORD @D129066, AGR [COUNT @D129065, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SEE, 
   [COORD @D129068, AGR [COUNT @D129067, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129070, 
      AGR [COUNT @D129069, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129072, 
      AGR [COUNT @D129071, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129074, 
      AGR [COUNT @D129073, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129076, 
      AGR [COUNT @D129075, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_PASS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129078, 
      AGR [COUNT @D129077, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129080, 
      AGR [COUNT @D129079, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129082, 
      AGR [COUNT @D129081, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129084, 
      AGR [COUNT @D129083, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129086, 
      AGR [COUNT @D129085, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129088, 
      AGR [COUNT @D129087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129090, 
      AGR [COUNT @D129089, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEE, 
   [COORD @D129092, AGR [COUNT @D129091, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEE, 
   [COORD @D129094, AGR [COUNT @D129093, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEE, 
   [COORD @D129096, AGR [COUNT @D129095, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEE, 
   [COORD @D129098, AGR [COUNT @D129097, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SEE, 
   [COORD @D129100, 
      AGR [COUNT @D129099, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SEE, 
   [COORD @D129102, AGR [COUNT @D129101, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEE, 
   [COORD @D129104, AGR [COUNT @D129103, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEE, 
   [COORD @D129106, AGR [COUNT @D129105, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEE, 
   [COORD @D129108, AGR [COUNT @D129107, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SEE.

WORD select : 
   [COORD @D129119, AGR [COUNT @D129118, PER @D129117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SELECT, 
   [COORD @D129121, AGR [COUNT @D129120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SELECT, 
   [COORD @D129123, AGR [COUNT @D129122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SELECT, 
   [COORD @D129127, AGR [COUNT @D129126, PER @D129125, PLU @D129124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SELECT, 
   [COORD @D129133, PAST @D129132, AGR 
         [CASE @D129131, COUNT @D129130, PER @D129129, PLU @D129128, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : SELECT, 
   [COORD @D129136, AGR [COUNT @D129135, PER @D129134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SELECT, 
   [COORD @D129138, AGR [COUNT @D129137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SELECT, 
   [COORD @D129140, AGR [COUNT @D129139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SELECT, 
   [COORD @D129144, AGR [COUNT @D129143, PER @D129142, PLU @D129141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SELECT, 
   [COORD @D129150, PAST @D129149, 
      AGR [CASE @D129148, COUNT @D129147, PER @D129146, PLU @D129145, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : SELECT, 
   [COORD @D129153, AGR [COUNT @D129152, PER @D129151, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SELECT, 
   [COORD @D129155, AGR [COUNT @D129154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SELECT, 
   [COORD @D129157, AGR [COUNT @D129156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SELECT, 
   [COORD @D129161, AGR [COUNT @D129160, PER @D129159, PLU @D129158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SELECT, 
   [COORD @D129167, PAST @D129166, AGR [CASE @D129165, COUNT @D129164, 
            PER @D129163, PLU @D129162, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SELECT.

WORD selected : 
   [COORD @D129177, AGR [CASE @D129176, COUNT @D129175, PER @D129174, 
            PLU @D129173, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SELECT, 
   [COORD @D129182, AGR [CASE @D129181, COUNT @D129180, PER @D129179, 
            PLU @D129178, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SELECT, 
   [COORD @D129188, AGR [CASE @D129187, NFORM @D129186, COUNT @D129185, 
            PER @D129184, PLU @D129183, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SELECT, 
   [COORD @D129193, AGR [CASE @D129192, COUNT @D129191, PER @D129190, 
            PLU @D129189, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SELECT, 
   [COORD @D129198, AGR [CASE @D129197, COUNT @D129196, PER @D129195, 
            PLU @D129194, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SELECT, 
   [COORD @D129203, AGR [CASE @D129202, COUNT @D129201, PER @D129200, 
            PLU @D129199, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SELECT, 
   [COORD @D129208, AGR [CASE @D129207, COUNT @D129206, PER @D129205, 
            PLU @D129204, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SELECT, 
   [COORD @D129213, AGR [CASE @D129212, COUNT @D129211, PER @D129210, 
            PLU @D129209, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SELECT, 
   [COORD @D129218, AGR [CASE @D129217, COUNT @D129216, PER @D129215, 
            PLU @D129214, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SELECT.

WORD selecting : 
   [COORD @D129231, PRD @D129230, AGR [CASE @D129229, COUNT @D129228, 
            PER @D129227, PLU @D129226, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SELECT, 
   [COORD @D129237, PRD @D129236, 
      AGR [CASE @D129235, COUNT @D129234, PER @D129233, PLU @D129232, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SELECT, 
   [COORD @D129243, PRD @D129242, AGR [CASE @D129241, COUNT @D129240, 
            PER @D129239, PLU @D129238, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SELECT.

WORD selects : 
   [COORD @D129250, AGR [COUNT @D129249, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SELECT, 
   [COORD @D129252, AGR [COUNT @D129251, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SELECT, 
   [COORD @D129254, AGR [COUNT @D129253, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELECT.

WORD sell : 
   [COORD @D129261, AGR [COUNT @D129260, PER @D129259, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SELL, 
   [COORD @D129263, AGR [COUNT @D129262, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SELL, 
   [COORD @D129265, AGR [COUNT @D129264, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SELL, 
   [COORD @D129269, AGR [COUNT @D129268, PER @D129267, PLU @D129266, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : SELL, 
   [COORD @D129275, PAST @D129274, 
      AGR [CASE @D129273, COUNT @D129272, PER @D129271, PLU @D129270, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : SELL, 
   [COORD @D129278, AGR [COUNT @D129277, PER @D129276, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SELL, 
   [COORD @D129280, AGR [COUNT @D129279, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SELL, 
   [COORD @D129282, AGR [COUNT @D129281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SELL, 
   [COORD @D129286, AGR [COUNT @D129285, PER @D129284, PLU @D129283, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : SELL, 
   [COORD @D129292, PAST @D129291, 
      AGR [CASE @D129290, COUNT @D129289, PER @D129288, PLU @D129287, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SELL, 
   [COORD @D129295, AGR [COUNT @D129294, PER @D129293, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SELL, 
   [COORD @D129297, AGR [COUNT @D129296, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SELL, 
   [COORD @D129299, AGR [COUNT @D129298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SELL, 
   [COORD @D129303, AGR [COUNT @D129302, PER @D129301, PLU @D129300, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : SELL, 
   [COORD @D129309, PAST @D129308, 
      AGR [CASE @D129307, COUNT @D129306, PER @D129305, PLU @D129304, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ON, ARITY 3] : SELL, 
   [COORD @D129312, AGR [COUNT @D129311, PER @D129310, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : SELL, 
   [COORD @D129314, AGR [COUNT @D129313, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : SELL, 
   [COORD @D129316, AGR [COUNT @D129315, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM OF, ARITY 3] : SELL, 
   [COORD @D129320, AGR [COUNT @D129319, PER @D129318, PLU @D129317, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, ARITY 3] : SELL, 
   [COORD @D129326, PAST @D129325, 
      AGR [CASE @D129324, COUNT @D129323, PER @D129322, PLU @D129321, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, ARITY 3] : SELL, 
   [COORD @D129329, AGR [COUNT @D129328, PER @D129327, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SELL, 
   [COORD @D129331, AGR [COUNT @D129330, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SELL, 
   [COORD @D129333, AGR [COUNT @D129332, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SELL, 
   [COORD @D129337, AGR [COUNT @D129336, PER @D129335, PLU @D129334, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SELL, 
   [COORD @D129343, PAST @D129342, AGR [CASE @D129341, COUNT @D129340, 
            PER @D129339, PLU @D129338, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SELL, 
   [COORD @D129346, AGR [COUNT @D129345, PER @D129344, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : SELL, 
   [COORD @D129348, AGR [COUNT @D129347, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : SELL, 
   [COORD @D129350, AGR [COUNT @D129349, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM OF, ARITY 2] : SELL, 
   [COORD @D129354, AGR [COUNT @D129353, PER @D129352, PLU @D129351, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM OF, ARITY 2] : SELL, 
   [COORD @D129360, PAST @D129359, 
      AGR [CASE @D129358, COUNT @D129357, PER @D129356, PLU @D129355, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM OF, ARITY 2] : SELL, 
   [COORD @D129363, AGR [COUNT @D129362, PER @D129361, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SELL, 
   [COORD @D129365, AGR [COUNT @D129364, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SELL, 
   [COORD @D129367, AGR [COUNT @D129366, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SELL, 
   [COORD @D129371, AGR [COUNT @D129370, PER @D129369, PLU @D129368, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : SELL, 
   [COORD @D129377, PAST @D129376, 
      AGR [CASE @D129375, COUNT @D129374, PER @D129373, PLU @D129372, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SELL, 
   [COORD @D129380, AGR [COUNT @D129379, PER @D129378, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SELL, 
   [COORD @D129382, AGR [COUNT @D129381, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SELL, 
   [COORD @D129384, AGR [COUNT @D129383, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SELL, 
   [COORD @D129388, AGR [COUNT @D129387, PER @D129386, PLU @D129385, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : SELL, 
   [COORD @D129394, PAST @D129393, AGR 
         [CASE @D129392, COUNT @D129391, PER @D129390, PLU @D129389, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SELL, 
   [COORD @D129397, AGR [COUNT @D129396, PER @D129395, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SELL, 
   [COORD @D129399, AGR [COUNT @D129398, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SELL, 
   [COORD @D129401, AGR [COUNT @D129400, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SELL, 
   [COORD @D129405, AGR [COUNT @D129404, PER @D129403, PLU @D129402, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : SELL, 
   [COORD @D129411, PAST @D129410, 
      AGR [CASE @D129409, COUNT @D129408, PER @D129407, PLU @D129406, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : SELL, 
   [COORD @D129414, AGR [COUNT @D129413, PER @D129412, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SELL, 
   [COORD @D129416, AGR [COUNT @D129415, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SELL, 
   [COORD @D129418, AGR [COUNT @D129417, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SELL, 
   [COORD @D129422, AGR [COUNT @D129421, PER @D129420, PLU @D129419, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SELL, 
   [COORD @D129428, PAST @D129427, 
      AGR [CASE @D129426, COUNT @D129425, PER @D129424, PLU @D129423, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SELL, 
   [COORD @D129431, AGR [COUNT @D129430, PER @D129429, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SELL, 
   [COORD @D129433, AGR [COUNT @D129432, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SELL, 
   [COORD @D129435, AGR [COUNT @D129434, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SELL, 
   [COORD @D129439, AGR [COUNT @D129438, PER @D129437, PLU @D129436, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : SELL, 
   [COORD @D129445, PAST @D129444, 
      AGR [CASE @D129443, COUNT @D129442, PER @D129441, PLU @D129440, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : SELL, 
   [COORD @D129448, AGR [COUNT @D129447, PER @D129446, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SELL, 
   [COORD @D129450, AGR [COUNT @D129449, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SELL, 
   [COORD @D129452, AGR [COUNT @D129451, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SELL, 
   [COORD @D129456, AGR [COUNT @D129455, PER @D129454, PLU @D129453, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SELL, 
   [COORD @D129462, PAST @D129461, 
      AGR [CASE @D129460, COUNT @D129459, PER @D129458, PLU @D129457, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SELL, 
   [COORD @D129465, AGR [COUNT @D129464, PER @D129463, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SELL, 
   [COORD @D129467, AGR [COUNT @D129466, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SELL, 
   [COORD @D129469, AGR [COUNT @D129468, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SELL, 
   [COORD @D129473, AGR [COUNT @D129472, PER @D129471, PLU @D129470, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : SELL, 
   [COORD @D129479, PAST @D129478, 
      AGR [CASE @D129477, COUNT @D129476, PER @D129475, PLU @D129474, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : SELL, 
   [COORD @D129482, AGR [COUNT @D129481, PER @D129480, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SELL, 
   [COORD @D129484, AGR [COUNT @D129483, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SELL, 
   [COORD @D129486, AGR [COUNT @D129485, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SELL, 
   [COORD @D129490, AGR [COUNT @D129489, PER @D129488, PLU @D129487, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SELL, 
   [COORD @D129496, PAST @D129495, 
      AGR [CASE @D129494, COUNT @D129493, PER @D129492, PLU @D129491, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SELL, 
   [COORD @D129499, AGR [COUNT @D129498, PER @D129497, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SELL, 
   [COORD @D129501, AGR [COUNT @D129500, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SELL, 
   [COORD @D129503, AGR [COUNT @D129502, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SELL, 
   [COORD @D129507, AGR [COUNT @D129506, PER @D129505, PLU @D129504, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : SELL, 
   [COORD @D129513, PAST @D129512, 
      AGR [CASE @D129511, COUNT @D129510, PER @D129509, PLU @D129508, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : SELL.

WORD selling : 
   [COORD @D129534, PRD @D129533, AGR [CASE @D129532, COUNT @D129531, 
            PER @D129530, PLU @D129529, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129540, PRD @D129539, 
      AGR [CASE @D129538, COUNT @D129537, PER @D129536, PLU @D129535, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SELL, 
   [COORD @D129546, PRD @D129545, AGR [CASE @D129544, COUNT @D129543, 
            PER @D129542, PLU @D129541, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129552, PRD @D129551, 
      AGR [CASE @D129550, COUNT @D129549, PER @D129548, PLU @D129547, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129558, PRD @D129557, AGR [CASE @D129556, COUNT @D129555, 
            PER @D129554, PLU @D129553, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129564, PRD @D129563, 
      AGR [CASE @D129562, COUNT @D129561, PER @D129560, PLU @D129559, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129570, PRD @D129569, AGR [CASE @D129568, COUNT @D129567, 
            PER @D129566, PLU @D129565, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129576, PRD @D129575, 
      AGR [CASE @D129574, COUNT @D129573, PER @D129572, PLU @D129571, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SELL, 
   [COORD @D129582, PRD @D129581, AGR [CASE @D129580, COUNT @D129579, 
            PER @D129578, PLU @D129577, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129588, PRD @D129587, 
      AGR [CASE @D129586, COUNT @D129585, PER @D129584, PLU @D129583, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SELL, 
   [COORD @D129594, PRD @D129593, AGR [CASE @D129592, COUNT @D129591, 
            PER @D129590, PLU @D129589, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129600, PRD @D129599, 
      AGR [CASE @D129598, COUNT @D129597, PER @D129596, PLU @D129595, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SELL, 
   [COORD @D129606, PRD @D129605, AGR [CASE @D129604, COUNT @D129603, 
            PER @D129602, PLU @D129601, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SELL, 
   [COORD @D129612, PRD @D129611, 
      AGR [CASE @D129610, COUNT @D129609, PER @D129608, PLU @D129607, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SELL, 
   [COORD @D129618, PRD @D129617, AGR [CASE @D129616, COUNT @D129615, 
            PER @D129614, PLU @D129613, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SELL.

WORD sells : 
   [COORD @D129626, AGR [COUNT @D129625, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL, 
   [COORD @D129628, 
      AGR [COUNT @D129627, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL, 
   [COORD @D129630, 
      AGR [COUNT @D129629, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL, 
   [COORD @D129632, 
      AGR [COUNT @D129631, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SELL, 
   [COORD @D129634, AGR [COUNT @D129633, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL, 
   [COORD @D129636, 
      AGR [COUNT @D129635, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SELL, 
   [COORD @D129638, AGR [COUNT @D129637, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SELL, 
   [COORD @D129640, AGR [COUNT @D129639, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SELL, 
   [COORD @D129642, AGR [COUNT @D129641, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SELL, 
   [COORD @D129644, AGR [COUNT @D129643, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SELL, 
   [COORD @D129646, AGR [COUNT @D129645, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SELL, 
   [COORD @D129648, AGR [COUNT @D129647, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL, 
   [COORD @D129650, 
      AGR [COUNT @D129649, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL, 
   [COORD @D129652, 
      AGR [COUNT @D129651, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL, 
   [COORD @D129654, 
      AGR [COUNT @D129653, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SELL.

WORD sense : 
   [COORD @D129664, REFL @D129663, PRD @D129662, CASE @D129661, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, COUNT +] : SENSE, 
   [COORD @D129669, REFL @D129668, COUNT @D129667, PRD @D129666, 
      CASE @D129665, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SENSE, 
   [COORD @D129673, REFL @D129672, PRD @D129671, CASE @D129670, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SENSE, 
   [COORD @D129677, REFL @D129676, PRD @D129675, CASE @D129674, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : SENSE, 
   [COORD @D129682, REFL @D129681, COUNT @D129680, PRD @D129679, 
      CASE @D129678, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SENSE, 
   [COORD @D129687, REFL @D129686, COUNT @D129685, PRD @D129684, 
      CASE @D129683, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : 
   SENSE, 
   [COORD @D129691, REFL @D129690, PRD @D129689, CASE @D129688, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SENSE, 
   [COORD @D129694, 
      AGR [COUNT @D129693, PER @D129692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, ARITY 2] : 
   SENSE, 
   [COORD @D129696, AGR [COUNT @D129695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SENSE, 
   [COORD @D129698, AGR [COUNT @D129697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SENSE, 
   [COORD @D129702, AGR [COUNT @D129701, PER @D129700, PLU @D129699, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SENSE, 
   [COORD @D129708, PAST @D129707, AGR [CASE @D129706, COUNT @D129705, 
            PER @D129704, PLU @D129703, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : SENSE, 
   [COORD @D129711, AGR [COUNT @D129710, PER @D129709, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SENSE, 
   [COORD @D129713, AGR [COUNT @D129712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SENSE, 
   [COORD @D129715, AGR [COUNT @D129714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SENSE, 
   [COORD @D129719, AGR [COUNT @D129718, PER @D129717, PLU @D129716, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : SENSE, 
   [COORD @D129725, PAST @D129724, AGR [CASE @D129723, COUNT @D129722, 
            PER @D129721, PLU @D129720, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : SENSE, 
   [COORD @D129728, AGR [COUNT @D129727, PER @D129726, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SENSE, 
   [COORD @D129730, AGR [COUNT @D129729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SENSE, 
   [COORD @D129732, AGR [COUNT @D129731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SENSE, 
   [COORD @D129736, AGR [COUNT @D129735, PER @D129734, PLU @D129733, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SENSE, 
   [COORD @D129742, PAST @D129741, AGR [CASE @D129740, COUNT @D129739, 
            PER @D129738, PLU @D129737, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : SENSE, 
   [COORD @D129745, AGR [COUNT @D129744, PER @D129743, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SENSE, 
   [COORD @D129747, AGR [COUNT @D129746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SENSE, 
   [COORD @D129749, AGR [COUNT @D129748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SENSE, 
   [COORD @D129753, AGR [COUNT @D129752, PER @D129751, PLU @D129750, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SENSE, 
   [COORD @D129759, PAST @D129758, AGR [CASE @D129757, COUNT @D129756, 
            PER @D129755, PLU @D129754, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SENSE.

WORD sensed : 
   [COORD @D129772, AGR [CASE @D129771, COUNT @D129770, PER @D129769, 
            PLU @D129768, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129777, AGR [CASE @D129776, COUNT @D129775, PER @D129774, 
            PLU @D129773, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129782, AGR [CASE @D129781, COUNT @D129780, PER @D129779, 
            PLU @D129778, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129787, AGR [CASE @D129786, COUNT @D129785, PER @D129784, 
            PLU @D129783, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129792, AGR [UB @D129791, VFORM @D129790, SUBJ @D129789, 
            FIN @D129788, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SENSE, 
   [COORD @D129797, AGR [CASE @D129796, COUNT @D129795, PER @D129794, 
            PLU @D129793, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129802, AGR [CASE @D129801, COUNT @D129800, PER @D129799, 
            PLU @D129798, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129807, AGR [CASE @D129806, COUNT @D129805, PER @D129804, 
            PLU @D129803, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SENSE, 
   [COORD @D129812, AGR [CASE @D129811, COUNT @D129810, PER @D129809, 
            PLU @D129808, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129817, AGR [CASE @D129816, COUNT @D129815, PER @D129814, 
            PLU @D129813, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SENSE.

WORD senses : 
   [COORD @D129829, REFL @D129828, PRD @D129827, CASE @D129826, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : SENSES, 
   [COORD @D129834, DEMON @D129833, REFL @D129832, PRD @D129831, 
      CASE @D129830, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SENSE, 
   [COORD @D129839, DEMON @D129838, REFL @D129837, PRD @D129836, 
      CASE @D129835, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SENSE, 
   [COORD @D129844, DEMON @D129843, REFL @D129842, PRD @D129841, 
      CASE @D129840, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SENSE, 
   [COORD @D129846, AGR [COUNT @D129845, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SENSE, 
   [COORD @D129848, 
      AGR [COUNT @D129847, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SENSE, 
   [COORD @D129850, 
      AGR [COUNT @D129849, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SENSE, 
   [COORD @D129852, 
      AGR [COUNT @D129851, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SENSE.

WORD sensing : 
   [COORD @D129877, PRD @D129876, AGR [CASE @D129875, COUNT @D129874, 
            PER @D129873, PLU @D129872, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129883, PRD @D129882, 
      AGR [CASE @D129881, COUNT @D129880, PER @D129879, PLU @D129878, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SENSE, 
   [COORD @D129889, PRD @D129888, AGR [CASE @D129887, COUNT @D129886, 
            PER @D129885, PLU @D129884, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SENSE, 
   [COORD @D129895, PRD @D129894, 
      AGR [CASE @D129893, COUNT @D129892, PER @D129891, PLU @D129890, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SENSE.

WORD sent : 
   [COORD @D129905, PAST @D129904, AGR [CASE @D129903, COUNT @D129902, 
            PER @D129901, PLU @D129900, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, FIN -, ARITY 3] : SEND, 
   [COORD @D129911, PAST @D129910, 
      AGR [CASE @D129909, COUNT @D129908, PER @D129907, PLU @D129906, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, FIN -, 
      ARITY 3] : SEND, 
   [COORD @D129917, PAST @D129916, AGR [CASE @D129915, COUNT @D129914, 
            PER @D129913, PLU @D129912, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : SEND, 
   [COORD @D129923, PAST @D129922, 
      AGR [CASE @D129921, COUNT @D129920, PER @D129919, PLU @D129918, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, 
      ARITY 3] : SEND, 
   [COORD @D129929, PAST @D129928, AGR [CASE @D129927, COUNT @D129926, 
            PER @D129925, PLU @D129924, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : SEND, 
   [COORD @D129935, PAST @D129934, 
      AGR [CASE @D129933, COUNT @D129932, PER @D129931, PLU @D129930, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, 
      ARITY 3] : SEND, 
   [COORD @D129941, PAST @D129940, AGR [CASE @D129939, COUNT @D129938, 
            PER @D129937, PLU @D129936, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : SEND, 
   [COORD @D129947, PAST @D129946, 
      AGR [CASE @D129945, COUNT @D129944, PER @D129943, PLU @D129942, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : SEND, 
   [COORD @D129953, PAST @D129952, AGR [CASE @D129951, COUNT @D129950, 
            PER @D129949, PLU @D129948, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : SEND, 
   [COORD @D129959, PAST @D129958, 
      AGR [CASE @D129957, COUNT @D129956, PER @D129955, PLU @D129954, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : SEND, 
   [COORD @D129965, PAST @D129964, AGR [CASE @D129963, COUNT @D129962, 
            PER @D129961, PLU @D129960, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : SEND, 
   [COORD @D129971, PAST @D129970, 
      AGR [CASE @D129969, COUNT @D129968, PER @D129967, PLU @D129966, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : SEND, 
   [COORD @D129977, PAST @D129976, AGR [CASE @D129975, COUNT @D129974, 
            PER @D129973, PLU @D129972, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM INTO, FIN -, ARITY 3] : SEND, 
   [COORD @D129983, PAST @D129982, 
      AGR [CASE @D129981, COUNT @D129980, PER @D129979, PLU @D129978, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM INTO, 
      FIN -, ARITY 3] : SEND, 
   [COORD @D129989, PAST @D129988, AGR [CASE @D129987, COUNT @D129986, 
            PER @D129985, PLU @D129984, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM FOR, FIN -, ARITY 3] : SEND, 
   [COORD @D129995, PAST @D129994, 
      AGR [CASE @D129993, COUNT @D129992, PER @D129991, PLU @D129990, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      PFORM FOR, FIN -, ARITY 3] : SEND, 
   [COORD @D129999, AGR [COUNT @D129998, PER @D129997, PLU @D129996, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, PAST +, ARITY 3] : SEND, 
   [COORD @D130003, AGR [COUNT @D130002, PER @D130001, PLU @D130000, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PAST +, ARITY 3] : SEND, 
   [COORD @D130007, AGR [COUNT @D130006, PER @D130005, PLU @D130004, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 3] : SEND, 
   [COORD @D130011, AGR [COUNT @D130010, PER @D130009, PLU @D130008, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : SEND, 
   [COORD @D130015, AGR [COUNT @D130014, PER @D130013, PLU @D130012, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : SEND, 
   [COORD @D130019, AGR [COUNT @D130018, PER @D130017, PLU @D130016, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, PAST +, ARITY 3] : SEND, 
   [COORD @D130023, 
      AGR [COUNT @D130022, PER @D130021, PLU @D130020, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM INTO, PAST +, ARITY 3] : SEND, 
   [COORD @D130027, AGR [COUNT @D130026, PER @D130025, PLU @D130024, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, PFORM FOR, PAST +, ARITY 3] : SEND, 
   [COORD @D130033, PAST @D130032, 
      AGR [CASE @D130031, COUNT @D130030, PER @D130029, PLU @D130028, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130039, PAST @D130038, AGR [CASE @D130037, COUNT @D130036, 
            PER @D130035, PLU @D130034, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, FIN -, ARITY 2] : SEND, 
   [COORD @D130045, PAST @D130044, 
      AGR [CASE @D130043, COUNT @D130042, PER @D130041, PLU @D130040, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130051, PAST @D130050, AGR [CASE @D130049, COUNT @D130048, 
            PER @D130047, PLU @D130046, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SEND, 
   [COORD @D130057, PAST @D130056, 
      AGR [CASE @D130055, COUNT @D130054, PER @D130053, PLU @D130052, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT DOWN, 
      PFORM TO, FIN -, ARITY 2] : SEND, 
   [COORD @D130063, PAST @D130062, AGR 
         [CASE @D130061, COUNT @D130060, PER @D130059, PLU @D130058, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      FIN -, ARITY 2] : SEND, 
   [COORD @D130069, PAST @D130068, AGR [CASE @D130067, COUNT @D130066, 
            PER @D130065, PLU @D130064, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM FOR, FIN -, ARITY 2] : SEND, 
   [COORD @D130075, PAST @D130074, 
      AGR [CASE @D130073, COUNT @D130072, PER @D130071, PLU @D130070, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM FOR, FIN -, ARITY 2] : SEND, 
   [COORD @D130081, PAST @D130080, 
      AGR [CASE @D130079, COUNT @D130078, PER @D130077, PLU @D130076, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT AWAY, 
      PFORM FOR, FIN -, ARITY 2] : SEND, 
   [COORD @D130087, PAST @D130086, 
      AGR [CASE @D130085, COUNT @D130084, PER @D130083, PLU @D130082, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130093, PAST @D130092, AGR [CASE @D130091, COUNT @D130090, 
            PER @D130089, PLU @D130088, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : SEND, 
   [COORD @D130099, PAST @D130098, 
      AGR [CASE @D130097, COUNT @D130096, PER @D130095, PLU @D130094, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130105, PAST @D130104, AGR [CASE @D130103, COUNT @D130102, 
            PER @D130101, PLU @D130100, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SEND, 
   [COORD @D130111, PAST @D130110, 
      AGR [CASE @D130109, COUNT @D130108, PER @D130107, PLU @D130106, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ON, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130117, PAST @D130116, AGR [CASE @D130115, COUNT @D130114, 
            PER @D130113, PLU @D130112, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ON, FIN -, ARITY 2] : SEND, 
   [COORD @D130123, PAST @D130122, 
      AGR [CASE @D130121, COUNT @D130120, PER @D130119, PLU @D130118, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130129, PAST @D130128, AGR [CASE @D130127, COUNT @D130126, 
            PER @D130125, PLU @D130124, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : SEND, 
   [COORD @D130135, PAST @D130134, 
      AGR [CASE @D130133, COUNT @D130132, PER @D130131, PLU @D130130, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130141, PAST @D130140, AGR [CASE @D130139, COUNT @D130138, 
            PER @D130137, PLU @D130136, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : SEND, 
   [COORD @D130147, PAST @D130146, 
      AGR [CASE @D130145, COUNT @D130144, PER @D130143, PLU @D130142, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT FORTH, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130153, PAST @D130152, AGR [CASE @D130151, COUNT @D130150, 
            PER @D130149, PLU @D130148, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT FORTH, FIN -, ARITY 2] : SEND, 
   [COORD @D130159, PAST @D130158, 
      AGR [CASE @D130157, COUNT @D130156, PER @D130155, PLU @D130154, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130165, PAST @D130164, AGR [CASE @D130163, COUNT @D130162, 
            PER @D130161, PLU @D130160, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : SEND, 
   [COORD @D130171, PAST @D130170, 
      AGR [CASE @D130169, COUNT @D130168, PER @D130167, PLU @D130166, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, FIN -, 
      ARITY 2] : SEND, 
   [COORD @D130177, PAST @D130176, AGR [CASE @D130175, COUNT @D130174, 
            PER @D130173, PLU @D130172, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, FIN -, ARITY 2] : SEND, 
   [COORD @D130181, 
      AGR [COUNT @D130180, PER @D130179, PLU @D130178, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : SEND, 
   [COORD @D130185, AGR [COUNT @D130184, PER @D130183, PLU @D130182, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PAST +, ARITY 2] : SEND, 
   [COORD @D130189, AGR [COUNT @D130188, PER @D130187, PLU @D130186, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SEND, 
   [COORD @D130193, AGR [COUNT @D130192, PER @D130191, PLU @D130190, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT DOWN, PFORM TO, PAST +, ARITY 2] : SEND, 
   [COORD @D130197, 
      AGR [COUNT @D130196, PER @D130195, PLU @D130194, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : SEND, 
   [COORD @D130201, AGR [COUNT @D130200, PER @D130199, PLU @D130198, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM FOR, PAST +, ARITY 2] : SEND, 
   [COORD @D130205, 
      AGR [COUNT @D130204, PER @D130203, PLU @D130202, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM FOR, PAST +, ARITY 2] : SEND, 
   [COORD @D130209, AGR [COUNT @D130208, PER @D130207, PLU @D130206, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT AWAY, PFORM FOR, PAST +, ARITY 2] : SEND, 
   [COORD @D130213, 
      AGR [COUNT @D130212, PER @D130211, PLU @D130210, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : SEND, 
   [COORD @D130217, AGR [COUNT @D130216, PER @D130215, PLU @D130214, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SEND, 
   [COORD @D130221, AGR [COUNT @D130220, PER @D130219, PLU @D130218, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ON, PAST +, ARITY 2] : SEND, 
   [COORD @D130225, AGR [COUNT @D130224, PER @D130223, PLU @D130222, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : SEND, 
   [COORD @D130229, AGR [COUNT @D130228, PER @D130227, PLU @D130226, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT IN, PAST +, ARITY 2] : SEND, 
   [COORD @D130233, AGR [COUNT @D130232, PER @D130231, PLU @D130230, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT FORTH, PAST +, ARITY 2] : SEND, 
   [COORD @D130237, AGR [COUNT @D130236, PER @D130235, PLU @D130234, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : SEND, 
   [COORD @D130241, AGR [COUNT @D130240, PER @D130239, PLU @D130238, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT AWAY, PAST +, ARITY 2] : SEND, 
   [COORD @D130247, PAST @D130246, 
      AGR [CASE @D130245, COUNT @D130244, PER @D130243, PLU @D130242, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SEND, 
   [COORD @D130253, PAST @D130252, AGR [CASE @D130251, COUNT @D130250, 
            PER @D130249, PLU @D130248, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : SEND, 
   [COORD @D130259, PAST @D130258, 
      AGR [CASE @D130257, COUNT @D130256, PER @D130255, PLU @D130254, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : SEND, 
   [COORD @D130265, PAST @D130264, AGR [CASE @D130263, COUNT @D130262, 
            PER @D130261, PLU @D130260, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, FIN -, ARITY 1] : SEND, 
   [COORD @D130271, PAST @D130270, 
      AGR [CASE @D130269, COUNT @D130268, PER @D130267, PLU @D130266, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      FIN -, ARITY 1] : SEND, 
   [COORD @D130277, PAST @D130276, AGR [CASE @D130275, COUNT @D130274, 
            PER @D130273, PLU @D130272, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : SEND, 
   [COORD @D130283, PAST @D130282, 
      AGR [CASE @D130281, COUNT @D130280, PER @D130279, PLU @D130278, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT FORTH, 
      FIN -, ARITY 1] : SEND, 
   [COORD @D130289, PAST @D130288, AGR [CASE @D130287, COUNT @D130286, 
            PER @D130285, PLU @D130284, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : SEND, 
   [COORD @D130295, PAST @D130294, 
      AGR [CASE @D130293, COUNT @D130292, PER @D130291, PLU @D130290, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AWAY, 
      FIN -, ARITY 1] : SEND, 
   [COORD @D130299, AGR [COUNT @D130298, PER @D130297, PLU @D130296, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : SEND, 
   [COORD @D130303, AGR [COUNT @D130302, PER @D130301, PLU @D130300, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SEND, 
   [COORD @D130307, 
      AGR [COUNT @D130306, PER @D130305, PLU @D130304, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : SEND, 
   [COORD @D130311, AGR [COUNT @D130310, PER @D130309, PLU @D130308, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ON, PAST +, ARITY 1] : SEND, 
   [COORD @D130315, 
      AGR [COUNT @D130314, PER @D130313, PLU @D130312, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : SEND, 
   [COORD @D130319, AGR [COUNT @D130318, PER @D130317, PLU @D130316, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, PAST +, ARITY 1] : SEND, 
   [COORD @D130323, 
      AGR [COUNT @D130322, PER @D130321, PLU @D130320, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORTH, PAST +, ARITY 1] : SEND, 
   [COORD @D130327, AGR [COUNT @D130326, PER @D130325, PLU @D130324, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, PAST +, ARITY 1] : SEND, 
   [COORD @D130331, 
      AGR [COUNT @D130330, PER @D130329, PLU @D130328, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, PAST +, ARITY 1] : SEND.

WORD serve : 
   [COORD @D130354, AGR [COUNT @D130353, PER @D130352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : SERVE, 
   [COORD @D130356, AGR [COUNT @D130355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : SERVE, 
   [COORD @D130358, AGR [COUNT @D130357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : SERVE, 
   [COORD @D130362, AGR [COUNT @D130361, PER @D130360, PLU @D130359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : SERVE, 
   [COORD @D130368, PAST @D130367, AGR [CASE @D130366, COUNT @D130365, 
            PER @D130364, PLU @D130363, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : SERVE, 
   [COORD @D130371, AGR [COUNT @D130370, PER @D130369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SERVE, 
   [COORD @D130373, AGR [COUNT @D130372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SERVE, 
   [COORD @D130375, AGR [COUNT @D130374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SERVE, 
   [COORD @D130379, AGR [COUNT @D130378, PER @D130377, PLU @D130376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : SERVE, 
   [COORD @D130385, PAST @D130384, AGR [CASE @D130383, COUNT @D130382, 
            PER @D130381, PLU @D130380, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : SERVE, 
   [COORD @D130388, AGR [COUNT @D130387, PER @D130386, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130390, AGR [COUNT @D130389, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130392, AGR [COUNT @D130391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130396, AGR [COUNT @D130395, PER @D130394, PLU @D130393, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130402, PAST @D130401, 
      AGR [CASE @D130400, COUNT @D130399, PER @D130398, PLU @D130397, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      PRT UP, ARITY 3] : SERVE, 
   [COORD @D130405, AGR [COUNT @D130404, PER @D130403, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130407, AGR [COUNT @D130406, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130409, AGR [COUNT @D130408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130413, AGR [COUNT @D130412, PER @D130411, PLU @D130410, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT UP, ARITY 3] : SERVE, 
   [COORD @D130419, PAST @D130418, 
      AGR [CASE @D130417, COUNT @D130416, PER @D130415, PLU @D130414, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      PRT UP, ARITY 3] : SERVE, 
   [COORD @D130422, AGR [COUNT @D130421, PER @D130420, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130424, AGR [COUNT @D130423, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130426, AGR [COUNT @D130425, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130430, AGR [COUNT @D130429, PER @D130428, PLU @D130427, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130436, PAST @D130435, 
      AGR [CASE @D130434, COUNT @D130433, PER @D130432, PLU @D130431, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130439, AGR [COUNT @D130438, PER @D130437, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130441, AGR [COUNT @D130440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130443, AGR [COUNT @D130442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130447, AGR [COUNT @D130446, PER @D130445, PLU @D130444, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130453, PAST @D130452, 
      AGR [CASE @D130451, COUNT @D130450, PER @D130449, PLU @D130448, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      PRT OUT, ARITY 3] : SERVE, 
   [COORD @D130456, AGR [COUNT @D130455, PER @D130454, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SERVE, 
   [COORD @D130458, AGR [COUNT @D130457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SERVE, 
   [COORD @D130460, AGR [COUNT @D130459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SERVE, 
   [COORD @D130464, AGR [COUNT @D130463, PER @D130462, PLU @D130461, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SERVE, 
   [COORD @D130470, PAST @D130469, 
      AGR [CASE @D130468, COUNT @D130467, PER @D130466, PLU @D130465, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : SERVE, 
   [COORD @D130473, AGR [COUNT @D130472, PER @D130471, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SERVE, 
   [COORD @D130475, AGR [COUNT @D130474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SERVE, 
   [COORD @D130477, AGR [COUNT @D130476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SERVE, 
   [COORD @D130481, AGR [COUNT @D130480, PER @D130479, PLU @D130478, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SERVE, 
   [COORD @D130487, PAST @D130486, 
      AGR [CASE @D130485, COUNT @D130484, PER @D130483, PLU @D130482, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : SERVE, 
   [COORD @D130490, AGR [COUNT @D130489, PER @D130488, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SERVE, 
   [COORD @D130492, AGR [COUNT @D130491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SERVE, 
   [COORD @D130494, AGR [COUNT @D130493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SERVE, 
   [COORD @D130498, AGR [COUNT @D130497, PER @D130496, PLU @D130495, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SERVE, 
   [COORD @D130504, PAST @D130503, 
      AGR [CASE @D130502, COUNT @D130501, PER @D130500, PLU @D130499, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : SERVE, 
   [COORD @D130507, AGR [COUNT @D130506, PER @D130505, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SERVE, 
   [COORD @D130509, AGR [COUNT @D130508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SERVE, 
   [COORD @D130511, AGR [COUNT @D130510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SERVE, 
   [COORD @D130515, AGR [COUNT @D130514, PER @D130513, PLU @D130512, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM IN, ARITY 3] : SERVE, 
   [COORD @D130521, PAST @D130520, 
      AGR [CASE @D130519, COUNT @D130518, PER @D130517, PLU @D130516, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM IN, ARITY 3] : SERVE, 
   [COORD @D130524, AGR [COUNT @D130523, PER @D130522, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SERVE, 
   [COORD @D130526, AGR [COUNT @D130525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SERVE, 
   [COORD @D130528, AGR [COUNT @D130527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SERVE, 
   [COORD @D130532, AGR [COUNT @D130531, PER @D130530, PLU @D130529, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : SERVE, 
   [COORD @D130538, PAST @D130537, 
      AGR [CASE @D130536, COUNT @D130535, PER @D130534, PLU @D130533, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : SERVE, 
   [COORD @D130541, AGR [COUNT @D130540, PER @D130539, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : SERVE, 
   [COORD @D130543, AGR [COUNT @D130542, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : SERVE, 
   [COORD @D130545, AGR [COUNT @D130544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : SERVE, 
   [COORD @D130549, AGR [COUNT @D130548, PER @D130547, PLU @D130546, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : SERVE, 
   [COORD @D130555, PAST @D130554, 
      AGR [CASE @D130553, COUNT @D130552, PER @D130551, PLU @D130550, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : SERVE, 
   [COORD @D130558, AGR [COUNT @D130557, PER @D130556, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SERVE, 
   [COORD @D130560, AGR [COUNT @D130559, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SERVE, 
   [COORD @D130562, AGR [COUNT @D130561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SERVE, 
   [COORD @D130566, AGR [COUNT @D130565, PER @D130564, PLU @D130563, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SERVE, 
   [COORD @D130572, PAST @D130571, AGR [CASE @D130570, COUNT @D130569, 
            PER @D130568, PLU @D130567, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : SERVE, 
   [COORD @D130575, AGR [COUNT @D130574, PER @D130573, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SERVE, 
   [COORD @D130577, AGR [COUNT @D130576, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SERVE, 
   [COORD @D130579, AGR [COUNT @D130578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SERVE, 
   [COORD @D130583, AGR [COUNT @D130582, PER @D130581, PLU @D130580, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SERVE, 
   [COORD @D130589, PAST @D130588, AGR [CASE @D130587, COUNT @D130586, 
            PER @D130585, PLU @D130584, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SERVE, 
   [COORD @D130592, AGR [COUNT @D130591, PER @D130590, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UNDER, ARITY 2] : SERVE, 
   [COORD @D130594, AGR [COUNT @D130593, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UNDER, ARITY 2] : SERVE, 
   [COORD @D130596, AGR [COUNT @D130595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UNDER, ARITY 2] : SERVE, 
   [COORD @D130600, AGR [COUNT @D130599, PER @D130598, PLU @D130597, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM UNDER, ARITY 2] : SERVE, 
   [COORD @D130606, PAST @D130605, 
      AGR [CASE @D130604, COUNT @D130603, PER @D130602, PLU @D130601, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM UNDER, ARITY 2] : SERVE, 
   [COORD @D130609, AGR [COUNT @D130608, PER @D130607, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SERVE, 
   [COORD @D130611, AGR [COUNT @D130610, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SERVE, 
   [COORD @D130613, AGR [COUNT @D130612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SERVE, 
   [COORD @D130617, AGR [COUNT @D130616, PER @D130615, PLU @D130614, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : SERVE, 
   [COORD @D130623, PAST @D130622, 
      AGR [CASE @D130621, COUNT @D130620, PER @D130619, PLU @D130618, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SERVE, 
   [COORD @D130626, AGR [COUNT @D130625, PER @D130624, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SERVE, 
   [COORD @D130628, AGR [COUNT @D130627, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SERVE, 
   [COORD @D130630, AGR [COUNT @D130629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SERVE, 
   [COORD @D130634, AGR [COUNT @D130633, PER @D130632, PLU @D130631, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : SERVE, 
   [COORD @D130640, PAST @D130639, 
      AGR [CASE @D130638, COUNT @D130637, PER @D130636, PLU @D130635, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SERVE, 
   [COORD @D130643, AGR [COUNT @D130642, PER @D130641, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SERVE, 
   [COORD @D130645, AGR [COUNT @D130644, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SERVE, 
   [COORD @D130647, AGR [COUNT @D130646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SERVE, 
   [COORD @D130651, AGR [COUNT @D130650, PER @D130649, PLU @D130648, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SERVE, 
   [COORD @D130657, PAST @D130656, 
      AGR [CASE @D130655, COUNT @D130654, PER @D130653, PLU @D130652, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SERVE, 
   [COORD @D130660, AGR [COUNT @D130659, PER @D130658, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : SERVE, 
   [COORD @D130662, AGR [COUNT @D130661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : SERVE, 
   [COORD @D130664, AGR [COUNT @D130663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : SERVE, 
   [COORD @D130668, AGR [COUNT @D130667, PER @D130666, PLU @D130665, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AS, ARITY 2] : SERVE, 
   [COORD @D130674, PAST @D130673, 
      AGR [CASE @D130672, COUNT @D130671, PER @D130670, PLU @D130669, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AS, ARITY 2] : SERVE, 
   [COORD @D130677, AGR [COUNT @D130676, PER @D130675, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : SERVE, 
   [COORD @D130679, AGR [COUNT @D130678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : SERVE, 
   [COORD @D130681, AGR [COUNT @D130680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : SERVE, 
   [COORD @D130685, AGR [COUNT @D130684, PER @D130683, PLU @D130682, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : SERVE, 
   [COORD @D130691, PAST @D130690, 
      AGR [CASE @D130689, COUNT @D130688, PER @D130687, PLU @D130686, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : SERVE, 
   [COORD @D130694, AGR [COUNT @D130693, PER @D130692, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SERVE, 
   [COORD @D130696, AGR [COUNT @D130695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SERVE, 
   [COORD @D130698, AGR [COUNT @D130697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SERVE, 
   [COORD @D130702, AGR [COUNT @D130701, PER @D130700, PLU @D130699, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : SERVE, 
   [COORD @D130708, PAST @D130707, 
      AGR [CASE @D130706, COUNT @D130705, PER @D130704, PLU @D130703, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : SERVE, 
   [COORD @D130711, AGR [COUNT @D130710, PER @D130709, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SERVE, 
   [COORD @D130713, AGR [COUNT @D130712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SERVE, 
   [COORD @D130715, AGR [COUNT @D130714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SERVE, 
   [COORD @D130719, AGR [COUNT @D130718, PER @D130717, PLU @D130716, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SERVE, 
   [COORD @D130725, PAST @D130724, AGR [CASE @D130723, COUNT @D130722, 
            PER @D130721, PLU @D130720, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SERVE, 
   [COORD @D130728, AGR [COUNT @D130727, PER @D130726, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SERVE, 
   [COORD @D130730, AGR [COUNT @D130729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SERVE, 
   [COORD @D130732, AGR [COUNT @D130731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SERVE, 
   [COORD @D130736, AGR [COUNT @D130735, PER @D130734, PLU @D130733, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SERVE, 
   [COORD @D130742, PAST @D130741, 
      AGR [CASE @D130740, COUNT @D130739, PER @D130738, PLU @D130737, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : SERVE, 
   [COORD @D130745, AGR [COUNT @D130744, PER @D130743, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SERVE, 
   [COORD @D130747, AGR [COUNT @D130746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SERVE, 
   [COORD @D130749, AGR [COUNT @D130748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SERVE, 
   [COORD @D130753, AGR [COUNT @D130752, PER @D130751, PLU @D130750, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SERVE, 
   [COORD @D130759, PAST @D130758, 
      AGR [CASE @D130757, COUNT @D130756, PER @D130755, PLU @D130754, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SERVE.

WORD served : 
   [COORD @D130771, AGR [CASE @D130770, NFORM @D130769, COUNT @D130768, 
            PER @D130767, PLU @D130766, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D130776, AGR [CASE @D130775, COUNT @D130774, PER @D130773, 
            PLU @D130772, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130781, AGR [CASE @D130780, COUNT @D130779, PER @D130778, 
            PLU @D130777, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130786, AGR [CASE @D130785, COUNT @D130784, PER @D130783, 
            PLU @D130782, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D130791, AGR [CASE @D130790, COUNT @D130789, PER @D130788, 
            PLU @D130787, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130796, AGR [CASE @D130795, COUNT @D130794, PER @D130793, 
            PLU @D130792, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130802, AGR [CASE @D130801, NFORM @D130800, COUNT @D130799, 
            PER @D130798, PLU @D130797, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130807, AGR [CASE @D130806, COUNT @D130805, PER @D130804, 
            PLU @D130803, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130812, AGR [CASE @D130811, COUNT @D130810, PER @D130809, 
            PLU @D130808, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130817, AGR [CASE @D130816, COUNT @D130815, PER @D130814, 
            PLU @D130813, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130822, AGR [CASE @D130821, COUNT @D130820, PER @D130819, 
            PLU @D130818, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130827, AGR [CASE @D130826, COUNT @D130825, PER @D130824, 
            PLU @D130823, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130832, AGR [CASE @D130831, COUNT @D130830, PER @D130829, 
            PLU @D130828, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130837, AGR [CASE @D130836, COUNT @D130835, PER @D130834, 
            PLU @D130833, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130843, AGR [CASE @D130842, NFORM @D130841, COUNT @D130840, 
            PER @D130839, PLU @D130838, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130848, AGR [CASE @D130847, COUNT @D130846, PER @D130845, 
            PLU @D130844, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130853, AGR [CASE @D130852, COUNT @D130851, PER @D130850, 
            PLU @D130849, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130858, AGR [CASE @D130857, COUNT @D130856, PER @D130855, 
            PLU @D130854, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130863, AGR [CASE @D130862, COUNT @D130861, PER @D130860, 
            PLU @D130859, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130868, AGR [CASE @D130867, COUNT @D130866, PER @D130865, 
            PLU @D130864, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130873, AGR [CASE @D130872, COUNT @D130871, PER @D130870, 
            PLU @D130869, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130878, AGR [CASE @D130877, COUNT @D130876, PER @D130875, 
            PLU @D130874, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130883, AGR [CASE @D130882, COUNT @D130881, PER @D130880, 
            PLU @D130879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130888, AGR [CASE @D130887, COUNT @D130886, PER @D130885, 
            PLU @D130884, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130893, AGR [CASE @D130892, COUNT @D130891, PER @D130890, 
            PLU @D130889, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130898, AGR [CASE @D130897, COUNT @D130896, PER @D130895, 
            PLU @D130894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130903, AGR [CASE @D130902, COUNT @D130901, PER @D130900, 
            PLU @D130899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130908, AGR [CASE @D130907, COUNT @D130906, PER @D130905, 
            PLU @D130904, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130913, AGR [CASE @D130912, COUNT @D130911, PER @D130910, 
            PLU @D130909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130918, AGR [CASE @D130917, COUNT @D130916, PER @D130915, 
            PLU @D130914, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130923, AGR [CASE @D130922, COUNT @D130921, PER @D130920, 
            PLU @D130919, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130928, AGR [CASE @D130927, COUNT @D130926, PER @D130925, 
            PLU @D130924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130933, AGR [CASE @D130932, COUNT @D130931, PER @D130930, 
            PLU @D130929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130938, AGR [CASE @D130937, COUNT @D130936, PER @D130935, 
            PLU @D130934, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AS, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130943, AGR [CASE @D130942, COUNT @D130941, PER @D130940, 
            PLU @D130939, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130948, AGR [CASE @D130947, COUNT @D130946, PER @D130945, 
            PLU @D130944, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130953, AGR [CASE @D130952, COUNT @D130951, PER @D130950, 
            PLU @D130949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130958, AGR [CASE @D130957, COUNT @D130956, PER @D130955, 
            PLU @D130954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130963, AGR [CASE @D130962, COUNT @D130961, PER @D130960, 
            PLU @D130959, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D130968, AGR [CASE @D130967, COUNT @D130966, PER @D130965, 
            PLU @D130964, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130973, AGR [CASE @D130972, COUNT @D130971, PER @D130970, 
            PLU @D130969, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130978, AGR [CASE @D130977, COUNT @D130976, PER @D130975, 
            PLU @D130974, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UNDER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130983, AGR [CASE @D130982, COUNT @D130981, PER @D130980, 
            PLU @D130979, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UNDER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130988, AGR [CASE @D130987, COUNT @D130986, PER @D130985, 
            PLU @D130984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130993, AGR [CASE @D130992, COUNT @D130991, PER @D130990, 
            PLU @D130989, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D130998, AGR [CASE @D130997, COUNT @D130996, PER @D130995, 
            PLU @D130994, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131003, AGR [CASE @D131002, COUNT @D131001, PER @D131000, 
            PLU @D130999, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131008, AGR [CASE @D131007, COUNT @D131006, PER @D131005, 
            PLU @D131004, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131013, AGR [CASE @D131012, COUNT @D131011, PER @D131010, 
            PLU @D131009, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131018, AGR [CASE @D131017, COUNT @D131016, PER @D131015, 
            PLU @D131014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131023, AGR [CASE @D131022, COUNT @D131021, PER @D131020, 
            PLU @D131019, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131028, AGR [CASE @D131027, COUNT @D131026, PER @D131025, 
            PLU @D131024, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131033, AGR [CASE @D131032, COUNT @D131031, PER @D131030, 
            PLU @D131029, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131038, AGR [CASE @D131037, COUNT @D131036, PER @D131035, 
            PLU @D131034, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131043, AGR [CASE @D131042, COUNT @D131041, PER @D131040, 
            PLU @D131039, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131048, AGR [CASE @D131047, COUNT @D131046, PER @D131045, 
            PLU @D131044, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131053, AGR [CASE @D131052, COUNT @D131051, PER @D131050, 
            PLU @D131049, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131058, AGR [CASE @D131057, COUNT @D131056, PER @D131055, 
            PLU @D131054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131063, AGR [CASE @D131062, COUNT @D131061, PER @D131060, 
            PLU @D131059, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131068, AGR [CASE @D131067, COUNT @D131066, PER @D131065, 
            PLU @D131064, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131073, AGR [CASE @D131072, COUNT @D131071, PER @D131070, 
            PLU @D131069, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131078, AGR [CASE @D131077, COUNT @D131076, PER @D131075, 
            PLU @D131074, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131083, AGR [CASE @D131082, COUNT @D131081, PER @D131080, 
            PLU @D131079, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SERVE.

WORD serves : 
   [COORD @D131091, AGR [COUNT @D131090, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SERVE, 
   [COORD @D131093, AGR [COUNT @D131092, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131095, 
      AGR [COUNT @D131094, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131097, 
      AGR [COUNT @D131096, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131099, 
      AGR [COUNT @D131098, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131101, 
      AGR [COUNT @D131100, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131103, 
      AGR [COUNT @D131102, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SERVE, 
   [COORD @D131105, AGR [COUNT @D131104, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SERVE, 
   [COORD @D131107, AGR [COUNT @D131106, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SERVE, 
   [COORD @D131109, AGR [COUNT @D131108, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SERVE, 
   [COORD @D131111, AGR [COUNT @D131110, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SERVE, 
   [COORD @D131113, AGR [COUNT @D131112, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SERVE, 
   [COORD @D131115, AGR [COUNT @D131114, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SERVE, 
   [COORD @D131117, AGR [COUNT @D131116, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131119, 
      AGR [COUNT @D131118, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131121, 
      AGR [COUNT @D131120, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131123, 
      AGR [COUNT @D131122, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131125, 
      AGR [COUNT @D131124, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131127, 
      AGR [COUNT @D131126, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131129, 
      AGR [COUNT @D131128, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131131, 
      AGR [COUNT @D131130, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131133, 
      AGR [COUNT @D131132, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131135, 
      AGR [COUNT @D131134, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE, 
   [COORD @D131137, 
      AGR [COUNT @D131136, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVE.

WORD service : 
   [COORD @D131148, REFL @D131147, PRD @D131146, CASE @D131145, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : SERVICE, 
   [COORD @D131152, REFL @D131151, PRD @D131150, CASE @D131149, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SERVICE, 
   [COORD @D131157, REFL @D131156, COUNT @D131155, PRD @D131154, 
      CASE @D131153, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SERVICE, 
   [COORD @D131161, REFL @D131160, PRD @D131159, CASE @D131158, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : SERVICE, 
   [COORD @D131164, 
      AGR [COUNT @D131163, PER @D131162, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   SERVICE, 
   [COORD @D131166, AGR [COUNT @D131165, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SERVICE, 
   [COORD @D131168, AGR [COUNT @D131167, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SERVICE, 
   [COORD @D131172, AGR [COUNT @D131171, PER @D131170, PLU @D131169, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SERVICE, 
   [COORD @D131178, PAST @D131177, AGR [CASE @D131176, COUNT @D131175, 
            PER @D131174, PLU @D131173, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SERVICE.

WORD serviced : 
   [COORD @D131192, AGR [CASE @D131191, COUNT @D131190, PER @D131189, 
            PLU @D131188, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVICE, 
   [COORD @D131197, AGR [CASE @D131196, COUNT @D131195, PER @D131194, 
            PLU @D131193, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SERVICE, 
   [COORD @D131202, AGR [CASE @D131201, COUNT @D131200, PER @D131199, 
            PLU @D131198, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SERVICE.

WORD services : 
   [COORD @D131216, DEMON @D131215, REFL @D131214, PRD @D131213, 
      CASE @D131212, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SERVICE, 
   [COORD @D131221, DEMON @D131220, REFL @D131219, PRD @D131218, 
      CASE @D131217, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SERVICE, 
   [COORD @D131226, DEMON @D131225, REFL @D131224, PRD @D131223, 
      CASE @D131222, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SERVICE, 
   [COORD @D131231, DEMON @D131230, REFL @D131229, PRD @D131228, 
      CASE @D131227, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SERVICE, 
   [COORD @D131233, AGR [COUNT @D131232, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SERVICE.

WORD servicing : 
   [COORD @D131248, PRD @D131247, AGR [CASE @D131246, COUNT @D131245, 
            PER @D131244, PLU @D131243, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVICE.

WORD serving : 
   [COORD @D131258, REFL @D131257, COUNT @D131256, PRD @D131255, 
      CASE @D131254, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SERVING, 
   [COORD @D131264, PRD @D131263, 
      AGR [CASE @D131262, COUNT @D131261, PER @D131260, PLU @D131259, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   SERVE, 
   [COORD @D131270, PRD @D131269, AGR [CASE @D131268, COUNT @D131267, 
            PER @D131266, PLU @D131265, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131276, PRD @D131275, 
      AGR [CASE @D131274, COUNT @D131273, PER @D131272, PLU @D131271, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SERVE, 
   [COORD @D131282, PRD @D131281, AGR [CASE @D131280, COUNT @D131279, 
            PER @D131278, PLU @D131277, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131288, PRD @D131287, 
      AGR [CASE @D131286, COUNT @D131285, PER @D131284, PLU @D131283, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SERVE, 
   [COORD @D131294, PRD @D131293, AGR [CASE @D131292, COUNT @D131291, 
            PER @D131290, PLU @D131289, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131300, PRD @D131299, 
      AGR [CASE @D131298, COUNT @D131297, PER @D131296, PLU @D131295, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D131306, PRD @D131305, AGR [CASE @D131304, COUNT @D131303, 
            PER @D131302, PLU @D131301, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131312, PRD @D131311, 
      AGR [CASE @D131310, COUNT @D131309, PER @D131308, PLU @D131307, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D131318, PRD @D131317, AGR [CASE @D131316, COUNT @D131315, 
            PER @D131314, PLU @D131313, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131324, PRD @D131323, 
      AGR [CASE @D131322, COUNT @D131321, PER @D131320, PLU @D131319, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D131330, PRD @D131329, AGR [CASE @D131328, COUNT @D131327, 
            PER @D131326, PLU @D131325, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131336, PRD @D131335, 
      AGR [CASE @D131334, COUNT @D131333, PER @D131332, PLU @D131331, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SERVE, 
   [COORD @D131342, PRD @D131341, AGR [CASE @D131340, COUNT @D131339, 
            PER @D131338, PLU @D131337, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131348, PRD @D131347, 
      AGR [CASE @D131346, COUNT @D131345, PER @D131344, PLU @D131343, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM UNDER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D131354, PRD @D131353, AGR [CASE @D131352, COUNT @D131351, 
            PER @D131350, PLU @D131349, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131360, PRD @D131359, 
      AGR [CASE @D131358, COUNT @D131357, PER @D131356, PLU @D131355, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D131366, PRD @D131365, AGR [CASE @D131364, COUNT @D131363, 
            PER @D131362, PLU @D131361, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131372, PRD @D131371, 
      AGR [CASE @D131370, COUNT @D131369, PER @D131368, PLU @D131367, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D131378, PRD @D131377, AGR [CASE @D131376, COUNT @D131375, 
            PER @D131374, PLU @D131373, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131384, PRD @D131383, 
      AGR [CASE @D131382, COUNT @D131381, PER @D131380, PLU @D131379, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SERVE, 
   [COORD @D131390, PRD @D131389, AGR [CASE @D131388, COUNT @D131387, 
            PER @D131386, PLU @D131385, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SERVE, 
   [COORD @D131396, PRD @D131395, 
      AGR [CASE @D131394, COUNT @D131393, PER @D131392, PLU @D131391, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SERVE, 
   [COORD @D131402, PRD @D131401, AGR [CASE @D131400, COUNT @D131399, 
            PER @D131398, PLU @D131397, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SERVE.

WORD servings : 
   [COORD @D131414, DEMON @D131413, REFL @D131412, PRD @D131411, 
      CASE @D131410, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SERVING.

WORD set : 
   [COADV @D131426, COORD @D131425, DEF @D131424, PRD @D131423, AGR 
            [CASE @D131422, COUNT @D131421, PER @D131420, PLU @D131419, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : SET, 
   [COADV @D131434, COORD @D131433, DEF @D131432, PRD @D131431, 
      AGR [CASE @D131430, COUNT @D131429, PER @D131428, PLU @D131427, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM UPON, DISTR PRD, 
      ARITY 2] : SET, 
   [COADV @D131442, COORD @D131441, DEF @D131440, PRD @D131439, 
      AGR [CASE @D131438, COUNT @D131437, PER @D131436, PLU @D131435, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, DISTR PRD, 
      ARITY 2] : SET, 
   [COADV @D131450, COORD @D131449, DEF @D131448, PRD @D131447, 
      AGR [CASE @D131446, COUNT @D131445, PER @D131444, PLU @D131443, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE READY, SUBCAT VPINF, 
      DISTR PRD, ARITY 2] : SET, 
   [COADV @D131458, COORD @D131457, DEF @D131456, PRD @D131455, 
      AGR [CASE @D131454, COUNT @D131453, PER @D131452, PLU @D131451, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      DISTR PRD, ARITY 2] : SET, 
   [COADV @D131466, COORD @D131465, DEF @D131464, PRD @D131463, 
      AGR [CASE @D131462, COUNT @D131461, PER @D131460, PLU @D131459, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, DISTR PRD, ARITY 2] : SET, 
   [COADV @D131474, COORD @D131473, DEF @D131472, PRD @D131471, 
      AGR [CASE @D131470, COUNT @D131469, PER @D131468, PLU @D131467, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ALL, DISTR PRD, ARITY 2] : SET, 
   [COORD @D131478, REFL @D131477, PRD @D131476, CASE @D131475, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SET, 
   [COORD @D131483, REFL @D131482, COUNT @D131481, PRD @D131480, 
      CASE @D131479, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SET, 
   [COORD @D131486, 
      AGR [COUNT @D131485, PER @D131484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, ARITY 3] : 
   SET, 
   [COORD @D131488, AGR [COUNT @D131487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SET, 
   [COORD @D131490, AGR [COUNT @D131489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SET, 
   [COORD @D131494, AGR [COUNT @D131493, PER @D131492, PLU @D131491, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, ARITY 3] : SET, 
   [COORD @D131500, PAST @D131499, 
      AGR [CASE @D131498, COUNT @D131497, PER @D131496, PLU @D131495, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SET, 
   [COORD @D131503, AGR [COUNT @D131502, PER @D131501, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : SET, 
   [COORD @D131505, AGR [COUNT @D131504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : SET, 
   [COORD @D131507, AGR [COUNT @D131506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : SET, 
   [COORD @D131511, AGR [COUNT @D131510, PER @D131509, PLU @D131508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : SET, 
   [COORD @D131517, PAST @D131516, 
      AGR [CASE @D131515, COUNT @D131514, PER @D131513, PLU @D131512, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : SET, 
   [COORD @D131520, AGR [COUNT @D131519, PER @D131518, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SET, 
   [COORD @D131522, AGR [COUNT @D131521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SET, 
   [COORD @D131524, AGR [COUNT @D131523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SET, 
   [COORD @D131528, AGR [COUNT @D131527, PER @D131526, PLU @D131525, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : SET, 
   [COORD @D131534, PAST @D131533, 
      AGR [CASE @D131532, COUNT @D131531, PER @D131530, PLU @D131529, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SET, 
   [COORD @D131537, AGR [COUNT @D131536, PER @D131535, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SET, 
   [COORD @D131539, AGR [COUNT @D131538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SET, 
   [COORD @D131541, AGR [COUNT @D131540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SET, 
   [COORD @D131545, AGR [COUNT @D131544, PER @D131543, PLU @D131542, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : SET, 
   [COORD @D131551, PAST @D131550, 
      AGR [CASE @D131549, COUNT @D131548, PER @D131547, PLU @D131546, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : SET, 
   [COORD @D131554, AGR [COUNT @D131553, PER @D131552, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SET, 
   [COORD @D131556, AGR [COUNT @D131555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SET, 
   [COORD @D131558, AGR [COUNT @D131557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SET, 
   [COORD @D131562, AGR [COUNT @D131561, PER @D131560, PLU @D131559, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : SET, 
   [COORD @D131568, PAST @D131567, 
      AGR [CASE @D131566, COUNT @D131565, PER @D131564, PLU @D131563, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : SET, 
   [COORD @D131571, AGR [COUNT @D131570, PER @D131569, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : SET, 
   [COORD @D131573, AGR [COUNT @D131572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : SET, 
   [COORD @D131575, AGR [COUNT @D131574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : SET, 
   [COORD @D131579, AGR [COUNT @D131578, PER @D131577, PLU @D131576, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, REG -, ARITY 3] : SET, 
   [COORD @D131585, PAST @D131584, 
      AGR [CASE @D131583, COUNT @D131582, PER @D131581, PLU @D131580, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, REG -, 
      ARITY 3] : SET, 
   [COORD @D131588, AGR [COUNT @D131587, PER @D131586, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, 
      REG -, PRT BACK, ARITY 3] : SET, 
   [COORD @D131590, AGR [COUNT @D131589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, 
      REG -, PRT BACK, ARITY 3] : SET, 
   [COORD @D131592, AGR [COUNT @D131591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, 
      REG -, PRT BACK, ARITY 3] : SET, 
   [COORD @D131596, AGR [COUNT @D131595, PER @D131594, PLU @D131593, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_MP, REG -, PRT BACK, ARITY 3] : SET, 
   [COORD @D131602, PAST @D131601, 
      AGR [CASE @D131600, COUNT @D131599, PER @D131598, PLU @D131597, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_MP, REG -, 
      PRT BACK, ARITY 3] : SET, 
   [COORD @D131605, AGR [COUNT @D131604, PER @D131603, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131607, AGR [COUNT @D131606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131609, AGR [COUNT @D131608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131613, AGR [COUNT @D131612, PER @D131611, PLU @D131610, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131619, PAST @D131618, 
      AGR [CASE @D131617, COUNT @D131616, PER @D131615, PLU @D131614, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, ARITY 3] : SET, 
   [COORD @D131622, AGR [COUNT @D131621, PER @D131620, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SET, 
   [COORD @D131624, AGR [COUNT @D131623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SET, 
   [COORD @D131626, AGR [COUNT @D131625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SET, 
   [COORD @D131630, AGR [COUNT @D131629, PER @D131628, PLU @D131627, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : SET, 
   [COORD @D131636, PAST @D131635, 
      AGR [CASE @D131634, COUNT @D131633, PER @D131632, PLU @D131631, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM TO, ARITY 3] : SET, 
   [COORD @D131639, AGR [COUNT @D131638, PER @D131637, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SET, 
   [COORD @D131641, AGR [COUNT @D131640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SET, 
   [COORD @D131643, AGR [COUNT @D131642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SET, 
   [COORD @D131647, AGR [COUNT @D131646, PER @D131645, PLU @D131644, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : SET, 
   [COORD @D131653, PAST @D131652, 
      AGR [CASE @D131651, COUNT @D131650, PER @D131649, PLU @D131648, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SET, 
   [COORD @D131656, AGR [COUNT @D131655, PER @D131654, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SET, 
   [COORD @D131658, AGR [COUNT @D131657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SET, 
   [COORD @D131660, AGR [COUNT @D131659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SET, 
   [COORD @D131664, AGR [COUNT @D131663, PER @D131662, PLU @D131661, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, ARITY 3] : SET, 
   [COORD @D131670, PAST @D131669, 
      AGR [CASE @D131668, COUNT @D131667, PER @D131666, PLU @D131665, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM IN, ARITY 3] : SET, 
   [COORD @D131673, AGR [COUNT @D131672, PER @D131671, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM BESIDE, ARITY 3] : SET, 
   [COORD @D131675, AGR [COUNT @D131674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM BESIDE, ARITY 3] : SET, 
   [COORD @D131677, AGR [COUNT @D131676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM BESIDE, ARITY 3] : SET, 
   [COORD @D131681, AGR [COUNT @D131680, PER @D131679, PLU @D131678, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM BESIDE, ARITY 3] : SET, 
   [COORD @D131687, PAST @D131686, 
      AGR [CASE @D131685, COUNT @D131684, PER @D131683, PLU @D131682, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM BESIDE, ARITY 3] : SET, 
   [COORD @D131690, AGR [COUNT @D131689, PER @D131688, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM AS, ARITY 3] : SET, 
   [COORD @D131692, AGR [COUNT @D131691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM AS, ARITY 3] : SET, 
   [COORD @D131694, AGR [COUNT @D131693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM AS, ARITY 3] : SET, 
   [COORD @D131698, AGR [COUNT @D131697, PER @D131696, PLU @D131695, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT UP, PFORM AS, ARITY 3] : SET, 
   [COORD @D131704, PAST @D131703, 
      AGR [CASE @D131702, COUNT @D131701, PER @D131700, PLU @D131699, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT UP, PFORM AS, ARITY 3] : SET, 
   [COORD @D131707, AGR [COUNT @D131706, PER @D131705, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131709, AGR [COUNT @D131708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131711, AGR [COUNT @D131710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131715, AGR [COUNT @D131714, PER @D131713, PLU @D131712, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131721, PAST @D131720, 
      AGR [CASE @D131719, COUNT @D131718, PER @D131717, PLU @D131716, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131724, AGR [COUNT @D131723, PER @D131722, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131726, AGR [COUNT @D131725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131728, AGR [COUNT @D131727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131732, AGR [COUNT @D131731, PER @D131730, PLU @D131729, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OFF, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131738, PAST @D131737, 
      AGR [CASE @D131736, COUNT @D131735, PER @D131734, PLU @D131733, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT OFF, PFORM AGAINST, ARITY 3] : SET, 
   [COORD @D131741, AGR [COUNT @D131740, PER @D131739, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131743, AGR [COUNT @D131742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131745, AGR [COUNT @D131744, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131749, AGR [COUNT @D131748, PER @D131747, PLU @D131746, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM WITH, ARITY 3] : SET, 
   [COORD @D131755, PAST @D131754, 
      AGR [CASE @D131753, COUNT @D131752, PER @D131751, PLU @D131750, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, ARITY 3] : SET, 
   [COORD @D131758, AGR [COUNT @D131757, PER @D131756, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM FOR, ARITY 3] : SET, 
   [COORD @D131760, AGR [COUNT @D131759, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM FOR, ARITY 3] : SET, 
   [COORD @D131762, AGR [COUNT @D131761, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM FOR, ARITY 3] : SET, 
   [COORD @D131766, AGR [COUNT @D131765, PER @D131764, PLU @D131763, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM FOR, ARITY 3] : SET, 
   [COORD @D131772, PAST @D131771, 
      AGR [CASE @D131770, COUNT @D131769, PER @D131768, PLU @D131767, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM FOR, ARITY 3] : SET, 
   [COORD @D131778, PAST @D131777, AGR [CASE @D131776, COUNT @D131775, 
            PER @D131774, PLU @D131773, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, FIN -, ARITY 3] : SET, 
   [COORD @D131784, PAST @D131783, 
      AGR [CASE @D131782, COUNT @D131781, PER @D131780, PLU @D131779, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, FIN -, 
      ARITY 3] : SET, 
   [COORD @D131790, PAST @D131789, AGR [CASE @D131788, COUNT @D131787, 
            PER @D131786, PLU @D131785, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : SET, 
   [COORD @D131796, PAST @D131795, 
      AGR [CASE @D131794, COUNT @D131793, PER @D131792, PLU @D131791, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, 
      ARITY 3] : SET, 
   [COORD @D131802, PAST @D131801, AGR [CASE @D131800, COUNT @D131799, 
            PER @D131798, PLU @D131797, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : SET, 
   [COORD @D131808, PAST @D131807, 
      AGR [CASE @D131806, COUNT @D131805, PER @D131804, PLU @D131803, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, 
      ARITY 3] : SET, 
   [COORD @D131814, PAST @D131813, AGR [CASE @D131812, COUNT @D131811, 
            PER @D131810, PLU @D131809, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : SET, 
   [COORD @D131820, PAST @D131819, 
      AGR [CASE @D131818, COUNT @D131817, PER @D131816, PLU @D131815, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : SET, 
   [COORD @D131826, PAST @D131825, AGR [CASE @D131824, COUNT @D131823, 
            PER @D131822, PLU @D131821, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : SET, 
   [COORD @D131832, PAST @D131831, 
      AGR [CASE @D131830, COUNT @D131829, PER @D131828, PLU @D131827, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : SET, 
   [COORD @D131838, PAST @D131837, AGR [CASE @D131836, COUNT @D131835, 
            PER @D131834, PLU @D131833, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, REG -, FIN -, ARITY 3] : SET, 
   [COORD @D131844, PAST @D131843, 
      AGR [CASE @D131842, COUNT @D131841, PER @D131840, PLU @D131839, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, REG -, FIN -, 
      ARITY 3] : SET, 
   [COORD @D131850, PAST @D131849, AGR [CASE @D131848, COUNT @D131847, 
            PER @D131846, PLU @D131845, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_MP, REG -, PRT BACK, FIN -, ARITY 3] : SET, 
   [COORD @D131856, PAST @D131855, 
      AGR [CASE @D131854, COUNT @D131853, PER @D131852, PLU @D131851, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      FIN -, ARITY 3] : SET, 
   [COORD @D131862, PAST @D131861, AGR [CASE @D131860, COUNT @D131859, 
            PER @D131858, PLU @D131857, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, FIN -, ARITY 3] : SET, 
   [COORD @D131868, PAST @D131867, 
      AGR [CASE @D131866, COUNT @D131865, PER @D131864, PLU @D131863, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : SET, 
   [COORD @D131874, PAST @D131873, AGR [CASE @D131872, COUNT @D131871, 
            PER @D131870, PLU @D131869, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : SET, 
   [COORD @D131880, PAST @D131879, 
      AGR [CASE @D131878, COUNT @D131877, PER @D131876, PLU @D131875, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, 
      FIN -, ARITY 3] : SET, 
   [COORD @D131886, PAST @D131885, AGR [CASE @D131884, COUNT @D131883, 
            PER @D131882, PLU @D131881, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : SET, 
   [COORD @D131892, PAST @D131891, 
      AGR [CASE @D131890, COUNT @D131889, PER @D131888, PLU @D131887, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM IN, 
      FIN -, ARITY 3] : SET, 
   [COORD @D131898, PAST @D131897, AGR [CASE @D131896, COUNT @D131895, 
            PER @D131894, PLU @D131893, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, FIN -, ARITY 3] : SET, 
   [COORD @D131904, PAST @D131903, 
      AGR [CASE @D131902, COUNT @D131901, PER @D131900, PLU @D131899, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM BESIDE, 
      FIN -, ARITY 3] : SET, 
   [COORD @D131910, PAST @D131909, AGR [CASE @D131908, COUNT @D131907, 
            PER @D131906, PLU @D131905, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM BESIDE, FIN -, ARITY 3] : SET, 
   [COORD @D131916, PAST @D131915, 
      AGR [CASE @D131914, COUNT @D131913, PER @D131912, PLU @D131911, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT UP, 
      PFORM AS, FIN -, ARITY 3] : SET, 
   [COORD @D131922, PAST @D131921, AGR [CASE @D131920, COUNT @D131919, 
            PER @D131918, PLU @D131917, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT UP, PFORM AS, FIN -, ARITY 3] : SET, 
   [COORD @D131928, PAST @D131927, 
      AGR [CASE @D131926, COUNT @D131925, PER @D131924, PLU @D131923, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM AGAINST, 
      FIN -, ARITY 3] : SET, 
   [COORD @D131934, PAST @D131933, AGR [CASE @D131932, COUNT @D131931, 
            PER @D131930, PLU @D131929, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AGAINST, FIN -, ARITY 3] : SET, 
   [COORD @D131940, PAST @D131939, 
      AGR [CASE @D131938, COUNT @D131937, PER @D131936, PLU @D131935, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OFF, 
      PFORM AGAINST, FIN -, ARITY 3] : SET, 
   [COORD @D131946, PAST @D131945, 
      AGR [CASE @D131944, COUNT @D131943, PER @D131942, PLU @D131941, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OFF, 
      PFORM AGAINST, FIN -, ARITY 3] : SET, 
   [COORD @D131952, PAST @D131951, 
      AGR [CASE @D131950, COUNT @D131949, PER @D131948, PLU @D131947, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, FIN -, ARITY 3] : SET, 
   [COORD @D131958, PAST @D131957, 
      AGR [CASE @D131956, COUNT @D131955, PER @D131954, PLU @D131953, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, FIN -, ARITY 3] : SET, 
   [COORD @D131964, PAST @D131963, 
      AGR [CASE @D131962, COUNT @D131961, PER @D131960, PLU @D131959, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM FOR, FIN -, ARITY 3] : SET, 
   [COORD @D131970, PAST @D131969, AGR 
         [CASE @D131968, COUNT @D131967, PER @D131966, PLU @D131965, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM FOR, FIN -, ARITY 3] : SET, 
   [COORD @D131974, AGR [COUNT @D131973, PER @D131972, PLU @D131971, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, PAST +, ARITY 3] : SET, 
   [COORD @D131978, AGR [COUNT @D131977, PER @D131976, PLU @D131975, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PAST +, ARITY 3] : SET, 
   [COORD @D131982, AGR [COUNT @D131981, PER @D131980, PLU @D131979, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 3] : SET, 
   [COORD @D131986, AGR [COUNT @D131985, PER @D131984, PLU @D131983, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : SET, 
   [COORD @D131990, AGR [COUNT @D131989, PER @D131988, PLU @D131987, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : SET, 
   [COORD @D131994, AGR [COUNT @D131993, PER @D131992, PLU @D131991, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, REG -, PAST +, ARITY 3] : SET, 
   [COORD @D131998, AGR [COUNT @D131997, PER @D131996, PLU @D131995, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_MP, REG -, PRT BACK, PAST +, ARITY 3] : SET, 
   [COORD @D132002, 
      AGR [COUNT @D132001, PER @D132000, PLU @D131999, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, PAST +, ARITY 3] : SET, 
   [COORD @D132006, AGR [COUNT @D132005, PER @D132004, PLU @D132003, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, PAST +, ARITY 3] : SET, 
   [COORD @D132010, 
      AGR [COUNT @D132009, PER @D132008, PLU @D132007, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM ON, PAST +, ARITY 3] : SET, 
   [COORD @D132014, AGR [COUNT @D132013, PER @D132012, PLU @D132011, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, PAST +, ARITY 3] : SET, 
   [COORD @D132018, 
      AGR [COUNT @D132017, PER @D132016, PLU @D132015, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM BESIDE, PAST +, ARITY 3] : SET, 
   [COORD @D132022, AGR [COUNT @D132021, PER @D132020, PLU @D132019, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT UP, PFORM AS, PAST +, ARITY 3] : SET, 
   [COORD @D132026, 
      AGR [COUNT @D132025, PER @D132024, PLU @D132023, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM AGAINST, PAST +, ARITY 3] : SET, 
   [COORD @D132030, AGR [COUNT @D132029, PER @D132028, PLU @D132027, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT OFF, PFORM AGAINST, PAST +, ARITY 3] : SET, 
   [COORD @D132034, 
      AGR [COUNT @D132033, PER @D132032, PLU @D132031, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM WITH, PAST +, ARITY 3] : SET, 
   [COORD @D132038, AGR [COUNT @D132037, PER @D132036, PLU @D132035, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM FOR, PAST +, ARITY 3] : SET, 
   [COORD @D132041, 
      AGR [COUNT @D132040, PER @D132039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SET, 
   
   [COORD @D132043, AGR [COUNT @D132042, N +, V -, BAR 2, NFORM NORM, CASE 
               NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SET, 
   [COORD @D132045, AGR [COUNT @D132044, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SET, 
   [COORD @D132049, AGR [COUNT @D132048, PER @D132047, PLU @D132046, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SET, 
   [COORD @D132055, PAST @D132054, AGR [CASE @D132053, COUNT @D132052, 
            PER @D132051, PLU @D132050, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SET, 
   [COORD @D132058, AGR [COUNT @D132057, PER @D132056, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT OUT, ARITY 2] : SET, 
   [COORD @D132060, AGR [COUNT @D132059, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT OUT, ARITY 2] : SET, 
   [COORD @D132062, AGR [COUNT @D132061, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT OUT, ARITY 2] : SET, 
   [COORD @D132066, AGR [COUNT @D132065, PER @D132064, PLU @D132063, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PRT OUT, ARITY 2] : SET, 
   [COORD @D132072, PAST @D132071, 
      AGR [CASE @D132070, COUNT @D132069, PER @D132068, PLU @D132067, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT OUT, ARITY 2] : SET, 
   [COORD @D132075, AGR [COUNT @D132074, PER @D132073, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ABOUT, ARITY 2] : SET, 
   [COORD @D132077, AGR [COUNT @D132076, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ABOUT, ARITY 2] : SET, 
   [COORD @D132079, AGR [COUNT @D132078, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ABOUT, ARITY 2] : SET, 
   [COORD @D132083, AGR [COUNT @D132082, PER @D132081, PLU @D132080, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP ABOUT, ARITY 2] : SET, 
   [COORD @D132089, PAST @D132088, 
      AGR [CASE @D132087, COUNT @D132086, PER @D132085, PLU @D132084, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP ABOUT, ARITY 2] : SET, 
   [COORD @D132092, AGR [COUNT @D132091, PER @D132090, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SET, 
   [COORD @D132094, AGR [COUNT @D132093, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SET, 
   [COORD @D132096, AGR [COUNT @D132095, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SET, 
   [COORD @D132100, AGR [COUNT @D132099, PER @D132098, PLU @D132097, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : SET, 
   [COORD @D132106, PAST @D132105, AGR [CASE @D132104, COUNT @D132103, 
            PER @D132102, PLU @D132101, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : SET, 
   [COORD @D132109, 
      AGR [COUNT @D132108, PER @D132107, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM AS, ARITY 2] : SET, 
   [COORD @D132111, AGR [COUNT @D132110, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AS, ARITY 2] : SET, 
   [COORD @D132113, AGR [COUNT @D132112, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AS, ARITY 2] : SET, 
   [COORD @D132117, AGR [COUNT @D132116, PER @D132115, PLU @D132114, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM AS, ARITY 2] : SET, 
   [COORD @D132123, PAST @D132122, 
      AGR [CASE @D132121, COUNT @D132120, PER @D132119, PLU @D132118, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM AS, ARITY 2] : SET, 
   [COORD @D132126, AGR [COUNT @D132125, PER @D132124, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SET, 
   [COORD @D132128, AGR [COUNT @D132127, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SET, 
   [COORD @D132130, AGR [COUNT @D132129, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SET, 
   [COORD @D132134, AGR [COUNT @D132133, PER @D132132, PLU @D132131, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, ARITY 2] : SET, 
   [COORD @D132140, PAST @D132139, 
      AGR [CASE @D132138, COUNT @D132137, PER @D132136, PLU @D132135, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : SET, 
   [COORD @D132143, AGR [COUNT @D132142, PER @D132141, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SET, 
   [COORD @D132145, AGR [COUNT @D132144, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SET, 
   [COORD @D132147, AGR [COUNT @D132146, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SET, 
   [COORD @D132151, AGR [COUNT @D132150, PER @D132149, PLU @D132148, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : SET, 
   [COORD @D132157, PAST @D132156, 
      AGR [CASE @D132155, COUNT @D132154, PER @D132153, PLU @D132152, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : SET, 
   [COORD @D132160, AGR [COUNT @D132159, PER @D132158, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SET, 
   [COORD @D132162, AGR [COUNT @D132161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SET, 
   [COORD @D132164, AGR [COUNT @D132163, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SET, 
   [COORD @D132168, AGR [COUNT @D132167, PER @D132166, PLU @D132165, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SET, 
   [COORD @D132174, PAST @D132173, 
      AGR [CASE @D132172, COUNT @D132171, PER @D132170, PLU @D132169, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SET, 
   [COORD @D132177, AGR [COUNT @D132176, PER @D132175, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SET, 
   [COORD @D132179, AGR [COUNT @D132178, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SET, 
   [COORD @D132181, AGR [COUNT @D132180, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SET, 
   [COORD @D132185, AGR [COUNT @D132184, PER @D132183, PLU @D132182, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : SET, 
   [COORD @D132191, PAST @D132190, 
      AGR [CASE @D132189, COUNT @D132188, PER @D132187, PLU @D132186, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : SET, 
   [COORD @D132194, AGR [COUNT @D132193, PER @D132192, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SET, 
   [COORD @D132196, AGR [COUNT @D132195, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SET, 
   [COORD @D132198, AGR [COUNT @D132197, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SET, 
   [COORD @D132202, AGR [COUNT @D132201, PER @D132200, PLU @D132199, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : SET, 
   [COORD @D132208, PAST @D132207, 
      AGR [CASE @D132206, COUNT @D132205, PER @D132204, PLU @D132203, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SET, 
   [COORD @D132211, AGR [COUNT @D132210, PER @D132209, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BY, ARITY 2] : SET, 
   [COORD @D132213, AGR [COUNT @D132212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BY, ARITY 2] : SET, 
   [COORD @D132215, AGR [COUNT @D132214, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BY, ARITY 2] : SET, 
   [COORD @D132219, AGR [COUNT @D132218, PER @D132217, PLU @D132216, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BY, ARITY 2] : SET, 
   [COORD @D132225, PAST @D132224, 
      AGR [CASE @D132223, COUNT @D132222, PER @D132221, PLU @D132220, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BY, 
      ARITY 2] : SET, 
   [COORD @D132228, AGR [COUNT @D132227, PER @D132226, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : SET, 
   [COORD @D132230, AGR [COUNT @D132229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : SET, 
   [COORD @D132232, AGR [COUNT @D132231, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : SET, 
   [COORD @D132236, AGR [COUNT @D132235, PER @D132234, PLU @D132233, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : SET, 
   [COORD @D132242, PAST @D132241, 
      AGR [CASE @D132240, COUNT @D132239, PER @D132238, PLU @D132237, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : SET, 
   [COORD @D132245, AGR [COUNT @D132244, PER @D132243, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : SET, 
   [COORD @D132247, AGR [COUNT @D132246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : SET, 
   [COORD @D132249, AGR [COUNT @D132248, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : SET, 
   [COORD @D132253, AGR [COUNT @D132252, PER @D132251, PLU @D132250, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASIDE, ARITY 2] : SET, 
   [COORD @D132259, PAST @D132258, 
      AGR [CASE @D132257, COUNT @D132256, PER @D132255, PLU @D132254, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT ASIDE, ARITY 2] : SET, 
   [COORD @D132265, PAST @D132264, AGR [CASE @D132263, COUNT @D132262, 
            PER @D132261, PLU @D132260, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SET, 
   [COORD @D132271, PAST @D132270, 
      AGR [CASE @D132269, COUNT @D132268, PER @D132267, PLU @D132266, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132277, PAST @D132276, AGR [CASE @D132275, COUNT @D132274, 
            PER @D132273, PLU @D132272, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PRT OUT, FIN -, ARITY 2] : SET, 
   [COORD @D132283, PAST @D132282, 
      AGR [CASE @D132281, COUNT @D132280, PER @D132279, PLU @D132278, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP ABOUT, 
      FIN -, ARITY 2] : SET, 
   [COORD @D132289, PAST @D132288, AGR [CASE @D132287, COUNT @D132286, 
            PER @D132285, PLU @D132284, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ON, FIN -, ARITY 2] : SET, 
   [COORD @D132295, PAST @D132294, 
      AGR [CASE @D132293, COUNT @D132292, PER @D132291, PLU @D132290, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132301, PAST @D132300, AGR [CASE @D132299, COUNT @D132298, 
            PER @D132297, PLU @D132296, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM AS, FIN -, ARITY 2] : SET, 
   [COORD @D132307, PAST @D132306, 
      AGR [CASE @D132305, COUNT @D132304, PER @D132303, PLU @D132302, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ABOUT, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132313, PAST @D132312, AGR [CASE @D132311, COUNT @D132310, 
            PER @D132309, PLU @D132308, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ABOUT, FIN -, ARITY 2] : SET, 
   [COORD @D132319, PAST @D132318, 
      AGR [CASE @D132317, COUNT @D132316, PER @D132315, PLU @D132314, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132325, PAST @D132324, AGR [CASE @D132323, COUNT @D132322, 
            PER @D132321, PLU @D132320, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : SET, 
   [COORD @D132331, PAST @D132330, 
      AGR [CASE @D132329, COUNT @D132328, PER @D132327, PLU @D132326, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132337, PAST @D132336, AGR [CASE @D132335, COUNT @D132334, 
            PER @D132333, PLU @D132332, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SET, 
   [COORD @D132343, PAST @D132342, 
      AGR [CASE @D132341, COUNT @D132340, PER @D132339, PLU @D132338, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132349, PAST @D132348, AGR [CASE @D132347, COUNT @D132346, 
            PER @D132345, PLU @D132344, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : SET, 
   [COORD @D132355, PAST @D132354, 
      AGR [CASE @D132353, COUNT @D132352, PER @D132351, PLU @D132350, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132361, PAST @D132360, AGR [CASE @D132359, COUNT @D132358, 
            PER @D132357, PLU @D132356, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : SET, 
   [COORD @D132367, PAST @D132366, 
      AGR [CASE @D132365, COUNT @D132364, PER @D132363, PLU @D132362, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BY, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132373, PAST @D132372, AGR [CASE @D132371, COUNT @D132370, 
            PER @D132369, PLU @D132368, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BY, FIN -, ARITY 2] : SET, 
   [COORD @D132379, PAST @D132378, 
      AGR [CASE @D132377, COUNT @D132376, PER @D132375, PLU @D132374, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132385, PAST @D132384, AGR [CASE @D132383, COUNT @D132382, 
            PER @D132381, PLU @D132380, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : SET, 
   [COORD @D132391, PAST @D132390, 
      AGR [CASE @D132389, COUNT @D132388, PER @D132387, PLU @D132386, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT ASIDE, FIN -, 
      ARITY 2] : SET, 
   [COORD @D132397, PAST @D132396, AGR [CASE @D132395, COUNT @D132394, 
            PER @D132393, PLU @D132392, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT ASIDE, FIN -, ARITY 2] : SET, 
   [COORD @D132401, 
      AGR [COUNT @D132400, PER @D132399, PLU @D132398, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : SET, 
   [COORD @D132405, AGR [COUNT @D132404, PER @D132403, PLU @D132402, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PRT OUT, PAST +, ARITY 2] : SET, 
   [COORD @D132409, 
      AGR [COUNT @D132408, PER @D132407, PLU @D132406, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP ABOUT, 
      PAST +, ARITY 2] : SET, 
   [COORD @D132413, AGR [COUNT @D132412, PER @D132411, PLU @D132410, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, PAST +, ARITY 2] : SET, 
   [COORD @D132417, AGR [COUNT @D132416, PER @D132415, PLU @D132414, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM AS, PAST +, ARITY 2] : SET, 
   [COORD @D132421, 
      AGR [COUNT @D132420, PER @D132419, PLU @D132418, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, PAST +, ARITY 2] : SET, 
   [COORD @D132425, AGR [COUNT @D132424, PER @D132423, PLU @D132422, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : SET, 
   [COORD @D132429, AGR [COUNT @D132428, PER @D132427, PLU @D132426, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SET, 
   [COORD @D132433, AGR [COUNT @D132432, PER @D132431, PLU @D132430, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : SET, 
   [COORD @D132437, AGR [COUNT @D132436, PER @D132435, PLU @D132434, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : SET, 
   [COORD @D132441, AGR [COUNT @D132440, PER @D132439, PLU @D132438, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BY, PAST +, ARITY 2] : SET, 
   [COORD @D132445, AGR [COUNT @D132444, PER @D132443, PLU @D132442, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT BACK, PAST +, ARITY 2] : SET, 
   [COORD @D132449, AGR [COUNT @D132448, PER @D132447, PLU @D132446, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT ASIDE, PAST +, ARITY 2] : SET, 
   [COORD @D132452, AGR [COUNT @D132451, PER @D132450, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SET, 
   [COORD @D132454, AGR [COUNT @D132453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SET, 
   [COORD @D132456, AGR [COUNT @D132455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SET, 
   [COORD @D132460, AGR [COUNT @D132459, PER @D132458, PLU @D132457, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SET, 
   [COORD @D132466, PAST @D132465, 
      AGR [CASE @D132464, COUNT @D132463, PER @D132462, PLU @D132461, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SET, 
   [COORD @D132469, AGR [COUNT @D132468, PER @D132467, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SET, 
   [COORD @D132471, AGR [COUNT @D132470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SET, 
   [COORD @D132473, AGR [COUNT @D132472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SET, 
   [COORD @D132477, AGR [COUNT @D132476, PER @D132475, PLU @D132474, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : SET, 
   [COORD @D132483, PAST @D132482, 
      AGR [CASE @D132481, COUNT @D132480, PER @D132479, PLU @D132478, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : SET, 
   [COORD @D132486, AGR [COUNT @D132485, PER @D132484, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : SET, 
   [COORD @D132488, AGR [COUNT @D132487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : SET, 
   [COORD @D132490, AGR [COUNT @D132489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : SET, 
   [COORD @D132494, AGR [COUNT @D132493, PER @D132492, PLU @D132491, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, ARITY 1] : SET, 
   [COORD @D132500, PAST @D132499, 
      AGR [CASE @D132498, COUNT @D132497, PER @D132496, PLU @D132495, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, ARITY 1] : SET, 
   [COORD @D132503, AGR [COUNT @D132502, PER @D132501, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SET, 
   [COORD @D132505, AGR [COUNT @D132504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SET, 
   [COORD @D132507, AGR [COUNT @D132506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SET, 
   [COORD @D132511, AGR [COUNT @D132510, PER @D132509, PLU @D132508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SET, 
   [COORD @D132517, PAST @D132516, 
      AGR [CASE @D132515, COUNT @D132514, PER @D132513, PLU @D132512, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SET, 
   [COORD @D132520, AGR [COUNT @D132519, PER @D132518, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SET, 
   [COORD @D132522, AGR [COUNT @D132521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SET, 
   [COORD @D132524, AGR [COUNT @D132523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SET, 
   [COORD @D132528, AGR [COUNT @D132527, PER @D132526, PLU @D132525, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : SET, 
   [COORD @D132534, PAST @D132533, 
      AGR [CASE @D132532, COUNT @D132531, PER @D132530, PLU @D132529, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : SET, 
   [COORD @D132537, AGR [COUNT @D132536, PER @D132535, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SET, 
   [COORD @D132539, AGR [COUNT @D132538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SET, 
   [COORD @D132541, AGR [COUNT @D132540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SET, 
   [COORD @D132545, AGR [COUNT @D132544, PER @D132543, PLU @D132542, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : SET, 
   [COORD @D132551, PAST @D132550, 
      AGR [CASE @D132549, COUNT @D132548, PER @D132547, PLU @D132546, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : SET, 
   [COORD @D132554, AGR [COUNT @D132553, PER @D132552, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : SET, 
   [COORD @D132556, AGR [COUNT @D132555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : SET, 
   [COORD @D132558, AGR [COUNT @D132557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT FORTH, ARITY 1] : SET, 
   [COORD @D132562, AGR [COUNT @D132561, PER @D132560, PLU @D132559, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORTH, ARITY 1] : SET, 
   [COORD @D132568, PAST @D132567, 
      AGR [CASE @D132566, COUNT @D132565, PER @D132564, PLU @D132563, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORTH, ARITY 1] : SET, 
   [COORD @D132571, AGR [COUNT @D132570, PER @D132569, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SET, 
   [COORD @D132573, AGR [COUNT @D132572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SET, 
   [COORD @D132575, AGR [COUNT @D132574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SET, 
   [COORD @D132579, AGR [COUNT @D132578, PER @D132577, PLU @D132576, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : SET, 
   [COORD @D132585, PAST @D132584, 
      AGR [CASE @D132583, COUNT @D132582, PER @D132581, PLU @D132580, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : SET, 
   [COORD @D132588, AGR [COUNT @D132587, PER @D132586, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : SET, 
   [COORD @D132590, AGR [COUNT @D132589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : SET, 
   [COORD @D132592, AGR [COUNT @D132591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : SET, 
   [COORD @D132596, AGR [COUNT @D132595, PER @D132594, PLU @D132593, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, ARITY 1] : SET, 
   [COORD @D132602, PAST @D132601, 
      AGR [CASE @D132600, COUNT @D132599, PER @D132598, PLU @D132597, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, ARITY 1] : SET, 
   [COORD @D132605, AGR [COUNT @D132604, PER @D132603, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : SET, 
   [COORD @D132607, AGR [COUNT @D132606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : SET, 
   [COORD @D132609, AGR [COUNT @D132608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : SET, 
   [COORD @D132613, AGR [COUNT @D132612, PER @D132611, PLU @D132610, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : SET, 
   [COORD @D132619, PAST @D132618, 
      AGR [CASE @D132617, COUNT @D132616, PER @D132615, PLU @D132614, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, ARITY 1] : SET, 
   [COORD @D132622, AGR [COUNT @D132621, PER @D132620, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : SET, 
   [COORD @D132624, AGR [COUNT @D132623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : SET, 
   [COORD @D132626, AGR [COUNT @D132625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ASIDE, ARITY 1] : SET, 
   [COORD @D132630, AGR [COUNT @D132629, PER @D132628, PLU @D132627, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASIDE, ARITY 1] : SET, 
   [COORD @D132636, PAST @D132635, 
      AGR [CASE @D132634, COUNT @D132633, PER @D132632, PLU @D132631, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ASIDE, ARITY 1] : SET, 
   [COORD @D132642, PAST @D132641, AGR [CASE @D132640, COUNT @D132639, 
            PER @D132638, PLU @D132637, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : SET, 
   [COORD @D132648, PAST @D132647, 
      AGR [CASE @D132646, COUNT @D132645, PER @D132644, PLU @D132643, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      FIN -, ARITY 1] : SET, 
   [COORD @D132654, PAST @D132653, AGR [CASE @D132652, COUNT @D132651, 
            PER @D132650, PLU @D132649, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, FIN -, ARITY 1] : SET, 
   [COORD @D132660, PAST @D132659, 
      AGR [CASE @D132658, COUNT @D132657, PER @D132656, PLU @D132655, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : SET, 
   [COORD @D132666, PAST @D132665, AGR [CASE @D132664, COUNT @D132663, 
            PER @D132662, PLU @D132661, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : SET, 
   [COORD @D132672, PAST @D132671, 
      AGR [CASE @D132670, COUNT @D132669, PER @D132668, PLU @D132667, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      FIN -, ARITY 1] : SET, 
   [COORD @D132678, PAST @D132677, AGR [CASE @D132676, COUNT @D132675, 
            PER @D132674, PLU @D132673, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT FORTH, FIN -, ARITY 1] : SET, 
   [COORD @D132684, PAST @D132683, 
      AGR [CASE @D132682, COUNT @D132681, PER @D132680, PLU @D132679, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      FIN -, ARITY 1] : SET, 
   [COORD @D132690, PAST @D132689, AGR [CASE @D132688, COUNT @D132687, 
            PER @D132686, PLU @D132685, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, FIN -, ARITY 1] : SET, 
   [COORD @D132696, PAST @D132695, 
      AGR [CASE @D132694, COUNT @D132693, PER @D132692, PLU @D132691, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT BACK, 
      FIN -, ARITY 1] : SET, 
   [COORD @D132702, PAST @D132701, AGR [CASE @D132700, COUNT @D132699, 
            PER @D132698, PLU @D132697, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ASIDE, FIN -, ARITY 1] : SET, 
   [COORD @D132706, 
      AGR [COUNT @D132705, PER @D132704, PLU @D132703, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : SET, 
   [COORD @D132710, AGR [COUNT @D132709, PER @D132708, PLU @D132707, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SET, 
   [COORD @D132714, 
      AGR [COUNT @D132713, PER @D132712, PLU @D132711, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, PAST +, ARITY 1] : SET, 
   [COORD @D132718, AGR [COUNT @D132717, PER @D132716, PLU @D132715, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, PAST +, ARITY 1] : SET, 
   [COORD @D132722, 
      AGR [COUNT @D132721, PER @D132720, PLU @D132719, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : SET, 
   [COORD @D132726, AGR [COUNT @D132725, PER @D132724, PLU @D132723, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, PAST +, ARITY 1] : SET, 
   [COORD @D132730, 
      AGR [COUNT @D132729, PER @D132728, PLU @D132727, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT FORTH, PAST +, ARITY 1] : SET, 
   [COORD @D132734, AGR [COUNT @D132733, PER @D132732, PLU @D132731, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, PAST +, ARITY 1] : SET, 
   [COORD @D132738, 
      AGR [COUNT @D132737, PER @D132736, PLU @D132735, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, PAST +, ARITY 1] : SET, 
   [COORD @D132742, AGR [COUNT @D132741, PER @D132740, PLU @D132739, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, PAST +, ARITY 1] : SET, 
   [COORD @D132746, 
      AGR [COUNT @D132745, PER @D132744, PLU @D132743, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ASIDE, PAST +, ARITY 1] : SET.

WORD sets : 
   [COORD @D132758, DEMON @D132757, REFL @D132756, PRD @D132755, 
      CASE @D132754, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SET, 
   [COORD @D132760, AGR [COUNT @D132759, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SET, 
   [COORD @D132762, AGR [COUNT @D132761, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SET, 
   [COORD @D132764, AGR [COUNT @D132763, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SET, 
   [COORD @D132766, AGR [COUNT @D132765, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132768, 
      AGR [COUNT @D132767, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132770, 
      AGR [COUNT @D132769, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132772, 
      AGR [COUNT @D132771, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_MP, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132774, 
      AGR [COUNT @D132773, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SET, 
   [COORD @D132776, AGR [COUNT @D132775, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132778, AGR [COUNT @D132777, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132780, AGR [COUNT @D132779, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132782, AGR [COUNT @D132781, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM BESIDE, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132784, AGR [COUNT @D132783, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT UP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132786, AGR [COUNT @D132785, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132788, AGR [COUNT @D132787, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OFF, PFORM AGAINST, AUX -, INV -, 
      NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132790, AGR [COUNT @D132789, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132792, AGR [COUNT @D132791, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132794, AGR [COUNT @D132793, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132796, 
      AGR [COUNT @D132795, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132798, 
      AGR [COUNT @D132797, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SET, 
   [COORD @D132800, AGR [COUNT @D132799, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132802, AGR [COUNT @D132801, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132804, AGR [COUNT @D132803, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132806, AGR [COUNT @D132805, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132808, AGR [COUNT @D132807, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132810, AGR [COUNT @D132809, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132812, AGR [COUNT @D132811, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132814, AGR [COUNT @D132813, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132816, AGR [COUNT @D132815, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132818, AGR [COUNT @D132817, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132820, AGR [COUNT @D132819, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132822, 
      AGR [COUNT @D132821, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132824, 
      AGR [COUNT @D132823, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132826, 
      AGR [COUNT @D132825, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132828, 
      AGR [COUNT @D132827, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132830, 
      AGR [COUNT @D132829, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132832, 
      AGR [COUNT @D132831, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132834, 
      AGR [COUNT @D132833, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132836, 
      AGR [COUNT @D132835, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132838, 
      AGR [COUNT @D132837, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET, 
   [COORD @D132840, 
      AGR [COUNT @D132839, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SET.

WORD setting : 
   [COORD @D132858, REFL @D132857, COUNT @D132856, PRD @D132855, 
      CASE @D132854, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SETTING, 
   [COORD @D132864, PRD @D132863, 
      AGR [CASE @D132862, COUNT @D132861, PER @D132860, PLU @D132859, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   
   [COORD @D132870, PRD @D132869, AGR [CASE @D132868, COUNT @D132867, PER 
               @D132866, PLU @D132865, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132876, PRD @D132875, 
      AGR [CASE @D132874, COUNT @D132873, PER @D132872, PLU @D132871, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   
   [COORD @D132882, PRD @D132881, AGR [CASE @D132880, COUNT @D132879, PER 
               @D132878, PLU @D132877, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132888, PRD @D132887, 
      AGR [CASE @D132886, COUNT @D132885, PER @D132884, PLU @D132883, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SET, 
   [COORD @D132894, PRD @D132893, AGR [CASE @D132892, COUNT @D132891, 
            PER @D132890, PLU @D132889, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132900, PRD @D132899, 
      AGR [CASE @D132898, COUNT @D132897, PER @D132896, PLU @D132895, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_MP, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132906, PRD @D132905, AGR [CASE @D132904, COUNT @D132903, 
            PER @D132902, PLU @D132901, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132912, PRD @D132911, 
      AGR [CASE @D132910, COUNT @D132909, PER @D132908, PLU @D132907, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132918, PRD @D132917, AGR [CASE @D132916, COUNT @D132915, 
            PER @D132914, PLU @D132913, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132924, PRD @D132923, 
      AGR [CASE @D132922, COUNT @D132921, PER @D132920, PLU @D132919, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132930, PRD @D132929, AGR [CASE @D132928, COUNT @D132927, 
            PER @D132926, PLU @D132925, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM BESIDE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132936, PRD @D132935, 
      AGR [CASE @D132934, COUNT @D132933, PER @D132932, PLU @D132931, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT UP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132942, PRD @D132941, AGR [CASE @D132940, COUNT @D132939, 
            PER @D132938, PLU @D132937, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132948, PRD @D132947, 
      AGR [CASE @D132946, COUNT @D132945, PER @D132944, PLU @D132943, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OFF, PFORM AGAINST, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132954, PRD @D132953, AGR [CASE @D132952, COUNT @D132951, 
            PER @D132950, PLU @D132949, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132960, PRD @D132959, 
      AGR [CASE @D132958, COUNT @D132957, PER @D132956, PLU @D132955, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132966, PRD @D132965, AGR [CASE @D132964, COUNT @D132963, 
            PER @D132962, PLU @D132961, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132972, PRD @D132971, 
      AGR [CASE @D132970, COUNT @D132969, PER @D132968, PLU @D132967, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D132978, PRD @D132977, AGR [CASE @D132976, COUNT @D132975, 
            PER @D132974, PLU @D132973, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, 
      PREP ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132984, PRD @D132983, 
      AGR [CASE @D132982, COUNT @D132981, PER @D132980, PLU @D132979, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SET, 
   [COORD @D132990, PRD @D132989, AGR [CASE @D132988, COUNT @D132987, 
            PER @D132986, PLU @D132985, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D132996, PRD @D132995, 
      AGR [CASE @D132994, COUNT @D132993, PER @D132992, PLU @D132991, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SET, 
   [COORD @D133002, PRD @D133001, AGR [CASE @D133000, COUNT @D132999, 
            PER @D132998, PLU @D132997, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133008, PRD @D133007, 
      AGR [CASE @D133006, COUNT @D133005, PER @D133004, PLU @D133003, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SET, 
   [COORD @D133014, PRD @D133013, AGR [CASE @D133012, COUNT @D133011, 
            PER @D133010, PLU @D133009, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133020, PRD @D133019, 
      AGR [CASE @D133018, COUNT @D133017, PER @D133016, PLU @D133015, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SET, 
   [COORD @D133026, PRD @D133025, AGR [CASE @D133024, COUNT @D133023, 
            PER @D133022, PLU @D133021, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133032, PRD @D133031, 
      AGR [CASE @D133030, COUNT @D133029, PER @D133028, PLU @D133027, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SET, 
   [COORD @D133038, PRD @D133037, AGR [CASE @D133036, COUNT @D133035, 
            PER @D133034, PLU @D133033, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ASIDE, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133044, PRD @D133043, 
      AGR [CASE @D133042, COUNT @D133041, PER @D133040, PLU @D133039, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SET, 
   [COORD @D133050, PRD @D133049, AGR [CASE @D133048, COUNT @D133047, 
            PER @D133046, PLU @D133045, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133056, PRD @D133055, 
      AGR [CASE @D133054, COUNT @D133053, PER @D133052, PLU @D133051, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D133062, PRD @D133061, AGR [CASE @D133060, COUNT @D133059, 
            PER @D133058, PLU @D133057, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133068, PRD @D133067, 
      AGR [CASE @D133066, COUNT @D133065, PER @D133064, PLU @D133063, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D133074, PRD @D133073, AGR [CASE @D133072, COUNT @D133071, 
            PER @D133070, PLU @D133069, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133080, PRD @D133079, 
      AGR [CASE @D133078, COUNT @D133077, PER @D133076, PLU @D133075, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT FORTH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D133086, PRD @D133085, AGR [CASE @D133084, COUNT @D133083, 
            PER @D133082, PLU @D133081, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133092, PRD @D133091, 
      AGR [CASE @D133090, COUNT @D133089, PER @D133088, PLU @D133087, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET, 
   [COORD @D133098, PRD @D133097, AGR [CASE @D133096, COUNT @D133095, 
            PER @D133094, PLU @D133093, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SET, 
   [COORD @D133104, PRD @D133103, 
      AGR [CASE @D133102, COUNT @D133101, PER @D133100, PLU @D133099, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SET.

WORD settings : 
   [COORD @D133126, DEMON @D133125, REFL @D133124, PRD @D133123, 
      CASE @D133122, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SETTING.

WORD settle : 
   [COORD @D133137, AGR [COUNT @D133136, PER @D133135, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SETTLE, 
   [COORD @D133139, AGR [COUNT @D133138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SETTLE, 
   [COORD @D133141, AGR [COUNT @D133140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SETTLE, 
   [COORD @D133145, AGR [COUNT @D133144, PER @D133143, PLU @D133142, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SETTLE, 
   [COORD @D133151, PAST @D133150, AGR 
         [CASE @D133149, COUNT @D133148, PER @D133147, PLU @D133146, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      ARITY 3] : SETTLE, 
   [COORD @D133154, AGR [COUNT @D133153, PER @D133152, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : SETTLE, 
   [COORD @D133156, AGR [COUNT @D133155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : SETTLE, 
   [COORD @D133158, AGR [COUNT @D133157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : SETTLE, 
   [COORD @D133162, AGR [COUNT @D133161, PER @D133160, PLU @D133159, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : SETTLE, 
   [COORD @D133168, PAST @D133167, 
      AGR [CASE @D133166, COUNT @D133165, PER @D133164, PLU @D133163, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM UPON, ARITY 3] : SETTLE, 
   [COORD @D133171, AGR [COUNT @D133170, PER @D133169, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SETTLE, 
   [COORD @D133173, AGR [COUNT @D133172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SETTLE, 
   [COORD @D133175, AGR [COUNT @D133174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SETTLE, 
   [COORD @D133179, AGR [COUNT @D133178, PER @D133177, PLU @D133176, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : SETTLE, 
   [COORD @D133185, PAST @D133184, 
      AGR [CASE @D133183, COUNT @D133182, PER @D133181, PLU @D133180, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : SETTLE, 
   [COORD @D133188, AGR [COUNT @D133187, PER @D133186, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SETTLE, 
   [COORD @D133190, AGR [COUNT @D133189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SETTLE, 
   [COORD @D133192, AGR [COUNT @D133191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SETTLE, 
   [COORD @D133196, AGR [COUNT @D133195, PER @D133194, PLU @D133193, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SETTLE, 
   [COORD @D133202, PAST @D133201, AGR [CASE @D133200, COUNT @D133199, 
            PER @D133198, PLU @D133197, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : SETTLE, 
   [COORD @D133205, AGR [COUNT @D133204, PER @D133203, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SETTLE, 
   [COORD @D133207, AGR [COUNT @D133206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SETTLE, 
   [COORD @D133209, AGR [COUNT @D133208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SETTLE, 
   [COORD @D133213, AGR [COUNT @D133212, PER @D133211, PLU @D133210, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : SETTLE, 
   [COORD @D133219, PAST @D133218, AGR [CASE @D133217, COUNT @D133216, 
            PER @D133215, PLU @D133214, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : SETTLE, 
   [COORD @D133222, AGR [COUNT @D133221, PER @D133220, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SETTLE, 
   [COORD @D133224, AGR [COUNT @D133223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SETTLE, 
   [COORD @D133226, AGR [COUNT @D133225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SETTLE, 
   [COORD @D133230, AGR [COUNT @D133229, PER @D133228, PLU @D133227, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SETTLE, 
   [COORD @D133236, PAST @D133235, AGR [CASE @D133234, COUNT @D133233, 
            PER @D133232, PLU @D133231, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : SETTLE, 
   [COORD @D133239, AGR [COUNT @D133238, PER @D133237, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SETTLE, 
   [COORD @D133241, AGR [COUNT @D133240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SETTLE, 
   [COORD @D133243, AGR [COUNT @D133242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SETTLE, 
   [COORD @D133247, AGR [COUNT @D133246, PER @D133245, PLU @D133244, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SETTLE, 
   [COORD @D133253, PAST @D133252, AGR [CASE @D133251, COUNT @D133250, 
            PER @D133249, PLU @D133248, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SETTLE, 
   [COORD @D133256, AGR [COUNT @D133255, PER @D133254, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : SETTLE, 
   [COORD @D133258, AGR [COUNT @D133257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : SETTLE, 
   [COORD @D133260, AGR [COUNT @D133259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : SETTLE, 
   [COORD @D133264, AGR [COUNT @D133263, PER @D133262, PLU @D133261, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : SETTLE, 
   [COORD @D133270, PAST @D133269, AGR [CASE @D133268, COUNT @D133267, 
            PER @D133266, PLU @D133265, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : SETTLE, 
   [COORD @D133273, AGR [COUNT @D133272, PER @D133271, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133275, AGR [COUNT @D133274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133277, AGR [COUNT @D133276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133281, AGR [COUNT @D133280, PER @D133279, PLU @D133278, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133287, PAST @D133286, 
      AGR [CASE @D133285, COUNT @D133284, PER @D133283, PLU @D133282, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133290, AGR [COUNT @D133289, PER @D133288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133292, AGR [COUNT @D133291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133294, AGR [COUNT @D133293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133298, AGR [COUNT @D133297, PER @D133296, PLU @D133295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133304, PAST @D133303, 
      AGR [CASE @D133302, COUNT @D133301, PER @D133300, PLU @D133299, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM WITH, ARITY 2] : SETTLE, 
   [COORD @D133307, AGR [COUNT @D133306, PER @D133305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : SETTLE, 
   [COORD @D133309, AGR [COUNT @D133308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : SETTLE, 
   [COORD @D133311, AGR [COUNT @D133310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : SETTLE, 
   [COORD @D133315, AGR [COUNT @D133314, PER @D133313, PLU @D133312, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : SETTLE, 
   [COORD @D133321, PAST @D133320, 
      AGR [CASE @D133319, COUNT @D133318, PER @D133317, PLU @D133316, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : SETTLE, 
   [COORD @D133324, AGR [COUNT @D133323, PER @D133322, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : SETTLE, 
   [COORD @D133326, AGR [COUNT @D133325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : SETTLE, 
   [COORD @D133328, AGR [COUNT @D133327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : SETTLE, 
   [COORD @D133332, AGR [COUNT @D133331, PER @D133330, PLU @D133329, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT DOWN, PFORM TO, ARITY 2] : SETTLE, 
   [COORD @D133338, PAST @D133337, 
      AGR [CASE @D133336, COUNT @D133335, PER @D133334, PLU @D133333, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : SETTLE, 
   [COORD @D133341, AGR [COUNT @D133340, PER @D133339, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SETTLE, 
   [COORD @D133343, AGR [COUNT @D133342, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SETTLE, 
   [COORD @D133345, AGR [COUNT @D133344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SETTLE, 
   [COORD @D133349, AGR [COUNT @D133348, PER @D133347, PLU @D133346, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OVER, ARITY 2] : SETTLE, 
   [COORD @D133355, PAST @D133354, 
      AGR [CASE @D133353, COUNT @D133352, PER @D133351, PLU @D133350, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : SETTLE, 
   [COORD @D133358, AGR [COUNT @D133357, PER @D133356, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SETTLE, 
   [COORD @D133360, AGR [COUNT @D133359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SETTLE, 
   [COORD @D133362, AGR [COUNT @D133361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SETTLE, 
   [COORD @D133366, AGR [COUNT @D133365, PER @D133364, PLU @D133363, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : SETTLE, 
   [COORD @D133372, PAST @D133371, 
      AGR [CASE @D133370, COUNT @D133369, PER @D133368, PLU @D133367, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : SETTLE, 
   [COORD @D133375, AGR [COUNT @D133374, PER @D133373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SETTLE, 
   [COORD @D133377, AGR [COUNT @D133376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SETTLE, 
   [COORD @D133379, AGR [COUNT @D133378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SETTLE, 
   [COORD @D133383, AGR [COUNT @D133382, PER @D133381, PLU @D133380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, ARITY 2] : SETTLE, 
   [COORD @D133389, PAST @D133388, 
      AGR [CASE @D133387, COUNT @D133386, PER @D133385, PLU @D133384, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SETTLE, 
   [COORD @D133392, AGR [COUNT @D133391, PER @D133390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SETTLE, 
   [COORD @D133394, AGR [COUNT @D133393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SETTLE, 
   [COORD @D133396, AGR [COUNT @D133395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SETTLE, 
   [COORD @D133400, AGR [COUNT @D133399, PER @D133398, PLU @D133397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SETTLE, 
   [COORD @D133406, PAST @D133405, 
      AGR [CASE @D133404, COUNT @D133403, PER @D133402, PLU @D133401, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SETTLE, 
   [COORD @D133409, AGR [COUNT @D133408, PER @D133407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : SETTLE, 
   [COORD @D133411, AGR [COUNT @D133410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : SETTLE, 
   [COORD @D133413, AGR [COUNT @D133412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : SETTLE, 
   [COORD @D133417, AGR [COUNT @D133416, PER @D133415, PLU @D133414, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : SETTLE, 
   [COORD @D133423, PAST @D133422, 
      AGR [CASE @D133421, COUNT @D133420, PER @D133419, PLU @D133418, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : SETTLE, 
   [COORD @D133426, AGR [COUNT @D133425, PER @D133424, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : SETTLE, 
   [COORD @D133428, AGR [COUNT @D133427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : SETTLE, 
   [COORD @D133430, AGR [COUNT @D133429, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : SETTLE, 
   [COORD @D133434, AGR [COUNT @D133433, PER @D133432, PLU @D133431, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : SETTLE, 
   [COORD @D133440, PAST @D133439, 
      AGR [CASE @D133438, COUNT @D133437, PER @D133436, PLU @D133435, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : SETTLE, 
   [COORD @D133443, AGR [COUNT @D133442, PER @D133441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SETTLE, 
   [COORD @D133445, AGR [COUNT @D133444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SETTLE, 
   [COORD @D133447, AGR [COUNT @D133446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SETTLE, 
   [COORD @D133451, AGR [COUNT @D133450, PER @D133449, PLU @D133448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SETTLE, 
   [COORD @D133457, PAST @D133456, AGR [CASE @D133455, COUNT @D133454, 
            PER @D133453, PLU @D133452, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SETTLE, 
   [COORD @D133460, AGR [COUNT @D133459, PER @D133458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SETTLE, 
   [COORD @D133462, AGR [COUNT @D133461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SETTLE, 
   [COORD @D133464, AGR [COUNT @D133463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SETTLE, 
   [COORD @D133468, AGR [COUNT @D133467, PER @D133466, PLU @D133465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SETTLE, 
   [COORD @D133474, PAST @D133473, 
      AGR [CASE @D133472, COUNT @D133471, PER @D133470, PLU @D133469, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : SETTLE, 
   [COORD @D133477, AGR [COUNT @D133476, PER @D133475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SETTLE, 
   [COORD @D133479, AGR [COUNT @D133478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SETTLE, 
   [COORD @D133481, AGR [COUNT @D133480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SETTLE, 
   [COORD @D133485, AGR [COUNT @D133484, PER @D133483, PLU @D133482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SETTLE, 
   [COORD @D133491, PAST @D133490, 
      AGR [CASE @D133489, COUNT @D133488, PER @D133487, PLU @D133486, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : SETTLE, 
   [COORD @D133494, AGR [COUNT @D133493, PER @D133492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SETTLE, 
   [COORD @D133496, AGR [COUNT @D133495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SETTLE, 
   [COORD @D133498, AGR [COUNT @D133497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SETTLE, 
   [COORD @D133502, AGR [COUNT @D133501, PER @D133500, PLU @D133499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SETTLE, 
   [COORD @D133508, PAST @D133507, 
      AGR [CASE @D133506, COUNT @D133505, PER @D133504, PLU @D133503, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : SETTLE.

WORD settled : 
   [COADV @D133525, COORD @D133524, DEF @D133523, PRD @D133522, 
      AGR [CASE @D133521, COUNT @D133520, PER @D133519, PLU @D133518, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : SETTLED, 
   [COORD @D133530, AGR [CASE @D133529, COUNT @D133528, PER @D133527, 
            PLU @D133526, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SETTLE, 
   [COORD @D133535, AGR [CASE @D133534, COUNT @D133533, PER @D133532, 
            PLU @D133531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133540, AGR [CASE @D133539, COUNT @D133538, PER @D133537, 
            PLU @D133536, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133545, AGR [CASE @D133544, COUNT @D133543, PER @D133542, 
            PLU @D133541, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133550, AGR [CASE @D133549, COUNT @D133548, PER @D133547, 
            PLU @D133546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133555, AGR [CASE @D133554, COUNT @D133553, PER @D133552, 
            PLU @D133551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133560, AGR [CASE @D133559, COUNT @D133558, PER @D133557, 
            PLU @D133556, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133565, AGR [CASE @D133564, COUNT @D133563, PER @D133562, 
            PLU @D133561, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133570, AGR [CASE @D133569, COUNT @D133568, PER @D133567, 
            PLU @D133566, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133575, AGR [CASE @D133574, COUNT @D133573, PER @D133572, 
            PLU @D133571, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133580, AGR [CASE @D133579, COUNT @D133578, PER @D133577, 
            PLU @D133576, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133585, AGR [CASE @D133584, COUNT @D133583, PER @D133582, 
            PLU @D133581, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133590, AGR [CASE @D133589, COUNT @D133588, PER @D133587, 
            PLU @D133586, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133595, AGR [UB @D133594, VFORM @D133593, SUBJ @D133592, 
            FIN @D133591, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133600, AGR [CASE @D133599, COUNT @D133598, PER @D133597, 
            PLU @D133596, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133605, AGR [CASE @D133604, COUNT @D133603, PER @D133602, 
            PLU @D133601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133610, AGR [CASE @D133609, COUNT @D133608, PER @D133607, 
            PLU @D133606, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SETTLE, 
   [COORD @D133615, AGR [CASE @D133614, COUNT @D133613, PER @D133612, 
            PLU @D133611, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133620, AGR [CASE @D133619, COUNT @D133618, PER @D133617, 
            PLU @D133616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133625, AGR [CASE @D133624, COUNT @D133623, PER @D133622, 
            PLU @D133621, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133630, AGR [CASE @D133629, COUNT @D133628, PER @D133627, 
            PLU @D133626, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133635, AGR [CASE @D133634, COUNT @D133633, PER @D133632, 
            PLU @D133631, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133640, AGR [CASE @D133639, COUNT @D133638, PER @D133637, 
            PLU @D133636, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133645, AGR [CASE @D133644, COUNT @D133643, PER @D133642, 
            PLU @D133641, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133650, AGR [CASE @D133649, COUNT @D133648, PER @D133647, 
            PLU @D133646, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133655, AGR [CASE @D133654, COUNT @D133653, PER @D133652, 
            PLU @D133651, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133660, AGR [CASE @D133659, COUNT @D133658, PER @D133657, 
            PLU @D133656, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133665, AGR [CASE @D133664, COUNT @D133663, PER @D133662, 
            PLU @D133661, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133670, AGR [CASE @D133669, COUNT @D133668, PER @D133667, 
            PLU @D133666, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133675, AGR [CASE @D133674, COUNT @D133673, PER @D133672, 
            PLU @D133671, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133680, AGR [CASE @D133679, COUNT @D133678, PER @D133677, 
            PLU @D133676, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133685, AGR [CASE @D133684, COUNT @D133683, PER @D133682, 
            PLU @D133681, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133690, AGR [CASE @D133689, COUNT @D133688, PER @D133687, 
            PLU @D133686, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133695, AGR [CASE @D133694, COUNT @D133693, PER @D133692, 
            PLU @D133691, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133700, AGR [CASE @D133699, COUNT @D133698, PER @D133697, 
            PLU @D133696, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133705, AGR [CASE @D133704, COUNT @D133703, PER @D133702, 
            PLU @D133701, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133710, AGR [CASE @D133709, COUNT @D133708, PER @D133707, 
            PLU @D133706, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133715, AGR [CASE @D133714, COUNT @D133713, PER @D133712, 
            PLU @D133711, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133720, AGR [CASE @D133719, COUNT @D133718, PER @D133717, 
            PLU @D133716, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133725, AGR [CASE @D133724, COUNT @D133723, PER @D133722, 
            PLU @D133721, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133730, AGR [CASE @D133729, COUNT @D133728, PER @D133727, 
            PLU @D133726, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133735, AGR [CASE @D133734, COUNT @D133733, PER @D133732, 
            PLU @D133731, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133740, AGR [CASE @D133739, COUNT @D133738, PER @D133737, 
            PLU @D133736, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133745, AGR [CASE @D133744, COUNT @D133743, PER @D133742, 
            PLU @D133741, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133750, AGR [CASE @D133749, COUNT @D133748, PER @D133747, 
            PLU @D133746, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133755, AGR [CASE @D133754, COUNT @D133753, PER @D133752, 
            PLU @D133751, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133760, AGR [CASE @D133759, COUNT @D133758, PER @D133757, 
            PLU @D133756, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133765, AGR [CASE @D133764, COUNT @D133763, PER @D133762, 
            PLU @D133761, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133770, AGR [CASE @D133769, COUNT @D133768, PER @D133767, 
            PLU @D133766, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133775, AGR [CASE @D133774, COUNT @D133773, PER @D133772, 
            PLU @D133771, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133780, AGR [CASE @D133779, COUNT @D133778, PER @D133777, 
            PLU @D133776, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133785, AGR [CASE @D133784, COUNT @D133783, PER @D133782, 
            PLU @D133781, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133790, AGR [CASE @D133789, COUNT @D133788, PER @D133787, 
            PLU @D133786, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133795, AGR [CASE @D133794, COUNT @D133793, PER @D133792, 
            PLU @D133791, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133800, AGR [CASE @D133799, COUNT @D133798, PER @D133797, 
            PLU @D133796, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SETTLE.

WORD settles : 
   [COORD @D133811, AGR [COUNT @D133810, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SETTLE, 
   [COORD @D133813, AGR [COUNT @D133812, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133815, AGR [COUNT @D133814, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133817, AGR [COUNT @D133816, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133819, 
      AGR [COUNT @D133818, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133821, 
      AGR [COUNT @D133820, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133823, 
      AGR [COUNT @D133822, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133825, 
      AGR [COUNT @D133824, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133827, 
      AGR [COUNT @D133826, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133829, 
      AGR [COUNT @D133828, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SETTLE, 
   [COORD @D133831, AGR [COUNT @D133830, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133833, AGR [COUNT @D133832, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133835, AGR [COUNT @D133834, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133837, AGR [COUNT @D133836, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133839, AGR [COUNT @D133838, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133841, AGR [COUNT @D133840, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133843, AGR [COUNT @D133842, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133845, AGR [COUNT @D133844, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133847, AGR [COUNT @D133846, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133849, 
      AGR [COUNT @D133848, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133851, 
      AGR [COUNT @D133850, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133853, 
      AGR [COUNT @D133852, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SETTLE.

WORD settling : 
   [COORD @D133867, PRD @D133866, AGR [CASE @D133865, COUNT @D133864, 
            PER @D133863, PLU @D133862, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133873, PRD @D133872, 
      AGR [CASE @D133871, COUNT @D133870, PER @D133869, PLU @D133868, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133879, PRD @D133878, AGR [CASE @D133877, COUNT @D133876, 
            PER @D133875, PLU @D133874, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133885, PRD @D133884, 
      AGR [CASE @D133883, COUNT @D133882, PER @D133881, PLU @D133880, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133891, PRD @D133890, AGR [CASE @D133889, COUNT @D133888, 
            PER @D133887, PLU @D133886, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133897, PRD @D133896, 
      AGR [CASE @D133895, COUNT @D133894, PER @D133893, PLU @D133892, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133903, PRD @D133902, AGR [CASE @D133901, COUNT @D133900, 
            PER @D133899, PLU @D133898, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133909, PRD @D133908, 
      AGR [CASE @D133907, COUNT @D133906, PER @D133905, PLU @D133904, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133915, PRD @D133914, AGR [CASE @D133913, COUNT @D133912, 
            PER @D133911, PLU @D133910, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133921, PRD @D133920, 
      AGR [CASE @D133919, COUNT @D133918, PER @D133917, PLU @D133916, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133927, PRD @D133926, AGR [CASE @D133925, COUNT @D133924, 
            PER @D133923, PLU @D133922, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133933, PRD @D133932, 
      AGR [CASE @D133931, COUNT @D133930, PER @D133929, PLU @D133928, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133939, PRD @D133938, AGR [CASE @D133937, COUNT @D133936, 
            PER @D133935, PLU @D133934, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133945, PRD @D133944, 
      AGR [CASE @D133943, COUNT @D133942, PER @D133941, PLU @D133940, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SETTLE, 
   [COORD @D133951, PRD @D133950, AGR [CASE @D133949, COUNT @D133948, 
            PER @D133947, PLU @D133946, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133957, PRD @D133956, 
      AGR [CASE @D133955, COUNT @D133954, PER @D133953, PLU @D133952, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SETTLE, 
   [COORD @D133963, PRD @D133962, AGR [CASE @D133961, COUNT @D133960, 
            PER @D133959, PLU @D133958, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133969, PRD @D133968, 
      AGR [CASE @D133967, COUNT @D133966, PER @D133965, PLU @D133964, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SETTLE, 
   [COORD @D133975, PRD @D133974, AGR [CASE @D133973, COUNT @D133972, 
            PER @D133971, PLU @D133970, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133981, PRD @D133980, 
      AGR [CASE @D133979, COUNT @D133978, PER @D133977, PLU @D133976, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SETTLE, 
   [COORD @D133987, PRD @D133986, AGR [CASE @D133985, COUNT @D133984, 
            PER @D133983, PLU @D133982, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SETTLE, 
   [COORD @D133993, PRD @D133992, 
      AGR [CASE @D133991, COUNT @D133990, PER @D133989, PLU @D133988, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SETTLE.

WORD shade : 
   [COORD @D134003, REFL @D134002, PRD @D134001, CASE @D134000, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHADE, 
   [COORD @D134008, REFL @D134007, COUNT @D134006, PRD @D134005, 
      CASE @D134004, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SHADE, 
   [COORD @D134012, REFL @D134011, PRD @D134010, CASE @D134009, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : SHADE, 
   [COORD @D134015, 
      AGR [COUNT @D134014, PER @D134013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   SHADE, 
   [COORD @D134017, AGR [COUNT @D134016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHADE, 
   [COORD @D134019, AGR [COUNT @D134018, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHADE, 
   [COORD @D134023, AGR [COUNT @D134022, PER @D134021, PLU @D134020, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SHADE, 
   [COORD @D134029, PAST @D134028, AGR [CASE @D134027, COUNT @D134026, 
            PER @D134025, PLU @D134024, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SHADE, 
   [COORD @D134032, AGR [COUNT @D134031, PER @D134030, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHADE, 
   [COORD @D134034, AGR [COUNT @D134033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHADE, 
   [COORD @D134036, AGR [COUNT @D134035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHADE, 
   [COORD @D134040, AGR [COUNT @D134039, PER @D134038, PLU @D134037, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : SHADE, 
   [COORD @D134046, PAST @D134045, 
      AGR [CASE @D134044, COUNT @D134043, PER @D134042, PLU @D134041, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHADE, 
   [COORD @D134049, AGR [COUNT @D134048, PER @D134047, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : SHADE, 
   [COORD @D134051, AGR [COUNT @D134050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : SHADE, 
   [COORD @D134053, AGR [COUNT @D134052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : SHADE, 
   [COORD @D134057, AGR [COUNT @D134056, PER @D134055, PLU @D134054, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : SHADE, 
   [COORD @D134063, PAST @D134062, 
      AGR [CASE @D134061, COUNT @D134060, PER @D134059, PLU @D134058, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : SHADE, 
   [COORD @D134066, AGR [COUNT @D134065, PER @D134064, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SHADE, 
   [COORD @D134068, AGR [COUNT @D134067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SHADE, 
   [COORD @D134070, AGR [COUNT @D134069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SHADE, 
   [COORD @D134074, AGR [COUNT @D134073, PER @D134072, PLU @D134071, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SHADE, 
   [COORD @D134080, PAST @D134079, 
      AGR [CASE @D134078, COUNT @D134077, PER @D134076, PLU @D134075, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : SHADE, 
   [COORD @D134083, AGR [COUNT @D134082, PER @D134081, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SHADE, 
   [COORD @D134085, AGR [COUNT @D134084, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SHADE, 
   [COORD @D134087, AGR [COUNT @D134086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SHADE, 
   [COORD @D134091, AGR [COUNT @D134090, PER @D134089, PLU @D134088, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SHADE, 
   [COORD @D134097, PAST @D134096, 
      AGR [CASE @D134095, COUNT @D134094, PER @D134093, PLU @D134092, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : SHADE.

WORD shaded : 
   [COORD @D134110, AGR [CASE @D134109, COUNT @D134108, PER @D134107, 
            PLU @D134106, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHADE, 
   [COORD @D134115, AGR [CASE @D134114, COUNT @D134113, PER @D134112, 
            PLU @D134111, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134120, AGR [CASE @D134119, COUNT @D134118, PER @D134117, 
            PLU @D134116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134125, AGR [CASE @D134124, COUNT @D134123, PER @D134122, 
            PLU @D134121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134130, AGR [CASE @D134129, COUNT @D134128, PER @D134127, 
            PLU @D134126, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134135, AGR [CASE @D134134, COUNT @D134133, PER @D134132, 
            PLU @D134131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134140, AGR [CASE @D134139, COUNT @D134138, PER @D134137, 
            PLU @D134136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134145, AGR [CASE @D134144, COUNT @D134143, PER @D134142, 
            PLU @D134141, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134150, AGR [CASE @D134149, COUNT @D134148, PER @D134147, 
            PLU @D134146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134155, AGR [CASE @D134154, COUNT @D134153, PER @D134152, 
            PLU @D134151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134160, AGR [CASE @D134159, COUNT @D134158, PER @D134157, 
            PLU @D134156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134165, AGR [CASE @D134164, COUNT @D134163, PER @D134162, 
            PLU @D134161, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHADE.

WORD shades : 
   [COORD @D134177, REFL @D134176, PRD @D134175, CASE @D134174, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHADES, 
   [COORD @D134181, REFL @D134180, PRD @D134179, CASE @D134178, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : SHADES, 
   [COORD @D134186, DEMON @D134185, REFL @D134184, PRD @D134183, 
      CASE @D134182, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHADE, 
   [COORD @D134191, DEMON @D134190, REFL @D134189, PRD @D134188, 
      CASE @D134187, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHADE, 
   [COORD @D134196, DEMON @D134195, REFL @D134194, PRD @D134193, 
      CASE @D134192, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHADE, 
   [COORD @D134198, AGR [COUNT @D134197, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHADE, 
   [COORD @D134200, 
      AGR [COUNT @D134199, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHADE, 
   [COORD @D134202, 
      AGR [COUNT @D134201, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHADE, 
   [COORD @D134204, 
      AGR [COUNT @D134203, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHADE, 
   [COORD @D134206, 
      AGR [COUNT @D134205, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHADE.

WORD shadeses : 
   [COORD @D134224, DEMON @D134223, REFL @D134222, PRD @D134221, 
      CASE @D134220, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHADES.

WORD shading : 
   [COORD @D134236, PRD @D134235, AGR [CASE @D134234, COUNT @D134233, 
            PER @D134232, PLU @D134231, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134242, PRD @D134241, 
      AGR [CASE @D134240, COUNT @D134239, PER @D134238, PLU @D134237, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHADE, 
   [COORD @D134248, PRD @D134247, AGR [CASE @D134246, COUNT @D134245, 
            PER @D134244, PLU @D134243, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHADE, 
   [COORD @D134254, PRD @D134253, 
      AGR [CASE @D134252, COUNT @D134251, PER @D134250, PLU @D134249, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHADE, 
   [COORD @D134260, PRD @D134259, AGR [CASE @D134258, COUNT @D134257, 
            PER @D134256, PLU @D134255, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHADE.

WORD shadow : 
   [COADV @D134274, COORD @D134273, DEF @D134272, PRD @D134271, 
      AGR [CASE @D134270, COUNT @D134269, PER @D134268, PLU @D134267, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : SHADOW, 
   [COORD @D134278, REFL @D134277, PRD @D134276, CASE @D134275, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHADOW, 
   [COORD @D134283, REFL @D134282, COUNT @D134281, PRD @D134280, 
      CASE @D134279, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SHADOW, 
   [COORD @D134286, 
      AGR [COUNT @D134285, PER @D134284, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   SHADOW, 
   [COORD @D134288, AGR [COUNT @D134287, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHADOW, 
   [COORD @D134290, AGR [COUNT @D134289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHADOW, 
   [COORD @D134294, AGR [COUNT @D134293, PER @D134292, PLU @D134291, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SHADOW, 
   [COORD @D134300, PAST @D134299, AGR [CASE @D134298, COUNT @D134297, 
            PER @D134296, PLU @D134295, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SHADOW.

WORD shadowed : 
   [COORD @D134314, AGR [CASE @D134313, COUNT @D134312, PER @D134311, 
            PLU @D134310, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHADOW, 
   [COORD @D134319, AGR [CASE @D134318, COUNT @D134317, PER @D134316, 
            PLU @D134315, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHADOW, 
   [COORD @D134324, AGR [CASE @D134323, COUNT @D134322, PER @D134321, 
            PLU @D134320, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHADOW.

WORD shadowing : 
   [COORD @D134345, PRD @D134344, AGR [CASE @D134343, COUNT @D134342, 
            PER @D134341, PLU @D134340, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHADOW.

WORD shadows : 
   [COORD @D134359, DEMON @D134358, REFL @D134357, PRD @D134356, 
      CASE @D134355, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHADOW, 
   [COORD @D134361, AGR [COUNT @D134360, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHADOW.

WORD shape : 
   [COORD @D134371, REFL @D134370, PRD @D134369, CASE @D134368, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN] : SHAPE, 
   [COORD @D134375, REFL @D134374, PRD @D134373, CASE @D134372, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHAPE, 
   [COORD @D134379, REFL @D134378, PRD @D134377, CASE @D134376, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHAPE, 
   [COORD @D134384, REFL @D134383, COUNT @D134382, PRD @D134381, 
      CASE @D134380, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SHAPE, 
   [COORD @D134387, 
      AGR [COUNT @D134386, PER @D134385, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : SHAPE, 
   [COORD @D134389, AGR [COUNT @D134388, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SHAPE, 
   [COORD @D134391, AGR [COUNT @D134390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SHAPE, 
   [COORD @D134395, AGR [COUNT @D134394, PER @D134393, PLU @D134392, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SHAPE, 
   [COORD @D134401, PAST @D134400, AGR [CASE @D134399, COUNT @D134398, 
            PER @D134397, PLU @D134396, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : SHAPE, 
   [COORD @D134404, AGR [COUNT @D134403, PER @D134402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : SHAPE, 
   [COORD @D134406, AGR [COUNT @D134405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : SHAPE, 
   [COORD @D134408, AGR [COUNT @D134407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : SHAPE, 
   [COORD @D134412, AGR [COUNT @D134411, PER @D134410, PLU @D134409, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : SHAPE, 
   [COORD @D134418, PAST @D134417, 
      AGR [CASE @D134416, COUNT @D134415, PER @D134414, PLU @D134413, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : SHAPE, 
   [COORD @D134421, AGR [COUNT @D134420, PER @D134419, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SHAPE, 
   [COORD @D134423, AGR [COUNT @D134422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SHAPE, 
   [COORD @D134425, AGR [COUNT @D134424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SHAPE, 
   [COORD @D134429, AGR [COUNT @D134428, PER @D134427, PLU @D134426, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : SHAPE, 
   [COORD @D134435, PAST @D134434, 
      AGR [CASE @D134433, COUNT @D134432, PER @D134431, PLU @D134430, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : SHAPE, 
   [COORD @D134438, AGR [COUNT @D134437, PER @D134436, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHAPE, 
   [COORD @D134440, AGR [COUNT @D134439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHAPE, 
   [COORD @D134442, AGR [COUNT @D134441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHAPE, 
   [COORD @D134446, AGR [COUNT @D134445, PER @D134444, PLU @D134443, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SHAPE, 
   [COORD @D134452, PAST @D134451, AGR [CASE @D134450, COUNT @D134449, 
            PER @D134448, PLU @D134447, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SHAPE, 
   [COORD @D134455, AGR [COUNT @D134454, PER @D134453, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SHAPE, 
   [COORD @D134457, AGR [COUNT @D134456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SHAPE, 
   [COORD @D134459, AGR [COUNT @D134458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SHAPE, 
   [COORD @D134463, AGR [COUNT @D134462, PER @D134461, PLU @D134460, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SHAPE, 
   [COORD @D134469, PAST @D134468, AGR [CASE @D134467, COUNT @D134466, 
            PER @D134465, PLU @D134464, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : SHAPE, 
   [COORD @D134472, AGR [COUNT @D134471, PER @D134470, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT UP, ARITY 2] : SHAPE, 
   [COORD @D134474, AGR [COUNT @D134473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT UP, ARITY 2] : SHAPE, 
   [COORD @D134476, AGR [COUNT @D134475, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT UP, ARITY 2] : SHAPE, 
   [COORD @D134480, AGR [COUNT @D134479, PER @D134478, PLU @D134477, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, PRT UP, ARITY 2] : SHAPE, 
   [COORD @D134486, PAST @D134485, 
      AGR [CASE @D134484, COUNT @D134483, PER @D134482, PLU @D134481, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADVP, 
      PRT UP, ARITY 2] : SHAPE, 
   [COORD @D134489, AGR [COUNT @D134488, PER @D134487, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHAPE, 
   [COORD @D134491, AGR [COUNT @D134490, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHAPE, 
   [COORD @D134493, AGR [COUNT @D134492, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHAPE, 
   [COORD @D134497, AGR [COUNT @D134496, PER @D134495, PLU @D134494, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHAPE, 
   [COORD @D134503, PAST @D134502, 
      AGR [CASE @D134501, COUNT @D134500, PER @D134499, PLU @D134498, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : SHAPE.

WORD shaped : 
   [COORD @D134516, AGR [CASE @D134515, COUNT @D134514, PER @D134513, 
            PLU @D134512, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134521, AGR [CASE @D134520, COUNT @D134519, PER @D134518, 
            PLU @D134517, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134527, AGR [CASE @D134526, NFORM @D134525, COUNT @D134524, 
            PER @D134523, PLU @D134522, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHAPE, 
   [COORD @D134532, AGR [CASE @D134531, COUNT @D134530, PER @D134529, 
            PLU @D134528, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134537, AGR [CASE @D134536, COUNT @D134535, PER @D134534, 
            PLU @D134533, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134542, AGR [CASE @D134541, COUNT @D134540, PER @D134539, 
            PLU @D134538, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134547, AGR [CASE @D134546, COUNT @D134545, PER @D134544, 
            PLU @D134543, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134552, AGR [CASE @D134551, COUNT @D134550, PER @D134549, 
            PLU @D134548, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134557, AGR [CASE @D134556, COUNT @D134555, PER @D134554, 
            PLU @D134553, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134562, AGR [CASE @D134561, COUNT @D134560, PER @D134559, 
            PLU @D134558, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134567, AGR [CASE @D134566, COUNT @D134565, PER @D134564, 
            PLU @D134563, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134572, AGR [CASE @D134571, COUNT @D134570, PER @D134569, 
            PLU @D134568, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHAPE, 
   [COORD @D134577, AGR [CASE @D134576, COUNT @D134575, PER @D134574, 
            PLU @D134573, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134582, AGR [CASE @D134581, COUNT @D134580, PER @D134579, 
            PLU @D134578, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134587, AGR [CASE @D134586, COUNT @D134585, PER @D134584, 
            PLU @D134583, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134592, AGR [CASE @D134591, COUNT @D134590, PER @D134589, 
            PLU @D134588, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134597, AGR [CASE @D134596, COUNT @D134595, PER @D134594, 
            PLU @D134593, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134602, AGR [CASE @D134601, COUNT @D134600, PER @D134599, 
            PLU @D134598, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHAPE.

WORD shapes : 
   [COORD @D134615, DEMON @D134614, REFL @D134613, PRD @D134612, 
      CASE @D134611, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHAPE, 
   [COORD @D134620, DEMON @D134619, REFL @D134618, PRD @D134617, 
      CASE @D134616, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHAPE, 
   [COORD @D134622, AGR [COUNT @D134621, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHAPE, 
   [COORD @D134624, AGR [COUNT @D134623, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHAPE, 
   [COORD @D134626, AGR [COUNT @D134625, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHAPE, 
   [COORD @D134628, AGR [COUNT @D134627, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134630, 
      AGR [COUNT @D134629, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134632, 
      AGR [COUNT @D134631, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134634, 
      AGR [COUNT @D134633, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHAPE.

WORD shaping : 
   [COORD @D134646, PRD @D134645, AGR [CASE @D134644, COUNT @D134643, 
            PER @D134642, PLU @D134641, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134652, PRD @D134651, 
      AGR [CASE @D134650, COUNT @D134649, PER @D134648, PLU @D134647, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHAPE, 
   [COORD @D134658, PRD @D134657, AGR [CASE @D134656, COUNT @D134655, 
            PER @D134654, PLU @D134653, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134664, PRD @D134663, 
      AGR [CASE @D134662, COUNT @D134661, PER @D134660, PLU @D134659, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHAPE, 
   [COORD @D134670, PRD @D134669, AGR [CASE @D134668, COUNT @D134667, 
            PER @D134666, PLU @D134665, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHAPE, 
   [COORD @D134676, PRD @D134675, 
      AGR [CASE @D134674, COUNT @D134673, PER @D134672, PLU @D134671, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHAPE, 
   [COORD @D134682, PRD @D134681, AGR [CASE @D134680, COUNT @D134679, 
            PER @D134678, PLU @D134677, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHAPE.

WORD share : 
   [COORD @D134692, REFL @D134691, PRD @D134690, CASE @D134689, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : SHARE, 
   [COORD @D134696, REFL @D134695, PRD @D134694, CASE @D134693, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHARE, 
   [COORD @D134700, REFL @D134699, PRD @D134698, CASE @D134697, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHARE, 
   [COORD @D134703, 
      AGR [COUNT @D134702, PER @D134701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : SHARE, 
   [COORD @D134705, AGR [COUNT @D134704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SHARE, 
   [COORD @D134707, AGR [COUNT @D134706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SHARE, 
   [COORD @D134711, AGR [COUNT @D134710, PER @D134709, PLU @D134708, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SHARE, 
   [COORD @D134717, PAST @D134716, 
      AGR [CASE @D134715, COUNT @D134714, PER @D134713, PLU @D134712, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : SHARE, 
   [COORD @D134720, AGR [COUNT @D134719, PER @D134718, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134722, AGR [COUNT @D134721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134724, AGR [COUNT @D134723, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134728, AGR [COUNT @D134727, PER @D134726, PLU @D134725, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134734, PAST @D134733, 
      AGR [CASE @D134732, COUNT @D134731, PER @D134730, PLU @D134729, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134737, AGR [COUNT @D134736, PER @D134735, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134739, AGR [COUNT @D134738, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134741, AGR [COUNT @D134740, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134745, AGR [COUNT @D134744, PER @D134743, PLU @D134742, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134751, PAST @D134750, 
      AGR [CASE @D134749, COUNT @D134748, PER @D134747, PLU @D134746, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134754, AGR [COUNT @D134753, PER @D134752, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134756, 
      AGR [COUNT @D134755, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134758, AGR [COUNT @D134757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134762, 
      AGR [COUNT @D134761, PER @D134760, PLU @D134759, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134768, PAST @D134767, 
      AGR [CASE @D134766, COUNT @D134765, PER @D134764, PLU @D134763, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM BETWEEN, ARITY 3] : SHARE, 
   [COORD @D134771, AGR [COUNT @D134770, PER @D134769, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134773, 
      AGR [COUNT @D134772, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134775, AGR [COUNT @D134774, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134779, 
      AGR [COUNT @D134778, PER @D134777, PLU @D134776, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134785, PAST @D134784, 
      AGR [CASE @D134783, COUNT @D134782, PER @D134781, PLU @D134780, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM AMONG, ARITY 3] : SHARE, 
   [COORD @D134788, AGR [COUNT @D134787, PER @D134786, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHARE, 
   [COORD @D134790, AGR [COUNT @D134789, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHARE, 
   [COORD @D134792, AGR [COUNT @D134791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHARE, 
   [COORD @D134796, AGR [COUNT @D134795, PER @D134794, PLU @D134793, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SHARE, 
   [COORD @D134802, PAST @D134801, AGR [CASE @D134800, COUNT @D134799, 
            PER @D134798, PLU @D134797, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SHARE, 
   [COORD @D134805, AGR [COUNT @D134804, PER @D134803, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SHARE, 
   [COORD @D134807, AGR [COUNT @D134806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SHARE, 
   [COORD @D134809, AGR [COUNT @D134808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SHARE, 
   [COORD @D134813, AGR [COUNT @D134812, PER @D134811, PLU @D134810, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : SHARE, 
   [COORD @D134819, PAST @D134818, 
      AGR [CASE @D134817, COUNT @D134816, PER @D134815, PLU @D134814, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : SHARE, 
   [COORD @D134822, AGR [COUNT @D134821, PER @D134820, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : SHARE, 
   [COORD @D134824, AGR [COUNT @D134823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : SHARE, 
   [COORD @D134826, AGR [COUNT @D134825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : SHARE, 
   [COORD @D134830, AGR [COUNT @D134829, PER @D134828, PLU @D134827, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, ARITY 2] : SHARE, 
   [COORD @D134836, PAST @D134835, 
      AGR [CASE @D134834, COUNT @D134833, PER @D134832, PLU @D134831, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : SHARE, 
   [COORD @D134839, AGR [COUNT @D134838, PER @D134837, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BETWEEN, ARITY 2] : SHARE, 
   [COORD @D134841, AGR [COUNT @D134840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BETWEEN, ARITY 2] : SHARE, 
   [COORD @D134843, AGR [COUNT @D134842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BETWEEN, ARITY 2] : SHARE, 
   [COORD @D134847, AGR [COUNT @D134846, PER @D134845, PLU @D134844, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM BETWEEN, ARITY 2] : SHARE, 
   [COORD @D134853, PAST @D134852, 
      AGR [CASE @D134851, COUNT @D134850, PER @D134849, PLU @D134848, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BETWEEN, ARITY 2] : SHARE, 
   [COORD @D134856, AGR [COUNT @D134855, PER @D134854, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AMONG, ARITY 2] : SHARE, 
   [COORD @D134858, AGR [COUNT @D134857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AMONG, ARITY 2] : SHARE, 
   [COORD @D134860, AGR [COUNT @D134859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AMONG, ARITY 2] : SHARE, 
   [COORD @D134864, AGR [COUNT @D134863, PER @D134862, PLU @D134861, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AMONG, ARITY 2] : SHARE, 
   [COORD @D134870, PAST @D134869, 
      AGR [CASE @D134868, COUNT @D134867, PER @D134866, PLU @D134865, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AMONG, ARITY 2] : SHARE, 
   [COORD @D134873, AGR [COUNT @D134872, PER @D134871, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SHARE, 
   [COORD @D134875, AGR [COUNT @D134874, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SHARE, 
   [COORD @D134877, AGR [COUNT @D134876, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SHARE, 
   [COORD @D134881, AGR [COUNT @D134880, PER @D134879, PLU @D134878, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : SHARE, 
   [COORD @D134887, PAST @D134886, 
      AGR [CASE @D134885, COUNT @D134884, PER @D134883, PLU @D134882, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : SHARE, 
   [COORD @D134890, AGR [COUNT @D134889, PER @D134888, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHARE, 
   [COORD @D134892, AGR [COUNT @D134891, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHARE, 
   [COORD @D134894, AGR [COUNT @D134893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHARE, 
   [COORD @D134898, AGR [COUNT @D134897, PER @D134896, PLU @D134895, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHARE, 
   [COORD @D134904, PAST @D134903, AGR [CASE @D134902, COUNT @D134901, 
            PER @D134900, PLU @D134899, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SHARE, 
   [COORD @D134907, AGR [COUNT @D134906, PER @D134905, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SHARE, 
   [COORD @D134909, AGR [COUNT @D134908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SHARE, 
   [COORD @D134911, AGR [COUNT @D134910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SHARE, 
   [COORD @D134915, AGR [COUNT @D134914, PER @D134913, PLU @D134912, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SHARE, 
   [COORD @D134921, PAST @D134920, 
      AGR [CASE @D134919, COUNT @D134918, PER @D134917, PLU @D134916, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SHARE.

WORD shared : 
   [COORD @D134934, AGR [CASE @D134933, COUNT @D134932, PER @D134931, 
            PLU @D134930, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134939, AGR [CASE @D134938, COUNT @D134937, PER @D134936, 
            PLU @D134935, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134944, AGR [CASE @D134943, COUNT @D134942, PER @D134941, 
            PLU @D134940, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134949, AGR [CASE @D134948, COUNT @D134947, PER @D134946, 
            PLU @D134945, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134954, AGR [CASE @D134953, COUNT @D134952, PER @D134951, 
            PLU @D134950, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134959, AGR [CASE @D134958, COUNT @D134957, PER @D134956, 
            PLU @D134955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134964, AGR [CASE @D134963, COUNT @D134962, PER @D134961, 
            PLU @D134960, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134969, AGR [CASE @D134968, COUNT @D134967, PER @D134966, 
            PLU @D134965, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134974, AGR [CASE @D134973, COUNT @D134972, PER @D134971, 
            PLU @D134970, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134979, AGR [CASE @D134978, COUNT @D134977, PER @D134976, 
            PLU @D134975, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM BETWEEN, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134984, AGR [CASE @D134983, COUNT @D134982, PER @D134981, 
            PLU @D134980, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM BETWEEN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134989, 
      AGR [CASE @D134988, COUNT @D134987, PER @D134986, PLU @D134985, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134994, AGR [CASE @D134993, COUNT @D134992, PER @D134991, 
            PLU @D134990, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM AMONG, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D134999, AGR [CASE @D134998, COUNT @D134997, PER @D134996, 
            PLU @D134995, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM AMONG, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135004, 
      AGR [CASE @D135003, COUNT @D135002, PER @D135001, PLU @D135000, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135009, AGR [CASE @D135008, COUNT @D135007, PER @D135006, 
            PLU @D135005, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHARE, 
   [COORD @D135014, AGR [CASE @D135013, COUNT @D135012, PER @D135011, 
            PLU @D135010, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135019, AGR [CASE @D135018, COUNT @D135017, PER @D135016, 
            PLU @D135015, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135024, AGR [CASE @D135023, COUNT @D135022, PER @D135021, 
            PLU @D135020, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135029, AGR [CASE @D135028, COUNT @D135027, PER @D135026, 
            PLU @D135025, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135034, AGR [CASE @D135033, COUNT @D135032, PER @D135031, 
            PLU @D135030, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135039, AGR [CASE @D135038, COUNT @D135037, PER @D135036, 
            PLU @D135035, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135044, AGR [CASE @D135043, COUNT @D135042, PER @D135041, 
            PLU @D135040, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135049, AGR [CASE @D135048, COUNT @D135047, PER @D135046, 
            PLU @D135045, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135054, AGR [CASE @D135053, COUNT @D135052, PER @D135051, 
            PLU @D135050, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135059, AGR [CASE @D135058, COUNT @D135057, PER @D135056, 
            PLU @D135055, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AMONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135064, AGR [CASE @D135063, COUNT @D135062, PER @D135061, 
            PLU @D135060, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AMONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135069, AGR [CASE @D135068, COUNT @D135067, PER @D135066, 
            PLU @D135065, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135074, AGR [CASE @D135073, COUNT @D135072, PER @D135071, 
            PLU @D135070, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135079, AGR [CASE @D135078, COUNT @D135077, PER @D135076, 
            PLU @D135075, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135084, AGR [CASE @D135083, COUNT @D135082, PER @D135081, 
            PLU @D135080, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135089, AGR [CASE @D135088, COUNT @D135087, PER @D135086, 
            PLU @D135085, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135094, AGR [CASE @D135093, COUNT @D135092, PER @D135091, 
            PLU @D135090, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135099, AGR [CASE @D135098, COUNT @D135097, PER @D135096, 
            PLU @D135095, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHARE.

WORD shares : 
   [COORD @D135111, REFL @D135110, PRD @D135109, CASE @D135108, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : SHARES, 
   [COORD @D135116, DEMON @D135115, REFL @D135114, PRD @D135113, 
      CASE @D135112, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHARE, 
   [COORD @D135121, DEMON @D135120, REFL @D135119, PRD @D135118, 
      CASE @D135117, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHARE, 
   [COORD @D135123, AGR [COUNT @D135122, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHARE, 
   [COORD @D135125, AGR [COUNT @D135124, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHARE, 
   [COORD @D135127, AGR [COUNT @D135126, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHARE, 
   [COORD @D135129, AGR [COUNT @D135128, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM BETWEEN, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SHARE, 
   [COORD @D135131, AGR [COUNT @D135130, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM AMONG, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SHARE, 
   [COORD @D135133, AGR [COUNT @D135132, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHARE, 
   [COORD @D135135, 
      AGR [COUNT @D135134, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHARE, 
   [COORD @D135137, 
      AGR [COUNT @D135136, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHARE, 
   [COORD @D135139, 
      AGR [COUNT @D135138, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHARE, 
   [COORD @D135141, AGR [COUNT @D135140, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AMONG, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHARE, 
   [COORD @D135143, AGR [COUNT @D135142, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHARE, 
   [COORD @D135145, AGR [COUNT @D135144, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHARE, 
   [COORD @D135147, 
      AGR [COUNT @D135146, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHARE.

WORD sharing : 
   [COORD @D135172, PRD @D135171, AGR [CASE @D135170, COUNT @D135169, 
            PER @D135168, PLU @D135167, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135178, PRD @D135177, 
      AGR [CASE @D135176, COUNT @D135175, PER @D135174, PLU @D135173, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BETWEEN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135184, PRD @D135183, AGR [CASE @D135182, COUNT @D135181, 
            PER @D135180, PLU @D135179, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM AMONG, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135190, PRD @D135189, 
      AGR [CASE @D135188, COUNT @D135187, PER @D135186, PLU @D135185, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM BETWEEN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135196, PRD @D135195, 
      AGR [CASE @D135194, COUNT @D135193, PER @D135192, PLU @D135191, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM AMONG, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135202, PRD @D135201, 
      AGR [CASE @D135200, COUNT @D135199, PER @D135198, PLU @D135197, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHARE, 
   [COORD @D135208, PRD @D135207, AGR [CASE @D135206, COUNT @D135205, 
            PER @D135204, PLU @D135203, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135214, PRD @D135213, 
      AGR [CASE @D135212, COUNT @D135211, PER @D135210, PLU @D135209, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHARE, 
   [COORD @D135220, PRD @D135219, AGR [CASE @D135218, COUNT @D135217, 
            PER @D135216, PLU @D135215, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM BETWEEN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135226, PRD @D135225, 
      AGR [CASE @D135224, COUNT @D135223, PER @D135222, PLU @D135221, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AMONG, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHARE, 
   [COORD @D135232, PRD @D135231, AGR [CASE @D135230, COUNT @D135229, 
            PER @D135228, PLU @D135227, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE, 
   [COORD @D135238, PRD @D135237, 
      AGR [CASE @D135236, COUNT @D135235, PER @D135234, PLU @D135233, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHARE, 
   [COORD @D135244, PRD @D135243, AGR [CASE @D135242, COUNT @D135241, 
            PER @D135240, PLU @D135239, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHARE.

WORD shift : 
   [COORD @D135252, REFL @D135251, PRD @D135250, CASE @D135249, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHIFT, 
   [COORD @D135255, 
      AGR [COUNT @D135254, PER @D135253, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   SHIFT, 
   [COORD @D135257, AGR [COUNT @D135256, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHIFT, 
   [COORD @D135259, AGR [COUNT @D135258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHIFT, 
   [COORD @D135263, AGR [COUNT @D135262, PER @D135261, PLU @D135260, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SHIFT, 
   [COORD @D135269, PAST @D135268, AGR [CASE @D135267, COUNT @D135266, 
            PER @D135265, PLU @D135264, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SHIFT, 
   [COORD @D135272, AGR [COUNT @D135271, PER @D135270, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SHIFT, 
   [COORD @D135274, AGR [COUNT @D135273, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SHIFT, 
   [COORD @D135276, AGR [COUNT @D135275, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SHIFT, 
   [COORD @D135280, AGR [COUNT @D135279, PER @D135278, PLU @D135277, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : SHIFT, 
   [COORD @D135286, PAST @D135285, 
      AGR [CASE @D135284, COUNT @D135283, PER @D135282, PLU @D135281, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SHIFT, 
   [COORD @D135289, AGR [COUNT @D135288, PER @D135287, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHIFT, 
   [COORD @D135291, AGR [COUNT @D135290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHIFT, 
   [COORD @D135293, AGR [COUNT @D135292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHIFT, 
   [COORD @D135297, AGR [COUNT @D135296, PER @D135295, PLU @D135294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : SHIFT, 
   [COORD @D135303, PAST @D135302, 
      AGR [CASE @D135301, COUNT @D135300, PER @D135299, PLU @D135298, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : SHIFT, 
   [COORD @D135306, AGR [COUNT @D135305, PER @D135304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHIFT, 
   [COORD @D135308, AGR [COUNT @D135307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHIFT, 
   [COORD @D135310, AGR [COUNT @D135309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHIFT, 
   [COORD @D135314, AGR [COUNT @D135313, PER @D135312, PLU @D135311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SHIFT, 
   [COORD @D135320, PAST @D135319, 
      AGR [CASE @D135318, COUNT @D135317, PER @D135316, PLU @D135315, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHIFT, 
   [COORD @D135323, AGR [COUNT @D135322, PER @D135321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHIFT, 
   [COORD @D135325, AGR [COUNT @D135324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHIFT, 
   [COORD @D135327, AGR [COUNT @D135326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHIFT, 
   [COORD @D135331, AGR [COUNT @D135330, PER @D135329, PLU @D135328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHIFT, 
   [COORD @D135337, PAST @D135336, AGR [CASE @D135335, COUNT @D135334, 
            PER @D135333, PLU @D135332, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SHIFT, 
   [COORD @D135340, AGR [COUNT @D135339, PER @D135338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHIFT, 
   [COORD @D135342, AGR [COUNT @D135341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHIFT, 
   [COORD @D135344, AGR [COUNT @D135343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHIFT, 
   [COORD @D135348, AGR [COUNT @D135347, PER @D135346, PLU @D135345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SHIFT, 
   [COORD @D135354, PAST @D135353, 
      AGR [CASE @D135352, COUNT @D135351, PER @D135350, PLU @D135349, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : SHIFT, 
   [COORD @D135357, AGR [COUNT @D135356, PER @D135355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SHIFT, 
   [COORD @D135359, AGR [COUNT @D135358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SHIFT, 
   [COORD @D135361, AGR [COUNT @D135360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SHIFT, 
   [COORD @D135365, AGR [COUNT @D135364, PER @D135363, PLU @D135362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : SHIFT, 
   [COORD @D135371, PAST @D135370, 
      AGR [CASE @D135369, COUNT @D135368, PER @D135367, PLU @D135366, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : SHIFT.

WORD shifted : 
   [COORD @D135382, AGR [CASE @D135381, COUNT @D135380, PER @D135379, 
            PLU @D135378, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135387, AGR [CASE @D135386, COUNT @D135385, PER @D135384, 
            PLU @D135383, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135392, AGR [CASE @D135391, COUNT @D135390, PER @D135389, 
            PLU @D135388, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHIFT, 
   [COORD @D135397, AGR [CASE @D135396, COUNT @D135395, PER @D135394, 
            PLU @D135393, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135402, AGR [CASE @D135401, COUNT @D135400, PER @D135399, 
            PLU @D135398, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135407, AGR [CASE @D135406, COUNT @D135405, PER @D135404, 
            PLU @D135403, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135412, AGR [CASE @D135411, COUNT @D135410, PER @D135409, 
            PLU @D135408, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135417, AGR [CASE @D135416, COUNT @D135415, PER @D135414, 
            PLU @D135413, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135422, AGR [CASE @D135421, COUNT @D135420, PER @D135419, 
            PLU @D135418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135427, AGR [CASE @D135426, COUNT @D135425, PER @D135424, 
            PLU @D135423, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135432, AGR [CASE @D135431, COUNT @D135430, PER @D135429, 
            PLU @D135428, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135437, AGR [CASE @D135436, COUNT @D135435, PER @D135434, 
            PLU @D135433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135442, AGR [CASE @D135441, COUNT @D135440, PER @D135439, 
            PLU @D135438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135447, AGR [CASE @D135446, COUNT @D135445, PER @D135444, 
            PLU @D135443, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135452, AGR [CASE @D135451, COUNT @D135450, PER @D135449, 
            PLU @D135448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHIFT.

WORD shifting : 
   [COORD @D135468, PRD @D135467, AGR [CASE @D135466, COUNT @D135465, 
            PER @D135464, PLU @D135463, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135474, PRD @D135473, 
      AGR [CASE @D135472, COUNT @D135471, PER @D135470, PLU @D135469, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHIFT, 
   [COORD @D135480, PRD @D135479, AGR [CASE @D135478, COUNT @D135477, 
            PER @D135476, PLU @D135475, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135486, PRD @D135485, 
      AGR [CASE @D135484, COUNT @D135483, PER @D135482, PLU @D135481, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHIFT, 
   [COORD @D135492, PRD @D135491, AGR [CASE @D135490, COUNT @D135489, 
            PER @D135488, PLU @D135487, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135498, PRD @D135497, 
      AGR [CASE @D135496, COUNT @D135495, PER @D135494, PLU @D135493, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHIFT, 
   [COORD @D135504, PRD @D135503, AGR [CASE @D135502, COUNT @D135501, 
            PER @D135500, PLU @D135499, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHIFT.

WORD shifts : 
   [COORD @D135515, DEMON @D135514, REFL @D135513, PRD @D135512, 
      CASE @D135511, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHIFT, 
   [COORD @D135517, AGR [COUNT @D135516, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135519, 
      AGR [COUNT @D135518, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135521, 
      AGR [COUNT @D135520, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135523, 
      AGR [COUNT @D135522, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135525, 
      AGR [COUNT @D135524, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135527, 
      AGR [COUNT @D135526, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHIFT, 
   [COORD @D135529, 
      AGR [COUNT @D135528, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHIFT.

WORD shirt : 
   [COORD @D135537, REFL @D135536, PRD @D135535, CASE @D135534, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHIRT.

WORD shirts : 
   [COORD @D135547, DEMON @D135546, REFL @D135545, PRD @D135544, 
      CASE @D135543, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHIRT.

WORD shone : 
   [COORD @D135558, PAST @D135557, AGR [CASE @D135556, COUNT @D135555, 
            PER @D135554, PLU @D135553, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : SHINE, 
   [COORD @D135564, PAST @D135563, 
      AGR [CASE @D135562, COUNT @D135561, PER @D135560, PLU @D135559, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : SHINE, 
   [COORD @D135568, AGR [COUNT @D135567, PER @D135566, PLU @D135565, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : SHINE, 
   [COORD @D135574, PAST @D135573, 
      AGR [CASE @D135572, COUNT @D135571, PER @D135570, PLU @D135569, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SHINE, 
   [COORD @D135578, AGR [COUNT @D135577, PER @D135576, PLU @D135575, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : SHINE.

WORD shoot : 
   [COORD @D135602, AGR [COUNT @D135601, PER @D135600, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135604, AGR [COUNT @D135603, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135606, AGR [COUNT @D135605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135610, AGR [COUNT @D135609, PER @D135608, PLU @D135607, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : SHOOT, 
   [COORD @D135616, PAST @D135615, 
      AGR [CASE @D135614, COUNT @D135613, PER @D135612, PLU @D135611, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135619, AGR [COUNT @D135618, PER @D135617, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135621, AGR [COUNT @D135620, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135623, AGR [COUNT @D135622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135627, AGR [COUNT @D135626, PER @D135625, PLU @D135624, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : SHOOT, 
   [COORD @D135633, PAST @D135632, 
      AGR [CASE @D135631, COUNT @D135630, PER @D135629, PLU @D135628, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : SHOOT, 
   [COORD @D135636, AGR [COUNT @D135635, PER @D135634, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135638, AGR [COUNT @D135637, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135640, AGR [COUNT @D135639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SHOOT, 
   [COORD @D135644, AGR [COUNT @D135643, PER @D135642, PLU @D135641, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : SHOOT, 
   [COORD @D135650, PAST @D135649, 
      AGR [CASE @D135648, COUNT @D135647, PER @D135646, PLU @D135645, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : SHOOT, 
   [COORD @D135653, AGR [COUNT @D135652, PER @D135651, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : SHOOT, 
   [COORD @D135655, AGR [COUNT @D135654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : SHOOT, 
   [COORD @D135657, AGR [COUNT @D135656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AT, ARITY 3] : SHOOT, 
   [COORD @D135661, AGR [COUNT @D135660, PER @D135659, PLU @D135658, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM AT, ARITY 3] : SHOOT, 
   [COORD @D135667, PAST @D135666, 
      AGR [CASE @D135665, COUNT @D135664, PER @D135663, PLU @D135662, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM AT, ARITY 3] : SHOOT, 
   [COORD @D135670, AGR [COUNT @D135669, PER @D135668, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM WITH, ARITY 3] : SHOOT, 
   [COORD @D135672, AGR [COUNT @D135671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM WITH, ARITY 3] : SHOOT, 
   [COORD @D135674, AGR [COUNT @D135673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PFORM WITH, ARITY 3] : SHOOT, 
   [COORD @D135678, AGR [COUNT @D135677, PER @D135676, PLU @D135675, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM WITH, ARITY 3] : SHOOT, 
   [COORD @D135684, PAST @D135683, 
      AGR [CASE @D135682, COUNT @D135681, PER @D135680, PLU @D135679, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM WITH, ARITY 3] : SHOOT, 
   [COORD @D135687, AGR [COUNT @D135686, PER @D135685, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHOOT, 
   [COORD @D135689, AGR [COUNT @D135688, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHOOT, 
   [COORD @D135691, AGR [COUNT @D135690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHOOT, 
   [COORD @D135695, AGR [COUNT @D135694, PER @D135693, PLU @D135692, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SHOOT, 
   [COORD @D135701, PAST @D135700, AGR [CASE @D135699, COUNT @D135698, 
            PER @D135697, PLU @D135696, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SHOOT, 
   [COORD @D135704, AGR 
         [COUNT @D135703, PER @D135702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : 
   SHOOT, 
   [COORD @D135706, AGR [COUNT @D135705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : SHOOT, 
   [COORD @D135708, AGR [COUNT @D135707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : SHOOT, 
   [COORD @D135712, AGR [COUNT @D135711, PER @D135710, PLU @D135709, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : SHOOT, 
   [COORD @D135718, PAST @D135717, AGR [CASE @D135716, COUNT @D135715, 
            PER @D135714, PLU @D135713, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : SHOOT, 
   [COORD @D135721, 
      AGR [COUNT @D135720, PER @D135719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, 
      ARITY 2] : SHOOT, 
   [COORD @D135723, AGR [COUNT @D135722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SHOOT, 
   [COORD @D135725, AGR [COUNT @D135724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SHOOT, 
   [COORD @D135729, AGR [COUNT @D135728, PER @D135727, PLU @D135726, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : SHOOT, 
   [COORD @D135735, PAST @D135734, 
      AGR [CASE @D135733, COUNT @D135732, PER @D135731, PLU @D135730, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SHOOT, 
   [COORD @D135738, AGR [COUNT @D135737, PER @D135736, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SHOOT, 
   [COORD @D135740, AGR [COUNT @D135739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SHOOT, 
   [COORD @D135742, AGR [COUNT @D135741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SHOOT, 
   [COORD @D135746, AGR [COUNT @D135745, PER @D135744, PLU @D135743, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : SHOOT, 
   [COORD @D135752, PAST @D135751, 
      AGR [CASE @D135750, COUNT @D135749, PER @D135748, PLU @D135747, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : SHOOT, 
   [COORD @D135755, AGR [COUNT @D135754, PER @D135753, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHOOT, 
   [COORD @D135757, AGR [COUNT @D135756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHOOT, 
   [COORD @D135759, AGR [COUNT @D135758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHOOT, 
   [COORD @D135763, AGR [COUNT @D135762, PER @D135761, PLU @D135760, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : SHOOT, 
   [COORD @D135769, PAST @D135768, 
      AGR [CASE @D135767, COUNT @D135766, PER @D135765, PLU @D135764, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : SHOOT, 
   [COORD @D135772, AGR [COUNT @D135771, PER @D135770, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SHOOT, 
   [COORD @D135774, AGR [COUNT @D135773, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SHOOT, 
   [COORD @D135776, AGR [COUNT @D135775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SHOOT, 
   [COORD @D135780, AGR [COUNT @D135779, PER @D135778, PLU @D135777, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SHOOT, 
   [COORD @D135786, PAST @D135785, 
      AGR [CASE @D135784, COUNT @D135783, PER @D135782, PLU @D135781, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SHOOT, 
   [COORD @D135789, AGR [COUNT @D135788, PER @D135787, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHOOT, 
   [COORD @D135791, AGR [COUNT @D135790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHOOT, 
   [COORD @D135793, AGR [COUNT @D135792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHOOT, 
   [COORD @D135797, AGR [COUNT @D135796, PER @D135795, PLU @D135794, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : SHOOT, 
   [COORD @D135803, PAST @D135802, 
      AGR [CASE @D135801, COUNT @D135800, PER @D135799, PLU @D135798, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : SHOOT, 
   [COORD @D135806, AGR [COUNT @D135805, PER @D135804, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHOOT, 
   [COORD @D135808, AGR [COUNT @D135807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHOOT, 
   [COORD @D135810, AGR [COUNT @D135809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHOOT, 
   [COORD @D135814, AGR [COUNT @D135813, PER @D135812, PLU @D135811, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : SHOOT, 
   [COORD @D135820, PAST @D135819, 
      AGR [CASE @D135818, COUNT @D135817, PER @D135816, PLU @D135815, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHOOT, 
   [COORD @D135823, AGR [COUNT @D135822, PER @D135821, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHOOT, 
   [COORD @D135825, AGR [COUNT @D135824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHOOT, 
   [COORD @D135827, AGR [COUNT @D135826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHOOT, 
   [COORD @D135831, AGR [COUNT @D135830, PER @D135829, PLU @D135828, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SHOOT, 
   [COORD @D135837, PAST @D135836, 
      AGR [CASE @D135835, COUNT @D135834, PER @D135833, PLU @D135832, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SHOOT, 
   [COORD @D135840, AGR [COUNT @D135839, PER @D135838, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHOOT, 
   [COORD @D135842, AGR [COUNT @D135841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHOOT, 
   [COORD @D135844, AGR [COUNT @D135843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHOOT, 
   [COORD @D135848, AGR [COUNT @D135847, PER @D135846, PLU @D135845, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : SHOOT, 
   [COORD @D135854, PAST @D135853, 
      AGR [CASE @D135852, COUNT @D135851, PER @D135850, PLU @D135849, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : SHOOT, 
   [COORD @D135857, AGR [COUNT @D135856, PER @D135855, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SHOOT, 
   [COORD @D135859, AGR [COUNT @D135858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SHOOT, 
   [COORD @D135861, AGR [COUNT @D135860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SHOOT, 
   [COORD @D135865, AGR [COUNT @D135864, PER @D135863, PLU @D135862, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SHOOT, 
   [COORD @D135871, PAST @D135870, 
      AGR [CASE @D135869, COUNT @D135868, PER @D135867, PLU @D135866, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SHOOT, 
   [COORD @D135874, AGR [COUNT @D135873, PER @D135872, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHOOT, 
   [COORD @D135876, AGR [COUNT @D135875, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHOOT, 
   [COORD @D135878, AGR [COUNT @D135877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHOOT, 
   [COORD @D135882, AGR [COUNT @D135881, PER @D135880, PLU @D135879, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : SHOOT, 
   [COORD @D135888, PAST @D135887, 
      AGR [CASE @D135886, COUNT @D135885, PER @D135884, PLU @D135883, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : SHOOT, 
   [COORD @D135891, AGR [COUNT @D135890, PER @D135889, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SHOOT, 
   [COORD @D135893, AGR [COUNT @D135892, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SHOOT, 
   [COORD @D135895, AGR [COUNT @D135894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SHOOT, 
   [COORD @D135899, AGR [COUNT @D135898, PER @D135897, PLU @D135896, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : SHOOT, 
   [COORD @D135905, PAST @D135904, 
      AGR [CASE @D135903, COUNT @D135902, PER @D135901, PLU @D135900, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : SHOOT.

WORD shooting : 
   [COORD @D135918, PRD @D135917, AGR [CASE @D135916, COUNT @D135915, 
            PER @D135914, PLU @D135913, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D135924, PRD @D135923, 
      AGR [CASE @D135922, COUNT @D135921, PER @D135920, PLU @D135919, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOOT, 
   [COORD @D135930, PRD @D135929, AGR [CASE @D135928, COUNT @D135927, 
            PER @D135926, PLU @D135925, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D135936, PRD @D135935, 
      AGR [CASE @D135934, COUNT @D135933, PER @D135932, PLU @D135931, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOOT, 
   [COORD @D135942, PRD @D135941, AGR [CASE @D135940, COUNT @D135939, 
            PER @D135938, PLU @D135937, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D135948, PRD @D135947, 
      AGR [CASE @D135946, COUNT @D135945, PER @D135944, PLU @D135943, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHOOT, 
   [COORD @D135954, PRD @D135953, AGR [CASE @D135952, COUNT @D135951, 
            PER @D135950, PLU @D135949, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D135960, PRD @D135959, 
      AGR [CASE @D135958, COUNT @D135957, PER @D135956, PLU @D135955, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOOT, 
   [COORD @D135966, PRD @D135965, AGR [CASE @D135964, COUNT @D135963, 
            PER @D135962, PLU @D135961, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D135972, PRD @D135971, 
      AGR [CASE @D135970, COUNT @D135969, PER @D135968, PLU @D135967, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHOOT, 
   [COORD @D135978, PRD @D135977, AGR [CASE @D135976, COUNT @D135975, 
            PER @D135974, PLU @D135973, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D135984, PRD @D135983, 
      AGR [CASE @D135982, COUNT @D135981, PER @D135980, PLU @D135979, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHOOT, 
   [COORD @D135990, PRD @D135989, AGR [CASE @D135988, COUNT @D135987, 
            PER @D135986, PLU @D135985, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D135996, PRD @D135995, 
      AGR [CASE @D135994, COUNT @D135993, PER @D135992, PLU @D135991, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOOT, 
   [COORD @D136002, PRD @D136001, AGR [CASE @D136000, COUNT @D135999, 
            PER @D135998, PLU @D135997, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136008, PRD @D136007, 
      AGR [CASE @D136006, COUNT @D136005, PER @D136004, PLU @D136003, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOOT, 
   [COORD @D136014, PRD @D136013, AGR [CASE @D136012, COUNT @D136011, 
            PER @D136010, PLU @D136009, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136020, PRD @D136019, 
      AGR [CASE @D136018, COUNT @D136017, PER @D136016, PLU @D136015, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOOT.

WORD shoots : 
   [COORD @D136027, AGR [COUNT @D136026, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOOT, 
   [COORD @D136029, AGR [COUNT @D136028, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136031, 
      AGR [COUNT @D136030, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136033, 
      AGR [COUNT @D136032, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136035, 
      AGR [COUNT @D136034, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOOT, 
   [COORD @D136037, AGR [COUNT @D136036, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136039, 
      AGR [COUNT @D136038, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136041, 
      AGR [COUNT @D136040, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136043, 
      AGR [COUNT @D136042, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136045, 
      AGR [COUNT @D136044, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136047, 
      AGR [COUNT @D136046, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136049, 
      AGR [COUNT @D136048, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136051, 
      AGR [COUNT @D136050, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136053, 
      AGR [COUNT @D136052, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136055, 
      AGR [COUNT @D136054, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136057, 
      AGR [COUNT @D136056, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136059, 
      AGR [COUNT @D136058, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT, 
   [COORD @D136061, 
      AGR [COUNT @D136060, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOOT.

WORD shop : 
   [COORD @D136068, AGR [COUNT @D136067, PER @D136066, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHOP, 
   [COORD @D136070, AGR [COUNT @D136069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHOP, 
   [COORD @D136072, AGR [COUNT @D136071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHOP, 
   [COORD @D136076, AGR [COUNT @D136075, PER @D136074, PLU @D136073, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SHOP, 
   [COORD @D136082, PAST @D136081, AGR [CASE @D136080, COUNT @D136079, 
            PER @D136078, PLU @D136077, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SHOP, 
   [COORD @D136085, AGR [COUNT @D136084, PER @D136083, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136087, AGR [COUNT @D136086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136089, AGR [COUNT @D136088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136093, AGR [COUNT @D136092, PER @D136091, PLU @D136090, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136099, PAST @D136098, 
      AGR [CASE @D136097, COUNT @D136096, PER @D136095, PLU @D136094, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136102, AGR [COUNT @D136101, PER @D136100, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136104, AGR [COUNT @D136103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136106, AGR [COUNT @D136105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136110, AGR [COUNT @D136109, PER @D136108, PLU @D136107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT AROUND, PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136116, PAST @D136115, 
      AGR [CASE @D136114, COUNT @D136113, PER @D136112, PLU @D136111, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT AROUND, PFORM FOR, ARITY 2] : SHOP, 
   [COORD @D136119, AGR [COUNT @D136118, PER @D136117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHOP, 
   [COORD @D136121, AGR [COUNT @D136120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHOP, 
   [COORD @D136123, AGR [COUNT @D136122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHOP, 
   [COORD @D136127, AGR [COUNT @D136126, PER @D136125, PLU @D136124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SHOP, 
   [COORD @D136133, PAST @D136132, AGR [CASE @D136131, COUNT @D136130, 
            PER @D136129, PLU @D136128, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SHOP, 
   [COORD @D136136, AGR [COUNT @D136135, PER @D136134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : SHOP, 
   [COORD @D136138, AGR [COUNT @D136137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : SHOP, 
   [COORD @D136140, AGR [COUNT @D136139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : SHOP, 
   [COORD @D136144, AGR [COUNT @D136143, PER @D136142, PLU @D136141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : SHOP, 
   [COORD @D136150, PAST @D136149, 
      AGR [CASE @D136148, COUNT @D136147, PER @D136146, PLU @D136145, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AROUND, ARITY 1] : SHOP.

WORD shopped : 
   [COORD @D136160, AGR [CASE @D136159, COUNT @D136158, PER @D136157, 
            PLU @D136156, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136165, AGR [CASE @D136164, COUNT @D136163, PER @D136162, 
            PLU @D136161, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136170, AGR [CASE @D136169, COUNT @D136168, PER @D136167, 
            PLU @D136166, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOP, 
   [COORD @D136175, AGR [CASE @D136174, COUNT @D136173, PER @D136172, 
            PLU @D136171, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136180, AGR [CASE @D136179, COUNT @D136178, PER @D136177, 
            PLU @D136176, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136185, AGR [CASE @D136184, COUNT @D136183, PER @D136182, 
            PLU @D136181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136190, 
      AGR [CASE @D136189, COUNT @D136188, PER @D136187, PLU @D136186, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136195, AGR [CASE @D136194, COUNT @D136193, PER @D136192, 
            PLU @D136191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136200, AGR [CASE @D136199, COUNT @D136198, PER @D136197, 
            PLU @D136196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136205, AGR [CASE @D136204, COUNT @D136203, PER @D136202, 
            PLU @D136201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136210, AGR [CASE @D136209, COUNT @D136208, PER @D136207, 
            PLU @D136206, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SHOP.

WORD shopping : 
   [COORD @D136221, PRD @D136220, AGR [CASE @D136219, COUNT @D136218, 
            PER @D136217, PLU @D136216, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136227, PRD @D136226, 
      AGR [CASE @D136225, COUNT @D136224, PER @D136223, PLU @D136222, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOP, 
   [COORD @D136233, PRD @D136232, AGR [CASE @D136231, COUNT @D136230, 
            PER @D136229, PLU @D136228, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AROUND, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOP, 
   [COORD @D136239, PRD @D136238, 
      AGR [CASE @D136237, COUNT @D136236, PER @D136235, PLU @D136234, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOP, 
   [COORD @D136245, PRD @D136244, AGR [CASE @D136243, COUNT @D136242, 
            PER @D136241, PLU @D136240, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOP.

WORD shops : 
   [COORD @D136252, AGR [COUNT @D136251, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOP, 
   [COORD @D136254, 
      AGR [COUNT @D136253, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOP, 
   [COORD @D136256, 
      AGR [COUNT @D136255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT AROUND, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHOP, 
   [COORD @D136258, AGR [COUNT @D136257, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOP, 
   [COORD @D136260, 
      AGR [COUNT @D136259, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOP.

WORD shot : 
   [COADV @D136272, COORD @D136271, DEF @D136270, PRD @D136269, AGR 
         [CASE @D136268, COUNT @D136267, PER @D136266, PLU @D136265, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, DISTR PRD] : SHOT, 
   [COADV @D136280, COORD @D136279, DEF @D136278, PRD @D136277, 
      AGR [CASE @D136276, COUNT @D136275, PER @D136274, PLU @D136273, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : SHOT, 
   [COADV @D136288, COORD @D136287, DEF @D136286, PRD @D136285, 
      AGR [CASE @D136284, COUNT @D136283, PER @D136282, PLU @D136281, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PRT THROUGH, 
      PFORM WITH, DISTR PRD, ARITY 2] : SHOT, 
   [COADV @D136296, COORD @D136295, DEF @D136294, PRD @D136293, 
      AGR [CASE @D136292, COUNT @D136291, PER @D136290, PLU @D136289, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, DISTR PRD, 
      ARITY 2] : SHOT, 
   [COADV @D136304, COORD @D136303, DEF @D136302, PRD @D136301, 
      AGR [CASE @D136300, COUNT @D136299, PER @D136298, PLU @D136297, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, DISTR PRD, ARITY 2] : SHOT, 
   [COORD @D136309, REFL @D136308, COUNT @D136307, PRD @D136306, 
      CASE @D136305, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SHOT, 
   [COORD @D136315, PAST @D136314, 
      AGR [CASE @D136313, COUNT @D136312, PER @D136311, PLU @D136310, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, 
      ARITY 3] : SHOOT, 
   [COORD @D136321, PAST @D136320, AGR [CASE @D136319, COUNT @D136318, 
            PER @D136317, PLU @D136316, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : SHOOT, 
   [COORD @D136327, PAST @D136326, 
      AGR [CASE @D136325, COUNT @D136324, PER @D136323, PLU @D136322, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : SHOOT, 
   [COORD @D136333, PAST @D136332, AGR [CASE @D136331, COUNT @D136330, 
            PER @D136329, PLU @D136328, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : SHOOT, 
   [COORD @D136339, PAST @D136338, 
      AGR [CASE @D136337, COUNT @D136336, PER @D136335, PLU @D136334, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : SHOOT, 
   [COORD @D136345, PAST @D136344, AGR [CASE @D136343, COUNT @D136342, 
            PER @D136341, PLU @D136340, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : SHOOT, 
   [COORD @D136351, PAST @D136350, 
      AGR [CASE @D136349, COUNT @D136348, PER @D136347, PLU @D136346, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM AT, 
      FIN -, ARITY 3] : SHOOT, 
   [COORD @D136357, PAST @D136356, AGR [CASE @D136355, COUNT @D136354, 
            PER @D136353, PLU @D136352, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM AT, FIN -, ARITY 3] : SHOOT, 
   [COORD @D136363, PAST @D136362, 
      AGR [CASE @D136361, COUNT @D136360, PER @D136359, PLU @D136358, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM WITH, FIN -, ARITY 3] : SHOOT, 
   [COORD @D136369, PAST @D136368, 
      AGR [CASE @D136367, COUNT @D136366, PER @D136365, PLU @D136364, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM WITH, FIN -, ARITY 3] : SHOOT, 
   [COORD @D136373, AGR [COUNT @D136372, PER @D136371, PLU @D136370, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 3] : SHOOT, 
   [COORD @D136377, AGR [COUNT @D136376, PER @D136375, PLU @D136374, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : SHOOT, 
   [COORD @D136381, AGR [COUNT @D136380, PER @D136379, PLU @D136378, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : SHOOT, 
   [COORD @D136385, AGR [COUNT @D136384, PER @D136383, PLU @D136382, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM AT, PAST +, ARITY 3] : SHOOT, 
   [COORD @D136389, 
      AGR [COUNT @D136388, PER @D136387, PLU @D136386, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, PFORM WITH, PAST +, ARITY 3] : SHOOT, 
   [COORD @D136395, PAST @D136394, 
      AGR [CASE @D136393, COUNT @D136392, PER @D136391, PLU @D136390, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SHOOT, 
   [COORD @D136401, PAST @D136400, AGR [CASE @D136399, COUNT @D136398, 
            PER @D136397, PLU @D136396, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SHOOT, 
   [COORD @D136407, PAST @D136406, 
      AGR [CASE @D136405, COUNT @D136404, PER @D136403, PLU @D136402, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, FIN -, 
      ARITY 2] : SHOOT, 
   [COORD @D136413, PAST @D136412, AGR [CASE @D136411, COUNT @D136410, 
            PER @D136409, PLU @D136408, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM FOR, FIN -, ARITY 2] : SHOOT, 
   [COORD @D136419, PAST @D136418, 
      AGR [CASE @D136417, COUNT @D136416, PER @D136415, PLU @D136414, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, FIN -, 
      ARITY 2] : SHOOT, 
   [COORD @D136425, PAST @D136424, AGR [CASE @D136423, COUNT @D136422, 
            PER @D136421, PLU @D136420, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AT, FIN -, ARITY 2] : SHOOT, 
   [COORD @D136431, PAST @D136430, 
      AGR [CASE @D136429, COUNT @D136428, PER @D136427, PLU @D136426, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AT, FIN -, 
      ARITY 2] : SHOOT, 
   [COORD @D136437, PAST @D136436, AGR [CASE @D136435, COUNT @D136434, 
            PER @D136433, PLU @D136432, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : SHOOT, 
   [COORD @D136443, PAST @D136442, 
      AGR [CASE @D136441, COUNT @D136440, PER @D136439, PLU @D136438, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : SHOOT, 
   [COORD @D136449, PAST @D136448, AGR [CASE @D136447, COUNT @D136446, 
            PER @D136445, PLU @D136444, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SHOOT, 
   [COORD @D136455, PAST @D136454, 
      AGR [CASE @D136453, COUNT @D136452, PER @D136451, PLU @D136450, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : SHOOT, 
   [COORD @D136461, PAST @D136460, AGR [CASE @D136459, COUNT @D136458, 
            PER @D136457, PLU @D136456, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : SHOOT, 
   [COORD @D136467, PAST @D136466, 
      AGR [CASE @D136465, COUNT @D136464, PER @D136463, PLU @D136462, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : SHOOT, 
   [COORD @D136473, PAST @D136472, AGR [CASE @D136471, COUNT @D136470, 
            PER @D136469, PLU @D136468, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : SHOOT, 
   [COORD @D136479, PAST @D136478, 
      AGR [CASE @D136477, COUNT @D136476, PER @D136475, PLU @D136474, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      FIN -, ARITY 2] : SHOOT, 
   [COORD @D136483, AGR [COUNT @D136482, PER @D136481, PLU @D136480, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136487, AGR [COUNT @D136486, PER @D136485, PLU @D136484, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136491, AGR [COUNT @D136490, PER @D136489, PLU @D136488, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136495, AGR [COUNT @D136494, PER @D136493, PLU @D136492, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136499, AGR [COUNT @D136498, PER @D136497, PLU @D136496, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136503, AGR [COUNT @D136502, PER @D136501, PLU @D136500, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136507, AGR [COUNT @D136506, PER @D136505, PLU @D136504, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136511, AGR [COUNT @D136510, PER @D136509, PLU @D136508, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : SHOOT, 
   [COORD @D136517, PAST @D136516, 
      AGR [CASE @D136515, COUNT @D136514, PER @D136513, PLU @D136512, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SHOOT, 
   [COORD @D136523, PAST @D136522, AGR [CASE @D136521, COUNT @D136520, 
            PER @D136519, PLU @D136518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : SHOOT, 
   [COORD @D136529, PAST @D136528, 
      AGR [CASE @D136527, COUNT @D136526, PER @D136525, PLU @D136524, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : SHOOT, 
   [COORD @D136535, PAST @D136534, AGR [CASE @D136533, COUNT @D136532, 
            PER @D136531, PLU @D136530, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : SHOOT, 
   [COORD @D136541, PAST @D136540, 
      AGR [CASE @D136539, COUNT @D136538, PER @D136537, PLU @D136536, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      FIN -, ARITY 1] : SHOOT, 
   [COORD @D136545, AGR [COUNT @D136544, PER @D136543, PLU @D136542, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : SHOOT, 
   [COORD @D136549, AGR [COUNT @D136548, PER @D136547, PLU @D136546, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SHOOT, 
   [COORD @D136553, 
      AGR [COUNT @D136552, PER @D136551, PLU @D136550, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : SHOOT, 
   [COORD @D136557, AGR [COUNT @D136556, PER @D136555, PLU @D136554, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : SHOOT, 
   [COORD @D136561, 
      AGR [COUNT @D136560, PER @D136559, PLU @D136558, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : SHOOT.

WORD shots : 
   [COORD @D136573, DEMON @D136572, REFL @D136571, PRD @D136570, 
      CASE @D136569, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHOT.

WORD shoulder : 
   [COORD @D136601, REFL @D136600, COUNT @D136599, PRD @D136598, 
      CASE @D136597, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SHOULDER, 
   [COORD @D136604, 
      AGR [COUNT @D136603, PER @D136602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   SHOULDER, 
   [COORD @D136606, AGR [COUNT @D136605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SHOULDER, 
   [COORD @D136608, AGR [COUNT @D136607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SHOULDER, 
   [COORD @D136612, AGR [COUNT @D136611, PER @D136610, PLU @D136609, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SHOULDER, 
   [COORD @D136618, PAST @D136617, 
      AGR [CASE @D136616, COUNT @D136615, PER @D136614, PLU @D136613, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      ARITY 3] : SHOULDER, 
   [COORD @D136621, AGR [COUNT @D136620, PER @D136619, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHOULDER, 
   [COORD @D136623, AGR [COUNT @D136622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHOULDER, 
   [COORD @D136625, AGR [COUNT @D136624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SHOULDER, 
   [COORD @D136629, AGR [COUNT @D136628, PER @D136627, PLU @D136626, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SHOULDER, 
   [COORD @D136635, PAST @D136634, AGR [CASE @D136633, COUNT @D136632, 
            PER @D136631, PLU @D136630, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SHOULDER.

WORD shouldered : 
   [COORD @D136647, AGR [CASE @D136646, COUNT @D136645, PER @D136644, 
            PLU @D136643, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOULDER, 
   [COORD @D136652, AGR [CASE @D136651, COUNT @D136650, PER @D136649, 
            PLU @D136648, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHOULDER, 
   [COORD @D136657, AGR [CASE @D136656, COUNT @D136655, PER @D136654, 
            PLU @D136653, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHOULDER, 
   [COORD @D136662, AGR [CASE @D136661, COUNT @D136660, PER @D136659, 
            PLU @D136658, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOULDER, 
   [COORD @D136667, AGR [CASE @D136666, COUNT @D136665, PER @D136664, 
            PLU @D136663, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SHOULDER, 
   [COORD @D136672, AGR [CASE @D136671, COUNT @D136670, PER @D136669, 
            PLU @D136668, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SHOULDER.

WORD shouldering : 
   [COORD @D136689, PRD @D136688, AGR [CASE @D136687, COUNT @D136686, 
            PER @D136685, PLU @D136684, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOULDER, 
   [COORD @D136695, PRD @D136694, 
      AGR [CASE @D136693, COUNT @D136692, PER @D136691, PLU @D136690, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHOULDER.

WORD shoulders : 
   [COORD @D136707, DEMON @D136706, REFL @D136705, PRD @D136704, 
      CASE @D136703, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHOULDER, 
   [COORD @D136709, AGR [COUNT @D136708, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOULDER, 
   [COORD @D136711, AGR [COUNT @D136710, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOULDER.

WORD show : 
   [COORD @D136720, REFL @D136719, COUNT @D136718, PRD @D136717, 
      CASE @D136716, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SHOW, 
   [COORD @D136724, REFL @D136723, PRD @D136722, CASE @D136721, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : SHOW, 
   [COORD @D136728, REFL @D136727, PRD @D136726, CASE @D136725, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHOW, 
   [COORD @D136731, 
      AGR [COUNT @D136730, PER @D136729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, REG -, ARITY 3] : 
   SHOW, 
   [COORD @D136733, AGR [COUNT @D136732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136735, AGR [COUNT @D136734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136739, AGR [COUNT @D136738, PER @D136737, PLU @D136736, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, ARITY 3] : SHOW, 
   [COORD @D136745, PAST @D136744, 
      AGR [CASE @D136743, COUNT @D136742, PER @D136741, PLU @D136740, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136748, AGR [COUNT @D136747, PER @D136746, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136750, AGR [COUNT @D136749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136752, AGR [COUNT @D136751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136756, AGR [COUNT @D136755, PER @D136754, PLU @D136753, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHVP, REG -, ARITY 3] : SHOW, 
   [COORD @D136762, PAST @D136761, 
      AGR [CASE @D136760, COUNT @D136759, PER @D136758, PLU @D136757, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, REG -, 
      ARITY 3] : SHOW, 
   [COORD @D136765, AGR [COUNT @D136764, PER @D136763, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136767, AGR [COUNT @D136766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136769, AGR [COUNT @D136768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136773, AGR [COUNT @D136772, PER @D136771, PLU @D136770, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHS, REG -, ARITY 3] : SHOW, 
   [COORD @D136779, PAST @D136778, 
      AGR [CASE @D136777, COUNT @D136776, PER @D136775, PLU @D136774, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, REG -, 
      ARITY 3] : SHOW, 
   [COORD @D136782, AGR [COUNT @D136781, PER @D136780, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136784, AGR [COUNT @D136783, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136786, AGR [COUNT @D136785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136790, AGR [COUNT @D136789, PER @D136788, PLU @D136787, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, ARITY 3] : SHOW, 
   [COORD @D136796, PAST @D136795, 
      AGR [CASE @D136794, COUNT @D136793, PER @D136792, PLU @D136791, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, REG -, 
      ARITY 3] : SHOW, 
   [COORD @D136799, AGR [COUNT @D136798, PER @D136797, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136801, AGR [COUNT @D136800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136803, AGR [COUNT @D136802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136807, AGR [COUNT @D136806, PER @D136805, PLU @D136804, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : SHOW, 
   [COORD @D136813, PAST @D136812, 
      AGR [CASE @D136811, COUNT @D136810, PER @D136809, PLU @D136808, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : SHOW, 
   [COORD @D136816, AGR [COUNT @D136815, PER @D136814, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136818, AGR [COUNT @D136817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136820, AGR [COUNT @D136819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : SHOW, 
   [COORD @D136824, AGR [COUNT @D136823, PER @D136822, PLU @D136821, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : SHOW, 
   [COORD @D136830, PAST @D136829, 
      AGR [CASE @D136828, COUNT @D136827, PER @D136826, PLU @D136825, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : SHOW, 
   [COORD @D136833, AGR [COUNT @D136832, PER @D136831, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SHOW, 
   [COORD @D136835, AGR [COUNT @D136834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SHOW, 
   [COORD @D136837, AGR [COUNT @D136836, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SHOW, 
   [COORD @D136841, AGR [COUNT @D136840, PER @D136839, PLU @D136838, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : SHOW, 
   [COORD @D136847, PAST @D136846, 
      AGR [CASE @D136845, COUNT @D136844, PER @D136843, PLU @D136842, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SHOW, 
   [COORD @D136850, AGR [COUNT @D136849, PER @D136848, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ROUND, ARITY 3] : SHOW, 
   [COORD @D136852, AGR [COUNT @D136851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ROUND, ARITY 3] : SHOW, 
   [COORD @D136854, AGR [COUNT @D136853, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ROUND, ARITY 3] : SHOW, 
   [COORD @D136858, AGR [COUNT @D136857, PER @D136856, PLU @D136855, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM ROUND, ARITY 3] : SHOW, 
   [COORD @D136864, PAST @D136863, 
      AGR [CASE @D136862, COUNT @D136861, PER @D136860, PLU @D136859, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM ROUND, ARITY 3] : SHOW, 
   [COORD @D136867, AGR [COUNT @D136866, PER @D136865, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : SHOW, 
   [COORD @D136869, AGR [COUNT @D136868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : SHOW, 
   [COORD @D136871, AGR [COUNT @D136870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : SHOW, 
   [COORD @D136875, AGR [COUNT @D136874, PER @D136873, PLU @D136872, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OVER, ARITY 3] : SHOW, 
   [COORD @D136881, PAST @D136880, 
      AGR [CASE @D136879, COUNT @D136878, PER @D136877, PLU @D136876, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : SHOW, 
   [COORD @D136884, AGR [COUNT @D136883, PER @D136882, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AROUND, ARITY 3] : SHOW, 
   [COORD @D136886, AGR [COUNT @D136885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AROUND, ARITY 3] : SHOW, 
   [COORD @D136888, AGR [COUNT @D136887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AROUND, ARITY 3] : SHOW, 
   [COORD @D136892, AGR [COUNT @D136891, PER @D136890, PLU @D136889, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM AROUND, ARITY 3] : SHOW, 
   [COORD @D136898, PAST @D136897, 
      AGR [CASE @D136896, COUNT @D136895, PER @D136894, PLU @D136893, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PFORM AROUND, ARITY 3] : SHOW, 
   [COORD @D136901, AGR [COUNT @D136900, PER @D136899, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136903, AGR [COUNT @D136902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136905, AGR [COUNT @D136904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136909, AGR [COUNT @D136908, PER @D136907, PLU @D136906, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, ARITY 2] : SHOW, 
   [COORD @D136915, PAST @D136914, 
      AGR [CASE @D136913, COUNT @D136912, PER @D136911, PLU @D136910, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D136918, AGR [COUNT @D136917, PER @D136916, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D136920, AGR [COUNT @D136919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D136922, AGR [COUNT @D136921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D136926, AGR [COUNT @D136925, PER @D136924, PLU @D136923, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136932, PAST @D136931, AGR [CASE @D136930, COUNT @D136929, 
            PER @D136928, PLU @D136927, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, ARITY 2] : SHOW, 
   [COORD @D136935, AGR 
         [COUNT @D136934, PER @D136933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   SHOW, 
   [COORD @D136937, AGR [COUNT @D136936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136939, AGR [COUNT @D136938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136943, AGR [COUNT @D136942, PER @D136941, PLU @D136940, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : SHOW, 
   [COORD @D136949, PAST @D136948, 
      AGR [CASE @D136947, COUNT @D136946, PER @D136945, PLU @D136944, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D136952, AGR [COUNT @D136951, PER @D136950, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136954, AGR [COUNT @D136953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136956, AGR [COUNT @D136955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136960, AGR [COUNT @D136959, PER @D136958, PLU @D136957, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : SHOW, 
   [COORD @D136966, PAST @D136965, 
      AGR [CASE @D136964, COUNT @D136963, PER @D136962, PLU @D136961, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136969, AGR [COUNT @D136968, PER @D136967, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136971, AGR [COUNT @D136970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136973, AGR [COUNT @D136972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136977, AGR [COUNT @D136976, PER @D136975, PLU @D136974, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, ARITY 2] : SHOW, 
   [COORD @D136983, PAST @D136982, 
      AGR [CASE @D136981, COUNT @D136980, PER @D136979, PLU @D136978, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136986, AGR [COUNT @D136985, PER @D136984, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136988, AGR [COUNT @D136987, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136990, AGR [COUNT @D136989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D136994, AGR [COUNT @D136993, PER @D136992, PLU @D136991, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, ARITY 2] : SHOW, 
   [COORD @D137000, PAST @D136999, 
      AGR [CASE @D136998, COUNT @D136997, PER @D136996, PLU @D136995, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D137003, AGR [COUNT @D137002, PER @D137001, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D137005, AGR [COUNT @D137004, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D137007, AGR [COUNT @D137006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D137011, AGR [COUNT @D137010, PER @D137009, PLU @D137008, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, ARITY 2] : SHOW, 
   [COORD @D137017, PAST @D137016, 
      AGR [CASE @D137015, COUNT @D137014, PER @D137013, PLU @D137012, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D137020, AGR [COUNT @D137019, PER @D137018, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D137022, AGR [COUNT @D137021, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D137024, AGR [COUNT @D137023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHOW, 
   [COORD @D137028, AGR [COUNT @D137027, PER @D137026, PLU @D137025, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SHOW, 
   [COORD @D137034, PAST @D137033, AGR [CASE @D137032, COUNT @D137031, 
            PER @D137030, PLU @D137029, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SHOW, 
   [COORD @D137037, AGR [COUNT @D137036, PER @D137035, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SHOW, 
   [COORD @D137039, AGR [COUNT @D137038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SHOW, 
   [COORD @D137041, AGR [COUNT @D137040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SHOW, 
   [COORD @D137045, AGR [COUNT @D137044, PER @D137043, PLU @D137042, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT ROUND, ARITY 2] : SHOW, 
   [COORD @D137051, PAST @D137050, 
      AGR [CASE @D137049, COUNT @D137048, PER @D137047, PLU @D137046, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT ROUND, ARITY 2] : SHOW, 
   [COORD @D137054, AGR [COUNT @D137053, PER @D137052, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT AROUND, ARITY 2] : SHOW, 
   [COORD @D137056, AGR [COUNT @D137055, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT AROUND, ARITY 2] : SHOW, 
   [COORD @D137058, AGR [COUNT @D137057, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT AROUND, ARITY 2] : SHOW, 
   [COORD @D137062, AGR [COUNT @D137061, PER @D137060, PLU @D137059, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT AROUND, ARITY 2] : SHOW, 
   [COORD @D137068, PAST @D137067, 
      AGR [CASE @D137066, COUNT @D137065, PER @D137064, PLU @D137063, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT AROUND, ARITY 2] : SHOW, 
   [COORD @D137071, AGR [COUNT @D137070, PER @D137069, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHOW, 
   [COORD @D137073, AGR [COUNT @D137072, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHOW, 
   [COORD @D137075, AGR [COUNT @D137074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHOW, 
   [COORD @D137079, AGR [COUNT @D137078, PER @D137077, PLU @D137076, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : SHOW, 
   [COORD @D137085, PAST @D137084, 
      AGR [CASE @D137083, COUNT @D137082, PER @D137081, PLU @D137080, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : SHOW, 
   [COORD @D137088, AGR [COUNT @D137087, PER @D137086, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHOW, 
   [COORD @D137090, AGR [COUNT @D137089, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHOW, 
   [COORD @D137092, AGR [COUNT @D137091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHOW, 
   [COORD @D137096, AGR [COUNT @D137095, PER @D137094, PLU @D137093, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : SHOW, 
   [COORD @D137102, PAST @D137101, 
      AGR [CASE @D137100, COUNT @D137099, PER @D137098, PLU @D137097, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : SHOW, 
   [COORD @D137105, AGR [COUNT @D137104, PER @D137103, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHOW, 
   [COORD @D137107, AGR [COUNT @D137106, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHOW, 
   [COORD @D137109, AGR [COUNT @D137108, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHOW, 
   [COORD @D137113, AGR [COUNT @D137112, PER @D137111, PLU @D137110, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SHOW, 
   [COORD @D137119, PAST @D137118, 
      AGR [CASE @D137117, COUNT @D137116, PER @D137115, PLU @D137114, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SHOW, 
   [COORD @D137122, AGR [COUNT @D137121, PER @D137120, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHOW, 
   [COORD @D137124, AGR [COUNT @D137123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHOW, 
   [COORD @D137126, AGR [COUNT @D137125, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHOW, 
   [COORD @D137130, AGR [COUNT @D137129, PER @D137128, PLU @D137127, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : SHOW, 
   [COORD @D137136, PAST @D137135, 
      AGR [CASE @D137134, COUNT @D137133, PER @D137132, PLU @D137131, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : SHOW, 
   [COORD @D137139, AGR [COUNT @D137138, PER @D137137, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : SHOW, 
   [COORD @D137141, AGR [COUNT @D137140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : SHOW, 
   [COORD @D137143, AGR [COUNT @D137142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ROUND, ARITY 1] : SHOW, 
   [COORD @D137147, AGR [COUNT @D137146, PER @D137145, PLU @D137144, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ROUND, ARITY 1] : SHOW, 
   [COORD @D137153, PAST @D137152, 
      AGR [CASE @D137151, COUNT @D137150, PER @D137149, PLU @D137148, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ROUND, ARITY 1] : SHOW, 
   [COORD @D137156, AGR [COUNT @D137155, PER @D137154, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHOW, 
   [COORD @D137158, AGR [COUNT @D137157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHOW, 
   [COORD @D137160, AGR [COUNT @D137159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHOW, 
   [COORD @D137164, AGR [COUNT @D137163, PER @D137162, PLU @D137161, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : SHOW, 
   [COORD @D137170, PAST @D137169, 
      AGR [CASE @D137168, COUNT @D137167, PER @D137166, PLU @D137165, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : SHOW, 
   [COORD @D137173, AGR [COUNT @D137172, PER @D137171, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : SHOW, 
   [COORD @D137175, AGR [COUNT @D137174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : SHOW, 
   [COORD @D137177, AGR [COUNT @D137176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : SHOW, 
   [COORD @D137181, AGR [COUNT @D137180, PER @D137179, PLU @D137178, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, ARITY 1] : SHOW, 
   [COORD @D137187, PAST @D137186, 
      AGR [CASE @D137185, COUNT @D137184, PER @D137183, PLU @D137182, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, ARITY 1] : SHOW.

WORD showed : 
   [COORD @D137197, AGR [COUNT @D137196, PER @D137195, PLU @D137194, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, REG -, PAST +, ARITY 3] : SHOW, 
   [COORD @D137201, AGR [COUNT @D137200, PER @D137199, PLU @D137198, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHVP, REG -, PAST +, ARITY 3] : SHOW, 
   [COORD @D137205, AGR [COUNT @D137204, PER @D137203, PLU @D137202, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHS, REG -, PAST +, ARITY 3] : SHOW, 
   [COORD @D137209, AGR [COUNT @D137208, PER @D137207, PLU @D137206, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, PAST +, ARITY 3] : SHOW, 
   [COORD @D137213, AGR [COUNT @D137212, PER @D137211, PLU @D137210, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : SHOW, 
   [COORD @D137217, AGR [COUNT @D137216, PER @D137215, PLU @D137214, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : SHOW, 
   [COORD @D137221, AGR [COUNT @D137220, PER @D137219, PLU @D137218, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, PAST +, ARITY 3] : SHOW, 
   [COORD @D137225, 
      AGR [COUNT @D137224, PER @D137223, PLU @D137222, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM ROUND, PAST +, ARITY 3] : SHOW, 
   [COORD @D137229, AGR [COUNT @D137228, PER @D137227, PLU @D137226, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PFORM OVER, PAST +, ARITY 3] : SHOW, 
   [COORD @D137233, 
      AGR [COUNT @D137232, PER @D137231, PLU @D137230, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, 
      PFORM AROUND, PAST +, ARITY 3] : SHOW, 
   [COORD @D137237, AGR [COUNT @D137236, PER @D137235, PLU @D137234, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137241, AGR [COUNT @D137240, PER @D137239, PLU @D137238, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137245, AGR [COUNT @D137244, PER @D137243, PLU @D137242, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137249, AGR [COUNT @D137248, PER @D137247, PLU @D137246, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137253, AGR [COUNT @D137252, PER @D137251, PLU @D137250, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137257, AGR [COUNT @D137256, PER @D137255, PLU @D137254, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137261, AGR [COUNT @D137260, PER @D137259, PLU @D137258, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137265, AGR [COUNT @D137264, PER @D137263, PLU @D137262, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SHOW, 
   [COORD @D137269, AGR [COUNT @D137268, PER @D137267, PLU @D137266, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT ROUND, PAST +, ARITY 2] : SHOW, 
   [COORD @D137273, 
      AGR [COUNT @D137272, PER @D137271, PLU @D137270, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT AROUND, PAST +, ARITY 2] : SHOW, 
   [COORD @D137277, AGR [COUNT @D137276, PER @D137275, PLU @D137274, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : SHOW, 
   [COORD @D137281, AGR [COUNT @D137280, PER @D137279, PLU @D137278, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : SHOW, 
   [COORD @D137285, AGR [COUNT @D137284, PER @D137283, PLU @D137282, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : SHOW, 
   [COORD @D137289, AGR [COUNT @D137288, PER @D137287, PLU @D137286, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SHOW, 
   [COORD @D137293, 
      AGR [COUNT @D137292, PER @D137291, PLU @D137290, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ROUND, PAST +, ARITY 1] : SHOW, 
   [COORD @D137297, AGR [COUNT @D137296, PER @D137295, PLU @D137294, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : SHOW, 
   [COORD @D137301, 
      AGR [COUNT @D137300, PER @D137299, PLU @D137298, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, PAST +, ARITY 1] : SHOW.

WORD showing : 
   [COORD @D137342, REFL @D137341, PRD @D137340, CASE @D137339, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHOWING, 
   [COORD @D137346, REFL @D137345, PRD @D137344, CASE @D137343, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SHOWING, 
   [COORD @D137352, PRD @D137351, 
      AGR [CASE @D137350, COUNT @D137349, PER @D137348, PLU @D137347, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137358, PRD @D137357, AGR [CASE @D137356, COUNT @D137355, 
            PER @D137354, PLU @D137353, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137364, PRD @D137363, 
      AGR [CASE @D137362, COUNT @D137361, PER @D137360, PLU @D137359, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137370, PRD @D137369, AGR [CASE @D137368, COUNT @D137367, 
            PER @D137366, PLU @D137365, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137376, PRD @D137375, 
      AGR [CASE @D137374, COUNT @D137373, PER @D137372, PLU @D137371, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137382, PRD @D137381, AGR [CASE @D137380, COUNT @D137379, 
            PER @D137378, PLU @D137377, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137388, PRD @D137387, 
      AGR [CASE @D137386, COUNT @D137385, PER @D137384, PLU @D137383, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137394, PRD @D137393, AGR [CASE @D137392, COUNT @D137391, 
            PER @D137390, PLU @D137389, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137400, PRD @D137399, 
      AGR [CASE @D137398, COUNT @D137397, PER @D137396, PLU @D137395, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137406, PRD @D137405, AGR [CASE @D137404, COUNT @D137403, 
            PER @D137402, PLU @D137401, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137412, PRD @D137411, 
      AGR [CASE @D137410, COUNT @D137409, PER @D137408, PLU @D137407, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137418, PRD @D137417, AGR [CASE @D137416, COUNT @D137415, 
            PER @D137414, PLU @D137413, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137424, PRD @D137423, 
      AGR [CASE @D137422, COUNT @D137421, PER @D137420, PLU @D137419, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137430, PRD @D137429, AGR [CASE @D137428, COUNT @D137427, 
            PER @D137426, PLU @D137425, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137436, PRD @D137435, 
      AGR [CASE @D137434, COUNT @D137433, PER @D137432, PLU @D137431, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137442, PRD @D137441, AGR [CASE @D137440, COUNT @D137439, 
            PER @D137438, PLU @D137437, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137448, PRD @D137447, 
      AGR [CASE @D137446, COUNT @D137445, PER @D137444, PLU @D137443, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137454, PRD @D137453, AGR [CASE @D137452, COUNT @D137451, 
            PER @D137450, PLU @D137449, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137460, PRD @D137459, 
      AGR [CASE @D137458, COUNT @D137457, PER @D137456, PLU @D137455, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOW, 
   [COORD @D137466, PRD @D137465, AGR [CASE @D137464, COUNT @D137463, 
            PER @D137462, PLU @D137461, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT AROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137472, PRD @D137471, 
      AGR [CASE @D137470, COUNT @D137469, PER @D137468, PLU @D137467, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHOW, 
   [COORD @D137478, PRD @D137477, AGR [CASE @D137476, COUNT @D137475, 
            PER @D137474, PLU @D137473, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137484, PRD @D137483, 
      AGR [CASE @D137482, COUNT @D137481, PER @D137480, PLU @D137479, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137490, PRD @D137489, AGR [CASE @D137488, COUNT @D137487, 
            PER @D137486, PLU @D137485, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137496, PRD @D137495, 
      AGR [CASE @D137494, COUNT @D137493, PER @D137492, PLU @D137491, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOW, 
   [COORD @D137502, PRD @D137501, AGR [CASE @D137500, COUNT @D137499, 
            PER @D137498, PLU @D137497, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHOW, 
   [COORD @D137508, PRD @D137507, 
      AGR [CASE @D137506, COUNT @D137505, PER @D137504, PLU @D137503, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHOW.

WORD showings : 
   [COORD @D137526, DEMON @D137525, REFL @D137524, PRD @D137523, 
      CASE @D137522, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHOWING.

WORD shows : 
   [COORD @D137537, DEMON @D137536, REFL @D137535, PRD @D137534, 
      CASE @D137533, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SHOW, 
   [COORD @D137539, AGR [COUNT @D137538, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137541, AGR [COUNT @D137540, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137543, AGR [COUNT @D137542, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137545, AGR [COUNT @D137544, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137547, AGR [COUNT @D137546, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137549, 
      AGR [COUNT @D137548, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137551, 
      AGR [COUNT @D137550, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137553, 
      AGR [COUNT @D137552, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SHOW, 
   [COORD @D137555, AGR [COUNT @D137554, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137557, AGR [COUNT @D137556, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHOW, 
   [COORD @D137559, AGR [COUNT @D137558, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137561, 
      AGR [COUNT @D137560, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137563, 
      AGR [COUNT @D137562, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137565, 
      AGR [COUNT @D137564, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137567, 
      AGR [COUNT @D137566, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137569, 
      AGR [COUNT @D137568, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137571, 
      AGR [COUNT @D137570, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137573, 
      AGR [COUNT @D137572, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137575, 
      AGR [COUNT @D137574, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137577, 
      AGR [COUNT @D137576, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137579, 
      AGR [COUNT @D137578, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137581, 
      AGR [COUNT @D137580, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137583, 
      AGR [COUNT @D137582, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137585, 
      AGR [COUNT @D137584, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137587, 
      AGR [COUNT @D137586, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137589, 
      AGR [COUNT @D137588, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW, 
   [COORD @D137591, 
      AGR [COUNT @D137590, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHOW.

WORD shut : 
   [COORD @D137598, AGR [COUNT @D137597, PER @D137596, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OUT, ARITY 3] : SHUT, 
   [COORD @D137600, AGR [COUNT @D137599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OUT, ARITY 3] : SHUT, 
   [COORD @D137602, AGR [COUNT @D137601, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OUT, ARITY 3] : SHUT, 
   [COORD @D137606, AGR [COUNT @D137605, PER @D137604, PLU @D137603, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OUT, ARITY 3] : SHUT, 
   [COORD @D137612, PAST @D137611, 
      AGR [CASE @D137610, COUNT @D137609, PER @D137608, PLU @D137607, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OUT, ARITY 3] : SHUT, 
   [COORD @D137615, AGR [COUNT @D137614, PER @D137613, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SHUT, 
   [COORD @D137617, AGR [COUNT @D137616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SHUT, 
   [COORD @D137619, AGR [COUNT @D137618, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SHUT, 
   [COORD @D137623, AGR [COUNT @D137622, PER @D137621, PLU @D137620, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, ARITY 3] : SHUT, 
   [COORD @D137629, PAST @D137628, 
      AGR [CASE @D137627, COUNT @D137626, PER @D137625, PLU @D137624, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM IN, ARITY 3] : SHUT, 
   [COORD @D137632, AGR [COUNT @D137631, PER @D137630, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM FROM, ARITY 3] : SHUT, 
   [COORD @D137634, AGR [COUNT @D137633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM FROM, ARITY 3] : SHUT, 
   [COORD @D137636, AGR [COUNT @D137635, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PFORM FROM, ARITY 3] : SHUT, 
   [COORD @D137640, AGR [COUNT @D137639, PER @D137638, PLU @D137637, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM FROM, ARITY 3] : SHUT, 
   [COORD @D137646, PAST @D137645, 
      AGR [CASE @D137644, COUNT @D137643, PER @D137642, PLU @D137641, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM FROM, ARITY 3] : SHUT, 
   [COORD @D137652, PAST @D137651, AGR [CASE @D137650, COUNT @D137649, 
            PER @D137648, PLU @D137647, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OUT, FIN -, ARITY 3] : SHUT, 
   [COORD @D137658, PAST @D137657, 
      AGR [CASE @D137656, COUNT @D137655, PER @D137654, PLU @D137653, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OUT, 
      FIN -, ARITY 3] : SHUT, 
   [COORD @D137664, PAST @D137663, AGR [CASE @D137662, COUNT @D137661, 
            PER @D137660, PLU @D137659, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, FIN -, ARITY 3] : SHUT, 
   [COORD @D137670, PAST @D137669, 
      AGR [CASE @D137668, COUNT @D137667, PER @D137666, PLU @D137665, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM IN, 
      FIN -, ARITY 3] : SHUT, 
   [COORD @D137676, PAST @D137675, AGR [CASE @D137674, COUNT @D137673, 
            PER @D137672, PLU @D137671, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM FROM, FIN -, ARITY 3] : SHUT, 
   [COORD @D137682, PAST @D137681, 
      AGR [CASE @D137680, COUNT @D137679, PER @D137678, PLU @D137677, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      PFORM FROM, FIN -, ARITY 3] : SHUT, 
   [COORD @D137686, AGR [COUNT @D137685, PER @D137684, PLU @D137683, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OUT, PAST +, ARITY 3] : SHUT, 
   [COORD @D137690, 
      AGR [COUNT @D137689, PER @D137688, PLU @D137687, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM IN, PAST +, ARITY 3] : SHUT, 
   [COORD @D137694, AGR [COUNT @D137693, PER @D137692, PLU @D137691, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, PFORM FROM, PAST +, ARITY 3] : SHUT, 
   [COORD @D137697, 
      AGR [COUNT @D137696, PER @D137695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : 
   SHUT, 
   [COORD @D137699, AGR [COUNT @D137698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHUT, 
   [COORD @D137701, AGR [COUNT @D137700, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SHUT, 
   [COORD @D137705, AGR [COUNT @D137704, PER @D137703, PLU @D137702, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SHUT, 
   [COORD @D137711, PAST @D137710, AGR [CASE @D137709, COUNT @D137708, 
            PER @D137707, PLU @D137706, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SHUT, 
   [COORD @D137714, AGR [COUNT @D137713, PER @D137712, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHUT, 
   [COORD @D137716, AGR [COUNT @D137715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHUT, 
   [COORD @D137718, AGR [COUNT @D137717, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : SHUT, 
   [COORD @D137722, AGR [COUNT @D137721, PER @D137720, PLU @D137719, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : SHUT, 
   [COORD @D137728, PAST @D137727, 
      AGR [CASE @D137726, COUNT @D137725, PER @D137724, PLU @D137723, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : SHUT, 
   [COORD @D137731, AGR [COUNT @D137730, PER @D137729, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SHUT, 
   [COORD @D137733, AGR [COUNT @D137732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SHUT, 
   [COORD @D137735, AGR [COUNT @D137734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SHUT, 
   [COORD @D137739, AGR [COUNT @D137738, PER @D137737, PLU @D137736, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SHUT, 
   [COORD @D137745, PAST @D137744, 
      AGR [CASE @D137743, COUNT @D137742, PER @D137741, PLU @D137740, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SHUT, 
   [COORD @D137748, AGR [COUNT @D137747, PER @D137746, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHUT, 
   [COORD @D137750, AGR [COUNT @D137749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHUT, 
   [COORD @D137752, AGR [COUNT @D137751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SHUT, 
   [COORD @D137756, AGR [COUNT @D137755, PER @D137754, PLU @D137753, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : SHUT, 
   [COORD @D137762, PAST @D137761, 
      AGR [CASE @D137760, COUNT @D137759, PER @D137758, PLU @D137757, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : SHUT, 
   [COORD @D137765, AGR [COUNT @D137764, PER @D137763, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : SHUT, 
   [COORD @D137767, AGR [COUNT @D137766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : SHUT, 
   [COORD @D137769, AGR [COUNT @D137768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : SHUT, 
   [COORD @D137773, AGR [COUNT @D137772, PER @D137771, PLU @D137770, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : SHUT, 
   [COORD @D137779, PAST @D137778, 
      AGR [CASE @D137777, COUNT @D137776, PER @D137775, PLU @D137774, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : SHUT, 
   [COORD @D137782, AGR [COUNT @D137781, PER @D137780, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHUT, 
   [COORD @D137784, AGR [COUNT @D137783, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHUT, 
   [COORD @D137786, AGR [COUNT @D137785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHUT, 
   [COORD @D137790, AGR [COUNT @D137789, PER @D137788, PLU @D137787, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : SHUT, 
   [COORD @D137796, PAST @D137795, 
      AGR [CASE @D137794, COUNT @D137793, PER @D137792, PLU @D137791, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SHUT, 
   [COORD @D137799, AGR [COUNT @D137798, PER @D137797, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : SHUT, 
   [COORD @D137801, AGR [COUNT @D137800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : SHUT, 
   [COORD @D137803, AGR [COUNT @D137802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : SHUT, 
   [COORD @D137807, AGR [COUNT @D137806, PER @D137805, PLU @D137804, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, ARITY 2] : SHUT, 
   [COORD @D137813, PAST @D137812, 
      AGR [CASE @D137811, COUNT @D137810, PER @D137809, PLU @D137808, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT AWAY, ARITY 2] : SHUT, 
   [COORD @D137819, PAST @D137818, AGR [CASE @D137817, COUNT @D137816, 
            PER @D137815, PLU @D137814, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SHUT, 
   [COORD @D137825, PAST @D137824, 
      AGR [CASE @D137823, COUNT @D137822, PER @D137821, PLU @D137820, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SHUT, 
   [COORD @D137831, PAST @D137830, AGR [CASE @D137829, COUNT @D137828, 
            PER @D137827, PLU @D137826, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : SHUT, 
   [COORD @D137837, PAST @D137836, 
      AGR [CASE @D137835, COUNT @D137834, PER @D137833, PLU @D137832, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : SHUT, 
   [COORD @D137843, PAST @D137842, AGR [CASE @D137841, COUNT @D137840, 
            PER @D137839, PLU @D137838, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SHUT, 
   [COORD @D137849, PAST @D137848, 
      AGR [CASE @D137847, COUNT @D137846, PER @D137845, PLU @D137844, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : SHUT, 
   [COORD @D137855, PAST @D137854, AGR [CASE @D137853, COUNT @D137852, 
            PER @D137851, PLU @D137850, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : SHUT, 
   [COORD @D137861, PAST @D137860, 
      AGR [CASE @D137859, COUNT @D137858, PER @D137857, PLU @D137856, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : SHUT, 
   [COORD @D137867, PAST @D137866, AGR [CASE @D137865, COUNT @D137864, 
            PER @D137863, PLU @D137862, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, FIN -, ARITY 2] : SHUT, 
   [COORD @D137873, PAST @D137872, 
      AGR [CASE @D137871, COUNT @D137870, PER @D137869, PLU @D137868, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      FIN -, ARITY 2] : SHUT, 
   [COORD @D137879, PAST @D137878, AGR [CASE @D137877, COUNT @D137876, 
            PER @D137875, PLU @D137874, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : SHUT, 
   [COORD @D137885, PAST @D137884, 
      AGR [CASE @D137883, COUNT @D137882, PER @D137881, PLU @D137880, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      FIN -, ARITY 2] : SHUT, 
   [COORD @D137891, PAST @D137890, AGR [CASE @D137889, COUNT @D137888, 
            PER @D137887, PLU @D137886, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT AWAY, FIN -, ARITY 2] : SHUT, 
   [COORD @D137897, PAST @D137896, 
      AGR [CASE @D137895, COUNT @D137894, PER @D137893, PLU @D137892, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT AWAY, 
      FIN -, ARITY 2] : SHUT, 
   [COORD @D137901, AGR [COUNT @D137900, PER @D137899, PLU @D137898, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SHUT, 
   [COORD @D137905, AGR [COUNT @D137904, PER @D137903, PLU @D137902, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : SHUT, 
   [COORD @D137909, AGR [COUNT @D137908, PER @D137907, PLU @D137906, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SHUT, 
   [COORD @D137913, AGR [COUNT @D137912, PER @D137911, PLU @D137910, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : SHUT, 
   [COORD @D137917, AGR [COUNT @D137916, PER @D137915, PLU @D137914, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT IN, PAST +, ARITY 2] : SHUT, 
   [COORD @D137921, AGR [COUNT @D137920, PER @D137919, PLU @D137918, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : SHUT, 
   [COORD @D137925, AGR [COUNT @D137924, PER @D137923, PLU @D137922, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT AWAY, PAST +, ARITY 2] : SHUT, 
   [COORD @D137928, AGR [COUNT @D137927, PER @D137926, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHUT, 
   [COORD @D137930, AGR [COUNT @D137929, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHUT, 
   [COORD @D137932, AGR [COUNT @D137931, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SHUT, 
   [COORD @D137936, AGR [COUNT @D137935, PER @D137934, PLU @D137933, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SHUT, 
   [COORD @D137942, PAST @D137941, 
      AGR [CASE @D137940, COUNT @D137939, PER @D137938, PLU @D137937, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SHUT, 
   [COORD @D137945, AGR [COUNT @D137944, PER @D137943, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHUT, 
   [COORD @D137947, AGR [COUNT @D137946, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHUT, 
   [COORD @D137949, AGR [COUNT @D137948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SHUT, 
   [COORD @D137953, AGR [COUNT @D137952, PER @D137951, PLU @D137950, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : SHUT, 
   [COORD @D137959, PAST @D137958, 
      AGR [CASE @D137957, COUNT @D137956, PER @D137955, PLU @D137954, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : SHUT, 
   [COORD @D137962, AGR [COUNT @D137961, PER @D137960, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SHUT, 
   [COORD @D137964, AGR [COUNT @D137963, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SHUT, 
   [COORD @D137966, AGR [COUNT @D137965, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SHUT, 
   [COORD @D137970, AGR [COUNT @D137969, PER @D137968, PLU @D137967, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SHUT, 
   [COORD @D137976, PAST @D137975, 
      AGR [CASE @D137974, COUNT @D137973, PER @D137972, PLU @D137971, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SHUT, 
   [COORD @D137979, AGR [COUNT @D137978, PER @D137977, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHUT, 
   [COORD @D137981, AGR [COUNT @D137980, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHUT, 
   [COORD @D137983, AGR [COUNT @D137982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SHUT, 
   [COORD @D137987, AGR [COUNT @D137986, PER @D137985, PLU @D137984, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : SHUT, 
   [COORD @D137993, PAST @D137992, 
      AGR [CASE @D137991, COUNT @D137990, PER @D137989, PLU @D137988, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : SHUT, 
   [COORD @D137996, AGR [COUNT @D137995, PER @D137994, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SHUT, 
   [COORD @D137998, AGR [COUNT @D137997, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SHUT, 
   [COORD @D138000, AGR [COUNT @D137999, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SHUT, 
   [COORD @D138004, AGR [COUNT @D138003, PER @D138002, PLU @D138001, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : SHUT, 
   [COORD @D138010, PAST @D138009, 
      AGR [CASE @D138008, COUNT @D138007, PER @D138006, PLU @D138005, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : SHUT, 
   [COORD @D138013, AGR [COUNT @D138012, PER @D138011, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SHUT, 
   [COORD @D138015, AGR [COUNT @D138014, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SHUT, 
   [COORD @D138017, AGR [COUNT @D138016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SHUT, 
   [COORD @D138021, AGR [COUNT @D138020, PER @D138019, PLU @D138018, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : SHUT, 
   [COORD @D138027, PAST @D138026, 
      AGR [CASE @D138025, COUNT @D138024, PER @D138023, PLU @D138022, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : SHUT, 
   [COORD @D138030, AGR [COUNT @D138029, PER @D138028, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : SHUT, 
   [COORD @D138032, AGR [COUNT @D138031, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : SHUT, 
   [COORD @D138034, AGR [COUNT @D138033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : SHUT, 
   [COORD @D138038, AGR [COUNT @D138037, PER @D138036, PLU @D138035, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : SHUT, 
   [COORD @D138044, PAST @D138043, 
      AGR [CASE @D138042, COUNT @D138041, PER @D138040, PLU @D138039, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, ARITY 1] : SHUT, 
   [COORD @D138050, PAST @D138049, AGR [CASE @D138048, COUNT @D138047, 
            PER @D138046, PLU @D138045, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : SHUT, 
   [COORD @D138056, PAST @D138055, 
      AGR [CASE @D138054, COUNT @D138053, PER @D138052, PLU @D138051, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      FIN -, ARITY 1] : SHUT, 
   [COORD @D138062, PAST @D138061, AGR [CASE @D138060, COUNT @D138059, 
            PER @D138058, PLU @D138057, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : SHUT, 
   [COORD @D138068, PAST @D138067, 
      AGR [CASE @D138066, COUNT @D138065, PER @D138064, PLU @D138063, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      FIN -, ARITY 1] : SHUT, 
   [COORD @D138074, PAST @D138073, AGR [CASE @D138072, COUNT @D138071, 
            PER @D138070, PLU @D138069, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : SHUT, 
   [COORD @D138080, PAST @D138079, 
      AGR [CASE @D138078, COUNT @D138077, PER @D138076, PLU @D138075, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      FIN -, ARITY 1] : SHUT, 
   [COORD @D138086, PAST @D138085, AGR [CASE @D138084, COUNT @D138083, 
            PER @D138082, PLU @D138081, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, FIN -, ARITY 1] : SHUT, 
   [COORD @D138090, 
      AGR [COUNT @D138089, PER @D138088, PLU @D138087, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : SHUT, 
   [COORD @D138094, AGR [COUNT @D138093, PER @D138092, PLU @D138091, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SHUT, 
   [COORD @D138098, 
      AGR [COUNT @D138097, PER @D138096, PLU @D138095, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : SHUT, 
   [COORD @D138102, AGR [COUNT @D138101, PER @D138100, PLU @D138099, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : SHUT, 
   [COORD @D138106, 
      AGR [COUNT @D138105, PER @D138104, PLU @D138103, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : SHUT, 
   [COORD @D138110, AGR [COUNT @D138109, PER @D138108, PLU @D138107, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, PAST +, ARITY 1] : SHUT, 
   [COORD @D138114, 
      AGR [COUNT @D138113, PER @D138112, PLU @D138111, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, PAST +, ARITY 1] : SHUT.

WORD shuts : 
   [COORD @D138121, AGR [COUNT @D138120, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHUT, 
   [COORD @D138123, AGR [COUNT @D138122, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SHUT, 
   [COORD @D138125, AGR [COUNT @D138124, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SHUT, 
   [COORD @D138127, AGR [COUNT @D138126, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138129, 
      AGR [COUNT @D138128, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138131, 
      AGR [COUNT @D138130, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138133, 
      AGR [COUNT @D138132, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138135, 
      AGR [COUNT @D138134, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138137, 
      AGR [COUNT @D138136, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138139, 
      AGR [COUNT @D138138, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138141, 
      AGR [COUNT @D138140, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138143, 
      AGR [COUNT @D138142, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138145, 
      AGR [COUNT @D138144, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138147, 
      AGR [COUNT @D138146, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138149, 
      AGR [COUNT @D138148, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138151, 
      AGR [COUNT @D138150, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT, 
   [COORD @D138153, 
      AGR [COUNT @D138152, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SHUT.

WORD shutting : 
   [COORD @D138171, PRD @D138170, AGR [CASE @D138169, COUNT @D138168, 
            PER @D138167, PLU @D138166, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM OUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138177, PRD @D138176, 
      AGR [CASE @D138175, COUNT @D138174, PER @D138173, PLU @D138172, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHUT, 
   [COORD @D138183, PRD @D138182, AGR [CASE @D138181, COUNT @D138180, 
            PER @D138179, PLU @D138178, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138189, PRD @D138188, 
      AGR [CASE @D138187, COUNT @D138186, PER @D138185, PLU @D138184, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHUT, 
   [COORD @D138195, PRD @D138194, AGR [CASE @D138193, COUNT @D138192, 
            PER @D138191, PLU @D138190, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138201, PRD @D138200, 
      AGR [CASE @D138199, COUNT @D138198, PER @D138197, PLU @D138196, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHUT, 
   [COORD @D138207, PRD @D138206, AGR [CASE @D138205, COUNT @D138204, 
            PER @D138203, PLU @D138202, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138213, PRD @D138212, 
      AGR [CASE @D138211, COUNT @D138210, PER @D138209, PLU @D138208, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHUT, 
   [COORD @D138219, PRD @D138218, AGR [CASE @D138217, COUNT @D138216, 
            PER @D138215, PLU @D138214, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138225, PRD @D138224, 
      AGR [CASE @D138223, COUNT @D138222, PER @D138221, PLU @D138220, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SHUT, 
   [COORD @D138231, PRD @D138230, AGR [CASE @D138229, COUNT @D138228, 
            PER @D138227, PLU @D138226, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138237, PRD @D138236, 
      AGR [CASE @D138235, COUNT @D138234, PER @D138233, PLU @D138232, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHUT, 
   [COORD @D138243, PRD @D138242, AGR [CASE @D138241, COUNT @D138240, 
            PER @D138239, PLU @D138238, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138249, PRD @D138248, 
      AGR [CASE @D138247, COUNT @D138246, PER @D138245, PLU @D138244, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHUT, 
   [COORD @D138255, PRD @D138254, AGR [CASE @D138253, COUNT @D138252, 
            PER @D138251, PLU @D138250, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT, 
   [COORD @D138261, PRD @D138260, 
      AGR [CASE @D138259, COUNT @D138258, PER @D138257, PLU @D138256, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SHUT, 
   [COORD @D138267, PRD @D138266, AGR [CASE @D138265, COUNT @D138264, 
            PER @D138263, PLU @D138262, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SHUT.

WORD sign : 
   [COORD @D138273, AGR [COUNT @D138272, PER @D138271, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SIGN, 
   [COORD @D138275, AGR [COUNT @D138274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SIGN, 
   [COORD @D138277, AGR [COUNT @D138276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SIGN, 
   [COORD @D138281, AGR [COUNT @D138280, PER @D138279, PLU @D138278, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : SIGN, 
   [COORD @D138287, PAST @D138286, AGR [CASE @D138285, COUNT @D138284, 
            PER @D138283, PLU @D138282, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : SIGN, 
   [COORD @D138290, AGR [COUNT @D138289, PER @D138288, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT UP, ARITY 3] : SIGN, 
   [COORD @D138292, AGR [COUNT @D138291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT UP, ARITY 3] : SIGN, 
   [COORD @D138294, AGR [COUNT @D138293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT UP, ARITY 3] : SIGN, 
   [COORD @D138298, AGR [COUNT @D138297, PER @D138296, PLU @D138295, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, PRT UP, ARITY 3] : SIGN, 
   [COORD @D138304, PAST @D138303, 
      AGR [CASE @D138302, COUNT @D138301, PER @D138300, PLU @D138299, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      PRT UP, ARITY 3] : SIGN, 
   [COORD @D138307, AGR [COUNT @D138306, PER @D138305, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138309, AGR [COUNT @D138308, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138311, AGR [COUNT @D138310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138315, AGR [COUNT @D138314, PER @D138313, PLU @D138312, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138321, PAST @D138320, 
      AGR [CASE @D138319, COUNT @D138318, PER @D138317, PLU @D138316, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PP_INF, 
      PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138324, AGR [COUNT @D138323, PER @D138322, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : SIGN, 
   [COORD @D138326, AGR [COUNT @D138325, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : SIGN, 
   [COORD @D138328, AGR [COUNT @D138327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : SIGN, 
   [COORD @D138332, AGR [COUNT @D138331, PER @D138330, PLU @D138329, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : SIGN, 
   [COORD @D138338, PAST @D138337, 
      AGR [CASE @D138336, COUNT @D138335, PER @D138334, PLU @D138333, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_PP_INF, 
      PFORM FOR, ARITY 3] : SIGN, 
   [COORD @D138341, AGR [COUNT @D138340, PER @D138339, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138343, 
      AGR [COUNT @D138342, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OVER, 
      PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138345, AGR [COUNT @D138344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138349, 
      AGR [COUNT @D138348, PER @D138347, PLU @D138346, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138355, PAST @D138354, 
      AGR [CASE @D138353, COUNT @D138352, PER @D138351, PLU @D138350, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, PFORM TO, ARITY 3] : SIGN, 
   [COORD @D138358, AGR [COUNT @D138357, PER @D138356, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SIGN, 
   [COORD @D138360, AGR [COUNT @D138359, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SIGN, 
   [COORD @D138362, AGR [COUNT @D138361, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SIGN, 
   [COORD @D138366, AGR [COUNT @D138365, PER @D138364, PLU @D138363, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SIGN, 
   [COORD @D138372, PAST @D138371, AGR [CASE @D138370, COUNT @D138369, 
            PER @D138368, PLU @D138367, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : SIGN, 
   [COORD @D138375, AGR [COUNT @D138374, PER @D138373, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SIGN, 
   [COORD @D138377, AGR [COUNT @D138376, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SIGN, 
   [COORD @D138379, AGR [COUNT @D138378, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SIGN, 
   [COORD @D138383, AGR [COUNT @D138382, PER @D138381, PLU @D138380, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SIGN, 
   [COORD @D138389, PAST @D138388, AGR [CASE @D138387, COUNT @D138386, 
            PER @D138385, PLU @D138384, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SIGN, 
   [COORD @D138392, AGR [COUNT @D138391, PER @D138390, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : SIGN, 
   [COORD @D138394, AGR [COUNT @D138393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : SIGN, 
   [COORD @D138396, AGR [COUNT @D138395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : SIGN, 
   [COORD @D138400, AGR [COUNT @D138399, PER @D138398, PLU @D138397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT UP, ARITY 2] : SIGN, 
   [COORD @D138406, PAST @D138405, 
      AGR [CASE @D138404, COUNT @D138403, PER @D138402, PLU @D138401, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      PRT UP, ARITY 2] : SIGN, 
   [COORD @D138409, AGR [COUNT @D138408, PER @D138407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SIGN, 
   [COORD @D138411, AGR [COUNT @D138410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SIGN, 
   [COORD @D138413, AGR [COUNT @D138412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SIGN, 
   [COORD @D138417, AGR [COUNT @D138416, PER @D138415, PLU @D138414, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SIGN, 
   [COORD @D138423, PAST @D138422, 
      AGR [CASE @D138421, COUNT @D138420, PER @D138419, PLU @D138418, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SIGN, 
   [COORD @D138426, AGR [COUNT @D138425, PER @D138424, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : SIGN, 
   [COORD @D138428, AGR [COUNT @D138427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : SIGN, 
   [COORD @D138430, AGR [COUNT @D138429, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : SIGN, 
   [COORD @D138434, AGR [COUNT @D138433, PER @D138432, PLU @D138431, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : SIGN, 
   [COORD @D138440, PAST @D138439, 
      AGR [CASE @D138438, COUNT @D138437, PER @D138436, PLU @D138435, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : SIGN, 
   [COORD @D138443, AGR [COUNT @D138442, PER @D138441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : SIGN, 
   [COORD @D138445, AGR [COUNT @D138444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : SIGN, 
   [COORD @D138447, AGR [COUNT @D138446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : SIGN, 
   [COORD @D138451, AGR [COUNT @D138450, PER @D138449, PLU @D138448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : SIGN, 
   [COORD @D138457, PAST @D138456, 
      AGR [CASE @D138455, COUNT @D138454, PER @D138453, PLU @D138452, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : SIGN, 
   [COORD @D138460, AGR [COUNT @D138459, PER @D138458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : SIGN, 
   [COORD @D138462, AGR [COUNT @D138461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : SIGN, 
   [COORD @D138464, AGR [COUNT @D138463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : SIGN, 
   [COORD @D138468, AGR [COUNT @D138467, PER @D138466, PLU @D138465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : SIGN, 
   [COORD @D138474, PAST @D138473, 
      AGR [CASE @D138472, COUNT @D138471, PER @D138470, PLU @D138469, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : SIGN, 
   [COORD @D138477, AGR [COUNT @D138476, PER @D138475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : SIGN, 
   [COORD @D138479, AGR [COUNT @D138478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : SIGN, 
   [COORD @D138481, AGR [COUNT @D138480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : SIGN, 
   [COORD @D138485, AGR [COUNT @D138484, PER @D138483, PLU @D138482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : SIGN, 
   [COORD @D138491, PAST @D138490, 
      AGR [CASE @D138489, COUNT @D138488, PER @D138487, PLU @D138486, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : SIGN, 
   [COORD @D138494, AGR [COUNT @D138493, PER @D138492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SIGN, 
   [COORD @D138496, AGR [COUNT @D138495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SIGN, 
   [COORD @D138498, AGR [COUNT @D138497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SIGN, 
   [COORD @D138502, AGR [COUNT @D138501, PER @D138500, PLU @D138499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SIGN, 
   [COORD @D138508, PAST @D138507, AGR [CASE @D138506, COUNT @D138505, 
            PER @D138504, PLU @D138503, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SIGN, 
   [COORD @D138511, AGR [COUNT @D138510, PER @D138509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SIGN, 
   [COORD @D138513, AGR [COUNT @D138512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SIGN, 
   [COORD @D138515, AGR [COUNT @D138514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SIGN, 
   [COORD @D138519, AGR [COUNT @D138518, PER @D138517, PLU @D138516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : SIGN, 
   [COORD @D138525, PAST @D138524, 
      AGR [CASE @D138523, COUNT @D138522, PER @D138521, PLU @D138520, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : SIGN, 
   [COORD @D138528, AGR [COUNT @D138527, PER @D138526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SIGN, 
   [COORD @D138530, AGR [COUNT @D138529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SIGN, 
   [COORD @D138532, AGR [COUNT @D138531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SIGN, 
   [COORD @D138536, AGR [COUNT @D138535, PER @D138534, PLU @D138533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SIGN, 
   [COORD @D138542, PAST @D138541, 
      AGR [CASE @D138540, COUNT @D138539, PER @D138538, PLU @D138537, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : SIGN, 
   [COORD @D138545, AGR [COUNT @D138544, PER @D138543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SIGN, 
   [COORD @D138547, AGR [COUNT @D138546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SIGN, 
   [COORD @D138549, AGR [COUNT @D138548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SIGN, 
   [COORD @D138553, AGR [COUNT @D138552, PER @D138551, PLU @D138550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SIGN, 
   [COORD @D138559, PAST @D138558, 
      AGR [CASE @D138557, COUNT @D138556, PER @D138555, PLU @D138554, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SIGN, 
   [COORD @D138562, AGR [COUNT @D138561, PER @D138560, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SIGN, 
   [COORD @D138564, AGR [COUNT @D138563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SIGN, 
   [COORD @D138566, AGR [COUNT @D138565, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SIGN, 
   [COORD @D138570, AGR [COUNT @D138569, PER @D138568, PLU @D138567, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SIGN, 
   [COORD @D138576, PAST @D138575, 
      AGR [CASE @D138574, COUNT @D138573, PER @D138572, PLU @D138571, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : SIGN, 
   [COORD @D138579, AGR [COUNT @D138578, PER @D138577, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SIGN, 
   [COORD @D138581, AGR [COUNT @D138580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SIGN, 
   [COORD @D138583, AGR [COUNT @D138582, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SIGN, 
   [COORD @D138587, AGR [COUNT @D138586, PER @D138585, PLU @D138584, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SIGN, 
   [COORD @D138593, PAST @D138592, 
      AGR [CASE @D138591, COUNT @D138590, PER @D138589, PLU @D138588, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : SIGN, 
   [COORD @D138596, AGR [COUNT @D138595, PER @D138594, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SIGN, 
   [COORD @D138598, AGR [COUNT @D138597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SIGN, 
   [COORD @D138600, AGR [COUNT @D138599, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SIGN, 
   [COORD @D138604, AGR [COUNT @D138603, PER @D138602, PLU @D138601, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : SIGN, 
   [COORD @D138610, PAST @D138609, 
      AGR [CASE @D138608, COUNT @D138607, PER @D138606, PLU @D138605, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : SIGN, 
   [COORD @D138613, AGR [COUNT @D138612, PER @D138611, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : SIGN, 
   [COORD @D138615, AGR [COUNT @D138614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : SIGN, 
   [COORD @D138617, AGR [COUNT @D138616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : SIGN, 
   [COORD @D138621, AGR [COUNT @D138620, PER @D138619, PLU @D138618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : SIGN, 
   [COORD @D138627, PAST @D138626, 
      AGR [CASE @D138625, COUNT @D138624, PER @D138623, PLU @D138622, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AWAY, ARITY 1] : SIGN.

WORD signed : 
   [COORD @D138637, AGR [CASE @D138636, NFORM @D138635, COUNT @D138634, 
            PER @D138633, PLU @D138632, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIGN, 
   [COORD @D138642, AGR [CASE @D138641, COUNT @D138640, PER @D138639, 
            PLU @D138638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138647, AGR [CASE @D138646, COUNT @D138645, PER @D138644, 
            PLU @D138643, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138652, AGR [CASE @D138651, COUNT @D138650, PER @D138649, 
            PLU @D138648, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138657, AGR [CASE @D138656, COUNT @D138655, PER @D138654, 
            PLU @D138653, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138663, AGR [CASE @D138662, NFORM @D138661, COUNT @D138660, 
            PER @D138659, PLU @D138658, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138668, AGR [CASE @D138667, COUNT @D138666, PER @D138665, 
            PLU @D138664, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE EQUI, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138673, AGR [CASE @D138672, COUNT @D138671, PER @D138670, 
            PLU @D138669, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138678, AGR [CASE @D138677, COUNT @D138676, PER @D138675, 
            PLU @D138674, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138683, AGR [CASE @D138682, COUNT @D138681, PER @D138680, 
            PLU @D138679, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE EQUI, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138688, AGR [CASE @D138687, COUNT @D138686, PER @D138685, 
            PLU @D138684, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138693, AGR [CASE @D138692, COUNT @D138691, PER @D138690, 
            PLU @D138689, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138698, AGR [CASE @D138697, COUNT @D138696, PER @D138695, 
            PLU @D138694, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138703, AGR [CASE @D138702, COUNT @D138701, PER @D138700, 
            PLU @D138699, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138708, 
      AGR [CASE @D138707, COUNT @D138706, PER @D138705, PLU @D138704, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138713, AGR [CASE @D138712, COUNT @D138711, PER @D138710, 
            PLU @D138709, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138718, AGR [CASE @D138717, COUNT @D138716, PER @D138715, 
            PLU @D138714, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138723, AGR [CASE @D138722, COUNT @D138721, PER @D138720, 
            PLU @D138719, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIGN, 
   [COORD @D138728, AGR [CASE @D138727, COUNT @D138726, PER @D138725, 
            PLU @D138724, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138733, AGR [CASE @D138732, COUNT @D138731, PER @D138730, 
            PLU @D138729, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138738, AGR [CASE @D138737, COUNT @D138736, PER @D138735, 
            PLU @D138734, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138743, AGR [CASE @D138742, COUNT @D138741, PER @D138740, 
            PLU @D138739, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138748, AGR [CASE @D138747, COUNT @D138746, PER @D138745, 
            PLU @D138744, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138753, AGR [CASE @D138752, COUNT @D138751, PER @D138750, 
            PLU @D138749, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138758, AGR [CASE @D138757, COUNT @D138756, PER @D138755, 
            PLU @D138754, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138763, AGR [CASE @D138762, COUNT @D138761, PER @D138760, 
            PLU @D138759, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138768, AGR [CASE @D138767, COUNT @D138766, PER @D138765, 
            PLU @D138764, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138773, AGR [CASE @D138772, COUNT @D138771, PER @D138770, 
            PLU @D138769, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138778, AGR [CASE @D138777, COUNT @D138776, PER @D138775, 
            PLU @D138774, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138783, AGR [CASE @D138782, COUNT @D138781, PER @D138780, 
            PLU @D138779, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138788, AGR [CASE @D138787, COUNT @D138786, PER @D138785, 
            PLU @D138784, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138793, AGR [CASE @D138792, COUNT @D138791, PER @D138790, 
            PLU @D138789, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138798, AGR [CASE @D138797, COUNT @D138796, PER @D138795, 
            PLU @D138794, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138803, AGR [CASE @D138802, COUNT @D138801, PER @D138800, 
            PLU @D138799, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138808, AGR [CASE @D138807, COUNT @D138806, PER @D138805, 
            PLU @D138804, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138813, AGR [CASE @D138812, COUNT @D138811, PER @D138810, 
            PLU @D138809, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138818, AGR [CASE @D138817, COUNT @D138816, PER @D138815, 
            PLU @D138814, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138823, AGR [CASE @D138822, COUNT @D138821, PER @D138820, 
            PLU @D138819, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138828, AGR [CASE @D138827, COUNT @D138826, PER @D138825, 
            PLU @D138824, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138833, AGR [CASE @D138832, COUNT @D138831, PER @D138830, 
            PLU @D138829, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138838, AGR [CASE @D138837, COUNT @D138836, PER @D138835, 
            PLU @D138834, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138843, AGR [CASE @D138842, COUNT @D138841, PER @D138840, 
            PLU @D138839, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138848, AGR [CASE @D138847, COUNT @D138846, PER @D138845, 
            PLU @D138844, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138853, AGR [CASE @D138852, COUNT @D138851, PER @D138850, 
            PLU @D138849, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138858, AGR [CASE @D138857, COUNT @D138856, PER @D138855, 
            PLU @D138854, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138863, AGR [CASE @D138862, COUNT @D138861, PER @D138860, 
            PLU @D138859, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138868, AGR [CASE @D138867, COUNT @D138866, PER @D138865, 
            PLU @D138864, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138873, AGR [CASE @D138872, COUNT @D138871, PER @D138870, 
            PLU @D138869, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138878, AGR [CASE @D138877, COUNT @D138876, PER @D138875, 
            PLU @D138874, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138883, AGR [CASE @D138882, COUNT @D138881, PER @D138880, 
            PLU @D138879, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138888, AGR [CASE @D138887, COUNT @D138886, PER @D138885, 
            PLU @D138884, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138893, AGR [CASE @D138892, COUNT @D138891, PER @D138890, 
            PLU @D138889, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138898, AGR [CASE @D138897, COUNT @D138896, PER @D138895, 
            PLU @D138894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SIGN.

WORD signing : 
   [COORD @D138910, PRD @D138909, AGR [CASE @D138908, COUNT @D138907, 
            PER @D138906, PLU @D138905, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138916, PRD @D138915, 
      AGR [CASE @D138914, COUNT @D138913, PER @D138912, PLU @D138911, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SIGN, 
   [COORD @D138922, PRD @D138921, AGR [CASE @D138920, COUNT @D138919, 
            PER @D138918, PLU @D138917, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_PP_INF, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138928, PRD @D138927, 
      AGR [CASE @D138926, COUNT @D138925, PER @D138924, PLU @D138923, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SIGN, 
   [COORD @D138934, PRD @D138933, AGR [CASE @D138932, COUNT @D138931, 
            PER @D138930, PLU @D138929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138940, PRD @D138939, 
      AGR [CASE @D138938, COUNT @D138937, PER @D138936, PLU @D138935, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SIGN, 
   [COORD @D138946, PRD @D138945, AGR [CASE @D138944, COUNT @D138943, 
            PER @D138942, PLU @D138941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138952, PRD @D138951, 
      AGR [CASE @D138950, COUNT @D138949, PER @D138948, PLU @D138947, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIGN, 
   [COORD @D138958, PRD @D138957, AGR [CASE @D138956, COUNT @D138955, 
            PER @D138954, PLU @D138953, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138964, PRD @D138963, 
      AGR [CASE @D138962, COUNT @D138961, PER @D138960, PLU @D138959, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SIGN, 
   [COORD @D138970, PRD @D138969, AGR [CASE @D138968, COUNT @D138967, 
            PER @D138966, PLU @D138965, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138976, PRD @D138975, 
      AGR [CASE @D138974, COUNT @D138973, PER @D138972, PLU @D138971, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SIGN, 
   [COORD @D138982, PRD @D138981, AGR [CASE @D138980, COUNT @D138979, 
            PER @D138978, PLU @D138977, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D138988, PRD @D138987, 
      AGR [CASE @D138986, COUNT @D138985, PER @D138984, PLU @D138983, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SIGN, 
   [COORD @D138994, PRD @D138993, AGR [CASE @D138992, COUNT @D138991, 
            PER @D138990, PLU @D138989, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D139000, PRD @D138999, 
      AGR [CASE @D138998, COUNT @D138997, PER @D138996, PLU @D138995, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIGN, 
   [COORD @D139006, PRD @D139005, AGR [CASE @D139004, COUNT @D139003, 
            PER @D139002, PLU @D139001, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D139012, PRD @D139011, 
      AGR [CASE @D139010, COUNT @D139009, PER @D139008, PLU @D139007, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIGN, 
   [COORD @D139018, PRD @D139017, AGR [CASE @D139016, COUNT @D139015, 
            PER @D139014, PLU @D139013, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN, 
   [COORD @D139024, PRD @D139023, 
      AGR [CASE @D139022, COUNT @D139021, PER @D139020, PLU @D139019, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIGN, 
   [COORD @D139030, PRD @D139029, AGR [CASE @D139028, COUNT @D139027, 
            PER @D139026, PLU @D139025, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIGN.

WORD signs : 
   [COORD @D139036, AGR [COUNT @D139035, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SIGN, 
   [COORD @D139038, AGR [COUNT @D139037, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIGN, 
   [COORD @D139040, AGR [COUNT @D139039, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIGN, 
   [COORD @D139042, AGR [COUNT @D139041, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_PP_INF, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIGN, 
   [COORD @D139044, AGR [COUNT @D139043, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SIGN, 
   [COORD @D139046, AGR [COUNT @D139045, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SIGN, 
   [COORD @D139048, AGR [COUNT @D139047, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139050, 
      AGR [COUNT @D139049, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139052, 
      AGR [COUNT @D139051, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139054, 
      AGR [COUNT @D139053, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139056, 
      AGR [COUNT @D139055, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139058, 
      AGR [COUNT @D139057, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139060, 
      AGR [COUNT @D139059, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139062, 
      AGR [COUNT @D139061, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139064, 
      AGR [COUNT @D139063, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139066, 
      AGR [COUNT @D139065, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139068, 
      AGR [COUNT @D139067, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139070, 
      AGR [COUNT @D139069, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139072, 
      AGR [COUNT @D139071, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139074, 
      AGR [COUNT @D139073, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN, 
   [COORD @D139076, 
      AGR [COUNT @D139075, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIGN.

WORD sing : 
   [COORD @D139082, AGR [COUNT @D139081, PER @D139080, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SING, 
   [COORD @D139084, AGR [COUNT @D139083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SING, 
   [COORD @D139086, AGR [COUNT @D139085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : SING, 
   [COORD @D139090, AGR [COUNT @D139089, PER @D139088, PLU @D139087, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : SING, 
   [COORD @D139096, PAST @D139095, 
      AGR [CASE @D139094, COUNT @D139093, PER @D139092, PLU @D139091, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : SING, 
   [COORD @D139099, AGR [COUNT @D139098, PER @D139097, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : SING, 
   [COORD @D139101, AGR [COUNT @D139100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : SING, 
   [COORD @D139103, AGR [COUNT @D139102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, 
      REG -, ARITY 3] : SING, 
   [COORD @D139107, AGR [COUNT @D139106, PER @D139105, PLU @D139104, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, REG -, ARITY 3] : SING, 
   [COORD @D139113, PAST @D139112, 
      AGR [CASE @D139111, COUNT @D139110, PER @D139109, PLU @D139108, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_ADL, REG -, 
      ARITY 3] : SING, 
   [COORD @D139116, AGR [COUNT @D139115, PER @D139114, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SING, 
   [COORD @D139118, AGR [COUNT @D139117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SING, 
   [COORD @D139120, AGR [COUNT @D139119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : SING, 
   [COORD @D139124, AGR [COUNT @D139123, PER @D139122, PLU @D139121, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : SING, 
   [COORD @D139130, PAST @D139129, 
      AGR [CASE @D139128, COUNT @D139127, PER @D139126, PLU @D139125, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM TO, ARITY 3] : SING, 
   [COORD @D139133, AGR [COUNT @D139132, PER @D139131, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SING, 
   [COORD @D139135, AGR [COUNT @D139134, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SING, 
   [COORD @D139137, AGR [COUNT @D139136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SING, 
   [COORD @D139141, AGR [COUNT @D139140, PER @D139139, PLU @D139138, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : SING, 
   [COORD @D139147, PAST @D139146, 
      AGR [CASE @D139145, COUNT @D139144, PER @D139143, PLU @D139142, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SING, 
   [COORD @D139150, AGR [COUNT @D139149, PER @D139148, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SING, 
   [COORD @D139152, AGR [COUNT @D139151, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SING, 
   [COORD @D139154, AGR [COUNT @D139153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SING, 
   [COORD @D139158, AGR [COUNT @D139157, PER @D139156, PLU @D139155, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SING, 
   [COORD @D139164, PAST @D139163, AGR [CASE @D139162, COUNT @D139161, 
            PER @D139160, PLU @D139159, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SING, 
   [COORD @D139167, AGR [COUNT @D139166, PER @D139165, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : SING, 
   [COORD @D139169, AGR [COUNT @D139168, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : SING, 
   [COORD @D139171, AGR [COUNT @D139170, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : SING, 
   [COORD @D139175, AGR [COUNT @D139174, PER @D139173, PLU @D139172, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM OF, ARITY 2] : SING, 
   [COORD @D139181, PAST @D139180, AGR 
         [CASE @D139179, COUNT @D139178, PER @D139177, PLU @D139176, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : SING, 
   [COORD @D139184, AGR [COUNT @D139183, PER @D139182, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SING, 
   [COORD @D139186, AGR [COUNT @D139185, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SING, 
   [COORD @D139188, AGR [COUNT @D139187, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SING, 
   [COORD @D139192, AGR [COUNT @D139191, PER @D139190, PLU @D139189, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SING, 
   [COORD @D139198, PAST @D139197, 
      AGR [CASE @D139196, COUNT @D139195, PER @D139194, PLU @D139193, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SING, 
   [COORD @D139201, AGR [COUNT @D139200, PER @D139199, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SING, 
   [COORD @D139203, AGR [COUNT @D139202, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SING, 
   [COORD @D139205, AGR [COUNT @D139204, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SING, 
   [COORD @D139209, AGR [COUNT @D139208, PER @D139207, PLU @D139206, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SING, 
   [COORD @D139215, PAST @D139214, 
      AGR [CASE @D139213, COUNT @D139212, PER @D139211, PLU @D139210, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SING, 
   [COORD @D139218, AGR [COUNT @D139217, PER @D139216, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SING, 
   [COORD @D139220, AGR [COUNT @D139219, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SING, 
   [COORD @D139222, AGR [COUNT @D139221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SING, 
   [COORD @D139226, AGR [COUNT @D139225, PER @D139224, PLU @D139223, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : SING, 
   [COORD @D139232, PAST @D139231, 
      AGR [CASE @D139230, COUNT @D139229, PER @D139228, PLU @D139227, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : SING, 
   [COORD @D139235, AGR [COUNT @D139234, PER @D139233, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SING, 
   [COORD @D139237, AGR [COUNT @D139236, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SING, 
   [COORD @D139239, AGR [COUNT @D139238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SING, 
   [COORD @D139243, AGR [COUNT @D139242, PER @D139241, PLU @D139240, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SING, 
   [COORD @D139249, PAST @D139248, 
      AGR [CASE @D139247, COUNT @D139246, PER @D139245, PLU @D139244, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SING.

WORD singe : 
   [COORD @D139257, AGR [COUNT @D139256, PER @D139255, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SINGE, 
   [COORD @D139259, AGR [COUNT @D139258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SINGE, 
   [COORD @D139261, AGR [COUNT @D139260, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SINGE, 
   [COORD @D139265, AGR [COUNT @D139264, PER @D139263, PLU @D139262, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SINGE, 
   [COORD @D139271, PAST @D139270, AGR [CASE @D139269, COUNT @D139268, 
            PER @D139267, PLU @D139266, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SINGE.

WORD singed : 
   [COORD @D139282, AGR [CASE @D139281, COUNT @D139280, PER @D139279, 
            PLU @D139278, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SINGE, 
   [COORD @D139287, AGR [CASE @D139286, COUNT @D139285, PER @D139284, 
            PLU @D139283, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SINGE, 
   [COORD @D139292, AGR [CASE @D139291, COUNT @D139290, PER @D139289, 
            PLU @D139288, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SINGE.

WORD singes : 
   [COORD @D139300, AGR [COUNT @D139299, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SINGE.

WORD singing : 
   [COORD @D139312, REFL @D139311, COUNT @D139310, PRD @D139309, 
      CASE @D139308, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SINGING, 
   [COORD @D139318, PRD @D139317, 
      AGR [CASE @D139316, COUNT @D139315, PER @D139314, PLU @D139313, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SING, 
   [COORD @D139324, PRD @D139323, AGR [CASE @D139322, COUNT @D139321, 
            PER @D139320, PLU @D139319, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SING, 
   [COORD @D139330, PRD @D139329, 
      AGR [CASE @D139328, COUNT @D139327, PER @D139326, PLU @D139325, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SING, 
   [COORD @D139336, PRD @D139335, AGR [CASE @D139334, COUNT @D139333, 
            PER @D139332, PLU @D139331, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SING, 
   [COORD @D139342, PRD @D139341, 
      AGR [CASE @D139340, COUNT @D139339, PER @D139338, PLU @D139337, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SING, 
   [COORD @D139348, PRD @D139347, AGR [CASE @D139346, COUNT @D139345, 
            PER @D139344, PLU @D139343, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SING, 
   [COORD @D139354, PRD @D139353, 
      AGR [CASE @D139352, COUNT @D139351, PER @D139350, PLU @D139349, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SING, 
   [COORD @D139360, PRD @D139359, AGR [CASE @D139358, COUNT @D139357, 
            PER @D139356, PLU @D139355, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SING, 
   [COORD @D139366, PRD @D139365, 
      AGR [CASE @D139364, COUNT @D139363, PER @D139362, PLU @D139361, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SING, 
   [COORD @D139372, PRD @D139371, AGR [CASE @D139370, COUNT @D139369, 
            PER @D139368, PLU @D139367, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SING, 
   [COORD @D139378, PRD @D139377, 
      AGR [CASE @D139376, COUNT @D139375, PER @D139374, PLU @D139373, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SINGE.

WORD singings : 
   [COORD @D139393, DEMON @D139392, REFL @D139391, PRD @D139390, 
      CASE @D139389, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SINGING.

WORD sings : 
   [COORD @D139400, AGR [COUNT @D139399, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139402, 
      AGR [COUNT @D139401, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139404, 
      AGR [COUNT @D139403, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139406, 
      AGR [COUNT @D139405, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139408, 
      AGR [COUNT @D139407, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139410, 
      AGR [COUNT @D139409, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139412, 
      AGR [COUNT @D139411, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139414, 
      AGR [COUNT @D139413, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139416, 
      AGR [COUNT @D139415, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING, 
   [COORD @D139418, 
      AGR [COUNT @D139417, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SING.

WORD sir : 
   [COORD @D139425, REFL @D139424, PRD @D139423, CASE @D139422, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, ADDRESS +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SIR.

WORD sit : 
   [COORD @D139435, AGR [COUNT @D139434, PER @D139433, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SIT, 
   [COORD @D139437, AGR [COUNT @D139436, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SIT, 
   [COORD @D139439, AGR [COUNT @D139438, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SIT, 
   [COORD @D139443, AGR [COUNT @D139442, PER @D139441, PLU @D139440, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SIT, 
   [COORD @D139449, PAST @D139448, AGR [CASE @D139447, COUNT @D139446, 
            PER @D139445, PLU @D139444, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SIT, 
   [COORD @D139452, AGR [COUNT @D139451, PER @D139450, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : SIT, 
   [COORD @D139454, AGR [COUNT @D139453, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : SIT, 
   [COORD @D139456, AGR [COUNT @D139455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : SIT, 
   [COORD @D139460, AGR [COUNT @D139459, PER @D139458, PLU @D139457, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : SIT, 
   [COORD @D139466, PAST @D139465, AGR [CASE @D139464, COUNT @D139463, 
            PER @D139462, PLU @D139461, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : SIT, 
   [COORD @D139469, AGR [COUNT @D139468, PER @D139467, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UP, ARITY 2] : SIT, 
   [COORD @D139471, AGR [COUNT @D139470, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UP, ARITY 2] : SIT, 
   [COORD @D139473, AGR [COUNT @D139472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT UP, ARITY 2] : SIT, 
   [COORD @D139477, AGR [COUNT @D139476, PER @D139475, PLU @D139474, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT UP, ARITY 2] : SIT, 
   [COORD @D139483, PAST @D139482, AGR [CASE @D139481, COUNT @D139480, 
            PER @D139479, PLU @D139478, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT UP, ARITY 2] : SIT, 
   [COORD @D139486, 
      AGR [COUNT @D139485, PER @D139484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, PRT DOWN, 
      ARITY 2] : SIT, 
   [COORD @D139488, AGR [COUNT @D139487, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139490, AGR [COUNT @D139489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139494, AGR [COUNT @D139493, PER @D139492, PLU @D139491, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139500, PAST @D139499, AGR [CASE @D139498, COUNT @D139497, 
            PER @D139496, PLU @D139495, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139503, 
      AGR [COUNT @D139502, PER @D139501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : SIT, 
   [COORD @D139505, AGR [COUNT @D139504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : SIT, 
   [COORD @D139507, AGR [COUNT @D139506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : SIT, 
   [COORD @D139511, AGR [COUNT @D139510, PER @D139509, PLU @D139508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : SIT, 
   [COORD @D139517, PAST @D139516, 
      AGR [CASE @D139515, COUNT @D139514, PER @D139513, PLU @D139512, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : SIT, 
   [COORD @D139520, AGR [COUNT @D139519, PER @D139518, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM UNDER, ARITY 2] : SIT, 
   [COORD @D139522, AGR [COUNT @D139521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM UNDER, ARITY 2] : SIT, 
   [COORD @D139524, AGR [COUNT @D139523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM UNDER, ARITY 2] : SIT, 
   [COORD @D139528, AGR [COUNT @D139527, PER @D139526, PLU @D139525, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT DOWN, PFORM UNDER, ARITY 2] : SIT, 
   [COORD @D139534, PAST @D139533, 
      AGR [CASE @D139532, COUNT @D139531, PER @D139530, PLU @D139529, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT DOWN, PFORM UNDER, ARITY 2] : SIT, 
   [COORD @D139537, AGR [COUNT @D139536, PER @D139535, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : SIT, 
   [COORD @D139539, AGR [COUNT @D139538, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : SIT, 
   [COORD @D139541, AGR [COUNT @D139540, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : SIT, 
   [COORD @D139545, AGR [COUNT @D139544, PER @D139543, PLU @D139542, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : SIT, 
   [COORD @D139551, PAST @D139550, 
      AGR [CASE @D139549, COUNT @D139548, PER @D139547, PLU @D139546, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, ARITY 2] : SIT, 
   [COORD @D139554, AGR [COUNT @D139553, PER @D139552, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SIT, 
   [COORD @D139556, AGR [COUNT @D139555, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SIT, 
   [COORD @D139558, AGR [COUNT @D139557, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SIT, 
   [COORD @D139562, AGR [COUNT @D139561, PER @D139560, PLU @D139559, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : SIT, 
   [COORD @D139568, PAST @D139567, AGR [CASE @D139566, COUNT @D139565, 
            PER @D139564, PLU @D139563, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, ARITY 2] : SIT, 
   [COORD @D139571, 
      AGR [COUNT @D139570, PER @D139569, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT IN, PFORM ON, 
      ARITY 2] : SIT, 
   [COORD @D139573, AGR [COUNT @D139572, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : SIT, 
   [COORD @D139575, AGR [COUNT @D139574, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : SIT, 
   [COORD @D139579, AGR [COUNT @D139578, PER @D139577, PLU @D139576, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT IN, PFORM ON, ARITY 2] : SIT, 
   [COORD @D139585, PAST @D139584, 
      AGR [CASE @D139583, COUNT @D139582, PER @D139581, PLU @D139580, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT IN, PFORM ON, ARITY 2] : SIT, 
   [COORD @D139588, AGR [COUNT @D139587, PER @D139586, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139590, AGR [COUNT @D139589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139592, AGR [COUNT @D139591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139596, AGR [COUNT @D139595, PER @D139594, PLU @D139593, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139602, PAST @D139601, AGR 
         [CASE @D139600, COUNT @D139599, PER @D139598, PLU @D139597, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139605, AGR [COUNT @D139604, PER @D139603, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139607, AGR [COUNT @D139606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139609, AGR [COUNT @D139608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139613, AGR [COUNT @D139612, PER @D139611, PLU @D139610, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139619, PAST @D139618, 
      AGR [CASE @D139617, COUNT @D139616, PER @D139615, PLU @D139614, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139622, AGR [COUNT @D139621, PER @D139620, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139624, AGR [COUNT @D139623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139626, AGR [COUNT @D139625, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139630, AGR [COUNT @D139629, PER @D139628, PLU @D139627, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT IN, PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139636, PAST @D139635, 
      AGR [CASE @D139634, COUNT @D139633, PER @D139632, PLU @D139631, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, ARITY 2] : SIT, 
   [COORD @D139639, AGR [COUNT @D139638, PER @D139637, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AT, ARITY 2] : SIT, 
   [COORD @D139641, AGR [COUNT @D139640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AT, ARITY 2] : SIT, 
   [COORD @D139643, AGR [COUNT @D139642, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM AT, ARITY 2] : SIT, 
   [COORD @D139647, AGR [COUNT @D139646, PER @D139645, PLU @D139644, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM AT, ARITY 2] : SIT, 
   [COORD @D139653, PAST @D139652, 
      AGR [CASE @D139651, COUNT @D139650, PER @D139649, PLU @D139648, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM AT, ARITY 2] : SIT, 
   [COORD @D139656, AGR [COUNT @D139655, PER @D139654, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM AS, ARITY 2] : SIT, 
   [COORD @D139658, AGR [COUNT @D139657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM AS, ARITY 2] : SIT, 
   [COORD @D139660, AGR [COUNT @D139659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM AS, ARITY 2] : SIT, 
   [COORD @D139664, AGR [COUNT @D139663, PER @D139662, PLU @D139661, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT IN, PFORM AS, ARITY 2] : SIT, 
   [COORD @D139670, PAST @D139669, 
      AGR [CASE @D139668, COUNT @D139667, PER @D139666, PLU @D139665, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM AS, ARITY 2] : SIT, 
   [COORD @D139673, AGR [COUNT @D139672, PER @D139671, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SIT, 
   [COORD @D139675, AGR [COUNT @D139674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SIT, 
   [COORD @D139677, AGR [COUNT @D139676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SIT, 
   [COORD @D139681, AGR [COUNT @D139680, PER @D139679, PLU @D139678, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SIT, 
   [COORD @D139687, PAST @D139686, 
      AGR [CASE @D139685, COUNT @D139684, PER @D139683, PLU @D139682, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SIT, 
   [COORD @D139690, AGR [COUNT @D139689, PER @D139688, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139692, AGR [COUNT @D139691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139694, AGR [COUNT @D139693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139698, AGR [COUNT @D139697, PER @D139696, PLU @D139695, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139704, PAST @D139703, 
      AGR [CASE @D139702, COUNT @D139701, PER @D139700, PLU @D139699, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : SIT, 
   [COORD @D139707, AGR [COUNT @D139706, PER @D139705, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SIT, 
   [COORD @D139709, AGR [COUNT @D139708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SIT, 
   [COORD @D139711, AGR [COUNT @D139710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SIT, 
   [COORD @D139715, AGR [COUNT @D139714, PER @D139713, PLU @D139712, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SIT, 
   [COORD @D139721, PAST @D139720, 
      AGR [CASE @D139719, COUNT @D139718, PER @D139717, PLU @D139716, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SIT, 
   [COORD @D139724, AGR [COUNT @D139723, PER @D139722, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SIT, 
   [COORD @D139726, AGR [COUNT @D139725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SIT, 
   [COORD @D139728, AGR [COUNT @D139727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : SIT, 
   [COORD @D139732, AGR [COUNT @D139731, PER @D139730, PLU @D139729, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : SIT, 
   [COORD @D139738, PAST @D139737, 
      AGR [CASE @D139736, COUNT @D139735, PER @D139734, PLU @D139733, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : SIT, 
   [COORD @D139741, AGR [COUNT @D139740, PER @D139739, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SIT, 
   [COORD @D139743, AGR [COUNT @D139742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SIT, 
   [COORD @D139745, AGR [COUNT @D139744, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SIT, 
   [COORD @D139749, AGR [COUNT @D139748, PER @D139747, PLU @D139746, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SIT, 
   [COORD @D139755, PAST @D139754, 
      AGR [CASE @D139753, COUNT @D139752, PER @D139751, PLU @D139750, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SIT, 
   [COORD @D139758, AGR [COUNT @D139757, PER @D139756, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SIT, 
   [COORD @D139760, AGR [COUNT @D139759, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SIT, 
   [COORD @D139762, AGR [COUNT @D139761, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SIT, 
   [COORD @D139766, AGR [COUNT @D139765, PER @D139764, PLU @D139763, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : SIT, 
   [COORD @D139772, PAST @D139771, 
      AGR [CASE @D139770, COUNT @D139769, PER @D139768, PLU @D139767, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : SIT, 
   [COORD @D139775, AGR [COUNT @D139774, PER @D139773, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SIT, 
   [COORD @D139777, AGR [COUNT @D139776, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SIT, 
   [COORD @D139779, AGR [COUNT @D139778, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : SIT, 
   [COORD @D139783, AGR [COUNT @D139782, PER @D139781, PLU @D139780, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : SIT, 
   [COORD @D139789, PAST @D139788, 
      AGR [CASE @D139787, COUNT @D139786, PER @D139785, PLU @D139784, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : SIT, 
   [COORD @D139792, AGR [COUNT @D139791, PER @D139790, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : SIT, 
   [COORD @D139794, AGR [COUNT @D139793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : SIT, 
   [COORD @D139796, AGR [COUNT @D139795, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : SIT, 
   [COORD @D139800, AGR [COUNT @D139799, PER @D139798, PLU @D139797, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, ARITY 1] : SIT, 
   [COORD @D139806, PAST @D139805, 
      AGR [CASE @D139804, COUNT @D139803, PER @D139802, PLU @D139801, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, ARITY 1] : SIT, 
   [COORD @D139809, AGR [COUNT @D139808, PER @D139807, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : SIT, 
   [COORD @D139811, AGR [COUNT @D139810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : SIT, 
   [COORD @D139813, AGR [COUNT @D139812, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : SIT, 
   [COORD @D139817, AGR [COUNT @D139816, PER @D139815, PLU @D139814, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : SIT, 
   [COORD @D139823, PAST @D139822, 
      AGR [CASE @D139821, COUNT @D139820, PER @D139819, PLU @D139818, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, ARITY 1] : SIT, 
   [COORD @D139826, AGR [COUNT @D139825, PER @D139824, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : SIT, 
   [COORD @D139828, AGR [COUNT @D139827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : SIT, 
   [COORD @D139830, AGR [COUNT @D139829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT ABOUT, ARITY 1] : SIT, 
   [COORD @D139834, AGR [COUNT @D139833, PER @D139832, PLU @D139831, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT ABOUT, ARITY 1] : SIT, 
   [COORD @D139840, PAST @D139839, 
      AGR [CASE @D139838, COUNT @D139837, PER @D139836, PLU @D139835, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT ABOUT, ARITY 1] : SIT.

WORD sits : 
   [COORD @D139846, AGR [COUNT @D139845, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139848, 
      AGR [COUNT @D139847, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139850, 
      AGR [COUNT @D139849, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139852, 
      AGR [COUNT @D139851, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139854, 
      AGR [COUNT @D139853, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139856, 
      AGR [COUNT @D139855, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT DOWN, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139858, AGR [COUNT @D139857, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139860, AGR [COUNT @D139859, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139862, AGR [COUNT @D139861, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SIT, 
   [COORD @D139864, AGR [COUNT @D139863, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139866, AGR [COUNT @D139865, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139868, AGR [COUNT @D139867, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139870, AGR [COUNT @D139869, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139872, AGR [COUNT @D139871, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139874, AGR [COUNT @D139873, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139876, AGR [COUNT @D139875, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139878, AGR [COUNT @D139877, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139880, 
      AGR [COUNT @D139879, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139882, 
      AGR [COUNT @D139881, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139884, 
      AGR [COUNT @D139883, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139886, 
      AGR [COUNT @D139885, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139888, 
      AGR [COUNT @D139887, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139890, 
      AGR [COUNT @D139889, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT, 
   [COORD @D139892, 
      AGR [COUNT @D139891, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SIT.

WORD sitting : 
   [COADV @D139906, COORD @D139905, DEF @D139904, PRD @D139903, 
      AGR [CASE @D139902, COUNT @D139901, PER @D139900, PLU @D139899, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : SITTING, 
   [COORD @D139910, REFL @D139909, PRD @D139908, CASE @D139907, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SITTING, 
   [COORD @D139916, PRD @D139915, 
      AGR [CASE @D139914, COUNT @D139913, PER @D139912, PLU @D139911, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SIT, 
   [COORD @D139922, PRD @D139921, AGR [CASE @D139920, COUNT @D139919, 
            PER @D139918, PLU @D139917, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139928, PRD @D139927, 
      AGR [CASE @D139926, COUNT @D139925, PER @D139924, PLU @D139923, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIT, 
   [COORD @D139934, PRD @D139933, AGR [CASE @D139932, COUNT @D139931, 
            PER @D139930, PLU @D139929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139940, PRD @D139939, 
      AGR [CASE @D139938, COUNT @D139937, PER @D139936, PLU @D139935, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D139946, PRD @D139945, AGR [CASE @D139944, COUNT @D139943, 
            PER @D139942, PLU @D139941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT DOWN, 
      PFORM UNDER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139952, PRD @D139951, 
      AGR [CASE @D139950, COUNT @D139949, PER @D139948, PLU @D139947, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139958, PRD @D139957, AGR [CASE @D139956, COUNT @D139955, 
            PER @D139954, PLU @D139953, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139964, PRD @D139963, 
      AGR [CASE @D139962, COUNT @D139961, PER @D139960, PLU @D139959, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIT, 
   [COORD @D139970, PRD @D139969, AGR [CASE @D139968, COUNT @D139967, 
            PER @D139966, PLU @D139965, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139976, PRD @D139975, 
      AGR [CASE @D139974, COUNT @D139973, PER @D139972, PLU @D139971, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139982, PRD @D139981, AGR [CASE @D139980, COUNT @D139979, 
            PER @D139978, PLU @D139977, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139988, PRD @D139987, 
      AGR [CASE @D139986, COUNT @D139985, PER @D139984, PLU @D139983, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D139994, PRD @D139993, AGR [CASE @D139992, COUNT @D139991, 
            PER @D139990, PLU @D139989, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D140000, PRD @D139999, 
      AGR [CASE @D139998, COUNT @D139997, PER @D139996, PLU @D139995, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SIT, 
   [COORD @D140006, PRD @D140005, AGR [CASE @D140004, COUNT @D140003, 
            PER @D140002, PLU @D140001, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D140012, PRD @D140011, 
      AGR [CASE @D140010, COUNT @D140009, PER @D140008, PLU @D140007, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SIT, 
   [COORD @D140018, PRD @D140017, AGR [CASE @D140016, COUNT @D140015, 
            PER @D140014, PLU @D140013, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D140024, PRD @D140023, 
      AGR [CASE @D140022, COUNT @D140021, PER @D140020, PLU @D140019, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIT, 
   [COORD @D140030, PRD @D140029, AGR [CASE @D140028, COUNT @D140027, 
            PER @D140026, PLU @D140025, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D140036, PRD @D140035, 
      AGR [CASE @D140034, COUNT @D140033, PER @D140032, PLU @D140031, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIT, 
   [COORD @D140042, PRD @D140041, AGR [CASE @D140040, COUNT @D140039, 
            PER @D140038, PLU @D140037, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT, 
   [COORD @D140048, PRD @D140047, 
      AGR [CASE @D140046, COUNT @D140045, PER @D140044, PLU @D140043, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SIT, 
   [COORD @D140054, PRD @D140053, AGR [CASE @D140052, COUNT @D140051, 
            PER @D140050, PLU @D140049, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SIT.

WORD sittings : 
   [COORD @D140068, DEMON @D140067, REFL @D140066, PRD @D140065, 
      CASE @D140064, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SITTING.

WORD skill : 
   [COORD @D140076, REFL @D140075, COUNT @D140074, PRD @D140073, 
      CASE @D140072, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SKILL.

WORD skills : 
   [COORD @D140086, DEMON @D140085, REFL @D140084, PRD @D140083, 
      CASE @D140082, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SKILL.

WORD sleep : 
   [COORD @D140093, REFL @D140092, PRD @D140091, CASE @D140090, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SLEEP, 
   [COORD @D140098, REFL @D140097, COUNT @D140096, PRD @D140095, 
      CASE @D140094, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SLEEP, 
   [COORD @D140101, 
      AGR [COUNT @D140100, PER @D140099, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : 
   SLEEP, 
   [COORD @D140103, AGR [COUNT @D140102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SLEEP, 
   [COORD @D140105, AGR [COUNT @D140104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SLEEP, 
   [COORD @D140109, AGR [COUNT @D140108, PER @D140107, PLU @D140106, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SLEEP, 
   [COORD @D140115, PAST @D140114, AGR [CASE @D140113, COUNT @D140112, 
            PER @D140111, PLU @D140110, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SLEEP, 
   [COORD @D140118, AGR 
         [COUNT @D140117, PER @D140116, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : SLEEP, 
   [COORD @D140120, AGR [COUNT @D140119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : SLEEP, 
   [COORD @D140122, AGR [COUNT @D140121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : SLEEP, 
   [COORD @D140126, AGR [COUNT @D140125, PER @D140124, PLU @D140123, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : SLEEP, 
   [COORD @D140132, PAST @D140131, 
      AGR [CASE @D140130, COUNT @D140129, PER @D140128, PLU @D140127, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : SLEEP, 
   [COORD @D140135, AGR [COUNT @D140134, PER @D140133, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : SLEEP, 
   [COORD @D140137, AGR [COUNT @D140136, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : SLEEP, 
   [COORD @D140139, AGR [COUNT @D140138, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : SLEEP, 
   [COORD @D140143, AGR [COUNT @D140142, PER @D140141, PLU @D140140, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM THROUGH, ARITY 2] : SLEEP, 
   [COORD @D140149, PAST @D140148, 
      AGR [CASE @D140147, COUNT @D140146, PER @D140145, PLU @D140144, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM THROUGH, ARITY 2] : SLEEP, 
   [COORD @D140152, AGR [COUNT @D140151, PER @D140150, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SLEEP, 
   [COORD @D140154, AGR [COUNT @D140153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SLEEP, 
   [COORD @D140156, AGR [COUNT @D140155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SLEEP, 
   [COORD @D140160, AGR [COUNT @D140159, PER @D140158, PLU @D140157, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : SLEEP, 
   [COORD @D140166, PAST @D140165, 
      AGR [CASE @D140164, COUNT @D140163, PER @D140162, PLU @D140161, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : SLEEP, 
   [COORD @D140169, AGR [COUNT @D140168, PER @D140167, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SLEEP, 
   [COORD @D140171, AGR [COUNT @D140170, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SLEEP, 
   [COORD @D140173, AGR [COUNT @D140172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : SLEEP, 
   [COORD @D140177, AGR [COUNT @D140176, PER @D140175, PLU @D140174, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : SLEEP, 
   [COORD @D140183, PAST @D140182, 
      AGR [CASE @D140181, COUNT @D140180, PER @D140179, PLU @D140178, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : SLEEP, 
   [COORD @D140186, AGR [COUNT @D140185, PER @D140184, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SLEEP, 
   [COORD @D140188, AGR [COUNT @D140187, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SLEEP, 
   [COORD @D140190, AGR [COUNT @D140189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SLEEP, 
   [COORD @D140194, AGR [COUNT @D140193, PER @D140192, PLU @D140191, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SLEEP, 
   [COORD @D140200, PAST @D140199, 
      AGR [CASE @D140198, COUNT @D140197, PER @D140196, PLU @D140195, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SLEEP, 
   [COORD @D140203, AGR [COUNT @D140202, PER @D140201, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : SLEEP, 
   [COORD @D140205, AGR [COUNT @D140204, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : SLEEP, 
   [COORD @D140207, AGR [COUNT @D140206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : SLEEP, 
   [COORD @D140211, AGR [COUNT @D140210, PER @D140209, PLU @D140208, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, ARITY 1] : SLEEP, 
   [COORD @D140217, PAST @D140216, 
      AGR [CASE @D140215, COUNT @D140214, PER @D140213, PLU @D140212, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, ARITY 1] : SLEEP, 
   [COORD @D140220, AGR [COUNT @D140219, PER @D140218, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SLEEP, 
   [COORD @D140222, AGR [COUNT @D140221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SLEEP, 
   [COORD @D140224, AGR [COUNT @D140223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SLEEP, 
   [COORD @D140228, AGR [COUNT @D140227, PER @D140226, PLU @D140225, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SLEEP, 
   [COORD @D140234, PAST @D140233, 
      AGR [CASE @D140232, COUNT @D140231, PER @D140230, PLU @D140229, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SLEEP, 
   [COORD @D140237, AGR [COUNT @D140236, PER @D140235, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SLEEP, 
   [COORD @D140239, AGR [COUNT @D140238, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SLEEP, 
   [COORD @D140241, AGR [COUNT @D140240, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : SLEEP, 
   [COORD @D140245, AGR [COUNT @D140244, PER @D140243, PLU @D140242, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : SLEEP, 
   [COORD @D140251, PAST @D140250, 
      AGR [CASE @D140249, COUNT @D140248, PER @D140247, PLU @D140246, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : SLEEP, 
   [COORD @D140254, AGR [COUNT @D140253, PER @D140252, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SLEEP, 
   [COORD @D140256, AGR [COUNT @D140255, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SLEEP, 
   [COORD @D140258, AGR [COUNT @D140257, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : SLEEP, 
   [COORD @D140262, AGR [COUNT @D140261, PER @D140260, PLU @D140259, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : SLEEP, 
   [COORD @D140268, PAST @D140267, 
      AGR [CASE @D140266, COUNT @D140265, PER @D140264, PLU @D140263, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : SLEEP, 
   [COORD @D140271, AGR [COUNT @D140270, PER @D140269, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : SLEEP, 
   [COORD @D140273, AGR [COUNT @D140272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : SLEEP, 
   [COORD @D140275, AGR [COUNT @D140274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : SLEEP, 
   [COORD @D140279, AGR [COUNT @D140278, PER @D140277, PLU @D140276, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, ARITY 1] : SLEEP, 
   [COORD @D140285, PAST @D140284, 
      AGR [CASE @D140283, COUNT @D140282, PER @D140281, PLU @D140280, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, ARITY 1] : SLEEP.

WORD sleeping : 
   [COORD @D140300, PRD @D140299, AGR [CASE @D140298, COUNT @D140297, 
            PER @D140296, PLU @D140295, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140306, PRD @D140305, 
      AGR [CASE @D140304, COUNT @D140303, PER @D140302, PLU @D140301, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SLEEP, 
   [COORD @D140312, PRD @D140311, AGR [CASE @D140310, COUNT @D140309, 
            PER @D140308, PLU @D140307, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140318, PRD @D140317, 
      AGR [CASE @D140316, COUNT @D140315, PER @D140314, PLU @D140313, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SLEEP, 
   [COORD @D140324, PRD @D140323, AGR [CASE @D140322, COUNT @D140321, 
            PER @D140320, PLU @D140319, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140330, PRD @D140329, 
      AGR [CASE @D140328, COUNT @D140327, PER @D140326, PLU @D140325, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SLEEP, 
   [COORD @D140336, PRD @D140335, AGR [CASE @D140334, COUNT @D140333, 
            PER @D140332, PLU @D140331, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140342, PRD @D140341, 
      AGR [CASE @D140340, COUNT @D140339, PER @D140338, PLU @D140337, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SLEEP, 
   [COORD @D140348, PRD @D140347, AGR [CASE @D140346, COUNT @D140345, 
            PER @D140344, PLU @D140343, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140354, PRD @D140353, 
      AGR [CASE @D140352, COUNT @D140351, PER @D140350, PLU @D140349, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SLEEP, 
   [COORD @D140360, PRD @D140359, AGR [CASE @D140358, COUNT @D140357, 
            PER @D140356, PLU @D140355, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SLEEP.

WORD sleeps : 
   [COORD @D140370, DEMON @D140369, REFL @D140368, PRD @D140367, 
      CASE @D140366, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SLEEP, 
   [COORD @D140372, AGR [COUNT @D140371, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140374, 
      AGR [COUNT @D140373, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140376, 
      AGR [COUNT @D140375, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SLEEP, 
   [COORD @D140378, AGR [COUNT @D140377, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SLEEP, 
   [COORD @D140380, AGR [COUNT @D140379, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SLEEP, 
   [COORD @D140382, AGR [COUNT @D140381, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SLEEP, 
   [COORD @D140384, 
      AGR [COUNT @D140383, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SLEEP, 
   [COORD @D140386, AGR [COUNT @D140385, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SLEEP, 
   [COORD @D140388, AGR [COUNT @D140387, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SLEEP, 
   [COORD @D140390, AGR [COUNT @D140389, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SLEEP, 
   [COORD @D140392, AGR [COUNT @D140391, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SLEEP.

WORD slept : 
   [COORD @D140401, PAST @D140400, AGR [CASE @D140399, COUNT @D140398, 
            PER @D140397, PLU @D140396, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SLEEP, 
   [COORD @D140407, PAST @D140406, 
      AGR [CASE @D140405, COUNT @D140404, PER @D140403, PLU @D140402, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SLEEP, 
   [COORD @D140413, PAST @D140412, AGR [CASE @D140411, COUNT @D140410, 
            PER @D140409, PLU @D140408, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM WITH, FIN -, ARITY 2] : SLEEP, 
   [COORD @D140419, PAST @D140418, 
      AGR [CASE @D140417, COUNT @D140416, PER @D140415, PLU @D140414, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      FIN -, ARITY 2] : SLEEP, 
   [COORD @D140425, PAST @D140424, AGR [CASE @D140423, COUNT @D140422, 
            PER @D140421, PLU @D140420, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM THROUGH, FIN -, ARITY 2] : SLEEP, 
   [COORD @D140431, PAST @D140430, 
      AGR [CASE @D140429, COUNT @D140428, PER @D140427, PLU @D140426, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM THROUGH, 
      FIN -, ARITY 2] : SLEEP, 
   [COORD @D140437, PAST @D140436, AGR [CASE @D140435, COUNT @D140434, 
            PER @D140433, PLU @D140432, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ON, FIN -, ARITY 2] : SLEEP, 
   [COORD @D140443, PAST @D140442, 
      AGR [CASE @D140441, COUNT @D140440, PER @D140439, PLU @D140438, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, FIN -, 
      ARITY 2] : SLEEP, 
   [COORD @D140449, PAST @D140448, AGR [CASE @D140447, COUNT @D140446, 
            PER @D140445, PLU @D140444, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : SLEEP, 
   [COORD @D140455, PAST @D140454, 
      AGR [CASE @D140453, COUNT @D140452, PER @D140451, PLU @D140450, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : SLEEP, 
   [COORD @D140459, AGR [COUNT @D140458, PER @D140457, PLU @D140456, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SLEEP, 
   [COORD @D140463, AGR [COUNT @D140462, PER @D140461, PLU @D140460, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, PAST +, ARITY 2] : SLEEP, 
   [COORD @D140467, AGR [COUNT @D140466, PER @D140465, PLU @D140464, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM THROUGH, PAST +, ARITY 2] : SLEEP, 
   [COORD @D140471, AGR [COUNT @D140470, PER @D140469, PLU @D140468, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, PAST +, ARITY 2] : SLEEP, 
   [COORD @D140475, AGR [COUNT @D140474, PER @D140473, PLU @D140472, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : SLEEP, 
   [COORD @D140481, PAST @D140480, 
      AGR [CASE @D140479, COUNT @D140478, PER @D140477, PLU @D140476, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SLEEP, 
   [COORD @D140487, PAST @D140486, AGR [CASE @D140485, COUNT @D140484, 
            PER @D140483, PLU @D140482, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, FIN -, ARITY 1] : SLEEP, 
   [COORD @D140493, PAST @D140492, 
      AGR [CASE @D140491, COUNT @D140490, PER @D140489, PLU @D140488, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : SLEEP, 
   [COORD @D140499, PAST @D140498, AGR [CASE @D140497, COUNT @D140496, 
            PER @D140495, PLU @D140494, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : SLEEP, 
   [COORD @D140505, PAST @D140504, 
      AGR [CASE @D140503, COUNT @D140502, PER @D140501, PLU @D140500, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT IN, 
      FIN -, ARITY 1] : SLEEP, 
   [COORD @D140511, PAST @D140510, AGR [CASE @D140509, COUNT @D140508, 
            PER @D140507, PLU @D140506, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, FIN -, ARITY 1] : SLEEP, 
   [COORD @D140515, 
      AGR [COUNT @D140514, PER @D140513, PLU @D140512, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : SLEEP, 
   [COORD @D140519, AGR [COUNT @D140518, PER @D140517, PLU @D140516, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, PAST +, ARITY 1] : SLEEP, 
   [COORD @D140523, 
      AGR [COUNT @D140522, PER @D140521, PLU @D140520, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : SLEEP, 
   [COORD @D140527, AGR [COUNT @D140526, PER @D140525, PLU @D140524, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : SLEEP, 
   [COORD @D140531, 
      AGR [COUNT @D140530, PER @D140529, PLU @D140528, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, PAST +, ARITY 1] : SLEEP, 
   [COORD @D140535, AGR [COUNT @D140534, PER @D140533, PLU @D140532, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, PAST +, ARITY 1] : SLEEP.

WORD smack : 
   [COORD @D140553, AGR [COUNT @D140552, PER @D140551, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SMACK, 
   [COORD @D140555, AGR [COUNT @D140554, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SMACK, 
   [COORD @D140557, AGR [COUNT @D140556, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SMACK, 
   [COORD @D140561, AGR [COUNT @D140560, PER @D140559, PLU @D140558, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : SMACK, 
   [COORD @D140567, PAST @D140566, AGR [CASE @D140565, COUNT @D140564, 
            PER @D140563, PLU @D140562, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : SMACK, 
   [COORD @D140570, AGR [COUNT @D140569, PER @D140568, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMACK, 
   [COORD @D140572, AGR [COUNT @D140571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMACK, 
   [COORD @D140574, AGR [COUNT @D140573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMACK, 
   [COORD @D140578, AGR [COUNT @D140577, PER @D140576, PLU @D140575, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SMACK, 
   [COORD @D140584, PAST @D140583, AGR [CASE @D140582, COUNT @D140581, 
            PER @D140580, PLU @D140579, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SMACK, 
   [COORD @D140587, AGR [COUNT @D140586, PER @D140585, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMACK, 
   [COORD @D140589, AGR [COUNT @D140588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMACK, 
   [COORD @D140591, AGR [COUNT @D140590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMACK, 
   [COORD @D140595, AGR [COUNT @D140594, PER @D140593, PLU @D140592, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, ARITY 2] : SMACK, 
   [COORD @D140601, PAST @D140600, 
      AGR [CASE @D140599, COUNT @D140598, PER @D140597, PLU @D140596, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMACK.

WORD smacked : 
   [COORD @D140610, AGR [CASE @D140609, COUNT @D140608, PER @D140607, 
            PLU @D140606, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMACK, 
   [COORD @D140615, AGR [CASE @D140614, COUNT @D140613, PER @D140612, 
            PLU @D140611, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMACK, 
   [COORD @D140620, AGR [CASE @D140619, COUNT @D140618, PER @D140617, 
            PLU @D140616, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMACK, 
   [COORD @D140625, AGR [CASE @D140624, COUNT @D140623, PER @D140622, 
            PLU @D140621, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMACK, 
   [COORD @D140630, AGR [CASE @D140629, COUNT @D140628, PER @D140627, 
            PLU @D140626, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMACK, 
   [COORD @D140635, AGR [CASE @D140634, COUNT @D140633, PER @D140632, 
            PLU @D140631, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMACK, 
   [COORD @D140640, AGR [CASE @D140639, COUNT @D140638, PER @D140637, 
            PLU @D140636, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMACK, 
   [COORD @D140645, AGR [CASE @D140644, COUNT @D140643, PER @D140642, 
            PLU @D140641, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMACK, 
   [COORD @D140650, AGR [CASE @D140649, COUNT @D140648, PER @D140647, 
            PLU @D140646, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMACK.

WORD smacking : 
   [COORD @D140662, PRD @D140661, AGR [CASE @D140660, COUNT @D140659, 
            PER @D140658, PLU @D140657, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMACK, 
   [COORD @D140668, PRD @D140667, 
      AGR [CASE @D140666, COUNT @D140665, PER @D140664, PLU @D140663, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SMACK, 
   [COORD @D140674, PRD @D140673, AGR [CASE @D140672, COUNT @D140671, 
            PER @D140670, PLU @D140669, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SMACK.

WORD smacks : 
   [COORD @D140680, AGR [COUNT @D140679, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SMACK, 
   [COORD @D140682, AGR [COUNT @D140681, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMACK, 
   [COORD @D140684, 
      AGR [COUNT @D140683, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMACK.

WORD smell : 
   [COORD @D140692, REFL @D140691, COUNT @D140690, PRD @D140689, 
      CASE @D140688, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SMELL, 
   [COORD @D140695, 
      AGR [COUNT @D140694, PER @D140693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      ARITY 3] : SMELL, 
   [COORD @D140697, AGR [COUNT @D140696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : SMELL, 
   [COORD @D140699, AGR [COUNT @D140698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : SMELL, 
   [COORD @D140703, AGR [COUNT @D140702, PER @D140701, PLU @D140700, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : SMELL, 
   [COORD @D140709, PAST @D140708, AGR [CASE @D140707, COUNT @D140706, 
            PER @D140705, PLU @D140704, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_ING, ARITY 3] : SMELL, 
   [COORD @D140712, AGR [COUNT @D140711, PER @D140710, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SMELL, 
   [COORD @D140714, AGR [COUNT @D140713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SMELL, 
   [COORD @D140716, AGR [COUNT @D140715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SMELL, 
   [COORD @D140720, AGR [COUNT @D140719, PER @D140718, PLU @D140717, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : SMELL, 
   [COORD @D140726, PAST @D140725, AGR [CASE @D140724, COUNT @D140723, 
            PER @D140722, PLU @D140721, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : SMELL, 
   [COORD @D140729, AGR [COUNT @D140728, PER @D140727, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SMELL, 
   [COORD @D140731, AGR [COUNT @D140730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SMELL, 
   [COORD @D140733, AGR [COUNT @D140732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SMELL, 
   [COORD @D140737, AGR [COUNT @D140736, PER @D140735, PLU @D140734, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SMELL, 
   [COORD @D140743, PAST @D140742, AGR [CASE @D140741, COUNT @D140740, 
            PER @D140739, PLU @D140738, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : SMELL, 
   [COORD @D140746, AGR [COUNT @D140745, PER @D140744, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SMELL, 
   [COORD @D140748, AGR [COUNT @D140747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SMELL, 
   [COORD @D140750, AGR [COUNT @D140749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SMELL, 
   [COORD @D140754, AGR [COUNT @D140753, PER @D140752, PLU @D140751, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SMELL, 
   [COORD @D140760, PAST @D140759, AGR [CASE @D140758, COUNT @D140757, 
            PER @D140756, PLU @D140755, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : SMELL, 
   [COORD @D140763, AGR [COUNT @D140762, PER @D140761, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMELL, 
   [COORD @D140765, AGR [COUNT @D140764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMELL, 
   [COORD @D140767, AGR [COUNT @D140766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMELL, 
   [COORD @D140771, AGR [COUNT @D140770, PER @D140769, PLU @D140768, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SMELL, 
   [COORD @D140777, PAST @D140776, AGR [CASE @D140775, COUNT @D140774, 
            PER @D140773, PLU @D140772, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SMELL, 
   [COORD @D140780, AGR [COUNT @D140779, PER @D140778, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMELL, 
   [COORD @D140782, AGR [COUNT @D140781, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMELL, 
   [COORD @D140784, AGR [COUNT @D140783, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMELL, 
   [COORD @D140788, AGR [COUNT @D140787, PER @D140786, PLU @D140785, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OF, ARITY 2] : SMELL, 
   [COORD @D140794, PAST @D140793, 
      AGR [CASE @D140792, COUNT @D140791, PER @D140790, PLU @D140789, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : SMELL, 
   [COORD @D140797, AGR [COUNT @D140796, PER @D140795, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM LIKE, ARITY 2] : SMELL, 
   [COORD @D140799, AGR [COUNT @D140798, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM LIKE, ARITY 2] : SMELL, 
   [COORD @D140801, AGR [COUNT @D140800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM LIKE, ARITY 2] : SMELL, 
   [COORD @D140805, AGR [COUNT @D140804, PER @D140803, PLU @D140802, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM LIKE, ARITY 2] : SMELL, 
   [COORD @D140811, PAST @D140810, 
      AGR [CASE @D140809, COUNT @D140808, PER @D140807, PLU @D140806, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM LIKE, ARITY 2] : SMELL, 
   [COORD @D140814, AGR [COUNT @D140813, PER @D140812, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SMELL, 
   [COORD @D140816, AGR [COUNT @D140815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SMELL, 
   [COORD @D140818, AGR [COUNT @D140817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SMELL, 
   [COORD @D140822, AGR [COUNT @D140821, PER @D140820, PLU @D140819, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : SMELL, 
   [COORD @D140828, PAST @D140827, 
      AGR [CASE @D140826, COUNT @D140825, PER @D140824, PLU @D140823, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : SMELL, 
   [COORD @D140831, AGR [COUNT @D140830, PER @D140829, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMELL, 
   [COORD @D140833, AGR [COUNT @D140832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMELL, 
   [COORD @D140835, AGR [COUNT @D140834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMELL, 
   [COORD @D140839, AGR [COUNT @D140838, PER @D140837, PLU @D140836, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMELL, 
   [COORD @D140845, PAST @D140844, AGR [CASE @D140843, COUNT @D140842, 
            PER @D140841, PLU @D140840, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SMELL, 
   [COORD @D140848, AGR [COUNT @D140847, PER @D140846, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMELL, 
   [COORD @D140850, AGR [COUNT @D140849, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMELL, 
   [COORD @D140852, AGR [COUNT @D140851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMELL, 
   [COORD @D140856, AGR [COUNT @D140855, PER @D140854, PLU @D140853, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMELL, 
   [COORD @D140862, PAST @D140861, 
      AGR [CASE @D140860, COUNT @D140859, PER @D140858, PLU @D140857, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SMELL.

WORD smelled : 
   [COORD @D140874, AGR [CASE @D140873, COUNT @D140872, PER @D140871, 
            PLU @D140870, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMELL, 
   [COORD @D140879, AGR [CASE @D140878, COUNT @D140877, PER @D140876, 
            PLU @D140875, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140884, AGR [CASE @D140883, COUNT @D140882, PER @D140881, 
            PLU @D140880, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140889, AGR [CASE @D140888, COUNT @D140887, PER @D140886, 
            PLU @D140885, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140894, AGR [CASE @D140893, COUNT @D140892, PER @D140891, 
            PLU @D140890, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140899, AGR [CASE @D140898, COUNT @D140897, PER @D140896, 
            PLU @D140895, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140904, AGR [CASE @D140903, COUNT @D140902, PER @D140901, 
            PLU @D140900, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140909, AGR [UB @D140908, VFORM @D140907, SUBJ @D140906, 
            FIN @D140905, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SMELL, 
   [COORD @D140914, AGR [CASE @D140913, COUNT @D140912, PER @D140911, 
            PLU @D140910, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140919, AGR [CASE @D140918, COUNT @D140917, PER @D140916, 
            PLU @D140915, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140924, AGR [CASE @D140923, COUNT @D140922, PER @D140921, 
            PLU @D140920, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMELL, 
   [COORD @D140929, AGR [CASE @D140928, COUNT @D140927, PER @D140926, 
            PLU @D140925, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140934, AGR [CASE @D140933, COUNT @D140932, PER @D140931, 
            PLU @D140930, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140939, AGR [CASE @D140938, COUNT @D140937, PER @D140936, 
            PLU @D140935, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140944, AGR [CASE @D140943, COUNT @D140942, PER @D140941, 
            PLU @D140940, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140949, AGR [CASE @D140948, COUNT @D140947, PER @D140946, 
            PLU @D140945, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM LIKE, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140954, AGR [CASE @D140953, COUNT @D140952, PER @D140951, 
            PLU @D140950, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM LIKE, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140959, AGR [CASE @D140958, COUNT @D140957, PER @D140956, 
            PLU @D140955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140964, AGR [CASE @D140963, COUNT @D140962, PER @D140961, 
            PLU @D140960, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140969, AGR [CASE @D140968, COUNT @D140967, PER @D140966, 
            PLU @D140965, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140974, AGR [CASE @D140973, COUNT @D140972, PER @D140971, 
            PLU @D140970, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140979, AGR [CASE @D140978, COUNT @D140977, PER @D140976, 
            PLU @D140975, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140984, AGR [CASE @D140983, COUNT @D140982, PER @D140981, 
            PLU @D140980, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D140989, AGR [CASE @D140988, COUNT @D140987, PER @D140986, 
            PLU @D140985, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMELL.

WORD smelling : 
   [COORD @D141008, PRD @D141007, AGR [CASE @D141006, COUNT @D141005, 
            PER @D141004, PLU @D141003, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D141014, PRD @D141013, 
      AGR [CASE @D141012, COUNT @D141011, PER @D141010, PLU @D141009, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SMELL, 
   [COORD @D141020, PRD @D141019, AGR [CASE @D141018, COUNT @D141017, 
            PER @D141016, PLU @D141015, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D141026, PRD @D141025, 
      AGR [CASE @D141024, COUNT @D141023, PER @D141022, PLU @D141021, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SMELL, 
   [COORD @D141032, PRD @D141031, AGR [CASE @D141030, COUNT @D141029, 
            PER @D141028, PLU @D141027, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D141038, PRD @D141037, 
      AGR [CASE @D141036, COUNT @D141035, PER @D141034, PLU @D141033, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMELL, 
   [COORD @D141044, PRD @D141043, AGR [CASE @D141042, COUNT @D141041, 
            PER @D141040, PLU @D141039, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM LIKE, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D141050, PRD @D141049, 
      AGR [CASE @D141048, COUNT @D141047, PER @D141046, PLU @D141045, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SMELL, 
   [COORD @D141056, PRD @D141055, AGR [CASE @D141054, COUNT @D141053, 
            PER @D141052, PLU @D141051, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMELL, 
   [COORD @D141062, PRD @D141061, 
      AGR [CASE @D141060, COUNT @D141059, PER @D141058, PLU @D141057, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMELL.

WORD smells : 
   [COORD @D141074, DEMON @D141073, REFL @D141072, PRD @D141071, 
      CASE @D141070, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SMELL, 
   [COORD @D141076, AGR [COUNT @D141075, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SMELL, 
   [COORD @D141078, AGR [COUNT @D141077, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141080, 
      AGR [COUNT @D141079, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141082, 
      AGR [COUNT @D141081, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141084, 
      AGR [COUNT @D141083, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141086, 
      AGR [COUNT @D141085, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141088, 
      AGR [COUNT @D141087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM LIKE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141090, 
      AGR [COUNT @D141089, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141092, 
      AGR [COUNT @D141091, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL, 
   [COORD @D141094, 
      AGR [COUNT @D141093, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMELL.

WORD smile : 
   [COORD @D141103, REFL @D141102, PRD @D141101, CASE @D141100, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SMILE, 
   [COORD @D141106, 
      AGR [COUNT @D141105, PER @D141104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : SMILE, 
   [COORD @D141108, AGR [COUNT @D141107, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SMILE, 
   [COORD @D141110, AGR [COUNT @D141109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SMILE, 
   [COORD @D141114, AGR [COUNT @D141113, PER @D141112, PLU @D141111, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : SMILE, 
   [COORD @D141120, PAST @D141119, AGR [CASE @D141118, COUNT @D141117, 
            PER @D141116, PLU @D141115, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : SMILE, 
   [COORD @D141123, AGR [COUNT @D141122, PER @D141121, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMILE, 
   [COORD @D141125, AGR [COUNT @D141124, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMILE, 
   [COORD @D141127, AGR [COUNT @D141126, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMILE, 
   [COORD @D141131, AGR [COUNT @D141130, PER @D141129, PLU @D141128, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SMILE, 
   [COORD @D141137, PAST @D141136, AGR [CASE @D141135, COUNT @D141134, 
            PER @D141133, PLU @D141132, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SMILE, 
   [COORD @D141140, AGR [COUNT @D141139, PER @D141138, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SMILE, 
   [COORD @D141142, AGR [COUNT @D141141, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SMILE, 
   [COORD @D141144, AGR [COUNT @D141143, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SMILE, 
   [COORD @D141148, AGR [COUNT @D141147, PER @D141146, PLU @D141145, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : SMILE, 
   [COORD @D141154, PAST @D141153, 
      AGR [CASE @D141152, COUNT @D141151, PER @D141150, PLU @D141149, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : SMILE, 
   [COORD @D141157, AGR [COUNT @D141156, PER @D141155, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : SMILE, 
   [COORD @D141159, AGR [COUNT @D141158, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : SMILE, 
   [COORD @D141161, AGR [COUNT @D141160, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : SMILE, 
   [COORD @D141165, AGR [COUNT @D141164, PER @D141163, PLU @D141162, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : SMILE, 
   [COORD @D141171, PAST @D141170, 
      AGR [CASE @D141169, COUNT @D141168, PER @D141167, PLU @D141166, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : SMILE, 
   [COORD @D141174, AGR [COUNT @D141173, PER @D141172, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMILE, 
   [COORD @D141176, AGR [COUNT @D141175, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMILE, 
   [COORD @D141178, AGR [COUNT @D141177, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMILE, 
   [COORD @D141182, AGR [COUNT @D141181, PER @D141180, PLU @D141179, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMILE, 
   [COORD @D141188, PAST @D141187, AGR [CASE @D141186, COUNT @D141185, 
            PER @D141184, PLU @D141183, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SMILE.

WORD smiled : 
   [COORD @D141200, AGR [CASE @D141199, COUNT @D141198, PER @D141197, 
            PLU @D141196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141205, AGR [CASE @D141204, COUNT @D141203, PER @D141202, 
            PLU @D141201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141210, AGR [CASE @D141209, COUNT @D141208, PER @D141207, 
            PLU @D141206, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141215, AGR [CASE @D141214, COUNT @D141213, PER @D141212, 
            PLU @D141211, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141220, AGR [CASE @D141219, COUNT @D141218, PER @D141217, 
            PLU @D141216, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMILE, 
   [COORD @D141225, AGR [CASE @D141224, COUNT @D141223, PER @D141222, 
            PLU @D141221, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141230, AGR [CASE @D141229, COUNT @D141228, PER @D141227, 
            PLU @D141226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141235, AGR [CASE @D141234, COUNT @D141233, PER @D141232, 
            PLU @D141231, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141240, AGR [CASE @D141239, COUNT @D141238, PER @D141237, 
            PLU @D141236, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141245, AGR [CASE @D141244, COUNT @D141243, PER @D141242, 
            PLU @D141241, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141250, AGR [CASE @D141249, COUNT @D141248, PER @D141247, 
            PLU @D141246, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMILE.

WORD smiles : 
   [COORD @D141262, DEMON @D141261, REFL @D141260, PRD @D141259, 
      CASE @D141258, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SMILE, 
   [COORD @D141264, AGR [COUNT @D141263, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SMILE, 
   [COORD @D141266, AGR [COUNT @D141265, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMILE, 
   [COORD @D141268, 
      AGR [COUNT @D141267, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMILE, 
   [COORD @D141270, 
      AGR [COUNT @D141269, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMILE, 
   [COORD @D141272, 
      AGR [COUNT @D141271, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMILE.

WORD smiling : 
   [COORD @D141283, PRD @D141282, AGR [CASE @D141281, COUNT @D141280, 
            PER @D141279, PLU @D141278, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141289, PRD @D141288, 
      AGR [CASE @D141287, COUNT @D141286, PER @D141285, PLU @D141284, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SMILE, 
   [COORD @D141295, PRD @D141294, AGR [CASE @D141293, COUNT @D141292, 
            PER @D141291, PLU @D141290, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SMILE, 
   [COORD @D141301, PRD @D141300, 
      AGR [CASE @D141299, COUNT @D141298, PER @D141297, PLU @D141296, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMILE, 
   [COORD @D141307, PRD @D141306, AGR [CASE @D141305, COUNT @D141304, 
            PER @D141303, PLU @D141302, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMILE.

WORD smoke : 
   [COORD @D141317, REFL @D141316, COUNT @D141315, PRD @D141314, 
      CASE @D141313, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SMOKE, 
   [COORD @D141320, 
      AGR [COUNT @D141319, PER @D141318, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   SMOKE, 
   [COORD @D141322, AGR [COUNT @D141321, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMOKE, 
   [COORD @D141324, AGR [COUNT @D141323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SMOKE, 
   [COORD @D141328, AGR [COUNT @D141327, PER @D141326, PLU @D141325, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SMOKE, 
   [COORD @D141334, PAST @D141333, AGR [CASE @D141332, COUNT @D141331, 
            PER @D141330, PLU @D141329, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SMOKE, 
   [COORD @D141337, AGR [COUNT @D141336, PER @D141335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SMOKE, 
   [COORD @D141339, AGR [COUNT @D141338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SMOKE, 
   [COORD @D141341, AGR [COUNT @D141340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SMOKE, 
   [COORD @D141345, AGR [COUNT @D141344, PER @D141343, PLU @D141342, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADVP, ARITY 2] : SMOKE, 
   [COORD @D141351, PAST @D141350, AGR [CASE @D141349, COUNT @D141348, 
            PER @D141347, PLU @D141346, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADVP, ARITY 2] : SMOKE, 
   [COORD @D141354, AGR [COUNT @D141353, PER @D141352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SMOKE, 
   [COORD @D141356, AGR [COUNT @D141355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SMOKE, 
   [COORD @D141358, AGR [COUNT @D141357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SMOKE, 
   [COORD @D141362, AGR [COUNT @D141361, PER @D141360, PLU @D141359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : SMOKE, 
   [COORD @D141368, PAST @D141367, 
      AGR [CASE @D141366, COUNT @D141365, PER @D141364, PLU @D141363, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : SMOKE, 
   [COORD @D141371, AGR [COUNT @D141370, PER @D141369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMOKE, 
   [COORD @D141373, AGR [COUNT @D141372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMOKE, 
   [COORD @D141375, AGR [COUNT @D141374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMOKE, 
   [COORD @D141379, AGR [COUNT @D141378, PER @D141377, PLU @D141376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SMOKE, 
   [COORD @D141385, PAST @D141384, AGR [CASE @D141383, COUNT @D141382, 
            PER @D141381, PLU @D141380, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SMOKE, 
   [COORD @D141388, AGR [COUNT @D141387, PER @D141386, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMOKE, 
   [COORD @D141390, AGR [COUNT @D141389, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMOKE, 
   [COORD @D141392, AGR [COUNT @D141391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMOKE, 
   [COORD @D141396, AGR [COUNT @D141395, PER @D141394, PLU @D141393, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SMOKE, 
   [COORD @D141402, PAST @D141401, 
      AGR [CASE @D141400, COUNT @D141399, PER @D141398, PLU @D141397, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SMOKE.

WORD smoked : 
   [COORD @D141414, AGR [CASE @D141413, COUNT @D141412, PER @D141411, 
            PLU @D141410, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SMOKE, 
   [COORD @D141419, AGR [CASE @D141418, COUNT @D141417, PER @D141416, 
            PLU @D141415, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141424, AGR [CASE @D141423, COUNT @D141422, PER @D141421, 
            PLU @D141420, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141429, AGR [CASE @D141428, COUNT @D141427, PER @D141426, 
            PLU @D141425, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141434, AGR [CASE @D141433, COUNT @D141432, PER @D141431, 
            PLU @D141430, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141439, AGR [CASE @D141438, COUNT @D141437, PER @D141436, 
            PLU @D141435, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141444, AGR [CASE @D141443, COUNT @D141442, PER @D141441, 
            PLU @D141440, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141449, AGR [CASE @D141448, COUNT @D141447, PER @D141446, 
            PLU @D141445, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141454, AGR [CASE @D141453, COUNT @D141452, PER @D141451, 
            PLU @D141450, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141459, AGR [CASE @D141458, COUNT @D141457, PER @D141456, 
            PLU @D141455, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141464, AGR [CASE @D141463, COUNT @D141462, PER @D141461, 
            PLU @D141460, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141469, AGR [CASE @D141468, COUNT @D141467, PER @D141466, 
            PLU @D141465, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SMOKE.

WORD smokes : 
   [COORD @D141481, DEMON @D141480, REFL @D141479, PRD @D141478, 
      CASE @D141477, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SMOKE, 
   [COORD @D141483, AGR [COUNT @D141482, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141485, 
      AGR [COUNT @D141484, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141487, 
      AGR [COUNT @D141486, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141489, 
      AGR [COUNT @D141488, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141491, 
      AGR [COUNT @D141490, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SMOKE.

WORD smoking : 
   [COORD @D141502, PRD @D141501, AGR [CASE @D141500, COUNT @D141499, 
            PER @D141498, PLU @D141497, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141508, PRD @D141507, 
      AGR [CASE @D141506, COUNT @D141505, PER @D141504, PLU @D141503, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SMOKE, 
   [COORD @D141514, PRD @D141513, AGR [CASE @D141512, COUNT @D141511, 
            PER @D141510, PLU @D141509, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SMOKE, 
   [COORD @D141520, PRD @D141519, 
      AGR [CASE @D141518, COUNT @D141517, PER @D141516, PLU @D141515, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SMOKE, 
   [COORD @D141526, PRD @D141525, AGR [CASE @D141524, COUNT @D141523, 
            PER @D141522, PLU @D141521, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SMOKE.

WORD sold : 
   [COORD @D141537, PAST @D141536, AGR [CASE @D141535, COUNT @D141534, 
            PER @D141533, PLU @D141532, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : SELL, 
   [COORD @D141543, PAST @D141542, 
      AGR [CASE @D141541, COUNT @D141540, PER @D141539, PLU @D141538, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : SELL, 
   [COORD @D141549, PAST @D141548, AGR [CASE @D141547, COUNT @D141546, 
            PER @D141545, PLU @D141544, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : SELL, 
   [COORD @D141555, PAST @D141554, 
      AGR [CASE @D141553, COUNT @D141552, PER @D141551, PLU @D141550, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : SELL, 
   [COORD @D141561, PAST @D141560, AGR [CASE @D141559, COUNT @D141558, 
            PER @D141557, PLU @D141556, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : SELL, 
   [COORD @D141567, PAST @D141566, 
      AGR [CASE @D141565, COUNT @D141564, PER @D141563, PLU @D141562, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      FIN -, ARITY 3] : SELL, 
   [COORD @D141573, PAST @D141572, AGR [CASE @D141571, COUNT @D141570, 
            PER @D141569, PLU @D141568, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, FIN -, ARITY 3] : SELL, 
   [COORD @D141579, PAST @D141578, 
      AGR [CASE @D141577, COUNT @D141576, PER @D141575, PLU @D141574, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      PFORM OF, FIN -, ARITY 3] : SELL, 
   [COORD @D141583, AGR [COUNT @D141582, PER @D141581, PLU @D141580, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : SELL, 
   [COORD @D141587, AGR [COUNT @D141586, PER @D141585, PLU @D141584, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, PAST +, ARITY 3] : SELL, 
   [COORD @D141591, 
      AGR [COUNT @D141590, PER @D141589, PLU @D141588, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ON, PAST +, ARITY 3] : SELL, 
   [COORD @D141595, AGR [COUNT @D141594, PER @D141593, PLU @D141592, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, PFORM OF, PAST +, ARITY 3] : SELL, 
   [COORD @D141601, PAST @D141600, 
      AGR [CASE @D141599, COUNT @D141598, PER @D141597, PLU @D141596, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SELL, 
   [COORD @D141607, PAST @D141606, AGR [CASE @D141605, COUNT @D141604, 
            PER @D141603, PLU @D141602, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SELL, 
   [COORD @D141613, PAST @D141612, 
      AGR [CASE @D141611, COUNT @D141610, PER @D141609, PLU @D141608, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM OF, FIN -, ARITY 2] : SELL, 
   [COORD @D141619, PAST @D141618, AGR 
         [CASE @D141617, COUNT @D141616, PER @D141615, PLU @D141614, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      FIN -, ARITY 2] : SELL, 
   [COORD @D141625, PAST @D141624, AGR [CASE @D141623, COUNT @D141622, 
            PER @D141621, PLU @D141620, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM AT, FIN -, ARITY 2] : SELL, 
   [COORD @D141631, PAST @D141630, 
      AGR [CASE @D141629, COUNT @D141628, PER @D141627, PLU @D141626, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : SELL, 
   [COORD @D141637, PAST @D141636, AGR [CASE @D141635, COUNT @D141634, 
            PER @D141633, PLU @D141632, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : SELL, 
   [COORD @D141643, PAST @D141642, 
      AGR [CASE @D141641, COUNT @D141640, PER @D141639, PLU @D141638, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : SELL, 
   [COORD @D141649, PAST @D141648, AGR [CASE @D141647, COUNT @D141646, 
            PER @D141645, PLU @D141644, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SELL, 
   [COORD @D141655, PAST @D141654, 
      AGR [CASE @D141653, COUNT @D141652, PER @D141651, PLU @D141650, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : SELL, 
   [COORD @D141661, PAST @D141660, AGR [CASE @D141659, COUNT @D141658, 
            PER @D141657, PLU @D141656, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : SELL, 
   [COORD @D141665, 
      AGR [COUNT @D141664, PER @D141663, PLU @D141662, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : SELL, 
   [COORD @D141669, AGR [COUNT @D141668, PER @D141667, PLU @D141666, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM OF, PAST +, ARITY 2] : SELL, 
   [COORD @D141673, 
      AGR [COUNT @D141672, PER @D141671, PLU @D141670, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : SELL, 
   [COORD @D141677, AGR [COUNT @D141676, PER @D141675, PLU @D141674, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM AT, PAST +, ARITY 2] : SELL, 
   [COORD @D141681, 
      AGR [COUNT @D141680, PER @D141679, PLU @D141678, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : SELL, 
   [COORD @D141685, AGR [COUNT @D141684, PER @D141683, PLU @D141682, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SELL, 
   [COORD @D141689, AGR [COUNT @D141688, PER @D141687, PLU @D141686, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : SELL, 
   [COORD @D141695, PAST @D141694, 
      AGR [CASE @D141693, COUNT @D141692, PER @D141691, PLU @D141690, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SELL, 
   [COORD @D141701, PAST @D141700, AGR [CASE @D141699, COUNT @D141698, 
            PER @D141697, PLU @D141696, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : SELL, 
   [COORD @D141707, PAST @D141706, 
      AGR [CASE @D141705, COUNT @D141704, PER @D141703, PLU @D141702, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : SELL, 
   [COORD @D141713, PAST @D141712, AGR [CASE @D141711, COUNT @D141710, 
            PER @D141709, PLU @D141708, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : SELL, 
   [COORD @D141717, 
      AGR [COUNT @D141716, PER @D141715, PLU @D141714, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : SELL, 
   [COORD @D141721, AGR [COUNT @D141720, PER @D141719, PLU @D141718, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SELL, 
   [COORD @D141725, 
      AGR [COUNT @D141724, PER @D141723, PLU @D141722, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : SELL, 
   [COORD @D141729, AGR [COUNT @D141728, PER @D141727, PLU @D141726, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : SELL.

WORD sought : 
   [COORD @D141757, PAST @D141756, AGR [CASE @D141755, COUNT @D141754, 
            PER @D141753, PLU @D141752, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, FIN -, ARITY 2] : SEEK, 
   [COORD @D141763, PAST @D141762, 
      AGR [CASE @D141761, COUNT @D141760, PER @D141759, PLU @D141758, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SEEK, 
   [COORD @D141769, PAST @D141768, AGR [CASE @D141767, COUNT @D141766, 
            PER @D141765, PLU @D141764, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SEEK, 
   [COORD @D141775, PAST @D141774, 
      AGR [CASE @D141773, COUNT @D141772, PER @D141771, PLU @D141770, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      FIN -, ARITY 2] : SEEK, 
   [COORD @D141781, PAST @D141780, AGR [CASE @D141779, COUNT @D141778, 
            PER @D141777, PLU @D141776, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM AFTER, FIN -, ARITY 2] : SEEK, 
   [COORD @D141787, PAST @D141786, 
      AGR [CASE @D141785, COUNT @D141784, PER @D141783, PLU @D141782, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : SEEK, 
   [COORD @D141793, PAST @D141792, AGR [CASE @D141791, COUNT @D141790, 
            PER @D141789, PLU @D141788, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SEEK, 
   [COORD @D141797, 
      AGR [COUNT @D141796, PER @D141795, PLU @D141794, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, PAST +, 
      ARITY 2] : SEEK, 
   [COORD @D141801, AGR [COUNT @D141800, PER @D141799, PLU @D141798, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SEEK, 
   [COORD @D141805, AGR [COUNT @D141804, PER @D141803, PLU @D141802, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM FOR, PAST +, ARITY 2] : SEEK, 
   [COORD @D141809, 
      AGR [COUNT @D141808, PER @D141807, PLU @D141806, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AFTER, PAST +, ARITY 2] : SEEK, 
   [COORD @D141813, AGR [COUNT @D141812, PER @D141811, PLU @D141810, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SEEK, 
   [COORD @D141819, PAST @D141818, 
      AGR [CASE @D141817, COUNT @D141816, PER @D141815, PLU @D141814, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SEEK, 
   [COORD @D141825, PAST @D141824, AGR [CASE @D141823, COUNT @D141822, 
            PER @D141821, PLU @D141820, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : SEEK, 
   [COORD @D141829, 
      AGR [COUNT @D141828, PER @D141827, PLU @D141826, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : SEEK, 
   [COORD @D141833, AGR [COUNT @D141832, PER @D141831, PLU @D141830, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, PAST +, ARITY 1] : SEEK.

WORD sound : 
   [COORD @D141857, REFL @D141856, PRD @D141855, CASE @D141854, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : SOUND, 
   [COORD @D141861, REFL @D141860, PRD @D141859, CASE @D141858, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SOUND, 
   [COORD @D141866, REFL @D141865, COUNT @D141864, PRD @D141863, 
      CASE @D141862, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SOUND, 
   [COORD @D141869, 
      AGR [COUNT @D141868, PER @D141867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM ON, ARITY 3] : SOUND, 
   [COORD @D141871, AGR [COUNT @D141870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM ON, ARITY 3] : SOUND, 
   [COORD @D141873, 
      AGR [COUNT @D141872, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, PFORM ON, 
      ARITY 3] : SOUND, 
   [COORD @D141877, AGR [COUNT @D141876, PER @D141875, PLU @D141874, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM ON, ARITY 3] : SOUND, 
   [COORD @D141883, PAST @D141882, 
      AGR [CASE @D141881, COUNT @D141880, PER @D141879, PLU @D141878, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM ON, ARITY 3] : SOUND, 
   [COORD @D141886, AGR [COUNT @D141885, PER @D141884, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM ABOUT, ARITY 3] : SOUND, 
   [COORD @D141888, 
      AGR [COUNT @D141887, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM ABOUT, ARITY 3] : SOUND, 
   [COORD @D141890, AGR [COUNT @D141889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM ABOUT, ARITY 3] : SOUND, 
   [COORD @D141894, 
      AGR [COUNT @D141893, PER @D141892, PLU @D141891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, PFORM ABOUT, ARITY 3] : SOUND, 
   [COORD @D141900, PAST @D141899, 
      AGR [CASE @D141898, COUNT @D141897, PER @D141896, PLU @D141895, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      PFORM ABOUT, ARITY 3] : SOUND, 
   [COORD @D141903, AGR [COUNT @D141902, PER @D141901, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : SOUND, 
   [COORD @D141905, AGR [COUNT @D141904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : SOUND, 
   [COORD @D141907, AGR [COUNT @D141906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : SOUND, 
   [COORD @D141911, AGR [COUNT @D141910, PER @D141909, PLU @D141908, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : SOUND, 
   [COORD @D141917, PAST @D141916, AGR [CASE @D141915, COUNT @D141914, 
            PER @D141913, PLU @D141912, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : SOUND, 
   [COORD @D141920, AGR [COUNT @D141919, PER @D141918, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SOUND, 
   [COORD @D141922, AGR [COUNT @D141921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SOUND, 
   [COORD @D141924, AGR [COUNT @D141923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SOUND, 
   [COORD @D141928, AGR [COUNT @D141927, PER @D141926, PLU @D141925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : SOUND, 
   [COORD @D141934, PAST @D141933, AGR [CASE @D141932, COUNT @D141931, 
            PER @D141930, PLU @D141929, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : SOUND, 
   [COORD @D141937, AGR [COUNT @D141936, PER @D141935, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SOUND, 
   [COORD @D141939, AGR [COUNT @D141938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SOUND, 
   [COORD @D141941, AGR [COUNT @D141940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SOUND, 
   [COORD @D141945, AGR [COUNT @D141944, PER @D141943, PLU @D141942, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SOUND, 
   [COORD @D141951, PAST @D141950, AGR [CASE @D141949, COUNT @D141948, 
            PER @D141947, PLU @D141946, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SOUND, 
   [COORD @D141954, AGR [COUNT @D141953, PER @D141952, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ON, ARITY 2] : SOUND, 
   [COORD @D141956, AGR [COUNT @D141955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ON, ARITY 2] : SOUND, 
   [COORD @D141958, AGR [COUNT @D141957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ON, ARITY 2] : SOUND, 
   [COORD @D141962, AGR [COUNT @D141961, PER @D141960, PLU @D141959, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OFF, PFORM ON, ARITY 2] : SOUND, 
   [COORD @D141968, PAST @D141967, 
      AGR [CASE @D141966, COUNT @D141965, PER @D141964, PLU @D141963, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ON, ARITY 2] : SOUND, 
   [COORD @D141971, AGR [COUNT @D141970, PER @D141969, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ABOUT, ARITY 2] : SOUND, 
   [COORD @D141973, AGR [COUNT @D141972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ABOUT, ARITY 2] : SOUND, 
   [COORD @D141975, AGR [COUNT @D141974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ABOUT, ARITY 2] : SOUND, 
   [COORD @D141979, AGR [COUNT @D141978, PER @D141977, PLU @D141976, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OFF, PFORM ABOUT, ARITY 2] : SOUND, 
   [COORD @D141985, PAST @D141984, 
      AGR [CASE @D141983, COUNT @D141982, PER @D141981, PLU @D141980, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM ABOUT, ARITY 2] : SOUND, 
   [COORD @D141988, AGR [COUNT @D141987, PER @D141986, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SOUND, 
   [COORD @D141990, AGR [COUNT @D141989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SOUND, 
   [COORD @D141992, AGR [COUNT @D141991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : SOUND, 
   [COORD @D141996, AGR [COUNT @D141995, PER @D141994, PLU @D141993, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : SOUND, 
   [COORD @D142002, PAST @D142001, 
      AGR [CASE @D142000, COUNT @D141999, PER @D141998, PLU @D141997, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : SOUND, 
   [COORD @D142005, AGR [COUNT @D142004, PER @D142003, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SOUND, 
   [COORD @D142007, AGR [COUNT @D142006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SOUND, 
   [COORD @D142009, AGR [COUNT @D142008, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SOUND, 
   [COORD @D142013, AGR [COUNT @D142012, PER @D142011, PLU @D142010, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SOUND, 
   [COORD @D142019, PAST @D142018, AGR [CASE @D142017, COUNT @D142016, 
            PER @D142015, PLU @D142014, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SOUND, 
   [COORD @D142022, AGR [COUNT @D142021, PER @D142020, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SOUND, 
   [COORD @D142024, AGR [COUNT @D142023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SOUND, 
   [COORD @D142026, AGR [COUNT @D142025, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SOUND, 
   [COORD @D142030, AGR [COUNT @D142029, PER @D142028, PLU @D142027, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : SOUND, 
   [COORD @D142036, PAST @D142035, 
      AGR [CASE @D142034, COUNT @D142033, PER @D142032, PLU @D142031, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : SOUND, 
   [COORD @D142039, AGR [COUNT @D142038, PER @D142037, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SOUND, 
   [COORD @D142041, AGR [COUNT @D142040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SOUND, 
   [COORD @D142043, AGR [COUNT @D142042, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SOUND, 
   [COORD @D142047, AGR [COUNT @D142046, PER @D142045, PLU @D142044, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SOUND, 
   [COORD @D142053, PAST @D142052, 
      AGR [CASE @D142051, COUNT @D142050, PER @D142049, PLU @D142048, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : SOUND.

WORD sounded : 
   [COORD @D142066, AGR [CASE @D142065, COUNT @D142064, PER @D142063, 
            PLU @D142062, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ON, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142071, AGR [CASE @D142070, COUNT @D142069, PER @D142068, 
            PLU @D142067, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142076, 
      AGR [CASE @D142075, COUNT @D142074, PER @D142073, PLU @D142072, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142081, AGR [CASE @D142080, COUNT @D142079, PER @D142078, 
            PLU @D142077, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ABOUT, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142086, AGR [CASE @D142085, COUNT @D142084, PER @D142083, 
            PLU @D142082, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142091, 
      AGR [CASE @D142090, COUNT @D142089, PER @D142088, PLU @D142087, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142096, AGR [CASE @D142095, COUNT @D142094, PER @D142093, 
            PLU @D142092, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142101, AGR [CASE @D142100, COUNT @D142099, PER @D142098, 
            PLU @D142097, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142106, AGR [CASE @D142105, COUNT @D142104, PER @D142103, 
            PLU @D142102, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142111, AGR [CASE @D142110, COUNT @D142109, PER @D142108, 
            PLU @D142107, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142116, AGR [CASE @D142115, COUNT @D142114, PER @D142113, 
            PLU @D142112, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SOUND, 
   [COORD @D142121, AGR [CASE @D142120, COUNT @D142119, PER @D142118, 
            PLU @D142117, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142126, AGR [CASE @D142125, COUNT @D142124, PER @D142123, 
            PLU @D142122, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142131, AGR [CASE @D142130, COUNT @D142129, PER @D142128, 
            PLU @D142127, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142136, AGR [CASE @D142135, COUNT @D142134, PER @D142133, 
            PLU @D142132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142141, AGR [CASE @D142140, COUNT @D142139, PER @D142138, 
            PLU @D142137, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142146, 
      AGR [CASE @D142145, COUNT @D142144, PER @D142143, PLU @D142142, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142151, AGR [CASE @D142150, COUNT @D142149, PER @D142148, 
            PLU @D142147, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142156, AGR [CASE @D142155, COUNT @D142154, PER @D142153, 
            PLU @D142152, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142161, AGR [CASE @D142160, COUNT @D142159, PER @D142158, 
            PLU @D142157, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142166, AGR [CASE @D142165, COUNT @D142164, PER @D142163, 
            PLU @D142162, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142171, AGR [CASE @D142170, COUNT @D142169, PER @D142168, 
            PLU @D142167, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142176, AGR [CASE @D142175, COUNT @D142174, PER @D142173, 
            PLU @D142172, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142181, AGR [CASE @D142180, COUNT @D142179, PER @D142178, 
            PLU @D142177, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142186, AGR [CASE @D142185, COUNT @D142184, PER @D142183, 
            PLU @D142182, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142191, AGR [CASE @D142190, COUNT @D142189, PER @D142188, 
            PLU @D142187, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SOUND.

WORD sounding : 
   [COORD @D142210, PRD @D142209, AGR [CASE @D142208, COUNT @D142207, 
            PER @D142206, PLU @D142205, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142216, PRD @D142215, 
      AGR [CASE @D142214, COUNT @D142213, PER @D142212, PLU @D142211, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142222, PRD @D142221, 
      AGR [CASE @D142220, COUNT @D142219, PER @D142218, PLU @D142217, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SOUND, 
   [COORD @D142228, PRD @D142227, AGR [CASE @D142226, COUNT @D142225, 
            PER @D142224, PLU @D142223, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142234, PRD @D142233, 
      AGR [CASE @D142232, COUNT @D142231, PER @D142230, PLU @D142229, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SOUND, 
   [COORD @D142240, PRD @D142239, AGR [CASE @D142238, COUNT @D142237, 
            PER @D142236, PLU @D142235, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142246, PRD @D142245, 
      AGR [CASE @D142244, COUNT @D142243, PER @D142242, PLU @D142241, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142252, PRD @D142251, AGR [CASE @D142250, COUNT @D142249, 
            PER @D142248, PLU @D142247, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142258, PRD @D142257, 
      AGR [CASE @D142256, COUNT @D142255, PER @D142254, PLU @D142253, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SOUND, 
   [COORD @D142264, PRD @D142263, AGR [CASE @D142262, COUNT @D142261, 
            PER @D142260, PLU @D142259, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SOUND, 
   [COORD @D142270, PRD @D142269, 
      AGR [CASE @D142268, COUNT @D142267, PER @D142266, PLU @D142265, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SOUND.

WORD sounds : 
   [COORD @D142283, DEMON @D142282, REFL @D142281, PRD @D142280, 
      CASE @D142279, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SOUND, 
   [COORD @D142288, DEMON @D142287, REFL @D142286, PRD @D142285, 
      CASE @D142284, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SOUND, 
   [COORD @D142290, AGR [COUNT @D142289, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SOUND, 
   [COORD @D142292, AGR [COUNT @D142291, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, PFORM ABOUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SOUND, 
   [COORD @D142294, AGR [COUNT @D142293, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SOUND, 
   [COORD @D142296, 
      AGR [COUNT @D142295, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SOUND, 
   [COORD @D142298, 
      AGR [COUNT @D142297, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SOUND, 
   [COORD @D142300, 
      AGR [COUNT @D142299, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OFF, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SOUND, 
   [COORD @D142302, AGR [COUNT @D142301, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OFF, PFORM ABOUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SOUND, 
   [COORD @D142304, AGR [COUNT @D142303, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SOUND, 
   [COORD @D142306, AGR [COUNT @D142305, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SOUND, 
   [COORD @D142308, 
      AGR [COUNT @D142307, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SOUND, 
   [COORD @D142310, 
      AGR [COUNT @D142309, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SOUND.

WORD spend : 
   [COORD @D142320, AGR [COUNT @D142319, PER @D142318, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SPEND, 
   [COORD @D142322, AGR [COUNT @D142321, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SPEND, 
   [COORD @D142324, AGR [COUNT @D142323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SPEND, 
   [COORD @D142328, AGR [COUNT @D142327, PER @D142326, PLU @D142325, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : SPEND, 
   [COORD @D142334, PAST @D142333, 
      AGR [CASE @D142332, COUNT @D142331, PER @D142330, PLU @D142329, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ON, ARITY 3] : SPEND, 
   [COORD @D142337, AGR [COUNT @D142336, PER @D142335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SPEND, 
   [COORD @D142339, AGR [COUNT @D142338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SPEND, 
   [COORD @D142341, AGR [COUNT @D142340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM IN, ARITY 3] : SPEND, 
   [COORD @D142345, AGR [COUNT @D142344, PER @D142343, PLU @D142342, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, ARITY 3] : SPEND, 
   [COORD @D142351, PAST @D142350, 
      AGR [CASE @D142349, COUNT @D142348, PER @D142347, PLU @D142346, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM IN, ARITY 3] : SPEND, 
   [COORD @D142354, AGR [COUNT @D142353, PER @D142352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SPEND, 
   [COORD @D142356, AGR [COUNT @D142355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SPEND, 
   [COORD @D142358, AGR [COUNT @D142357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : SPEND, 
   [COORD @D142362, AGR [COUNT @D142361, PER @D142360, PLU @D142359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : SPEND, 
   [COORD @D142368, PAST @D142367, 
      AGR [CASE @D142366, COUNT @D142365, PER @D142364, PLU @D142363, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FOR, ARITY 3] : SPEND, 
   [COORD @D142371, AGR [COUNT @D142370, PER @D142369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPEND, 
   [COORD @D142373, AGR [COUNT @D142372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPEND, 
   [COORD @D142375, AGR [COUNT @D142374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPEND, 
   [COORD @D142379, AGR [COUNT @D142378, PER @D142377, PLU @D142376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SPEND, 
   [COORD @D142385, PAST @D142384, AGR [CASE @D142383, COUNT @D142382, 
            PER @D142381, PLU @D142380, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SPEND, 
   [COORD @D142388, AGR 
         [COUNT @D142387, PER @D142386, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   SPEND, 
   [COORD @D142390, AGR [COUNT @D142389, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPEND, 
   [COORD @D142392, AGR [COUNT @D142391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPEND, 
   [COORD @D142396, AGR [COUNT @D142395, PER @D142394, PLU @D142393, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SPEND, 
   [COORD @D142402, PAST @D142401, 
      AGR [CASE @D142400, COUNT @D142399, PER @D142398, PLU @D142397, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SPEND.

WORD spending : 
   [COORD @D142414, PRD @D142413, AGR [CASE @D142412, COUNT @D142411, 
            PER @D142410, PLU @D142409, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SPEND, 
   [COORD @D142420, PRD @D142419, 
      AGR [CASE @D142418, COUNT @D142417, PER @D142416, PLU @D142415, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SPEND, 
   [COORD @D142426, PRD @D142425, AGR [CASE @D142424, COUNT @D142423, 
            PER @D142422, PLU @D142421, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SPEND, 
   [COORD @D142432, PRD @D142431, 
      AGR [CASE @D142430, COUNT @D142429, PER @D142428, PLU @D142427, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SPEND, 
   [COORD @D142438, PRD @D142437, AGR [CASE @D142436, COUNT @D142435, 
            PER @D142434, PLU @D142433, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SPEND.

WORD spends : 
   [COORD @D142444, AGR [COUNT @D142443, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SPEND, 
   [COORD @D142446, AGR [COUNT @D142445, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SPEND, 
   [COORD @D142448, AGR [COUNT @D142447, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SPEND, 
   [COORD @D142450, AGR [COUNT @D142449, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPEND, 
   [COORD @D142452, 
      AGR [COUNT @D142451, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPEND.

WORD spent : 
   [COADV @D142463, COORD @D142462, DEF @D142461, PRD @D142460, 
      AGR [CASE @D142459, COUNT @D142458, PER @D142457, PLU @D142456, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : SPENT, 
   [COORD @D142469, PAST @D142468, AGR [CASE @D142467, COUNT @D142466, 
            PER @D142465, PLU @D142464, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : SPEND, 
   [COORD @D142475, PAST @D142474, 
      AGR [CASE @D142473, COUNT @D142472, PER @D142471, PLU @D142470, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      FIN -, ARITY 3] : SPEND, 
   [COORD @D142481, PAST @D142480, AGR [CASE @D142479, COUNT @D142478, 
            PER @D142477, PLU @D142476, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM IN, FIN -, ARITY 3] : SPEND, 
   [COORD @D142487, PAST @D142486, 
      AGR [CASE @D142485, COUNT @D142484, PER @D142483, PLU @D142482, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM IN, 
      FIN -, ARITY 3] : SPEND, 
   [COORD @D142493, PAST @D142492, AGR [CASE @D142491, COUNT @D142490, 
            PER @D142489, PLU @D142488, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : SPEND, 
   [COORD @D142499, PAST @D142498, 
      AGR [CASE @D142497, COUNT @D142496, PER @D142495, PLU @D142494, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      FIN -, ARITY 3] : SPEND, 
   [COORD @D142503, AGR [COUNT @D142502, PER @D142501, PLU @D142500, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, PAST +, ARITY 3] : SPEND, 
   [COORD @D142507, 
      AGR [COUNT @D142506, PER @D142505, PLU @D142504, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM IN, PAST +, ARITY 3] : SPEND, 
   [COORD @D142511, AGR [COUNT @D142510, PER @D142509, PLU @D142508, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, PAST +, ARITY 3] : SPEND, 
   [COORD @D142517, PAST @D142516, 
      AGR [CASE @D142515, COUNT @D142514, PER @D142513, PLU @D142512, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SPEND, 
   [COORD @D142523, PAST @D142522, AGR [CASE @D142521, COUNT @D142520, 
            PER @D142519, PLU @D142518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SPEND, 
   [COORD @D142527, AGR [COUNT @D142526, PER @D142525, PLU @D142524, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SPEND, 
   [COORD @D142533, PAST @D142532, 
      AGR [CASE @D142531, COUNT @D142530, PER @D142529, PLU @D142528, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : SPEND, 
   [COORD @D142537, AGR [COUNT @D142536, PER @D142535, PLU @D142534, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : SPEND.

WORD sperm : 
   [COORD @D142562, REFL @D142561, COUNT @D142560, PRD @D142559, 
      CASE @D142558, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SPERM, 
   [COORD @D142566, REFL @D142565, PRD @D142564, CASE @D142563, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : SPERM.

WORD sperms : 
   [COORD @D142575, DEMON @D142574, REFL @D142573, PRD @D142572, 
      CASE @D142571, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SPERM.

WORD spin : 
   [COORD @D142582, REFL @D142581, PRD @D142580, CASE @D142579, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : SPIN, 
   [COORD @D142586, REFL @D142585, PRD @D142584, CASE @D142583, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SPIN, 
   [COORD @D142591, REFL @D142590, COUNT @D142589, PRD @D142588, 
      CASE @D142587, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SPIN, 
   [COORD @D142594, 
      AGR [COUNT @D142593, PER @D142592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : 
   SPIN, 
   [COORD @D142596, AGR [COUNT @D142595, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPIN, 
   [COORD @D142598, AGR [COUNT @D142597, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPIN, 
   [COORD @D142602, AGR [COUNT @D142601, PER @D142600, PLU @D142599, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SPIN, 
   [COORD @D142608, PAST @D142607, AGR [CASE @D142606, COUNT @D142605, 
            PER @D142604, PLU @D142603, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SPIN, 
   [COORD @D142611, AGR [COUNT @D142610, PER @D142609, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SPIN, 
   [COORD @D142613, AGR [COUNT @D142612, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SPIN, 
   [COORD @D142615, AGR [COUNT @D142614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SPIN, 
   [COORD @D142619, AGR [COUNT @D142618, PER @D142617, PLU @D142616, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SPIN, 
   [COORD @D142625, PAST @D142624, 
      AGR [CASE @D142623, COUNT @D142622, PER @D142621, PLU @D142620, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SPIN, 
   [COORD @D142628, AGR [COUNT @D142627, PER @D142626, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPIN, 
   [COORD @D142630, AGR [COUNT @D142629, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPIN, 
   [COORD @D142632, AGR [COUNT @D142631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPIN, 
   [COORD @D142636, AGR [COUNT @D142635, PER @D142634, PLU @D142633, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SPIN, 
   [COORD @D142642, PAST @D142641, 
      AGR [CASE @D142640, COUNT @D142639, PER @D142638, PLU @D142637, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SPIN, 
   [COORD @D142645, AGR [COUNT @D142644, PER @D142643, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SPIN, 
   [COORD @D142647, AGR [COUNT @D142646, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SPIN, 
   [COORD @D142649, AGR [COUNT @D142648, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SPIN, 
   [COORD @D142653, AGR [COUNT @D142652, PER @D142651, PLU @D142650, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SPIN, 
   [COORD @D142659, PAST @D142658, 
      AGR [CASE @D142657, COUNT @D142656, PER @D142655, PLU @D142654, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SPIN.

WORD spinning : 
   [COORD @D142677, PRD @D142676, AGR [CASE @D142675, COUNT @D142674, 
            PER @D142673, PLU @D142672, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SPIN, 
   [COORD @D142683, PRD @D142682, 
      AGR [CASE @D142681, COUNT @D142680, PER @D142679, PLU @D142678, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SPIN, 
   [COORD @D142689, PRD @D142688, AGR [CASE @D142687, COUNT @D142686, 
            PER @D142685, PLU @D142684, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SPIN, 
   [COORD @D142695, PRD @D142694, 
      AGR [CASE @D142693, COUNT @D142692, PER @D142691, PLU @D142690, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SPIN.

WORD spins : 
   [COORD @D142705, DEMON @D142704, REFL @D142703, PRD @D142702, 
      CASE @D142701, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SPIN, 
   [COORD @D142710, DEMON @D142709, REFL @D142708, PRD @D142707, 
      CASE @D142706, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SPIN, 
   [COORD @D142712, AGR [COUNT @D142711, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPIN, 
   [COORD @D142714, 
      AGR [COUNT @D142713, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPIN, 
   [COORD @D142716, 
      AGR [COUNT @D142715, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPIN, 
   [COORD @D142718, 
      AGR [COUNT @D142717, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPIN.

WORD spread : 
   [COORD @D142725, REFL @D142724, PRD @D142723, CASE @D142722, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SPREAD, 
   [COORD @D142730, REFL @D142729, COUNT @D142728, PRD @D142727, 
      CASE @D142726, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SPREAD, 
   [COORD @D142733, 
      AGR [COUNT @D142732, PER @D142731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      ARITY 3] : SPREAD, 
   [COORD @D142735, AGR [COUNT @D142734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : SPREAD, 
   [COORD @D142737, AGR [COUNT @D142736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM WITH, ARITY 3] : SPREAD, 
   [COORD @D142741, AGR [COUNT @D142740, PER @D142739, PLU @D142738, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : SPREAD, 
   [COORD @D142747, PAST @D142746, 
      AGR [CASE @D142745, COUNT @D142744, PER @D142743, PLU @D142742, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM WITH, ARITY 3] : SPREAD, 
   [COORD @D142750, AGR [COUNT @D142749, PER @D142748, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : SPREAD, 
   [COORD @D142752, AGR [COUNT @D142751, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : SPREAD, 
   [COORD @D142754, AGR [COUNT @D142753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM OVER, ARITY 3] : SPREAD, 
   [COORD @D142758, AGR [COUNT @D142757, PER @D142756, PLU @D142755, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OVER, ARITY 3] : SPREAD, 
   [COORD @D142764, PAST @D142763, 
      AGR [CASE @D142762, COUNT @D142761, PER @D142760, PLU @D142759, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OVER, ARITY 3] : SPREAD, 
   [COORD @D142767, AGR [COUNT @D142766, PER @D142765, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SPREAD, 
   [COORD @D142769, AGR [COUNT @D142768, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SPREAD, 
   [COORD @D142771, AGR [COUNT @D142770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM ON, ARITY 3] : SPREAD, 
   [COORD @D142775, AGR [COUNT @D142774, PER @D142773, PLU @D142772, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : SPREAD, 
   [COORD @D142781, PAST @D142780, 
      AGR [CASE @D142779, COUNT @D142778, PER @D142777, PLU @D142776, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM ON, ARITY 3] : SPREAD, 
   [COORD @D142784, AGR [COUNT @D142783, PER @D142782, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AMONG, ARITY 3] : SPREAD, 
   [COORD @D142786, AGR [COUNT @D142785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AMONG, ARITY 3] : SPREAD, 
   [COORD @D142788, AGR [COUNT @D142787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM AMONG, ARITY 3] : SPREAD, 
   [COORD @D142792, AGR [COUNT @D142791, PER @D142790, PLU @D142789, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM AMONG, ARITY 3] : SPREAD, 
   [COORD @D142798, PAST @D142797, 
      AGR [CASE @D142796, COUNT @D142795, PER @D142794, PLU @D142793, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM AMONG, ARITY 3] : SPREAD, 
   [COORD @D142804, PAST @D142803, AGR [CASE @D142802, COUNT @D142801, 
            PER @D142800, PLU @D142799, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, FIN -, ARITY 3] : SPREAD, 
   [COORD @D142810, PAST @D142809, 
      AGR [CASE @D142808, COUNT @D142807, PER @D142806, PLU @D142805, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM WITH, 
      FIN -, ARITY 3] : SPREAD, 
   [COORD @D142816, PAST @D142815, AGR [CASE @D142814, COUNT @D142813, 
            PER @D142812, PLU @D142811, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OVER, FIN -, ARITY 3] : SPREAD, 
   [COORD @D142822, PAST @D142821, 
      AGR [CASE @D142820, COUNT @D142819, PER @D142818, PLU @D142817, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OVER, 
      FIN -, ARITY 3] : SPREAD, 
   [COORD @D142828, PAST @D142827, AGR [CASE @D142826, COUNT @D142825, 
            PER @D142824, PLU @D142823, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, FIN -, ARITY 3] : SPREAD, 
   [COORD @D142834, PAST @D142833, 
      AGR [CASE @D142832, COUNT @D142831, PER @D142830, PLU @D142829, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ON, 
      FIN -, ARITY 3] : SPREAD, 
   [COORD @D142840, PAST @D142839, AGR [CASE @D142838, COUNT @D142837, 
            PER @D142836, PLU @D142835, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM AMONG, FIN -, ARITY 3] : SPREAD, 
   [COORD @D142846, PAST @D142845, 
      AGR [CASE @D142844, COUNT @D142843, PER @D142842, PLU @D142841, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM AMONG, 
      FIN -, ARITY 3] : SPREAD, 
   [COORD @D142850, AGR [COUNT @D142849, PER @D142848, PLU @D142847, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM WITH, PAST +, ARITY 3] : SPREAD, 
   [COORD @D142854, 
      AGR [COUNT @D142853, PER @D142852, PLU @D142851, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM OVER, PAST +, ARITY 3] : SPREAD, 
   [COORD @D142858, AGR [COUNT @D142857, PER @D142856, PLU @D142855, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ON, PAST +, ARITY 3] : SPREAD, 
   [COORD @D142862, 
      AGR [COUNT @D142861, PER @D142860, PLU @D142859, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM AMONG, PAST +, ARITY 3] : SPREAD, 
   [COORD @D142865, AGR [COUNT @D142864, PER @D142863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPREAD, 
   [COORD @D142867, AGR [COUNT @D142866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPREAD, 
   [COORD @D142869, AGR [COUNT @D142868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : SPREAD, 
   [COORD @D142873, AGR [COUNT @D142872, PER @D142871, PLU @D142870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : SPREAD, 
   [COORD @D142879, PAST @D142878, AGR [CASE @D142877, COUNT @D142876, 
            PER @D142875, PLU @D142874, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : SPREAD, 
   [COORD @D142882, 
      AGR [COUNT @D142881, PER @D142880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM OVER, 
      ARITY 2] : SPREAD, 
   [COORD @D142884, AGR [COUNT @D142883, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : SPREAD, 
   [COORD @D142886, AGR [COUNT @D142885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : SPREAD, 
   [COORD @D142890, AGR [COUNT @D142889, PER @D142888, PLU @D142887, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM OVER, ARITY 2] : SPREAD, 
   [COORD @D142896, PAST @D142895, 
      AGR [CASE @D142894, COUNT @D142893, PER @D142892, PLU @D142891, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM OVER, ARITY 2] : SPREAD, 
   [COORD @D142899, AGR [COUNT @D142898, PER @D142897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SPREAD, 
   [COORD @D142901, AGR [COUNT @D142900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SPREAD, 
   [COORD @D142903, AGR [COUNT @D142902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SPREAD, 
   [COORD @D142907, AGR [COUNT @D142906, PER @D142905, PLU @D142904, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : SPREAD, 
   [COORD @D142913, PAST @D142912, 
      AGR [CASE @D142911, COUNT @D142910, PER @D142909, PLU @D142908, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : SPREAD, 
   [COORD @D142916, AGR [COUNT @D142915, PER @D142914, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SPREAD, 
   [COORD @D142918, AGR [COUNT @D142917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SPREAD, 
   [COORD @D142920, AGR [COUNT @D142919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : SPREAD, 
   [COORD @D142924, AGR [COUNT @D142923, PER @D142922, PLU @D142921, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : SPREAD, 
   [COORD @D142930, PAST @D142929, 
      AGR [CASE @D142928, COUNT @D142927, PER @D142926, PLU @D142925, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : SPREAD, 
   [COORD @D142936, PAST @D142935, AGR [CASE @D142934, COUNT @D142933, 
            PER @D142932, PLU @D142931, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SPREAD, 
   [COORD @D142942, PAST @D142941, 
      AGR [CASE @D142940, COUNT @D142939, PER @D142938, PLU @D142937, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SPREAD, 
   [COORD @D142948, PAST @D142947, AGR [CASE @D142946, COUNT @D142945, 
            PER @D142944, PLU @D142943, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM OVER, FIN -, ARITY 2] : SPREAD, 
   [COORD @D142954, PAST @D142953, 
      AGR [CASE @D142952, COUNT @D142951, PER @D142950, PLU @D142949, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      FIN -, ARITY 2] : SPREAD, 
   [COORD @D142960, PAST @D142959, AGR [CASE @D142958, COUNT @D142957, 
            PER @D142956, PLU @D142955, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : SPREAD, 
   [COORD @D142966, PAST @D142965, 
      AGR [CASE @D142964, COUNT @D142963, PER @D142962, PLU @D142961, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : SPREAD, 
   [COORD @D142970, AGR [COUNT @D142969, PER @D142968, PLU @D142967, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SPREAD, 
   [COORD @D142974, AGR [COUNT @D142973, PER @D142972, PLU @D142971, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM OVER, PAST +, ARITY 2] : SPREAD, 
   [COORD @D142978, 
      AGR [COUNT @D142977, PER @D142976, PLU @D142975, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, PAST +, ARITY 2] : SPREAD, 
   [COORD @D142982, AGR [COUNT @D142981, PER @D142980, PLU @D142979, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : SPREAD, 
   [COORD @D142985, AGR [COUNT @D142984, PER @D142983, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPREAD, 
   [COORD @D142987, AGR [COUNT @D142986, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPREAD, 
   [COORD @D142989, AGR [COUNT @D142988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : SPREAD, 
   [COORD @D142993, AGR [COUNT @D142992, PER @D142991, PLU @D142990, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : SPREAD, 
   [COORD @D142999, PAST @D142998, 
      AGR [CASE @D142997, COUNT @D142996, PER @D142995, PLU @D142994, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : SPREAD, 
   [COORD @D143002, AGR [COUNT @D143001, PER @D143000, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SPREAD, 
   [COORD @D143004, AGR [COUNT @D143003, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SPREAD, 
   [COORD @D143006, AGR [COUNT @D143005, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : SPREAD, 
   [COORD @D143010, AGR [COUNT @D143009, PER @D143008, PLU @D143007, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : SPREAD, 
   [COORD @D143016, PAST @D143015, 
      AGR [CASE @D143014, COUNT @D143013, PER @D143012, PLU @D143011, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : SPREAD, 
   [COORD @D143022, PAST @D143021, AGR [CASE @D143020, COUNT @D143019, 
            PER @D143018, PLU @D143017, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : SPREAD, 
   [COORD @D143028, PAST @D143027, 
      AGR [CASE @D143026, COUNT @D143025, PER @D143024, PLU @D143023, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : SPREAD, 
   [COORD @D143032, AGR [COUNT @D143031, PER @D143030, PLU @D143029, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : SPREAD, 
   [COORD @D143036, AGR [COUNT @D143035, PER @D143034, PLU @D143033, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, PAST +, ARITY 1] : SPREAD.

WORD spreading : 
   [COORD @D143051, PRD @D143050, AGR [CASE @D143049, COUNT @D143048, 
            PER @D143047, PLU @D143046, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143057, PRD @D143056, 
      AGR [CASE @D143055, COUNT @D143054, PER @D143053, PLU @D143052, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SPREAD, 
   [COORD @D143063, PRD @D143062, AGR [CASE @D143061, COUNT @D143060, 
            PER @D143059, PLU @D143058, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143069, PRD @D143068, 
      AGR [CASE @D143067, COUNT @D143066, PER @D143065, PLU @D143064, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143075, PRD @D143074, AGR [CASE @D143073, COUNT @D143072, 
            PER @D143071, PLU @D143070, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143081, PRD @D143080, 
      AGR [CASE @D143079, COUNT @D143078, PER @D143077, PLU @D143076, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SPREAD, 
   [COORD @D143087, PRD @D143086, AGR [CASE @D143085, COUNT @D143084, 
            PER @D143083, PLU @D143082, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143093, PRD @D143092, 
      AGR [CASE @D143091, COUNT @D143090, PER @D143089, PLU @D143088, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SPREAD, 
   [COORD @D143099, PRD @D143098, AGR [CASE @D143097, COUNT @D143096, 
            PER @D143095, PLU @D143094, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143105, PRD @D143104, 
      AGR [CASE @D143103, COUNT @D143102, PER @D143101, PLU @D143100, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SPREAD.

WORD spreads : 
   [COORD @D143115, DEMON @D143114, REFL @D143113, PRD @D143112, 
      CASE @D143111, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SPREAD, 
   [COORD @D143117, AGR [COUNT @D143116, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SPREAD, 
   [COORD @D143119, AGR [COUNT @D143118, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SPREAD, 
   [COORD @D143121, AGR [COUNT @D143120, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SPREAD, 
   [COORD @D143123, AGR [COUNT @D143122, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AMONG, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SPREAD, 
   [COORD @D143125, AGR [COUNT @D143124, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143127, 
      AGR [COUNT @D143126, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143129, 
      AGR [COUNT @D143128, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143131, 
      AGR [COUNT @D143130, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143133, 
      AGR [COUNT @D143132, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPREAD, 
   [COORD @D143135, 
      AGR [COUNT @D143134, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SPREAD.

WORD stake : 
   [COORD @D143144, REFL @D143143, PRD @D143142, CASE @D143141, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STAKE, 
   [COORD @D143148, REFL @D143147, PRD @D143146, CASE @D143145, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STAKE, 
   [COORD @D143151, 
      AGR [COUNT @D143150, PER @D143149, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, ARITY 3] : 
   STAKE, 
   [COORD @D143153, AGR [COUNT @D143152, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : STAKE, 
   [COORD @D143155, AGR [COUNT @D143154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : STAKE, 
   [COORD @D143159, AGR [COUNT @D143158, PER @D143157, PLU @D143156, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : STAKE, 
   [COORD @D143165, PAST @D143164, AGR 
         [CASE @D143163, COUNT @D143162, PER @D143161, PLU @D143160, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      ARITY 3] : STAKE, 
   [COORD @D143168, AGR [COUNT @D143167, PER @D143166, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : STAKE, 
   [COORD @D143170, AGR [COUNT @D143169, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : STAKE, 
   [COORD @D143172, AGR [COUNT @D143171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : STAKE, 
   [COORD @D143176, AGR [COUNT @D143175, PER @D143174, PLU @D143173, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : STAKE, 
   [COORD @D143182, PAST @D143181, 
      AGR [CASE @D143180, COUNT @D143179, PER @D143178, PLU @D143177, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : STAKE, 
   [COORD @D143185, AGR [COUNT @D143184, PER @D143183, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : STAKE, 
   [COORD @D143187, AGR [COUNT @D143186, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : STAKE, 
   [COORD @D143189, AGR [COUNT @D143188, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : STAKE, 
   [COORD @D143193, AGR [COUNT @D143192, PER @D143191, PLU @D143190, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : STAKE, 
   [COORD @D143199, PAST @D143198, 
      AGR [CASE @D143197, COUNT @D143196, PER @D143195, PLU @D143194, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : STAKE, 
   [COORD @D143202, AGR [COUNT @D143201, PER @D143200, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STAKE, 
   [COORD @D143204, AGR [COUNT @D143203, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STAKE, 
   [COORD @D143206, AGR [COUNT @D143205, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STAKE, 
   [COORD @D143210, AGR [COUNT @D143209, PER @D143208, PLU @D143207, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STAKE, 
   [COORD @D143216, PAST @D143215, AGR [CASE @D143214, COUNT @D143213, 
            PER @D143212, PLU @D143211, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STAKE, 
   [COORD @D143219, AGR [COUNT @D143218, PER @D143217, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : STAKE, 
   [COORD @D143221, AGR [COUNT @D143220, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : STAKE, 
   [COORD @D143223, AGR [COUNT @D143222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : STAKE, 
   [COORD @D143227, AGR [COUNT @D143226, PER @D143225, PLU @D143224, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : STAKE, 
   [COORD @D143233, PAST @D143232, 
      AGR [CASE @D143231, COUNT @D143230, PER @D143229, PLU @D143228, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : STAKE, 
   [COORD @D143236, AGR [COUNT @D143235, PER @D143234, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : STAKE, 
   [COORD @D143238, AGR [COUNT @D143237, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : STAKE, 
   [COORD @D143240, AGR [COUNT @D143239, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : STAKE, 
   [COORD @D143244, AGR [COUNT @D143243, PER @D143242, PLU @D143241, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : STAKE, 
   [COORD @D143250, PAST @D143249, 
      AGR [CASE @D143248, COUNT @D143247, PER @D143246, PLU @D143245, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : STAKE, 
   [COORD @D143253, AGR [COUNT @D143252, PER @D143251, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STAKE, 
   [COORD @D143255, AGR [COUNT @D143254, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STAKE, 
   [COORD @D143257, AGR [COUNT @D143256, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STAKE, 
   [COORD @D143261, AGR [COUNT @D143260, PER @D143259, PLU @D143258, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STAKE, 
   [COORD @D143267, PAST @D143266, 
      AGR [CASE @D143265, COUNT @D143264, PER @D143263, PLU @D143262, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : STAKE, 
   [COORD @D143270, AGR [COUNT @D143269, PER @D143268, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STAKE, 
   [COORD @D143272, AGR [COUNT @D143271, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STAKE, 
   [COORD @D143274, AGR [COUNT @D143273, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STAKE, 
   [COORD @D143278, AGR [COUNT @D143277, PER @D143276, PLU @D143275, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STAKE, 
   [COORD @D143284, PAST @D143283, 
      AGR [CASE @D143282, COUNT @D143281, PER @D143280, PLU @D143279, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : STAKE.

WORD staked : 
   [COORD @D143296, AGR [CASE @D143295, COUNT @D143294, PER @D143293, 
            PLU @D143292, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAKE, 
   [COORD @D143301, AGR [CASE @D143300, COUNT @D143299, PER @D143298, 
            PLU @D143297, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143306, AGR [CASE @D143305, COUNT @D143304, PER @D143303, 
            PLU @D143302, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143311, AGR [CASE @D143310, COUNT @D143309, PER @D143308, 
            PLU @D143307, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143316, AGR [CASE @D143315, COUNT @D143314, PER @D143313, 
            PLU @D143312, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143321, AGR [CASE @D143320, COUNT @D143319, PER @D143318, 
            PLU @D143317, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143326, AGR [CASE @D143325, COUNT @D143324, PER @D143323, 
            PLU @D143322, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143331, AGR [CASE @D143330, COUNT @D143329, PER @D143328, 
            PLU @D143327, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143336, AGR [CASE @D143335, COUNT @D143334, PER @D143333, 
            PLU @D143332, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143341, AGR [CASE @D143340, COUNT @D143339, PER @D143338, 
            PLU @D143337, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAKE, 
   [COORD @D143346, AGR [CASE @D143345, COUNT @D143344, PER @D143343, 
            PLU @D143342, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143351, AGR [CASE @D143350, COUNT @D143349, PER @D143348, 
            PLU @D143347, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143356, AGR [CASE @D143355, COUNT @D143354, PER @D143353, 
            PLU @D143352, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143361, AGR [CASE @D143360, COUNT @D143359, PER @D143358, 
            PLU @D143357, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143366, AGR [CASE @D143365, COUNT @D143364, PER @D143363, 
            PLU @D143362, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143371, AGR [CASE @D143370, COUNT @D143369, PER @D143368, 
            PLU @D143367, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143376, AGR [CASE @D143375, COUNT @D143374, PER @D143373, 
            PLU @D143372, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143381, AGR [CASE @D143380, COUNT @D143379, PER @D143378, 
            PLU @D143377, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143386, AGR [CASE @D143385, COUNT @D143384, PER @D143383, 
            PLU @D143382, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143391, AGR [CASE @D143390, COUNT @D143389, PER @D143388, 
            PLU @D143387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143396, AGR [CASE @D143395, COUNT @D143394, PER @D143393, 
            PLU @D143392, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143401, AGR [CASE @D143400, COUNT @D143399, PER @D143398, 
            PLU @D143397, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STAKE.

WORD stakes : 
   [COORD @D143412, REFL @D143411, PRD @D143410, CASE @D143409, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STAKES, 
   [COORD @D143416, REFL @D143415, PRD @D143414, CASE @D143413, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : STAKES, 
   [COORD @D143421, DEMON @D143420, REFL @D143419, PRD @D143418, 
      CASE @D143417, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STAKE, 
   [COORD @D143426, DEMON @D143425, REFL @D143424, PRD @D143423, 
      CASE @D143422, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : STAKE, 
   [COORD @D143428, AGR [COUNT @D143427, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STAKE, 
   [COORD @D143430, AGR [COUNT @D143429, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAKE, 
   [COORD @D143432, AGR [COUNT @D143431, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAKE, 
   [COORD @D143434, AGR [COUNT @D143433, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAKE, 
   [COORD @D143436, 
      AGR [COUNT @D143435, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAKE, 
   [COORD @D143438, 
      AGR [COUNT @D143437, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAKE, 
   [COORD @D143440, 
      AGR [COUNT @D143439, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAKE, 
   [COORD @D143442, 
      AGR [COUNT @D143441, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAKE.

WORD staking : 
   [COORD @D143465, PRD @D143464, AGR [CASE @D143463, COUNT @D143462, 
            PER @D143461, PLU @D143460, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143471, PRD @D143470, 
      AGR [CASE @D143469, COUNT @D143468, PER @D143467, PLU @D143466, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAKE, 
   [COORD @D143477, PRD @D143476, AGR [CASE @D143475, COUNT @D143474, 
            PER @D143473, PLU @D143472, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143483, PRD @D143482, 
      AGR [CASE @D143481, COUNT @D143480, PER @D143479, PLU @D143478, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STAKE, 
   [COORD @D143489, PRD @D143488, AGR [CASE @D143487, COUNT @D143486, 
            PER @D143485, PLU @D143484, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143495, PRD @D143494, 
      AGR [CASE @D143493, COUNT @D143492, PER @D143491, PLU @D143490, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STAKE, 
   [COORD @D143501, PRD @D143500, AGR [CASE @D143499, COUNT @D143498, 
            PER @D143497, PLU @D143496, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAKE, 
   [COORD @D143507, PRD @D143506, 
      AGR [CASE @D143505, COUNT @D143504, PER @D143503, PLU @D143502, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAKE.

WORD stall : 
   [COORD @D143514, REFL @D143513, PRD @D143512, CASE @D143511, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : STALL, 
   [COORD @D143518, REFL @D143517, PRD @D143516, CASE @D143515, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STALL, 
   [COORD @D143521, 
      AGR [COUNT @D143520, PER @D143519, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   STALL, 
   [COORD @D143523, AGR [COUNT @D143522, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STALL, 
   [COORD @D143525, AGR [COUNT @D143524, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STALL, 
   [COORD @D143529, AGR [COUNT @D143528, PER @D143527, PLU @D143526, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STALL, 
   [COORD @D143535, PAST @D143534, AGR [CASE @D143533, COUNT @D143532, 
            PER @D143531, PLU @D143530, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STALL, 
   [COORD @D143538, AGR [COUNT @D143537, PER @D143536, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STALL, 
   [COORD @D143540, AGR [COUNT @D143539, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STALL, 
   [COORD @D143542, AGR [COUNT @D143541, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STALL, 
   [COORD @D143546, AGR [COUNT @D143545, PER @D143544, PLU @D143543, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STALL, 
   [COORD @D143552, PAST @D143551, AGR [CASE @D143550, COUNT @D143549, 
            PER @D143548, PLU @D143547, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : STALL.

WORD stalled : 
   [COORD @D143564, AGR [CASE @D143563, COUNT @D143562, PER @D143561, 
            PLU @D143560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STALL, 
   [COORD @D143569, AGR [CASE @D143568, COUNT @D143567, PER @D143566, 
            PLU @D143565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STALL, 
   [COORD @D143574, AGR [CASE @D143573, COUNT @D143572, PER @D143571, 
            PLU @D143570, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STALL, 
   [COORD @D143579, AGR [CASE @D143578, COUNT @D143577, PER @D143576, 
            PLU @D143575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STALL, 
   [COORD @D143584, AGR [CASE @D143583, COUNT @D143582, PER @D143581, 
            PLU @D143580, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STALL.

WORD stalling : 
   [COORD @D143603, PRD @D143602, AGR [CASE @D143601, COUNT @D143600, 
            PER @D143599, PLU @D143598, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STALL, 
   [COORD @D143609, PRD @D143608, 
      AGR [CASE @D143607, COUNT @D143606, PER @D143605, PLU @D143604, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STALL.

WORD stalls : 
   [COORD @D143620, REFL @D143619, PRD @D143618, CASE @D143617, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : STALLS, 
   [COORD @D143625, DEMON @D143624, REFL @D143623, PRD @D143622, 
      CASE @D143621, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STALL, 
   [COORD @D143630, DEMON @D143629, REFL @D143628, PRD @D143627, 
      CASE @D143626, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STALL, 
   [COORD @D143632, AGR [COUNT @D143631, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STALL, 
   [COORD @D143634, 
      AGR [COUNT @D143633, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STALL.

WORD stand : 
   [COORD @D143653, REFL @D143652, PRD @D143651, CASE @D143650, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STAND, 
   [COORD @D143656, 
      AGR [COUNT @D143655, PER @D143654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   STAND, 
   [COORD @D143658, AGR [COUNT @D143657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : STAND, 
   [COORD @D143660, AGR [COUNT @D143659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : STAND, 
   [COORD @D143664, AGR [COUNT @D143663, PER @D143662, PLU @D143661, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : STAND, 
   [COORD @D143670, PAST @D143669, 
      AGR [CASE @D143668, COUNT @D143667, PER @D143666, PLU @D143665, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : STAND, 
   [COORD @D143673, AGR [COUNT @D143672, PER @D143671, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STAND, 
   [COORD @D143675, AGR [COUNT @D143674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STAND, 
   [COORD @D143677, AGR [COUNT @D143676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STAND, 
   [COORD @D143681, AGR [COUNT @D143680, PER @D143679, PLU @D143678, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : STAND, 
   [COORD @D143687, PAST @D143686, 
      AGR [CASE @D143685, COUNT @D143684, PER @D143683, PLU @D143682, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : STAND, 
   [COORD @D143690, AGR [COUNT @D143689, PER @D143688, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : STAND, 
   [COORD @D143692, AGR [COUNT @D143691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : STAND, 
   [COORD @D143694, AGR [COUNT @D143693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : STAND, 
   [COORD @D143698, AGR [COUNT @D143697, PER @D143696, PLU @D143695, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : STAND, 
   [COORD @D143704, PAST @D143703, 
      AGR [CASE @D143702, COUNT @D143701, PER @D143700, PLU @D143699, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : STAND, 
   [COORD @D143707, AGR [COUNT @D143706, PER @D143705, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143709, AGR [COUNT @D143708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143711, AGR [COUNT @D143710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143715, AGR [COUNT @D143714, PER @D143713, PLU @D143712, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 2] : STAND, 
   [COORD @D143721, PAST @D143720, 
      AGR [CASE @D143719, COUNT @D143718, PER @D143717, PLU @D143716, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143724, AGR [COUNT @D143723, PER @D143722, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143726, AGR [COUNT @D143725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143728, AGR [COUNT @D143727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143732, AGR [COUNT @D143731, PER @D143730, PLU @D143729, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 2] : STAND, 
   [COORD @D143738, PAST @D143737, 
      AGR [CASE @D143736, COUNT @D143735, PER @D143734, PLU @D143733, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143741, AGR [COUNT @D143740, PER @D143739, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143743, AGR [COUNT @D143742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143745, AGR [COUNT @D143744, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143749, AGR [COUNT @D143748, PER @D143747, PLU @D143746, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : STAND, 
   [COORD @D143755, PAST @D143754, 
      AGR [CASE @D143753, COUNT @D143752, PER @D143751, PLU @D143750, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143758, AGR [COUNT @D143757, PER @D143756, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143760, AGR [COUNT @D143759, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143762, AGR [COUNT @D143761, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143766, AGR [COUNT @D143765, PER @D143764, PLU @D143763, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, REG -, ARITY 2] : STAND, 
   [COORD @D143772, PAST @D143771, 
      AGR [CASE @D143770, COUNT @D143769, PER @D143768, PLU @D143767, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143775, AGR [COUNT @D143774, PER @D143773, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143777, AGR [COUNT @D143776, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143779, AGR [COUNT @D143778, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143783, AGR [COUNT @D143782, PER @D143781, PLU @D143780, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143789, PAST @D143788, AGR [CASE @D143787, COUNT @D143786, 
            PER @D143785, PLU @D143784, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : STAND, 
   [COORD @D143792, AGR 
         [COUNT @D143791, PER @D143790, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, ARITY 2] : 
   STAND, 
   [COORD @D143794, AGR [COUNT @D143793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143796, AGR [COUNT @D143795, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143800, AGR [COUNT @D143799, PER @D143798, PLU @D143797, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143806, PAST @D143805, AGR [CASE @D143804, COUNT @D143803, 
            PER @D143802, PLU @D143801, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT MP, REG -, ARITY 2] : STAND, 
   [COORD @D143809, AGR 
         [COUNT @D143808, PER @D143807, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : 
   STAND, 
   [COORD @D143811, AGR [COUNT @D143810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143813, AGR [COUNT @D143812, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143817, AGR [COUNT @D143816, PER @D143815, PLU @D143814, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143823, PAST @D143822, AGR [CASE @D143821, COUNT @D143820, 
            PER @D143819, PLU @D143818, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : STAND, 
   [COORD @D143826, 
      AGR [COUNT @D143825, PER @D143824, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, ARITY 2] : 
   STAND, 
   [COORD @D143828, AGR [COUNT @D143827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143830, AGR [COUNT @D143829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, 
      ARITY 2] : STAND, 
   [COORD @D143834, AGR [COUNT @D143833, PER @D143832, PLU @D143831, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      REG -, ARITY 2] : STAND, 
   [COORD @D143840, PAST @D143839, AGR [CASE @D143838, COUNT @D143837, 
            PER @D143836, PLU @D143835, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, REG -, ARITY 2] : STAND, 
   [COORD @D143843, 
      AGR [COUNT @D143842, PER @D143841, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM UNDER, ARITY 2] : STAND, 
   [COORD @D143845, AGR [COUNT @D143844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM UNDER, ARITY 2] : STAND, 
   [COORD @D143847, AGR [COUNT @D143846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM UNDER, ARITY 2] : STAND, 
   [COORD @D143851, AGR [COUNT @D143850, PER @D143849, PLU @D143848, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM UNDER, ARITY 2] : STAND, 
   [COORD @D143857, PAST @D143856, 
      AGR [CASE @D143855, COUNT @D143854, PER @D143853, PLU @D143852, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM UNDER, ARITY 2] : STAND, 
   [COORD @D143860, AGR [COUNT @D143859, PER @D143858, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : STAND, 
   [COORD @D143862, AGR [COUNT @D143861, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : STAND, 
   [COORD @D143864, AGR [COUNT @D143863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : STAND, 
   [COORD @D143868, AGR [COUNT @D143867, PER @D143866, PLU @D143865, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : STAND, 
   [COORD @D143874, PAST @D143873, 
      AGR [CASE @D143872, COUNT @D143871, PER @D143870, PLU @D143869, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, ARITY 2] : STAND, 
   [COORD @D143877, AGR [COUNT @D143876, PER @D143875, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FROM, ARITY 2] : STAND, 
   [COORD @D143879, AGR [COUNT @D143878, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FROM, ARITY 2] : STAND, 
   [COORD @D143881, AGR [COUNT @D143880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FROM, ARITY 2] : STAND, 
   [COORD @D143885, AGR [COUNT @D143884, PER @D143883, PLU @D143882, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM FROM, ARITY 2] : STAND, 
   [COORD @D143891, PAST @D143890, 
      AGR [CASE @D143889, COUNT @D143888, PER @D143887, PLU @D143886, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FROM, ARITY 2] : STAND, 
   [COORD @D143894, AGR [COUNT @D143893, PER @D143892, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143896, AGR [COUNT @D143895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143898, AGR [COUNT @D143897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143902, AGR [COUNT @D143901, PER @D143900, PLU @D143899, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143908, PAST @D143907, 
      AGR [CASE @D143906, COUNT @D143905, PER @D143904, PLU @D143903, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143911, AGR [COUNT @D143910, PER @D143909, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143913, AGR [COUNT @D143912, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143915, AGR [COUNT @D143914, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143919, AGR [COUNT @D143918, PER @D143917, PLU @D143916, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143925, PAST @D143924, 
      AGR [CASE @D143923, COUNT @D143922, PER @D143921, PLU @D143920, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143928, AGR [COUNT @D143927, PER @D143926, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143930, AGR [COUNT @D143929, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143932, AGR [COUNT @D143931, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143936, AGR [COUNT @D143935, PER @D143934, PLU @D143933, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143942, PAST @D143941, 
      AGR [CASE @D143940, COUNT @D143939, PER @D143938, PLU @D143937, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143945, AGR [COUNT @D143944, PER @D143943, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143947, AGR [COUNT @D143946, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143949, AGR [COUNT @D143948, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143953, AGR [COUNT @D143952, PER @D143951, PLU @D143950, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT IN, PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143959, PAST @D143958, 
      AGR [CASE @D143957, COUNT @D143956, PER @D143955, PLU @D143954, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, ARITY 2] : STAND, 
   [COORD @D143962, AGR [COUNT @D143961, PER @D143960, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STAND, 
   [COORD @D143964, AGR [COUNT @D143963, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STAND, 
   [COORD @D143966, AGR [COUNT @D143965, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STAND, 
   [COORD @D143970, AGR [COUNT @D143969, PER @D143968, PLU @D143967, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BY, ARITY 2] : STAND, 
   [COORD @D143976, PAST @D143975, 
      AGR [CASE @D143974, COUNT @D143973, PER @D143972, PLU @D143971, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STAND, 
   [COORD @D143979, AGR [COUNT @D143978, PER @D143977, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AMONG, ARITY 2] : STAND, 
   [COORD @D143981, AGR [COUNT @D143980, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AMONG, ARITY 2] : STAND, 
   [COORD @D143983, AGR [COUNT @D143982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AMONG, ARITY 2] : STAND, 
   [COORD @D143987, AGR [COUNT @D143986, PER @D143985, PLU @D143984, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM AMONG, ARITY 2] : STAND, 
   [COORD @D143993, PAST @D143992, 
      AGR [CASE @D143991, COUNT @D143990, PER @D143989, PLU @D143988, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM AMONG, ARITY 2] : STAND, 
   [COORD @D143996, AGR [COUNT @D143995, PER @D143994, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D143998, AGR [COUNT @D143997, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144000, AGR [COUNT @D143999, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144004, AGR [COUNT @D144003, PER @D144002, PLU @D144001, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144010, PAST @D144009, 
      AGR [CASE @D144008, COUNT @D144007, PER @D144006, PLU @D144005, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144013, AGR [COUNT @D144012, PER @D144011, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144015, AGR [COUNT @D144014, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144017, AGR [COUNT @D144016, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OUT, PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144021, AGR [COUNT @D144020, PER @D144019, PLU @D144018, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OUT, PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144027, PAST @D144026, 
      AGR [CASE @D144025, COUNT @D144024, PER @D144023, PLU @D144022, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM AGAINST, ARITY 2] : STAND, 
   [COORD @D144030, AGR [COUNT @D144029, PER @D144028, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STAND, 
   [COORD @D144032, AGR [COUNT @D144031, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STAND, 
   [COORD @D144034, AGR [COUNT @D144033, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STAND, 
   [COORD @D144038, AGR [COUNT @D144037, PER @D144036, PLU @D144035, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : STAND, 
   [COORD @D144044, PAST @D144043, 
      AGR [CASE @D144042, COUNT @D144041, PER @D144040, PLU @D144039, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : STAND, 
   [COORD @D144047, AGR [COUNT @D144046, PER @D144045, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : STAND, 
   [COORD @D144049, AGR [COUNT @D144048, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : STAND, 
   [COORD @D144051, AGR [COUNT @D144050, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT TO, ARITY 2] : STAND, 
   [COORD @D144055, AGR [COUNT @D144054, PER @D144053, PLU @D144052, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TO, ARITY 2] : STAND, 
   [COORD @D144061, PAST @D144060, 
      AGR [CASE @D144059, COUNT @D144058, PER @D144057, PLU @D144056, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TO, 
      ARITY 2] : STAND, 
   [COORD @D144064, AGR [COUNT @D144063, PER @D144062, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : STAND, 
   [COORD @D144066, AGR [COUNT @D144065, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : STAND, 
   [COORD @D144068, AGR [COUNT @D144067, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : STAND, 
   [COORD @D144072, AGR [COUNT @D144071, PER @D144070, PLU @D144069, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : STAND, 
   [COORD @D144078, PAST @D144077, 
      AGR [CASE @D144076, COUNT @D144075, PER @D144074, PLU @D144073, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : STAND, 
   [COORD @D144081, AGR [COUNT @D144080, PER @D144079, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STAND, 
   [COORD @D144083, AGR [COUNT @D144082, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STAND, 
   [COORD @D144085, AGR [COUNT @D144084, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STAND, 
   [COORD @D144089, AGR [COUNT @D144088, PER @D144087, PLU @D144086, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : STAND, 
   [COORD @D144095, PAST @D144094, 
      AGR [CASE @D144093, COUNT @D144092, PER @D144091, PLU @D144090, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STAND, 
   [COORD @D144098, AGR [COUNT @D144097, PER @D144096, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STAND, 
   [COORD @D144100, AGR [COUNT @D144099, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STAND, 
   [COORD @D144102, AGR [COUNT @D144101, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STAND, 
   [COORD @D144106, AGR [COUNT @D144105, PER @D144104, PLU @D144103, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : STAND, 
   [COORD @D144112, PAST @D144111, 
      AGR [CASE @D144110, COUNT @D144109, PER @D144108, PLU @D144107, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : STAND, 
   [COORD @D144115, AGR [COUNT @D144114, PER @D144113, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STAND, 
   [COORD @D144117, AGR [COUNT @D144116, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STAND, 
   [COORD @D144119, AGR [COUNT @D144118, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STAND, 
   [COORD @D144123, AGR [COUNT @D144122, PER @D144121, PLU @D144120, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : STAND, 
   [COORD @D144129, PAST @D144128, 
      AGR [CASE @D144127, COUNT @D144126, PER @D144125, PLU @D144124, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : STAND, 
   [COORD @D144132, AGR [COUNT @D144131, PER @D144130, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : STAND, 
   [COORD @D144134, AGR [COUNT @D144133, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : STAND, 
   [COORD @D144136, AGR [COUNT @D144135, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TO, ARITY 1] : STAND, 
   [COORD @D144140, AGR [COUNT @D144139, PER @D144138, PLU @D144137, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TO, ARITY 1] : STAND, 
   [COORD @D144146, PAST @D144145, 
      AGR [CASE @D144144, COUNT @D144143, PER @D144142, PLU @D144141, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, ARITY 1] : STAND, 
   [COORD @D144149, AGR [COUNT @D144148, PER @D144147, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STAND, 
   [COORD @D144151, AGR [COUNT @D144150, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STAND, 
   [COORD @D144153, AGR [COUNT @D144152, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STAND, 
   [COORD @D144157, AGR [COUNT @D144156, PER @D144155, PLU @D144154, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : STAND, 
   [COORD @D144163, PAST @D144162, 
      AGR [CASE @D144161, COUNT @D144160, PER @D144159, PLU @D144158, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : STAND, 
   [COORD @D144166, AGR [COUNT @D144165, PER @D144164, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : STAND, 
   [COORD @D144168, AGR [COUNT @D144167, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : STAND, 
   [COORD @D144170, AGR [COUNT @D144169, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : STAND, 
   [COORD @D144174, AGR [COUNT @D144173, PER @D144172, PLU @D144171, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : STAND, 
   [COORD @D144180, PAST @D144179, 
      AGR [CASE @D144178, COUNT @D144177, PER @D144176, PLU @D144175, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : STAND, 
   [COORD @D144183, AGR [COUNT @D144182, PER @D144181, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : STAND, 
   [COORD @D144185, AGR [COUNT @D144184, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : STAND, 
   [COORD @D144187, AGR [COUNT @D144186, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : STAND, 
   [COORD @D144191, AGR [COUNT @D144190, PER @D144189, PLU @D144188, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : STAND, 
   [COORD @D144197, PAST @D144196, 
      AGR [CASE @D144195, COUNT @D144194, PER @D144193, PLU @D144192, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : STAND, 
   [COORD @D144200, AGR [COUNT @D144199, PER @D144198, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : STAND, 
   [COORD @D144202, AGR [COUNT @D144201, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : STAND, 
   [COORD @D144204, AGR [COUNT @D144203, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : STAND, 
   [COORD @D144208, AGR [COUNT @D144207, PER @D144206, PLU @D144205, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : STAND, 
   [COORD @D144214, PAST @D144213, 
      AGR [CASE @D144212, COUNT @D144211, PER @D144210, PLU @D144209, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : STAND, 
   [COORD @D144217, AGR [COUNT @D144216, PER @D144215, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : STAND, 
   [COORD @D144219, AGR [COUNT @D144218, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : STAND, 
   [COORD @D144221, AGR [COUNT @D144220, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BY, ARITY 1] : STAND, 
   [COORD @D144225, AGR [COUNT @D144224, PER @D144223, PLU @D144222, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, ARITY 1] : STAND, 
   [COORD @D144231, PAST @D144230, 
      AGR [CASE @D144229, COUNT @D144228, PER @D144227, PLU @D144226, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BY, ARITY 1] : STAND.

WORD standing : 
   [COADV @D144253, COORD @D144252, DEF @D144251, PRD @D144250, 
      AGR [CASE @D144249, COUNT @D144248, PER @D144247, PLU @D144246, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : STANDING, 
   [COORD @D144257, REFL @D144256, PRD @D144255, CASE @D144254, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : STANDING, 
   [COORD @D144263, PRD @D144262, 
      AGR [CASE @D144261, COUNT @D144260, PER @D144259, PLU @D144258, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144269, PRD @D144268, AGR [CASE @D144267, COUNT @D144266, 
            PER @D144265, PLU @D144264, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144275, PRD @D144274, 
      AGR [CASE @D144273, COUNT @D144272, PER @D144271, PLU @D144270, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144281, PRD @D144280, AGR [CASE @D144279, COUNT @D144278, 
            PER @D144277, PLU @D144276, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144287, PRD @D144286, 
      AGR [CASE @D144285, COUNT @D144284, PER @D144283, PLU @D144282, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144293, PRD @D144292, AGR [CASE @D144291, COUNT @D144290, 
            PER @D144289, PLU @D144288, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144299, PRD @D144298, 
      AGR [CASE @D144297, COUNT @D144296, PER @D144295, PLU @D144294, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   STAND, 
   [COORD @D144305, PRD @D144304, AGR [CASE @D144303, COUNT @D144302, 
            PER @D144301, PLU @D144300, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144311, PRD @D144310, 
      AGR [CASE @D144309, COUNT @D144308, PER @D144307, PLU @D144306, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT MP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STAND, 
   [COORD @D144317, PRD @D144316, AGR [CASE @D144315, COUNT @D144314, 
            PER @D144313, PLU @D144312, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144323, PRD @D144322, 
      AGR [CASE @D144321, COUNT @D144320, PER @D144319, PLU @D144318, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144329, PRD @D144328, AGR [CASE @D144327, COUNT @D144326, 
            PER @D144325, PLU @D144324, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM UNDER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144335, PRD @D144334, 
      AGR [CASE @D144333, COUNT @D144332, PER @D144331, PLU @D144330, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144341, PRD @D144340, AGR [CASE @D144339, COUNT @D144338, 
            PER @D144337, PLU @D144336, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144347, PRD @D144346, 
      AGR [CASE @D144345, COUNT @D144344, PER @D144343, PLU @D144342, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144353, PRD @D144352, AGR [CASE @D144351, COUNT @D144350, 
            PER @D144349, PLU @D144348, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144359, PRD @D144358, 
      AGR [CASE @D144357, COUNT @D144356, PER @D144355, PLU @D144354, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144365, PRD @D144364, AGR [CASE @D144363, COUNT @D144362, 
            PER @D144361, PLU @D144360, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144371, PRD @D144370, 
      AGR [CASE @D144369, COUNT @D144368, PER @D144367, PLU @D144366, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STAND, 
   [COORD @D144377, PRD @D144376, AGR [CASE @D144375, COUNT @D144374, 
            PER @D144373, PLU @D144372, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM AMONG, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144383, PRD @D144382, 
      AGR [CASE @D144381, COUNT @D144380, PER @D144379, PLU @D144378, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAND, 
   [COORD @D144389, PRD @D144388, AGR [CASE @D144387, COUNT @D144386, 
            PER @D144385, PLU @D144384, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144395, PRD @D144394, 
      AGR [CASE @D144393, COUNT @D144392, PER @D144391, PLU @D144390, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STAND, 
   [COORD @D144401, PRD @D144400, AGR [CASE @D144399, COUNT @D144398, 
            PER @D144397, PLU @D144396, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144407, PRD @D144406, 
      AGR [CASE @D144405, COUNT @D144404, PER @D144403, PLU @D144402, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STAND, 
   [COORD @D144413, PRD @D144412, AGR [CASE @D144411, COUNT @D144410, 
            PER @D144409, PLU @D144408, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144419, PRD @D144418, 
      AGR [CASE @D144417, COUNT @D144416, PER @D144415, PLU @D144414, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144425, PRD @D144424, AGR [CASE @D144423, COUNT @D144422, 
            PER @D144421, PLU @D144420, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144431, PRD @D144430, 
      AGR [CASE @D144429, COUNT @D144428, PER @D144427, PLU @D144426, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAND, 
   [COORD @D144437, PRD @D144436, AGR [CASE @D144435, COUNT @D144434, 
            PER @D144433, PLU @D144432, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144443, PRD @D144442, 
      AGR [CASE @D144441, COUNT @D144440, PER @D144439, PLU @D144438, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAND, 
   [COORD @D144449, PRD @D144448, AGR [CASE @D144447, COUNT @D144446, 
            PER @D144445, PLU @D144444, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND, 
   [COORD @D144455, PRD @D144454, 
      AGR [CASE @D144453, COUNT @D144452, PER @D144451, PLU @D144450, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAND, 
   [COORD @D144461, PRD @D144460, AGR [CASE @D144459, COUNT @D144458, 
            PER @D144457, PLU @D144456, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STAND.

WORD stands : 
   [COORD @D144484, DEMON @D144483, REFL @D144482, PRD @D144481, 
      CASE @D144480, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STAND, 
   [COORD @D144486, AGR [COUNT @D144485, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144488, 
      AGR [COUNT @D144487, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144490, 
      AGR [COUNT @D144489, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144492, 
      AGR [COUNT @D144491, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144494, 
      AGR [COUNT @D144493, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144496, 
      AGR [COUNT @D144495, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144498, 
      AGR [COUNT @D144497, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144500, 
      AGR [COUNT @D144499, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144502, 
      AGR [COUNT @D144501, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT MP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144504, 
      AGR [COUNT @D144503, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144506, 
      AGR [COUNT @D144505, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144508, 
      AGR [COUNT @D144507, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM UNDER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STAND, 
   [COORD @D144510, AGR [COUNT @D144509, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144512, AGR [COUNT @D144511, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144514, AGR [COUNT @D144513, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144516, AGR [COUNT @D144515, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : STAND, 
   [COORD @D144518, AGR [COUNT @D144517, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144520, AGR [COUNT @D144519, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144522, AGR [COUNT @D144521, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144524, AGR [COUNT @D144523, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM AMONG, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : STAND, 
   [COORD @D144526, AGR [COUNT @D144525, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144528, AGR [COUNT @D144527, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : STAND, 
   [COORD @D144530, AGR [COUNT @D144529, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144532, AGR [COUNT @D144531, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144534, AGR [COUNT @D144533, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144536, AGR [COUNT @D144535, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STAND, 
   [COORD @D144538, AGR [COUNT @D144537, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144540, 
      AGR [COUNT @D144539, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144542, 
      AGR [COUNT @D144541, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144544, 
      AGR [COUNT @D144543, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144546, 
      AGR [COUNT @D144545, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144548, 
      AGR [COUNT @D144547, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144550, 
      AGR [COUNT @D144549, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND, 
   [COORD @D144552, 
      AGR [COUNT @D144551, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAND.

WORD start : 
   [COORD @D144559, REFL @D144558, PRD @D144557, CASE @D144556, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : START, 
   [COORD @D144564, REFL @D144563, COUNT @D144562, PRD @D144561, 
      CASE @D144560, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : START, 
   [COORD @D144569, REFL @D144568, COUNT @D144567, PRD @D144566, 
      CASE @D144565, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON] : 
   START, 
   [COORD @D144574, REFL @D144573, COUNT @D144572, PRD @D144571, 
      CASE @D144570, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OVER] : 
   START, 
   [COORD @D144579, REFL @D144578, COUNT @D144577, PRD @D144576, 
      CASE @D144575, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : START, 
   [COORD @D144582, 
      AGR [COUNT @D144581, PER @D144580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : START, 
   [COORD @D144584, AGR [COUNT @D144583, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : START, 
   [COORD @D144586, AGR [COUNT @D144585, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : START, 
   [COORD @D144590, AGR [COUNT @D144589, PER @D144588, PLU @D144587, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : START, 
   [COORD @D144596, PAST @D144595, 
      AGR [CASE @D144594, COUNT @D144593, PER @D144592, PLU @D144591, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : START, 
   [COORD @D144599, AGR [COUNT @D144598, PER @D144597, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : START, 
   [COORD @D144601, AGR [COUNT @D144600, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : START, 
   [COORD @D144603, AGR [COUNT @D144602, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : START, 
   [COORD @D144607, AGR [COUNT @D144606, PER @D144605, PLU @D144604, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : START, 
   [COORD @D144613, PAST @D144612, AGR [CASE @D144611, COUNT @D144610, 
            PER @D144609, PLU @D144608, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : START, 
   [COORD @D144616, AGR [COUNT @D144615, PER @D144614, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : START, 
   [COORD @D144618, AGR [COUNT @D144617, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : START, 
   [COORD @D144620, AGR [COUNT @D144619, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : START, 
   [COORD @D144624, AGR [COUNT @D144623, PER @D144622, PLU @D144621, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : START, 
   [COORD @D144630, PAST @D144629, AGR [CASE @D144628, COUNT @D144627, 
            PER @D144626, PLU @D144625, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : START, 
   [COORD @D144633, AGR [COUNT @D144632, PER @D144631, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : START, 
   [COORD @D144635, AGR [COUNT @D144634, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : START, 
   [COORD @D144637, AGR [COUNT @D144636, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : START, 
   [COORD @D144641, AGR [COUNT @D144640, PER @D144639, PLU @D144638, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : START, 
   [COORD @D144647, PAST @D144646, AGR [CASE @D144645, COUNT @D144644, 
            PER @D144643, PLU @D144642, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : START, 
   [COORD @D144650, AGR [COUNT @D144649, PER @D144648, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : START, 
   [COORD @D144652, AGR [COUNT @D144651, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : START, 
   [COORD @D144654, AGR [COUNT @D144653, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : START, 
   [COORD @D144658, AGR [COUNT @D144657, PER @D144656, PLU @D144655, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : START, 
   [COORD @D144664, PAST @D144663, 
      AGR [CASE @D144662, COUNT @D144661, PER @D144660, PLU @D144659, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : START, 
   [COORD @D144667, AGR [COUNT @D144666, PER @D144665, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : START, 
   [COORD @D144669, AGR [COUNT @D144668, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : START, 
   [COORD @D144671, AGR [COUNT @D144670, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : START, 
   [COORD @D144675, AGR [COUNT @D144674, PER @D144673, PLU @D144672, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : START, 
   [COORD @D144681, PAST @D144680, 
      AGR [CASE @D144679, COUNT @D144678, PER @D144677, PLU @D144676, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : START, 
   [COORD @D144684, AGR [COUNT @D144683, PER @D144682, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : START, 
   [COORD @D144686, AGR [COUNT @D144685, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : START, 
   [COORD @D144688, AGR [COUNT @D144687, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : START, 
   [COORD @D144692, AGR [COUNT @D144691, PER @D144690, PLU @D144689, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM ON, ARITY 2] : START, 
   [COORD @D144698, PAST @D144697, 
      AGR [CASE @D144696, COUNT @D144695, PER @D144694, PLU @D144693, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM ON, ARITY 2] : START, 
   [COORD @D144701, AGR [COUNT @D144700, PER @D144699, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : START, 
   [COORD @D144703, AGR [COUNT @D144702, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : START, 
   [COORD @D144705, AGR [COUNT @D144704, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : START, 
   [COORD @D144709, AGR [COUNT @D144708, PER @D144707, PLU @D144706, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : START, 
   [COORD @D144715, PAST @D144714, 
      AGR [CASE @D144713, COUNT @D144712, PER @D144711, PLU @D144710, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : START, 
   [COORD @D144718, AGR [COUNT @D144717, PER @D144716, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : START, 
   [COORD @D144720, AGR [COUNT @D144719, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : START, 
   [COORD @D144722, AGR [COUNT @D144721, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : START, 
   [COORD @D144726, AGR [COUNT @D144725, PER @D144724, PLU @D144723, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : START, 
   [COORD @D144732, PAST @D144731, 
      AGR [CASE @D144730, COUNT @D144729, PER @D144728, PLU @D144727, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : START, 
   [COORD @D144735, AGR [COUNT @D144734, PER @D144733, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : START, 
   [COORD @D144737, AGR [COUNT @D144736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : START, 
   [COORD @D144739, AGR [COUNT @D144738, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : START, 
   [COORD @D144743, AGR [COUNT @D144742, PER @D144741, PLU @D144740, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : START, 
   [COORD @D144749, PAST @D144748, 
      AGR [CASE @D144747, COUNT @D144746, PER @D144745, PLU @D144744, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : START, 
   [COORD @D144752, AGR [COUNT @D144751, PER @D144750, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : START, 
   [COORD @D144754, AGR [COUNT @D144753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : START, 
   [COORD @D144756, AGR [COUNT @D144755, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : START, 
   [COORD @D144760, AGR [COUNT @D144759, PER @D144758, PLU @D144757, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : START, 
   [COORD @D144766, PAST @D144765, 
      AGR [CASE @D144764, COUNT @D144763, PER @D144762, PLU @D144761, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : START, 
   [COORD @D144769, AGR [COUNT @D144768, PER @D144767, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : START, 
   [COORD @D144771, AGR [COUNT @D144770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : START, 
   [COORD @D144773, AGR [COUNT @D144772, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : START, 
   [COORD @D144777, AGR [COUNT @D144776, PER @D144775, PLU @D144774, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : START, 
   [COORD @D144783, PAST @D144782, 
      AGR [CASE @D144781, COUNT @D144780, PER @D144779, PLU @D144778, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : START, 
   [COORD @D144786, AGR [COUNT @D144785, PER @D144784, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : START, 
   [COORD @D144788, AGR [COUNT @D144787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : START, 
   [COORD @D144790, AGR [COUNT @D144789, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : START, 
   [COORD @D144794, AGR [COUNT @D144793, PER @D144792, PLU @D144791, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : START, 
   [COORD @D144800, PAST @D144799, 
      AGR [CASE @D144798, COUNT @D144797, PER @D144796, PLU @D144795, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : START, 
   [COORD @D144802, AGR [COUNT @D144801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : START, 
   [COORD @D144804, AGR [COUNT @D144803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : START, 
   [COORD @D144808, AGR [NFORM @D144807, COUNT @D144806, PER @D144805, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : START, 
   [COORD @D144812, AGR [COUNT @D144811, PER @D144810, PLU @D144809, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : START, 
   [COORD @D144815, AGR @D144814, PAST @D144813, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_ING, ARITY 1] : START, 
   [COORD @D144817, AGR [COUNT @D144816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : START, 
   [COORD @D144819, AGR [COUNT @D144818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : START, 
   [COORD @D144823, AGR [NFORM @D144822, COUNT @D144821, PER @D144820, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : START, 
   [COORD @D144827, AGR [COUNT @D144826, PER @D144825, PLU @D144824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 1] : START, 
   [COORD @D144830, AGR @D144829, PAST @D144828, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, ARITY 1] : START, 
   [COORD @D144832, AGR [COUNT @D144831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : START, 
   [COORD @D144834, AGR [COUNT @D144833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : START, 
   [COORD @D144838, AGR [NFORM @D144837, COUNT @D144836, PER @D144835, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : START, 
   [COORD @D144842, AGR [COUNT @D144841, PER @D144840, PLU @D144839, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 1] : START, 
   [COORD @D144845, AGR @D144844, PAST @D144843, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_AP, ARITY 1] : START, 
   [COORD @D144848, AGR [COUNT @D144847, PER @D144846, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : START, 
   [COORD @D144850, AGR [COUNT @D144849, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : START, 
   [COORD @D144852, AGR [COUNT @D144851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : START, 
   [COORD @D144856, AGR [COUNT @D144855, PER @D144854, PLU @D144853, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : START, 
   [COORD @D144862, PAST @D144861, AGR [CASE @D144860, COUNT @D144859, 
            PER @D144858, PLU @D144857, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : START, 
   [COORD @D144865, AGR [COUNT @D144864, PER @D144863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : START, 
   [COORD @D144867, AGR [COUNT @D144866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : START, 
   [COORD @D144869, AGR [COUNT @D144868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : START, 
   [COORD @D144873, AGR [COUNT @D144872, PER @D144871, PLU @D144870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : START, 
   [COORD @D144879, PAST @D144878, 
      AGR [CASE @D144877, COUNT @D144876, PER @D144875, PLU @D144874, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : START, 
   [COORD @D144881, AGR [COUNT @D144880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : START, 
   [COORD @D144883, AGR [COUNT @D144882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : START, 
   [COORD @D144887, AGR [NFORM @D144886, COUNT @D144885, PER @D144884, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : START, 
   [COORD @D144891, AGR [COUNT @D144890, PER @D144889, PLU @D144888, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : START, 
   [COORD @D144894, AGR @D144893, PAST @D144892, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : START, 
   [COORD @D144896, AGR [COUNT @D144895, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : START, 
   [COORD @D144898, AGR [COUNT @D144897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : START, 
   [COORD @D144902, AGR [NFORM @D144901, COUNT @D144900, PER @D144899, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : START, 
   [COORD @D144906, AGR [COUNT @D144905, PER @D144904, PLU @D144903, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : START, 
   [COORD @D144909, AGR @D144908, PAST @D144907, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : START, 
   [COORD @D144912, AGR [COUNT @D144911, PER @D144910, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : START, 
   [COORD @D144914, AGR [COUNT @D144913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : START, 
   [COORD @D144916, AGR [COUNT @D144915, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : START, 
   [COORD @D144920, AGR [COUNT @D144919, PER @D144918, PLU @D144917, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : START, 
   [COORD @D144926, PAST @D144925, 
      AGR [CASE @D144924, COUNT @D144923, PER @D144922, PLU @D144921, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : START, 
   [COORD @D144928, AGR [COUNT @D144927, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OFF, ARITY 1] : START, 
   [COORD @D144930, AGR [COUNT @D144929, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OFF, ARITY 1] : START, 
   [COORD @D144934, AGR [NFORM @D144933, COUNT @D144932, PER @D144931, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OFF, ARITY 1] : START, 
   [COORD @D144938, AGR [COUNT @D144937, PER @D144936, PLU @D144935, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OFF, ARITY 1] : START, 
   [COORD @D144941, AGR @D144940, PAST @D144939, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, PRT OFF, ARITY 1] : START, 
   [COORD @D144943, AGR [COUNT @D144942, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OFF, ARITY 1] : START, 
   [COORD @D144945, AGR [COUNT @D144944, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OFF, ARITY 1] : START, 
   [COORD @D144949, AGR [NFORM @D144948, COUNT @D144947, PER @D144946, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OFF, ARITY 1] : START, 
   [COORD @D144953, AGR [COUNT @D144952, PER @D144951, PLU @D144950, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OFF, ARITY 1] : START, 
   [COORD @D144956, AGR @D144955, PAST @D144954, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_AP, PRT OFF, ARITY 1] : START, 
   [COORD @D144959, AGR [COUNT @D144958, PER @D144957, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : START, 
   [COORD @D144961, AGR [COUNT @D144960, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : START, 
   [COORD @D144963, AGR [COUNT @D144962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : START, 
   [COORD @D144967, AGR [COUNT @D144966, PER @D144965, PLU @D144964, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : START, 
   [COORD @D144973, PAST @D144972, 
      AGR [CASE @D144971, COUNT @D144970, PER @D144969, PLU @D144968, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : START, 
   [COORD @D144976, AGR [COUNT @D144975, PER @D144974, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : START, 
   [COORD @D144978, AGR [COUNT @D144977, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : START, 
   [COORD @D144980, AGR [COUNT @D144979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : START, 
   [COORD @D144984, AGR [COUNT @D144983, PER @D144982, PLU @D144981, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : START, 
   [COORD @D144990, PAST @D144989, 
      AGR [CASE @D144988, COUNT @D144987, PER @D144986, PLU @D144985, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : START.

WORD started : 
   [COORD @D145000, AGR [CASE @D144999, COUNT @D144998, PER @D144997, 
            PLU @D144996, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145005, AGR [CASE @D145004, COUNT @D145003, PER @D145002, 
            PLU @D145001, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145010, AGR [CASE @D145009, COUNT @D145008, PER @D145007, 
            PLU @D145006, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145015, AGR [CASE @D145014, COUNT @D145013, PER @D145012, 
            PLU @D145011, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145020, AGR [CASE @D145019, COUNT @D145018, PER @D145017, 
            PLU @D145016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145025, AGR [CASE @D145024, COUNT @D145023, PER @D145022, 
            PLU @D145021, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145030, AGR [CASE @D145029, COUNT @D145028, PER @D145027, 
            PLU @D145026, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145035, AGR [CASE @D145034, COUNT @D145033, PER @D145032, 
            PLU @D145031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145040, AGR [CASE @D145039, COUNT @D145038, PER @D145037, 
            PLU @D145036, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145045, AGR [CASE @D145044, COUNT @D145043, PER @D145042, 
            PLU @D145041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145050, AGR [CASE @D145049, COUNT @D145048, PER @D145047, 
            PLU @D145046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145055, AGR [CASE @D145054, COUNT @D145053, PER @D145052, 
            PLU @D145051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145060, AGR [CASE @D145059, COUNT @D145058, PER @D145057, 
            PLU @D145056, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145065, AGR [CASE @D145064, COUNT @D145063, PER @D145062, 
            PLU @D145061, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145070, AGR [CASE @D145069, COUNT @D145068, PER @D145067, 
            PLU @D145066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145075, AGR [CASE @D145074, COUNT @D145073, PER @D145072, 
            PLU @D145071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145080, AGR [CASE @D145079, COUNT @D145078, PER @D145077, 
            PLU @D145076, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145085, AGR [CASE @D145084, COUNT @D145083, PER @D145082, 
            PLU @D145081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145090, AGR [CASE @D145089, COUNT @D145088, PER @D145087, 
            PLU @D145086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145095, AGR [CASE @D145094, COUNT @D145093, PER @D145092, 
            PLU @D145091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145100, AGR [CASE @D145099, COUNT @D145098, PER @D145097, 
            PLU @D145096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145105, AGR [CASE @D145104, COUNT @D145103, PER @D145102, 
            PLU @D145101, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145110, AGR [CASE @D145109, COUNT @D145108, PER @D145107, 
            PLU @D145106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145115, AGR [CASE @D145114, COUNT @D145113, PER @D145112, 
            PLU @D145111, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145120, AGR [CASE @D145119, COUNT @D145118, PER @D145117, 
            PLU @D145116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145125, AGR [CASE @D145124, COUNT @D145123, PER @D145122, 
            PLU @D145121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145130, AGR [CASE @D145129, COUNT @D145128, PER @D145127, 
            PLU @D145126, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145135, AGR [CASE @D145134, COUNT @D145133, PER @D145132, 
            PLU @D145131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145140, AGR [CASE @D145139, COUNT @D145138, PER @D145137, 
            PLU @D145136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145145, AGR [CASE @D145144, COUNT @D145143, PER @D145142, 
            PLU @D145141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145150, AGR [CASE @D145149, COUNT @D145148, PER @D145147, 
            PLU @D145146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145155, AGR [CASE @D145154, COUNT @D145153, PER @D145152, 
            PLU @D145151, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145157, AGR @D145156, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : START, 
   [COORD @D145159, AGR @D145158, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : START, 
   [COORD @D145161, AGR @D145160, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : START, 
   [COORD @D145163, AGR @D145162, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : START, 
   [COORD @D145165, AGR @D145164, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : START, 
   [COORD @D145167, AGR @D145166, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : START, 
   [COORD @D145172, AGR [CASE @D145171, COUNT @D145170, PER @D145169, 
            PLU @D145168, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145177, AGR [CASE @D145176, COUNT @D145175, PER @D145174, 
            PLU @D145173, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145182, AGR [CASE @D145181, COUNT @D145180, PER @D145179, 
            PLU @D145178, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145187, AGR [CASE @D145186, COUNT @D145185, PER @D145184, 
            PLU @D145183, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145189, AGR @D145188, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145191, AGR @D145190, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145193, AGR @D145192, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145195, AGR @D145194, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145200, AGR [CASE @D145199, COUNT @D145198, PER @D145197, 
            PLU @D145196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145205, AGR [CASE @D145204, COUNT @D145203, PER @D145202, 
            PLU @D145201, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145207, AGR @D145206, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145209, AGR @D145208, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145211, AGR @D145210, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145213, AGR @D145212, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145218, AGR [CASE @D145217, COUNT @D145216, PER @D145215, 
            PLU @D145214, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145223, AGR [CASE @D145222, COUNT @D145221, PER @D145220, 
            PLU @D145219, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START, 
   [COORD @D145228, AGR [CASE @D145227, COUNT @D145226, PER @D145225, 
            PLU @D145224, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145233, AGR [CASE @D145232, COUNT @D145231, PER @D145230, 
            PLU @D145229, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : START.

WORD starting : 
   [COORD @D145248, PRD @D145247, AGR [CASE @D145246, COUNT @D145245, 
            PER @D145244, PLU @D145243, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145254, PRD @D145253, 
      AGR [CASE @D145252, COUNT @D145251, PER @D145250, PLU @D145249, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   START, 
   [COORD @D145260, PRD @D145259, AGR [CASE @D145258, COUNT @D145257, 
            PER @D145256, PLU @D145255, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145266, PRD @D145265, 
      AGR [CASE @D145264, COUNT @D145263, PER @D145262, PLU @D145261, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : START, 
   [COORD @D145272, PRD @D145271, AGR [CASE @D145270, COUNT @D145269, 
            PER @D145268, PLU @D145267, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145278, PRD @D145277, 
      AGR [CASE @D145276, COUNT @D145275, PER @D145274, PLU @D145273, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145284, PRD @D145283, AGR [CASE @D145282, COUNT @D145281, 
            PER @D145280, PLU @D145279, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145290, PRD @D145289, 
      AGR [CASE @D145288, COUNT @D145287, PER @D145286, PLU @D145285, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145296, PRD @D145295, AGR [CASE @D145294, COUNT @D145293, 
            PER @D145292, PLU @D145291, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145302, PRD @D145301, 
      AGR [CASE @D145300, COUNT @D145299, PER @D145298, PLU @D145297, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145308, PRD @D145307, AGR [CASE @D145306, COUNT @D145305, 
            PER @D145304, PLU @D145303, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145314, PRD @D145313, 
      AGR [CASE @D145312, COUNT @D145311, PER @D145310, PLU @D145309, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : START, 
   [COORD @D145320, PRD @D145319, AGR [CASE @D145318, COUNT @D145317, 
            PER @D145316, PLU @D145315, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145323, AGR @D145322, PRD @D145321, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : START, 
   [COORD @D145326, AGR @D145325, PRD @D145324, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : START, 
   [COORD @D145329, AGR @D145328, PRD @D145327, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : START, 
   [COORD @D145335, PRD @D145334, AGR [CASE @D145333, COUNT @D145332, 
            PER @D145331, PLU @D145330, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145341, PRD @D145340, 
      AGR [CASE @D145339, COUNT @D145338, PER @D145337, PLU @D145336, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145344, AGR @D145343, PRD @D145342, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145347, AGR @D145346, PRD @D145345, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_AP, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145353, PRD @D145352, AGR [CASE @D145351, COUNT @D145350, 
            PER @D145349, PLU @D145348, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145356, AGR @D145355, PRD @D145354, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145359, AGR @D145358, PRD @D145357, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_AP, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START, 
   [COORD @D145365, PRD @D145364, AGR [CASE @D145363, COUNT @D145362, 
            PER @D145361, PLU @D145360, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : START, 
   [COORD @D145371, PRD @D145370, 
      AGR [CASE @D145369, COUNT @D145368, PER @D145367, PLU @D145366, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : START.

WORD starts : 
   [COORD @D145381, DEMON @D145380, REFL @D145379, PRD @D145378, 
      CASE @D145377, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   START, 
   [COORD @D145386, DEMON @D145385, REFL @D145384, PRD @D145383, 
      CASE @D145382, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   START, 
   [COORD @D145391, DEMON @D145390, REFL @D145389, PRD @D145388, 
      CASE @D145387, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OVER, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   START, 
   [COORD @D145396, DEMON @D145395, REFL @D145394, PRD @D145393, 
      CASE @D145392, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   START, 
   [COORD @D145398, AGR [COUNT @D145397, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145400, AGR [COUNT @D145399, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   START, 
   [COORD @D145402, AGR [COUNT @D145401, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : START, 
   [COORD @D145404, 
      AGR [COUNT @D145403, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : START, 
   [COORD @D145406, 
      AGR [COUNT @D145405, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : START, 
   [COORD @D145408, 
      AGR [COUNT @D145407, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : START, 
   [COORD @D145410, 
      AGR [COUNT @D145409, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   START, 
   [COORD @D145412, AGR [COUNT @D145411, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145414, AGR [COUNT @D145413, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145416, AGR [COUNT @D145415, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   START, 
   [COORD @D145418, AGR [COUNT @D145417, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145420, AGR [COUNT @D145419, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145422, AGR [COUNT @D145421, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145426, AGR [CASE @D145425, NFORM @D145424, COUNT @D145423, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_ING, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145431, AGR [UB @D145430, VFORM @D145429, SUBJ @D145428, 
            FIN @D145427, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_ING, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145435, AGR [CASE @D145434, NFORM @D145433, COUNT @D145432, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145440, AGR [UB @D145439, VFORM @D145438, SUBJ @D145437, 
            FIN @D145436, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145444, AGR [CASE @D145443, NFORM @D145442, COUNT @D145441, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145449, AGR [UB @D145448, VFORM @D145447, SUBJ @D145446, 
            FIN @D145445, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145451, AGR [COUNT @D145450, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : START, 
   [COORD @D145453, 
      AGR [COUNT @D145452, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : START, 
   [COORD @D145457, 
      AGR [CASE @D145456, NFORM @D145455, COUNT @D145454, PLU -, PER 3, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145462, AGR [UB @D145461, VFORM @D145460, SUBJ @D145459, 
            FIN @D145458, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : START, 
   [COORD @D145466, AGR [CASE @D145465, NFORM @D145464, COUNT @D145463, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : START, 
   [COORD @D145471, AGR [UB @D145470, VFORM @D145469, SUBJ @D145468, 
            FIN @D145467, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : START, 
   [COORD @D145473, AGR [COUNT @D145472, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145477, AGR [CASE @D145476, NFORM @D145475, COUNT @D145474, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : START, 
   [COORD @D145482, AGR [UB @D145481, VFORM @D145480, SUBJ @D145479, 
            FIN @D145478, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : START, 
   [COORD @D145486, AGR [CASE @D145485, NFORM @D145484, COUNT @D145483, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : START, 
   [COORD @D145491, AGR [UB @D145490, VFORM @D145489, SUBJ @D145488, 
            FIN @D145487, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : START, 
   [COORD @D145493, AGR [COUNT @D145492, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : START, 
   [COORD @D145495, AGR [COUNT @D145494, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   START.

WORD state : 
   [COORD @D145507, REFL @D145506, COUNT @D145505, PRD @D145504, 
      CASE @D145503, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : STATE, 
   [COORD @D145511, REFL @D145510, PRD @D145509, CASE @D145508, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STATE, 
   [COORD @D145514, 
      AGR [COUNT @D145513, PER @D145512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, ARITY 2] : 
   STATE, 
   [COORD @D145516, AGR [COUNT @D145515, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : STATE, 
   [COORD @D145518, AGR [COUNT @D145517, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : STATE, 
   [COORD @D145522, AGR [COUNT @D145521, PER @D145520, PLU @D145519, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : STATE, 
   [COORD @D145528, PAST @D145527, AGR [CASE @D145526, COUNT @D145525, 
            PER @D145524, PLU @D145523, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : STATE, 
   [COORD @D145531, AGR [COUNT @D145530, PER @D145529, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : STATE, 
   [COORD @D145533, AGR [COUNT @D145532, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : STATE, 
   [COORD @D145535, AGR [COUNT @D145534, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : STATE, 
   [COORD @D145539, AGR [COUNT @D145538, PER @D145537, PLU @D145536, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : STATE, 
   [COORD @D145545, PAST @D145544, AGR [CASE @D145543, COUNT @D145542, 
            PER @D145541, PLU @D145540, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : STATE, 
   [COORD @D145548, AGR [COUNT @D145547, PER @D145546, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : STATE, 
   [COORD @D145550, AGR [COUNT @D145549, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : STATE, 
   [COORD @D145552, AGR [COUNT @D145551, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : STATE, 
   [COORD @D145556, AGR [COUNT @D145555, PER @D145554, PLU @D145553, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : STATE, 
   [COORD @D145562, PAST @D145561, AGR [CASE @D145560, COUNT @D145559, 
            PER @D145558, PLU @D145557, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : STATE, 
   [COORD @D145565, AGR [COUNT @D145564, PER @D145563, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STATE, 
   [COORD @D145567, AGR [COUNT @D145566, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STATE, 
   [COORD @D145569, AGR [COUNT @D145568, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STATE, 
   [COORD @D145573, AGR [COUNT @D145572, PER @D145571, PLU @D145570, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STATE, 
   [COORD @D145579, PAST @D145578, AGR [CASE @D145577, COUNT @D145576, 
            PER @D145575, PLU @D145574, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STATE.

WORD stated : 
   [COORD @D145591, AGR [CASE @D145590, COUNT @D145589, PER @D145588, 
            PLU @D145587, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STATE, 
   [COORD @D145596, AGR [CASE @D145595, COUNT @D145594, PER @D145593, 
            PLU @D145592, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STATE, 
   [COORD @D145601, AGR [CASE @D145600, COUNT @D145599, PER @D145598, 
            PLU @D145597, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STATE, 
   [COORD @D145606, AGR [CASE @D145605, COUNT @D145604, PER @D145603, 
            PLU @D145602, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STATE, 
   [COORD @D145611, AGR [CASE @D145610, COUNT @D145609, PER @D145608, 
            PLU @D145607, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STATE, 
   [COORD @D145616, AGR [CASE @D145615, COUNT @D145614, PER @D145613, 
            PLU @D145612, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STATE, 
   [COORD @D145621, AGR [UB @D145620, VFORM @D145619, SUBJ @D145618, 
            FIN @D145617, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STATE, 
   [COORD @D145626, AGR [CASE @D145625, COUNT @D145624, PER @D145623, 
            PLU @D145622, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STATE, 
   [COORD @D145631, AGR [CASE @D145630, COUNT @D145629, PER @D145628, 
            PLU @D145627, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STATE, 
   [COORD @D145636, AGR [CASE @D145635, COUNT @D145634, PER @D145633, 
            PLU @D145632, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STATE.

WORD states : 
   [COORD @D145650, DEMON @D145649, REFL @D145648, PRD @D145647, 
      CASE @D145646, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STATE, 
   [COORD @D145655, DEMON @D145654, REFL @D145653, PRD @D145652, 
      CASE @D145651, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STATE, 
   [COORD @D145657, AGR [COUNT @D145656, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STATE, 
   [COORD @D145659, 
      AGR [COUNT @D145658, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STATE, 
   [COORD @D145661, 
      AGR [COUNT @D145660, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STATE, 
   [COORD @D145663, 
      AGR [COUNT @D145662, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STATE.

WORD stating : 
   [COORD @D145676, PRD @D145675, AGR [CASE @D145674, COUNT @D145673, 
            PER @D145672, PLU @D145671, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STATE, 
   [COORD @D145682, PRD @D145681, 
      AGR [CASE @D145680, COUNT @D145679, PER @D145678, PLU @D145677, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STATE, 
   [COORD @D145688, PRD @D145687, AGR [CASE @D145686, COUNT @D145685, 
            PER @D145684, PLU @D145683, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STATE, 
   [COORD @D145694, PRD @D145693, 
      AGR [CASE @D145692, COUNT @D145691, PER @D145690, PLU @D145689, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STATE.

WORD station : 
   [COORD @D145704, REFL @D145703, COUNT @D145702, PRD @D145701, 
      CASE @D145700, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : STATION, 
   [COORD @D145707, 
      AGR [COUNT @D145706, PER @D145705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   STATION, 
   [COORD @D145709, AGR [COUNT @D145708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : STATION, 
   [COORD @D145711, AGR [COUNT @D145710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : STATION, 
   [COORD @D145715, AGR [COUNT @D145714, PER @D145713, PLU @D145712, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : STATION, 
   [COORD @D145721, PAST @D145720, 
      AGR [CASE @D145719, COUNT @D145718, PER @D145717, PLU @D145716, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      ARITY 3] : STATION.

WORD stationed : 
   [COORD @D145733, AGR [CASE @D145732, COUNT @D145731, PER @D145730, 
            PLU @D145729, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STATION, 
   [COORD @D145738, AGR [CASE @D145737, COUNT @D145736, PER @D145735, 
            PLU @D145734, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STATION, 
   [COORD @D145743, AGR [CASE @D145742, COUNT @D145741, PER @D145740, 
            PLU @D145739, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STATION.

WORD stationing : 
   [COORD @D145760, PRD @D145759, AGR [CASE @D145758, COUNT @D145757, 
            PER @D145756, PLU @D145755, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STATION.

WORD stations : 
   [COORD @D145772, DEMON @D145771, REFL @D145770, PRD @D145769, 
      CASE @D145768, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STATION, 
   [COORD @D145774, AGR [COUNT @D145773, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STATION.

WORD stay : 
   [COORD @D145782, REFL @D145781, COUNT @D145780, PRD @D145779, 
      CASE @D145778, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : STAY, 
   [COORD @D145785, 
      AGR [COUNT @D145784, PER @D145783, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP, 
      ARITY 2] : STAY, 
   [COORD @D145787, AGR [COUNT @D145786, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : STAY, 
   [COORD @D145789, AGR [COUNT @D145788, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : STAY, 
   [COORD @D145793, AGR [COUNT @D145792, PER @D145791, PLU @D145790, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : STAY, 
   [COORD @D145799, PAST @D145798, AGR [CASE @D145797, COUNT @D145796, 
            PER @D145795, PLU @D145794, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : STAY, 
   [COORD @D145802, AGR [COUNT @D145801, PER @D145800, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : STAY, 
   [COORD @D145804, AGR [COUNT @D145803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : STAY, 
   [COORD @D145806, AGR [COUNT @D145805, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : STAY, 
   [COORD @D145810, AGR [COUNT @D145809, PER @D145808, PLU @D145807, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : STAY, 
   [COORD @D145816, PAST @D145815, AGR [CASE @D145814, COUNT @D145813, 
            PER @D145812, PLU @D145811, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : STAY, 
   [COORD @D145819, AGR [COUNT @D145818, PER @D145817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STAY, 
   [COORD @D145821, AGR [COUNT @D145820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STAY, 
   [COORD @D145823, AGR [COUNT @D145822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STAY, 
   [COORD @D145827, AGR [COUNT @D145826, PER @D145825, PLU @D145824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STAY, 
   [COORD @D145833, PAST @D145832, AGR [CASE @D145831, COUNT @D145830, 
            PER @D145829, PLU @D145828, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STAY, 
   [COORD @D145836, AGR [COUNT @D145835, PER @D145834, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STAY, 
   [COORD @D145838, AGR [COUNT @D145837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STAY, 
   [COORD @D145840, AGR [COUNT @D145839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STAY, 
   [COORD @D145844, AGR [COUNT @D145843, PER @D145842, PLU @D145841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : STAY, 
   [COORD @D145850, PAST @D145849, AGR [CASE @D145848, COUNT @D145847, 
            PER @D145846, PLU @D145845, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : STAY, 
   [COORD @D145853, AGR [COUNT @D145852, PER @D145851, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STAY, 
   [COORD @D145855, AGR [COUNT @D145854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STAY, 
   [COORD @D145857, AGR [COUNT @D145856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STAY, 
   [COORD @D145861, AGR [COUNT @D145860, PER @D145859, PLU @D145858, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STAY, 
   [COORD @D145867, PAST @D145866, AGR [CASE @D145865, COUNT @D145864, 
            PER @D145863, PLU @D145862, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : STAY, 
   [COORD @D145870, AGR [COUNT @D145869, PER @D145868, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : STAY, 
   [COORD @D145872, AGR [COUNT @D145871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : STAY, 
   [COORD @D145874, AGR [COUNT @D145873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : STAY, 
   [COORD @D145878, AGR [COUNT @D145877, PER @D145876, PLU @D145875, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : STAY, 
   [COORD @D145884, PAST @D145883, 
      AGR [CASE @D145882, COUNT @D145881, PER @D145880, PLU @D145879, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : STAY.

WORD stayed : 
   [COORD @D145894, AGR [CASE @D145893, COUNT @D145892, PER @D145891, 
            PLU @D145890, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145899, AGR [CASE @D145898, COUNT @D145897, PER @D145896, 
            PLU @D145895, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STAY, 
   [COORD @D145904, AGR [CASE @D145903, COUNT @D145902, PER @D145901, 
            PLU @D145900, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145909, AGR [CASE @D145908, COUNT @D145907, PER @D145906, 
            PLU @D145905, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STAY, 
   [COORD @D145914, AGR [CASE @D145913, COUNT @D145912, PER @D145911, 
            PLU @D145910, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145919, AGR [CASE @D145918, COUNT @D145917, PER @D145916, 
            PLU @D145915, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STAY, 
   [COORD @D145924, AGR [CASE @D145923, COUNT @D145922, PER @D145921, 
            PLU @D145920, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAY, 
   [COORD @D145929, AGR [CASE @D145928, COUNT @D145927, PER @D145926, 
            PLU @D145925, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145934, AGR [CASE @D145933, COUNT @D145932, PER @D145931, 
            PLU @D145930, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STAY, 
   [COORD @D145939, AGR [CASE @D145938, COUNT @D145937, PER @D145936, 
            PLU @D145935, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145944, AGR [CASE @D145943, COUNT @D145942, PER @D145941, 
            PLU @D145940, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STAY, 
   [COORD @D145949, AGR [CASE @D145948, COUNT @D145947, PER @D145946, 
            PLU @D145945, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145954, AGR [CASE @D145953, COUNT @D145952, PER @D145951, 
            PLU @D145950, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STAY.

WORD staying : 
   [COORD @D145969, PRD @D145968, AGR [CASE @D145967, COUNT @D145966, 
            PER @D145965, PLU @D145964, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145975, PRD @D145974, 
      AGR [CASE @D145973, COUNT @D145972, PER @D145971, PLU @D145970, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAY, 
   [COORD @D145981, PRD @D145980, AGR [CASE @D145979, COUNT @D145978, 
            PER @D145977, PLU @D145976, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145987, PRD @D145986, 
      AGR [CASE @D145985, COUNT @D145984, PER @D145983, PLU @D145982, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STAY, 
   [COORD @D145993, PRD @D145992, AGR [CASE @D145991, COUNT @D145990, 
            PER @D145989, PLU @D145988, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STAY, 
   [COORD @D145999, PRD @D145998, 
      AGR [CASE @D145997, COUNT @D145996, PER @D145995, PLU @D145994, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STAY.

WORD stays : 
   [COORD @D146008, REFL @D146007, PRD @D146006, CASE @D146005, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : STAYS, 
   [COORD @D146013, DEMON @D146012, REFL @D146011, PRD @D146010, 
      CASE @D146009, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STAY, 
   [COORD @D146015, AGR [COUNT @D146014, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAY, 
   [COORD @D146017, 
      AGR [COUNT @D146016, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAY, 
   [COORD @D146019, 
      AGR [COUNT @D146018, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAY, 
   [COORD @D146021, 
      AGR [COUNT @D146020, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAY, 
   [COORD @D146023, 
      AGR [COUNT @D146022, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAY, 
   [COORD @D146025, 
      AGR [COUNT @D146024, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STAY.

WORD steam : 
   [COORD @D146042, REFL @D146041, PRD @D146040, CASE @D146039, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PREMOD +, COUNT +] : STEAM, 
   [COORD @D146047, REFL @D146046, COUNT @D146045, PRD @D146044, 
      CASE @D146043, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : STEAM, 
   [COORD @D146050, 
      AGR [COUNT @D146049, PER @D146048, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   STEAM, 
   [COORD @D146052, AGR [COUNT @D146051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STEAM, 
   [COORD @D146054, AGR [COUNT @D146053, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STEAM, 
   [COORD @D146058, AGR [COUNT @D146057, PER @D146056, PLU @D146055, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STEAM, 
   [COORD @D146064, PAST @D146063, AGR [CASE @D146062, COUNT @D146061, 
            PER @D146060, PLU @D146059, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STEAM, 
   [COORD @D146067, AGR [COUNT @D146066, PER @D146065, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STEAM, 
   [COORD @D146069, AGR [COUNT @D146068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STEAM, 
   [COORD @D146071, AGR [COUNT @D146070, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STEAM, 
   [COORD @D146075, AGR [COUNT @D146074, PER @D146073, PLU @D146072, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : STEAM, 
   [COORD @D146081, PAST @D146080, AGR [CASE @D146079, COUNT @D146078, 
            PER @D146077, PLU @D146076, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : STEAM, 
   [COORD @D146084, AGR [COUNT @D146083, PER @D146082, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STEAM, 
   [COORD @D146086, AGR [COUNT @D146085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STEAM, 
   [COORD @D146088, AGR [COUNT @D146087, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STEAM, 
   [COORD @D146092, AGR [COUNT @D146091, PER @D146090, PLU @D146089, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : STEAM, 
   [COORD @D146098, PAST @D146097, 
      AGR [CASE @D146096, COUNT @D146095, PER @D146094, PLU @D146093, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : STEAM, 
   [COORD @D146101, AGR [COUNT @D146100, PER @D146099, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEAM, 
   [COORD @D146103, AGR [COUNT @D146102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEAM, 
   [COORD @D146105, AGR [COUNT @D146104, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEAM, 
   [COORD @D146109, AGR [COUNT @D146108, PER @D146107, PLU @D146106, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEAM, 
   [COORD @D146115, PAST @D146114, AGR [CASE @D146113, COUNT @D146112, 
            PER @D146111, PLU @D146110, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : STEAM, 
   [COORD @D146118, AGR [COUNT @D146117, PER @D146116, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEAM, 
   [COORD @D146120, AGR [COUNT @D146119, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEAM, 
   [COORD @D146122, AGR [COUNT @D146121, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEAM, 
   [COORD @D146126, AGR [COUNT @D146125, PER @D146124, PLU @D146123, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEAM, 
   [COORD @D146132, PAST @D146131, 
      AGR [CASE @D146130, COUNT @D146129, PER @D146128, PLU @D146127, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : STEAM.

WORD steamed : 
   [COORD @D146142, AGR [CASE @D146141, COUNT @D146140, PER @D146139, 
            PLU @D146138, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STEAM, 
   [COORD @D146147, AGR [CASE @D146146, COUNT @D146145, PER @D146144, 
            PLU @D146143, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146152, AGR [CASE @D146151, COUNT @D146150, PER @D146149, 
            PLU @D146148, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146157, AGR [CASE @D146156, COUNT @D146155, PER @D146154, 
            PLU @D146153, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146162, AGR [CASE @D146161, COUNT @D146160, PER @D146159, 
            PLU @D146158, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146167, AGR [CASE @D146166, COUNT @D146165, PER @D146164, 
            PLU @D146163, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146172, AGR [CASE @D146171, COUNT @D146170, PER @D146169, 
            PLU @D146168, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146177, AGR [CASE @D146176, COUNT @D146175, PER @D146174, 
            PLU @D146173, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146182, AGR [CASE @D146181, COUNT @D146180, PER @D146179, 
            PLU @D146178, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146187, AGR [CASE @D146186, COUNT @D146185, PER @D146184, 
            PLU @D146183, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146192, AGR [CASE @D146191, COUNT @D146190, PER @D146189, 
            PLU @D146188, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146197, AGR [CASE @D146196, COUNT @D146195, PER @D146194, 
            PLU @D146193, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEAM.

WORD steaming : 
   [COORD @D146212, PRD @D146211, AGR [CASE @D146210, COUNT @D146209, 
            PER @D146208, PLU @D146207, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146218, PRD @D146217, 
      AGR [CASE @D146216, COUNT @D146215, PER @D146214, PLU @D146213, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STEAM, 
   [COORD @D146224, PRD @D146223, AGR [CASE @D146222, COUNT @D146221, 
            PER @D146220, PLU @D146219, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STEAM, 
   [COORD @D146230, PRD @D146229, 
      AGR [CASE @D146228, COUNT @D146227, PER @D146226, PLU @D146225, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STEAM, 
   [COORD @D146236, PRD @D146235, AGR [CASE @D146234, COUNT @D146233, 
            PER @D146232, PLU @D146231, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STEAM.

WORD steams : 
   [COORD @D146246, DEMON @D146245, REFL @D146244, PRD @D146243, 
      CASE @D146242, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STEAM, 
   [COORD @D146251, DEMON @D146250, REFL @D146249, PRD @D146248, 
      CASE @D146247, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STEAM, 
   [COORD @D146253, AGR [COUNT @D146252, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEAM, 
   [COORD @D146255, 
      AGR [COUNT @D146254, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEAM, 
   [COORD @D146257, 
      AGR [COUNT @D146256, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEAM, 
   [COORD @D146259, 
      AGR [COUNT @D146258, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEAM, 
   [COORD @D146261, 
      AGR [COUNT @D146260, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEAM.

WORD stem : 
   [COORD @D146268, REFL @D146267, PRD @D146266, CASE @D146265, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STEM, 
   [COORD @D146271, 
      AGR [COUNT @D146270, PER @D146269, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   STEM, 
   [COORD @D146273, AGR [COUNT @D146272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STEM, 
   [COORD @D146275, AGR [COUNT @D146274, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STEM, 
   [COORD @D146279, AGR [COUNT @D146278, PER @D146277, PLU @D146276, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STEM, 
   [COORD @D146285, PAST @D146284, AGR [CASE @D146283, COUNT @D146282, 
            PER @D146281, PLU @D146280, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STEM, 
   [COORD @D146288, AGR [COUNT @D146287, PER @D146286, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : STEM, 
   [COORD @D146290, AGR [COUNT @D146289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : STEM, 
   [COORD @D146292, AGR [COUNT @D146291, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : STEM, 
   [COORD @D146296, AGR [COUNT @D146295, PER @D146294, PLU @D146293, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : STEM, 
   [COORD @D146302, PAST @D146301, 
      AGR [CASE @D146300, COUNT @D146299, PER @D146298, PLU @D146297, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : STEM.

WORD stemmed : 
   [COORD @D146318, AGR [CASE @D146317, COUNT @D146316, PER @D146315, 
            PLU @D146314, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEM, 
   [COORD @D146323, AGR [CASE @D146322, COUNT @D146321, PER @D146320, 
            PLU @D146319, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STEM, 
   [COORD @D146328, AGR [CASE @D146327, COUNT @D146326, PER @D146325, 
            PLU @D146324, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STEM, 
   [COORD @D146333, AGR [CASE @D146332, COUNT @D146331, PER @D146330, 
            PLU @D146329, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEM, 
   [COORD @D146338, AGR [CASE @D146337, COUNT @D146336, PER @D146335, 
            PLU @D146334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEM, 
   [COORD @D146343, AGR [CASE @D146342, COUNT @D146341, PER @D146340, 
            PLU @D146339, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEM.

WORD stemming : 
   [COORD @D146362, PRD @D146361, AGR [CASE @D146360, COUNT @D146359, 
            PER @D146358, PLU @D146357, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEM, 
   [COORD @D146368, PRD @D146367, 
      AGR [CASE @D146366, COUNT @D146365, PER @D146364, PLU @D146363, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STEM.

WORD stems : 
   [COORD @D146378, DEMON @D146377, REFL @D146376, PRD @D146375, 
      CASE @D146374, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STEM, 
   [COORD @D146380, AGR [COUNT @D146379, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEM, 
   [COORD @D146382, 
      AGR [COUNT @D146381, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEM.

WORD step : 
   [COORD @D146389, REFL @D146388, PRD @D146387, CASE @D146386, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STEP, 
   [COORD @D146392, 
      AGR [COUNT @D146391, PER @D146390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   STEP, 
   [COORD @D146394, AGR [COUNT @D146393, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STEP, 
   [COORD @D146396, AGR [COUNT @D146395, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STEP, 
   [COORD @D146400, AGR [COUNT @D146399, PER @D146398, PLU @D146397, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STEP, 
   [COORD @D146406, PAST @D146405, AGR [CASE @D146404, COUNT @D146403, 
            PER @D146402, PLU @D146401, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STEP, 
   [COORD @D146409, AGR [COUNT @D146408, PER @D146407, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STEP, 
   [COORD @D146411, AGR [COUNT @D146410, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STEP, 
   [COORD @D146413, AGR [COUNT @D146412, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STEP, 
   [COORD @D146417, AGR [COUNT @D146416, PER @D146415, PLU @D146414, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : STEP, 
   [COORD @D146423, PAST @D146422, AGR [CASE @D146421, COUNT @D146420, 
            PER @D146419, PLU @D146418, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : STEP, 
   [COORD @D146426, AGR [COUNT @D146425, PER @D146424, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : STEP, 
   [COORD @D146428, AGR [COUNT @D146427, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : STEP, 
   [COORD @D146430, AGR [COUNT @D146429, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : STEP, 
   [COORD @D146434, AGR [COUNT @D146433, PER @D146432, PLU @D146431, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : STEP, 
   [COORD @D146440, PAST @D146439, 
      AGR [CASE @D146438, COUNT @D146437, PER @D146436, PLU @D146435, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : STEP, 
   [COORD @D146443, AGR [COUNT @D146442, PER @D146441, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STEP, 
   [COORD @D146445, AGR [COUNT @D146444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STEP, 
   [COORD @D146447, AGR [COUNT @D146446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STEP, 
   [COORD @D146451, AGR [COUNT @D146450, PER @D146449, PLU @D146448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : STEP, 
   [COORD @D146457, PAST @D146456, 
      AGR [CASE @D146455, COUNT @D146454, PER @D146453, PLU @D146452, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : STEP, 
   [COORD @D146460, AGR [COUNT @D146459, PER @D146458, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEP, 
   [COORD @D146462, AGR [COUNT @D146461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEP, 
   [COORD @D146464, AGR [COUNT @D146463, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEP, 
   [COORD @D146468, AGR [COUNT @D146467, PER @D146466, PLU @D146465, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STEP, 
   [COORD @D146474, PAST @D146473, AGR [CASE @D146472, COUNT @D146471, 
            PER @D146470, PLU @D146469, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : STEP, 
   [COORD @D146477, AGR [COUNT @D146476, PER @D146475, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEP, 
   [COORD @D146479, AGR [COUNT @D146478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEP, 
   [COORD @D146481, AGR [COUNT @D146480, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEP, 
   [COORD @D146485, AGR [COUNT @D146484, PER @D146483, PLU @D146482, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STEP, 
   [COORD @D146491, PAST @D146490, 
      AGR [CASE @D146489, COUNT @D146488, PER @D146487, PLU @D146486, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : STEP, 
   [COORD @D146494, AGR [COUNT @D146493, PER @D146492, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STEP, 
   [COORD @D146496, AGR [COUNT @D146495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STEP, 
   [COORD @D146498, AGR [COUNT @D146497, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STEP, 
   [COORD @D146502, AGR [COUNT @D146501, PER @D146500, PLU @D146499, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STEP, 
   [COORD @D146508, PAST @D146507, 
      AGR [CASE @D146506, COUNT @D146505, PER @D146504, PLU @D146503, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : STEP, 
   [COORD @D146511, AGR [COUNT @D146510, PER @D146509, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : STEP, 
   [COORD @D146513, AGR [COUNT @D146512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : STEP, 
   [COORD @D146515, AGR [COUNT @D146514, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : STEP, 
   [COORD @D146519, AGR [COUNT @D146518, PER @D146517, PLU @D146516, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : STEP, 
   [COORD @D146525, PAST @D146524, 
      AGR [CASE @D146523, COUNT @D146522, PER @D146521, PLU @D146520, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : STEP, 
   [COORD @D146528, AGR [COUNT @D146527, PER @D146526, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : STEP, 
   [COORD @D146530, AGR [COUNT @D146529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : STEP, 
   [COORD @D146532, AGR [COUNT @D146531, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : STEP, 
   [COORD @D146536, AGR [COUNT @D146535, PER @D146534, PLU @D146533, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : STEP, 
   [COORD @D146542, PAST @D146541, 
      AGR [CASE @D146540, COUNT @D146539, PER @D146538, PLU @D146537, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : STEP, 
   [COORD @D146545, AGR [COUNT @D146544, PER @D146543, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ASIDE, ARITY 1] : STEP, 
   [COORD @D146547, AGR [COUNT @D146546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ASIDE, ARITY 1] : STEP, 
   [COORD @D146549, AGR [COUNT @D146548, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ASIDE, ARITY 1] : STEP, 
   [COORD @D146553, AGR [COUNT @D146552, PER @D146551, PLU @D146550, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ASIDE, ARITY 1] : STEP, 
   [COORD @D146559, PAST @D146558, 
      AGR [CASE @D146557, COUNT @D146556, PER @D146555, PLU @D146554, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ASIDE, ARITY 1] : STEP.

WORD stepped : 
   [COORD @D146569, AGR [CASE @D146568, COUNT @D146567, PER @D146566, 
            PLU @D146565, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STEP, 
   [COORD @D146574, AGR [CASE @D146573, COUNT @D146572, PER @D146571, 
            PLU @D146570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146579, AGR [CASE @D146578, COUNT @D146577, PER @D146576, 
            PLU @D146575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146584, AGR [CASE @D146583, COUNT @D146582, PER @D146581, 
            PLU @D146580, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146589, AGR [CASE @D146588, COUNT @D146587, PER @D146586, 
            PLU @D146585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146594, AGR [CASE @D146593, COUNT @D146592, PER @D146591, 
            PLU @D146590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146599, AGR [CASE @D146598, COUNT @D146597, PER @D146596, 
            PLU @D146595, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146604, AGR [CASE @D146603, COUNT @D146602, PER @D146601, 
            PLU @D146600, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146609, AGR [CASE @D146608, COUNT @D146607, PER @D146606, 
            PLU @D146605, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146614, AGR [CASE @D146613, COUNT @D146612, PER @D146611, 
            PLU @D146610, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146619, AGR [CASE @D146618, COUNT @D146617, PER @D146616, 
            PLU @D146615, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146624, AGR [CASE @D146623, COUNT @D146622, PER @D146621, 
            PLU @D146620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146629, AGR [CASE @D146628, COUNT @D146627, PER @D146626, 
            PLU @D146625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146634, AGR [CASE @D146633, COUNT @D146632, PER @D146631, 
            PLU @D146630, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146639, AGR [CASE @D146638, COUNT @D146637, PER @D146636, 
            PLU @D146635, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146644, AGR [CASE @D146643, COUNT @D146642, PER @D146641, 
            PLU @D146640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146649, AGR [CASE @D146648, COUNT @D146647, PER @D146646, 
            PLU @D146645, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146654, AGR [CASE @D146653, COUNT @D146652, PER @D146651, 
            PLU @D146650, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146659, AGR [CASE @D146658, COUNT @D146657, PER @D146656, 
            PLU @D146655, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146664, AGR [CASE @D146663, COUNT @D146662, PER @D146661, 
            PLU @D146660, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEP, 
   [COORD @D146669, AGR [CASE @D146668, COUNT @D146667, PER @D146666, 
            PLU @D146665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ASIDE, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146674, AGR [CASE @D146673, COUNT @D146672, PER @D146671, 
            PLU @D146670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ASIDE, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STEP.

WORD stepping : 
   [COORD @D146685, PRD @D146684, AGR [CASE @D146683, COUNT @D146682, 
            PER @D146681, PLU @D146680, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146691, PRD @D146690, 
      AGR [CASE @D146689, COUNT @D146688, PER @D146687, PLU @D146686, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STEP, 
   [COORD @D146697, PRD @D146696, AGR [CASE @D146695, COUNT @D146694, 
            PER @D146693, PLU @D146692, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146703, PRD @D146702, 
      AGR [CASE @D146701, COUNT @D146700, PER @D146699, PLU @D146698, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STEP, 
   [COORD @D146709, PRD @D146708, AGR [CASE @D146707, COUNT @D146706, 
            PER @D146705, PLU @D146704, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146715, PRD @D146714, 
      AGR [CASE @D146713, COUNT @D146712, PER @D146711, PLU @D146710, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STEP, 
   [COORD @D146721, PRD @D146720, AGR [CASE @D146719, COUNT @D146718, 
            PER @D146717, PLU @D146716, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146727, PRD @D146726, 
      AGR [CASE @D146725, COUNT @D146724, PER @D146723, PLU @D146722, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STEP, 
   [COORD @D146733, PRD @D146732, AGR [CASE @D146731, COUNT @D146730, 
            PER @D146729, PLU @D146728, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STEP, 
   [COORD @D146739, PRD @D146738, 
      AGR [CASE @D146737, COUNT @D146736, PER @D146735, PLU @D146734, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STEP.

WORD steps : 
   [COORD @D146748, REFL @D146747, PRD @D146746, CASE @D146745, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : STEPS, 
   [COORD @D146753, DEMON @D146752, REFL @D146751, PRD @D146750, 
      CASE @D146749, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STEP, 
   [COORD @D146755, AGR [COUNT @D146754, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146757, 
      AGR [COUNT @D146756, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146759, 
      AGR [COUNT @D146758, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146761, 
      AGR [COUNT @D146760, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146763, 
      AGR [COUNT @D146762, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146765, 
      AGR [COUNT @D146764, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146767, 
      AGR [COUNT @D146766, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146769, 
      AGR [COUNT @D146768, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146771, 
      AGR [COUNT @D146770, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP, 
   [COORD @D146773, 
      AGR [COUNT @D146772, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ASIDE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STEP.

WORD stick : 
   [COORD @D146790, REFL @D146789, PRD @D146788, CASE @D146787, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STICK, 
   [COORD @D146795, REFL @D146794, COUNT @D146793, PRD @D146792, 
      CASE @D146791, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : STICK, 
   [COORD @D146799, REFL @D146798, PRD @D146797, CASE @D146796, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : STICK, 
   [COORD @D146802, 
      AGR [COUNT @D146801, PER @D146800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   STICK, 
   [COORD @D146804, AGR [COUNT @D146803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STICK, 
   [COORD @D146806, AGR [COUNT @D146805, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STICK, 
   [COORD @D146810, AGR [COUNT @D146809, PER @D146808, PLU @D146807, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : STICK, 
   [COORD @D146816, PAST @D146815, 
      AGR [CASE @D146814, COUNT @D146813, PER @D146812, PLU @D146811, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : STICK, 
   [COORD @D146819, AGR [COUNT @D146818, PER @D146817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STICK, 
   [COORD @D146821, AGR [COUNT @D146820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STICK, 
   [COORD @D146823, AGR [COUNT @D146822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STICK, 
   [COORD @D146827, AGR [COUNT @D146826, PER @D146825, PLU @D146824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 2] : STICK, 
   [COORD @D146833, PAST @D146832, 
      AGR [CASE @D146831, COUNT @D146830, PER @D146829, PLU @D146828, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : STICK, 
   [COORD @D146836, AGR [COUNT @D146835, PER @D146834, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STICK, 
   [COORD @D146838, AGR [COUNT @D146837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STICK, 
   [COORD @D146840, AGR [COUNT @D146839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STICK, 
   [COORD @D146844, AGR [COUNT @D146843, PER @D146842, PLU @D146841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : STICK, 
   [COORD @D146850, PAST @D146849, AGR [CASE @D146848, COUNT @D146847, 
            PER @D146846, PLU @D146845, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : STICK, 
   [COORD @D146853, AGR 
         [COUNT @D146852, PER @D146851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : 
   STICK, 
   [COORD @D146855, AGR [COUNT @D146854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : STICK, 
   [COORD @D146857, AGR [COUNT @D146856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      ARITY 2] : STICK, 
   [COORD @D146861, AGR [COUNT @D146860, PER @D146859, PLU @D146858, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, ARITY 2] : STICK, 
   [COORD @D146867, PAST @D146866, AGR [CASE @D146865, COUNT @D146864, 
            PER @D146863, PLU @D146862, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, REG -, ARITY 2] : STICK, 
   [COORD @D146870, 
      AGR [COUNT @D146869, PER @D146868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, 
      ARITY 2] : STICK, 
   [COORD @D146872, AGR [COUNT @D146871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : STICK, 
   [COORD @D146874, AGR [COUNT @D146873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : STICK, 
   [COORD @D146878, AGR [COUNT @D146877, PER @D146876, PLU @D146875, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, ARITY 2] : STICK, 
   [COORD @D146884, PAST @D146883, 
      AGR [CASE @D146882, COUNT @D146881, PER @D146880, PLU @D146879, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM WITH, ARITY 2] : STICK, 
   [COORD @D146887, AGR [COUNT @D146886, PER @D146885, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : STICK, 
   [COORD @D146889, AGR [COUNT @D146888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : STICK, 
   [COORD @D146891, AGR [COUNT @D146890, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : STICK, 
   [COORD @D146895, AGR [COUNT @D146894, PER @D146893, PLU @D146892, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : STICK, 
   [COORD @D146901, PAST @D146900, 
      AGR [CASE @D146899, COUNT @D146898, PER @D146897, PLU @D146896, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : STICK, 
   [COORD @D146904, AGR [COUNT @D146903, PER @D146902, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146906, AGR [COUNT @D146905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146908, AGR [COUNT @D146907, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146912, AGR [COUNT @D146911, PER @D146910, PLU @D146909, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146918, PAST @D146917, 
      AGR [CASE @D146916, COUNT @D146915, PER @D146914, PLU @D146913, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT UP, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146921, AGR [COUNT @D146920, PER @D146919, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146923, AGR [COUNT @D146922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146925, AGR [COUNT @D146924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146929, AGR [COUNT @D146928, PER @D146927, PLU @D146926, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT OUT, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146935, PAST @D146934, 
      AGR [CASE @D146933, COUNT @D146932, PER @D146931, PLU @D146930, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PRT OUT, PFORM FOR, ARITY 2] : STICK, 
   [COORD @D146938, AGR [COUNT @D146937, PER @D146936, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STICK, 
   [COORD @D146940, AGR [COUNT @D146939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STICK, 
   [COORD @D146942, AGR [COUNT @D146941, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STICK, 
   [COORD @D146946, AGR [COUNT @D146945, PER @D146944, PLU @D146943, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BY, ARITY 2] : STICK, 
   [COORD @D146952, PAST @D146951, 
      AGR [CASE @D146950, COUNT @D146949, PER @D146948, PLU @D146947, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM BY, ARITY 2] : STICK, 
   [COORD @D146955, AGR [COUNT @D146954, PER @D146953, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : STICK, 
   [COORD @D146957, AGR [COUNT @D146956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : STICK, 
   [COORD @D146959, AGR [COUNT @D146958, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : STICK, 
   [COORD @D146963, AGR [COUNT @D146962, PER @D146961, PLU @D146960, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : STICK, 
   [COORD @D146969, PAST @D146968, 
      AGR [CASE @D146967, COUNT @D146966, PER @D146965, PLU @D146964, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : STICK, 
   [COORD @D146972, AGR [COUNT @D146971, PER @D146970, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STICK, 
   [COORD @D146974, AGR [COUNT @D146973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STICK, 
   [COORD @D146976, AGR [COUNT @D146975, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STICK, 
   [COORD @D146980, AGR [COUNT @D146979, PER @D146978, PLU @D146977, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : STICK, 
   [COORD @D146986, PAST @D146985, 
      AGR [CASE @D146984, COUNT @D146983, PER @D146982, PLU @D146981, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : STICK, 
   [COORD @D146989, AGR [COUNT @D146988, PER @D146987, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : STICK, 
   [COORD @D146991, AGR [COUNT @D146990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : STICK, 
   [COORD @D146993, AGR [COUNT @D146992, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : STICK, 
   [COORD @D146997, AGR [COUNT @D146996, PER @D146995, PLU @D146994, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : STICK, 
   [COORD @D147003, PAST @D147002, 
      AGR [CASE @D147001, COUNT @D147000, PER @D146999, PLU @D146998, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : STICK, 
   [COORD @D147006, AGR [COUNT @D147005, PER @D147004, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STICK, 
   [COORD @D147008, AGR [COUNT @D147007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STICK, 
   [COORD @D147010, AGR [COUNT @D147009, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STICK, 
   [COORD @D147014, AGR [COUNT @D147013, PER @D147012, PLU @D147011, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : STICK, 
   [COORD @D147020, PAST @D147019, 
      AGR [CASE @D147018, COUNT @D147017, PER @D147016, PLU @D147015, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : STICK, 
   [COORD @D147023, AGR [COUNT @D147022, PER @D147021, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STICK, 
   [COORD @D147025, AGR [COUNT @D147024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STICK, 
   [COORD @D147027, AGR [COUNT @D147026, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STICK, 
   [COORD @D147031, AGR [COUNT @D147030, PER @D147029, PLU @D147028, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : STICK, 
   [COORD @D147037, PAST @D147036, 
      AGR [CASE @D147035, COUNT @D147034, PER @D147033, PLU @D147032, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : STICK, 
   [COORD @D147040, AGR [COUNT @D147039, PER @D147038, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : STICK, 
   [COORD @D147042, AGR [COUNT @D147041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : STICK, 
   [COORD @D147044, AGR [COUNT @D147043, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT TOGETHER, ARITY 1] : STICK, 
   [COORD @D147048, AGR [COUNT @D147047, PER @D147046, PLU @D147045, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT TOGETHER, ARITY 1] : STICK, 
   [COORD @D147054, PAST @D147053, 
      AGR [CASE @D147052, COUNT @D147051, PER @D147050, PLU @D147049, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, ARITY 1] : STICK, 
   [COORD @D147057, AGR [COUNT @D147056, PER @D147055, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STICK, 
   [COORD @D147059, AGR [COUNT @D147058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STICK, 
   [COORD @D147061, AGR [COUNT @D147060, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STICK, 
   [COORD @D147065, AGR [COUNT @D147064, PER @D147063, PLU @D147062, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : STICK, 
   [COORD @D147071, PAST @D147070, 
      AGR [CASE @D147069, COUNT @D147068, PER @D147067, PLU @D147066, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : STICK, 
   [COORD @D147074, AGR [COUNT @D147073, PER @D147072, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : STICK, 
   [COORD @D147076, AGR [COUNT @D147075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : STICK, 
   [COORD @D147078, AGR [COUNT @D147077, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AROUND, ARITY 1] : STICK, 
   [COORD @D147082, AGR [COUNT @D147081, PER @D147080, PLU @D147079, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AROUND, ARITY 1] : STICK, 
   [COORD @D147088, PAST @D147087, 
      AGR [CASE @D147086, COUNT @D147085, PER @D147084, PLU @D147083, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, ARITY 1] : STICK.

WORD sticking : 
   [COORD @D147103, PRD @D147102, AGR [CASE @D147101, COUNT @D147100, 
            PER @D147099, PLU @D147098, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147109, PRD @D147108, 
      AGR [CASE @D147107, COUNT @D147106, PER @D147105, PLU @D147104, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STICK, 
   [COORD @D147115, PRD @D147114, AGR [CASE @D147113, COUNT @D147112, 
            PER @D147111, PLU @D147110, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147121, PRD @D147120, 
      AGR [CASE @D147119, COUNT @D147118, PER @D147117, PLU @D147116, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STICK, 
   [COORD @D147127, PRD @D147126, AGR [CASE @D147125, COUNT @D147124, 
            PER @D147123, PLU @D147122, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147133, PRD @D147132, 
      AGR [CASE @D147131, COUNT @D147130, PER @D147129, PLU @D147128, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STICK, 
   [COORD @D147139, PRD @D147138, AGR [CASE @D147137, COUNT @D147136, 
            PER @D147135, PLU @D147134, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT UP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147145, PRD @D147144, 
      AGR [CASE @D147143, COUNT @D147142, PER @D147141, PLU @D147140, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STICK, 
   [COORD @D147151, PRD @D147150, AGR [CASE @D147149, COUNT @D147148, 
            PER @D147147, PLU @D147146, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147157, PRD @D147156, 
      AGR [CASE @D147155, COUNT @D147154, PER @D147153, PLU @D147152, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STICK, 
   [COORD @D147163, PRD @D147162, AGR [CASE @D147161, COUNT @D147160, 
            PER @D147159, PLU @D147158, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147169, PRD @D147168, 
      AGR [CASE @D147167, COUNT @D147166, PER @D147165, PLU @D147164, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STICK, 
   [COORD @D147175, PRD @D147174, AGR [CASE @D147173, COUNT @D147172, 
            PER @D147171, PLU @D147170, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147181, PRD @D147180, 
      AGR [CASE @D147179, COUNT @D147178, PER @D147177, PLU @D147176, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STICK, 
   [COORD @D147187, PRD @D147186, AGR [CASE @D147185, COUNT @D147184, 
            PER @D147183, PLU @D147182, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STICK, 
   [COORD @D147193, PRD @D147192, 
      AGR [CASE @D147191, COUNT @D147190, PER @D147189, PLU @D147188, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STICK, 
   [COORD @D147199, PRD @D147198, AGR [CASE @D147197, COUNT @D147196, 
            PER @D147195, PLU @D147194, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT AROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STICK.

WORD sticks : 
   [COORD @D147208, REFL @D147207, PRD @D147206, CASE @D147205, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : STICKS, 
   [COORD @D147213, DEMON @D147212, REFL @D147211, PRD @D147210, 
      CASE @D147209, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STICK, 
   [COORD @D147218, DEMON @D147217, REFL @D147216, PRD @D147215, 
      CASE @D147214, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STICK, 
   [COORD @D147223, DEMON @D147222, REFL @D147221, PRD @D147220, 
      CASE @D147219, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STICK, 
   [COORD @D147225, AGR [COUNT @D147224, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STICK, 
   [COORD @D147227, AGR [COUNT @D147226, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STICK, 
   [COORD @D147229, AGR [COUNT @D147228, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STICK, 
   [COORD @D147231, 
      AGR [COUNT @D147230, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STICK, 
   [COORD @D147233, 
      AGR [COUNT @D147232, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STICK, 
   [COORD @D147235, 
      AGR [COUNT @D147234, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STICK, 
   [COORD @D147237, 
      AGR [COUNT @D147236, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STICK, 
   [COORD @D147239, AGR [COUNT @D147238, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : STICK, 
   [COORD @D147241, AGR [COUNT @D147240, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STICK, 
   [COORD @D147243, AGR [COUNT @D147242, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STICK, 
   [COORD @D147245, AGR [COUNT @D147244, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STICK, 
   [COORD @D147247, AGR [COUNT @D147246, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STICK, 
   [COORD @D147249, AGR [COUNT @D147248, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STICK, 
   [COORD @D147251, 
      AGR [COUNT @D147250, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STICK, 
   [COORD @D147253, 
      AGR [COUNT @D147252, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STICK, 
   [COORD @D147255, AGR [COUNT @D147254, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STICK, 
   [COORD @D147257, AGR [COUNT @D147256, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STICK.

WORD stood : 
   [COORD @D147276, PAST @D147275, AGR [CASE @D147274, COUNT @D147273, 
            PER @D147272, PLU @D147271, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : STAND, 
   [COORD @D147282, PAST @D147281, 
      AGR [CASE @D147280, COUNT @D147279, PER @D147278, PLU @D147277, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : STAND, 
   [COORD @D147288, PAST @D147287, AGR [CASE @D147286, COUNT @D147285, 
            PER @D147284, PLU @D147283, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : STAND, 
   [COORD @D147294, PAST @D147293, 
      AGR [CASE @D147292, COUNT @D147291, PER @D147290, PLU @D147289, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : STAND, 
   [COORD @D147300, PAST @D147299, AGR [CASE @D147298, COUNT @D147297, 
            PER @D147296, PLU @D147295, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : STAND, 
   [COORD @D147306, PAST @D147305, 
      AGR [CASE @D147304, COUNT @D147303, PER @D147302, PLU @D147301, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FOR, 
      FIN -, ARITY 3] : STAND, 
   [COORD @D147310, AGR [COUNT @D147309, PER @D147308, PLU @D147307, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : STAND, 
   [COORD @D147314, AGR [COUNT @D147313, PER @D147312, PLU @D147311, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : STAND, 
   [COORD @D147318, AGR [COUNT @D147317, PER @D147316, PLU @D147315, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FOR, PAST +, ARITY 3] : STAND, 
   [COORD @D147324, PAST @D147323, 
      AGR [CASE @D147322, COUNT @D147321, PER @D147320, PLU @D147319, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147330, PAST @D147329, AGR [CASE @D147328, COUNT @D147327, 
            PER @D147326, PLU @D147325, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, FIN -, ARITY 2] : STAND, 
   [COORD @D147336, PAST @D147335, 
      AGR [CASE @D147334, COUNT @D147333, PER @D147332, PLU @D147331, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147342, PAST @D147341, AGR [CASE @D147340, COUNT @D147339, 
            PER @D147338, PLU @D147337, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, REG -, FIN -, ARITY 2] : STAND, 
   [COORD @D147348, PAST @D147347, 
      AGR [CASE @D147346, COUNT @D147345, PER @D147344, PLU @D147343, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147354, PAST @D147353, AGR [CASE @D147352, COUNT @D147351, 
            PER @D147350, PLU @D147349, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : STAND, 
   [COORD @D147360, PAST @D147359, 
      AGR [CASE @D147358, COUNT @D147357, PER @D147356, PLU @D147355, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT MP, REG -, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147366, PAST @D147365, AGR [CASE @D147364, COUNT @D147363, 
            PER @D147362, PLU @D147361, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, FIN -, ARITY 2] : STAND, 
   [COORD @D147372, PAST @D147371, 
      AGR [CASE @D147370, COUNT @D147369, PER @D147368, PLU @D147367, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, REG -, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147378, PAST @D147377, AGR [CASE @D147376, COUNT @D147375, 
            PER @D147374, PLU @D147373, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM UNDER, FIN -, ARITY 2] : STAND, 
   [COORD @D147384, PAST @D147383, 
      AGR [CASE @D147382, COUNT @D147381, PER @D147380, PLU @D147379, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, FIN -, ARITY 2] : STAND, 
   [COORD @D147390, PAST @D147389, 
      AGR [CASE @D147388, COUNT @D147387, PER @D147386, PLU @D147385, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FROM, FIN -, ARITY 2] : STAND, 
   [COORD @D147396, PAST @D147395, 
      AGR [CASE @D147394, COUNT @D147393, PER @D147392, PLU @D147391, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM FOR, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147402, PAST @D147401, AGR [CASE @D147400, COUNT @D147399, 
            PER @D147398, PLU @D147397, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM FOR, FIN -, ARITY 2] : STAND, 
   [COORD @D147408, PAST @D147407, 
      AGR [CASE @D147406, COUNT @D147405, PER @D147404, PLU @D147403, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM FOR, 
      FIN -, ARITY 2] : STAND, 
   [COORD @D147414, PAST @D147413, AGR [CASE @D147412, COUNT @D147411, 
            PER @D147410, PLU @D147409, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT UP, PFORM FOR, FIN -, ARITY 2] : STAND, 
   [COORD @D147420, PAST @D147419, 
      AGR [CASE @D147418, COUNT @D147417, PER @D147416, PLU @D147415, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, FIN -, ARITY 2] : STAND, 
   [COORD @D147426, PAST @D147425, 
      AGR [CASE @D147424, COUNT @D147423, PER @D147422, PLU @D147421, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, FIN -, ARITY 2] : STAND, 
   [COORD @D147432, PAST @D147431, 
      AGR [CASE @D147430, COUNT @D147429, PER @D147428, PLU @D147427, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM BY, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147438, PAST @D147437, AGR [CASE @D147436, COUNT @D147435, 
            PER @D147434, PLU @D147433, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM BY, FIN -, ARITY 2] : STAND, 
   [COORD @D147444, PAST @D147443, 
      AGR [CASE @D147442, COUNT @D147441, PER @D147440, PLU @D147439, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM AMONG, FIN -, ARITY 2] : STAND, 
   [COORD @D147450, PAST @D147449, 
      AGR [CASE @D147448, COUNT @D147447, PER @D147446, PLU @D147445, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM AGAINST, 
      FIN -, ARITY 2] : STAND, 
   [COORD @D147456, PAST @D147455, AGR [CASE @D147454, COUNT @D147453, 
            PER @D147452, PLU @D147451, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM AGAINST, FIN -, ARITY 2] : STAND, 
   [COORD @D147462, PAST @D147461, 
      AGR [CASE @D147460, COUNT @D147459, PER @D147458, PLU @D147457, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147468, PAST @D147467, AGR [CASE @D147466, COUNT @D147465, 
            PER @D147464, PLU @D147463, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : STAND, 
   [COORD @D147474, PAST @D147473, 
      AGR [CASE @D147472, COUNT @D147471, PER @D147470, PLU @D147469, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT TO, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147480, PAST @D147479, AGR [CASE @D147478, COUNT @D147477, 
            PER @D147476, PLU @D147475, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT TO, FIN -, ARITY 2] : STAND, 
   [COORD @D147486, PAST @D147485, 
      AGR [CASE @D147484, COUNT @D147483, PER @D147482, PLU @D147481, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147492, PAST @D147491, AGR [CASE @D147490, COUNT @D147489, 
            PER @D147488, PLU @D147487, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : STAND, 
   [COORD @D147498, PAST @D147497, 
      AGR [CASE @D147496, COUNT @D147495, PER @D147494, PLU @D147493, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : STAND, 
   [COORD @D147504, PAST @D147503, AGR [CASE @D147502, COUNT @D147501, 
            PER @D147500, PLU @D147499, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : STAND, 
   [COORD @D147508, 
      AGR [COUNT @D147507, PER @D147506, PLU @D147505, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PAST +, 
      ARITY 2] : STAND, 
   [COORD @D147512, AGR [COUNT @D147511, PER @D147510, PLU @D147509, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PAST +, ARITY 2] : STAND, 
   [COORD @D147516, AGR [COUNT @D147515, PER @D147514, PLU @D147513, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PAST +, ARITY 2] : STAND, 
   [COORD @D147520, AGR [COUNT @D147519, PER @D147518, PLU @D147517, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, REG -, PAST +, ARITY 2] : STAND, 
   [COORD @D147524, AGR [COUNT @D147523, PER @D147522, PLU @D147521, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : STAND, 
   [COORD @D147528, AGR [COUNT @D147527, PER @D147526, PLU @D147525, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT MP, REG -, PAST +, ARITY 2] : STAND, 
   [COORD @D147532, AGR [COUNT @D147531, PER @D147530, PLU @D147529, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PAST +, ARITY 2] : STAND, 
   [COORD @D147536, AGR [COUNT @D147535, PER @D147534, PLU @D147533, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, REG -, PAST +, ARITY 2] : STAND, 
   [COORD @D147540, AGR [COUNT @D147539, PER @D147538, PLU @D147537, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT UP, PFORM UNDER, PAST +, ARITY 2] : STAND, 
   [COORD @D147544, 
      AGR [COUNT @D147543, PER @D147542, PLU @D147541, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, PAST +, ARITY 2] : STAND, 
   [COORD @D147548, AGR [COUNT @D147547, PER @D147546, PLU @D147545, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM FROM, PAST +, ARITY 2] : STAND, 
   [COORD @D147552, 
      AGR [COUNT @D147551, PER @D147550, PLU @D147549, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, 
      PAST +, ARITY 2] : STAND, 
   [COORD @D147556, AGR [COUNT @D147555, PER @D147554, PLU @D147553, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM FOR, PAST +, ARITY 2] : STAND, 
   [COORD @D147560, 
      AGR [COUNT @D147559, PER @D147558, PLU @D147557, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, PAST +, ARITY 2] : STAND, 
   [COORD @D147564, AGR [COUNT @D147563, PER @D147562, PLU @D147561, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT IN, PFORM FOR, PAST +, ARITY 2] : STAND, 
   [COORD @D147568, 
      AGR [COUNT @D147567, PER @D147566, PLU @D147565, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM BY, 
      PAST +, ARITY 2] : STAND, 
   [COORD @D147572, AGR [COUNT @D147571, PER @D147570, PLU @D147569, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM AMONG, PAST +, ARITY 2] : STAND, 
   [COORD @D147576, 
      AGR [COUNT @D147575, PER @D147574, PLU @D147573, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AGAINST, PAST +, ARITY 2] : STAND, 
   [COORD @D147580, AGR [COUNT @D147579, PER @D147578, PLU @D147577, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PRT OUT, PFORM AGAINST, PAST +, ARITY 2] : STAND, 
   [COORD @D147584, 
      AGR [COUNT @D147583, PER @D147582, PLU @D147581, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : STAND, 
   [COORD @D147588, AGR [COUNT @D147587, PER @D147586, PLU @D147585, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT TO, PAST +, ARITY 2] : STAND, 
   [COORD @D147592, AGR [COUNT @D147591, PER @D147590, PLU @D147589, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : STAND, 
   [COORD @D147596, AGR [COUNT @D147595, PER @D147594, PLU @D147593, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : STAND, 
   [COORD @D147602, PAST @D147601, 
      AGR [CASE @D147600, COUNT @D147599, PER @D147598, PLU @D147597, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : STAND, 
   [COORD @D147608, PAST @D147607, AGR [CASE @D147606, COUNT @D147605, 
            PER @D147604, PLU @D147603, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : STAND, 
   [COORD @D147614, PAST @D147613, 
      AGR [CASE @D147612, COUNT @D147611, PER @D147610, PLU @D147609, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TO, 
      FIN -, ARITY 1] : STAND, 
   [COORD @D147620, PAST @D147619, AGR [CASE @D147618, COUNT @D147617, 
            PER @D147616, PLU @D147615, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : STAND, 
   [COORD @D147626, PAST @D147625, 
      AGR [CASE @D147624, COUNT @D147623, PER @D147622, PLU @D147621, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OFF, 
      FIN -, ARITY 1] : STAND, 
   [COORD @D147632, PAST @D147631, AGR [CASE @D147630, COUNT @D147629, 
            PER @D147628, PLU @D147627, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, FIN -, ARITY 1] : STAND, 
   [COORD @D147638, PAST @D147637, 
      AGR [CASE @D147636, COUNT @D147635, PER @D147634, PLU @D147633, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      FIN -, ARITY 1] : STAND, 
   [COORD @D147644, PAST @D147643, AGR [CASE @D147642, COUNT @D147641, 
            PER @D147640, PLU @D147639, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, FIN -, ARITY 1] : STAND, 
   [COORD @D147648, 
      AGR [COUNT @D147647, PER @D147646, PLU @D147645, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : STAND, 
   [COORD @D147652, AGR [COUNT @D147651, PER @D147650, PLU @D147649, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : STAND, 
   [COORD @D147656, 
      AGR [COUNT @D147655, PER @D147654, PLU @D147653, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TO, PAST +, ARITY 1] : STAND, 
   [COORD @D147660, AGR [COUNT @D147659, PER @D147658, PLU @D147657, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, PAST +, ARITY 1] : STAND, 
   [COORD @D147664, 
      AGR [COUNT @D147663, PER @D147662, PLU @D147661, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, PAST +, ARITY 1] : STAND, 
   [COORD @D147668, AGR [COUNT @D147667, PER @D147666, PLU @D147665, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, PAST +, ARITY 1] : STAND, 
   [COORD @D147672, 
      AGR [COUNT @D147671, PER @D147670, PLU @D147669, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : STAND, 
   [COORD @D147676, AGR [COUNT @D147675, PER @D147674, PLU @D147673, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BY, PAST +, ARITY 1] : STAND.

WORD stop : 
   [COORD @D147695, REFL @D147694, PRD @D147693, CASE @D147692, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STOP, 
   [COORD @D147698, 
      AGR [COUNT @D147697, PER @D147696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_ING, 
      ARITY 2] : STOP, 
   [COORD @D147700, AGR [COUNT @D147699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : STOP, 
   [COORD @D147702, AGR [COUNT @D147701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : STOP, 
   [COORD @D147706, AGR [COUNT @D147705, PER @D147704, PLU @D147703, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : STOP, 
   [COORD @D147712, PAST @D147711, AGR [CASE @D147710, COUNT @D147709, 
            PER @D147708, PLU @D147707, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : STOP, 
   [COORD @D147715, AGR [COUNT @D147714, PER @D147713, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STOP, 
   [COORD @D147717, AGR [COUNT @D147716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STOP, 
   [COORD @D147719, AGR [COUNT @D147718, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STOP, 
   [COORD @D147723, AGR [COUNT @D147722, PER @D147721, PLU @D147720, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STOP, 
   [COORD @D147729, PAST @D147728, AGR [CASE @D147727, COUNT @D147726, 
            PER @D147725, PLU @D147724, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STOP, 
   [COORD @D147732, AGR [COUNT @D147731, PER @D147730, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STOP, 
   [COORD @D147734, AGR [COUNT @D147733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STOP, 
   [COORD @D147736, AGR [COUNT @D147735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STOP, 
   [COORD @D147740, AGR [COUNT @D147739, PER @D147738, PLU @D147737, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : STOP, 
   [COORD @D147746, PAST @D147745, AGR [CASE @D147744, COUNT @D147743, 
            PER @D147742, PLU @D147741, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : STOP, 
   [COORD @D147749, AGR [COUNT @D147748, PER @D147747, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : STOP, 
   [COORD @D147751, AGR [COUNT @D147750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : STOP, 
   [COORD @D147753, AGR [COUNT @D147752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : STOP, 
   [COORD @D147757, AGR [COUNT @D147756, PER @D147755, PLU @D147754, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ROUND, ARITY 2] : STOP, 
   [COORD @D147763, PAST @D147762, 
      AGR [CASE @D147761, COUNT @D147760, PER @D147759, PLU @D147758, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : STOP, 
   [COORD @D147766, AGR [COUNT @D147765, PER @D147764, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FROM, ARITY 2] : STOP, 
   [COORD @D147768, AGR [COUNT @D147767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FROM, ARITY 2] : STOP, 
   [COORD @D147770, AGR [COUNT @D147769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FROM, ARITY 2] : STOP, 
   [COORD @D147774, AGR [COUNT @D147773, PER @D147772, PLU @D147771, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FROM, ARITY 2] : STOP, 
   [COORD @D147780, PAST @D147779, 
      AGR [CASE @D147778, COUNT @D147777, PER @D147776, PLU @D147775, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FROM, ARITY 2] : STOP, 
   [COORD @D147783, AGR [COUNT @D147782, PER @D147781, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : STOP, 
   [COORD @D147785, AGR [COUNT @D147784, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : STOP, 
   [COORD @D147787, AGR [COUNT @D147786, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : STOP, 
   [COORD @D147791, AGR [COUNT @D147790, PER @D147789, PLU @D147788, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM BY, ARITY 2] : STOP, 
   [COORD @D147797, PAST @D147796, 
      AGR [CASE @D147795, COUNT @D147794, PER @D147793, PLU @D147792, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM BY, ARITY 2] : STOP, 
   [COORD @D147800, AGR [COUNT @D147799, PER @D147798, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM AT, ARITY 2] : STOP, 
   [COORD @D147802, AGR [COUNT @D147801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM AT, ARITY 2] : STOP, 
   [COORD @D147804, AGR [COUNT @D147803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM AT, ARITY 2] : STOP, 
   [COORD @D147808, AGR [COUNT @D147807, PER @D147806, PLU @D147805, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OFF, PFORM AT, ARITY 2] : STOP, 
   [COORD @D147814, PAST @D147813, 
      AGR [CASE @D147812, COUNT @D147811, PER @D147810, PLU @D147809, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OFF, PFORM AT, ARITY 2] : STOP, 
   [COORD @D147817, AGR [COUNT @D147816, PER @D147815, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STOP, 
   [COORD @D147819, AGR [COUNT @D147818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STOP, 
   [COORD @D147821, AGR [COUNT @D147820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STOP, 
   [COORD @D147825, AGR [COUNT @D147824, PER @D147823, PLU @D147822, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : STOP, 
   [COORD @D147831, PAST @D147830, 
      AGR [CASE @D147829, COUNT @D147828, PER @D147827, PLU @D147826, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : STOP, 
   [COORD @D147833, AGR [COUNT @D147832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : STOP, 
   [COORD @D147835, AGR [COUNT @D147834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : STOP, 
   [COORD @D147839, AGR [NFORM @D147838, COUNT @D147837, PER @D147836, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : STOP, 
   [COORD @D147843, AGR [COUNT @D147842, PER @D147841, PLU @D147840, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 1] : STOP, 
   [COORD @D147846, AGR @D147845, PAST @D147844, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_ING, ARITY 1] : STOP, 
   [COORD @D147849, AGR [COUNT @D147848, PER @D147847, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STOP, 
   [COORD @D147851, AGR [COUNT @D147850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STOP, 
   [COORD @D147853, AGR [COUNT @D147852, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STOP, 
   [COORD @D147857, AGR [COUNT @D147856, PER @D147855, PLU @D147854, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STOP, 
   [COORD @D147863, PAST @D147862, AGR [CASE @D147861, COUNT @D147860, 
            PER @D147859, PLU @D147858, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : STOP, 
   [COORD @D147866, AGR [COUNT @D147865, PER @D147864, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STOP, 
   [COORD @D147868, AGR [COUNT @D147867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STOP, 
   [COORD @D147870, AGR [COUNT @D147869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STOP, 
   [COORD @D147874, AGR [COUNT @D147873, PER @D147872, PLU @D147871, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STOP, 
   [COORD @D147880, PAST @D147879, 
      AGR [CASE @D147878, COUNT @D147877, PER @D147876, PLU @D147875, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : STOP, 
   [COORD @D147883, AGR [COUNT @D147882, PER @D147881, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : STOP, 
   [COORD @D147885, AGR [COUNT @D147884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : STOP, 
   [COORD @D147887, AGR [COUNT @D147886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : STOP, 
   [COORD @D147891, AGR [COUNT @D147890, PER @D147889, PLU @D147888, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : STOP, 
   [COORD @D147897, PAST @D147896, 
      AGR [CASE @D147895, COUNT @D147894, PER @D147893, PLU @D147892, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ROUND, ARITY 1] : STOP, 
   [COORD @D147900, AGR [COUNT @D147899, PER @D147898, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : STOP, 
   [COORD @D147902, AGR [COUNT @D147901, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : STOP, 
   [COORD @D147904, AGR [COUNT @D147903, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : STOP, 
   [COORD @D147908, AGR [COUNT @D147907, PER @D147906, PLU @D147905, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : STOP, 
   [COORD @D147914, PAST @D147913, 
      AGR [CASE @D147912, COUNT @D147911, PER @D147910, PLU @D147909, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : STOP, 
   [COORD @D147917, AGR [COUNT @D147916, PER @D147915, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STOP, 
   [COORD @D147919, AGR [COUNT @D147918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STOP, 
   [COORD @D147921, AGR [COUNT @D147920, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STOP, 
   [COORD @D147925, AGR [COUNT @D147924, PER @D147923, PLU @D147922, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : STOP, 
   [COORD @D147931, PAST @D147930, 
      AGR [CASE @D147929, COUNT @D147928, PER @D147927, PLU @D147926, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : STOP, 
   [COORD @D147934, AGR [COUNT @D147933, PER @D147932, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : STOP, 
   [COORD @D147936, AGR [COUNT @D147935, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : STOP, 
   [COORD @D147938, AGR [COUNT @D147937, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : STOP, 
   [COORD @D147942, AGR [COUNT @D147941, PER @D147940, PLU @D147939, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BY, ARITY 1] : STOP, 
   [COORD @D147948, PAST @D147947, 
      AGR [CASE @D147946, COUNT @D147945, PER @D147944, PLU @D147943, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT BY, ARITY 1] : STOP.

WORD stopped : 
   [COORD @D147958, AGR [CASE @D147957, COUNT @D147956, PER @D147955, 
            PLU @D147954, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STOP, 
   [COORD @D147963, AGR [CASE @D147962, COUNT @D147961, PER @D147960, 
            PLU @D147959, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D147968, AGR [CASE @D147967, COUNT @D147966, PER @D147965, 
            PLU @D147964, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D147973, AGR [CASE @D147972, COUNT @D147971, PER @D147970, 
            PLU @D147969, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STOP, 
   [COORD @D147978, AGR [CASE @D147977, COUNT @D147976, PER @D147975, 
            PLU @D147974, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D147983, AGR [CASE @D147982, COUNT @D147981, PER @D147980, 
            PLU @D147979, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D147988, AGR [CASE @D147987, COUNT @D147986, PER @D147985, 
            PLU @D147984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D147993, AGR [CASE @D147992, COUNT @D147991, PER @D147990, 
            PLU @D147989, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D147998, AGR [CASE @D147997, COUNT @D147996, PER @D147995, 
            PLU @D147994, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148003, AGR [CASE @D148002, COUNT @D148001, PER @D148000, 
            PLU @D147999, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148008, AGR [CASE @D148007, COUNT @D148006, PER @D148005, 
            PLU @D148004, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148013, AGR [CASE @D148012, COUNT @D148011, PER @D148010, 
            PLU @D148009, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OR, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148018, AGR [CASE @D148017, COUNT @D148016, PER @D148015, 
            PLU @D148014, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148023, 
      AGR [CASE @D148022, COUNT @D148021, PER @D148020, PLU @D148019, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148028, AGR [CASE @D148027, COUNT @D148026, PER @D148025, 
            PLU @D148024, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148033, AGR [CASE @D148032, COUNT @D148031, PER @D148030, 
            PLU @D148029, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148038, AGR [CASE @D148037, COUNT @D148036, PER @D148035, 
            PLU @D148034, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM BY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148043, AGR [CASE @D148042, COUNT @D148041, PER @D148040, 
            PLU @D148039, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148048, AGR [CASE @D148047, COUNT @D148046, PER @D148045, 
            PLU @D148044, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148053, AGR [CASE @D148052, COUNT @D148051, PER @D148050, 
            PLU @D148049, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148058, AGR [CASE @D148057, COUNT @D148056, PER @D148055, 
            PLU @D148054, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148063, AGR [CASE @D148062, COUNT @D148061, PER @D148060, 
            PLU @D148059, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148065, AGR @D148064, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STOP, 
   [COORD @D148067, AGR @D148066, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148072, AGR [CASE @D148071, COUNT @D148070, PER @D148069, 
            PLU @D148068, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148077, AGR [CASE @D148076, COUNT @D148075, PER @D148074, 
            PLU @D148073, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148082, AGR [CASE @D148081, COUNT @D148080, PER @D148079, 
            PLU @D148078, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148087, AGR [CASE @D148086, COUNT @D148085, PER @D148084, 
            PLU @D148083, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148092, AGR [CASE @D148091, COUNT @D148090, PER @D148089, 
            PLU @D148088, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148097, AGR [CASE @D148096, COUNT @D148095, PER @D148094, 
            PLU @D148093, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148102, AGR [CASE @D148101, COUNT @D148100, PER @D148099, 
            PLU @D148098, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148107, AGR [CASE @D148106, COUNT @D148105, PER @D148104, 
            PLU @D148103, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148112, AGR [CASE @D148111, COUNT @D148110, PER @D148109, 
            PLU @D148108, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148117, AGR [CASE @D148116, COUNT @D148115, PER @D148114, 
            PLU @D148113, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STOP, 
   [COORD @D148122, AGR [CASE @D148121, COUNT @D148120, PER @D148119, 
            PLU @D148118, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148127, AGR [CASE @D148126, COUNT @D148125, PER @D148124, 
            PLU @D148123, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STOP.

WORD stopping : 
   [COORD @D148138, PRD @D148137, AGR [CASE @D148136, COUNT @D148135, 
            PER @D148134, PLU @D148133, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148144, PRD @D148143, 
      AGR [CASE @D148142, COUNT @D148141, PER @D148140, PLU @D148139, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STOP, 
   [COORD @D148150, PRD @D148149, AGR [CASE @D148148, COUNT @D148147, 
            PER @D148146, PLU @D148145, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148156, PRD @D148155, 
      AGR [CASE @D148154, COUNT @D148153, PER @D148152, PLU @D148151, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148162, PRD @D148161, AGR [CASE @D148160, COUNT @D148159, 
            PER @D148158, PLU @D148157, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, SUBCAT OC_PP_ING, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148168, PRD @D148167, 
      AGR [CASE @D148166, COUNT @D148165, PER @D148164, PLU @D148163, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STOP, 
   [COORD @D148174, PRD @D148173, AGR [CASE @D148172, COUNT @D148171, 
            PER @D148170, PLU @D148169, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, 
      PFORM AT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148180, PRD @D148179, 
      AGR [CASE @D148178, COUNT @D148177, PER @D148176, PLU @D148175, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STOP, 
   [COORD @D148183, AGR @D148182, PRD @D148181, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148189, PRD @D148188, AGR [CASE @D148187, COUNT @D148186, 
            PER @D148185, PLU @D148184, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148195, PRD @D148194, 
      AGR [CASE @D148193, COUNT @D148192, PER @D148191, PLU @D148190, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STOP, 
   [COORD @D148201, PRD @D148200, AGR [CASE @D148199, COUNT @D148198, 
            PER @D148197, PLU @D148196, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148207, PRD @D148206, 
      AGR [CASE @D148205, COUNT @D148204, PER @D148203, PLU @D148202, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STOP, 
   [COORD @D148213, PRD @D148212, AGR [CASE @D148211, COUNT @D148210, 
            PER @D148209, PLU @D148208, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STOP, 
   [COORD @D148219, PRD @D148218, 
      AGR [CASE @D148217, COUNT @D148216, PER @D148215, PLU @D148214, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STOP.

WORD stops : 
   [COORD @D148229, DEMON @D148228, REFL @D148227, PRD @D148226, 
      CASE @D148225, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STOP, 
   [COORD @D148231, AGR [COUNT @D148230, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STOP, 
   [COORD @D148233, AGR [COUNT @D148232, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148235, 
      AGR [COUNT @D148234, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148237, 
      AGR [COUNT @D148236, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148239, 
      AGR [COUNT @D148238, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OR, 
      SUBCAT OC_PP_ING, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STOP, 
   [COORD @D148241, AGR [COUNT @D148240, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148243, AGR [COUNT @D148242, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OFF, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148245, AGR [COUNT @D148244, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148249, AGR [CASE @D148248, NFORM @D148247, COUNT @D148246, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_ING, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148254, AGR [UB @D148253, VFORM @D148252, SUBJ @D148251, 
            FIN @D148250, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_ING, CONJ NULL, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STOP, 
   [COORD @D148256, AGR [COUNT @D148255, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148258, 
      AGR [COUNT @D148257, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148260, 
      AGR [COUNT @D148259, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148262, 
      AGR [COUNT @D148261, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148264, 
      AGR [COUNT @D148263, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP, 
   [COORD @D148266, 
      AGR [COUNT @D148265, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STOP.

WORD store : 
   [COORD @D148276, REFL @D148275, COUNT @D148274, PRD @D148273, 
      CASE @D148272, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : STORE, 
   [COORD @D148280, REFL @D148279, PRD @D148278, CASE @D148277, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : STORE, 
   [COORD @D148283, 
      AGR [COUNT @D148282, PER @D148281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   STORE, 
   [COORD @D148285, AGR [COUNT @D148284, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STORE, 
   [COORD @D148287, AGR [COUNT @D148286, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STORE, 
   [COORD @D148291, AGR [COUNT @D148290, PER @D148289, PLU @D148288, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STORE, 
   [COORD @D148297, PAST @D148296, AGR [CASE @D148295, COUNT @D148294, 
            PER @D148293, PLU @D148292, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STORE, 
   [COORD @D148300, AGR [COUNT @D148299, PER @D148298, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STORE, 
   [COORD @D148302, AGR [COUNT @D148301, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STORE, 
   [COORD @D148304, AGR [COUNT @D148303, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : STORE, 
   [COORD @D148308, AGR [COUNT @D148307, PER @D148306, PLU @D148305, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : STORE, 
   [COORD @D148314, PAST @D148313, 
      AGR [CASE @D148312, COUNT @D148311, PER @D148310, PLU @D148309, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : STORE, 
   [COORD @D148317, AGR [COUNT @D148316, PER @D148315, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STORE, 
   [COORD @D148319, AGR [COUNT @D148318, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STORE, 
   [COORD @D148321, AGR [COUNT @D148320, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STORE, 
   [COORD @D148325, AGR [COUNT @D148324, PER @D148323, PLU @D148322, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : STORE, 
   [COORD @D148331, PAST @D148330, 
      AGR [CASE @D148329, COUNT @D148328, PER @D148327, PLU @D148326, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : STORE.

WORD stored : 
   [COORD @D148343, AGR [CASE @D148342, COUNT @D148341, PER @D148340, 
            PLU @D148339, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STORE, 
   [COORD @D148348, AGR [CASE @D148347, COUNT @D148346, PER @D148345, 
            PLU @D148344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STORE, 
   [COORD @D148353, AGR [CASE @D148352, COUNT @D148351, PER @D148350, 
            PLU @D148349, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STORE, 
   [COORD @D148358, AGR [CASE @D148357, COUNT @D148356, PER @D148355, 
            PLU @D148354, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STORE, 
   [COORD @D148363, AGR [CASE @D148362, COUNT @D148361, PER @D148360, 
            PLU @D148359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STORE, 
   [COORD @D148368, AGR [CASE @D148367, COUNT @D148366, PER @D148365, 
            PLU @D148364, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STORE, 
   [COORD @D148373, AGR [CASE @D148372, COUNT @D148371, PER @D148370, 
            PLU @D148369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STORE, 
   [COORD @D148378, AGR [CASE @D148377, COUNT @D148376, PER @D148375, 
            PLU @D148374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STORE.

WORD stores : 
   [COORD @D148389, REFL @D148388, PRD @D148387, CASE @D148386, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : STORES, 
   [COORD @D148393, REFL @D148392, PRD @D148391, CASE @D148390, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : STORES, 
   [COORD @D148397, REFL @D148396, PRD @D148395, CASE @D148394, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, GROUP +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT -] : STORES, 
   [COORD @D148402, DEMON @D148401, REFL @D148400, PRD @D148399, 
      CASE @D148398, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STORE, 
   [COORD @D148407, DEMON @D148406, REFL @D148405, PRD @D148404, 
      CASE @D148403, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STORE, 
   [COORD @D148409, AGR [COUNT @D148408, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STORE, 
   [COORD @D148411, 
      AGR [COUNT @D148410, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STORE, 
   [COORD @D148413, 
      AGR [COUNT @D148412, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STORE.

WORD storing : 
   [COORD @D148436, PRD @D148435, AGR [CASE @D148434, COUNT @D148433, 
            PER @D148432, PLU @D148431, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STORE, 
   [COORD @D148442, PRD @D148441, 
      AGR [CASE @D148440, COUNT @D148439, PER @D148438, PLU @D148437, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STORE, 
   [COORD @D148448, PRD @D148447, AGR [CASE @D148446, COUNT @D148445, 
            PER @D148444, PLU @D148443, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STORE.

WORD stretch : 
   [COORD @D148454, AGR [COUNT @D148453, PER @D148452, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STRETCH, 
   [COORD @D148456, AGR [COUNT @D148455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STRETCH, 
   [COORD @D148458, AGR [COUNT @D148457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STRETCH, 
   [COORD @D148462, AGR [COUNT @D148461, PER @D148460, PLU @D148459, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STRETCH, 
   [COORD @D148468, PAST @D148467, AGR [CASE @D148466, COUNT @D148465, 
            PER @D148464, PLU @D148463, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STRETCH, 
   [COORD @D148471, AGR [COUNT @D148470, PER @D148469, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STRETCH, 
   [COORD @D148473, AGR [COUNT @D148472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STRETCH, 
   [COORD @D148475, AGR [COUNT @D148474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : STRETCH, 
   [COORD @D148479, AGR [COUNT @D148478, PER @D148477, PLU @D148476, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : STRETCH, 
   [COORD @D148485, PAST @D148484, AGR [CASE @D148483, COUNT @D148482, 
            PER @D148481, PLU @D148480, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : STRETCH, 
   [COORD @D148488, AGR [COUNT @D148487, PER @D148486, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : STRETCH, 
   [COORD @D148490, AGR [COUNT @D148489, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : STRETCH, 
   [COORD @D148492, AGR [COUNT @D148491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : STRETCH, 
   [COORD @D148496, AGR [COUNT @D148495, PER @D148494, PLU @D148493, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : STRETCH, 
   [COORD @D148502, PAST @D148501, 
      AGR [CASE @D148500, COUNT @D148499, PER @D148498, PLU @D148497, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : STRETCH, 
   [COORD @D148505, AGR [COUNT @D148504, PER @D148503, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STRETCH, 
   [COORD @D148507, AGR [COUNT @D148506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STRETCH, 
   [COORD @D148509, AGR [COUNT @D148508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STRETCH, 
   [COORD @D148513, AGR [COUNT @D148512, PER @D148511, PLU @D148510, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STRETCH, 
   [COORD @D148519, PAST @D148518, AGR [CASE @D148517, COUNT @D148516, 
            PER @D148515, PLU @D148514, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : STRETCH, 
   [COORD @D148522, AGR [COUNT @D148521, PER @D148520, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STRETCH, 
   [COORD @D148524, AGR [COUNT @D148523, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STRETCH, 
   [COORD @D148526, AGR [COUNT @D148525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STRETCH, 
   [COORD @D148530, AGR [COUNT @D148529, PER @D148528, PLU @D148527, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : STRETCH, 
   [COORD @D148536, PAST @D148535, 
      AGR [CASE @D148534, COUNT @D148533, PER @D148532, PLU @D148531, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : STRETCH.

WORD stretched : 
   [COORD @D148545, AGR [CASE @D148544, COUNT @D148543, PER @D148542, 
            PLU @D148541, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STRETCH, 
   [COORD @D148550, AGR [CASE @D148549, COUNT @D148548, PER @D148547, 
            PLU @D148546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148555, AGR [CASE @D148554, COUNT @D148553, PER @D148552, 
            PLU @D148551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148560, AGR [CASE @D148559, COUNT @D148558, PER @D148557, 
            PLU @D148556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148565, AGR [CASE @D148564, COUNT @D148563, PER @D148562, 
            PLU @D148561, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148570, AGR [CASE @D148569, COUNT @D148568, PER @D148567, 
            PLU @D148566, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148575, AGR [CASE @D148574, COUNT @D148573, PER @D148572, 
            PLU @D148571, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148580, AGR [CASE @D148579, COUNT @D148578, PER @D148577, 
            PLU @D148576, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148585, AGR [CASE @D148584, COUNT @D148583, PER @D148582, 
            PLU @D148581, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148590, AGR [CASE @D148589, COUNT @D148588, PER @D148587, 
            PLU @D148586, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148595, AGR [CASE @D148594, COUNT @D148593, PER @D148592, 
            PLU @D148591, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148600, AGR [CASE @D148599, COUNT @D148598, PER @D148597, 
            PLU @D148596, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : STRETCH.

WORD stretching : 
   [COORD @D148612, PRD @D148611, AGR [CASE @D148610, COUNT @D148609, 
            PER @D148608, PLU @D148607, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148618, PRD @D148617, 
      AGR [CASE @D148616, COUNT @D148615, PER @D148614, PLU @D148613, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STRETCH, 
   [COORD @D148624, PRD @D148623, AGR [CASE @D148622, COUNT @D148621, 
            PER @D148620, PLU @D148619, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRETCH, 
   [COORD @D148630, PRD @D148629, 
      AGR [CASE @D148628, COUNT @D148627, PER @D148626, PLU @D148625, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STRETCH, 
   [COORD @D148636, PRD @D148635, AGR [CASE @D148634, COUNT @D148633, 
            PER @D148632, PLU @D148631, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRETCH.

WORD strike : 
   [COORD @D148650, REFL @D148649, COUNT @D148648, PRD @D148647, 
      CASE @D148646, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : STRIKE, 
   [COORD @D148653, 
      AGR [COUNT @D148652, PER @D148651, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, ARITY 3] : 
   STRIKE, 
   [COORD @D148655, AGR [COUNT @D148654, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148657, AGR [COUNT @D148656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148661, AGR [COUNT @D148660, PER @D148659, PLU @D148658, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, ARITY 3] : STRIKE, 
   [COORD @D148667, PAST @D148666, 
      AGR [CASE @D148665, COUNT @D148664, PER @D148663, PLU @D148662, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148670, AGR [COUNT @D148669, PER @D148668, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148672, AGR [COUNT @D148671, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148674, AGR [COUNT @D148673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148678, AGR [COUNT @D148677, PER @D148676, PLU @D148675, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : STRIKE, 
   [COORD @D148684, PAST @D148683, 
      AGR [CASE @D148682, COUNT @D148681, PER @D148680, PLU @D148679, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : STRIKE, 
   [COORD @D148687, AGR [COUNT @D148686, PER @D148685, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148689, AGR [COUNT @D148688, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148691, AGR [COUNT @D148690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : STRIKE, 
   [COORD @D148695, AGR [COUNT @D148694, PER @D148693, PLU @D148692, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : STRIKE, 
   [COORD @D148701, PAST @D148700, 
      AGR [CASE @D148699, COUNT @D148698, PER @D148697, PLU @D148696, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : STRIKE, 
   [COORD @D148704, AGR [COUNT @D148703, PER @D148702, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : STRIKE, 
   [COORD @D148706, AGR [COUNT @D148705, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : STRIKE, 
   [COORD @D148708, AGR [COUNT @D148707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PFORM WITH, ARITY 3] : STRIKE, 
   [COORD @D148712, AGR [COUNT @D148711, PER @D148710, PLU @D148709, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM WITH, ARITY 3] : STRIKE, 
   [COORD @D148718, PAST @D148717, 
      AGR [CASE @D148716, COUNT @D148715, PER @D148714, PLU @D148713, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, ARITY 3] : STRIKE, 
   [COORD @D148721, AGR [COUNT @D148720, PER @D148719, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STRIKE, 
   [COORD @D148723, AGR [COUNT @D148722, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STRIKE, 
   [COORD @D148725, AGR [COUNT @D148724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STRIKE, 
   [COORD @D148729, AGR [COUNT @D148728, PER @D148727, PLU @D148726, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, ARITY 2] : STRIKE, 
   [COORD @D148735, PAST @D148734, 
      AGR [CASE @D148733, COUNT @D148732, PER @D148731, PLU @D148730, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, 
      REG -, ARITY 2] : STRIKE, 
   [COORD @D148738, AGR [COUNT @D148737, PER @D148736, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STRIKE, 
   [COORD @D148740, AGR [COUNT @D148739, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STRIKE, 
   [COORD @D148742, AGR [COUNT @D148741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : STRIKE, 
   [COORD @D148746, AGR [COUNT @D148745, PER @D148744, PLU @D148743, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : STRIKE, 
   [COORD @D148752, PAST @D148751, AGR [CASE @D148750, COUNT @D148749, 
            PER @D148748, PLU @D148747, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : STRIKE, 
   [COORD @D148755, 
      AGR [COUNT @D148754, PER @D148753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, PRT OUT, 
      ARITY 2] : STRIKE, 
   [COORD @D148757, AGR [COUNT @D148756, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148759, AGR [COUNT @D148758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148763, AGR [COUNT @D148762, PER @D148761, PLU @D148760, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      REG -, PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148769, PAST @D148768, 
      AGR [CASE @D148767, COUNT @D148766, PER @D148765, PLU @D148764, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, 
      PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148771, AGR [COUNT @D148770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP_NP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148773, AGR [COUNT @D148772, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP_NP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148777, AGR [NFORM @D148776, COUNT @D148775, PER @D148774, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP_NP, REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148781, 
      AGR [COUNT @D148780, PER @D148779, PLU @D148778, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP_NP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148784, AGR @D148783, PAST @D148782, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP_NP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148786, AGR [COUNT @D148785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP_AP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148788, AGR [COUNT @D148787, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP_AP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148792, AGR [NFORM @D148791, COUNT @D148790, PER @D148789, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP_AP, REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148796, 
      AGR [COUNT @D148795, PER @D148794, PLU @D148793, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      SUBTYPE RAIS, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_NP_AP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148799, AGR @D148798, PAST @D148797, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP_AP, 
      REG -, PREP AS, ARITY 2] : STRIKE, 
   [COORD @D148802, AGR [COUNT @D148801, PER @D148800, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : STRIKE, 
   [COORD @D148804, AGR [COUNT @D148803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : STRIKE, 
   [COORD @D148806, AGR [COUNT @D148805, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : STRIKE, 
   [COORD @D148810, AGR [COUNT @D148809, PER @D148808, PLU @D148807, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, ARITY 2] : STRIKE, 
   [COORD @D148816, PAST @D148815, 
      AGR [CASE @D148814, COUNT @D148813, PER @D148812, PLU @D148811, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM UPON, ARITY 2] : STRIKE, 
   [COORD @D148819, AGR [COUNT @D148818, PER @D148817, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : STRIKE, 
   [COORD @D148821, AGR [COUNT @D148820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : STRIKE, 
   [COORD @D148823, AGR [COUNT @D148822, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : STRIKE, 
   [COORD @D148827, AGR [COUNT @D148826, PER @D148825, PLU @D148824, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, ARITY 2] : STRIKE, 
   [COORD @D148833, PAST @D148832, 
      AGR [CASE @D148831, COUNT @D148830, PER @D148829, PLU @D148828, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ON, ARITY 2] : STRIKE, 
   [COORD @D148836, AGR [COUNT @D148835, PER @D148834, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STRIKE, 
   [COORD @D148838, AGR [COUNT @D148837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STRIKE, 
   [COORD @D148840, AGR [COUNT @D148839, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STRIKE, 
   [COORD @D148844, AGR [COUNT @D148843, PER @D148842, PLU @D148841, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM FOR, ARITY 2] : STRIKE, 
   [COORD @D148850, PAST @D148849, 
      AGR [CASE @D148848, COUNT @D148847, PER @D148846, PLU @D148845, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM FOR, ARITY 2] : STRIKE, 
   [COORD @D148853, AGR [COUNT @D148852, PER @D148851, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STRIKE, 
   [COORD @D148855, AGR [COUNT @D148854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STRIKE, 
   [COORD @D148857, AGR [COUNT @D148856, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : STRIKE, 
   [COORD @D148861, AGR [COUNT @D148860, PER @D148859, PLU @D148858, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : STRIKE, 
   [COORD @D148867, PAST @D148866, 
      AGR [CASE @D148865, COUNT @D148864, PER @D148863, PLU @D148862, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : STRIKE, 
   [COORD @D148870, AGR [COUNT @D148869, PER @D148868, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148872, AGR [COUNT @D148871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148874, AGR [COUNT @D148873, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148878, AGR [COUNT @D148877, PER @D148876, PLU @D148875, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : STRIKE, 
   [COORD @D148884, PAST @D148883, 
      AGR [CASE @D148882, COUNT @D148881, PER @D148880, PLU @D148879, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : STRIKE, 
   [COORD @D148887, AGR [COUNT @D148886, PER @D148885, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : STRIKE, 
   [COORD @D148889, AGR [COUNT @D148888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : STRIKE, 
   [COORD @D148891, AGR [COUNT @D148890, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : STRIKE, 
   [COORD @D148895, AGR [COUNT @D148894, PER @D148893, PLU @D148892, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : STRIKE, 
   [COORD @D148901, PAST @D148900, 
      AGR [CASE @D148899, COUNT @D148898, PER @D148897, PLU @D148896, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : STRIKE, 
   [COORD @D148904, AGR [COUNT @D148903, PER @D148902, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STRIKE, 
   [COORD @D148906, AGR [COUNT @D148905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STRIKE, 
   [COORD @D148908, AGR [COUNT @D148907, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STRIKE, 
   [COORD @D148912, AGR [COUNT @D148911, PER @D148910, PLU @D148909, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : STRIKE, 
   [COORD @D148918, PAST @D148917, 
      AGR [CASE @D148916, COUNT @D148915, PER @D148914, PLU @D148913, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : STRIKE, 
   [COORD @D148921, AGR [COUNT @D148920, PER @D148919, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STRIKE, 
   [COORD @D148923, AGR [COUNT @D148922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STRIKE, 
   [COORD @D148925, AGR [COUNT @D148924, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : STRIKE, 
   [COORD @D148929, AGR [COUNT @D148928, PER @D148927, PLU @D148926, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : STRIKE, 
   [COORD @D148935, PAST @D148934, 
      AGR [CASE @D148933, COUNT @D148932, PER @D148931, PLU @D148930, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : STRIKE, 
   [COORD @D148938, AGR [COUNT @D148937, PER @D148936, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STRIKE, 
   [COORD @D148940, AGR [COUNT @D148939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STRIKE, 
   [COORD @D148942, AGR [COUNT @D148941, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : STRIKE, 
   [COORD @D148946, AGR [COUNT @D148945, PER @D148944, PLU @D148943, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : STRIKE, 
   [COORD @D148952, PAST @D148951, 
      AGR [CASE @D148950, COUNT @D148949, PER @D148948, PLU @D148947, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : STRIKE, 
   [COORD @D148955, AGR [COUNT @D148954, PER @D148953, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STRIKE, 
   [COORD @D148957, AGR [COUNT @D148956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STRIKE, 
   [COORD @D148959, AGR [COUNT @D148958, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : STRIKE, 
   [COORD @D148963, AGR [COUNT @D148962, PER @D148961, PLU @D148960, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : STRIKE, 
   [COORD @D148969, PAST @D148968, 
      AGR [CASE @D148967, COUNT @D148966, PER @D148965, PLU @D148964, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : STRIKE, 
   [COORD @D148972, AGR [COUNT @D148971, PER @D148970, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : STRIKE, 
   [COORD @D148974, AGR [COUNT @D148973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : STRIKE, 
   [COORD @D148976, AGR [COUNT @D148975, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : STRIKE, 
   [COORD @D148980, AGR [COUNT @D148979, PER @D148978, PLU @D148977, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : STRIKE, 
   [COORD @D148986, PAST @D148985, 
      AGR [CASE @D148984, COUNT @D148983, PER @D148982, PLU @D148981, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : STRIKE, 
   [COORD @D148989, AGR [COUNT @D148988, PER @D148987, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : STRIKE, 
   [COORD @D148991, AGR [COUNT @D148990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : STRIKE, 
   [COORD @D148993, AGR [COUNT @D148992, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : STRIKE, 
   [COORD @D148997, AGR [COUNT @D148996, PER @D148995, PLU @D148994, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : STRIKE, 
   [COORD @D149003, PAST @D149002, 
      AGR [CASE @D149001, COUNT @D149000, PER @D148999, PLU @D148998, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : STRIKE.

WORD strikes : 
   [COORD @D149022, DEMON @D149021, REFL @D149020, PRD @D149019, 
      CASE @D149018, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   STRIKE, 
   [COORD @D149024, AGR [COUNT @D149023, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STRIKE, 
   [COORD @D149026, AGR [COUNT @D149025, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149028, 
      AGR [COUNT @D149027, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149030, 
      AGR [COUNT @D149029, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   STRIKE, 
   [COORD @D149032, AGR [COUNT @D149031, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149034, 
      AGR [COUNT @D149033, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149036, 
      AGR [COUNT @D149035, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149040, 
      AGR [CASE @D149039, NFORM @D149038, COUNT @D149037, PLU -, PER 3, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT SC_NP_NP, CONJ NULL, PREP AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149045, AGR [UB @D149044, VFORM @D149043, SUBJ @D149042, 
            FIN @D149041, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_NP_NP, CONJ NULL, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : STRIKE, 
   [COORD @D149049, AGR [CASE @D149048, NFORM @D149047, COUNT @D149046, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_NP_AP, CONJ NULL, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : STRIKE, 
   [COORD @D149054, AGR [UB @D149053, VFORM @D149052, SUBJ @D149051, 
            FIN @D149050, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_NP_AP, CONJ NULL, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : STRIKE, 
   [COORD @D149056, AGR [COUNT @D149055, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149058, AGR [COUNT @D149057, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149060, AGR [COUNT @D149059, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149062, AGR [COUNT @D149061, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149064, AGR [COUNT @D149063, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149066, AGR [COUNT @D149065, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149068, AGR [COUNT @D149067, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149070, AGR [COUNT @D149069, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149072, 
      AGR [COUNT @D149071, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149074, 
      AGR [COUNT @D149073, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149076, 
      AGR [COUNT @D149075, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149078, 
      AGR [COUNT @D149077, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STRIKE.

WORD striking : 
   [COORD @D149089, PRD @D149088, AGR [CASE @D149087, COUNT @D149086, 
            PER @D149085, PLU @D149084, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149095, PRD @D149094, 
      AGR [CASE @D149093, COUNT @D149092, PER @D149091, PLU @D149090, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149101, PRD @D149100, AGR [CASE @D149099, COUNT @D149098, 
            PER @D149097, PLU @D149096, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149107, PRD @D149106, 
      AGR [CASE @D149105, COUNT @D149104, PER @D149103, PLU @D149102, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149113, PRD @D149112, 
      AGR [CASE @D149111, COUNT @D149110, PER @D149109, PLU @D149108, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149119, PRD @D149118, AGR [CASE @D149117, COUNT @D149116, 
            PER @D149115, PLU @D149114, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149125, PRD @D149124, 
      AGR [CASE @D149123, COUNT @D149122, PER @D149121, PLU @D149120, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STRIKE, 
   [COORD @D149128, AGR @D149127, PRD @D149126, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_NP_NP, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STRIKE, 
   [COORD @D149131, AGR @D149130, PRD @D149129, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_NP_AP, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STRIKE, 
   [COORD @D149137, PRD @D149136, AGR [CASE @D149135, COUNT @D149134, 
            PER @D149133, PLU @D149132, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149143, PRD @D149142, 
      AGR [CASE @D149141, COUNT @D149140, PER @D149139, PLU @D149138, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STRIKE, 
   [COORD @D149149, PRD @D149148, AGR [CASE @D149147, COUNT @D149146, 
            PER @D149145, PLU @D149144, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149155, PRD @D149154, 
      AGR [CASE @D149153, COUNT @D149152, PER @D149151, PLU @D149150, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STRIKE, 
   [COORD @D149161, PRD @D149160, AGR [CASE @D149159, COUNT @D149158, 
            PER @D149157, PLU @D149156, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149167, PRD @D149166, 
      AGR [CASE @D149165, COUNT @D149164, PER @D149163, PLU @D149162, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : STRIKE, 
   [COORD @D149173, PRD @D149172, AGR [CASE @D149171, COUNT @D149170, 
            PER @D149169, PLU @D149168, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149179, PRD @D149178, 
      AGR [CASE @D149177, COUNT @D149176, PER @D149175, PLU @D149174, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STRIKE, 
   [COORD @D149185, PRD @D149184, AGR [CASE @D149183, COUNT @D149182, 
            PER @D149181, PLU @D149180, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149191, PRD @D149190, 
      AGR [CASE @D149189, COUNT @D149188, PER @D149187, PLU @D149186, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STRIKE, 
   [COORD @D149197, PRD @D149196, AGR [CASE @D149195, COUNT @D149194, 
            PER @D149193, PLU @D149192, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : STRIKE, 
   [COORD @D149203, PRD @D149202, 
      AGR [CASE @D149201, COUNT @D149200, PER @D149199, PLU @D149198, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STRIKE.

WORD struck : 
   [COORD @D149212, PAST @D149211, AGR [CASE @D149210, COUNT @D149209, 
            PER @D149208, PLU @D149207, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : STRIKE, 
   [COORD @D149218, PAST @D149217, 
      AGR [CASE @D149216, COUNT @D149215, PER @D149214, PLU @D149213, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, 
      ARITY 3] : STRIKE, 
   [COORD @D149224, PAST @D149223, AGR [CASE @D149222, COUNT @D149221, 
            PER @D149220, PLU @D149219, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : STRIKE, 
   [COORD @D149230, PAST @D149229, 
      AGR [CASE @D149228, COUNT @D149227, PER @D149226, PLU @D149225, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : STRIKE, 
   [COORD @D149236, PAST @D149235, AGR [CASE @D149234, COUNT @D149233, 
            PER @D149232, PLU @D149231, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : STRIKE, 
   [COORD @D149242, PAST @D149241, 
      AGR [CASE @D149240, COUNT @D149239, PER @D149238, PLU @D149237, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : STRIKE, 
   [COORD @D149248, PAST @D149247, AGR [CASE @D149246, COUNT @D149245, 
            PER @D149244, PLU @D149243, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM WITH, FIN -, ARITY 3] : STRIKE, 
   [COORD @D149254, PAST @D149253, 
      AGR [CASE @D149252, COUNT @D149251, PER @D149250, PLU @D149249, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, FIN -, ARITY 3] : STRIKE, 
   [COORD @D149258, AGR [COUNT @D149257, PER @D149256, PLU @D149255, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 3] : STRIKE, 
   [COORD @D149262, AGR [COUNT @D149261, PER @D149260, PLU @D149259, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : STRIKE, 
   [COORD @D149266, AGR [COUNT @D149265, PER @D149264, PLU @D149263, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : STRIKE, 
   [COORD @D149270, AGR [COUNT @D149269, PER @D149268, PLU @D149267, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, PFORM WITH, PAST +, ARITY 3] : STRIKE, 
   [COORD @D149276, PAST @D149275, 
      AGR [CASE @D149274, COUNT @D149273, PER @D149272, PLU @D149271, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, FIN -, 
      ARITY 2] : STRIKE, 
   [COORD @D149282, PAST @D149281, AGR [CASE @D149280, COUNT @D149279, 
            PER @D149278, PLU @D149277, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149288, PAST @D149287, 
      AGR [CASE @D149286, COUNT @D149285, PER @D149284, PLU @D149283, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : STRIKE, 
   [COORD @D149294, PAST @D149293, AGR [CASE @D149292, COUNT @D149291, 
            PER @D149290, PLU @D149289, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PRT OUT, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149297, AGR @D149296, PAST @D149295, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP_NP, REG -, 
      PREP AS, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149300, AGR @D149299, PAST @D149298, FIX NOT, V +, N -, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP_AP, REG -, 
      PREP AS, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149306, PAST @D149305, 
      AGR [CASE @D149304, COUNT @D149303, PER @D149302, PLU @D149301, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM UPON, FIN -, 
      ARITY 2] : STRIKE, 
   [COORD @D149312, PAST @D149311, AGR [CASE @D149310, COUNT @D149309, 
            PER @D149308, PLU @D149307, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM UPON, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149318, PAST @D149317, 
      AGR [CASE @D149316, COUNT @D149315, PER @D149314, PLU @D149313, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM ON, FIN -, 
      ARITY 2] : STRIKE, 
   [COORD @D149324, PAST @D149323, AGR [CASE @D149322, COUNT @D149321, 
            PER @D149320, PLU @D149319, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM ON, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149330, PAST @D149329, 
      AGR [CASE @D149328, COUNT @D149327, PER @D149326, PLU @D149325, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM FOR, 
      FIN -, ARITY 2] : STRIKE, 
   [COORD @D149336, PAST @D149335, AGR [CASE @D149334, COUNT @D149333, 
            PER @D149332, PLU @D149331, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149342, PAST @D149341, 
      AGR [CASE @D149340, COUNT @D149339, PER @D149338, PLU @D149337, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : STRIKE, 
   [COORD @D149348, PAST @D149347, AGR [CASE @D149346, COUNT @D149345, 
            PER @D149344, PLU @D149343, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149354, PAST @D149353, 
      AGR [CASE @D149352, COUNT @D149351, PER @D149350, PLU @D149349, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      FIN -, ARITY 2] : STRIKE, 
   [COORD @D149360, PAST @D149359, AGR [CASE @D149358, COUNT @D149357, 
            PER @D149356, PLU @D149355, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149366, PAST @D149365, 
      AGR [CASE @D149364, COUNT @D149363, PER @D149362, PLU @D149361, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : STRIKE, 
   [COORD @D149372, PAST @D149371, AGR [CASE @D149370, COUNT @D149369, 
            PER @D149368, PLU @D149367, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : STRIKE, 
   [COORD @D149378, PAST @D149377, 
      AGR [CASE @D149376, COUNT @D149375, PER @D149374, PLU @D149373, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, 
      FIN -, ARITY 2] : STRIKE, 
   [COORD @D149382, AGR [COUNT @D149381, PER @D149380, PLU @D149379, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, REG -, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149386, AGR [COUNT @D149385, PER @D149384, PLU @D149383, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149390, AGR [COUNT @D149389, PER @D149388, PLU @D149387, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PRT OUT, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149392, AGR @D149391, FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP_NP, REG -, 
      PREP AS, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149394, AGR @D149393, FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_NP_AP, REG -, 
      PREP AS, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149398, AGR [COUNT @D149397, PER @D149396, PLU @D149395, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM UPON, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149402, AGR [COUNT @D149401, PER @D149400, PLU @D149399, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149406, AGR [COUNT @D149405, PER @D149404, PLU @D149403, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM FOR, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149410, 
      AGR [COUNT @D149409, PER @D149408, PLU @D149407, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149414, AGR [COUNT @D149413, PER @D149412, PLU @D149411, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149418, AGR [COUNT @D149417, PER @D149416, PLU @D149415, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149422, AGR [COUNT @D149421, PER @D149420, PLU @D149419, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : STRIKE, 
   [COORD @D149428, PAST @D149427, 
      AGR [CASE @D149426, COUNT @D149425, PER @D149424, PLU @D149423, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : STRIKE, 
   [COORD @D149434, PAST @D149433, AGR [CASE @D149432, COUNT @D149431, 
            PER @D149430, PLU @D149429, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : STRIKE, 
   [COORD @D149440, PAST @D149439, 
      AGR [CASE @D149438, COUNT @D149437, PER @D149436, PLU @D149435, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : STRIKE, 
   [COORD @D149446, PAST @D149445, AGR [CASE @D149444, COUNT @D149443, 
            PER @D149442, PLU @D149441, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : STRIKE, 
   [COORD @D149452, PAST @D149451, 
      AGR [CASE @D149450, COUNT @D149449, PER @D149448, PLU @D149447, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT DOWN, 
      FIN -, ARITY 1] : STRIKE, 
   [COORD @D149456, AGR [COUNT @D149455, PER @D149454, PLU @D149453, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : STRIKE, 
   [COORD @D149460, AGR [COUNT @D149459, PER @D149458, PLU @D149457, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : STRIKE, 
   [COORD @D149464, 
      AGR [COUNT @D149463, PER @D149462, PLU @D149461, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : STRIKE, 
   [COORD @D149468, AGR [COUNT @D149467, PER @D149466, PLU @D149465, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : STRIKE, 
   [COORD @D149472, 
      AGR [COUNT @D149471, PER @D149470, PLU @D149469, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, PAST +, ARITY 1] : STRIKE.

WORD stuck : 
   [COADV @D149495, COORD @D149494, DEF @D149493, PRD @D149492, 
      AGR [CASE @D149491, COUNT @D149490, PER @D149489, PLU @D149488, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : STUCK, 
   [COADV @D149503, COORD @D149502, DEF @D149501, PRD @D149500, 
      AGR [CASE @D149499, COUNT @D149498, PER @D149497, PLU @D149496, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR PRD] : STUCK, 
   [COADV @D149511, COORD @D149510, DEF @D149509, PRD @D149508, 
      AGR [CASE @D149507, COUNT @D149506, PER @D149505, PLU @D149504, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, DISTR PRD, ARITY 2] : STUCK, 
   [COADV @D149519, COORD @D149518, DEF @D149517, PRD @D149516, 
      AGR [CASE @D149515, COUNT @D149514, PER @D149513, PLU @D149512, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, DISTR PRD, ARITY 2] : STUCK, 
   [COORD @D149525, PAST @D149524, 
      AGR [CASE @D149523, COUNT @D149522, PER @D149521, PLU @D149520, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : STICK, 
   [COORD @D149531, PAST @D149530, AGR [CASE @D149529, COUNT @D149528, 
            PER @D149527, PLU @D149526, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : STICK, 
   [COORD @D149535, AGR [COUNT @D149534, PER @D149533, PLU @D149532, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : STICK, 
   [COORD @D149541, PAST @D149540, 
      AGR [CASE @D149539, COUNT @D149538, PER @D149537, PLU @D149536, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149547, PAST @D149546, AGR [CASE @D149545, COUNT @D149544, 
            PER @D149543, PLU @D149542, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : STICK, 
   [COORD @D149553, PAST @D149552, 
      AGR [CASE @D149551, COUNT @D149550, PER @D149549, PLU @D149548, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149559, PAST @D149558, AGR [CASE @D149557, COUNT @D149556, 
            PER @D149555, PLU @D149554, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, FIN -, ARITY 2] : STICK, 
   [COORD @D149565, PAST @D149564, 
      AGR [CASE @D149563, COUNT @D149562, PER @D149561, PLU @D149560, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM WITH, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149571, PAST @D149570, AGR [CASE @D149569, COUNT @D149568, 
            PER @D149567, PLU @D149566, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM WITH, FIN -, ARITY 2] : STICK, 
   [COORD @D149577, PAST @D149576, 
      AGR [CASE @D149575, COUNT @D149574, PER @D149573, PLU @D149572, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM TO, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149583, PAST @D149582, AGR [CASE @D149581, COUNT @D149580, 
            PER @D149579, PLU @D149578, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM TO, FIN -, ARITY 2] : STICK, 
   [COORD @D149589, PAST @D149588, 
      AGR [CASE @D149587, COUNT @D149586, PER @D149585, PLU @D149584, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, PFORM FOR, 
      FIN -, ARITY 2] : STICK, 
   [COORD @D149595, PAST @D149594, AGR [CASE @D149593, COUNT @D149592, 
            PER @D149591, PLU @D149590, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT UP, PFORM FOR, FIN -, ARITY 2] : STICK, 
   [COORD @D149601, PAST @D149600, 
      AGR [CASE @D149599, COUNT @D149598, PER @D149597, PLU @D149596, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, PFORM FOR, 
      FIN -, ARITY 2] : STICK, 
   [COORD @D149607, PAST @D149606, AGR [CASE @D149605, COUNT @D149604, 
            PER @D149603, PLU @D149602, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PRT OUT, PFORM FOR, FIN -, ARITY 2] : STICK, 
   [COORD @D149613, PAST @D149612, 
      AGR [CASE @D149611, COUNT @D149610, PER @D149609, PLU @D149608, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM BY, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149619, PAST @D149618, AGR [CASE @D149617, COUNT @D149616, 
            PER @D149615, PLU @D149614, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM BY, FIN -, ARITY 2] : STICK, 
   [COORD @D149625, PAST @D149624, 
      AGR [CASE @D149623, COUNT @D149622, PER @D149621, PLU @D149620, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, SUBCAT PP, SUBTYPE PVERB, 
      PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PFORM AT, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149631, PAST @D149630, AGR [CASE @D149629, COUNT @D149628, 
            PER @D149627, PLU @D149626, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, REG -, PFORM AT, FIN -, ARITY 2] : STICK, 
   [COORD @D149637, PAST @D149636, 
      AGR [CASE @D149635, COUNT @D149634, PER @D149633, PLU @D149632, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149643, PAST @D149642, AGR [CASE @D149641, COUNT @D149640, 
            PER @D149639, PLU @D149638, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : STICK, 
   [COORD @D149649, PAST @D149648, 
      AGR [CASE @D149647, COUNT @D149646, PER @D149645, PLU @D149644, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : STICK, 
   [COORD @D149655, PAST @D149654, AGR [CASE @D149653, COUNT @D149652, 
            PER @D149651, PLU @D149650, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : STICK, 
   [COORD @D149659, 
      AGR [COUNT @D149658, PER @D149657, PLU @D149656, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PAST +, 
      ARITY 2] : STICK, 
   [COORD @D149663, AGR [COUNT @D149662, PER @D149661, PLU @D149660, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : STICK, 
   [COORD @D149667, AGR [COUNT @D149666, PER @D149665, PLU @D149664, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PAST +, ARITY 2] : STICK, 
   [COORD @D149671, AGR [COUNT @D149670, PER @D149669, PLU @D149668, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM WITH, PAST +, ARITY 2] : STICK, 
   [COORD @D149675, AGR [COUNT @D149674, PER @D149673, PLU @D149672, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM TO, PAST +, ARITY 2] : STICK, 
   [COORD @D149679, AGR [COUNT @D149678, PER @D149677, PLU @D149676, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PRT UP, PFORM FOR, PAST +, ARITY 2] : STICK, 
   [COORD @D149683, 
      AGR [COUNT @D149682, PER @D149681, PLU @D149680, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT OUT, 
      PFORM FOR, PAST +, ARITY 2] : STICK, 
   [COORD @D149687, AGR [COUNT @D149686, PER @D149685, PLU @D149684, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM BY, PAST +, ARITY 2] : STICK, 
   [COORD @D149691, AGR [COUNT @D149690, PER @D149689, PLU @D149688, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AT, PAST +, ARITY 2] : STICK, 
   [COORD @D149695, AGR [COUNT @D149694, PER @D149693, PLU @D149692, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : STICK, 
   [COORD @D149699, AGR [COUNT @D149698, PER @D149697, PLU @D149696, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : STICK, 
   [COORD @D149705, PAST @D149704, 
      AGR [CASE @D149703, COUNT @D149702, PER @D149701, PLU @D149700, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : STICK, 
   [COORD @D149711, PAST @D149710, AGR [CASE @D149709, COUNT @D149708, 
            PER @D149707, PLU @D149706, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : STICK, 
   [COORD @D149717, PAST @D149716, 
      AGR [CASE @D149715, COUNT @D149714, PER @D149713, PLU @D149712, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT TOGETHER, 
      FIN -, ARITY 1] : STICK, 
   [COORD @D149723, PAST @D149722, AGR [CASE @D149721, COUNT @D149720, 
            PER @D149719, PLU @D149718, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, FIN -, ARITY 1] : STICK, 
   [COORD @D149729, PAST @D149728, 
      AGR [CASE @D149727, COUNT @D149726, PER @D149725, PLU @D149724, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT AROUND, 
      FIN -, ARITY 1] : STICK, 
   [COORD @D149733, AGR [COUNT @D149732, PER @D149731, PLU @D149730, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : STICK, 
   [COORD @D149737, AGR [COUNT @D149736, PER @D149735, PLU @D149734, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : STICK, 
   [COORD @D149741, 
      AGR [COUNT @D149740, PER @D149739, PLU @D149738, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT TOGETHER, PAST +, ARITY 1] : STICK, 
   [COORD @D149745, AGR [COUNT @D149744, PER @D149743, PLU @D149742, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, PAST +, ARITY 1] : STICK, 
   [COORD @D149749, 
      AGR [COUNT @D149748, PER @D149747, PLU @D149746, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AROUND, PAST +, ARITY 1] : STICK.

WORD studied : 
   [COADV @D149779, COORD @D149778, DEF @D149777, PRD @D149776, 
      AGR [CASE @D149775, COUNT @D149774, PER @D149773, PLU @D149772, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : STUDIED, 
   [COORD @D149784, AGR [CASE @D149783, COUNT @D149782, PER @D149781, 
            PLU @D149780, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : STUDY, 
   [COORD @D149789, AGR [CASE @D149788, COUNT @D149787, PER @D149786, 
            PLU @D149785, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STUDY, 
   [COORD @D149794, AGR [CASE @D149793, COUNT @D149792, PER @D149791, 
            PLU @D149790, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STUDY, 
   [COORD @D149799, AGR [CASE @D149798, COUNT @D149797, PER @D149796, 
            PLU @D149795, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : STUDY, 
   [COORD @D149804, AGR [CASE @D149803, COUNT @D149802, PER @D149801, 
            PLU @D149800, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : STUDY.

WORD studies : 
   [COORD @D149811, AGR [COUNT @D149810, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STUDY, 
   [COORD @D149813, 
      AGR [COUNT @D149812, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : STUDY.

WORD study : 
   [COORD @D149820, AGR [COUNT @D149819, PER @D149818, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STUDY, 
   [COORD @D149822, AGR [COUNT @D149821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STUDY, 
   [COORD @D149824, AGR [COUNT @D149823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : STUDY, 
   [COORD @D149828, AGR [COUNT @D149827, PER @D149826, PLU @D149825, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : STUDY, 
   [COORD @D149834, PAST @D149833, AGR [CASE @D149832, COUNT @D149831, 
            PER @D149830, PLU @D149829, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : STUDY, 
   [COORD @D149837, AGR [COUNT @D149836, PER @D149835, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STUDY, 
   [COORD @D149839, AGR [COUNT @D149838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STUDY, 
   [COORD @D149841, AGR [COUNT @D149840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STUDY, 
   [COORD @D149845, AGR [COUNT @D149844, PER @D149843, PLU @D149842, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : STUDY, 
   [COORD @D149851, PAST @D149850, AGR [CASE @D149849, COUNT @D149848, 
            PER @D149847, PLU @D149846, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : STUDY.

WORD studying : 
   [COORD @D149864, PRD @D149863, AGR [CASE @D149862, COUNT @D149861, 
            PER @D149860, PLU @D149859, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : STUDY, 
   [COORD @D149870, PRD @D149869, 
      AGR [CASE @D149868, COUNT @D149867, PER @D149866, PLU @D149865, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : STUDY.

WORD succeed : 
   [COORD @D149876, AGR [COUNT @D149875, PER @D149874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUCCEED, 
   [COORD @D149878, AGR [COUNT @D149877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUCCEED, 
   [COORD @D149880, AGR [COUNT @D149879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUCCEED, 
   [COORD @D149884, AGR [COUNT @D149883, PER @D149882, PLU @D149881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SUCCEED, 
   [COORD @D149890, PAST @D149889, AGR [CASE @D149888, COUNT @D149887, 
            PER @D149886, PLU @D149885, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SUCCEED, 
   [COORD @D149893, AGR [COUNT @D149892, PER @D149891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SUCCEED, 
   [COORD @D149895, AGR [COUNT @D149894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SUCCEED, 
   [COORD @D149897, AGR [COUNT @D149896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SUCCEED, 
   [COORD @D149901, AGR [COUNT @D149900, PER @D149899, PLU @D149898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : SUCCEED, 
   [COORD @D149907, PAST @D149906, 
      AGR [CASE @D149905, COUNT @D149904, PER @D149903, PLU @D149902, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : SUCCEED, 
   [COORD @D149910, AGR [COUNT @D149909, PER @D149908, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SUCCEED, 
   [COORD @D149912, AGR [COUNT @D149911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SUCCEED, 
   [COORD @D149914, AGR [COUNT @D149913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SUCCEED, 
   [COORD @D149918, AGR [COUNT @D149917, PER @D149916, PLU @D149915, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : SUCCEED, 
   [COORD @D149924, PAST @D149923, 
      AGR [CASE @D149922, COUNT @D149921, PER @D149920, PLU @D149919, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : SUCCEED, 
   [COORD @D149927, AGR [COUNT @D149926, PER @D149925, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUCCEED, 
   [COORD @D149929, AGR [COUNT @D149928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUCCEED, 
   [COORD @D149931, AGR [COUNT @D149930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUCCEED, 
   [COORD @D149935, AGR [COUNT @D149934, PER @D149933, PLU @D149932, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUCCEED, 
   [COORD @D149941, PAST @D149940, AGR [CASE @D149939, COUNT @D149938, 
            PER @D149937, PLU @D149936, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SUCCEED.

WORD succeeded : 
   [COORD @D149950, AGR [CASE @D149949, COUNT @D149948, PER @D149947, 
            PLU @D149946, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149955, AGR [CASE @D149954, COUNT @D149953, PER @D149952, 
            PLU @D149951, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149960, AGR [CASE @D149959, COUNT @D149958, PER @D149957, 
            PLU @D149956, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149965, AGR [CASE @D149964, COUNT @D149963, PER @D149962, 
            PLU @D149961, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149970, AGR [CASE @D149969, COUNT @D149968, PER @D149967, 
            PLU @D149966, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149975, AGR [CASE @D149974, COUNT @D149973, PER @D149972, 
            PLU @D149971, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149980, AGR [CASE @D149979, COUNT @D149978, PER @D149977, 
            PLU @D149976, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149985, AGR [CASE @D149984, COUNT @D149983, PER @D149982, 
            PLU @D149981, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D149990, AGR [CASE @D149989, COUNT @D149988, PER @D149987, 
            PLU @D149986, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUCCEED.

WORD succeeding : 
   [COORD @D150002, PRD @D150001, AGR [CASE @D150000, COUNT @D149999, 
            PER @D149998, PLU @D149997, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D150008, PRD @D150007, 
      AGR [CASE @D150006, COUNT @D150005, PER @D150004, PLU @D150003, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUCCEED, 
   [COORD @D150014, PRD @D150013, AGR [CASE @D150012, COUNT @D150011, 
            PER @D150010, PLU @D150009, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D150020, PRD @D150019, 
      AGR [CASE @D150018, COUNT @D150017, PER @D150016, PLU @D150015, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUCCEED.

WORD succeeds : 
   [COORD @D150026, AGR [COUNT @D150025, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D150028, 
      AGR [COUNT @D150027, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D150030, 
      AGR [COUNT @D150029, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUCCEED, 
   [COORD @D150032, 
      AGR [COUNT @D150031, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUCCEED.

WORD suffer : 
   [COORD @D150038, AGR [COUNT @D150037, PER @D150036, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUFFER, 
   [COORD @D150040, AGR [COUNT @D150039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUFFER, 
   [COORD @D150042, AGR [COUNT @D150041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUFFER, 
   [COORD @D150046, AGR [COUNT @D150045, PER @D150044, PLU @D150043, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUFFER, 
   [COORD @D150052, PAST @D150051, AGR 
         [CASE @D150050, COUNT @D150049, PER @D150048, PLU @D150047, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      ARITY 2] : SUFFER, 
   [COORD @D150055, AGR [COUNT @D150054, PER @D150053, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUFFER, 
   [COORD @D150057, AGR [COUNT @D150056, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUFFER, 
   [COORD @D150059, AGR [COUNT @D150058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUFFER, 
   [COORD @D150063, AGR [COUNT @D150062, PER @D150061, PLU @D150060, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SUFFER, 
   [COORD @D150069, PAST @D150068, AGR [CASE @D150067, COUNT @D150066, 
            PER @D150065, PLU @D150064, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SUFFER, 
   [COORD @D150072, AGR [COUNT @D150071, PER @D150070, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : SUFFER, 
   [COORD @D150074, AGR [COUNT @D150073, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : SUFFER, 
   [COORD @D150076, AGR [COUNT @D150075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : SUFFER, 
   [COORD @D150080, AGR [COUNT @D150079, PER @D150078, PLU @D150077, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, ARITY 2] : SUFFER, 
   [COORD @D150086, PAST @D150085, 
      AGR [CASE @D150084, COUNT @D150083, PER @D150082, PLU @D150081, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FROM, ARITY 2] : SUFFER, 
   [COORD @D150089, AGR [COUNT @D150088, PER @D150087, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SUFFER, 
   [COORD @D150091, AGR [COUNT @D150090, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SUFFER, 
   [COORD @D150093, AGR [COUNT @D150092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SUFFER, 
   [COORD @D150097, AGR [COUNT @D150096, PER @D150095, PLU @D150094, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : SUFFER, 
   [COORD @D150103, PAST @D150102, 
      AGR [CASE @D150101, COUNT @D150100, PER @D150099, PLU @D150098, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : SUFFER, 
   [COORD @D150106, AGR [COUNT @D150105, PER @D150104, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUFFER, 
   [COORD @D150108, AGR [COUNT @D150107, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUFFER, 
   [COORD @D150110, AGR [COUNT @D150109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUFFER, 
   [COORD @D150114, AGR [COUNT @D150113, PER @D150112, PLU @D150111, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUFFER, 
   [COORD @D150120, PAST @D150119, AGR [CASE @D150118, COUNT @D150117, 
            PER @D150116, PLU @D150115, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SUFFER.

WORD suffered : 
   [COORD @D150129, AGR [CASE @D150128, COUNT @D150127, PER @D150126, 
            PLU @D150125, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150134, AGR [CASE @D150133, COUNT @D150132, PER @D150131, 
            PLU @D150130, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150140, AGR [CASE @D150139, NFORM @D150138, COUNT @D150137, 
            PER @D150136, PLU @D150135, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUFFER, 
   [COORD @D150145, AGR [UB @D150144, VFORM @D150143, SUBJ @D150142, 
            FIN @D150141, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUFFER, 
   [COORD @D150150, AGR [CASE @D150149, COUNT @D150148, PER @D150147, 
            PLU @D150146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150155, AGR [CASE @D150154, COUNT @D150153, PER @D150152, 
            PLU @D150151, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150160, AGR [CASE @D150159, COUNT @D150158, PER @D150157, 
            PLU @D150156, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUFFER, 
   [COORD @D150165, AGR [CASE @D150164, COUNT @D150163, PER @D150162, 
            PLU @D150161, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150170, AGR [CASE @D150169, COUNT @D150168, PER @D150167, 
            PLU @D150166, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150175, AGR [CASE @D150174, COUNT @D150173, PER @D150172, 
            PLU @D150171, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150180, AGR [CASE @D150179, COUNT @D150178, PER @D150177, 
            PLU @D150176, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150185, AGR [CASE @D150184, COUNT @D150183, PER @D150182, 
            PLU @D150181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150190, AGR [CASE @D150189, COUNT @D150188, PER @D150187, 
            PLU @D150186, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150195, AGR [CASE @D150194, COUNT @D150193, PER @D150192, 
            PLU @D150191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUFFER.

WORD suffering : 
   [COORD @D150206, REFL @D150205, COUNT @D150204, PRD @D150203, 
      CASE @D150202, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SUFFERING, 
   [COORD @D150212, PRD @D150211, 
      AGR [CASE @D150210, COUNT @D150209, PER @D150208, PLU @D150207, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   SUFFER, 
   [COORD @D150218, PRD @D150217, AGR [CASE @D150216, COUNT @D150215, 
            PER @D150214, PLU @D150213, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150224, PRD @D150223, 
      AGR [CASE @D150222, COUNT @D150221, PER @D150220, PLU @D150219, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUFFER, 
   [COORD @D150230, PRD @D150229, AGR [CASE @D150228, COUNT @D150227, 
            PER @D150226, PLU @D150225, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150236, PRD @D150235, 
      AGR [CASE @D150234, COUNT @D150233, PER @D150232, PLU @D150231, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUFFER.

WORD sufferings : 
   [COORD @D150249, DEMON @D150248, REFL @D150247, PRD @D150246, 
      CASE @D150245, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SUFFERING.

WORD suffers : 
   [COORD @D150255, AGR [COUNT @D150254, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SUFFER, 
   [COORD @D150257, AGR [COUNT @D150256, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150259, 
      AGR [COUNT @D150258, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150261, 
      AGR [COUNT @D150260, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUFFER, 
   [COORD @D150263, 
      AGR [COUNT @D150262, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUFFER.

WORD suggest : 
   [COORD @D150269, AGR [COUNT @D150268, PER @D150267, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SUGGEST, 
   [COORD @D150271, AGR [COUNT @D150270, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SUGGEST, 
   [COORD @D150273, AGR [COUNT @D150272, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SUGGEST, 
   [COORD @D150277, AGR [COUNT @D150276, PER @D150275, PLU @D150274, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : SUGGEST, 
   [COORD @D150283, PAST @D150282, AGR [CASE @D150281, COUNT @D150280, 
            PER @D150279, PLU @D150278, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : SUGGEST, 
   [COORD @D150286, AGR [COUNT @D150285, PER @D150284, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SUGGEST, 
   [COORD @D150288, AGR [COUNT @D150287, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SUGGEST, 
   [COORD @D150290, AGR [COUNT @D150289, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : SUGGEST, 
   [COORD @D150294, AGR [COUNT @D150293, PER @D150292, PLU @D150291, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : SUGGEST, 
   [COORD @D150300, PAST @D150299, AGR [CASE @D150298, COUNT @D150297, 
            PER @D150296, PLU @D150295, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : SUGGEST, 
   [COORD @D150303, AGR [COUNT @D150302, PER @D150301, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUGGEST, 
   [COORD @D150305, AGR [COUNT @D150304, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUGGEST, 
   [COORD @D150307, AGR [COUNT @D150306, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUGGEST, 
   [COORD @D150311, AGR [COUNT @D150310, PER @D150309, PLU @D150308, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUGGEST, 
   [COORD @D150317, PAST @D150316, AGR [CASE @D150315, COUNT @D150314, 
            PER @D150313, PLU @D150312, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : SUGGEST, 
   [COORD @D150320, AGR [COUNT @D150319, PER @D150318, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : SUGGEST, 
   [COORD @D150322, AGR [COUNT @D150321, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : SUGGEST, 
   [COORD @D150324, AGR [COUNT @D150323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : SUGGEST, 
   [COORD @D150328, AGR [COUNT @D150327, PER @D150326, PLU @D150325, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : SUGGEST, 
   [COORD @D150334, PAST @D150333, AGR [CASE @D150332, COUNT @D150331, 
            PER @D150330, PLU @D150329, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : SUGGEST, 
   [COORD @D150337, AGR [COUNT @D150336, PER @D150335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUGGEST, 
   [COORD @D150339, AGR [COUNT @D150338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUGGEST, 
   [COORD @D150341, AGR [COUNT @D150340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUGGEST, 
   [COORD @D150345, AGR [COUNT @D150344, PER @D150343, PLU @D150342, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SUGGEST, 
   [COORD @D150351, PAST @D150350, AGR [CASE @D150349, COUNT @D150348, 
            PER @D150347, PLU @D150346, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SUGGEST.

WORD suggested : 
   [COORD @D150360, AGR [CASE @D150359, COUNT @D150358, PER @D150357, 
            PLU @D150356, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150365, AGR [CASE @D150364, COUNT @D150363, PER @D150362, 
            PLU @D150361, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150370, AGR [CASE @D150369, COUNT @D150368, PER @D150367, 
            PLU @D150366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150375, AGR [CASE @D150374, COUNT @D150373, PER @D150372, 
            PLU @D150371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150380, AGR [CASE @D150379, COUNT @D150378, PER @D150377, 
            PLU @D150376, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150385, AGR [CASE @D150384, COUNT @D150383, PER @D150382, 
            PLU @D150381, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150390, AGR [UB @D150389, VFORM @D150388, SUBJ @D150387, 
            FIN @D150386, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUGGEST, 
   [COORD @D150395, AGR [CASE @D150394, COUNT @D150393, PER @D150392, 
            PLU @D150391, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150400, AGR [CASE @D150399, COUNT @D150398, PER @D150397, 
            PLU @D150396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150405, AGR [CASE @D150404, COUNT @D150403, PER @D150402, 
            PLU @D150401, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150410, AGR [CASE @D150409, COUNT @D150408, PER @D150407, 
            PLU @D150406, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150415, AGR [CASE @D150414, COUNT @D150413, PER @D150412, 
            PLU @D150411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUGGEST.

WORD suggesting : 
   [COORD @D150427, PRD @D150426, AGR [CASE @D150425, COUNT @D150424, 
            PER @D150423, PLU @D150422, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150433, PRD @D150432, 
      AGR [CASE @D150431, COUNT @D150430, PER @D150429, PLU @D150428, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUGGEST, 
   [COORD @D150439, PRD @D150438, AGR [CASE @D150437, COUNT @D150436, 
            PER @D150435, PLU @D150434, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150445, PRD @D150444, 
      AGR [CASE @D150443, COUNT @D150442, PER @D150441, PLU @D150440, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUGGEST, 
   [COORD @D150451, PRD @D150450, AGR [CASE @D150449, COUNT @D150448, 
            PER @D150447, PLU @D150446, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUGGEST.

WORD suggests : 
   [COORD @D150457, AGR [COUNT @D150456, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150459, 
      AGR [COUNT @D150458, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150461, 
      AGR [COUNT @D150460, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150463, 
      AGR [COUNT @D150462, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUGGEST, 
   [COORD @D150465, 
      AGR [COUNT @D150464, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUGGEST.

WORD suit : 
   [COORD @D150472, REFL @D150471, PRD @D150470, CASE @D150469, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SUIT, 
   [COORD @D150475, 
      AGR [COUNT @D150474, PER @D150473, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : SUIT, 
   [COORD @D150477, AGR [COUNT @D150476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SUIT, 
   [COORD @D150479, AGR [COUNT @D150478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SUIT, 
   [COORD @D150483, AGR [COUNT @D150482, PER @D150481, PLU @D150480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SUIT, 
   [COORD @D150489, PAST @D150488, 
      AGR [CASE @D150487, COUNT @D150486, PER @D150485, PLU @D150484, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : SUIT, 
   [COORD @D150494, AGR [CASE @D150493, COUNT @D150492, PER @D150491, 
            PLU @D150490, BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, VFORM EN, FIN -, 
      PAST NOT, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PSVE +, PRD +, PFORM TO, ARITY 3] : SUIT, 
   [COORD @D150499, 
      AGR [CASE @D150498, COUNT @D150497, PER @D150496, PLU @D150495, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, VFORM EN, FIN -, PAST NOT, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PSVE +, PRD +, 
      PFORM FOR, ARITY 3] : SUIT, 
   [COORD @D150502, AGR @D150501, PAST @D150500, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, ARITY 2] : SUIT, 
   [COORD @D150505, AGR @D150504, PAST @D150503, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT NP_SFIN, ARITY 2] : SUIT, 
   [COORD @D150508, AGR [COUNT @D150507, PER @D150506, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUIT, 
   [COORD @D150510, AGR [COUNT @D150509, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUIT, 
   [COORD @D150512, AGR [COUNT @D150511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUIT, 
   [COORD @D150516, AGR [COUNT @D150515, PER @D150514, PLU @D150513, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SUIT, 
   [COORD @D150522, PAST @D150521, AGR [CASE @D150520, COUNT @D150519, 
            PER @D150518, PLU @D150517, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SUIT, 
   [COORD @D150525, AGR [COUNT @D150524, PER @D150523, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUIT, 
   [COORD @D150527, AGR [COUNT @D150526, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUIT, 
   [COORD @D150529, AGR [COUNT @D150528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUIT, 
   [COORD @D150533, AGR [COUNT @D150532, PER @D150531, PLU @D150530, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SUIT, 
   [COORD @D150539, PAST @D150538, AGR [CASE @D150537, COUNT @D150536, 
            PER @D150535, PLU @D150534, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SUIT.

WORD suited : 
   [COORD @D150549, AGR [CASE @D150548, COUNT @D150547, PER @D150546, 
            PLU @D150545, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150554, AGR [CASE @D150553, COUNT @D150552, PER @D150551, 
            PLU @D150550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150559, AGR [CASE @D150558, COUNT @D150557, PER @D150556, 
            PLU @D150555, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150561, AGR @D150560, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150563, AGR @D150562, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150568, AGR [CASE @D150567, COUNT @D150566, PER @D150565, 
            PLU @D150564, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, CONJ NULL, SUBTYPE EXTRAP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150570, AGR @D150569, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150572, AGR @D150571, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150577, AGR [CASE @D150576, COUNT @D150575, PER @D150574, 
            PLU @D150573, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150582, AGR [CASE @D150581, COUNT @D150580, PER @D150579, 
            PLU @D150578, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150587, AGR [CASE @D150586, COUNT @D150585, PER @D150584, 
            PLU @D150583, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUIT, 
   [COORD @D150592, AGR [CASE @D150591, COUNT @D150590, PER @D150589, 
            PLU @D150588, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150597, AGR [CASE @D150596, COUNT @D150595, PER @D150594, 
            PLU @D150593, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUIT.

WORD suiting : 
   [COORD @D150612, PRD @D150611, AGR [CASE @D150610, COUNT @D150609, 
            PER @D150608, PLU @D150607, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150615, AGR @D150614, PRD @D150613, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUIT, 
   [COORD @D150618, AGR @D150617, PRD @D150616, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150624, PRD @D150623, AGR [CASE @D150622, COUNT @D150621, 
            PER @D150620, PLU @D150619, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUIT, 
   [COORD @D150630, PRD @D150629, 
      AGR [CASE @D150628, COUNT @D150627, PER @D150626, PLU @D150625, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUIT.

WORD suits : 
   [COORD @D150640, DEMON @D150639, REFL @D150638, PRD @D150637, 
      CASE @D150636, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SUIT, 
   [COORD @D150642, AGR [COUNT @D150641, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150646, AGR [CASE @D150645, NFORM @D150644, COUNT @D150643, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQU_EXTRAP, CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SUIT, 
   [COORD @D150651, AGR [UB @D150650, VFORM @D150649, SUBJ @D150648, 
            FIN @D150647, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQU_EXTRAP, CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SUIT, 
   [COORD @D150655, AGR [CASE @D150654, NFORM @D150653, COUNT @D150652, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150660, AGR [UB @D150659, VFORM @D150658, SUBJ @D150657, 
            FIN @D150656, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SUIT, 
   [COORD @D150662, AGR [COUNT @D150661, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUIT, 
   [COORD @D150664, 
      AGR [COUNT @D150663, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUIT.

WORD supplied : 
   [COORD @D150676, AGR [CASE @D150675, COUNT @D150674, PER @D150673, 
            PLU @D150672, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150681, AGR [CASE @D150680, COUNT @D150679, PER @D150678, 
            PLU @D150677, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150686, AGR [CASE @D150685, COUNT @D150684, PER @D150683, 
            PLU @D150682, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150691, AGR [CASE @D150690, COUNT @D150689, PER @D150688, 
            PLU @D150687, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150696, AGR [CASE @D150695, COUNT @D150694, PER @D150693, 
            PLU @D150692, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150701, AGR [CASE @D150700, COUNT @D150699, PER @D150698, 
            PLU @D150697, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150706, AGR [CASE @D150705, COUNT @D150704, PER @D150703, 
            PLU @D150702, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150711, AGR [CASE @D150710, COUNT @D150709, PER @D150708, 
            PLU @D150707, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150716, AGR [CASE @D150715, COUNT @D150714, PER @D150713, 
            PLU @D150712, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUPPLY.

WORD supplies : 
   [COORD @D150728, DEMON @D150727, REFL @D150726, PRD @D150725, 
      CASE @D150724, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SUPPLY, 
   [COORD @D150733, DEMON @D150732, REFL @D150731, PRD @D150730, 
      CASE @D150729, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SUPPLY, 
   [COORD @D150738, DEMON @D150737, REFL @D150736, PRD @D150735, 
      CASE @D150734, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SUPPLY, 
   [COORD @D150742, REFL @D150741, PRD @D150740, CASE @D150739, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : SUPPLIES, 
   [COORD @D150744, 
      AGR [COUNT @D150743, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SUPPLY, 
   [COORD @D150746, AGR [COUNT @D150745, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SUPPLY, 
   [COORD @D150748, AGR [COUNT @D150747, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUPPLY.

WORD supply : 
   [COORD @D150767, REFL @D150766, PRD @D150765, CASE @D150764, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SUPPLY, 
   [COORD @D150772, REFL @D150771, COUNT @D150770, PRD @D150769, 
      CASE @D150768, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SUPPLY, 
   [COORD @D150776, REFL @D150775, PRD @D150774, CASE @D150773, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : SUPPLY, 
   [COORD @D150779, 
      AGR [COUNT @D150778, PER @D150777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : SUPPLY, 
   [COORD @D150781, AGR [COUNT @D150780, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SUPPLY, 
   [COORD @D150783, AGR [COUNT @D150782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SUPPLY, 
   [COORD @D150787, AGR [COUNT @D150786, PER @D150785, PLU @D150784, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : SUPPLY, 
   [COORD @D150793, PAST @D150792, 
      AGR [CASE @D150791, COUNT @D150790, PER @D150789, PLU @D150788, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : SUPPLY, 
   [COORD @D150796, AGR [COUNT @D150795, PER @D150794, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SUPPLY, 
   [COORD @D150798, AGR [COUNT @D150797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SUPPLY, 
   [COORD @D150800, AGR [COUNT @D150799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SUPPLY, 
   [COORD @D150804, AGR [COUNT @D150803, PER @D150802, PLU @D150801, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SUPPLY, 
   [COORD @D150810, PAST @D150809, 
      AGR [CASE @D150808, COUNT @D150807, PER @D150806, PLU @D150805, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : SUPPLY, 
   [COORD @D150813, AGR [COUNT @D150812, PER @D150811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUPPLY, 
   [COORD @D150815, AGR [COUNT @D150814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUPPLY, 
   [COORD @D150817, AGR [COUNT @D150816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUPPLY, 
   [COORD @D150821, AGR [COUNT @D150820, PER @D150819, PLU @D150818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SUPPLY, 
   [COORD @D150827, PAST @D150826, AGR [CASE @D150825, COUNT @D150824, 
            PER @D150823, PLU @D150822, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SUPPLY.

WORD supplying : 
   [COORD @D150844, PRD @D150843, AGR [CASE @D150842, COUNT @D150841, 
            PER @D150840, PLU @D150839, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150850, PRD @D150849, 
      AGR [CASE @D150848, COUNT @D150847, PER @D150846, PLU @D150845, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUPPLY, 
   [COORD @D150856, PRD @D150855, AGR [CASE @D150854, COUNT @D150853, 
            PER @D150852, PLU @D150851, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUPPLY.

WORD support : 
   [COORD @D150864, REFL @D150863, COUNT @D150862, PRD @D150861, 
      CASE @D150860, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : SUPPORT, 
   [COORD @D150867, 
      AGR [COUNT @D150866, PER @D150865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   SUPPORT, 
   [COORD @D150869, AGR [COUNT @D150868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUPPORT, 
   [COORD @D150871, AGR [COUNT @D150870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUPPORT, 
   [COORD @D150875, AGR [COUNT @D150874, PER @D150873, PLU @D150872, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SUPPORT, 
   [COORD @D150881, PAST @D150880, AGR [CASE @D150879, COUNT @D150878, 
            PER @D150877, PLU @D150876, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SUPPORT.

WORD supported : 
   [COORD @D150891, AGR [CASE @D150890, COUNT @D150889, PER @D150888, 
            PLU @D150887, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUPPORT, 
   [COORD @D150896, AGR [CASE @D150895, COUNT @D150894, PER @D150893, 
            PLU @D150892, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUPPORT, 
   [COORD @D150901, AGR [CASE @D150900, COUNT @D150899, PER @D150898, 
            PLU @D150897, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUPPORT.

WORD supporting : 
   [COORD @D150916, PRD @D150915, AGR [CASE @D150914, COUNT @D150913, 
            PER @D150912, PLU @D150911, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUPPORT.

WORD supports : 
   [COORD @D150926, DEMON @D150925, REFL @D150924, PRD @D150923, 
      CASE @D150922, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SUPPORT, 
   [COORD @D150928, AGR [COUNT @D150927, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUPPORT.

WORD survive : 
   [COORD @D150935, AGR [COUNT @D150934, PER @D150933, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SURVIVE, 
   [COORD @D150937, AGR [COUNT @D150936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SURVIVE, 
   [COORD @D150939, AGR [COUNT @D150938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SURVIVE, 
   [COORD @D150943, AGR [COUNT @D150942, PER @D150941, PLU @D150940, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SURVIVE, 
   [COORD @D150949, PAST @D150948, AGR [CASE @D150947, COUNT @D150946, 
            PER @D150945, PLU @D150944, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SURVIVE, 
   [COORD @D150952, AGR [COUNT @D150951, PER @D150950, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SURVIVE, 
   [COORD @D150954, AGR [COUNT @D150953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SURVIVE, 
   [COORD @D150956, AGR [COUNT @D150955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SURVIVE, 
   [COORD @D150960, AGR [COUNT @D150959, PER @D150958, PLU @D150957, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : SURVIVE, 
   [COORD @D150966, PAST @D150965, AGR [CASE @D150964, COUNT @D150963, 
            PER @D150962, PLU @D150961, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : SURVIVE.

WORD survived : 
   [COORD @D150976, AGR [CASE @D150975, COUNT @D150974, PER @D150973, 
            PLU @D150972, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SURVIVE, 
   [COORD @D150981, AGR [CASE @D150980, COUNT @D150979, PER @D150978, 
            PLU @D150977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SURVIVE, 
   [COORD @D150986, AGR [CASE @D150985, COUNT @D150984, PER @D150983, 
            PLU @D150982, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SURVIVE, 
   [COORD @D150991, AGR [CASE @D150990, COUNT @D150989, PER @D150988, 
            PLU @D150987, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SURVIVE, 
   [COORD @D150996, AGR [CASE @D150995, COUNT @D150994, PER @D150993, 
            PLU @D150992, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SURVIVE.

WORD survives : 
   [COORD @D151003, AGR [COUNT @D151002, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SURVIVE, 
   [COORD @D151005, 
      AGR [COUNT @D151004, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SURVIVE.

WORD surviving : 
   [COORD @D151015, PRD @D151014, AGR [CASE @D151013, COUNT @D151012, 
            PER @D151011, PLU @D151010, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SURVIVE, 
   [COORD @D151021, PRD @D151020, 
      AGR [CASE @D151019, COUNT @D151018, PER @D151017, PLU @D151016, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SURVIVE.

WORD suspect : 
   [COADV @D151032, COORD @D151031, DEF @D151030, PRD @D151029, 
      AGR [CASE @D151028, COUNT @D151027, PER @D151026, PLU @D151025, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   SUSPECT, 
   [COORD @D151036, REFL @D151035, PRD @D151034, CASE @D151033, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SUSPECT, 
   [COORD @D151039, 
      AGR [COUNT @D151038, PER @D151037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM OF, 
      ARITY 3] : SUSPECT, 
   [COORD @D151041, AGR [COUNT @D151040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : SUSPECT, 
   [COORD @D151043, AGR [COUNT @D151042, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : SUSPECT, 
   [COORD @D151047, AGR [COUNT @D151046, PER @D151045, PLU @D151044, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : SUSPECT, 
   [COORD @D151053, PAST @D151052, 
      AGR [CASE @D151051, COUNT @D151050, PER @D151049, PLU @D151048, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OF, ARITY 3] : SUSPECT, 
   [COORD @D151056, AGR [COUNT @D151055, PER @D151054, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUSPECT, 
   [COORD @D151058, AGR [COUNT @D151057, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUSPECT, 
   [COORD @D151060, AGR [COUNT @D151059, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUSPECT, 
   [COORD @D151064, AGR [COUNT @D151063, PER @D151062, PLU @D151061, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : SUSPECT, 
   [COORD @D151070, PAST @D151069, AGR [CASE @D151068, COUNT @D151067, 
            PER @D151066, PLU @D151065, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : SUSPECT, 
   [COORD @D151073, AGR [COUNT @D151072, PER @D151071, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUSPECT, 
   [COORD @D151075, AGR [COUNT @D151074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUSPECT, 
   [COORD @D151077, AGR [COUNT @D151076, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUSPECT, 
   [COORD @D151081, AGR [COUNT @D151080, PER @D151079, PLU @D151078, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : SUSPECT, 
   [COORD @D151087, PAST @D151086, 
      AGR [CASE @D151085, COUNT @D151084, PER @D151083, PLU @D151082, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      ARITY 2] : SUSPECT, 
   [COORD @D151090, AGR [COUNT @D151089, PER @D151088, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUSPECT, 
   [COORD @D151092, AGR [COUNT @D151091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUSPECT, 
   [COORD @D151094, AGR [COUNT @D151093, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SUSPECT, 
   [COORD @D151098, AGR [COUNT @D151097, PER @D151096, PLU @D151095, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SUSPECT, 
   [COORD @D151104, PAST @D151103, AGR [CASE @D151102, COUNT @D151101, 
            PER @D151100, PLU @D151099, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SUSPECT.

WORD suspected : 
   [COORD @D151115, AGR [CASE @D151114, COUNT @D151113, PER @D151112, 
            PLU @D151111, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151120, AGR [CASE @D151119, COUNT @D151118, PER @D151117, 
            PLU @D151116, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151125, AGR [CASE @D151124, COUNT @D151123, PER @D151122, 
            PLU @D151121, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151130, AGR [UB @D151129, VFORM @D151128, SUBJ @D151127, 
            FIN @D151126, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUSPECT, 
   [COORD @D151135, AGR [CASE @D151134, COUNT @D151133, PER @D151132, 
            PLU @D151131, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151140, AGR [CASE @D151139, COUNT @D151138, PER @D151137, 
            PLU @D151136, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151145, AGR [CASE @D151144, COUNT @D151143, PER @D151142, 
            PLU @D151141, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151150, AGR [CASE @D151149, COUNT @D151148, PER @D151147, 
            PLU @D151146, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151156, AGR [CASE @D151155, NFORM @D151154, COUNT @D151153, 
            PER @D151152, PLU @D151151, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151161, AGR [UB @D151160, VFORM @D151159, SUBJ @D151158, 
            FIN @D151157, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUSPECT, 
   [COORD @D151166, AGR [CASE @D151165, COUNT @D151164, PER @D151163, 
            PLU @D151162, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151171, AGR [CASE @D151170, COUNT @D151169, PER @D151168, 
            PLU @D151167, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151176, AGR [CASE @D151175, COUNT @D151174, PER @D151173, 
            PLU @D151172, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SUSPECT.

WORD suspecting : 
   [COORD @D151194, PRD @D151193, AGR [CASE @D151192, COUNT @D151191, 
            PER @D151190, PLU @D151189, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151200, PRD @D151199, 
      AGR [CASE @D151198, COUNT @D151197, PER @D151196, PLU @D151195, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : SUSPECT, 
   [COORD @D151206, PRD @D151205, AGR [CASE @D151204, COUNT @D151203, 
            PER @D151202, PLU @D151201, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151212, PRD @D151211, 
      AGR [CASE @D151210, COUNT @D151209, PER @D151208, PLU @D151207, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SUSPECT.

WORD suspects : 
   [COORD @D151223, DEMON @D151222, REFL @D151221, PRD @D151220, 
      CASE @D151219, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SUSPECT, 
   [COORD @D151225, AGR [COUNT @D151224, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SUSPECT, 
   [COORD @D151227, AGR [COUNT @D151226, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151229, 
      AGR [COUNT @D151228, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUSPECT, 
   [COORD @D151231, 
      AGR [COUNT @D151230, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SUSPECT.

WORD swept : 
   [COORD @D151240, PAST @D151239, AGR [CASE @D151238, COUNT @D151237, 
            PER @D151236, PLU @D151235, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : SWEEP, 
   [COORD @D151246, PAST @D151245, 
      AGR [CASE @D151244, COUNT @D151243, PER @D151242, PLU @D151241, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, 
      ARITY 3] : SWEEP, 
   [COORD @D151252, PAST @D151251, AGR [CASE @D151250, COUNT @D151249, 
            PER @D151248, PLU @D151247, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : SWEEP, 
   [COORD @D151258, PAST @D151257, 
      AGR [CASE @D151256, COUNT @D151255, PER @D151254, PLU @D151253, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : SWEEP, 
   [COORD @D151264, PAST @D151263, AGR [CASE @D151262, COUNT @D151261, 
            PER @D151260, PLU @D151259, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OFF, FIN -, ARITY 3] : SWEEP, 
   [COORD @D151270, PAST @D151269, 
      AGR [CASE @D151268, COUNT @D151267, PER @D151266, PLU @D151265, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OFF, 
      FIN -, ARITY 3] : SWEEP, 
   [COORD @D151274, AGR [COUNT @D151273, PER @D151272, PLU @D151271, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 3] : SWEEP, 
   [COORD @D151278, AGR [COUNT @D151277, PER @D151276, PLU @D151275, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : SWEEP, 
   [COORD @D151282, AGR [COUNT @D151281, PER @D151280, PLU @D151279, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OFF, PAST +, ARITY 3] : SWEEP, 
   [COORD @D151288, PAST @D151287, 
      AGR [CASE @D151286, COUNT @D151285, PER @D151284, PLU @D151283, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : SWEEP, 
   [COORD @D151294, PAST @D151293, AGR [CASE @D151292, COUNT @D151291, 
            PER @D151290, PLU @D151289, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : SWEEP, 
   [COORD @D151300, PAST @D151299, 
      AGR [CASE @D151298, COUNT @D151297, PER @D151296, PLU @D151295, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, FIN -, 
      ARITY 2] : SWEEP, 
   [COORD @D151304, AGR [COUNT @D151303, PER @D151302, PLU @D151301, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : SWEEP, 
   [COORD @D151308, AGR [COUNT @D151307, PER @D151306, PLU @D151305, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PAST +, ARITY 2] : SWEEP, 
   [COORD @D151314, PAST @D151313, 
      AGR [CASE @D151312, COUNT @D151311, PER @D151310, PLU @D151309, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      FIN -, ARITY 1] : SWEEP, 
   [COORD @D151318, AGR [COUNT @D151317, PER @D151316, PLU @D151315, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : SWEEP.

WORD switch : 
   [COORD @D151337, REFL @D151336, PRD @D151335, CASE @D151334, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : SWITCH, 
   [COORD @D151340, 
      AGR [COUNT @D151339, PER @D151338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : SWITCH, 
   [COORD @D151342, AGR [COUNT @D151341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SWITCH, 
   [COORD @D151344, AGR [COUNT @D151343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SWITCH, 
   [COORD @D151348, AGR [COUNT @D151347, PER @D151346, PLU @D151345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : SWITCH, 
   [COORD @D151354, PAST @D151353, 
      AGR [CASE @D151352, COUNT @D151351, PER @D151350, PLU @D151349, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : SWITCH, 
   [COORD @D151357, AGR [COUNT @D151356, PER @D151355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SWITCH, 
   [COORD @D151359, AGR [COUNT @D151358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SWITCH, 
   [COORD @D151361, AGR [COUNT @D151360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : SWITCH, 
   [COORD @D151365, AGR [COUNT @D151364, PER @D151363, PLU @D151362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : SWITCH, 
   [COORD @D151371, PAST @D151370, AGR [CASE @D151369, COUNT @D151368, 
            PER @D151367, PLU @D151366, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : SWITCH, 
   [COORD @D151374, AGR [COUNT @D151373, PER @D151372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM TO, ARITY 2] : SWITCH, 
   [COORD @D151376, AGR [COUNT @D151375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM TO, ARITY 2] : SWITCH, 
   [COORD @D151378, AGR [COUNT @D151377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM TO, ARITY 2] : SWITCH, 
   [COORD @D151382, AGR [COUNT @D151381, PER @D151380, PLU @D151379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OVER, PFORM TO, ARITY 2] : SWITCH, 
   [COORD @D151388, PAST @D151387, 
      AGR [CASE @D151386, COUNT @D151385, PER @D151384, PLU @D151383, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM TO, ARITY 2] : SWITCH, 
   [COORD @D151391, AGR [COUNT @D151390, PER @D151389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : SWITCH, 
   [COORD @D151393, AGR [COUNT @D151392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : SWITCH, 
   [COORD @D151395, AGR [COUNT @D151394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : SWITCH, 
   [COORD @D151399, AGR [COUNT @D151398, PER @D151397, PLU @D151396, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OVER, PFORM FROM, ARITY 2] : SWITCH, 
   [COORD @D151405, PAST @D151404, 
      AGR [CASE @D151403, COUNT @D151402, PER @D151401, PLU @D151400, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OVER, PFORM FROM, ARITY 2] : SWITCH, 
   [COORD @D151408, AGR [COUNT @D151407, PER @D151406, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : SWITCH, 
   [COORD @D151410, AGR [COUNT @D151409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : SWITCH, 
   [COORD @D151412, AGR [COUNT @D151411, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : SWITCH, 
   [COORD @D151416, AGR [COUNT @D151415, PER @D151414, PLU @D151413, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : SWITCH, 
   [COORD @D151422, PAST @D151421, 
      AGR [CASE @D151420, COUNT @D151419, PER @D151418, PLU @D151417, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : SWITCH, 
   [COORD @D151425, AGR [COUNT @D151424, PER @D151423, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : SWITCH, 
   [COORD @D151427, AGR [COUNT @D151426, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : SWITCH, 
   [COORD @D151429, AGR [COUNT @D151428, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : SWITCH, 
   [COORD @D151433, AGR [COUNT @D151432, PER @D151431, PLU @D151430, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : SWITCH, 
   [COORD @D151439, PAST @D151438, 
      AGR [CASE @D151437, COUNT @D151436, PER @D151435, PLU @D151434, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : SWITCH, 
   [COORD @D151442, AGR [COUNT @D151441, PER @D151440, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SWITCH, 
   [COORD @D151444, AGR [COUNT @D151443, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SWITCH, 
   [COORD @D151446, AGR [COUNT @D151445, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SWITCH, 
   [COORD @D151450, AGR [COUNT @D151449, PER @D151448, PLU @D151447, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : SWITCH, 
   [COORD @D151456, PAST @D151455, 
      AGR [CASE @D151454, COUNT @D151453, PER @D151452, PLU @D151451, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : SWITCH, 
   [COORD @D151459, AGR [COUNT @D151458, PER @D151457, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SWITCH, 
   [COORD @D151461, AGR [COUNT @D151460, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SWITCH, 
   [COORD @D151463, AGR [COUNT @D151462, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SWITCH, 
   [COORD @D151467, AGR [COUNT @D151466, PER @D151465, PLU @D151464, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : SWITCH, 
   [COORD @D151473, PAST @D151472, 
      AGR [CASE @D151471, COUNT @D151470, PER @D151469, PLU @D151468, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : SWITCH, 
   [COORD @D151476, AGR [COUNT @D151475, PER @D151474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SWITCH, 
   [COORD @D151478, AGR [COUNT @D151477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SWITCH, 
   [COORD @D151480, AGR [COUNT @D151479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SWITCH, 
   [COORD @D151484, AGR [COUNT @D151483, PER @D151482, PLU @D151481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : SWITCH, 
   [COORD @D151490, PAST @D151489, 
      AGR [CASE @D151488, COUNT @D151487, PER @D151486, PLU @D151485, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : SWITCH.

WORD switched : 
   [COORD @D151500, AGR [CASE @D151499, COUNT @D151498, PER @D151497, 
            PLU @D151496, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151505, AGR [CASE @D151504, COUNT @D151503, PER @D151502, 
            PLU @D151501, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151510, AGR [CASE @D151509, COUNT @D151508, PER @D151507, 
            PLU @D151506, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151515, AGR [CASE @D151514, COUNT @D151513, PER @D151512, 
            PLU @D151511, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SWITCH, 
   [COORD @D151520, AGR [CASE @D151519, COUNT @D151518, PER @D151517, 
            PLU @D151516, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151525, AGR [CASE @D151524, COUNT @D151523, PER @D151522, 
            PLU @D151521, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151530, AGR [CASE @D151529, COUNT @D151528, PER @D151527, 
            PLU @D151526, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151535, AGR [CASE @D151534, COUNT @D151533, PER @D151532, 
            PLU @D151531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151540, AGR [CASE @D151539, COUNT @D151538, PER @D151537, 
            PLU @D151536, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151545, 
      AGR [CASE @D151544, COUNT @D151543, PER @D151542, PLU @D151541, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151550, AGR [CASE @D151549, COUNT @D151548, PER @D151547, 
            PLU @D151546, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151555, AGR [CASE @D151554, COUNT @D151553, PER @D151552, 
            PLU @D151551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151560, AGR [CASE @D151559, COUNT @D151558, PER @D151557, 
            PLU @D151556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151565, AGR [CASE @D151564, COUNT @D151563, PER @D151562, 
            PLU @D151561, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151570, AGR [CASE @D151569, COUNT @D151568, PER @D151567, 
            PLU @D151566, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151575, AGR [CASE @D151574, COUNT @D151573, PER @D151572, 
            PLU @D151571, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151580, AGR [CASE @D151579, COUNT @D151578, PER @D151577, 
            PLU @D151576, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151585, AGR [CASE @D151584, COUNT @D151583, PER @D151582, 
            PLU @D151581, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151590, AGR [CASE @D151589, COUNT @D151588, PER @D151587, 
            PLU @D151586, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151595, AGR [CASE @D151594, COUNT @D151593, PER @D151592, 
            PLU @D151591, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151600, AGR [CASE @D151599, COUNT @D151598, PER @D151597, 
            PLU @D151596, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151605, AGR [CASE @D151604, COUNT @D151603, PER @D151602, 
            PLU @D151601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : SWITCH.

WORD switches : 
   [COORD @D151615, DEMON @D151614, REFL @D151613, PRD @D151612, 
      CASE @D151611, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   SWITCH, 
   [COORD @D151617, AGR [COUNT @D151616, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SWITCH, 
   [COORD @D151619, AGR [COUNT @D151618, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151621, 
      AGR [COUNT @D151620, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SWITCH, 
   [COORD @D151623, AGR [COUNT @D151622, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : SWITCH, 
   [COORD @D151625, AGR [COUNT @D151624, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SWITCH, 
   [COORD @D151627, AGR [COUNT @D151626, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SWITCH, 
   [COORD @D151629, AGR [COUNT @D151628, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SWITCH, 
   [COORD @D151631, AGR [COUNT @D151630, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   SWITCH, 
   [COORD @D151633, AGR [COUNT @D151632, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : SWITCH.

WORD switching : 
   [COORD @D151648, PRD @D151647, AGR [CASE @D151646, COUNT @D151645, 
            PER @D151644, PLU @D151643, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151654, PRD @D151653, 
      AGR [CASE @D151652, COUNT @D151651, PER @D151650, PLU @D151649, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SWITCH, 
   [COORD @D151660, PRD @D151659, AGR [CASE @D151658, COUNT @D151657, 
            PER @D151656, PLU @D151655, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151666, PRD @D151665, 
      AGR [CASE @D151664, COUNT @D151663, PER @D151662, PLU @D151661, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OVER, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151672, PRD @D151671, AGR [CASE @D151670, COUNT @D151669, 
            PER @D151668, PLU @D151667, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151678, PRD @D151677, 
      AGR [CASE @D151676, COUNT @D151675, PER @D151674, PLU @D151673, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : SWITCH, 
   [COORD @D151684, PRD @D151683, AGR [CASE @D151682, COUNT @D151681, 
            PER @D151680, PLU @D151679, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SWITCH, 
   [COORD @D151690, PRD @D151689, 
      AGR [CASE @D151688, COUNT @D151687, PER @D151686, PLU @D151685, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : SWITCH, 
   [COORD @D151696, PRD @D151695, AGR [CASE @D151694, COUNT @D151693, 
            PER @D151692, PLU @D151691, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : SWITCH.

WORD talk : 
   [COORD @D151708, REFL @D151707, COUNT @D151706, PRD @D151705, 
      CASE @D151704, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TALK, 
   [COORD @D151712, REFL @D151711, PRD @D151710, CASE @D151709, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, COUNT +] : TALK, 
   [COORD @D151717, REFL @D151716, COUNT @D151715, PRD @D151714, 
      CASE @D151713, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TALK, 
   [COORD @D151721, REFL @D151720, PRD @D151719, CASE @D151718, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN +, ADDRESS -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : TALK, 
   [COORD @D151725, REFL @D151724, PRD @D151723, CASE @D151722, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : TALK, 
   [COORD @D151730, REFL @D151729, COUNT @D151728, PRD @D151727, 
      CASE @D151726, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, 
      PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TALK, 
   [COORD @D151733, 
      AGR [COUNT @D151732, PER @D151731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM WITH_ABOUT, ARITY 3] : TALK, 
   [COORD @D151735, AGR [COUNT @D151734, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM WITH_ABOUT, ARITY 3] : TALK, 
   [COORD @D151737, AGR [COUNT @D151736, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM WITH_ABOUT, ARITY 3] : TALK, 
   [COORD @D151741, AGR [COUNT @D151740, PER @D151739, PLU @D151738, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP_PP, PFORM WITH_ABOUT, ARITY 3] : TALK, 
   [COORD @D151747, PAST @D151746, 
      AGR [CASE @D151745, COUNT @D151744, PER @D151743, PLU @D151742, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP_PP, 
      PFORM WITH_ABOUT, ARITY 3] : TALK, 
   [COORD @D151750, AGR [COUNT @D151749, PER @D151748, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT ROUND, PFORM TO, ARITY 3] : TALK, 
   [COORD @D151752, 
      AGR [COUNT @D151751, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PRT ROUND, 
      PFORM TO, ARITY 3] : TALK, 
   [COORD @D151754, AGR [COUNT @D151753, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT ROUND, PFORM TO, ARITY 3] : TALK, 
   [COORD @D151758, 
      AGR [COUNT @D151757, PER @D151756, PLU @D151755, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT ROUND, PFORM TO, ARITY 3] : TALK, 
   [COORD @D151764, PAST @D151763, 
      AGR [CASE @D151762, COUNT @D151761, PER @D151760, PLU @D151759, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PRT ROUND, PFORM TO, ARITY 3] : TALK, 
   [COORD @D151767, AGR [COUNT @D151766, PER @D151765, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151769, 
      AGR [COUNT @D151768, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PRT OUT, 
      PFORM OF, ARITY 3] : TALK, 
   [COORD @D151771, AGR [COUNT @D151770, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151775, 
      AGR [COUNT @D151774, PER @D151773, PLU @D151772, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151781, PAST @D151780, 
      AGR [CASE @D151779, COUNT @D151778, PER @D151777, PLU @D151776, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151784, 
      AGR [COUNT @D151783, PER @D151782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151786, AGR [COUNT @D151785, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151788, AGR 
         [COUNT @D151787, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, 
      PFORM OF, ARITY 3] : TALK, 
   [COORD @D151792, AGR [COUNT @D151791, PER @D151790, PLU @D151789, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151798, PAST @D151797, 
      AGR [CASE @D151796, COUNT @D151795, PER @D151794, PLU @D151793, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PRT OUT, PFORM OF, ARITY 3] : TALK, 
   [COORD @D151801, AGR [COUNT @D151800, PER @D151799, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151803, AGR [COUNT @D151802, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151805, AGR [COUNT @D151804, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151809, AGR [COUNT @D151808, PER @D151807, PLU @D151806, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151815, PAST @D151814, 
      AGR [CASE @D151813, COUNT @D151812, PER @D151811, PLU @D151810, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_ING, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151818, AGR [COUNT @D151817, PER @D151816, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151820, AGR [COUNT @D151819, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151822, AGR [COUNT @D151821, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151826, AGR [COUNT @D151825, PER @D151824, PLU @D151823, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151832, PAST @D151831, 
      AGR [CASE @D151830, COUNT @D151829, PER @D151828, PLU @D151827, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : TALK, 
   [COORD @D151835, AGR [COUNT @D151834, PER @D151833, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM WITH, ARITY 3] : TALK, 
   [COORD @D151837, 
      AGR [COUNT @D151836, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OVER, 
      PFORM WITH, ARITY 3] : TALK, 
   [COORD @D151839, AGR [COUNT @D151838, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM WITH, ARITY 3] : TALK, 
   [COORD @D151843, 
      AGR [COUNT @D151842, PER @D151841, PLU @D151840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM WITH, ARITY 3] : TALK, 
   [COORD @D151849, PAST @D151848, 
      AGR [CASE @D151847, COUNT @D151846, PER @D151845, PLU @D151844, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, PFORM WITH, ARITY 3] : TALK, 
   [COORD @D151852, AGR [COUNT @D151851, PER @D151850, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TALK, 
   [COORD @D151854, AGR [COUNT @D151853, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TALK, 
   [COORD @D151856, AGR [COUNT @D151855, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TALK, 
   [COORD @D151860, AGR [COUNT @D151859, PER @D151858, PLU @D151857, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TALK, 
   [COORD @D151866, PAST @D151865, AGR [CASE @D151864, COUNT @D151863, 
            PER @D151862, PLU @D151861, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TALK, 
   [COORD @D151869, AGR [COUNT @D151868, PER @D151867, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ROUND, ARITY 2] : TALK, 
   [COORD @D151871, AGR [COUNT @D151870, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ROUND, ARITY 2] : TALK, 
   [COORD @D151873, AGR [COUNT @D151872, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ROUND, ARITY 2] : TALK, 
   [COORD @D151877, AGR [COUNT @D151876, PER @D151875, PLU @D151874, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT ROUND, ARITY 2] : TALK, 
   [COORD @D151883, PAST @D151882, 
      AGR [CASE @D151881, COUNT @D151880, PER @D151879, PLU @D151878, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT ROUND, ARITY 2] : TALK, 
   [COORD @D151886, AGR [COUNT @D151885, PER @D151884, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TALK, 
   [COORD @D151888, AGR [COUNT @D151887, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TALK, 
   [COORD @D151890, AGR [COUNT @D151889, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TALK, 
   [COORD @D151894, AGR [COUNT @D151893, PER @D151892, PLU @D151891, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : TALK, 
   [COORD @D151900, PAST @D151899, 
      AGR [CASE @D151898, COUNT @D151897, PER @D151896, PLU @D151895, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TALK, 
   [COORD @D151903, AGR [COUNT @D151902, PER @D151901, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : TALK, 
   [COORD @D151905, AGR [COUNT @D151904, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : TALK, 
   [COORD @D151907, AGR [COUNT @D151906, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : TALK, 
   [COORD @D151911, AGR [COUNT @D151910, PER @D151909, PLU @D151908, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM TO, ARITY 2] : TALK, 
   [COORD @D151917, PAST @D151916, 
      AGR [CASE @D151915, COUNT @D151914, PER @D151913, PLU @D151912, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM TO, ARITY 2] : TALK, 
   [COORD @D151920, AGR [COUNT @D151919, PER @D151918, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : TALK, 
   [COORD @D151922, AGR [COUNT @D151921, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : TALK, 
   [COORD @D151924, AGR [COUNT @D151923, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : TALK, 
   [COORD @D151928, AGR [COUNT @D151927, PER @D151926, PLU @D151925, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT DOWN, PFORM TO, ARITY 2] : TALK, 
   [COORD @D151934, PAST @D151933, 
      AGR [CASE @D151932, COUNT @D151931, PER @D151930, PLU @D151929, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT DOWN, PFORM TO, ARITY 2] : TALK, 
   [COORD @D151937, AGR [COUNT @D151936, PER @D151935, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TALK, 
   [COORD @D151939, AGR [COUNT @D151938, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TALK, 
   [COORD @D151941, AGR [COUNT @D151940, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TALK, 
   [COORD @D151945, AGR [COUNT @D151944, PER @D151943, PLU @D151942, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ROUND, ARITY 2] : TALK, 
   [COORD @D151951, PAST @D151950, 
      AGR [CASE @D151949, COUNT @D151948, PER @D151947, PLU @D151946, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TALK, 
   [COORD @D151954, AGR [COUNT @D151953, PER @D151952, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : TALK, 
   [COORD @D151956, AGR [COUNT @D151955, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : TALK, 
   [COORD @D151958, AGR [COUNT @D151957, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : TALK, 
   [COORD @D151962, AGR [COUNT @D151961, PER @D151960, PLU @D151959, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : TALK, 
   [COORD @D151968, PAST @D151967, 
      AGR [CASE @D151966, COUNT @D151965, PER @D151964, PLU @D151963, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : TALK, 
   [COORD @D151971, AGR [COUNT @D151970, PER @D151969, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TALK, 
   [COORD @D151973, AGR [COUNT @D151972, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TALK, 
   [COORD @D151975, AGR [COUNT @D151974, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TALK, 
   [COORD @D151979, AGR [COUNT @D151978, PER @D151977, PLU @D151976, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : TALK, 
   [COORD @D151985, PAST @D151984, 
      AGR [CASE @D151983, COUNT @D151982, PER @D151981, PLU @D151980, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TALK, 
   [COORD @D151988, AGR [COUNT @D151987, PER @D151986, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TALK, 
   [COORD @D151990, AGR [COUNT @D151989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TALK, 
   [COORD @D151992, AGR [COUNT @D151991, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TALK, 
   [COORD @D151996, AGR [COUNT @D151995, PER @D151994, PLU @D151993, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : TALK, 
   [COORD @D152002, PAST @D152001, 
      AGR [CASE @D152000, COUNT @D151999, PER @D151998, PLU @D151997, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : TALK, 
   [COORD @D152005, AGR [COUNT @D152004, PER @D152003, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TALK, 
   [COORD @D152007, AGR [COUNT @D152006, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TALK, 
   [COORD @D152009, AGR [COUNT @D152008, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TALK, 
   [COORD @D152013, AGR [COUNT @D152012, PER @D152011, PLU @D152010, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : TALK, 
   [COORD @D152019, PAST @D152018, 
      AGR [CASE @D152017, COUNT @D152016, PER @D152015, PLU @D152014, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TALK, 
   [COORD @D152022, AGR [COUNT @D152021, PER @D152020, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TALK, 
   [COORD @D152024, AGR [COUNT @D152023, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TALK, 
   [COORD @D152026, AGR [COUNT @D152025, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TALK, 
   [COORD @D152030, AGR [COUNT @D152029, PER @D152028, PLU @D152027, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TALK, 
   [COORD @D152036, PAST @D152035, AGR [CASE @D152034, COUNT @D152033, 
            PER @D152032, PLU @D152031, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TALK, 
   [COORD @D152039, AGR [COUNT @D152038, PER @D152037, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TALK, 
   [COORD @D152041, AGR [COUNT @D152040, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TALK, 
   [COORD @D152043, AGR [COUNT @D152042, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TALK, 
   [COORD @D152047, AGR [COUNT @D152046, PER @D152045, PLU @D152044, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TALK, 
   [COORD @D152053, PAST @D152052, 
      AGR [CASE @D152051, COUNT @D152050, PER @D152049, PLU @D152048, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ROUND, ARITY 1] : TALK, 
   [COORD @D152056, AGR [COUNT @D152055, PER @D152054, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TALK, 
   [COORD @D152058, AGR [COUNT @D152057, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TALK, 
   [COORD @D152060, AGR [COUNT @D152059, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TALK, 
   [COORD @D152064, AGR [COUNT @D152063, PER @D152062, PLU @D152061, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TALK, 
   [COORD @D152070, PAST @D152069, 
      AGR [CASE @D152068, COUNT @D152067, PER @D152066, PLU @D152065, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : TALK, 
   [COORD @D152073, AGR [COUNT @D152072, PER @D152071, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TALK, 
   [COORD @D152075, AGR [COUNT @D152074, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TALK, 
   [COORD @D152077, AGR [COUNT @D152076, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TALK, 
   [COORD @D152081, AGR [COUNT @D152080, PER @D152079, PLU @D152078, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TALK, 
   [COORD @D152087, PAST @D152086, 
      AGR [CASE @D152085, COUNT @D152084, PER @D152083, PLU @D152082, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : TALK, 
   [COORD @D152090, AGR [COUNT @D152089, PER @D152088, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TALK, 
   [COORD @D152092, AGR [COUNT @D152091, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TALK, 
   [COORD @D152094, AGR [COUNT @D152093, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TALK, 
   [COORD @D152098, AGR [COUNT @D152097, PER @D152096, PLU @D152095, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TALK, 
   [COORD @D152104, PAST @D152103, 
      AGR [CASE @D152102, COUNT @D152101, PER @D152100, PLU @D152099, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : TALK.

WORD talked : 
   [COORD @D152113, AGR [CASE @D152112, COUNT @D152111, PER @D152110, 
            PLU @D152109, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM WITH_ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152118, 
      AGR [CASE @D152117, COUNT @D152116, PER @D152115, PLU @D152114, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, PFORM WITH_ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152123, AGR [CASE @D152122, COUNT @D152121, PER @D152120, 
            PLU @D152119, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT ROUND, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152128, AGR [CASE @D152127, COUNT @D152126, PER @D152125, 
            PLU @D152124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT ROUND, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152133, 
      AGR [CASE @D152132, COUNT @D152131, PER @D152130, PLU @D152129, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT ROUND, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152138, AGR [CASE @D152137, COUNT @D152136, PER @D152135, 
            PLU @D152134, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD +, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152143, 
      AGR [CASE @D152142, COUNT @D152141, PER @D152140, PLU @D152139, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152148, AGR [CASE @D152147, COUNT @D152146, PER @D152145, 
            PLU @D152144, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152153, 
      AGR [CASE @D152152, COUNT @D152151, PER @D152150, PLU @D152149, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152158, AGR [CASE @D152157, COUNT @D152156, PER @D152155, 
            PLU @D152154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152163, 
      AGR [CASE @D152162, COUNT @D152161, PER @D152160, PLU @D152159, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152168, AGR [CASE @D152167, COUNT @D152166, PER @D152165, 
            PLU @D152164, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_ING, CONJ NULL, SUBTYPE PVERB_OE, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152173, AGR [CASE @D152172, COUNT @D152171, PER @D152170, 
            PLU @D152169, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152178, 
      AGR [CASE @D152177, COUNT @D152176, PER @D152175, PLU @D152174, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152183, AGR [CASE @D152182, COUNT @D152181, PER @D152180, 
            PLU @D152179, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152188, AGR [CASE @D152187, COUNT @D152186, PER @D152185, 
            PLU @D152184, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152193, AGR [CASE @D152192, COUNT @D152191, PER @D152190, 
            PLU @D152189, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152198, AGR [CASE @D152197, COUNT @D152196, PER @D152195, 
            PLU @D152194, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152203, AGR [CASE @D152202, COUNT @D152201, PER @D152200, 
            PLU @D152199, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152208, 
      AGR [CASE @D152207, COUNT @D152206, PER @D152205, PLU @D152204, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152213, AGR [CASE @D152212, COUNT @D152211, PER @D152210, 
            PLU @D152209, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152218, AGR [CASE @D152217, COUNT @D152216, PER @D152215, 
            PLU @D152214, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152223, AGR [CASE @D152222, COUNT @D152221, PER @D152220, 
            PLU @D152219, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152228, AGR [CASE @D152227, COUNT @D152226, PER @D152225, 
            PLU @D152224, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152233, AGR [CASE @D152232, COUNT @D152231, PER @D152230, 
            PLU @D152229, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152238, AGR [CASE @D152237, COUNT @D152236, PER @D152235, 
            PLU @D152234, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152243, AGR [CASE @D152242, COUNT @D152241, PER @D152240, 
            PLU @D152239, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152248, AGR [CASE @D152247, COUNT @D152246, PER @D152245, 
            PLU @D152244, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152253, AGR [CASE @D152252, COUNT @D152251, PER @D152250, 
            PLU @D152249, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152258, AGR [CASE @D152257, COUNT @D152256, PER @D152255, 
            PLU @D152254, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152263, AGR [CASE @D152262, COUNT @D152261, PER @D152260, 
            PLU @D152259, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT DOWN, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152268, AGR [CASE @D152267, COUNT @D152266, PER @D152265, 
            PLU @D152264, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152273, 
      AGR [CASE @D152272, COUNT @D152271, PER @D152270, PLU @D152269, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152278, AGR [CASE @D152277, COUNT @D152276, PER @D152275, 
            PLU @D152274, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152283, AGR [CASE @D152282, COUNT @D152281, PER @D152280, 
            PLU @D152279, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152288, AGR [CASE @D152287, COUNT @D152286, PER @D152285, 
            PLU @D152284, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ROUND, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152293, AGR [CASE @D152292, COUNT @D152291, PER @D152290, 
            PLU @D152289, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152298, AGR [CASE @D152297, COUNT @D152296, PER @D152295, 
            PLU @D152294, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152303, AGR [CASE @D152302, COUNT @D152301, PER @D152300, 
            PLU @D152299, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152308, AGR [CASE @D152307, COUNT @D152306, PER @D152305, 
            PLU @D152304, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152313, AGR [CASE @D152312, COUNT @D152311, PER @D152310, 
            PLU @D152309, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152318, AGR [CASE @D152317, COUNT @D152316, PER @D152315, 
            PLU @D152314, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152323, AGR [CASE @D152322, COUNT @D152321, PER @D152320, 
            PLU @D152319, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152328, AGR [CASE @D152327, COUNT @D152326, PER @D152325, 
            PLU @D152324, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152333, AGR [CASE @D152332, COUNT @D152331, PER @D152330, 
            PLU @D152329, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152338, AGR [CASE @D152337, COUNT @D152336, PER @D152335, 
            PLU @D152334, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152343, AGR [CASE @D152342, COUNT @D152341, PER @D152340, 
            PLU @D152339, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152348, AGR [CASE @D152347, COUNT @D152346, PER @D152345, 
            PLU @D152344, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152353, AGR [CASE @D152352, COUNT @D152351, PER @D152350, 
            PLU @D152349, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152358, AGR [CASE @D152357, COUNT @D152356, PER @D152355, 
            PLU @D152354, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152363, AGR [CASE @D152362, COUNT @D152361, PER @D152360, 
            PLU @D152359, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152368, AGR [CASE @D152367, COUNT @D152366, PER @D152365, 
            PLU @D152364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152373, AGR [CASE @D152372, COUNT @D152371, PER @D152370, 
            PLU @D152369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152378, AGR [CASE @D152377, COUNT @D152376, PER @D152375, 
            PLU @D152374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152383, AGR [CASE @D152382, COUNT @D152381, PER @D152380, 
            PLU @D152379, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK, 
   [COORD @D152388, AGR [CASE @D152387, COUNT @D152386, PER @D152385, 
            PLU @D152384, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152393, AGR [CASE @D152392, COUNT @D152391, PER @D152390, 
            PLU @D152389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TALK.

WORD talking : 
   [COORD @D152407, PRD @D152406, AGR [CASE @D152405, COUNT @D152404, 
            PER @D152403, PLU @D152402, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP_PP, 
      PFORM WITH_ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152413, PRD @D152412, 
      AGR [CASE @D152411, COUNT @D152410, PER @D152409, PLU @D152408, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT ROUND, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152419, PRD @D152418, 
      AGR [CASE @D152417, COUNT @D152416, PER @D152415, PLU @D152414, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152425, PRD @D152424, AGR [CASE @D152423, COUNT @D152422, 
            PER @D152421, PLU @D152420, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152431, PRD @D152430, 
      AGR [CASE @D152429, COUNT @D152428, PER @D152427, PLU @D152426, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152437, PRD @D152436, AGR [CASE @D152435, COUNT @D152434, 
            PER @D152433, PLU @D152432, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152443, PRD @D152442, 
      AGR [CASE @D152441, COUNT @D152440, PER @D152439, PLU @D152438, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152449, PRD @D152448, 
      AGR [CASE @D152447, COUNT @D152446, PER @D152445, PLU @D152444, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TALK, 
   [COORD @D152455, PRD @D152454, AGR [CASE @D152453, COUNT @D152452, 
            PER @D152451, PLU @D152450, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152461, PRD @D152460, 
      AGR [CASE @D152459, COUNT @D152458, PER @D152457, PLU @D152456, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152467, PRD @D152466, AGR [CASE @D152465, COUNT @D152464, 
            PER @D152463, PLU @D152462, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152473, PRD @D152472, 
      AGR [CASE @D152471, COUNT @D152470, PER @D152469, PLU @D152468, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152479, PRD @D152478, AGR [CASE @D152477, COUNT @D152476, 
            PER @D152475, PLU @D152474, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ROUND, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152485, PRD @D152484, 
      AGR [CASE @D152483, COUNT @D152482, PER @D152481, PLU @D152480, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152491, PRD @D152490, AGR [CASE @D152489, COUNT @D152488, 
            PER @D152487, PLU @D152486, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152497, PRD @D152496, 
      AGR [CASE @D152495, COUNT @D152494, PER @D152493, PLU @D152492, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TALK, 
   [COORD @D152503, PRD @D152502, AGR [CASE @D152501, COUNT @D152500, 
            PER @D152499, PLU @D152498, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152509, PRD @D152508, 
      AGR [CASE @D152507, COUNT @D152506, PER @D152505, PLU @D152504, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152515, PRD @D152514, AGR [CASE @D152513, COUNT @D152512, 
            PER @D152511, PLU @D152510, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152521, PRD @D152520, 
      AGR [CASE @D152519, COUNT @D152518, PER @D152517, PLU @D152516, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152527, PRD @D152526, AGR [CASE @D152525, COUNT @D152524, 
            PER @D152523, PLU @D152522, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TALK, 
   [COORD @D152533, PRD @D152532, 
      AGR [CASE @D152531, COUNT @D152530, PER @D152529, PLU @D152528, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TALK.

WORD talks : 
   [COORD @D152541, REFL @D152540, PRD @D152539, CASE @D152538, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : TALKS, 
   [COORD @D152546, DEMON @D152545, REFL @D152544, PRD @D152543, 
      CASE @D152542, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TALK, 
   [COORD @D152551, DEMON @D152550, REFL @D152549, PRD @D152548, 
      CASE @D152547, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TALK, 
   [COORD @D152556, DEMON @D152555, REFL @D152554, PRD @D152553, 
      CASE @D152552, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TALK, 
   [COORD @D152561, DEMON @D152560, REFL @D152559, PRD @D152558, 
      CASE @D152557, COMPOUND NOT, FIX NOT, PN +, ADDRESS -, ADV -, PART -, 
      CONJ NULL, SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : TALK, 
   [COORD @D152566, DEMON @D152565, REFL @D152564, PRD @D152563, 
      CASE @D152562, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TALK, 
   [COORD @D152571, DEMON @D152570, REFL @D152569, PRD @D152568, 
      CASE @D152567, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : TALK, 
   [COORD @D152573, AGR [COUNT @D152572, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP_PP, PFORM WITH_ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152575, AGR [COUNT @D152574, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PRT ROUND, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152577, AGR [COUNT @D152576, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PRT OUT, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152579, AGR [COUNT @D152578, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152581, AGR [COUNT @D152580, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_ING, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152583, AGR [COUNT @D152582, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152585, AGR [COUNT @D152584, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TALK, 
   [COORD @D152587, AGR [COUNT @D152586, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152589, 
      AGR [COUNT @D152588, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152591, 
      AGR [COUNT @D152590, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152593, 
      AGR [COUNT @D152592, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152595, 
      AGR [COUNT @D152594, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TALK, 
   [COORD @D152597, AGR [COUNT @D152596, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152599, AGR [COUNT @D152598, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152601, AGR [COUNT @D152600, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152603, AGR [COUNT @D152602, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152605, AGR [COUNT @D152604, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TALK, 
   [COORD @D152607, AGR [COUNT @D152606, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152609, 
      AGR [COUNT @D152608, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152611, 
      AGR [COUNT @D152610, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152613, 
      AGR [COUNT @D152612, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK, 
   [COORD @D152615, 
      AGR [COUNT @D152614, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TALK.

WORD target : 
   [COORD @D152631, REFL @D152630, COUNT @D152629, PRD @D152628, 
      CASE @D152627, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TARGET, 
   [COORD @D152635, REFL @D152634, PRD @D152633, CASE @D152632, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : TARGET.

WORD targets : 
   [COORD @D152643, DEMON @D152642, REFL @D152641, PRD @D152640, 
      CASE @D152639, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TARGET, 
   [COORD @D152648, DEMON @D152647, REFL @D152646, PRD @D152645, 
      CASE @D152644, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TARGET.

WORD taught : 
   [COORD @D152656, PAST @D152655, AGR [CASE @D152654, COUNT @D152653, 
            PER @D152652, PLU @D152651, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : TEACH, 
   [COORD @D152662, PAST @D152661, 
      AGR [CASE @D152660, COUNT @D152659, PER @D152658, PLU @D152657, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, 
      ARITY 3] : TEACH, 
   [COORD @D152668, PAST @D152667, AGR [CASE @D152666, COUNT @D152665, 
            PER @D152664, PLU @D152663, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHVP, REG -, FIN -, ARITY 3] : TEACH, 
   [COORD @D152674, PAST @D152673, 
      AGR [CASE @D152672, COUNT @D152671, PER @D152670, PLU @D152669, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, REG -, FIN -, 
      ARITY 3] : TEACH, 
   [COORD @D152680, PAST @D152679, AGR [CASE @D152678, COUNT @D152677, 
            PER @D152676, PLU @D152675, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHS, REG -, FIN -, ARITY 3] : TEACH, 
   [COORD @D152686, PAST @D152685, 
      AGR [CASE @D152684, COUNT @D152683, PER @D152682, PLU @D152681, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, REG -, FIN -, 
      ARITY 3] : TEACH, 
   [COORD @D152692, PAST @D152691, AGR [CASE @D152690, COUNT @D152689, 
            PER @D152688, PLU @D152687, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, FIN -, ARITY 3] : TEACH, 
   [COORD @D152698, PAST @D152697, 
      AGR [CASE @D152696, COUNT @D152695, PER @D152694, PLU @D152693, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, REG -, FIN -, 
      ARITY 3] : TEACH, 
   [COORD @D152704, PAST @D152703, AGR [CASE @D152702, COUNT @D152701, 
            PER @D152700, PLU @D152699, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : TEACH, 
   [COORD @D152710, PAST @D152709, 
      AGR [CASE @D152708, COUNT @D152707, PER @D152706, PLU @D152705, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : TEACH, 
   [COORD @D152716, PAST @D152715, AGR [CASE @D152714, COUNT @D152713, 
            PER @D152712, PLU @D152711, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : TEACH, 
   [COORD @D152722, PAST @D152721, 
      AGR [CASE @D152720, COUNT @D152719, PER @D152718, PLU @D152717, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : TEACH, 
   [COORD @D152726, AGR [COUNT @D152725, PER @D152724, PLU @D152723, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PAST +, ARITY 3] : TEACH, 
   [COORD @D152730, AGR [COUNT @D152729, PER @D152728, PLU @D152727, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHVP, REG -, PAST +, ARITY 3] : TEACH, 
   [COORD @D152734, AGR [COUNT @D152733, PER @D152732, PLU @D152731, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHS, REG -, PAST +, ARITY 3] : TEACH, 
   [COORD @D152738, AGR [COUNT @D152737, PER @D152736, PLU @D152735, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, PAST +, ARITY 3] : TEACH, 
   [COORD @D152742, AGR [COUNT @D152741, PER @D152740, PLU @D152739, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : TEACH, 
   [COORD @D152746, AGR [COUNT @D152745, PER @D152744, PLU @D152743, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, PAST +, ARITY 3] : TEACH, 
   [COORD @D152752, PAST @D152751, 
      AGR [CASE @D152750, COUNT @D152749, PER @D152748, PLU @D152747, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, 
      ARITY 2] : TEACH, 
   [COORD @D152758, PAST @D152757, AGR [CASE @D152756, COUNT @D152755, 
            PER @D152754, PLU @D152753, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : TEACH, 
   [COORD @D152764, PAST @D152763, 
      AGR [CASE @D152762, COUNT @D152761, PER @D152760, PLU @D152759, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : TEACH, 
   [COORD @D152768, AGR [COUNT @D152767, PER @D152766, PLU @D152765, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PAST +, ARITY 2] : TEACH, 
   [COORD @D152772, AGR [COUNT @D152771, PER @D152770, PLU @D152769, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : TEACH, 
   [COORD @D152778, PAST @D152777, 
      AGR [CASE @D152776, COUNT @D152775, PER @D152774, PLU @D152773, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : TEACH, 
   [COORD @D152782, AGR [COUNT @D152781, PER @D152780, PLU @D152779, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : TEACH.

WORD teach : 
   [COORD @D152796, AGR [COUNT @D152795, PER @D152794, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152798, AGR [COUNT @D152797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152800, AGR [COUNT @D152799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152804, AGR [COUNT @D152803, PER @D152802, PLU @D152801, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, ARITY 3] : TEACH, 
   [COORD @D152810, PAST @D152809, 
      AGR [CASE @D152808, COUNT @D152807, PER @D152806, PLU @D152805, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152813, AGR [COUNT @D152812, PER @D152811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152815, AGR [COUNT @D152814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152817, AGR [COUNT @D152816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152821, AGR [COUNT @D152820, PER @D152819, PLU @D152818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHVP, REG -, ARITY 3] : TEACH, 
   [COORD @D152827, PAST @D152826, 
      AGR [CASE @D152825, COUNT @D152824, PER @D152823, PLU @D152822, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, REG -, 
      ARITY 3] : TEACH, 
   [COORD @D152830, AGR [COUNT @D152829, PER @D152828, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152832, AGR [COUNT @D152831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152834, AGR [COUNT @D152833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152838, AGR [COUNT @D152837, PER @D152836, PLU @D152835, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHS, REG -, ARITY 3] : TEACH, 
   [COORD @D152844, PAST @D152843, 
      AGR [CASE @D152842, COUNT @D152841, PER @D152840, PLU @D152839, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, REG -, 
      ARITY 3] : TEACH, 
   [COORD @D152847, AGR [COUNT @D152846, PER @D152845, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152849, AGR [COUNT @D152848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152851, AGR [COUNT @D152850, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152855, AGR [COUNT @D152854, PER @D152853, PLU @D152852, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, ARITY 3] : TEACH, 
   [COORD @D152861, PAST @D152860, 
      AGR [CASE @D152859, COUNT @D152858, PER @D152857, PLU @D152856, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, REG -, 
      ARITY 3] : TEACH, 
   [COORD @D152864, AGR [COUNT @D152863, PER @D152862, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152866, AGR [COUNT @D152865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152868, AGR [COUNT @D152867, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : TEACH, 
   [COORD @D152872, AGR [COUNT @D152871, PER @D152870, PLU @D152869, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : TEACH, 
   [COORD @D152878, PAST @D152877, 
      AGR [CASE @D152876, COUNT @D152875, PER @D152874, PLU @D152873, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : TEACH, 
   [COORD @D152881, AGR [COUNT @D152880, PER @D152879, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : TEACH, 
   [COORD @D152883, AGR [COUNT @D152882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : TEACH, 
   [COORD @D152885, AGR [COUNT @D152884, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : TEACH, 
   [COORD @D152889, AGR [COUNT @D152888, PER @D152887, PLU @D152886, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : TEACH, 
   [COORD @D152895, PAST @D152894, 
      AGR [CASE @D152893, COUNT @D152892, PER @D152891, PLU @D152890, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : TEACH, 
   [COORD @D152898, AGR [COUNT @D152897, PER @D152896, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : TEACH, 
   [COORD @D152900, AGR [COUNT @D152899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : TEACH, 
   [COORD @D152902, AGR [COUNT @D152901, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : TEACH, 
   [COORD @D152906, AGR [COUNT @D152905, PER @D152904, PLU @D152903, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : TEACH, 
   [COORD @D152912, PAST @D152911, 
      AGR [CASE @D152910, COUNT @D152909, PER @D152908, PLU @D152907, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : TEACH, 
   [COORD @D152915, AGR [COUNT @D152914, PER @D152913, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : TEACH, 
   [COORD @D152917, AGR [COUNT @D152916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : TEACH, 
   [COORD @D152919, AGR [COUNT @D152918, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : TEACH, 
   [COORD @D152923, AGR [COUNT @D152922, PER @D152921, PLU @D152920, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : TEACH, 
   [COORD @D152929, PAST @D152928, AGR [CASE @D152927, COUNT @D152926, 
            PER @D152925, PLU @D152924, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : TEACH, 
   [COORD @D152932, AGR 
         [COUNT @D152931, PER @D152930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   TEACH, 
   [COORD @D152934, AGR [COUNT @D152933, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : TEACH, 
   [COORD @D152936, AGR [COUNT @D152935, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : TEACH, 
   [COORD @D152940, AGR [COUNT @D152939, PER @D152938, PLU @D152937, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : TEACH, 
   [COORD @D152946, PAST @D152945, 
      AGR [CASE @D152944, COUNT @D152943, PER @D152942, PLU @D152941, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : TEACH.

WORD teaching : 
   [COORD @D152959, REFL @D152958, COUNT @D152957, PRD @D152956, 
      CASE @D152955, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TEACHING, 
   [COORD @D152965, PRD @D152964, 
      AGR [CASE @D152963, COUNT @D152962, PER @D152961, PLU @D152960, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   TEACH, 
   [COORD @D152971, PRD @D152970, AGR [CASE @D152969, COUNT @D152968, 
            PER @D152967, PLU @D152966, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TEACH, 
   [COORD @D152977, PRD @D152976, 
      AGR [CASE @D152975, COUNT @D152974, PER @D152973, PLU @D152972, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TEACH, 
   [COORD @D152983, PRD @D152982, AGR [CASE @D152981, COUNT @D152980, 
            PER @D152979, PLU @D152978, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TEACH, 
   [COORD @D152989, PRD @D152988, 
      AGR [CASE @D152987, COUNT @D152986, PER @D152985, PLU @D152984, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TEACH, 
   [COORD @D152995, PRD @D152994, AGR [CASE @D152993, COUNT @D152992, 
            PER @D152991, PLU @D152990, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TEACH, 
   [COORD @D153001, PRD @D153000, 
      AGR [CASE @D152999, COUNT @D152998, PER @D152997, PLU @D152996, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TEACH, 
   [COORD @D153007, PRD @D153006, AGR [CASE @D153005, COUNT @D153004, 
            PER @D153003, PLU @D153002, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TEACH, 
   [COORD @D153013, PRD @D153012, 
      AGR [CASE @D153011, COUNT @D153010, PER @D153009, PLU @D153008, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TEACH.

WORD teachings : 
   [COORD @D153025, DEMON @D153024, REFL @D153023, PRD @D153022, 
      CASE @D153021, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TEACHING.

WORD telephone : 
   [COORD @D153037, REFL @D153036, COUNT @D153035, PRD @D153034, 
      CASE @D153033, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TELEPHONE, 
   [COORD @D153040, 
      AGR [COUNT @D153039, PER @D153038, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : TELEPHONE, 
   [COORD @D153042, AGR [COUNT @D153041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TELEPHONE, 
   [COORD @D153044, AGR [COUNT @D153043, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TELEPHONE, 
   [COORD @D153048, AGR [COUNT @D153047, PER @D153046, PLU @D153045, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TELEPHONE, 
   [COORD @D153054, PAST @D153053, 
      AGR [CASE @D153052, COUNT @D153051, PER @D153050, PLU @D153049, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : TELEPHONE, 
   [COORD @D153057, AGR [COUNT @D153056, PER @D153055, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TELEPHONE, 
   [COORD @D153059, AGR [COUNT @D153058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TELEPHONE, 
   [COORD @D153061, AGR [COUNT @D153060, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TELEPHONE, 
   [COORD @D153065, AGR [COUNT @D153064, PER @D153063, PLU @D153062, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TELEPHONE, 
   [COORD @D153071, PAST @D153070, 
      AGR [CASE @D153069, COUNT @D153068, PER @D153067, PLU @D153066, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      ARITY 3] : TELEPHONE, 
   [COORD @D153074, AGR [COUNT @D153073, PER @D153072, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TELEPHONE, 
   [COORD @D153076, AGR [COUNT @D153075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TELEPHONE, 
   [COORD @D153078, AGR [COUNT @D153077, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TELEPHONE, 
   [COORD @D153082, AGR [COUNT @D153081, PER @D153080, PLU @D153079, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TELEPHONE, 
   [COORD @D153088, PAST @D153087, 
      AGR [CASE @D153086, COUNT @D153085, PER @D153084, PLU @D153083, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : TELEPHONE, 
   [COORD @D153091, AGR [COUNT @D153090, PER @D153089, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TELEPHONE, 
   [COORD @D153093, AGR [COUNT @D153092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TELEPHONE, 
   [COORD @D153095, AGR [COUNT @D153094, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TELEPHONE, 
   [COORD @D153099, AGR [COUNT @D153098, PER @D153097, PLU @D153096, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TELEPHONE, 
   [COORD @D153105, PAST @D153104, AGR [CASE @D153103, COUNT @D153102, 
            PER @D153101, PLU @D153100, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TELEPHONE, 
   [COORD @D153108, AGR [COUNT @D153107, PER @D153106, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TELEPHONE, 
   [COORD @D153110, AGR [COUNT @D153109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TELEPHONE, 
   [COORD @D153112, AGR [COUNT @D153111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TELEPHONE, 
   [COORD @D153116, AGR [COUNT @D153115, PER @D153114, PLU @D153113, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TELEPHONE, 
   [COORD @D153122, PAST @D153121, 
      AGR [CASE @D153120, COUNT @D153119, PER @D153118, PLU @D153117, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      ARITY 1] : TELEPHONE.

WORD telephoned : 
   [COORD @D153133, AGR [CASE @D153132, COUNT @D153131, PER @D153130, 
            PLU @D153129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153138, AGR [CASE @D153137, COUNT @D153136, PER @D153135, 
            PLU @D153134, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153144, AGR [CASE @D153143, NFORM @D153142, COUNT @D153141, 
            PER @D153140, PLU @D153139, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153149, AGR [CASE @D153148, COUNT @D153147, PER @D153146, 
            PLU @D153145, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153154, AGR [CASE @D153153, COUNT @D153152, PER @D153151, 
            PLU @D153150, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153159, AGR [CASE @D153158, COUNT @D153157, PER @D153156, 
            PLU @D153155, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153164, AGR [CASE @D153163, COUNT @D153162, PER @D153161, 
            PLU @D153160, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153169, AGR [CASE @D153168, COUNT @D153167, PER @D153166, 
            PLU @D153165, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153174, 
      AGR [CASE @D153173, COUNT @D153172, PER @D153171, PLU @D153170, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153179, AGR [CASE @D153178, COUNT @D153177, PER @D153176, 
            PLU @D153175, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153184, AGR [CASE @D153183, COUNT @D153182, PER @D153181, 
            PLU @D153180, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153189, AGR [CASE @D153188, COUNT @D153187, PER @D153186, 
            PLU @D153185, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153194, AGR [CASE @D153193, COUNT @D153192, PER @D153191, 
            PLU @D153190, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153199, AGR [CASE @D153198, COUNT @D153197, PER @D153196, 
            PLU @D153195, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TELEPHONE.

WORD telephones : 
   [COORD @D153210, DEMON @D153209, REFL @D153208, PRD @D153207, 
      CASE @D153206, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TELEPHONE, 
   [COORD @D153212, AGR [COUNT @D153211, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TELEPHONE, 
   [COORD @D153214, AGR [COUNT @D153213, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TELEPHONE, 
   [COORD @D153216, AGR [COUNT @D153215, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TELEPHONE, 
   [COORD @D153218, AGR [COUNT @D153217, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TELEPHONE, 
   [COORD @D153220, AGR [COUNT @D153219, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TELEPHONE.

WORD telephoning : 
   [COORD @D153230, PRD @D153229, AGR [CASE @D153228, COUNT @D153227, 
            PER @D153226, PLU @D153225, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153236, PRD @D153235, 
      AGR [CASE @D153234, COUNT @D153233, PER @D153232, PLU @D153231, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TELEPHONE, 
   [COORD @D153242, PRD @D153241, AGR [CASE @D153240, COUNT @D153239, 
            PER @D153238, PLU @D153237, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TELEPHONE, 
   [COORD @D153248, PRD @D153247, 
      AGR [CASE @D153246, COUNT @D153245, PER @D153244, PLU @D153243, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TELEPHONE, 
   [COORD @D153254, PRD @D153253, AGR [CASE @D153252, COUNT @D153251, 
            PER @D153250, PLU @D153249, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TELEPHONE.

WORD television : 
   [COORD @D153261, REFL @D153260, COUNT @D153259, PRD @D153258, 
      CASE @D153257, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TELEVISION.

WORD televisions : 
   [COORD @D153269, DEMON @D153268, REFL @D153267, PRD @D153266, 
      CASE @D153265, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TELEVISION.

WORD tennis : 
   [COORD @D153276, REFL @D153275, PRD @D153274, CASE @D153273, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : TENNIS.

WORD test : 
   [COORD @D153286, REFL @D153285, PRD @D153284, CASE @D153283, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TEST, 
   [COORD @D153289, 
      AGR [COUNT @D153288, PER @D153287, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : TEST, 
   [COORD @D153291, AGR [COUNT @D153290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TEST, 
   [COORD @D153293, AGR [COUNT @D153292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TEST, 
   [COORD @D153297, AGR [COUNT @D153296, PER @D153295, PLU @D153294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TEST, 
   [COORD @D153303, PAST @D153302, 
      AGR [CASE @D153301, COUNT @D153300, PER @D153299, PLU @D153298, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : TEST, 
   [COORD @D153306, AGR [COUNT @D153305, PER @D153304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TEST, 
   [COORD @D153308, AGR [COUNT @D153307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TEST, 
   [COORD @D153310, AGR [COUNT @D153309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TEST, 
   [COORD @D153314, AGR [COUNT @D153313, PER @D153312, PLU @D153311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TEST, 
   [COORD @D153320, PAST @D153319, AGR [CASE @D153318, COUNT @D153317, 
            PER @D153316, PLU @D153315, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TEST, 
   [COORD @D153323, AGR [COUNT @D153322, PER @D153321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TEST, 
   [COORD @D153325, AGR [COUNT @D153324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TEST, 
   [COORD @D153327, AGR [COUNT @D153326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TEST, 
   [COORD @D153331, AGR [COUNT @D153330, PER @D153329, PLU @D153328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : TEST, 
   [COORD @D153337, PAST @D153336, 
      AGR [CASE @D153335, COUNT @D153334, PER @D153333, PLU @D153332, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TEST, 
   [COORD @D153340, AGR [COUNT @D153339, PER @D153338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TEST, 
   [COORD @D153342, AGR [COUNT @D153341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TEST, 
   [COORD @D153344, AGR [COUNT @D153343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TEST, 
   [COORD @D153348, AGR [COUNT @D153347, PER @D153346, PLU @D153345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TEST, 
   [COORD @D153354, PAST @D153353, AGR [CASE @D153352, COUNT @D153351, 
            PER @D153350, PLU @D153349, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TEST.

WORD tested : 
   [COORD @D153363, AGR [CASE @D153362, COUNT @D153361, PER @D153360, 
            PLU @D153359, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TEST, 
   [COORD @D153368, AGR [CASE @D153367, COUNT @D153366, PER @D153365, 
            PLU @D153364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TEST, 
   [COORD @D153373, AGR [CASE @D153372, COUNT @D153371, PER @D153370, 
            PLU @D153369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TEST, 
   [COORD @D153378, AGR [CASE @D153377, COUNT @D153376, PER @D153375, 
            PLU @D153374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TEST, 
   [COORD @D153383, AGR [CASE @D153382, COUNT @D153381, PER @D153380, 
            PLU @D153379, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TEST, 
   [COORD @D153388, AGR [CASE @D153387, COUNT @D153386, PER @D153385, 
            PLU @D153384, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TEST, 
   [COORD @D153393, AGR [CASE @D153392, COUNT @D153391, PER @D153390, 
            PLU @D153389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TEST, 
   [COORD @D153398, AGR [CASE @D153397, COUNT @D153396, PER @D153395, 
            PLU @D153394, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TEST, 
   [COORD @D153403, AGR [CASE @D153402, COUNT @D153401, PER @D153400, 
            PLU @D153399, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TEST, 
   [COORD @D153408, AGR [CASE @D153407, COUNT @D153406, PER @D153405, 
            PLU @D153404, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TEST.

WORD testing : 
   [COORD @D153422, PRD @D153421, AGR [CASE @D153420, COUNT @D153419, 
            PER @D153418, PLU @D153417, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TEST, 
   [COORD @D153428, PRD @D153427, 
      AGR [CASE @D153426, COUNT @D153425, PER @D153424, PLU @D153423, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TEST, 
   [COORD @D153434, PRD @D153433, AGR [CASE @D153432, COUNT @D153431, 
            PER @D153430, PLU @D153429, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TEST, 
   [COORD @D153440, PRD @D153439, 
      AGR [CASE @D153438, COUNT @D153437, PER @D153436, PLU @D153435, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TEST.

WORD tests : 
   [COORD @D153449, DEMON @D153448, REFL @D153447, PRD @D153446, 
      CASE @D153445, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TEST, 
   [COORD @D153451, AGR [COUNT @D153450, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TEST, 
   [COORD @D153453, AGR [COUNT @D153452, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TEST, 
   [COORD @D153455, 
      AGR [COUNT @D153454, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TEST, 
   [COORD @D153457, 
      AGR [COUNT @D153456, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TEST.

WORD thank : 
   [COORD @D153464, AGR [COUNT @D153463, PER @D153462, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : THANK, 
   [COORD @D153466, AGR [COUNT @D153465, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : THANK, 
   [COORD @D153468, AGR [COUNT @D153467, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : THANK, 
   [COORD @D153472, AGR [COUNT @D153471, PER @D153470, PLU @D153469, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : THANK, 
   [COORD @D153478, PAST @D153477, AGR [CASE @D153476, COUNT @D153475, 
            PER @D153474, PLU @D153473, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : THANK, 
   [COORD @D153481, AGR [COUNT @D153480, PER @D153479, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : THANK, 
   [COORD @D153483, AGR [COUNT @D153482, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : THANK, 
   [COORD @D153485, AGR [COUNT @D153484, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : THANK, 
   [COORD @D153489, AGR [COUNT @D153488, PER @D153487, PLU @D153486, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : THANK, 
   [COORD @D153495, PAST @D153494, 
      AGR [CASE @D153493, COUNT @D153492, PER @D153491, PLU @D153490, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : THANK, 
   [COORD @D153498, AGR [COUNT @D153497, PER @D153496, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : THANK, 
   [COORD @D153500, AGR [COUNT @D153499, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : THANK, 
   [COORD @D153502, AGR [COUNT @D153501, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : THANK, 
   [COORD @D153506, AGR [COUNT @D153505, PER @D153504, PLU @D153503, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : THANK, 
   [COORD @D153512, PAST @D153511, AGR [CASE @D153510, COUNT @D153509, 
            PER @D153508, PLU @D153507, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : THANK.

WORD thanked : 
   [COORD @D153522, AGR [CASE @D153521, COUNT @D153520, PER @D153519, 
            PLU @D153518, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : THANK, 
   [COORD @D153527, AGR [CASE @D153526, COUNT @D153525, PER @D153524, 
            PLU @D153523, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : THANK, 
   [COORD @D153533, AGR [CASE @D153532, NFORM @D153531, COUNT @D153530, 
            PER @D153529, PLU @D153528, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : THANK, 
   [COORD @D153538, AGR [CASE @D153537, COUNT @D153536, PER @D153535, 
            PLU @D153534, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THANK, 
   [COORD @D153543, AGR [CASE @D153542, COUNT @D153541, PER @D153540, 
            PLU @D153539, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : THANK, 
   [COORD @D153548, AGR [CASE @D153547, COUNT @D153546, PER @D153545, 
            PLU @D153544, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : THANK, 
   [COORD @D153553, AGR [CASE @D153552, COUNT @D153551, PER @D153550, 
            PLU @D153549, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : THANK, 
   [COORD @D153558, AGR [CASE @D153557, COUNT @D153556, PER @D153555, 
            PLU @D153554, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : THANK, 
   [COORD @D153563, AGR [CASE @D153562, COUNT @D153561, PER @D153560, 
            PLU @D153559, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : THANK.

WORD thanking : 
   [COORD @D153576, PRD @D153575, AGR [CASE @D153574, COUNT @D153573, 
            PER @D153572, PLU @D153571, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THANK, 
   [COORD @D153582, PRD @D153581, 
      AGR [CASE @D153580, COUNT @D153579, PER @D153578, PLU @D153577, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : THANK, 
   [COORD @D153588, PRD @D153587, AGR [CASE @D153586, COUNT @D153585, 
            PER @D153584, PLU @D153583, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THANK.

WORD thanks : 
   [COORD @D153597, REFL @D153596, PRD @D153595, CASE @D153594, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : THANKS, 
   [COORD @D153599, 
      AGR [COUNT @D153598, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THANK, 
   [COORD @D153601, 
      AGR [COUNT @D153600, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THANK, 
   [COORD @D153603, 
      AGR [COUNT @D153602, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THANK.

WORD think : 
   [COORD @D153618, REFL @D153617, PRD @D153616, CASE @D153615, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, COUNT +] : THINK, 
   [COORD @D153622, REFL @D153621, PRD @D153620, CASE @D153619, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : THINK, 
   [COORD @D153625, 
      AGR [COUNT @D153624, PER @D153623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, ARITY 2] : 
   THINK, 
   [COORD @D153627, AGR [COUNT @D153626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153629, AGR [COUNT @D153628, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153633, AGR [COUNT @D153632, PER @D153631, PLU @D153630, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, ARITY 2] : THINK, 
   [COORD @D153639, PAST @D153638, 
      AGR [CASE @D153637, COUNT @D153636, PER @D153635, PLU @D153634, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153642, AGR [COUNT @D153641, PER @D153640, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153644, AGR [COUNT @D153643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153646, AGR [COUNT @D153645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153650, AGR [COUNT @D153649, PER @D153648, PLU @D153647, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153656, PAST @D153655, AGR [CASE @D153654, COUNT @D153653, 
            PER @D153652, PLU @D153651, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, ARITY 2] : THINK, 
   [COORD @D153659, 
      AGR [COUNT @D153658, PER @D153657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   THINK, 
   [COORD @D153661, AGR [COUNT @D153660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153663, AGR [COUNT @D153662, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153667, AGR [COUNT @D153666, PER @D153665, PLU @D153664, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : THINK, 
   [COORD @D153673, PAST @D153672, 
      AGR [CASE @D153671, COUNT @D153670, PER @D153669, PLU @D153668, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153676, AGR [COUNT @D153675, PER @D153674, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153678, AGR [COUNT @D153677, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153680, AGR [COUNT @D153679, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153684, AGR [COUNT @D153683, PER @D153682, PLU @D153681, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 2] : THINK, 
   [COORD @D153690, PAST @D153689, 
      AGR [CASE @D153688, COUNT @D153687, PER @D153686, PLU @D153685, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153693, AGR [COUNT @D153692, PER @D153691, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153695, AGR [COUNT @D153694, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153697, AGR [COUNT @D153696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153701, AGR [COUNT @D153700, PER @D153699, PLU @D153698, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, ARITY 2] : THINK, 
   [COORD @D153707, PAST @D153706, 
      AGR [CASE @D153705, COUNT @D153704, PER @D153703, PLU @D153702, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_NP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153710, AGR [COUNT @D153709, PER @D153708, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153712, AGR [COUNT @D153711, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153714, AGR [COUNT @D153713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153718, AGR [COUNT @D153717, PER @D153716, PLU @D153715, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, ARITY 2] : THINK, 
   [COORD @D153724, PAST @D153723, 
      AGR [CASE @D153722, COUNT @D153721, PER @D153720, PLU @D153719, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_AP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153727, AGR [COUNT @D153726, PER @D153725, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153729, AGR [COUNT @D153728, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153731, AGR [COUNT @D153730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : THINK, 
   [COORD @D153735, AGR [COUNT @D153734, PER @D153733, PLU @D153732, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : THINK, 
   [COORD @D153741, PAST @D153740, AGR [CASE @D153739, COUNT @D153738, 
            PER @D153737, PLU @D153736, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : THINK, 
   [COORD @D153744, AGR 
         [COUNT @D153743, PER @D153742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP OF, 
      ARITY 2] : THINK, 
   [COORD @D153746, AGR [COUNT @D153745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP OF, ARITY 2] : THINK, 
   [COORD @D153748, AGR [COUNT @D153747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP OF, ARITY 2] : THINK, 
   [COORD @D153752, AGR [COUNT @D153751, PER @D153750, PLU @D153749, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP OF, ARITY 2] : THINK, 
   [COORD @D153758, PAST @D153757, 
      AGR [CASE @D153756, COUNT @D153755, PER @D153754, PLU @D153753, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PREP OF, ARITY 2] : THINK, 
   [COORD @D153761, AGR [COUNT @D153760, PER @D153759, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : THINK, 
   [COORD @D153763, AGR [COUNT @D153762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : THINK, 
   [COORD @D153765, AGR [COUNT @D153764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : THINK, 
   [COORD @D153769, AGR [COUNT @D153768, PER @D153767, PLU @D153766, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM OF, ARITY 2] : THINK, 
   [COORD @D153775, PAST @D153774, 
      AGR [CASE @D153773, COUNT @D153772, PER @D153771, PLU @D153770, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM OF, ARITY 2] : THINK, 
   [COORD @D153778, AGR [COUNT @D153777, PER @D153776, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : THINK, 
   [COORD @D153780, AGR [COUNT @D153779, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : THINK, 
   [COORD @D153782, AGR [COUNT @D153781, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : THINK, 
   [COORD @D153786, AGR [COUNT @D153785, PER @D153784, PLU @D153783, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, ARITY 2] : THINK, 
   [COORD @D153792, PAST @D153791, 
      AGR [CASE @D153790, COUNT @D153789, PER @D153788, PLU @D153787, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, 
      PFORM ABOUT, ARITY 2] : THINK, 
   [COORD @D153795, AGR [COUNT @D153794, PER @D153793, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : THINK, 
   [COORD @D153797, AGR [COUNT @D153796, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : THINK, 
   [COORD @D153799, AGR [COUNT @D153798, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : THINK, 
   [COORD @D153803, AGR [COUNT @D153802, PER @D153801, PLU @D153800, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : THINK, 
   [COORD @D153809, PAST @D153808, 
      AGR [CASE @D153807, COUNT @D153806, PER @D153805, PLU @D153804, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : THINK, 
   [COORD @D153812, AGR [COUNT @D153811, PER @D153810, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : THINK, 
   [COORD @D153814, AGR [COUNT @D153813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : THINK, 
   [COORD @D153816, AGR [COUNT @D153815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : THINK, 
   [COORD @D153820, AGR [COUNT @D153819, PER @D153818, PLU @D153817, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, ARITY 2] : THINK, 
   [COORD @D153826, PAST @D153825, 
      AGR [CASE @D153824, COUNT @D153823, PER @D153822, PLU @D153821, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, ARITY 2] : THINK, 
   [COORD @D153829, AGR [COUNT @D153828, PER @D153827, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : THINK, 
   [COORD @D153831, AGR [COUNT @D153830, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : THINK, 
   [COORD @D153833, AGR [COUNT @D153832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : THINK, 
   [COORD @D153837, AGR [COUNT @D153836, PER @D153835, PLU @D153834, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, ARITY 2] : THINK, 
   [COORD @D153843, PAST @D153842, 
      AGR [CASE @D153841, COUNT @D153840, PER @D153839, PLU @D153838, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OVER, ARITY 2] : THINK, 
   [COORD @D153846, AGR [COUNT @D153845, PER @D153844, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : THINK, 
   [COORD @D153848, AGR [COUNT @D153847, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : THINK, 
   [COORD @D153850, AGR [COUNT @D153849, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : THINK, 
   [COORD @D153854, AGR [COUNT @D153853, PER @D153852, PLU @D153851, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : THINK, 
   [COORD @D153860, PAST @D153859, 
      AGR [CASE @D153858, COUNT @D153857, PER @D153856, PLU @D153855, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : THINK, 
   [COORD @D153863, AGR [COUNT @D153862, PER @D153861, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : THINK, 
   [COORD @D153865, AGR [COUNT @D153864, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : THINK, 
   [COORD @D153867, AGR [COUNT @D153866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : THINK, 
   [COORD @D153871, AGR [COUNT @D153870, PER @D153869, PLU @D153868, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : THINK, 
   [COORD @D153877, PAST @D153876, 
      AGR [CASE @D153875, COUNT @D153874, PER @D153873, PLU @D153872, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : THINK, 
   [COORD @D153880, AGR [COUNT @D153879, PER @D153878, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : THINK, 
   [COORD @D153882, AGR [COUNT @D153881, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : THINK, 
   [COORD @D153884, AGR [COUNT @D153883, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : THINK, 
   [COORD @D153888, AGR [COUNT @D153887, PER @D153886, PLU @D153885, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : THINK, 
   [COORD @D153894, PAST @D153893, 
      AGR [CASE @D153892, COUNT @D153891, PER @D153890, PLU @D153889, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : THINK, 
   [COORD @D153897, AGR [COUNT @D153896, PER @D153895, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : THINK, 
   [COORD @D153899, AGR [COUNT @D153898, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : THINK, 
   [COORD @D153901, AGR [COUNT @D153900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : THINK, 
   [COORD @D153905, AGR [COUNT @D153904, PER @D153903, PLU @D153902, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : THINK, 
   [COORD @D153911, PAST @D153910, 
      AGR [CASE @D153909, COUNT @D153908, PER @D153907, PLU @D153906, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, ARITY 1] : THINK, 
   [COORD @D153914, AGR [COUNT @D153913, PER @D153912, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : THINK, 
   [COORD @D153916, AGR [COUNT @D153915, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : THINK, 
   [COORD @D153918, AGR [COUNT @D153917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : THINK, 
   [COORD @D153922, AGR [COUNT @D153921, PER @D153920, PLU @D153919, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : THINK, 
   [COORD @D153928, PAST @D153927, 
      AGR [CASE @D153926, COUNT @D153925, PER @D153924, PLU @D153923, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, ARITY 1] : THINK, 
   [COORD @D153931, AGR [COUNT @D153930, PER @D153929, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : THINK, 
   [COORD @D153933, AGR [COUNT @D153932, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : THINK, 
   [COORD @D153935, AGR [COUNT @D153934, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : THINK, 
   [COORD @D153939, AGR [COUNT @D153938, PER @D153937, PLU @D153936, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : THINK, 
   [COORD @D153945, PAST @D153944, 
      AGR [CASE @D153943, COUNT @D153942, PER @D153941, PLU @D153940, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : THINK.

WORD thinking : 
   [COADV @D153960, COORD @D153959, DEF @D153958, PRD @D153957, 
      AGR [CASE @D153956, COUNT @D153955, PER @D153954, PLU @D153953, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : THINKING, 
   [COORD @D153964, REFL @D153963, PRD @D153962, CASE @D153961, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : THINKING, 
   [COORD @D153970, PRD @D153969, 
      AGR [CASE @D153968, COUNT @D153967, PER @D153966, PLU @D153965, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : THINK, 
   [COORD @D153976, PRD @D153975, AGR [CASE @D153974, COUNT @D153973, 
            PER @D153972, PLU @D153971, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D153982, PRD @D153981, 
      AGR [CASE @D153980, COUNT @D153979, PER @D153978, PLU @D153977, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : THINK, 
   [COORD @D153988, PRD @D153987, AGR [CASE @D153986, COUNT @D153985, 
            PER @D153984, PLU @D153983, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D153994, PRD @D153993, 
      AGR [CASE @D153992, COUNT @D153991, PER @D153990, PLU @D153989, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   THINK, 
   [COORD @D154000, PRD @D153999, AGR [CASE @D153998, COUNT @D153997, 
            PER @D153996, PLU @D153995, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D154006, PRD @D154005, 
      AGR [CASE @D154004, COUNT @D154003, PER @D154002, PLU @D154001, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : THINK, 
   [COORD @D154012, PRD @D154011, AGR [CASE @D154010, COUNT @D154009, 
            PER @D154008, PLU @D154007, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, PREP OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D154018, PRD @D154017, 
      AGR [CASE @D154016, COUNT @D154015, PER @D154014, PLU @D154013, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : THINK, 
   [COORD @D154024, PRD @D154023, AGR [CASE @D154022, COUNT @D154021, 
            PER @D154020, PLU @D154019, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D154030, PRD @D154029, 
      AGR [CASE @D154028, COUNT @D154027, PER @D154026, PLU @D154025, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : THINK, 
   [COORD @D154036, PRD @D154035, AGR [CASE @D154034, COUNT @D154033, 
            PER @D154032, PLU @D154031, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D154042, PRD @D154041, 
      AGR [CASE @D154040, COUNT @D154039, PER @D154038, PLU @D154037, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : THINK, 
   [COORD @D154048, PRD @D154047, AGR [CASE @D154046, COUNT @D154045, 
            PER @D154044, PLU @D154043, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D154054, PRD @D154053, 
      AGR [CASE @D154052, COUNT @D154051, PER @D154050, PLU @D154049, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : THINK, 
   [COORD @D154060, PRD @D154059, AGR [CASE @D154058, COUNT @D154057, 
            PER @D154056, PLU @D154055, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D154066, PRD @D154065, 
      AGR [CASE @D154064, COUNT @D154063, PER @D154062, PLU @D154061, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : THINK, 
   [COORD @D154072, PRD @D154071, AGR [CASE @D154070, COUNT @D154069, 
            PER @D154068, PLU @D154067, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : THINK, 
   [COORD @D154078, PRD @D154077, 
      AGR [CASE @D154076, COUNT @D154075, PER @D154074, PLU @D154073, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : THINK.

WORD thinks : 
   [COORD @D154095, AGR [COUNT @D154094, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154097, 
      AGR [COUNT @D154096, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154099, 
      AGR [COUNT @D154098, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154101, 
      AGR [COUNT @D154100, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154103, 
      AGR [COUNT @D154102, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154105, 
      AGR [COUNT @D154104, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154107, 
      AGR [COUNT @D154106, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154109, 
      AGR [COUNT @D154108, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PREP OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154111, 
      AGR [COUNT @D154110, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154113, 
      AGR [COUNT @D154112, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154115, 
      AGR [COUNT @D154114, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154117, 
      AGR [COUNT @D154116, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154119, 
      AGR [COUNT @D154118, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154121, 
      AGR [COUNT @D154120, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154123, 
      AGR [COUNT @D154122, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154125, 
      AGR [COUNT @D154124, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THINK, 
   [COORD @D154127, 
      AGR [COUNT @D154126, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   THINK, 
   [COORD @D154129, AGR [COUNT @D154128, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : THINK, 
   [COORD @D154131, AGR [COUNT @D154130, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : THINK.

WORD thought : 
   [COORD @D154139, REFL @D154138, PRD @D154137, CASE @D154136, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : THOUGHT, 
   [COORD @D154143, REFL @D154142, PRD @D154141, CASE @D154140, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : THOUGHT, 
   [COORD @D154148, REFL @D154147, COUNT @D154146, PRD @D154145, 
      CASE @D154144, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : THOUGHT, 
   [COORD @D154152, REFL @D154151, PRD @D154150, CASE @D154149, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : THOUGHT, 
   [COORD @D154157, REFL @D154156, COUNT @D154155, PRD @D154154, 
      CASE @D154153, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : THOUGHT, 
   [COORD @D154162, REFL @D154161, COUNT @D154160, PRD @D154159, 
      CASE @D154158, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR] : 
   THOUGHT, 
   [COORD @D154168, PAST @D154167, AGR [CASE @D154166, COUNT @D154165, 
            PER @D154164, PLU @D154163, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, FIN -, ARITY 2] : THINK, 
   [COORD @D154174, PAST @D154173, 
      AGR [CASE @D154172, COUNT @D154171, PER @D154170, PLU @D154169, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, FIN -, 
      ARITY 2] : THINK, 
   [COORD @D154180, PAST @D154179, AGR [CASE @D154178, COUNT @D154177, 
            PER @D154176, PLU @D154175, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, FIN -, ARITY 2] : THINK, 
   [COORD @D154186, PAST @D154185, 
      AGR [CASE @D154184, COUNT @D154183, PER @D154182, PLU @D154181, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, REG -, FIN -, 
      ARITY 2] : THINK, 
   [COORD @D154192, PAST @D154191, AGR [CASE @D154190, COUNT @D154189, 
            PER @D154188, PLU @D154187, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, FIN -, ARITY 2] : THINK, 
   [COORD @D154195, AGR @D154194, PAST @D154193, VFORM EN, SUBCAT OC_AP, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : THINK, 
   [COORD @D154201, PAST @D154200, AGR [CASE @D154199, COUNT @D154198, 
            PER @D154197, PLU @D154196, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 2] : THINK, 
   [COORD @D154207, PAST @D154206, 
      AGR [CASE @D154205, COUNT @D154204, PER @D154203, PLU @D154202, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : THINK, 
   [COORD @D154213, PAST @D154212, AGR [CASE @D154211, COUNT @D154210, 
            PER @D154209, PLU @D154208, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : THINK, 
   [COORD @D154219, PAST @D154218, 
      AGR [CASE @D154217, COUNT @D154216, PER @D154215, PLU @D154214, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP OF, 
      FIN -, ARITY 2] : THINK, 
   [COORD @D154225, PAST @D154224, AGR [CASE @D154223, COUNT @D154222, 
            PER @D154221, PLU @D154220, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM OF, FIN -, ARITY 2] : THINK, 
   [COORD @D154231, PAST @D154230, 
      AGR [CASE @D154229, COUNT @D154228, PER @D154227, PLU @D154226, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OF, FIN -, 
      ARITY 2] : THINK, 
   [COORD @D154237, PAST @D154236, AGR [CASE @D154235, COUNT @D154234, 
            PER @D154233, PLU @D154232, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ABOUT, FIN -, ARITY 2] : THINK, 
   [COORD @D154243, PAST @D154242, 
      AGR [CASE @D154241, COUNT @D154240, PER @D154239, PLU @D154238, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ABOUT, 
      FIN -, ARITY 2] : THINK, 
   [COORD @D154249, PAST @D154248, AGR [CASE @D154247, COUNT @D154246, 
            PER @D154245, PLU @D154244, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : THINK, 
   [COORD @D154255, PAST @D154254, 
      AGR [CASE @D154253, COUNT @D154252, PER @D154251, PLU @D154250, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      FIN -, ARITY 2] : THINK, 
   [COORD @D154261, PAST @D154260, AGR [CASE @D154259, COUNT @D154258, 
            PER @D154257, PLU @D154256, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT THROUGH, FIN -, ARITY 2] : THINK, 
   [COORD @D154267, PAST @D154266, 
      AGR [CASE @D154265, COUNT @D154264, PER @D154263, PLU @D154262, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT THROUGH, FIN -, ARITY 2] : THINK, 
   [COORD @D154273, PAST @D154272, 
      AGR [CASE @D154271, COUNT @D154270, PER @D154269, PLU @D154268, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, FIN -, 
      ARITY 2] : THINK, 
   [COORD @D154279, PAST @D154278, AGR [CASE @D154277, COUNT @D154276, 
            PER @D154275, PLU @D154274, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OVER, FIN -, ARITY 2] : THINK, 
   [COORD @D154285, PAST @D154284, 
      AGR [CASE @D154283, COUNT @D154282, PER @D154281, PLU @D154280, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, FIN -, 
      ARITY 2] : THINK, 
   [COORD @D154291, PAST @D154290, AGR [CASE @D154289, COUNT @D154288, 
            PER @D154287, PLU @D154286, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, FIN -, ARITY 2] : THINK, 
   [COORD @D154295, 
      AGR [COUNT @D154294, PER @D154293, PLU @D154292, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, 
      PAST +, ARITY 2] : THINK, 
   [COORD @D154299, AGR [COUNT @D154298, PER @D154297, PLU @D154296, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PAST +, ARITY 2] : THINK, 
   [COORD @D154303, AGR [COUNT @D154302, PER @D154301, PLU @D154300, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PAST +, ARITY 2] : THINK, 
   [COORD @D154307, AGR [COUNT @D154306, PER @D154305, PLU @D154304, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PAST +, ARITY 2] : THINK, 
   [COORD @D154311, AGR [COUNT @D154310, PER @D154309, PLU @D154308, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_NP, REG -, PAST +, ARITY 2] : THINK, 
   [COORD @D154315, AGR [COUNT @D154314, PER @D154313, PLU @D154312, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 2] : THINK, 
   [COORD @D154319, AGR [COUNT @D154318, PER @D154317, PLU @D154316, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : THINK, 
   [COORD @D154323, AGR [COUNT @D154322, PER @D154321, PLU @D154320, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PREP OF, PAST +, ARITY 2] : THINK, 
   [COORD @D154327, 
      AGR [COUNT @D154326, PER @D154325, PLU @D154324, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM OF, 
      PAST +, ARITY 2] : THINK, 
   [COORD @D154331, AGR [COUNT @D154330, PER @D154329, PLU @D154328, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ABOUT, PAST +, ARITY 2] : THINK, 
   [COORD @D154335, AGR [COUNT @D154334, PER @D154333, PLU @D154332, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT UP, PAST +, ARITY 2] : THINK, 
   [COORD @D154339, AGR [COUNT @D154338, PER @D154337, PLU @D154336, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT THROUGH, PAST +, ARITY 2] : THINK, 
   [COORD @D154343, AGR [COUNT @D154342, PER @D154341, PLU @D154340, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OVER, PAST +, ARITY 2] : THINK, 
   [COORD @D154347, AGR [COUNT @D154346, PER @D154345, PLU @D154344, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OUT, PAST +, ARITY 2] : THINK, 
   [COORD @D154353, PAST @D154352, 
      AGR [CASE @D154351, COUNT @D154350, PER @D154349, PLU @D154348, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : THINK, 
   [COORD @D154359, PAST @D154358, AGR [CASE @D154357, COUNT @D154356, 
            PER @D154355, PLU @D154354, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, FIN -, ARITY 1] : THINK, 
   [COORD @D154365, PAST @D154364, 
      AGR [CASE @D154363, COUNT @D154362, PER @D154361, PLU @D154360, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT THROUGH, 
      FIN -, ARITY 1] : THINK, 
   [COORD @D154371, PAST @D154370, AGR [CASE @D154369, COUNT @D154368, 
            PER @D154367, PLU @D154366, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, FIN -, ARITY 1] : THINK, 
   [COORD @D154377, PAST @D154376, 
      AGR [CASE @D154375, COUNT @D154374, PER @D154373, PLU @D154372, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OUT, 
      FIN -, ARITY 1] : THINK, 
   [COORD @D154381, AGR [COUNT @D154380, PER @D154379, PLU @D154378, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : THINK, 
   [COORD @D154385, AGR [COUNT @D154384, PER @D154383, PLU @D154382, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, PAST +, ARITY 1] : THINK, 
   [COORD @D154389, 
      AGR [COUNT @D154388, PER @D154387, PLU @D154386, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, PAST +, ARITY 1] : THINK, 
   [COORD @D154393, AGR [COUNT @D154392, PER @D154391, PLU @D154390, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, PAST +, ARITY 1] : THINK, 
   [COORD @D154397, 
      AGR [COUNT @D154396, PER @D154395, PLU @D154394, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, PAST +, ARITY 1] : THINK.

WORD thoughts : 
   [COORD @D154422, DEMON @D154421, REFL @D154420, PRD @D154419, 
      CASE @D154418, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   THOUGHT, 
   [COORD @D154427, DEMON @D154426, REFL @D154425, PRD @D154424, 
      CASE @D154423, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   THOUGHT, 
   [COORD @D154432, DEMON @D154431, REFL @D154430, PRD @D154429, 
      CASE @D154428, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   THOUGHT.

WORD thrust : 
   [COORD @D154440, REFL @D154439, COUNT @D154438, PRD @D154437, 
      CASE @D154436, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : THRUST, 
   [COORD @D154443, 
      AGR [COUNT @D154442, PER @D154441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, ARITY 3] : 
   THRUST, 
   [COORD @D154445, AGR [COUNT @D154444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : THRUST, 
   [COORD @D154447, AGR [COUNT @D154446, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, 
      REG -, ARITY 3] : THRUST, 
   [COORD @D154451, AGR [COUNT @D154450, PER @D154449, PLU @D154448, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, ARITY 3] : THRUST, 
   [COORD @D154457, PAST @D154456, 
      AGR [CASE @D154455, COUNT @D154454, PER @D154453, PLU @D154452, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, 
      ARITY 3] : THRUST, 
   [COORD @D154463, PAST @D154462, AGR [CASE @D154461, COUNT @D154460, 
            PER @D154459, PLU @D154458, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : THRUST, 
   [COORD @D154469, PAST @D154468, 
      AGR [CASE @D154467, COUNT @D154466, PER @D154465, PLU @D154464, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : THRUST, 
   [COORD @D154473, AGR [COUNT @D154472, PER @D154471, PLU @D154470, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : THRUST, 
   [COORD @D154476, AGR [COUNT @D154475, PER @D154474, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : THRUST, 
   [COORD @D154478, AGR [COUNT @D154477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : THRUST, 
   [COORD @D154480, AGR [COUNT @D154479, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : THRUST, 
   [COORD @D154484, AGR [COUNT @D154483, PER @D154482, PLU @D154481, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM AT, ARITY 2] : THRUST, 
   [COORD @D154490, PAST @D154489, 
      AGR [CASE @D154488, COUNT @D154487, PER @D154486, PLU @D154485, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, ARITY 2] : THRUST, 
   [COORD @D154496, PAST @D154495, AGR [CASE @D154494, COUNT @D154493, 
            PER @D154492, PLU @D154491, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM AT, FIN -, ARITY 2] : THRUST, 
   [COORD @D154500, 
      AGR [COUNT @D154499, PER @D154498, PLU @D154497, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM AT, PAST +, ARITY 2] : THRUST, 
   [COORD @D154503, AGR [COUNT @D154502, PER @D154501, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : THRUST, 
   [COORD @D154505, AGR [COUNT @D154504, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : THRUST, 
   [COORD @D154507, AGR [COUNT @D154506, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : THRUST, 
   [COORD @D154511, AGR [COUNT @D154510, PER @D154509, PLU @D154508, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : THRUST, 
   [COORD @D154517, PAST @D154516, 
      AGR [CASE @D154515, COUNT @D154514, PER @D154513, PLU @D154512, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : THRUST, 
   [COORD @D154523, PAST @D154522, AGR [CASE @D154521, COUNT @D154520, 
            PER @D154519, PLU @D154518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : THRUST, 
   [COORD @D154527, AGR [COUNT @D154526, PER @D154525, PLU @D154524, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : THRUST.

WORD thrusting : 
   [COORD @D154547, PRD @D154546, AGR [CASE @D154545, COUNT @D154544, 
            PER @D154543, PLU @D154542, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THRUST, 
   [COORD @D154553, PRD @D154552, 
      AGR [CASE @D154551, COUNT @D154550, PER @D154549, PLU @D154548, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : THRUST, 
   [COORD @D154559, PRD @D154558, AGR [CASE @D154557, COUNT @D154556, 
            PER @D154555, PLU @D154554, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : THRUST.

WORD thrusts : 
   [COORD @D154569, DEMON @D154568, REFL @D154567, PRD @D154566, 
      CASE @D154565, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   THRUST, 
   [COORD @D154571, AGR [COUNT @D154570, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   THRUST, 
   [COORD @D154573, AGR [COUNT @D154572, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   THRUST, 
   [COORD @D154575, AGR [COUNT @D154574, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : THRUST.

WORD tie : 
   [COORD @D154583, REFL @D154582, PRD @D154581, CASE @D154580, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TIE, 
   [COORD @D154586, 
      AGR [COUNT @D154585, PER @D154584, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PRT DOWN, 
      PFORM TO, ARITY 3] : TIE, 
   [COORD @D154588, AGR [COUNT @D154587, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT DOWN, PFORM TO, ARITY 3] : TIE, 
   [COORD @D154590, AGR 
         [COUNT @D154589, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PRT DOWN, 
      PFORM TO, ARITY 3] : TIE, 
   [COORD @D154594, AGR [COUNT @D154593, PER @D154592, PLU @D154591, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT DOWN, PFORM TO, ARITY 3] : TIE, 
   [COORD @D154600, PAST @D154599, 
      AGR [CASE @D154598, COUNT @D154597, PER @D154596, PLU @D154595, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PRT DOWN, PFORM TO, ARITY 3] : TIE, 
   [COORD @D154603, AGR [COUNT @D154602, PER @D154601, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT DOWN, PFORM ON, ARITY 3] : TIE, 
   [COORD @D154605, AGR 
         [COUNT @D154604, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PRT DOWN, 
      PFORM ON, ARITY 3] : TIE, 
   [COORD @D154607, AGR [COUNT @D154606, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT DOWN, PFORM ON, ARITY 3] : TIE, 
   [COORD @D154611, AGR 
         [COUNT @D154610, PER @D154609, PLU @D154608, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PRT DOWN, PFORM ON, ARITY 3] : TIE, 
   [COORD @D154617, PAST @D154616, 
      AGR [CASE @D154615, COUNT @D154614, PER @D154613, PLU @D154612, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PRT DOWN, PFORM ON, ARITY 3] : TIE, 
   [COORD @D154620, AGR [COUNT @D154619, PER @D154618, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : TIE, 
   [COORD @D154622, AGR 
         [COUNT @D154621, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM WITH, ARITY 3] : TIE, 
   [COORD @D154624, AGR [COUNT @D154623, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : TIE, 
   [COORD @D154628, AGR 
         [COUNT @D154627, PER @D154626, PLU @D154625, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM WITH, ARITY 3] : TIE, 
   [COORD @D154634, PAST @D154633, 
      AGR [CASE @D154632, COUNT @D154631, PER @D154630, PLU @D154629, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM WITH, ARITY 3] : TIE, 
   [COORD @D154637, AGR [COUNT @D154636, PER @D154635, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : TIE, 
   [COORD @D154639, AGR [COUNT @D154638, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : TIE, 
   [COORD @D154641, AGR [COUNT @D154640, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : TIE, 
   [COORD @D154645, AGR [COUNT @D154644, PER @D154643, PLU @D154642, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, PFORM IN, ARITY 3] : TIE, 
   [COORD @D154651, PAST @D154650, 
      AGR [CASE @D154649, COUNT @D154648, PER @D154647, PLU @D154646, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      PFORM IN, ARITY 3] : TIE, 
   [COORD @D154654, AGR [COUNT @D154653, PER @D154652, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIE, 
   [COORD @D154656, AGR [COUNT @D154655, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIE, 
   [COORD @D154658, AGR [COUNT @D154657, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIE, 
   [COORD @D154662, AGR [COUNT @D154661, PER @D154660, PLU @D154659, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TIE, 
   [COORD @D154668, PAST @D154667, AGR [CASE @D154666, COUNT @D154665, 
            PER @D154664, PLU @D154663, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TIE, 
   [COORD @D154671, AGR [COUNT @D154670, PER @D154669, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT DOWN, ARITY 2] : TIE, 
   [COORD @D154673, AGR [COUNT @D154672, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT DOWN, ARITY 2] : TIE, 
   [COORD @D154675, AGR [COUNT @D154674, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT DOWN, ARITY 2] : TIE, 
   [COORD @D154679, AGR [COUNT @D154678, PER @D154677, PLU @D154676, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT DOWN, ARITY 2] : TIE, 
   [COORD @D154685, PAST @D154684, 
      AGR [CASE @D154683, COUNT @D154682, PER @D154681, PLU @D154680, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT DOWN, ARITY 2] : TIE, 
   [COORD @D154688, AGR [COUNT @D154687, PER @D154686, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154690, AGR [COUNT @D154689, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154692, AGR [COUNT @D154691, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154696, AGR [COUNT @D154695, PER @D154694, PLU @D154693, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154702, PAST @D154701, 
      AGR [CASE @D154700, COUNT @D154699, PER @D154698, PLU @D154697, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154705, AGR [COUNT @D154704, PER @D154703, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154707, AGR [COUNT @D154706, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154709, AGR [COUNT @D154708, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154713, AGR [COUNT @D154712, PER @D154711, PLU @D154710, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT IN, PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154719, PAST @D154718, 
      AGR [CASE @D154717, COUNT @D154716, PER @D154715, PLU @D154714, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : TIE, 
   [COORD @D154722, AGR [COUNT @D154721, PER @D154720, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TIE, 
   [COORD @D154724, AGR [COUNT @D154723, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TIE, 
   [COORD @D154726, AGR [COUNT @D154725, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TIE, 
   [COORD @D154730, AGR [COUNT @D154729, PER @D154728, PLU @D154727, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : TIE, 
   [COORD @D154736, PAST @D154735, 
      AGR [CASE @D154734, COUNT @D154733, PER @D154732, PLU @D154731, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TIE, 
   [COORD @D154739, AGR [COUNT @D154738, PER @D154737, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TIE, 
   [COORD @D154741, AGR [COUNT @D154740, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TIE, 
   [COORD @D154743, AGR [COUNT @D154742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TIE, 
   [COORD @D154747, AGR [COUNT @D154746, PER @D154745, PLU @D154744, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : TIE, 
   [COORD @D154753, PAST @D154752, 
      AGR [CASE @D154751, COUNT @D154750, PER @D154749, PLU @D154748, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : TIE, 
   [COORD @D154756, AGR [COUNT @D154755, PER @D154754, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : TIE, 
   [COORD @D154758, AGR [COUNT @D154757, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : TIE, 
   [COORD @D154760, AGR [COUNT @D154759, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : TIE, 
   [COORD @D154764, AGR [COUNT @D154763, PER @D154762, PLU @D154761, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT TOGETHER, ARITY 2] : TIE, 
   [COORD @D154770, PAST @D154769, 
      AGR [CASE @D154768, COUNT @D154767, PER @D154766, PLU @D154765, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT TOGETHER, ARITY 2] : TIE, 
   [COORD @D154773, AGR [COUNT @D154772, PER @D154771, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIE, 
   [COORD @D154775, AGR [COUNT @D154774, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIE, 
   [COORD @D154777, AGR [COUNT @D154776, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIE, 
   [COORD @D154781, AGR [COUNT @D154780, PER @D154779, PLU @D154778, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIE, 
   [COORD @D154787, PAST @D154786, AGR [CASE @D154785, COUNT @D154784, 
            PER @D154783, PLU @D154782, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TIE, 
   [COORD @D154790, AGR [COUNT @D154789, PER @D154788, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIE, 
   [COORD @D154792, AGR [COUNT @D154791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIE, 
   [COORD @D154794, AGR [COUNT @D154793, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIE, 
   [COORD @D154798, AGR [COUNT @D154797, PER @D154796, PLU @D154795, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIE, 
   [COORD @D154804, PAST @D154803, 
      AGR [CASE @D154802, COUNT @D154801, PER @D154800, PLU @D154799, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : TIE, 
   [COORD @D154807, AGR [COUNT @D154806, PER @D154805, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : TIE, 
   [COORD @D154809, AGR [COUNT @D154808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : TIE, 
   [COORD @D154811, AGR [COUNT @D154810, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : TIE, 
   [COORD @D154815, AGR [COUNT @D154814, PER @D154813, PLU @D154812, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TOGETHER, ARITY 1] : TIE, 
   [COORD @D154821, PAST @D154820, 
      AGR [CASE @D154819, COUNT @D154818, PER @D154817, PLU @D154816, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT TOGETHER, ARITY 1] : TIE, 
   [COORD @D154824, AGR [COUNT @D154823, PER @D154822, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TIE, 
   [COORD @D154826, AGR [COUNT @D154825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TIE, 
   [COORD @D154828, AGR [COUNT @D154827, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TIE, 
   [COORD @D154832, AGR [COUNT @D154831, PER @D154830, PLU @D154829, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TIE, 
   [COORD @D154838, PAST @D154837, 
      AGR [CASE @D154836, COUNT @D154835, PER @D154834, PLU @D154833, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : TIE, 
   [COORD @D154841, AGR [COUNT @D154840, PER @D154839, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TIE, 
   [COORD @D154843, AGR [COUNT @D154842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TIE, 
   [COORD @D154845, AGR [COUNT @D154844, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TIE, 
   [COORD @D154849, AGR [COUNT @D154848, PER @D154847, PLU @D154846, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TIE, 
   [COORD @D154855, PAST @D154854, 
      AGR [CASE @D154853, COUNT @D154852, PER @D154851, PLU @D154850, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : TIE.

WORD tied : 
   [COORD @D154866, AGR [CASE @D154865, COUNT @D154864, PER @D154863, 
            PLU @D154862, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT DOWN, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154871, AGR [CASE @D154870, COUNT @D154869, PER @D154868, 
            PLU @D154867, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT DOWN, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154876, 
      AGR [CASE @D154875, COUNT @D154874, PER @D154873, PLU @D154872, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT DOWN, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154881, AGR [CASE @D154880, COUNT @D154879, PER @D154878, 
            PLU @D154877, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT DOWN, PFORM ON, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154886, AGR [CASE @D154885, COUNT @D154884, PER @D154883, 
            PLU @D154882, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT DOWN, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154891, 
      AGR [CASE @D154890, COUNT @D154889, PER @D154888, PLU @D154887, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT DOWN, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154896, AGR [CASE @D154895, COUNT @D154894, PER @D154893, 
            PLU @D154892, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154901, AGR [CASE @D154900, COUNT @D154899, PER @D154898, 
            PLU @D154897, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154906, 
      AGR [CASE @D154905, COUNT @D154904, PER @D154903, PLU @D154902, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154911, AGR [CASE @D154910, COUNT @D154909, PER @D154908, 
            PLU @D154907, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154916, AGR [CASE @D154915, COUNT @D154914, PER @D154913, 
            PLU @D154912, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154921, 
      AGR [CASE @D154920, COUNT @D154919, PER @D154918, PLU @D154917, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154926, AGR [CASE @D154925, COUNT @D154924, PER @D154923, 
            PLU @D154922, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIE, 
   [COORD @D154931, AGR [CASE @D154930, COUNT @D154929, PER @D154928, 
            PLU @D154927, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154936, AGR [CASE @D154935, COUNT @D154934, PER @D154933, 
            PLU @D154932, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154941, AGR [CASE @D154940, COUNT @D154939, PER @D154938, 
            PLU @D154937, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154946, AGR [CASE @D154945, COUNT @D154944, PER @D154943, 
            PLU @D154942, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154951, AGR [CASE @D154950, COUNT @D154949, PER @D154948, 
            PLU @D154947, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154956, AGR [CASE @D154955, COUNT @D154954, PER @D154953, 
            PLU @D154952, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154961, AGR [CASE @D154960, COUNT @D154959, PER @D154958, 
            PLU @D154957, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154966, AGR [CASE @D154965, COUNT @D154964, PER @D154963, 
            PLU @D154962, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154971, AGR [CASE @D154970, COUNT @D154969, PER @D154968, 
            PLU @D154967, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154976, AGR [CASE @D154975, COUNT @D154974, PER @D154973, 
            PLU @D154972, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154981, AGR [CASE @D154980, COUNT @D154979, PER @D154978, 
            PLU @D154977, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D154986, AGR [CASE @D154985, COUNT @D154984, PER @D154983, 
            PLU @D154982, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154991, AGR [CASE @D154990, COUNT @D154989, PER @D154988, 
            PLU @D154987, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D154996, AGR [CASE @D154995, COUNT @D154994, PER @D154993, 
            PLU @D154992, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D155001, AGR [CASE @D155000, COUNT @D154999, PER @D154998, 
            PLU @D154997, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D155006, AGR [CASE @D155005, COUNT @D155004, PER @D155003, 
            PLU @D155002, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D155011, AGR [CASE @D155010, COUNT @D155009, PER @D155008, 
            PLU @D155007, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D155016, AGR [CASE @D155015, COUNT @D155014, PER @D155013, 
            PLU @D155012, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D155021, AGR [CASE @D155020, COUNT @D155019, PER @D155018, 
            PLU @D155017, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D155026, AGR [CASE @D155025, COUNT @D155024, PER @D155023, 
            PLU @D155022, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D155031, AGR [CASE @D155030, COUNT @D155029, PER @D155028, 
            PLU @D155027, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D155036, AGR [CASE @D155035, COUNT @D155034, PER @D155033, 
            PLU @D155032, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D155041, AGR [CASE @D155040, COUNT @D155039, PER @D155038, 
            PLU @D155037, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TOGETHER, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D155046, AGR [CASE @D155045, COUNT @D155044, PER @D155043, 
            PLU @D155042, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D155051, AGR [CASE @D155050, COUNT @D155049, PER @D155048, 
            PLU @D155047, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE, 
   [COORD @D155056, AGR [CASE @D155055, COUNT @D155054, PER @D155053, 
            PLU @D155052, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIE, 
   [COORD @D155061, AGR [CASE @D155060, COUNT @D155059, PER @D155058, 
            PLU @D155057, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIE.

WORD ties : 
   [COORD @D155072, DEMON @D155071, REFL @D155070, PRD @D155069, 
      CASE @D155068, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TIE, 
   [COORD @D155074, AGR [COUNT @D155073, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PRT DOWN, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TIE, 
   [COORD @D155076, AGR [COUNT @D155075, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PRT DOWN, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TIE, 
   [COORD @D155078, AGR [COUNT @D155077, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TIE, 
   [COORD @D155080, AGR [COUNT @D155079, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, PFORM IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TIE, 
   [COORD @D155082, AGR [COUNT @D155081, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIE, 
   [COORD @D155084, 
      AGR [COUNT @D155083, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIE, 
   [COORD @D155086, 
      AGR [COUNT @D155085, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIE, 
   [COORD @D155088, 
      AGR [COUNT @D155087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TIE, 
   [COORD @D155090, AGR [COUNT @D155089, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TIE, 
   [COORD @D155092, AGR [COUNT @D155091, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TIE, 
   [COORD @D155094, AGR [COUNT @D155093, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TIE, 
   [COORD @D155096, AGR [COUNT @D155095, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIE, 
   [COORD @D155098, 
      AGR [COUNT @D155097, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIE, 
   [COORD @D155100, 
      AGR [COUNT @D155099, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TOGETHER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TIE, 
   [COORD @D155102, AGR [COUNT @D155101, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TIE, 
   [COORD @D155104, AGR [COUNT @D155103, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TIE.

WORD time : 
   [COORD @D155119, REFL @D155118, PRD @D155117, CASE @D155116, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TIME, 
   [COORD @D155123, REFL @D155122, PRD @D155121, CASE @D155120, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, ADV +, COUNT +] : TIME, 
   [COORD @D155127, REFL @D155126, PRD @D155125, CASE @D155124, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TIME, 
   [COORD @D155132, REFL @D155131, COUNT @D155130, PRD @D155129, 
      CASE @D155128, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TIME, 
   [COORD @D155136, REFL @D155135, PRD @D155134, CASE @D155133, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TIME, 
   [COORD @D155139, 
      AGR [COUNT @D155138, PER @D155137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : TIME, 
   [COORD @D155141, AGR [COUNT @D155140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TIME, 
   [COORD @D155143, AGR [COUNT @D155142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TIME, 
   [COORD @D155147, AGR [COUNT @D155146, PER @D155145, PLU @D155144, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TIME, 
   [COORD @D155153, PAST @D155152, AGR [CASE @D155151, COUNT @D155150, 
            PER @D155149, PLU @D155148, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : TIME, 
   [COORD @D155156, AGR [COUNT @D155155, PER @D155154, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIME, 
   [COORD @D155158, AGR [COUNT @D155157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIME, 
   [COORD @D155160, AGR [COUNT @D155159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIME, 
   [COORD @D155164, AGR [COUNT @D155163, PER @D155162, PLU @D155161, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TIME, 
   [COORD @D155170, PAST @D155169, AGR [CASE @D155168, COUNT @D155167, 
            PER @D155166, PLU @D155165, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TIME.

WORD timed : 
   [COORD @D155185, AGR [CASE @D155184, COUNT @D155183, PER @D155182, 
            PLU @D155181, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIME, 
   [COORD @D155190, AGR [CASE @D155189, COUNT @D155188, PER @D155187, 
            PLU @D155186, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIME, 
   [COORD @D155196, AGR [CASE @D155195, NFORM @D155194, COUNT @D155193, 
            PER @D155192, PLU @D155191, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIME, 
   [COORD @D155201, AGR [CASE @D155200, COUNT @D155199, PER @D155198, 
            PLU @D155197, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIME, 
   [COORD @D155206, AGR [CASE @D155205, COUNT @D155204, PER @D155203, 
            PLU @D155202, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIME, 
   [COORD @D155211, AGR [CASE @D155210, COUNT @D155209, PER @D155208, 
            PLU @D155207, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIME.

WORD times : 
   [COORD @D155226, DEMON @D155225, REFL @D155224, PRD @D155223, 
      CASE @D155222, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TIME, 
   [COORD @D155231, DEMON @D155230, REFL @D155229, PRD @D155228, 
      CASE @D155227, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, PART -, 
      CONJ NULL, ADV +, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TIME, 
   [COORD @D155235, REFL @D155234, PRD @D155233, CASE @D155232, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : TIMES, 
   [COORD @D155240, DEMON @D155239, REFL @D155238, PRD @D155237, 
      CASE @D155236, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TIME, 
   [COORD @D155245, DEMON @D155244, REFL @D155243, PRD @D155242, 
      CASE @D155241, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : TIME, 
   [COORD @D155247, AGR [COUNT @D155246, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TIME, 
   [COORD @D155249, AGR [COUNT @D155248, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIME.

WORD timing : 
   [COORD @D155277, REFL @D155276, PRD @D155275, CASE @D155274, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : TIMING, 
   [COORD @D155283, PRD @D155282, 
      AGR [CASE @D155281, COUNT @D155280, PER @D155279, PLU @D155278, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   TIME, 
   [COORD @D155289, PRD @D155288, AGR [CASE @D155287, COUNT @D155286, 
            PER @D155285, PLU @D155284, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIME.

WORD tip : 
   [COORD @D155309, REFL @D155308, COUNT @D155307, PRD @D155306, 
      CASE @D155305, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TIP, 
   [COORD @D155313, REFL @D155312, PRD @D155311, CASE @D155310, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : TIP, 
   [COORD @D155317, REFL @D155316, PRD @D155315, CASE @D155314, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT SFIN, COUNT +] : TIP, 
   [COORD @D155320, AGR 
         [COUNT @D155319, PER @D155318, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : TIP, 
   [COORD @D155322, AGR [COUNT @D155321, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TIP, 
   [COORD @D155324, AGR [COUNT @D155323, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TIP, 
   [COORD @D155328, AGR [COUNT @D155327, PER @D155326, PLU @D155325, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TIP, 
   [COORD @D155334, PAST @D155333, AGR [CASE @D155332, COUNT @D155331, 
            PER @D155330, PLU @D155329, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : TIP, 
   [COORD @D155337, AGR [COUNT @D155336, PER @D155335, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TIP, 
   [COORD @D155339, AGR [COUNT @D155338, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TIP, 
   [COORD @D155341, AGR [COUNT @D155340, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TIP, 
   [COORD @D155345, AGR [COUNT @D155344, PER @D155343, PLU @D155342, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : TIP, 
   [COORD @D155351, PAST @D155350, AGR [CASE @D155349, COUNT @D155348, 
            PER @D155347, PLU @D155346, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : TIP, 
   [COORD @D155354, AGR [COUNT @D155353, PER @D155352, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TIP, 
   [COORD @D155356, AGR [COUNT @D155355, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TIP, 
   [COORD @D155358, AGR [COUNT @D155357, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TIP, 
   [COORD @D155362, AGR [COUNT @D155361, PER @D155360, PLU @D155359, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TIP, 
   [COORD @D155368, PAST @D155367, AGR [CASE @D155366, COUNT @D155365, 
            PER @D155364, PLU @D155363, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : TIP, 
   [COORD @D155371, AGR [COUNT @D155370, PER @D155369, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, PRT OFF, ARITY 3] : TIP, 
   [COORD @D155373, AGR [COUNT @D155372, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, PRT OFF, ARITY 3] : TIP, 
   [COORD @D155375, AGR [COUNT @D155374, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, PRT OFF, ARITY 3] : TIP, 
   [COORD @D155379, AGR [COUNT @D155378, PER @D155377, PLU @D155376, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, PRT OFF, ARITY 3] : TIP, 
   [COORD @D155385, PAST @D155384, 
      AGR [CASE @D155383, COUNT @D155382, PER @D155381, PLU @D155380, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      PRT OFF, ARITY 3] : TIP, 
   [COORD @D155388, AGR [COUNT @D155387, PER @D155386, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM ABOUT, ARITY 3] : TIP, 
   [COORD @D155390, 
      AGR [COUNT @D155389, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM ABOUT, ARITY 3] : TIP, 
   [COORD @D155392, AGR [COUNT @D155391, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM ABOUT, ARITY 3] : TIP, 
   [COORD @D155396, 
      AGR [COUNT @D155395, PER @D155394, PLU @D155393, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, PFORM ABOUT, ARITY 3] : TIP, 
   [COORD @D155402, PAST @D155401, 
      AGR [CASE @D155400, COUNT @D155399, PER @D155398, PLU @D155397, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      PFORM ABOUT, ARITY 3] : TIP, 
   [COORD @D155405, AGR [COUNT @D155404, PER @D155403, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIP, 
   [COORD @D155407, AGR [COUNT @D155406, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIP, 
   [COORD @D155409, AGR [COUNT @D155408, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TIP, 
   [COORD @D155413, AGR [COUNT @D155412, PER @D155411, PLU @D155410, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TIP, 
   [COORD @D155419, PAST @D155418, AGR [CASE @D155417, COUNT @D155416, 
            PER @D155415, PLU @D155414, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TIP, 
   [COORD @D155422, AGR [COUNT @D155421, PER @D155420, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TIP, 
   [COORD @D155424, AGR [COUNT @D155423, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TIP, 
   [COORD @D155426, AGR [COUNT @D155425, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TIP, 
   [COORD @D155430, AGR [COUNT @D155429, PER @D155428, PLU @D155427, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : TIP, 
   [COORD @D155436, PAST @D155435, 
      AGR [CASE @D155434, COUNT @D155433, PER @D155432, PLU @D155431, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : TIP, 
   [COORD @D155439, AGR [COUNT @D155438, PER @D155437, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TIP, 
   [COORD @D155441, AGR [COUNT @D155440, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TIP, 
   [COORD @D155443, AGR [COUNT @D155442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TIP, 
   [COORD @D155447, AGR [COUNT @D155446, PER @D155445, PLU @D155444, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : TIP, 
   [COORD @D155453, PAST @D155452, 
      AGR [CASE @D155451, COUNT @D155450, PER @D155449, PLU @D155448, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TIP, 
   [COORD @D155456, AGR [COUNT @D155455, PER @D155454, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : TIP, 
   [COORD @D155458, AGR [COUNT @D155457, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : TIP, 
   [COORD @D155460, AGR [COUNT @D155459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : TIP, 
   [COORD @D155464, AGR [COUNT @D155463, PER @D155462, PLU @D155461, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : TIP, 
   [COORD @D155470, PAST @D155469, 
      AGR [CASE @D155468, COUNT @D155467, PER @D155466, PLU @D155465, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : TIP, 
   [COORD @D155473, AGR [COUNT @D155472, PER @D155471, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIP, 
   [COORD @D155475, AGR [COUNT @D155474, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIP, 
   [COORD @D155477, AGR [COUNT @D155476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIP, 
   [COORD @D155481, AGR [COUNT @D155480, PER @D155479, PLU @D155478, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TIP, 
   [COORD @D155487, PAST @D155486, AGR [CASE @D155485, COUNT @D155484, 
            PER @D155483, PLU @D155482, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TIP, 
   [COORD @D155490, AGR [COUNT @D155489, PER @D155488, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIP, 
   [COORD @D155492, AGR [COUNT @D155491, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIP, 
   [COORD @D155494, AGR [COUNT @D155493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIP, 
   [COORD @D155498, AGR [COUNT @D155497, PER @D155496, PLU @D155495, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TIP, 
   [COORD @D155504, PAST @D155503, 
      AGR [CASE @D155502, COUNT @D155501, PER @D155500, PLU @D155499, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : TIP, 
   [COORD @D155507, AGR [COUNT @D155506, PER @D155505, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TIP, 
   [COORD @D155509, AGR [COUNT @D155508, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TIP, 
   [COORD @D155511, AGR [COUNT @D155510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TIP, 
   [COORD @D155515, AGR [COUNT @D155514, PER @D155513, PLU @D155512, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TIP, 
   [COORD @D155521, PAST @D155520, 
      AGR [CASE @D155519, COUNT @D155518, PER @D155517, PLU @D155516, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : TIP, 
   [COORD @D155524, AGR [COUNT @D155523, PER @D155522, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TIP, 
   [COORD @D155526, AGR [COUNT @D155525, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TIP, 
   [COORD @D155528, AGR [COUNT @D155527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TIP, 
   [COORD @D155532, AGR [COUNT @D155531, PER @D155530, PLU @D155529, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TIP, 
   [COORD @D155538, PAST @D155537, 
      AGR [CASE @D155536, COUNT @D155535, PER @D155534, PLU @D155533, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : TIP.

WORD tipped : 
   [COORD @D155549, AGR [CASE @D155548, COUNT @D155547, PER @D155546, 
            PLU @D155545, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155554, AGR [CASE @D155553, COUNT @D155552, PER @D155551, 
            PLU @D155550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155560, AGR [CASE @D155559, NFORM @D155558, COUNT @D155557, 
            PER @D155556, PLU @D155555, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIP, 
   [COORD @D155565, AGR [CASE @D155564, COUNT @D155563, PER @D155562, 
            PLU @D155561, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIP, 
   [COORD @D155570, AGR [CASE @D155569, COUNT @D155568, PER @D155567, 
            PLU @D155566, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155575, AGR [CASE @D155574, COUNT @D155573, PER @D155572, 
            PLU @D155571, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155580, AGR [CASE @D155579, COUNT @D155578, PER @D155577, 
            PLU @D155576, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIP, 
   [COORD @D155585, AGR [CASE @D155584, COUNT @D155583, PER @D155582, 
            PLU @D155581, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155590, AGR [CASE @D155589, COUNT @D155588, PER @D155587, 
            PLU @D155586, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155595, AGR [CASE @D155594, COUNT @D155593, PER @D155592, 
            PLU @D155591, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155600, AGR [CASE @D155599, COUNT @D155598, PER @D155597, 
            PLU @D155596, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, PRT OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155605, AGR [CASE @D155604, COUNT @D155603, PER @D155602, 
            PLU @D155601, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, PRT OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155610, AGR [CASE @D155609, COUNT @D155608, PER @D155607, 
            PLU @D155606, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM ABOUT, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155615, AGR [CASE @D155614, COUNT @D155613, PER @D155612, 
            PLU @D155611, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155620, 
      AGR [CASE @D155619, COUNT @D155618, PER @D155617, PLU @D155616, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, PFORM ABOUT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155625, AGR [CASE @D155624, COUNT @D155623, PER @D155622, 
            PLU @D155621, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIP, 
   [COORD @D155630, AGR [CASE @D155629, COUNT @D155628, PER @D155627, 
            PLU @D155626, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155635, AGR [CASE @D155634, COUNT @D155633, PER @D155632, 
            PLU @D155631, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155640, AGR [CASE @D155639, COUNT @D155638, PER @D155637, 
            PLU @D155636, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155645, AGR [CASE @D155644, COUNT @D155643, PER @D155642, 
            PLU @D155641, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155650, AGR [CASE @D155649, COUNT @D155648, PER @D155647, 
            PLU @D155646, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155655, AGR [CASE @D155654, COUNT @D155653, PER @D155652, 
            PLU @D155651, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155660, AGR [CASE @D155659, COUNT @D155658, PER @D155657, 
            PLU @D155656, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155665, AGR [CASE @D155664, COUNT @D155663, PER @D155662, 
            PLU @D155661, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155670, AGR [CASE @D155669, COUNT @D155668, PER @D155667, 
            PLU @D155666, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155675, AGR [CASE @D155674, COUNT @D155673, PER @D155672, 
            PLU @D155671, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155680, AGR [CASE @D155679, COUNT @D155678, PER @D155677, 
            PLU @D155676, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155685, AGR [CASE @D155684, COUNT @D155683, PER @D155682, 
            PLU @D155681, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155690, AGR [CASE @D155689, COUNT @D155688, PER @D155687, 
            PLU @D155686, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155695, AGR [CASE @D155694, COUNT @D155693, PER @D155692, 
            PLU @D155691, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155700, AGR [CASE @D155699, COUNT @D155698, PER @D155697, 
            PLU @D155696, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155705, AGR [CASE @D155704, COUNT @D155703, PER @D155702, 
            PLU @D155701, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155710, AGR [CASE @D155709, COUNT @D155708, PER @D155707, 
            PLU @D155706, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIP, 
   [COORD @D155715, AGR [CASE @D155714, COUNT @D155713, PER @D155712, 
            PLU @D155711, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155720, AGR [CASE @D155719, COUNT @D155718, PER @D155717, 
            PLU @D155716, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TIP.

WORD tipping : 
   [COORD @D155732, PRD @D155731, AGR [CASE @D155730, COUNT @D155729, 
            PER @D155728, PLU @D155727, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155738, PRD @D155737, 
      AGR [CASE @D155736, COUNT @D155735, PER @D155734, PLU @D155733, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TIP, 
   [COORD @D155744, PRD @D155743, AGR [CASE @D155742, COUNT @D155741, 
            PER @D155740, PLU @D155739, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155750, PRD @D155749, 
      AGR [CASE @D155748, COUNT @D155747, PER @D155746, PLU @D155745, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIP, 
   [COORD @D155756, PRD @D155755, AGR [CASE @D155754, COUNT @D155753, 
            PER @D155752, PLU @D155751, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155762, PRD @D155761, 
      AGR [CASE @D155760, COUNT @D155759, PER @D155758, PLU @D155757, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TIP, 
   [COORD @D155768, PRD @D155767, AGR [CASE @D155766, COUNT @D155765, 
            PER @D155764, PLU @D155763, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155774, PRD @D155773, 
      AGR [CASE @D155772, COUNT @D155771, PER @D155770, PLU @D155769, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TIP, 
   [COORD @D155780, PRD @D155779, AGR [CASE @D155778, COUNT @D155777, 
            PER @D155776, PLU @D155775, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155786, PRD @D155785, 
      AGR [CASE @D155784, COUNT @D155783, PER @D155782, PLU @D155781, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TIP, 
   [COORD @D155792, PRD @D155791, AGR [CASE @D155790, COUNT @D155789, 
            PER @D155788, PLU @D155787, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP, 
   [COORD @D155798, PRD @D155797, 
      AGR [CASE @D155796, COUNT @D155795, PER @D155794, PLU @D155793, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TIP, 
   [COORD @D155804, PRD @D155803, AGR [CASE @D155802, COUNT @D155801, 
            PER @D155800, PLU @D155799, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TIP.

WORD tips : 
   [COORD @D155815, DEMON @D155814, REFL @D155813, PRD @D155812, 
      CASE @D155811, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TIP, 
   [COORD @D155820, DEMON @D155819, REFL @D155818, PRD @D155817, 
      CASE @D155816, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TIP, 
   [COORD @D155825, DEMON @D155824, REFL @D155823, PRD @D155822, 
      CASE @D155821, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT SFIN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : TIP, 
   [COORD @D155827, 
      AGR [COUNT @D155826, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155829, 
      AGR [COUNT @D155828, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155831, 
      AGR [COUNT @D155830, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155833, 
      AGR [COUNT @D155832, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_SFIN, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155835, 
      AGR [COUNT @D155834, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TIP, 
   [COORD @D155837, AGR [COUNT @D155836, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155839, 
      AGR [COUNT @D155838, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155841, 
      AGR [COUNT @D155840, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155843, 
      AGR [COUNT @D155842, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155845, 
      AGR [COUNT @D155844, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155847, 
      AGR [COUNT @D155846, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155849, 
      AGR [COUNT @D155848, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP, 
   [COORD @D155851, 
      AGR [COUNT @D155850, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TIP.

WORD told : 
   [COORD @D155860, PAST @D155859, AGR [CASE @D155858, COUNT @D155857, 
            PER @D155856, PLU @D155855, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 3] : TELL, 
   [COORD @D155866, PAST @D155865, 
      AGR [CASE @D155864, COUNT @D155863, PER @D155862, PLU @D155861, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, FIN -, 
      ARITY 3] : TELL, 
   [COORD @D155872, PAST @D155871, AGR [CASE @D155870, COUNT @D155869, 
            PER @D155868, PLU @D155867, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHVP, REG -, FIN -, ARITY 3] : TELL, 
   [COORD @D155878, PAST @D155877, 
      AGR [CASE @D155876, COUNT @D155875, PER @D155874, PLU @D155873, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHVP, REG -, FIN -, 
      ARITY 3] : TELL, 
   [COORD @D155884, PAST @D155883, AGR [CASE @D155882, COUNT @D155881, 
            PER @D155880, PLU @D155879, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHS, REG -, FIN -, ARITY 3] : TELL, 
   [COORD @D155890, PAST @D155889, 
      AGR [CASE @D155888, COUNT @D155887, PER @D155886, PLU @D155885, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_WHS, REG -, FIN -, 
      ARITY 3] : TELL, 
   [COORD @D155896, PAST @D155895, AGR [CASE @D155894, COUNT @D155893, 
            PER @D155892, PLU @D155891, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, FIN -, ARITY 3] : TELL, 
   [COORD @D155902, PAST @D155901, 
      AGR [CASE @D155900, COUNT @D155899, PER @D155898, PLU @D155897, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, REG -, FIN -, 
      ARITY 3] : TELL, 
   [COORD @D155908, PAST @D155907, AGR [CASE @D155906, COUNT @D155905, 
            PER @D155904, PLU @D155903, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : TELL, 
   [COORD @D155914, PAST @D155913, 
      AGR [CASE @D155912, COUNT @D155911, PER @D155910, PLU @D155909, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : TELL, 
   [COORD @D155920, PAST @D155919, AGR [CASE @D155918, COUNT @D155917, 
            PER @D155916, PLU @D155915, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PRT OFF, FIN -, ARITY 3] : TELL, 
   [COORD @D155926, PAST @D155925, 
      AGR [CASE @D155924, COUNT @D155923, PER @D155922, PLU @D155921, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, REG -, PRT OFF, 
      FIN -, ARITY 3] : TELL, 
   [COORD @D155932, PAST @D155931, AGR [CASE @D155930, COUNT @D155929, 
            PER @D155928, PLU @D155927, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, FIN -, ARITY 3] : TELL, 
   [COORD @D155938, PAST @D155937, 
      AGR [CASE @D155936, COUNT @D155935, PER @D155934, PLU @D155933, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM TO, 
      FIN -, ARITY 3] : TELL, 
   [COORD @D155944, PAST @D155943, AGR [CASE @D155942, COUNT @D155941, 
            PER @D155940, PLU @D155939, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OF, FIN -, ARITY 3] : TELL, 
   [COORD @D155950, PAST @D155949, 
      AGR [CASE @D155948, COUNT @D155947, PER @D155946, PLU @D155945, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM OF, 
      FIN -, ARITY 3] : TELL, 
   [COORD @D155956, PAST @D155955, AGR [CASE @D155954, COUNT @D155953, 
            PER @D155952, PLU @D155951, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM FROM, FIN -, ARITY 3] : TELL, 
   [COORD @D155962, PAST @D155961, 
      AGR [CASE @D155960, COUNT @D155959, PER @D155958, PLU @D155957, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM FROM, 
      FIN -, ARITY 3] : TELL, 
   [COORD @D155966, AGR [COUNT @D155965, PER @D155964, PLU @D155963, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PAST +, ARITY 3] : TELL, 
   [COORD @D155970, AGR [COUNT @D155969, PER @D155968, PLU @D155967, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHVP, REG -, PAST +, ARITY 3] : TELL, 
   [COORD @D155974, AGR [COUNT @D155973, PER @D155972, PLU @D155971, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_WHS, REG -, PAST +, ARITY 3] : TELL, 
   [COORD @D155978, AGR [COUNT @D155977, PER @D155976, PLU @D155975, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, PAST +, ARITY 3] : TELL, 
   [COORD @D155982, AGR [COUNT @D155981, PER @D155980, PLU @D155979, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : TELL, 
   [COORD @D155986, AGR [COUNT @D155985, PER @D155984, PLU @D155983, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, REG -, PRT OFF, PAST +, ARITY 3] : TELL, 
   [COORD @D155990, 
      AGR [COUNT @D155989, PER @D155988, PLU @D155987, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, 
      PFORM TO, PAST +, ARITY 3] : TELL, 
   [COORD @D155994, AGR [COUNT @D155993, PER @D155992, PLU @D155991, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM OF, PAST +, ARITY 3] : TELL, 
   [COORD @D155998, 
      AGR [COUNT @D155997, PER @D155996, PLU @D155995, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM FROM, PAST +, ARITY 3] : TELL, 
   [COORD @D156004, PAST @D156003, 
      AGR [CASE @D156002, COUNT @D156001, PER @D156000, PLU @D155999, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, REG -, FIN -, 
      ARITY 2] : TELL, 
   [COORD @D156010, PAST @D156009, AGR [CASE @D156008, COUNT @D156007, 
            PER @D156006, PLU @D156005, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, FIN -, ARITY 2] : TELL, 
   [COORD @D156016, PAST @D156015, 
      AGR [CASE @D156014, COUNT @D156013, PER @D156012, PLU @D156011, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, FIN -, 
      ARITY 2] : TELL, 
   [COORD @D156022, PAST @D156021, AGR [CASE @D156020, COUNT @D156019, 
            PER @D156018, PLU @D156017, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : TELL, 
   [COORD @D156028, PAST @D156027, 
      AGR [CASE @D156026, COUNT @D156025, PER @D156024, PLU @D156023, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : TELL, 
   [COORD @D156034, PAST @D156033, AGR [CASE @D156032, COUNT @D156031, 
            PER @D156030, PLU @D156029, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM ON, FIN -, ARITY 2] : TELL, 
   [COORD @D156040, PAST @D156039, 
      AGR [CASE @D156038, COUNT @D156037, PER @D156036, PLU @D156035, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM ON, FIN -, 
      ARITY 2] : TELL, 
   [COORD @D156046, PAST @D156045, AGR [CASE @D156044, COUNT @D156043, 
            PER @D156042, PLU @D156041, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, SUBCAT PP, SUBTYPE PVERB, PSVE +, PRD +, FIX NOT, V +, N -, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PFORM AGAINST, FIN -, ARITY 2] : TELL, 
   [COORD @D156052, PAST @D156051, 
      AGR [CASE @D156050, COUNT @D156049, PER @D156048, PLU @D156047, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM AGAINST, 
      FIN -, ARITY 2] : TELL, 
   [COORD @D156058, PAST @D156057, AGR [CASE @D156056, COUNT @D156055, 
            PER @D156054, PLU @D156053, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, FIN -, ARITY 2] : TELL, 
   [COORD @D156064, PAST @D156063, 
      AGR [CASE @D156062, COUNT @D156061, PER @D156060, PLU @D156059, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      FIN -, ARITY 2] : TELL, 
   [COORD @D156070, PAST @D156069, AGR [CASE @D156068, COUNT @D156067, 
            PER @D156066, PLU @D156065, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, 
      AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT APART, FIN -, ARITY 2] : TELL, 
   [COORD @D156076, PAST @D156075, 
      AGR [CASE @D156074, COUNT @D156073, PER @D156072, PLU @D156071, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT APART, FIN -, ARITY 2] : TELL, 
   [COORD @D156080, AGR [COUNT @D156079, PER @D156078, PLU @D156077, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, REG -, PAST +, ARITY 2] : TELL, 
   [COORD @D156084, AGR [COUNT @D156083, PER @D156082, PLU @D156081, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PAST +, ARITY 2] : TELL, 
   [COORD @D156088, AGR [COUNT @D156087, PER @D156086, PLU @D156085, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PAST +, ARITY 2] : TELL, 
   [COORD @D156092, AGR [COUNT @D156091, PER @D156090, PLU @D156089, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : TELL, 
   [COORD @D156096, AGR [COUNT @D156095, PER @D156094, PLU @D156093, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM ON, PAST +, ARITY 2] : TELL, 
   [COORD @D156100, AGR [COUNT @D156099, PER @D156098, PLU @D156097, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      REG -, PFORM AGAINST, PAST +, ARITY 2] : TELL, 
   [COORD @D156104, AGR [COUNT @D156103, PER @D156102, PLU @D156101, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT OFF, PAST +, ARITY 2] : TELL, 
   [COORD @D156108, AGR [COUNT @D156107, PER @D156106, PLU @D156105, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT APART, PAST +, ARITY 2] : TELL, 
   [COORD @D156114, PAST @D156113, 
      AGR [CASE @D156112, COUNT @D156111, PER @D156110, PLU @D156109, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : TELL, 
   [COORD @D156120, PAST @D156119, AGR [CASE @D156118, COUNT @D156117, 
            PER @D156116, PLU @D156115, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, FIN -, ARITY 1] : TELL, 
   [COORD @D156126, PAST @D156125, 
      AGR [CASE @D156124, COUNT @D156123, PER @D156122, PLU @D156121, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT APART, 
      FIN -, ARITY 1] : TELL, 
   [COORD @D156130, AGR [COUNT @D156129, PER @D156128, PLU @D156127, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : TELL, 
   [COORD @D156134, AGR [COUNT @D156133, PER @D156132, PLU @D156131, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, PAST +, ARITY 1] : TELL, 
   [COORD @D156138, 
      AGR [COUNT @D156137, PER @D156136, PLU @D156135, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT APART, PAST +, ARITY 1] : TELL.

WORD torture : 
   [COORD @D156160, REFL @D156159, COUNT @D156158, PRD @D156157, 
      CASE @D156156, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TORTURE, 
   [COORD @D156163, 
      AGR [COUNT @D156162, PER @D156161, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   TORTURE, 
   [COORD @D156165, AGR [COUNT @D156164, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TORTURE, 
   [COORD @D156167, AGR [COUNT @D156166, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TORTURE, 
   [COORD @D156171, AGR [COUNT @D156170, PER @D156169, PLU @D156168, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TORTURE, 
   [COORD @D156177, PAST @D156176, AGR [CASE @D156175, COUNT @D156174, 
            PER @D156173, PLU @D156172, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TORTURE.

WORD tortured : 
   [COORD @D156189, AGR [CASE @D156188, COUNT @D156187, PER @D156186, 
            PLU @D156185, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TORTURE, 
   [COORD @D156194, AGR [CASE @D156193, COUNT @D156192, PER @D156191, 
            PLU @D156190, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TORTURE, 
   [COORD @D156199, AGR [CASE @D156198, COUNT @D156197, PER @D156196, 
            PLU @D156195, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TORTURE.

WORD tortures : 
   [COORD @D156211, DEMON @D156210, REFL @D156209, PRD @D156208, 
      CASE @D156207, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TORTURE, 
   [COORD @D156213, AGR [COUNT @D156212, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TORTURE.

WORD torturing : 
   [COORD @D156224, PRD @D156223, AGR [CASE @D156222, COUNT @D156221, 
            PER @D156220, PLU @D156219, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TORTURE.

WORD touch : 
   [COORD @D156231, REFL @D156230, PRD @D156229, CASE @D156228, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TOUCH, 
   [COORD @D156235, REFL @D156234, PRD @D156233, CASE @D156232, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TOUCH, 
   [COORD @D156240, REFL @D156239, COUNT @D156238, PRD @D156237, 
      CASE @D156236, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TOUCH, 
   [COORD @D156244, REFL @D156243, PRD @D156242, CASE @D156241, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TOUCH, 
   [COORD @D156248, REFL @D156247, PRD @D156246, CASE @D156245, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : TOUCH, 
   [COORD @D156252, REFL @D156251, PRD @D156250, CASE @D156249, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : TOUCH, 
   [COORD @D156255, 
      AGR [COUNT @D156254, PER @D156253, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : TOUCH, 
   [COORD @D156257, AGR [COUNT @D156256, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TOUCH, 
   [COORD @D156259, AGR [COUNT @D156258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TOUCH, 
   [COORD @D156263, AGR [COUNT @D156262, PER @D156261, PLU @D156260, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TOUCH, 
   [COORD @D156269, PAST @D156268, 
      AGR [CASE @D156267, COUNT @D156266, PER @D156265, PLU @D156264, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : TOUCH, 
   [COORD @D156272, AGR [COUNT @D156271, PER @D156270, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TOUCH, 
   [COORD @D156274, AGR [COUNT @D156273, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TOUCH, 
   [COORD @D156276, AGR [COUNT @D156275, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TOUCH, 
   [COORD @D156280, AGR [COUNT @D156279, PER @D156278, PLU @D156277, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TOUCH, 
   [COORD @D156286, PAST @D156285, AGR [CASE @D156284, COUNT @D156283, 
            PER @D156282, PLU @D156281, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TOUCH, 
   [COORD @D156289, AGR [COUNT @D156288, PER @D156287, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT OFF, ARITY 2] : TOUCH, 
   [COORD @D156291, AGR [COUNT @D156290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT OFF, ARITY 2] : TOUCH, 
   [COORD @D156293, AGR [COUNT @D156292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT OFF, ARITY 2] : TOUCH, 
   [COORD @D156297, AGR [COUNT @D156296, PER @D156295, PLU @D156294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, PRT OFF, ARITY 2] : TOUCH, 
   [COORD @D156303, PAST @D156302, 
      AGR [CASE @D156301, COUNT @D156300, PER @D156299, PLU @D156298, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      PRT OFF, ARITY 2] : TOUCH, 
   [COORD @D156306, AGR [COUNT @D156305, PER @D156304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TOUCH, 
   [COORD @D156308, AGR [COUNT @D156307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TOUCH, 
   [COORD @D156310, AGR [COUNT @D156309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TOUCH, 
   [COORD @D156314, AGR [COUNT @D156313, PER @D156312, PLU @D156311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : TOUCH, 
   [COORD @D156320, PAST @D156319, 
      AGR [CASE @D156318, COUNT @D156317, PER @D156316, PLU @D156315, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TOUCH, 
   [COORD @D156323, AGR [COUNT @D156322, PER @D156321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TOUCH, 
   [COORD @D156325, AGR [COUNT @D156324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TOUCH, 
   [COORD @D156327, AGR [COUNT @D156326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TOUCH, 
   [COORD @D156331, AGR [COUNT @D156330, PER @D156329, PLU @D156328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : TOUCH, 
   [COORD @D156337, PAST @D156336, 
      AGR [CASE @D156335, COUNT @D156334, PER @D156333, PLU @D156332, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TOUCH, 
   [COORD @D156340, AGR [COUNT @D156339, PER @D156338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TOUCH, 
   [COORD @D156342, AGR [COUNT @D156341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TOUCH, 
   [COORD @D156344, AGR [COUNT @D156343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TOUCH, 
   [COORD @D156348, AGR [COUNT @D156347, PER @D156346, PLU @D156345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : TOUCH, 
   [COORD @D156354, PAST @D156353, 
      AGR [CASE @D156352, COUNT @D156351, PER @D156350, PLU @D156349, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : TOUCH, 
   [COORD @D156357, AGR [COUNT @D156356, PER @D156355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TOUCH, 
   [COORD @D156359, AGR [COUNT @D156358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TOUCH, 
   [COORD @D156361, AGR [COUNT @D156360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TOUCH, 
   [COORD @D156365, AGR [COUNT @D156364, PER @D156363, PLU @D156362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TOUCH, 
   [COORD @D156371, PAST @D156370, AGR [CASE @D156369, COUNT @D156368, 
            PER @D156367, PLU @D156366, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TOUCH, 
   [COORD @D156374, AGR [COUNT @D156373, PER @D156372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TOUCH, 
   [COORD @D156376, AGR [COUNT @D156375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TOUCH, 
   [COORD @D156378, AGR [COUNT @D156377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TOUCH, 
   [COORD @D156382, AGR [COUNT @D156381, PER @D156380, PLU @D156379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TOUCH, 
   [COORD @D156388, PAST @D156387, 
      AGR [CASE @D156386, COUNT @D156385, PER @D156384, PLU @D156383, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : TOUCH, 
   [COORD @D156391, AGR [COUNT @D156390, PER @D156389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TOUCH, 
   [COORD @D156393, AGR [COUNT @D156392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TOUCH, 
   [COORD @D156395, AGR [COUNT @D156394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TOUCH, 
   [COORD @D156399, AGR [COUNT @D156398, PER @D156397, PLU @D156396, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TOUCH, 
   [COORD @D156405, PAST @D156404, 
      AGR [CASE @D156403, COUNT @D156402, PER @D156401, PLU @D156400, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : TOUCH, 
   [COORD @D156408, AGR [COUNT @D156407, PER @D156406, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TOUCH, 
   [COORD @D156410, AGR [COUNT @D156409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TOUCH, 
   [COORD @D156412, AGR [COUNT @D156411, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TOUCH, 
   [COORD @D156416, AGR [COUNT @D156415, PER @D156414, PLU @D156413, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TOUCH, 
   [COORD @D156422, PAST @D156421, 
      AGR [CASE @D156420, COUNT @D156419, PER @D156418, PLU @D156417, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : TOUCH.

WORD touched : 
   [COORD @D156432, AGR [CASE @D156431, COUNT @D156430, PER @D156429, 
            PLU @D156428, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156437, AGR [CASE @D156436, COUNT @D156435, PER @D156434, 
            PLU @D156433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156442, AGR [CASE @D156441, COUNT @D156440, PER @D156439, 
            PLU @D156438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156447, AGR [CASE @D156446, COUNT @D156445, PER @D156444, 
            PLU @D156443, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TOUCH, 
   [COORD @D156452, AGR [CASE @D156451, COUNT @D156450, PER @D156449, 
            PLU @D156448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156457, AGR [CASE @D156456, COUNT @D156455, PER @D156454, 
            PLU @D156453, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156462, AGR [CASE @D156461, COUNT @D156460, PER @D156459, 
            PLU @D156458, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156467, AGR [CASE @D156466, COUNT @D156465, PER @D156464, 
            PLU @D156463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156472, AGR [CASE @D156471, COUNT @D156470, PER @D156469, 
            PLU @D156468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156477, AGR [CASE @D156476, COUNT @D156475, PER @D156474, 
            PLU @D156473, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156482, AGR [CASE @D156481, COUNT @D156480, PER @D156479, 
            PLU @D156478, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156487, AGR [CASE @D156486, COUNT @D156485, PER @D156484, 
            PLU @D156483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156492, AGR [CASE @D156491, COUNT @D156490, PER @D156489, 
            PLU @D156488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156497, AGR [CASE @D156496, COUNT @D156495, PER @D156494, 
            PLU @D156493, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156502, AGR [CASE @D156501, COUNT @D156500, PER @D156499, 
            PLU @D156498, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156507, AGR [CASE @D156506, COUNT @D156505, PER @D156504, 
            PLU @D156503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156512, AGR [CASE @D156511, COUNT @D156510, PER @D156509, 
            PLU @D156508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156517, AGR [CASE @D156516, COUNT @D156515, PER @D156514, 
            PLU @D156513, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156522, AGR [CASE @D156521, COUNT @D156520, PER @D156519, 
            PLU @D156518, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156527, AGR [CASE @D156526, COUNT @D156525, PER @D156524, 
            PLU @D156523, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156532, AGR [CASE @D156531, COUNT @D156530, PER @D156529, 
            PLU @D156528, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156537, AGR [CASE @D156536, COUNT @D156535, PER @D156534, 
            PLU @D156533, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156542, AGR [CASE @D156541, COUNT @D156540, PER @D156539, 
            PLU @D156538, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156547, AGR [CASE @D156546, COUNT @D156545, PER @D156544, 
            PLU @D156543, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156552, AGR [CASE @D156551, COUNT @D156550, PER @D156549, 
            PLU @D156548, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156557, AGR [CASE @D156556, COUNT @D156555, PER @D156554, 
            PLU @D156553, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUCH.

WORD touches : 
   [COORD @D156567, DEMON @D156566, REFL @D156565, PRD @D156564, 
      CASE @D156563, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TOUCH, 
   [COORD @D156572, DEMON @D156571, REFL @D156570, PRD @D156569, 
      CASE @D156568, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TOUCH, 
   [COORD @D156577, DEMON @D156576, REFL @D156575, PRD @D156574, 
      CASE @D156573, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TOUCH, 
   [COORD @D156579, AGR [COUNT @D156578, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TOUCH, 
   [COORD @D156581, AGR [COUNT @D156580, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156583, 
      AGR [COUNT @D156582, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156585, 
      AGR [COUNT @D156584, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156587, 
      AGR [COUNT @D156586, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156589, 
      AGR [COUNT @D156588, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156591, 
      AGR [COUNT @D156590, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156593, 
      AGR [COUNT @D156592, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156595, 
      AGR [COUNT @D156594, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156597, 
      AGR [COUNT @D156596, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUCH.

WORD touching : 
   [COORD @D156612, PRD @D156611, AGR [CASE @D156610, COUNT @D156609, 
            PER @D156608, PLU @D156607, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156618, PRD @D156617, 
      AGR [CASE @D156616, COUNT @D156615, PER @D156614, PLU @D156613, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TOUCH, 
   [COORD @D156624, PRD @D156623, AGR [CASE @D156622, COUNT @D156621, 
            PER @D156620, PLU @D156619, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156630, PRD @D156629, 
      AGR [CASE @D156628, COUNT @D156627, PER @D156626, PLU @D156625, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TOUCH, 
   [COORD @D156636, PRD @D156635, AGR [CASE @D156634, COUNT @D156633, 
            PER @D156632, PLU @D156631, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156642, PRD @D156641, 
      AGR [CASE @D156640, COUNT @D156639, PER @D156638, PLU @D156637, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TOUCH, 
   [COORD @D156648, PRD @D156647, AGR [CASE @D156646, COUNT @D156645, 
            PER @D156644, PLU @D156643, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156654, PRD @D156653, 
      AGR [CASE @D156652, COUNT @D156651, PER @D156650, PLU @D156649, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TOUCH, 
   [COORD @D156660, PRD @D156659, AGR [CASE @D156658, COUNT @D156657, 
            PER @D156656, PLU @D156655, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TOUCH, 
   [COORD @D156666, PRD @D156665, 
      AGR [CASE @D156664, COUNT @D156663, PER @D156662, PLU @D156661, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TOUCH.

WORD tour : 
   [COORD @D156678, REFL @D156677, PRD @D156676, CASE @D156675, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM IN, COUNT +] : TOUR, 
   [COORD @D156683, REFL @D156682, COUNT @D156681, PRD @D156680, 
      CASE @D156679, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TOUR, 
   [COORD @D156687, REFL @D156686, PRD @D156685, CASE @D156684, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ROUND, COUNT +] : TOUR, 
   [COORD @D156692, REFL @D156691, COUNT @D156690, PRD @D156689, 
      CASE @D156688, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TOUR, 
   [COORD @D156695, 
      AGR [COUNT @D156694, PER @D156693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   TOUR, 
   [COORD @D156697, AGR [COUNT @D156696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TOUR, 
   [COORD @D156699, AGR [COUNT @D156698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TOUR, 
   [COORD @D156703, AGR [COUNT @D156702, PER @D156701, PLU @D156700, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TOUR, 
   [COORD @D156709, PAST @D156708, AGR [CASE @D156707, COUNT @D156706, 
            PER @D156705, PLU @D156704, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TOUR, 
   [COORD @D156712, AGR [COUNT @D156711, PER @D156710, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TOUR, 
   [COORD @D156714, AGR [COUNT @D156713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TOUR, 
   [COORD @D156716, AGR [COUNT @D156715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TOUR, 
   [COORD @D156720, AGR [COUNT @D156719, PER @D156718, PLU @D156717, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ROUND, ARITY 2] : TOUR, 
   [COORD @D156726, PAST @D156725, 
      AGR [CASE @D156724, COUNT @D156723, PER @D156722, PLU @D156721, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ROUND, ARITY 2] : TOUR.

WORD toured : 
   [COORD @D156736, AGR [CASE @D156735, COUNT @D156734, PER @D156733, 
            PLU @D156732, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TOUR, 
   [COORD @D156741, AGR [CASE @D156740, COUNT @D156739, PER @D156738, 
            PLU @D156737, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TOUR, 
   [COORD @D156746, AGR [CASE @D156745, COUNT @D156744, PER @D156743, 
            PLU @D156742, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TOUR, 
   [COORD @D156751, AGR [CASE @D156750, COUNT @D156749, PER @D156748, 
            PLU @D156747, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUR, 
   [COORD @D156756, AGR [CASE @D156755, COUNT @D156754, PER @D156753, 
            PLU @D156752, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TOUR.

WORD touring : 
   [COORD @D156771, PRD @D156770, AGR [CASE @D156769, COUNT @D156768, 
            PER @D156767, PLU @D156766, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TOUR, 
   [COORD @D156777, PRD @D156776, 
      AGR [CASE @D156775, COUNT @D156774, PER @D156773, PLU @D156772, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TOUR.

WORD tours : 
   [COORD @D156787, DEMON @D156786, REFL @D156785, PRD @D156784, 
      CASE @D156783, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM IN, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TOUR, 
   [COORD @D156792, DEMON @D156791, REFL @D156790, PRD @D156789, 
      CASE @D156788, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TOUR, 
   [COORD @D156797, DEMON @D156796, REFL @D156795, PRD @D156794, 
      CASE @D156793, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ROUND, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TOUR, 
   [COORD @D156802, DEMON @D156801, REFL @D156800, PRD @D156799, 
      CASE @D156798, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TOUR, 
   [COORD @D156804, AGR [COUNT @D156803, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUR, 
   [COORD @D156806, 
      AGR [COUNT @D156805, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TOUR.

WORD trade : 
   [COORD @D156814, AGR [COUNT @D156813, PER @D156812, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156816, AGR [COUNT @D156815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156818, AGR [COUNT @D156817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156822, AGR [COUNT @D156821, PER @D156820, PLU @D156819, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156828, PAST @D156827, 
      AGR [CASE @D156826, COUNT @D156825, PER @D156824, PLU @D156823, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156831, AGR [COUNT @D156830, PER @D156829, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156833, 
      AGR [COUNT @D156832, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, PFORM FOR, 
      ARITY 3] : TRADE, 
   [COORD @D156835, AGR [COUNT @D156834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156839, 
      AGR [COUNT @D156838, PER @D156837, PLU @D156836, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156845, PAST @D156844, 
      AGR [CASE @D156843, COUNT @D156842, PER @D156841, PLU @D156840, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      PFORM FOR, ARITY 3] : TRADE, 
   [COORD @D156848, AGR [COUNT @D156847, PER @D156846, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRADE, 
   [COORD @D156850, AGR [COUNT @D156849, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRADE, 
   [COORD @D156852, AGR [COUNT @D156851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRADE, 
   [COORD @D156856, AGR [COUNT @D156855, PER @D156854, PLU @D156853, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TRADE, 
   [COORD @D156862, PAST @D156861, AGR [CASE @D156860, COUNT @D156859, 
            PER @D156858, PLU @D156857, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TRADE, 
   [COORD @D156865, AGR [COUNT @D156864, PER @D156863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TRADE, 
   [COORD @D156867, AGR [COUNT @D156866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TRADE, 
   [COORD @D156869, AGR [COUNT @D156868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TRADE, 
   [COORD @D156873, AGR [COUNT @D156872, PER @D156871, PLU @D156870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : TRADE, 
   [COORD @D156879, PAST @D156878, 
      AGR [CASE @D156877, COUNT @D156876, PER @D156875, PLU @D156874, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TRADE, 
   [COORD @D156882, AGR [COUNT @D156881, PER @D156880, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TRADE, 
   [COORD @D156884, AGR [COUNT @D156883, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TRADE, 
   [COORD @D156886, AGR [COUNT @D156885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TRADE, 
   [COORD @D156890, AGR [COUNT @D156889, PER @D156888, PLU @D156887, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : TRADE, 
   [COORD @D156896, PAST @D156895, 
      AGR [CASE @D156894, COUNT @D156893, PER @D156892, PLU @D156891, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : TRADE, 
   [COORD @D156899, AGR [COUNT @D156898, PER @D156897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TRADE, 
   [COORD @D156901, AGR [COUNT @D156900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TRADE, 
   [COORD @D156903, AGR [COUNT @D156902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TRADE, 
   [COORD @D156907, AGR [COUNT @D156906, PER @D156905, PLU @D156904, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : TRADE, 
   [COORD @D156913, PAST @D156912, 
      AGR [CASE @D156911, COUNT @D156910, PER @D156909, PLU @D156908, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TRADE, 
   [COORD @D156916, AGR [COUNT @D156915, PER @D156914, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : TRADE, 
   [COORD @D156918, AGR [COUNT @D156917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : TRADE, 
   [COORD @D156920, AGR [COUNT @D156919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : TRADE, 
   [COORD @D156924, AGR [COUNT @D156923, PER @D156922, PLU @D156921, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : TRADE, 
   [COORD @D156930, PAST @D156929, 
      AGR [CASE @D156928, COUNT @D156927, PER @D156926, PLU @D156925, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : TRADE, 
   [COORD @D156933, AGR [COUNT @D156932, PER @D156931, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : TRADE, 
   [COORD @D156935, AGR [COUNT @D156934, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : TRADE, 
   [COORD @D156937, AGR [COUNT @D156936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : TRADE, 
   [COORD @D156941, AGR [COUNT @D156940, PER @D156939, PLU @D156938, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : TRADE, 
   [COORD @D156947, PAST @D156946, 
      AGR [CASE @D156945, COUNT @D156944, PER @D156943, PLU @D156942, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : TRADE, 
   [COORD @D156950, AGR [COUNT @D156949, PER @D156948, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRADE, 
   [COORD @D156952, AGR [COUNT @D156951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRADE, 
   [COORD @D156954, AGR [COUNT @D156953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRADE, 
   [COORD @D156958, AGR [COUNT @D156957, PER @D156956, PLU @D156955, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRADE, 
   [COORD @D156964, PAST @D156963, AGR [CASE @D156962, COUNT @D156961, 
            PER @D156960, PLU @D156959, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TRADE, 
   [COORD @D156967, AGR [COUNT @D156966, PER @D156965, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TRADE, 
   [COORD @D156969, AGR [COUNT @D156968, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TRADE, 
   [COORD @D156971, AGR [COUNT @D156970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TRADE, 
   [COORD @D156975, AGR [COUNT @D156974, PER @D156973, PLU @D156972, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TRADE, 
   [COORD @D156981, PAST @D156980, 
      AGR [CASE @D156979, COUNT @D156978, PER @D156977, PLU @D156976, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : TRADE.

WORD traded : 
   [COORD @D156992, AGR [CASE @D156991, COUNT @D156990, PER @D156989, 
            PLU @D156988, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D156997, AGR [CASE @D156996, COUNT @D156995, PER @D156994, 
            PLU @D156993, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157002, AGR [CASE @D157001, COUNT @D157000, PER @D156999, 
            PLU @D156998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157007, AGR [CASE @D157006, COUNT @D157005, PER @D157004, 
            PLU @D157003, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157012, AGR [CASE @D157011, COUNT @D157010, PER @D157009, 
            PLU @D157008, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157017, 
      AGR [CASE @D157016, COUNT @D157015, PER @D157014, PLU @D157013, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157022, AGR [CASE @D157021, COUNT @D157020, PER @D157019, 
            PLU @D157018, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRADE, 
   [COORD @D157027, AGR [CASE @D157026, COUNT @D157025, PER @D157024, 
            PLU @D157023, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157032, AGR [CASE @D157031, COUNT @D157030, PER @D157029, 
            PLU @D157028, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157037, AGR [CASE @D157036, COUNT @D157035, PER @D157034, 
            PLU @D157033, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157042, AGR [CASE @D157041, COUNT @D157040, PER @D157039, 
            PLU @D157038, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157047, AGR [CASE @D157046, COUNT @D157045, PER @D157044, 
            PLU @D157043, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157052, AGR [CASE @D157051, COUNT @D157050, PER @D157049, 
            PLU @D157048, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157057, AGR [CASE @D157056, COUNT @D157055, PER @D157054, 
            PLU @D157053, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157062, AGR [CASE @D157061, COUNT @D157060, PER @D157059, 
            PLU @D157058, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157067, AGR [CASE @D157066, COUNT @D157065, PER @D157064, 
            PLU @D157063, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157072, AGR [CASE @D157071, COUNT @D157070, PER @D157069, 
            PLU @D157068, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157077, AGR [CASE @D157076, COUNT @D157075, PER @D157074, 
            PLU @D157073, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157082, AGR [CASE @D157081, COUNT @D157080, PER @D157079, 
            PLU @D157078, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157087, AGR [CASE @D157086, COUNT @D157085, PER @D157084, 
            PLU @D157083, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157092, AGR [CASE @D157091, COUNT @D157090, PER @D157089, 
            PLU @D157088, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157097, AGR [CASE @D157096, COUNT @D157095, PER @D157094, 
            PLU @D157093, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157102, AGR [CASE @D157101, COUNT @D157100, PER @D157099, 
            PLU @D157098, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157107, AGR [CASE @D157106, COUNT @D157105, PER @D157104, 
            PLU @D157103, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157112, AGR [CASE @D157111, COUNT @D157110, PER @D157109, 
            PLU @D157108, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157117, AGR [CASE @D157116, COUNT @D157115, PER @D157114, 
            PLU @D157113, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRADE.

WORD trades : 
   [COORD @D157125, AGR [COUNT @D157124, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRADE, 
   [COORD @D157127, AGR [COUNT @D157126, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TRADE, 
   [COORD @D157129, AGR [COUNT @D157128, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE, 
   [COORD @D157131, 
      AGR [COUNT @D157130, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE, 
   [COORD @D157133, 
      AGR [COUNT @D157132, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE, 
   [COORD @D157135, 
      AGR [COUNT @D157134, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE, 
   [COORD @D157137, 
      AGR [COUNT @D157136, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE, 
   [COORD @D157139, 
      AGR [COUNT @D157138, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE, 
   [COORD @D157141, 
      AGR [COUNT @D157140, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE, 
   [COORD @D157143, 
      AGR [COUNT @D157142, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRADE.

WORD trading : 
   [COORD @D157154, PRD @D157153, AGR [CASE @D157152, COUNT @D157151, 
            PER @D157150, PLU @D157149, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157160, PRD @D157159, 
      AGR [CASE @D157158, COUNT @D157157, PER @D157156, PLU @D157155, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT IN, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157166, PRD @D157165, AGR [CASE @D157164, COUNT @D157163, 
            PER @D157162, PLU @D157161, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157172, PRD @D157171, 
      AGR [CASE @D157170, COUNT @D157169, PER @D157168, PLU @D157167, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRADE, 
   [COORD @D157178, PRD @D157177, AGR [CASE @D157176, COUNT @D157175, 
            PER @D157174, PLU @D157173, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157184, PRD @D157183, 
      AGR [CASE @D157182, COUNT @D157181, PER @D157180, PLU @D157179, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TRADE, 
   [COORD @D157190, PRD @D157189, AGR [CASE @D157188, COUNT @D157187, 
            PER @D157186, PLU @D157185, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157196, PRD @D157195, 
      AGR [CASE @D157194, COUNT @D157193, PER @D157192, PLU @D157191, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TRADE, 
   [COORD @D157202, PRD @D157201, AGR [CASE @D157200, COUNT @D157199, 
            PER @D157198, PLU @D157197, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRADE, 
   [COORD @D157208, PRD @D157207, 
      AGR [CASE @D157206, COUNT @D157205, PER @D157204, PLU @D157203, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRADE.

WORD train : 
   [COORD @D157217, REFL @D157216, COUNT @D157215, PRD @D157214, 
      CASE @D157213, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TRAIN, 
   [COORD @D157221, REFL @D157220, PRD @D157219, CASE @D157218, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, GROUP +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TRAIN, 
   [COORD @D157224, 
      AGR [COUNT @D157223, PER @D157222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : TRAIN, 
   [COORD @D157226, AGR [COUNT @D157225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TRAIN, 
   [COORD @D157228, AGR [COUNT @D157227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TRAIN, 
   [COORD @D157232, AGR [COUNT @D157231, PER @D157230, PLU @D157229, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TRAIN, 
   [COORD @D157238, PAST @D157237, AGR [CASE @D157236, COUNT @D157235, 
            PER @D157234, PLU @D157233, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : TRAIN, 
   [COORD @D157241, AGR [COUNT @D157240, PER @D157239, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : TRAIN, 
   [COORD @D157243, AGR [COUNT @D157242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : TRAIN, 
   [COORD @D157245, AGR [COUNT @D157244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : TRAIN, 
   [COORD @D157249, AGR [COUNT @D157248, PER @D157247, PLU @D157246, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : TRAIN, 
   [COORD @D157255, PAST @D157254, 
      AGR [CASE @D157253, COUNT @D157252, PER @D157251, PLU @D157250, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM UPON, ARITY 3] : TRAIN, 
   [COORD @D157258, AGR [COUNT @D157257, PER @D157256, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : TRAIN, 
   [COORD @D157260, AGR [COUNT @D157259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : TRAIN, 
   [COORD @D157262, AGR [COUNT @D157261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : TRAIN, 
   [COORD @D157266, AGR [COUNT @D157265, PER @D157264, PLU @D157263, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : TRAIN, 
   [COORD @D157272, PAST @D157271, 
      AGR [CASE @D157270, COUNT @D157269, PER @D157268, PLU @D157267, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : TRAIN, 
   [COORD @D157275, AGR [COUNT @D157274, PER @D157273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRAIN, 
   [COORD @D157277, AGR [COUNT @D157276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRAIN, 
   [COORD @D157279, AGR [COUNT @D157278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRAIN, 
   [COORD @D157283, AGR [COUNT @D157282, PER @D157281, PLU @D157280, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TRAIN, 
   [COORD @D157289, PAST @D157288, 
      AGR [CASE @D157287, COUNT @D157286, PER @D157285, PLU @D157284, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : TRAIN, 
   [COORD @D157292, AGR [COUNT @D157291, PER @D157290, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRAIN, 
   [COORD @D157294, AGR [COUNT @D157293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRAIN, 
   [COORD @D157296, AGR [COUNT @D157295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRAIN, 
   [COORD @D157300, AGR [COUNT @D157299, PER @D157298, PLU @D157297, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRAIN, 
   [COORD @D157306, PAST @D157305, AGR [CASE @D157304, COUNT @D157303, 
            PER @D157302, PLU @D157301, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : TRAIN, 
   [COORD @D157309, AGR [COUNT @D157308, PER @D157307, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRAIN, 
   [COORD @D157311, AGR [COUNT @D157310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRAIN, 
   [COORD @D157313, AGR [COUNT @D157312, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRAIN, 
   [COORD @D157317, AGR [COUNT @D157316, PER @D157315, PLU @D157314, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TRAIN, 
   [COORD @D157323, PAST @D157322, AGR [CASE @D157321, COUNT @D157320, 
            PER @D157319, PLU @D157318, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TRAIN, 
   [COORD @D157326, AGR [COUNT @D157325, PER @D157324, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRAIN, 
   [COORD @D157328, AGR [COUNT @D157327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRAIN, 
   [COORD @D157330, AGR [COUNT @D157329, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRAIN, 
   [COORD @D157334, AGR [COUNT @D157333, PER @D157332, PLU @D157331, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : TRAIN, 
   [COORD @D157340, PAST @D157339, 
      AGR [CASE @D157338, COUNT @D157337, PER @D157336, PLU @D157335, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRAIN, 
   [COORD @D157343, AGR [COUNT @D157342, PER @D157341, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAIN, 
   [COORD @D157345, AGR [COUNT @D157344, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAIN, 
   [COORD @D157347, AGR [COUNT @D157346, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAIN, 
   [COORD @D157351, AGR [COUNT @D157350, PER @D157349, PLU @D157348, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAIN, 
   [COORD @D157357, PAST @D157356, AGR [CASE @D157355, COUNT @D157354, 
            PER @D157353, PLU @D157352, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TRAIN.

WORD trained : 
   [COORD @D157368, AGR [CASE @D157367, COUNT @D157366, PER @D157365, 
            PLU @D157364, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157373, AGR [CASE @D157372, COUNT @D157371, PER @D157370, 
            PLU @D157369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157379, AGR [CASE @D157378, NFORM @D157377, COUNT @D157376, 
            PER @D157375, PLU @D157374, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRAIN, 
   [COORD @D157384, AGR [CASE @D157383, COUNT @D157382, PER @D157381, 
            PLU @D157380, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157389, AGR [CASE @D157388, COUNT @D157387, PER @D157386, 
            PLU @D157385, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157394, AGR [CASE @D157393, COUNT @D157392, PER @D157391, 
            PLU @D157390, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157399, AGR [CASE @D157398, COUNT @D157397, PER @D157396, 
            PLU @D157395, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157404, AGR [CASE @D157403, COUNT @D157402, PER @D157401, 
            PLU @D157400, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157409, AGR [CASE @D157408, COUNT @D157407, PER @D157406, 
            PLU @D157405, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157414, AGR [CASE @D157413, COUNT @D157412, PER @D157411, 
            PLU @D157410, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157419, AGR [CASE @D157418, COUNT @D157417, PER @D157416, 
            PLU @D157415, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157424, AGR [CASE @D157423, COUNT @D157422, PER @D157421, 
            PLU @D157420, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157429, AGR [CASE @D157428, COUNT @D157427, PER @D157426, 
            PLU @D157425, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157434, AGR [CASE @D157433, COUNT @D157432, PER @D157431, 
            PLU @D157430, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157439, AGR [CASE @D157438, COUNT @D157437, PER @D157436, 
            PLU @D157435, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRAIN, 
   [COORD @D157444, AGR [CASE @D157443, COUNT @D157442, PER @D157441, 
            PLU @D157440, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157449, AGR [CASE @D157448, COUNT @D157447, PER @D157446, 
            PLU @D157445, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157454, AGR [CASE @D157453, COUNT @D157452, PER @D157451, 
            PLU @D157450, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157459, AGR [CASE @D157458, COUNT @D157457, PER @D157456, 
            PLU @D157455, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157464, AGR [CASE @D157463, COUNT @D157462, PER @D157461, 
            PLU @D157460, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157469, AGR [CASE @D157468, COUNT @D157467, PER @D157466, 
            PLU @D157465, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAIN.

WORD training : 
   [COORD @D157483, REFL @D157482, PRD @D157481, CASE @D157480, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TRAINING, 
   [COORD @D157488, REFL @D157487, COUNT @D157486, PRD @D157485, 
      CASE @D157484, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TRAINING, 
   [COORD @D157494, PRD @D157493, 
      AGR [CASE @D157492, COUNT @D157491, PER @D157490, PLU @D157489, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   TRAIN, 
   [COORD @D157500, PRD @D157499, AGR [CASE @D157498, COUNT @D157497, 
            PER @D157496, PLU @D157495, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157506, PRD @D157505, 
      AGR [CASE @D157504, COUNT @D157503, PER @D157502, PLU @D157501, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRAIN, 
   [COORD @D157512, PRD @D157511, AGR [CASE @D157510, COUNT @D157509, 
            PER @D157508, PLU @D157507, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157518, PRD @D157517, 
      AGR [CASE @D157516, COUNT @D157515, PER @D157514, PLU @D157513, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TRAIN, 
   [COORD @D157524, PRD @D157523, AGR [CASE @D157522, COUNT @D157521, 
            PER @D157520, PLU @D157519, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157530, PRD @D157529, 
      AGR [CASE @D157528, COUNT @D157527, PER @D157526, PLU @D157525, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRAIN, 
   [COORD @D157536, PRD @D157535, AGR [CASE @D157534, COUNT @D157533, 
            PER @D157532, PLU @D157531, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAIN.

WORD trainings : 
   [COORD @D157554, DEMON @D157553, REFL @D157552, PRD @D157551, 
      CASE @D157550, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TRAINING.

WORD trains : 
   [COORD @D157565, DEMON @D157564, REFL @D157563, PRD @D157562, 
      CASE @D157561, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TRAIN, 
   [COORD @D157567, AGR [COUNT @D157566, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TRAIN, 
   [COORD @D157569, AGR [COUNT @D157568, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRAIN, 
   [COORD @D157571, AGR [COUNT @D157570, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRAIN, 
   [COORD @D157573, AGR [COUNT @D157572, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRAIN, 
   [COORD @D157575, AGR [COUNT @D157574, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TRAIN, 
   [COORD @D157577, AGR [COUNT @D157576, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157579, 
      AGR [COUNT @D157578, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAIN, 
   [COORD @D157581, 
      AGR [COUNT @D157580, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAIN.

WORD transport : 
   [COORD @D157590, REFL @D157589, COUNT @D157588, PRD @D157587, 
      CASE @D157586, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TRANSPORT, 
   [COORD @D157593, 
      AGR [COUNT @D157592, PER @D157591, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP_PP, 
      PFORM FROM_TO, ARITY 4] : TRANSPORT, 
   [COORD @D157595, AGR [COUNT @D157594, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_TO, ARITY 4] : TRANSPORT, 
   [COORD @D157597, 
      AGR [COUNT @D157596, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP_PP, 
      PFORM FROM_TO, ARITY 4] : TRANSPORT, 
   [COORD @D157601, AGR [COUNT @D157600, PER @D157599, PLU @D157598, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_TO, ARITY 4] : TRANSPORT, 
   [COORD @D157607, PAST @D157606, 
      AGR [CASE @D157605, COUNT @D157604, PER @D157603, PLU @D157602, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_TO, ARITY 4] : TRANSPORT, 
   [COORD @D157610, 
      AGR [COUNT @D157609, PER @D157608, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM TO, 
      ARITY 3] : TRANSPORT, 
   [COORD @D157612, AGR [COUNT @D157611, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TRANSPORT, 
   [COORD @D157614, AGR [COUNT @D157613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TRANSPORT, 
   [COORD @D157618, AGR [COUNT @D157617, PER @D157616, PLU @D157615, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TRANSPORT, 
   [COORD @D157624, PAST @D157623, 
      AGR [CASE @D157622, COUNT @D157621, PER @D157620, PLU @D157619, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : TRANSPORT, 
   [COORD @D157627, AGR [COUNT @D157626, PER @D157625, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TRANSPORT, 
   [COORD @D157629, AGR [COUNT @D157628, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TRANSPORT, 
   [COORD @D157631, AGR [COUNT @D157630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TRANSPORT, 
   [COORD @D157635, AGR [COUNT @D157634, PER @D157633, PLU @D157632, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TRANSPORT, 
   [COORD @D157641, PAST @D157640, 
      AGR [CASE @D157639, COUNT @D157638, PER @D157637, PLU @D157636, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : TRANSPORT, 
   [COORD @D157644, AGR [COUNT @D157643, PER @D157642, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRANSPORT, 
   [COORD @D157646, AGR [COUNT @D157645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRANSPORT, 
   [COORD @D157648, AGR [COUNT @D157647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRANSPORT, 
   [COORD @D157652, AGR [COUNT @D157651, PER @D157650, PLU @D157649, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TRANSPORT, 
   [COORD @D157658, PAST @D157657, AGR [CASE @D157656, COUNT @D157655, 
            PER @D157654, PLU @D157653, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TRANSPORT.

WORD transported : 
   [COORD @D157669, AGR [CASE @D157668, COUNT @D157667, PER @D157666, 
            PLU @D157665, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM_TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157674, 
      AGR [CASE @D157673, COUNT @D157672, PER @D157671, PLU @D157670, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157679, AGR [CASE @D157678, COUNT @D157677, PER @D157676, 
            PLU @D157675, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, 
      FIN +, AT +, LAT +, PAST +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157684, 
      AGR [CASE @D157683, COUNT @D157682, PER @D157681, PLU @D157680, 
            NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM TO, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157689, AGR [CASE @D157688, COUNT @D157687, PER @D157686, 
            PLU @D157685, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157694, AGR [CASE @D157693, COUNT @D157692, PER @D157691, 
            PLU @D157690, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157699, AGR [CASE @D157698, COUNT @D157697, PER @D157696, 
            PLU @D157695, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157704, AGR [CASE @D157703, COUNT @D157702, PER @D157701, 
            PLU @D157700, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157709, 
      AGR [CASE @D157708, COUNT @D157707, PER @D157706, PLU @D157705, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157714, AGR [CASE @D157713, COUNT @D157712, PER @D157711, 
            PLU @D157710, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157719, AGR [CASE @D157718, COUNT @D157717, PER @D157716, 
            PLU @D157715, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157724, AGR [CASE @D157723, COUNT @D157722, PER @D157721, 
            PLU @D157720, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRANSPORT.

WORD transporting : 
   [COORD @D157740, PRD @D157739, AGR [CASE @D157738, COUNT @D157737, 
            PER @D157736, PLU @D157735, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, 
      PFORM FROM_TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157746, PRD @D157745, 
      AGR [CASE @D157744, COUNT @D157743, PER @D157742, PLU @D157741, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157752, PRD @D157751, AGR [CASE @D157750, COUNT @D157749, 
            PER @D157748, PLU @D157747, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRANSPORT, 
   [COORD @D157758, PRD @D157757, 
      AGR [CASE @D157756, COUNT @D157755, PER @D157754, PLU @D157753, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TRANSPORT.

WORD transports : 
   [COORD @D157769, DEMON @D157768, REFL @D157767, PRD @D157766, 
      CASE @D157765, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TRANSPORT, 
   [COORD @D157771, AGR [COUNT @D157770, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRANSPORT, 
   [COORD @D157773, AGR [COUNT @D157772, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRANSPORT, 
   [COORD @D157775, AGR [COUNT @D157774, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRANSPORT, 
   [COORD @D157777, AGR [COUNT @D157776, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRANSPORT.

WORD travel : 
   [COORD @D157785, REFL @D157784, PRD @D157783, CASE @D157782, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : TRAVEL, 
   [COORD @D157788, AGR [COUNT @D157787, PER @D157786, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRAVEL, 
   [COORD @D157790, AGR [COUNT @D157789, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRAVEL, 
   [COORD @D157792, AGR [COUNT @D157791, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRAVEL, 
   [COORD @D157796, AGR [COUNT @D157795, PER @D157794, PLU @D157793, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TRAVEL, 
   [COORD @D157802, PAST @D157801, AGR [CASE @D157800, COUNT @D157799, 
            PER @D157798, PLU @D157797, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TRAVEL, 
   [COORD @D157805, AGR [COUNT @D157804, PER @D157803, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TRAVEL, 
   [COORD @D157807, AGR [COUNT @D157806, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TRAVEL, 
   [COORD @D157809, AGR [COUNT @D157808, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TRAVEL, 
   [COORD @D157813, AGR [COUNT @D157812, PER @D157811, PLU @D157810, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : TRAVEL, 
   [COORD @D157819, PAST @D157818, AGR [CASE @D157817, COUNT @D157816, 
            PER @D157815, PLU @D157814, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : TRAVEL, 
   [COORD @D157822, AGR [COUNT @D157821, PER @D157820, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : TRAVEL, 
   [COORD @D157824, AGR [COUNT @D157823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : TRAVEL, 
   [COORD @D157826, AGR [COUNT @D157825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT ADL, 
      ARITY 2] : TRAVEL, 
   [COORD @D157830, AGR [COUNT @D157829, PER @D157828, PLU @D157827, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT ADL, ARITY 2] : TRAVEL, 
   [COORD @D157836, PAST @D157835, AGR [CASE @D157834, COUNT @D157833, 
            PER @D157832, PLU @D157831, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT ADL, ARITY 2] : TRAVEL, 
   [COORD @D157839, AGR [COUNT @D157838, PER @D157837, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : TRAVEL, 
   [COORD @D157841, AGR [COUNT @D157840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : TRAVEL, 
   [COORD @D157843, AGR [COUNT @D157842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : TRAVEL, 
   [COORD @D157847, AGR [COUNT @D157846, PER @D157845, PLU @D157844, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, ARITY 2] : TRAVEL, 
   [COORD @D157853, PAST @D157852, 
      AGR [CASE @D157851, COUNT @D157850, PER @D157849, PLU @D157848, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM IN, ARITY 2] : TRAVEL, 
   [COORD @D157856, AGR [COUNT @D157855, PER @D157854, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAVEL, 
   [COORD @D157858, AGR [COUNT @D157857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAVEL, 
   [COORD @D157860, AGR [COUNT @D157859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAVEL, 
   [COORD @D157864, AGR [COUNT @D157863, PER @D157862, PLU @D157861, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRAVEL, 
   [COORD @D157870, PAST @D157869, AGR [CASE @D157868, COUNT @D157867, 
            PER @D157866, PLU @D157865, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TRAVEL.

WORD travelled : 
   [COORD @D157883, AGR [CASE @D157882, COUNT @D157881, PER @D157880, 
            PLU @D157879, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157888, AGR [CASE @D157887, COUNT @D157886, PER @D157885, 
            PLU @D157884, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157893, AGR [CASE @D157892, COUNT @D157891, PER @D157890, 
            PLU @D157889, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157898, AGR [CASE @D157897, COUNT @D157896, PER @D157895, 
            PLU @D157894, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157903, AGR [CASE @D157902, COUNT @D157901, PER @D157900, 
            PLU @D157899, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157908, AGR [CASE @D157907, COUNT @D157906, PER @D157905, 
            PLU @D157904, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157913, AGR [CASE @D157912, COUNT @D157911, PER @D157910, 
            PLU @D157909, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157918, AGR [CASE @D157917, COUNT @D157916, PER @D157915, 
            PLU @D157914, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157923, AGR [CASE @D157922, COUNT @D157921, PER @D157920, 
            PLU @D157919, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157928, AGR [CASE @D157927, COUNT @D157926, PER @D157925, 
            PLU @D157924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157933, AGR [CASE @D157932, COUNT @D157931, PER @D157930, 
            PLU @D157929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157938, AGR [CASE @D157937, COUNT @D157936, PER @D157935, 
            PLU @D157934, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRAVEL.

WORD travelling : 
   [COORD @D157954, PRD @D157953, AGR [CASE @D157952, COUNT @D157951, 
            PER @D157950, PLU @D157949, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157960, PRD @D157959, 
      AGR [CASE @D157958, COUNT @D157957, PER @D157956, PLU @D157955, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TRAVEL, 
   [COORD @D157966, PRD @D157965, AGR [CASE @D157964, COUNT @D157963, 
            PER @D157962, PLU @D157961, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157972, PRD @D157971, 
      AGR [CASE @D157970, COUNT @D157969, PER @D157968, PLU @D157967, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TRAVEL, 
   [COORD @D157978, PRD @D157977, AGR [CASE @D157976, COUNT @D157975, 
            PER @D157974, PLU @D157973, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRAVEL.

WORD travels : 
   [COORD @D157988, REFL @D157987, PRD @D157986, CASE @D157985, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : TRAVELS, 
   [COORD @D157990, 
      AGR [COUNT @D157989, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157992, 
      AGR [COUNT @D157991, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157994, 
      AGR [COUNT @D157993, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157996, 
      AGR [COUNT @D157995, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAVEL, 
   [COORD @D157998, 
      AGR [COUNT @D157997, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRAVEL.

WORD treat : 
   [COORD @D158014, AGR [COUNT @D158013, PER @D158012, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : TREAT, 
   [COORD @D158016, AGR [COUNT @D158015, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : TREAT, 
   [COORD @D158018, AGR [COUNT @D158017, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : TREAT, 
   [COORD @D158022, AGR [COUNT @D158021, PER @D158020, PLU @D158019, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : TREAT, 
   [COORD @D158028, PAST @D158027, AGR [CASE @D158026, COUNT @D158025, 
            PER @D158024, PLU @D158023, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_ADL, ARITY 3] : TREAT, 
   [COORD @D158031, AGR [COUNT @D158030, PER @D158029, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TREAT, 
   [COORD @D158033, AGR [COUNT @D158032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TREAT, 
   [COORD @D158035, AGR [COUNT @D158034, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TREAT, 
   [COORD @D158039, AGR [COUNT @D158038, PER @D158037, PLU @D158036, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : TREAT, 
   [COORD @D158045, PAST @D158044, 
      AGR [CASE @D158043, COUNT @D158042, PER @D158041, PLU @D158040, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : TREAT, 
   [COORD @D158048, AGR [COUNT @D158047, PER @D158046, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TREAT, 
   [COORD @D158050, AGR [COUNT @D158049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TREAT, 
   [COORD @D158052, AGR [COUNT @D158051, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TREAT, 
   [COORD @D158056, AGR [COUNT @D158055, PER @D158054, PLU @D158053, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TREAT, 
   [COORD @D158062, PAST @D158061, AGR [CASE @D158060, COUNT @D158059, 
            PER @D158058, PLU @D158057, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TREAT, 
   [COORD @D158065, AGR [COUNT @D158064, PER @D158063, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TREAT, 
   [COORD @D158067, AGR [COUNT @D158066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TREAT, 
   [COORD @D158069, AGR [COUNT @D158068, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TREAT, 
   [COORD @D158073, AGR [COUNT @D158072, PER @D158071, PLU @D158070, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM WITH, ARITY 2] : TREAT, 
   [COORD @D158079, PAST @D158078, 
      AGR [CASE @D158077, COUNT @D158076, PER @D158075, PLU @D158074, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM WITH, ARITY 2] : TREAT, 
   [COORD @D158082, AGR [COUNT @D158081, PER @D158080, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : TREAT, 
   [COORD @D158084, AGR [COUNT @D158083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : TREAT, 
   [COORD @D158086, AGR [COUNT @D158085, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : TREAT, 
   [COORD @D158090, AGR [COUNT @D158089, PER @D158088, PLU @D158087, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, ARITY 2] : TREAT, 
   [COORD @D158096, PAST @D158095, 
      AGR [CASE @D158094, COUNT @D158093, PER @D158092, PLU @D158091, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OF, ARITY 2] : TREAT, 
   [COORD @D158099, AGR [COUNT @D158098, PER @D158097, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TREAT, 
   [COORD @D158101, AGR [COUNT @D158100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TREAT, 
   [COORD @D158103, AGR [COUNT @D158102, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TREAT, 
   [COORD @D158107, AGR [COUNT @D158106, PER @D158105, PLU @D158104, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TREAT, 
   [COORD @D158113, PAST @D158112, AGR [CASE @D158111, COUNT @D158110, 
            PER @D158109, PLU @D158108, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TREAT.

WORD treated : 
   [COORD @D158123, AGR [CASE @D158122, COUNT @D158121, PER @D158120, 
            PLU @D158119, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADL, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TREAT, 
   [COORD @D158128, AGR [CASE @D158127, COUNT @D158126, PER @D158125, 
            PLU @D158124, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158133, AGR [CASE @D158132, COUNT @D158131, PER @D158130, 
            PLU @D158129, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158138, AGR [CASE @D158137, COUNT @D158136, PER @D158135, 
            PLU @D158134, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158143, AGR [CASE @D158142, COUNT @D158141, PER @D158140, 
            PLU @D158139, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158148, AGR [CASE @D158147, COUNT @D158146, PER @D158145, 
            PLU @D158144, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158153, AGR [CASE @D158152, COUNT @D158151, PER @D158150, 
            PLU @D158149, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TREAT, 
   [COORD @D158158, AGR [CASE @D158157, COUNT @D158156, PER @D158155, 
            PLU @D158154, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158163, AGR [CASE @D158162, COUNT @D158161, PER @D158160, 
            PLU @D158159, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158168, AGR [CASE @D158167, COUNT @D158166, PER @D158165, 
            PLU @D158164, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158173, AGR [CASE @D158172, COUNT @D158171, PER @D158170, 
            PLU @D158169, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158178, AGR [CASE @D158177, COUNT @D158176, PER @D158175, 
            PLU @D158174, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158183, AGR [CASE @D158182, COUNT @D158181, PER @D158180, 
            PLU @D158179, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158188, AGR [CASE @D158187, COUNT @D158186, PER @D158185, 
            PLU @D158184, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158193, AGR [CASE @D158192, COUNT @D158191, PER @D158190, 
            PLU @D158189, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158198, AGR [CASE @D158197, COUNT @D158196, PER @D158195, 
            PLU @D158194, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TREAT.

WORD treating : 
   [COORD @D158211, PRD @D158210, AGR [CASE @D158209, COUNT @D158208, 
            PER @D158207, PLU @D158206, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158217, PRD @D158216, 
      AGR [CASE @D158215, COUNT @D158214, PER @D158213, PLU @D158212, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TREAT, 
   [COORD @D158223, PRD @D158222, AGR [CASE @D158221, COUNT @D158220, 
            PER @D158219, PLU @D158218, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158229, PRD @D158228, 
      AGR [CASE @D158227, COUNT @D158226, PER @D158225, PLU @D158224, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TREAT, 
   [COORD @D158235, PRD @D158234, AGR [CASE @D158233, COUNT @D158232, 
            PER @D158231, PLU @D158230, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TREAT, 
   [COORD @D158241, PRD @D158240, 
      AGR [CASE @D158239, COUNT @D158238, PER @D158237, PLU @D158236, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TREAT.

WORD treats : 
   [COORD @D158248, AGR [COUNT @D158247, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TREAT, 
   [COORD @D158250, AGR [COUNT @D158249, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TREAT, 
   [COORD @D158252, AGR [COUNT @D158251, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TREAT, 
   [COORD @D158254, 
      AGR [COUNT @D158253, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TREAT, 
   [COORD @D158256, 
      AGR [COUNT @D158255, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TREAT, 
   [COORD @D158258, 
      AGR [COUNT @D158257, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TREAT.

WORD tried : 
   [COADV @D158272, COORD @D158271, DEF @D158270, PRD @D158269, 
      AGR [CASE @D158268, COUNT @D158267, PER @D158266, PLU @D158265, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, PART -, NEG -, 
      SUBCAT NULL, DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT] : TRIED, 
   [COORD @D158277, AGR [CASE @D158276, COUNT @D158275, PER @D158274, 
            PLU @D158273, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158282, AGR [CASE @D158281, COUNT @D158280, PER @D158279, 
            PLU @D158278, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158287, AGR [CASE @D158286, COUNT @D158285, PER @D158284, 
            PLU @D158283, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158292, AGR [CASE @D158291, COUNT @D158290, PER @D158289, 
            PLU @D158288, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158297, AGR [CASE @D158296, COUNT @D158295, PER @D158294, 
            PLU @D158293, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRY, 
   [COORD @D158302, AGR [CASE @D158301, COUNT @D158300, PER @D158299, 
            PLU @D158298, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158307, AGR [CASE @D158306, COUNT @D158305, PER @D158304, 
            PLU @D158303, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158312, AGR [CASE @D158311, COUNT @D158310, PER @D158309, 
            PLU @D158308, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158317, AGR [CASE @D158316, COUNT @D158315, PER @D158314, 
            PLU @D158313, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158322, AGR [CASE @D158321, COUNT @D158320, PER @D158319, 
            PLU @D158318, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158327, AGR [CASE @D158326, COUNT @D158325, PER @D158324, 
            PLU @D158323, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158332, AGR [CASE @D158331, COUNT @D158330, PER @D158329, 
            PLU @D158328, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158337, 
      AGR [CASE @D158336, COUNT @D158335, PER @D158334, PLU @D158333, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158342, AGR [CASE @D158341, COUNT @D158340, PER @D158339, 
            PLU @D158338, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158347, AGR [CASE @D158346, COUNT @D158345, PER @D158344, 
            PLU @D158343, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158352, AGR [CASE @D158351, COUNT @D158350, PER @D158349, 
            PLU @D158348, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158357, AGR [CASE @D158356, COUNT @D158355, PER @D158354, 
            PLU @D158353, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158362, AGR [CASE @D158361, COUNT @D158360, PER @D158359, 
            PLU @D158358, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158367, AGR [CASE @D158366, COUNT @D158365, PER @D158364, 
            PLU @D158363, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158372, AGR [CASE @D158371, COUNT @D158370, PER @D158369, 
            PLU @D158368, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158377, AGR [CASE @D158376, COUNT @D158375, PER @D158374, 
            PLU @D158373, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158382, AGR [CASE @D158381, COUNT @D158380, PER @D158379, 
            PLU @D158378, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158387, AGR [CASE @D158386, COUNT @D158385, PER @D158384, 
            PLU @D158383, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRY, 
   [COORD @D158392, AGR [CASE @D158391, COUNT @D158390, PER @D158389, 
            PLU @D158388, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D158397, AGR [CASE @D158396, COUNT @D158395, PER @D158394, 
            PLU @D158393, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRY.

WORD tries : 
   [COORD @D158408, DEMON @D158407, REFL @D158406, PRD @D158405, 
      CASE @D158404, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TRY, 
   [COORD @D158410, AGR [COUNT @D158409, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TRY, 
   [COORD @D158412, AGR [COUNT @D158411, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TRY, 
   [COORD @D158414, AGR [COUNT @D158413, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRY, 
   [COORD @D158416, 
      AGR [COUNT @D158415, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRY, 
   [COORD @D158418, 
      AGR [COUNT @D158417, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TRY, 
   [COORD @D158420, AGR [COUNT @D158419, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRY, 
   [COORD @D158422, AGR [COUNT @D158421, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TRY, 
   [COORD @D158424, AGR [COUNT @D158423, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRY, 
   [COORD @D158426, 
      AGR [COUNT @D158425, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRY, 
   [COORD @D158428, 
      AGR [COUNT @D158427, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRY.

WORD trip : 
   [COORD @D158438, REFL @D158437, PRD @D158436, CASE @D158435, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TRIP, 
   [COORD @D158441, 
      AGR [COUNT @D158440, PER @D158439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   TRIP, 
   [COORD @D158443, AGR [COUNT @D158442, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRIP, 
   [COORD @D158445, AGR [COUNT @D158444, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRIP, 
   [COORD @D158449, AGR [COUNT @D158448, PER @D158447, PLU @D158446, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TRIP, 
   [COORD @D158455, PAST @D158454, AGR [CASE @D158453, COUNT @D158452, 
            PER @D158451, PLU @D158450, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TRIP, 
   [COORD @D158458, AGR [COUNT @D158457, PER @D158456, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TRIP, 
   [COORD @D158460, AGR [COUNT @D158459, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TRIP, 
   [COORD @D158462, AGR [COUNT @D158461, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TRIP, 
   [COORD @D158466, AGR [COUNT @D158465, PER @D158464, PLU @D158463, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : TRIP, 
   [COORD @D158472, PAST @D158471, AGR [CASE @D158470, COUNT @D158469, 
            PER @D158468, PLU @D158467, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : TRIP, 
   [COORD @D158475, AGR [COUNT @D158474, PER @D158473, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : TRIP, 
   [COORD @D158477, AGR [COUNT @D158476, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : TRIP, 
   [COORD @D158479, AGR [COUNT @D158478, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : TRIP, 
   [COORD @D158483, AGR [COUNT @D158482, PER @D158481, PLU @D158480, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OVER, ARITY 2] : TRIP, 
   [COORD @D158489, PAST @D158488, 
      AGR [CASE @D158487, COUNT @D158486, PER @D158485, PLU @D158484, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : TRIP, 
   [COORD @D158492, AGR [COUNT @D158491, PER @D158490, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TRIP, 
   [COORD @D158494, AGR [COUNT @D158493, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TRIP, 
   [COORD @D158496, AGR [COUNT @D158495, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TRIP, 
   [COORD @D158500, AGR [COUNT @D158499, PER @D158498, PLU @D158497, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : TRIP, 
   [COORD @D158506, PAST @D158505, 
      AGR [CASE @D158504, COUNT @D158503, PER @D158502, PLU @D158501, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : TRIP, 
   [COORD @D158509, AGR [COUNT @D158508, PER @D158507, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TRIP, 
   [COORD @D158511, AGR [COUNT @D158510, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TRIP, 
   [COORD @D158513, AGR [COUNT @D158512, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TRIP, 
   [COORD @D158517, AGR [COUNT @D158516, PER @D158515, PLU @D158514, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : TRIP, 
   [COORD @D158523, PAST @D158522, 
      AGR [CASE @D158521, COUNT @D158520, PER @D158519, PLU @D158518, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TRIP, 
   [COORD @D158526, AGR [COUNT @D158525, PER @D158524, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRIP, 
   [COORD @D158528, AGR [COUNT @D158527, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRIP, 
   [COORD @D158530, AGR [COUNT @D158529, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRIP, 
   [COORD @D158534, AGR [COUNT @D158533, PER @D158532, PLU @D158531, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRIP, 
   [COORD @D158540, PAST @D158539, AGR [CASE @D158538, COUNT @D158537, 
            PER @D158536, PLU @D158535, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TRIP, 
   [COORD @D158543, AGR [COUNT @D158542, PER @D158541, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TRIP, 
   [COORD @D158545, AGR [COUNT @D158544, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TRIP, 
   [COORD @D158547, AGR [COUNT @D158546, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TRIP, 
   [COORD @D158551, AGR [COUNT @D158550, PER @D158549, PLU @D158548, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TRIP, 
   [COORD @D158557, PAST @D158556, 
      AGR [CASE @D158555, COUNT @D158554, PER @D158553, PLU @D158552, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : TRIP, 
   [COORD @D158560, AGR [COUNT @D158559, PER @D158558, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TRIP, 
   [COORD @D158562, AGR [COUNT @D158561, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TRIP, 
   [COORD @D158564, AGR [COUNT @D158563, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TRIP, 
   [COORD @D158568, AGR [COUNT @D158567, PER @D158566, PLU @D158565, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TRIP, 
   [COORD @D158574, PAST @D158573, 
      AGR [CASE @D158572, COUNT @D158571, PER @D158570, PLU @D158569, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : TRIP, 
   [COORD @D158577, AGR [COUNT @D158576, PER @D158575, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRIP, 
   [COORD @D158579, AGR [COUNT @D158578, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRIP, 
   [COORD @D158581, AGR [COUNT @D158580, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRIP, 
   [COORD @D158585, AGR [COUNT @D158584, PER @D158583, PLU @D158582, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRIP, 
   [COORD @D158591, PAST @D158590, 
      AGR [CASE @D158589, COUNT @D158588, PER @D158587, PLU @D158586, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : TRIP.

WORD tripped : 
   [COORD @D158604, AGR [CASE @D158603, COUNT @D158602, PER @D158601, 
            PLU @D158600, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRIP, 
   [COORD @D158609, AGR [CASE @D158608, COUNT @D158607, PER @D158606, 
            PLU @D158605, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158614, AGR [CASE @D158613, COUNT @D158612, PER @D158611, 
            PLU @D158610, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158619, AGR [CASE @D158618, COUNT @D158617, PER @D158616, 
            PLU @D158615, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158624, AGR [CASE @D158623, COUNT @D158622, PER @D158621, 
            PLU @D158620, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158629, AGR [CASE @D158628, COUNT @D158627, PER @D158626, 
            PLU @D158625, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158634, AGR [CASE @D158633, COUNT @D158632, PER @D158631, 
            PLU @D158630, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158639, AGR [CASE @D158638, COUNT @D158637, PER @D158636, 
            PLU @D158635, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158644, AGR [CASE @D158643, COUNT @D158642, PER @D158641, 
            PLU @D158640, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158649, AGR [CASE @D158648, COUNT @D158647, PER @D158646, 
            PLU @D158645, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158654, AGR [CASE @D158653, COUNT @D158652, PER @D158651, 
            PLU @D158650, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158659, AGR [CASE @D158658, COUNT @D158657, PER @D158656, 
            PLU @D158655, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158664, AGR [CASE @D158663, COUNT @D158662, PER @D158661, 
            PLU @D158660, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158669, AGR [CASE @D158668, COUNT @D158667, PER @D158666, 
            PLU @D158665, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158674, AGR [CASE @D158673, COUNT @D158672, PER @D158671, 
            PLU @D158670, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158679, AGR [CASE @D158678, COUNT @D158677, PER @D158676, 
            PLU @D158675, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158684, AGR [CASE @D158683, COUNT @D158682, PER @D158681, 
            PLU @D158680, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158689, AGR [CASE @D158688, COUNT @D158687, PER @D158686, 
            PLU @D158685, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158694, AGR [CASE @D158693, COUNT @D158692, PER @D158691, 
            PLU @D158690, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158699, AGR [CASE @D158698, COUNT @D158697, PER @D158696, 
            PLU @D158695, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158704, AGR [CASE @D158703, COUNT @D158702, PER @D158701, 
            PLU @D158700, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TRIP.

WORD tripping : 
   [COORD @D158718, PRD @D158717, AGR [CASE @D158716, COUNT @D158715, 
            PER @D158714, PLU @D158713, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158724, PRD @D158723, 
      AGR [CASE @D158722, COUNT @D158721, PER @D158720, PLU @D158719, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TRIP, 
   [COORD @D158730, PRD @D158729, AGR [CASE @D158728, COUNT @D158727, 
            PER @D158726, PLU @D158725, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158736, PRD @D158735, 
      AGR [CASE @D158734, COUNT @D158733, PER @D158732, PLU @D158731, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TRIP, 
   [COORD @D158742, PRD @D158741, AGR [CASE @D158740, COUNT @D158739, 
            PER @D158738, PLU @D158737, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158748, PRD @D158747, 
      AGR [CASE @D158746, COUNT @D158745, PER @D158744, PLU @D158743, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TRIP, 
   [COORD @D158754, PRD @D158753, AGR [CASE @D158752, COUNT @D158751, 
            PER @D158750, PLU @D158749, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRIP, 
   [COORD @D158760, PRD @D158759, 
      AGR [CASE @D158758, COUNT @D158757, PER @D158756, PLU @D158755, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRIP, 
   [COORD @D158766, PRD @D158765, AGR [CASE @D158764, COUNT @D158763, 
            PER @D158762, PLU @D158761, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRIP.

WORD trips : 
   [COORD @D158779, DEMON @D158778, REFL @D158777, PRD @D158776, 
      CASE @D158775, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TRIP, 
   [COORD @D158781, AGR [COUNT @D158780, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158783, 
      AGR [COUNT @D158782, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158785, 
      AGR [COUNT @D158784, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158787, 
      AGR [COUNT @D158786, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158789, 
      AGR [COUNT @D158788, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158791, 
      AGR [COUNT @D158790, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158793, 
      AGR [COUNT @D158792, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158795, 
      AGR [COUNT @D158794, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP, 
   [COORD @D158797, 
      AGR [COUNT @D158796, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TRIP.

WORD trouble : 
   [COORD @D158809, REFL @D158808, PRD @D158807, CASE @D158806, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TROUBLE, 
   [COORD @D158814, REFL @D158813, COUNT @D158812, PRD @D158811, 
      CASE @D158810, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TROUBLE, 
   [COORD @D158819, REFL @D158818, COUNT @D158817, PRD @D158816, 
      CASE @D158815, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM WITH] : 
   TROUBLE, 
   [COORD @D158822, AGR [COUNT @D158821, PER @D158820, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TROUBLE, 
   [COORD @D158824, AGR [COUNT @D158823, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TROUBLE, 
   [COORD @D158826, AGR [COUNT @D158825, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TROUBLE, 
   [COORD @D158830, AGR [COUNT @D158829, PER @D158828, PLU @D158827, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : TROUBLE, 
   [COORD @D158836, PAST @D158835, 
      AGR [CASE @D158834, COUNT @D158833, PER @D158832, PLU @D158831, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : TROUBLE, 
   [COORD @D158839, AGR [COUNT @D158838, PER @D158837, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TROUBLE, 
   [COORD @D158841, AGR [COUNT @D158840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TROUBLE, 
   [COORD @D158843, AGR [COUNT @D158842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TROUBLE, 
   [COORD @D158847, AGR [COUNT @D158846, PER @D158845, PLU @D158844, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : TROUBLE, 
   [COORD @D158853, PAST @D158852, 
      AGR [CASE @D158851, COUNT @D158850, PER @D158849, PLU @D158848, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : TROUBLE, 
   [COORD @D158856, AGR [COUNT @D158855, PER @D158854, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TROUBLE, 
   [COORD @D158858, AGR [COUNT @D158857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TROUBLE, 
   [COORD @D158860, AGR [COUNT @D158859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TROUBLE, 
   [COORD @D158864, AGR [COUNT @D158863, PER @D158862, PLU @D158861, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TROUBLE, 
   [COORD @D158870, PAST @D158869, 
      AGR [CASE @D158868, COUNT @D158867, PER @D158866, PLU @D158865, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : TROUBLE, 
   [COORD @D158873, AGR @D158872, PAST @D158871, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT NP_SFIN, ARITY 2] : TROUBLE, 
   [COORD @D158876, AGR [COUNT @D158875, PER @D158874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TROUBLE, 
   [COORD @D158878, AGR [COUNT @D158877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TROUBLE, 
   [COORD @D158880, AGR [COUNT @D158879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TROUBLE, 
   [COORD @D158884, AGR [COUNT @D158883, PER @D158882, PLU @D158881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TROUBLE, 
   [COORD @D158890, PAST @D158889, AGR [CASE @D158888, COUNT @D158887, 
            PER @D158886, PLU @D158885, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TROUBLE, 
   [COORD @D158893, AGR [COUNT @D158892, PER @D158891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TROUBLE, 
   [COORD @D158895, AGR [COUNT @D158894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TROUBLE, 
   [COORD @D158897, AGR [COUNT @D158896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TROUBLE, 
   [COORD @D158901, AGR [COUNT @D158900, PER @D158899, PLU @D158898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TROUBLE, 
   [COORD @D158907, PAST @D158906, AGR [CASE @D158905, COUNT @D158904, 
            PER @D158903, PLU @D158902, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TROUBLE.

WORD troubled : 
   [COORD @D158923, AGR [CASE @D158922, NFORM @D158921, COUNT @D158920, 
            PER @D158919, PLU @D158918, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158928, AGR [CASE @D158927, COUNT @D158926, PER @D158925, 
            PLU @D158924, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158933, AGR [CASE @D158932, COUNT @D158931, PER @D158930, 
            PLU @D158929, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158938, AGR [CASE @D158937, COUNT @D158936, PER @D158935, 
            PLU @D158934, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158943, AGR [CASE @D158942, COUNT @D158941, PER @D158940, 
            PLU @D158939, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158948, AGR [CASE @D158947, COUNT @D158946, PER @D158945, 
            PLU @D158944, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158953, AGR [CASE @D158952, COUNT @D158951, PER @D158950, 
            PLU @D158949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158958, AGR [CASE @D158957, COUNT @D158956, PER @D158955, 
            PLU @D158954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158963, AGR [CASE @D158962, COUNT @D158961, PER @D158960, 
            PLU @D158959, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, CONJ NULL, SUBTYPE EXTRAP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158965, AGR @D158964, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TROUBLE, 
   [COORD @D158967, AGR @D158966, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : TROUBLE, 
   [COORD @D158972, AGR [CASE @D158971, COUNT @D158970, PER @D158969, 
            PLU @D158968, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158977, AGR [CASE @D158976, COUNT @D158975, PER @D158974, 
            PLU @D158973, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158982, AGR [CASE @D158981, COUNT @D158980, PER @D158979, 
            PLU @D158978, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158987, AGR [CASE @D158986, COUNT @D158985, PER @D158984, 
            PLU @D158983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D158992, AGR [CASE @D158991, COUNT @D158990, PER @D158989, 
            PLU @D158988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TROUBLE.

WORD troubles : 
   [COORD @D159007, DEMON @D159006, REFL @D159005, PRD @D159004, 
      CASE @D159003, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TROUBLE, 
   [COORD @D159012, DEMON @D159011, REFL @D159010, PRD @D159009, 
      CASE @D159008, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM WITH, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TROUBLE, 
   [COORD @D159014, AGR [COUNT @D159013, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TROUBLE, 
   [COORD @D159016, AGR [COUNT @D159015, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TROUBLE, 
   [COORD @D159018, AGR [COUNT @D159017, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TROUBLE, 
   [COORD @D159022, AGR [CASE @D159021, NFORM @D159020, COUNT @D159019, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TROUBLE, 
   [COORD @D159027, AGR [UB @D159026, VFORM @D159025, SUBJ @D159024, 
            FIN @D159023, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TROUBLE, 
   [COORD @D159029, AGR [COUNT @D159028, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D159031, 
      AGR [COUNT @D159030, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TROUBLE.

WORD troubling : 
   [COORD @D159045, PRD @D159044, AGR [CASE @D159043, COUNT @D159042, 
            PER @D159041, PLU @D159040, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D159051, PRD @D159050, 
      AGR [CASE @D159049, COUNT @D159048, PER @D159047, PLU @D159046, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TROUBLE, 
   [COORD @D159057, PRD @D159056, AGR [CASE @D159055, COUNT @D159054, 
            PER @D159053, PLU @D159052, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D159060, AGR @D159059, PRD @D159058, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TROUBLE, 
   [COORD @D159066, PRD @D159065, AGR [CASE @D159064, COUNT @D159063, 
            PER @D159062, PLU @D159061, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TROUBLE, 
   [COORD @D159072, PRD @D159071, 
      AGR [CASE @D159070, COUNT @D159069, PER @D159068, PLU @D159067, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TROUBLE.

WORD try : 
   [COORD @D159080, REFL @D159079, PRD @D159078, CASE @D159077, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TRY, 
   [COORD @D159083, 
      AGR [COUNT @D159082, PER @D159081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      ARITY 2] : TRY, 
   [COORD @D159085, AGR [COUNT @D159084, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : TRY, 
   [COORD @D159087, AGR [COUNT @D159086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : TRY, 
   [COORD @D159091, AGR [COUNT @D159090, PER @D159089, PLU @D159088, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : TRY, 
   [COORD @D159097, PAST @D159096, AGR [CASE @D159095, COUNT @D159094, 
            PER @D159093, PLU @D159092, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : TRY, 
   [COORD @D159100, AGR [COUNT @D159099, PER @D159098, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRY, 
   [COORD @D159102, AGR [COUNT @D159101, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRY, 
   [COORD @D159104, AGR [COUNT @D159103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRY, 
   [COORD @D159108, AGR [COUNT @D159107, PER @D159106, PLU @D159105, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : TRY, 
   [COORD @D159114, PAST @D159113, AGR [CASE @D159112, COUNT @D159111, 
            PER @D159110, PLU @D159109, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : TRY, 
   [COORD @D159117, AGR [COUNT @D159116, PER @D159115, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRY, 
   [COORD @D159119, AGR [COUNT @D159118, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRY, 
   [COORD @D159121, AGR [COUNT @D159120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TRY, 
   [COORD @D159125, AGR [COUNT @D159124, PER @D159123, PLU @D159122, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TRY, 
   [COORD @D159131, PAST @D159130, AGR [CASE @D159129, COUNT @D159128, 
            PER @D159127, PLU @D159126, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TRY, 
   [COORD @D159134, AGR [COUNT @D159133, PER @D159132, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159136, AGR [COUNT @D159135, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159138, AGR [COUNT @D159137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159142, AGR [COUNT @D159141, PER @D159140, PLU @D159139, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159148, PAST @D159147, 
      AGR [CASE @D159146, COUNT @D159145, PER @D159144, PLU @D159143, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159151, AGR [COUNT @D159150, PER @D159149, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159153, AGR [COUNT @D159152, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159155, AGR [COUNT @D159154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159159, AGR [COUNT @D159158, PER @D159157, PLU @D159156, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159165, PAST @D159164, 
      AGR [CASE @D159163, COUNT @D159162, PER @D159161, PLU @D159160, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : TRY, 
   [COORD @D159168, AGR [COUNT @D159167, PER @D159166, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TRY, 
   [COORD @D159170, AGR [COUNT @D159169, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TRY, 
   [COORD @D159172, AGR [COUNT @D159171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TRY, 
   [COORD @D159176, AGR [COUNT @D159175, PER @D159174, PLU @D159173, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : TRY, 
   [COORD @D159182, PAST @D159181, 
      AGR [CASE @D159180, COUNT @D159179, PER @D159178, PLU @D159177, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : TRY, 
   [COORD @D159185, AGR [COUNT @D159184, PER @D159183, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : TRY, 
   [COORD @D159187, AGR [COUNT @D159186, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : TRY, 
   [COORD @D159189, AGR [COUNT @D159188, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : TRY, 
   [COORD @D159193, AGR [COUNT @D159192, PER @D159191, PLU @D159190, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : TRY, 
   [COORD @D159199, PAST @D159198, 
      AGR [CASE @D159197, COUNT @D159196, PER @D159195, PLU @D159194, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : TRY, 
   [COORD @D159202, AGR [COUNT @D159201, PER @D159200, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRY, 
   [COORD @D159204, AGR [COUNT @D159203, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRY, 
   [COORD @D159206, AGR [COUNT @D159205, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRY, 
   [COORD @D159210, AGR [COUNT @D159209, PER @D159208, PLU @D159207, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TRY, 
   [COORD @D159216, PAST @D159215, AGR [CASE @D159214, COUNT @D159213, 
            PER @D159212, PLU @D159211, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TRY, 
   [COORD @D159219, AGR [COUNT @D159218, PER @D159217, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRY, 
   [COORD @D159221, AGR [COUNT @D159220, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRY, 
   [COORD @D159223, AGR [COUNT @D159222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRY, 
   [COORD @D159227, AGR [COUNT @D159226, PER @D159225, PLU @D159224, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TRY, 
   [COORD @D159233, PAST @D159232, 
      AGR [CASE @D159231, COUNT @D159230, PER @D159229, PLU @D159228, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : TRY, 
   [COORD @D159236, AGR [COUNT @D159235, PER @D159234, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TRY, 
   [COORD @D159238, AGR [COUNT @D159237, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TRY, 
   [COORD @D159240, AGR [COUNT @D159239, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TRY, 
   [COORD @D159244, AGR [COUNT @D159243, PER @D159242, PLU @D159241, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TRY, 
   [COORD @D159250, PAST @D159249, 
      AGR [CASE @D159248, COUNT @D159247, PER @D159246, PLU @D159245, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : TRY.

WORD trying : 
   [COORD @D159266, PRD @D159265, AGR [CASE @D159264, COUNT @D159263, 
            PER @D159262, PLU @D159261, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D159272, PRD @D159271, 
      AGR [CASE @D159270, COUNT @D159269, PER @D159268, PLU @D159267, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TRY, 
   [COORD @D159278, PRD @D159277, AGR [CASE @D159276, COUNT @D159275, 
            PER @D159274, PLU @D159273, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D159284, PRD @D159283, 
      AGR [CASE @D159282, COUNT @D159281, PER @D159280, PLU @D159279, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TRY, 
   [COORD @D159290, PRD @D159289, AGR [CASE @D159288, COUNT @D159287, 
            PER @D159286, PLU @D159285, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D159296, PRD @D159295, 
      AGR [CASE @D159294, COUNT @D159293, PER @D159292, PLU @D159291, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TRY, 
   [COORD @D159302, PRD @D159301, AGR [CASE @D159300, COUNT @D159299, 
            PER @D159298, PLU @D159297, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D159308, PRD @D159307, 
      AGR [CASE @D159306, COUNT @D159305, PER @D159304, PLU @D159303, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TRY, 
   [COORD @D159314, PRD @D159313, AGR [CASE @D159312, COUNT @D159311, 
            PER @D159310, PLU @D159309, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TRY, 
   [COORD @D159320, PRD @D159319, 
      AGR [CASE @D159318, COUNT @D159317, PER @D159316, PLU @D159315, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TRY.

WORD tunnel : 
   [COORD @D159326, REFL @D159325, PRD @D159324, CASE @D159323, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TUNNEL, 
   [COORD @D159329, 
      AGR [COUNT @D159328, PER @D159327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, ARITY 2] : 
   TUNNEL, 
   [COORD @D159331, AGR [COUNT @D159330, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TUNNEL, 
   [COORD @D159333, AGR [COUNT @D159332, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TUNNEL, 
   [COORD @D159337, AGR [COUNT @D159336, PER @D159335, PLU @D159334, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TUNNEL, 
   [COORD @D159343, PAST @D159342, AGR [CASE @D159341, COUNT @D159340, 
            PER @D159339, PLU @D159338, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TUNNEL, 
   [COORD @D159346, AGR [COUNT @D159345, PER @D159344, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TUNNEL, 
   [COORD @D159348, AGR [COUNT @D159347, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TUNNEL, 
   [COORD @D159350, AGR [COUNT @D159349, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TUNNEL, 
   [COORD @D159354, AGR [COUNT @D159353, PER @D159352, PLU @D159351, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TUNNEL, 
   [COORD @D159360, PAST @D159359, AGR [CASE @D159358, COUNT @D159357, 
            PER @D159356, PLU @D159355, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TUNNEL.

WORD tunnelled : 
   [COORD @D159373, AGR [CASE @D159372, COUNT @D159371, PER @D159370, 
            PLU @D159369, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TUNNEL, 
   [COORD @D159378, AGR [CASE @D159377, COUNT @D159376, PER @D159375, 
            PLU @D159374, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TUNNEL, 
   [COORD @D159383, AGR [CASE @D159382, COUNT @D159381, PER @D159380, 
            PLU @D159379, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TUNNEL, 
   [COORD @D159388, AGR [CASE @D159387, COUNT @D159386, PER @D159385, 
            PLU @D159384, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TUNNEL, 
   [COORD @D159393, AGR [CASE @D159392, COUNT @D159391, PER @D159390, 
            PLU @D159389, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TUNNEL.

WORD tunnelling : 
   [COORD @D159411, PRD @D159410, AGR [CASE @D159409, COUNT @D159408, 
            PER @D159407, PLU @D159406, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TUNNEL, 
   [COORD @D159417, PRD @D159416, 
      AGR [CASE @D159415, COUNT @D159414, PER @D159413, PLU @D159412, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TUNNEL.

WORD tunnels : 
   [COORD @D159426, DEMON @D159425, REFL @D159424, PRD @D159423, 
      CASE @D159422, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TUNNEL, 
   [COORD @D159428, AGR [COUNT @D159427, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TUNNEL, 
   [COORD @D159430, 
      AGR [COUNT @D159429, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TUNNEL.

WORD turn : 
   [COORD @D159436, REFL @D159435, PRD @D159434, CASE @D159433, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TURN, 
   [COORD @D159441, REFL @D159440, COUNT @D159439, PRD @D159438, 
      CASE @D159437, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TURN, 
   [COORD @D159445, REFL @D159444, PRD @D159443, CASE @D159442, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN +, ADDRESS -, 
      PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : TURN, 
   [COORD @D159450, REFL @D159449, COUNT @D159448, PRD @D159447, 
      CASE @D159446, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, 
      PART -, DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : TURN, 
   [COORD @D159454, REFL @D159453, PRD @D159452, CASE @D159451, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF, COUNT +] : TURN, 
   [COORD @D159457, 
      AGR [COUNT @D159456, PER @D159455, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP_PP, 
      PFORM FROM_INTO, ARITY 4] : TURN, 
   [COORD @D159459, AGR [COUNT @D159458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_INTO, ARITY 4] : TURN, 
   [COORD @D159461, 
      AGR [COUNT @D159460, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 2, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP_PP, 
      PFORM FROM_INTO, ARITY 4] : TURN, 
   [COORD @D159465, AGR [COUNT @D159464, PER @D159463, PLU @D159462, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_INTO, ARITY 4] : TURN, 
   [COORD @D159471, PAST @D159470, 
      AGR [CASE @D159469, COUNT @D159468, PER @D159467, PLU @D159466, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP_PP, PFORM FROM_INTO, ARITY 4] : TURN, 
   [COORD @D159474, 
      AGR [COUNT @D159473, PER @D159472, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      ARITY 3] : TURN, 
   [COORD @D159476, AGR [COUNT @D159475, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : TURN, 
   [COORD @D159478, AGR [COUNT @D159477, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : TURN, 
   [COORD @D159482, AGR [COUNT @D159481, PER @D159480, PLU @D159479, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, ARITY 3] : TURN, 
   [COORD @D159488, PAST @D159487, AGR [CASE @D159486, COUNT @D159485, 
            PER @D159484, PLU @D159483, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_AP, ARITY 3] : TURN, 
   [COORD @D159491, AGR [COUNT @D159490, PER @D159489, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TURN, 
   [COORD @D159493, AGR [COUNT @D159492, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TURN, 
   [COORD @D159495, AGR [COUNT @D159494, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TURN, 
   [COORD @D159499, AGR [COUNT @D159498, PER @D159497, PLU @D159496, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : TURN, 
   [COORD @D159505, PAST @D159504, AGR [CASE @D159503, COUNT @D159502, 
            PER @D159501, PLU @D159500, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : TURN, 
   [COORD @D159508, AGR [COUNT @D159507, PER @D159506, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159510, 
      AGR [COUNT @D159509, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, PRT OVER, 
      PFORM TO, ARITY 3] : TURN, 
   [COORD @D159512, AGR [COUNT @D159511, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159516, 
      AGR [COUNT @D159515, PER @D159514, PLU @D159513, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159522, PAST @D159521, 
      AGR [CASE @D159520, COUNT @D159519, PER @D159518, PLU @D159517, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159525, AGR [COUNT @D159524, PER @D159523, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TURN, 
   [COORD @D159527, AGR [COUNT @D159526, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TURN, 
   [COORD @D159529, AGR [COUNT @D159528, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TURN, 
   [COORD @D159533, AGR [COUNT @D159532, PER @D159531, PLU @D159530, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : TURN, 
   [COORD @D159539, PAST @D159538, 
      AGR [CASE @D159537, COUNT @D159536, PER @D159535, PLU @D159534, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : TURN, 
   [COORD @D159542, AGR [COUNT @D159541, PER @D159540, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TURN, 
   [COORD @D159544, AGR [COUNT @D159543, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TURN, 
   [COORD @D159546, AGR [COUNT @D159545, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TURN, 
   [COORD @D159550, AGR [COUNT @D159549, PER @D159548, PLU @D159547, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FROM, ARITY 3] : TURN, 
   [COORD @D159556, PAST @D159555, 
      AGR [CASE @D159554, COUNT @D159553, PER @D159552, PLU @D159551, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FROM, ARITY 3] : TURN, 
   [COORD @D159559, AGR [COUNT @D159558, PER @D159557, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : TURN, 
   [COORD @D159561, AGR [COUNT @D159560, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : TURN, 
   [COORD @D159563, AGR [COUNT @D159562, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : TURN, 
   [COORD @D159567, AGR [COUNT @D159566, PER @D159565, PLU @D159564, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : TURN, 
   [COORD @D159573, PAST @D159572, 
      AGR [CASE @D159571, COUNT @D159570, PER @D159569, PLU @D159568, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AGAINST, ARITY 3] : TURN, 
   [COORD @D159576, AGR [COUNT @D159575, PER @D159574, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159578, 
      AGR [COUNT @D159577, N +, V -, BAR 2, NFORM NORM, CASE NOM, PER 1, 
            PLU -], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, N -, 
      SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OVER, 
      PFORM TO, ARITY 3] : TURN, 
   [COORD @D159580, AGR [COUNT @D159579, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159584, 
      AGR [COUNT @D159583, PER @D159582, PLU @D159581, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, PAST NOT, 
      FIX NOT, V +, N -, SUBCAT NP_PP, SUBTYPE NONE, REG +, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159590, PAST @D159589, 
      AGR [CASE @D159588, COUNT @D159587, PER @D159586, PLU @D159585, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, PFORM TO, ARITY 3] : TURN, 
   [COORD @D159593, AGR [COUNT @D159592, PER @D159591, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : TURN, 
   [COORD @D159595, AGR [COUNT @D159594, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : TURN, 
   [COORD @D159597, AGR [COUNT @D159596, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : TURN, 
   [COORD @D159601, AGR [COUNT @D159600, PER @D159599, PLU @D159598, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, ARITY 2] : TURN, 
   [COORD @D159607, PAST @D159606, AGR [CASE @D159605, COUNT @D159604, 
            PER @D159603, PLU @D159602, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_NP, ARITY 2] : TURN, 
   [COORD @D159610, AGR [COUNT @D159609, PER @D159608, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : TURN, 
   [COORD @D159612, AGR [COUNT @D159611, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : TURN, 
   [COORD @D159614, AGR [COUNT @D159613, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : TURN, 
   [COORD @D159618, AGR [COUNT @D159617, PER @D159616, PLU @D159615, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, ARITY 2] : TURN, 
   [COORD @D159624, PAST @D159623, AGR [CASE @D159622, COUNT @D159621, 
            PER @D159620, PLU @D159619, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_AP, ARITY 2] : TURN, 
   [COORD @D159627, AGR [COUNT @D159626, PER @D159625, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TURN, 
   [COORD @D159629, AGR [COUNT @D159628, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TURN, 
   [COORD @D159631, AGR [COUNT @D159630, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : TURN, 
   [COORD @D159635, AGR [COUNT @D159634, PER @D159633, PLU @D159632, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : TURN, 
   [COORD @D159641, PAST @D159640, AGR [CASE @D159639, COUNT @D159638, 
            PER @D159637, PLU @D159636, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : TURN, 
   [COORD @D159644, AGR [COUNT @D159643, PER @D159642, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TURN, 
   [COORD @D159646, AGR [COUNT @D159645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TURN, 
   [COORD @D159648, AGR [COUNT @D159647, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : TURN, 
   [COORD @D159652, AGR [COUNT @D159651, PER @D159650, PLU @D159649, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : TURN, 
   [COORD @D159658, PAST @D159657, AGR [CASE @D159656, COUNT @D159655, 
            PER @D159654, PLU @D159653, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : TURN, 
   [COORD @D159661, AGR [COUNT @D159660, PER @D159659, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : TURN, 
   [COORD @D159663, AGR [COUNT @D159662, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : TURN, 
   [COORD @D159665, AGR [COUNT @D159664, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : TURN, 
   [COORD @D159669, AGR [COUNT @D159668, PER @D159667, PLU @D159666, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, ARITY 2] : TURN, 
   [COORD @D159675, PAST @D159674, 
      AGR [CASE @D159673, COUNT @D159672, PER @D159671, PLU @D159670, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM TO, ARITY 2] : TURN, 
   [COORD @D159678, AGR [COUNT @D159677, PER @D159676, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TURN, 
   [COORD @D159680, AGR [COUNT @D159679, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TURN, 
   [COORD @D159682, AGR [COUNT @D159681, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TURN, 
   [COORD @D159686, AGR [COUNT @D159685, PER @D159684, PLU @D159683, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : TURN, 
   [COORD @D159692, PAST @D159691, 
      AGR [CASE @D159690, COUNT @D159689, PER @D159688, PLU @D159687, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : TURN, 
   [COORD @D159695, AGR [COUNT @D159694, PER @D159693, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : TURN, 
   [COORD @D159697, AGR [COUNT @D159696, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : TURN, 
   [COORD @D159699, AGR [COUNT @D159698, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : TURN, 
   [COORD @D159703, AGR [COUNT @D159702, PER @D159701, PLU @D159700, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM INTO, ARITY 2] : TURN, 
   [COORD @D159709, PAST @D159708, 
      AGR [CASE @D159707, COUNT @D159706, PER @D159705, PLU @D159704, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM INTO, ARITY 2] : TURN, 
   [COORD @D159712, AGR [COUNT @D159711, PER @D159710, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : TURN, 
   [COORD @D159714, AGR [COUNT @D159713, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : TURN, 
   [COORD @D159716, AGR [COUNT @D159715, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : TURN, 
   [COORD @D159720, AGR [COUNT @D159719, PER @D159718, PLU @D159717, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : TURN, 
   [COORD @D159726, PAST @D159725, 
      AGR [CASE @D159724, COUNT @D159723, PER @D159722, PLU @D159721, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : TURN, 
   [COORD @D159729, AGR [COUNT @D159728, PER @D159727, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : TURN, 
   [COORD @D159731, AGR [COUNT @D159730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : TURN, 
   [COORD @D159733, AGR [COUNT @D159732, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : TURN, 
   [COORD @D159737, AGR [COUNT @D159736, PER @D159735, PLU @D159734, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : TURN, 
   [COORD @D159743, PAST @D159742, 
      AGR [CASE @D159741, COUNT @D159740, PER @D159739, PLU @D159738, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : TURN, 
   [COORD @D159746, AGR [COUNT @D159745, PER @D159744, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TURN, 
   [COORD @D159748, AGR [COUNT @D159747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TURN, 
   [COORD @D159750, AGR [COUNT @D159749, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : TURN, 
   [COORD @D159754, AGR [COUNT @D159753, PER @D159752, PLU @D159751, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : TURN, 
   [COORD @D159760, PAST @D159759, 
      AGR [CASE @D159758, COUNT @D159757, PER @D159756, PLU @D159755, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : TURN, 
   [COORD @D159763, AGR [COUNT @D159762, PER @D159761, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TURN, 
   [COORD @D159765, AGR [COUNT @D159764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TURN, 
   [COORD @D159767, AGR [COUNT @D159766, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TURN, 
   [COORD @D159771, AGR [COUNT @D159770, PER @D159769, PLU @D159768, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : TURN, 
   [COORD @D159777, PAST @D159776, 
      AGR [CASE @D159775, COUNT @D159774, PER @D159773, PLU @D159772, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : TURN, 
   [COORD @D159780, AGR [COUNT @D159779, PER @D159778, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TURN, 
   [COORD @D159782, AGR [COUNT @D159781, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TURN, 
   [COORD @D159784, AGR [COUNT @D159783, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : TURN, 
   [COORD @D159788, AGR [COUNT @D159787, PER @D159786, PLU @D159785, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : TURN, 
   [COORD @D159794, PAST @D159793, 
      AGR [CASE @D159792, COUNT @D159791, PER @D159790, PLU @D159789, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : TURN, 
   [COORD @D159797, AGR [COUNT @D159796, PER @D159795, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : TURN, 
   [COORD @D159799, AGR [COUNT @D159798, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : TURN, 
   [COORD @D159801, AGR [COUNT @D159800, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : TURN, 
   [COORD @D159805, AGR [COUNT @D159804, PER @D159803, PLU @D159802, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : TURN, 
   [COORD @D159811, PAST @D159810, 
      AGR [CASE @D159809, COUNT @D159808, PER @D159807, PLU @D159806, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : TURN, 
   [COORD @D159814, AGR [COUNT @D159813, PER @D159812, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : TURN, 
   [COORD @D159816, AGR [COUNT @D159815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : TURN, 
   [COORD @D159818, AGR [COUNT @D159817, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : TURN, 
   [COORD @D159822, AGR [COUNT @D159821, PER @D159820, PLU @D159819, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : TURN, 
   [COORD @D159828, PAST @D159827, 
      AGR [CASE @D159826, COUNT @D159825, PER @D159824, PLU @D159823, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : TURN, 
   [COORD @D159831, AGR [COUNT @D159830, PER @D159829, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : TURN, 
   [COORD @D159833, AGR [COUNT @D159832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : TURN, 
   [COORD @D159835, AGR [COUNT @D159834, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : TURN, 
   [COORD @D159839, AGR [COUNT @D159838, PER @D159837, PLU @D159836, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : TURN, 
   [COORD @D159845, PAST @D159844, 
      AGR [CASE @D159843, COUNT @D159842, PER @D159841, PLU @D159840, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : TURN, 
   [COORD @D159848, AGR [COUNT @D159847, PER @D159846, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TURN, 
   [COORD @D159850, AGR [COUNT @D159849, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TURN, 
   [COORD @D159852, AGR [COUNT @D159851, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TURN, 
   [COORD @D159856, AGR [COUNT @D159855, PER @D159854, PLU @D159853, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : TURN, 
   [COORD @D159862, PAST @D159861, 
      AGR [CASE @D159860, COUNT @D159859, PER @D159858, PLU @D159857, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : TURN, 
   [COORD @D159865, AGR [COUNT @D159864, PER @D159863, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : TURN, 
   [COORD @D159867, AGR [COUNT @D159866, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : TURN, 
   [COORD @D159869, AGR [COUNT @D159868, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : TURN, 
   [COORD @D159873, AGR [COUNT @D159872, PER @D159871, PLU @D159870, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT BACK, ARITY 2] : TURN, 
   [COORD @D159879, PAST @D159878, 
      AGR [CASE @D159877, COUNT @D159876, PER @D159875, PLU @D159874, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT BACK, ARITY 2] : TURN, 
   [COORD @D159882, AGR [COUNT @D159881, PER @D159880, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : TURN, 
   [COORD @D159884, AGR [COUNT @D159883, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : TURN, 
   [COORD @D159886, AGR [COUNT @D159885, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : TURN, 
   [COORD @D159890, AGR [COUNT @D159889, PER @D159888, PLU @D159887, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT AWAY, ARITY 2] : TURN, 
   [COORD @D159896, PAST @D159895, 
      AGR [CASE @D159894, COUNT @D159893, PER @D159892, PLU @D159891, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT AWAY, ARITY 2] : TURN, 
   [COORD @D159899, AGR [COUNT @D159898, PER @D159897, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TURN, 
   [COORD @D159901, AGR [COUNT @D159900, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TURN, 
   [COORD @D159903, AGR [COUNT @D159902, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TURN, 
   [COORD @D159907, AGR [COUNT @D159906, PER @D159905, PLU @D159904, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : TURN, 
   [COORD @D159913, PAST @D159912, AGR [CASE @D159911, COUNT @D159910, 
            PER @D159909, PLU @D159908, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : TURN, 
   [COORD @D159916, AGR [COUNT @D159915, PER @D159914, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TURN, 
   [COORD @D159918, AGR [COUNT @D159917, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TURN, 
   [COORD @D159920, AGR [COUNT @D159919, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TURN, 
   [COORD @D159924, AGR [COUNT @D159923, PER @D159922, PLU @D159921, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : TURN, 
   [COORD @D159930, PAST @D159929, 
      AGR [CASE @D159928, COUNT @D159927, PER @D159926, PLU @D159925, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : TURN, 
   [COORD @D159933, AGR [COUNT @D159932, PER @D159931, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TO, ARITY 1] : TURN, 
   [COORD @D159935, AGR [COUNT @D159934, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TO, ARITY 1] : TURN, 
   [COORD @D159937, AGR [COUNT @D159936, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TO, ARITY 1] : TURN, 
   [COORD @D159941, AGR [COUNT @D159940, PER @D159939, PLU @D159938, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT TO, ARITY 1] : TURN, 
   [COORD @D159947, PAST @D159946, 
      AGR [CASE @D159945, COUNT @D159944, PER @D159943, PLU @D159942, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT TO, ARITY 1] : TURN, 
   [COORD @D159950, AGR [COUNT @D159949, PER @D159948, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TURN, 
   [COORD @D159952, AGR [COUNT @D159951, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TURN, 
   [COORD @D159954, AGR [COUNT @D159953, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TURN, 
   [COORD @D159958, AGR [COUNT @D159957, PER @D159956, PLU @D159955, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ROUND, ARITY 1] : TURN, 
   [COORD @D159964, PAST @D159963, 
      AGR [CASE @D159962, COUNT @D159961, PER @D159960, PLU @D159959, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ROUND, ARITY 1] : TURN, 
   [COORD @D159967, AGR [COUNT @D159966, PER @D159965, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TURN, 
   [COORD @D159969, AGR [COUNT @D159968, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TURN, 
   [COORD @D159971, AGR [COUNT @D159970, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TURN, 
   [COORD @D159975, AGR [COUNT @D159974, PER @D159973, PLU @D159972, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : TURN, 
   [COORD @D159981, PAST @D159980, 
      AGR [CASE @D159979, COUNT @D159978, PER @D159977, PLU @D159976, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : TURN, 
   [COORD @D159983, AGR [COUNT @D159982, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D159985, AGR [COUNT @D159984, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D159989, AGR [NFORM @D159988, COUNT @D159987, PER @D159986, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D159993, AGR [COUNT @D159992, PER @D159991, PLU @D159990, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_NP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D159996, AGR @D159995, PAST @D159994, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_NP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D159998, AGR [COUNT @D159997, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160000, AGR [COUNT @D159999, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160004, AGR [NFORM @D160003, COUNT @D160002, PER @D160001, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160008, AGR [COUNT @D160007, PER @D160006, PLU @D160005, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160011, AGR @D160010, PAST @D160009, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_INF, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160013, AGR [COUNT @D160012, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160015, AGR [COUNT @D160014, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160019, AGR [NFORM @D160018, COUNT @D160017, PER @D160016, 
            N +, V -, BAR 2, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, 
      PAST -, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160023, AGR [COUNT @D160022, PER @D160021, PLU @D160020, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, SUBTYPE RAIS, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160026, AGR @D160025, PAST @D160024, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT SC_AP, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160029, AGR [COUNT @D160028, PER @D160027, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160031, AGR [COUNT @D160030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160033, AGR [COUNT @D160032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160037, AGR [COUNT @D160036, PER @D160035, PLU @D160034, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : TURN, 
   [COORD @D160043, PAST @D160042, 
      AGR [CASE @D160041, COUNT @D160040, PER @D160039, PLU @D160038, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : TURN, 
   [COORD @D160046, AGR [COUNT @D160045, PER @D160044, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TURN, 
   [COORD @D160048, AGR [COUNT @D160047, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TURN, 
   [COORD @D160050, AGR [COUNT @D160049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TURN, 
   [COORD @D160054, AGR [COUNT @D160053, PER @D160052, PLU @D160051, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : TURN, 
   [COORD @D160060, PAST @D160059, 
      AGR [CASE @D160058, COUNT @D160057, PER @D160056, PLU @D160055, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : TURN, 
   [COORD @D160063, AGR [COUNT @D160062, PER @D160061, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TURN, 
   [COORD @D160065, AGR [COUNT @D160064, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TURN, 
   [COORD @D160067, AGR [COUNT @D160066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TURN, 
   [COORD @D160071, AGR [COUNT @D160070, PER @D160069, PLU @D160068, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : TURN, 
   [COORD @D160077, PAST @D160076, 
      AGR [CASE @D160075, COUNT @D160074, PER @D160073, PLU @D160072, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : TURN, 
   [COORD @D160080, AGR [COUNT @D160079, PER @D160078, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TURN, 
   [COORD @D160082, AGR [COUNT @D160081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TURN, 
   [COORD @D160084, AGR [COUNT @D160083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TURN, 
   [COORD @D160088, AGR [COUNT @D160087, PER @D160086, PLU @D160085, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : TURN, 
   [COORD @D160094, PAST @D160093, 
      AGR [CASE @D160092, COUNT @D160091, PER @D160090, PLU @D160089, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : TURN, 
   [COORD @D160097, AGR [COUNT @D160096, PER @D160095, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TURN, 
   [COORD @D160099, AGR [COUNT @D160098, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TURN, 
   [COORD @D160101, AGR [COUNT @D160100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TURN, 
   [COORD @D160105, AGR [COUNT @D160104, PER @D160103, PLU @D160102, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : TURN, 
   [COORD @D160111, PAST @D160110, 
      AGR [CASE @D160109, COUNT @D160108, PER @D160107, PLU @D160106, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : TURN, 
   [COORD @D160114, AGR [COUNT @D160113, PER @D160112, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : TURN, 
   [COORD @D160116, AGR [COUNT @D160115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : TURN, 
   [COORD @D160118, AGR [COUNT @D160117, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : TURN, 
   [COORD @D160122, AGR [COUNT @D160121, PER @D160120, PLU @D160119, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT BACK, ARITY 1] : TURN, 
   [COORD @D160128, PAST @D160127, 
      AGR [CASE @D160126, COUNT @D160125, PER @D160124, PLU @D160123, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT BACK, ARITY 1] : TURN, 
   [COORD @D160131, AGR [COUNT @D160130, PER @D160129, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : TURN, 
   [COORD @D160133, AGR [COUNT @D160132, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : TURN, 
   [COORD @D160135, AGR [COUNT @D160134, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : TURN, 
   [COORD @D160139, AGR [COUNT @D160138, PER @D160137, PLU @D160136, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AWAY, ARITY 1] : TURN, 
   [COORD @D160145, PAST @D160144, 
      AGR [CASE @D160143, COUNT @D160142, PER @D160141, PLU @D160140, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AWAY, ARITY 1] : TURN, 
   [COORD @D160150, PAST @D160149, AGR [COUNT @D160148, PER @D160147, 
            PLU @D160146, NFORM IT, CASE NOM, N +, V -, BAR 2], FIX NOT, 
      V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 1] : TURN.

WORD turned : 
   [COORD @D160159, AGR [CASE @D160158, COUNT @D160157, PER @D160156, 
            PLU @D160155, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM_INTO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160164, AGR [CASE @D160163, COUNT @D160162, PER @D160161, 
            PLU @D160160, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_INTO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160169, 
      AGR [CASE @D160168, COUNT @D160167, PER @D160166, PLU @D160165, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160174, AGR [CASE @D160173, COUNT @D160172, PER @D160171, 
            PLU @D160170, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160179, AGR [CASE @D160178, COUNT @D160177, PER @D160176, 
            PLU @D160175, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160185, AGR [CASE @D160184, NFORM @D160183, COUNT @D160182, 
            PER @D160181, PLU @D160180, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160190, AGR [CASE @D160189, COUNT @D160188, PER @D160187, 
            PLU @D160186, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160195, AGR [CASE @D160194, COUNT @D160193, PER @D160192, 
            PLU @D160191, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160200, AGR [CASE @D160199, COUNT @D160198, PER @D160197, 
            PLU @D160196, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160205, AGR [CASE @D160204, COUNT @D160203, PER @D160202, 
            PLU @D160201, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PRT OVER, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160210, AGR [CASE @D160209, COUNT @D160208, PER @D160207, 
            PLU @D160206, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PRT OVER, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160215, 
      AGR [CASE @D160214, COUNT @D160213, PER @D160212, PLU @D160211, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160220, AGR [CASE @D160219, COUNT @D160218, PER @D160217, 
            PLU @D160216, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160225, AGR [CASE @D160224, COUNT @D160223, PER @D160222, 
            PLU @D160221, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160230, AGR [CASE @D160229, COUNT @D160228, PER @D160227, 
            PLU @D160226, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160235, AGR [CASE @D160234, COUNT @D160233, PER @D160232, 
            PLU @D160231, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160240, AGR [CASE @D160239, COUNT @D160238, PER @D160237, 
            PLU @D160236, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160245, AGR [CASE @D160244, COUNT @D160243, PER @D160242, 
            PLU @D160241, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160250, AGR [CASE @D160249, COUNT @D160248, PER @D160247, 
            PLU @D160246, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160255, AGR [CASE @D160254, COUNT @D160253, PER @D160252, 
            PLU @D160251, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160260, AGR [CASE @D160259, COUNT @D160258, PER @D160257, 
            PLU @D160256, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160265, AGR [CASE @D160264, COUNT @D160263, PER @D160262, 
            PLU @D160261, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160270, AGR [CASE @D160269, COUNT @D160268, PER @D160267, 
            PLU @D160266, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160275, 
      AGR [CASE @D160274, COUNT @D160273, PER @D160272, PLU @D160271, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160280, AGR [CASE @D160279, COUNT @D160278, PER @D160277, 
            PLU @D160276, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160285, AGR [CASE @D160284, COUNT @D160283, PER @D160282, 
            PLU @D160281, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160290, AGR [CASE @D160289, COUNT @D160288, PER @D160287, 
            PLU @D160286, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160295, AGR [CASE @D160294, COUNT @D160293, PER @D160292, 
            PLU @D160291, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160300, AGR [CASE @D160299, COUNT @D160298, PER @D160297, 
            PLU @D160296, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160305, AGR [CASE @D160304, COUNT @D160303, PER @D160302, 
            PLU @D160301, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160310, AGR [CASE @D160309, COUNT @D160308, PER @D160307, 
            PLU @D160306, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160315, AGR [CASE @D160314, COUNT @D160313, PER @D160312, 
            PLU @D160311, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160320, AGR [CASE @D160319, COUNT @D160318, PER @D160317, 
            PLU @D160316, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160325, AGR [CASE @D160324, COUNT @D160323, PER @D160322, 
            PLU @D160321, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM TO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160330, AGR [CASE @D160329, COUNT @D160328, PER @D160327, 
            PLU @D160326, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160335, AGR [CASE @D160334, COUNT @D160333, PER @D160332, 
            PLU @D160331, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160340, AGR [CASE @D160339, COUNT @D160338, PER @D160337, 
            PLU @D160336, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160345, AGR [CASE @D160344, COUNT @D160343, PER @D160342, 
            PLU @D160341, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160350, AGR [CASE @D160349, COUNT @D160348, PER @D160347, 
            PLU @D160346, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160355, AGR [CASE @D160354, COUNT @D160353, PER @D160352, 
            PLU @D160351, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160360, AGR [CASE @D160359, COUNT @D160358, PER @D160357, 
            PLU @D160356, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160365, AGR [CASE @D160364, COUNT @D160363, PER @D160362, 
            PLU @D160361, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160370, AGR [CASE @D160369, COUNT @D160368, PER @D160367, 
            PLU @D160366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160375, AGR [CASE @D160374, COUNT @D160373, PER @D160372, 
            PLU @D160371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160380, AGR [CASE @D160379, COUNT @D160378, PER @D160377, 
            PLU @D160376, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160385, AGR [CASE @D160384, COUNT @D160383, PER @D160382, 
            PLU @D160381, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160390, AGR [CASE @D160389, COUNT @D160388, PER @D160387, 
            PLU @D160386, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160395, AGR [CASE @D160394, COUNT @D160393, PER @D160392, 
            PLU @D160391, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160400, AGR [CASE @D160399, COUNT @D160398, PER @D160397, 
            PLU @D160396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160405, AGR [CASE @D160404, COUNT @D160403, PER @D160402, 
            PLU @D160401, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160410, AGR [CASE @D160409, COUNT @D160408, PER @D160407, 
            PLU @D160406, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160415, AGR [CASE @D160414, COUNT @D160413, PER @D160412, 
            PLU @D160411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160420, AGR [CASE @D160419, COUNT @D160418, PER @D160417, 
            PLU @D160416, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160425, AGR [CASE @D160424, COUNT @D160423, PER @D160422, 
            PLU @D160421, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160430, AGR [CASE @D160429, COUNT @D160428, PER @D160427, 
            PLU @D160426, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160435, AGR [CASE @D160434, COUNT @D160433, PER @D160432, 
            PLU @D160431, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160440, AGR [CASE @D160439, COUNT @D160438, PER @D160437, 
            PLU @D160436, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160445, AGR [CASE @D160444, COUNT @D160443, PER @D160442, 
            PLU @D160441, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160450, AGR [CASE @D160449, COUNT @D160448, PER @D160447, 
            PLU @D160446, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160455, AGR [CASE @D160454, COUNT @D160453, PER @D160452, 
            PLU @D160451, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160460, AGR [CASE @D160459, COUNT @D160458, PER @D160457, 
            PLU @D160456, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160465, AGR [CASE @D160464, COUNT @D160463, PER @D160462, 
            PLU @D160461, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160470, AGR [CASE @D160469, COUNT @D160468, PER @D160467, 
            PLU @D160466, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160475, AGR [CASE @D160474, COUNT @D160473, PER @D160472, 
            PLU @D160471, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160480, AGR [CASE @D160479, COUNT @D160478, PER @D160477, 
            PLU @D160476, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160485, AGR [CASE @D160484, COUNT @D160483, PER @D160482, 
            PLU @D160481, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160490, AGR [CASE @D160489, COUNT @D160488, PER @D160487, 
            PLU @D160486, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160495, AGR [CASE @D160494, COUNT @D160493, PER @D160492, 
            PLU @D160491, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160500, AGR [CASE @D160499, COUNT @D160498, PER @D160497, 
            PLU @D160496, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160505, AGR [CASE @D160504, COUNT @D160503, PER @D160502, 
            PLU @D160501, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160510, AGR [CASE @D160509, COUNT @D160508, PER @D160507, 
            PLU @D160506, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160515, AGR [CASE @D160514, COUNT @D160513, PER @D160512, 
            PLU @D160511, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160520, AGR [CASE @D160519, COUNT @D160518, PER @D160517, 
            PLU @D160516, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160525, AGR [CASE @D160524, COUNT @D160523, PER @D160522, 
            PLU @D160521, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160530, AGR [CASE @D160529, COUNT @D160528, PER @D160527, 
            PLU @D160526, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160535, AGR [CASE @D160534, COUNT @D160533, PER @D160532, 
            PLU @D160531, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160540, AGR [CASE @D160539, COUNT @D160538, PER @D160537, 
            PLU @D160536, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160545, AGR [CASE @D160544, COUNT @D160543, PER @D160542, 
            PLU @D160541, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160550, AGR [CASE @D160549, COUNT @D160548, PER @D160547, 
            PLU @D160546, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160555, AGR [CASE @D160554, COUNT @D160553, PER @D160552, 
            PLU @D160551, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160560, AGR [CASE @D160559, COUNT @D160558, PER @D160557, 
            PLU @D160556, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160565, AGR [CASE @D160564, COUNT @D160563, PER @D160562, 
            PLU @D160561, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160570, AGR [CASE @D160569, COUNT @D160568, PER @D160567, 
            PLU @D160566, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160572, AGR @D160571, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160574, AGR @D160573, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_NP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160576, AGR @D160575, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160578, AGR @D160577, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160580, AGR @D160579, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160582, AGR @D160581, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT SC_AP, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160587, AGR [CASE @D160586, COUNT @D160585, PER @D160584, 
            PLU @D160583, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160592, AGR [CASE @D160591, COUNT @D160590, PER @D160589, 
            PLU @D160588, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160597, AGR [CASE @D160596, COUNT @D160595, PER @D160594, 
            PLU @D160593, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160602, AGR [CASE @D160601, COUNT @D160600, PER @D160599, 
            PLU @D160598, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160607, AGR [CASE @D160606, COUNT @D160605, PER @D160604, 
            PLU @D160603, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160612, AGR [CASE @D160611, COUNT @D160610, PER @D160609, 
            PLU @D160608, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160617, AGR [CASE @D160616, COUNT @D160615, PER @D160614, 
            PLU @D160613, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160622, AGR [CASE @D160621, COUNT @D160620, PER @D160619, 
            PLU @D160618, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160627, AGR [CASE @D160626, COUNT @D160625, PER @D160624, 
            PLU @D160623, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160632, AGR [CASE @D160631, COUNT @D160630, PER @D160629, 
            PLU @D160628, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160637, AGR [CASE @D160636, COUNT @D160635, PER @D160634, 
            PLU @D160633, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160642, AGR [CASE @D160641, COUNT @D160640, PER @D160639, 
            PLU @D160638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160647, AGR [CASE @D160646, COUNT @D160645, PER @D160644, 
            PLU @D160643, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160652, AGR [CASE @D160651, COUNT @D160650, PER @D160649, 
            PLU @D160648, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : TURN, 
   [COORD @D160656, AGR [COUNT @D160655, PER @D160654, PLU @D160653, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160660, AGR [COUNT @D160659, PER @D160658, PLU @D160657, 
            NFORM IT, CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, 
      BAR 0, V +, N -] : TURN.

WORD turning : 
   [COORD @D160672, REFL @D160671, PRD @D160670, CASE @D160669, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : TURNING, 
   [COORD @D160678, PRD @D160677, 
      AGR [CASE @D160676, COUNT @D160675, PER @D160674, PLU @D160673, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP_PP, PFORM FROM_INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160684, PRD @D160683, 
      AGR [CASE @D160682, COUNT @D160681, PER @D160680, PLU @D160679, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   TURN, 
   [COORD @D160690, PRD @D160689, AGR [CASE @D160688, COUNT @D160687, 
            PER @D160686, PLU @D160685, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160696, PRD @D160695, 
      AGR [CASE @D160694, COUNT @D160693, PER @D160692, PLU @D160691, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160702, PRD @D160701, AGR [CASE @D160700, COUNT @D160699, 
            PER @D160698, PLU @D160697, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160708, PRD @D160707, 
      AGR [CASE @D160706, COUNT @D160705, PER @D160704, PLU @D160703, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160714, PRD @D160713, AGR [CASE @D160712, COUNT @D160711, 
            PER @D160710, PLU @D160709, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160720, PRD @D160719, 
      AGR [CASE @D160718, COUNT @D160717, PER @D160716, PLU @D160715, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160726, PRD @D160725, 
      AGR [CASE @D160724, COUNT @D160723, PER @D160722, PLU @D160721, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160732, PRD @D160731, AGR [CASE @D160730, COUNT @D160729, 
            PER @D160728, PLU @D160727, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_AP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160738, PRD @D160737, 
      AGR [CASE @D160736, COUNT @D160735, PER @D160734, PLU @D160733, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TURN, 
   [COORD @D160744, PRD @D160743, AGR [CASE @D160742, COUNT @D160741, 
            PER @D160740, PLU @D160739, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160750, PRD @D160749, 
      AGR [CASE @D160748, COUNT @D160747, PER @D160746, PLU @D160745, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TURN, 
   [COORD @D160756, PRD @D160755, AGR [CASE @D160754, COUNT @D160753, 
            PER @D160752, PLU @D160751, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160762, PRD @D160761, 
      AGR [CASE @D160760, COUNT @D160759, PER @D160758, PLU @D160757, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160768, PRD @D160767, AGR [CASE @D160766, COUNT @D160765, 
            PER @D160764, PLU @D160763, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160774, PRD @D160773, 
      AGR [CASE @D160772, COUNT @D160771, PER @D160770, PLU @D160769, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160780, PRD @D160779, AGR [CASE @D160778, COUNT @D160777, 
            PER @D160776, PLU @D160775, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160786, PRD @D160785, 
      AGR [CASE @D160784, COUNT @D160783, PER @D160782, PLU @D160781, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TURN, 
   [COORD @D160792, PRD @D160791, AGR [CASE @D160790, COUNT @D160789, 
            PER @D160788, PLU @D160787, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160798, PRD @D160797, 
      AGR [CASE @D160796, COUNT @D160795, PER @D160794, PLU @D160793, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TURN, 
   [COORD @D160804, PRD @D160803, AGR [CASE @D160802, COUNT @D160801, 
            PER @D160800, PLU @D160799, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160810, PRD @D160809, 
      AGR [CASE @D160808, COUNT @D160807, PER @D160806, PLU @D160805, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TURN, 
   [COORD @D160816, PRD @D160815, AGR [CASE @D160814, COUNT @D160813, 
            PER @D160812, PLU @D160811, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160822, PRD @D160821, 
      AGR [CASE @D160820, COUNT @D160819, PER @D160818, PLU @D160817, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : TURN, 
   [COORD @D160828, PRD @D160827, AGR [CASE @D160826, COUNT @D160825, 
            PER @D160824, PLU @D160823, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160834, PRD @D160833, 
      AGR [CASE @D160832, COUNT @D160831, PER @D160830, PLU @D160829, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160840, PRD @D160839, AGR [CASE @D160838, COUNT @D160837, 
            PER @D160836, PLU @D160835, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160846, PRD @D160845, 
      AGR [CASE @D160844, COUNT @D160843, PER @D160842, PLU @D160841, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160852, PRD @D160851, AGR [CASE @D160850, COUNT @D160849, 
            PER @D160848, PLU @D160847, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ROUND, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160858, PRD @D160857, 
      AGR [CASE @D160856, COUNT @D160855, PER @D160854, PLU @D160853, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160861, AGR @D160860, PRD @D160859, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_NP, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160864, AGR @D160863, PRD @D160862, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_INF, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160867, AGR @D160866, PRD @D160865, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE RAIS, SUBCAT SC_AP, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160873, PRD @D160872, AGR [CASE @D160871, COUNT @D160870, 
            PER @D160869, PLU @D160868, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160879, PRD @D160878, 
      AGR [CASE @D160877, COUNT @D160876, PER @D160875, PLU @D160874, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160885, PRD @D160884, AGR [CASE @D160883, COUNT @D160882, 
            PER @D160881, PLU @D160880, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160891, PRD @D160890, 
      AGR [CASE @D160889, COUNT @D160888, PER @D160887, PLU @D160886, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160897, PRD @D160896, AGR [CASE @D160895, COUNT @D160894, 
            PER @D160893, PLU @D160892, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160903, PRD @D160902, 
      AGR [CASE @D160901, COUNT @D160900, PER @D160899, PLU @D160898, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160909, PRD @D160908, AGR [CASE @D160907, COUNT @D160906, 
            PER @D160905, PLU @D160904, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN, 
   [COORD @D160914, PRD @D160913, 
      AGR [COUNT @D160912, PER @D160911, PLU @D160910, NFORM IT, CASE NOM, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : TURN.

WORD turnings : 
   [COORD @D160930, DEMON @D160929, REFL @D160928, PRD @D160927, 
      CASE @D160926, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TURNING.

WORD turns : 
   [COORD @D160939, DEMON @D160938, REFL @D160937, PRD @D160936, 
      CASE @D160935, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   TURN, 
   [COORD @D160944, DEMON @D160943, REFL @D160942, PRD @D160941, 
      CASE @D160940, COMPOUND NOT, FIX NOT, PN +, ADDRESS -, ADV -, PART -, 
      CONJ NULL, SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : TURN, 
   [COORD @D160949, DEMON @D160948, REFL @D160947, PRD @D160946, 
      CASE @D160945, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : TURN, 
   [COORD @D160954, DEMON @D160953, REFL @D160952, PRD @D160951, 
      CASE @D160950, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : TURN, 
   [COORD @D160956, 
      AGR [COUNT @D160955, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP_PP, PFORM FROM_INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160958, AGR [COUNT @D160957, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TURN, 
   [COORD @D160960, AGR [COUNT @D160959, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TURN, 
   [COORD @D160962, AGR [COUNT @D160961, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160964, AGR [COUNT @D160963, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160966, AGR [COUNT @D160965, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160968, AGR [COUNT @D160967, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160970, AGR [COUNT @D160969, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, PFORM TO, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D160972, AGR [COUNT @D160971, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160974, 
      AGR [COUNT @D160973, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160976, 
      AGR [COUNT @D160975, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160978, 
      AGR [COUNT @D160977, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160980, 
      AGR [COUNT @D160979, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160982, 
      AGR [COUNT @D160981, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160984, 
      AGR [COUNT @D160983, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160986, 
      AGR [COUNT @D160985, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D160988, 
      AGR [COUNT @D160987, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TURN, 
   [COORD @D160990, AGR [COUNT @D160989, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160992, AGR [COUNT @D160991, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160994, AGR [COUNT @D160993, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160996, AGR [COUNT @D160995, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D160998, AGR [COUNT @D160997, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161000, AGR [COUNT @D160999, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161002, AGR [COUNT @D161001, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161004, AGR [COUNT @D161003, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161006, AGR [COUNT @D161005, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161008, AGR [COUNT @D161007, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D161010, 
      AGR [COUNT @D161009, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D161012, 
      AGR [COUNT @D161011, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D161014, 
      AGR [COUNT @D161013, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D161016, 
      AGR [COUNT @D161015, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN, 
   [COORD @D161020, 
      AGR [CASE @D161019, NFORM @D161018, COUNT @D161017, PLU -, PER 3, 
            N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE RAIS, 
      SUBCAT SC_NP, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161025, AGR [UB @D161024, VFORM @D161023, SUBJ @D161022, 
            FIN @D161021, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_NP, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D161029, AGR [CASE @D161028, NFORM @D161027, COUNT @D161026, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D161034, AGR [UB @D161033, VFORM @D161032, SUBJ @D161031, 
            FIN @D161030, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_INF, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D161038, AGR [CASE @D161037, NFORM @D161036, COUNT @D161035, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D161043, AGR [UB @D161042, VFORM @D161041, SUBJ @D161040, 
            FIN @D161039, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT SC_AP, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : TURN, 
   [COORD @D161045, AGR [COUNT @D161044, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161047, AGR [COUNT @D161046, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TURN, 
   [COORD @D161049, AGR [COUNT @D161048, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161051, AGR [COUNT @D161050, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   TURN, 
   [COORD @D161053, AGR [COUNT @D161052, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161055, AGR [COUNT @D161054, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161057, AGR [COUNT @D161056, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : TURN, 
   [COORD @D161060, AGR [CASE @D161059, COUNT @D161058, N +, V -, BAR 2, 
            NFORM IT, PLU -, PER 3], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : TURN.

WORD understand : 
   [COORD @D161068, AGR [COUNT @D161067, PER @D161066, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : UNDERSTAND, 
   [COORD @D161070, AGR [COUNT @D161069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : UNDERSTAND, 
   [COORD @D161072, AGR [COUNT @D161071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PFORM BY, ARITY 3] : UNDERSTAND, 
   [COORD @D161076, AGR [COUNT @D161075, PER @D161074, PLU @D161073, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM BY, ARITY 3] : UNDERSTAND, 
   [COORD @D161082, PAST @D161081, 
      AGR [CASE @D161080, COUNT @D161079, PER @D161078, PLU @D161077, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PFORM BY, ARITY 3] : UNDERSTAND, 
   [COORD @D161085, AGR [COUNT @D161084, PER @D161083, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161087, AGR [COUNT @D161086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161089, AGR [COUNT @D161088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161093, AGR [COUNT @D161092, PER @D161091, PLU @D161090, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161099, PAST @D161098, AGR [CASE @D161097, COUNT @D161096, 
            PER @D161095, PLU @D161094, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161102, 
      AGR [COUNT @D161101, PER @D161100, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, ARITY 2] : 
   UNDERSTAND, 
   [COORD @D161104, AGR [COUNT @D161103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161106, AGR [COUNT @D161105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161110, AGR [COUNT @D161109, PER @D161108, PLU @D161107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161116, PAST @D161115, 
      AGR [CASE @D161114, COUNT @D161113, PER @D161112, PLU @D161111, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161119, AGR [COUNT @D161118, PER @D161117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161121, AGR [COUNT @D161120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161123, AGR [COUNT @D161122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161127, AGR [COUNT @D161126, PER @D161125, PLU @D161124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161133, PAST @D161132, 
      AGR [CASE @D161131, COUNT @D161130, PER @D161129, PLU @D161128, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT OC_INF, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161136, AGR [COUNT @D161135, PER @D161134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161138, AGR [COUNT @D161137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161140, AGR [COUNT @D161139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161144, AGR [COUNT @D161143, PER @D161142, PLU @D161141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161150, PAST @D161149, AGR [CASE @D161148, COUNT @D161147, 
            PER @D161146, PLU @D161145, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : UNDERSTAND, 
   [COORD @D161153, 
      AGR [COUNT @D161152, PER @D161151, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, ARITY 1] : 
   UNDERSTAND, 
   [COORD @D161155, AGR [COUNT @D161154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : UNDERSTAND, 
   [COORD @D161157, AGR [COUNT @D161156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : UNDERSTAND, 
   [COORD @D161161, AGR [COUNT @D161160, PER @D161159, PLU @D161158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : UNDERSTAND, 
   [COORD @D161167, PAST @D161166, 
      AGR [CASE @D161165, COUNT @D161164, PER @D161163, PLU @D161162, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : UNDERSTAND.

WORD understanding : 
   [COORD @D161185, REFL @D161184, PRD @D161183, CASE @D161182, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : UNDERSTANDING, 
   [COORD @D161190, REFL @D161189, COUNT @D161188, PRD @D161187, 
      CASE @D161186, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : UNDERSTANDING, 
   [COORD @D161196, PRD @D161195, 
      AGR [CASE @D161194, COUNT @D161193, PER @D161192, PLU @D161191, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : UNDERSTAND, 
   [COORD @D161202, PRD @D161201, AGR [CASE @D161200, COUNT @D161199, 
            PER @D161198, PLU @D161197, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : UNDERSTAND, 
   [COORD @D161208, PRD @D161207, 
      AGR [CASE @D161206, COUNT @D161205, PER @D161204, PLU @D161203, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : UNDERSTAND, 
   [COORD @D161214, PRD @D161213, AGR [CASE @D161212, COUNT @D161211, 
            PER @D161210, PLU @D161209, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : UNDERSTAND, 
   [COORD @D161220, PRD @D161219, 
      AGR [CASE @D161218, COUNT @D161217, PER @D161216, PLU @D161215, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : UNDERSTAND, 
   [COORD @D161226, PRD @D161225, AGR [CASE @D161224, COUNT @D161223, 
            PER @D161222, PLU @D161221, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : UNDERSTAND.

WORD understandings : 
   [COORD @D161241, DEMON @D161240, REFL @D161239, PRD @D161238, 
      CASE @D161237, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   UNDERSTANDING.

WORD understands : 
   [COORD @D161249, AGR [COUNT @D161248, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : UNDERSTAND, 
   [COORD @D161251, AGR [COUNT @D161250, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   UNDERSTAND, 
   [COORD @D161253, AGR [COUNT @D161252, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   UNDERSTAND, 
   [COORD @D161255, AGR [COUNT @D161254, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   UNDERSTAND, 
   [COORD @D161257, AGR [COUNT @D161256, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   UNDERSTAND, 
   [COORD @D161259, AGR [COUNT @D161258, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   UNDERSTAND.

WORD understood : 
   [COORD @D161270, PAST @D161269, AGR [CASE @D161268, COUNT @D161267, 
            PER @D161266, PLU @D161265, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM BY, FIN -, ARITY 3] : UNDERSTAND, 
   [COORD @D161276, PAST @D161275, 
      AGR [CASE @D161274, COUNT @D161273, PER @D161272, PLU @D161271, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM BY, 
      FIN -, ARITY 3] : UNDERSTAND, 
   [COORD @D161280, AGR [COUNT @D161279, PER @D161278, PLU @D161277, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM BY, PAST +, ARITY 3] : UNDERSTAND, 
   [COORD @D161286, PAST @D161285, 
      AGR [CASE @D161284, COUNT @D161283, PER @D161282, PLU @D161281, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, REG -, FIN -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161292, PAST @D161291, AGR [CASE @D161290, COUNT @D161289, 
            PER @D161288, PLU @D161287, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, FIN -, ARITY 2] : UNDERSTAND, 
   [COORD @D161295, AGR @D161294, PAST @D161293, VFORM EN, SUBCAT OC_INF, 
      SUBTYPE RAIS, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, 
      NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      FIN -, ARITY 2] : UNDERSTAND, 
   [COORD @D161301, PAST @D161300, AGR [CASE @D161299, COUNT @D161298, 
            PER @D161297, PLU @D161296, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, FIN -, ARITY 2] : UNDERSTAND, 
   [COORD @D161307, PAST @D161306, 
      AGR [CASE @D161305, COUNT @D161304, PER @D161303, PLU @D161302, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161313, PAST @D161312, AGR [CASE @D161311, COUNT @D161310, 
            PER @D161309, PLU @D161308, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : UNDERSTAND, 
   [COORD @D161317, AGR [COUNT @D161316, PER @D161315, PLU @D161314, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, REG -, PAST +, ARITY 2] : UNDERSTAND, 
   [COORD @D161321, AGR 
         [COUNT @D161320, PER @D161319, PLU @D161318, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PAST +, ARITY 2] : UNDERSTAND, 
   [COORD @D161325, AGR [COUNT @D161324, PER @D161323, PLU @D161322, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, REG -, PAST +, ARITY 2] : UNDERSTAND, 
   [COORD @D161329, 
      AGR [COUNT @D161328, PER @D161327, PLU @D161326, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : UNDERSTAND, 
   [COORD @D161335, PAST @D161334, AGR [CASE @D161333, COUNT @D161332, 
            PER @D161331, PLU @D161330, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, FIN -, ARITY 1] : UNDERSTAND, 
   [COORD @D161339, AGR 
         [COUNT @D161338, PER @D161337, PLU @D161336, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : UNDERSTAND.

WORD use : 
   [COORD @D161367, REFL @D161366, COUNT @D161365, PRD @D161364, 
      CASE @D161363, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : USE, 
   [COORD @D161370, 
      AGR [COUNT @D161369, PER @D161368, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_INF, 
      ARITY 3] : USE, 
   [COORD @D161372, AGR [COUNT @D161371, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : USE, 
   [COORD @D161374, AGR [COUNT @D161373, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : USE, 
   [COORD @D161378, AGR [COUNT @D161377, PER @D161376, PLU @D161375, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : USE, 
   [COORD @D161384, PAST @D161383, AGR [CASE @D161382, COUNT @D161381, 
            PER @D161380, PLU @D161379, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : USE, 
   [COORD @D161387, AGR [COUNT @D161386, PER @D161385, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : USE, 
   [COORD @D161389, AGR [COUNT @D161388, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : USE, 
   [COORD @D161391, AGR [COUNT @D161390, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : USE, 
   [COORD @D161395, AGR [COUNT @D161394, PER @D161393, PLU @D161392, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADVP, ARITY 3] : USE, 
   [COORD @D161401, PAST @D161400, AGR [CASE @D161399, COUNT @D161398, 
            PER @D161397, PLU @D161396, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_ADVP, ARITY 3] : USE, 
   [COORD @D161404, AGR [COUNT @D161403, PER @D161402, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : USE, 
   [COORD @D161406, AGR [COUNT @D161405, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : USE, 
   [COORD @D161408, AGR [COUNT @D161407, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : USE, 
   [COORD @D161412, AGR [COUNT @D161411, PER @D161410, PLU @D161409, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : USE, 
   [COORD @D161418, PAST @D161417, 
      AGR [CASE @D161416, COUNT @D161415, PER @D161414, PLU @D161413, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : USE, 
   [COORD @D161421, AGR [COUNT @D161420, PER @D161419, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : USE, 
   [COORD @D161423, AGR [COUNT @D161422, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : USE, 
   [COORD @D161425, AGR [COUNT @D161424, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : USE, 
   [COORD @D161429, AGR [COUNT @D161428, PER @D161427, PLU @D161426, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : USE, 
   [COORD @D161435, PAST @D161434, AGR [CASE @D161433, COUNT @D161432, 
            PER @D161431, PLU @D161430, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : USE, 
   [COORD @D161438, AGR [COUNT @D161437, PER @D161436, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : USE, 
   [COORD @D161440, AGR [COUNT @D161439, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : USE, 
   [COORD @D161442, AGR [COUNT @D161441, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : USE, 
   [COORD @D161446, AGR [COUNT @D161445, PER @D161444, PLU @D161443, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : USE, 
   [COORD @D161452, PAST @D161451, 
      AGR [CASE @D161450, COUNT @D161449, PER @D161448, PLU @D161447, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : USE, 
   [COORD @D161455, AGR [COUNT @D161454, PER @D161453, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : USE, 
   [COORD @D161457, AGR [COUNT @D161456, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : USE, 
   [COORD @D161459, AGR [COUNT @D161458, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : USE, 
   [COORD @D161463, AGR [COUNT @D161462, PER @D161461, PLU @D161460, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : USE, 
   [COORD @D161469, PAST @D161468, 
      AGR [CASE @D161467, COUNT @D161466, PER @D161465, PLU @D161464, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : USE.

WORD used : 
   [COADV @D161484, COORD @D161483, DEF @D161482, PRD @D161481, AGR 
         [CASE @D161480, COUNT @D161479, PER @D161478, PLU @D161477, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : USED, 
   [COADV @D161492, COORD @D161491, DEF @D161490, PRD @D161489, 
      AGR [CASE @D161488, COUNT @D161487, PER @D161486, PLU @D161485, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PPSING, PFORM TO, 
      DISTR PRD, ARITY 2] : USED, 
   [COADV @D161500, COORD @D161499, DEF @D161498, PRD @D161497, 
      AGR [CASE @D161496, COUNT @D161495, PER @D161494, PLU @D161493, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, INFL +, BAR 0, V +, N +, 
      GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT PPING, PFORM TO, 
      DISTR PRD, ARITY 2] : USED, 
   [COADV @D161508, COORD @D161507, DEF @D161506, PRD @D161505, 
      AGR [CASE @D161504, COUNT @D161503, PER @D161502, PLU @D161501, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, QUA -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, DISTR PRD, 
      ARITY 2] : USED, 
   [COORD @D161513, AGR [CASE @D161512, COUNT @D161511, PER @D161510, 
            PLU @D161509, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161518, AGR [CASE @D161517, COUNT @D161516, PER @D161515, 
            PLU @D161514, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : USE, 
   [COORD @D161524, AGR [CASE @D161523, NFORM @D161522, COUNT @D161521, 
            PER @D161520, PLU @D161519, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : USE, 
   [COORD @D161529, AGR [CASE @D161528, COUNT @D161527, PER @D161526, 
            PLU @D161525, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADVP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : USE, 
   [COORD @D161534, AGR [CASE @D161533, COUNT @D161532, PER @D161531, 
            PLU @D161530, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161539, AGR [CASE @D161538, COUNT @D161537, PER @D161536, 
            PLU @D161535, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : USE, 
   [COORD @D161544, AGR [CASE @D161543, COUNT @D161542, PER @D161541, 
            PLU @D161540, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161549, AGR [CASE @D161548, COUNT @D161547, PER @D161546, 
            PLU @D161545, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161554, AGR [CASE @D161553, COUNT @D161552, PER @D161551, 
            PLU @D161550, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : USE, 
   [COORD @D161559, AGR [CASE @D161558, COUNT @D161557, PER @D161556, 
            PLU @D161555, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : USE, 
   [COORD @D161564, AGR [CASE @D161563, COUNT @D161562, PER @D161561, 
            PLU @D161560, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161569, AGR [CASE @D161568, COUNT @D161567, PER @D161566, 
            PLU @D161565, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : USE, 
   [COORD @D161574, AGR [CASE @D161573, COUNT @D161572, PER @D161571, 
            PLU @D161570, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161579, AGR [CASE @D161578, COUNT @D161577, PER @D161576, 
            PLU @D161575, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : USE, 
   [COORD @D161584, AGR [CASE @D161583, COUNT @D161582, PER @D161581, 
            PLU @D161580, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161589, AGR [CASE @D161588, COUNT @D161587, PER @D161586, 
            PLU @D161585, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161594, AGR [CASE @D161593, COUNT @D161592, PER @D161591, 
            PLU @D161590, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : USE.

WORD uses : 
   [COORD @D161606, DEMON @D161605, REFL @D161604, PRD @D161603, 
      CASE @D161602, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   USE, 
   [COORD @D161608, AGR [COUNT @D161607, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   USE, 
   [COORD @D161610, AGR [COUNT @D161609, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   USE, 
   [COORD @D161612, AGR [COUNT @D161611, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : USE, 
   [COORD @D161614, AGR [COUNT @D161613, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : USE, 
   [COORD @D161616, 
      AGR [COUNT @D161615, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : USE, 
   [COORD @D161618, 
      AGR [COUNT @D161617, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : USE.

WORD using : 
   [COORD @D161629, PRD @D161628, AGR [CASE @D161627, COUNT @D161626, 
            PER @D161625, PLU @D161624, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161635, PRD @D161634, 
      AGR [CASE @D161633, COUNT @D161632, PER @D161631, PLU @D161630, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : USE, 
   [COORD @D161641, PRD @D161640, AGR [CASE @D161639, COUNT @D161638, 
            PER @D161637, PLU @D161636, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161647, PRD @D161646, 
      AGR [CASE @D161645, COUNT @D161644, PER @D161643, PLU @D161642, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : USE, 
   [COORD @D161653, PRD @D161652, AGR [CASE @D161651, COUNT @D161650, 
            PER @D161649, PLU @D161648, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : USE, 
   [COORD @D161659, PRD @D161658, 
      AGR [CASE @D161657, COUNT @D161656, PER @D161655, PLU @D161654, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : USE.

WORD value : 
   [COORD @D161667, REFL @D161666, PRD @D161665, CASE @D161664, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : VALUE, 
   [COORD @D161671, REFL @D161670, PRD @D161669, CASE @D161668, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : VALUE, 
   [COORD @D161676, REFL @D161675, COUNT @D161674, PRD @D161673, 
      CASE @D161672, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : VALUE, 
   [COORD @D161679, 
      AGR [COUNT @D161678, PER @D161677, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM AT, 
      ARITY 3] : VALUE, 
   [COORD @D161681, AGR [COUNT @D161680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : VALUE, 
   [COORD @D161683, AGR [COUNT @D161682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : VALUE, 
   [COORD @D161687, AGR [COUNT @D161686, PER @D161685, PLU @D161684, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AT, ARITY 3] : VALUE, 
   [COORD @D161693, PAST @D161692, 
      AGR [CASE @D161691, COUNT @D161690, PER @D161689, PLU @D161688, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AT, ARITY 3] : VALUE, 
   [COORD @D161696, AGR [COUNT @D161695, PER @D161694, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VALUE, 
   [COORD @D161698, AGR [COUNT @D161697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VALUE, 
   [COORD @D161700, AGR [COUNT @D161699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VALUE, 
   [COORD @D161704, AGR [COUNT @D161703, PER @D161702, PLU @D161701, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : VALUE, 
   [COORD @D161710, PAST @D161709, AGR [CASE @D161708, COUNT @D161707, 
            PER @D161706, PLU @D161705, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : VALUE.

WORD valued : 
   [COORD @D161721, AGR [CASE @D161720, COUNT @D161719, PER @D161718, 
            PLU @D161717, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VALUE, 
   [COORD @D161726, AGR [CASE @D161725, COUNT @D161724, PER @D161723, 
            PLU @D161722, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VALUE, 
   [COORD @D161731, AGR [CASE @D161730, COUNT @D161729, PER @D161728, 
            PLU @D161727, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VALUE, 
   [COORD @D161736, AGR [CASE @D161735, COUNT @D161734, PER @D161733, 
            PLU @D161732, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VALUE, 
   [COORD @D161741, AGR [CASE @D161740, COUNT @D161739, PER @D161738, 
            PLU @D161737, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VALUE, 
   [COORD @D161746, AGR [CASE @D161745, COUNT @D161744, PER @D161743, 
            PLU @D161742, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VALUE.

WORD values : 
   [COORD @D161757, DEMON @D161756, REFL @D161755, PRD @D161754, 
      CASE @D161753, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VALUE, 
   [COORD @D161762, DEMON @D161761, REFL @D161760, PRD @D161759, 
      CASE @D161758, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VALUE, 
   [COORD @D161764, AGR [COUNT @D161763, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VALUE, 
   [COORD @D161766, AGR [COUNT @D161765, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VALUE.

WORD valuing : 
   [COORD @D161776, PRD @D161775, AGR [CASE @D161774, COUNT @D161773, 
            PER @D161772, PLU @D161771, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VALUE, 
   [COORD @D161782, PRD @D161781, 
      AGR [CASE @D161780, COUNT @D161779, PER @D161778, PLU @D161777, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : VALUE.

WORD varied : 
   [COADV @D161794, COORD @D161793, DEF @D161792, PRD @D161791, 
      AGR [CASE @D161790, COUNT @D161789, PER @D161788, PLU @D161787, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, INFL +, 
      BAR 0, N +, GRADE +, ADV -, AFORM NONE, PART -, NEG -, SUBCAT NULL, 
      DISTR ATT, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : 
   VARIED, 
   [COORD @D161799, AGR [CASE @D161798, COUNT @D161797, PER @D161796, 
            PLU @D161795, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VARY, 
   [COORD @D161804, AGR [CASE @D161803, COUNT @D161802, PER @D161801, 
            PLU @D161800, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VARY, 
   [COORD @D161809, AGR [CASE @D161808, COUNT @D161807, PER @D161806, 
            PLU @D161805, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VARY, 
   [COORD @D161814, AGR [CASE @D161813, COUNT @D161812, PER @D161811, 
            PLU @D161810, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VARY, 
   [COORD @D161819, AGR [CASE @D161818, COUNT @D161817, PER @D161816, 
            PLU @D161815, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VARY, 
   [COORD @D161824, AGR [CASE @D161823, COUNT @D161822, PER @D161821, 
            PLU @D161820, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VARY, 
   [COORD @D161829, AGR [CASE @D161828, COUNT @D161827, PER @D161826, 
            PLU @D161825, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VARY, 
   [COORD @D161834, AGR [CASE @D161833, COUNT @D161832, PER @D161831, 
            PLU @D161830, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VARY, 
   [COORD @D161839, AGR [CASE @D161838, COUNT @D161837, PER @D161836, 
            PLU @D161835, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VARY.

WORD varies : 
   [COORD @D161845, AGR [COUNT @D161844, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VARY, 
   [COORD @D161847, 
      AGR [COUNT @D161846, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VARY, 
   [COORD @D161849, 
      AGR [COUNT @D161848, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FROM, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VARY, 
   [COORD @D161851, 
      AGR [COUNT @D161850, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VARY.

WORD vary : 
   [COORD @D161857, AGR [COUNT @D161856, PER @D161855, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VARY, 
   [COORD @D161859, AGR [COUNT @D161858, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VARY, 
   [COORD @D161861, AGR [COUNT @D161860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VARY, 
   [COORD @D161865, AGR [COUNT @D161864, PER @D161863, PLU @D161862, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : VARY, 
   [COORD @D161871, PAST @D161870, AGR [CASE @D161869, COUNT @D161868, 
            PER @D161867, PLU @D161866, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : VARY, 
   [COORD @D161874, AGR [COUNT @D161873, PER @D161872, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VARY, 
   [COORD @D161876, AGR [COUNT @D161875, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VARY, 
   [COORD @D161878, AGR [COUNT @D161877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VARY, 
   [COORD @D161882, AGR [COUNT @D161881, PER @D161880, PLU @D161879, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : VARY, 
   [COORD @D161888, PAST @D161887, 
      AGR [CASE @D161886, COUNT @D161885, PER @D161884, PLU @D161883, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VARY, 
   [COORD @D161891, AGR [COUNT @D161890, PER @D161889, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : VARY, 
   [COORD @D161893, AGR [COUNT @D161892, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : VARY, 
   [COORD @D161895, AGR [COUNT @D161894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : VARY, 
   [COORD @D161899, AGR [COUNT @D161898, PER @D161897, PLU @D161896, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FROM, ARITY 2] : VARY, 
   [COORD @D161905, PAST @D161904, 
      AGR [CASE @D161903, COUNT @D161902, PER @D161901, PLU @D161900, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FROM, ARITY 2] : VARY, 
   [COORD @D161908, AGR [COUNT @D161907, PER @D161906, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VARY, 
   [COORD @D161910, AGR [COUNT @D161909, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VARY, 
   [COORD @D161912, AGR [COUNT @D161911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VARY, 
   [COORD @D161916, AGR [COUNT @D161915, PER @D161914, PLU @D161913, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VARY, 
   [COORD @D161922, PAST @D161921, AGR [CASE @D161920, COUNT @D161919, 
            PER @D161918, PLU @D161917, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : VARY.

WORD varying : 
   [COORD @D161934, PRD @D161933, AGR [CASE @D161932, COUNT @D161931, 
            PER @D161930, PLU @D161929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VARY, 
   [COORD @D161940, PRD @D161939, 
      AGR [CASE @D161938, COUNT @D161937, PER @D161936, PLU @D161935, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VARY, 
   [COORD @D161946, PRD @D161945, AGR [CASE @D161944, COUNT @D161943, 
            PER @D161942, PLU @D161941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VARY, 
   [COORD @D161952, PRD @D161951, 
      AGR [CASE @D161950, COUNT @D161949, PER @D161948, PLU @D161947, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : VARY.

WORD view : 
   [COORD @D161958, REFL @D161957, PRD @D161956, CASE @D161955, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : VIEW, 
   [COORD @D161963, REFL @D161962, COUNT @D161961, PRD @D161960, 
      CASE @D161959, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : VIEW, 
   [COORD @D161967, REFL @D161966, PRD @D161965, CASE @D161964, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, COUNT +] : VIEW, 
   [COORD @D161972, REFL @D161971, COUNT @D161970, PRD @D161969, 
      CASE @D161968, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : VIEW, 
   [COORD @D161976, REFL @D161975, PRD @D161974, CASE @D161973, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : VIEW, 
   [COORD @D161980, REFL @D161979, PRD @D161978, CASE @D161977, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : VIEW, 
   [COORD @D161984, REFL @D161983, PRD @D161982, CASE @D161981, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : VIEW, 
   [COORD @D161988, REFL @D161987, PRD @D161986, CASE @D161985, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : VIEW, 
   [COORD @D161991, 
      AGR [COUNT @D161990, PER @D161989, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM WITH, 
      ARITY 3] : VIEW, 
   [COORD @D161993, AGR [COUNT @D161992, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : VIEW, 
   [COORD @D161995, AGR [COUNT @D161994, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : VIEW, 
   [COORD @D161999, AGR [COUNT @D161998, PER @D161997, PLU @D161996, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM WITH, ARITY 3] : VIEW, 
   [COORD @D162005, PAST @D162004, 
      AGR [CASE @D162003, COUNT @D162002, PER @D162001, PLU @D162000, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM WITH, ARITY 3] : VIEW, 
   [COORD @D162008, AGR [COUNT @D162007, PER @D162006, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : VIEW, 
   [COORD @D162010, AGR [COUNT @D162009, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : VIEW, 
   [COORD @D162012, AGR [COUNT @D162011, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : VIEW, 
   [COORD @D162016, AGR [COUNT @D162015, PER @D162014, PLU @D162013, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AS, ARITY 3] : VIEW, 
   [COORD @D162022, PAST @D162021, 
      AGR [CASE @D162020, COUNT @D162019, PER @D162018, PLU @D162017, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AS, ARITY 3] : VIEW, 
   [COORD @D162025, AGR [COUNT @D162024, PER @D162023, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VIEW, 
   [COORD @D162027, AGR [COUNT @D162026, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VIEW, 
   [COORD @D162029, AGR [COUNT @D162028, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VIEW, 
   [COORD @D162033, AGR [COUNT @D162032, PER @D162031, PLU @D162030, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : VIEW, 
   [COORD @D162039, PAST @D162038, AGR [CASE @D162037, COUNT @D162036, 
            PER @D162035, PLU @D162034, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : VIEW, 
   [COORD @D162042, AGR [COUNT @D162041, PER @D162040, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VIEW, 
   [COORD @D162044, AGR [COUNT @D162043, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VIEW, 
   [COORD @D162046, AGR [COUNT @D162045, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VIEW, 
   [COORD @D162050, AGR [COUNT @D162049, PER @D162048, PLU @D162047, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VIEW, 
   [COORD @D162056, PAST @D162055, AGR [CASE @D162054, COUNT @D162053, 
            PER @D162052, PLU @D162051, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : VIEW.

WORD viewed : 
   [COORD @D162065, AGR [CASE @D162064, COUNT @D162063, PER @D162062, 
            PLU @D162061, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162070, AGR [CASE @D162069, COUNT @D162068, PER @D162067, 
            PLU @D162066, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162075, AGR [CASE @D162074, COUNT @D162073, PER @D162072, 
            PLU @D162071, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162080, AGR [CASE @D162079, COUNT @D162078, PER @D162077, 
            PLU @D162076, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AS, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162085, AGR [CASE @D162084, COUNT @D162083, PER @D162082, 
            PLU @D162081, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162090, AGR [CASE @D162089, COUNT @D162088, PER @D162087, 
            PLU @D162086, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162095, AGR [CASE @D162094, COUNT @D162093, PER @D162092, 
            PLU @D162091, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162100, AGR [CASE @D162099, COUNT @D162098, PER @D162097, 
            PLU @D162096, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162105, AGR [CASE @D162104, COUNT @D162103, PER @D162102, 
            PLU @D162101, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VIEW, 
   [COORD @D162110, AGR [CASE @D162109, COUNT @D162108, PER @D162107, 
            PLU @D162106, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162115, AGR [CASE @D162114, COUNT @D162113, PER @D162112, 
            PLU @D162111, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VIEW.

WORD viewing : 
   [COORD @D162129, PRD @D162128, AGR [CASE @D162127, COUNT @D162126, 
            PER @D162125, PLU @D162124, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162135, PRD @D162134, 
      AGR [CASE @D162133, COUNT @D162132, PER @D162131, PLU @D162130, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VIEW, 
   [COORD @D162141, PRD @D162140, AGR [CASE @D162139, COUNT @D162138, 
            PER @D162137, PLU @D162136, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VIEW, 
   [COORD @D162147, PRD @D162146, 
      AGR [CASE @D162145, COUNT @D162144, PER @D162143, PLU @D162142, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : VIEW.

WORD views : 
   [COORD @D162156, DEMON @D162155, REFL @D162154, PRD @D162153, 
      CASE @D162152, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VIEW, 
   [COORD @D162161, DEMON @D162160, REFL @D162159, PRD @D162158, 
      CASE @D162157, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VIEW, 
   [COORD @D162166, DEMON @D162165, REFL @D162164, PRD @D162163, 
      CASE @D162162, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VIEW, 
   [COORD @D162171, DEMON @D162170, REFL @D162169, PRD @D162168, 
      CASE @D162167, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VIEW, 
   [COORD @D162176, DEMON @D162175, REFL @D162174, PRD @D162173, 
      CASE @D162172, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VIEW, 
   [COORD @D162181, DEMON @D162180, REFL @D162179, PRD @D162178, 
      CASE @D162177, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VIEW, 
   [COORD @D162183, AGR [COUNT @D162182, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VIEW, 
   [COORD @D162185, AGR [COUNT @D162184, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VIEW, 
   [COORD @D162187, AGR [COUNT @D162186, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VIEW, 
   [COORD @D162189, 
      AGR [COUNT @D162188, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VIEW.

WORD visit : 
   [COORD @D162195, REFL @D162194, PRD @D162193, CASE @D162192, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : VISIT, 
   [COORD @D162200, REFL @D162199, COUNT @D162198, PRD @D162197, 
      CASE @D162196, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : VISIT, 
   [COORD @D162204, REFL @D162203, PRD @D162202, CASE @D162201, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM TO, COUNT +] : VISIT, 
   [COORD @D162208, REFL @D162207, PRD @D162206, CASE @D162205, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FROM, COUNT +] : VISIT, 
   [COORD @D162211, 
      AGR [COUNT @D162210, PER @D162209, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM UPON, ARITY 3] : VISIT, 
   [COORD @D162213, AGR [COUNT @D162212, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : VISIT, 
   [COORD @D162215, AGR [COUNT @D162214, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : VISIT, 
   [COORD @D162219, AGR [COUNT @D162218, PER @D162217, PLU @D162216, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM UPON, ARITY 3] : VISIT, 
   [COORD @D162225, PAST @D162224, 
      AGR [CASE @D162223, COUNT @D162222, PER @D162221, PLU @D162220, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM UPON, ARITY 3] : VISIT, 
   [COORD @D162228, AGR [COUNT @D162227, PER @D162226, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : VISIT, 
   [COORD @D162230, AGR [COUNT @D162229, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : VISIT, 
   [COORD @D162232, AGR [COUNT @D162231, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : VISIT, 
   [COORD @D162236, AGR [COUNT @D162235, PER @D162234, PLU @D162233, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : VISIT, 
   [COORD @D162242, PAST @D162241, 
      AGR [CASE @D162240, COUNT @D162239, PER @D162238, PLU @D162237, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : VISIT, 
   [COORD @D162245, AGR [COUNT @D162244, PER @D162243, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VISIT, 
   [COORD @D162247, AGR [COUNT @D162246, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VISIT, 
   [COORD @D162249, AGR [COUNT @D162248, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VISIT, 
   [COORD @D162253, AGR [COUNT @D162252, PER @D162251, PLU @D162250, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : VISIT, 
   [COORD @D162259, PAST @D162258, AGR [CASE @D162257, COUNT @D162256, 
            PER @D162255, PLU @D162254, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : VISIT, 
   [COORD @D162262, AGR [COUNT @D162261, PER @D162260, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : VISIT, 
   [COORD @D162264, AGR [COUNT @D162263, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : VISIT, 
   [COORD @D162266, AGR [COUNT @D162265, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : VISIT, 
   [COORD @D162270, AGR [COUNT @D162269, PER @D162268, PLU @D162267, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, ARITY 2] : VISIT, 
   [COORD @D162276, PAST @D162275, 
      AGR [CASE @D162274, COUNT @D162273, PER @D162272, PLU @D162271, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM WITH, ARITY 2] : VISIT, 
   [COORD @D162279, AGR [COUNT @D162278, PER @D162277, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VISIT, 
   [COORD @D162281, AGR [COUNT @D162280, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VISIT, 
   [COORD @D162283, AGR [COUNT @D162282, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VISIT, 
   [COORD @D162287, AGR [COUNT @D162286, PER @D162285, PLU @D162284, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM IN, ARITY 2] : VISIT, 
   [COORD @D162293, PAST @D162292, 
      AGR [CASE @D162291, COUNT @D162290, PER @D162289, PLU @D162288, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM IN, ARITY 2] : VISIT, 
   [COORD @D162296, AGR [COUNT @D162295, PER @D162294, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : VISIT, 
   [COORD @D162298, AGR [COUNT @D162297, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : VISIT, 
   [COORD @D162300, AGR [COUNT @D162299, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : VISIT, 
   [COORD @D162304, AGR [COUNT @D162303, PER @D162302, PLU @D162301, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : VISIT, 
   [COORD @D162310, PAST @D162309, 
      AGR [CASE @D162308, COUNT @D162307, PER @D162306, PLU @D162305, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : VISIT, 
   [COORD @D162313, AGR [COUNT @D162312, PER @D162311, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VISIT, 
   [COORD @D162315, AGR [COUNT @D162314, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VISIT, 
   [COORD @D162317, AGR [COUNT @D162316, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VISIT, 
   [COORD @D162321, AGR [COUNT @D162320, PER @D162319, PLU @D162318, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VISIT, 
   [COORD @D162327, PAST @D162326, AGR [CASE @D162325, COUNT @D162324, 
            PER @D162323, PLU @D162322, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : VISIT.

WORD visits : 
   [COORD @D162336, DEMON @D162335, REFL @D162334, PRD @D162333, 
      CASE @D162332, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VISIT, 
   [COORD @D162341, DEMON @D162340, REFL @D162339, PRD @D162338, 
      CASE @D162337, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VISIT, 
   [COORD @D162346, DEMON @D162345, REFL @D162344, PRD @D162343, 
      CASE @D162342, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM TO, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VISIT, 
   [COORD @D162351, DEMON @D162350, REFL @D162349, PRD @D162348, 
      CASE @D162347, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FROM, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VISIT, 
   [COORD @D162353, AGR [COUNT @D162352, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VISIT, 
   [COORD @D162355, AGR [COUNT @D162354, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VISIT, 
   [COORD @D162357, AGR [COUNT @D162356, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VISIT, 
   [COORD @D162359, 
      AGR [COUNT @D162358, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VISIT, 
   [COORD @D162361, 
      AGR [COUNT @D162360, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VISIT, 
   [COORD @D162363, 
      AGR [COUNT @D162362, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VISIT, 
   [COORD @D162365, 
      AGR [COUNT @D162364, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VISIT.

WORD visitted : 
   [COORD @D162374, AGR [CASE @D162373, COUNT @D162372, PER @D162371, 
            PLU @D162370, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162379, AGR [CASE @D162378, COUNT @D162377, PER @D162376, 
            PLU @D162375, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162384, AGR [CASE @D162383, COUNT @D162382, PER @D162381, 
            PLU @D162380, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM UPON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162389, AGR [CASE @D162388, COUNT @D162387, PER @D162386, 
            PLU @D162385, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162394, AGR [CASE @D162393, COUNT @D162392, PER @D162391, 
            PLU @D162390, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162399, AGR [CASE @D162398, COUNT @D162397, PER @D162396, 
            PLU @D162395, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162404, AGR [CASE @D162403, COUNT @D162402, PER @D162401, 
            PLU @D162400, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162409, AGR [CASE @D162408, COUNT @D162407, PER @D162406, 
            PLU @D162405, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162414, AGR [CASE @D162413, COUNT @D162412, PER @D162411, 
            PLU @D162410, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VISIT, 
   [COORD @D162419, AGR [CASE @D162418, COUNT @D162417, PER @D162416, 
            PLU @D162415, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162424, AGR [CASE @D162423, COUNT @D162422, PER @D162421, 
            PLU @D162420, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162429, AGR [CASE @D162428, COUNT @D162427, PER @D162426, 
            PLU @D162425, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM WITH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162434, AGR [CASE @D162433, COUNT @D162432, PER @D162431, 
            PLU @D162430, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162439, AGR [CASE @D162438, COUNT @D162437, PER @D162436, 
            PLU @D162435, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162444, AGR [CASE @D162443, COUNT @D162442, PER @D162441, 
            PLU @D162440, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162449, AGR [CASE @D162448, COUNT @D162447, PER @D162446, 
            PLU @D162445, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162454, AGR [CASE @D162453, COUNT @D162452, PER @D162451, 
            PLU @D162450, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162459, AGR [CASE @D162458, COUNT @D162457, PER @D162456, 
            PLU @D162455, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VISIT.

WORD visitting : 
   [COORD @D162473, PRD @D162472, AGR [CASE @D162471, COUNT @D162470, 
            PER @D162469, PLU @D162468, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM UPON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162479, PRD @D162478, 
      AGR [CASE @D162477, COUNT @D162476, PER @D162475, PLU @D162474, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : VISIT, 
   [COORD @D162485, PRD @D162484, AGR [CASE @D162483, COUNT @D162482, 
            PER @D162481, PLU @D162480, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162491, PRD @D162490, 
      AGR [CASE @D162489, COUNT @D162488, PER @D162487, PLU @D162486, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM WITH, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : VISIT, 
   [COORD @D162497, PRD @D162496, AGR [CASE @D162495, COUNT @D162494, 
            PER @D162493, PLU @D162492, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VISIT, 
   [COORD @D162503, PRD @D162502, 
      AGR [CASE @D162501, COUNT @D162500, PER @D162499, PLU @D162498, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VISIT, 
   [COORD @D162509, PRD @D162508, AGR [CASE @D162507, COUNT @D162506, 
            PER @D162505, PLU @D162504, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VISIT.

WORD volunteer : 
   [COORD @D162516, REFL @D162515, COUNT @D162514, PRD @D162513, 
      CASE @D162512, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : VOLUNTEER, 
   [COORD @D162520, REFL @D162519, PRD @D162518, CASE @D162517, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : VOLUNTEER, 
   [COORD @D162523, 
      AGR [COUNT @D162522, PER @D162521, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : VOLUNTEER, 
   [COORD @D162525, AGR [COUNT @D162524, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : VOLUNTEER, 
   [COORD @D162527, AGR [COUNT @D162526, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : VOLUNTEER, 
   [COORD @D162531, AGR [COUNT @D162530, PER @D162529, PLU @D162528, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : VOLUNTEER, 
   [COORD @D162537, PAST @D162536, 
      AGR [CASE @D162535, COUNT @D162534, PER @D162533, PLU @D162532, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      ARITY 2] : VOLUNTEER, 
   [COORD @D162540, AGR [COUNT @D162539, PER @D162538, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VOLUNTEER, 
   [COORD @D162542, AGR [COUNT @D162541, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VOLUNTEER, 
   [COORD @D162544, AGR [COUNT @D162543, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VOLUNTEER, 
   [COORD @D162548, AGR [COUNT @D162547, PER @D162546, PLU @D162545, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : VOLUNTEER, 
   [COORD @D162554, PAST @D162553, AGR [CASE @D162552, COUNT @D162551, 
            PER @D162550, PLU @D162549, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : VOLUNTEER, 
   [COORD @D162557, AGR [COUNT @D162556, PER @D162555, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOLUNTEER, 
   [COORD @D162559, AGR [COUNT @D162558, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOLUNTEER, 
   [COORD @D162561, AGR [COUNT @D162560, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOLUNTEER, 
   [COORD @D162565, AGR [COUNT @D162564, PER @D162563, PLU @D162562, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : VOLUNTEER, 
   [COORD @D162571, PAST @D162570, 
      AGR [CASE @D162569, COUNT @D162568, PER @D162567, PLU @D162566, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOLUNTEER, 
   [COORD @D162574, AGR [COUNT @D162573, PER @D162572, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOLUNTEER, 
   [COORD @D162576, AGR [COUNT @D162575, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOLUNTEER, 
   [COORD @D162578, AGR [COUNT @D162577, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOLUNTEER, 
   [COORD @D162582, AGR [COUNT @D162581, PER @D162580, PLU @D162579, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOLUNTEER, 
   [COORD @D162588, PAST @D162587, 
      AGR [CASE @D162586, COUNT @D162585, PER @D162584, PLU @D162583, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      ARITY 1] : VOLUNTEER.

WORD volunteered : 
   [COORD @D162597, AGR [CASE @D162596, COUNT @D162595, PER @D162594, 
            PLU @D162593, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162602, AGR [CASE @D162601, COUNT @D162600, PER @D162599, 
            PLU @D162598, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162607, AGR [CASE @D162606, COUNT @D162605, PER @D162604, 
            PLU @D162603, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162612, AGR [CASE @D162611, COUNT @D162610, PER @D162609, 
            PLU @D162608, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162617, AGR [CASE @D162616, COUNT @D162615, PER @D162614, 
            PLU @D162613, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162622, AGR [CASE @D162621, COUNT @D162620, PER @D162619, 
            PLU @D162618, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162627, AGR [CASE @D162626, COUNT @D162625, PER @D162624, 
            PLU @D162623, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162632, AGR [CASE @D162631, COUNT @D162630, PER @D162629, 
            PLU @D162628, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162637, AGR [CASE @D162636, COUNT @D162635, PER @D162634, 
            PLU @D162633, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOLUNTEER.

WORD volunteering : 
   [COORD @D162651, PRD @D162650, AGR [CASE @D162649, COUNT @D162648, 
            PER @D162647, PLU @D162646, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162657, PRD @D162656, 
      AGR [CASE @D162655, COUNT @D162654, PER @D162653, PLU @D162652, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : VOLUNTEER, 
   [COORD @D162663, PRD @D162662, AGR [CASE @D162661, COUNT @D162660, 
            PER @D162659, PLU @D162658, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOLUNTEER, 
   [COORD @D162669, PRD @D162668, 
      AGR [CASE @D162667, COUNT @D162666, PER @D162665, PLU @D162664, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : VOLUNTEER.

WORD volunteers : 
   [COORD @D162678, DEMON @D162677, REFL @D162676, PRD @D162675, 
      CASE @D162674, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOLUNTEER, 
   [COORD @D162683, DEMON @D162682, REFL @D162681, PRD @D162680, 
      CASE @D162679, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOLUNTEER, 
   [COORD @D162685, AGR [COUNT @D162684, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   VOLUNTEER, 
   [COORD @D162687, AGR [COUNT @D162686, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   VOLUNTEER, 
   [COORD @D162689, AGR [COUNT @D162688, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOLUNTEER, 
   [COORD @D162691, AGR [COUNT @D162690, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOLUNTEER.

WORD vote : 
   [COORD @D162699, REFL @D162698, PRD @D162697, CASE @D162696, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM AGAINST, COUNT +] : VOTE, 
   [COORD @D162703, REFL @D162702, PRD @D162701, CASE @D162700, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : VOTE, 
   [COORD @D162708, REFL @D162707, COUNT @D162706, PRD @D162705, 
      CASE @D162704, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : VOTE, 
   [COORD @D162712, REFL @D162711, PRD @D162710, CASE @D162709, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ABOUT, COUNT +] : VOTE, 
   [COORD @D162716, REFL @D162715, PRD @D162714, CASE @D162713, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM FOR, COUNT +] : VOTE, 
   [COORD @D162720, REFL @D162719, PRD @D162718, CASE @D162717, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN +, ADDRESS -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : VOTE, 
   [COORD @D162725, REFL @D162724, COUNT @D162723, PRD @D162722, 
      CASE @D162721, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : VOTE, 
   [COORD @D162729, REFL @D162728, PRD @D162727, CASE @D162726, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM ON, COUNT +] : VOTE, 
   [COORD @D162732, 
      AGR [COUNT @D162731, PER @D162730, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   VOTE, 
   [COORD @D162734, AGR [COUNT @D162733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : VOTE, 
   [COORD @D162736, AGR [COUNT @D162735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : VOTE, 
   [COORD @D162740, AGR [COUNT @D162739, PER @D162738, PLU @D162737, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : VOTE, 
   [COORD @D162746, PAST @D162745, AGR [CASE @D162744, COUNT @D162743, 
            PER @D162742, PLU @D162741, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : VOTE, 
   [COORD @D162749, AGR [COUNT @D162748, PER @D162747, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : VOTE, 
   [COORD @D162751, AGR [COUNT @D162750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : VOTE, 
   [COORD @D162753, AGR [COUNT @D162752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : VOTE, 
   [COORD @D162757, AGR [COUNT @D162756, PER @D162755, PLU @D162754, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM ONTO, ARITY 3] : VOTE, 
   [COORD @D162763, PAST @D162762, 
      AGR [CASE @D162761, COUNT @D162760, PER @D162759, PLU @D162758, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM ONTO, ARITY 3] : VOTE, 
   [COORD @D162766, AGR [COUNT @D162765, PER @D162764, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : VOTE, 
   [COORD @D162768, AGR [COUNT @D162767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : VOTE, 
   [COORD @D162770, AGR [COUNT @D162769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : VOTE, 
   [COORD @D162774, AGR [COUNT @D162773, PER @D162772, PLU @D162771, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : VOTE, 
   [COORD @D162780, PAST @D162779, 
      AGR [CASE @D162778, COUNT @D162777, PER @D162776, PLU @D162775, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OFF, ARITY 3] : VOTE, 
   [COORD @D162783, AGR [COUNT @D162782, PER @D162781, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : VOTE, 
   [COORD @D162785, AGR [COUNT @D162784, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : VOTE, 
   [COORD @D162787, AGR [COUNT @D162786, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : VOTE, 
   [COORD @D162791, AGR [COUNT @D162790, PER @D162789, PLU @D162788, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : VOTE, 
   [COORD @D162797, PAST @D162796, 
      AGR [CASE @D162795, COUNT @D162794, PER @D162793, PLU @D162792, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : VOTE, 
   [COORD @D162800, AGR [COUNT @D162799, PER @D162798, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : VOTE, 
   [COORD @D162802, AGR [COUNT @D162801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : VOTE, 
   [COORD @D162804, AGR [COUNT @D162803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : VOTE, 
   [COORD @D162808, AGR [COUNT @D162807, PER @D162806, PLU @D162805, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : VOTE, 
   [COORD @D162814, PAST @D162813, AGR [CASE @D162812, COUNT @D162811, 
            PER @D162810, PLU @D162809, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : VOTE, 
   [COORD @D162817, AGR [COUNT @D162816, PER @D162815, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : VOTE, 
   [COORD @D162819, AGR [COUNT @D162818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : VOTE, 
   [COORD @D162821, AGR [COUNT @D162820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : VOTE, 
   [COORD @D162825, AGR [COUNT @D162824, PER @D162823, PLU @D162822, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : VOTE, 
   [COORD @D162831, PAST @D162830, AGR [CASE @D162829, COUNT @D162828, 
            PER @D162827, PLU @D162826, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : VOTE, 
   [COORD @D162834, AGR [COUNT @D162833, PER @D162832, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VOTE, 
   [COORD @D162836, AGR [COUNT @D162835, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VOTE, 
   [COORD @D162838, AGR [COUNT @D162837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : VOTE, 
   [COORD @D162842, AGR [COUNT @D162841, PER @D162840, PLU @D162839, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : VOTE, 
   [COORD @D162848, PAST @D162847, AGR [CASE @D162846, COUNT @D162845, 
            PER @D162844, PLU @D162843, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : VOTE, 
   [COORD @D162851, AGR [COUNT @D162850, PER @D162849, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : VOTE, 
   [COORD @D162853, AGR [COUNT @D162852, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : VOTE, 
   [COORD @D162855, AGR [COUNT @D162854, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : VOTE, 
   [COORD @D162859, AGR [COUNT @D162858, PER @D162857, PLU @D162856, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : VOTE, 
   [COORD @D162865, PAST @D162864, 
      AGR [CASE @D162863, COUNT @D162862, PER @D162861, PLU @D162860, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : VOTE, 
   [COORD @D162868, AGR [COUNT @D162867, PER @D162866, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOTE, 
   [COORD @D162870, AGR [COUNT @D162869, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOTE, 
   [COORD @D162872, AGR [COUNT @D162871, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOTE, 
   [COORD @D162876, AGR [COUNT @D162875, PER @D162874, PLU @D162873, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : VOTE, 
   [COORD @D162882, PAST @D162881, 
      AGR [CASE @D162880, COUNT @D162879, PER @D162878, PLU @D162877, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : VOTE, 
   [COORD @D162885, AGR [COUNT @D162884, PER @D162883, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : VOTE, 
   [COORD @D162887, AGR [COUNT @D162886, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : VOTE, 
   [COORD @D162889, AGR [COUNT @D162888, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : VOTE, 
   [COORD @D162893, AGR [COUNT @D162892, PER @D162891, PLU @D162890, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : VOTE, 
   [COORD @D162899, PAST @D162898, 
      AGR [CASE @D162897, COUNT @D162896, PER @D162895, PLU @D162894, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : VOTE, 
   [COORD @D162902, AGR [COUNT @D162901, PER @D162900, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : VOTE, 
   [COORD @D162904, AGR [COUNT @D162903, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : VOTE, 
   [COORD @D162906, AGR [COUNT @D162905, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : VOTE, 
   [COORD @D162910, AGR [COUNT @D162909, PER @D162908, PLU @D162907, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT THROUGH, ARITY 2] : VOTE, 
   [COORD @D162916, PAST @D162915, 
      AGR [CASE @D162914, COUNT @D162913, PER @D162912, PLU @D162911, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT THROUGH, ARITY 2] : VOTE, 
   [COORD @D162919, AGR [COUNT @D162918, PER @D162917, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : VOTE, 
   [COORD @D162921, AGR [COUNT @D162920, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : VOTE, 
   [COORD @D162923, AGR [COUNT @D162922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : VOTE, 
   [COORD @D162927, AGR [COUNT @D162926, PER @D162925, PLU @D162924, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : VOTE, 
   [COORD @D162933, PAST @D162932, 
      AGR [CASE @D162931, COUNT @D162930, PER @D162929, PLU @D162928, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : VOTE, 
   [COORD @D162936, AGR [COUNT @D162935, PER @D162934, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : VOTE, 
   [COORD @D162938, AGR [COUNT @D162937, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : VOTE, 
   [COORD @D162940, AGR [COUNT @D162939, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT ON, ARITY 2] : VOTE, 
   [COORD @D162944, AGR [COUNT @D162943, PER @D162942, PLU @D162941, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT ON, ARITY 2] : VOTE, 
   [COORD @D162950, PAST @D162949, 
      AGR [CASE @D162948, COUNT @D162947, PER @D162946, PLU @D162945, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT ON, 
      ARITY 2] : VOTE, 
   [COORD @D162953, AGR [COUNT @D162952, PER @D162951, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : VOTE, 
   [COORD @D162955, AGR [COUNT @D162954, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : VOTE, 
   [COORD @D162957, AGR [COUNT @D162956, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : VOTE, 
   [COORD @D162961, AGR [COUNT @D162960, PER @D162959, PLU @D162958, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : VOTE, 
   [COORD @D162967, PAST @D162966, 
      AGR [CASE @D162965, COUNT @D162964, PER @D162963, PLU @D162962, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : VOTE, 
   [COORD @D162970, AGR [COUNT @D162969, PER @D162968, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : VOTE, 
   [COORD @D162972, AGR [COUNT @D162971, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : VOTE, 
   [COORD @D162974, AGR [COUNT @D162973, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : VOTE, 
   [COORD @D162978, AGR [COUNT @D162977, PER @D162976, PLU @D162975, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : VOTE, 
   [COORD @D162984, PAST @D162983, 
      AGR [CASE @D162982, COUNT @D162981, PER @D162980, PLU @D162979, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : VOTE, 
   [COORD @D162987, AGR [COUNT @D162986, PER @D162985, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : VOTE, 
   [COORD @D162989, AGR [COUNT @D162988, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : VOTE, 
   [COORD @D162991, AGR [COUNT @D162990, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : VOTE, 
   [COORD @D162995, AGR [COUNT @D162994, PER @D162993, PLU @D162992, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : VOTE, 
   [COORD @D163001, PAST @D163000, 
      AGR [CASE @D162999, COUNT @D162998, PER @D162997, PLU @D162996, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : VOTE, 
   [COORD @D163004, AGR [COUNT @D163003, PER @D163002, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOTE, 
   [COORD @D163006, AGR [COUNT @D163005, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOTE, 
   [COORD @D163008, AGR [COUNT @D163007, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOTE, 
   [COORD @D163012, AGR [COUNT @D163011, PER @D163010, PLU @D163009, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : VOTE, 
   [COORD @D163018, PAST @D163017, AGR [CASE @D163016, COUNT @D163015, 
            PER @D163014, PLU @D163013, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : VOTE, 
   [COORD @D163021, AGR [COUNT @D163020, PER @D163019, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : VOTE, 
   [COORD @D163023, AGR [COUNT @D163022, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : VOTE, 
   [COORD @D163025, AGR [COUNT @D163024, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : VOTE, 
   [COORD @D163029, AGR [COUNT @D163028, PER @D163027, PLU @D163026, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT THROUGH, ARITY 1] : VOTE, 
   [COORD @D163035, PAST @D163034, 
      AGR [CASE @D163033, COUNT @D163032, PER @D163031, PLU @D163030, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT THROUGH, ARITY 1] : VOTE, 
   [COORD @D163038, AGR [COUNT @D163037, PER @D163036, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : VOTE, 
   [COORD @D163040, AGR [COUNT @D163039, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : VOTE, 
   [COORD @D163042, AGR [COUNT @D163041, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : VOTE, 
   [COORD @D163046, AGR [COUNT @D163045, PER @D163044, PLU @D163043, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : VOTE, 
   [COORD @D163052, PAST @D163051, 
      AGR [CASE @D163050, COUNT @D163049, PER @D163048, PLU @D163047, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : VOTE, 
   [COORD @D163055, AGR [COUNT @D163054, PER @D163053, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : VOTE, 
   [COORD @D163057, AGR [COUNT @D163056, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : VOTE, 
   [COORD @D163059, AGR [COUNT @D163058, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : VOTE, 
   [COORD @D163063, AGR [COUNT @D163062, PER @D163061, PLU @D163060, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ON, ARITY 1] : VOTE, 
   [COORD @D163069, PAST @D163068, 
      AGR [CASE @D163067, COUNT @D163066, PER @D163065, PLU @D163064, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ON, ARITY 1] : VOTE, 
   [COORD @D163072, AGR [COUNT @D163071, PER @D163070, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : VOTE, 
   [COORD @D163074, AGR [COUNT @D163073, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : VOTE, 
   [COORD @D163076, AGR [COUNT @D163075, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : VOTE, 
   [COORD @D163080, AGR [COUNT @D163079, PER @D163078, PLU @D163077, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : VOTE, 
   [COORD @D163086, PAST @D163085, 
      AGR [CASE @D163084, COUNT @D163083, PER @D163082, PLU @D163081, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : VOTE, 
   [COORD @D163089, AGR [COUNT @D163088, PER @D163087, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : VOTE, 
   [COORD @D163091, AGR [COUNT @D163090, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : VOTE, 
   [COORD @D163093, AGR [COUNT @D163092, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : VOTE, 
   [COORD @D163097, AGR [COUNT @D163096, PER @D163095, PLU @D163094, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : VOTE, 
   [COORD @D163103, PAST @D163102, 
      AGR [CASE @D163101, COUNT @D163100, PER @D163099, PLU @D163098, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : VOTE, 
   [COORD @D163106, AGR [COUNT @D163105, PER @D163104, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : VOTE, 
   [COORD @D163108, AGR [COUNT @D163107, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : VOTE, 
   [COORD @D163110, AGR [COUNT @D163109, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : VOTE, 
   [COORD @D163114, AGR [COUNT @D163113, PER @D163112, PLU @D163111, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : VOTE, 
   [COORD @D163120, PAST @D163119, 
      AGR [CASE @D163118, COUNT @D163117, PER @D163116, PLU @D163115, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : VOTE.

WORD voted : 
   [COORD @D163131, AGR [CASE @D163130, COUNT @D163129, PER @D163128, 
            PLU @D163127, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163136, AGR [CASE @D163135, COUNT @D163134, PER @D163133, 
            PLU @D163132, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163141, AGR [CASE @D163140, COUNT @D163139, PER @D163138, 
            PLU @D163137, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163146, AGR [CASE @D163145, COUNT @D163144, PER @D163143, 
            PLU @D163142, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163151, AGR [CASE @D163150, COUNT @D163149, PER @D163148, 
            PLU @D163147, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163156, AGR [CASE @D163155, COUNT @D163154, PER @D163153, 
            PLU @D163152, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ONTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163161, AGR [CASE @D163160, COUNT @D163159, PER @D163158, 
            PLU @D163157, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163166, AGR [CASE @D163165, COUNT @D163164, PER @D163163, 
            PLU @D163162, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163171, AGR [CASE @D163170, COUNT @D163169, PER @D163168, 
            PLU @D163167, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163176, AGR [CASE @D163175, COUNT @D163174, PER @D163173, 
            PLU @D163172, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163181, AGR [CASE @D163180, COUNT @D163179, PER @D163178, 
            PLU @D163177, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163186, AGR [CASE @D163185, COUNT @D163184, PER @D163183, 
            PLU @D163182, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163191, AGR [CASE @D163190, COUNT @D163189, PER @D163188, 
            PLU @D163187, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163196, AGR [CASE @D163195, COUNT @D163194, PER @D163193, 
            PLU @D163192, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163201, AGR [UB @D163200, VFORM @D163199, SUBJ @D163198, 
            FIN @D163197, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163206, AGR [CASE @D163205, COUNT @D163204, PER @D163203, 
            PLU @D163202, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163211, AGR [CASE @D163210, COUNT @D163209, PER @D163208, 
            PLU @D163207, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163216, AGR [CASE @D163215, COUNT @D163214, PER @D163213, 
            PLU @D163212, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163221, AGR [CASE @D163220, COUNT @D163219, PER @D163218, 
            PLU @D163217, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163226, AGR [CASE @D163225, COUNT @D163224, PER @D163223, 
            PLU @D163222, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163231, AGR [CASE @D163230, COUNT @D163229, PER @D163228, 
            PLU @D163227, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163236, AGR [CASE @D163235, COUNT @D163234, PER @D163233, 
            PLU @D163232, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163241, AGR [CASE @D163240, COUNT @D163239, PER @D163238, 
            PLU @D163237, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163246, AGR [CASE @D163245, COUNT @D163244, PER @D163243, 
            PLU @D163242, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163251, AGR [CASE @D163250, COUNT @D163249, PER @D163248, 
            PLU @D163247, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163256, AGR [CASE @D163255, COUNT @D163254, PER @D163253, 
            PLU @D163252, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163261, AGR [CASE @D163260, COUNT @D163259, PER @D163258, 
            PLU @D163257, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163266, AGR [CASE @D163265, COUNT @D163264, PER @D163263, 
            PLU @D163262, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163271, AGR [CASE @D163270, COUNT @D163269, PER @D163268, 
            PLU @D163267, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163276, AGR [CASE @D163275, COUNT @D163274, PER @D163273, 
            PLU @D163272, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163281, AGR [CASE @D163280, COUNT @D163279, PER @D163278, 
            PLU @D163277, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163286, AGR [CASE @D163285, COUNT @D163284, PER @D163283, 
            PLU @D163282, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163291, AGR [CASE @D163290, COUNT @D163289, PER @D163288, 
            PLU @D163287, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163296, AGR [CASE @D163295, COUNT @D163294, PER @D163293, 
            PLU @D163292, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163301, AGR [CASE @D163300, COUNT @D163299, PER @D163298, 
            PLU @D163297, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163306, AGR [CASE @D163305, COUNT @D163304, PER @D163303, 
            PLU @D163302, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163311, AGR [CASE @D163310, COUNT @D163309, PER @D163308, 
            PLU @D163307, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163316, AGR [CASE @D163315, COUNT @D163314, PER @D163313, 
            PLU @D163312, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163321, AGR [CASE @D163320, COUNT @D163319, PER @D163318, 
            PLU @D163317, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163326, AGR [CASE @D163325, COUNT @D163324, PER @D163323, 
            PLU @D163322, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163331, AGR [CASE @D163330, COUNT @D163329, PER @D163328, 
            PLU @D163327, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163336, AGR [CASE @D163335, COUNT @D163334, PER @D163333, 
            PLU @D163332, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163341, AGR [CASE @D163340, COUNT @D163339, PER @D163338, 
            PLU @D163337, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163346, AGR [CASE @D163345, COUNT @D163344, PER @D163343, 
            PLU @D163342, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163351, AGR [CASE @D163350, COUNT @D163349, PER @D163348, 
            PLU @D163347, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163356, AGR [CASE @D163355, COUNT @D163354, PER @D163353, 
            PLU @D163352, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163361, AGR [CASE @D163360, COUNT @D163359, PER @D163358, 
            PLU @D163357, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163366, AGR [CASE @D163365, COUNT @D163364, PER @D163363, 
            PLU @D163362, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163371, AGR [CASE @D163370, COUNT @D163369, PER @D163368, 
            PLU @D163367, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163376, AGR [CASE @D163375, COUNT @D163374, PER @D163373, 
            PLU @D163372, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163381, AGR [CASE @D163380, COUNT @D163379, PER @D163378, 
            PLU @D163377, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163386, AGR [CASE @D163385, COUNT @D163384, PER @D163383, 
            PLU @D163382, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163391, AGR [CASE @D163390, COUNT @D163389, PER @D163388, 
            PLU @D163387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163396, AGR [CASE @D163395, COUNT @D163394, PER @D163393, 
            PLU @D163392, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163401, AGR [CASE @D163400, COUNT @D163399, PER @D163398, 
            PLU @D163397, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163406, AGR [CASE @D163405, COUNT @D163404, PER @D163403, 
            PLU @D163402, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163411, AGR [CASE @D163410, COUNT @D163409, PER @D163408, 
            PLU @D163407, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163416, AGR [CASE @D163415, COUNT @D163414, PER @D163413, 
            PLU @D163412, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : VOTE.

WORD votes : 
   [COORD @D163427, DEMON @D163426, REFL @D163425, PRD @D163424, 
      CASE @D163423, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : VOTE, 
   [COORD @D163432, DEMON @D163431, REFL @D163430, PRD @D163429, 
      CASE @D163428, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOTE, 
   [COORD @D163437, DEMON @D163436, REFL @D163435, PRD @D163434, 
      CASE @D163433, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOTE, 
   [COORD @D163442, DEMON @D163441, REFL @D163440, PRD @D163439, 
      CASE @D163438, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOTE, 
   [COORD @D163447, DEMON @D163446, REFL @D163445, PRD @D163444, 
      CASE @D163443, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM FOR, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOTE, 
   [COORD @D163452, DEMON @D163451, REFL @D163450, PRD @D163449, 
      CASE @D163448, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN +, ADDRESS -, 
      ADV -, PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, 
      PER 3, INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, 
      V -] : VOTE, 
   [COORD @D163457, DEMON @D163456, REFL @D163455, PRD @D163454, 
      CASE @D163453, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOTE, 
   [COORD @D163462, DEMON @D163461, REFL @D163460, PRD @D163459, 
      CASE @D163458, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM ON, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   VOTE, 
   [COORD @D163464, AGR [COUNT @D163463, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOTE, 
   [COORD @D163466, 
      AGR [COUNT @D163465, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PFORM ONTO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   VOTE, 
   [COORD @D163468, AGR [COUNT @D163467, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163470, AGR [COUNT @D163469, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163472, AGR [COUNT @D163471, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOTE, 
   [COORD @D163474, 
      AGR [COUNT @D163473, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOTE, 
   [COORD @D163476, 
      AGR [COUNT @D163475, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOTE, 
   [COORD @D163478, 
      AGR [COUNT @D163477, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOTE, 
   [COORD @D163480, 
      AGR [COUNT @D163479, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOTE, 
   [COORD @D163482, 
      AGR [COUNT @D163481, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   VOTE, 
   [COORD @D163484, AGR [COUNT @D163483, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163486, AGR [COUNT @D163485, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163488, AGR [COUNT @D163487, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163490, AGR [COUNT @D163489, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163492, AGR [COUNT @D163491, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163494, AGR [COUNT @D163493, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163496, AGR [COUNT @D163495, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : VOTE, 
   [COORD @D163498, 
      AGR [COUNT @D163497, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   VOTE, 
   [COORD @D163500, AGR [COUNT @D163499, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163502, AGR [COUNT @D163501, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   VOTE, 
   [COORD @D163504, AGR [COUNT @D163503, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163506, AGR [COUNT @D163505, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   VOTE, 
   [COORD @D163508, AGR [COUNT @D163507, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : VOTE.

WORD voting : 
   [COORD @D163518, PRD @D163517, AGR [CASE @D163516, COUNT @D163515, 
            PER @D163514, PLU @D163513, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163524, PRD @D163523, 
      AGR [CASE @D163522, COUNT @D163521, PER @D163520, PLU @D163519, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM ONTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163530, PRD @D163529, AGR [CASE @D163528, COUNT @D163527, 
            PER @D163526, PLU @D163525, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM OFF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163536, PRD @D163535, 
      AGR [CASE @D163534, COUNT @D163533, PER @D163532, PLU @D163531, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163542, PRD @D163541, AGR [CASE @D163540, COUNT @D163539, 
            PER @D163538, PLU @D163537, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163548, PRD @D163547, 
      AGR [CASE @D163546, COUNT @D163545, PER @D163544, PLU @D163543, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : VOTE, 
   [COORD @D163554, PRD @D163553, AGR [CASE @D163552, COUNT @D163551, 
            PER @D163550, PLU @D163549, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163560, PRD @D163559, 
      AGR [CASE @D163558, COUNT @D163557, PER @D163556, PLU @D163555, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163566, PRD @D163565, AGR [CASE @D163564, COUNT @D163563, 
            PER @D163562, PLU @D163561, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163572, PRD @D163571, 
      AGR [CASE @D163570, COUNT @D163569, PER @D163568, PLU @D163567, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163578, PRD @D163577, AGR [CASE @D163576, COUNT @D163575, 
            PER @D163574, PLU @D163573, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT THROUGH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163584, PRD @D163583, 
      AGR [CASE @D163582, COUNT @D163581, PER @D163580, PLU @D163579, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : VOTE, 
   [COORD @D163590, PRD @D163589, AGR [CASE @D163588, COUNT @D163587, 
            PER @D163586, PLU @D163585, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163596, PRD @D163595, 
      AGR [CASE @D163594, COUNT @D163593, PER @D163592, PLU @D163591, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : VOTE, 
   [COORD @D163602, PRD @D163601, AGR [CASE @D163600, COUNT @D163599, 
            PER @D163598, PLU @D163597, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163608, PRD @D163607, 
      AGR [CASE @D163606, COUNT @D163605, PER @D163604, PLU @D163603, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : VOTE, 
   [COORD @D163614, PRD @D163613, AGR [CASE @D163612, COUNT @D163611, 
            PER @D163610, PLU @D163609, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163620, PRD @D163619, 
      AGR [CASE @D163618, COUNT @D163617, PER @D163616, PLU @D163615, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163626, PRD @D163625, AGR [CASE @D163624, COUNT @D163623, 
            PER @D163622, PLU @D163621, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163632, PRD @D163631, 
      AGR [CASE @D163630, COUNT @D163629, PER @D163628, PLU @D163627, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163638, PRD @D163637, AGR [CASE @D163636, COUNT @D163635, 
            PER @D163634, PLU @D163633, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE, 
   [COORD @D163644, PRD @D163643, 
      AGR [CASE @D163642, COUNT @D163641, PER @D163640, PLU @D163639, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : VOTE, 
   [COORD @D163650, PRD @D163649, AGR [CASE @D163648, COUNT @D163647, 
            PER @D163646, PLU @D163645, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : VOTE.

WORD wait : 
   [COORD @D163657, REFL @D163656, PRD @D163655, CASE @D163654, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WAIT, 
   [COORD @D163660, 
      AGR [COUNT @D163659, PER @D163658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : WAIT, 
   [COORD @D163662, AGR [COUNT @D163661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WAIT, 
   [COORD @D163664, AGR [COUNT @D163663, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WAIT, 
   [COORD @D163668, AGR [COUNT @D163667, PER @D163666, PLU @D163665, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WAIT, 
   [COORD @D163674, PAST @D163673, 
      AGR [CASE @D163672, COUNT @D163671, PER @D163670, PLU @D163669, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : WAIT, 
   [COORD @D163677, AGR [COUNT @D163676, PER @D163675, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WAIT, 
   [COORD @D163679, AGR [COUNT @D163678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WAIT, 
   [COORD @D163681, AGR [COUNT @D163680, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WAIT, 
   [COORD @D163685, AGR [COUNT @D163684, PER @D163683, PLU @D163682, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WAIT, 
   [COORD @D163691, PAST @D163690, AGR [CASE @D163689, COUNT @D163688, 
            PER @D163687, PLU @D163686, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : WAIT, 
   [COORD @D163694, AGR [COUNT @D163693, PER @D163692, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WAIT, 
   [COORD @D163696, AGR [COUNT @D163695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WAIT, 
   [COORD @D163698, AGR [COUNT @D163697, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WAIT, 
   [COORD @D163702, AGR [COUNT @D163701, PER @D163700, PLU @D163699, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WAIT, 
   [COORD @D163708, PAST @D163707, AGR [CASE @D163706, COUNT @D163705, 
            PER @D163704, PLU @D163703, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WAIT, 
   [COORD @D163711, AGR [COUNT @D163710, PER @D163709, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : WAIT, 
   [COORD @D163713, AGR [COUNT @D163712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : WAIT, 
   [COORD @D163715, AGR [COUNT @D163714, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : WAIT, 
   [COORD @D163719, AGR [COUNT @D163718, PER @D163717, PLU @D163716, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, ARITY 2] : WAIT, 
   [COORD @D163725, PAST @D163724, 
      AGR [CASE @D163723, COUNT @D163722, PER @D163721, PLU @D163720, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM UPON, ARITY 2] : WAIT, 
   [COORD @D163728, AGR [COUNT @D163727, PER @D163726, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : WAIT, 
   [COORD @D163730, AGR [COUNT @D163729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : WAIT, 
   [COORD @D163732, AGR [COUNT @D163731, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : WAIT, 
   [COORD @D163736, AGR [COUNT @D163735, PER @D163734, PLU @D163733, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, ARITY 2] : WAIT, 
   [COORD @D163742, PAST @D163741, 
      AGR [CASE @D163740, COUNT @D163739, PER @D163738, PLU @D163737, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM ON, ARITY 2] : WAIT, 
   [COORD @D163745, AGR [COUNT @D163744, PER @D163743, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163747, AGR [COUNT @D163746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163749, AGR [COUNT @D163748, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163753, AGR [COUNT @D163752, PER @D163751, PLU @D163750, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163759, PAST @D163758, 
      AGR [CASE @D163757, COUNT @D163756, PER @D163755, PLU @D163754, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163762, AGR [COUNT @D163761, PER @D163760, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163764, AGR [COUNT @D163763, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163766, AGR [COUNT @D163765, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163770, AGR [COUNT @D163769, PER @D163768, PLU @D163767, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163776, PAST @D163775, 
      AGR [CASE @D163774, COUNT @D163773, PER @D163772, PLU @D163771, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM FOR, ARITY 2] : WAIT, 
   [COORD @D163779, AGR [COUNT @D163778, PER @D163777, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WAIT, 
   [COORD @D163781, AGR [COUNT @D163780, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WAIT, 
   [COORD @D163783, AGR [COUNT @D163782, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WAIT, 
   [COORD @D163787, AGR [COUNT @D163786, PER @D163785, PLU @D163784, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WAIT, 
   [COORD @D163793, PAST @D163792, AGR [CASE @D163791, COUNT @D163790, 
            PER @D163789, PLU @D163788, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WAIT, 
   [COORD @D163796, AGR [COUNT @D163795, PER @D163794, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WAIT, 
   [COORD @D163798, AGR [COUNT @D163797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WAIT, 
   [COORD @D163800, AGR [COUNT @D163799, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WAIT, 
   [COORD @D163804, AGR [COUNT @D163803, PER @D163802, PLU @D163801, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WAIT, 
   [COORD @D163810, PAST @D163809, 
      AGR [CASE @D163808, COUNT @D163807, PER @D163806, PLU @D163805, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : WAIT, 
   [COORD @D163813, AGR [COUNT @D163812, PER @D163811, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : WAIT, 
   [COORD @D163815, AGR [COUNT @D163814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : WAIT, 
   [COORD @D163817, AGR [COUNT @D163816, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : WAIT, 
   [COORD @D163821, AGR [COUNT @D163820, PER @D163819, PLU @D163818, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT AROUND, ARITY 1] : WAIT, 
   [COORD @D163827, PAST @D163826, 
      AGR [CASE @D163825, COUNT @D163824, PER @D163823, PLU @D163822, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT AROUND, ARITY 1] : WAIT, 
   [COORD @D163830, AGR [COUNT @D163829, PER @D163828, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : WAIT, 
   [COORD @D163832, AGR [COUNT @D163831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : WAIT, 
   [COORD @D163834, AGR [COUNT @D163833, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : WAIT, 
   [COORD @D163838, AGR [COUNT @D163837, PER @D163836, PLU @D163835, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT ABOUT, ARITY 1] : WAIT, 
   [COORD @D163844, PAST @D163843, 
      AGR [CASE @D163842, COUNT @D163841, PER @D163840, PLU @D163839, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT ABOUT, ARITY 1] : WAIT.

WORD waited : 
   [COORD @D163854, AGR [CASE @D163853, COUNT @D163852, PER @D163851, 
            PLU @D163850, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163859, AGR [CASE @D163858, COUNT @D163857, PER @D163856, 
            PLU @D163855, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163864, AGR [CASE @D163863, COUNT @D163862, PER @D163861, 
            PLU @D163860, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163869, AGR [CASE @D163868, COUNT @D163867, PER @D163866, 
            PLU @D163865, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163874, AGR [CASE @D163873, COUNT @D163872, PER @D163871, 
            PLU @D163870, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163879, AGR [CASE @D163878, COUNT @D163877, PER @D163876, 
            PLU @D163875, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163884, AGR [CASE @D163883, COUNT @D163882, PER @D163881, 
            PLU @D163880, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163889, AGR [CASE @D163888, COUNT @D163887, PER @D163886, 
            PLU @D163885, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WAIT, 
   [COORD @D163894, AGR [CASE @D163893, COUNT @D163892, PER @D163891, 
            PLU @D163890, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163899, AGR [CASE @D163898, COUNT @D163897, PER @D163896, 
            PLU @D163895, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163904, AGR [CASE @D163903, COUNT @D163902, PER @D163901, 
            PLU @D163900, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163909, AGR [CASE @D163908, COUNT @D163907, PER @D163906, 
            PLU @D163905, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163914, AGR [CASE @D163913, COUNT @D163912, PER @D163911, 
            PLU @D163910, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163919, AGR [CASE @D163918, COUNT @D163917, PER @D163916, 
            PLU @D163915, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM ON, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163924, AGR [CASE @D163923, COUNT @D163922, PER @D163921, 
            PLU @D163920, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163929, AGR [CASE @D163928, COUNT @D163927, PER @D163926, 
            PLU @D163925, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163934, AGR [CASE @D163933, COUNT @D163932, PER @D163931, 
            PLU @D163930, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163939, AGR [CASE @D163938, COUNT @D163937, PER @D163936, 
            PLU @D163935, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163944, AGR [CASE @D163943, COUNT @D163942, PER @D163941, 
            PLU @D163940, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163949, AGR [CASE @D163948, COUNT @D163947, PER @D163946, 
            PLU @D163945, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163954, AGR [CASE @D163953, COUNT @D163952, PER @D163951, 
            PLU @D163950, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163959, AGR [CASE @D163958, COUNT @D163957, PER @D163956, 
            PLU @D163955, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163964, AGR [CASE @D163963, COUNT @D163962, PER @D163961, 
            PLU @D163960, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163969, AGR [CASE @D163968, COUNT @D163967, PER @D163966, 
            PLU @D163965, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163974, AGR [CASE @D163973, COUNT @D163972, PER @D163971, 
            PLU @D163970, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D163979, AGR [CASE @D163978, COUNT @D163977, PER @D163976, 
            PLU @D163975, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WAIT.

WORD waiting : 
   [COORD @D163994, PRD @D163993, AGR [CASE @D163992, COUNT @D163991, 
            PER @D163990, PLU @D163989, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D164000, PRD @D163999, 
      AGR [CASE @D163998, COUNT @D163997, PER @D163996, PLU @D163995, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WAIT, 
   [COORD @D164006, PRD @D164005, AGR [CASE @D164004, COUNT @D164003, 
            PER @D164002, PLU @D164001, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D164012, PRD @D164011, 
      AGR [CASE @D164010, COUNT @D164009, PER @D164008, PLU @D164007, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WAIT, 
   [COORD @D164018, PRD @D164017, AGR [CASE @D164016, COUNT @D164015, 
            PER @D164014, PLU @D164013, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM ON, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D164024, PRD @D164023, 
      AGR [CASE @D164022, COUNT @D164021, PER @D164020, PLU @D164019, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WAIT, 
   [COORD @D164030, PRD @D164029, AGR [CASE @D164028, COUNT @D164027, 
            PER @D164026, PLU @D164025, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D164036, PRD @D164035, 
      AGR [CASE @D164034, COUNT @D164033, PER @D164032, PLU @D164031, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WAIT, 
   [COORD @D164042, PRD @D164041, AGR [CASE @D164040, COUNT @D164039, 
            PER @D164038, PLU @D164037, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT, 
   [COORD @D164048, PRD @D164047, 
      AGR [CASE @D164046, COUNT @D164045, PER @D164044, PLU @D164043, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WAIT, 
   [COORD @D164054, PRD @D164053, AGR [CASE @D164052, COUNT @D164051, 
            PER @D164050, PLU @D164049, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WAIT.

WORD waits : 
   [COORD @D164063, REFL @D164062, PRD @D164061, CASE @D164060, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : WAITS, 
   [COORD @D164068, DEMON @D164067, REFL @D164066, PRD @D164065, 
      CASE @D164064, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WAIT, 
   [COORD @D164070, AGR [COUNT @D164069, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WAIT, 
   [COORD @D164072, AGR [COUNT @D164071, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, 
      CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WAIT, 
   [COORD @D164074, AGR [COUNT @D164073, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT, 
   [COORD @D164076, 
      AGR [COUNT @D164075, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM UPON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT, 
   [COORD @D164078, 
      AGR [COUNT @D164077, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT, 
   [COORD @D164080, 
      AGR [COUNT @D164079, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT, 
   [COORD @D164082, 
      AGR [COUNT @D164081, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WAIT, 
   [COORD @D164084, AGR [COUNT @D164083, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT, 
   [COORD @D164086, 
      AGR [COUNT @D164085, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT, 
   [COORD @D164088, 
      AGR [COUNT @D164087, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AROUND, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT, 
   [COORD @D164090, 
      AGR [COUNT @D164089, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WAIT.

WORD walk : 
   [COORD @D164107, REFL @D164106, PRD @D164105, CASE @D164104, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WALK, 
   [COORD @D164110, 
      AGR [COUNT @D164109, PER @D164108, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   WALK, 
   [COORD @D164112, AGR [COUNT @D164111, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : WALK, 
   [COORD @D164114, AGR [COUNT @D164113, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : WALK, 
   [COORD @D164118, AGR [COUNT @D164117, PER @D164116, PLU @D164115, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : WALK, 
   [COORD @D164124, PAST @D164123, AGR [CASE @D164122, COUNT @D164121, 
            PER @D164120, PLU @D164119, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : WALK, 
   [COORD @D164127, AGR [COUNT @D164126, PER @D164125, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WALK, 
   [COORD @D164129, AGR [COUNT @D164128, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WALK, 
   [COORD @D164131, AGR [COUNT @D164130, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WALK, 
   [COORD @D164135, AGR [COUNT @D164134, PER @D164133, PLU @D164132, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WALK, 
   [COORD @D164141, PAST @D164140, AGR [CASE @D164139, COUNT @D164138, 
            PER @D164137, PLU @D164136, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WALK, 
   [COORD @D164144, AGR [COUNT @D164143, PER @D164142, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : WALK, 
   [COORD @D164146, AGR [COUNT @D164145, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : WALK, 
   [COORD @D164148, AGR [COUNT @D164147, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, 
      ARITY 2] : WALK, 
   [COORD @D164152, AGR [COUNT @D164151, PER @D164150, PLU @D164149, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, ARITY 2] : WALK, 
   [COORD @D164158, PAST @D164157, AGR [CASE @D164156, COUNT @D164155, 
            PER @D164154, PLU @D164153, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT LOC, ARITY 2] : WALK, 
   [COORD @D164161, AGR [COUNT @D164160, PER @D164159, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OFF, PFORM WITH, ARITY 2] : WALK, 
   [COORD @D164163, AGR [COUNT @D164162, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OFF, PFORM WITH, ARITY 2] : WALK, 
   [COORD @D164165, AGR [COUNT @D164164, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OFF, PFORM WITH, ARITY 2] : WALK, 
   [COORD @D164169, AGR [COUNT @D164168, PER @D164167, PLU @D164166, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OFF, PFORM WITH, ARITY 2] : WALK, 
   [COORD @D164175, PAST @D164174, 
      AGR [CASE @D164173, COUNT @D164172, PER @D164171, PLU @D164170, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OFF, PFORM WITH, ARITY 2] : WALK, 
   [COORD @D164178, AGR [COUNT @D164177, PER @D164176, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WALK, 
   [COORD @D164180, AGR [COUNT @D164179, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WALK, 
   [COORD @D164182, AGR [COUNT @D164181, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WALK, 
   [COORD @D164186, AGR [COUNT @D164185, PER @D164184, PLU @D164183, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM OVER, ARITY 2] : WALK, 
   [COORD @D164192, PAST @D164191, 
      AGR [CASE @D164190, COUNT @D164189, PER @D164188, PLU @D164187, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WALK, 
   [COORD @D164195, AGR [COUNT @D164194, PER @D164193, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM ON, ARITY 2] : WALK, 
   [COORD @D164197, AGR [COUNT @D164196, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM ON, ARITY 2] : WALK, 
   [COORD @D164199, AGR [COUNT @D164198, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM ON, ARITY 2] : WALK, 
   [COORD @D164203, AGR [COUNT @D164202, PER @D164201, PLU @D164200, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM ON, ARITY 2] : WALK, 
   [COORD @D164209, PAST @D164208, 
      AGR [CASE @D164207, COUNT @D164206, PER @D164205, PLU @D164204, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM ON, ARITY 2] : WALK, 
   [COORD @D164212, AGR [COUNT @D164211, PER @D164210, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : WALK, 
   [COORD @D164214, AGR [COUNT @D164213, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : WALK, 
   [COORD @D164216, AGR [COUNT @D164215, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : WALK, 
   [COORD @D164220, AGR [COUNT @D164219, PER @D164218, PLU @D164217, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM OF, ARITY 2] : WALK, 
   [COORD @D164226, PAST @D164225, 
      AGR [CASE @D164224, COUNT @D164223, PER @D164222, PLU @D164221, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM OF, ARITY 2] : WALK, 
   [COORD @D164229, AGR [COUNT @D164228, PER @D164227, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : WALK, 
   [COORD @D164231, AGR [COUNT @D164230, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : WALK, 
   [COORD @D164233, AGR [COUNT @D164232, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : WALK, 
   [COORD @D164237, AGR [COUNT @D164236, PER @D164235, PLU @D164234, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM INTO, ARITY 2] : WALK, 
   [COORD @D164243, PAST @D164242, 
      AGR [CASE @D164241, COUNT @D164240, PER @D164239, PLU @D164238, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM INTO, ARITY 2] : WALK, 
   [COORD @D164246, AGR [COUNT @D164245, PER @D164244, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : WALK, 
   [COORD @D164248, AGR [COUNT @D164247, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : WALK, 
   [COORD @D164250, AGR [COUNT @D164249, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : WALK, 
   [COORD @D164254, AGR [COUNT @D164253, PER @D164252, PLU @D164251, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT AWAY, PFORM FROM, ARITY 2] : WALK, 
   [COORD @D164260, PAST @D164259, 
      AGR [CASE @D164258, COUNT @D164257, PER @D164256, PLU @D164255, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT AWAY, PFORM FROM, ARITY 2] : WALK, 
   [COORD @D164263, AGR [COUNT @D164262, PER @D164261, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WALK, 
   [COORD @D164265, AGR [COUNT @D164264, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WALK, 
   [COORD @D164267, AGR [COUNT @D164266, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WALK, 
   [COORD @D164271, AGR [COUNT @D164270, PER @D164269, PLU @D164268, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WALK, 
   [COORD @D164277, PAST @D164276, AGR [CASE @D164275, COUNT @D164274, 
            PER @D164273, PLU @D164272, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WALK, 
   [COORD @D164280, AGR [COUNT @D164279, PER @D164278, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WALK, 
   [COORD @D164282, AGR [COUNT @D164281, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WALK, 
   [COORD @D164284, AGR [COUNT @D164283, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WALK, 
   [COORD @D164288, AGR [COUNT @D164287, PER @D164286, PLU @D164285, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WALK, 
   [COORD @D164294, PAST @D164293, 
      AGR [CASE @D164292, COUNT @D164291, PER @D164290, PLU @D164289, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : WALK, 
   [COORD @D164297, AGR [COUNT @D164296, PER @D164295, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WALK, 
   [COORD @D164299, AGR [COUNT @D164298, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WALK, 
   [COORD @D164301, AGR [COUNT @D164300, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WALK, 
   [COORD @D164305, AGR [COUNT @D164304, PER @D164303, PLU @D164302, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WALK, 
   [COORD @D164311, PAST @D164310, 
      AGR [CASE @D164309, COUNT @D164308, PER @D164307, PLU @D164306, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : WALK.

WORD walked : 
   [COORD @D164321, AGR [CASE @D164320, COUNT @D164319, PER @D164318, 
            PLU @D164317, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WALK, 
   [COORD @D164326, AGR [CASE @D164325, COUNT @D164324, PER @D164323, 
            PLU @D164322, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164331, AGR [CASE @D164330, COUNT @D164329, PER @D164328, 
            PLU @D164327, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164336, AGR [CASE @D164335, COUNT @D164334, PER @D164333, 
            PLU @D164332, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164341, AGR [CASE @D164340, COUNT @D164339, PER @D164338, 
            PLU @D164337, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164346, AGR [CASE @D164345, COUNT @D164344, PER @D164343, 
            PLU @D164342, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WALK, 
   [COORD @D164351, AGR [CASE @D164350, COUNT @D164349, PER @D164348, 
            PLU @D164347, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164356, AGR [CASE @D164355, COUNT @D164354, PER @D164353, 
            PLU @D164352, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164361, AGR [CASE @D164360, COUNT @D164359, PER @D164358, 
            PLU @D164357, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OFF, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164366, AGR [CASE @D164365, COUNT @D164364, PER @D164363, 
            PLU @D164362, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OFF, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164371, 
      AGR [CASE @D164370, COUNT @D164369, PER @D164368, PLU @D164367, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164376, AGR [CASE @D164375, COUNT @D164374, PER @D164373, 
            PLU @D164372, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164381, AGR [CASE @D164380, COUNT @D164379, PER @D164378, 
            PLU @D164377, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164386, AGR [CASE @D164385, COUNT @D164384, PER @D164383, 
            PLU @D164382, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164391, AGR [CASE @D164390, COUNT @D164389, PER @D164388, 
            PLU @D164387, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OUT, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164396, AGR [CASE @D164395, COUNT @D164394, PER @D164393, 
            PLU @D164392, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164401, AGR [CASE @D164400, COUNT @D164399, PER @D164398, 
            PLU @D164397, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164406, AGR [CASE @D164405, COUNT @D164404, PER @D164403, 
            PLU @D164402, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164411, AGR [CASE @D164410, COUNT @D164409, PER @D164408, 
            PLU @D164407, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164416, AGR [CASE @D164415, COUNT @D164414, PER @D164413, 
            PLU @D164412, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164421, AGR [CASE @D164420, COUNT @D164419, PER @D164418, 
            PLU @D164417, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164426, AGR [CASE @D164425, COUNT @D164424, PER @D164423, 
            PLU @D164422, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164431, AGR [CASE @D164430, COUNT @D164429, PER @D164428, 
            PLU @D164427, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164436, 
      AGR [CASE @D164435, COUNT @D164434, PER @D164433, PLU @D164432, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164441, AGR [CASE @D164440, COUNT @D164439, PER @D164438, 
            PLU @D164437, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT AWAY, PFORM FROM, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164446, AGR [CASE @D164445, COUNT @D164444, PER @D164443, 
            PLU @D164442, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164451, AGR [CASE @D164450, COUNT @D164449, PER @D164448, 
            PLU @D164447, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164456, AGR [CASE @D164455, COUNT @D164454, PER @D164453, 
            PLU @D164452, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164461, AGR [CASE @D164460, COUNT @D164459, PER @D164458, 
            PLU @D164457, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WALK, 
   [COORD @D164466, AGR [CASE @D164465, COUNT @D164464, PER @D164463, 
            PLU @D164462, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164471, AGR [CASE @D164470, COUNT @D164469, PER @D164468, 
            PLU @D164467, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WALK.

WORD walking : 
   [COORD @D164486, PRD @D164485, AGR [CASE @D164484, COUNT @D164483, 
            PER @D164482, PLU @D164481, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164492, PRD @D164491, 
      AGR [CASE @D164490, COUNT @D164489, PER @D164488, PLU @D164487, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WALK, 
   [COORD @D164498, PRD @D164497, AGR [CASE @D164496, COUNT @D164495, 
            PER @D164494, PLU @D164493, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164504, PRD @D164503, 
      AGR [CASE @D164502, COUNT @D164501, PER @D164500, PLU @D164499, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WALK, 
   [COORD @D164510, PRD @D164509, AGR [CASE @D164508, COUNT @D164507, 
            PER @D164506, PLU @D164505, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164516, PRD @D164515, 
      AGR [CASE @D164514, COUNT @D164513, PER @D164512, PLU @D164511, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WALK, 
   [COORD @D164522, PRD @D164521, AGR [CASE @D164520, COUNT @D164519, 
            PER @D164518, PLU @D164517, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM OF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164528, PRD @D164527, 
      AGR [CASE @D164526, COUNT @D164525, PER @D164524, PLU @D164523, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WALK, 
   [COORD @D164534, PRD @D164533, AGR [CASE @D164532, COUNT @D164531, 
            PER @D164530, PLU @D164529, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT AWAY, 
      PFORM FROM, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164540, PRD @D164539, 
      AGR [CASE @D164538, COUNT @D164537, PER @D164536, PLU @D164535, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WALK, 
   [COORD @D164546, PRD @D164545, AGR [CASE @D164544, COUNT @D164543, 
            PER @D164542, PLU @D164541, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WALK, 
   [COORD @D164552, PRD @D164551, 
      AGR [CASE @D164550, COUNT @D164549, PER @D164548, PLU @D164547, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WALK.

WORD walks : 
   [COORD @D164562, DEMON @D164561, REFL @D164560, PRD @D164559, 
      CASE @D164558, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WALK, 
   [COORD @D164564, AGR [COUNT @D164563, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WALK, 
   [COORD @D164566, AGR [COUNT @D164565, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WALK, 
   [COORD @D164568, 
      AGR [COUNT @D164567, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WALK, 
   [COORD @D164570, 
      AGR [COUNT @D164569, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT OFF, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WALK, 
   [COORD @D164572, AGR [COUNT @D164571, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WALK, 
   [COORD @D164574, AGR [COUNT @D164573, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WALK, 
   [COORD @D164576, AGR [COUNT @D164575, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WALK, 
   [COORD @D164578, AGR [COUNT @D164577, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WALK, 
   [COORD @D164580, AGR [COUNT @D164579, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM FROM, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WALK, 
   [COORD @D164582, AGR [COUNT @D164581, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WALK, 
   [COORD @D164584, 
      AGR [COUNT @D164583, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WALK, 
   [COORD @D164586, 
      AGR [COUNT @D164585, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WALK.

WORD want : 
   [COORD @D164593, REFL @D164592, PRD @D164591, CASE @D164590, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WANT, 
   [COORD @D164597, REFL @D164596, PRD @D164595, CASE @D164594, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WANT, 
   [COORD @D164601, REFL @D164600, PRD @D164599, CASE @D164598, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF, COUNT +] : WANT, 
   [COORD @D164605, REFL @D164604, PRD @D164603, CASE @D164602, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : WANT, 
   [COORD @D164610, REFL @D164609, COUNT @D164608, PRD @D164607, 
      CASE @D164606, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : WANT, 
   [COORD @D164613, 
      AGR [COUNT @D164612, PER @D164611, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : WANT, 
   [COORD @D164615, AGR [COUNT @D164614, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WANT, 
   [COORD @D164617, AGR [COUNT @D164616, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WANT, 
   [COORD @D164621, AGR [COUNT @D164620, PER @D164619, PLU @D164618, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WANT, 
   [COORD @D164627, PAST @D164626, 
      AGR [CASE @D164625, COUNT @D164624, PER @D164623, PLU @D164622, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : WANT, 
   [COORD @D164630, AGR [COUNT @D164629, PER @D164628, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : WANT, 
   [COORD @D164632, AGR [COUNT @D164631, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : WANT, 
   [COORD @D164634, AGR [COUNT @D164633, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : WANT, 
   [COORD @D164638, AGR [COUNT @D164637, PER @D164636, PLU @D164635, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SINF, ARITY 2] : WANT, 
   [COORD @D164644, PAST @D164643, AGR [CASE @D164642, COUNT @D164641, 
            PER @D164640, PLU @D164639, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SINF, ARITY 2] : WANT, 
   [COORD @D164647, AGR [COUNT @D164646, PER @D164645, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : WANT, 
   [COORD @D164649, AGR [COUNT @D164648, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : WANT, 
   [COORD @D164651, AGR [COUNT @D164650, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : WANT, 
   [COORD @D164655, AGR [COUNT @D164654, PER @D164653, PLU @D164652, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, ARITY 2] : WANT, 
   [COORD @D164661, PAST @D164660, AGR [CASE @D164659, COUNT @D164658, 
            PER @D164657, PLU @D164656, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_ING, ARITY 2] : WANT, 
   [COORD @D164664, AGR [COUNT @D164663, PER @D164662, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WANT, 
   [COORD @D164666, AGR [COUNT @D164665, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WANT, 
   [COORD @D164668, AGR [COUNT @D164667, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WANT, 
   [COORD @D164672, AGR [COUNT @D164671, PER @D164670, PLU @D164669, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WANT, 
   [COORD @D164678, PAST @D164677, AGR [CASE @D164676, COUNT @D164675, 
            PER @D164674, PLU @D164673, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : WANT, 
   [COORD @D164681, AGR [COUNT @D164680, PER @D164679, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : WANT, 
   [COORD @D164683, AGR [COUNT @D164682, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : WANT, 
   [COORD @D164685, AGR [COUNT @D164684, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : WANT, 
   [COORD @D164689, AGR [COUNT @D164688, PER @D164687, PLU @D164686, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_PASS, ARITY 2] : WANT, 
   [COORD @D164695, PAST @D164694, AGR [CASE @D164693, COUNT @D164692, 
            PER @D164691, PLU @D164690, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_PASS, ARITY 2] : WANT, 
   [COORD @D164698, AGR [COUNT @D164697, PER @D164696, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : WANT, 
   [COORD @D164700, AGR [COUNT @D164699, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : WANT, 
   [COORD @D164702, AGR [COUNT @D164701, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : WANT, 
   [COORD @D164706, AGR [COUNT @D164705, PER @D164704, PLU @D164703, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_ING, ARITY 2] : WANT, 
   [COORD @D164712, PAST @D164711, AGR [CASE @D164710, COUNT @D164709, 
            PER @D164708, PLU @D164707, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_ING, ARITY 2] : WANT, 
   [COORD @D164715, AGR [COUNT @D164714, PER @D164713, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WANT, 
   [COORD @D164717, AGR [COUNT @D164716, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WANT, 
   [COORD @D164719, AGR [COUNT @D164718, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WANT, 
   [COORD @D164723, AGR [COUNT @D164722, PER @D164721, PLU @D164720, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WANT, 
   [COORD @D164729, PAST @D164728, AGR [CASE @D164727, COUNT @D164726, 
            PER @D164725, PLU @D164724, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : WANT, 
   [COORD @D164732, AGR [COUNT @D164731, PER @D164730, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WANT, 
   [COORD @D164734, AGR [COUNT @D164733, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WANT, 
   [COORD @D164736, AGR [COUNT @D164735, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WANT, 
   [COORD @D164740, AGR [COUNT @D164739, PER @D164738, PLU @D164737, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WANT, 
   [COORD @D164746, PAST @D164745, AGR [CASE @D164744, COUNT @D164743, 
            PER @D164742, PLU @D164741, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : WANT, 
   [COORD @D164749, AGR [COUNT @D164748, PER @D164747, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WANT, 
   [COORD @D164751, AGR [COUNT @D164750, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WANT, 
   [COORD @D164753, AGR [COUNT @D164752, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WANT, 
   [COORD @D164757, AGR [COUNT @D164756, PER @D164755, PLU @D164754, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WANT, 
   [COORD @D164763, PAST @D164762, AGR [CASE @D164761, COUNT @D164760, 
            PER @D164759, PLU @D164758, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WANT, 
   [COORD @D164766, AGR [COUNT @D164765, PER @D164764, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WANT, 
   [COORD @D164768, AGR [COUNT @D164767, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WANT, 
   [COORD @D164770, AGR [COUNT @D164769, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WANT, 
   [COORD @D164774, AGR [COUNT @D164773, PER @D164772, PLU @D164771, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : WANT, 
   [COORD @D164780, PAST @D164779, 
      AGR [CASE @D164778, COUNT @D164777, PER @D164776, PLU @D164775, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WANT, 
   [COORD @D164783, AGR [COUNT @D164782, PER @D164781, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WANT, 
   [COORD @D164785, AGR [COUNT @D164784, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WANT, 
   [COORD @D164787, AGR [COUNT @D164786, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WANT, 
   [COORD @D164791, AGR [COUNT @D164790, PER @D164789, PLU @D164788, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WANT, 
   [COORD @D164797, PAST @D164796, AGR [CASE @D164795, COUNT @D164794, 
            PER @D164793, PLU @D164792, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WANT, 
   [COORD @D164800, AGR [COUNT @D164799, PER @D164798, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WANT, 
   [COORD @D164802, AGR [COUNT @D164801, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WANT, 
   [COORD @D164804, AGR [COUNT @D164803, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WANT, 
   [COORD @D164808, AGR [COUNT @D164807, PER @D164806, PLU @D164805, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WANT, 
   [COORD @D164814, PAST @D164813, 
      AGR [CASE @D164812, COUNT @D164811, PER @D164810, PLU @D164809, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : WANT, 
   [COORD @D164817, AGR [COUNT @D164816, PER @D164815, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WANT, 
   [COORD @D164819, AGR [COUNT @D164818, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WANT, 
   [COORD @D164821, AGR [COUNT @D164820, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WANT, 
   [COORD @D164825, AGR [COUNT @D164824, PER @D164823, PLU @D164822, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WANT, 
   [COORD @D164831, PAST @D164830, 
      AGR [CASE @D164829, COUNT @D164828, PER @D164827, PLU @D164826, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : WANT.

WORD wanted : 
   [COORD @D164841, AGR [CASE @D164840, COUNT @D164839, PER @D164838, 
            PLU @D164837, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164846, AGR [CASE @D164845, COUNT @D164844, PER @D164843, 
            PLU @D164842, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164851, AGR [CASE @D164850, COUNT @D164849, PER @D164848, 
            PLU @D164847, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164856, AGR [CASE @D164855, COUNT @D164854, PER @D164853, 
            PLU @D164852, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164861, AGR [CASE @D164860, COUNT @D164859, PER @D164858, 
            PLU @D164857, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164866, AGR [CASE @D164865, COUNT @D164864, PER @D164863, 
            PLU @D164862, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164871, AGR [CASE @D164870, COUNT @D164869, PER @D164868, 
            PLU @D164867, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164876, AGR [CASE @D164875, COUNT @D164874, PER @D164873, 
            PLU @D164872, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164881, AGR [CASE @D164880, COUNT @D164879, PER @D164878, 
            PLU @D164877, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164886, AGR [CASE @D164885, COUNT @D164884, PER @D164883, 
            PLU @D164882, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_PASS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164891, AGR [CASE @D164890, COUNT @D164889, PER @D164888, 
            PLU @D164887, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_PASS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164896, AGR [CASE @D164895, COUNT @D164894, PER @D164893, 
            PLU @D164892, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE RAIS, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WANT, 
   [COORD @D164901, AGR [CASE @D164900, COUNT @D164899, PER @D164898, 
            PLU @D164897, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164906, AGR [CASE @D164905, COUNT @D164904, PER @D164903, 
            PLU @D164902, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164912, AGR [CASE @D164911, NFORM @D164910, COUNT @D164909, 
            PER @D164908, PLU @D164907, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WANT, 
   [COORD @D164917, AGR [UB @D164916, VFORM @D164915, SUBJ @D164914, 
            FIN @D164913, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WANT, 
   [COORD @D164922, AGR [CASE @D164921, COUNT @D164920, PER @D164919, 
            PLU @D164918, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164927, AGR [CASE @D164926, COUNT @D164925, PER @D164924, 
            PLU @D164923, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164932, AGR [CASE @D164931, COUNT @D164930, PER @D164929, 
            PLU @D164928, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164937, AGR [CASE @D164936, COUNT @D164935, PER @D164934, 
            PLU @D164933, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164943, AGR [CASE @D164942, NFORM @D164941, COUNT @D164940, 
            PER @D164939, PLU @D164938, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WANT, 
   [COORD @D164948, AGR [UB @D164947, VFORM @D164946, SUBJ @D164945, 
            FIN @D164944, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WANT, 
   [COORD @D164953, AGR [CASE @D164952, COUNT @D164951, PER @D164950, 
            PLU @D164949, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164958, AGR [CASE @D164957, COUNT @D164956, PER @D164955, 
            PLU @D164954, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164963, AGR [CASE @D164962, COUNT @D164961, PER @D164960, 
            PLU @D164959, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WANT, 
   [COORD @D164968, AGR [CASE @D164967, COUNT @D164966, PER @D164965, 
            PLU @D164964, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164973, AGR [CASE @D164972, COUNT @D164971, PER @D164970, 
            PLU @D164969, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164978, AGR [CASE @D164977, COUNT @D164976, PER @D164975, 
            PLU @D164974, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164983, AGR [CASE @D164982, COUNT @D164981, PER @D164980, 
            PLU @D164979, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164988, AGR [CASE @D164987, COUNT @D164986, PER @D164985, 
            PLU @D164984, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D164993, AGR [CASE @D164992, COUNT @D164991, PER @D164990, 
            PLU @D164989, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D164998, AGR [CASE @D164997, COUNT @D164996, PER @D164995, 
            PLU @D164994, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WANT, 
   [COORD @D165003, AGR [CASE @D165002, COUNT @D165001, PER @D165000, 
            PLU @D164999, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D165008, AGR [CASE @D165007, COUNT @D165006, PER @D165005, 
            PLU @D165004, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WANT.

WORD wanting : 
   [COORD @D165023, PRD @D165022, AGR [CASE @D165021, COUNT @D165020, 
            PER @D165019, PLU @D165018, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D165029, PRD @D165028, 
      AGR [CASE @D165027, COUNT @D165026, PER @D165025, PLU @D165024, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WANT, 
   [COORD @D165035, PRD @D165034, AGR [CASE @D165033, COUNT @D165032, 
            PER @D165031, PLU @D165030, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D165041, PRD @D165040, 
      AGR [CASE @D165039, COUNT @D165038, PER @D165037, PLU @D165036, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WANT, 
   [COORD @D165047, PRD @D165046, AGR [CASE @D165045, COUNT @D165044, 
            PER @D165043, PLU @D165042, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_PASS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D165053, PRD @D165052, 
      AGR [CASE @D165051, COUNT @D165050, PER @D165049, PLU @D165048, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   WANT, 
   [COORD @D165059, PRD @D165058, AGR [CASE @D165057, COUNT @D165056, 
            PER @D165055, PLU @D165054, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D165065, PRD @D165064, 
      AGR [CASE @D165063, COUNT @D165062, PER @D165061, PLU @D165060, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   WANT, 
   [COORD @D165071, PRD @D165070, AGR [CASE @D165069, COUNT @D165068, 
            PER @D165067, PLU @D165066, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D165077, PRD @D165076, 
      AGR [CASE @D165075, COUNT @D165074, PER @D165073, PLU @D165072, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WANT, 
   [COORD @D165083, PRD @D165082, AGR [CASE @D165081, COUNT @D165080, 
            PER @D165079, PLU @D165078, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WANT, 
   [COORD @D165089, PRD @D165088, 
      AGR [CASE @D165087, COUNT @D165086, PER @D165085, PLU @D165084, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WANT, 
   [COORD @D165095, PRD @D165094, AGR [CASE @D165093, COUNT @D165092, 
            PER @D165091, PLU @D165090, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WANT.

WORD wants : 
   [COORD @D165104, REFL @D165103, PRD @D165102, CASE @D165101, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : WANTS, 
   [COORD @D165109, DEMON @D165108, REFL @D165107, PRD @D165106, 
      CASE @D165105, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WANT, 
   [COORD @D165114, DEMON @D165113, REFL @D165112, PRD @D165111, 
      CASE @D165110, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WANT, 
   [COORD @D165116, AGR [COUNT @D165115, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WANT, 
   [COORD @D165118, AGR [COUNT @D165117, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SINF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165120, 
      AGR [COUNT @D165119, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165122, 
      AGR [COUNT @D165121, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165124, 
      AGR [COUNT @D165123, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_PASS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165126, 
      AGR [COUNT @D165125, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165128, 
      AGR [COUNT @D165127, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165130, 
      AGR [COUNT @D165129, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165132, 
      AGR [COUNT @D165131, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165134, 
      AGR [COUNT @D165133, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165136, 
      AGR [COUNT @D165135, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165138, 
      AGR [COUNT @D165137, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT, 
   [COORD @D165140, 
      AGR [COUNT @D165139, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WANT.

WORD warn : 
   [COORD @D165156, AGR [COUNT @D165155, PER @D165154, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : WARN, 
   [COORD @D165158, AGR [COUNT @D165157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : WARN, 
   [COORD @D165160, AGR [COUNT @D165159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : WARN, 
   [COORD @D165164, AGR [COUNT @D165163, PER @D165162, PLU @D165161, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_INF, ARITY 3] : WARN, 
   [COORD @D165170, PAST @D165169, AGR [CASE @D165168, COUNT @D165167, 
            PER @D165166, PLU @D165165, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_INF, ARITY 3] : WARN, 
   [COORD @D165173, AGR [COUNT @D165172, PER @D165171, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : WARN, 
   [COORD @D165175, AGR [COUNT @D165174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : WARN, 
   [COORD @D165177, AGR [COUNT @D165176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : WARN, 
   [COORD @D165181, AGR [COUNT @D165180, PER @D165179, PLU @D165178, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, ARITY 3] : WARN, 
   [COORD @D165187, PAST @D165186, AGR [CASE @D165185, COUNT @D165184, 
            PER @D165183, PLU @D165182, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_SFIN, ARITY 3] : WARN, 
   [COORD @D165190, AGR [COUNT @D165189, PER @D165188, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : WARN, 
   [COORD @D165192, AGR [COUNT @D165191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : WARN, 
   [COORD @D165194, AGR [COUNT @D165193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : WARN, 
   [COORD @D165198, AGR [COUNT @D165197, PER @D165196, PLU @D165195, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OFF, ARITY 3] : WARN, 
   [COORD @D165204, PAST @D165203, 
      AGR [CASE @D165202, COUNT @D165201, PER @D165200, PLU @D165199, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OFF, ARITY 3] : WARN, 
   [COORD @D165207, AGR [COUNT @D165206, PER @D165205, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : WARN, 
   [COORD @D165209, AGR [COUNT @D165208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : WARN, 
   [COORD @D165211, AGR [COUNT @D165210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : WARN, 
   [COORD @D165215, AGR [COUNT @D165214, PER @D165213, PLU @D165212, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM OF, ARITY 3] : WARN, 
   [COORD @D165221, PAST @D165220, 
      AGR [CASE @D165219, COUNT @D165218, PER @D165217, PLU @D165216, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM OF, ARITY 3] : WARN, 
   [COORD @D165224, AGR [COUNT @D165223, PER @D165222, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : WARN, 
   [COORD @D165226, AGR [COUNT @D165225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : WARN, 
   [COORD @D165228, AGR [COUNT @D165227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : WARN, 
   [COORD @D165232, AGR [COUNT @D165231, PER @D165230, PLU @D165229, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM AGAINST, ARITY 3] : WARN, 
   [COORD @D165238, PAST @D165237, 
      AGR [CASE @D165236, COUNT @D165235, PER @D165234, PLU @D165233, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM AGAINST, ARITY 3] : WARN, 
   [COORD @D165241, AGR [COUNT @D165240, PER @D165239, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WARN, 
   [COORD @D165243, AGR [COUNT @D165242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WARN, 
   [COORD @D165245, AGR [COUNT @D165244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WARN, 
   [COORD @D165249, AGR [COUNT @D165248, PER @D165247, PLU @D165246, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WARN, 
   [COORD @D165255, PAST @D165254, AGR [CASE @D165253, COUNT @D165252, 
            PER @D165251, PLU @D165250, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : WARN, 
   [COORD @D165258, AGR [COUNT @D165257, PER @D165256, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WARN, 
   [COORD @D165260, AGR [COUNT @D165259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WARN, 
   [COORD @D165262, AGR [COUNT @D165261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WARN, 
   [COORD @D165266, AGR [COUNT @D165265, PER @D165264, PLU @D165263, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WARN, 
   [COORD @D165272, PAST @D165271, AGR [CASE @D165270, COUNT @D165269, 
            PER @D165268, PLU @D165267, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WARN, 
   [COORD @D165275, AGR [COUNT @D165274, PER @D165273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : WARN, 
   [COORD @D165277, AGR [COUNT @D165276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : WARN, 
   [COORD @D165279, AGR [COUNT @D165278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : WARN, 
   [COORD @D165283, AGR [COUNT @D165282, PER @D165281, PLU @D165280, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OF, ARITY 2] : WARN, 
   [COORD @D165289, PAST @D165288, 
      AGR [CASE @D165287, COUNT @D165286, PER @D165285, PLU @D165284, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OF, ARITY 2] : WARN, 
   [COORD @D165292, AGR [COUNT @D165291, PER @D165290, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : WARN, 
   [COORD @D165294, AGR [COUNT @D165293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : WARN, 
   [COORD @D165296, AGR [COUNT @D165295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : WARN, 
   [COORD @D165300, AGR [COUNT @D165299, PER @D165298, PLU @D165297, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AGAINST, ARITY 2] : WARN, 
   [COORD @D165306, PAST @D165305, 
      AGR [CASE @D165304, COUNT @D165303, PER @D165302, PLU @D165301, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AGAINST, ARITY 2] : WARN, 
   [COORD @D165309, AGR [COUNT @D165308, PER @D165307, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : WARN, 
   [COORD @D165311, AGR [COUNT @D165310, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : WARN, 
   [COORD @D165313, AGR [COUNT @D165312, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : WARN, 
   [COORD @D165317, AGR [COUNT @D165316, PER @D165315, PLU @D165314, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : WARN, 
   [COORD @D165323, PAST @D165322, 
      AGR [CASE @D165321, COUNT @D165320, PER @D165319, PLU @D165318, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : WARN, 
   [COORD @D165326, AGR [COUNT @D165325, PER @D165324, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WARN, 
   [COORD @D165328, AGR [COUNT @D165327, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WARN, 
   [COORD @D165330, AGR [COUNT @D165329, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WARN, 
   [COORD @D165334, AGR [COUNT @D165333, PER @D165332, PLU @D165331, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WARN, 
   [COORD @D165340, PAST @D165339, 
      AGR [CASE @D165338, COUNT @D165337, PER @D165336, PLU @D165335, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : WARN.

WORD warned : 
   [COORD @D165349, AGR [CASE @D165348, COUNT @D165347, PER @D165346, 
            PLU @D165345, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165354, AGR [CASE @D165353, COUNT @D165352, PER @D165351, 
            PLU @D165350, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165360, AGR [CASE @D165359, NFORM @D165358, COUNT @D165357, 
            PER @D165356, PLU @D165355, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WARN, 
   [COORD @D165365, AGR [CASE @D165364, COUNT @D165363, PER @D165362, 
            PLU @D165361, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WARN, 
   [COORD @D165370, AGR [CASE @D165369, COUNT @D165368, PER @D165367, 
            PLU @D165366, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165375, AGR [CASE @D165374, COUNT @D165373, PER @D165372, 
            PLU @D165371, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165380, AGR [CASE @D165379, COUNT @D165378, PER @D165377, 
            PLU @D165376, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165385, AGR [CASE @D165384, COUNT @D165383, PER @D165382, 
            PLU @D165381, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165390, AGR [CASE @D165389, COUNT @D165388, PER @D165387, 
            PLU @D165386, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165395, AGR [CASE @D165394, COUNT @D165393, PER @D165392, 
            PLU @D165391, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM OF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165400, AGR [CASE @D165399, COUNT @D165398, PER @D165397, 
            PLU @D165396, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165405, AGR [CASE @D165404, COUNT @D165403, PER @D165402, 
            PLU @D165401, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165410, AGR [CASE @D165409, COUNT @D165408, PER @D165407, 
            PLU @D165406, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165415, AGR [CASE @D165414, COUNT @D165413, PER @D165412, 
            PLU @D165411, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165420, AGR [CASE @D165419, COUNT @D165418, PER @D165417, 
            PLU @D165416, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165425, AGR [CASE @D165424, COUNT @D165423, PER @D165422, 
            PLU @D165421, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165430, AGR [CASE @D165429, COUNT @D165428, PER @D165427, 
            PLU @D165426, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165435, AGR [UB @D165434, VFORM @D165433, SUBJ @D165432, 
            FIN @D165431, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WARN, 
   [COORD @D165440, AGR [CASE @D165439, COUNT @D165438, PER @D165437, 
            PLU @D165436, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WARN, 
   [COORD @D165445, AGR [CASE @D165444, COUNT @D165443, PER @D165442, 
            PLU @D165441, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165450, AGR [CASE @D165449, COUNT @D165448, PER @D165447, 
            PLU @D165446, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165455, AGR [CASE @D165454, COUNT @D165453, PER @D165452, 
            PLU @D165451, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165460, AGR [CASE @D165459, COUNT @D165458, PER @D165457, 
            PLU @D165456, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165465, AGR [CASE @D165464, COUNT @D165463, PER @D165462, 
            PLU @D165461, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165470, AGR [CASE @D165469, COUNT @D165468, PER @D165467, 
            PLU @D165466, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AGAINST, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165475, AGR [CASE @D165474, COUNT @D165473, PER @D165472, 
            PLU @D165471, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165480, AGR [CASE @D165479, COUNT @D165478, PER @D165477, 
            PLU @D165476, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WARN, 
   [COORD @D165485, AGR [CASE @D165484, COUNT @D165483, PER @D165482, 
            PLU @D165481, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165490, AGR [CASE @D165489, COUNT @D165488, PER @D165487, 
            PLU @D165486, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165495, AGR [CASE @D165494, COUNT @D165493, PER @D165492, 
            PLU @D165491, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WARN.

WORD warning : 
   [COORD @D165505, REFL @D165504, PRD @D165503, CASE @D165502, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WARNING, 
   [COORD @D165509, REFL @D165508, PRD @D165507, CASE @D165506, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF, COUNT +] : WARNING, 
   [COORD @D165514, REFL @D165513, COUNT @D165512, PRD @D165511, 
      CASE @D165510, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : WARNING, 
   [COORD @D165519, REFL @D165518, COUNT @D165517, PRD @D165516, 
      CASE @D165515, FIX NOT, INFL +, BAR 0, N +, V -, POSS -, PRO -, 
      PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, 
      NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, PFORM OF] : 
   WARNING, 
   [COORD @D165525, PRD @D165524, AGR [CASE @D165523, COUNT @D165522, 
            PER @D165521, PLU @D165520, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165531, PRD @D165530, 
      AGR [CASE @D165529, COUNT @D165528, PER @D165527, PLU @D165526, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WARN, 
   [COORD @D165537, PRD @D165536, AGR [CASE @D165535, COUNT @D165534, 
            PER @D165533, PLU @D165532, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM OFF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165543, PRD @D165542, 
      AGR [CASE @D165541, COUNT @D165540, PER @D165539, PLU @D165538, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WARN, 
   [COORD @D165549, PRD @D165548, AGR [CASE @D165547, COUNT @D165546, 
            PER @D165545, PLU @D165544, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165555, PRD @D165554, 
      AGR [CASE @D165553, COUNT @D165552, PER @D165551, PLU @D165550, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WARN, 
   [COORD @D165561, PRD @D165560, AGR [CASE @D165559, COUNT @D165558, 
            PER @D165557, PLU @D165556, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165567, PRD @D165566, 
      AGR [CASE @D165565, COUNT @D165564, PER @D165563, PLU @D165562, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WARN, 
   [COORD @D165573, PRD @D165572, AGR [CASE @D165571, COUNT @D165570, 
            PER @D165569, PLU @D165568, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, 
      PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WARN, 
   [COORD @D165579, PRD @D165578, 
      AGR [CASE @D165577, COUNT @D165576, PER @D165575, PLU @D165574, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WARN, 
   [COORD @D165585, PRD @D165584, AGR [CASE @D165583, COUNT @D165582, 
            PER @D165581, PLU @D165580, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WARN.

WORD warnings : 
   [COORD @D165598, DEMON @D165597, REFL @D165596, PRD @D165595, 
      CASE @D165594, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WARNING, 
   [COORD @D165603, DEMON @D165602, REFL @D165601, PRD @D165600, 
      CASE @D165599, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : WARNING, 
   
   [COORD @D165608, DEMON @D165607, REFL @D165606, PRD @D165605, CASE 
         @D165604, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, PART -, 
      CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : WARNING, 
   
   [COORD @D165613, DEMON @D165612, REFL @D165611, PRD @D165610, CASE 
         @D165609, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT PP, PFORM OF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WARNING.

WORD warns : 
   [COORD @D165619, AGR [COUNT @D165618, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WARN, 
   [COORD @D165621, AGR [COUNT @D165620, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WARN, 
   [COORD @D165623, AGR [COUNT @D165622, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WARN, 
   [COORD @D165625, AGR [COUNT @D165624, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WARN, 
   [COORD @D165627, AGR [COUNT @D165626, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WARN, 
   [COORD @D165629, AGR [COUNT @D165628, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WARN, 
   [COORD @D165631, 
      AGR [COUNT @D165630, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WARN, 
   [COORD @D165633, 
      AGR [COUNT @D165632, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WARN, 
   [COORD @D165635, 
      AGR [COUNT @D165634, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AGAINST, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WARN, 
   [COORD @D165637, AGR [COUNT @D165636, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WARN, 
   [COORD @D165639, AGR [COUNT @D165638, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WARN.

WORD watch : 
   [COORD @D165646, REFL @D165645, PRD @D165644, CASE @D165643, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WATCH, 
   [COORD @D165651, REFL @D165650, COUNT @D165649, PRD @D165648, 
      CASE @D165647, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : WATCH, 
   [COORD @D165655, REFL @D165654, PRD @D165653, CASE @D165652, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, GROUP +, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT -] : WATCH, 
   [COORD @D165658, 
      AGR [COUNT @D165657, PER @D165656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_ING, 
      ARITY 3] : WATCH, 
   [COORD @D165660, AGR [COUNT @D165659, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : WATCH, 
   [COORD @D165662, AGR [COUNT @D165661, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : WATCH, 
   [COORD @D165666, AGR [COUNT @D165665, PER @D165664, PLU @D165663, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_ING, ARITY 3] : WATCH, 
   [COORD @D165672, PAST @D165671, AGR [CASE @D165670, COUNT @D165669, 
            PER @D165668, PLU @D165667, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_ING, ARITY 3] : WATCH, 
   [COORD @D165675, AGR [COUNT @D165674, PER @D165673, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : WATCH, 
   [COORD @D165677, AGR [COUNT @D165676, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : WATCH, 
   [COORD @D165679, AGR [COUNT @D165678, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : WATCH, 
   [COORD @D165683, AGR [COUNT @D165682, PER @D165681, PLU @D165680, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_BSE, ARITY 3] : WATCH, 
   [COORD @D165689, PAST @D165688, AGR [CASE @D165687, COUNT @D165686, 
            PER @D165685, PLU @D165684, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQUI, SUBCAT OC_BSE, ARITY 3] : WATCH, 
   [COORD @D165692, AGR [COUNT @D165691, PER @D165690, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : WATCH, 
   [COORD @D165694, AGR [COUNT @D165693, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : WATCH, 
   [COORD @D165696, AGR [COUNT @D165695, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : WATCH, 
   [COORD @D165700, AGR [COUNT @D165699, PER @D165698, PLU @D165697, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : WATCH, 
   [COORD @D165706, PAST @D165705, 
      AGR [CASE @D165704, COUNT @D165703, PER @D165702, PLU @D165701, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM FOR, ARITY 3] : WATCH, 
   [COORD @D165709, AGR [COUNT @D165708, PER @D165707, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : WATCH, 
   [COORD @D165711, AGR [COUNT @D165710, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : WATCH, 
   [COORD @D165713, AGR [COUNT @D165712, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : WATCH, 
   [COORD @D165717, AGR [COUNT @D165716, PER @D165715, PLU @D165714, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : WATCH, 
   [COORD @D165723, PAST @D165722, AGR [CASE @D165721, COUNT @D165720, 
            PER @D165719, PLU @D165718, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : WATCH, 
   [COORD @D165726, AGR [COUNT @D165725, PER @D165724, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : WATCH, 
   [COORD @D165728, AGR [COUNT @D165727, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : WATCH, 
   [COORD @D165730, AGR [COUNT @D165729, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : WATCH, 
   [COORD @D165734, AGR [COUNT @D165733, PER @D165732, PLU @D165731, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : WATCH, 
   [COORD @D165740, PAST @D165739, AGR [CASE @D165738, COUNT @D165737, 
            PER @D165736, PLU @D165735, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : WATCH, 
   [COORD @D165743, AGR [COUNT @D165742, PER @D165741, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WATCH, 
   [COORD @D165745, AGR [COUNT @D165744, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WATCH, 
   [COORD @D165747, AGR [COUNT @D165746, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WATCH, 
   [COORD @D165751, AGR [COUNT @D165750, PER @D165749, PLU @D165748, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WATCH, 
   [COORD @D165757, PAST @D165756, AGR [CASE @D165755, COUNT @D165754, 
            PER @D165753, PLU @D165752, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : WATCH, 
   [COORD @D165760, AGR [COUNT @D165759, PER @D165758, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WATCH, 
   [COORD @D165762, AGR [COUNT @D165761, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WATCH, 
   [COORD @D165764, AGR [COUNT @D165763, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WATCH, 
   [COORD @D165768, AGR [COUNT @D165767, PER @D165766, PLU @D165765, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WATCH, 
   [COORD @D165774, PAST @D165773, AGR [CASE @D165772, COUNT @D165771, 
            PER @D165770, PLU @D165769, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : WATCH, 
   [COORD @D165777, AGR [COUNT @D165776, PER @D165775, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WATCH, 
   [COORD @D165779, AGR [COUNT @D165778, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WATCH, 
   [COORD @D165781, AGR [COUNT @D165780, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WATCH, 
   [COORD @D165785, AGR [COUNT @D165784, PER @D165783, PLU @D165782, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WATCH, 
   [COORD @D165791, PAST @D165790, AGR [CASE @D165789, COUNT @D165788, 
            PER @D165787, PLU @D165786, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WATCH, 
   [COORD @D165794, AGR [COUNT @D165793, PER @D165792, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165796, AGR [COUNT @D165795, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165798, AGR [COUNT @D165797, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165802, AGR [COUNT @D165801, PER @D165800, PLU @D165799, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165808, PAST @D165807, 
      AGR [CASE @D165806, COUNT @D165805, PER @D165804, PLU @D165803, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165811, AGR [COUNT @D165810, PER @D165809, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165813, AGR [COUNT @D165812, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165815, AGR [COUNT @D165814, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165819, AGR [COUNT @D165818, PER @D165817, PLU @D165816, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165825, PAST @D165824, 
      AGR [CASE @D165823, COUNT @D165822, PER @D165821, PLU @D165820, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT OUT, PFORM FOR, ARITY 2] : WATCH, 
   [COORD @D165828, AGR [COUNT @D165827, PER @D165826, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, ARITY 2] : WATCH, 
   [COORD @D165830, AGR [COUNT @D165829, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, ARITY 2] : WATCH, 
   [COORD @D165832, AGR [COUNT @D165831, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, ARITY 2] : WATCH, 
   [COORD @D165836, AGR [COUNT @D165835, PER @D165834, PLU @D165833, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM BY, ARITY 2] : WATCH, 
   [COORD @D165842, PAST @D165841, 
      AGR [CASE @D165840, COUNT @D165839, PER @D165838, PLU @D165837, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM BY, ARITY 2] : WATCH, 
   [COORD @D165845, AGR [COUNT @D165844, PER @D165843, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WATCH, 
   [COORD @D165847, AGR [COUNT @D165846, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WATCH, 
   [COORD @D165849, AGR [COUNT @D165848, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WATCH, 
   [COORD @D165853, AGR [COUNT @D165852, PER @D165851, PLU @D165850, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : WATCH, 
   [COORD @D165859, PAST @D165858, 
      AGR [CASE @D165857, COUNT @D165856, PER @D165855, PLU @D165854, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WATCH, 
   [COORD @D165862, AGR [COUNT @D165861, PER @D165860, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WATCH, 
   [COORD @D165864, AGR [COUNT @D165863, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WATCH, 
   [COORD @D165866, AGR [COUNT @D165865, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WATCH, 
   [COORD @D165870, AGR [COUNT @D165869, PER @D165868, PLU @D165867, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : WATCH, 
   [COORD @D165876, PAST @D165875, 
      AGR [CASE @D165874, COUNT @D165873, PER @D165872, PLU @D165871, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WATCH, 
   [COORD @D165879, AGR [COUNT @D165878, PER @D165877, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATCH, 
   [COORD @D165881, AGR [COUNT @D165880, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATCH, 
   [COORD @D165883, AGR [COUNT @D165882, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATCH, 
   [COORD @D165887, AGR [COUNT @D165886, PER @D165885, PLU @D165884, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATCH, 
   [COORD @D165893, PAST @D165892, AGR [CASE @D165891, COUNT @D165890, 
            PER @D165889, PLU @D165888, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WATCH, 
   [COORD @D165896, AGR [COUNT @D165895, PER @D165894, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WATCH, 
   [COORD @D165898, AGR [COUNT @D165897, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WATCH, 
   [COORD @D165900, AGR [COUNT @D165899, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WATCH, 
   [COORD @D165904, AGR [COUNT @D165903, PER @D165902, PLU @D165901, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WATCH, 
   [COORD @D165910, PAST @D165909, 
      AGR [CASE @D165908, COUNT @D165907, PER @D165906, PLU @D165905, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : WATCH, 
   [COORD @D165913, AGR [COUNT @D165912, PER @D165911, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WATCH, 
   [COORD @D165915, AGR [COUNT @D165914, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WATCH, 
   [COORD @D165917, AGR [COUNT @D165916, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WATCH, 
   [COORD @D165921, AGR [COUNT @D165920, PER @D165919, PLU @D165918, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WATCH, 
   [COORD @D165927, PAST @D165926, 
      AGR [CASE @D165925, COUNT @D165924, PER @D165923, PLU @D165922, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : WATCH.

WORD watched : 
   [COORD @D165937, AGR [CASE @D165936, COUNT @D165935, PER @D165934, 
            PLU @D165933, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_ING, CONJ NULL, SUBTYPE EQUI, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WATCH, 
   [COORD @D165942, AGR [CASE @D165941, COUNT @D165940, PER @D165939, 
            PLU @D165938, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165947, AGR [CASE @D165946, COUNT @D165945, PER @D165944, 
            PLU @D165943, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165952, AGR [CASE @D165951, COUNT @D165950, PER @D165949, 
            PLU @D165948, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165957, AGR [CASE @D165956, COUNT @D165955, PER @D165954, 
            PLU @D165953, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165962, AGR [CASE @D165961, COUNT @D165960, PER @D165959, 
            PLU @D165958, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE PVERB_OE, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165967, AGR [CASE @D165966, COUNT @D165965, PER @D165964, 
            PLU @D165963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165972, 
      AGR [CASE @D165971, COUNT @D165970, PER @D165969, PLU @D165968, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165977, AGR [CASE @D165976, COUNT @D165975, PER @D165974, 
            PLU @D165973, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165982, AGR [CASE @D165981, COUNT @D165980, PER @D165979, 
            PLU @D165978, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165987, AGR [CASE @D165986, COUNT @D165985, PER @D165984, 
            PLU @D165983, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165992, AGR [CASE @D165991, COUNT @D165990, PER @D165989, 
            PLU @D165988, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D165997, AGR [CASE @D165996, COUNT @D165995, PER @D165994, 
            PLU @D165993, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166002, AGR [CASE @D166001, COUNT @D166000, PER @D165999, 
            PLU @D165998, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166007, AGR [UB @D166006, VFORM @D166005, SUBJ @D166004, 
            FIN @D166003, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WATCH, 
   [COORD @D166012, AGR [CASE @D166011, COUNT @D166010, PER @D166009, 
            PLU @D166008, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166017, AGR [CASE @D166016, COUNT @D166015, PER @D166014, 
            PLU @D166013, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166022, AGR [CASE @D166021, COUNT @D166020, PER @D166019, 
            PLU @D166018, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WATCH, 
   [COORD @D166027, AGR [CASE @D166026, COUNT @D166025, PER @D166024, 
            PLU @D166023, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166032, AGR [CASE @D166031, COUNT @D166030, PER @D166029, 
            PLU @D166028, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166037, AGR [CASE @D166036, COUNT @D166035, PER @D166034, 
            PLU @D166033, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166042, AGR [CASE @D166041, COUNT @D166040, PER @D166039, 
            PLU @D166038, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166047, AGR [CASE @D166046, COUNT @D166045, PER @D166044, 
            PLU @D166043, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166052, AGR [CASE @D166051, COUNT @D166050, PER @D166049, 
            PLU @D166048, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166057, 
      AGR [CASE @D166056, COUNT @D166055, PER @D166054, PLU @D166053, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166062, AGR [CASE @D166061, COUNT @D166060, PER @D166059, 
            PLU @D166058, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT OUT, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166067, AGR [CASE @D166066, COUNT @D166065, PER @D166064, 
            PLU @D166063, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166072, AGR [CASE @D166071, COUNT @D166070, PER @D166069, 
            PLU @D166068, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BY, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166077, AGR [CASE @D166076, COUNT @D166075, PER @D166074, 
            PLU @D166073, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166082, AGR [CASE @D166081, COUNT @D166080, PER @D166079, 
            PLU @D166078, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166087, AGR [CASE @D166086, COUNT @D166085, PER @D166084, 
            PLU @D166083, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166092, AGR [CASE @D166091, COUNT @D166090, PER @D166089, 
            PLU @D166088, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166097, AGR [CASE @D166096, COUNT @D166095, PER @D166094, 
            PLU @D166093, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166102, AGR [CASE @D166101, COUNT @D166100, PER @D166099, 
            PLU @D166098, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166107, AGR [CASE @D166106, COUNT @D166105, PER @D166104, 
            PLU @D166103, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166112, AGR [CASE @D166111, COUNT @D166110, PER @D166109, 
            PLU @D166108, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166117, AGR [CASE @D166116, COUNT @D166115, PER @D166114, 
            PLU @D166113, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166122, AGR [CASE @D166121, COUNT @D166120, PER @D166119, 
            PLU @D166118, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166127, AGR [CASE @D166126, COUNT @D166125, PER @D166124, 
            PLU @D166123, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATCH.

WORD watches : 
   [COORD @D166136, REFL @D166135, PRD @D166134, CASE @D166133, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WATCHES, 
   [COORD @D166141, DEMON @D166140, REFL @D166139, PRD @D166138, 
      CASE @D166137, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WATCH, 
   [COORD @D166143, AGR [COUNT @D166142, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WATCH, 
   [COORD @D166145, AGR [COUNT @D166144, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WATCH, 
   [COORD @D166147, AGR [COUNT @D166146, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WATCH, 
   [COORD @D166149, AGR [COUNT @D166148, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166151, 
      AGR [COUNT @D166150, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166153, 
      AGR [COUNT @D166152, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166155, 
      AGR [COUNT @D166154, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166157, 
      AGR [COUNT @D166156, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166159, 
      AGR [COUNT @D166158, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166161, 
      AGR [COUNT @D166160, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WATCH, 
   [COORD @D166163, AGR [COUNT @D166162, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM BY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WATCH, 
   [COORD @D166165, AGR [COUNT @D166164, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WATCH, 
   [COORD @D166167, AGR [COUNT @D166166, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WATCH, 
   [COORD @D166169, AGR [COUNT @D166168, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166171, 
      AGR [COUNT @D166170, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH, 
   [COORD @D166173, 
      AGR [COUNT @D166172, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATCH.

WORD watcheses : 
   [COORD @D166186, DEMON @D166185, REFL @D166184, PRD @D166183, 
      CASE @D166182, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WATCHES.

WORD watching : 
   [COORD @D166201, PRD @D166200, AGR [CASE @D166199, COUNT @D166198, 
            PER @D166197, PLU @D166196, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, SUBCAT OC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166207, PRD @D166206, 
      AGR [CASE @D166205, COUNT @D166204, PER @D166203, PLU @D166202, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_BSE, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   WATCH, 
   [COORD @D166213, PRD @D166212, AGR [CASE @D166211, COUNT @D166210, 
            PER @D166209, PLU @D166208, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166219, PRD @D166218, 
      AGR [CASE @D166217, COUNT @D166216, PER @D166215, PLU @D166214, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WATCH, 
   [COORD @D166225, PRD @D166224, AGR [CASE @D166223, COUNT @D166222, 
            PER @D166221, PLU @D166220, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166231, PRD @D166230, 
      AGR [CASE @D166229, COUNT @D166228, PER @D166227, PLU @D166226, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WATCH, 
   [COORD @D166237, PRD @D166236, AGR [CASE @D166235, COUNT @D166234, 
            PER @D166233, PLU @D166232, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166243, PRD @D166242, 
      AGR [CASE @D166241, COUNT @D166240, PER @D166239, PLU @D166238, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WATCH, 
   [COORD @D166249, PRD @D166248, AGR [CASE @D166247, COUNT @D166246, 
            PER @D166245, PLU @D166244, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166255, PRD @D166254, 
      AGR [CASE @D166253, COUNT @D166252, PER @D166251, PLU @D166250, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT OUT, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WATCH, 
   [COORD @D166261, PRD @D166260, AGR [CASE @D166259, COUNT @D166258, 
            PER @D166257, PLU @D166256, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM BY, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166267, PRD @D166266, 
      AGR [CASE @D166265, COUNT @D166264, PER @D166263, PLU @D166262, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WATCH, 
   [COORD @D166273, PRD @D166272, AGR [CASE @D166271, COUNT @D166270, 
            PER @D166269, PLU @D166268, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166279, PRD @D166278, 
      AGR [CASE @D166277, COUNT @D166276, PER @D166275, PLU @D166274, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WATCH, 
   [COORD @D166285, PRD @D166284, AGR [CASE @D166283, COUNT @D166282, 
            PER @D166281, PLU @D166280, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WATCH, 
   [COORD @D166291, PRD @D166290, 
      AGR [CASE @D166289, COUNT @D166288, PER @D166287, PLU @D166286, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WATCH.

WORD water : 
   [COORD @D166303, REFL @D166302, PRD @D166301, CASE @D166300, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : WATER, 
   [COORD @D166306, AGR [COUNT @D166305, PER @D166304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WATER, 
   [COORD @D166308, AGR [COUNT @D166307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WATER, 
   [COORD @D166310, AGR [COUNT @D166309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WATER, 
   [COORD @D166314, AGR [COUNT @D166313, PER @D166312, PLU @D166311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WATER, 
   [COORD @D166320, PAST @D166319, AGR [CASE @D166318, COUNT @D166317, 
            PER @D166316, PLU @D166315, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WATER, 
   [COORD @D166323, AGR [COUNT @D166322, PER @D166321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : WATER, 
   [COORD @D166325, AGR [COUNT @D166324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : WATER, 
   [COORD @D166327, AGR [COUNT @D166326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : WATER, 
   [COORD @D166331, AGR [COUNT @D166330, PER @D166329, PLU @D166328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT DOWN, ARITY 2] : WATER, 
   [COORD @D166337, PAST @D166336, 
      AGR [CASE @D166335, COUNT @D166334, PER @D166333, PLU @D166332, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT DOWN, ARITY 2] : WATER, 
   [COORD @D166340, AGR [COUNT @D166339, PER @D166338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATER, 
   [COORD @D166342, AGR [COUNT @D166341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATER, 
   [COORD @D166344, AGR [COUNT @D166343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATER, 
   [COORD @D166348, AGR [COUNT @D166347, PER @D166346, PLU @D166345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WATER, 
   [COORD @D166354, PAST @D166353, AGR [CASE @D166352, COUNT @D166351, 
            PER @D166350, PLU @D166349, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WATER, 
   [COORD @D166357, AGR [COUNT @D166356, PER @D166355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : WATER, 
   [COORD @D166359, AGR [COUNT @D166358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : WATER, 
   [COORD @D166361, AGR [COUNT @D166360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : WATER, 
   [COORD @D166365, AGR [COUNT @D166364, PER @D166363, PLU @D166362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT DOWN, ARITY 1] : WATER, 
   [COORD @D166371, PAST @D166370, 
      AGR [CASE @D166369, COUNT @D166368, PER @D166367, PLU @D166366, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT DOWN, ARITY 1] : WATER.

WORD watered : 
   [COORD @D166381, AGR [CASE @D166380, COUNT @D166379, PER @D166378, 
            PLU @D166377, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WATER, 
   [COORD @D166386, AGR [CASE @D166385, COUNT @D166384, PER @D166383, 
            PLU @D166382, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATER, 
   [COORD @D166391, AGR [CASE @D166390, COUNT @D166389, PER @D166388, 
            PLU @D166387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATER, 
   [COORD @D166396, AGR [CASE @D166395, COUNT @D166394, PER @D166393, 
            PLU @D166392, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATER, 
   [COORD @D166401, AGR [CASE @D166400, COUNT @D166399, PER @D166398, 
            PLU @D166397, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATER, 
   [COORD @D166406, AGR [CASE @D166405, COUNT @D166404, PER @D166403, 
            PLU @D166402, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATER, 
   [COORD @D166411, AGR [CASE @D166410, COUNT @D166409, PER @D166408, 
            PLU @D166407, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WATER, 
   [COORD @D166416, AGR [CASE @D166415, COUNT @D166414, PER @D166413, 
            PLU @D166412, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WATER, 
   [COORD @D166421, AGR [CASE @D166420, COUNT @D166419, PER @D166418, 
            PLU @D166417, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATER, 
   [COORD @D166426, AGR [CASE @D166425, COUNT @D166424, PER @D166423, 
            PLU @D166422, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WATER.

WORD watering : 
   [COORD @D166439, PRD @D166438, AGR [CASE @D166437, COUNT @D166436, 
            PER @D166435, PLU @D166434, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATER, 
   [COORD @D166445, PRD @D166444, 
      AGR [CASE @D166443, COUNT @D166442, PER @D166441, PLU @D166440, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WATER, 
   [COORD @D166451, PRD @D166450, AGR [CASE @D166449, COUNT @D166448, 
            PER @D166447, PLU @D166446, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WATER, 
   [COORD @D166457, PRD @D166456, 
      AGR [CASE @D166455, COUNT @D166454, PER @D166453, PLU @D166452, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WATER.

WORD waters : 
   [COORD @D166466, REFL @D166465, PRD @D166464, CASE @D166463, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WATERS, 
   [COORD @D166470, REFL @D166469, PRD @D166468, CASE @D166467, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : WATERS, 
   [COORD @D166472, 
      AGR [COUNT @D166471, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATER, 
   [COORD @D166474, 
      AGR [COUNT @D166473, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATER, 
   [COORD @D166476, 
      AGR [COUNT @D166475, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATER, 
   [COORD @D166478, 
      AGR [COUNT @D166477, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WATER.

WORD waterses : 
   [COORD @D166491, DEMON @D166490, REFL @D166489, PRD @D166488, 
      CASE @D166487, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WATERS.

WORD wept : 
   [COORD @D166501, PAST @D166500, AGR [CASE @D166499, COUNT @D166498, 
            PER @D166497, PLU @D166496, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, FIN -, ARITY 3] : WEEP, 
   [COORD @D166507, PAST @D166506, 
      AGR [CASE @D166505, COUNT @D166504, PER @D166503, PLU @D166502, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, REG -, FIN -, 
      ARITY 3] : WEEP, 
   [COORD @D166511, AGR [COUNT @D166510, PER @D166509, PLU @D166508, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PAST +, ARITY 3] : WEEP, 
   [COORD @D166517, PAST @D166516, 
      AGR [CASE @D166515, COUNT @D166514, PER @D166513, PLU @D166512, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : WEEP, 
   [COORD @D166523, PAST @D166522, AGR [CASE @D166521, COUNT @D166520, 
            PER @D166519, PLU @D166518, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : WEEP, 
   [COORD @D166529, PAST @D166528, 
      AGR [CASE @D166527, COUNT @D166526, PER @D166525, PLU @D166524, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PFORM OVER, 
      FIN -, ARITY 2] : WEEP, 
   [COORD @D166533, AGR [COUNT @D166532, PER @D166531, PLU @D166530, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PAST +, ARITY 2] : WEEP, 
   [COORD @D166537, AGR [COUNT @D166536, PER @D166535, PLU @D166534, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, REG -, PFORM OVER, PAST +, ARITY 2] : WEEP, 
   [COORD @D166543, PAST @D166542, 
      AGR [CASE @D166541, COUNT @D166540, PER @D166539, PLU @D166538, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : WEEP, 
   [COORD @D166547, AGR [COUNT @D166546, PER @D166545, PLU @D166544, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PAST +, ARITY 1] : WEEP.

WORD will : 
   [COORD @D166572, SUBTYPE @D166571, AGR @D166570, FIX NOT, V +, N -, 
      VFORM NOT, AUX +, NEG -, CONEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, 
      CONJ NULL, AT +, LAT +, PAST FUT, PRO +, SUBCAT NULL, INV -] : 
   (lambda (Q) 
         (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2) (lambda 
               (qu) qu))), 
   [COORD @D166575, INV @D166574, AGR @D166573, FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, PRO -, AUX +, NEG -, CONEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PAST FUT, SUBCAT FUT] : NIL, 
   [COORD @D166579, REFL @D166578, PRD @D166577, CASE @D166576, FIX NOT, 
      N +, V -, POSS -, PRO -, PROTYPE NONE, BAR 0, PN -, PLU -, NFORM NORM, 
      PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF] : WILL, 
   [COORD @D166583, REFL @D166582, PRD @D166581, CASE @D166580, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WILL, 
   [COORD @D166588, REFL @D166587, COUNT @D166586, PRD @D166585, 
      CASE @D166584, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : WILL, 
   [COORD @D166591, 
      AGR [COUNT @D166590, PER @D166589, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   WILL, 
   [COORD @D166593, AGR [COUNT @D166592, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : WILL, 
   [COORD @D166595, AGR [COUNT @D166594, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : WILL, 
   [COORD @D166599, AGR [COUNT @D166598, PER @D166597, PLU @D166596, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : WILL, 
   [COORD @D166605, PAST @D166604, AGR [CASE @D166603, COUNT @D166602, 
            PER @D166601, PLU @D166600, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : WILL, 
   [COORD @D166608, AGR [COUNT @D166607, PER @D166606, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WILL, 
   [COORD @D166610, AGR [COUNT @D166609, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WILL, 
   [COORD @D166612, AGR [COUNT @D166611, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WILL, 
   [COORD @D166616, AGR [COUNT @D166615, PER @D166614, PLU @D166613, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WILL, 
   [COORD @D166622, PAST @D166621, 
      AGR [CASE @D166620, COUNT @D166619, PER @D166618, PLU @D166617, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : WILL, 
   [COORD @D166625, AGR [COUNT @D166624, PER @D166623, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WILL, 
   [COORD @D166627, AGR [COUNT @D166626, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WILL, 
   [COORD @D166629, AGR [COUNT @D166628, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WILL, 
   [COORD @D166633, AGR [COUNT @D166632, PER @D166631, PLU @D166630, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WILL, 
   [COORD @D166639, PAST @D166638, AGR [CASE @D166637, COUNT @D166636, 
            PER @D166635, PLU @D166634, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : WILL, 
   [COORD @D166642, AGR [COUNT @D166641, PER @D166640, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WILL, 
   [COORD @D166644, AGR [COUNT @D166643, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WILL, 
   [COORD @D166646, AGR [COUNT @D166645, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WILL, 
   [COORD @D166650, AGR [COUNT @D166649, PER @D166648, PLU @D166647, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WILL, 
   [COORD @D166656, PAST @D166655, AGR [CASE @D166654, COUNT @D166653, 
            PER @D166652, PLU @D166651, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : WILL, 
   [COORD @D166659, AGR [COUNT @D166658, PER @D166657, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WILL, 
   [COORD @D166661, AGR [COUNT @D166660, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WILL, 
   [COORD @D166663, AGR [COUNT @D166662, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WILL, 
   [COORD @D166667, AGR [COUNT @D166666, PER @D166665, PLU @D166664, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WILL, 
   [COORD @D166673, PAST @D166672, AGR [CASE @D166671, COUNT @D166670, 
            PER @D166669, PLU @D166668, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WILL.

WORD willed : 
   [COORD @D166686, AGR [CASE @D166685, COUNT @D166684, PER @D166683, 
            PLU @D166682, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WILL, 
   [COORD @D166691, AGR [CASE @D166690, COUNT @D166689, PER @D166688, 
            PLU @D166687, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166696, AGR [CASE @D166695, COUNT @D166694, PER @D166693, 
            PLU @D166692, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WILL, 
   [COORD @D166701, AGR [CASE @D166700, COUNT @D166699, PER @D166698, 
            PLU @D166697, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166706, AGR [CASE @D166705, COUNT @D166704, PER @D166703, 
            PLU @D166702, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166711, AGR [CASE @D166710, COUNT @D166709, PER @D166708, 
            PLU @D166707, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WILL, 
   [COORD @D166716, AGR [UB @D166715, VFORM @D166714, SUBJ @D166713, 
            FIN @D166712, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WILL, 
   [COORD @D166721, AGR [CASE @D166720, COUNT @D166719, PER @D166718, 
            PLU @D166717, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166726, AGR [CASE @D166725, COUNT @D166724, PER @D166723, 
            PLU @D166722, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WILL, 
   [COORD @D166731, AGR [CASE @D166730, COUNT @D166729, PER @D166728, 
            PLU @D166727, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166736, AGR [CASE @D166735, COUNT @D166734, PER @D166733, 
            PLU @D166732, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WILL, 
   [COORD @D166742, AGR [CASE @D166741, NFORM @D166740, COUNT @D166739, 
            PER @D166738, PLU @D166737, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WILL, 
   [COORD @D166747, AGR [UB @D166746, VFORM @D166745, SUBJ @D166744, 
            FIN @D166743, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WILL, 
   [COORD @D166752, AGR [CASE @D166751, COUNT @D166750, PER @D166749, 
            PLU @D166748, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WILL, 
   [COORD @D166757, AGR [CASE @D166756, COUNT @D166755, PER @D166754, 
            PLU @D166753, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166762, AGR [CASE @D166761, COUNT @D166760, PER @D166759, 
            PLU @D166758, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WILL.

WORD willing : 
   [COORD @D166782, PRD @D166781, AGR [CASE @D166780, COUNT @D166779, 
            PER @D166778, PLU @D166777, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166788, PRD @D166787, 
      AGR [CASE @D166786, COUNT @D166785, PER @D166784, PLU @D166783, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WILL, 
   [COORD @D166794, PRD @D166793, AGR [CASE @D166792, COUNT @D166791, 
            PER @D166790, PLU @D166789, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WILL, 
   [COORD @D166800, PRD @D166799, 
      AGR [CASE @D166798, COUNT @D166797, PER @D166796, PLU @D166795, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   WILL, 
   [COORD @D166806, PRD @D166805, AGR [CASE @D166804, COUNT @D166803, 
            PER @D166802, PLU @D166801, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WILL.

WORD wills : 
   [COORD @D166819, DEMON @D166818, REFL @D166817, PRD @D166816, 
      CASE @D166815, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WILL, 
   [COORD @D166821, AGR [COUNT @D166820, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WILL, 
   [COORD @D166823, 
      AGR [COUNT @D166822, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WILL, 
   [COORD @D166825, 
      AGR [COUNT @D166824, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WILL, 
   [COORD @D166827, 
      AGR [COUNT @D166826, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WILL, 
   [COORD @D166829, 
      AGR [COUNT @D166828, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WILL.

WORD win : 
   [COORD @D166836, REFL @D166835, PRD @D166834, CASE @D166833, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WIN, 
   [COORD @D166839, 
      AGR [COUNT @D166838, PER @D166837, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, ARITY 3] : 
   WIN, 
   [COORD @D166841, AGR [COUNT @D166840, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : WIN, 
   [COORD @D166843, AGR [COUNT @D166842, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : WIN, 
   [COORD @D166847, AGR [COUNT @D166846, PER @D166845, PLU @D166844, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : WIN, 
   [COORD @D166853, PAST @D166852, 
      AGR [CASE @D166851, COUNT @D166850, PER @D166849, PLU @D166848, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : WIN, 
   [COORD @D166856, AGR [COUNT @D166855, PER @D166854, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : WIN, 
   [COORD @D166858, AGR [COUNT @D166857, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : WIN, 
   [COORD @D166860, AGR [COUNT @D166859, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      REG -, PRT OVER, PFORM TO, ARITY 3] : WIN, 
   [COORD @D166864, AGR [COUNT @D166863, PER @D166862, PLU @D166861, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT OVER, PFORM TO, ARITY 3] : WIN, 
   [COORD @D166870, PAST @D166869, 
      AGR [CASE @D166868, COUNT @D166867, PER @D166866, PLU @D166865, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, 
      PRT OVER, PFORM TO, ARITY 3] : WIN, 
   [COORD @D166873, AGR [COUNT @D166872, PER @D166871, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : WIN, 
   [COORD @D166875, AGR [COUNT @D166874, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : WIN, 
   [COORD @D166877, AGR [COUNT @D166876, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : WIN, 
   [COORD @D166881, AGR [COUNT @D166880, PER @D166879, PLU @D166878, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, ARITY 3] : WIN, 
   [COORD @D166887, PAST @D166886, 
      AGR [CASE @D166885, COUNT @D166884, PER @D166883, PLU @D166882, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM FOR, ARITY 3] : WIN, 
   [COORD @D166890, AGR [COUNT @D166889, PER @D166888, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : WIN, 
   [COORD @D166892, AGR [COUNT @D166891, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : WIN, 
   [COORD @D166894, AGR [COUNT @D166893, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : WIN, 
   [COORD @D166898, AGR [COUNT @D166897, PER @D166896, PLU @D166895, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : WIN, 
   [COORD @D166904, PAST @D166903, AGR [CASE @D166902, COUNT @D166901, 
            PER @D166900, PLU @D166899, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : WIN, 
   [COORD @D166907, AGR [COUNT @D166906, PER @D166905, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OVER, ARITY 2] : WIN, 
   [COORD @D166909, AGR [COUNT @D166908, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OVER, ARITY 2] : WIN, 
   [COORD @D166911, AGR [COUNT @D166910, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      PRT OVER, ARITY 2] : WIN, 
   [COORD @D166915, AGR [COUNT @D166914, PER @D166913, PLU @D166912, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, PRT OVER, ARITY 2] : WIN, 
   [COORD @D166921, PAST @D166920, AGR [CASE @D166919, COUNT @D166918, 
            PER @D166917, PLU @D166916, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, PRT OVER, ARITY 2] : WIN, 
   [COORD @D166924, 
      AGR [COUNT @D166923, PER @D166922, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, 
      ARITY 2] : WIN, 
   [COORD @D166926, AGR [COUNT @D166925, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : WIN, 
   [COORD @D166928, AGR [COUNT @D166927, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : WIN, 
   [COORD @D166932, AGR [COUNT @D166931, PER @D166930, PLU @D166929, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, ARITY 2] : WIN, 
   [COORD @D166938, PAST @D166937, 
      AGR [CASE @D166936, COUNT @D166935, PER @D166934, PLU @D166933, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, ARITY 2] : WIN, 
   [COORD @D166941, AGR [COUNT @D166940, PER @D166939, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : WIN, 
   [COORD @D166943, AGR [COUNT @D166942, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : WIN, 
   [COORD @D166945, AGR [COUNT @D166944, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : WIN, 
   [COORD @D166949, AGR [COUNT @D166948, PER @D166947, PLU @D166946, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : WIN, 
   [COORD @D166955, PAST @D166954, 
      AGR [CASE @D166953, COUNT @D166952, PER @D166951, PLU @D166950, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : WIN, 
   [COORD @D166958, AGR [COUNT @D166957, PER @D166956, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : WIN, 
   [COORD @D166960, AGR [COUNT @D166959, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : WIN, 
   [COORD @D166962, AGR [COUNT @D166961, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT THROUGH, ARITY 1] : WIN, 
   [COORD @D166966, AGR [COUNT @D166965, PER @D166964, PLU @D166963, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, ARITY 1] : WIN, 
   [COORD @D166972, PAST @D166971, 
      AGR [CASE @D166970, COUNT @D166969, PER @D166968, PLU @D166967, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT THROUGH, ARITY 1] : WIN, 
   [COORD @D166975, AGR [COUNT @D166974, PER @D166973, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : WIN, 
   [COORD @D166977, AGR [COUNT @D166976, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : WIN, 
   [COORD @D166979, AGR [COUNT @D166978, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OVER, ARITY 1] : WIN, 
   [COORD @D166983, AGR [COUNT @D166982, PER @D166981, PLU @D166980, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OVER, ARITY 1] : WIN, 
   [COORD @D166989, PAST @D166988, 
      AGR [CASE @D166987, COUNT @D166986, PER @D166985, PLU @D166984, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, ARITY 1] : WIN, 
   [COORD @D166992, AGR [COUNT @D166991, PER @D166990, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : WIN, 
   [COORD @D166994, AGR [COUNT @D166993, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : WIN, 
   [COORD @D166996, AGR [COUNT @D166995, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : WIN, 
   [COORD @D167000, AGR [COUNT @D166999, PER @D166998, PLU @D166997, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : WIN, 
   [COORD @D167006, PAST @D167005, 
      AGR [CASE @D167004, COUNT @D167003, PER @D167002, PLU @D167001, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, ARITY 1] : WIN.

WORD winning : 
   [COORD @D167024, PRD @D167023, AGR [CASE @D167022, COUNT @D167021, 
            PER @D167020, PLU @D167019, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WIN, 
   [COORD @D167030, PRD @D167029, 
      AGR [CASE @D167028, COUNT @D167027, PER @D167026, PLU @D167025, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PRT OVER, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WIN, 
   [COORD @D167036, PRD @D167035, 
      AGR [CASE @D167034, COUNT @D167033, PER @D167032, PLU @D167031, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WIN, 
   [COORD @D167042, PRD @D167041, AGR [CASE @D167040, COUNT @D167039, 
            PER @D167038, PLU @D167037, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WIN, 
   [COORD @D167048, PRD @D167047, 
      AGR [CASE @D167046, COUNT @D167045, PER @D167044, PLU @D167043, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WIN, 
   [COORD @D167054, PRD @D167053, AGR [CASE @D167052, COUNT @D167051, 
            PER @D167050, PLU @D167049, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WIN, 
   [COORD @D167060, PRD @D167059, 
      AGR [CASE @D167058, COUNT @D167057, PER @D167056, PLU @D167055, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WIN, 
   [COORD @D167066, PRD @D167065, AGR [CASE @D167064, COUNT @D167063, 
            PER @D167062, PLU @D167061, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, 
      PRT THROUGH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WIN, 
   [COORD @D167072, PRD @D167071, 
      AGR [CASE @D167070, COUNT @D167069, PER @D167068, PLU @D167067, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WIN, 
   [COORD @D167078, PRD @D167077, AGR [CASE @D167076, COUNT @D167075, 
            PER @D167074, PLU @D167073, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WIN.

WORD wins : 
   [COORD @D167088, DEMON @D167087, REFL @D167086, PRD @D167085, 
      CASE @D167084, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WIN, 
   [COORD @D167090, AGR [COUNT @D167089, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WIN, 
   [COORD @D167092, 
      AGR [COUNT @D167091, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_PP, PRT OVER, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WIN, 
   [COORD @D167094, AGR [COUNT @D167093, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WIN, 
   [COORD @D167096, AGR [COUNT @D167095, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WIN, 
   [COORD @D167098, 
      AGR [COUNT @D167097, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WIN, 
   [COORD @D167100, 
      AGR [COUNT @D167099, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, 
      CONJ NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WIN, 
   [COORD @D167102, 
      AGR [COUNT @D167101, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WIN, 
   [COORD @D167104, 
      AGR [COUNT @D167103, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT THROUGH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WIN, 
   [COORD @D167106, AGR [COUNT @D167105, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WIN, 
   [COORD @D167108, AGR [COUNT @D167107, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WIN.

WORD wish : 
   [COORD @D167115, REFL @D167114, PRD @D167113, CASE @D167112, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WISH, 
   [COORD @D167119, REFL @D167118, PRD @D167117, CASE @D167116, FIX NOT, 
      INFL +, BAR 0, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBCAT VPINF, COUNT +] : WISH, 
   [COORD @D167122, 
      AGR [COUNT @D167121, PER @D167120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : 
   WISH, 
   [COORD @D167124, AGR [COUNT @D167123, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : WISH, 
   [COORD @D167126, AGR [COUNT @D167125, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : WISH, 
   [COORD @D167130, AGR [COUNT @D167129, PER @D167128, PLU @D167127, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, ARITY 3] : WISH, 
   [COORD @D167136, PAST @D167135, AGR [CASE @D167134, COUNT @D167133, 
            PER @D167132, PLU @D167131, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_NP, ARITY 3] : WISH, 
   [COORD @D167139, AGR [COUNT @D167138, PER @D167137, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WISH, 
   [COORD @D167141, AGR [COUNT @D167140, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WISH, 
   [COORD @D167143, AGR [COUNT @D167142, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WISH, 
   [COORD @D167147, AGR [COUNT @D167146, PER @D167145, PLU @D167144, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, ARITY 3] : WISH, 
   [COORD @D167153, PAST @D167152, 
      AGR [CASE @D167151, COUNT @D167150, PER @D167149, PLU @D167148, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, ARITY 3] : WISH, 
   [COORD @D167156, AGR [COUNT @D167155, PER @D167154, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : WISH, 
   [COORD @D167158, AGR [COUNT @D167157, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : WISH, 
   [COORD @D167160, AGR [COUNT @D167159, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : WISH, 
   [COORD @D167164, AGR [COUNT @D167163, PER @D167162, PLU @D167161, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, ARITY 3] : WISH, 
   [COORD @D167170, PAST @D167169, 
      AGR [CASE @D167168, COUNT @D167167, PER @D167166, PLU @D167165, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, ARITY 3] : WISH, 
   [COORD @D167173, AGR [COUNT @D167172, PER @D167171, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WISH, 
   [COORD @D167175, AGR [COUNT @D167174, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WISH, 
   [COORD @D167177, AGR [COUNT @D167176, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WISH, 
   [COORD @D167181, AGR [COUNT @D167180, PER @D167179, PLU @D167178, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WISH, 
   [COORD @D167187, PAST @D167186, AGR [CASE @D167185, COUNT @D167184, 
            PER @D167183, PLU @D167182, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : WISH, 
   [COORD @D167190, AGR [COUNT @D167189, PER @D167188, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WISH, 
   [COORD @D167192, AGR [COUNT @D167191, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WISH, 
   [COORD @D167194, AGR [COUNT @D167193, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WISH, 
   [COORD @D167198, AGR [COUNT @D167197, PER @D167196, PLU @D167195, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, ARITY 2] : WISH, 
   [COORD @D167204, PAST @D167203, AGR [CASE @D167202, COUNT @D167201, 
            PER @D167200, PLU @D167199, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : WISH, 
   [COORD @D167207, AGR [COUNT @D167206, PER @D167205, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : WISH, 
   [COORD @D167209, AGR [COUNT @D167208, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : WISH, 
   [COORD @D167211, AGR [COUNT @D167210, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : WISH, 
   [COORD @D167215, AGR [COUNT @D167214, PER @D167213, PLU @D167212, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SBSE, ARITY 2] : WISH, 
   [COORD @D167221, PAST @D167220, AGR [CASE @D167219, COUNT @D167218, 
            PER @D167217, PLU @D167216, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SBSE, ARITY 2] : WISH, 
   [COORD @D167224, AGR [COUNT @D167223, PER @D167222, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WISH, 
   [COORD @D167226, AGR [COUNT @D167225, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WISH, 
   [COORD @D167228, AGR [COUNT @D167227, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WISH, 
   [COORD @D167232, AGR [COUNT @D167231, PER @D167230, PLU @D167229, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_INF, ARITY 2] : WISH, 
   [COORD @D167238, PAST @D167237, AGR [CASE @D167236, COUNT @D167235, 
            PER @D167234, PLU @D167233, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, ARITY 2] : WISH, 
   [COORD @D167241, AGR [COUNT @D167240, PER @D167239, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WISH, 
   [COORD @D167243, AGR [COUNT @D167242, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WISH, 
   [COORD @D167245, AGR [COUNT @D167244, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WISH, 
   [COORD @D167249, AGR [COUNT @D167248, PER @D167247, PLU @D167246, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, 
      SUBCAT OC_AP, ARITY 2] : WISH, 
   [COORD @D167255, PAST @D167254, AGR [CASE @D167253, COUNT @D167252, 
            PER @D167251, PLU @D167250, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, ARITY 2] : WISH, 
   [COORD @D167258, AGR [COUNT @D167257, PER @D167256, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WISH, 
   [COORD @D167260, AGR [COUNT @D167259, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WISH, 
   [COORD @D167262, AGR [COUNT @D167261, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WISH, 
   [COORD @D167266, AGR [COUNT @D167265, PER @D167264, PLU @D167263, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WISH, 
   [COORD @D167272, PAST @D167271, AGR [CASE @D167270, COUNT @D167269, 
            PER @D167268, PLU @D167267, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WISH, 
   [COORD @D167275, AGR [COUNT @D167274, PER @D167273, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WISH, 
   [COORD @D167277, AGR [COUNT @D167276, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WISH, 
   [COORD @D167279, AGR [COUNT @D167278, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WISH, 
   [COORD @D167283, AGR [COUNT @D167282, PER @D167281, PLU @D167280, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM FOR, ARITY 2] : WISH, 
   [COORD @D167289, PAST @D167288, 
      AGR [CASE @D167287, COUNT @D167286, PER @D167285, PLU @D167284, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM FOR, ARITY 2] : WISH, 
   [COORD @D167292, AGR [COUNT @D167291, PER @D167290, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WISH, 
   [COORD @D167294, AGR [COUNT @D167293, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WISH, 
   [COORD @D167296, AGR [COUNT @D167295, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WISH, 
   [COORD @D167300, AGR [COUNT @D167299, PER @D167298, PLU @D167297, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WISH, 
   [COORD @D167306, PAST @D167305, AGR [CASE @D167304, COUNT @D167303, 
            PER @D167302, PLU @D167301, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WISH.

WORD wished : 
   [COORD @D167316, AGR [CASE @D167315, COUNT @D167314, PER @D167313, 
            PLU @D167312, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WISH, 
   [COORD @D167321, AGR [CASE @D167320, COUNT @D167319, PER @D167318, 
            PLU @D167317, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167326, AGR [CASE @D167325, COUNT @D167324, PER @D167323, 
            PLU @D167322, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167331, AGR [CASE @D167330, COUNT @D167329, PER @D167328, 
            PLU @D167327, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE DMOVT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167336, AGR [CASE @D167335, COUNT @D167334, PER @D167333, 
            PLU @D167332, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167341, AGR [CASE @D167340, COUNT @D167339, PER @D167338, 
            PLU @D167337, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167346, AGR [CASE @D167345, COUNT @D167344, PER @D167343, 
            PLU @D167342, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM ON, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167351, AGR [CASE @D167350, COUNT @D167349, PER @D167348, 
            PLU @D167347, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167356, AGR [CASE @D167355, COUNT @D167354, PER @D167353, 
            PLU @D167352, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM ON, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167361, AGR [UB @D167360, VFORM @D167359, SUBJ @D167358, 
            FIN @D167357, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WISH, 
   [COORD @D167366, AGR [CASE @D167365, COUNT @D167364, PER @D167363, 
            PLU @D167362, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167371, AGR [CASE @D167370, COUNT @D167369, PER @D167368, 
            PLU @D167367, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167376, AGR [CASE @D167375, COUNT @D167374, PER @D167373, 
            PLU @D167372, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167381, AGR [CASE @D167380, COUNT @D167379, PER @D167378, 
            PLU @D167377, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167386, AGR [CASE @D167385, COUNT @D167384, PER @D167383, 
            PLU @D167382, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167391, AGR [CASE @D167390, COUNT @D167389, PER @D167388, 
            PLU @D167387, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167397, AGR [CASE @D167396, NFORM @D167395, COUNT @D167394, 
            PER @D167393, PLU @D167392, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WISH, 
   [COORD @D167402, AGR [UB @D167401, VFORM @D167400, SUBJ @D167399, 
            FIN @D167398, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_INF, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WISH, 
   [COORD @D167407, AGR [CASE @D167406, COUNT @D167405, PER @D167404, 
            PLU @D167403, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167412, AGR [CASE @D167411, COUNT @D167410, PER @D167409, 
            PLU @D167408, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167417, AGR [CASE @D167416, COUNT @D167415, PER @D167414, 
            PLU @D167413, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167422, AGR [CASE @D167421, COUNT @D167420, PER @D167419, 
            PLU @D167418, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167428, AGR [CASE @D167427, NFORM @D167426, COUNT @D167425, 
            PER @D167424, PLU @D167423, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WISH, 
   [COORD @D167433, AGR [UB @D167432, VFORM @D167431, SUBJ @D167430, 
            FIN @D167429, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE RAIS, SUBCAT OC_AP, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WISH, 
   [COORD @D167438, AGR [CASE @D167437, COUNT @D167436, PER @D167435, 
            PLU @D167434, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167443, AGR [CASE @D167442, COUNT @D167441, PER @D167440, 
            PLU @D167439, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167448, AGR [CASE @D167447, COUNT @D167446, PER @D167445, 
            PLU @D167444, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WISH, 
   [COORD @D167453, AGR [CASE @D167452, COUNT @D167451, PER @D167450, 
            PLU @D167449, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167458, AGR [CASE @D167457, COUNT @D167456, PER @D167455, 
            PLU @D167454, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WISH, 
   [COORD @D167463, AGR [CASE @D167462, COUNT @D167461, PER @D167460, 
            PLU @D167459, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167468, AGR [CASE @D167467, COUNT @D167466, PER @D167465, 
            PLU @D167464, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WISH.

WORD wishes : 
   [COORD @D167478, DEMON @D167477, REFL @D167476, PRD @D167475, 
      CASE @D167474, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WISH, 
   [COORD @D167483, DEMON @D167482, REFL @D167481, PRD @D167480, 
      CASE @D167479, COMPOUND NOT, FIX NOT, PN -, ADV -, PART -, CONJ NULL, 
      SUBCAT VPINF, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, INFL -, 
      PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : WISH, 
   [COORD @D167485, 
      AGR [COUNT @D167484, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167487, 
      AGR [COUNT @D167486, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, 
      SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167489, 
      AGR [COUNT @D167488, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167491, 
      AGR [COUNT @D167490, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167493, 
      AGR [COUNT @D167492, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167495, 
      AGR [COUNT @D167494, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167497, 
      AGR [COUNT @D167496, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167499, 
      AGR [COUNT @D167498, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, 
      SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167501, 
      AGR [COUNT @D167500, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167503, 
      AGR [COUNT @D167502, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH, 
   [COORD @D167505, 
      AGR [COUNT @D167504, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WISH.

WORD wishing : 
   [COORD @D167520, PRD @D167519, AGR [CASE @D167518, COUNT @D167517, 
            PER @D167516, PLU @D167515, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167526, PRD @D167525, 
      AGR [CASE @D167524, COUNT @D167523, PER @D167522, PLU @D167521, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WISH, 
   [COORD @D167532, PRD @D167531, AGR [CASE @D167530, COUNT @D167529, 
            PER @D167528, PLU @D167527, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM ON, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167538, PRD @D167537, 
      AGR [CASE @D167536, COUNT @D167535, PER @D167534, PLU @D167533, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WISH, 
   [COORD @D167544, PRD @D167543, AGR [CASE @D167542, COUNT @D167541, 
            PER @D167540, PLU @D167539, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167550, PRD @D167549, 
      AGR [CASE @D167548, COUNT @D167547, PER @D167546, PLU @D167545, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SBSE, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WISH, 
   [COORD @D167556, PRD @D167555, AGR [CASE @D167554, COUNT @D167553, 
            PER @D167552, PLU @D167551, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE RAIS, SUBCAT OC_INF, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167562, PRD @D167561, 
      AGR [CASE @D167560, COUNT @D167559, PER @D167558, PLU @D167557, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE RAIS, SUBCAT OC_AP, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, 
      VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : 
   WISH, 
   [COORD @D167568, PRD @D167567, AGR [CASE @D167566, COUNT @D167565, 
            PER @D167564, PLU @D167563, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH, 
   [COORD @D167574, PRD @D167573, 
      AGR [CASE @D167572, COUNT @D167571, PER @D167570, PLU @D167569, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM FOR, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WISH, 
   [COORD @D167580, PRD @D167579, AGR [CASE @D167578, COUNT @D167577, 
            PER @D167576, PLU @D167575, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WISH.

WORD won : 
   [COORD @D167594, PAST @D167593, AGR [CASE @D167592, COUNT @D167591, 
            PER @D167590, PLU @D167589, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, FIN -, ARITY 3] : WIN, 
   [COORD @D167600, PAST @D167599, 
      AGR [CASE @D167598, COUNT @D167597, PER @D167596, PLU @D167595, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, FIN -, 
      ARITY 3] : WIN, 
   [COORD @D167606, PAST @D167605, AGR [CASE @D167604, COUNT @D167603, 
            PER @D167602, PLU @D167601, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, 
      PRO -, NEG -, INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT OVER, PFORM TO, FIN -, ARITY 3] : WIN, 
   [COORD @D167612, PAST @D167611, 
      AGR [CASE @D167610, COUNT @D167609, PER @D167608, PLU @D167607, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT OVER, 
      PFORM TO, FIN -, ARITY 3] : WIN, 
   [COORD @D167618, PAST @D167617, AGR [CASE @D167616, COUNT @D167615, 
            PER @D167614, PLU @D167613, N +, V -, BAR 2, NFORM NORM], 
      VFORM EN, PSVE +, PRD +, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM FOR, FIN -, ARITY 3] : WIN, 
   [COORD @D167624, PAST @D167623, 
      AGR [CASE @D167622, COUNT @D167621, PER @D167620, PLU @D167619, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, 
      LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, PFORM FOR, 
      FIN -, ARITY 3] : WIN, 
   [COORD @D167628, AGR [COUNT @D167627, PER @D167626, PLU @D167625, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, PAST +, ARITY 3] : WIN, 
   [COORD @D167632, AGR [COUNT @D167631, PER @D167630, PLU @D167629, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PRT OVER, PFORM TO, PAST +, ARITY 3] : WIN, 
   [COORD @D167636, 
      AGR [COUNT @D167635, PER @D167634, PLU @D167633, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, 
      AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, REG -, 
      PFORM FOR, PAST +, ARITY 3] : WIN, 
   [COORD @D167642, PAST @D167641, 
      AGR [CASE @D167640, COUNT @D167639, PER @D167638, PLU @D167637, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : WIN, 
   [COORD @D167648, PAST @D167647, AGR [CASE @D167646, COUNT @D167645, 
            PER @D167644, PLU @D167643, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : WIN, 
   [COORD @D167654, PAST @D167653, 
      AGR [CASE @D167652, COUNT @D167651, PER @D167650, PLU @D167649, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT OVER, 
      FIN -, ARITY 2] : WIN, 
   [COORD @D167660, PAST @D167659, AGR [CASE @D167658, COUNT @D167657, 
            PER @D167656, PLU @D167655, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT OVER, FIN -, ARITY 2] : WIN, 
   [COORD @D167666, PAST @D167665, 
      AGR [CASE @D167664, COUNT @D167663, PER @D167662, PLU @D167661, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT BACK, FIN -, 
      ARITY 2] : WIN, 
   [COORD @D167672, PAST @D167671, AGR [CASE @D167670, COUNT @D167669, 
            PER @D167668, PLU @D167667, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT BACK, FIN -, ARITY 2] : WIN, 
   [COORD @D167676, 
      AGR [COUNT @D167675, PER @D167674, PLU @D167673, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : WIN, 
   [COORD @D167680, AGR [COUNT @D167679, PER @D167678, PLU @D167677, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, PRT OVER, PAST +, ARITY 2] : WIN, 
   [COORD @D167684, 
      AGR [COUNT @D167683, PER @D167682, PLU @D167681, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT BACK, PAST +, ARITY 2] : WIN, 
   [COORD @D167690, PAST @D167689, AGR 
         [CASE @D167688, COUNT @D167687, PER @D167686, PLU @D167685, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, FIN -, 
      ARITY 1] : WIN, 
   [COORD @D167696, PAST @D167695, AGR [CASE @D167694, COUNT @D167693, 
            PER @D167692, PLU @D167691, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, FIN -, ARITY 1] : WIN, 
   [COORD @D167702, PAST @D167701, 
      AGR [CASE @D167700, COUNT @D167699, PER @D167698, PLU @D167697, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT OVER, 
      FIN -, ARITY 1] : WIN, 
   [COORD @D167708, PAST @D167707, AGR [CASE @D167706, COUNT @D167705, 
            PER @D167704, PLU @D167703, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, FIN -, ARITY 1] : WIN, 
   [COORD @D167712, 
      AGR [COUNT @D167711, PER @D167710, PLU @D167709, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PAST +, ARITY 1] : WIN, 
   [COORD @D167716, AGR [COUNT @D167715, PER @D167714, PLU @D167713, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT THROUGH, PAST +, ARITY 1] : WIN, 
   [COORD @D167720, 
      AGR [COUNT @D167719, PER @D167718, PLU @D167717, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OVER, PAST +, ARITY 1] : WIN, 
   [COORD @D167724, AGR [COUNT @D167723, PER @D167722, PLU @D167721, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, PAST +, ARITY 1] : WIN.

WORD wonder : 
   [COADV @D167736, COORD @D167735, DEF @D167734, PRD @D167733, 
      AGR [CASE @D167732, COUNT @D167731, PER @D167730, PLU @D167729, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : WONDER, 
   [COORD @D167741, REFL @D167740, COUNT @D167739, PRD @D167738, 
      CASE @D167737, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : WONDER, 
   [COORD @D167744, 
      AGR [COUNT @D167743, PER @D167742, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, ARITY 2] : 
   WONDER, 
   [COORD @D167746, AGR [COUNT @D167745, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : WONDER, 
   [COORD @D167748, AGR [COUNT @D167747, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : WONDER, 
   [COORD @D167752, AGR [COUNT @D167751, PER @D167750, PLU @D167749, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, ARITY 2] : WONDER, 
   [COORD @D167758, PAST @D167757, AGR [CASE @D167756, COUNT @D167755, 
            PER @D167754, PLU @D167753, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHVP, ARITY 2] : WONDER, 
   [COORD @D167761, AGR [COUNT @D167760, PER @D167759, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : WONDER, 
   [COORD @D167763, AGR [COUNT @D167762, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : WONDER, 
   [COORD @D167765, AGR [COUNT @D167764, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      ARITY 2] : WONDER, 
   [COORD @D167769, AGR [COUNT @D167768, PER @D167767, PLU @D167766, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, ARITY 2] : WONDER, 
   [COORD @D167775, PAST @D167774, AGR [CASE @D167773, COUNT @D167772, 
            PER @D167771, PLU @D167770, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT WHS, ARITY 2] : WONDER, 
   [COORD @D167778, AGR [COUNT @D167777, PER @D167776, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WONDER, 
   [COORD @D167780, AGR [COUNT @D167779, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WONDER, 
   [COORD @D167782, AGR [COUNT @D167781, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WONDER, 
   [COORD @D167786, AGR [COUNT @D167785, PER @D167784, PLU @D167783, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, ARITY 2] : WONDER, 
   [COORD @D167792, PAST @D167791, AGR [CASE @D167790, COUNT @D167789, 
            PER @D167788, PLU @D167787, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT SFIN, ARITY 2] : WONDER, 
   [COORD @D167795, AGR [COUNT @D167794, PER @D167793, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WONDER, 
   [COORD @D167797, AGR [COUNT @D167796, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WONDER, 
   [COORD @D167799, AGR [COUNT @D167798, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WONDER, 
   [COORD @D167803, AGR [COUNT @D167802, PER @D167801, PLU @D167800, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : WONDER, 
   [COORD @D167809, PAST @D167808, 
      AGR [CASE @D167807, COUNT @D167806, PER @D167805, PLU @D167804, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WONDER, 
   [COORD @D167812, AGR [COUNT @D167811, PER @D167810, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WONDER, 
   [COORD @D167814, AGR [COUNT @D167813, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WONDER, 
   [COORD @D167816, AGR [COUNT @D167815, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WONDER, 
   [COORD @D167820, AGR [COUNT @D167819, PER @D167818, PLU @D167817, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : WONDER, 
   [COORD @D167826, PAST @D167825, 
      AGR [CASE @D167824, COUNT @D167823, PER @D167822, PLU @D167821, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WONDER, 
   [COORD @D167829, AGR [COUNT @D167828, PER @D167827, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WONDER, 
   [COORD @D167831, AGR [COUNT @D167830, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WONDER, 
   [COORD @D167833, AGR [COUNT @D167832, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WONDER, 
   [COORD @D167837, AGR [COUNT @D167836, PER @D167835, PLU @D167834, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WONDER, 
   [COORD @D167843, PAST @D167842, AGR [CASE @D167841, COUNT @D167840, 
            PER @D167839, PLU @D167838, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WONDER.

WORD wondered : 
   [COORD @D167855, AGR [CASE @D167854, COUNT @D167853, PER @D167852, 
            PLU @D167851, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167860, AGR [CASE @D167859, COUNT @D167858, PER @D167857, 
            PLU @D167856, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167865, AGR [CASE @D167864, COUNT @D167863, PER @D167862, 
            PLU @D167861, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167870, AGR [CASE @D167869, COUNT @D167868, PER @D167867, 
            PLU @D167866, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167875, AGR [CASE @D167874, COUNT @D167873, PER @D167872, 
            PLU @D167871, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167880, AGR [CASE @D167879, COUNT @D167878, PER @D167877, 
            PLU @D167876, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167885, AGR [UB @D167884, VFORM @D167883, SUBJ @D167882, 
            FIN @D167881, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, SUBCAT SFIN, CONJ NULL, AUX -, INV -, NEG -, PSVE +, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WONDER, 
   [COORD @D167890, AGR [CASE @D167889, COUNT @D167888, PER @D167887, 
            PLU @D167886, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167895, AGR [CASE @D167894, COUNT @D167893, PER @D167892, 
            PLU @D167891, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167900, AGR [CASE @D167899, COUNT @D167898, PER @D167897, 
            PLU @D167896, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167905, AGR [CASE @D167904, COUNT @D167903, PER @D167902, 
            PLU @D167901, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167910, AGR [CASE @D167909, COUNT @D167908, PER @D167907, 
            PLU @D167906, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167915, AGR [CASE @D167914, COUNT @D167913, PER @D167912, 
            PLU @D167911, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WONDER.

WORD wondering : 
   [COORD @D167934, PRD @D167933, AGR [CASE @D167932, COUNT @D167931, 
            PER @D167930, PLU @D167929, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167940, PRD @D167939, 
      AGR [CASE @D167938, COUNT @D167937, PER @D167936, PLU @D167935, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WONDER, 
   [COORD @D167946, PRD @D167945, AGR [CASE @D167944, COUNT @D167943, 
            PER @D167942, PLU @D167941, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167952, PRD @D167951, 
      AGR [CASE @D167950, COUNT @D167949, PER @D167948, PLU @D167947, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WONDER, 
   [COORD @D167958, PRD @D167957, AGR [CASE @D167956, COUNT @D167955, 
            PER @D167954, PLU @D167953, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WONDER, 
   [COORD @D167964, PRD @D167963, 
      AGR [CASE @D167962, COUNT @D167961, PER @D167960, PLU @D167959, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WONDER.

WORD wonders : 
   [COORD @D167975, REFL @D167974, PRD @D167973, CASE @D167972, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WONDERS, 
   [COORD @D167980, DEMON @D167979, REFL @D167978, PRD @D167977, 
      CASE @D167976, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WONDER, 
   [COORD @D167982, AGR [COUNT @D167981, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT WHVP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WONDER, 
   [COORD @D167984, 
      AGR [COUNT @D167983, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WONDER, 
   [COORD @D167986, 
      AGR [COUNT @D167985, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WONDER, 
   [COORD @D167988, 
      AGR [COUNT @D167987, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WONDER, 
   [COORD @D167990, 
      AGR [COUNT @D167989, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WONDER, 
   [COORD @D167992, 
      AGR [COUNT @D167991, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WONDER.

WORD wonderses : 
   [COORD @D168011, DEMON @D168010, REFL @D168009, PRD @D168008, 
      CASE @D168007, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WONDERS.

WORD work : 
   [COORD @D168031, REFL @D168030, COUNT @D168029, PRD @D168028, 
      CASE @D168027, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : WORK, 
   [COORD @D168034, 
      AGR [COUNT @D168033, PER @D168032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : 
   WORK, 
   [COORD @D168036, AGR [COUNT @D168035, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : WORK, 
   [COORD @D168038, AGR [COUNT @D168037, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : WORK, 
   [COORD @D168042, AGR [COUNT @D168041, PER @D168040, PLU @D168039, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, ARITY 3] : WORK, 
   [COORD @D168048, PAST @D168047, AGR [CASE @D168046, COUNT @D168045, 
            PER @D168044, PLU @D168043, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_LOC, ARITY 3] : WORK, 
   [COORD @D168051, AGR [COUNT @D168050, PER @D168049, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : WORK, 
   [COORD @D168053, AGR [COUNT @D168052, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : WORK, 
   [COORD @D168055, AGR [COUNT @D168054, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : WORK, 
   [COORD @D168059, AGR [COUNT @D168058, PER @D168057, PLU @D168056, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_ADL, ARITY 3] : WORK, 
   [COORD @D168065, PAST @D168064, AGR [CASE @D168063, COUNT @D168062, 
            PER @D168061, PLU @D168060, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP_ADL, ARITY 3] : WORK, 
   [COORD @D168068, AGR [COUNT @D168067, PER @D168066, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : WORK, 
   [COORD @D168070, AGR [COUNT @D168069, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : WORK, 
   [COORD @D168072, AGR [COUNT @D168071, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : WORK, 
   [COORD @D168076, AGR [COUNT @D168075, PER @D168074, PLU @D168073, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, PFORM INTO, ARITY 3] : WORK, 
   [COORD @D168082, PAST @D168081, 
      AGR [CASE @D168080, COUNT @D168079, PER @D168078, PLU @D168077, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, ARITY 3] : WORK, 
   [COORD @D168085, AGR [COUNT @D168084, PER @D168083, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WORK, 
   [COORD @D168087, AGR [COUNT @D168086, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WORK, 
   [COORD @D168089, AGR [COUNT @D168088, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WORK, 
   [COORD @D168093, AGR [COUNT @D168092, PER @D168091, PLU @D168090, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WORK, 
   [COORD @D168099, PAST @D168098, AGR [CASE @D168097, COUNT @D168096, 
            PER @D168095, PLU @D168094, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WORK, 
   [COORD @D168102, AGR [COUNT @D168101, PER @D168100, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : WORK, 
   [COORD @D168104, AGR [COUNT @D168103, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : WORK, 
   [COORD @D168106, AGR [COUNT @D168105, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : WORK, 
   [COORD @D168110, AGR [COUNT @D168109, PER @D168108, PLU @D168107, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHVP, PRT OUT, ARITY 2] : WORK, 
   [COORD @D168116, PAST @D168115, 
      AGR [CASE @D168114, COUNT @D168113, PER @D168112, PLU @D168111, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHVP, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168119, AGR [COUNT @D168118, PER @D168117, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168121, AGR [COUNT @D168120, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168123, AGR [COUNT @D168122, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168127, AGR [COUNT @D168126, PER @D168125, PLU @D168124, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT WHS, PRT OUT, ARITY 2] : WORK, 
   [COORD @D168133, PAST @D168132, 
      AGR [CASE @D168131, COUNT @D168130, PER @D168129, PLU @D168128, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT WHS, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168136, AGR [COUNT @D168135, PER @D168134, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : WORK, 
   [COORD @D168138, AGR [COUNT @D168137, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : WORK, 
   [COORD @D168140, AGR [COUNT @D168139, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PRT IN, PFORM WITH, ARITY 2] : WORK, 
   [COORD @D168144, AGR [COUNT @D168143, PER @D168142, PLU @D168141, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PRT IN, PFORM WITH, ARITY 2] : WORK, 
   [COORD @D168150, PAST @D168149, 
      AGR [CASE @D168148, COUNT @D168147, PER @D168146, PLU @D168145, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, PRT IN, 
      PFORM WITH, ARITY 2] : WORK, 
   [COORD @D168153, AGR [COUNT @D168152, PER @D168151, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168155, AGR [COUNT @D168154, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168157, AGR [COUNT @D168156, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168161, AGR [COUNT @D168160, PER @D168159, PLU @D168158, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT UP, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168167, PAST @D168166, 
      AGR [CASE @D168165, COUNT @D168164, PER @D168163, PLU @D168162, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT UP, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168170, AGR [COUNT @D168169, PER @D168168, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168172, AGR [COUNT @D168171, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168174, AGR [COUNT @D168173, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168178, AGR [COUNT @D168177, PER @D168176, PLU @D168175, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168184, PAST @D168183, 
      AGR [CASE @D168182, COUNT @D168181, PER @D168180, PLU @D168179, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM TO, ARITY 2] : WORK, 
   [COORD @D168187, AGR [COUNT @D168186, PER @D168185, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : WORK, 
   [COORD @D168189, AGR [COUNT @D168188, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : WORK, 
   [COORD @D168191, AGR [COUNT @D168190, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : WORK, 
   [COORD @D168195, AGR [COUNT @D168194, PER @D168193, PLU @D168192, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ON, ARITY 2] : WORK, 
   [COORD @D168201, PAST @D168200, 
      AGR [CASE @D168199, COUNT @D168198, PER @D168197, PLU @D168196, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ON, ARITY 2] : WORK, 
   [COORD @D168204, AGR [COUNT @D168203, PER @D168202, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORK, 
   [COORD @D168206, AGR [COUNT @D168205, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORK, 
   [COORD @D168208, AGR [COUNT @D168207, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORK, 
   [COORD @D168212, AGR [COUNT @D168211, PER @D168210, PLU @D168209, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM AT, ARITY 2] : WORK, 
   [COORD @D168218, PAST @D168217, 
      AGR [CASE @D168216, COUNT @D168215, PER @D168214, PLU @D168213, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORK, 
   [COORD @D168221, AGR [COUNT @D168220, PER @D168219, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM AT, ARITY 2] : WORK, 
   [COORD @D168223, AGR [COUNT @D168222, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM AT, ARITY 2] : WORK, 
   [COORD @D168225, AGR [COUNT @D168224, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM AT, ARITY 2] : WORK, 
   [COORD @D168229, AGR [COUNT @D168228, PER @D168227, PLU @D168226, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PRT OUT, PFORM AT, ARITY 2] : WORK, 
   [COORD @D168235, PAST @D168234, 
      AGR [CASE @D168233, COUNT @D168232, PER @D168231, PLU @D168230, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PRT OUT, PFORM AT, ARITY 2] : WORK, 
   [COORD @D168238, AGR [COUNT @D168237, PER @D168236, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : WORK, 
   [COORD @D168240, AGR [COUNT @D168239, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : WORK, 
   [COORD @D168242, AGR [COUNT @D168241, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT UP, ARITY 2] : WORK, 
   [COORD @D168246, AGR [COUNT @D168245, PER @D168244, PLU @D168243, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT UP, ARITY 2] : WORK, 
   [COORD @D168252, PAST @D168251, 
      AGR [CASE @D168250, COUNT @D168249, PER @D168248, PLU @D168247, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT UP, 
      ARITY 2] : WORK, 
   [COORD @D168255, AGR [COUNT @D168254, PER @D168253, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WORK, 
   [COORD @D168257, AGR [COUNT @D168256, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WORK, 
   [COORD @D168259, AGR [COUNT @D168258, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WORK, 
   [COORD @D168263, AGR [COUNT @D168262, PER @D168261, PLU @D168260, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OVER, ARITY 2] : WORK, 
   [COORD @D168269, PAST @D168268, 
      AGR [CASE @D168267, COUNT @D168266, PER @D168265, PLU @D168264, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OVER, ARITY 2] : WORK, 
   [COORD @D168272, AGR [COUNT @D168271, PER @D168270, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168274, AGR [COUNT @D168273, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168276, AGR [COUNT @D168275, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OUT, ARITY 2] : WORK, 
   [COORD @D168280, AGR [COUNT @D168279, PER @D168278, PLU @D168277, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OUT, ARITY 2] : WORK, 
   [COORD @D168286, PAST @D168285, 
      AGR [CASE @D168284, COUNT @D168283, PER @D168282, PLU @D168281, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OUT, 
      ARITY 2] : WORK, 
   [COORD @D168289, AGR [COUNT @D168288, PER @D168287, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : WORK, 
   [COORD @D168291, AGR [COUNT @D168290, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : WORK, 
   [COORD @D168293, AGR [COUNT @D168292, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT OFF, ARITY 2] : WORK, 
   [COORD @D168297, AGR [COUNT @D168296, PER @D168295, PLU @D168294, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT OFF, ARITY 2] : WORK, 
   [COORD @D168303, PAST @D168302, 
      AGR [CASE @D168301, COUNT @D168300, PER @D168299, PLU @D168298, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT OFF, 
      ARITY 2] : WORK, 
   [COORD @D168306, AGR [COUNT @D168305, PER @D168304, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : WORK, 
   [COORD @D168308, AGR [COUNT @D168307, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : WORK, 
   [COORD @D168310, AGR [COUNT @D168309, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      PRT IN, ARITY 2] : WORK, 
   [COORD @D168314, AGR [COUNT @D168313, PER @D168312, PLU @D168311, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, REG +, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, PRT IN, ARITY 2] : WORK, 
   [COORD @D168320, PAST @D168319, 
      AGR [CASE @D168318, COUNT @D168317, PER @D168316, PLU @D168315, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, PRT IN, 
      ARITY 2] : WORK, 
   [COORD @D168323, AGR [COUNT @D168322, PER @D168321, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORK, 
   [COORD @D168325, AGR [COUNT @D168324, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORK, 
   [COORD @D168327, AGR [COUNT @D168326, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORK, 
   [COORD @D168331, AGR [COUNT @D168330, PER @D168329, PLU @D168328, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORK, 
   [COORD @D168337, PAST @D168336, AGR [CASE @D168335, COUNT @D168334, 
            PER @D168333, PLU @D168332, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WORK, 
   [COORD @D168340, AGR [COUNT @D168339, PER @D168338, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WORK, 
   [COORD @D168342, AGR [COUNT @D168341, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WORK, 
   [COORD @D168344, AGR [COUNT @D168343, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WORK, 
   [COORD @D168348, AGR [COUNT @D168347, PER @D168346, PLU @D168345, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT UP, ARITY 1] : WORK, 
   [COORD @D168354, PAST @D168353, 
      AGR [CASE @D168352, COUNT @D168351, PER @D168350, PLU @D168349, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT UP, ARITY 1] : WORK, 
   [COORD @D168357, AGR [COUNT @D168356, PER @D168355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WORK, 
   [COORD @D168359, AGR [COUNT @D168358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WORK, 
   [COORD @D168361, AGR [COUNT @D168360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WORK, 
   [COORD @D168365, AGR [COUNT @D168364, PER @D168363, PLU @D168362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OVER, ARITY 1] : WORK, 
   [COORD @D168371, PAST @D168370, 
      AGR [CASE @D168369, COUNT @D168368, PER @D168367, PLU @D168366, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OVER, ARITY 1] : WORK, 
   [COORD @D168374, AGR [COUNT @D168373, PER @D168372, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WORK, 
   [COORD @D168376, AGR [COUNT @D168375, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WORK, 
   [COORD @D168378, AGR [COUNT @D168377, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WORK, 
   [COORD @D168382, AGR [COUNT @D168381, PER @D168380, PLU @D168379, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OUT, ARITY 1] : WORK, 
   [COORD @D168388, PAST @D168387, 
      AGR [CASE @D168386, COUNT @D168385, PER @D168384, PLU @D168383, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OUT, ARITY 1] : WORK, 
   [COORD @D168391, AGR [COUNT @D168390, PER @D168389, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WORK, 
   [COORD @D168393, AGR [COUNT @D168392, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WORK, 
   [COORD @D168395, AGR [COUNT @D168394, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WORK, 
   [COORD @D168399, AGR [COUNT @D168398, PER @D168397, PLU @D168396, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT OFF, ARITY 1] : WORK, 
   [COORD @D168405, PAST @D168404, 
      AGR [CASE @D168403, COUNT @D168402, PER @D168401, PLU @D168400, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT OFF, ARITY 1] : WORK, 
   [COORD @D168408, AGR [COUNT @D168407, PER @D168406, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WORK, 
   [COORD @D168410, AGR [COUNT @D168409, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WORK, 
   [COORD @D168412, AGR [COUNT @D168411, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WORK, 
   [COORD @D168416, AGR [COUNT @D168415, PER @D168414, PLU @D168413, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, PRT IN, ARITY 1] : WORK, 
   [COORD @D168422, PAST @D168421, 
      AGR [CASE @D168420, COUNT @D168419, PER @D168418, PLU @D168417, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      PRT IN, ARITY 1] : WORK.

WORD worked : 
   [COORD @D168432, AGR [CASE @D168431, COUNT @D168430, PER @D168429, 
            PLU @D168428, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_LOC, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORK, 
   [COORD @D168437, AGR [CASE @D168436, COUNT @D168435, PER @D168434, 
            PLU @D168433, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168442, AGR [CASE @D168441, COUNT @D168440, PER @D168439, 
            PLU @D168438, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168447, AGR [CASE @D168446, COUNT @D168445, PER @D168444, 
            PLU @D168443, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_ADL, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORK, 
   [COORD @D168452, AGR [CASE @D168451, COUNT @D168450, PER @D168449, 
            PLU @D168448, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168457, AGR [CASE @D168456, COUNT @D168455, PER @D168454, 
            PLU @D168453, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168462, AGR [CASE @D168461, COUNT @D168460, PER @D168459, 
            PLU @D168458, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168467, AGR [CASE @D168466, COUNT @D168465, PER @D168464, 
            PLU @D168463, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168472, AGR [CASE @D168471, COUNT @D168470, PER @D168469, 
            PLU @D168468, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168477, AGR [CASE @D168476, COUNT @D168475, PER @D168474, 
            PLU @D168473, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORK, 
   [COORD @D168482, AGR [CASE @D168481, COUNT @D168480, PER @D168479, 
            PLU @D168478, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168487, AGR [CASE @D168486, COUNT @D168485, PER @D168484, 
            PLU @D168483, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168492, AGR [CASE @D168491, COUNT @D168490, PER @D168489, 
            PLU @D168488, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168497, AGR [CASE @D168496, COUNT @D168495, PER @D168494, 
            PLU @D168493, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168502, AGR [CASE @D168501, COUNT @D168500, PER @D168499, 
            PLU @D168498, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168507, AGR [CASE @D168506, COUNT @D168505, PER @D168504, 
            PLU @D168503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168512, AGR [CASE @D168511, COUNT @D168510, PER @D168509, 
            PLU @D168508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168517, 
      AGR [CASE @D168516, COUNT @D168515, PER @D168514, PLU @D168513, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168522, AGR [CASE @D168521, COUNT @D168520, PER @D168519, 
            PLU @D168518, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PRT IN, PFORM WITH, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168527, AGR [CASE @D168526, COUNT @D168525, PER @D168524, 
            PLU @D168523, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168532, AGR [CASE @D168531, COUNT @D168530, PER @D168529, 
            PLU @D168528, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168537, AGR [CASE @D168536, COUNT @D168535, PER @D168534, 
            PLU @D168533, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168542, AGR [CASE @D168541, COUNT @D168540, PER @D168539, 
            PLU @D168538, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM TO, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168547, AGR [CASE @D168546, COUNT @D168545, PER @D168544, 
            PLU @D168543, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168552, AGR [CASE @D168551, COUNT @D168550, PER @D168549, 
            PLU @D168548, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168557, AGR [CASE @D168556, COUNT @D168555, PER @D168554, 
            PLU @D168553, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168562, AGR [CASE @D168561, COUNT @D168560, PER @D168559, 
            PLU @D168558, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168567, AGR [CASE @D168566, COUNT @D168565, PER @D168564, 
            PLU @D168563, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168572, AGR [CASE @D168571, COUNT @D168570, PER @D168569, 
            PLU @D168568, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM AT, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168577, AGR [CASE @D168576, COUNT @D168575, PER @D168574, 
            PLU @D168573, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168582, AGR [CASE @D168581, COUNT @D168580, PER @D168579, 
            PLU @D168578, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168587, AGR [CASE @D168586, COUNT @D168585, PER @D168584, 
            PLU @D168583, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168592, AGR [CASE @D168591, COUNT @D168590, PER @D168589, 
            PLU @D168588, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168597, AGR [CASE @D168596, COUNT @D168595, PER @D168594, 
            PLU @D168593, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168602, AGR [CASE @D168601, COUNT @D168600, PER @D168599, 
            PLU @D168598, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168607, AGR [CASE @D168606, COUNT @D168605, PER @D168604, 
            PLU @D168603, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168612, AGR [CASE @D168611, COUNT @D168610, PER @D168609, 
            PLU @D168608, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168617, AGR [CASE @D168616, COUNT @D168615, PER @D168614, 
            PLU @D168613, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168622, AGR [CASE @D168621, COUNT @D168620, PER @D168619, 
            PLU @D168618, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168627, AGR [CASE @D168626, COUNT @D168625, PER @D168624, 
            PLU @D168623, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168632, AGR [CASE @D168631, COUNT @D168630, PER @D168629, 
            PLU @D168628, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168637, AGR [CASE @D168636, COUNT @D168635, PER @D168634, 
            PLU @D168633, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168642, AGR [CASE @D168641, COUNT @D168640, PER @D168639, 
            PLU @D168638, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168647, AGR [CASE @D168646, COUNT @D168645, PER @D168644, 
            PLU @D168643, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168652, AGR [CASE @D168651, COUNT @D168650, PER @D168649, 
            PLU @D168648, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168657, AGR [CASE @D168656, COUNT @D168655, PER @D168654, 
            PLU @D168653, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168662, AGR [CASE @D168661, COUNT @D168660, PER @D168659, 
            PLU @D168658, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168667, AGR [CASE @D168666, COUNT @D168665, PER @D168664, 
            PLU @D168663, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168672, AGR [CASE @D168671, COUNT @D168670, PER @D168669, 
            PLU @D168668, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168677, AGR [CASE @D168676, COUNT @D168675, PER @D168674, 
            PLU @D168673, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168682, AGR [CASE @D168681, COUNT @D168680, PER @D168679, 
            PLU @D168678, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168687, AGR [CASE @D168686, COUNT @D168685, PER @D168684, 
            PLU @D168683, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168692, AGR [CASE @D168691, COUNT @D168690, PER @D168689, 
            PLU @D168688, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168697, AGR [CASE @D168696, COUNT @D168695, PER @D168694, 
            PLU @D168693, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK, 
   [COORD @D168702, AGR [CASE @D168701, COUNT @D168700, PER @D168699, 
            PLU @D168698, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168707, AGR [CASE @D168706, COUNT @D168705, PER @D168704, 
            PLU @D168703, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORK.

WORD working : 
   [COADV @D168724, COORD @D168723, DEF @D168722, PRD @D168721, 
      AGR [CASE @D168720, COUNT @D168719, PER @D168718, PLU @D168717, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, BAR 0, 
      SUBCAT NULL, INFL +, N +, COMPAR NO, GRADE -, ADV -, AFORM NONE, 
      PART -, NEG -, QUA -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      DISTR ATT] : WORKING, 
   [COORD @D168730, PRD @D168729, AGR [CASE @D168728, COUNT @D168727, 
            PER @D168726, PLU @D168725, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_LOC, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168736, PRD @D168735, 
      AGR [CASE @D168734, COUNT @D168733, PER @D168732, PLU @D168731, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168742, PRD @D168741, AGR [CASE @D168740, COUNT @D168739, 
            PER @D168738, PLU @D168737, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, 
      PFORM INTO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168748, PRD @D168747, 
      AGR [CASE @D168746, COUNT @D168745, PER @D168744, PLU @D168743, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WORK, 
   [COORD @D168754, PRD @D168753, AGR [CASE @D168752, COUNT @D168751, 
            PER @D168750, PLU @D168749, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT WHVP, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168760, PRD @D168759, 
      AGR [CASE @D168758, COUNT @D168757, PER @D168756, PLU @D168755, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT WHS, PRT OUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORK, 
   [COORD @D168766, PRD @D168765, AGR [CASE @D168764, COUNT @D168763, 
            PER @D168762, PLU @D168761, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT IN, 
      PFORM WITH, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, 
      FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168772, PRD @D168771, 
      AGR [CASE @D168770, COUNT @D168769, PER @D168768, PLU @D168767, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168778, PRD @D168777, AGR [CASE @D168776, COUNT @D168775, 
            PER @D168774, PLU @D168773, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168784, PRD @D168783, 
      AGR [CASE @D168782, COUNT @D168781, PER @D168780, PLU @D168779, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORK, 
   [COORD @D168790, PRD @D168789, AGR [CASE @D168788, COUNT @D168787, 
            PER @D168786, PLU @D168785, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168796, PRD @D168795, 
      AGR [CASE @D168794, COUNT @D168793, PER @D168792, PLU @D168791, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OUT, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168802, PRD @D168801, AGR [CASE @D168800, COUNT @D168799, 
            PER @D168798, PLU @D168797, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168808, PRD @D168807, 
      AGR [CASE @D168806, COUNT @D168805, PER @D168804, PLU @D168803, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WORK, 
   [COORD @D168814, PRD @D168813, AGR [CASE @D168812, COUNT @D168811, 
            PER @D168810, PLU @D168809, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168820, PRD @D168819, 
      AGR [CASE @D168818, COUNT @D168817, PER @D168816, PLU @D168815, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WORK, 
   [COORD @D168826, PRD @D168825, AGR [CASE @D168824, COUNT @D168823, 
            PER @D168822, PLU @D168821, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168832, PRD @D168831, 
      AGR [CASE @D168830, COUNT @D168829, PER @D168828, PLU @D168827, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168838, PRD @D168837, AGR [CASE @D168836, COUNT @D168835, 
            PER @D168834, PLU @D168833, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168844, PRD @D168843, 
      AGR [CASE @D168842, COUNT @D168841, PER @D168840, PLU @D168839, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORK, 
   [COORD @D168850, PRD @D168849, AGR [CASE @D168848, COUNT @D168847, 
            PER @D168846, PLU @D168845, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK, 
   [COORD @D168856, PRD @D168855, 
      AGR [CASE @D168854, COUNT @D168853, PER @D168852, PLU @D168851, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORK, 
   [COORD @D168862, PRD @D168861, AGR [CASE @D168860, COUNT @D168859, 
            PER @D168858, PLU @D168857, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORK.

WORD works : 
   [COORD @D168871, REFL @D168870, PRD @D168869, CASE @D168868, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WORKS, 
   [COORD @D168875, REFL @D168874, PRD @D168873, CASE @D168872, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, REG -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WORKS, 
   [COORD @D168879, REFL @D168878, PRD @D168877, CASE @D168876, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : WORKS, 
   [COORD @D168884, DEMON @D168883, REFL @D168882, PRD @D168881, 
      CASE @D168880, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WORK, 
   [COORD @D168886, AGR [COUNT @D168885, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_LOC, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WORK, 
   [COORD @D168888, AGR [COUNT @D168887, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_ADL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WORK, 
   [COORD @D168890, AGR [COUNT @D168889, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PFORM INTO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168892, AGR [COUNT @D168891, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168894, 
      AGR [COUNT @D168893, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHVP, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168896, 
      AGR [COUNT @D168895, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT WHS, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168898, 
      AGR [COUNT @D168897, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PRT IN, PFORM WITH, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WORK, 
   [COORD @D168900, AGR [COUNT @D168899, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168902, AGR [COUNT @D168901, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168904, AGR [COUNT @D168903, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM ON, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WORK, 
   [COORD @D168906, AGR [COUNT @D168905, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WORK, 
   [COORD @D168908, AGR [COUNT @D168907, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OUT, PFORM AT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168910, AGR [COUNT @D168909, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168912, AGR [COUNT @D168911, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168914, AGR [COUNT @D168913, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168916, AGR [COUNT @D168915, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168918, AGR [COUNT @D168917, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORK, 
   [COORD @D168920, AGR [COUNT @D168919, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168922, 
      AGR [COUNT @D168921, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168924, 
      AGR [COUNT @D168923, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168926, 
      AGR [COUNT @D168925, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168928, 
      AGR [COUNT @D168927, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK, 
   [COORD @D168930, 
      AGR [COUNT @D168929, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORK.

WORD workses : 
   [COORD @D168945, DEMON @D168944, REFL @D168943, PRD @D168942, 
      CASE @D168941, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WORKS.

WORD worried : 
   [COORD @D168957, AGR [CASE @D168956, COUNT @D168955, PER @D168954, 
            PLU @D168953, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_PP, SUBTYPE NONE, CONJ NULL, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D168962, AGR [CASE @D168961, COUNT @D168960, PER @D168959, 
            PLU @D168958, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D168967, AGR [CASE @D168966, COUNT @D168965, PER @D168964, 
            PLU @D168963, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, 
      INV -, NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, 
      AT +, LAT +, PAST +, BAR 0, V +, N -] : WORRY, 
   [COORD @D168972, AGR [CASE @D168971, COUNT @D168970, PER @D168969, 
            PLU @D168968, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT OC_PP_INF, CONJ NULL, SUBTYPE PVERB_OE, PFORM AT, 
      AUX -, INV -, NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D168977, AGR [CASE @D168976, COUNT @D168975, PER @D168974, 
            PLU @D168973, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, 
      PRD -, INFL -, AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D168982, 
      AGR [CASE @D168981, COUNT @D168980, PER @D168979, PLU @D168978, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORRY, 
   [COORD @D168984, AGR @D168983, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D168986, AGR @D168985, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D168991, AGR [CASE @D168990, COUNT @D168989, PER @D168988, 
            PLU @D168987, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, CONJ NULL, SUBTYPE EXTRAP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D168993, AGR @D168992, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D168995, AGR @D168994, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D169000, AGR [CASE @D168999, COUNT @D168998, PER @D168997, 
            PLU @D168996, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169005, AGR [CASE @D169004, COUNT @D169003, PER @D169002, 
            PLU @D169001, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169010, AGR [CASE @D169009, COUNT @D169008, PER @D169007, 
            PLU @D169006, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169015, AGR [CASE @D169014, COUNT @D169013, PER @D169012, 
            PLU @D169011, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169020, AGR [CASE @D169019, COUNT @D169018, PER @D169017, 
            PLU @D169016, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169025, AGR [CASE @D169024, COUNT @D169023, PER @D169022, 
            PLU @D169021, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBTYPE PVERB, SUBCAT PP, CONJ NULL, PFORM AT, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169030, AGR [CASE @D169029, COUNT @D169028, PER @D169027, 
            PLU @D169026, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169035, AGR [CASE @D169034, COUNT @D169033, PER @D169032, 
            PLU @D169031, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169040, AGR [CASE @D169039, COUNT @D169038, PER @D169037, 
            PLU @D169036, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169045, AGR [CASE @D169044, COUNT @D169043, PER @D169042, 
            PLU @D169041, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, 
      NEG -, PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, 
      LAT +, PAST +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169050, AGR [CASE @D169049, COUNT @D169048, PER @D169047, 
            PLU @D169046, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169055, AGR [CASE @D169054, COUNT @D169053, PER @D169052, 
            PLU @D169051, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WORRY.

WORD worries : 
   [COORD @D169067, DEMON @D169066, REFL @D169065, PRD @D169064, 
      CASE @D169063, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WORRY, 
   [COORD @D169069, AGR [COUNT @D169068, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_PP, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D169071, AGR [COUNT @D169070, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169075, AGR [CASE @D169074, NFORM @D169073, COUNT @D169072, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQU_EXTRAP, CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169080, AGR [UB @D169079, VFORM @D169078, SUBJ @D169077, 
            FIN @D169076, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQU_EXTRAP, CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169084, AGR [CASE @D169083, NFORM @D169082, COUNT @D169081, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D169089, AGR [UB @D169088, VFORM @D169087, SUBJ @D169086, 
            FIN @D169085, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D169091, AGR [COUNT @D169090, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORRY, 
   [COORD @D169093, 
      AGR [COUNT @D169092, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORRY, 
   [COORD @D169095, 
      AGR [COUNT @D169094, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORRY, 
   [COORD @D169097, 
      AGR [COUNT @D169096, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORRY, 
   [COORD @D169099, 
      AGR [COUNT @D169098, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WORRY.

WORD worry : 
   [COORD @D169109, REFL @D169108, COUNT @D169107, PRD @D169106, 
      CASE @D169105, FIX NOT, BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, 
      PRO -, PROTYPE NONE, PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, 
      DEMON -, NUM -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : WORRY, 
   [COORD @D169112, 
      AGR [COUNT @D169111, PER @D169110, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, PFORM FOR, 
      ARITY 3] : WORRY, 
   [COORD @D169114, AGR [COUNT @D169113, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WORRY, 
   [COORD @D169116, AGR [COUNT @D169115, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WORRY, 
   [COORD @D169120, AGR [COUNT @D169119, PER @D169118, PLU @D169117, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, PFORM FOR, ARITY 3] : WORRY, 
   [COORD @D169126, PAST @D169125, 
      AGR [CASE @D169124, COUNT @D169123, PER @D169122, PLU @D169121, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, 
      PFORM FOR, ARITY 3] : WORRY, 
   [COORD @D169129, AGR [COUNT @D169128, PER @D169127, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM AT, ARITY 3] : WORRY, 
   [COORD @D169131, AGR [COUNT @D169130, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM AT, ARITY 3] : WORRY, 
   [COORD @D169133, AGR [COUNT @D169132, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM AT, ARITY 3] : WORRY, 
   [COORD @D169137, AGR [COUNT @D169136, PER @D169135, PLU @D169134, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM AT, ARITY 3] : WORRY, 
   [COORD @D169143, PAST @D169142, 
      AGR [CASE @D169141, COUNT @D169140, PER @D169139, PLU @D169138, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB_OE, 
      SUBCAT OC_PP_INF, PFORM AT, ARITY 3] : WORRY, 
   [COORD @D169146, AGR @D169145, PAST @D169144, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, ARITY 2] : WORRY, 
   [COORD @D169149, AGR @D169148, PAST @D169147, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT NP_SFIN, ARITY 2] : WORRY, 
   [COORD @D169152, AGR [COUNT @D169151, PER @D169150, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WORRY, 
   [COORD @D169154, AGR [COUNT @D169153, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WORRY, 
   [COORD @D169156, AGR [COUNT @D169155, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WORRY, 
   [COORD @D169160, AGR [COUNT @D169159, PER @D169158, PLU @D169157, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WORRY, 
   [COORD @D169166, PAST @D169165, AGR [CASE @D169164, COUNT @D169163, 
            PER @D169162, PLU @D169161, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WORRY, 
   [COORD @D169169, AGR [COUNT @D169168, PER @D169167, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WORRY, 
   [COORD @D169171, AGR [COUNT @D169170, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WORRY, 
   [COORD @D169173, AGR [COUNT @D169172, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WORRY, 
   [COORD @D169177, AGR [COUNT @D169176, PER @D169175, PLU @D169174, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM OVER, ARITY 2] : WORRY, 
   [COORD @D169183, PAST @D169182, 
      AGR [CASE @D169181, COUNT @D169180, PER @D169179, PLU @D169178, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM OVER, ARITY 2] : WORRY, 
   [COORD @D169186, AGR [COUNT @D169185, PER @D169184, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORRY, 
   [COORD @D169188, AGR [COUNT @D169187, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORRY, 
   [COORD @D169190, AGR [COUNT @D169189, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORRY, 
   [COORD @D169194, AGR [COUNT @D169193, PER @D169192, PLU @D169191, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, REG +, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT PP, PFORM AT, ARITY 2] : WORRY, 
   [COORD @D169200, PAST @D169199, 
      AGR [CASE @D169198, COUNT @D169197, PER @D169196, PLU @D169195, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, INFL +, REG +, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, 
      PFORM AT, ARITY 2] : WORRY, 
   [COORD @D169203, AGR [COUNT @D169202, PER @D169201, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WORRY, 
   [COORD @D169205, AGR [COUNT @D169204, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WORRY, 
   [COORD @D169207, AGR [COUNT @D169206, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WORRY, 
   [COORD @D169211, AGR [COUNT @D169210, PER @D169209, PLU @D169208, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT PP, PFORM ABOUT, ARITY 2] : WORRY, 
   [COORD @D169217, PAST @D169216, 
      AGR [CASE @D169215, COUNT @D169214, PER @D169213, PLU @D169212, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      PFORM ABOUT, ARITY 2] : WORRY, 
   [COORD @D169220, AGR [COUNT @D169219, PER @D169218, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORRY, 
   [COORD @D169222, AGR [COUNT @D169221, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORRY, 
   [COORD @D169224, AGR [COUNT @D169223, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORRY, 
   [COORD @D169228, AGR [COUNT @D169227, PER @D169226, PLU @D169225, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, ARITY 1] : WORRY, 
   [COORD @D169234, PAST @D169233, AGR [CASE @D169232, COUNT @D169231, 
            PER @D169230, PLU @D169229, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NULL, ARITY 1] : WORRY.

WORD worrying : 
   [COORD @D169251, PRD @D169250, AGR [CASE @D169249, COUNT @D169248, 
            PER @D169247, PLU @D169246, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_PP, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169257, PRD @D169256, 
      AGR [CASE @D169255, COUNT @D169254, PER @D169253, PLU @D169252, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB_OE, SUBCAT OC_PP_INF, PFORM AT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169260, AGR @D169259, PRD @D169258, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169263, AGR @D169262, PRD @D169261, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WORRY, 
   [COORD @D169269, PRD @D169268, AGR [CASE @D169267, COUNT @D169266, 
            PER @D169265, PLU @D169264, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169275, PRD @D169274, 
      AGR [CASE @D169273, COUNT @D169272, PER @D169271, PLU @D169270, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM OVER, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169281, PRD @D169280, AGR [CASE @D169279, COUNT @D169278, 
            PER @D169277, PLU @D169276, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM AT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WORRY, 
   [COORD @D169287, PRD @D169286, 
      AGR [CASE @D169285, COUNT @D169284, PER @D169283, PLU @D169282, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM ABOUT, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WORRY, 
   [COORD @D169293, PRD @D169292, AGR [CASE @D169291, COUNT @D169290, 
            PER @D169289, PLU @D169288, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WORRY.

WORD wound : 
   [COORD @D169300, REFL @D169299, PRD @D169298, CASE @D169297, FIX NOT, 
      BAR 0, SUBCAT NULL, INFL +, N +, V -, POSS -, PRO -, PROTYPE NONE, 
      PN -, PLU -, NFORM NORM, PER 3, ADV -, PART -, DEMON -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, COUNT +] : WOUND, 
   [COORD @D169306, PAST @D169305, 
      AGR [CASE @D169304, COUNT @D169303, PER @D169302, PLU @D169301, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_LOC, REG -, FIN -, 
      ARITY 3] : WIND, 
   [COORD @D169312, PAST @D169311, AGR [CASE @D169310, COUNT @D169309, 
            PER @D169308, PLU @D169307, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, FIN -, ARITY 3] : WIND, 
   [COORD @D169318, PAST @D169317, 
      AGR [CASE @D169316, COUNT @D169315, PER @D169314, PLU @D169313, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PFORM ROUND, 
      FIN -, ARITY 3] : WIND, 
   [COORD @D169324, PAST @D169323, AGR [CASE @D169322, COUNT @D169321, 
            PER @D169320, PLU @D169319, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ROUND, FIN -, ARITY 3] : WIND, 
   [COORD @D169330, PAST @D169329, 
      AGR [CASE @D169328, COUNT @D169327, PER @D169326, PLU @D169325, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP_PP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      INFL -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, FIN -, ARITY 3] : WIND, 
   [COORD @D169336, PAST @D169335, 
      AGR [CASE @D169334, COUNT @D169333, PER @D169332, PLU @D169331, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      PFORM WITH, FIN -, ARITY 3] : WIND, 
   [COORD @D169340, AGR [COUNT @D169339, PER @D169338, PLU @D169337, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_LOC, REG -, PAST +, ARITY 3] : WIND, 
   [COORD @D169344, AGR [COUNT @D169343, PER @D169342, PLU @D169341, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_PP, REG -, PFORM ROUND, PAST +, ARITY 3] : WIND, 
   [COORD @D169348, 
      AGR [COUNT @D169347, PER @D169346, PLU @D169345, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PFORM WITH, PAST +, ARITY 3] : WIND, 
   [COORD @D169351, AGR @D169350, PAST @D169349, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, ARITY 2] : WOUND, 
   [COORD @D169354, AGR @D169353, PAST @D169352, FIX NOT, V +, N -, 
      INFL +, REG +, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, 
      SUBCAT NP_SFIN, ARITY 2] : WOUND, 
   [COORD @D169357, AGR [COUNT @D169356, PER @D169355, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WOUND, 
   [COORD @D169359, AGR [COUNT @D169358, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WOUND, 
   [COORD @D169361, AGR [COUNT @D169360, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      ARITY 2] : WOUND, 
   [COORD @D169365, AGR [COUNT @D169364, PER @D169363, PLU @D169362, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, ARITY 2] : WOUND, 
   [COORD @D169371, PAST @D169370, AGR [CASE @D169369, COUNT @D169368, 
            PER @D169367, PLU @D169366, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, INFL +, REG +, AUX -, INV -, PRO -, 
      NEG -, PRD -, PSVE -, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, ARITY 2] : WOUND, 
   [COORD @D169377, PAST @D169376, 
      AGR [CASE @D169375, COUNT @D169374, PER @D169373, PLU @D169372, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, INFL -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, FIN -, 
      ARITY 2] : WIND, 
   [COORD @D169383, PAST @D169382, AGR [CASE @D169381, COUNT @D169380, 
            PER @D169379, PLU @D169378, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP, REG -, FIN -, ARITY 2] : WIND, 
   [COORD @D169389, PAST @D169388, 
      AGR [CASE @D169387, COUNT @D169386, PER @D169385, PLU @D169384, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT LOC, REG -, FIN -, 
      ARITY 2] : WIND, 
   [COORD @D169395, PAST @D169394, AGR [CASE @D169393, COUNT @D169392, 
            PER @D169391, PLU @D169390, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, 
      VFORM EN, BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT UP, FIN -, ARITY 2] : WIND, 
   [COORD @D169401, PAST @D169400, 
      AGR [CASE @D169399, COUNT @D169398, PER @D169397, PLU @D169396, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT UP, 
      FIN -, ARITY 2] : WIND, 
   [COORD @D169407, PAST @D169406, AGR [CASE @D169405, COUNT @D169404, 
            PER @D169403, PLU @D169402, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PRT UP, FIN -, ARITY 2] : WIND, 
   [COORD @D169413, PAST @D169412, 
      AGR [CASE @D169411, COUNT @D169410, PER @D169409, PLU @D169408, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, FIN -, 
      ARITY 2] : WIND, 
   [COORD @D169419, PAST @D169418, AGR [CASE @D169417, COUNT @D169416, 
            PER @D169415, PLU @D169414, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, FIN -, ARITY 2] : WIND, 
   [COORD @D169425, PAST @D169424, 
      AGR [CASE @D169423, COUNT @D169422, PER @D169421, PLU @D169420, 
            N +, V -, BAR 2, NFORM NORM], VFORM EN, PSVE +, PRD +, FIX NOT, 
      V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, INFL -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, FIN -, 
      ARITY 2] : WIND, 
   [COORD @D169431, PAST @D169430, AGR [CASE @D169429, COUNT @D169428, 
            PER @D169427, PLU @D169426, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, FIN -, ARITY 2] : WIND, 
   [COORD @D169435, 
      AGR [COUNT @D169434, PER @D169433, PLU @D169432, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, PAST +, 
      ARITY 2] : WIND, 
   [COORD @D169439, AGR [COUNT @D169438, PER @D169437, PLU @D169436, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PAST +, ARITY 2] : WIND, 
   [COORD @D169443, AGR [COUNT @D169442, PER @D169441, PLU @D169440, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT UP, PAST +, ARITY 2] : WIND, 
   [COORD @D169447, 
      AGR [COUNT @D169446, PER @D169445, PLU @D169444, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, VFORM NOT, AUX -, 
      INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, BAR 0, SUBTYPE EQUI, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_AP, REG -, PRT UP, 
      PAST +, ARITY 2] : WIND, 
   [COORD @D169451, AGR [COUNT @D169450, PER @D169449, PLU @D169448, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT LOC, REG -, PRT UP, PAST +, ARITY 2] : WIND, 
   [COORD @D169455, 
      AGR [COUNT @D169454, PER @D169453, PLU @D169452, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, PAST +, ARITY 2] : WIND, 
   [COORD @D169459, AGR [COUNT @D169458, PER @D169457, PLU @D169456, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, N -, 
      SUBCAT NP, SUBTYPE NONE, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      REG -, PRT DOWN, PAST +, ARITY 2] : WIND, 
   [COORD @D169465, PAST @D169464, 
      AGR [CASE @D169463, COUNT @D169462, PER @D169461, PLU @D169460, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, VFORM EN, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT UP, 
      FIN -, ARITY 1] : WIND, 
   [COORD @D169471, PAST @D169470, AGR [CASE @D169469, COUNT @D169468, 
            PER @D169467, PLU @D169466, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, VFORM EN, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, FIN -, ARITY 1] : WIND, 
   [COORD @D169475, 
      AGR [COUNT @D169474, PER @D169473, PLU @D169472, BAR 2, V -, N +, 
            NFORM NORM, CASE NOM], FIX NOT, V +, SUBTYPE NONE, N -, 
      VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL -, FIN +, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, PAST +, ARITY 1] : WIND, 
   [COORD @D169479, AGR [COUNT @D169478, PER @D169477, PLU @D169476, 
            BAR 2, V -, N +, NFORM NORM, CASE NOM], FIX NOT, V +, 
      SUBTYPE NONE, N -, VFORM NOT, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL -, FIN +, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, PAST +, ARITY 1] : WIND.

WORD wounded : 
   [COORD @D169486, AGR @D169485, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WOUND, 
   [COORD @D169488, AGR @D169487, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : WOUND, 
   [COORD @D169493, AGR [CASE @D169492, COUNT @D169491, PER @D169490, 
            PLU @D169489, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP_SFIN, CONJ NULL, SUBTYPE EXTRAP, AUX -, INV -, 
      NEG -, PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WOUND, 
   [COORD @D169495, AGR @D169494, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WOUND, 
   [COORD @D169497, AGR @D169496, COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, REG -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST +, BAR 0, 
      V +, N -] : WOUND, 
   [COORD @D169502, AGR [CASE @D169501, COUNT @D169500, PER @D169499, 
            PLU @D169498, NFORM NORM, N +, V -, BAR 2], COMPOUND NOT, 
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, AUX -, INV -, NEG -, 
      PSVE +, PRO -, VFORM EN, FIN -, PAST NOT, PRD +, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WOUND, 
   [COORD @D169507, AGR [CASE @D169506, COUNT @D169505, PER @D169504, 
            PLU @D169503, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM EN, FIN -, PAST NOT, PRD -, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WOUND, 
   [COORD @D169512, AGR [CASE @D169511, COUNT @D169510, PER @D169509, 
            PLU @D169508, BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, 
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, 
      PSVE -, REG -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, 
      PAST +, BAR 0, V +, N -] : WOUND.

WORD wounding : 
   [COORD @D169524, AGR @D169523, PRD @D169522, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EQU_EXTRAP, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WOUND, 
   [COORD @D169527, AGR @D169526, PRD @D169525, COMPOUND NOT, FIX NOT, 
      CONJ NULL, SUBTYPE EXTRAP, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WOUND, 
   [COORD @D169533, PRD @D169532, AGR [CASE @D169531, COUNT @D169530, 
            PER @D169529, PLU @D169528, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WOUND.

WORD wounds : 
   [COORD @D169543, DEMON @D169542, REFL @D169541, PRD @D169540, 
      CASE @D169539, COMPOUND NOT, FIX NOT, SUBCAT NULL, PN -, ADV -, 
      PART -, CONJ NULL, PROTYPE NONE, REG -, PRO -, NFORM NORM, PER 3, 
      INFL -, PLU +, NUM -, AT +, LAT +, COUNT +, POSS -, BAR 0, N +, V -] : 
   WOUND, 
   [COORD @D169547, AGR [CASE @D169546, NFORM @D169545, COUNT @D169544, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQU_EXTRAP, CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WOUND, 
   [COORD @D169552, AGR [UB @D169551, VFORM @D169550, SUBJ @D169549, 
            FIN @D169548, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQU_EXTRAP, CONJ NULL, SUBCAT OC_INF, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WOUND, 
   [COORD @D169556, AGR [CASE @D169555, NFORM @D169554, COUNT @D169553, 
            PLU -, PER 3, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WOUND, 
   [COORD @D169561, AGR [UB @D169560, VFORM @D169559, SUBJ @D169558, 
            FIN @D169557, N -, V +, BAR 2], COMPOUND NOT, FIX NOT, 
      SUBTYPE EXTRAP, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WOUND, 
   [COORD @D169563, AGR [COUNT @D169562, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WOUND.

WORD write : 
   [COORD @D169570, AGR [COUNT @D169569, PER @D169568, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : WRITE, 
   [COORD @D169572, AGR [COUNT @D169571, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : WRITE, 
   [COORD @D169574, AGR [COUNT @D169573, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, 
      REG -, ARITY 3] : WRITE, 
   [COORD @D169578, AGR [COUNT @D169577, PER @D169576, PLU @D169575, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_SFIN, REG -, ARITY 3] : WRITE, 
   [COORD @D169584, PAST @D169583, 
      AGR [CASE @D169582, COUNT @D169581, PER @D169580, PLU @D169579, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_SFIN, REG -, 
      ARITY 3] : WRITE, 
   [COORD @D169587, AGR [COUNT @D169586, PER @D169585, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : WRITE, 
   [COORD @D169589, AGR [COUNT @D169588, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : WRITE, 
   [COORD @D169591, AGR [COUNT @D169590, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, 
      REG -, ARITY 3] : WRITE, 
   [COORD @D169595, AGR [COUNT @D169594, PER @D169593, PLU @D169592, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NP_NP, REG -, ARITY 3] : WRITE, 
   [COORD @D169601, PAST @D169600, 
      AGR [CASE @D169599, COUNT @D169598, PER @D169597, PLU @D169596, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP_NP, REG -, 
      ARITY 3] : WRITE, 
   [COORD @D169604, AGR [COUNT @D169603, PER @D169602, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : WRITE, 
   [COORD @D169606, AGR [COUNT @D169605, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : WRITE, 
   [COORD @D169608, AGR [COUNT @D169607, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : WRITE, 
   [COORD @D169612, AGR [COUNT @D169611, PER @D169610, PLU @D169609, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, 
      SUBCAT OC_AP, REG -, PRT DOWN, PREP AS, ARITY 3] : WRITE, 
   [COORD @D169618, PAST @D169617, 
      AGR [CASE @D169616, COUNT @D169615, PER @D169614, PLU @D169613, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EQUI, SUBCAT OC_AP, 
      REG -, PRT DOWN, PREP AS, ARITY 3] : WRITE, 
   [COORD @D169621, AGR [COUNT @D169620, PER @D169619, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : WRITE, 
   [COORD @D169623, AGR [COUNT @D169622, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : WRITE, 
   [COORD @D169625, AGR [COUNT @D169624, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : WRITE, 
   [COORD @D169629, AGR [COUNT @D169628, PER @D169627, PLU @D169626, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, 
      SUBCAT NP_PP, REG -, PFORM TO, ARITY 3] : WRITE, 
   [COORD @D169635, PAST @D169634, 
      AGR [CASE @D169633, COUNT @D169632, PER @D169631, PLU @D169630, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE DMOVT, SUBCAT NP_PP, 
      REG -, PFORM TO, ARITY 3] : WRITE, 
   [COORD @D169638, AGR [COUNT @D169637, PER @D169636, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169640, AGR [COUNT @D169639, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169642, AGR [COUNT @D169641, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169646, AGR [COUNT @D169645, PER @D169644, PLU @D169643, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      SUBCAT NP_PP, REG -, PRT DOWN, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169652, PAST @D169651, 
      AGR [CASE @D169650, COUNT @D169649, PER @D169648, PLU @D169647, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, 
      REG -, PRT DOWN, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169655, AGR [COUNT @D169654, PER @D169653, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT OFF, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169657, AGR [COUNT @D169656, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT OFF, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169659, AGR [COUNT @D169658, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, 
      REG -, PRT OFF, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169663, AGR [COUNT @D169662, PER @D169661, PLU @D169660, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP_PP, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBTYPE PVERB, REG -, PRT OFF, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169669, PAST @D169668, 
      AGR [CASE @D169667, COUNT @D169666, PER @D169665, PLU @D169664, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP_PP, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE PVERB, REG -, 
      PRT OFF, PFORM AS, ARITY 3] : WRITE, 
   [COORD @D169672, AGR [COUNT @D169671, PER @D169670, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169674, AGR [COUNT @D169673, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169676, AGR [COUNT @D169675, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169680, AGR [COUNT @D169679, PER @D169678, PLU @D169677, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, ARITY 2] : WRITE, 
   [COORD @D169686, PAST @D169685, 
      AGR [CASE @D169684, COUNT @D169683, PER @D169682, PLU @D169681, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      ARITY 2] : WRITE, 
   [COORD @D169689, AGR [COUNT @D169688, PER @D169687, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169691, AGR [COUNT @D169690, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169693, AGR [COUNT @D169692, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169697, AGR [COUNT @D169696, PER @D169695, PLU @D169694, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, ARITY 2] : WRITE, 
   [COORD @D169703, PAST @D169702, 
      AGR [CASE @D169701, COUNT @D169700, PER @D169699, PLU @D169698, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169706, AGR [COUNT @D169705, PER @D169704, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169708, AGR [COUNT @D169707, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169710, AGR [COUNT @D169709, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169714, AGR [COUNT @D169713, PER @D169712, PLU @D169711, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, ARITY 2] : WRITE, 
   [COORD @D169720, PAST @D169719, 
      AGR [CASE @D169718, COUNT @D169717, PER @D169716, PLU @D169715, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169723, AGR [COUNT @D169722, PER @D169721, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : WRITE, 
   [COORD @D169725, AGR [COUNT @D169724, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : WRITE, 
   [COORD @D169727, AGR [COUNT @D169726, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -, 
      ARITY 2] : WRITE, 
   [COORD @D169731, AGR [COUNT @D169730, PER @D169729, PLU @D169728, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP, 
      REG -, ARITY 2] : WRITE, 
   [COORD @D169737, PAST @D169736, AGR [CASE @D169735, COUNT @D169734, 
            PER @D169733, PLU @D169732, BAR 2, V -, N +, NFORM NORM], 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, SUBCAT NP, REG -, ARITY 2] : WRITE, 
   [COORD @D169740, AGR 
         [COUNT @D169739, PER @D169738, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, FIX NOT, V +, 
      SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, PRT BACK, 
      ARITY 2] : WRITE, 
   [COORD @D169742, AGR [COUNT @D169741, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169744, AGR [COUNT @D169743, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169748, AGR [COUNT @D169747, PER @D169746, PLU @D169745, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SFIN, REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169754, PAST @D169753, 
      AGR [CASE @D169752, COUNT @D169751, PER @D169750, PLU @D169749, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, REG -, 
      PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169757, AGR [COUNT @D169756, PER @D169755, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169759, AGR [COUNT @D169758, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169761, AGR [COUNT @D169760, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169765, AGR [COUNT @D169764, PER @D169763, PLU @D169762, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_ING, REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169771, PAST @D169770, 
      AGR [CASE @D169769, COUNT @D169768, PER @D169767, PLU @D169766, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169774, AGR [COUNT @D169773, PER @D169772, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169776, AGR [COUNT @D169775, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169778, AGR [COUNT @D169777, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169782, AGR [COUNT @D169781, PER @D169780, PLU @D169779, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, 
      BAR 0, SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT SC_INF, REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169788, PAST @D169787, 
      AGR [CASE @D169786, COUNT @D169785, PER @D169784, PLU @D169783, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, BAR 0, 
      SUBTYPE EQUI, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, 
      REG -, PRT BACK, ARITY 2] : WRITE, 
   [COORD @D169791, AGR [COUNT @D169790, PER @D169789, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169793, AGR [COUNT @D169792, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169795, AGR [COUNT @D169794, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169799, AGR [COUNT @D169798, PER @D169797, PLU @D169796, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169805, PAST @D169804, 
      AGR [CASE @D169803, COUNT @D169802, PER @D169801, PLU @D169800, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169808, AGR [COUNT @D169807, PER @D169806, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169810, AGR [COUNT @D169809, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169812, AGR [COUNT @D169811, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT UP, PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169816, AGR [COUNT @D169815, PER @D169814, PLU @D169813, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT UP, PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169822, PAST @D169821, 
      AGR [CASE @D169820, COUNT @D169819, PER @D169818, PLU @D169817, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT UP, 
      PFORM TO, ARITY 2] : WRITE, 
   [COORD @D169825, AGR [COUNT @D169824, PER @D169823, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169827, AGR [COUNT @D169826, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169829, AGR [COUNT @D169828, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT OFF, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169833, AGR [COUNT @D169832, PER @D169831, PLU @D169830, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT OFF, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169839, PAST @D169838, 
      AGR [CASE @D169837, COUNT @D169836, PER @D169835, PLU @D169834, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT OFF, 
      PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169842, AGR [COUNT @D169841, PER @D169840, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169844, AGR [COUNT @D169843, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169846, AGR [COUNT @D169845, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT IN, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169850, AGR [COUNT @D169849, PER @D169848, PLU @D169847, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT IN, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169856, PAST @D169855, 
      AGR [CASE @D169854, COUNT @D169853, PER @D169852, PLU @D169851, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, PRT IN, 
      PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169859, AGR [COUNT @D169858, PER @D169857, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169861, AGR [COUNT @D169860, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169863, AGR [COUNT @D169862, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169867, AGR [COUNT @D169866, PER @D169865, PLU @D169864, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, 
      REG -, PRT AWAY, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169873, PAST @D169872, 
      AGR [CASE @D169871, COUNT @D169870, PER @D169869, PLU @D169868, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT PP, REG -, 
      PRT AWAY, PFORM FOR, ARITY 2] : WRITE, 
   [COORD @D169876, AGR [COUNT @D169875, PER @D169874, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : WRITE, 
   [COORD @D169878, AGR [COUNT @D169877, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : WRITE, 
   [COORD @D169880, AGR [COUNT @D169879, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT UP, ARITY 2] : WRITE, 
   [COORD @D169884, AGR [COUNT @D169883, PER @D169882, PLU @D169881, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT UP, ARITY 2] : WRITE, 
   [COORD @D169890, PAST @D169889, 
      AGR [CASE @D169888, COUNT @D169887, PER @D169886, PLU @D169885, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT UP, 
      ARITY 2] : WRITE, 
   [COORD @D169893, AGR [COUNT @D169892, PER @D169891, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : WRITE, 
   [COORD @D169895, AGR [COUNT @D169894, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : WRITE, 
   [COORD @D169897, AGR [COUNT @D169896, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OUT, ARITY 2] : WRITE, 
   [COORD @D169901, AGR [COUNT @D169900, PER @D169899, PLU @D169898, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OUT, ARITY 2] : WRITE, 
   [COORD @D169907, PAST @D169906, 
      AGR [CASE @D169905, COUNT @D169904, PER @D169903, PLU @D169902, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, 
      ARITY 2] : WRITE, 
   [COORD @D169910, AGR [COUNT @D169909, PER @D169908, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : WRITE, 
   [COORD @D169912, AGR [COUNT @D169911, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : WRITE, 
   [COORD @D169914, AGR [COUNT @D169913, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT OFF, ARITY 2] : WRITE, 
   [COORD @D169918, AGR [COUNT @D169917, PER @D169916, PLU @D169915, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT OFF, ARITY 2] : WRITE, 
   [COORD @D169924, PAST @D169923, 
      AGR [CASE @D169922, COUNT @D169921, PER @D169920, PLU @D169919, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT OFF, 
      ARITY 2] : WRITE, 
   [COORD @D169927, AGR [COUNT @D169926, PER @D169925, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : WRITE, 
   [COORD @D169929, AGR [COUNT @D169928, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : WRITE, 
   [COORD @D169931, AGR [COUNT @D169930, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT IN, ARITY 2] : WRITE, 
   [COORD @D169935, AGR [COUNT @D169934, PER @D169933, PLU @D169932, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT IN, ARITY 2] : WRITE, 
   [COORD @D169941, PAST @D169940, 
      AGR [CASE @D169939, COUNT @D169938, PER @D169937, PLU @D169936, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, PRT IN, 
      ARITY 2] : WRITE, 
   [COORD @D169944, AGR [COUNT @D169943, PER @D169942, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : WRITE, 
   [COORD @D169946, AGR [COUNT @D169945, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : WRITE, 
   [COORD @D169948, AGR [COUNT @D169947, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : WRITE, 
   [COORD @D169952, AGR [COUNT @D169951, PER @D169950, PLU @D169949, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, N -, SUBCAT NP, SUBTYPE NONE, AUX -, INV -, 
      PRO -, NEG -, PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, 
      COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : WRITE, 
   [COORD @D169958, PAST @D169957, 
      AGR [CASE @D169956, COUNT @D169955, PER @D169954, PLU @D169953, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, N -, SUBCAT NP, 
      SUBTYPE NONE, AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, 
      VFORM BSE, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, 
      PRT DOWN, ARITY 2] : WRITE, 
   [COORD @D169961, AGR [COUNT @D169960, PER @D169959, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : WRITE, 
   [COORD @D169963, AGR [COUNT @D169962, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : WRITE, 
   [COORD @D169965, AGR [COUNT @D169964, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, ARITY 1] : WRITE, 
   [COORD @D169969, AGR [COUNT @D169968, PER @D169967, PLU @D169966, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, ARITY 1] : WRITE, 
   [COORD @D169975, PAST @D169974, 
      AGR [CASE @D169973, COUNT @D169972, PER @D169971, PLU @D169970, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      ARITY 1] : WRITE, 
   [COORD @D169978, AGR [COUNT @D169977, PER @D169976, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : WRITE, 
   [COORD @D169980, AGR [COUNT @D169979, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : WRITE, 
   [COORD @D169982, AGR [COUNT @D169981, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT UP, ARITY 1] : WRITE, 
   [COORD @D169986, AGR [COUNT @D169985, PER @D169984, PLU @D169983, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT UP, ARITY 1] : WRITE, 
   [COORD @D169992, PAST @D169991, 
      AGR [CASE @D169990, COUNT @D169989, PER @D169988, PLU @D169987, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT UP, ARITY 1] : WRITE, 
   [COORD @D169995, AGR [COUNT @D169994, PER @D169993, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : WRITE, 
   [COORD @D169997, AGR [COUNT @D169996, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : WRITE, 
   [COORD @D169999, AGR [COUNT @D169998, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OUT, ARITY 1] : WRITE, 
   [COORD @D170003, AGR [COUNT @D170002, PER @D170001, PLU @D170000, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OUT, ARITY 1] : WRITE, 
   [COORD @D170009, PAST @D170008, 
      AGR [CASE @D170007, COUNT @D170006, PER @D170005, PLU @D170004, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OUT, ARITY 1] : WRITE, 
   [COORD @D170012, AGR [COUNT @D170011, PER @D170010, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : WRITE, 
   [COORD @D170014, AGR [COUNT @D170013, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : WRITE, 
   [COORD @D170016, AGR [COUNT @D170015, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT OFF, ARITY 1] : WRITE, 
   [COORD @D170020, AGR [COUNT @D170019, PER @D170018, PLU @D170017, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT OFF, ARITY 1] : WRITE, 
   [COORD @D170026, PAST @D170025, 
      AGR [CASE @D170024, COUNT @D170023, PER @D170022, PLU @D170021, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT OFF, ARITY 1] : WRITE, 
   [COORD @D170029, AGR [COUNT @D170028, PER @D170027, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : WRITE, 
   [COORD @D170031, AGR [COUNT @D170030, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : WRITE, 
   [COORD @D170033, AGR [COUNT @D170032, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT IN, ARITY 1] : WRITE, 
   [COORD @D170037, AGR [COUNT @D170036, PER @D170035, PLU @D170034, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT IN, ARITY 1] : WRITE, 
   [COORD @D170043, PAST @D170042, 
      AGR [CASE @D170041, COUNT @D170040, PER @D170039, PLU @D170038, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT IN, ARITY 1] : WRITE, 
   [COORD @D170046, AGR [COUNT @D170045, PER @D170044, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : WRITE, 
   [COORD @D170048, AGR [COUNT @D170047, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : WRITE, 
   [COORD @D170050, AGR [COUNT @D170049, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT DOWN, ARITY 1] : WRITE, 
   [COORD @D170054, AGR [COUNT @D170053, PER @D170052, PLU @D170051, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT DOWN, ARITY 1] : WRITE, 
   [COORD @D170060, PAST @D170059, 
      AGR [CASE @D170058, COUNT @D170057, PER @D170056, PLU @D170055, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT DOWN, ARITY 1] : WRITE, 
   [COORD @D170063, AGR [COUNT @D170062, PER @D170061, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : WRITE, 
   [COORD @D170065, AGR [COUNT @D170064, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : WRITE, 
   [COORD @D170067, AGR [COUNT @D170066, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT BACK, ARITY 1] : WRITE, 
   [COORD @D170071, AGR [COUNT @D170070, PER @D170069, PLU @D170068, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT BACK, ARITY 1] : WRITE, 
   [COORD @D170077, PAST @D170076, 
      AGR [CASE @D170075, COUNT @D170074, PER @D170073, PLU @D170072, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT BACK, ARITY 1] : WRITE, 
   [COORD @D170080, AGR [COUNT @D170079, PER @D170078, N +, V -, BAR 2, 
            NFORM NORM, CASE NOM, PLU +], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : WRITE, 
   [COORD @D170082, AGR [COUNT @D170081, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 1, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : WRITE, 
   [COORD @D170084, AGR [COUNT @D170083, N +, V -, BAR 2, NFORM NORM, 
            CASE NOM, PER 2, PLU -], VFORM NOT, FIN +, INFL -, PAST -, 
      FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, PRD -, 
      PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, 
      REG -, PRT AWAY, ARITY 1] : WRITE, 
   [COORD @D170088, AGR [COUNT @D170087, PER @D170086, PLU @D170085, N +, 
            V -, BAR 2, NFORM NORM, CASE NOM], VFORM BSE, FIN +, INFL -, 
      PAST NOT, FIX NOT, V +, SUBTYPE NONE, N -, AUX -, INV -, PRO -, NEG -, 
      PRD -, PSVE -, BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, 
      SUBCAT NULL, REG -, PRT AWAY, ARITY 1] : WRITE, 
   [COORD @D170094, PAST @D170093, 
      AGR [CASE @D170092, COUNT @D170091, PER @D170090, PLU @D170089, 
            BAR 2, V -, N +, NFORM NORM], FIX NOT, V +, SUBTYPE NONE, N -, 
      AUX -, INV -, PRO -, NEG -, PRD -, PSVE -, INFL +, FIN -, VFORM BSE, 
      BAR 0, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NULL, REG -, 
      PRT AWAY, ARITY 1] : WRITE.

WORD writes : 
   [COORD @D170106, AGR [COUNT @D170105, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WRITE, 
   [COORD @D170108, AGR [COUNT @D170107, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NP_NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170110, 
      AGR [COUNT @D170109, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE EQUI, 
      SUBCAT OC_AP, PRT DOWN, PREP AS, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170112, AGR [COUNT @D170111, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE DMOVT, SUBCAT NP_PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170114, AGR [COUNT @D170113, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT DOWN, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170116, AGR [COUNT @D170115, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP_PP, 
      CONJ NULL, SUBTYPE PVERB, PRT OFF, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170118, AGR [COUNT @D170117, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170120, 
      AGR [COUNT @D170119, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170122, 
      AGR [COUNT @D170121, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170124, 
      AGR [COUNT @D170123, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, PRD -, 
      INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170126, 
      AGR [COUNT @D170125, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT SFIN, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170128, 
      AGR [COUNT @D170127, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_ING, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170130, 
      AGR [COUNT @D170129, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, 
      SUBCAT SC_INF, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170132, 
      AGR [COUNT @D170131, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170134, 
      AGR [COUNT @D170133, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, NEG -, PSVE -, VFORM NOT, 
      PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : 
   WRITE, 
   [COORD @D170136, AGR [COUNT @D170135, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT OFF, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170138, AGR [COUNT @D170137, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170140, AGR [COUNT @D170139, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT PP, PRT AWAY, PFORM FOR, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170142, AGR [COUNT @D170141, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170144, AGR [COUNT @D170143, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170146, AGR [COUNT @D170145, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170148, AGR [COUNT @D170147, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170150, AGR [COUNT @D170149, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, 
      VFORM NOT, PRO -, PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170152, AGR [COUNT @D170151, NFORM NORM, PLU -, PER 3, 
            CASE NOM, N +, V -, BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, 
      CONJ NULL, SUBCAT NULL, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170154, 
      AGR [COUNT @D170153, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170156, 
      AGR [COUNT @D170155, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OUT, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170158, 
      AGR [COUNT @D170157, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170160, 
      AGR [COUNT @D170159, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT IN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170162, 
      AGR [COUNT @D170161, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170164, 
      AGR [COUNT @D170163, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT BACK, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE, 
   [COORD @D170166, 
      AGR [COUNT @D170165, NFORM NORM, PLU -, PER 3, CASE NOM, N +, V -, 
            BAR 2], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, 
      SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, PSVE -, VFORM NOT, PRO -, 
      PRD -, INFL -, FIN +, AT +, LAT +, PAST -, BAR 0, V +, N -] : WRITE.

WORD writing : 
   [COORD @D170174, REFL @D170173, PRD @D170172, CASE @D170171, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, PLU -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, COUNT -, INFL -, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT] : WRITING, 
   [COORD @D170180, PRD @D170179, 
      AGR [CASE @D170178, COUNT @D170177, PER @D170176, PLU @D170175, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NP_SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170186, PRD @D170185, AGR [CASE @D170184, COUNT @D170183, 
            PER @D170182, PLU @D170181, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP_NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170192, PRD @D170191, 
      AGR [CASE @D170190, COUNT @D170189, PER @D170188, PLU @D170187, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE EQUI, SUBCAT OC_AP, PRT DOWN, PREP AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170198, PRD @D170197, AGR [CASE @D170196, COUNT @D170195, 
            PER @D170194, PLU @D170193, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE DMOVT, SUBCAT NP_PP, 
      PFORM TO, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170204, PRD @D170203, 
      AGR [CASE @D170202, COUNT @D170201, PER @D170200, PLU @D170199, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, 
      SUBTYPE PVERB, SUBCAT NP_PP, PRT DOWN, PFORM AS, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170210, PRD @D170209, AGR [CASE @D170208, COUNT @D170207, 
            PER @D170206, PLU @D170205, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP_PP, CONJ NULL, SUBTYPE PVERB, PRT OFF, 
      PFORM AS, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170216, PRD @D170215, 
      AGR [CASE @D170214, COUNT @D170213, PER @D170212, PLU @D170211, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170222, PRD @D170221, AGR [CASE @D170220, COUNT @D170219, 
            PER @D170218, PLU @D170217, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170228, PRD @D170227, 
      AGR [CASE @D170226, COUNT @D170225, PER @D170224, PLU @D170223, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, AUX -, INV -, NEG -, PSVE -, 
      REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, 
      V +, N -] : WRITE, 
   [COORD @D170234, PRD @D170233, AGR [CASE @D170232, COUNT @D170231, 
            PER @D170230, PLU @D170229, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170240, PRD @D170239, 
      AGR [CASE @D170238, COUNT @D170237, PER @D170236, PLU @D170235, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT SFIN, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170246, PRD @D170245, AGR [CASE @D170244, COUNT @D170243, 
            PER @D170242, PLU @D170241, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE EQUI, CONJ NULL, SUBCAT SC_ING, 
      PRT BACK, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170252, PRD @D170251, 
      AGR [CASE @D170250, COUNT @D170249, PER @D170248, PLU @D170247, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE EQUI, CONJ NULL, SUBCAT SC_INF, PRT BACK, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170258, PRD @D170257, AGR [CASE @D170256, COUNT @D170255, 
            PER @D170254, PLU @D170253, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PFORM TO, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170264, PRD @D170263, 
      AGR [CASE @D170262, COUNT @D170261, PER @D170260, PLU @D170259, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT UP, PFORM TO, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170270, PRD @D170269, AGR [CASE @D170268, COUNT @D170267, 
            PER @D170266, PLU @D170265, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT OFF, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170276, PRD @D170275, 
      AGR [CASE @D170274, COUNT @D170273, PER @D170272, PLU @D170271, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT IN, PFORM FOR, AUX -, INV -, 
      NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, 
      LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170282, PRD @D170281, AGR [CASE @D170280, COUNT @D170279, 
            PER @D170278, PLU @D170277, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT PP, PRT AWAY, 
      PFORM FOR, AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, 
      PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170288, PRD @D170287, 
      AGR [CASE @D170286, COUNT @D170285, PER @D170284, PLU @D170283, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT UP, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WRITE, 
   [COORD @D170294, PRD @D170293, AGR [CASE @D170292, COUNT @D170291, 
            PER @D170290, PLU @D170289, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170300, PRD @D170299, 
      AGR [CASE @D170298, COUNT @D170297, PER @D170296, PLU @D170295, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT OFF, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WRITE, 
   [COORD @D170306, PRD @D170305, AGR [CASE @D170304, COUNT @D170303, 
            PER @D170302, PLU @D170301, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170312, PRD @D170311, 
      AGR [CASE @D170310, COUNT @D170309, PER @D170308, PLU @D170307, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, 
      SUBTYPE NONE, CONJ NULL, PRT DOWN, AUX -, INV -, NEG -, PSVE -, REG -, 
      PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, BAR 0, V +, 
      N -] : WRITE, 
   [COORD @D170318, PRD @D170317, AGR [CASE @D170316, COUNT @D170315, 
            PER @D170314, PLU @D170313, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, AUX -, 
      INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, 
      AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170324, PRD @D170323, 
      AGR [CASE @D170322, COUNT @D170321, PER @D170320, PLU @D170319, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT UP, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170330, PRD @D170329, AGR [CASE @D170328, COUNT @D170327, 
            PER @D170326, PLU @D170325, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OUT, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170336, PRD @D170335, 
      AGR [CASE @D170334, COUNT @D170333, PER @D170332, PLU @D170331, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT OFF, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170342, PRD @D170341, AGR [CASE @D170340, COUNT @D170339, 
            PER @D170338, PLU @D170337, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT IN, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170348, PRD @D170347, 
      AGR [CASE @D170346, COUNT @D170345, PER @D170344, PLU @D170343, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT DOWN, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE, 
   [COORD @D170354, PRD @D170353, AGR [CASE @D170352, COUNT @D170351, 
            PER @D170350, PLU @D170349, BAR 2, V -, N +, NFORM NORM], 
      COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT BACK, 
      AUX -, INV -, NEG -, PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, 
      INFL -, AT +, LAT +, BAR 0, V +, N -] : WRITE, 
   [COORD @D170360, PRD @D170359, 
      AGR [CASE @D170358, COUNT @D170357, PER @D170356, PLU @D170355, 
            BAR 2, V -, N +, NFORM NORM], COMPOUND NOT, FIX NOT, 
      SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT AWAY, AUX -, INV -, NEG -, 
      PSVE -, REG -, PRO -, VFORM ING, FIN -, PAST NOT, INFL -, AT +, LAT +, 
      BAR 0, V +, N -] : WRITE.

WORD writings : 
   [COORD @D170370, REFL @D170369, PRD @D170368, CASE @D170367, FIX NOT, 
      BAR 0, SUBCAT NULL, N +, V -, POSS -, PRO -, PROTYPE NONE, PN -, 
      NFORM NORM, PER 3, ADV -, PART -, DEMON -, INFL -, PLU +, NUM -, 
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, COUNT +] : WRITINGS.
; nanlt/closed-lex - closed class GDE lexicon based on the output of FWord
; applied to (most of the) words in dict/d.le under the ANLT grammar.
; Eirik Hektoen, 1998-1-24.

; NB: Many cases of PAST NO were corrected to PAST NOT.
; NB: In the def of "to", PFORM DASH was changed to PFORM TO.

WORD ' :
   N[+POSS, -ADV, +PLU, -PRO, -NUM, COORD @D1364, REFL @D1363, COUNT
         @D1362, PRD @D1361, CASE @D1360, FIX NOT, SUBCAT NULL,
      PROTYPE NONE, PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, INFL -] : S.

WORD 's :
   N[+POSS, -ADV, -PLU, -PRO, -NUM, COORD @D1372, REFL @D1371, COUNT
         @D1370, PRD @D1369, CASE @D1368, FIX NOT, SUBCAT NULL,
      PROTYPE NONE, PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, INFL -] : S.

WORD a :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D1378, REFL @D1377,
      PRD @D1376, CASE @D1375, FIX NOT, SUBCAT NULL, PROTYPE NONE,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, INFL -, ADDRESS -] : (initial A),
   [FIX NOT, INFL -, CN3 A] : |1|,
   DetN[-POSS, -DEF, AGR N2[-PLU, +COUNT, CASE @D1381, NFORM @D1380,
            PER @D1379, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (uq (some (x) (and (sg x) (P x))))).

WORD about : [FIX NOT, PRT ABOUT, INFL -] : ABOUT,
   P[-PRO, MODTYPE @D1389, COORD @D1388, NEG @D1387, PRD @D1386, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_ABOUT] : ABOUT,
   P[-PRO, MODTYPE @D1393, COORD @D1392, NEG @D1391, PRD @D1390, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM AT_ABOUT] : ABOUT,
   P[-PRO, MODTYPE @D1397, COORD @D1396, NEG @D1395, PRD @D1394, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ABOUT_WITH] : ABOUT,
   P[-PRO, MODTYPE @D1401, COORD @D1400, NEG @D1399, PRD @D1398, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ABOUT_TO] : ABOUT,
   P[-PRO, MODTYPE @D1406, COORD @D1405, NEG @D1404, PRD @D1403,
      LOC @D1402, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : ABOUT,
   P[-PRO, MODTYPE @D1411, COORD @D1410, NEG @D1409, PRD @D1408,
      LOC @D1407, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM ABOUT] : ABOUT.

WORD above : [FIX NOT, PRT ABOVE, INFL -] : ABOVE,
   P[-PRO, MODTYPE @D1422, COORD @D1421, NEG @D1420, PRD @D1419,
      LOC @D1418, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : ABOVE,
   P[-PRO, MODTYPE @D1427, COORD @D1426, NEG @D1425, PRD @D1424,
      LOC @D1423, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM ABOVE] : ABOVE,
   A[-ADV, -NEG, -QUA, -NUM, COADV @D1435, COORD @D1434, DEF @D1433,
      PRD @D1432,
      AGR N2[CASE @D1431, COUNT @D1430, PER @D1429, PLU @D1428,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, COMPAR NO, GRADE -,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : ABOVE.

WORD abroad : [FIX NOT, PRT ABROAD, INFL -] : ABROAD.

WORD across : [FIX NOT, PRT ACROSS, INFL -] : ACROSS,
   P[-PRO, MODTYPE @D1447, COORD @D1446, NEG @D1445, PRD @D1444,
      LOC @D1443, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : ACROSS,
   P[-PRO, MODTYPE @D1452, COORD @D1451, NEG @D1450, PRD @D1449,
      LOC @D1448, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM ACROSS] : ACROSS.

WORD after :
   P[-PRO, COORD @D1458, NEG @D1457, PRD @D1456, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SING,
      PFORM NORM] : AFTER,
   P[-PRO, COORD @D1461, NEG @D1460, PRD @D1459, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : AFTER,
   P[-PRO, MODTYPE @D1465, COORD @D1464, NEG @D1463, PRD @D1462, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -, SUBCAT SFIN,
      PFORM NORM] : AFTER,
   P[-PRO, MODTYPE @D1470, COORD @D1469, NEG @D1468, PRD @D1467,
      LOC @D1466, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : AFTER,
   P[-PRO, MODTYPE @D1475, COORD @D1474, NEG @D1473, PRD @D1472,
      LOC @D1471, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM AFTER] : AFTER,
   A[-ADV, -NEG, -QUA, -NUM, COORD @D1482, DEF @D1481, PRD @D1480,
      AGR N2[CASE @D1479, COUNT @D1478, PER @D1477, PLU @D1476,
            NFORM NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      AFORM NONE, PART -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE -,
      COADV +, DISTR PRD] : AFTER,
   A[+ADV, -NEG, -QUA, -NUM, COADV @D1487, COORD @D1486, DEF @D1485,
      AGR @D1484, PRD @D1483, FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      COMPAR NO, GRADE -, AFORM NONE, PART -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, DISTR PST] : AFTER,
   A[+ADV, -NEG, -QUA, -NUM, COADV @D1492, COORD @D1491, DEF @D1490,
      AGR @D1489, PRD @D1488, FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      COMPAR NO, GRADE -, AFORM NONE, PART -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, DISTR PRD] : AFTER.

WORD again : [FIX NOT, PRT AGAIN, INFL -] : AGAIN.

WORD against :
   P[-PRO, MODTYPE @D1505, COORD @D1504, NEG @D1503, PRD @D1502, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_AGAINST] : AGAINST,
   P[-PRO, MODTYPE @D1509, COORD @D1508, NEG @D1507, PRD @D1506, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_AGAINST] : AGAINST,
   P[-PRO, MODTYPE @D1514, COORD @D1513, NEG @D1512, PRD @D1511,
      LOC @D1510, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : AGAINST,
   P[-PRO, MODTYPE @D1519, COORD @D1518, NEG @D1517, PRD @D1516,
      LOC @D1515, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM AGAINST] : AGAINST.

WORD ago :
   A[-ADV, -NEG, -QUA, -NUM, COORD @D1530, DEF @D1529, PRD @D1528,
      AGR N2[CASE @D1527, COUNT @D1526, PER @D1525, PLU @D1524,
            NFORM NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      AFORM NONE, PART -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE -,
      COADV +, DISTR PRD] : AGO.

WORD ahead : [FIX NOT, PRT AHEAD, INFL -] : AHEAD.

WORD all :
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D1541, COORD @D1540,
      AGR N2[+PLU, +COUNT, CASE @D1539, NFORM @D1538, PER @D1537,
            QFEAT +], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   ALL,
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D1546, COORD @D1545,
      AGR N2[+PLU, +COUNT, CASE @D1544, NFORM @D1543, PER @D1542,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q all (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D1551, COORD @D1550,
      AGR N2[-PLU, -COUNT, CASE @D1549, NFORM @D1548, PER @D1547,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q all (lambda (x) (lambda (P) (and (ms x) (P x)))))),
   N[-PRD, -POSS, -ADV, +ACC, +DEF, +PRO, -NUM, COORD @D1554, COUNT @D1553,
      PLU @D1552, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq all (lambda (x) (and (or (ms x) (pl x)) (entity x))))),

   N[-PRD, -POSS, -ADV, +NOM, +DEF, +PLU, +PRO, -NUM, COORD @D1556, COUNT
         @D1555, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq all (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +NOM, +DEF, -PLU, +PRO, -COUNT, -NUM, COORD @D1557,
      FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +, LAT +,
      PROTYPE PMOD] :
   (lambda (Q) (Q uq all (lambda (x) (and (ms x) (entity x))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D1563, COORD @D1562,
      AGR N2[CASE @D1561, COUNT @D1560, PER @D1559, PLU @D1558,
            NFORM NORM], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART OF] : ALL,
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D1569, COORD @D1568,
      AGR N2[CASE @D1567, COUNT @D1566, PER @D1565, PLU @D1564,
            NFORM NORM], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART NO_OF] : ALL.

WORD along : [FIX NOT, PRT ALONG, INFL -] : ALONG,
   P[-PRO, MODTYPE @D1577, COORD @D1576, NEG @D1575, PRD @D1574,
      LOC @D1573, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : ALONG,
   P[-PRO, MODTYPE @D1582, COORD @D1581, NEG @D1580, PRD @D1579,
      LOC @D1578, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM ALONG] : ALONG.

WORD aloud : [FIX NOT, PRT ALOUD, INFL -] : ALOUD.

WORD although :
   P[-PRO, COORD @D1591, NEG @D1590, PRD @D1589, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : ALTHOUGH.

WORD always :
   A[+ADV, -NEG, -DEF, +QUA, -NUM, COADV @D1601, COORD @D1600, AGR @D1599,
      PRD @D1598, FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   always.

WORD am :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D1607, SUBTYPE @D1606,
      AGR N2[+NOM, -PLU, COUNT @D1605, PER 1, NFORM NORM], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL, PAST -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D1610, INV @D1609,
      AGR N2[+NOM, -PLU, COUNT @D1608, PER 1, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT BE, PAST -] : NIL.

WORD among :
   P[-PRO, MODTYPE @D1619, COORD @D1618, NEG @D1617, PRD @D1616,
      LOC @D1615, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : AMONG,
   P[-PRO, MODTYPE @D1624, COORD @D1623, NEG @D1622, PRD @D1621,
      LOC @D1620, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM AMONG] : AMONG.

WORD amongst :
   P[-PRO, MODTYPE @D1634, COORD @D1633, NEG @D1632, PRD @D1631,
      LOC @D1630, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : AMONGST,
   P[-PRO, MODTYPE @D1639, COORD @D1638, NEG @D1637, PRD @D1636,
      LOC @D1635, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM AMONGST] : AMONGST.

WORD an :
   DetN[-POSS, -DEF, AGR N2[-PLU, +COUNT, CASE @D1645, NFORM @D1644,
            PER @D1643, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (uq (some (x) (and (sg x) (P x))))).

WORD and : [FIX NOT, CONJN +, SUBCAT AND] : AND.

WORD another :
   DetN[-POSS, -DEF, AGR N2[+PLU, +COUNT, CASE @D1658, NFORM @D1657,
            PER @D1656, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   ANOTHER,
   DetN[-POSS, -DEF, AGR N2[-PLU, +COUNT, CASE @D1661, NFORM @D1660,
            PER @D1659, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (uq (another (x) (and (sg x) (P x))))).

WORD any :
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D1671, COORD @D1670,
      AGR N2[+PLU, +COUNT, CASE @D1669, NFORM @D1668, PER @D1667,
            QFEAT +], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   ANY,
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D1676, COORD @D1675,
      AGR N2[-PLU, -COUNT, CASE @D1674, NFORM @D1673, PER @D1672,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q any (lambda (x) (lambda (P) (and (ms x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D1681, COORD @D1680,
      AGR N2[+PLU, +COUNT, CASE @D1679, NFORM @D1678, PER @D1677,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q any (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D1686, COORD @D1685,
      AGR N2[-PLU, +COUNT, CASE @D1684, NFORM @D1683, PER @D1682,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q any (lambda (x) (lambda (P) (and (sg x) (P x)))))),
   N[-PRD, -POSS, -ADV, +DEF, +PRO, +COUNT, -NUM, COORD @D1689,
      CASE @D1688, PLU @D1687, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO,
      EVER NO, CONJ NULL, AT +, LAT +, PART OF2] : ANY.

WORD anybody :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D1699, COUNT @D1698,
      CASE @D1697, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq any (lambda (x) (and (sg x) (person x))))).

WORD anyone :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D1709, COUNT @D1708,
      CASE @D1707, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq any (lambda (x) (and (sg x) (person x))))).

WORD anything :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D1718, COUNT @D1717,
      CASE @D1716, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq any (lambda (x) (and (sg x) (entity x))))).

WORD anywhere :
   N[+PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D1728, COUNT @D1727,
      CASE @D1726, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq any (lambda (x) (and (sg x) (place x))) AT)).

WORD apart : [FIX NOT, PRT APART, INFL -] : APART.

WORD april :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D1738, REFL @D1737,
      PRD @D1736, CASE @D1735, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : APRIL.

WORD are :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D1747, SUBTYPE @D1746,
      AGR N2[+NOM, +PLU, NFORM @D1745, COUNT @D1744, PER @D1743], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL, PAST -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D1750, SUBTYPE @D1749,
      AGR N2[+NOM, -PLU, COUNT @D1748, PER 2, NFORM NORM], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL, PAST -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D1755, INV @D1754,
      AGR N2[+NOM, +PLU, NFORM @D1753, COUNT @D1752, PER @D1751], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT BE, PAST -] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D1758, INV @D1757,
      AGR N2[+NOM, -PLU, COUNT @D1756, PER 2, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT BE, PAST -] : NIL.

WORD aren't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D1769, SUBTYPE @D1768,
      AGR N2[+NOM, +PLU, NFORM @D1767, COUNT @D1766, PER @D1765],
      CONEG @D1764, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, SUBCAT NULL, PAST -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D1773, SUBTYPE @D1772,
      AGR N2[+NOM, -PLU, COUNT @D1771, PER 2, NFORM NORM], CONEG @D1770,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL, PAST -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +INV, +NEG, +FIN, +AUX, -PRO, COORD @D1776,
      AGR N2[+NOM, -PLU, COUNT @D1775, PER 1, NFORM NORM], CONEG @D1774,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT BE, PAST -] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D1782, INV @D1781,
      AGR N2[+NOM, +PLU, NFORM @D1780, COUNT @D1779, PER @D1778],
      CONEG @D1777, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT BE, PAST -] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D1786, INV @D1785,
      AGR N2[+NOM, -PLU, COUNT @D1784, PER 2, NFORM NORM], CONEG @D1783,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT BE, PAST -] : NIL.

WORD around : [FIX NOT, PRT AROUND, INFL -] : AROUND,
   P[-PRO, MODTYPE @D1795, COORD @D1794, NEG @D1793, PRD @D1792,
      LOC @D1791, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : AROUND,
   P[-PRO, MODTYPE @D1800, COORD @D1799, NEG @D1798, PRD @D1797,
      LOC @D1796, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM AROUND] : AROUND.

WORD as : [FIX NOT, SUBCAT AS] : AS,
   DetA[as, FIX NOT, WH NO, UB NO, EVER NO, DISTR PRD] : (as much as),
   [FIX NOT, PRT AS, INFL -] : AS,
   P[-PRO, MODTYPE @D1807, COORD @D1806, NEG @D1805, PRD @D1804, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_AS] : AS,
   P[-PRO, MODTYPE @D1811, COORD @D1810, NEG @D1809, PRD @D1808, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_AS] : AS,
   P[-PRO, MODTYPE @D1815, COORD @D1814, NEG @D1813, PRD @D1812, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OF_AS] : AS,
   P[-PRO, MODTYPE @D1819, COORD @D1818, NEG @D1817, PRD @D1816, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM AS_TO] : AS,
   P[-PRO, MODTYPE @D1823, COORD @D1822, NEG @D1821, PRD @D1820, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM AS] : AS.

WORD aside : [FIX NOT, PRT ASIDE, INFL -] : ASIDE.

WORD astray : [FIX NOT, PRT ASTRAY, INFL -] : ASTRAY.

WORD at :
   P[-PRO, MODTYPE @D1840, COORD @D1839, NEG @D1838, PRD @D1837, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_AT] : AT,
   P[-PRO, MODTYPE @D1844, COORD @D1843, NEG @D1842, PRD @D1841, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM IN_AT] : AT,
   P[-PRO, MODTYPE @D1848, COORD @D1847, NEG @D1846, PRD @D1845, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM AT_FOR] : AT,
   P[-PRO, MODTYPE @D1852, COORD @D1851, NEG @D1850, PRD @D1849, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM AT_ABOUT] : AT,
   P[-PRO, MODTYPE @D1857, COORD @D1856, NEG @D1855, PRD @D1854,
      LOC @D1853, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : AT,
   P[-PRO, MODTYPE @D1862, COORD @D1861, NEG @D1860, PRD @D1859,
      LOC @D1858, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM AT] : AT.

WORD august :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D1869, REFL @D1868,
      PRD @D1867, CASE @D1866, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : AUGUST.

WORD away : [FIX NOT, PRT AWAY, INFL -] : AWAY,
   P[-PRO, MODTYPE @D1877, COORD @D1876, NEG @D1875, PRD @D1874,
      LOC @D1873, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : AWAY.

WORD b :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D1883, REFL @D1882,
      PRD @D1881, CASE @D1880, FIX NOT, SUBCAT NULL, PROTYPE NONE,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, INFL -, ADDRESS -] : (initial B).


WORD be :
   V[BSE, -PRD, -INV, -NEG, -FIN, +AUX, +PRO, COORD @D1904, SUBTYPE @D1903,
      AGR @D1902, FIX NOT, CONEG -, PAST NOT, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[IMP, -PRD, -NEG, +AUX, -PRO, COORD @D1908, INV @D1907, AGR @D1906,
      PAST @D1905, FIX NOT, SUBTYPE NONE, CONEG -, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT BE] : NIL,
   V[BSE, -PRD, -NEG, -FIN, +AUX, -PRO, COORD @D1911, INV @D1910,
      AGR @D1909, FIX NOT, SUBTYPE NONE, CONEG -, PAST NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT BE] : NIL.

WORD because :
   P[-PRO, COORD @D1922, NEG @D1921, PRD @D1920, LOC @D1919, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, PREP OF,
      SUBCAT PP, PFORM NORM] : BECAUSE,
   P[-PRO, COORD @D1925, NEG @D1924, PRD @D1923, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : BECAUSE.

WORD been :
   V[PSP, -INV, -NEG, -FIN, +AUX, +PRO, COORD @D1934, SUBTYPE @D1933,
      AGR @D1932, FIX NOT, CONEG -, PAST NOT, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[PSP, -NEG, -FIN, +AUX, -PRO, COORD @D1937, INV @D1936, AGR @D1935,
      FIX NOT, SUBTYPE NONE, CONEG -, PAST NOT, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT BE] : NIL.

WORD before :
   P[-PRO, COORD @D1947, NEG @D1946, PRD @D1945, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SING,
      PFORM NORM] : BEFORE,
   P[-PRO, COORD @D1950, NEG @D1949, PRD @D1948, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : BEFORE,
   P[-PRO, MODTYPE @D1954, COORD @D1953, NEG @D1952, PRD @D1951, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -, SUBCAT SFIN,
      PFORM NORM] : BEFORE,
   P[-PRO, MODTYPE @D1959, COORD @D1958, NEG @D1957, PRD @D1956,
      LOC @D1955, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : BEFORE,
   P[-PRO, MODTYPE @D1964, COORD @D1963, NEG @D1962, PRD @D1961,
      LOC @D1960, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM BEFORE] : BEFORE,
   A[-ADV, -NEG, -QUA, -NUM, COORD @D1971, DEF @D1970, PRD @D1969,
      AGR N2[CASE @D1968, COUNT @D1967, PER @D1966, PLU @D1965,
            NFORM NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      AFORM NONE, PART -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE -,
      COADV +, DISTR PRD] : BEFORE.

WORD behind : [FIX NOT, PRT BEHIND, INFL -] : BEHIND,
   P[-PRO, MODTYPE @D1982, COORD @D1981, NEG @D1980, PRD @D1979,
      LOC @D1978, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : BEHIND,
   P[-PRO, MODTYPE @D1987, COORD @D1986, NEG @D1985, PRD @D1984,
      LOC @D1983, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM BEHIND] : BEHIND.

WORD being :
   V[ING, -INV, -NEG, -FIN, +AUX, +PRO, COORD @D1997, SUBTYPE @D1996,
      AGR @D1995, PRD @D1994, FIX NOT, CONEG -, PAST NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[ING, -NEG, -FIN, +AUX, -PRO, COORD @D2001, INV @D2000, AGR @D1999,
      PRD @D1998, FIX NOT, SUBTYPE NONE, CONEG -, PAST NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT BE] : NIL.

WORD below :
   P[-PRO, MODTYPE @D2012, COORD @D2011, NEG @D2010, PRD @D2009,
      LOC @D2008, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : BELOW,
   P[-PRO, MODTYPE @D2017, COORD @D2016, NEG @D2015, PRD @D2014,
      LOC @D2013, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM BELOW] : BELOW.

WORD beside :
   P[-PRO, MODTYPE @D2029, COORD @D2028, NEG @D2027, PRD @D2026,
      LOC @D2025, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : BESIDE,
   P[-PRO, MODTYPE @D2034, COORD @D2033, NEG @D2032, PRD @D2031,
      LOC @D2030, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM BESIDE] : BESIDE.

WORD between :
   P[-PRO, MODTYPE @D2048, COORD @D2047, NEG @D2046, PRD @D2045,
      LOC @D2044, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : BETWEEN,
   P[-PRO, MODTYPE @D2053, COORD @D2052, NEG @D2051, PRD @D2050,
      LOC @D2049, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM BETWEEN] : BETWEEN.

WORD both :
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D2063, COORD @D2062,
      AGR N2[+PLU, +COUNT, CASE @D2061, NFORM @D2060, PER @D2059,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q both (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, +COUNT, -NUM, COORD @D2065,
      CASE @D2064, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq both (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D2068, COUNT @D2067,
      CASE @D2066, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART OF] : BOTH,
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D2071, COUNT @D2070,
      CASE @D2069, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART NO_OF] : BOTH,
   [FIX NOT, CONJN +, SUBCAT BOTH] : BOTH.

WORD but : [FIX NOT, CONJN +, SUBCAT BUT] : BUT.

WORD by : [FIX NOT, PRT BY, INFL -] : BY,
   P[-PRO, COORD @D2084, NEG @D2083, PRD @D2082, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : BY,
   P[-PRO, MODTYPE @D2088, COORD @D2087, NEG @D2086, PRD @D2085, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM BY_FOR] : BY,
   P[-PRO, MODTYPE @D2093, COORD @D2092, NEG @D2091, PRD @D2090,
      LOC @D2089, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : BY,
   P[-PRO, by, MODTYPE @D2098, COORD @D2097, NEG @D2096, PRD @D2095,
      LOC @D2094, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : BY.

WORD c :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D2104, REFL @D2103,
      PRD @D2102, CASE @D2101, FIX NOT, SUBCAT NULL, PROTYPE NONE,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, INFL -, ADDRESS -] : (initial C).

WORD can :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D2109, AGR @D2108, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : CAN,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D2111, AGR @D2110, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (POS (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (CAN e x (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2114, INV @D2113, AGR @D2112,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS CAN)).

WORD can't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2121, AGR @D2120,
      CONEG @D2119, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (POS (PROVP e x)))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (CAN e x (PROVP (uqe (some (e2) (NOTENSE e2))) x)))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2125, INV @D2124, AGR @D2123,
      CONEG @D2122, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS CAN)).

WORD cannot :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2132, AGR @D2131,
      CONEG @D2130, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (POS (PROVP e x)))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (CAN e x (PROVP (uqe (some (e2) (NOTENSE e2))) x)))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2136, INV @D2135, AGR @D2134,
      CONEG @D2133, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS CAN)).

WORD certain :
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D2144, COORD @D2143,
      AGR N2[+PLU, +COUNT, CASE @D2142, NFORM @D2141, PER @D2140,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q certain (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   A[-ADV, -NEG, -QUA, -NUM, COADV @D2152, COORD @D2151, DEF @D2150,
      PRD @D2149,
      AGR N2[CASE @D2148, COUNT @D2147, PER @D2146, PLU @D2145,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE +, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   CERTAIN,
   A[-ADV, -NEG, -QUA, -NUM, COADV @D2160, COORD @D2159, DEF @D2158,
      PRD @D2157,
      AGR N2[CASE @D2156, COUNT @D2155, PER @D2154, PLU @D2153,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE +, AFORM NONE,
      PART -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT SFIN, DISTR PRD,
      ARITY 2] : CERTAIN,
   A[-ADV, -NEG, -QUA, -NUM, COADV @D2165, COORD @D2164, DEF @D2163,
      AGR @D2162, PRD @D2161, FIX NOT, INFL +, GRADE +, AFORM NONE, PART -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, SUBCAT WHS,
      DISTR PRD, ARITY 1] : CERTAIN,
   A[-ADV, -NEG, -QUA, -NUM, COADV @D2170, COORD @D2169, DEF @D2168,
      AGR @D2167, PRD @D2166, FIX NOT, INFL +, GRADE +, AFORM NONE, PART -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE EXTRAP, SUBCAT SFIN,
      DISTR PRD, ARITY 1] : CERTAIN,
   A[-ADV, -NEG, -QUA, -NUM, COADV @D2175, COORD @D2174, DEF @D2173,
      AGR @D2172, PRD @D2171, FIX NOT, INFL +, GRADE +, AFORM NONE, PART -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF,
      DISTR PRD, ARITY 1] : CERTAIN,
   A[-ADV, -NEG, -QUA, -NUM, COADV @D2180, COORD @D2179, DEF @D2178,
      AGR @D2177, PRD @D2176, FIX NOT, INFL +, GRADE +, AFORM NONE, PART -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_INF,
      DISTR ATT, ARITY 1] : CERTAIN.

WORD could :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D2185, AGR @D2184, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : COULD,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D2187, AGR @D2186, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (POS (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (COULD e x (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2190, INV @D2189, AGR @D2188,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS COULD)).

WORD couldn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2197, AGR @D2196,
      CONEG @D2195, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST +, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (POS (PROVP e x)))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (COULD e x (PROVP (uqe (some (e2) (NOTENSE e2)))
                           x))))) (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2201, INV @D2200, AGR @D2199,
      CONEG @D2198, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS COULD)).

WORD d :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D2207, REFL @D2206,
      PRD @D2205, CASE @D2204, FIX NOT, SUBCAT NULL, PROTYPE NONE,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, INFL -, ADDRESS -] : (initial D).

WORD dare :
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2214, AGR N2[+NOM, +PLU,
            COUNT @D2213, PER @D2212, NFORM NORM], VFORM NOT, INFL -,
      PAST -, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT SC_BSE, ARITY 2] : DARE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2216,
      AGR N2[+NOM, -PLU, COUNT @D2215, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT SC_BSE, ARITY 2] : DARE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2218,
      AGR N2[+NOM, -PLU, COUNT @D2217, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT SC_BSE, ARITY 2] : DARE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2222,
      AGR N2[+NOM, COUNT @D2221, PER @D2220, PLU @D2219, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT SC_BSE, ARITY 2] : DARE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2228, PAST @D2227,

      AGR N2[CASE @D2226, COUNT @D2225, PER @D2224, PLU @D2223, NFORM
         NORM], FIX NOT, INFL +, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_BSE, ARITY 2] : DARE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2231,
      AGR N2[+NOM, +PLU, COUNT @D2230, PER @D2229, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DARE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2233,
      AGR N2[+NOM, -PLU, COUNT @D2232, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DARE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2235,
      AGR N2[+NOM, -PLU, COUNT @D2234, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DARE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2239,
      AGR N2[+NOM, COUNT @D2238, PER @D2237, PLU @D2236, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DARE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2245, PAST @D2244,

      AGR N2[CASE @D2243, COUNT @D2242, PER @D2241, PLU @D2240, NFORM
         NORM], FIX NOT, INFL +, REG +, PSVE -, SUBTYPE EQUI, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_INF, ARITY 2] : DARE,
   V[-PRD, +INV, -NEG, +FIN, +AUX, -PRO, COORD @D2247, AGR @D2246, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE DEO, PAST -, SUBCAT MODAL_BSE] : DARE.

WORD daren't :
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2256, INV @D2255, AGR @D2254,
      CONEG @D2253, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBTYPE DEO, PAST -, SUBCAT MODAL_BSE] : DARE.

WORD day :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D2263, REFL @D2262,
      PRD @D2261, CASE @D2260, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : DAY,
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D2267, REFL @D2266,
      PRD @D2265, CASE @D2264, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : DAY.

WORD december :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D2274, REFL @D2273,
      PRD @D2272, CASE @D2271, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : DECEMBER.

WORD definitely :
   A[+ADV, -NEG, -QUA, -NUM, COADV @D2283, COORD @D2282, DEF @D2281,
      AGR @D2280, PRD @D2279, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : DEFINITE.

WORD despite :
   P[-PRO, COORD @D2290, NEG @D2289, PRD @D2288, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SING,
      PFORM NORM] : DESPITE,
   P[-PRO, COORD @D2293, NEG @D2292, PRD @D2291, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : DESPITE.

WORD did :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D2299, SUBTYPE @D2298,
      AGR @D2297, FIX NOT, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, PAST +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2303,
      AGR N2[+NOM, COUNT @D2302, PER @D2301, PLU @D2300, NFORM NORM],
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT NP, REG -] : DO,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2306, INV @D2305, AGR @D2304,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST +, SUBCAT DO] : NIL.

WORD didn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2314, SUBTYPE @D2313,
      AGR @D2312, CONEG @D2311, FIX NOT, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, PAST +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2318, INV @D2317, AGR @D2316,
      CONEG @D2315, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST +, SUBCAT DO] : NIL.

WORD do :
   V[IMP, -PRD, -INV, -NEG, +AUX, +PRO, COORD @D2325, SUBTYPE @D2324,
      AGR @D2323, PAST @D2322, FIX NOT, CONEG -, PSVE -, CONJ NULL, AT +,
      LAT +, SUBCAT NULL, INFL -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[BSE, -PRD, -INV, -NEG, -FIN, +AUX, +PRO, COORD @D2328, SUBTYPE @D2327,
      AGR @D2326, FIX NOT, CONEG -, PAST NOT, PSVE -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL, INFL -, REG -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2331,
      AGR N2[+NOM, +PLU, COUNT @D2330, PER @D2329, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2333,
      AGR N2[+NOM, -PLU, COUNT @D2332, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2335,
      AGR N2[+NOM, -PLU, COUNT @D2334, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2339,
      AGR N2[+NOM, COUNT @D2338, PER @D2337, PLU @D2336, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2345, PAST @D2344,

      AGR N2[CASE @D2343, COUNT @D2342, PER @D2341, PLU @D2340, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT NP, REG -] : DO,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2350, INV @D2349,
      AGR N2[+NOM, +PLU, NFORM @D2348, COUNT @D2347, PER @D2346], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2353, INV @D2352,
      AGR N2[+NOM, -PLU, COUNT @D2351, PER 2, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2356, INV @D2355,
      AGR N2[+NOM, -PLU, COUNT @D2354, PER 1, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[IMP, -PRD, -NEG, +AUX, -PRO, COORD @D2360, INV @D2359, AGR @D2358,
      PAST @D2357, FIX NOT, SUBTYPE NONE, CONEG -, PSVE -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT DO, INFL -] : NIL,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2363,
      AGR N2[+NOM, +PLU, COUNT @D2362, PER @D2361, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2365,
      AGR N2[+NOM, -PLU, COUNT @D2364, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2367,
      AGR N2[+NOM, -PLU, COUNT @D2366, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2371,
      AGR N2[+NOM, COUNT @D2370, PER @D2369, PLU @D2368, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM WITH, ARITY 3] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2377, PAST @D2376,

      AGR N2[CASE @D2375, COUNT @D2374, PER @D2373, PLU @D2372, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM WITH,
      ARITY 3] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2380, AGR
         N2[+NOM, +PLU, COUNT @D2379, PER @D2378, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, ARITY 3] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2382,
      AGR N2[+NOM, -PLU, COUNT @D2381, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, ARITY 3] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2384,
      AGR N2[+NOM, -PLU, COUNT @D2383, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, ARITY 3] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2388,
      AGR N2[+NOM, COUNT @D2387, PER @D2386, PLU @D2385, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, PFORM OF, ARITY 3] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2394, PAST @D2393,

      AGR N2[CASE @D2392, COUNT @D2391, PER @D2390, PLU @D2389, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PRT OUT, PFORM OF,
      ARITY 3] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2397, AGR
         N2[+NOM, +PLU, COUNT @D2396, PER @D2395, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITHOUT, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2399,
      AGR N2[+NOM, -PLU, COUNT @D2398, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITHOUT, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2401,
      AGR N2[+NOM, -PLU, COUNT @D2400, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITHOUT, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2405,
      AGR N2[+NOM, COUNT @D2404, PER @D2403, PLU @D2402, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITHOUT, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2411, PAST @D2410,

      AGR N2[CASE @D2409, COUNT @D2408, PER @D2407, PLU @D2406, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITHOUT,
      ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2414, AGR
         N2[+NOM, +PLU, COUNT @D2413, PER @D2412, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2416,
      AGR N2[+NOM, -PLU, COUNT @D2415, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2418,
      AGR N2[+NOM, -PLU, COUNT @D2417, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2422,
      AGR N2[+NOM, COUNT @D2421, PER @D2420, PLU @D2419, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2428, PAST @D2427,

      AGR N2[CASE @D2426, COUNT @D2425, PER @D2424, PLU @D2423, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM WITH, ARITY 2] :
   DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2431, AGR N2[+NOM, +PLU,
            COUNT @D2430, PER @D2429, NFORM NORM], VFORM NOT, INFL -,
      PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, PFORM WITH, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2433,
      AGR N2[+NOM, -PLU, COUNT @D2432, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, PFORM WITH, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2435,
      AGR N2[+NOM, -PLU, COUNT @D2434, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, PFORM WITH, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2439,
      AGR N2[+NOM, COUNT @D2438, PER @D2437, PLU @D2436, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, PFORM WITH, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2445, PAST @D2444,

      AGR N2[CASE @D2443, COUNT @D2442, PER @D2441, PLU @D2440, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PRT AWAY, PFORM WITH,
      ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2448, AGR
         N2[+NOM, +PLU, COUNT @D2447, PER @D2446, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2450,
      AGR N2[+NOM, -PLU, COUNT @D2449, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2452,
      AGR N2[+NOM, -PLU, COUNT @D2451, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2456,
      AGR N2[+NOM, COUNT @D2455, PER @D2454, PLU @D2453, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2462, PAST @D2461,

      AGR N2[CASE @D2460, COUNT @D2459, PER @D2458, PLU @D2457, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP, REG -, PFORM FOR, ARITY 2] :
   DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2465, AGR N2[+NOM, +PLU,
            COUNT @D2464, PER @D2463, NFORM NORM], VFORM NOT, INFL -,
      PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2467,
      AGR N2[+NOM, -PLU, COUNT @D2466, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2469,
      AGR N2[+NOM, -PLU, COUNT @D2468, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2473,
      AGR N2[+NOM, COUNT @D2472, PER @D2471, PLU @D2470, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2479, PAST @D2478,

      AGR N2[CASE @D2477, COUNT @D2476, PER @D2475, PLU @D2474, NFORM
         NORM], FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2482,
      AGR N2[+NOM, +PLU, COUNT @D2481, PER @D2480, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2484,
      AGR N2[+NOM, -PLU, COUNT @D2483, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2486,
      AGR N2[+NOM, -PLU, COUNT @D2485, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2490,
      AGR N2[+NOM, COUNT @D2489, PER @D2488, PLU @D2487, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2496, PAST @D2495,

      AGR N2[CASE @D2494, COUNT @D2493, PER @D2492, PLU @D2491, NFORM
         NORM], FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OVER, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2499,
      AGR N2[+NOM, +PLU, COUNT @D2498, PER @D2497, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2501,
      AGR N2[+NOM, -PLU, COUNT @D2500, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2503,
      AGR N2[+NOM, -PLU, COUNT @D2502, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2507,
      AGR N2[+NOM, COUNT @D2506, PER @D2505, PLU @D2504, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2513, PAST @D2512,

      AGR N2[CASE @D2511, COUNT @D2510, PER @D2509, PLU @D2508, NFORM
         NORM], FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT OUT, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2516,
      AGR N2[+NOM, +PLU, COUNT @D2515, PER @D2514, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT IN, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2518,
      AGR N2[+NOM, -PLU, COUNT @D2517, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT IN, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2520,
      AGR N2[+NOM, -PLU, COUNT @D2519, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT IN, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2524,
      AGR N2[+NOM, COUNT @D2523, PER @D2522, PLU @D2521, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT IN, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2530, PAST @D2529,

      AGR N2[CASE @D2528, COUNT @D2527, PER @D2526, PLU @D2525, NFORM
         NORM], FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT IN, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2533,
      AGR N2[+NOM, +PLU, COUNT @D2532, PER @D2531, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2535,
      AGR N2[+NOM, -PLU, COUNT @D2534, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2537,
      AGR N2[+NOM, -PLU, COUNT @D2536, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2541,
      AGR N2[+NOM, COUNT @D2540, PER @D2539, PLU @D2538, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2547, PAST @D2546,

      AGR N2[CASE @D2545, COUNT @D2544, PER @D2543, PLU @D2542, NFORM
         NORM], FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT DOWN, ARITY 2] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2550,
      AGR N2[+NOM, +PLU, COUNT @D2549, PER @D2548, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NULL, REG -, PRT WITHOUT, ARITY 1] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2552,
      AGR N2[+NOM, -PLU, COUNT @D2551, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NULL, REG -, PRT WITHOUT, ARITY 1] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2554,
      AGR N2[+NOM, -PLU, COUNT @D2553, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NULL, REG -, PRT WITHOUT, ARITY 1] : DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2558,
      AGR N2[+NOM, COUNT @D2557, PER @D2556, PLU @D2555, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NULL, REG -, PRT WITHOUT, ARITY 1] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2564, PAST @D2563,

      AGR N2[CASE @D2562, COUNT @D2561, PER @D2560, PLU @D2559, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT NULL, REG -, PRT WITHOUT, ARITY 1] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2566,
      AGR N2[+NOM, -PLU, COUNT @D2565, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, SUBTYPE RAIS, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT SC_ING, REG -, PREP WITH, ARITY 1] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2568,
      AGR N2[+NOM, -PLU, COUNT @D2567, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, SUBTYPE RAIS, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT SC_ING, REG -, PREP WITH, ARITY 1] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2572,
      AGR N2[+NOM, +PLU, NFORM @D2571, COUNT @D2570, PER @D2569],
      VFORM NOT, INFL -, PAST -, SUBTYPE RAIS, FIX NOT, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT SC_ING, REG -, PREP WITH, ARITY 1] :
   DO,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D2576, AGR N2[+NOM, COUNT
               @D2575, PER @D2574, PLU @D2573, NFORM NORM], INFL -,
      PAST NOT, SUBTYPE RAIS, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT SC_ING, REG -, PREP WITH, ARITY 1] : DO,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2579, AGR @D2578,
      PAST @D2577, FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE RAIS, SUBCAT SC_ING, REG -, PREP WITH, ARITY 1] :
   DO.

WORD does :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D2588, SUBTYPE @D2587,
      AGR N2[+NOM, -PLU, NFORM @D2586, COUNT @D2585, PER 3], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D2594, SUBTYPE @D2593,
      AGR V2[UB @D2592, VFORM @D2591, SUBJ @D2590, FIN @D2589], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2598, INV @D2597,
      AGR N2[+NOM, -PLU, NFORM @D2596, COUNT @D2595, PER 3], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D2604, INV @D2603,
      AGR V2[UB @D2602, VFORM @D2601, SUBJ @D2600, FIN @D2599], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2606,
      AGR N2[+NOM, -PLU, COUNT @D2605, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NP, PSVE -, VFORM NOT, INFL -,
      AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2608,
      AGR N2[+NOM, -PLU, COUNT @D2607, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PFORM WITH, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2610,
      AGR N2[+NOM, -PLU, COUNT @D2609, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT NP_PP, PRT OUT, PFORM OF,
      PSVE -, VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2612,
      AGR N2[+NOM, -PLU, COUNT @D2611, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITHOUT, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2614,
      AGR N2[+NOM, -PLU, COUNT @D2613, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM WITH, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2616,
      AGR N2[+NOM, -PLU, COUNT @D2615, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PRT AWAY, PFORM WITH,
      PSVE -, VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2618,
      AGR N2[+NOM, -PLU, COUNT @D2617, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, CONJ NULL, SUBTYPE PVERB, SUBCAT PP, PFORM FOR, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2620,
      AGR N2[+NOM, -PLU, COUNT @D2619, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT UP, PSVE -, VFORM NOT,
      INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2622,
      AGR N2[+NOM, -PLU, COUNT @D2621, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OVER, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2624,
      AGR N2[+NOM, -PLU, COUNT @D2623, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT OUT, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2626,
      AGR N2[+NOM, -PLU, COUNT @D2625, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT IN, PSVE -, VFORM NOT,
      INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2628,
      AGR N2[+NOM, -PLU, COUNT @D2627, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, SUBCAT NP, SUBTYPE NONE, CONJ NULL, PRT DOWN, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2630,
      AGR N2[+NOM, -PLU, COUNT @D2629, NFORM NORM, PER 3], COMPOUND NOT,
      FIX NOT, SUBTYPE NONE, CONJ NULL, SUBCAT NULL, PRT WITHOUT, PSVE -,
      VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2634,
      AGR N2[-PLU, CASE @D2633, NFORM @D2632, COUNT @D2631, PER 3],
      COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, CONJ NULL,
      PREP WITH, PSVE -, VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D2639,
      AGR V2[UB @D2638, VFORM @D2637, SUBJ @D2636, FIN @D2635],
      COMPOUND NOT, FIX NOT, SUBTYPE RAIS, SUBCAT SC_ING, CONJ NULL,
      PREP WITH, PSVE -, VFORM NOT, INFL -, AT +, LAT +, PAST -] : DO.

WORD doesn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2652, SUBTYPE @D2651,
      AGR N2[+NOM, -PLU, NFORM @D2650, COUNT @D2649, PER 3], CONEG @D2648,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2659, SUBTYPE @D2658,
      AGR V2[UB @D2657, VFORM @D2656, SUBJ @D2655, FIN @D2654],
      CONEG @D2653, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2664, INV @D2663,
      AGR N2[+NOM, -PLU, NFORM @D2662, COUNT @D2661, PER 3], CONEG @D2660,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2671, INV @D2670,
      AGR V2[UB @D2669, VFORM @D2668, SUBJ @D2667, FIN @D2666],
      CONEG @D2665, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL.

WORD don't :
   V[IMP, -PRD, -INV, +NEG, +AUX, +PRO, COORD @D2682, SUBTYPE @D2681,
      AGR @D2680, PAST @D2679, CONEG @D2678, FIX NOT, PSVE -, CONJ NULL,
      AT +, LAT +, SUBCAT NULL, INFL -] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2688, SUBTYPE @D2687,
      AGR N2[+NOM, +PLU, NFORM @D2686, COUNT @D2685, PER @D2684],
      CONEG @D2683, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2692, SUBTYPE @D2691,
      AGR N2[+NOM, -PLU, COUNT @D2690, PER 2, NFORM NORM], CONEG @D2689,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D2696, SUBTYPE @D2695,
      AGR N2[+NOM, -PLU, COUNT @D2694, PER 1, NFORM NORM], CONEG @D2693,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[IMP, -PRD, +NEG, +AUX, -PRO, COORD @D2701, INV @D2700, AGR @D2699,
      PAST @D2698, CONEG @D2697, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT DO, INFL -] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2707, INV @D2706,
      AGR N2[+NOM, +PLU, NFORM @D2705, COUNT @D2704, PER @D2703],
      CONEG @D2702, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2711, INV @D2710,
      AGR N2[+NOM, -PLU, COUNT @D2709, PER 2, NFORM NORM], CONEG @D2708,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D2715, INV @D2714,
      AGR N2[+NOM, -PLU, COUNT @D2713, PER 1, NFORM NORM], CONEG @D2712,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT DO] : NIL.

WORD done :
   V[PAS, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2727, PAST @D2726,
      AGR N2[CASE @D2725, COUNT @D2724, PER @D2723, PLU @D2722,
            NFORM NORM], PSVE +, FIX NOT, SUBTYPE NONE, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -] : DO,
   V[PSP, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D2733, PAST @D2732,
      AGR N2[CASE @D2731, COUNT @D2730, PER @D2729, PLU @D2728,
            NFORM NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT NP, REG -] : DO.

WORD double :
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D2746, COORD @D2745,
      AGR N2[-PLU, CASE @D2744, NFORM @D2743, COUNT @D2742, PER @D2741],
      FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, SUBCAT NULL, DISTR ATT,
      INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, PART NO_OF] : DOUBLE.

WORD down : [FIX NOT, PRT DOWN, INFL -] : DOWN,
   P[-PRO, MODTYPE @D2758, COORD @D2757, NEG @D2756, PRD @D2755,
      LOC @D2754, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM DOWN] : DOWN,
   P[-PRO, MODTYPE @D2763, COORD @D2762, NEG @D2761, PRD @D2760,
      LOC @D2759, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : DOWN,
   P[-PRO, MODTYPE @D2767, COORD @D2766, NEG @D2765, PRD @D2764, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM DOWN_TO] : DOWN,
   P[-PRO, MODTYPE @D2772, COORD @D2771, NEG @D2770, PRD @D2769,
      LOC @D2768, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : DOWN,
   P[-PRO, MODTYPE @D2777, COORD @D2776, NEG @D2775, PRD @D2774,
      LOC @D2773, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM DOWN] : DOWN.

WORD during :
   P[-PRO, MODTYPE @D2785, COORD @D2784, NEG @D2783, PRD @D2782,
      LOC @D2781, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : DURING,
   P[-PRO, MODTYPE @D2790, COORD @D2789, NEG @D2788, PRD @D2787,
      LOC @D2786, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM DURING] : DURING.

WORD each :
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D2797, COORD @D2796,
      AGR N2[-PLU, +COUNT, CASE @D2795, NFORM @D2794, PER @D2793,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q each (lambda (x) (lambda (P) (and (sg x) (P x)))))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, +COUNT, -NUM, COORD @D2799,
      CASE @D2798, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq each (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D2802, COUNT @D2801,
      CASE @D2800, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART OF] : ALL.

WORD earlier :
   A[-ADV, -NEG, -QUA, -NUM, COORD @D2811, DEF @D2810, PRD @D2809,
      AGR N2[CASE @D2808, COUNT @D2807, PER @D2806, PLU @D2805,
            NFORM NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      AFORM NONE, PART -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE -,
      COADV +, DISTR PRD] : EARLIER.

WORD eg :
   P[-PRO, COORD @D2817, NEG @D2816, PRD @D2815, LOC @D2814, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, SUBCAT SFIN,
      PFORM NORM] : EG,
   P[-PRO, MODTYPE @D2821, COORD @D2820, NEG @D2819, PRD @D2818, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM NORM] : EG.

WORD eight : [AND @D2824, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |8|.

WORD eighteen : [AND @D2829, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |18|.

WORD eighteenth :
   DetA[ORD, DISTR @D2836, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   EIGHTEENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D2844, COORD @D2843, DEF @D2842,
      PRD @D2841,
      AGR N2[CASE @D2840, COUNT @D2839, PER @D2838, PLU @D2837,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   EIGHTEENTH, -PLU[FIX NOT, FRACT -] : |18|.

WORD eighteenths : +PLU[FIX NOT, INFL -, FRACT -] : |18|.

WORD eighth :
   DetA[ORD, DISTR @D2857, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   EIGHTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D2865, COORD @D2864, DEF @D2863,
      PRD @D2862,
      AGR N2[CASE @D2861, COUNT @D2860, PER @D2859, PLU @D2858,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   EIGHTH, -PLU[FIX NOT, FRACT -] : |8|.

WORD eighths : +PLU[FIX NOT, INFL -, FRACT -] : |8|.

WORD eightieth :
   DetA[ORD, DISTR @D2878, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   EIGHTIETH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D2886, COORD @D2885, DEF @D2884,
      PRD @D2883,
      AGR N2[CASE @D2882, COUNT @D2881, PER @D2880, PLU @D2879,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   EIGHTIETH, -PLU[FIX NOT, FRACT -] : |80|.

WORD eightieths : +PLU[FIX NOT, INFL -, FRACT -] : |80|.

WORD eighty : [AND @D2898, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |80|.

WORD either : -NEG[FIX NOT, CONEG +, SO +] : EITHER,
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D2905, COORD @D2904,
      AGR N2[-PLU, +COUNT, CASE @D2903, NFORM @D2902, PER @D2901,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q either (lambda (x) (lambda (P) (and (sg x) (P x)))))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, +COUNT, -NUM, COORD @D2907,
      CASE @D2906, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq either (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D2910, COUNT @D2909,
      CASE @D2908, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART OF] : EITHER,
   [FIX NOT, CONJN +, SUBCAT EITHER] : EITHER.

WORD eleven : [AND @D2913, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |11|.

WORD eleventh :
   DetA[ORD, DISTR @D2918, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   ELEVENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D2926, COORD @D2925, DEF @D2924,
      PRD @D2923,
      AGR N2[CASE @D2922, COUNT @D2921, PER @D2920, PLU @D2919,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   ELEVENTH, -PLU[FIX NOT, FRACT -] : |11|.

WORD elevenths : +PLU[FIX NOT, INFL -, FRACT -] : |11|.

WORD else :
   A[-ADV, -NEG, -QUA, -NUM, COORD @D2942, DEF @D2941, PRD @D2940,
      AGR N2[CASE @D2939, COUNT @D2938, PER @D2937, PLU @D2936,
            NFORM NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      AFORM NONE, PART -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE -,
      COADV -, DISTR PRD] : ELSE,
   P[-PRO, COORD @D2945, NEG @D2944, PRD @D2943, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : ELSE.

WORD enough :
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D2952, COORD @D2951,
      AGR N2[+PLU, +COUNT, CASE @D2950, NFORM @D2949, PER @D2948,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q enough (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D2957, COORD @D2956,
      AGR N2[-PLU, -COUNT, CASE @D2955, NFORM @D2954, PER @D2953,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q enough (lambda (x) (lambda (P) (and (ms x) (P x)))))),
   N[-PRD, -POSS, -ADV, +ACC, -DEF, +PRO, -NUM, COORD @D2960, COUNT @D2959,
      PLU @D2958, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq enough (lambda (x) (and (or (ms x) (pl x))
                  (entity x))))),
   N[-PRD, -POSS, -ADV, +NOM, -DEF, +PLU, +PRO, -NUM, COORD @D2962,
      COUNT @D2961, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq enough (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +NOM, -DEF, -PLU, +PRO, -COUNT, -NUM, COORD @D2963,
      FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +, LAT +,
      PROTYPE PMOD] :
   (lambda (Q) (Q uq enough (lambda (x) (and (ms x) (entity x))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D2969, COORD @D2968,
      AGR N2[CASE @D2967, COUNT @D2966, PER @D2965, PLU @D2964,
            NFORM NORM], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART OF] : ENOUGH.

WORD esq :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D2975, REFL @D2974,
      PRD @D2973, CASE @D2972, FIX NOT, SUBCAT NULL, PROTYPE NONE, PN -,
      NFORM NORM, PER 3, PART -, DEMON -, ADDRESS +, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT] : ESQ.

WORD etc : X2[+PRD, FIX NOT, SLASH NOSLASH, CONJ AND] : ETC,
   VP[-NEG, -AUX, -PRO, ELLIP @D2984, COORD @D2983, AGR @D2982,
      PAST @D2981, VFORM @D2980, FIN @D2979, PRD @D2978, FIX NOT,
      SLASH NOSLASH, AT +, LAT +, COMPOUND NOT, CONJ AND] : ETC,
   A2[-ADV, -NEG, -QUA, -NUM, EVER @D2996, UB @D2995, WH @D2994,
      COADV @D2993, COORD @D2992, DISTR @D2991, DEF @D2990, PRD @D2989,

      AGR N2[CASE @D2988, COUNT @D2987, PER @D2986, PLU @D2985, NFORM
         NORM], FIX NOT, SLASH NOSLASH, GRADE +, AFORM NONE, PART -, AT +,
      LAT +, COMPOUND NOT, CONJ AND] : ETC,
   P2[-PRO, MODTYPE @D3006, COORD @D3005, NEG @D3004, PRD @D3003,
      LOC @D3002, EVER @D3001, UB @D3000, WH @D2999, GERUND @D2998,
      POSS @D2997, FIX NOT, SLASH NOSLASH, PFORM NORM, AT +, LAT +,
      COMPOUND NOT, CONJ AND] : ETC,
   N2[-PRO, -NUM, PART @D3027, ADV @D3026, COORD @D3025, REFL @D3024,
      PER @D3023, COUNT @D3022, PN @D3021, PRD @D3020, CASE @D3019,
      POSS @D3018, PLU @D3017, EVER @D3016, UB @D3015, WH @D3014,
      KIND @D3013, COADV @D3012, QFEAT @D3011, AFORM @D3010, NEG @D3009,
      DEF @D3008, SPEC @D3007, FIX NOT, SLASH NOSLASH, PROTYPE NONE,
      NFORM NORM, DEMON -, AT +, LAT +, COMPOUND NOT, CONJ AND] : ETC.

WORD every :
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D3035, COORD @D3034,
      AGR N2[-PLU, +COUNT, CASE @D3033, NFORM @D3032, PER @D3031,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q every (lambda (x) (lambda (P) (and (sg x) (P x)))))).

WORD everybody :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D3043, COUNT @D3042,
      CASE @D3041, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq every (lambda (x) (and (sg x) (person x))))).

WORD everyone :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D3051, COUNT @D3050,
      CASE @D3049, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq every (lambda (x) (and (sg x) (person x))))).

WORD everything :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D3058, COUNT @D3057,
      CASE @D3056, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq every (lambda (x) (and (sg x) (entity x))))).

WORD everywhere :
   N[+PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D3066, COUNT @D3065,
      CASE @D3064, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq every (lambda (x) (and (sg x) (place x))) AT)).

WORD far : [FIX NOT, PRT FAR, INFL -] : FAR,
   A[+ADV, -NEG, -QUA, -NUM, COADV @D3073, COORD @D3072, DEF @D3071,
      AGR @D3070, PRD @D3069, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : FAR,
   A[+ADV, -NEG, -QUA, -NUM, COADV @D3078, COORD @D3077, DEF @D3076,
      AGR @D3075, PRD @D3074, FIX NOT, SUBTYPE NONE, INFL +, COMPAR NO,
      GRADE -, AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +,
      LAT +, COMPOUND NOT] : FAR,
   A[+ADV, -NEG, -QUA, -NUM, COADV @D3083, COORD @D3082, DEF @D3081,
      AGR @D3080, PRD @D3079, FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      COMPAR INFL, GRADE +, AFORM NONE, PART -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, DISTR PREPP] : FAR.

WORD february :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D3090, REFL @D3089,
      PRD @D3088, CASE @D3087, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : FEBRUARY.

WORD few :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D3098, COORD @D3097,
      AGR +N[+PLU, +COUNT, CASE @D3096, NFORM @D3095, PER @D3094,
            BAR @D3093, V -], FIX NOT, SUBTYPE NONE, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +,
      INFL +] :
   (lambda (P) (lambda (Q) (lambda (T) (T few (lambda (x) (and (Q x)
                        (P x))))))),
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, +COUNT, -NUM, COORD @D3100,
      CASE @D3099, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD+] :
   (lambda (Q) (Q uq few (lambda (x) (and (pl x) (entity x))))),
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D3105, COORD @D3104,
      AGR N2[+PLU, +COUNT, CASE @D3103, NFORM @D3102, PER @D3101],
      FIX NOT, SUBTYPE NONE, AFORM NONE, SUBCAT NULL, DISTR ATT, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +, PART OF] : FEW.

WORD fewer :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D3114, COORD @D3113,

      AGR +N[+PLU, +COUNT, CASE @D3112, NFORM @D3111, PER @D3110, BAR
               @D3109, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T fewer (lambda (x) (and (Q x) (P x))))))),

   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D3119, COORD @D3118,
      AGR N2[+PLU, +COUNT, CASE @D3117, NFORM @D3116, PER @D3115],
      FIX NOT, SUBTYPE NONE, SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, GRADE +, PART OF] : FEW.

WORD fewest :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, est, COADV @D3128, COORD @D3127,

      AGR +N[+PLU, +COUNT, CASE @D3126, NFORM @D3125, PER @D3124, BAR
               @D3123, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T fewest (lambda (x) (and (Q x) (P x))))))).

WORD fifteen : [AND @D3132, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |15|.

WORD fifteenth :
   DetA[ORD, DISTR @D3138, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   FIFTEENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D3146, COORD @D3145, DEF @D3144,
      PRD @D3143,
      AGR N2[CASE @D3142, COUNT @D3141, PER @D3140, PLU @D3139,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   FIFTEENTH, -PLU[FIX NOT, FRACT -] : |15|.

WORD fifteenths : +PLU[FIX NOT, INFL -, FRACT -] : |15|.

WORD fifth :
   DetA[ORD, DISTR @D3157, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   FIFTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D3165, COORD @D3164, DEF @D3163,
      PRD @D3162,
      AGR N2[CASE @D3161, COUNT @D3160, PER @D3159, PLU @D3158,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   FIFTH, -PLU[FIX NOT, FRACT -] : |5|.

WORD fifths : +PLU[FIX NOT, INFL -, FRACT -] : |5|.

WORD fiftieth :
   DetA[ORD, DISTR @D3174, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   FIFTIETH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D3182, COORD @D3181, DEF @D3180,
      PRD @D3179,
      AGR N2[CASE @D3178, COUNT @D3177, PER @D3176, PLU @D3175,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   FIFTIETH, -PLU[FIX NOT, FRACT -] : |50|.

WORD fiftieths : +PLU[FIX NOT, INFL -, FRACT -] : |50|.

WORD fifty : [AND @D3191, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |50|.

WORD first :
   DetA[ORD, DISTR @D3194, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   FIRST,
   A[-ADV, -NEG, -QUA, ORD, COADV @D3202, COORD @D3201, DEF @D3200,
      PRD @D3199,
      AGR N2[CASE @D3198, COUNT @D3197, PER @D3196, PLU @D3195,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   FIRST.

WORD five : [AND @D3206, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |5|.

WORD flat : [FIX NOT, PRT FLAT, INFL -] : FLAT.

WORD for : [FIX NOT, SUBCAT FOR] : NIL, [FIX NOT, PRT FOR, INFL -] : FOR,
   P[-PRO, MODTYPE @D3214, COORD @D3213, NEG @D3212, PRD @D3211, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_FOR] : FOR,
   P[-PRO, MODTYPE @D3218, COORD @D3217, NEG @D3216, PRD @D3215, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_FOR] : FOR,
   P[-PRO, MODTYPE @D3222, COORD @D3221, NEG @D3220, PRD @D3219, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_FOR] : FOR,
   P[-PRO, MODTYPE @D3226, COORD @D3225, NEG @D3224, PRD @D3223, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OF_FOR] : FOR,
   P[-PRO, MODTYPE @D3230, COORD @D3229, NEG @D3228, PRD @D3227, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FROM_FOR] : FOR,
   P[-PRO, MODTYPE @D3234, COORD @D3233, NEG @D3232, PRD @D3231, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FOR_WITH] : FOR,
   P[-PRO, MODTYPE @D3238, COORD @D3237, NEG @D3236, PRD @D3235, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FOR_TO] : FOR,
   P[-PRO, MODTYPE @D3242, COORD @D3241, NEG @D3240, PRD @D3239, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM BY_FOR] : FOR,
   P[-PRO, MODTYPE @D3246, COORD @D3245, NEG @D3244, PRD @D3243, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM AT_FOR] : FOR,
   P[-PRO, MODTYPE @D3250, COORD @D3249, NEG @D3248, PRD @D3247, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM NORM] : FOR,
   P[-PRO, MODTYPE @D3254, COORD @D3253, NEG @D3252, PRD @D3251, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FOR] : FOR.

WORD forth : [FIX NOT, PRT FORTH, INFL -] : FORTH.

WORD forty : [AND @D3263, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |40|.

WORD forward : [FIX NOT, PRT FORWARD, INFL -] : FORWARD.

WORD forwards : [FIX NOT, PRT FORWARDS, INFL -] : FORWARDS.

WORD four : [AND @D3275, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |4|.

WORD four-fifths : +PLU[FIX NOT, INFL -, FRACT +] : (/ |4| |5|).

WORD fourteen : [AND @D3282, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |14|.

WORD fourteenth :
   DetA[ORD, DISTR @D3288, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   FOURTEENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D3296, COORD @D3295, DEF @D3294,
      PRD @D3293,
      AGR N2[CASE @D3292, COUNT @D3291, PER @D3290, PLU @D3289,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   FOURTEENTH, -PLU[FIX NOT, FRACT -] : |14|.

WORD fourteenths : +PLU[FIX NOT, INFL -, FRACT -] : |14|.

WORD fourth :
   DetA[ORD, DISTR @D3307, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   FOURTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D3315, COORD @D3314, DEF @D3313,
      PRD @D3312,
      AGR N2[CASE @D3311, COUNT @D3310, PER @D3309, PLU @D3308,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   FOURTH.

WORD fourtieth : -PLU[FIX NOT, FRACT -] : |40|.

WORD fourtieths : +PLU[FIX NOT, INFL -, FRACT -] : |40|.

WORD frequently :
   A[+ADV, -NEG, -DEF, +QUA, -NUM, COADV @D3329, COORD @D3328, AGR @D3327,
      PRD @D3326, FIX NOT, SUBTYPE NONE, AFORM NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   frequently.

WORD friday :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D3335, REFL @D3334,
      PRD @D3333, CASE @D3332, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : FRIDAY.

WORD from :
   P[-PRO, MODTYPE @D3342, COORD @D3341, NEG @D3340, PRD @D3339,
      LOC @D3338, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : FROM,
   P[-PRO, MODTYPE @D3346, COORD @D3345, NEG @D3344, PRD @D3343, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_FROM] : FROM,
   P[-PRO, MODTYPE @D3350, COORD @D3349, NEG @D3348, PRD @D3347, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FROM_TO] : FROM,
   P[-PRO, MODTYPE @D3354, COORD @D3353, NEG @D3352, PRD @D3351, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FROM_INTO] : FROM,
   P[-PRO, MODTYPE @D3358, COORD @D3357, NEG @D3356, PRD @D3355, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FROM_FOR] : FROM,
   P[-PRO, MODTYPE @D3363, COORD @D3362, NEG @D3361, PRD @D3360,
      LOC @D3359, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : FROM,
   P[-PRO, MODTYPE @D3367, COORD @D3366, NEG @D3365, PRD @D3364, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FROM] : FROM.

WORD further :
   P[-PRO, COORD @D3373, NEG @D3372, PRD @D3371, LOC @D3370, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, PREP TO,
      SUBCAT PP, PFORM NORM] : FURTHER.

WORD gram :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D3379, REFL @D3378,
      PRD @D3377, CASE @D3376, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, DEMON -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART NO_OF] : GRAM,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D3383, REFL @D3382,
      PRD @D3381, CASE @D3380, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, DEMON -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART OF] : GRAM,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D3387, REFL @D3386,
      PRD @D3385, CASE @D3384, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : GRAM.

WORD had :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D3393, SUBTYPE @D3392,
      AGR @D3391, FIX NOT, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, PAST +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x)))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[PAS, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3398,
      AGR N2[CASE @D3397, COUNT @D3396, PER @D3395, PLU @D3394,
            NFORM NORM], PSVE +, FIX NOT, SUBTYPE NONE, PAST NOT, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP] : HAVE,
   V[PSP, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3403,
      AGR N2[CASE @D3402, COUNT @D3401, PER @D3400, PLU @D3399,
            NFORM NORM], FIX NOT, SUBTYPE NONE, PAST NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT NP] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3407,
      AGR N2[+NOM, COUNT @D3406, PER @D3405, PLU @D3404, NFORM NORM],
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT NP] : HAVE,
   V[PSP, -NEG, -FIN, +AUX, -PRO, COORD @D3410, INV @D3409, AGR @D3408,
      FIX NOT, SUBTYPE NONE, CONEG -, PAST NOT, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC HAVE-TO)),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3413, INV @D3412, AGR @D3411,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST +, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC HAVE-TO)),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3416, INV @D3415, AGR @D3414,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST +, SUBCAT HAVE] : NIL.

WORD hadn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D3424, SUBTYPE @D3423,
      AGR @D3422, CONEG @D3421, FIX NOT, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, PAST +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D3428, INV @D3427, AGR @D3426,
      CONEG @D3425, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST +, SUBCAT HAVE] : NIL.

WORD half : -PLU[FIX NOT, FRACT -] : |2|,
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D3435, COUNT @D3434,
      CASE @D3433, PLU @D3432, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO,
      INFL -, UB NO, EVER NO, CONJ NULL, AT +, LAT +] :
   (uq (half (x) (pl x))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D3441, COORD @D3440,
      AGR N2[CASE @D3439, COUNT @D3438, PER @D3437, PLU @D3436,
            NFORM NORM], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART OF] : HALF,
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D3447, COORD @D3446,
      AGR N2[CASE @D3445, COUNT @D3444, PER @D3443, PLU @D3442,
            NFORM NORM], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART NO_OF] : HALF.

WORD halloween :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D3454, REFL @D3453,
      PRD @D3452, CASE @D3451, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : HALLOWEEN.

WORD halves : +PLU[FIX NOT, INFL -, FRACT -] : |2|.

WORD has :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D3466, SUBTYPE @D3465,
      AGR V2[UB @D3464, VFORM @D3463, SUBJ @D3462, FIN @D3461], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2)
               (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D3470, SUBTYPE @D3469,
      AGR N2[+NOM, -PLU, NFORM @D3468, COUNT @D3467, PER 3], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2)
               (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3473,
      AGR N2[+NOM, -PLU, NFORM @D3472, COUNT @D3471, PER 3], FIX NOT,
      SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PAST -, SUBCAT NP] : HAVE,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3479, INV @D3478,
      AGR V2[UB @D3477, VFORM @D3476, SUBJ @D3475, FIN @D3474], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC HAVE-TO)),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3483, INV @D3482,
      AGR N2[+NOM, -PLU, NFORM @D3481, COUNT @D3480, PER 3], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC HAVE-TO)),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3489, INV @D3488,
      AGR V2[UB @D3487, VFORM @D3486, SUBJ @D3485, FIN @D3484], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT HAVE] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3493, INV @D3492,
      AGR N2[+NOM, -PLU, NFORM @D3491, COUNT @D3490, PER 3], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT HAVE] : NIL.

WORD hasn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D3504, SUBTYPE @D3503,
      AGR V2[UB @D3502, VFORM @D3501, SUBJ @D3500, FIN @D3499],
      CONEG @D3498, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D3509, SUBTYPE @D3508,
      AGR N2[+NOM, -PLU, NFORM @D3507, COUNT @D3506, PER 3], CONEG @D3505,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D3516, INV @D3515,
      AGR V2[UB @D3514, VFORM @D3513, SUBJ @D3512, FIN @D3511],
      CONEG @D3510, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT HAVE] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D3521, INV @D3520,
      AGR N2[+NOM, -PLU, NFORM @D3519, COUNT @D3518, PER 3], CONEG @D3517,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT HAVE] : NIL.

WORD have :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D3532, SUBTYPE @D3531,
      PAST @D3530,
      AGR N2[+NOM, +PLU, NFORM @D3529, COUNT @D3528, PER @D3527], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2)
               (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D3536, SUBTYPE @D3535,
      PAST @D3534, AGR N2[+NOM, -PLU, COUNT @D3533, PER 2, NFORM NORM],
      FIX NOT, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2)
               (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D3540, SUBTYPE @D3539,
      PAST @D3538, AGR N2[+NOM, -PLU, COUNT @D3537, PER 1, NFORM NORM],
      FIX NOT, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2)
               (PERF e2)) (lambda (qu) qu))),
   V[BSE, -PRD, -INV, -NEG, -FIN, +AUX, +PRO, COORD @D3543, SUBTYPE @D3542,
      AGR @D3541, FIX NOT, CONEG -, PAST NOT, PSVE -, CONJ NULL, AT +, LAT +,
      REG -, INFL -, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x)))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3546,
      AGR N2[+NOM, +PLU, COUNT @D3545, PER @D3544, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, REG -, SUBCAT NP] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3548,
      AGR N2[+NOM, -PLU, COUNT @D3547, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, REG -, SUBCAT NP] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3550,
      AGR N2[+NOM, -PLU, COUNT @D3549, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, REG -, SUBCAT NP] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3554,
      AGR N2[+NOM, COUNT @D3553, PER @D3552, PLU @D3551, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, REG -, SUBCAT NP] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3560, PAST @D3559,

      AGR N2[CASE @D3558, COUNT @D3557, PER @D3556, PLU @D3555, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, REG -, SUBCAT NP] : HAVE,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3565, INV @D3564,
      AGR N2[+NOM, +PLU, NFORM @D3563, COUNT @D3562, PER @D3561], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC HAVE-TO)),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3568, INV @D3567,
      AGR N2[+NOM, -PLU, COUNT @D3566, PER 2, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC HAVE-TO)),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3571, INV @D3570,
      AGR N2[+NOM, -PLU, COUNT @D3569, PER 1, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC HAVE-TO)),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3576, INV @D3575,
      AGR N2[+NOM, +PLU, NFORM @D3574, COUNT @D3573, PER @D3572], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT HAVE] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3579, INV @D3578,
      AGR N2[+NOM, -PLU, COUNT @D3577, PER 2, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT HAVE] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D3582, INV @D3581,
      AGR N2[+NOM, -PLU, COUNT @D3580, PER 1, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT HAVE] : NIL,
   V[BSE, -PRD, -NEG, -FIN, +AUX, -PRO, COORD @D3585, INV @D3584,
      AGR @D3583, FIX NOT, SUBTYPE NONE, CONEG -, PAST NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, REG -, SUBCAT HAVE] : NIL,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3588,
      AGR N2[+NOM, +PLU, COUNT @D3587, PER @D3586, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP_SFIN, REG -, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3590,
      AGR N2[+NOM, -PLU, COUNT @D3589, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP_SFIN, REG -, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3592,
      AGR N2[+NOM, -PLU, COUNT @D3591, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP_SFIN, REG -, ARITY 3] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3596,
      AGR N2[+NOM, COUNT @D3595, PER @D3594, PLU @D3593, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT PP_SFIN, REG -, ARITY 3] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3602, PAST @D3601,

      AGR N2[CASE @D3600, COUNT @D3599, PER @D3598, PLU @D3597, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT PP_SFIN, REG -, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3605,
      AGR N2[+NOM, +PLU, COUNT @D3604, PER @D3603, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP_SFIN, REG -, PRT ON, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3607,
      AGR N2[+NOM, -PLU, COUNT @D3606, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP_SFIN, REG -, PRT ON, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3609,
      AGR N2[+NOM, -PLU, COUNT @D3608, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP_SFIN, REG -, PRT ON, ARITY 3] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3613,
      AGR N2[+NOM, COUNT @D3612, PER @D3611, PLU @D3610, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP_SFIN, REG -, PRT ON, ARITY 3] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3619, PAST @D3618,

      AGR N2[CASE @D3617, COUNT @D3616, PER @D3615, PLU @D3614, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT NP_SFIN, REG -, PRT ON, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3622,
      AGR N2[+NOM, +PLU, COUNT @D3621, PER @D3620, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP_PP, REG -, PRT OUT, PFORM WITH, ARITY 3] :
   HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3624, AGR N2[+NOM, -PLU,
            COUNT @D3623, NFORM NORM, PER 1], VFORM NOT, INFL -, PAST -,
      FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBCAT NP_PP, REG -, PRT OUT, PFORM WITH, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3626,
      AGR N2[+NOM, -PLU, COUNT @D3625, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP_PP, REG -, PRT OUT, PFORM WITH, ARITY 3] :
   HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3630, AGR N2[+NOM,
            COUNT @D3629, PER @D3628, PLU @D3627, NFORM NORM], INFL -,
      PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP_PP, REG -, PRT OUT, PFORM WITH, ARITY 3] :
   HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3636, PAST @D3635,

      AGR N2[CASE @D3634, COUNT @D3633, PER @D3632, PLU @D3631, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT NP_PP, REG -, PRT OUT, PFORM WITH,
      ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3639,
      AGR N2[+NOM, +PLU, COUNT @D3638, PER @D3637, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OVER, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3641,
      AGR N2[+NOM, -PLU, COUNT @D3640, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OVER, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3643,
      AGR N2[+NOM, -PLU, COUNT @D3642, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OVER, ARITY 3] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3647,
      AGR N2[+NOM, COUNT @D3646, PER @D3645, PLU @D3644, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OVER, ARITY 3] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3653, PAST @D3652,

      AGR N2[CASE @D3651, COUNT @D3650, PER @D3649, PLU @D3648, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM OVER,
      ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3656,
      AGR N2[+NOM, +PLU, COUNT @D3655, PER @D3654, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3658,
      AGR N2[+NOM, -PLU, COUNT @D3657, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3660,
      AGR N2[+NOM, -PLU, COUNT @D3659, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3664,
      AGR N2[+NOM, COUNT @D3663, PER @D3662, PLU @D3661, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, PSVE -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3670, PAST @D3669,

      AGR N2[CASE @D3668, COUNT @D3667, PER @D3666, PLU @D3665, NFORM
         NORM], FIX NOT, PSVE -, INFL +, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE PVERB, SUBCAT NP_PP, REG -, PFORM ON, ARITY 3] :
   HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3673, AGR N2[+NOM, +PLU,
            COUNT @D3672, PER @D3671, NFORM NORM], VFORM NOT, INFL -,
      PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3675,
      AGR N2[+NOM, -PLU, COUNT @D3674, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3677,
      AGR N2[+NOM, -PLU, COUNT @D3676, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, ARITY 2] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3681,
      AGR N2[+NOM, COUNT @D3680, PER @D3679, PLU @D3678, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, ARITY 2] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3687, PAST @D3686,

      AGR N2[CASE @D3685, COUNT @D3684, PER @D3683, PLU @D3682, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT OUT, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3690,
      AGR N2[+NOM, +PLU, COUNT @D3689, PER @D3688, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OFF, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3692,
      AGR N2[+NOM, -PLU, COUNT @D3691, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OFF, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3694,
      AGR N2[+NOM, -PLU, COUNT @D3693, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OFF, ARITY 2] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3698,
      AGR N2[+NOM, COUNT @D3697, PER @D3696, PLU @D3695, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT OFF, ARITY 2] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3704, PAST @D3703,

      AGR N2[CASE @D3702, COUNT @D3701, PER @D3700, PLU @D3699, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT OFF, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3707,
      AGR N2[+NOM, +PLU, COUNT @D3706, PER @D3705, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT IN, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3709,
      AGR N2[+NOM, -PLU, COUNT @D3708, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT IN, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3711,
      AGR N2[+NOM, -PLU, COUNT @D3710, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT IN, ARITY 2] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3715,
      AGR N2[+NOM, COUNT @D3714, PER @D3713, PLU @D3712, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBTYPE NONE, PSVE -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBCAT NP, REG -, PRT IN, ARITY 2] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3721, PAST @D3720,

      AGR N2[CASE @D3719, COUNT @D3718, PER @D3717, PLU @D3716, NFORM
         NORM], FIX NOT, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT NP, REG -, PRT IN, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3724,
      AGR N2[+NOM, +PLU, COUNT @D3723, PER @D3722, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3726,
      AGR N2[+NOM, -PLU, COUNT @D3725, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3728,
      AGR N2[+NOM, -PLU, COUNT @D3727, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3732,
      AGR N2[+NOM, COUNT @D3731, PER @D3730, PLU @D3729, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3738, PAST @D3737,

      AGR N2[CASE @D3736, COUNT @D3735, PER @D3734, PLU @D3733, NFORM
         NORM], FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT UP, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3741,
      AGR N2[+NOM, +PLU, COUNT @D3740, PER @D3739, NFORM NORM], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT ON, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3743,
      AGR N2[+NOM, -PLU, COUNT @D3742, NFORM NORM, PER 1], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT ON, ARITY 2] : HAVE,
   V[-PRD, -INV, -NEG, +FIN, -AUX, -PRO, COORD @D3745,
      AGR N2[+NOM, -PLU, COUNT @D3744, NFORM NORM, PER 2], VFORM NOT,
      INFL -, PAST -, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT ON, ARITY 2] : HAVE,
   V[IMP, -PRD, -INV, -NEG, -AUX, -PRO, COORD @D3749,
      AGR N2[+NOM, COUNT @D3748, PER @D3747, PLU @D3746, NFORM NORM],
      INFL -, PAST NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT ON, ARITY 2] : HAVE,
   V[BSE, -PRD, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3755, PAST @D3754,

      AGR N2[CASE @D3753, COUNT @D3752, PER @D3751, PLU @D3750, NFORM
         NORM], FIX NOT, SUBCAT NP, SUBTYPE NONE, PSVE -, INFL +, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, REG -, PRT ON, ARITY 2] : HAVE.

WORD haven't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D3769, SUBTYPE @D3768,
      PAST @D3767,
      AGR N2[+NOM, +PLU, NFORM @D3766, COUNT @D3765, PER @D3764],
      CONEG @D3763, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D3774, SUBTYPE @D3773,
      PAST @D3772, AGR N2[+NOM, -PLU, COUNT @D3771, PER 2, NFORM NORM],
      CONEG @D3770, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D3779, SUBTYPE @D3778,
      PAST @D3777, AGR N2[+NOM, -PLU, COUNT @D3776, PER 1, NFORM NORM],
      CONEG @D3775, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) (PERF e2)) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D3786, INV @D3785, PAST @D3784,
      AGR N2[+NOM, +PLU, NFORM @D3783, COUNT @D3782, PER @D3781],
      CONEG @D3780, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT HAVE] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D3791, INV @D3790, PAST @D3789,
      AGR N2[+NOM, -PLU, COUNT @D3788, PER 2, NFORM NORM], CONEG @D3787,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT HAVE] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D3796, INV @D3795, PAST @D3794,
      AGR N2[+NOM, -PLU, COUNT @D3793, PER 1, NFORM NORM], CONEG @D3792,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBCAT HAVE] : NIL.

WORD having :
   V[GER, -NEG, -FIN, +AUX, -PRO, COORD @D3804, INV @D3803, AGR @D3802,
      FIX NOT, SUBTYPE NONE, CONEG -, PAST NOT, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, SUBCAT HAVE] : NIL,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3810, PRD @D3809,
      AGR N2[CASE @D3808, COUNT @D3807, PER @D3806, PLU @D3805,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL,
      SUBCAT NP, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] : HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3816, PRD @D3815,
      AGR N2[CASE @D3814, COUNT @D3813, PER @D3812, PLU @D3811,
            NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB,
      SUBCAT PP_SFIN, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] : HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3822, PRD @D3821,
      AGR N2[CASE @D3820, COUNT @D3819, PER @D3818, PLU @D3817,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL,
      SUBCAT NP_SFIN, PRT ON, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] :
   HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3828, PRD @D3827, AGR
         N2[CASE @D3826, COUNT @D3825, PER @D3824, PLU @D3823,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL,
      SUBCAT NP_PP, PRT OUT, PFORM WITH, PSVE -, REG -, PAST NOT, INFL -,
      AT +, LAT +] : HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3834, PRD @D3833,
      AGR N2[CASE @D3832, COUNT @D3831, PER @D3830, PLU @D3829,
            NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB,
      SUBCAT NP_PP, PFORM OVER, PSVE -, REG -, PAST NOT, INFL -, AT +,
      LAT +] : HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3840, PRD @D3839,
      AGR N2[CASE @D3838, COUNT @D3837, PER @D3836, PLU @D3835,
            NFORM NORM], COMPOUND NOT, FIX NOT, CONJ NULL, SUBTYPE PVERB,
      SUBCAT NP_PP, PFORM ON, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] :
   HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3846, PRD @D3845, AGR
         N2[CASE @D3844, COUNT @D3843, PER @D3842, PLU @D3841,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL,
      SUBCAT NP, PRT OUT, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] :
   HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3852, PRD @D3851, AGR
         N2[CASE @D3850, COUNT @D3849, PER @D3848, PLU @D3847,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL,
      SUBCAT NP, PRT OFF, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] :
   HAVE,
   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3858, PRD @D3857, AGR
         N2[CASE @D3856, COUNT @D3855, PER @D3854, PLU @D3853,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBTYPE NONE, CONJ NULL,
      SUBCAT NP, PRT IN, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] : HAVE,

   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3864, PRD @D3863, AGR
            N2[CASE @D3862, COUNT @D3861, PER @D3860, PLU @D3859,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE,
      CONJ NULL, PRT UP, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] : HAVE,

   V[ING, -INV, -NEG, -FIN, -AUX, -PRO, COORD @D3870, PRD @D3869, AGR
            N2[CASE @D3868, COUNT @D3867, PER @D3866, PLU @D3865,
            NFORM NORM], COMPOUND NOT, FIX NOT, SUBCAT NP, SUBTYPE NONE,
      CONJ NULL, PRT ON, PSVE -, REG -, PAST NOT, INFL -, AT +, LAT +] : HAVE.

WORD he :
   N[-PRD, -POSS, -ADV, +NOM, +DEF, -PLU, +PRO, -NUM, COORD @D1357,
      COUNT @D1356, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] : (pro (the (x) (and (sg x) (male x)))).

WORD her :
   N[-PRD, -POSS, -ADV, +ACC, +DEF, -PLU, +PRO, -NUM, COORD @D3876,
      COUNT @D3875, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (x) (and (sg x) (female x)))),
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D3879, NFORM @D3878,
            PER @D3877, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (female y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D3884, NFORM @D3883, COUNT @D3882, PER
               @D3881, PLU @D3880, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (female y))))))).

WORD here :
   N[+PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D3894, COUNT @D3893,
      CASE @D3892, PLU @D3891, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, DEMON +, PROTYPE PMOD] :
   (lambda (Q) (Q dd the (lambda (x) (and (sg x) (proximal x) (place x)))
            AT)).

WORD hers :
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D3904, COUNT @D3903,
      CASE @D3902, PLU @D3901, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -,
      UB NO, EVER NO, CONJ NULL, AT +, LAT +, PER 3] :
   (dd (the (x) (lambda (R) (R x (pro (the (y) (and (sg y) (female y)))))))).

WORD herself :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D3914, COUNT @D3913,
      CASE @D3912, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 3] : (rpro (the (x) (and (sg x) (female x)))).

WORD him :
   N[-PRD, -POSS, -ADV, +ACC, +DEF, -PLU, +PRO, -NUM, COORD @D3919,
      COUNT @D3918, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] : (pro (the (x) (and (sg x) (male x)))).

WORD himself :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D3926, COUNT @D3925,
      CASE @D3924, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 3] : (rpro (the (x) (and (sg x) (male x)))).

WORD his :
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D3933, COUNT @D3932,
      CASE @D3931, PLU @D3930, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -,
      UB NO, EVER NO, CONJ NULL, AT +, LAT +, PER 3] :
   (dd (the (x) (lambda (R) (R x (pro (the (y) (and (sg y) (male y)))))))),

   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D3936, NFORM @D3935, PER
               @D3934, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (male y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D3941, NFORM @D3940, COUNT @D3939, PER
               @D3938, PLU @D3937, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (male y))))))).

WORD home : [FIX NOT, PRT HOME, INFL -] : HOME.

WORD how :
   P[+PRO, +Q, +WH, -EVER, MODTYPE @D3953, COORD @D3952, NEG @D3951,
      PRD @D3950, LOC @D3949, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] :
   (lambda (y) (IN y (pro (the (_wh) (and (manner _wh)))))),
   DetA[+Q, +WH, -EVER, FIX NOT, AFORM NONE, DISTR PRD] : _wh.

WORD however :
   P[+PRO, +Q, +WH, +EVER, MODTYPE @D3962, COORD @D3961, NEG @D3960,
      PRD @D3959, LOC @D3958, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] : NIL,
   DetA[+R, +WH, +EVER, FIX NOT, AFORM NONE, DISTR PRD] : however,
   DetA[+Q, +WH, +EVER, FIX NOT, AFORM NONE, DISTR PRD] : however.

WORD hundred : [FIX NOT, CN4 -, AND -, CN2 BIG, CN1 HUN] : |100|.

WORD hundredth :
   DetA[ORD, DISTR @D3970, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   HUNDREDTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D3978, COORD @D3977, DEF @D3976,
      PRD @D3975,
      AGR N2[CASE @D3974, COUNT @D3973, PER @D3972, PLU @D3971,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   HUNDREDTH, -PLU[FIX NOT, FRACT -] : |100|.

WORD hundredths : +PLU[FIX NOT, INFL -, FRACT -] : |100|.

WORD i :
   N[-PRD, -POSS, -ADV, +NOM, +DEF, -PLU, +PRO, -NUM, COORD @D3988, COUNT
         @D3987, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 1] :
   (pro (the (x) (and (sg x) (speaker x)))).

WORD if : [FIX NOT, SUBCAT IF] : IF,
   P[-PRO, COORD @D3994, NEG @D3993, PRD @D3992, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : IF.

WORD in : [FIX NOT, PRT IN, INFL -] : IN,
   P[-PRO, MODTYPE @D4002, COORD @D4001, NEG @D4000, PRD @D3999,
      LOC @D3998, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : IN,
   P[-PRO, COORD @D4005, NEG @D4004, PRD @D4003, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : IN,
   P[-PRO, MODTYPE @D4009, COORD @D4008, NEG @D4007, PRD @D4006, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM IN_WITH] : IN,
   P[-PRO, MODTYPE @D4013, COORD @D4012, NEG @D4011, PRD @D4010, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM IN_AT] : IN,
   P[+LOC, -PRO, MODTYPE @D4017, COORD @D4016, NEG @D4015, PRD @D4014,
      FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PFORM NORM] : IN,
   P[+LOC, -PRO, MODTYPE @D4021, COORD @D4020, NEG @D4019, PRD @D4018,
      FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PFORM IN] : IN.

WORD inside :
   P[-PRO, MODTYPE @D4031, COORD @D4030, NEG @D4029, PRD @D4028,
      LOC @D4027, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : INSIDE.

WORD into : [FIX NOT, PRT INTO, INFL -] : INTO,
   P[-PRO, MODTYPE @D4040, COORD @D4039, NEG @D4038, PRD @D4037,
      LOC @D4036, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM INTO] : INTO,
   P[-PRO, MODTYPE @D4044, COORD @D4043, NEG @D4042, PRD @D4041, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM INTO_WITH] : INTO,
   P[-PRO, MODTYPE @D4048, COORD @D4047, NEG @D4046, PRD @D4045, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FROM_INTO] : INTO,
   P[-PRO, MODTYPE @D4053, COORD @D4052, NEG @D4051, PRD @D4050,
      LOC @D4049, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : INTO.

WORD is :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4062, SUBTYPE @D4061,
      AGR V2[UB @D4060, VFORM @D4059, SUBJ @D4058, FIN @D4057], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4066, SUBTYPE @D4065,
      AGR N2[+NOM, -PLU, NFORM @D4064, COUNT @D4063, PER 3], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D4072, INV @D4071,
      AGR V2[UB @D4070, VFORM @D4069, SUBJ @D4068, FIN @D4067], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT BE] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D4076, INV @D4075,
      AGR N2[+NOM, -PLU, NFORM @D4074, COUNT @D4073, PER 3], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT BE] : NIL.

WORD isn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D4087, SUBTYPE @D4086,
      AGR V2[UB @D4085, VFORM @D4084, SUBJ @D4083, FIN @D4082],
      CONEG @D4081, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D4092, SUBTYPE @D4091,
      AGR N2[+NOM, -PLU, NFORM @D4090, COUNT @D4089, PER 3], CONEG @D4088,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D4099, INV @D4098,
      AGR V2[UB @D4097, VFORM @D4096, SUBJ @D4095, FIN @D4094],
      CONEG @D4093, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT BE] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D4104, INV @D4103,
      AGR N2[+NOM, -PLU, NFORM @D4102, COUNT @D4101, PER 3], CONEG @D4100,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST -, SUBCAT BE] : NIL.

WORD it :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4110, COUNT @D4109,
      CASE @D4108, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (x) (and (or (sg x) (ms x)) (nonhuman x)))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4113, COUNT @D4112,
      CASE @D4111, FIX NOT, SUBCAT NULL, PN -, REFL -, PER 3, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, NFORM IT] : NIL.

WORD its :
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D4121, COUNT @D4120,
      CASE @D4119, PLU @D4118, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -,
      UB NO, EVER NO, CONJ NULL, AT +, LAT +, PER 3] :
   (dd (the (x) (lambda (R)
               (R x (pro (the (y) (and (or (sg y) (ms y)) (nonhuman
                              y)))))))),
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D4124, NFORM @D4123,
            PER @D4122, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x)
         (lambda (R) (R x (pro (the (y) (and (or (sg y) (ms y)) (nonhuman
                           y))))))),
   DetN[+POSS, +DEF, AGR N2[CASE @D4129, NFORM @D4128, COUNT @D4127,
            PER @D4126, PLU @D4125, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (or (sg y) (ms y))
                        (nonhuman y))))))).

WORD itself :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4137, COUNT @D4136,
      CASE @D4135, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 3] :
   (rpro (the (x) (and (or (sg y) (ms y)) (nonhuman x)))).

WORD january :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4144, REFL @D4143,
      PRD @D4142, CASE @D4141, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : JANUARY.

WORD jnr :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4150, REFL @D4149,
      PRD @D4148, CASE @D4147, FIX NOT, SUBCAT NULL, PROTYPE NONE, PN -,
      NFORM NORM, PER 3, PART -, DEMON -, ADDRESS +, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT] : JNR.

WORD jones :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4156, REFL @D4155,
      PRD @D4154, CASE @D4153, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, ADDRESS -] :
   (name (the (x) (and (sg x) (named x JONES) (animate x)))).

WORD july :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4163, REFL @D4162,
      PRD @D4161, CASE @D4160, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : JULY.

WORD june :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4170, REFL @D4169,
      PRD @D4168, CASE @D4167, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : JUNE.

WORD just :
   A[+ADV, -NEG, -QUA, -NUM, COADV @D4177, COORD @D4176, DEF @D4175,
      AGR @D4174, PRD @D4173, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : JUST.

WORD kind :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4183, REFL @D4182,
      PRD @D4181, CASE @D4180, FIX NOT, INFL +, PROTYPE NONE, PN -,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM OF, SUBCAT OFN1] : KIND.

WORD last :
   DetA[ORD, DISTR @D4190, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   LAST,
   DetN[-POSS, +DEF, AGR N2[-PLU, +COUNT, CASE @D4193, NFORM @D4192,
            PER @D4191, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (dd (the (x) (and (sg x) (LAST x) (P x))))).

WORD later :
   A[-ADV, -NEG, -QUA, -NUM, COORD @D4203, DEF @D4202, PRD @D4201,
      AGR N2[CASE @D4200, COUNT @D4199, PER @D4198, PLU @D4197,
            NFORM NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      AFORM NONE, PART -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE -,
      COADV +, DISTR PRD] : LATER.

WORD least :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, est, COADV @D4213, COORD @D4212,

      AGR +N[-PLU, -COUNT, CASE @D4211, NFORM @D4210, PER @D4209, BAR
               @D4208, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T least (lambda (x) (and (Q x) (P x))))))),
   DetA[est, DISTR @D4214, FIX NOT, WH NO, UB NO, EVER NO] : least.

WORD less :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D4224, COORD @D4223,

      AGR +N[-PLU, -COUNT, CASE @D4222, NFORM @D4221, PER @D4220, BAR
               @D4219, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T less (lambda (x) (and (Q x) (P x))))))),

   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D4230, COORD @D4229,
      AGR N2[-PLU, CASE @D4228, NFORM @D4227, COUNT @D4226, PER @D4225],
      FIX NOT, SUBTYPE NONE, SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, GRADE +, PART OF] : LESS,
   DetA[er, DISTR @D4231, FIX NOT, WH NO, UB NO, EVER NO] : (less than).

WORD lest :
   P[-PRO, COORD @D4238, NEG @D4237, PRD @D4236, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : LEST.


WORD little :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4265, COORD @D4264,
      AGR +N[-PLU, -COUNT, CASE @D4263, NFORM @D4262, PER @D4261,
            BAR @D4260, V -], FIX NOT, SUBTYPE NONE, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      GRADE +] :
   (lambda (P) (lambda (Q) (lambda (T) (T little (lambda (x) (and (Q x)
                        (P x))))))),
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -COUNT, -NUM, COORD @D4267,
      CASE @D4266, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD+] :
   (lambda (Q) (Q uq little (lambda (x) (and (ms x) (entity x))))),
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4273, COORD @D4272,
      AGR N2[-PLU, CASE @D4271, NFORM @D4270, COUNT @D4269, PER @D4268],
      FIX NOT, SUBTYPE NONE, AFORM NONE, SUBCAT NULL, DISTR ATT, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +, PART OF] : LITTLE.

WORD loose : [FIX NOT, PRT LOOSE, INFL -] : LOOSE.

WORD low : [FIX NOT, PRT LOW, INFL -] : LOW.

WORD many :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4291, COORD @D4290,
      AGR +N[+PLU, +COUNT, CASE @D4289, NFORM @D4288, PER @D4287,
            BAR @D4286, V -], FIX NOT, SUBTYPE NONE, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      GRADE +] :
   (lambda (P) (lambda (Q) (lambda (T) (T many (lambda (x) (and (Q x)
                        (P x))))))),
   N[-PRD, -POSS, -ADV, -DEF, +PLU, +PRO, +COUNT, -NUM, COORD @D4293,
      CASE @D4292, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD+] :
   (lambda (Q) (Q uq many (lambda (x) (and (pl x) (entity x))))),
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4298, COORD @D4297,
      AGR N2[+PLU, +COUNT, CASE @D4296, NFORM @D4295, PER @D4294],
      FIX NOT, SUBTYPE NONE, AFORM NONE, SUBCAT NULL, DISTR ATT, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +, PART OF] : MANY.

WORD march :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4306, REFL @D4305,
      PRD @D4304, CASE @D4303, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : MARCH.

WORD may :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4312, AGR @D4311, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : MAY,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4314, AGR @D4313, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (POS (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (MAY e x (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D4317, INV @D4316, AGR @D4315,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS MAY)),
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4321, REFL @D4320,
      PRD @D4319, CASE @D4318, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : MAY.

WORD me :
   N[-PRD, -POSS, -ADV, +ACC, +DEF, -PLU, +PRO, -NUM, COORD @D4327,
      COUNT @D4326, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 1] :
   (pro (the (x) (and (sg x) (speaker x)))).

WORD mg :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4335, REFL @D4334,
      PRD @D4333, CASE @D4332, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, DEMON -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART NO_OF] : MILLIGRAM,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4339, REFL @D4338,
      PRD @D4337, CASE @D4336, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, DEMON -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART OF] : MILLIGRAM,
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4343, REFL @D4342,
      PRD @D4341, CASE @D4340, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : MILLIGRAM.

WORD might :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4350, AGR @D4349, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : MIGHT,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4352, AGR @D4351, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (POS (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (MIGHT e x (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D4355, INV @D4354, AGR @D4353,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS MIGHT)).

WORD mightn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D4364, AGR @D4363,
      CONEG @D4362, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (POS (PROVP e x)))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (MIGHT e x (PROVP (uqe (some (e2) (NOTENSE e2)))
                           x))))) (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D4368, INV @D4367, AGR @D4366,
      CONEG @D4365, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int POS MIGHT)).

WORD million : [FIX NOT, CN4 -, AND -, CN2 BIG, CN1 THOU] : |1000000|.

WORD millionth :
   DetA[ORD, DISTR @D4381, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   MILLIONTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D4389, COORD @D4388, DEF @D4387,
      PRD @D4386,
      AGR N2[CASE @D4385, COUNT @D4384, PER @D4383, PLU @D4382,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   MILLIONTH, -PLU[FIX NOT, FRACT -] : |1000000|.

WORD millionths : +PLU[FIX NOT, INFL -, FRACT -] : |1000000|.

WORD mine :
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D4408, COUNT @D4407,
      CASE @D4406, PLU @D4405, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -,
      UB NO, EVER NO, CONJ NULL, AT +, LAT +, PER 3] :
   (dd (the (x) (lambda (R) (R x (pro (the (y) (and (sg y) (speaker y)))))))).

WORD minute :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4419, REFL @D4418,
      PRD @D4417, CASE @D4416, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : MINUTE,
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4423, REFL @D4422,
      PRD @D4421, CASE @D4420, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : MINUTE.

WORD monday :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4431, REFL @D4430,
      PRD @D4429, CASE @D4428, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : MONDAY.

WORD more :
   A[+ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D4440, COORD @D4439,
      AGR @D4438, PRD @D4437, FIX NOT, SUBTYPE NONE, GRADE -, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (deg) (deg (more than))),
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D4446, COORD @D4445,

      AGR +N[-PLU, -COUNT, CASE @D4444, NFORM @D4443, PER @D4442, BAR
               @D4441, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T more (lambda (x) (and (Q x) (P x))))))),

   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D4452, COORD @D4451,
      AGR
         +N[+PLU, +COUNT, CASE @D4450, NFORM @D4449, PER @D4448, BAR
               @D4447, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T more (lambda (x) (and (Q x) (P x))))))),

   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, er, COADV @D4458, COORD @D4457,
      AGR
         N2[CASE @D4456, COUNT @D4455, PER @D4454, PLU @D4453, NFORM
         NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, DISTR ATT, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +, PART OF] : MORE,
   DetA[er, DISTR @D4459, FIX NOT, WH NO, UB NO, EVER NO] : (more than).

WORD most :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, est, COADV @D4469, COORD @D4468,

      AGR +N[-PLU, -COUNT, CASE @D4467, NFORM @D4466, PER @D4465, BAR
               @D4464, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T most (lambda (x) (and (Q x) (P x))))))),

   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, est, COADV @D4475, COORD @D4474,

      AGR +N[+PLU, +COUNT, CASE @D4473, NFORM @D4472, PER @D4471, BAR
               @D4470, V -], FIX NOT, SUBTYPE NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   (lambda (P)
         (lambda (Q) (lambda (T) (T most (lambda (x) (and (Q x) (P x))))))),

   N[-PRD, -POSS, -ADV, +ACC, -DEF, +PRO, -NUM, est, COORD @D4478, COUNT
         @D4477, PLU @D4476, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, PART -, DEMON -, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq most (lambda (x) (and (or (ms x) (pl x)) (entity x))))),

   N[-PRD, -POSS, -ADV, +NOM, -DEF, +PLU, +PRO, -NUM, est, COORD @D4480,
      COUNT @D4479, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +, LAT +,
      PROTYPE PMOD] :
   (lambda (Q) (Q uq most (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +NOM, -DEF, -PLU, +PRO, -COUNT, -NUM, est,
      COORD @D4481, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +, LAT +,
      PROTYPE PMOD] :
   (lambda (Q) (Q uq most (lambda (x) (and (ms x) (entity x))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, est, COADV @D4487, COORD @D4486,

      AGR N2[CASE @D4485, COUNT @D4484, PER @D4483, PLU @D4482, NFORM
         NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, DISTR ATT, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +, PART OF] : MOST,
   DetA[est, DISTR @D4488, FIX NOT, WH NO, UB NO, EVER NO] : most.

WORD mr :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4496, REFL @D4495,
      PRD @D4494, CASE @D4493, FIX NOT, SUBCAT NULL, PROTYPE NONE, PN -,
      NFORM NORM, PER 3, PART -, DEMON -, ADDRESS +, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT] : MR.

WORD ms :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D4504, REFL @D4503,
      PRD @D4502, CASE @D4501, FIX NOT, SUBCAT NULL, PROTYPE NONE, PN -,
      NFORM NORM, PER 3, PART -, DEMON -, ADDRESS +, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT] : MS.

WORD much :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4514, COORD @D4513,
      AGR +N[-PLU, -COUNT, CASE @D4512, NFORM @D4511, PER @D4510,
            BAR @D4509, V -], FIX NOT, SUBTYPE NONE, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      GRADE +] :
   (lambda (P) (lambda (Q) (lambda (T) (T much (lambda (x) (and (Q x)
                        (P x))))))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -COUNT, -NUM, COORD @D4516,
      CASE @D4515, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq much (lambda (x) (and (ms x) (entity x))))),
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4522, COORD @D4521,
      AGR N2[-PLU, CASE @D4520, NFORM @D4519, COUNT @D4518, PER @D4517],
      FIX NOT, SUBTYPE NONE, AFORM NONE, SUBCAT NULL, DISTR ATT, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +, PART OF] : MUCH.

WORD must :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4528, AGR @D4527, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : MUST,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4530, AGR @D4529, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NEC (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (MUST e x (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D4533, INV @D4532, AGR @D4531,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_BSE] :
   (lambda (int) (int NEC MUST)).

WORD mustn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D4541, AGR @D4540,
      CONEG @D4539, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (MUST e x (PROVP (uqe (some (e2) (NOTENSE e2))) x)))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D4545, INV @D4544, AGR @D4543,
      CONEG @D4542, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBTYPE DEO, PAST -, SUBCAT MODAL_BSE] : MUST.

WORD my :
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D4552, NFORM @D4551,
            PER @D4550, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (speaker y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D4557, NFORM @D4556, COUNT @D4555, PER
               @D4554, PLU @D4553, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (speaker y))))))).

WORD myself :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4565, COUNT @D4564,
      CASE @D4563, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 1] : (rpro (the (x) (and (sg x) (speaker x)))).

WORD near :
   P[-PRO, MODTYPE @D4572, COORD @D4571, NEG @D4570, PRD @D4569,
      LOC @D4568, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : NEAR.

WORD nearly :
   A[+ADV, -NEG, -QUA, -NUM, COADV @D4581, COORD @D4580, DEF @D4579,
      AGR @D4578, PRD @D4577, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : NEARLY.


WORD needn't :
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D4592, INV @D4591, AGR @D4590,
      CONEG @D4589, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBTYPE DEO, PAST -, SUBCAT MODAL_BSE] : NEED.

WORD neither : +NEG[FIX NOT, CONEG -, SO +] : NEITHER,
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D4599, COORD @D4598,
      AGR N2[-PLU, +COUNT, CASE @D4597, NFORM @D4596, PER @D4595,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q neither (lambda (x) (lambda (P) (and (sg x) (P x)))))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, +COUNT, -NUM, COORD @D4601,
      CASE @D4600, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq neither (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4604, COUNT @D4603,
      CASE @D4602, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART OF] : NEITHER,
   [FIX NOT, CONJN +, SUBCAT NEITHER] : NEITHER.

WORD never :
   A[+ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4610, COORD @D4609, AGR @D4608,
      PRD @D4607, FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   never.

WORD next :
   DetN[-POSS, +DEF, AGR N2[-PLU, +COUNT, CASE @D4615, NFORM @D4614,
            PER @D4613, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (dd (the (x) (and (sg x) (NEXT x) (P x))))).

WORD nine : [AND @D4619, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |9|.

WORD nineteen : [AND @D4625, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |19|.

WORD nineteenth :
   DetA[ORD, DISTR @D4633, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   NINETEENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D4641, COORD @D4640, DEF @D4639,
      PRD @D4638,
      AGR N2[CASE @D4637, COUNT @D4636, PER @D4635, PLU @D4634,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   NINETEENTH, -PLU[FIX NOT, FRACT -] : |19|.

WORD nineteenths : +PLU[FIX NOT, INFL -, FRACT -] : |19|.

WORD ninetieth :
   DetA[ORD, DISTR @D4657, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   NINETIETH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D4665, COORD @D4664, DEF @D4663,
      PRD @D4662,
      AGR N2[CASE @D4661, COUNT @D4660, PER @D4659, PLU @D4658,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   NINETIETH, -PLU[FIX NOT, FRACT -] : |90|.

WORD ninetieths : +PLU[FIX NOT, INFL -, FRACT -] : |90|.

WORD ninety : [AND @D4678, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |90|.

WORD ninth :
   DetA[ORD, DISTR @D4682, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   NINTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D4690, COORD @D4689, DEF @D4688,
      PRD @D4687,
      AGR N2[CASE @D4686, COUNT @D4685, PER @D4684, PLU @D4683,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   NINTH, -PLU[FIX NOT, FRACT -] : |9|.

WORD ninths : +PLU[FIX NOT, INFL -, FRACT -] : |9|.

WORD no :
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4701, COORD @D4700,
      AGR N2[+PLU, +COUNT, CASE @D4699, NFORM @D4698, PER @D4697,
            QFEAT +], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   NO,
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4706, COORD @D4705,
      AGR N2[+PLU, +COUNT, CASE @D4704, NFORM @D4703, PER @D4702,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q no (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4711, COORD @D4710,
      AGR N2[-PLU, -COUNT, CASE @D4709, NFORM @D4708, PER @D4707,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q no (lambda (x) (lambda (P) (and (ms x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4716, COORD @D4715,
      AGR N2[-PLU, +COUNT, CASE @D4714, NFORM @D4713, PER @D4712,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q no (lambda (x) (lambda (P) (and (sg x) (P x)))))).

WORD no-one :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D4723, COUNT @D4722,
      CASE @D4721, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq no (lambda (x) (and (sg x) (person x))))).

WORD nobody :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D4730, COUNT @D4729,
      CASE @D4728, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq no (lambda (x) (and (sg x) (person x))))).

WORD none :
   N[-PRD, -POSS, -ADV, -DEF, +PRO, -NUM, COORD @D4738, COUNT @D4737,
      CASE @D4736, PLU @D4735, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO,
      EVER NO, CONJ NULL, AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq no (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D4741, COUNT @D4740,
      CASE @D4739, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART OF] : NONE.

WORD nor : [FIX NOT, CONJN +, SUBCAT NOR] : NOR.

WORD not : +NEG[FIX NOT] : NOT.

WORD nothing :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D4755, COUNT @D4754,
      CASE @D4753, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq no (lambda (x) (and (sg x) (entity x))))).

WORD november :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4762, REFL @D4761,
      PRD @D4760, CASE @D4759, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : NOVEMBER.

WORD now :
   N[+PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D4769, COUNT @D4768,
      CASE @D4767, PLU @D4766, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, DEMON +, PROTYPE PMOD] :
   (lambda (Q) (Q dd the (lambda (x) (and (sg x) (proximal x) (time x))) AT)).

WORD nowhere :
   N[+PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4777, COUNT @D4776,
      CASE @D4775, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq no (lambda (x) (and (sg x) (place x))) AT)).

WORD october :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D4783, REFL @D4782,
      PRD @D4781, CASE @D4780, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : OCTOBER.

WORD of :
   P[-PRO, MODTYPE @D4789, COORD @D4788, NEG @D4787, PRD @D4786, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OF_FOR] : OF,
   P[-PRO, MODTYPE @D4793, COORD @D4792, NEG @D4791, PRD @D4790, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OF_AS] : OF,
   P[-PRO, MODTYPE @D4797, COORD @D4796, NEG @D4795, PRD @D4794, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OF] : OF, [FIX NOT, PFORM OF, INFL -] : OF.

WORD off : [FIX NOT, PRT OFF, INFL -] : OFF,
   P[-PRO, MODTYPE @D4805, COORD @D4804, NEG @D4803, PRD @D4802,
      LOC @D4801, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP OF, SUBCAT PP, PFORM NORM] : OFF,
   P[-PRO, MODTYPE @D4810, COORD @D4809, NEG @D4808, PRD @D4807,
      LOC @D4806, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : OFF,
   P[-PRO, MODTYPE @D4815, COORD @D4814, NEG @D4813, PRD @D4812,
      LOC @D4811, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : OFF,
   P[-PRO, MODTYPE @D4820, COORD @D4819, NEG @D4818, PRD @D4817,
      LOC @D4816, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM OFF] : OFF.

WORD often :
   A[+ADV, -NEG, -DEF, +QUA, -NUM, COADV @D4827, COORD @D4826, AGR @D4825,
      PRD @D4824, FIX NOT, SUBTYPE NONE, AFORM NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   often.

WORD on : [FIX NOT, PRT ON, INFL -] : ON,
   P[-PRO, MODTYPE @D4834, COORD @D4833, NEG @D4832, PRD @D4831,
      LOC @D4830, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : OFF,
   P[-PRO, COORD @D4837, NEG @D4836, PRD @D4835, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : ON,
   P[-PRO, MODTYPE @D4841, COORD @D4840, NEG @D4839, PRD @D4838, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_ON] : ON,
   P[-PRO, MODTYPE @D4845, COORD @D4844, NEG @D4843, PRD @D4842, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_WITH] : ON,
   P[-PRO, MODTYPE @D4849, COORD @D4848, NEG @D4847, PRD @D4846, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_TO] : ON,
   P[-PRO, MODTYPE @D4853, COORD @D4852, NEG @D4851, PRD @D4850, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_FOR] : ON,
   P[-PRO, MODTYPE @D4857, COORD @D4856, NEG @D4855, PRD @D4854, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_AS] : ON,
   P[+LOC, -PRO, MODTYPE @D4861, COORD @D4860, NEG @D4859, PRD @D4858,
      FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PFORM NORM] : ON,
   P[+LOC, -PRO, MODTYPE @D4865, COORD @D4864, NEG @D4863, PRD @D4862,
      FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PFORM ON] : ON.

WORD once :
   P[-PRO, COORD @D4873, NEG @D4872, PRD @D4871, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : ONCE,
   P[-PRO, COORD @D4876, NEG @D4875, PRD @D4874, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : ONCE.

WORD one :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4883, COUNT @D4882,
      CASE @D4881, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (x) (and (sg x) (human x)))), [FIX NOT, CN3 ONE] : |1|.

WORD one's :
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D4892, NFORM @D4891,
            PER @D4890, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (human y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D4897, NFORM @D4896, COUNT @D4895, PER
               @D4894, PLU @D4893, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (human y))))))).

WORD ones :
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D4905, NFORM @D4904,
            PER @D4903, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (human y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D4910, NFORM @D4909, COUNT @D4908, PER
               @D4907, PLU @D4906, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (human y))))))).

WORD oneself :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D4921, COUNT @D4920,
      CASE @D4919, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 3] : (rpro (the (x) (and (sg x) (human x)))).

WORD onto :
   P[-PRO, MODTYPE @D4930, COORD @D4929, NEG @D4928, PRD @D4927,
      LOC @D4926, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : ONTO,
   P[-PRO, MODTYPE @D4935, COORD @D4934, NEG @D4933, PRD @D4932,
      LOC @D4931, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM ONTO] : ONTO.


WORD or : [FIX NOT, CONJN +, SUBCAT OR] : OR.

WORD other :
   A[-ADV, -NEG, -QUA, -NUM, er, COADV @D4949, COORD @D4948, DEF @D4947,
      PRD @D4946,
      AGR N2[CASE @D4945, COUNT @D4944, PER @D4943, PLU @D4942,
            NFORM NORM], FIX NOT, SUBTYPE NONE, GRADE +, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] : OTHER,
   A[-ADV, -NEG, -QUA, -NUM, COADV @D4957, COORD @D4956, DEF @D4955,
      PRD @D4954,
      AGR N2[CASE @D4953, COUNT @D4952, PER @D4951, PLU @D4950,
            NFORM NORM], FIX NOT, SUBTYPE NONE, SUBCAT NULL, INFL +,
      COMPAR NO, GRADE -, AFORM NONE, PART -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, DISTR ATT] : OTHER,
   N[-POSS, -ADV, -PLU, -PRO, -NUM, COORD @D4962, REFL @D4961,
      COUNT @D4960, PRD @D4959, CASE @D4958, FIX NOT, SUBCAT NULL, INFL +,
      PROTYPE NONE, PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT] : OTHER.

WORD otherwise :
   P[-PRO, COORD @D4970, NEG @D4969, PRD @D4968, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : OTHERWISE.

WORD ought :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4974, AGR @D4973, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : OUGHT,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D4976, AGR @D4975, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NEC (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (OUGHT e x (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D4979, INV @D4978, AGR @D4977,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC OUGHT)).

WORD oughtn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D4985, AGR @D4984,
      CONEG @D4983, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (NEC (PROVP e x)))))
            (lambda (e2) e2) (lambda (qu) qu))) :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (OUGHT e x (PROVP (uqe (some (e2) (NOTENSE e2)))
                           x))))) (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D4989, INV @D4988, AGR @D4987,
      CONEG @D4986, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST -, SUBCAT MODAL_INF] :
   (lambda (int) (int NEC OUGHT)).

WORD our :
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D4994, NFORM @D4993,
            PER @D4992, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (pl y) (speaker y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D4999, NFORM @D4998, COUNT @D4997, PER
               @D4996, PLU @D4995, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (pl y) (speaker y))))))).

WORD ours :
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D5006, COUNT @D5005,
      CASE @D5004, PLU @D5003, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -,
      UB NO, EVER NO, CONJ NULL, AT +, LAT +, PER 3] :
   (dd (the (x) (lambda (R) (R x (pro (the (y) (and (pl y) (speaker y)))))))).

WORD ourselves :
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D5013, COUNT @D5012,
      CASE @D5011, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 1] : (rpro (the (x) (and (pl x) (speaker x)))).

WORD out : [FIX NOT, PRT OUT, INFL -] : OUT,
   P[-PRO, MODTYPE @D5020, COORD @D5019, NEG @D5018, PRD @D5017,
      LOC @D5016, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP OF, SUBCAT PP, PFORM NORM] : OUT,
   P[-PRO, MODTYPE @D5025, COORD @D5024, NEG @D5023, PRD @D5022,
      LOC @D5021, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : OUT,
   P[-PRO, MODTYPE @D5030, COORD @D5029, NEG @D5028, PRD @D5027,
      LOC @D5026, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : OUT,
   P[-PRO, MODTYPE @D5035, COORD @D5034, NEG @D5033, PRD @D5032,
      LOC @D5031, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM OUT] : OUT.

WORD outside :
   P[-PRO, MODTYPE @D5044, COORD @D5043, NEG @D5042, PRD @D5041,
      LOC @D5040, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : OUTSIDE.

WORD over : [FIX NOT, PRT OVER, INFL -] : OVER,
   P[-PRO, MODTYPE @D5050, COORD @D5049, NEG @D5048, PRD @D5047, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_OVER] : OVER,
   P[-PRO, MODTYPE @D5054, COORD @D5053, NEG @D5052, PRD @D5051, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OVER_WITH] : OVER,
   P[-PRO, MODTYPE @D5058, COORD @D5057, NEG @D5056, PRD @D5055, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM NORM] : OVER,
   P[-PRO, MODTYPE @D5062, COORD @D5061, NEG @D5060, PRD @D5059, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OVER] : OVER,
   P[-PRO, MODTYPE @D5066, COORD @D5065, NEG @D5064, PRD @D5063, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, PFORM OVER, RANGEOP PRE,
      SUBCAT NULL, LOC -] : OVER.

WORD per :
   P[-PRO, MODTYPE @D5072, COORD @D5071, NEG @D5070, PRD @D5069, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM NORM] : PER.

WORD possibly :
   A[+ADV, -NEG, -QUA, -NUM, COADV @D5080, COORD @D5079, DEF @D5078,
      AGR @D5077, PRD @D5076, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : POSSIBLE.

WORD prior :
   P[-PRO, MODTYPE @D5087, COORD @D5086, NEG @D5085, PRD @D5084,
      LOC @D5083, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP TO, SUBCAT PP, PFORM NORM] : PRIOR.

WORD probably :
   A[+ADV, -NEG, -QUA, -NUM, COADV @D5095, COORD @D5094, DEF @D5093,
      AGR @D5092, PRD @D5091, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : PROBABLE.

WORD quarter : -PLU[FIX NOT, FRACT -] : |4|.

WORD quarters : +PLU[FIX NOT, INFL -, FRACT -] : |4|.

WORD quite : DetA[DISTR @D5104, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   quite.

WORD rather : DetA[DISTR @D5107, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   rather.

WORD round : [FIX NOT, PRT ROUND, INFL -] : ROUND,
   P[-PRO, MODTYPE @D5114, COORD @D5113, NEG @D5112, PRD @D5111,
      LOC @D5110, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : ROUND,
   P[-PRO, MODTYPE @D5119, COORD @D5118, NEG @D5117, PRD @D5116,
      LOC @D5115, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM ROUND] : ROUND.

WORD s' :
   N[+POSS, -ADV, +PLU, -PRO, -NUM, COORD @D5127, REFL @D5126, COUNT
         @D5125, PRD @D5124, CASE @D5123, FIX NOT, SUBCAT NULL,
      PROTYPE NONE, PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, INFL -] : S.

WORD saturday :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D5134, REFL @D5133,
      PRD @D5132, CASE @D5131, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : SATURDAY.

WORD second :
   DetA[ORD, DISTR @D5139, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   SECOND,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5147, COORD @D5146, DEF @D5145,
      PRD @D5144,
      AGR N2[CASE @D5143, COUNT @D5142, PER @D5141, PLU @D5140,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SECOND.

WORD seldom :
   A[+ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5155, COORD @D5154, AGR @D5153,
      PRD @D5152, FIX NOT, SUBTYPE NONE, AFORM NONE, PART -, SUBCAT NULL,
      DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, GRADE +] :
   seldom.

WORD september :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D5163, REFL @D5162,
      PRD @D5161, CASE @D5160, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : SEPTEMBER.

WORD seven : [AND @D5168, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |7|.

WORD seventeen : [AND @D5176, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |17|.

WORD seventeenth :
   DetA[ORD, DISTR @D5186, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   SEVENTEENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5194, COORD @D5193, DEF @D5192,
      PRD @D5191,
      AGR N2[CASE @D5190, COUNT @D5189, PER @D5188, PLU @D5187,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SEVENTEENTH, -PLU[FIX NOT, FRACT -] : |17|.

WORD seventeenths : +PLU[FIX NOT, INFL -, FRACT -] : |17|.

WORD seventh :
   DetA[ORD, DISTR @D5213, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   SEVENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5221, COORD @D5220, DEF @D5219,
      PRD @D5218,
      AGR N2[CASE @D5217, COUNT @D5216, PER @D5215, PLU @D5214,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SEVENTH, -PLU[FIX NOT, FRACT -] : |7|.

WORD sevenths : +PLU[FIX NOT, INFL -, FRACT -] : |7|.

WORD seventieth :
   DetA[ORD, DISTR @D5239, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   SEVENTIETH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5247, COORD @D5246, DEF @D5245,
      PRD @D5244,
      AGR N2[CASE @D5243, COUNT @D5242, PER @D5241, PLU @D5240,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SEVENTIETH, -PLU[FIX NOT, FRACT -] : |70|.

WORD seventieths : +PLU[FIX NOT, INFL -, FRACT -] : |70|.

WORD seventy : [AND @D5264, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |70|.

WORD several :
   A[+PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5274, COORD @D5273,
      AGR +N[+PLU, +COUNT, CASE @D5272, NFORM @D5271, PER @D5270,
            BAR @D5269, V -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] :
   (lambda (P) (lambda (Q) (lambda (T) (T several (lambda (x)
                     (and (Q x) (P x))))))),
   N[-PRD, -POSS, -ADV, -DEF, +PLU, +PRO, +COUNT, -NUM, COORD @D5276,
      CASE @D5275, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD+] :
   (lambda (Q) (Q uq several (lambda (x) (and (pl x) (entity x))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5281, COORD @D5280,
      AGR N2[+PLU, +COUNT, CASE @D5279, NFORM @D5278, PER @D5277],
      FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, SUBCAT NULL, DISTR ATT,
      INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, PART OF] : SEVERAL.

WORD shall :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D5288, SUBTYPE @D5287,
      AGR @D5286, FIX NOT, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, PAST FUT, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D5291, INV @D5290, AGR @D5289,
      FIX NOT, SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, COMPOUND NOT, PAST FUT, SUBCAT FUT] : NIL.

WORD shan't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D5299, SUBTYPE @D5298,
      AGR @D5297, CONEG @D5296, FIX NOT, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, PAST FUT, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D5303, INV @D5302, AGR @D5301,
      CONEG @D5300, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST FUT, SUBCAT FUT] : NIL.

WORD she :
   N[-PRD, -POSS, -ADV, +NOM, +DEF, -PLU, +PRO, -NUM, COORD @D5309,
      COUNT @D5308, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (x) (and (sg x) (female x)))).

WORD should :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D5315, AGR @D5314, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : SHOULD,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D5317, AGR @D5316, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST -,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (SHOULD e x
                     (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D5320, INV @D5319, AGR @D5318,
      FIX NOT, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE DEO, PAST -, SUBCAT MODAL_BSE] : SHOULD.

WORD shouldn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D5328, AGR @D5327,
      CONEG @D5326, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (SHOULD e x (PROVP (uqe (some (e2) (NOTENSE e2)))
                           x))))) (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D5332, INV @D5331, AGR @D5330,
      CONEG @D5329, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBTYPE DEO, PAST -, SUBCAT MODAL_BSE] : SHOULD.

WORD since :
   P[-PRO, COORD @D5339, NEG @D5338, PRD @D5337, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SING,
      PFORM NORM] : SINCE,
   P[-PRO, COORD @D5342, NEG @D5341, PRD @D5340, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : SINCE,
   P[-PRO, COORD @D5345, NEG @D5344, PRD @D5343, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : SINCE.

WORD six : [AND @D5349, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |6|.

WORD sixteen : [AND @D5355, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |16|.

WORD sixteenth :
   DetA[ORD, DISTR @D5363, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   SIXTEENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5371, COORD @D5370, DEF @D5369,
      PRD @D5368,
      AGR N2[CASE @D5367, COUNT @D5366, PER @D5365, PLU @D5364,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SIXTEENTH, -PLU[FIX NOT, FRACT -] : |16|.

WORD sixteenths : +PLU[FIX NOT, INFL -, FRACT -] : |16|.

WORD sixth :
   DetA[ORD, DISTR @D5386, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   SIXTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5394, COORD @D5393, DEF @D5392,
      PRD @D5391,
      AGR N2[CASE @D5390, COUNT @D5389, PER @D5388, PLU @D5387,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SIXTH, -PLU[FIX NOT, FRACT -] : |6|.

WORD sixths : +PLU[FIX NOT, INFL -, FRACT -] : |6|.

WORD sixtieth :
   DetA[ORD, DISTR @D5408, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   SIXTIETH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5416, COORD @D5415, DEF @D5414,
      PRD @D5413,
      AGR N2[CASE @D5412, COUNT @D5411, PER @D5410, PLU @D5409,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SIXTIETH, -PLU[FIX NOT, FRACT -] : |60|.

WORD sixtieths : +PLU[FIX NOT, INFL -, FRACT -] : |60|.

WORD sixty : [AND @D5429, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |60|.

WORD smith :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D5436, REFL @D5435,
      PRD @D5434, CASE @D5433, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, ADDRESS -] :
   (name (the (x) (and (sg x) (named x SMITH) (animate x)))).

WORD so : -NEG[FIX NOT, CONEG -, SO +] : SO,
   DetA[FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO, DISTR PRD] : so,
   P[-PRO, COORD @D5442, NEG @D5441, PRD @D5440, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : SO.

WORD some :
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5454, COORD @D5453,
      AGR N2[+PLU, +COUNT, CASE @D5452, NFORM @D5451, PER @D5450,
            QFEAT +], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   SOME,
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5459, COORD @D5458,
      AGR N2[-PLU, -COUNT, CASE @D5457, NFORM @D5456, PER @D5455,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q some (lambda (x) (lambda (P) (and (ms x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5464, COORD @D5463,
      AGR N2[+PLU, +COUNT, CASE @D5462, NFORM @D5461, PER @D5460,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q some (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   N[-PRD, -POSS, -ADV, +ACC, -DEF, +PRO, -NUM, COORD @D5467, COUNT @D5466,
      PLU @D5465, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq some (lambda (x) (and (or (ms x) (pl x)) (entity x))))),

   N[-PRD, -POSS, -ADV, +NOM, -DEF, +PLU, +PRO, -NUM, COORD @D5469, COUNT
         @D5468, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE PMOD] :
   (lambda (Q) (Q uq some (lambda (x) (and (pl x) (entity x))))),
   N[-PRD, -POSS, -ADV, +NOM, -DEF, -PLU, +PRO, -COUNT, -NUM, COORD @D5470,
      FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +, LAT +,
      PROTYPE PMOD] :
   (lambda (Q) (Q uq some (lambda (x) (and (ms x) (entity x))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5476, COORD @D5475,
      AGR N2[CASE @D5474, COUNT @D5473, PER @D5472, PLU @D5471,
            NFORM NORM], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PART OF] : SOME,
   DetN[-POSS, -DEF, AGR N2[-PLU, +COUNT, CASE @D5479, NFORM @D5478,
            PER @D5477, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (uq (some (x) (and (sg x) (P x))))).

WORD somebody :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D5492, COUNT @D5491,
      CASE @D5490, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq some (lambda (x) (and (sg x) (person x))))).

WORD someone :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D5505, COUNT @D5504,
      CASE @D5503, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq some (lambda (x) (and (sg x) (person x))))).

WORD something :
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D5517, COUNT @D5516,
      CASE @D5515, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, INFL -, WH NO, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq some (lambda (x) (and (sg x) (entity x))))).

WORD somewhere :
   N[+PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D5530, COUNT @D5529,
      CASE @D5528, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, DEMON -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, PROTYPE COMPOUND] :
   (lambda (Q) (Q uq some (lambda (x) (and (sg x) (place x))) AT)).

WORD sort :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D5538, REFL @D5537,
      PRD @D5536, CASE @D5535, FIX NOT, INFL +, PROTYPE NONE, PN -,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM OF, SUBCAT OFN1] : SORT.

WORD subsequent :
   P[-PRO, MODTYPE @D5546, COORD @D5545, NEG @D5544, PRD @D5543,
      LOC @D5542, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP TO, SUBCAT PP, PFORM NORM] : SUBSEQUENT.

WORD such :
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5554, COORD @D5553,
      AGR N2[-PLU, -COUNT, CASE @D5552, NFORM @D5551, PER @D5550,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q such (lambda (x) (lambda (P) (and (ms x) (P x)))))),
   A[-PRD, -ADV, -NEG, -DEF, +QUA, -NUM, COADV @D5559, COORD @D5558,
      AGR N2[+PLU, +COUNT, CASE @D5557, NFORM @D5556, PER @D5555,
            QFEAT -], FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, PART -,
      SUBCAT NULL, DISTR ATT, INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   (lambda (Q) (Q such (lambda (x) (lambda (P) (and (pl x) (P x)))))),
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D5562, COUNT @D5561,
      CASE @D5560, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART NO_OF] : SUCH.

WORD sunday :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D5569, REFL @D5568,
      PRD @D5567, CASE @D5566, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : SUNDAY.

WORD ten : [AND @D5572, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |10|.

WORD tenth :
   DetA[ORD, DISTR @D5577, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   TENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5585, COORD @D5584, DEF @D5583,
      PRD @D5582,
      AGR N2[CASE @D5581, COUNT @D5580, PER @D5579, PLU @D5578,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   TENTH, -PLU[FIX NOT, FRACT -] : |10|.

WORD tenths : +PLU[FIX NOT, INFL -, FRACT -] : |10|.

WORD than : [FIX NOT, SUBCAT THAN] : THAN,
   P[-PRO, MODTYPE @D5598, COORD @D5597, NEG @D5596, PRD @D5595, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM THAN] : THAN,
   P[-PRO, MODTYPE @D5602, COORD @D5601, NEG @D5600, PRD @D5599, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ER] : THAN.

WORD that :
   N[-PRD, -POSS, -ADV, +PRO, -NUM, +R, -WH, -EVER, COORD @D5610,
      COUNT @D5609, CASE @D5608, PLU @D5607, DEF @D5606, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (z) z),
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D5613, COUNT @D5612,
      CASE @D5611, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +,
      LAT +, DEMON +, PROTYPE THAT] :
   (lambda (Q) (Q dd the (lambda (x) (and (or (sg x) (ms x)) (distal x)
                  (entity x))))), [FIX NOT, SUBCAT THAT] : NIL,
   DetN[-POSS, +DEF,
      AGR N2[-PLU, +COUNT, CASE @D5616, NFORM @D5615, PER @D5614,
            QFEAT -], FIX NOT, WH NO, UB NO, EVER NO, DEMON +] :
   (lambda (P) (dd (the (x) (and (sg x) (distal x) (P x))))),
   DetA[FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO, DISTR PRD] : that.

WORD the :
   DetN[-POSS, +DEF, AGR N2[+COUNT, CASE @D5623, NFORM @D5622, PER @D5621,
            PLU @D5620, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   NIL,
   DetN[-POSS, +DEF, AGR N2[-PLU, -COUNT, CASE @D5626, NFORM @D5625,
            PER @D5624, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (dd (the (x) (and (ms x) (P x))))),
   DetN[-POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D5629, NFORM @D5628,
            PER @D5627, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (dd (the (x) (and (pl x) (P x))))),
   DetN[-POSS, +DEF, AGR N2[-PLU, +COUNT, CASE @D5632, NFORM @D5631,
            PER @D5630, QFEAT -], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (P) (dd (the (x) (and (sg x) (P x))))).

WORD their :
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D5640, NFORM @D5639,
            PER @D5638, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (pl y) (entity y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D5645, NFORM @D5644, COUNT @D5643, PER
               @D5642, PLU @D5641, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (pl y) (entity y))))))).

WORD theirs :
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D5655, COUNT @D5654,
      CASE @D5653, PLU @D5652, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -,
      UB NO, EVER NO, CONJ NULL, AT +, LAT +, PER 3] :
   (dd (the (x) (lambda (R) (R x (pro (the (y) (and (pl y) (entity y)))))))).

WORD them :
   N[-PRD, -POSS, -ADV, +ACC, +DEF, +PLU, +PRO, -NUM, COORD @D5661,
      COUNT @D5660, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (x) (and (pl x) (entity x)))).

WORD themselves :
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D5669, COUNT @D5668,
      CASE @D5667, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 3] : (rpro (the (x) (and (pl x) (entity x)))).

WORD then :
   N[+PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D5677, COUNT @D5676,
      CASE @D5675, PLU @D5674, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, DEMON +, PROTYPE PMOD] :
   (lambda (Q) (Q dd the (lambda (x) (and (sg x) (distal x) (time x))) AT)).

WORD there :
   N[+PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D5686, COUNT @D5685,
      CASE @D5684, PLU @D5683, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PER 3, PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, DEMON +, PROTYPE PMOD] :
   (lambda (Q) (Q dd the (lambda (x) (and (sg x) (distal x) (place x))) AT)),

   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D5690, COUNT @D5689, CASE
         @D5688, PLU @D5687, FIX NOT, SUBCAT NULL, PN -, REFL -, PER 3,
      PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO,
      EVER NO, CONJ NULL, AT +, LAT +, NFORM THERE] : NIL.

WORD therefore :
   A[+ADV, -NEG, -QUA, -NUM, COADV @D5702, COORD @D5701, DEF @D5700,
      AGR @D5699, PRD @D5698, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : THEREFORE,
   P[-PRO, COORD @D5705, NEG @D5704, PRD @D5703, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : THEREFORE.

WORD these :
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D5713, COUNT @D5712,
      CASE @D5711, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +,
      LAT +, DEMON +, PROTYPE PMOD] :
   (lambda (Q) (Q dd the (lambda (x) (and (pl x) (proximal x) (entity x))))),

   DetN[-POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D5716, NFORM @D5715, PER
               @D5714, QFEAT +], FIX NOT, WH NO, UB NO, EVER NO, DEMON +] :
   NIL,
   DetN[-POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D5719, NFORM @D5718,
            PER @D5717, QFEAT -], FIX NOT, WH NO, UB NO, EVER NO, DEMON +] :
   (lambda (P) (dd (the (x) (and (pl x) (proximal x) (P x))))).

WORD they :
   N[-PRD, -POSS, -ADV, +NOM, +DEF, +PLU, +PRO, -NUM, COORD @D5725,
      COUNT @D5724, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (x) (and (pl x) (entity x)))).

WORD third :
   DetA[ORD, DISTR @D5729, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   THIRD,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5737, COORD @D5736, DEF @D5735,
      PRD @D5734,
      AGR N2[CASE @D5733, COUNT @D5732, PER @D5731, PLU @D5730,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   THIRD, -PLU[FIX NOT, FRACT -] : |3|.

WORD thirds : +PLU[FIX NOT, INFL -, FRACT -] : |3|.

WORD thirteen : [AND @D5746, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |13|.

WORD thirteenth :
   DetA[ORD, DISTR @D5753, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   THIRTEENTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5761, COORD @D5760, DEF @D5759,
      PRD @D5758,
      AGR N2[CASE @D5757, COUNT @D5756, PER @D5755, PLU @D5754,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   THIRTEENTH.

WORD thirtennth : -PLU[FIX NOT, FRACT -] : |13|.

WORD thirtennths : +PLU[FIX NOT, INFL -, FRACT -] : |13|.

WORD thirtieth :
   DetA[ORD, DISTR @D5776, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   THIRTIETH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5784, COORD @D5783, DEF @D5782,
      PRD @D5781,
      AGR N2[CASE @D5780, COUNT @D5779, PER @D5778, PLU @D5777,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   THIRTIETH, -PLU[FIX NOT, FRACT -] : |30|.

WORD thirtieths : +PLU[FIX NOT, INFL -, FRACT -] : |30|.

WORD thirty : [AND @D5795, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |30|.

WORD this :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D5801, COUNT @D5800,
      CASE @D5799, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +,
      LAT +, DEMON +, PROTYPE PMOD] :
   (lambda (Q) (Q dd the (lambda (x) (and (or (sg x) (ms x)) (proximal x)
                  (entity x))))),
   DetN[-POSS, +DEF, AGR N2[-PLU, +COUNT, CASE @D5804, NFORM @D5803,
            PER @D5802, QFEAT -], FIX NOT, WH NO, UB NO, EVER NO, DEMON +] :
   (lambda (P) (dd (the (x) (and (sg x) (proximal x) (P x))))).

WORD those :
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D5811, COUNT @D5810,
      CASE @D5809, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      PART -, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL, AT +,
      LAT +, DEMON +, PROTYPE PMOD] :
   (lambda (Q) (Q dd the (lambda (x) (and (pl x) (distal x) (entity x))))),
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D5814, COUNT @D5813,
      CASE @D5812, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART OF] : THOSE,
   DetN[-POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D5817, NFORM @D5816,
            PER @D5815, QFEAT +], FIX NOT, WH NO, UB NO, EVER NO, DEMON +] :
   NIL,
   DetN[-POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D5820, NFORM @D5819,
            PER @D5818, QFEAT -], FIX NOT, WH NO, UB NO, EVER NO, DEMON +] :
   (lambda (P) (dd (the (x) (and (pl x) (distal x) (P x))))).

WORD though :
   P[-PRO, COORD @D5826, NEG @D5825, PRD @D5824, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : THOUGH.

WORD thousand : [FIX NOT, CN4 -, AND -, CN2 BIG, CN1 THOU] : |1000|.

WORD thousandth :
   DetA[ORD, DISTR @D5834, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   THOUSANDTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D5842, COORD @D5841, DEF @D5840,
      PRD @D5839,
      AGR N2[CASE @D5838, COUNT @D5837, PER @D5836, PLU @D5835,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   THOUSANDTH, -PLU[FIX NOT, FRACT -] : |1000|.

WORD thousandths : +PLU[FIX NOT, INFL -, FRACT -] : |1000|.

WORD three : [AND @D5853, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |3|.

WORD three-quarters : +PLU[FIX NOT, INFL -, FRACT +] : (/ |3| |4|).

WORD through : [FIX NOT, PRT THROUGH, INFL -] : THROUGH,
   P[-PRO, COORD @D5864, NEG @D5863, PRD @D5862, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : THROUGH,
   P[-PRO, MODTYPE @D5869, COORD @D5868, NEG @D5867, PRD @D5866,
      LOC @D5865, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : THROUGH,
   P[-PRO, MODTYPE @D5874, COORD @D5873, NEG @D5872, PRD @D5871,
      LOC @D5870, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM THROUGH] : THROUGH.

WORD throughout :
   P[-PRO, MODTYPE @D5883, COORD @D5882, NEG @D5881, PRD @D5880,
      LOC @D5879, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : THROUGHOUT,
   P[-PRO, MODTYPE @D5888, COORD @D5887, NEG @D5886, PRD @D5885,
      LOC @D5884, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM THROUGHOUT] : THROUGHOUT.

WORD thursday :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D5895, REFL @D5894,
      PRD @D5893, CASE @D5892, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : THURSDAY.

WORD to :
   V[TO, -PRD, -INV, -NEG, -FIN, +AUX, +PRO, COORD @D5927, SUBTYPE @D5926,
      AGR @D5925, PAST @D5924, FIX NOT, CONEG -, PSVE -, INFL -, CONJ NULL,
      AT +, LAT +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[TO, -PRD, -NEG, -FIN, +AUX, -PRO, COORD @D5931, INV @D5930,
      AGR @D5929, PAST @D5928, FIX NOT, SUBTYPE NONE, CONEG -, PSVE -,
      INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, SUBCAT TO] : NIL,
   [FIX NOT, PRT TO, INFL -] : TO,
   P[-PRO, MODTYPE @D5936, COORD @D5935, NEG @D5934, PRD @D5933,
      LOC @D5932, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : TO,
   P[-PRO, MODTYPE @D5940, COORD @D5939, NEG @D5938, PRD @D5937, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM UP_TO] : TO,
   P[-PRO, MODTYPE @D5944, COORD @D5943, NEG @D5942, PRD @D5941, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_FROM] : TO,
   P[-PRO, MODTYPE @D5948, COORD @D5947, NEG @D5946, PRD @D5945, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_FOR] : TO,
   P[-PRO, MODTYPE @D5952, COORD @D5951, NEG @D5950, PRD @D5949, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_AS] : TO,
   P[-PRO, MODTYPE @D5956, COORD @D5955, NEG @D5954, PRD @D5953, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM TO_AGAINST] : TO,
   P[-PRO, MODTYPE @D5960, COORD @D5959, NEG @D5958, PRD @D5957, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_TO] : TO,
   P[-PRO, MODTYPE @D5964, COORD @D5963, NEG @D5962, PRD @D5961, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FROM_TO] : TO,
   P[-PRO, MODTYPE @D5968, COORD @D5967, NEG @D5966, PRD @D5965, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FOR_TO] : TO,
   P[-PRO, MODTYPE @D5972, COORD @D5971, NEG @D5970, PRD @D5969, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM DOWN_TO] : TO,
   P[-PRO, MODTYPE @D5976, COORD @D5975, NEG @D5974, PRD @D5973, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM AS_TO] : TO,
   P[-PRO, MODTYPE @D5980, COORD @D5979, NEG @D5978, PRD @D5977, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ABOUT_TO] : TO,
   P[-PRO, MODTYPE @D5985, COORD @D5984, NEG @D5983, PRD @D5982,
      LOC @D5981, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM TO] : TO,
   P[-PRO, MODTYPE @D5989, COORD @D5988, NEG @D5987, PRD @D5986, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, PFORM TO, RANGEOP IN,
      SUBCAT NULL, LOC -] : TO.

WORD together : [FIX NOT, PRT TOGETHER, INFL -] : TOGETHER,
   P[-PRO, MODTYPE @D5997, COORD @D5996, NEG @D5995, PRD @D5994,
      LOC @D5993, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : TOGETHER,
   P[-PRO, MODTYPE @D6002, COORD @D6001, NEG @D6000, PRD @D5999,
      LOC @D5998, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM TOGETHER] : TOGETHER.

WORD too :
   P[-PRD, +PRO, MODTYPE @D6009, COORD @D6008, NEG @D6007, LOC @D6006,
      FIX NOT, SUBCAT NULL, PFORM NORM, INFL -, CONJ NULL, AT +, LAT +,
      EVER NO, UB NO, WH NO] : TOO,
   DetA[FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO, DISTR PRD] : too.

WORD toward :
   P[-PRO, MODTYPE @D6017, COORD @D6016, NEG @D6015, PRD @D6014,
      LOC @D6013, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : TOWARD,
   P[-PRO, MODTYPE @D6022, COORD @D6021, NEG @D6020, PRD @D6019,
      LOC @D6018, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM TOWARD] : TOWARD.

WORD towards :
   P[-PRO, MODTYPE @D6031, COORD @D6030, NEG @D6029, PRD @D6028,
      LOC @D6027, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : TOWARDS,
   P[-PRO, MODTYPE @D6036, COORD @D6035, NEG @D6034, PRD @D6033,
      LOC @D6032, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM TOWARDS] : TOWARDS.

WORD tuesday :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D6042, REFL @D6041,
      PRD @D6040, CASE @D6039, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : TUESDAY.

WORD twelfth :
   DetA[ORD, DISTR @D6045, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   TWELFTH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D6053, COORD @D6052, DEF @D6051,
      PRD @D6050,
      AGR N2[CASE @D6049, COUNT @D6048, PER @D6047, PLU @D6046,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   TWELFTH, -PLU[FIX NOT, FRACT -] : |12|.

WORD twelfths : +PLU[FIX NOT, INFL -, FRACT -] : |12|.

WORD twelve : [AND @D6060, FIX NOT, CN4 +, CN2 SMALL, CN1 TEEN] : |12|.

WORD twentieth :
   DetA[ORD, DISTR @D6065, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   TWENTIETH,
   A[-ADV, -NEG, -QUA, ORD, COADV @D6073, COORD @D6072, DEF @D6071,
      PRD @D6070,
      AGR N2[CASE @D6069, COUNT @D6068, PER @D6067, PLU @D6066,
            NFORM NORM], FIX NOT, SUBTYPE NONE, INFL +, GRADE -, AFORM NONE,
      PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +, COMPOUND NOT] :
   TWENTIETH, -PLU[FIX NOT, FRACT -] : |20|.

WORD twentieths : +PLU[FIX NOT, INFL -, FRACT -] : |20|.

WORD twenty : [AND @D6082, FIX NOT, CN4 +, CN2 SMALL, CN1 TY] : |20|.

WORD twice :
   A[-PRD, -ADV, -NEG, +DEF, +QUA, -NUM, COADV @D6091, COORD @D6090,
      AGR N2[-PLU, CASE @D6089, NFORM @D6088, COUNT @D6087, PER @D6086],
      FIX NOT, SUBTYPE NONE, GRADE -, AFORM NONE, SUBCAT NULL, DISTR ATT,
      INFL -, CONJ NULL, AT +, LAT +, COMPOUND NOT, PART NO_OF] : TWICE.

WORD two : [AND @D6094, FIX NOT, CN4 +, CN2 SMALL, CN1 TEN] : |2|.

WORD two-thirds : +PLU[FIX NOT, INFL -, FRACT +] : (/ |2| |3|).

WORD type :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D6104, REFL @D6103,
      PRD @D6102, CASE @D6101, FIX NOT, INFL +, PROTYPE NONE, PN -,
      NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM OF, SUBCAT OFN1] : TYPE.

WORD under : [FIX NOT, PRT UNDER, INFL -] : UNDER,
   P[-PRO, MODTYPE @D6113, COORD @D6112, NEG @D6111, PRD @D6110,
      LOC @D6109, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : UNDER,
   P[-PRO, MODTYPE @D6118, COORD @D6117, NEG @D6116, PRD @D6115,
      LOC @D6114, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM UNDER] : UNDER,
   P[-PRO, MODTYPE @D6122, COORD @D6121, NEG @D6120, PRD @D6119, FIX NOT,
      INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT, PFORM UNDER, RANGEOP PRE,
      SUBCAT NULL, LOC -] : UNDER.

WORD unless :
   P[-PRO, COORD @D6179, NEG @D6178, PRD @D6177, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : UNLESS,
   P[-PRO, COORD @D6216, NEG @D6215, PRD @D6214, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : UNLESS.

WORD until :
   P[-PRO, COORD @D6179, NEG @D6178, PRD @D6177, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : UNTIL,
   P[-PRO, MODTYPE @D6184, COORD @D6183, NEG @D6182, PRD @D6181,
      LOC @D6180, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : UNTIL,
   P[-PRO, MODTYPE @D6189, COORD @D6188, NEG @D6187, PRD @D6186,
      LOC @D6185, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM UNTIL] : UNTIL.

WORD up : [FIX NOT, PRT UP, INFL -] : UP,
   P[-PRO, MODTYPE @D6196, COORD @D6195, NEG @D6194, PRD @D6193,
      LOC @D6192, FIX NOT, INFL +, CONJ NULL, AT +, LAT +, COMPOUND NOT,
      PREP LOC, SUBCAT PP, PFORM NORM] : UP,
   P[-PRO, MODTYPE @D6200, COORD @D6199, NEG @D6198, PRD @D6197, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM UP_TO] : UP,
   P[-PRO, MODTYPE @D6205, COORD @D6204, NEG @D6203, PRD @D6202,
      LOC @D6201, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : UP,
   P[-PRO, MODTYPE @D6210, COORD @D6209, NEG @D6208, PRD @D6207,
      LOC @D6206, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM UP] : UP.

WORD upon : [FIX NOT, PRT UPON, INFL -] : UPON,
   P[-PRO, COORD @D6216, NEG @D6215, PRD @D6214, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : UPON,
   P[-PRO, MODTYPE @D6221, COORD @D6220, NEG @D6219, PRD @D6218,
      LOC @D6217, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : UPON,
   P[-PRO, MODTYPE @D6226, COORD @D6225, NEG @D6224, PRD @D6223,
      LOC @D6222, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM UPON] : UPON.

WORD us :
   N[-PRD, -POSS, -ADV, +ACC, +DEF, +PLU, +PRO, -NUM, COORD @D6230,
      COUNT @D6229, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 1] :
   (pro (the (x) (and (pl x) (speaker x)))).

WORD very : DetA[DISTR @D6234, FIX NOT, AFORM NONE, WH NO, UB NO, EVER NO] :
   very.

WORD was :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D6243, SUBTYPE @D6242,
      AGR V2[UB @D6241, VFORM @D6240, SUBJ @D6239, FIN @D6238], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D6247, SUBTYPE @D6246,
      AGR N2[+NOM, -PLU, NFORM @D6245, COUNT @D6244, PER 3], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D6250, SUBTYPE @D6249,
      AGR N2[+NOM, -PLU, COUNT @D6248, PER 1, NFORM NORM], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D6256, INV @D6255,
      AGR V2[UB @D6254, VFORM @D6253, SUBJ @D6252, FIN @D6251], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D6260, INV @D6259,
      AGR N2[+NOM, -PLU, NFORM @D6258, COUNT @D6257, PER 3], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D6263, INV @D6262,
      AGR N2[+NOM, -PLU, COUNT @D6261, PER 1, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL.

WORD wasn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6274, SUBTYPE @D6273,
      AGR V2[UB @D6272, VFORM @D6271, SUBJ @D6270, FIN @D6269],
      CONEG @D6268, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6279, SUBTYPE @D6278,
      AGR N2[+NOM, -PLU, NFORM @D6277, COUNT @D6276, PER 3], CONEG @D6275,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6283, SUBTYPE @D6282,
      AGR N2[+NOM, -PLU, COUNT @D6281, PER 1, NFORM NORM], CONEG @D6280,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6290, INV @D6289,
      AGR V2[UB @D6288, VFORM @D6287, SUBJ @D6286, FIN @D6285],
      CONEG @D6284, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6295, INV @D6294,
      AGR N2[+NOM, -PLU, NFORM @D6293, COUNT @D6292, PER 3], CONEG @D6291,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6299, INV @D6298,
      AGR N2[+NOM, -PLU, COUNT @D6297, PER 1, NFORM NORM], CONEG @D6296,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL.

WORD waste : [FIX NOT, PRT WASTE, INFL -] : WASTE.

WORD we :
   N[-PRD, -POSS, -ADV, +NOM, +DEF, +PLU, +PRO, -NUM, COORD @D6309,
      COUNT @D6308, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 1] :
   (pro (the (x) (and (pl x) (speaker x)))).

WORD wednesday :
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, +PN, COORD @D6317, REFL @D6316,
      PRD @D6315, CASE @D6314, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      ADDRESS -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : WEDNESDAY.

WORD week :
   N[-POSS, -ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D6325, REFL @D6324,
      PRD @D6323, CASE @D6322, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : WEEK,
   N[-POSS, +ADV, -PLU, -PRO, +COUNT, -NUM, COORD @D6329, REFL @D6328,
      PRD @D6327, CASE @D6326, FIX NOT, SUBCAT NULL, INFL +, PROTYPE NONE,
      PN -, NFORM NORM, PER 3, PART -, DEMON -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : WEEK.

WORD well :
   A[+ADV, -NEG, -QUA, -NUM, COADV @D6338, COORD @D6337, DEF @D6336,
      AGR @D6335, PRD @D6334, FIX NOT, SUBTYPE NONE, INFL +, GRADE +,
      AFORM NONE, PART -, SUBCAT NULL, DISTR ATT, CONJ NULL, AT +, LAT +,
      COMPOUND NOT] : WELL.

WORD were :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D6346, SUBTYPE @D6345,
      AGR N2[+NOM, -PLU, COUNT @D6344, PER 2, NFORM NORM], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D6351, SUBTYPE @D6350,
      AGR N2[+NOM, +PLU, NFORM @D6349, COUNT @D6348, PER @D6347], FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (PROVP e x))) (lambda (e2) e2)
            (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D6354, INV @D6353,
      AGR N2[+NOM, -PLU, COUNT @D6352, PER 2, NFORM NORM], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL,
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D6359, INV @D6358,
      AGR N2[+NOM, +PLU, NFORM @D6357, COUNT @D6356, PER @D6355], FIX NOT,
      SUBTYPE NONE, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL.

WORD weren't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6369, SUBTYPE @D6368,
      AGR N2[+NOM, -PLU, COUNT @D6367, PER 2, NFORM NORM], CONEG @D6366,
      FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6375, SUBTYPE @D6374,
      AGR N2[+NOM, +PLU, NFORM @D6373, COUNT @D6372, PER @D6371],
      CONEG @D6370, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST +, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6379, INV @D6378,
      AGR N2[+NOM, -PLU, COUNT @D6377, PER 2, NFORM NORM], CONEG @D6376,
      FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6385, INV @D6384,
      AGR N2[+NOM, +PLU, NFORM @D6383, COUNT @D6382, PER @D6381],
      CONEG @D6380, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST +, SUBCAT BE] : NIL.

WORD what :
   N[-POSS, -ADV, -PLU, +PRO, -NUM, +R, +WH, +EVER, COORD @D6394,
      COUNT @D6393, PRD @D6392, CASE @D6391, DEF @D6390, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (T) (dd (the (_wh) (and (entity _wh) (T _wh))))),
   N[+PRD, -POSS, -ADV, +PRO, -NUM, +Q, +WH, -EVER, COORD @D6399,
      COUNT @D6398, CASE @D6397, PLU @D6396, DEF @D6395, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -, DEMON -, PROTYPE NONE,
      AFORM NONE, INFL -, CONJ NULL, AT +, LAT +, PER 3] :
   (lambda (x) (_WH x)),
   N[-PRD, -POSS, -ADV, +PRO, -NUM, +Q, +WH, -EVER, COORD @D6404,
      COUNT @D6403, CASE @D6402, PLU @D6401, DEF @D6400, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -, DEMON -, PROTYPE NONE,
      AFORM NONE, INFL -, CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (_wh) (entity _wh))),
   N[-PRD, -POSS, -ADV, -DEF, -PLU, +PRO, -NUM, COORD @D6407, COUNT @D6406,
      CASE @D6405, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PART NO_OF] : WHAT,
   DetN[-POSS, +DEF, +Q, +WH, -EVER,
      AGR N2[+PLU, +COUNT, CASE @D6410, NFORM @D6409, PER @D6408,
            QFEAT +], FIX NOT, DEMON -] : NIL,
   DetN[-POSS, +DEF, +Q, +WH, -EVER,
      AGR N2[-PLU, -COUNT, CASE @D6413, NFORM @D6412, PER @D6411,
            QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (dd (the (_wh) (and (ms _wh) (P _wh))))),
   DetN[-POSS, +DEF, +Q, +WH, -EVER,
      AGR N2[+PLU, +COUNT, CASE @D6416, NFORM @D6415, PER @D6414,
            QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (dd (the (_wh) (and (pl _wh) (P _wh))))),
   DetN[-POSS, +DEF, +Q, +WH, -EVER,
      AGR N2[-PLU, +COUNT, CASE @D6419, NFORM @D6418, PER @D6417,
            QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (dd (the (_wh) (and (sg _wh) (P _wh))))).

WORD whatever :
   N[-POSS, -ADV, +PRO, -NUM, +R, +WH, +EVER, COORD @D6430, COUNT @D6429,
      PRD @D6428, CASE @D6427, PLU @D6426, DEF @D6425, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (T) (dd (the (_wh) (and (entity _wh) (T _wh))))),
   DetN[-POSS, +DEF, +R, +WH, +EVER,
      AGR N2[+PLU, +COUNT, CASE @D6433, NFORM @D6432, PER @D6431,
            QFEAT +], FIX NOT, DEMON -] : NIL,
   DetN[-POSS, +DEF, +R, +WH, +EVER,
      AGR N2[-PLU, -COUNT, CASE @D6436, NFORM @D6435, PER @D6434,
            QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (lambda (T) (dd (the (_wh) (and (ms _wh) (P _wh) (T _wh)))))),

   DetN[-POSS, +DEF, +R, +WH, +EVER, AGR N2[+PLU, +COUNT, CASE @D6439, NFORM
               @D6438, PER @D6437, QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (lambda (T) (dd (the (_wh) (and (pl _wh) (P _wh) (T _wh)))))),

   DetN[-POSS, +DEF, +R, +WH, +EVER, AGR N2[-PLU, +COUNT, CASE @D6442, NFORM
               @D6441, PER @D6440, QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (lambda (T) (dd (the (_wh) (and (sg _wh) (P _wh) (T _wh)))))).

WORD when :
   P[+PRO, +R, +WH, -EVER, MODTYPE @D6451, COORD @D6450, NEG @D6449,
      PRD @D6448, LOC @D6447, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] : (lambda (y) (lambda (x) (AT y x))),
   P[+PRO, +Q, +WH, -EVER, MODTYPE @D6456, COORD @D6455, NEG @D6454,
      PRD @D6453, LOC @D6452, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] :
   (lambda (y) (AT y (pro (the (_wh) (and (time _wh)))))),
   P[-PRO, COORD @D6459, NEG @D6458, PRD @D6457, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : WHEN,
   P[-PRO, COORD @D6462, NEG @D6461, PRD @D6460, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : WHEN.

WORD whenever :
   P[-PRO, COORD @D6470, NEG @D6469, PRD @D6468, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : WHENEVER,
   P[-PRO, COORD @D6473, NEG @D6472, PRD @D6471, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : WHENEVER.

WORD where :
   P[+PRO, +R, +WH, -EVER, MODTYPE @D6483, COORD @D6482, NEG @D6481,
      PRD @D6480, LOC @D6479, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] : (lambda (y) (lambda (x) (AT y x))),
   P[+PRO, +Q, +WH, -EVER, MODTYPE @D6488, COORD @D6487, NEG @D6486,
      PRD @D6485, LOC @D6484, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] :
   (lambda (y) (AT y (pro (the (_wh) (and (place _wh)))))).

WORD whereas :
   P[-PRO, COORD @D6497, NEG @D6496, PRD @D6495, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : WHEREAS.

WORD whereupon :
   P[-PRO, COORD @D6506, NEG @D6505, PRD @D6504, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : WHEREUPON.

WORD whether : [FIX NOT, SUBCAT WHETHER] : WHETHER.

WORD which :
   N[-PRD, -POSS, -ADV, +PRO, -NUM, +R, +WH, -EVER, COORD @D6520,
      COUNT @D6519, CASE @D6518, PLU @D6517, DEF @D6516, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (z) z),
   N[-PRD, -POSS, -ADV, +PRO, -NUM, +Q, +WH, -EVER, COORD @D6525,
      COUNT @D6524, CASE @D6523, PLU @D6522, DEF @D6521, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -, DEMON -, PROTYPE NONE,
      AFORM NONE, INFL -, CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (_wh) (entity _wh))),
   N[-POSS, -ADV, +PRO, -NUM, +Q, COORD @D6533, COUNT @D6532, PRD @D6531,
      CASE @D6530, PLU @D6529, EVER @D6528, WH @D6527, DEF @D6526,
      FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +, PART OF] :
   _wh,
   DetN[-POSS, +DEF, +Q, +WH, -EVER, AGR N2[+PLU, +COUNT, CASE @D6536,
            NFORM @D6535, PER @D6534, QFEAT +], FIX NOT, DEMON -] : NIL,

   DetN[-POSS, +DEF, +Q, +WH, -EVER, AGR N2[-PLU, -COUNT, CASE @D6539, NFORM
               @D6538, PER @D6537, QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (dd (the (_wh) (and (ms _wh) (P _wh))))),
   DetN[-POSS, +DEF, +Q, +WH, -EVER,
      AGR N2[+PLU, +COUNT, CASE @D6542, NFORM @D6541, PER @D6540,
            QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (dd (the (_wh) (and (pl _wh) (P _wh))))),
   DetN[-POSS, +DEF, +Q, +WH, -EVER,
      AGR N2[-PLU, +COUNT, CASE @D6545, NFORM @D6544, PER @D6543,
            QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (dd (the (_wh) (and (sg _wh) (P _wh))))).

WORD whichever :
   N[-POSS, -ADV, +PRO, -NUM, +R, +WH, +EVER, COORD @D6557, COUNT @D6556,
      PRD @D6555, CASE @D6554, PLU @D6553, DEF @D6552, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (T) (dd (the (_wh) (and (entity _wh) (T _wh))))),
   DetN[-POSS, +DEF, +R, +WH, +EVER,
      AGR N2[+PLU, +COUNT, CASE @D6560, NFORM @D6559, PER @D6558,
            QFEAT +], FIX NOT, DEMON -] : NIL,
   DetN[-POSS, +DEF, +R, +WH, +EVER,
      AGR N2[-PLU, -COUNT, CASE @D6563, NFORM @D6562, PER @D6561,
            QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (lambda (T) (dd (the (_wh) (and (ms _wh) (P _wh) (T _wh)))))),

   DetN[-POSS, +DEF, +R, +WH, +EVER, AGR N2[+PLU, +COUNT, CASE @D6566, NFORM
               @D6565, PER @D6564, QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (lambda (T) (dd (the (_wh) (and (pl _wh) (P _wh) (T _wh)))))),

   DetN[-POSS, +DEF, +R, +WH, +EVER, AGR N2[-PLU, +COUNT, CASE @D6569, NFORM
               @D6568, PER @D6567, QFEAT -], FIX NOT, DEMON -] :
   (lambda (P) (lambda (T) (dd (the (_wh) (and (sg _wh) (P _wh) (T _wh)))))).

WORD while :
   P[-PRO, COORD @D6578, NEG @D6577, PRD @D6576, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : WHILE,
   P[-PRO, COORD @D6581, NEG @D6580, PRD @D6579, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : WHILE.

WORD whilst :
   P[-PRO, COORD @D6590, NEG @D6589, PRD @D6588, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : WHILST,
   P[-PRO, COORD @D6593, NEG @D6592, PRD @D6591, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SFIN,
      PFORM NORM] : WHILST.

WORD who :
   N[-PRD, -POSS, -ADV, +PRO, -NUM, +R, +WH, -EVER, COORD @D6602, COUNT
         @D6601, CASE @D6600, PLU @D6599, DEF @D6598, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (z) z),
   N[-PRD, -POSS, -ADV, +PRO, -NUM, +Q, +WH, -EVER, COORD @D6607,
      COUNT @D6606, CASE @D6605, PLU @D6604, DEF @D6603, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -, DEMON -, PROTYPE NONE,
      AFORM NONE, INFL -, CONJ NULL, AT +, LAT +, PER 3] :
   (pro (the (_wh) (human _wh))).

WORD whoever :
   N[-POSS, -ADV, +PRO, -NUM, +R, +WH, +EVER, COORD @D6618, COUNT @D6617,
      PRD @D6616, CASE @D6615, PLU @D6614, DEF @D6613, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (T) (dd (the (_wh) (and (person _wh) (T _wh))))),
   N[-POSS, -ADV, -PLU, +PRO, -NUM, +Q, +WH, +EVER, COORD @D6623,
      COUNT @D6622, PRD @D6621, CASE @D6620, DEF @D6619, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (pro (the (_wh) (human _wh))).

WORD whom :
   N[-PRD, -POSS, -ADV, +ACC, +PRO, -NUM, +R, +WH, -EVER, COORD @D6632,
      COUNT @D6631, PLU @D6630, DEF @D6629, FIX NOT, SUBCAT NULL, PN -,
      NFORM NORM, REFL -, PER 3, PART -, DEMON -, PROTYPE NONE, AFORM NONE,
      INFL -, CONJ NULL, AT +, LAT +] : (lambda (z) z),
   N[-PRD, -POSS, -ADV, +ACC, +PRO, -NUM, +Q, +WH, -EVER, COORD @D6636,
      COUNT @D6635, PLU @D6634, DEF @D6633, FIX NOT, SUBCAT NULL, PN -,
      NFORM NORM, REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, INFL -,
      CONJ NULL, AT +, LAT +, PER 3] : (pro (the (_wh) (human _wh))).

WORD whose :
   N[+POSS, -ADV, +PRO, -NUM, +R, +WH, -EVER, COORD @D6648, COUNT @D6647,
      PRD @D6646, CASE @D6645, PLU @D6644, DEF @D6643, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (P) (lambda (z) (dd (the (x) (and (P x) (lambda (R) (R x z))))))),

   N[+POSS, -ADV, +PRO, -NUM, +Q, +WH, -EVER, COORD @D6654, COUNT @D6653,
      PRD @D6652, CASE @D6651, PLU @D6650, DEF @D6649, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (lambda (P) (dd (the (x) (and (P x) (lambda (R) (R x z)))))),
   N[-PRD, -POSS, -ADV, +PRO, -NUM, +Q, +WH, -EVER, COORD @D6659,
      COUNT @D6658, CASE @D6657, PLU @D6656, DEF @D6655, FIX NOT,
      SUBCAT NULL, PN -, NFORM NORM, REFL -, PER 3, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, INFL -, CONJ NULL, AT +, LAT +] :
   (dd (the (x) (lambda (R) (R x (pro (the (_wh) (human _wh))))))).

WORD why :
   P[+PRO, +R, +WH, -EVER, MODTYPE @D6668, COORD @D6667, NEG @D6666,
      PRD @D6665, LOC @D6664, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] : (lambda (y) (lambda (x) (FOR y x))),
   P[+PRO, +Q, +WH, -EVER, MODTYPE @D6673, COORD @D6672, NEG @D6671,
      PRD @D6670, LOC @D6669, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] :
   (lambda (y) (FOR y (pro (the (_wh) (and (reason _wh)))))).

WORD whyever :
   P[+PRO, +R, +WH, +EVER, MODTYPE @D6683, COORD @D6682, NEG @D6681,
      PRD @D6680, LOC @D6679, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] : (lambda (y) (lambda (x) (FOR y x))),
   P[+PRO, +Q, +WH, +EVER, MODTYPE @D6688, COORD @D6687, NEG @D6686,
      PRD @D6685, LOC @D6684, FIX NOT, SUBCAT NULL, PFORM NORM, INFL -,
      CONJ NULL, AT +, LAT +] :
   (lambda (y) (FOR y (pro (the (_wh) (and (reason _wh)))))).

WORD with : [FIX NOT, PRT WITH, INFL -] : WITH,
   P[-PRO, MODTYPE @D6704, COORD @D6703, NEG @D6702, PRD @D6701, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_OVER] : WITH,
   P[-PRO, MODTYPE @D6708, COORD @D6707, NEG @D6706, PRD @D6705, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_ON] : WITH,
   P[-PRO, MODTYPE @D6712, COORD @D6711, NEG @D6710, PRD @D6709, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_FOR] : WITH,
   P[-PRO, MODTYPE @D6716, COORD @D6715, NEG @D6714, PRD @D6713, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_AT] : WITH,
   P[-PRO, MODTYPE @D6720, COORD @D6719, NEG @D6718, PRD @D6717, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_AGAINST] : WITH,
   P[-PRO, MODTYPE @D6724, COORD @D6723, NEG @D6722, PRD @D6721, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH_ABOUT] : WITH,
   P[-PRO, MODTYPE @D6728, COORD @D6727, NEG @D6726, PRD @D6725, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM OVER_WITH] : WITH,
   P[-PRO, MODTYPE @D6732, COORD @D6731, NEG @D6730, PRD @D6729, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ON_WITH] : WITH,
   P[-PRO, MODTYPE @D6736, COORD @D6735, NEG @D6734, PRD @D6733, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM IN_WITH] : WITH,
   P[-PRO, MODTYPE @D6740, COORD @D6739, NEG @D6738, PRD @D6737, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM INTO_WITH] : WITH,
   P[-PRO, MODTYPE @D6744, COORD @D6743, NEG @D6742, PRD @D6741, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM FOR_WITH] : WITH,
   P[-PRO, MODTYPE @D6748, COORD @D6747, NEG @D6746, PRD @D6745, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM ABOUT_WITH] : WITH,
   P[-PRO, MODTYPE @D6752, COORD @D6751, NEG @D6750, PRD @D6749, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM NORM] : WITH,
   P[-PRO, MODTYPE @D6756, COORD @D6755, NEG @D6754, PRD @D6753, FIX NOT,
      INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +, COMPOUND NOT, LOC -,
      PFORM WITH] : WITH.

WORD without : [FIX NOT, PRT WITHOUT, INFL -] : WITHOUT,
   P[-PRO, COORD @D6763, NEG @D6762, PRD @D6761, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT SING,
      PFORM NORM] : WITHOUT,
   P[-PRO, COORD @D6766, NEG @D6765, PRD @D6764, FIX NOT, INFL +,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, MODTYPE VBL, LOC -, SUBCAT VPING,
      PFORM NORM] : WITHOUT,
   P[-PRO, MODTYPE @D6771, COORD @D6770, NEG @D6769, PRD @D6768,
      LOC @D6767, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM NORM] : WITHOUT,
   P[-PRO, MODTYPE @D6776, COORD @D6775, NEG @D6774, PRD @D6773,
      LOC @D6772, FIX NOT, INFL +, SUBCAT NP, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, PFORM WITHOUT] : WITHOUT.

WORD won't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6782, AGR @D6781,
      CONEG @D6780, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST -, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (WILL e x (PROVP (uqe (some (e2) (NOTENSE e2))) x)))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6786, SUBTYPE @D6785,
      AGR @D6784, CONEG @D6783, FIX NOT, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, PAST FUT, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (NOT (PROVP e x))))
            (lambda (e2) e2) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6790, INV @D6789, AGR @D6788,
      CONEG @D6787, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBTYPE DEO, PAST -, SUBCAT MODAL_BSE] : WILL,
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6794, INV @D6793, AGR @D6792,
      CONEG @D6791, FIX NOT, SUBTYPE NONE, VFORM NOT, PSVE -, INFL -,
      CONJ NULL, AT +, LAT +, COMPOUND NOT, PAST FUT, SUBCAT FUT] : NIL.

WORD would :
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D6799, AGR @D6798, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBTYPE DEO, SUBCAT MODAL_BSE] : WOULD,
   V[-PRD, -INV, -NEG, +FIN, +AUX, +PRO, COORD @D6801, AGR @D6800, FIX NOT,
      VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +, PAST +,
      SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x) (WOULD e x
                     (PROVP (uqe (some (e2) (NOTENSE e2))) x))))
            (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, -NEG, +FIN, +AUX, -PRO, COORD @D6804, INV @D6803, AGR @D6802,
      FIX NOT, VFORM NOT, CONEG -, PSVE -, INFL -, CONJ NULL, AT +, LAT +,
      COMPOUND NOT, SUBTYPE DEO, PAST +, SUBCAT MODAL_BSE] : WOULD.

WORD wouldn't :
   V[-PRD, -INV, +NEG, +FIN, +AUX, +PRO, COORD @D6811, AGR @D6810,
      CONEG @D6809, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, PAST +, SUBTYPE NONE, SUBCAT NULL] :
   (lambda (Q) (Q (lambda (e) (lambda (x)
                  (NOT (WOULD e x (PROVP (uqe (some (e2) (NOTENSE e2)))
                           x))))) (lambda (e3) e3) (lambda (qu) qu))),
   V[-PRD, +NEG, +FIN, +AUX, -PRO, COORD @D6815, INV @D6814, AGR @D6813,
      CONEG @D6812, FIX NOT, VFORM NOT, PSVE -, INFL -, CONJ NULL, AT +,
      LAT +, COMPOUND NOT, SUBTYPE DEO, PAST +, SUBCAT MODAL_BSE] : WOULD.

WORD you :
   N[-PRD, -POSS, -ADV, +ACC, +DEF, +PRO, -NUM, COORD @D6820, COUNT @D6819,
      PLU @D6818, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 2] :
   (pro (the (x) (and (sg x) (hearer x)))) :
   (pro (the (x) (and (pl x) (hearer x)))),
   N[-PRD, -POSS, -ADV, +NOM, +DEF, +PLU, +PRO, -NUM, COORD @D6822,
      COUNT @D6821, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 2] :
   (pro (the (x) (and (pl x) (hearer x)))),
   N[-PRD, -POSS, -ADV, +NOM, +DEF, -PLU, +PRO, -NUM, COORD @D6824,
      COUNT @D6823, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, REFL -, PART -,
      DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO,
      CONJ NULL, AT +, LAT +, PER 2] :
   (pro (the (x) (and (sg x) (hearer x)))).

WORD your :
   DetN[+POSS, +DEF, AGR N2[+PLU, +COUNT, CASE @D6830, NFORM @D6829,
            PER @D6828, QFEAT +], FIX NOT, DEMON -, WH NO, UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (hearer y))))))) :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (pl y) (hearer y))))))),

   DetN[+POSS, +DEF, AGR N2[CASE @D6835, NFORM @D6834, COUNT @D6833, PER
               @D6832, PLU @D6831, QFEAT -], FIX NOT, DEMON -, WH NO,
      UB NO, EVER NO] :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (sg y) (hearer y))))))) :
   (lambda (x) (lambda (R) (R x (pro (the (y) (and (pl y) (hearer y))))))).

WORD yours :
   N[-PRD, -POSS, -ADV, +DEF, +PRO, -NUM, COORD @D6843, COUNT @D6842,
      CASE @D6841, PLU @D6840, FIX NOT, SUBCAT NULL, PN -, NFORM NORM,
      REFL -, PART -, DEMON -, PROTYPE NONE, AFORM NONE, WH NO, INFL -,
      UB NO, EVER NO, CONJ NULL, AT +, LAT +, PER 3] :
   (dd (the (x) (lambda (R)
               (R x (pro (the (y) (and (sg y) (hearer y)))))))) :
   (dd (the (x) (lambda (R) (R x (pro (the (y) (and (pl y) (hearer y)))))))).

WORD yourself :
   N[-PRD, -POSS, -ADV, +DEF, -PLU, +PRO, -NUM, COORD @D6851, COUNT @D6850,
      CASE @D6849, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 2] : (rpro (the (x) (and (sg x) (hearer x)))).

WORD yourselves :
   N[-PRD, -POSS, -ADV, +DEF, +PLU, +PRO, -NUM, COORD @D6859, COUNT @D6858,
      CASE @D6857, FIX NOT, SUBCAT NULL, PN -, NFORM NORM, PART -, DEMON -,
      PROTYPE NONE, AFORM NONE, WH NO, INFL -, UB NO, EVER NO, CONJ NULL,
      AT +, LAT +, REFL +, PER 2] : (rpro (the (x) (and (pl x) (hearer x)))).

WORD zero : [AND @D6862, FIX NOT, CN4 +, CN2 SMALL, CN1 ZERO] : |0|.
